CREATE DATABASE  IF NOT EXISTS `jjrc` /*!40100 DEFAULT CHARACTER SET utf8 */;
USE `jjrc`;
-- MySQL dump 10.13  Distrib 8.0.18, for Win64 (x86_64)
--
-- Host: localhost    Database: jjrc
-- ------------------------------------------------------
-- Server version	5.5.5-10.4.6-MariaDB

/*!40101 SET @OLD_CHARACTER_SET_CLIENT=@@CHARACTER_SET_CLIENT */;
/*!40101 SET @OLD_CHARACTER_SET_RESULTS=@@CHARACTER_SET_RESULTS */;
/*!40101 SET @OLD_COLLATION_CONNECTION=@@COLLATION_CONNECTION */;
/*!50503 SET NAMES utf8 */;
/*!40103 SET @OLD_TIME_ZONE=@@TIME_ZONE */;
/*!40103 SET TIME_ZONE='+00:00' */;
/*!40014 SET @OLD_UNIQUE_CHECKS=@@UNIQUE_CHECKS, UNIQUE_CHECKS=0 */;
/*!40014 SET @OLD_FOREIGN_KEY_CHECKS=@@FOREIGN_KEY_CHECKS, FOREIGN_KEY_CHECKS=0 */;
/*!40101 SET @OLD_SQL_MODE=@@SQL_MODE, SQL_MODE='NO_AUTO_VALUE_ON_ZERO' */;
/*!40111 SET @OLD_SQL_NOTES=@@SQL_NOTES, SQL_NOTES=0 */;

--
-- Table structure for table `md_living_allowance_info`
--

DROP TABLE IF EXISTS `md_living_allowance_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `md_living_allowance_info` (
  `id` varchar(30) NOT NULL COMMENT '主键',
  `year` int(4) DEFAULT NULL,
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '所属单位',
  `enterpriseName` varchar(100) DEFAULT NULL COMMENT '企业名称',
  `type` tinyint(1) DEFAULT NULL COMMENT '人才类型',
  `talentType` varchar(30) DEFAULT NULL COMMENT '人才标签',
  `cardType` tinyint(1) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(30) DEFAULT NULL COMMENT '证件号码',
  `name` varchar(100) DEFAULT NULL COMMENT '姓名',
  `photo` varchar(100) DEFAULT NULL COMMENT '头像',
  `sex` tinyint(1) NOT NULL COMMENT '性别',
  `nation` varchar(50) DEFAULT NULL COMMENT '民族',
  `nationality` varchar(30) DEFAULT NULL COMMENT '国籍',
  `provinceCode` varchar(50) DEFAULT NULL COMMENT '籍贯省代码',
  `provinceName` varchar(100) DEFAULT NULL COMMENT '籍贯省名称',
  `cityCode` varchar(50) DEFAULT NULL COMMENT '籍贯市代码',
  `cityName` varchar(100) DEFAULT NULL COMMENT '籍贯市名称',
  `countyCode` varchar(50) DEFAULT NULL COMMENT '籍贯县代码',
  `countyName` varchar(100) DEFAULT NULL COMMENT '籍贯县名称',
  `birthday` varchar(40) DEFAULT NULL COMMENT '出生日期',
  `address` varchar(255) DEFAULT NULL COMMENT '现居地址',
  `politics` varchar(50) DEFAULT NULL COMMENT '政治面貌',
  `highEducation` varchar(100) DEFAULT NULL COMMENT '最高学历',
  `graduateSchool` varchar(100) DEFAULT NULL COMMENT '毕业学校',
  `major` varchar(100) DEFAULT NULL COMMENT '专业',
  `post` varchar(100) DEFAULT NULL COMMENT '职务',
  `phone` varchar(20) DEFAULT NULL COMMENT '手机号码',
  `email` varchar(150) DEFAULT NULL COMMENT '邮箱',
  `bank` varchar(100) DEFAULT NULL COMMENT '开户银行',
  `bankNetwork` varchar(100) DEFAULT '' COMMENT '开户银行网点',
  `bankAccount` varchar(50) DEFAULT NULL COMMENT '银行账号',
  `bankNumber` varchar(50) DEFAULT NULL COMMENT '银行行号',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '本单位入职时间',
  `quitTime` varchar(40) DEFAULT NULL COMMENT '离职时间',
  `startTime` varchar(40) DEFAULT NULL COMMENT '工作合同开始时间',
  `endTime` varchar(40) DEFAULT NULL COMMENT '工作合同结束时间',
  `educationAndResume` text DEFAULT NULL COMMENT '教育背景及工作简历',
  `mainHonours` text DEFAULT NULL COMMENT '主要业绩及取得的荣誉',
  `firstInJJTime` varchar(40) DEFAULT NULL COMMENT '首次来晋工作时间',
  `isIntroduction` tinyint(1) DEFAULT NULL COMMENT '是否引进人才',
  `industryField` varchar(255) DEFAULT NULL COMMENT '行业领域',
  `title` varchar(255) DEFAULT NULL COMMENT '职称',
  `professionalQualifications` varchar(255) DEFAULT NULL COMMENT '国家职业资格',
  `studyAbroad` tinyint(1) DEFAULT NULL COMMENT '是否有留学经历',
  `studyAbroadCountry` varchar(100) DEFAULT NULL COMMENT '留学国家',
  `studyAbroadTime` varchar(40) DEFAULT NULL COMMENT '留学时间',
  `introductionMode` varchar(40) DEFAULT NULL COMMENT '引进方式',
  `letterTime` varchar(30) DEFAULT NULL COMMENT '行政介绍信时间',
  `personalTax` varchar(255) DEFAULT NULL COMMENT '个税缴纳情况',
  `socialSecurity` varchar(255) DEFAULT NULL COMMENT '社保缴纳情况',
  `applyCount` tinyint(2) DEFAULT NULL COMMENT '申请次数',
  `isPublic` tinyint(1) DEFAULT 1 COMMENT '公示状态',
  `creditStatus` tinyint(2) DEFAULT NULL COMMENT '征信状态，1-待核查，2-通过，3-失信',
  `amount` decimal(10,2) DEFAULT 0.00,
  `isPay` tinyint(1) DEFAULT 2 COMMENT '是否发放补贴',
  `publicBatch` varchar(20) DEFAULT NULL COMMENT '公布批次',
  `active` tinyint(1) DEFAULT NULL COMMENT '是否确认提交',
  `checkState` tinyint(2) DEFAULT 0 COMMENT '审核状态',
  `checkMsg` varchar(2000) DEFAULT NULL COMMENT '基础信息审核意见',
  `fields` longtext DEFAULT NULL,
  `files` varchar(500) DEFAULT NULL,
  `firstSubmitTime` varchar(40) DEFAULT NULL COMMENT '首次确认提交时间',
  `newSubmitTime` varchar(40) DEFAULT NULL COMMENT '最新确认提交时间',
  `outMsg` varchar(255) DEFAULT NULL COMMENT '退件原因',
  `highProcess` smallint(2) DEFAULT 0,
  `isEffect` tinyint(1) DEFAULT NULL,
  `firstDepPassTime` varchar(20) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='硕博人才生活补贴';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `md_living_allowance_info`
--

LOCK TABLES `md_living_allowance_info` WRITE;
/*!40000 ALTER TABLE `md_living_allowance_info` DISABLE KEYS */;
INSERT INTO `md_living_allowance_info` VALUES ('1494514182607478785',2021,'1494514182607478785','泉州亲亲食品有限公司',1,'myqy',1,'110101199003078830','Lana Thornton','jjrcw/talentFile/photo/202202/1494514174969651203.jpg',1,'56','02','230000','黑龙江省','232700','大兴安岭地区','232722','塔河县','2022-02-18','00020','10','1','Minima iure veritati','Tenetur ullam vitae ','Mollit a nobis eos a','17362523273','1508798227@qq.com','中国建设银行','泉州银行福建省泉州市新门支行','123445','102391050013','2022-02-18',NULL,'2022-02-18','2022-02-18','Quis voluptates et n','Anim culpa quia vel','2022-02-18',NULL,'05','Ut dolorem cupidatat1','中国',2,NULL,'2022-02-18','10','','2021-01,2021-02,2021-03,2021-04','2021-01,2021-02,2021-03',1,5,2,30000.00,2,'202203',1,35,'1','','','2022-02-18 11:28:57','2022-02-18 17:00:21','',3,NULL,'2022-02-21 15:39:19',NULL,'2022-02-18 11:28:42','1462713906911801345',NULL,NULL),('1494562800022462465',2021,'1462713906911801345','泉州亲亲食品有限公司',1,'myqy',1,'350582198410203029','Malachi Little','jjrcw/talentFile/photo/202202/1494562797036118019.jpg',2,'56','01','120000','天津市','120200','县','120225','蓟县','2022-02-18','00020','08','1','Incididunt tempora e','Quam dolor perspicia','Natus aut sit deser','17362523273','1508798227@qq.com','中国建设银行','泉州银行福建省泉州市新门支行','123445','102391050013','2022-02-18',NULL,'2022-02-18','2022-02-18','Reprehenderit conseq','Vel et ea similique ','2022-02-18',NULL,'05','Blanditiis in nulla ','中国',1,NULL,'2022-02-18','01','','2021-01,2021-02,2021-03','2021-03,2021-04,2021-05',1,4,3,NULL,2,'202202',1,-1,'','','','2022-02-18 17:09:53','2022-02-18 17:09:53','不通过',1,NULL,NULL,NULL,'2022-02-18 14:41:53','1462713906911801345',NULL,NULL),('1498124827349458945',2021,'1498124827349458945','泉州亲亲食品有限公司',1,NULL,1,'350583198108118030','Germaine Nichols','jjrcw/talentFile/photo/202202/1498124823742357506.jpg',2,'04','02','370000','山东省','370400','枣庄市','370401','市辖区','1981-08-11','00020','03','1','Totam ipsum do bland','Modi sit doloremque','Ea cupidatat magna n','17362523273','1508798227@qq.com','中国建设银行','泉州银行福建省泉州市新门支行','123445','102391050013','2022-02-28',NULL,'2022-02-28','2022-02-28','Optio enim ullamco ','Fugiat sit quae lab','2022-02-28',NULL,'05','Aut quae id aspernat','中国',2,NULL,'2022-02-28','10','','2021-01,2021-02,2021-03','2021-01,2021-02,2021-03,2021-04',1,1,NULL,0.00,2,NULL,1,10,'','description,','','2022-02-28 10:36:18','2022-02-28 10:49:21',NULL,1,NULL,NULL,'Nulla et fugit sit ','2022-02-28 10:36:07','1462713906911801345',NULL,NULL),('1498195721122316289',2021,'1462713906911801345','泉州亲亲食品有限公司',1,NULL,1,'422822198503290010','Mariam Shaw','jjrcw/talentFile/photo/202202/1498195718211469314.jpg',1,'01','08','460000','海南省','460300','三沙市','',NULL,'1985-03-29','00020','01','2','Ipsum reiciendis id','Voluptatem Sed et r','Voluptas culpa ex q','17362523273','admin@qq.com','泉州银行','中国兴业银行福建省泉州市石狮市东港支行','123445','309397205502','2022-02-28',NULL,'2022-02-28','2022-02-28','Eiusmod tempor volup','Laboris fugiat perfe','2022-02-28',NULL,'05','Ea est dolore enim v','Id ullamco nostrum ',2,NULL,'2022-02-28','05','','2021-02,2021-04','2021-01,2021-02,2021-04',1,1,NULL,0.00,2,NULL,1,1,NULL,NULL,NULL,NULL,NULL,NULL,0,NULL,NULL,'Ullamco similique et','2022-02-28 15:17:49','1462713906911801345','2022-02-28 15:17:49','1462713906911801345');
/*!40000 ALTER TABLE `md_living_allowance_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Temporary view structure for view `past_12_month_view`
--

DROP TABLE IF EXISTS `past_12_month_view`;
/*!50001 DROP VIEW IF EXISTS `past_12_month_view`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `past_12_month_view` AS SELECT 
 1 AS `month`*/;
SET character_set_client = @saved_cs_client;

--
-- Temporary view structure for view `past_week_view`
--

DROP TABLE IF EXISTS `past_week_view`;
/*!50001 DROP VIEW IF EXISTS `past_week_view`*/;
SET @saved_cs_client     = @@character_set_client;
/*!50503 SET character_set_client = utf8mb4 */;
/*!50001 CREATE VIEW `past_week_view` AS SELECT 
 1 AS `day`*/;
SET character_set_client = @saved_cs_client;

--
-- Table structure for table `sys_amount_standard`
--

DROP TABLE IF EXISTS `sys_amount_standard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_amount_standard` (
  `id` varchar(40) DEFAULT NULL COMMENT 'id',
  `type` tinyint(1) DEFAULT NULL COMMENT '人才类型',
  `allowanceType` tinyint(1) DEFAULT NULL COMMENT '津贴类别',
  `talentArrange` varchar(10) DEFAULT NULL COMMENT '人才层次',
  `money` decimal(10,2) DEFAULT NULL COMMENT '金额',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='人才津贴配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_amount_standard`
--

LOCK TABLES `sys_amount_standard` WRITE;
/*!40000 ALTER TABLE `sys_amount_standard` DISABLE KEYS */;
INSERT INTO `sys_amount_standard` VALUES ('1190153365206319105',1,1,'1',15000.00,'',NULL,NULL,NULL,NULL),('1190153429706326017',1,1,'2',10000.00,'',NULL,NULL,NULL,NULL),('1190153490498568193',1,1,'3',8000.00,'',NULL,NULL,NULL,NULL),('1190153544265351169',1,1,'4',5000.00,'',NULL,NULL,NULL,NULL),('1190153618810716161',1,1,'5',3000.00,'',NULL,NULL,NULL,NULL),('1190153662486003713',1,1,'6',1000.00,'',NULL,NULL,'1','2019-11-01 14:29:02'),('1190153710842134529',1,1,'7',500.00,'',NULL,NULL,NULL,NULL),('1190153901070598146',1,2,'1',15000.00,'',NULL,NULL,NULL,NULL),('1190153954082406401',1,2,'2',10000.00,'',NULL,NULL,NULL,NULL),('1190154019278667777',1,2,'3',8000.00,'',NULL,NULL,NULL,NULL),('1190154102569156610',1,2,'4',6000.00,'',NULL,NULL,NULL,NULL),('1190154213261033473',1,2,'5',4000.00,'',NULL,NULL,NULL,NULL),('1190154368391561218',2,1,'1',15000.00,'',NULL,NULL,NULL,NULL),('1190154502466682882',2,1,'2',12000.00,'',NULL,NULL,'1','2019-11-01 14:33:31'),('1190154946391760898',2,1,'3',8000.00,'',NULL,NULL,NULL,NULL),('1190155003052613633',2,1,'3',5000.00,'',NULL,NULL,NULL,NULL),('1190155092273848322',2,1,'5',3000.00,'',NULL,NULL,NULL,NULL),('1190155146220986369',2,1,'6',1000.00,'',NULL,NULL,NULL,NULL),('1190155200797270017',2,1,'7',500.00,'',NULL,NULL,NULL,NULL),('1190155252613701634',2,2,'1',15000.00,'',NULL,NULL,NULL,NULL),('1190155311619170306',2,2,'2',13000.00,'',NULL,NULL,NULL,NULL),('1190155360751247362',2,2,'3',11000.00,'',NULL,NULL,NULL,NULL),('1190155419773493249',2,2,'4',9000.00,'',NULL,NULL,NULL,NULL),('1190155470017060865',2,2,'5',6000.00,'',NULL,NULL,'1','2021-09-06 17:15:45'),('1497106418968981505',1,3,'1',1000000.00,'',NULL,NULL,NULL,NULL),('1497106823828369409',1,3,'2',600000.00,'',NULL,NULL,NULL,NULL),('1497106885400752130',1,3,'3',300000.00,'',NULL,NULL,NULL,NULL),('1497106958381641729',1,3,'4',200000.00,'',NULL,NULL,NULL,NULL),('1497107018024644610',1,3,'5',100000.00,'',NULL,NULL,NULL,NULL),('1497107065650966529',1,3,'6',50000.00,'',NULL,NULL,NULL,NULL),('1497107124811624449',1,3,'7',30000.00,'',NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `sys_amount_standard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_batch`
--

DROP TABLE IF EXISTS `sys_batch`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_batch` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `type` varchar(50) DEFAULT NULL COMMENT '申报类别',
  `source` tinyint(1) DEFAULT NULL,
  `batch` int(4) DEFAULT NULL COMMENT '申报批次',
  `startTime` varchar(40) DEFAULT NULL COMMENT '开始时间',
  `endTime` varchar(40) DEFAULT NULL COMMENT '截止时间',
  `submitEndTime` varchar(40) DEFAULT NULL COMMENT '提交截止时间',
  `publicStartTime` varchar(40) DEFAULT NULL,
  `publicEndTime` varchar(40) DEFAULT NULL,
  `averageWage` decimal(10,0) DEFAULT NULL,
  `active` tinyint(1) DEFAULT 2 COMMENT '是否有效    1-有效，2-无效',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='申报批次表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_batch`
--

LOCK TABLES `sys_batch` WRITE;
/*!40000 ALTER TABLE `sys_batch` DISABLE KEYS */;
INSERT INTO `sys_batch` VALUES ('1188667421799677954','1',1,2019,'2019-10-28 00:00:00','2019-12-31 00:00:00','','','',NULL,2,'','2019-10-28 12:02:52','1','2020-07-10 11:02:34','1'),('1189084535700799490','8',1,2020,'2020-06-19 10:16:41','2020-12-31 17:30:00','','','',NULL,2,'','2019-10-29 15:40:19','1','2020-06-19 10:16:55','87'),('1214163377287417857','3',1,2020,'2020-06-19 10:11:48','2020-12-31 17:30:00','','','',NULL,2,'','2020-01-06 20:34:31','1','2020-06-19 10:33:18','1'),('1273798939744698370','1',1,2020,'2020-06-19 10:03:57','2020-12-31 17:30:00','2021-12-31 00:00:00','','',NULL,2,'','2020-06-19 10:05:07','87','2021-02-18 15:03:44','87'),('1273801192236941314','4',1,2020,'2020-06-19 10:13:32','2020-12-31 17:30:00','','','',NULL,2,'','2020-06-19 10:14:04','87','2020-06-19 10:32:31','1'),('1273801692315418626','7',1,2020,'2020-06-19 10:15:51','2020-12-31 17:30:00','','','',NULL,2,'','2020-06-19 10:16:04','87','2020-06-19 10:32:02','1'),('1281423401541447681','6',1,2020,'2020-07-13 00:00:00','2020-07-20 00:00:00','','','',NULL,2,'','2020-07-10 11:02:01','1','2020-07-10 11:03:28','1'),('1287585152280584193','2',1,2019,'2020-07-29 08:35:00','2020-08-28 16:50:00','','','',65168,2,'','2020-07-27 11:06:37','58','2020-08-28 16:55:41','58'),('1302904003998281730','5',1,2019,'2020-09-09 08:00:00','2020-09-17 18:00:00','','','',NULL,2,'','2020-09-07 17:38:15','58','2020-09-08 18:12:33','58'),('1345986168558190593','1',1,2021,'2021-01-04 14:50:28','2021-12-31 17:30:00','','','',NULL,2,'','2021-01-04 14:51:24','87',NULL,NULL),('1356177451780145154','3',1,2021,'2021-01-01 00:00:00','2021-12-31 00:00:00','','','',NULL,1,'','2021-02-01 17:47:55','87',NULL,NULL),('1356429281521041410','4',1,2021,'2021-01-01 00:00:00','2021-12-31 00:00:00','','','',NULL,1,'','2021-02-02 10:28:36','87',NULL,NULL),('1356429551260925953','8',1,2021,'2021-01-01 00:00:00','2021-12-31 00:00:00','','','',NULL,1,'','2021-02-02 10:29:40','87',NULL,NULL),('1356429664683294721','7',1,2021,'2021-01-01 00:00:00','2021-12-31 00:00:00','','','',NULL,1,'','2021-02-02 10:30:07','87',NULL,NULL),('1371615991922012162','2',1,2020,'2021-03-15 00:00:00','2021-04-05 17:30:00','2021-07-14 23:59:00','','',73048,1,'','2021-03-16 08:15:10','87','2021-07-14 15:29:03','87'),('1374305502212763649','1',2,1,'2021-03-23 00:00:00','2021-09-07 15:56:22','','','',NULL,2,'','2021-03-23 18:22:19','59','2021-09-06 15:33:29','68'),('1375350776041349121','11',NULL,2020,'2021-03-26 00:00:00','2021-03-30 00:00:00','','','',NULL,2,'','2021-03-26 15:35:52','68',NULL,NULL),('1382233718340579330','11',2,2020,'2021-04-14 15:24:21','2021-05-15 00:00:00','','','',NULL,1,'','2021-04-14 15:26:13','68',NULL,NULL),('1394932780927856641','6',1,2021,'2021-05-19 14:30:00','2021-06-30 17:30:00','','','',NULL,1,'','2021-05-19 16:27:46','87','2021-05-26 15:19:51','87'),('1417669243821916162','3',2,1,'2021-07-21 10:14:03','2021-12-31 00:00:00','','','',NULL,1,'','2021-07-21 10:14:21','68','2021-08-06 15:44:01','67'),('1419483621667930114','1',2,202101,'2021-07-26 00:00:00','2021-12-31 23:59:59','','','',NULL,1,'','2021-07-26 10:24:02','68','2021-08-25 18:24:25','68'),('1419583649254244353','8',2,1,'2021-07-26 17:01:15','2021-12-31 23:59:59','','','',NULL,1,'','2021-07-26 17:01:31','68','2021-08-06 15:48:05','68'),('1422402438622633985','4',2,1,'2021-08-03 11:42:19','2021-12-31 23:59:59','','','',NULL,1,'','2021-08-03 11:42:22','68','2021-09-06 11:05:25','68'),('1425005166448386050','9',2,1,'2021-08-10 16:04:22','2021-12-31 23:59:59','','','',NULL,1,'','2021-08-10 16:04:41','68','2021-09-10 11:00:17','68'),('1466214915673653249','5',1,2020,'2021-12-01 00:00:00','2022-03-11 00:00:00','','','',NULL,1,'','2021-12-02 09:17:29','1','2022-02-25 11:22:54','1'),('1491314478457499649','19',1,2021,'2022-02-08 00:00:00','2022-03-09 00:00:00','2022-03-18 00:00:00','2022-03-10 00:00:00','',NULL,1,'','2022-02-09 15:34:13','1',NULL,NULL),('1494121582884827138','1',1,2022,'2022-02-01 00:00:00','2022-12-31 00:00:00','2022-12-31 00:00:00','2022-02-01 00:00:00','2022-12-31 00:00:00',NULL,1,'','2022-02-17 09:28:39','1',NULL,NULL);
/*!40000 ALTER TABLE `sys_batch` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_common_file`
--

DROP TABLE IF EXISTS `sys_common_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_common_file` (
  `id` varchar(40) NOT NULL,
  `originalName` varchar(255) DEFAULT NULL,
  `url` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `createUser` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_common_file`
--

LOCK TABLES `sys_common_file` WRITE;
/*!40000 ALTER TABLE `sys_common_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_common_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_company`
--

DROP TABLE IF EXISTS `sys_company`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_company` (
  `id` varchar(50) NOT NULL COMMENT '主键id',
  `shortName` varchar(100) DEFAULT NULL COMMENT '简称',
  `name` varchar(150) DEFAULT NULL COMMENT '全称',
  `code` varchar(50) DEFAULT NULL COMMENT '社会信用代码',
  `sn` int(3) DEFAULT NULL COMMENT '排序',
  `description` varchar(255) DEFAULT NULL COMMENT '全称',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='单位表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_company`
--

LOCK TABLES `sys_company` WRITE;
/*!40000 ALTER TABLE `sys_company` DISABLE KEYS */;
INSERT INTO `sys_company` VALUES ('1196327814145646594','工业和信息化局','工业和信息化局','工业和信息化局',1,'','2019-11-18 15:22:32','1',NULL,NULL),('1196327955313336322','民政局','民政局','mzj',2,'','2019-11-18 15:23:05','1','2020-07-10 11:21:26','1'),('1196328018018181122','宣传部','宣传部','宣传部',3,'','2019-11-18 15:23:20','1',NULL,NULL),('1196328242593800193','广电局','广电局','广电局',4,'','2019-11-18 15:24:14','1',NULL,NULL),('1196328965217853442','博士后工作站','博士后工作站','博士后工作站',5,'','2019-11-18 15:27:06','1','2019-11-18 15:27:13','1'),('1196331850672513026','教育局','教育局','教育局',6,'','2019-11-18 15:38:34','1',NULL,NULL),('1196331995954814977','科学技术局','科学技术局','科学技术局',7,'','2019-11-18 15:39:09','1',NULL,NULL),('1196332086363037697','文化和旅游局','文化和旅游局','文化和旅游局',8,'','2019-11-18 15:39:30','1',NULL,NULL),('1196332264142807042','人社局职业能力建设科','人社局职业能力建设科','人社局职业能力建设科',9,'','2019-11-18 15:40:13','1',NULL,NULL),('1196332383294595073','体育局','体育局','体育局',10,'','2019-11-18 15:40:41','1',NULL,NULL),('1196347541488906242','super','super','super',0,'不可修改，不可删除','2019-11-18 16:40:55','1','2019-11-21 10:28:02','1'),('1197345219366043649','集成电路筹备组','福建省集成电路产业园区建设筹备工作组','集成电路筹备组',12,'','2019-11-21 10:45:20','59','2019-11-21 10:45:45','59'),('1197443773921181697','人社局','晋江市人力资源和社会保障局','rsj',11,'','2019-11-21 17:16:57','58','2020-03-05 13:14:03','58'),('1201673316928286721','财政局','财政局','财政局',13,'','2019-12-03 09:23:39','58',NULL,NULL),('1210488527915302913','三创办','创意创业创新园开发建设领导小组办公室','三创办',14,'','2019-12-27 17:12:09','74',NULL,NULL),('1210488645792022529','市场监督管理局','市场监督管理局','市场监督管理局',15,'','2019-12-27 17:12:37','74',NULL,NULL),('1272726463010885634','社保中心','社保中心','sbj',17,'','2020-06-16 11:03:29','58',NULL,NULL),('1272726686756032513','税务局','税务局','swj',18,'','2020-06-16 11:04:22','58',NULL,NULL),('1323456497744670722','核查小组','优秀人才津补贴走访核查小组','visitGroup',19,'','2020-11-03 10:46:32','87','2021-07-29 10:27:18','1'),('1326073065053925378','住建局','住建局','zjj',20,'','2020-11-10 16:03:50','1',NULL,NULL),('1326073161522917378','自然资源局','自然资源局','zrzyj',21,'','2020-11-10 16:04:13','1',NULL,NULL);
/*!40000 ALTER TABLE `sys_company` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_dept`
--

DROP TABLE IF EXISTS `sys_dept`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_dept` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `num` int(11) DEFAULT NULL COMMENT '排序',
  `pid` int(11) DEFAULT NULL COMMENT '父部门id',
  `pids` varchar(255) DEFAULT NULL COMMENT '父级ids',
  `simplename` varchar(45) DEFAULT NULL COMMENT '简称',
  `fullname` varchar(255) DEFAULT NULL COMMENT '全称',
  `tips` varchar(255) DEFAULT NULL COMMENT '提示',
  `version` int(11) DEFAULT NULL COMMENT '版本（乐观锁保留字段）',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_dept`
--

LOCK TABLES `sys_dept` WRITE;
/*!40000 ALTER TABLE `sys_dept` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_dept` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_dict`
--

DROP TABLE IF EXISTS `sys_dict`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_dict` (
  `id` int(11) unsigned NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `num` int(11) DEFAULT NULL COMMENT '排序',
  `pid` int(11) DEFAULT NULL COMMENT '父级字典',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `tips` varchar(255) DEFAULT NULL COMMENT '提示',
  `code` varchar(255) DEFAULT NULL COMMENT '值',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `index_id` (`id`) USING BTREE,
  KEY `index_code` (`code`) USING BTREE,
  KEY `index_pId` (`pid`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=1711 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='字典表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_dict`
--

LOCK TABLES `sys_dict` WRITE;
/*!40000 ALTER TABLE `sys_dict` DISABLE KEYS */;
INSERT INTO `sys_dict` VALUES (50,0,0,'性别',NULL,'sys_sex'),(51,1,50,'男',NULL,'1'),(52,2,50,'女',NULL,'2'),(53,0,0,'状态',NULL,'sys_state'),(54,1,53,'启用',NULL,'1'),(55,2,53,'禁用',NULL,'2'),(56,0,0,'账号状态',NULL,'account_state'),(57,1,56,'启用',NULL,'1'),(58,2,56,'冻结',NULL,'2'),(59,3,56,'已删除',NULL,'3'),(275,0,0,'专业领域','海峡计划申报的专业领域','un_professionalField'),(276,1,275,'大健康',NULL,'pf_djk'),(277,2,275,'先进制造',NULL,'pf_xjzz'),(278,3,275,'新材料',NULL,'pf_xcl'),(279,4,275,'新能源',NULL,'pf_xny'),(280,5,275,'集成电路',NULL,'pf_jcdl'),(281,6,275,'电子信息',NULL,'pf_dzxx'),(282,7,275,'其他',NULL,'pf_other'),(283,0,0,'申报类别','海峡计划的申报类别，前台可通用','un_declareSort'),(284,1,283,'第一类（国际一流水平）',NULL,'ds_1'),(285,2,283,'第二类（国际高端水平）',NULL,'ds_2'),(286,3,283,'第三类（国内先进水平）',NULL,'ds_3'),(287,4,283,'第四类（国内优秀水平）',NULL,'ds_4'),(288,5,283,'第五类（高成长性）',NULL,'ds_5'),(289,6,283,'不推荐类别',NULL,'ds_6'),(290,0,0,'团队成员','海峡计划团队成员','un_teamMember'),(291,1,290,'团队带头人',NULL,'teamLeader'),(292,2,290,'第一核心成员',NULL,'team01'),(293,3,290,'第二核心成员',NULL,'team02'),(294,4,290,'第三核心成员',NULL,'team03'),(295,5,290,'第四核心成员',NULL,'team04'),(296,6,290,'第五核心成员',NULL,'team05'),(297,7,290,'第六核心成员',NULL,'team06'),(318,0,0,'人才层次','人才认定模块','un_talentLevel'),(319,1,318,'第一层次',NULL,'1'),(320,2,318,'第二层次',NULL,'2'),(321,3,318,'第三层次',NULL,'3'),(322,4,318,'第四层次',NULL,'4'),(323,5,318,'第五层次',NULL,'5'),(324,6,318,'第六层次',NULL,'6'),(325,7,318,'第七层次',NULL,'7'),(326,0,0,'评审分组','','reviewGroup'),(327,1,326,'大健康',NULL,'group1'),(328,2,326,'电子技术',NULL,'group2'),(329,3,326,'通讯及信息技术',NULL,'group3'),(330,4,326,'先进制造',NULL,'group4'),(331,5,326,'新材料',NULL,'group5'),(332,0,0,'国籍','','un_nationality'),(333,1,332,'中国大陆',NULL,'01'),(334,5,332,'美国',NULL,'05'),(335,6,332,'英国',NULL,'06'),(336,7,332,'日本',NULL,'07'),(337,8,332,'韩国',NULL,'08'),(338,9,332,'荷兰',NULL,'09'),(339,10,332,'新加坡',NULL,'10'),(340,11,332,'其他',NULL,'11'),(341,2,332,'中国香港',NULL,'02'),(342,3,332,'中国澳门',NULL,'03'),(343,4,332,'中国台湾',NULL,'04'),(477,0,0,'引进方式','','un_introduction_mode'),(478,1,477,'受聘',NULL,'01'),(479,5,477,'合作',NULL,'05'),(480,10,477,'创办企业',NULL,'10'),(481,15,477,'受派',NULL,'15'),(747,0,0,'民族','','un_nation'),(748,1,747,'汉族',NULL,'01'),(749,2,747,'壮族',NULL,'02'),(750,3,747,'满族',NULL,'03'),(751,4,747,'回族',NULL,'04'),(752,5,747,'苗族',NULL,'05'),(753,7,747,'维吾尔族',NULL,'06'),(754,8,747,'土家族',NULL,'07'),(755,9,747,'彝族',NULL,'08'),(756,10,747,'蒙古族',NULL,'09'),(757,11,747,'藏族',NULL,'10'),(758,12,747,'布依族',NULL,'11'),(759,13,747,'侗族',NULL,'12'),(760,14,747,'瑶族',NULL,'13'),(761,15,747,'朝鲜族',NULL,'14'),(762,16,747,'白族',NULL,'15'),(763,17,747,'哈尼族',NULL,'16'),(764,18,747,'哈萨克族',NULL,'17'),(765,19,747,'黎族',NULL,'18'),(766,20,747,'傣族',NULL,'19'),(767,21,747,'畲族',NULL,'20'),(768,22,747,'傈僳族',NULL,'21'),(769,23,747,'仡佬族',NULL,'22'),(770,24,747,'东乡族',NULL,'23'),(771,25,747,'高山族',NULL,'24'),(772,26,747,'拉祜族',NULL,'25'),(773,27,747,'水族',NULL,'26'),(774,28,747,'佤族',NULL,'27'),(775,29,747,'纳西族',NULL,'28'),(776,30,747,'羌族',NULL,'29'),(777,31,747,'土族',NULL,'30'),(778,32,747,'仫佬族',NULL,'31'),(779,33,747,'锡伯族',NULL,'32'),(780,34,747,'柯尔克孜族',NULL,'33'),(781,35,747,'达斡尔族',NULL,'34'),(782,36,747,'景颇族',NULL,'35'),(783,37,747,'毛南族',NULL,'36'),(784,38,747,'撒拉族',NULL,'37'),(785,39,747,'布朗族',NULL,'38'),(786,40,747,'塔吉克族',NULL,'39'),(787,41,747,'阿昌族',NULL,'40'),(788,42,747,'普米族',NULL,'41'),(789,43,747,'鄂温克族',NULL,'42'),(790,44,747,'怒族',NULL,'43'),(791,45,747,'京族',NULL,'44'),(792,46,747,'基诺族',NULL,'45'),(793,47,747,'德昂族',NULL,'46'),(794,48,747,'保安族',NULL,'47'),(795,49,747,'俄罗斯族',NULL,'48'),(796,50,747,'裕固族',NULL,'49'),(797,51,747,'乌孜别克族',NULL,'50'),(798,52,747,'门巴族',NULL,'51'),(799,53,747,'鄂伦春族',NULL,'52'),(800,54,747,'独龙族',NULL,'53'),(801,55,747,'塔塔尔族',NULL,'54'),(802,56,747,'赫哲族',NULL,'55'),(803,57,747,'珞巴族',NULL,'56'),(804,58,747,'其他',NULL,'57'),(805,0,0,'政治面貌','','un_political'),(806,1,805,'中共党员',NULL,'01'),(807,2,805,'中共预备党员',NULL,'02'),(808,3,805,'共青团员',NULL,'03'),(809,4,805,'民革党员',NULL,'04'),(810,5,805,'民盟盟员',NULL,'05'),(811,6,805,'民建会员',NULL,'06'),(812,7,805,'民进会员',NULL,'07'),(813,8,805,'农工党党员',NULL,'08'),(814,9,805,'致公党党员',NULL,'09'),(815,10,805,'九三学社社员',NULL,'10'),(816,11,805,'台盟盟员',NULL,'11'),(817,12,805,'无党派人士',NULL,'12'),(818,13,805,'群众',NULL,'13'),(819,14,805,'其他',NULL,'14'),(820,0,0,'最高学历','学历','un_education'),(821,1,820,'本科',NULL,'01'),(822,2,820,'硕士',NULL,'02'),(823,3,820,'博士',NULL,'03'),(824,4,820,'EDP',NULL,'04'),(825,5,820,'EMBA',NULL,'05'),(826,6,820,'MBA',NULL,'06'),(827,7,820,'MBA在读',NULL,'07'),(828,8,820,'初中',NULL,'08'),(829,9,820,'大学',NULL,'09'),(830,10,820,'大专',NULL,'10'),(831,11,820,'大专以下',NULL,'11'),(832,12,820,'高中',NULL,'12'),(833,13,820,'技校',NULL,'13'),(834,14,820,'双学位',NULL,'14'),(835,15,820,'学士',NULL,'15'),(836,16,820,'研究生',NULL,'16'),(837,17,820,'职高',NULL,'17'),(838,18,820,'中技',NULL,'18'),(839,19,820,'中专',NULL,'19'),(840,20,820,'专科',NULL,'20'),(841,21,820,'其他',NULL,'21'),(842,0,0,'申报类别','通用附件选项','un_common_declareType'),(843,1,842,'企业信息变更',NULL,'enterpriseChange'),(948,0,0,'行业领域','','un_industryField'),(949,1,948,'纺织鞋服',NULL,'01'),(950,2,948,'石油化工',NULL,'02'),(951,3,948,'机械装备',NULL,'03'),(952,4,948,'建材家居',NULL,'04'),(953,5,948,'食品',NULL,'05'),(954,6,948,'工艺制品',NULL,'06'),(955,7,948,'纸业印刷',NULL,'07'),(956,8,948,'新一代信息技术',NULL,'08'),(957,9,948,'生物与新医药',NULL,'09'),(958,10,948,'新材料',NULL,'10'),(959,11,948,'节能环保',NULL,'11'),(960,12,948,'光电',NULL,'12'),(961,13,948,'现代物流',NULL,'13'),(962,14,948,'电子商务',NULL,'14'),(963,15,948,'金融',NULL,'15'),(964,16,948,'旅游',NULL,'16'),(965,17,948,'文化创意',NULL,'17'),(966,20,948,'其他',NULL,'19'),(1066,0,0,'证件类型','','un_cardType'),(1067,1,1066,'身份证',NULL,'1'),(1068,2,1066,'通行证',NULL,'2'),(1069,3,1066,'护照',NULL,'3'),(1081,0,0,'与申报人关系','子女就学申报模块','un_education_relation'),(1082,1,1081,'父子',NULL,'1'),(1083,2,1081,'父女',NULL,'2'),(1084,3,1081,'母子',NULL,'3'),(1085,4,1081,'母女',NULL,'4'),(1146,0,0,'婚姻状态','','un_marryStatus'),(1147,1,1146,'未婚',NULL,'1'),(1148,2,1146,'已婚',NULL,'2'),(1149,3,1146,'丧偶',NULL,'3'),(1150,4,1146,'离异',NULL,'4'),(1192,0,0,'走访小组','','un_visit_group'),(1193,1,1192,'第一走访小组',NULL,'1'),(1194,2,1192,'第二走访小组',NULL,'2'),(1195,3,1192,'第三走访小组',NULL,'3'),(1196,4,1192,'第四走访小组',NULL,'4'),(1197,5,1192,'第五走访小组',NULL,'5'),(1198,6,1192,'第六走访小组',NULL,'6'),(1199,7,1192,'第七走访小组',NULL,'7'),(1200,0,0,'子女择校申报项目','子女就学模块','un_educationSchool_project'),(1201,1,1200,'择校',NULL,'1'),(1202,2,1200,'中考加分',NULL,'2'),(1214,0,0,'入选重大专项 级别、名称','重大专项模块','un_major_degree'),(1215,1,1214,'国家“千人计划”',NULL,'1'),(1216,2,1214,'国家“万人计划”',NULL,'2'),(1217,3,1214,'福建省“百人计划”',NULL,'3'),(1218,4,1214,'福建省台湾“百人计划”',NULL,'4'),(1219,0,0,'配套额度比例','重大专项模块','un_major_proportion'),(1220,1,1219,'国家',NULL,'1'),(1221,2,1219,'福建省',NULL,'0.5'),(1249,0,0,'学杂费补助兑现比例','code为人才层次，name为比例','un_schoolfees_proportion'),(1250,1,1249,'0.3',NULL,'1'),(1251,2,1249,'0.3',NULL,'2'),(1252,3,1249,'0.3',NULL,'3'),(1253,4,1249,'0.3',NULL,'4'),(1254,5,1249,'0.2',NULL,'5'),(1255,6,1249,'0.15',NULL,'6'),(1256,7,1249,'0.1',NULL,'7'),(1257,0,0,'申报类别','此处为批次管理下拉框服务','un_batch_type'),(1258,1,1257,'津补贴(晋江市优秀人才)',NULL,'1'),(1259,2,1257,'津补贴(晋江市集成电路)',NULL,'2'),(1260,3,1257,'海峡计划申报',NULL,'3'),(1261,4,1257,'人才认定(晋江市优秀人才)',NULL,'4'),(1262,5,1257,'人才认定(晋江市集成电路)',NULL,'5'),(1263,6,1257,'离职申报(晋江市优秀人才)',NULL,'6'),(1264,7,1257,'离职申报(晋江市集成电路)',NULL,'7'),(1265,8,1257,'工作单位变更(晋江市优秀人才)',NULL,'8'),(1266,9,1257,'工作单位变更(晋江市集成电路)',NULL,'9'),(1267,10,1257,'购房补贴(晋江市优秀人才)',NULL,'10'),(1268,30,1257,'子女就学(晋江市优秀人才)',NULL,'30'),(1269,31,1257,'子女就学(晋江市集成电路)',NULL,'31'),(1270,32,1257,'学杂费补助(集成电路优秀人才)',NULL,'32'),(1271,35,1257,'培训补贴(晋江市集成电路)',NULL,'35'),(1272,37,1257,'医疗补助(晋江市集成电路)',NULL,'37'),(1286,0,0,'医疗补助最高额度','医疗补助根据人才层次每年可申报最高额度','un_medic_highMoney'),(1287,1,1286,'250000',NULL,'1'),(1288,2,1286,'200000',NULL,'2'),(1289,3,1286,'150000',NULL,'3'),(1290,4,1286,'100000',NULL,'4'),(1291,5,1286,'50000',NULL,'5'),(1292,6,1286,'30000',NULL,'6'),(1293,7,1286,'10000',NULL,'7'),(1302,0,0,'医疗补助兑现百分比','医疗补助个人才层次兑现百分比(个人自费的百分比)','un_medic_percentage'),(1303,1,1302,'0.3',NULL,'1'),(1304,2,1302,'0.3',NULL,'2'),(1305,3,1302,'0.3',NULL,'3'),(1306,4,1302,'0.3',NULL,'4'),(1307,5,1302,'0.3',NULL,'5'),(1308,6,1302,'0.3',NULL,'6'),(1309,7,1302,'0.3',NULL,'7'),(1310,0,0,'学校名单',NULL,'un_school_pool'),(1311,1,1310,'晋江市实验幼儿园',NULL,'1'),(1312,2,1310,'晋江市第二实验幼儿园',NULL,'2'),(1313,3,1310,'晋江市第三实验幼儿园',NULL,'3'),(1314,4,1310,'晋江市第四实验幼儿园',NULL,'4'),(1315,5,1310,'晋江市第八实验幼儿园',NULL,'5'),(1316,6,1310,'晋江市安海实验幼儿园',NULL,'6'),(1317,7,1310,'晋江市青阳街道中心幼儿园',NULL,'7'),(1318,8,1310,'晋江市艺术实验幼儿园',NULL,'8'),(1319,9,1310,'晋江市青阳街道青华幼儿园',NULL,'9'),(1320,10,1310,'晋江市青阳街道锦青幼儿园',NULL,'10'),(1321,11,1310,'晋江市青阳街道象山幼儿园',NULL,'11'),(1322,12,1310,'晋江市梅岭街道桂华中心幼儿园',NULL,'12'),(1323,13,1310,'晋江市梅岭街道平山中心幼儿园',NULL,'13'),(1324,14,1310,'晋江市梅岭街道梅岭中心幼儿园',NULL,'14'),(1325,15,1310,'晋江市西园版筑中心幼儿园',NULL,'15'),(1326,16,1310,'晋江市罗山街道荣宗中心幼儿园',NULL,'16'),(1327,17,1310,'晋江市罗山街道苏前幼儿园',NULL,'17'),(1328,18,1310,'晋江市灵源街道灵水中心幼儿园',NULL,'18'),(1329,19,1310,'晋江市灵源街道林口中心幼儿园',NULL,'19'),(1330,20,1310,'晋江市新塘街道沙塘中心幼儿园',NULL,'20'),(1331,21,1310,'晋江市新塘街道杏田中心幼儿园',NULL,'21'),(1332,22,1310,'晋江市陈埭镇阿梅中心幼儿园',NULL,'22'),(1333,23,1310,'晋江市陈埭镇溪边幼儿园',NULL,'23'),(1334,24,1310,'晋江市陈埭镇岸兜阿瑞幼儿园',NULL,'24'),(1335,25,1310,'晋江市陈埭镇湖中幼儿园',NULL,'25'),(1336,26,1310,'晋江市陈埭镇龙林中心幼儿园',NULL,'26'),(1337,27,1310,'晋江市池店中心幼儿园',NULL,'27'),(1338,28,1310,'晋江市池店镇桥南中心幼儿园',NULL,'28'),(1339,29,1310,'晋江市池店镇海丝幼儿园',NULL,'29'),(1340,30,1310,'晋江市池店镇滨江幼儿园',NULL,'30'),(1341,31,1310,'晋江市池店镇启智幼儿园',NULL,'31'),(1342,32,1310,'晋江市池店镇启梦幼儿园',NULL,'32'),(1343,33,1310,'晋江市池店镇顺英幼儿园',NULL,'33'),(1344,34,1310,'晋江市磁灶镇大埔中心幼儿园',NULL,'34'),(1345,35,1310,'晋江市磁灶镇张林中心幼儿园',NULL,'35'),(1346,36,1310,'晋江市内坑镇国才中心幼儿园',NULL,'36'),(1347,37,1310,'晋江市安海镇苗苗中心幼儿园',NULL,'37'),(1348,38,1310,'晋江市安海镇第二幼儿园',NULL,'38'),(1349,39,1310,'晋江市安海镇第三幼儿园',NULL,'39'),(1350,40,1310,'晋江市安海镇第五幼儿园',NULL,'40'),(1351,41,1310,'晋江市东石镇中心幼儿园',NULL,'41'),(1352,42,1310,'晋江市东石钻石海岸幼儿园',NULL,'42'),(1353,43,1310,'晋江市东石镇井林中心幼儿园',NULL,'43'),(1354,44,1310,'晋江市东石锦青中心幼儿园',NULL,'44'),(1355,45,1310,'晋江市东石镇塔头刘中心幼儿园',NULL,'45'),(1356,46,1310,'晋江市东石诚明幼儿园',NULL,'46'),(1357,47,1310,'晋江市东石镇金山中心幼儿园',NULL,'47'),(1358,48,1310,'晋江市英林镇中心幼儿园',NULL,'48'),(1359,49,1310,'晋江市英林镇达德幼儿园',NULL,'49'),(1360,50,1310,'晋江市金井镇毓英中心幼儿园',NULL,'50'),(1361,51,1310,'晋江市金井镇石圳中心幼儿园',NULL,'51'),(1362,52,1310,'晋江市金井镇双山中心幼儿园',NULL,'52'),(1363,53,1310,'晋江市金井镇西资岩幼儿园',NULL,'53'),(1364,54,1310,'晋江市深沪镇中心幼儿园',NULL,'54'),(1365,55,1310,'晋江市深沪镇金屿幼儿园',NULL,'55'),(1366,56,1310,'晋江市龙湖镇衙口中心幼儿园',NULL,'56'),(1367,57,1310,'晋江市龙湖镇如论中心幼儿园',NULL,'57'),(1368,58,1310,'晋江市龙湖镇光厦中心幼儿园',NULL,'58'),(1369,59,1310,'晋江市永和镇中心幼儿园',NULL,'59'),(1370,60,1310,'晋江市永和镇群英幼儿园',NULL,'60'),(1371,61,1310,'晋江市紫帽镇中心幼儿园',NULL,'61'),(1372,62,1310,'晋江市西滨镇中心幼儿园',NULL,'62'),(1373,63,1310,'晋江市实验小学',NULL,'63'),(1374,64,1310,'晋江市第二实验小学',NULL,'64'),(1375,65,1310,'晋江市第三实验小学',NULL,'65'),(1376,66,1310,'晋江市第四实验小学',NULL,'66'),(1377,67,1310,'晋江市第五实验小学',NULL,'67'),(1378,68,1310,'晋江市第六实验小学',NULL,'68'),(1379,69,1310,'晋江市第七实验小学',NULL,'69'),(1380,70,1310,'晋江市第八实验小学',NULL,'70'),(1381,71,1310,'晋江市第十实验小学',NULL,'71'),(1382,72,1310,'晋江市华泰实验小学',NULL,'72'),(1383,73,1310,'晋江市潘径实验小学',NULL,'73'),(1384,74,1310,'晋江市安海中心小学',NULL,'74'),(1385,75,1310,'晋江市西滨镇中心小学',NULL,'75'),(1386,76,1310,'晋江市特殊教育学校',NULL,'76'),(1387,77,1310,'晋江市青阳街道中和中心小学',NULL,'77'),(1388,78,1310,'晋江市青阳街道象山中心小学',NULL,'78'),(1389,79,1310,'晋江市青阳街道高霞小学',NULL,'79'),(1390,80,1310,'晋江市青阳街道普贤小学',NULL,'80'),(1391,81,1310,'晋江市梅岭街道希信中心小学',NULL,'81'),(1392,82,1310,'晋江市心养小学',NULL,'82'),(1393,83,1310,'晋江市梅岭街道平山实验小学',NULL,'83'),(1394,84,1310,'晋江市西园街道版筑中心小学',NULL,'84'),(1395,85,1310,'晋江市西园街道霞浯小学',NULL,'85'),(1396,86,1310,'晋江市罗山街道龙泉小学',NULL,'86'),(1397,87,1310,'晋江市罗山街道荣宗小学',NULL,'87'),(1398,88,1310,'晋江市罗山街道育德小学',NULL,'88'),(1399,89,1310,'晋江市罗山街道福埔小学',NULL,'89'),(1400,90,1310,'晋江市罗山街道延林小学',NULL,'90'),(1401,91,1310,'晋江市罗山街道军民小学',NULL,'91'),(1402,92,1310,'晋江市灵源街道灵水中心小学',NULL,'92'),(1403,93,1310,'晋江市灵源街道华林小学',NULL,'93'),(1404,94,1310,'晋江市灵源街道群峰小学',NULL,'94'),(1405,95,1310,'晋江市新塘街道沙塘中心小学',NULL,'95'),(1406,96,1310,'晋江市新塘街道道南小学',NULL,'96'),(1407,97,1310,'晋江市新塘街道瑞鹊小学',NULL,'97'),(1408,98,1310,'晋江市新塘街道杏田小学',NULL,'98'),(1409,99,1310,'晋江市新塘街道南塘小学',NULL,'99'),(1410,100,1310,'晋江市新塘街道杏坂小学',NULL,'100'),(1411,101,1310,'晋江市新塘街道雁峰小学',NULL,'101'),(1412,102,1310,'晋江市陈埭镇中心小学',NULL,'102'),(1413,103,1310,'晋江市陈埭镇江头中心小学',NULL,'103'),(1414,104,1310,'晋江市陈埭镇龙林中心小学',NULL,'104'),(1415,105,1310,'晋江市陈埭镇紫峰中心小学',NULL,'105'),(1416,106,1310,'晋江市陈埭镇西滨中心小学',NULL,'106'),(1417,107,1310,'晋江市池店中心小学',NULL,'107'),(1418,108,1310,'晋江市雁山中心小学',NULL,'108'),(1419,109,1310,'晋江市池店镇溜滨中心小学',NULL,'109'),(1420,110,1310,'晋江市池店镇浯潭小学',NULL,'110'),(1421,111,1310,'晋江市池店镇潘湖小学',NULL,'111'),(1422,112,1310,'晋江市池店镇钱头小学',NULL,'112'),(1423,113,1310,'晋江市池店镇仕春小学',NULL,'113'),(1424,114,1310,'晋江市池店镇唐厝小学',NULL,'114'),(1425,115,1310,'晋江市池店镇东山小学',NULL,'115'),(1426,116,1310,'晋江市磁灶中心小学',NULL,'116'),(1427,117,1310,'晋江市磁灶镇尚志中心小学',NULL,'117'),(1428,118,1310,'晋江市磁灶镇梅里中心小学',NULL,'118'),(1429,119,1310,'晋江市磁灶镇张林中心小学',NULL,'119'),(1430,120,1310,'晋江市磁灶镇大埔中心小学',NULL,'120'),(1431,121,1310,'晋江市磁灶镇瑶琼小学',NULL,'121'),(1432,122,1310,'晋江市磁灶镇大宅小学',NULL,'122'),(1433,123,1310,'晋江市磁灶镇梅峰小学',NULL,'123'),(1434,124,1310,'晋江市内坑中心小学',NULL,'124'),(1435,125,1310,'晋江市内坑镇三民中心小学',NULL,'125'),(1436,126,1310,'晋江市内坑镇怀斧小学',NULL,'126'),(1437,127,1310,'晋江市内坑镇柑市中心小学',NULL,'127'),(1438,128,1310,'晋江市内坑镇东红小学',NULL,'128'),(1439,129,1310,'晋江市内坑镇潘厝小学',NULL,'129'),(1440,130,1310,'晋江市内坑镇霞美畲族小学',NULL,'130'),(1441,131,1310,'晋江市安海镇可慕中心小学',NULL,'131'),(1442,132,1310,'晋江市安海镇仁寿中心小学',NULL,'132'),(1443,133,1310,'晋江市安海镇桥头中心小学',NULL,'133'),(1444,134,1310,'晋江市安海镇养正中心小学',NULL,'134'),(1445,135,1310,'晋江市安海镇成功中心小学',NULL,'135'),(1446,136,1310,'晋江市安海镇龙山小学',NULL,'136'),(1447,137,1310,'晋江市安海镇梧山小学',NULL,'137'),(1448,138,1310,'晋江市安海镇庄头小学',NULL,'138'),(1449,139,1310,'晋江市安海镇西隅小学',NULL,'139'),(1450,140,1310,'晋江市安海镇西安小学',NULL,'140'),(1451,141,1310,'晋江市安海镇早毓小学',NULL,'141'),(1452,142,1310,'晋江市紫帽镇紫帽中心小学',NULL,'142'),(1453,143,1310,'晋江市东石中心小学',NULL,'143'),(1454,144,1310,'晋江市东石镇第二中心小学',NULL,'144'),(1455,145,1310,'晋江市东石镇锦青中心小学',NULL,'145'),(1456,146,1310,'晋江市东石镇廷都中心小学',NULL,'146'),(1457,147,1310,'晋江市东石镇郭岑中心小学',NULL,'147'),(1458,148,1310,'晋江市东石镇龙厦小学',NULL,'148'),(1459,149,1310,'晋江市东石镇檗谷小学',NULL,'149'),(1460,150,1310,'晋江市英林镇中心小学',NULL,'150'),(1461,151,1310,'晋江市英林镇英埔中心小学',NULL,'151'),(1462,152,1310,'晋江市英林镇港塔小学',NULL,'152'),(1463,153,1310,'晋江市英林镇埭边小学',NULL,'153'),(1464,154,1310,'晋江市英林镇龙西小学',NULL,'154'),(1465,155,1310,'晋江市金井镇毓英中心小学',NULL,'155'),(1466,156,1310,'晋江市金井镇岱峰中心小学',NULL,'156'),(1467,157,1310,'晋江市金井镇双山中心小学',NULL,'157'),(1468,158,1310,'晋江市深沪镇中心小学',NULL,'158'),(1469,159,1310,'晋江市深沪镇狮峰中心小学',NULL,'159'),(1470,160,1310,'晋江市深沪镇华峰小学',NULL,'160'),(1471,161,1310,'晋江市深沪镇东山小学',NULL,'161'),(1472,162,1310,'晋江市龙湖镇衙口中心小学',NULL,'162'),(1473,163,1310,'晋江市龙湖镇阳溪中心小学',NULL,'163'),(1474,164,1310,'晋江市龙湖镇恢斋中心小学',NULL,'164'),(1475,165,1310,'晋江市龙湖镇尊道小学',NULL,'165'),(1476,166,1310,'晋江市龙湖镇震瑶小学',NULL,'166'),(1477,167,1310,'晋江市龙湖镇浔联小学',NULL,'167'),(1478,168,1310,'晋江市永和镇重华中心小学',NULL,'168'),(1479,169,1310,'晋江市永和镇茂峰中心小学',NULL,'169'),(1480,170,1310,'晋江市永和镇启蒙小学',NULL,'170'),(1481,171,1310,'晋江市永和镇群滨小学',NULL,'171'),(1482,172,1310,'晋江市永和镇城山小学',NULL,'172'),(1483,173,1310,'晋江市永和镇群英小学',NULL,'173'),(1484,174,1310,'晋江市云峰中学',NULL,'174'),(1485,175,1310,'晋江市侨声中学',NULL,'175'),(1486,176,1310,'晋江市养正中学',NULL,'176'),(1487,177,1310,'晋江市内坑中学',NULL,'177'),(1488,178,1310,'晋江市华侨中学',NULL,'178'),(1489,179,1310,'晋江市南侨中学',NULL,'179'),(1490,180,1310,'晋江市季延中学',NULL,'180'),(1491,181,1310,'晋江市安海中学',NULL,'181'),(1492,182,1310,'晋江市实验中学',NULL,'182'),(1493,183,1310,'晋江市平山中学',NULL,'183'),(1494,184,1310,'晋江市毓英中学',NULL,'184'),(1495,185,1310,'晋江市永和中学',NULL,'185'),(1496,186,1310,'晋江市潘径中学',NULL,'186'),(1497,187,1310,'晋江市磁灶中学',NULL,'187'),(1498,188,1310,'晋江市第一中学',NULL,'188'),(1499,189,1310,'晋江市第二中学',NULL,'189'),(1500,190,1310,'晋江市紫华中学',NULL,'190'),(1501,191,1310,'晋江市紫峰中学',NULL,'191'),(1502,192,1310,'晋江市英林中学',NULL,'192'),(1503,193,1310,'晋江市陈埭民族中学',NULL,'193'),(1504,194,1310,'晋江市首峰中学',NULL,'194'),(1505,195,1310,'晋江市拔萃双语学校',NULL,'195'),(1506,196,1310,'晋江市子江中学',NULL,'196'),(1507,197,1310,'泉州中远学校',NULL,'197'),(1508,198,1310,'晋江市季延初级中学',NULL,'198'),(1509,199,1310,'泉州五中桥南校区',NULL,'199'),(1523,0,0,'租房申请人才房类型','','un_renting_houseType'),(1524,1,1523,'国际人才社区',NULL,'1'),(1525,2,1523,'高端人才社区',NULL,'2'),(1541,0,0,'企业标签','注册时使用','un_enterprise_talentType'),(1542,1,1541,'国字号平台',NULL,'gzh'),(1543,2,1541,'民营企业',NULL,'myqy'),(1544,3,1541,'公办医疗卫生机构',NULL,'gbylwsjg'),(1545,5,1541,'媒体单位',NULL,'mtdw'),(1546,6,1541,'民办非企业(含民办医疗机构)',NULL,'mbfqy'),(1547,7,1541,'国有企业 (我市本级国有股比超过50％)',NULL,'gyqyh'),(1548,8,1541,'国有企业(我市本级国有股比未超过50％)',NULL,'gyqyl'),(1549,9,1541,'事业单位(医疗教育除外)',NULL,'sydw'),(1550,11,1541,'高校',NULL,'gx'),(1551,12,1541,'其他',NULL,'other'),(1552,13,1541,'事业单位(医疗教育)',NULL,'sydwyljy'),(1553,0,0,'人才标签','人才标签','un_jbt_talentType'),(1554,1,1553,'国字号平台',NULL,'gzh'),(1555,2,1553,'行政人员(高校)',NULL,'xzry'),(1556,3,1553,'专职教师(高校)',NULL,'zzjs'),(1557,4,1553,'外聘教师(高校)',NULL,'wpjs'),(1558,5,1553,'外聘非教师(高校)',NULL,'wpfjs'),(1559,6,1553,'全职人员(管委会)(高校)',NULL,'qzrygwh'),(1560,7,1553,'全职人员(晋江编制、常驻校区)(高校)',NULL,'qzrybz'),(1561,8,1553,'在编在岗教师(教学)(高校)',NULL,'zbzgjsjx'),(1562,9,1553,'在编在岗教师(科研指导)(高校)',NULL,'zbzgjskyzd'),(1563,10,1553,'在编在岗教师(教学科研)(高校)',NULL,'zbzgjsjxky'),(1564,11,1553,'民营企业',NULL,'myqy'),(1565,12,1553,'媒体单位',NULL,'mtdw'),(1566,13,1553,'民办非企业',NULL,'mbfqy'),(1567,14,1553,'国有企业(我市本级国有股比未超过50％)',NULL,'gyqyl'),(1568,15,1553,'国有企业 (我市本级国有股比超过50％)',NULL,'gyqyh'),(1569,16,1553,'事业单位(医疗教育除外)',NULL,'sydw'),(1570,17,1553,'民办医疗卫生机构',NULL,'mbylwsjg'),(1571,18,1553,'其他',NULL,'other'),(1572,20,1553,'公办医疗卫生机构(卫生在编)',NULL,'gbwszb'),(1573,22,1553,'公办医疗卫生机构(卫生编外)',NULL,'gbwsbw'),(1574,24,1553,'在站博士后',NULL,'zzbsh'),(1575,25,1553,'事业单位(医疗教育)(编制人员)',NULL,'sydwyljybzry'),(1576,26,1553,'事业单位(医疗教育)(聘用人员)',NULL,'sydwyljypyry'),(1577,0,0,'集成电路购房补贴年度比例','','un_housepurchase_percentage_ic'),(1578,1,1577,'0.4',NULL,'1'),(1579,2,1577,'0.3',NULL,'2'),(1580,3,1577,'0.3',NULL,'3'),(1598,0,0,'年级','子女就学模块','un_grade'),(1599,1,1598,'学前教育(小班)',NULL,'1'),(1600,2,1598,'学前教育(中班)',NULL,'2'),(1601,3,1598,'学前教育(大班)',NULL,'3'),(1602,4,1598,'一年级',NULL,'4'),(1603,5,1598,'二年级',NULL,'5'),(1604,6,1598,'三年级',NULL,'6'),(1605,7,1598,'四年级',NULL,'7'),(1606,8,1598,'五年级',NULL,'8'),(1607,9,1598,'六年级',NULL,'9'),(1608,10,1598,'七年级(初一)',NULL,'10'),(1609,11,1598,'八年级(初二)',NULL,'11'),(1610,12,1598,'九年级(初三)',NULL,'12'),(1611,13,1598,'高一',NULL,'13'),(1612,14,1598,'高二',NULL,'14'),(1613,15,1598,'高三',NULL,'15'),(1614,0,1598,'无',NULL,'16'),(1655,0,0,'街道','街道','un_street'),(1656,1,1655,'青阳',NULL,'00001'),(1657,2,1655,'罗山',NULL,'00002'),(1658,3,1655,'梅岭',NULL,'00003'),(1659,4,1655,'西园',NULL,'00004'),(1660,5,1655,'灵源',NULL,'00005'),(1661,6,1655,'新塘',NULL,'00006'),(1662,7,1655,'陈埭',NULL,'00007'),(1663,8,1655,'磁灶',NULL,'00008'),(1664,9,1655,'池店',NULL,'00009'),(1665,10,1655,'紫帽',NULL,'00010'),(1666,11,1655,'西滨',NULL,'00011'),(1667,12,1655,'内坑',NULL,'00012'),(1668,13,1655,'安海',NULL,'00013'),(1669,14,1655,'东石',NULL,'00014'),(1670,15,1655,'永和',NULL,'00015'),(1671,16,1655,'英林',NULL,'00016'),(1672,17,1655,'金井',NULL,'00017'),(1673,18,1655,'深沪',NULL,'00018'),(1674,19,1655,'龙湖',NULL,'00019'),(1675,20,1655,'经济开发区',NULL,'00020'),(1676,21,1655,'综合保税区',NULL,'00021'),(1677,22,1655,'无',NULL,'00000'),(1678,0,0,'申报项目','整个系统申报项目','un_project'),(1679,1,1678,'人才认定',NULL,'1'),(1680,2,1678,'津补贴申报',NULL,'2'),(1681,3,1678,'离职申报',NULL,'3'),(1682,4,1678,'工作单位变更',NULL,'4'),(1683,5,1678,'购房补贴',NULL,'5'),(1684,6,1678,'子女就学',NULL,'6'),(1685,7,1678,'银行账号变更',NULL,'7'),(1686,8,1678,'人才层次变更',NULL,'8'),(1687,9,1678,'人才基础信息变更',NULL,'9'),(1688,11,1678,'培训补贴',NULL,'11'),(1689,12,1678,'重大专项经费',NULL,'12'),(1690,13,1678,'学杂费补助',NULL,'13'),(1691,14,1678,'医疗补助',NULL,'14'),(1692,15,1678,'租房申请',NULL,'15'),(1693,16,1678,'房租补助',NULL,'16'),(1694,17,1678,'购房申请',NULL,'17'),(1695,18,1678,'购房补助',NULL,'18'),(1696,19,1678,'硕博人才生活补贴',NULL,'19'),(1697,0,0,'硕博人才学位','','un_master_education'),(1698,1,1697,'硕士',NULL,'1'),(1699,2,1697,'博士',NULL,'2'),(1700,0,0,'硕士人才生活补贴','','master_living_allowance_ss_money'),(1701,1,1700,'30000',NULL,'1'),(1702,2,1700,'20000',NULL,'2'),(1703,3,1700,'10000',NULL,'3'),(1704,0,0,'博士研究生生活补贴金额','','master_living_allowance_bs_money'),(1705,1,1704,'50000',NULL,'1'),(1706,2,1704,'30000',NULL,'2'),(1707,3,1704,'30000',NULL,'3'),(1708,0,0,'性别','','1'),(1709,1,1708,'男',NULL,'1'),(1710,2,1708,'女',NULL,'2');
/*!40000 ALTER TABLE `sys_dict` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_enterprisetype_properties`
--

DROP TABLE IF EXISTS `sys_enterprisetype_properties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_enterprisetype_properties` (
  `id` varchar(40) NOT NULL,
  `talentType` varchar(20) DEFAULT NULL,
  `companyIds` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='企业标签审核单位配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_enterprisetype_properties`
--

LOCK TABLES `sys_enterprisetype_properties` WRITE;
/*!40000 ALTER TABLE `sys_enterprisetype_properties` DISABLE KEYS */;
INSERT INTO `sys_enterprisetype_properties` VALUES ('1199656168261849089','gyqyh','1197443773921181697,1201673316928286721,','',NULL,NULL,NULL,NULL),('1199656807905792002','gyqyl','1197443773921181697,1201673316928286721,','',NULL,NULL,NULL,NULL),('1199656845386092545','gzh','1197443773921181697,','',NULL,NULL,NULL,NULL),('1199656914252369922','myqy','1197443773921181697,','',NULL,NULL,NULL,NULL),('1199656962910490626','gbylwsjg','1197443773921181697,','',NULL,NULL,NULL,NULL),('1199657007403667458','mtdw','1196328018018181122,1197443773921181697,','',NULL,NULL,NULL,NULL),('1199657042455465986','mbfqy','1196327955313336322,1197443773921181697,','',NULL,NULL,NULL,NULL),('1199657107773362178','sydw','1197443773921181697,','',NULL,NULL,NULL,NULL),('1199657142850326530','zzbsh','1197443773921181697,','',NULL,NULL,NULL,NULL),('1199657169878421506','gx','1197443773921181697,','',NULL,NULL,NULL,NULL),('1219526905187844098','other','1197443773921181697,','',NULL,NULL,NULL,NULL),('1277787964746797058','sydwyljy','1197443773921181697,','',NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `sys_enterprisetype_properties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_expense`
--

DROP TABLE IF EXISTS `sys_expense`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_expense` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `money` decimal(20,2) DEFAULT NULL COMMENT '报销金额',
  `desc` varchar(255) DEFAULT '' COMMENT '描述',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `state` int(11) DEFAULT NULL COMMENT '状态: 1.待提交  2:待审核   3.审核通过 4:驳回',
  `userid` int(11) DEFAULT NULL COMMENT '用户id',
  `processId` varchar(255) DEFAULT NULL COMMENT '流程定义id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='报销表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_expense`
--

LOCK TABLES `sys_expense` WRITE;
/*!40000 ALTER TABLE `sys_expense` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_expense` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_expert`
--

DROP TABLE IF EXISTS `sys_expert`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_expert` (
  `id` varchar(255) NOT NULL COMMENT '唯一标识',
  `name` varchar(255) NOT NULL COMMENT '专家姓名',
  `phone` varchar(255) NOT NULL COMMENT '联系方式',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` datetime DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(255) DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(255) DEFAULT NULL COMMENT '更新用户',
  `state` int(11) DEFAULT 2 COMMENT '有效状态，1为有效，2为有效',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `name` (`name`) USING BTREE COMMENT '唯一标识'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_expert`
--

LOCK TABLES `sys_expert` WRITE;
/*!40000 ALTER TABLE `sys_expert` DISABLE KEYS */;
INSERT INTO `sys_expert` VALUES ('1158646386422792193','qjc','17610052773','32','2019-08-06 03:49:59','1','2019-09-26 10:56:28','1',1),('1159630918152204289','1231','12352423324','231','2019-08-09 09:02:10','1',NULL,NULL,1),('1177054473781329921','fw','12345567823','2','2019-09-26 10:57:09','1',NULL,NULL,1);
/*!40000 ALTER TABLE `sys_expert` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_feedback`
--

DROP TABLE IF EXISTS `sys_feedback`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_feedback` (
  `id` varchar(40) NOT NULL COMMENT 'id',
  `pid` varchar(40) DEFAULT '0',
  `userId` varchar(40) DEFAULT NULL,
  `type` int(2) DEFAULT NULL,
  `description` varchar(2000) DEFAULT NULL,
  `replyContent` varchar(2000) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `createUser` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_feedback`
--

LOCK TABLES `sys_feedback` WRITE;
/*!40000 ALTER TABLE `sys_feedback` DISABLE KEYS */;
INSERT INTO `sys_feedback` VALUES ('1211654576244047874','0','1211479687600062466',1,'测试','测试','2019-12-30 22:25:37','测试','2020-03-24 14:38:49','刘建锋'),('1213731136866373633','0','1211816368236707842',2,'泉州市优秀农村实用人才按照政策文件也可以申报第五类人才，选项里面搜索不到，联系电话：18558994473',NULL,'2020-01-05 15:57:07','晋江市吉隆农业综合开发有限公司',NULL,NULL),('1214113083451002882','0','1211439642532954113',2,'1、审核中不能修改信息；\n2、引进人才方式不能选择无。\n',NULL,'2020-01-06 17:14:50','福建省晋江城市建设投资开发集团有限责任公司',NULL,NULL),('1214376591086407681','0','1212253296765505538',2,'填写申报人才信息时一会就会屏保，再打开时内容就全没有了，就是选择了保存也不行，太不好用了。',NULL,'2020-01-07 10:41:55','泉州寰球鞋服有限公司',NULL,NULL),('1217275565870960642','0','1211945767430832130',2,'您好，有信息填错，请帮忙退回晋江市安海医院的王雄力，甯家琴，胡建军，吕平华，尹耀慧5人。谢谢',NULL,'2020-01-15 10:41:25','晋江市安海医院',NULL,NULL),('1220265263446900737','0','1220180021985951745',2,'管理类副高级职称，以前可以认定为晋江优秀人才四类，现在转为泉州高层次人才认定后，没有可以对应的层次认定了。',NULL,'2020-01-23 16:41:24','晋江市新合发塑胶印刷有限公司',NULL,NULL),('1220265566502141953','0','1220180021985951745',2,'以前被认定的晋江优秀人才，购房补贴还没有到期，剩余的年限是否还可以申请补贴？',NULL,'2020-01-23 16:42:37','晋江市新合发塑胶印刷有限公司',NULL,NULL),('1230329267460632577','0','1211945767430832130',2,'丁峰的银行卡号未填写，目前填写不了',NULL,'2020-02-20 11:12:10','晋江市安海医院',NULL,NULL),('1231743028423684097','0','1211945767430832130',2,'本批新的优秀人才公示，安海医院有李聪蓉、蔡耿耀、肖文焕、张向前、黄香莲五人从第五层次变为第四层次的人才，已公示，但人才证没有下来，请问这次信息填报填第几层次？',NULL,'2020-02-24 08:49:57','晋江市安海医院',NULL,NULL),('1245885231605571586','0','1211450825436610561',2,'审批速度太慢',NULL,'2020-04-03 09:26:01','福建海峡石墨烯产业技术研究院有限公司',NULL,NULL),('1281054703202897921','0','1214766839310147586',2,'你好，林建新的高层次人才申报其他栏的行政介绍信要上传吗，点修改进去没有一个上传附件的键，无法上传。',NULL,'2020-07-09 10:36:56','晋江市内坑镇卫生院',NULL,NULL),('1281472060022861826','0','1275632103135952897',1,'1、 360极速浏览器 ，人才认定的基础信息填写完成，系统判定说需要填写。人才认定的附件没办法提交。\n\n2、ie11，账号登录不了。',NULL,'2020-07-10 14:15:22','福建省信芯长盈科技有限公司',NULL,NULL),('1288397398950866945','0','1211461407799820290',1,'津补贴申报无法操作',NULL,'2020-07-29 16:54:11','晋江经济报发展有限责任公司',NULL,NULL),('1289125072304398337','0','1211945767430832130',2,'吴重祥改银行卡号，津贴申请请驳回\n',NULL,'2020-07-31 17:05:42','晋江市安海医院',NULL,NULL),('1289353985509048321','0','1211945767430832130',2,'沈梅芬银行卡号更换，津贴申请请驳回','需要变更银行账号信息请在系统做”银行账号变更“申报，审核通过后会自动更新至津补贴库，但是津补贴在公示之后将无法修改银行账号信息。','2020-08-01 08:15:19','晋江市安海医院','2020-08-03 11:51:41','刘建锋'),('1290105868293042178','0','1211490953219588098',2,'人才库是否可以添加人才相关信息批量导出，比如银行账号等信息。','人才库已有该功能，请点击左侧菜单栏“优秀人才库”，点击“导出按钮”，选择需要导出的字段即可','2020-08-03 10:03:02','中国科学院海西研究院泉州装备制造研究所','2020-08-03 11:48:04','刘建锋'),('1383234772431663106','0','1211945767430832130',2,'工作单位变更需要修改，请撤回许群英和吴辉炫',NULL,'2021-04-17 09:44:03','晋江市安海医院',NULL,NULL),('1385132339130007554','0','1374922080805564418',1,'无法修改内容',NULL,'2021-04-22 15:24:18','晋江市文物保护中心',NULL,NULL),('1395541491920711681','0','1374922080805564418',1,'无法按照人社局的要求更改信息内容',NULL,'2021-05-21 08:46:34','晋江市文物保护中心',NULL,NULL),('1399904044440387586','0','1348924009986654209',1,'如何撤销申报',NULL,'2021-06-02 09:41:47','福建力利实业有限公司',NULL,NULL),('1400996441844908034','0','1348924009986654209',2,'如何撤销申报中的信息','您好,申报信息一旦提交审核无法撤回，只有相关部门审核驳回后才能修改。需要修改时可以联系相关部门驳回再行修改。','2021-06-05 10:02:35','福建力利实业有限公司','2021-06-07 10:46:20','刘建锋');
/*!40000 ALTER TABLE `sys_feedback` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_login_log`
--

DROP TABLE IF EXISTS `sys_login_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_login_log` (
  `id` int(65) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `logname` varchar(255) DEFAULT NULL COMMENT '日志名称',
  `userid` int(65) DEFAULT NULL COMMENT '管理员id',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `succeed` varchar(255) DEFAULT NULL COMMENT '是否执行成功',
  `message` text DEFAULT NULL COMMENT '具体消息',
  `ip` varchar(255) DEFAULT NULL COMMENT '登录ip',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=275484 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='登录记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_login_log`
--

LOCK TABLES `sys_login_log` WRITE;
/*!40000 ALTER TABLE `sys_login_log` DISABLE KEYS */;
INSERT INTO `sys_login_log` VALUES (275450,'登录日志',1,'2022-08-11 04:45:21','成功',NULL,'127.0.0.1'),(275451,'退出日志',1,'2022-08-11 07:13:15','成功',NULL,'127.0.0.1'),(275452,'登录日志',1,'2022-08-11 07:13:30','成功',NULL,'127.0.0.1'),(275453,'退出日志',1,'2022-08-11 08:03:58','成功',NULL,'127.0.0.1'),(275454,'登录日志',1,'2022-08-11 09:20:07','成功',NULL,'127.0.0.1'),(275455,'登录日志',1,'2022-08-18 13:28:40','成功',NULL,'127.0.0.1'),(275456,'登录日志',1,'2022-08-19 12:08:30','成功',NULL,'127.0.0.1'),(275457,'退出日志',1,'2022-08-19 13:23:27','成功',NULL,'127.0.0.1'),(275458,'登录日志',1,'2022-08-19 13:37:01','成功',NULL,'127.0.0.1'),(275459,'退出日志',1,'2022-08-19 13:53:59','成功',NULL,'127.0.0.1'),(275460,'登录日志',1,'2022-08-19 14:17:43','成功',NULL,'127.0.0.1'),(275461,'退出日志',1,'2022-08-19 14:17:48','成功',NULL,'127.0.0.1'),(275462,'登录日志',1,'2022-08-19 15:47:20','成功',NULL,'127.0.0.1'),(275463,'退出日志',1,'2022-08-19 16:03:12','成功',NULL,'127.0.0.1'),(275464,'登录日志',1,'2022-08-19 17:13:31','成功',NULL,'127.0.0.1'),(275465,'退出日志',1,'2022-08-19 17:33:41','成功',NULL,'127.0.0.1'),(275466,'登录日志',1,'2022-08-19 18:07:13','成功',NULL,'127.0.0.1'),(275467,'退出日志',1,'2022-08-19 18:20:44','成功',NULL,'127.0.0.1'),(275468,'登录日志',1,'2022-08-19 18:22:32','成功',NULL,'127.0.0.1'),(275469,'退出日志',1,'2022-08-19 18:31:38','成功',NULL,'127.0.0.1'),(275470,'登录日志',1,'2022-08-19 18:52:14','成功',NULL,'127.0.0.1'),(275471,'登录日志',1,'2022-08-19 19:17:35','成功',NULL,'127.0.0.1'),(275472,'退出日志',1,'2022-08-19 19:23:31','成功',NULL,'127.0.0.1'),(275473,'登录日志',1,'2022-08-21 03:04:11','成功',NULL,'127.0.0.1'),(275474,'登录日志',1,'2022-08-21 05:27:16','成功',NULL,'127.0.0.1'),(275475,'退出日志',1,'2022-08-21 06:01:43','成功',NULL,'127.0.0.1'),(275476,'登录日志',58,'2022-08-21 06:01:50','成功',NULL,'127.0.0.1'),(275477,'退出日志',58,'2022-08-21 06:02:36','成功',NULL,'127.0.0.1'),(275478,'登录日志',58,'2022-08-21 06:02:45','成功',NULL,'127.0.0.1'),(275479,'登录日志',1,'2022-08-21 08:48:30','成功',NULL,'127.0.0.1'),(275480,'退出日志',1,'2022-08-21 11:31:21','成功',NULL,'127.0.0.1'),(275481,'登录日志',1,'2022-08-21 11:58:35','成功',NULL,'127.0.0.1'),(275482,'退出日志',1,'2022-08-21 11:58:37','成功',NULL,'127.0.0.1'),(275483,'登录日志',1,'2022-08-21 17:02:57','成功',NULL,'127.0.0.1');
/*!40000 ALTER TABLE `sys_login_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_menu`
--

DROP TABLE IF EXISTS `sys_menu`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_menu` (
  `id` bigint(20) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `code` varchar(255) DEFAULT NULL COMMENT '菜单编号',
  `pcode` varchar(255) DEFAULT NULL COMMENT '菜单父编号',
  `pcodes` varchar(255) DEFAULT NULL COMMENT '当前菜单的所有父菜单编号',
  `name` varchar(255) DEFAULT NULL COMMENT '菜单名称',
  `icon` varchar(255) DEFAULT NULL COMMENT '菜单图标',
  `url` varchar(255) DEFAULT NULL COMMENT 'url地址',
  `num` int(65) DEFAULT NULL COMMENT '菜单排序号',
  `levels` int(65) DEFAULT NULL COMMENT '菜单层级',
  `ismenu` int(11) DEFAULT NULL COMMENT '是否是菜单（1：是  0：不是）',
  `tips` varchar(255) DEFAULT NULL COMMENT '备注',
  `status` int(65) DEFAULT NULL COMMENT '菜单状态 :  1:启用   0:不启用',
  `isopen` int(11) DEFAULT NULL COMMENT '是否打开:    1:打开   0:不打开',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=558 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='菜单表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_menu`
--

LOCK TABLES `sys_menu` WRITE;
/*!40000 ALTER TABLE `sys_menu` DISABLE KEYS */;
INSERT INTO `sys_menu` VALUES (105,'system','0','[0],','系统管理','fa-cogs','#',1,1,1,NULL,1,1),(106,'mgr','system','[0],[system],','用户管理','','/mgr',9,2,1,NULL,1,0),(107,'mgr_add','mgr','[0],[system],[mgr],','添加用户',NULL,'/mgr/add',1,3,0,NULL,1,0),(108,'mgr_edit','mgr','[0],[system],[mgr],','修改用户',NULL,'/mgr/edit',2,3,0,NULL,1,0),(109,'mgr_delete','mgr','[0],[system],[mgr],','删除用户',NULL,'/mgr/delete',3,3,0,NULL,1,0),(110,'mgr_reset','mgr','[0],[system],[mgr],','重置密码',NULL,'/mgr/reset',4,3,0,NULL,1,0),(111,'mgr_freeze','mgr','[0],[system],[mgr],','冻结用户',NULL,'/mgr/freeze',5,3,0,NULL,1,0),(112,'mgr_unfreeze','mgr','[0],[system],[mgr],','解除冻结用户',NULL,'/mgr/unfreeze',6,3,0,NULL,1,0),(113,'mgr_setRole','mgr','[0],[system],[mgr],','分配角色',NULL,'/mgr/setRole',7,3,0,NULL,1,0),(114,'role','system','[0],[system],','角色管理','','/role',8,2,1,NULL,1,0),(115,'role_add','role','[0],[system],[role],','添加角色',NULL,'/role/add',1,3,0,NULL,1,0),(116,'role_edit','role','[0],[system],[role],','修改角色',NULL,'/role/edit',2,3,0,NULL,1,0),(117,'role_remove','role','[0],[system],[role],','删除角色',NULL,'/role/remove',3,3,0,NULL,1,0),(118,'role_setAuthority','role','[0],[system],[role],','配置权限','','/role/setAuthority',4,3,0,NULL,1,0),(119,'menu','system','[0],[system],','菜单管理','','/menu',2,2,1,NULL,1,0),(120,'menu_add','menu','[0],[system],[menu],','添加菜单',NULL,'/menu/add',1,3,0,NULL,1,0),(121,'menu_edit','menu','[0],[system],[menu],','修改菜单',NULL,'/menu/edit',2,3,0,NULL,1,0),(122,'menu_remove','menu','[0],[system],[menu],','删除菜单',NULL,'/menu/remove',3,3,0,NULL,1,0),(128,'log','system','[0],[system],','业务日志',NULL,'/log',6,2,1,NULL,1,0),(130,'druid','system','[0],[system],','监控管理',NULL,'/druid',7,2,1,NULL,1,NULL),(131,'dept','system','[0],[system],','部门管理','','/dept',4,2,1,NULL,1,NULL),(132,'dict','system','[0],[system],','字典管理','','/dict',1,2,1,NULL,1,NULL),(133,'loginLog','system','[0],[system],','登录日志','','/loginLog',5,2,1,NULL,1,NULL),(134,'log_clean','log','[0],[system],[log],','清空日志',NULL,'/log/delLog',3,3,0,NULL,1,NULL),(135,'dept_add','dept','[0],[system],[dept],','添加部门',NULL,'/dept/add',1,3,0,NULL,1,NULL),(136,'dept_update','dept','[0],[system],[dept],','修改部门',NULL,'/dept/update',1,3,0,NULL,1,NULL),(137,'dept_delete','dept','[0],[system],[dept],','删除部门',NULL,'/dept/delete',1,3,0,NULL,1,NULL),(138,'dict_add','dict','[0],[system],[dict],','添加字典',NULL,'/dict/add',1,3,0,NULL,1,NULL),(139,'dict_update','dict','[0],[system],[dict],','修改字典',NULL,'/dict/update',1,3,0,NULL,1,NULL),(140,'dict_delete','dict','[0],[system],[dict],','删除字典',NULL,'/dict/delete',1,3,0,NULL,1,NULL),(141,'notice','system','[0],[system],','通知管理',NULL,'/notice',9,2,1,NULL,1,NULL),(142,'notice_add','notice','[0],[system],[notice],','添加通知',NULL,'/notice/add',1,3,0,NULL,1,NULL),(143,'notice_update','notice','[0],[system],[notice],','修改通知',NULL,'/notice/update',2,3,0,NULL,1,NULL),(144,'notice_delete','notice','[0],[system],[notice],','删除通知',NULL,'/notice/delete',3,3,0,NULL,1,NULL),(145,'hello','0','[0],','通知','fa-rocket','/notice/hello',98,1,1,NULL,1,NULL),(148,'code','0','[0],','代码生成','fa-code','/code',99,1,1,NULL,1,NULL),(149,'api_mgr','0','[0],','接口文档','fa-leaf','/swagger-ui.html',100,1,1,NULL,1,NULL),(150,'to_menu_edit','menu','[0],[system],[menu],','菜单编辑跳转','','/menu/menu_edit',4,3,0,NULL,1,NULL),(151,'menu_list','menu','[0],[system],[menu],','菜单列表','','/menu/list',5,3,0,NULL,1,NULL),(152,'to_dept_update','dept','[0],[system],[dept],','修改部门跳转','','/dept/dept_update',4,3,0,NULL,1,NULL),(153,'dept_list','dept','[0],[system],[dept],','部门列表','','/dept/list',5,3,0,NULL,1,NULL),(154,'dept_detail','dept','[0],[system],[dept],','部门详情','','/dept/detail',6,3,0,NULL,1,NULL),(155,'to_dict_edit','dict','[0],[system],[dict],','修改菜单跳转','','/dict/dict_edit',4,3,0,NULL,1,NULL),(156,'dict_list','dict','[0],[system],[dict],','字典列表','','/dict/list',5,3,0,NULL,1,NULL),(157,'dict_detail','dict','[0],[system],[dict],','字典详情','','/dict/detail',6,3,0,NULL,1,NULL),(158,'log_list','log','[0],[system],[log],','日志列表','','/log/list',2,3,0,NULL,1,NULL),(159,'log_detail','log','[0],[system],[log],','日志详情','','/log/detail',3,3,0,NULL,1,NULL),(160,'del_login_log','loginLog','[0],[system],[loginLog],','清空登录日志','','/loginLog/delLoginLog',1,3,0,NULL,1,NULL),(161,'login_log_list','loginLog','[0],[system],[loginLog],','登录日志列表','','/loginLog/list',2,3,0,NULL,1,NULL),(162,'to_role_edit','role','[0],[system],[role],','修改角色跳转','','/role/role_edit',5,3,0,NULL,1,NULL),(163,'to_role_assign','role','[0],[system],[role],','角色分配跳转','','/role/role_assign',6,3,0,NULL,1,NULL),(164,'role_list','role','[0],[system],[role],','角色列表','','/role/list',7,3,0,NULL,1,NULL),(165,'to_assign_role','mgr','[0],[system],[mgr],','分配角色跳转','','/mgr/role_assign',8,3,0,NULL,1,NULL),(166,'to_user_edit','mgr','[0],[system],[mgr],','编辑用户跳转','','/mgr/user_edit',9,3,0,NULL,1,NULL),(167,'mgr_list','mgr','[0],[system],[mgr],','用户列表','','/mgr/list',10,3,0,NULL,1,NULL),(173,'unCommonFiletype','fileType','[0],[fileType],','人才认定申报','','/unCommonFiletype',3,2,1,NULL,1,NULL),(185,'company','system','[0],[system],','单位管理','','/company',3,2,1,NULL,1,NULL),(186,'company_add','company','[0],[system],[company],','添加','','/company/add',1,3,0,NULL,1,NULL),(187,'expertManager','system','[0],[system],','专家管理','','/expert',10,2,1,NULL,1,NULL),(188,'expertAdd','expertManager','[0],[system],[expertManager],','添加','','/expert/add',1,3,0,NULL,1,NULL),(189,'expertUpdate','expertManager','[0],[system],[expertManager],','修改','','/expert/update',2,3,0,NULL,1,NULL),(190,'expertDelete','expertManager','[0],[system],[expertManager],','删除','','/expert/delete',3,3,0,NULL,1,NULL),(191,'fileType','0','[0],','附件类别管理','fa-file','#',4,1,1,NULL,1,NULL),(192,'company_update','company','[0],[system],[company],','修改','','/company/update',2,3,0,NULL,1,NULL),(193,'company_delete','company','[0],[system],[company],','删除','','/company/delete',4,3,0,NULL,1,NULL),(194,'company_select','company','[0],[system],[company],','查看','','/company/select',3,3,0,NULL,1,NULL),(195,'gotoEnterprisePage','enterpriseAdmin','[0],[enterpriseAdmin],','企业用户','','/enterprise/gotoEnterprisePage',1,2,1,NULL,1,NULL),(196,'enterprise_setActive','gotoEnterprisePage','[0],[gotoEnterprisePage],','设置冻结','','/enterprise/setActive',1,2,0,NULL,1,NULL),(197,'enterprise_doExamine','gotoEnterprisePage','[0],[gotoEnterprisePage],','审核','','/enterprise/doExamine',2,2,0,NULL,1,NULL),(198,'enterprise_delEnterprise','gotoEnterprisePage','[0],[gotoEnterprisePage],','删除','','/enterprise/delEnterprise',3,2,0,NULL,1,NULL),(200,'enterprise_resetPassword','gotoEnterprisePage','[0],[gotoEnterprisePage],','重置密码','','/enterprise/resetPassword',6,2,0,NULL,1,NULL),(201,'channelPlanFiletype','fileType','[0],[fileType],','海峡计划申报','','/channelPlanFiletype',99,2,1,NULL,1,0),(202,'channelPlanFiletype_list','channelPlanFiletype','[0],[fileType],[channelPlanFiletype],','海峡计划申报列表','','/channelPlanFiletype/list',99,3,0,NULL,1,0),(203,'channelPlanFiletype_add','channelPlanFiletype','[0],[fileType],[channelPlanFiletype],','海峡计划申报添加','','/channelPlanFiletype/add',99,3,0,NULL,1,0),(204,'channelPlanFiletype_update','channelPlanFiletype','[0],[fileType],[channelPlanFiletype],','海峡计划申报更新','','/channelPlanFiletype/update',99,3,0,NULL,1,0),(205,'channelPlanFiletype_delete','channelPlanFiletype','[0],[fileType],[channelPlanFiletype],','海峡计划申报删除','','/channelPlanFiletype/delete',99,3,0,NULL,1,0),(206,'channelPlanFiletype_detail','channelPlanFiletype','[0],[fileType],[channelPlanFiletype],','海峡计划申报详情','','/channelPlanFiletype/detail',99,3,0,NULL,1,0),(214,'enterprise_export','gotoEnterprisePage','[0],[gotoEnterprisePage],','导出','','/enterprise/export',5,2,0,NULL,1,NULL),(215,'enterpriseAdmin','0','[0],','企业信息','fa-institution','#',2,1,1,NULL,1,NULL),(216,'gotoEnterpriseChangeRecordPage','enterpriseAdmin','[0],[enterpriseAdmin],','企业信息变更','','/enterprisechangeRecord/gotoEnterpriseChangeRecordPage',2,2,1,NULL,1,NULL),(217,'unCommonFiletypeAdd','unCommonFiletype','[0],[fileType],[unCommonFiletype],','添加','','/unCommonFiletype/add',1,3,0,NULL,1,NULL),(218,'unCommonFiletypeUpdate','unCommonFiletype','[0],[fileType],[unCommonFiletype],','修改','','/unCommonFiletype/update',2,3,0,NULL,1,NULL),(219,'gotoEnterpriseChangeDetailPage','gotoEnterpriseChangeRecordPage','[0],[enterpriseAdmin],[gotoEnterpriseChangeRecordPage],','查看详情','','/enterprisechangeRecord/gotoEnterpriseChangeDetailPage',1,3,0,NULL,1,NULL),(220,'enterprisechangeRecord_doExamine','gotoEnterpriseChangeRecordPage','[0],[enterpriseAdmin],[gotoEnterpriseChangeRecordPage],','审核','','/enterprisechangeRecord/doExamine',2,3,0,NULL,1,NULL),(221,'person_gotoPersonPage','0','[0],','个人用户信息','fa-user','/person/gotoPersonPage',3,1,1,NULL,1,NULL),(222,'gotoPersonDetailPage','person_gotoPersonPage','[0],[person_gotoPersonPage],','查看详情','','/person/gotoPersonDetailPage',1,2,0,NULL,1,NULL),(223,'person_setActive','person_gotoPersonPage','[0],[person_gotoPersonPage],','设置冻结','','/person/setActive',2,2,0,NULL,1,NULL),(224,'person_resetPassword','person_gotoPersonPage','[0],[person_gotoPersonPage],','重置密码','','/person/resetPassword',3,2,0,NULL,1,NULL),(225,'talentAllowanceFiletype','fileType','[0],[fileType],','人才津贴申报','','/talentAllowanceFiletype',3,2,1,NULL,1,NULL),(226,'talentAllowanceFiletypeAdd','talentAllowanceFiletype','[0],[fileType],[talentAllowanceFiletype],','添加','','/talentAllowanceFiletype/add',1,3,0,NULL,1,NULL),(227,'talentAllowanceFiletypeUpdate','talentAllowanceFiletype','[0],[fileType],[talentAllowanceFiletype],','修改','','/talentAllowanceFiletype/update',2,3,0,NULL,1,NULL),(228,'talentAllowanceFiletypeExport','talentAllowanceFiletype','[0],[fileType],[talentAllowanceFiletype],','导出','','/talentAllowanceFiletype/export',3,3,0,NULL,1,NULL),(229,'batch','system','[0],[system],','批次管理','','/batch',99,2,1,NULL,1,0),(230,'batch_list','batch','[0],[system],[batch],','批次管理列表','','/batch/list',99,3,0,NULL,1,0),(231,'batch_add','batch','[0],[system],[batch],','批次管理添加','','/batch/add',99,3,0,NULL,1,0),(232,'batch_update','batch','[0],[system],[batch],','批次管理更新','','/batch/update',99,3,0,NULL,1,0),(233,'batch_delete','batch','[0],[system],[batch],','批次管理删除','','/batch/delete',99,3,0,NULL,1,0),(234,'batch_detail','batch','[0],[system],[batch],','批次管理详情','','/batch/detail',99,3,0,NULL,1,0),(235,'channelPlan','0','[0],','海峡计划管理','fa-briefcase','#',5,1,1,NULL,1,NULL),(236,'channelplanScoreStandard','channelPlan','[0],[channelPlan],','评分标准','','/channelplanScoreStandard',1,2,1,NULL,1,NULL),(237,'channelplanScoreStandardAdd','channelplanScoreStandard','[0],[channelPlan],[channelplanScoreStandard],','添加','','/channelplanScoreStandard/add',1,3,0,NULL,1,NULL),(238,'channelplanScoreStandardUpdate','channelplanScoreStandard','[0],[channelPlan],[channelplanScoreStandard],','修改','','/channelplanScoreStandard/update',2,3,0,NULL,1,NULL),(239,'batch_active','batch','[0],[system],[batch],','批次管理设置生效','fa-toggle-off','/batch/setActive',5,3,0,NULL,1,NULL),(240,'talentIdentify','0','[0],','人才认定管理','fa-gavel ','#',6,1,1,NULL,1,NULL),(241,'channelplanScoreStandardDelete','channelplanScoreStandard','[0],[channelPlan],[channelplanScoreStandard],','删除','','/channelplanScoreStandard/delete',3,3,0,NULL,1,NULL),(242,'identifyCondition','talentIdentify','[0],[talentIdentify],','认定条件管理','','/identifyCondition',1,2,1,NULL,1,0),(243,'identifyCondition_list','identifyCondition','[0],[talentIdentify],[identifyCondition],','认定条件管理列表','','/identifyCondition/list',99,3,0,NULL,1,0),(244,'identifyCondition_add','identifyCondition','[0],[talentIdentify],[identifyCondition],','认定条件管理添加','','/identifyCondition/add',99,3,0,NULL,1,0),(245,'identifyCondition_update','identifyCondition','[0],[talentIdentify],[identifyCondition],','认定条件管理更新','','/identifyCondition/update',99,3,0,NULL,1,0),(246,'identifyCondition_delete','identifyCondition','[0],[talentIdentify],[identifyCondition],','认定条件管理删除','','/identifyCondition/delete',99,3,0,NULL,1,0),(247,'identifyCondition_detail','identifyCondition','[0],[talentIdentify],[identifyCondition],','认定条件管理详情','','/identifyCondition/detail',99,3,0,NULL,1,0),(248,'currencyFiletype','fileType','[0],[fileType],','通用附件类别','','/currencyFiletype',99,2,1,NULL,1,0),(249,'currencyFiletype_list','currencyFiletype','[0],[fileType],[currencyFiletype],','通用附件类别列表','','/currencyFiletype/list',99,3,0,NULL,1,0),(250,'currencyFiletype_add','currencyFiletype','[0],[fileType],[currencyFiletype],','通用附件类别添加','','/currencyFiletype/add',99,3,0,NULL,1,0),(251,'currencyFiletype_update','currencyFiletype','[0],[fileType],[currencyFiletype],','通用附件类别更新','','/currencyFiletype/update',99,3,0,NULL,1,0),(252,'currencyFiletype_delete','currencyFiletype','[0],[fileType],[currencyFiletype],','通用附件类别删除','','/currencyFiletype/delete',99,3,0,NULL,1,0),(253,'currencyFiletype_detail','currencyFiletype','[0],[fileType],[currencyFiletype],','通用附件类别详情','','/currencyFiletype/detail',99,3,0,NULL,1,0),(254,'talentInfo_first','talentIdentify','[0],[talentIdentify],','初级审核','','/talentInfo/gotoIndex/1',15,2,1,NULL,1,NULL),(255,'talentInfo_firstCheck','talentInfo_first','[0],[talentIdentify],[talentInfo_first],','审核','','/talentInfo/firstCheck',1,3,0,NULL,1,NULL),(257,'talentInfo_dep','talentIdentify','[0],[talentIdentify],','部门审核','','/talentInfo/gotoIndex/2',20,2,1,NULL,1,NULL),(258,'talentInfo_depCheck','talentInfo_dep','[0],[talentIdentify],[talentInfo_dep],','审核','','/talentInfo/depCheck',1,3,0,NULL,1,NULL),(260,'talentInfo_third','talentIdentify','[0],[talentIdentify],','复核','','/talentInfo/gotoIndex/3',25,2,1,NULL,1,NULL),(261,'talentInfo_thirdCheck','talentInfo_third','[0],[talentIdentify],[talentInfo_third],','审核& #40;非集成电路& #41;','','/talentInfo/thirdCheck',1,3,0,NULL,1,NULL),(264,'talentLibrary','0','[0],','优秀人才库','fa-book','#',7,1,1,NULL,1,NULL),(265,'talentInfo_library','talentLibrary','[0],[talentLibrary],','优秀人才库','','/talentInfo/gotoIndex/5',1,2,1,NULL,1,NULL),(266,'talentInfo_libraryDetail','talentInfo_library','[0],[#],[talentInfo_library],','查看','','/talentInfo/libraryDetail',1,3,0,NULL,1,NULL),(267,'channelPlanDeclare','channelPlan','[0],[channelPlan],','海峡计划申报','','/channelplanBasicinfo',2,2,1,NULL,1,NULL),(268,'channelPlanAssessDetail','channelPlanDeclare','[0],[channelPlan],[channelPlanDeclare],','详情','','/channelplanBasicinfo/update',1,3,0,NULL,1,NULL),(269,'talentQuit','talentLibrary','[0],[talentLibrary],','离职申报','','/talentQuit',2,2,1,NULL,1,NULL),(270,'talentWorkUnitChange','talentLibrary','[0],[talentLibrary],','工作单位变更','','/talentWorkunitChange',3,2,1,NULL,1,NULL),(271,'talentBankChange','talentLibrary','[0],[talentLibrary],','银行账号变更','','/talentBankChange',4,2,1,NULL,1,NULL),(272,'talentTypeChangeFirst','talentTypeChangeMain','[0],[talentTypeChangeMain],','初级审核','','/talentTypeChange/gotoIndex/1',2,2,1,NULL,1,NULL),(273,'TalentChangeQuitCheck','talentQuit','[0],[talentLibrary],[talentQuit],','审核','','/talentChange/quitCheck',1,3,0,NULL,1,NULL),(274,'TalentChangeQuitDetail','talentQuit','[0],[talentLibrary],[talentQuit],','查看','','/talentChange/quitDetail',3,3,0,NULL,1,NULL),(275,'talentWorkUnitChangeCheck','talentWorkUnitChange','[0],[talentLibrary],[talentWorkUnitChange],','审核','','/talentWorkunitChange/workunitCheck',1,3,0,NULL,1,NULL),(276,'talentWorkUnitChangeSelect','talentWorkUnitChange','[0],[talentLibrary],[talentWorkUnitChange],','查看','','/talentWorkunitChange/workunitDetail',3,3,0,NULL,1,NULL),(277,'talentBankChangeCheck','talentBankChange','[0],[talentLibrary],[talentBankChange],','审核','','/talentBankChange/bankCheck',1,3,0,NULL,1,NULL),(278,'talentBankChangeSelect','talentBankChange','[0],[talentLibrary],[talentBankChange],','查看','','/talentBankChange/bankDetail',3,3,0,NULL,1,NULL),(279,'talentTypeChangeFirstCheck','talentTypeChangeFirst','[0],[talentTypeChangeMain],[talentTypeChangeFirst],','审核','','/talentTypeChange/firstCheck',1,3,0,NULL,1,NULL),(280,'talentTypeChangeFirstSelect','talentTypeChangeFirst','[0],[talentTypeChangeMain],[talentTypeChangeFirst],','查看','','/talentTypeChange/firstDetail',3,3,0,NULL,1,NULL),(282,'talentLibraryPublic','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公示','5','/talentInfo/preparePublic',1,3,0,NULL,1,NULL),(286,'talentLibraryPublicExport','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公示导出','','/talentInfo/preparePublicExport',7,3,0,NULL,1,NULL),(292,'talentTypeChangeMain','0','[0],','人才层次变更','fa-street-view','#',8,1,1,NULL,1,NULL),(293,'talentTypeChangeDep','talentTypeChangeMain','[0],[talentTypeChangeMain],','部门审核','','/talentTypeChange/gotoIndex/2',3,2,1,NULL,1,NULL),(294,'talentTypeChangeThird','talentTypeChangeMain','[0],[talentTypeChangeMain],','复核','','/talentTypeChange/gotoIndex/3',4,2,1,NULL,1,NULL),(295,'talentTypeChangePrepare','talentTypeChangeMain','[0],[talentTypeChangeMain],','预备变更库','','/talentTypeChange/gotoIndex/4',5,2,1,NULL,1,NULL),(296,'talentTypeChange','talentTypeChangeDep','[0],[talentTypeChangeMain],[talentTypeChangeDep],','审核','','/talentTypeChange/depCheck',1,3,0,NULL,1,NULL),(298,'talentTypeChangeDepDetail','talentTypeChangeDep','[0],[talentTypeChangeMain],[talentTypeChangeDep],','查看','','/talentTypeChange/depDetail',3,3,0,NULL,1,NULL),(299,'talentTypeChangeThirdCheck','talentTypeChangeThird','[0],[talentTypeChangeMain],[talentTypeChangeThird],','审核','','/talentTypeChange/thirdCheck',1,3,0,NULL,1,NULL),(301,'talentTypeChangeThirdDetail','talentTypeChangeThird','[0],[talentTypeChangeMain],[talentTypeChangeThird],','查看','','/talentTypeChange/thirdDetail',3,3,0,NULL,1,NULL),(302,'talentcheckproperties','talentIdentify','[0],[talentIdentify],','主管部门审核配置','','/talentcheckproperties',5,2,1,NULL,1,NULL),(303,'talentcheckpropertiesAdd','talentcheckproperties','[0],[talentIdentify],[talentcheckproperties],','添加','','/talentcheckproperties/add',1,3,0,NULL,1,NULL),(304,'talentInfoGotoBefore','talentIdentify','[0],[talentIdentify],','部门初审','','/talentInfo/gotoIndex/-1',10,2,1,NULL,1,NULL),(305,'talentInfoBeforeCheck','talentInfoGotoBefore','[0],[talentIdentify],[talentInfoGotoBefore],','审核','','/talentInfo/beforeCheck',1,3,0,NULL,1,NULL),(307,'talentInfoPrepare','talentIdentify','[0],[talentIdentify],','预备人才库','','/talentInfo/gotoIndex/4',27,2,1,NULL,1,NULL),(308,'talentInfoPrepareHczx','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','核查征信','','/talentInfo/prepareHczx',1,3,0,NULL,1,NULL),(309,'talentInfohczxReject','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','征信失信','','/talentInfo/hczxReject',3,3,0,NULL,1,NULL),(312,'talentInfoprepareCheck','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公示再审核','','/talentInfo/prepareCheck',9,3,0,NULL,1,NULL),(314,'talentInfopublicPass','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公示通过','','/talentInfo/publicPass',11,3,0,NULL,1,NULL),(316,'talentInfopreparePublish','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公布','','/talentInfo/preparePublish',13,3,0,NULL,1,NULL),(318,'talentInfoprepareCertification','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','发证','','/talentInfo/prepareCertification',15,3,0,NULL,1,NULL),(320,'talentTypeChangegotoIndexBefore','talentTypeChangeMain','[0],[talentTypeChangeMain],','部门初审','','/talentTypeChange/gotoIndex/-1',1,2,1,NULL,1,NULL),(321,'talentTypeChangebeforeCheck','talentTypeChangegotoIndexBefore','[0],[talentTypeChangeMain],[talentTypeChangegotoIndexBefore],','审核','','/talentTypeChange/beforeCheck',1,3,0,NULL,1,NULL),(322,'talentTypeChangeprepareHczx','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','导出核查征信','','/talentTypeChange/prepareHczx',1,3,0,NULL,1,NULL),(323,'talentTypeChangehczxReject','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','征信失信','','/talentTypeChange/hczxReject',2,3,0,NULL,1,NULL),(324,'talentTypeChangepreparePublic','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','公示','','/talentTypeChange/preparePublic',3,3,0,NULL,1,NULL),(325,'talentTypeChangepreparePublicExport','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','公示导出','','/talentTypeChange/preparePublicExport',4,3,0,NULL,1,NULL),(326,'talentTypeChangeprepareCheck','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','公示再审核','','/talentTypeChange/prepareCheck',5,3,0,NULL,1,NULL),(327,'talentTypeChangepublicPass','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','公示通过','','/talentTypeChange/publicPass',6,3,0,NULL,1,NULL),(328,'talentTypeChangepreparePublish','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','公布','','/talentTypeChange/preparePublish',7,3,0,NULL,1,NULL),(329,'talentTypeChangeprepareCertification','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','发证','','/talentTypeChange/prepareCertification',8,3,0,NULL,1,NULL),(330,'talentTypeChangeprepareDetail','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','查看','','/talentTypeChange/prepareDetail',9,3,0,NULL,1,NULL),(331,'talentInfolibraryExport','talentInfo_library','[0],[talentLibrary],[talentInfo_library],','导出','','/talentInfo/libraryExport',1,3,0,NULL,1,NULL),(333,'enterprisechangeRecordexcelExport','gotoEnterpriseChangeRecordPage','[0],[enterpriseAdmin],[gotoEnterpriseChangeRecordPage],','导出','','/enterprisechangeRecord/excelExport',3,3,0,NULL,1,NULL),(334,'talentInfohczxPass','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','征信通过','','/talentInfo/hczxPass',4,3,0,NULL,1,NULL),(336,'identifyConditionimport','identifyCondition','[0],[talentIdentify],[identifyCondition],','导入','','/identifyCondition/import',5,3,0,NULL,1,NULL),(337,'identifyConditionimportTemplate','identifyCondition','[0],[talentIdentify],[identifyCondition],','模板下载','','/identifyCondition/importTemplate',4,3,0,NULL,1,NULL),(338,'schedule','system','[0],[system],','定时任务','','/schedule',15,2,1,NULL,1,NULL),(339,'scheduleadd','schedule','[0],[system],[schedule],','添加','','/schedule/add',1,3,0,NULL,1,NULL),(340,'scheduleupdate','schedule','[0],[system],[schedule],','修改','','/schedule/update',2,3,0,NULL,1,NULL),(341,'scheduledelete','schedule','[0],[system],[schedule],','删除','','/schedule/delete',4,3,0,NULL,1,NULL),(342,'talentTypeChangehczxPass','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','征信通过','','/talentTypeChange/hczxPass',3,3,0,NULL,1,NULL),(343,'messageRecord','system','[0],[system],','短信日志','','/messageRecord',50,2,1,NULL,1,NULL),(346,'amountStandard','system','[0],[system],','人才津贴配置','','/amountStandard',20,2,1,NULL,1,NULL),(347,'amountStandardadd','amountStandard','[0],[system],[amountStandard],','添加','','/amountStandard/add',1,3,0,NULL,1,NULL),(348,'amountStandardupdate','amountStandard','[0],[system],[amountStandard],','修改','','/amountStandard/update',2,3,0,NULL,1,NULL),(349,'amountStandarddelete','amountStandard','[0],[system],[amountStandard],','删除','','/amountStandard/delete',3,3,0,NULL,1,NULL),(350,'talentAllowance','0','[0],','津补贴管理','fa-money','#',9,1,1,NULL,1,NULL),(351,'talentAllowanceInfoFirst','talentAllowance','[0],[talentAllowance],','初级审核','','/talentAllowanceInfo/index/1',1,2,1,NULL,1,NULL),(352,'talentAllowanceInfoVisit','talentAllowance','[0],[talentAllowance],','走访核查','','/talentAllowanceInfo/index/2',2,2,1,NULL,1,NULL),(353,'talentAllowanceInfoReview','talentAllowance','[0],[talentAllowance],','复核','','/talentAllowanceInfo/index/3',3,2,1,NULL,1,NULL),(354,'talentAllowancefirstCheck','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','审核','','/talentAllowance/firstCheck',1,3,0,NULL,1,NULL),(355,'talentAllowancevisitCheck','talentAllowanceInfoVisit','[0],[talentAllowance],[talentAllowanceInfoVisit],','审核','','/talentAllowance/visitCheck',1,3,0,NULL,1,NULL),(356,'talentAllowancereviewCheck','talentAllowanceInfoReview','[0],[talentAllowance],[talentAllowanceInfoReview],','审核','','/talentAllowance/reviewCheck',1,3,0,NULL,1,NULL),(357,'talentAllowancefirstExport','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','导出基础信息','','/talentAllowance/firstExport',2,3,0,NULL,1,NULL),(358,'talentAllowancevisitExport','talentAllowanceInfoVisit','[0],[talentAllowance],[talentAllowanceInfoVisit],','导出基础信息','','/talentAllowance/visitExport',2,3,0,NULL,1,NULL),(359,'talentAllowancereviewExport','talentAllowanceInfoReview','[0],[talentAllowance],[talentAllowanceInfoReview],','导出基础信息','','/talentAllowance/reviewExport',2,3,0,NULL,1,NULL),(360,'talentAllowancefirstExportProject','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','导出项目录入模板','','/talentAllowance/firstExportProject',3,3,0,NULL,1,NULL),(361,'talentAllowancevisitExportProject','talentAllowanceInfoVisit','[0],[talentAllowance],[talentAllowanceInfoVisit],','导出项目录入模板','','/talentAllowance/visitExportProject',3,3,0,NULL,1,NULL),(362,'talentAllowancefirstImportProject','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','导入项目核查结果','','/talentAllowance/firstImportProject',3,3,0,NULL,1,NULL),(363,'talentAllowancevisitImportProject','talentAllowanceInfoVisit','[0],[talentAllowance],[talentAllowanceInfoVisit],','导入项目核查结果','','/talentAllowance/visitImportProject',4,3,0,NULL,1,NULL),(364,'unCommonFiletypedelete','unCommonFiletype','[0],[fileType],[unCommonFiletype],','删除','','/unCommonFiletype/delete',3,3,0,NULL,1,NULL),(365,'enterprisetypeProperties','system','[0],[system],','企业标签配置','','/enterprisetypeProperties',20,2,1,NULL,1,NULL),(366,'enterprisetypePropertiesadd','enterprisetypeProperties','[0],[system],[enterprisetypeProperties],','添加','','/enterprisetypeProperties/add',1,3,0,NULL,1,NULL),(367,'enterprisetypePropertiesupdate','enterprisetypeProperties','[0],[system],[enterprisetypeProperties],','修改','','/enterprisetypeProperties/update',2,3,0,NULL,1,NULL),(368,'enterprisetypePropertiesdelete','enterprisetypeProperties','[0],[system],[enterprisetypeProperties],','删除','','/enterprisetypeProperties/delete',3,3,0,NULL,1,NULL),(369,'talentAllowanceInfoPrepare','talentAllowance','[0],[talentAllowance],','预备津贴库','','/talentAllowanceInfo/index/4',4,2,1,NULL,1,NULL),(370,'talentAllowanceprepareHczx','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','导出核查征信','','/talentAllowance/prepareHczx',1,3,0,NULL,1,NULL),(371,'talentAllowancehczxReject','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','征信失信','','/talentAllowance/hczxReject',2,3,0,NULL,1,NULL),(372,'talentAllowancehczxPass','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','征信通过','','/talentAllowance/hczxPass',3,3,0,NULL,1,NULL),(373,'talentAllowancepreparePublic','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','公示& #40;兑现& #41;','','/talentAllowance/preparePublic',4,3,0,NULL,1,NULL),(374,'talentAllowanceprepareCheck','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','公示再审核','','/talentAllowance/prepareCheck',5,3,0,NULL,1,NULL),(375,'talentAllowancepublicPass','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','公示通过','','/talentAllowance/publicPass',6,3,0,NULL,1,NULL),(376,'talentAllowanceprepareSelect','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','查看','','/talentAllowance/prepareSelect',7,3,0,NULL,1,NULL),(377,'talentAllowancepreparePublicNoCash','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','公示& #40;不予兑现& #41;','','/talentAllowance/preparePublicNoCash',4,3,0,NULL,1,NULL),(378,'talentAllowancecash','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','兑现','','/talentAllowance/cash',7,3,0,NULL,1,NULL),(379,'talentInfopreparePublishExport','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公布导出','','/talentInfo/preparePublishExport',6,3,0,NULL,1,NULL),(380,'talentTypeChangepreparePublishExport','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','公布导出','','/talentTypeChange/preparePublishExport',5,3,0,NULL,1,NULL),(381,'talentTypeChangeprepareCanclePublish','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','撤销公布','','/talentTypeChange/prepareCanclePublish',3,3,0,NULL,1,NULL),(382,'talentInfoprepareCanclePublish','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','撤销公布','','/talentInfo/prepareCanclePublish',3,3,0,NULL,1,NULL),(383,'talentInfolibraryCancle','talentInfo_library','[0],[talentLibrary],[talentInfo_library],','取消优秀人才','','/talentInfo/libraryCancle',1,3,0,NULL,1,NULL),(384,'talentInfobeforeExport','talentInfoGotoBefore','[0],[talentIdentify],[talentInfoGotoBefore],','导出','','/talentInfo/beforeExport',2,3,0,NULL,1,NULL),(385,'talentInfofirstExport','talentInfo_first','[0],[talentIdentify],[talentInfo_first],','导出','','/talentInfo/firstExport',2,3,0,NULL,1,NULL),(386,'talentInfodepExport','talentInfo_dep','[0],[talentIdentify],[talentInfo_dep],','导出','','/talentInfo/depExport',2,3,0,NULL,1,NULL),(387,'talentInfothirdExport','talentInfo_third','[0],[talentIdentify],[talentInfo_third],','导出','','/talentInfo/thirdExport',2,3,0,NULL,1,NULL),(388,'talentInfoprepareExport','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','导出','','/talentInfo/prepareExport',2,3,0,NULL,1,NULL),(389,'talentTypeChangebeforeExport','talentTypeChangegotoIndexBefore','[0],[talentTypeChangeMain],[talentTypeChangegotoIndexBefore],','导出','','/talentTypeChange/beforeExport',2,3,0,NULL,1,NULL),(390,'talentTypeChangebefirstExport','talentTypeChangeFirst','[0],[talentTypeChangeMain],[talentTypeChangeFirst],','导出','','/talentTypeChange/firstExport',2,3,0,NULL,1,NULL),(391,'talentTypeChangedepExport','talentTypeChangeDep','[0],[talentTypeChangeMain],[talentTypeChangeDep],','导出','','/talentTypeChange/depExport',2,3,0,NULL,1,NULL),(392,'talentTypeChangethirdExport','talentTypeChangeThird','[0],[talentTypeChangeMain],[talentTypeChangeThird],','导出','','/talentTypeChange/thirdExport',2,3,0,NULL,1,NULL),(393,'talentTypeChangeprepareExport','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','导出','','/talentTypeChange/prepareExport',2,3,0,NULL,1,NULL),(394,'talentChangequitExport','talentQuit','[0],[talentLibrary],[talentQuit],','导出','','/talentChange/quitExport',2,3,0,NULL,1,NULL),(395,'talentWorkunitChangeworkunitExport','talentWorkUnitChange','[0],[talentLibrary],[talentWorkUnitChange],','导出','','/talentWorkunitChange/workunitExport',2,3,0,NULL,1,NULL),(396,'talentBankChangebankExport','talentBankChange','[0],[talentLibrary],[talentBankChange],','导出','','/talentBankChange/bankExport',2,3,0,NULL,1,NULL),(397,'talentInfodownload','talentInfo_first','[0],[talentIdentify],[talentInfo_first],','下载','','/talentInfo/firstDownload',3,3,0,NULL,1,NULL),(398,'talentInfodepDownload','talentInfo_dep','[0],[talentIdentify],[talentInfo_dep],','下载','','/talentInfo/depDownload',3,3,0,NULL,1,NULL),(399,'talentInfobeforeDownload','talentInfoGotoBefore','[0],[talentIdentify],[talentInfoGotoBefore],','下载','','/talentInfo/beforeDownload',3,3,0,NULL,1,NULL),(400,'talentInfothirdDownload','talentInfo_third','[0],[talentIdentify],[talentInfo_third],','下载','','/talentInfo/thirdDownload',3,3,0,NULL,1,NULL),(401,'talentInfoprepareDownload','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','下载','','/talentInfo/prepareDownload',5,3,0,NULL,1,NULL),(402,'talentInfolibraryDownload','talentInfo_library','[0],[talentLibrary],[talentInfo_library],','下载','','/talentInfo/libraryDownload',3,3,0,NULL,1,NULL),(403,'talentChangequitDownload','talentQuit','[0],[talentLibrary],[talentQuit],','下载','','/talentChange/quitDownload',3,3,0,NULL,1,NULL),(404,'talentWorkunitChangeworkunitDownload','talentWorkUnitChange','[0],[talentLibrary],[talentWorkUnitChange],','下载','','/talentWorkunitChange/workunitDownload',3,3,0,NULL,1,NULL),(405,'talentTypeChangebeforeDownload','talentTypeChangegotoIndexBefore','[0],[talentTypeChangeMain],[talentTypeChangegotoIndexBefore],','下载','','/talentTypeChange/beforeDownload',2,3,0,NULL,1,NULL),(406,'talentTypeChangedepDownload','talentTypeChangeDep','[0],[talentTypeChangeMain],[talentTypeChangeDep],','下载','','/talentTypeChange/depDownload',2,3,0,NULL,1,NULL),(407,'talentTypeChangefirstDownload','talentTypeChangeFirst','[0],[talentTypeChangeMain],[talentTypeChangeFirst],','下载','','/talentTypeChange/firstDownload',2,3,0,NULL,1,NULL),(408,'talentTypeChangeprepareDownload','talentTypeChangePrepare','[0],[talentTypeChangeMain],[talentTypeChangePrepare],','下载','','/talentTypeChange/prepareDownload',2,3,0,NULL,1,NULL),(409,'talentTypeChangethirdDownload','talentTypeChangeThird','[0],[talentTypeChangeMain],[talentTypeChangeThird],','下载','','/talentTypeChange/thirdDownload',2,3,0,NULL,1,NULL),(410,'talentInfolibraryRecovery','talentInfo_library','[0],[talentLibrary],[talentInfo_library],','恢复优秀人才','','/talentInfo/libraryRecovery',2,3,0,NULL,1,NULL),(411,'messageRecordSend','messageRecord','[0],[system],[messageRecord],','重新发送','fa-money','/messageRecord/send',1,3,0,NULL,1,NULL),(412,'feedBack','system','[0],[system],','用户反馈','','/api/feedBack/',101,2,1,NULL,1,NULL),(413,'data','0','[0],','统计分析','fa-pie-chart','#',30,1,1,NULL,1,NULL),(414,'dataAnalysisIndex','data','[0],[data],','数据统计','','/webIndex/index',1,2,1,NULL,1,NULL),(415,'talentInfoupdateFieldsAndFiles','talentInfo_first','[0],[talentIdentify],[talentInfo_first],','修改驳回字段','fa-edit','/talentInfo/updateFieldsAndFiles',4,3,0,NULL,1,NULL),(416,'messageRecordinsert','messageRecord','[0],[system],[messageRecord],','发送短信','fa-envelope','/messageRecord/insert',1,3,0,NULL,1,NULL),(417,'feedBackback','feedBack','[0],[system],[feedBack],','回复','fa-plus','/feedBack/back',1,3,0,NULL,1,NULL),(418,'education','0','[0],','子女就学','fa-graduation-cap','#',11,1,1,NULL,1,NULL),(419,'educationSchoolIndex','education','[0],[education],','子女择校','','/educationSchool/',1,2,1,NULL,1,NULL),(420,'educationSchooltoCheckPage','educationSchoolIndex','[0],[education],[educationSchoolIndex],','审核','','/educationSchool/toCheckPage',1,3,0,NULL,1,NULL),(421,'educationSchoolexport','educationSchoolIndex','[0],[education],[educationSchoolIndex],','导出','','/educationSchool/export',2,3,0,NULL,1,NULL),(422,'talentInfosetNotPass','talentInfo_first','[0],[talentIdentify],[talentInfo_first],','审核不通过','','/talentInfo/setNotPass',5,3,0,NULL,1,NULL),(423,'messageRecordexport','messageRecord','[0],[system],[messageRecord],','导出','','/messageRecord/export',3,3,0,NULL,1,NULL),(424,'talentAllowanceupdateFieldsAndFiles','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','修改驳回字段','','/talentAllowance/updateFieldsAndFiles',1,3,0,NULL,1,NULL),(425,'talentInfocancleThirdCheck','talentInfo_third','[0],[talentIdentify],[talentInfo_third],','撤销复核','','/talentInfo/cancleThirdCheck',1,3,0,NULL,1,NULL),(426,'talentAllowancefirstSbSubmit','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','批量提交审核(社保局)','','/talentAllowance/firstSbSubmit',1,3,0,NULL,1,NULL),(427,'talentAllowanceexportSbProject','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','导出社保核查结果','','/talentAllowance/exportSbProject',1,3,0,NULL,1,NULL),(428,'talentAllowancefirstExportProjectData','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','导出项目核查结果','','/talentAllowance/firstExportProjectData',1,3,0,NULL,1,NULL),(429,'talentAllowancefirstSelect','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','查看','','/talentAllowance/firstSelect',1,3,0,NULL,1,NULL),(430,'talentAllowancevisitSbSubmit','talentAllowanceInfoVisit','[0],[talentAllowance],[talentAllowanceInfoVisit],','批量提交审核','','/talentAllowance/visitSbSubmit',1,3,0,NULL,1,NULL),(431,'talentAllowancevisitExportProjectData','talentAllowanceInfoVisit','[0],[talentAllowance],[talentAllowanceInfoVisit],','导出项目核查结果','','/talentAllowance/visitExportProjectData',1,3,0,NULL,1,NULL),(432,'talentAllowancevisitSelect','talentAllowanceInfoVisit','[0],[talentAllowance],[talentAllowanceInfoVisit],','查看','','/talentAllowance/visitSelect',1,3,0,NULL,1,NULL),(433,'talentAllowancereviewExportProjectData','talentAllowanceInfoReview','[0],[talentAllowance],[talentAllowanceInfoReview],','导出项目核查结果','','/talentAllowance/reviewExportProjectData',1,3,0,NULL,1,NULL),(434,'talentAllowancereviewSelect','talentAllowanceInfoReview','[0],[talentAllowance],[talentAllowanceInfoReview],','查看','','/talentAllowance/reviewSelect',1,3,0,NULL,1,NULL),(435,'talentAllowanceprepareExport','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','导出基础信息','','/talentAllowance/prepareExport',1,3,0,NULL,1,NULL),(436,'talentAllowanceprepareExportProjectData','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','导出项目核查结果','','/talentAllowance/prepareExportProjectData',1,3,0,NULL,1,NULL),(437,'housepurchase','0','[0],','购房补贴','fa-home','#',10,1,1,NULL,1,NULL),(438,'housepurchaseCheck','housepurchase','[0],[housepurchase],','初级审核','','/housepurchase/1',1,2,1,NULL,1,NULL),(439,'housepurchaseDep','housepurchase','[0],[housepurchase],','部门审核','','/housepurchase/2',2,2,1,NULL,1,NULL),(440,'housepurchasePublic','housepurchase','[0],[housepurchase],','公示兑现','','/housepurchase/4',4,2,1,NULL,1,NULL),(441,'housepurchasefirstCheck','housepurchaseCheck','[0],[housepurchase],[housepurchaseCheck],','审核','','/housepurchase/firstCheck',1,3,0,NULL,1,NULL),(442,'housepurchasefirstExport','housepurchaseCheck','[0],[housepurchase],[housepurchaseCheck],','导出','','/housepurchase/firstExport',2,3,0,NULL,1,NULL),(443,'housepurchasedepCheck','housepurchaseDep','[0],[housepurchase],[housepurchaseDep],','审核','','/housepurchase/depCheck',1,3,0,NULL,1,NULL),(444,'housepurchasedepExport','housepurchaseDep','[0],[housepurchase],[housepurchaseDep],','导出','','/housepurchase/depExport',2,3,0,NULL,1,NULL),(445,'housepurchasepublicCheckNeedCash','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','公示(兑现)','','/housepurchase/publicCheckNeedCash',1,3,0,NULL,1,NULL),(446,'housepurchasepublicAfterCheck','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','公示再审核','','/housepurchase/publicAfterCheck',2,3,0,NULL,1,NULL),(447,'housepurchasepublicPass','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','公示通过','','/housepurchase/publicPass',3,3,0,NULL,1,NULL),(448,'housepurchasecash','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','兑现','','/housepurchase/cash',4,3,0,NULL,1,NULL),(449,'housepurchasepublicExport','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','导出','','/housepurchase/publicExport',5,3,0,NULL,1,NULL),(450,'housepurchasepublicDetail','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','查看','','/housepurchase/publicDetail',7,3,0,NULL,1,NULL),(451,'housepurchaseThird','housepurchase','[0],[housepurchase],','复核','','/housepurchase/3',3,2,1,NULL,1,NULL),(452,'housepurchasereviewCheck','housepurchaseThird','[0],[housepurchase],[housepurchaseThird],','审核','','/housepurchase/reviewCheck',1,3,0,NULL,1,NULL),(453,'housepurchasereviewExport','housepurchaseThird','[0],[housepurchase],[housepurchaseThird],','导出','','/housepurchase/reviewExport',2,3,0,NULL,1,NULL),(454,'visitGroup','system','[0],[system],','走访小组配置','','/visitGroup/',15,2,1,NULL,1,NULL),(455,'visitGroupadd','visitGroup','[0],[system],[visitGroup],','新增','','/visitGroup/add',1,3,0,NULL,1,NULL),(456,'visitGroupupdate','visitGroup','[0],[system],[visitGroup],','修改','','/visitGroup/update',2,3,0,NULL,1,NULL),(457,'visitGroupdelete','visitGroup','[0],[system],[visitGroup],','删除','','/visitGroup/delete',3,3,0,NULL,1,NULL),(458,'talentAllowancereviewCancleCheck','talentAllowanceInfoReview','[0],[talentAllowance],[talentAllowanceInfoReview],','撤销审核','','/talentAllowance/reviewCancleCheck',2,3,0,NULL,1,NULL),(459,'housepurchasepublicCheckNotNeedCash','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','公示(不予兑现)','','/housepurchase/publicCheckNotNeedCash',2,3,0,NULL,1,NULL),(460,'training','0','[0],','培训补贴','fa-gg-circle','#',12,1,1,NULL,1,NULL),(461,'trainingSubsidy','training','[0],[training],','培训补贴','','/trainingSubsidy/',1,2,1,NULL,1,NULL),(462,'trainingSubsidycheck','trainingSubsidy','[0],[training],[trainingSubsidy],','审核','','/trainingSubsidy/check',1,3,0,NULL,1,NULL),(463,'trainingSubsidyexport','trainingSubsidy','[0],[training],[trainingSubsidy],','导出','','/trainingSubsidy/export',2,3,0,NULL,1,NULL),(464,'trainingSubsidypublic','trainingSubsidy','[0],[training],[trainingSubsidy],','公示','','/trainingSubsidy/public',3,3,0,NULL,1,NULL),(465,'trainingSubsidyafterCheck','trainingSubsidy','[0],[training],[trainingSubsidy],','公示再审核','','/trainingSubsidy/afterCheck',4,3,0,NULL,1,NULL),(466,'trainingSubsidypublicPass','trainingSubsidy','[0],[training],[trainingSubsidy],','公示通过','','/trainingSubsidy/publicPass',5,3,0,NULL,1,NULL),(467,'trainingSubsidycash','trainingSubsidy','[0],[training],[trainingSubsidy],','兑现','','/trainingSubsidy/cash',6,3,0,NULL,1,NULL),(468,'talentInfopublicExportBefore','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公示预览','','/talentInfo/publicExportBefore',1,3,0,NULL,1,NULL),(469,'talentInfopublishExportBefore','talentInfoPrepare','[0],[talentIdentify],[talentInfoPrepare],','公布预览','','/talentInfo/publishExportBefore',1,3,0,NULL,1,NULL),(470,'childschoolFees','education','[0],[education],','学杂费补助','','/childschoolFees/',2,2,1,NULL,1,NULL),(471,'childschoolFeescheck','childschoolFees','[0],[education],[childschoolFees],','审核','','/childschoolFees/check',1,3,0,NULL,1,NULL),(472,'childschoolFeesexport','childschoolFees','[0],[education],[childschoolFees],','导出','','/childschoolFees/export',2,3,0,NULL,1,NULL),(473,'childschoolFeespublicExportBefore','childschoolFees','[0],[education],[childschoolFees],','公示预览','','/childschoolFees/publicExportBefore',2,3,0,NULL,1,NULL),(474,'childschoolFeespublic','childschoolFees','[0],[education],[childschoolFees],','公示','','/childschoolFees/public',3,3,0,NULL,1,NULL),(475,'childschoolFeesafterCheck','childschoolFees','[0],[education],[childschoolFees],','公示再审核','','/childschoolFees/afterCheck',4,3,0,NULL,1,NULL),(476,'childschoolFeespublicPass','childschoolFees','[0],[education],[childschoolFees],','公示通过','','/childschoolFees/publicPass',5,3,0,NULL,1,NULL),(477,'childschoolFeescash','childschoolFees','[0],[education],[childschoolFees],','兑现','','/childschoolFees/cash',6,3,0,NULL,1,NULL),(478,'medical','0','[0],','医疗补助','fa-hospital-o','#',13,1,1,NULL,1,NULL),(479,'medicalSubsidy','medical','[0],[medical],','医疗补助','','/medicalSubsidy/',1,2,1,NULL,1,NULL),(480,'medicalSubsidycheck','medicalSubsidy','[0],[medical],[medicalSubsidy],','审核','','/medicalSubsidy/check',1,3,0,NULL,1,NULL),(481,'medicalSubsidypublicExportBefore','medicalSubsidy','[0],[medical],[medicalSubsidy],','公式预览','','/medicalSubsidy/publicExportBefore',2,3,0,NULL,1,NULL),(482,'medicalSubsidypublic','medicalSubsidy','[0],[medical],[medicalSubsidy],','公示','','/medicalSubsidy/public',3,3,0,NULL,1,NULL),(483,'medicalSubsidyafterCheck','medicalSubsidy','[0],[medical],[medicalSubsidy],','公示再审核','','/medicalSubsidy/afterCheck',4,3,0,NULL,1,NULL),(484,'medicalSubsidypublicPass','medicalSubsidy','[0],[medical],[medicalSubsidy],','公示通过','','/medicalSubsidy/publicPass',5,3,0,NULL,1,NULL),(485,'medicalSubsidycash','medicalSubsidy','[0],[medical],[medicalSubsidy],','兑现','','/medicalSubsidy/cash',6,3,0,NULL,1,NULL),(486,'medicalSubsidyexport','medicalSubsidy','[0],[medical],[medicalSubsidy],','导出','','/medicalSubsidy/export',7,3,0,NULL,1,NULL),(487,'houseRenting','0','[0],','租房申请','fa-home','#',15,1,1,NULL,1,NULL),(488,'houseRentingIndex','houseRenting','[0],[houseRenting],','初级审核','','/houseRenting/index/1',1,2,1,NULL,1,NULL),(489,'houseRentingDep','houseRenting','[0],[houseRenting],','部门审核','','/houseRenting/index/2',2,2,1,NULL,1,NULL),(490,'houseRentingThird','houseRenting','[0],[houseRenting],','复核','','/houseRenting/index/3',3,2,1,NULL,1,NULL),(491,'houseRentingfirstCheck','houseRentingIndex','[0],[houseRenting],[houseRentingIndex],','审核','','/houseRenting/firstCheck',1,3,0,NULL,1,NULL),(492,'houseRentingfirstExport','houseRentingIndex','[0],[houseRenting],[houseRentingIndex],','导出','','/houseRenting/firstExport',2,3,0,NULL,1,NULL),(493,'houseRentingdepCheck','houseRentingDep','[0],[houseRenting],[houseRentingDep],','审核','','/houseRenting/depCheck',1,3,0,NULL,1,NULL),(494,'houseRentingdepExport','houseRentingDep','[0],[houseRenting],[houseRentingDep],','导出','','/houseRenting/depExport',2,3,0,NULL,1,NULL),(495,'houseRentingthirdCheck','houseRentingThird','[0],[houseRenting],[houseRentingThird],','审核','','/houseRenting/thirdCheck',1,3,0,NULL,1,NULL),(496,'houseRentingthirdExport','houseRentingThird','[0],[houseRenting],[houseRentingThird],','导出','','/houseRenting/thirdExport',2,3,0,NULL,1,NULL),(497,'houseRentingindex4','houseRenting','[0],[houseRenting],','入住登记','','/houseRenting/index/4',4,2,1,NULL,1,NULL),(498,'houseRentingregist','houseRentingindex4','[0],[houseRenting],[houseRentingindex4],','登记','','/houseRenting/regist',1,3,0,NULL,1,NULL),(499,'housepurchasepublicExportBefore','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','公示预览(兑现)','','/housepurchase/publicExportBefore',1,3,0,NULL,1,NULL),(500,'housepurchasepublicExportBeforeNoCash','housepurchasePublic','[0],[housepurchase],[housepurchasePublic],','公示预览(不予兑现)','','/housepurchase/publicExportBeforeNoCash',1,3,0,NULL,1,NULL),(501,'houseRentingFees','0','[0],','房租补助','fa-money','#',17,1,1,NULL,1,NULL),(502,'houseRentingFeesMenu','houseRentingFees','[0],[houseRentingFees],','房租补助','','/houseRentingFees/',1,2,1,NULL,1,NULL),(503,'houseRentingFeescheck','houseRentingFeesMenu','[0],[houseRentingFees],[houseRentingFeesMenu],','审核','','/houseRentingFees/check',1,3,0,NULL,1,NULL),(504,'houseRentingFeespublicExportBefore','houseRentingFeesMenu','[0],[houseRentingFees],[houseRentingFeesMenu],','公示预览','','/houseRentingFees/publicExportBefore',2,3,0,NULL,1,NULL),(505,'houseRentingFeespublic','houseRentingFeesMenu','[0],[houseRentingFees],[houseRentingFeesMenu],','公示','','/houseRentingFees/public',1,3,0,NULL,1,NULL),(506,'houseRentingFeesafterCheck','houseRentingFeesMenu','[0],[houseRentingFees],[houseRentingFeesMenu],','公示再审核','','/houseRentingFees/afterCheck',1,3,0,NULL,1,NULL),(507,'houseRentingFeespublicPass','houseRentingFeesMenu','[0],[houseRentingFees],[houseRentingFeesMenu],','公示通过','','/houseRentingFees/publicPass',1,3,0,NULL,1,NULL),(508,'houseRentingFeescash','houseRentingFeesMenu','[0],[houseRentingFees],[houseRentingFeesMenu],','兑现','','/houseRentingFees/cash',1,3,0,NULL,1,NULL),(509,'houseRentingFeesexport','houseRentingFeesMenu','[0],[houseRentingFees],[houseRentingFeesMenu],','导出','','/houseRentingFees/export',1,3,0,NULL,1,NULL),(510,'houserRentingPurchaseApply','0','[0],','购房申请','fa-empire','#',21,1,1,NULL,1,NULL),(511,'houserRentingPurchaseApplyindex1','houserRentingPurchaseApply','[0],[houserRentingPurchaseApply],','初级审核','','/houserRentingPurchaseApply/index/1',1,2,1,NULL,1,NULL),(512,'houserRentingPurchaseApplyindex2','houserRentingPurchaseApply','[0],[houserRentingPurchaseApply],','部门审核','','/houserRentingPurchaseApply/index/2',2,2,1,NULL,1,NULL),(513,'houserRentingPurchaseApplyindex3','houserRentingPurchaseApply','[0],[houserRentingPurchaseApply],','复核','','/houserRentingPurchaseApply/index/3',3,2,1,NULL,1,NULL),(514,'houserRentingPurchaseApplyfirstCheck','houserRentingPurchaseApplyindex1','[0],[houserRentingPurchaseApply],[houserRentingPurchaseApplyindex1],','审核','','/houserRentingPurchaseApply/firstCheck',1,3,0,NULL,1,NULL),(515,'houserRentingPurchaseApplyfirstExport','houserRentingPurchaseApplyindex1','[0],[houserRentingPurchaseApply],[houserRentingPurchaseApplyindex1],','导出','','/houserRentingPurchaseApply/firstExport',2,3,0,NULL,1,NULL),(516,'houserRentingPurchaseApplydepCheck','houserRentingPurchaseApplyindex2','[0],[houserRentingPurchaseApply],[houserRentingPurchaseApplyindex2],','审核','','/houserRentingPurchaseApply/depCheck',1,3,0,NULL,1,NULL),(517,'houserRentingPurchaseApplydepExport','houserRentingPurchaseApplyindex2','[0],[houserRentingPurchaseApply],[houserRentingPurchaseApplyindex2],','导出','','/houserRentingPurchaseApply/depExport',2,3,0,NULL,1,NULL),(518,'houserRentingPurchaseApplythirdCheck','houserRentingPurchaseApplyindex3','[0],[houserRentingPurchaseApply],[houserRentingPurchaseApplyindex3],','审核','','/houserRentingPurchaseApply/thirdCheck',1,3,0,NULL,1,NULL),(519,'houserRentingPurchaseApplythirdExport','houserRentingPurchaseApplyindex3','[0],[houserRentingPurchaseApply],[houserRentingPurchaseApplyindex3],','导出','','/houserRentingPurchaseApply/thirdExport',2,3,0,NULL,1,NULL),(520,'houserRentingPurchaseFees','0','[0],','购房补助','fa-building','#',22,1,1,NULL,1,NULL),(521,'houseRentingPurchaseFeesIndex','houserRentingPurchaseFees','[0],[houserRentingPurchaseFees],','购房补助','','/houseRentingPurchaseFees/',1,2,1,NULL,1,NULL),(522,'houseRentingPurchaseFeescheck','houseRentingPurchaseFeesIndex','[0],[houserRentingPurchaseFees],[houseRentingPurchaseFeesIndex],','审核','','/houseRentingPurchaseFees/check',1,3,0,NULL,1,NULL),(523,'houseRentingPurchaseFeespublicExportBefore','houseRentingPurchaseFeesIndex','[0],[houserRentingPurchaseFees],[houseRentingPurchaseFeesIndex],','公示预览','','/houseRentingPurchaseFees/publicExportBefore',2,3,0,NULL,1,NULL),(524,'houseRentingPurchaseFeespublic','houseRentingPurchaseFeesIndex','[0],[houserRentingPurchaseFees],[houseRentingPurchaseFeesIndex],','公示','','/houseRentingPurchaseFees/public',3,3,0,NULL,1,NULL),(525,'houseRentingPurchaseFeesafterCheck','houseRentingPurchaseFeesIndex','[0],[houserRentingPurchaseFees],[houseRentingPurchaseFeesIndex],','公示再审核','','/houseRentingPurchaseFees/afterCheck',4,3,0,NULL,1,NULL),(526,'houseRentingPurchaseFeespublicPass','houseRentingPurchaseFeesIndex','[0],[houserRentingPurchaseFees],[houseRentingPurchaseFeesIndex],','公示通过','','/houseRentingPurchaseFees/publicPass',5,3,0,NULL,1,NULL),(527,'houseRentingPurchaseFeescash','houseRentingPurchaseFeesIndex','[0],[houserRentingPurchaseFees],[houseRentingPurchaseFeesIndex],','兑现','','/houseRentingPurchaseFees/cash',6,3,0,NULL,1,NULL),(528,'houseRentingPurchaseFeesexport','houseRentingPurchaseFeesIndex','[0],[houserRentingPurchaseFees],[houseRentingPurchaseFeesIndex],','导出','','/houseRentingPurchaseFees/export',7,3,0,NULL,1,NULL),(529,'commonFile','system','[0],[system],','附件管理','','/commonFile/',30,2,1,NULL,1,NULL),(530,'talentAllowancepublicExportBeforeNoCash','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','公示预览(不予兑现)','','/talentAllowance/publicExportBeforeNoCash',1,3,0,NULL,1,NULL),(531,'talentAllowancepublicExportBefore','talentAllowanceInfoPrepare','[0],[talentAllowance],[talentAllowanceInfoPrepare],','公示预览(兑现)','','/talentAllowance/publicExportBefore',1,3,0,NULL,1,NULL),(532,'talentTypeChangeupdateFieldsAndFiles','talentTypeChangeFirst','[0],[talentTypeChangeMain],[talentTypeChangeFirst],','修改驳回字段','','/talentTypeChange/updateFieldsAndFiles',2,3,0,NULL,1,NULL),(533,'talentBasicChange','talentLibrary','[0],[talentLibrary],','基础信息变更','','/talentBasicChange',5,2,1,NULL,1,NULL),(534,'talentBasicChangecheck','talentBasicChange','[0],[talentLibrary],[talentBasicChange],','审核','','/talentBasicChange/check',1,3,0,NULL,1,NULL),(535,'talentBasicChangeexport','talentBasicChange','[0],[talentLibrary],[talentBasicChange],','导出','','/talentBasicChange/export',2,3,0,NULL,1,NULL),(536,'talentInfoselectFirstInfo','talentInfo_library','[0],[talentLibrary],[talentInfo_library],','查看首次申报信息','','/talentInfo/selectFirstInfo',2,3,0,NULL,1,NULL),(537,'housepurchaseeditRejctFields','housepurchaseCheck','[0],[housepurchase],[housepurchaseCheck],','修改驳回字段','','/housepurchase/editRejctFields',3,3,0,NULL,1,NULL),(538,'talentAllowancefirstCancleCheck','talentAllowanceInfoFirst','[0],[talentAllowance],[talentAllowanceInfoFirst],','撤销初审','','/talentAllowance/firstCancleCheck',2,3,0,NULL,1,NULL),(539,'trainingSubsidycancle','trainingSubsidy','[0],[training],[trainingSubsidy],','撤回审核','','/trainingSubsidy/cancle',2,3,0,NULL,1,NULL),(540,'talentAllowancerepair','talentAllowanceInfoReview','[0],[talentAllowance],[talentAllowanceInfoReview],','修复','','/talentAllowance/repair',1,3,0,NULL,1,NULL),(541,'sbrc','0','[0],','硕博人才管理','fa-graduation-cap','#',25,1,1,NULL,1,NULL),(542,'livingAllowanceInfo3','sbrc','[0],[sbrc],','生活补贴复核','','/livingAllowanceInfo?process=3',2,2,1,NULL,1,NULL),(543,'livingAllowanceInfofristCheck','livingAllowanceInfo','[0],[sbrc],[livingAllowanceInfo],','审核','','/livingAllowanceInfo/firstCheck',1,3,0,NULL,1,NULL),(544,'livingAllowanceInfo1','sbrc','[0],[sbrc],','生活补贴初审','','/livingAllowanceInfo?process=1',1,2,1,NULL,1,NULL),(545,'livingAllowanceInfofirstCheck','livingAllowanceInfo1','[0],[sbrc],[livingAllowanceInfo1],','审核','','/livingAllowanceInfo/firstCheck',1,3,0,NULL,1,NULL),(546,'livingAllowanceInfothirdCheck','livingAllowanceInfo3','[0],[sbrc],[livingAllowanceInfo3],','审核','','/livingAllowanceInfo/thirdCheck',1,3,0,NULL,1,NULL),(547,'livingAllowanceInfo4','sbrc','[0],[sbrc],','生活补贴兑现','','/livingAllowanceInfo?process=4',3,2,1,NULL,1,NULL),(548,'livingAllowanceInfoprepareHczx','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','导出核查征信','','/livingAllowanceInfo/prepareHczx',1,3,0,NULL,1,NULL),(549,'livingAllowanceInfohczxReject','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','征信失信','','/livingAllowanceInfo/hczxReject',2,3,0,NULL,1,NULL),(550,'livingAllowanceInfohczxPass','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','征信通过','','/livingAllowanceInfo/hczxPass',3,3,0,NULL,1,NULL),(551,'livingAllowanceInfopreparePublic','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','公示','','/livingAllowanceInfo/preparePublic',4,3,0,NULL,1,NULL),(552,'livingAllowanceInfopreparePublicExport','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','公示导出','','/livingAllowanceInfo/preparePublicExport',5,3,0,NULL,1,NULL),(553,'livingAllowanceInfopublicExportBefore','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','公示预览','','/livingAllowanceInfo/publicExportBefore',1,3,0,NULL,1,NULL),(554,'livingAllowanceInfoprepareCheck','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','公示再审核','','/livingAllowanceInfo/prepareCheck',1,3,0,NULL,1,NULL),(555,'livingAllowanceInfopublicPass','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','公示通过','','/livingAllowanceInfo/publicPass',1,3,0,NULL,1,NULL),(556,'livingAllowanceInfoissue','livingAllowanceInfo4','[0],[sbrc],[livingAllowanceInfo4],','发放','','/livingAllowanceInfo/issue',1,3,0,NULL,1,NULL),(557,'livingAllowanceInfoexport','livingAllowanceInfo3','[0],[sbrc],[livingAllowanceInfo3],','导出','','/livingAllowanceInfo/export',1,3,0,NULL,1,NULL);
/*!40000 ALTER TABLE `sys_menu` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_message_record`
--

DROP TABLE IF EXISTS `sys_message_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_message_record` (
  `id` varchar(40) NOT NULL COMMENT 'id',
  `userId` varchar(40) DEFAULT NULL COMMENT '用户id',
  `bizId` varchar(50) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '短信类别',
  `smsType` tinyint(1) DEFAULT NULL,
  `name` varchar(255) DEFAULT NULL COMMENT '用户姓名',
  `phone` text DEFAULT NULL COMMENT '手机号码',
  `params` text DEFAULT NULL COMMENT '发送参数',
  `templateCode` varchar(500) DEFAULT NULL COMMENT '短信模板',
  `state` tinyint(1) DEFAULT NULL COMMENT '返回状态',
  `msg` varchar(255) DEFAULT NULL COMMENT '发送说明',
  `sendingDate` varchar(255) DEFAULT NULL COMMENT '发送时间',
  `content` varchar(255) DEFAULT NULL,
  `sendNum` int(1) DEFAULT NULL COMMENT '发送次数',
  `description` varchar(255) DEFAULT NULL COMMENT '说明',
  `createTime` varchar(40) DEFAULT NULL,
  `createUser` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='短信发送记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_message_record`
--

LOCK TABLES `sys_message_record` WRITE;
/*!40000 ALTER TABLE `sys_message_record` DISABLE KEYS */;
INSERT INTO `sys_message_record` VALUES ('1210539249770803201',NULL,NULL,2,1,NULL,'17362523273','667304','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2019-12-27',NULL,NULL,NULL,'2019-12-27 20:33:42',NULL,NULL,NULL),('1210539842564370433','1210539645922816002',NULL,2,2,'江苏艾克斯科技有限公司','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2019-12-27',NULL,NULL,NULL,'2019-12-27 20:36:03',NULL,NULL,NULL),('1210882255682121730',NULL,NULL,2,1,NULL,'13255957226','493848','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2019-12-28',NULL,NULL,NULL,'2019-12-28 19:16:41',NULL,NULL,NULL),('1210882849503293442',NULL,NULL,2,1,NULL,'18859987377','793597','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2019-12-28',NULL,NULL,NULL,'2019-12-28 19:19:03',NULL,NULL,NULL),('1210883830899126273',NULL,NULL,2,1,NULL,'13505044247','663505','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2019-12-28',NULL,NULL,NULL,'2019-12-28 19:22:57',NULL,NULL,NULL),('1210885623582404610',NULL,NULL,2,1,NULL,'13505044247','926356','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2019-12-28',NULL,NULL,NULL,'2019-12-28 19:30:04',NULL,NULL,NULL),('1210889378059104258',NULL,NULL,2,1,NULL,'18759439111','719152','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2019-12-28',NULL,NULL,NULL,'2019-12-28 19:44:59',NULL,NULL,NULL),('1210891251382071297',NULL,NULL,2,1,NULL,'18759439111','180297','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2019-12-28',NULL,NULL,NULL,'2019-12-28 19:52:26',NULL,NULL,NULL),('1210918527947616258',NULL,NULL,2,1,NULL,'18959705077','578543','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-28',NULL,NULL,NULL,'2019-12-28 21:40:49',NULL,NULL,NULL),('1210930721393324034',NULL,NULL,2,1,NULL,'13506086731','731778','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-28',NULL,NULL,NULL,'2019-12-28 22:29:16',NULL,NULL,NULL),('1210946356420653058',NULL,NULL,2,1,NULL,'13506055705','567615','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-28',NULL,NULL,NULL,'2019-12-28 23:31:24',NULL,NULL,NULL),('1210949621526933506',NULL,NULL,2,1,NULL,'13506055705','917860','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-28',NULL,NULL,NULL,'2019-12-28 23:44:22',NULL,NULL,NULL),('1210950245769392129',NULL,NULL,2,1,NULL,'13506055705','384654','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-28',NULL,NULL,NULL,'2019-12-28 23:46:51',NULL,NULL,NULL),('1210952746631540738',NULL,NULL,2,1,NULL,'13506055705','234283','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-28',NULL,NULL,NULL,'2019-12-28 23:56:47',NULL,NULL,NULL),('1211092208292311041',NULL,NULL,2,1,NULL,'15759732363','643441','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:10:58',NULL,NULL,NULL),('1211093284944982018',NULL,NULL,2,1,NULL,'13799553654','967028','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:15:14',NULL,NULL,NULL),('1211094010823815169',NULL,NULL,2,1,NULL,'13788825810','724227','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:18:07',NULL,NULL,NULL),('1211094407726608386',NULL,NULL,2,1,NULL,'13799553654','989481','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:19:42',NULL,NULL,NULL),('1211095484798709761',NULL,NULL,2,1,NULL,'13799487213','620004','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:23:59',NULL,NULL,NULL),('1211095975574220802',NULL,NULL,2,1,NULL,'15959596830','426424','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:25:56',NULL,NULL,NULL),('1211098407674949634',NULL,NULL,2,1,NULL,'13799487213','981258','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:35:36',NULL,NULL,NULL),('1211098959314006018',NULL,NULL,2,1,NULL,'15859799211','229067','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:37:47',NULL,NULL,NULL),('1211099201828663297',NULL,NULL,2,1,NULL,'15959596830','213167','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:38:45',NULL,NULL,NULL),('1211100197489324033',NULL,NULL,2,1,NULL,'15859799211','468361','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:42:42',NULL,NULL,NULL),('1211104258536091650',NULL,NULL,2,1,NULL,'13599496037','394380','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 09:58:51',NULL,NULL,NULL),('1211110245821165570',NULL,NULL,2,1,NULL,'18859969666','512003','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 10:22:38',NULL,NULL,NULL),('1211116729082687489',NULL,NULL,2,1,NULL,'15880936557','864863','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 10:48:24',NULL,NULL,NULL),('1211117059111497730',NULL,NULL,2,1,NULL,'15959596830','759535','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 10:49:43',NULL,NULL,NULL),('1211119934046842881',NULL,NULL,2,1,NULL,'13313825373','880701','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 11:01:08',NULL,NULL,NULL),('1211128127896530945',NULL,NULL,2,1,NULL,'18959847128','092761','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 11:33:42',NULL,NULL,NULL),('1211128362538479618',NULL,NULL,2,1,NULL,'13959957107','329653','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 11:34:37',NULL,NULL,NULL),('1211131310534406145',NULL,NULL,2,1,NULL,'18959847128','245597','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 11:46:20',NULL,NULL,NULL),('1211134134517346305',NULL,NULL,2,1,NULL,'13295959911','513583','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 11:57:34',NULL,NULL,NULL),('1211138197053091842',NULL,NULL,2,1,NULL,'18959858592','904683','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 12:13:42',NULL,NULL,NULL),('1211138848315256834',NULL,NULL,2,1,NULL,'18959847128','160189','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 12:16:17',NULL,NULL,NULL),('1211139056168185858',NULL,NULL,2,1,NULL,'18959858592','019147','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 12:17:07',NULL,NULL,NULL),('1211139499535478785',NULL,NULL,2,1,NULL,'13305967663','875430','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 12:18:53',NULL,NULL,NULL),('1211140791548882946',NULL,NULL,2,1,NULL,'13599250912','875588','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 12:24:01',NULL,NULL,NULL),('1211148880369004545',NULL,NULL,2,1,NULL,'18396220746','995844','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 12:56:09',NULL,NULL,NULL),('1211164193953263618',NULL,NULL,2,1,NULL,'18659597668','509820','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 13:57:00',NULL,NULL,NULL),('1211166011886252033',NULL,NULL,2,1,NULL,'18959210622','523427','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 14:04:14',NULL,NULL,NULL),('1211166750083756034',NULL,NULL,2,1,NULL,'13520554703','415749','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 14:07:10',NULL,NULL,NULL),('1211167872961851394',NULL,NULL,2,1,NULL,'18959210622','628864','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 14:11:37',NULL,NULL,NULL),('1211169597491884033',NULL,NULL,2,1,NULL,'13520554703','470450','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 14:18:29',NULL,NULL,NULL),('1211171015120498689',NULL,NULL,2,1,NULL,'13520554703','519820','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 14:24:07',NULL,NULL,NULL),('1211177035783843842',NULL,NULL,2,1,NULL,'15959556399','432252','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 14:48:02',NULL,NULL,NULL),('1211183158754652161',NULL,NULL,2,1,NULL,'15880720190','327722','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 15:12:22',NULL,NULL,NULL),('1211184538617753601',NULL,NULL,2,1,NULL,'15880720190','383929','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 15:17:51',NULL,NULL,NULL),('1211191022730719233',NULL,NULL,2,1,NULL,'13295959911','549475','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 15:43:37',NULL,NULL,NULL),('1211206971039002626',NULL,NULL,2,1,NULL,'18959847128','006386','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 16:46:59',NULL,NULL,NULL),('1211212770968711170',NULL,NULL,2,1,NULL,'18959847128','398939','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 17:10:02',NULL,NULL,NULL),('1211218866554908674',NULL,NULL,2,1,NULL,'14759154723','745642','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 17:34:15',NULL,NULL,NULL),('1211220932421595138',NULL,NULL,2,1,NULL,'18959847128','373496','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 17:42:28',NULL,NULL,NULL),('1211236067806654465',NULL,NULL,2,1,NULL,'15109613666','990305','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 18:42:36',NULL,NULL,NULL),('1211239544960167937',NULL,NULL,2,1,NULL,'15306089555','561609','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29',NULL,NULL,NULL,'2019-12-29 18:56:25',NULL,NULL,NULL),('1211439192010178561',NULL,NULL,2,1,NULL,'13799766670','133747','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:09:35',NULL,NULL,NULL),('1211439213812170754',NULL,NULL,2,1,NULL,'13799766670','995034','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:09:50',NULL,NULL,NULL),('1211441024119914498',NULL,NULL,2,1,NULL,'18859716647','507172','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:17:02',NULL,NULL,NULL),('1211442115960160258',NULL,NULL,2,1,NULL,'15102155779','626195','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:21:22',NULL,NULL,NULL),('1211443619932717058',NULL,NULL,2,1,NULL,'15102155779','589461','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:27:21',NULL,NULL,NULL),('1211443947352670210',NULL,NULL,2,1,NULL,'18559275265','481112','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:28:39',NULL,NULL,NULL),('1211444790638460930',NULL,NULL,2,1,NULL,'13799557721','464772','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:32:00',NULL,NULL,NULL),('1211445744079257602',NULL,NULL,2,1,NULL,'13625958406','596032','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:35:47',NULL,NULL,NULL),('1211447677405937665',NULL,NULL,2,1,NULL,'18959847128','438278','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:43:28',NULL,NULL,NULL),('1211449398328868865',NULL,NULL,2,1,NULL,'15980473561','537606','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:50:18',NULL,NULL,NULL),('1211450286271414274',NULL,NULL,2,1,NULL,'18859971221','054072','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:53:50',NULL,NULL,NULL),('1211451621498732545',NULL,NULL,2,1,NULL,'18159352255','480091','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 08:59:08',NULL,NULL,NULL),('1211451857159897089','64',NULL,1,2,'财政局','17362523273','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:05',NULL,NULL,NULL),('1211451878613762049','69',NULL,1,2,'陈文经','13599795023','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211451879091912705','72',NULL,1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211451879293239298','70',NULL,1,2,'陈瑞清','13788864979','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211451879486177281','71',NULL,1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211451879687503874','58',NULL,1,2,'张荣荣','15280619456','36,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211451879901413378','61',NULL,1,2,'叶志钦','17362523273','36,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211451880111128578','62',NULL,1,2,'林曼雅','17362523273','36,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211451880308260866','74',NULL,1,2,'叶志钦','13675957398','36,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:00:10',NULL,NULL,NULL),('1211453759591333890',NULL,NULL,2,1,NULL,'15859813817','920364','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:07:38',NULL,NULL,NULL),('1211454159660826625',NULL,NULL,2,1,NULL,'13506060342','540780','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:09:14',NULL,NULL,NULL),('1211455281867833345',NULL,NULL,2,1,NULL,'15059551567','386586','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:13:41',NULL,NULL,NULL),('1211455284782874625',NULL,NULL,2,1,NULL,'18965689935','868783','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:13:42',NULL,NULL,NULL),('1211455642695417857',NULL,NULL,2,1,NULL,'15392286115','781667','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:15:07',NULL,NULL,NULL),('1211456348219293698',NULL,NULL,2,1,NULL,'15059821270','528038','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:17:55',NULL,NULL,NULL),('1211456933324701697',NULL,NULL,2,1,NULL,'18150505789','014184','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:20:15',NULL,NULL,NULL),('1211457203429490689',NULL,NULL,2,1,NULL,'18350770050','356281','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:21:19',NULL,NULL,NULL),('1211458515751714818',NULL,NULL,2,1,NULL,'18159338867','600542','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:26:32',NULL,NULL,NULL),('1211458876675768321',NULL,NULL,2,1,NULL,'18965689935','398612','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:27:58',NULL,NULL,NULL),('1211458977422950401',NULL,NULL,2,1,NULL,'13788846820','078013','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:28:22',NULL,NULL,NULL),('1211459954217631745',NULL,NULL,2,1,NULL,'15880885350','480731','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:32:15',NULL,NULL,NULL),('1211460047939354625',NULL,NULL,2,1,NULL,'18159338867','728420','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:32:37',NULL,NULL,NULL),('1211460318039949313',NULL,NULL,2,1,NULL,'18959857088','463721','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:33:42',NULL,NULL,NULL),('1211460707753705473',NULL,NULL,2,1,NULL,'13505004167','338613','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:35:15',NULL,NULL,NULL),('1211463847630651393',NULL,NULL,2,1,NULL,'15059551567','282031','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:47:43',NULL,NULL,NULL),('1211464831840862209',NULL,NULL,2,1,NULL,'13615901213','175423','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:51:38',NULL,NULL,NULL),('1211465849974603778',NULL,NULL,2,1,NULL,'15059551567','393286','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:55:41',NULL,NULL,NULL),('1211466011690188802',NULL,NULL,2,1,NULL,'13365978588','660344','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:56:19',NULL,NULL,NULL),('1211466250912317441',NULL,NULL,2,1,NULL,'18250413746','373182','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:57:16',NULL,NULL,NULL),('1211466711245570049',NULL,NULL,2,1,NULL,'15805969239','132235','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 09:59:06',NULL,NULL,NULL),('1211466977466433538',NULL,NULL,2,1,NULL,'15959896966','635653','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:00:10',NULL,NULL,NULL),('1211467100447621121',NULL,NULL,2,1,NULL,'13489887652','433111','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:00:39',NULL,NULL,NULL),('1211467587867688961',NULL,NULL,2,1,NULL,'13365978588','173237','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:02:35',NULL,NULL,NULL),('1211470000288743426',NULL,NULL,2,1,NULL,'13799550180','527506','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:12:10',NULL,NULL,NULL),('1211471300086775809',NULL,NULL,2,1,NULL,'18959708027','107395','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:17:20',NULL,NULL,NULL),('1211471932009005057',NULL,NULL,2,1,NULL,'18959995705','451455','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:19:51',NULL,NULL,NULL),('1211471954754715650',NULL,NULL,2,1,NULL,'15359991222','575099','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:19:56',NULL,NULL,NULL),('1211472154034487297','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:44',NULL,NULL,NULL),('1211472175639347202','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:49',NULL,NULL,NULL),('1211472176071360514','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:49',NULL,NULL,NULL),('1211472176436264962','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:49',NULL,NULL,NULL),('1211472176838918145','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:49',NULL,NULL,NULL),('1211472177304485890','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:49',NULL,NULL,NULL),('1211472177677778945','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:49',NULL,NULL,NULL),('1211472178155929602','1211221341013913601',NULL,2,2,'中菱& #40;福建& #41;电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:20:49',NULL,NULL,NULL),('1211472823931944962',NULL,NULL,2,1,NULL,'13255006151','301375','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:23:23',NULL,NULL,NULL),('1211472854185459714',NULL,NULL,2,1,NULL,'13788809209','903760','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:23:31',NULL,NULL,NULL),('1211473042492932097',NULL,NULL,2,1,NULL,'13799550180','139417','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:24:16',NULL,NULL,NULL),('1211473293626884098',NULL,NULL,2,1,NULL,'18759429880','905872','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:25:15',NULL,NULL,NULL),('1211474627851763714',NULL,NULL,2,1,NULL,'13799550180','322521','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:30:34',NULL,NULL,NULL),('1211475667888160769',NULL,NULL,2,1,NULL,'18959995705','964033','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:34:42',NULL,NULL,NULL),('1211476030921949186',NULL,NULL,2,1,NULL,'18759429880','838158','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:36:08',NULL,NULL,NULL),('1211476864153993218',NULL,NULL,2,1,NULL,'18876509838','170002','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:39:27',NULL,NULL,NULL),('1211478597022302209',NULL,NULL,2,1,NULL,'13055667605','281532','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:46:20',NULL,NULL,NULL),('1211479400567062529',NULL,NULL,2,1,NULL,'17362523273','970556','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:49:31',NULL,NULL,NULL),('1211479777240727554',NULL,NULL,2,1,NULL,'18960355033','112192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:51:01',NULL,NULL,NULL),('1211479931905687554','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:51:38',NULL,NULL,NULL),('1211480127133761537',NULL,NULL,2,1,NULL,'15960789678','063117','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:52:25',NULL,NULL,NULL),('1211480780048482305',NULL,NULL,2,1,NULL,'18876509838','642152','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:55:00',NULL,NULL,NULL),('1211481080482283521',NULL,NULL,2,1,NULL,'18016585576','659328','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 10:56:12',NULL,NULL,NULL),('1211482257064247297','1210885744126701570',NULL,2,2,'福建省维德福消防工程有限公司','13505044247','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:00:52',NULL,NULL,NULL),('1211482598375735298','1210891343090528258',NULL,2,2,'晋江市泳衣库技术服务有限公司','18759439111','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:02:14',NULL,NULL,NULL),('1211482619858960386','1210891343090528258',NULL,2,2,'晋江市泳衣库技术服务有限公司','18759439111','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:02:19',NULL,NULL,NULL),('1211482620177727490','1210891343090528258',NULL,2,2,'晋江市泳衣库技术服务有限公司','18759439111','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:02:19',NULL,NULL,NULL),('1211482655548293121',NULL,NULL,2,1,NULL,'18659518160','830728','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:02:27',NULL,NULL,NULL),('1211483382123380738','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:21',NULL,NULL,NULL),('1211483389127868417',NULL,NULL,2,1,NULL,'13599749329','259180','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:22',NULL,NULL,NULL),('1211483404663570433','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:26',NULL,NULL,NULL),('1211483405208829953','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:26',NULL,NULL,NULL),('1211483405846364161','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:26',NULL,NULL,NULL),('1211483407662497794','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:27',NULL,NULL,NULL),('1211483408832708609','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:27',NULL,NULL,NULL),('1211483409315053570','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:05:27',NULL,NULL,NULL),('1211484308590608385',NULL,NULL,2,1,NULL,'13506061626','309807','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:09:02',NULL,NULL,NULL),('1211486296137056258',NULL,NULL,2,1,NULL,'18016585576','598219','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:16:55',NULL,NULL,NULL),('1211487886688436226',NULL,NULL,2,1,NULL,'15959856777','442757','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:23:15',NULL,NULL,NULL),('1211488515443965953','1210918631014248450',NULL,2,2,'茂泰& #40;福建& #41;鞋材有限公司','18959705077','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:25:45',NULL,NULL,NULL),('1211489887006539777',NULL,NULL,2,1,NULL,'15980788802','693910','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:31:12',NULL,NULL,NULL),('1211490206482481154',NULL,NULL,2,1,NULL,'18060007601','444018','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:32:28',NULL,NULL,NULL),('1211490438846922753',NULL,NULL,2,1,NULL,'15959566799','845220','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:33:23',NULL,NULL,NULL),('1211492087913037825',NULL,NULL,2,1,NULL,'13255957226','629560','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:39:56',NULL,NULL,NULL),('1211493351862353922',NULL,NULL,2,1,NULL,'18050996325','741452','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:44:58',NULL,NULL,NULL),('1211493934027554818',NULL,NULL,2,1,NULL,'15905907962','635709','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:47:16',NULL,NULL,NULL),('1211494014797266946','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:47:36',NULL,NULL,NULL),('1211494315231068161',NULL,NULL,2,1,NULL,'15280619456','357496','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:48:47',NULL,NULL,NULL),('1211494773924347906','1211494485905686529',NULL,2,2,'时来运转','15280619456','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:50:37',NULL,NULL,NULL),('1211494795441127426','1211494485905686529',NULL,2,2,'时来运转','15280619456','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:50:42',NULL,NULL,NULL),('1211494913544339458',NULL,NULL,2,1,NULL,'18050996325','397260','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:51:10',NULL,NULL,NULL),('1211495312519118850','1211494485905686529',NULL,2,2,'时来运转','15280619456','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:52:45',NULL,NULL,NULL),('1211495334040092673','1211494485905686529',NULL,2,2,'时来运转','15280619456','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:52:50',NULL,NULL,NULL),('1211495367678410753',NULL,NULL,2,1,NULL,'15106011992','612760','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:52:58',NULL,NULL,NULL),('1211497126958252033',NULL,NULL,2,1,NULL,'18960206656','808556','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 11:59:58',NULL,NULL,NULL),('1211505125420482561',NULL,NULL,2,1,NULL,'13905972257','142797','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 12:31:45',NULL,NULL,NULL),('1211515378073649154',NULL,NULL,2,1,NULL,'15960791997','082815','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 13:12:29',NULL,NULL,NULL),('1211517326621458434',NULL,NULL,2,1,NULL,'13559060707','347400','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 13:20:14',NULL,NULL,NULL),('1211519064455823361',NULL,NULL,2,1,NULL,'13559060707','094289','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 13:27:08',NULL,NULL,NULL),('1211520528821567490',NULL,NULL,2,1,NULL,'13559060707','316799','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 13:32:57',NULL,NULL,NULL),('1211525309933862914',NULL,NULL,2,1,NULL,'18960357668','135465','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 13:51:57',NULL,NULL,NULL),('1211526824593506305',NULL,NULL,2,1,NULL,'18959906986','416125','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 13:57:58',NULL,NULL,NULL),('1211528281963151362',NULL,NULL,2,1,NULL,'18815985118','047862','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:03:46',NULL,NULL,NULL),('1211528738374729730',NULL,NULL,2,1,NULL,'15805021228','141778','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:05:35',NULL,NULL,NULL),('1211528891261304834',NULL,NULL,2,1,NULL,'15960551920','577743','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:06:11',NULL,NULL,NULL),('1211529882803159042',NULL,NULL,2,1,NULL,'18815985118','524032','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:10:07',NULL,NULL,NULL),('1211531834094043137',NULL,NULL,2,1,NULL,'15905065558','645013','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:17:53',NULL,NULL,NULL),('1211533248006504449',NULL,NULL,2,1,NULL,'18859791858','025757','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:23:30',NULL,NULL,NULL),('1211535069957636097',NULL,NULL,2,1,NULL,'13506069172','771446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:30:44',NULL,NULL,NULL),('1211536333059702786',NULL,NULL,2,1,NULL,'13559054268','549973','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:35:45',NULL,NULL,NULL),('1211537150823153665',NULL,NULL,2,1,NULL,'13906095618','884717','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:39:00',NULL,NULL,NULL),('1211538794394730498',NULL,NULL,2,1,NULL,'15280796970','429177','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:45:32',NULL,NULL,NULL),('1211542098105384961',NULL,NULL,2,1,NULL,'18698390251','014419','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 14:58:40',NULL,NULL,NULL),('1211546036330348545',NULL,NULL,2,1,NULL,'13959811363','017079','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 15:14:19',NULL,NULL,NULL),('1211548099919527937',NULL,NULL,2,1,NULL,'15059528886','711764','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 15:22:31',NULL,NULL,NULL),('1211551021126434817',NULL,NULL,2,1,NULL,'18959709952','577397','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 15:34:07',NULL,NULL,NULL),('1211551539903119361',NULL,NULL,2,1,NULL,'13559060707','429584','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 15:36:11',NULL,NULL,NULL),('1211553650292342785',NULL,NULL,2,1,NULL,'13860748042','373991','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 15:44:34',NULL,NULL,NULL),('1211559260698230786',NULL,NULL,2,1,NULL,'13665929319','070798','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 16:06:52',NULL,NULL,NULL),('1211560941775273985',NULL,NULL,2,1,NULL,'13665929319','564558','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 16:13:32',NULL,NULL,NULL),('1211561209988431874',NULL,NULL,2,1,NULL,'15959993860','498092','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 16:14:36',NULL,NULL,NULL),('1211561397079556098',NULL,NULL,2,1,NULL,'15959559398','550400','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 16:15:21',NULL,NULL,NULL),('1211562610533646337',NULL,NULL,2,1,NULL,'13625995436','194266','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 16:20:10',NULL,NULL,NULL),('1211568186630127617',NULL,NULL,2,1,NULL,'13959757688','299633','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 16:42:20',NULL,NULL,NULL),('1211572640796426241',NULL,NULL,2,1,NULL,'13625976298','767408','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 17:00:02',NULL,NULL,NULL),('1211573472224919553',NULL,NULL,2,1,NULL,'13625976298','273112','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 17:03:20',NULL,NULL,NULL),('1211573480307343361',NULL,NULL,2,1,NULL,'18900399682','254931','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 17:03:22',NULL,NULL,NULL),('1211573795534454786',NULL,NULL,2,1,NULL,'18605007810','153248','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 17:04:37',NULL,NULL,NULL),('1211575913779609602',NULL,NULL,2,1,NULL,'18900399682','920532','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 17:13:02',NULL,NULL,NULL),('1211598962016960513',NULL,NULL,2,1,NULL,'18965723060','394975','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 18:44:37',NULL,NULL,NULL),('1211599681482702850',NULL,NULL,2,1,NULL,'13799233113','795150','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 18:47:29',NULL,NULL,NULL),('1211601717255258113',NULL,NULL,2,1,NULL,'13799233113','549748','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 18:55:34',NULL,NULL,NULL),('1211602808634130434',NULL,NULL,2,1,NULL,'13799233113','505004','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 18:59:54',NULL,NULL,NULL),('1211608270171586561',NULL,NULL,2,1,NULL,'13599789599','271122','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 19:21:36',NULL,NULL,NULL),('1211609778552356866',NULL,NULL,2,1,NULL,'13599789599','881202','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 19:27:36',NULL,NULL,NULL),('1211610451973029890',NULL,NULL,2,1,NULL,'14759154723','659255','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 19:30:17',NULL,NULL,NULL),('1211625604370186242',NULL,NULL,2,1,NULL,'18350062033','342375','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-30',NULL,NULL,NULL,'2019-12-30 20:30:29',NULL,NULL,NULL),('1211654036873330689','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 22:23:18',NULL,NULL,NULL),('1211654058796957697','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 22:23:33',NULL,NULL,NULL),('1211654368022020097','1211479687600062466',NULL,2,2,'测试','17362523273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'发送条数超限制','2019-12-30',NULL,NULL,NULL,'2019-12-30 22:24:47',NULL,NULL,NULL),('1211728359936016385',NULL,NULL,2,1,NULL,'18698387555','715611','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 03:18:48',NULL,NULL,NULL),('1211730922420879362',NULL,NULL,2,1,NULL,'18698387555','723128','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 03:28:59',NULL,NULL,NULL),('1211737078618963969',NULL,NULL,2,1,NULL,'18698387555','304098','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 03:53:27',NULL,NULL,NULL),('1211804786609930242',NULL,NULL,2,1,NULL,'13905089190','615752','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 08:22:30',NULL,NULL,NULL),('1211810654176985090','1211236784814534658',NULL,2,2,'晋江乐康医院有限公司','15109613666','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 08:45:48',NULL,NULL,NULL),('1211812312189550594','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 08:52:24',NULL,NULL,NULL),('1211814114075131905','1210918631014248450',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 08:59:33',NULL,NULL,NULL),('1211814586198573058',NULL,NULL,2,1,NULL,'13666026522','760809','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:01:26',NULL,NULL,NULL),('1211815825984503809','1211104782702456833',NULL,2,2,'晋江市星工场教育咨询有限公司','13599496037','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:06:22',NULL,NULL,NULL),('1211815887582052354',NULL,NULL,2,1,NULL,'13666026522','355721','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:06:36',NULL,NULL,NULL),('1211815999502860289',NULL,NULL,2,1,NULL,'18558994473','885307','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:07:03',NULL,NULL,NULL),('1211816574172839938','1210952926445547521',NULL,2,2,'福建楚威贸易有限公司','13506055705','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:09:20',NULL,NULL,NULL),('1211818610276745218','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:17:25',NULL,NULL,NULL),('1211818836194541570',NULL,NULL,2,1,NULL,'13666026522','320115','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:18:19',NULL,NULL,NULL),('1211819319755849729','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:20:15',NULL,NULL,NULL),('1211819492208852993',NULL,NULL,2,1,NULL,'17350926157','451790','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:20:56',NULL,NULL,NULL),('1211819883285757954',NULL,NULL,2,1,NULL,'13805992036','760507','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:22:29',NULL,NULL,NULL),('1211822136923045890','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:31:26',NULL,NULL,NULL),('1211822195253231617','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:31:40',NULL,NULL,NULL),('1211828651214028801','1211815946042261505',NULL,2,2,'泉州市陶源环保科技有限公司','13666026522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 09:57:19',NULL,NULL,NULL),('1211831026620350465',NULL,NULL,2,1,NULL,'18350062033','619215','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:06:46',NULL,NULL,NULL),('1211831267004301313','1211098602777194497',NULL,2,2,'福建省诺美护理用品有限公司','13799487213','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:07:43',NULL,NULL,NULL),('1211832874710384641',NULL,NULL,2,1,NULL,'18350062033','412209','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:14:06',NULL,NULL,NULL),('1211835379351601154','1211100599215566849',NULL,2,2,'劲派经编科技有限公司','15859799211','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:24:03',NULL,NULL,NULL),('1211835834278395906',NULL,NULL,2,1,NULL,'15960778794','587570','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:25:52',NULL,NULL,NULL),('1211836026453016578',NULL,NULL,2,1,NULL,'17759539230','988653','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:26:38',NULL,NULL,NULL),('1211837501312909314',NULL,NULL,2,1,NULL,'15959420909','723161','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:32:29',NULL,NULL,NULL),('1211837728195395586',NULL,NULL,2,1,NULL,'15960778794','535310','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:33:23',NULL,NULL,NULL),('1211837907854213122',NULL,NULL,2,1,NULL,'19942826787','988515','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:34:06',NULL,NULL,NULL),('1211838090222551042','1211110678463623169',NULL,2,2,'琪尔特股份有限公司','18859969666','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:34:50',NULL,NULL,NULL),('1211838725651218434','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:37:21',NULL,NULL,NULL),('1211839242389471233','1211117817491992577',NULL,2,2,'晋江泉荣远东水处理有限公司','15959596830','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:39:24',NULL,NULL,NULL),('1211839805747412993','1211120827064496130',NULL,2,2,'泉州市至真工具科技有限公司','13313825373','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:41:39',NULL,NULL,NULL),('1211839842011365378','1211120827064496130',NULL,2,2,'泉州市至真工具科技有限公司','13313825373','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:41:47',NULL,NULL,NULL),('1211839958340386817',NULL,NULL,2,1,NULL,'19942826787','281757','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:42:15',NULL,NULL,NULL),('1211839968083755009','1211177535560331265',NULL,2,2,'晋江市凯鑫汽配有限责任公司','15959556399','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:42:17',NULL,NULL,NULL),('1211840065538408450','1211164549680574466',NULL,2,2,'乔丹体育股份有限公司','18659597668','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:42:41',NULL,NULL,NULL),('1211840238985461762','1211167966465470465',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:43:22',NULL,NULL,NULL),('1211840392757035010','1211128473930805250',NULL,2,2,'福建晋江凤竹鞋业发展有限公司','13959957107','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:43:59',NULL,NULL,NULL),('1211840510721835009','1211171114114461697',NULL,2,2,'中轻（晋江）卫生用品研究有限公司','13520554703','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:44:27',NULL,NULL,NULL),('1211840605408247809','1211138539417350145',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:44:49',NULL,NULL,NULL),('1211840786757369857','1211139634755645442',NULL,2,2,'福建百宏高新材料实业有限公司','13305967663','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:45:33',NULL,NULL,NULL),('1211840964839129089','1211140930858496001',NULL,2,2,'晋江名仕纺织机械设计有限公司','13599250912','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:46:15',NULL,NULL,NULL),('1211841139343147010','1211475811404660738',NULL,2,2,'迦南（福建）新材料科技有限公司','18959995705','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:46:57',NULL,NULL,NULL),('1211841545465020417','1211150098789150721',NULL,2,2,'泉州永实工程质量检测有限公司','18396220746','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:48:34',NULL,NULL,NULL),('1211841730219917313','1211459042799566850',NULL,2,2,'福建省晋江市三力机车有限公司','18965689935','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:49:18',NULL,NULL,NULL),('1211841792320782337',NULL,NULL,2,1,NULL,'13599701057','143054','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:49:32',NULL,NULL,NULL),('1211842315589566465','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:51:37',NULL,NULL,NULL),('1211842495680397313','1211459203080699905',NULL,2,2,'福建省育才建设发展有限公司','13788846820','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:52:20',NULL,NULL,NULL),('1211842635124228098','1211457535089885185',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:52:53',NULL,NULL,NULL),('1211842873134202881','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:53:50',NULL,NULL,NULL),('1211843048149925889','1211456215943528450',NULL,2,2,'福建泉成机械有限公司','15392286115','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:54:32',NULL,NULL,NULL),('1211843592193097729','1211139634755645442',NULL,2,2,'福建百宏高新材料实业有限公司','13305967663','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:56:42',NULL,NULL,NULL),('1211843952555114498','1211138539417350145',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 10:58:07',NULL,NULL,NULL),('1211844794289012738','1211465952919601153',NULL,2,2,'福建省晋江市福埔S.M国际广场','15059551567','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:01:28',NULL,NULL,NULL),('1211845160514666498','1211466629175623682',NULL,2,2,'福建省杰泰建设发展有限公司','18250413746','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:02:55',NULL,NULL,NULL),('1211845486663745538','1211467512697372673',NULL,2,2,'晋江市万达汽车贸易有限公司','13489887652','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:04:13',NULL,NULL,NULL),('1211846479430336513','1211467536848175106',NULL,2,2,'泉州市德玛特电机制造有限公司','15805969239','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:08:10',NULL,NULL,NULL),('1211846971627716609','1211467701302640642',NULL,2,2,'福建凤竹环保有限公司','13365978588','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:10:07',NULL,NULL,NULL),('1211847706071318529','1211471774600970241',NULL,2,2,'泉州鸿展模具制造有限公司','18959708027','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:13:02',NULL,NULL,NULL),('1211848222331420673','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:15:05',NULL,NULL,NULL),('1211850402836824065','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:23:45',NULL,NULL,NULL),('1211850914218950658','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:25:47',NULL,NULL,NULL),('1211850933252702209',NULL,NULL,2,1,NULL,'18150989333','614203','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:25:52',NULL,NULL,NULL),('1211851444462862337','1211476436687306754',NULL,2,2,'晋江裕福集团有限公司','18759429880','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:27:54',NULL,NULL,NULL),('1211851508337917953',NULL,NULL,2,1,NULL,'15880896188','846920','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:28:09',NULL,NULL,NULL),('1211851927927701506','1211444027140915202',NULL,2,2,'福建省万物智联科技有限公司','18559275265','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:29:49',NULL,NULL,NULL),('1211852190080090113','1211479386717470722',NULL,2,2,'晋江盛雅新能源有限责任公司','13055667605','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:30:51',NULL,NULL,NULL),('1211852651843600385','1211479976335949826',NULL,2,2,'福建省晋江市兴达机电器材有限公司','18960355033','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:32:41',NULL,NULL,NULL),('1211852986486145025',NULL,NULL,2,1,NULL,'13959883141','967713','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:34:01',NULL,NULL,NULL),('1211853074881101826','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:34:22',NULL,NULL,NULL),('1211853366427172866','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:35:32',NULL,NULL,NULL),('1211853760393953281','1211484578443739137',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:37:06',NULL,NULL,NULL),('1211854248980037634','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:39:02',NULL,NULL,NULL),('1211854844617342977',NULL,NULL,2,1,NULL,'15160423086','598618','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:41:24',NULL,NULL,NULL),('1211854951425294337','1211486447580790785',NULL,2,2,'福建省劲牛重工发展有限公司','18016585576','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:41:50',NULL,NULL,NULL),('1211855291994390530','1211444939745968130',NULL,2,2,'晋江市安海镇卫生院','13799557721','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:43:11',NULL,NULL,NULL),('1211855487453151234','1211489025517469698',NULL,2,2,'泉州星城纸业有限公司','15959856777','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:43:58',NULL,NULL,NULL),('1211856629268529154','1211465952919601153',NULL,2,2,'福建省晋江市福埔S.M国际广场','15059551567','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:48:30',NULL,NULL,NULL),('1211857141510488066','1211184671690436610',NULL,2,2,'泉州市里仁财务咨询有限公司','15880720190','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:50:32',NULL,NULL,NULL),('1211857680407248898','1211221341013913601',NULL,2,2,'中菱（福建）电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:52:40',NULL,NULL,NULL),('1211859373475807233','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 11:59:24',NULL,NULL,NULL),('1211875907950657537',NULL,NULL,2,1,NULL,'18250413746','870592','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 13:05:06',NULL,NULL,NULL),('1211892177836228610',NULL,NULL,2,1,NULL,'18859989399','505482','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:09:45',NULL,NULL,NULL),('1211892496607526914',NULL,NULL,2,1,NULL,'18859989399','571673','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:11:01',NULL,NULL,NULL),('1211897576840806402','1211609839420096513',NULL,2,2,'福建省晋江产业发展投资集团有限公司','13599789599','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:31:12',NULL,NULL,NULL),('1211898062474100738','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:33:08',NULL,NULL,NULL),('1211898295174086658','1211473627321516033',NULL,2,2,'晋江市新佳园资产管理有限公司','13255006151','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:34:04',NULL,NULL,NULL),('1211898728626044930','1211450825436610561',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:35:47',NULL,NULL,NULL),('1211898810809237506','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:36:07',NULL,NULL,NULL),('1211901400649351169','1211191315514109954',NULL,2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:46:24',NULL,NULL,NULL),('1211902166827057153','1211221341013913601',NULL,2,2,'中菱（福建）电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 14:49:27',NULL,NULL,NULL),('1211905407086280706','1211486447580790785',NULL,2,2,'福建省劲牛重工发展有限公司','18016585576','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:02:19',NULL,NULL,NULL),('1211906876736847874','1211486447580790785',NULL,2,2,'福建省劲牛重工发展有限公司','18016585576','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:08:10',NULL,NULL,NULL),('1211911275362172930','1211601884993863681',NULL,2,2,'晋江市妇幼保健 院','13799233113','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:25:38',NULL,NULL,NULL),('1211913730498019329',NULL,NULL,2,1,NULL,'18965690059','445252','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:35:24',NULL,NULL,NULL),('1211917862130728962','1211574035113099265',NULL,2,2,'三六一度（中国）有限公司','18605007810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:51:49',NULL,NULL,NULL),('1211917987645276161','1211572731150123009',NULL,2,2,'三六一度（福建）体育用品有限公司','13625976298','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:52:19',NULL,NULL,NULL),('1211919061806530562','1211221341013913601',NULL,2,2,'中菱（福建）电梯有限公司','18959847128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:56:35',NULL,NULL,NULL),('1211919106396176385',NULL,NULL,2,1,NULL,'15160330306','335217','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 15:56:45',NULL,NULL,NULL),('1211920052274642946',NULL,NULL,2,1,NULL,'15160330306','734566','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:00:31',NULL,NULL,NULL),('1211921628473114626','1211240519515090946',NULL,2,2,'晋江友峰鞋业有限公司','15306089555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:06:47',NULL,NULL,NULL),('1211922276274978817',NULL,NULL,2,1,NULL,'13675959528','959798','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:09:21',NULL,NULL,NULL),('1211922709169094658',NULL,NULL,2,1,NULL,'13799233113','438186','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:11:04',NULL,NULL,NULL),('1211923203971137538',NULL,NULL,2,1,NULL,'15260875883','827358','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:13:02',NULL,NULL,NULL),('1211923810798845954',NULL,NULL,2,1,NULL,'13675959528','554998','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:15:27',NULL,NULL,NULL),('1211923851043192833','1211441648983130114',NULL,2,2,'兴业皮革科技股份有限公司','18859716647','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:15:37',NULL,NULL,NULL),('1211925071505965058',NULL,NULL,2,1,NULL,'17359269810','206388','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:20:28',NULL,NULL,NULL),('1211925496703533058',NULL,NULL,2,1,NULL,'13509362773','037443','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:22:09',NULL,NULL,NULL),('1211926141896540161','1211492544651771905',NULL,2,2,'晋江凯燕新材料科技有限公司','13255957226','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:24:43',NULL,NULL,NULL),('1211927034498957314','1211450215958102018',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:28:16',NULL,NULL,NULL),('1211927353542885377','1211452681604874242',NULL,2,2,'泉州巾帼人力资源发展有限公司','18159352255','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:29:32',NULL,NULL,NULL),('1211927445519777793',NULL,NULL,2,1,NULL,'13509362773','351754','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:29:54',NULL,NULL,NULL),('1211927630455029762','1211492544651771905',NULL,2,2,'晋江凯燕新材料科技有限公司','13255957226','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:30:38',NULL,NULL,NULL),('1211930005668413441','1211453814360555522',NULL,2,2,'伟志股份公司','15859813817','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:40:04',NULL,NULL,NULL),('1211930551737434114',NULL,NULL,2,1,NULL,'13506042338','233287','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:42:14',NULL,NULL,NULL),('1211930623292260354',NULL,NULL,2,1,NULL,'15191454197','495905','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:42:31',NULL,NULL,NULL),('1211931663949414401','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:46:39',NULL,NULL,NULL),('1211931989913944065','1210952926445547521',NULL,2,2,'福建楚威贸易有限公司','13506055705','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:47:57',NULL,NULL,NULL),('1211932515195994113','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:50:02',NULL,NULL,NULL),('1211932684339691522','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:50:43',NULL,NULL,NULL),('1211932804456169473','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:51:11',NULL,NULL,NULL),('1211934302720278530',NULL,NULL,2,1,NULL,'18815985118','023377','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 16:57:09',NULL,NULL,NULL),('1211935923080577025',NULL,NULL,2,1,NULL,'18815985118','640695','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:03:35',NULL,NULL,NULL),('1211939254297477121','1211454669394591746',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:16:49',NULL,NULL,NULL),('1211942225903140865','1211460115408928770',NULL,2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:28:38',NULL,NULL,NULL),('1211942970912194561',NULL,NULL,2,1,NULL,'13860758785','765792','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:31:35',NULL,NULL,NULL),('1211943165444014082','1211460552828698626',NULL,2,2,'雨中鸟（福建）户外用品有限公司','15880885350','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:32:22',NULL,NULL,NULL),('1211943918732623874',NULL,NULL,2,1,NULL,'13859769696','908532','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:35:21',NULL,NULL,NULL),('1211943990102900738','1211460918949494786',NULL,2,2,'大发科技集团有限公司','18959857088','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:35:38',NULL,NULL,NULL),('1211944771946332161',NULL,NULL,2,1,NULL,'13860758785','518966','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:38:45',NULL,NULL,NULL),('1211945614414233601',NULL,NULL,2,1,NULL,'13859769696','265157','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:42:05',NULL,NULL,NULL),('1211946509235437569',NULL,NULL,2,1,NULL,'13860758785','650888','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 17:45:39',NULL,NULL,NULL),('1211983424324157442','1211936677191270402',NULL,2,2,'泉州市陶源环保科技有限公司','13666026522','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 20:12:20',NULL,NULL,NULL),('1212022750428860417',NULL,NULL,2,1,NULL,'13599218888','081091','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-31',NULL,NULL,NULL,'2019-12-31 22:48:36',NULL,NULL,NULL),('1212194807179448322',NULL,NULL,2,1,NULL,'13656038332','449246','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-01',NULL,NULL,NULL,'2020-01-01 10:12:18',NULL,NULL,NULL),('1212198417321758721',NULL,NULL,2,1,NULL,'17759990690','978790','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-01',NULL,NULL,NULL,'2020-01-01 10:26:38',NULL,NULL,NULL),('1212200573265317889',NULL,NULL,2,1,NULL,'13559591215','695200','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-01',NULL,NULL,NULL,'2020-01-01 10:35:12',NULL,NULL,NULL),('1212251304508854273',NULL,NULL,2,1,NULL,'13580701185','256201','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-01',NULL,NULL,NULL,'2020-01-01 13:56:48',NULL,NULL,NULL),('1212253208412491778',NULL,NULL,2,1,NULL,'13580701185','035906','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-01',NULL,NULL,NULL,'2020-01-01 14:04:22',NULL,NULL,NULL),('1212270689822773250',NULL,NULL,2,1,NULL,'13959717808','318533','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-01',NULL,NULL,NULL,'2020-01-01 15:13:50',NULL,NULL,NULL),('1212369821396701186',NULL,NULL,2,1,NULL,'13275951100','208425','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-01',NULL,NULL,NULL,'2020-01-01 21:47:44',NULL,NULL,NULL),('1212412126942007298',NULL,NULL,2,1,NULL,'18698387555','586097','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 00:35:51',NULL,NULL,NULL),('1212412420144828417',NULL,NULL,2,1,NULL,'18698387555','668491','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 00:37:01',NULL,NULL,NULL),('1212412819148967938',NULL,NULL,2,1,NULL,'18698387555','066519','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 00:38:36',NULL,NULL,NULL),('1212524539662110722',NULL,NULL,2,1,NULL,'13788829369','219506','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:02:32',NULL,NULL,NULL),('1212524813298503681',NULL,NULL,2,1,NULL,'13788829369','736669','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:03:37',NULL,NULL,NULL),('1212525426048569345',NULL,NULL,2,1,NULL,'13788829369','876920','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:06:03',NULL,NULL,NULL),('1212527870602186754',NULL,NULL,2,1,NULL,'13788829369','864169','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:15:46',NULL,NULL,NULL),('1212528328267862017',NULL,NULL,2,1,NULL,'13788829369','432477','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:17:35',NULL,NULL,NULL),('1212530461306327041','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:26:04',NULL,NULL,NULL),('1212530757717790722','1211491083737939970',NULL,2,2,'晋江市三福纺织实业有限公司','15959566799','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:27:15',NULL,NULL,NULL),('1212531152405991425','1211494671642050561',NULL,2,2,'顺宏达（福建）针织服饰有限公司','15905907962','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:28:49',NULL,NULL,NULL),('1212532331634561026',NULL,NULL,2,1,NULL,'15396486268','680572','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:33:30',NULL,NULL,NULL),('1212532646194778114','1211494978245672962',NULL,2,2,'福建省德腾智能科技有限公司','18050996325','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:34:45',NULL,NULL,NULL),('1212532866286686209','1211495827340574722',NULL,2,2,'晋江市品质陶瓷建材有限公司','15106011992','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:35:37',NULL,NULL,NULL),('1212533047660974081','1211497229303463938',NULL,2,2,'泉州市晋科技术检测有限公司','18960206656','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:36:20',NULL,NULL,NULL),('1212533775662125058','1211505228151570433',NULL,2,2,'晋江市陈埭中心卫生院','13905972257','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:39:14',NULL,NULL,NULL),('1212535004429619201',NULL,NULL,2,1,NULL,'15160330306','498464','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:44:07',NULL,NULL,NULL),('1212535300354543617',NULL,NULL,2,1,NULL,'18120662230','082142','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:45:18',NULL,NULL,NULL),('1212536640099127297',NULL,NULL,2,1,NULL,'13675998353','842076','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:50:37',NULL,NULL,NULL),('1212536835645968386','1211515979058692097',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:51:24',NULL,NULL,NULL),('1212536946623057922',NULL,NULL,2,1,NULL,'15396486268','556710','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:51:50',NULL,NULL,NULL),('1212537119583571969','1211525473977286657',NULL,2,2,'凯毅（福建）体育用品有限公司','18960357668','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:52:31',NULL,NULL,NULL),('1212538211407040513','1211527239116570626',NULL,2,2,'泉州思力科电子科技有限公司','18959906986','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:56:52',NULL,NULL,NULL),('1212538943787044865',NULL,NULL,2,1,NULL,'13788808205','621115','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 08:59:46',NULL,NULL,NULL),('1212539021293588482','69',NULL,1,2,'陈文经','13599795023','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021662687233','70',NULL,1,2,'陈瑞清','13788864979','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021851430913','71',NULL,1,2,'王小阳','13559621092','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539022019203073','58',NULL,1,2,'张荣荣','15280619456','59,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539022195363841','61',NULL,1,2,'叶志钦','17362523273','59,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539022375718913','62',NULL,1,2,'林曼雅','17362523273','59,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539022589628418','73',NULL,1,2,'张荣荣','15280619456','59,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539022757400578','74',NULL,1,2,'叶志钦','13675957398','59,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539022929367041','87',NULL,1,2,'叶志钦','13675957398','59,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539023105527809','89',NULL,1,2,'林曼雅','13799500668','59,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:00:05',NULL,NULL,NULL),('1212539672434118658','1211528991136071681',NULL,2,2,'福建乐隆隆食品科技有限公司','15960551920','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:02:40',NULL,NULL,NULL),('1212540349759688706',NULL,NULL,2,1,NULL,'13788808205','803739','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:05:21',NULL,NULL,NULL),('1212540574956064770',NULL,NULL,2,1,NULL,'18905078173','756655','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:06:15',NULL,NULL,NULL),('1212541914692259842','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:11:35',NULL,NULL,NULL),('1212542684573536258','1211532077091045377',NULL,2,2,'晋江市西滨镇卫生院','15905065558','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:14:38',NULL,NULL,NULL),('1212543098610061314','1211533483709612033',NULL,2,2,'泉州正懋伟航纸业有限公司','18859791858','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:16:17',NULL,NULL,NULL),('1212545020117192705','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'黑名单','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:23:55',NULL,NULL,NULL),('1212545502319546369','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:25:50',NULL,NULL,NULL),('1212546148540157953','1211892702682071041',NULL,2,2,'福建省晋江万利瓷业有限公司','18859989399','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:28:24',NULL,NULL,NULL),('1212546244417753090','1211236784814534658',NULL,2,2,'晋江乐康医院有限公司','15109613666','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:28:47',NULL,NULL,NULL),('1212549237548584961',NULL,NULL,2,1,NULL,'18150596289','109955','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:40:40',NULL,NULL,NULL),('1212549313838780418','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:40:59',NULL,NULL,NULL),('1212549694434119681','1211535199725207554',NULL,2,2,'福建亿龙建工有限公司','13506069172','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:42:29',NULL,NULL,NULL),('1212552195417903105',NULL,NULL,2,1,NULL,'18859989399','504478','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:52:26',NULL,NULL,NULL),('1212552484082487298',NULL,NULL,2,1,NULL,'18859989399','131372','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 09:53:34',NULL,NULL,NULL),('1212554301868675074','1211537376518651906',NULL,2,2,'南湾投资发展有限公司','13559054268','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:00:48',NULL,NULL,NULL),('1212555569634807809','1211539398999457793',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:05:50',NULL,NULL,NULL),('1212555970119536642','1211927486787534850',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:07:26',NULL,NULL,NULL),('1212558552846110721','1211538270857510913',NULL,2,2,'福建省晋江优兰发纸业有限公司','13906095618','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:17:41',NULL,NULL,NULL),('1212559635370807298','1211554636561956866',NULL,2,2,'泉州华祥纸业有限公司','13860748042','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:21:59',NULL,NULL,NULL),('1212559809627361282',NULL,NULL,2,1,NULL,'18659625552','087298','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:22:41',NULL,NULL,NULL),('1212560666200707073',NULL,NULL,2,1,NULL,'13860706464','585445','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:26:05',NULL,NULL,NULL),('1212562160929017857','1211805224986001409',NULL,2,2,'浩沙实业（福建）有限公司','13905089190','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:32:02',NULL,NULL,NULL),('1212564035850014721','1211851434828546050',NULL,2,2,'晋江纳创新环境技术有限公司','18150989333','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:39:29',NULL,NULL,NULL),('1212565841569189889','1211561316616028162',NULL,2,2,'福建盼盼饮料有限公司','15959993860','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:46:39',NULL,NULL,NULL),('1212566639665549314','1211539398999457793',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:49:49',NULL,NULL,NULL),('1212566741410975745','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:50:14',NULL,NULL,NULL),('1212566846541205506',NULL,NULL,2,1,NULL,'15359991222','760626','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:50:39',NULL,NULL,NULL),('1212566851574370305','1211171114114461697',NULL,2,2,'中轻（晋江）卫生用品研究有限公司','13520554703','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:50:40',NULL,NULL,NULL),('1212567963731824641','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:55:05',NULL,NULL,NULL),('1212568462732365825',NULL,NULL,2,1,NULL,'15359991222','861831','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:57:04',NULL,NULL,NULL),('1212568616738820098','1211543330165407746',NULL,2,2,'福建省咭咭文化传播有限公司','18698390251','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:57:41',NULL,NULL,NULL),('1212568780178264065',NULL,NULL,2,1,NULL,'18900300373','196333','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:58:20',NULL,NULL,NULL),('1212569088337973249',NULL,NULL,2,1,NULL,'18016655887','895941','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 10:59:33',NULL,NULL,NULL),('1212569357540986881',NULL,NULL,2,1,NULL,'18900300373','729574','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:00:37',NULL,NULL,NULL),('1212569840380874754',NULL,NULL,2,1,NULL,'18900300373','206374','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:02:33',NULL,NULL,NULL),('1212571769773297665','1211461407799820290',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:10:13',NULL,NULL,NULL),('1212571840698978305','1211576021401255937',NULL,2,2,'泉州鑫豪工程机械科技有限公司','18900399682','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:10:29',NULL,NULL,NULL),('1212571850417180674','1211446058115186690',NULL,2,2,'晋江新闻网有限公司','13625958406','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:10:32',NULL,NULL,NULL),('1212572465390227457',NULL,NULL,2,1,NULL,'18016655887','543325','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:12:58',NULL,NULL,NULL),('1212574079786225665','1211599500318130177',NULL,2,2,'深圳市安评信息咨询有限公司晋江分公司','18965723060','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:19:23',NULL,NULL,NULL),('1212574273311412225','1211610997505179649',NULL,2,2,'晋江市中西医结合医院','14759154723','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:20:09',NULL,NULL,NULL),('1212574531441463297','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:21:11',NULL,NULL,NULL),('1212574931636785154','1211562719606521857',NULL,2,2,'晋江市锦福化纤聚合有限公司','13625995436','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:22:46',NULL,NULL,NULL),('1212575284679741442','1211552596691566593',NULL,2,2,'福建海创医药科技有限公司','13559060707','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:24:11',NULL,NULL,NULL),('1212575297954713601',NULL,NULL,2,1,NULL,'13959757688','618140','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:24:14',NULL,NULL,NULL),('1212575759961493506','1211551476439105538',NULL,2,2,'冠达星股份有限公司','18959709952','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:26:04',NULL,NULL,NULL),('1212575960214343681','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:26:52',NULL,NULL,NULL),('1212576889764384769','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:30:33',NULL,NULL,NULL),('1212579397488414721',NULL,NULL,2,1,NULL,'13599295908','016800','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:40:31',NULL,NULL,NULL),('1212579881343324161','1211546940102197249',NULL,2,2,'晋江市金井中心卫生院','13959811363','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:42:27',NULL,NULL,NULL),('1212580494995165186','1211450215958102018',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:44:53',NULL,NULL,NULL),('1212581885000093698',NULL,NULL,2,1,NULL,'18698387555','998874','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 11:50:24',NULL,NULL,NULL),('1212603966777528321',NULL,NULL,2,1,NULL,'18065606507','094242','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 13:18:09',NULL,NULL,NULL),('1212619882936471554',NULL,NULL,2,1,NULL,'15959886256','817810','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:21:24',NULL,NULL,NULL),('1212621391849918466',NULL,NULL,2,1,NULL,'15905958858','050766','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:27:23',NULL,NULL,NULL),('1212622773491404801',NULL,NULL,2,1,NULL,'15905958858','165703','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:32:53',NULL,NULL,NULL),('1212623387025805314',NULL,NULL,2,1,NULL,'15959501581','927247','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:35:19',NULL,NULL,NULL),('1212624172430200833',NULL,NULL,2,1,NULL,'15905958858','301283','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:38:26',NULL,NULL,NULL),('1212626653230993409',NULL,NULL,2,1,NULL,'15905958858','077050','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:48:18',NULL,NULL,NULL),('1212626955136995329',NULL,NULL,2,1,NULL,'13805939056','627501','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:49:30',NULL,NULL,NULL),('1212627373850169345',NULL,NULL,2,1,NULL,'13905050770','235425','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:51:10',NULL,NULL,NULL),('1212628320135483394',NULL,NULL,2,1,NULL,'13805939056','453555','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:54:55',NULL,NULL,NULL),('1212629168924200962',NULL,NULL,2,1,NULL,'13805939056','481913','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 14:58:18',NULL,NULL,NULL),('1212630348152770561',NULL,NULL,2,1,NULL,'13805939056','249709','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:02:59',NULL,NULL,NULL),('1212632953952210946',NULL,NULL,2,1,NULL,'13805939056','271657','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:13:20',NULL,NULL,NULL),('1212634989305335810',NULL,NULL,2,1,NULL,'13805939056','088033','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:21:25',NULL,NULL,NULL),('1212636862968041474','1211574035113099265',NULL,2,2,'三六一度（中国）有限公司','18605007810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:28:52',NULL,NULL,NULL),('1212636949769162753','1211572731150123009',NULL,2,2,'三六一度（福建）体育用品有限公司','13625976298','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:29:13',NULL,NULL,NULL),('1212638737234726913','1211836173303988226',NULL,2,2,'福建陆地港集团有限责任公司','17759539230','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:36:19',NULL,NULL,NULL),('1212639258108563458','1211914077576675329',NULL,2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:38:23',NULL,NULL,NULL),('1212640003709014018',NULL,NULL,2,1,NULL,'17759539230','173174','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:41:21',NULL,NULL,NULL),('1212640303429783554',NULL,NULL,2,1,NULL,'17759539230','834904','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:42:32',NULL,NULL,NULL),('1212640860697595906','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','18815985118','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:44:45',NULL,NULL,NULL),('1212641474869530625','1212627500790779906',NULL,2,2,'福建省烨烽软件科技有限公司','13905050770','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:47:12',NULL,NULL,NULL),('1212642323586945026',NULL,NULL,2,1,NULL,'13489848301','316053','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:50:34',NULL,NULL,NULL),('1212643554803912705','1211459042799566850',NULL,2,2,'福建省晋江市三力机车有限公司','18965689935','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:55:27',NULL,NULL,NULL),('1212644252677378049','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:58:14',NULL,NULL,NULL),('1212644648292519938',NULL,NULL,2,1,NULL,'15392121201','431251','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 15:59:48',NULL,NULL,NULL),('1212647408102608898','1210918631014248450',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 16:10:46',NULL,NULL,NULL),('1212647984618082305','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 16:13:04',NULL,NULL,NULL),('1212648321013846018','1211098602777194497',NULL,2,2,'福建省诺美护理用品有限公司','13799487213','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 16:14:24',NULL,NULL,NULL),('1212649224638894082','1211100599215566849',NULL,2,2,'劲派经编科技有限公司','15859799211','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 16:17:59',NULL,NULL,NULL),('1212654393200021506',NULL,NULL,2,1,NULL,'13505959355','343817','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 16:38:32',NULL,NULL,NULL),('1212656556471029761',NULL,NULL,2,1,NULL,'13505959355','514962','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 16:47:07',NULL,NULL,NULL),('1212658410785411073','1211100599215566849',NULL,2,2,'劲派经编科技有限公司','15859799211','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 16:54:29',NULL,NULL,NULL),('1212661172763955201',NULL,NULL,2,1,NULL,'15757467502','746297','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:05:28',NULL,NULL,NULL),('1212661588100714498',NULL,NULL,2,1,NULL,'13599749329','663487','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:07:07',NULL,NULL,NULL),('1212661874059972610',NULL,NULL,2,1,NULL,'18698386676','299969','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:08:15',NULL,NULL,NULL),('1212662329775296514','1211475811404660738',NULL,2,2,'迦南（福建）新材料科技有限公司','18959995705','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:10:04',NULL,NULL,NULL),('1212662929728540674','1211110678463623169',NULL,2,2,'琪尔特股份有限公司','18859969666','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:12:27',NULL,NULL,NULL),('1212663017502740482','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:12:48',NULL,NULL,NULL),('1212663199657168898','1211117817491992577',NULL,2,2,'晋江泉荣远东水处理有限公司','15959596830','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:13:31',NULL,NULL,NULL),('1212664068503048194','1211164549680574466',NULL,2,2,'乔丹体育股份有限公司','18659597668','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:16:58',NULL,NULL,NULL),('1212664257599049729','1211167966465470465',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:17:43',NULL,NULL,NULL),('1212664567528755201',NULL,NULL,2,1,NULL,'13960372015','682829','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:18:57',NULL,NULL,NULL),('1212664582280122370',NULL,NULL,2,1,NULL,'18250638258','433488','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:19:01',NULL,NULL,NULL),('1212665249816186881',NULL,NULL,2,1,NULL,'13905969530','452472','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:21:40',NULL,NULL,NULL),('1212665345454706690',NULL,NULL,2,1,NULL,'18250638258','237808','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:22:03',NULL,NULL,NULL),('1212665435342835713',NULL,NULL,2,1,NULL,'15059830121','414796','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:22:24',NULL,NULL,NULL),('1212665852869021698',NULL,NULL,2,1,NULL,'13960372015','981450','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:24:04',NULL,NULL,NULL),('1212666477023399937',NULL,NULL,2,1,NULL,'13905969530','145880','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:26:33',NULL,NULL,NULL),('1212666699673833474',NULL,NULL,2,1,NULL,'13506943601','155091','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:27:26',NULL,NULL,NULL),('1212666974774038529',NULL,NULL,2,1,NULL,'15359996376','085985','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:28:31',NULL,NULL,NULL),('1212667108375203841','1211184671690436610',NULL,2,2,'泉州市里仁财务咨询有限公司','15880720190','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:29:03',NULL,NULL,NULL),('1212667241821179905','1211191315514109954',NULL,2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:29:35',NULL,NULL,NULL),('1212668386631290881','1211236784814534658',NULL,2,2,'晋江乐康医院有限公司','15109613666','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:34:08',NULL,NULL,NULL),('1212668640155996161','1211441648983130114',NULL,2,2,'兴业皮革科技股份有限公司','18859716647','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:35:08',NULL,NULL,NULL),('1212668985863114754','1211240519515090946',NULL,2,2,'晋江友峰鞋业有限公司','15306089555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:36:31',NULL,NULL,NULL),('1212669519055622146','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:38:38',NULL,NULL,NULL),('1212670350261817345','1211444939745968130',NULL,2,2,'晋江市安海镇卫生院','13799557721','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:41:56',NULL,NULL,NULL),('1212671049498431490','1211453814360555522',NULL,2,2,'伟志股份公司','15859813817','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:44:43',NULL,NULL,NULL),('1212671270475337729','1211454669394591746',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:45:35',NULL,NULL,NULL),('1212671299336343554',NULL,NULL,2,1,NULL,'18900300373','878552','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:45:42',NULL,NULL,NULL),('1212671490827292674','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:46:28',NULL,NULL,NULL),('1212671886668926977','1211456215943528450',NULL,2,2,'福建泉成机械有限公司','15392286115','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:48:02',NULL,NULL,NULL),('1212672494142558209','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:50:27',NULL,NULL,NULL),('1212672651198271490','1211457535089885185',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:51:05',NULL,NULL,NULL),('1212672735558307841','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:51:25',NULL,NULL,NULL),('1212673073401106433','1211459203080699905',NULL,2,2,'福建省育才建设发展有限公司','13788846820','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:52:45',NULL,NULL,NULL),('1212673486586187777','1211460115408928770',NULL,2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:54:24',NULL,NULL,NULL),('1212673601325568001','1211460552828698626',NULL,2,2,'雨中鸟（福建）户外用品有限公司','15880885350','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:54:51',NULL,NULL,NULL),('1212673825397870594','1211460918949494786',NULL,2,2,'大发科技集团有限公司','18959857088','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:55:45',NULL,NULL,NULL),('1212674062321520641','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:56:41',NULL,NULL,NULL),('1212674468363702273','1211467536848175106',NULL,2,2,'泉州市德玛特电机制造有限公司','15805969239','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:58:18',NULL,NULL,NULL),('1212674790716936194',NULL,NULL,2,1,NULL,'18900300373','673163','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:59:35',NULL,NULL,NULL),('1212674840230694913','1211467701302640642',NULL,2,2,'福建凤竹环保有限公司','13365978588','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 17:59:46',NULL,NULL,NULL),('1212674983701057538','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:00:21',NULL,NULL,NULL),('1212675262601302017','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:01:27',NULL,NULL,NULL),('1212675499956965378','1211476436687306754',NULL,2,2,'晋江裕福集团有限公司','18759429880','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:02:24',NULL,NULL,NULL),('1212675654600953858','1211479386717470722',NULL,2,2,'晋江盛雅新能源有限责任公司','13055667605','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:03:01',NULL,NULL,NULL),('1212676205485035521','1211479976335949826',NULL,2,2,'福建省晋江市兴达机电器材有限公司','18960355033','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:05:12',NULL,NULL,NULL),('1212676423827918850','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:06:04',NULL,NULL,NULL),('1212676742381113345','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:07:20',NULL,NULL,NULL),('1212676935000330242','1211484578443739137',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:08:06',NULL,NULL,NULL),('1212678628752560129','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:14:50',NULL,NULL,NULL),('1212680605611921409',NULL,NULL,2,1,NULL,'15159832652','716665','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:22:41',NULL,NULL,NULL),('1212685383318441986',NULL,NULL,2,1,NULL,'15960586523','442138','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:41:40',NULL,NULL,NULL),('1212688101676224513',NULL,NULL,2,1,NULL,'13860756932','825487','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 18:52:28',NULL,NULL,NULL),('1212690553527930882',NULL,NULL,2,1,NULL,'17350011170','137765','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 19:02:13',NULL,NULL,NULL),('1212692728492658690',NULL,NULL,2,1,NULL,'17350011170','958552','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 19:10:51',NULL,NULL,NULL),('1212723708947402753',NULL,NULL,2,1,NULL,'13505986964','242740','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 21:13:58',NULL,NULL,NULL),('1212730854774738945',NULL,NULL,2,1,NULL,'13599145737','392124','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 21:42:21',NULL,NULL,NULL),('1212731116650303489',NULL,NULL,2,1,NULL,'13505986964','230821','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 21:43:24',NULL,NULL,NULL),('1212733840515207169',NULL,NULL,2,1,NULL,'13955145737','715084','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 21:54:13',NULL,NULL,NULL),('1212734487650177025',NULL,NULL,2,1,NULL,'13955145737','157660','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 21:56:48',NULL,NULL,NULL),('1212734881696649218',NULL,NULL,2,1,NULL,'13599145737','141973','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-02',NULL,NULL,NULL,'2020-01-02 21:58:21',NULL,NULL,NULL),('1212890737876733953','1211460115408928770',NULL,2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:17:40',NULL,NULL,NULL),('1212891089552347137','1211489025517469698',NULL,2,2,'泉州星城纸业有限公司','15959856777','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:19:04',NULL,NULL,NULL),('1212896069139107842',NULL,NULL,2,1,NULL,'13959888172','435839','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:38:52',NULL,NULL,NULL),('1212898186146942977',NULL,NULL,2,1,NULL,'13788829369','845992','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:47:16',NULL,NULL,NULL),('1212898362530009090',NULL,NULL,2,1,NULL,'18698390251','613476','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:47:58',NULL,NULL,NULL),('1212898456197206018',NULL,NULL,2,1,NULL,'13788829369','119461','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:48:21',NULL,NULL,NULL),('1212899088912158721',NULL,NULL,2,1,NULL,'13850777672','247523','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:50:52',NULL,NULL,NULL),('1212900380808122370',NULL,NULL,2,1,NULL,'13489887652','467319','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 08:56:00',NULL,NULL,NULL),('1212901408559403009','64',NULL,1,2,'财政局','17362523273','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:05',NULL,NULL,NULL),('1212901429996490754','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901430462058498','58',NULL,1,2,'张荣荣','15280619456','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901430634024962','61',NULL,1,2,'叶志钦','17362523273','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901430818574337','62',NULL,1,2,'林曼雅','17362523273','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901430998929410','73',NULL,1,2,'张荣荣','15280619456','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901431187673089','74',NULL,1,2,'叶志钦','13675957398','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901431368028162','87',NULL,1,2,'叶志钦','13675957398','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901431544188929','89',NULL,1,2,'林曼雅','13799500668','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901431724544001','90',NULL,1,2,'丁煌权','13959757007','49,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:00:10',NULL,NULL,NULL),('1212901947577798658',NULL,NULL,2,1,NULL,'18606985861','509599','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:02:13',NULL,NULL,NULL),('1212903437780455426',NULL,NULL,2,1,NULL,'18606981162','237634','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:08:08',NULL,NULL,NULL),('1212905283089666049',NULL,NULL,2,1,NULL,'18959995205','492425','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:15:28',NULL,NULL,NULL),('1212905852982333441',NULL,NULL,2,1,NULL,'13505929732','546664','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:17:44',NULL,NULL,NULL),('1212906359943663617',NULL,NULL,2,1,NULL,'15359382970','434498','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:19:45',NULL,NULL,NULL),('1212908194003750913','1211491083737939970',NULL,2,2,'晋江市三福纺织实业有限公司','15959566799','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:27:02',NULL,NULL,NULL),('1212908975259979778','1212692778300018689',NULL,2,2,'晋江市路桥建设开发有限公司','17350011170','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:30:09',NULL,NULL,NULL),('1212909489783640066','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:32:11',NULL,NULL,NULL),('1212909649016197122','1212536999949438978',NULL,2,2,'晋江市医院晋南分院','15396486268','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:32:49',NULL,NULL,NULL),('1212909996921131010',NULL,NULL,2,1,NULL,'15359382970','470150','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:34:12',NULL,NULL,NULL),('1212910524367441921',NULL,NULL,2,1,NULL,'15750998817','856170','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:36:18',NULL,NULL,NULL),('1212910976295309313','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:38:06',NULL,NULL,NULL),('1212911300926050305','1211853076714012673',NULL,2,2,'晋江市永和镇卫生院','13959883141','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:39:23',NULL,NULL,NULL),('1212912817754148866','1211610997505179649',NULL,2,2,'晋江市中西医结合医院','14759154723','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:45:25',NULL,NULL,NULL),('1212914663713476610','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:52:45',NULL,NULL,NULL),('1212915116538925058','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:54:33',NULL,NULL,NULL),('1212915734737391618','1211494671642050561',NULL,2,2,'顺宏达（福建）针织服饰有限公司','15905907962','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:57:00',NULL,NULL,NULL),('1212915932821786625','1211546940102197249',NULL,2,2,'晋江市金井中心卫生院','13959811363','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:57:47',NULL,NULL,NULL),('1212916118755282946','1211495827340574722',NULL,2,2,'晋江市品质陶瓷建材有限公司','15106011992','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:58:32',NULL,NULL,NULL),('1212916189559328770','1212536999949438978',NULL,2,2,'晋江市医院晋南分院','15396486268','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:58:49',NULL,NULL,NULL),('1212916287110451202','1211497229303463938',NULL,2,2,'泉州市晋科技术检测有限公司','18960206656','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 09:59:12',NULL,NULL,NULL),('1212916494636224513','1211505228151570433',NULL,2,2,'晋江市陈埭中心卫生院','13905972257','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:00:01',NULL,NULL,NULL),('1212916692607373313','1211515979058692097',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:00:49',NULL,NULL,NULL),('1212917224877133826','1211525473977286657',NULL,2,2,'凯毅（福建）体育用品有限公司','18960357668','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:02:55',NULL,NULL,NULL),('1212917671708921857',NULL,NULL,2,1,NULL,'18759552098','229248','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:04:42',NULL,NULL,NULL),('1212922033948659713',NULL,NULL,2,1,NULL,'15359823950','105788','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:22:02',NULL,NULL,NULL),('1212923105282953218','1211601884993863681',NULL,2,2,'晋江市妇幼保健 院','13799233113','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:26:17',NULL,NULL,NULL),('1212924809181204481','1211816368236707842',NULL,2,2,'晋江市吉隆农业综合开发有限公司','18558994473','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'黑名单','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:33:04',NULL,NULL,NULL),('1212925244927447042',NULL,NULL,2,1,NULL,'15375873767','113034','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:34:48',NULL,NULL,NULL),('1212925450695806978','1211819923995672577',NULL,2,2,'福建省卓展信息科技股份有限公司','17350926157','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:35:37',NULL,NULL,NULL),('1212925758784212994','1211820100991107074',NULL,2,2,'福建星宏新材料科技有限公司','13805992036','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:36:50',NULL,NULL,NULL),('1212926315536125953','1211527239116570626',NULL,2,2,'泉州思力科电子科技有限公司','18959906986','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:39:03',NULL,NULL,NULL),('1212926626204028929','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:40:17',NULL,NULL,NULL),('1212926899626512385',NULL,NULL,2,1,NULL,'18905054972','212860','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:41:22',NULL,NULL,NULL),('1212927223636496386',NULL,NULL,2,1,NULL,'18905054972','794113','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:42:39',NULL,NULL,NULL),('1212927377701670913','1211528991136071681',NULL,2,2,'福建乐隆隆食品科技有限公司','15960551920','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:43:16',NULL,NULL,NULL),('1212927449801756673','1211837828162437121',NULL,2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:43:33',NULL,NULL,NULL),('1212927499542007810','1211533483709612033',NULL,2,2,'泉州正懋伟航纸业有限公司','18859791858','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:43:45',NULL,NULL,NULL),('1212927588922626049',NULL,NULL,2,1,NULL,'15106027935','273122','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:44:06',NULL,NULL,NULL),('1212927700214288386','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:44:33',NULL,NULL,NULL),('1212928003588296706','1211840469537964033',NULL,2,2,'福建省致慧医疗科技有限公司','19942826787','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:45:45',NULL,NULL,NULL),('1212928380949827586','1211851845316689922',NULL,2,2,'泉州威可赛机械科技有限公司','15880896188','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:47:15',NULL,NULL,NULL),('1212929013618642945',NULL,NULL,2,1,NULL,'15106027935','534293','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:49:46',NULL,NULL,NULL),('1212929561344413697',NULL,NULL,2,1,NULL,'13559568461','672239','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:51:57',NULL,NULL,NULL),('1212929709436899330',NULL,NULL,2,1,NULL,'15880713988','985558','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:52:32',NULL,NULL,NULL),('1212929724876132353',NULL,NULL,2,1,NULL,'18606984919','914919','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:52:36',NULL,NULL,NULL),('1212929814026063873','1211535199725207554',NULL,2,2,'福建亿龙建工有限公司','13506069172','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:52:57',NULL,NULL,NULL),('1212930650248646658','1211855307945328641',NULL,2,2,'福建好来屋食品工业有限公司','15160423086','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:56:16',NULL,NULL,NULL),('1212930892784275458','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:57:14',NULL,NULL,NULL),('1212931107343896578',NULL,NULL,2,1,NULL,'13559568461','822324','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:58:05',NULL,NULL,NULL),('1212931460311355394',NULL,NULL,2,1,NULL,'15960417947','505870','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:59:29',NULL,NULL,NULL),('1212931526283563009','1211923801521045506',NULL,2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 10:59:45',NULL,NULL,NULL),('1212931832513892353','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:00:58',NULL,NULL,NULL),('1212931986126082049',NULL,NULL,2,1,NULL,'13615912594','280883','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:01:35',NULL,NULL,NULL),('1212932427182313473',NULL,NULL,2,1,NULL,'15960417947','036405','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:03:20',NULL,NULL,NULL),('1212934103129722881',NULL,NULL,2,1,NULL,'15375873767','622468','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:10:00',NULL,NULL,NULL),('1212934379442081793','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:11:05',NULL,NULL,NULL),('1212934521419272193',NULL,NULL,2,1,NULL,'13625952299','223939','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:11:39',NULL,NULL,NULL),('1212937656619569154','1212023228055228418',NULL,2,2,'晋江市永建皮革制品有限公司','13599218888','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:24:07',NULL,NULL,NULL),('1212939363827126274','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:30:54',NULL,NULL,NULL),('1212939894289141762','1211945706491789313',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:33:00',NULL,NULL,NULL),('1212941000452935681','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:37:24',NULL,NULL,NULL),('1212943016092831746','1211543330165407746',NULL,2,2,'福建省咭咭文化传播有限公司','18698390251','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:45:25',NULL,NULL,NULL),('1212943296586911746',NULL,NULL,2,1,NULL,'15375873767','114873','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:46:31',NULL,NULL,NULL),('1212943327784144898','1212549344071323649',NULL,2,2,'福建久晴科技有限公司','18150596289','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:46:39',NULL,NULL,NULL),('1212943565328551938','1211552596691566593',NULL,2,2,'福建海创医药科技有限公司','13559060707','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:47:36',NULL,NULL,NULL),('1212944377677156353','1212369915563020289',NULL,2,2,'晋江市保骏行汽车维修服务有限公司','13275951100','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:50:49',NULL,NULL,NULL),('1212944607256580098','1212198922987048961',NULL,2,2,'晋江市远祥服装织造有限公司','17759990690','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:51:44',NULL,NULL,NULL),('1212944977110306818','1212540840212238338',NULL,2,2,'福建省信拓建设发展有限公司','18905078173','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:53:12',NULL,NULL,NULL),('1212946369963167746','1211554636561956866',NULL,2,2,'泉州华祥纸业有限公司','13860748042','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:58:44',NULL,NULL,NULL),('1212946635626188802','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 11:59:48',NULL,NULL,NULL),('1212947144441401345','1212665763958165505',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 12:01:49',NULL,NULL,NULL),('1212950629366960130',NULL,NULL,2,1,NULL,'13110801508','438192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 12:15:40',NULL,NULL,NULL),('1212981477566910466',NULL,NULL,2,1,NULL,'18050996325','524788','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:18:15',NULL,NULL,NULL),('1212988160401805314','1211494978245672962',NULL,2,2,'福建省德腾智能科技有限公司','18050996325','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:44:48',NULL,NULL,NULL),('1212988957873213442','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:47:58',NULL,NULL,NULL),('1212989027830009857','1211561316616028162',NULL,2,2,'福建盼盼饮料有限公司','15959993860','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:48:15',NULL,NULL,NULL),('1212989191172984834','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:48:54',NULL,NULL,NULL),('1212989352607551489','1211576021401255937',NULL,2,2,'泉州鑫豪工程机械科技有限公司','18900399682','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:49:32',NULL,NULL,NULL),('1212989358034980866',NULL,NULL,2,1,NULL,'13960496669','984054','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:49:33',NULL,NULL,NULL),('1212989521633808386','1211599500318130177',NULL,2,2,'深圳市安评信息咨询有限公司晋江分公司','18965723060','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:50:12',NULL,NULL,NULL),('1212991950362316801','1211836173303988226',NULL,2,2,'福建陆地港集团有限责任公司','17759539230','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 14:59:51',NULL,NULL,NULL),('1212993826986201090',NULL,NULL,2,1,NULL,'13599145737','919270','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:07:19',NULL,NULL,NULL),('1212994220869095426','1211914077576675329',NULL,2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:08:53',NULL,NULL,NULL),('1212995107553349634','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:12:24',NULL,NULL,NULL),('1212995734530494465','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:14:54',NULL,NULL,NULL),('1212996129218695170',NULL,NULL,2,1,NULL,'18250155553','731440','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:16:28',NULL,NULL,NULL),('1212996474510577666','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:17:50',NULL,NULL,NULL),('1213000839476613121','1212910689362972674',NULL,2,2,'福建盛达机器股份公司','15359382970','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:35:11',NULL,NULL,NULL),('1213003361478053890','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','18815985118','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:45:12',NULL,NULL,NULL),('1213006694200709121',NULL,NULL,2,1,NULL,'18659568811','339869','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 15:58:27',NULL,NULL,NULL),('1213007572433440770','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 16:01:56',NULL,NULL,NULL),('1213007882681913346','1212922386479910913',NULL,2,2,'中桥文化传媒（福建）股份有限公司','15359823950','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 16:03:10',NULL,NULL,NULL),('1213016314155700225',NULL,NULL,2,1,NULL,'13805992036','859394','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 16:36:40',NULL,NULL,NULL),('1213017203318788097',NULL,NULL,2,1,NULL,'13805992036','481596','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 16:40:12',NULL,NULL,NULL),('1213018902414561282','1212195053699665922',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 16:46:57',NULL,NULL,NULL),('1213019871730798593','1212201267179360257',NULL,2,2,'福州建通工程试验检测有限公司泉州分公司','13559591215','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 16:50:48',NULL,NULL,NULL),('1213030293330530305','1213024890861457409',NULL,2,2,'福建省晋江市兴达机电器材有限公司','18960355033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 17:32:13',NULL,NULL,NULL),('1213030629780819969',NULL,NULL,2,1,NULL,'13805951471','329667','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 17:33:33',NULL,NULL,NULL),('1213030792792444930',NULL,NULL,2,1,NULL,'13400808814','880044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 17:34:12',NULL,NULL,NULL),('1213030998204289025',NULL,NULL,2,1,NULL,'13805951471','794346','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 17:35:01',NULL,NULL,NULL),('1213032093102182402',NULL,NULL,2,1,NULL,'15959508318','847227','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 17:39:22',NULL,NULL,NULL),('1213050408323321858',NULL,NULL,2,1,NULL,'18965183911','610616','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 18:52:09',NULL,NULL,NULL),('1213065841378136065',NULL,NULL,2,1,NULL,'15059570222','754849','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 19:53:28',NULL,NULL,NULL),('1213067284029968385',NULL,NULL,2,1,NULL,'15059570222','721513','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 19:59:12',NULL,NULL,NULL),('1213097772358635522',NULL,NULL,2,1,NULL,'13960259639','824638','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 22:00:21',NULL,NULL,NULL),('1213100226479460354',NULL,NULL,2,1,NULL,'13960259639','087277','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-03',NULL,NULL,NULL,'2020-01-03 22:10:06',NULL,NULL,NULL),('1213273972439846914',NULL,NULL,2,1,NULL,'17758709290','808982','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 09:40:31',NULL,NULL,NULL),('1213277476243968001',NULL,NULL,2,1,NULL,'15905054477','977008','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 09:54:26',NULL,NULL,NULL),('1213279316444516354',NULL,NULL,2,1,NULL,'13599257966','033500','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 10:01:45',NULL,NULL,NULL),('1213282046076588034',NULL,NULL,2,1,NULL,'13599257966','236209','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 10:12:36',NULL,NULL,NULL),('1213309480515735553',NULL,NULL,2,1,NULL,'13559554933','224495','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 12:01:37',NULL,NULL,NULL),('1213341118700261377',NULL,NULL,2,1,NULL,'13489858089','829984','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 14:07:20',NULL,NULL,NULL),('1213345540230680577',NULL,NULL,2,1,NULL,'13030981560','029811','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 14:24:54',NULL,NULL,NULL),('1213359837954510850',NULL,NULL,2,1,NULL,'13205957447','491521','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 15:21:43',NULL,NULL,NULL),('1213375780973776898',NULL,NULL,2,1,NULL,'15805967556','071711','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 16:25:04',NULL,NULL,NULL),('1213380863782359041',NULL,NULL,2,1,NULL,'18960276085','705500','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 16:45:16',NULL,NULL,NULL),('1213447534073155585',NULL,NULL,2,1,NULL,'13665987766','084679','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 21:10:11',NULL,NULL,NULL),('1213450791109595138',NULL,NULL,2,1,NULL,'13665987766','631536','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 21:23:08',NULL,NULL,NULL),('1213451078708826114',NULL,NULL,2,1,NULL,'13665987766','179081','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-04',NULL,NULL,NULL,'2020-01-04 21:24:16',NULL,NULL,NULL),('1213501286230548481',NULL,NULL,2,1,NULL,'18372551198','240096','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 00:43:37',NULL,NULL,NULL),('1213506342090735618',NULL,NULL,2,1,NULL,'18372551198','060252','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 01:03:42',NULL,NULL,NULL),('1213506364370878466',NULL,NULL,2,1,NULL,'18372551198','713335','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 01:03:57',NULL,NULL,NULL),('1213509115389693954',NULL,NULL,2,1,NULL,'19971782113','804088','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 01:14:43',NULL,NULL,NULL),('1213509400212295682','1213509309745352706',NULL,2,2,'adada','19971782113','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 01:16:01',NULL,NULL,NULL),('1213635455661133825',NULL,NULL,2,1,NULL,'13906932889','437243','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 09:36:55',NULL,NULL,NULL),('1213638914854637569',NULL,NULL,2,1,NULL,'13906932889','606277','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 09:50:40',NULL,NULL,NULL),('1213697636704473090',NULL,NULL,2,1,NULL,'18859760088','264690','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 13:44:00',NULL,NULL,NULL),('1213734010719588353',NULL,NULL,2,1,NULL,'13808516919','265045','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 16:08:32',NULL,NULL,NULL),('1213736322720616450',NULL,NULL,2,1,NULL,'13808516919','294758','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 16:17:44',NULL,NULL,NULL),('1213748287438344194',NULL,NULL,2,1,NULL,'15059882658','778407','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 17:05:16',NULL,NULL,NULL),('1213843694029918210',NULL,NULL,2,1,NULL,'17750799505','809044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-05',NULL,NULL,NULL,'2020-01-05 23:24:23',NULL,NULL,NULL),('1213973441196085250',NULL,NULL,2,1,NULL,'13808558152','849917','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 07:59:57',NULL,NULL,NULL),('1213981213581135874','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:30:50',NULL,NULL,NULL),('1213981283173027842','1212561377781157890',NULL,2,2,'泉州育英服装有限公司','13860706464','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:31:07',NULL,NULL,NULL),('1213981310167568385','1212568548061286401',NULL,2,2,'贵人鸟股份有限公司','15359991222','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:31:13',NULL,NULL,NULL),('1213983025021341697','1213844233778122754',NULL,2,2,'泉州市一听文化艺术有限公司','17750799505','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:38:02',NULL,NULL,NULL),('1213983546419466242','1213748424076185601',NULL,2,2,'心赢销服装（福建）有限公司','15059882658','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:40:06',NULL,NULL,NULL),('1213983830122188802','1213736612547022850',NULL,2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:41:14',NULL,NULL,NULL),('1213984020975603713','1213698480367751170',NULL,2,2,'福建龙峰纺织科技实业有限公司','18859760088','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:41:59',NULL,NULL,NULL),('1213986450509418498','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:51:39',NULL,NULL,NULL),('1213986703803437057','1213381203172855810',NULL,2,2,'晋江市隆盛针织印染有限公司','18960276085','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:52:39',NULL,NULL,NULL),('1213987091512315906',NULL,NULL,2,1,NULL,'18016623555','945294','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:54:12',NULL,NULL,NULL),('1213987780258975746','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:56:56',NULL,NULL,NULL),('1213988178424254465','1213310396123910145',NULL,2,2,'晋江市第三医院','13559554933','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 08:58:31',NULL,NULL,NULL),('1213990240184717313','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:06:42',NULL,NULL,NULL),('1213990828708483074','1213274113339101185',NULL,2,2,'福建省群策环境检测有限公司','17758709290','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:09:03',NULL,NULL,NULL),('1213991037316386818','1213032291266269186',NULL,2,2,'福建优安纳伞业科技有限公司','15959508318','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'未知错误','2020-01-06',NULL,NULL,NULL,'2020-01-06 09:09:52',NULL,NULL,NULL),('1213995207121457154',NULL,NULL,2,1,NULL,'18050911980','760297','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:26:26',NULL,NULL,NULL),('1213996617250656257','1213031390673702913',NULL,2,2,'海峡（晋江）伞业科技有限公司','13400808814','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:32:03',NULL,NULL,NULL),('1213999272488357890','1213050734480789505',NULL,2,2,'晋江市梓源农业发展有限公司','18965183911','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:42:36',NULL,NULL,NULL),('1213999294034497538','1213050734480789505',NULL,2,2,'晋江市梓源农业发展有限公司','18965183911','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:42:41',NULL,NULL,NULL),('1213999846185259009','1213031116903092226',NULL,2,2,'泉州市澳兴织造服装有限公司','13805951471','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:44:53',NULL,NULL,NULL),('1214000361996570625','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:46:55',NULL,NULL,NULL),('1214000695515041794','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:48:15',NULL,NULL,NULL),('1214001130959294465','1212661969526525954',NULL,2,2,'福建正麒高纤科技股份有限公司','18698386676','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:49:59',NULL,NULL,NULL),('1214001411944108034','1212644982180089858',NULL,2,2,'福建省华晟建设发展有限公司','15392121201','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:51:06',NULL,NULL,NULL),('1214001433314086913','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18065606507','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:51:11',NULL,NULL,NULL),('1214001716467355650','1212620045818073089',NULL,2,2,'晋江市达胜纺织实业有限公司','15959886256','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:52:18',NULL,NULL,NULL),('1214002318316425217','1212623502012649474',NULL,2,2,'福建省纳金网信息技术有限公司','15959501581','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:54:42',NULL,NULL,NULL),('1214002606662242306','1212620045818073089',NULL,2,2,'晋江市达胜纺织实业有限公司','15959886256','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:55:51',NULL,NULL,NULL),('1214002698785935361','1212626739503632385',NULL,2,2,'晋江宏基机械有限公司','15905958858','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:56:13',NULL,NULL,NULL),('1214002938091950081','1212626739503632385',NULL,2,2,'晋江宏基机械有限公司','15905958858','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:57:10',NULL,NULL,NULL),('1214003225884119042','1212903777946898433',NULL,2,2,'福建兴翼机械有限公司','18606981162','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:58:18',NULL,NULL,NULL),('1214003628017209346','1212951182637600770',NULL,2,2,'泉州禧余商贸有限公司','13110801508','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 09:59:54',NULL,NULL,NULL),('1214004284723580930','1212935665344385025',NULL,2,2,'福建省晋江市新联兴汽车用品有限公司','13625952299','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:02:31',NULL,NULL,NULL),('1214004628505513985','1212930279740608514',NULL,2,2,'福建省晋江市华宇织造有限公司','18606984919','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:03:53',NULL,NULL,NULL),('1214005504586567681','1212930369930727426',NULL,2,2,'福建正扬科技股份有限公司','15880713988','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:07:22',NULL,NULL,NULL),('1214005807054606337','1212897074375364610',NULL,2,2,'泉州森地客体育用品有限公司','13959888172','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:08:34',NULL,NULL,NULL),('1214005997194989570','1212731840222269441',NULL,2,2,'福建中策光电股份公司','13505986964','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:09:19',NULL,NULL,NULL),('1214006020158803969','1212666223108624386',NULL,2,2,'晋江市圣飞伞业科技有限公司','13960372015','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:09:25',NULL,NULL,NULL),('1214006287059144706','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:10:28',NULL,NULL,NULL),('1214006492445822977',NULL,NULL,2,1,NULL,'17362523273','181082','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:11:17',NULL,NULL,NULL),('1214006871027896322','1211892702682071041',NULL,2,2,'福建省晋江万利瓷业有限公司','18859989399','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:12:47',NULL,NULL,NULL),('1214007020953292801','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:13:23',NULL,NULL,NULL),('1214007404631445505',NULL,NULL,2,1,NULL,'15905970382','787020','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:14:55',NULL,NULL,NULL),('1214007463360090114','1212675031784558593',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:15:09',NULL,NULL,NULL),('1214007743308910593','1212688284107476994',NULL,2,2,'晋江市成达齿轮有限公司','13860756932','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:16:15',NULL,NULL,NULL),('1214008057764270082','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:17:30',NULL,NULL,NULL),('1214009308308590594','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:22:28',NULL,NULL,NULL),('1214009485975113730','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:23:11',NULL,NULL,NULL),('1214009809087516674','1211444027140915202',NULL,2,2,'福建省万物智联科技有限公司','18559275265','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:24:28',NULL,NULL,NULL),('1214011228079280129','1212929090869334017',NULL,2,2,'福建省晋江市辉源建材物资有限公司','15106027935','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:30:06',NULL,NULL,NULL),('1214012098800013313',NULL,NULL,2,1,NULL,'15959851616','913264','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:33:34',NULL,NULL,NULL),('1214014633493417986',NULL,NULL,2,1,NULL,'15080238126','641881','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:43:38',NULL,NULL,NULL),('1214015838718283777','1212666561777700865',NULL,2,2,'锦兴（福建）化纤纺织实业有限公司','13905969530','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:48:25',NULL,NULL,NULL),('1214016280760176642',NULL,NULL,2,1,NULL,'15080238126','700101','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:50:11',NULL,NULL,NULL),('1214016487816187905','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:51:00',NULL,NULL,NULL),('1214016621270552578',NULL,NULL,2,1,NULL,'17706075999','754624','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:51:32',NULL,NULL,NULL),('1214016773347627010',NULL,NULL,2,1,NULL,'13505925273','950760','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:52:08',NULL,NULL,NULL),('1214017131725737986','1213007171541864449',NULL,2,2,'福建省兆亨科技有限公司','18659568811','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:53:34',NULL,NULL,NULL),('1214017187598061570',NULL,NULL,2,1,NULL,'18050888018','422354','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:53:47',NULL,NULL,NULL),('1214017506780401666','1213067533700108289',NULL,2,2,'晋江市锦马汽车检验有限公司','15059570222','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:55:03',NULL,NULL,NULL),('1214017586618978306','1212906675946721282',NULL,2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:55:22',NULL,NULL,NULL),('1214018019936718849','1214017346281164801',NULL,2,2,'晋江富海鸿汽车贸易有限公司','18050888018','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:57:05',NULL,NULL,NULL),('1214018255979565057',NULL,NULL,2,1,NULL,'13505925273','335284','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:58:02',NULL,NULL,NULL),('1214018297280876546',NULL,NULL,2,1,NULL,'15080238126','232111','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:58:12',NULL,NULL,NULL),('1214018477547868161',NULL,NULL,2,1,NULL,'15959851616','189128','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 10:58:55',NULL,NULL,NULL),('1214019430422433793',NULL,NULL,2,1,NULL,'15959851616','204601','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:02:42',NULL,NULL,NULL),('1214020097908166657',NULL,NULL,2,1,NULL,'15960785858','789984','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:05:21',NULL,NULL,NULL),('1214020510988390401',NULL,NULL,2,1,NULL,'13489858089','337799','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:06:59',NULL,NULL,NULL),('1214020740777529346',NULL,NULL,2,1,NULL,'18259591998','315780','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:07:54',NULL,NULL,NULL),('1214021120852774913',NULL,NULL,2,1,NULL,'15959851616','795192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:09:25',NULL,NULL,NULL),('1214021633593856001',NULL,NULL,2,1,NULL,'15959851616','734922','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:11:27',NULL,NULL,NULL),('1214022655519248386',NULL,NULL,2,1,NULL,'19905050771','876758','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:15:31',NULL,NULL,NULL),('1214023627251404802','1212932412644855809',NULL,2,2,'泉州新华都购物广场有限公司晋江万隆店','13615912594','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:19:22',NULL,NULL,NULL),('1214025433499062273',NULL,NULL,2,1,NULL,'13489858089','853488','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:26:33',NULL,NULL,NULL),('1214025482798911489',NULL,NULL,2,1,NULL,'15959851616','084499','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:26:45',NULL,NULL,NULL),('1214027593230077953','1214018323050680321',NULL,2,2,'晋江市新兴机动车服务有限公司','13505925273','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:35:08',NULL,NULL,NULL),('1214029597474050050','1212996449227313153',NULL,2,2,'晋江闽古食品有限公司','18250155553','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:43:06',NULL,NULL,NULL),('1214030886480138242','1212540446794911745',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 11:48:13',NULL,NULL,NULL),('1214041583096188930',NULL,NULL,2,1,NULL,'19905050771','301600','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 12:30:43',NULL,NULL,NULL),('1214052621225054209',NULL,NULL,2,1,NULL,'15905970382','499473','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 13:14:35',NULL,NULL,NULL),('1214074959551287297',NULL,NULL,2,1,NULL,'18106990767','219553','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 14:43:21',NULL,NULL,NULL),('1214076272313913345',NULL,NULL,2,1,NULL,'18106990767','181502','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 14:48:34',NULL,NULL,NULL),('1214078705601630210',NULL,NULL,2,1,NULL,'18106990767','448773','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 14:58:14',NULL,NULL,NULL),('1214080757308346370','1213360496950972418',NULL,2,2,'泉州市洋铭雕塑科技有限公司','13205957447','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:06:23',NULL,NULL,NULL),('1214081246796206081','1213639355004899330',NULL,2,2,'晋江市中特教育咨询有限公司','13906932889','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:08:20',NULL,NULL,NULL),('1214081500849393665',NULL,NULL,2,1,NULL,'13506956621','333713','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:09:21',NULL,NULL,NULL),('1214082842284281858','1214025654970896386',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:14:40',NULL,NULL,NULL),('1214083602845814786','1213376299297476609',NULL,2,2,'福建省建设发展有限公司','15805967556','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:17:42',NULL,NULL,NULL),('1214083877212016642',NULL,NULL,2,1,NULL,'15805972719','584200','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:18:47',NULL,NULL,NULL),('1214083911081021442','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:18:55',NULL,NULL,NULL),('1214084416314298369','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:20:56',NULL,NULL,NULL),('1214084789330530305','1214082730300559362',NULL,2,2,'晋江市英林镇中心卫生院','13506956621','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:22:25',NULL,NULL,NULL),('1214085897725693954','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:26:49',NULL,NULL,NULL),('1214087571051663361','1214079030446280705',NULL,2,2,'摩尔工业设计（晋江）有限公司','18106990767','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:33:28',NULL,NULL,NULL),('1214089926929305602',NULL,NULL,2,1,NULL,'13960305977','413511','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:42:49',NULL,NULL,NULL),('1214092138980069378',NULL,NULL,2,1,NULL,'15080238126','353932','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 15:51:37',NULL,NULL,NULL),('1214097366131429377','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:12:23',NULL,NULL,NULL),('1214097415271895041',NULL,NULL,2,1,NULL,'13960315655','463229','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:12:35',NULL,NULL,NULL),('1214097447987466241','1214068783157628929',NULL,2,2,'福建优安纳伞业科技有限公司','15959508318','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-01-06',NULL,NULL,NULL,'2020-01-06 16:12:43',NULL,NULL,NULL),('1214100934020321281','1214090141543452674',NULL,2,2,'晋江海川市政园林工程有限公司','13960305977','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:26:34',NULL,NULL,NULL),('1214102885789356034','1214090141543452674',NULL,2,2,'晋江海川市政园林工程有限公司','13960305977','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:34:19',NULL,NULL,NULL),('1214104226779648002','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:39:39',NULL,NULL,NULL),('1214104921373167617','1213987181866012674',NULL,2,2,'晋江集成轻工有限公司','18016623555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:42:24',NULL,NULL,NULL),('1214105170414161922','1213100306318036993',NULL,2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:43:24',NULL,NULL,NULL),('1214105835794354177',NULL,NULL,2,1,NULL,'13850777672','298641','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:46:02',NULL,NULL,NULL),('1214108708905177090','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:57:27',NULL,NULL,NULL),('1214109133930778625','1214106170453676034',NULL,2,2,'晋江丰顺食品有限公司','13850777672','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 16:59:09',NULL,NULL,NULL),('1214113851008634882',NULL,NULL,2,1,NULL,'18105050548','374827','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:17:53',NULL,NULL,NULL),('1214116294115217409','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:27:36',NULL,NULL,NULL),('1214116784253194241','1213376299297476609',NULL,2,2,'福建省建设发展有限公司','15805967556','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:29:33',NULL,NULL,NULL),('1214116805757390849','1213376299297476609',NULL,2,2,'福建省建设发展有限公司','15805967556','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:29:38',NULL,NULL,NULL),('1214117371099238402','1214114379507716097',NULL,2,2,'泉州市珍优鲜食品工贸有限公司','18105050548','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:31:53',NULL,NULL,NULL),('1214117699399995393',NULL,NULL,2,1,NULL,'13860256299','543611','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:33:11',NULL,NULL,NULL),('1214117799937462274','1213376299297476609',NULL,2,2,'福建省海峡建设发展有限公司','15805967556','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:33:35',NULL,NULL,NULL),('1214117939410653186',NULL,NULL,2,1,NULL,'17750792370','394042','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:34:08',NULL,NULL,NULL),('1214117980317700098',NULL,NULL,2,1,NULL,'13960256299','039190','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:34:18',NULL,NULL,NULL),('1214118421302628353','1213031390673702913',NULL,2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:36:03',NULL,NULL,NULL),('1214118683136249858',NULL,NULL,2,1,NULL,'13960256299','660851','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:37:05',NULL,NULL,NULL),('1214118692627959810','1212935665344385025',NULL,2,2,'福建省晋江市新联兴汽车用品有限公司','13625952299','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:37:08',NULL,NULL,NULL),('1214119124641271809','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:38:51',NULL,NULL,NULL),('1214119352601694209','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:39:45',NULL,NULL,NULL),('1214119727882850306',NULL,NULL,2,1,NULL,'13960256299','697310','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:41:15',NULL,NULL,NULL),('1214119813291462657',NULL,NULL,2,1,NULL,'18050998195','779452','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:41:35',NULL,NULL,NULL),('1214120798420226049','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:45:30',NULL,NULL,NULL),('1214121423367327746',NULL,NULL,2,1,NULL,'13960256299','733363','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:47:59',NULL,NULL,NULL),('1214123281246867458',NULL,NULL,2,1,NULL,'13960256266','718782','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:55:22',NULL,NULL,NULL),('1214123581156380673',NULL,NULL,2,1,NULL,'13960256266','450619','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:56:33',NULL,NULL,NULL),('1214123853056331778',NULL,NULL,2,1,NULL,'13960256299','776832','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 17:57:38',NULL,NULL,NULL),('1214141405870444545',NULL,NULL,2,1,NULL,'13328567990','158995','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 19:07:23',NULL,NULL,NULL),('1214154244093923329',NULL,NULL,2,1,NULL,'18859987377','105246','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-01-06',NULL,NULL,NULL,'2020-01-06 19:58:24',NULL,NULL,NULL),('1214183035365314561',NULL,NULL,2,1,NULL,'18965183911','241477','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-06',NULL,NULL,NULL,'2020-01-06 21:52:48',NULL,NULL,NULL),('1214185439318069250',NULL,NULL,2,1,NULL,'18759442340','954791','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-06',NULL,NULL,NULL,'2020-01-06 22:02:21',NULL,NULL,NULL),('1214342402710523906','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:04',NULL,NULL,NULL),('1214342424533487617','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:10',NULL,NULL,NULL),('1214342424999055361','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:10',NULL,NULL,NULL),('1214342425380737025','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'发送条数超限制','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:10',NULL,NULL,NULL),('1214342425846304770','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'发送条数超限制','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:10',NULL,NULL,NULL),('1214342429264662529','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'发送条数超限制','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:11',NULL,NULL,NULL),('1214342429696675842','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'发送条数超限制','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:11',NULL,NULL,NULL),('1214342430128689153','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'发送条数超限制','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:11',NULL,NULL,NULL),('1214342430535536641','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'发送条数超限制','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:26:11',NULL,NULL,NULL),('1214345559167553537','1211150098789150721',NULL,2,2,'泉州永实工程质量检测有限公司','18396220746','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:38:37',NULL,NULL,NULL),('1214345745398845441','1211120827064496130',NULL,2,2,'泉州市至真工具科技有限公司','13313825373','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:39:21',NULL,NULL,NULL),('1214345771873292290','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:39:28',NULL,NULL,NULL),('1214346113201557505','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:40:49',NULL,NULL,NULL),('1214346116460531714','1211104782702456833',NULL,2,2,'晋江市星工场教育咨询有限公司','13599496037','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:40:50',NULL,NULL,NULL),('1214346358090190850','1211177535560331265',NULL,2,2,'晋江市凯鑫汽配有限责任公司','15959556399','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:41:47',NULL,NULL,NULL),('1214346622553640962','1214123943149981698',NULL,2,2,'福建帝霖食品有限公司','13960256299','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:42:50',NULL,NULL,NULL),('1214347124943179777','1214120061220966402',NULL,2,2,'北京同辉知识产权代理事务所（普通合伙）泉州分所','18050998195','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:44:50',NULL,NULL,NULL),('1214347536920301569','1214118511954120705',NULL,2,2,'泉州协创知识产权代理事务所（普通合伙）','17750792370','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:46:28',NULL,NULL,NULL),('1214348461093244930','1214092357348118529',NULL,2,2,'福建绿涛市政园林工程有限公司晋江分公司','15080238126','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:50:09',NULL,NULL,NULL),('1214349253770563585','1212734981810491393',NULL,2,2,'福建省闽楚建设工程有限公司晋江分公司','13599145737','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 08:53:18',NULL,NULL,NULL),('1214352014172049409','1211466629175623682',NULL,2,2,'福建省杰泰建设发展有限公司','18250413746','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:04:16',NULL,NULL,NULL),('1214352186872516609','1211467512697372673',NULL,2,2,'晋江市万达汽车贸易有限公司','13489887652','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:04:57',NULL,NULL,NULL),('1214352405404143617','1211471774600970241',NULL,2,2,'泉州鸿展模具制造有限公司','18959708027','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:05:49',NULL,NULL,NULL),('1214353547475374081','1211505228151570433',NULL,2,2,'晋江市陈埭中心卫生院','13905972257','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:10:21',NULL,NULL,NULL),('1214355850089549825','1212906675946721282',NULL,2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:19:30',NULL,NULL,NULL),('1214357607158992897','1211538270857510913',NULL,2,2,'福建省晋江优兰发纸业有限公司','13906095618','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:26:29',NULL,NULL,NULL),('1214360617801043969','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:38:27',NULL,NULL,NULL),('1214361657229266945','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 09:42:35',NULL,NULL,NULL),('1214366393588338690',NULL,NULL,2,1,NULL,'15959851616','982680','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:01:24',NULL,NULL,NULL),('1214369130656911361',NULL,NULL,2,1,NULL,'13599719905','819590','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:12:17',NULL,NULL,NULL),('1214369285443506177',NULL,NULL,2,1,NULL,'13850772783','577596','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:12:54',NULL,NULL,NULL),('1214369900735320065',NULL,NULL,2,1,NULL,'13959713700','682013','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:15:20',NULL,NULL,NULL),('1214372178712154113',NULL,NULL,2,1,NULL,'13959713700','478434','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:24:24',NULL,NULL,NULL),('1214372507155517442',NULL,NULL,2,1,NULL,'15959851616','156981','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:25:42',NULL,NULL,NULL),('1214373576057114626','1213310396123910145',NULL,2,2,'晋江市第三医院','13559554933','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:29:57',NULL,NULL,NULL),('1214375259461996545',NULL,NULL,2,1,NULL,'13950116705','584926','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:36:38',NULL,NULL,NULL),('1214378695783960578','1214372276024201217',NULL,2,2,'泉州市红桥民间资本管理股份有限公司','13959713700','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:50:17',NULL,NULL,NULL),('1214380470767276033',NULL,NULL,2,1,NULL,'15860304280','911810','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 10:57:20',NULL,NULL,NULL),('1214404277049561090',NULL,NULL,2,1,NULL,'13799225181','854434','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 12:31:56',NULL,NULL,NULL),('1214419838630432769',NULL,NULL,2,1,NULL,'18859951871','810856','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 13:33:47',NULL,NULL,NULL),('1214424239306772481',NULL,NULL,2,1,NULL,'18859951871','402828','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 13:51:16',NULL,NULL,NULL),('1214425604695330817',NULL,NULL,2,1,NULL,'19959711592','270764','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 13:56:41',NULL,NULL,NULL),('1214439215501217794','1214369748926681089',NULL,2,2,'福建晋江营边异形石业有限公司','13850772783','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 14:50:46',NULL,NULL,NULL),('1214440530830757889','1211104782702456833',NULL,2,2,'晋江市星工场教育咨询有限公司','13599496037','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 14:56:00',NULL,NULL,NULL),('1214442019074674690','1212929090869334017',NULL,2,2,'福建省晋江市辉源建材物资有限公司','15106027935','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:01:55',NULL,NULL,NULL),('1214442332900888577','1212951182637600770',NULL,2,2,'泉州禧余商贸有限公司','13110801508','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:03:10',NULL,NULL,NULL),('1214443057848586241',NULL,NULL,2,1,NULL,'18876398522','333515','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:06:02',NULL,NULL,NULL),('1214446283595517953','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:18:51',NULL,NULL,NULL),('1214447065220845569',NULL,NULL,2,1,NULL,'18876398522','672044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:21:58',NULL,NULL,NULL),('1214447599759724546','1214404632114171905',NULL,2,2,'晋江市至简资产管理有限公司','13799225181','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:24:05',NULL,NULL,NULL),('1214448415816093697',NULL,NULL,2,1,NULL,'15959880009','399628','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:27:20',NULL,NULL,NULL),('1214448480920080386',NULL,NULL,2,1,NULL,'18876398522','582193','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:27:35',NULL,NULL,NULL),('1214450020577775618',NULL,NULL,2,1,NULL,'18876398522','738217','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:33:42',NULL,NULL,NULL),('1214451318203158530',NULL,NULL,2,1,NULL,'19959711592','742790','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 15:38:52',NULL,NULL,NULL),('1214457012004392962','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 16:01:29',NULL,NULL,NULL),('1214460790745141249',NULL,NULL,2,1,NULL,'15259760497','005648','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 16:16:30',NULL,NULL,NULL),('1214473964089315330','1214451511434743809',NULL,2,2,'福建北电新材料科技有限公司','19959711592','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 17:08:51',NULL,NULL,NULL),('1214474396228456449','1214461743938473985',NULL,2,2,'福建七匹狼集团有限公司','15259760497','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 17:10:34',NULL,NULL,NULL),('1214482616766500865',NULL,NULL,2,1,NULL,'13859210956','567902','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-07',NULL,NULL,NULL,'2020-01-07 17:43:14',NULL,NULL,NULL),('1214700023879655426',NULL,NULL,2,1,NULL,'18350599665','193103','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 08:07:08',NULL,NULL,NULL),('1214705069803528193','1214380965749673986',NULL,2,2,'泉州市德和汽车销售有限公司','15860304280','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 08:27:11',NULL,NULL,NULL),('1214707533571252226','1214482717169750018',NULL,2,2,'晋江市光影多媒体设计有限公司','13859210956','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 08:36:58',NULL,NULL,NULL),('1214713348508180482','58',NULL,1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348508180483','72',NULL,1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:05',NULL,NULL,NULL),('1214713369915908098','87',NULL,1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:10',NULL,NULL,NULL),('1214713369966239746','71',NULL,1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:10',NULL,NULL,NULL),('1214713370096263170','89',NULL,1,2,'林曼雅','13799500668','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:10',NULL,NULL,NULL),('1214713370255646721','90',NULL,1,2,'丁煌权','13959757007','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:10',NULL,NULL,NULL),('1214713370448584705','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:10',NULL,NULL,NULL),('1214713370620551169','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:00:10',NULL,NULL,NULL),('1214714453065555969','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:04:28',NULL,NULL,NULL),('1214714924463382530','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:06:20',NULL,NULL,NULL),('1214718003007021057','1214700126568800258',NULL,2,2,'三六一度童装有限公司','18350599665','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:18:34',NULL,NULL,NULL),('1214721785694609410','1213282123302113281',NULL,2,2,'晋江市子江中学','13599257966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:33:36',NULL,NULL,NULL),('1214721807412715521','1213282123302113281',NULL,2,2,'晋江市子江中学','13599257966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:33:41',NULL,NULL,NULL),('1214723632761233409','1212943836112818177',NULL,2,2,'晋江中纺标检测有限公司','15375873767','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:40:57',NULL,NULL,NULL),('1214727898863329282',NULL,NULL,2,1,NULL,'13599936037','361473','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 09:57:54',NULL,NULL,NULL),('1214729784819539970','1214700126568800258',NULL,2,2,'三六一度童装有限公司','18350599665','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:05:23',NULL,NULL,NULL),('1214735262286962689','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:27:09',NULL,NULL,NULL),('1214735283921182721','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:27:15',NULL,NULL,NULL),('1214735284332224514','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:27:15',NULL,NULL,NULL),('1214735284701323266','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:27:15',NULL,NULL,NULL),('1214735285108170754','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:27:15',NULL,NULL,NULL),('1214735285515018241','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:27:15',NULL,NULL,NULL),('1214735285913477122','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:27:15',NULL,NULL,NULL),('1214742029981016065','1211850431366479873',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:54:03',NULL,NULL,NULL),('1214743274519093250',NULL,NULL,2,1,NULL,'18650060049','538043','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 10:59:00',NULL,NULL,NULL),('1214747956033445890',NULL,NULL,2,1,NULL,'15960694893','162043','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:17:36',NULL,NULL,NULL),('1214751489340301314','1214103131894337537',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:31:38',NULL,NULL,NULL),('1214751644886065154','1214094072415801345',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:32:15',NULL,NULL,NULL),('1214751822766497794','1213349060656828418',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:32:58',NULL,NULL,NULL),('1214751927145947137','1213343817353203713',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:33:23',NULL,NULL,NULL),('1214752017172488193','1213310072533356546',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:33:44',NULL,NULL,NULL),('1214752148340957185','1213087701302054913',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:34:15',NULL,NULL,NULL),('1214752227395198977','1212699084805181441',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:34:34',NULL,NULL,NULL),('1214752337109803010','1212695165861433346',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:35:00',NULL,NULL,NULL),('1214752410870833154','1212685670133338114',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:35:18',NULL,NULL,NULL),('1214752518064660482','1212562949206511618',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:35:43',NULL,NULL,NULL),('1214752601128656897','1212558974272999426',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:36:03',NULL,NULL,NULL),('1214753599779856386','1212571178556788737',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:40:01',NULL,NULL,NULL),('1214754237997735938',NULL,NULL,2,1,NULL,'13489848301','240046','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 11:42:34',NULL,NULL,NULL),('1214765341306085377',NULL,NULL,2,1,NULL,'13859752110','562374','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 12:26:41',NULL,NULL,NULL),('1214766769336573954',NULL,NULL,2,1,NULL,'13859752110','248779','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 12:32:21',NULL,NULL,NULL),('1214794885182349313',NULL,NULL,2,1,NULL,'13489848301','776805','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 14:24:05',NULL,NULL,NULL),('1214795736600895490',NULL,NULL,2,1,NULL,'13600737691','161508','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 14:27:28',NULL,NULL,NULL),('1214801061219491842',NULL,NULL,2,1,NULL,'15060933526','078602','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 14:48:37',NULL,NULL,NULL),('1214801688406351873',NULL,NULL,2,1,NULL,'13489719977','794319','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 14:51:07',NULL,NULL,NULL),('1214802622578515969','1214430321844490242',NULL,2,2,'福建省烨烽软件科技有限公司','13905050770','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 14:54:49',NULL,NULL,NULL),('1214803162171531265',NULL,NULL,2,1,NULL,'15060933526','345187','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 14:56:58',NULL,NULL,NULL),('1214803944795103234','72',NULL,1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 15:00:05',NULL,NULL,NULL),('1214803966177665025','58',NULL,1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 15:00:10',NULL,NULL,NULL),('1214803966341242881','87',NULL,1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 15:00:10',NULL,NULL,NULL),('1214815465663193090',NULL,NULL,2,1,NULL,'13489848301','891229','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 15:45:51',NULL,NULL,NULL),('1214819424381526018',NULL,NULL,2,1,NULL,'17350937795','655611','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 16:01:35',NULL,NULL,NULL),('1214821111640973314',NULL,NULL,2,1,NULL,'17350937795','922508','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 16:08:17',NULL,NULL,NULL),('1214821550570692610',NULL,NULL,2,1,NULL,'13489848301','422322','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 16:10:02',NULL,NULL,NULL),('1214824784341327873',NULL,NULL,2,1,NULL,'15860517253','401806','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 16:22:53',NULL,NULL,NULL),('1214824826884153346',NULL,NULL,2,1,NULL,'17350937795','884993','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 16:23:03',NULL,NULL,NULL),('1214825152135651329',NULL,NULL,2,1,NULL,'13774889061','039941','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 16:24:21',NULL,NULL,NULL),('1214842512888389633',NULL,NULL,2,1,NULL,'18905953233','296295','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-08',NULL,NULL,NULL,'2020-01-08 17:33:20',NULL,NULL,NULL),('1215073683144491009','1211505228151570433',NULL,2,2,'晋江市陈埭中心卫生院','13905972257','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 08:51:55',NULL,NULL,NULL),('1215074833142956033','1214729031224745985',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 08:56:29',NULL,NULL,NULL),('1215075736394711041','72',NULL,1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:00:05',NULL,NULL,NULL),('1215075757777272834','58',NULL,1,2,'张荣荣','15280619456','11,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:00:10',NULL,NULL,NULL),('1215075757966016514','87',NULL,1,2,'叶志钦','13675957398','11,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:00:10',NULL,NULL,NULL),('1215078223956721665','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:09:58',NULL,NULL,NULL),('1215078245548998658','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:10:03',NULL,NULL,NULL),('1215078671254077442','1214450521214095362',NULL,2,2,'福建省晋江风电开发有限公司','18876398522','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:11:44',NULL,NULL,NULL),('1215080922131513345','1212943836112818177',NULL,2,2,'晋江中纺标检测有限公司','15375873767','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:20:41',NULL,NULL,NULL),('1215080943828647938','1212943836112818177',NULL,2,2,'晋江中纺标检测有限公司','15375873767','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:20:46',NULL,NULL,NULL),('1215086212717527041','1214448822097350658',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 09:41:42',NULL,NULL,NULL),('1215091004911173634','1214465949311242242',NULL,2,2,'晋江元素设计有限公司','13030981560','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:00:45',NULL,NULL,NULL),('1215091758245920770','1211862889812508674',NULL,2,2,'福建省晋江市福埔S.M国际广场','15059551567','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:03:45',NULL,NULL,NULL),('1215099797761998849',NULL,NULL,2,1,NULL,'15880742575','541950','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:35:41',NULL,NULL,NULL),('1215102678091218946',NULL,NULL,2,1,NULL,'18905054972','879798','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:47:08',NULL,NULL,NULL),('1215103037941530625','1214743507491708930',NULL,2,2,'福建电弧物联智能科技有限公司','18650060049','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:48:34',NULL,NULL,NULL),('1215103925183627265','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:52:05',NULL,NULL,NULL),('1215104270899134465','1214766839310147586',NULL,2,2,'晋江市内坑镇卫生院','13859752110','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:53:28',NULL,NULL,NULL),('1215104959410913282','1214796116982325250',NULL,2,2,'福建盼福食品有限公司','13600737691','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 10:56:12',NULL,NULL,NULL),('1215107952768237570',NULL,NULL,2,1,NULL,'15705936082','871798','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 11:08:06',NULL,NULL,NULL),('1215110954010853377','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 11:20:01',NULL,NULL,NULL),('1215114602040311810',NULL,NULL,2,1,NULL,'15980228632','670780','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 11:34:31',NULL,NULL,NULL),('1215114853132320770','1214821220722237441',NULL,2,2,'新中利佳荣汽车销售服务有限公司','17350937795','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 11:35:31',NULL,NULL,NULL),('1215117090525069313','1214821655621230594',NULL,2,2,'福建省百安物业服务有限公司晋江分公司','13489848301','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 11:44:24',NULL,NULL,NULL),('1215118893455032321','1214825252777975810',NULL,2,2,'晋江新中利丰田汽车销售服务有限公司','13774889061','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 11:51:34',NULL,NULL,NULL),('1215119331390701569','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 11:53:19',NULL,NULL,NULL),('1215151714471034881',NULL,NULL,2,1,NULL,'18050880266','864429','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 14:01:59',NULL,NULL,NULL),('1215164835579346945','1211494485905686529',NULL,2,2,'时来运转','15280619456','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 14:54:08',NULL,NULL,NULL),('1215166332593553409','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 15:00:05',NULL,NULL,NULL),('1215166353946755074','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 15:00:10',NULL,NULL,NULL),('1215166354127110146','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 15:00:10',NULL,NULL,NULL),('1215181893746606081','1212558974272999426',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 16:01:55',NULL,NULL,NULL),('1215191288140316673',NULL,NULL,2,1,NULL,'13559592263','594009','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 16:39:14',NULL,NULL,NULL),('1215193719209246722',NULL,NULL,2,1,NULL,'19971782113','495352','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 16:48:54',NULL,NULL,NULL),('1215203346932088833','1211909253418237954',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 17:27:09',NULL,NULL,NULL),('1215207390161453058',NULL,NULL,2,1,NULL,'18350528526','583392','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 17:43:13',NULL,NULL,NULL),('1215259337258221570',NULL,NULL,2,1,NULL,'15259555117','052542','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 21:09:39',NULL,NULL,NULL),('1215261090888335362',NULL,NULL,2,1,NULL,'15259555117','411331','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 21:16:37',NULL,NULL,NULL),('1215261635820699650',NULL,NULL,2,1,NULL,'15259555117','877146','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 21:18:47',NULL,NULL,NULL),('1215277008460759041',NULL,NULL,2,1,NULL,'13960358840','349652','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 22:19:52',NULL,NULL,NULL),('1215279485344071682',NULL,NULL,2,1,NULL,'13960358840','631665','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 22:29:42',NULL,NULL,NULL),('1215280768897564673',NULL,NULL,2,1,NULL,'13960358840','623195','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-09',NULL,NULL,NULL,'2020-01-09 22:34:48',NULL,NULL,NULL),('1215438123689885698','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:00:05',NULL,NULL,NULL),('1215438145198276610','58',NULL,1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:00:10',NULL,NULL,NULL),('1215438145370243074','87',NULL,1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:00:10',NULL,NULL,NULL),('1215439735871291394',NULL,NULL,2,1,NULL,'15559133531','289683','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:06:29',NULL,NULL,NULL),('1215442627487383553',NULL,NULL,2,1,NULL,'15260856039','151785','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:17:58',NULL,NULL,NULL),('1215444129614446594',NULL,NULL,2,1,NULL,'15260856039','413959','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:23:57',NULL,NULL,NULL),('1215444583492665345',NULL,NULL,2,1,NULL,'15260856039','170930','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:25:45',NULL,NULL,NULL),('1215445785831849985',NULL,NULL,2,1,NULL,'13950238890','024298','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:30:31',NULL,NULL,NULL),('1215446043857043457','1213349060656828418',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:31:33',NULL,NULL,NULL),('1215446210618376193','1213343817353203713',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 09:32:13',NULL,NULL,NULL),('1215453795346071553','1213343817353203713',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:02:21',NULL,NULL,NULL),('1215453852833202178',NULL,NULL,2,1,NULL,'15860517253','961823','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:02:35',NULL,NULL,NULL),('1215453951839748098','1213349060656828418',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:02:58',NULL,NULL,NULL),('1215455390880284674',NULL,NULL,2,1,NULL,'15860517253','001579','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:08:41',NULL,NULL,NULL),('1215455728307847169','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:10:02',NULL,NULL,NULL),('1215456787629654017','1214367286887010305',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:14:14',NULL,NULL,NULL),('1215459875019079682',NULL,NULL,2,1,NULL,'18350528526','585444','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:26:31',NULL,NULL,NULL),('1215460800228016129',NULL,NULL,2,1,NULL,'15860517253','067148','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:30:11',NULL,NULL,NULL),('1215464663559487490','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:45:32',NULL,NULL,NULL),('1215465989907464194','1215446302779817985',NULL,2,2,'福建省力和勘察设计有限公司','13950238890','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:50:48',NULL,NULL,NULL),('1215466964672102402',NULL,NULL,2,1,NULL,'15985931159','885344','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:54:41',NULL,NULL,NULL),('1215467566378565634','1215439821749665794',NULL,2,2,'泉州福盈汽车销售服务有限公司','15559133531','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:57:04',NULL,NULL,NULL),('1215468088267423746','1215259455701172226',NULL,2,2,'福建新宇拉链织造有限公司','15259555117','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 10:59:09',NULL,NULL,NULL),('1215468798769938433','1215191426158084097',NULL,2,2,'晋江市金阳汽车销售有限公司','13559592263','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:01:58',NULL,NULL,NULL),('1215469275125432321','1215108487227424769',NULL,2,2,'晋江市池店镇卫生院','15705936082','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:03:52',NULL,NULL,NULL),('1215470059133124609','1215100340257472514',NULL,2,2,'晋江万兴隆染织实业有限公司','15880742575','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:06:59',NULL,NULL,NULL),('1215470300892807169','1215102801626054658',NULL,2,2,'晋江市民发汽车销售有限公司','18905054972','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:07:56',NULL,NULL,NULL),('1215470646717366274','1215152072387772418',NULL,2,2,'晋江市溢泰织造机械有限公司','18050880266','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:09:19',NULL,NULL,NULL),('1215471108095000578',NULL,NULL,2,1,NULL,'18905054972','145416','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:11:09',NULL,NULL,NULL),('1215471439868641281','1215467591057850370',NULL,2,2,'晋江市瑞盛机械制造有限公司','15985931159','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:12:28',NULL,NULL,NULL),('1215472419695804417','1215444208769351681',NULL,2,2,'晋江市卫生计生执法大队','15260856039','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:16:21',NULL,NULL,NULL),('1215473349325537281',NULL,NULL,2,1,NULL,'15985931159','646625','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:20:03',NULL,NULL,NULL),('1215474543234170881','1215467591057850370',NULL,2,2,'晋江市瑞盛机械制造有限公司','15985931159','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:24:48',NULL,NULL,NULL),('1215474664902541313','1215444208769351681',NULL,2,2,'晋江市卫生计生执法大队（晋江市卫生监督所）','15260856039','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:25:17',NULL,NULL,NULL),('1215475601670979585','1215108487227424769',NULL,2,2,'晋江市池店镇卫生院','15705936082','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:29:00',NULL,NULL,NULL),('1215476881617371137','1214766839310147586',NULL,2,2,'晋江市内坑镇卫生院','13859752110','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 11:34:05',NULL,NULL,NULL),('1215528720425598977','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:00:05',NULL,NULL,NULL),('1215528741862686722','71',NULL,1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:00:10',NULL,NULL,NULL),('1215528742332448769','58',NULL,1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:00:10',NULL,NULL,NULL),('1215528742516998145','87',NULL,1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:00:10',NULL,NULL,NULL),('1215530157989740545','1215455507792314370',NULL,2,2,'晋江市致和社工事务所','15860517253','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:05:47',NULL,NULL,NULL),('1215530179644932098','1215455507792314370',NULL,2,2,'晋江市致和社工事务所','15860517253','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:05:52',NULL,NULL,NULL),('1215531871761383426',NULL,NULL,2,1,NULL,'13489387611','298376','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:12:36',NULL,NULL,NULL),('1215541562474283010',NULL,NULL,2,1,NULL,'15906066156','352082','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:51:06',NULL,NULL,NULL),('1215542877409558530',NULL,NULL,2,1,NULL,'15805972719','312186','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 15:56:20',NULL,NULL,NULL),('1215546551833772034',NULL,NULL,2,1,NULL,'15805972719','722225','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:10:56',NULL,NULL,NULL),('1215547306980458497',NULL,NULL,2,1,NULL,'18959995205','039036','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:13:56',NULL,NULL,NULL),('1215547909337038850','1211919059642269697',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:16:20',NULL,NULL,NULL),('1215548051482001409',NULL,NULL,2,1,NULL,'15805972719','914645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:16:53',NULL,NULL,NULL),('1215548216200708097','1215460590617673730',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:17:33',NULL,NULL,NULL),('1215548343497834497','1215189664495878146',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:18:03',NULL,NULL,NULL),('1215548426788323329','1214843906471059458',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:18:23',NULL,NULL,NULL),('1215550038600630273',NULL,NULL,2,1,NULL,'18959995205','622754','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:24:47',NULL,NULL,NULL),('1215556817854185473','1215549063731134465',NULL,2,2,'灵源药业有限公司','18350770050','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 16:51:43',NULL,NULL,NULL),('1215568133557895170',NULL,NULL,2,1,NULL,'19959813350','289148','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 17:36:41',NULL,NULL,NULL),('1215607991064117249',NULL,NULL,2,1,NULL,'13506062515','727055','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-10',NULL,NULL,NULL,'2020-01-10 20:15:04',NULL,NULL,NULL),('1215820731569434626',NULL,NULL,2,1,NULL,'13597766670','297957','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-11',NULL,NULL,NULL,'2020-01-11 10:20:25',NULL,NULL,NULL),('1215821623056166914',NULL,NULL,2,1,NULL,'13599766670','529063','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-11',NULL,NULL,NULL,'2020-01-11 10:23:58',NULL,NULL,NULL),('1215822119519154178',NULL,NULL,2,1,NULL,'13599766670','593061','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-11',NULL,NULL,NULL,'2020-01-11 10:25:56',NULL,NULL,NULL),('1215822434746265601',NULL,NULL,2,1,NULL,'13599766670','804262','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-11',NULL,NULL,NULL,'2020-01-11 10:27:11',NULL,NULL,NULL),('1215836846525804545',NULL,NULL,2,1,NULL,'18072769019','745987','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-11',NULL,NULL,NULL,'2020-01-11 11:24:28',NULL,NULL,NULL),('1215845003159433217',NULL,NULL,2,1,NULL,'13505925273','465126','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-11',NULL,NULL,NULL,'2020-01-11 11:56:52',NULL,NULL,NULL),('1215974849239871489',NULL,NULL,2,1,NULL,'13489384995','340634','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-11',NULL,NULL,NULL,'2020-01-11 20:32:50',NULL,NULL,NULL),('1216179255663161345',NULL,NULL,2,1,NULL,'15711376693','306044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-12',NULL,NULL,NULL,'2020-01-12 10:05:04',NULL,NULL,NULL),('1216181997852979202',NULL,NULL,2,1,NULL,'13636959434','476696','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-12',NULL,NULL,NULL,'2020-01-12 10:15:58',NULL,NULL,NULL),('1216183037352505346',NULL,NULL,2,1,NULL,'18959996091','246178','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-12',NULL,NULL,NULL,'2020-01-12 10:20:06',NULL,NULL,NULL),('1216184781113421825',NULL,NULL,2,1,NULL,'18959996091','634444','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-12',NULL,NULL,NULL,'2020-01-12 10:27:02',NULL,NULL,NULL),('1216214796060356609',NULL,NULL,2,1,NULL,'13905055766','212040','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-12',NULL,NULL,NULL,'2020-01-12 12:26:18',NULL,NULL,NULL),('1216370822541766658',NULL,NULL,2,1,NULL,'13905055766','845190','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-12',NULL,NULL,NULL,'2020-01-12 22:46:17',NULL,NULL,NULL),('1216519250626244609','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 08:36:05',NULL,NULL,NULL),('1216520211818115074','1215542604263899137',NULL,2,2,'福建美溪通信科技股份有限公司','15906066156','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 08:39:55',NULL,NULL,NULL),('1216525287676735489','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:00:05',NULL,NULL,NULL),('1216525309118017538','71',NULL,1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:00:10',NULL,NULL,NULL),('1216525309315149825','58',NULL,1,2,'张荣荣','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:00:10',NULL,NULL,NULL),('1216525309508087809','87',NULL,1,2,'叶志钦','13675957398','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:00:10',NULL,NULL,NULL),('1216530609980076034','1215548205433929729',NULL,2,2,'龙之族（中国）有限公司','15805972719','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:21:14',NULL,NULL,NULL),('1216533299212611585',NULL,NULL,2,1,NULL,'13959882723','232261','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:31:55',NULL,NULL,NULL),('1216535753773838338',NULL,NULL,2,1,NULL,'13959882723','388080','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:41:40',NULL,NULL,NULL),('1216537199927914498',NULL,NULL,2,1,NULL,'13959882723','829551','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:47:25',NULL,NULL,NULL),('1216539885813395458','1215568298586980354',NULL,2,2,'福建永恒能源管理有限公司','19959813350','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 09:58:05',NULL,NULL,NULL),('1216545806471950338','1212919516728725506',NULL,2,2,'福建凤竹环保有限公司','13365978588','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 10:21:37',NULL,NULL,NULL),('1216546050798546946','1212907561423015937',NULL,2,2,'福建凤竹环保有限公司','13365978588','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 10:22:35',NULL,NULL,NULL),('1216546433147105282','1215608523329683457',NULL,2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 10:24:06',NULL,NULL,NULL),('1216547622836269058','1215194056280293377',NULL,2,2,'haohaoxuexigongsi','19971782113','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 10:28:50',NULL,NULL,NULL),('1216551974485389313','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 10:46:07',NULL,NULL,NULL),('1216554629085556738',NULL,NULL,2,1,NULL,'13030990915','682579','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 10:56:40',NULL,NULL,NULL),('1216557866983387137','1215542604263899137',NULL,2,2,'福建美溪通信科技股份有限公司','15906066156','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:09:32',NULL,NULL,NULL),('1216558772764307458',NULL,NULL,2,1,NULL,'15160050023','297973','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:13:08',NULL,NULL,NULL),('1216563767672860674',NULL,NULL,2,1,NULL,'15980228632','083224','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:32:59',NULL,NULL,NULL),('1216565453011316737',NULL,NULL,2,1,NULL,'15980228632','913088','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:39:41',NULL,NULL,NULL),('1216566639567335426',NULL,NULL,2,1,NULL,'15980228632','556642','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:44:24',NULL,NULL,NULL),('1216566836078866433','1215974921277042690',NULL,2,2,'泉州中升雷克萨斯汽车销售有限公司','13489384995','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:45:11',NULL,NULL,NULL),('1216567096213794817','1216180400276140034',NULL,2,2,'泉州荣兴丝绸材料研究院有限公司','15711376693','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:46:13',NULL,NULL,NULL),('1216568427985006594',NULL,NULL,2,1,NULL,'15980228632','190946','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:51:30',NULL,NULL,NULL),('1216568769665593346',NULL,NULL,2,1,NULL,'15880272172','162188','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:52:52',NULL,NULL,NULL),('1216569715636334593','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 11:56:37',NULL,NULL,NULL),('1216608440709816322',NULL,NULL,2,1,NULL,'13905985153','980787','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 14:30:30',NULL,NULL,NULL),('1216617528722202626',NULL,NULL,2,1,NULL,'13952816855','103979','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:06:37',NULL,NULL,NULL),('1216618317129719809',NULL,NULL,2,1,NULL,'15880881006','288241','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:09:45',NULL,NULL,NULL),('1216618764154445826','1216617598242791425',NULL,2,2,'haohaoxuexigongsi','13952816855','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:11:31',NULL,NULL,NULL),('1216622391598260225','1211494485905686529',NULL,2,2,'时来运转','15280619456','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:25:56',NULL,NULL,NULL),('1216622538587643905','1216537288914268162',NULL,2,2,'耀华园林股份有限公司','13959882723','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:26:31',NULL,NULL,NULL),('1216622865684635650','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:27:49',NULL,NULL,NULL),('1216622887323049986','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:27:54',NULL,NULL,NULL),('1216622993241808897','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:28:20',NULL,NULL,NULL),('1216623528741183489','1216559724997144578',NULL,2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:30:27',NULL,NULL,NULL),('1216624372589010945','1216609110485639170',NULL,2,2,'泉州时空文化传媒有限公司','13905985153','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:33:48',NULL,NULL,NULL),('1216624892867256321','1216619023060443137',NULL,2,2,'福建省统仕金属制品有限公司','15880881006','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:35:52',NULL,NULL,NULL),('1216625605190098945','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:38:42',NULL,NULL,NULL),('1216625688233123842','1214743507491708930',NULL,2,2,'福建电弧物联智能科技有限公司','18650060049','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:39:02',NULL,NULL,NULL),('1216626363830640641',NULL,NULL,2,1,NULL,'13599718877','915796','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:41:43',NULL,NULL,NULL),('1216627657978945537',NULL,NULL,2,1,NULL,'13599766670','357969','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:46:52',NULL,NULL,NULL),('1216627687724949505','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 15:46:59',NULL,NULL,NULL),('1216636655465668609','1216568840104734722',NULL,2,2,'福州大学','15880272172','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 16:22:37',NULL,NULL,NULL),('1216639086324883457',NULL,NULL,2,1,NULL,'18959759065','586730','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 16:32:16',NULL,NULL,NULL),('1216639630934286338',NULL,NULL,2,1,NULL,'18959759065','373690','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 16:34:26',NULL,NULL,NULL),('1216649286729605121',NULL,NULL,2,1,NULL,'18959759065','671476','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 17:12:48',NULL,NULL,NULL),('1216649742633672705',NULL,NULL,2,1,NULL,'18959759065','895693','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 17:14:37',NULL,NULL,NULL),('1216650334856814593',NULL,NULL,2,1,NULL,'18959759065','361206','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-13',NULL,NULL,NULL,'2020-01-13 17:16:58',NULL,NULL,NULL),('1216887675273891841','69',NULL,1,2,'陈文经','13599795023','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:00:05',NULL,NULL,NULL),('1216887696895528961','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:00:10',NULL,NULL,NULL),('1216887697101049857','70',NULL,1,2,'陈瑞清','13788864979','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:00:10',NULL,NULL,NULL),('1216887697289793538','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:00:10',NULL,NULL,NULL),('1216887697474342913','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:00:10',NULL,NULL,NULL),('1216889802461302785','1215115207978827777',NULL,2,2,'晋江市科教园区建设有限公司（福州大学）','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:08:32',NULL,NULL,NULL),('1216889824120688642','1215115207978827777',NULL,2,2,'晋江市科教园区建设有限公司（福州大学）','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:08:37',NULL,NULL,NULL),('1216889824502370306','1215115207978827777',NULL,2,2,'晋江市科教园区建设有限公司（福州大学）','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:08:37',NULL,NULL,NULL),('1216890810084118530','1216626668072869889',NULL,2,2,'晋江市广播电视事业局','13599718877','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:12:32',NULL,NULL,NULL),('1216892671910498305',NULL,NULL,2,1,NULL,'13805350771','097909','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:19:56',NULL,NULL,NULL),('1216898360548544513',NULL,NULL,2,1,NULL,'13905063574','420058','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:42:32',NULL,NULL,NULL),('1216900294365958146',NULL,NULL,2,1,NULL,'13905063574','479906','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 09:50:13',NULL,NULL,NULL),('1216903499762126849','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 10:02:57',NULL,NULL,NULL),('1216904671084433410','1215550908977430529',NULL,2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 10:07:37',NULL,NULL,NULL),('1216906770060955649','1211140930858496001',NULL,2,2,'晋江名仕纺织机械设计有限公司','13599250912','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'黑名单','2020-01-14',NULL,NULL,NULL,'2020-01-14 10:15:57',NULL,NULL,NULL),('1216907324271120386','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 10:18:09',NULL,NULL,NULL),('1216911951993524226','1212204590548717570',NULL,2,2,'福建省劲牛重工发展有限公司','18016585576','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 10:36:33',NULL,NULL,NULL),('1216918895684767746','1211933540841734146',NULL,2,2,'晋江凯燕新材料科技有限公司','13255957226','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 11:04:08',NULL,NULL,NULL),('1216925102399049729','1211953724851798017',NULL,2,2,'福建楚威贸易有限公司','13506055705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 11:28:48',NULL,NULL,NULL),('1216926229077184513',NULL,NULL,2,1,NULL,'18650916825','254358','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 11:33:17',NULL,NULL,NULL),('1216927800573841410','1211941475839950850',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 11:39:31',NULL,NULL,NULL),('1216932299128459266','1211943010711945217',NULL,2,2,'中菱（福建）电梯有限公司','18959847128','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 11:57:24',NULL,NULL,NULL),('1216963828080726018',NULL,NULL,2,1,NULL,'18559780403','495302','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 14:02:41',NULL,NULL,NULL),('1216965323786309633',NULL,NULL,2,1,NULL,'18559780403','291867','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 14:08:37',NULL,NULL,NULL),('1216966034326573057',NULL,NULL,2,1,NULL,'18559780104','105233','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 14:11:27',NULL,NULL,NULL),('1216971118070484993',NULL,NULL,2,1,NULL,'15906094639','904311','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 14:31:39',NULL,NULL,NULL),('1216984335580680194','1216964347578830850',NULL,2,2,'泉州世派电子商务有限公司','18559780403','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 15:24:10',NULL,NULL,NULL),('1216986816062705666','1216966155533570050',NULL,2,2,'晋江市新阶社会经济咨询服务中心','18559780104','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 15:34:02',NULL,NULL,NULL),('1216988518140628993','1216971228074496001',NULL,2,2,'深圳沃尔玛百货零售有限公司晋江SM分店','15906094639','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 15:40:47',NULL,NULL,NULL),('1216996146585554946',NULL,NULL,2,1,NULL,'13959955966','526103','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 16:11:06',NULL,NULL,NULL),('1217001185605603329','1211942399333416962',NULL,2,2,'福建省晋江产业发展投资集团有限公司','13599789599','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 16:31:08',NULL,NULL,NULL),('1217014292314869762',NULL,NULL,2,1,NULL,'13959955966','320743','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 17:23:12',NULL,NULL,NULL),('1217015577558667265',NULL,NULL,2,1,NULL,'13959955966','184851','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 17:28:19',NULL,NULL,NULL),('1217020192933040130','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会（福州大学）','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 17:46:39',NULL,NULL,NULL),('1217040860558938114',NULL,NULL,2,1,NULL,'18859781366','254069','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-14',NULL,NULL,NULL,'2020-01-14 19:08:47',NULL,NULL,NULL),('1217240833057640449',NULL,NULL,2,1,NULL,'18259068085','801401','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',2,'未知错误','2020-01-15',NULL,NULL,NULL,'2020-01-15 08:23:24',NULL,NULL,NULL),('1217241216492523521',NULL,NULL,2,1,NULL,'18559529595','281447','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 08:24:55',NULL,NULL,NULL),('1217245041139929089','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 08:40:07',NULL,NULL,NULL),('1217246071688810498','1217041144660119553',NULL,2,2,'晋江市天泽农业开发有限公司','18859781366','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 08:44:13',NULL,NULL,NULL),('1217248768534007809','1214448822097350658',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 08:54:56',NULL,NULL,NULL),('1217250062820724738','71',NULL,1,2,'王小阳','13559621092','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 09:00:05',NULL,NULL,NULL),('1217250084190703618','58',NULL,1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 09:00:10',NULL,NULL,NULL),('1217250084375252993','87',NULL,1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 09:00:10',NULL,NULL,NULL),('1217257632302125057','1217242391405154305',NULL,2,2,'晋江市汇鑫小额贷款有限公司','18559529595','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 09:30:09',NULL,NULL,NULL),('1217259809540165633','1214451511434743809',NULL,2,2,'福建北电新材料科技有限公司','19959711592','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 09:38:48',NULL,NULL,NULL),('1217264233843019778',NULL,NULL,2,1,NULL,'15259755678','093336','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 09:56:23',NULL,NULL,NULL),('1217274902130741249',NULL,NULL,2,1,NULL,'15060997885','466364','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 10:38:47',NULL,NULL,NULL),('1217288745896660994',NULL,NULL,2,1,NULL,'13505959911','979373','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 11:33:47',NULL,NULL,NULL),('1217290152368427009',NULL,NULL,2,1,NULL,'13505959911','477166','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 11:39:23',NULL,NULL,NULL),('1217291415491465218',NULL,NULL,2,1,NULL,'13675918895','462134','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 11:44:24',NULL,NULL,NULL),('1217292755533844482',NULL,NULL,2,1,NULL,'13505959911','535103','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 11:49:43',NULL,NULL,NULL),('1217332255827972097',NULL,NULL,2,1,NULL,'13505959911','642477','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 14:26:41',NULL,NULL,NULL),('1217337892163047426',NULL,NULL,2,1,NULL,'13505959911','839718','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 14:49:05',NULL,NULL,NULL),('1217341600166858753','1217264466144546817',NULL,2,2,'晋江市铠锋制鞋机械有限公司','15259755678','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:03:49',NULL,NULL,NULL),('1217346451449860097',NULL,NULL,2,1,NULL,'13959883141','894652','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:23:05',NULL,NULL,NULL),('1217348249820614658',NULL,NULL,2,1,NULL,'13505959911','310005','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:30:14',NULL,NULL,NULL),('1217349200296038402',NULL,NULL,2,1,NULL,'18960272000','181516','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:34:01',NULL,NULL,NULL),('1217349272937189378',NULL,NULL,2,1,NULL,'13075838343','556127','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:34:18',NULL,NULL,NULL),('1217350171499712513','1217075748158853121',NULL,2,2,'中轻（晋江）卫生用品研究有限公司','13520554703','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:37:52',NULL,NULL,NULL),('1217353667561148418','1217348495564886017',NULL,2,2,'晋江劲霸男装有限公司','13505959911','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:51:46',NULL,NULL,NULL),('1217354151634161665','1217349592555737090',NULL,2,2,'劲霸男装股份有限公司','13075838343','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 15:53:41',NULL,NULL,NULL),('1217363982873022465','1211853076714012673',NULL,2,2,'晋江市永和镇卫生院','13959883141','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 16:32:45',NULL,NULL,NULL),('1217368395566043137',NULL,NULL,2,1,NULL,'13774889061','542192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 16:50:17',NULL,NULL,NULL),('1217369826717093889',NULL,NULL,2,1,NULL,'13774889061','682431','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 16:55:58',NULL,NULL,NULL),('1217377376451710978',NULL,NULL,2,1,NULL,'15260822852','252560','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-15',NULL,NULL,NULL,'2020-01-15 17:25:58',NULL,NULL,NULL),('1217455163409760258','1211140930858496001',NULL,2,2,'晋江名仕纺织机械设计有限公司','13599250912','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'黑名单','2020-01-15',NULL,NULL,NULL,'2020-01-15 22:35:04',NULL,NULL,NULL),('1217604666855063554','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 08:29:09',NULL,NULL,NULL),('1217604688904519681','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 08:29:14',NULL,NULL,NULL),('1217612235556323329','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 08:59:13',NULL,NULL,NULL),('1217612450925445122','71',NULL,1,2,'王小阳','13559621092','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 09:00:05',NULL,NULL,NULL),('1217612472387698689','58',NULL,1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 09:00:10',NULL,NULL,NULL),('1217612472840683521','87',NULL,1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 09:00:10',NULL,NULL,NULL),('1217613900577570817',NULL,NULL,2,1,NULL,'15260822852','417124','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 09:05:50',NULL,NULL,NULL),('1217614250357358594','1211140930858496001',NULL,2,2,'晋江名仕纺织机械设计有限公司','13599250912','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 09:07:14',NULL,NULL,NULL),('1217624344893652994',NULL,NULL,2,1,NULL,'18960272000','345507','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 09:47:20',NULL,NULL,NULL),('1217633623168057346',NULL,NULL,2,1,NULL,'17305060050','303697','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 10:24:12',NULL,NULL,NULL),('1217634206625103873',NULL,NULL,2,1,NULL,'17305060050','030605','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 10:26:32',NULL,NULL,NULL),('1217639451426095105','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 10:47:22',NULL,NULL,NULL),('1217639638966009858',NULL,NULL,2,1,NULL,'13505959355','213268','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 10:48:07',NULL,NULL,NULL),('1217647976445444098',NULL,NULL,2,1,NULL,'18850018674','901044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 11:21:15',NULL,NULL,NULL),('1217648927365464066','1217646165894430722',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 11:25:01',NULL,NULL,NULL),('1217649267263471618',NULL,NULL,2,1,NULL,'18850018674','918708','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 11:26:22',NULL,NULL,NULL),('1217650748419014658','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 11:32:15',NULL,NULL,NULL),('1217657749559640066','1216632437300273153',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 12:00:05',NULL,NULL,NULL),('1217657912097308674','1216985665393152001',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 12:00:43',NULL,NULL,NULL),('1217658037154676738','1216651527934976001',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 12:01:13',NULL,NULL,NULL),('1217658132696727553','1216914529154256898',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 12:01:36',NULL,NULL,NULL),('1217658269129048066','1216920881062760449',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 12:02:09',NULL,NULL,NULL),('1217698765599735809','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 14:43:04',NULL,NULL,NULL),('1217703469171933186','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会（福州大学）','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 15:01:45',NULL,NULL,NULL),('1217703490810347521','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会（福州大学）','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 15:01:50',NULL,NULL,NULL),('1217703491150086146','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会（福州大学）','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 15:01:50',NULL,NULL,NULL),('1217703770683670529','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 15:02:57',NULL,NULL,NULL),('1217704410210172929','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会','15980228632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 15:05:29',NULL,NULL,NULL),('1217711824011591681','1213744490175549442',NULL,2,2,'中轻（晋江）卫生用品研究有限公司','13520554703','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 15:34:57',NULL,NULL,NULL),('1217729576965308418','1213067832691068929',NULL,2,2,'中轻（晋江）卫生用品研究有限公司','13520554703','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 16:45:30',NULL,NULL,NULL),('1217731161808240642',NULL,NULL,2,1,NULL,'15375886386','976463','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 16:51:47',NULL,NULL,NULL),('1217742338382692353','1211950739581091841',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-16',NULL,NULL,NULL,'2020-01-16 17:36:12',NULL,NULL,NULL),('1217971422123589633',NULL,NULL,2,1,NULL,'15960417947','773182','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 08:46:30',NULL,NULL,NULL),('1217974838505832450','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:00:05',NULL,NULL,NULL),('1217974859892588546','71',NULL,1,2,'王小阳','13559621092','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:00:10',NULL,NULL,NULL),('1217974860060360706','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:00:10',NULL,NULL,NULL),('1217974860253298689','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:00:10',NULL,NULL,NULL),('1217974907044954114',NULL,NULL,2,1,NULL,'15905010176','753917','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:00:21',NULL,NULL,NULL),('1217975836439805954',NULL,NULL,2,1,NULL,'15905010176','149979','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:04:02',NULL,NULL,NULL),('1217976125511237633',NULL,NULL,2,1,NULL,'18959709952','421165','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:05:11',NULL,NULL,NULL),('1217976183120003073',NULL,NULL,2,1,NULL,'15960417947','503565','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:05:25',NULL,NULL,NULL),('1217985782434824193',NULL,NULL,2,1,NULL,'15960417947','273868','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:43:34',NULL,NULL,NULL),('1217988782557560834','1217985949057744898',NULL,2,2,'福建荣荣新材料股份有限公司','15960417947','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 09:55:29',NULL,NULL,NULL),('1217991936707723265',NULL,NULL,2,1,NULL,'18959995205','572704','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:08:01',NULL,NULL,NULL),('1217992710468730882','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:11:06',NULL,NULL,NULL),('1217992732044230657','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:11:11',NULL,NULL,NULL),('1217992862151540737','1216926739968577538',NULL,2,2,'晋江市启航社工服务中心','18650916825','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:11:42',NULL,NULL,NULL),('1217992994901262337','1217291550673883138',NULL,2,2,'晋江市向阳青少年社工事务所','13675918895','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:12:13',NULL,NULL,NULL),('1217993157413765122','1217614697717628930',NULL,2,2,'晋江市拔萃双语学校','15260822852','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:12:52',NULL,NULL,NULL),('1217993178938933249','1217614697717628930',NULL,2,2,'晋江市拔萃双语学校','15260822852','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:12:57',NULL,NULL,NULL),('1217997721152061441','1215550908977430529',NULL,2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 10:31:00',NULL,NULL,NULL),('1218008271038775298','1212549256930463745',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 11:12:55',NULL,NULL,NULL),('1218016548527079426','1212561682967105537',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 11:45:49',NULL,NULL,NULL),('1218018925481099266','1212573153730039810',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 11:55:16',NULL,NULL,NULL),('1218019290855309314','1211950739581091841',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 11:56:43',NULL,NULL,NULL),('1218060978751602689','1211551476439105538',NULL,2,2,'冠达星股份有限公司','15905010176','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 14:42:22',NULL,NULL,NULL),('1218062034562777089','1218001977741475841',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 14:46:34',NULL,NULL,NULL),('1218082451105054722','1212209407291625473',NULL,2,2,'晋江市新佳园资产管理有限公司','13255006151','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 16:07:41',NULL,NULL,NULL),('1218083061128822786','1216894342052990977',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 16:10:07',NULL,NULL,NULL),('1218096870174294017',NULL,NULL,2,1,NULL,'13799855086','770742','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 17:04:59',NULL,NULL,NULL),('1218099633713119233','1217391140760735745',NULL,2,2,'晋江一岂科技有限公司','13950116705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 17:15:58',NULL,NULL,NULL),('1218101675017961474','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 17:24:05',NULL,NULL,NULL),('1218102761405612034','1212532603131858945',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 17:28:24',NULL,NULL,NULL),('1218105644842811393',NULL,NULL,2,1,NULL,'18650672995','693771','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 17:39:51',NULL,NULL,NULL),('1218106363658436610',NULL,NULL,2,1,NULL,'18650672995','813534','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 17:42:43',NULL,NULL,NULL),('1218107884093636610',NULL,NULL,2,1,NULL,'18650672995','792976','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 17:48:45',NULL,NULL,NULL),('1218159825754587138',NULL,NULL,2,1,NULL,'13205957447','667324','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 21:15:09',NULL,NULL,NULL),('1218160635133624321',NULL,NULL,2,1,NULL,'13898810920','942941','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-17',NULL,NULL,NULL,'2020-01-17 21:18:22',NULL,NULL,NULL),('1218375356554272770',NULL,NULL,2,1,NULL,'15260225737','209163','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-18',NULL,NULL,NULL,'2020-01-18 11:31:35',NULL,NULL,NULL),('1218438231121584130',NULL,NULL,2,1,NULL,'13506095562','906575','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-18',NULL,NULL,NULL,'2020-01-18 15:41:26',NULL,NULL,NULL),('1218449690006249473',NULL,NULL,2,1,NULL,'13506095562','982494','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-18',NULL,NULL,NULL,'2020-01-18 16:26:58',NULL,NULL,NULL),('1218702634400210946','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 09:12:05',NULL,NULL,NULL),('1218702655891824642','58',NULL,1,2,'张荣荣','15280619456','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 09:12:10',NULL,NULL,NULL),('1218702656084762625','87',NULL,1,2,'叶志钦','13675957398','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 09:12:10',NULL,NULL,NULL),('1218726237443317761',NULL,NULL,2,1,NULL,'15905031789','637355','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 10:45:52',NULL,NULL,NULL),('1218728768730947586',NULL,NULL,2,1,NULL,'15905031789','955893','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 10:55:56',NULL,NULL,NULL),('1218774783529967618',NULL,NULL,2,1,NULL,'15980228632','529446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 13:58:46',NULL,NULL,NULL),('1218780881469169665',NULL,NULL,2,1,NULL,'15880272172','670160','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 14:23:00',NULL,NULL,NULL),('1218790230002360321',NULL,NULL,2,1,NULL,'13675964999','841395','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 15:00:09',NULL,NULL,NULL),('1218790385875279873',NULL,NULL,2,1,NULL,'13506098847','087623','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 15:00:46',NULL,NULL,NULL),('1218791586922618882',NULL,NULL,2,1,NULL,'13506098847','442477','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 15:05:33',NULL,NULL,NULL),('1218794243842236417',NULL,NULL,2,1,NULL,'13506098847','253538','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 15:16:06',NULL,NULL,NULL),('1218812238580801537',NULL,NULL,2,1,NULL,'13400821686','346483','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',2,'未知错误','2020-01-19',NULL,NULL,NULL,'2020-01-19 16:27:36',NULL,NULL,NULL),('1218812528449150977',NULL,NULL,2,1,NULL,'15759777586','692105','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 16:28:45',NULL,NULL,NULL),('1218815076476248066','1218100314259914753',NULL,2,2,'晋江大白科技有限公司','18850018674','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-19',NULL,NULL,NULL,'2020-01-19 16:38:53',NULL,NULL,NULL),('1219062002173992962','72',NULL,1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 09:00:05',NULL,NULL,NULL),('1219062023611080705','71',NULL,1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 09:00:10',NULL,NULL,NULL),('1219062023816601602','58',NULL,1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 09:00:10',NULL,NULL,NULL),('1219062024026316802','87',NULL,1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 09:00:10',NULL,NULL,NULL),('1219089665630527489','1218100314259914753',NULL,2,2,'晋江大白科技有限公司','18850018674','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 10:50:00',NULL,NULL,NULL),('1219092632836366337',NULL,NULL,2,1,NULL,'13338577800','947999','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 11:01:47',NULL,NULL,NULL),('1219097975926677506',NULL,NULL,2,1,NULL,'15759877981','259411','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 11:23:01',NULL,NULL,NULL),('1219099842240962562',NULL,NULL,2,1,NULL,'13338577800','297078','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 11:30:26',NULL,NULL,NULL),('1219101672190631937',NULL,NULL,2,1,NULL,'13338577800','844028','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 11:37:43',NULL,NULL,NULL),('1219102054350446593',NULL,NULL,2,1,NULL,'13338577800','978107','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 11:39:14',NULL,NULL,NULL),('1219107538524561409',NULL,NULL,2,1,NULL,'18965878729','251857','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 12:01:01',NULL,NULL,NULL),('1219114402519834625',NULL,NULL,2,1,NULL,'13959777981','412344','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 12:28:18',NULL,NULL,NULL),('1219114734977146882',NULL,NULL,2,1,NULL,'15396380625','493523','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 12:29:37',NULL,NULL,NULL),('1219115472973324289',NULL,NULL,2,1,NULL,'15396380625','529180','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 12:32:33',NULL,NULL,NULL),('1219116984533377026',NULL,NULL,2,1,NULL,'13959777981','532265','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 12:38:33',NULL,NULL,NULL),('1219121828140802049',NULL,NULL,2,1,NULL,'15396380625','518287','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 12:57:48',NULL,NULL,NULL),('1219122272946741250',NULL,NULL,2,1,NULL,'15396380625','652133','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 12:59:34',NULL,NULL,NULL),('1219123115527888897',NULL,NULL,2,1,NULL,'15396380625','044308','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:02:55',NULL,NULL,NULL),('1219127334976741378',NULL,NULL,2,1,NULL,'15905975168','424681','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:19:41',NULL,NULL,NULL),('1219127852864233473',NULL,NULL,2,1,NULL,'18016516089','626998','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:21:45',NULL,NULL,NULL),('1219129686781714433',NULL,NULL,2,1,NULL,'13489875197','279516','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:29:02',NULL,NULL,NULL),('1219130421091098625',NULL,NULL,2,1,NULL,'13489875197','384504','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:31:57',NULL,NULL,NULL),('1219132898343510017',NULL,NULL,2,1,NULL,'13489875197','725635','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:41:48',NULL,NULL,NULL),('1219134488387379201',NULL,NULL,2,1,NULL,'13489875197','850426','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:48:07',NULL,NULL,NULL),('1219134807498416129',NULL,NULL,2,1,NULL,'13489875197','154112','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 13:49:23',NULL,NULL,NULL),('1219139437498327042',NULL,NULL,2,1,NULL,'15905035025','584693','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 14:07:47',NULL,NULL,NULL),('1219143646901821442',NULL,NULL,2,1,NULL,'15396395062','838253','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 14:24:30',NULL,NULL,NULL),('1219144512337731586',NULL,NULL,2,1,NULL,'13960228853','149920','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 14:27:57',NULL,NULL,NULL),('1219144572328861697',NULL,NULL,2,1,NULL,'18159581122','067175','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 14:28:11',NULL,NULL,NULL),('1219146860732735489',NULL,NULL,2,1,NULL,'18159581122','834931','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 14:37:16',NULL,NULL,NULL),('1219148740523319298',NULL,NULL,2,1,NULL,'13489875197','663301','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 14:44:45',NULL,NULL,NULL),('1219149229440753666','1217806607539306498',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 14:46:41',NULL,NULL,NULL),('1219158575767740418',NULL,NULL,2,1,NULL,'15906099696','136125','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 15:23:49',NULL,NULL,NULL),('1219159614562623490',NULL,NULL,2,1,NULL,'15080426614','225397','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 15:27:57',NULL,NULL,NULL),('1219165877069537282',NULL,NULL,2,1,NULL,'13960228853','765063','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 15:52:50',NULL,NULL,NULL),('1219166362186932226',NULL,NULL,2,1,NULL,'13850752082','373882','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 15:54:46',NULL,NULL,NULL),('1219169544376016898',NULL,NULL,2,1,NULL,'13960358840','866234','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:07:25',NULL,NULL,NULL),('1219170983089397761',NULL,NULL,2,1,NULL,'13859776052','817238','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:13:08',NULL,NULL,NULL),('1219171447751172098',NULL,NULL,2,1,NULL,'13859776052','240870','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:14:58',NULL,NULL,NULL),('1219172687646154753',NULL,NULL,2,1,NULL,'13906095454','612969','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:19:54',NULL,NULL,NULL),('1219172964256309249',NULL,NULL,2,1,NULL,'15960788001','727782','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:21:00',NULL,NULL,NULL),('1219177790658699266',NULL,NULL,2,1,NULL,'13960358840','445024','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:40:11',NULL,NULL,NULL),('1219178254460641281',NULL,NULL,2,1,NULL,'15259513222','825732','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:42:01',NULL,NULL,NULL),('1219179025080115202',NULL,NULL,2,1,NULL,'13960358840','800010','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:45:05',NULL,NULL,NULL),('1219179840037576706',NULL,NULL,2,1,NULL,'13459504545','585471','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:48:19',NULL,NULL,NULL),('1219180109110566914',NULL,NULL,2,1,NULL,'13459504545','184591','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:49:23',NULL,NULL,NULL),('1219181094017032194',NULL,NULL,2,1,NULL,'13365952758','684042','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:53:18',NULL,NULL,NULL),('1219182053556346881',NULL,NULL,2,1,NULL,'15375886386','853962','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 16:57:07',NULL,NULL,NULL),('1219184393604685826',NULL,NULL,2,1,NULL,'15375886386','905014','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:06:25',NULL,NULL,NULL),('1219184774078390273',NULL,NULL,2,1,NULL,'15960731557','876317','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:07:56',NULL,NULL,NULL),('1219186559455191041',NULL,NULL,2,1,NULL,'13959737339','683318','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:15:01',NULL,NULL,NULL),('1219189213908557826',NULL,NULL,2,1,NULL,'13960358840','115050','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:25:34',NULL,NULL,NULL),('1219189394829860865',NULL,NULL,2,1,NULL,'15375886386','187103','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:26:17',NULL,NULL,NULL),('1219190110277459970',NULL,NULL,2,1,NULL,'13506030795','302532','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:29:08',NULL,NULL,NULL),('1219191443021750274',NULL,NULL,2,1,NULL,'13960358840','245445','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:34:26',NULL,NULL,NULL),('1219192322990923777',NULL,NULL,2,1,NULL,'13599773033','263965','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:37:55',NULL,NULL,NULL),('1219192432567115778',NULL,NULL,2,1,NULL,'13960358840','537769','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:38:22',NULL,NULL,NULL),('1219193312712450050',NULL,NULL,2,1,NULL,'13959737339','304487','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:41:51',NULL,NULL,NULL),('1219193365548097537',NULL,NULL,2,1,NULL,'15375886386','712086','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:42:04',NULL,NULL,NULL),('1219194865733197826',NULL,NULL,2,1,NULL,'15259741125','874320','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 17:48:02',NULL,NULL,NULL),('1219240111611437058',NULL,NULL,2,1,NULL,'15260663037','938366','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 20:47:49',NULL,NULL,NULL),('1219241313854152706',NULL,NULL,2,1,NULL,'15260663037','720085','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 20:52:36',NULL,NULL,NULL),('1219242530844041217',NULL,NULL,2,1,NULL,'15260663037','368664','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 20:57:26',NULL,NULL,NULL),('1219245580518285313',NULL,NULL,2,1,NULL,'13959737339','418884','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 21:09:33',NULL,NULL,NULL),('1219253120861855746',NULL,NULL,2,1,NULL,'13959737339','641413','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 21:39:31',NULL,NULL,NULL),('1219254428369018881',NULL,NULL,2,1,NULL,'15375754488','011203','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 21:44:43',NULL,NULL,NULL),('1219255693736009729',NULL,NULL,2,1,NULL,'15859590857','789818','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 21:49:44',NULL,NULL,NULL),('1219273875968352258',NULL,NULL,2,1,NULL,'18372551198','475927','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 23:01:59',NULL,NULL,NULL),('1219284538841153537',NULL,NULL,2,1,NULL,'18372551198','291049','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-20',NULL,NULL,NULL,'2020-01-20 23:44:21',NULL,NULL,NULL),('1219418038776938497',NULL,NULL,2,1,NULL,'13960358840','176674','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 08:34:50',NULL,NULL,NULL),('1219425295828828162',NULL,NULL,2,1,NULL,'18659005089','283377','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 09:03:41',NULL,NULL,NULL),('1219427171097952257',NULL,NULL,2,1,NULL,'13506095562','039375','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 09:11:08',NULL,NULL,NULL),('1219428523635163138',NULL,NULL,2,1,NULL,'13506095562','316924','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 09:16:30',NULL,NULL,NULL),('1219432517468209154','1212962518260060162',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 09:32:22',NULL,NULL,NULL),('1219436480485703682',NULL,NULL,2,1,NULL,'15375886386','954334','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 09:48:07',NULL,NULL,NULL),('1219440570993262594','1216229133139341313',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:04:22',NULL,NULL,NULL),('1219440949713747970',NULL,NULL,2,1,NULL,'18605002505','460879','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:05:53',NULL,NULL,NULL),('1219442761246228481','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:13:05',NULL,NULL,NULL),('1219442782700093442','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:13:10',NULL,NULL,NULL),('1219444333669826561',NULL,NULL,2,1,NULL,'18259038660','235763','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:19:19',NULL,NULL,NULL),('1219445408581861378','1219440890318209025',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:23:36',NULL,NULL,NULL),('1219445830541426689',NULL,NULL,2,1,NULL,'18605002505','601323','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:25:16',NULL,NULL,NULL),('1219448138121658369',NULL,NULL,2,1,NULL,'13665975556','521255','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:34:27',NULL,NULL,NULL),('1219449434929152002',NULL,NULL,2,1,NULL,'13665975556','464453','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:39:36',NULL,NULL,NULL),('1219449450150281218',NULL,NULL,2,1,NULL,'13960358840','703955','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:39:39',NULL,NULL,NULL),('1219449961234612225',NULL,NULL,2,1,NULL,'15805039263','043852','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:41:41',NULL,NULL,NULL),('1219451333040455682',NULL,NULL,2,1,NULL,'13928388546','665028','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:47:08',NULL,NULL,NULL),('1219451383976083458',NULL,NULL,2,1,NULL,'18650672995','844924','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:47:20',NULL,NULL,NULL),('1219452341648932866',NULL,NULL,2,1,NULL,'13850755337','579326','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:51:09',NULL,NULL,NULL),('1219453623872831489',NULL,NULL,2,1,NULL,'13850755337','902460','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 10:56:14',NULL,NULL,NULL),('1219467271924137986',NULL,NULL,2,1,NULL,'15959595731','188424','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 11:50:28',NULL,NULL,NULL),('1219504478420516866',NULL,NULL,2,1,NULL,'15880758339','768017','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 14:18:19',NULL,NULL,NULL),('1219509413665095681',NULL,NULL,2,1,NULL,'18160997720','050395','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 14:37:56',NULL,NULL,NULL),('1219512439775739906',NULL,NULL,2,1,NULL,'15880801277','092421','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 14:49:57',NULL,NULL,NULL),('1219516895376490498',NULL,NULL,2,1,NULL,'13159037366','087768','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 15:07:40',NULL,NULL,NULL),('1219517563252293634',NULL,NULL,2,1,NULL,'15880713988','091049','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 15:10:19',NULL,NULL,NULL),('1219529861266194434',NULL,NULL,2,1,NULL,'18659822322','986329','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 15:59:11',NULL,NULL,NULL),('1219530379539562497',NULL,NULL,2,1,NULL,'15859506299','497039','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 16:01:14',NULL,NULL,NULL),('1219531044911366145',NULL,NULL,2,1,NULL,'13799599097','512029','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 16:03:53',NULL,NULL,NULL),('1219531325866819585',NULL,NULL,2,1,NULL,'13799599097','007707','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 16:05:00',NULL,NULL,NULL),('1219535690618945537',NULL,NULL,2,1,NULL,'18750561717','731120','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 16:22:21',NULL,NULL,NULL),('1219538721011974145',NULL,NULL,2,1,NULL,'18659501212','754608','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 16:34:23',NULL,NULL,NULL),('1219544985045614594',NULL,NULL,2,1,NULL,'15964917281','976285','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 16:59:17',NULL,NULL,NULL),('1219545015827611650',NULL,NULL,2,1,NULL,'18960276085','671557','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 16:59:24',NULL,NULL,NULL),('1219545716179910657',NULL,NULL,2,1,NULL,'18960276085','656866','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 17:02:11',NULL,NULL,NULL),('1219546940111372290',NULL,NULL,2,1,NULL,'18960276085','178387','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 17:07:03',NULL,NULL,NULL),('1219555193876692994',NULL,NULL,2,1,NULL,'13959992226','940067','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 17:39:51',NULL,NULL,NULL),('1219556370525765633',NULL,NULL,2,1,NULL,'13959992226','876925','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 17:44:31',NULL,NULL,NULL),('1219564867313254402',NULL,NULL,2,1,NULL,'18659822322','326933','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 18:18:17',NULL,NULL,NULL),('1219609257670918146',NULL,NULL,2,1,NULL,'13788816686','269785','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 21:14:40',NULL,NULL,NULL),('1219616901257281537',NULL,NULL,2,1,NULL,'15980006525','556408','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 21:45:03',NULL,NULL,NULL),('1219636329625731074',NULL,NULL,2,1,NULL,'13911221419','866115','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 23:02:15',NULL,NULL,NULL),('1219636774880460801',NULL,NULL,2,1,NULL,'13911221419','906996','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-21',NULL,NULL,NULL,'2020-01-21 23:04:01',NULL,NULL,NULL),('1219678535187185666',NULL,NULL,2,1,NULL,'19959952885','826337','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 01:49:47',NULL,NULL,NULL),('1219684732036464642',NULL,NULL,2,1,NULL,'19959952885','266768','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 02:14:35',NULL,NULL,NULL),('1219781568621461505',NULL,NULL,2,1,NULL,'13799550180','565531','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 08:39:23',NULL,NULL,NULL),('1219786348798427138','1219684860977758209',NULL,2,2,'晋江市守望麦田教育咨询有限公司','19959952885','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 08:58:22',NULL,NULL,NULL),('1219786778202882049','72',NULL,1,2,'翁海勇','13599173733','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 09:00:05',NULL,NULL,NULL),('1219786799585443842','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 09:00:10',NULL,NULL,NULL),('1219786799757410306','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 09:00:10',NULL,NULL,NULL),('1219789346941452290','1211452681604874242',NULL,2,2,'泉州巾帼人力资源发展有限公司','18159352255','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 09:10:17',NULL,NULL,NULL),('1219799121926307842','1219637247674990594',NULL,2,2,'晋江市梧林青普文旅运营管理有限公司','13911221419','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 09:49:08',NULL,NULL,NULL),('1219802807557701634','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:03:46',NULL,NULL,NULL),('1219803993216139265','1219609878780231682',NULL,2,2,'福能期货股份有限公司晋江营业部','13788816686','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:08:29',NULL,NULL,NULL),('1219804229070241793','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:09:25',NULL,NULL,NULL),('1219804425455943682','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务远翔公司','13959992226','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:10:12',NULL,NULL,NULL),('1219804452022665217','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:10:18',NULL,NULL,NULL),('1219806036857208833','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务远翔公司','13959992226','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:16:36',NULL,NULL,NULL),('1219807455869943810','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:22:15',NULL,NULL,NULL),('1219807559586693122','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:22:39',NULL,NULL,NULL),('1219807860788051970',NULL,NULL,2,1,NULL,'13911221419','986591','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:23:51',NULL,NULL,NULL),('1219808499907706881',NULL,NULL,2,1,NULL,'13305956810','348267','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:26:23',NULL,NULL,NULL),('1219813101499596802','1219808912245538817',NULL,2,2,'福建省地信数据科技有限公司晋江分公司','13305956810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:44:41',NULL,NULL,NULL),('1219813750056435714','1219808912245538817',NULL,2,2,'福建省地信数据科技有限公司晋江分公司','13305956810','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:47:15',NULL,NULL,NULL),('1219814202902855682','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 10:49:03',NULL,NULL,NULL),('1219820354793390082',NULL,NULL,2,1,NULL,'18050881166','729215','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 11:13:30',NULL,NULL,NULL),('1219821262998618114',NULL,NULL,2,1,NULL,'18050881166','431931','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 11:17:06',NULL,NULL,NULL),('1219821594633846786',NULL,NULL,2,1,NULL,'18050881166','319257','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 11:18:26',NULL,NULL,NULL),('1219823499854495745',NULL,NULL,2,1,NULL,'18050881166','822066','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 11:26:00',NULL,NULL,NULL),('1219829308151840769','1219792929099366402',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 11:49:05',NULL,NULL,NULL),('1219860206003961857',NULL,NULL,2,1,NULL,'13506099300','436407','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 13:51:51',NULL,NULL,NULL),('1219867454138761217',NULL,NULL,2,1,NULL,'13808552366','709912','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 14:20:39',NULL,NULL,NULL),('1219880689218895874','1219609878780231682',NULL,2,2,'福能期货股份有限公司晋江营业部','13788816686','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 15:13:15',NULL,NULL,NULL),('1219880851156779010','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 15:13:53',NULL,NULL,NULL),('1219881244888678402','1219824202652073985',NULL,2,2,'泉州市雄健体育用品有限公司','18050881166','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 15:15:27',NULL,NULL,NULL),('1219881408697221122','1219868423635353602',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 15:16:06',NULL,NULL,NULL),('1219881491308232705','1219449507670966273',NULL,2,2,'晋江润德商业有限公司迎宾路分公司','13665975556','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 15:16:26',NULL,NULL,NULL),('1219890400139952130',NULL,NULL,2,1,NULL,'13306051592','746544','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 15:51:50',NULL,NULL,NULL),('1219891391014912001','1219609878780231682',NULL,2,2,'福能期货股份有限公司晋江营业部','13788816686','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 15:55:46',NULL,NULL,NULL),('1219894346543808514',NULL,NULL,2,1,NULL,'18859969666','449551','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 16:07:31',NULL,NULL,NULL),('1219894636596707329','1219609878780231682',NULL,2,2,'福能期货股份有限公司晋江营业部','13788816686','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 16:08:40',NULL,NULL,NULL),('1219895051002331138','1219637247674990594',NULL,2,2,'晋江市梧林青普投资有限公司','13911221419','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 16:10:19',NULL,NULL,NULL),('1219896111783755777',NULL,NULL,2,1,NULL,'13306051592','810883','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 16:14:32',NULL,NULL,NULL),('1219897500274540546','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 16:20:03',NULL,NULL,NULL),('1219928021281030146',NULL,NULL,2,1,NULL,'13600704026','446475','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 18:21:20',NULL,NULL,NULL),('1219961339745681410',NULL,NULL,2,1,NULL,'13600770238','447521','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 20:33:43',NULL,NULL,NULL),('1219965398342975490',NULL,NULL,2,1,NULL,'13600704026','868648','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 20:49:51',NULL,NULL,NULL),('1219982060362416130',NULL,NULL,2,1,NULL,'13850751502','236646','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 21:56:04',NULL,NULL,NULL),('1219983426371731458',NULL,NULL,2,1,NULL,'13850751502','872515','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 22:01:29',NULL,NULL,NULL),('1219992594059116546',NULL,NULL,2,1,NULL,'13600704026','639447','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-22',NULL,NULL,NULL,'2020-01-22 22:37:55',NULL,NULL,NULL),('1220135702776266754','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 08:06:35',NULL,NULL,NULL),('1220135912810233857','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 08:07:25',NULL,NULL,NULL),('1220149165787463681','58',NULL,1,2,'张荣荣','15280619456','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 09:00:05',NULL,NULL,NULL),('1220149187182608385','87',NULL,1,2,'叶志钦','13675957398','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 09:00:10',NULL,NULL,NULL),('1220153092805246977','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 09:15:41',NULL,NULL,NULL),('1220155769794609154','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-01-23',NULL,NULL,NULL,'2020-01-23 09:26:19',NULL,NULL,NULL),('1220159892124352514','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 09:42:42',NULL,NULL,NULL),('1220161896838086657','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 09:50:40',NULL,NULL,NULL),('1220163009511440385',NULL,NULL,2,1,NULL,'15859555637','350287','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 09:55:05',NULL,NULL,NULL),('1220165240583372801',NULL,NULL,2,1,NULL,'15859555637','924415','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 10:03:57',NULL,NULL,NULL),('1220167197066805249',NULL,NULL,2,1,NULL,'18050877288','868823','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 10:11:44',NULL,NULL,NULL),('1220168340455047169','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 10:16:16',NULL,NULL,NULL),('1220173766236061697',NULL,NULL,2,1,NULL,'13599204959','805442','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 10:37:50',NULL,NULL,NULL),('1220176075896668161',NULL,NULL,2,1,NULL,'13599204959','808154','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 10:47:00',NULL,NULL,NULL),('1220177472620871681',NULL,NULL,2,1,NULL,'13599204959','220470','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 10:52:33',NULL,NULL,NULL),('1220178754131738626','1220177570545287169',NULL,2,2,'安塔（福建）机械设备实业有限公司','13599204959','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 10:57:39',NULL,NULL,NULL),('1220179943250477058',NULL,NULL,2,1,NULL,'13599703460','240050','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 11:02:22',NULL,NULL,NULL),('1220181470698553345','1220180021985951745',NULL,2,2,'晋江市新合发塑胶印刷有限公司','13599703460','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 11:08:27',NULL,NULL,NULL),('1220268066466709505',NULL,NULL,2,1,NULL,'15964917281','131816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 16:52:33',NULL,NULL,NULL),('1220269414323077122',NULL,NULL,2,1,NULL,'15964917281','065994','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 16:57:54',NULL,NULL,NULL),('1220276400632643585',NULL,NULL,2,1,NULL,'13600704026','828158','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 17:25:40',NULL,NULL,NULL),('1220301739589124098','1220276790312845313',NULL,2,2,'晋江市东石镇成圆方广告服务部','13600704026','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 19:06:21',NULL,NULL,NULL),('1220302073174704130','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 19:07:41',NULL,NULL,NULL),('1220302292520026114',NULL,NULL,2,1,NULL,'13600704026','805792','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 19:08:33',NULL,NULL,NULL),('1220307548360425474','1220276790312845313',NULL,2,2,'晋江市东石镇成圆方广告服务部','13600704026','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-01-23',NULL,NULL,NULL,'2020-01-23 19:29:26',NULL,NULL,NULL),('1220511553615314945','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-24',NULL,NULL,NULL,'2020-01-24 09:00:05',NULL,NULL,NULL),('1220511574993682434','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-24',NULL,NULL,NULL,'2020-01-24 09:00:10',NULL,NULL,NULL),('1221598717434413057','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-27',NULL,NULL,NULL,'2020-01-27 09:00:05',NULL,NULL,NULL),('1221598738846334978','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-27',NULL,NULL,NULL,'2020-01-27 09:00:10',NULL,NULL,NULL),('1221961105039966209','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-28',NULL,NULL,NULL,'2020-01-28 09:00:05',NULL,NULL,NULL),('1221961126464471042','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-28',NULL,NULL,NULL,'2020-01-28 09:00:10',NULL,NULL,NULL),('1222323493157224450','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-29',NULL,NULL,NULL,'2020-01-29 09:00:05',NULL,NULL,NULL),('1222323514590117889','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-29',NULL,NULL,NULL,'2020-01-29 09:00:10',NULL,NULL,NULL),('1222685880758583298','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-30',NULL,NULL,NULL,'2020-01-30 09:00:05',NULL,NULL,NULL),('1222685902183088129','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-30',NULL,NULL,NULL,'2020-01-30 09:00:10',NULL,NULL,NULL),('1223048268682903553','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-31',NULL,NULL,NULL,'2020-01-31 09:00:05',NULL,NULL,NULL),('1223048290061271042','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-01-31',NULL,NULL,NULL,'2020-01-31 09:00:10',NULL,NULL,NULL),('1224135432401338369','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-03',NULL,NULL,NULL,'2020-02-03 09:00:05',NULL,NULL,NULL),('1224135453830037506','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-03',NULL,NULL,NULL,'2020-02-03 09:00:10',NULL,NULL,NULL),('1224493888622837762','1212567522423934978',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 08:44:27',NULL,NULL,NULL),('1224497602049884162','1212575205948461057',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 08:59:13',NULL,NULL,NULL),('1224497820128526338','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:00:05',NULL,NULL,NULL),('1224497841481728002','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:00:10',NULL,NULL,NULL),('1224499476811497473','1212579981331337217',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:06:40',NULL,NULL,NULL),('1224500425357541377','1212580034712244226',NULL,2,2,'浩沙实业（福建）有限公司','13905089190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:10:26',NULL,NULL,NULL),('1224503708755181569','1212600949760135170',NULL,2,2,'浩沙实业（福建）有限公司','13905089190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:23:29',NULL,NULL,NULL),('1224505608334491650','1212607283893178369',NULL,2,2,'浩沙实业（福建）有限公司','13905089190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:31:01',NULL,NULL,NULL),('1224506723897720834','1212608748166647810',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:35:27',NULL,NULL,NULL),('1224511203024322561','1212632261338402818',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:53:15',NULL,NULL,NULL),('1224512147598360578','1212637667074838529',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 09:57:00',NULL,NULL,NULL),('1224515878767312897','1212641622613889026',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 10:11:50',NULL,NULL,NULL),('1224518909353279490','1212647370311929858',NULL,2,2,'浩沙实业（福建）有限公司','13905089190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 10:23:53',NULL,NULL,NULL),('1224523980652691458','1212647642031525890',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 10:44:02',NULL,NULL,NULL),('1224525724061286402','1212657319473647618',NULL,2,2,'浩沙实业（福建）有限公司','13905089190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 10:50:57',NULL,NULL,NULL),('1224609508651712513','1212596177489432578',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-04',NULL,NULL,NULL,'2020-02-04 16:23:53',NULL,NULL,NULL),('1224860208233201665','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-05',NULL,NULL,NULL,'2020-02-05 09:00:05',NULL,NULL,NULL),('1224860229695455233','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-05',NULL,NULL,NULL,'2020-02-05 09:00:10',NULL,NULL,NULL),('1224882183680835585',NULL,NULL,2,1,NULL,'13799857333','586019','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-05',NULL,NULL,NULL,'2020-02-05 10:27:24',NULL,NULL,NULL),('1225222595821977601','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 09:00:05',NULL,NULL,NULL),('1225222617242288130','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 09:00:10',NULL,NULL,NULL),('1225225392801988610','1212657476319645697',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 09:11:11',NULL,NULL,NULL),('1225228018729893889','1212658332729413634',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 09:21:37',NULL,NULL,NULL),('1225230183871561730','1212658529249333250',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 09:30:14',NULL,NULL,NULL),('1225233589331836930','1212658872058187777',NULL,2,2,'福建省晋江市三力机车有限公司','18965689935','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 09:43:46',NULL,NULL,NULL),('1225236070388482049','1212663550716219394',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 09:53:37',NULL,NULL,NULL),('1225237989534220289','1212666654106914817',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 10:01:15',NULL,NULL,NULL),('1225239778019000321','1212667563964698626',NULL,2,2,'浩沙实业（福建）有限公司','13905089190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 10:08:21',NULL,NULL,NULL),('1225241449914712066','1212674951778209793',NULL,2,2,'泉州市里仁财务咨询有限公司','15880720190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 10:15:00',NULL,NULL,NULL),('1225243248591650818','1212677254027481089',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 10:22:09',NULL,NULL,NULL),('1225255698695208962','1212680200152748034',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 11:11:37',NULL,NULL,NULL),('1225257316027219969','1212683942583406594',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 11:18:02',NULL,NULL,NULL),('1225260516880957441','1212683619374534657',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 11:30:46',NULL,NULL,NULL),('1225314780328247297','1212684140613275649',NULL,2,2,'晋江裕福集团有限公司','18759429880','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 15:06:23',NULL,NULL,NULL),('1225316988490891265','1212685670133338114',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 15:15:10',NULL,NULL,NULL),('1225320672310345730','1212688098635354113',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 15:29:48',NULL,NULL,NULL),('1225323706776043522','1211862889812508674',NULL,2,2,'福建省晋江市福埔S.M国际广场','15059551567','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 15:41:51',NULL,NULL,NULL),('1225324177880268802','1212938213098852353',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 15:43:44',NULL,NULL,NULL),('1225326839614947330','1211909253418237954',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 15:54:18',NULL,NULL,NULL),('1225329064588361730','1212897100929503234',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:03:09',NULL,NULL,NULL),('1225329929671950338','1212933920325177346',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:06:35',NULL,NULL,NULL),('1225330594724986881','1212902667278422017',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:09:13',NULL,NULL,NULL),('1225333735344324610','1212933809062875137',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:21:42',NULL,NULL,NULL),('1225334283158175745','1212894669021712385',NULL,2,2,'晋江市安海镇卫生院','13799557721','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:23:53',NULL,NULL,NULL),('1225336231630487554','1212903750239326209',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:31:37',NULL,NULL,NULL),('1225337661267394561','1212927832926261250',NULL,2,2,'福建泉成机械有限公司','15392286115','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:37:18',NULL,NULL,NULL),('1225341862454247425','1211919059642269697',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 16:54:00',NULL,NULL,NULL),('1225343440884088833','1212924522345336834',NULL,2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 17:00:16',NULL,NULL,NULL),('1225345205046099970','1213042992743518210',NULL,2,2,'晋江市品质陶瓷建材有限公司','15106011992','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 17:07:17',NULL,NULL,NULL),('1225347714212970497','1212902867833262081',NULL,2,2,'迦南（福建）新材料科技有限公司','18959995705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 17:17:15',NULL,NULL,NULL),('1225351219841613826','1212985756319027201',NULL,2,2,'琪尔特股份有限公司','18859969666','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 17:31:11',NULL,NULL,NULL),('1225353881454657538','1213026211559706625',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-06',NULL,NULL,NULL,'2020-02-06 17:41:45',NULL,NULL,NULL),('1225578898926911489','1212905727883022338',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 08:35:54',NULL,NULL,NULL),('1225580380967452674','1212905755926138882',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 08:41:47',NULL,NULL,NULL),('1225584984580997122','58',NULL,1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:00:05',NULL,NULL,NULL),('1225584984580997123','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:00:05',NULL,NULL,NULL),('1225585006080999426','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:00:10',NULL,NULL,NULL),('1225585006080999427','87',NULL,1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:00:10',NULL,NULL,NULL),('1225585797349031937','1212912656298610690',NULL,2,2,'福建省育才建设发展有限公司','13788846820','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:03:19',NULL,NULL,NULL),('1225586637841416193','1212950205255716866',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:06:39',NULL,NULL,NULL),('1225587611767193602','1212658872058187777',NULL,2,2,'福建省晋江市三力机车有限公司','18965689935','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:10:31',NULL,NULL,NULL),('1225591818192732162','1212918170390695937',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:27:14',NULL,NULL,NULL),('1225596140704022530','1211941475839950850',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:44:25',NULL,NULL,NULL),('1225596304772612097','1213420676216590338',NULL,2,2,'晋江市远祥服装织造有限公司','17759990690','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:45:04',NULL,NULL,NULL),('1225597190127271938','1212946031856128001',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:48:35',NULL,NULL,NULL),('1225598253525942274','1211942399333416962',NULL,2,2,'福建省晋江产业发展投资集团有限公司','13599789599','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 09:52:48',NULL,NULL,NULL),('1225600541971759105','1211943010711945217',NULL,2,2,'中菱（福建）电梯有限公司','18959847128','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:01:54',NULL,NULL,NULL),('1225603052795379714','1212924904316407809',NULL,2,2,'泉州星城纸业有限公司','15959856777','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:11:53',NULL,NULL,NULL),('1225604998604308481','1212941994020638721',NULL,2,2,'顺宏达（福建）针织服饰有限公司','15905907962','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:19:36',NULL,NULL,NULL),('1225606770899075073','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:26:39',NULL,NULL,NULL),('1225607414405971970','1212943349011517441',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:29:12',NULL,NULL,NULL),('1225607802802716673','1212974473033093121',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:30:45',NULL,NULL,NULL),('1225608590153269249','1211953724851798017',NULL,2,2,'福建楚威贸易有限公司','13506055705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:33:53',NULL,NULL,NULL),('1225608881103749122','1212943464417792002',NULL,2,2,'兴业皮革科技股份有限公司','18859716647','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:35:02',NULL,NULL,NULL),('1225610876929753090','1212945396666535937',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:42:58',NULL,NULL,NULL),('1225611774305288194','1212947823172063234',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:46:32',NULL,NULL,NULL),('1225614657734098945','1212956968151486466',NULL,2,2,'晋江市品质陶瓷建材有限公司','15106011992','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 10:57:59',NULL,NULL,NULL),('1225615728648962049','1212967890165239809',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 11:02:15',NULL,NULL,NULL),('1225616345698189314','1212897100929503234',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 11:04:42',NULL,NULL,NULL),('1225617722558169089','1212968372904464385',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 11:10:10',NULL,NULL,NULL),('1225618707347193858','1212969066218721282',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 11:14:05',NULL,NULL,NULL),('1225618834468159489','1212971976801456129',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 11:14:35',NULL,NULL,NULL),('1225619211938742273','1212209407291625473',NULL,2,2,'晋江市新佳园资产管理有限公司','13255006151','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 11:16:05',NULL,NULL,NULL),('1225675418837762049','1211943010711945217',NULL,2,2,'中菱（福建）电梯有限公司','18959847128','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 14:59:26',NULL,NULL,NULL),('1225677543378567170','1212549256930463745',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:07:52',NULL,NULL,NULL),('1225678677396733953','1212558974272999426',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:12:23',NULL,NULL,NULL),('1225680335967141890','1212924904316407809',NULL,2,2,'泉州星城纸业有限公司','15959856777','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:18:58',NULL,NULL,NULL),('1225681628290924546','1212561682967105537',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:24:06',NULL,NULL,NULL),('1225683457204600834','1213292302215221250',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:31:22',NULL,NULL,NULL),('1225685051316944898','1213290742638776322',NULL,2,2,'福建泉成机械有限公司','15392286115','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:37:43',NULL,NULL,NULL),('1225685068123521025','1213022671835566081',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:37:47',NULL,NULL,NULL),('1225685641254191105','1212972053599162370',NULL,2,2,'三六一度（福建）体育用品有限公司','13625976298','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:40:03',NULL,NULL,NULL),('1225686804124975106','1212978268479754242',NULL,2,2,'兴业皮革科技股份有限公司','18859716647','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:44:40',NULL,NULL,NULL),('1225687088217767938','1213283951964131330',NULL,2,2,'福建省育才建设发展有限公司','13788846820','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:45:48',NULL,NULL,NULL),('1225689936460562433','1212983011176419329',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 15:57:07',NULL,NULL,NULL),('1225691479536615426','1213017769201700865',NULL,2,2,'福建海创医药科技有限公司','13559060707','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:03:15',NULL,NULL,NULL),('1225694572621905922','1212980344865755138',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:15:33',NULL,NULL,NULL),('1225694911748161537','1212658872058187777',NULL,2,2,'福建省晋江市三力机车有限公司','18965689935','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:16:53',NULL,NULL,NULL),('1225695873892139009','1212985083577831426',NULL,2,2,'福建省晋江市三力机车有限公司','18965689935','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:20:43',NULL,NULL,NULL),('1225695995296268290','1213282411031367682',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:21:12',NULL,NULL,NULL),('1225696627113639937','1212987116238213122',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:23:42',NULL,NULL,NULL),('1225697541505466370','1212674951778209793',NULL,2,2,'泉州市里仁财务咨询有限公司','15880720190','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:27:20',NULL,NULL,NULL),('1225697880770134018','1213282201777541122',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:28:41',NULL,NULL,NULL),('1225698144075956225','1212987260249640961',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:29:44',NULL,NULL,NULL),('1225699344544481282','1213274805487341570',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:34:30',NULL,NULL,NULL),('1225699379743080449','1212695165861433346',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:34:39',NULL,NULL,NULL),('1225701565550084097','1213270758189502466',NULL,2,2,'福建省育才建设发展有限公司','13788846820','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:43:20',NULL,NULL,NULL),('1225703430752878594','1213265730556989441',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:50:45',NULL,NULL,NULL),('1225704780588957698','1213265388700241921',NULL,2,2,'福建省育才建设发展有限公司','13788846820','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:56:06',NULL,NULL,NULL),('1225705274275315714','1212699084805181441',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 16:58:04',NULL,NULL,NULL),('1225706279918419969','1213260782201016321',NULL,2,2,'中桥文化传媒（福建）股份有限公司','15359823950','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 17:02:04',NULL,NULL,NULL),('1225707486737121281','1213256522814001154',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 17:06:52',NULL,NULL,NULL),('1225709658585481218','1212902667278422017',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 17:15:29',NULL,NULL,NULL),('1225711342535622658','1212902867833262081',NULL,2,2,'迦南（福建）新材料科技有限公司','18959995705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 17:22:11',NULL,NULL,NULL),('1225712287084494849',NULL,NULL,2,1,NULL,'18150505789','395427','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-07',NULL,NULL,NULL,'2020-02-07 17:25:56',NULL,NULL,NULL),('1225980316171186177','1212902867833262081',NULL,2,2,'迦南（福建）新材料科技有限公司','18959995705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-08',NULL,NULL,NULL,'2020-02-08 11:10:59',NULL,NULL,NULL),('1226668795221848066','1213021272770940930',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 08:46:45',NULL,NULL,NULL),('1226670925148139521','1213084910835798017',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 08:55:13',NULL,NULL,NULL),('1226671754957631489','1213080342668316673',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 08:58:31',NULL,NULL,NULL),('1226674154183405569','1213023506338484226',NULL,2,2,'福建省致慧医疗科技有限公司','19942826787','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:08:03',NULL,NULL,NULL),('1226674399545995265','1213077517758435329',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:09:02',NULL,NULL,NULL),('1226675417683931138','1212989091294023681',NULL,2,2,'凯毅（福建）体育用品有限公司','18960357668','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:13:04',NULL,NULL,NULL),('1226676242649001986','1213012502506442754',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:16:21',NULL,NULL,NULL),('1226677883985014786','1213004988083671042',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:22:52',NULL,NULL,NULL),('1226678243088740353','1213024390346772482',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:24:18',NULL,NULL,NULL),('1226681315143790594','1213004687175913474',NULL,2,2,'福建省卓展信息科技股份有限公司','17350926157','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:36:30',NULL,NULL,NULL),('1226682279292645377','1213056936719749122',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:40:20',NULL,NULL,NULL),('1226683726516269057','1213058002945380353',NULL,2,2,'晋江友峰鞋业有限公司','15306089555','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:46:05',NULL,NULL,NULL),('1226683938542530561','1213074866991861762',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:46:56',NULL,NULL,NULL),('1226684243095138305','1213364861812150274',NULL,2,2,'福建亿龙建工有限公司','13506069172','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:48:08',NULL,NULL,NULL),('1226685197697757185','1213294989413519362',NULL,2,2,'福建省卓展信息科技股份有限公司','17350926157','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:51:56',NULL,NULL,NULL),('1226686238585597954','1213071853334106114',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:56:04',NULL,NULL,NULL),('1226686590554812417','1213364068425994241',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:57:28',NULL,NULL,NULL),('1226686883556306945','1213296617474560002',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 09:58:38',NULL,NULL,NULL),('1226689381855735809','1213066837890240514',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:08:34',NULL,NULL,NULL),('1226689735632695297','1213361485699420161',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:09:58',NULL,NULL,NULL),('1226690959429939202','1213299717002301441',NULL,2,2,'大发科技集团有限公司','18959857088','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:14:50',NULL,NULL,NULL),('1226691473647415298','1213356697788157953',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:16:52',NULL,NULL,NULL),('1226693011296038913','1213353405095940097',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:22:59',NULL,NULL,NULL),('1226693832024862722','1213304930010468353',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:26:15',NULL,NULL,NULL),('1226695667934638082','1213332419713765378',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:33:32',NULL,NULL,NULL),('1226696067920244738','1213301849034133506',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:35:08',NULL,NULL,NULL),('1226696605722292226','1213329258450063362',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:37:16',NULL,NULL,NULL),('1226697510173618177','1213372893656846338',NULL,2,2,'福建泉成机械有限公司','15392286115','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:40:52',NULL,NULL,NULL),('1226697744631017473','1213325852792655874',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:41:47',NULL,NULL,NULL),('1226698713360052226','1213374148680683522',NULL,2,2,'三六一度（福建）体育用品有限公司','13625976298','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:45:38',NULL,NULL,NULL),('1226699874381148162','1213316508038533121',NULL,2,2,'福建省咭咭文化传播有限公司','18698390251','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:50:15',NULL,NULL,NULL),('1226700796775706626','1213305593486446593',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 10:53:55',NULL,NULL,NULL),('1226703223537086466','1213004988083671042',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:03:34',NULL,NULL,NULL),('1226703932449959937','1213383364199911425',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:06:23',NULL,NULL,NULL),('1226704543711047682','1213301093195386882',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:08:48',NULL,NULL,NULL),('1226705326821158913','1212997733082796034',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:11:55',NULL,NULL,NULL),('1226705944021381122','1213389172656640002',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:14:22',NULL,NULL,NULL),('1226708833347383297','1213296617474560002',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:25:51',NULL,NULL,NULL),('1226709081453047809','1212994333037367297',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:26:50',NULL,NULL,NULL),('1226710010864676866','1213375300625305601',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:30:32',NULL,NULL,NULL),('1226710431549173762','1212987260249640961',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:32:12',NULL,NULL,NULL),('1226711461666041857','1212991105256198146',NULL,2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:36:18',NULL,NULL,NULL),('1226711984620253186','1213368856349839362',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:38:22',NULL,NULL,NULL),('1226712194117349377','1212991260680327170',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:39:12',NULL,NULL,NULL),('1226712516676104194','1213402248961396738',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:40:29',NULL,NULL,NULL),('1226713726397263874','1213391452441219073',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 11:45:18',NULL,NULL,NULL),('1226761653010337794','1213399608441507842',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 14:55:44',NULL,NULL,NULL),('1226767265991528449','1213396960715804674',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:18:03',NULL,NULL,NULL),('1226770278974001153','1213457476616261633',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:30:01',NULL,NULL,NULL),('1226771416678961153','1215521014180528130',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:34:32',NULL,NULL,NULL),('1226771528306167810','1215198257546838017',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:34:59',NULL,NULL,NULL),('1226771957781925889','1212993872293072898',NULL,2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:36:41',NULL,NULL,NULL),('1226772007249547265','1215188446381916162',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:36:53',NULL,NULL,NULL),('1226772099536818178','1214822576229015553',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:37:15',NULL,NULL,NULL),('1226772167740395521','1214798444183511041',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:37:31',NULL,NULL,NULL),('1226772267615162369','1214744454548774914',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:37:55',NULL,NULL,NULL),('1226772336229781506','1214021217028165634',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:38:11',NULL,NULL,NULL),('1226772461874352130','1213990446234095617',NULL,2,2,'泉州市农业科学研究所','13599701057','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:38:41',NULL,NULL,NULL),('1226773504867733505','1213445866220752897',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:42:50',NULL,NULL,NULL),('1226773773101862913','1213392846904692738',NULL,2,2,'泉州星城纸业有限公司','15959856777','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:43:54',NULL,NULL,NULL),('1226775813957914626','1213370349530451969',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 15:52:01',NULL,NULL,NULL),('1226777846127562754','1213487839396827137',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:00:05',NULL,NULL,NULL),('1226778236801814530','1213388745647132674',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:01:38',NULL,NULL,NULL),('1226780047105363969','1213396397731155969',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:08:50',NULL,NULL,NULL),('1226780453709582337','1213356697788157953',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:10:27',NULL,NULL,NULL),('1226781655667085314','1213481714882514945',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:15:13',NULL,NULL,NULL),('1226782051781349377','1213633017902288898',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:16:48',NULL,NULL,NULL),('1226783510988099585','1213672704066998274',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:22:36',NULL,NULL,NULL),('1226784091077120001','1213643648609046529',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:24:54',NULL,NULL,NULL),('1226785677568413698','1213670710782742529',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:31:12',NULL,NULL,NULL),('1226785934687637506','1213461396017188865',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:32:14',NULL,NULL,NULL),('1226786319192068097','1213408700786610178',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:33:45',NULL,NULL,NULL),('1226786735174750209','1213403344614264834',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:35:24',NULL,NULL,NULL),('1226787893486325761','1213370321193734146',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:40:01',NULL,NULL,NULL),('1226789655119171585','1213667275836510209',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:47:01',NULL,NULL,NULL),('1226790044170227713','1213649680047558657',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:48:33',NULL,NULL,NULL),('1226790584136536065','1213664024676290561',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:50:42',NULL,NULL,NULL),('1226791389732311042','1213661596878917634',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:53:54',NULL,NULL,NULL),('1226792042982576130','1213659094011891713',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 16:56:30',NULL,NULL,NULL),('1226793229391794178','1214005343110057985',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 17:01:13',NULL,NULL,NULL),('1226794410990145538','1213453373349629953',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 17:05:54',NULL,NULL,NULL),('1226795173304897538','1213654210319503362',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-10',NULL,NULL,NULL,'2020-02-10 17:08:56',NULL,NULL,NULL),('1227037526800289793','1213771207946555393',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:11:58',NULL,NULL,NULL),('1227040620711858178','1213991024473427970',NULL,2,2,'福建集成伞业有限公司','13788829369','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:24:15',NULL,NULL,NULL),('1227042134067073026','1213987563191160834',NULL,2,2,'福建星宏新材料科技有限公司','13805992036','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:30:16',NULL,NULL,NULL),('1227043811650260994','1213993729728204801',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:36:56',NULL,NULL,NULL),('1227045060844015617','1213999987906596865',NULL,2,2,'福建龙峰纺织科技实业有限公司','18859760088','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:41:54',NULL,NULL,NULL),('1227045742217089025','1213391690212118529',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:44:37',NULL,NULL,NULL),('1227047094594916353','1214002927958511617',NULL,2,2,'福建泉成机械有限公司','15392286115','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:49:59',NULL,NULL,NULL),('1227048229451943937','1214006045093941249',NULL,2,2,'艾派集团（中国）有限公司','13959757688','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:54:30',NULL,NULL,NULL),('1227048697443995649','1213793630708322306',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 09:56:21',NULL,NULL,NULL),('1227050867568496642','1213383835576766465',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:04:58',NULL,NULL,NULL),('1227051251796103169','1213782394973212674',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:06:30',NULL,NULL,NULL),('1227057329388736513','1213780730350424065',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:30:39',NULL,NULL,NULL),('1227059572921946113','1219634301822353409',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:39:34',NULL,NULL,NULL),('1227060026695307265','1213679284053364738',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:41:22',NULL,NULL,NULL),('1227061702374281217','1213762698039283714',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:48:02',NULL,NULL,NULL),('1227062371088945154','1213991024473427970',NULL,2,2,'福建集成伞业有限公司','13788829369','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:50:41',NULL,NULL,NULL),('1227062711561572354','1213777973207912449',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:52:02',NULL,NULL,NULL),('1227062725021093889','1213645378851721217',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:52:06',NULL,NULL,NULL),('1227063621700374529','1213760414832152577',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 10:55:39',NULL,NULL,NULL),('1227065150700343297','1213757323755933698',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:01:44',NULL,NULL,NULL),('1227065267687870465','1213457383972474882',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:02:12',NULL,NULL,NULL),('1227065995592552450','1214004213684654082',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:05:05',NULL,NULL,NULL),('1227067086539411458','1213439944773668865',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:09:25',NULL,NULL,NULL),('1227067114087600130','1214006201298210817',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:09:32',NULL,NULL,NULL),('1227067854239649794','1214007063722610689',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:12:28',NULL,NULL,NULL),('1227068621180719105','1213042992743518210',NULL,2,2,'晋江市品质陶瓷建材有限公司','15106011992','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:15:31',NULL,NULL,NULL),('1227070302823993346','1213735503061340162',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:22:12',NULL,NULL,NULL),('1227071547928301570','1214011148295229441',NULL,2,2,'福建省纳金网信息技术有限公司','15959501581','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:27:09',NULL,NULL,NULL),('1227072070626660354','1214014388726419458',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 11:29:14',NULL,NULL,NULL),('1227122904781639682','1214355481057906689',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 14:51:13',NULL,NULL,NULL),('1227124141551865858','1214003261376319490',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 14:56:08',NULL,NULL,NULL),('1227127090961272833','1214006401932742657',NULL,2,2,'晋江市达胜纺织实业有限公司','15959886256','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:07:52',NULL,NULL,NULL),('1227127217612476417','1214007880756252674',NULL,2,2,'福建乐隆隆食品科技有限公司','15960551920','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:08:22',NULL,NULL,NULL),('1227128066698989569','1213689583217168386',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:11:44',NULL,NULL,NULL),('1227134228290949122','1214008021189939201',NULL,2,2,'福建泉成机械有限公司','15392286115','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:36:13',NULL,NULL,NULL),('1227134347446931458','1214020909606653954',NULL,2,2,'福建星宏新材料科技有限公司','13805992036','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:36:42',NULL,NULL,NULL),('1227134467483717634','1213737203620925441',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:37:10',NULL,NULL,NULL),('1227135243522232321','1214014513922199554',NULL,2,2,'泉州市一听文化艺术有限公司','17750799505','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:40:15',NULL,NULL,NULL),('1227136408079126529','1213709144100458497',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:44:53',NULL,NULL,NULL),('1227136821515866114','1214022647243886594',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:46:32',NULL,NULL,NULL),('1227137342188376066','1213997736014139394',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:48:36',NULL,NULL,NULL),('1227138160539029506','1214023804481720322',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:51:51',NULL,NULL,NULL),('1227138305414483969','1213433843349000193',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:52:25',NULL,NULL,NULL),('1227139404573790209','1213438414507020289',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:56:47',NULL,NULL,NULL),('1227139532974018562','1214026712526901249',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:57:18',NULL,NULL,NULL),('1227139758942146562','1214042788153282562',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 15:58:12',NULL,NULL,NULL),('1227140518694178817','1213799058515185666',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:01:13',NULL,NULL,NULL),('1227140854049755138','1214024888939991041',NULL,2,2,'泉州恒毅机械有限公司','15750998817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:02:33',NULL,NULL,NULL),('1227141546286075905','1213675959106949122',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:05:18',NULL,NULL,NULL),('1227142949922492418','1213749002919497730',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:10:53',NULL,NULL,NULL),('1227143110522392577','1214069382544642049',NULL,2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:11:31',NULL,NULL,NULL),('1227143502694010882','1214012053283426305',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:13:04',NULL,NULL,NULL),('1227144012960452610','1214019673369104385',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:15:06',NULL,NULL,NULL),('1227144706530562049','1214027834125733889',NULL,2,2,'福建正麒高纤科技股份有限公司','18698386676','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:17:51',NULL,NULL,NULL),('1227146019125415937','1213459231395614722',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:23:04',NULL,NULL,NULL),('1227146488317038593','1214077679309967361',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:24:56',NULL,NULL,NULL),('1227146604218241025','1214025859166392321',NULL,2,2,'晋江宏基机械有限公司','15905958858','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:25:24',NULL,NULL,NULL),('1227147241500790786','1213796975414104065',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:27:56',NULL,NULL,NULL),('1227147651108130818','1213787973707911170',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:29:33',NULL,NULL,NULL),('1227148910741508097','1214059498356887553',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:34:34',NULL,NULL,NULL),('1227149054731964417','1213742610015866882',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:35:08',NULL,NULL,NULL),('1227149263197261826','1214031611008405505',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:35:58',NULL,NULL,NULL),('1227149509780393985','1214076364613767170',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:36:57',NULL,NULL,NULL),('1227149936928313345','1213659767864578050',NULL,2,2,'福建省诺美护理用品有限公司','13799487213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:38:38',NULL,NULL,NULL),('1227151083231596546','1213785376003477506',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:43:12',NULL,NULL,NULL),('1227151264991760386','1214087116452024321',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:43:55',NULL,NULL,NULL),('1227151849505771522','1214104941166088193',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:46:14',NULL,NULL,NULL),('1227152514537836545','1214084655297351682',NULL,2,2,'福建星宏新材料科技有限公司','13805992036','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:48:53',NULL,NULL,NULL),('1227152768565858305','1213747488628953089',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:49:54',NULL,NULL,NULL),('1227152787503140866','1214041833848459266',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:49:58',NULL,NULL,NULL),('1227153307752026114','1214174722925875201',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:52:02',NULL,NULL,NULL),('1227154108343996417','1213444552661209090',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:55:13',NULL,NULL,NULL),('1227154463073062914','1214083140377661441',NULL,2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:56:38',NULL,NULL,NULL),('1227155120073035778','1213780730350424065',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:59:14',NULL,NULL,NULL),('1227155163186286594','1213758959509327874',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 16:59:25',NULL,NULL,NULL),('1227156035672821762','1213404572173799425',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-11',NULL,NULL,NULL,'2020-02-11 17:02:53',NULL,NULL,NULL),('1227156736310333442','1214074633901330433',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 17:05:40',NULL,NULL,NULL),('1227157847809282050','1212684627026710530',NULL,2,2,'晋江乐康医院有限公司','15109613666','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 17:10:05',NULL,NULL,NULL),('1227158245299277825','1214082032494202882',NULL,2,2,'劲派经编科技有限公司','15859799211','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 17:11:39',NULL,NULL,NULL),('1227159561719336961','1214063838148710401',NULL,2,2,'福建集成伞业有限公司','13788829369','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 17:16:53',NULL,NULL,NULL),('1227160518985338882','1214363925387235329',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 17:20:41',NULL,NULL,NULL),('1227160663290368002','1214095842214957058',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-11',NULL,NULL,NULL,'2020-02-11 17:21:16',NULL,NULL,NULL),('1227402944870174722','1214358991866515458',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 09:24:00',NULL,NULL,NULL),('1227404163927855105','1214357547901865985',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 09:28:51',NULL,NULL,NULL),('1227404557722669058','1214099366390812674',NULL,2,2,'福建星宏新材料科技有限公司','13805992036','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 09:30:25',NULL,NULL,NULL),('1227406680841605122','1214357696682217473',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 09:38:51',NULL,NULL,NULL),('1227408903587844097','1214087503733084161',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 09:47:41',NULL,NULL,NULL),('1227410076231356417','1214083642872057857',NULL,2,2,'福建省群策环境检测有限公司','17758709290','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 09:52:21',NULL,NULL,NULL),('1227413246609281026','1214089134675611649',NULL,2,2,'泉州众德机械有限公司','15905970382','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 10:04:56',NULL,NULL,NULL),('1227420450691305474','1214109622848212994',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 10:33:34',NULL,NULL,NULL),('1227425483096936450','1214110188903092225',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 10:53:34',NULL,NULL,NULL),('1227425545583677441','1214112853145964546',NULL,2,2,'泉州鑫豪工程机械科技有限公司','18900399682','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 10:53:49',NULL,NULL,NULL),('1227432770284900353','1214106532652797953',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 11:22:31',NULL,NULL,NULL),('1227434745860804610','1214103605930381314',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 11:30:22',NULL,NULL,NULL),('1227488169839120386','1214358957997510657',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:02:39',NULL,NULL,NULL),('1227490023352389634','1214156016623570945',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:10:01',NULL,NULL,NULL),('1227490687507845122','1214353812312117250',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:12:40',NULL,NULL,NULL),('1227493320452820994','1214355387147440130',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:23:07',NULL,NULL,NULL),('1227494148400041986','1214084126613721090',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:26:25',NULL,NULL,NULL),('1227497270505721857','1214360538285428737',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:38:49',NULL,NULL,NULL),('1227497370921553921','1214089766316822530',NULL,2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:39:13',NULL,NULL,NULL),('1227498333652733953','1214034001136734210',NULL,2,2,'贵人鸟股份有限公司','15359991222','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:43:03',NULL,NULL,NULL),('1227498777238130690','1214114694827102210',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:44:48',NULL,NULL,NULL),('1227501988867035137','1214372517821632513',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 15:57:34',NULL,NULL,NULL),('1227503317878394881','1214111200846041089',NULL,2,2,'晋江市美味强食品有限公司','17706075999','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:02:51',NULL,NULL,NULL),('1227503318780170241','1214363485929033729',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:02:51',NULL,NULL,NULL),('1227504419566866434','1214369112097116161',NULL,2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:07:14',NULL,NULL,NULL),('1227505738167963650','1214363432564903937',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:12:28',NULL,NULL,NULL),('1227507719519424513','1214379806326607874',NULL,2,2,'泉州国科文化有限公司','18259591998','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:20:20',NULL,NULL,NULL),('1227509867225370626','1214369770497986561',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:28:53',NULL,NULL,NULL),('1227510636141957122','1214373071096467457',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:31:56',NULL,NULL,NULL),('1227512925128839170','1214200592700887042',NULL,2,2,'晋江闽古食品有限公司','18250155553','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:41:02',NULL,NULL,NULL),('1227515812038922242','1214181538506297345',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:52:30',NULL,NULL,NULL),('1227516081984327681','1214349158736023554',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:53:34',NULL,NULL,NULL),('1227516448763629570','1214361339498156034',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:55:02',NULL,NULL,NULL),('1227517431719743490','1214197483815653378',NULL,2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 16:58:56',NULL,NULL,NULL),('1227518597362962433','1214100840579616770',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 17:03:34',NULL,NULL,NULL),('1227519110703828993','1214357623005073410',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 17:05:36',NULL,NULL,NULL),('1227520093966127106','1214100352186470401',NULL,2,2,'晋江宏基机械有限公司','15905958858','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 17:09:31',NULL,NULL,NULL),('1227520844264198145','1214352720551563265',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 17:12:30',NULL,NULL,NULL),('1227523213882380289','1214092185507483650',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 17:21:55',NULL,NULL,NULL),('1227525633790267394','1214193571331133442',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-12',NULL,NULL,NULL,'2020-02-12 17:31:32',NULL,NULL,NULL),('1227759311820812290','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 09:00:05',NULL,NULL,NULL),('1227759333333397506','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 09:00:10',NULL,NULL,NULL),('1227760947226079233','1214168537384439810',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 09:06:35',NULL,NULL,NULL),('1227767454726483970','1214129414149787649',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 09:32:26',NULL,NULL,NULL),('1227776773069074433','1214084655297351682',NULL,2,2,'福建星宏新材料科技有限公司','13805992036','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:09:28',NULL,NULL,NULL),('1227777830927069185','1214126001668247554',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:13:40',NULL,NULL,NULL),('1227781147245801473','1214127329123520514',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-02-13',NULL,NULL,NULL,'2020-02-13 10:26:51',NULL,NULL,NULL),('1227781468680482817','1214020909606653954',NULL,2,2,'福建星宏新材料科技有限公司','13805992036','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:28:07',NULL,NULL,NULL),('1227783001904115714','1214360938757574658',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:34:13',NULL,NULL,NULL),('1227784034512400386','1214363132869300226',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:38:19',NULL,NULL,NULL),('1227784799146602497','1214114236033159169',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:41:21',NULL,NULL,NULL),('1227785520575279105','1214372654325256193',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:44:13',NULL,NULL,NULL),('1227786010285436929','1214364201229832194',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:46:10',NULL,NULL,NULL),('1227786140610850817','1214372739553513473',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:46:41',NULL,NULL,NULL),('1227789302264623105','1214383445065682945',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 10:59:15',NULL,NULL,NULL),('1227792098674208769','1214361014678671362',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 11:10:22',NULL,NULL,NULL),('1227794357998972929','1214350585311088641',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 11:19:20',NULL,NULL,NULL),('1227794687901954050','1214387252851986434',NULL,2,2,'福建中策光电股份公司','13505986964','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 11:20:39',NULL,NULL,NULL),('1227795937779380226','1214093274348802049',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 11:25:37',NULL,NULL,NULL),('1227798659345805313','1214370868822626305',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 11:36:26',NULL,NULL,NULL),('1227858277480656898','1214367428725788673',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 15:33:20',NULL,NULL,NULL),('1227860650932432898','1214378673881305090',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 15:42:46',NULL,NULL,NULL),('1227860931384569858','1214370925873549313',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 15:43:53',NULL,NULL,NULL),('1227863785147068417','1214385904639102977',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 15:55:13',NULL,NULL,NULL),('1227864002244243457','1214366021461299201',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 15:56:05',NULL,NULL,NULL),('1227866603954237441','1214361476228272129',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 16:06:25',NULL,NULL,NULL),('1227867863692472321','1214361401859067905',NULL,2,2,'福建帝霖食品有限公司','13960256299','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 16:11:26',NULL,NULL,NULL),('1227869460187181058','1214357195051847681',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 16:17:46',NULL,NULL,NULL),('1227872002883317761','1214377233985130498',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 16:27:52',NULL,NULL,NULL),('1227873203121156098','1214350132154290178',NULL,2,2,'晋江集成轻工有限公司','18016623555','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 16:32:39',NULL,NULL,NULL),('1227878375142584321','1214385518196903938',NULL,2,2,'晋江市第三医院','13559554933','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 16:53:12',NULL,NULL,NULL),('1227881132029243394','1213420676216590338',NULL,2,2,'晋江市远祥服装织造有限公司','17759990690','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-13',NULL,NULL,NULL,'2020-02-13 17:04:09',NULL,NULL,NULL),('1228121236740108289','1214372230373396482',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 08:58:14',NULL,NULL,NULL),('1228121698897883138','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:00:05',NULL,NULL,NULL),('1228121720347553793','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:00:10',NULL,NULL,NULL),('1228125222704640001','1214381342595305474',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:14:05',NULL,NULL,NULL),('1228127719733194753','1214381342595305474',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:24:00',NULL,NULL,NULL),('1228128763238281218','1214383468067246081',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:28:09',NULL,NULL,NULL),('1228129475242356737','1213017154744553474',NULL,2,2,'福建集成伞业有限公司','13788829369','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:30:59',NULL,NULL,NULL),('1228132383845380097','1214368256555569153',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:42:32',NULL,NULL,NULL),('1228132930308665345','1214379235095957505',NULL,2,2,'泉州市至真工具科技有限公司','13313825373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:44:42',NULL,NULL,NULL),('1228134521963147266','1214407984940126209',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:51:02',NULL,NULL,NULL),('1228135948458520578','1214377400591273985',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:56:42',NULL,NULL,NULL),('1228135982260416513','1214427748823535617',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 09:56:50',NULL,NULL,NULL),('1228137043226390529','1214423562958475266',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:01:03',NULL,NULL,NULL),('1228138059283951617','1214416366082265090',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:05:05',NULL,NULL,NULL),('1228138984211869697','1214431630802882561',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:08:46',NULL,NULL,NULL),('1228138994433388546','1214387797276839937',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:08:48',NULL,NULL,NULL),('1228142811040313346','1214419389554692097',NULL,2,2,'泉州市至真工具科技有限公司','13313825373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:23:58',NULL,NULL,NULL),('1228143158232215553',NULL,NULL,2,1,NULL,'15906099696','466000','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:25:21',NULL,NULL,NULL),('1228144100457443329',NULL,NULL,2,1,NULL,'15906099696','757084','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:29:06',NULL,NULL,NULL),('1228144860977033217','1214419249741762561',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:32:07',NULL,NULL,NULL),('1228146917125517313','1214100650997075970',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 10:40:17',NULL,NULL,NULL),('1228153644852047873','1214394522675515393',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 11:07:01',NULL,NULL,NULL),('1228155265803743234','1214498107723681793',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 11:13:28',NULL,NULL,NULL),('1228156038298071042','1214448827919044610',NULL,2,2,'福建省万物智联科技有限公司','18559275265','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 11:16:32',NULL,NULL,NULL),('1228158378044420097','1214471441240625154',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 11:25:50',NULL,NULL,NULL),('1228161584006819841','1214441663758405634',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 11:38:34',NULL,NULL,NULL),('1228217597883969538','1214436714290941953',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 15:21:09',NULL,NULL,NULL),('1228217855858831362','1214459225254727681',NULL,2,2,'福建省晋江市华宇织造有限公司','18606984919','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 15:22:10',NULL,NULL,NULL),('1228223496694394881','1214460361680424962',NULL,2,2,'福建省万物智联科技有限公司','18559275265','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 15:44:35',NULL,NULL,NULL),('1228223684817317890','1214459085664096258',NULL,2,2,'贵人鸟股份有限公司','15359991222','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 15:45:20',NULL,NULL,NULL),('1228225206804410370','1214439353158275074',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 15:51:23',NULL,NULL,NULL),('1228227032505249794','1214458792381583361',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 15:58:38',NULL,NULL,NULL),('1228228925600165890','1214455044749987841',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:06:09',NULL,NULL,NULL),('1228229512307798018','1214345627488571394',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:08:29',NULL,NULL,NULL),('1228230487324094466','1214454594474676226',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:12:22',NULL,NULL,NULL),('1228232482470621185','1214432643169456129',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:20:17',NULL,NULL,NULL),('1228233472691269634','1214464004529917953',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:24:14',NULL,NULL,NULL),('1228234293436870658','1214465089160155137',NULL,2,2,'泉州好彩头食品有限公司','18859951871','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:27:29',NULL,NULL,NULL),('1228235033811218434','1214364251020414978',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:30:26',NULL,NULL,NULL),('1228240130976903169','1214464672674156546',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:50:41',NULL,NULL,NULL),('1228242300715528194','1214473714993795073',NULL,2,2,'福建省德腾智能科技有限公司','18050996325','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 16:59:18',NULL,NULL,NULL),('1228242579687075841','1214478999942664194',NULL,2,2,'泉州协创知识产权代理事务所（普通合伙）','17750792370','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:00:25',NULL,NULL,NULL),('1228243959260770306','1214503757660884994',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:05:54',NULL,NULL,NULL),('1228244233241096194','1214470478874349569',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:06:59',NULL,NULL,NULL),('1228244914492534786','1214523792034959362',NULL,2,2,'福建省闽楚建设工程有限公司晋江分公司','13599145737','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:09:41',NULL,NULL,NULL),('1228245581982461953','1214479073808551938',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:12:21',NULL,NULL,NULL),('1228245777365725186','1214442592394088449',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:13:07',NULL,NULL,NULL),('1228247215269605378','1214496694402617345',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:18:50',NULL,NULL,NULL),('1228248408435847170','1215796677630259202',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:23:34',NULL,NULL,NULL),('1228250574424764418','1215085756532441089',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-14',NULL,NULL,NULL,'2020-02-14 17:32:11',NULL,NULL,NULL),('1228570675652980737','1214364251020414978',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-15',NULL,NULL,NULL,'2020-02-15 14:44:09',NULL,NULL,NULL),('1228869793097052162','1214200592700887042',NULL,2,2,'晋江闽古食品有限公司','18250155553','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-16',NULL,NULL,NULL,'2020-02-16 10:32:44',NULL,NULL,NULL),('1229206653077942273','1214571685114634242',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 08:51:18',NULL,NULL,NULL),('1229207972782141442','1214539330161283073',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 08:56:32',NULL,NULL,NULL),('1229208325061734401','1214499046564106242',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 08:57:56',NULL,NULL,NULL),('1229208862377242626','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:00:05',NULL,NULL,NULL),('1229208883789164545','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:00:10',NULL,NULL,NULL),('1229210641164791809','1214513030570774530',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:07:09',NULL,NULL,NULL),('1229211209287462914','1214510075125764098',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:09:24',NULL,NULL,NULL),('1229212665629503489','1214485868425842690',NULL,2,2,'泉州森地客体育用品有限公司','13959888172','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:15:11',NULL,NULL,NULL),('1229214247045689346','1214721773111697409',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:21:28',NULL,NULL,NULL),('1229216924488036354','1214437987694219266',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-02-17',NULL,NULL,NULL,'2020-02-17 09:32:07',NULL,NULL,NULL),('1229218673961594882','1215473375900647425',NULL,2,2,'福建省力和勘察设计有限公司','13950238890','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:39:04',NULL,NULL,NULL),('1229223132611604481','1214714285742186497',NULL,2,2,'福建集成伞业有限公司','13788829369','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 09:56:47',NULL,NULL,NULL),('1229226756754501634','1214733159351017474',NULL,2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:11:11',NULL,NULL,NULL),('1229227311199547394','1214728131785613313',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:13:23',NULL,NULL,NULL),('1229229715127136257','1214715294136754177',NULL,2,2,'福建兴翼机械有限公司','18606981162','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:22:56',NULL,NULL,NULL),('1229230754207232001','1214728268905799682',NULL,2,2,'福建兴翼机械有限公司','18606981162','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:27:04',NULL,NULL,NULL),('1229231560281157633','1214730795768438786',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:30:16',NULL,NULL,NULL),('1229231829165404162','1214724648864931841',NULL,2,2,'福建兴翼机械有限公司','18606981162','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:31:20',NULL,NULL,NULL),('1229233263755784194','1214729918731083778',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:37:02',NULL,NULL,NULL),('1229234999841124354','1214728621923590145',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:43:56',NULL,NULL,NULL),('1229235398287421442','1214815732710334466',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:45:31',NULL,NULL,NULL),('1229236511233404930','1214712764900139009',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:49:57',NULL,NULL,NULL),('1229237349603471362','1215120903000604673',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:53:16',NULL,NULL,NULL),('1229238480702402562','1215116562449612802',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 10:57:46',NULL,NULL,NULL),('1229239907415879682','1214707591712694274',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 11:03:26',NULL,NULL,NULL),('1229240373243670530','1214722982321152001',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 11:05:17',NULL,NULL,NULL),('1229242453396156418','1215113784209752066',NULL,2,2,'晋江市金井中心卫生院','13959811363','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 11:13:33',NULL,NULL,NULL),('1229246021406683137','1214770652842647553',NULL,2,2,'峰安皮业股份有限公司','15059821270','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 11:27:44',NULL,NULL,NULL),('1229247456777203714','1215111788417302529',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 11:33:26',NULL,NULL,NULL),('1229297412057722881','1215463572293861377',NULL,2,2,'福建省百安物业服务有限公司晋江分公司','13489848301','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 14:51:56',NULL,NULL,NULL),('1229298817346695169','1215176838305857537',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 14:57:31',NULL,NULL,NULL),('1229299579816636418','1214479073808551938',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 15:00:33',NULL,NULL,NULL),('1229299723840647169','1214383468067246081',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 15:01:08',NULL,NULL,NULL),('1229302622549307393','1215171861621555202',NULL,2,2,'晋江市梓源农业发展有限公司','18965183911','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 15:12:39',NULL,NULL,NULL),('1229309378776133634','1214733294395023361',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 15:39:30',NULL,NULL,NULL),('1229317534893862914','1214737160985468929',NULL,2,2,'峰安皮业股份有限公司','15059821270','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 16:11:54',NULL,NULL,NULL),('1229318513248825345','1214794028541894657',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 16:15:47',NULL,NULL,NULL),('1229319977329356802','1214802745274490881',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 16:21:36',NULL,NULL,NULL),('1229321193677516802','1214775674980622338',NULL,2,2,'摩尔工业设计（晋江）有限公司','18106990767','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 16:26:26',NULL,NULL,NULL),('1229322672056430594','1214800057501573121',NULL,2,2,'福建省晋江优兰发纸业有限公司','13906095618','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 16:32:19',NULL,NULL,NULL),('1229325830514143233','1214759144939151361',NULL,2,2,'泉州鸿展模具制造有限公司','18959708027','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 16:44:52',NULL,NULL,NULL),('1229330209652731906','1214800057501573121',NULL,2,2,'福建省晋江优兰发纸业有限公司','13906095618','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:02:16',NULL,NULL,NULL),('1229330680484327426','1215511943096352770',NULL,2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:04:08',NULL,NULL,NULL),('1229333191614132225','1215503996567994369',NULL,2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:14:07',NULL,NULL,NULL),('1229333388889026561','1214804225721196545',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:14:54',NULL,NULL,NULL),('1229334402920738817','1215548499957956609',NULL,2,2,'泉州育英服装有限公司','13860706464','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:18:56',NULL,NULL,NULL),('1229335262073581570','1214466953859633154',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:22:21',NULL,NULL,NULL),('1229335659462914049','1214383468067246081',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:23:55',NULL,NULL,NULL),('1229335677305483265','1215571273749413889',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:24:00',NULL,NULL,NULL),('1229335863016681474','1214479073808551938',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-17',NULL,NULL,NULL,'2020-02-17 17:24:44',NULL,NULL,NULL),('1229566752699052033','1215524058515423233',NULL,2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 08:42:12',NULL,NULL,NULL),('1229567023797891073','1215531972470816769',NULL,2,2,'灵源药业有限公司','18350770050','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 08:43:17',NULL,NULL,NULL),('1229570952866689025','1214916634205052929',NULL,2,2,'晋江市凯鑫汽配有限责任公司','15959556399','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 08:58:54',NULL,NULL,NULL),('1229571250209288193','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:00:05',NULL,NULL,NULL),('1229571271562489858','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:00:10',NULL,NULL,NULL),('1229573642816450561','1216726114563530754',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:09:35',NULL,NULL,NULL),('1229573892323012609','1219129690304929793',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:10:34',NULL,NULL,NULL),('1229574187681705986','1219898357082767362',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:11:45',NULL,NULL,NULL),('1229577152257716226',NULL,NULL,2,1,NULL,'18160909658','950771','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:23:32',NULL,NULL,NULL),('1229578840335052802',NULL,NULL,2,1,NULL,'18160909658','531826','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:30:14',NULL,NULL,NULL),('1229579119847665666','1214808872515100673',NULL,2,2,'福建省晋江市辉源建材物资有限公司','15106027935','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:31:21',NULL,NULL,NULL),('1229580697694498817','1214938643072860162',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:37:37',NULL,NULL,NULL),('1229580815302782977','1214812000488611841',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:38:05',NULL,NULL,NULL),('1229582316540653570','1214806891054587905',NULL,2,2,'晋江市路桥建设开发有限公司','17350011170','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:44:03',NULL,NULL,NULL),('1229582411713605633','1215088914730106882',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:44:26',NULL,NULL,NULL),('1229583344652644354','1215147906500182018',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:48:08',NULL,NULL,NULL),('1229585400897597441','1214711157097586690',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 09:56:18',NULL,NULL,NULL),('1229587403560316929','1215576384982794241',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:04:16',NULL,NULL,NULL),('1229596825841954818','1215069927115898881',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:41:42',NULL,NULL,NULL),('1229597137625542658','1215069927115898881',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:42:57',NULL,NULL,NULL),('1229597761930915841','1214383468067246081',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:45:25',NULL,NULL,NULL),('1229598091057950721','1214834704109363202',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:46:44',NULL,NULL,NULL),('1229598148461195265','1214479073808551938',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:46:58',NULL,NULL,NULL),('1229599129584398337','1215072747881807874',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:50:51',NULL,NULL,NULL),('1229599877202309122','1214839914441564161',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:53:50',NULL,NULL,NULL),('1229600599931219969','1214908083915022338',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:56:42',NULL,NULL,NULL),('1229600739551211521','1213420676216590338',NULL,2,2,'晋江市远祥服装织造有限公司','17759990690','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 10:57:15',NULL,NULL,NULL),('1229602394099281922','1215133719514365953',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 11:03:50',NULL,NULL,NULL),('1229602541201911810','1214492237044453378',NULL,2,2,'泉州禧余商贸有限公司','13110801508','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS（手机关机，停机及黑名单用户）','2020-02-18',NULL,NULL,NULL,'2020-02-18 11:04:25',NULL,NULL,NULL),('1229606743206653953','1215610703029780482',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 11:21:07',NULL,NULL,NULL),('1229607179816923138','1215164212926529538',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 11:22:51',NULL,NULL,NULL),('1229608456579837953','1214818764613312514',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-02-18',NULL,NULL,NULL,'2020-02-18 11:27:55',NULL,NULL,NULL),('1229609528094486529','1214726641809448962',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 11:32:11',NULL,NULL,NULL),('1229611104137768961','1215799913544183809',NULL,2,2,'福建盛达机器股份公司','15359382970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 11:38:26',NULL,NULL,NULL),('1229668576970010626','1215447238340296706',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 15:26:49',NULL,NULL,NULL),('1229670069823467522','1215136783331803137',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 15:32:45',NULL,NULL,NULL),('1229671798665244674','1215104659945996290',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 15:39:37',NULL,NULL,NULL),('1229676386235576321','1215072908251021313',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 15:57:51',NULL,NULL,NULL),('1229679296256274434','1214838121154306050',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:09:25',NULL,NULL,NULL),('1229682638218981377','1215445896372731906',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:22:42',NULL,NULL,NULL),('1229683816617078786','1214825895592812546',NULL,2,2,'晋江市至简资产管理有限公司','13799225181','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:27:22',NULL,NULL,NULL),('1229684188442128386','1215442533493030914',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:28:51',NULL,NULL,NULL),('1229685585728368642','1215439123058311169',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:34:24',NULL,NULL,NULL),('1229687693928165378','1215434147816849409',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:42:47',NULL,NULL,NULL),('1229690272674344962','1215442126997864450',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:53:02',NULL,NULL,NULL),('1229690779883139073','1215196400472604674',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 16:55:03',NULL,NULL,NULL),('1229692652564377602','1215476555652841473',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 17:02:29',NULL,NULL,NULL),('1229693263015964674','1214809621504548865',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 17:04:55',NULL,NULL,NULL),('1229693838294118401','1215532448209747969',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 17:07:12',NULL,NULL,NULL),('1229695411896315906','1215524453077794818',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 17:13:27',NULL,NULL,NULL),('1229696496421695490','1215463533140033538',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 17:17:46',NULL,NULL,NULL),('1229700906199674882',NULL,NULL,2,1,NULL,'13799225181','437009','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-18',NULL,NULL,NULL,'2020-02-18 17:35:17',NULL,NULL,NULL),('1229930063047290882','1212903003795820546',NULL,2,2,'晋江市安海镇卫生院','13799557721','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 08:45:52',NULL,NULL,NULL),('1229933470705381377','1215188908443222018',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 08:59:25',NULL,NULL,NULL),('1229933638087471105','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:00:05',NULL,NULL,NULL),('1229933659491004417','58',NULL,1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:00:10',NULL,NULL,NULL),('1229933659675553793','87',NULL,1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:00:10',NULL,NULL,NULL),('1229936212085698562','1215497090688401410',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:10:18',NULL,NULL,NULL),('1229938816790425601','1215260124776546306',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:20:39',NULL,NULL,NULL),('1229939755047841794','1215188908443222018',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:24:23',NULL,NULL,NULL),('1229940295962062849','1215551205783158786',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:26:32',NULL,NULL,NULL),('1229940849169788930','1215829672827318273',NULL,2,2,'泉州福盈汽车销售服务有限公司','15559133531','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:28:44',NULL,NULL,NULL),('1229941630044336130','1215841796588859393',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:31:50',NULL,NULL,NULL),('1229941917849088001','1229579025916227586',NULL,2,2,'福建省晋江水务集团有限公司','18160909658','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:32:59',NULL,NULL,NULL),('1229942806336892930','1216192545575432193',NULL,2,2,'泉州福盈汽车销售服务有限公司','15559133531','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:36:30',NULL,NULL,NULL),('1229943539744501762','1216189099086475266',NULL,2,2,'泉州福盈汽车销售服务有限公司','15559133531','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:39:25',NULL,NULL,NULL),('1229943594345951233','1215151276040437762',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:39:38',NULL,NULL,NULL),('1229945319039561730','1216272842195234817',NULL,2,2,'晋江丰顺食品有限公司','13850777672','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:46:29',NULL,NULL,NULL),('1229945562263056386','1215520156864790530',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:47:27',NULL,NULL,NULL),('1229945639702491137','1215176787160514561',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:47:46',NULL,NULL,NULL),('1229948395620265985','1216284069973749762',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 09:58:43',NULL,NULL,NULL),('1229949092583567361','1215242977119617026',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:01:29',NULL,NULL,NULL),('1229950250492489729','1215832057964425218',NULL,2,2,'福建省晋江优兰发纸业有限公司','13906095618','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:06:05',NULL,NULL,NULL),('1229950624418885634','1212916225613565953',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:07:34',NULL,NULL,NULL),('1229950892598489089','1216289419011584002',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:08:38',NULL,NULL,NULL),('1229952786276413442','1212924105729314818',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:16:10',NULL,NULL,NULL),('1229953170638237697','1215163836269641729',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:17:41',NULL,NULL,NULL),('1229953970567507969','1216585572571705346',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:20:52',NULL,NULL,NULL),('1229954285949808642','1216567805076336642',NULL,2,2,'福建七匹狼集团有限公司','15259760497','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:22:07',NULL,NULL,NULL),('1229954450521714689',NULL,NULL,2,1,NULL,'18150505789','107100','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:22:47',NULL,NULL,NULL),('1229954771964784642','1212999274472738817',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:24:03',NULL,NULL,NULL),('1229954945504112641','1216605775175098369',NULL,2,2,'泉州众德机械有限公司','15905970382','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:24:45',NULL,NULL,NULL),('1229954975464026113','1215172658988105729',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:24:52',NULL,NULL,NULL),('1229955287344082946','1216611327846391809',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:26:06',NULL,NULL,NULL),('1229956051412054017','1216546490718121985',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:29:08',NULL,NULL,NULL),('1229957560216449026','1215169251703308289',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:35:08',NULL,NULL,NULL),('1229957788147511298','1216627839000911874',NULL,2,2,'泉州国科文化有限公司','18259591998','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:36:02',NULL,NULL,NULL),('1229958678178820098','1215884374315134977',NULL,2,2,'泉州华祥纸业有限公司','13860748042','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:39:35',NULL,NULL,NULL),('1229960209565347841','1216636156737757185',NULL,2,2,'福建美溪通信科技股份有限公司','15906066156','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:45:40',NULL,NULL,NULL),('1229960211637334017','1216670179749011458',NULL,2,2,'安踏体育用品集团有限公司','18120662230','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:45:40',NULL,NULL,NULL),('1229962739045232641','1216643063514931202',NULL,2,2,'泉州好彩头食品有限公司','18859951871','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:55:43',NULL,NULL,NULL),('1229962918586609666','1216665608863621121',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 10:56:26',NULL,NULL,NULL),('1229964486954315778','1216655382395494402',NULL,2,2,'晋江中纺标检测有限公司','15375873767','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 11:02:39',NULL,NULL,NULL),('1229967480382943234','1216893982945071105',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 11:14:33',NULL,NULL,NULL),('1229969873560530945','1216927156592988162',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 11:24:04',NULL,NULL,NULL),('1229972125650120705','1215471819226660865',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 11:33:01',NULL,NULL,NULL),('1229972216125452289','1213686948212789249',NULL,2,2,'福建金石能源有限公司','13615901213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 11:33:22',NULL,NULL,NULL),('1229973688275824641','1213322366503948289',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 11:39:13',NULL,NULL,NULL),('1230025048291667969','1216631987134013441',NULL,2,2,'福建省统仕金属制品有限公司','15880881006','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:03:18',NULL,NULL,NULL),('1230025410083942401','1215194397507895298',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:04:45',NULL,NULL,NULL),('1230026170465120257','1216897993211400193',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:07:46',NULL,NULL,NULL),('1230032833066692610','1216901112372678658',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:34:14',NULL,NULL,NULL),('1230034153668472834','1216905942545747970',NULL,2,2,'耀华园林股份有限公司','13959882723','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:39:29',NULL,NULL,NULL),('1230034252981202945',NULL,NULL,2,1,NULL,'15880881006','349563','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:39:53',NULL,NULL,NULL),('1230035898859646978','1216921255798657025',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:46:25',NULL,NULL,NULL),('1230036895262699522','1216942692534079489',NULL,2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:50:23',NULL,NULL,NULL),('1230037762770595841','1215479057190273025',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 15:53:50',NULL,NULL,NULL),('1230040952022888450','1216915037784920066',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:06:30',NULL,NULL,NULL),('1230045528113410049','1216945662168420353',NULL,2,2,'耀华园林股份有限公司','13959882723','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:24:41',NULL,NULL,NULL),('1230047324504453122','1217269967582416898',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:31:49',NULL,NULL,NULL),('1230047963305340929','1217263780807856130',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:34:22',NULL,NULL,NULL),('1230048615226011650','1216963346264248321',NULL,2,2,'耀华园林股份有限公司','13959882723','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:36:57',NULL,NULL,NULL),('1230048660046344194','1215466631380123649',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:37:08',NULL,NULL,NULL),('1230048695941197826','1217045484011540481',NULL,2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:37:16',NULL,NULL,NULL),('1230049133159641090','1216987548153303041',NULL,2,2,'耀华园林股份有限公司','13959882723','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:39:01',NULL,NULL,NULL),('1230051102825771010','1215475552429850625',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:46:50',NULL,NULL,NULL),('1230051877673103361','1216968553165508610',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:49:55',NULL,NULL,NULL),('1230052631112708097','1217009965542166529',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 16:52:55',NULL,NULL,NULL),('1230055474305560577','1215471544743018497',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 17:04:13',NULL,NULL,NULL),('1230055738475409409','1217024164079095809',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 17:05:16',NULL,NULL,NULL),('1230057233690259458','1217032839107727362',NULL,2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 17:11:12',NULL,NULL,NULL),('1230057690420604929','1217017662492659713',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 17:13:01',NULL,NULL,NULL),('1230058211395104769','1217028823334277121',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 17:15:05',NULL,NULL,NULL),('1230060610209837057','1217070349011668993',NULL,2,2,'福建新宇拉链织造有限公司','15259555117','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 17:24:37',NULL,NULL,NULL),('1230063394535632898','1217286440824623105',NULL,2,2,'泉州国科文化有限公司','18259591998','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-19',NULL,NULL,NULL,'2020-02-19 17:35:41',NULL,NULL,NULL),('1230290757122912258','1216971575710994434',NULL,2,2,'泉州时空文化传媒有限公司','13905985153','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 08:39:08',NULL,NULL,NULL),('1230291199055753217','1216975831427993601',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 08:40:54',NULL,NULL,NULL),('1230291663465869313','1216964657063940098',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 08:42:44',NULL,NULL,NULL),('1230294279788818434','1217021356902731778',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 08:53:08',NULL,NULL,NULL),('1230296025999208450','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:00:05',NULL,NULL,NULL),('1230296047406936065','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:00:10',NULL,NULL,NULL),('1230298634042601474','1217070061441798145',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:10:26',NULL,NULL,NULL),('1230299327679819778','1216980797005778946',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:13:12',NULL,NULL,NULL),('1230300161784279042','1216987391676403714',NULL,2,2,'晋江源泰皮革有限公司','13030990915','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:16:31',NULL,NULL,NULL),('1230302191839997953','1216982985027375105',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:24:35',NULL,NULL,NULL),('1230303317679271938','1216985366024704002',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:29:03',NULL,NULL,NULL),('1230305017366441985','1216990086051155970',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:35:48',NULL,NULL,NULL),('1230307036009459713','1217072996410216449',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:43:50',NULL,NULL,NULL),('1230307052618903554','1216990212610084865',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:43:54',NULL,NULL,NULL),('1230307638374428674','1217075093637713922',NULL,2,2,'舒华体育股份有限公司','13599295908','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:46:13',NULL,NULL,NULL),('1230308123508600833','1215564809194487810',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:48:09',NULL,NULL,NULL),('1230308697599766530','1217348007360483330',NULL,2,2,'晋江市铠锋制鞋机械有限公司','15259755678','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:50:26',NULL,NULL,NULL),('1230309981807570945','1215456879954673666',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 09:55:32',NULL,NULL,NULL),('1230312171347505154','1215920271630823426',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:04:14',NULL,NULL,NULL),('1230312343171362817','1217369827073609730',NULL,2,2,'晋江一岂科技有限公司','13950116705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:04:55',NULL,NULL,NULL),('1230312726736269313','1215617882700955649',NULL,2,2,'晋江市致和社工事务所','15860517253','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:06:26',NULL,NULL,NULL),('1230313485813018626','1217390225970450434',NULL,2,2,'晋江劲霸男装有限公司','13505959911','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:09:27',NULL,NULL,NULL),('1230314603951550465','1215568800515145729',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:13:54',NULL,NULL,NULL),('1230314895438901250','1215544821565931521',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:15:03',NULL,NULL,NULL),('1230315618092314625','1217636527870377985',NULL,2,2,'晋江市远祥服装织造有限公司','17759990690','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:17:56',NULL,NULL,NULL),('1230315891879702529','1216895831311929345',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:19:01',NULL,NULL,NULL),('1230315916064059394','1215562838022602754',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:19:07',NULL,NULL,NULL),('1230317114678702081','1215552396269240322',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:23:52',NULL,NULL,NULL),('1230317145368424450','1215460247632658434',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:24:00',NULL,NULL,NULL),('1230317653177004033','1217721886004281346',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:26:01',NULL,NULL,NULL),('1230318606814932993','1216975871538122754',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:29:48',NULL,NULL,NULL),('1230318872398262274','1215547713173635074',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:30:52',NULL,NULL,NULL),('1230319155949989890','1216566349946449921',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:31:59',NULL,NULL,NULL),('1230319179878494210',NULL,NULL,2,1,NULL,'13030990915','187933','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:32:05',NULL,NULL,NULL),('1230319850262491138','1217718469060001794',NULL,2,2,'福建北电新材料科技有限公司','19959711592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:34:45',NULL,NULL,NULL),('1230320496206278657','1216535143146090497',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:37:19',NULL,NULL,NULL),('1230321462531977218','1215572086349676545',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:41:09',NULL,NULL,NULL),('1230323515828334594','1215565904239181825',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:49:19',NULL,NULL,NULL),('1230326169275068418','1217708780234539010',NULL,2,2,'福建北电新材料科技有限公司','19959711592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 10:59:51',NULL,NULL,NULL),('1230326917241106434','1215560663351476225',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 11:02:50',NULL,NULL,NULL),('1230328384773550082','1217712699413168130',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 11:08:39',NULL,NULL,NULL),('1230328419045208066','1215541287856422914',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 11:08:48',NULL,NULL,NULL),('1230331100786716674','1217016026160451586',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 11:19:27',NULL,NULL,NULL),('1230389536081702913','1217007741164343297',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:11:39',NULL,NULL,NULL),('1230390023203975169','1215570767543058433',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:13:35',NULL,NULL,NULL),('1230390080691105793','1217734466244509698',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:13:49',NULL,NULL,NULL),('1230390453363404802','1217256044393156610',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:15:18',NULL,NULL,NULL),('1230391407768891393','1217744018566348802',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:19:05',NULL,NULL,NULL),('1230391932816060418','1217004895144529922',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:21:11',NULL,NULL,NULL),('1230393061704593409','1216521103799775234',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:25:40',NULL,NULL,NULL),('1230393664770011137','1215841735112945666',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:28:03',NULL,NULL,NULL),('1230394647562547202','1216622869274959874',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:31:58',NULL,NULL,NULL),('1230395512159596546','1217774441090580482',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:35:24',NULL,NULL,NULL),('1230397578890309633','1218111020397035521',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:43:37',NULL,NULL,NULL),('1230398574240591873','1217004330696069121',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:47:34',NULL,NULL,NULL),('1230398612979183617','1217726827821334530',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:47:43',NULL,NULL,NULL),('1230399107487625218','1215538403135766529',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:49:41',NULL,NULL,NULL),('1230400047896719362','1217285994676506625',NULL,2,2,'泉州世派电子商务有限公司','18559780403','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:53:25',NULL,NULL,NULL),('1230400570628632577','1218091755098931202',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:55:30',NULL,NULL,NULL),('1230401401683832834','1216627039612706817',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 15:58:48',NULL,NULL,NULL),('1230401967847763970','1217777474784526337',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:01:03',NULL,NULL,NULL),('1230402681508589570','1215538403135766529',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:03:53',NULL,NULL,NULL),('1230403723600195586','1217792708345659393',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:08:02',NULL,NULL,NULL),('1230404514746593282','1217285685698908162',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:11:10',NULL,NULL,NULL),('1230404748956528641','1215538333690675202',NULL,2,2,'晋江市卫生计生执法大队（晋江市卫生监督所）','15260856039','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:12:06',NULL,NULL,NULL),('1230406470290501633','1215473739706187777',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:18:57',NULL,NULL,NULL),('1230406889796399106','1215113784209752066',NULL,2,2,'晋江市金井中心卫生院','13959811363','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:20:37',NULL,NULL,NULL),('1230407093647962114','1217343761676259329',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:21:25',NULL,NULL,NULL),('1230408176940216321','1216571435712016385',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:25:43',NULL,NULL,NULL),('1230409046775951361','1217413485772689409',NULL,2,2,'晋江市汇鑫小额贷款有限公司','18559529595','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:29:11',NULL,NULL,NULL),('1230410604494319617','1217795505879318529',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:35:22',NULL,NULL,NULL),('1230411544580452354','1217406988292476930',NULL,2,2,'晋江一岂科技有限公司','13950116705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:39:06',NULL,NULL,NULL),('1230412286561218562','1215467321171165186',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:42:03',NULL,NULL,NULL),('1230412603365388290','1217441556953321473',NULL,2,2,'晋江市锦马汽车检验有限公司','15059570222','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:43:19',NULL,NULL,NULL),('1230415768416546817','1215816445317902337',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 16:55:53',NULL,NULL,NULL),('1230416953798160385','1215485446725877762',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:00:36',NULL,NULL,NULL),('1230417849638580225','1215158534740688898',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:04:10',NULL,NULL,NULL),('1230418934537252865','1214816262354460673',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:08:28',NULL,NULL,NULL),('1230419217136873474','1216527470442868738',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:09:36',NULL,NULL,NULL),('1230420271945609218','1216013260860452866',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:13:47',NULL,NULL,NULL),('1230421080393510914','1216019689554079745',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:17:00',NULL,NULL,NULL),('1230422011755491330','1216640531120005122',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:20:42',NULL,NULL,NULL),('1230422715354181633','1215833733270106114',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:23:30',NULL,NULL,NULL),('1230423324178378753','1216637279154479105',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:25:55',NULL,NULL,NULL),('1230423901230723073','1215831176141369346',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:28:12',NULL,NULL,NULL),('1230424525313798146','1216633241696477185',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:30:41',NULL,NULL,NULL),('1230425666864934914','1216622237096878081',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-20',NULL,NULL,NULL,'2020-02-20 17:35:13',NULL,NULL,NULL),('1230651020539981826','1216543259027861505',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 08:30:42',NULL,NULL,NULL),('1230654991505682433','1216635186188394498',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 08:46:29',NULL,NULL,NULL),('1230656968734142466','1217797260176326658',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 08:54:20',NULL,NULL,NULL),('1230657636278595585','1217799606050553857',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 08:56:59',NULL,NULL,NULL),('1230658413869002754','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:00:05',NULL,NULL,NULL),('1230658435377393666','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:00:10',NULL,NULL,NULL),('1230659354101936129','1217816084707606530',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:03:49',NULL,NULL,NULL),('1230660472445988866','1215836419931533314',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:08:15',NULL,NULL,NULL),('1230662387930099713','1217801467751104513',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:15:52',NULL,NULL,NULL),('1230663270835286017','1217804193272758274',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:19:23',NULL,NULL,NULL),('1230663822868606978','1216573077731700737',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:21:34',NULL,NULL,NULL),('1230664364122566658','1215832201065689089',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:23:43',NULL,NULL,NULL),('1230664379788292097','1217808853987557377',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:23:47',NULL,NULL,NULL),('1230665437579177985','1217811820883017729',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:27:59',NULL,NULL,NULL),('1230665480180723713','1217696703822495745',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:28:09',NULL,NULL,NULL),('1230666046436929538','1216526928714952705',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:30:24',NULL,NULL,NULL),('1230669348444696577','1217638361703972866',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:43:32',NULL,NULL,NULL),('1230670908641898497','1216546223469654017',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:49:44',NULL,NULL,NULL),('1230672030639190017','1216909778505191425',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:54:11',NULL,NULL,NULL),('1230673095635890177','1216001905252134914',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:58:25',NULL,NULL,NULL),('1230673270618058753','1216908795511328769',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 09:59:07',NULL,NULL,NULL),('1230673733811826689','1216660790828867585',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 10:00:57',NULL,NULL,NULL),('1230679374634807298','1216884293817618433',NULL,2,2,'晋江市池店镇卫生院','15705936082','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 10:23:22',NULL,NULL,NULL),('1230681058601725953','1216647927309541377',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 10:30:03',NULL,NULL,NULL),('1230684305785745410','1217356630987919361',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 10:42:58',NULL,NULL,NULL),('1230686861006073858','1215538333690675202',NULL,2,2,'晋江市卫生计生执法大队（晋江市卫生监督所）','15260856039','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 10:53:07',NULL,NULL,NULL),('1230688311169904642','1215560663351476225',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 10:58:53',NULL,NULL,NULL),('1230691207542337538','1215538333690675202',NULL,2,2,'晋江市卫生计生执法大队（晋江市卫生监督所）','15260856039','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 11:10:23',NULL,NULL,NULL),('1230692131518148609','1217370660297265154',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 11:14:03',NULL,NULL,NULL),('1230692391292366849','1213420676216590338',NULL,2,2,'晋江市远祥服装织造有限公司','17759990690','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 11:15:05',NULL,NULL,NULL),('1230697304512655361','1217631268146053121',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 11:34:37',NULL,NULL,NULL),('1230749160119070722','1216558659094474753',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 15:00:40',NULL,NULL,NULL),('1230749651825717250','1216537209268629506',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 15:02:37',NULL,NULL,NULL),('1230749685698916354','1217401868280418305',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 15:02:45',NULL,NULL,NULL),('1230751186794180609','1216560905018437633',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 15:08:43',NULL,NULL,NULL),('1230751755483082753','1216560905018437633',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 15:10:59',NULL,NULL,NULL),('1230753940186984449','1215835925364371457',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 15:19:40',NULL,NULL,NULL),('1230756946211106818','1215829170072875009',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 15:31:36',NULL,NULL,NULL),('1230772325998260225','1216544622403153922',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:32:43',NULL,NULL,NULL),('1230773866121523202','1216541042883457025',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:38:51',NULL,NULL,NULL),('1230775595579863042','1216537775478697986',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:45:43',NULL,NULL,NULL),('1230776310998102018','1216530531655643138',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:48:33',NULL,NULL,NULL),('1230777223913533442','1215828292985188353',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:52:11',NULL,NULL,NULL),('1230777628898750466','1215820693602594818',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:53:48',NULL,NULL,NULL),('1230777687916802049','1216899629946261505',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:54:02',NULL,NULL,NULL),('1230778201949728770','1214753188196999170',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:56:04',NULL,NULL,NULL),('1230778759049768961','1216902364519223298',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 16:58:17',NULL,NULL,NULL),('1230779523235180545','1216897138248667138',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 17:01:19',NULL,NULL,NULL),('1230780043857358850','1216894203741622274',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-21',NULL,NULL,NULL,'2020-02-21 17:03:23',NULL,NULL,NULL),('1231745577398693889','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 09:00:05',NULL,NULL,NULL),('1231745598831587330','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 09:00:10',NULL,NULL,NULL),('1231754458866774018','1217649602182840321',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 09:35:22',NULL,NULL,NULL),('1231757747511488514','1217653960702230530',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 09:48:26',NULL,NULL,NULL),('1231761545600561154','1216612625987674114',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 10:03:32',NULL,NULL,NULL),('1231766173973082114','1214729918731083778',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 10:21:55',NULL,NULL,NULL),('1231771393302065154','1216544806155612161',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 10:42:40',NULL,NULL,NULL),('1231773261008859137','1216531659139084290',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 10:50:05',NULL,NULL,NULL),('1231774201350844418','1217704183101194242',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 10:53:49',NULL,NULL,NULL),('1231775438330785794','1214372739553513473',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 10:58:44',NULL,NULL,NULL),('1231776213064871938','1217652147215204354',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:01:49',NULL,NULL,NULL),('1231777929692835842',NULL,NULL,2,1,NULL,'13505986964','806645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:08:38',NULL,NULL,NULL),('1231778726019198977','1216913705288093697',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:11:48',NULL,NULL,NULL),('1231779800675381249','1217724057139609602',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:16:04',NULL,NULL,NULL),('1231781760149352450','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:23:51',NULL,NULL,NULL),('1231781781691297793','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:23:56',NULL,NULL,NULL),('1231782544148656130','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:26:58',NULL,NULL,NULL),('1231785040745197569','1216636156737757185',NULL,2,2,'福建美溪通信科技股份有限公司','15906066156','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 11:36:53',NULL,NULL,NULL),('1231793210372780034',NULL,NULL,2,1,NULL,'13505986964','368692','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 12:09:21',NULL,NULL,NULL),('1231834486057070593','1214383445065682945',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 14:53:22',NULL,NULL,NULL),('1231834842308669441','1216897138248667138',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 14:54:47',NULL,NULL,NULL),('1231836373141549058','1216621154668650497',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 15:00:52',NULL,NULL,NULL),('1231836425482268674','1217010214633492481',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 15:01:04',NULL,NULL,NULL),('1231837286304444417','1216618566950854658',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 15:04:30',NULL,NULL,NULL),('1231838104327942146','1216533634073260033',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 15:07:45',NULL,NULL,NULL),('1231843326341279745','1216270521314865154',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 15:28:30',NULL,NULL,NULL),('1231850382750248962','1216168659274199041',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 15:56:32',NULL,NULL,NULL),('1231851984617861121','1216922950050009089',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-24',NULL,NULL,NULL,'2020-02-24 16:02:54',NULL,NULL,NULL),('1232105315890229250','1219984744003944450',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 08:49:33',NULL,NULL,NULL),('1232107965314625537','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:00:05',NULL,NULL,NULL),('1232107986743324674','58',NULL,1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:00:10',NULL,NULL,NULL),('1232107986932068354','87',NULL,1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:00:10',NULL,NULL,NULL),('1232112341194240002','1216919994282037249',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:17:28',NULL,NULL,NULL),('1232113242113961985','1216918775069167617',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:21:03',NULL,NULL,NULL),('1232114083029970946','1216916876643291138',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:24:23',NULL,NULL,NULL),('1232114888625745922','1216933815218360321',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:27:35',NULL,NULL,NULL),('1232115783274983426','1216930657352044545',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:31:08',NULL,NULL,NULL),('1232116093984829441','1215457675257626625',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:32:23',NULL,NULL,NULL),('1232116559363829762','1216928516818358273',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:34:14',NULL,NULL,NULL),('1232117072696307713','1216926276145664001',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:36:16',NULL,NULL,NULL),('1232117644619018241','1216992090911690753',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:38:32',NULL,NULL,NULL),('1232118434939138050','1214369770497986561',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:41:41',NULL,NULL,NULL),('1232118632012705793','1216989131008135169',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:42:28',NULL,NULL,NULL),('1232119132674191362','1216986840586801154',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:44:27',NULL,NULL,NULL),('1232119230841876481','1214513030570774530',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:44:50',NULL,NULL,NULL),('1232119549701255169','1214363432564903937',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:46:06',NULL,NULL,NULL),('1232119820850425857','1216934917208821762',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:47:11',NULL,NULL,NULL),('1232119848511860737','1214367428725788673',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:47:18',NULL,NULL,NULL),('1232120392953491457','1214432643169456129',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:49:28',NULL,NULL,NULL),('1232121318653161473','1217006810842550274',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:53:08',NULL,NULL,NULL),('1232122095446650881','1217004781910904834',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:56:13',NULL,NULL,NULL),('1232122854397571074','1216993972832980994',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-02-25',NULL,NULL,NULL,'2020-02-25 09:59:14',NULL,NULL,NULL),('1232124071773335553','1217259341950767105',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:04:05',NULL,NULL,NULL),('1232124666051686402','1217264394958819330',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:06:26',NULL,NULL,NULL),('1232125139840266242','1217263341009915906',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:08:19',NULL,NULL,NULL),('1232127072256782338','1217261892246982657',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:16:00',NULL,NULL,NULL),('1232128063689584641','1216929492556075009',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:19:56',NULL,NULL,NULL),('1232128908418215937','1216924150795358209',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:23:18',NULL,NULL,NULL),('1232129194637520898','1217625199751528450',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:24:26',NULL,NULL,NULL),('1232129636826214402','1216916298546565122',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:26:11',NULL,NULL,NULL),('1232130483060600833','1216642541949034498',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:29:33',NULL,NULL,NULL),('1232131039149813761','1217637700941709314',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:31:46',NULL,NULL,NULL),('1232132804322652161','1216921638382096385',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:38:47',NULL,NULL,NULL),('1232135907281334273','1217460964589371394',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:51:06',NULL,NULL,NULL),('1232136283288104962','1215562083865772033',NULL,2,2,'晋江万兴隆染织实业有限公司','15880742575','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:52:36',NULL,NULL,NULL),('1232136773635796993','1217630398083825665',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:54:33',NULL,NULL,NULL),('1232137574877884418','1217256435050631170',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 10:57:44',NULL,NULL,NULL),('1232138790693367809','1216980552222003201',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 11:02:34',NULL,NULL,NULL),('1232140463750901761','1217698821522391042',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 11:09:13',NULL,NULL,NULL),('1232198098684604417','1216933918465347585',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 14:58:14',NULL,NULL,NULL),('1232203054749708289','1215189834935615489',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 15:17:56',NULL,NULL,NULL),('1232203737930526722','1217001853900836865',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 15:20:39',NULL,NULL,NULL),('1232204395228295169','1216998303959371777',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 15:23:15',NULL,NULL,NULL),('1232210722155524097','1216996078935625729',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 15:48:24',NULL,NULL,NULL),('1232215160928727042','1215189834935615489',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:06:02',NULL,NULL,NULL),('1232215222027153410','1217007701054214146',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:06:17',NULL,NULL,NULL),('1232215661548269570','1217257216160059393',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:08:01',NULL,NULL,NULL),('1232216537545437185','1217012330840215554',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:11:30',NULL,NULL,NULL),('1232217836194230274','1217008594231250946',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:16:40',NULL,NULL,NULL),('1232218565839548418','1216993536956715009',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:19:34',NULL,NULL,NULL),('1232219000990199810','1217007960094429185',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:21:18',NULL,NULL,NULL),('1232222707832188929','1217345295537426433',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:36:01',NULL,NULL,NULL),('1232223727144529921','1217273244709572609',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:40:04',NULL,NULL,NULL),('1232223868056367105','1217416771045183489',NULL,2,2,'晋江一岂科技有限公司','13950116705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:40:38',NULL,NULL,NULL),('1232224356243992577','1217295216000651265',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:42:34',NULL,NULL,NULL),('1232224797493161986','1217270334802120706',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:44:20',NULL,NULL,NULL),('1232225133402386434','1217272803582038017',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:45:40',NULL,NULL,NULL),('1232225962041667585','1217708056645795842',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 16:48:57',NULL,NULL,NULL),('1232229497189822466','1217289318654038018',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 17:03:00',NULL,NULL,NULL),('1232229964208795650','1217268714735423489',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 17:04:51',NULL,NULL,NULL),('1232231400728555521','1217261531956269057',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 17:10:34',NULL,NULL,NULL),('1232232288100675585','1217266037150470145',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 17:14:05',NULL,NULL,NULL),('1232234830591291393','1217257558088110081',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 17:24:12',NULL,NULL,NULL),('1232235345848954882','1217010533740335106',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-25',NULL,NULL,NULL,'2020-02-25 17:26:14',NULL,NULL,NULL),('1232470353217974273','72',NULL,1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 09:00:05',NULL,NULL,NULL),('1232470374587953153','58',NULL,1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 09:00:10',NULL,NULL,NULL),('1232470374764113921','87',NULL,1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 09:00:10',NULL,NULL,NULL),('1232476946466729986','1217253635499511810',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 09:26:17',NULL,NULL,NULL),('1232481247742259201','1216995129471029250',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 09:43:22',NULL,NULL,NULL),('1232483729650348033','1216992834683424770',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 09:53:14',NULL,NULL,NULL),('1232485435599613953','1217346939964641282',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:00:00',NULL,NULL,NULL),('1232486284233142273','1217293964277731330',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:03:23',NULL,NULL,NULL),('1232487577232207874','1217335178641297409',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:08:31',NULL,NULL,NULL),('1232488621639069698','1217348139837575169',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:12:40',NULL,NULL,NULL),('1232489324906409985','1217350577751609345',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:15:28',NULL,NULL,NULL),('1232490786558439425','1217350925929172993',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:21:16',NULL,NULL,NULL),('1232491627717718018','1217354230457716738',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:24:37',NULL,NULL,NULL),('1232492405073244162','1217356291614199809',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:27:42',NULL,NULL,NULL),('1232493474037755906','1217368921309466625',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:31:57',NULL,NULL,NULL),('1232495090442825730','1217614452652834817',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:38:22',NULL,NULL,NULL),('1232497130631983105','1218025922175762434',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:46:29',NULL,NULL,NULL),('1232498977308536833','1217632801550041090',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:53:49',NULL,NULL,NULL),('1232500212518481921','1217641151771770881',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 10:58:44',NULL,NULL,NULL),('1232500866074931201','1217642384867786754',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 11:01:19',NULL,NULL,NULL),('1232502587954163714','1217973973556461570',NULL,2,2,'晋江市天泽农业开发有限公司','18859781366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 11:08:10',NULL,NULL,NULL),('1232506572643627009','1217643630576074754',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 11:24:00',NULL,NULL,NULL),('1232508010404900866','1217645354695065601',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 11:29:43',NULL,NULL,NULL),('1232509279844560898','1219524203951210497',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 11:34:45',NULL,NULL,NULL),('1232560922501967873','1218041922552135681',NULL,2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 14:59:58',NULL,NULL,NULL),('1232562188770734081','1217724666622312449',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:05:00',NULL,NULL,NULL),('1232562629982154754','1218047004773515265',NULL,2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:06:45',NULL,NULL,NULL),('1232564182625415170','1218055241275080705',NULL,2,2,'福建北电新材料科技有限公司','19959711592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:12:55',NULL,NULL,NULL),('1232564559307468801','1217731268083515393',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:14:25',NULL,NULL,NULL),('1232565847562776578','1218098084534353922',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:19:32',NULL,NULL,NULL),('1232566930645315585','1218174744747114497',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:23:50',NULL,NULL,NULL),('1232566951537143809','1217998219418599426',NULL,2,2,'福建省润永信息科技有限公司','18959759065','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:23:55',NULL,NULL,NULL),('1232569848924598273','1217007193744756737',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:35:26',NULL,NULL,NULL),('1232570758128070658','1218433137902739457',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:39:03',NULL,NULL,NULL),('1232572515407228930','1217270111828725762',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 15:46:02',NULL,NULL,NULL),('1232576818725384194','1218510722317803522',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:03:08',NULL,NULL,NULL),('1232576890460565506','1217259475484823554',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:03:25',NULL,NULL,NULL),('1232578871992381441','1217749026796011522',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:11:17',NULL,NULL,NULL),('1232581204520333313','1216982418997661698',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:20:34',NULL,NULL,NULL),('1232583406882254849','1218703412447797249',NULL,2,2,'福建陆地港集团有限责任公司','17759539230','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:29:19',NULL,NULL,NULL),('1232583833736572930','1218018881830977538',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:31:00',NULL,NULL,NULL),('1232583916632797186','1217352402571644930',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:31:20',NULL,NULL,NULL),('1232584713957404674','1217377726374105090',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:34:30',NULL,NULL,NULL),('1232585024168128513','1215107598433435650',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:35:44',NULL,NULL,NULL),('1232585282780524546','1217364117023641601',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:36:46',NULL,NULL,NULL),('1232585732858703874','1218032644818796546',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:38:33',NULL,NULL,NULL),('1232585984982511618','1218076280189157377',NULL,2,2,'军鹏特种装备股份公司','17305060050','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:39:33',NULL,NULL,NULL),('1232586368794882050','1217363725854461954',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:41:05',NULL,NULL,NULL),('1232586722127245313','1217258184792625154',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:42:29',NULL,NULL,NULL),('1232587230330089473','1217352390684987393',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:44:30',NULL,NULL,NULL),('1232587462761639938','1218732371302539265',NULL,2,2,'福建陆地港集团有限责任公司','17759539230','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 16:45:26',NULL,NULL,NULL),('1232591523523194882','1216611425145856001',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 17:01:34',NULL,NULL,NULL),('1232594990165782530','1215451889433362434',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-26',NULL,NULL,NULL,'2020-02-26 17:15:20',NULL,NULL,NULL),('1232827201703948290','1217719874684518402',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 08:38:04',NULL,NULL,NULL),('1232827938638966786','1217737445643190274',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 08:41:00',NULL,NULL,NULL),('1232829438878593025','1217696703822495745',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 08:46:57',NULL,NULL,NULL),('1232836053790928897','1218792033532108801',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 09:13:14',NULL,NULL,NULL),('1232836839669280769','1218824748625158146',NULL,2,2,'晋江新奥燃气有限公司','13506098847','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 09:16:22',NULL,NULL,NULL),('1232838713411678209','1218880003274563586',NULL,2,2,'福建荣荣新材料股份有限公司','15960417947','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 09:23:48',NULL,NULL,NULL),('1232838946455597057','1220323185384243202',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 09:24:44',NULL,NULL,NULL),('1232840078573744130','1218909437822099457',NULL,2,2,'福建省晋江优兰发纸业有限公司','13906095618','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 09:29:14',NULL,NULL,NULL),('1232841125484605442','1219097838726799362',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 09:33:24',NULL,NULL,NULL),('1232842648503496706','1219102041012559874',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 09:39:27',NULL,NULL,NULL),('1232849733312098305','1219117123998179329',NULL,2,2,'福建中策光电股份公司','18006999862','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:07:36',NULL,NULL,NULL),('1232851050306777090','1219118659495124994',NULL,2,2,'晋江市万达汽车贸易有限公司','13489887652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:12:50',NULL,NULL,NULL),('1232851191675793410','1216616135059841026',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:13:24',NULL,NULL,NULL),('1232853275389243393','1219126509734846465',NULL,2,2,'福建中策光电股份公司','18006999862','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:21:40',NULL,NULL,NULL),('1232853450493046785','1214739367654940674',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:22:22',NULL,NULL,NULL),('1232854201743224834','1219191145553321986',NULL,2,2,'福建盼福食品有限公司','13600737691','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:25:21',NULL,NULL,NULL),('1232855907767988225','1214067208985006082',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:32:08',NULL,NULL,NULL),('1232856381107777538','1219200144747126786',NULL,2,2,'福建省华晟建设发展有限公司','15392121201','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:34:01',NULL,NULL,NULL),('1232856671999537153','1217282533922721793',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:35:10',NULL,NULL,NULL),('1232857482573950977','1218115375934275586',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:38:23',NULL,NULL,NULL),('1232858385557270529','1219200153236398081',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:41:59',NULL,NULL,NULL),('1232859007106985986','1217295168508547074',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:44:27',NULL,NULL,NULL),('1232859725549318146','1215537804721831938',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:47:18',NULL,NULL,NULL),('1232862359349932034','1217293407936860162',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 10:57:46',NULL,NULL,NULL),('1232863995124297730','1218364218957488130',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:04:16',NULL,NULL,NULL),('1232864248405733378','1218385494371590146',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:05:16',NULL,NULL,NULL),('1232864713285611521','1217283314356867073',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:07:07',NULL,NULL,NULL),('1232864795057762306','1218389381128249346',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:07:27',NULL,NULL,NULL),('1232867723814416386','1218373801776111617',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:19:05',NULL,NULL,NULL),('1232868774655340546','1219208538195353602',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:23:16',NULL,NULL,NULL),('1232870021881966594','1218438715953766402',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:28:13',NULL,NULL,NULL),('1232872345190838274','1216991247831420929',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 11:37:27',NULL,NULL,NULL),('1232923818075471873','1215538333690675202',NULL,2,2,'晋江市卫生计生执法大队（晋江市卫生监督所）','15260856039','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:01:59',NULL,NULL,NULL),('1232927371410128897','1219911710920425473',NULL,2,2,'晋江市城市展馆管理服务中心','13506030795','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:16:06',NULL,NULL,NULL),('1232931374047019010','1219207676739837953',NULL,2,2,'福建省华晟建设发展有限公司','15392121201','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:32:00',NULL,NULL,NULL),('1232931595988615169','1211479687600062466',NULL,2,2,'测试','17362523273','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:32:53',NULL,NULL,NULL),('1232932079730278401','1211479687600062466',NULL,2,2,'测试','17362523273','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:34:49',NULL,NULL,NULL),('1232933324406767618','1219208718978244610',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:39:45',NULL,NULL,NULL),('1232935948069748738','1219211975909826561',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:50:11',NULL,NULL,NULL),('1232937515162386433','1219214038878248961',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 15:56:25',NULL,NULL,NULL),('1232938617383534594','1219217544397840386',NULL,2,2,'福建省华晟建设发展有限公司','15392121201','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 16:00:47',NULL,NULL,NULL),('1232945438928257026','1219217591264993282',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 16:27:54',NULL,NULL,NULL),('1232948846712176642','1219223075179061249',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 16:41:26',NULL,NULL,NULL),('1232959462462046210','1219230516620943362',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 17:23:37',NULL,NULL,NULL),('1232963060931608578','1219246424127037442',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-27',NULL,NULL,NULL,'2020-02-27 17:37:55',NULL,NULL,NULL),('1233192375493443585','1219948087653449729',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 08:49:08',NULL,NULL,NULL),('1233195471846096897','1217364117023641601',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:01:26',NULL,NULL,NULL),('1233198926228733954','1219256695734263810',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:15:10',NULL,NULL,NULL),('1233199092532887554','1217259475484823554',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:15:50',NULL,NULL,NULL),('1233200202354114562','1217379867432079361',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:20:14',NULL,NULL,NULL),('1233200923824734210','1219261648821411841',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:23:06',NULL,NULL,NULL),('1233203214808104961','1217740028650782722',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:32:12',NULL,NULL,NULL),('1233205564436234242','1219263120317472769',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:41:33',NULL,NULL,NULL),('1233205916627746818','1218048079459057666',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:42:57',NULL,NULL,NULL),('1233209601118289922','1219269920165060610',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 09:57:35',NULL,NULL,NULL),('1233211487951110145','1219271172001226754',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 10:05:05',NULL,NULL,NULL),('1233213296493051906','1219282323716038658',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 10:12:16',NULL,NULL,NULL),('1233215573438087169',NULL,NULL,2,1,NULL,'13489875197','923898','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 10:21:19',NULL,NULL,NULL),('1233218500609294337','1218047261104209921',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 10:32:57',NULL,NULL,NULL),('1233223315900973058','1217394567981060097',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 10:52:05',NULL,NULL,NULL),('1233223798275293185','1217639982060077058',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 10:54:00',NULL,NULL,NULL),('1233224096188317698','1217711463355973633',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 10:55:11',NULL,NULL,NULL),('1233225497501089794','1217723394934505473',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:00:45',NULL,NULL,NULL),('1233225625846792194','1219286594293383170',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:01:16',NULL,NULL,NULL),('1233226965306163202','1218050638986936322',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:06:35',NULL,NULL,NULL),('1233228036946640897','1217639033455312898',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:10:50',NULL,NULL,NULL),('1233229247556993025','1217714651610021889',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:15:39',NULL,NULL,NULL),('1233229839629139970','1217705202421923842',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:18:00',NULL,NULL,NULL),('1233230313388359682','1217711545161678850',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:19:53',NULL,NULL,NULL),('1233230389510782978','1219294268762406914',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:20:11',NULL,NULL,NULL),('1233230954517086209','1218733465969745922',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:22:26',NULL,NULL,NULL),('1233231606232236033','1218042479585067010',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:25:01',NULL,NULL,NULL),('1233232478714576897','1219295738723352577',NULL,2,2,'龙之族（中国）有限公司','15805972719','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 11:28:29',NULL,NULL,NULL),('1233287428211589121','1219427489378516994',NULL,2,2,'晋江富海鸿汽车贸易有限公司','18050888018','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:06:50',NULL,NULL,NULL),('1233288636095643649','1216294714458796034',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:11:38',NULL,NULL,NULL),('1233290298931658753','1219444817306632194',NULL,2,2,'晋江市永和镇马坪村金马汽修厂','13599773033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:18:15',NULL,NULL,NULL),('1233291358773559298','1219457571014885377',NULL,2,2,'福建亲亲股份有限公司','15905035025','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:22:28',NULL,NULL,NULL),('1233293510036275201','1214462943484252161',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:31:00',NULL,NULL,NULL),('1233295809752186882','1217656909662846977',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:40:09',NULL,NULL,NULL),('1233295924957134850','1219462170006306817',NULL,2,2,'福建省晋江万利瓷业有限公司','18859989399','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:40:36',NULL,NULL,NULL),('1233296677192974338','1217656015558868994',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:43:36',NULL,NULL,NULL),('1233297450035429377','1217654774019719170',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:46:40',NULL,NULL,NULL),('1233297813224407042','1220014155839324161',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:48:06',NULL,NULL,NULL),('1233298328792449026','1217653148336848897',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:50:09',NULL,NULL,NULL),('1233300688268804097','1217978010360152066',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 15:59:32',NULL,NULL,NULL),('1233301170655707137','1220018282749247489',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:01:27',NULL,NULL,NULL),('1233301602073427970','1219464271675572225',NULL,2,2,'福建亲亲股份有限公司','15905035025','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:03:10',NULL,NULL,NULL),('1233302037530263553','1217771320943640577',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:04:54',NULL,NULL,NULL),('1233303217803214849','1217727438629437442',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:09:35',NULL,NULL,NULL),('1233304148234059777','1217797631892324353',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:13:17',NULL,NULL,NULL),('1233304536169431041','1217659720928657409',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:14:49',NULL,NULL,NULL),('1233304736044793858','1217739065084936193',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:15:37',NULL,NULL,NULL),('1233305421331152897','1219514603537481729',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:18:20',NULL,NULL,NULL),('1233306084563861506','1217724498770460673',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:20:58',NULL,NULL,NULL),('1233306480044785666','1217658574059143170',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:22:33',NULL,NULL,NULL),('1233306975710855169','1217737851379187713',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:24:31',NULL,NULL,NULL),('1233308253362962433','1217735734220357634',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 16:29:36',NULL,NULL,NULL),('1233316292535107586','1219515563278123009',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-02-28',NULL,NULL,NULL,'2020-02-28 17:01:32',NULL,NULL,NULL),('1234294869007122433','1218032269793492994',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 09:50:03',NULL,NULL,NULL),('1234317444680630273','1219911710920425473',NULL,2,2,'晋江市城市展馆管理服务中心','13506030795','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 11:19:45',NULL,NULL,NULL),('1234382350062829570','1216927175534465026',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 15:37:40',NULL,NULL,NULL),('1234385196904726529','1217651608645599233',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 15:48:59',NULL,NULL,NULL),('1234385851778187266','1217729148152250369',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 15:51:35',NULL,NULL,NULL),('1234386938652377090','1217726282016555009',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 15:55:54',NULL,NULL,NULL),('1234387137034567681','1219526711729766401',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 15:56:41',NULL,NULL,NULL),('1234387870475730945','1217723404468158465',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 15:59:36',NULL,NULL,NULL),('1234389548377686018','1219527503018770433',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 16:06:16',NULL,NULL,NULL),('1234396850795167746','1219532204212797442',NULL,2,2,'泉州福林汽车销售服务有限公司','15805039263','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 16:35:17',NULL,NULL,NULL),('1234400908868173825','1219532372580548609',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 16:51:25',NULL,NULL,NULL),('1234401745774428161','1218740181599903746',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 16:54:44',NULL,NULL,NULL),('1234403205559992321','1218736496165642241',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 17:00:32',NULL,NULL,NULL),('1234405654416965634','1218735247710085122',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 17:10:16',NULL,NULL,NULL),('1234406859708940289','1218727750186164226',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-02',NULL,NULL,NULL,'2020-03-02 17:15:04',NULL,NULL,NULL),('1234642780559622145','1217748888358813698',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 08:52:32',NULL,NULL,NULL),('1234644020886618114','1219533176188223490',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 08:57:27',NULL,NULL,NULL),('1234650254813544449','1218064298648076289',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 09:22:14',NULL,NULL,NULL),('1234653514756636673','1219538307218718721',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 09:35:11',NULL,NULL,NULL),('1234664755692683266','1217755142246432769',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 10:19:51',NULL,NULL,NULL),('1234665754280968193','1217758031610183681',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 10:23:49',NULL,NULL,NULL),('1234671109962579969','1218134971353464834',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 10:45:06',NULL,NULL,NULL),('1234674878741856257','1219545859042099202',NULL,2,2,'泉州福林汽车销售服务有限公司','15805039263','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 11:00:04',NULL,NULL,NULL),('1234678099409485826','1218435971322863617',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 11:12:52',NULL,NULL,NULL),('1234679796764622849','1218438469903310850',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 11:19:37',NULL,NULL,NULL),('1234683206595362818','1218440482485559298',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 11:33:10',NULL,NULL,NULL),('1234735730547343361','1218067633220419586',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 15:01:53',NULL,NULL,NULL),('1234741135671410689','1218791399160406018',NULL,2,2,'晋江市新佳园资产管理有限公司','13255006151','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 15:23:21',NULL,NULL,NULL),('1234741370736984065','1218482842347102209',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 15:24:17',NULL,NULL,NULL),('1234741511606878209','1218494928187940866',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 15:24:51',NULL,NULL,NULL),('1234741691622211585','1218553375818375169',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 15:25:34',NULL,NULL,NULL),('1234742702051016705','1218718494087045121',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 15:29:35',NULL,NULL,NULL),('1234746689986871298','1218725617428717570',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 15:45:26',NULL,NULL,NULL),('1234750739251838977','1218730428484149250',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:01:31',NULL,NULL,NULL),('1234755316206387201','1218381589428428801',NULL,2,2,'安踏体育用品集团有限公司','18120662230','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:19:42',NULL,NULL,NULL),('1234756214685024257','1218832729433563138',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:23:16',NULL,NULL,NULL),('1234757726521901057','1219563169425440769',NULL,2,2,'泉州福林汽车销售服务有限公司','15805039263','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:29:17',NULL,NULL,NULL),('1234759496916647938','1217737275408973825',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:36:19',NULL,NULL,NULL),('1234759833002033154','1218831276157558785',NULL,2,2,'晋江大白科技有限公司','18850018674','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:37:39',NULL,NULL,NULL),('1234761639832698882','1218844270748884994',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:44:50',NULL,NULL,NULL),('1234762266407190530','1219073489806417921',NULL,2,2,'晋江大白科技有限公司','18850018674','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:47:19',NULL,NULL,NULL),('1234763980476628993','1218832910208065537',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:54:08',NULL,NULL,NULL),('1234764098068135937','1219434077111762945',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 16:54:36',NULL,NULL,NULL),('1234766014688903169','1219078147820085250',NULL,2,2,'福建省兴泰物业管理有限公司','15260225737','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 17:02:13',NULL,NULL,NULL),('1234768887766171650','1219456254724849666',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 17:13:38',NULL,NULL,NULL),('1234771917689438209','1219459294475370497',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 17:25:40',NULL,NULL,NULL),('1234772396800589826','1220258824707915778',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-03',NULL,NULL,NULL,'2020-03-03 17:27:35',NULL,NULL,NULL),('1235019935978209282','1218002335565938690',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 09:51:12',NULL,NULL,NULL),('1235020441211486210','1218001736321531906',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 09:53:13',NULL,NULL,NULL),('1235020949733097473','1218001176910430209',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 09:55:14',NULL,NULL,NULL),('1235021318726991873','1217998767685435393',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 09:56:42',NULL,NULL,NULL),('1235022155704549377','1219944390156369921',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:00:02',NULL,NULL,NULL),('1235022611294044162','1217725840591224833',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:01:50',NULL,NULL,NULL),('1235022791900774402','1219940660577058818',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:02:33',NULL,NULL,NULL),('1235023354826702849','1219878538421747713',NULL,2,2,'晋江市第三医院','13559554933','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:04:48',NULL,NULL,NULL),('1235023860034813953','1219878040939544577',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:06:48',NULL,NULL,NULL),('1235024312784764929','1219559039394955265',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:08:36',NULL,NULL,NULL),('1235024615999389697','1219557176494833665',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:09:48',NULL,NULL,NULL),('1235024940105842689','1219551803931148289',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:11:06',NULL,NULL,NULL),('1235029794761064450','1212897100929503234',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 10:30:23',NULL,NULL,NULL),('1235041708018876417','1218013594797539329',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:17:43',NULL,NULL,NULL),('1235044531519471618','1219595870589206529',NULL,2,2,'晋江农商银行','15260663037','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:28:56',NULL,NULL,NULL),('1235045050258407425','1219548214110240770',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:31:00',NULL,NULL,NULL),('1235046859857313794','1219546709609201665',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:38:12',NULL,NULL,NULL),('1235047431276707842','1219538543433531394',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:40:28',NULL,NULL,NULL),('1235047741835558913','1219518734750760961',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:41:42',NULL,NULL,NULL),('1235048165967773697','1219517658479771649',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:43:23',NULL,NULL,NULL),('1235048811932532738','1219516454337036289',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:45:57',NULL,NULL,NULL),('1235049282558607361','1219515045105418242',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:47:49',NULL,NULL,NULL),('1235049753742524417','1219513879743217666',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 11:49:42',NULL,NULL,NULL),('1235103882087088129','1219453472349405185',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:24:47',NULL,NULL,NULL),('1235106436946706434','1216894203741622274',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:34:56',NULL,NULL,NULL),('1235107548047196161','1216618566950854658',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:39:21',NULL,NULL,NULL),('1235109414676054017','1216530531655643138',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:46:46',NULL,NULL,NULL),('1235110328505843714','1215833733270106114',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:50:24',NULL,NULL,NULL),('1235112119461068801','1215831176141369346',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:57:31',NULL,NULL,NULL),('1235112153090998273','1219186952113348610',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:57:39',NULL,NULL,NULL),('1235112418267480065','1215828292985188353',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 15:58:42',NULL,NULL,NULL),('1235112773160124418','1219601832096088065',NULL,2,2,'福建省晋江市绿色保健蛋品有限公司','15375754488','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:00:07',NULL,NULL,NULL),('1235112923869855746','1215816445317902337',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:00:42',NULL,NULL,NULL),('1235113223057948673','1215572086349676545',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:01:54',NULL,NULL,NULL),('1235113346244657154','1216894203741622274',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:02:23',NULL,NULL,NULL),('1235114266600783873','1215537804721831938',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:06:03',NULL,NULL,NULL),('1235115579187249154','1219431142298533890',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:11:16',NULL,NULL,NULL),('1235115837623484417','1219461101423476738',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:12:17',NULL,NULL,NULL),('1235116896706215937','1219467141422563329',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:16:30',NULL,NULL,NULL),('1235116941845315585','1215816445317902337',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:16:40',NULL,NULL,NULL),('1235117252106371074','1219465396390772738',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:17:54',NULL,NULL,NULL),('1235117841167007746','1219084637838630913',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:20:15',NULL,NULL,NULL),('1235118261331410945','1215833733270106114',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:21:55',NULL,NULL,NULL),('1235118334589124610','1219521919099912193',NULL,2,2,'晋江拓普旺防霉材料有限公司','18259038660','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:22:13',NULL,NULL,NULL),('1235118414842937346','1215828292985188353',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:22:32',NULL,NULL,NULL),('1235120245560164353','1212657476319645697',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:29:48',NULL,NULL,NULL),('1235121630385127425','1212657476319645697',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:35:18',NULL,NULL,NULL),('1235124268338102273','1212657476319645697',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:45:47',NULL,NULL,NULL),('1235125732355719169','1218427970952224769',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:51:36',NULL,NULL,NULL),('1235126051114434562','1218411365367144450',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:52:52',NULL,NULL,NULL),('1235126490828488706','1218406931400613889',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 16:54:37',NULL,NULL,NULL),('1235128583043792898','1218403607259504642',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:02:56',NULL,NULL,NULL),('1235129015849828353','1218397163663515650',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:04:39',NULL,NULL,NULL),('1235129439399034881','1218392381775273986',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:06:20',NULL,NULL,NULL),('1235129776121954306','1218381613512122370',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:07:40',NULL,NULL,NULL),('1235130277697798146','1218378289073217537',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:09:40',NULL,NULL,NULL),('1235131282472681473','1218119763188842498',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:13:40',NULL,NULL,NULL),('1235131688250621953','1218117017358368770',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:15:16',NULL,NULL,NULL),('1235133160807841794','1219650880119291905',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:21:07',NULL,NULL,NULL),('1235134289218224130','1219655815321927682',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-04',NULL,NULL,NULL,'2020-03-04 17:25:36',NULL,NULL,NULL),('1235371522063974401','1219895506436636674',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 09:08:17',NULL,NULL,NULL),('1235373242596835330','1219908628002127873',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 09:15:07',NULL,NULL,NULL),('1235374785194737666','1219916477956636673',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 09:21:15',NULL,NULL,NULL),('1235375808244203521','1219928679526711297',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 09:25:19',NULL,NULL,NULL),('1235378781401759746','1219937952994443265',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 09:37:08',NULL,NULL,NULL),('1235381625911623681','1219943640734908418',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 09:48:26',NULL,NULL,NULL),('1235381711722889218','1217273961440628737',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 09:48:47',NULL,NULL,NULL),('1235385091727933442','1218356578026119169',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:02:12',NULL,NULL,NULL),('1235385675730239490','1218077016138514433',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:04:32',NULL,NULL,NULL),('1235386122369089538','1218075647994298370',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:06:18',NULL,NULL,NULL),('1235386530143518721','1218073069436862465',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:07:55',NULL,NULL,NULL),('1235387008516472833','1218072998066585601',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:09:49',NULL,NULL,NULL),('1235387319981293570','1217747288936480770',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:11:04',NULL,NULL,NULL),('1235387727898329090','1218066597483184130',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:12:41',NULL,NULL,NULL),('1235388124805316610','1218066465547157506',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:14:16',NULL,NULL,NULL),('1235388458160209921','1218024603406893058',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:15:35',NULL,NULL,NULL),('1235389504144130049','1218005094847545346',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:19:44',NULL,NULL,NULL),('1235389874920603650','1218004246310486018',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:21:13',NULL,NULL,NULL),('1235390311002390530','1218003112011300866',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:22:57',NULL,NULL,NULL),('1235390552640438274','1218074405976997889',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:23:54',NULL,NULL,NULL),('1235390747520385026','1218113872355983361',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:24:41',NULL,NULL,NULL),('1235391272819212289','1218096054776430593',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:26:46',NULL,NULL,NULL),('1235391752165244930','1218092577346093057',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:28:40',NULL,NULL,NULL),('1235392313585418242','1218081744750706689',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:30:54',NULL,NULL,NULL),('1235392732994846721','1218087121840046082',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:32:34',NULL,NULL,NULL),('1235393106619252737','1231793752096501762',NULL,2,2,'晋江国家体育城市股份有限公司','13505986964','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:34:03',NULL,NULL,NULL),('1235397401045483521','1220215865371279362',NULL,2,2,'泉州市雄健体育用品有限公司','18050881166','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 10:51:07',NULL,NULL,NULL),('1235404254483693569','1219155573380079617',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 11:18:21',NULL,NULL,NULL),('1235459001374756866','1220157880188026882',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 14:55:54',NULL,NULL,NULL),('1235459982833504257','1214383468067246081',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 14:59:48',NULL,NULL,NULL),('1235465535467048961','1214479073808551938',NULL,2,2,'晋江市聚艺健身有限公司','18900300373','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 15:21:52',NULL,NULL,NULL),('1235468402009591810','1220193814782689281',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 15:33:15',NULL,NULL,NULL),('1235468780365172738','1220240921497452546',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 15:34:45',NULL,NULL,NULL),('1235474663329517569','1220248054104342530',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 15:58:08',NULL,NULL,NULL),('1235475084257284097','1211849919334236161',NULL,2,2,'测试','17362523273','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 15:59:48',NULL,NULL,NULL),('1235476795860471810','1219120807784079362',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:06:36',NULL,NULL,NULL),('1235476837581213698','1220239278928314369',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:06:46',NULL,NULL,NULL),('1235480858266193922','1219172505265233921',NULL,2,2,'艾派集团（中国）有限公司','13959757688','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:22:45',NULL,NULL,NULL),('1235481196280958978','1220232041237331970',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:24:05',NULL,NULL,NULL),('1235483961589780481','1220225581916897282',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:35:05',NULL,NULL,NULL),('1235485699302510593','1219143006838448130',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:41:59',NULL,NULL,NULL),('1235486086365466625','1219529426220400642',NULL,2,2,'福建冠泓工业有限公司','15396395062','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:43:31',NULL,NULL,NULL),('1235486109211840514','1220275796959051777',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:43:37',NULL,NULL,NULL),('1235487358019719170','1220222370095054849',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:48:35',NULL,NULL,NULL),('1235488415357620225','1219290379195564034',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:52:47',NULL,NULL,NULL),('1235489586898030594','1220261940962541569',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 16:57:26',NULL,NULL,NULL),('1235490728600162305','1220212229161369601',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 17:01:58',NULL,NULL,NULL),('1235491600545632258','1220210106075987970',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 17:05:26',NULL,NULL,NULL),('1235492223378804737','1219478980067901442',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 17:07:55',NULL,NULL,NULL),('1235492400835612674','1219549120738410498',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 17:08:37',NULL,NULL,NULL),('1235499150632570881','1219444402859065346',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 17:35:26',NULL,NULL,NULL),('1235501348502392833',NULL,NULL,2,1,NULL,'18965878729','433493','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-05',NULL,NULL,NULL,'2020-03-05 17:44:10',NULL,NULL,NULL),('1235729896211238913','1219298256048144385',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 08:52:20',NULL,NULL,NULL),('1235731944084361218','1219440219934212097',NULL,2,2,'福建省正基检测技术有限公司','15080426614','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 09:00:28',NULL,NULL,NULL),('1235737626070241281','1217648599928733698',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 09:23:03',NULL,NULL,NULL),('1235740848117796866','1217400322662617089',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 09:35:51',NULL,NULL,NULL),('1235741184781996033','1219464615822409730',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 09:37:12',NULL,NULL,NULL),('1235745581335334913','1219529606223151106',NULL,2,2,'福建正扬科技股份有限公司','15880713988','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 09:54:40',NULL,NULL,NULL),('1235746387002413057','1219530637640253441',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 09:57:52',NULL,NULL,NULL),('1235748816355872770',NULL,NULL,2,1,NULL,'15375886386','985272','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 10:07:31',NULL,NULL,NULL),('1235750591104307202','1219535606607036417',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 10:14:34',NULL,NULL,NULL),('1235753509140320258','1219541402262749186',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 10:26:10',NULL,NULL,NULL),('1235753613339414530','1219582046729453570',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 10:26:35',NULL,NULL,NULL),('1235754474941730818','1219803688659337217',NULL,2,2,'福建冠泓工业有限公司','15396395062','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 10:30:00',NULL,NULL,NULL),('1235754686422732801','1219806358677766145',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 10:30:51',NULL,NULL,NULL),('1235760467633262594','1219831985833263106',NULL,2,2,'福建冠泓工业有限公司','15396395062','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 10:53:49',NULL,NULL,NULL),('1235762420069191682','1217345496356507649',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 11:01:34',NULL,NULL,NULL),('1235766021533487106','1219529062171590657',NULL,2,2,'晋江拓普旺防霉材料有限公司','18259038660','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 11:15:53',NULL,NULL,NULL),('1235766534593335297','1217718719728386049',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 11:17:55',NULL,NULL,NULL),('1235770600987840513','1219871507010830337',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 11:34:05',NULL,NULL,NULL),('1235773869139185665','1217751595110957058',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 11:47:04',NULL,NULL,NULL),('1235825461532053505','1219872353102610433',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:12:05',NULL,NULL,NULL),('1235826201084317697','1219879402892967937',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:15:01',NULL,NULL,NULL),('1235826710931329026','1219885753148915713',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:17:03',NULL,NULL,NULL),('1235827017270710274',NULL,NULL,2,1,NULL,'18859989399','166192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:18:16',NULL,NULL,NULL),('1235827447010709506',NULL,NULL,2,1,NULL,'18859989399','728240','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:19:58',NULL,NULL,NULL),('1235828243639062530',NULL,NULL,2,1,NULL,'18859989399','069400','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:23:08',NULL,NULL,NULL),('1235828956435861505','1219928679526711297',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:25:58',NULL,NULL,NULL),('1235829464663871489','1219948087653449729',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:27:59',NULL,NULL,NULL),('1235829842218340354','1219937952994443265',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:29:29',NULL,NULL,NULL),('1235830146460569602','1219908628002127873',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:30:42',NULL,NULL,NULL),('1235830318015991809','1219943640734908418',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:31:23',NULL,NULL,NULL),('1235836603331530754','1219916477956636673',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 15:56:21',NULL,NULL,NULL),('1235842783562977282','1219916477956636673',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 16:20:55',NULL,NULL,NULL),('1235843125964984322','1219928679526711297',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 16:22:16',NULL,NULL,NULL),('1235843345218031618','1219895506436636674',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 16:23:09',NULL,NULL,NULL),('1235847526611963905','1219902317613039618',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 16:39:45',NULL,NULL,NULL),('1235848006859771906','1219917568526008322',NULL,2,2,'晋江市海晟机械有限公司','15859506299','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 16:41:40',NULL,NULL,NULL),('1235848831782899714','1219920970362404866',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 16:44:57',NULL,NULL,NULL),('1235850182629806082','1220187057930911745',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-06',NULL,NULL,NULL,'2020-03-06 16:50:19',NULL,NULL,NULL),('1236839544859414529','1216902364519223298',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 10:21:41',NULL,NULL,NULL),('1236839725151571970','1216616135059841026',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 10:22:24',NULL,NULL,NULL),('1236839959084683265','1215828292985188353',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 10:23:20',NULL,NULL,NULL),('1236840104094355458','1215537804721831938',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 10:23:54',NULL,NULL,NULL),('1236840211468537857','1215485446725877762',NULL,2,2,'晋江经济报发展有限责任公司','13505004167','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 10:24:20',NULL,NULL,NULL),('1236843703323086849','1220191027625738242',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 10:38:12',NULL,NULL,NULL),('1236857278355755010','1219535606607036417',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 11:32:09',NULL,NULL,NULL),('1236894493253324801',NULL,NULL,2,1,NULL,'15960417947','290410','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 14:00:02',NULL,NULL,NULL),('1236912900736569346','1219979131165360129',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 15:13:10',NULL,NULL,NULL),('1236914072574775297','1220168788616429569',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 15:17:50',NULL,NULL,NULL),('1236914332705509377','1220248410003619841',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 15:18:52',NULL,NULL,NULL),('1236920352244781058','1220251895952588801',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 15:42:47',NULL,NULL,NULL),('1236921290049212418','1217276938930900994',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 15:46:31',NULL,NULL,NULL),('1236928426460336130','1217736756825227266',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 16:14:52',NULL,NULL,NULL),('1236932123139526657','1217721583083257857',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 16:29:33',NULL,NULL,NULL),('1236935517673639938','1217717951851986945',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 16:43:03',NULL,NULL,NULL),('1236938359226519553','1217706105803702273',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 16:54:20',NULL,NULL,NULL),('1236941824682119169','1217650056161722369',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-09',NULL,NULL,NULL,'2020-03-09 17:08:06',NULL,NULL,NULL),('1237188553771864066','1219791034142179329',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 09:28:31',NULL,NULL,NULL),('1237192995766292482','1219806186426089473',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 09:46:10',NULL,NULL,NULL),('1237197200027570177','1220323561542008833',NULL,2,2,'晋江市东石镇成圆方广告服务部','13600704026','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 10:02:53',NULL,NULL,NULL),('1237201553396355073','1218000372006715393',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 10:20:11',NULL,NULL,NULL),('1237203276366106625','1217978245446696962',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 10:27:01',NULL,NULL,NULL),('1237204152073867265','1217749394258984962',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 10:30:30',NULL,NULL,NULL),('1237213747269881857','1218081819237351425',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 11:08:38',NULL,NULL,NULL),('1237215207936249857','1218078711534911489',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 11:14:26',NULL,NULL,NULL),('1237220179239260161','1218016451881926657',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 11:34:11',NULL,NULL,NULL),('1237274693786947586','1220253622441361409',NULL,2,2,'泉州荣兴丝绸材料研究院有限公司','15711376693','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 15:10:49',NULL,NULL,NULL),('1237282141784526850','1219873151819726849',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 15:40:24',NULL,NULL,NULL),('1237285822407921665','1219871122015666178',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 15:55:02',NULL,NULL,NULL),('1237298150184603649','1219827191286611970',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 16:44:01',NULL,NULL,NULL),('1237299090455285761','1219865173423046658',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 16:47:45',NULL,NULL,NULL),('1237300851404460034','1219829709529956354',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 16:54:45',NULL,NULL,NULL),('1237303063354560514','1219827584712327169',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 17:03:32',NULL,NULL,NULL),('1237305643195453441','1219861683632095234',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 17:13:48',NULL,NULL,NULL),('1237311336870858754','1219902737429315585',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-10',NULL,NULL,NULL,'2020-03-10 17:36:25',NULL,NULL,NULL),('1237537974254587905','1219920712303656961',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 08:37:00',NULL,NULL,NULL),('1237541509587292161','1218082596001480706',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 08:51:02',NULL,NULL,NULL),('1237546022176051201','1219892406237806593',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:08:58',NULL,NULL,NULL),('1237547369076117505','1218062000182067202',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:14:19',NULL,NULL,NULL),('1237547918081150978','1219867388472737793',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:16:30',NULL,NULL,NULL),('1237550578654007297','1219819903448530945',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:27:05',NULL,NULL,NULL),('1237552731653165058','1217738331136262146',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:35:38',NULL,NULL,NULL),('1237553708217159681','1219817465337364482',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:39:31',NULL,NULL,NULL),('1237555668995559425','1218094005196226561',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:47:18',NULL,NULL,NULL),('1237557360457699329','1218091171063070721',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:54:02',NULL,NULL,NULL),('1237557915615776769','1219872797111631873',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 09:56:14',NULL,NULL,NULL),('1237559653752131585','1218086531693084673',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 10:03:08',NULL,NULL,NULL),('1237562241767723010','1218084484893704194',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 10:13:25',NULL,NULL,NULL),('1237564744223707138','1218007014152667138',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 10:23:22',NULL,NULL,NULL),('1237573957754834945','1219874477622444034',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 10:59:59',NULL,NULL,NULL),('1237575805186363393','1218103201019002881',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 11:07:19',NULL,NULL,NULL),('1237578341649764354','1219878625491304450',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 11:17:24',NULL,NULL,NULL),('1237579417438408705','1218102308257202178',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 11:21:40',NULL,NULL,NULL),('1237581262550487042','1218089650237800449',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 11:29:00',NULL,NULL,NULL),('1237583541492011010','1218096316610052097',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 11:38:04',NULL,NULL,NULL),('1237639714467500033','1217998219418599426',NULL,2,2,'福建省润永信息科技有限公司','18959759065','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:21:16',NULL,NULL,NULL),('1237641441107267585','1218099047018070018',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:28:08',NULL,NULL,NULL),('1237642089261453313','1220021332171833345',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:30:43',NULL,NULL,NULL),('1237643921597681665','1218440981326716929',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:37:59',NULL,NULL,NULL),('1237644160954028034','1218372418830196738',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:38:56',NULL,NULL,NULL),('1237644870168891393','1219973405948788738',NULL,2,2,'福能期货股份有限公司晋江营业部','13788816686','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:41:46',NULL,NULL,NULL),('1237645245450047489','1218365566469922817',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:43:15',NULL,NULL,NULL),('1237646017302646786','1218127915628167170',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:46:19',NULL,NULL,NULL),('1237647465591623681','1219867009437679618',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 15:52:04',NULL,NULL,NULL),('1237665200505638913','1218130520949456898',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:02:33',NULL,NULL,NULL),('1237666535565185026','1219795260285140994',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:07:51',NULL,NULL,NULL),('1237668482829537282','1219809712367747073',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:15:35',NULL,NULL,NULL),('1237669101476794369','1218810674495479810',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:18:03',NULL,NULL,NULL),('1237670220613570562','1218800517380169729',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:22:30',NULL,NULL,NULL),('1237670720830459905','1219811510352625665',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:24:29',NULL,NULL,NULL),('1237671527541919746','1219813105232527361',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:27:41',NULL,NULL,NULL),('1237671642415517698','1218798999293779969',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:28:09',NULL,NULL,NULL),('1237671898217730050','1218437334773653505',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:29:10',NULL,NULL,NULL),('1237672770951729153','1219552108269846529',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:32:38',NULL,NULL,NULL),('1237673237844873218','1218346019239092226',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:34:29',NULL,NULL,NULL),('1237674155139158018','1219556556337627137',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:38:08',NULL,NULL,NULL),('1237674904980049921','1219786365198155778',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 17:41:06',NULL,NULL,NULL),('1237747626338701313',NULL,NULL,2,1,NULL,'13600755402','822191','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 22:30:05',NULL,NULL,NULL),('1237747920443297793',NULL,NULL,2,1,NULL,'13659228811','721335','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 22:31:15',NULL,NULL,NULL),('1237748338359554049',NULL,NULL,2,1,NULL,'13655928811','569364','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-11',NULL,NULL,NULL,'2020-03-11 22:32:54',NULL,NULL,NULL),('1237898628090056705','1219815482366902273',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 08:30:06',NULL,NULL,NULL),('1237899042730561537','1218820301115219969',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 08:31:45',NULL,NULL,NULL),('1237900304146518017','1219815718338445313',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 08:36:46',NULL,NULL,NULL),('1237901137978347521','1219822690488041473',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 08:40:05',NULL,NULL,NULL),('1237901426189946881','1218812544634970113',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 08:41:13',NULL,NULL,NULL),('1237902168460120065','1219869545464872962',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 08:44:10',NULL,NULL,NULL),('1237904524895604738','1218732945431453697',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 08:53:32',NULL,NULL,NULL),('1237908753538371586','1219796622544748546',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:10:20',NULL,NULL,NULL),('1237908852435865601','1219062593365336065',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:10:44',NULL,NULL,NULL),('1237910902632632322','1219197107945201666',NULL,2,2,'晋江市致和社工事务所','15860517253','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:18:53',NULL,NULL,NULL),('1237912556710940673','1218842817661624322',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:25:27',NULL,NULL,NULL),('1237913219067039746','1218108797797597185',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:28:05',NULL,NULL,NULL),('1237915217350905857','1218836384098410497',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:36:01',NULL,NULL,NULL),('1237917501862465538','1220257432576475138',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:45:06',NULL,NULL,NULL),('1237918912654364673','1220023822044905473',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:50:42',NULL,NULL,NULL),('1237919842942603265','1220015766884073473',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 09:54:24',NULL,NULL,NULL),('1237921628814331905','1220161126193446913',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 10:01:30',NULL,NULL,NULL),('1237923221798408194','1220173299930120194',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 10:07:50',NULL,NULL,NULL),('1237925016872439809','1220187140072161281',NULL,2,2,'晋江海西职业培训中心','15259513222','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 10:14:58',NULL,NULL,NULL),('1237931016216137730','1219549149637165057',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 10:38:48',NULL,NULL,NULL),('1237933137346973697','1220176795374993410',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 10:47:14',NULL,NULL,NULL),('1237937825400246274','1219560946138136578',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:05:52',NULL,NULL,NULL),('1237938062072238081','1220182093884047362',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:06:48',NULL,NULL,NULL),('1237939385983324161','1220183958113763329',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:12:04',NULL,NULL,NULL),('1237939755434397698','1219470124042469378',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:13:32',NULL,NULL,NULL),('1237942273472221185','1220179602089984001',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:23:32',NULL,NULL,NULL),('1237943251860738049','1219465980581822466',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:27:25',NULL,NULL,NULL),('1237944888020979714','1219150635069464577',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:33:55',NULL,NULL,NULL),('1237947501063983106','1220189371525775362',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 11:44:18',NULL,NULL,NULL),('1237997007038074881','1219512433568169985',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 15:01:02',NULL,NULL,NULL),('1237998265140531202','1219793345828634625',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 15:06:01',NULL,NULL,NULL),('1237998371973648385','1219511060147519489',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 15:06:27',NULL,NULL,NULL),('1238000001716604930','1219473687992909825',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 15:12:55',NULL,NULL,NULL),('1238002895601815554','1219564685238517761',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 15:24:25',NULL,NULL,NULL),('1238007740589166593','1219563827297828866',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 15:43:41',NULL,NULL,NULL),('1238011419442565122','1219468365085589506',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 15:58:18',NULL,NULL,NULL),('1238016826563121154','1219787769384026113',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 16:19:47',NULL,NULL,NULL),('1238017885016707074','1219562488736038913',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 16:23:59',NULL,NULL,NULL),('1238021630639230977','1219559999924125698',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 16:38:52',NULL,NULL,NULL),('1238024966188847105','1219559999924125698',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 16:52:07',NULL,NULL,NULL),('1238027564744724481','1219079312028852226',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 17:02:27',NULL,NULL,NULL),('1238038779575422977','1211849919334236161',NULL,2,2,'测试','17362523273','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-12',NULL,NULL,NULL,'2020-03-12 17:47:01',NULL,NULL,NULL),('1238265983886446593','1219829149053501441',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 08:49:51',NULL,NULL,NULL),('1238267506855006209','1219788873601662977',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 08:55:54',NULL,NULL,NULL),('1238271676492304385','1218832577738170369',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 09:12:28',NULL,NULL,NULL),('1238272229976854529','1219515185182588930',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 09:14:40',NULL,NULL,NULL),('1238276834630586369','1219090097505427458',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 09:32:58',NULL,NULL,NULL),('1238277600116232193','1218808888011382786',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 09:36:00',NULL,NULL,NULL),('1238281303145598978','1219474964785184769',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 09:50:43',NULL,NULL,NULL),('1238285985708527618','1220022895804170242',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:09:19',NULL,NULL,NULL),('1238287828861865986','1219472555891539970',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:16:39',NULL,NULL,NULL),('1238290289349644290','1218116615560822786',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:26:25',NULL,NULL,NULL),('1238290407318638593','1219471274053517313',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:26:54',NULL,NULL,NULL),('1238291790994362370','1220285224684896257',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:32:23',NULL,NULL,NULL),('1238292522837495810','1218091377347330049',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:35:18',NULL,NULL,NULL),('1238294167872884737','1218074769212112898',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:41:50',NULL,NULL,NULL),('1238294602251784194','1220188691218055169',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:43:34',NULL,NULL,NULL),('1238296121499996161','1219936748092538881',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:49:36',NULL,NULL,NULL),('1238296212193431553','1217757739992809473',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:49:58',NULL,NULL,NULL),('1238297827860303873','1219831839561105410',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:56:23',NULL,NULL,NULL),('1238297973532676098','1217986629948473346',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 10:56:58',NULL,NULL,NULL),('1238299940476702721','1217741321343664129',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 11:04:46',NULL,NULL,NULL),('1238359582724608001','1218839666254536705',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:01:46',NULL,NULL,NULL),('1238361154581975042','1218807186487107586',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:08:01',NULL,NULL,NULL),('1238361241685086210','1219467174809223170',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:08:22',NULL,NULL,NULL),('1238362705010642946','1218469806810980354',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:14:11',NULL,NULL,NULL),('1238363671399256065','1219464218839924737',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:18:01',NULL,NULL,NULL),('1238364445390950402','1218817543444226050',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:21:06',NULL,NULL,NULL),('1238364484465086465','1219788873601662977',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:21:15',NULL,NULL,NULL),('1238369923953086466','1218054908880683010',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:42:52',NULL,NULL,NULL),('1238372629027508225','1216635186188394498',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 15:53:37',NULL,NULL,NULL),('1238377646602080257','1219870669634813954',NULL,2,2,'泉州永实工程质量检测有限公司','18396220746','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 16:13:33',NULL,NULL,NULL),('1238381538047971330','1218850304968220674',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 16:29:01',NULL,NULL,NULL),('1238383007732092930',NULL,NULL,2,1,NULL,'15880713988','665184','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 16:34:51',NULL,NULL,NULL),('1238383374129713154',NULL,NULL,2,1,NULL,'18695659900','594951','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 16:36:19',NULL,NULL,NULL),('1238385296769306626',NULL,NULL,2,1,NULL,'18695659900','027118','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 16:43:57',NULL,NULL,NULL),('1238387007516856322',NULL,NULL,2,1,NULL,'18695659900','395007','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 16:50:45',NULL,NULL,NULL),('1238390177395658754','1219529606223151106',NULL,2,2,'福建正扬科技股份有限公司','15880713988','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 17:03:21',NULL,NULL,NULL),('1238390989446467585','1220256914189860866',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-13',NULL,NULL,NULL,'2020-03-13 17:06:34',NULL,NULL,NULL),('1239356943752019970','1211909253418237954',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 09:04:56',NULL,NULL,NULL),('1239359066820624385','1219440890318209025',NULL,2,2,'泉州众骋汽车有限公司','18159581122','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 09:13:22',NULL,NULL,NULL),('1239360197189746690','1219427489378516994',NULL,2,2,'晋江富海鸿汽车贸易有限公司','18050888018','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 09:17:51',NULL,NULL,NULL),('1239361367387979777','1219427489378516994',NULL,2,2,'晋江富海鸿汽车贸易有限公司','18050888018','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 09:22:30',NULL,NULL,NULL),('1239364472385093633','1211943010711945217',NULL,2,2,'中菱（福建）电梯有限公司','18959847128','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 09:34:51',NULL,NULL,NULL),('1239368039330267137','1220323561542008833',NULL,2,2,'晋江市东石镇成圆方广告服务部','13600704026','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 09:49:01',NULL,NULL,NULL),('1239371941731680258','1220239278928314369',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:04:31',NULL,NULL,NULL),('1239372669372121089','1212575205948461057',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:07:25',NULL,NULL,NULL),('1239373322194567170','1212573153730039810',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:10:01',NULL,NULL,NULL),('1239378889977937921','1220258824707915778',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:32:08',NULL,NULL,NULL),('1239381368715132930','1219943640734908418',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:41:59',NULL,NULL,NULL),('1239381988356440066','1219948087653449729',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:44:27',NULL,NULL,NULL),('1239383124178157569','1219937952994443265',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:48:58',NULL,NULL,NULL),('1239384079963570177','1220253622441361409',NULL,2,2,'泉州荣兴丝绸材料研究院有限公司','15711376693','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 10:52:45',NULL,NULL,NULL),('1239391238495453186','1219908628002127873',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 11:21:12',NULL,NULL,NULL),('1239392891193835522','1220253622441361409',NULL,2,2,'泉州荣兴丝绸材料研究院有限公司','15711376693','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 11:27:46',NULL,NULL,NULL),('1239394579359252482','1218100291304488961',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 11:34:29',NULL,NULL,NULL),('1239394791230324737','1219916477956636673',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 11:35:19',NULL,NULL,NULL),('1239395915379294209','1218001247433457666',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 11:39:47',NULL,NULL,NULL),('1239397346211577858','1217971590294208513',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 11:45:28',NULL,NULL,NULL),('1239398042742865922','1217719503224373249',NULL,2,2,'晋江市广播电视事业局','13599718877','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 11:48:14',NULL,NULL,NULL),('1239444605938745346','1220256914189860866',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 14:53:16',NULL,NULL,NULL),('1239445934966882305','1220215865371279362',NULL,2,2,'泉州市雄健体育用品有限公司','18050881166','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 14:58:33',NULL,NULL,NULL),('1239446416452009986','1219928679526711297',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 15:00:28',NULL,NULL,NULL),('1239447003113504769','1219895506436636674',NULL,2,2,'福建省晋江市和盛机械有限公司','13808552366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 15:02:48',NULL,NULL,NULL),('1239449522174738433','1211919059642269697',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 15:12:48',NULL,NULL,NULL),('1239451012675190786','1211933540841734146',NULL,2,2,'晋江凯燕新材料科技有限公司','13255957226','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 15:18:43',NULL,NULL,NULL),('1239455693799473153','1211936677191270402',NULL,2,2,'泉州市陶源环保科技有限公司','13666026522','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 15:37:20',NULL,NULL,NULL),('1239458483267485697','1212596177489432578',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 15:48:25',NULL,NULL,NULL),('1239461179189936130','1212637667074838529',NULL,2,2,'福建晋工机械有限公司','13799553654','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 15:59:07',NULL,NULL,NULL),('1239465476996775938','1212680200152748034',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 16:16:12',NULL,NULL,NULL),('1239467145880977410','1212683619374534657',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-03-16',NULL,NULL,NULL,'2020-03-16 16:22:50',NULL,NULL,NULL),('1239469250914074626','1212684140613275649',NULL,2,2,'晋江裕福集团有限公司','18759429880','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 16:31:12',NULL,NULL,NULL),('1239470243567419394','1212684627026710530',NULL,2,2,'晋江乐康医院有限公司','15109613666','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 16:35:08',NULL,NULL,NULL),('1239472186360643585','1212916225613565953',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 16:42:52',NULL,NULL,NULL),('1239473228901040129','1212684140613275649',NULL,2,2,'晋江裕福集团有限公司','18759429880','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 16:47:00',NULL,NULL,NULL),('1239475561659678722','1211936677191270402',NULL,2,2,'泉州市陶源环保科技有限公司','13666026522','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 16:56:16',NULL,NULL,NULL),('1239483360351404033','1212903750239326209',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 17:27:16',NULL,NULL,NULL),('1239484355542302721','1212905755926138882',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 17:31:13',NULL,NULL,NULL),('1239486225748901889','1219532372580548609',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 17:38:39',NULL,NULL,NULL),('1239486750896734209','1212941994020638721',NULL,2,2,'顺宏达（福建）针织服饰有限公司','15905907962','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 17:40:44',NULL,NULL,NULL),('1239487054723727361','1212987116238213122',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-16',NULL,NULL,NULL,'2020-03-16 17:41:57',NULL,NULL,NULL),('1239716005744263170','1219526128939614209',NULL,2,2,'泉州市勾勾手电子商务有限公司','13959737339','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 08:51:43',NULL,NULL,NULL),('1239720965169004546','1212916225613565953',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 09:11:25',NULL,NULL,NULL),('1239732926803918849','1219546709609201665',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 09:58:57',NULL,NULL,NULL),('1239734620782641154','1219534159362441218',NULL,2,2,'晋江嘉年华婴儿用品有限公司','15859590857','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 10:05:41',NULL,NULL,NULL),('1239738009440534529','1218077016138514433',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 10:19:09',NULL,NULL,NULL),('1239738066403377153','1216931364314566657',NULL,2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 10:19:22',NULL,NULL,NULL),('1239744436695515138','1214843906471059458',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 10:44:41',NULL,NULL,NULL),('1239747488722763778','1215158534740688898',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 10:56:49',NULL,NULL,NULL),('1239755292326019074','1218073069436862465',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 11:27:49',NULL,NULL,NULL),('1239756890309705730','1218002335565938690',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 11:34:10',NULL,NULL,NULL),('1239757646119092225','1218001176910430209',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 11:37:11',NULL,NULL,NULL),('1239758909296656386','1217978010360152066',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 11:42:12',NULL,NULL,NULL),('1239806791089438721','1215158534740688898',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 14:52:28',NULL,NULL,NULL),('1239819323564933121','1217653148336848897',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 15:42:16',NULL,NULL,NULL),('1239822246185320450','1212987260249640961',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 15:53:52',NULL,NULL,NULL),('1239832279086317569','1217735734220357634',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 16:33:44',NULL,NULL,NULL),('1239833647440248834','1217727438629437442',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 16:39:11',NULL,NULL,NULL),('1239836166006554626','1217726282016555009',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 16:49:11',NULL,NULL,NULL),('1239837744239263745','1212987260249640961',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 16:55:27',NULL,NULL,NULL),('1239842437254397954',NULL,NULL,2,1,NULL,'18959996091','844349','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 17:14:06',NULL,NULL,NULL),('1239843006387896321','1219600721192730626',NULL,2,2,'福建中和新材料科技有限公司','13365952758','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-17',NULL,NULL,NULL,'2020-03-17 17:16:22',NULL,NULL,NULL),('1240082715286487042','1217348139837575169',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:08:53',NULL,NULL,NULL),('1240083855805825026','1217345295537426433',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:13:25',NULL,NULL,NULL),('1240086753415577601','1217266037150470145',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:24:56',NULL,NULL,NULL),('1240087503411658754','1217264394958819330',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:27:55',NULL,NULL,NULL),('1240088046699855874','1214345627488571394',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:30:04',NULL,NULL,NULL),('1240088068560568322','1217261892246982657',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:30:09',NULL,NULL,NULL),('1240088807294943233','1217259341950767105',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:33:06',NULL,NULL,NULL),('1240089348234330113','1214353812312117250',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:35:15',NULL,NULL,NULL),('1240090436735909890','1214355387147440130',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:39:34',NULL,NULL,NULL),('1240091783635976193','1214361014678671362',NULL,2,2,'福建盼盼食品有限公司','13665929319','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 09:44:55',NULL,NULL,NULL),('1240100491807997953','1214369112097116161',NULL,2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:19:31',NULL,NULL,NULL),('1240101209591824385','1214369770497986561',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:22:22',NULL,NULL,NULL),('1240102050071625729','1214423562958475266',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:25:43',NULL,NULL,NULL),('1240102401894039553','1214439353158275074',NULL,2,2,'信泰（福建）科技有限公司','15102155779','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:27:07',NULL,NULL,NULL),('1240103275911495681','1214454594474676226',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:30:35',NULL,NULL,NULL),('1240104033889337346','1214455044749987841',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:33:36',NULL,NULL,NULL),('1240104222096146434','1216993536956715009',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:34:21',NULL,NULL,NULL),('1240108795544256513','1214728131785613313',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:52:31',NULL,NULL,NULL),('1240109355865522177','1214733294395023361',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:54:45',NULL,NULL,NULL),('1240110042531807234','1217712699413168130',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 10:57:28',NULL,NULL,NULL),('1240116042668228609','1215189834935615489',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 11:21:19',NULL,NULL,NULL),('1240119783450525698','1217801467751104513',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 11:36:11',NULL,NULL,NULL),('1240122372032348162','1214369112097116161',NULL,2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 11:46:28',NULL,NULL,NULL),('1240171152643506178','1214353812312117250',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:00:18',NULL,NULL,NULL),('1240171414502293505','1214355387147440130',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:01:21',NULL,NULL,NULL),('1240171639874830338','1214369112097116161',NULL,2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:02:14',NULL,NULL,NULL),('1240171881936502786','1214369770497986561',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:03:12',NULL,NULL,NULL),('1240172227492626433','1214423562958475266',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:04:34',NULL,NULL,NULL),('1240172408489426945','1216920881062760449',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:05:18',NULL,NULL,NULL),('1240172607521734657','1214454594474676226',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:06:05',NULL,NULL,NULL),('1240173226634559489','1214733294395023361',NULL,2,2,'福建约克新材料科技有限公司','18065606507','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:08:33',NULL,NULL,NULL),('1240173568046710785','1216642541949034498',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:09:54',NULL,NULL,NULL),('1240176099057516546','1214353812312117250',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:19:58',NULL,NULL,NULL),('1240176436493467650','1214369770497986561',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:21:18',NULL,NULL,NULL),('1240177565361029122','1216914529154256898',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:25:47',NULL,NULL,NULL),('1240178309006934017','1216908795511328769',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:28:44',NULL,NULL,NULL),('1240178874151649281','1216660790828867585',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:30:59',NULL,NULL,NULL),('1240179513850118146','1216651527934976001',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:33:32',NULL,NULL,NULL),('1240180660451196930','1216632437300273153',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:38:05',NULL,NULL,NULL),('1240182084782309377','1212933920325177346',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:43:45',NULL,NULL,NULL),('1240182787093348353','1216013260860452866',NULL,2,2,'晋江市中医院','15960586523','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:46:32',NULL,NULL,NULL),('1240184121095929858','1212947823172063234',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:51:50',NULL,NULL,NULL),('1240185061186256898','1216627039612706817',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:55:34',NULL,NULL,NULL),('1240185597730013186','1213024890861457409',NULL,2,2,'福建省晋江市兴达机电器材有限公司','18960355033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 15:57:42',NULL,NULL,NULL),('1240186998422028289','1213383835576766465',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:03:16',NULL,NULL,NULL),('1240193416835416065','1216995905291440129',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:28:46',NULL,NULL,NULL),('1240193593730187266','1212894669021712385',NULL,2,2,'晋江市安海镇卫生院','13799557721','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:29:29',NULL,NULL,NULL),('1240195902170251265','1218078711534911489',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:38:39',NULL,NULL,NULL),('1240197774415282177','1216622237096878081',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:46:05',NULL,NULL,NULL),('1240199048342847490','1213296617474560002',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:51:09',NULL,NULL,NULL),('1240199337900818433','1217658574059143170',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:52:18',NULL,NULL,NULL),('1240200579486105602','1213375300625305601',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:57:14',NULL,NULL,NULL),('1240200862068948994','1216566349946449921',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 16:58:21',NULL,NULL,NULL),('1240202892640567298','1215544821565931521',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 17:06:26',NULL,NULL,NULL),('1240204245572042753','1215456879954673666',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 17:11:48',NULL,NULL,NULL),('1240205368152342530','1212933920325177346',NULL,2,2,'福建夜光达科技股份有限公司','15980473561','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 17:16:16',NULL,NULL,NULL),('1240207514126041089','1213370321193734146',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 17:24:47',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1240208902692323329','1213391690212118529',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 17:30:19',NULL,NULL,NULL),('1240209133337100290','1213389172656640002',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-18',NULL,NULL,NULL,'2020-03-18 17:31:14',NULL,NULL,NULL),('1240434597863407618','1214437987694219266',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-03-19',NULL,NULL,NULL,'2020-03-19 08:27:08',NULL,NULL,NULL),('1240438030951563266','1217289318654038018',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 08:40:47',NULL,NULL,NULL),('1240438388071383042','1217008594231250946',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 08:42:12',NULL,NULL,NULL),('1240439996360474625','1216521103799775234',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 08:48:36',NULL,NULL,NULL),('1240440669378494466','1215568800515145729',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 08:51:16',NULL,NULL,NULL),('1240441480452030465','1213433843349000193',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 08:54:29',NULL,NULL,NULL),('1240442072264130562','1215570767543058433',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 08:56:50',NULL,NULL,NULL),('1240442668446695425','1215560663351476225',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 08:59:13',NULL,NULL,NULL),('1240444357794906114','1215565904239181825',NULL,2,2,'晋江市疾病预防控制中心','13675959528','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:05:55',NULL,NULL,NULL),('1240445052833021953','1213445866220752897',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:08:41',NULL,NULL,NULL),('1240446173949509634','1215564809194487810',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:13:08',NULL,NULL,NULL),('1240449166061125634','1215841735112945666',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:25:02',NULL,NULL,NULL),('1240450888020049921','1215552396269240322',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:31:52',NULL,NULL,NULL),('1240452487907950593','1215463533140033538',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:38:14',NULL,NULL,NULL),('1240453001081044994','1215538403135766529',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:40:16',NULL,NULL,NULL),('1240453288940322818','1213481714882514945',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:41:25',NULL,NULL,NULL),('1240453677563559938','1215476555652841473',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:42:57',NULL,NULL,NULL),('1240455014363742210','1215524453077794818',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 09:48:16',NULL,NULL,NULL),('1240458493480189953','1215460590617673730',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:02:06',NULL,NULL,NULL),('1240459966276485121','1215434147816849409',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:07:57',NULL,NULL,NULL),('1240460652049383426','1215460247632658434',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:10:40',NULL,NULL,NULL),('1240461762604613633','1213305593486446593',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:15:05',NULL,NULL,NULL),('1240463185006346241','1213353405095940097',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:20:44',NULL,NULL,NULL),('1240464087767367681','1215196400472604674',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:24:19',NULL,NULL,NULL),('1240464659182567425','1220253622441361409',NULL,2,2,'泉州荣兴丝绸材料研究院有限公司','15711376693','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:26:36',NULL,NULL,NULL),('1240466866275663873','1213361485699420161',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:35:22',NULL,NULL,NULL),('1240467864201248770','1215113784209752066',NULL,2,2,'晋江市金井中心卫生院','13959811363','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:39:20',NULL,NULL,NULL),('1240471536175988737','1215189664495878146',NULL,2,2,'晋江市妇幼保健院','13799233113','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 10:53:55',NULL,NULL,NULL),('1240473416071430145','1213793630708322306',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:01:23',NULL,NULL,NULL),('1240475604009140225','1213796975414104065',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:10:05',NULL,NULL,NULL),('1240476063654526978','1213758959509327874',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:11:55',NULL,NULL,NULL),('1240477020866002945','1214364201229832194',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:15:43',NULL,NULL,NULL),('1240478074332561409','1213757323755933698',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:19:54',NULL,NULL,NULL),('1240478174307991554','1218810674495479810',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:20:18',NULL,NULL,NULL),('1240480265344696321','1215113784209752066',NULL,2,2,'晋江市金井中心卫生院','13959811363','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:28:36',NULL,NULL,NULL),('1240482519057481729','1219564685238517761',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:37:34',NULL,NULL,NULL),('1240483465091137537','1219563827297828866',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:41:19',NULL,NULL,NULL),('1240484207780741121','1214100840579616770',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 11:44:16',NULL,NULL,NULL),('1240530556421193729','1213762698039283714',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 14:48:27',NULL,NULL,NULL),('1240531521908031490','1213742610015866882',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 14:52:17',NULL,NULL,NULL),('1240532508517384193','1217725840591224833',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 14:56:12',NULL,NULL,NULL),('1240535252745633793','1214012053283426305',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:07:06',NULL,NULL,NULL),('1240536843032772610','1213799058515185666',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:13:26',NULL,NULL,NULL),('1240538532825579522','1214441663758405634',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:20:08',NULL,NULL,NULL),('1240539470395129858','1214110188903092225',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:23:52',NULL,NULL,NULL),('1240539947543347201','1214109622848212994',NULL,2,2,'海西纺织新材料工业技术晋江研究院','15280796970','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:25:46',NULL,NULL,NULL),('1240541192316305409','1212916225613565953',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:30:43',NULL,NULL,NULL),('1240542400384909314','1214370868822626305',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:35:31',NULL,NULL,NULL),('1240543601788764162','1214470478874349569',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:40:17',NULL,NULL,NULL),('1240544851259342849','1216894342052990977',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:45:15',NULL,NULL,NULL),('1240545294144290818','1217293964277731330',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:47:00',NULL,NULL,NULL),('1240545641407496194','1217259475484823554',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:48:23',NULL,NULL,NULL),('1240545853383426050','1213389172656640002',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:49:14',NULL,NULL,NULL),('1240546154605756418','1213375300625305601',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:50:26',NULL,NULL,NULL),('1240546824725512194','1217345496356507649',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:53:05',NULL,NULL,NULL),('1240546909655973889','1213481714882514945',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:53:26',NULL,NULL,NULL),('1240547071296061442','1213757323755933698',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:54:04',NULL,NULL,NULL),('1240547232185368577','1217364117023641601',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:54:43',NULL,NULL,NULL),('1240547434719920129','1213785376003477506',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:55:31',NULL,NULL,NULL),('1240547556405067777','1213796975414104065',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:56:00',NULL,NULL,NULL),('1240548386050981889','1213361485699420161',NULL,2,2,'晋江市医院晋南分院','15396486268','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:59:18',NULL,NULL,NULL),('1240548429445251073','1214042788153282562',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'发送条数超限制','2020-03-19',NULL,NULL,NULL,'2020-03-19 15:59:28',NULL,NULL,NULL),('1240558763518246913','1219562488736038913',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:40:32',NULL,NULL,NULL),('1240559325378822146','1216926276145664001',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:42:46',NULL,NULL,NULL),('1240560249589514241','1216985665393152001',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:46:26',NULL,NULL,NULL),('1240561203600736258','1219560946138136578',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:50:14',NULL,NULL,NULL),('1240561445670797314','1219511060147519489',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:51:11',NULL,NULL,NULL),('1240562090251436033','1219559999924125698',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:53:45',NULL,NULL,NULL),('1240562532452712450','1219473687992909825',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:55:30',NULL,NULL,NULL),('1240562860166266881','1218091171063070721',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:56:49',NULL,NULL,NULL),('1240562998871900161','1218094005196226561',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:57:22',NULL,NULL,NULL),('1240563178304225282','1218096316610052097',NULL,2,2,'晋江市医院','18350528526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:58:04',NULL,NULL,NULL),('1240563483024605186','1218082596001480706',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 16:59:17',NULL,NULL,NULL),('1240565354665656322','1220189371525775362',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 17:06:43',NULL,NULL,NULL),('1240566184227684354','1220239278928314369',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 17:10:01',NULL,NULL,NULL),('1240567776511311874','1214806891054587905',NULL,2,2,'晋江市路桥建设开发有限公司','17350011170','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 17:16:21',NULL,NULL,NULL),('1240570417232527361','1218054908880683010',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 17:26:50',NULL,NULL,NULL),('1240570786582937601','1215457675257626625',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 17:28:18',NULL,NULL,NULL),('1240572128080740353','1215479057190273025',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 17:33:38',NULL,NULL,NULL),('1240573342235279362','1218001977741475841',NULL,2,2,'福州大学晋江科教园管委会','15980228632','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-19',NULL,NULL,NULL,'2020-03-19 17:38:28',NULL,NULL,NULL),('1240802748446871553','1214007880756252674',NULL,2,2,'福建乐隆隆食品科技有限公司','15960551920','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 08:50:02',NULL,NULL,NULL),('1240804611309244418','1214059498356887553',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 08:57:27',NULL,NULL,NULL),('1240804964389949441','1219872353102610433',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 08:58:51',NULL,NULL,NULL),('1240805275485671425','58',NULL,1,2,'张荣荣','15280619456','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:00:05',NULL,NULL,NULL),('1240805275494060034','83',NULL,1,2,'李女元','15359825666','199,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:00:05',NULL,NULL,NULL),('1240805275502448642','58',NULL,1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:00:05',NULL,NULL,NULL),('1240805296897593346','87',NULL,1,2,'叶志钦','13675957398','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:00:10',NULL,NULL,NULL),('1240805296918564865','86',NULL,1,2,'洪嘉靖','13600737303','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:00:10',NULL,NULL,NULL),('1240805296947924994','87',NULL,1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:00:10',NULL,NULL,NULL),('1240807035122028545','1219526711729766401',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:07:04',NULL,NULL,NULL),('1240808251063341058','1219217544397840386',NULL,2,2,'福建省华晟建设发展有限公司','15392121201','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:11:54',NULL,NULL,NULL),('1240809900297228289','1214361401859067905',NULL,2,2,'福建帝霖食品有限公司','13960256299','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:18:28',NULL,NULL,NULL),('1240810006585085953','1217973973556461570',NULL,2,2,'晋江市天泽农业开发有限公司','18859781366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:18:53',NULL,NULL,NULL),('1240810831629848578','1215475552429850625',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:22:10',NULL,NULL,NULL),('1240811043865825281','1214363432564903937',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:23:00',NULL,NULL,NULL),('1240812120333946881','1214366021461299201',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:27:17',NULL,NULL,NULL),('1240813112639164417','1214363432564903937',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:31:13',NULL,NULL,NULL),('1240814047914430466','1214377400591273985',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:34:56',NULL,NULL,NULL),('1240814336872615938',NULL,NULL,2,1,NULL,'13559568461','591480','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:36:05',NULL,NULL,NULL),('1240815298886569986','1217391140760735745',NULL,2,2,'晋江一岂科技有限公司','13950116705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:39:55',NULL,NULL,NULL),('1240815555850604545','1214419249741762561',NULL,2,2,'利郎（中国）有限公司','15959420909','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:40:56',NULL,NULL,NULL),('1240817959430066177','1217369827073609730',NULL,2,2,'晋江一岂科技有限公司','13950116705','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:50:29',NULL,NULL,NULL),('1240819617413271553','1217285994676506625',NULL,2,2,'泉州世派电子商务有限公司','18559780403','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 09:57:04',NULL,NULL,NULL),('1240822841998381057','1216971575710994434',NULL,2,2,'泉州时空文化传媒有限公司','13905985153','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:09:53',NULL,NULL,NULL),('1240824713693958145','1215479057190273025',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:17:19',NULL,NULL,NULL),('1240828438932164610','1215571273749413889',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:32:07',NULL,NULL,NULL),('1240830588798177281','1215576384982794241',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:40:40',NULL,NULL,NULL),('1240832456836321281','1215920271630823426',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:48:05',NULL,NULL,NULL),('1240832549543022593','1214368256555569153',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:48:28',NULL,NULL,NULL),('1240833204265488386','1216289419011584002',NULL,2,2,'福建恒安集团有限公司','13960315655','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:51:04',NULL,NULL,NULL),('1240834529338396674','1217973973556461570',NULL,2,2,'晋江市天泽农业开发有限公司','18859781366','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 10:56:20',NULL,NULL,NULL),('1240835893338640386','1215475552429850625',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 11:01:45',NULL,NULL,NULL),('1240840602921275393','1216942692534079489',NULL,2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 11:20:28',NULL,NULL,NULL),('1240841845559332866','1216971575710994434',NULL,2,2,'泉州时空文化传媒有限公司','13905985153','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 11:25:24',NULL,NULL,NULL),('1240846945770082305','1216921255798657025',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 11:45:40',NULL,NULL,NULL),('1240894679340355586','1216990086051155970',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 14:55:20',NULL,NULL,NULL),('1240895343747469314','1217256435050631170',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 14:57:59',NULL,NULL,NULL),('1240895922104242177','1217285685698908162',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:00:17',NULL,NULL,NULL),('1240896594182737922','1217696703822495745',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:02:57',NULL,NULL,NULL),('1240898180594339841','1217698821522391042',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:09:15',NULL,NULL,NULL),('1240899781539205122','1217708056645795842',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:15:37',NULL,NULL,NULL),('1240900442494406657','1217737275408973825',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:18:14',NULL,NULL,NULL),('1240904682642149378','1217748888358813698',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:35:05',NULL,NULL,NULL),('1240905901745967105','1217998219418599426',NULL,2,2,'福建省润永信息科技有限公司','18959759065','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:39:56',NULL,NULL,NULL),('1240906226787749890','1217696703822495745',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:41:14',NULL,NULL,NULL),('1240908793022320641','1218435971322863617',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:51:25',NULL,NULL,NULL),('1240909351024136193','1218381589428428801',NULL,2,2,'安踏体育用品集团有限公司','18120662230','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:53:38',NULL,NULL,NULL),('1240910691444002817','1218791399160406018',NULL,2,2,'晋江市新佳园资产管理有限公司','13255006151','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 15:58:58',NULL,NULL,NULL),('1240911653952884738','1218832910208065537',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:02:47',NULL,NULL,NULL),('1240912327243534337','1219078147820085250',NULL,2,2,'福建省兴泰物业管理有限公司','15260225737','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:05:28',NULL,NULL,NULL),('1240918073209327618','1214465949311242242',NULL,2,2,'晋江元素设计有限公司','13030981560','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:28:18',NULL,NULL,NULL),('1240919106396426241','1219155573380079617',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:32:24',NULL,NULL,NULL),('1240920257653182465','1219290379195564034',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:36:59',NULL,NULL,NULL),('1240923177236893698','1219298256048144385',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:48:35',NULL,NULL,NULL),('1240923800401416193','1213316508038533121',NULL,2,2,'福建省咭咭文化传播有限公司','18698390251','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:51:03',NULL,NULL,NULL),('1240924532919832577','1219440219934212097',NULL,2,2,'福建省正基检测技术有限公司','15080426614','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:53:58',NULL,NULL,NULL),('1240925822576037890','1219535606607036417',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 16:59:06',NULL,NULL,NULL),('1240926382838583298','1219440219934212097',NULL,2,2,'福建省正基检测技术有限公司','15080426614','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 17:01:19',NULL,NULL,NULL),('1240927194713231362','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18900370886','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 17:04:33',NULL,NULL,NULL),('1240927541397622785','1211936677191270402',NULL,2,2,'泉州市陶源环保科技有限公司','13666026522','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 17:05:55',NULL,NULL,NULL),('1240928990844227586','1211933540841734146',NULL,2,2,'晋江凯燕新材料科技有限公司','13255957226','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 17:11:41',NULL,NULL,NULL),('1240929926975131650','1217285994676506625',NULL,2,2,'泉州世派电子商务有限公司','18559780403','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 17:15:24',NULL,NULL,NULL),('1240931461985538049','1218438469903310850',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 17:21:30',NULL,NULL,NULL),('1240932666027610113','1218718494087045121',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 17:26:17',NULL,NULL,NULL),('1240951972752855042',NULL,NULL,2,1,NULL,'18160999097','204363','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 18:43:00',NULL,NULL,NULL),('1240952259345453057',NULL,NULL,2,1,NULL,'18160999097','484548','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-20',NULL,NULL,NULL,'2020-03-20 18:44:09',NULL,NULL,NULL),('1241241861952180225',NULL,NULL,2,1,NULL,'18160999097','296661','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-21',NULL,NULL,NULL,'2020-03-21 13:54:55',NULL,NULL,NULL),('1241246156638457857',NULL,NULL,2,1,NULL,'13559568461','133531','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-21',NULL,NULL,NULL,'2020-03-21 14:11:59',NULL,NULL,NULL),('1241252177746399233',NULL,NULL,2,1,NULL,'18160999097','938789','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-21',NULL,NULL,NULL,'2020-03-21 14:35:55',NULL,NULL,NULL),('1241252920578609154',NULL,NULL,2,1,NULL,'18160999097','584030','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-21',NULL,NULL,NULL,'2020-03-21 14:38:52',NULL,NULL,NULL),('1241253427242143745',NULL,NULL,2,1,NULL,'18160999097','373920','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-21',NULL,NULL,NULL,'2020-03-21 14:40:53',NULL,NULL,NULL),('1241569899508207618',NULL,NULL,2,1,NULL,'13960252008','096175','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-22',NULL,NULL,NULL,'2020-03-22 11:38:25',NULL,NULL,NULL),('1241891921853485058','1213024890861457409',NULL,2,2,'福建省晋江市兴达机电器材有限公司','18960355033','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 08:58:02',NULL,NULL,NULL),('1241892437748682754','83',NULL,1,2,'李女元','15359825666','222,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:00:05',NULL,NULL,NULL),('1241892437748682755','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:00:05',NULL,NULL,NULL),('1241892459185770497','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:00:10',NULL,NULL,NULL),('1241893444088041473','1213659767864578050',NULL,2,2,'福建省诺美护理用品有限公司','13799487213','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:04:04',NULL,NULL,NULL),('1241896177352380418','1218727750186164226',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:14:56',NULL,NULL,NULL),('1241896690005381122','1218730428484149250',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:16:58',NULL,NULL,NULL),('1241897393708929026','1218736496165642241',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:19:46',NULL,NULL,NULL),('1241898263892791298','1218740181599903746',NULL,2,2,'安踏（中国）有限公司','15160330306','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:23:14',NULL,NULL,NULL),('1241900604645773314','1219143006838448130',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:32:32',NULL,NULL,NULL),('1241903910587797506','1213760414832152577',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:45:40',NULL,NULL,NULL),('1241904289694158849','1220222370095054849',NULL,2,2,'泉州轻工职业学院','13799550180','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:47:10',NULL,NULL,NULL),('1241906049267601410','1216985665393152001',NULL,2,2,'晋江市安海医院','13860758785','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:54:10',NULL,NULL,NULL),('1241907419261505538','1213997736014139394',NULL,2,2,'泉州职业技术大学','18060007601','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 09:59:36',NULL,NULL,NULL),('1241917816563634177','1213017769201700865',NULL,2,2,'福建海创医药科技有限公司','13559060707','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 10:40:55',NULL,NULL,NULL),('1241922264862101505','1212905755926138882',NULL,2,2,'伟志股份公司','15859813817','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 10:58:36',NULL,NULL,NULL),('1241924473943298050','1211933540841734146',NULL,2,2,'晋江凯燕新材料科技有限公司','13255957226','认定','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 11:07:23',NULL,NULL,NULL),('1241963607667838977',NULL,NULL,2,1,NULL,'18160999097','151133','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 13:42:53',NULL,NULL,NULL),('1241964563457445890',NULL,NULL,2,1,NULL,'18160999097','847238','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 13:46:41',NULL,NULL,NULL),('1241983035235123201','1210918631014248450',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:05',NULL,NULL,NULL),('1241983056844177410','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983057066475521','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983057246830594','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983057422991362','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983057607540737','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983057800478722','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983057976639490','1211444027140915202',NULL,2,2,'福建省万物智联科技有限公司','18559275265','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983058144411650','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983058320572417','1211457535089885185',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983058484150273','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983058643533826','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983058815500289','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983058991661058','1211473627321516033',NULL,2,2,'晋江市新佳园资产管理有限公司','13255006151','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983059184599041','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983059348176898','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983059532726274','1211479976335949826',NULL,2,2,'福建省晋江市兴达机电器材有限公司','18960355033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:10',NULL,NULL,NULL),('1241983059696304129','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983059868270594','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983060023459841','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983060191232002','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983060359004162','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983060522582017','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','22,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983060694548482','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983060887486465','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983061055258625','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983061273362433','1211552596691566593',NULL,2,2,'福建海创医药科技有限公司','13559060707','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983061436940289','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983061604712449','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983061839593474','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983062003171329','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983062166749186','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983062338715649','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983062540042241','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983062703620097','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983062875586561','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983063043358721','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983063202742273','1211927486787534850',NULL,2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983063404068866','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983063567646722','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983063743807489','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:11',NULL,NULL,NULL),('1241983063949328385','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983064108711937','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983064263901185','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983064444256258','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983064607834114','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983064783994882','1212568548061286401',NULL,2,2,'贵人鸟股份有限公司','15359991222','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983064968544258','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983065127927809','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983065295699969','1212665763958165505',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983065484443650','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983065643827201','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','54,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983065849348097','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983066025508866','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983066189086721','1212930369930727426',NULL,2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983066373636097','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983066570768385','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983066755317762','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983066931478529','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983067095056386','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983067271217154','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983067459960833','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983067669676033','1214025654970896386',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983067858419714','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:12',NULL,NULL,NULL),('1241983068026191874','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983068210741249','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983068416262146','1214118511954120705',NULL,2,2,'泉州协创知识产权代理事务所（普通合伙）','17750792370','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983068579840001','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983068743417858','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983068902801409','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983069066379265','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983069234151426','1214448822097350658',NULL,2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983069397729281','1214729031224745985',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983069557112833','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983069741662210','1214796116982325250',NULL,2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983069917822978','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983070077206530','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983070240784386','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983070400167938','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会','15980228632','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983070576328706','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','49,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983070765072385','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983070970593281','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983071142559746','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983071301943297','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983071503269890','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983071658459138','1216559724997144578',NULL,2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983071838814210','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983072023363585','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:13',NULL,NULL,NULL),('1241983072228884481','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983072405045250','1217242391405154305',NULL,2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983072572817410','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983072744783873','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983072908361730','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983073067745282','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983073239711746','1218376015684952065',NULL,2,2,'福建省兴泰物业管理有限公司','15260225737','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983073403289601','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983073566867457','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983073738833921','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983073935966209','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983074116321281','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983074284093442','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983074699329537','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983074967764993','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983075135537154','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983075307503617','1219241646047223809',NULL,2,2,'晋江农商银行','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983075475275778','1219253246086995969',NULL,2,2,'泉州市勾勾手电子商务有限公司','13959737339','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983075643047937','1219255868495880193',NULL,2,2,'晋江嘉年华婴儿用品有限公司','15859590857','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983075815014401','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983075991175170','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983076163141634','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:14',NULL,NULL,NULL),('1241983076666458113','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983076884561922','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983077052334081','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983077215911938','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983077396267010','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983077572427778','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983077727617025','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983077949915138','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983078138658817','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1241983078306430978','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 15:00:15',NULL,NULL,NULL),('1242064395001937921',NULL,NULL,2,1,NULL,'15980788802','870706','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-23',NULL,NULL,NULL,'2020-03-23 20:23:22',NULL,NULL,NULL),('1242254826419535873','83',NULL,1,2,'李女元','15359825666','186,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:00:05',NULL,NULL,NULL),('1242254826419535874','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:00:05',NULL,NULL,NULL),('1242254847881789441','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:00:10',NULL,NULL,NULL),('1242254847885983746','86',NULL,1,2,'洪嘉靖','13600737303','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:00:10',NULL,NULL,NULL),('1242257342012080129','1210918631014248450',NULL,2,2,'茂泰（福建）鞋材有限公司','18959705077','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:05',NULL,NULL,NULL),('1242257363394641922','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257363541442562','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257363755352066','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257363990233089','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257364153810945','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257364350943234','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257364615184386','1211444027140915202',NULL,2,2,'福建省万物智联科技有限公司','18559275265','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257364766179330','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257364908785665','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257365076557825','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257365273690113','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257365487599617','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257365688926209','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257365835726849','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257365995110401','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257366146105346','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257366301294593','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257366469066754','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257366682976257','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','14,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257366829776897','1211492544651771905',NULL,2,2,'晋江凯燕新材料科技有限公司','13255957226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257366972383234','1211495827340574722',NULL,2,2,'晋江市品质陶瓷建材有限公司','15106011992','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:10',NULL,NULL,NULL),('1242257367198875650','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257367349870594','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257367496671234','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257367752523777','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257367895130113','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257368050319362','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257368197120002','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257368322949121','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257368461361153','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257368616550401','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257368763351041','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257368910151681','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257369056952321','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257369258278913','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257369417662465','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257369560268802','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257369698680834','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257369841287170','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257369988087809','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257370126499842','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257370269106178','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257370411712514','1212568548061286401',NULL,2,2,'贵人鸟股份有限公司','15359991222','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257370550124546','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257370701119490','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257370843725825','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257370982137858','1212665763958165505',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257371128938497','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257371271544834','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','54,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:11',NULL,NULL,NULL),('1242257371414151170','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257371649032193','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257371787444225','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257371925856258','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257372068462594','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257372269789185','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257372408201217','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257372546613250','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257372697608194','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257372844408833','1214025654970896386',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257372995403777','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257373138010113','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257373284810754','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257373427417090','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257373582606338','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257373725212673','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257373901373442','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257374048174081','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257374194974722','1214796116982325250',NULL,2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257374345969665','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257374501158913','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257374647959554','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257374861869057','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会','15980228632','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257375021252609','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','49,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257375163858946','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257375310659585','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257375465848833','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:12',NULL,NULL,NULL),('1242257375612649474','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257375767838722','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257375910445057','1216559724997144578',NULL,2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257376053051393','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257376204046338','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257376355041281','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257376577339393','1217242391405154305',NULL,2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257376732528642','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257376887717890','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257377038712833','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257377185513473','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257377336508417','1218376015684952065',NULL,2,2,'福建省兴泰物业管理有限公司','15260225737','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257377483309058','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257377655275522','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257377806270465','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257377969848322','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257378120843265','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257378267643905','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257378431221762','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257378582216705','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257378737405953','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257378905178114','1219190487777402882',NULL,2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257379047784449','1219241646047223809',NULL,2,2,'晋江农商银行','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257379190390786','1219253246086995969',NULL,2,2,'泉州市勾勾手电子商务有限公司','13959737339','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:13',NULL,NULL,NULL),('1242257380058611714','1219255868495880193',NULL,2,2,'晋江嘉年华婴儿用品有限公司','15859590857','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257380205412354','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257380352212994','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257380503207937','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257380650008578','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257380817780737','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257380968775681','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257381119770626','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257381258182657','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257381413371905','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257381560172545','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257381715361794','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257382789103617','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242257382969458689','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 09:10:14',NULL,NULL,NULL),('1242291625363783682',NULL,NULL,2,1,NULL,'18160999097','972187','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 11:26:18',NULL,NULL,NULL),('1242340070854303745','1211479687600062466',NULL,2,2,'测试','17362523273','17362523273','【晋江市人才服务平台】您好，您在晋江市人才综合服务平台的反馈已被回复，请及时查看。',3,'短信发送成功','2020-03-24',NULL,NULL,NULL,'2020-03-24 14:38:49',NULL,NULL,NULL),('1242613857227186177','1241252588561698817',NULL,2,2,'福建哲创新材料科技有限公司','18160999097','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 08:46:44',NULL,NULL,NULL),('1242617213857374210','83',NULL,1,2,'李女元','15359825666','173,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:00:05',NULL,NULL,NULL),('1242617213861568514','58',NULL,1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:00:05',NULL,NULL,NULL),('1242617235294461954','86',NULL,1,2,'洪嘉靖','13600737303','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:00:10',NULL,NULL,NULL),('1242617235298656257','87',NULL,1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:00:10',NULL,NULL,NULL),('1242619729890320386','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:05',NULL,NULL,NULL),('1242619751147053058','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619751310630913','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619751482597377','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619751650369537','1211167966465470465',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619751822336002','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619751969136641','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619752128520193','1211444027140915202',NULL,2,2,'福建省万物智联科技有限公司','18559275265','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619752283709442','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619752443092993','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619752594087938','1211460115408928770',NULL,2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619752766054401','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619752917049346','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619753072238594','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619753227427842','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619753403588609','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619753604915202','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619753772687362','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619753940459521','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619754091454465','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619754276003842','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','14,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619754498301954','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619754653491202','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619754808680450','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619754968064001','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:10',NULL,NULL,NULL),('1242619755119058946','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619755270053890','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619755429437442','1211819923995672577',NULL,2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619755639152642','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619755802730497','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619755953725441','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619756104720386','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619756289269761','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619756469624834','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619756658368514','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619756809363457','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619756981329921','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619757136519169','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619757300097026','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619757451091969','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619757618864129','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619757887299585','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619758126374913','1212536999949438978',NULL,2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619758277369858','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619758432559105','1212627500790779906',NULL,2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619758633885698','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619758789074946','1212665763958165505',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619758948458497','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619759145590786','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','54,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:11',NULL,NULL,NULL),('1242619759296585729','1212692778300018689',NULL,2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619759447580673','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619759602769921','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619759757959169','1212930369930727426',NULL,2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619759908954113','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'手机端与网关连接失败，可先确认下号码是否正常使用中。','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619760059949057','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619760210944001','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619760374521857','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619760538099714','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619760693288962','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619760865255426','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619761033027586','1214025654970896386',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619761217576961','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619761385349121','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619761544732674','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619761699921921','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619761855111169','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619761997717506','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619762148712449','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619762299707394','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619762446508034','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619762605891585','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619762765275137','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619762912075778','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','33,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619763096625154','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619763251814402','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:12',NULL,NULL,NULL),('1242619763394420737','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619763537027073','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619763683827713','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619763839016961','1216559724997144578',NULL,2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619763990011906','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619764141006849','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619764287807490','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619764438802433','1217242391405154305',NULL,2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619764585603073','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619764736598017','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619764891787266','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619765046976514','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619765193777154','1218376015684952065',NULL,2,2,'福建省兴泰物业管理有限公司','15260225737','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619765344772098','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619765508349954','1219140374220627970',NULL,2,2,'福建亲亲股份有限公司','15905035025','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619765663539202','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619765839699969','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619765986500610','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619766145884161','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619766301073410','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619766452068353','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619766594674690','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619766770835457','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619766917636098','1219190487777402882',NULL,2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619767068631041','1219241646047223809',NULL,2,2,'晋江农商银行','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619767244791810','1219253246086995969',NULL,2,2,'泉州市勾勾手电子商务有限公司','13959737339','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619767496450050','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:13',NULL,NULL,NULL),('1242619767660027905','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619767802634242','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619767953629185','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619768125595650','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619768649883649','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619768800878593','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619768964456449','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619769107062786','1219824202652073985',NULL,2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619769270640642','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619769421635586','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619769564241922','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242619769715236865','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 09:10:14',NULL,NULL,NULL),('1242701587567157249',NULL,NULL,2,1,NULL,'13675998353','396672','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 14:35:21',NULL,NULL,NULL),('1242740244827152386',NULL,NULL,2,1,NULL,'13675998353','728093','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 17:08:58',NULL,NULL,NULL),('1242742040471609346',NULL,NULL,2,1,NULL,'13675998353','528019','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-25',NULL,NULL,NULL,'2020-03-25 17:16:06',NULL,NULL,NULL),('1242979601290960899','83',NULL,1,2,'李女元','15359825666','133,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:00:05',NULL,NULL,NULL),('1242979601316126721','58',NULL,1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:00:05',NULL,NULL,NULL),('1242979622728048641','86',NULL,1,2,'洪嘉靖','13600737303','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:00:10',NULL,NULL,NULL),('1242979622728048642','87',NULL,1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:00:10',NULL,NULL,NULL),('1242982117743337473','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:05',NULL,NULL,NULL),('1242982139037818882','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982139205591041','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982139394334721','1211098602777194497',NULL,2,2,'福建省诺美护理用品有限公司','13799487213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982139587272705','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982139746656257','1211150098789150721',NULL,2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982139897651202','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982140057034754','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982140224806913','1211444027140915202',NULL,2,2,'福建省万物智联科技有限公司','18559275265','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982140384190466','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982140535185409','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982140686180353','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982140837175298','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982140983975937','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982141130776578','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982141290160130','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982141432766466','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982141579567105','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982141738950657','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982141915111426','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','10,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982142099660802','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','14,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982142246461442','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982142422622210','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982142577811458','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982142733000705','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:10',NULL,NULL,NULL),('1242982142879801345','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982143034990594','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982143223734273','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982143362146305','1211819923995672577',NULL,2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982143525724162','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982143685107713','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982143831908353','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982143982903298','1211892702682071041',NULL,2,2,'福建省晋江万利瓷业有限公司','18859989399','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982144129703938','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982144289087489','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982144435888130','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982144633020417','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982144788209666','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982144935010305','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982145090199554','1211945706491789313',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982145245388801','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982145392189441','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982145547378689','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982145689985025','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982145857757185','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982146012946433','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982146159747074','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982146314936321','1212627500790779906',NULL,2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982146470125570','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982146629509122','1212665763958165505',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982146776309762','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982146918916097','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','54,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:11',NULL,NULL,NULL),('1242982147069911041','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982147216711682','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982147371900929','1212930369930727426',NULL,2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982147514507265','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982147657113602','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982147795525633','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982147942326274','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982148080738306','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982148223344641','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982148365950978','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982148504363009','1214025654970896386',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982148651163649','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982148797964289','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982148940570626','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982149083176961','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982149238366209','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982149376778242','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982149578104834','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982149724905473','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982149871706114','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982150018506754','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982150165307393','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982150324690945','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','30,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982150492463105','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982150643458049','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982150794452993','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982150941253634','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982151096442881','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:12',NULL,NULL,NULL),('1242982151239049217','1216559724997144578',NULL,2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982151394238465','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982151549427713','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982151692034049','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982151838834689','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982151998218241','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982152207933442','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982152375705601','1217985949057744898',NULL,2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982152543477762','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982152690278402','1218376015684952065',NULL,2,2,'福建省兴泰物业管理有限公司','15260225737','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982152832884737','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982153009045506','1219140374220627970',NULL,2,2,'福建亲亲股份有限公司','15905035025','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982153160040450','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982153319424002','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982153470418945','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982153625608194','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982153768214529','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982153910820866','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982154057621506','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982154212810753','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982154355417090','1219241646047223809',NULL,2,2,'晋江农商银行','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982154602881026','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982154758070274','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982154900676609','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982155064254466','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982155215249410','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982155362050050','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:13',NULL,NULL,NULL),('1242982155521433602','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:14',NULL,NULL,NULL),('1242982155672428545','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:14',NULL,NULL,NULL),('1242982155819229186','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:14',NULL,NULL,NULL),('1242982156003778562','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:14',NULL,NULL,NULL),('1242982156150579201','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:14',NULL,NULL,NULL),('1242982156301574146','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:14',NULL,NULL,NULL),('1242982156444180481','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 09:10:14',NULL,NULL,NULL),('1243014465197252610',NULL,NULL,2,1,NULL,'18960357668','059031','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-03-26',NULL,NULL,NULL,'2020-03-26 11:18:37',NULL,NULL,NULL),('1243341989324333057','70',NULL,1,2,'陈瑞清','13788864979','11,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:00:05',NULL,NULL,NULL),('1243341989328527362','58',NULL,1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:00:05',NULL,NULL,NULL),('1243342010774003714','76',NULL,1,2,'陈灿峰','13599718877','11,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:00:10',NULL,NULL,NULL),('1243342010849501185','87',NULL,1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:00:10',NULL,NULL,NULL),('1243342010958553089','83',NULL,1,2,'李女元','15359825666','60,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:00:10',NULL,NULL,NULL),('1243342011138908161','86',NULL,1,2,'洪嘉靖','13600737303','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:00:10',NULL,NULL,NULL),('1243344505642491905','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:05',NULL,NULL,NULL),('1243344526966333442','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344527138299905','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344527301877761','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344527473844226','1211150098789150721',NULL,2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344527637422081','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344527800999938','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344527964577793','1211444027140915202',NULL,2,2,'福建省万物智联科技有限公司','18559275265','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344528128155649','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344528291733505','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344528463699970','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344528623083522','1211467512697372673',NULL,2,2,'晋江市万达汽车贸易有限公司','13489887652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344528786661377','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344528941850625','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344529101234178','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344529256423426','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344529424195586','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344529579384834','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344529734574082','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344529889763329','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','10,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344530065924098','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','13,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344530225307650','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344530380496897','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344530539880449','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:10',NULL,NULL,NULL),('1243344530711846913','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344530871230465','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344531034808321','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344531223552002','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344531382935553','1211819923995672577',NULL,2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344531546513410','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344531697508354','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344531856891906','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344532012081153','1211892702682071041',NULL,2,2,'福建省晋江万利瓷业有限公司','18859989399','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344532179853313','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344532335042562','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344532502814721','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344532674781186','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344532846747649','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344533069045762','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344533224235009','1211945706491789313',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344533379424258','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344533547196418','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344533748523010','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344533903712257','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344534067290114','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344534230867969','1212540446794911745',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344534398640129','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344534566412289','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344534729990146','1212627500790779906',NULL,2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:11',NULL,NULL,NULL),('1243344534918733825','1212644982180089858',NULL,2,2,'福建省华晟建设发展有限公司','15392121201','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344535082311682','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344535245889537','1212665763958165505',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344535413661697','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344535577239554','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','54,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344535782760450','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344535958921217','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344536139276289','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344536311242754','1212930369930727426',NULL,2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344536474820609','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344536638398466','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344536793587714','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344536957165570','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344537124937730','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344537292709890','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344537485647874','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344537645031426','1214025654970896386',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344537804414978','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344537980575745','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344538135764993','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344538295148545','1214118511954120705',NULL,2,2,'泉州协创知识产权代理事务所（普通合伙）','17750792370','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344538462920706','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344538613915650','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344538785882113','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344538941071362','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:12',NULL,NULL,NULL),('1243344539117232130','1214451511434743809',NULL,2,2,'福建北电新材料科技有限公司','19959711592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344539280809986','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344539444387841','1214796116982325250',NULL,2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344539620548610','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344539784126465','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344539951898625','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344540123865090','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','26,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344540337774593','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344540509741058','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344540677513217','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344540841091074','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344541029834754','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344541201801217','1216626668072869889',NULL,2,2,'晋江市广播电视事业局','13599718877','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344541394739202','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344541558317058','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344541726089217','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344541889667073','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344542053244929','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344542216822785','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344542413955073','1217985949057744898',NULL,2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344542573338626','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344542732722177','1218794464953360385',NULL,2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344542892105730','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344543064072193','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344543257010178','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:13',NULL,NULL,NULL),('1243344543412199425','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344543575777281','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344543823241217','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344543961653249','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344544125231106','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344544288808961','1219241646047223809',NULL,2,2,'晋江农商银行','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344544427220994','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344544582410242','1219444673739800577',NULL,2,2,'晋江拓普旺防霉材料有限公司','18259038660','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344544725016577','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344544876011521','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344545027006465','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344545169612802','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344545316413442','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344545454825473','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344545605820417','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344545752621058','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344545924587521','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344546490818561','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344546671173633','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1243344546817974274','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-27',NULL,NULL,NULL,'2020-03-27 09:10:14',NULL,NULL,NULL),('1244791541046804481','70',NULL,1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:00:05',NULL,NULL,NULL),('1244791541046804482','58',NULL,1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:00:05',NULL,NULL,NULL),('1244791563381473282','76',NULL,1,2,'陈灿峰','13599718877','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:00:10',NULL,NULL,NULL),('1244791563381473283','87',NULL,1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:00:10',NULL,NULL,NULL),('1244791563620548610','83',NULL,1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:00:10',NULL,NULL,NULL),('1244791563809292289','84',NULL,1,2,' 洪全益','13808555296','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:00:10',NULL,NULL,NULL),('1244794057104916481','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:05',NULL,NULL,NULL),('1244794078407786497','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794078571364354','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794078747525122','1211098602777194497',NULL,2,2,'福建省诺美护理用品有限公司','13799487213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794078906908673','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794079066292226','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794079229870082','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794079393447938','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794079565414402','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794079728992257','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794079888375809','1211467512697372673',NULL,2,2,'晋江市万达汽车贸易有限公司','13489887652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794080060342274','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794080215531522','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','12,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794080391692290','1211476436687306754',NULL,2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794080601407490','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794080790151170','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794080978894849','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794081163444225','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794081331216385','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794081490599937','1211489025517469698',NULL,2,2,'泉州星城纸业有限公司','15959856777','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794081649983489','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794081813561346','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','13,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794081972944897','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:10',NULL,NULL,NULL),('1244794082216214530','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794082375598081','1211548619757371393',NULL,2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794082539175937','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794082715336705','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794082908274690','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794083067658241','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794083218653185','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794083382231041','1211836173303988226',NULL,2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794083545808897','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794083709386753','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794083860381697','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','13,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794084057513985','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794084221091842','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794084380475394','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794084544053249','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794084720214017','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794084900569090','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794085072535554','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794085223530497','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794085387108354','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794085563269122','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794085731041281','1212540446794911745',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794085890424833','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794086054002690','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794086213386241','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:11',NULL,NULL,NULL),('1244794086393741313','1212665763958165505',NULL,2,2,'泉州安踏鞋材有限公司','18250638258','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794086561513474','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794086716702722','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','55,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794086871891969','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794087039664130','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794087199047681','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794087362625537','1212929090869334017',NULL,2,2,'福建省晋江市辉源建材物资有限公司','15106027935','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794087517814785','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794087689781250','1213067533700108289',NULL,2,2,'晋江市锦马汽车检验有限公司','15059570222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794087853359106','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794088012742658','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794088167931905','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794088323121154','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794088482504705','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794088641888257','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794088797077506','1214025654970896386',NULL,2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794088956461058','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794089115844609','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794089266839554','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794089434611713','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794089593995265','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794089757573121','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794089912762370','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794090067951617','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794090223140865','1214796116982325250',NULL,2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794090382524418','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794090537713665','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:12',NULL,NULL,NULL),('1244794090701291522','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794090848092162','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会','15980228632','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794091011670018','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','29,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794091171053570','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794091334631425','1215550908977430529',NULL,2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794091494014978','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794091649204226','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794091825364993','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794091976359937','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794092139937793','1216537288914268162',NULL,2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794092295127042','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794092454510593','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794092605505538','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794092760694786','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794092907495426','1217242391405154305',NULL,2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794093062684674','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794093213679618','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794093368868865','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794093524058114','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794093679247361','1218794464953360385',NULL,2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794093830242306','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794093981237249','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794094136426498','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794094291615746','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794094438416386','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794094606188545','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:13',NULL,NULL,NULL),('1244794095088533505','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794095231139841','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794095365357570','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794095512158209','1219190487777402882',NULL,2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794095654764545','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794095805759489','1219444673739800577',NULL,2,2,'晋江拓普旺防霉材料有限公司','18259038660','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794095952560130','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794096099360769','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794096241967105','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794096392962050','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794096539762689','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794096690757633','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794096850141186','1219609878780231682',NULL,2,2,'福能期货股份有限公司晋江营业部','13788816686','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794096992747522','1219617616927178754',NULL,2,2,'兴业银行股份有限公司晋江支行','15980006525','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794097139548162','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794097311514626','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794097466703874','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794097634476034','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1244794097798053890','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-03-31',NULL,NULL,NULL,'2020-03-31 09:10:14',NULL,NULL,NULL),('1245153928463613953','70',NULL,1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:00:05',NULL,NULL,NULL),('1245153928513945602','58',NULL,1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:00:05',NULL,NULL,NULL),('1245153949888118786','87',NULL,1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:00:10',NULL,NULL,NULL),('1245153949896507394','83',NULL,1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:00:10',NULL,NULL,NULL),('1245153950097833985','84',NULL,1,2,' 洪全益','13808555296','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:00:10',NULL,NULL,NULL),('1245156445012459521','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:05',NULL,NULL,NULL),('1245156466340495361','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156466504073217','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156466671845378','1211100599215566849',NULL,2,2,'劲派经编科技有限公司','15859799211','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156466835423233','1211117113914273793',NULL,2,2,'福建柒牌时装科技股份有限公司','15880936557','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156467019972610','1211138539417350145',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156467183550466','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156467359711234','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156467615563778','1211453814360555522',NULL,2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156467795918849','1211454669394591746',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156467955302402','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156468114685953','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156468320206850','1211459203080699905',NULL,2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156468500561922','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156468672528385','1211467512697372673',NULL,2,2,'晋江市万达汽车贸易有限公司','13489887652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156468831911937','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156468995489794','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','11,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156469150679042','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156469339422722','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156469494611970','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156469653995521','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156469821767682','1211484578443739137',NULL,2,2,'晋江市锦福化纤聚合有限公司','13599749329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:10',NULL,NULL,NULL),('1245156470962618370','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156471130390530','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156471289774081','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','11,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156471449157633','1211494978245672962',NULL,2,2,'福建省德腾智能科技有限公司','18050996325','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156471604346881','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156471763730433','1211538270857510913',NULL,2,2,'福建省晋江优兰发纸业有限公司','13906095618','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156471923113985','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156472078303234','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156472246075393','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156472443207682','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156472594202625','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156472757780481','1211837828162437121',NULL,2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156472921358337','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','27,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156473097519105','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156473256902657','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156473424674818','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156473588252673','1211925547903401986',NULL,2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156473764413442','1211930809942982658',NULL,2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156473923796994','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156474087374849','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:11',NULL,NULL,NULL),('1245156474250952706','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156474418724865','1212195053699665922',NULL,2,2,'泉州建发凯迪汽车有限公司','13656038332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156474582302722','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156474741686273','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156474901069825','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156475056259074','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156475215642626','1212540446794911745',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156475379220481','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156475538604033','1212661969526525954',NULL,2,2,'福建正麒高纤科技股份有限公司','18698386676','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156475744124929','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156475903508482','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156476058697730','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','55,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156476218081282','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156476369076226','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156476536848385','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156476700426241','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156476864004098','1213067533700108289',NULL,2,2,'晋江市锦马汽车检验有限公司','15059570222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156477014999041','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156477178576898','1213345803519725570',NULL,2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156477333766146','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156477501538305','1213698480367751170',NULL,2,2,'福建龙峰纺织科技实业有限公司','18859760088','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156477656727553','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156477837082625','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156477992271873','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156478155849730','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156478323621889','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:12',NULL,NULL,NULL),('1245156478495588353','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156478659166209','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156478818549762','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156478994710529','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156479149899777','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156479321866242','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156479502221313','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156479657410562','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156479808405506','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156479959400449','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','29,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156480106201090','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156480257196033','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156480412385281','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156480559185921','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156480731152386','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156480886341634','1216537288914268162',NULL,2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156481041530882','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156481226080258','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156481381269506','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156481544847362','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156481700036610','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156481859420161','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156482014609410','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156482182381570','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156482337570817','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156482509537282','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:13',NULL,NULL,NULL),('1245156482660532225','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156482815721473','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156482975105025','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156483176431618','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156483327426561','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156483482615809','1219178348228501506',NULL,2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156483641999362','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156483881074689','1219190487777402882',NULL,2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156484023681026','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156484573134849','1219444673739800577',NULL,2,2,'晋江拓普旺防霉材料有限公司','18259038660','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156484719935489','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156484854153217','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156484996759553','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156485147754498','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156485286166529','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156485445550081','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156485592350722','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156485747539970','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156485890146305','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156486036946945','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245156486192136194','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 09:10:14',NULL,NULL,NULL),('1245239250258067457',NULL,NULL,2,1,NULL,'13959941699','695076','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-01',NULL,NULL,NULL,'2020-04-01 14:39:07',NULL,NULL,NULL),('1245516316446654465','83',NULL,1,2,'李女元','15359825666','15,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:00:05',NULL,NULL,NULL),('1245516316509569025','58',NULL,1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:00:05',NULL,NULL,NULL),('1245516337837604866','84',NULL,1,2,' 洪全益','13808555296','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:00:10',NULL,NULL,NULL),('1245516337841799170','87',NULL,1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:00:10',NULL,NULL,NULL),('1245518832810950657','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:05',NULL,NULL,NULL),('1245518854084460545','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518854248038401','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518854407421954','1211138539417350145',NULL,2,2,'福建百宏聚纤科技实业有限公司','18959858592','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518854566805505','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518854726189057','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518854893961218','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518855057539073','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518855212728322','1211459203080699905',NULL,2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518855367917569','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518855577632770','1211467512697372673',NULL,2,2,'晋江市万达汽车贸易有限公司','13489887652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518855804125186','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518855950925825','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','11,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518856101920770','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518856286470146','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518856445853697','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518856630403074','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518856840118274','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518856991113218','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518857146302465','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','10,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518857305686018','1211494978245672962',NULL,2,2,'福建省德腾智能科技有限公司','18050996325','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518857460875265','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518857632841729','1211559758373371905',NULL,2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518857792225282','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:10',NULL,NULL,NULL),('1245518857943220225','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518858119380994','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518858249404418','1211819923995672577',NULL,2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518858404593665','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518858559782914','1211837828162437121',NULL,2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518858727555073','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','27,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518858928881665','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518859079876609','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518859222482945','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518859369283586','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518859528667138','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518859688050690','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518859830657025','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518859994234881','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518860153618434','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518860300419073','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518860447219713','1212540446794911745',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518860656934913','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518860807929857','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518860958924802','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518861139279874','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518861290274818','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','55,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518861445464065','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518861604847618','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518861764231170','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518861915226114','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518862070415361','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:11',NULL,NULL,NULL),('1245518862225604610','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518862393376769','1213698480367751170',NULL,2,2,'福建龙峰纺织科技实业有限公司','18859760088','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518862540177410','1213736612547022850',NULL,2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518862699560962','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518862858944514','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518863009939457','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518863173517313','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518863328706561','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518863483895809','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518863643279361','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518863794274306','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518863949463553','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518864104652801','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518864335339522','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518864486334465','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518864637329410','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518864788324353','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','27,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518864939319297','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518865094508545','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518865245503489','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518865400692738','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518865555881986','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518865706876930','1216537288914268162',NULL,2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518865853677570','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518866017255426','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518866168250370','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:12',NULL,NULL,NULL),('1245518866310856706','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518866461851650','1217348495564886017',NULL,2,2,'晋江劲霸男装有限公司','13505959911','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518866612846594','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518866772230146','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518866935808002','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518867090997249','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518867250380801','1218794464953360385',NULL,2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518867405570050','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518867560759297','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518867753697281','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518867900497921','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518868047298562','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518868202487809','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518868391231489','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518868546420738','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518868722581506','1219190487777402882',NULL,2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518868881965057','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518869037154305','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518869192343553','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518869351727106','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518869523693570','1219531747910270978',NULL,2,2,'中国工商银行股份有限公司晋江分行','13799599097','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518869674688514','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518869829877761','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518869976678402','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518870274473985','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518870429663233','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:13',NULL,NULL,NULL),('1245518870589046785','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:14',NULL,NULL,NULL),('1245518870769401858','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 09:10:14',NULL,NULL,NULL),('1245614591631785985',NULL,NULL,2,1,NULL,'13950287905','653182','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 15:30:35',NULL,NULL,NULL),('1245663839408709634',NULL,NULL,2,2,'批量发送','15280619456,17362523273','15280619456,17362523273','【晋江市人才服务平台】短信问题解决了，明天教你怎么用',3,'短信发送成功','2020-04-02',NULL,NULL,NULL,'2020-04-02 18:46:07',NULL,NULL,NULL),('1245874316629860353',NULL,NULL,2,2,'批量发送','15280619456,13675957398,13799500668','15280619456,13675957398,13799500668','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才申报对象：为做好2019年度晋江市优秀人才认定工作，请符合申报条件但未重新补齐人才认定材料的各申报对象及时与人才联络员联系，抓紧时间提交材料，补件时间截止至2020年4月10日17:30，谢谢！',3,'短信发送成功','2020-04-03',NULL,NULL,NULL,'2020-04-03 08:42:38',NULL,NULL,NULL),('1245877568893181954',NULL,NULL,2,2,'批量发送','15059551567,15260305126,13655986799,13338562717,13506056368,13905958730,13774825517,13509362773,15160330306,15906092370,13799555666,18605008168,13599162155,15905907962,13144828970,15559162475,13850778776,18559161283,18650100145,13685908658,13599717008,15259546913,15260899107,15980066202,15059157225,15759488187,13774828120,18771094578,13400820519,18959805200,18695665035,13859727077,15345952654,15659972175,15359383363,13625979936,13514019395,15396608587,13969010619,15805981750,13842019660,13940108782,18862155925,18275745728,13799487213,15960707755,18468034987,13860116953,18805920922,18659030881,17006098806,17359711663,15059803792,13436970465,15980013301,13950430719,18900336517,18105907301,18851401527,18020867909,15860257142,18876336921,15806032297,18965785175,15005062379,18950700105,18741355270,18150563203,13075572292,18649652527,17741357996,15090088338,13599220676,18900371513,15191818740,18696960184,15905037555,15960551920,15629795466,18959941093,13599279399,13505906457,18571081281,18859464970,13027105101,17758709290,13425480722,18050929268,13816975274,13178336506,13600703008,14759154723,18262283166,15059719567,15960402869,18829340451,15359490818,15559110466,15191845928,13122120652,15191815436,13959264368,15080318157,15060823577,18659066928,18559472664,18150591518,13860752060,13328555097,17759892862,18876272213,18829298483,13313825373,18259591998,18250850010,13559554933,15389303652,15805955751,13649283497,15959590927,18065606507,18192276329,15759590781,13614268392,18701704136,18898408023,18506966086,15702950980,18806028372,18605914467,18065525518,17750792370,15959873463,13959888172,15191815139,15805097777,18959708032,15059850519,18392859639,13484917236,15029140185,15903645816,18659719331,13072350035,15905050688,15959996599,15202404290,15821998683,15111982965,15980011425,15259519391,15202427957,15959581739,15527179406,13599921781,13799898116,15905092171,18960353905,15880911717,15029236362,13959861620,13805956558,13808549828,15060832111,18959995002,18350770057,15060972472,13600701178,15623564761,13859754633,13459562051,15605003638,15905996868,15860517253,13512216307,13559532808,15980036243,15860901713,18960279877,15880931696,15359556333,18350062033,18359837870,18059993901,13636903309,15759876282,13905971030,13515055988,15959888180,13636906289,13774877242,13850772504,19959999508,13559591215,15260399516,15905006169,15985959061,15059528748,13850755588,15985905430,13625958406,18959996388,13489719977,15959592923,13559592136,13505045259,15959592127,18750931024,13960391700,13649278723,15880762096,13906934045,15260852001,15060806451,15859796399,15359493923,13959882723,15074870926,13774898032,15060990680,18650917845,18850547191,15985923093,13950362316,13788852001,13615922291,15860351538,15806036626,15880825431,13159012670,18259060411,13075877415,15880719513,13860631416,15060933526,15059543210,13636993769,18250292550,17512098847,18050056871,18159235825,18350535110,15859468355,15259471016,15880758500,15080345751,15960581457,13459246092,18876291470,13627292269,13599719905,15846593350,15810298887,15605009590,13805948042,15059510022,15880818089,18606031846,13689056004,15905070935,18953138447,18750537614,18050869127,18876240048,18805921912,18835792826,18215628161,13788803006,15980301999,18722334354,18202655266,18581998214,15059839423,15860358661,18559511816,15959264462,15559528807,15880027485,13706991487,13055336977,13030978969,15906066000,15980274172,15060804302,15860514476,18650916825,15280404202,13599954300,13328979519,18350776066,13105060008,18868801836,18859716793,15805990003,15880480928,13635240509,15259758239,15505950959,18250882613,15860353200,15905996655,18965513668,18046009745,15160441962,15960746554,15759732116,13505959355,13685000414,15759296423,15959552577,15805073665,18876568900,15904412438,17359991180,15205011506,18250422227,18950490831,15959530855,15705923619,15259597676,18429006632,15359855333,18965175339,13950989318,13205957447,15260225737,18703659101,18750207251,13599177919,13696857207,13505905685,15905975168,13960228853,13675918895,15980025829,13799855086,13960257652,15080426614,18750651805,13489875197,18659005089,13506095562,13960256303,13665903960,13960256111,18905079898,18959853655,13601076764,13505050692,18905060268,13959955769,18965667777,18759922187,15859590857,13850757007,18859225776,15959962792,18030243370,18259061182,13799857333,15059597777,18850383723,15059871315,15880024622,15980041722,13600766763,18850549376,15060827887,18859495931,18605958852,15805060325,15880764254,13959888168,18750561717,17606025253,13599717079,13646022408,13600703996,13710228756,13615908669,13386880667,13506030795,15959882366,15905988871,15960250972,18005073259,18005065560,15605959006,13645971717,18050270931,17758766631,13305952629,15659132085,18050916965,18050876301,15396596855,13559513508,13229424859,13645032611,15059154896,18650591551,15759216753,18805065856,13328883775','15059551567,15260305126,13655986799,13338562717,13506056368,13905958730,13774825517,13509362773,15160330306,15906092370,13799555666,18605008168,13599162155,15905907962,13144828970,15559162475,13850778776,18559161283,18650100145,13685908658,13599717008,15259546913,15260899107,15980066202,15059157225,15759488187,13774828120,18771094578,13400820519,18959805200,18695665035,13859727077,15345952654,15659972175,15359383363,13625979936,13514019395,15396608587,13969010619,15805981750,13842019660,13940108782,18862155925,18275745728,13799487213,15960707755,18468034987,13860116953,18805920922,18659030881,17006098806,17359711663,15059803792,13436970465,15980013301,13950430719,18900336517,18105907301,18851401527,18020867909,15860257142,18876336921,15806032297,18965785175,15005062379,18950700105,18741355270,18150563203,13075572292,18649652527,17741357996,15090088338,13599220676,18900371513,15191818740,18696960184,15905037555,15960551920,15629795466,18959941093,13599279399,13505906457,18571081281,18859464970,13027105101,17758709290,13425480722,18050929268,13816975274,13178336506,13600703008,14759154723,18262283166,15059719567,15960402869,18829340451,15359490818,15559110466,15191845928,13122120652,15191815436,13959264368,15080318157,15060823577,18659066928,18559472664,18150591518,13860752060,13328555097,17759892862,18876272213,18829298483,13313825373,18259591998,18250850010,13559554933,15389303652,15805955751,13649283497,15959590927,18065606507,18192276329,15759590781,13614268392,18701704136,18898408023,18506966086,15702950980,18806028372,18605914467,18065525518,17750792370,15959873463,13959888172,15191815139,15805097777,18959708032,15059850519,18392859639,13484917236,15029140185,15903645816,18659719331,13072350035,15905050688,15959996599,15202404290,15821998683,15111982965,15980011425,15259519391,15202427957,15959581739,15527179406,13599921781,13799898116,15905092171,18960353905,15880911717,15029236362,13959861620,13805956558,13808549828,15060832111,18959995002,18350770057,15060972472,13600701178,15623564761,13859754633,13459562051,15605003638,15905996868,15860517253,13512216307,13559532808,15980036243,15860901713,18960279877,15880931696,15359556333,18350062033,18359837870,18059993901,13636903309,15759876282,13905971030,13515055988,15959888180,13636906289,13774877242,13850772504,19959999508,13559591215,15260399516,15905006169,15985959061,15059528748,13850755588,15985905430,13625958406,18959996388,13489719977,15959592923,13559592136,13505045259,15959592127,18750931024,13960391700,13649278723,15880762096,13906934045,15260852001,15060806451,15859796399,15359493923,13959882723,15074870926,13774898032,15060990680,18650917845,18850547191,15985923093,13950362316,13788852001,13615922291,15860351538,15806036626,15880825431,13159012670,18259060411,13075877415,15880719513,13860631416,15060933526,15059543210,13636993769,18250292550,17512098847,18050056871,18159235825,18350535110,15859468355,15259471016,15880758500,15080345751,15960581457,13459246092,18876291470,13627292269,13599719905,15846593350,15810298887,15605009590,13805948042,15059510022,15880818089,18606031846,13689056004,15905070935,18953138447,18750537614,18050869127,18876240048,18805921912,18835792826,18215628161,13788803006,15980301999,18722334354,18202655266,18581998214,15059839423,15860358661,18559511816,15959264462,15559528807,15880027485,13706991487,13055336977,13030978969,15906066000,15980274172,15060804302,15860514476,18650916825,15280404202,13599954300,13328979519,18350776066,13105060008,18868801836,18859716793,15805990003,15880480928,13635240509,15259758239,15505950959,18250882613,15860353200,15905996655,18965513668,18046009745,15160441962,15960746554,15759732116,13505959355,13685000414,15759296423,15959552577,15805073665,18876568900,15904412438,17359991180,15205011506,18250422227,18950490831,15959530855,15705923619,15259597676,18429006632,15359855333,18965175339,13950989318,13205957447,15260225737,18703659101,18750207251,13599177919,13696857207,13505905685,15905975168,13960228853,13675918895,15980025829,13799855086,13960257652,15080426614,18750651805,13489875197,18659005089,13506095562,13960256303,13665903960,13960256111,18905079898,18959853655,13601076764,13505050692,18905060268,13959955769,18965667777,18759922187,15859590857,13850757007,18859225776,15959962792,18030243370,18259061182,13799857333,15059597777,18850383723,15059871315,15880024622,15980041722,13600766763,18850549376,15060827887,18859495931,18605958852,15805060325,15880764254,13959888168,18750561717,17606025253,13599717079,13646022408,13600703996,13710228756,13615908669,13386880667,13506030795,15959882366,15905988871,15960250972,18005073259,18005065560,15605959006,13645971717,18050270931,17758766631,13305952629,15659132085,18050916965,18050876301,15396596855,13559513508,13229424859,13645032611,15059154896,18650591551,15759216753,18805065856,13328883775','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才申报对象：为做好2019年度晋江市优秀人才认定工作，请符合申报条件但未重新补齐人才认定材料的各申报对象及时与人才联络员联系，抓紧时间提交材料，补件时间截止至2020年4月10日17:30，谢谢！',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-04-03',NULL,NULL,NULL,'2020-04-03 08:55:34',NULL,NULL,NULL),('1245881113382051842',NULL,NULL,2,2,'批量发送','13906095618,18959858592,18965129895,13255957226,13666026522,13801333177,15106096021,18959847128,13802609526,13506086731,18016585576,15959798579,18859971221,18250298076,18065376686,15602265352,13906099888,13809549382,18876509838,13905070552,13705941428,15159878799,13905089190,13960381057,15980788802,15985952242,13055808024,13950920100,13105079935,13799966695,15805032333,13505080996,18959705077,18965689935,19852121931,18960206656,15880720190,13295959911,15810812160,13905975119,18960278086,18759429880,18609586661,13306995188,15059792958,13305967663,13306995039,13808510760,15959896966,13905952020,18959995705,13805957081,13906091693,13559566696,18859990000,15860395678,15980325929,15859759601,18159826888,13805946193,13044554499,18006037555,18350782990,13506060342,13788851759,13615901213,13599212929,15805021228,15750768536,13506000615,13905974006,13905974002,13358591930,13808505006,15959995535,13559593361,13960417367,13599109151,15659878695,15106088998,18965689828,18859969666,13808557909,18960357668,15260875883,18959988073,15160423086,13705943966,13305088921,15059750761,13799766670,18815985118,15611255393,13636963633,18721796963,13656038332,13675953607,18959210622,13805900098,18859932277,15306089555,15905079361,18618285267,18859799829,13337211223,13600757303,13626072564,13615950806,13906933286,15359996305,18605958880,13788846820,15260782666,13905985809,15260803666,18659030309,13805919195,15392288855,13600754180,17689485050,15880785555,15960692650,13599780560,15259571333,13959712401,18516157979,13328509988,13655902993,15860398018,18859551760,18606989818,13395096999,18959858506,15985918296,13960341716,15880972652,15980313135,13906096567,15080070385,13675995249,15995216889,15260429705,13959778888,18859555816,13905968151,13959776520,13799521561,13720842620,18659915000,13205061526,15060626155,13959237668,13779911861,13601032833,13506042338,18567651331,15959959200,13960291518,13859796953,15850693987,15959870601,18876572155,13959753823,13459034477,15860688762,18859596380,15502179365,15086777305,18850528121,18052150317,17689683160,18859757759,18359810815,13505957512,13696949262,17689690969,18959813876,13805924801,18250169959,15005059367,15502207706,13599218888,18959707235,13788829369,18059037101,18859760088,15392286115,13636957868,15880974760,13794913769,15259555555,18960285333,18959997270,15392288851,13960207400,15946798736,15191577654,17750799505,13666988888,17750103317,18959706230,15622174598,15260807555,13506003686,15905958858,15080458330,15359585555,15059748612,18065333731,15959889099,17605014353,13459504545,15396597171,18605001616,15260785666,18106980703,13959975329,13285030066,18959855726,15906067008,18046360864,13459556182,15060456431,13860300607,13306995027,18796922940,13325253201,18350777627,13599159330,18020650858,13328963385,13709857491,13489312968,15960408186,18859780809,17706075999,15359590811,13959119986,13505951467,15141327771,13599949096,13665987766,15980000372,13905089834,18965687332,13959951039,13960259639,18250155553,18359714502,18965687331,13905085845,15980060559,13960359859,18965523733,17759991213,15959579818,13505008588,15029265211,18650908918,15980000359,17755092627,13960256299,15980000660,18722290558,13636950764,18539456470,17613712423,13107872929,13669274728,18759552098,18659003978,19959848541,17689494919,15959517575,13905051776,13906095618,13505986964,18740431050,13505050069,18759919815,13314987388,15759496852,15059556400,18859996145,15060011828,13400808814,13905950588,15960753968,15315563156,13665959771,13906903291,18705052323,15959505915,13505932929,18159276351,13960282791,13799552053,13626066721,13675998353,18859951871,13030981560,15259223745,18659568811,15559544571,13905953818,13506054328,15759733818,15860902967,13067154015,13599145737,13328500766,13799557193,13905055474,18606985861,18876223641,13788869420,18606056998,18659003000,13559054268,13506969315,13313872221,13328989299,15260704530,13799564888,15159518618,15059821270,18350770992,18959906506,18805959777,15659512626,13905089465,15559067588,18603006276,19906870165,18965689711,13959953589,13489858089,13400840823,13805957117,13960311095,17350011170,13860750864,13808556705,13256678813,13905957105,13506928380,13805959366,15029279845,15979017673,15959556399,15620636649,13484540329,18316739194,18359877950,13488103520,13501115138,13860190418,13805959125,18850496760,13572104402,18659262866,15985751705,15805010196,13505056755,13506069249,13906998897,13696900561,17750891999,13774878631,18959210622,13599161927,15759653345,18516970130,18046311397,13906999100,18292635234,15029278847,13859751591,13636950560,13959840868,15396583913,13920285434,15829907184,13600753338,15860902576,13505059996,13489848301,13505058832,13625959920,13805945051,13950238890,13004886898,13599936037,18960259259,13612150403,13720852551,13410024480,13600738975,13599127767,13659192458,18959706253,13506066917,15860304280,13788811853,13506956209,18859920423,18959992832,15060998567,13850799806,15860381909,13358577766,15905035169,15959553375,15960795588,13506941213,18965699955,13805950256,15080421696,15905095955,17706067083,15859495050,15559133531,15805952318,13799239878,13600751875,13859775220,15905077879,18905953233,15905006716,13055667605,13850777555,15959507666,13636905051,13625994626,13860763453,19859573633,13489403314,15260875781,13004800144,13850777672,18059983988,13799240204,13600709507,15959596201,19959999308,13799850617,13313880008,13808512082,13615940087,13959926888,15059557916,13950108669,13808510666,13799797017,13850728390,18957137209,13505992220,13959941521,13860703356,18633637251,13959856161,13506055166,13959910000,15880881006,13960382970,13860757775,15906066156,15860396396,13559625390,15060946052,18815985602,15880881883,15260823192,15959509673,13905059153,18950026794,13859989821,13506045449,13960459977,18876539791,13706957817,15860302368,13959798556,13505961108,13960292725,15905032289,18659060047,13599994541,15859577452,13559045209,15980065535,15260101691,18759508729,13799896025,15159529936,18905951960,15880161129,13599507077,13859705235,13799202233,13655933296,13950299290,13505907585,13606051571,15059520014,15601588313,13506066359,13799899315,18859933999,13860703516,13505942660,15980456333,13506083126,18659281177,15005936026,13600703472,13905350771,13959752857,15059832543,18150983366,15980235626,13505943066,13559575942,18659737170,15106087765,13110816682,15905044580,13599115973,15659450305,13675930836,17359990624,13405350771,15505952026,13599766670,13685910527,15083847155,15106037664,13808543336,13615922291,18965636930,13863831087,13960296362,17762027770,13700242731,13063191843,15911052916,13505028679,13506062515,18750597755,15259555117,17612198088,18659822922,13520554703,13655601013,15080417163,15827609588,18859785085,15359383458,15905975697,13405353771,15905076266,15980271486,13110592357,15859775715,13808540799,15392481724,15141988697,15880975265,15860328381,18605001313,13959940177,18225662357,18905080205,13506057070,13905055766,15060985107,15060032495,13860726225,13121833855,17727971605,17750989111,13685921872,15980063533,13860143467,15260237093,13960250701,13599505962,18559273254,18950070276,13404252272,17388204055,15259729821,13459599999,15059823968,18106968679,13407735197,17715205257,15326179637,15860301827,15905057579,18060501876,15859231310,15059570222,13959955966,13400887176,15059830121,18050020726,13055224466,15106033846,15880990268,18965483880,18698399527,18314463516,19905053569,13950364429,15805026065,18750530127,13950092022,15980067586,13859790099,15260200619,18965658201,15059755771,15827436094,13459533442,13696856720,15159887877,13599172228,13505008000,13805956092,15880754887,18698360960,13085059001,13665965633,15805003589,15859554650,15260720911,18859498656,18876284599,18876377906,13950317095,15711502057,15905055709,13159060909,15201615843,18065589080,18411037910,13505054724,13459523099,13950063837,13859745152,13959280218,15906061807,18659923130,15860516215,15859565605,18682261122,15159724662,18698372705,13906998716,15860900865,18815997296,15959232693,13788814546,18159595252,18959700369,15859559078,13505990915,13779982480,13615963766,15959966729,13825584576,15122460079,13506061896,15922263220,13600759390,13275049035,13030982553,18559552007,13599710039,13799239129,18292491251,15959994811,15159739903,18859781366,18006037070,18906999069,18876569027,15859553823,13506998846,15980068126,13960259810,18876539839,18050878555,13960826248,15280423942,18659069495,18006990697,13959812033,15159790586,13859085700,18859907988,13808505910,15806017885,15805956361,15980232523,13110982808,18046040451,15959569933,15860356356,18805025309,13055650678,13960254757,15205972628,15806019077,13505097888,13599106745,13959717283,13636959434,13905985743,13636995533,13666029324,13905079763,13599978051,15280422458,18650676688,13906099550,13665001804,15659050608,18960877567,18900311779,15880977738,18605007853,15159871537,15906005715,18606942212,13067198079,13400539210,18825160801,13163906685,18817333998,15375771216,13505955686,13559546275,15260371606,13665956888,15159832652,18750914154,15980478011,13960455227,18559672261,13960270097,18862155979,18659097395,15259727676,13905969285,13799758056,15606087056,18782977456,18965526351,13906091302,13960408350,13959946911,18960251988,15060969798,13505071035,18905059500,13808525056,17705061101,13905059909,13806969722,15985900838,13799581818,13626076868,13960255304,15959992008,15375708923,13615926622,15959990198,13636928198,18106930966,13808558181,13905075757,13905079280,13606021816,15980056221,13805997206,13489887652,13808505732,13506009833,15905022650,13646031399,13805941850,13488682111,15392121201,18659936998,18959981231,13959952350,13489512117,15759500600,13959921098,13799870758,13850753398,15959599793,13242884288,13559550686,15759877981,13805951761,15710646360,15260838513,13600704238,13316225195,13860708740,15805972719,18050888018,13788828099,13505977599,13950175990,18016516089,13959975903,18659516267,15280871258,13505956777,15959853522,15959525859,15359508512,13505051522,15859505750,13489545332,15377953096,15960731557,13599715762,13788826386,13459523253,13489512136,13107880950,15750898928,18950498312,15375886386,13400507028,13587756546,13959737339,18659916888,18859525583,13506059007,13215066449,13505955666,13975057391,13505902557,13636951165,13805957070,13860602468,13960358840,13305962813,13661356074,18350742084,15606088553,13645019389,15280875858,13600788662,19905908656,18344910844,18059147928,15260708136,15880824003,15880939936,13365952758,13805951603,15375754488,13918199745,15859577777,15606946335,13805997578,15060933832,17850929207,18750654331,13599751999,13906099845,15559050207,18859552366,18859626598,15959990680,15905909283,13805145645,15059720864,15620633941,15980006525,15260813616,18100525107,18859763636,18396220746,18559477701,13959992226,15759596655,13905955872,13605944765,15959595731,13505954433,13808552366,13655928585,15859506299,13306051592,13788833384,13960305030,13338583366,13505905737,15280081010,13788805366,13559369710,13788816686,17683234600,13067166871,13600785508,13805065379,13459218283,13107891508,15396503999,13600770238,18705045726,15071360501,13400886486,18050877288,15305009255,15080406979,18359592597,15905903705,13328505767,13799866661,13285957289,18965662565,15960217968,17359987925,13960326290,13850751502,18905051668,13159037366,13600703555,13489387611,15060619686,18084725997,13901318357,13295908788,15964917281,13600704026','13906095618,18959858592,18965129895,13255957226,13666026522,13801333177,15106096021,18959847128,13802609526,13506086731,18016585576,15959798579,18859971221,18250298076,18065376686,15602265352,13906099888,13809549382,18876509838,13905070552,13705941428,15159878799,13905089190,13960381057,15980788802,15985952242,13055808024,13950920100,13105079935,13799966695,15805032333,13505080996,18959705077,18965689935,19852121931,18960206656,15880720190,13295959911,15810812160,13905975119,18960278086,18759429880,18609586661,13306995188,15059792958,13305967663,13306995039,13808510760,15959896966,13905952020,18959995705,13805957081,13906091693,13559566696,18859990000,15860395678,15980325929,15859759601,18159826888,13805946193,13044554499,18006037555,18350782990,13506060342,13788851759,13615901213,13599212929,15805021228,15750768536,13506000615,13905974006,13905974002,13358591930,13808505006,15959995535,13559593361,13960417367,13599109151,15659878695,15106088998,18965689828,18859969666,13808557909,18960357668,15260875883,18959988073,15160423086,13705943966,13305088921,15059750761,13799766670,18815985118,15611255393,13636963633,18721796963,13656038332,13675953607,18959210622,13805900098,18859932277,15306089555,15905079361,18618285267,18859799829,13337211223,13600757303,13626072564,13615950806,13906933286,15359996305,18605958880,13788846820,15260782666,13905985809,15260803666,18659030309,13805919195,15392288855,13600754180,17689485050,15880785555,15960692650,13599780560,15259571333,13959712401,18516157979,13328509988,13655902993,15860398018,18859551760,18606989818,13395096999,18959858506,15985918296,13960341716,15880972652,15980313135,13906096567,15080070385,13675995249,15995216889,15260429705,13959778888,18859555816,13905968151,13959776520,13799521561,13720842620,18659915000,13205061526,15060626155,13959237668,13779911861,13601032833,13506042338,18567651331,15959959200,13960291518,13859796953,15850693987,15959870601,18876572155,13959753823,13459034477,15860688762,18859596380,15502179365,15086777305,18850528121,18052150317,17689683160,18859757759,18359810815,13505957512,13696949262,17689690969,18959813876,13805924801,18250169959,15005059367,15502207706,13599218888,18959707235,13788829369,18059037101,18859760088,15392286115,13636957868,15880974760,13794913769,15259555555,18960285333,18959997270,15392288851,13960207400,15946798736,15191577654,17750799505,13666988888,17750103317,18959706230,15622174598,15260807555,13506003686,15905958858,15080458330,15359585555,15059748612,18065333731,15959889099,17605014353,13459504545,15396597171,18605001616,15260785666,18106980703,13959975329,13285030066,18959855726,15906067008,18046360864,13459556182,15060456431,13860300607,13306995027,18796922940,13325253201,18350777627,13599159330,18020650858,13328963385,13709857491,13489312968,15960408186,18859780809,17706075999,15359590811,13959119986,13505951467,15141327771,13599949096,13665987766,15980000372,13905089834,18965687332,13959951039,13960259639,18250155553,18359714502,18965687331,13905085845,15980060559,13960359859,18965523733,17759991213,15959579818,13505008588,15029265211,18650908918,15980000359,17755092627,13960256299,15980000660,18722290558,13636950764,18539456470,17613712423,13107872929,13669274728,18759552098,18659003978,19959848541,17689494919,15959517575,13905051776,13906095618,13505986964,18740431050,13505050069,18759919815,13314987388,15759496852,15059556400,18859996145,15060011828,13400808814,13905950588,15960753968,15315563156,13665959771,13906903291,18705052323,15959505915,13505932929,18159276351,13960282791,13799552053,13626066721,13675998353,18859951871,13030981560,15259223745,18659568811,15559544571,13905953818,13506054328,15759733818,15860902967,13067154015,13599145737,13328500766,13799557193,13905055474,18606985861,18876223641,13788869420,18606056998,18659003000,13559054268,13506969315,13313872221,13328989299,15260704530,13799564888,15159518618,15059821270,18350770992,18959906506,18805959777,15659512626,13905089465,15559067588,18603006276,19906870165,18965689711,13959953589,13489858089,13400840823,13805957117,13960311095,17350011170,13860750864,13808556705,13256678813,13905957105,13506928380,13805959366,15029279845,15979017673,15959556399,15620636649,13484540329,18316739194,18359877950,13488103520,13501115138,13860190418,13805959125,18850496760,13572104402,18659262866,15985751705,15805010196,13505056755,13506069249,13906998897,13696900561,17750891999,13774878631,18959210622,13599161927,15759653345,18516970130,18046311397,13906999100,18292635234,15029278847,13859751591,13636950560,13959840868,15396583913,13920285434,15829907184,13600753338,15860902576,13505059996,13489848301,13505058832,13625959920,13805945051,13950238890,13004886898,13599936037,18960259259,13612150403,13720852551,13410024480,13600738975,13599127767,13659192458,18959706253,13506066917,15860304280,13788811853,13506956209,18859920423,18959992832,15060998567,13850799806,15860381909,13358577766,15905035169,15959553375,15960795588,13506941213,18965699955,13805950256,15080421696,15905095955,17706067083,15859495050,15559133531,15805952318,13799239878,13600751875,13859775220,15905077879,18905953233,15905006716,13055667605,13850777555,15959507666,13636905051,13625994626,13860763453,19859573633,13489403314,15260875781,13004800144,13850777672,18059983988,13799240204,13600709507,15959596201,19959999308,13799850617,13313880008,13808512082,13615940087,13959926888,15059557916,13950108669,13808510666,13799797017,13850728390,18957137209,13505992220,13959941521,13860703356,18633637251,13959856161,13506055166,13959910000,15880881006,13960382970,13860757775,15906066156,15860396396,13559625390,15060946052,18815985602,15880881883,15260823192,15959509673,13905059153,18950026794,13859989821,13506045449,13960459977,18876539791,13706957817,15860302368,13959798556,13505961108,13960292725,15905032289,18659060047,13599994541,15859577452,13559045209,15980065535,15260101691,18759508729,13799896025,15159529936,18905951960,15880161129,13599507077,13859705235,13799202233,13655933296,13950299290,13505907585,13606051571,15059520014,15601588313,13506066359,13799899315,18859933999,13860703516,13505942660,15980456333,13506083126,18659281177,15005936026,13600703472,13905350771,13959752857,15059832543,18150983366,15980235626,13505943066,13559575942,18659737170,15106087765,13110816682,15905044580,13599115973,15659450305,13675930836,17359990624,13405350771,15505952026,13599766670,13685910527,15083847155,15106037664,13808543336,13615922291,18965636930,13863831087,13960296362,17762027770,13700242731,13063191843,15911052916,13505028679,13506062515,18750597755,15259555117,17612198088,18659822922,13520554703,13655601013,15080417163,15827609588,18859785085,15359383458,15905975697,13405353771,15905076266,15980271486,13110592357,15859775715,13808540799,15392481724,15141988697,15880975265,15860328381,18605001313,13959940177,18225662357,18905080205,13506057070,13905055766,15060985107,15060032495,13860726225,13121833855,17727971605,17750989111,13685921872,15980063533,13860143467,15260237093,13960250701,13599505962,18559273254,18950070276,13404252272,17388204055,15259729821,13459599999,15059823968,18106968679,13407735197,17715205257,15326179637,15860301827,15905057579,18060501876,15859231310,15059570222,13959955966,13400887176,15059830121,18050020726,13055224466,15106033846,15880990268,18965483880,18698399527,18314463516,19905053569,13950364429,15805026065,18750530127,13950092022,15980067586,13859790099,15260200619,18965658201,15059755771,15827436094,13459533442,13696856720,15159887877,13599172228,13505008000,13805956092,15880754887,18698360960,13085059001,13665965633,15805003589,15859554650,15260720911,18859498656,18876284599,18876377906,13950317095,15711502057,15905055709,13159060909,15201615843,18065589080,18411037910,13505054724,13459523099,13950063837,13859745152,13959280218,15906061807,18659923130,15860516215,15859565605,18682261122,15159724662,18698372705,13906998716,15860900865,18815997296,15959232693,13788814546,18159595252,18959700369,15859559078,13505990915,13779982480,13615963766,15959966729,13825584576,15122460079,13506061896,15922263220,13600759390,13275049035,13030982553,18559552007,13599710039,13799239129,18292491251,15959994811,15159739903,18859781366,18006037070,18906999069,18876569027,15859553823,13506998846,15980068126,13960259810,18876539839,18050878555,13960826248,15280423942,18659069495,18006990697,13959812033,15159790586,13859085700,18859907988,13808505910,15806017885,15805956361,15980232523,13110982808,18046040451,15959569933,15860356356,18805025309,13055650678,13960254757,15205972628,15806019077,13505097888,13599106745,13959717283,13636959434,13905985743,13636995533,13666029324,13905079763,13599978051,15280422458,18650676688,13906099550,13665001804,15659050608,18960877567,18900311779,15880977738,18605007853,15159871537,15906005715,18606942212,13067198079,13400539210,18825160801,13163906685,18817333998,15375771216,13505955686,13559546275,15260371606,13665956888,15159832652,18750914154,15980478011,13960455227,18559672261,13960270097,18862155979,18659097395,15259727676,13905969285,13799758056,15606087056,18782977456,18965526351,13906091302,13960408350,13959946911,18960251988,15060969798,13505071035,18905059500,13808525056,17705061101,13905059909,13806969722,15985900838,13799581818,13626076868,13960255304,15959992008,15375708923,13615926622,15959990198,13636928198,18106930966,13808558181,13905075757,13905079280,13606021816,15980056221,13805997206,13489887652,13808505732,13506009833,15905022650,13646031399,13805941850,13488682111,15392121201,18659936998,18959981231,13959952350,13489512117,15759500600,13959921098,13799870758,13850753398,15959599793,13242884288,13559550686,15759877981,13805951761,15710646360,15260838513,13600704238,13316225195,13860708740,15805972719,18050888018,13788828099,13505977599,13950175990,18016516089,13959975903,18659516267,15280871258,13505956777,15959853522,15959525859,15359508512,13505051522,15859505750,13489545332,15377953096,15960731557,13599715762,13788826386,13459523253,13489512136,13107880950,15750898928,18950498312,15375886386,13400507028,13587756546,13959737339,18659916888,18859525583,13506059007,13215066449,13505955666,13975057391,13505902557,13636951165,13805957070,13860602468,13960358840,13305962813,13661356074,18350742084,15606088553,13645019389,15280875858,13600788662,19905908656,18344910844,18059147928,15260708136,15880824003,15880939936,13365952758,13805951603,15375754488,13918199745,15859577777,15606946335,13805997578,15060933832,17850929207,18750654331,13599751999,13906099845,15559050207,18859552366,18859626598,15959990680,15905909283,13805145645,15059720864,15620633941,15980006525,15260813616,18100525107,18859763636,18396220746,18559477701,13959992226,15759596655,13905955872,13605944765,15959595731,13505954433,13808552366,13655928585,15859506299,13306051592,13788833384,13960305030,13338583366,13505905737,15280081010,13788805366,13559369710,13788816686,17683234600,13067166871,13600785508,13805065379,13459218283,13107891508,15396503999,13600770238,18705045726,15071360501,13400886486,18050877288,15305009255,15080406979,18359592597,15905903705,13328505767,13799866661,13285957289,18965662565,15960217968,17359987925,13960326290,13850751502,18905051668,13159037366,13600703555,13489387611,15060619686,18084725997,13901318357,13295908788,15964917281,13600704026','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才申报对象：为做好2019年度晋江市优秀人才认定工作，请符合申报条件但未重新补齐人才认定材料的各申报对象及时与人才联络员联系，抓紧时间提交材料，补件时间截止至2020年4月10日17:30，谢谢！',2,'未知错误','2020-04-03',NULL,NULL,NULL,'2020-04-03 09:09:39',NULL,NULL,NULL),('1245882295269810178',NULL,NULL,2,2,'批量发送','15959517575,18859763636,13960291518,15880975265,18100525107,18859596380,18859996145,17605014353,15080318157,15259597676,13459562051,15959530855,17741357996','15959517575,18859763636,13960291518,15880975265,18100525107,18859596380,18859996145,17605014353,15080318157,15259597676,13459562051,15959530855,17741357996','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才申报对象：为做好2019年度晋江市优秀人才认定工作，请符合申报条件但未重新补齐人才认定材料的各申报对象及时与人才联络员联系，抓紧时间提交材料，补件时间截止至2020年4月10日17:30，谢谢！',3,'短信发送成功','2020-04-03',NULL,NULL,NULL,'2020-04-03 09:14:21',NULL,NULL,NULL),('1245896731791548418',NULL,NULL,2,1,NULL,'18959707235','848594','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-03',NULL,NULL,NULL,'2020-04-03 10:11:43',NULL,NULL,NULL),('1246000703957176322',NULL,NULL,2,1,NULL,'13675998353','487336','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-03',NULL,NULL,NULL,'2020-04-03 17:04:52',NULL,NULL,NULL),('1246002093957910529',NULL,NULL,2,1,NULL,'13675998353','526808','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-03',NULL,NULL,NULL,'2020-04-03 17:10:23',NULL,NULL,NULL),('1246004640894488578',NULL,NULL,2,1,NULL,'13675998353','075021','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-03',NULL,NULL,NULL,'2020-04-03 17:20:30',NULL,NULL,NULL),('1246005892726460418',NULL,NULL,2,1,NULL,'13675998353','913515','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-03',NULL,NULL,NULL,'2020-04-03 17:25:29',NULL,NULL,NULL),('1247690644126765057','83',NULL,1,2,'李女元','15359825666','27,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:00:05',NULL,NULL,NULL),('1247690644164513794','91',NULL,1,2,'吴晓婷','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:00:05',NULL,NULL,NULL),('1247690665589018625','84',NULL,1,2,' 洪全益','13808555296','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:00:10',NULL,NULL,NULL),('1247690665630961665','58',NULL,1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:00:10',NULL,NULL,NULL),('1247690666079752194','87',NULL,1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:00:10',NULL,NULL,NULL),('1247693160025493505','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:05',NULL,NULL,NULL),('1247693181416443905','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693181588410369','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693181806514177','1211100599215566849',NULL,2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693182028812290','1211167966465470465',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693182234333186','1211177535560331265',NULL,2,2,'晋江市凯鑫汽配有限责任公司','15959556399','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693182477602817','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693182683123714','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693182913810433','1211454669394591746',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693183073193985','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693183303880706','1211457535089885185',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693183467458561','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693183685562369','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693183840751617','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693184075632642','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693184235016193','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693184394399746','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693184574754818','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693184755109890','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693184914493441','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:10',NULL,NULL,NULL),('1247693185128402946','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693185287786498','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693185455558658','1211515979058692097',NULL,2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693185610747905','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693185774325762','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693186000818177','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693186193756161','1211572731150123009',NULL,2,2,'三六一度（福建）体育用品有限公司','13625976298','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693186365722626','1211576021401255937',NULL,2,2,'泉州鑫豪工程机械科技有限公司','18900399682','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693186529300481','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693186697072642','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693186864844801','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693187041005569','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693187246526466','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693187422687234','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693187615625217','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693187787591681','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693187946975234','1211945706491789313',NULL,2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693188106358786','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693188274130946','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693188429320194','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693188672589825','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693188831973377','1212540446794911745',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693188995551233','1212561377781157890',NULL,2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693189146546178','1212568548061286401',NULL,2,2,'贵人鸟股份有限公司','15359991222','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:11',NULL,NULL,NULL),('1247693189335289858','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693189507256321','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693189675028482','1212604591955316738',NULL,2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693189830217729','1212620045818073089',NULL,2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693189997989889','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693190157373441','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693190312562689','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','52,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693190467751938','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693190635524098','1212734981810491393',NULL,2,2,'福建省闽楚建设工程有限公司晋江分公司','13599145737','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693190794907649','1212897074375364610',NULL,2,2,'泉州森地客体育用品有限公司','13959888172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693190950096897','1212903777946898433',NULL,2,2,'福建兴翼机械有限公司','18606981162','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693191101091841','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693191252086785','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693191419858946','1212930279740608514',NULL,2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693191579242498','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693191738626050','1213032291266269186',NULL,2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693191889620994','1213067533700108289',NULL,2,2,'晋江市锦马汽车检验有限公司','15059570222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693192053198849','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693192216776705','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693192371965954','1213987181866012674',NULL,2,2,'晋江集成轻工有限公司','18016623555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693192527155201','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693192741064705','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693192896253954','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693193068220417','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693193227603969','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693193382793218','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:12',NULL,NULL,NULL),('1247693193542176770','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693193735114753','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693193898692610','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693194049687553','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693194217459714','1214461743938473985',NULL,2,2,'福建七匹狼集团有限公司','15259760497','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693194372648962','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693194519449602','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693194678833153','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693194842411010','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693194989211649','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693195144400898','1215439821749665794',NULL,2,2,'泉州福盈汽车销售服务有限公司','15559133531','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693195303784449','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693195458973697','1215608523329683457',NULL,2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693195647717378','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693195807100929','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693195974873090','1216185557357457410',NULL,2,2,'晋江太古飞机复合材料有限公司','18959996091','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693196138450945','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693196297834497','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693196453023745','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693196616601601','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693196805345282','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693196968923137','1217624507943026690',NULL,2,2,'中国建设银行股份有限公司晋江分行','18960272000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693197128306689','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693197291884546','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693197459656706','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693197614845954','1218794464953360385',NULL,2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:13',NULL,NULL,NULL),('1247693197782618114','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693197950390274','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693198105579521','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693198273351682','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693198432735233','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693198671810561','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693198814416898','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693198957023233','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693199108018177','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693199271596033','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693199418396673','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693199561003010','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693199711997953','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693199858798593','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693200013987841','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693200156594178','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693200315977729','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247693200466972674','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'移动停机或关机','2020-04-08',NULL,NULL,NULL,'2020-04-08 09:10:14',NULL,NULL,NULL),('1247712107793813506',NULL,NULL,2,1,NULL,'15960791997','327657','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-08',NULL,NULL,NULL,'2020-04-08 10:25:22',NULL,NULL,NULL),('1248053031396773889','70',NULL,1,2,'陈瑞清','13788864979','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031442911233','91',NULL,1,2,'吴晓婷','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:05',NULL,NULL,NULL),('1248053052838055938','76',NULL,1,2,'陈灿峰','13599718877','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:10',NULL,NULL,NULL),('1248053052859027457','58',NULL,1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:10',NULL,NULL,NULL),('1248053053047771137','83',NULL,1,2,'李女元','15359825666','50,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:10',NULL,NULL,NULL),('1248053053056159746','87',NULL,1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:10',NULL,NULL,NULL),('1248053053236514817','84',NULL,1,2,' 洪全益','13808555296','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:10',NULL,NULL,NULL),('1248053053416869890','86',NULL,1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:00:10',NULL,NULL,NULL),('1248055547928842241','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:05',NULL,NULL,NULL),('1248055569227517953','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055569391095810','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055569546285057','1211100599215566849',NULL,2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055569709862913','1211167966465470465',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055569886023681','1211177535560331265',NULL,2,2,'晋江市凯鑫汽配有限责任公司','15959556399','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055570041212929','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055570213179393','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055570372562945','1211454669394591746',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055570523557890','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055570691330049','1211457535089885185',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055570846519298','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055571005902849','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055571169480706','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055571320475650','1211474926804975617',NULL,2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055571484053505','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055571639242753','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055571811209217','1211482027447074818',NULL,2,2,'福建晋江天然气发电有限公司','18876509838','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055571978981377','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055572125782018','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055572310331394','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055572486492162','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055572675235842','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055572868173826','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:10',NULL,NULL,NULL),('1248055573027557378','1211568776709980162',NULL,2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055573186940929','1211576021401255937',NULL,2,2,'泉州鑫豪工程机械科技有限公司','18900399682','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055573333741569','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055573493125122','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055573648314370','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055573824475137','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055573983858689','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055574147436545','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055574298431490','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055574587838465','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055574747222017','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055574894022658','1211945767430832130',NULL,2,2,'晋江市安海医院','13860758785','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055575065989122','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055575212789761','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055575380561921','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055575535751169','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055575682551809','1212540446794911745',NULL,2,2,'晋江七匹狼服装制造有限公司','13788808205','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055575841935362','1212568548061286401',NULL,2,2,'贵人鸟股份有限公司','15359991222','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055575997124609','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055576148119554','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055576307503106','1212620045818073089',NULL,2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055576471080962','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055576613687298','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055576764682242','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','44,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055576915677186','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055577075060737','1212734981810491393',NULL,2,2,'福建省闽楚建设工程有限公司晋江分公司','13599145737','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:11',NULL,NULL,NULL),('1248055577259610113','1212897074375364610',NULL,2,2,'泉州森地客体育用品有限公司','13959888172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055577427382274','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055577582571522','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055577746149377','1212930279740608514',NULL,2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055577901338625','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055578052333570','1213032291266269186',NULL,2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055578215911426','1213067533700108289',NULL,2,2,'晋江市锦马汽车检验有限公司','15059570222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055578366906370','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055578530484226','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055578689867778','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055578849251329','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055579004440577','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055579155435521','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055579306430465','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055579457425409','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055579612614658','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055579771998209','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055579927187457','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055580082376705','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055580233371649','1214461743938473985',NULL,2,2,'福建七匹狼集团有限公司','15259760497','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055580392755202','1214729031224745985',NULL,2,2,'泉州争艳文化艺术传播有限公司','13599936037','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055580589887489','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055580766048258','1214802166888357889',NULL,2,2,'福建省晋江人力资本有限公司','13489719977','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055580967374850','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055581114175489','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055581273559042','1215115207978827777',NULL,2,2,'福州大学晋江科教园管委会','15980228632','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:12',NULL,NULL,NULL),('1248055581424553986','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055581579743234','1215259455701172226',NULL,2,2,'福建新宇拉链织造有限公司','15259555117','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055581739126786','1215439821749665794',NULL,2,2,'泉州福盈汽车销售服务有限公司','15559133531','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055581885927426','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055582045310978','1215608523329683457',NULL,2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055583181967361','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055583332962306','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055583500734465','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055583668506625','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055583840473089','1216650516390486017',NULL,2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055583995662337','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055584146657281','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055584310235138','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055584482201602','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055584645779457','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055584809357314','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055584960352257','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055585119735810','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055585270730754','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055585430114306','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:13',NULL,NULL,NULL),('1248055585660801026','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055585832767490','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055585987956738','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055586155728898','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055586310918146','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055586591936513','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055586755514370','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055586923286530','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055587086864385','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055587250442242','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055587418214402','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055587594375169','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055587757953025','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248055587925725186','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'移动停机或关机','2020-04-09',NULL,NULL,NULL,'2020-04-09 09:10:14',NULL,NULL,NULL),('1248082494847258625',NULL,NULL,2,1,NULL,'18876509838','214687','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 10:57:09',NULL,NULL,NULL),('1248082765119819778',NULL,NULL,2,1,NULL,'18876509838','926018','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-09',NULL,NULL,NULL,'2020-04-09 10:58:14',NULL,NULL,NULL),('1248415419300122626','76',NULL,1,2,'陈灿峰','13599718877','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:00:05',NULL,NULL,NULL),('1248415419350454273','91',NULL,1,2,'吴晓婷','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:00:05',NULL,NULL,NULL),('1248415440691073026','83',NULL,1,2,'李女元','15359825666','49,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:00:10',NULL,NULL,NULL),('1248415440733016065','58',NULL,1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:00:10',NULL,NULL,NULL),('1248415440875622402','84',NULL,1,2,' 洪全益','13808555296','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:00:10',NULL,NULL,NULL),('1248415441055977473','86',NULL,1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:00:10',NULL,NULL,NULL),('1248415441206972417','87',NULL,1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:00:10',NULL,NULL,NULL),('1248417935731527682','1211092856509411330',NULL,2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:05',NULL,NULL,NULL),('1248417957059563522','1211095022649323522',NULL,2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417957273473025','1211095249951240193',NULL,2,2,'晋江市腾达齿轮轴制造有限公司','13788825810','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417957466411010','1211100599215566849',NULL,2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417957667737602','1211167966465470465',NULL,2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417957864869890','1211177535560331265',NULL,2,2,'晋江市凯鑫汽配有限责任公司','15959556399','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417958112333826','1211439642532954113',NULL,2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417958313660418','1211442194934710274',NULL,2,2,'信泰（福建）科技有限公司','15102155779','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417958485626882','1211454669394591746',NULL,2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417958678564865','1211456847907700737',NULL,2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417958917640193','1211457535089885185',NULL,2,2,'晋江市艺达木雕美术有限公司','18150505789','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417959181881345','1211457961772236801',NULL,2,2,'灵源药业有限公司','18350770050','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417959366430722','1211465260200935426',NULL,2,2,'福建金石能源有限公司','13615901213','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417959538397185','1211473406755651586',NULL,2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417959731335169','1211479687600062466',NULL,2,2,'测试','17362523273','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417959936856065','1211480586019979265',NULL,2,2,'福建丰豪汽车销售服务有限公司','15960789678','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417960146571266','1211482936533106690',NULL,2,2,'福建兴瑞建设工程有限公司','18659518160','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417960482115585','1211485201327243265',NULL,2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417960658276353','1211490446086291458',NULL,2,2,'泉州职业技术大学','18060007601','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:10',NULL,NULL,NULL),('1248417960834437122','1211490953219588098',NULL,2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417961002209282','1211529007779069954',NULL,2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417961174175745','1211537376518651906',NULL,2,2,'晋江市南湾投资发展有限公司','13559054268','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417961341947905','1211601884993863681',NULL,2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417961530691586','1211610997505179649',NULL,2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417961685880834','1211832959498240001',NULL,2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417961887207425','1211837849989595138',NULL,2,2,'利郎（中国）有限公司','15959420909','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417962096922626','1211842268063907841',NULL,2,2,'泉州市农业科学研究所','13599701057','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417962340192257','1211920348237316098',NULL,2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417962549907457','1211923882831822850',NULL,2,2,'晋江市疾病预防控制中心','13675959528','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417962730262529','1211931259509456897',NULL,2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417962939977729','1211936041519333377',NULL,2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417963111944194','1212253296765505538',NULL,2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417963279716353','1212271071303110658',NULL,2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417963443294209','1212535414099873794',NULL,2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417963619454977','1212536972627742722',NULL,2,2,'泉州汇京豪信汽车销售有限公司','13675998353','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417963795615746','1212568548061286401',NULL,2,2,'贵人鸟股份有限公司','15359991222','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417963959193601','1212580494957416450',NULL,2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417964164714498','1212582208896831489',NULL,2,2,'泉州市丰预泰企业管理有限公司','18698387555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417964378624002','1212620045818073089',NULL,2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417964546396162','1212665594457952258',NULL,2,2,'晋江市鹏翔生物科技有限公司','15059830121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417964722556930','1212680835921154049',NULL,2,2,'福建省亿海汽车贸易有限公司','15159832652','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417964915494914','1212685717864517633',NULL,2,2,'晋江市中医院','15960586523','25,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:11',NULL,NULL,NULL),('1248417965137793025','1212731840222269441',NULL,2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417965318148097','1212734981810491393',NULL,2,2,'福建省闽楚建设工程有限公司晋江分公司','13599145737','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417965490114561','1212910711521480705',NULL,2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417965666275329','1212918089352548353',NULL,2,2,'福建天测思创信息科技有限公司','18759552098','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417965829853185','1212930279740608514',NULL,2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417965993431042','1212989991169363970',NULL,2,2,'星馥乐（福建）生物科技有限公司','13960496669','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417966152814594','1213067533700108289',NULL,2,2,'晋江市锦马汽车检验有限公司','15059570222','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417966324781057','1213277633517785089',NULL,2,2,'泉州市英豪物流有限责任公司','15905054477','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417966492553218','1213451329813417985',NULL,2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417966656131074','1213995667383406593',NULL,2,2,'晋江信路达机械设备有限公司','18050911980','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417966823903234','1214017104513093633',NULL,2,2,'晋江市美味强食品有限公司','17706075999','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417966987481089','1214020915189272577',NULL,2,2,'泉州国科文化有限公司','18259591998','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417967151058946','1214041673798012930',NULL,2,2,'福建省全杰生物科技有限公司','19905050771','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417967318831106','1214052741177954306',NULL,2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417967490797569','1214097817526620161',NULL,2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417967650181122','1214142410787934209',NULL,2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417967813758978','1214185888003739649',NULL,2,2,'晋江市东石镇梅塘农业综合场','18759442340','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417968010891266','1214375861688553474',NULL,2,2,'晋江一岂科技有限公司','13950116705','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417968187052034','1214424661748682754',NULL,2,2,'泉州好彩头食品有限公司','18859951871','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417968354824194','1214748606972649473',NULL,2,2,'福建纸匠文化科技股份有限公司','15960694893','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417968522596353','1214803603139682306',NULL,2,2,'晋江市总商会投资开发有限公司','15060933526','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417968690368513','1214842942284455937',NULL,2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417968904278017','1215207699331989506',NULL,2,2,'晋江市医院','18350528526','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417969067855873','1215439821749665794',NULL,2,2,'泉州福盈汽车销售服务有限公司','15559133531','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:12',NULL,NULL,NULL),('1248417969235628034','1215532466647908353',NULL,2,2,'泉州晨鑫自动化科技有限公司','13489387611','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417969403400194','1215608523329683457',NULL,2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417969571172353','1215821758574129154',NULL,2,2,'泉州市海晟环保科技有限公司','13599766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417969734750209','1215837051279142913',NULL,2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417969898328066','1216370975893909505',NULL,2,2,'晋江伟昇贸易有限公司','13905055766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417970057711617','1216555050113986561',NULL,2,2,'晋江源泰皮革有限公司','13030990915','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417970225483777','1216900406462926849',NULL,2,2,'晋江山外山五祖拳传习中心','13905063574','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417970397450242','1217015677777367041',NULL,2,2,'晋江市安海镇建新汽车维修厂','13959955966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417970565222401','1217634677435727873',NULL,2,2,'军鹏特种装备股份公司','17305060050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417970745577473','1217649335316054018',NULL,2,2,'晋江大白科技有限公司','18850018674','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417970921738242','1218097536540147714',NULL,2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417971093704705','1219128118049103873',NULL,2,2,'晋江市睿杰财务管理有限公司','18016516089','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417971274059777','1219144052960780289',NULL,2,2,'福建冠泓工业有限公司','15396395062','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417971441831938','1219147136575332354',NULL,2,2,'泉州众骋汽车有限公司','18159581122','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417971622187010','1219149351193010178',NULL,2,2,'晋江盛名吉成百货有限公司','13489875197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417971802542082','1219166759144251393',NULL,2,2,'泉州市诺伊曼信息科技股份公司','13850752082','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417971966119938','1219171908407386114',NULL,2,2,'晋江华泰房地产有限责任公司','13859776052','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417972133892097','1219173440183984129',NULL,2,2,'福建省宏泰建设发展有限公司','15960788001','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417972297469953','1219181564773130242',NULL,2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417972473630722','1219436923634892801',NULL,2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417972645597186','1219449573446041602',NULL,2,2,'福建七彩陶瓷有限公司','13960358840','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417972809175042','1219467381299003394',NULL,2,2,'晋江市磁灶镇顺风轿车维修店','15959595731','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417972972752898','1219531006973886465',NULL,2,2,'晋江市海晟机械有限公司','15859506299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417973132136450','1219536013051871234',NULL,2,2,'国泰君安证券股份有限公司晋江长兴路证券营业部','18750561717','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417973299908610','1219556482719203329',NULL,2,2,'晋江市陈埭春鑫汽车服务有限公司','13959992226','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:13',NULL,NULL,NULL),('1248417973471875073','1219896525681868801',NULL,2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:14',NULL,NULL,NULL),('1248417973635452930','1219962405086314498',NULL,2,2,'墩煌（福建）实业有限公司','13600770238','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:14',NULL,NULL,NULL),('1248417973799030786','1219983713073381378',NULL,2,2,'晋江市明顺汽车维修服务有限公司','13850751502','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:14',NULL,NULL,NULL),('1248417973975191554','1220167586910584834',NULL,2,2,'晋江市天姿纺织实业有限公司','18050877288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:14',NULL,NULL,NULL),('1248417974138769409','1220269594833338369',NULL,2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 09:10:14',NULL,NULL,NULL),('1248520856565518337',NULL,NULL,2,2,'批量发送','18959705077,13506055705,15759732363,13799553654,13788825810,13799487213,15859799211,18859969666,15880936557,13313825373,18959858592,18396220746,18959210622,13520554703,15959556399,15880720190,13295959911,18959847128,15109613666,15306089555,13799766670,18859716647,15102155779,18559275265,13799557721,13625958406,15980473561,18859971221,15859813817,13506060342,15392286115,15059821270,18150505789,18350770050,18965689935,13788846820,18159338867,15880885350,18959857088,13505004167,13615901213,15059551567,18250413746,13489887652,13365978588,18959708027,13788809209,13255006151,13799550180,18959995705,18759429880,13055667605,17362523273,18960355033,15960789678,18876509838,18659518160,13599749329,13506061626,18016585576,15959856777,18060007601,15980788802,13255957226,15905907962,18050996325,15106011992,15960791997,18960357668,15960551920,15805021228,13506069172,13559054268,13906095618,15280796970,18698390251,13959811363,15059528886,13559060707,13860748042,13665929319,13959757688,13625976298,18900399682,13799233113,13599789599,137888000470,13905089190,13666026522,17350926157,13805992036,18350062033,17759539230,15960778794,15959420909,19942826787,13599701057,15160423086,18859989399,18965690059,15160330306,15260875883,13675959528,17359269810,13509362773,15191454197,13506042338,13788829369,13859769696,13860758785,13599218888,13656038332,17759990690,13559591215,13580701185,13959717808,18120662230,13675998353,15396486268,13788808205,13860706464,15359991222,13599295908,18698387555,18900370886,15959886256,15959501581,15905958858,13905050770,15392121201,18698386676,15059830121,18250638258,18900300373,15159832652,15960586523,17350011170,18006999862,13599145737,13959888172,18606981162,15359382970,15750998817,18759552098,15359823950,15106027935,18606984919,15880713988,13625952299,15375873767,13110801508,13960496669,18250155553,18659568811,13400808814,15959508318,18965183911,15059570222,13960259639,17758709290,15905054477,13559554933,13030981560,13665987766,18859760088,13808516919,17750799505,18016623555,18050911980,17706075999,18050888018,13505925273,18259591998,13489858089,19905050771,15905970382,18106990767,13960315655,13850777672,17750792370,13960256299,13328567990,18759442340,13959713700,13950116705,15860304280,13799225181,18859951871,15959880009,19959711592,15259760497,13859210956,18350599665,13599936037,15960694893,13600737691,13489719977,15060933526,17350937795,13489848301,18905953233,15880742575,15705936082,15980228632,13559592263,18350528526,15259555117,15559133531,15260856039,13950238890,15860517253,13489387611,15906066156,15805972719,18959995205,19959813350,13506062515,13599766670,18072769019,15711376693,18959996091,13905055766,13959882723,13030990915,15160050023,13905985153,15880881006,13599718877,18959759065,13905063574,18650916825,18559780403,13959955966,18859781366,18559529595,15259755678,13675918895,13505959911,18960272000,17305060050,18850018674,15960417947,13799855086,13898810920,15260225737,13506098847,18016516089,15905975168,15905035025,15396395062,18159581122,13489875197,15080426614,13850752082,13960228853,13859776052,15960788001,15259513222,13365952758,13506030795,13599773033,15260663037,13959737339,15375754488,15859590857,13506095562,15375886386,18259038660,13960358840,15805039263,15959595731,15859506299,13799599097,18750561717,13959992226,13788816686,15980006525,18050881166,13808552366,13306051592,13600770238,13850751502,18050877288,15964917281,13600704026','18959705077,13506055705,15759732363,13799553654,13788825810,13799487213,15859799211,18859969666,15880936557,13313825373,18959858592,18396220746,18959210622,13520554703,15959556399,15880720190,13295959911,18959847128,15109613666,15306089555,13799766670,18859716647,15102155779,18559275265,13799557721,13625958406,15980473561,18859971221,15859813817,13506060342,15392286115,15059821270,18150505789,18350770050,18965689935,13788846820,18159338867,15880885350,18959857088,13505004167,13615901213,15059551567,18250413746,13489887652,13365978588,18959708027,13788809209,13255006151,13799550180,18959995705,18759429880,13055667605,17362523273,18960355033,15960789678,18876509838,18659518160,13599749329,13506061626,18016585576,15959856777,18060007601,15980788802,13255957226,15905907962,18050996325,15106011992,15960791997,18960357668,15960551920,15805021228,13506069172,13559054268,13906095618,15280796970,18698390251,13959811363,15059528886,13559060707,13860748042,13665929319,13959757688,13625976298,18900399682,13799233113,13599789599,137888000470,13905089190,13666026522,17350926157,13805992036,18350062033,17759539230,15960778794,15959420909,19942826787,13599701057,15160423086,18859989399,18965690059,15160330306,15260875883,13675959528,17359269810,13509362773,15191454197,13506042338,13788829369,13859769696,13860758785,13599218888,13656038332,17759990690,13559591215,13580701185,13959717808,18120662230,13675998353,15396486268,13788808205,13860706464,15359991222,13599295908,18698387555,18900370886,15959886256,15959501581,15905958858,13905050770,15392121201,18698386676,15059830121,18250638258,18900300373,15159832652,15960586523,17350011170,18006999862,13599145737,13959888172,18606981162,15359382970,15750998817,18759552098,15359823950,15106027935,18606984919,15880713988,13625952299,15375873767,13110801508,13960496669,18250155553,18659568811,13400808814,15959508318,18965183911,15059570222,13960259639,17758709290,15905054477,13559554933,13030981560,13665987766,18859760088,13808516919,17750799505,18016623555,18050911980,17706075999,18050888018,13505925273,18259591998,13489858089,19905050771,15905970382,18106990767,13960315655,13850777672,17750792370,13960256299,13328567990,18759442340,13959713700,13950116705,15860304280,13799225181,18859951871,15959880009,19959711592,15259760497,13859210956,18350599665,13599936037,15960694893,13600737691,13489719977,15060933526,17350937795,13489848301,18905953233,15880742575,15705936082,15980228632,13559592263,18350528526,15259555117,15559133531,15260856039,13950238890,15860517253,13489387611,15906066156,15805972719,18959995205,19959813350,13506062515,13599766670,18072769019,15711376693,18959996091,13905055766,13959882723,13030990915,15160050023,13905985153,15880881006,13599718877,18959759065,13905063574,18650916825,18559780403,13959955966,18859781366,18559529595,15259755678,13675918895,13505959911,18960272000,17305060050,18850018674,15960417947,13799855086,13898810920,15260225737,13506098847,18016516089,15905975168,15905035025,15396395062,18159581122,13489875197,15080426614,13850752082,13960228853,13859776052,15960788001,15259513222,13365952758,13506030795,13599773033,15260663037,13959737339,15375754488,15859590857,13506095562,15375886386,18259038660,13960358840,15805039263,15959595731,15859506299,13799599097,18750561717,13959992226,13788816686,15980006525,18050881166,13808552366,13306051592,13600770238,13850751502,18050877288,15964917281,13600704026','【晋江市人才服务平台】尊敬的各用人单位人才联络员：请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年4月10日（今天）17:30，谢谢！',2,'非法操作GNS（手机关机，停机及黑名单用户）','2020-04-10',NULL,NULL,NULL,'2020-04-10 15:59:03',NULL,NULL,NULL),('1248525139075731457',NULL,NULL,2,2,'批量发送','18959705077,13506055705,15759732363,13799553654,13788825810,13799487213,15859799211,18859969666,15880936557,13313825373,18959858592,18396220746,18959210622,13520554703,15959556399,15880720190,13295959911,18959847128,15109613666,15306089555,13799766670,18859716647,15102155779,18559275265,13799557721,13625958406,15980473561,18859971221,15859813817,13506060342,15392286115,15059821270,18150505789,18350770050,18965689935,13788846820,18159338867,15880885350,18959857088,13505004167,13615901213,15059551567,18250413746,13489887652,13365978588,18959708027,13788809209,13255006151,13799550180,18959995705,18759429880,13055667605,17362523273,18960355033,15960789678,18876509838,18659518160,13599749329,13506061626,18016585576,15959856777,18060007601,15980788802,13255957226,15905907962,18050996325,15106011992,15960791997,18960357668,15960551920,15805021228,13506069172,13559054268,13906095618,15280796970,18698390251,13959811363,15059528886,13559060707,13860748042,13665929319,13959757688,13625976298,18900399682,13799233113,13599789599,137888000470,13905089190,13666026522,17350926157,13805992036,18350062033,17759539230,15960778794,15959420909,19942826787,13599701057,15160423086,18859989399,18965690059,15160330306,15260875883,13675959528,17359269810,13509362773,15191454197,13506042338,13788829369,13859769696,13860758785,13599218888,13656038332,17759990690,13559591215,13580701185,13959717808,18120662230,13675998353,15396486268,13788808205,13860706464,15359991222,13599295908,18698387555,18900370886,15959886256,15959501581,15905958858,13905050770,15392121201,18698386676,15059830121,18250638258,18900300373,15159832652,15960586523,17350011170,18006999862,13599145737,13959888172,18606981162,15359382970,15750998817,18759552098,15359823950,15106027935,18606984919,15880713988,13625952299,15375873767,13110801508,13960496669,18250155553,18659568811,13400808814,15959508318,18965183911,15059570222,13960259639,17758709290,15905054477,13559554933,13030981560,13665987766,18859760088,13808516919,17750799505,18016623555,18050911980,17706075999,18050888018,13505925273,18259591998,13489858089,19905050771,15905970382,18106990767,13960315655,13850777672,17750792370,13960256299,13328567990,18759442340,13959713700,13950116705,15860304280,13799225181,18859951871,15959880009,19959711592,15259760497,13859210956,18350599665,13599936037,15960694893,13600737691,13489719977,15060933526,17350937795,13489848301,18905953233,15880742575,15705936082,15980228632,13559592263,18350528526,15259555117,15559133531,15260856039,13950238890,15860517253,13489387611,15906066156,15805972719,18959995205,19959813350,13506062515,13599766670,18072769019,15711376693,18959996091,13905055766,13959882723,13030990915,15160050023,13905985153,15880881006,13599718877,18959759065,13905063574,18650916825,18559780403,13959955966,18859781366,18559529595,15259755678,13675918895,13505959911,18960272000,17305060050,18850018674,15960417947,13799855086,13898810920,15260225737,13506098847,18016516089,15905975168,15905035025,15396395062,18159581122,13489875197,15080426614,13850752082,13960228853,13859776052,15960788001,15259513222,13365952758,13506030795,13599773033,15260663037,13959737339,15375754488,15859590857,13506095562,15375886386,18259038660,13960358840,15805039263,15959595731,15859506299,13799599097,18750561717,13959992226,13788816686,15980006525,18050881166,13808552366,13306051592,13600770238,13850751502,18050877288,15964917281,13600704026','18959705077,13506055705,15759732363,13799553654,13788825810,13799487213,15859799211,18859969666,15880936557,13313825373,18959858592,18396220746,18959210622,13520554703,15959556399,15880720190,13295959911,18959847128,15109613666,15306089555,13799766670,18859716647,15102155779,18559275265,13799557721,13625958406,15980473561,18859971221,15859813817,13506060342,15392286115,15059821270,18150505789,18350770050,18965689935,13788846820,18159338867,15880885350,18959857088,13505004167,13615901213,15059551567,18250413746,13489887652,13365978588,18959708027,13788809209,13255006151,13799550180,18959995705,18759429880,13055667605,17362523273,18960355033,15960789678,18876509838,18659518160,13599749329,13506061626,18016585576,15959856777,18060007601,15980788802,13255957226,15905907962,18050996325,15106011992,15960791997,18960357668,15960551920,15805021228,13506069172,13559054268,13906095618,15280796970,18698390251,13959811363,15059528886,13559060707,13860748042,13665929319,13959757688,13625976298,18900399682,13799233113,13599789599,137888000470,13905089190,13666026522,17350926157,13805992036,18350062033,17759539230,15960778794,15959420909,19942826787,13599701057,15160423086,18859989399,18965690059,15160330306,15260875883,13675959528,17359269810,13509362773,15191454197,13506042338,13788829369,13859769696,13860758785,13599218888,13656038332,17759990690,13559591215,13580701185,13959717808,18120662230,13675998353,15396486268,13788808205,13860706464,15359991222,13599295908,18698387555,18900370886,15959886256,15959501581,15905958858,13905050770,15392121201,18698386676,15059830121,18250638258,18900300373,15159832652,15960586523,17350011170,18006999862,13599145737,13959888172,18606981162,15359382970,15750998817,18759552098,15359823950,15106027935,18606984919,15880713988,13625952299,15375873767,13110801508,13960496669,18250155553,18659568811,13400808814,15959508318,18965183911,15059570222,13960259639,17758709290,15905054477,13559554933,13030981560,13665987766,18859760088,13808516919,17750799505,18016623555,18050911980,17706075999,18050888018,13505925273,18259591998,13489858089,19905050771,15905970382,18106990767,13960315655,13850777672,17750792370,13960256299,13328567990,18759442340,13959713700,13950116705,15860304280,13799225181,18859951871,15959880009,19959711592,15259760497,13859210956,18350599665,13599936037,15960694893,13600737691,13489719977,15060933526,17350937795,13489848301,18905953233,15880742575,15705936082,15980228632,13559592263,18350528526,15259555117,15559133531,15260856039,13950238890,15860517253,13489387611,15906066156,15805972719,18959995205,19959813350,13506062515,13599766670,18072769019,15711376693,18959996091,13905055766,13959882723,13030990915,15160050023,13905985153,15880881006,13599718877,18959759065,13905063574,18650916825,18559780403,13959955966,18859781366,18559529595,15259755678,13675918895,13505959911,18960272000,17305060050,18850018674,15960417947,13799855086,13898810920,15260225737,13506098847,18016516089,15905975168,15905035025,15396395062,18159581122,13489875197,15080426614,13850752082,13960228853,13859776052,15960788001,15259513222,13365952758,13506030795,13599773033,15260663037,13959737339,15375754488,15859590857,13506095562,15375886386,18259038660,13960358840,15805039263,15959595731,15859506299,13799599097,18750561717,13959992226,13788816686,15980006525,18050881166,13808552366,13306051592,13600770238,13850751502,18050877288,15964917281,13600704026','【晋江市人才服务平台】（该短信发送对象为人才经办人群发， 若登录晋江人才系统查看后，没有被驳回的信息，则可忽略此短信，谢谢！！） 尊敬的各用人单位人才联络员：请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年4月10日（今天）17:30，谢谢！！',2,'非法操作GNS（手机关机，停机及黑名单用户）','2020-04-10',NULL,NULL,NULL,'2020-04-10 16:16:04',NULL,NULL,NULL),('1248527411327340546',NULL,NULL,2,1,NULL,'18859971221','494176','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-10',NULL,NULL,NULL,'2020-04-10 16:25:06',NULL,NULL,NULL),('1248996737197092866',NULL,'1248996714757566465',2,2,'批量发送(20200411)','17362523273','17362523273','【晋江市人才服务平台】测试',1,NULL,'2020-04-11',NULL,NULL,NULL,'2020-04-11 23:29:56',NULL,NULL,NULL),('1248996737226452993',NULL,'1248996714757566465',2,2,'批量发送(20200411)','18372551198','18372551198','【晋江市人才服务平台】测试',1,NULL,'2020-04-11',NULL,NULL,NULL,'2020-04-11 23:29:56',NULL,NULL,NULL),('1248996738304389121',NULL,'1248996737780101122',2,2,'批量发送(20200411)','17362523273','17362523273','【晋江市人才服务平台】测试',1,NULL,'2020-04-11',NULL,NULL,NULL,'2020-04-11 23:30:02',NULL,NULL,NULL),('1248996738333749250',NULL,'1248996737780101122',2,2,'批量发送(20200411)','18372551198','18372551198','【晋江市人才服务平台】测试',1,NULL,'2020-04-11',NULL,NULL,NULL,'2020-04-11 23:30:02',NULL,NULL,NULL),('1249001512802287618',NULL,'1249001490723471362',2,2,'批量发送(20200411)','17362523273','17362523273','【晋江市人才服务平台】测试批量回调',3,'短信发送成功','2020-04-11',NULL,NULL,NULL,'2020-04-11 23:48:55',NULL,NULL,NULL),('1249001512835842050',NULL,'1249001490723471362',2,2,'批量发送(20200411)','18372551198','18372551198','【晋江市人才服务平台】测试批量回调',3,'短信发送成功','2020-04-11',NULL,NULL,NULL,'2020-04-11 23:48:55',NULL,NULL,NULL),('1249501490716966914',NULL,'1249501469309239298',2,2,'批量发送(20200413)','17362523273','17362523273','【晋江市人才服务平台】测试，发送短信时可能需要等待回执，千万不要多次点击',3,'短信发送成功','2020-04-13',NULL,NULL,NULL,'2020-04-13 08:55:39',NULL,NULL,NULL),('1249501490721161217',NULL,'1249501469309239298',2,2,'批量发送(20200413)','15280619456','15280619456','【晋江市人才服务平台】测试，发送短信时可能需要等待回执，千万不要多次点击',3,'短信发送成功','2020-04-13',NULL,NULL,NULL,'2020-04-13 08:55:39',NULL,NULL,NULL),('1249629889976434689',NULL,'1249629889976434689',2,1,NULL,'18859987377','981053','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-13',NULL,NULL,NULL,'2020-04-13 17:25:57',NULL,NULL,NULL),('1250707719757856770',NULL,'1250707719757856770',2,1,NULL,'15905970382','634404','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-16',NULL,NULL,NULL,'2020-04-16 16:48:52',NULL,NULL,NULL),('1251356261195284481',NULL,'1251356261195284481',2,1,NULL,'13400713011','518595','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-18',NULL,NULL,NULL,'2020-04-18 11:45:56',NULL,NULL,NULL),('1251356829624139777',NULL,'1251356829624139777',2,1,NULL,'18965121148','555451','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-18',NULL,NULL,NULL,'2020-04-18 11:48:11',NULL,NULL,NULL),('1252428844137283586','83','1252428844137283586',1,2,'李女元','15359825666','10,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-21',NULL,NULL,NULL,'2020-04-21 10:48:00',NULL,NULL,NULL),('1252428844586074114','84','1252428844586074114',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-21',NULL,NULL,NULL,'2020-04-21 10:48:00',NULL,NULL,NULL),('1252428844850315265','86','1252428844850315265',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-21',NULL,NULL,NULL,'2020-04-21 10:48:00',NULL,NULL,NULL),('1252510432661438465',NULL,'1252510432661438465',2,1,NULL,'13959989905','557176','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-21',NULL,NULL,NULL,'2020-04-21 16:12:12',NULL,NULL,NULL),('1252764052761968641','83','1252764052761968641',1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-22',NULL,NULL,NULL,'2020-04-22 09:00:00',NULL,NULL,NULL),('1252764053282062337','84','1252764053282062337',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-22',NULL,NULL,NULL,'2020-04-22 09:00:00',NULL,NULL,NULL),('1252764053475000321','86','1252764053475000321',1,2,'洪嘉靖','13600737303','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-22',NULL,NULL,NULL,'2020-04-22 09:00:00',NULL,NULL,NULL),('1253126440631762945','83','1253126440631762945',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-23',NULL,NULL,NULL,'2020-04-23 09:00:00',NULL,NULL,NULL),('1253126441181216769','84','1253126441181216769',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-23',NULL,NULL,NULL,'2020-04-23 09:00:00',NULL,NULL,NULL),('1253130305297022978',NULL,'1253130305297022978',2,1,NULL,'13959989905','592388','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-23',NULL,NULL,NULL,'2020-04-23 09:15:21',NULL,NULL,NULL),('1253167619503128578','1214461743938473985','1253167619503128578',2,2,'福建七匹狼集团有限公司','13859769696','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-04-23',NULL,NULL,NULL,'2020-04-23 11:43:37',NULL,NULL,NULL),('1253488828350562306','83','1253488828350562306',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-24',NULL,NULL,NULL,'2020-04-24 09:00:00',NULL,NULL,NULL),('1253488828828712962','84','1253488828828712962',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-24',NULL,NULL,NULL,'2020-04-24 09:00:00',NULL,NULL,NULL),('1253585861493227522',NULL,'1253585861493227522',2,1,NULL,'18695659900','225613','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-04-24',NULL,NULL,NULL,'2020-04-24 15:25:34',NULL,NULL,NULL),('1254575992043831297','83','1254575992043831297',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-27',NULL,NULL,NULL,'2020-04-27 09:00:00',NULL,NULL,NULL),('1254575993016909826','84','1254575993016909826',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-27',NULL,NULL,NULL,'2020-04-27 09:00:00',NULL,NULL,NULL),('1254938379951374338','83','1254938379951374338',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-28',NULL,NULL,NULL,'2020-04-28 09:00:00',NULL,NULL,NULL),('1254938381960445954','84','1254938381960445954',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-28',NULL,NULL,NULL,'2020-04-28 09:00:00',NULL,NULL,NULL),('1255300767699533825','83','1255300767699533825',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-29',NULL,NULL,NULL,'2020-04-29 09:00:00',NULL,NULL,NULL),('1255300768215433217','84','1255300768215433217',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-29',NULL,NULL,NULL,'2020-04-29 09:00:00',NULL,NULL,NULL),('1255663155665797122','83','1255663155665797122',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-30',NULL,NULL,NULL,'2020-04-30 09:00:00',NULL,NULL,NULL),('1255663156223639554','84','1255663156223639554',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-04-30',NULL,NULL,NULL,'2020-04-30 09:00:00',NULL,NULL,NULL),('1256025543959175170','91','1256025543959175170',1,2,'吴晓婷','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543959175171','91','1256025543959175171',1,2,'吴晓婷','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543959175172','83','1256025543959175172',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1256025544831590401','58','1256025544831590401',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1256025544831590402','84','1256025544831590402',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1256025544831590403','58','1256025544831590403',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1256025545100025858','87','1256025545100025858',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1256025545137774594','87','1256025545137774594',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-01 09:00:00',NULL,NULL,NULL),('1257112707149127682','83','1257112707149127682',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707174293505','91','1257112707174293505',1,2,'吴晓婷','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707212042241','91','1257112707212042241',1,2,'吴晓婷','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707836993537','58','1257112707836993537',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707836993538','84','1257112707836993538',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707870547969','58','1257112707870547969',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257112708113817602','87','1257112708113817602',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257112708264812545','87','1257112708264812545',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-04 09:00:00',NULL,NULL,NULL),('1257475094985367559','91','1257475094985367559',1,2,'吴晓婷','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257475095039893505','83','1257475095039893505',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257475095039893506','91','1257475095039893506',1,2,'吴晓婷','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257475095425769473','58','1257475095425769473',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257475095450935297','58','1257475095450935297',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257475095547404290','84','1257475095547404290',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257475095643873281','87','1257475095643873281',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257475097418063874','87','1257475097418063874',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-05 09:00:00',NULL,NULL,NULL),('1257837482829996034','83','1257837482829996034',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482834190338','91','1257837482834190338',1,2,'吴晓婷','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482838384641','91','1257837482838384641',1,2,'吴晓婷','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257837483266203649','58','1257837483266203649',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257837483274592258','84','1257837483274592258',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257837483345895426','58','1257837483345895426',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257837483517861890','87','1257837483517861890',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257837483597553666','87','1257837483597553666',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-06 09:00:00',NULL,NULL,NULL),('1257863205787590657','1240815404952129537','1257863205787590657',2,2,'达狮雄（集团）福建有限公司','13559568461','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-29 10:42:00',NULL,NULL,NULL,'2020-05-06 10:42:12',NULL,NULL,NULL),('1257863511346831361','1241570456415309825','1257863511346831361',2,2,'晋江中海汽车销售服务有限公司','13960252008','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2019-12-29 10:43:00',NULL,NULL,NULL,'2020-05-06 10:43:25',NULL,NULL,NULL),('1257865252020740098','1245615593177055233','1257865252020740098',2,2,'晋江市新迪新材料科技有限公司','13950287905','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-29 10:50:00',NULL,NULL,NULL,'2020-05-06 10:50:20',NULL,NULL,NULL),('1257866029191716865','1249630370077442050','1257866029191716865',2,2,'晋江市凯嘉机器制造有限公司','18859987377','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-29 10:53:00',NULL,NULL,NULL,'2020-05-06 10:53:26',NULL,NULL,NULL),('1257867500285124609','1252510490651885569','1257867500285124609',2,2,'鸿坤卓越（广州）财富管理有限公司晋江分公司','13959989905','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-29 10:59:00',NULL,NULL,NULL,'2020-05-06 10:59:16',NULL,NULL,NULL),('1257869654454493186','1253585948415983617','1257869654454493186',2,2,'晋江龙湖晋嘉置业有限公司','18695659900','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2019-12-29 11:07:00',NULL,NULL,NULL,'2020-05-06 11:07:50',NULL,NULL,NULL),('1258199870657847298','83','1258199870657847298',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870670430209','91','1258199870670430209',1,2,'吴晓婷','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870708178946','91','1258199870708178946',1,2,'吴晓婷','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870993391618','84','1258199870993391618',1,2,' 洪全益','13808555296','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258199871094054913','58','1258199871094054913',1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258199871094054914','58','1258199871094054914',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258199871266021378','87','1258199871266021378',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258199871270215682','87','1258199871270215682',1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2019-12-29 09:00:00',NULL,NULL,NULL,'2020-05-07 09:00:00',NULL,NULL,NULL),('1258203278643093505',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13906095618','13906095618','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278647287810',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18250298076','18250298076','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278651482113',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905089190','13905089190','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278651482114',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18965689935','18965689935','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278651482115',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15059792958','15059792958','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278651482116',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18159826888','18159826888','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278655676418',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15906092370','15906092370','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278655676419',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13044554499','13044554499','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278655676420',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18350782990','18350782990','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278655676421',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905974002','13905974002','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278655676422',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13808505006','13808505006','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278659870722',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959995535','15959995535','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278659870723',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15659878695','15659878695','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278659870724',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15106088998','15106088998','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278659870725',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13144828970','13144828970','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278659870726',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13305088921','13305088921','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278664065025',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15559162475','15559162475','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278664065026',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13799766670','13799766670','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278664065027',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18815985118','18815985118','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278664065028',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13626072564','13626072564','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278664065029',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15359996305','15359996305','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278668259329',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599717008','13599717008','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278668259330',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15995216889','15995216889','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278668259331',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13959778888','13959778888','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278668259332',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905968151','13905968151','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278668259333',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15060626155','15060626155','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278668259334',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18567651331','18567651331','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',2,'联通停机或关机,个别情况与手机信号不稳定导致.','2020-05-07',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278672453633',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18275745728','18275745728','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278672453634',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15086777305','15086777305','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',2,'停机','2020-05-07',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278672453635',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18850528121','18850528121','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278672453636',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17689683160','17689683160','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278706008066',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18859757759','18859757759','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278710202370',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505957512','13505957512','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278710202371',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18900371513','18900371513','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278714396674',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18959707235','18959707235','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278714396675',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13788829369','13788829369','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278714396676',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13794913769','13794913769','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278714396677',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960207400','13960207400','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278714396678',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17750103317','17750103317','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278718590978',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18959706230','18959706230','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278718590979',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15622174598','15622174598','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278718590980',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13506003686','13506003686','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278718590981',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15359585555','15359585555','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278718590982',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13027105101','13027105101','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278722785282',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17758709290','17758709290','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278722785283',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15906067008','15906067008','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278722785284',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15060456431','15060456431','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278722785285',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18796922940','18796922940','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278722785286',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13325253201','13325253201','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278726979586',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17706075999','17706075999','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278726979587',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13665987766','13665987766','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278726979588',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17759991213','17759991213','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278726979589',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18262283166','18262283166','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278726979590',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15059719567','15059719567','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278726979591',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15359490818','15359490818','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278731173890',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15980000660','15980000660','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278731173891',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15080318157','15080318157','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278731173892',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13860752060','13860752060','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278731173893',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18759552098','18759552098','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278731173894',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18259591998','18259591998','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278735368193',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18250850010','18250850010','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278764728321',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959590927','15959590927','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278768922626',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18065606507','18065606507','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278768922627',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15759496852','15759496852','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278768922628',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905950588','13905950588','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278768922629',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959505915','15959505915','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278773116929',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505932929','13505932929','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278773116930',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13626066721','13626066721','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278773116931',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13675998353','13675998353','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278773116932',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18859951871','18859951871','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278773116933',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15860902967','15860902967','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278777311233',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13067154015','13067154015','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278777311234',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18959708032','18959708032','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278777311235',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599145737','13599145737','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:27:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278777311236',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13484917236','13484917236','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278777311237',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18659719331','18659719331','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278777311238',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13559054268','13559054268','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278781505537',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13328989299','13328989299','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278781505538',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15260704530','15260704530','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278781505539',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15059821270','15059821270','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278781505540',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18959906506','18959906506','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278781505541',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18603006276','18603006276','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278785699842',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18965689711','18965689711','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278785699843',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960311095','13960311095','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278785699844',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13256678813','13256678813','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278785699845',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15905050688','15905050688','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278785699846',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959996599','15959996599','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278785699847',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959556399','15959556399','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278789894145',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13860190418','13860190418','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278789894146',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18659262866','18659262866','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278789894147',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599921781','13599921781','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278815059970',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13799898116','13799898116','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278819254273',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15805010196','15805010196','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278823448578',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13906998897','13906998897','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278823448579',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13696900561','13696900561','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278823448580',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17750891999','17750891999','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278827642882',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15905092171','15905092171','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278827642883',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15759653345','15759653345','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278827642884',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18960353905','18960353905','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278831837186',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18046311397','18046311397','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278831837187',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15880911717','15880911717','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278831837188',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15029236362','15029236362','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278836031489',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13950238890','13950238890','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278836031490',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599936037','13599936037','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278836031491',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13720852551','13720852551','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278840225794',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13600738975','13600738975','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278840225795',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599127767','13599127767','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278840225796',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18959706253','18959706253','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278844420098',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15060832111','15060832111','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278844420099',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18350770057','18350770057','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278844420100',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15860381909','15860381909','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278844420101',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15623564761','15623564761','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278844420102',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13859754633','13859754633','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278844420103',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13506941213','13506941213','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278848614401',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17706067083','17706067083','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278848614402',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15980036243','15980036243','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278848614403',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15559133531','15559133531','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278848614404',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18905953233','18905953233','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278848614405',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','19859573633','19859573633','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278848614406',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13489403314','13489403314','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278852808706',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15260875781','15260875781','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278877974530',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18059993901','18059993901','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278882168834',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15759876282','15759876282','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278882168835',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13313880008','13313880008','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278882168836',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13615940087','13615940087','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278886363138',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15059557916','15059557916','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278886363139',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13950108669','13950108669','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278886363140',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13850728390','13850728390','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278886363141',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18957137209','18957137209','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278886363142',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13850755588','13850755588','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278886363143',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13959910000','13959910000','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278890557441',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15880881006','15880881006','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278890557442',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15860396396','15860396396','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278890557443',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13559592136','13559592136','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278890557444',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13559625390','13559625390','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278890557445',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15880881883','15880881883','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278890557446',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15260823192','15260823192','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278894751746',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959592127','15959592127','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278894751747',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959509673','15959509673','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278894751748',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18950026794','18950026794','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278894751749',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13706957817','13706957817','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278894751750',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13959798556','13959798556','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278894751751',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960292725','13960292725','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278898946050',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13649278723','13649278723','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278898946051',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15260101691','15260101691','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278898946052',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13859705235','13859705235','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278898946053',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13950299290','13950299290','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278898946054',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13606051571','13606051571','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278898946055',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13506066359','13506066359','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278903140354',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505942660','13505942660','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278903140355',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18659281177','18659281177','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278928306177',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13600703472','13600703472','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278932500481',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505943066','13505943066','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278932500482',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13405350771','13405350771','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',2,'空号','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278932500483',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15985923093','15985923093','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278932500484',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599766670','13599766670','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278936694785',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13863831087','13863831087','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278936694786',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17762027770','17762027770','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278936694787',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13700242731','13700242731','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278936694788',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505028679','13505028679','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278936694789',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13506062515','13506062515','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278936694790',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18750597755','18750597755','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278940889089',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13615922291','13615922291','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278940889090',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13520554703','13520554703','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278940889091',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15860351538','15860351538','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278940889092',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13405353771','13405353771','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278940889093',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15880719513','15880719513','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278940889094',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18605001313','18605001313','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278945083394',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15059543210','15059543210','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278945083395',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905055766','13905055766','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278945083396',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15060985107','15060985107','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278945083397',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13860143467','13860143467','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278945083398',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18950070276','18950070276','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278945083399',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18106968679','18106968679','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278949277697',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15859231310','15859231310','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278949277698',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15080345751','15080345751','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278949277699',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15059570222','15059570222','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278949277700',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13959955966','13959955966','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278949277701',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15960581457','15960581457','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',2,'空号','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278953472002',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15059830121','15059830121','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278953472003',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18050020726','18050020726','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278978637825',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18876291470','18876291470','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278978637826',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18965483880','18965483880','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278982832130',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13805956092','13805956092','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278982832131',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15880754887','15880754887','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278982832132',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13689056004','13689056004','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278982832133',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15711502057','15711502057','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278982832134',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13459523099','13459523099','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278982832135',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13950063837','13950063837','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278987026434',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13959280218','13959280218','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:14:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278987026435',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13788814546','13788814546','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278987026436',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15980301999','15980301999','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278987026437',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18722334354','18722334354','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278987026438',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18202655266','18202655266','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278991220737',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959264462','15959264462','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278991220738',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960826248','13960826248','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278991220739',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18659069495','18659069495','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278991220740',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599954300','13599954300','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278991220741',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13105060008','13105060008','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278991220742',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18859716793','18859716793','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278991220743',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13808505910','13808505910','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278995415041',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15880480928','15880480928','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278995415042',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15505950959','15505950959','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278995415043',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15205972628','15205972628','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278995415044',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13666029324','13666029324','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278995415045',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599978051','13599978051','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278995415046',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505959355','13505959355','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278999609345',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13906099550','13906099550','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278999609346',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18876568900','18876568900','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278999609347',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18605007853','18605007853','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203278999609348',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15159871537','15159871537','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279024775170',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15906005715','15906005715','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279028969474',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18606942212','18606942212','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279028969475',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18817333998','18817333998','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279028969476',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15159832652','15159832652','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279028969477',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18750914154','18750914154','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279033163778',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960455227','13960455227','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279033163779',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960270097','13960270097','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279033163780',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13799758056','13799758056','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279033163781',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13808525056','13808525056','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279033163782',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18965175339','18965175339','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279037358081',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905059909','13905059909','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279037358082',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13806969722','13806969722','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279037358083',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13950989318','13950989318','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279037358084',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13636928198','13636928198','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279037358085',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18106930966','18106930966','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279037358086',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13808558181','13808558181','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279041552386',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905075757','13905075757','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279041552387',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13905079280','13905079280','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279041552388',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13808505732','13808505732','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279041552389',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15905022650','15905022650','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279041552390',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18750207251','18750207251','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279041552391',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13599177919','13599177919','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279045746690',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13242884288','13242884288','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279045746691',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15710646360','15710646360','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279045746692',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15805972719','15805972719','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279045746693',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13788828099','13788828099','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279045746694',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505977599','13505977599','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279045746695',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18016516089','18016516089','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279049940993',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18659516267','18659516267','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279049940994',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15280871258','15280871258','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279087689730',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13489875197','13489875197','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279091884033',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505956777','13505956777','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279091884034',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960256111','13960256111','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279096078337',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959853522','15959853522','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279096078338',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959525859','15959525859','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279096078339',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13489545332','13489545332','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279096078340',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13788826386','13788826386','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279096078341',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18965667777','18965667777','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279096078342',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13489512136','13489512136','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279100272641',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13400507028','13400507028','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279100272642',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13587756546','13587756546','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279100272643',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18659916888','18659916888','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279100272644',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18859525583','18859525583','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279100272645',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13215066449','13215066449','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279104466946',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13975057391','13975057391','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279104466947',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13505902557','13505902557','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279104466948',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13805957070','13805957070','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279104466949',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13960358840','13960358840','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279104466950',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18350742084','18350742084','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279108661250',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13600788662','13600788662','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279108661251',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15880939936','15880939936','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279108661252',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13365952758','13365952758','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279108661253',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13918199745','13918199745','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279108661254',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13906099845','13906099845','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279108661255',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15559050207','15559050207','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279112855553',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13805145645','13805145645','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279112855554',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13959992226','13959992226','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279112855555',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18750561717','18750561717','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279112855556',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13646022408','13646022408','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279112855557',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15959595731','15959595731','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279146409985',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13600703996','13600703996','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279150604290',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13710228756','13710228756','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279150604291',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15859506299','15859506299','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279154798593',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13306051592','13306051592','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279154798594',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','15280081010','15280081010','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279154798595',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','17683234600','17683234600','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279154798596',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13459218283','13459218283','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279158992898',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13107891508','13107891508','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279158992899',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13600770238','13600770238','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279158992900',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13400886486','13400886486','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279163187201',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18050877288','18050877288','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279163187202',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13799866661','13799866661','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279163187203',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','13850751502','13850751502','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203279167381506',NULL,'1258203278156554241',2,2,'批量发送(晋江市优秀人才申报系统重新开放补件的通知20200507)','18805065856','18805065856','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:13:00',NULL,NULL,NULL,'2020-05-07 09:13:32',NULL,NULL,NULL),('1258203642075340801',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13295959911','13295959911','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729410',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15160330306','15160330306','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729411',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','18859555816','18859555816','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729412',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13599218888','13599218888','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729413',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13107872929','13107872929','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729414',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13905051776','13905051776','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729415',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15060011828','15060011828','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729416',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13905953818','13905953818','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729417',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15159518618','15159518618','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642083729418',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','18805959777','18805959777','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642087923714',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','18959210622','18959210622','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642087923715',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15860304280','15860304280','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642087923716',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','18859920423','18859920423','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642087923717',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15959507666','15959507666','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642087923718',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13625958406','13625958406','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642087923719',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','18859933999','18859933999','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642087923720',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15375708923','15375708923','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642092118018',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13205957447','13205957447','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642092118019',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15905975168','15905975168','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642092118020',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','13960228853','13960228853','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258203642092118021',NULL,'1258203641785933825',2,2,'批量发送(晋江市优秀人才申报系统重新开放的通知20200507)','15759877981','15759877981','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:15:00',NULL,NULL,NULL,'2020-05-07 09:14:59',NULL,NULL,NULL),('1258204951818067969',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15759732363','15759732363','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951826456578',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13799553654','13799553654','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951826456579',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13788825810','13788825810','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951830650881',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15859799211','15859799211','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951830650882',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18959210622','18959210622','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951830650883',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13520554703','13520554703','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951830650884',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15959556399','15959556399','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951830650885',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13799766670','13799766670','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951830650886',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15102155779','15102155779','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951834845186',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15980473561','15980473561','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951834845187',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18859971221','18859971221','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951834845188',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15859813817','15859813817','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951834845189',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13506060342','13506060342','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951834845190',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15059821270','15059821270','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951834845191',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18350770050','18350770050','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951839039489',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18965689935','18965689935','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951839039490',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18159338867','18159338867','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951839039491',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13505004167','13505004167','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951839039492',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13615901213','13615901213','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951839039493',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13788809209','13788809209','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951843233794',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','17362523273','17362523273','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951843233795',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15960789678','15960789678','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951843233796',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18876509838','18876509838','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951843233797',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18659518160','18659518160','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951843233798',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13599749329','13599749329','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951843233799',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13506061626','13506061626','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951847428097',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18060007601','18060007601','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951847428098',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15980788802','15980788802','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951847428099',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13559054268','13559054268','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951847428100',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15280796970','15280796970','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951847428101',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15059528886','15059528886','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 10:26:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951876788226',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13665929319','13665929319','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951880982530',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13959757688','13959757688','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951880982531',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13625976298','13625976298','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951880982532',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13799233113','13799233113','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951885176834',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','137888000470','137888000470','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',2,'错误的电话号码','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951885176835',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13905089190','13905089190','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951885176836',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','17350926157','17350926157','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951885176837',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13805992036','13805992036','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951885176838',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18350062033','18350062033','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951885176839',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15960778794','15960778794','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951889371137',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15959420909','15959420909','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951889371138',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13599701057','13599701057','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951889371139',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15160330306','15160330306','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951889371140',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13675959528','13675959528','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951889371141',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','17359269810','17359269810','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951893565442',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13509362773','13509362773','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951893565443',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13788829369','13788829369','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951893565444',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13860758785','13860758785','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951893565445',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','17759990690','17759990690','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951893565446',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13580701185','13580701185','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951893565447',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13959717808','13959717808','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',2,'黑名单','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951893565448',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18120662230','18120662230','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951897759745',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13675998353','13675998353','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951897759746',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13788808205','13788808205','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951897759747',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15359991222','15359991222','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951897759748',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13599295908','13599295908','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951897759749',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18698387555','18698387555','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951897759750',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18900370886','18900370886','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951901954050',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15959501581','15959501581','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951901954051',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15059830121','15059830121','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951927119874',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15159832652','15159832652','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951927119875',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15960586523','15960586523','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951931314178',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13599145737','13599145737','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:27:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951931314179',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15750998817','15750998817','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951931314180',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18759552098','18759552098','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951931314181',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18606984919','18606984919','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951931314182',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13960496669','13960496669','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-07',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951931314183',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15059570222','15059570222','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951935508482',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','17758709290','17758709290','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951935508483',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15905054477','15905054477','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951935508484',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13665987766','13665987766','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951935508485',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13808516919','13808516919','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951935508486',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','17706075999','17706075999','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951935508487',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18259591998','18259591998','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951939702786',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','19905050771','19905050771','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951939702787',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15905970382','15905970382','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951939702788',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18106990767','18106990767','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951939702789',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13960315655','13960315655','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951939702790',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13328567990','13328567990','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951939702791',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18759442340','18759442340','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951939702792',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13950116705','13950116705','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951943897089',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18859951871','18859951871','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951943897090',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','19959711592','19959711592','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951943897091',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13859769696','13859769696','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951943897092',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13599936037','13599936037','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951943897093',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15960694893','15960694893','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951943897094',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13489719977','13489719977','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951943897095',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15060933526','15060933526','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951948091393',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18905953233','18905953233','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951948091394',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15980228632','15980228632','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951973257218',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18350528526','18350528526','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951977451521',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15559133531','15559133531','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951977451522',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13950238890','13950238890','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951977451523',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13489387611','13489387611','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951977451524',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15805972719','15805972719','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951977451525',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13506062515','13506062515','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951977451526',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13599766670','13599766670','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951977451527',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18072769019','18072769019','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951981645825',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13905055766','13905055766','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951981645826',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13030990915','13030990915','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951981645827',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15160050023','15160050023','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951981645828',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15880881006','15880881006','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951981645829',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13599718877','13599718877','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951981645830',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18559780403','18559780403','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 17:04:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951981645831',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13959955966','13959955966','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951985840129',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','17305060050','17305060050','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951985840130',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18850018674','18850018674','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951985840131',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13799855086','13799855086','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951985840132',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18016516089','18016516089','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951985840133',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15396395062','15396395062','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951985840134',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18159581122','18159581122','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951985840135',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13489875197','13489875197','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951990034434',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13850752082','13850752082','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951990034435',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13859776052','13859776052','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951990034436',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15960788001','15960788001','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951990034437',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15259513222','15259513222','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951990034438',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13365952758','13365952758','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951990034439',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15375886386','15375886386','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951990034440',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18259038660','18259038660','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204951994228738',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13960358840','13960358840','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952019394562',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15959595731','15959595731','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952019394563',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','15859506299','15859506299','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952019394564',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18750561717','18750561717','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952023588866',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13959992226','13959992226','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952023588867',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18050881166','18050881166','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952023588868',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13306051592','13306051592','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952023588869',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13600770238','13600770238','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952023588870',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','13850751502','13850751502','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258204952023588871',NULL,'1258204951318945794',2,2,'批量发送(关于晋江优秀人才系统重新开放补件的通知20200507)','18050877288','18050877288','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:20:00',NULL,NULL,NULL,'2020-05-07 09:20:11',NULL,NULL,NULL),('1258205177278685185',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','18959210622','18959210622','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177278685186',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13295959911','13295959911','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177282879489',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13625958406','13625958406','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177282879490',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','18250413746','18250413746','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177282879491',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13599218888','13599218888','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177282879492',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','18120662230','18120662230','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177282879493',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','15396486268','15396486268','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177282879494',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','15359382970','15359382970','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177287073794',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13625952299','13625952299','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177287073795',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13960496669','13960496669','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-07',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177287073796',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13505925273','13505925273','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177287073797',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','17750792370','17750792370','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177287073798',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13959713700','13959713700','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177287073799',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','15860304280','15860304280','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177287073800',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13859210956','13859210956','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177291268098',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','18350599665','18350599665','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177291268099',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','17350937795','17350937795','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177291268100',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13559592263','13559592263','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177291268101',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13898810920','13898810920','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177291268102',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','15905975168','15905975168','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:21:00',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258205177291268103',NULL,'1258205176997666818',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13960228853\n','13960228853\n','【晋江市人才服务平台】尊敬的各用人单位人才联络员：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各用人单位抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',1,NULL,'2020-05-07',NULL,NULL,NULL,'2020-05-07 09:21:05',NULL,NULL,NULL),('1258213635755401217',NULL,'1258213635755401217',2,1,NULL,'13030990915','486048','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 09:54:00',NULL,NULL,NULL,'2020-05-07 09:54:41',NULL,NULL,NULL),('1258214330197925890',NULL,'1258214329900130305',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','15191577654','15191577654','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:57:00',NULL,NULL,NULL,'2020-05-07 09:57:27',NULL,NULL,NULL),('1258214330197925891',NULL,'1258214329900130305',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13159060909','13159060909','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:57:00',NULL,NULL,NULL,'2020-05-07 09:57:27',NULL,NULL,NULL),('1258214330197925892',NULL,'1258214329900130305',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','15959994811','15959994811','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:57:00',NULL,NULL,NULL,'2020-05-07 09:57:27',NULL,NULL,NULL),('1258214330197925893',NULL,'1258214329900130305',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','15906066000','15906066000','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:57:00',NULL,NULL,NULL,'2020-05-07 09:57:27',NULL,NULL,NULL),('1258214330197925894',NULL,'1258214329900130305',2,2,'批量发送(关于晋江市优秀人才申报系统重新开放补件的通知20200507)','13636995533','13636995533','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2019-12-29 09:57:00',NULL,NULL,NULL,'2020-05-07 09:57:27',NULL,NULL,NULL),('1258216474548428801',NULL,'1258216474548428801',2,1,NULL,'13030990915','969721','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 10:06:00',NULL,NULL,NULL,'2020-05-07 10:05:58',NULL,NULL,NULL),('1258323271439409153',NULL,'1258323271439409153',2,1,NULL,'13960256299','065402','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 17:10:00',NULL,NULL,NULL,'2020-05-07 17:10:21',NULL,NULL,NULL),('1258323768074362881',NULL,'1258323768074362881',2,1,NULL,'13960256299','795063','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 17:12:00',NULL,NULL,NULL,'2020-05-07 17:12:19',NULL,NULL,NULL),('1258324095448178689',NULL,'1258324095448178689',2,1,NULL,'13960256299','393370','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 17:13:00',NULL,NULL,NULL,'2020-05-07 17:13:37',NULL,NULL,NULL),('1258326472750325762',NULL,'1258326472750325762',2,1,NULL,'13960256299','171781','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 17:23:00',NULL,NULL,NULL,'2020-05-07 17:23:04',NULL,NULL,NULL),('1258327095545749505',NULL,'1258327095545749505',2,1,NULL,'13960256299','943295','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 17:25:00',NULL,NULL,NULL,'2020-05-07 17:25:32',NULL,NULL,NULL),('1258327371967160321',NULL,'1258327371967160321',2,1,NULL,'13960256299','127134','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2019-12-29 17:26:00',NULL,NULL,NULL,'2020-05-07 17:26:38',NULL,NULL,NULL),('1258562259135787009','83','1258562259135787009',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259135787010','91','1258562259135787010',1,2,'吴晓婷','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259135787011','91','1258562259135787011',1,2,'吴晓婷','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259802681346','58','1258562259802681346',1,2,'张荣荣','15280619456','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259811069953','58','1258562259811069953',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 09:00:00',NULL,NULL,NULL),('1258562260029173761','87','1258562260029173761',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 09:00:00',NULL,NULL,NULL),('1258562260066922498','87','1258562260066922498',1,2,'叶志钦','13675957398','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 09:00:00',NULL,NULL,NULL),('1258619195759816705',NULL,'1258619195759816705',2,1,NULL,'13905051776','549406','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 12:46:14',NULL,NULL,NULL),('1258620805735018498',NULL,'1258620805735018498',2,1,NULL,'13905051776','434288','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 12:52:38',NULL,NULL,NULL),('1258621084006117377',NULL,'1258621084006117377',2,1,NULL,'13905051776','533416','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 12:53:45',NULL,NULL,NULL),('1258652334267854849',NULL,'1258652334267854849',2,1,NULL,'13625952299','887313','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-08',NULL,NULL,NULL,'2020-05-08 14:57:55',NULL,NULL,NULL),('1259025134732247042',NULL,'1259025134732247042',2,1,NULL,'18959859775','217753','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-09',NULL,NULL,NULL,'2020-05-09 15:39:18',NULL,NULL,NULL),('1259032059599454209',NULL,'1259032059599454209',2,1,NULL,'18959859775','681745','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-09',NULL,NULL,NULL,'2020-05-09 16:06:49',NULL,NULL,NULL),('1259051439548858370',NULL,'1259051439548858370',2,1,NULL,'15860018012','547580','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-09',NULL,NULL,NULL,'2020-05-09 17:23:49',NULL,NULL,NULL),('1259384988546170881',NULL,'1259384988546170881',2,1,NULL,'13960358840','248932','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 15:29:14',NULL,NULL,NULL),('1259385280738164737',NULL,'1259385280738164737',2,1,NULL,'13960358840','165675','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 15:30:23',NULL,NULL,NULL),('1259385538633334785',NULL,'1259385538633334785',2,1,NULL,'13960358840','067221','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 15:31:25',NULL,NULL,NULL),('1259385819953692673',NULL,'1259385819953692673',2,1,NULL,'13960358840','894770','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 15:32:32',NULL,NULL,NULL),('1259386092549898241',NULL,'1259386092549898241',2,1,NULL,'13960358840','037104','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 15:33:37',NULL,NULL,NULL),('1259386369495597058',NULL,'1259386369495597058',2,1,NULL,'13960358840','540483','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 15:34:43',NULL,NULL,NULL),('1259446764377800706',NULL,'1259446764377800706',2,1,NULL,'15960567183','249815','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 19:34:42',NULL,NULL,NULL),('1259448262956482562',NULL,'1259448262956482562',2,1,NULL,'15960567183','540330','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-10',NULL,NULL,NULL,'2020-05-10 19:40:39',NULL,NULL,NULL),('1259661028522786817','1211442194934710274','1259661028522786817',2,2,'信泰（福建）科技有限公司','15659222652','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-05-11',NULL,NULL,NULL,'2020-05-11 09:46:07',NULL,NULL,NULL),('1259777961750495233',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','18876509838','18876509838','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961763078145',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','13505905685','13505905685','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961763078146',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','13850755588','13850755588','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961763078147',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','18850547191','18850547191','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961767272449',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','13599212929','13599212929','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961767272450',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','15860901713','15860901713','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961767272451',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','18359592597','18359592597','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961767272452',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','13505957512','13505957512','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1259777961767272453',NULL,'1259777961339453441',2,2,'批量发送(关于晋江市优秀人才申报系统补充提交材料的通知20200511)','13600703555','13600703555','【晋江市人才服务平台】尊敬的各2019年度晋江市优秀人才认定申报对象：现晋江市优秀人才申报系统已重新开放，请符合2019年度晋江市优秀人才认定申报条件但未重新补齐材料的各申报对象及时与人才联络员联系，登录申报系统查看审核状态及操作日志的审核意见，抓紧时间提交材料，补件时间截止至2020年5月13 日(下周三)17:30，逾期将不予认定为2019年度晋江市优秀人才，谢谢！',3,'短信发送成功','2020-05-11 17:30:46',NULL,NULL,NULL,'2020-05-11 17:30:46',NULL,NULL,NULL),('1260472361447108610',NULL,'1260472361447108610',2,1,NULL,'18359797834','093754','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-13',NULL,NULL,NULL,'2020-05-13 15:30:04',NULL,NULL,NULL),('1260474314818367489',NULL,'1260474314818367489',2,1,NULL,'18359797834','348154','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-13',NULL,NULL,NULL,'2020-05-13 15:37:49',NULL,NULL,NULL),('1261201403708223490',NULL,'1261201403708223490',2,1,NULL,'15359825666','910633','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-15',NULL,NULL,NULL,'2020-05-15 15:47:01',NULL,NULL,NULL),('1261207573974003714',NULL,'1261207573974003714',2,1,NULL,'15359825666','129470','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-15',NULL,NULL,NULL,'2020-05-15 16:11:32',NULL,NULL,NULL),('1261223467173326850',NULL,'1261223467173326850',2,1,NULL,'15359825666','416698','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-15',NULL,NULL,NULL,'2020-05-15 17:14:41',NULL,NULL,NULL),('1261470740423684098',NULL,'1261470740423684098',2,1,NULL,'13860756932','713483','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-16',NULL,NULL,NULL,'2020-05-16 09:37:16',NULL,NULL,NULL),('1262286515602501634',NULL,'1262286515602501634',2,1,NULL,'15359825666','425268','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-18',NULL,NULL,NULL,'2020-05-18 15:38:52',NULL,NULL,NULL),('1262289814485512193',NULL,'1262289814485512193',2,1,NULL,'15359825666','612479','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-18',NULL,NULL,NULL,'2020-05-18 15:51:58',NULL,NULL,NULL),('1262552609361801218',NULL,'1262552609361801218',2,1,NULL,'13506025607','453202','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-19',NULL,NULL,NULL,'2020-05-19 09:16:13',NULL,NULL,NULL),('1262556410231697410',NULL,'1262556410231697410',2,1,NULL,'13506025607','138082','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-19',NULL,NULL,NULL,'2020-05-19 09:31:20',NULL,NULL,NULL),('1262954699737313282',NULL,'1262954699737313282',2,1,NULL,'13959888172','049209','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-20',NULL,NULL,NULL,'2020-05-20 11:53:59',NULL,NULL,NULL),('1262957224154673153',NULL,'1262957224154673153',2,1,NULL,'13959888172','249668','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-20',NULL,NULL,NULL,'2020-05-20 12:04:01',NULL,NULL,NULL),('1263017894703312897','1211444027140915202','1263017894703312897',2,2,'福建省万物智联科技有限公司','15659222652','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-05-20',NULL,NULL,NULL,'2020-05-20 16:05:06',NULL,NULL,NULL),('1263017998818521089','1212582208896831489','1263017998818521089',2,2,'泉州市丰预泰企业管理有限公司','13242884288','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-05-20',NULL,NULL,NULL,'2020-05-20 16:05:31',NULL,NULL,NULL),('1263278335258025985',NULL,'1263278335258025985',2,1,NULL,'18659518160','969046','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-21',NULL,NULL,NULL,'2020-05-21 09:20:00',NULL,NULL,NULL),('1263278809231155202',NULL,'1263278809231155202',2,1,NULL,'18659518160','195440','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-21',NULL,NULL,NULL,'2020-05-21 09:21:53',NULL,NULL,NULL),('1263279252690722818',NULL,'1263279252690722818',2,1,NULL,'18659518160','415967','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-21',NULL,NULL,NULL,'2020-05-21 09:23:39',NULL,NULL,NULL),('1263305177914433537','1262556491227901953','1263305177914433537',2,2,'晋江市博思企业管理咨询有限公司','13506025607','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-05-21',NULL,NULL,NULL,'2020-05-21 11:06:40',NULL,NULL,NULL),('1263635688918638594','91','1263635688918638594',1,2,'吴晓婷','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-22',NULL,NULL,NULL,'2020-05-22 09:00:00',NULL,NULL,NULL),('1263635689455509505','58','1263635689455509505',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-22',NULL,NULL,NULL,'2020-05-22 09:00:00',NULL,NULL,NULL),('1263635689937854466','87','1263635689937854466',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-22',NULL,NULL,NULL,'2020-05-22 09:00:00',NULL,NULL,NULL),('1263695372484632577',NULL,'1263695372484632577',2,1,NULL,'13505949993','844117','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-22',NULL,NULL,NULL,'2020-05-22 12:57:09',NULL,NULL,NULL),('1263697911582056450',NULL,'1263697911582056450',2,1,NULL,'13505949993','067313','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-22',NULL,NULL,NULL,'2020-05-22 13:07:15',NULL,NULL,NULL),('1263735206213345281',NULL,'1263735206213345281',2,1,NULL,'13860756932','512467','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-22',NULL,NULL,NULL,'2020-05-22 15:35:26',NULL,NULL,NULL),('1264722852238614529','91','1264722852238614529',1,2,'吴晓婷','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-25',NULL,NULL,NULL,'2020-05-25 09:00:00',NULL,NULL,NULL),('1264722852632879106','58','1264722852632879106',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-25',NULL,NULL,NULL,'2020-05-25 09:00:00',NULL,NULL,NULL),('1264722852867760129','87','1264722852867760129',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-25',NULL,NULL,NULL,'2020-05-25 09:00:00',NULL,NULL,NULL),('1264753130931773442',NULL,'1264753130931773442',2,1,NULL,'18050438239','930564','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-25',NULL,NULL,NULL,'2020-05-25 11:00:19',NULL,NULL,NULL),('1264754443665039361',NULL,'1264754443665039361',2,1,NULL,'18050438239','999190','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-25',NULL,NULL,NULL,'2020-05-25 11:05:32',NULL,NULL,NULL),('1265077256435294209',NULL,'1265077256435294209',2,1,NULL,'13205059567','644509','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-26',NULL,NULL,NULL,'2020-05-26 08:28:16',NULL,NULL,NULL),('1265085241538666497','91','1265085241538666497',1,2,'吴晓婷','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-26',NULL,NULL,NULL,'2020-05-26 09:00:00',NULL,NULL,NULL),('1265085245531643906','58','1265085245531643906',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-26',NULL,NULL,NULL,'2020-05-26 09:00:01',NULL,NULL,NULL),('1265085247775596546','87','1265085247775596546',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-26',NULL,NULL,NULL,'2020-05-26 09:00:01',NULL,NULL,NULL),('1265447628125003777','91','1265447628125003777',1,2,'吴晓婷','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-27',NULL,NULL,NULL,'2020-05-27 09:00:00',NULL,NULL,NULL),('1265447628645097474','58','1265447628645097474',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-27',NULL,NULL,NULL,'2020-05-27 09:00:00',NULL,NULL,NULL),('1265447628884172801','87','1265447628884172801',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-05-27',NULL,NULL,NULL,'2020-05-27 09:00:00',NULL,NULL,NULL),('1265524282465714178',NULL,'1265524282465714178',2,1,NULL,'19965412404','726306','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-27',NULL,NULL,NULL,'2020-05-27 14:04:35',NULL,NULL,NULL),('1265845319644479489',NULL,'1265845319644479489',2,1,NULL,'15359509870','012795','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-28',NULL,NULL,NULL,'2020-05-28 11:20:17',NULL,NULL,NULL),('1265846699746656257',NULL,'1265846699746656257',2,1,NULL,'15359509870','088897','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-28',NULL,NULL,NULL,'2020-05-28 11:25:46',NULL,NULL,NULL),('1266983467468455937',NULL,'1266983467468455937',2,1,NULL,'15880881006','455307','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-05-31',NULL,NULL,NULL,'2020-05-31 14:42:52',NULL,NULL,NULL),('1268358660359192578',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959858592','18959858592','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660371775490',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965129895','18965129895','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660371775491',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13255957226','13255957226','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1268358660371775492',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13666026522','13666026522','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660371775493',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13801333177','13801333177','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660375969793',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15106096021','15106096021','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660375969794',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959847128','18959847128','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660375969795',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13802609526','13802609526','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660375969796',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506086731','13506086731','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660375969797',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18016585576','18016585576','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660375969798',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959798579','15959798579','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660380164098',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859971221','18859971221','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660380164099',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18250298076','18250298076','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660380164100',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18065376686','18065376686','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660380164101',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15602265352','15602265352','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660380164102',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906099888','13906099888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660384358401',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13809549382','13809549382','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660384358402',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876509838','18876509838','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660384358403',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905070552','13905070552','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660384358404',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13705941428','13705941428','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660384358405',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15159878799','15159878799','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552706',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905089190','13905089190','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552707',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960381057','13960381057','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552708',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980788802','15980788802','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552709',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15985952242','15985952242','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552710',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13055808024','13055808024','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552711',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13950920100','13950920100','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552712',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13105079935','13105079935','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552713',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799966695','13799966695','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552714',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805032333','15805032333','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660388552715',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505080996','13505080996','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660443078657',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959705077','18959705077','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660447272962',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965689935','18965689935','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660447272963',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','19852121931','19852121931','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660447272964',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18960206656','18960206656','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660451467265',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880720190','15880720190','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660451467266',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15810812160','15810812160','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660451467267',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905975119','13905975119','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660451467268',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18960278086','18960278086','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660451467269',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18759429880','18759429880','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660455661569',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18609586661','18609586661','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660455661570',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13306995188','13306995188','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660455661571',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059792958','15059792958','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660455661572',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13305967663','13305967663','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660459855874',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13306995039','13306995039','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660459855875',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808510760','13808510760','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660459855876',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959896966','15959896966','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660459855877',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905952020','13905952020','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660459855878',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959995705','18959995705','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660459855879',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805957081','13805957081','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660464050178',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13559566696','13559566696','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660464050179',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859990000','18859990000','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660464050180',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860395678','15860395678','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660464050181',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980325929','15980325929','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660464050182',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859759601','15859759601','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660464050183',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805946193','13805946193','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660464050184',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13044554499','13044554499','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660468244482',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18006037555','18006037555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660468244483',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18350782990','18350782990','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660468244484',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506060342','13506060342','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660468244485',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788851759','13788851759','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660493410305',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13615901213','13615901213','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660497604609',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599212929','13599212929','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660497604610',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805021228','15805021228','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660501798913',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15750768536','15750768536','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660501798914',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506000615','13506000615','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660501798915',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905974006','13905974006','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660501798916',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13358591930','13358591930','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660501798917',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959995535','15959995535','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660501798918',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13559593361','13559593361','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660505993217',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960417367','13960417367','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660505993218',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599109151','13599109151','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660505993219',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15659878695','15659878695','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660505993220',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965689828','18965689828','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660505993221',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859969666','18859969666','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660505993222',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18960357668','18960357668','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660505993223',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260875883','15260875883','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660510187521',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15160423086','15160423086','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660510187522',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13705943966','13705943966','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660510187523',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15611255393','15611255393','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660510187524',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636963633','13636963633','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660510187525',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18721796963','18721796963','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660510187526',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13656038332','13656038332','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660510187527',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13675953607','13675953607','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660514381826',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959210622','18959210622','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660514381827',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805900098','13805900098','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660514381828',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859932277','18859932277','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660514381829',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15306089555','15306089555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660514381830',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905079361','15905079361','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660514381831',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18618285267','18618285267','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660514381832',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859799829','18859799829','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660539547650',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13337211223','13337211223','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660543741954',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600757303','13600757303','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660543741955',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13626072564','13626072564','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660543741956',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13615950806','13615950806','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660543741957',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906933286','13906933286','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660543741958',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18605958880','18605958880','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660547936257',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788846820','13788846820','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660547936258',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260782666','15260782666','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660547936259',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905985809','13905985809','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660547936260',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260803666','15260803666','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660552130562',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659030309','18659030309','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660552130563',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805919195','13805919195','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660552130564',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15392288855','15392288855','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660552130565',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600754180','13600754180','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660556324866',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17689485050','17689485050','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660556324867',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880785555','15880785555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660556324868',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15960692650','15960692650','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660556324869',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599780560','13599780560','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660560519169',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15259571333','15259571333','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660560519170',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959712401','13959712401','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660560519171',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18516157979','18516157979','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660560519172',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13328509988','13328509988','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660564713474',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13655902993','13655902993','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660564713475',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860398018','15860398018','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660564713476',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859551760','18859551760','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660568907778',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18606989818','18606989818','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660568907779',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13395096999','13395096999','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660568907780',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959858506','18959858506','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660568907781',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15985918296','15985918296','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660568907782',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960341716','13960341716','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660602462209',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880972652','15880972652','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660606656513',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980313135','15980313135','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660606656514',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906096567','13906096567','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660606656515',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15080070385','15080070385','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660606656516',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13675995249','13675995249','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660610850817',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15995216889','15995216889','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660610850818',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260429705','15260429705','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660610850819',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959778888','13959778888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660610850820',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905968151','13905968151','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660610850821',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959776520','13959776520','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660615045121',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799521561','13799521561','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660615045122',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13720842620','13720842620','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660615045123',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659915000','18659915000','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660619239426',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13205061526','13205061526','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660619239427',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060626155','15060626155','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660619239428',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959237668','13959237668','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660619239429',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13779911861','13779911861','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660623433730',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13601032833','13601032833','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660623433731',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506042338','13506042338','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660623433732',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18567651331','18567651331','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660627628034',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959959200','15959959200','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660627628035',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960291518','13960291518','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660627628036',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13859796953','13859796953','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660627628037',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15850693987','15850693987','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660627628038',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959870601','15959870601','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660627628039',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876572155','18876572155','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660631822338',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959753823','13959753823','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660631822339',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13459034477','13459034477','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660631822340',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860688762','15860688762','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'空号','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660631822341',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859596380','18859596380','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660661182465',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15502179365','15502179365','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'关机','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660665376770',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15086777305','15086777305','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660665376771',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18850528121','18850528121','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660665376772',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18052150317','18052150317','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660669571073',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17689683160','17689683160','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660669571074',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859757759','18859757759','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660669571075',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18359810815','18359810815','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660669571076',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505957512','13505957512','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660669571077',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13696949262','13696949262','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660669571078',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17689690969','17689690969','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660673765378',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959813876','18959813876','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660673765379',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805924801','13805924801','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660673765380',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18250169959','18250169959','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660673765381',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15005059367','15005059367','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660673765382',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15502207706','15502207706','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660673765383',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788829369','13788829369','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660673765384',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18059037101','18059037101','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660677959682',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859760088','18859760088','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660677959683',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15392286115','15392286115','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660677959684',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636957868','13636957868','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660677959685',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880974760','15880974760','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660682153985',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13794913769','13794913769','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660682153986',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15259555555','15259555555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660682153987',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18960285333','18960285333','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660682153988',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959997270','18959997270','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660682153989',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15392288851','15392288851','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660686348289',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960207400','13960207400','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660686348290',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15946798736','15946798736','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660686348291',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17750799505','17750799505','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660686348292',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13666988888','13666988888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660719902722',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17750103317','17750103317','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660724097026',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15622174598','15622174598','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660724097027',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260807555','15260807555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660724097028',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905958858','15905958858','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660724097029',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15080458330','15080458330','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660724097030',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15359585555','15359585555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660728291329',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059748612','15059748612','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660728291330',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18065333731','18065333731','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660728291331',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959889099','15959889099','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660728291332',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17605014353','17605014353','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660728291333',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13459504545','13459504545','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660732485633',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15396597171','15396597171','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660732485634',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18605001616','18605001616','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660732485635',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260785666','15260785666','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660732485636',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18106980703','18106980703','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660736679937',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959975329','13959975329','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660736679938',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13285030066','13285030066','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660736679939',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959855726','18959855726','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660736679940',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18046360864','18046360864','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660736679941',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13459556182','13459556182','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660740874241',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060456431','15060456431','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660740874242',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860300607','13860300607','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660740874243',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13306995027','13306995027','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660740874244',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18796922940','18796922940','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660745068545',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13325253201','13325253201','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660745068546',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18350777627','18350777627','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660745068547',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599159330','13599159330','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660745068548',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18020650858','18020650858','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660749262850',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13328963385','13328963385','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660749262851',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13709857491','13709857491','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660791205889',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13489312968','13489312968','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660795400194',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15960408186','15960408186','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660795400195',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859780809','18859780809','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660799594497',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15359590811','15359590811','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660799594498',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959119986','13959119986','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660799594499',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505951467','13505951467','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660799594500',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15141327771','15141327771','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660799594501',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599949096','13599949096','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660803788802',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980000372','15980000372','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660803788803',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905089834','13905089834','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660803788804',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965687332','18965687332','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660803788805',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959951039','13959951039','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660807983106',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960259639','13960259639','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660807983107',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18250155553','18250155553','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660807983108',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18359714502','18359714502','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660807983109',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965687331','18965687331','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660807983110',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905085845','13905085845','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660807983111',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980060559','15980060559','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660807983112',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960359859','13960359859','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660812177410',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965523733','18965523733','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660812177411',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17759991213','17759991213','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660812177412',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959579818','15959579818','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660812177413',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505008588','13505008588','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660812177414',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15029265211','15029265211','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660812177415',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18650908918','18650908918','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660812177416',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980000359','15980000359','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660816371714',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17755092627','17755092627','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660816371715',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960256299','13960256299','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660816371716',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980000660','15980000660','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660816371717',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18722290558','18722290558','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660849926145',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636950764','13636950764','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660854120450',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18539456470','18539456470','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660854120451',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13669274728','13669274728','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660854120452',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659003978','18659003978','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660858314753',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','19959848541','19959848541','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660858314754',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17689494919','17689494919','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660858314755',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959517575','15959517575','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660858314756',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906095618','13906095618','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660858314757',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505986964','13505986964','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660862509057',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18740431050','18740431050','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660862509058',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505050069','13505050069','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660862509059',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18759919815','18759919815','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660862509060',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13314987388','13314987388','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660862509061',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15759496852','15759496852','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660862509062',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059556400','15059556400','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660866703361',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859996145','18859996145','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660866703362',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13400808814','13400808814','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660866703363',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905950588','13905950588','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660866703364',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15960753968','15960753968','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660866703365',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15315563156','15315563156','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660866703366',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13665959771','13665959771','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660870897666',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906903291','13906903291','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660870897667',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18705052323','18705052323','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660870897668',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959505915','15959505915','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660870897669',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505932929','13505932929','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660870897670',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18159276351','18159276351','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660875091969',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960282791','13960282791','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660875091970',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799552053','13799552053','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660875091971',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13626066721','13626066721','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660875091972',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13030981560','13030981560','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660908646402',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15259223745','15259223745','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660912840705',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659568811','18659568811','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660912840706',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15559544571','15559544571','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660912840707',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506054328','13506054328','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660917035010',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15759733818','15759733818','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660917035011',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860902967','15860902967','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660917035012',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13067154015','13067154015','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660917035013',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13328500766','13328500766','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660917035014',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799557193','13799557193','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660921229314',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905055474','13905055474','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660921229315',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18606985861','18606985861','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660921229316',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876223641','18876223641','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660921229317',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788869420','13788869420','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660921229318',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18606056998','18606056998','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423617',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659003000','18659003000','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423618',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506969315','13506969315','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423619',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13313872221','13313872221','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423620',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13328989299','13328989299','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423621',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260704530','15260704530','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423622',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799564888','13799564888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423623',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18350770992','18350770992','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423624',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15659512626','15659512626','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423625',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905089465','13905089465','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423626',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15559067588','15559067588','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423627',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18603006276','18603006276','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423628',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','19906870165','19906870165','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423629',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959953589','13959953589','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423630',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13489858089','13489858089','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660925423631',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13400840823','13400840823','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660938006529',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805957117','13805957117','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660975755265',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960311095','13960311095','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660979949570',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17350011170','17350011170','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660979949571',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860750864','13860750864','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660979949572',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808556705','13808556705','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660979949573',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13256678813','13256678813','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660979949574',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905957105','13905957105','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660984143873',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506928380','13506928380','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660984143874',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805959366','13805959366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660984143875',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15029279845','15029279845','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660984143876',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15979017673','15979017673','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660984143877',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15620636649','15620636649','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660988338177',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13484540329','13484540329','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660988338178',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18316739194','18316739194','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660988338179',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18359877950','18359877950','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660988338180',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13488103520','13488103520','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660988338181',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13501115138','13501115138','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660992532481',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805959125','13805959125','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660992532482',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18850496760','18850496760','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660992532483',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13572104402','13572104402','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660992532484',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659262866','18659262866','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660996726785',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15985751705','15985751705','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660996726786',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805010196','15805010196','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660996726787',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505056755','13505056755','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660996726788',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506069249','13506069249','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358660996726789',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906998897','13906998897','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661000921089',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13696900561','13696900561','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661000921090',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13774878631','13774878631','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661000921091',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599161927','13599161927','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661000921092',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15759653345','15759653345','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661000921093',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18516970130','18516970130','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661042864130',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18046311397','18046311397','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661047058434',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906999100','13906999100','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661047058435',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18292635234','18292635234','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661051252737',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15029278847','15029278847','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661051252738',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13859751591','13859751591','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661051252739',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636950560','13636950560','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661051252740',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959840868','13959840868','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661051252741',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15396583913','15396583913','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661051252742',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13920285434','13920285434','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661055447042',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15829907184','15829907184','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661055447043',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600753338','13600753338','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661055447044',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860902576','15860902576','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661055447045',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505059996','13505059996','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661055447046',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13489848301','13489848301','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661059641346',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505058832','13505058832','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661059641347',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13625959920','13625959920','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661059641348',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805945051','13805945051','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661059641349',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13950238890','13950238890','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661059641350',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13004886898','13004886898','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661059641351',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599936037','13599936037','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661059641352',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18960259259','18960259259','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661063835650',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13612150403','13612150403','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661063835651',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13720852551','13720852551','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661063835652',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13410024480','13410024480','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661063835653',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600738975','13600738975','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661063835654',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599127767','13599127767','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661063835655',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13659192458','13659192458','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661068029954',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506066917','13506066917','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661068029955',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788811853','13788811853','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661068029956',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506956209','13506956209','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661101584385',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959992832','18959992832','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661105778690',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060998567','15060998567','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661105778691',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13850799806','13850799806','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661105778692',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13358577766','13358577766','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661109972994',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905035169','15905035169','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661109972995',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959553375','15959553375','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661109972996',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15960795588','15960795588','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661109972997',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506941213','13506941213','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661109972998',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965699955','18965699955','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661114167297',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805950256','13805950256','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661114167298',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15080421696','15080421696','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661114167299',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905095955','15905095955','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661114167300',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17706067083','17706067083','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661118361602',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859495050','15859495050','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661118361603',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805952318','15805952318','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661118361604',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799239878','13799239878','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661118361605',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600751875','13600751875','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661118361606',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13859775220','13859775220','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661122555906',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905077879','15905077879','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661122555907',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905006716','15905006716','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661122555908',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13055667605','13055667605','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661122555909',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13850777555','13850777555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'空号','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661126750210',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636905051','13636905051','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661126750211',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13625994626','13625994626','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661126750212',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860763453','13860763453','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661126750213',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13004800144','13004800144','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661126750214',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13850777672','13850777672','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661126750215',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18059983988','18059983988','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661126750216',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799240204','13799240204','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661130944513',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600709507','13600709507','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661164498945',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959596201','15959596201','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661168693249',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','19959999308','19959999308','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661172887554',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799850617','13799850617','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661172887555',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808512082','13808512082','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661172887556',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13615940087','13615940087','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661172887557',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959926888','13959926888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661172887558',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059557916','15059557916','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661177081858',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13950108669','13950108669','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661177081859',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808510666','13808510666','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661177081860',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799797017','13799797017','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661177081861',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505992220','13505992220','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661177081862',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959941521','13959941521','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'空号','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661181276161',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860703356','13860703356','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661181276162',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18633637251','18633637251','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661181276163',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959856161','13959856161','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661181276164',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506055166','13506055166','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661181276165',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959910000','13959910000','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661181276166',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880881006','15880881006','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661181276167',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960382970','13960382970','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661185470466',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860757775','13860757775','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661185470467',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15906066156','15906066156','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661185470468',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860396396','15860396396','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661185470469',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060946052','15060946052','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661185470470',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18815985602','18815985602','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661185470471',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880881883','15880881883','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661189664770',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905059153','13905059153','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661189664771',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18950026794','18950026794','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661189664772',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13859989821','13859989821','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661189664773',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506045449','13506045449','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661189664774',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960459977','13960459977','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661231607810',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876539791','18876539791','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661231607811',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860302368','15860302368','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661231607812',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505961108','13505961108','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661235802114',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960292725','13960292725','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661235802115',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905032289','15905032289','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661235802116',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659060047','18659060047','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661235802117',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599994541','13599994541','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661235802118',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859577452','15859577452','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661235802119',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13559045209','13559045209','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996417',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980065535','15980065535','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996418',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260101691','15260101691','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996419',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18759508729','18759508729','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996420',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799896025','13799896025','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996421',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15159529936','15159529936','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996422',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18905951960','18905951960','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996423',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880161129','15880161129','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661239996424',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599507077','13599507077','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661244190722',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799202233','13799202233','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661244190723',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13655933296','13655933296','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661244190724',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13950299290','13950299290','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661244190725',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505907585','13505907585','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661244190726',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13606051571','13606051571','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661244190727',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059520014','15059520014','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661248385026',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15601588313','15601588313','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661248385027',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506066359','13506066359','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661248385028',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799899315','13799899315','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661248385029',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860703516','13860703516','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661248385030',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980456333','15980456333','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661248385031',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506083126','13506083126','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661252579329',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15005936026','15005936026','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661290328066',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600703472','13600703472','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661294522370',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905350771','13905350771','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661294522371',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959752857','13959752857','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661294522372',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059832543','15059832543','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661298716673',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18150983366','18150983366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661298716674',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980235626','15980235626','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661298716675',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13559575942','13559575942','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661298716676',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659737170','18659737170','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661302910978',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15106087765','15106087765','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661302910979',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13110816682','13110816682','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661302910980',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905044580','15905044580','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661302910981',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599115973','13599115973','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661307105282',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15659450305','15659450305','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661307105283',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13675930836','13675930836','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661307105284',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17359990624','17359990624','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661307105285',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15505952026','15505952026','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661307105286',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13685910527','13685910527','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661311299586',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15083847155','15083847155','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661311299587',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15106037664','15106037664','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661311299588',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808543336','13808543336','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661311299589',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13615922291','13615922291','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661315493890',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965636930','18965636930','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661315493891',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960296362','13960296362','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661315493892',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13063191843','13063191843','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661315493893',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15911052916','15911052916','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661315493894',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506062515','13506062515','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661315493895',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15259555117','15259555117','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661319688194',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17612198088','17612198088','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661319688195',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659822922','18659822922','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661319688196',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13520554703','13520554703','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661353242626',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13655601013','13655601013','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661357436930',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15080417163','15080417163','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661357436931',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15827609588','15827609588','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661357436932',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859785085','18859785085','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661357436933',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15359383458','15359383458','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661357436934',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905975697','15905975697','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661361631234',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905076266','15905076266','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661361631235',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980271486','15980271486','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661361631236',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13110592357','13110592357','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661361631237',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859775715','15859775715','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661361631238',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808540799','13808540799','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661361631239',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15392481724','15392481724','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661361631240',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880975265','15880975265','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661365825538',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860328381','15860328381','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661365825539',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18605001313','18605001313','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661365825540',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959940177','13959940177','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661365825541',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18225662357','18225662357','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661365825542',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18905080205','18905080205','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661365825543',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506057070','13506057070','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661370019841',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060985107','15060985107','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661370019842',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060032495','15060032495','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661370019843',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860726225','13860726225','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661370019844',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13121833855','13121833855','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661370019845',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17750989111','17750989111','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661370019846',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13685921872','13685921872','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661370019847',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980063533','15980063533','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661374214145',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860143467','13860143467','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661374214146',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260237093','15260237093','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661374214147',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960250701','13960250701','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661374214148',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599505962','13599505962','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661411962882',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18559273254','18559273254','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661411962883',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18950070276','18950070276','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661416157185',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13404252272','13404252272','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661416157186',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17388204055','17388204055','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661416157187',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15259729821','15259729821','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661416157188',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13459599999','13459599999','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661416157189',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059823968','15059823968','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661416157190',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13407735197','13407735197','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'移动网关的内部错误','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661420351490',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17715205257','17715205257','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661420351491',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15326179637','15326179637','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661420351492',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860301827','15860301827','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661420351493',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905057579','15905057579','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661420351494',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18060501876','18060501876','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661420351495',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13400887176','13400887176','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661424545793',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18050020726','18050020726','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661424545794',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13055224466','13055224466','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661424545795',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15106033846','15106033846','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661424545796',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880990268','15880990268','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661424545797',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18698399527','18698399527','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661424545798',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18314463516','18314463516','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661428740097',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','19905053569','19905053569','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661428740098',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13950364429','13950364429','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661428740099',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805026065','15805026065','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661428740100',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18750530127','18750530127','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661428740101',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13950092022','13950092022','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661428740102',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980067586','15980067586','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661432934402',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13859790099','13859790099','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661432934403',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260200619','15260200619','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661432934404',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965658201','18965658201','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661432934405',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059755771','15059755771','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661466488833',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15827436094','15827436094','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661470683138',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13459533442','13459533442','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661474877442',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13696856720','13696856720','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661474877443',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15159887877','15159887877','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661474877444',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599172228','13599172228','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661474877445',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505008000','13505008000','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661474877446',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805956092','13805956092','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661479071745',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880754887','15880754887','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661479071746',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18698360960','18698360960','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661479071747',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13085059001','13085059001','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661479071748',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13665965633','13665965633','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661479071749',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805003589','15805003589','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661479071750',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859554650','15859554650','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661483266050',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260720911','15260720911','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661483266051',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859498656','18859498656','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'空号','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661483266052',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876284599','18876284599','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661483266053',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876377906','18876377906','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661483266054',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13950317095','13950317095','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661516820481',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905055709','15905055709','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661516820482',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13159060909','13159060909','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014786',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15201615843','15201615843','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014787',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18065589080','18065589080','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014788',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18411037910','18411037910','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014789',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505054724','13505054724','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014790',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13859745152','13859745152','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014791',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15906061807','15906061807','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014792',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659923130','18659923130','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661521014793',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860516215','15860516215','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661525209089',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859565605','15859565605','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661525209090',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18682261122','18682261122','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661562957825',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15159724662','15159724662','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661567152130',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18698372705','18698372705','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661567152131',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906998716','13906998716','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661567152132',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860900865','15860900865','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661571346434',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18815997296','18815997296','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661571346435',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959232693','15959232693','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661571346436',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18159595252','18159595252','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661571346437',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959700369','18959700369','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661575540737',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859559078','15859559078','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661575540738',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505990915','13505990915','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661575540739',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13779982480','13779982480','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661575540740',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13615963766','13615963766','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661575540741',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959966729','15959966729','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661579735041',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13825584576','13825584576','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661579735042',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15122460079','15122460079','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661579735043',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506061896','13506061896','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661579735044',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15922263220','15922263220','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661579735045',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600759390','13600759390','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661583929346',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13275049035','13275049035','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661583929347',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13030982553','13030982553','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661583929348',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18559552007','18559552007','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661583929349',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599710039','13599710039','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661583929350',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799239129','13799239129','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661588123650',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18292491251','18292491251','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661588123651',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15159739903','15159739903','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661588123652',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859781366','18859781366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661588123653',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18006037070','18006037070','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661588123654',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18906999069','18906999069','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661592317953',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876569027','18876569027','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661592317954',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859553823','15859553823','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661625872385',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506998846','13506998846','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661630066690',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980068126','15980068126','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661630066691',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960259810','13960259810','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661630066692',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18876539839','18876539839','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661630066693',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18050878555','18050878555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661634260993',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960826248','13960826248','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661634260994',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15280423942','15280423942','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661634260995',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659069495','18659069495','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661634260996',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18006990697','18006990697','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661638455297',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959812033','13959812033','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661638455298',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15159790586','15159790586','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661638455299',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13859085700','13859085700','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661638455300',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808505910','13808505910','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661638455301',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15806017885','15806017885','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661642649602',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805956361','15805956361','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661642649603',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980232523','15980232523','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661642649604',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13110982808','13110982808','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661642649605',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18046040451','18046040451','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661646843906',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959569933','15959569933','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661646843907',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15860356356','15860356356','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661646843908',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18805025309','18805025309','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661646843909',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13055650678','13055650678','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661646843910',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960254757','13960254757','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661651038209',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15806019077','15806019077','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661651038210',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505097888','13505097888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661651038211',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599106745','13599106745','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661651038212',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959717283','13959717283','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661655232514',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636959434','13636959434','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661655232515',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905985743','13905985743','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661655232516',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905079763','13905079763','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661692981250',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599978051','13599978051','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661697175554',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15280422458','15280422458','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661697175555',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18650676688','18650676688','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661701369857',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906099550','13906099550','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661701369858',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13665001804','13665001804','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661701369859',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18960877567','18960877567','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661701369860',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18900311779','18900311779','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661701369861',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880977738','15880977738','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661705564162',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18605007853','18605007853','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661705564163',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18606942212','18606942212','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661705564164',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13067198079','13067198079','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661705564165',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13400539210','13400539210','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661705564166',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18825160801','18825160801','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661709758465',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13163906685','13163906685','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661709758466',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18817333998','18817333998','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661709758467',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505955686','13505955686','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661709758468',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13559546275','13559546275','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661709758469',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13665956888','13665956888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661713952769',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980478011','15980478011','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661713952770',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18559672261','18559672261','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661713952771',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18862155979','18862155979','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661713952772',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659097395','18659097395','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661713952773',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15259727676','15259727676','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661718147073',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905969285','13905969285','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661718147074',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15606087056','15606087056','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661718147075',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18782977456','18782977456','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661718147076',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906091302','13906091302','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661722341377',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960408350','13960408350','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661722341378',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959946911','13959946911','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661722341379',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18960251988','18960251988','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661764284418',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060969798','15060969798','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661768478721',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505071035','13505071035','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661768478722',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18905059500','18905059500','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661768478723',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808525056','13808525056','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661768478724',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17705061101','17705061101','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661772673026',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905059909','13905059909','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661772673027',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15985900838','15985900838','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661772673028',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799581818','13799581818','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661772673029',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13626076868','13626076868','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661772673030',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960255304','13960255304','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661776867330',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959992008','15959992008','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661776867331',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13615926622','13615926622','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661776867332',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959990198','15959990198','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661776867333',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636928198','13636928198','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661781061633',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808558181','13808558181','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661781061634',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905075757','13905075757','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661781061635',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905079280','13905079280','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661781061636',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13606021816','13606021816','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661781061637',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980056221','15980056221','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661785255937',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805997206','13805997206','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661785255938',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13489887652','13489887652','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661785255939',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506009833','13506009833','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661785255940',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13646031399','13646031399','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661789450242',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805941850','13805941850','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661789450243',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13488682111','13488682111','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661789450244',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15392121201','15392121201','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661789450245',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18959981231','18959981231','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661789450246',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959952350','13959952350','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661793644545',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13489512117','13489512117','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661793644546',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15759500600','15759500600','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661881724930',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959921098','13959921098','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661890113537',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799870758','13799870758','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661890113538',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13850753398','13850753398','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661890113539',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959599793','15959599793','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661890113540',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13242884288','13242884288','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661894307841',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13559550686','13559550686','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661894307842',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805951761','13805951761','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661894307843',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15710646360','15710646360','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661894307844',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260838513','15260838513','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661898502146',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600704238','13600704238','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661898502147',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13316225195','13316225195','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661898502148',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860708740','13860708740','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661898502149',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15805972719','15805972719','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661902696449',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18050888018','18050888018','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661902696450',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959975903','13959975903','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661902696451',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15359508512','15359508512','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661902696452',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505051522','13505051522','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661902696453',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859505750','15859505750','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661902696454',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15377953096','15377953096','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661906890753',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15960731557','15960731557','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661906890754',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599715762','13599715762','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661906890755',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788826386','13788826386','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661906890756',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13459523253','13459523253','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661906890757',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13489512136','13489512136','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661906890758',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13107880950','13107880950','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661906890759',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15750898928','15750898928','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661911085057',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18950498312','18950498312','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661911085058',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15375886386','15375886386','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661911085059',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13400507028','13400507028','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661911085060',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13587756546','13587756546','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'移动停机或关机','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661940445186',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13959737339','13959737339','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661944639490',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18659916888','18659916888','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661944639491',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859525583','18859525583','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661944639492',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13506059007','13506059007','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661948833793',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505955666','13505955666','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661948833794',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505902557','13505902557','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661948833795',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13636951165','13636951165','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661948833796',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805957070','13805957070','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661953028098',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13860602468','13860602468','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661953028099',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13305962813','13305962813','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661953028100',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13661356074','13661356074','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661953028101',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15606088553','15606088553','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661953028102',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13645019389','13645019389','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661957222401',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15280875858','15280875858','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661957222402',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600788662','13600788662','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661957222403',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','19905908656','19905908656','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661957222404',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18344910844','18344910844','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661957222405',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18059147928','18059147928','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661961416705',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260708136','15260708136','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661961416706',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15880824003','15880824003','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661961416707',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13365952758','13365952758','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661961416708',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805951603','13805951603','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661961416709',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15375754488','15375754488','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661965611010',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13918199745','13918199745','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661965611011',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15859577777','15859577777','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661965611012',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15606946335','15606946335','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661965611013',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805997578','13805997578','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661969805313',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060933832','15060933832','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661969805314',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17850929207','17850929207','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358661969805315',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18750654331','18750654331','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662011748353',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13599751999','13599751999','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662011748354',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13906099845','13906099845','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662015942658',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859552366','18859552366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662015942659',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859626598','18859626598','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662015942660',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15959990680','15959990680','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662015942661',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905909283','15905909283','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662015942662',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15059720864','15059720864','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662015942663',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15620633941','15620633941','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662020136962',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15980006525','15980006525','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662020136963',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15260813616','15260813616','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662020136964',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18100525107','18100525107','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662020136965',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18859763636','18859763636','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662020136966',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18396220746','18396220746','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662020136967',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18559477701','18559477701','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662024331265',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15759596655','15759596655','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662024331266',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13905955872','13905955872','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662024331267',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13605944765','13605944765','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662024331268',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505954433','13505954433','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662024331269',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13808552366','13808552366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662024331270',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13655928585','13655928585','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662024331271',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788833384','13788833384','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662028525570',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960305030','13960305030','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662028525571',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13338583366','13338583366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662028525572',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13505905737','13505905737','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662028525573',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15280081010','15280081010','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662028525574',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788805366','13788805366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662028525575',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13559369710','13559369710','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662032719873',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13788816686','13788816686','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662032719874',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13067166871','13067166871','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662032719875',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600785508','13600785508','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662066274306',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13805065379','13805065379','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662070468610',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13459218283','13459218283','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662070468611',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13107891508','13107891508','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662070468612',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15396503999','15396503999','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662074662913',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18705045726','18705045726','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662074662914',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15071360501','15071360501','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662074662915',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13400886486','13400886486','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662074662916',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15305009255','15305009255','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662074662917',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15080406979','15080406979','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662074662918',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18359592597','18359592597','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662078857217',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15905903705','15905903705','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662078857218',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13328505767','13328505767','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662078857219',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13799866661','13799866661','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662078857220',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13285957289','13285957289','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662078857221',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18965662565','18965662565','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662078857222',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15960217968','15960217968','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662078857223',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','17359987925','17359987925','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051522',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13960326290','13960326290','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051523',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18905051668','18905051668','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051524',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13159037366','13159037366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051525',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600703555','13600703555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051526',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13489387611','13489387611','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051527',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','15060619686','15060619686','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051528',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','18084725997','18084725997','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662083051529',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13901318357','13901318357','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662087245826',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13295908788','13295908788','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268358662087245827',NULL,'1268358659818127362',2,2,'批量发送(2019年人才认定公示20200604)','13600704026','13600704026','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 09:47:24',NULL,NULL,NULL,'2020-06-04 09:47:24',NULL,NULL,NULL),('1268363165754720258',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059551567','15059551567','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165758914562',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15260305126','15260305126','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165758914563',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13655986799','13655986799','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165763108866',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13338562717','13338562717','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165763108867',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13506056368','13506056368','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165763108868',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13905958730','13905958730','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165763108869',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13774825517','13774825517','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165763108870',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13509362773','13509362773','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165763108871',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15906092370','15906092370','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165767303169',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13799555666','13799555666','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165767303170',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18605008168','18605008168','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165767303171',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13599162155','13599162155','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165767303172',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905907962','15905907962','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165767303173',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13144828970','13144828970','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165767303174',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15559162475','15559162475','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165767303175',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13850778776','13850778776','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165771497474',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18559161283','18559161283','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165771497475',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18650100145','18650100145','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165771497476',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13685908658','13685908658','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165771497477',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13599717008','13599717008','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165771497478',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15259546913','15259546913','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165771497479',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15260899107','15260899107','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165771497480',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980066202','15980066202','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165775691778',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059157225','15059157225','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165775691779',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15759488187','15759488187','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165775691780',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13774828120','13774828120','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165775691781',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18771094578','18771094578','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165775691782',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13400820519','13400820519','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165775691783',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18959805200','18959805200','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165779886082',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18695665035','18695665035','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165779886083',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13859727077','13859727077','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165805051906',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15345952654','15345952654','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165805051907',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15659972175','15659972175','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165809246209',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15359383363','15359383363','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165809246210',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13625979936','13625979936','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165809246211',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13514019395','13514019395','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165809246212',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15396608587','15396608587','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165809246213',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13969010619','13969010619','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165809246214',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15805981750','15805981750','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165809246215',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13842019660','13842019660','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165813440513',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13940108782','13940108782','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165813440514',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18862155925','18862155925','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165813440515',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18275745728','18275745728','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165813440516',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13799487213','13799487213','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165813440517',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15960707755','15960707755','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165813440518',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18468034987','18468034987','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165813440519',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13860116953','13860116953','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634817',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18805920922','18805920922','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634818',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18659030881','18659030881','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634819',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17006098806','17006098806','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634820',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17359711663','17359711663','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634821',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059803792','15059803792','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634822',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13436970465','13436970465','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634823',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980013301','15980013301','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165817634824',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13950430719','13950430719','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165821829122',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18900336517','18900336517','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165821829123',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18105907301','18105907301','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165821829124',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18851401527','18851401527','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165821829125',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18020867909','18020867909','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165821829126',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15860257142','15860257142','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165821829127',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18876336921','18876336921','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165846994946',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15806032297','15806032297','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165851189250',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18965785175','18965785175','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165851189251',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15005062379','15005062379','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165851189252',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18950700105','18950700105','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165851189253',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18741355270','18741355270','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165855383553',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18150563203','18150563203','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165855383554',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13075572292','13075572292','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165855383555',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18649652527','18649652527','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165855383556',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17741357996','17741357996','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165855383557',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15090088338','15090088338','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165855383558',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13599220676','13599220676','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165855383559',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18900371513','18900371513','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165859577858',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15191818740','15191818740','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165859577859',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18696960184','18696960184','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165859577860',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905037555','15905037555','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165859577861',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15960551920','15960551920','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165859577862',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15629795466','15629795466','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165859577863',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18959941093','18959941093','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165859577864',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13599279399','13599279399','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165863772162',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13505906457','13505906457','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165863772163',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18571081281','18571081281','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165863772164',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18859464970','18859464970','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165863772165',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13027105101','13027105101','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165863772166',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17758709290','17758709290','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165863772167',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13425480722','13425480722','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'常见原因是：关机，停机，不在服务区；在少数情况下，号码正常通信，是由于地区屏蔽导致。','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165863772168',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18050929268','18050929268','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165867966465',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13816975274','13816975274','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165867966466',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13178336506','13178336506','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165867966467',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13600703008','13600703008','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165867966468',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','14759154723','14759154723','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165897326594',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18262283166','18262283166','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165901520897',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059719567','15059719567','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165901520898',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15960402869','15960402869','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165901520899',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18829340451','18829340451','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165901520900',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15559110466','15559110466','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165901520901',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15191845928','15191845928','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165901520902',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13122120652','13122120652','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165901520903',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15191815436','15191815436','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165905715202',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13959264368','13959264368','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165905715203',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15080318157','15080318157','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165905715204',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060823577','15060823577','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165905715205',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18659066928','18659066928','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165905715206',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18559472664','18559472664','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165905715207',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18150591518','18150591518','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165909909505',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13860752060','13860752060','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165909909506',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13328555097','13328555097','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165909909507',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17759892862','17759892862','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165909909508',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18876272213','18876272213','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165909909509',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18829298483','18829298483','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165909909510',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13313825373','13313825373','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165914103810',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18250850010','18250850010','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165914103811',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13559554933','13559554933','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165914103812',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15389303652','15389303652','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165914103813',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15805955751','15805955751','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165914103814',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13649283497','13649283497','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165914103815',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959590927','15959590927','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165918298113',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18065606507','18065606507','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165918298114',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18192276329','18192276329','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165918298115',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15759590781','15759590781','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165918298116',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13614268392','13614268392','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165943463937',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18701704136','18701704136','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165947658241',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18898408023','18898408023','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165947658242',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18506966086','18506966086','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165947658243',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15702950980','15702950980','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165947658244',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18806028372','18806028372','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165951852546',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18605914467','18605914467','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165951852547',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18065525518','18065525518','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165951852548',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17750792370','17750792370','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165951852549',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959873463','15959873463','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165951852550',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15191815139','15191815139','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165951852551',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15805097777','15805097777','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165951852552',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059850519','15059850519','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046849',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18392859639','18392859639','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046850',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13484917236','13484917236','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046851',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15029140185','15029140185','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046852',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15903645816','15903645816','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046853',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18659719331','18659719331','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046854',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13072350035','13072350035','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046855',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905050688','15905050688','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165956046856',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15202404290','15202404290','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165960241153',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15821998683','15821998683','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165960241154',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15111982965','15111982965','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165960241155',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980011425','15980011425','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165960241156',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15259519391','15259519391','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165960241157',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15202427957','15202427957','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165960241158',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959581739','15959581739','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165960241159',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15527179406','15527179406','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165964435457',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13799898116','13799898116','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165964435458',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15029236362','15029236362','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165964435459',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13959861620','13959861620','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165985406977',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13805956558','13805956558','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165989601281',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13808549828','13808549828','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165989601282',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060832111','15060832111','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165989601283',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18959995002','18959995002','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165993795586',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060972472','15060972472','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165993795587',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13600701178','13600701178','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165993795588',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15623564761','15623564761','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165993795589',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13859754633','13859754633','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165993795590',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13459562051','13459562051','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165993795591',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15605003638','15605003638','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165993795592',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905996868','15905996868','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989889',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15860517253','15860517253','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989890',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13512216307','13512216307','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989891',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13559532808','13559532808','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989892',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980036243','15980036243','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989893',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15860901713','15860901713','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989894',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18960279877','18960279877','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989895',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880931696','15880931696','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363165997989896',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15359556333','15359556333','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166002184194',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18350062033','18350062033','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166002184195',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18359837870','18359837870','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166002184196',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18059993901','18059993901','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166002184197',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13636903309','13636903309','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166002184198',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13905971030','13905971030','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166002184199',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13515055988','13515055988','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166002184200',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959888180','15959888180','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166006378498',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13636906289','13636906289','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166006378499',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13774877242','13774877242','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166006378500',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13850772504','13850772504','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166006378501',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','19959999508','19959999508','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166031544322',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13559591215','13559591215','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166035738625',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15260399516','15260399516','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166039932930',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905006169','15905006169','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166039932931',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15985959061','15985959061','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166039932932',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059528748','15059528748','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166039932933',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13850755588','13850755588','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166044127233',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15985905430','15985905430','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166044127234',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18959996388','18959996388','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166044127235',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13489719977','13489719977','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166044127236',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959592923','15959592923','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166044127237',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13559592136','13559592136','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166048321537',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13505045259','13505045259','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166048321538',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959592127','15959592127','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166048321539',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18750931024','18750931024','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166048321540',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13960391700','13960391700','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166052515842',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880762096','15880762096','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166052515843',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13906934045','13906934045','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166052515844',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15260852001','15260852001','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166052515845',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060806451','15060806451','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166052515846',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15859796399','15859796399','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166052515847',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15359493923','15359493923','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166052515848',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13959882723','13959882723','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710146',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15074870926','15074870926','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710147',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13774898032','13774898032','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710148',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060990680','15060990680','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710149',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18650917845','18650917845','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710150',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18850547191','18850547191','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710151',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15985923093','15985923093','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710152',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13950362316','13950362316','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166056710153',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13788852001','13788852001','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166081875969',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13615922291','13615922291','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166086070274',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15806036626','15806036626','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166086070275',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880825431','15880825431','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166090264577',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13159012670','13159012670','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166090264578',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18259060411','18259060411','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166090264579',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13075877415','13075877415','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166090264580',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13860631416','13860631416','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166090264581',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060933526','15060933526','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166090264582',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13636993769','13636993769','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166094458881',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18250292550','18250292550','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166094458882',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17512098847','17512098847','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166094458883',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18050056871','18050056871','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166094458884',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18159235825','18159235825','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166094458885',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18350535110','18350535110','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166094458886',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15859468355','15859468355','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653185',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15259471016','15259471016','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653186',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880758500','15880758500','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653187',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15960581457','15960581457','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',2,'空号','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653188',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13459246092','13459246092','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653189',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13627292269','13627292269','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653190',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13599719905','13599719905','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653191',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15846593350','15846593350','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166098653192',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15810298887','15810298887','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166102847489',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15605009590','15605009590','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166102847490',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13805948042','13805948042','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166102847491',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059510022','15059510022','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166102847492',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880818089','15880818089','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166102847493',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18606031846','18606031846','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166102847494',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13689056004','13689056004','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166102847495',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905070935','15905070935','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166132207617',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18750537614','18750537614','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166132207618',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18050869127','18050869127','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166132207619',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18876240048','18876240048','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166136401921',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18805921912','18805921912','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166136401922',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18835792826','18835792826','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166136401923',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18215628161','18215628161','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166136401924',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13788803006','13788803006','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166136401925',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980301999','15980301999','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166136401926',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18722334354','18722334354','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166136401927',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18202655266','18202655266','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166140596226',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18581998214','18581998214','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166140596227',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059839423','15059839423','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166140596228',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15860358661','15860358661','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166140596229',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18559511816','18559511816','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166140596230',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959264462','15959264462','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166140596231',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15559528807','15559528807','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166140596232',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880027485','15880027485','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166144790529',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13706991487','13706991487','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166144790530',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13055336977','13055336977','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166144790531',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13030978969','13030978969','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166144790532',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15906066000','15906066000','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166144790533',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980274172','15980274172','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166144790534',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060804302','15060804302','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166144790535',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18650916825','18650916825','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166148984834',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15280404202','15280404202','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166148984835',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13328979519','13328979519','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166148984836',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18350776066','18350776066','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166148984837',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18868801836','18868801836','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166148984838',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18859716793','18859716793','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166148984839',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15805990003','15805990003','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166178344962',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880480928','15880480928','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539266',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13635240509','13635240509','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539267',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15259758239','15259758239','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539268',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18250882613','18250882613','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539269',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15860353200','15860353200','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539270',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905996655','15905996655','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539271',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18965513668','18965513668','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539272',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18046009745','18046009745','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166182539273',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15160441962','15160441962','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733570',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15960746554','15960746554','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733571',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13685000414','13685000414','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733572',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15759296423','15759296423','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733573',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959552577','15959552577','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733574',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15805073665','15805073665','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733575',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18876568900','18876568900','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733576',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15205011506','15205011506','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166186733577',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18250422227','18250422227','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166190927873',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18950490831','18950490831','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166190927874',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959530855','15959530855','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166190927875',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15705923619','15705923619','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166190927876',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15259597676','15259597676','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166190927877',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18429006632','18429006632','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166190927878',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15359855333','15359855333','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166190927879',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15260225737','15260225737','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166195122177',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18703659101','18703659101','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166195122178',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13599177919','13599177919','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166195122179',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13696857207','13696857207','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166195122180',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13505905685','13505905685','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166195122181',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13675918895','13675918895','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166195122182',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980025829','15980025829','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166220288002',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13799855086','13799855086','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166224482306',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13960257652','13960257652','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166224482307',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15080426614','15080426614','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166224482308',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18750651805','18750651805','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166224482309',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18659005089','18659005089','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166224482310',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13506095562','13506095562','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166224482311',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13960256303','13960256303','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166224482312',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13665903960','13665903960','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676610',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13960256111','13960256111','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676611',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18905079898','18905079898','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676612',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18959853655','18959853655','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676613',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13601076764','13601076764','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676614',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13505050692','13505050692','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676615',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18905060268','18905060268','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676616',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13959955769','13959955769','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166228676617',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18965667777','18965667777','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870913',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18759922187','18759922187','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870914',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15859590857','15859590857','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870915',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13850757007','13850757007','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870916',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18859225776','18859225776','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870917',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959962792','15959962792','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870918',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18030243370','18030243370','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870919',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18259061182','18259061182','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166232870920',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13799857333','13799857333','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166237065217',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059597777','15059597777','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166237065218',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18850383723','18850383723','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166237065219',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059871315','15059871315','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166237065220',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880024622','15880024622','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166237065221',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15980041722','15980041722','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166237065222',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13600766763','13600766763','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166262231042',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18850549376','18850549376','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166266425346',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15060827887','15060827887','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166270619649',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18859495931','18859495931','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166270619650',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18605958852','18605958852','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166270619651',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15805060325','15805060325','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166270619652',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15880764254','15880764254','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166274813953',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13959888168','13959888168','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166274813954',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18750561717','18750561717','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166274813955',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17606025253','17606025253','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166274813956',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13599717079','13599717079','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166279008257',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13615908669','13615908669','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166279008258',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13386880667','13386880667','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166279008259',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13506030795','13506030795','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166279008260',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15959882366','15959882366','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166279008261',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15905988871','15905988871','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166283202561',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15960250972','15960250972','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166283202562',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18005073259','18005073259','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166283202563',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18005065560','18005065560','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166283202564',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15605959006','15605959006','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166287396865',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13645971717','13645971717','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166287396866',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18050270931','18050270931','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166287396867',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','17758766631','17758766631','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166287396868',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13305952629','13305952629','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166287396869',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15659132085','15659132085','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166291591169',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18050916965','18050916965','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166291591170',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18050876301','18050876301','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166291591171',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15396596855','15396596855','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166291591172',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13559513508','13559513508','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166295785473',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13229424859','13229424859','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166295785474',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13645032611','13645032611','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166325145602',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15059154896','15059154896','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166329339905',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18650591551','18650591551','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166329339906',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','15759216753','15759216753','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166329339907',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','18805065856','18805065856','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268363166329339908',NULL,'1268363165247209474',2,2,'批量发送(2019年人才认定公示20200604)','13328883775','13328883775','【晋江市人才服务平台】您好！您提交申请的2019年度晋江市优秀人才认定已完成初步审核，现通过人才晋江微信公众号将审核结果予以公示，公示时间2020-06-03至2020-06-09 。公示期间如有异议，请及时向中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心反映。电话0595-85671348、0595-85633128  ,电子邮箱jjrc85661234@163.com 。',3,'短信发送成功','2020-06-04 10:05:18',NULL,NULL,NULL,'2020-06-04 10:05:18',NULL,NULL,NULL),('1268467751542902786',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13295959911','13295959911','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751555485697',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15160330306','15160330306','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751555485698',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18859555816','18859555816','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751559680002',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13599218888','13599218888','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751559680003',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13107872929','13107872929','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751568068609',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13905051776','13905051776','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751572262913',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15060011828','15060011828','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751576457217',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13905953818','13905953818','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751576457218',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15159518618','15159518618','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751580651522',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18805959777','18805959777','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751580651523',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18959210622','18959210622','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751580651524',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15860304280','15860304280','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751584845826',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18859920423','18859920423','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751584845827',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959507666','15959507666','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751584845828',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13625958406','13625958406','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751589040130',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18859933999','18859933999','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751589040131',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15375708923','15375708923','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751589040132',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13205957447','13205957447','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751589040133',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15905975168','15905975168','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751593234434',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13960228853','13960228853','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268467751593234435',NULL,'1268467750959894529',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15759877981','15759877981','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:00:53',NULL,NULL,NULL,'2020-06-04 17:00:53',NULL,NULL,NULL),('1268470715288440833',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18159826888','18159826888','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715296829441',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13905974002','13905974002','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715296829442',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13808505006','13808505006','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715301023745',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13305088921','13305088921','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715301023746',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13799766670','13799766670','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715301023747',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18815985118','18815985118','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715301023748',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15359996305','15359996305','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715305218050',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18959707235','18959707235','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715305218051',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15191577654','15191577654','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715305218052',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18959706230','18959706230','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715309412354',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13506003686','13506003686','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715309412355',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15906067008','15906067008','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715309412356',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','17706075999','17706075999','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715309412357',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13665987766','13665987766','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715313606658',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15359490818','15359490818','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715313606659',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18759552098','18759552098','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715313606660',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18259591998','18259591998','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715313606661',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13675998353','13675998353','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715317800962',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18859951871','18859951871','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715317800963',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18959708032','18959708032','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715317800964',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13599145737','13599145737','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715321995266',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13559054268','13559054268','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715321995267',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18959906506','18959906506','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715321995268',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18965689711','18965689711','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715321995269',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959996599','15959996599','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715326189570',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959556399','15959556399','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715326189571',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13860190418','13860190418','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715326189572',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13599921781','13599921781','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715330383874',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','17750891999','17750891999','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715330383875',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15905092171','15905092171','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715330383876',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18960353905','18960353905','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715363938305',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15880911717','15880911717','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715368132609',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18959706253','18959706253','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715368132610',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18350770057','18350770057','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715372326913',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15860381909','15860381909','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715372326914',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15559133531','15559133531','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715372326915',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18905953233','18905953233','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715376521218',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','19859573633','19859573633','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715376521219',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13489403314','13489403314','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715376521220',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15260875781','15260875781','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715376521221',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15759876282','15759876282','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715380715522',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13313880008','13313880008','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715384909825',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13850728390','13850728390','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715384909826',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13559625390','13559625390','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715384909827',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15260823192','15260823192','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715389104130',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959509673','15959509673','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715389104131',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13706957817','13706957817','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715393298433',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13959798556','13959798556','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715393298434',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13649278723','13649278723','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715393298435',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13859705235','13859705235','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715397492737',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13505942660','13505942660','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715397492738',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18659281177','18659281177','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715401687041',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13505943066','13505943066','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715401687042',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13405350771','13405350771','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',2,'空号','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715405881345',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13599766670','13599766670','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715405881346',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13863831087','13863831087','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715405881347',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','17762027770','17762027770','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715410075649',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13700242731','13700242731','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715410075650',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13505028679','13505028679','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715410075651',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15860351538','15860351538','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715414269954',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13405353771','13405353771','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715443630082',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15880719513','15880719513','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715443630083',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15059543210','15059543210','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715447824385',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13905055766','13905055766','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715447824386',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18106968679','18106968679','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715447824387',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15859231310','15859231310','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715452018689',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15080345751','15080345751','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715452018690',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15059570222','15059570222','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715452018691',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13959955966','13959955966','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715456212994',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15059830121','15059830121','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715456212995',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18876291470','18876291470','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715456212996',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18965483880','18965483880','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715456212997',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13459523099','13459523099','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715460407298',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13950063837','13950063837','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715460407299',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13959280218','13959280218','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715460407300',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13788814546','13788814546','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715464601601',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959994811','15959994811','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715464601602',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13599954300','13599954300','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715464601603',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13105060008','13105060008','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715464601604',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15505950959','15505950959','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715468795905',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15205972628','15205972628','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715468795906',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13636995533','13636995533','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715468795907',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13666029324','13666029324','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715472990209',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13505959355','13505959355','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715472990210',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15159871537','15159871537','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715472990211',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15906005715','15906005715','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715472990212',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15159832652','15159832652','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715477184514',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18750914154','18750914154','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715477184515',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13960455227','13960455227','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715477184516',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13799758056','13799758056','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715477184517',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18965175339','18965175339','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715506544641',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13806969722','13806969722','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715510738946',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13950989318','13950989318','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715510738947',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18106930966','18106930966','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715510738948',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13808505732','13808505732','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715514933249',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15905022650','15905022650','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715514933250',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18750207251','18750207251','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715514933251',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13788828099','13788828099','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715514933252',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13505977599','13505977599','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715514933253',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18016516089','18016516089','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715514933254',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18659516267','18659516267','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715523321857',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15280871258','15280871258','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715523321858',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13489875197','13489875197','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715523321859',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13505956777','13505956777','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715523321860',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959853522','15959853522','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715523321861',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959525859','15959525859','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715527516162',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13489545332','13489545332','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715527516163',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13215066449','13215066449','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715527516164',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13975057391','13975057391','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715531710466',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13960358840','13960358840','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715531710467',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18350742084','18350742084','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715531710468',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15880939936','15880939936','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715531710469',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15559050207','15559050207','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715535904769',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13805145645','13805145645','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715535904770',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13646022408','13646022408','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715535904771',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15959595731','15959595731','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715540099073',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13600703996','13600703996','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715540099074',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13710228756','13710228756','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715540099075',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15859506299','15859506299','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715540099076',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13306051592','13306051592','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715544293378',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','17683234600','17683234600','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715577847809',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13600770238','13600770238','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715582042113',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18050877288','18050877288','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470715582042114',NULL,'1268470714810290178',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13850751502','13850751502','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:12:40',NULL,NULL,NULL,'2020-06-04 17:12:40',NULL,NULL,NULL),('1268470911112105986',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13906091693','13906091693','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911116300289',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15106088998','15106088998','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911116300290',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13808557909','13808557909','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911120494594',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18959988073','18959988073','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911120494595',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15059750761','15059750761','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911120494596',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','17613712423','17613712423','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911120494597',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13959888172','13959888172','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911124688897',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15059821270','15059821270','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911124688898',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18957137209','18957137209','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911124688899',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18750597755','18750597755','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911124688900',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15141988697','15141988697','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911124688901',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','17727971605','17727971605','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911128883202',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18953138447','18953138447','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911128883203',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15711502057','15711502057','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911128883204',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15860514476','15860514476','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911133077506',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18859907988','18859907988','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911133077507',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15759732116','15759732116','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911133077508',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15659050608','15659050608','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911133077509',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15904412438','15904412438','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911137271809',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','17359991180','17359991180','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911137271810',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15375771216','15375771216','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911137271811',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15260371606','15260371606','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911137271812',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13960270097','13960270097','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911141466113',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18965526351','18965526351','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911141466114',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','18659936998','18659936998','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911141466115',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13950175990','13950175990','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911141466116',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','13959992226','13959992226','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',3,'短信发送成功','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268470911145660418',NULL,'1268470910780755970',2,2,'批量发送(关于2019年度晋江市优秀人才认定材料审核未通过的通知20200604)','15964917281','15964917281','【晋江市人才服务平台】通知：您申请提交的2019年度晋江市优秀人才认定材料审核未通过，请及时与用人单位人才联络员联系，并登录“晋江市人才综合服务平台”点击“操作日志”，查看审核未通过原因。如有异议，请于2020年6月9日(下周二)前向晋江市公共就业和人才服务中心人才服务科反馈，联系电话0595-85633128。',2,'因用户关机或不在服务区里，手机信号端导致的失败。','2020-06-04 17:13:26',NULL,NULL,NULL,'2020-06-04 17:13:26',NULL,NULL,NULL),('1268473427145052162',NULL,'1268473427145052162',2,1,NULL,'13960228853','935949','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-04',NULL,NULL,NULL,'2020-06-04 17:23:26',NULL,NULL,NULL),('1268498652406534146',NULL,'1268498652406534146',2,1,NULL,'15860514476','957369','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-04',NULL,NULL,NULL,'2020-06-04 19:03:40',NULL,NULL,NULL),('1268716483932901378',NULL,'1268716483932901378',2,1,NULL,'18859920423','886620','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-05',NULL,NULL,NULL,'2020-06-05 09:29:16',NULL,NULL,NULL),('1268744559471415298','1214461743938473985','1268744559471415298',2,2,'福建七匹狼集团有限公司','13859769696','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-05',NULL,NULL,NULL,'2020-06-05 11:20:49',NULL,NULL,NULL),('1269615496156729345',NULL,'1269615496156729345',2,1,NULL,'13599272818','326573','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-07',NULL,NULL,NULL,'2020-06-07 21:01:37',NULL,NULL,NULL),('1269829989004529666',NULL,'1269829989004529666',2,1,NULL,'18859791858','283446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-08',NULL,NULL,NULL,'2020-06-08 11:13:56',NULL,NULL,NULL),('1269830910971269122',NULL,'1269830910971269122',2,1,NULL,'13774648357','423950','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-08',NULL,NULL,NULL,'2020-06-08 11:17:36',NULL,NULL,NULL),('1269892202088157186',NULL,'1269892202088157186',2,1,NULL,'13205059567','633396','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-08',NULL,NULL,NULL,'2020-06-08 15:21:09',NULL,NULL,NULL),('1269892511199973378',NULL,'1269892511199973378',2,1,NULL,'18050929285','506256','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-08',NULL,NULL,NULL,'2020-06-08 15:22:22',NULL,NULL,NULL),('1269892790104412161',NULL,'1269892790104412161',2,1,NULL,'18876549550','473116','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-08',NULL,NULL,NULL,'2020-06-08 15:23:29',NULL,NULL,NULL),('1270175479776727041',NULL,'1270175479776727041',2,1,NULL,'18160999097','317537','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-09',NULL,NULL,NULL,'2020-06-09 10:06:47',NULL,NULL,NULL),('1270178907538116609',NULL,'1270178907538116609',2,1,NULL,'13123108336','870522','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-09',NULL,NULL,NULL,'2020-06-09 10:20:24',NULL,NULL,NULL),('1270189438613377025',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059551567','15059551567','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438621765633',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15260305126','15260305126','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438621765634',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13655986799','13655986799','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438621765635',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13338562717','13338562717','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438621765636',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13506056368','13506056368','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438625959937',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13905958730','13905958730','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438625959938',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13774825517','13774825517','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438625959939',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13509362773','13509362773','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438625959940',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15906092370','15906092370','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438630154241',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13799555666','13799555666','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438630154242',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18605008168','18605008168','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438630154243',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13599162155','13599162155','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438630154244',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905907962','15905907962','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438630154245',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13144828970','13144828970','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438634348546',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15559162475','15559162475','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438634348547',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13850778776','13850778776','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438634348548',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18559161283','18559161283','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438634348549',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18650100145','18650100145','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438634348550',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13685908658','13685908658','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542849',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13599717008','13599717008','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542850',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15259546913','15259546913','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542851',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15260899107','15260899107','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542852',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980066202','15980066202','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542853',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059157225','15059157225','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542854',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15759488187','15759488187','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542855',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13774828120','13774828120','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438638542856',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18771094578','18771094578','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438642737154',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13400820519','13400820519','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438642737155',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18959805200','18959805200','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438642737156',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18695665035','18695665035','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438642737157',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13859727077','13859727077','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438667902977',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15345952654','15345952654','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438672097282',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15659972175','15659972175','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438672097283',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15359383363','15359383363','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438672097284',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13625979936','13625979936','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438672097285',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13514019395','13514019395','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438672097286',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15396608587','15396608587','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438672097287',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13969010619','13969010619','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438672097288',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15805981750','15805981750','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438676291586',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13842019660','13842019660','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438676291587',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13940108782','13940108782','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438676291588',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18862155925','18862155925','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438676291589',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18275745728','18275745728','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438676291590',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13799487213','13799487213','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438676291591',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15960707755','15960707755','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438676291592',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18468034987','18468034987','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485889',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13860116953','13860116953','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485890',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18805920922','18805920922','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485891',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18659030881','18659030881','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485892',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17006098806','17006098806','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485893',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17359711663','17359711663','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485894',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059803792','15059803792','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485895',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13436970465','13436970465','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438680485896',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980013301','15980013301','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438684680194',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13950430719','13950430719','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438684680195',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18900336517','18900336517','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438684680196',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18105907301','18105907301','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438684680197',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18851401527','18851401527','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438684680198',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18020867909','18020867909','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438684680199',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15860257142','15860257142','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438684680200',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18876336921','18876336921','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438709846017',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15806032297','15806032297','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438714040322',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18965785175','18965785175','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438714040323',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15005062379','15005062379','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438714040324',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18950700105','18950700105','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438714040325',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18741355270','18741355270','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438714040326',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18150563203','18150563203','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438714040327',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13075572292','13075572292','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438718234626',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18649652527','18649652527','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438718234627',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17741357996','17741357996','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438718234628',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15090088338','15090088338','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438718234629',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13599220676','13599220676','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438718234630',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18900371513','18900371513','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438718234631',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15191818740','15191818740','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438718234632',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18696960184','18696960184','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438722428930',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905037555','15905037555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438722428931',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15960551920','15960551920','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438722428932',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15629795466','15629795466','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438722428933',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18959941093','18959941093','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438722428934',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13599279399','13599279399','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438722428935',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13505906457','13505906457','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438722428936',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18571081281','18571081281','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623233',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18859464970','18859464970','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623234',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13027105101','13027105101','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623235',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17758709290','17758709290','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623236',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13425480722','13425480722','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623237',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18050929268','18050929268','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623238',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13816975274','13816975274','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623239',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13178336506','13178336506','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438726623240',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13600703008','13600703008','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438730817538',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','14759154723','14759154723','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438751789058',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18262283166','18262283166','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438751789059',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059719567','15059719567','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438755983362',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15960402869','15960402869','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438755983363',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18829340451','18829340451','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438755983364',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15559110466','15559110466','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438755983365',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15191845928','15191845928','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438755983366',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13122120652','13122120652','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438755983367',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15191815436','15191815436','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438755983368',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13959264368','13959264368','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438760177666',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15080318157','15080318157','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438760177667',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060823577','15060823577','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438760177668',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18659066928','18659066928','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438760177669',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18559472664','18559472664','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438760177670',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18150591518','18150591518','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438760177671',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13860752060','13860752060','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438760177672',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13328555097','13328555097','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438764371969',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17759892862','17759892862','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438764371970',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18876272213','18876272213','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438764371971',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18829298483','18829298483','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438764371972',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13313825373','13313825373','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438764371973',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18250850010','18250850010','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438764371974',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13559554933','13559554933','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438768566274',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15389303652','15389303652','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438768566275',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15805955751','15805955751','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438768566276',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13649283497','13649283497','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438768566277',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959590927','15959590927','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438768566278',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18065606507','18065606507','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438768566279',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18192276329','18192276329','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438772760578',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15759590781','15759590781','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438772760579',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13614268392','13614268392','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438797926401',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18701704136','18701704136','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1270189438797926402',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18898408023','18898408023','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120705',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18506966086','18506966086','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120706',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15702950980','15702950980','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120707',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18806028372','18806028372','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120708',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18605914467','18605914467','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120709',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18065525518','18065525518','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120710',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17750792370','17750792370','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120711',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959873463','15959873463','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438802120712',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15191815139','15191815139','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438806315010',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15805097777','15805097777','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438806315011',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059850519','15059850519','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438806315012',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18392859639','18392859639','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438806315013',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13484917236','13484917236','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438806315014',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15029140185','15029140185','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438806315015',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15903645816','15903645816','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438806315016',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18659719331','18659719331','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509314',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13072350035','13072350035','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509315',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905050688','15905050688','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509316',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15202404290','15202404290','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509317',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15821998683','15821998683','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509318',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15111982965','15111982965','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509319',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980011425','15980011425','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509320',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15259519391','15259519391','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438810509321',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15202427957','15202427957','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438814703617',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959581739','15959581739','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438814703618',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15527179406','15527179406','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438814703619',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13799898116','13799898116','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438814703620',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15029236362','15029236362','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438814703621',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13959861620','13959861620','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438835675137',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13805956558','13805956558','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438839869442',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13808549828','13808549828','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438839869443',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060832111','15060832111','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438839869444',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18959995002','18959995002','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438839869445',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060972472','15060972472','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438839869446',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13600701178','13600701178','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438839869447',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15623564761','15623564761','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438844063745',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13859754633','13859754633','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438844063746',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13459562051','13459562051','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438844063747',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15605003638','15605003638','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438844063748',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905996868','15905996868','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438844063749',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15860517253','15860517253','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438844063750',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13512216307','13512216307','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438844063751',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13559532808','13559532808','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258049',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980036243','15980036243','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258050',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15860901713','15860901713','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258051',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18960279877','18960279877','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258052',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880931696','15880931696','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258053',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15359556333','15359556333','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258054',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18350062033','18350062033','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258055',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18359837870','18359837870','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438848258056',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18059993901','18059993901','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438852452354',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13636903309','13636903309','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438852452355',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13905971030','13905971030','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438852452356',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13515055988','13515055988','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438852452357',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959888180','15959888180','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438852452358',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13636906289','13636906289','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438852452359',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13774877242','13774877242','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438852452360',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13850772504','13850772504','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438856646658',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','19959999508','19959999508','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438877618177',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13559591215','13559591215','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438881812482',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15260399516','15260399516','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438881812483',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905006169','15905006169','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438881812484',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15985959061','15985959061','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438881812485',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059528748','15059528748','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438881812486',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13850755588','13850755588','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438886006785',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15985905430','15985905430','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438886006786',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18959996388','18959996388','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438886006787',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13489719977','13489719977','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438886006788',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959592923','15959592923','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438886006789',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13559592136','13559592136','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438886006790',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13505045259','13505045259','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438886006791',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959592127','15959592127','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438890201089',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18750931024','18750931024','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438890201090',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13960391700','13960391700','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438890201091',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880762096','15880762096','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438890201092',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13906934045','13906934045','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438890201093',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15260852001','15260852001','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438890201094',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060806451','15060806451','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438890201095',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15859796399','15859796399','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395393',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15359493923','15359493923','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395394',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13959882723','13959882723','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395395',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15074870926','15074870926','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395396',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13774898032','13774898032','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395397',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060990680','15060990680','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395398',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18650917845','18650917845','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395399',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18850547191','18850547191','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438894395400',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15985923093','15985923093','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438898589697',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13950362316','13950362316','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438898589698',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13788852001','13788852001','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438923755522',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13615922291','13615922291','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438927949825',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15806036626','15806036626','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438927949826',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880825431','15880825431','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438927949827',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13159012670','13159012670','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438927949828',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18259060411','18259060411','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144130',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13075877415','13075877415','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144131',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13860631416','13860631416','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144132',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060933526','15060933526','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144133',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13636993769','13636993769','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144134',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18250292550','18250292550','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144135',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17512098847','17512098847','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144136',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18050056871','18050056871','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438932144137',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18159235825','18159235825','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438936338433',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18350535110','18350535110','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438936338434',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15859468355','15859468355','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438936338435',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15259471016','15259471016','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438936338436',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880758500','15880758500','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438936338437',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15960581457','15960581457','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438936338438',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13459246092','13459246092','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438936338439',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13627292269','13627292269','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532737',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13599719905','13599719905','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532738',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15846593350','15846593350','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532739',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15810298887','15810298887','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532740',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15605009590','15605009590','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532741',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13805948042','13805948042','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532742',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059510022','15059510022','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532743',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880818089','15880818089','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438940532744',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18606031846','18606031846','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438944727041',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13689056004','13689056004','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438944727042',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905070935','15905070935','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438969892865',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18750537614','18750537614','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438974087169',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18050869127','18050869127','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438974087170',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18876240048','18876240048','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438978281473',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18805921912','18805921912','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438978281474',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18835792826','18835792826','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438978281475',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18215628161','18215628161','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438978281476',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13788803006','13788803006','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438978281477',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980301999','15980301999','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438978281478',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18722334354','18722334354','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438982475778',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18202655266','18202655266','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438982475779',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18581998214','18581998214','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438982475780',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059839423','15059839423','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438982475781',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15860358661','15860358661','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438982475782',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18559511816','18559511816','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438982475783',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959264462','15959264462','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438982475784',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15559528807','15559528807','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438986670082',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880027485','15880027485','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438986670083',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13706991487','13706991487','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438986670084',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13055336977','13055336977','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438986670085',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13030978969','13030978969','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438986670086',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15906066000','15906066000','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438986670087',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980274172','15980274172','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438990864385',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060804302','15060804302','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438990864386',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18650916825','18650916825','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438990864387',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15280404202','15280404202','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438990864388',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13328979519','13328979519','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438990864389',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18350776066','18350776066','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438990864390',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18868801836','18868801836','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438990864391',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18859716793','18859716793','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189438995058689',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15805990003','15805990003','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439020224514',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880480928','15880480928','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439024418818',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13635240509','13635240509','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439024418819',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15259758239','15259758239','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439024418820',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18250882613','18250882613','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439024418821',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15860353200','15860353200','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439024418822',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905996655','15905996655','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439028613121',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18965513668','18965513668','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439028613122',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18046009745','18046009745','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439028613123',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15160441962','15160441962','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439028613124',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15960746554','15960746554','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439032807425',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13685000414','13685000414','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439032807426',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15759296423','15759296423','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439032807427',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959552577','15959552577','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439032807428',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15805073665','15805073665','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439032807429',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18876568900','18876568900','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439037001730',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15205011506','15205011506','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439037001731',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18250422227','18250422227','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439037001732',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18950490831','18950490831','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439037001733',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959530855','15959530855','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439041196034',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15705923619','15705923619','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439041196035',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15259597676','15259597676','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439041196036',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18429006632','18429006632','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439041196037',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15359855333','15359855333','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439041196038',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15260225737','15260225737','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439045390338',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18703659101','18703659101','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439045390339',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13599177919','13599177919','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439045390340',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13696857207','13696857207','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439045390341',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13505905685','13505905685','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439049584642',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13675918895','13675918895','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439049584643',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980025829','15980025829','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439074750466',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13799855086','13799855086','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439078944770',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13960257652','13960257652','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439078944771',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15080426614','15080426614','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439078944772',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18750651805','18750651805','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439078944773',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18659005089','18659005089','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439078944774',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13506095562','13506095562','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439078944775',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13960256303','13960256303','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439078944776',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13665903960','13665903960','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439083139073',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13960256111','13960256111','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439083139074',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18905079898','18905079898','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439083139075',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18959853655','18959853655','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439083139076',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13601076764','13601076764','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439083139077',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13505050692','13505050692','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439083139078',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18905060268','18905060268','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333378',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13959955769','13959955769','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333379',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18965667777','18965667777','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333380',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18759922187','18759922187','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333381',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15859590857','15859590857','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333382',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13850757007','13850757007','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333383',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18859225776','18859225776','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333384',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959962792','15959962792','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439087333385',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18030243370','18030243370','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439091527682',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18259061182','18259061182','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439091527683',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13799857333','13799857333','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439091527684',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059597777','15059597777','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439091527685',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18850383723','18850383723','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439091527686',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059871315','15059871315','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439091527687',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880024622','15880024622','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439091527688',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15980041722','15980041722','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439095721985',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13600766763','13600766763','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439116693506',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18850549376','18850549376','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439120887810',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15060827887','15060827887','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439120887811',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18859495931','18859495931','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439120887812',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18605958852','18605958852','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439125082114',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15805060325','15805060325','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439125082115',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15880764254','15880764254','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439125082116',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13959888168','13959888168','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439125082117',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18750561717','18750561717','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439125082118',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17606025253','17606025253','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439125082119',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13599717079','13599717079','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439125082120',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13615908669','13615908669','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439129276417',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13386880667','13386880667','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439129276418',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13506030795','13506030795','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439129276419',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15959882366','15959882366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439129276420',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15905988871','15905988871','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439129276421',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15960250972','15960250972','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439129276422',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18005073259','18005073259','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439129276423',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18005065560','18005065560','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439133470721',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15605959006','15605959006','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439133470722',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13645971717','13645971717','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439133470723',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18050270931','18050270931','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439133470724',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','17758766631','17758766631','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439133470725',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13305952629','13305952629','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439133470726',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15659132085','15659132085','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439133470727',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18050916965','18050916965','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439137665026',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18050876301','18050876301','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439137665027',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15396596855','15396596855','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439137665028',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13559513508','13559513508','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439137665029',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13229424859','13229424859','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439137665030',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13645032611','13645032611','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439162830850',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15059154896','15059154896','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439167025154',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18650591551','18650591551','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439167025155',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','15759216753','15759216753','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439167025156',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','18805065856','18805065856','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189439167025157',NULL,'1270189438168780802',2,2,'批量发送(关注人才晋江公众号20200609)','13328883775','13328883775','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:15',NULL,NULL,NULL,'2020-06-09 11:02:15',NULL,NULL,NULL),('1270189623544434689',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959858592','18959858592','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623548628993',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965129895','18965129895','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623552823298',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13255957226','13255957226','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623552823299',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13666026522','13666026522','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623552823300',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13801333177','13801333177','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623552823301',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15106096021','15106096021','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623552823302',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959847128','18959847128','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623552823303',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13802609526','13802609526','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623552823304',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506086731','13506086731','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623557017601',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18016585576','18016585576','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623557017602',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959798579','15959798579','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623557017603',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859971221','18859971221','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623557017604',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18250298076','18250298076','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623557017605',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18065376686','18065376686','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623557017606',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15602265352','15602265352','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623557017607',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906099888','13906099888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211905',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13809549382','13809549382','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211906',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876509838','18876509838','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211907',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905070552','13905070552','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211908',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13705941428','13705941428','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211909',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15159878799','15159878799','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211910',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905089190','13905089190','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211911',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960381057','13960381057','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623561211912',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980788802','15980788802','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623565406209',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15985952242','15985952242','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623565406210',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13055808024','13055808024','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623565406211',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13950920100','13950920100','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623565406212',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13105079935','13105079935','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623565406213',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799966695','13799966695','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623565406214',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805032333','15805032333','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623565406215',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505080996','13505080996','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623603154945',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959705077','18959705077','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623603154946',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965689935','18965689935','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623607349250',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','19852121931','19852121931','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623607349251',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18960206656','18960206656','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623607349252',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880720190','15880720190','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623607349253',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15810812160','15810812160','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623607349254',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905975119','13905975119','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623607349255',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18960278086','18960278086','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623607349256',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18759429880','18759429880','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623611543554',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18609586661','18609586661','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623611543555',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13306995188','13306995188','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623611543556',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059792958','15059792958','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623611543557',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13305967663','13305967663','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623611543558',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13306995039','13306995039','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623611543559',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808510760','13808510760','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623611543560',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959896966','15959896966','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737858',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905952020','13905952020','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737859',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959995705','18959995705','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737860',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805957081','13805957081','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737861',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13559566696','13559566696','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737862',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859990000','18859990000','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737863',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860395678','15860395678','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737864',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980325929','15980325929','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623615737865',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859759601','15859759601','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623619932162',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805946193','13805946193','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623619932163',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13044554499','13044554499','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623619932164',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18006037555','18006037555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623619932165',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18350782990','18350782990','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623619932166',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506060342','13506060342','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623619932167',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788851759','13788851759','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623649292290',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13615901213','13615901213','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623649292291',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599212929','13599212929','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623653486593',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805021228','15805021228','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623653486594',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15750768536','15750768536','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623653486595',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506000615','13506000615','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623653486596',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905974006','13905974006','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623653486597',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13358591930','13358591930','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623653486598',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959995535','15959995535','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623653486599',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13559593361','13559593361','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680898',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960417367','13960417367','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680899',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599109151','13599109151','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680900',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15659878695','15659878695','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680901',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965689828','18965689828','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680902',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859969666','18859969666','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680903',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18960357668','18960357668','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680904',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260875883','15260875883','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623657680905',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15160423086','15160423086','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623661875201',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13705943966','13705943966','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623661875202',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15611255393','15611255393','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623661875203',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636963633','13636963633','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623661875204',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18721796963','18721796963','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623661875205',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13656038332','13656038332','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623661875206',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13675953607','13675953607','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623661875207',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959210622','18959210622','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623666069505',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805900098','13805900098','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623666069506',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859932277','18859932277','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623666069507',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15306089555','15306089555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623666069508',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905079361','15905079361','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623666069509',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18618285267','18618285267','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623666069510',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859799829','18859799829','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623691235330',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13337211223','13337211223','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623695429633',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600757303','13600757303','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623695429634',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13626072564','13626072564','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623695429635',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13615950806','13615950806','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623695429636',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906933286','13906933286','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623695429637',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18605958880','18605958880','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623695429638',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788846820','13788846820','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623695429639',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260782666','15260782666','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623938',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905985809','13905985809','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623939',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260803666','15260803666','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623940',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659030309','18659030309','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623941',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805919195','13805919195','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623942',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15392288855','15392288855','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623943',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600754180','13600754180','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623944',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17689485050','17689485050','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623699623945',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880785555','15880785555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818242',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15960692650','15960692650','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818243',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599780560','13599780560','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818244',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15259571333','15259571333','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818245',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959712401','13959712401','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818246',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18516157979','18516157979','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818247',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13328509988','13328509988','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818248',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13655902993','13655902993','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623703818249',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860398018','15860398018','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623708012546',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859551760','18859551760','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623708012547',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18606989818','18606989818','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623708012548',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13395096999','13395096999','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623708012549',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959858506','18959858506','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623708012550',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15985918296','15985918296','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623708012551',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960341716','13960341716','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623728984066',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880972652','15880972652','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623733178370',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980313135','15980313135','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623733178371',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906096567','13906096567','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623733178372',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15080070385','15080070385','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623733178373',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13675995249','13675995249','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623737372674',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15995216889','15995216889','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623737372675',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260429705','15260429705','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623737372676',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959778888','13959778888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623737372677',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905968151','13905968151','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623737372678',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959776520','13959776520','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623737372679',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799521561','13799521561','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623737372680',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13720842620','13720842620','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566978',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659915000','18659915000','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566979',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13205061526','13205061526','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566980',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060626155','15060626155','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566981',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959237668','13959237668','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566982',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13779911861','13779911861','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566983',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13601032833','13601032833','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566984',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506042338','13506042338','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623741566985',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18567651331','18567651331','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623745761281',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959959200','15959959200','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623745761282',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960291518','13960291518','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623745761283',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13859796953','13859796953','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623745761284',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15850693987','15850693987','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623745761285',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959870601','15959870601','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623745761286',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876572155','18876572155','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623745761287',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959753823','13959753823','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623749955585',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13459034477','13459034477','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623749955586',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860688762','15860688762','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623749955587',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859596380','18859596380','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623770927106',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15502179365','15502179365','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623775121410',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15086777305','15086777305','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623775121411',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18850528121','18850528121','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623775121412',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18052150317','18052150317','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623775121413',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17689683160','17689683160','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623775121414',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859757759','18859757759','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623775121415',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18359810815','18359810815','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623779315714',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505957512','13505957512','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623779315715',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13696949262','13696949262','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623779315716',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17689690969','17689690969','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623779315717',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959813876','18959813876','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623779315718',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805924801','13805924801','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623779315719',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18250169959','18250169959','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623779315720',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15005059367','15005059367','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623783510017',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15502207706','15502207706','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623783510018',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788829369','13788829369','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623783510019',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18059037101','18059037101','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623783510020',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859760088','18859760088','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623783510021',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15392286115','15392286115','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623783510022',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636957868','13636957868','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623783510023',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880974760','15880974760','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623787704321',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13794913769','13794913769','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623787704322',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15259555555','15259555555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623787704323',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18960285333','18960285333','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623787704324',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959997270','18959997270','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623787704325',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15392288851','15392288851','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623787704326',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960207400','13960207400','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623787704327',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15946798736','15946798736','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623791898626',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17750799505','17750799505','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623791898627',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13666988888','13666988888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623821258754',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17750103317','17750103317','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623821258755',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15622174598','15622174598','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623821258756',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260807555','15260807555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623825453058',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905958858','15905958858','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623825453059',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15080458330','15080458330','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623825453060',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15359585555','15359585555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623825453061',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059748612','15059748612','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623825453062',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18065333731','18065333731','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623825453063',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959889099','15959889099','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623825453064',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17605014353','17605014353','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623829647361',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13459504545','13459504545','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623829647362',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15396597171','15396597171','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623829647363',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18605001616','18605001616','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623829647364',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260785666','15260785666','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623829647365',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18106980703','18106980703','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623829647366',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959975329','13959975329','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623829647367',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13285030066','13285030066','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623833841666',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959855726','18959855726','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623833841667',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18046360864','18046360864','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623833841668',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13459556182','13459556182','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623833841669',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060456431','15060456431','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623833841670',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860300607','13860300607','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623833841671',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13306995027','13306995027','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623833841672',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18796922940','18796922940','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623838035969',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13325253201','13325253201','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623838035970',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18350777627','18350777627','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623838035971',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599159330','13599159330','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623838035972',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18020650858','18020650858','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623838035973',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13328963385','13328963385','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623838035974',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13709857491','13709857491','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623867396098',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13489312968','13489312968','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623867396099',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15960408186','15960408186','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623867396100',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859780809','18859780809','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623867396101',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15359590811','15359590811','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623871590402',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959119986','13959119986','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623871590403',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505951467','13505951467','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623871590404',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15141327771','15141327771','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623871590405',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599949096','13599949096','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623871590406',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980000372','15980000372','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623871590407',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905089834','13905089834','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623871590408',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965687332','18965687332','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784706',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959951039','13959951039','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784707',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960259639','13960259639','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784708',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18250155553','18250155553','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784709',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18359714502','18359714502','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784710',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965687331','18965687331','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784711',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905085845','13905085845','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784712',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980060559','15980060559','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623875784713',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960359859','13960359859','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623879979010',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965523733','18965523733','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623879979011',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17759991213','17759991213','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623879979012',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959579818','15959579818','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623879979013',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505008588','13505008588','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623879979014',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15029265211','15029265211','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623879979015',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18650908918','18650908918','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623879979016',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980000359','15980000359','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623884173314',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17755092627','17755092627','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623884173315',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960256299','13960256299','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623884173316',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980000660','15980000660','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623884173317',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18722290558','18722290558','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623905144834',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636950764','13636950764','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623909339137',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18539456470','18539456470','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623909339138',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13669274728','13669274728','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623909339139',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659003978','18659003978','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623909339140',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','19959848541','19959848541','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623909339141',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17689494919','17689494919','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623913533442',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959517575','15959517575','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623913533443',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906095618','13906095618','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623913533444',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505986964','13505986964','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623913533445',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18740431050','18740431050','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623913533446',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505050069','13505050069','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623913533447',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18759919815','18759919815','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623913533448',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13314987388','13314987388','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623917727745',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15759496852','15759496852','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623917727746',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059556400','15059556400','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623917727747',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859996145','18859996145','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623917727748',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13400808814','13400808814','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623917727749',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905950588','13905950588','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623917727750',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15960753968','15960753968','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623917727751',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15315563156','15315563156','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922049',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13665959771','13665959771','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922050',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906903291','13906903291','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922051',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18705052323','18705052323','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922052',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959505915','15959505915','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922053',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505932929','13505932929','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922054',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18159276351','18159276351','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922055',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960282791','13960282791','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623921922056',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799552053','13799552053','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623926116353',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13626066721','13626066721','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623926116354',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13030981560','13030981560','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623947087873',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15259223745','15259223745','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623947087874',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659568811','18659568811','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623947087875',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15559544571','15559544571','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623951282177',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506054328','13506054328','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623951282178',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15759733818','15759733818','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623951282179',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860902967','15860902967','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623951282180',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13067154015','13067154015','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623951282181',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13328500766','13328500766','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623951282182',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799557193','13799557193','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623955476482',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905055474','13905055474','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623955476483',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18606985861','18606985861','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623955476484',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876223641','18876223641','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623955476485',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788869420','13788869420','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623955476486',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18606056998','18606056998','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623955476487',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659003000','18659003000','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623955476488',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506969315','13506969315','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623959670785',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13313872221','13313872221','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623959670786',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13328989299','13328989299','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623959670787',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260704530','15260704530','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623959670788',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799564888','13799564888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623959670789',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18350770992','18350770992','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623963865090',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15659512626','15659512626','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623963865091',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905089465','13905089465','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623963865092',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15559067588','15559067588','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623963865093',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18603006276','18603006276','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623963865094',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','19906870165','19906870165','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623963865095',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959953589','13959953589','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623963865096',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13489858089','13489858089','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623968059393',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13400840823','13400840823','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623968059394',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805957117','13805957117','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623993225217',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960311095','13960311095','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623997419522',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17350011170','17350011170','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623997419523',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860750864','13860750864','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623997419524',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808556705','13808556705','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623997419525',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13256678813','13256678813','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623997419526',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905957105','13905957105','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623997419527',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506928380','13506928380','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189623997419528',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805959366','13805959366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613826',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15029279845','15029279845','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613827',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15979017673','15979017673','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613828',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15620636649','15620636649','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613829',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13484540329','13484540329','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613830',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18316739194','18316739194','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613831',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18359877950','18359877950','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613832',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13488103520','13488103520','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624001613833',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13501115138','13501115138','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624005808129',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805959125','13805959125','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624005808130',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18850496760','18850496760','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624005808131',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13572104402','13572104402','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624005808132',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659262866','18659262866','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624005808133',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15985751705','15985751705','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624005808134',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805010196','15805010196','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624005808135',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505056755','13505056755','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624010002434',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506069249','13506069249','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624010002435',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906998897','13906998897','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624010002436',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13696900561','13696900561','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624010002437',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13774878631','13774878631','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624010002438',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599161927','13599161927','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624010002439',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15759653345','15759653345','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624010002440',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18516970130','18516970130','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624039362561',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18046311397','18046311397','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624039362562',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906999100','13906999100','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624039362563',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18292635234','18292635234','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624043556866',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15029278847','15029278847','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624043556867',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13859751591','13859751591','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624043556868',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636950560','13636950560','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624043556869',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959840868','13959840868','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624043556870',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15396583913','15396583913','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624043556871',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13920285434','13920285434','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624043556872',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15829907184','15829907184','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751169',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600753338','13600753338','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751170',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860902576','15860902576','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751171',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505059996','13505059996','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751172',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13489848301','13489848301','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751173',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505058832','13505058832','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751174',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13625959920','13625959920','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751175',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805945051','13805945051','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624047751176',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13950238890','13950238890','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945474',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13004886898','13004886898','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945475',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599936037','13599936037','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945476',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18960259259','18960259259','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945477',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13612150403','13612150403','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945478',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13720852551','13720852551','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945479',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13410024480','13410024480','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945480',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600738975','13600738975','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624051945481',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599127767','13599127767','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624056139777',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13659192458','13659192458','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624056139778',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506066917','13506066917','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624056139779',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788811853','13788811853','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624056139780',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506956209','13506956209','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624077111297',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959992832','18959992832','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624081305601',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060998567','15060998567','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624081305602',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13850799806','13850799806','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624081305603',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13358577766','13358577766','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624081305604',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905035169','15905035169','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624081305605',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959553375','15959553375','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499906',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15960795588','15960795588','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499907',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506941213','13506941213','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499908',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965699955','18965699955','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499909',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805950256','13805950256','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499910',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15080421696','15080421696','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499911',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905095955','15905095955','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499912',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17706067083','17706067083','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624085499913',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859495050','15859495050','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624089694209',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805952318','15805952318','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624089694210',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799239878','13799239878','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624089694211',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600751875','13600751875','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624089694212',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13859775220','13859775220','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624089694213',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905077879','15905077879','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624089694214',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905006716','15905006716','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624089694215',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13055667605','13055667605','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888514',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13850777555','13850777555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888515',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636905051','13636905051','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888516',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13625994626','13625994626','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888517',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860763453','13860763453','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888518',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13004800144','13004800144','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888519',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13850777672','13850777672','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888520',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18059983988','18059983988','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624093888521',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799240204','13799240204','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624098082818',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600709507','13600709507','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624119054337',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959596201','15959596201','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624119054338',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','19959999308','19959999308','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624119054339',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799850617','13799850617','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248642',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808512082','13808512082','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248643',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13615940087','13615940087','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248644',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959926888','13959926888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248645',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059557916','15059557916','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248646',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13950108669','13950108669','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248647',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808510666','13808510666','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248648',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799797017','13799797017','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624123248649',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505992220','13505992220','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624127442945',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959941521','13959941521','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624127442946',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860703356','13860703356','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624127442947',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18633637251','18633637251','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624127442948',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959856161','13959856161','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624127442949',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506055166','13506055166','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624127442950',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959910000','13959910000','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624127442951',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880881006','15880881006','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637249',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960382970','13960382970','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637250',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860757775','13860757775','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637251',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15906066156','15906066156','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637252',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860396396','15860396396','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637253',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060946052','15060946052','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637254',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18815985602','18815985602','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637255',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880881883','15880881883','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624131637256',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905059153','13905059153','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624135831553',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18950026794','18950026794','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624135831554',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13859989821','13859989821','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624135831555',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506045449','13506045449','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624135831556',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960459977','13960459977','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624156803074',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876539791','18876539791','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624160997377',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860302368','15860302368','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624160997378',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505961108','13505961108','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624160997379',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960292725','13960292725','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624160997380',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905032289','15905032289','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624160997381',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659060047','18659060047','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191682',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599994541','13599994541','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191683',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859577452','15859577452','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191684',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13559045209','13559045209','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191685',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980065535','15980065535','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191686',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260101691','15260101691','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191687',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18759508729','18759508729','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191688',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799896025','13799896025','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624165191689',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15159529936','15159529936','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385985',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18905951960','18905951960','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385986',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880161129','15880161129','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385987',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599507077','13599507077','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385988',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799202233','13799202233','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385989',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13655933296','13655933296','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385990',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13950299290','13950299290','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385991',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505907585','13505907585','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624169385992',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13606051571','13606051571','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624173580289',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059520014','15059520014','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624173580290',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15601588313','15601588313','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624173580291',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506066359','13506066359','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624173580292',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799899315','13799899315','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624173580293',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860703516','13860703516','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624173580294',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980456333','15980456333','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624173580295',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506083126','13506083126','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624177774594',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15005936026','15005936026','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624207134721',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600703472','13600703472','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624207134722',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905350771','13905350771','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624211329025',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959752857','13959752857','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624211329026',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059832543','15059832543','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624211329027',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18150983366','18150983366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624211329028',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980235626','15980235626','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624211329029',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13559575942','13559575942','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624211329030',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659737170','18659737170','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624211329031',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15106087765','15106087765','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624215523329',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13110816682','13110816682','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624215523330',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905044580','15905044580','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624215523331',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599115973','13599115973','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624215523332',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15659450305','15659450305','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624215523333',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13675930836','13675930836','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624215523334',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17359990624','17359990624','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717633',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15505952026','15505952026','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717634',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13685910527','13685910527','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717635',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15083847155','15083847155','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717636',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15106037664','15106037664','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717637',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808543336','13808543336','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717638',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13615922291','13615922291','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717639',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965636930','18965636930','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624219717640',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960296362','13960296362','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624223911938',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13063191843','13063191843','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624223911939',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15911052916','15911052916','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624223911940',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506062515','13506062515','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624223911941',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15259555117','15259555117','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624223911942',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17612198088','17612198088','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624223911943',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659822922','18659822922','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624223911944',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13520554703','13520554703','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624249077762',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13655601013','13655601013','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624249077763',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15080417163','15080417163','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624253272066',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15827609588','15827609588','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624253272067',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859785085','18859785085','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624253272068',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15359383458','15359383458','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624253272069',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905975697','15905975697','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624253272070',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905076266','15905076266','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624253272071',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980271486','15980271486','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624257466370',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13110592357','13110592357','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624257466371',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859775715','15859775715','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624257466372',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808540799','13808540799','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624257466373',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15392481724','15392481724','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624257466374',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880975265','15880975265','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624257466375',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860328381','15860328381','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624257466376',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18605001313','18605001313','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660674',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959940177','13959940177','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660675',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18225662357','18225662357','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660676',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18905080205','18905080205','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660677',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506057070','13506057070','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660678',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060985107','15060985107','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660679',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060032495','15060032495','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660680',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860726225','13860726225','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624261660681',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13121833855','13121833855','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624265854977',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17750989111','17750989111','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624265854978',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13685921872','13685921872','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624265854979',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980063533','15980063533','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624265854980',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860143467','13860143467','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624265854981',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260237093','15260237093','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624265854982',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960250701','13960250701','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624265854983',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599505962','13599505962','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624291020802',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18559273254','18559273254','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624291020803',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18950070276','18950070276','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624291020804',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13404252272','13404252272','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624291020805',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17388204055','17388204055','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624295215105',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15259729821','15259729821','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624295215106',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13459599999','13459599999','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624295215107',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059823968','15059823968','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624295215108',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13407735197','13407735197','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624295215109',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17715205257','17715205257','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624295215110',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15326179637','15326179637','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624299409410',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860301827','15860301827','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624299409411',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905057579','15905057579','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624299409412',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18060501876','18060501876','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624299409413',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13400887176','13400887176','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624303603713',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18050020726','18050020726','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624303603714',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13055224466','13055224466','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624303603715',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15106033846','15106033846','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624307798017',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880990268','15880990268','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624307798018',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18698399527','18698399527','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624307798019',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18314463516','18314463516','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624307798020',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','19905053569','19905053569','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624311992322',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13950364429','13950364429','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624311992323',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805026065','15805026065','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624311992324',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18750530127','18750530127','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624311992325',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13950092022','13950092022','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624311992326',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980067586','15980067586','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624316186625',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13859790099','13859790099','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624316186626',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260200619','15260200619','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624316186627',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965658201','18965658201','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624316186628',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059755771','15059755771','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624341352450',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15827436094','15827436094','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624341352451',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13459533442','13459533442','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624345546754',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13696856720','13696856720','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624345546755',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15159887877','15159887877','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624345546756',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599172228','13599172228','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624345546757',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505008000','13505008000','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624345546758',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805956092','13805956092','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624345546759',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880754887','15880754887','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741057',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18698360960','18698360960','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741058',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13085059001','13085059001','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741059',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13665965633','13665965633','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741060',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805003589','15805003589','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741061',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859554650','15859554650','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741062',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260720911','15260720911','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741063',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859498656','18859498656','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624349741064',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876284599','18876284599','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624353935361',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876377906','18876377906','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624353935362',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13950317095','13950317095','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624353935363',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905055709','15905055709','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624353935364',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13159060909','13159060909','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624353935365',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15201615843','15201615843','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624353935366',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18065589080','18065589080','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624353935367',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18411037910','18411037910','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624358129666',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505054724','13505054724','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624358129667',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13859745152','13859745152','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624358129668',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15906061807','15906061807','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624358129669',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659923130','18659923130','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624358129670',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860516215','15860516215','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624358129671',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859565605','15859565605','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624358129672',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18682261122','18682261122','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624387489794',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15159724662','15159724662','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624391684097',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18698372705','18698372705','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624391684098',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906998716','13906998716','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624391684099',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860900865','15860900865','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624391684100',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18815997296','18815997296','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624391684101',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959232693','15959232693','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624391684102',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18159595252','18159595252','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624391684103',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959700369','18959700369','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624395878401',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859559078','15859559078','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624395878402',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505990915','13505990915','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624395878403',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13779982480','13779982480','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624395878404',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13615963766','13615963766','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624395878405',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959966729','15959966729','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624395878406',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13825584576','13825584576','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624400072705',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15122460079','15122460079','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624400072706',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506061896','13506061896','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624400072707',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15922263220','15922263220','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624400072708',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600759390','13600759390','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624400072709',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13275049035','13275049035','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624400072710',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13030982553','13030982553','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624400072711',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18559552007','18559552007','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624404267010',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599710039','13599710039','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624404267011',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799239129','13799239129','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624404267012',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18292491251','18292491251','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624404267013',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15159739903','15159739903','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624404267014',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859781366','18859781366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624404267015',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18006037070','18006037070','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624404267016',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18906999069','18906999069','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624408461314',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876569027','18876569027','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624408461315',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859553823','15859553823','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624433627138',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506998846','13506998846','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624437821441',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980068126','15980068126','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624437821442',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960259810','13960259810','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624437821443',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18876539839','18876539839','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624437821444',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18050878555','18050878555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624437821445',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960826248','13960826248','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624437821446',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15280423942','15280423942','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624437821447',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659069495','18659069495','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624442015745',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18006990697','18006990697','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624442015746',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959812033','13959812033','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624442015747',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15159790586','15159790586','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624442015748',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13859085700','13859085700','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624442015749',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808505910','13808505910','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624442015750',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15806017885','15806017885','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624442015751',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805956361','15805956361','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210050',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980232523','15980232523','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210051',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13110982808','13110982808','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210052',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18046040451','18046040451','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210053',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959569933','15959569933','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210054',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15860356356','15860356356','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210055',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18805025309','18805025309','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210056',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13055650678','13055650678','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624446210057',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960254757','13960254757','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624450404353',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15806019077','15806019077','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624450404354',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505097888','13505097888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624450404355',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599106745','13599106745','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624450404356',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959717283','13959717283','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624450404357',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636959434','13636959434','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624450404358',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905985743','13905985743','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624450404359',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905079763','13905079763','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624479764482',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599978051','13599978051','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624479764483',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15280422458','15280422458','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624479764484',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18650676688','18650676688','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624483958785',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906099550','13906099550','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624483958786',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13665001804','13665001804','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624483958787',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18960877567','18960877567','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624483958788',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18900311779','18900311779','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624483958789',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880977738','15880977738','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624488153090',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18605007853','18605007853','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624488153091',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18606942212','18606942212','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624488153092',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13067198079','13067198079','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624488153093',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13400539210','13400539210','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624488153094',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18825160801','18825160801','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624488153095',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13163906685','13163906685','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624488153096',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18817333998','18817333998','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624492347393',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505955686','13505955686','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624492347394',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13559546275','13559546275','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624492347395',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13665956888','13665956888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624492347396',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980478011','15980478011','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624492347397',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18559672261','18559672261','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624496541697',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18862155979','18862155979','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624496541698',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659097395','18659097395','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624496541699',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15259727676','15259727676','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624496541700',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905969285','13905969285','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624496541701',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15606087056','15606087056','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624496541702',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18782977456','18782977456','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624496541703',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906091302','13906091302','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624500736002',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960408350','13960408350','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624500736003',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959946911','13959946911','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624500736004',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18960251988','18960251988','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624530096129',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060969798','15060969798','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624530096130',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505071035','13505071035','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624530096131',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18905059500','18905059500','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624534290433',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808525056','13808525056','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624534290434',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17705061101','17705061101','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624534290435',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905059909','13905059909','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624534290436',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15985900838','15985900838','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624534290437',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799581818','13799581818','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624534290438',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13626076868','13626076868','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624534290439',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960255304','13960255304','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624538484738',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959992008','15959992008','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624538484739',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13615926622','13615926622','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624538484740',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959990198','15959990198','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624538484741',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636928198','13636928198','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624538484742',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808558181','13808558181','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624538484743',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905075757','13905075757','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624538484744',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905079280','13905079280','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624542679042',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13606021816','13606021816','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624542679043',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980056221','15980056221','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624542679044',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805997206','13805997206','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624542679045',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13489887652','13489887652','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624542679046',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506009833','13506009833','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624542679047',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13646031399','13646031399','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624542679048',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805941850','13805941850','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624546873346',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13488682111','13488682111','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624546873347',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15392121201','15392121201','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624546873348',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18959981231','18959981231','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624546873349',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959952350','13959952350','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624546873350',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13489512117','13489512117','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624546873351',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15759500600','15759500600','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624572039170',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959921098','13959921098','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624576233474',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799870758','13799870758','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624576233475',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13850753398','13850753398','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624576233476',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959599793','15959599793','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624576233477',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13242884288','13242884288','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624576233478',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13559550686','13559550686','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624580427777',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805951761','13805951761','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624580427778',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15710646360','15710646360','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624580427779',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260838513','15260838513','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624580427780',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600704238','13600704238','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624580427781',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13316225195','13316225195','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624580427782',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860708740','13860708740','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624580427783',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15805972719','15805972719','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622081',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18050888018','18050888018','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622082',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959975903','13959975903','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622083',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15359508512','15359508512','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622084',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505051522','13505051522','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622085',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859505750','15859505750','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622086',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15377953096','15377953096','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622087',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15960731557','15960731557','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624584622088',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599715762','13599715762','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624588816385',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788826386','13788826386','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624588816386',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13459523253','13459523253','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624588816387',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13489512136','13489512136','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624588816388',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13107880950','13107880950','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624588816389',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15750898928','15750898928','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624588816390',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18950498312','18950498312','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624588816391',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15375886386','15375886386','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624593010690',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13400507028','13400507028','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624593010691',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13587756546','13587756546','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624702062593',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13959737339','13959737339','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624706256897',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18659916888','18659916888','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624706256898',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859525583','18859525583','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624706256899',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13506059007','13506059007','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624706256900',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505955666','13505955666','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624706256901',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505902557','13505902557','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624710451202',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13636951165','13636951165','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624710451203',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805957070','13805957070','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624710451204',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13860602468','13860602468','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624710451205',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13305962813','13305962813','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624710451206',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13661356074','13661356074','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624710451207',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15606088553','15606088553','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624710451208',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13645019389','13645019389','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624714645506',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15280875858','15280875858','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624714645507',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600788662','13600788662','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624714645508',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','19905908656','19905908656','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624714645509',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18344910844','18344910844','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624714645510',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18059147928','18059147928','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624714645511',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260708136','15260708136','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624714645512',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15880824003','15880824003','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839810',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13365952758','13365952758','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839811',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805951603','13805951603','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839812',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15375754488','15375754488','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839813',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13918199745','13918199745','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839814',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15859577777','15859577777','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839815',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15606946335','15606946335','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839816',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805997578','13805997578','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624718839817',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060933832','15060933832','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624723034113',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17850929207','17850929207','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624723034114',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18750654331','18750654331','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624748199938',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13599751999','13599751999','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624752394242',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13906099845','13906099845','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624752394243',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859552366','18859552366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624752394244',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859626598','18859626598','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624756588546',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15959990680','15959990680','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624756588547',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905909283','15905909283','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624756588548',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15059720864','15059720864','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624756588549',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15620633941','15620633941','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624760782850',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15980006525','15980006525','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624760782851',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15260813616','15260813616','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624760782852',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18100525107','18100525107','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624764977153',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18859763636','18859763636','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624764977154',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18396220746','18396220746','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624764977155',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18559477701','18559477701','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624764977156',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15759596655','15759596655','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624764977157',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13905955872','13905955872','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624769171457',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13605944765','13605944765','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624769171458',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505954433','13505954433','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624769171459',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13808552366','13808552366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624769171460',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13655928585','13655928585','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624769171461',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788833384','13788833384','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624773365762',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960305030','13960305030','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624773365763',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13338583366','13338583366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624773365764',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13505905737','13505905737','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624773365765',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15280081010','15280081010','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624777560065',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788805366','13788805366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624777560066',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13559369710','13559369710','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624777560067',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13788816686','13788816686','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624777560068',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13067166871','13067166871','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624781754369',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600785508','13600785508','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624806920193',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13805065379','13805065379','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624806920194',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13459218283','13459218283','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624806920195',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13107891508','13107891508','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624811114498',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15396503999','15396503999','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624811114499',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18705045726','18705045726','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624811114500',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15071360501','15071360501','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624811114501',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13400886486','13400886486','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624811114502',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15305009255','15305009255','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624811114503',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15080406979','15080406979','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624815308802',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18359592597','18359592597','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624815308803',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15905903705','15905903705','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624815308804',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13328505767','13328505767','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624815308805',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13799866661','13799866661','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624815308806',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13285957289','13285957289','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624815308807',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18965662565','18965662565','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624815308808',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15960217968','15960217968','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624819503105',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','17359987925','17359987925','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624819503106',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13960326290','13960326290','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624819503107',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18905051668','18905051668','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624819503108',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13159037366','13159037366','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624819503109',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600703555','13600703555','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624819503110',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13489387611','13489387611','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624819503111',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','15060619686','15060619686','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624823697410',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','18084725997','18084725997','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624823697411',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13901318357','13901318357','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624823697412',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13295908788','13295908788','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270189624823697413',NULL,'1270189623116615681',2,2,'批量发送(关注人才晋江公众号20200609)','13600704026','13600704026','【晋江市人才服务平台】通知：近期我市已开展泉州晋江优秀人才疗休养活动，请各位人才及时关注人才晋江微信公众号，具体报名资格、注意事项、疗休养方案等可详见“阅读原文”，活动咨询热线：0595-88223456。',2,'消息因为敏感词被拒绝','2020-06-09 11:02:59',NULL,NULL,NULL,'2020-06-09 11:02:59',NULL,NULL,NULL),('1270197787992051713',NULL,'1270197787992051713',2,1,NULL,'15905984868','130944','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-09',NULL,NULL,NULL,'2020-06-09 11:35:26',NULL,NULL,NULL),('1270296585552580609',NULL,'1270296585552580609',2,1,NULL,'13600704026','933112','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-09',NULL,NULL,NULL,'2020-06-09 18:08:01',NULL,NULL,NULL),('1270322049486737410',NULL,'1270322049486737410',2,1,NULL,'18859791858','529384','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-09',NULL,NULL,NULL,'2020-06-09 19:49:12',NULL,NULL,NULL),('1270331986350755842',NULL,'1270331986350755842',2,1,NULL,'15964917281','651599','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-09',NULL,NULL,NULL,'2020-06-09 20:28:41',NULL,NULL,NULL),('1270893628029456385','1269831043272200193','1270893628029456385',2,2,'晋江隆旺再生资源有限公司','13774648357','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-11',NULL,NULL,NULL,'2020-06-11 09:40:27',NULL,NULL,NULL),('1271239389476868097',NULL,'1271239389476868097',2,1,NULL,'13559591215','639762','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-12',NULL,NULL,NULL,'2020-06-12 08:34:23',NULL,NULL,NULL),('1271243856884584449',NULL,'1271243856884584449',2,1,NULL,'15821998683','676526','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-12',NULL,NULL,NULL,'2020-06-12 08:52:08',NULL,NULL,NULL),('1271256212444336130',NULL,'1271256212444336130',2,1,NULL,'15821998683','310565','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-12',NULL,NULL,NULL,'2020-06-12 09:41:14',NULL,NULL,NULL),('1272322169979850753','1211572731150123009','1272322169979850753',2,2,'三六一度(福建)体育用品有限公司','18350599665','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-15',NULL,NULL,NULL,'2020-06-15 08:16:58',NULL,NULL,NULL),('1272322250753757186','1211574035113099265','1272322250753757186',2,2,'三六一度(中国)有限公司','18350599665','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-15',NULL,NULL,NULL,'2020-06-15 08:17:17',NULL,NULL,NULL),('1272322318311411714','1214700126568800258','1272322318311411714',2,2,'三六一度童装有限公司','18350599665','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-15',NULL,NULL,NULL,'2020-06-15 08:17:33',NULL,NULL,NULL),('1272813739699130369','1245615593177055233','1272813739699130369',2,2,'晋江市新迪新材料科技有限公司','13950287905','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 16:50:17',NULL,NULL,NULL),('1272817599582883842','1211171114114461697','1272817599582883842',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:05:38',NULL,NULL,NULL),('1272818786914848769','1252510490651885569','1272818786914848769',2,2,'鸿坤卓越(广州)财富管理有限公司晋江分公司','13959989905','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:10:21',NULL,NULL,NULL),('1272819560315146241','1253585948415983617','1272819560315146241',2,2,'晋江龙湖晋嘉置业有限公司','18695659900','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:13:25',NULL,NULL,NULL),('1272819762849697794','1259032430883438593','1272819762849697794',2,2,'晋江市维丰织造漂染有限公司','18959859775','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:14:13',NULL,NULL,NULL),('1272821856692391938','1259051498508189698','1272821856692391938',2,2,'晋江爱乐百杰聚隆酒店有限公司','15860018012','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:22:33',NULL,NULL,NULL),('1272822491856818178','1259448331973754881','1272822491856818178',2,2,'聚隆(福建)包装有限公司','15960567183','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:25:04',NULL,NULL,NULL),('1272827120267087874','1265077426581430273','1272827120267087874',2,2,'晋江市达树机械科技有限公司','13205059567','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:43:28',NULL,NULL,NULL),('1272828001754599426','1269616748789813250','1272828001754599426',2,2,'福建省晋江市英林英华娱乐有限公司','13599272818','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:46:58',NULL,NULL,NULL),('1272828750911819778','1269892936389152770','1272828750911819778',2,2,'晋江市鹏太机械科技有限公司','18876549550','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:49:56',NULL,NULL,NULL),('1272830423386345473','1270198206789111809','1272830423386345473',2,2,'泉州市威豹保安服务有限公司','15905984868','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 17:56:35',NULL,NULL,NULL),('1272831358514810882','1271256834497368065','1272831358514810882',2,2,'福建晖彩鞋材有限公司','15821998683','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-16',NULL,NULL,NULL,'2020-06-16 18:00:18',NULL,NULL,NULL),('1273048318041182209','1270198206789111809','1273048318041182209',2,2,'泉州市威豹保安服务有限公司','15905984868','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-17',NULL,NULL,NULL,'2020-06-17 08:22:25',NULL,NULL,NULL),('1273051371741958146','1270178975045439490','1273051371741958146',2,2,'泉州市安心管家居民服务有限公司','13123108336','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-17',NULL,NULL,NULL,'2020-06-17 08:34:33',NULL,NULL,NULL),('1273183451754823681','1265077426581430273','1273183451754823681',2,2,'晋江市达树机械科技有限公司','13205059567','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-17',NULL,NULL,NULL,'2020-06-17 17:19:24',NULL,NULL,NULL),('1273439199097290753',NULL,'1273439199097290753',2,1,NULL,'15959555236','539524','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-18',NULL,NULL,NULL,'2020-06-18 10:15:39',NULL,NULL,NULL),('1273513816881135618',NULL,'1273513816881135618',2,1,NULL,'13905972257','313107','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-18',NULL,NULL,NULL,'2020-06-18 15:12:09',NULL,NULL,NULL),('1273523358532665346','1273439521798651905','1273523358532665346',2,2,'泉州市六源印染织造有限公司','15959555236','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-18',NULL,NULL,NULL,'2020-06-18 15:50:04',NULL,NULL,NULL),('1273524807043940354','1263695702228230145','1273524807043940354',2,2,'泉州市新天智能科技有限公司','13505949993','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-18',NULL,NULL,NULL,'2020-06-18 15:55:49',NULL,NULL,NULL),('1273532139962400770','1260474359613534209','1273532139962400770',2,2,'晋江市银达锦信息科技有限公司','18359797834','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-18',NULL,NULL,NULL,'2020-06-18 16:24:57',NULL,NULL,NULL),('1273544480502349826','1245239948823592961','1273544480502349826',2,2,'晋江五店市晋文坊房地产开发有限公司','13959941699','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-18',NULL,NULL,NULL,'2020-06-18 17:14:00',NULL,NULL,NULL),('1273808526401110017',NULL,'1273808526401110017',2,1,NULL,'17689492671','189446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 10:43:13',NULL,NULL,NULL),('1273809593230721026',NULL,'1273809593230721026',2,1,NULL,'17689492671','617524','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 10:47:27',NULL,NULL,NULL),('1273811049878945793',NULL,'1273811049878945793',2,1,NULL,'17689492671','941880','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 10:53:15',NULL,NULL,NULL),('1273850345189048321',NULL,'1273850345189048321',2,1,NULL,'15960777080','092561','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 13:29:23',NULL,NULL,NULL),('1273884378904141826','1265846765748224001','1273884378904141826',2,2,'青艺(福建)烫画科技有限公司','15359509870','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 15:44:38',NULL,NULL,NULL),('1273884626896560130','1273850390323953666','1273884626896560130',2,2,'晋江市启宁净水科技有限公司','15960777080','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 15:45:37',NULL,NULL,NULL),('1273885962551697409','1249630370077442050','1273885962551697409',2,2,'晋江市凯嘉机器制造有限公司','18859987377','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 15:50:55',NULL,NULL,NULL),('1273891524895055874','1265846765748224001','1273891524895055874',2,2,'青艺(福建)烫画科技有限公司','15359509870','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 16:13:01',NULL,NULL,NULL),('1273923716182450178',NULL,'1273923716182450178',2,1,NULL,'13959777981','855909','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-19',NULL,NULL,NULL,'2020-06-19 18:20:56',NULL,NULL,NULL),('1274148953767550977',NULL,'1274148953767550977',2,1,NULL,'18159338867','126357','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-20',NULL,NULL,NULL,'2020-06-20 09:15:57',NULL,NULL,NULL),('1274354122371375106',NULL,'1274354122371375106',2,1,NULL,'13720848341','662148','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-20',NULL,NULL,NULL,'2020-06-20 22:51:13',NULL,NULL,NULL),('1274895631843860482',NULL,'1274895631520899074',2,2,'批量发送(1120200622)','13675957398','13675957398','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',3,'短信发送成功','2020-06-22 10:42:59',NULL,NULL,NULL,'2020-06-22 10:42:59',NULL,NULL,NULL),('1274898133347737601',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13626066721','13626066721','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133356126210',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18046311397','18046311397','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133356126211',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13906998716','13906998716','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133356126212',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15159739903','15159739903','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133356126213',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18959847128','18959847128','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133356126214',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959798579','15959798579','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133360320514',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13506056368','13506056368','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133364514818',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13705941428','13705941428','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133364514819',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799966695','13799966695','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133364514820',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13306995188','13306995188','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133364514821',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13559593361','13559593361','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133368709121',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18965689828','18965689828','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133368709122',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18859969666','18859969666','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133368709123',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15611255393','15611255393','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133368709124',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18618285267','18618285267','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133372903426',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13906933286','13906933286','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133372903427',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18516157979','18516157979','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133372903428',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13436970465','13436970465','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133377097730',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18900371513','18900371513','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133377097731',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13960207400','13960207400','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133377097732',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13709857491','13709857491','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133377097733',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18965687332','18965687332','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133381292034',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799557193','13799557193','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133381292035',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805957117','13805957117','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133381292036',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905957105','13905957105','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133381292037',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905350771','13905350771','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133381292038',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13063191843','13063191843','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133385486337',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15860328381','15860328381','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133385486338',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13960250701','13960250701','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133385486339',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18950070276','18950070276','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133385486340',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15805026065','15805026065','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133414846466',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18065589080','18065589080','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133419040770',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13600759390','13600759390','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133419040771',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13918199745','13918199745','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133423235074',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805997578','13805997578','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133423235075',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18396220746','18396220746','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133423235076',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805065379','13805065379','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133423235077',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13159037366','13159037366','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133423235078',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13901318357','13901318357','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133423235079',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13255957226','13255957226','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133427429377',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13666026522','13666026522','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133427429378',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905070552','13905070552','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133427429379',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15159878799','15159878799','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133427429380',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13960381057','13960381057','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133427429381',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18965689935','18965689935','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133431623682',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18960206656','18960206656','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133431623683',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13509362773','13509362773','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133431623684',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905952020','13905952020','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133431623685',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13559566696','13559566696','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133431623686',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15860395678','15860395678','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133435817986',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13788851759','13788851759','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133435817987',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599109151','13599109151','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133435817988',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15160423086','15160423086','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133435817989',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805900098','13805900098','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133435817990',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15880785555','15880785555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133440012290',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18606989818','18606989818','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133440012291',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15985918296','15985918296','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133440012292',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15995216889','15995216889','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133440012293',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959778888','13959778888','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133440012294',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959237668','13959237668','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133444206594',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13601032833','13601032833','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133469372417',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18059037101','18059037101','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133473566722',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15259555555','15259555555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133477761025',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18960285333','18960285333','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133477761026',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13666988888','13666988888','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133477761027',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15622174598','15622174598','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133477761028',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959889099','15959889099','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133477761029',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905089834','13905089834','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133477761030',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905085845','13905085845','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133481955329',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505008588','13505008588','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133481955330',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18650908918','18650908918','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133481955331',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18150591518','18150591518','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133481955332',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13906095618','13906095618','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133481955333',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13400808814','13400808814','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133486149634',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905950588','13905950588','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133486149635',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15315563156','15315563156','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133486149636',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13665959771','13665959771','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133486149637',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18159276351','18159276351','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133486149638',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959873463','15959873463','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133490343937',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13506054328','13506054328','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133490343938',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905055474','13905055474','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133490343939',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13788869420','13788869420','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133490343940',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18603006276','18603006276','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133490343941',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13696900561','13696900561','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133494538241',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15860517253','15860517253','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133494538242',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13850777555','13850777555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133494538243',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13850777672','13850777672','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133494538244',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905971030','13905971030','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133494538245',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959926888','13959926888','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133498732545',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799797017','13799797017','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133498732546',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18959996388','18959996388','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133528092674',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13859989821','13859989821','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133532286977',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18876539791','18876539791','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133536481281',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15860302368','15860302368','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133536481282',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599507077','13599507077','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133536481283',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13606051571','13606051571','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133536481284',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18659737170','18659737170','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133536481285',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15880990268','15880990268','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133540675585',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18698360960','18698360960','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133540675586',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13950317095','13950317095','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133540675587',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15905055709','15905055709','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133540675588',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18859781366','18859781366','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133540675589',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599106745','13599106745','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133544869890',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13808525056','13808525056','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133544869891',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13636928198','13636928198','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133544869892',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805941850','13805941850','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133544869893',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505905685','13505905685','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133549064193',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13850753398','13850753398','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133549064194',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959599793','15959599793','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133549064195',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13559550686','13559550686','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133549064196',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805951761','13805951761','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133549064197',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15710646360','15710646360','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133553258497',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13600704238','13600704238','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133553258498',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13400507028','13400507028','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133553258499',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805957070','13805957070','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133553258500',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805951603','13805951603','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133553258501',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15859577777','15859577777','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133557452801',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15059597777','15059597777','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133557452802',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13600703555','13600703555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133557452803',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18959858592','18959858592','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133557452804',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13801333177','13801333177','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133586812930',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13802609526','13802609526','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133591007234',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18016585576','18016585576','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133595201538',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18065376686','18065376686','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133595201539',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13906099888','13906099888','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133595201540',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15985952242','15985952242','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133595201541',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13055808024','13055808024','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133599395841',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13950920100','13950920100','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133599395842',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905958730','13905958730','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133599395843',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13105079935','13105079935','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133603590145',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','19852121931','19852121931','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133603590146',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905975119','13905975119','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133603590147',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13305967663','13305967663','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133603590148',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18859990000','18859990000','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133603590149',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805946193','13805946193','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133607784450',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799555666','13799555666','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133607784451',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18006037555','18006037555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133607784452',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599162155','13599162155','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133607784453',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15905907962','15905907962','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133611978753',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13506060342','13506060342','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133611978754',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599212929','13599212929','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133611978755',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15750768536','15750768536','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133611978756',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13506000615','13506000615','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133611978757',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905974006','13905974006','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133616173057',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18960357668','18960357668','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133616173058',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18650100145','18650100145','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133616173059',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18721796963','18721796963','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133616173060',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18959210622','18959210622','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133616173061',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15260782666','15260782666','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133620367362',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15260803666','15260803666','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133620367363',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13685908658','13685908658','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133649727490',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15392288855','15392288855','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133653921794',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13600754180','13600754180','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133653921795',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599780560','13599780560','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133653921796',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13655902993','13655902993','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133653921797',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13675995249','13675995249','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133653921798',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15260429705','15260429705','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133658116098',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905968151','13905968151','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133658116099',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13720842620','13720842620','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133658116100',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18659915000','18659915000','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133658116101',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15060626155','15060626155','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133658116102',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805924801','13805924801','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133662310402',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18859760088','18859760088','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133662310403',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15905037555','15905037555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133662310404',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15260807555','15260807555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133662310405',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15905958858','15905958858','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133662310406',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15359585555','15359585555','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133666504705',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15059748612','15059748612','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133666504706',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13459504545','13459504545','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133666504707',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15396597171','15396597171','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133666504708',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13285030066','13285030066','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133666504709',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18050929268','18050929268','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133670699009',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18350777627','18350777627','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133670699010',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599159330','13599159330','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133670699011',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15960408186','15960408186','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133670699012',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959119986','13959119986','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133670699013',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13600703008','13600703008','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133670699014',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505951467','13505951467','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133674893313',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959951039','13959951039','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133674893314',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18705052323','18705052323','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133674893315',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505932929','13505932929','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133700059137',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13960282791','13960282791','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133704253441',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18065525518','18065525518','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133708447745',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13400840823','13400840823','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133708447746',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13501115138','13501115138','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133708447747',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799898116','13799898116','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133708447748',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505056755','13505056755','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133708447749',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13906998897','13906998897','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133712642050',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13774878631','13774878631','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133712642051',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599161927','13599161927','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133712642052',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13920285434','13920285434','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133712642053',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13805956558','13805956558','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133712642054',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599936037','13599936037','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133716836353',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18959992832','18959992832','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133716836354',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13850799806','13850799806','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133716836355',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959553375','15959553375','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133716836356',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15960795588','15960795588','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133721030658',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799239878','13799239878','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133721030659',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18960279877','18960279877','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133721030660',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13859775220','13859775220','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133721030661',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15905006716','15905006716','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133721030662',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13860763453','13860763453','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133725224961',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13004800144','13004800144','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133725224962',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13515055988','13515055988','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133725224963',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13559591215','13559591215','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133725224964',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15985959061','15985959061','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133725224965',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13850755588','13850755588','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133725224966',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18633637251','18633637251','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133729419266',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505961108','13505961108','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133729419267',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13950299290','13950299290','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133729419268',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15980456333','15980456333','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133754585089',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959752857','13959752857','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133758779393',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18150983366','18150983366','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133762973698',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15106087765','15106087765','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133762973699',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13675930836','13675930836','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133762973700',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15505952026','15505952026','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133762973701',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13615922291','13615922291','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133762973702',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','17612198088','17612198088','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133762973703',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18659822922','18659822922','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133767168002',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13655601013','13655601013','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133767168003',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15827609588','15827609588','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133767168004',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13159012670','13159012670','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133767168005',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','17512098847','17512098847','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133767168006',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18050056871','18050056871','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133771362305',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','17750989111','17750989111','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133771362306',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599505962','13599505962','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133771362307',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15259729821','15259729821','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133771362308',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15059823968','15059823968','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133771362309',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13407735197','13407735197','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133771362310',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','17715205257','17715205257','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133775556609',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15106033846','15106033846','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133775556610',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15846593350','15846593350','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133775556611',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13950092022','13950092022','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133775556612',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15810298887','15810298887','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133775556613',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505008000','13505008000','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133779750913',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13085059001','13085059001','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133779750914',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18859498656','18859498656','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133779750915',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18876240048','18876240048','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133779750916',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18411037910','18411037910','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133779750917',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18698372705','18698372705','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133779750918',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18815997296','18815997296','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133813305346',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13506998846','13506998846','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133817499650',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15259758239','15259758239','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133817499651',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959569933','15959569933','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133817499652',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15860356356','15860356356','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133821693953',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15860353200','15860353200','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133821693954',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15905996655','15905996655','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133821693955',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13055650678','13055650678','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133825888258',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505097888','13505097888','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133825888259',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959717283','13959717283','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133825888260',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905985743','13905985743','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133825888261',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905079763','13905079763','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133830082562',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18650676688','18650676688','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133830082563',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15805073665','15805073665','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133830082564',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18900311779','18900311779','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133834276865',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15880977738','15880977738','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133834276866',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505955686','13505955686','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133834276867',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13906091302','13906091302','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133834276868',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959992008','15959992008','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133838471170',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959990198','15959990198','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133838471171',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13808558181','13808558181','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133838471172',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905075757','13905075757','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133838471173',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13905079280','13905079280','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133838471174',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18959981231','18959981231','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133838471175',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13489512117','13489512117','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133842665474',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799870758','13799870758','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133842665475',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15980025829','15980025829','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133842665476',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15260838513','15260838513','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133842665477',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959975903','13959975903','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133846859777',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13506095562','13506095562','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133846859778',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18965667777','18965667777','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133880414209',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13489512136','13489512136','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133884608513',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13587756546','13587756546','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133888802818',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13959737339','13959737339','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133888802819',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505902557','13505902557','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133888802820',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15859590857','15859590857','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133888802821',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13599751999','13599751999','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133888802822',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15059720864','15059720864','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133888802823',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13655928585','13655928585','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133892997121',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13386880667','13386880667','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133892997122',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15959882366','15959882366','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133892997123',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13788833384','13788833384','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133892997124',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13338583366','13338583366','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133892997125',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13505905737','13505905737','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133892997126',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13788805366','13788805366','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133897191426',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13107891508','13107891508','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133897191427',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13645971717','13645971717','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133897191428',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15396503999','15396503999','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133897191429',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13400886486','13400886486','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133901385730',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','18359592597','18359592597','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133901385731',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13799866661','13799866661','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133901385732',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','15060619686','15060619686','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133901385733',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13328883775','13328883775','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',2,'消息因为敏感词被拒绝','2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274898133901385734',NULL,'1274898132894752769',2,2,'批量发送(晋江市第一至第四层次优秀人才微信群20200622)','13600704026\n','13600704026\n','【晋江市人才服务平台】尊敬的晋江市第一至第四层次优秀人才：现诚邀您加入“新晋江市优秀人才群”，烦请加微信号15280619456或13675957398，并备注好工作单位+姓名，以便审核通过，谢谢！',1,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL,'2020-06-22 10:52:56',NULL,NULL,NULL),('1274904538859446273',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906095618','13906095618','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538863640578',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13295959911','13295959911','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538867834882',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15160330306','15160330306','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538867834883',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906091693','13906091693','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538867834884',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18159826888','18159826888','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538867834885',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905974002','13905974002','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538867834886',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808505006','13808505006','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538867834887',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15106088998','15106088998','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538872029186',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808557909','13808557909','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538872029187',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959988073','18959988073','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538872029188',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13305088921','13305088921','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538872029189',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059750761','15059750761','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538872029190',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799766670','13799766670','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538872029191',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18815985118','18815985118','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538876223490',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359996305','15359996305','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538876223491',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859555816','18859555816','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538876223492',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599218888','13599218888','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538876223493',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959707235','18959707235','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538876223494',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15191577654','15191577654','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538876223495',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959706230','18959706230','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538880417793',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506003686','13506003686','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538880417794',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15906067008','15906067008','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538880417795',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17706075999','17706075999','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538880417796',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13665987766','13665987766','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538880417797',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359490818','15359490818','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538880417798',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17613712423','17613712423','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538884612098',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13107872929','13107872929','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538884612099',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18759552098','18759552098','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538884612100',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18259591998','18259591998','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538884612101',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905051776','13905051776','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538884612102',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060011828','15060011828','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538918166529',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13675998353','13675998353','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538922360834',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859951871','18859951871','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538922360835',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905953818','13905953818','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538922360836',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959888172','13959888172','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538922360837',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959708032','18959708032','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538922360838',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599145737','13599145737','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538926555137',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559054268','13559054268','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538926555138',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15159518618','15159518618','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538926555139',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059821270','15059821270','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538926555140',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959906506','18959906506','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538926555141',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18805959777','18805959777','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538926555142',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965689711','18965689711','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538930749442',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959996599','15959996599','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538930749443',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959556399','15959556399','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538930749444',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860190418','13860190418','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538930749445',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599921781','13599921781','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538930749446',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17750891999','17750891999','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538934943746',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959210622','18959210622','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538934943747',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905092171','15905092171','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538934943748',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18960353905','18960353905','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538934943749',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880911717','15880911717','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538934943750',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959706253','18959706253','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538934943751',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18350770057','18350770057','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538939138049',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860304280','15860304280','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538939138050',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859920423','18859920423','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538939138051',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860381909','15860381909','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538939138052',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15559133531','15559133531','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538939138053',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18905953233','18905953233','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538939138054',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959507666','15959507666','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538943332353',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','19859573633','19859573633','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538972692482',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489403314','13489403314','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538976886785',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260875781','15260875781','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538976886786',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759876282','15759876282','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538976886787',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13313880008','13313880008','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538981081090',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13850728390','13850728390','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538981081091',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18957137209','18957137209','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538981081092',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13625958406','13625958406','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538981081093',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559625390','13559625390','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538981081094',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260823192','15260823192','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538985275394',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959509673','15959509673','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538985275395',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13706957817','13706957817','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538985275396',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959798556','13959798556','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538985275397',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13649278723','13649278723','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538985275398',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859705235','13859705235','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538989469697',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859933999','18859933999','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538989469698',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505942660','13505942660','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538989469699',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659281177','18659281177','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538989469700',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505943066','13505943066','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538989469701',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13405350771','13405350771','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',2,'空号','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538989469702',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599766670','13599766670','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538993664002',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13863831087','13863831087','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538993664003',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17762027770','17762027770','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538993664004',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13700242731','13700242731','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538993664005',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505028679','13505028679','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538993664006',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750597755','18750597755','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538997858305',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860351538','15860351538','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538997858306',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13405353771','13405353771','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538997858307',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880719513','15880719513','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904538997858308',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15141988697','15141988697','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539002052610',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059543210','15059543210','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539031412737',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905055766','13905055766','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539035607042',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17727971605','17727971605','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539039801346',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18106968679','18106968679','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539039801347',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859231310','15859231310','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539039801348',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080345751','15080345751','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539039801349',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059570222','15059570222','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539039801350',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959955966','13959955966','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539039801351',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059830121','15059830121','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539043995650',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876291470','18876291470','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539043995651',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965483880','18965483880','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539043995652',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18953138447','18953138447','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539043995653',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15711502057','15711502057','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539043995654',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459523099','13459523099','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539043995655',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950063837','13950063837','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539048189954',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959280218','13959280218','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539048189955',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788814546','13788814546','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539048189956',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959994811','15959994811','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539048189957',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860514476','15860514476','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539048189958',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599954300','13599954300','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539048189959',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13105060008','13105060008','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539052384258',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859907988','18859907988','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539052384259',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15505950959','15505950959','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539052384260',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15205972628','15205972628','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539052384261',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636995533','13636995533','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539052384262',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13666029324','13666029324','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539052384263',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759732116','15759732116','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539052384264',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505959355','13505959355','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539056578561',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15659050608','15659050608','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539056578562',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15904412438','15904412438','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539056578563',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17359991180','17359991180','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539085938690',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15159871537','15159871537','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539090132993',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15906005715','15906005715','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539090132994',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15375771216','15375771216','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539090132995',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260371606','15260371606','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539090132996',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15159832652','15159832652','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539090132997',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750914154','18750914154','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539090132998',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960455227','13960455227','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539094327298',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960270097','13960270097','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539094327299',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799758056','13799758056','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539094327300',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965526351','18965526351','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539094327301',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965175339','18965175339','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539094327302',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13806969722','13806969722','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539094327303',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950989318','13950989318','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539094327304',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15375708923','15375708923','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539098521602',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13205957447','13205957447','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539098521603',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18106930966','18106930966','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539098521604',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808505732','13808505732','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539098521605',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905022650','15905022650','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539098521606',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750207251','18750207251','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539098521607',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905975168','15905975168','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539102715905',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960228853','13960228853','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539102715906',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659936998','18659936998','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539102715907',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759877981','15759877981','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539102715908',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788828099','13788828099','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539102715909',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505977599','13505977599','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539102715910',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950175990','13950175990','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539102715911',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18016516089','18016516089','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539106910210',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659516267','18659516267','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539106910211',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15280871258','15280871258','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539106910212',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489875197','13489875197','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539136270338',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505956777','13505956777','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539140464642',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959853522','15959853522','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539140464643',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959525859','15959525859','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539144658946',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489545332','13489545332','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539144658947',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13215066449','13215066449','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539144658948',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13975057391','13975057391','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539144658949',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960358840','13960358840','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539144658950',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18350742084','18350742084','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539144658951',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880939936','15880939936','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539148853249',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15559050207','15559050207','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539148853250',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805145645','13805145645','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539148853251',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959992226','13959992226','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539148853252',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13646022408','13646022408','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539148853253',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959595731','15959595731','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539148853254',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600703996','13600703996','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539153047554',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13710228756','13710228756','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539153047555',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859506299','15859506299','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539153047556',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13306051592','13306051592','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539153047557',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600770238','13600770238','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539153047558',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050877288','18050877288','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539153047559',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13850751502','13850751502','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274904539153047560',NULL,'1274904496425672706',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15964917281','15964917281','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:18:13',NULL,NULL,NULL,'2020-06-22 11:18:13',NULL,NULL,NULL),('1274905045384568834',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059551567','15059551567','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045388763137',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506086731','13506086731','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045392957442',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13338562717','13338562717','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045392957443',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876509838','18876509838','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045392957444',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905089190','13905089190','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045392957445',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980788802','15980788802','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045392957446',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805032333','15805032333','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045392957447',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505080996','13505080996','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045392957448',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959705077','18959705077','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045397151746',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880720190','15880720190','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045397151747',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18960278086','18960278086','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045397151748',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059792958','15059792958','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045397151749',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13306995039','13306995039','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045397151750',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808510760','13808510760','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045397151751',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959896966','15959896966','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045397151752',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959995705','18959995705','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045401346050',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805957081','13805957081','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045401346051',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13705943966','13705943966','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045401346052',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13850778776','13850778776','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045401346053',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636963633','13636963633','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045401346054',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13656038332','13656038332','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045401346055',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859932277','18859932277','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045401346056',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15306089555','15306089555','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045405540353',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905079361','15905079361','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045405540354',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18605958880','18605958880','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045405540355',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905985809','13905985809','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045405540356',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960692650','15960692650','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045405540357',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959712401','13959712401','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045405540358',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13328509988','13328509988','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045405540359',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860398018','15860398018','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045409734657',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859551760','18859551760','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045434900481',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13395096999','13395096999','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045439094785',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959858506','18959858506','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045439094786',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960341716','13960341716','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045439094787',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980313135','15980313135','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045439094788',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906096567','13906096567','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045439094789',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13205061526','13205061526','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045439094790',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506042338','13506042338','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045443289090',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959753823','13959753823','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045443289091',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459034477','13459034477','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045443289092',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860688762','15860688762','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',2,'空号','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045443289093',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859596380','18859596380','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045443289094',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960707755','15960707755','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045443289095',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505957512','13505957512','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045443289096',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788829369','13788829369','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045447483394',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15392286115','15392286115','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045447483395',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880974760','15880974760','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045447483396',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959997270','18959997270','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045447483397',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15392288851','15392288851','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045447483398',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17750103317','17750103317','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045447483399',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18605001616','18605001616','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045451677697',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13425480722','13425480722','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',2,'常见原因是：关机，停机，不在服务区；在少数情况下，号码正常通信，是由于地区屏蔽导致。','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045451677698',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959855726','18959855726','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045451677699',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459556182','13459556182','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045451677700',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13306995027','13306995027','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045451677701',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13325253201','13325253201','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045455872002',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13328963385','13328963385','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045455872003',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13816975274','13816975274','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045455872004',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359590811','15359590811','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045455872005',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599949096','13599949096','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045455872006',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960259639','13960259639','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045481037825',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18250155553','18250155553','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045485232130',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965687331','18965687331','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045489426433',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960359859','13960359859','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045489426434',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959579818','15959579818','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045489426435',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980000660','15980000660','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045489426436',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18722290558','18722290558','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045489426437',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959517575','15959517575','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045489426438',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505050069','13505050069','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045489426439',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059556400','15059556400','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045493620737',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959505915','15959505915','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045493620738',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799552053','13799552053','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045493620739',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13030981560','13030981560','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045493620740',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659568811','18659568811','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045493620741',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805097777','15805097777','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045493620742',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13328500766','13328500766','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045493620743',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18606985861','18606985861','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045497815042',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18606056998','18606056998','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045497815043',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659003000','18659003000','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045497815044',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506969315','13506969315','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045497815045',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18350770992','18350770992','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045497815046',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905089465','13905089465','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045497815047',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15559067588','15559067588','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045497815048',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959953589','13959953589','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045502009346',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489858089','13489858089','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045502009347',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860750864','13860750864','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045502009348',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13256678813','13256678813','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045502009349',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805959125','13805959125','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045502009350',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659262866','18659262866','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045502009351',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506069249','13506069249','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045502009352',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906999100','13906999100','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045527175169',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859751591','13859751591','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045531369473',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636950560','13636950560','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045531369474',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959840868','13959840868','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045531369475',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15396583913','15396583913','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045531369476',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600753338','13600753338','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045531369477',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860902576','15860902576','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045531369478',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505059996','13505059996','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045531369479',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505058832','13505058832','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045535563777',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808549828','13808549828','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045535563778',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805945051','13805945051','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045535563779',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18960259259','18960259259','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045535563780',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959995002','18959995002','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045535563781',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506066917','13506066917','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045535563782',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600701178','13600701178','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045535563783',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506956209','13506956209','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758081',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13358577766','13358577766','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758082',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905035169','15905035169','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758083',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859754633','13859754633','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758084',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506941213','13506941213','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758085',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965699955','18965699955','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758086',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805950256','13805950256','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758087',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905095955','15905095955','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045539758088',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559532808','13559532808','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045543952386',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860901713','15860901713','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045543952387',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359556333','15359556333','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045543952388',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905077879','15905077879','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045543952389',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13055667605','13055667605','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045543952390',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18059983988','18059983988','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045543952391',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18059993901','18059993901','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045543952392',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600709507','13600709507','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045569118209',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636906289','13636906289','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045569118210',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808512082','13808512082','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045573312514',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260399516','15260399516','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045573312515',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905006169','15905006169','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045573312516',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808510666','13808510666','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045573312517',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860703356','13860703356','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045573312518',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959910000','13959910000','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045573312519',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860757775','13860757775','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506818',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15906066156','15906066156','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506819',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959592923','15959592923','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506820',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905059153','13905059153','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506821',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799896025','13799896025','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506822',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506083126','13506083126','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506823',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15005936026','15005936026','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506824',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060806451','15060806451','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045577506825',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600703472','13600703472','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045581701122',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059832543','15059832543','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045581701123',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13110816682','13110816682','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045581701124',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15659450305','15659450305','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045581701125',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18650917845','18650917845','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045581701126',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18850547191','18850547191','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045581701127',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15083847155','15083847155','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045581701128',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808543336','13808543336','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045585895425',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965636930','18965636930','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045585895426',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259555117','15259555117','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045585895427',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13110592357','13110592357','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045585895428',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15392481724','15392481724','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045585895429',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959940177','13959940177','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045585895430',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860726225','13860726225','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045585895431',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260237093','15260237093','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045611061249',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859468355','15859468355','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045611061250',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259471016','15259471016','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045611061251',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459599999','13459599999','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045611061252',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15326179637','15326179637','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045615255553',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860301827','15860301827','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045615255554',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905057579','15905057579','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045615255555',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18060501876','18060501876','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045615255556',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13400887176','13400887176','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045615255557',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050020726','18050020726','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045615255558',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459246092','13459246092','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045615255559',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13055224466','13055224466','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449858',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18698399527','18698399527','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449859',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18314463516','18314463516','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449860',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859790099','13859790099','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449861',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260200619','15260200619','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449862',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15605009590','15605009590','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449863',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059755771','15059755771','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449864',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15827436094','15827436094','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045619449865',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15159887877','15159887877','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045623644161',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059510022','15059510022','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045623644162',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18606031846','18606031846','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045623644163',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905070935','15905070935','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045623644164',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805003589','15805003589','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045623644165',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260720911','15260720911','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045623644166',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050869127','18050869127','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045623644167',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659923130','18659923130','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045627838465',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859565605','15859565605','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045627838466',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18682261122','18682261122','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045627838467',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959700369','18959700369','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045627838468',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13615963766','13615963766','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045648809985',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980301999','15980301999','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045653004290',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13030978969','13030978969','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045653004291',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050878555','18050878555','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045653004292',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18650916825','18650916825','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045653004293',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959812033','13959812033','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045653004294',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859716793','18859716793','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045653004295',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13163906685','13163906685','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045653004296',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13665956888','13665956888','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045657198594',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259597676','15259597676','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045657198595',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259727676','15259727676','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045657198596',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905969285','13905969285','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045657198597',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960408350','13960408350','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045657198598',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959946911','13959946911','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045657198599',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18960251988','18960251988','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045657198600',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060969798','15060969798','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392897',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359855333','15359855333','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392898',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505071035','13505071035','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392899',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18905059500','18905059500','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392900',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17705061101','17705061101','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392901',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905059909','13905059909','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392902',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799581818','13799581818','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392903',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13626076868','13626076868','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045661392904',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960255304','13960255304','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045665587202',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805997206','13805997206','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045665587203',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506009833','13506009833','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045665587204',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13488682111','13488682111','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045665587205',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13675918895','13675918895','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045665587206',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759500600','15759500600','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045665587207',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860708740','13860708740','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045665587208',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805972719','15805972719','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045690753026',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050888018','18050888018','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045690753027',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960256303','13960256303','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045690753028',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18905079898','18905079898','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045694947330',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359508512','15359508512','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045694947331',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505051522','13505051522','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045694947332',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959853655','18959853655','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045694947333',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859505750','15859505750','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045694947334',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505050692','13505050692','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045694947335',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18905060268','18905060268','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045694947336',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959955769','13959955769','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141634',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15377953096','15377953096','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141635',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960731557','15960731557','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141636',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788826386','13788826386','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141637',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15375886386','15375886386','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141638',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659916888','18659916888','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141639',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859525583','18859525583','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141640',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506059007','13506059007','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045699141641',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505955666','13505955666','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045703335938',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636951165','13636951165','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045703335939',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13365952758','13365952758','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045703335940',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15375754488','15375754488','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045703335941',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808552366','13808552366','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045703335942',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960305030','13960305030','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045703335943',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559369710','13559369710','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045703335944',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13067166871','13067166871','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045707530242',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600785508','13600785508','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045707530243',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459218283','13459218283','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045707530244',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15605959006','15605959006','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045707530245',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960326290','13960326290','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045707530246',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18905051668','18905051668','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045728501762',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489387611','13489387611','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045732696065',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260305126','15260305126','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045732696066',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965129895','18965129895','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045732696067',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15106096021','15106096021','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045732696068',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13655986799','13655986799','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045732696069',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18250298076','18250298076','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890369',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15602265352','15602265352','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890370',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13809549382','13809549382','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890371',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13774825517','13774825517','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890372',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15810812160','15810812160','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890373',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18759429880','18759429880','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890374',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18609586661','18609586661','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890375',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980325929','15980325929','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045736890376',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15906092370','15906092370','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045741084674',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13044554499','13044554499','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045741084675',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18605008168','18605008168','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045741084676',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18350782990','18350782990','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045741084677',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805021228','15805021228','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045741084678',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13358591930','13358591930','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045741084679',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959995535','15959995535','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045741084680',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960417367','13960417367','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278977',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15659878695','15659878695','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278978',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13144828970','13144828970','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278979',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260875883','15260875883','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278980',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13675953607','13675953607','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278981',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859799829','18859799829','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278982',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13337211223','13337211223','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278983',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600757303','13600757303','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045745278984',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13626072564','13626072564','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045749473281',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13615950806','13615950806','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045770444802',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788846820','13788846820','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045770444803',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805919195','13805919195','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045770444804',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599717008','13599717008','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045774639105',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17689485050','17689485050','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045774639106',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259571333','15259571333','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045774639107',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260899107','15260899107','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045774639108',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880972652','15880972652','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045774639109',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980066202','15980066202','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045774639110',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080070385','15080070385','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045774639111',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059157225','15059157225','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833410',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959776520','13959776520','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833411',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759488187','15759488187','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833412',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13774828120','13774828120','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833413',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18771094578','18771094578','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833414',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13400820519','13400820519','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833415',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13779911861','13779911861','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833416',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959805200','18959805200','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045778833417',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18567651331','18567651331','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045783027713',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18695665035','18695665035','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045783027714',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859727077','13859727077','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045783027715',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15345952654','15345952654','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045783027716',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15659972175','15659972175','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045783027717',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359383363','15359383363','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045783027718',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959959200','15959959200','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045783027719',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960291518','13960291518','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045787222017',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13625979936','13625979936','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045787222018',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13514019395','13514019395','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045787222019',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15396608587','15396608587','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045787222020',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13969010619','13969010619','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045787222021',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859796953','13859796953','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045808193537',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15850693987','15850693987','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045812387842',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959870601','15959870601','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045812387843',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805981750','15805981750','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045812387844',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13842019660','13842019660','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045812387845',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13940108782','13940108782','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045812387846',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876572155','18876572155','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045812387847',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18862155925','18862155925','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045816582146',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18275745728','18275745728','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045816582147',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799487213','13799487213','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045816582148',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15502179365','15502179365','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',2,'关机','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045816582149',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15086777305','15086777305','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045816582150',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18850528121','18850528121','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045816582151',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18052150317','18052150317','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045816582152',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17689683160','17689683160','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776449',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859757759','18859757759','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776450',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18359810815','18359810815','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776451',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13696949262','13696949262','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776452',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18468034987','18468034987','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776453',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860116953','13860116953','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776454',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17689690969','17689690969','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776455',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18805920922','18805920922','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045820776456',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659030881','18659030881','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045824970753',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17006098806','17006098806','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045824970754',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17359711663','17359711663','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045824970755',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059803792','15059803792','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045824970756',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959813876','18959813876','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045824970757',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980013301','15980013301','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045824970758',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950430719','13950430719','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045824970759',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18250169959','18250169959','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045829165058',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18900336517','18900336517','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045850136577',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18105907301','18105907301','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045850136578',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18851401527','18851401527','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045850136579',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18020867909','18020867909','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045854330881',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860257142','15860257142','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045854330882',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876336921','18876336921','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045854330883',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15806032297','15806032297','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045854330884',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965785175','18965785175','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045854330885',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15005062379','15005062379','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045854330886',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18950700105','18950700105','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045854330887',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15005059367','15005059367','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525186',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18741355270','18741355270','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525187',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18150563203','18150563203','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525188',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13075572292','13075572292','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525189',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15502207706','15502207706','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525190',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18649652527','18649652527','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525191',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17741357996','17741357996','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525192',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15090088338','15090088338','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045858525193',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599220676','13599220676','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045862719489',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15191818740','15191818740','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045862719490',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18696960184','18696960184','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045862719491',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636957868','13636957868','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045862719492',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960551920','15960551920','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045862719493',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15629795466','15629795466','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045862719494',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15946798736','15946798736','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045862719495',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18959941093','18959941093','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045866913794',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599279399','13599279399','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045866913795',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080458330','15080458330','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045866913796',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18571081281','18571081281','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045866913797',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18065333731','18065333731','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045866913798',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17605014353','17605014353','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045887885313',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260785666','15260785666','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045892079618',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13027105101','13027105101','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045892079619',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17758709290','17758709290','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045892079620',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18046360864','18046360864','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045892079621',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860300607','13860300607','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045892079622',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18796922940','18796922940','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273921',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18020650858','18020650858','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273922',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489312968','13489312968','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273923',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13178336506','13178336506','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273924',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','14759154723','14759154723','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273925',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15141327771','15141327771','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273926',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980000372','15980000372','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273927',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18359714502','18359714502','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045896273928',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980060559','15980060559','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045900468226',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965523733','18965523733','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045900468227',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17759991213','17759991213','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045900468228',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18262283166','18262283166','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045900468229',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980000359','15980000359','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045900468230',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17755092627','17755092627','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045900468231',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960256299','13960256299','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045900468232',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15559110466','15559110466','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045904662530',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13122120652','13122120652','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045904662531',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959264368','13959264368','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045904662532',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080318157','15080318157','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045904662533',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060823577','15060823577','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045904662534',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659066928','18659066928','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045904662535',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636950764','13636950764','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045904662536',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860752060','13860752060','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045908856833',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13328555097','13328555097','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045908856834',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659003978','18659003978','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045929828353',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13313825373','13313825373','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045929828354',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559554933','13559554933','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022658',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505986964','13505986964','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022659',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18759919815','18759919815','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022660',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13314987388','13314987388','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022661',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18065606507','18065606507','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022662',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960753968','15960753968','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022663',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13614268392','13614268392','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022664',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906903291','13906903291','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045934022665',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18701704136','18701704136','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045938216962',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18898408023','18898408023','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045938216963',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18506966086','18506966086','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045938216964',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15702950980','15702950980','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045938216965',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18605914467','18605914467','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045938216966',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259223745','15259223745','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045938216967',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17750792370','17750792370','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045938216968',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759733818','15759733818','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411266',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15903645816','15903645816','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411267',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659719331','18659719331','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411268',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13313872221','13313872221','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411269',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13328989299','13328989299','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411270',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260704530','15260704530','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411271',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799564888','13799564888','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411272',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15659512626','15659512626','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045942411273',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17350011170','17350011170','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1274905045946605570',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808556705','13808556705','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045946605571',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506928380','13506928380','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045946605572',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905050688','15905050688','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045946605573',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805959366','13805959366','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045946605574',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15821998683','15821998683','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045971771393',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15111982965','15111982965','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045971771394',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980011425','15980011425','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045971771395',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18359877950','18359877950','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045975965697',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13488103520','13488103520','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045975965698',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959581739','15959581739','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045975965699',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18850496760','18850496760','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045975965700',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15985751705','15985751705','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045975965701',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805010196','15805010196','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045975965702',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18516970130','18516970130','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045975965703',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959861620','13959861620','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045980160002',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15829907184','15829907184','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045980160003',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13625959920','13625959920','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045980160004',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950238890','13950238890','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045980160005',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13612150403','13612150403','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045980160006',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600738975','13600738975','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045980160007',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599127767','13599127767','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045980160008',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788811853','13788811853','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045984354306',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060972472','15060972472','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045984354307',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060998567','15060998567','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045984354308',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459562051','13459562051','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045984354309',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905996868','15905996868','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045984354310',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080421696','15080421696','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045984354311',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13512216307','13512216307','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045984354312',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17706067083','17706067083','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045988548609',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600751875','13600751875','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045988548610',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18350062033','18350062033','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045988548611',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636905051','13636905051','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045988548612',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13625994626','13625994626','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045988548613',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18359837870','18359837870','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905045988548614',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799240204','13799240204','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046013714434',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959596201','15959596201','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046013714435',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','19959999308','19959999308','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046013714436',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799850617','13799850617','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046013714437',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13774877242','13774877242','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046017908738',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13850772504','13850772504','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046017908739',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','19959999508','19959999508','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046017908740',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059557916','15059557916','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046017908741',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950108669','13950108669','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046017908742',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059528748','15059528748','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046022103041',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959941521','13959941521','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',2,'空号','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046022103042',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959856161','13959856161','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046022103043',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506055166','13506055166','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046022103044',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880881006','15880881006','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046022103045',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960382970','13960382970','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046022103046',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489719977','13489719977','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046022103047',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860396396','15860396396','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046026297346',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559592136','13559592136','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046026297347',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505045259','13505045259','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046026297348',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060946052','15060946052','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046026297349',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880881883','15880881883','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046026297350',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18950026794','18950026794','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046026297351',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750931024','18750931024','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046030491650',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960391700','13960391700','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046030491651',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960459977','13960459977','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046030491652',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960292725','13960292725','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046030491653',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905032289','15905032289','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046030491654',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659060047','18659060047','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046030491655',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599994541','13599994541','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046030491656',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859577452','15859577452','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046034685953',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559045209','13559045209','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046055657473',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980065535','15980065535','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046059851778',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260101691','15260101691','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046059851779',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880762096','15880762096','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046059851780',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18759508729','18759508729','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046059851781',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906934045','13906934045','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046059851782',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15159529936','15159529936','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046064046081',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18905951960','18905951960','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046064046082',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880161129','15880161129','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046064046083',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799202233','13799202233','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046064046084',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13655933296','13655933296','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046064046085',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505907585','13505907585','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046064046086',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260852001','15260852001','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046064046087',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059520014','15059520014','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046068240385',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15601588313','15601588313','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046068240386',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859796399','15859796399','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046068240387',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359493923','15359493923','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046068240388',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980235626','15980235626','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046068240389',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559575942','13559575942','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046068240390',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15074870926','15074870926','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046068240391',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13774898032','13774898032','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046072434690',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905044580','15905044580','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046072434691',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599115973','13599115973','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046072434692',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060990680','15060990680','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046072434693',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17359990624','17359990624','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046072434694',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15985923093','15985923093','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046072434695',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950362316','13950362316','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046076628994',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788852001','13788852001','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046076628995',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13685910527','13685910527','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046076628996',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15106037664','15106037664','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046076628997',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960296362','13960296362','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046101794818',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15911052916','15911052916','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046105989122',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506062515','13506062515','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046105989123',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13520554703','13520554703','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046105989124',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15806036626','15806036626','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046105989125',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080417163','15080417163','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046105989126',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859785085','18859785085','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046110183425',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15359383458','15359383458','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046110183426',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905975697','15905975697','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046110183427',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18259060411','18259060411','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046110183428',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13075877415','13075877415','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046110183429',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905076266','15905076266','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046110183430',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980271486','15980271486','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046110183431',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859775715','15859775715','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046114377729',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860631416','13860631416','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046114377730',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808540799','13808540799','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046114377731',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060933526','15060933526','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046114377732',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18605001313','18605001313','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046114377733',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18225662357','18225662357','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046114377734',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18905080205','18905080205','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046118572034',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506057070','13506057070','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046118572035',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636993769','13636993769','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046118572036',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18250292550','18250292550','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046118572037',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060985107','15060985107','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046118572038',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060032495','15060032495','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046118572039',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18159235825','18159235825','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046118572040',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18350535110','18350535110','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046122766337',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13121833855','13121833855','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046122766338',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13685921872','13685921872','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046122766339',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980063533','15980063533','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046122766340',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860143467','13860143467','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046147932162',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18559273254','18559273254','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046147932163',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13404252272','13404252272','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046147932164',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17388204055','17388204055','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046147932165',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880758500','15880758500','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126466',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960581457','15960581457','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',2,'空号','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126467',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13627292269','13627292269','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126468',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','19905053569','19905053569','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126469',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13950364429','13950364429','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126470',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750530127','18750530127','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126471',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980067586','15980067586','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126472',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965658201','18965658201','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046152126473',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805948042','13805948042','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046156320770',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459533442','13459533442','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046156320771',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13696856720','13696856720','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046156320772',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599172228','13599172228','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046156320773',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13805956092','13805956092','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046156320774',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880754887','15880754887','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046156320775',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880818089','15880818089','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046156320776',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13689056004','13689056004','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046160515074',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13665965633','13665965633','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046160515075',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859554650','15859554650','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046160515076',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876284599','18876284599','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046160515077',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750537614','18750537614','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046160515078',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876377906','18876377906','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046160515079',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15201615843','15201615843','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046164709377',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505054724','13505054724','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046164709378',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18805921912','18805921912','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046164709379',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18835792826','18835792826','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046164709380',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859745152','13859745152','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046164709381',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15906061807','15906061807','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046194069506',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860516215','15860516215','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046194069507',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860900865','15860900865','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046198263809',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959232693','15959232693','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046198263810',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18159595252','18159595252','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046198263811',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859559078','15859559078','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046198263812',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18215628161','18215628161','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046198263813',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13779982480','13779982480','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046198263814',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959966729','15959966729','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046198263815',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13825584576','13825584576','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046202458113',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15122460079','15122460079','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046202458114',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18722334354','18722334354','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046202458115',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18202655266','18202655266','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046202458116',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15922263220','15922263220','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046202458117',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18581998214','18581998214','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046202458118',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059839423','15059839423','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046202458119',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860358661','15860358661','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046206652418',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18559511816','18559511816','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046206652419',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13275049035','13275049035','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046206652420',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18559552007','18559552007','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046206652421',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959264462','15959264462','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046206652422',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599710039','13599710039','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046206652423',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15559528807','15559528807','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046206652424',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799239129','13799239129','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046210846722',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880027485','15880027485','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046210846723',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18292491251','18292491251','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046210846724',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13706991487','13706991487','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046210846725',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18906999069','18906999069','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046210846726',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876569027','18876569027','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046210846727',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859553823','15859553823','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046210846728',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980274172','15980274172','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046236012546',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980068126','15980068126','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046236012547',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960259810','13960259810','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046236012548',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060804302','15060804302','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046240206850',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876539839','18876539839','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046240206851',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960826248','13960826248','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046240206852',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15280423942','15280423942','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046240206853',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659069495','18659069495','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046240206854',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15280404202','15280404202','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046240206855',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18350776066','18350776066','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046240206856',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18868801836','18868801836','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401153',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13859085700','13859085700','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401154',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13808505910','13808505910','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401155',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15806017885','15806017885','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401156',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805956361','15805956361','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401157',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805990003','15805990003','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401158',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880480928','15880480928','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401159',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980232523','15980232523','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046244401160',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13635240509','13635240509','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046248595457',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13110982808','13110982808','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046248595458',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18046040451','18046040451','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046248595459',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18250882613','18250882613','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046248595460',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18805025309','18805025309','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046248595461',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965513668','18965513668','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046248595462',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18046009745','18046009745','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046248595463',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960254757','13960254757','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046252789762',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15806019077','15806019077','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046252789763',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15160441962','15160441962','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046252789764',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960746554','15960746554','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046252789765',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599978051','13599978051','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046252789766',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15280422458','15280422458','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046273761281',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906099550','13906099550','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046277955585',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13685000414','13685000414','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046277955586',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13665001804','13665001804','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046277955587',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18960877567','18960877567','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046277955588',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759296423','15759296423','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046277955589',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959552577','15959552577','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149890',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876568900','18876568900','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149891',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15205011506','15205011506','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149892',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18605007853','18605007853','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149893',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18250422227','18250422227','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149894',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18606942212','18606942212','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149895',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13067198079','13067198079','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149896',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18950490831','18950490831','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046282149897',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13400539210','13400539210','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046286344194',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959530855','15959530855','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046286344195',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18825160801','18825160801','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046286344196',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18817333998','18817333998','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046286344197',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15705923619','15705923619','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046286344198',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559546275','13559546275','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046286344199',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18559672261','18559672261','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046286344200',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18862155979','18862155979','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538498',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659097395','18659097395','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538499',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15606087056','15606087056','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538500',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18782977456','18782977456','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538501',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18429006632','18429006632','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538502',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15985900838','15985900838','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538503',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13615926622','13615926622','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538504',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260225737','15260225737','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046290538505',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489887652','13489887652','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046294732801',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18703659101','18703659101','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046315704321',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13646031399','13646031399','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046315704322',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599177919','13599177919','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046319898625',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13696857207','13696857207','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046319898626',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15392121201','15392121201','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046319898627',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959952350','13959952350','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046319898628',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959921098','13959921098','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046319898629',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799855086','13799855086','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046319898630',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13242884288','13242884288','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046319898631',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13316225195','13316225195','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046324092930',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960257652','13960257652','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046324092931',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080426614','15080426614','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046324092932',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750651805','18750651805','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046324092933',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659005089','18659005089','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046324092934',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13665903960','13665903960','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046324092935',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960256111','13960256111','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046324092936',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13601076764','13601076764','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287234',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599715762','13599715762','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287235',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13459523253','13459523253','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287236',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13107880950','13107880950','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287237',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15750898928','15750898928','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287238',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18950498312','18950498312','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287239',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18759922187','18759922187','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287240',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13850757007','13850757007','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046328287241',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860602468','13860602468','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046332481537',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13305962813','13305962813','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046332481538',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859225776','18859225776','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046332481539',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13661356074','13661356074','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046332481540',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13645019389','13645019389','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046332481541',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600788662','13600788662','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046332481542',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18030243370','18030243370','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046361841666',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','19905908656','19905908656','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046361841667',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18344910844','18344910844','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046361841668',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18059147928','18059147928','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046366035969',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260708136','15260708136','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046366035970',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880824003','15880824003','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046366035971',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18259061182','18259061182','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046366035972',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799857333','13799857333','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046366035973',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15606946335','15606946335','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046366035974',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060933832','15060933832','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046366035975',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059871315','15059871315','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046370230274',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17850929207','17850929207','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046370230275',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750654331','18750654331','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046370230276',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13906099845','13906099845','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046370230277',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880024622','15880024622','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046370230278',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060827887','15060827887','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046370230279',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18605958852','18605958852','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046370230280',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905909283','15905909283','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424577',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805060325','15805060325','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424578',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15620633941','15620633941','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424579',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980006525','15980006525','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424580',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880764254','15880764254','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424581',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18100525107','18100525107','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424582',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959888168','13959888168','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424583',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18559477701','18559477701','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046374424584',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18750561717','18750561717','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046378618881',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759596655','15759596655','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046378618882',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13905955872','13905955872','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046378618883',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17606025253','17606025253','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046378618884',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13605944765','13605944765','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046378618885',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599717079','13599717079','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046403784706',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505954433','13505954433','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046407979009',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13615908669','13615908669','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046407979010',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506030795','13506030795','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046407979011',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905988871','15905988871','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046407979012',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960250972','15960250972','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046407979013',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15280081010','15280081010','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173313',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788816686','13788816686','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173314',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17683234600','17683234600','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173315',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18005073259','18005073259','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173316',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18005065560','18005065560','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173317',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18705045726','18705045726','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173318',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050270931','18050270931','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173319',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17758766631','17758766631','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046412173320',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15071360501','15071360501','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046416367617',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13305952629','13305952629','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046416367618',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15659132085','15659132085','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046416367619',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15305009255','15305009255','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046416367620',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15080406979','15080406979','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046416367621',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050916965','18050916965','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046416367622',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18050876301','18050876301','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046416367623',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15905903705','15905903705','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561921',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13328505767','13328505767','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561922',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13285957289','13285957289','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561923',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15396596855','15396596855','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561924',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13559513508','13559513508','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561925',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13229424859','13229424859','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561926',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13645032611','13645032611','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561927',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059154896','15059154896','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046420561928',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18650591551','18650591551','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046424756225',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18965662565','18965662565','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046449922050',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759216753','15759216753','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046449922051',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960217968','15960217968','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046449922052',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17359987925','17359987925','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116354',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18084725997','18084725997','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116355',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18805065856','18805065856','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116356',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859971221','18859971221','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116357',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859759601','15859759601','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116358',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13615901213','13615901213','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116359',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15559162475','15559162475','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116360',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18559161283','18559161283','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046454116361',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18659030309','18659030309','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046458310657',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259546913','15259546913','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046458310658',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799521561','13799521561','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046458310659',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13794913769','13794913769','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046458310660',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17750799505','17750799505','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046458310661',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505906457','13505906457','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046458310662',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18106980703','18106980703','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504962',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859464970','18859464970','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504963',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959975329','13959975329','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504964',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060456431','15060456431','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504965',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859780809','18859780809','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504966',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059719567','15059719567','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504967',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15029265211','15029265211','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504968',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15960402869','15960402869','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046462504969',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18829340451','18829340451','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046466699265',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15191845928','15191845928','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046466699266',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15191815436','15191815436','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046466699267',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18559472664','18559472664','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046466699268',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18539456470','18539456470','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046466699269',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17759892862','17759892862','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046491865090',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876272213','18876272213','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046491865091',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13669274728','13669274728','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046491865092',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18829298483','18829298483','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046496059394',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','19959848541','19959848541','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046496059395',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18250850010','18250850010','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046496059396',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','17689494919','17689494919','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046496059397',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15389303652','15389303652','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046496059398',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18740431050','18740431050','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046496059399',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805955751','15805955751','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046496059400',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13649283497','13649283497','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046500253698',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959590927','15959590927','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046500253699',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759496852','15759496852','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046500253700',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859996145','18859996145','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046500253701',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18192276329','18192276329','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046500253702',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759590781','15759590781','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046500253703',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18806028372','18806028372','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046500253704',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15559544571','15559544571','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046504448002',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15191815139','15191815139','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046504448003',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15860902967','15860902967','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046504448004',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13067154015','13067154015','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046504448005',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15059850519','15059850519','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046504448006',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18392859639','18392859639','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046504448007',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13484917236','13484917236','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046504448008',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15029140185','15029140185','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046508642305',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18876223641','18876223641','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046508642306',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','19906870165','19906870165','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046508642307',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13960311095','13960311095','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046508642308',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13072350035','13072350035','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046508642309',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15202404290','15202404290','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046508642310',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15029279845','15029279845','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046533808129',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15979017673','15979017673','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046533808130',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15620636649','15620636649','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046533808131',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13484540329','13484540329','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046533808132',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18316739194','18316739194','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046538002434',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15259519391','15259519391','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046538002435',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15202427957','15202427957','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046538002436',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13572104402','13572104402','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046538002437',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15527179406','15527179406','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046542196738',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15759653345','15759653345','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046542196739',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18292635234','18292635234','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046542196740',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15029278847','15029278847','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046542196741',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15029236362','15029236362','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046546391042',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13489848301','13489848301','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046546391043',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13004886898','13004886898','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046546391044',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13720852551','13720852551','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046546391045',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13410024480','13410024480','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046546391046',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13659192458','13659192458','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046550585345',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15060832111','15060832111','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046550585346',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15623564761','15623564761','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046550585347',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15605003638','15605003638','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046550585348',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15859495050','15859495050','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046550585349',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980036243','15980036243','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046554779649',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15805952318','15805952318','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046554779650',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880931696','15880931696','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046554779651',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636903309','13636903309','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046554779652',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959888180','15959888180','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046554779653',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13615940087','13615940087','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046554779654',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505992220','13505992220','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046554779655',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15985905430','15985905430','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046558973954',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18815985602','18815985602','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046579945474',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959592127','15959592127','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046584139777',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506045449','13506045449','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046584139778',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506066359','13506066359','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046584139779',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13799899315','13799899315','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334081',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13860703516','13860703516','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334082',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13959882723','13959882723','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334083',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880825431','15880825431','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334084',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15880975265','15880975265','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334085',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13599719905','13599719905','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334086',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13159060909','13159060909','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334087',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15159724662','15159724662','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046588334088',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13505990915','13505990915','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046592528385',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13788803006','13788803006','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046592528386',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13506061896','13506061896','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046592528387',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13030982553','13030982553','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046592528388',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18006037070','18006037070','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046592528389',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13055336977','13055336977','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046592528390',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15906066000','15906066000','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046592528391',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18006990697','18006990697','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046596722690',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13328979519','13328979519','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046596722691',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15159790586','15159790586','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046596722692',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13636959434','13636959434','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046596722693',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980478011','15980478011','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046596722694',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13606021816','13606021816','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046596722695',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980056221','15980056221','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046596722696',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15606088553','15606088553','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046600916994',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959962792','15959962792','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046600916995',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15280875858','15280875858','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046600916996',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18850383723','18850383723','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046600916997',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15980041722','15980041722','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046626082818',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859552366','18859552366','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277121',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859626598','18859626598','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277122',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13600766763','13600766763','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277123',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18850549376','18850549376','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277124',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859495931','18859495931','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277125',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15959990680','15959990680','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277126',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','15260813616','15260813616','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277127',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','18859763636','18859763636','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274905046630277128',NULL,'1274905044931584002',2,2,'批量发送(关于开展2020年度优秀人才申报认定工作的通知20200622)','13295908788','13295908788','【晋江市人才服务平台】通知：“晋江市人才综合服务平台”已重新开放，请大家相互转告，如需进行2020年度优秀人才认定、人才层次变更等，可登陆“聚才网”-“优秀人才申报系统”进行操作，谢谢！',3,'短信发送成功','2020-06-22 11:20:23',NULL,NULL,NULL,'2020-06-22 11:20:23',NULL,NULL,NULL),('1274911427236208641',NULL,'1274911427236208641',2,1,NULL,'15392271725','180191','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 11:45:45',NULL,NULL,NULL),('1274912796248645633',NULL,'1274912796248645633',2,1,NULL,'15392271725','937334','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 11:51:12',NULL,NULL,NULL),('1274940571168808962',NULL,'1274940571168808962',2,1,NULL,'13275085383','822537','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 13:41:34',NULL,NULL,NULL),('1274972879670222850','1274962714078224385','1274972879670222850',2,2,'福建泉成机械有限公司','15392286115','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 15:49:57',NULL,NULL,NULL),('1274985285729394689',NULL,'1274985285729394689',2,1,NULL,'18250413746','805158','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 16:39:14',NULL,NULL,NULL),('1274985989353250817',NULL,'1274985989353250817',2,1,NULL,'18250413746','106720','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 16:42:02',NULL,NULL,NULL),('1274986499091210241',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905055474','13905055474','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499095404546',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905085845','13905085845','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499095404547',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959889099','15959889099','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499095404548',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905089465','13905089465','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499095404549',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506009833','13506009833','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598849',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805997206','13805997206','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598850',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13400840823','13400840823','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598851',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808552366','13808552366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598852',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799239878','13799239878','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598853',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13338583366','13338583366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598854',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859781366','18859781366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598855',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788805366','13788805366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499099598856',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505905737','13505905737','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499103793153',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905907962','15905907962','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499103793154',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505050069','13505050069','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499103793155',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159512595','15159512595','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499103793156',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13906095618','13906095618','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499103793157',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636951165','13636951165','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499103793158',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805951603','13805951603','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499103793159',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859775220','13859775220','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499107987457',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599161927','13599161927','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499107987458',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659916888','18659916888','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499107987459',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13205061526','13205061526','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499107987460',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905006716','15905006716','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499107987461',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788826386','13788826386','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499107987462',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059556400','15059556400','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499107987463',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18016585576','18016585576','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499112181762',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18606985861','18606985861','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499112181763',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18606056998','18606056998','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499112181764',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15105995993','15105995993','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499112181765',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13255957226','13255957226','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499141541890',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18650675858','18650675858','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499141541891',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859271698','18859271698','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736194',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13701315570','13701315570','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736195',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808514751','13808514751','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736196',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905975119','13905975119','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736197',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959847128','18959847128','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736198',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15160423086','15160423086','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736199',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15260399516','15260399516','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736200',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905958858','15905958858','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499145736201',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788851307','13788851307','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499149930497',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808512082','13808512082','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499149930498',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489512136','13489512136','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499149930499',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15985951598','15985951598','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499149930500',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905055709','15905055709','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499149930501',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13696900561','13696900561','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499149930502',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599507077','13599507077','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499149930503',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15985952242','15985952242','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124801',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505951467','13505951467','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124802',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599159330','13599159330','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124803',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959855726','18959855726','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124804',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13906998716','13906998716','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124805',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960285117','13960285117','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124806',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965687332','18965687332','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124807',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13313889912','13313889912','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499154124808',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960359859','13960359859','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499158319105',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959210622','18959210622','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499158319106',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328883775','13328883775','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499158319107',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13305967663','13305967663','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499158319108',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13285030066','13285030066','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499158319109',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15396336096','15396336096','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499183484930',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850777672','13850777672','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499187679233',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959953589','13959953589','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499187679234',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13774878631','13774878631','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499187679235',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18876244708','18876244708','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499187679236',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18705052323','18705052323','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499187679237',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559566696','13559566696','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499187679238',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13306995188','13306995188','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873538',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160990369','18160990369','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873539',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965687331','18965687331','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873540',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960207400','13960207400','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873541',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13400808814','13400808814','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873542',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13665959771','13665959771','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873543',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13295029222','13295029222','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873544',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13608354375','13608354375','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499191873545',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960692650','15960692650','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499196067842',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659568811','18659568811','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499196067843',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105087203','18105087203','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499196067844',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13720889138','13720889138','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499196067845',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599911707','13599911707','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499196067846',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905070552','13905070552','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499196067847',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799453379','13799453379','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499196067848',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965689935','18965689935','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262145',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959737339','13959737339','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262146',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959798579','15959798579','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262147',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13950920100','13950920100','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262148',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13615961122','13615961122','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262149',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506029535','13506029535','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262150',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965689828','18965689828','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262151',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959858628','13959858628','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499200262152',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15559593868','15559593868','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499229622273',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960232793','13960232793','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499233816578',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805051580','15805051580','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499233816579',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599991899','13599991899','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499233816580',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13074992803','13074992803','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499233816581',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506044192','13506044192','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499233816582',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600750078','13600750078','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499233816583',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15995216889','15995216889','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499233816584',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375886386','15375886386','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499238010882',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506056368','13506056368','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499238010883',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359585555','15359585555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499238010884',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808555555','13808555555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499238010885',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959505915','15959505915','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499238010886',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505059388','13505059388','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499238010887',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859575388','18859575388','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499242205185',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18650085153','18650085153','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499242205186',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960251988','18960251988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499242205187',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505957512','13505957512','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499242205188',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805957070','13805957070','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499242205189',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15060969798','15060969798','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499242205190',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15392288855','15392288855','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499246399490',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659915000','18659915000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499246399491',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','85057269','85057269','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'错误的电话号码','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499246399492',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505059996','13505059996','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499246399493',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960259259','18960259259','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499246399494',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17750989111','17750989111','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499246399495',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505905685','13505905685','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499250593794',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959981231','18959981231','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499250593795',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636906289','13636906289','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499250593796',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506066917','13506066917','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499250593797',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860353200','15860353200','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499288342530',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13358577766','13358577766','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499292536834',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805950256','13805950256','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499292536835',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859551097','18859551097','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499292536836',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959501213','15959501213','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499296731138',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505008000','13505008000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499296731139',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600701178','13600701178','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499296731140',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959850238','13959850238','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499296731141',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505045000','13505045000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499296731142',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13675923392','13675923392','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499296731143',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850778776','13850778776','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499300925442',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959119986','13959119986','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499300925443',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860356356','15860356356','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499300925444',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960795588','15960795588','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499300925445',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959939999','13959939999','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499300925446',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860726225','13860726225','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499300925447',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13675930836','13675930836','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499300925448',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18650916825','18650916825','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499305119745',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359855333','15359855333','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499305119746',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905077879','15905077879','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499305119747',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506956509','13506956509','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499305119748',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505071035','13505071035','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499305119749',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18006037555','18006037555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499309314049',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15605009590','15605009590','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499309314050',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','85552595','85552595','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'错误的电话号码','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499309314051',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959569933','15959569933','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499309314052',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13030978969','13030978969','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499309314053',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788800419','13788800419','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499309314054',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17506990761','17506990761','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499313508354',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159739903','15159739903','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499313508355',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859754633','13859754633','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499347062785',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905035169','15905035169','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499351257089',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15260429705','15260429705','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499351257090',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905006169','15905006169','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499351257091',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359556333','15359556333','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499355451393',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559369198','13559369198','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499355451394',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13488682111','13488682111','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499355451395',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860517253','15860517253','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499355451396',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15985959061','15985959061','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499355451397',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18905059500','18905059500','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499355451398',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905971030','13905971030','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499355451399',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959926888','13959926888','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499359645697',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659737170','18659737170','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499359645698',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18815997296','18815997296','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499359645699',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905079280','13905079280','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499359645700',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808525056','13808525056','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499359645701',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','1336928198','1336928198','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'错误的电话号码','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499359645702',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808558181','13808558181','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499359645703',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960731557','15960731557','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840001',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905070935','15905070935','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840002',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13675995249','13675995249','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840003',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805073665','15805073665','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840004',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959856777','15959856777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840005',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905075757','13905075757','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840006',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18905051668','18905051668','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840007',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15980301999','15980301999','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499363840008',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13606051571','13606051571','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499368034306',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489512117','13489512117','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499368034307',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15759500600','15759500600','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499368034308',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15980025829','15980025829','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499368034309',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15060619686','15060619686','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499393200129',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799870758','13799870758','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499397394434',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15980313135','15980313135','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499397394435',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960451941','13960451941','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499397394436',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960305030','13960305030','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499397394437',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805972719','15805972719','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499397394438',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905089701','13905089701','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499397394439',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15259442997','15259442997','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588737',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505957830','13505957830','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588738',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960353905','18960353905','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588739',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18359592597','18359592597','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588740',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','85556080','85556080','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'错误的电话号码','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588741',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960278086','18960278086','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588742',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805941850','13805941850','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588743',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13055650678','13055650678','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499401588744',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13666026522','13666026522','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499405783041',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860301827','15860301827','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499405783042',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15980788802','15980788802','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499405783043',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850753398','13850753398','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499405783044',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18698360960','18698360960','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499405783045',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859590857','15859590857','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499405783046',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13709857491','13709857491','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499405783047',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','136000704026','136000704026','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'错误的电话号码','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499409977345',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13085059001','13085059001','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499409977346',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15505952026','15505952026','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499409977347',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15106033846','15106033846','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499409977348',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859989821','13859989821','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499409977349',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559088636','13559088636','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499409977350',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18616523918','18616523918','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499409977351',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805026065','15805026065','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499414171649',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13055808024','13055808024','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499439337473',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960263035','13960263035','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499439337474',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18876509838','18876509838','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499443531778',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959886256','15959886256','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499443531779',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13159037366','13159037366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499443531780',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850777555','13850777555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499443531781',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13459504545','13459504545','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499443531782',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18150983366','18150983366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499443531783',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850755588','13850755588','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499443531784',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960326290','13960326290','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499447726082',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600703555','13600703555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499447726083',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905089834','13905089834','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499447726084',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13803031977','13803031977','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499447726085',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13655601013','13655601013','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499447726086',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15985918296','15985918296','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499447726087',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859532777','15859532777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499447726088',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050633631','18050633631','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920385',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860397378','15860397378','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920386',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559360789','13559360789','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920387',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860757775','13860757775','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920388',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959592923','15959592923','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920389',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905974006','13905974006','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920390',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960256303','13960256303','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920391',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050020726','18050020726','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499451920392',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13071898300','13071898300','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499456114690',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059597777','15059597777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499456114691',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15050859383','15050859383','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499456114692',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13459599999','13459599999','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499456114693',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959990198','15959990198','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499456114694',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13920285434','13920285434','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499456114695',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859907988','18859907988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499481280513',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905968151','13905968151','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499485474818',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050303359','18050303359','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499485474819',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559558996','13559558996','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499485474820',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960411692','13960411692','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499485474821',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960381057','13960381057','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499485474822',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13105079935','13105079935','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499489669122',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18722290558','18722290558','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499489669123',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15106087765','15106087765','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499489669124',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13906091302','13906091302','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499489669125',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13950092022','13950092022','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499489669126',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18682261122','18682261122','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499489669127',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13705941428','13705941428','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499489669128',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18005053009','18005053009','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499493863425',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105055292','18105055292','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499493863426',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505052567','13505052567','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499493863427',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15259597676','15259597676','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499493863428',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13055224466','13055224466','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499493863429',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959753823','13959753823','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499493863430',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880815069','15880815069','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499493863431',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18950351553','18950351553','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499498057729',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17750798475','17750798475','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499498057730',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859813817','15859813817','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499498057731',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050878981','18050878981','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499498057732',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965636930','18965636930','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499498057733',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805003589','15805003589','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499498057734',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18606031846','18606031846','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499498057735',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13802609526','13802609526','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499502252033',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13801333177','13801333177','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499502252034',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18314463516','18314463516','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499502252035',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059157330','15059157330','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499527417857',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050929268','18050929268','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499531612161',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959218329','18959218329','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499531612162',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559593361','13559593361','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499531612163',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15105978225','15105978225','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499531612164',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15060626155','15060626155','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499535806466',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375754488','15375754488','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499535806467',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18030358668','18030358668','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499535806468',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959858592','18959858592','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499535806469',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13906099888','13906099888','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499535806470',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799896025','13799896025','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499535806471',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505082577','13505082577','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499535806472',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600703008','13600703008','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499540000770',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17705066726','17705066726','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499540000771',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559550686','13559550686','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499540000772',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959599793','15959599793','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499540000773',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805951761','13805951761','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499540000774',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13163906685','13163906685','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499540000775',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505902557','13505902557','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499540000776',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506095562','13506095562','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195073',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559087665','13559087665','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195074',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18606989899','18606989899','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195075',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599611717','13599611717','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195076',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050303111','18050303111','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195077',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18805956568','18805956568','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195078',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959783399','13959783399','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195079',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18815980119','18815980119','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499544195080',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599109151','13599109151','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499548389377',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959705077','18959705077','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499548389378',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960457127','13960457127','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499548389379',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659099600','18659099600','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499573555202',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880785555','15880785555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749505',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799489750','13799489750','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749506',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18815980158','18815980158','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749507',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859799951','18859799951','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749508',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506042338','13506042338','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749509',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18815971188','18815971188','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749510',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15750921685','15750921685','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749511',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18368518985','18368518985','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749512',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18950070276','18950070276','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749513',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17606067156','17606067156','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749514',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505955666','13505955666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749515',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15280257625','15280257625','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499577749516',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15326179637','15326179637','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499581943810',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18815981058','18815981058','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'未知错误','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499581943811',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15810298887','15810298887','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138114',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18016513651','18016513651','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138115',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105082610','18105082610','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138116',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','19959860199','19959860199','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138117',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18060501876','18060501876','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138118',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13655928585','13655928585','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138119',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959882366','15959882366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138120',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788833384','13788833384','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499586138121',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15659707257','15659707257','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499590332417',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17350786575','17350786575','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499590332418',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18118917499','18118917499','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499590332419',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15527204727','15527204727','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499590332420',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18559223590','18559223590','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499590332421',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559518886','13559518886','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499590332422',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13114362008','13114362008','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499590332423',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18605956664','18605956664','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499615498241',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059066119','15059066119','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499619692545',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788829369','13788829369','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499619692546',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13779953927','13779953927','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499619692547',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15759233296','15759233296','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499619692548',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18559510509','18559510509','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499619692549',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799591130','13799591130','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499619692550',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17689471466','17689471466','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499619692551',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15980473561','15980473561','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886850',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15659085736','15659085736','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'连接过多,联通网关的内部错误','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886851',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13459556182','13459556182','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886852',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960206656','18960206656','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886853',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905950588','13905950588','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886854',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859971221','18859971221','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886855',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15083847155','15083847155','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886856',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505080996','13505080996','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499623886857',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15611255393','15611255393','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499628081154',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13459573303','13459573303','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499628081155',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505932929','13505932929','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499628081156',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18900371513','18900371513','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499628081157',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13774801406','13774801406','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499628081158',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959951039','13959951039','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499628081159',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905079361','15905079361','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499632275457',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859751591','13859751591','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499632275458',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636950560','13636950560','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499632275459',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959840868','13959840868','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499632275460',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13906999100','13906999100','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499632275461',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18006990697','18006990697','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499632275462',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659803841','18659803841','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499632275463',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15396583913','15396583913','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499636469761',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600753338','13600753338','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499665829890',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808549828','13808549828','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499670024194',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600709507','13600709507','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499670024195',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805959598','13805959598','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499670024196',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15259555117','15259555117','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499670024197',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859701319','15859701319','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499670024198',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17350786569','17350786569','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499670024199',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506083126','13506083126','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499670024200',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15392288851','15392288851','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218497',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15392286115','15392286115','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218498',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13509362773','13509362773','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218499',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18559161283','18559161283','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218500',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959995705','18959995705','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218501',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059792958','15059792958','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218502',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18084726690','18084726690','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218503',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659743753','18659743753','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499674218504',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13225070039','13225070039','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'关机','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499678412802',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905350771','13905350771','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499678412803',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599212929','13599212929','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499678412804',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960732777','15960732777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499678412805',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659030309','18659030309','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499678412806',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13027105101','13027105101','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499678412807',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18759997255','18759997255','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499678412808',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18605008168','18605008168','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499682607105',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','19942826787','19942826787','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499682607106',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13110592357','13110592357','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499682607107',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059823968','15059823968','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499682607108',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13110816682','13110816682','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499682607109',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15750768536','15750768536','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499682607110',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636957868','13636957868','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499682607111',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18065333731','18065333731','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499707772929',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18065376686','18065376686','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967233',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805032333','15805032333','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967234',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17805982933','17805982933','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967235',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15980035607','15980035607','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967236',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18359810815','18359810815','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967237',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13313872221','13313872221','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967238',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506000615','13506000615','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967239',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805997578','13805997578','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499711967240',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959557241','15959557241','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499716161538',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18659262866','18659262866','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499716161539',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960282791','13960282791','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499716161540',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960408350','13960408350','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499716161541',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13685908658','13685908658','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499716161542',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13675965549','13675965549','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499716161543',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959700369','18959700369','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499716161544',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600703472','13600703472','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355842',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13194068170','13194068170','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355843',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805957117','13805957117','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355844',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960778794','15960778794','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355845',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13459572624','13459572624','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355846',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799857951','13799857951','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355847',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860736349','13860736349','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355848',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13794913769','13794913769','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499720355849',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15259555555','15259555555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499724550146',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880990268','15880990268','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499724550147',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18650908918','18650908918','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499724550148',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13358591930','13358591930','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499724550149',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636928198','13636928198','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499724550150',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13665956888','13665956888','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499724550151',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960255304','13960255304','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499749715970',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799581818','13799581818','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499753910273',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13626076868','13626076868','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499753910274',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859759030','13859759030','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499758104577',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859771689','15859771689','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499758104578',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15392121201','15392121201','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499758104579',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13488103520','13488103520','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499758104580',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859759601','15859759601','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499762298881',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506054328','13506054328','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499762298882',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15396597171','15396597171','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499762298883',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965523733','18965523733','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499762298884',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18993299613','18993299613','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499762298885',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13122120652','13122120652','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499766493186',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15388603813','15388603813','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499766493187',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15106015337','15106015337','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499766493188',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15759653345','15759653345','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499766493189',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506998846','13506998846','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499766493190',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18506966086','18506966086','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499766493191',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18876223641','18876223641','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499770687490',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18262283166','18262283166','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499770687491',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13572104402','13572104402','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499770687492',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15527179406','15527179406','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499770687493',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18710465485','18710465485','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499770687494',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17317312368','17317312368','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499770687495',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18250850010','18250850010','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499770687496',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860752060','13860752060','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499774881794',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17759892862','17759892862','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499774881795',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18806028372','18806028372','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499774881796',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18829298483','18829298483','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499774881797',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17759991213','17759991213','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499774881798',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17606001293','17606001293','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499829407745',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18759919815','18759919815','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499833602049',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15559544571','15559544571','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499833602050',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959592638','15959592638','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499833602051',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13950317095','13950317095','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499833602052',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506060342','13506060342','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499833602053',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959590927','15959590927','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499833602054',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599749999','13599749999','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796354',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13615963766','13615963766','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796355',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859565605','15859565605','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796356',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15392481724','15392481724','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796357',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905059909','13905059909','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796358',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859716793','18859716793','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796359',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959887171','15959887171','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796360',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506045838','13506045838','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499837796361',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15060972266','15060972266','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990658',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059510022','15059510022','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990659',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13305971330','13305971330','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990660',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960278383','18960278383','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990661',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905970565','13905970565','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990662',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959997958','18959997958','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990663',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959593789','15959593789','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990664',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905063959','13905063959','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499841990665',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13601032833','13601032833','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499846184962',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506051505','13506051505','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499846184963',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959776520','13959776520','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499846184964',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959753399','18959753399','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499846184965',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805957081','13805957081','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499846184966',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808510760','13808510760','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499846184967',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860322322','15860322322','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499846184968',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860757696','13860757696','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499871350786',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859758762','13859758762','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499875545090',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600701207','13600701207','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499875545091',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505053671','13505053671','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499875545092',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600732359','13600732359','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499875545093',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18065339785','18065339785','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499875545094',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959885018','15959885018','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499875545095',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808558001','13808558001','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739394',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860755570','13860755570','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739395',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359500085','15359500085','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739396',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860707408','13860707408','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739397',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328967897','13328967897','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739398',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959996125','18959996125','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739399',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059859792','15059859792','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739400',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905010099','15905010099','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499879739401',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506064500','13506064500','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499883933697',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18558983360','18558983360','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499883933698',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960295358','13960295358','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499883933699',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15259503858','15259503858','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499883933700',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13358569966','13358569966','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499883933701',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18150981808','18150981808','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499883933702',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328563789','13328563789','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499883933703',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18065339718','18065339718','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128002',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960252599','18960252599','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128003',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159877969','15159877969','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128004',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13774859831','13774859831','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128005',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13365967502','13365967502','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128006',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636994983','13636994983','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128007',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505957887','13505957887','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128008',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18016505959','18016505959','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499888128009',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506952780','13506952780','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499913293825',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859555637','15859555637','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499917488129',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15060920659','15060920659','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499917488130',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375753351','15375753351','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499917488131',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905059767','13905059767','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499917488132',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050612358','18050612358','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499917488133',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799212898','13799212898','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499917488134',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13774853339','13774853339','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499921682434',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960207714','13960207714','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499921682435',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375750986','15375750986','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499921682436',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799545474','13799545474','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499921682437',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13004871856','13004871856','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499921682438',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375758381','15375758381','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499921682439',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788857025','13788857025','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499921682440',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13004812421','13004812421','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499925876738',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160996273','18160996273','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499925876739',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506058950','13506058950','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499925876740',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15985923558','15985923558','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499925876741',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859798936','13859798936','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499925876742',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489317518','13489317518','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499925876743',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505951825','13505951825','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499925876744',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13774898940','13774898940','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499930071042',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599751599','13599751599','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499930071043',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18059999739','18059999739','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499930071044',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15160323000','15160323000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499930071045',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18150981965','18150981965','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499930071046',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959851225','18959851225','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499930071047',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13655926686','13655926686','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499930071048',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905036767','15905036767','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499934265345',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359502577','15359502577','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499934265346',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960778063','15960778063','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499959431170',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905950768','13905950768','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499959431171',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805025858','15805025858','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499959431172',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805013760','15805013760','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499959431173',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808509287','13808509287','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499963625474',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960383717','18960383717','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499963625475',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15811060106','15811060106','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499963625476',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965696515','18965696515','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499963625477',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059851615','15059851615','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499963625478',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506957115','13506957115','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499963625479',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860902576','15860902576','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499963625480',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13178017456','13178017456','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819777',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960557097','15960557097','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819778',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805957304','13805957304','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819779',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489302250','13489302250','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819780',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960351496','13960351496','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819781',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13665969968','13665969968','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819782',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859598678','18859598678','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819783',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13400886486','13400886486','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499967819784',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960252288','13960252288','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499972014081',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905085912','13905085912','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499972014082',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959898125','13959898125','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499972014083',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788853258','13788853258','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499972014084',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880729668','15880729668','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499972014085',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18906996078','18906996078','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499972014086',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15345994706','15345994706','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499976208385',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600740753','13600740753','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499976208386',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960776250','15960776250','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499976208387',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965611666','18965611666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499976208388',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960206893','18960206893','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986499976208389',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965696111','18965696111','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500001374210',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505906061','13505906061','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500005568513',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859503880','15859503880','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500005568514',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959896753','13959896753','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500005568515',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13365950805','13365950805','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500005568516',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959759632','18959759632','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500005568517',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959990407','13959990407','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500005568518',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13110828738','13110828738','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500005568519',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359502988','15359502988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762817',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905059153','13905059153','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762818',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506054912','13506054912','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762819',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860405577','15860405577','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762820',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808556780','13808556780','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762821',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959959908','13959959908','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762822',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15860577951','15860577951','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762823',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489749479','13489749479','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500009762824',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905079696','13905079696','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500013957122',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959990747','18959990747','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500013957123',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18905061172','18905061172','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'黑名单','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500013957124',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960392363','13960392363','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500013957125',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505080366','13505080366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500013957126',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959598885','15959598885','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500013957127',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905077165','13905077165','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151426',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959850456','13959850456','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151427',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808521209','13808521209','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151428',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960276710','18960276710','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151429',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160990680','18160990680','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151430',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505058410','13505058410','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151431',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636999066','13636999066','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151432',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506003852','13506003852','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500018151433',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880884178','15880884178','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500043317249',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905969206','13905969206','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500047511553',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959717190','15959717190','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500047511554',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859790099','13859790099','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500047511555',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15392282626','15392282626','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500047511556',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059559536','15059559536','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500047511557',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799533933','13799533933','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500047511558',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15859558706','15859558706','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705858',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880756753','15880756753','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705859',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050852797','18050852797','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705860',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960279966','18960279966','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705861',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506099300','13506099300','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705862',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599943177','13599943177','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705863',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489577234','13489577234','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705864',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505045354','13505045354','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500051705865',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13074996163','13074996163','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500055900162',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808512929','13808512929','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500055900163',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505907299','13505907299','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500055900164',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359992810','15359992810','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500055900165',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375852555','15375852555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500055900166',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599258098','13599258098','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500055900167',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506061065','13506061065','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500055900168',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13655958777','13655958777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500060094465',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159888083','15159888083','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500060094466',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960277878','18960277878','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500060094467',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788860087','13788860087','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500060094468',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13305065027','13305065027','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500060094469',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059857468','15059857468','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500060094470',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599700988','13599700988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500060094471',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905070513','15905070513','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500064288770',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960350305','18960350305','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500085260290',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808509995','13808509995','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500089454593',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18876590588','18876590588','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500089454594',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599204658','13599204658','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500089454595',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959708709','18959708709','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500089454596',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959702582','18959702582','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500093648897',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959857912','13959857912','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500093648898',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506061101','13506061101','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500093648899',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559054956','13559054956','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500093648900',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799503950','13799503950','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500093648901',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799505373','13799505373','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500093648902',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905989550','13905989550','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500093648903',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960457252','13960457252','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500097843201',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13313833575','13313833575','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500097843202',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636955987','13636955987','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500097843203',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18006997198','18006997198','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500097843204',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905900169','15905900169','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500097843205',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905053925','13905053925','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500097843206',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18059981666','18059981666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500097843207',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636910716','13636910716','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500102037505',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18006997269','18006997269','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500102037506',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160992883','18160992883','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500102037507',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359828297','15359828297','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500102037508',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18859982821','18859982821','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500102037509',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600740330','13600740330','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500102037510',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159527567','15159527567','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500102037511',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600753732','13600753732','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500106231810',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600741987','13600741987','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500106231811',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799239819','13799239819','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500106231812',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636993447','13636993447','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500106231813',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559519596','13559519596','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500131397634',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960785369','15960785369','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500131397635',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959758989','18959758989','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500131397636',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13305052886','13305052886','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500131397637',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489552768','13489552768','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500135591937',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959859977','18959859977','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500135591938',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359995155','15359995155','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500135591939',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506088960','13506088960','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500135591940',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13365955003','13365955003','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500135591941',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328881979','13328881979','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500135591942',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960261808','18960261808','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500139786241',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805953239','13805953239','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500139786242',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15160778078','15160778078','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500139786243',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359996089','15359996089','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500139786244',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506940200','13506940200','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500139786245',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18905955577','18905955577','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500139786246',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359552567','15359552567','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500143980545',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506923201','13506923201','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500143980546',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506956398','13506956398','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500143980547',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505901114','13505901114','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500143980548',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805952335','13805952335','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500143980549',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805919635','13805919635','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500143980550',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959758516','13959758516','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500143980551',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505052289','13505052289','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500148174849',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13110702878','13110702878','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500148174850',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506927055','13506927055','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500148174851',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359852008','15359852008','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500148174852',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505998352','13505998352','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500148174853',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805943793','13805943793','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500148174854',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959800299','13959800299','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500148174855',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600788200','13600788200','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500177534977',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905952567','13905952567','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500177534978',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905965513','13905965513','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500177534979',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965688656','18965688656','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500177534980',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959888585','18959888585','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500181729281',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506920007','13506920007','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500181729282',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559086001','13559086001','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500181729283',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850755998','13850755998','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500181729284',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960255250','18960255250','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500181729285',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880884545','15880884545','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500181729286',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13107883773','13107883773','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500181729287',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13313820622','13313820622','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500185923585',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505058979','13505058979','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500185923586',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18900399371','18900399371','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500185923587',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159520572','15159520572','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500185923588',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17305062163','17305062163','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500185923589',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905069011','13905069011','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500185923590',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959842771','13959842771','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500190117890',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959903379','18959903379','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500190117891',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18606039289','18606039289','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500190117892',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505900362','13505900362','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500190117893',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599255860','13599255860','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500190117894',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960382909','18960382909','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500194312194',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506952931','13506952931','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500194312195',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905950151','13905950151','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500194312196',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17305062161','17305062161','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500194312197',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600700811','13600700811','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'黑名单','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500198506498',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13720849168','13720849168','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500198506499',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15106015742','15106015742','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500198506500',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13004839770','13004839770','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500198506501',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965144967','18965144967','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500223672322',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506054929','13506054929','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500223672323',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18750538537','18750538537','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500223672324',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159545118','15159545118','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500227866626',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13636948948','13636948948','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500227866627',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505055289','13505055289','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500227866628',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506067070','13506067070','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500227866629',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799216561','13799216561','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500227866630',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959708586','18959708586','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500227866631',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559550311','13559550311','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500232060929',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359503007','15359503007','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500232060930',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375758116','15375758116','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500232060931',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359995791','15359995791','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500232060932',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808513923','13808513923','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500232060933',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13625956209','13625956209','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500236255234',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506929389','13506929389','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500236255235',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905969285','13905969285','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500236255236',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328882050','13328882050','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500236255237',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159877308','15159877308','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500236255238',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18006990565','18006990565','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449538',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359383703','15359383703','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449539',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','19905069358','19905069358','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449540',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13067098216','13067098216','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449541',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','17706076913','17706076913','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449542',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18905060038','18905060038','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449543',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506945772','13506945772','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449544',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15305095799','15305095799','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500240449545',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489386363','13489386363','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500244643841',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960259998','18960259998','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500244643842',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788851692','13788851692','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500244643843',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13024890689','13024890689','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500265615362',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359556931','15359556931','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500269809666',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959857832','15959857832','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500269809667',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599271106','13599271106','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500269809668',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359856753','15359856753','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500269809669',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13515051598','13515051598','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500269809670',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15305095656','15305095656','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500269809671',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905989969','13905989969','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500269809672',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13515050050','13515050050','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003969',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600750662','13600750662','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'黑名单','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003970',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159877302','15159877302','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003971',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359506696','15359506696','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003972',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505950740','13505950740','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003973',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599752616','13599752616','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003974',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559512692','13559512692','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003975',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328989299','13328989299','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500274003976',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959708233','18959708233','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500278198273',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880767876','15880767876','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500278198274',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13004870872','13004870872','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500278198275',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960204177','13960204177','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500278198276',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905943388','15905943388','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500278198277',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13055614167','13055614167','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500278198278',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808554452','13808554452','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500278198279',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805950788','15805950788','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500282392577',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505900079','13505900079','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500282392578',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15985956817','15985956817','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500282392579',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505930172','13505930172','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500282392580',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505071051','13505071051','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500282392581',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859790769','13859790769','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500282392582',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905051552','13905051552','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500282392583',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805959682','13805959682','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500307558402',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18150509095','18150509095','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500307558403',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18760355986','18760355986','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500307558404',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599277607','13599277607','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500307558405',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600752802','13600752802','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500307558406',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880728815','15880728815','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500311752706',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788856791','13788856791','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500311752707',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15259497102','15259497102','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500311752708',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959776008','13959776008','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500311752709',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788851958','13788851958','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500311752710',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505021299','13505021299','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500311752711',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959889072','15959889072','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500311752712',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599253856','13599253856','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947009',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959701788','18959701788','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947010',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505058414','13505058414','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947011',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15396589712','15396589712','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947012',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559545666','13559545666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947013',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506958265','13506958265','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947014',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959990116','18959990116','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947015',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15960783806','15960783806','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500315947016',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13358585800','13358585800','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141313',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506058981','13506058981','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'黑名单','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141314',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506058761','13506058761','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141315',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13024890678','13024890678','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141316',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850717556','13850717556','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141317',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13515055588','13515055588','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141318',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506950130','13506950130','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141319',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860707887','13860707887','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500320141320',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600737986','13600737986','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500324335617',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375883133','15375883133','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500324335618',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960261000','18960261000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500349501441',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359494082','15359494082','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500353695745',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15106010755','15106010755','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500353695746',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13675970525','13675970525','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500353695747',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15160311312','15160311312','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500353695748',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880766153','15880766153','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500353695749',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959776881','13959776881','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500353695750',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160992885','18160992885','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500353695751',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489356021','13489356021','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890049',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960410458','13960410458','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890050',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600744963','13600744963','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890051',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15396306899','15396306899','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890052',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599729116','13599729116','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890053',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160992699','18160992699','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890054',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860755206','13860755206','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890055',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959753036','13959753036','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500357890056',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559550262','13559550262','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500362084353',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599252676','13599252676','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500362084354',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505005256','13505005256','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500362084355',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13358585309','13358585309','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500362084356',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959851863','13959851863','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500362084357',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960250606','18960250606','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500362084358',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959959366','13959959366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500362084359',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13805945305','13805945305','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500366278657',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506062572','13506062572','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500366278658',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13011864796','13011864796','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500366278659',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505006671','13505006671','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500366278660',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15659229330','15659229330','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500366278661',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959880217','15959880217','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500366278662',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959595156','15959595156','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500366278663',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15805959939','15805959939','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500391444482',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13514021971','13514021971','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500391444483',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359388928','15359388928','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500391444484',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160992889','18160992889','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500391444485',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328898332','13328898332','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500395638785',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506065310','13506065310','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500395638786',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905951126','13905951126','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500395638787',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15392121321','15392121321','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500395638788',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506959039','13506959039','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500395638789',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505951500','13505951500','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500395638790',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059860998','15059860998','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500395638791',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905088710','13905088710','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833090',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959708707','18959708707','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833091',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506904358','13506904358','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833092',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359983002','15359983002','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833093',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160992795','18160992795','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833094',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506044320','13506044320','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833095',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860783988','13860783988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833096',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13860757727','13860757727','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500399833097',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965689732','18965689732','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027393',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13675922787','13675922787','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027394',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965688138','18965688138','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027395',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18965699877','18965699877','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027396',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880929283','15880929283','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027397',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159877306','15159877306','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027398',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15980048101','15980048101','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027399',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15375750282','15375750282','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500404027400',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808505500','13808505500','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500408221697',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960295385','13960295385','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500408221698',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960495947','13960495947','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500408221699',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13123112345','13123112345','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500429193218',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160992867','18160992867','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500433387522',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105087668','18105087668','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500433387523',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105087637','18105087637','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500433387524',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13328552716','13328552716','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500433387525',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600700444','13600700444','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500433387526',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13159071569','13159071569','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500433387527',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105087618','18105087618','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500437581825',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050878629','18050878629','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500437581826',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599251261','13599251261','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500437581827',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105087675','18105087675','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500437581828',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18050878670','18050878670','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500437581829',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808552645','13808552645','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500437581830',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18105087609','18105087609','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500437581831',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905061587','13905061587','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776130',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506923111','13506923111','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776131',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850796626','13850796626','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776132',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599789012','13599789012','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776133',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505054142','13505054142','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776134',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959990126','13959990126','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776135',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880927347','15880927347','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776136',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13305982462','13305982462','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500441776137',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905061605','13905061605','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500445970434',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505026001','13505026001','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500445970435',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959555279','15959555279','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500445970436',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18900399236','18900399236','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500445970437',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13600727110','13600727110','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500445970438',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505021925','13505021925','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500445970439',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960256889','13960256889','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500445970440',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505053585','13505053585','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500450164737',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505952860','13505952860','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500471136258',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13850754503','13850754503','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500471136259',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13515058161','13515058161','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500471136260',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359994648','15359994648','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500475330562',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880727717','15880727717','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500475330563',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18805952030','18805952030','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500475330564',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559088855','13559088855','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500475330565',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960385620','18960385620','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500475330566',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15059521997','15059521997','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500475330567',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13559088110','13559088110','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500479524866',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506953105','13506953105','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500479524867',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905904129','15905904129','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500479524868',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359558988','15359558988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500479524869',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159799935','15159799935','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500479524870',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960256712','13960256712','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500479524871',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18160992361','18160992361','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500479524872',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960261872','13960261872','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719169',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960259102','13960259102','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719170',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799218988','13799218988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719171',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359494363','15359494363','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719172',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13788808024','13788808024','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719173',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18959932299','18959932299','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719174',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13799878811','13799878811','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719175',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808519144','13808519144','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500483719176',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808518477','13808518477','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500487913473',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13338567155','13338567155','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500487913474',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905053259','13905053259','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500487913475',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18150981635','18150981635','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500487913476',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489857561','13489857561','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500487913477',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13959851043','13959851043','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500487913478',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599722097','13599722097','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500517273601',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15359380823','15359380823','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500517273602',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599992870','13599992870','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500517273603',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959592879','15959592879','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500517273604',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18150981608','18150981608','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467905',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599720612','13599720612','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467906',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13859713777','13859713777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467907',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18960353046','18960353046','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467908',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18150981669','18150981669','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467909',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599113307','13599113307','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467910',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13808553926','13808553926','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467911',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13599700582','13599700582','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500521467912',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13905069130','13905069130','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662209',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15159719249','15159719249','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662210',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506953558','13506953558','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662211',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15060909851','15060909851','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662212',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15880737972','15880737972','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662213',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13489292412','13489292412','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662214',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13506069712','13506069712','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662215',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','18905957123','18905957123','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500525662216',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13960305049','13960305049','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500529856514',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15985922899','15985922899','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500529856515',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13505056381','13505056381','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500529856516',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','13004850717','13004850717','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500529856517',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15959999562','15959999562','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274986500529856518',NULL,'1274986498608865282',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200622)','15905979518','15905979518','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-22 16:44:04',NULL,NULL,NULL,'2020-06-22 16:44:04',NULL,NULL,NULL),('1274992856397787137',NULL,'1274992856397787137',2,1,NULL,'15396380625','559976','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 17:09:19',NULL,NULL,NULL),('1274993859515920385',NULL,'1274993859515920385',2,1,NULL,'15396380625','741330','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 17:13:19',NULL,NULL,NULL),('1274994156300677121',NULL,'1274994156300677121',2,1,NULL,'15396380625','687040','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-22',NULL,NULL,NULL,'2020-06-22 17:14:29',NULL,NULL,NULL),('1275223190330720257',NULL,'1275223190330720257',2,1,NULL,'18750536470','822761','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 08:24:35',NULL,NULL,NULL),('1275234882578071553',NULL,'1275234882578071553',2,1,NULL,'13600753747','038358','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 09:11:03',NULL,NULL,NULL),('1275240207997779969',NULL,'1275240207997779969',2,1,NULL,'13905966797','182925','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 09:32:13',NULL,NULL,NULL),('1275259397198626817',NULL,'1275259397198626817',2,1,NULL,'15159875837','441654','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 10:48:28',NULL,NULL,NULL),('1275260690965250050',NULL,'1275260690965250050',2,1,NULL,'15159875837','985380','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 10:53:36',NULL,NULL,NULL),('1275262156618645505',NULL,'1275262156618645505',2,1,NULL,'15959508318','222517','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 10:59:26',NULL,NULL,NULL),('1275265730165653505',NULL,'1275265730165653505',2,1,NULL,'18150596289','676940','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 11:13:38',NULL,NULL,NULL),('1275266017152516098',NULL,'1275266017152516098',2,1,NULL,'18050888080','691612','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 11:14:46',NULL,NULL,NULL),('1275266267678294017',NULL,'1275266267678294017',2,1,NULL,'13788851735','743163','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 11:15:46',NULL,NULL,NULL),('1275266919565410306',NULL,'1275266919565410306',2,1,NULL,'18050880880','556541','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 11:18:21',NULL,NULL,NULL),('1275267223392403458',NULL,'1275267223392403458',2,1,NULL,'18050888080','195202','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 11:19:34',NULL,NULL,NULL),('1275335359042994177',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959940177','13959940177','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359047188482',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15905007782','15905007782','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359051382785',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15960236865','15960236865','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359051382786',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980019','18815980019','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359051382787',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18046311397','18046311397','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359051382788',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13850777672','13850777672','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359051382789',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18960261819','18960261819','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359055577089',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799797017','13799797017','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359059771393',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17612198088','17612198088','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359059771394',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18906998323','18906998323','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359059771395',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13092598830','13092598830','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359059771396',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13178365040','13178365040','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359063965698',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18750918808','18750918808','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359063965699',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15506922830','15506922830','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359063965700',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13055335125','13055335125','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359063965701',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18060480095','18060480095','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359068160002',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059535959','15059535959','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359068160003',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17750718723','17750718723','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359068160004',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959797611','19959797611','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359068160005',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13459034477','13459034477','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359072354305',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13859989821','13859989821','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359072354306',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18876539791','18876539791','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359072354307',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860302368','15860302368','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359072354308',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659737170','18659737170','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359072354309',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18965873113','18965873113','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359072354310',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13805957531','13805957531','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359076548610',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059820805','15059820805','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359076548611',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15359996228','15359996228','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359076548612',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18960261818','18960261818','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359076548613',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980115','18815980115','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359080742914',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15985908601','15985908601','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359118491650',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15505959657','15505959657','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359122685954',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980191','18815980191','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359122685955',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15659700269','15659700269','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359122685956',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980135','18815980135','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'未知错误','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359122685957',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18606098653','18606098653','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359122685958',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18559799970','18559799970','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359126880258',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15202861980','15202861980','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359126880259',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15695952861','15695952861','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359126880260',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959593185','15959593185','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359126880261',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19906055394','19906055394','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359126880262',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13558689686','13558689686','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359131074561',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980186','18815980186','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359131074562',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959992008','15959992008','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359131074563',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13338562717','13338562717','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359131074564',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18618285267','18618285267','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359131074565',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980215','18815980215','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359131074566',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905066509','18905066509','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359135268865',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980032','18815980032','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359135268866',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18759557515','18759557515','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359135268867',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13075849694','13075849694','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359135268868',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18200596289','18200596289','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359135268869',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599961726','13599961726','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359135268870',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15859577777','15859577777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359139463169',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18649718338','18649718338','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359139463170',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959287303','19959287303','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359139463171',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13859709271','13859709271','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359139463172',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18050918220','18050918220','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359139463173',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18767432301','18767432301','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359139463174',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18805929360','18805929360','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359143657473',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18649713923','18649713923','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359173017601',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505951467','13505951467','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359177211905',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13906091302','13906091302','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359177211906',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13950092022','13950092022','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359181406210',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905079898','18905079898','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359181406211',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15359508512','15359508512','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359181406212',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15859505750','15859505750','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600514',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13808510666','13808510666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600515',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505097888','13505097888','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600516',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905985743','13905985743','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600517',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959717283','13959717283','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600518',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13400804466','13400804466','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'未知错误','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600519',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18059290969','18059290969','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600520',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15859214681','15859214681','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600521',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17720628659','17720628659','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600522',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18222285957','18222285957','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600523',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260843017','15260843017','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600524',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15659058225','15659058225','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600525',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18050878555','18050878555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359185600526',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505051522','13505051522','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377730',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959797366','19959797366','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377731',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15606938785','15606938785','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377732',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15880926263','15880926263','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377733',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18359262260','18359262260','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377734',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15359590811','15359590811','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377735',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13559597000','13559597000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377736',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13600704238','13600704238','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359202377737',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13506952112','13506952112','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359206572034',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13636957150','13636957150','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359206572035',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13600703496','13600703496','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359206572036',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13808519798','13808519798','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359235932161',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059870039','15059870039','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359240126466',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505985911','13505985911','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359240126467',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959886068','15959886068','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359240126468',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13459557105','13459557105','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359244320770',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18050962871','18050962871','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359244320771',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13675918895','13675918895','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359244320772',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599519873','13599519873','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359244320773',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059512937','15059512937','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359244320774',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18559550805','18559550805','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359248515074',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18859799951','18859799951','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359248515075',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980162','18815980162','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359248515076',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13808543336','13808543336','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359248515077',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18950086017','18950086017','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359248515078',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980668','18815980668','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709378',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17359317387','17359317387','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709379',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13110795211','13110795211','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709380',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659748259','18659748259','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709381',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980192','18815980192','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709382',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13215985873','13215985873','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709383',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980802','18815980802','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709384',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13030988380','13030988380','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709385',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505050692','13505050692','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709386',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18959853655','18959853655','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709387',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980696','18815980696','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709388',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18559556165','18559556165','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709389',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815981631','18815981631','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709390',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980731','18815980731','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709391',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980218','18815980218','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709392',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15659090507','15659090507','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359252709393',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815981650','18815981650','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'未知错误','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359298846721',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18559557186','18559557186','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359303041025',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959797830','19959797830','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359303041026',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17704655519','17704655519','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359303041027',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18959996257','18959996257','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359303041028',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980608','18815980608','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235330',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980780','18815980780','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235331',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959699530','19959699530','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235332',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980820','18815980820','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235333',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18926823263','18926823263','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235334',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980167','18815980167','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235335',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815981311','18815981311','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235336',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815981639','18815981639','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359307235337',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980638','18815980638','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359315623938',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18695680873','18695680873','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359315623939',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15880885121','15880885121','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359315623940',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15505351667','15505351667','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359315623941',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15505959675','15505959675','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359315623942',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980230','18815980230','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359315623943',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959910000','13959910000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012545',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13805956558','13805956558','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012546',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980633','18815980633','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012547',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980155','18815980155','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012548',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15505955206','15505955206','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012549',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15666579249','15666579249','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012550',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13159019069','13159019069','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012551',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18850585864','18850585864','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012552',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15375736116','15375736116','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359324012553',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13805900098','13805900098','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359328206850',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18060977772','18060977772','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359328206851',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15659510388','15659510388','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359353372673',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15929932359','15929932359','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359357566978',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15806030380','15806030380','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359357566979',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13215952116','13215952116','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359357566980',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959880757','15959880757','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359361761281',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18608910987','18608910987','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359361761282',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13600931913','13600931913','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359361761283',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505996776','13505996776','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359361761284',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13358592501','13358592501','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359361761285',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18250617775','18250617775','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359361761286',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505986964','13505986964','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359361761287',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260782666','15260782666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359365955586',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260803666','15260803666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359365955587',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260785666','15260785666','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359365955588',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13328509988','13328509988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359365955589',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260807555','15260807555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359365955590',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659005089','18659005089','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359365955591',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799552053','13799552053','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359370149890',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13055500305','13055500305','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359370149891',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15759817233','15759817233','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359370149892',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599295708','13599295708','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359374344193',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980631','18815980631','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359374344194',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599717008','13599717008','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359374344195',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17689682850','17689682850','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359374344196',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815981850','18815981850','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359378538497',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980687','18815980687','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359378538498',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260704530','15260704530','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359378538499',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905055213','13905055213','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359378538500',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15159836000','15159836000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359378538501',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599127767','13599127767','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359382732802',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13559591215','13559591215','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359412092930',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059755771','15059755771','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359412092931',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18567651331','18567651331','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359416287233',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15827436094','15827436094','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359416287234',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13666988888','13666988888','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359416287235',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15259571333','15259571333','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359416287236',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15605959006','15605959006','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359416287237',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15980056221','15980056221','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359420481538',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13506066359','13506066359','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359420481539',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13305972917','13305972917','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359420481540',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13600738975','13600738975','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359420481541',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13950920100','13950920100','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359449841666',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13105079935','13105079935','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359449841667',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18859932277','18859932277','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359449841668',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13636963633','13636963633','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359449841669',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13626072564','13626072564','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359454035970',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15060806451','15060806451','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359454035971',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15005936026','15005936026','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359454035972',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13055667605','13055667605','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359454035973',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13606021816','13606021816','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359454035974',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13600757303','13600757303','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359454035975',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659003000','18659003000','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359458230274',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13960381057','13960381057','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359458230275',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659066928','18659066928','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359458230276',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15080318157','15080318157','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359458230277',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17755092627','17755092627','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359458230278',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15980060559','15980060559','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359458230279',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18359714502','18359714502','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359462424577',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15985918296','15985918296','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359462424578',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15141327771','15141327771','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359462424579',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13906933286','13906933286','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359495979009',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13906096567','13906096567','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359495979010',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13506941213','13506941213','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359500173314',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959237668','13959237668','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359500173315',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13316225195','13316225195','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359500173316',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13559369710','13559369710','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359500173317',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15259546913','15259546913','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359500173318',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13178210216','13178210216','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359504367618',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15891104580','15891104580','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359504367619',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18859464970','18859464970','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359504367620',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13242884288','13242884288','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359504367621',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959712401','13959712401','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359504367622',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799855086','13799855086','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359504367623',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13489312968','13489312968','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359508561921',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13067166871','13067166871','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359508561922',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17683234600','17683234600','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359508561923',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260838513','15260838513','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359508561924',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18959997270','18959997270','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359508561925',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13459246092','13459246092','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359508561926',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13407735197','13407735197','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359508561927',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15396635619','15396635619','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359512756225',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905076587','18905076587','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359512756226',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13774876626','13774876626','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359512756227',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17706067083','17706067083','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359512756228',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13144828970','13144828970','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359512756229',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860393718','15860393718','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359512756230',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905088009','18905088009','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359516950529',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18052150317','18052150317','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359516950530',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13960259639','13960259639','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359516950531',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13649283497','13649283497','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359516950532',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15620636649','15620636649','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359546310658',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905060268','18905060268','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359546310659',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959946911','13959946911','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359550504961',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860902967','15860902967','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359558893570',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15905079361','15905079361','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359558893571',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18698372705','18698372705','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359558893572',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18050869127','18050869127','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359558893573',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13816975274','13816975274','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359558893574',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13960257652','13960257652','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359563087873',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13425480722','13425480722','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'常见原因是：关机，停机，不在服务区；在少数情况下，号码正常通信，是由于地区屏蔽导致。','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359563087874',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17512098847','17512098847','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359563087875',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799521561','13799521561','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359563087876',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15559162475','15559162475','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359563087877',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13395096999','13395096999','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359563087878',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13328963385','13328963385','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359563087879',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18959858506','18959858506','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359567282177',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18250155553','18250155553','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359567282178',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959990618','13959990618','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359567282179',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959579818','15959579818','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359567282180',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13808550727','13808550727','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359567282181',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18695660966','18695660966','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359567282182',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13779982480','13779982480','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359571476482',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18750537614','18750537614','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359571476483',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860767791','15860767791','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359571476484',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13110515615','13110515615','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359571476485',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18259057239','18259057239','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359571476486',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959551103','15959551103','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359571476487',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13050690718','13050690718','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'信息长度错','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359571476488',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18065605512','18065605512','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359575670786',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659714177','18659714177','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359575670787',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18305948230','18305948230','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359605030914',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13788805485','13788805485','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359609225217',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15159528106','15159528106','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359609225218',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18250798648','18250798648','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'黑名单','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359609225219',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15005052329','15005052329','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359609225220',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13023884842','13023884842','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359613419521',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15711572870','15711572870','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359613419522',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18050781324','18050781324','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359613419523',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15880481571','15880481571','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359613419524',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18060480281','18060480281','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1275335359613419525',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13636950764','13636950764','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359613419526',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18060101650','18060101650','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359613419527',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959798235','19959798235','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359617613825',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905910054','18905910054','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359617613826',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18050404507','18050404507','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359617613827',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15659435463','15659435463','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359617613828',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17705074232','17705074232','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359617613829',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17750103317','17750103317','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359621808130',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13808552645','13808552645','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359621808131',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13906999355','13906999355','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359621808132',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905085569','13905085569','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359621808133',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15880977738','15880977738','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359626002434',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15710646360','15710646360','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359626002435',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815985602','18815985602','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359626002436',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17705061101','17705061101','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359626002437',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959813350','19959813350','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359626002438',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15960795588','15960795588','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359630196738',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860356356','15860356356','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359630196739',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18603006276','18603006276','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359630196740',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18059040389','18059040389','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'黑名单','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359630196741',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18120806139','18120806139','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359663751169',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15710613393','15710613393','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359667945473',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980039','18815980039','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359667945474',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980125','18815980125','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359667945475',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980078','18815980078','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359672139778',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15505656188','15505656188','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359672139779',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13901318357','13901318357','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359672139780',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13386880667','13386880667','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359672139781',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959709699','19959709699','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359676334081',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980832','18815980832','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359676334082',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959797500','19959797500','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359676334083',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980679','18815980679','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359680528386',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13788846820','13788846820','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359680528387',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959989905','13959989905','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359680528388',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13805945051','13805945051','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359680528389',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18050888018','18050888018','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359684722689',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15905909283','15905909283','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359684722690',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599162155','13599162155','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359684722691',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959592127','15959592127','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359684722692',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980056','18815980056','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359688916994',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980028','18815980028','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359688916995',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13506969021','13506969021','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359688916996',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18750944533','18750944533','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359688916997',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18818217809','18818217809','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359693111297',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15905045630','15905045630','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359693111298',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18259228704','18259228704','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359693111299',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17758798131','17758798131','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359693111300',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959699073','19959699073','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359693111301',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18259598970','18259598970','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359697305602',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959799928','19959799928','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359697305603',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13615926622','13615926622','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359722471426',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18965699955','18965699955','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359722471427',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799752976','13799752976','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359722471428',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17758766697','17758766697','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',1,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860034',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15157528576','15157528576','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860035',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15191815436','15191815436','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860036',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18701704136','18701704136','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860037',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15060823577','15060823577','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860038',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15259519391','15259519391','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860039',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13512216307','13512216307','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860040',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18539456470','18539456470','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860041',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15623564761','15623564761','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860042',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959758665','13959758665','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359730860043',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599751999','13599751999','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359735054338',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18950026794','18950026794','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359735054339',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905061587','18905061587','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359735054340',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18159256051','18159256051','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359735054341',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13587756546','13587756546','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'移动停机或关机','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359735054342',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799591130','13799591130','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359735054343',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659003978','18659003978','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359735054344',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18105082610','18105082610','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248641',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15389303652','15389303652','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248642',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15191815139','15191815139','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248643',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15191845928','15191845928','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248644',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15202427957','15202427957','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248645',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15029279845','15029279845','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248646',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17689494919','17689494919','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248647',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15691846289','15691846289','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248648',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18633637251','18633637251','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359739248649',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860395678','15860395678','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359743442946',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13805946193','13805946193','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359776997378',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13805941850','13805941850','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359781191681',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860328381','15860328381','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359781191682',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905971497','13905971497','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359781191683',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15979017673','15979017673','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359781191684',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659719331','18659719331','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359781191685',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059850519','15059850519','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359785385986',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17629088209','17629088209','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359785385987',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15029236362','15029236362','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359785385988',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15805955751','15805955751','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359785385989',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959848541','19959848541','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359785385990',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18559472664','18559472664','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359785385991',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13484917236','13484917236','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359785385992',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15559110466','15559110466','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359789580290',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18392859639','18392859639','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359789580291',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18829340457','18829340457','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'常见原因是：关机，停机，不在服务区；在少数情况下，号码正常通信，是由于地区屏蔽导致。','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359789580292',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13055657231','13055657231','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359789580293',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15029278847','15029278847','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359789580294',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18250178387','18250178387','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359789580295',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18750942279','18750942279','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359789580296',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13337211223','13337211223','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359793774594',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260708136','15260708136','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359793774595',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18859799829','18859799829','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359793774596',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505906457','13505906457','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359793774597',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18316739194','18316739194','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359793774598',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15821998683','15821998683','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359797968898',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905958730','13905958730','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359797968899',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15029140185','15029140185','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359797968900',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17350011170','17350011170','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359797968901',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18065558100','18065558100','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359802163201',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959797828','19959797828','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359835717634',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799966695','13799966695','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359839911938',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059551567','15059551567','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359844106242',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13774825517','13774825517','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359844106243',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15159739903','15159739903','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359844106244',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599279399','13599279399','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359844106245',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18960357668','18960357668','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359844106246',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15805097777','15805097777','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359844106247',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959841155','13959841155','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359844106248',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13959955769','13959955769','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359848300546',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980030','18815980030','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359848300547',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980027','18815980027','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359848300548',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959993866','15959993866','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359848300549',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905957105','13905957105','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359848300550',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905079763','13905079763','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359848300551',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18650100145','18650100145','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359852494849',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18750561717','18750561717','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359852494850',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15505957052','15505957052','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359852494851',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980190','18815980190','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359852494852',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15655116706','15655116706','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359852494853',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13053080336','13053080336','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359852494854',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13788851759','13788851759','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359852494855',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799898116','13799898116','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359856689154',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13328979519','13328979519','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359856689155',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15980456333','15980456333','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359856689156',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13659192458','13659192458','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359856689157',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','16659005526','16659005526','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359856689158',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18740431050','18740431050','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359856689159',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505056755','13505056755','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359856689160',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13906998897','13906998897','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359860883457',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18859596380','18859596380','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359886049282',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13805953864','13805953864','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359886049283',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18559555307','18559555307','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359890243585',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980131','18815980131','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359890243586',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15106036557','15106036557','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359890243587',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659822922','18659822922','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359890243588',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799489750','13799489750','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359890243589',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980061','18815980061','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359890243590',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19905061070','19905061070','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359894437889',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13615922291','13615922291','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359894437890',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18953278508','18953278508','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359894437891',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18905959787','18905959787','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359894437892',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15306089555','15306089555','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359894437893',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18605958880','18605958880','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359894437894',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15985959061','15985959061','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359894437895',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860901713','15860901713','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359898632193',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505058832','13505058832','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359898632194',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13027331257','13027331257','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359898632195',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13072350035','13072350035','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359898632196',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599949096','13599949096','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359898632197',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18960279877','18960279877','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359898632198',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19905062656','19905062656','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359898632199',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18606994823','18606994823','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359902826497',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15059860983','15059860983','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359902826498',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13215951986','13215951986','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'关机','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359902826499',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13255946809','13255946809','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359902826500',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','19959699057','19959699057','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359902826501',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18592020579','18592020579','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359902826502',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15106019502','15106019502','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359902826503',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13788869420','13788869420','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359907020801',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15960753968','15960753968','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359927992321',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18674020219','18674020219','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359932186625',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13799866661','13799866661','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359932186626',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15860688762','15860688762','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'空号','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359932186627',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18106980703','18106980703','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359932186628',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15859813817','15859813817','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359936380929',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18059983988','18059983988','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359936380930',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15260875883','15260875883','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359936380931',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13599109151','13599109151','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359936380932',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13960250701','13960250701','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359936380933',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18876272213','18876272213','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359936380934',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18292635234','18292635234','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359936380935',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15759590781','15759590781','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359940575234',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13506969315','13506969315','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359940575235',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15905057579','15905057579','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359940575236',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13656038332','13656038332','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359940575237',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13501115138','13501115138','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359940575238',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13505959338','13505959338','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359940575239',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18250298076','18250298076','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359944769537',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18150591518','18150591518','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359944769538',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959213985','15959213985','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359944769539',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17750823916','17750823916','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359944769540',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15606078067','15606078067','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359944769541',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15280425542','15280425542','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359944769542',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18009257146','18009257146','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359948963841',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18805927013','18805927013','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359948963842',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13648073455','13648073455','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359948963843',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15959208753','15959208753','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359948963844',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13325253201','13325253201','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359948963845',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13905985809','13905985809','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359948963846',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','17750825396','17750825396','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359978323969',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18759922187','18759922187','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359978323970',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13860750864','13860750864','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359982518273',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','15980000372','15980000372','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359982518274',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','13410024480','13410024480','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359982518275',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980195','18815980195','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359982518276',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659590936','18659590936','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359982518277',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18815980178','18815980178','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',2,'未知错误','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275335359982518278',NULL,'1275335358619369474',2,2,'批量发送(“人才港湾”APP服务已升级的通知20200623)','18659598305','18659598305','【晋江市人才服务平台】通知：近期“人才港湾”APP服务已升级，各泉州市高层次人才只需出示APP生成的二维码，便可一码享受公交优惠(含晋江)、国有A级旅游景区、体检等惠才政策。请各高层次人才及时登陆App查看，若无法登录的，编辑本人姓名+身份证+电话号码发至jjrc85661234@163.com邮箱。',3,'短信发送成功','2020-06-23 15:50:18',NULL,NULL,NULL,'2020-06-23 15:50:18',NULL,NULL,NULL),('1275339446182526977',NULL,'1275339446182526977',2,1,NULL,'18259555290','534969','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 16:06:33',NULL,NULL,NULL),('1275341159899643906',NULL,'1275341159899643906',2,1,NULL,'18606984919','388302','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 16:13:21',NULL,NULL,NULL),('1275343432964947970',NULL,'1275343432964947970',2,1,NULL,'15160326656','896563','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 16:22:23',NULL,NULL,NULL),('1275345156479959041',NULL,'1275345156479959041',2,1,NULL,'15160326656','052577','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 16:29:14',NULL,NULL,NULL),('1275354011091910658','1274912838720167938','1275354011091910658',2,2,'晋江市梅岭索风鞋业商行','15392271725','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:04:25',NULL,NULL,NULL),('1275357992077803522','1275223626664165377','1275357992077803522',2,2,'福建爱乡亲食品股份有限公司','18750536470','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:20:14',NULL,NULL,NULL),('1275359107078995969',NULL,'1275359107078995969',2,1,NULL,'15905058965','815381','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:24:40',NULL,NULL,NULL),('1275360382680088578','1275235140389355521','1275360382680088578',2,2,'元丰(泉州)纺织有限公司','13600753747','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:29:44',NULL,NULL,NULL),('1275361147096186881','1275240508809068545','1275361147096186881',2,2,'福建省百亩洋农业科技有限公司','13905966797','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:32:47',NULL,NULL,NULL),('1275363028581269505','1275260777149808641','1275363028581269505',2,2,'晋江海纳机械有限公司','15159875837','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:40:15',NULL,NULL,NULL),('1275363985658527746','1275343906086633473','1275363985658527746',2,2,'晋江市安海镇邱名耀雕刻工艺品加工坊','15160326656','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:44:03',NULL,NULL,NULL),('1275366165622865922','1275343906086633473','1275366165622865922',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:52:43',NULL,NULL,NULL),('1275367867574960129',NULL,'1275367867574960129',2,1,NULL,'15160326656','088944','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 17:59:29',NULL,NULL,NULL),('1275388075064737794',NULL,'1275388075064737794',2,1,NULL,'15959566799','183751','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-23',NULL,NULL,NULL,'2020-06-23 19:19:47',NULL,NULL,NULL),('1275590208053624834','1274912838720167938','1275590208053624834',2,2,'晋江市梅岭索风鞋业商行','15392271725','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 08:42:59',NULL,NULL,NULL),('1275590394544963586','1211453814360555522','1275590394544963586',2,2,'伟志股份公司','15859813817','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 08:43:44',NULL,NULL,NULL),('1275590553823657986','1275240508809068545','1275590553823657986',2,2,'福建省百亩洋农业科技有限公司','13905966797','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 08:44:22',NULL,NULL,NULL),('1275590913044824065','1275223626664165377','1275590913044824065',2,2,'福建爱乡亲食品股份有限公司','18750536470','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 08:45:47',NULL,NULL,NULL),('1275592334427340801',NULL,'1275592334427340801',2,1,NULL,'15159875837','736505','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 08:51:26',NULL,NULL,NULL),('1275595353495748609','1275360115897188354','1275595353495748609',2,2,'晋江市图书馆','15905058965','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 09:03:26',NULL,NULL,NULL),('1275595948193529858','1275260777149808641','1275595948193529858',2,2,'晋江海纳机械有限公司','15159875837','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 09:05:48',NULL,NULL,NULL),('1275620923222835201',NULL,'1275620923222835201',2,1,NULL,'18059995763','039873','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 10:45:02',NULL,NULL,NULL),('1275631703213260801',NULL,'1275631703213260801',2,1,NULL,'15059788121','143638','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 11:27:52',NULL,NULL,NULL),('1275692803283795970','1275360115897188354','1275692803283795970',2,2,'晋江市图书馆','15905058965','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 15:30:40',NULL,NULL,NULL),('1275753232630595586',NULL,'1275753232630595586',2,1,NULL,'18859973216','111298','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-24',NULL,NULL,NULL,'2020-06-24 19:30:47',NULL,NULL,NULL),('1276351833710837761',NULL,'1276351833710837761',2,1,NULL,'15905975168','845190','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-26',NULL,NULL,NULL,'2020-06-26 11:09:25',NULL,NULL,NULL),('1276352017572347906',NULL,'1276352017572347906',2,1,NULL,'15905975168','880862','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-26',NULL,NULL,NULL,'2020-06-26 11:10:09',NULL,NULL,NULL),('1277053354438082562','1275632103135952897','1277053354438082562',2,2,'福建省信芯长盈科技有限公司','15059788121','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 09:37:00',NULL,NULL,NULL),('1277053472692289538',NULL,'1277053472692289538',2,1,NULL,'13805919195','967274','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 09:37:29',NULL,NULL,NULL),('1277069581722107906',NULL,'1277069581722107906',2,1,NULL,'15260372095','242946','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 10:41:29',NULL,NULL,NULL),('1277071268088168449','1275235140389355521','1277071268088168449',2,2,'元丰(泉州)纺织有限公司','13600753747','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 10:48:11',NULL,NULL,NULL),('1277072673356169217','1277053658302824449','1277072673356169217',2,2,'福建省尚航建设发展有限公司','13805919195','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 10:53:46',NULL,NULL,NULL),('1277137503626772481',NULL,'1277137503626772481',2,1,NULL,'18859529900','843535','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 15:11:23',NULL,NULL,NULL),('1277139105293058049',NULL,'1277139105293058049',2,1,NULL,'18859529900','126843','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 15:17:45',NULL,NULL,NULL),('1277167573380677633',NULL,'1277167573380677633',2,1,NULL,'15059520255','524257','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 17:10:52',NULL,NULL,NULL),('1277173789859299330','1277168809672753154','1277173789859299330',2,2,'福建省霞浦县江海水电工程建设有限公司晋江分公司','15059520255','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-28',NULL,NULL,NULL,'2020-06-28 17:35:34',NULL,NULL,NULL),('1277408682547658753',NULL,'1277408682547658753',2,1,NULL,'18859529900','039395','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-29',NULL,NULL,NULL,'2020-06-29 09:08:57',NULL,NULL,NULL),('1277409383986282498',NULL,'1277409383986282498',2,1,NULL,'18859529900','270865','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-29',NULL,NULL,NULL,'2020-06-29 09:11:44',NULL,NULL,NULL),('1277412857171984385',NULL,'1277412857171984385',2,1,NULL,'18859529900','655695','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-29',NULL,NULL,NULL,'2020-06-29 09:25:32',NULL,NULL,NULL),('1277431344783212545',NULL,'1277431344783212545',2,1,NULL,'15959529925','905553','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-29',NULL,NULL,NULL,'2020-06-29 10:39:00',NULL,NULL,NULL),('1277434147601694721',NULL,'1277434147601694721',2,1,NULL,'15959529925','279440','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-29',NULL,NULL,NULL,'2020-06-29 10:50:09',NULL,NULL,NULL),('1277527722024800258','1275621554885017601','1277527722024800258',2,2,'晋江市卫生健康局','18059995763','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-06-29',NULL,NULL,NULL,'2020-06-29 17:01:58',NULL,NULL,NULL),('1277791414071103490','1275621554885017601','1277791414071103490',2,2,'晋江市卫生健康局','18059995763','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-06-30',NULL,NULL,NULL,'2020-06-30 10:29:47',NULL,NULL,NULL),('1277909576007585793',NULL,'1277909576007585793',2,1,NULL,'15985992783','028200','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-06-30',NULL,NULL,NULL,'2020-06-30 18:19:19',NULL,NULL,NULL),('1278143598285590529',NULL,'1278143598285590529',2,1,NULL,'15905058965','241629','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-01',NULL,NULL,NULL,'2020-07-01 09:49:15',NULL,NULL,NULL),('1278227182761578497','1275002982185889793','1278227182761578497',2,2,'泉州星城纸业有限公司','15959856777','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-01',NULL,NULL,NULL,'2020-07-01 15:21:23',NULL,NULL,NULL),('1278227343374061569','1277212346409861122','1278227343374061569',2,2,'泉州星城纸业有限公司','15959856777','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-01',NULL,NULL,NULL,'2020-07-01 15:22:01',NULL,NULL,NULL),('1278488754360717313','1277910183363776514','1278488754360717313',2,2,'泉州市顺时针电子商务有限公司','15985992783','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-02',NULL,NULL,NULL,'2020-07-02 08:40:46',NULL,NULL,NULL),('1278495547967180802',NULL,'1278495547967180802',2,1,NULL,'13959102760','474529','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-02',NULL,NULL,NULL,'2020-07-02 09:07:46',NULL,NULL,NULL),('1278532425445576705',NULL,'1278532425445576705',2,1,NULL,'13400808814','759074','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-02',NULL,NULL,NULL,'2020-07-02 11:34:18',NULL,NULL,NULL),('1278534174017359873',NULL,'1278534174017359873',2,1,NULL,'18150596289','393645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-02',NULL,NULL,NULL,'2020-07-02 11:41:15',NULL,NULL,NULL),('1278588378928943106',NULL,'1278588378928943106',2,1,NULL,'18150596289','395906','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-02',NULL,NULL,NULL,'2020-07-02 15:16:39',NULL,NULL,NULL),('1278597538076725250',NULL,'1278597538076725250',2,1,NULL,'18259555290','364530','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-02',NULL,NULL,NULL,'2020-07-02 15:53:02',NULL,NULL,NULL),('1278846039578677250','1277413340309667842','1278846039578677250',2,2,'晋江市东石镇人民政府','18859529900','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-03',NULL,NULL,NULL,'2020-07-03 08:20:30',NULL,NULL,NULL),('1278899659842031617',NULL,'1278899659842031617',2,1,NULL,'13599121782','614705','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-03',NULL,NULL,NULL,'2020-07-03 11:53:34',NULL,NULL,NULL),('1278964249095344129','1278900368952037378','1278964249095344129',2,2,'晋江市东石中心卫生院','13599121782','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-03',NULL,NULL,NULL,'2020-07-03 16:10:13',NULL,NULL,NULL),('1278972626630381569','1277434198482796545','1278972626630381569',2,2,'晋江爱尔眼科医院有限公司','15959529925','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-03',NULL,NULL,NULL,'2020-07-03 16:43:31',NULL,NULL,NULL),('1278978088872480770',NULL,'1278978088872480770',2,1,NULL,'15080005305','697431','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-03',NULL,NULL,NULL,'2020-07-03 17:05:13',NULL,NULL,NULL),('1279334074313379841',NULL,'1279334074313379841',2,1,NULL,'15880750160','222529','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-04',NULL,NULL,NULL,'2020-07-04 16:39:46',NULL,NULL,NULL),('1279947788062330881','1279334502522458113','1279947788062330881',2,2,'晋江市德顺陶瓷建材有限公司','15880750160','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-06',NULL,NULL,NULL,'2020-07-06 09:18:27',NULL,NULL,NULL),('1279952036435103745','1275339775733186562','1279952036435103745',2,2,'晋江市爱群社工服务中心','18259555290','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-06',NULL,NULL,NULL,'2020-07-06 09:35:20',NULL,NULL,NULL),('1279952200612745217','1277069643340627970','1279952200612745217',2,2,'晋江市益心社工服务中心','15260372095','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-06',NULL,NULL,NULL,'2020-07-06 09:35:59',NULL,NULL,NULL),('1280059923975147521',NULL,'1280059923975147521',2,1,NULL,'15557603640','855381','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-06',NULL,NULL,NULL,'2020-07-06 16:44:02',NULL,NULL,NULL),('1280071132241760257','1275232669650698242','1280071132241760257',2,2,'晋江凯燕新材料科技有限公司','13255957226','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-06',NULL,NULL,NULL,'2020-07-06 17:28:35',NULL,NULL,NULL),('1280073180316209154','1274962714078224385','1280073180316209154',2,2,'福建泉成机械有限公司','15392286115','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-06',NULL,NULL,NULL,'2020-07-06 17:36:43',NULL,NULL,NULL),('1280315479516286978','1275232669650698242','1280315479516286978',2,2,'晋江凯燕新材料科技有限公司','13255957226','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 09:39:32',NULL,NULL,NULL),('1280319586805256194',NULL,'1280319586805256194',2,1,NULL,'15960586822','312242','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 09:55:51',NULL,NULL,NULL),('1280325244577419266','1280060097522864129','1280325244577419266',2,2,'泉州浩燕商贸有限公司','15557603640','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 10:18:20',NULL,NULL,NULL),('1280424628430344194',NULL,'1280424628430344194',2,1,NULL,'13960208800','096777','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 16:53:15',NULL,NULL,NULL),('1280426660738404353','1280319682515079169','1280426660738404353',2,2,'晋江市集成电路科技投资有限责任公司','15960586822','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 17:01:19',NULL,NULL,NULL),('1280427064440164353','1278978156241391618','1280427064440164353',2,2,'晋江新丝路教育科技有限公司','15080005305','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 17:02:56',NULL,NULL,NULL),('1280427650850000898','1231793752096501762','1280427650850000898',2,2,'晋江国家体育城市股份有限公司','13505986964','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 17:05:15',NULL,NULL,NULL),('1280432364773740546','1278496729536172034','1280432364773740546',2,2,'中国邮政储蓄银行股份有限公司晋江市支行','13959102760','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 17:23:59',NULL,NULL,NULL),('1280434444078977026','1278496729536172034','1280434444078977026',2,2,'中国邮政储蓄银行股份有限公司晋江市支行','13959102760','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 17:32:15',NULL,NULL,NULL),('1280435162282233858','1280424993095716866','1280435162282233858',2,2,'晋江市掌中木偶艺术保护传承中心','13960208800','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-07',NULL,NULL,NULL,'2020-07-07 17:35:06',NULL,NULL,NULL),('1281063548985839618',NULL,'1281063548985839618',2,1,NULL,'13400808814','253230','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 11:12:05',NULL,NULL,NULL),('1281138601102446593','1281051746243743746','1281138601102446593',2,2,'福建兴翼机械有限公司','18606981162','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:10:19',NULL,NULL,NULL),('1281140798401843201','1277062744067063810','1281140798401843201',2,2,'晋江市医院','18350528526','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:19:03',NULL,NULL,NULL),('1281141560909533185','1276708006897172481','1281141560909533185',2,2,'福建凤竹纺织科技股份有限公司','13506060342','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:22:05',NULL,NULL,NULL),('1281142180483731457','1276704144597499906','1281142180483731457',2,2,'晋江元素设计有限公司','13030981560','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:24:32',NULL,NULL,NULL),('1281143450338627585','1275345182316871681','1281143450338627585',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:29:35',NULL,NULL,NULL),('1281144328814628865','1274983077512224770','1281144328814628865',2,2,'晋江市天泽农业开发有限公司','18859781366','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:33:05',NULL,NULL,NULL),('1281145793151012866','1275251212274417665','1281145793151012866',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:38:54',NULL,NULL,NULL),('1281146965500923905','1274954139494785025','1281146965500923905',2,2,'福建凤竹纺织科技股份有限公司','13506060342','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:43:33',NULL,NULL,NULL),('1281148084763529217','1275224880488431617','1281148084763529217',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:48:00',NULL,NULL,NULL),('1281148558573080578','1275224421430247425','1281148558573080578',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:49:53',NULL,NULL,NULL),('1281149088733106178','1275224077795115010','1281149088733106178',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:52:00',NULL,NULL,NULL),('1281149476441985025','1275222683646214146','1281149476441985025',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:53:32',NULL,NULL,NULL),('1281149870056443905','1275222053175214082','1281149870056443905',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:55:06',NULL,NULL,NULL),('1281150353252847617','1275053907197870082','1281150353252847617',2,2,'晋江易库物联网科技有限公司','18959210622','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 16:57:01',NULL,NULL,NULL),('1281159206384209922','1274983077512224770','1281159206384209922',2,2,'晋江市天泽农业开发有限公司','18859781366','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 17:32:12',NULL,NULL,NULL),('1281199472713437185',NULL,'1281199472713437185',2,1,NULL,'15159878799','401149','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-09',NULL,NULL,NULL,'2020-07-09 20:12:12',NULL,NULL,NULL),('1281405265001852930',NULL,'1281405265001852930',2,1,NULL,'13599781990','100089','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 09:49:57',NULL,NULL,NULL),('1281406074976481281',NULL,'1281406074976481281',2,1,NULL,'13599781990','263567','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 09:53:10',NULL,NULL,NULL),('1281406794110873601',NULL,'1281406794110873601',2,1,NULL,'13489512117','614636','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 09:56:01',NULL,NULL,NULL),('1281413684043722754',NULL,'1281413684043722754',2,1,NULL,'13506060342','142553','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 10:23:24',NULL,NULL,NULL),('1281414124806352897',NULL,'1281414124806352897',2,1,NULL,'15759500600','693418','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 10:25:09',NULL,NULL,NULL),('1281417068410843138',NULL,'1281417068410843138',2,1,NULL,'15980025829','341491','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 10:36:51',NULL,NULL,NULL),('1281418891699957761',NULL,'1281418891699957761',2,1,NULL,'18959858592','621289','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 10:44:06',NULL,NULL,NULL),('1281436781962604545',NULL,'1281436781962604545',2,1,NULL,'13559591215','651591','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 11:55:11',NULL,NULL,NULL),('1281457082918252545',NULL,'1281457082918252545',2,1,NULL,'18750652188','431595','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 13:15:51',NULL,NULL,NULL),('1281521548972281857',NULL,'1281521548364107778',2,2,'批量发送(子女入学相关通知20200710)','13626066721','13626066721','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:01',NULL,NULL,NULL,'2020-07-10 17:32:01',NULL,NULL,NULL),('1281521548980670466',NULL,'1281521548364107778',2,2,'批量发送(子女入学相关通知20200710)','18046311397','18046311397','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:01',NULL,NULL,NULL,'2020-07-10 17:32:01',NULL,NULL,NULL),('1281521548980670467',NULL,'1281521548364107778',2,2,'批量发送(子女入学相关通知20200710)','13906998716','13906998716','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:01',NULL,NULL,NULL,'2020-07-10 17:32:01',NULL,NULL,NULL),('1281521548980670468',NULL,'1281521548364107778',2,2,'批量发送(子女入学相关通知20200710)','15159739903','15159739903','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:01',NULL,NULL,NULL,'2020-07-10 17:32:01',NULL,NULL,NULL),('1281521678102319106',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18959847128','18959847128','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678114902018',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','15959798579','15959798579','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678119096322',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13506056368','13506056368','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678123290625',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13705941428','13705941428','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678131679233',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13799966695','13799966695','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678131679234',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13306995188','13306995188','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678135873537',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13559593361','13559593361','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678135873538',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18965689828','18965689828','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678140067842',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18859969666','18859969666','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678140067843',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','15611255393','15611255393','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678144262146',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18618285267','18618285267','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678144262147',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13906933286','13906933286','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678148456449',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18516157979','18516157979','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678148456450',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13436970465','13436970465','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678152650753',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18900371513','18900371513','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678152650754',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13960207400','13960207400','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678156845057',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13709857491','13709857491','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678156845058',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18965687332','18965687332','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678161039362',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13799557193','13799557193','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678161039363',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13805957117','13805957117','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678161039364',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13905957105','13905957105','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678165233666',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13905350771','13905350771','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678165233667',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13063191843','13063191843','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678165233668',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','15860328381','15860328381','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678169427970',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13960250701','13960250701','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678169427971',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18950070276','18950070276','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678173622274',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','15805026065','15805026065','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678173622275',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18065589080','18065589080','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678173622276',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13600759390','13600759390','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678177816578',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13918199745','13918199745','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678177816579',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13805997578','13805997578','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678215565314',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','18396220746','18396220746','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678219759618',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13805065379','13805065379','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678219759619',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13159037366','13159037366','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521678223953921',NULL,'1281521677783552001',2,2,'批量发送(子女入学相关通知20200710)','13901318357','13901318357','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:32',NULL,NULL,NULL,'2020-07-10 17:32:32',NULL,NULL,NULL),('1281521782527905793',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13255957226','13255957226','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782532100097',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13666026522','13666026522','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782536294402',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13905070552','13905070552','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782536294403',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15159878799','15159878799','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782536294404',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13960381057','13960381057','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782540488706',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18965689935','18965689935','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782540488707',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18960206656','18960206656','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782544683009',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13509362773','13509362773','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782544683010',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13905952020','13905952020','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782548877313',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13559566696','13559566696','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782548877314',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15860395678','15860395678','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782553071617',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13788851759','13788851759','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782553071618',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13599109151','13599109151','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782553071619',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15160423086','15160423086','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782557265922',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13805900098','13805900098','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782557265923',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15880785555','15880785555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782561460225',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18606989818','18606989818','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782561460226',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15985918296','15985918296','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782565654530',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15995216889','15995216889','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782565654531',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13959778888','13959778888','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782565654532',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13959237668','13959237668','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782569848834',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13601032833','13601032833','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782569848835',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18059037101','18059037101','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782574043138',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15259555555','15259555555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782574043139',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18960285333','18960285333','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782574043140',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13666988888','13666988888','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782578237442',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15622174598','15622174598','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782578237443',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15959889099','15959889099','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782582431745',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13905089834','13905089834','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782582431746',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13905085845','13905085845','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782582431747',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13505008588','13505008588','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782620180482',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18650908918','18650908918','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782624374785',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18150591518','18150591518','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782628569090',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13906095618','13906095618','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782628569091',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13400808814','13400808814','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782632763394',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13905950588','13905950588','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782632763395',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15315563156','15315563156','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782636957697',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13665959771','13665959771','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782641152001',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18159276351','18159276351','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782641152002',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15959873463','15959873463','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',2,'未知错误','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782645346306',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13506054328','13506054328','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782645346307',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13905055474','13905055474','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782649540610',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13788869420','13788869420','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782653734913',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18603006276','18603006276','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782653734914',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13696900561','13696900561','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782657929217',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15860517253','15860517253','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782657929218',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13850777555','13850777555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',2,'空号','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782662123522',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13850777672','13850777672','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782662123523',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13905971030','13905971030','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782666317825',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13959926888','13959926888','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782666317826',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13799797017','13799797017','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782666317827',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18959996388','18959996388','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782670512129',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13859989821','13859989821','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782674706434',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18876539791','18876539791','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782674706435',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15860302368','15860302368','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782678900737',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13599507077','13599507077','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782683095042',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13606051571','13606051571','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782683095043',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18659737170','18659737170','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782687289346',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15880990268','15880990268','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782687289347',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18698360960','18698360960','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782691483649',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13950317095','13950317095','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782725038082',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15905055709','15905055709','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782729232386',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','18859781366','18859781366','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782729232387',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13599106745','13599106745','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782733426689',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13808525056','13808525056','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782733426690',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13636928198','13636928198','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782733426691',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13805941850','13805941850','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782737620994',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13505905685','13505905685','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782737620995',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13850753398','13850753398','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782741815297',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15959599793','15959599793','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782746009602',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13559550686','13559550686','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782750203905',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13805951761','13805951761','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782750203906',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15710646360','15710646360','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782754398209',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13600704238','13600704238','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782758592513',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13400507028','13400507028','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782758592514',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13805957070','13805957070','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782762786817',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13805951603','13805951603','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782762786818',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15859577777','15859577777','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782766981121',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','15059597777','15059597777','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281521782766981122',NULL,'1281521782066532353',2,2,'批量发送(子女入学相关通知20200710)','13600703555','13600703555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:32:57',NULL,NULL,NULL,'2020-07-10 17:32:57',NULL,NULL,NULL),('1281522063160397825',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959858592','18959858592','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063164592130',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13801333177','13801333177','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063168786433',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13802609526','13802609526','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063168786434',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18016585576','18016585576','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063168786435',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18065376686','18065376686','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063168786436',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13906099888','13906099888','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063172980738',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15985952242','15985952242','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063172980739',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13055808024','13055808024','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063172980740',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13950920100','13950920100','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063177175042',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905958730','13905958730','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063177175043',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13105079935','13105079935','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063177175044',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','19852121931','19852121931','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063181369346',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905975119','13905975119','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063181369347',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13305967663','13305967663','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063181369348',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859990000','18859990000','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063185563649',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805946193','13805946193','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063185563650',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799555666','13799555666','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063252672514',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18006037555','18006037555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063252672515',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599162155','13599162155','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063256866817',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905907962','15905907962','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063261061122',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506060342','13506060342','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063261061123',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599212929','13599212929','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063265255426',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15750768536','15750768536','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063269449729',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506000615','13506000615','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063269449730',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905974006','13905974006','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063273644034',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18960357668','18960357668','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063273644035',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18650100145','18650100145','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063273644036',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18721796963','18721796963','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063277838338',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959210622','18959210622','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063277838339',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260782666','15260782666','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063277838340',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260803666','15260803666','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063315587073',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13685908658','13685908658','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063319781378',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15392288855','15392288855','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063319781379',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600754180','13600754180','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063323975682',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599780560','13599780560','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063323975683',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13655902993','13655902993','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063323975684',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13675995249','13675995249','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063328169986',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260429705','15260429705','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063328169987',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905968151','13905968151','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063328169988',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13720842620','13720842620','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063328169989',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18659915000','18659915000','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063332364289',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15060626155','15060626155','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063332364290',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805924801','13805924801','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063332364291',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859760088','18859760088','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063336558594',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905037555','15905037555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063336558595',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260807555','15260807555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063336558596',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905958858','15905958858','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063336558597',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15359585555','15359585555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063340752898',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059748612','15059748612','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063340752899',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13459504545','13459504545','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063340752900',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15396597171','15396597171','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063344947201',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13285030066','13285030066','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063344947202',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18050929268','18050929268','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063344947203',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18350777627','18350777627','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063349141505',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599159330','13599159330','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063349141506',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15960408186','15960408186','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063349141507',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959119986','13959119986','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063349141508',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600703008','13600703008','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063353335810',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505951467','13505951467','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063353335811',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959951039','13959951039','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063353335812',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18705052323','18705052323','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063391084546',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505932929','13505932929','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063395278850',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960282791','13960282791','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063395278851',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18065525518','18065525518','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063399473153',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13400840823','13400840823','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063399473154',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13501115138','13501115138','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063399473155',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799898116','13799898116','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063403667458',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505056755','13505056755','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063403667459',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13906998897','13906998897','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063403667460',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13774878631','13774878631','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063403667461',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599161927','13599161927','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063407861762',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13920285434','13920285434','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063407861763',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805956558','13805956558','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063407861764',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599936037','13599936037','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063412056066',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959992832','18959992832','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063412056067',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13850799806','13850799806','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063412056068',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959553375','15959553375','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063416250370',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15960795588','15960795588','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063416250371',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799239878','13799239878','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063416250372',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18960279877','18960279877','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063420444673',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13859775220','13859775220','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063420444674',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905006716','15905006716','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063420444675',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13860763453','13860763453','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063420444676',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13004800144','13004800144','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063424638977',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13515055988','13515055988','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063424638978',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13559591215','13559591215','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063424638979',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15985959061','15985959061','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063424638980',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13850755588','13850755588','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063428833282',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18633637251','18633637251','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063428833283',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505961108','13505961108','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063428833284',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13950299290','13950299290','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063462387714',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15980456333','15980456333','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063466582018',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959752857','13959752857','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063466582019',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18150983366','18150983366','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063466582020',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15106087765','15106087765','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063470776321',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13675930836','13675930836','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063470776322',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15505952026','15505952026','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063470776323',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13615922291','13615922291','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063474970625',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','17612198088','17612198088','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063474970626',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18659822922','18659822922','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063474970627',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13655601013','13655601013','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063474970628',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15827609588','15827609588','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063479164930',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13159012670','13159012670','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063479164931',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','17512098847','17512098847','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063479164932',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18050056871','18050056871','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063483359233',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','17750989111','17750989111','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063483359234',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599505962','13599505962','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063483359235',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15259729821','15259729821','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063487553537',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059823968','15059823968','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063487553538',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13407735197','13407735197','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063487553539',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','17715205257','17715205257','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063487553540',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15106033846','15106033846','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063491747841',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15846593350','15846593350','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063491747842',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13950092022','13950092022','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063491747843',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15810298887','15810298887','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063495942145',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505008000','13505008000','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063495942146',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13085059001','13085059001','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063495942147',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859498656','18859498656','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',2,'空号','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063495942148',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18876240048','18876240048','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063500136450',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18411037910','18411037910','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063500136451',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18698372705','18698372705','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063533690882',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18815997296','18815997296','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063537885186',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506998846','13506998846','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063537885187',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15259758239','15259758239','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063542079490',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959569933','15959569933','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063542079491',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15860356356','15860356356','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063542079492',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15860353200','15860353200','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063546273794',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905996655','15905996655','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063546273795',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13055650678','13055650678','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063546273796',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505097888','13505097888','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063546273797',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959717283','13959717283','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063550468097',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905985743','13905985743','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063550468098',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905079763','13905079763','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063550468099',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18650676688','18650676688','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063554662402',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15805073665','15805073665','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063554662403',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18900311779','18900311779','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063554662404',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15880977738','15880977738','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063558856705',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505955686','13505955686','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063558856706',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13906091302','13906091302','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063558856707',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959992008','15959992008','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063558856708',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959990198','15959990198','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063563051009',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13808558181','13808558181','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063563051010',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905075757','13905075757','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',1,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063563051011',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905079280','13905079280','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063563051012',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959981231','18959981231','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063567245313',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13489512117','13489512117','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063567245314',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799870758','13799870758','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063567245315',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15980025829','15980025829','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063571439618',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260838513','15260838513','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063571439619',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959975903','13959975903','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063571439620',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506095562','13506095562','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063613382658',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18965667777','18965667777','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063617576961',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13489512136','13489512136','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063617576962',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13587756546','13587756546','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063617576963',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959737339','13959737339','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063621771266',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505902557','13505902557','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063621771267',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15859590857','15859590857','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063625965569',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599751999','13599751999','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063625965570',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059720864','15059720864','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063625965571',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13655928585','13655928585','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063625965572',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13386880667','13386880667','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063630159874',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959882366','15959882366','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063630159875',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13788833384','13788833384','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063630159876',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13338583366','13338583366','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063634354178',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505905737','13505905737','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063634354179',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13788805366','13788805366','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063634354180',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13107891508','13107891508','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063634354181',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13645971717','13645971717','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063638548482',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15396503999','15396503999','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063638548483',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13400886486','13400886486','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063638548484',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18359592597','18359592597','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063638548485',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799866661','13799866661','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063642742785',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15060619686','15060619686','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063642742786',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13328883775','13328883775','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063642742787',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600704026','13600704026','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063642742788',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059551567','15059551567','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063646937090',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506086731','13506086731','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063646937091',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13338562717','13338562717','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063646937092',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18876509838','18876509838','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063651131393',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905089190','13905089190','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063651131394',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15980788802','15980788802','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063680491522',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15805032333','15805032333','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063684685825',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505080996','13505080996','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063684685826',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959705077','18959705077','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063688880130',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15880720190','15880720190','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063688880131',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18960278086','18960278086','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063688880132',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059792958','15059792958','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063693074433',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13306995039','13306995039','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063693074434',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13808510760','13808510760','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063693074435',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959896966','15959896966','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063693074436',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959995705','18959995705','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063697268737',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805957081','13805957081','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063697268738',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13705943966','13705943966','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063697268739',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13850778776','13850778776','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063697268740',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13636963633','13636963633','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063701463042',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13656038332','13656038332','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063701463043',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859932277','18859932277','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063701463044',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15306089555','15306089555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063701463045',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905079361','15905079361','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063705657345',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18605958880','18605958880','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063705657346',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905985809','13905985809','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063705657347',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15960692650','15960692650','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063709851650',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959712401','13959712401','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063709851651',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13328509988','13328509988','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063709851652',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15860398018','15860398018','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063709851653',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859551760','18859551760','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063714045954',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13395096999','13395096999','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063714045955',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959858506','18959858506','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063714045956',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960341716','13960341716','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063714045957',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15980313135','15980313135','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063718240258',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13906096567','13906096567','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063747600386',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13205061526','13205061526','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063751794689',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506042338','13506042338','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063751794690',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959753823','13959753823','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063751794691',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13459034477','13459034477','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063751794692',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15860688762','15860688762','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',2,'空号','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063755988993',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859596380','18859596380','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063755988994',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15960707755','15960707755','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063755988995',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505957512','13505957512','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063755988996',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13788829369','13788829369','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063760183297',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15392286115','15392286115','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063760183298',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15880974760','15880974760','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063760183299',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959997270','18959997270','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063760183300',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15392288851','15392288851','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063764377601',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','17750103317','17750103317','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063764377602',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18605001616','18605001616','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063764377603',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13425480722','13425480722','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',2,'常见原因是：关机，停机，不在服务区；在少数情况下，号码正常通信，是由于地区屏蔽导致。','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063764377604',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959855726','18959855726','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063768571905',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13459556182','13459556182','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063768571906',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13306995027','13306995027','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063768571907',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13325253201','13325253201','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063768571908',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13328963385','13328963385','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766209',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13816975274','13816975274','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766210',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15359590811','15359590811','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766211',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13599949096','13599949096','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766212',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960259639','13960259639','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766213',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18250155553','18250155553','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766214',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18965687331','18965687331','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766215',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960359859','13960359859','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766216',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959579818','15959579818','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063772766217',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15980000660','15980000660','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063827292162',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18722290558','18722290558','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063831486466',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959517575','15959517575','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063831486467',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505050069','13505050069','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063831486468',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059556400','15059556400','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063835680769',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959505915','15959505915','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063835680770',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799552053','13799552053','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063835680771',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13030981560','13030981560','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063835680772',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18659568811','18659568811','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063839875073',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15805097777','15805097777','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063839875074',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13328500766','13328500766','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063839875075',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18606985861','18606985861','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063839875076',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18606056998','18606056998','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063844069377',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18659003000','18659003000','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063844069378',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506969315','13506969315','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063844069379',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18350770992','18350770992','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063844069380',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905089465','13905089465','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063848263681',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15559067588','15559067588','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063848263682',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959953589','13959953589','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063848263683',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13489858089','13489858089','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063848263684',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13860750864','13860750864','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063852457986',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13256678813','13256678813','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063852457987',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805959125','13805959125','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063852457988',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18659262866','18659262866','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063852457989',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506069249','13506069249','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063856652290',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13906999100','13906999100','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063856652291',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13859751591','13859751591','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063856652292',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13636950560','13636950560','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063856652293',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959840868','13959840868','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063860846593',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15396583913','15396583913','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063860846594',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600753338','13600753338','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063923761153',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15860902576','15860902576','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063927955457',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505059996','13505059996','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063927955458',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505058832','13505058832','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063932149761',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13808549828','13808549828','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063932149762',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805945051','13805945051','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063932149763',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18960259259','18960259259','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063932149764',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959995002','18959995002','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063936344065',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506066917','13506066917','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063936344066',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600701178','13600701178','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063936344067',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506956209','13506956209','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063936344068',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13358577766','13358577766','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063936344069',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905035169','15905035169','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063940538370',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13859754633','13859754633','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063940538371',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506941213','13506941213','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063940538372',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18965699955','18965699955','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063940538373',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805950256','13805950256','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063944732674',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905095955','15905095955','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063944732675',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13559532808','13559532808','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063944732676',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15860901713','15860901713','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063944732677',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15359556333','15359556333','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063948926977',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905077879','15905077879','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063948926978',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13055667605','13055667605','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063948926979',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18059983988','18059983988','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063948926980',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18059993901','18059993901','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063953121281',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600709507','13600709507','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063953121282',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13636906289','13636906289','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063953121283',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13808512082','13808512082','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063953121284',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260399516','15260399516','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063953121285',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905006169','15905006169','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063957315586',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13808510666','13808510666','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063990870018',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13860703356','13860703356','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063990870019',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959910000','13959910000','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063995064322',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13860757775','13860757775','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063995064323',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15906066156','15906066156','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063995064324',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15959592923','15959592923','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063995064325',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905059153','13905059153','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063999258626',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799896025','13799896025','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063999258627',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506083126','13506083126','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063999258628',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15005936026','15005936026','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522063999258629',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15060806451','15060806451','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064003452930',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600703472','13600703472','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064003452931',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059832543','15059832543','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064003452932',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13110816682','13110816682','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064003452933',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15659450305','15659450305','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064007647233',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18650917845','18650917845','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064007647234',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18850547191','18850547191','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064007647235',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15083847155','15083847155','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064007647236',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13808543336','13808543336','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064011841537',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18965636930','18965636930','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064011841538',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15259555117','15259555117','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064011841539',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13110592357','13110592357','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064011841540',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15392481724','15392481724','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064016035842',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959940177','13959940177','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064016035843',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13860726225','13860726225','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064016035844',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260237093','15260237093','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064016035845',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15859468355','15859468355','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064016035846',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15259471016','15259471016','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064020230146',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13459599999','13459599999','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064020230147',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15326179637','15326179637','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064020230148',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15860301827','15860301827','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064049590274',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905057579','15905057579','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064053784578',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18060501876','18060501876','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064053784579',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13400887176','13400887176','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064057978881',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18050020726','18050020726','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064057978882',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13459246092','13459246092','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064057978883',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13055224466','13055224466','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064057978884',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18698399527','18698399527','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064062173186',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18314463516','18314463516','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064062173187',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13859790099','13859790099','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064062173188',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260200619','15260200619','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064062173189',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15605009590','15605009590','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064066367490',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059755771','15059755771','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064066367491',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15827436094','15827436094','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064066367492',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15159887877','15159887877','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064066367493',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15059510022','15059510022','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064070561794',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18606031846','18606031846','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064070561795',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15905070935','15905070935','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064070561796',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15805003589','15805003589','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064070561797',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15260720911','15260720911','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064070561798',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18050869127','18050869127','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064074756098',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18659923130','18659923130','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',2,'关机','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064074756099',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15859565605','15859565605','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064074756100',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18682261122','18682261122','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064074756101',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959700369','18959700369','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064078950401',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13615963766','13615963766','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064078950402',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15980301999','15980301999','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064078950403',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13030978969','13030978969','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064078950404',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18050878555','18050878555','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064083144706',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18650916825','18650916825','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064083144707',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959812033','13959812033','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064112504834',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859716793','18859716793','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064112504835',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13163906685','13163906685','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064116699137',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13665956888','13665956888','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064116699138',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15259597676','15259597676','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064116699139',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15259727676','15259727676','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064116699140',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905969285','13905969285','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064120893442',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960408350','13960408350','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064120893443',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959946911','13959946911','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064120893444',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18960251988','18960251988','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064125087746',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15060969798','15060969798','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064125087747',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15359855333','15359855333','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064125087748',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505071035','13505071035','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064125087749',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18905059500','18905059500','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064129282050',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','17705061101','17705061101','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064129282051',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13905059909','13905059909','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064129282052',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13799581818','13799581818','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064129282053',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13626076868','13626076868','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064133476354',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960255304','13960255304','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064133476355',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13805997206','13805997206','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064133476356',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506009833','13506009833','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064133476357',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13488682111','13488682111','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064133476358',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13675918895','13675918895','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064137670657',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15759500600','15759500600','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064137670658',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13860708740','13860708740','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064137670659',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15805972719','15805972719','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064141864961',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18050888018','18050888018','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064141864962',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960256303','13960256303','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064141864963',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18905079898','18905079898','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064141864964',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15359508512','15359508512','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064141864965',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505051522','13505051522','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064171225090',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18959853655','18959853655','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419394',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15859505750','15859505750','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419395',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505050692','13505050692','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419396',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18905060268','18905060268','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419397',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13959955769','13959955769','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419398',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15377953096','15377953096','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419399',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15960731557','15960731557','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419400',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13788826386','13788826386','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419401',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15375886386','15375886386','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419402',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18659916888','18659916888','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064175419403',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18859525583','18859525583','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064188002306',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13506059007','13506059007','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064188002307',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13505955666','13505955666','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064188002308',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13636951165','13636951165','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064188002309',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13365952758','13365952758','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064188002310',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15375754488','15375754488','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064188002311',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13808552366','13808552366','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064188002312',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960305030','13960305030','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064192196609',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13559369710','13559369710','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064192196610',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13067166871','13067166871','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064192196611',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13600785508','13600785508','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064192196612',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13459218283','13459218283','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064196390913',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','15605959006','15605959006','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064196390914',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13960326290','13960326290','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064196390915',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','18905051668','18905051668','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281522064196390916',NULL,'1281522062686441473',2,2,'批量发送(子女入学相关通知20200710)','13489387611','13489387611','【晋江市人才服务平台】通知：根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》(晋政文[2019]107号)精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户(个人用户注册)”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科',3,'短信发送成功','2020-07-10 17:34:03',NULL,NULL,NULL,'2020-07-10 17:34:03',NULL,NULL,NULL),('1281523585550245890',NULL,'1281523585550245890',2,1,NULL,'18618285267','237992','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:40:07',NULL,NULL,NULL),('1281523813623914497',NULL,'1281523813623914497',2,1,NULL,'15805021228','227029','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:41:01',NULL,NULL,NULL),('1281524642804260866',NULL,'1281524642804260866',2,1,NULL,'13799898116','784627','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:44:19',NULL,NULL,NULL),('1281524800505896962',NULL,'1281524800505896962',2,1,NULL,'15860398018','467657','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:44:56',NULL,NULL,NULL),('1281526508292268034',NULL,'1281526508292268034',2,1,NULL,'13400840823','544702','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:51:43',NULL,NULL,NULL),('1281527105972199425',NULL,'1281527105972199425',2,1,NULL,'13788832255','055066','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:54:06',NULL,NULL,NULL),('1281527312638140418',NULL,'1281527312638140418',2,1,NULL,'13600708564','415888','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:54:55',NULL,NULL,NULL),('1281528268687794178',NULL,'1281528268687794178',2,1,NULL,'13400840823','875557','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 17:58:43',NULL,NULL,NULL),('1281528635920080897',NULL,'1281528635920080897',2,1,NULL,'13615901213','591695','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 18:00:11',NULL,NULL,NULL),('1281530796116664322',NULL,'1281530796116664322',2,1,NULL,'15059839423','054110','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 18:08:46',NULL,NULL,NULL),('1281530848239280130',NULL,'1281530848239280130',2,1,NULL,'13400840823','050999','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 18:08:58',NULL,NULL,NULL),('1281532024426979330',NULL,'1281532024426979330',2,1,NULL,'13107870056','886276','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 18:13:38',NULL,NULL,NULL),('1281532516251066369',NULL,'1281532516251066369',2,1,NULL,'13400840823','681088','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 18:15:36',NULL,NULL,NULL),('1281533106049900546',NULL,'1281533106049900546',2,1,NULL,'13400840823','049516','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 18:17:56',NULL,NULL,NULL),('1281533107043950594',NULL,'1281533107043950594',2,1,NULL,'15059792958','333200','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 18:17:57',NULL,NULL,NULL),('1281547584187523074',NULL,'1281547584187523074',2,1,NULL,'15260875883','846635','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 19:15:28',NULL,NULL,NULL),('1281550210824265730',NULL,'1281550210824265730',2,1,NULL,'13599106745','315014','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 19:25:54',NULL,NULL,NULL),('1281550505193103361',NULL,'1281550505193103361',2,1,NULL,'13599106745','575004','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 19:27:05',NULL,NULL,NULL),('1281551639412596738',NULL,'1281551639412596738',2,1,NULL,'18350533612','121196','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 19:31:35',NULL,NULL,NULL),('1281551940815282177',NULL,'1281551940815282177',2,1,NULL,'13587756546','656941','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 19:32:47',NULL,NULL,NULL),('1281575525646721025',NULL,'1281575525646721025',2,1,NULL,'18960410787','781280','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 21:06:30',NULL,NULL,NULL),('1281587487235497985',NULL,'1281587487235497985',2,1,NULL,'13506086731','678379','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 21:54:02',NULL,NULL,NULL),('1281589075870081026',NULL,'1281589075870081026',2,1,NULL,'18605958880','091657','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 22:00:21',NULL,NULL,NULL),('1281612962871762946',NULL,'1281612962871762946',2,1,NULL,'18659910077','954749','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 23:35:16',NULL,NULL,NULL),('1281614662114336770',NULL,'1281614662114336770',2,1,NULL,'18659910077','656034','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 23:42:01',NULL,NULL,NULL),('1281616729402892289',NULL,'1281616729402892289',2,1,NULL,'18659910077','648994','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-10',NULL,NULL,NULL,'2020-07-10 23:50:14',NULL,NULL,NULL),('1281672135378591745',NULL,'1281672135378591745',2,1,NULL,'15260237093','192169','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 03:30:24',NULL,NULL,NULL),('1281742662872981506',NULL,'1281742662872981506',2,1,NULL,'15392286115','543624','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 08:10:39',NULL,NULL,NULL),('1281744655729418242',NULL,'1281744655729418242',2,1,NULL,'13549602580','656740','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 08:18:34',NULL,NULL,NULL),('1281753278304083970',NULL,'1281753278304083970',2,1,NULL,'18659910077','718211','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 08:52:50',NULL,NULL,NULL),('1281763985774993409',NULL,'1281763985774993409',2,1,NULL,'13055667605','476053','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 09:35:22',NULL,NULL,NULL),('1281764615977558017',NULL,'1281764615977558017',2,1,NULL,'13400840823','808806','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 09:37:53',NULL,NULL,NULL),('1281773339106467841',NULL,'1281773339106467841',2,1,NULL,'15880720190','356735','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 10:12:32',NULL,NULL,NULL),('1281773575510024194',NULL,'1281773575510024194',2,1,NULL,'18859596380','276184','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 10:13:29',NULL,NULL,NULL),('1281778755903283202',NULL,'1281778755903283202',2,1,NULL,'18965689828','241265','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 10:34:04',NULL,NULL,NULL),('1281792938086621186',NULL,'1281792938086621186',2,1,NULL,'15160423086','010380','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 11:30:25',NULL,NULL,NULL),('1281833629475004418',NULL,'1281833629475004418',2,1,NULL,'15880886959','752065','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 14:12:07',NULL,NULL,NULL),('1281843706302947330',NULL,'1281843706302947330',2,1,NULL,'13400840823','648746','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 14:52:09',NULL,NULL,NULL),('1281847533127196674',NULL,'1281847533127196674',2,1,NULL,'15960788399','759878','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 15:07:22',NULL,NULL,NULL),('1281848135311810562',NULL,'1281848135311810562',2,1,NULL,'13400840823','223471','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 15:09:45',NULL,NULL,NULL),('1281848259983302657',NULL,'1281848259983302657',2,1,NULL,'13599127767','429441','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 15:10:15',NULL,NULL,NULL),('1281848720408829953',NULL,'1281848720408829953',2,1,NULL,'18750597755','656965','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-11',NULL,NULL,NULL,'2020-07-11 15:12:05',NULL,NULL,NULL),('1282111425476681729',NULL,'1282111425476681729',2,1,NULL,'15260838513','914040','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-12',NULL,NULL,NULL,'2020-07-12 08:35:58',NULL,NULL,NULL),('1282235704600027137',NULL,'1282235704600027137',2,1,NULL,'15905079361','370194','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-12',NULL,NULL,NULL,'2020-07-12 16:49:49',NULL,NULL,NULL),('1282280977384726529',NULL,'1282280977384726529',2,1,NULL,'13655601013','918621','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-12',NULL,NULL,NULL,'2020-07-12 19:49:43',NULL,NULL,NULL),('1282281196407087106',NULL,'1282281196407087106',2,1,NULL,'18650916825','942097','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-12',NULL,NULL,NULL,'2020-07-12 19:50:35',NULL,NULL,NULL),('1282468806429630466',NULL,'1282468806429630466',2,1,NULL,'13587756546','706952','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 08:16:05',NULL,NULL,NULL),('1282479857736998915','83','1282479857736998915',1,2,'李女元','15359825666','7,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:00:00',NULL,NULL,NULL),('1282479857757970433','72','1282479857757970433',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:00:00',NULL,NULL,NULL),('1282479858148040706','87','1282479858148040706',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:00:00',NULL,NULL,NULL),('1282479858324201474','58','1282479858324201474',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:00:00',NULL,NULL,NULL),('1282480029837680641',NULL,'1282480029837680641',2,1,NULL,'15880024622','466873','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:00:41',NULL,NULL,NULL),('1282481109757714434',NULL,'1282481109757714434',2,1,NULL,'15959555236','868472','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:04:58',NULL,NULL,NULL),('1282481392869040130',NULL,'1282481392869040130',2,1,NULL,'13588114500','614033','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:06:06',NULL,NULL,NULL),('1282481714215641089',NULL,'1282481714215641089',2,1,NULL,'15959962792','034074','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:07:22',NULL,NULL,NULL),('1282482058756743170',NULL,'1282482058756743170',2,1,NULL,'17557282029','447552','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:08:44',NULL,NULL,NULL),('1282483522145214465',NULL,'1282483522145214465',2,1,NULL,'17557282029','024021','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:14:33',NULL,NULL,NULL),('1282484686207180802',NULL,'1282484686207180802',2,1,NULL,'15759596655','063358','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:19:11',NULL,NULL,NULL),('1282486859020230658',NULL,'1282486859020230658',2,1,NULL,'18960410787','227015','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:27:49',NULL,NULL,NULL),('1282490623630368769',NULL,'1282490623630368769',2,1,NULL,'15059551567','683730','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 09:42:46',NULL,NULL,NULL),('1282496802318311425',NULL,'1282496802318311425',2,1,NULL,'15602265352','461921','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 10:07:19',NULL,NULL,NULL),('1282500427052605442',NULL,'1282500427052605442',2,1,NULL,'13788832255','075024','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 10:21:44',NULL,NULL,NULL),('1282502644727930882',NULL,'1282502644727930882',2,1,NULL,'13600754180','257814','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 10:30:32',NULL,NULL,NULL),('1282502954393395202',NULL,'1282502954393395202',2,1,NULL,'13788805366','116870','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 10:31:46',NULL,NULL,NULL),('1282509569498669058',NULL,'1282509569498669058',2,1,NULL,'15059720864','737981','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 10:58:03',NULL,NULL,NULL),('1282512977664270337',NULL,'1282512977664270337',2,1,NULL,'15396596855','026711','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 11:11:36',NULL,NULL,NULL),('1282517985575165953',NULL,'1282517985575165953',2,1,NULL,'15080406979','638756','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 11:31:30',NULL,NULL,NULL),('1282518306498142210',NULL,'1282518306498142210',2,1,NULL,'18059993901','619304','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 11:32:46',NULL,NULL,NULL),('1282520631778336770',NULL,'1282520631778336770',2,1,NULL,'13400840823','076746','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 11:42:01',NULL,NULL,NULL),('1282532646806740994',NULL,'1282532646806740994',2,1,NULL,'18759429880','896052','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 12:29:45',NULL,NULL,NULL),('1282533147937988610',NULL,'1282533147937988610',2,1,NULL,'18759429880','603765','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 12:31:45',NULL,NULL,NULL),('1282541039680348162',NULL,'1282541039680348162',2,1,NULL,'17850539625','926383','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 13:03:06',NULL,NULL,NULL),('1282541466001989634',NULL,'1282541466001989634',2,1,NULL,'13559060707','740748','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 13:04:48',NULL,NULL,NULL),('1282543133644677121',NULL,'1282543133644677121',2,1,NULL,'15611255393','309630','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 13:11:26',NULL,NULL,NULL),('1282546653286490114',NULL,'1282546653286490114',2,1,NULL,'13788829369','450983','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 13:25:25',NULL,NULL,NULL),('1282553424231129090',NULL,'1282553424231129090',2,1,NULL,'15005062379','274585','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 13:52:19',NULL,NULL,NULL),('1282554232372846594',NULL,'1282554232372846594',2,1,NULL,'15005062379','627345','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 13:55:32',NULL,NULL,NULL),('1282557502264827905',NULL,'1282557502264827905',2,1,NULL,'18705045726','280214','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 14:08:31',NULL,NULL,NULL),('1282557987533217793',NULL,'1282557987533217793',2,1,NULL,'13587756546','946828','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 14:10:27',NULL,NULL,NULL),('1282565917057867778',NULL,'1282565917057867778',2,1,NULL,'18050270931','409396','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 14:41:58',NULL,NULL,NULL),('1282572171432026113',NULL,'1282572171432026113',2,1,NULL,'18571081281','387935','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 15:06:49',NULL,NULL,NULL),('1282586274535956482',NULL,'1282586274535956482',2,1,NULL,'13489848301','562453','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:02:51',NULL,NULL,NULL),('1282586776212463618',NULL,'1282586776212463618',2,1,NULL,'13400840823','526844','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:04:51',NULL,NULL,NULL),('1282587710023917569',NULL,'1282587710023917569',2,1,NULL,'13506903117','735158','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:08:34',NULL,NULL,NULL),('1282592011496579074',NULL,'1282592011496579074',2,1,NULL,'15392481724','692962','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:25:39',NULL,NULL,NULL),('1282597469410156545',NULL,'1282597469410156545',2,1,NULL,'13615922291','451687','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:47:20',NULL,NULL,NULL),('1282598641814593537',NULL,'1282598641814593537',2,1,NULL,'13799766670','547882','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:52:00',NULL,NULL,NULL),('1282599294607679490',NULL,'1282599294607679490',2,1,NULL,'13514019395','315490','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:54:36',NULL,NULL,NULL),('1282599435792146433',NULL,'1282599435792146433',2,1,NULL,'18050869127','084856','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:55:09',NULL,NULL,NULL),('1282599536602243073',NULL,'1282599536602243073',2,1,NULL,'15880758500','955873','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:55:33',NULL,NULL,NULL),('1282600322711281665',NULL,'1282600322711281665',2,1,NULL,'13110816682','420820','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:58:41',NULL,NULL,NULL),('1282600414025474049',NULL,'1282600414025474049',2,1,NULL,'18876539791','180881','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:59:02',NULL,NULL,NULL),('1282600560754810881',NULL,'1282600560754810881',2,1,NULL,'13110816682','583878','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 16:59:37',NULL,NULL,NULL),('1282602472459853825',NULL,'1282602472459853825',2,1,NULL,'15359383363','306024','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 17:07:13',NULL,NULL,NULL),('1282602627288391681',NULL,'1282602627288391681',2,1,NULL,'15959896966','260704','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 17:07:50',NULL,NULL,NULL),('1282602943035596802',NULL,'1282602943035596802',2,1,NULL,'15959896966','943744','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 17:09:05',NULL,NULL,NULL),('1282604032845799426',NULL,'1282604032845799426',2,1,NULL,'15805003589','418443','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 17:13:25',NULL,NULL,NULL),('1282612644410417154','1281532581099200514','1282612644410417154',2,2,'福建省晋南建设集团有限公司','13107870056','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 17:47:38',NULL,NULL,NULL),('1282614027964506114',NULL,'1282614027964506114',2,1,NULL,'18505958400','874293','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 17:53:08',NULL,NULL,NULL),('1282620575084306434',NULL,'1282620575084306434',2,1,NULL,'13400840823','765694','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 18:19:09',NULL,NULL,NULL),('1282624987810881538',NULL,'1282624987810881538',2,1,NULL,'18659003872','221810','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 18:36:41',NULL,NULL,NULL),('1282627004008620034',NULL,'1282627004008620034',2,1,NULL,'13788832255','443619','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 18:44:42',NULL,NULL,NULL),('1282629421404119041',NULL,'1282629421404119041',2,1,NULL,'18859969666','950604','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 18:54:18',NULL,NULL,NULL),('1282629959621402626',NULL,'1282629959621402626',2,1,NULL,'18659003872','620437','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 18:56:27',NULL,NULL,NULL),('1282642076286181378',NULL,'1282642076286181378',2,1,NULL,'15659050608','304563','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 19:44:35',NULL,NULL,NULL),('1282642427856936961',NULL,'1282642427856936961',2,1,NULL,'15659050608','967369','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 19:45:59',NULL,NULL,NULL),('1282658081792188418',NULL,'1282658081792188418',2,1,NULL,'18609586661','195547','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 20:48:11',NULL,NULL,NULL),('1282673351457890305',NULL,'1282673351457890305',2,1,NULL,'13505940442','182286','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-13',NULL,NULL,NULL,'2020-07-13 21:48:52',NULL,NULL,NULL),('1282707851269234690',NULL,'1282707851269234690',2,1,NULL,'13506903117','582249','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 00:05:57',NULL,NULL,NULL),('1282722800838238210',NULL,'1282722800838238210',2,1,NULL,'13505954433','056598','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 01:05:22',NULL,NULL,NULL),('1282828702098513922',NULL,'1282828702098513922',2,1,NULL,'13328989299','908866','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 08:06:11',NULL,NULL,NULL),('1282836967976984578',NULL,'1282836967976984578',2,1,NULL,'18650100145','530936','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 08:39:01',NULL,NULL,NULL),('1282842245493547009','72','1282842245493547009',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:00:00',NULL,NULL,NULL),('1282842245892005890','58','1282842245892005890',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:00:00',NULL,NULL,NULL),('1282842246311436290','87','1282842246311436290',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:00:00',NULL,NULL,NULL),('1282845557420843010',NULL,'1282845557420843010',2,1,NULL,'18959981231','116983','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:13:09',NULL,NULL,NULL),('1282846411670544386',NULL,'1282846411670544386',2,1,NULL,'18960410787','397906','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:16:33',NULL,NULL,NULL),('1282846865653620738',NULL,'1282846865653620738',2,1,NULL,'18559511816','998226','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:18:21',NULL,NULL,NULL),('1282847637279727618',NULL,'1282847637279727618',2,1,NULL,'13615950806','519029','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:21:25',NULL,NULL,NULL),('1282850789504655361',NULL,'1282850789504655361',2,1,NULL,'15959982171','323260','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:33:57',NULL,NULL,NULL),('1282851048498733058',NULL,'1282851048498733058',2,1,NULL,'18859716647','439712','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:34:58',NULL,NULL,NULL),('1282852817308033026',NULL,'1282852817308033026',2,1,NULL,'18859716647','305374','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 09:42:00',NULL,NULL,NULL),('1282867271898882049',NULL,'1282867271898882049',2,1,NULL,'13400840823','137672','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 10:39:26',NULL,NULL,NULL),('1282878416047169537',NULL,'1282878416047169537',2,1,NULL,'13400840823','746122','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 11:23:43',NULL,NULL,NULL),('1282892280478425090',NULL,'1282892280478425090',2,1,NULL,'13788805366','752019','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 12:18:49',NULL,NULL,NULL),('1282939842401001474',NULL,'1282939842401001474',2,1,NULL,'13799855086','455915','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 15:27:48',NULL,NULL,NULL),('1282956309192278017',NULL,'1282956309192278017',2,1,NULL,'13599109151','007320','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 16:33:14',NULL,NULL,NULL),('1282963573928132610',NULL,'1282963573928132610',2,1,NULL,'15905075826','185940','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 17:02:06',NULL,NULL,NULL),('1282964759573987329',NULL,'1282964759573987329',2,1,NULL,'15905075826','040008','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 17:06:49',NULL,NULL,NULL),('1282967371711021057',NULL,'1282967371711021057',2,1,NULL,'15159878799','717350','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 17:17:12',NULL,NULL,NULL),('1282971855552020482',NULL,'1282971855552020482',2,1,NULL,'13799866661','486454','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 17:35:01',NULL,NULL,NULL),('1282972281793970178',NULL,'1282972281793970178',2,1,NULL,'13799866661','339500','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 17:36:43',NULL,NULL,NULL),('1282980741344428034',NULL,'1282980741344428034',2,1,NULL,'18659910077','391525','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 18:10:20',NULL,NULL,NULL),('1282985890049810434',NULL,'1282985890049810434',2,1,NULL,'18050878520','541290','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 18:30:47',NULL,NULL,NULL),('1282991593862848513',NULL,'1282991593862848513',2,1,NULL,'13788805366','379615','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 18:53:27',NULL,NULL,NULL),('1283014798417715201',NULL,'1283014798417715201',2,1,NULL,'13959888168','039157','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 20:25:39',NULL,NULL,NULL),('1283059840402448386',NULL,'1283059840402448386',2,1,NULL,'13506903117','710977','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-14',NULL,NULL,NULL,'2020-07-14 23:24:38',NULL,NULL,NULL),('1283069065400803330',NULL,'1283069065400803330',2,1,NULL,'13489387611','761984','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 00:01:18',NULL,NULL,NULL),('1283198555426775041',NULL,'1283198555426775041',2,1,NULL,'13400840823','997120','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 08:35:50',NULL,NULL,NULL),('1283203478784696321',NULL,'1283203478784696321',2,1,NULL,'13459504545','614668','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 08:55:24',NULL,NULL,NULL),('1283206787926974466',NULL,'1283206787926974466',2,1,NULL,'13959975903','272258','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 09:08:33',NULL,NULL,NULL),('1283217280162893825',NULL,'1283217280162893825',2,1,NULL,'13599171402','114247','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 09:50:15',NULL,NULL,NULL),('1283229011945725954',NULL,'1283229011945725954',2,1,NULL,'18605001616','409705','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 10:36:52',NULL,NULL,NULL),('1283232648407293953','1282964895578488833','1283232648407293953',2,2,'泉州尚德服饰有限公司','15905075826','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 10:51:19',NULL,NULL,NULL),('1283277895451549697',NULL,'1283277895451549697',2,1,NULL,'18959996091','104840','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 13:51:07',NULL,NULL,NULL),('1283285769527500802',NULL,'1283285769527500802',2,1,NULL,'13599781990','131160','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 14:22:24',NULL,NULL,NULL),('1283291268385873921',NULL,'1283291268385873921',2,1,NULL,'13506903117','368281','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 14:44:15',NULL,NULL,NULL),('1283303201944117250',NULL,'1283303201944117250',2,1,NULL,'15980025829','771326','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 15:31:40',NULL,NULL,NULL),('1283324600368766977','1214748606972649473','1283324600368766977',2,2,'福建纸匠文化科技股份有限公司','15960759601','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 16:56:42',NULL,NULL,NULL),('1283331630768857090',NULL,'1283331630768857090',2,1,NULL,'18862155925','568909','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 17:24:38',NULL,NULL,NULL),('1283367090786410497',NULL,'1283367090786410497',2,1,NULL,'13850755588','487528','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 19:45:32',NULL,NULL,NULL),('1283400536338472961',NULL,'1283400536338472961',2,1,NULL,'13506903117','726237','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 21:58:26',NULL,NULL,NULL),('1283410041386311682',NULL,'1283410041386311682',2,1,NULL,'13599111348','843554','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 22:36:13',NULL,NULL,NULL),('1283414467912146945',NULL,'1283414467912146945',2,1,NULL,'13599111348','816346','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-15',NULL,NULL,NULL,'2020-07-15 22:53:48',NULL,NULL,NULL),('1283560218038378497',NULL,'1283560218038378497',2,1,NULL,'13599781990','555740','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 08:32:58',NULL,NULL,NULL),('1283563399799644161',NULL,'1283563399799644161',2,1,NULL,'13588114500','158487','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 08:45:36',NULL,NULL,NULL),('1283563976977817601',NULL,'1283563976977817601',2,1,NULL,'15160776754','669066','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 08:47:54',NULL,NULL,NULL),('1283567436473311233',NULL,'1283567436473311233',2,1,NULL,'15106035553','829522','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 09:01:39',NULL,NULL,NULL),('1283577359986860034',NULL,'1283577359986860034',2,1,NULL,'15260875781','675823','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 09:41:04',NULL,NULL,NULL),('1283588063766781953',NULL,'1283588063766781953',2,1,NULL,'17606000285','680805','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 10:23:36',NULL,NULL,NULL),('1283590522866245633',NULL,'1283590522866245633',2,1,NULL,'18505955256','294486','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 10:33:23',NULL,NULL,NULL),('1283594884145487874',NULL,'1283594884145487874',2,1,NULL,'18960410787','050571','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 10:50:43',NULL,NULL,NULL),('1283596986003496961',NULL,'1283596986003496961',2,1,NULL,'15880754887','923090','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 10:59:04',NULL,NULL,NULL),('1283612012969992194',NULL,'1283612012969992194',2,1,NULL,'13506903117','490128','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 11:58:46',NULL,NULL,NULL),('1283642378015481857',NULL,'1283642378015481857',2,1,NULL,'13600708564','500136','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 13:59:26',NULL,NULL,NULL),('1283643980382216193',NULL,'1283643980382216193',2,1,NULL,'13489293319','392637','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 14:05:48',NULL,NULL,NULL),('1283645703939170306',NULL,'1283645703939170306',2,1,NULL,'18859716647','123599','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 14:12:39',NULL,NULL,NULL),('1283658625792876545',NULL,'1283658625792876545',2,1,NULL,'13506903117','600645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 15:04:00',NULL,NULL,NULL),('1283667645693960193',NULL,'1283667645693960193',2,1,NULL,'13506903117','256628','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 15:39:50',NULL,NULL,NULL),('1283685885115637762',NULL,'1283685885115637762',2,1,NULL,'13850777672','985434','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 16:52:19',NULL,NULL,NULL),('1283686026853752833',NULL,'1283686026853752833',2,1,NULL,'13588114500','175561','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 16:52:53',NULL,NULL,NULL),('1283686440537956353',NULL,'1283686440537956353',2,1,NULL,'13506903117','914216','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 16:54:31',NULL,NULL,NULL),('1283686731605876737',NULL,'1283686731605876737',2,1,NULL,'13805943888','231514','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 16:55:41',NULL,NULL,NULL),('1283688618417725441',NULL,'1283688618417725441',2,1,NULL,'13599781990','605470','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 17:03:11',NULL,NULL,NULL),('1283741530305077250',NULL,'1283741530305077250',2,1,NULL,'18960410787','249150','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 20:33:26',NULL,NULL,NULL),('1283744005665857537',NULL,'1283744005665857537',2,1,NULL,'15905988871','643584','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 20:43:16',NULL,NULL,NULL),('1283752687921274881',NULL,'1283752687921274881',2,1,NULL,'15880024622','793192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-16',NULL,NULL,NULL,'2020-07-16 21:17:46',NULL,NULL,NULL),('1283922158048780289',NULL,'1283922158048780289',2,1,NULL,'15375754488','820531','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 08:31:11',NULL,NULL,NULL),('1283922870249988097',NULL,'1283922870249988097',2,1,NULL,'15106035553','519969','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 08:34:01',NULL,NULL,NULL),('1283923886034919426',NULL,'1283923886034919426',2,1,NULL,'15260833617','466107','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 08:38:03',NULL,NULL,NULL),('1283934672551682050',NULL,'1283934672551682050',2,1,NULL,'13805946193','706412','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 09:20:54',NULL,NULL,NULL),('1283940799972646913',NULL,'1283940799972646913',2,1,NULL,'15260875781','105446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 09:45:15',NULL,NULL,NULL),('1283960281457762305','1281834150738911234','1283960281457762305',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 11:02:40',NULL,NULL,NULL),('1283960806412656642','1245239948823592961','1283960806412656642',2,2,'晋江五店市晋文坊房地产开发有限公司','13959941699','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 11:04:45',NULL,NULL,NULL),('1283962186288340993',NULL,'1283962186288340993',2,1,NULL,'13489767598','661543','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 11:10:14',NULL,NULL,NULL),('1284023947100168193',NULL,'1284023947100168193',2,1,NULL,'18959996091','650021','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 15:15:39',NULL,NULL,NULL),('1284028110127243265',NULL,'1284028110127243265',2,1,NULL,'18016585576','836320','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 15:32:12',NULL,NULL,NULL),('1284034082866470913',NULL,'1284034082866470913',2,1,NULL,'18659902677','044547','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 15:55:56',NULL,NULL,NULL),('1284042925117808641',NULL,'1284042925117808641',2,1,NULL,'18605958852','158723','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 16:31:04',NULL,NULL,NULL),('1284066952427347969',NULL,'1284066952427347969',2,1,NULL,'13489887652','844635','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 18:06:32',NULL,NULL,NULL),('1284114578698936321',NULL,'1284114578698936321',2,1,NULL,'15160326656','706110','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 21:15:47',NULL,NULL,NULL),('1284126055430365186',NULL,'1284126055430365186',2,1,NULL,'13505940442','829686','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-17',NULL,NULL,NULL,'2020-07-17 22:01:24',NULL,NULL,NULL),('1284277243991826433',NULL,'1284277243991826433',2,1,NULL,'13489767598','381670','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-18',NULL,NULL,NULL,'2020-07-18 08:02:10',NULL,NULL,NULL),('1284358589690945538',NULL,'1284358589690945538',2,1,NULL,'18050929268','697601','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-18',NULL,NULL,NULL,'2020-07-18 13:25:24',NULL,NULL,NULL),('1284375136169893889',NULL,'1284375136169893889',2,1,NULL,'18695669899','883201','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-18',NULL,NULL,NULL,'2020-07-18 14:31:09',NULL,NULL,NULL),('1284380449874911234',NULL,'1284380449874911234',2,1,NULL,'13489767598','178106','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-18',NULL,NULL,NULL,'2020-07-18 14:52:16',NULL,NULL,NULL),('1284399378206826497',NULL,'1284399378206826497',2,1,NULL,'15260704530','527787','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-18',NULL,NULL,NULL,'2020-07-18 16:07:29',NULL,NULL,NULL),('1284399984455720961',NULL,'1284399984455720961',2,1,NULL,'15260704530','222075','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-18',NULL,NULL,NULL,'2020-07-18 16:09:53',NULL,NULL,NULL),('1284674171950866434',NULL,'1284674171950866434',2,1,NULL,'15891723537','212525','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-19',NULL,NULL,NULL,'2020-07-19 10:19:25',NULL,NULL,NULL),('1284757954662244354',NULL,'1284757954662244354',2,1,NULL,'15906066156','243890','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-19',NULL,NULL,NULL,'2020-07-19 15:52:20',NULL,NULL,NULL),('1284763566104125441',NULL,'1284763566104125441',2,1,NULL,'18150915678','220434','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-19',NULL,NULL,NULL,'2020-07-19 16:14:38',NULL,NULL,NULL),('1284764468097589249',NULL,'1284764468097589249',2,1,NULL,'18150915678','759116','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-19',NULL,NULL,NULL,'2020-07-19 16:18:13',NULL,NULL,NULL),('1285011037799587841',NULL,'1285011037799587841',2,1,NULL,'15959896966','816804','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 08:38:00',NULL,NULL,NULL),('1285014300565446658','1281834150738911234','1285014300565446658',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 08:50:58',NULL,NULL,NULL),('1285095831367589890',NULL,'1285095831367589890',2,1,NULL,'13615950806','445679','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 14:14:56',NULL,NULL,NULL),('1285096129876205569',NULL,'1285096129876205569',2,1,NULL,'13615950806','270197','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 14:16:07',NULL,NULL,NULL),('1285127007159459841','1283410609538342913','1285127007159459841',2,2,'福建田洋九九文旅发展有限公司','13599111348','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 16:18:49',NULL,NULL,NULL),('1285134432268722177',NULL,'1285134432268722177',2,1,NULL,'13506902259','015862','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 16:48:19',NULL,NULL,NULL),('1285134814059438082','1283410609538342913','1285134814059438082',2,2,'福建田洋九九文旅发展有限公司','13599111348','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 16:49:50',NULL,NULL,NULL),('1285137536406003714','1283410609538342913','1285137536406003714',2,2,'福建田洋九九文旅发展有限公司','13599111348','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-20',NULL,NULL,NULL,'2020-07-20 17:00:40',NULL,NULL,NULL),('1285395292589400065',NULL,'1285395292589400065',2,1,NULL,'18659516267','489709','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-21',NULL,NULL,NULL,'2020-07-21 10:04:53',NULL,NULL,NULL),('1285485511976165377',NULL,'1285485511976165377',2,1,NULL,'13805957070','529182','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-21',NULL,NULL,NULL,'2020-07-21 16:03:23',NULL,NULL,NULL),('1285492476634734594',NULL,'1285492476634734594',2,1,NULL,'15059066119','109931','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-21',NULL,NULL,NULL,'2020-07-21 16:31:04',NULL,NULL,NULL),('1285493962634698753',NULL,'1285493962634698753',2,1,NULL,'15059066119','354079','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-21',NULL,NULL,NULL,'2020-07-21 16:36:58',NULL,NULL,NULL),('1285495193444818946',NULL,'1285495193444818946',2,1,NULL,'15059066119','967905','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-21',NULL,NULL,NULL,'2020-07-21 16:41:52',NULL,NULL,NULL),('1285513303656767490',NULL,'1285513303656767490',2,1,NULL,'13799766670','759498','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-21',NULL,NULL,NULL,'2020-07-21 17:53:49',NULL,NULL,NULL),('1285792432792805378',NULL,'1285792432792805378',2,1,NULL,'13799899050','922653','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-22',NULL,NULL,NULL,'2020-07-22 12:22:59',NULL,NULL,NULL),('1285862194436644865',NULL,'1285862194436644865',2,1,NULL,'13599937223','995815','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-22',NULL,NULL,NULL,'2020-07-22 17:00:11',NULL,NULL,NULL),('1285866942845952001',NULL,'1285866942845952001',2,1,NULL,'18859210518','584958','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-22',NULL,NULL,NULL,'2020-07-22 17:19:04',NULL,NULL,NULL),('1286096186620534786','1211490953219588098','1286096186620534786',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096187430035458','1211505228151570433','1286096187430035458',2,2,'晋江市陈埭中心卫生院','13905972257','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096187627167745','1211574035113099265','1286096187627167745',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096187811717121','1211837849989595138','1286096187811717121',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096188021432322','1211920348237316098','1286096188021432322',2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096188210176002','1211930809942982658','1286096188210176002',2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096188403113985','1212580494957416450','1286096188403113985',2,2,'舒华体育股份有限公司','13599295908','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096188591857666','1212903777946898433','1286096188591857666',2,2,'福建兴翼机械有限公司','18606981162','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096188797378562','1213031390673702913','1286096188797378562',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096188986122242','1214097817526620161','1286096188986122242',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096189187448833','1214748606972649473','1286096189187448833',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096189388775426','1215115207978827777','1286096189388775426',2,2,'福州大学晋江科教园管委会','15980228632','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096189598490626','1215207699331989506','1286096189598490626',2,2,'晋江市医院','18350528526','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096189791428610','1215455507792314370','1286096189791428610',2,2,'晋江市致和社工事务所','15860517253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096189984366594','1215608523329683457','1286096189984366594',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096190185693185','1216900406462926849','1286096190185693185',2,2,'晋江山外山五祖拳传习中心','13905063574','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096190370242562','1219140374220627970','1286096190370242562',2,2,'福建亲亲股份有限公司','15905035025','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:00',NULL,NULL,NULL),('1286096190567374849','1241252588561698817','1286096190567374849',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:01',NULL,NULL,NULL),('1286096190764507138','1275360115897188354','1286096190764507138',2,2,'晋江市图书馆','15905058965','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:01',NULL,NULL,NULL),('1286096190957445121','1275621554885017601','1286096190957445121',2,2,'晋江市卫生健康局','18059995763','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:01',NULL,NULL,NULL),('1286096191158771713','1278496729536172034','1286096191158771713',2,2,'中国邮政储蓄银行股份有限公司晋江市支行','13959102760','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 08:30:01',NULL,NULL,NULL),('1286103736413872129','72','1286103736413872129',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 09:00:00',NULL,NULL,NULL),('1286103736875245570','58','1286103736875245570',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 09:00:00',NULL,NULL,NULL),('1286103737412116481','87','1286103737412116481',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 09:00:00',NULL,NULL,NULL),('1286170591308570625','1284416517621948417','1286170591308570625',2,2,'福建省晋江市三力机车有限公司','18965689935','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 13:25:39',NULL,NULL,NULL),('1286188065110384642','1284416517621948417','1286188065110384642',2,2,'福建省晋江市三力机车有限公司','18965689935','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 14:35:05',NULL,NULL,NULL),('1286190309574729730',NULL,'1286190309574729730',2,1,NULL,'15960791997','500809','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-23',NULL,NULL,NULL,'2020-07-23 14:44:00',NULL,NULL,NULL),('1286470375214964737',NULL,'1286470375214964737',2,1,NULL,'13506075567','520977','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-24',NULL,NULL,NULL,'2020-07-24 09:16:53',NULL,NULL,NULL),('1286493359845695489',NULL,'1286493359845695489',2,1,NULL,'15396380625','100935','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-24',NULL,NULL,NULL,'2020-07-24 10:48:13',NULL,NULL,NULL),('1286493870300880898',NULL,'1286493870300880898',2,1,NULL,'15396380625','713579','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-24',NULL,NULL,NULL,'2020-07-24 10:50:15',NULL,NULL,NULL),('1286498955403747330',NULL,'1286498955403747330',2,1,NULL,'15359826329','861525','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-24',NULL,NULL,NULL,'2020-07-24 11:10:27',NULL,NULL,NULL),('1286573847805452289','1285862298023370753','1286573847805452289',2,2,'金鹰(福建)印刷有限公司','13599937223','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-24',NULL,NULL,NULL,'2020-07-24 16:08:03',NULL,NULL,NULL),('1286600924797624322',NULL,'1286600924797624322',2,1,NULL,'13636905076','154108','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-24',NULL,NULL,NULL,'2020-07-24 17:55:39',NULL,NULL,NULL),('1286601841114636289',NULL,'1286601841114636289',2,1,NULL,'13636905076','133535','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-24',NULL,NULL,NULL,'2020-07-24 17:59:17',NULL,NULL,NULL),('1286835165292683266',NULL,'1286835165292683266',2,1,NULL,'13489767598','622826','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-25',NULL,NULL,NULL,'2020-07-25 09:26:26',NULL,NULL,NULL),('1286866706190327809',NULL,'1286866706190327809',2,1,NULL,'15860396001','243590','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-25',NULL,NULL,NULL,'2020-07-25 11:31:46',NULL,NULL,NULL),('1286866980015464450',NULL,'1286866980015464450',2,1,NULL,'13306995027','941886','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-25',NULL,NULL,NULL,'2020-07-25 11:32:51',NULL,NULL,NULL),('1287275871425552386',NULL,'1287275871425552386',2,1,NULL,'15160326656','422098','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-26',NULL,NULL,NULL,'2020-07-26 14:37:38',NULL,NULL,NULL),('1287339828454645762',NULL,'1287339828454645762',2,1,NULL,'15260803666','314490','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-26',NULL,NULL,NULL,'2020-07-26 18:51:47',NULL,NULL,NULL),('1287565386245496834',NULL,'1287565386245496834',2,1,NULL,'15160775562','401270','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-27',NULL,NULL,NULL,'2020-07-27 09:48:04',NULL,NULL,NULL),('1287570369225449473','1283674430534328322','1287570369225449473',2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-27',NULL,NULL,NULL,'2020-07-27 10:07:52',NULL,NULL,NULL),('1287667660552691714',NULL,'1287667660552691714',2,1,NULL,'15806036626','680966','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-27',NULL,NULL,NULL,'2020-07-27 16:34:28',NULL,NULL,NULL),('1287688343592665089',NULL,'1287688343592665089',2,1,NULL,'13505997870','370415','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-27',NULL,NULL,NULL,'2020-07-27 17:56:39',NULL,NULL,NULL),('1287692931234299905',NULL,'1287692931234299905',2,1,NULL,'13328566911','962771','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-27',NULL,NULL,NULL,'2020-07-27 18:14:53',NULL,NULL,NULL),('1287913342614142977',NULL,'1287913342614142977',2,1,NULL,'13328566911','269613','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 08:50:43',NULL,NULL,NULL),('1287914562808479746',NULL,'1287914562808479746',2,1,NULL,'19905061916','782123','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 08:55:34',NULL,NULL,NULL),('1287919053230342145',NULL,'1287919053230342145',2,1,NULL,'19905061916','275567','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 09:13:25',NULL,NULL,NULL),('1287926651673411585',NULL,'1287926651673411585',2,1,NULL,'19905061916','025898','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 09:43:36',NULL,NULL,NULL),('1287931939038199809','1275222683646214146','1287931939038199809',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 10:04:37',NULL,NULL,NULL),('1287933152924303362','1275224421430247425','1287933152924303362',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 10:09:26',NULL,NULL,NULL),('1287933599693176833','1275224880488431617','1287933599693176833',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 10:11:13',NULL,NULL,NULL),('1287934712299421697','1286601591461273602','1287934712299421697',2,2,'福建省晋江市新华石油加油站有限公司','13636905076','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 10:15:38',NULL,NULL,NULL),('1287936615322255362','1275222683646214146','1287936615322255362',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 10:23:12',NULL,NULL,NULL),('1287946882693234690','1211815946042261505','1287946882693234690',2,2,'许清池','13666026522','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946883024584705','1211805224986001409','1287946883024584705',2,2,'常向真','13506056368','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946883204939778','1211490953219588098','1287946883204939778',2,2,'吴志清','15980788802','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946883393683457','1210918631014248450','1287946883393683457',2,2,'丁思博','18960278086','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946883607592962','1211450215958102018','1287946883607592962',2,2,'许经厨','15959896966','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946883783753729','1211489025517469698','1287946883783753729',2,2,'曾碧芬','13799555666','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946883968303105','1211456215943528450','1287946883968303105',2,2,'黄兴煜','18006037555','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946884148658177','1211855307945328641','1287946884148658177',2,2,'周恋东','15160423086','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946884349984769','1211819923995672577','1287946884349984769',2,2,'郭卓君','13850778776','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946884534534146','1211456215943528450','1287946884534534146',2,2,'朱志刚','15392288855','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946884710694914','1212536999949438978','1287946884710694914',2,2,'叶定明','13960341716','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946884891049986','1212536999949438978','1287946884891049986',2,2,'童寿明','15980313135','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946885117542402','1212536999949438978','1287946885117542402',2,2,'李盛富','13675995249','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:00',NULL,NULL,NULL),('1287946885293703169','1211456215943528450','1287946885293703169',2,2,'何伟川','15260429705','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946885469863937','1211945767430832130','1287946885469863937',2,2,'许群英','18659915000','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946885654413314','1212271071303110658','1287946885654413314',2,2,'王俊仁','13505957512','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946885822185473','1211490446086291458','1287946885822185473',2,2,'臧树良','13709857491','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946885998346241','1211490446086291458','1287946885998346241',2,2,'林其天','13959119986','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946886174507009','1212568548061286401','1287946886174507009',2,2,'左立民','15959505915','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946886350667778','1211925547903401986','1287946886350667778',2,2,'陈敬龙','13696900561','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946886526828546','1211945767430832130','1287946886526828546',2,2,'张向前','13505059996','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946886707183617','1211945767430832130','1287946886707183617',2,2,'蔡耿耀','18960259259','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946886912704513','1211945767430832130','1287946886912704513',2,2,'李聪蓉','18959995002','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946887109836801','1211945767430832130','1287946887109836801',2,2,'肖文焕','13506066917','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946887319552001','1211945767430832130','1287946887319552001',2,2,'黄香莲','13600701178','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946887516684289','1211601884993863681','1287946887516684289',2,2,'陈扶持','13506956209','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946887692845058','1211945767430832130','1287946887692845058',2,2,'黄诸侯','18959992832','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946887873200129','1211945767430832130','1287946887873200129',2,2,'陈龙群','13358577766','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946888040972289','1211945767430832130','1287946888040972289',2,2,'丁峰','15905035169','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946888212938753','1215100340257472514','1287946888212938753',2,2,'吴志辉','15959553375','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946888384905217','1211945767430832130','1287946888384905217',2,2,'王晓彤','13859754633','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946888556871682','1211945767430832130','1287946888556871682',2,2,'汪顺加','13805950256','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946888733032450','1211601884993863681','1287946888733032450',2,2,'许小蓉','15359556333','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946888904998914','1211945767430832130','1287946888904998914',2,2,'李良文','15905077879','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946889148268546','1211855307945328641','1287946889148268546',2,2,'洪荫治','13905971030','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946889320235010','1211945767430832130','1287946889320235010',2,2,'杨琳','13636906289','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:01',NULL,NULL,NULL),('1287946889492201473','1211855307945328641','1287946889492201473',2,2,'许金培','13959926888','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946889668362241','1211601884993863681','1287946889668362241',2,2,'许少茹','15905006169','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946889848717314','1211450825436610561','1287946889848717314',2,2,'肖炳烜','13606051571','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946890041655297','1215207699331989506','1287946890041655297',2,2,'卢清旺','13675930836','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946890209427458','1211490953219588098','1287946890209427458',2,2,'韩军','15505952026','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946890389782530','1217264466144546817','1287946890389782530',2,2,'陆廷栋','13860726225','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946890561748994','1215207699331989506','1287946890561748994',2,2,'刘维波','17750989111','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946890754686977','1215207699331989506','1287946890754686977',2,2,'石艳','15605009590','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946890918264834','1215207699331989506','1287946890918264834',2,2,'王旭东','13505008000','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946891086036993','1211490953219588098','1287946891086036993',2,2,'林名强','13085059001','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946891258003457','1212685717864517633','1287946891258003457',2,2,'刘素萍','15905070935','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946891429969922','1211490953219588098','1287946891429969922',2,2,'汤璇','18876240048','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946891606130689','1211490953219588098','1287946891606130689',2,2,'夏安俊','18815997296','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946891782291458','1212685717864517633','1287946891782291458',2,2,'刘文杰','15980301999','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946891979423746','1215207699331989506','1287946891979423746',2,2,'张荣君','13030978969','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946892180750337','1216926739968577538','1287946892180750337',2,2,'黄芳','18650916825','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946892369494017','1215207699331989506','1287946892369494017',2,2,'林友榆','15959569933','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946892533071873','1215207699331989506','1287946892533071873',2,2,'洪婷婷','15860353200','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946892721815553','1215207699331989506','1287946892721815553',2,2,'赵晓馥','15905996655','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946892897976321','1215207699331989506','1287946892897976321',2,2,'李跃辉','13055650678','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946893069942785','1212685717864517633','1287946893069942785',2,2,'张茹','15805073665','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946893237714945','1215207699331989506','1287946893237714945',2,2,'丁育钧','18960251988','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946893405487105','1215207699331989506','1287946893405487105',2,2,'张育仁','15060969798','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946893590036481','1215207699331989506','1287946893590036481',2,2,'洪远香','15359855333','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:02',NULL,NULL,NULL),('1287946893757808641','1215207699331989506','1287946893757808641',2,2,'洪杨文','13505071035','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946893971718145','1215207699331989506','1287946893971718145',2,2,'林水龙','18905059500','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946894143684609','1212685717864517633','1287946894143684609',2,2,'黄伟荣','13808525056','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946894324039682','1212685717864517633','1287946894324039682',2,2,'蔡文墨','13808558181','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946894496006146','1212685717864517633','1287946894496006146',2,2,'杨声波','13905075757','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',2,'黑名单','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946894684749825','1212685717864517633','1287946894684749825',2,2,'郭森仁','13905079280','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946894865104898','1215455507792314370','1287946894865104898',2,2,'夏晋城','13488682111','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946895028682754','1214097817526620161','1287946895028682754',2,2,'刘莹','13505905685','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946895200649217','1214097817526620161','1287946895200649217',2,2,'苏文庭','18959981231','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946895368421377','1214097817526620161','1287946895368421377',2,2,'翁文伟','13489512117','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946895540387841','1214097817526620161','1287946895540387841',2,2,'吴晓彪','15759500600','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946895712354305','1214097817526620161','1287946895712354305',2,2,'蔡增雄','13799870758','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946895909486593','1214097817526620161','1287946895909486593',2,2,'罗梅芳','15980025829','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946896081453058','1215548205433929729','1287946896081453058',2,2,'罗耀发','15805972719','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946896266002434','1215207699331989506','1287946896266002434',2,2,'佘日光','15377953096','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946896437968898','1215207699331989506','1287946896437968898',2,2,'王鸿飞','15960731557','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946896609935362','1219436923634892801','1287946896609935362',2,2,'黄秋波','15375886386','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946896773513218','1215207699331989506','1287946896773513218',2,2,'庄志伟','13960305030','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946896958062594','1211474926804975617','1287946896958062594',2,2,'刘义圣','13805065379','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1287946897125834753','1214097817526620161','1287946897125834753',2,2,'祝二斌','15060619686','','【晋江市人才服务平台】温馨提醒：尊敬的晋江市优秀人才，您公布入选的晋江市优秀人才有效期即将到期，请您重新对照认定标准进行人才认定申报。符合泉州市高层次人才认定标准的，请先在“泉州市高层次人才网”点击“泉州市高层次人才一站式服务系统”进行泉州市高层次人才认定，待公布入选后登陆“聚才网”点击“晋江市人才综合服务平台”提交晋江市优秀人才认定；符合晋江市优秀人才补充认定标准的，则直接在“晋江市人才综合服务平台”提交晋江市优秀人才认定。（若已重新申报请忽略该条信息）',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 11:04:03',NULL,NULL,NULL),('1288018526291918849','1283955260880068610','1288018526291918849',2,2,'三斯达（福建）塑胶有限公司','15375886386','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 15:48:41',NULL,NULL,NULL),('1288020432594698241','1284027210780385281','1288020432594698241',2,2,'福建省烨烽软件科技有限公司','13905050770','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-07-28',NULL,NULL,NULL,'2020-07-28 15:56:16',NULL,NULL,NULL),('1288023824624812033','1284381096389124098','1288023824624812033',2,2,'福建盼盼食品有限公司','13665929319','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-07-28',NULL,NULL,NULL,'2020-07-28 16:09:44',NULL,NULL,NULL),('1288079194613383169',NULL,'1288079194613383169',2,1,NULL,'18965696828','506779','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 19:49:46',NULL,NULL,NULL),('1288079728900603906',NULL,'1288079728900603906',2,1,NULL,'13808525056','175882','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 19:51:53',NULL,NULL,NULL),('1288080622736146434',NULL,'1288080622736146434',2,1,NULL,'13808525056','010898','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 19:55:26',NULL,NULL,NULL),('1288129745355046914',NULL,'1288129745355046914',2,1,NULL,'18959859775','609084','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-28',NULL,NULL,NULL,'2020-07-28 23:10:38',NULL,NULL,NULL),('1288261193709944833',NULL,'1288261193709944833',2,1,NULL,'13599719905','595544','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 07:52:57',NULL,NULL,NULL),('1288271200329433090',NULL,'1288271200329433090',2,1,NULL,'13636928198','984687','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 08:32:43',NULL,NULL,NULL),('1288275042110570498',NULL,'1288275042110570498',2,1,NULL,'13559050753','977930','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 08:47:59',NULL,NULL,NULL),('1288295602135822338',NULL,'1288295602135822338',2,1,NULL,'15859481444','734839','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 10:09:41',NULL,NULL,NULL),('1288300097163030530',NULL,'1288300097163030530',2,1,NULL,'15859481444','919239','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 10:27:33',NULL,NULL,NULL),('1288301590469472257',NULL,'1288301590469472257',2,1,NULL,'15305009255','104856','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 10:33:29',NULL,NULL,NULL),('1288302375102115841',NULL,'1288302375102115841',2,1,NULL,'18659091166','850286','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 10:36:36',NULL,NULL,NULL),('1288309548343422977',NULL,'1288309548343422977',2,1,NULL,'18959950999','073667','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 11:05:06',NULL,NULL,NULL),('1288311824428625922',NULL,'1288311824428625922',2,1,NULL,'18959950999','695041','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 11:14:09',NULL,NULL,NULL),('1288315742931972098',NULL,'1288315742931972098',2,1,NULL,'13233863311','900999','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 11:29:43',NULL,NULL,NULL),('1288341274872573953',NULL,'1288341274872573953',2,1,NULL,'18965121148','772399','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 13:11:10',NULL,NULL,NULL),('1288341735629451265',NULL,'1288341735629451265',2,1,NULL,'13400713011','463730','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 13:13:00',NULL,NULL,NULL),('1288342945249947650',NULL,'1288342945249947650',2,1,NULL,'18965121148','775619','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 13:17:49',NULL,NULL,NULL),('1288367246581755906',NULL,'1288367246581755906',2,1,NULL,'15059750761','678221','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 14:54:22',NULL,NULL,NULL),('1288368612217778178',NULL,'1288368612217778178',2,1,NULL,'15059750761','138794','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 14:59:48',NULL,NULL,NULL),('1288369178029387777',NULL,'1288369178029387777',2,1,NULL,'13960255299','906716','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 15:02:03',NULL,NULL,NULL),('1288371197637095425',NULL,'1288371197637095425',2,1,NULL,'13960255299','989317','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 15:10:04',NULL,NULL,NULL),('1288374072853458945',NULL,'1288374072853458945',2,1,NULL,'13960255299','753691','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 15:21:30',NULL,NULL,NULL),('1288375870825754625',NULL,'1288375870825754625',2,1,NULL,'13960255299','227999','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 15:28:39',NULL,NULL,NULL),('1288386799638474753',NULL,'1288386799638474753',2,1,NULL,'15960589393','989016','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 16:12:04',NULL,NULL,NULL),('1288388453481902082',NULL,'1288388453481902082',2,1,NULL,'15960589393','545440','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 16:18:39',NULL,NULL,NULL),('1288396660761751553',NULL,'1288396660761751553',2,1,NULL,'18705052323','680032','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 16:51:15',NULL,NULL,NULL),('1288397477304659970',NULL,'1288397477304659970',2,1,NULL,'13706964102','883998','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 16:54:30',NULL,NULL,NULL),('1288403880010379266',NULL,'1288403880010379266',2,1,NULL,'15160326656','270001','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 17:19:57',NULL,NULL,NULL),('1288417367096881154',NULL,'1288417367096881154',2,1,NULL,'15060997885','485351','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 18:13:32',NULL,NULL,NULL),('1288425510996590593',NULL,'1288425510996590593',2,1,NULL,'13590256583','772499','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 18:45:54',NULL,NULL,NULL),('1288425511000784898',NULL,'1288425511000784898',2,1,NULL,'13960455132','914802','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 18:45:54',NULL,NULL,NULL),('1288428511693946881',NULL,'1288428511693946881',2,1,NULL,'18217618815','341128','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 18:57:49',NULL,NULL,NULL),('1288428839499776002',NULL,'1288428839499776002',2,1,NULL,'18217618815','436508','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 18:59:07',NULL,NULL,NULL),('1288429378820161537',NULL,'1288429378820161537',2,1,NULL,'18217618815','792223','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 19:01:16',NULL,NULL,NULL),('1288430129684463618',NULL,'1288430129684463618',2,1,NULL,'15711376693','191360','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 19:04:15',NULL,NULL,NULL),('1288431198321819649',NULL,'1288431198321819649',2,1,NULL,'13159037366','905349','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-29',NULL,NULL,NULL,'2020-07-29 19:08:30',NULL,NULL,NULL),('1288628236653215746',NULL,'1288628236653215746',2,1,NULL,'13459562051','312250','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:11:27',NULL,NULL,NULL),('1288629180283535361',NULL,'1288629180283535361',2,1,NULL,'15080421696','414637','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:15:12',NULL,NULL,NULL),('1288629637252956161',NULL,'1288629637252956161',2,1,NULL,'15080421696','025236','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:17:01',NULL,NULL,NULL),('1288632901616844801','1211474926804975617','1288632901616844801',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632901964972033','1211515979058692097','1288632901964972033',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632902136938497','1211837849989595138','1288632902136938497',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632902350848002','1211920348237316098','1288632902350848002',2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632902535397377','1212935665344385025','1288632902535397377',2,2,'福建省晋江市新联兴汽车用品有限公司','13625952299','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632902749306881','1213031390673702913','1288632902749306881',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632902933856257','1214748606972649473','1288632902933856257',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632903118405634','1215115207978827777','1288632903118405634',2,2,'福州大学晋江科教园管委会','15980228632','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632903311343617','1215207699331989506','1288632903311343617',2,2,'晋江市医院','18350528526','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632903533641729','1215455507792314370','1288632903533641729',2,2,'晋江市致和社工事务所','15860517253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632903760134145','1219896525681868801','1288632903760134145',2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632903957266434','1241252588561698817','1288632903957266434',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632904166981634','1275339775733186562','1288632904166981634',2,2,'晋江市爱群社工服务中心','18259555290','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632904338948098','1275360115897188354','1288632904338948098',2,2,'晋江市图书馆','15905058965','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632904536080385','1275632103135952897','1288632904536080385',2,2,'福建省信芯长盈科技有限公司','15059788121','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632904729018369','1278496729536172034','1288632904729018369',2,2,'中国邮政储蓄银行股份有限公司晋江市支行','13959102760','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632904917762049','1280424993095716866','1288632904917762049',2,2,'晋江市掌中木偶艺术保护传承中心','13960208800','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288632905114894338','1285862298023370753','1288632905114894338',2,2,'金鹰(福建)印刷有限公司','13599937223','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:30:00',NULL,NULL,NULL),('1288637395557728258',NULL,'1288637395557728258',2,1,NULL,'13506075567','049986','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:47:51',NULL,NULL,NULL),('1288638119809171457','1288312529155584002','1288638119809171457',2,2,'晋江市信昌服装织造有限公司','18959950999','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:50:44',NULL,NULL,NULL),('1288638453516386306','1288372149664411649','1288638453516386306',2,2,'晋江市兴泰商务大酒店','13960255299','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:52:03',NULL,NULL,NULL),('1288638891368169474','1288388548977815553','1288638891368169474',2,2,'福建晋江科立无石棉摩擦材料有限公司','15960589393','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:53:48',NULL,NULL,NULL),('1288639147086495746','1288431323949613058','1288639147086495746',2,2,'泉州市荣兴丝绸材料研究院有限公司','13159037366','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 08:54:49',NULL,NULL,NULL),('1288640451447930881','70','1288640451447930881',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451447930882','58','1288640451447930882',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451510845441','72','1288640451510845441',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451867361282','83','1288640451867361282',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451867361283','87','1288640451867361283',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451913498626','58','1288640451913498626',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:00:00',NULL,NULL,NULL),('1288640452135796738','87','1288640452135796738',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:00:00',NULL,NULL,NULL),('1288645857826095106',NULL,'1288645857826095106',2,1,NULL,'15375187617','371132','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:21:29',NULL,NULL,NULL),('1288646461663264770',NULL,'1288646461663264770',2,1,NULL,'15375817617','807998','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:23:53',NULL,NULL,NULL),('1288646528692436994','1287927444887601153','1288646528692436994',2,2,'晋江市少年儿童业余体育学校','19905061916','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:24:08',NULL,NULL,NULL),('1288648479807160321',NULL,'1288648479807160321',2,1,NULL,'19905061916','260525','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:31:54',NULL,NULL,NULL),('1288649325722779649','1288646739615596545','1288649325722779649',2,2,'泉州三众工程管理有限公司','15375817617','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:35:15',NULL,NULL,NULL),('1288653170574147586',NULL,'1288653170574147586',2,1,NULL,'13960255299','256179','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:50:32',NULL,NULL,NULL),('1288653660435300353','1287927444887601153','1288653660435300353',2,2,'晋江市少年儿童业余体育学校','19905061916','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:52:29',NULL,NULL,NULL),('1288654075704950786','1287927444887601153','1288654075704950786',2,2,'晋江市少年儿童业余体育学校','19905061916','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 09:54:08',NULL,NULL,NULL),('1288661582762524673',NULL,'1288661582762524673',2,1,NULL,'17750798475','269546','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 10:23:58',NULL,NULL,NULL),('1288662600707522561',NULL,'1288662600707522561',2,1,NULL,'17750798475','103413','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 10:28:00',NULL,NULL,NULL),('1288676347031371778',NULL,'1288676347031371778',2,1,NULL,'13905059909','328070','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 11:22:38',NULL,NULL,NULL),('1288715692303994881',NULL,'1288715692303994881',2,1,NULL,'15280423942','857348','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 13:58:58',NULL,NULL,NULL),('1288721069833736194',NULL,'1288721069833736194',2,1,NULL,'15880750160','496527','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 14:20:20',NULL,NULL,NULL),('1288738693464477698',NULL,'1288738693464477698',2,1,NULL,'15880750160','531013','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 15:30:22',NULL,NULL,NULL),('1288740777307951106',NULL,'1288740777307951106',2,1,NULL,'18965121148','827272','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 15:38:39',NULL,NULL,NULL),('1288741809194815490',NULL,'1288741809194815490',2,1,NULL,'15080318773','212436','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 15:42:45',NULL,NULL,NULL),('1288743665761538050',NULL,'1288743665761538050',2,1,NULL,'13636907870','865816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 15:50:08',NULL,NULL,NULL),('1288743928484352002',NULL,'1288743928484352002',2,1,NULL,'13636907870','303195','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 15:51:10',NULL,NULL,NULL),('1288746564382117889','1288740952881516545','1288746564382117889',2,2,'泉州市双益税务师事务所有限责任公司','18965121148','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 16:01:39',NULL,NULL,NULL),('1288759361690161154',NULL,'1288759361690161154',2,1,NULL,'15559126942','562188','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 16:52:30',NULL,NULL,NULL),('1288762484173328386',NULL,'1288762484173328386',2,1,NULL,'13960255299','662115','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 17:04:54',NULL,NULL,NULL),('1288768026975424513',NULL,'1288768026975424513',2,1,NULL,'15060919536','477392','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 17:26:56',NULL,NULL,NULL),('1288768298997010433',NULL,'1288768298997010433',2,1,NULL,'18050878268','169236','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 17:28:01',NULL,NULL,NULL),('1288769555245584386',NULL,'1288769555245584386',2,1,NULL,'18050878268','496058','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 17:33:00',NULL,NULL,NULL),('1288771183050772482',NULL,'1288771183050772482',2,1,NULL,'18050878268','030652','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 17:39:28',NULL,NULL,NULL),('1288789264238174210',NULL,'1288789264238174210',2,1,NULL,'13599764353','468936','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 18:51:19',NULL,NULL,NULL),('1288802674313060353',NULL,'1288802674313060353',2,1,NULL,'13805910561','236859','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-30',NULL,NULL,NULL,'2020-07-30 19:44:37',NULL,NULL,NULL),('1288994744197767169','1288759533518213122','1288994744197767169',2,2,'福建兰峰制革有限公司','15559126942','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:27:50',NULL,NULL,NULL),('1288995016139661314','1288771257810046977','1288995016139661314',2,2,'福建省威盛机械发展有限公司','18050878268','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:28:54',NULL,NULL,NULL),('1288995289440509954','1211474926804975617','1288995289440509954',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995289817997314','1211515979058692097','1288995289817997314',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995290031906818','1211920348237316098','1288995290031906818',2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995290241622018','1213031390673702913','1288995290241622018',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995290455531521','1214748606972649473','1288995290455531521',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995290669441025','1215115207978827777','1288995290669441025',2,2,'福州大学晋江科教园管委会','15980228632','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995290958848001','1215207699331989506','1288995290958848001',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995291223089154','1241252588561698817','1288995291223089154',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995291491524610','1275360115897188354','1288995291491524610',2,2,'晋江市图书馆','15905058965','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995291692851201','1278496729536172034','1288995291692851201',2,2,'中国邮政储蓄银行股份有限公司晋江市支行','13959102760','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995291944509442','1280424993095716866','1288995291944509442',2,2,'晋江市掌中木偶艺术保护传承中心','13960208800','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1288995292150030338','1285862298023370753','1288995292150030338',2,2,'金鹰(福建)印刷有限公司','13599937223','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:30:00',NULL,NULL,NULL),('1289000077095919618',NULL,'1289000077095919618',2,1,NULL,'13506943601','885450','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:49:01',NULL,NULL,NULL),('1289000924106252290',NULL,'1289000924106252290',2,1,NULL,'18859989399','923366','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 08:52:23',NULL,NULL,NULL),('1289002839502282753','70','1289002839502282753',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839506477057','69','1289002839506477057',1,2,'陈文经','13599795023','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839514865665','72','1289002839514865665',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839946878978','70','1289002839946878978',1,2,'陈瑞清','13788864979','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839976239106','83','1289002839976239106',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002840227897345','58','1289002840227897345',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002840416641025','87','1289002840416641025',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002840857042945','71','1289002840857042945',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002841075146754','58','1289002841075146754',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289002841280667649','87','1289002841280667649',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:00:00',NULL,NULL,NULL),('1289009713576468482',NULL,'1289009713576468482',2,1,NULL,'18859989399','779570','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:27:19',NULL,NULL,NULL),('1289009826654904321',NULL,'1289009826654904321',2,1,NULL,'17362523273','247365','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:27:45',NULL,NULL,NULL),('1289011175153000449',NULL,'1289011175153000449',2,1,NULL,'18859989399','255002','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 09:33:07',NULL,NULL,NULL),('1289023799789936641',NULL,'1289023799789936641',2,1,NULL,'15260309372','099584','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 10:23:17',NULL,NULL,NULL),('1289033971572727810',NULL,'1289033971572727810',2,1,NULL,'18960219966','699942','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 11:03:42',NULL,NULL,NULL),('1289039527863705601',NULL,'1289039527863705601',2,1,NULL,'15880936557','005042','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 11:25:47',NULL,NULL,NULL),('1289039924959436801',NULL,'1289039924959436801',2,1,NULL,'15959980017','660762','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 11:27:21',NULL,NULL,NULL),('1289054779829444609',NULL,'1289054779829444609',2,1,NULL,'13960455132','404247','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 12:26:23',NULL,NULL,NULL),('1289055171183173633',NULL,'1289055171183173633',2,1,NULL,'13599158683','850362','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 12:27:56',NULL,NULL,NULL),('1289099086414274561',NULL,'1289099086414274561',2,1,NULL,'18259557079','986340','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 15:22:27',NULL,NULL,NULL),('1289099967780151297',NULL,'1289099967780151297',2,1,NULL,'18559006999','381131','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 15:25:57',NULL,NULL,NULL),('1289111789379837953',NULL,'1289111789379837953',2,1,NULL,'13600756165','596214','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 16:12:55',NULL,NULL,NULL),('1289132870241148930',NULL,'1289132870241148930',2,1,NULL,'15060997885','876261','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 17:36:41',NULL,NULL,NULL),('1289134345830850561',NULL,'1289134345830850561',2,1,NULL,'15060997885','550742','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 17:42:33',NULL,NULL,NULL),('1289135223702872066',NULL,'1289135223702872066',2,1,NULL,'15060997885','569153','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 17:46:02',NULL,NULL,NULL),('1289137927120543745',NULL,'1289137927120543745',2,1,NULL,'17350031698','600805','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 17:56:47',NULL,NULL,NULL),('1289139320258617345',NULL,'1289139320258617345',2,1,NULL,'17350031698','287420','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 18:02:19',NULL,NULL,NULL),('1289167693299073025',NULL,'1289167693299073025',2,1,NULL,'15906066156','115046','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-07-31',NULL,NULL,NULL,'2020-07-31 19:55:04',NULL,NULL,NULL),('1289370368124928002',NULL,'1289370368124928002',2,1,NULL,'18859969666','817492','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 09:20:25',NULL,NULL,NULL),('1289394385942757377',NULL,'1289394385942757377',2,1,NULL,'18609586661','291051','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 10:55:52',NULL,NULL,NULL),('1289400288142180354',NULL,'1289400288142180354',2,1,NULL,'18259591998','346477','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 11:19:19',NULL,NULL,NULL),('1289508652528451585',NULL,'1289508652528451585',2,1,NULL,'15960746554','588838','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 18:29:55',NULL,NULL,NULL),('1289524708592599041',NULL,'1289524708592599041',2,1,NULL,'15659050608','215893','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 19:33:43',NULL,NULL,NULL),('1289525018673299458',NULL,'1289525018673299458',2,1,NULL,'15659050608','116604','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 19:34:57',NULL,NULL,NULL),('1289525407430754305',NULL,'1289525407430754305',2,1,NULL,'15659050608','169213','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 19:36:30',NULL,NULL,NULL),('1289525768103149569',NULL,'1289525768103149569',2,1,NULL,'15659050608','007751','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 19:37:56',NULL,NULL,NULL),('1289536301116178434',NULL,'1289536301116178434',2,1,NULL,'15960746554','805331','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 20:19:47',NULL,NULL,NULL),('1289544654131314690',NULL,'1289544654131314690',2,1,NULL,'13808514751','432495','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 20:52:58',NULL,NULL,NULL),('1289545091903406081',NULL,'1289545091903406081',2,1,NULL,'13808514751','038260','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-01',NULL,NULL,NULL,'2020-08-01 20:54:43',NULL,NULL,NULL),('1289957635063300098',NULL,'1289957635063300098',2,1,NULL,'18350777245','629309','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 00:14:01',NULL,NULL,NULL),('1290082453049851906','1211920348237316098','1290082453049851906',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082453364424706','1213031390673702913','1290082453364424706',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082453553168385','1214748606972649473','1290082453553168385',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082453754494977','1215115207978827777','1290082453754494977',2,2,'福州大学晋江科教园管委会','15980228632','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082453934850050','1215207699331989506','1290082453934850050',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082454106816513','1219140374220627970','1290082454106816513',2,2,'福建亲亲股份有限公司','15905035025','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082454295560193','1219896525681868801','1290082454295560193',2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082454480109569','1241252588561698817','1290082454480109569',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082454656270338','1278496729536172034','1290082454656270338',2,2,'中国邮政储蓄银行股份有限公司晋江市支行','13959102760','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082454853402625','1280424993095716866','1290082454853402625',2,2,'晋江市掌中木偶艺术保护传承中心','13960208800','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290082455029563393','1285862298023370753','1290082455029563393',2,2,'金鹰(福建)印刷有限公司','13599937223','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 08:30:00',NULL,NULL,NULL),('1290090002876743682','70','1290090002876743682',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002876743683','69','1290090002876743683',1,2,'陈文经','13599795023','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002918686722','72','1290090002918686722',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090003296174082','83','1290090003296174082',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090003317145601','71','1290090003317145601',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090003317145602','70','1290090003317145602',1,2,'陈瑞清','13788864979','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090003522666497','58','1290090003522666497',1,2,'张荣荣','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090003694632961','87','1290090003694632961',1,2,'叶志钦','13675957398','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090003770130433','58','1290090003770130433',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290090003950485505','87','1290090003950485505',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:00:00',NULL,NULL,NULL),('1290100456130932738','1289134473471909889','1290100456130932738',2,2,'晋江市高新技术开发办公室','15060997885','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 09:41:32',NULL,NULL,NULL),('1290118287597805570',NULL,'1290118287597805570',2,1,NULL,'13960255299','947575','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 10:52:23',NULL,NULL,NULL),('1290127801290104833','1216626668072869889','1290127801290104833',2,2,'晋江市融媒体中心','13599718877','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 11:30:11',NULL,NULL,NULL),('1290128299007188993','1289112186135830529','1290128299007188993',2,2,'福建泉州宝辉珠宝首饰有限公司','13600756165','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 11:32:10',NULL,NULL,NULL),('1290130693757640705','1286499346338045953','1290130693757640705',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 11:41:41',NULL,NULL,NULL),('1290132299077128194','1211490953219588098','1290132299077128194',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','15980788802','【晋江市人才服务平台】您好，您在晋江市人才综合服务平台的反馈已被回复，请及时查看。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 11:48:04',NULL,NULL,NULL),('1290133212198080513','1211945767430832130','1290133212198080513',2,2,'晋江市安海医院','13860758785','13860758785','【晋江市人才服务平台】您好，您在晋江市人才综合服务平台的反馈已被回复，请及时查看。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 11:51:41',NULL,NULL,NULL),('1290170175009705985',NULL,'1290170175009705985',2,1,NULL,'13808558230','728935','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 14:18:34',NULL,NULL,NULL),('1290178663538610178','1288637929832366081','1290178663538610178',2,2,'福建省晋江文旅集团有限公司','13506075567','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 14:52:18',NULL,NULL,NULL),('1290178928828338177','1285493408407756802','1290178928828338177',2,2,'福建晋江热电有限公司','15059066119','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 14:53:21',NULL,NULL,NULL),('1290179477275529218','1289035100629032961','1290179477275529218',2,2,'中国电信股份有限公司晋江分公司','18960219966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 14:55:32',NULL,NULL,NULL),('1290200666882560001',NULL,'1290200666882560001',2,1,NULL,'13313885858','705839','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 16:19:44',NULL,NULL,NULL),('1290207188719095809',NULL,'1290207188719095809',2,1,NULL,'13860736349','790148','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 16:45:39',NULL,NULL,NULL),('1290207822809780225',NULL,'1290207822809780225',2,1,NULL,'15106000006','947002','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 16:48:10',NULL,NULL,NULL),('1290212228766748673',NULL,'1290212228766748673',2,1,NULL,'15106000006','741653','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:05:40',NULL,NULL,NULL),('1290212920516530178',NULL,'1290212920516530178',2,1,NULL,'15260853516','001199','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:08:25',NULL,NULL,NULL),('1290215506661462018',NULL,'1290215506661462018',2,1,NULL,'13506060342','808339','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:18:42',NULL,NULL,NULL),('1290215802510888961',NULL,'1290215802510888961',2,1,NULL,'18396589640','082702','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:19:53',NULL,NULL,NULL),('1290219094745927682',NULL,'1290219094745927682',2,1,NULL,'15260853516','719643','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:32:57',NULL,NULL,NULL),('1290219723350462466',NULL,'1290219723350462466',2,1,NULL,'15260853516','779887','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:35:27',NULL,NULL,NULL),('1290220725738786818',NULL,'1290220725738786818',2,1,NULL,'15260853516','050544','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:39:26',NULL,NULL,NULL),('1290221036209557506',NULL,'1290221036209557506',2,1,NULL,'13661356074','617139','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 17:40:40',NULL,NULL,NULL),('1290251193880268801',NULL,'1290251193880268801',2,1,NULL,'13505020870','592036','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 19:40:30',NULL,NULL,NULL),('1290298569433141250',NULL,'1290298569433141250',2,1,NULL,'15659790479','944063','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-03',NULL,NULL,NULL,'2020-08-03 22:48:46',NULL,NULL,NULL),('1290444840932331521','1213031390673702913','1290444840932331521',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 08:30:00',NULL,NULL,NULL),('1290444841259487233','1215115207978827777','1290444841259487233',2,2,'福州大学晋江科教园管委会','15980228632','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 08:30:00',NULL,NULL,NULL),('1290444841448230914','1215207699331989506','1290444841448230914',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 08:30:00',NULL,NULL,NULL),('1290444841636974594','1219140374220627970','1290444841636974594',2,2,'福建亲亲股份有限公司','15905035025','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 08:30:00',NULL,NULL,NULL),('1290444841821523969','1241252588561698817','1290444841821523969',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 08:30:00',NULL,NULL,NULL),('1290444842006073346','1273850390323953666','1290444842006073346',2,2,'晋江市启宁净水科技有限公司','15960777080','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 08:30:00',NULL,NULL,NULL),('1290444842199011329','1287927444887601153','1290444842199011329',2,2,'晋江市少年儿童业余体育学校','19905061916','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 08:30:00',NULL,NULL,NULL),('1290452390843109377','71','1290452390843109377',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 09:00:00',NULL,NULL,NULL),('1290452390847303681','58','1290452390847303681',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 09:00:00',NULL,NULL,NULL),('1290452391262539777','58','1290452391262539777',1,2,'张荣荣','15280619456','11,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 09:00:00',NULL,NULL,NULL),('1290452391266734081','87','1290452391266734081',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 09:00:00',NULL,NULL,NULL),('1290452391468060674','87','1290452391468060674',1,2,'叶志钦','13675957398','11,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 09:00:00',NULL,NULL,NULL),('1290452955765526530','1288662402170142722','1290452955765526530',2,2,'晋江市阳光家庭关爱服务中心','17750798475','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 09:02:14',NULL,NULL,NULL),('1290454697974550529',NULL,'1290454697974550529',2,1,NULL,'17750798475','323810','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 09:09:10',NULL,NULL,NULL),('1290471950833012738','1215568298586980354','1290471950833012738',2,2,'福建永恒能源管理有限公司','19959813350','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 10:17:43',NULL,NULL,NULL),('1290477889090867202','1215568298586980354','1290477889090867202',2,2,'福建永恒能源管理有限公司','19959813350','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 10:41:19',NULL,NULL,NULL),('1290481044822282242','1290207451647430657','1290481044822282242',2,2,'晋江国盛新材料科技有限公司','13860736349','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 10:53:51',NULL,NULL,NULL),('1290484889719787521','1290207451647430657','1290484889719787521',2,2,'晋江国盛新材料科技有限公司','13860736349','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 11:09:08',NULL,NULL,NULL),('1290486498130513922','1290213066868379649','1290486498130513922',2,2,'泉州耀东塑业有限公司','15106000006','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 11:15:31',NULL,NULL,NULL),('1290487161862344705','1290215873327517697','1290487161862344705',2,2,'晋江市欣欣织造有限公司','18396589640','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 11:18:10',NULL,NULL,NULL),('1290487345056960513','1290251429117808642','1290487345056960513',2,2,'泉州浙平国木雕工艺品有限公司','13505020870','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 11:18:53',NULL,NULL,NULL),('1290492555141697537','1290219135275487234','1290492555141697537',2,2,'泉州银行股份有限公司晋江支行','15260853516','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 11:39:35',NULL,NULL,NULL),('1290494975167025154',NULL,'1290494975167025154',2,1,NULL,'13599778158','208427','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 11:49:12',NULL,NULL,NULL),('1290561833610018818',NULL,'1290561833610018818',2,1,NULL,'15160328352','022289','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 16:14:53',NULL,NULL,NULL),('1290588240918642690','1290495759225049090','1290588240918642690',2,2,'晋江市石达塑胶精细有限公司','13599778158','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 17:59:49',NULL,NULL,NULL),('1290589177678692353',NULL,'1290589177678692353',2,1,NULL,'15260225737','767428','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-04',NULL,NULL,NULL,'2020-08-04 18:03:32',NULL,NULL,NULL),('1290807228806234114','1211505228151570433','1290807228806234114',2,2,'晋江市陈埭中心卫生院','13905972257','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290807229150167042','1213031390673702913','1290807229150167042',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290807229334716417','1215115207978827777','1290807229334716417',2,2,'福州大学晋江科教园管委会','15980228632','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290807229506682882','1215207699331989506','1290807229506682882',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290807229712203777','1219140374220627970','1290807229712203777',2,2,'福建亲亲股份有限公司','15905035025','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290807229930307585','1241252588561698817','1290807229930307585',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290807230127439874','1278496729536172034','1290807230127439874',2,2,'中国邮政储蓄银行股份有限公司晋江市支行','13959102760','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290807230353932289','1287927444887601153','1290807230353932289',2,2,'晋江市少年儿童业余体育学校','19905061916','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 08:30:00',NULL,NULL,NULL),('1290814778578599938','83','1290814778578599938',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 09:00:00',NULL,NULL,NULL),('1290849919472533505',NULL,'1290849919472533505',2,1,NULL,'15606088075','931140','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 11:19:38',NULL,NULL,NULL),('1290851560380727297',NULL,'1290851560380727297',2,1,NULL,'15160775562','149881','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 11:26:09',NULL,NULL,NULL),('1290851765930983425',NULL,'1290851765930983425',2,1,NULL,'15160775562','527169','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-05',NULL,NULL,NULL,'2020-08-05 11:26:58',NULL,NULL,NULL),('1291149616217133057',NULL,'1291149616217133057',2,1,NULL,'15059570222','534907','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 07:10:31',NULL,NULL,NULL),('1291169616629927938','1211515979058692097','1291169616629927938',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169616986443778','1211554636561956866','1291169616986443778',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169617229713410','1211920348237316098','1291169617229713410',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169617443622914','1212685717864517633','1291169617443622914',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169617678503938','1212906675946721282','1291169617678503938',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169617888219138','1213031390673702913','1291169617888219138',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169618135683074','1215115207978827777','1291169618135683074',2,2,'福州大学晋江科教园管委会','15980228632','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169618324426753','1215207699331989506','1291169618324426753',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169618550919170','1241252588561698817','1291169618550919170',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169618752245761','1273850390323953666','1291169618752245761',2,2,'晋江市启宁净水科技有限公司','15960777080','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291169618949378049','1289134473471909889','1291169618949378049',2,2,'晋江市高新技术开发办公室','15060997885','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 08:30:00',NULL,NULL,NULL),('1291177166502957057','83','1291177166502957057',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 09:00:00',NULL,NULL,NULL),('1291177166586843137','58','1291177166586843137',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 09:00:00',NULL,NULL,NULL),('1291177166624591874','58','1291177166624591874',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 09:00:00',NULL,NULL,NULL),('1291177166960136193','87','1291177166960136193',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 09:00:00',NULL,NULL,NULL),('1291177167002079234','87','1291177167002079234',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 09:00:00',NULL,NULL,NULL),('1291189316873162754',NULL,'1291189316873162754',2,1,NULL,'18759762083','099718','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 09:48:16',NULL,NULL,NULL),('1291192141703352321',NULL,'1291192141703352321',2,1,NULL,'18659518160','668886','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 09:59:30',NULL,NULL,NULL),('1291197615672725506',NULL,'1291197615672725506',2,1,NULL,'18859951871','689981','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 10:21:15',NULL,NULL,NULL),('1291246786714800130',NULL,'1291246786714800130',2,1,NULL,'15260225737','394722','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 13:36:38',NULL,NULL,NULL),('1291247361489637378',NULL,'1291247361489637378',2,1,NULL,'15659991725','180352','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 13:38:55',NULL,NULL,NULL),('1291273828000862209',NULL,'1291273828000862209',2,1,NULL,'18659597668','027715','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 15:24:05',NULL,NULL,NULL),('1291283909362847746',NULL,'1291283909362847746',2,1,NULL,'18250085177','965264','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-06',NULL,NULL,NULL,'2020-08-06 16:04:09',NULL,NULL,NULL),('1291532004541599746','1211515979058692097','1291532004541599746',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532004877144065','1211554636561956866','1291532004877144065',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532005061693441','1211920348237316098','1291532005061693441',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532005258825729','1212685717864517633','1291532005258825729',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532005447569409','1212906675946721282','1291532005447569409',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532005653090306','1213031390673702913','1291532005653090306',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532005892165633','1215115207978827777','1291532005892165633',2,2,'福州大学晋江科教园管委会','15980228632','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532006080909313','1215207699331989506','1291532006080909313',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532006257070082','1241252588561698817','1291532006257070082',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291532006445813761','1289134473471909889','1291532006445813761',2,2,'晋江市高新技术开发办公室','15060997885','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 08:30:00',NULL,NULL,NULL),('1291539554309771265','58','1291539554309771265',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554309771266','58','1291539554309771266',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554309771267','83','1291539554309771267',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554729201665','87','1291539554729201665',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554745978881','87','1291539554745978881',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 09:00:00',NULL,NULL,NULL),('1291572441620942849',NULL,'1291572441620942849',2,1,NULL,'18759552098','603838','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 11:10:40',NULL,NULL,NULL),('1291580303533412353',NULL,'1291580303533412353',2,1,NULL,'18815980687','116098','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 11:41:55',NULL,NULL,NULL),('1291601728541593602',NULL,'1291601728541593602',2,1,NULL,'15805079676','754759','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 13:07:03',NULL,NULL,NULL),('1291608150486585345',NULL,'1291608150486585345',2,1,NULL,'13505900864','189588','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 13:32:34',NULL,NULL,NULL),('1291646173886582786','1274941001584091137','1291646173886582786',2,2,'福建佳汇律师事务所','13275085383','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 16:03:40',NULL,NULL,NULL),('1291679718352990210',NULL,'1291679718352990210',2,1,NULL,'13906095080','112801','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 18:16:57',NULL,NULL,NULL),('1291681422851026945',NULL,'1291681422851026945',2,1,NULL,'15860362000','534644','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-07',NULL,NULL,NULL,'2020-08-07 18:23:44',NULL,NULL,NULL),('1291911922303741954',NULL,'1291911922303741954',2,1,NULL,'13808507662','608564','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-08',NULL,NULL,NULL,'2020-08-08 09:39:39',NULL,NULL,NULL),('1292077637363150850',NULL,'1292077637363150850',2,1,NULL,'15860499339','395820','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-08',NULL,NULL,NULL,'2020-08-08 20:38:09',NULL,NULL,NULL),('1292292536391544834',NULL,'1292292536391544834',2,1,NULL,'13600765632','593949','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 10:52:04',NULL,NULL,NULL),('1292378669704130562',NULL,'1292378669704130562',2,1,NULL,'13599100426','109575','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 16:34:20',NULL,NULL,NULL),('1292379006850674689',NULL,'1292379006850674689',2,1,NULL,'13505053023','854245','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 16:35:41',NULL,NULL,NULL),('1292380775949381634',NULL,'1292380775949381634',2,1,NULL,'13599100426','445776','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 16:42:42',NULL,NULL,NULL),('1292387577361444866',NULL,'1292387577361444866',2,1,NULL,'13599100426','876243','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 17:09:44',NULL,NULL,NULL),('1292390508043284481',NULL,'1292390508043284481',2,1,NULL,'13599100426','010718','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 17:21:23',NULL,NULL,NULL),('1292393082112815105',NULL,'1292393082112815105',2,1,NULL,'13599100426','279332','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 17:31:36',NULL,NULL,NULL),('1292438877860114434',NULL,'1292438877860114434',2,1,NULL,'13237076821','085651','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-09',NULL,NULL,NULL,'2020-08-09 20:33:35',NULL,NULL,NULL),('1292626717952815106','1211920348237316098','1292626717952815106',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718305136642','58','1292626718305136642',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718305136643','83','1292626718305136643',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718347079682','58','1292626718347079682',1,2,'张荣荣','15280619456','11,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718456131585','1212685717864517633','1292626718456131585',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718703595521','1212906675946721282','1292626718703595521',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718779092994','87','1292626718779092994',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718787481602','87','1292626718787481602',1,2,'叶志钦','13675957398','11,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718909116418','1213031390673702913','1292626718909116418',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626719148191745','1215207699331989506','1292626719148191745',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626719328546817','1241252588561698817','1292626719328546817',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292626719546650626','1289134473471909889','1292626719546650626',2,2,'晋江市高新技术开发办公室','15060997885','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:00:00',NULL,NULL,NULL),('1292641480346808321','1212943836112818177','1292641480346808321',2,2,'晋江中纺标检测有限公司','15375873767','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 09:58:39',NULL,NULL,NULL),('1292651478091149314','1291247414321090561','1292651478091149314',2,2,'秋山有限公司','15659991725','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 10:38:23',NULL,NULL,NULL),('1292652880343445505','1291608243923095553','1292652880343445505',2,2,'福建意乐焙宝生物科技有限公司','13505900864','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 10:43:57',NULL,NULL,NULL),('1292655206747713538','1291682260298346498','1292655206747713538',2,2,'泉州东杰进出口贸易有限公司','15860362000','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 10:53:12',NULL,NULL,NULL),('1292658235366551554','1292292908438892546','1292658235366551554',2,2,'福建省晋江市励精汽配有限公司','13600765632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 11:05:14',NULL,NULL,NULL),('1292658890244206594','1292393167542398977','1292658890244206594',2,2,'福建省宝球建材有限公司','13599100426','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 11:07:50',NULL,NULL,NULL),('1292665606549647361',NULL,'1292665606549647361',2,1,NULL,'18859575388','115895','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 11:34:31',NULL,NULL,NULL),('1292740573362499585',NULL,'1292740573362499585',2,1,NULL,'18559595923','428052','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 16:32:25',NULL,NULL,NULL),('1292743166662914049','1285862298023370753','1292743166662914049',2,2,'金鹰(福建)印刷有限公司','13599937223','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 16:42:43',NULL,NULL,NULL),('1292753870908403713',NULL,'1292753870908403713',2,1,NULL,'13506095562','799016','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 17:25:15',NULL,NULL,NULL),('1292754209581674498',NULL,'1292754209581674498',2,1,NULL,'13506095562','714582','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 17:26:36',NULL,NULL,NULL),('1292754463202848769',NULL,'1292754463202848769',2,1,NULL,'13506095562','112311','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 17:27:36',NULL,NULL,NULL),('1292771366189248514',NULL,'1292771366189248514',2,1,NULL,'18259068085','959849','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 18:34:46',NULL,NULL,NULL),('1292771831362727937',NULL,'1292771831362727937',2,1,NULL,'18259068085','018078','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 18:36:37',NULL,NULL,NULL),('1292773582463676417',NULL,'1292773582463676417',2,1,NULL,'18259068085','705617','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 18:43:35',NULL,NULL,NULL),('1292783467842613249',NULL,'1292783467842613249',2,1,NULL,'18065292010','369442','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-10',NULL,NULL,NULL,'2020-08-10 19:22:52',NULL,NULL,NULL),('1293013255219949570',NULL,'1293013255219949570',2,1,NULL,'18760035217','727192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 10:35:57',NULL,NULL,NULL),('1293013549379072001',NULL,'1293013549379072001',2,1,NULL,'18760035217','633286','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 10:37:07',NULL,NULL,NULL),('1293013824919678978',NULL,'1293013824919678978',2,1,NULL,'13123022370','302621','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 10:38:13',NULL,NULL,NULL),('1293015949007499265',NULL,'1293015949007499265',2,1,NULL,'18760035217','347153','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 10:46:39',NULL,NULL,NULL),('1293077040722911233',NULL,'1293077040722911233',2,1,NULL,'18065525518','853562','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 14:49:25',NULL,NULL,NULL),('1293077408072638466',NULL,'1293077408072638466',2,1,NULL,'18065525518','697917','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 14:50:52',NULL,NULL,NULL),('1293100483178700801',NULL,'1293100483178700801',2,1,NULL,'13860798768','007128','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 16:22:34',NULL,NULL,NULL),('1293101441061265410',NULL,'1293101441061265410',2,1,NULL,'13860798768','253981','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 16:26:22',NULL,NULL,NULL),('1293104184320630786',NULL,'1293104184320630786',2,1,NULL,'13860798768','475110','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 16:37:16',NULL,NULL,NULL),('1293142448175882241',NULL,'1293142448175882241',2,1,NULL,'13030981560','982172','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 19:09:19',NULL,NULL,NULL),('1293142822337159169',NULL,'1293142822337159169',2,1,NULL,'13030981560','166720','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 19:10:48',NULL,NULL,NULL),('1293143410961588226',NULL,'1293143410961588226',2,1,NULL,'13030981560','479272','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 19:13:09',NULL,NULL,NULL),('1293164884162289665',NULL,'1293164884162289665',2,1,NULL,'18906999238','492134','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 20:38:28',NULL,NULL,NULL),('1293165264388530178',NULL,'1293165264388530178',2,1,NULL,'18906999238','732927','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 20:39:59',NULL,NULL,NULL),('1293165548254830593',NULL,'1293165548254830593',2,1,NULL,'18906999238','170446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-11',NULL,NULL,NULL,'2020-08-11 20:41:07',NULL,NULL,NULL),('1293342218282622977',NULL,'1293342218282622977',2,1,NULL,'15905006169','178519','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-12',NULL,NULL,NULL,'2020-08-12 08:23:08',NULL,NULL,NULL),('1293342504875220994',NULL,'1293342504875220994',2,1,NULL,'15905006169','090161','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-12',NULL,NULL,NULL,'2020-08-12 08:24:16',NULL,NULL,NULL),('1293342789236449281',NULL,'1293342789236449281',2,1,NULL,'15905006169','892814','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-12',NULL,NULL,NULL,'2020-08-12 08:25:24',NULL,NULL,NULL),('1293345006567841793','1292665965330411521','1293345006567841793',2,2,'泉州市新丝路电子商务有限公司','18859575388','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-08-12',NULL,NULL,NULL,'2020-08-12 08:34:13',NULL,NULL,NULL),('1293346290154889218',NULL,'1293346290154889218',2,1,NULL,'15905006169','063521','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-12',NULL,NULL,NULL,'2020-08-12 08:39:19',NULL,NULL,NULL),('1293365448141725698',NULL,'1293365448141725698',2,1,NULL,'17362523273','654077','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2020-08-12',NULL,NULL,NULL,'2020-08-12 09:55:27',NULL,NULL,NULL),('1293367794708013057','1290215873327517697','1293367794708013057',2,2,'晋江市凤竹欣欣织造有限公司','18396589640','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 10:04:46',NULL,NULL,NULL),('1293371388425428993',NULL,'1293371388022775810',2,2,'批量发送(测试20200812)','17362523273','17362523273','【晋江市人才服务平台】测试',3,'短信发送成功','2020-08-12 10:19:03',NULL,NULL,NULL,'2020-08-12 10:19:03',NULL,NULL,NULL),('1293374577417674754',NULL,'1293374577145044993',2,2,'批量发送(异常提醒20200812)','15980436266','15980436266','【晋江市人才服务平台】您好,系统观察到您多次发送短信未成功，是由于服务器网络导致。请您再次前往申报平台进行短信验证，给您带来的不变请见谅。',3,'短信发送成功','2020-08-12 10:31:43',NULL,NULL,NULL,'2020-08-12 10:31:43',NULL,NULL,NULL),('1293374693759279106',NULL,'1293374693759279106',2,1,NULL,'15980436266','988416','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 10:32:11',NULL,NULL,NULL),('1293377883762352129',NULL,'1293377883762352129',2,1,NULL,'18059985303','724098','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 10:44:51',NULL,NULL,NULL),('1293378451285237762',NULL,'1293378451285237762',2,1,NULL,'15285859168','614756','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',2,'常见原因是：关机，停机，不在服务区；在少数情况下，号码正常通信，是由于地区屏蔽导致。','2020-08-12',NULL,NULL,NULL,'2020-08-12 10:47:07',NULL,NULL,NULL),('1293379050244431874',NULL,'1293379050244431874',2,1,NULL,'15280859168','385396','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 10:49:30',NULL,NULL,NULL),('1293379460950679553',NULL,'1293379460950679553',2,1,NULL,'15280859168','557256','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 10:51:07',NULL,NULL,NULL),('1293380740716716033',NULL,'1293380740716716033',2,1,NULL,'15280859168','227868','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 10:56:13',NULL,NULL,NULL),('1293385328043778049',NULL,'1293385328043778049',2,1,NULL,'18059985303','289607','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 11:14:26',NULL,NULL,NULL),('1293390580830724097',NULL,'1293390580830724097',2,1,NULL,'15980436266','072327','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 11:35:19',NULL,NULL,NULL),('1293425931783790593',NULL,'1293425931783790593',2,1,NULL,'13506095562','230600','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 13:55:47',NULL,NULL,NULL),('1293433290589495297',NULL,'1293433290589495297',2,1,NULL,'15280217202','668392','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 14:25:01',NULL,NULL,NULL),('1293434630933864450',NULL,'1293434630933864450',2,1,NULL,'15280217202','370246','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 14:30:21',NULL,NULL,NULL),('1293434791147888641',NULL,'1293434791147888641',2,1,NULL,'15280859168','853388','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 14:30:59',NULL,NULL,NULL),('1293436062206550018',NULL,'1293436062206550018',2,1,NULL,'15280217202','883337','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 14:36:02',NULL,NULL,NULL),('1293441708310159362',NULL,'1293441708310159362',2,1,NULL,'15280859168','257406','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 14:58:28',NULL,NULL,NULL),('1293475363468369921',NULL,'1293475363468369921',2,1,NULL,'13506086731','968125','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 17:12:12',NULL,NULL,NULL),('1293477111117406210',NULL,'1293477111117406210',2,1,NULL,'13506086731','996186','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 17:19:09',NULL,NULL,NULL),('1293478409107693569','1293477192008753154','1293478409107693569',2,2,'福建省众腾职业篮球俱乐部有限公司','13506086731','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 17:24:19',NULL,NULL,NULL),('1293488737581293570','1289515572505100289','1293488737581293570',2,2,'福建佶龙机械科技股份有限公司','15960791997','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 18:05:21',NULL,NULL,NULL),('1293490148343832578','1288296914273497089','1293490148343832578',2,2,'泉州星城纸业有限公司','15959856777','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 18:10:57',NULL,NULL,NULL),('1293493662411415554','1284401308073205762','1293493662411415554',2,2,'福建晋工机械有限公司','13799553654','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 18:24:55',NULL,NULL,NULL),('1293493995959246850','1284403731059712001','1293493995959246850',2,2,'福建晋工机械有限公司','13799553654','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 18:26:15',NULL,NULL,NULL),('1293495218347204610','1285763185265090562','1293495218347204610',2,2,'福建省劲牛重工发展有限公司','18016585576','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 18:31:06',NULL,NULL,NULL),('1293502972038242305','1292993923203051521','1293502972038242305',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:01:55',NULL,NULL,NULL),('1293503725486235649','1292999807597654017','1293503725486235649',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:04:54',NULL,NULL,NULL),('1293503984648085506','1293000867670241281','1293503984648085506',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:05:56',NULL,NULL,NULL),('1293504103032315905','1293001672687202306','1293504103032315905',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:06:24',NULL,NULL,NULL),('1293504218920935425','1293002050304585729','1293504218920935425',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:06:52',NULL,NULL,NULL),('1293504331772878850','1293002383919525890','1293504331772878850',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:07:19',NULL,NULL,NULL),('1293504831775858689','1293002646793334786','1293504831775858689',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:09:18',NULL,NULL,NULL),('1293504938743193602','1293003473650036738','1293504938743193602',2,2,'晋江市安海医院','13860758785','层次变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:09:44',NULL,NULL,NULL),('1293509812998397953',NULL,'1293509812998397953',2,1,NULL,'18906999238','418373','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-12',NULL,NULL,NULL,'2020-08-12 19:29:06',NULL,NULL,NULL),('1293717027852148737',NULL,'1293717027852148737',2,1,NULL,'13489848301','148276','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-13',NULL,NULL,NULL,'2020-08-13 09:12:30',NULL,NULL,NULL),('1293731567205638146',NULL,'1293731567205638146',2,1,NULL,'15905984868','323780','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-13',NULL,NULL,NULL,'2020-08-13 10:10:16',NULL,NULL,NULL),('1293819929220349953','1293436329887031297','1293819929220349953',2,2,'晋江宝龙大酒店有限公司','15280217202','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-13 16:01:23',NULL,NULL,NULL,'2020-08-13 16:01:23',NULL,NULL,NULL),('1293820234716676097','1293391727398248450','1293820234716676097',2,2,'泉州诚达交通技术服务有限公司','15980436266','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-13 16:02:36',NULL,NULL,NULL,'2020-08-13 16:02:36',NULL,NULL,NULL),('1293820600644534274','1290850604855361537','1293820600644534274',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-13 16:04:03',NULL,NULL,NULL,'2020-08-13 16:04:03',NULL,NULL,NULL),('1293821446753091585','1291680726785306626','1293821446753091585',2,2,'晋江国泰皮革有限公司','13906095080','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-13 16:07:25',NULL,NULL,NULL,'2020-08-13 16:07:25',NULL,NULL,NULL),('1293821736160067585','1281532581099200514','1293821736160067585',2,2,'福建省晋南建设集团有限公司','13107870056','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-13 16:08:34',NULL,NULL,NULL,'2020-08-13 16:08:34',NULL,NULL,NULL),('1293822052590944258','1249630370077442050','1293822052590944258',2,2,'晋江市凯嘉机器制造有限公司','18859987377','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-13 16:09:50',NULL,NULL,NULL,'2020-08-13 16:09:50',NULL,NULL,NULL),('1293822164796964866','1211128473930805250','1293822164796964866',2,2,'福建晋江凤竹鞋业发展有限公司','13959957107','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-13 16:10:16',NULL,NULL,NULL,'2020-08-13 16:10:16',NULL,NULL,NULL),('1293846103686381569',NULL,'1293846103686381569',2,1,NULL,'15260779889','897510','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-13 17:45:24',NULL,NULL,NULL,'2020-08-13 17:45:24',NULL,NULL,NULL),('1293847512733450242',NULL,'1293847512733450242',2,1,NULL,'15260779889','514729','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-13 17:51:00',NULL,NULL,NULL,'2020-08-13 17:51:00',NULL,NULL,NULL),('1293848880680534018',NULL,'1293848880680534018',2,1,NULL,'15260779889','843996','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-13 17:56:26',NULL,NULL,NULL,'2020-08-13 17:56:26',NULL,NULL,NULL),('1293900394040131586',NULL,'1293900394040131586',2,1,NULL,'13960251965','416907','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-13 21:21:08',NULL,NULL,NULL,'2020-08-13 21:21:08',NULL,NULL,NULL),('1294076837957206018',NULL,'1294076837957206018',2,1,NULL,'15905071236','900708','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-14 09:02:15',NULL,NULL,NULL,'2020-08-14 09:02:15',NULL,NULL,NULL),('1294091962072170497','1211456215943528450','1294091962072170497',2,2,'福建泉成机械有限公司','15392286115','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 10:02:21',NULL,NULL,NULL,'2020-08-14 10:02:21',NULL,NULL,NULL),('1294091962474823682','1211568776709980162','1294091962474823682',2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 10:02:21',NULL,NULL,NULL,'2020-08-14 10:02:21',NULL,NULL,NULL),('1294091962684538882','1214796116982325250','1294091962684538882',2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 10:02:21',NULL,NULL,NULL,'2020-08-14 10:02:21',NULL,NULL,NULL),('1294091962894254081','1219178348228501506','1294091962894254081',2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 10:02:21',NULL,NULL,NULL,'2020-08-14 10:02:21',NULL,NULL,NULL),('1294099849884467202',NULL,'1294099849884467202',2,1,NULL,'13960372915','762430','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-14 10:33:42',NULL,NULL,NULL,'2020-08-14 10:33:42',NULL,NULL,NULL),('1294124839509950465','1211459042799566850','1294124839509950465',2,2,'福建省晋江市三力机车有限公司','18965689935','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 12:13:00',NULL,NULL,NULL,'2020-08-14 12:13:00',NULL,NULL,NULL),('1294124840579497986','1211486447580790785','1294124840579497986',2,2,'福建省劲牛重工发展有限公司','18016585576','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 12:13:00',NULL,NULL,NULL,'2020-08-14 12:13:00',NULL,NULL,NULL),('1294124840831156225','1211489025517469698','1294124840831156225',2,2,'泉州星城纸业有限公司','15959856777','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 12:13:00',NULL,NULL,NULL,'2020-08-14 12:13:00',NULL,NULL,NULL),('1294124841024094210','1211515979058692097','1294124841024094210',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-14 12:13:00',NULL,NULL,NULL,'2020-08-14 12:13:00',NULL,NULL,NULL),('1294171541340160001','1211548619757371393','1294171541340160001',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-14 15:18:34',NULL,NULL,NULL,'2020-08-14 15:18:34',NULL,NULL,NULL),('1294444267787255810',NULL,'1294444267787255810',2,1,NULL,'13960455132','572450','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-15 09:22:17',NULL,NULL,NULL,'2020-08-15 09:22:17',NULL,NULL,NULL),('1294450390191833090',NULL,'1294450390191833090',2,1,NULL,'13960455132','696768','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-15 09:46:37',NULL,NULL,NULL,'2020-08-15 09:46:37',NULL,NULL,NULL),('1294530301761945602',NULL,'1294530301761945602',2,1,NULL,'15260225737','173753','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-15 15:04:09',NULL,NULL,NULL,'2020-08-15 15:04:09',NULL,NULL,NULL),('1295163433104179201','1211454669394591746','1295163433104179201',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433204842497','1211456215943528450','1295163433204842497',2,2,'福建泉成机械有限公司','15392286115','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433271951362','1211486447580790785','1295163433271951362',2,2,'福建省劲牛重工发展有限公司','18016585576','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433406169090','1211444027140915202','1295163433406169090',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433448112129','1211100599215566849','1295163433448112129',2,2,'劲派经编科技有限公司','15859799211','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433594912770','1211920348237316098','1295163433594912770',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433594912771','1219178348228501506','1295163433594912771',2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433687187457','1211489025517469698','1295163433687187457',2,2,'泉州星城纸业有限公司','15959856777','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433762684930','1211444027140915202','1295163433762684930',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433833988098','1212685717864517633','1295163433833988098',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433909485569','1211515979058692097','1295163433909485569',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433934651393','58','1295163433934651393',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433964011522','83','1295163433964011522',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434001760257','72','1295163434001760257',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434169532418','1212906675946721282','1295163434169532418',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434349887490','58','1295163434349887490',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434370859010','1213031390673702913','1295163434370859010',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434496688130','87','1295163434496688130',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434572185602','87','1295163434572185602',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434580574209','1215207699331989506','1295163434580574209',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434773512193','1218097536540147714','1295163434773512193',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163434953867266','1219241646047223809','1295163434953867266',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163435134222337','1241252588561698817','1295163435134222337',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163435331354625','1273850390323953666','1295163435331354625',2,2,'晋江市启宁净水科技有限公司','15960777080','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163435511709698','1275260777149808641','1295163435511709698',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163435683676161','1287927444887601153','1295163435683676161',2,2,'晋江市少年儿童业余体育学校','19905061916','13,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163435872419841','1288662402170142722','1295163435872419841',2,2,'晋江市阳光家庭关爱服务中心','17750798475','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163436065357826','1289112186135830529','1295163436065357826',2,2,'福建泉州宝辉珠宝首饰有限公司','13600756165','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163436245712898','1289134473471909889','1295163436245712898',2,2,'晋江市高新技术开发办公室','15060997885','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295163436430262274','1291608243923095553','1295163436430262274',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-17 09:00:00',NULL,NULL,NULL,'2020-08-17 09:00:00',NULL,NULL,NULL),('1295170496643465217','1219140374220627970','1295170496643465217',2,2,'福建亲亲股份有限公司','15960735252','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-17 09:28:04',NULL,NULL,NULL,'2020-08-17 09:28:04',NULL,NULL,NULL),('1295176286666227714','1291680726785306626','1295176286666227714',2,2,'晋江国泰皮革有限公司','13906095080','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-17 09:51:04',NULL,NULL,NULL,'2020-08-17 09:51:04',NULL,NULL,NULL),('1295525820705538049','1211444027140915202','1295525820705538049',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525820743286785','1211454669394591746','1295525820743286785',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525820760064001','1211100599215566849','1295525820760064001',2,2,'劲派经编科技有限公司','15859799211','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525820776841218','1211515979058692097','1295525820776841218',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525820806201346','1211456215943528450','1295525820806201346',2,2,'福建泉成机械有限公司','15392286115','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821074636802','78','1295525821074636802',1,2,'李真珠','18259597575','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821091414017','58','1295525821091414017',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821112385538','72','1295525821112385538',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821192077313','1211444027140915202','1295525821192077313',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821196271617','1211490446086291458','1295525821196271617',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821208854529','1211925547903401986','1295525821208854529',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821410181122','1212198922987048961','1295525821410181122',2,2,'晋江市远祥服装织造有限公司','17759990690','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821418569730','1211920348237316098','1295525821418569730',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821485678594','58','1295525821485678594',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821489872897','87','1295525821489872897',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821502455809','83','1295525821502455809',1,2,'李女元','15359825666','10,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821611507713','1212540446794911745','1295525821611507713',2,2,'晋江七匹狼服装制造有限公司','13788808205','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821645062145','1212580494957416450','1295525821645062145',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821812834306','1214461743938473985','1295525821812834306',2,2,'福建七匹狼集团有限公司','13859769696','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821838000129','1212685717864517633','1295525821838000129',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821959634946','87','1295525821959634946',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822005772290','1219178348228501506','1295525822005772290',2,2,'晋江海西职业培训中心','15259513222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822005772291','1212906675946721282','1295525822005772291',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822207098881','1213031390673702913','1295525822207098881',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822207098882','1219192562749923330','1295525822207098882',2,2,'晋江市永和镇马坪村金马汽修厂','13599773033','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822412619778','1215115207978827777','1295525822412619778',2,2,'福州大学晋江科教园管委会','15980228632','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822597169154','1215207699331989506','1295525822597169154',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822773329922','1215608523329683457','1295525822773329922',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525822999822337','1219241646047223809','1295525822999822337',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525823184371714','1219896525681868801','1295525823184371714',2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525823373115394','1241252588561698817','1295525823373115394',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525823549276162','1275260777149808641','1295525823549276162',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525823721242626','1281834150738911234','1295525823721242626',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525823909986305','1287927444887601153','1295525823909986305',2,2,'晋江市少年儿童业余体育学校','19905061916','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525824102924290','1288662402170142722','1295525824102924290',2,2,'晋江市阳光家庭关爱服务中心','17750798475','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525824279085058','1289134473471909889','1295525824279085058',2,2,'晋江市高新技术开发办公室','15060997885','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525824459440130','1291608243923095553','1295525824459440130',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295525824685932545','1291682260298346498','1295525824685932545',2,2,'泉州东杰进出口贸易有限公司','15860362000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-18 09:00:00',NULL,NULL,NULL,'2020-08-18 09:00:00',NULL,NULL,NULL),('1295549946287620098',NULL,'1295549946287620098',2,1,NULL,'13960232793','924399','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-18 10:35:52',NULL,NULL,NULL,'2020-08-18 10:35:52',NULL,NULL,NULL),('1295635912302002177',NULL,'1295635912302002177',2,1,NULL,'15905006169','541335','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-18 16:17:27',NULL,NULL,NULL,'2020-08-18 16:17:27',NULL,NULL,NULL),('1295639833179324417',NULL,'1295639833179324417',2,1,NULL,'13799233113','266484','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-18 16:33:02',NULL,NULL,NULL,'2020-08-18 16:33:02',NULL,NULL,NULL),('1295640861186457602',NULL,'1295640861186457602',2,1,NULL,'13799233113','356002','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-18 16:37:07',NULL,NULL,NULL,'2020-08-18 16:37:07',NULL,NULL,NULL),('1295644101642813441',NULL,'1295644101642813441',2,1,NULL,'13489767598','769511','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-18 16:50:00',NULL,NULL,NULL,'2020-08-18 16:50:00',NULL,NULL,NULL),('1295888208634052609','1211444027140915202','1295888208634052609',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208671801345','1211444027140915202','1295888208671801345',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208684384257','1211490446086291458','1295888208684384257',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208701161474','1211515979058692097','1295888208701161474',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208722132994','1210918631014248450','1295888208722132994',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208986374145','78','1295888208986374145',1,2,'李真珠','18259597575','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208990568449','72','1295888208990568449',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208998957057','58','1295888208998957057',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209116397569','1211505228151570433','1295888209116397569',2,2,'晋江市陈埭中心卫生院','13905972257','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209221255170','1211456215943528450','1295888209221255170',2,2,'福建泉成机械有限公司','15392286115','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209313529858','1211920348237316098','1295888209313529858',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209334501377','58','1295888209334501377',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209342889985','83','1295888209342889985',1,2,'李女元','15359825666','10,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209397415938','87','1295888209397415938',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209401610241','1211815946042261505','1295888209401610241',2,2,'泉州市陶源环保科技有限公司','13666026522','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209481302018','87','1295888209481302018',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209514856450','1211927486787534850','1295888209514856450',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209615519745','1211832959498240001','1295888209615519745',2,2,'晋江市南港污水处理有限公司','18350062033','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209670045697','1212685717864517633','1295888209670045697',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209800069121','1211925547903401986','1295888209800069121',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888209879760898','1212906675946721282','1295888209879760898',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210022367234','1212731840222269441','1295888210022367234',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210072698881','1212930279740608514','1295888210072698881',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210194333697','1212930369930727426','1295888210194333697',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210286608386','1213031390673702913','1295888210286608386',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210353717250','1214142410787934209','1295888210353717250',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210487934977','1214766839310147586','1295888210487934977',2,2,'晋江市内坑镇卫生院','13859752110','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210513100801','1214375861688553474','1295888210513100801',2,2,'晋江一岂科技有限公司','13950116705','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210685067266','1215207699331989506','1295888210685067266',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210685067267','1214461743938473985','1295888210685067267',2,2,'福建七匹狼集团有限公司','13859769696','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888210915753986','1219241646047223809','1295888210915753986',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888211175800834','1241252588561698817','1295888211175800834',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888211410681857','1281834150738911234','1295888211410681857',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888211612008449','1287927444887601153','1295888211612008449',2,2,'晋江市少年儿童业余体育学校','19905061916','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888211804946434','1289134473471909889','1295888211804946434',2,2,'晋江市高新技术开发办公室','15060997885','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888211989495809','1291608243923095553','1295888211989495809',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295888212195016706','1291682260298346498','1295888212195016706',2,2,'泉州东杰进出口贸易有限公司','15860362000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:00:00',NULL,NULL,NULL,'2020-08-19 09:00:00',NULL,NULL,NULL),('1295899558542311425',NULL,'1295899558542311425',2,1,NULL,'18250600713','536848','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-19 09:45:06',NULL,NULL,NULL,'2020-08-19 09:45:06',NULL,NULL,NULL),('1295902738500026370','1289035100629032961','1295902738500026370',2,2,'中国电信股份有限公司晋江分公司','18960219966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 09:57:44',NULL,NULL,NULL,'2020-08-19 09:57:44',NULL,NULL,NULL),('1295903892839596033','1286499346338045953','1295903892839596033',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 10:02:19',NULL,NULL,NULL,'2020-08-19 10:02:19',NULL,NULL,NULL),('1295989169020993537','1289035100629032961','1295989169020993537',2,2,'中国电信股份有限公司晋江分公司','18960219966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-19 15:41:10',NULL,NULL,NULL,'2020-08-19 15:41:10',NULL,NULL,NULL),('1295993157153980418',NULL,'1295993157153980418',2,1,NULL,'13489576771','357182','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-19 15:57:01',NULL,NULL,NULL,'2020-08-19 15:57:01',NULL,NULL,NULL),('1295995387009564673',NULL,'1295995387009564673',2,1,NULL,'13489576771','326182','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-19 16:05:53',NULL,NULL,NULL,'2020-08-19 16:05:53',NULL,NULL,NULL),('1295995937214169090',NULL,'1295995937214169090',2,1,NULL,'13489576771','896847','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-19 16:08:04',NULL,NULL,NULL,'2020-08-19 16:08:04',NULL,NULL,NULL),('1296025381232443393','1295550188802277378','1296025381232443393',2,2,'晋江市磁灶镇李锦成农场','13960232793','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 18:05:04',NULL,NULL,NULL,'2020-08-19 18:05:04',NULL,NULL,NULL),('1296026455506944001','1294076991682641922','1296026455506944001',2,2,'福建意尔康体育用品有限公司','15905071236','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-19 18:09:20',NULL,NULL,NULL,'2020-08-19 18:09:20',NULL,NULL,NULL),('1296026645727019010','1295900371603947522','1296026645727019010',2,2,'雅客(中国)有限公司','18250600713','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-19 18:10:06',NULL,NULL,NULL,'2020-08-19 18:10:06',NULL,NULL,NULL),('1296026935540842498','1294099914032152578','1296026935540842498',2,2,'福建省顺凯包装用品有限公司','13960372915','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-08-19 18:11:15',NULL,NULL,NULL,'2020-08-19 18:11:15',NULL,NULL,NULL),('1296248875274731521','1295550188802277378','1296248875274731521',2,2,'晋江市磁灶镇李锦成农场','13960232793','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-20 08:53:09',NULL,NULL,NULL,'2020-08-20 08:53:09',NULL,NULL,NULL),('1296250596482875393','1211444027140915202','1296250596482875393',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596495458306','1211515979058692097','1296250596495458306',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596529012738','1211454669394591746','1296250596529012738',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1296250596612898818','1211805224986001409','1296250596612898818',2,2,'浩沙实业（福建）有限公司','13905089190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596776476673','78','1296250596776476673',1,2,'李真珠','18259597575','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596797448194','58','1296250596797448194',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596797448195','72','1296250596797448195',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597007163393','1211473406755651586','1296250597007163393',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597007163394','1211832959498240001','1296250597007163394',2,2,'晋江市南港污水处理有限公司','18350062033','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597200101377','83','1296250597200101377',1,2,'李女元','15359825666','13,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597221072897','1211490446086291458','1296250597221072897',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597237850113','58','1296250597237850113',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597263015938','1211925547903401986','1296250597263015938',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597271404546','87','1296250597271404546',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597418205186','87','1296250597418205186',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597443371009','1211505228151570433','1296250597443371009',2,2,'晋江市陈埭中心卫生院','13905972257','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597481119745','1212930369930727426','1296250597481119745',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597669863425','1211816368236707842','1296250597669863425',2,2,'晋江市吉隆农业综合开发有限公司','18558994473','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250597871190017','1211920348237316098','1296250597871190017',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250598097682433','1212685717864517633','1296250598097682433',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250598282231810','1212906675946721282','1296250598282231810',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250598462586882','1212930279740608514','1296250598462586882',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250598642941954','1213031390673702913','1296250598642941954',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250598819102721','1214766839310147586','1296250598819102721',2,2,'晋江市内坑镇卫生院','13859752110','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250598995263490','1215207699331989506','1296250598995263490',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250599192395777','1215608523329683457','1296250599192395777',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250599376945153','1215837051279142913','1296250599376945153',2,2,'晋江星辉智能科技有限公司','18072769019','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250599582466049','1219896525681868801','1296250599582466049',2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250599775404034','1241252588561698817','1296250599775404034',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250599959953410','1275260777149808641','1296250599959953410',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250600190640129','1281834150738911234','1296250600190640129',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250600370995202','1287927444887601153','1296250600370995202',2,2,'晋江市少年儿童业余体育学校','19905061916','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:00',NULL,NULL,NULL,'2020-08-20 09:00:00',NULL,NULL,NULL),('1296250600601681922','1288662402170142722','1296250600601681922',2,2,'晋江市阳光家庭关爱服务中心','17750798475','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:01',NULL,NULL,NULL,'2020-08-20 09:00:01',NULL,NULL,NULL),('1296250600782036994','1291608243923095553','1296250600782036994',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:01',NULL,NULL,NULL,'2020-08-20 09:00:01',NULL,NULL,NULL),('1296250601012723713','1291682260298346498','1296250601012723713',2,2,'泉州东杰进出口贸易有限公司','15860362000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-20 09:00:01',NULL,NULL,NULL,'2020-08-20 09:00:01',NULL,NULL,NULL),('1296256057894502402',NULL,'1296256057894502402',2,1,NULL,'18815981178','810676','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-20 09:21:42',NULL,NULL,NULL,'2020-08-20 09:21:42',NULL,NULL,NULL),('1296612984306532354','1211490446086291458','1296612984306532354',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984348475394','1211100599215566849','1296612984348475394',2,2,'劲派经编科技有限公司','15859799211','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984365252610','1211515979058692097','1296612984365252610',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984386224129','1211444027140915202','1296612984386224129',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984591745025','83','1296612984591745025',1,2,'李女元','15359825666','14,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984633688066','58','1296612984633688066',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984688214017','72','1296612984688214017',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984772100098','1211548619757371393','1296612984772100098',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984805654530','1211505228151570433','1296612984805654530',2,2,'晋江市陈埭中心卫生院','13905972257','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984818237441','1211601884993863681','1296612984818237441',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984990203905','1211805224986001409','1296612984990203905',2,2,'浩沙实业（福建）有限公司','13905089190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985006981121','1211920348237316098','1296612985006981121',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985074089985','87','1296612985074089985',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985183141890','58','1296612985183141890',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985233473538','1211832959498240001','1296612985233473538',2,2,'晋江市南港污水处理有限公司','18350062033','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985275416578','1212685717864517633','1296612985275416578',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985350914050','87','1296612985350914050',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985434800129','1211925547903401986','1296612985434800129',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985485131778','1212906675946721282','1296612985485131778',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985615155201','1213844233778122754','1296612985615155201',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985648709634','1213031390673702913','1296612985648709634',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612985833259009','1215207699331989506','1296612985833259009',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612986034585602','1219241646047223809','1296612986034585602',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612986240106497','1219896525681868801','1296612986240106497',2,2,'泉州市三龙机械制造有限公司','13306051592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612986416267265','1241252588561698817','1296612986416267265',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612986600816641','1275260777149808641','1296612986600816641',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612986793754625','1281834150738911234','1296612986793754625',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612987045412866','1288662402170142722','1296612987045412866',2,2,'晋江市阳光家庭关爱服务中心','17750798475','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296612987225767938','1291608243923095553','1296612987225767938',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-21 09:00:00',NULL,NULL,NULL,'2020-08-21 09:00:00',NULL,NULL,NULL),('1296633953058291713','1294076991682641922','1296633953058291713',2,2,'福建意尔康体育用品有限公司','15905071236','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-21 10:23:19',NULL,NULL,NULL,'2020-08-21 10:23:19',NULL,NULL,NULL),('1296658387458588674',NULL,'1296658387458588674',2,1,NULL,'18065859939','413214','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-21 12:00:24',NULL,NULL,NULL,'2020-08-21 12:00:24',NULL,NULL,NULL),('1297156693611900929',NULL,'1297156693611900929',2,1,NULL,'18299000000','410954','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-22 21:00:30',NULL,NULL,NULL,'2020-08-22 21:00:30',NULL,NULL,NULL),('1297159377437978625',NULL,'1297159377437978625',2,1,NULL,'18299000000','659783','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-22 21:11:10',NULL,NULL,NULL,'2020-08-22 21:11:10',NULL,NULL,NULL),('1297160691790245889',NULL,'1297160691790245889',2,1,NULL,'18299000000','592496','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-22 21:16:23',NULL,NULL,NULL,'2020-08-22 21:16:23',NULL,NULL,NULL),('1297161111304531969',NULL,'1297161111304531969',2,1,NULL,'18299000000','147443','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-22 21:18:03',NULL,NULL,NULL,'2020-08-22 21:18:03',NULL,NULL,NULL),('1297700148012511234','1211920348237316098','1297700148012511234',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148012511235','1211444027140915202','1297700148012511235',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148117368833','1211515979058692097','1297700148117368833',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148150923265','1211100599215566849','1297700148150923265',2,2,'劲派经编科技有限公司','15859799211','11,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148343861250','72','1297700148343861250',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148364832769','72','1297700148364832769',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148431941633','1212685717864517633','1297700148431941633',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148482273281','1211601884993863681','1297700148482273281',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148511633410','1211490953219588098','1297700148511633410',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148616491010','1212906675946721282','1297700148616491010',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148704571393','1211548619757371393','1297700148704571393',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148704571394','58','1297700148704571394',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148754903041','58','1297700148754903041',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148809428993','1213031390673702913','1297700148809428993',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148914286594','87','1297700148914286594',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148926869505','87','1297700148926869505',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148943646721','1211805224986001409','1297700148943646721',2,2,'浩沙实业（福建）有限公司','13905089190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148981395458','1215207699331989506','1297700148981395458',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149111418882','1211832959498240001','1297700149111418882',2,2,'晋江市南港污水处理有限公司','18350062033','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149170139137','1219241646047223809','1297700149170139137',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149295968257','1211837828162437121','1297700149295968257',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149388242946','1241252588561698817','1297700149388242946',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149463740417','1211855307945328641','1297700149463740417',2,2,'福建好来屋食品工业有限公司','15160423086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149597958145','1275260777149808641','1297700149597958145',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149635706882','1211925547903401986','1297700149635706882',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149790896130','1281834150738911234','1297700149790896130',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149824450561','1211931259509456897','1297700149824450561',2,2,'泉州市数坊信息科技有限公司','13506042338','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700149992222721','1287927444887601153','1297700149992222721',2,2,'晋江市少年儿童业余体育学校','19905061916','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700150017388546','1212195053699665922','1297700150017388546',2,2,'泉州建发凯迪汽车有限公司','13656038332','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700150168383489','1291608243923095553','1297700150168383489',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700150180966402','1214106170453676034','1297700150180966402',2,2,'晋江丰顺食品有限公司','13850777672','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700150415847425','1214404632114171905','1297700150415847425',2,2,'晋江市至简资产管理有限公司','13799225181','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700150592008193','1215259455701172226','1297700150592008193',2,2,'福建新宇拉链织造有限公司','15259555117','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700150826889217','1216180400276140034','1297700150826889217',2,2,'泉州荣兴丝绸材料研究院有限公司','15711376693','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700151024021506','1216609110485639170','1297700151024021506',2,2,'泉州时空文化传媒有限公司','13905985153','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297700151216959490','1219241646047223809','1297700151216959490',2,2,'晋江农商银行','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-24 09:00:00',NULL,NULL,NULL,'2020-08-24 09:00:00',NULL,NULL,NULL),('1297750491958210562',NULL,'1297750491958210562',2,1,NULL,'13905055213','954773','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-24 12:20:02',NULL,NULL,NULL,'2020-08-24 12:20:02',NULL,NULL,NULL),('1297786175095959553',NULL,'1297786175095959553',2,1,NULL,'13950399301','460484','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-24 14:41:50',NULL,NULL,NULL,'2020-08-24 14:41:50',NULL,NULL,NULL),('1297788366217146369',NULL,'1297788366217146369',2,1,NULL,'18950086017','862609','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-24 14:50:32',NULL,NULL,NULL,'2020-08-24 14:50:32',NULL,NULL,NULL),('1298062535785836546','1211444027140915202','1298062535785836546',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062535785836547','1211515979058692097','1298062535785836547',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062535811002370','1211920348237316098','1298062535811002370',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062535811002371','1211460115408928770','1298062535811002371',2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536050077697','72','1298062536050077697',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536066854914','72','1298062536066854914',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536217849857','1212685717864517633','1298062536217849857',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536259792898','1211475811404660738','1298062536259792898',2,2,'迦南（福建）新材料科技有限公司','18959995705','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536385622017','1213031390673702913','1298062536385622017',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536427565058','58','1298062536427565058',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536448536578','58','1298062536448536578',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536473702401','1211515979058692097','1298062536473702401',2,2,'福建佶龙机械科技股份有限公司','15960791997','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536607920130','1215207699331989506','1298062536607920130',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536654057474','87','1298062536654057474',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536654057475','87','1298062536654057475',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536679223298','1211548619757371393','1298062536679223298',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536779886593','1219241646047223809','1298062536779886593',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536872161282','1211837828162437121','1298062536872161282',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536993796097','1241252588561698817','1298062536993796097',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062537069293570','1211925547903401986','1298062537069293570',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062537190928385','1281834150738911234','1298062537190928385',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062537270620161','1211931259509456897','1298062537270620161',2,2,'泉州市数坊信息科技有限公司','13506042338','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062537400643585','1291608243923095553','1298062537400643585',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062537463558146','1212195053699665922','1298062537463558146',2,2,'泉州建发凯迪汽车有限公司','13656038332','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062537677467650','1212582208896831489','1298062537677467650',2,2,'泉州市丰预泰企业管理有限公司','13242884288','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062537849434114','1212604591955316738','1298062537849434114',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062538033983490','1212929090869334017','1298062538033983490',2,2,'福建省晋江市辉源建材物资有限公司','15106027935','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062538239504386','1212996449227313153','1298062538239504386',2,2,'晋江闽古食品有限公司','18250155553','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062538478579714','1213698480367751170','1298062538478579714',2,2,'福建龙峰纺织科技实业有限公司','18859760088','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062538663129090','1213736612547022850','1298062538663129090',2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062538868649986','1214020915189272577','1298062538868649986',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062539065782273','1214025654970896386','1298062539065782273',2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062539254525954','1214079030446280705','1298062539254525954',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062539451658241','1214106170453676034','1298062539451658241',2,2,'晋江丰顺食品有限公司','13850777672','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062539627819009','1215608523329683457','1298062539627819009',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062539808174082','1216609110485639170','1298062539808174082',2,2,'泉州时空文化传媒有限公司','13905985153','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:00',NULL,NULL,NULL,'2020-08-25 09:00:00',NULL,NULL,NULL),('1298062540001112065','1219140374220627970','1298062540001112065',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:01',NULL,NULL,NULL,'2020-08-25 09:00:01',NULL,NULL,NULL),('1298062540168884226','1219147136575332354','1298062540168884226',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:01',NULL,NULL,NULL,'2020-08-25 09:00:01',NULL,NULL,NULL),('1298062540378599426','1219241646047223809','1298062540378599426',2,2,'晋江农商银行','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-25 09:00:01',NULL,NULL,NULL,'2020-08-25 09:00:01',NULL,NULL,NULL),('1298095876522242049',NULL,'1298095876522242049',2,1,NULL,'18659923130','898903','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-25 11:12:29',NULL,NULL,NULL,'2020-08-25 11:12:29',NULL,NULL,NULL),('1298424923760488450','1211460115408928770','1298424923760488450',2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923773071362','1211920348237316098','1298424923773071362',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923789848577','1211515979058692097','1298424923789848577',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923789848578','1211444027140915202','1298424923789848578',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923978592258','72','1298424923978592258',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924045701121','72','1298424924045701121',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924108615682','1211465260200935426','1298424924108615682',2,2,'福建金石能源有限公司','13615901213','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924171530242','1212685717864517633','1298424924171530242',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924272193537','1211515979058692097','1298424924272193537',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924314136577','58','1298424924314136577',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924360273921','1213031390673702913','1298424924360273921',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924402216962','58','1298424924402216962',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924469325825','1211548619757371393','1298424924469325825',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924481908738','87','1298424924481908738',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924536434689','1215207699331989506','1298424924536434689',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924569989122','87','1298424924569989122',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924628709377','1211837828162437121','1298424924628709377',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924691623937','1219241646047223809','1298424924691623937',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924821647361','1211925547903401986','1298424924821647361',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424924855201793','1241252588561698817','1298424924855201793',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424925010391041','1211931259509456897','1298424925010391041',2,2,'泉州市数坊信息科技有限公司','13506042338','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424925014585346','1281834150738911234','1298424925014585346',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424925186551810','1212580494957416450','1298424925186551810',2,2,'舒华体育股份有限公司','13599295908','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424925337546754','1212582208896831489','1298424925337546754',2,2,'泉州市丰预泰企业管理有限公司','13242884288','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424925505318914','1212604591955316738','1298424925505318914',2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424925656313858','1212929090869334017','1298424925656313858',2,2,'福建省晋江市辉源建材物资有限公司','15106027935','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424925845057537','1213736612547022850','1298424925845057537',2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424926000246786','1214020915189272577','1298424926000246786',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424926172213250','1214025654970896386','1298424926172213250',2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424926348374017','1214097817526620161','1298424926348374017',2,2,'福建恒安集团有限公司','13960315655','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424926516146178','1214106170453676034','1298424926516146178',2,2,'晋江丰顺食品有限公司','13850777672','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424926683918338','1215608523329683457','1298424926683918338',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424926876856322','1219140374220627970','1298424926876856322',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298424927040434178','1219241646047223809','1298424927040434178',2,2,'晋江农商银行','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 09:00:00',NULL,NULL,NULL,'2020-08-26 09:00:00',NULL,NULL,NULL),('1298442134898208770',NULL,'1298442134898208770',2,1,NULL,'15280217202','538318','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-26 10:08:23',NULL,NULL,NULL,'2020-08-26 10:08:23',NULL,NULL,NULL),('1298460499071070210',NULL,'1298460499071070210',2,1,NULL,'18959811357','948741','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-26 11:21:21',NULL,NULL,NULL,'2020-08-26 11:21:21',NULL,NULL,NULL),('1298462403645796354',NULL,'1298462403645796354',2,1,NULL,'15375882135','829238','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-26 11:28:55',NULL,NULL,NULL,'2020-08-26 11:28:55',NULL,NULL,NULL),('1298464049645875202','1298462952558555137','1298464049645875202',2,2,'熊仔动漫有限公司','15375882135','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-26 11:35:28',NULL,NULL,NULL,'2020-08-26 11:35:28',NULL,NULL,NULL),('1298464945419186177','1298462952558555137','1298464945419186177',2,2,'熊仔动漫有限公司','15375882135','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-26 11:39:01',NULL,NULL,NULL,'2020-08-26 11:39:01',NULL,NULL,NULL),('1298466381167194114','1286499346338045953','1298466381167194114',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-26 11:44:44',NULL,NULL,NULL,'2020-08-26 11:44:44',NULL,NULL,NULL),('1298548185282768897',NULL,'1298548185282768897',2,1,NULL,'13506085037','403306','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-26 17:09:47',NULL,NULL,NULL,'2020-08-26 17:09:47',NULL,NULL,NULL),('1298549612403093505','1298548254794969089','1298549612403093505',2,2,'福建省晋江市金童蚊香制品有限公司','13506085037','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-26 17:15:28',NULL,NULL,NULL,'2020-08-26 17:15:28',NULL,NULL,NULL),('1298787311567368193','1211444027140915202','1298787311567368193',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311571562498','1211920348237316098','1298787311571562498',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311802249218','1211095022649323522','1298787311802249218',2,2,'福建晋工机械有限公司','13799553654','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311819026433','72','1298787311819026433',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311873552385','72','1298787311873552385',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312011964418','1212685717864517633','1298787312011964418',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312121016322','1211450215958102018','1298787312121016322',2,2,'福建夜光达科技股份有限公司','15980473561','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312162959362','58','1298787312162959362',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312251039746','1213031390673702913','1298787312251039746',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312255234050','58','1298787312255234050',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312313954306','1211453814360555522','1298787312313954306',2,2,'伟志股份公司','15859813817','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312326537218','87','1298787312326537218',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312448172034','87','1298787312448172034',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312502697986','1215207699331989506','1298787312502697986',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312548835329','1211490953219588098','1298787312548835329',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312704024578','1219241646047223809','1298787312704024578',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312787910658','1211494671642050561','1298787312787910658',2,2,'顺宏达（福建）针织服饰有限公司','15905907962','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312901156866','1241252588561698817','1298787312901156866',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787312964071426','1211539398999457793','1298787312964071426',2,2,'海西纺织新材料工业技术晋江研究院','15280796970','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787313081511938','1281834150738911234','1298787313081511938',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787313140232194','1211920348237316098','1298787313140232194',2,2,'安踏（中国）有限公司','15160330306','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787313362530306','1211925547903401986','1298787313362530306',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787313609994242','1211927486787534850','1298787313609994242',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787313798737922','1211930809942982658','1298787313798737922',2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787313983287297','1211931259509456897','1298787313983287297',2,2,'泉州市数坊信息科技有限公司','13506042338','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787314172030978','1212580494957416450','1298787314172030978',2,2,'舒华体育股份有限公司','13599295908','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787314352386049','1212582208896831489','1298787314352386049',2,2,'泉州市丰预泰企业管理有限公司','13242884288','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787314520158210','1212604591955316738','1298787314520158210',2,2,'福建约克新材料科技有限公司','18900370886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787314708901889','1212665763958165505','1298787314708901889',2,2,'泉州安踏鞋材有限公司','18250638258','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787314880868353','1212903777946898433','1298787314880868353',2,2,'福建兴翼机械有限公司','18606981162','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787315057029121','1213310396123910145','1298787315057029121',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787315254161409','1213736612547022850','1298787315254161409',2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787315463876610','1214020915189272577','1298787315463876610',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:00',NULL,NULL,NULL,'2020-08-27 09:00:00',NULL,NULL,NULL),('1298787315686174722','1214025654970896386','1298787315686174722',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298787315879112706','1214097817526620161','1298787315879112706',2,2,'福建恒安集团有限公司','13960315655','16,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298787316084633602','1215207699331989506','1298787316084633602',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298787316294348801','1215608523329683457','1298787316294348801',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298787316478898177','1216185557357457410','1298787316478898177',2,2,'晋江太古飞机复合材料有限公司','18959996091','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298787316688613378','1217348495564886017','1298787316688613378',2,2,'晋江劲霸男装有限公司','13505959911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298787316868968449','1219140374220627970','1298787316868968449',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298787317040934913','1219241646047223809','1298787317040934913',2,2,'晋江农商银行','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-27 09:00:01',NULL,NULL,NULL,'2020-08-27 09:00:01',NULL,NULL,NULL),('1298792354890772481',NULL,'1298792354890772481',2,1,NULL,'13559076739','795473','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-27 09:20:02',NULL,NULL,NULL,'2020-08-27 09:20:02',NULL,NULL,NULL),('1298870456656457729',NULL,'1298870456656457729',2,1,NULL,'13506085037','853258','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-27 14:30:23',NULL,NULL,NULL,'2020-08-27 14:30:23',NULL,NULL,NULL),('1298891568509480961',NULL,'1298891568509480961',2,1,NULL,'15880936557','704656','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-27 15:54:16',NULL,NULL,NULL,'2020-08-27 15:54:16',NULL,NULL,NULL),('1298925372833918977',NULL,'1298925372833918977',2,1,NULL,'15959993797','288278','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-27 18:08:36',NULL,NULL,NULL,'2020-08-27 18:08:36',NULL,NULL,NULL),('1299149699391025154','1211453814360555522','1299149699391025154',2,2,'伟志股份公司','15859813817','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699391025155','1211920348237316098','1299149699391025155',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699424579585','1211444027140915202','1299149699424579585',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699571380226','72','1299149699571380226',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699600740353','72','1299149699600740353',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699781095425','1211454669394591746','1299149699781095425',2,2,'福建凤竹纺织科技股份有限公司','13506060342','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699802066945','1212685717864517633','1299149699802066945',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699936284674','58','1299149699936284674',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699944673281','58','1299149699944673281',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699986616321','1211473406755651586','1299149699986616321',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700007587841','1213031390673702913','1299149700007587841',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700112445441','87','1299149700112445441',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700158582786','1211490953219588098','1299149700158582786',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700171165698','1215207699331989506','1299149700171165698',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700322160642','1211494671642050561','1299149700322160642',2,2,'顺宏达（福建）针织服饰有限公司','15905907962','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700359909378','1219241646047223809','1299149700359909378',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700380880898','87','1299149700380880898',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700502515713','1211539398999457793','1299149700502515713',2,2,'海西纺织新材料工业技术晋江研究院','15280796970','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700540264449','1241252588561698817','1299149700540264449',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700678676482','1211805224986001409','1299149700678676482',2,2,'浩沙实业（福建）有限公司','13905089190','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700741591041','1281834150738911234','1299149700741591041',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149700917751810','1211820100991107074','1299149700917751810',2,2,'福建星宏新材料科技有限公司','13805992036','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149701131661313','1211920348237316098','1299149701131661313',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149701395902465','1211925547903401986','1299149701395902465',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149701609811969','1211927486787534850','1299149701609811969',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149701819527169','1211930809942982658','1299149701819527169',2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149702004076546','1212580494957416450','1299149702004076546',2,2,'舒华体育股份有限公司','13599295908','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149702192820225','1212582208896831489','1299149702192820225',2,2,'泉州市丰预泰企业管理有限公司','13242884288','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149702406729730','1212930279740608514','1299149702406729730',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149702574501890','1213310396123910145','1299149702574501890',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149702914240513','1213736612547022850','1299149702914240513',2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149703107178498','1214020915189272577','1299149703107178498',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149703287533569','1214097817526620161','1299149703287533569',2,2,'福建恒安集团有限公司','13960315655','15,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:00',NULL,NULL,NULL,'2020-08-28 09:00:00',NULL,NULL,NULL),('1299149703493054466','1214448822097350658','1299149703493054466',2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299149703673409538','1215207699331989506','1299149703673409538',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299149703845376001','1215608523329683457','1299149703845376001',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299149704067674114','1216185557357457410','1299149704067674114',2,2,'晋江太古飞机复合材料有限公司','18959996091','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299149704248029186','1217348495564886017','1299149704248029186',2,2,'晋江劲霸男装有限公司','13505959911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299149704461938689','1218097536540147714','1299149704461938689',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299149704650682369','1219140374220627970','1299149704650682369',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299149704818454530','1219241646047223809','1299149704818454530',2,2,'晋江农商银行','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-28 09:00:01',NULL,NULL,NULL,'2020-08-28 09:00:01',NULL,NULL,NULL),('1299258245885587457',NULL,'1299258245529071617',2,2,'批量发送(测试20200828)','17362523273','17362523273','【晋江市人才服务平台】测试',3,'短信发送成功','2020-08-28 16:11:19',NULL,NULL,NULL,'2020-08-28 16:11:19',NULL,NULL,NULL),('1299534402069590017',NULL,'1299534402069590017',2,1,NULL,'18575590595','274155','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-29 10:28:40',NULL,NULL,NULL,'2020-08-29 10:28:40',NULL,NULL,NULL),('1299732356936101889',NULL,'1299732356936101889',2,1,NULL,'18717727991','643522','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-29 23:35:16',NULL,NULL,NULL,'2020-08-29 23:35:16',NULL,NULL,NULL),('1299733501385502721',NULL,'1299733501385502721',2,1,NULL,'18717727991','666479','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-29 23:39:49',NULL,NULL,NULL,'2020-08-29 23:39:49',NULL,NULL,NULL),('1300226050780950529',NULL,'1300226050780950529',2,1,NULL,'13505986964','818673','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-31 08:17:02',NULL,NULL,NULL,'2020-08-31 08:17:02',NULL,NULL,NULL),('1300226917286408194',NULL,'1300226917286408194',2,1,NULL,'13489708373','139335','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-08-31 08:20:28',NULL,NULL,NULL,'2020-08-31 08:20:28',NULL,NULL,NULL),('1300236862950076417','1211920348237316098','1300236862950076417',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236862950076418','1211444027140915202','1300236862950076418',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863000408066','1211117113914273793','1300236863000408066',2,2,'福建柒牌时装科技股份有限公司','15880936557','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863147208708','72','1300236863147208708',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863159791617','72','1300236863159791617',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863323369474','1211120827064496130','1300236863323369474',2,2,'泉州市至真工具科技有限公司','13313825373','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863331758082','1212685717864517633','1300236863331758082',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863507918850','1211240519515090946','1300236863507918850',2,2,'晋江友峰鞋业有限公司','15306089555','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863507918851','1213031390673702913','1300236863507918851',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863575027713','58','1300236863575027713',1,2,'张荣荣','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863575027714','58','1300236863575027714',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863671496706','1211454669394591746','1300236863671496706',2,2,'福建凤竹纺织科技股份有限公司','13506060342','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863671496707','1215207699331989506','1300236863671496707',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863788937218','87','1300236863788937218',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863843463169','1219241646047223809','1300236863843463169',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863847657473','1211459203080699905','1300236863847657473',2,2,'福建省育才建设发展有限公司','13788846820','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864028012545','1211473406755651586','1300236864028012545',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864028012546','1241252588561698817','1300236864028012546',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864061566977','87','1300236864061566977',1,2,'叶志钦','13675957398','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864204173314','1211489025517469698','1300236864204173314',2,2,'泉州星城纸业有限公司','15959856777','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864204173315','1281834150738911234','1300236864204173315',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864376139777','1211494671642050561','1300236864376139777',2,2,'顺宏达（福建）针织服饰有限公司','15905907962','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864548106241','1211554636561956866','1300236864548106241',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864715878402','1211559758373371905','1300236864715878402',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236864892039170','1211820100991107074','1300236864892039170',2,2,'福建星宏新材料科技有限公司','13805992036','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236865089171457','1211840469537964033','1300236865089171457',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236865286303745','1211892702682071041','1300236865286303745',2,2,'福建省晋江万利瓷业有限公司','18859989399','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236865449881601','1211925547903401986','1300236865449881601',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236865613459457','1211927486787534850','1300236865613459457',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236865781231618','1212561377781157890','1300236865781231618',2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236865949003777','1212580494957416450','1300236865949003777',2,2,'舒华体育股份有限公司','13599295908','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236866116775937','1212582208896831489','1300236866116775937',2,2,'泉州市丰预泰企业管理有限公司','13242884288','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236866284548098','1212930279740608514','1300236866284548098',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236866481680385','1213032291266269186','1300236866481680385',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236866674618370','1213274113339101185','1300236866674618370',2,2,'福建省群策环境检测有限公司','17758709290','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236866842390530','1213310396123910145','1300236866842390530',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236867026939905','1213736612547022850','1300236867026939905',2,2,'泉州市大长江丰田汽车销售服务有限公司','13808516919','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:00',NULL,NULL,NULL,'2020-08-31 09:00:00',NULL,NULL,NULL),('1300236867211489282','1214020915189272577','1300236867211489282',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236867396038658','1214025654970896386','1300236867396038658',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236867593170945','1214729031224745985','1300236867593170945',2,2,'泉州争艳文化艺术传播有限公司','13599936037','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236867769331714','1214803603139682306','1300236867769331714',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236868037767170','1215207699331989506','1300236868037767170',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236868222316546','1215446302779817985','1300236868222316546',2,2,'福建省力和勘察设计有限公司','13950238890','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236868402671618','1216185557357457410','1300236868402671618',2,2,'晋江太古飞机复合材料有限公司','18959996091','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236868578832386','1216650516390486017','1300236868578832386',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236868796936193','1217348495564886017','1300236868796936193',2,2,'晋江劲霸男装有限公司','13505959911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236868960514050','1218097536540147714','1300236868960514050',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236869145063425','1219140374220627970','1300236869145063425',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236869358972929','1219181564773130242','1300236869358972929',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236869518356482','1219241646047223809','1300236869518356482',2,2,'晋江农商银行','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300236869694517250','1219451161745080321','1300236869694517250',2,2,'泉州福林汽车销售服务有限公司','15805039263','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 09:00:01',NULL,NULL,NULL,'2020-08-31 09:00:01',NULL,NULL,NULL),('1300276290565238786','1298793063874949122','1300276290565238786',2,2,'泉州传化公路港物流有限公司','13559076739','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-31 11:36:40',NULL,NULL,NULL,'2020-08-31 11:36:40',NULL,NULL,NULL),('1300276775640690689','1298925594909732865','1300276775640690689',2,2,'福建柒牌集团有限公司','15959993797','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'未知错误','2020-08-31 11:38:35',NULL,NULL,NULL,'2020-08-31 11:38:35',NULL,NULL,NULL),('1300277125936377858','1297750547696316418','1300277125936377858',2,2,'晋江市罗山清煌古玩店','13905055213','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-31 11:39:59',NULL,NULL,NULL,'2020-08-31 11:39:59',NULL,NULL,NULL),('1300277240914833409','1293436329887031297','1300277240914833409',2,2,'晋江宝龙大酒店有限公司','15280217202','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-31 11:40:26',NULL,NULL,NULL,'2020-08-31 11:40:26',NULL,NULL,NULL),('1300277669870497794','1299733835944161282','1300277669870497794',2,2,'晋江市含光农业科技有限公司','18717727991','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-08-31 11:42:09',NULL,NULL,NULL,'2020-08-31 11:42:09',NULL,NULL,NULL),('1300332759478235137','1299733835944161282','1300332759478235137',2,2,'晋江市含光农业科技有限公司','18717727991','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-08-31 15:21:03',NULL,NULL,NULL,'2020-08-31 15:21:03',NULL,NULL,NULL),('1300599250954022914','1211444027140915202','1300599250954022914',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599250954022915','1211920348237316098','1300599250954022915',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251092434946','1211117113914273793','1300599251092434946',2,2,'福建柒牌时装科技股份有限公司','15880936557','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251285372929','72','1300599251285372929',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251297955842','72','1300599251297955842',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251381841922','1212685717864517633','1300599251381841922',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251381841923','1211120827064496130','1300599251381841923',2,2,'泉州市至真工具科技有限公司','13313825373','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251595751426','1213031390673702913','1300599251595751426',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251595751427','1211456847907700737','1300599251595751427',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251688026114','58','1300599251688026114',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251704803329','58','1300599251704803329',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251755134977','1215207699331989506','1300599251755134977',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251822243841','1211459203080699905','1300599251822243841',2,2,'福建省育才建设发展有限公司','13788846820','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251897741313','87','1300599251897741313',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251914518529','87','1300599251914518529',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251931295746','1219241646047223809','1300599251931295746',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251985821697','1211473406755651586','1300599251985821697',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252111650817','1241252588561698817','1300599252111650817',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252141010945','1211479386717470722','1300599252141010945',2,2,'晋江盛雅新能源有限责任公司','13055667605','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252279422978','1281834150738911234','1300599252279422978',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252317171714','1211489025517469698','1300599252317171714',2,2,'泉州星城纸业有限公司','15959856777','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252501721089','1211494671642050561','1300599252501721089',2,2,'顺宏达（福建）针织服饰有限公司','15905907962','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252665298945','1211494978245672962','1300599252665298945',2,2,'福建省德腾智能科技有限公司','18050996325','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252828876802','1211495827340574722','1300599252828876802',2,2,'晋江市品质陶瓷建材有限公司','15106011992','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599252984066049','1211535199725207554','1300599252984066049',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599253135060993','1211548619757371393','1300599253135060993',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599253294444545','1211554636561956866','1300599253294444545',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599253466411009','1211576021401255937','1300599253466411009',2,2,'泉州鑫豪工程机械科技有限公司','18900399682','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599253634183170','1211836173303988226','1300599253634183170',2,2,'福建陆地港集团有限责任公司','17759539230','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599253810343938','1211840469537964033','1300599253810343938',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599254066196481','1211920348237316098','1300599254066196481',2,2,'安踏（中国）有限公司','15160330306','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599254229774337','1211925547903401986','1300599254229774337',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599254393352193','1211927486787534850','1300599254393352193',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599254556930049','1212561377781157890','1300599254556930049',2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599254724702209','1212620045818073089','1300599254724702209',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:00',NULL,NULL,NULL,'2020-09-01 09:00:00',NULL,NULL,NULL),('1300599254959583233','1212623502012649474','1300599254959583233',2,2,'福建省纳金网信息技术有限公司','15959501581','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599255123161090','1212930279740608514','1300599255123161090',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599255311904770','1212943836112818177','1300599255311904770',2,2,'晋江中纺标检测有限公司','15375873767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599255475482625','1213100306318036993','1300599255475482625',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599255643254785','1213310396123910145','1300599255643254785',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599255815221250','1214020915189272577','1300599255815221250',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599255987187714','1214118511954120705','1300599255987187714',2,2,'泉州协创知识产权代理事务所（普通合伙）','17750792370','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599256205291521','1214729031224745985','1300599256205291521',2,2,'泉州争艳文化艺术传播有限公司','13599936037','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599256377257986','1214803603139682306','1300599256377257986',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599256549224450','1214821655621230594','1300599256549224450',2,2,'福建省百安物业服务有限公司晋江分公司','13489848301','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599256716996609','1215207699331989506','1300599256716996609',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599256884768769','1215446302779817985','1300599256884768769',2,2,'福建省力和勘察设计有限公司','13950238890','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599257039958018','1216185557357457410','1300599257039958018',2,2,'晋江太古飞机复合材料有限公司','18959996091','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599257211924481','1216650516390486017','1300599257211924481',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599257375502337','1217264466144546817','1300599257375502337',2,2,'晋江市铠锋制鞋机械有限公司','15259755678','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599257551663105','1217985949057744898','1300599257551663105',2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599257786544129','1218097536540147714','1300599257786544129',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599257962704898','1218794464953360385','1300599257962704898',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599258122088450','1219140374220627970','1300599258122088450',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599258331803650','1219181564773130242','1300599258331803650',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599258524741633','1219436923634892801','1300599258524741633',2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599258734456834','1219451161745080321','1300599258734456834',2,2,'泉州福林汽车销售服务有限公司','15805039263','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300599258906423297','1219824202652073985','1300599258906423297',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-01 09:00:01',NULL,NULL,NULL,'2020-09-01 09:00:01',NULL,NULL,NULL),('1300683974942715905',NULL,'1300683974942715905',2,1,NULL,'13799855086','608981','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-01 14:36:39',NULL,NULL,NULL,'2020-09-01 14:36:39',NULL,NULL,NULL),('1300961639041888257','1211444027140915202','1300961639041888257',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639058665473','1212685717864517633','1300961639058665473',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639071248385','1211456847907700737','1300961639071248385',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639264186369','72','1300961639264186369',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639272574978','72','1300961639272574978',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639679422465','1213031390673702913','1300961639679422465',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639679422466','1211459203080699905','1300961639679422466',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639679422467','58','1300961639679422467',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639696199682','58','1300961639696199682',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639905914882','1215207699331989506','1300961639905914882',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639905914883','87','1300961639905914883',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639910109185','87','1300961639910109185',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639910109186','1211471774600970241','1300961639910109186',2,2,'泉州鸿展模具制造有限公司','18959708027','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640090464258','1211473406755651586','1300961640090464258',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640107241473','1219241646047223809','1300961640107241473',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640262430722','1241252588561698817','1300961640262430722',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640270819330','1211479386717470722','1300961640270819330',2,2,'晋江盛雅新能源有限责任公司','13055667605','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640455368706','1281834150738911234','1300961640455368706',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640463757314','1211489025517469698','1300961640463757314',2,2,'泉州星城纸业有限公司','15959856777','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640639918082','1211494671642050561','1300961640639918082',2,2,'顺宏达（福建）针织服饰有限公司','15905907962','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640803495937','1211554636561956866','1300961640803495937',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961640975462401','1211836173303988226','1300961640975462401',2,2,'福建陆地港集团有限责任公司','17759539230','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961641160011777','1211837849989595138','1300961641160011777',2,2,'利郎（中国）有限公司','15959420909','53,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961641378115585','1211840469537964033','1300961641378115585',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961641545887746','1211925547903401986','1300961641545887746',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961641713659906','1212561377781157890','1300961641713659906',2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961641889820674','1212930279740608514','1300961641889820674',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961642049204226','1212943836112818177','1300961642049204226',2,2,'晋江中纺标检测有限公司','15375873767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961642216976385','1213100306318036993','1300961642216976385',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961642380554242','1213345803519725570','1300961642380554242',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961642548326401','1214020915189272577','1300961642548326401',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961642732875778','1214041673798012930','1300961642732875778',2,2,'福建省全杰生物科技有限公司','19905050771','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:00',NULL,NULL,NULL,'2020-09-02 09:00:00',NULL,NULL,NULL),('1300961642896453634','1214803603139682306','1300961642896453634',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961643064225794','1214821655621230594','1300961643064225794',2,2,'福建省百安物业服务有限公司晋江分公司','13489848301','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961643219415042','1215207699331989506','1300961643219415042',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961643374604289','1215446302779817985','1300961643374604289',2,2,'福建省力和勘察设计有限公司','13950238890','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961643542376449','1216185557357457410','1300961643542376449',2,2,'晋江太古飞机复合材料有限公司','18959996091','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961643705954305','1216650516390486017','1300961643705954305',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961643886309378','1217242391405154305','1300961643886309378',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961644045692930','1217264466144546817','1300961644045692930',2,2,'晋江市铠锋制鞋机械有限公司','15259755678','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961644205076481','1217985949057744898','1300961644205076481',2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961644494483458','1218794464953360385','1300961644494483458',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961644666449921','1219140374220627970','1300961644666449921',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961644821639169','1219181564773130242','1300961644821639169',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961644989411329','1219436923634892801','1300961644989411329',2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961645152989186','1219451161745080321','1300961645152989186',2,2,'泉州福林汽车销售服务有限公司','15805039263','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300961645337538562','1219824202652073985','1300961645337538562',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-02 09:00:01',NULL,NULL,NULL,'2020-09-02 09:00:01',NULL,NULL,NULL),('1300984173900623873','1300227590451228674','1300984173900623873',2,2,'晋江劲拓体育有限公司','13489708373','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-02 10:29:32',NULL,NULL,NULL,'2020-09-02 10:29:32',NULL,NULL,NULL),('1301081183584546817',NULL,'1301081183584546817',2,1,NULL,'13313825373','494485','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-02 16:55:01',NULL,NULL,NULL,'2020-09-02 16:55:01',NULL,NULL,NULL),('1301324026563555330','1211444027140915202','1301324026563555330',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026613886977','1212685717864517633','1301324026613886977',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026639052802','1211221341013913601','1301324026639052802',2,2,'中菱（福建）电梯有限公司','18959847128','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026773270529','72','1301324026773270529',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026785853441','72','1301324026785853441',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026962014209','1213031390673702913','1301324026962014209',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026962014210','1211442194934710274','1301324026962014210',2,2,'信泰（福建）科技有限公司','15659222652','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027121397761','58','1301324027121397761',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027138174978','58','1301324027138174978',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027150757890','1211456847907700737','1301324027150757890',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027154952194','1215207699331989506','1301324027154952194',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027347890177','1219241646047223809','1301324027347890177',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027368861697','1211459203080699905','1301324027368861697',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027515662338','1241252588561698817','1301324027515662338',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027540828161','1211460552828698626','1301324027540828161',2,2,'雨中鸟（福建）户外用品有限公司','15880885350','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027574382594','87','1301324027574382594',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027649880066','87','1301324027649880066',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027733766145','1211473406755651586','1301324027733766145',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324027918315521','1211484578443739137','1301324027918315521',2,2,'晋江市锦福化纤聚合有限公司','13599749329','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324028115447809','1211489025517469698','1301324028115447809',2,2,'泉州星城纸业有限公司','15959856777','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324028404854785','1211529007779069954','1301324028404854785',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324028610375681','1211538270857510913','1301324028610375681',2,2,'福建省晋江优兰发纸业有限公司','13906095618','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324028794925058','1211543330165407746','1301324028794925058',2,2,'福建省咭咭文化传播有限公司','18698390251','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324028958502913','1211552596691566593','1301324028958502913',2,2,'福建海创医药科技有限公司','13559060707','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324029126275073','1211836173303988226','1301324029126275073',2,2,'福建陆地港集团有限责任公司','17759539230','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324029302435841','1211837849989595138','1301324029302435841',2,2,'利郎（中国）有限公司','15959420909','67,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324029499568130','1211925547903401986','1301324029499568130',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324029663145985','1212627500790779906','1301324029663145985',2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324029826723841','1212930279740608514','1301324029826723841',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324030032244737','1212943836112818177','1301324030032244737',2,2,'晋江中纺标检测有限公司','15375873767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324030208405505','1213050734480789505','1301324030208405505',2,2,'晋江市梓源农业发展有限公司','18965183911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324030376177666','1213345803519725570','1301324030376177666',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324030548144129','1214020915189272577','1301324030548144129',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:00',NULL,NULL,NULL,'2020-09-03 09:00:00',NULL,NULL,NULL),('1301324030757859330','1214041673798012930','1301324030757859330',2,2,'福建省全杰生物科技有限公司','19905050771','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324030975963137','1214123943149981698','1301324030975963137',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324031156318210','1214803603139682306','1301324031156318210',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324031370227713','1215100340257472514','1301324031370227713',2,2,'晋江万兴隆染织实业有限公司','15880742575','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324031546388482','1215207699331989506','1301324031546388482',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324031722549249','1215532466647908353','1301324031722549249',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324031932264450','1216185557357457410','1301324031932264450',2,2,'晋江太古飞机复合材料有限公司','18959996091','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324032104230913','1216559724997144578','1301324032104230913',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324032288780290','1216650516390486017','1301324032288780290',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324032473329665','1217041144660119553','1301324032473329665',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324032649490433','1217242391405154305','1301324032649490433',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324032863399938','1217985949057744898','1301324032863399938',2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324033052143618','1218794464953360385','1301324033052143618',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324033224110082','1219140374220627970','1301324033224110082',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324033438019585','1219166759144251393','1301324033438019585',2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324033643540482','1219181564773130242','1301324033643540482',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324033811312641','1219436923634892801','1301324033811312641',2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324033987473410','1219451161745080321','1301324033987473410',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301324034172022785','1219824202652073985','1301324034172022785',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-03 09:00:01',NULL,NULL,NULL,'2020-09-03 09:00:01',NULL,NULL,NULL),('1301395435478347778',NULL,'1301395435478347778',2,1,NULL,'13205957447','737765','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-03 13:43:45',NULL,NULL,NULL,'2020-09-03 13:43:45',NULL,NULL,NULL),('1301681540916342786',NULL,'1301681540916342786',2,1,NULL,'15659995820','101561','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',2,'空号','2020-09-04 08:40:38',NULL,NULL,NULL,'2020-09-04 08:40:38',NULL,NULL,NULL),('1301681791966408705',NULL,'1301681791966408705',2,1,NULL,'15659885820','958485','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-04 08:41:37',NULL,NULL,NULL,'2020-09-04 08:41:37',NULL,NULL,NULL),('1301686414429155329','1211444027140915202','1301686414429155329',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414479486977','1211098602777194497','1301686414479486977',2,2,'福建省诺美护理用品有限公司','13799487213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414664036354','1212685717864517633','1301686414664036354',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414714368001','72','1301686414714368001',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414726950914','72','1301686414726950914',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414966026241','1211100599215566849','1301686414966026241',2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415037329409','1213031390673702913','1301686415037329409',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415104438274','58','1301686415104438274',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415117021186','58','1301686415117021186',1,2,'张荣荣','15280619456','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415158964226','1211167966465470465','1301686415158964226',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415234461697','1215207699331989506','1301686415234461697',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415297376258','87','1301686415297376258',1,2,'叶志钦','13675957398','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415305764866','87','1301686415305764866',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415364485122','1211450215958102018','1301686415364485122',2,2,'福建夜光达科技股份有限公司','15980473561','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415431593985','1219241646047223809','1301686415431593985',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415582588930','1211456847907700737','1301686415582588930',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415641309186','1241252588561698817','1301686415641309186',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415762944002','1211460552828698626','1301686415762944002',2,2,'雨中鸟（福建）户外用品有限公司','15880885350','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686415947493377','1211461407799820290','1301686415947493377',2,2,'晋江经济报发展有限责任公司','13505004167','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686416190763010','1211465952919601153','1301686416190763010',2,2,'福建省晋江市福埔S.M国际广场','15059551567','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686416366923778','1211473406755651586','1301686416366923778',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686416555667457','1211474926804975617','1301686416555667457',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686416756994050','1211476436687306754','1301686416756994050',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686416933154817','1211485201327243265','1301686416933154817',2,2,'泉州市安科职业卫生技术服务有限公司','13506061626','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686417109315586','1211489025517469698','1301686417109315586',2,2,'泉州星城纸业有限公司','15959856777','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686417344196610','1211538270857510913','1301686417344196610',2,2,'福建省晋江优兰发纸业有限公司','13906095618','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686417583271937','1211805224986001409','1301686417583271937',2,2,'浩沙实业（福建）有限公司','13905089190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686417763627009','1211815946042261505','1301686417763627009',2,2,'泉州市陶源环保科技有限公司','13666026522','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686418032062466','1211832959498240001','1301686418032062466',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686418216611842','1211837849989595138','1301686418216611842',2,2,'利郎（中国）有限公司','15959420909','67,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686418392772610','1211925547903401986','1301686418392772610',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:00',NULL,NULL,NULL,'2020-09-04 09:00:00',NULL,NULL,NULL),('1301686418573127682','1212580494957416450','1301686418573127682',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686418778648577','1212627500790779906','1301686418778648577',2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686418967392257','1212943836112818177','1301686418967392257',2,2,'晋江中纺标检测有限公司','15375873767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686419160330242','1213050734480789505','1301686419160330242',2,2,'晋江市梓源农业发展有限公司','18965183911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686419349073921','1213345803519725570','1301686419349073921',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686419621703681','1213844233778122754','1301686419621703681',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686419797864449','1214020915189272577','1301686419797864449',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686419969830913','1214123943149981698','1301686419969830913',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686420133408770','1214803603139682306','1301686420133408770',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686420317958146','1215207699331989506','1301686420317958146',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686420661891073','1215532466647908353','1301686420661891073',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686420842246145','1216559724997144578','1301686420842246145',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686421035184130','1216650516390486017','1301686421035184130',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686421249093633','1217041144660119553','1301686421249093633',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686421479780354','1217242391405154305','1301686421479780354',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686421660135426','1217985949057744898','1301686421660135426',2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686421844684801','1218794464953360385','1301686421844684801',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686422075371522','1219140374220627970','1301686422075371522',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686422251532289','1219166759144251393','1301686422251532289',2,2,'泉州市诺伊曼信息科技股份公司','13850752082','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686422448664578','1219428616866152449','1301686422448664578',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686422629019649','1219451161745080321','1301686422629019649',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:01',NULL,NULL,NULL,'2020-09-04 09:00:01',NULL,NULL,NULL),('1301686423065227265','1219824202652073985','1301686423065227265',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-04 09:00:02',NULL,NULL,NULL,'2020-09-04 09:00:02',NULL,NULL,NULL),('1301687207685287938','1301682900063776769','1301687207685287938',2,2,'福建天工房地产开发有限公司','15659885820','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-04 09:03:09',NULL,NULL,NULL,'2020-09-04 09:03:09',NULL,NULL,NULL),('1301823902619561986',NULL,'1301823902619561986',2,1,NULL,'13489551288','216407','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-04 18:06:19',NULL,NULL,NULL,'2020-09-04 18:06:19',NULL,NULL,NULL),('1302773578038538242','1211444027140915202','1302773578038538242',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578042732545','1212685717864517633','1302773578042732545',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578063704066','1211138539417350145','1302773578063704066',2,2,'福建百宏聚纤科技实业有限公司','18959858592','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578189533185','72','1302773578189533185',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578193727490','72','1302773578193727490',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578432802817','1213031390673702913','1302773578432802817',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578483134465','1211167966465470465','1302773578483134465',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578562826241','58','1302773578562826241',1,2,'张荣荣','15280619456','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578562826242','58','1302773578562826242',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578650906626','1215207699331989506','1302773578650906626',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578701238273','1211439642532954113','1302773578701238273',2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578738987009','87','1302773578738987009',1,2,'叶志钦','13675957398','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578814484481','87','1302773578814484481',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578818678786','1219241646047223809','1302773578818678786',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578877399041','1211456847907700737','1302773578877399041',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578986450946','1241252588561698817','1302773578986450946',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773579040976898','1211460552828698626','1302773579040976898',2,2,'雨中鸟（福建）户外用品有限公司','15880885350','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773579196166145','1211465952919601153','1302773579196166145',2,2,'福建省晋江市福埔S.M国际广场','15059551567','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773579389104129','1211473406755651586','1302773579389104129',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773579548487682','1211474926804975617','1302773579548487682',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773579728842754','1211489025517469698','1302773579728842754',2,2,'泉州星城纸业有限公司','15959856777','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773579896614914','1211805224986001409','1302773579896614914',2,2,'浩沙实业（福建）有限公司','13905089190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773580064387073','1211815946042261505','1302773580064387073',2,2,'泉州市陶源环保科技有限公司','13666026522','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773580223770626','1211832959498240001','1302773580223770626',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773580399931393','1211837849989595138','1302773580399931393',2,2,'利郎（中国）有限公司','15959420909','21,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773580559314945','1211925547903401986','1302773580559314945',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773580752252930','1212580494957416450','1302773580752252930',2,2,'舒华体育股份有限公司','13599295908','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773580915830786','1212627500790779906','1302773580915830786',2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773581121351682','1212692778300018689','1302773581121351682',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773581284929537','1213050734480789505','1302773581284929537',2,2,'晋江市梓源农业发展有限公司','18965183911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773581486256130','1213345803519725570','1302773581486256130',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773581658222593','1214020915189272577','1302773581658222593',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773581876326402','1214097817526620161','1302773581876326402',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773582052487170','1214123943149981698','1302773582052487170',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:00',NULL,NULL,NULL,'2020-09-07 09:00:00',NULL,NULL,NULL),('1302773582207676417','1214802166888357889','1302773582207676417',2,2,'福建省晋江人力资本有限公司','13489719977','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773582396420098','1214803603139682306','1302773582396420098',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773582568386561','1215115207978827777','1302773582568386561',2,2,'福州大学晋江科教园管委会','15980228632','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773582731964418','1215207699331989506','1302773582731964418',2,2,'晋江市医院','18350528526','36,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773582929096705','1215532466647908353','1302773582929096705',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773583138811905','1216180400276140034','1302773583138811905',2,2,'泉州荣兴丝绸材料研究院有限公司','15711376693','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773583314972674','1216537288914268162','1302773583314972674',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773583478550529','1216626668072869889','1302773583478550529',2,2,'晋江市融媒体中心','13599718877','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773583667294210','1216650516390486017','1302773583667294210',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773583835066369','1217242391405154305','1302773583835066369',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773583998644225','1219140374220627970','1302773583998644225',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773584191582209','1219190487777402882','1302773584191582209',2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773584376131586','1219428616866152449','1302773584376131586',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773584543903746','1219444673739800577','1302773584543903746',2,2,'晋江拓普旺防霉材料有限公司','18259038660','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773584707481601','1219451161745080321','1302773584707481601',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302773584871059458','1219824202652073985','1302773584871059458',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-07 09:00:01',NULL,NULL,NULL,'2020-09-07 09:00:01',NULL,NULL,NULL),('1302777970003308546',NULL,'1302777970003308546',2,1,NULL,'13235950077','817338','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-07 09:17:27',NULL,NULL,NULL,'2020-09-07 09:17:27',NULL,NULL,NULL),('1303135966097113089','1212685717864517633','1303135966097113089',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966344577025','1211138539417350145','1303135966344577025',2,2,'福建百宏聚纤科技实业有限公司','18959858592','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966348771329','1211444027140915202','1303135966348771329',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966541709313','72','1303135966541709313',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966613012481','72','1303135966613012481',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966776590338','1213031390673702913','1303135966776590338',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966789173250','1211439642532954113','1303135966789173250',2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967011471361','1215207699331989506','1303135967011471361',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967015665665','58','1303135967015665665',1,2,'张荣荣','15280619456','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967015665666','58','1303135967015665666',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967024054274','1211456847907700737','1303135967024054274',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967242158082','87','1303135967242158082',1,2,'叶志钦','13675957398','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967242158083','87','1303135967242158083',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967254740994','1219241646047223809','1303135967254740994',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967321849858','1211473406755651586','1303135967321849858',2,2,'福建省麦都食品发展有限公司','13788809209','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967472844802','1241252588561698817','1303135967472844802',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967527370753','1211489025517469698','1303135967527370753',2,2,'泉州星城纸业有限公司','15959856777','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967711920129','1211601884993863681','1303135967711920129',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135967904858114','1211832959498240001','1303135967904858114',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135968097796098','1211925547903401986','1303135968097796098',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135968282345474','1212627500790779906','1303135968282345474',2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135968458506241','1212692778300018689','1303135968458506241',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135968634667010','1213310396123910145','1303135968634667010',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135968810827777','1214020915189272577','1303135968810827777',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135968999571457','1214097817526620161','1303135968999571457',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135969175732225','1214802166888357889','1303135969175732225',2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135969356087297','1215115207978827777','1303135969356087297',2,2,'福州大学晋江科教园管委会','15980228632','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135969540636673','1215207699331989506','1303135969540636673',2,2,'晋江市医院','18350528526','15,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135969725186050','1215532466647908353','1303135969725186050',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135969922318338','1216650516390486017','1303135969922318338',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:00',NULL,NULL,NULL,'2020-09-08 09:00:00',NULL,NULL,NULL),('1303135970106867713','1217242391405154305','1303135970106867713',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:01',NULL,NULL,NULL,'2020-09-08 09:00:01',NULL,NULL,NULL),('1303135970295611393','1219140374220627970','1303135970295611393',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:01',NULL,NULL,NULL,'2020-09-08 09:00:01',NULL,NULL,NULL),('1303135970484355073','1219190487777402882','1303135970484355073',2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:01',NULL,NULL,NULL,'2020-09-08 09:00:01',NULL,NULL,NULL),('1303135970660515841','1219255868495880193','1303135970660515841',2,2,'晋江嘉年华婴儿用品有限公司','15859590857','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:01',NULL,NULL,NULL,'2020-09-08 09:00:01',NULL,NULL,NULL),('1303135970845065217','1219428616866152449','1303135970845065217',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:01',NULL,NULL,NULL,'2020-09-08 09:00:01',NULL,NULL,NULL),('1303135971021225986','1219451161745080321','1303135971021225986',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:01',NULL,NULL,NULL,'2020-09-08 09:00:01',NULL,NULL,NULL),('1303135971235135490','1219824202652073985','1303135971235135490',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-08 09:00:01',NULL,NULL,NULL,'2020-09-08 09:00:01',NULL,NULL,NULL),('1303328317969022978',NULL,'1303328317969022978',2,1,NULL,'15059823968','456136','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-08 21:44:20',NULL,NULL,NULL,'2020-09-08 21:44:20',NULL,NULL,NULL),('1303496537258606594',NULL,'1303496537258606594',2,1,NULL,'13489551288','516436','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-09 08:52:46',NULL,NULL,NULL,'2020-09-09 08:52:46',NULL,NULL,NULL),('1303497221567692802',NULL,'1303497221567692802',2,1,NULL,'13489551288','796684','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-09 08:55:30',NULL,NULL,NULL,'2020-09-09 08:55:30',NULL,NULL,NULL),('1303498354096881665','1212685717864517633','1303498354096881665',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354105270273','1211444027140915202','1303498354105270273',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354143019010','1211456847907700737','1303498354143019010',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354247876609','72','1303498354247876609',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354277236738','72','1303498354277236738',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354499534850','1211601884993863681','1303498354499534850',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354520506369','1213031390673702913','1303498354520506369',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354621169665','58','1303498354621169665',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354688278530','58','1303498354688278530',1,2,'张荣荣','15280619456','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354734415873','1215207699331989506','1303498354734415873',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354746998786','1211837849989595138','1303498354746998786',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354784747522','87','1303498354784747522',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354885410818','87','1303498354885410818',1,2,'叶志钦','13675957398','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354918965250','1219241646047223809','1303498354918965250',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354973491201','1211925547903401986','1303498354973491201',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498355116097537','1241252588561698817','1303498355116097537',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498355149651969','1212536999949438978','1303498355149651969',2,2,'晋江市医院晋南分院','15396486268','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498355342589953','1213310396123910145','1303498355342589953',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498355543916546','1214020915189272577','1303498355543916546',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498355757826049','1214802166888357889','1303498355757826049',2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498355921403905','1214803603139682306','1303498355921403905',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498356114341889','1215115207978827777','1303498356114341889',2,2,'福州大学晋江科教园管委会','15980228632','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498356286308353','1215207699331989506','1303498356286308353',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498356454080513','1215532466647908353','1303498356454080513',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498356634435585','1216626668072869889','1303498356634435585',2,2,'晋江市融媒体中心','13599718877','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498356831567874','1216650516390486017','1303498356831567874',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498357053865986','1217242391405154305','1303498357053865986',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498357225832449','1217985949057744898','1303498357225832449',2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498357393604609','1218794464953360385','1303498357393604609',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498357657845762','1219190487777402882','1303498357657845762',2,2,'晋江市城市展馆管理服务中心','13506030795','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:00',NULL,NULL,NULL,'2020-09-09 09:00:00',NULL,NULL,NULL),('1303498357859172354','1219255868495880193','1303498357859172354',2,2,'晋江嘉年华婴儿用品有限公司','15859590857','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:01',NULL,NULL,NULL,'2020-09-09 09:00:01',NULL,NULL,NULL),('1303498358035333122','1219428616866152449','1303498358035333122',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:01',NULL,NULL,NULL,'2020-09-09 09:00:01',NULL,NULL,NULL),('1303498358207299585','1219451161745080321','1303498358207299585',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:01',NULL,NULL,NULL,'2020-09-09 09:00:01',NULL,NULL,NULL),('1303498358417014786','1219824202652073985','1303498358417014786',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-09 09:00:01',NULL,NULL,NULL,'2020-09-09 09:00:01',NULL,NULL,NULL),('1303517680451469313',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','18959858592','18959858592','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',3,'短信发送成功','2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680459857922',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059551567','\n15059551567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680459857923',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260305126','\n15260305126','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680459857924',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965129895','\n18965129895','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680459857925',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13666026522','\n13666026522','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680464052226',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13801333177','\n13801333177','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680464052227',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15106096021','\n15106096021','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680464052228',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959847128','\n18959847128','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680468246530',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13802609526','\n13802609526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680468246531',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506086731','\n13506086731','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680468246532',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18016585576','\n18016585576','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680468246533',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13655986799','\n13655986799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680472440833',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959798579','\n15959798579','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680472440834',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859971221','\n18859971221','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680472440835',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13338562717','\n13338562717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680472440836',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18250298076','\n18250298076','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680472440837',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18065376686','\n18065376686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680476635138',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15602265352','\n15602265352','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680476635139',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906099888','\n13906099888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680476635140',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13809549382','\n13809549382','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680476635141',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876509838','\n18876509838','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680476635142',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905070552','\n13905070552','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680476635143',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506056368','\n13506056368','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680480829441',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13705941428','\n13705941428','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680480829442',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15159878799','\n15159878799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680480829443',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905089190','\n13905089190','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680480829444',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960381057','\n13960381057','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680480829445',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980788802','\n15980788802','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680485023746',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15985952242','\n15985952242','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680485023747',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13055808024','\n13055808024','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680485023748',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950920100','\n13950920100','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680522772481',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905958730','\n13905958730','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680526966785',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13105079935','\n13105079935','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680526966786',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799966695','\n13799966695','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680526966787',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805032333','\n15805032333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680531161089',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505080996','\n13505080996','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680531161090',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959705077','\n18959705077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680531161091',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965689935','\n18965689935','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680535355393',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960206656','\n18960206656','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680535355394',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13774825517','\n13774825517','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680535355395',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880720190','\n15880720190','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680539549698',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15810812160','\n15810812160','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680539549699',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905975119','\n13905975119','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680539549700',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13509362773','\n13509362773','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680539549701',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960278086','\n18960278086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680543744002',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18759429880','\n18759429880','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680543744003',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18609586661','\n18609586661','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680543744004',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13306995188','\n13306995188','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680543744005',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059792958','\n15059792958','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680547938306',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13305967663','\n13305967663','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680547938307',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13306995039','\n13306995039','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680547938308',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808510760','\n13808510760','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680547938309',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959896966','\n15959896966','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680552132609',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905952020','\n13905952020','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680552132610',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959995705','\n18959995705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680552132611',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805957081','\n13805957081','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680552132612',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559566696','\n13559566696','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680556326913',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859990000','\n18859990000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680556326914',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860395678','\n15860395678','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680556326915',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980325929','\n15980325929','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680556326916',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859759601','\n15859759601','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680589881345',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805946193','\n13805946193','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680589881346',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15906092370','\n15906092370','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680594075650',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13044554499','\n13044554499','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680594075651',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799555666','\n13799555666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680594075652',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18006037555','\n18006037555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680594075653',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18605008168','\n18605008168','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680598269953',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18350782990','\n18350782990','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680598269954',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599162155','\n13599162155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680598269955',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905907962','\n15905907962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680598269956',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506060342','\n13506060342','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680598269957',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788851759','\n13788851759','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680602464258',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13615901213','\n13615901213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680602464259',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599212929','\n13599212929','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680602464260',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805021228','\n15805021228','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680602464261',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15750768536','\n15750768536','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680602464262',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506000615','\n13506000615','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680602464263',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905974006','\n13905974006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680606658562',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13358591930','\n13358591930','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680606658563',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959995535','\n15959995535','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680606658564',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559593361','\n13559593361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680606658565',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960417367','\n13960417367','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680606658566',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599109151','\n13599109151','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680606658567',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15659878695','\n15659878695','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680610852865',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965689828','\n18965689828','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680610852866',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859969666','\n18859969666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680610852867',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13144828970','\n13144828970','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680610852868',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960357668','\n18960357668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680615047169',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260875883','\n15260875883','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680615047170',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15160423086','\n15160423086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680615047171',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13705943966','\n13705943966','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680656990210',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15559162475','\n15559162475','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680656990211',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850778776','\n13850778776','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680661184513',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18559161283','\n18559161283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680661184514',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15611255393','\n15611255393','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680661184515',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636963633','\n13636963633','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680661184516',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18650100145','\n18650100145','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680661184517',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18721796963','\n18721796963','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680665378818',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13656038332','\n13656038332','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680665378819',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13675953607','\n13675953607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680665378820',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959210622','\n18959210622','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680665378821',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805900098','\n13805900098','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680665378822',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859932277','\n18859932277','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680665378823',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15306089555','\n15306089555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680669573122',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905079361','\n15905079361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680669573123',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18618285267','\n18618285267','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680669573124',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859799829','\n18859799829','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680669573125',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13337211223','\n13337211223','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680669573126',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600757303','\n13600757303','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680669573127',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13626072564','\n13626072564','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680673767425',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906933286','\n13906933286','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680673767426',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18605958880','\n18605958880','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680673767427',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788846820','\n13788846820','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680673767428',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260782666','\n15260782666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680673767429',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905985809','\n13905985809','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680673767430',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260803666','\n15260803666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680677961730',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659030309','\n18659030309','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680677961731',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13685908658','\n13685908658','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680677961732',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805919195','\n13805919195','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680677961733',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15392288855','\n15392288855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680677961734',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600754180','\n13600754180','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680715710466',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599717008','\n13599717008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680719904769',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880785555','\n15880785555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680719904770',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599780560','\n13599780560','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680719904771',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259571333','\n15259571333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680719904772',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259546913','\n15259546913','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680724099074',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959712401','\n13959712401','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680724099075',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260899107','\n15260899107','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680724099076',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18516157979','\n18516157979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680724099077',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328509988','\n13328509988','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680724099078',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13655902993','\n13655902993','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680728293377',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860398018','\n15860398018','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680728293378',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859551760','\n18859551760','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680728293379',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18606989818','\n18606989818','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680728293380',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13395096999','\n13395096999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680728293381',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959858506','\n18959858506','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680732487682',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15985918296','\n15985918296','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680732487683',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960341716','\n13960341716','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680732487684',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880972652','\n15880972652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680732487685',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980313135','\n15980313135','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680732487686',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980066202','\n15980066202','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680732487687',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906096567','\n13906096567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680736681985',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15080070385','\n15080070385','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680736681986',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13675995249','\n13675995249','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680736681987',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15995216889','\n15995216889','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680736681988',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260429705','\n15260429705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680736681989',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959778888','\n13959778888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680736681990',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059157225','\n15059157225','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680740876290',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905968151','\n13905968151','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680740876291',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959776520','\n13959776520','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680740876292',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799521561','\n13799521561','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680778625026',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759488187','\n15759488187','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680782819329',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13720842620','\n13720842620','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680782819330',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659915000','\n18659915000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680787013633',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13774828120','\n13774828120','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680787013634',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060626155','\n15060626155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680787013635',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18771094578','\n18771094578','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680787013636',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959237668','\n13959237668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680787013637',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13400820519','\n13400820519','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680791207937',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13779911861','\n13779911861','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680791207938',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13601032833','\n13601032833','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680791207939',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959805200','\n18959805200','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680791207940',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506042338','\n13506042338','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680795402242',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18567651331','\n18567651331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680795402243',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18695665035','\n18695665035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680795402244',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859727077','\n13859727077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680795402245',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15345952654','\n15345952654','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680799596545',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15659972175','\n15659972175','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680799596546',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359383363','\n15359383363','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680799596547',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959959200','\n15959959200','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680799596548',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960291518','\n13960291518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680803790849',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13625979936','\n13625979936','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680803790850',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13514019395','\n13514019395','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680803790851',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15396608587','\n15396608587','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680807985153',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13969010619','\n13969010619','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680807985154',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859796953','\n13859796953','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680807985155',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15850693987','\n15850693987','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680807985156',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959870601','\n15959870601','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680812179458',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805981750','\n15805981750','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680812179459',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13842019660','\n13842019660','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680812179460',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13940108782','\n13940108782','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680849928193',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876572155','\n18876572155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680854122497',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959753823','\n13959753823','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680854122498',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459034477','\n13459034477','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680854122499',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18862155925','\n18862155925','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680858316801',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860688762','\n15860688762','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680858316802',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859596380','\n18859596380','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680858316803',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18275745728','\n18275745728','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680858316804',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799487213','\n13799487213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680858316805',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15502179365','\n15502179365','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680858316806',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15086777305','\n15086777305','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680862511105',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18850528121','\n18850528121','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680862511106',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18052150317','\n18052150317','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680862511107',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859757759','\n18859757759','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680862511108',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18359810815','\n18359810815','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680866705409',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960707755','\n15960707755','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680866705410',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505957512','\n13505957512','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680866705411',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13696949262','\n13696949262','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680866705412',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860116953','\n13860116953','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680870899713',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18805920922','\n18805920922','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680870899714',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659030881','\n18659030881','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680870899715',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059803792','\n15059803792','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680870899716',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959813876','\n18959813876','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680875094017',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13436970465','\n13436970465','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680875094018',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980013301','\n15980013301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680879288321',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805924801','\n13805924801','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680879288322',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950430719','\n13950430719','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680883482626',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18250169959','\n18250169959','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680883482627',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18900336517','\n18900336517','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680883482628',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18105907301','\n18105907301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680887676929',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18851401527','\n18851401527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680925425665',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18020867909','\n18020867909','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680929619970',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860257142','\n15860257142','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680929619971',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876336921','\n18876336921','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680929619972',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15806032297','\n15806032297','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680933814273',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965785175','\n18965785175','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680933814274',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15005062379','\n15005062379','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680938008578',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18950700105','\n18950700105','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680938008579',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15005059367','\n15005059367','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680938008580',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18741355270','\n18741355270','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680942202882',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18150563203','\n18150563203','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680942202883',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13075572292','\n13075572292','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680946397186',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15502207706','\n15502207706','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680946397187',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18649652527','\n18649652527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680946397188',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17741357996','\n17741357996','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680950591489',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15090088338','\n15090088338','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680950591490',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599220676','\n13599220676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680950591491',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18900371513','\n18900371513','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680950591492',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788829369','\n13788829369','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680950591493',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15191818740','\n15191818740','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680954785794',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18059037101','\n18059037101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680954785795',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18696960184','\n18696960184','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680954785796',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859760088','\n18859760088','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680954785797',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636957868','\n13636957868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680954785798',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880974760','\n15880974760','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680958980098',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13794913769','\n13794913769','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680958980099',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259555555','\n15259555555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680958980100',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905037555','\n15905037555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680958980101',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960285333','\n18960285333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680963174402',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959997270','\n18959997270','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517680963174403',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960551920','\n15960551920','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681118363650',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960207400','\n13960207400','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681122557954',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15629795466','\n15629795466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681126752257',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15946798736','\n15946798736','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681126752258',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17750799505','\n17750799505','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681126752259',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13666988888','\n13666988888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681126752260',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17750103317','\n17750103317','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681126752261',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959941093','\n18959941093','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681126752262',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15622174598','\n15622174598','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681126752263',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260807555','\n15260807555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681130946561',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905958858','\n15905958858','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681130946562',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599279399','\n13599279399','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681130946563',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505906457','\n13505906457','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681130946564',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15080458330','\n15080458330','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681130946565',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359585555','\n15359585555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681130946566',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059748612','\n15059748612','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681135140865',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18571081281','\n18571081281','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681135140866',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18065333731','\n18065333731','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681135140867',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959889099','\n15959889099','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681135140868',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459504545','\n13459504545','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681135140869',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15396597171','\n15396597171','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681135140870',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18605001616','\n18605001616','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681139335170',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260785666','\n15260785666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681139335171',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18106980703','\n18106980703','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681139335172',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859464970','\n18859464970','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681139335173',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13027105101','\n13027105101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681139335174',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959975329','\n13959975329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681143529473',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17758709290','\n17758709290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681143529474',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13285030066','\n13285030066','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681143529475',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13425480722','\n13425480722','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681147723778',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959855726','\n18959855726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681181278209',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18046360864','\n18046360864','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681185472514',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459556182','\n13459556182','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681189666817',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060456431','\n15060456431','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681189666818',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050929268','\n18050929268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681189666819',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860300607','\n13860300607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681189666820',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13306995027','\n13306995027','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681193861121',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18796922940','\n18796922940','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681193861122',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13325253201','\n13325253201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681193861123',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18350777627','\n18350777627','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681193861124',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599159330','\n13599159330','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681198055426',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18020650858','\n18020650858','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681198055427',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328963385','\n13328963385','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681198055428',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13816975274','\n13816975274','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681198055429',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13709857491','\n13709857491','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681198055430',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489312968','\n13489312968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681202249730',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960408186','\n15960408186','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681202249731',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859780809','\n18859780809','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681202249732',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359590811','\n15359590811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681202249733',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959119986','\n13959119986','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681206444034',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13178336506','\n13178336506','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681206444035',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600703008','\n13600703008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681206444036',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505951467','\n13505951467','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681210638337',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n14759154723','\n14759154723','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681210638338',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15141327771','\n15141327771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681210638339',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599949096','\n13599949096','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681210638340',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980000372','\n15980000372','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681214832642',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905089834','\n13905089834','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681214832643',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965687332','\n18965687332','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681214832644',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959951039','\n13959951039','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681214832645',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960259639','\n13960259639','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681252581378',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18250155553','\n18250155553','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681256775681',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18359714502','\n18359714502','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681256775682',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965687331','\n18965687331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681256775683',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905085845','\n13905085845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681256775684',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980060559','\n15980060559','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681256775685',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960359859','\n13960359859','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681260969985',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965523733','\n18965523733','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681260969986',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17759991213','\n17759991213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681260969987',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959579818','\n15959579818','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681260969988',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18262283166','\n18262283166','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681260969989',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059719567','\n15059719567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681260969990',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505008588','\n13505008588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681260969991',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15029265211','\n15029265211','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681265164289',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18650908918','\n18650908918','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681265164290',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980000359','\n15980000359','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681265164291',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960402869','\n15960402869','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681265164292',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18829340451','\n18829340451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681265164293',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17755092627','\n17755092627','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681265164294',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960256299','\n13960256299','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681269358594',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15559110466','\n15559110466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681269358595',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15191845928','\n15191845928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681269358596',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13122120652','\n13122120652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681269358597',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15191815436','\n15191815436','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681269358598',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980000660','\n15980000660','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681269358599',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959264368','\n13959264368','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681273552897',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15080318157','\n15080318157','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681273552898',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060823577','\n15060823577','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681273552899',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659066928','\n18659066928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681273552900',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18559472664','\n18559472664','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681273552901',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18150591518','\n18150591518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681307107329',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18722290558','\n18722290558','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681311301633',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636950764','\n13636950764','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681311301634',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860752060','\n13860752060','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681311301635',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328555097','\n13328555097','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681311301636',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18539456470','\n18539456470','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681311301637',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17759892862','\n17759892862','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681315495937',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876272213','\n18876272213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681315495938',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13669274728','\n13669274728','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681315495939',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18829298483','\n18829298483','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681315495940',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659003978','\n18659003978','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681315495941',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13313825373','\n13313825373','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681315495942',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18250850010','\n18250850010','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681319690242',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959517575','\n15959517575','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681319690243',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906095618','\n13906095618','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681319690244',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559554933','\n13559554933','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681319690245',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15389303652','\n15389303652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681319690246',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505986964','\n13505986964','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681319690247',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18740431050','\n18740431050','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681319690248',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805955751','\n15805955751','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681323884545',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505050069','\n13505050069','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681323884546',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13649283497','\n13649283497','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681323884547',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959590927','\n15959590927','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681323884548',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18759919815','\n18759919815','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681323884549',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13314987388','\n13314987388','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681323884550',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18065606507','\n18065606507','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681328078850',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759496852','\n15759496852','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681328078851',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059556400','\n15059556400','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681328078852',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859996145','\n18859996145','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681328078853',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18192276329','\n18192276329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681328078854',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13400808814','\n13400808814','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681357438978',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759590781','\n15759590781','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681365827586',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905950588','\n13905950588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681365827587',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960753968','\n15960753968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681365827588',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13614268392','\n13614268392','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681365827589',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13665959771','\n13665959771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681370021890',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906903291','\n13906903291','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681370021891',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18705052323','\n18705052323','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681370021892',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18701704136','\n18701704136','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681370021893',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18898408023','\n18898408023','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681370021894',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18506966086','\n18506966086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681374216194',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959505915','\n15959505915','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681374216195',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505932929','\n13505932929','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681374216196',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15702950980','\n15702950980','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681374216197',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18159276351','\n18159276351','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681374216198',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960282791','\n13960282791','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681378410498',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799552053','\n13799552053','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681378410499',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13626066721','\n13626066721','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681378410500',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18806028372','\n18806028372','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681378410501',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13030981560','\n13030981560','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681378410502',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18605914467','\n18605914467','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681378410503',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259223745','\n15259223745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681382604801',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659568811','\n18659568811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681382604802',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15559544571','\n15559544571','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681382604803',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18065525518','\n18065525518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681382604804',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17750792370','\n17750792370','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681382604805',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959873463','\n15959873463','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681382604806',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506054328','\n13506054328','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681386799106',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759733818','\n15759733818','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681386799107',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15191815139','\n15191815139','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681386799108',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860902967','\n15860902967','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681420353537',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805097777','\n15805097777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681424547841',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13067154015','\n13067154015','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681424547842',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059850519','\n15059850519','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681428742145',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18392859639','\n18392859639','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681428742146',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13484917236','\n13484917236','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681428742147',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15029140185','\n15029140185','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681432936449',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328500766','\n13328500766','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681432936450',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799557193','\n13799557193','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681432936451',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905055474','\n13905055474','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681432936452',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18606985861','\n18606985861','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681437130754',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876223641','\n18876223641','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681437130755',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788869420','\n13788869420','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681437130756',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18606056998','\n18606056998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681441325058',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15903645816','\n15903645816','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681441325059',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659719331','\n18659719331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681441325060',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659003000','\n18659003000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681441325061',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506969315','\n13506969315','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681445519362',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13313872221','\n13313872221','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681445519363',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328989299','\n13328989299','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681445519364',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260704530','\n15260704530','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681449713666',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799564888','\n13799564888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681449713667',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18350770992','\n18350770992','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681449713668',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15659512626','\n15659512626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681449713669',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905089465','\n13905089465','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681453907969',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15559067588','\n15559067588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681453907970',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18603006276','\n18603006276','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681453907971',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959953589','\n13959953589','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681453907972',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489858089','\n13489858089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681453907973',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13400840823','\n13400840823','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681458102273',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805957117','\n13805957117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681487462402',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960311095','\n13960311095','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681491656706',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860750864','\n13860750864','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681491656707',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808556705','\n13808556705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681491656708',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13256678813','\n13256678813','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681495851009',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13072350035','\n13072350035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681495851010',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905957105','\n13905957105','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681495851011',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506928380','\n13506928380','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681495851012',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905050688','\n15905050688','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681500045314',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805959366','\n13805959366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681500045315',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15202404290','\n15202404290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681500045316',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15821998683','\n15821998683','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681500045317',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15029279845','\n15029279845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681504239617',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15111982965','\n15111982965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681504239618',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15979017673','\n15979017673','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681504239619',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15620636649','\n15620636649','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681504239620',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13484540329','\n13484540329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681508433922',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18316739194','\n18316739194','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681508433923',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980011425','\n15980011425','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681508433924',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18359877950','\n18359877950','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681508433925',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13488103520','\n13488103520','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681508433926',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259519391','\n15259519391','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681508433927',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15202427957','\n15202427957','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681508433928',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13501115138','\n13501115138','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681512628226',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805959125','\n13805959125','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681512628227',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959581739','\n15959581739','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681512628228',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18850496760','\n18850496760','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681512628229',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13572104402','\n13572104402','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681512628230',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15527179406','\n15527179406','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681512628231',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659262866','\n18659262866','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681512628232',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15985751705','\n15985751705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681546182657',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799898116','\n13799898116','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681550376962',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805010196','\n15805010196','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681554571266',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505056755','\n13505056755','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681554571267',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506069249','\n13506069249','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681554571268',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906998897','\n13906998897','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681554571269',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13696900561','\n13696900561','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681558765569',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13774878631','\n13774878631','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681558765570',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599161927','\n13599161927','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681558765571',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759653345','\n15759653345','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681562959873',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18516970130','\n18516970130','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681562959874',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18046311397','\n18046311397','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681562959875',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906999100','\n13906999100','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681562959876',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18292635234','\n18292635234','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681567154178',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15029278847','\n15029278847','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681567154179',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859751591','\n13859751591','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681567154180',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636950560','\n13636950560','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681571348482',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15029236362','\n15029236362','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681571348483',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959840868','\n13959840868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681571348484',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15396583913','\n15396583913','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681571348485',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959861620','\n13959861620','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681575542786',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13920285434','\n13920285434','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681575542787',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805956558','\n13805956558','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681575542788',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15829907184','\n15829907184','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681579737090',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600753338','\n13600753338','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681579737091',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860902576','\n15860902576','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681579737092',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505059996','\n13505059996','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681579737093',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489848301','\n13489848301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681579737094',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505058832','\n13505058832','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681583931394',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13625959920','\n13625959920','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681583931395',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808549828','\n13808549828','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681621680130',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805945051','\n13805945051','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681625874433',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950238890','\n13950238890','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681625874434',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13004886898','\n13004886898','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681630068738',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599936037','\n13599936037','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681630068739',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960259259','\n18960259259','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681630068740',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13612150403','\n13612150403','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681634263041',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13720852551','\n13720852551','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681634263042',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13410024480','\n13410024480','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681634263043',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600738975','\n13600738975','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681638457346',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599127767','\n13599127767','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681638457347',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13659192458','\n13659192458','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681638457348',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060832111','\n15060832111','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681638457349',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959995002','\n18959995002','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681638457350',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506066917','\n13506066917','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681642651649',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788811853','\n13788811853','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681642651650',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060972472','\n15060972472','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681642651651',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600701178','\n13600701178','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681642651652',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506956209','\n13506956209','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681642651653',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959992832','\n18959992832','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681646845954',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060998567','\n15060998567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681646845955',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850799806','\n13850799806','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681646845956',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15623564761','\n15623564761','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681646845957',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13358577766','\n13358577766','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681646845958',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905035169','\n15905035169','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681646845959',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959553375','\n15959553375','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681651040257',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960795588','\n15960795588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681651040258',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859754633','\n13859754633','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681651040259',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506941213','\n13506941213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681651040260',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965699955','\n18965699955','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681651040261',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805950256','\n13805950256','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681692983297',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459562051','\n13459562051','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681697177601',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15605003638','\n15605003638','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681701371905',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905996868','\n15905996868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681701371906',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15080421696','\n15080421696','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681701371907',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905095955','\n15905095955','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681705566209',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860517253','\n15860517253','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681705566210',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13512216307','\n13512216307','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681705566211',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17706067083','\n17706067083','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681705566212',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559532808','\n13559532808','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681709760514',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859495050','\n15859495050','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681709760515',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980036243','\n15980036243','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681709760516',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860901713','\n15860901713','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681713954817',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805952318','\n15805952318','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681713954818',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799239878','\n13799239878','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681713954819',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960279877','\n18960279877','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681713954820',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880931696','\n15880931696','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681718149122',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359556333','\n15359556333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681718149123',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600751875','\n13600751875','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681718149124',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859775220','\n13859775220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681718149125',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905077879','\n15905077879','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681722343426',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905006716','\n15905006716','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681722343427',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13055667605','\n13055667605','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681722343428',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850777555','\n13850777555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681722343429',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18350062033','\n18350062033','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681722343430',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636905051','\n13636905051','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681726537730',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13625994626','\n13625994626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681726537731',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18359837870','\n18359837870','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681726537732',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860763453','\n13860763453','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681726537733',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13004800144','\n13004800144','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681726537734',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850777672','\n13850777672','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681764286466',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18059983988','\n18059983988','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681768480770',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799240204','\n13799240204','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681772675074',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18059993901','\n18059993901','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681772675075',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600709507','\n13600709507','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681772675076',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636903309','\n13636903309','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681772675077',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905971030','\n13905971030','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681772675078',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959596201','\n15959596201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681776869378',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13515055988','\n13515055988','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681776869379',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959888180','\n15959888180','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681776869380',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636906289','\n13636906289','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681776869381',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799850617','\n13799850617','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681781063682',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13774877242','\n13774877242','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681781063683',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850772504','\n13850772504','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681781063684',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13615940087','\n13615940087','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681781063685',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959926888','\n13959926888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681781063686',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559591215','\n13559591215','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681781063687',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059557916','\n15059557916','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681785257985',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260399516','\n15260399516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681785257986',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905006169','\n15905006169','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681785257987',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15985959061','\n15985959061','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681785257988',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950108669','\n13950108669','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681785257989',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808510666','\n13808510666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681785257990',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059528748','\n15059528748','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681789452289',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799797017','\n13799797017','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681789452290',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850755588','\n13850755588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681789452291',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505992220','\n13505992220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681789452292',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15985905430','\n15985905430','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681789452293',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959941521','\n13959941521','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681789452294',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860703356','\n13860703356','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681789452295',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18633637251','\n18633637251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681831395329',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959856161','\n13959856161','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681835589633',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506055166','\n13506055166','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681835589634',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959910000','\n13959910000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681839783938',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880881006','\n15880881006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681839783939',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959996388','\n18959996388','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681839783940',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960382970','\n13960382970','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681839783941',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860757775','\n13860757775','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681843978242',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489719977','\n13489719977','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681843978243',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15906066156','\n15906066156','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681843978244',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959592923','\n15959592923','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681843978245',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860396396','\n15860396396','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681843978246',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559592136','\n13559592136','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681848172545',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505045259','\n13505045259','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681848172546',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060946052','\n15060946052','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681848172547',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18815985602','\n18815985602','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681848172548',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880881883','\n15880881883','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681852366850',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959592127','\n15959592127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681852366851',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905059153','\n13905059153','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681852366852',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18950026794','\n18950026794','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681852366853',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859989821','\n13859989821','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681852366854',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506045449','\n13506045449','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681852366855',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18750931024','\n18750931024','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681856561153',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960391700','\n13960391700','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681856561154',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960459977','\n13960459977','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681856561155',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876539791','\n18876539791','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681856561156',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860302368','\n15860302368','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681856561157',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505961108','\n13505961108','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681856561158',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960292725','\n13960292725','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681860755458',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905032289','\n15905032289','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681860755459',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659060047','\n18659060047','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681902698498',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599994541','\n13599994541','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681906892802',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859577452','\n15859577452','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681906892803',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559045209','\n13559045209','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681906892804',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980065535','\n15980065535','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681911087106',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260101691','\n15260101691','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681911087107',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880762096','\n15880762096','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681911087108',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18759508729','\n18759508729','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681911087109',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799896025','\n13799896025','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681915281409',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906934045','\n13906934045','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681915281410',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15159529936','\n15159529936','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681915281411',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18905951960','\n18905951960','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681915281412',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880161129','\n15880161129','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681915281413',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599507077','\n13599507077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681919475713',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799202233','\n13799202233','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681919475714',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13655933296','\n13655933296','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681919475715',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950299290','\n13950299290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681919475716',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505907585','\n13505907585','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681923670017',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13606051571','\n13606051571','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681923670018',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260852001','\n15260852001','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681923670019',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059520014','\n15059520014','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681923670020',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15601588313','\n15601588313','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681923670021',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506066359','\n13506066359','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681923670022',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799899315','\n13799899315','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681927864321',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860703516','\n13860703516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681927864322',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980456333','\n15980456333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681927864323',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506083126','\n13506083126','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681927864324',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15005936026','\n15005936026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681927864325',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060806451','\n15060806451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681932058625',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600703472','\n13600703472','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681932058626',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905350771','\n13905350771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681965613057',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959752857','\n13959752857','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681965613058',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859796399','\n15859796399','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681969807361',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059832543','\n15059832543','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681969807362',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18150983366','\n18150983366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681969807363',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359493923','\n15359493923','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681974001665',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980235626','\n15980235626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681974001666',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959882723','\n13959882723','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681974001667',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559575942','\n13559575942','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681978195970',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15074870926','\n15074870926','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681978195971',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659737170','\n18659737170','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681978195972',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15106087765','\n15106087765','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681978195973',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13774898032','\n13774898032','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681978195974',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13110816682','\n13110816682','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681978195975',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905044580','\n15905044580','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681982390274',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599115973','\n13599115973','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681982390275',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15659450305','\n15659450305','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681982390276',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13675930836','\n13675930836','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681982390277',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060990680','\n15060990680','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681982390278',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18650917845','\n18650917845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681982390279',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15505952026','\n15505952026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681986584578',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18850547191','\n18850547191','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681986584579',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15985923093','\n15985923093','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681986584580',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950362316','\n13950362316','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681986584581',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788852001','\n13788852001','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681986584582',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13685910527','\n13685910527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681986584583',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15083847155','\n15083847155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681986584584',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15106037664','\n15106037664','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681990778882',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808543336','\n13808543336','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681990778883',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13615922291','\n13615922291','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517681990778884',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965636930','\n18965636930','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682028527618',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960296362','\n13960296362','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682032721922',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13063191843','\n13063191843','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682032721923',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15911052916','\n15911052916','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682032721924',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506062515','\n13506062515','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682036916225',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259555117','\n15259555117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682036916226',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659822922','\n18659822922','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682036916227',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13520554703','\n13520554703','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682036916228',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13655601013','\n13655601013','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682036916229',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15806036626','\n15806036626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682036916230',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15080417163','\n15080417163','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682041110530',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15827609588','\n15827609588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682041110531',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880825431','\n15880825431','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682041110532',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859785085','\n18859785085','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682041110533',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13159012670','\n13159012670','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682041110534',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359383458','\n15359383458','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682041110535',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905975697','\n15905975697','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682045304834',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18259060411','\n18259060411','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682045304835',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13075877415','\n13075877415','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682045304836',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905076266','\n15905076266','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682045304837',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980271486','\n15980271486','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682049499137',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13110592357','\n13110592357','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682049499138',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859775715','\n15859775715','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682049499139',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860631416','\n13860631416','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682049499140',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808540799','\n13808540799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682049499141',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15392481724','\n15392481724','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682053693441',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880975265','\n15880975265','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682053693442',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860328381','\n15860328381','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682053693443',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060933526','\n15060933526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682053693444',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18605001313','\n18605001313','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682053693445',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959940177','\n13959940177','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682091442177',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18905080205','\n18905080205','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682095636481',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506057070','\n13506057070','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682099830786',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636993769','\n13636993769','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682099830787',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18250292550','\n18250292550','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682099830788',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060985107','\n15060985107','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682099830789',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050056871','\n18050056871','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682099830790',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060032495','\n15060032495','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682099830791',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860726225','\n13860726225','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682099830792',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18159235825','\n18159235825','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682104025090',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18350535110','\n18350535110','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682104025091',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13121833855','\n13121833855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682104025092',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17750989111','\n17750989111','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682104025093',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13685921872','\n13685921872','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682108219394',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980063533','\n15980063533','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682108219395',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860143467','\n13860143467','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682108219396',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260237093','\n15260237093','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682108219397',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960250701','\n13960250701','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682108219398',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859468355','\n15859468355','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682108219399',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599505962','\n13599505962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682112413698',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259471016','\n15259471016','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682112413699',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18559273254','\n18559273254','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682112413700',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18950070276','\n18950070276','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682116608001',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13404252272','\n13404252272','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682116608002',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259729821','\n15259729821','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682116608003',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459599999','\n13459599999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682116608004',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059823968','\n15059823968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682120802305',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13407735197','\n13407735197','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682120802306',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17715205257','\n17715205257','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682120802307',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15326179637','\n15326179637','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682120802308',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860301827','\n15860301827','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682158551041',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905057579','\n15905057579','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682162745346',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18060501876','\n18060501876','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682162745347',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880758500','\n15880758500','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682166939649',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960581457','\n15960581457','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1303517682166939650',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13400887176','\n13400887176','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682166939651',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459246092','\n13459246092','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682166939652',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13055224466','\n13055224466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682171133953',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15106033846','\n15106033846','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682171133954',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13627292269','\n13627292269','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682171133955',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880990268','\n15880990268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682171133956',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18698399527','\n18698399527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682175328257',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599719905','\n13599719905','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682175328258',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15846593350','\n15846593350','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682175328259',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18314463516','\n18314463516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682175328260',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950364429','\n13950364429','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682179522562',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805026065','\n15805026065','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682179522563',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18750530127','\n18750530127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682179522564',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950092022','\n13950092022','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682183716865',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980067586','\n15980067586','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682183716866',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15810298887','\n15810298887','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682183716867',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859790099','\n13859790099','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682183716868',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260200619','\n15260200619','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682183716869',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15605009590','\n15605009590','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682187911170',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965658201','\n18965658201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682187911171',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059755771','\n15059755771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682187911172',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805948042','\n13805948042','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682187911173',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15827436094','\n15827436094','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682192105474',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459533442','\n13459533442','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682192105475',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13696856720','\n13696856720','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682192105476',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15159887877','\n15159887877','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682225659905',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599172228','\n13599172228','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682229854209',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505008000','\n13505008000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682229854210',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805956092','\n13805956092','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682229854211',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880754887','\n15880754887','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682229854212',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059510022','\n15059510022','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682234048513',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880818089','\n15880818089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682234048514',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18606031846','\n18606031846','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682234048515',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18698360960','\n18698360960','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682234048516',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13689056004','\n13689056004','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682234048517',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13085059001','\n13085059001','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682234048518',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13665965633','\n13665965633','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682238242818',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905070935','\n15905070935','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682238242819',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805003589','\n15805003589','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682238242820',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859554650','\n15859554650','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682238242821',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260720911','\n15260720911','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682238242822',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859498656','\n18859498656','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682238242823',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876284599','\n18876284599','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682238242824',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18750537614','\n18750537614','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682242437122',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050869127','\n18050869127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682242437123',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876377906','\n18876377906','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682242437124',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13950317095','\n13950317095','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682246631425',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905055709','\n15905055709','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682246631426',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13159060909','\n13159060909','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682246631427',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15201615843','\n15201615843','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682246631428',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876240048','\n18876240048','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682246631429',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18065589080','\n18065589080','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682246631430',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505054724','\n13505054724','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682246631431',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18805921912','\n18805921912','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682250825729',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18835792826','\n18835792826','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682250825730',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859745152','\n13859745152','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682292768769',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15906061807','\n15906061807','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682296963074',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860516215','\n15860516215','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682296963075',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859565605','\n15859565605','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682296963076',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18682261122','\n18682261122','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682301157378',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15159724662','\n15159724662','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682301157379',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18698372705','\n18698372705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682301157380',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906998716','\n13906998716','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682305351681',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860900865','\n15860900865','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682305351682',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18815997296','\n18815997296','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682305351683',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959232693','\n15959232693','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682305351684',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18159595252','\n18159595252','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682309545986',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959700369','\n18959700369','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682309545987',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859559078','\n15859559078','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682309545988',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18215628161','\n18215628161','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682309545989',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505990915','\n13505990915','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682309545990',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13779982480','\n13779982480','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682313740290',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13615963766','\n13615963766','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682313740291',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959966729','\n15959966729','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682313740292',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13825584576','\n13825584576','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682313740293',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15122460079','\n15122460079','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682313740294',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788803006','\n13788803006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934594',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980301999','\n15980301999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934595',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18722334354','\n18722334354','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934596',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506061896','\n13506061896','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934597',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18202655266','\n18202655266','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934598',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15922263220','\n15922263220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934599',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18581998214','\n18581998214','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934600',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059839423','\n15059839423','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934601',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600759390','\n13600759390','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682317934602',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860358661','\n15860358661','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682368266242',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18559511816','\n18559511816','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682372460546',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13275049035','\n13275049035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682376654850',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13030982553','\n13030982553','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682376654851',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18559552007','\n18559552007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682376654852',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959264462','\n15959264462','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682380849153',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599710039','\n13599710039','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682380849154',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15559528807','\n15559528807','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682380849155',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799239129','\n13799239129','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682380849156',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880027485','\n15880027485','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682385043458',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18292491251','\n18292491251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682385043459',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15159739903','\n15159739903','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682385043460',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13706991487','\n13706991487','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682385043461',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18006037070','\n18006037070','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682389237761',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13055336977','\n13055336977','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682389237762',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18906999069','\n18906999069','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682389237763',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876569027','\n18876569027','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682389237764',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13030978969','\n13030978969','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682389237765',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859553823','\n15859553823','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682393432066',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15906066000','\n15906066000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682393432067',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980274172','\n15980274172','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682393432068',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506998846','\n13506998846','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682393432069',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980068126','\n15980068126','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682393432070',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960259810','\n13960259810','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682393432071',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060804302','\n15060804302','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682393432072',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876539839','\n18876539839','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682397626369',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050878555','\n18050878555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682397626370',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960826248','\n13960826248','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682397626371',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18650916825','\n18650916825','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682397626372',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15280423942','\n15280423942','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682397626373',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659069495','\n18659069495','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682439569409',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18006990697','\n18006990697','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682443763713',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15280404202','\n15280404202','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682443763714',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328979519','\n13328979519','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682443763715',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959812033','\n13959812033','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682447958018',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15159790586','\n15159790586','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682447958019',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18350776066','\n18350776066','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682447958020',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18868801836','\n18868801836','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682452152322',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13859085700','\n13859085700','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682452152323',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859716793','\n18859716793','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682452152324',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808505910','\n13808505910','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682452152325',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15806017885','\n15806017885','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682452152326',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805956361','\n15805956361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682452152327',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805990003','\n15805990003','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682456346625',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880480928','\n15880480928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682456346626',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980232523','\n15980232523','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682456346627',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13635240509','\n13635240509','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682456346628',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259758239','\n15259758239','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682460540930',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13110982808','\n13110982808','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682460540931',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18046040451','\n18046040451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682460540932',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959569933','\n15959569933','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682460540933',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18250882613','\n18250882613','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682464735233',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860356356','\n15860356356','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682464735234',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18805025309','\n18805025309','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682464735235',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15860353200','\n15860353200','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682468929538',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905996655','\n15905996655','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682468929539',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965513668','\n18965513668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682468929540',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18046009745','\n18046009745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682468929541',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13055650678','\n13055650678','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682473123842',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960254757','\n13960254757','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682473123843',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15806019077','\n15806019077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682510872578',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505097888','\n13505097888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682519261186',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599106745','\n13599106745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682519261187',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15160441962','\n15160441962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682519261188',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959717283','\n13959717283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682519261189',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636959434','\n13636959434','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682523455489',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960746554','\n15960746554','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682523455490',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905985743','\n13905985743','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682523455491',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905079763','\n13905079763','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682523455492',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599978051','\n13599978051','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682527649794',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15280422458','\n15280422458','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682527649795',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18650676688','\n18650676688','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682527649796',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906099550','\n13906099550','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682531844098',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13685000414','\n13685000414','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682531844099',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13665001804','\n13665001804','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682531844100',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960877567','\n18960877567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682531844101',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759296423','\n15759296423','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682536038402',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959552577','\n15959552577','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682536038403',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805073665','\n15805073665','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682536038404',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18876568900','\n18876568900','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682536038405',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18900311779','\n18900311779','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682536038406',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880977738','\n15880977738','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682540232706',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15205011506','\n15205011506','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682540232707',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18605007853','\n18605007853','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682540232708',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18250422227','\n18250422227','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682540232709',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18606942212','\n18606942212','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682540232710',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13067198079','\n13067198079','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682544427009',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18950490831','\n18950490831','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682544427010',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13400539210','\n13400539210','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682544427011',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959530855','\n15959530855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682544427012',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18825160801','\n18825160801','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682598952962',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13163906685','\n13163906685','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682598952963',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18817333998','\n18817333998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682603147265',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15705923619','\n15705923619','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682603147266',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505955686','\n13505955686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682603147267',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559546275','\n13559546275','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682603147268',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13665956888','\n13665956888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682607341569',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980478011','\n15980478011','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682607341570',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259597676','\n15259597676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682607341571',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18559672261','\n18559672261','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682607341572',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18862155979','\n18862155979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682607341573',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659097395','\n18659097395','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682607341574',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15259727676','\n15259727676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682607341575',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905969285','\n13905969285','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682611535873',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15606087056','\n15606087056','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682611535874',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18782977456','\n18782977456','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682611535875',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906091302','\n13906091302','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682611535876',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960408350','\n13960408350','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682611535877',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959946911','\n13959946911','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682611535878',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18960251988','\n18960251988','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682615730177',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060969798','\n15060969798','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682615730178',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359855333','\n15359855333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682615730179',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505071035','\n13505071035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682615730180',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18905059500','\n18905059500','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682615730181',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808525056','\n13808525056','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682619924482',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17705061101','\n17705061101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682619924483',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905059909','\n13905059909','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682619924484',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15985900838','\n15985900838','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682624118786',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799581818','\n13799581818','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682624118787',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13626076868','\n13626076868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682624118788',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960255304','\n13960255304','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682670256130',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959992008','\n15959992008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682674450433',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13615926622','\n13615926622','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682678644737',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959990198','\n15959990198','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682678644738',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636928198','\n13636928198','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682678644739',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260225737','\n15260225737','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682678644740',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808558181','\n13808558181','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682682839041',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905075757','\n13905075757','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682682839042',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905079280','\n13905079280','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682682839043',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13606021816','\n13606021816','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682682839044',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980056221','\n15980056221','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682682839045',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805997206','\n13805997206','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682687033345',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489887652','\n13489887652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682687033346',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506009833','\n13506009833','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682687033347',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18703659101','\n18703659101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682691227649',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13646031399','\n13646031399','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682691227650',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599177919','\n13599177919','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682691227651',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13696857207','\n13696857207','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682691227652',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805941850','\n13805941850','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517682691227653',NULL,'1303517679939764226',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13488682111\n','\n13488682111\n','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL,'2020-09-09 10:16:47',NULL,NULL,NULL),('1303517957749489666',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','15392121201','15392121201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',3,'短信发送成功','2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957753683970',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505905685','\n13505905685','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957753683971',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13675918895','\n13675918895','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957753683972',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959981231','\n18959981231','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957753683973',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959952350','\n13959952350','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957757878273',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489512117','\n13489512117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957757878274',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759500600','\n15759500600','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957757878275',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959921098','\n13959921098','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957757878276',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799870758','\n13799870758','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957757878277',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850753398','\n13850753398','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957757878278',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980025829','\n15980025829','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957762072578',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799855086','\n13799855086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957762072579',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959599793','\n15959599793','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957762072580',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13242884288','\n13242884288','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957762072581',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559550686','\n13559550686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957762072582',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805951761','\n13805951761','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957766266882',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15710646360','\n15710646360','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957766266883',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260838513','\n15260838513','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957766266884',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600704238','\n13600704238','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957766266885',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13316225195','\n13316225195','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957766266886',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860708740','\n13860708740','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957766266887',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805972719','\n15805972719','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957770461186',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960257652','\n13960257652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957770461187',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050888018','\n18050888018','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957770461188',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15080426614','\n15080426614','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957770461189',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959975903','\n13959975903','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957770461190',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18750651805','\n18750651805','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957770461191',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659005089','\n18659005089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957774655490',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506095562','\n13506095562','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957774655491',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960256303','\n13960256303','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957774655492',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13665903960','\n13665903960','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957804015618',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960256111','\n13960256111','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957808209921',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18905079898','\n18905079898','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957808209922',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15359508512','\n15359508512','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957808209923',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505051522','\n13505051522','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957808209924',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18959853655','\n18959853655','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957812404225',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859505750','\n15859505750','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957812404226',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13601076764','\n13601076764','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957812404227',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505050692','\n13505050692','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957812404228',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18905060268','\n18905060268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957812404229',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959955769','\n13959955769','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957816598529',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15377953096','\n15377953096','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957816598530',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960731557','\n15960731557','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957816598531',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599715762','\n13599715762','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957816598532',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788826386','\n13788826386','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957816598533',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459523253','\n13459523253','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957816598534',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965667777','\n18965667777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957820792834',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489512136','\n13489512136','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957820792835',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13107880950','\n13107880950','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957820792836',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15750898928','\n15750898928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957820792837',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18950498312','\n18950498312','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957820792838',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15375886386','\n15375886386','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957820792839',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13400507028','\n13400507028','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957820792840',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13587756546','\n13587756546','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957824987137',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959737339','\n13959737339','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957824987138',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659916888','\n18659916888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957824987139',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859525583','\n18859525583','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957824987140',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506059007','\n13506059007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957824987141',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505955666','\n13505955666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957824987142',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18759922187','\n18759922187','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957829181441',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505902557','\n13505902557','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957850152961',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13636951165','\n13636951165','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957854347266',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859590857','\n15859590857','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957854347267',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13850757007','\n13850757007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957854347268',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805957070','\n13805957070','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957854347269',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13860602468','\n13860602468','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957858541569',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13305962813','\n13305962813','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957858541570',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859225776','\n18859225776','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957858541571',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13661356074','\n13661356074','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957858541572',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15606088553','\n15606088553','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957858541573',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13645019389','\n13645019389','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957858541574',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959962792','\n15959962792','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957858541575',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15280875858','\n15280875858','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957862735874',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600788662','\n13600788662','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957862735875',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18030243370','\n18030243370','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957862735876',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18344910844','\n18344910844','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957862735877',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18059147928','\n18059147928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957862735878',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260708136','\n15260708136','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957862735879',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880824003','\n15880824003','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957866930177',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18259061182','\n18259061182','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957866930178',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799857333','\n13799857333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957866930179',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13365952758','\n13365952758','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957866930180',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805951603','\n13805951603','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957866930181',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15375754488','\n15375754488','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957866930182',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13918199745','\n13918199745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957866930183',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15859577777','\n15859577777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957871124481',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059597777','\n15059597777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957871124482',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18850383723','\n18850383723','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957871124483',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15606946335','\n15606946335','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957871124484',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805997578','\n13805997578','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957871124485',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060933832','\n15060933832','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957900484609',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059871315','\n15059871315','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957904678913',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18750654331','\n18750654331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957904678914',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599751999','\n13599751999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957904678915',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13906099845','\n13906099845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957908873218',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880024622','\n15880024622','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957908873219',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980041722','\n15980041722','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957908873220',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859552366','\n18859552366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957908873221',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859626598','\n18859626598','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957908873222',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600766763','\n13600766763','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957908873223',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18850549376','\n18850549376','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957913067522',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060827887','\n15060827887','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957913067523',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859495931','\n18859495931','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957913067524',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959990680','\n15959990680','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957913067525',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18605958852','\n18605958852','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957913067526',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905909283','\n15905909283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957913067527',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15805060325','\n15805060325','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957913067528',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059720864','\n15059720864','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957917261825',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15620633941','\n15620633941','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957917261826',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15980006525','\n15980006525','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957917261827',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15880764254','\n15880764254','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957917261828',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15260813616','\n15260813616','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957917261829',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18100525107','\n18100525107','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957917261830',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859763636','\n18859763636','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957917261831',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18396220746','\n18396220746','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957921456129',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13959888168','\n13959888168','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957921456130',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18559477701','\n18559477701','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957921456131',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18750561717','\n18750561717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957921456132',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759596655','\n15759596655','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957921456133',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13905955872','\n13905955872','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957921456134',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13605944765','\n13605944765','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957950816257',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13599717079','\n13599717079','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957955010561',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505954433','\n13505954433','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957955010562',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808552366','\n13808552366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957955010563',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13615908669','\n13615908669','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957955010564',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13655928585','\n13655928585','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957959204865',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13386880667','\n13386880667','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957959204866',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13506030795','\n13506030795','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957959204867',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15959882366','\n15959882366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957959204868',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905988871','\n15905988871','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957959204869',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788833384','\n13788833384','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957959204870',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960305030','\n13960305030','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957963399170',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13338583366','\n13338583366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957963399171',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960250972','\n15960250972','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957963399172',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13505905737','\n13505905737','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957963399173',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15280081010','\n15280081010','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957963399174',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788805366','\n13788805366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957967593473',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559369710','\n13559369710','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957967593474',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13788816686','\n13788816686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957967593475',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13067166871','\n13067166871','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957967593476',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600785508','\n13600785508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957967593477',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13805065379','\n13805065379','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957971787777',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13459218283','\n13459218283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957971787778',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18005073259','\n18005073259','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957971787779',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18005065560','\n18005065560','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957971787780',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13107891508','\n13107891508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957975982082',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15605959006','\n15605959006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957975982083',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13645971717','\n13645971717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957975982084',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15396503999','\n15396503999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957975982085',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18705045726','\n18705045726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517957980176386',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050270931','\n18050270931','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958005342209',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n17758766631','\n17758766631','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958009536514',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15071360501','\n15071360501','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958009536515',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13305952629','\n13305952629','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958013730817',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15659132085','\n15659132085','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958013730818',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13400886486','\n13400886486','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958013730819',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15305009255','\n15305009255','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958013730820',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15080406979','\n15080406979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958013730821',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18359592597','\n18359592597','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958013730822',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050916965','\n18050916965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958017925122',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050876301','\n18050876301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958017925123',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15905903705','\n15905903705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958017925124',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328505767','\n13328505767','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958017925125',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13799866661','\n13799866661','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958017925126',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13285957289','\n13285957289','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958017925127',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15396596855','\n15396596855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958022119426',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13559513508','\n13559513508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958022119427',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13229424859','\n13229424859','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958022119428',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13645032611','\n13645032611','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958022119429',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15059154896','\n15059154896','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958022119430',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18650591551','\n18650591551','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958022119431',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18965662565','\n18965662565','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958022119432',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15759216753','\n15759216753','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958026313730',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960217968','\n15960217968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958026313731',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13960326290','\n13960326290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958026313732',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18905051668','\n18905051668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958026313733',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13159037366','\n13159037366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958026313734',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600703555','\n13600703555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958026313735',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13489387611','\n13489387611','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958026313736',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15060619686','\n15060619686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958030508034',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18084725997','\n18084725997','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958055673858',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13901318357','\n13901318357','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958059868161',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18805065856','\n18805065856','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958059868162',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13295908788','\n13295908788','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958064062465',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13328883775','\n13328883775','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958064062466',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13600704026','\n13600704026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958064062467',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15392286115','\n15392286115','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958064062468',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15392288851','\n15392288851','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958064062469',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18859781366','\n18859781366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958064062470',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15960692650','\n15960692650','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958068256770',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13255957226','\n13255957226','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958068256771',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18225662357','\n18225662357','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958068256772',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18659923130','\n18659923130','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958068256773',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13615950806','\n13615950806','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958068256774',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n15315563156','\n15315563156','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958068256775',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n18050020726','\n18050020726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958072451074',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13205061526','\n13205061526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303517958072451075',NULL,'1303517957380390914',2,2,'批量发送(关于开展晋江市2019年度优秀人才 购房补贴申报工作的通知20200909)','\n13808512082','\n13808512082','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2020年9月9日至9月17日组织开展2019年度优秀人才购房补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请大家相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，非此次申报对象请忽略)',1,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL,'2020-09-09 10:17:53',NULL,NULL,NULL),('1303564308881358849',NULL,'1303564308881358849',2,1,NULL,'17758768226','192363','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-09 13:22:04',NULL,NULL,NULL,'2020-09-09 13:22:04',NULL,NULL,NULL),('1303623567920889858',NULL,'1303623567920889858',2,1,NULL,'13489551288','383219','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-09 17:17:33',NULL,NULL,NULL,'2020-09-09 17:17:33',NULL,NULL,NULL),('1303856553119481858','1301823981006909441','1303856553119481858',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 08:43:21',NULL,NULL,NULL,'2020-09-10 08:43:21',NULL,NULL,NULL),('1303858516787757057','1303564489018327042','1303858516787757057',2,2,'泉州百福纸业有限公司','17758768226','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-10 08:51:09',NULL,NULL,NULL,'2020-09-10 08:51:09',NULL,NULL,NULL),('1303860742222544897','1212685717864517633','1303860742222544897',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742394511362','1211444027140915202','1303860742394511362',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742579060738','1211601884993863681','1303860742579060738',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742621003777','72','1303860742621003777',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742633586690','72','1303860742633586690',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742763610114','1213031390673702913','1303860742763610114',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742855884802','1211925547903401986','1303860742855884802',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742969131009','1215207699331989506','1303860742969131009',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743048822785','58','1303860743048822785',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743053017089','1212536999949438978','1303860743053017089',2,2,'晋江市医院晋南分院','15396486268','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743065600001','58','1303860743065600001',1,2,'张荣荣','15280619456','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743237566466','1219241646047223809','1303860743237566466',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743321452546','87','1303860743321452546',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743350812674','1212731840222269441','1303860743350812674',2,2,'福建中策光电股份公司','18006999862','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743355006978','87','1303860743355006978',1,2,'叶志钦','13675957398','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743430504450','1241252588561698817','1303860743430504450',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743539556353','97','1303860743539556353',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743539556354','97','1303860743539556354',1,2,'吴思莹','12345674868','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743564722177','1214017346281164801','1303860743564722177',2,2,'晋江富海鸿汽车贸易有限公司','18050888018','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743753465858','1214020915189272577','1303860743753465858',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860743979958274','1214802166888357889','1303860743979958274',2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860744235810818','1214803603139682306','1303860744235810818',2,2,'晋江市总商会投资开发有限公司','15060933526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860744479080450','1215207699331989506','1303860744479080450',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860744676212737','1215532466647908353','1303860744676212737',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860744869150722','1216626668072869889','1303860744869150722',2,2,'晋江市融媒体中心','13599718877','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860745078865921','1216650516390486017','1303860745078865921',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860745267609601','1217242391405154305','1303860745267609601',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860745452158978','1217985949057744898','1303860745452158978',2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860745645096961','1218794464953360385','1303860745645096961',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:00',NULL,NULL,NULL,'2020-09-10 09:00:00',NULL,NULL,NULL),('1303860745829646338','1219428616866152449','1303860745829646338',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:01',NULL,NULL,NULL,'2020-09-10 09:00:01',NULL,NULL,NULL),('1303860746026778625','1219451161745080321','1303860746026778625',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:01',NULL,NULL,NULL,'2020-09-10 09:00:01',NULL,NULL,NULL),('1303860746228105218','1219824202652073985','1303860746228105218',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 09:00:01',NULL,NULL,NULL,'2020-09-10 09:00:01',NULL,NULL,NULL),('1303881528677269505','1297160741345947650','1303881528677269505',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 10:22:36',NULL,NULL,NULL,'2020-09-10 10:22:36',NULL,NULL,NULL),('1303881646172307458','1296659016558051330','1303881646172307458',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 10:23:04',NULL,NULL,NULL,'2020-09-10 10:23:04',NULL,NULL,NULL),('1303881746974015490','1292741409895460865','1303881746974015490',2,2,'广发证券股份有限公司晋江长兴路证券营业部','18559595923','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 10:23:28',NULL,NULL,NULL,'2020-09-10 10:23:28',NULL,NULL,NULL),('1303881814175154178','1290850604855361537','1303881814175154178',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-10 10:23:44',NULL,NULL,NULL,'2020-09-10 10:23:44',NULL,NULL,NULL),('1303883313441701889',NULL,'1303883313441701889',2,1,NULL,'18299000000','180718','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 10:29:41',NULL,NULL,NULL,'2020-09-10 10:29:41',NULL,NULL,NULL),('1303894924323749890',NULL,'1303894924323749890',2,1,NULL,'13489551288','470551','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 11:15:49',NULL,NULL,NULL,'2020-09-10 11:15:49',NULL,NULL,NULL),('1303954151385890818',NULL,'1303954151385890818',2,1,NULL,'13599106460','132647','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 15:11:10',NULL,NULL,NULL,'2020-09-10 15:11:10',NULL,NULL,NULL),('1303955580557230082',NULL,'1303955580557230082',2,1,NULL,'13599106460','585267','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 15:16:51',NULL,NULL,NULL,'2020-09-10 15:16:51',NULL,NULL,NULL),('1303974017690009601',NULL,'1303974017690009601',2,1,NULL,'15260225737','221510','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 16:30:07',NULL,NULL,NULL,'2020-09-10 16:30:07',NULL,NULL,NULL),('1303974375107624962',NULL,'1303974375107624962',2,1,NULL,'13505952596','396336','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 16:31:32',NULL,NULL,NULL,'2020-09-10 16:31:32',NULL,NULL,NULL),('1303974689726562305',NULL,'1303974689726562305',2,1,NULL,'13505952596','956946','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 16:32:47',NULL,NULL,NULL,'2020-09-10 16:32:47',NULL,NULL,NULL),('1303977494411509762',NULL,'1303977494411509762',2,1,NULL,'13505952596','353429','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-10 16:43:56',NULL,NULL,NULL,'2020-09-10 16:43:56',NULL,NULL,NULL),('1304217196934758401','1297160741345947650','1304217196934758401',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-11 08:36:25',NULL,NULL,NULL,'2020-09-11 08:36:25',NULL,NULL,NULL),('1304217332473692161','1301823981006909441','1304217332473692161',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 08:36:57',NULL,NULL,NULL,'2020-09-11 08:36:57',NULL,NULL,NULL),('1304218527309266946','1303955626757488641','1304218527309266946',2,2,'恒安(中国)纸业有限公司','13599106460','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-11 08:41:42',NULL,NULL,NULL,'2020-09-11 08:41:42',NULL,NULL,NULL),('1304221117484924929','1301823981006909441','1304221117484924929',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-11 08:52:00',NULL,NULL,NULL,'2020-09-11 08:52:00',NULL,NULL,NULL),('1304223129467387906','1211444027140915202','1304223129467387906',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129572245506','1212685717864517633','1304223129572245506',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129572245507','1211110678463623169','1304223129572245507',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129777766402','72','1304223129777766402',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129828098050','72','1304223129828098050',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129991675906','1211601884993863681','1304223129991675906',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129995870210','1213031390673702913','1304223129995870210',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130180419585','58','1304223130180419585',1,2,'张荣荣','15280619456','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130213974018','1215207699331989506','1304223130213974018',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130268499969','58','1304223130268499969',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130268499970','1211832959498240001','1304223130268499970',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130331414530','87','1304223130331414530',1,2,'叶志钦','13675957398','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130436272130','1211925547903401986','1304223130436272130',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130465632258','1219241646047223809','1304223130465632258',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130524352514','87','1304223130524352514',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130524352515','97','1304223130524352515',1,2,'吴思莹','12345674868','9,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130683736066','1241252588561698817','1304223130683736066',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130696318978','97','1304223130696318978',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130708901890','1211936041519333377','1304223130708901890',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223130901839873','1212271071303110658','1304223130901839873',2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223131191246850','1212536999949438978','1304223131191246850',2,2,'晋江市医院晋南分院','15396486268','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223131388379137','1212731840222269441','1304223131388379137',2,2,'福建中策光电股份公司','18006999862','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223131690369026','1214020915189272577','1304223131690369026',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223131908472833','1214052741177954306','1304223131908472833',2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223132097216514','1214802166888357889','1304223132097216514',2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223132302737410','1215207699331989506','1304223132302737410',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223132516646913','1215532466647908353','1304223132516646913',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223132709584898','1215548205433929729','1304223132709584898',2,2,'龙之族（中国）有限公司','15805972719','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223132881551362','1216650516390486017','1304223132881551362',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223133061906434','1218794464953360385','1304223133061906434',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223133246455809','1219428616866152449','1304223133246455809',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223133540057090','1219451161745080321','1304223133540057090',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:00',NULL,NULL,NULL,'2020-09-11 09:00:00',NULL,NULL,NULL),('1304223133737189377','1219824202652073985','1304223133737189377',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-11 09:00:01',NULL,NULL,NULL,'2020-09-11 09:00:01',NULL,NULL,NULL),('1304238322079531010',NULL,'1304238322079531010',2,1,NULL,'15805039263','572463','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-11 10:00:22',NULL,NULL,NULL,'2020-09-11 10:00:22',NULL,NULL,NULL),('1304239788257214465',NULL,'1304239788257214465',2,1,NULL,'18759762083','731833','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-11 10:06:11',NULL,NULL,NULL,'2020-09-11 10:06:11',NULL,NULL,NULL),('1304252254676615170','1304240436428177410','1304252254676615170',2,2,'泉州盈海汽车有限公司','18759762083','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-11 10:55:44',NULL,NULL,NULL,'2020-09-11 10:55:44',NULL,NULL,NULL),('1304480613830524929',NULL,'1304480613830524929',2,1,NULL,'13960255304','461257','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-12 02:03:09',NULL,NULL,NULL,'2020-09-12 02:03:09',NULL,NULL,NULL),('1305062428924477441',NULL,'1305062428924477441',2,1,NULL,'13123130025','466724','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-13 16:35:04',NULL,NULL,NULL,'2020-09-13 16:35:04',NULL,NULL,NULL),('1305098830718468098',NULL,'1305098830718468098',2,1,NULL,'15980235626','103194','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-13 18:59:43',NULL,NULL,NULL,'2020-09-13 18:59:43',NULL,NULL,NULL),('1305310293122908161','1212685717864517633','1305310293122908161',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293122908162','1211110678463623169','1305310293122908162',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293202599938','1211444027140915202','1305310293202599938',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293299068930','72','1305310293299068930',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293307457537','72','1305310293307457537',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293496201218','1213031390673702913','1305310293496201218',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293508784129','1211492544651771905','1305310293508784129',2,2,'晋江凯燕新材料科技有限公司','13255957226','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293659779074','58','1305310293659779074',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293697527810','1211925547903401986','1305310293697527810',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293697527811','58','1305310293697527811',1,2,'张荣荣','15280619456','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293722693633','1215207699331989506','1305310293722693633',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293835939841','87','1305310293835939841',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293869494273','87','1305310293869494273',1,2,'叶志钦','13675957398','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293877882882','1212271071303110658','1305310293877882882',2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293903048706','1219241646047223809','1305310293903048706',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294041460738','97','1305310294041460738',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294062432258','1212536999949438978','1305310294062432258',2,2,'晋江市医院晋南分院','15396486268','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294079209474','1241252588561698817','1305310294079209474',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294246981634','1212731840222269441','1305310294246981634',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294335062018','97','1305310294335062018',1,2,'吴思莹','12345674868','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294444113921','1214020915189272577','1305310294444113921',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294628663298','1214052741177954306','1305310294628663298',2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294809018369','1214106170453676034','1305310294809018369',2,2,'晋江丰顺食品有限公司','13850777672','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310294985179137','1214802166888357889','1305310294985179137',2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310295165534209','1215207699331989506','1305310295165534209',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310295358472193','1216650516390486017','1305310295358472193',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310295538827265','1218794464953360385','1305310295538827265',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310295819845634','1219181564773130242','1305310295819845634',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310296000200705','1219428616866152449','1305310296000200705',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310296180555777','1219451161745080321','1305310296180555777',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305310296365105154','1219824202652073985','1305310296365105154',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-14 09:00:00',NULL,NULL,NULL,'2020-09-14 09:00:00',NULL,NULL,NULL),('1305461116905771010',NULL,'1305461116905771010',2,1,NULL,'18723935381','724171','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-14 18:59:19',NULL,NULL,NULL,'2020-09-14 18:59:19',NULL,NULL,NULL),('1305672681198243841','1212685717864517633','1305672681198243841',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681198243842','1211444027140915202','1305672681198243842',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681579925506','1211110678463623169','1305672681579925506',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681852555265','72','1305672681852555265',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681852555266','72','1305672681852555266',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681894498306','1211473406755651586','1305672681894498306',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681894498307','1213031390673702913','1305672681894498307',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682141962241','1215207699331989506','1305672682141962241',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682146156545','58','1305672682146156545',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682217459714','1211925547903401986','1305672682217459714',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682301345794','87','1305672682301345794',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682313928705','1219241646047223809','1305672682313928705',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682334900225','58','1305672682334900225',1,2,'张荣荣','15280619456','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682414592002','1212271071303110658','1305672682414592002',2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682498478082','97','1305672682498478082',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682527838210','1241252588561698817','1305672682527838210',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682527838211','87','1305672682527838211',1,2,'叶志钦','13675957398','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682594947074','1212536999949438978','1305672682594947074',2,2,'晋江市医院晋南分院','15396486268','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682687221761','1212580494957416450','1305672682687221761',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672682859188225','97','1305672682859188225',1,2,'吴思莹','12345674868','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672683014377473','1212620045818073089','1305672683014377473',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672683232481282','1212731840222269441','1305672683232481282',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672683417030658','1212930279740608514','1305672683417030658',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672683643523074','1214020915189272577','1305672683643523074',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672683807100930','1214025654970896386','1305672683807100930',2,2,'泉州盈众福海汽车销售有限公司','13489858089','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672683970678785','1214052741177954306','1305672683970678785',2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672684155228162','1214802166888357889','1305672684155228162',2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672684356554754','1215532466647908353','1305672684356554754',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672684524326913','1215550908977430529','1305672684524326913',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672684746625025','1216650516390486017','1305672684746625025',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672684922785793','1217242391405154305','1305672684922785793',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:00',NULL,NULL,NULL,'2020-09-15 09:00:00',NULL,NULL,NULL),('1305672685098946561','1219147136575332354','1305672685098946561',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:01',NULL,NULL,NULL,'2020-09-15 09:00:01',NULL,NULL,NULL),('1305672685296078850','1219181564773130242','1305672685296078850',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:01',NULL,NULL,NULL,'2020-09-15 09:00:01',NULL,NULL,NULL),('1305672685476433922','1219451161745080321','1305672685476433922',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:01',NULL,NULL,NULL,'2020-09-15 09:00:01',NULL,NULL,NULL),('1305672685656788993','1219824202652073985','1305672685656788993',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-15 09:00:01',NULL,NULL,NULL,'2020-09-15 09:00:01',NULL,NULL,NULL),('1305708749696061441',NULL,'1305708749696061441',2,1,NULL,'15059179640','070429','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-15 11:23:19',NULL,NULL,NULL,'2020-09-15 11:23:19',NULL,NULL,NULL),('1306035068858322945','1211473406755651586','1306035068858322945',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035068900265986','1211444027140915202','1306035068900265986',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035068900265987','1212685717864517633','1306035068900265987',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035068992540675','72','1306035068992540675',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069051260929','72','1306035069051260929',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069273559041','1211836173303988226','1306035069273559041',2,2,'福建陆地港集团有限责任公司','17759539230','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069286141953','1213031390673702913','1306035069286141953',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069361639425','58','1306035069361639425',1,2,'张荣荣','15280619456','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069495857153','1211920348237316098','1306035069495857153',2,2,'安踏（中国）有限公司','15160330306','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069508440066','58','1306035069508440066',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069550383106','1215207699331989506','1306035069550383106',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069709766658','87','1306035069709766658',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069713960961','1219241646047223809','1306035069713960961',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069730738177','1211925547903401986','1306035069730738177',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069776875521','87','1306035069776875521',1,2,'叶志钦','13675957398','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069890121729','1241252588561698817','1306035069890121729',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069898510337','97','1306035069898510337',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069927870466','1212271071303110658','1306035069927870466',2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069940453378','97','1306035069940453378',1,2,'吴思莹','12345674868','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035070125002753','1212580494957416450','1306035070125002753',2,2,'舒华体育股份有限公司','13599295908','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035070305357825','1212620045818073089','1306035070305357825',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035070485712897','1212644982180089858','1306035070485712897',2,2,'福建省华晟建设发展有限公司','15392121201','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035070703816705','1212731840222269441','1306035070703816705',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035070896754690','1214020915189272577','1306035070896754690',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035071047749633','1214052741177954306','1306035071047749633',2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035071215521794','1214802166888357889','1306035071215521794',2,2,'福建省晋江人力资本有限公司','13489719977','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035071416848385','1215532466647908353','1306035071416848385',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035071572037633','1215550908977430529','1306035071572037633',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035071731421185','1216650516390486017','1306035071731421185',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035071894999041','1217242391405154305','1306035071894999041',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035072062771201','1219147136575332354','1306035072062771201',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035072255709185','1219181564773130242','1306035072255709185',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035072473812993','1219436923634892801','1306035072473812993',2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035072670945282','1219451161745080321','1306035072670945282',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:00',NULL,NULL,NULL,'2020-09-16 09:00:00',NULL,NULL,NULL),('1306035072922603522','1219824202652073985','1306035072922603522',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-16 09:00:01',NULL,NULL,NULL,'2020-09-16 09:00:01',NULL,NULL,NULL),('1306397456921063425','1212685717864517633','1306397456921063425',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397456950423554','1211098602777194497','1306397456950423554',2,2,'福建省诺美护理用品有限公司','13799487213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397456954617857','1211444027140915202','1306397456954617857',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457353076738','72','1306397457353076738',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457462128642','72','1306397457462128642',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457608929282','1211460552828698626','1306397457608929282',2,2,'雨中鸟（福建）户外用品有限公司','15880885350','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457608929283','1213031390673702913','1306397457608929283',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457705398274','58','1306397457705398274',1,2,'张荣荣','15280619456','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457797672961','1211460918949494786','1306397457797672961',2,2,'大发科技集团有限公司','18959857088','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457831227393','58','1306397457831227393',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457843810306','1215207699331989506','1306397457843810306',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457948667905','87','1306397457948667905',1,2,'叶志钦','13675957398','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458007388162','1211543330165407746','1306397458007388162',2,2,'福建省咭咭文化传播有限公司','18698390251','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458099662849','1219241646047223809','1306397458099662849',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458137411585','97','1306397458137411585',1,2,'吴思莹','12345674868','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458175160322','1211559758373371905','1306397458175160322',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458259046401','1241252588561698817','1306397458259046401',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458263240706','87','1306397458263240706',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458347126786','1211609839420096513','1306397458347126786',2,2,'福建省晋江产业发展投资集团有限公司','13599789599','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458435207169','97','1306397458435207169',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458582007809','1211805224986001409','1306397458582007809',2,2,'浩沙实业（福建）有限公司','13905089190','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458758168577','1211914077576675329','1306397458758168577',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397458955300865','1211920348237316098','1306397458955300865',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397459139850241','1211925547903401986','1306397459139850241',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397459299233794','1212271071303110658','1306397459299233794',2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397459454423042','1212580494957416450','1306397459454423042',2,2,'舒华体育股份有限公司','13599295908','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397459630583810','1212620045818073089','1306397459630583810',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397459785773057','1212665763958165505','1306397459785773057',2,2,'泉州安踏鞋材有限公司','18250638258','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397459949350913','1212731840222269441','1306397459949350913',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397460112928770','1213050734480789505','1306397460112928770',2,2,'晋江市梓源农业发展有限公司','18965183911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397460276506626','1214020915189272577','1306397460276506626',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397460444278785','1214052741177954306','1306397460444278785',2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397460612050946','1215532466647908353','1306397460612050946',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397460775628801','1215550908977430529','1306397460775628801',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:00',NULL,NULL,NULL,'2020-09-17 09:00:00',NULL,NULL,NULL),('1306397461035675650','1216650516390486017','1306397461035675650',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:01',NULL,NULL,NULL,'2020-09-17 09:00:01',NULL,NULL,NULL),('1306397461211836417','1217242391405154305','1306397461211836417',2,2,'晋江市汇鑫小额贷款有限公司','18559529595','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:01',NULL,NULL,NULL,'2020-09-17 09:00:01',NULL,NULL,NULL),('1306397461371219970','1218376015684952065','1306397461371219970',2,2,'福建省兴泰物业管理有限公司','15260225737','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:01',NULL,NULL,NULL,'2020-09-17 09:00:01',NULL,NULL,NULL),('1306397461534797826','1219181564773130242','1306397461534797826',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:01',NULL,NULL,NULL,'2020-09-17 09:00:01',NULL,NULL,NULL),('1306397461689987073','1219436923634892801','1306397461689987073',2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:01',NULL,NULL,NULL,'2020-09-17 09:00:01',NULL,NULL,NULL),('1306397461908090882','1219451161745080321','1306397461908090882',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:01',NULL,NULL,NULL,'2020-09-17 09:00:01',NULL,NULL,NULL),('1306397462075863041','1219824202652073985','1306397462075863041',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-17 09:00:01',NULL,NULL,NULL,'2020-09-17 09:00:01',NULL,NULL,NULL),('1306525512511844353','1296659016558051330','1306525512511844353',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-17 17:28:50',NULL,NULL,NULL,'2020-09-17 17:28:50',NULL,NULL,NULL),('1306531844296077313','1211184671690436610','1306531844296077313',2,2,'泉州市里仁财务咨询有限公司','15880720190','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-17 17:54:00',NULL,NULL,NULL,'2020-09-17 17:54:00',NULL,NULL,NULL),('1306606147582619650',NULL,'1306606147582619650',2,1,NULL,'18105071801','895264','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-17 22:49:15',NULL,NULL,NULL,'2020-09-17 22:49:15',NULL,NULL,NULL),('1306759844597919745','1211490446086291458','1306759844597919745',2,2,'泉州职业技术大学','18060007601','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844627279874','1211444027140915202','1306759844627279874',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844690194434','1211460552828698626','1306759844690194434',2,2,'雨中鸟（福建）户外用品有限公司','15880885350','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844845383682','72','1306759844845383682',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844849577985','83','1306759844849577985',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844874743809','72','1306759844874743809',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845076070401','1211543330165407746','1306759845076070401',2,2,'福建省咭咭文化传播有限公司','18698390251','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845088653314','1212685717864517633','1306759845088653314',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845256425473','1211559758373371905','1306759845256425473',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845256425474','58','1306759845256425474',1,2,'张荣荣','15280619456','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845310951425','1213031390673702913','1306759845310951425',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845323534338','58','1306759845323534338',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845420003329','1211805224986001409','1306759845420003329',2,2,'浩沙实业（福建）有限公司','13905089190','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845436780546','87','1306759845436780546',1,2,'叶志钦','13675957398','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845570998274','1215207699331989506','1306759845570998274',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845583581186','87','1306759845583581186',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845696827393','1211914077576675329','1306759845696827393',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845759741953','97','1306759845759741953',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845776519169','1219241646047223809','1306759845776519169',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845868793858','97','1306759845868793858',1,2,'吴思莹','12345674868','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845902348290','1211920348237316098','1306759845902348290',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759845948485634','1220269594833338369','1306759845948485634',2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759846082703361','1211925547903401986','1306759846082703361',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759846145617921','1241252588561698817','1306759846145617921',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759846250475521','1212271071303110658','1306759846250475521',2,2,'晋江东石源远水产研究推广中心','13959717808','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'黑名单','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759846409859074','1212731840222269441','1306759846409859074',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759846594408449','1213050734480789505','1306759846594408449',2,2,'晋江市梓源农业发展有限公司','18965183911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759846841872386','1214020915189272577','1306759846841872386',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759847030616065','1214052741177954306','1306759847030616065',2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759847215165442','1215115207978827777','1306759847215165442',2,2,'福州大学晋江科教园管委会','15980228632','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759847399714817','1215532466647908353','1306759847399714817',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759847592652802','1215550908977430529','1306759847592652802',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759847789785089','1216650516390486017','1306759847789785089',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759848054026241','1219181564773130242','1306759848054026241',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759848234381314','1219436923634892801','1306759848234381314',2,2,'三斯达（福建）塑胶有限公司','15375886386','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759848498622466','1219451161745080321','1306759848498622466',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:00',NULL,NULL,NULL,'2020-09-18 09:00:00',NULL,NULL,NULL),('1306759848754475009','1219824202652073985','1306759848754475009',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-18 09:00:01',NULL,NULL,NULL,'2020-09-18 09:00:01',NULL,NULL,NULL),('1306846534419148801',NULL,'1306846534419148801',2,1,NULL,'13959957107','115522','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-18 14:44:28',NULL,NULL,NULL,'2020-09-18 14:44:28',NULL,NULL,NULL),('1307842561896935425',NULL,'1307842561896935425',2,1,NULL,'13395955061','084126','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-21 08:42:19',NULL,NULL,NULL,'2020-09-21 08:42:19',NULL,NULL,NULL),('1307847008224079874','1211444027140915202','1307847008224079874',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008224079875','1211490446086291458','1307847008224079875',2,2,'泉州职业技术大学','18060007601','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008224079876','1211460552828698626','1307847008224079876',2,2,'雨中鸟（福建）户外用品有限公司','15880885350','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008433795075','83','1307847008433795075',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008517681154','72','1307847008517681154',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008538652674','72','1307847008538652674',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008618344450','1211559758373371905','1307847008618344450',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008685453314','1212685717864517633','1307847008685453314',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008786116609','1211914077576675329','1307847008786116609',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008878391297','1213031390673702913','1307847008878391297',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008924528641','58','1307847008924528641',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008928722946','58','1307847008928722946',1,2,'张荣荣','15280619456','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008974860290','1211920348237316098','1307847008974860290',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009046163458','1215207699331989506','1307847009046163458',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009113272321','87','1307847009113272321',1,2,'叶志钦','13675957398','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009125855233','1211925547903401986','1307847009125855233',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009230712834','1219241646047223809','1307847009230712834',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009276850178','97','1307847009276850178',1,2,'吴思莹','12345674868','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009314598913','1214020915189272577','1307847009314598913',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009398484994','87','1307847009398484994',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009440428033','1220269594833338369','1307847009440428033',2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009486565377','1214052741177954306','1307847009486565377',2,2,'泉州众德机械有限公司','15905970382','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009583034369','97','1307847009583034369',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009629171713','1241252588561698817','1307847009629171713',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009658531842','1215115207978827777','1307847009658531842',2,2,'福州大学晋江科教园管委会','15980228632','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009813721089','1289035100629032961','1307847009813721089',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847009838886914','1215532466647908353','1307847009838886914',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847010006659073','1215550908977430529','1307847010006659073',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847010212179970','1216650516390486017','1307847010212179970',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847010400923649','1219181564773130242','1307847010400923649',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847010593861634','1219451161745080321','1307847010593861634',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307847010770022402','1219824202652073985','1307847010770022402',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-21 09:00:00',NULL,NULL,NULL,'2020-09-21 09:00:00',NULL,NULL,NULL),('1307878985983651841',NULL,'1307878985983651841',2,1,NULL,'15880775599','675242','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-21 11:07:04',NULL,NULL,NULL,'2020-09-21 11:07:04',NULL,NULL,NULL),('1308209396085485570','1211474926804975617','1308209396085485570',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396085485571','1211460552828698626','1308209396085485571',2,2,'雨中鸟（福建）户外用品有限公司','15880885350','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396148400130','1211444027140915202','1308209396148400130',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396249063425','83','1308209396249063425',1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396261646338','72','1308209396261646338',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396379086849','72','1308209396379086849',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396479750145','1214748606972649473','1308209396479750145',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396479750146','1211559758373371905','1308209396479750146',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396483944450','1211490446086291458','1308209396483944450',2,2,'泉州职业技术大学','18060007601','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396681076738','1211914077576675329','1308209396681076738',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396693659649','1212685717864517633','1308209396693659649',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396718825473','58','1308209396718825473',1,2,'张荣荣','15280619456','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396781740034','58','1308209396781740034',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396853043202','1211920348237316098','1308209396853043202',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396869820418','1213031390673702913','1308209396869820418',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396911763457','87','1308209396911763457',1,2,'叶志钦','13675957398','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396953706497','87','1308209396953706497',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397071147010','1211925547903401986','1308209397071147010',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397071147011','1215207699331989506','1308209397071147011',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397075341314','97','1308209397075341314',1,2,'吴思莹','12345674868','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397201170434','97','1308209397201170434',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397264084993','1212731840222269441','1308209397264084993',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397293445122','1216568840104734722','1308209397293445122',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397431857154','1214020915189272577','1308209397431857154',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397507354626','1219241646047223809','1308209397507354626',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397587046401','1215532466647908353','1308209397587046401',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397658349570','1220269594833338369','1308209397658349570',2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397750624258','1215550908977430529','1308209397750624258',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397830316033','1241252588561698817','1308209397830316033',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397922590722','1216650516390486017','1308209397922590722',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209397989699585','1289035100629032961','1308209397989699585',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209398140694529','1219181564773130242','1308209398140694529',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209398304272385','1219451161745080321','1308209398304272385',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308209398472044546','1219824202652073985','1308209398472044546',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-22 09:00:00',NULL,NULL,NULL,'2020-09-22 09:00:00',NULL,NULL,NULL),('1308571784072720386','1211444027140915202','1308571784072720386',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784114663425','1211456215943528450','1308571784114663425',2,2,'福建泉成机械有限公司','15392286115','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784123052034','1211474926804975617','1308571784123052034',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784311795714','72','1308571784311795714',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784324378626','72','1308571784324378626',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784433430530','1211920348237316098','1308571784433430530',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784446013441','1214748606972649473','1308571784446013441',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784475373570','1211490953219588098','1308571784475373570',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784664117249','1211925547903401986','1308571784664117249',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784693477378','1212685717864517633','1308571784693477378',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784710254594','58','1308571784710254594',1,2,'张荣荣','15280619456','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784777363458','58','1308571784777363458',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784844472321','1212731840222269441','1308571784844472321',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784898998273','1213031390673702913','1308571784898998273',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784936747010','87','1308571784936747010',1,2,'叶志钦','13675957398','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784966107137','87','1308571784966107137',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785020633090','1214020915189272577','1308571785020633090',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785100324865','1215207699331989506','1308571785100324865',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785142267905','97','1308571785142267905',1,2,'吴思莹','12345674868','11,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785142267906','97','1308571785142267906',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785196793857','1214796116982325250','1308571785196793857',2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785284874241','1218160739617931266','1308571785284874241',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785351983105','1215532466647908353','1308571785351983105',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785469423617','1219241646047223809','1308571785469423617',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785544921090','1215550908977430529','1308571785544921090',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785645584386','1220269594833338369','1308571785645584386',2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785725276162','1216650516390486017','1308571785725276162',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785817550849','1241252588561698817','1308571785817550849',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785884659713','1217985949057744898','1308571785884659713',2,2,'福建荣荣新材料股份有限公司','15960417947','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571785993711618','1289035100629032961','1308571785993711618',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571786052431873','1219181564773130242','1308571786052431873',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571786174066690','1298548254794969089','1308571786174066690',2,2,'福建省晋江市金童蚊香制品有限公司','13506085037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571786220204033','1219451161745080321','1308571786220204033',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571786362810369','1300227590451228674','1308571786362810369',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571786396364801','1219824202652073985','1308571786396364801',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308571786547359746','1301682900063776769','1308571786547359746',2,2,'福建天工房地产开发有限公司','15659885820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-23 09:00:00',NULL,NULL,NULL,'2020-09-23 09:00:00',NULL,NULL,NULL),('1308692546427351042',NULL,'1308692546427351042',2,1,NULL,'13358438305','368979','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-23 16:59:52',NULL,NULL,NULL,'2020-09-23 16:59:52',NULL,NULL,NULL),('1308934171829268481','1211444027140915202','1308934171829268481',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934171858628609','1211456215943528450','1308934171858628609',2,2,'福建泉成机械有限公司','15392286115','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934171913154562','1211164549680574466','1308934171913154562',2,2,'乔丹体育股份有限公司','18659597668','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172097703938','72','1308934172097703938',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172173201410','83','1308934172173201410',1,2,'李女元','15359825666','11,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172181590017','72','1308934172181590017',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172257087489','1211191315514109954','1308934172257087489',2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172265476098','1211920348237316098','1308934172265476098',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172269670402','1214748606972649473','1308934172269670402',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172454219778','1211925547903401986','1308934172454219778',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172475191298','1211473406755651586','1308934172475191298',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172512940034','58','1308934172512940034',1,2,'张荣荣','15280619456','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172559077378','58','1308934172559077378',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172621991937','1214020915189272577','1308934172621991937',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172684906497','1211474926804975617','1308934172684906497',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172743626753','87','1308934172743626753',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172756209665','87','1308934172756209665',1,2,'叶志钦','13675957398','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172806541313','1215550908977430529','1308934172806541313',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172873650178','1211490446086291458','1308934172873650178',2,2,'泉州职业技术大学','18060007601','12,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172928176130','97','1308934172928176130',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172940759041','97','1308934172940759041',1,2,'吴思莹','12345674868','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172995284993','1216650516390486017','1308934172995284993',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173049810946','1211920348237316098','1308934173049810946',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173175640066','1219181564773130242','1308934173175640066',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173234360321','1211923801521045506','1308934173234360321',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173351800833','1219451161745080321','1308934173351800833',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173418909697','1212535414099873794','1308934173418909697',2,2,'安踏体育用品集团有限公司','18120662230','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173565710337','1219824202652073985','1308934173565710337',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173595070466','1212685717864517633','1308934173595070466',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173783814146','1213031390673702913','1308934173783814146',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934173955780609','1213376299297476609','1308934173955780609',2,2,'福建省海峡建设发展有限公司','15805967556','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934174169690114','1215207699331989506','1308934174169690114',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934174362628097','1218160739617931266','1308934174362628097',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934174547177474','1219241646047223809','1308934174547177474',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934174723338242','1220269594833338369','1308934174723338242',2,2,'福建凯萨王服饰有限公司','15964917281','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934174920470529','1241252588561698817','1308934174920470529',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934175117602818','1275260777149808641','1308934175117602818',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934175323123713','1289035100629032961','1308934175323123713',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934175528644609','1291608243923095553','1308934175528644609',2,2,'福建意乐焙宝生物科技有限公司','13505900864','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934175725776897','1294076991682641922','1308934175725776897',2,2,'福建意尔康体育用品有限公司','15905071236','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:00',NULL,NULL,NULL,'2020-09-24 09:00:00',NULL,NULL,NULL),('1308934175985823745','1297160741345947650','1308934175985823745',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:01',NULL,NULL,NULL,'2020-09-24 09:00:01',NULL,NULL,NULL),('1308934176203927553','1300227590451228674','1308934176203927553',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:01',NULL,NULL,NULL,'2020-09-24 09:00:01',NULL,NULL,NULL),('1308934176384282626','1301682900063776769','1308934176384282626',2,2,'福建天工房地产开发有限公司','15659885820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-24 09:00:01',NULL,NULL,NULL,'2020-09-24 09:00:01',NULL,NULL,NULL),('1309035255818153985',NULL,'1309035255818153985',2,1,NULL,'18559595923','767103','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-24 15:41:40',NULL,NULL,NULL,'2020-09-24 15:41:40',NULL,NULL,NULL),('1309041145254309890',NULL,'1309041145254309890',2,1,NULL,'18559595923','427844','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-24 16:05:04',NULL,NULL,NULL,'2020-09-24 16:05:04',NULL,NULL,NULL),('1309042509195833346',NULL,'1309042509195833346',2,1,NULL,'13559060725','636920','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-24 16:10:29',NULL,NULL,NULL,'2020-09-24 16:10:29',NULL,NULL,NULL),('1309296559615176706','1211117113914273793','1309296559615176706',2,2,'福建柒牌时装科技股份有限公司','15880936557','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559631953922','1211444027140915202','1309296559631953922',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559711645697','1211920348237316098','1309296559711645697',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559845863426','83','1309296559845863426',1,2,'李女元','15359825666','11,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559887806467','72','1309296559887806467',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559921360898','72','1309296559921360898',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560089133057','1211191315514109954','1309296560089133057',2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560089133058','1214748606972649473','1309296560089133058',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560131076098','1211925547903401986','1309296560131076098',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560223350786','58','1309296560223350786',1,2,'张荣荣','15280619456','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560256905217','1211441648983130114','1309296560256905217',2,2,'兴业皮革科技股份有限公司','18859716647','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560261099521','58','1309296560261099521',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560303042562','1214020915189272577','1309296560303042562',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560412094466','87','1309296560412094466',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560412094467','1211473406755651586','1309296560412094467',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560475009026','1215550908977430529','1309296560475009026',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560567283713','1211474926804975617','1309296560567283713',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560567283714','97','1309296560567283714',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560630198274','87','1309296560630198274',1,2,'叶志钦','13675957398','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560680529921','1216650516390486017','1309296560680529921',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560730861570','1211490446086291458','1309296560730861570',2,2,'泉州职业技术大学','18060007601','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560776998914','97','1309296560776998914',1,2,'吴思莹','12345674868','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560844107778','1219181564773130242','1309296560844107778',2,2,'福建中和新材料科技有限公司','13365952758','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296560890245122','1212535414099873794','1309296560890245122',2,2,'安踏体育用品集团有限公司','18120662230','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561016074241','1219451161745080321','1309296561016074241',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561049628673','1212685717864517633','1309296561049628673',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561188040706','1219824202652073985','1309296561188040706',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561267732481','1213031390673702913','1309296561267732481',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561443893249','1215207699331989506','1309296561443893249',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561620054017','1218160739617931266','1309296561620054017',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561771048961','1219241646047223809','1309296561771048961',2,2,'晋江农商银行','15260663037','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296561951404034','1241252588561698817','1309296561951404034',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296562098204673','1275260777149808641','1309296562098204673',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296562274365441','1286499346338045953','1309296562274365441',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296562475692034','1289035100629032961','1309296562475692034',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296562643464194','1297160741345947650','1309296562643464194',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296562807042049','1297750547696316418','1309296562807042049',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296563020951554','1300227590451228674','1309296563020951554',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309296563192918018','1301682900063776769','1309296563192918018',2,2,'福建天工房地产开发有限公司','15659885820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 09:00:00',NULL,NULL,NULL,'2020-09-25 09:00:00',NULL,NULL,NULL),('1309313980300324865','1292741409895460865','1309313980300324865',2,2,'广发证券股份有限公司晋江长兴路证券营业部','18559595923','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-25 10:09:13',NULL,NULL,NULL,'2020-09-25 10:09:13',NULL,NULL,NULL),('1309392635944824834','1292741409895460865','1309392635944824834',2,2,'广发证券股份有限公司晋江长兴路证券营业部','18559595923','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-25 15:21:46',NULL,NULL,NULL,'2020-09-25 15:21:46',NULL,NULL,NULL),('1309394676272394241',NULL,'1309394676272394241',2,1,NULL,'13506953825','844390','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-25 15:29:52',NULL,NULL,NULL,'2020-09-25 15:29:52',NULL,NULL,NULL),('1309396057666416642',NULL,'1309396057666416642',2,1,NULL,'13506953825','661052','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-25 15:35:22',NULL,NULL,NULL,'2020-09-25 15:35:22',NULL,NULL,NULL),('1309435672829947906','1306606610528923650','1309435672829947906',2,2,'福建省力豪现代农业有限公司','18105071801','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-25 18:12:47',NULL,NULL,NULL,'2020-09-25 18:12:47',NULL,NULL,NULL),('1309436029635194882','1308693126923218945','1309436029635194882',2,2,'泉州市创标专利代理事务所(特殊普通合伙)','13358438305','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-25 18:14:12',NULL,NULL,NULL,'2020-09-25 18:14:12',NULL,NULL,NULL),('1309899955011383298',NULL,'1309899955011383298',2,1,NULL,'15259757067','232651','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-27 00:57:40',NULL,NULL,NULL,'2020-09-27 00:57:40',NULL,NULL,NULL),('1310054090222399489','1309042683217506306','1310054090222399489',2,2,'泉州点津财务咨询有限责任公司','13559060725','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-27 11:10:09',NULL,NULL,NULL,'2020-09-27 11:10:09',NULL,NULL,NULL),('1310054552690552833','1309396118605459457','1310054552690552833',2,2,'晋江超特精铸有限公司','13506953825','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-27 11:11:59',NULL,NULL,NULL,'2020-09-27 11:11:59',NULL,NULL,NULL),('1310383723274891265','1210918631014248450','1310383723274891265',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723295862785','1211444027140915202','1310383723295862785',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723304251394','1210918631014248450','1310383723304251394',2,2,'茂泰（福建）鞋材有限公司','18959705077','3,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723337805826','1211925547903401986','1310383723337805826',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723509772290','72','1310383723509772290',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723589464065','83','1310383723589464065',1,2,'李女元','15359825666','15,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723589464066','72','1310383723589464066',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723711098881','1211092856509411330','1310383723711098881',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723723681793','1212685717864517633','1310383723723681793',2,2,'晋江市中医院','15960586523','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723769819138','1211484578443739137','1310383723769819138',2,2,'晋江市锦福化纤聚合有限公司','13599749329','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723782402050','1214748606972649473','1310383723782402050',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723920814081','1214020915189272577','1310383723920814081',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723920814082','1211191315514109954','1310383723920814082',2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723975340033','58','1310383723975340033',1,2,'张荣荣','15280619456','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723975340034','58','1310383723975340034',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724021477377','1211805224986001409','1310383724021477377',2,2,'浩沙实业（福建）有限公司','13905089190','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724306690050','1215207699331989506','1310383724306690050',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724306690051','1211837849989595138','1310383724306690051',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724340244482','1211441648983130114','1310383724340244482',2,2,'兴业皮革科技股份有限公司','18859716647','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724352827394','87','1310383724352827394',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724352827395','87','1310383724352827395',1,2,'叶志钦','13675957398','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724499628033','1215550908977430529','1310383724499628033',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724499628034','1211920348237316098','1310383724499628034',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724583514114','1211465260200935426','1310383724583514114',2,2,'福建金石能源有限公司','13615901213','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724583514115','97','1310383724583514115',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724587708417','97','1310383724587708417',1,2,'吴思莹','12345674868','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724772257793','1211473406755651586','1310383724772257793',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724776452097','1216650516390486017','1310383724776452097',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724956807169','1211474926804975617','1310383724956807169',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383724973584385','1219451161745080321','1310383724973584385',2,2,'泉州福林汽车销售服务有限公司','15805039263','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383725137162242','1211484578443739137','1310383725137162242',2,2,'晋江市锦福化纤聚合有限公司','13599749329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383725141356546','1219824202652073985','1310383725141356546',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383725309128705','1211490446086291458','1310383725309128705',2,2,'泉州职业技术大学','18060007601','15,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383725493678082','1211497229303463938','1310383725493678082',2,2,'泉州市晋科技术检测有限公司','18960206656','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383725661450242','1211572731150123009','1310383725661450242',2,2,'三六一度(福建)体育用品有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383725833416705','1211574035113099265','1310383725833416705',2,2,'三六一度(中国)有限公司','18350599665','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383725996994562','1211920348237316098','1310383725996994562',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383726160572417','1211923801521045506','1310383726160572417',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383726349316097','1212535414099873794','1310383726349316097',2,2,'安踏体育用品集团有限公司','18120662230','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383726529671170','1212685717864517633','1310383726529671170',2,2,'晋江市中医院','15960586523','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383726705831938','1213031390673702913','1310383726705831938',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383726898769922','1213310396123910145','1310383726898769922',2,2,'晋江市第三医院','13559554933','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383727104290817','1213451329813417985','1310383727104290817',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383727284645890','1214748606972649473','1310383727284645890',2,2,'福建纸匠文化科技股份有限公司','15960759601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:00',NULL,NULL,NULL,'2020-09-28 09:00:00',NULL,NULL,NULL),('1310383727477583873','1215207699331989506','1310383727477583873',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383727657938945','1218160739617931266','1310383727657938945',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383728500994050','1219241646047223809','1310383728500994050',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383728693932033','1241252588561698817','1310383728693932033',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383728886870018','1275260777149808641','1310383728886870018',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383729071419393','1286499346338045953','1310383729071419393',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383729243385858','1289035100629032961','1310383729243385858',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383729406963713','1290251429117808642','1310383729406963713',2,2,'泉州浙平国木雕工艺品有限公司','13505020870','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383729620873218','1292741409895460865','1310383729620873218',2,2,'广发证券股份有限公司晋江长兴路证券营业部','18559595923','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383729797033985','1296659016558051330','1310383729797033985',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383729973194753','1297160741345947650','1310383729973194753',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383730170327042','1297750547696316418','1310383730170327042',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383730354876417','1298793063874949122','1310383730354876417',2,2,'泉州传化公路港物流有限公司','13559076739','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383730531037186','1298925594909732865','1310383730531037186',2,2,'福建柒牌集团有限公司','15959993797','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383730719780866','1299733835944161282','1310383730719780866',2,2,'晋江市含光农业科技有限公司','18717727991','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383730895941633','1301682900063776769','1310383730895941633',2,2,'福建天工房地产开发有限公司','15659885820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310383731088879617','1301823981006909441','1310383731088879617',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-28 09:00:01',NULL,NULL,NULL,'2020-09-28 09:00:01',NULL,NULL,NULL),('1310506270200975361',NULL,'1310506270200975361',2,1,NULL,'13960571971','839417','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-28 17:06:57',NULL,NULL,NULL,'2020-09-28 17:06:57',NULL,NULL,NULL),('1310746111211753474','1211100599215566849','1310746111211753474',2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111312416770','1210918631014248450','1310746111312416770',2,2,'茂泰（福建）鞋材有限公司','18959705077','3,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111404691457','1211444027140915202','1310746111404691457',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111425662977','1210918631014248450','1310746111425662977',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111538909186','72','1310746111538909186',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111580852226','83','1310746111580852226',1,2,'李女元','15359825666','16,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111614406657','72','1310746111614406657',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111635378178','1211444027140915202','1310746111635378178',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111656349698','1211601884993863681','1310746111656349698',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111803150338','1211473406755651586','1310746111803150338',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111828316161','1211920348237316098','1310746111828316161',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111849287682','1211486447580790785','1310746111849287682',2,2,'福建省劲牛重工发展有限公司','18016585576','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111916396546','58','1310746111916396546',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111975116801','1211474926804975617','1310746111975116801',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112042225666','1211925547903401986','1310746112042225666',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112042225667','58','1310746112042225667',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112092557314','87','1310746112092557314',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112176443394','1211490446086291458','1310746112176443394',2,2,'泉州职业技术大学','18060007601','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112226775042','87','1310746112226775042',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112243552258','1212685717864517633','1310746112243552258',2,2,'晋江市中医院','15960586523','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112323244033','97','1310746112323244033',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112335826945','1211497229303463938','1310746112335826945',2,2,'泉州市晋科技术检测有限公司','18960206656','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112402935809','97','1310746112402935809',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112419713026','1214020915189272577','1310746112419713026',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112499404802','1211572731150123009','1310746112499404802',2,2,'三六一度(福建)体育用品有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112587485186','1214079030446280705','1310746112587485186',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112662982658','1211574035113099265','1310746112662982658',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112746868737','1215207699331989506','1310746112746868737',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112818171905','1211920348237316098','1310746112818171905',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746112914640897','1215542604263899137','1310746112914640897',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113057247234','1211923801521045506','1310746113057247234',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113074024449','1216650516390486017','1310746113074024449',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113216630785','1212535414099873794','1310746113216630785',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113237602305','1219451161745080321','1310746113237602305',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113396985857','1212685717864517633','1310746113396985857',2,2,'晋江市中医院','15960586523','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113401180162','1219824202652073985','1310746113401180162',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113560563714','1213031390673702913','1310746113560563714',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113724141570','1215207699331989506','1310746113724141570',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746113925468161','1218160739617931266','1310746113925468161',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746114110017537','1219241646047223809','1310746114110017537',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746114349092865','1241252588561698817','1310746114349092865',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746114516865025','1275260777149808641','1310746114516865025',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746114680442882','1289035100629032961','1310746114680442882',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746114894352386','1290251429117808642','1310746114894352386',2,2,'泉州浙平国木雕工艺品有限公司','13505020870','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746115070513154','1296659016558051330','1310746115070513154',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:00',NULL,NULL,NULL,'2020-09-29 09:00:00',NULL,NULL,NULL),('1310746115259256833','1297160741345947650','1310746115259256833',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:01',NULL,NULL,NULL,'2020-09-29 09:00:01',NULL,NULL,NULL),('1310746115435417601','1297750547696316418','1310746115435417601',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:01',NULL,NULL,NULL,'2020-09-29 09:00:01',NULL,NULL,NULL),('1310746115594801153','1298925594909732865','1310746115594801153',2,2,'福建柒牌集团有限公司','15959993797','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:01',NULL,NULL,NULL,'2020-09-29 09:00:01',NULL,NULL,NULL),('1310746115791933442','1299733835944161282','1310746115791933442',2,2,'晋江市含光农业科技有限公司','18717727991','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:01',NULL,NULL,NULL,'2020-09-29 09:00:01',NULL,NULL,NULL),('1310746115959705601','1301823981006909441','1310746115959705601',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-09-29 09:00:01',NULL,NULL,NULL,'2020-09-29 09:00:01',NULL,NULL,NULL),('1310864149940645890',NULL,'1310864149940645890',2,1,NULL,'18965686555','395664','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-29 16:49:02',NULL,NULL,NULL,'2020-09-29 16:49:02',NULL,NULL,NULL),('1310864825395556354',NULL,'1310864825395556354',2,1,NULL,'18965686555','595232','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-29 16:51:43',NULL,NULL,NULL,'2020-09-29 16:51:43',NULL,NULL,NULL),('1311218012430311425',NULL,'1311218012430311425',2,1,NULL,'13788822586','162906','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-09-30 16:15:10',NULL,NULL,NULL,'2020-09-30 16:15:10',NULL,NULL,NULL),('1311219002143449089','1311218079904079874','1311219002143449089',2,2,'晋江市企业上市服务中心','13788822586','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-09-30 16:19:06',NULL,NULL,NULL,'2020-09-30 16:19:06',NULL,NULL,NULL),('1311470887047831553','1211920348237316098','1311470887047831553',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887190437889','1211473406755651586','1311470887190437889',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887198826498','1211486447580790785','1311470887198826498',2,2,'福建省劲牛重工发展有限公司','18016585576','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887261741058','1211444027140915202','1311470887261741058',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887542759425','72','1311470887542759425',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887542759426','83','1311470887542759426',1,2,'李女元','15359825666','17,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887605673985','72','1311470887605673985',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887656005633','1211610997505179649','1311470887656005633',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887668588545','1211474926804975617','1311470887668588545',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887899275265','1211925547903401986','1311470887899275265',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887928635393','58','1311470887928635393',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887928635394','1211490446086291458','1311470887928635394',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888100601858','1211945767430832130','1311470888100601858',2,2,'晋江市安海医院','13860758785','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888113184770','87','1311470888113184770',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888125767681','58','1311470888125767681',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888222236673','1211574035113099265','1311470888222236673',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888264179713','97','1311470888264179713',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888310317058','1212536999949438978','1311470888310317058',2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888331288577','87','1311470888331288577',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888398397441','1211920348237316098','1311470888398397441',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888499060738','1215207699331989506','1311470888499060738',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888511643649','97','1311470888511643649',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888574558209','1211923801521045506','1311470888574558209',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888671027202','1215542604263899137','1311470888671027202',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888742330370','1212535414099873794','1311470888742330370',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888876548097','1216650516390486017','1311470888876548097',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470888918491138','1212685717864517633','1311470888918491138',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470889048514562','1219451161745080321','1311470889048514562',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470889136594945','1213031390673702913','1311470889136594945',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470889233063938','1219824202652073985','1311470889233063938',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470889329532930','1215207699331989506','1311470889329532930',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470889505693698','1218160739617931266','1311470889505693698',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470889698631682','1219241646047223809','1311470889698631682',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470889883181058','1241252588561698817','1311470889883181058',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470890059341826','1289035100629032961','1311470890059341826',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470890248085506','1290251429117808642','1311470890248085506',2,2,'泉州浙平国木雕工艺品有限公司','13505020870','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470890428440577','1297160741345947650','1311470890428440577',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470890633961474','1299733835944161282','1311470890633961474',2,2,'晋江市含光农业科技有限公司','18717727991','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311470890835288065','1301823981006909441','1311470890835288065',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-01 09:00:00',NULL,NULL,NULL,'2020-10-01 09:00:00',NULL,NULL,NULL),('1311833274716299266','1211920348237316098','1311833274716299266',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833274749853697','1211444027140915202','1311833274749853697',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833274775019522','1211486447580790785','1311833274775019522',2,2,'福建省劲牛重工发展有限公司','18016585576','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833274854711297','1211473406755651586','1311833274854711297',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275001511938','83','1311833275001511938',1,2,'李女元','15359825666','17,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275043454977','72','1311833275043454977',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275043454978','72','1311833275043454978',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275160895489','1211610997505179649','1311833275160895489',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275228004353','1211474926804975617','1311833275228004353',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275324473345','1211925547903401986','1311833275324473345',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275370610690','58','1311833275370610690',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275404165121','58','1311833275404165121',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275408359425','1211490446086291458','1311833275408359425',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275529994242','1211945767430832130','1311833275529994242',2,2,'晋江市安海医院','13860758785','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275613880322','87','1311833275613880322',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275655823361','1211574035113099265','1311833275655823361',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275706155009','1212536999949438978','1311833275706155009',2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275785846785','97','1311833275785846785',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275827789825','1211920348237316098','1311833275827789825',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275899092993','87','1311833275899092993',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275903287298','1215207699331989506','1311833275903287298',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276012339201','1211923801521045506','1311833276012339201',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276125585410','97','1311833276125585410',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276129779713','1215542604263899137','1311833276129779713',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276171722754','1212535414099873794','1311833276171722754',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276318523394','1216650516390486017','1311833276318523394',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276335300609','1212685717864517633','1311833276335300609',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276498878465','1219451161745080321','1311833276498878465',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276507267073','1213031390673702913','1311833276507267073',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276666650626','1219824202652073985','1311833276666650626',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276708593665','1215207699331989506','1311833276708593665',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833276884754433','1218160739617931266','1311833276884754433',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833277048332289','1219241646047223809','1311833277048332289',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833277245464578','1241252588561698817','1311833277245464578',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833277434208257','1289035100629032961','1311833277434208257',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833277627146241','1290251429117808642','1311833277627146241',2,2,'泉州浙平国木雕工艺品有限公司','13505020870','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833277799112706','1297160741345947650','1311833277799112706',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1311833277971079169','1299733835944161282','1311833277971079169',2,2,'晋江市含光农业科技有限公司','18717727991','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-02 09:00:00',NULL,NULL,NULL,'2020-10-02 09:00:00',NULL,NULL,NULL),('1312683682653315073',NULL,'1312683682653315073',2,1,NULL,'13489084867','595341','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-04 17:19:13',NULL,NULL,NULL,'2020-10-04 17:19:13',NULL,NULL,NULL),('1312920438438928385','1211486447580790785','1312920438438928385',2,2,'福建省劲牛重工发展有限公司','18016585576','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438451511298','1211920348237316098','1312920438451511298',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438468288513','1211444027140915202','1312920438468288513',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438468288514','1211473406755651586','1312920438468288514',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438740918273','83','1312920438740918273',1,2,'李女元','15359825666','17,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438766084098','72','1312920438766084098',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438778667010','72','1312920438778667010',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438870941697','1211610997505179649','1312920438870941697',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438942244866','1211474926804975617','1312920438942244866',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439013548033','58','1312920439013548033',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439068073985','1211925547903401986','1312920439068073985',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439105822721','58','1312920439105822721',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439130988546','1211490446086291458','1312920439130988546',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439193903105','87','1312920439193903105',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439240040450','1211945767430832130','1312920439240040450',2,2,'晋江市安海医院','13860758785','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439277789186','87','1312920439277789186',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439340703745','1211574035113099265','1312920439340703745',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439370063874','97','1312920439370063874',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439428784129','1212536999949438978','1312920439428784129',2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439445561346','97','1312920439445561346',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439516864514','1211920348237316098','1312920439516864514',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439609139201','1215207699331989506','1312920439609139201',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439688830978','1211923801521045506','1312920439688830978',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439772717057','1215542604263899137','1312920439772717057',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439864991746','1212535414099873794','1312920439864991746',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920439944683522','1216650516390486017','1312920439944683522',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440032763906','1212685717864517633','1312920440032763906',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440108261378','1219451161745080321','1312920440108261378',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440213118978','1213031390673702913','1312920440213118978',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440301199362','1219824202652073985','1312920440301199362',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440368308226','1215207699331989506','1312920440368308226',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440523497473','1218160739617931266','1312920440523497473',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440703852546','1219241646047223809','1312920440703852546',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920440875819010','1241252588561698817','1312920440875819010',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920441047785473','1289035100629032961','1312920441047785473',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920441307832321','1297160741345947650','1312920441307832321',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1312920441521741825','1299733835944161282','1312920441521741825',2,2,'晋江市含光农业科技有限公司','18717727991','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-05 09:00:00',NULL,NULL,NULL,'2020-10-05 09:00:00',NULL,NULL,NULL),('1313282826149339138','1211473406755651586','1313282826149339138',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826229030914','1211444027140915202','1313282826229030914',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826233225218','1211610997505179649','1313282826233225218',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826308722689','1211920348237316098','1313282826308722689',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826472300545','83','1313282826472300545',1,2,'李女元','15359825666','17,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826493272066','72','1313282826493272066',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826543603714','72','1313282826543603714',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826547798018','1211474926804975617','1313282826547798018',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826598129666','1211925547903401986','1313282826598129666',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826740736001','58','1313282826740736001',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826778484737','1211945767430832130','1313282826778484737',2,2,'晋江市安海医院','13860758785','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826816233473','1211490446086291458','1313282826816233473',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826908508161','87','1313282826908508161',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826912702466','58','1313282826912702466',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826937868289','1212536999949438978','1313282826937868289',2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826971422721','1211574035113099265','1313282826971422721',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827063697409','97','1313282827063697409',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827088863233','87','1313282827088863233',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827114029058','1215207699331989506','1313282827114029058',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827151777793','1211920348237316098','1313282827151777793',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827281801218','97','1313282827281801218',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827298578433','1215542604263899137','1313282827298578433',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827323744258','1211923801521045506','1313282827323744258',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827474739202','1216650516390486017','1313282827474739202',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827558625282','1212535414099873794','1313282827558625282',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827646705666','1219451161745080321','1313282827646705666',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827730591746','1212685717864517633','1313282827730591746',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827818672130','1219824202652073985','1313282827818672130',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282827910946818','1213031390673702913','1313282827910946818',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282828095496193','1215207699331989506','1313282828095496193',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282828288434177','1218160739617931266','1313282828288434177',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282828481372161','1219241646047223809','1313282828481372161',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282828699475969','1241252588561698817','1313282828699475969',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282828871442433','1289035100629032961','1313282828871442433',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313282829064380417','1297160741345947650','1313282829064380417',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-06 09:00:00',NULL,NULL,NULL,'2020-10-06 09:00:00',NULL,NULL,NULL),('1313645214136573954','1211920348237316098','1313645214136573954',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214182711297','1211473406755651586','1313645214182711297',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214182711298','1211444027140915202','1313645214182711298',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214350483458','1211610997505179649','1313645214350483458',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214375649282','83','1313645214375649282',1,2,'李女元','15359825666','17,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214379843585','72','1313645214379843585',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214459535362','72','1313645214459535362',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214560198657','1211474926804975617','1313645214560198657',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214585364482','1211925547903401986','1313645214585364482',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214744748033','1211490446086291458','1313645214744748033',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214790885377','58','1313645214790885377',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214790885378','1211945767430832130','1313645214790885378',2,2,'晋江市安海医院','13860758785','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214853799938','58','1313645214853799938',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215004794881','87','1313645215004794881',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215008989186','1211574035113099265','1313645215008989186',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215008989187','87','1313645215008989187',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215017377794','1212536999949438978','1313645215017377794',2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215189344258','1211920348237316098','1313645215189344258',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215193538561','97','1313645215193538561',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215206121474','97','1313645215206121474',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215218704385','1215207699331989506','1313645215218704385',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215357116417','1211923801521045506','1313645215357116417',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215436808194','1215542604263899137','1313645215436808194',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215520694274','1212535414099873794','1313645215520694274',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215646523394','1216650516390486017','1313645215646523394',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215675883521','1212685717864517633','1313645215675883521',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215822684161','1219451161745080321','1313645215822684161',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645215839461378','1213031390673702913','1313645215839461378',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645216049176578','1215207699331989506','1313645216049176578',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645216049176579','1219824202652073985','1313645216049176579',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645216204365826','1218160739617931266','1313645216204365826',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645216372137985','1219241646047223809','1313645216372137985',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645216531521537','1241252588561698817','1313645216531521537',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645216690905089','1289035100629032961','1313645216690905089',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1313645216888037378','1297160741345947650','1313645216888037378',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-07 09:00:00',NULL,NULL,NULL,'2020-10-07 09:00:00',NULL,NULL,NULL),('1314007601880539138','1211444027140915202','1314007601880539138',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007601897316354','1211920348237316098','1314007601897316354',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007601947648002','1211610997505179649','1314007601947648002',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007601989591042','1211473406755651586','1314007601989591042',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602148974593','72','1314007602148974593',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602169946114','83','1314007602169946114',1,2,'李女元','15359825666','17,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602178334722','72','1314007602178334722',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602299969537','1211925547903401986','1314007602299969537',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602312552449','1211474926804975617','1314007602312552449',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602455158786','58','1314007602455158786',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602492907521','1211945767430832130','1314007602492907521',2,2,'晋江市安海医院','13860758785','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602509684737','58','1314007602509684737',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602513879042','1211490446086291458','1314007602513879042',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602618736642','87','1314007602618736642',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602690039810','1211574035113099265','1314007602690039810',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602690039811','87','1314007602690039811',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602690039812','1212536999949438978','1314007602690039812',2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602815868930','97','1314007602815868930',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602845229058','1211920348237316098','1314007602845229058',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602853617665','97','1314007602853617665',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602878783490','1215207699331989506','1314007602878783490',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603008806914','1211923801521045506','1314007603008806914',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603017195522','1215542604263899137','1314007603017195522',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603176579074','1212535414099873794','1314007603176579074',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603231105026','1216650516390486017','1314007603231105026',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603407265794','1219451161745080321','1314007603407265794',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603407265795','1212685717864517633','1314007603407265795',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603570843649','1219824202652073985','1314007603570843649',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603583426562','1213031390673702913','1314007603583426562',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603755393025','1215207699331989506','1314007603755393025',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007603939942402','1218160739617931266','1314007603939942402',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007604116103169','1219241646047223809','1314007604116103169',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007604300652545','1241252588561698817','1314007604300652545',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007604472619010','1289035100629032961','1314007604472619010',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314007604648779778','1297160741345947650','1314007604648779778',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-08 09:00:00',NULL,NULL,NULL,'2020-10-08 09:00:00',NULL,NULL,NULL),('1314185334694649857',NULL,'1314185334694649857',2,1,NULL,'18005065255','328959','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-08 20:46:14',NULL,NULL,NULL,'2020-10-08 20:46:14',NULL,NULL,NULL),('1314369989720973313','1211473406755651586','1314369989720973313',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989762916353','1211610997505179649','1314369989762916353',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989771304961','1211444027140915202','1314369989771304961',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989779693569','1211920348237316098','1314369989779693569',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989981020165','72','1314369989981020165',1,2,'翁海勇','13599173733','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989981020166','83','1314369989981020166',1,2,'李女元','15359825666','17,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990022963202','72','1314369990022963202',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990073294849','1211925547903401986','1314369990073294849',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990098460673','1211474926804975617','1314369990098460673',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990287204354','1211945767430832130','1314369990287204354',2,2,'晋江市安海医院','13860758785','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990287204355','1211490446086291458','1314369990287204355',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990333341697','58','1314369990333341697',1,2,'张荣荣','15280619456','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990354313218','58','1314369990354313218',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990442393601','1211574035113099265','1314369990442393601',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990446587905','1212536999949438978','1314369990446587905',2,2,'晋江市医院晋南分院','15396486268','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990517891074','87','1314369990517891074',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990614360066','1211920348237316098','1314369990614360066',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990622748674','1215207699331989506','1314369990622748674',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990689857537','97','1314369990689857537',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990786326529','87','1314369990786326529',1,2,'叶志钦','13675957398','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990803103746','1211923801521045506','1314369990803103746',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990807298049','1215542604263899137','1314369990807298049',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990962487297','97','1314369990962487297',1,2,'吴思莹','12345674868','14,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990962487298','1216650516390486017','1314369990962487298',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369990970875906','1212535414099873794','1314369990970875906',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369991159619586','1212685717864517633','1314369991159619586',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369991180591106','1219451161745080321','1314369991180591106',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369991314808833','1213031390673702913','1314369991314808833',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369991365140481','1219824202652073985','1314369991365140481',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369991511941122','1215207699331989506','1314369991511941122',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369991667130370','1218160739617931266','1314369991667130370',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369991847485442','1219241646047223809','1314369991847485442',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369992036229121','1241252588561698817','1314369992036229121',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369992195612674','1289035100629032961','1314369992195612674',2,2,'中国电信股份有限公司晋江分公司','18960219966','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314369992367579138','1297160741345947650','1314369992367579138',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-09 09:00:00',NULL,NULL,NULL,'2020-10-09 09:00:00',NULL,NULL,NULL),('1314480913752563714',NULL,'1314480913752563714',2,1,NULL,'19905065506','639048','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-09 16:20:46',NULL,NULL,NULL,'2020-10-09 16:20:46',NULL,NULL,NULL),('1314481258893451265',NULL,'1314481258893451265',2,1,NULL,'19905065506','768623','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-09 16:22:08',NULL,NULL,NULL,'2020-10-09 16:22:08',NULL,NULL,NULL),('1314501422020075521',NULL,'1314501422020075521',2,1,NULL,'18558692200','680785','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-09 17:42:15',NULL,NULL,NULL,'2020-10-09 17:42:15',NULL,NULL,NULL),('1314765500269502465',NULL,'1314765500269502465',2,1,NULL,'13960397234','448168','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-10 11:11:37',NULL,NULL,NULL,'2020-10-10 11:11:37',NULL,NULL,NULL),('1314766590335557634',NULL,'1314766590335557634',2,1,NULL,'13506055071','014595','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-10 11:15:56',NULL,NULL,NULL,'2020-10-10 11:15:56',NULL,NULL,NULL),('1314772863428894722',NULL,'1314772863428894722',2,1,NULL,'18558692200','646378','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-10 11:40:52',NULL,NULL,NULL,'2020-10-10 11:40:52',NULL,NULL,NULL),('1314773661504282625',NULL,'1314773661504282625',2,1,NULL,'18558692200','939574','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-10 11:44:02',NULL,NULL,NULL,'2020-10-10 11:44:02',NULL,NULL,NULL),('1314846105216868353',NULL,'1314846105216868353',2,1,NULL,'18959201571','229515','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-10 16:31:54',NULL,NULL,NULL,'2020-10-10 16:31:54',NULL,NULL,NULL),('1315191025802682369',NULL,'1315191025802682369',2,1,NULL,'13358579727','924255','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-11 15:22:30',NULL,NULL,NULL,'2020-10-11 15:22:30',NULL,NULL,NULL),('1315275535240142849',NULL,'1315275535240142849',2,1,NULL,'17547513720','727194','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-11 20:58:18',NULL,NULL,NULL,'2020-10-11 20:58:18',NULL,NULL,NULL),('1315447071116894210',NULL,'1315447071116894210',2,1,NULL,'13599703460','081577','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-12 08:19:56',NULL,NULL,NULL,'2020-10-12 08:19:56',NULL,NULL,NULL),('1315447602577154050',NULL,'1315447602577154050',2,1,NULL,'13506075567','673177','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-12 08:22:02',NULL,NULL,NULL,'2020-10-12 08:22:02',NULL,NULL,NULL),('1315457153548427266','1211601884993863681','1315457153548427266',2,2,'晋江市妇幼保健院','13799233113','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457153615536129','1211444027140915202','1315457153615536129',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457153720393729','1211610997505179649','1315457153720393729',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457153951080449','1210918631014248450','1315457153951080449',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154127241217','1211925547903401986','1315457154127241217',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154257264641','83','1315457154257264641',1,2,'李女元','15359825666','28,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154269847553','72','1315457154269847553',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154274041858','72','1315457154274041858',1,2,'翁海勇','13599173733','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154311790593','1211092856509411330','1315457154311790593',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154345345025','1212685717864517633','1315457154345345025',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154496339970','58','1315457154496339970',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154538283010','1211441648983130114','1315457154538283010',2,2,'兴业皮革科技股份有限公司','18859716647','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154597003266','58','1315457154597003266',1,2,'张荣荣','15280619456','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154706055170','87','1315457154706055170',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154727026690','1215207699331989506','1315457154727026690',2,2,'晋江市医院','18350528526','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154781552641','87','1315457154781552641',1,2,'叶志钦','13675957398','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154781552642','86','1315457154781552642',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154781552643','1211473406755651586','1315457154781552643',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154919964673','1215542604263899137','1315457154919964673',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154974490625','97','1315457154974490625',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154978684930','97','1315457154978684930',1,2,'吴思莹','12345674868','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154991267842','1211474926804975617','1315457154991267842',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457155171622914','1216650516390486017','1315457155171622914',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457155263897602','1211490446086291458','1315457155263897602',2,2,'泉州职业技术大学','18060007601','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457155360366593','1219451161745080321','1315457155360366593',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457155490390017','1211497229303463938','1315457155490390017',2,2,'泉州市晋科技术检测有限公司','18960206656','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457155616219138','1219824202652073985','1315457155616219138',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457155674939394','1211559758373371905','1315457155674939394',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457155842711553','1211561316616028162','1315457155842711553',2,2,'福建盼盼饮料有限公司','15959993860','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457156014678018','1211574035113099265','1315457156014678018',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457156241170433','1211920348237316098','1315457156241170433',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457156413136898','1211923801521045506','1315457156413136898',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457156580909058','1212580494957416450','1315457156580909058',2,2,'舒华体育股份有限公司','13599295908','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457156891287554','1212685717864517633','1315457156891287554',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457157075836930','1212943836112818177','1315457157075836930',2,2,'晋江中纺标检测有限公司','15375873767','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457157256192002','1213031390673702913','1315457157256192002',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:00',NULL,NULL,NULL,'2020-10-12 09:00:00',NULL,NULL,NULL),('1315457157440741377','1213310396123910145','1315457157440741377',2,2,'晋江市第三医院','13559554933','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457157612707841','1213376299297476609','1315457157612707841',2,2,'福建省海峡建设发展有限公司','15805967556','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457157780480002','1215207699331989506','1315457157780480002',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457157948252161','1215550908977430529','1315457157948252161',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457158128607234','1218160739617931266','1315457158128607234',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'停机','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457158342516738','1219241646047223809','1315457158342516738',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457158548037633','1241252588561698817','1315457158548037633',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457158724198401','1289035100629032961','1315457158724198401',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457158900359170','1290219135275487234','1315457158900359170',2,2,'泉州银行股份有限公司晋江支行','15260853516','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457159084908546','1296659016558051330','1315457159084908546',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457159256875009','1297160741345947650','1315457159256875009',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457159424647169','1297750547696316418','1315457159424647169',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315457159625973762','1298793063874949122','1315457159625973762',2,2,'泉州传化公路港物流有限公司','13559076739','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-12 09:00:01',NULL,NULL,NULL,'2020-10-12 09:00:01',NULL,NULL,NULL),('1315459606033473537','1314481312186277890','1315459606033473537',2,2,'福建逸锦化纤有限公司','19905065506','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-12 09:09:44',NULL,NULL,NULL,'2020-10-12 09:09:44',NULL,NULL,NULL),('1315459843296862209','1310864917322117121','1315459843296862209',2,2,'捷洋(福建)食品有限公司','18965686555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-12 09:10:41',NULL,NULL,NULL,'2020-10-12 09:10:41',NULL,NULL,NULL),('1315483604414898178',NULL,'1315483604414898178',2,1,NULL,'13505952596','995149','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-12 10:45:06',NULL,NULL,NULL,'2020-10-12 10:45:06',NULL,NULL,NULL),('1315484837389279234',NULL,'1315484837389279234',2,1,NULL,'13559550870','470334','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-12 10:50:00',NULL,NULL,NULL,'2020-10-12 10:50:00',NULL,NULL,NULL),('1315551702975295490',NULL,'1315551702975295490',2,1,NULL,'15850575332','501682','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-12 15:15:42',NULL,NULL,NULL,'2020-10-12 15:15:42',NULL,NULL,NULL),('1315819541401481218','1211610997505179649','1315819541401481218',2,2,'晋江市磁灶中心卫生院（晋江市中西医结合医院）','137888000470','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541456007169','1210918631014248450','1315819541456007169',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541527310338','1211444027140915202','1315819541527310338',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541531504641','1210918631014248450','1315819541531504641',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541661528065','83','1315819541661528065',1,2,'李女元','15359825666','30,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541674110977','72','1315819541674110977',1,2,'翁海勇','13599173733','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541757997057','72','1315819541757997057',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541850271746','1211441648983130114','1315819541850271746',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541862854658','1211095022649323522','1315819541862854658',2,2,'福建晋工机械有限公司','13799553654','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541950935041','1211925547903401986','1315819541950935041',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542055792641','1211465952919601153','1315819542055792641',2,2,'福建省晋江市福埔S.M国际广场','15059551567','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542055792642','1211473406755651586','1315819542055792642',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542068375554','58','1315819542068375554',1,2,'张荣荣','15280619456','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542127095809','1212685717864517633','1315819542127095809',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542143873025','58','1315819542143873025',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542223564801','87','1315819542223564801',1,2,'叶志钦','13675957398','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542227759105','1211474926804975617','1315819542227759105',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542231953409','1211474926804975617','1315819542231953409',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542307450882','1215207699331989506','1315819542307450882',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542349393921','87','1315819542349393921',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542420697090','1211490446086291458','1315819542420697090',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542420697091','97','1315819542420697091',1,2,'吴思莹','12345674868','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542424891393','1211832959498240001','1315819542424891393',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542471028738','1216650516390486017','1315819542471028738',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542512971778','97','1315819542512971778',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542596857857','1211497229303463938','1315819542596857857',2,2,'泉州市晋科技术检测有限公司','18960206656','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542596857858','1211837849989595138','1315819542596857858',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542651383810','1219451161745080321','1315819542651383810',2,2,'泉州福林汽车销售服务有限公司','15805039263','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542760435713','1211574035113099265','1315819542760435713',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542764630018','1211927486787534850','1315819542764630018',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542840127489','1219824202652073985','1315819542840127489',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542928207874','1214097817526620161','1315819542928207874',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819542957568002','1211920348237316098','1315819542957568002',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819543104368641','1214375861688553474','1315819543104368641',2,2,'晋江一岂科技有限公司','13950116705','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819543142117378','1211923801521045506','1315819543142117378',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819543284723713','1215207699331989506','1315819543284723713',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819543326666754','1212580494957416450','1315819543326666754',2,2,'舒华体育股份有限公司','13599295908','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819543507021825','1212685717864517633','1315819543507021825',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819543683182594','1213031390673702913','1315819543683182594',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819543863537665','1213100306318036993','1315819543863537665',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819544060669954','1215207699331989506','1315819544060669954',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819544241025026','1215550908977430529','1315819544241025026',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819544408797185','1218160739617931266','1315819544408797185',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'停机','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819544580763650','1219241646047223809','1315819544580763650',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819544761118721','1241252588561698817','1315819544761118721',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819544924696578','1288637929832366081','1315819544924696578',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819545105051649','1289035100629032961','1315819545105051649',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819545281212417','1297160741345947650','1315819545281212417',2,2,'中信证券股份有限公司晋江长兴路证券营业部','18299000000','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:00',NULL,NULL,NULL,'2020-10-13 09:00:00',NULL,NULL,NULL),('1315819545474150401','1297750547696316418','1315819545474150401',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-13 09:00:01',NULL,NULL,NULL,'2020-10-13 09:00:01',NULL,NULL,NULL),('1315848523689799681','1315551775847133185','1315848523689799681',2,2,'福建安踏物流信息科技有限公司','15850575332','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-13 10:55:09',NULL,NULL,NULL,'2020-10-13 10:55:09',NULL,NULL,NULL),('1315862468299370498',NULL,'1315862468299370498',2,1,NULL,'18065989225','202624','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-13 11:50:34',NULL,NULL,NULL,'2020-10-13 11:50:34',NULL,NULL,NULL),('1316181929111891970','1211925547903401986','1316181929111891970',2,2,'泉州市泽西生物科技有限公司','17359269810','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929124474882','1211444027140915202','1316181929124474882',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929128669185','1211459203080699905','1316181929128669185',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929174806529','1210918631014248450','1316181929174806529',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929334190081','72','1316181929334190081',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929342578689','72','1316181929342578689',1,2,'翁海勇','13599173733','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929342578690','83','1316181929342578690',1,2,'李女元','15359825666','33,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929489379329','1212685717864517633','1316181929489379329',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929514545153','1211473406755651586','1316181929514545153',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929527128065','1211441648983130114','1316181929527128065',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929648762881','58','1316181929648762881',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929703288833','1215207699331989506','1316181929703288833',2,2,'晋江市医院','18350528526','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929728454658','58','1316181929728454658',1,2,'张荣荣','15280619456','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929728454659','1211474926804975617','1316181929728454659',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929741037570','1211474926804975617','1316181929741037570',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929820729345','87','1316181929820729345',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929908809730','1216650516390486017','1316181929908809730',2,2,'福建省润永信息科技有限公司','18959759065','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929913004034','87','1316181929913004034',1,2,'叶志钦','13675957398','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929929781249','1211832959498240001','1316181929929781249',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929950752770','1211574035113099265','1316181929950752770',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929975918594','97','1316181929975918594',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930097553410','1219451161745080321','1316181930097553410',2,2,'泉州福林汽车销售服务有限公司','15805039263','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930101747714','97','1316181930101747714',1,2,'吴思莹','12345674868','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930105942018','1211927486787534850','1316181930105942018',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930118524929','1211920348237316098','1316181930118524929',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930273714177','1219824202652073985','1316181930273714177',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930290491394','1211923801521045506','1316181930290491394',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930298880002','1214097817526620161','1316181930298880002',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930441486338','1212580494957416450','1316181930441486338',2,2,'舒华体育股份有限公司','13599295908','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930466652161','1214375861688553474','1316181930466652161',2,2,'晋江一岂科技有限公司','13950116705','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930621841409','1212685717864517633','1316181930621841409',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930651201538','1215207699331989506','1316181930651201538',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930806390786','1212929090869334017','1316181930806390786',2,2,'福建省晋江市辉源建材物资有限公司','15106027935','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181930986745857','1213031390673702913','1316181930986745857',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181931175489538','1213100306318036993','1316181931175489538',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181931385204737','1215207699331989506','1316181931385204737',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181931565559810','1215550908977430529','1316181931565559810',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181931745914881','1218160739617931266','1316181931745914881',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181931926269954','1219241646047223809','1316181931926269954',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181932115013634','1241252588561698817','1316181932115013634',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181932303757314','1288637929832366081','1316181932303757314',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181932479918082','1289035100629032961','1316181932479918082',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316181932656078850','1297750547696316418','1316181932656078850',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:00:00',NULL,NULL,NULL,'2020-10-14 09:00:00',NULL,NULL,NULL),('1316191899941384193','1314765939572514817','1316191899941384193',2,2,'晋江市总工会','13960397234','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-14 09:39:37',NULL,NULL,NULL,'2020-10-14 09:39:37',NULL,NULL,NULL),('1316193035092013058','1314765939572514817','1316193035092013058',2,2,'晋江市总工会','13960397234','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-14 09:44:07',NULL,NULL,NULL,'2020-10-14 09:44:07',NULL,NULL,NULL),('1316200159213826050',NULL,'1316200159213826050',2,1,NULL,'15160312213','412106','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-14 10:12:26',NULL,NULL,NULL,'2020-10-14 10:12:26',NULL,NULL,NULL),('1316209647039852545','1316201027820630017','1316209647039852545',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-14 10:50:08',NULL,NULL,NULL,'2020-10-14 10:50:08',NULL,NULL,NULL),('1316316155090087938',NULL,'1316316155090087938',2,1,NULL,'13599773033','651910','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-14 17:53:22',NULL,NULL,NULL,'2020-10-14 17:53:22',NULL,NULL,NULL),('1316536162831085569',NULL,'1316536162831085569',2,1,NULL,'13599773033','714347','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-15 08:27:35',NULL,NULL,NULL,'2020-10-15 08:27:35',NULL,NULL,NULL),('1316537822026444802',NULL,'1316537822026444802',2,1,NULL,'19523637289','964031','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-15 08:34:11',NULL,NULL,NULL,'2020-10-15 08:34:11',NULL,NULL,NULL),('1316544316897800193','1211444027140915202','1316544316897800193',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544316956520449','1219824202652073985','1316544316956520449',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544316956520450','1211441648983130114','1316544316956520450',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544316981686273','1211459203080699905','1316544316981686273',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317162041346','72','1316544317162041346',1,2,'翁海勇','13599173733','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317208178689','72','1316544317208178689',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317216567297','83','1316544317216567297',1,2,'李女元','15359825666','33,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317350785025','1211473406755651586','1316544317350785025',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317514362881','1211832959498240001','1316544317514362881',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317535334402','1211474926804975617','1316544317535334402',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317585666050','58','1316544317585666050',1,2,'张荣荣','15280619456','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317686329345','1211927486787534850','1316544317686329345',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317728272386','1211574035113099265','1316544317728272386',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317799575554','58','1316544317799575554',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317849907202','1214375861688553474','1316544317849907202',2,2,'晋江一岂科技有限公司','13950116705','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317900238849','1211920348237316098','1316544317900238849',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318009290754','1215207699331989506','1316544318009290754',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318026067970','87','1316544318026067970',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318055428097','87','1316544318055428097',1,2,'叶志钦','13675957398','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318088982529','1211923801521045506','1316544318088982529',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318248366081','97','1316544318248366081',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318248366082','97','1316544318248366082',1,2,'吴思莹','12345674868','15,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318365806594','1212685717864517633','1316544318365806594',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318558744578','1213031390673702913','1316544318558744578',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318739099650','1215207699331989506','1316544318739099650',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544318969786369','1218160739617931266','1316544318969786369',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544319133364225','1219241646047223809','1316544319133364225',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544319368245249','1241252588561698817','1316544319368245249',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544319577960449','1288637929832366081','1316544319577960449',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544319745732610','1289035100629032961','1316544319745732610',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544319934476289','1297750547696316418','1316544319934476289',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316544320139997185','1314481312186277890','1316544320139997185',2,2,'福建逸锦化纤有限公司','19905065506','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:00:00',NULL,NULL,NULL,'2020-10-15 09:00:00',NULL,NULL,NULL),('1316548812365410305',NULL,'1316548812365410305',2,1,NULL,'13509362773','147424','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-15 09:17:51',NULL,NULL,NULL,'2020-10-15 09:17:51',NULL,NULL,NULL),('1316552828440850433','1211572731150123009','1316552828440850433',2,2,'三六一度(福建)体育用品有限公司','13657918010','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-15 09:33:49',NULL,NULL,NULL,'2020-10-15 09:33:49',NULL,NULL,NULL),('1316553409322594306','1211574035113099265','1316553409322594306',2,2,'三六一度(中国)有限公司','18350599665','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-15 09:36:07',NULL,NULL,NULL,'2020-10-15 09:36:07',NULL,NULL,NULL),('1316562174688145410','1316537973814112258','1316562174688145410',2,2,'泉州市民顺机动车检测有限公司','19523637289','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-15 10:10:57',NULL,NULL,NULL,'2020-10-15 10:10:57',NULL,NULL,NULL),('1316572399113646082',NULL,'1316572399113646082',2,1,NULL,'18065232785','256965','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-15 10:51:35',NULL,NULL,NULL,'2020-10-15 10:51:35',NULL,NULL,NULL),('1316906704817926145','1219824202652073985','1316906704817926145',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906704826314754','1211471774600970241','1316906704826314754',2,2,'泉州鸿展模具制造有限公司','18959708027','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906704826314755','1211441648983130114','1316906704826314755',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906704851480577','1211446058115186690','1316906704851480577',2,2,'晋江新闻网有限公司','13625958406','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906704935366658','1211444027140915202','1316906704935366658',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705048612866','72','1316906705048612866',1,2,'翁海勇','13599173733','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705124110337','72','1316906705124110337',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705220579330','1211473406755651586','1316906705220579330',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705241550850','83','1316906705241550850',1,2,'李女元','15359825666','33,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705333825537','1211832959498240001','1316906705333825537',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705434488834','58','1316906705434488834',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705543540737','1211474926804975617','1316906705543540737',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705568706561','1211927486787534850','1316906705568706561',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705619038210','87','1316906705619038210',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705728090113','1211574035113099265','1316906705728090113',2,2,'三六一度(中国)有限公司','18350599665','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705744867330','1215207699331989506','1316906705744867330',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705774227458','97','1316906705774227458',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705795198977','58','1316906705795198977',1,2,'张荣荣','15280619456','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705895862273','1211920348237316098','1316906705895862273',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705983942657','87','1316906705983942657',1,2,'叶志钦','13675957398','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906706109771777','1211923801521045506','1316906706109771777',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906706155909122','97','1316906706155909122',1,2,'吴思莹','12345674868','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906706285932546','1212685717864517633','1316906706285932546',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906706491453441','1212903777946898433','1316906706491453441',2,2,'福建兴翼机械有限公司','18606981162','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906706680197121','1213031390673702913','1316906706680197121',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906706864746497','1215207699331989506','1316906706864746497',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906707061878785','1218160739617931266','1316906707061878785',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906707221262337','1219241646047223809','1316906707221262337',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906707401617409','1220180021985951745','1316906707401617409',2,2,'晋江市新合发塑胶印刷有限公司','13599703460','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906707573583873','1241252588561698817','1316906707573583873',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906707732967425','1288637929832366081','1316906707732967425',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906707904933889','1289035100629032961','1316906707904933889',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1316906708068511746','1316201027820630017','1316906708068511746',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-16 09:00:00',NULL,NULL,NULL,'2020-10-16 09:00:00',NULL,NULL,NULL),('1317993868511195137','1211444027140915202','1317993868511195137',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868515389441','1211473406755651586','1317993868515389441',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868574109698','1211441648983130114','1317993868574109698',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868616052738','1219824202652073985','1317993868616052738',2,2,'泉州市雄健体育用品有限公司','18050881166','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868775436291','72','1317993868775436291',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868792213505','72','1317993868792213505',1,2,'翁海勇','13599173733','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868808990721','83','1317993868808990721',1,2,'李女元','15359825666','9,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868922236929','1211832959498240001','1317993868922236929',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868939014146','1211474926804975617','1317993868939014146',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869144535041','58','1317993869144535041',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869148729346','1211490446086291458','1317993869148729346',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869182283778','58','1317993869182283778',1,2,'张荣荣','15280619456','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869203255298','1211927486787534850','1317993869203255298',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869387804673','1215207699331989506','1317993869387804673',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869387804674','1211920348237316098','1317993869387804674',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869572354050','1211923801521045506','1317993869572354050',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869580742658','87','1317993869580742658',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869664628738','87','1317993869664628738',1,2,'叶志钦','13675957398','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869731737601','1212685717864517633','1317993869731737601',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869849178113','97','1317993869849178113',1,2,'吴思莹','12345674868','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993869895315458','1212903777946898433','1317993869895315458',2,2,'福建兴翼机械有限公司','18606981162','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993870004367361','97','1317993870004367361',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993870063087618','1213031390673702913','1317993870063087618',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993870268608513','1215207699331989506','1317993870268608513',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993870490906625','1218160739617931266','1317993870490906625',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993870729981954','1219241646047223809','1317993870729981954',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993870918725633','1241252588561698817','1317993870918725633',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993871111663617','1288637929832366081','1317993871111663617',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1317993871292018689','1289035100629032961','1317993871292018689',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-19 09:00:00',NULL,NULL,NULL,'2020-10-19 09:00:00',NULL,NULL,NULL),('1318103219745894401',NULL,'1318103219745894401',2,1,NULL,'13600709402','436840','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-19 16:14:31',NULL,NULL,NULL,'2020-10-19 16:14:31',NULL,NULL,NULL),('1318112825322811393',NULL,'1318112825322811393',2,1,NULL,'13600709402','754678','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-19 16:52:41',NULL,NULL,NULL,'2020-10-19 16:52:41',NULL,NULL,NULL),('1318118008257818625','1318113102461448194','1318118008257818625',2,2,'泉州市爱乐佳园置业有限公司','13600709402','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-19 17:13:17',NULL,NULL,NULL,'2020-10-19 17:13:17',NULL,NULL,NULL),('1318178702000959490',NULL,'1318178702000959490',2,1,NULL,'15960418149','932938','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-19 21:14:27',NULL,NULL,NULL,'2020-10-19 21:14:27',NULL,NULL,NULL),('1318178962186219521',NULL,'1318178962186219521',2,1,NULL,'15960418149','361919','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-19 21:15:29',NULL,NULL,NULL,'2020-10-19 21:15:29',NULL,NULL,NULL),('1318179747582226433',NULL,'1318179747582226433',2,1,NULL,'15960418149','364243','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-19 21:18:37',NULL,NULL,NULL,'2020-10-19 21:18:37',NULL,NULL,NULL),('1318186880709210114',NULL,'1318186880709210114',2,1,NULL,'15960418149','957924','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-19 21:46:57',NULL,NULL,NULL,'2020-10-19 21:46:57',NULL,NULL,NULL),('1318356256481652738','1211444027140915202','1318356256481652738',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256519401474','1211441648983130114','1318356256519401474',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256519401475','1211473406755651586','1318356256519401475',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256733310978','72','1318356256733310978',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256741699585','72','1318356256741699585',1,2,'翁海勇','13599173733','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256750088194','83','1318356256750088194',1,2,'李女元','15359825666','9,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256913666049','1211832959498240001','1318356256913666049',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256913666050','1211474926804975617','1318356256913666050',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257102409730','58','1318356257102409730',1,2,'张荣荣','15280619456','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257140158466','1211927486787534850','1318356257140158466',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257140158467','58','1318356257140158467',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257173712897','1211490446086291458','1318356257173712897',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257282764802','87','1318356257282764802',1,2,'叶志钦','13675957398','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257282764803','87','1318356257282764803',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257379233794','1215207699331989506','1318356257379233794',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257425371137','1211920348237316098','1318356257425371137',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257458925570','97','1318356257458925570',1,2,'吴思莹','12345674868','13,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257492480001','97','1318356257492480001',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257605726210','1211923801521045506','1318356257605726210',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257807052801','1212685717864517633','1318356257807052801',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356257983213569','1212903777946898433','1318356257983213569',2,2,'福建兴翼机械有限公司','18606981162','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356258171957249','1213031390673702913','1318356258171957249',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356258352312322','1214142410787934209','1318356258352312322',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356258545250305','1215207699331989506','1318356258545250305',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356258721411073','1218160739617931266','1318356258721411073',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13898810920','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'停机','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356258897571842','1219241646047223809','1318356258897571842',2,2,'晋江农商银行','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356259073732609','1241252588561698817','1318356259073732609',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318356259249893377','1288637929832366081','1318356259249893377',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-20 09:00:00',NULL,NULL,NULL,'2020-10-20 09:00:00',NULL,NULL,NULL),('1318452981938565121','1318179870542442498','1318452981938565121',2,2,'晋江市合豪果蔬种植有限公司','15960418149','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:24:21',NULL,NULL,NULL,'2020-10-20 15:24:21',NULL,NULL,NULL),('1318453223161376769','1212922386479910913','1318453223161376769',2,2,'中桥文化传媒(福建)股份有限公司','18558692200','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:25:18',NULL,NULL,NULL,'2020-10-20 15:25:18',NULL,NULL,NULL),('1318453334650171394','1211574035113099265','1318453334650171394',2,2,'三六一度(中国)有限公司','13657918010','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:25:45',NULL,NULL,NULL,'2020-10-20 15:25:45',NULL,NULL,NULL),('1318453626070413313','1211456847907700737','1318453626070413313',2,2,'峰安皮业股份有限公司','15059821270','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:26:54',NULL,NULL,NULL,'2020-10-20 15:26:54',NULL,NULL,NULL),('1318453680416010241','1211450215958102018','1318453680416010241',2,2,'福建夜光达科技股份有限公司','15659878695','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:27:07',NULL,NULL,NULL,'2020-10-20 15:27:07',NULL,NULL,NULL),('1318453778407534593','1291608243923095553','1318453778407534593',2,2,'福建意乐焙宝生物科技有限公司','15559079841','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:27:31',NULL,NULL,NULL,'2020-10-20 15:27:31',NULL,NULL,NULL),('1318453864743088129','1218160739617931266','1318453864743088129',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:27:51',NULL,NULL,NULL,'2020-10-20 15:27:51',NULL,NULL,NULL),('1318453972704473090','1211450825436610561','1318453972704473090',2,2,'福建海峡石墨烯产业技术研究院有限公司','18859971221','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:28:17',NULL,NULL,NULL,'2020-10-20 15:28:17',NULL,NULL,NULL),('1318454370794254338','1219241646047223809','1318454370794254338',2,2,'福建晋江农村商业银行股份有限公司','15260663037','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:29:52',NULL,NULL,NULL,'2020-10-20 15:29:52',NULL,NULL,NULL),('1318454453472374785','1214802166888357889','1318454453472374785',2,2,'福建省晋江人力资本有限公司','13636905051','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:30:12',NULL,NULL,NULL,'2020-10-20 15:30:12',NULL,NULL,NULL),('1318454561945464833','1216185557357457410','1318454561945464833',2,2,'晋江太古飞机复合材料有限公司','18959996091','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:30:37',NULL,NULL,NULL,'2020-10-20 15:30:37',NULL,NULL,NULL),('1318454676739371009','1219451161745080321','1318454676739371009',2,2,'泉州福林汽车销售服务有限公司','13675966551','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:31:05',NULL,NULL,NULL,'2020-10-20 15:31:05',NULL,NULL,NULL),('1318454904573964290','1214448822097350658','1318454904573964290',2,2,'中国移动通信集团福建有限公司晋江分公司','15959880009','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:31:59',NULL,NULL,NULL,'2020-10-20 15:31:59',NULL,NULL,NULL),('1318455865505787905','1211110678463623169','1318455865505787905',2,2,'琪尔特股份有限公司','18859969666','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:35:48',NULL,NULL,NULL,'2020-10-20 15:35:48',NULL,NULL,NULL),('1318455934846021634','1211495827340574722','1318455934846021634',2,2,'晋江市品质陶瓷建材有限公司','13808558152','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-20 15:36:05',NULL,NULL,NULL,'2020-10-20 15:36:05',NULL,NULL,NULL),('1318718644225617922','1211444027140915202','1318718644225617922',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644259172353','1211473406755651586','1318718644259172353',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644292726786','1211441648983130114','1318718644292726786',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644515024897','72','1318718644515024897',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644527607810','83','1318718644527607810',1,2,'李女元','15359825666','10,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644628271105','1211832959498240001','1318718644628271105',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644632465410','1211474926804975617','1318718644632465410',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644804431874','1211927486787534850','1318718644804431874',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644804431875','1211914077576675329','1318718644804431875',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644879929346','58','1318718644879929346',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644993175553','1211920348237316098','1318718644993175553',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645014147074','1215207699331989506','1318718645014147074',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645114810370','87','1318718645114810370',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645165142018','1211923801521045506','1318718645165142018',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645269999618','97','1318718645269999618',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645311942657','1212253296765505538','1318718645311942657',2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645479714817','1212644982180089858','1318718645479714817',2,2,'福建省华晟建设发展有限公司','15392121201','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645634904065','1212685717864517633','1318718645634904065',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645823647745','1213031390673702913','1318718645823647745',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718645995614210','1214142410787934209','1318718645995614210',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718646175969281','1215207699331989506','1318718646175969281',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718646339547138','1218160739617931266','1318718646339547138',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718646494736385','1219241646047223809','1318718646494736385',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718646654119938','1241252588561698817','1318718646654119938',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718646813503490','1289035100629032961','1318718646813503490',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718646972887041','1310864917322117121','1318718646972887041',2,2,'捷洋(福建)食品有限公司','18965686555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318718647128076289','1318113102461448194','1318718647128076289',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-21 09:00:00',NULL,NULL,NULL,'2020-10-21 09:00:00',NULL,NULL,NULL),('1318889269057613826',NULL,'1318889269057613826',2,1,NULL,'13906095618','266500','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-21 20:18:00',NULL,NULL,NULL,'2020-10-21 20:18:00',NULL,NULL,NULL),('1318890105687044097',NULL,'1318890105687044097',2,1,NULL,'15392123555','842479','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-21 20:21:19',NULL,NULL,NULL,'2020-10-21 20:21:19',NULL,NULL,NULL),('1319081032141565954','1211441648983130114','1319081032141565954',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032259006466','1211446058115186690','1319081032259006466',2,2,'晋江新闻网有限公司','13625958406','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032296755201','1211444027140915202','1319081032296755201',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032502276097','72','1319081032502276097',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032506470402','83','1319081032506470402',1,2,'李女元','15359825666','10,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032519053313','1211832959498240001','1319081032519053313',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032632299522','1211473406755651586','1319081032632299522',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032808460289','1211474926804975617','1319081032808460289',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032867180545','1211927486787534850','1319081032867180545',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032888152065','58','1319081032888152065',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033064312833','1211914077576675329','1319081033064312833',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033064312834','87','1319081033064312834',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033081090050','1215207699331989506','1319081033081090050',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033253056513','97','1319081033253056513',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033282416641','1211920348237316098','1319081033282416641',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033462771713','1211923801521045506','1319081033462771713',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033634738177','1212253296765505538','1319081033634738177',2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033802510337','1212685717864517633','1319081033802510337',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081033991254017','1213031390673702913','1319081033991254017',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081034205163522','1215207699331989506','1319081034205163522',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081034385518593','1218160739617931266','1319081034385518593',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081034565873665','1219241646047223809','1319081034565873665',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081034767200257','1241252588561698817','1319081034767200257',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081034943361025','1289035100629032961','1319081034943361025',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081035119521794','1310864917322117121','1319081035119521794',2,2,'捷洋(福建)食品有限公司','18965686555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319081035316654082','1318113102461448194','1319081035316654082',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-22 09:00:00',NULL,NULL,NULL,'2020-10-22 09:00:00',NULL,NULL,NULL),('1319440407280545793',NULL,'1319440407280545793',2,1,NULL,'15068210336','339035','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-23 08:48:01',NULL,NULL,NULL,'2020-10-23 08:48:01',NULL,NULL,NULL),('1319440687682351106',NULL,'1319440687682351106',2,1,NULL,'15260807555','389836','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-23 08:49:08',NULL,NULL,NULL,'2020-10-23 08:49:08',NULL,NULL,NULL),('1319443419990388738','1211444027140915202','1319443419990388738',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420082663425','1211441648983130114','1319443420082663425',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420086857730','1211446058115186690','1319443420086857730',2,2,'晋江新闻网有限公司','13625958406','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420258824194','83','1319443420258824194',1,2,'李女元','15359825666','10,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420388847618','72','1319443420388847618',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420485316609','1211832959498240001','1319443420485316609',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420552425474','1211457961772236801','1319443420552425474',2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420653088770','1211927486787534850','1319443420653088770',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420766334978','1211473406755651586','1319443420766334978',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420829249537','58','1319443420829249537',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420850221058','1215207699331989506','1319443420850221058',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420950884354','1211474926804975617','1319443420950884354',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443421127045121','1211920348237316098','1319443421127045121',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443421311594498','87','1319443421311594498',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443421340954626','1211923801521045506','1319443421340954626',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443421487755266','97','1319443421487755266',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443421517115393','1212253296765505538','1319443421517115393',2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443421693276162','1212580494957416450','1319443421693276162',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443421907185666','1212685717864517633','1319443421907185666',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443422083346433','1212906675946721282','1319443422083346433',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443422267895810','1213031390673702913','1319443422267895810',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443422460833793','1215207699331989506','1319443422460833793',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443422641188865','1218160739617931266','1319443422641188865',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443422817349634','1219241646047223809','1319443422817349634',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443422980927489','1241252588561698817','1319443422980927489',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443423173865474','1289035100629032961','1319443423173865474',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443423396163586','1310864917322117121','1319443423396163586',2,2,'捷洋(福建)食品有限公司','18965686555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1319443423576518657','1318113102461448194','1319443423576518657',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-23 09:00:00',NULL,NULL,NULL,'2020-10-23 09:00:00',NULL,NULL,NULL),('1320530583461359618','1211444027140915202','1320530583461359618',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583461359619','1211832959498240001','1320530583461359619',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583486525442','1211446058115186690','1320530583486525442',2,2,'晋江新闻网有限公司','13625958406','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583603965953','83','1320530583603965953',1,2,'李女元','15359825666','9,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583645908993','72','1320530583645908993',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583834652673','1211473406755651586','1320530583834652673',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583843041281','1211927486787534850','1320530583843041281',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583964676097','86','1320530583964676097',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584031784962','58','1320530584031784962',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584048562177','1211474926804975617','1320530584048562177',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584056950785','1215207699331989506','1320530584056950785',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584241500161','1211920348237316098','1320530584241500161',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584430243841','1211923801521045506','1320530584430243841',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584480575490','87','1320530584480575490',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584606404610','1212580494957416450','1320530584606404610',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584711262209','97','1320530584711262209',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530584837091329','1212685717864517633','1320530584837091329',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530585017446402','1212906675946721282','1320530585017446402',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530585231355906','1213031390673702913','1320530585231355906',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530585415905282','1215207699331989506','1320530585415905282',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530585575288834','1218160739617931266','1320530585575288834',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530585734672385','1219241646047223809','1320530585734672385',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530585898250242','1241252588561698817','1320530585898250242',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530586057633793','1289035100629032961','1320530586057633793',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530586246377473','1310864917322117121','1320530586246377473',2,2,'捷洋(福建)食品有限公司','18965686555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320530586422538242','1318113102461448194','1320530586422538242',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-26 09:00:00',NULL,NULL,NULL,'2020-10-26 09:00:00',NULL,NULL,NULL),('1320564239525539841',NULL,'1320564239525539841',2,1,NULL,'15759559009','454165','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-26 11:13:44',NULL,NULL,NULL,'2020-10-26 11:13:44',NULL,NULL,NULL),('1320892971322765313','1211832959498240001','1320892971322765313',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971352125441','1211444027140915202','1320892971352125441',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971431817218','1211150098789150721','1320892971431817218',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971528286210','83','1320892971528286210',1,2,'李女元','15359825666','10,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971599589377','72','1320892971599589377',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971750584321','1211927486787534850','1320892971750584321',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971758972929','1211446058115186690','1320892971758972929',2,2,'晋江新闻网有限公司','13625958406','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971855441922','86','1320892971855441922',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971939328001','58','1320892971939328001',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971985465345','1211457961772236801','1320892971985465345',2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971985465346','1215207699331989506','1320892971985465346',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892972102905858','87','1320892972102905858',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892972161626114','1211473406755651586','1320892972161626114',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892972262289409','97','1320892972262289409',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892972354564097','1211474926804975617','1320892972354564097',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892972534919169','1211920348237316098','1320892972534919169',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892972706885633','1211923801521045506','1320892972706885633',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892972866269185','1212685717864517633','1320892972866269185',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892973021458434','1212906675946721282','1320892973021458434',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892973185036290','1213031390673702913','1320892973185036290',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892973352808449','1215207699331989506','1320892973352808449',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892973591883778','1218160739617931266','1320892973591883778',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892973768044545','1219241646047223809','1320892973768044545',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892973927428098','1241252588561698817','1320892973927428098',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892974086811649','1289035100629032961','1320892974086811649',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892974254583810','1310864917322117121','1320892974254583810',2,2,'捷洋(福建)食品有限公司','18965686555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320892974422355970','1318113102461448194','1320892974422355970',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-27 09:00:00',NULL,NULL,NULL,'2020-10-27 09:00:00',NULL,NULL,NULL),('1320894356294529026',NULL,'1320894356294529026',2,1,NULL,'15880272172','024098','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-27 09:05:30',NULL,NULL,NULL,'2020-10-27 09:05:30',NULL,NULL,NULL),('1321019872569782274','1318890302517342210','1321019872569782274',2,2,'晋江红鼎咨询策划服务有限公司','15392123555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-27 17:24:15',NULL,NULL,NULL,'2020-10-27 17:24:15',NULL,NULL,NULL),('1321093015120441346',NULL,'1321093015120441346',2,1,NULL,'13788806309','873765','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-27 22:14:54',NULL,NULL,NULL,'2020-10-27 22:14:54',NULL,NULL,NULL),('1321255359221919746','1211150098789150721','1321255359221919746',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359221919747','1211444027140915202','1321255359221919747',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359263862785','1211832959498240001','1321255359263862785',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359507132418','72','1321255359507132418',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359662321665','1211446058115186690','1321255359662321665',2,2,'晋江新闻网有限公司','13625958406','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359666515969','1211927486787534850','1321255359666515969',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359842676737','1211473406755651586','1321255359842676737',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359846871041','1215207699331989506','1321255359846871041',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359897202689','58','1321255359897202689',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360010448898','1211474926804975617','1321255360010448898',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360064974849','87','1321255360064974849',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360190803969','1211920348237316098','1321255360190803969',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360345993217','97','1321255360345993217',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360366964737','1211923801521045506','1321255360366964737',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360576679938','1212685717864517633','1321255360576679938',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360757035009','1212906675946721282','1321255360757035009',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255360937390081','1213031390673702913','1321255360937390081',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255361105162241','1215207699331989506','1321255361105162241',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255361268740098','1219241646047223809','1321255361268740098',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255361461678082','1241252588561698817','1321255361461678082',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255361629450242','1289035100629032961','1321255361629450242',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321255361797222402','1318113102461448194','1321255361797222402',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-28 09:00:00',NULL,NULL,NULL,'2020-10-28 09:00:00',NULL,NULL,NULL),('1321617747163017218','1211444027140915202','1321617747163017218',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747171405826','1211150098789150721','1321617747171405826',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747242708994','1211927486787534850','1321617747242708994',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747431452674','72','1321617747431452674',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747448229889','70','1321617747448229889',1,2,'陈瑞清','13788864979','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747641167873','1215207699331989506','1321617747641167873',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747641167874','1211473406755651586','1321617747641167874',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747662139393','1211538270857510913','1321617747662139393',2,2,'福建省晋江优兰发纸业有限公司','13906095618','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747850883073','58','1321617747850883073',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747850883074','76','1321617747850883074',1,2,'陈灿峰','13599718877','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747863465986','1219159854892048385','1321617747863465986',2,2,'福建省正基检测技术有限公司','15080426614','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747863465987','1211474926804975617','1321617747863465987',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748010266625','83','1321617748010266625',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748031238145','87','1321617748031238145',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748060598273','1211920348237316098','1321617748060598273',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748240953345','1211923801521045506','1321617748240953345',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748417114113','1212685717864517633','1321617748417114113',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748446474241','97','1321617748446474241',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748597469185','1212906675946721282','1321617748597469185',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748765241345','1213031390673702913','1321617748765241345',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617748937207809','1215207699331989506','1321617748937207809',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617749104979969','1219241646047223809','1321617749104979969',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617749281140738','1241252588561698817','1321617749281140738',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617749453107202','1289035100629032961','1321617749453107202',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321617749629267969','1318113102461448194','1321617749629267969',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-29 09:00:00',NULL,NULL,NULL,'2020-10-29 09:00:00',NULL,NULL,NULL),('1321627869645959169',NULL,'1321627869645959169',2,1,NULL,'13599111348','691506','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-29 09:40:13',NULL,NULL,NULL,'2020-10-29 09:40:13',NULL,NULL,NULL),('1321628742904246273',NULL,'1321628742904246273',2,1,NULL,'18659905376','641223','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-29 09:43:41',NULL,NULL,NULL,'2020-10-29 09:43:41',NULL,NULL,NULL),('1321730121043828737',NULL,'1321730121043828737',2,1,NULL,'18159352255','739227','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-29 16:26:32',NULL,NULL,NULL,'2020-10-29 16:26:32',NULL,NULL,NULL),('1321980135045394433','1211150098789150721','1321980135045394433',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135129280513','1211927486787534850','1321980135129280513',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135137669122','1211444027140915202','1321980135137669122',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135510962177','72','1321980135510962177',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135523545089','70','1321980135523545089',1,2,'陈瑞清','13788864979','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136056221698','1215207699331989506','1321980136056221698',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136064610306','1211538270857510913','1321980136064610306',2,2,'福建省晋江优兰发纸业有限公司','13906095618','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136064610307','1211473406755651586','1321980136064610307',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136072998914','58','1321980136072998914',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136077193218','76','1321980136077193218',1,2,'陈灿峰','13599718877','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136358211585','1211474926804975617','1321980136358211585',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136366600194','87','1321980136366600194',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136379183105','83','1321980136379183105',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136525983745','97','1321980136525983745',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136534372354','1211490446086291458','1321980136534372354',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136718921730','1211559758373371905','1321980136718921730',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980136945414146','1211923801521045506','1321980136945414146',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980137117380609','1212580494957416450','1321980137117380609',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980137297735681','1212685717864517633','1321980137297735681',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980137465507842','1212906675946721282','1321980137465507842',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980137645862913','1213031390673702913','1321980137645862913',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980137822023681','1214142410787934209','1321980137822023681',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980138010767361','1214842942284455937','1321980138010767361',2,2,'晋江市远通汽车销售服务有限责任公司','18905953233','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980138195316738','1215207699331989506','1321980138195316738',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980138392449026','1219241646047223809','1321980138392449026',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980138568609794','1241252588561698817','1321980138568609794',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980138736381954','1289035100629032961','1321980138736381954',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1321980138899959810','1318179870542442498','1321980138899959810',2,2,'晋江市合豪果蔬种植有限公司','15960418149','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-10-30 09:00:00',NULL,NULL,NULL,'2020-10-30 09:00:00',NULL,NULL,NULL),('1322085932442120193',NULL,'1322085932442120193',2,1,NULL,'18159352255','836406','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-10-30 16:00:24',NULL,NULL,NULL,'2020-10-30 16:00:24',NULL,NULL,NULL),('1322094960094277633','1321628929244590082','1322094960094277633',2,2,'世茂天成物业服务集团有限公司晋江分公司','18659905376','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-10-30 16:36:16',NULL,NULL,NULL,'2020-10-30 16:36:16',NULL,NULL,NULL),('1323067298558308353','1211150098789150721','1323067298558308353',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298570891265','1211444027140915202','1323067298570891265',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298587668481','1211927486787534850','1323067298587668481',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298885464065','70','1323067298885464065',1,2,'陈瑞清','13788864979','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298919018497','72','1323067298919018497',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298994515969','1215207699331989506','1323067298994515969',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299053236226','1211473406755651586','1323067299053236226',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299254562818','76','1323067299254562818',1,2,'陈灿峰','13599718877','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299271340033','58','1323067299271340033',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299288117249','1211474926804975617','1323067299288117249',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299430723586','83','1323067299430723586',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299489443842','1211559758373371905','1323067299489443842',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299682381825','1211923801521045506','1323067299682381825',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299757879297','87','1323067299757879297',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299854348290','1212580494957416450','1323067299854348290',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067299938234370','97','1323067299938234370',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067300072452098','1212685717864517633','1323067300072452098',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067300290555906','1212906675946721282','1323067300290555906',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067300458328065','1213031390673702913','1323067300458328065',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067300621905921','1214142410787934209','1323067300621905921',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067300819038209','1215207699331989506','1323067300819038209',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067300991004673','1219241646047223809','1323067300991004673',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067301192331266','1241252588561698817','1323067301192331266',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323067301360103426','1289035100629032961','1323067301360103426',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-02 09:00:00',NULL,NULL,NULL,'2020-11-02 09:00:00',NULL,NULL,NULL),('1323089817180893186',NULL,'1323089817180893186',2,1,NULL,'17750989756','485488','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-02 10:29:28',NULL,NULL,NULL,'2020-11-02 10:29:28',NULL,NULL,NULL),('1323429686553931777','1211927486787534850','1323429686553931777',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686579097601','1211444027140915202','1323429686579097601',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686704926721','1211138539417350145','1323429686704926721',2,2,'福建百宏聚纤科技实业有限公司','18959858592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686809784321','72','1323429686809784321',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686834950145','76','1323429686834950145',1,2,'陈灿峰','13599718877','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686985945089','1215207699331989506','1323429686985945089',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686998528002','1211191315514109954','1323429686998528002',2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687174688769','1211441648983130114','1323429687174688769',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687199854594','83','1323429687199854594',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687220826113','58','1323429687220826113',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687371821057','1211457961772236801','1323429687371821057',2,2,'灵源药业有限公司','18350770050','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687434735618','87','1323429687434735618',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687552176130','1211465260200935426','1323429687552176130',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687589924865','97','1323429687589924865',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687728336898','1211473406755651586','1323429687728336898',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429687904497666','1211474926804975617','1323429687904497666',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429688072269825','1211490446086291458','1323429688072269825',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429688240041985','1211497229303463938','1323429688240041985',2,2,'泉州市晋科技术检测有限公司','18960206656','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429688407814146','1211574035113099265','1323429688407814146',2,2,'三六一度(中国)有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429688592363521','1211920348237316098','1323429688592363521',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429688806273026','1211923801521045506','1323429688806273026',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429688982433793','1212535414099873794','1323429688982433793',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429689166983170','1212580494957416450','1323429689166983170',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429689368309762','1212685717864517633','1323429689368309762',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429689548664834','1212906675946721282','1323429689548664834',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429689724825602','1213031390673702913','1323429689724825602',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429689892597762','1213310396123910145','1323429689892597762',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429690102312961','1213451329813417985','1323429690102312961',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429690408497153','1214375861688553474','1323429690408497153',2,2,'晋江一岂科技有限公司','13950116705','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:00',NULL,NULL,NULL,'2020-11-03 09:00:00',NULL,NULL,NULL),('1323429690630795265','1215207699331989506','1323429690630795265',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429690815344642','1219241646047223809','1323429690815344642',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429690991505410','1241252588561698817','1323429690991505410',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429691197026306','1277069643340627970','1323429691197026306',2,2,'晋江市益心社工服务中心','15260372095','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429691394158594','1281834150738911234','1323429691394158594',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429691566125058','1289035100629032961','1323429691566125058',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429691750674434','1294076991682641922','1323429691750674434',2,2,'福建意尔康体育用品有限公司','15905071236','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429691926835201','1296659016558051330','1323429691926835201',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429692102995969','1297750547696316418','1323429692102995969',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429692279156737','1298793063874949122','1323429692279156737',2,2,'泉州传化公路港物流有限公司','13559076739','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429692463706113','1301682900063776769','1323429692463706113',2,2,'福建天工房地产开发有限公司','15659885820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429692635672577','1309396118605459457','1323429692635672577',2,2,'晋江超特精铸有限公司','13506953825','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323429692820221954','1310864917322117121','1323429692820221954',2,2,'捷洋(福建)食品有限公司','18965686555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-03 09:00:01',NULL,NULL,NULL,'2020-11-03 09:00:01',NULL,NULL,NULL),('1323441983343095809',NULL,'1323441983343095809',2,1,NULL,'13599718877','413418','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-03 09:48:51',NULL,NULL,NULL,'2020-11-03 09:48:51',NULL,NULL,NULL),('1323442136430997506',NULL,'1323442136430997506',2,1,NULL,'15260225737','400287','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-03 09:49:28',NULL,NULL,NULL,'2020-11-03 09:49:28',NULL,NULL,NULL),('1323538593246932994',NULL,'1323538593246932994',2,1,NULL,'13960285632','843764','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-03 16:12:45',NULL,NULL,NULL,'2020-11-03 16:12:45',NULL,NULL,NULL),('1323542637852028930','1323539148186906626','1323542637852028930',2,2,'晋江市恒溢雨具有限公司','13960285632','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-03 16:28:49',NULL,NULL,NULL,'2020-11-03 16:28:49',NULL,NULL,NULL),('1323792095286194178','1211138539417350145','1323792095286194178',2,2,'福建百宏聚纤科技实业有限公司','18959858592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095286194179','1211441648983130114','1323792095286194179',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095344914433','1211490953219588098','1323792095344914433',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095483326465','1211444027140915202','1323792095483326465',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095814676481','1211150098789150721','1323792095814676481',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095965671425','1211927486787534850','1323792095965671425',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095965671426','1213100306318036993','1323792095965671426',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096028585986','72','1323792096028585986',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096028585987','83','1323792096028585987',1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096129249281','1215207699331989506','1323792096129249281',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096133443586','1211473406755651586','1323792096133443586',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096389296130','58','1323792096389296130',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096464793601','86','1323792096464793601',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096569651201','87','1323792096569651201',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096599011330','1211474926804975617','1323792096599011330',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096762589186','97','1323792096762589186',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792096804532225','1211490953219588098','1323792096804532225',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792097001664513','1211920348237316098','1323792097001664513',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792097253322754','1211923801521045506','1323792097253322754',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792097429483521','1212535414099873794','1323792097429483521',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792097614032898','1212685717864517633','1323792097614032898',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792097777610754','1212906675946721282','1323792097777610754',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792098100572162','1213031390673702913','1323792098100572162',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792098369007617','1213310396123910145','1323792098369007617',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792098591305730','1215207699331989506','1323792098591305730',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1323792098775855106','1215568298586980354','1323792098775855106',2,2,'福建永恒能源管理有限公司','19959813350','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792098952015873','1219241646047223809','1323792098952015873',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792099136565249','1219436923634892801','1323792099136565249',2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:05',NULL,NULL,NULL,'2020-11-04 09:00:05',NULL,NULL,NULL),('1323792099379834882','1241252588561698817','1323792099379834882',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:06',NULL,NULL,NULL,'2020-11-04 09:00:06',NULL,NULL,NULL),('1323792099631493122','1277069643340627970','1323792099631493122',2,2,'晋江市益心社工服务中心','15260372095','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:06',NULL,NULL,NULL,'2020-11-04 09:00:06',NULL,NULL,NULL),('1323792099820236802','1281834150738911234','1323792099820236802',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:06',NULL,NULL,NULL,'2020-11-04 09:00:06',NULL,NULL,NULL),('1323792100008980481','1289035100629032961','1323792100008980481',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:06',NULL,NULL,NULL,'2020-11-04 09:00:06',NULL,NULL,NULL),('1323792100231278594','1296659016558051330','1323792100231278594',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:06',NULL,NULL,NULL,'2020-11-04 09:00:06',NULL,NULL,NULL),('1323792100436799490','1297750547696316418','1323792100436799490',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:06',NULL,NULL,NULL,'2020-11-04 09:00:06',NULL,NULL,NULL),('1323792100612960258','1318113102461448194','1323792100612960258',2,2,'泉州市爱乐佳园置业有限公司','13600709402','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-04 09:00:06',NULL,NULL,NULL,'2020-11-04 09:00:06',NULL,NULL,NULL),('1324154462310297602','1211927486787534850','1324154462310297602',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154462406766594','1211150098789150721','1324154462406766594',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154462410960897','1211444027140915202','1324154462410960897',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154462989774850','83','1324154462989774850',1,2,'李女元','15359825666','7,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463014940674','1215207699331989506','1324154463014940674',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463069466626','1211473406755651586','1324154463069466626',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463212072962','72','1324154463212072962',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463233044482','86','1324154463233044482',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463295959041','1211474926804975617','1324154463295959041',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463484702721','1211923801521045506','1324154463484702721',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463652474881','58','1324154463652474881',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463652474882','1212535414099873794','1324154463652474882',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463857995778','87','1324154463857995778',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463887355905','1212685717864517633','1324154463887355905',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154464046739458','1212906675946721282','1324154464046739458',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154464046739459','97','1324154464046739459',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154464273231874','1213031390673702913','1324154464273231874',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154464441004033','1213310396123910145','1324154464441004033',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154464617164802','1215207699331989506','1324154464617164802',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154464814297090','1215568298586980354','1324154464814297090',2,2,'福建永恒能源管理有限公司','19959813350','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154464969486338','1219241646047223809','1324154464969486338',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154465154035714','1241252588561698817','1324154465154035714',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154465313419266','1277069643340627970','1324154465313419266',2,2,'晋江市益心社工服务中心','15260372095','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154465481191425','1281834150738911234','1324154465481191425',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154465653157889','1289035100629032961','1324154465653157889',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154465833512962','1296659016558051330','1324154465833512962',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324154466001285122','1297750547696316418','1324154466001285122',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-05 09:00:00',NULL,NULL,NULL,'2020-11-05 09:00:00',NULL,NULL,NULL),('1324160037140099074',NULL,'1324160037140099074',2,1,NULL,'13805941437','574174','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-05 09:22:09',NULL,NULL,NULL,'2020-11-05 09:22:09',NULL,NULL,NULL),('1324166132113928193',NULL,'1324166132113928193',2,1,NULL,'15805933163','196253','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-05 09:46:22',NULL,NULL,NULL,'2020-11-05 09:46:22',NULL,NULL,NULL),('1324174764415184898',NULL,'1324174764415184898',2,1,NULL,'15160773015','799034','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-05 10:20:40',NULL,NULL,NULL,'2020-11-05 10:20:40',NULL,NULL,NULL),('1324516850335248386','1211444027140915202','1324516850335248386',2,2,'福建省万物智联科技有限公司','15659222652','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850335248387','1211150098789150721','1324516850335248387',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850347831297','1211927486787534850','1324516850347831297',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850532380673','72','1324516850532380673',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850536574978','83','1324516850536574978',1,2,'李女元','15359825666','7,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851031502849','1215207699331989506','1324516851031502849',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851044085761','58','1324516851044085761',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851111194625','1211473406755651586','1324516851111194625',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851278966786','87','1324516851278966786',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851367047169','1211474926804975617','1324516851367047169',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851564179457','1211923801521045506','1324516851564179457',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851731951618','97','1324516851731951618',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851782283265','1212685717864517633','1324516851782283265',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516851950055426','1212906675946721282','1324516851950055426',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516852155576322','1213031390673702913','1324516852155576322',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516852331737089','1213310396123910145','1324516852331737089',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516852499509249','1215207699331989506','1324516852499509249',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516852675670017','1219241646047223809','1324516852675670017',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516852914745345','1241252588561698817','1324516852914745345',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516853107683330','1277069643340627970','1324516853107683330',2,2,'晋江市益心社工服务中心','15260372095','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516853275455490','1281834150738911234','1324516853275455490',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516853439033345','1289035100629032961','1324516853439033345',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516853602611201','1296659016558051330','1324516853602611201',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324516853967515650','1297750547696316418','1324516853967515650',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-06 09:00:00',NULL,NULL,NULL,'2020-11-06 09:00:00',NULL,NULL,NULL),('1324546090032205825',NULL,'1324546090032205825',2,1,NULL,'19959876703','836779','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-06 10:56:11',NULL,NULL,NULL,'2020-11-06 10:56:11',NULL,NULL,NULL),('1324551042146275329',NULL,'1324551042146275329',2,1,NULL,'13559627996','944406','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-06 11:15:52',NULL,NULL,NULL,'2020-11-06 11:15:52',NULL,NULL,NULL),('1324558022923554817',NULL,'1324558022923554817',2,1,NULL,'13559627996','369575','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-06 11:43:36',NULL,NULL,NULL,'2020-11-06 11:43:36',NULL,NULL,NULL),('1324606084240936962',NULL,'1324606084240936962',2,1,NULL,'13799233698','110724','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-06 14:54:35',NULL,NULL,NULL,'2020-11-06 14:54:35',NULL,NULL,NULL),('1324607706933268482',NULL,'1324607706933268482',2,1,NULL,'13799233698','812042','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-06 15:01:02',NULL,NULL,NULL,'2020-11-06 15:01:02',NULL,NULL,NULL),('1324976620095787009',NULL,'1324976620095787009',2,1,NULL,'18876305138','783740','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-07 15:26:57',NULL,NULL,NULL,'2020-11-07 15:26:57',NULL,NULL,NULL),('1324980783806533634',NULL,'1324980783806533634',2,1,NULL,'18876305138','671881','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-07 15:43:30',NULL,NULL,NULL,'2020-11-07 15:43:30',NULL,NULL,NULL),('1325350248331202561',NULL,'1325350248331202561',2,1,NULL,'18050878002','411935','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-08 16:11:37',NULL,NULL,NULL,'2020-11-08 16:11:37',NULL,NULL,NULL),('1325374367680548865',NULL,'1325374367680548865',2,1,NULL,'13959888664','089285','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-08 17:47:28',NULL,NULL,NULL,'2020-11-08 17:47:28',NULL,NULL,NULL),('1325604013839863810','1211927486787534850','1325604013839863810',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604013839863811','1211150098789150721','1325604013839863811',2,2,'泉州永实工程质量检测有限公司','18396220746','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014250905602','83','1325604014250905602',1,2,'李女元','15359825666','7,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014359957506','72','1325604014359957506',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014401900546','1215207699331989506','1325604014401900546',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014427066369','1211473406755651586','1325604014427066369',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014720667650','58','1325604014720667650',1,2,'张荣荣','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014833913858','1211474926804975617','1325604014833913858',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014917799938','87','1325604014917799938',1,2,'叶志钦','13675957398','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604015035240450','1211923801521045506','1325604015035240450',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604015119126529','97','1325604015119126529',1,2,'吴思莹','12345674868','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604015282704386','1212685717864517633','1325604015282704386',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604015471448066','1212906675946721282','1325604015471448066',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604015672774657','1213031390673702913','1325604015672774657',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604015869906945','1213310396123910145','1325604015869906945',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604016046067713','1215207699331989506','1325604016046067713',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604016218034178','1219241646047223809','1325604016218034178',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604016406777857','1241252588561698817','1325604016406777857',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604016582938626','1281834150738911234','1325604016582938626',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604016822013953','1289035100629032961','1325604016822013953',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604016998174721','1296659016558051330','1325604016998174721',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325604017170141186','1297750547696316418','1325604017170141186',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 09:00:00',NULL,NULL,NULL,'2020-11-09 09:00:00',NULL,NULL,NULL),('1325615206805655554','1321093914727346178','1325615206805655554',2,2,'泉州市壹合食品研究院有限公司','13788806309','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-09 09:44:28',NULL,NULL,NULL,'2020-11-09 09:44:28',NULL,NULL,NULL),('1325640383803281410',NULL,'1325640383803281410',2,1,NULL,'18250600713','259682','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-09 11:24:31',NULL,NULL,NULL,'2020-11-09 11:24:31',NULL,NULL,NULL),('1325691737640914946',NULL,'1325691737640914946',2,1,NULL,'17705959761','759552','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-09 14:48:35',NULL,NULL,NULL,'2020-11-09 14:48:35',NULL,NULL,NULL),('1325715165341143041','1303977759655100418','1325715165341143041',2,2,'福建省晋江自来水股份有限公司','13505952596','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-09 16:21:40',NULL,NULL,NULL,'2020-11-09 16:21:40',NULL,NULL,NULL),('1325715320329064449','1315484893530038273','1325715320329064449',2,2,'晋江市晋南污水处理有限公司','13559550870','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-09 16:22:17',NULL,NULL,NULL,'2020-11-09 16:22:17',NULL,NULL,NULL),('1325715716732735490','1324607776583880706','1325715716732735490',2,2,'深圳航空有限责任公司泉州分公司','13799233698','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-09 16:23:52',NULL,NULL,NULL,'2020-11-09 16:23:52',NULL,NULL,NULL),('1325966401470582786','1211473406755651586','1325966401470582786',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966401525108737','1211927486787534850','1325966401525108737',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966401797738497','83','1325966401797738497',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966401814515713','58','1325966401814515713',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966401969704962','1211474926804975617','1325966401969704962',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402003259393','1215207699331989506','1325966402003259393',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402204585985','1211923801521045506','1325966402204585985',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402225557506','87','1325966402225557506',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402418495490','1212685717864517633','1325966402418495490',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402586267649','1212906675946721282','1325966402586267649',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402644987905','97','1325966402644987905',1,2,'吴思莹','12345674868','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402749845506','1213031390673702913','1325966402749845506',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966402917617666','1213310396123910145','1325966402917617666',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966403085389826','1215207699331989506','1325966403085389826',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966403253161986','1219241646047223809','1325966403253161986',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966403425128449','1241252588561698817','1325966403425128449',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966403597094914','1281834150738911234','1325966403597094914',2,2,'中国光大银行股份有限公司泉州晋江支行','15880886959','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966403773255682','1289035100629032961','1325966403773255682',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966403936833538','1296659016558051330','1325966403936833538',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325966404163325953','1297750547696316418','1325966404163325953',2,2,'晋江市罗山清煌古玩店','13905055213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-10 09:00:00',NULL,NULL,NULL,'2020-11-10 09:00:00',NULL,NULL,NULL),('1325975552795914241',NULL,'1325975552795914241',2,1,NULL,'13799577105','282712','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-10 09:36:21',NULL,NULL,NULL,'2020-11-10 09:36:21',NULL,NULL,NULL),('1326328789474521090','1211927486787534850','1326328789474521090',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328789721985025','1211473406755651586','1326328789721985025',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328789893951489','58','1326328789893951489',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328789956866050','1215207699331989506','1326328789956866050',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328790015586305','1211474926804975617','1326328790015586305',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328790309187585','1211923801521045506','1326328790309187585',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328790325964801','87','1326328790325964801',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328790539874305','1212685717864517633','1326328790539874305',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328790539874306','97','1326328790539874306',1,2,'吴思莹','12345674868','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328790762172418','1212906675946721282','1326328790762172418',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328790997053442','1213031390673702913','1326328790997053442',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328791219351553','1213310396123910145','1326328791219351553',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328791399706625','1215207699331989506','1326328791399706625',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328791584256002','1219241646047223809','1326328791584256002',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328791764611073','1241252588561698817','1326328791764611073',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328791982714882','1289035100629032961','1326328791982714882',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326328792305676289','1296659016558051330','1326328792305676289',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-11 09:00:00',NULL,NULL,NULL,'2020-11-11 09:00:00',NULL,NULL,NULL),('1326451218863665153',NULL,'1326451218863665153',2,1,NULL,'13799855086','414791','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-11 17:06:29',NULL,NULL,NULL,'2020-11-11 17:06:29',NULL,NULL,NULL),('1326464140113391617',NULL,'1326464140113391617',2,1,NULL,'17705959761','146544','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-11 17:57:50',NULL,NULL,NULL,'2020-11-11 17:57:50',NULL,NULL,NULL),('1326465066039554050',NULL,'1326465066039554050',2,1,NULL,'13799527903','263222','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-11 18:01:30',NULL,NULL,NULL,'2020-11-11 18:01:30',NULL,NULL,NULL),('1326465553874857985',NULL,'1326465553874857985',2,1,NULL,'13799527903','858853','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-11 18:03:27',NULL,NULL,NULL,'2020-11-11 18:03:27',NULL,NULL,NULL),('1326691177231069186','1211473406755651586','1326691177231069186',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177268817921','1211927486787534850','1326691177268817921',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177570807809','58','1326691177570807809',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177700831234','1215207699331989506','1326691177700831234',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177734385665','1211474926804975617','1326691177734385665',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177914740738','1211923801521045506','1326691177914740738',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177956683777','87','1326691177956683777',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691178074124289','1212685717864517633','1326691178074124289',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691178250285058','1212906675946721282','1326691178250285058',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691178409668609','97','1326691178409668609',1,2,'吴思莹','12345674868','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691178418057218','1213031390673702913','1326691178418057218',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691178673909762','1213310396123910145','1326691178673909762',2,2,'晋江市第三医院','13559554933','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691178854264833','1215207699331989506','1326691178854264833',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691179038814209','1219241646047223809','1326691179038814209',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691179273695234','1241252588561698817','1326691179273695234',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691179475021825','1289035100629032961','1326691179475021825',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326691179655376898','1296659016558051330','1326691179655376898',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-12 09:00:00',NULL,NULL,NULL,'2020-11-12 09:00:00',NULL,NULL,NULL),('1326845971811921922',NULL,'1326845971811921922',2,1,NULL,'13672230321','456070','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-12 19:15:05',NULL,NULL,NULL,'2020-11-12 19:15:05',NULL,NULL,NULL),('1326846478311878658',NULL,'1326846478311878658',2,1,NULL,'13672230321','619122','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-12 19:17:06',NULL,NULL,NULL,'2020-11-12 19:17:06',NULL,NULL,NULL),('1327053579000868866','1214025654970896386','1327053579000868866',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579017646081','1211927486787534850','1327053579017646081',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579298664449','1211473406755651586','1327053579298664449',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579495796738','1215100340257472514','1327053579495796738',2,2,'晋江万兴隆染织实业有限公司','15880742575','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579567099906','58','1327053579567099906',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579604848642','1215207699331989506','1327053579604848642',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579776815106','1215115207978827777','1327053579776815106',2,2,'福州大学晋江科教园管委会','15980228632','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579776815107','1211474926804975617','1327053579776815107',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053580053639170','87','1327053580053639170',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053580238188546','97','1327053580238188546',1,2,'吴思莹','12345674868','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053580619870209','1211923801521045506','1327053580619870209',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053580817002498','1212685717864517633','1327053580817002498',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053581018329089','1212906675946721282','1327053581018329089',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053581295153153','1213031390673702913','1327053581295153153',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053581492285441','1219241646047223809','1327053581492285441',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053581706194946','1241252588561698817','1327053581706194946',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:03',NULL,NULL,NULL,'2020-11-13 09:00:03',NULL,NULL,NULL),('1327053581878161409','1289035100629032961','1327053581878161409',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:04',NULL,NULL,NULL,'2020-11-13 09:00:04',NULL,NULL,NULL),('1327053582129819650','1296659016558051330','1327053582129819650',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-13 09:00:04',NULL,NULL,NULL,'2020-11-13 09:00:04',NULL,NULL,NULL),('1327061864345104385',NULL,'1327061864345104385',2,1,NULL,'15160773015','559467','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-13 09:32:58',NULL,NULL,NULL,'2020-11-13 09:32:58',NULL,NULL,NULL),('1327517489927569409',NULL,'1327517489927569409',2,1,NULL,'15860018012','583690','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-14 15:43:28',NULL,NULL,NULL,'2020-11-14 15:43:28',NULL,NULL,NULL),('1327518898408407042',NULL,'1327518898408407042',2,1,NULL,'15860018012','841724','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-14 15:49:04',NULL,NULL,NULL,'2020-11-14 15:49:04',NULL,NULL,NULL),('1328139441679646722','1324166786635067394','1328139441679646722',2,2,'泉州市云知晓信息科技有限公司','15805933163','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-16 08:54:53',NULL,NULL,NULL,'2020-11-16 08:54:53',NULL,NULL,NULL),('1328140728752160769','1211927486787534850','1328140728752160769',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140728861212673','1211473406755651586','1328140728861212673',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140728919932930','1214025654970896386','1328140728919932930',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729125453825','58','1328140729125453825',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729255477249','1215207699331989506','1328140729255477249',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729255477250','1215115207978827777','1328140729255477250',2,2,'福州大学晋江科教园管委会','15980228632','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729289031682','1211474926804975617','1328140729289031682',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729544884225','87','1328140729544884225',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729553272834','1211923801521045506','1328140729553272834',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729737822210','97','1328140729737822210',1,2,'吴思莹','12345674868','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729746210817','1212685717864517633','1328140729746210817',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729989480449','1212906675946721282','1328140729989480449',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140730165641217','1213031390673702913','1328140730165641217',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140730371162113','1219241646047223809','1328140730371162113',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140730551517185','1241252588561698817','1328140730551517185',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140730727677953','1289035100629032961','1328140730727677953',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328140730949976066','1296659016558051330','1328140730949976066',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:00:00',NULL,NULL,NULL,'2020-11-16 09:00:00',NULL,NULL,NULL),('1328141798551339010','1324558769073459201','1328141798551339010',2,2,'福建省鸿林物流有限公司','13559627996','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:04:15',NULL,NULL,NULL,'2020-11-16 09:04:15',NULL,NULL,NULL),('1328142065493622785','1324980845383110658','1328142065493622785',2,2,'晋江市澳雷朗照明科技有限公司','18876305138','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-16 09:05:18',NULL,NULL,NULL,'2020-11-16 09:05:18',NULL,NULL,NULL),('1328142354019794945','1325350691455225857','1328142354019794945',2,2,'福建省永舜化工科技有限公司','18050878002','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:06:27',NULL,NULL,NULL,'2020-11-16 09:06:27',NULL,NULL,NULL),('1328144814188806146','1325692037793697794','1328144814188806146',2,2,'91350582MA2YGN0X1P','17705959761','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-16 09:16:14',NULL,NULL,NULL,'2020-11-16 09:16:14',NULL,NULL,NULL),('1328145281417494529','1325975626527584258','1328145281417494529',2,2,'福建闽嘻街舞俱乐部有限责任公司晋江梅岭分公司','13799577105','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-16 09:18:05',NULL,NULL,NULL,'2020-11-16 09:18:05',NULL,NULL,NULL),('1328145937020764161','1327062167207407617','1328145937020764161',2,2,'泉州市全欣财务咨询有限公司','15160773015','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-16 09:20:41',NULL,NULL,NULL,'2020-11-16 09:20:41',NULL,NULL,NULL),('1328179041747877889',NULL,'1328179041747877889',2,1,NULL,'17750792370','092943','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-16 11:32:14',NULL,NULL,NULL,'2020-11-16 11:32:14',NULL,NULL,NULL),('1328179596897566721',NULL,'1328179596897566721',2,1,NULL,'18016660902','764757','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-16 11:34:26',NULL,NULL,NULL,'2020-11-16 11:34:26',NULL,NULL,NULL),('1328503116559040514','1214025654970896386','1328503116559040514',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503116563234817','1211473406755651586','1328503116563234817',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503116575817730','1211927486787534850','1328503116575817730',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503116777144321','58','1328503116777144321',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503116915556353','1211474926804975617','1328503116915556353',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503116940722177','1215115207978827777','1328503116940722177',2,2,'福州大学晋江科教园管委会','15980228632','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117100105729','1211923801521045506','1328503117100105729',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117150437377','87','1328503117150437377',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117259489282','1212685717864517633','1328503117259489282',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117322403841','97','1328503117322403841',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117435650049','1212906675946721282','1328503117435650049',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117590839298','1213031390673702913','1328503117590839298',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117750222850','1219241646047223809','1328503117750222850',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503117905412098','1241252588561698817','1328503117905412098',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503118056407041','1289035100629032961','1328503118056407041',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328503118219984897','1296659016558051330','1328503118219984897',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-17 09:00:00',NULL,NULL,NULL,'2020-11-17 09:00:00',NULL,NULL,NULL),('1328534001958273025',NULL,'1328534001958273025',2,1,NULL,'15260861076','623780','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-17 11:02:43',NULL,NULL,NULL,'2020-11-17 11:02:43',NULL,NULL,NULL),('1328687455158681601',NULL,'1328687455158681601',2,1,NULL,'13338575228','848410','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-17 21:12:29',NULL,NULL,NULL,'2020-11-17 21:12:29',NULL,NULL,NULL),('1328702002548457473',NULL,'1328702002548457473',2,1,NULL,'13506001966','959233','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-17 22:10:18',NULL,NULL,NULL,'2020-11-17 22:10:18',NULL,NULL,NULL),('1328713573165187074',NULL,'1328713573165187074',2,1,NULL,'13506001966','495541','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-17 22:56:16',NULL,NULL,NULL,'2020-11-17 22:56:16',NULL,NULL,NULL),('1328714267632877570',NULL,'1328714267632877570',2,1,NULL,'13506001966','487943','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-17 22:59:02',NULL,NULL,NULL,'2020-11-17 22:59:02',NULL,NULL,NULL),('1328716486000263169',NULL,'1328716486000263169',2,1,NULL,'13506001966','744277','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-17 23:07:51',NULL,NULL,NULL,'2020-11-17 23:07:51',NULL,NULL,NULL),('1328716815458648065',NULL,'1328716815458648065',2,1,NULL,'13506001966','536240','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-17 23:09:09',NULL,NULL,NULL,'2020-11-17 23:09:09',NULL,NULL,NULL),('1328864214571302913','1328179674966147074','1328864214571302913',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-18 08:54:52',NULL,NULL,NULL,'2020-11-18 08:54:52',NULL,NULL,NULL),('1328864369244651521','1324607776583880706','1328864369244651521',2,2,'深圳航空有限责任公司泉州分公司','13799233698','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-18 08:55:29',NULL,NULL,NULL,'2020-11-18 08:55:29',NULL,NULL,NULL),('1328864445782310914','1324558769073459201','1328864445782310914',2,2,'福建省鸿林物流有限公司','13559627996','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-18 08:55:47',NULL,NULL,NULL,'2020-11-18 08:55:47',NULL,NULL,NULL),('1328865813498707970','1215115207978827777','1328865813498707970',2,2,'福州大学晋江科教园管委会','15980228632','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:13',NULL,NULL,NULL,'2020-11-18 09:01:13',NULL,NULL,NULL),('1328865814278848514','1211473406755651586','1328865814278848514',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:13',NULL,NULL,NULL,'2020-11-18 09:01:13',NULL,NULL,NULL),('1328865815646191618','58','1328865815646191618',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865815650385922','1211927486787534850','1328865815650385922',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865816061427714','87','1328865816061427714',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865816396972033','1211474926804975617','1328865816396972033',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865816820596737','1211923801521045506','1328865816820596737',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865816841568258','97','1328865816841568258',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865816992563201','1212685717864517633','1328865816992563201',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865817189695489','1212906675946721282','1328865817189695489',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865817370050561','1213031390673702913','1328865817370050561',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865817554599937','1219241646047223809','1328865817554599937',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865817739149313','1241252588561698817','1328865817739149313',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865817927892993','1289035100629032961','1328865817927892993',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328865818104053762','1296659016558051330','1328865818104053762',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:01:14',NULL,NULL,NULL,'2020-11-18 09:01:14',NULL,NULL,NULL),('1328871080089092097','1328687664219570178','1328871080089092097',2,2,'泉州市福广家食品有限责任公司','13338575228','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-18 09:22:09',NULL,NULL,NULL,'2020-11-18 09:22:09',NULL,NULL,NULL),('1328872126911873026','1328716877953777666','1328872126911873026',2,2,'福建省商乐商务咨询有限公司','13506001966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-18 09:26:18',NULL,NULL,NULL,'2020-11-18 09:26:18',NULL,NULL,NULL),('1329227892403470338','1211473406755651586','1329227892403470338',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892483162114','1215115207978827777','1329227892483162114',2,2,'福州大学晋江科教园管委会','15980228632','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892567048193','1211927486787534850','1329227892567048193',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892743208961','58','1329227892743208961',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892785152002','1211474926804975617','1329227892785152002',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892948729857','87','1329227892948729857',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892978089985','1211923801521045506','1329227892978089985',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227893145862146','1212685717864517633','1329227893145862146',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227893171027970','97','1329227893171027970',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227893342994434','1212906675946721282','1329227893342994434',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227893519155202','1213031390673702913','1329227893519155202',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227893691121666','1219241646047223809','1329227893691121666',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227893846310913','1241252588561698817','1329227893846310913',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227894035054593','1289035100629032961','1329227894035054593',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329227894202826753','1296659016558051330','1329227894202826753',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-19 09:00:00',NULL,NULL,NULL,'2020-11-19 09:00:00',NULL,NULL,NULL),('1329347086788853762',NULL,'1329347086788853762',2,1,NULL,'17705959791','103990','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-19 16:53:38',NULL,NULL,NULL,'2020-11-19 16:53:38',NULL,NULL,NULL),('1329347512175165441',NULL,'1329347512175165441',2,1,NULL,'17705959761','477086','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-19 16:55:19',NULL,NULL,NULL,'2020-11-19 16:55:19',NULL,NULL,NULL),('1329348420132929538',NULL,'1329348420132929538',2,1,NULL,'17705959761','787944','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-19 16:58:56',NULL,NULL,NULL,'2020-11-19 16:58:56',NULL,NULL,NULL),('1329348675767369730',NULL,'1329348675767369730',2,1,NULL,'13799527903','483599','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-19 16:59:57',NULL,NULL,NULL,'2020-11-19 16:59:57',NULL,NULL,NULL),('1329348942608990210',NULL,'1329348942608990210',2,1,NULL,'17705959761','925583','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-19 17:01:00',NULL,NULL,NULL,'2020-11-19 17:01:00',NULL,NULL,NULL),('1329590280424259585','1211927486787534850','1329590280424259585',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590280457814018','1211473406755651586','1329590280457814018',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590280747220993','1215115207978827777','1329590280747220993',2,2,'福州大学晋江科教园管委会','15980228632','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281024045057','1211474926804975617','1329590281024045057',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281149874177','58','1329590281149874177',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281233760258','1211923801521045506','1329590281233760258',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281518972930','1212685717864517633','1329590281518972930',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281598664705','87','1329590281598664705',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281883877378','1212906675946721282','1329590281883877378',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590282055843842','97','1329590282055843842',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590282097786881','1213031390673702913','1329590282097786881',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590282370416641','1219241646047223809','1329590282370416641',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590282584326145','1241252588561698817','1329590282584326145',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590282743709697','1289035100629032961','1329590282743709697',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1329590282940841986','1296659016558051330','1329590282940841986',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-20 09:00:00',NULL,NULL,NULL,'2020-11-20 09:00:00',NULL,NULL,NULL),('1330677443698098178','1215115207978827777','1330677443698098178',2,2,'福州大学晋江科教园管委会','15980228632','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443702292482','1211473406755651586','1330677443702292482',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443714875393','1211927486787534850','1330677443714875393',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443945562113','58','1330677443945562113',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443945562114','58','1330677443945562114',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677444050419713','1211474926804975617','1330677444050419713',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677444205608962','1211923801521045506','1330677444205608962',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677444323049474','87','1330677444323049474',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677444331438082','87','1330677444331438082',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677444906057730','1212685717864517633','1330677444906057730',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677445061246978','97','1330677445061246978',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677445086412802','97','1330677445086412802',1,2,'吴思莹','12345674868','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677445199659009','1212906675946721282','1330677445199659009',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677445363236865','1213031390673702913','1330677445363236865',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677445514231810','1219241646047223809','1330677445514231810',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677445715558401','1241252588561698817','1330677445715558401',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677445883330561','1289035100629032961','1330677445883330561',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330677446059491330','1296659016558051330','1330677446059491330',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-23 09:00:00',NULL,NULL,NULL,'2020-11-23 09:00:00',NULL,NULL,NULL),('1330767766797418498','1328687664219570178','1330767766797418498',2,2,'泉州市福广家食品有限责任公司','13338575228','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-23 14:58:54',NULL,NULL,NULL,'2020-11-23 14:58:54',NULL,NULL,NULL),('1330767948691800065','1325692037793697794','1330767948691800065',2,2,'泉州市立航专利代理事务所(普通合伙)','17705959761','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-23 14:59:38',NULL,NULL,NULL,'2020-11-23 14:59:38',NULL,NULL,NULL),('1330768019168690177','1325350691455225857','1330768019168690177',2,2,'福建省永舜化工科技有限公司','18050878002','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-11-23 14:59:54',NULL,NULL,NULL,'2020-11-23 14:59:54',NULL,NULL,NULL),('1331039831752441858','1215115207978827777','1331039831752441858',2,2,'福州大学晋江科教园管委会','15980228632','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831760830465','1211927486787534850','1331039831760830465',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831773413377','1214097817526620161','1331039831773413377',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831773413378','1211473406755651586','1331039831773413378',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831987322882','58','1331039831987322882',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832004100098','58','1331039832004100098',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832163483650','1211474926804975617','1331039832163483650',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832343838721','87','1331039832343838721',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832356421633','1211923801521045506','1331039832356421633',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832356421634','87','1331039832356421634',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832545165314','97','1331039832545165314',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832545165315','97','1331039832545165315',1,2,'吴思莹','12345674868','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832545165316','1212685717864517633','1331039832545165316',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832721326082','1212906675946721282','1331039832721326082',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039832977178625','1213031390673702913','1331039832977178625',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039833140756481','1219241646047223809','1331039833140756481',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039833342083073','1241252588561698817','1331039833342083073',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039833522438145','1289035100629032961','1331039833522438145',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331039833681821698','1296659016558051330','1331039833681821698',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-24 09:00:00',NULL,NULL,NULL,'2020-11-24 09:00:00',NULL,NULL,NULL),('1331402219425103873','1211473406755651586','1331402219425103873',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219471241217','1211927486787534850','1331402219471241217',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219651596290','58','1331402219651596290',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219655790594','58','1331402219655790594',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219806785537','1211474926804975617','1331402219806785537',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219982946305','1211923801521045506','1331402219982946305',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220029083650','87','1331402220029083650',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220029083651','87','1331402220029083651',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220205244417','97','1331402220205244417',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220205244418','97','1331402220205244418',1,2,'吴思莹','12345674868','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220209438721','1212685717864517633','1331402220209438721',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220385599490','1212906675946721282','1331402220385599490',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220553371649','1213031390673702913','1331402220553371649',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220725338114','1219241646047223809','1331402220725338114',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402220905693186','1241252588561698817','1331402220905693186',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402221077659649','1289035100629032961','1331402221077659649',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331402221253820418','1296659016558051330','1331402221253820418',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-25 09:00:00',NULL,NULL,NULL,'2020-11-25 09:00:00',NULL,NULL,NULL),('1331408386452881410',NULL,'1331408386452881410',2,1,NULL,'13559076739','550327','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-25 09:24:30',NULL,NULL,NULL,'2020-11-25 09:24:30',NULL,NULL,NULL),('1331483454163910657',NULL,'1331483454163910657',2,1,NULL,'13600744687','436936','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-25 14:22:47',NULL,NULL,NULL,'2020-11-25 14:22:47',NULL,NULL,NULL),('1331483813896781825',NULL,'1331483813896781825',2,1,NULL,'13600744687','931051','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-25 14:24:13',NULL,NULL,NULL,'2020-11-25 14:24:13',NULL,NULL,NULL),('1331484371705659394',NULL,'1331484371705659394',2,1,NULL,'13600744687','392243','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-25 14:26:26',NULL,NULL,NULL,'2020-11-25 14:26:26',NULL,NULL,NULL),('1331484889236635650',NULL,'1331484889236635650',2,1,NULL,'13600744687','549262','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-25 14:28:30',NULL,NULL,NULL,'2020-11-25 14:28:30',NULL,NULL,NULL),('1331488490566713346',NULL,'1331488490566713346',2,1,NULL,'13600744687','905256','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-25 14:42:48',NULL,NULL,NULL,'2020-11-25 14:42:48',NULL,NULL,NULL),('1331489009704108033',NULL,'1331489009704108033',2,1,NULL,'13600744687','710983','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-25 14:44:52',NULL,NULL,NULL,'2020-11-25 14:44:52',NULL,NULL,NULL),('1331764607349424129','1211473406755651586','1331764607349424129',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607399755778','1211927486787534850','1331764607399755778',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607655608321','58','1331764607655608321',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607668191233','83','1331764607668191233',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607722717185','58','1331764607722717185',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607852740609','1211474926804975617','1331764607852740609',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608012124162','1211920348237316098','1331764608012124162',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608062455810','87','1331764608062455810',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608066650113','87','1331764608066650113',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608171507713','1211923801521045506','1331764608171507713',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608330891266','1212685717864517633','1331764608330891266',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608330891267','97','1331764608330891267',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608528023554','1212906675946721282','1331764608528023554',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608528023555','97','1331764608528023555',1,2,'吴思莹','12345674868','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608708378625','1213031390673702913','1331764608708378625',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764608897122306','1241252588561698817','1331764608897122306',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764609052311554','1289035100629032961','1331764609052311554',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331764609207500801','1296659016558051330','1331764609207500801',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-26 09:00:00',NULL,NULL,NULL,'2020-11-26 09:00:00',NULL,NULL,NULL),('1331799339789451265',NULL,'1331799339789451265',2,1,NULL,'15964917281','453115','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 11:18:00',NULL,NULL,NULL,'2020-11-26 11:18:00',NULL,NULL,NULL),('1331801646694400001',NULL,'1331801646694400001',2,1,NULL,'13573266846','849283','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 11:27:10',NULL,NULL,NULL,'2020-11-26 11:27:10',NULL,NULL,NULL),('1331806077360013314',NULL,'1331806077360013314',2,1,NULL,'13573266846','879550','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 11:44:47',NULL,NULL,NULL,'2020-11-26 11:44:47',NULL,NULL,NULL),('1331807441704189953',NULL,'1331807441704189953',2,1,NULL,'13573266846','546307','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 11:50:12',NULL,NULL,NULL,'2020-11-26 11:50:12',NULL,NULL,NULL),('1331809148098052098',NULL,'1331809148098052098',2,1,NULL,'15880881998','495576','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 11:56:59',NULL,NULL,NULL,'2020-11-26 11:56:59',NULL,NULL,NULL),('1331809595345076226',NULL,'1331809595345076226',2,1,NULL,'15880881998','615194','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 11:58:46',NULL,NULL,NULL,'2020-11-26 11:58:46',NULL,NULL,NULL),('1331911597764902914',NULL,'1331911597764902914',2,1,NULL,'15260055555','666236','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 18:44:05',NULL,NULL,NULL,'2020-11-26 18:44:05',NULL,NULL,NULL),('1331913306541129730',NULL,'1331913306541129730',2,1,NULL,'15260055555','983655','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-26 18:50:52',NULL,NULL,NULL,'2020-11-26 18:50:52',NULL,NULL,NULL),('1332126995139526658','1211473406755651586','1332126995139526658',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995202441218','1211927486787534850','1332126995202441218',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995428933633','83','1332126995428933633',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995441516546','58','1332126995441516546',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995441516547','58','1332126995441516547',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995554762753','1211474926804975617','1332126995554762753',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995718340610','1211920348237316098','1332126995718340610',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995760283650','87','1332126995760283650',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995881918466','87','1332126995881918466',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995919667201','1211923801521045506','1332126995919667201',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995982581762','97','1332126995982581762',1,2,'吴思莹','12345674868','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126996091633665','97','1332126996091633665',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126996129382401','1212540446794911745','1332126996129382401',2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126996351680513','1212685717864517633','1332126996351680513',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126996515258370','1212906675946721282','1332126996515258370',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126996708196354','1213031390673702913','1332126996708196354',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126996863385601','1241252588561698817','1332126996863385601',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126997056323586','1289035100629032961','1332126997056323586',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332126997207318530','1296659016558051330','1332126997207318530',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-27 09:00:00',NULL,NULL,NULL,'2020-11-27 09:00:00',NULL,NULL,NULL),('1332140022874243074',NULL,'1332140022874243074',2,1,NULL,'13850753150','816575','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-27 09:51:46',NULL,NULL,NULL,'2020-11-27 09:51:46',NULL,NULL,NULL),('1332956382441242625',NULL,'1332956382441242625',2,1,NULL,'18120803795','481155','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-11-29 15:55:41',NULL,NULL,NULL,'2020-11-29 15:55:41',NULL,NULL,NULL),('1333214158941847554','1211473406755651586','1333214158941847554',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159046705153','1211927486787534850','1333214159046705153',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159118008322','58','1333214159118008322',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159118008323','83','1333214159118008323',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159168339970','58','1333214159168339970',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159445164034','1211474926804975617','1333214159445164034',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159587770369','87','1333214159587770369',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159596158977','87','1333214159596158977',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159642296322','1211920348237316098','1333214159642296322',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159860400130','97','1333214159860400130',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159868788737','1211923801521045506','1333214159868788737',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159881371650','97','1333214159881371650',1,2,'吴思莹','12345674868','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214160149807105','1212540446794911745','1333214160149807105',2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214160351133698','1212685717864517633','1333214160351133698',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214160577626113','1212906675946721282','1333214160577626113',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214160766369793','1213031390673702913','1333214160766369793',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214160967696385','1241252588561698817','1333214160967696385',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214161152245762','1289035100629032961','1333214161152245762',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333214161345183745','1296659016558051330','1333214161345183745',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-11-30 09:00:00',NULL,NULL,NULL,'2020-11-30 09:00:00',NULL,NULL,NULL),('1333576546606120961','1211927486787534850','1333576546606120961',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546618703874','1211473406755651586','1333576546618703874',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546794864641','58','1333576546794864641',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546828419074','58','1333576546828419074',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547042328578','1211474926804975617','1333576547042328578',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547172352001','87','1333576547172352001',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547176546305','87','1333576547176546305',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547201712130','1211923801521045506','1333576547201712130',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547377872898','97','1333576547377872898',1,2,'吴思莹','12345674868','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547403038722','1212540446794911745','1333576547403038722',2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547587588098','1212685717864517633','1333576547587588098',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547629531138','97','1333576547629531138',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547763748866','1212906675946721282','1333576547763748866',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576547944103938','1213031390673702913','1333576547944103938',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576548141236226','1241252588561698817','1333576548141236226',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576548313202690','1289035100629032961','1333576548313202690',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333576548497752065','1296659016558051330','1333576548497752065',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 09:00:00',NULL,NULL,NULL,'2020-12-01 09:00:00',NULL,NULL,NULL),('1333607846750715905','1331913401814745089','1333607846750715905',2,2,'晋江市俞大猷剑经研究会','15260055555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 11:04:22',NULL,NULL,NULL,'2020-12-01 11:04:22',NULL,NULL,NULL),('1333608309915123714','1331809968285810690','1333608309915123714',2,2,'福建省向兴纺织科技有限公司','15880881998','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-01 11:06:12',NULL,NULL,NULL,'2020-12-01 11:06:12',NULL,NULL,NULL),('1333608614014746625','1331802046063443969','1333608614014746625',2,2,'福建省希领服饰有限责任公司','13573266846','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-01 11:07:25',NULL,NULL,NULL,'2020-12-01 11:07:25',NULL,NULL,NULL),('1333609313788231682','1331489074619351041','1333609313788231682',2,2,'福建晋江佳信轻工发展有限公司','13600744687','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-01 11:10:12',NULL,NULL,NULL,'2020-12-01 11:10:12',NULL,NULL,NULL),('1333652997372116993',NULL,'1333652997372116993',2,1,NULL,'15880896188','502937','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-01 14:03:47',NULL,NULL,NULL,'2020-12-01 14:03:47',NULL,NULL,NULL),('1333653739956862977',NULL,'1333653739956862977',2,1,NULL,'15880896188','546236','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-01 14:06:44',NULL,NULL,NULL,'2020-12-01 14:06:44',NULL,NULL,NULL),('1333938934584967170','1211927486787534850','1333938934584967170',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934631104514','1211117113914273793','1333938934631104514',2,2,'福建柒牌时装科技股份有限公司','15880936557','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934773710850','83','1333938934773710850',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934794682370','58','1333938934794682370',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934824042498','58','1333938934824042498',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934975037442','1211473406755651586','1333938934975037442',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935159586818','1211474926804975617','1333938935159586818',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935167975426','87','1333938935167975426',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935172169730','86','1333938935172169730',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935197335554','87','1333938935197335554',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935335747586','1211923801521045506','1333938935335747586',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935352524802','97','1333938935352524802',1,2,'吴思莹','12345674868','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935486742530','1212540446794911745','1333938935486742530',2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935641931777','97','1333938935641931777',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935650320386','1212685717864517633','1333938935650320386',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935809703937','1212906675946721282','1333938935809703937',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938935977476097','1213031390673702913','1333938935977476097',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938936153636865','1215207699331989506','1333938936153636865',2,2,'晋江市医院','18350528526','17,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938936333991938','1241252588561698817','1333938936333991938',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938936510152705','1289035100629032961','1333938936510152705',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938936682119169','1292741409895460865','1333938936682119169',2,2,'广发证券股份有限公司晋江长兴路证券营业部','18559595923','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938936849891329','1295900371603947522','1333938936849891329',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938937017663489','1296659016558051330','1333938937017663489',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938937185435650','1324166786635067394','1333938937185435650',2,2,'泉州市云知晓信息科技有限公司','15805933163','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938937344819202','1324607776583880706','1333938937344819202',2,2,'深圳航空有限责任公司泉州分公司','13799233698','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1333938937508397058','1324980845383110658','1333938937508397058',2,2,'晋江市澳雷朗照明科技有限公司','18876305138','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-02 09:00:00',NULL,NULL,NULL,'2020-12-02 09:00:00',NULL,NULL,NULL),('1334023265823227905',NULL,'1334023265823227905',2,1,NULL,'15960589393','842086','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-02 14:35:06',NULL,NULL,NULL,'2020-12-02 14:35:06',NULL,NULL,NULL),('1334024002628222977',NULL,'1334024002628222977',2,1,NULL,'15960589393','926919','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-02 14:38:01',NULL,NULL,NULL,'2020-12-02 14:38:01',NULL,NULL,NULL),('1334059423873630210',NULL,'1334059423873630210',2,1,NULL,'18813076834','492605','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-02 16:58:46',NULL,NULL,NULL,'2020-12-02 16:58:46',NULL,NULL,NULL),('1334301322823860226','1211128473930805250','1334301322823860226',2,2,'福建晋江凤竹鞋业发展有限公司','13959957107','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323394285570','58','1334301323394285570',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323511726081','83','1334301323511726081',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323511726082','58','1334301323511726082',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323771772930','1211442194934710274','1334301323771772930',2,2,'信泰（福建）科技有限公司','15659222652','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323880824833','87','1334301323880824833',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323910184962','87','1334301323910184962',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301324090540034','1211459203080699905','1334301324090540034',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301324161843201','97','1334301324161843201',1,2,'吴思莹','12345674868','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301324170231810','97','1334301324170231810',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301324329615361','1211473406755651586','1334301324329615361',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301324518359041','1211474926804975617','1334301324518359041',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301324728074241','1211476436687306754','1334301324728074241',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301325155893249','1211490446086291458','1334301325155893249',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301325403357186','1211837849989595138','1334301325403357186',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301325613072385','1211923801521045506','1334301325613072385',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301325873119233','1212540446794911745','1334301325873119233',2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301326158331906','1212685717864517633','1334301326158331906',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:00',NULL,NULL,NULL,'2020-12-03 09:00:00',NULL,NULL,NULL),('1334301326472904705','1212906675946721282','1334301326472904705',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301326678425601','1213031390673702913','1334301326678425601',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301326925889538','1213451329813417985','1334301326925889538',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301327148187650','1214097817526620161','1334301327148187650',2,2,'福建恒安集团有限公司','13960315655','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301327383068673','1215207699331989506','1334301327383068673',2,2,'晋江市医院','18350528526','11,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301327760556034','1216537288914268162','1334301327760556034',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301327924133889','1216568840104734722','1334301327924133889',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301328091906049','1218097536540147714','1334301328091906049',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301328251289601','1241252588561698817','1334301328251289601',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301328423256066','1289035100629032961','1334301328423256066',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301328586833921','1292741409895460865','1334301328586833921',2,2,'广发证券股份有限公司晋江长兴路证券营业部','18559595923','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301328762994690','1295900371603947522','1334301328762994690',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301328981098497','1296659016558051330','1334301328981098497',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301329144676353','1303955626757488641','1334301329144676353',2,2,'恒安(中国)纸业有限公司','13599106460','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301329320837122','1323539148186906626','1334301329320837122',2,2,'晋江市恒溢雨具有限公司','13960285632','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301329488609282','1324607776583880706','1334301329488609282',2,2,'深圳航空有限责任公司泉州分公司','13799233698','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334301329652187137','1324980845383110658','1334301329652187137',2,2,'晋江市澳雷朗照明科技有限公司','18876305138','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-03 09:00:01',NULL,NULL,NULL,'2020-12-03 09:00:01',NULL,NULL,NULL),('1334663710412636161','1211171114114461697','1334663710412636161',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710592991233','58','1334663710592991233',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710605574146','83','1334663710605574146',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710618157057','58','1334663710618157057',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710773346305','1211441648983130114','1334663710773346305',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710949507073','1211442194934710274','1334663710949507073',2,2,'信泰（福建）科技有限公司','15659222652','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710970478594','87','1334663710970478594',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710970478595','87','1334663710970478595',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663711155027970','97','1334663711155027970',1,2,'吴思莹','12345674868','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663711201165313','97','1334663711201165313',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663711238914049','1211459203080699905','1334663711238914049',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663711436046338','1211473406755651586','1334663711436046338',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663711620595714','1211474926804975617','1334663711620595714',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663711796756481','1211476436687306754','1334663711796756481',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663712014860289','1211490446086291458','1334663712014860289',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663712211992578','1211837849989595138','1334663712211992578',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663712392347649','1211923801521045506','1334663712392347649',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663712597868546','1212253296765505538','1334663712597868546',2,2,'泉州寰球鞋服有限公司','13580701185','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663712778223618','1212540446794911745','1334663712778223618',2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663712958578690','1212685717864517633','1334663712958578690',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663713130545153','1212906675946721282','1334663713130545153',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663713336066050','1212910689362972674','1334663713336066050',2,2,'福建盛达机器股份公司','15359382970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663713508032514','1212922386479910913','1334663713508032514',2,2,'中桥文化传媒(福建)股份有限公司','18558692200','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663713675804674','1213031390673702913','1334663713675804674',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663713914880002','1214097817526620161','1334663713914880002',2,2,'福建恒安集团有限公司','13960315655','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663714095235073','1215207699331989506','1334663714095235073',2,2,'晋江市医院','18350528526','11,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663714271395841','1216537288914268162','1334663714271395841',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:00',NULL,NULL,NULL,'2020-12-04 09:00:00',NULL,NULL,NULL),('1334663714443362306','1216568840104734722','1334663714443362306',2,2,'晋江市福大科教园区发展中心','15880272172','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663714653077506','1218097536540147714','1334663714653077506',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663714871181313','1241252588561698817','1334663714871181313',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663715043147778','1277069643340627970','1334663715043147778',2,2,'晋江市益心社工服务中心','15260372095','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663715231891458','1289035100629032961','1334663715231891458',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663715458383873','1295900371603947522','1334663715458383873',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663715663904769','1296659016558051330','1334663715663904769',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663715831676929','1323539148186906626','1334663715831676929',2,2,'晋江市恒溢雨具有限公司','13960285632','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334663716049780737','1324607776583880706','1334663716049780737',2,2,'深圳航空有限责任公司泉州分公司','13799233698','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-04 09:00:01',NULL,NULL,NULL,'2020-12-04 09:00:01',NULL,NULL,NULL),('1334781118292951041',NULL,'1334781118292951041',2,1,NULL,'15905039624','916045','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-04 16:46:32',NULL,NULL,NULL,'2020-12-04 16:46:32',NULL,NULL,NULL),('1334785345627095042',NULL,'1334785345627095042',2,1,NULL,'15960788012','343824','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-04 17:03:20',NULL,NULL,NULL,'2020-12-04 17:03:20',NULL,NULL,NULL),('1335062951794573314',NULL,'1335062951794573314',2,1,NULL,'18859969666','704989','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-05 11:26:26',NULL,NULL,NULL,'2020-12-05 11:26:26',NULL,NULL,NULL),('1335066826073178114',NULL,'1335066826073178114',2,1,NULL,'18150505090','441948','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-05 11:41:50',NULL,NULL,NULL,'2020-12-05 11:41:50',NULL,NULL,NULL),('1335129912813551617',NULL,'1335129912813551617',2,1,NULL,'13074937542','418786','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-05 15:52:31',NULL,NULL,NULL,'2020-12-05 15:52:31',NULL,NULL,NULL),('1335590198674718722',NULL,'1335590198674718722',2,1,NULL,'17557282029','171578','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-06 22:21:32',NULL,NULL,NULL,'2020-12-06 22:21:32',NULL,NULL,NULL),('1335750873875218434','1211128473930805250','1335750873875218434',2,2,'福建晋江凤竹鞋业发展有限公司','13959957107','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874101710850','70','1335750874101710850',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874101710851','58','1335750874101710851',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874202374145','58','1335750874202374145',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874273677314','1211139634755645442','1335750874273677314',2,2,'福建百宏高新材料实业有限公司','13305967663','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874445643778','1211171114114461697','1335750874445643778',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874542112770','76','1335750874542112770',1,2,'陈灿峰','13599718877','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874542112771','87','1335750874542112771',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874630193153','1211441648983130114','1335750874630193153',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874663747586','87','1335750874663747586',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874802159617','83','1335750874802159617',1,2,'李女元','15359825666','18,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874806353921','97','1335750874806353921',1,2,'吴思莹','12345674868','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874869268482','1211442194934710274','1335750874869268482',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750875066400770','1211459203080699905','1335750875066400770',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750875141898241','97','1335750875141898241',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750875221590018','1211461407799820290','1335750875221590018',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750875389362178','1211473406755651586','1335750875389362178',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750875565522945','1211474926804975617','1335750875565522945',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750875733295106','1211476436687306754','1335750875733295106',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750875888484353','1211490446086291458','1335750875888484353',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750876077228033','1211574035113099265','1335750876077228033',2,2,'三六一度(中国)有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750876249194498','1211837849989595138','1335750876249194498',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750876404383745','1211923801521045506','1335750876404383745',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750876601516034','1211927486787534850','1335750876601516034',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750876786065410','1212253296765505538','1335750876786065410',2,2,'泉州寰球鞋服有限公司','13580701185','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750876945448962','1212685717864517633','1335750876945448962',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750877109026817','1212906675946721282','1335750877109026817',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750877289381890','1212910689362972674','1335750877289381890',2,2,'福建盛达机器股份公司','15359382970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750877469736962','1213451329813417985','1335750877469736962',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750877641703426','1214097817526620161','1335750877641703426',2,2,'福建恒安集团有限公司','13960315655','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750877834641410','1215207699331989506','1335750877834641410',2,2,'晋江市医院','18350528526','10,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:00',NULL,NULL,NULL,'2020-12-07 09:00:00',NULL,NULL,NULL),('1335750878052745217','1216568840104734722','1335750878052745217',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750878233100290','1218097536540147714','1335750878233100290',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750878405066754','1219241646047223809','1335750878405066754',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750878598004737','1241252588561698817','1335750878598004737',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750878757388289','1277069643340627970','1335750878757388289',2,2,'晋江市益心社工服务中心','15260372095','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750878958714881','1292741409895460865','1335750878958714881',2,2,'广发证券股份有限公司晋江长兴路证券营业部','18559595923','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750879109709825','1295900371603947522','1335750879109709825',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750879264899074','1296659016558051330','1335750879264899074',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750879466225666','1324166786635067394','1335750879466225666',2,2,'泉州市云知晓信息科技有限公司','15805933163','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335750879667552258','1324607776583880706','1335750879667552258',2,2,'深圳航空有限责任公司泉州分公司','13799233698','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-07 09:00:01',NULL,NULL,NULL,'2020-12-07 09:00:01',NULL,NULL,NULL),('1335770921603956738',NULL,'1335770921603956738',2,1,NULL,'18059998188','461004','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-07 10:19:39',NULL,NULL,NULL,'2020-12-07 10:19:39',NULL,NULL,NULL),('1335787253552644097',NULL,'1335787253552644097',2,1,NULL,'18505986016','139927','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-07 11:24:33',NULL,NULL,NULL,'2020-12-07 11:24:33',NULL,NULL,NULL),('1335843462599147522',NULL,'1335843462599147522',2,1,NULL,'13860703504','609071','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-07 15:07:54',NULL,NULL,NULL,'2020-12-07 15:07:54',NULL,NULL,NULL),('1336113261677903873','1211128473930805250','1336113261677903873',2,2,'福建晋江凤竹鞋业发展有限公司','13959957107','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261745012738','1211490953219588098','1336113261745012738',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261925367809','70','1336113261925367809',1,2,'陈瑞清','13788864979','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261929562113','58','1336113261929562113',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261933756418','58','1336113261933756418',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262101528577','1211139634755645442','1336113262101528577',2,2,'福建百宏高新材料实业有限公司','13305967663','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262101528578','1211945706491789313','1336113262101528578',2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262286077954','87','1336113262286077954',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262294466562','76','1336113262294466562',1,2,'陈灿峰','13599718877','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262307049473','87','1336113262307049473',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262328020993','1213031390673702913','1336113262328020993',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262340603906','1211171114114461697','1336113262340603906',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262458044417','83','1336113262458044417',1,2,'李女元','15359825666','21,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262499987457','97','1336113262499987457',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262512570370','1211442194934710274','1336113262512570370',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262537736193','97','1336113262537736193',1,2,'吴思莹','12345674868','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262625816578','86','1336113262625816578',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262697119745','1211459203080699905','1336113262697119745',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113262873280513','1211461407799820290','1336113262873280513',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113263129133058','1211473406755651586','1336113263129133058',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113263301099522','1211474926804975617','1336113263301099522',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113263510814722','1211476436687306754','1336113263510814722',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113263682781185','1211837849989595138','1336113263682781185',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113263858941953','1211923801521045506','1336113263858941953',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113264026714113','1211927486787534850','1336113264026714113',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113264211263489','1212253296765505538','1336113264211263489',2,2,'泉州寰球鞋服有限公司','13580701185','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113264400007170','1212685717864517633','1336113264400007170',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113264584556546','1212906675946721282','1336113264584556546',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113264760717314','1212910689362972674','1336113264760717314',2,2,'福建盛达机器股份公司','15359382970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113264983015425','1213451329813417985','1336113264983015425',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113265167564801','1214097817526620161','1336113265167564801',2,2,'福建恒安集团有限公司','13960315655','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113265368891394','1215207699331989506','1336113265368891394',2,2,'晋江市医院','18350528526','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113265549246466','1218097536540147714','1336113265549246466',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113265742184449','1218160739617931266','1336113265742184449',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:00',NULL,NULL,NULL,'2020-12-08 09:00:00',NULL,NULL,NULL),('1336113265935122434','1219241646047223809','1336113265935122434',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:01',NULL,NULL,NULL,'2020-12-08 09:00:01',NULL,NULL,NULL),('1336113266107088898','1241252588561698817','1336113266107088898',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:01',NULL,NULL,NULL,'2020-12-08 09:00:01',NULL,NULL,NULL),('1336113266300026882','1277069643340627970','1336113266300026882',2,2,'晋江市益心社工服务中心','15260372095','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:01',NULL,NULL,NULL,'2020-12-08 09:00:01',NULL,NULL,NULL),('1336113266480381953','1295900371603947522','1336113266480381953',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:01',NULL,NULL,NULL,'2020-12-08 09:00:01',NULL,NULL,NULL),('1336113266681708546','1296659016558051330','1336113266681708546',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:01',NULL,NULL,NULL,'2020-12-08 09:00:01',NULL,NULL,NULL),('1336113266908200961','1324166786635067394','1336113266908200961',2,2,'泉州市云知晓信息科技有限公司','15805933163','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-08 09:00:01',NULL,NULL,NULL,'2020-12-08 09:00:01',NULL,NULL,NULL),('1336321655202381825',NULL,'1336321655202381825',2,1,NULL,'15985879203','124658','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-08 22:48:04',NULL,NULL,NULL,'2020-12-08 22:48:04',NULL,NULL,NULL),('1336475649602224130','1211945706491789313','1336475649602224130',2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649656750082','1211128473930805250','1336475649656750082',2,2,'福建晋江凤竹鞋业发展有限公司','13959957107','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649816133633','58','1336475649816133633',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649824522241','58','1336475649824522241',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649879048194','70','1336475649879048194',1,2,'陈瑞清','13788864979','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650042626049','1211441648983130114','1336475650042626049',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650185232386','87','1336475650185232386',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650193620993','87','1336475650193620993',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650218786818','1211459203080699905','1336475650218786818',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650298478593','78','1336475650298478593',1,2,'陈一帆','13489760211','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650382364673','97','1336475650382364673',1,2,'吴思莹','12345674868','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650386558977','97','1336475650386558977',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650424307714','1211461407799820290','1336475650424307714',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650470445057','83','1336475650470445057',1,2,'李女元','15359825666','27,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650613051393','1211473406755651586','1336475650613051393',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650793406465','1211474926804975617','1336475650793406465',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475650977955842','1211476436687306754','1336475650977955842',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475651250585601','1211923801521045506','1336475651250585601',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475651418357762','1211927486787534850','1336475651418357762',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475651581935618','1212685717864517633','1336475651581935618',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475651741319170','1212906675946721282','1336475651741319170',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475651909091329','1212910689362972674','1336475651909091329',2,2,'福建盛达机器股份公司','15359382970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475652081057793','1213451329813417985','1336475652081057793',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475652253024257','1214097817526620161','1336475652253024257',2,2,'福建恒安集团有限公司','13960315655','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475652433379330','1215207699331989506','1336475652433379330',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475652626317313','1218097536540147714','1336475652626317313',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475652785700866','1218160739617931266','1336475652785700866',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475652953473025','1219241646047223809','1336475652953473025',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475653125439490','1241252588561698817','1336475653125439490',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475653293211650','1295900371603947522','1336475653293211650',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336475653448400898','1296659016558051330','1336475653448400898',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-09 09:00:00',NULL,NULL,NULL,'2020-12-09 09:00:00',NULL,NULL,NULL),('1336495261777657858',NULL,'1336495261777657858',2,1,NULL,'15980092234','354279','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-09 10:17:55',NULL,NULL,NULL,'2020-12-09 10:17:55',NULL,NULL,NULL),('1336509867665391617',NULL,'1336509867665391617',2,1,NULL,'18105087203','193725','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-09 11:15:58',NULL,NULL,NULL,'2020-12-09 11:15:58',NULL,NULL,NULL),('1336545137542561793',NULL,'1336545137542561793',2,1,NULL,'15375882135','168754','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-09 13:36:07',NULL,NULL,NULL,'2020-12-09 13:36:07',NULL,NULL,NULL),('1336565448988164097','1336495794064195585','1336565448988164097',2,2,'晋江市高甲柯派表演艺术中心','15980092234','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-09 14:56:49',NULL,NULL,NULL,'2020-12-09 14:56:49',NULL,NULL,NULL),('1336570302762582017',NULL,'1336570302762582017',2,1,NULL,'18965616589','091048','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-09 15:16:07',NULL,NULL,NULL,'2020-12-09 15:16:07',NULL,NULL,NULL),('1336570867395592193','1336570514910478338','1336570867395592193',2,2,'泉州华夏生态养生文化有限公司','18965616589','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-09 15:18:21',NULL,NULL,NULL,'2020-12-09 15:18:21',NULL,NULL,NULL),('1336572387654631425',NULL,'1336572387654631425',2,1,NULL,'13788800671','110062','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-09 15:24:24',NULL,NULL,NULL,'2020-12-09 15:24:24',NULL,NULL,NULL),('1336573836614696962','1336573384896544769','1336573836614696962',2,2,'晋江振东房地产开发有限公司','13788800671','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-09 15:30:09',NULL,NULL,NULL,'2020-12-09 15:30:09',NULL,NULL,NULL),('1336575157237448705',NULL,'1336575157237448705',2,1,NULL,'13788800671','621130','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-09 15:35:24',NULL,NULL,NULL,'2020-12-09 15:35:24',NULL,NULL,NULL),('1336838037526544385','1211441648983130114','1336838037526544385',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037669150721','58','1336838037669150721',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037694316546','1211554636561956866','1336838037694316546',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037736259586','58','1336838037736259586',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037761425409','70','1336838037761425409',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037971140609','1211459203080699905','1336838037971140609',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038021472257','87','1336838038021472257',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038075998209','87','1336838038075998209',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038101164034','83','1336838038101164034',1,2,'李女元','15359825666','27,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038180855809','1211461407799820290','1336838038180855809',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038180855810','97','1336838038180855810',1,2,'吴思莹','12345674868','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038252158977','97','1336838038252158977',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038386376706','1211473406755651586','1336838038386376706',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038545760257','1211474926804975617','1336838038545760257',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038709338113','1211476436687306754','1336838038709338113',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838038864527362','1211923801521045506','1336838038864527362',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838039015522306','1211927486787534850','1336838039015522306',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838039174905858','1212685717864517633','1336838039174905858',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838039342678018','1212906675946721282','1336838039342678018',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838039514644481','1214097817526620161','1336838039514644481',2,2,'福建恒安集团有限公司','13960315655','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838039669833729','1215207699331989506','1336838039669833729',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838039833411585','1218097536540147714','1336838039833411585',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838039996989441','1218160739617931266','1336838039996989441',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838040164761601','1219241646047223809','1336838040164761601',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838040324145154','1241252588561698817','1336838040324145154',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838040475140098','1295900371603947522','1336838040475140098',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336838040630329345','1296659016558051330','1336838040630329345',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-10 09:00:00',NULL,NULL,NULL,'2020-12-10 09:00:00',NULL,NULL,NULL),('1336953193396961281',NULL,'1336953193396961281',2,1,NULL,'13358438305','300443','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-10 16:37:35',NULL,NULL,NULL,'2020-12-10 16:37:35',NULL,NULL,NULL),('1336953922077589506',NULL,'1336953922077589506',2,1,NULL,'13358438305','348646','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-10 16:40:29',NULL,NULL,NULL,'2020-12-10 16:40:29',NULL,NULL,NULL),('1336955835212890113',NULL,'1336955835212890113',2,1,NULL,'13358438305','052695','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-10 16:48:05',NULL,NULL,NULL,'2020-12-10 16:48:05',NULL,NULL,NULL),('1336956435908526081',NULL,'1336956435908526081',2,1,NULL,'13358438305','911519','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-10 16:50:28',NULL,NULL,NULL,'2020-12-10 16:50:28',NULL,NULL,NULL),('1336958733183352834',NULL,'1336958733183352834',2,1,NULL,'13459557105','279619','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-10 16:59:36',NULL,NULL,NULL,'2020-12-10 16:59:36',NULL,NULL,NULL),('1337200425614442497','1211461407799820290','1337200425614442497',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425652191234','1211554636561956866','1337200425652191234',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425803186178','58','1337200425803186178',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425824157698','70','1337200425824157698',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425836740609','58','1337200425836740609',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425975152641','1211473406755651586','1337200425975152641',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426205839361','87','1337200426205839361',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426222616578','83','1337200426222616578',1,2,'李女元','15359825666','27,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426348445697','87','1337200426348445697',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426356834306','1211474926804975617','1337200426356834306',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426491052034','97','1337200426491052034',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426591715330','1211476436687306754','1337200426591715330',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426788847618','97','1337200426788847618',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200426826596353','1211923801521045506','1337200426826596353',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200427053088769','1211927486787534850','1337200427053088769',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200427254415362','1212685717864517633','1337200427254415362',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200427459936257','1212906675946721282','1337200427459936257',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200427661262849','1215207699331989506','1337200427661262849',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200427854200834','1218097536540147714','1337200427854200834',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200428105859073','1218160739617931266','1337200428105859073',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200428298797057','1219241646047223809','1337200428298797057',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200428487540737','1241252588561698817','1337200428487540737',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200428680478722','1295900371603947522','1337200428680478722',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337200428915359745','1296659016558051330','1337200428915359745',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 09:00:00',NULL,NULL,NULL,'2020-12-11 09:00:00',NULL,NULL,NULL),('1337219135544754177','1336510146032959489','1337219135544754177',2,2,'晋江市第二中学','18105087203','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-11 10:14:20',NULL,NULL,NULL,'2020-12-11 10:14:20',NULL,NULL,NULL),('1337221382294994946','1335771058392793090','1337221382294994946',2,2,'晋江力绿食品有限公司','18059998188','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-11 10:23:16',NULL,NULL,NULL,'2020-12-11 10:23:16',NULL,NULL,NULL),('1337221934458339330','1335066891319771137','1337221934458339330',2,2,'琪尔特集团有限公司','18150505090','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-11 10:25:28',NULL,NULL,NULL,'2020-12-11 10:25:28',NULL,NULL,NULL),('1337227497367928834',NULL,'1337227497367928834',2,1,NULL,'18659822322','822355','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-11 10:47:34',NULL,NULL,NULL,'2020-12-11 10:47:34',NULL,NULL,NULL),('1337233909955428353',NULL,'1337233909955428353',2,1,NULL,'13599106460','804000','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-11 11:13:03',NULL,NULL,NULL,'2020-12-11 11:13:03',NULL,NULL,NULL),('1337235004270313473',NULL,'1337235004270313473',2,1,NULL,'13960315655','627645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-11 11:17:24',NULL,NULL,NULL,'2020-12-11 11:17:24',NULL,NULL,NULL),('1337235256058576897',NULL,'1337235256058576897',2,1,NULL,'15960410213','798990','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-11 11:18:24',NULL,NULL,NULL,'2020-12-11 11:18:24',NULL,NULL,NULL),('1337291749646663682','1337235294725865473','1337291749646663682',2,2,'福建恒安家庭生活用品有限公司','15960410213','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-11 15:02:53',NULL,NULL,NULL,'2020-12-11 15:02:53',NULL,NULL,NULL),('1337295501350928385',NULL,'1337295501350928385',2,1,NULL,'15260055555','286337','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-11 15:17:47',NULL,NULL,NULL,'2020-12-11 15:17:47',NULL,NULL,NULL),('1337299835035844610',NULL,'1337299835035844610',2,1,NULL,'15106023277','393483','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-11 15:35:01',NULL,NULL,NULL,'2020-12-11 15:35:01',NULL,NULL,NULL),('1337321265303650305',NULL,'1337321265303650305',2,1,NULL,'15106023277','091936','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-11 17:00:10',NULL,NULL,NULL,'2020-12-11 17:00:10',NULL,NULL,NULL),('1337656740774150145',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','18959705077','18959705077','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740778344450',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','13615926622','13615926622','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740778344451',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','13905974006','13905974006','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740778344452',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','13860300607','13860300607','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740778344453',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','18050878002','18050878002','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740778344454',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','13459572329','13459572329','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740782538754',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','13859726335','13859726335','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740782538755',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','18859210518','18859210518','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',3,'短信发送成功','2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1337656740782538756',NULL,'1337656740413440001',2,2,'批量发送(关于补充2019年优秀人才津补贴申报材料的通知20201212)','15959525859\n','15959525859\n','【晋江市人才服务平台】通知:请您于2020年12月14日中午12点前将2019年度津补贴申报材料补齐，电子版发邮箱jjrc85661234@163.com，逾期将不予兑现2019年度人才津补贴。(相关材料需原件扫描并加盖用人单位公章)',1,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL,'2020-12-12 15:13:14',NULL,NULL,NULL),('1338045249586462722',NULL,'1338045249586462722',2,1,NULL,'15260812636','653253','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-13 16:57:01',NULL,NULL,NULL,'2020-12-13 16:57:01',NULL,NULL,NULL),('1338287589051858945','1211554636561956866','1338287589051858945',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589060247553','1211461407799820290','1338287589060247553',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589286739970','70','1338287589286739970',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589299322881','58','1338287589299322881',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589299322882','58','1338287589299322882',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589521620994','1211473406755651586','1338287589521620994',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589693587457','87','1338287589693587457',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589706170370','87','1338287589706170370',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589727141890','1211474926804975617','1338287589727141890',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589727141891','83','1338287589727141891',1,2,'李女元','15359825666','29,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287590079463426','1211923801521045506','1338287590079463426',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287590079463427','97','1338287590079463427',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287590234652674','97','1338287590234652674',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287590268207105','1211927486787534850','1338287590268207105',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287590465339393','1212685717864517633','1338287590465339393',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287590666665986','1212906675946721282','1338287590666665986',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287590842826753','1215207699331989506','1338287590842826753',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287591035764738','1218097536540147714','1338287591035764738',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287591216119810','1218160739617931266','1338287591216119810',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287591438417922','1219241646047223809','1338287591438417922',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287591631355906','1241252588561698817','1338287591631355906',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287591824293889','1295900371603947522','1338287591824293889',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338287592025620482','1296659016558051330','1338287592025620482',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 09:00:00',NULL,NULL,NULL,'2020-12-14 09:00:00',NULL,NULL,NULL),('1338302350221115393','1331913401814745089','1338302350221115393',2,2,'晋江市俞大猷剑经研究会','15260055555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-14 09:58:39',NULL,NULL,NULL,'2020-12-14 09:58:39',NULL,NULL,NULL),('1338350006154821634',NULL,'1338350006154821634',2,1,NULL,'13459572329','867165','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 13:08:01',NULL,NULL,NULL,'2020-12-14 13:08:01',NULL,NULL,NULL),('1338386100321779713',NULL,'1338386100321779713',2,1,NULL,'17601459038','449016','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 15:31:26',NULL,NULL,NULL,'2020-12-14 15:31:26',NULL,NULL,NULL),('1338408411456339970',NULL,'1338408411456339970',2,1,NULL,'13599161367','951904','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 17:00:06',NULL,NULL,NULL,'2020-12-14 17:00:06',NULL,NULL,NULL),('1338415391495421954',NULL,'1338415391495421954',2,1,NULL,'13805926950','300811','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 17:27:50',NULL,NULL,NULL,'2020-12-14 17:27:50',NULL,NULL,NULL),('1338416895723831297',NULL,'1338416895723831297',2,1,NULL,'13960378303','485012','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 17:33:49',NULL,NULL,NULL,'2020-12-14 17:33:49',NULL,NULL,NULL),('1338419209431941122',NULL,'1338419209431941122',2,1,NULL,'13599161367','701362','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 17:43:00',NULL,NULL,NULL,'2020-12-14 17:43:00',NULL,NULL,NULL),('1338449210097270786',NULL,'1338449210097270786',2,1,NULL,'18906060102','534356','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 19:42:13',NULL,NULL,NULL,'2020-12-14 19:42:13',NULL,NULL,NULL),('1338456755188793345','1337321333503033345','1338456755188793345',2,2,'福建','15106023277','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 20:12:12',NULL,NULL,NULL,'2020-12-14 20:12:12',NULL,NULL,NULL),('1338457149235265537','1338417326906671105','1338457149235265537',2,2,'福建长景建设有限公司','13960378303','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-14 20:13:46',NULL,NULL,NULL,'2020-12-14 20:13:46',NULL,NULL,NULL),('1338457516413026306','1338449877369094145','1338457516413026306',2,2,'欧中(晋江)工业技术开发有限责任公司','18906060102','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-14 20:15:13',NULL,NULL,NULL,'2020-12-14 20:15:13',NULL,NULL,NULL),('1338464720872538114',NULL,'1338464720872538114',2,1,NULL,'18850313393','840722','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-14 20:43:51',NULL,NULL,NULL,'2020-12-14 20:43:51',NULL,NULL,NULL),('1338649976925847553','1211461407799820290','1338649976925847553',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977051676674','1211554636561956866','1338649977051676674',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977236226049','70','1338649977236226049',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977395609601','72','1338649977395609601',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977412386817','58','1338649977412386817',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977475301377','1211473406755651586','1338649977475301377',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977705988097','1211474926804975617','1338649977705988097',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977764708353','83','1338649977764708353',1,2,'李女元','15359825666','29,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977785679873','58','1338649977785679873',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977869565953','87','1338649977869565953',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649978033143810','1211923801521045506','1338649978033143810',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649978125418498','87','1338649978125418498',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649978209304578','97','1338649978209304578',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649978351910913','97','1338649978351910913',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649978360299521','1211927486787534850','1338649978360299521',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649978926530562','1212685717864517633','1338649978926530562',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649979283046401','1212906675946721282','1338649979283046401',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649979547287554','1215207699331989506','1338649979547287554',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649979715059713','1218097536540147714','1338649979715059713',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649980247736321','1218160739617931266','1338649980247736321',2,2,'泉州市宜家装饰工程有限公司晋江市青阳分公司','13205957447','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649980402925569','1219241646047223809','1338649980402925569',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649980595863553','1241252588561698817','1338649980595863553',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649980759441410','1295900371603947522','1338649980759441410',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:00',NULL,NULL,NULL,'2020-12-15 09:00:00',NULL,NULL,NULL),('1338649980948185090','1296659016558051330','1338649980948185090',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-15 09:00:01',NULL,NULL,NULL,'2020-12-15 09:00:01',NULL,NULL,NULL),('1338655818010066945',NULL,'1338655818010066945',2,1,NULL,'13599161367','081403','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 09:23:12',NULL,NULL,NULL,'2020-12-15 09:23:12',NULL,NULL,NULL),('1338660882426626050',NULL,'1338660882426626050',2,1,NULL,'13799872505','009679','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 09:43:20',NULL,NULL,NULL,'2020-12-15 09:43:20',NULL,NULL,NULL),('1338671381360934913',NULL,'1338671381360934913',2,1,NULL,'13677665015','399258','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 10:25:03',NULL,NULL,NULL,'2020-12-15 10:25:03',NULL,NULL,NULL),('1338677870951661570',NULL,'1338677870951661570',2,1,NULL,'17689391260','959897','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 10:50:50',NULL,NULL,NULL,'2020-12-15 10:50:50',NULL,NULL,NULL),('1338690928369467393',NULL,'1338690928369467393',2,1,NULL,'13805926950','636741','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 11:42:43',NULL,NULL,NULL,'2020-12-15 11:42:43',NULL,NULL,NULL),('1338738118391496705',NULL,'1338738118391496705',2,1,NULL,'15106023277','014405','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 14:50:14',NULL,NULL,NULL,'2020-12-15 14:50:14',NULL,NULL,NULL),('1338767618894462977',NULL,'1338767618894462977',2,1,NULL,'15005933550','122399','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 16:47:28',NULL,NULL,NULL,'2020-12-15 16:47:28',NULL,NULL,NULL),('1338772566059253761','1338350696818278402','1338772566059253761',2,2,'晋江中运体育建设发展有限公司','13459572329','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-15 17:07:07',NULL,NULL,NULL,'2020-12-15 17:07:07',NULL,NULL,NULL),('1338777738114236417',NULL,'1338777738114236417',2,1,NULL,'13400806006','614650','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 17:27:40',NULL,NULL,NULL,'2020-12-15 17:27:40',NULL,NULL,NULL),('1338778106080526337',NULL,'1338778106080526337',2,1,NULL,'13400806006','508544','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 17:29:08',NULL,NULL,NULL,'2020-12-15 17:29:08',NULL,NULL,NULL),('1338783547770535937',NULL,'1338783547770535937',2,1,NULL,'13665929319','888582','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 17:50:45',NULL,NULL,NULL,'2020-12-15 17:50:45',NULL,NULL,NULL),('1338784809090023425',NULL,'1338784809090023425',2,1,NULL,'18750503035','364816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-15 17:55:46',NULL,NULL,NULL,'2020-12-15 17:55:46',NULL,NULL,NULL),('1339012364636258306','1211453814360555522','1339012364636258306',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012364636258307','1211554636561956866','1339012364636258307',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365106020357','58','1339012365106020357',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365126991873','70','1339012365126991873',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365139574786','58','1339012365139574786',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365307346945','1211461407799820290','1339012365307346945',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365579976706','1211473406755651586','1339012365579976706',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365617725441','87','1339012365617725441',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365626114050','87','1339012365626114050',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365638696962','83','1339012365638696962',1,2,'李女元','15359825666','29,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365772914689','1211474926804975617','1339012365772914689',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365869383682','97','1339012365869383682',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365869383683','97','1339012365869383683',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365986824194','1211923801521045506','1339012365986824194',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012366230093826','1211927486787534850','1339012366230093826',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012366452391937','1212906675946721282','1339012366452391937',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012366632747010','1215207699331989506','1339012366632747010',2,2,'晋江市医院','18350528526','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012366922153986','1218097536540147714','1339012366922153986',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012367115091970','1219241646047223809','1339012367115091970',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012367333195778','1241252588561698817','1339012367333195778',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012367538716674','1295900371603947522','1339012367538716674',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339012367706488833','1296659016558051330','1339012367706488833',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 09:00:00',NULL,NULL,NULL,'2020-12-16 09:00:00',NULL,NULL,NULL),('1339021108455669762',NULL,'1339021108455669762',2,1,NULL,'15396380625','598695','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-16 09:34:44',NULL,NULL,NULL,'2020-12-16 09:34:44',NULL,NULL,NULL),('1339047333173657602','1331809968285810690','1339047333173657602',2,2,'福建省向兴纺织科技有限公司','15880881998','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-16 11:18:57',NULL,NULL,NULL,'2020-12-16 11:18:57',NULL,NULL,NULL),('1339050115851091969','1337321333503033345','1339050115851091969',2,2,'福建晋创置业有限公司','15106023277','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-16 11:30:00',NULL,NULL,NULL,'2020-12-16 11:30:00',NULL,NULL,NULL),('1339090489197985793',NULL,'1339090489197985793',2,1,NULL,'13489319022','882740','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-16 14:10:26',NULL,NULL,NULL,'2020-12-16 14:10:26',NULL,NULL,NULL),('1339102123501027329',NULL,'1339102123501027329',2,1,NULL,'15260850530','409622','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-16 14:56:40',NULL,NULL,NULL,'2020-12-16 14:56:40',NULL,NULL,NULL),('1339108035959717889',NULL,'1339108035959717889',2,1,NULL,'19942826787','312142','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-16 15:20:09',NULL,NULL,NULL,'2020-12-16 15:20:09',NULL,NULL,NULL),('1339110406840385537',NULL,'1339110406840385537',2,1,NULL,'17750530050','599578','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-16 15:29:35',NULL,NULL,NULL,'2020-12-16 15:29:35',NULL,NULL,NULL),('1339112512490045441','1338691874809970690','1339112512490045441',2,2,'福建仙景建设有限公司','13805926950','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-16 15:37:57',NULL,NULL,NULL,'2020-12-16 15:37:57',NULL,NULL,NULL),('1339112980486291458','1338778188502794242','1339112980486291458',2,2,'晋江市荣誉国际酒店有限责任公司','13400806006','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-16 15:39:48',NULL,NULL,NULL,'2020-12-16 15:39:48',NULL,NULL,NULL),('1339113411593633794','1338784953806094337','1339113411593633794',2,2,'福建盼盼投资有限公司','18750503035','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-16 15:41:31',NULL,NULL,NULL,'2020-12-16 15:41:31',NULL,NULL,NULL),('1339113630003625985','1338678221159268353','1339113630003625985',2,2,'晋江学校','17689391260','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-16 15:42:23',NULL,NULL,NULL,'2020-12-16 15:42:23',NULL,NULL,NULL),('1339113917200203778','1339090713744244738','1339113917200203778',2,2,'梅花(晋江)伞业有限公司','13489319022','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-16 15:43:32',NULL,NULL,NULL,'2020-12-16 15:43:32',NULL,NULL,NULL),('1339114480872718338','1339103086685192194','1339114480872718338',2,2,'奇峰(福建)食品有限公司','15260850530','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-16 15:45:46',NULL,NULL,NULL,'2020-12-16 15:45:46',NULL,NULL,NULL),('1339374752531218433','1211461407799820290','1339374752531218433',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752556384258','1211554636561956866','1339374752556384258',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752724156418','70','1339374752724156418',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752757710850','58','1339374752757710850',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752782876673','58','1339374752782876673',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752883539970','1211473406755651586','1339374752883539970',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752950648834','1331802046063443969','1339374752950648834',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753055506433','1211474926804975617','1339374753055506433',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753063895041','83','1339374753063895041',1,2,'李女元','15359825666','29,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753122615297','87','1339374753122615297',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753156169730','87','1339374753156169730',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753261027329','1211837828162437121','1339374753261027329',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753277804546','97','1339374753277804546',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753307164674','97','1339374753307164674',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753437188098','1211923801521045506','1339374753437188098',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753625931778','1211927486787534850','1339374753625931778',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374753957281794','1212906675946721282','1339374753957281794',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374754133442562','1215207699331989506','1339374754133442562',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374754317991937','1215608523329683457','1339374754317991937',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374754565455874','1218097536540147714','1339374754565455874',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374754754199553','1219241646047223809','1339374754754199553',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374754963914753','1241252588561698817','1339374754963914753',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374755161047042','1295550188802277378','1339374755161047042',2,2,'晋江市磁灶镇李锦成农场','13960232793','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374755337207810','1295900371603947522','1339374755337207810',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374755530145794','1296659016558051330','1339374755530145794',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339374755781804033','1336495794064195585','1339374755781804033',2,2,'晋江市高甲柯派表演艺术中心','15980092234','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-17 09:00:00',NULL,NULL,NULL,'2020-12-17 09:00:00',NULL,NULL,NULL),('1339496543425658882',NULL,'1339496543425658882',2,1,NULL,'18659595539','586732','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-17 17:03:57',NULL,NULL,NULL,'2020-12-17 17:03:57',NULL,NULL,NULL),('1339497162752393218',NULL,'1339497162752393218',2,1,NULL,'18659595539','594796','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-17 17:06:24',NULL,NULL,NULL,'2020-12-17 17:06:24',NULL,NULL,NULL),('1339728533890531330',NULL,'1339728533890531330',2,1,NULL,'15396380625','386490','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-18 08:25:48',NULL,NULL,NULL,'2020-12-18 08:25:48',NULL,NULL,NULL),('1339729639890747394',NULL,'1339729639890747394',2,1,NULL,'15396380625','616839','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-18 08:30:11',NULL,NULL,NULL,'2020-12-18 08:30:11',NULL,NULL,NULL),('1339730406500466690',NULL,'1339730406500466690',2,1,NULL,'15396380625','783826','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-18 08:33:14',NULL,NULL,NULL,'2020-12-18 08:33:14',NULL,NULL,NULL),('1339737140350681090','1331802046063443969','1339737140350681090',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140392624129','1211461407799820290','1339737140392624129',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140535230467','58','1339737140535230467',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140577173506','58','1339737140577173506',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140577173507','70','1339737140577173507',1,2,'陈瑞清','13788864979','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140765917185','1211473406755651586','1339737140765917185',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140874969090','87','1339737140874969090',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140929495041','83','1339737140929495041',1,2,'李女元','15359825666','30,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140933689346','87','1339737140933689346',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140963049474','1211474926804975617','1339737140963049474',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141046935554','97','1339737141046935554',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141076295682','97','1339737141076295682',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141147598850','1211923801521045506','1339737141147598850',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141319565313','1211927486787534850','1339737141319565313',2,2,'国家服装服饰质量监督检验中心（福建）','13509362773','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141491531777','1212906675946721282','1339737141491531777',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141655109633','1215608523329683457','1339737141655109633',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141822881794','1218097536540147714','1339737141822881794',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737141982265346','1219241646047223809','1339737141982265346',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737142137454594','1241252588561698817','1339737142137454594',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737142330392578','1295900371603947522','1339737142330392578',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737142510747650','1296659016558051330','1339737142510747650',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737142670131202','1303977759655100418','1339737142670131202',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737142829514754','1314765939572514817','1339737142829514754',2,2,'晋江市总工会','13960397234','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737142984704002','1331913401814745089','1339737142984704002',2,2,'晋江市俞大猷剑经研究会','15260055555','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737143202807810','1336495794064195585','1339737143202807810',2,2,'晋江市高甲柯派表演艺术中心','15980092234','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1339737143399940098','1338350696818278402','1339737143399940098',2,2,'晋江中运体育建设发展有限公司','13459572329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-18 09:00:00',NULL,NULL,NULL,'2020-12-18 09:00:00',NULL,NULL,NULL),('1340642070393520129',NULL,'1340642070393520129',2,1,NULL,'18046022952','042571','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-20 20:55:52',NULL,NULL,NULL,'2020-12-20 20:55:52',NULL,NULL,NULL),('1340824303993618434','1210918631014248450','1340824303993618434',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304035561473','1211100599215566849','1340824304035561473',2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304052338689','1211442194934710274','1340824304052338689',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304316579842','58','1340824304316579842',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304366911489','58','1340824304366911489',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304408854530','1211832959498240001','1340824304408854530',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304438214658','1211454669394591746','1340824304438214658',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304526295042','1278978156241391618','1340824304526295042',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304593403906','87','1340824304593403906',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304639541250','87','1340824304639541250',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304736010242','1331802046063443969','1340824304736010242',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304761176065','1215207699331989506','1340824304761176065',2,2,'晋江市医院','18350528526','2,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304765370370','97','1340824304765370370',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304815702018','1211461407799820290','1340824304815702018',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304815702019','97','1340824304815702019',1,2,'吴思莹','12345674868','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824305096720385','1211473406755651586','1340824305096720385',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824305310629890','1211474926804975617','1340824305310629890',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824305490984961','1211923801521045506','1340824305490984961',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824305683922946','1212906675946721282','1340824305683922946',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824305893638145','1214142410787934209','1340824305893638145',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824306107547650','1218097536540147714','1340824306107547650',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824306304679937','1219241646047223809','1340824306304679937',2,2,'福建晋江农村商业银行股份有限公司','15260663037','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824306543755266','1241252588561698817','1340824306543755266',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824306728304642','1295900371603947522','1340824306728304642',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824306904465410','1296659016558051330','1340824306904465410',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824307080626178','1301823981006909441','1340824307080626178',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824307260981250','1303977759655100418','1340824307260981250',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824307466502145','1335771058392793090','1340824307466502145',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340824307655245825','1339090713744244738','1340824307655245825',2,2,'梅花(晋江)伞业有限公司','13489319022','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-21 09:00:00',NULL,NULL,NULL,'2020-12-21 09:00:00',NULL,NULL,NULL),('1340840148576763905',NULL,'1340840148576763905',2,1,NULL,'18906060102','034231','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-21 10:02:57',NULL,NULL,NULL,'2020-12-21 10:02:57',NULL,NULL,NULL),('1340878792918302722',NULL,'1340878792918302722',2,1,NULL,'18046022952','358130','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-21 12:36:31',NULL,NULL,NULL,'2020-12-21 12:36:31',NULL,NULL,NULL),('1340903497578577921',NULL,'1340903497578577921',2,1,NULL,'18259823108','083229','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-21 14:14:41',NULL,NULL,NULL,'2020-12-21 14:14:41',NULL,NULL,NULL),('1340904193086455810',NULL,'1340904193086455810',2,1,NULL,'18259823108','317854','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-21 14:17:27',NULL,NULL,NULL,'2020-12-21 14:17:27',NULL,NULL,NULL),('1340997110710927361',NULL,'1340997110710927361',2,1,NULL,'18046022952','907096','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-21 20:26:40',NULL,NULL,NULL,'2020-12-21 20:26:40',NULL,NULL,NULL),('1341186691796303873','1211832959498240001','1341186691796303873',2,2,'晋江市南港污水处理有限公司','18350062033','1,晋江市优秀人才购房补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691808886786','1211171114114461697','1341186691808886786',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691817275393','1211454669394591746','1341186691817275393',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691846635521','1278978156241391618','1341186691846635521',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691972464641','58','1341186691972464641',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692010213377','72','1341186692010213377',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692077322241','83','1341186692077322241',1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692215734273','1211461407799820290','1341186692215734273',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692240900097','1211490953219588098','1341186692240900097',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692261871618','1331802046063443969','1341186692261871618',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692349952001','87','1341186692349952001',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692471586818','58','1341186692471586818',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692505141249','1211473406755651586','1341186692505141249',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692576444418','1211554636561956866','1341186692576444418',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692589027329','97','1341186692589027329',1,2,'吴思莹','12345674868','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692681302018','87','1341186692681302018',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692727439361','1211474926804975617','1341186692727439361',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692777771010','1214097817526620161','1341186692777771010',2,2,'福建恒安集团有限公司','13960315655','5,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692861657090','97','1341186692861657090',1,2,'吴思莹','12345674868','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692911988738','1211923801521045506','1341186692911988738',2,2,'福建省泉州闽星汽车销售服务有限公司','15260875883','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692966514690','1215548205433929729','1341186692966514690',2,2,'龙之族（中国）有限公司','15805972719','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186693100732418','1212906675946721282','1341186693100732418',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186693293670402','1214097817526620161','1341186693293670402',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186693478219777','1218097536540147714','1341186693478219777',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186693679546370','1219241646047223809','1341186693679546370',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186693885067265','1241252588561698817','1341186693885067265',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186694057033729','1295550188802277378','1341186694057033729',2,2,'晋江市磁灶镇李锦成农场','13960232793','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186694245777409','1295900371603947522','1341186694245777409',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186694447104001','1296659016558051330','1341186694447104001',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186694640041985','1301823981006909441','1341186694640041985',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341186694824591362','1314765939572514817','1341186694824591362',2,2,'晋江市总工会','13960397234','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 09:00:00',NULL,NULL,NULL,'2020-12-22 09:00:00',NULL,NULL,NULL),('1341207953587306497',NULL,'1341207953587306497',2,1,NULL,'15905971778','749965','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 10:24:29',NULL,NULL,NULL,'2020-12-22 10:24:29',NULL,NULL,NULL),('1341208489644523521',NULL,'1341208489644523521',2,1,NULL,'15905971778','615656','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 10:26:37',NULL,NULL,NULL,'2020-12-22 10:26:37',NULL,NULL,NULL),('1341209645070417922',NULL,'1341209645070417922',2,1,NULL,'15905971778','480261','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 10:31:12',NULL,NULL,NULL,'2020-12-22 10:31:12',NULL,NULL,NULL),('1341210061212483585',NULL,'1341210061212483585',2,1,NULL,'15905971778','185063','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 10:32:51',NULL,NULL,NULL,'2020-12-22 10:32:51',NULL,NULL,NULL),('1341210503090798593',NULL,'1341210503090798593',2,1,NULL,'15905971778','359813','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 10:34:37',NULL,NULL,NULL,'2020-12-22 10:34:37',NULL,NULL,NULL),('1341213015264985089','1338449877369094145','1341213015264985089',2,2,'欧中(晋江)工业技术开发有限责任公司','18906060102','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-22 10:44:36',NULL,NULL,NULL,'2020-12-22 10:44:36',NULL,NULL,NULL),('1341213456883253250','1340879615110938626','1341213456883253250',2,2,'泉州银行股份有限公司晋江英林支行','18046022952','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-22 10:46:21',NULL,NULL,NULL,'2020-12-22 10:46:21',NULL,NULL,NULL),('1341215824530112513','1340903538506596353','1341215824530112513',2,2,'福建德邦物流有限公司','18259823108','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-22 10:55:45',NULL,NULL,NULL,'2020-12-22 10:55:45',NULL,NULL,NULL),('1341230314214653953',NULL,'1341230314214653953',2,1,NULL,'13559628247','958895','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 11:53:20',NULL,NULL,NULL,'2020-12-22 11:53:20',NULL,NULL,NULL),('1341285815128424450',NULL,'1341285815128424450',2,1,NULL,'15059155128','178436','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 15:33:52',NULL,NULL,NULL,'2020-12-22 15:33:52',NULL,NULL,NULL),('1341292060493217793','1340879615110938626','1341292060493217793',2,2,'泉州银行股份有限公司晋江英林支行','18046022952','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-22 15:58:41',NULL,NULL,NULL,'2020-12-22 15:58:41',NULL,NULL,NULL),('1341317854842060801',NULL,'1341317854842060801',2,1,NULL,'15980019030','684518','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 17:41:11',NULL,NULL,NULL,'2020-12-22 17:41:11',NULL,NULL,NULL),('1341358170240450561',NULL,'1341358170240450561',2,1,NULL,'13404252272','036073','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 20:21:23',NULL,NULL,NULL,'2020-12-22 20:21:23',NULL,NULL,NULL),('1341359457942110209',NULL,'1341359457942110209',2,1,NULL,'15280217202','878047','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 20:26:30',NULL,NULL,NULL,'2020-12-22 20:26:30',NULL,NULL,NULL),('1341360752895721474',NULL,'1341360752895721474',2,1,NULL,'15960746554','487461','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 20:31:39',NULL,NULL,NULL,'2020-12-22 20:31:39',NULL,NULL,NULL),('1341361055183405058',NULL,'1341361055183405058',2,1,NULL,'15960746554','029785','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 20:32:51',NULL,NULL,NULL,'2020-12-22 20:32:51',NULL,NULL,NULL),('1341361148728967170',NULL,'1341361148728967170',2,1,NULL,'15280217202','989941','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-22 20:33:13',NULL,NULL,NULL,'2020-12-22 20:33:13',NULL,NULL,NULL),('1341549079699652610','1211490953219588098','1341549079699652610',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549079737401345','1278978156241391618','1341549079737401345',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549079804510209','1211117113914273793','1341549079804510209',2,2,'福建柒牌时装科技股份有限公司','15880936557','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080035196930','72','1341549080035196930',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080035196931','58','1341549080035196931',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080135860226','1211459203080699905','1341549080135860226',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080173608962','1331802046063443969','1341549080173608962',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080173608963','1211554636561956866','1341549080173608963',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080404295681','1211461407799820290','1341549080404295681',2,2,'晋江经济报发展有限责任公司','13505004167','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080412684290','58','1341549080412684290',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080412684291','1337235294725865473','1341549080412684291',2,2,'福建恒安家庭生活用品有限公司','15960410213','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080483987458','87','1341549080483987458',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080681119746','1211473406755651586','1341549080681119746',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080756617217','87','1341549080756617217',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080911806466','1211474926804975617','1341549080911806466',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080941166593','97','1341549080941166593',1,2,'吴思莹','12345674868','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549081050218497','97','1341549081050218497',1,2,'吴思莹','12345674868','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549081125715969','1211837849989595138','1341549081125715969',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549081356402690','1211930809942982658','1341549081356402690',2,2,'中国皮革和制鞋工业研究院（晋江）有限公司','15191454197','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549081549340673','1212540446794911745','1341549081549340673',2,2,'晋江七匹狼服装制造有限公司','13788808205','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549081767444481','1212692778300018689','1341549081767444481',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549082019102722','1212906675946721282','1341549082019102722',2,2,'宁波敦煌集团（晋江）线业有限公司','13505929732','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549082304315394','1214142410787934209','1341549082304315394',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549082509836289','1215207699331989506','1341549082509836289',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549082732134402','1219241646047223809','1341549082732134402',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549082979598338','1241252588561698817','1341549082979598338',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549083227062273','1280424993095716866','1341549083227062273',2,2,'晋江市掌中木偶艺术保护传承中心','13960208800','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549083436777473','1285493408407756802','1341549083436777473',2,2,'福建晋江热电有限公司','15059066119','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549083633909761','1289035100629032961','1341549083633909761',2,2,'中国电信股份有限公司晋江分公司','18960219966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:00',NULL,NULL,NULL,'2020-12-23 09:00:00',NULL,NULL,NULL),('1341549083931705345','1295900371603947522','1341549083931705345',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:01',NULL,NULL,NULL,'2020-12-23 09:00:01',NULL,NULL,NULL),('1341549084179169281','1296659016558051330','1341549084179169281',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:01',NULL,NULL,NULL,'2020-12-23 09:00:01',NULL,NULL,NULL),('1341549084443410433','1301823981006909441','1341549084443410433',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:01',NULL,NULL,NULL,'2020-12-23 09:00:01',NULL,NULL,NULL),('1341549084707651586','1315551775847133185','1341549084707651586',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 09:00:01',NULL,NULL,NULL,'2020-12-23 09:00:01',NULL,NULL,NULL),('1341566241193590786','1341318122925195265','1341566241193590786',2,2,'泉州晋江国际机场股份有限公司','15980019030','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 10:08:11',NULL,NULL,NULL,'2020-12-23 10:08:11',NULL,NULL,NULL),('1341620800691634177',NULL,'1341620800691634177',2,1,NULL,'13625978296','186539','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-23 13:44:59',NULL,NULL,NULL,'2020-12-23 13:44:59',NULL,NULL,NULL),('1341624465200513026',NULL,'1341624465200513026',2,1,NULL,'13600739571','505873','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-23 13:59:33',NULL,NULL,NULL,'2020-12-23 13:59:33',NULL,NULL,NULL),('1341624874719772673',NULL,'1341624874719772673',2,1,NULL,'19859573633','496923','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-23 14:01:10',NULL,NULL,NULL,'2020-12-23 14:01:10',NULL,NULL,NULL),('1341726621274513409','1341621257593946113','1341726621274513409',2,2,'海峡石化产品交易中心有限公司','13625978296','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-23 20:45:29',NULL,NULL,NULL,'2020-12-23 20:45:29',NULL,NULL,NULL),('1341904514302648322',NULL,'1341904514302648322',2,1,NULL,'13505952596','144679','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 08:32:22',NULL,NULL,NULL,'2020-12-24 08:32:22',NULL,NULL,NULL),('1341904852594237442',NULL,'1341904852594237442',2,1,NULL,'13505952596','878022','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 08:33:42',NULL,NULL,NULL,'2020-12-24 08:33:42',NULL,NULL,NULL),('1341905557459607553',NULL,'1341905557459607553',2,1,NULL,'13505952596','435156','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 08:36:30',NULL,NULL,NULL,'2020-12-24 08:36:30',NULL,NULL,NULL),('1341906212710555650',NULL,'1341906212710555650',2,1,NULL,'15880816775','118511','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 08:39:07',NULL,NULL,NULL,'2020-12-24 08:39:07',NULL,NULL,NULL),('1341925339592433665',NULL,'1341925339592433665',2,1,NULL,'15059155128','446439','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 09:55:07',NULL,NULL,NULL,'2020-12-24 09:55:07',NULL,NULL,NULL),('1341935342084710402','1341906391132053505','1341935342084710402',2,2,'晋江市华天市政工程有限公司','15880816775','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-24 10:34:52',NULL,NULL,NULL,'2020-12-24 10:34:52',NULL,NULL,NULL),('1341935511782055937','1341621257593946113','1341935511782055937',2,2,'海峡石化产品交易中心有限公司','13625978296','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-24 10:35:32',NULL,NULL,NULL,'2020-12-24 10:35:32',NULL,NULL,NULL),('1342002716196495362',NULL,'1342002716196495362',2,1,NULL,'15060999845','855026','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 15:02:35',NULL,NULL,NULL,'2020-12-24 15:02:35',NULL,NULL,NULL),('1342003608593391618',NULL,'1342003608593391618',2,1,NULL,'15060999845','470268','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 15:06:08',NULL,NULL,NULL,'2020-12-24 15:06:08',NULL,NULL,NULL),('1342017244959367170',NULL,'1342017244959367170',2,1,NULL,'18750935051','193116','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 16:00:19',NULL,NULL,NULL,'2020-12-24 16:00:19',NULL,NULL,NULL),('1342040375702872066',NULL,'1342040375702872066',2,1,NULL,'15280796970','120353','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 17:32:14',NULL,NULL,NULL,'2020-12-24 17:32:14',NULL,NULL,NULL),('1342089347221970946',NULL,'1342089347221970946',2,1,NULL,'13600739571','321590','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 20:46:49',NULL,NULL,NULL,'2020-12-24 20:46:49',NULL,NULL,NULL),('1342090802771288066',NULL,'1342090802771288066',2,1,NULL,'19859573633','817630','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-24 20:52:36',NULL,NULL,NULL,'2020-12-24 20:52:36',NULL,NULL,NULL),('1342319404439855105','1285493408407756802','1342319404439855105',2,2,'福建晋江热电有限公司','18659595539','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-25 12:00:59',NULL,NULL,NULL,'2020-12-25 12:00:59',NULL,NULL,NULL),('1342408523937505281',NULL,'1342408523937505281',2,1,NULL,'13799861247','533157','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-25 17:55:07',NULL,NULL,NULL,'2020-12-25 17:55:07',NULL,NULL,NULL),('1342409423703793665',NULL,'1342409423703793665',2,1,NULL,'13799861247','722681','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-25 17:58:42',NULL,NULL,NULL,'2020-12-25 17:58:42',NULL,NULL,NULL),('1342688880087818242',NULL,'1342688880087818242',2,1,NULL,'13959960923','811784','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-26 12:29:09',NULL,NULL,NULL,'2020-12-26 12:29:09',NULL,NULL,NULL),('1343380200179654658',NULL,'1343380200179654658',2,1,NULL,'13600739571','154653','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-28 10:16:13',NULL,NULL,NULL,'2020-12-28 10:16:13',NULL,NULL,NULL),('1343382396996706306',NULL,'1343382396996706306',2,1,NULL,'13600739571','258515','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-28 10:24:56',NULL,NULL,NULL,'2020-12-28 10:24:56',NULL,NULL,NULL),('1343812773787729922','1342689394980577282','1343812773787729922',2,2,'福建飞扬鞋材有限公司','13959960923','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2020-12-29 14:55:06',NULL,NULL,NULL,'2020-12-29 14:55:06',NULL,NULL,NULL),('1343925767192444929',NULL,'1343925767192444929',2,1,NULL,'18159990666','663374','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-29 22:24:06',NULL,NULL,NULL,'2020-12-29 22:24:06',NULL,NULL,NULL),('1344085794943401986','1211461407799820290','1344085794943401986',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795006316546','1278978156241391618','1344085795006316546',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795245391874','58','1344085795245391874',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795266363393','58','1344085795266363393',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795547381761','1211473406755651586','1344085795547381761',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795740319746','87','1344085795740319746',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795740319747','87','1344085795740319747',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795874537474','1211474926804975617','1344085795874537474',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085796017143810','97','1344085796017143810',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085796025532417','97','1344085796025532417',1,2,'吴思莹','12345674868','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085796101029889','1241252588561698817','1344085796101029889',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085796365271042','1295900371603947522','1344085796365271042',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344085796658872321','1296659016558051330','1344085796658872321',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-30 09:00:00',NULL,NULL,NULL,'2020-12-30 09:00:00',NULL,NULL,NULL),('1344086484566671362',NULL,'1344086484566671362',2,1,NULL,'13559360158','262442','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-30 09:02:44',NULL,NULL,NULL,'2020-12-30 09:02:44',NULL,NULL,NULL),('1344143741547446274',NULL,'1344143741547446274',2,1,NULL,'15059520255','850337','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-30 12:50:15',NULL,NULL,NULL,'2020-12-30 12:50:15',NULL,NULL,NULL),('1344146465437515777',NULL,'1344146465437515777',2,1,NULL,'15059520255','640356','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-30 13:01:05',NULL,NULL,NULL,'2020-12-30 13:01:05',NULL,NULL,NULL),('1344147066212843522',NULL,'1344147066212843522',2,1,NULL,'15059520255','238791','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-30 13:03:28',NULL,NULL,NULL,'2020-12-30 13:03:28',NULL,NULL,NULL),('1344200659037061121',NULL,'1344200659037061121',2,1,NULL,'15959537034','565257','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2020-12-30 16:36:25',NULL,NULL,NULL,'2020-12-30 16:36:25',NULL,NULL,NULL),('1344448182653812738','1278978156241391618','1344448182653812738',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182729310209','1211461407799820290','1344448182729310209',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182892888065','58','1344448182892888065',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182918053890','58','1344448182918053890',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183203266561','1211473406755651586','1344448183203266561',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183282958337','87','1344448183282958337',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183291346945','87','1344448183291346945',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183408787458','1211474926804975617','1344448183408787458',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183484284929','97','1344448183484284929',1,2,'吴思莹','12345674868','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183522033665','97','1344448183522033665',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183614308353','1241252588561698817','1344448183614308353',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448183857577985','1295900371603947522','1344448183857577985',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344448184033738754','1296659016558051330','1344448184033738754',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2020-12-31 09:00:00',NULL,NULL,NULL,'2020-12-31 09:00:00',NULL,NULL,NULL),('1344547024128704513','1212943836112818177','1344547024128704513',2,2,'晋江中纺标检测有限公司','85109953','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2020-12-31 15:32:45',NULL,NULL,NULL,'2020-12-31 15:32:45',NULL,NULL,NULL),('1344810570666213378','1211461407799820290','1344810570666213378',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570699767809','1278978156241391618','1344810570699767809',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570863345665','58','1344810570863345665',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570922065921','58','1344810570922065921',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810571215667202','1211473406755651586','1344810571215667202',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810571320524802','87','1344810571320524802',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810571408605185','87','1344810571408605185',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810571500879874','97','1344810571500879874',1,2,'吴思莹','12345674868','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810571534434306','1211474926804975617','1344810571534434306',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810571622514689','97','1344810571622514689',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810571807064065','1241252588561698817','1344810571807064065',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810572054528001','1295900371603947522','1344810572054528001',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1344810572260048897','1296659016558051330','1344810572260048897',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-01 09:00:00',NULL,NULL,NULL,'2021-01-01 09:00:00',NULL,NULL,NULL),('1345897734061686785','1278978156241391618','1345897734061686785',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734074269698','1211461407799820290','1345897734074269698',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734283984898','58','1345897734283984898',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734300762114','58','1345897734300762114',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734485311489','1211473406755651586','1345897734485311489',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734686638081','87','1345897734686638081',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734703415298','87','1345897734703415298',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734778912770','1211474926804975617','1345897734778912770',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734879576065','97','1345897734879576065',1,2,'吴思莹','12345674868','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734929907713','97','1345897734929907713',1,2,'吴思莹','12345674868','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897735001210881','1241252588561698817','1345897735001210881',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897735198343170','1295900371603947522','1345897735198343170',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345897735399669762','1296659016558051330','1345897735399669762',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-04 09:00:00',NULL,NULL,NULL,'2021-01-04 09:00:00',NULL,NULL,NULL),('1345974563808215041',NULL,'1345974563808215041',2,1,NULL,'15259759208','235785','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-04 14:05:17',NULL,NULL,NULL,'2021-01-04 14:05:17',NULL,NULL,NULL),('1346004972038258690',NULL,'1346004972038258690',2,1,NULL,'13799861247','613697','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-04 16:06:07',NULL,NULL,NULL,'2021-01-04 16:06:07',NULL,NULL,NULL),('1346260121973424129','1278978156241391618','1346260121973424129',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122040532994','1211461407799820290','1346260122040532994',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122279608322','58','1346260122279608322',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122279608323','58','1346260122279608323',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122480934914','1211473406755651586','1346260122480934914',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122661289985','87','1346260122661289985',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122699038722','87','1346260122699038722',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122711621634','1211474926804975617','1346260122711621634',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122883588097','97','1346260122883588097',1,2,'吴思莹','12345674868','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122980057090','1241252588561698817','1346260122980057090',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260123147829249','97','1346260123147829249',1,2,'吴思莹','12345674868','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260123202355202','1295900371603947522','1346260123202355202',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346260123403681794','1296659016558051330','1346260123403681794',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-05 09:00:00',NULL,NULL,NULL,'2021-01-05 09:00:00',NULL,NULL,NULL),('1346291060480933889',NULL,'1346291060480933889',2,1,NULL,'13599781816','161019','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-05 11:02:56',NULL,NULL,NULL,'2021-01-05 11:02:56',NULL,NULL,NULL),('1346297017302777858',NULL,'1346297017302777858',2,1,NULL,'13655953368','672562','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-05 11:26:36',NULL,NULL,NULL,'2021-01-05 11:26:36',NULL,NULL,NULL),('1346348644772610050',NULL,'1346348644772610050',2,1,NULL,'15880758339','790403','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-05 14:51:45',NULL,NULL,NULL,'2021-01-05 14:51:45',NULL,NULL,NULL),('1346362902382116866',NULL,'1346362902382116866',2,1,NULL,'18811724563','129207','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-05 15:48:24',NULL,NULL,NULL,'2021-01-05 15:48:24',NULL,NULL,NULL),('1346364008231337986',NULL,'1346364008231337986',2,1,NULL,'18160997720','573986','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-05 15:52:48',NULL,NULL,NULL,'2021-01-05 15:52:48',NULL,NULL,NULL),('1346367588493426689',NULL,'1346367588493426689',2,1,NULL,'17705068655','527285','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-05 16:07:02',NULL,NULL,NULL,'2021-01-05 16:07:02',NULL,NULL,NULL),('1346369503918817281','1346368733597138946','1346369503918817281',2,2,'中国农业银行股份有限公司晋江市支行','17705068655','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-05 16:14:38',NULL,NULL,NULL,'2021-01-05 16:14:38',NULL,NULL,NULL),('1346622509805469697','1211461407799820290','1346622509805469697',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622509830635521','1278978156241391618','1346622509830635521',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510031962113','58','1346622510031962113',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510111653890','72','1346622510111653890',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510203928578','1211473406755651586','1346622510203928578',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510417838082','1211474926804975617','1346622510417838082',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510417838083','87','1346622510417838083',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510480752641','58','1346622510480752641',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510640136193','1241252588561698817','1346622510640136193',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510656913409','87','1346622510656913409',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510858240001','97','1346622510858240001',1,2,'吴思莹','12345674868','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510875017217','97','1346622510875017217',1,2,'吴思莹','12345674868','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510904377346','1295900371603947522','1346622510904377346',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346622511097315330','1296659016558051330','1346622511097315330',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-06 09:00:00',NULL,NULL,NULL,'2021-01-06 09:00:00',NULL,NULL,NULL),('1346662267512422401',NULL,'1346662267512422401',2,1,NULL,'18019069830','930714','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-06 11:37:59',NULL,NULL,NULL,'2021-01-06 11:37:59',NULL,NULL,NULL),('1346984897847230466','1278978156241391618','1346984897847230466',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984897901756417','1211461407799820290','1346984897901756417',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898136637442','58','1346984898136637442',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898165997570','72','1346984898165997570',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898337964033','1211473406755651586','1346984898337964033',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898509930498','87','1346984898509930498',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898560262145','1211474926804975617','1346984898560262145',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898560262146','58','1346984898560262146',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898786754562','1241252588561698817','1346984898786754562',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898950332417','97','1346984898950332417',1,2,'吴思莹','12345674868','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984899004858370','1295900371603947522','1346984899004858370',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984899025829890','87','1346984899025829890',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984899214573570','1296659016558051330','1346984899214573570',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1346984899214573571','97','1346984899214573571',1,2,'吴思莹','12345674868','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL,'2021-01-07 09:00:00',NULL,NULL,NULL),('1347004756299612162',NULL,'1347004756299612162',2,1,NULL,'15059528852','071333','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-07 10:18:54',NULL,NULL,NULL,'2021-01-07 10:18:54',NULL,NULL,NULL),('1347011404695076865','1347004886855712769','1347011404695076865',2,2,'福建广电网络集团股份有限公司晋江分公司','15059528852','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 10:45:19',NULL,NULL,NULL,'2021-01-07 10:45:19',NULL,NULL,NULL),('1347011505656168450','1346291413003796482','1347011505656168450',2,2,'华福证券有限责任公司晋江崇德路证券营业部','13599781816','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-07 10:45:43',NULL,NULL,NULL,'2021-01-07 10:45:43',NULL,NULL,NULL),('1347076885070217217',NULL,'1347076885070217217',2,1,NULL,'15060042924','504762','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-07 15:05:31',NULL,NULL,NULL,'2021-01-07 15:05:31',NULL,NULL,NULL),('1347097799124058114','1347004886855712769','1347097799124058114',2,2,'福建广电网络集团股份有限公司晋江分公司','15059528852','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-07 16:28:37',NULL,NULL,NULL,'2021-01-07 16:28:37',NULL,NULL,NULL),('1347098107191492609','1346291413003796482','1347098107191492609',2,2,'华福证券有限责任公司晋江崇德路证券营业部','13599781816','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-07 16:29:51',NULL,NULL,NULL,'2021-01-07 16:29:51',NULL,NULL,NULL),('1347347285536669697','1278978156241391618','1347347285536669697',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285675081730','1211461407799820290','1347347285675081730',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285712830467','58','1347347285712830467',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285729607682','58','1347347285729607682',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285956100097','1211473406755651586','1347347285956100097',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286086123522','87','1347347286086123522',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286119677954','87','1347347286119677954',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286128066562','1211474926804975617','1347347286128066562',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286291644418','97','1347347286291644418',1,2,'吴思莹','12345674868','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286346170369','1241252588561698817','1347347286346170369',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286526525441','1295900371603947522','1347347286526525441',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286606217217','97','1347347286606217217',1,2,'吴思莹','12345674868','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347347286719463425','1296659016558051330','1347347286719463425',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 09:00:00',NULL,NULL,NULL,'2021-01-08 09:00:00',NULL,NULL,NULL),('1347369810446516225',NULL,'1347369810446516225',2,1,NULL,'13960455132','281517','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-08 10:29:30',NULL,NULL,NULL,'2021-01-08 10:29:30',NULL,NULL,NULL),('1347375774520311809',NULL,'1347375774520311809',2,1,NULL,'19905056352','165519','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-08 10:53:12',NULL,NULL,NULL,'2021-01-08 10:53:12',NULL,NULL,NULL),('1347375932939173890','1341318122925195265','1347375932939173890',2,2,'泉州晋江国际机场股份有限公司','15980019030','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 10:53:50',NULL,NULL,NULL,'2021-01-08 10:53:50',NULL,NULL,NULL),('1347378594065678338','1342004211197435905','1347378594065678338',2,2,'福建省晋江市盛华纸品有限公司','15060999845','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-08 11:04:24',NULL,NULL,NULL,'2021-01-08 11:04:24',NULL,NULL,NULL),('1347378825079554050','1342409065560563714','1347378825079554050',2,2,'福建省东舟工程管理有限公司','13799861247','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-08 11:05:19',NULL,NULL,NULL,'2021-01-08 11:05:19',NULL,NULL,NULL),('1347379488094158850','1343382484661854210','1347379488094158850',2,2,'泉州市美吉汽车服务有限公司','13600739571','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-08 11:07:57',NULL,NULL,NULL,'2021-01-08 11:07:57',NULL,NULL,NULL),('1347379839329370113','1345975175715225602','1347379839329370113',2,2,'泉州凯迪知识产权代理事务所(普通合伙)','15259759208','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-08 11:09:21',NULL,NULL,NULL,'2021-01-08 11:09:21',NULL,NULL,NULL),('1347380156209037313','1347077169901207553','1347380156209037313',2,2,'晋江市动物卫生监督所','15060042924','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-08 11:10:37',NULL,NULL,NULL,'2021-01-08 11:10:37',NULL,NULL,NULL),('1347380279056007169',NULL,'1347380279056007169',2,1,NULL,'13960455132','572000','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-08 11:11:06',NULL,NULL,NULL,'2021-01-08 11:11:06',NULL,NULL,NULL),('1347385129139437570',NULL,'1347385129139437570',2,1,NULL,'15260225737','300535','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-08 11:30:22',NULL,NULL,NULL,'2021-01-08 11:30:22',NULL,NULL,NULL),('1347385426624643073',NULL,'1347385426624643073',2,1,NULL,'15260225737','452356','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-08 11:31:33',NULL,NULL,NULL,'2021-01-08 11:31:33',NULL,NULL,NULL),('1347392492785369090',NULL,'1347392492785369090',2,1,NULL,'15260225737','658752','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-08 11:59:38',NULL,NULL,NULL,'2021-01-08 11:59:38',NULL,NULL,NULL),('1348434449229938690','1278978156241391618','1348434449229938690',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449238327298','1211461407799820290','1348434449238327298',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449401905154','58','1348434449401905154',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449401905155','58','1348434449401905155',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449762615297','87','1348434449762615297',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449762615298','1211473406755651586','1348434449762615298',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449783586818','87','1348434449783586818',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434450001690626','1211474926804975617','1348434450001690626',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434450219794433','1241252588561698817','1348434450219794433',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434450467258370','1295900371603947522','1348434450467258370',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348434450723110914','1296659016558051330','1348434450723110914',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-11 09:00:00',NULL,NULL,NULL,'2021-01-11 09:00:00',NULL,NULL,NULL),('1348647529599729666',NULL,'1348647529599729666',2,1,NULL,'13906995965','020148','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-11 23:06:42',NULL,NULL,NULL,'2021-01-11 23:06:42',NULL,NULL,NULL),('1348796837028429826','1278978156241391618','1348796837028429826',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837032624129','1211461407799820290','1348796837032624129',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837116510209','58','1348796837116510209',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837133287426','58','1348796837133287426',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837447860225','1211473406755651586','1348796837447860225',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837519163394','87','1348796837519163394',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837556912130','87','1348796837556912130',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837686935554','1211474926804975617','1348796837686935554',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837892456450','1241252588561698817','1348796837892456450',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796838148308993','1295900371603947522','1348796838148308993',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796838358024193','1296659016558051330','1348796838358024193',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348796838651625474','1346368733597138946','1348796838651625474',2,2,'中国农业银行股份有限公司晋江市支行','17705068655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 09:00:00',NULL,NULL,NULL,'2021-01-12 09:00:00',NULL,NULL,NULL),('1348813388553125889','1348647915035295745','1348813388553125889',2,2,'晋江市东石镇伟翔综合农场','13906995965','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-12 10:05:46',NULL,NULL,NULL,'2021-01-12 10:05:46',NULL,NULL,NULL),('1348889889696907265',NULL,'1348889889696907265',2,1,NULL,'15605917025','592288','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-12 15:09:45',NULL,NULL,NULL,'2021-01-12 15:09:45',NULL,NULL,NULL),('1348910954808606721',NULL,'1348910954808606721',2,1,NULL,'13313885858','062681','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-12 16:33:27',NULL,NULL,NULL,'2021-01-12 16:33:27',NULL,NULL,NULL),('1348913901634322434',NULL,'1348913901634322434',2,1,NULL,'13313885858','319200','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-12 16:45:10',NULL,NULL,NULL,'2021-01-12 16:45:10',NULL,NULL,NULL),('1348923909054922754',NULL,'1348923909054922754',2,1,NULL,'13459503551','092565','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-12 17:24:56',NULL,NULL,NULL,'2021-01-12 17:24:56',NULL,NULL,NULL),('1348965335478304770',NULL,'1348965335478304770',2,1,NULL,'18559273254','454505','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-12 20:09:33',NULL,NULL,NULL,'2021-01-12 20:09:33',NULL,NULL,NULL),('1349156219712962562','1348647915035295745','1349156219712962562',2,2,'晋江市东石镇伟翔综合农场','13906995965','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 08:48:03',NULL,NULL,NULL,'2021-01-13 08:48:03',NULL,NULL,NULL),('1349157708380504066','1348924009986654209','1349157708380504066',2,2,'福建力利实业有限公司','13459503551','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-13 08:53:58',NULL,NULL,NULL,'2021-01-13 08:53:58',NULL,NULL,NULL),('1349159224881446913','1211117113914273793','1349159224881446913',2,2,'福建柒牌时装科技股份有限公司','15880936557','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159224961138689','1278978156241391618','1349159224961138689',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225019858946','58','1349159225019858946',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225065996289','72','1349159225065996289',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225372180482','1211461407799820290','1349159225372180482',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225456066561','58','1349159225456066561',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225460260866','87','1349159225460260866',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225632227330','1211473406755651586','1349159225632227330',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225825165314','1211474926804975617','1349159225825165314',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225896468481','87','1349159225896468481',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159226005520385','1211515979058692097','1349159226005520385',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159226236207106','1241252588561698817','1349159226236207106',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159226420756482','1290219135275487234','1349159226420756482',2,2,'泉州银行股份有限公司晋江支行','15260853516','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159226609500161','1295900371603947522','1349159226609500161',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159226798243841','1296659016558051330','1349159226798243841',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159226995376130','1346291413003796482','1349159226995376130',2,2,'华福证券有限责任公司晋江崇德路证券营业部','13599781816','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159227175731202','1346368733597138946','1349159227175731202',2,2,'中国农业银行股份有限公司晋江市支行','17705068655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349159227406417922','1347077169901207553','1349159227406417922',2,2,'晋江市动物卫生监督所','15060042924','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:00:00',NULL,NULL,NULL,'2021-01-13 09:00:00',NULL,NULL,NULL),('1349160246207053826','1348913989639208962','1349160246207053826',2,2,'晋江市坤源水利工程有限公司','13313885858','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-13 09:04:03',NULL,NULL,NULL,'2021-01-13 09:04:03',NULL,NULL,NULL),('1349162200681414658','1341318122925195265','1349162200681414658',2,2,'泉州晋江国际机场股份有限公司','15980019030','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-13 09:11:49',NULL,NULL,NULL,'2021-01-13 09:11:49',NULL,NULL,NULL),('1349193971066208258','1348647915035295745','1349193971066208258',2,2,'晋江市东石镇伟翔综合农场','13906995965','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-13 11:18:04',NULL,NULL,NULL,'2021-01-13 11:18:04',NULL,NULL,NULL),('1349246398956044289',NULL,'1349246398956044289',2,1,NULL,'13600739571','361727','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-13 14:46:23',NULL,NULL,NULL,'2021-01-13 14:46:23',NULL,NULL,NULL),('1349253108135362562',NULL,'1349253108135362562',2,1,NULL,'15606088075','176910','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-13 15:13:03',NULL,NULL,NULL,'2021-01-13 15:13:03',NULL,NULL,NULL),('1349255334492897282','1290850604855361537','1349255334492897282',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-13 15:21:54',NULL,NULL,NULL,'2021-01-13 15:21:54',NULL,NULL,NULL),('1349274045077520386','1212540446794911745','1349274045077520386',2,2,'晋江七匹狼服装制造有限公司','13489768628','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-13 16:36:15',NULL,NULL,NULL,'2021-01-13 16:36:15',NULL,NULL,NULL),('1349279892407058433',NULL,'1349279892407058433',2,1,NULL,'13505044247','010248','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-13 16:59:29',NULL,NULL,NULL,'2021-01-13 16:59:29',NULL,NULL,NULL),('1349521612759629826','1211461407799820290','1349521612759629826',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521612797378561','1278978156241391618','1349521612797378561',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521612981927938','58','1349521612981927938',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521612990316545','58','1349521612990316545',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521613275529217','1211467536848175106','1349521613275529217',2,2,'泉州市德玛特电机制造有限公司','15805969239','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521613371998210','87','1349521613371998210',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521613447495682','87','1349521613447495682',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521613493633026','1211473406755651586','1349521613493633026',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521613699153922','1211474926804975617','1349521613699153922',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521613908869121','1211515979058692097','1349521613908869121',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521614118584322','1211837849989595138','1349521614118584322',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521614403796994','1212922386479910913','1349521614403796994',2,2,'中桥文化传媒(福建)股份有限公司','18558692200','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521614617706498','1217348495564886017','1349521614617706498',2,2,'晋江劲霸男装有限公司','13505959911','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521614814838786','1219509525804007426','1349521614814838786',2,2,'泉州晋宝汽车销售服务有限公司','18160997720','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521615016165378','1241252588561698817','1349521615016165378',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521615200714753','1295900371603947522','1349521615200714753',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521615397847042','1296659016558051330','1349521615397847042',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521615603367937','1342689394980577282','1349521615603367937',2,2,'福建飞扬鞋材有限公司','13959960923','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521615825666049','1346368733597138946','1349521615825666049',2,2,'中国农业银行股份有限公司晋江市支行','17705068655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349521616035381250','1348924009986654209','1349521616035381250',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-14 09:00:00',NULL,NULL,NULL,'2021-01-14 09:00:00',NULL,NULL,NULL),('1349535366004080642','1211117113914273793','1349535366004080642',2,2,'福建柒牌时装科技股份有限公司','13163991887','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-14 09:54:39',NULL,NULL,NULL,'2021-01-14 09:54:39',NULL,NULL,NULL),('1349884000809779201','1211461407799820290','1349884000809779201',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884000826556418','1278978156241391618','1349884000826556418',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884000927219713','58','1349884000927219713',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884000935608322','58','1349884000935608322',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884001191460865','1211473406755651586','1349884001191460865',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884001292124162','87','1349884001292124162',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884001308901377','87','1349884001308901377',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884001384398850','1211474926804975617','1349884001384398850',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884001577336834','1211515979058692097','1349884001577336834',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884001791246337','1211572731150123009','1349884001791246337',2,2,'三六一度(福建)体育用品有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884001988378625','1211574035113099265','1349884001988378625',2,2,'三六一度(中国)有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884002219065345','1211837849989595138','1349884002219065345',2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884002399420417','1212580494957416450','1349884002399420417',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884002617524226','1212922386479910913','1349884002617524226',2,2,'中桥文化传媒(福建)股份有限公司','18558692200','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884002844016642','1215439821749665794','1349884002844016642',2,2,'泉州福盈汽车销售服务有限公司','15559133531','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884003049537538','1219509525804007426','1349884003049537538',2,2,'泉州晋宝汽车销售服务有限公司','18160997720','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884003255058433','1241252588561698817','1349884003255058433',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884003464773634','1288637929832366081','1349884003464773634',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884003674488833','1288646739615596545','1349884003674488833',2,2,'泉州三众工程管理有限公司','15375817617','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884003859038210','1295900371603947522','1349884003859038210',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884004064559105','1296659016558051330','1349884004064559105',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884004261691393','1325350691455225857','1349884004261691393',2,2,'福建省永舜化工科技有限公司','18050878002','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1349884004446240769','1348924009986654209','1349884004446240769',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-15 09:00:00',NULL,NULL,NULL,'2021-01-15 09:00:00',NULL,NULL,NULL),('1350085414408421378',NULL,'1350085414408421378',2,1,NULL,'15859750999','840248','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-15 22:20:20',NULL,NULL,NULL,'2021-01-15 22:20:20',NULL,NULL,NULL),('1350269086377967617',NULL,'1350269086377967617',2,1,NULL,'18695659900','489451','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-16 10:30:11',NULL,NULL,NULL,'2021-01-16 10:30:11',NULL,NULL,NULL),('1350970490134462466','1341318122925195265','1350970490134462466',2,2,'泉州晋江国际机场股份有限公司','15980019030','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 08:57:19',NULL,NULL,NULL,'2021-01-18 08:57:19',NULL,NULL,NULL),('1350971164180086785','1278978156241391618','1350971164180086785',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164209446914','1211461407799820290','1350971164209446914',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164410773505','58','1350971164410773505',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164419162113','58','1350971164419162113',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164599517186','1211473406755651586','1350971164599517186',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164800843777','87','1350971164800843777',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164800843778','1211474926804975617','1350971164800843778',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164813426689','87','1350971164813426689',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971165018947585','102','1350971165018947585',1,2,'颜思思','15059886866','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971165027336194','102','1350971165027336194',1,2,'颜思思','15059886866','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971165048307713','1211515979058692097','1350971165048307713',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971165245440001','1211572731150123009','1350971165245440001',2,2,'三六一度(福建)体育用品有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971165442572289','1211574035113099265','1350971165442572289',2,2,'三六一度(中国)有限公司','13657918010','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971165648093185','1211837849989595138','1350971165648093185',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971165849419778','1212540446794911745','1350971165849419778',2,2,'晋江七匹狼服装制造有限公司','13489768628','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971166038163458','1212580494957416450','1350971166038163458',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971166235295745','1212922386479910913','1350971166235295745',2,2,'中桥文化传媒(福建)股份有限公司','18558692200','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971166474371073','1215439821749665794','1350971166474371073',2,2,'泉州福盈汽车销售服务有限公司','15559133531','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971166663114754','1219509525804007426','1350971166663114754',2,2,'泉州晋宝汽车销售服务有限公司','18160997720','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971166860247042','1241252588561698817','1350971166860247042',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971167032213505','1288637929832366081','1350971167032213505',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971167208374274','1290850604855361537','1350971167208374274',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971167405506562','1295900371603947522','1350971167405506562',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971167577473026','1296659016558051330','1350971167577473026',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971167749439490','1303977759655100418','1350971167749439490',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350971167938183170','1325350691455225857','1350971167938183170',2,2,'福建省永舜化工科技有限公司','18050878002','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-18 09:00:00',NULL,NULL,NULL,'2021-01-18 09:00:00',NULL,NULL,NULL),('1350987458363260929','1341318122925195265','1350987458363260929',2,2,'泉州晋江国际机场股份有限公司','15980019030','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-18 10:04:44',NULL,NULL,NULL,'2021-01-18 10:04:44',NULL,NULL,NULL),('1351077699359080450',NULL,'1351077699359080450',2,1,NULL,'18305984125','237926','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-18 16:03:19',NULL,NULL,NULL,'2021-01-18 16:03:19',NULL,NULL,NULL),('1351078917686951937',NULL,'1351078917686951937',2,1,NULL,'18305984125','099401','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-18 16:08:10',NULL,NULL,NULL,'2021-01-18 16:08:10',NULL,NULL,NULL),('1351088572085567490','1351079067511685122','1351088572085567490',2,2,'宁波杰普供应链管理有限公司晋江分公司','18305984125','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-18 16:46:32',NULL,NULL,NULL,'2021-01-18 16:46:32',NULL,NULL,NULL),('1351333552196681729','1278978156241391618','1351333552196681729',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552196681730','1211461407799820290','1351333552196681730',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552418979842','58','1351333552418979842',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552456728578','58','1351333552456728578',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552628695042','1211473406755651586','1351333552628695042',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552809050113','1211474926804975617','1351333552809050113',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552834215937','87','1351333552834215937',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552838410242','87','1351333552838410242',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333553052319746','1211515979058692097','1351333553052319746',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333553064902657','102','1351333553064902657',1,2,'颜思思','15059886866','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333553064902658','102','1351333553064902658',1,2,'颜思思','15059886866','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333553375281153','1211572731150123009','1351333553375281153',2,2,'三六一度(福建)体育用品有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333553643716610','1211574035113099265','1351333553643716610',2,2,'三六一度(中国)有限公司','13657918010','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333553840848898','1211837849989595138','1351333553840848898',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333554046369794','1211914077576675329','1351333554046369794',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333554272862209','1212540446794911745','1351333554272862209',2,2,'晋江七匹狼服装制造有限公司','13489768628','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333554499354626','1212922386479910913','1351333554499354626',2,2,'中桥文化传媒(福建)股份有限公司','18558692200','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333554717458434','1215439821749665794','1351333554717458434',2,2,'泉州福盈汽车销售服务有限公司','15559133531','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333554943950850','1218794464953360385','1351333554943950850',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333555166248962','1219509525804007426','1351333555166248962',2,2,'泉州晋宝汽车销售服务有限公司','18160997720','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333555363381249','1241252588561698817','1351333555363381249',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333555589873665','1288637929832366081','1351333555589873665',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333555841531906','1290850604855361537','1351333555841531906',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333556080607233','1295900371603947522','1351333556080607233',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:00',NULL,NULL,NULL,'2021-01-19 09:00:00',NULL,NULL,NULL),('1351333556277739521','1296659016558051330','1351333556277739521',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:01',NULL,NULL,NULL,'2021-01-19 09:00:01',NULL,NULL,NULL),('1351333556479066114','1303977759655100418','1351333556479066114',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:01',NULL,NULL,NULL,'2021-01-19 09:00:01',NULL,NULL,NULL),('1351333556709752834','1325350691455225857','1351333556709752834',2,2,'福建省永舜化工科技有限公司','18050878002','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:01',NULL,NULL,NULL,'2021-01-19 09:00:01',NULL,NULL,NULL),('1351333556936245250','1348913989639208962','1351333556936245250',2,2,'晋江市坤源水利工程有限公司','13313885858','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-19 09:00:01',NULL,NULL,NULL,'2021-01-19 09:00:01',NULL,NULL,NULL),('1351338461554016257',NULL,'1351338461554016257',2,1,NULL,'15394409169','730543','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-19 09:19:30',NULL,NULL,NULL,'2021-01-19 09:19:30',NULL,NULL,NULL),('1351695939902898178','1278978156241391618','1351695939902898178',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695939982589954','1211117113914273793','1351695939982589954',2,2,'福建柒牌时装科技股份有限公司','13163991887','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940251025410','58','1351695940251025410',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940297162753','83','1351695940297162753',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940309745665','58','1351695940309745665',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940435574786','1211461407799820290','1351695940435574786',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940653678593','87','1351695940653678593',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940657872898','1211467536848175106','1351695940657872898',2,2,'泉州市德玛特电机制造有限公司','15805969239','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940691427330','87','1351695940691427330',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940867588098','102','1351695940867588098',1,2,'颜思思','15059886866','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940880171009','1211473406755651586','1351695940880171009',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695941073108994','1211474926804975617','1351695941073108994',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695941190549505','102','1351695941190549505',1,2,'颜思思','15059886866','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695941261852674','1211515979058692097','1351695941261852674',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695941454790658','1211572731150123009','1351695941454790658',2,2,'三六一度(福建)体育用品有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695941660311554','1211837849989595138','1351695941660311554',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695941865832449','1211914077576675329','1351695941865832449',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695942067159042','1212540446794911745','1351695942067159042',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695942285262850','1212580494957416450','1351695942285262850',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695942465617922','1212922386479910913','1351695942465617922',2,2,'中桥文化传媒(福建)股份有限公司','18558692200','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695942671138817','1215439821749665794','1351695942671138817',2,2,'泉州福盈汽车销售服务有限公司','15559133531','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695942918602753','1218794464953360385','1351695942918602753',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695943119929345','1219241646047223809','1351695943119929345',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695943296090114','1219509525804007426','1351695943296090114',2,2,'泉州晋宝汽车销售服务有限公司','18160997720','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695943484833793','1241252588561698817','1351695943484833793',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695943681966082','1288637929832366081','1351695943681966082',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695943916847106','1290219135275487234','1351695943916847106',2,2,'泉州银行股份有限公司晋江支行','15260853516','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:00',NULL,NULL,NULL,'2021-01-20 09:00:00',NULL,NULL,NULL),('1351695944122368002','1295900371603947522','1351695944122368002',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351695944315305985','1296659016558051330','1351695944315305985',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351695944499855361','1303977759655100418','1351695944499855361',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351695944713764865','1325350691455225857','1351695944713764865',2,2,'福建省永舜化工科技有限公司','18050878002','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351695944902508545','1342689394980577282','1351695944902508545',2,2,'福建飞扬鞋材有限公司','13959960923','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351695945108029442','1347077169901207553','1351695945108029442',2,2,'晋江市动物卫生监督所','15060042924','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351695945342910465','1348913989639208962','1351695945342910465',2,2,'晋江市坤源水利工程有限公司','13313885858','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351695945531654145','1348924009986654209','1351695945531654145',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-20 09:00:01',NULL,NULL,NULL,'2021-01-20 09:00:01',NULL,NULL,NULL),('1351721691075575809',NULL,'1351721691075575809',2,1,NULL,'15106087765','617239','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-20 10:42:19',NULL,NULL,NULL,'2021-01-20 10:42:19',NULL,NULL,NULL),('1351830542235992065',NULL,'1351830542235992065',2,1,NULL,'18876290332','312492','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-20 17:54:51',NULL,NULL,NULL,'2021-01-20 17:54:51',NULL,NULL,NULL),('1351833072592486402','1351830895278948354','1351833072592486402',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-20 18:04:55',NULL,NULL,NULL,'2021-01-20 18:04:55',NULL,NULL,NULL),('1352058327722360834','1278978156241391618','1352058327722360834',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058327768498178','1211461407799820290','1352058327768498178',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328007573505','58','1352058328007573505',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328020156417','83','1352058328020156417',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328020156418','58','1352058328020156418',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328317952002','1211473406755651586','1352058328317952002',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328464752642','87','1352058328464752642',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328477335554','87','1352058328477335554',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328598970369','1211474926804975617','1352058328598970369',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328699633665','102','1352058328699633665',1,2,'颜思思','15059886866','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328716410881','102','1352058328716410881',1,2,'颜思思','15059886866','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058328838045697','1211515979058692097','1352058328838045697',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058329072926721','1211574035113099265','1352058329072926721',2,2,'三六一度(中国)有限公司','13657918010','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058329295224834','1211837849989595138','1352058329295224834',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058329496551426','1211914077576675329','1352058329496551426',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058329693683713','1215439821749665794','1352058329693683713',2,2,'泉州福盈汽车销售服务有限公司','15559133531','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058329903398914','1218794464953360385','1352058329903398914',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058330150862850','1219241646047223809','1352058330150862850',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058330377355265','1241252588561698817','1352058330377355265',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058330582876161','1288637929832366081','1352058330582876161',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058330817757185','1290219135275487234','1352058330817757185',2,2,'泉州银行股份有限公司晋江支行','15260853516','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058331052638209','1290850604855361537','1352058331052638209',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058331253964801','1295900371603947522','1352058331253964801',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058331564343297','1296659016558051330','1352058331564343297',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:00',NULL,NULL,NULL,'2021-01-21 09:00:00',NULL,NULL,NULL),('1352058331870527489','1303977759655100418','1352058331870527489',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:01',NULL,NULL,NULL,'2021-01-21 09:00:01',NULL,NULL,NULL),('1352058332080242690','1346291413003796482','1352058332080242690',2,2,'华福证券有限责任公司晋江崇德路证券营业部','13599781816','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:01',NULL,NULL,NULL,'2021-01-21 09:00:01',NULL,NULL,NULL),('1352058332294152193','1348924009986654209','1352058332294152193',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-21 09:00:01',NULL,NULL,NULL,'2021-01-21 09:00:01',NULL,NULL,NULL),('1352165350812155905','1343382484661854210','1352165350812155905',2,2,'泉州市美吉汽车服务有限公司','13600739571','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-21 16:05:16',NULL,NULL,NULL,'2021-01-21 16:05:16',NULL,NULL,NULL),('1352420715646681089','1211454669394591746','1352420715646681089',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715772510210','1278978156241391618','1352420715772510210',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715852201987','83','1352420715852201987',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715860590594','58','1352420715860590594',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715877367809','58','1352420715877367809',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716078694402','1211461407799820290','1352420716078694402',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716225495041','87','1352420716225495041',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716233883649','87','1352420716233883649',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716271632385','1211473406755651586','1352420716271632385',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716410044418','102','1352420716410044418',1,2,'颜思思','15059886866','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716477153281','102','1352420716477153281',1,2,'颜思思','15059886866','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716502319105','1211474926804975617','1352420716502319105',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716753977346','1211914077576675329','1352420716753977346',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420716951109634','1219241646047223809','1352420716951109634',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420717173407746','1241252588561698817','1352420717173407746',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420717404094465','1288637929832366081','1352420717404094465',2,2,'福建省晋江文旅集团有限公司','13506075567','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420717626392578','1290850604855361537','1352420717626392578',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420717869662210','1295900371603947522','1352420717869662210',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420718096154625','1296659016558051330','1352420718096154625',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420718347812866','1303977759655100418','1352420718347812866',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1352420718578499585','1348924009986654209','1352420718578499585',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-22 09:00:00',NULL,NULL,NULL,'2021-01-22 09:00:00',NULL,NULL,NULL),('1353144862244864002',NULL,'1353144862244864002',2,1,NULL,'15260876759','549570','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-24 08:57:30',NULL,NULL,NULL,'2021-01-24 08:57:30',NULL,NULL,NULL),('1353145682227101698',NULL,'1353145682227101698',2,1,NULL,'15260876759','679830','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-24 09:00:45',NULL,NULL,NULL,'2021-01-24 09:00:45',NULL,NULL,NULL),('1353507879230898177','1278978156241391618','1353507879230898177',2,2,'晋江新丝路教育科技有限公司','15080005305','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879335755777','1211461407799820290','1353507879335755777',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879411253251','58','1353507879411253251',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879428030465','83','1353507879428030465',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879440613377','58','1353507879440613377',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879654522882','1211467536848175106','1353507879654522882',2,2,'泉州市德玛特电机制造有限公司','15805969239','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879792934914','87','1353507879792934914',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879818100737','87','1353507879818100737',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879860043777','1211473406755651586','1353507879860043777',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879964901377','102','1353507879964901377',1,2,'颜思思','15059886866','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507880069758978','1211474926804975617','1353507880069758978',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507880254308354','102','1353507880254308354',1,2,'颜思思','15059886866','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507880275279874','1219241646047223809','1353507880275279874',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507880472412161','1241252588561698817','1353507880472412161',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507880665350145','1290850604855361537','1353507880665350145',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507880866676738','1295900371603947522','1353507880866676738',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507881047031809','1296659016558051330','1353507881047031809',2,2,'江海证券有限公司晋江长兴路证券营业部','18065859939','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507881269329921','1303977759655100418','1353507881269329921',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353507881487433729','1348924009986654209','1353507881487433729',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-01-25 09:00:00',NULL,NULL,NULL,'2021-01-25 09:00:00',NULL,NULL,NULL),('1353548213822423042','1353145289086599170','1353548213822423042',2,2,'福建省壹鼎电子商务有限公司','15260876759','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-01-25 11:40:16',NULL,NULL,NULL,'2021-01-25 11:40:16',NULL,NULL,NULL),('1354241806644019201',NULL,'1354241806644019201',2,1,NULL,'15860351538','491376','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-27 09:36:21',NULL,NULL,NULL,'2021-01-27 09:36:21',NULL,NULL,NULL),('1355582505813540865',NULL,'1355582505813540865',2,1,NULL,'15880724878','854779','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-01-31 02:23:49',NULL,NULL,NULL,'2021-01-31 02:23:49',NULL,NULL,NULL),('1356057497860833282','1212198922987048961','1356057497860833282',2,2,'卡尔美体育用品有限公司','17759990690','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-01 09:51:16',NULL,NULL,NULL,'2021-02-01 09:51:16',NULL,NULL,NULL),('1356057761166655489','1212201267179360257','1356057761166655489',2,2,'泉州鑫通检测技术有限公司','13559591215','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-01 09:52:19',NULL,NULL,NULL,'2021-02-01 09:52:19',NULL,NULL,NULL),('1356057843999965186','1303955626757488641','1356057843999965186',2,2,'恒安(中国)纸业有限公司','13599106460','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-01 09:52:39',NULL,NULL,NULL,'2021-02-01 09:52:39',NULL,NULL,NULL),('1356058217628565506','1212253296765505538','1356058217628565506',2,2,'泉州寰球鞋服有限公司','18959708869','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-01 09:54:08',NULL,NULL,NULL,'2021-02-01 09:54:08',NULL,NULL,NULL),('1356058314378575873','1308693126923218945','1356058314378575873',2,2,'泉州市创标专利代理事务所(特殊普通合伙)','13358438305','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-01 09:54:31',NULL,NULL,NULL,'2021-02-01 09:54:31',NULL,NULL,NULL),('1356058385539137537','1214118511954120705','1356058385539137537',2,2,'泉州协创知识产权代理事务所(普通合伙)','18965727570','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-01 09:54:48',NULL,NULL,NULL,'2021-02-01 09:54:48',NULL,NULL,NULL),('1356058775257088002','1211150098789150721','1356058775257088002',2,2,'泉州永实工程质量检测有限公司','15759559009','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-01 09:56:21',NULL,NULL,NULL,'2021-02-01 09:56:21',NULL,NULL,NULL),('1356240107090214914',NULL,'1356240107090214914',2,1,NULL,'15396209380','357482','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-01 21:56:53',NULL,NULL,NULL,'2021-02-01 21:56:53',NULL,NULL,NULL),('1356467221164982273',NULL,'1356467221164982273',2,1,NULL,'13959852650','500349','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-02 12:59:22',NULL,NULL,NULL,'2021-02-02 12:59:22',NULL,NULL,NULL),('1356532458354376705',NULL,'1356532458354376705',2,1,NULL,'15860939778','542355','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-02 17:18:35',NULL,NULL,NULL,'2021-02-02 17:18:35',NULL,NULL,NULL),('1356602337963016194',NULL,'1356602337963016194',2,1,NULL,'15392027115','859024','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-02 21:56:16',NULL,NULL,NULL,'2021-02-02 21:56:16',NULL,NULL,NULL),('1356853481155067906',NULL,'1356853481155067906',2,1,NULL,'15559050207','796327','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-03 14:34:13',NULL,NULL,NULL,'2021-02-03 14:34:13',NULL,NULL,NULL),('1357603441622425602',NULL,'1357603441622425602',2,1,NULL,'13242884288','299631','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-05 16:14:18',NULL,NULL,NULL,'2021-02-05 16:14:18',NULL,NULL,NULL),('1357603693410689026',NULL,'1357603693410689026',2,1,NULL,'13055679900','520060','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-05 16:15:18',NULL,NULL,NULL,'2021-02-05 16:15:18',NULL,NULL,NULL),('1357903796964990978',NULL,'1357903796964990978',2,1,NULL,'15260896313','927182','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-06 12:07:48',NULL,NULL,NULL,'2021-02-06 12:07:48',NULL,NULL,NULL),('1357910048604463105',NULL,'1357910048604463105',2,1,NULL,'15960762288','124761','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-06 12:32:38',NULL,NULL,NULL,'2021-02-06 12:32:38',NULL,NULL,NULL),('1358344122615767041',NULL,'1358344122615767041',2,1,NULL,'15960551920','519600','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-07 17:17:30',NULL,NULL,NULL,'2021-02-07 17:17:30',NULL,NULL,NULL),('1358613743826673665','1357603793218347009','1358613743826673665',2,2,'泉州市丰裕泰企业管理有限公司','13055679900','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-08 11:08:53',NULL,NULL,NULL,'2021-02-08 11:08:53',NULL,NULL,NULL),('1358614144504340482','1357903938937987073','1358614144504340482',2,2,'福建亚特家具有限公司','15260896313','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-08 11:10:28',NULL,NULL,NULL,'2021-02-08 11:10:28',NULL,NULL,NULL),('1358668513731977217',NULL,'1358668513731977217',2,1,NULL,'18875256313','349464','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-08 14:46:31',NULL,NULL,NULL,'2021-02-08 14:46:31',NULL,NULL,NULL),('1358681698388189185',NULL,'1358681698388189185',2,1,NULL,'18875256313','825732','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-08 15:38:54',NULL,NULL,NULL,'2021-02-08 15:38:54',NULL,NULL,NULL),('1358695154394898434',NULL,'1358695154394898434',2,1,NULL,'18159223223','885393','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-08 16:32:22',NULL,NULL,NULL,'2021-02-08 16:32:22',NULL,NULL,NULL),('1358702852389773313',NULL,'1358702852389773313',2,1,NULL,'15960893711','673202','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-08 17:02:58',NULL,NULL,NULL,'2021-02-08 17:02:58',NULL,NULL,NULL),('1358799067072733185',NULL,'1358799067072733185',2,1,NULL,'18750651565','881569','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-08 23:25:17',NULL,NULL,NULL,'2021-02-08 23:25:17',NULL,NULL,NULL),('1358980615428415489','1358799868885245954','1358980615428415489',2,2,'晋江市鹏峰武术俱乐部','18750651565','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-09 11:26:42',NULL,NULL,NULL,'2021-02-09 11:26:42',NULL,NULL,NULL),('1359030020030373889',NULL,'1359030020030373889',2,1,NULL,'15859509738','020542','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-09 14:43:00',NULL,NULL,NULL,'2021-02-09 14:43:00',NULL,NULL,NULL),('1359033021080051713','1359031269891022850','1359033021080051713',2,2,'福建省晋江市公证处','15859509738','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-02-09 14:54:56',NULL,NULL,NULL,'2021-02-09 14:54:56',NULL,NULL,NULL),('1359036348031344641','1359031269891022850','1359036348031344641',2,2,'福建省晋江市公证处','15859509738','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-09 15:08:09',NULL,NULL,NULL,'2021-02-09 15:08:09',NULL,NULL,NULL),('1359099244128018434',NULL,'1359099244128018434',2,1,NULL,'15827632790','802774','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-09 19:18:05',NULL,NULL,NULL,'2021-02-09 19:18:05',NULL,NULL,NULL),('1359435160109490177',NULL,'1359435160109490177',2,1,NULL,'13905963392','083681','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-10 17:32:53',NULL,NULL,NULL,'2021-02-10 17:32:53',NULL,NULL,NULL),('1362583573193859074',NULL,'1362583573193859074',2,1,NULL,'15375817226','955102','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-19 10:03:34',NULL,NULL,NULL,'2021-02-19 10:03:34',NULL,NULL,NULL),('1362680006131621890',NULL,'1362680006131621890',2,1,NULL,'18558795679','460682','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-19 16:26:45',NULL,NULL,NULL,'2021-02-19 16:26:45',NULL,NULL,NULL),('1362751428275249154',NULL,'1362751428275249154',2,1,NULL,'19959953038','023648','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-19 21:10:33',NULL,NULL,NULL,'2021-02-19 21:10:33',NULL,NULL,NULL),('1363050523204296706',NULL,'1363050523204296706',2,1,NULL,'18959705077','370622','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-20 16:59:03',NULL,NULL,NULL,'2021-02-20 16:59:03',NULL,NULL,NULL),('1363309122795118593',NULL,'1363309122795118593',2,1,NULL,'15259741125','237394','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-21 10:06:38',NULL,NULL,NULL,'2021-02-21 10:06:38',NULL,NULL,NULL),('1363310863175426050',NULL,'1363310863175426050',2,1,NULL,'17359728802','110305','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-21 10:13:33',NULL,NULL,NULL,'2021-02-21 10:13:33',NULL,NULL,NULL),('1363368153639329793',NULL,'1363368153639329793',2,1,NULL,'13621272602','417752','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-21 14:01:12',NULL,NULL,NULL,'2021-02-21 14:01:12',NULL,NULL,NULL),('1363667351333019650','1363310937095839745','1363667351333019650',2,2,'晋江市池店镇星奥汇汽车维修服务部','17359728802','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-02-22 09:50:06',NULL,NULL,NULL,'2021-02-22 09:50:06',NULL,NULL,NULL),('1363667755156414465','1363310937095839745','1363667755156414465',2,2,'晋江市池店镇星奥汇汽车维修服务部','17359728802','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-22 09:51:43',NULL,NULL,NULL,'2021-02-22 09:51:43',NULL,NULL,NULL),('1364059015553785858','1211574035113099265','1364059015553785858',2,2,'三六一度(中国)有限公司','13600745760','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-23 11:46:26',NULL,NULL,NULL,'2021-02-23 11:46:26',NULL,NULL,NULL),('1364059051469611009','1211572731150123009','1364059051469611009',2,2,'三六一度(福建)体育用品有限公司','13600745760','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-23 11:46:35',NULL,NULL,NULL,'2021-02-23 11:46:35',NULL,NULL,NULL),('1364059134982397954','1314481312186277890','1364059134982397954',2,2,'福建逸锦化纤有限公司','19905065506','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-23 11:46:55',NULL,NULL,NULL,'2021-02-23 11:46:55',NULL,NULL,NULL),('1364062074359029761',NULL,'1364062074359029761',2,1,NULL,'18859998598','691595','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-23 11:58:36',NULL,NULL,NULL,'2021-02-23 11:58:36',NULL,NULL,NULL),('1364066979471728641',NULL,'1364066979471728641',2,1,NULL,'18859998598','236647','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-23 12:18:05',NULL,NULL,NULL,'2021-02-23 12:18:05',NULL,NULL,NULL),('1364115017225510913','1364063273527320578','1364115017225510913',2,2,'福建省辅城网络科技有限公司','18859998598','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-23 15:28:58',NULL,NULL,NULL,'2021-02-23 15:28:58',NULL,NULL,NULL),('1364116387949223937',NULL,'1364116387949223937',2,1,NULL,'19905065357','487763','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-23 15:34:25',NULL,NULL,NULL,'2021-02-23 15:34:25',NULL,NULL,NULL),('1364123888195248129','1364116774320119810','1364123888195248129',2,2,'福建晋江鞋纺城有限责任公司','19905065357','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-02-23 16:04:13',NULL,NULL,NULL,'2021-02-23 16:04:13',NULL,NULL,NULL),('1364860417435803649',NULL,'1364860417435803649',2,1,NULL,'13215958966','865109','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-25 16:50:56',NULL,NULL,NULL,'2021-02-25 16:50:56',NULL,NULL,NULL),('1364877942835945474','1364861648258506753','1364877942835945474',2,2,'晋江国家体育产业基地发展中心','13215958966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-02-25 18:00:34',NULL,NULL,NULL,'2021-02-25 18:00:34',NULL,NULL,NULL),('1364891647627796482',NULL,'1364891647627796482',2,1,NULL,'13055783311','136790','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-25 18:55:01',NULL,NULL,NULL,'2021-02-25 18:55:01',NULL,NULL,NULL),('1365132927062548481',NULL,'1365132927062548481',2,1,NULL,'18506966086','237807','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-26 10:53:47',NULL,NULL,NULL,'2021-02-26 10:53:47',NULL,NULL,NULL),('1365539586708643841',NULL,'1365539586708643841',2,1,NULL,'15985919427','518335','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-02-27 13:49:42',NULL,NULL,NULL,'2021-02-27 13:49:42',NULL,NULL,NULL),('1366314809640919041',NULL,'1366314809640919041',2,1,NULL,'15359609692','059874','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-01 17:10:10',NULL,NULL,NULL,'2021-03-01 17:10:10',NULL,NULL,NULL),('1366318375789174786','1366314965903908866','1366318375789174786',2,2,'晋江卡帝朗家居科技有限公司','15359609692','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-01 17:24:20',NULL,NULL,NULL,'2021-03-01 17:24:20',NULL,NULL,NULL),('1366655696304644098',NULL,'1366655696304644098',2,1,NULL,'18149562416','650338','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-02 15:44:43',NULL,NULL,NULL,'2021-03-02 15:44:43',NULL,NULL,NULL),('1366908141953916929',NULL,'1366908141953916929',2,1,NULL,'13178096917','599559','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 08:27:51',NULL,NULL,NULL,'2021-03-03 08:27:51',NULL,NULL,NULL),('1366925157859368961',NULL,'1366925157859368961',2,1,NULL,'16653129639','374796','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 09:35:28',NULL,NULL,NULL,'2021-03-03 09:35:28',NULL,NULL,NULL),('1366925574882238466',NULL,'1366925574882238466',2,1,NULL,'13772493136','954009','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 09:37:07',NULL,NULL,NULL,'2021-03-03 09:37:07',NULL,NULL,NULL),('1366926148566556673',NULL,'1366926148566556673',2,1,NULL,'13772493136','105021','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 09:39:24',NULL,NULL,NULL,'2021-03-03 09:39:24',NULL,NULL,NULL),('1366926595972964354',NULL,'1366926595972964354',2,1,NULL,'13772493136','135578','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 09:41:11',NULL,NULL,NULL,'2021-03-03 09:41:11',NULL,NULL,NULL),('1366943079403134977',NULL,'1366943079403134977',2,1,NULL,'18105071801','889202','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 10:46:41',NULL,NULL,NULL,'2021-03-03 10:46:41',NULL,NULL,NULL),('1366943758968463361',NULL,'1366943758968463361',2,1,NULL,'18659203084','280459','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 10:49:23',NULL,NULL,NULL,'2021-03-03 10:49:23',NULL,NULL,NULL),('1366952833005428738',NULL,'1366952833005428738',2,1,NULL,'13489293319','966805','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-03 11:25:26',NULL,NULL,NULL,'2021-03-03 11:25:26',NULL,NULL,NULL),('1367660833798135809',NULL,'1367660833798135809',2,1,NULL,'17798451269','601199','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-05 10:18:47',NULL,NULL,NULL,'2021-03-05 10:18:47',NULL,NULL,NULL),('1367797399052918785',NULL,'1367797399052918785',2,1,NULL,'13599796334','226359','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-05 19:21:27',NULL,NULL,NULL,'2021-03-05 19:21:27',NULL,NULL,NULL),('1367814147101728769',NULL,'1367814147101728769',2,1,NULL,'15827632790','557216','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-05 20:28:00',NULL,NULL,NULL,'2021-03-05 20:28:00',NULL,NULL,NULL),('1368156582373793794',NULL,'1368156582373793794',2,1,NULL,'17859736616','424173','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-06 19:08:43',NULL,NULL,NULL,'2021-03-06 19:08:43',NULL,NULL,NULL),('1368163037550256129',NULL,'1368163037550256129',2,1,NULL,'17859736616','322522','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-06 19:34:22',NULL,NULL,NULL,'2021-03-06 19:34:22',NULL,NULL,NULL),('1368748646245376002',NULL,'1368748646245376002',2,1,NULL,'18350533399','780319','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-08 10:21:22',NULL,NULL,NULL,'2021-03-08 10:21:22',NULL,NULL,NULL),('1368857055917547522','1366943804480856065','1368857055917547522',2,2,'晋江市陈埭镇芳惠农场','18659203084','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-08 17:32:08',NULL,NULL,NULL,'2021-03-08 17:32:08',NULL,NULL,NULL),('1369561025271078914',NULL,'1369561025271078914',2,1,NULL,'18378317763','601253','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-10 16:09:28',NULL,NULL,NULL,'2021-03-10 16:09:28',NULL,NULL,NULL),('1369936840743755778',NULL,'1369936840743755778',2,1,NULL,'13905966797','565953','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-11 17:02:49',NULL,NULL,NULL,'2021-03-11 17:02:49',NULL,NULL,NULL),('1369937174216089601',NULL,'1369937174216089601',2,1,NULL,'13905966797','120660','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-11 17:04:09',NULL,NULL,NULL,'2021-03-11 17:04:09',NULL,NULL,NULL),('1370566528008826882',NULL,'1370566528008826882',2,1,NULL,'13395955061','300018','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-13 10:44:58',NULL,NULL,NULL,'2021-03-13 10:44:58',NULL,NULL,NULL),('1371288597935796225',NULL,'1371288597935796225',2,1,NULL,'13506003779','423160','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-15 10:34:13',NULL,NULL,NULL,'2021-03-15 10:34:13',NULL,NULL,NULL),('1371351327178862593',NULL,'1371351327178862593',2,1,NULL,'18350533399','276662','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-15 14:43:29',NULL,NULL,NULL,'2021-03-15 14:43:29',NULL,NULL,NULL),('1371368604158767105',NULL,'1371368604158767105',2,1,NULL,'13788805513','096549','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-15 15:52:08',NULL,NULL,NULL,'2021-03-15 15:52:08',NULL,NULL,NULL),('1371369053742018562',NULL,'1371369053742018562',2,1,NULL,'13808555627','273658','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-15 15:53:55',NULL,NULL,NULL,'2021-03-15 15:53:55',NULL,NULL,NULL),('1371401031644196865',NULL,'1371401031644196865',2,1,NULL,'15906066156','819889','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-15 18:01:00',NULL,NULL,NULL,'2021-03-15 18:01:00',NULL,NULL,NULL),('1371617002233376770',NULL,'1371617002233376770',2,1,NULL,'13509365965','325505','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 08:19:11',NULL,NULL,NULL,'2021-03-16 08:19:11',NULL,NULL,NULL),('1371628929143648257',NULL,'1371628929143648257',2,1,NULL,'13559076739','420289','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 09:06:34',NULL,NULL,NULL,'2021-03-16 09:06:34',NULL,NULL,NULL),('1371630038419615746',NULL,'1371630038419615746',2,1,NULL,'13959775727','632744','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 09:10:59',NULL,NULL,NULL,'2021-03-16 09:10:59',NULL,NULL,NULL),('1371634127543054337',NULL,'1371634127543054337',2,1,NULL,'13107801090','794117','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 09:27:14',NULL,NULL,NULL,'2021-03-16 09:27:14',NULL,NULL,NULL),('1371639414576492546',NULL,'1371639414576492546',2,1,NULL,'15860939778','855425','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 09:48:14',NULL,NULL,NULL,'2021-03-16 09:48:14',NULL,NULL,NULL),('1371640869362446337','1371288651551584257','1371640869362446337',2,2,'泉州市爱优恩纺织品科技有限公司','13506003779','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-16 09:54:01',NULL,NULL,NULL,'2021-03-16 09:54:01',NULL,NULL,NULL),('1371647098948268034',NULL,'1371647098948268034',2,1,NULL,'18859530042','222607','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 10:18:47',NULL,NULL,NULL,'2021-03-16 10:18:47',NULL,NULL,NULL),('1371647350300323841',NULL,'1371647350300323841',2,1,NULL,'18859530042','285294','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 10:19:46',NULL,NULL,NULL,'2021-03-16 10:19:46',NULL,NULL,NULL),('1371647914195136514',NULL,'1371647914195136514',2,1,NULL,'18859530042','155921','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 10:22:01',NULL,NULL,NULL,'2021-03-16 10:22:01',NULL,NULL,NULL),('1371652353618456577',NULL,'1371652353618456577',2,1,NULL,'15159793788','712617','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 10:39:39',NULL,NULL,NULL,'2021-03-16 10:39:39',NULL,NULL,NULL),('1371652776148447233',NULL,'1371652776148447233',2,1,NULL,'13600709553','883570','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 10:41:20',NULL,NULL,NULL,'2021-03-16 10:41:20',NULL,NULL,NULL),('1371656580721913858',NULL,'1371656580721913858',2,1,NULL,'15959420909','889622','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 10:56:27',NULL,NULL,NULL,'2021-03-16 10:56:27',NULL,NULL,NULL),('1371660607778041857',NULL,'1371660607778041857',2,1,NULL,'15375882135','130894','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 11:12:27',NULL,NULL,NULL,'2021-03-16 11:12:27',NULL,NULL,NULL),('1371661662708412418',NULL,'1371661662708412418',2,1,NULL,'13615950806','415648','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 11:16:39',NULL,NULL,NULL,'2021-03-16 11:16:39',NULL,NULL,NULL),('1371662024622321666',NULL,'1371662024622321666',2,1,NULL,'13615950806','408150','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 11:18:05',NULL,NULL,NULL,'2021-03-16 11:18:05',NULL,NULL,NULL),('1371671333334790146',NULL,'1371671333334790146',2,1,NULL,'13205059567','698489','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 11:55:04',NULL,NULL,NULL,'2021-03-16 11:55:04',NULL,NULL,NULL),('1371706035542274050',NULL,'1371706035542274050',2,1,NULL,'18659905376','623775','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 14:12:58',NULL,NULL,NULL,'2021-03-16 14:12:58',NULL,NULL,NULL),('1371706290878918657',NULL,'1371706290878918657',2,1,NULL,'13328513681','414688','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 14:13:59',NULL,NULL,NULL,'2021-03-16 14:13:59',NULL,NULL,NULL),('1371715689307549698',NULL,'1371715689307549698',2,1,NULL,'15750998817','998502','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 14:51:20',NULL,NULL,NULL,'2021-03-16 14:51:20',NULL,NULL,NULL),('1371715942173749250',NULL,'1371715942173749250',2,1,NULL,'15173662302','755030','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 14:52:20',NULL,NULL,NULL,'2021-03-16 14:52:20',NULL,NULL,NULL),('1371716218779709441',NULL,'1371716218779709441',2,1,NULL,'15559010991','047424','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 14:53:26',NULL,NULL,NULL,'2021-03-16 14:53:26',NULL,NULL,NULL),('1371717138968064002','1211492544651771905','1371717138968064002',2,2,'福建省晋江凯燕新材料研究院有限公司','13255957226','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-16 14:57:05',NULL,NULL,NULL,'2021-03-16 14:57:05',NULL,NULL,NULL),('1371718005481910274',NULL,'1371718005481910274',2,1,NULL,'15750783120','386053','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 15:00:32',NULL,NULL,NULL,'2021-03-16 15:00:32',NULL,NULL,NULL),('1371718181479100417','1211454669394591746','1371718181479100417',2,2,'福建凤竹纺织科技股份有限公司','13506060342','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-16 15:01:14',NULL,NULL,NULL,'2021-03-16 15:01:14',NULL,NULL,NULL),('1371719145959305217','1212666561777700865','1371719145959305217',2,2,'锦兴(福建)化纤纺织实业有限公司','18750650129','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-16 15:05:04',NULL,NULL,NULL,'2021-03-16 15:05:04',NULL,NULL,NULL),('1371719487732166658','1212661969526525954','1371719487732166658',2,2,'福建正麒高纤科技股份有限公司','18750650129','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-16 15:06:25',NULL,NULL,NULL,'2021-03-16 15:06:25',NULL,NULL,NULL),('1371725597709021186',NULL,'1371725597709021186',2,1,NULL,'15960589393','412637','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 15:30:42',NULL,NULL,NULL,'2021-03-16 15:30:42',NULL,NULL,NULL),('1371731243447726082',NULL,'1371731243447726082',2,1,NULL,'18160997720','792609','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 15:53:08',NULL,NULL,NULL,'2021-03-16 15:53:08',NULL,NULL,NULL),('1371731805585125378',NULL,'1371731805585125378',2,1,NULL,'15959420909','222044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 15:55:22',NULL,NULL,NULL,'2021-03-16 15:55:22',NULL,NULL,NULL),('1371748148447391745',NULL,'1371748148447391745',2,1,NULL,'13599111348','663598','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 17:00:19',NULL,NULL,NULL,'2021-03-16 17:00:19',NULL,NULL,NULL),('1371756841255677953',NULL,'1371756841255677953',2,1,NULL,'13860748042','054039','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 17:34:51',NULL,NULL,NULL,'2021-03-16 17:34:51',NULL,NULL,NULL),('1371757213441437697',NULL,'1371757213441437697',2,1,NULL,'15985992783','321491','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 17:36:20',NULL,NULL,NULL,'2021-03-16 17:36:20',NULL,NULL,NULL),('1371758565861208066',NULL,'1371758565861208066',2,1,NULL,'13599703460','725139','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 17:41:42',NULL,NULL,NULL,'2021-03-16 17:41:42',NULL,NULL,NULL),('1371764563313274881',NULL,'1371764563313274881',2,1,NULL,'13489384995','755803','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 18:05:32',NULL,NULL,NULL,'2021-03-16 18:05:32',NULL,NULL,NULL),('1371822668130611202',NULL,'1371822668130611202',2,1,NULL,'15880161129','796429','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-16 21:56:25',NULL,NULL,NULL,'2021-03-16 21:56:25',NULL,NULL,NULL),('1371988268178010114',NULL,'1371988268178010114',2,1,NULL,'15750998817','096272','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 08:54:28',NULL,NULL,NULL,'2021-03-17 08:54:28',NULL,NULL,NULL),('1371991898436202498',NULL,'1371991898436202498',2,1,NULL,'15605953093','201686','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 09:08:53',NULL,NULL,NULL,'2021-03-17 09:08:53',NULL,NULL,NULL),('1371995413489446913',NULL,'1371995413489446913',2,1,NULL,'13959975329','110963','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 09:22:51',NULL,NULL,NULL,'2021-03-17 09:22:51',NULL,NULL,NULL),('1371997003575259138',NULL,'1371997003575259138',2,1,NULL,'18959708027','783840','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 09:29:10',NULL,NULL,NULL,'2021-03-17 09:29:10',NULL,NULL,NULL),('1371997288511107073',NULL,'1371997288511107073',2,1,NULL,'15880975588','323606','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 09:30:18',NULL,NULL,NULL,'2021-03-17 09:30:18',NULL,NULL,NULL),('1372009593776959489',NULL,'1372009593776959489',2,1,NULL,'15905992395','097257','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 10:19:12',NULL,NULL,NULL,'2021-03-17 10:19:12',NULL,NULL,NULL),('1372010731200901122',NULL,'1372010731200901122',2,1,NULL,'15859488368','969111','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 10:23:43',NULL,NULL,NULL,'2021-03-17 10:23:43',NULL,NULL,NULL),('1372011296525971458',NULL,'1372011296525971458',2,1,NULL,'15905992395','700194','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 10:25:58',NULL,NULL,NULL,'2021-03-17 10:25:58',NULL,NULL,NULL),('1372082643474116610',NULL,'1372082643474116610',2,1,NULL,'15880750160','177202','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 15:09:28',NULL,NULL,NULL,'2021-03-17 15:09:28',NULL,NULL,NULL),('1372083186288357377',NULL,'1372083186288357377',2,1,NULL,'15905984868','698777','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 15:11:38',NULL,NULL,NULL,'2021-03-17 15:11:38',NULL,NULL,NULL),('1372084245186539522',NULL,'1372084245186539522',2,1,NULL,'15905984868','980396','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 15:15:50',NULL,NULL,NULL,'2021-03-17 15:15:50',NULL,NULL,NULL),('1372084748746289153',NULL,'1372084748746289153',2,1,NULL,'15905984868','710696','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 15:17:50',NULL,NULL,NULL,'2021-03-17 15:17:50',NULL,NULL,NULL),('1372085579583385601',NULL,'1372085579583385601',2,1,NULL,'15905984868','476851','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 15:21:08',NULL,NULL,NULL,'2021-03-17 15:21:08',NULL,NULL,NULL),('1372088566678614018',NULL,'1372088566678614018',2,1,NULL,'18859989387','551564','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 15:33:01',NULL,NULL,NULL,'2021-03-17 15:33:01',NULL,NULL,NULL),('1372090108508958721',NULL,'1372090108508958721',2,1,NULL,'18859989387','116169','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-17 15:39:08',NULL,NULL,NULL,'2021-03-17 15:39:08',NULL,NULL,NULL),('1372090898472562690','1372090146027008001','1372090898472562690',2,2,'福建奔磊建材有限公司','18859989387','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-17 15:42:17',NULL,NULL,NULL,'2021-03-17 15:42:17',NULL,NULL,NULL),('1372090989837086721','1364861648258506753','1372090989837086721',2,2,'晋江国家体育产业基地发展中心','13215958966','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-17 15:42:38',NULL,NULL,NULL,'2021-03-17 15:42:38',NULL,NULL,NULL),('1372352096661250050',NULL,'1372352096661250050',2,1,NULL,'13799215598','717437','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 09:00:11',NULL,NULL,NULL,'2021-03-18 09:00:11',NULL,NULL,NULL),('1372352351481995265',NULL,'1372352351481995265',2,1,NULL,'15860569172','271500','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 09:01:12',NULL,NULL,NULL,'2021-03-18 09:01:12',NULL,NULL,NULL),('1372353238971555842',NULL,'1372353238971555842',2,1,NULL,'13799215598','722729','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 09:04:43',NULL,NULL,NULL,'2021-03-18 09:04:43',NULL,NULL,NULL),('1372383507254452225',NULL,'1372383507254452225',2,1,NULL,'13506085037','431961','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 11:05:00',NULL,NULL,NULL,'2021-03-18 11:05:00',NULL,NULL,NULL),('1372438079448653826',NULL,'1372438079448653826',2,1,NULL,'13636905586','307610','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 14:41:51',NULL,NULL,NULL,'2021-03-18 14:41:51',NULL,NULL,NULL),('1372449348293599234',NULL,'1372449348293599234',2,1,NULL,'15205000056','980993','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 15:26:38',NULL,NULL,NULL,'2021-03-18 15:26:38',NULL,NULL,NULL),('1372459802814423041',NULL,'1372459802814423041',2,1,NULL,'15980019030','579817','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 16:08:10',NULL,NULL,NULL,'2021-03-18 16:08:10',NULL,NULL,NULL),('1372467190112034817',NULL,'1372467190112034817',2,1,NULL,'13636905586','695007','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 16:37:31',NULL,NULL,NULL,'2021-03-18 16:37:31',NULL,NULL,NULL),('1372482330505093122',NULL,'1372482330505093122',2,1,NULL,'13505955680','514288','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 17:37:41',NULL,NULL,NULL,'2021-03-18 17:37:41',NULL,NULL,NULL),('1372485945672179714',NULL,'1372485945672179714',2,1,NULL,'13505099093','074503','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 17:52:03',NULL,NULL,NULL,'2021-03-18 17:52:03',NULL,NULL,NULL),('1372491528232083458',NULL,'1372491528232083458',2,1,NULL,'15880889992','847222','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 18:14:14',NULL,NULL,NULL,'2021-03-18 18:14:14',NULL,NULL,NULL),('1372557583063293953',NULL,'1372557583063293953',2,1,NULL,'13808525056','723282','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-18 22:36:43',NULL,NULL,NULL,'2021-03-18 22:36:43',NULL,NULL,NULL),('1372722159171948546',NULL,'1372722159171948546',2,1,NULL,'18605954086','642696','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 09:30:41',NULL,NULL,NULL,'2021-03-19 09:30:41',NULL,NULL,NULL),('1372743644699709442',NULL,'1372743644699709442',2,1,NULL,'13505952596','265631','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 10:56:03',NULL,NULL,NULL,'2021-03-19 10:56:03',NULL,NULL,NULL),('1372744573452832769',NULL,'1372744573452832769',2,1,NULL,'13559550870','890293','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 10:59:45',NULL,NULL,NULL,'2021-03-19 10:59:45',NULL,NULL,NULL),('1372744851837177858',NULL,'1372744851837177858',2,1,NULL,'15880816775','435531','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 11:00:51',NULL,NULL,NULL,'2021-03-19 11:00:51',NULL,NULL,NULL),('1372752305652256769',NULL,'1372752305652256769',2,1,NULL,'18200267815','028643','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 11:30:28',NULL,NULL,NULL,'2021-03-19 11:30:28',NULL,NULL,NULL),('1372752604777435138',NULL,'1372752604777435138',2,1,NULL,'17399655173','871239','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 11:31:40',NULL,NULL,NULL,'2021-03-19 11:31:40',NULL,NULL,NULL),('1372780786687692801',NULL,'1372780786687692801',2,1,NULL,'13559076739','290354','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 13:23:39',NULL,NULL,NULL,'2021-03-19 13:23:39',NULL,NULL,NULL),('1372781308698185730',NULL,'1372781308698185730',2,1,NULL,'15880750160','843388','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 13:25:43',NULL,NULL,NULL,'2021-03-19 13:25:43',NULL,NULL,NULL),('1372781573186801665',NULL,'1372781573186801665',2,1,NULL,'15880750160','103855','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 13:26:46',NULL,NULL,NULL,'2021-03-19 13:26:46',NULL,NULL,NULL),('1372781664349999106',NULL,'1372781664349999106',2,1,NULL,'13559076739','932664','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 13:27:08',NULL,NULL,NULL,'2021-03-19 13:27:08',NULL,NULL,NULL),('1372803565151604737','1371716486502133761','1372803565151604737',2,2,'福建鑫华股份有限公司','15559010991','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-19 14:54:10',NULL,NULL,NULL,'2021-03-19 14:54:10',NULL,NULL,NULL),('1372803966127067137','1372011400846700545','1372803966127067137',2,2,'泉州市胤荣进出口贸易有限公司','15905992395','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-19 14:55:45',NULL,NULL,NULL,'2021-03-19 14:55:45',NULL,NULL,NULL),('1372804489563623425','1372353335495073794','1372804489563623425',2,2,'泉州市领航文化传媒有限公司','13799215598','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-03-19 14:57:50',NULL,NULL,NULL,'2021-03-19 14:57:50',NULL,NULL,NULL),('1372805810899406849','1372467780753924097','1372805810899406849',2,2,'晋江市嘉景汽车配件有限公司','13636905586','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-19 15:03:05',NULL,NULL,NULL,'2021-03-19 15:03:05',NULL,NULL,NULL),('1372810082286325761','1371653548550500354','1372810082286325761',2,2,'晋江市梅岭街道社区卫生服务中心','15159793788','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-03-19 15:20:03',NULL,NULL,NULL,'2021-03-19 15:20:03',NULL,NULL,NULL),('1372815490937802754',NULL,'1372815490937802754',2,1,NULL,'18559477701','379544','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 15:41:33',NULL,NULL,NULL,'2021-03-19 15:41:33',NULL,NULL,NULL),('1372815988994625538',NULL,'1372815988994625538',2,1,NULL,'18559477701','237427','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 15:43:32',NULL,NULL,NULL,'2021-03-19 15:43:32',NULL,NULL,NULL),('1372816833270272002',NULL,'1372816833270272002',2,1,NULL,'18559477701','198066','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 15:46:53',NULL,NULL,NULL,'2021-03-19 15:46:53',NULL,NULL,NULL),('1372817045627883522',NULL,'1372817045627883522',2,1,NULL,'15711376693','333898','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 15:47:44',NULL,NULL,NULL,'2021-03-19 15:47:44',NULL,NULL,NULL),('1372817813659471873',NULL,'1372817813659471873',2,1,NULL,'18559477701','953949','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 15:50:47',NULL,NULL,NULL,'2021-03-19 15:50:47',NULL,NULL,NULL),('1372830990409420802','1372815651776778241','1372830990409420802',2,2,'晋江市华天污水处理有限公司','18559477701','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-19 16:43:08',NULL,NULL,NULL,'2021-03-19 16:43:08',NULL,NULL,NULL),('1372845624893919233',NULL,'1372845624893919233',2,1,NULL,'13905051776','306076','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 17:41:17',NULL,NULL,NULL,'2021-03-19 17:41:17',NULL,NULL,NULL),('1372868460350033922',NULL,'1372868460350033922',2,1,NULL,'18606097837','502237','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 19:12:02',NULL,NULL,NULL,'2021-03-19 19:12:02',NULL,NULL,NULL),('1372869156365422593',NULL,'1372869156365422593',2,1,NULL,'18606097837','619569','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-19 19:14:48',NULL,NULL,NULL,'2021-03-19 19:14:48',NULL,NULL,NULL),('1373086873345347586',NULL,'1373086873345347586',2,1,NULL,'13905051776','190263','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-20 09:39:55',NULL,NULL,NULL,'2021-03-20 09:39:55',NULL,NULL,NULL),('1373087133392195586',NULL,'1373087133392195586',2,1,NULL,'18100538866','371443','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-20 09:40:57',NULL,NULL,NULL,'2021-03-20 09:40:57',NULL,NULL,NULL),('1373183697410347009',NULL,'1373183697410347009',2,1,NULL,'13950841835','160167','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-20 16:04:40',NULL,NULL,NULL,'2021-03-20 16:04:40',NULL,NULL,NULL),('1373467408659927042',NULL,'1373467408659927042',2,1,NULL,'15260812636','340044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-21 10:52:02',NULL,NULL,NULL,'2021-03-21 10:52:02',NULL,NULL,NULL),('1373820884900401154',NULL,'1373820884900401154',2,1,NULL,'15905971778','426963','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-22 10:16:37',NULL,NULL,NULL,'2021-03-22 10:16:37',NULL,NULL,NULL),('1373888334694207489',NULL,'1373888334694207489',2,1,NULL,'15159793788','026554','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-22 14:44:39',NULL,NULL,NULL,'2021-03-22 14:44:39',NULL,NULL,NULL),('1373890037313196034',NULL,'1373890037313196034',2,1,NULL,'15159793788','736941','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-22 14:51:25',NULL,NULL,NULL,'2021-03-22 14:51:25',NULL,NULL,NULL),('1373896775475154945','1372491588135133185','1373896775475154945',2,2,'厦门市住宅设计院有限公司晋江分公司','15880889992','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-03-22 15:18:11',NULL,NULL,NULL,'2021-03-22 15:18:11',NULL,NULL,NULL),('1373899961766268929',NULL,'1373899961766268929',2,1,NULL,'15860325253','646397','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-22 15:30:51',NULL,NULL,NULL,'2021-03-22 15:30:51',NULL,NULL,NULL),('1373973665091178497',NULL,'1373973665091178497',2,1,NULL,'18650060049','776942','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-22 20:23:43',NULL,NULL,NULL,'2021-03-22 20:23:43',NULL,NULL,NULL),('1373973990250401794',NULL,'1373973990250401794',2,1,NULL,'18650060049','281333','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-22 20:25:01',NULL,NULL,NULL,'2021-03-22 20:25:01',NULL,NULL,NULL),('1374183961739153410','1212692778300018689','1374183961739153410',2,2,'晋江市路桥建设开发有限公司','17350011170','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-23 10:19:22',NULL,NULL,NULL,'2021-03-23 10:19:22',NULL,NULL,NULL),('1374185035879436290','1211450825436610561','1374185035879436290',2,2,'福建海峡石墨烯产业技术研究院有限公司','13606051571','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-23 10:23:38',NULL,NULL,NULL,'2021-03-23 10:23:38',NULL,NULL,NULL),('1374185146143494146','1211164549680574466','1374185146143494146',2,2,'中乔体育股份有限公司','18659597668','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-23 10:24:04',NULL,NULL,NULL,'2021-03-23 10:24:04',NULL,NULL,NULL),('1374185423600898050','1215974921277042690','1374185423600898050',2,2,'泉州中升雷克萨斯汽车销售有限公司','18159582179','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-23 10:25:10',NULL,NULL,NULL,'2021-03-23 10:25:10',NULL,NULL,NULL),('1374199021916147713',NULL,'1374199021916147713',2,1,NULL,'13850752082','548595','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-23 11:19:12',NULL,NULL,NULL,'2021-03-23 11:19:12',NULL,NULL,NULL),('1374300385723920385',NULL,'1374300385723920385',2,1,NULL,'13313876229','593387','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-23 18:01:59',NULL,NULL,NULL,'2021-03-23 18:01:59',NULL,NULL,NULL),('1374300845755183106','1374300616347725826','1374300845755183106',2,2,'晋江集成电路产业园','13313876229','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-23 18:03:49',NULL,NULL,NULL,'2021-03-23 18:03:49',NULL,NULL,NULL),('1374524060293246978',NULL,'1374524060293246978',2,1,NULL,'15059820805','262381','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 08:50:48',NULL,NULL,NULL,'2021-03-24 08:50:48',NULL,NULL,NULL),('1374531033382367233',NULL,'1374531033382367233',2,1,NULL,'18150992837','591424','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 09:18:30',NULL,NULL,NULL,'2021-03-24 09:18:30',NULL,NULL,NULL),('1374531606517231618','1373900784671936513','1374531606517231618',2,2,'晋江市国邦建材有限公司','15860325253','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-24 09:20:47',NULL,NULL,NULL,'2021-03-24 09:20:47',NULL,NULL,NULL),('1374531995488595969','1371997783552225282','1374531995488595969',2,2,'泉州市盛维电子科技有限公司','15880975588','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-24 09:22:19',NULL,NULL,NULL,'2021-03-24 09:22:19',NULL,NULL,NULL),('1374537943154274305',NULL,'1374537943154274305',2,1,NULL,'15059820805','326740','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 09:45:57',NULL,NULL,NULL,'2021-03-24 09:45:57',NULL,NULL,NULL),('1374539126765891585',NULL,'1374539126765891585',2,1,NULL,'15059820805','859715','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 09:50:40',NULL,NULL,NULL,'2021-03-24 09:50:40',NULL,NULL,NULL),('1374539913340497922',NULL,'1374539913340497922',2,1,NULL,'15059820805','054331','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 09:53:47',NULL,NULL,NULL,'2021-03-24 09:53:47',NULL,NULL,NULL),('1374540291918376961',NULL,'1374540291918376961',2,1,NULL,'15059820805','853615','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 09:55:17',NULL,NULL,NULL,'2021-03-24 09:55:17',NULL,NULL,NULL),('1374541263935746050',NULL,'1374541263935746050',2,1,NULL,'15059820805','951765','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 09:59:09',NULL,NULL,NULL,'2021-03-24 09:59:09',NULL,NULL,NULL),('1374543439865163777',NULL,'1374543439865163777',2,1,NULL,'15059820805','141624','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:07:48',NULL,NULL,NULL,'2021-03-24 10:07:48',NULL,NULL,NULL),('1374543909719486465',NULL,'1374543909719486465',2,1,NULL,'13313876229','187402','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:09:40',NULL,NULL,NULL,'2021-03-24 10:09:40',NULL,NULL,NULL),('1374544181107732481',NULL,'1374544181107732481',2,1,NULL,'13599110629','377222','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:10:45',NULL,NULL,NULL,'2021-03-24 10:10:45',NULL,NULL,NULL),('1374545322927304706','1374544234622857218','1374545322927304706',2,2,'半导体产业园区管委会','13599110629','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-24 10:15:17',NULL,NULL,NULL,'2021-03-24 10:15:17',NULL,NULL,NULL),('1374546354898055169',NULL,'1374546354898055169',2,1,NULL,'15059820805','471408','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:19:23',NULL,NULL,NULL,'2021-03-24 10:19:23',NULL,NULL,NULL),('1374548809165680641',NULL,'1374548809165680641',2,1,NULL,'15880975588','956201','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:29:08',NULL,NULL,NULL,'2021-03-24 10:29:08',NULL,NULL,NULL),('1374549145406255106',NULL,'1374549145406255106',2,1,NULL,'15059820805','443157','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:30:28',NULL,NULL,NULL,'2021-03-24 10:30:28',NULL,NULL,NULL),('1374550010586312706',NULL,'1374550010586312706',2,1,NULL,'18150992837','728412','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:33:55',NULL,NULL,NULL,'2021-03-24 10:33:55',NULL,NULL,NULL),('1374550720363212802',NULL,'1374550720363212802',2,1,NULL,'18159582179','688257','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:36:44',NULL,NULL,NULL,'2021-03-24 10:36:44',NULL,NULL,NULL),('1374552231466086402',NULL,'1374552231466086402',2,1,NULL,'15059820805','564925','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:42:44',NULL,NULL,NULL,'2021-03-24 10:42:44',NULL,NULL,NULL),('1374553886689439746','1374549152519794689','1374553886689439746',2,2,'泉州市盛维电子科技有限公司','15880975588','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-24 10:49:19',NULL,NULL,NULL,'2021-03-24 10:49:19',NULL,NULL,NULL),('1374554389892673538',NULL,'1374554389892673538',2,1,NULL,'15059820805','220505','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 10:51:19',NULL,NULL,NULL,'2021-03-24 10:51:19',NULL,NULL,NULL),('1374555370952962049','1374554432229978113','1374555370952962049',2,2,'福建省晋华集成电路有限公司','15059820805','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-24 10:55:13',NULL,NULL,NULL,'2021-03-24 10:55:13',NULL,NULL,NULL),('1374592023503417346',NULL,'1374592023503417346',2,1,NULL,'13290782758','402060','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 13:20:51',NULL,NULL,NULL,'2021-03-24 13:20:51',NULL,NULL,NULL),('1374644897562341378',NULL,'1374644897562341378',2,1,NULL,'13905089190','818104','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 16:50:57',NULL,NULL,NULL,'2021-03-24 16:50:57',NULL,NULL,NULL),('1374657376858255361',NULL,'1374657376858255361',2,1,NULL,'15259755367','503418','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 17:40:33',NULL,NULL,NULL,'2021-03-24 17:40:33',NULL,NULL,NULL),('1374734814686588930',NULL,'1374734814686588930',2,1,NULL,'13779911861','854866','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-24 22:48:15',NULL,NULL,NULL,'2021-03-24 22:48:15',NULL,NULL,NULL),('1374905184081260545','1372491588135133185','1374905184081260545',2,2,'厦门市住宅设计院有限公司晋江分公司','15880889992','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-25 10:05:15',NULL,NULL,NULL,'2021-03-25 10:05:15',NULL,NULL,NULL),('1374907913444896769',NULL,'1374907913444896769',2,1,NULL,'18859760088','361599','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 10:16:05',NULL,NULL,NULL,'2021-03-25 10:16:05',NULL,NULL,NULL),('1374909106787299330',NULL,'1374909106787299330',2,1,NULL,'15959999006','003281','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 10:20:50',NULL,NULL,NULL,'2021-03-25 10:20:50',NULL,NULL,NULL),('1374911953641779201',NULL,'1374911953641779201',2,1,NULL,'15959999006','617475','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 10:32:09',NULL,NULL,NULL,'2021-03-25 10:32:09',NULL,NULL,NULL),('1374913272943325186','1374909187762532354','1374913272943325186',2,2,'福建锦科新材料有限责任公司','15959999006','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-25 10:37:23',NULL,NULL,NULL,'2021-03-25 10:37:23',NULL,NULL,NULL),('1374915466585288705','1213698480367751170','1374915466585288705',2,2,'福建锦科新材料有限责任公司','15959999006','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-03-25 10:46:06',NULL,NULL,NULL,'2021-03-25 10:46:06',NULL,NULL,NULL),('1374921491719761922',NULL,'1374921491719761922',2,1,NULL,'18815995111','848366','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 11:10:03',NULL,NULL,NULL,'2021-03-25 11:10:03',NULL,NULL,NULL),('1374928022746017794',NULL,'1374928022746017794',2,1,NULL,'19859573633','450374','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 11:36:00',NULL,NULL,NULL,'2021-03-25 11:36:00',NULL,NULL,NULL),('1374929290260492290',NULL,'1374929290260492290',2,1,NULL,'19859573633','380142','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 11:41:02',NULL,NULL,NULL,'2021-03-25 11:41:02',NULL,NULL,NULL),('1374974268856639490',NULL,'1374974268856639490',2,1,NULL,'15659222652','117684','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 14:39:46',NULL,NULL,NULL,'2021-03-25 14:39:46',NULL,NULL,NULL),('1374975634727542786',NULL,'1374975634727542786',2,1,NULL,'13799238690','174653','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 14:45:11',NULL,NULL,NULL,'2021-03-25 14:45:11',NULL,NULL,NULL),('1374976847506350082','1374922080805564418','1374976847506350082',2,2,'晋江市文物保护中心','18815995111','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-25 14:50:00',NULL,NULL,NULL,'2021-03-25 14:50:00',NULL,NULL,NULL),('1375022430292058113',NULL,'1375022430292058113',2,1,NULL,'18159582179','129497','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-25 17:51:08',NULL,NULL,NULL,'2021-03-25 17:51:08',NULL,NULL,NULL),('1375243559216652290',NULL,'1375243559216652290',2,1,NULL,'13799859898','726759','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 08:29:49',NULL,NULL,NULL,'2021-03-26 08:29:49',NULL,NULL,NULL),('1375247200392617985','1374975706999595010','1375247200392617985',2,2,'向维智联(福建)科技有限公司','13799238690','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-26 08:44:18',NULL,NULL,NULL,'2021-03-26 08:44:18',NULL,NULL,NULL),('1375247573048139778','1374592097176367105','1375247573048139778',2,2,'泉州恒度微纳科技有限公司','13290782758','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-26 08:45:46',NULL,NULL,NULL,'2021-03-26 08:45:46',NULL,NULL,NULL),('1375252942659035137','1371630658811703297','1375252942659035137',2,2,'福建华清电子材料科技有限公司','13959775727','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-03-26 09:07:07',NULL,NULL,NULL,'2021-03-26 09:07:07',NULL,NULL,NULL),('1375273234164916226',NULL,'1375273234164916226',2,1,NULL,'18965616589','352098','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 10:27:45',NULL,NULL,NULL,'2021-03-26 10:27:45',NULL,NULL,NULL),('1375361461865455618',NULL,'1375361461865455618',2,1,NULL,'15880765364','329348','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 16:18:20',NULL,NULL,NULL,'2021-03-26 16:18:20',NULL,NULL,NULL),('1375361839700942850',NULL,'1375361839700942850',2,1,NULL,'15880765364','767300','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 16:19:50',NULL,NULL,NULL,'2021-03-26 16:19:50',NULL,NULL,NULL),('1375366648143323138',NULL,'1375366648143323138',2,1,NULL,'15880765364','510711','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 16:38:56',NULL,NULL,NULL,'2021-03-26 16:38:56',NULL,NULL,NULL),('1375406758784180226',NULL,'1375406758784180226',2,1,NULL,'13788807579','110430','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 19:18:19',NULL,NULL,NULL,'2021-03-26 19:18:19',NULL,NULL,NULL),('1375442481478410242',NULL,'1375442481478410242',2,1,NULL,'19859573633','088112','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 21:40:16',NULL,NULL,NULL,'2021-03-26 21:40:16',NULL,NULL,NULL),('1375443051526266881',NULL,'1375443051526266881',2,1,NULL,'13600739571','425428','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-26 21:42:32',NULL,NULL,NULL,'2021-03-26 21:42:32',NULL,NULL,NULL),('1375638977511464961',NULL,'1375638977511464961',2,1,NULL,'15359991222','254537','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-27 10:41:05',NULL,NULL,NULL,'2021-03-27 10:41:05',NULL,NULL,NULL),('1375639882776485889',NULL,'1375639882776485889',2,1,NULL,'15359991222','192854','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-27 10:44:40',NULL,NULL,NULL,'2021-03-27 10:44:40',NULL,NULL,NULL),('1375640051370729473',NULL,'1375640051370729473',2,1,NULL,'18159582179','409948','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-27 10:45:21',NULL,NULL,NULL,'2021-03-27 10:45:21',NULL,NULL,NULL),('1375640793229860865',NULL,'1375640793229860865',2,1,NULL,'15359991222','722453','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-27 10:48:17',NULL,NULL,NULL,'2021-03-27 10:48:17',NULL,NULL,NULL),('1375642513930493953',NULL,'1375642513930493953',2,1,NULL,'18159582179','432057','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-27 10:55:08',NULL,NULL,NULL,'2021-03-27 10:55:08',NULL,NULL,NULL),('1375642791069130754',NULL,'1375642791069130754',2,1,NULL,'18159582179','763446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-27 10:56:14',NULL,NULL,NULL,'2021-03-27 10:56:14',NULL,NULL,NULL),('1375644090732945410',NULL,'1375644090732945410',2,1,NULL,'18959708869','137900','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-27 11:01:24',NULL,NULL,NULL,'2021-03-27 11:01:24',NULL,NULL,NULL),('1376006306200068097',NULL,'1376006306200068097',2,1,NULL,'13850759758','328940','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-28 11:00:43',NULL,NULL,NULL,'2021-03-28 11:00:43',NULL,NULL,NULL),('1376007055046909953',NULL,'1376007055046909953',2,1,NULL,'13850759758','989331','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-28 11:03:41',NULL,NULL,NULL,'2021-03-28 11:03:41',NULL,NULL,NULL),('1376329416233230338','1376007099934351361','1376329416233230338',2,2,'福建省恺思智能设备有限公司','13850759758','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-29 08:24:38',NULL,NULL,NULL,'2021-03-29 08:24:38',NULL,NULL,NULL),('1376349591028408321',NULL,'1376349591028408321',2,1,NULL,'17359999106','482883','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-29 09:44:48',NULL,NULL,NULL,'2021-03-29 09:44:48',NULL,NULL,NULL),('1376352389593866242',NULL,'1376352389593866242',2,1,NULL,'15106011336','459416','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-29 09:55:55',NULL,NULL,NULL,'2021-03-29 09:55:55',NULL,NULL,NULL),('1376381513238618114',NULL,'1376381513238618114',2,1,NULL,'13959224957','753413','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-29 11:51:39',NULL,NULL,NULL,'2021-03-29 11:51:39',NULL,NULL,NULL),('1376426622361538562',NULL,'1376426622361538562',2,1,NULL,'13799215598','253071','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-29 14:50:54',NULL,NULL,NULL,'2021-03-29 14:50:54',NULL,NULL,NULL),('1376432246705098754','1376349644128296962','1376432246705098754',2,2,'福建宸琦新材料科技有限公司','17359999106','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-29 15:13:15',NULL,NULL,NULL,'2021-03-29 15:13:15',NULL,NULL,NULL),('1376467643510296578','1289134473471909889','1376467643510296578',2,2,'晋江市高新技术开发中心','15060997885','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-29 17:33:54',NULL,NULL,NULL,'2021-03-29 17:33:54',NULL,NULL,NULL),('1376478973927624705',NULL,'1376478973927624705',2,1,NULL,'15827632790','159747','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-29 18:18:55',NULL,NULL,NULL,'2021-03-29 18:18:55',NULL,NULL,NULL),('1376711067161354241',NULL,'1376711067161354241',2,1,NULL,'18359882323','171990','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-30 09:41:11',NULL,NULL,NULL,'2021-03-30 09:41:11',NULL,NULL,NULL),('1376712520449941505',NULL,'1376712520449941505',2,1,NULL,'18359882323','820180','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-30 09:46:57',NULL,NULL,NULL,'2021-03-30 09:46:57',NULL,NULL,NULL),('1376714374466527234',NULL,'1376714374466527234',2,1,NULL,'18960410787','294699','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-30 09:54:19',NULL,NULL,NULL,'2021-03-30 09:54:19',NULL,NULL,NULL),('1376724194548539394',NULL,'1376724194548539394',2,1,NULL,'15880750160','686378','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-30 10:33:20',NULL,NULL,NULL,'2021-03-30 10:33:20',NULL,NULL,NULL),('1376725226062110721',NULL,'1376725226062110721',2,1,NULL,'18105086003','452924','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-30 10:37:26',NULL,NULL,NULL,'2021-03-30 10:37:26',NULL,NULL,NULL),('1376725655076495361',NULL,'1376725655076495361',2,1,NULL,'15880750160','977180','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-30 10:39:09',NULL,NULL,NULL,'2021-03-30 10:39:09',NULL,NULL,NULL),('1376791714357862401','1376712565047975937','1376791714357862401',2,2,'渠梁电子有限公司','18359882323','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-30 15:01:38',NULL,NULL,NULL,'2021-03-30 15:01:38',NULL,NULL,NULL),('1376792122786603009','1376725268030316545','1376792122786603009',2,2,'福建省瑞桐集成电路研究院有限责任公司','18105086003','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-03-30 15:03:16',NULL,NULL,NULL,'2021-03-30 15:03:16',NULL,NULL,NULL),('1376796475232641025','1375361546384875521','1376796475232641025',2,2,'泉州展志钢材有限公司','15880765364','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-30 15:20:33',NULL,NULL,NULL,'2021-03-30 15:20:33',NULL,NULL,NULL),('1376799809419108354','1372353335495073794','1376799809419108354',2,2,'泉州市领航文化传媒有限公司','13799215598','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-30 15:33:48',NULL,NULL,NULL,'2021-03-30 15:33:48',NULL,NULL,NULL),('1376809116579684354','1289134473471909889','1376809116579684354',2,2,'晋江市高新技术开发服务中心','15060997885','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-03-30 16:10:47',NULL,NULL,NULL,'2021-03-30 16:10:47',NULL,NULL,NULL),('1377076785606373377',NULL,'1377076785606373377',2,1,NULL,'15160423086','451711','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-31 09:54:25',NULL,NULL,NULL,'2021-03-31 09:54:25',NULL,NULL,NULL),('1377160998749810689',NULL,'1377160998749810689',2,1,NULL,'15106011992','827077','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-31 15:29:03',NULL,NULL,NULL,'2021-03-31 15:29:03',NULL,NULL,NULL),('1377201887853490177',NULL,'1377201887853490177',2,1,NULL,'13788822586','953680','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-31 18:11:31',NULL,NULL,NULL,'2021-03-31 18:11:31',NULL,NULL,NULL),('1377269180016963585',NULL,'1377269180016963585',2,1,NULL,'15805903856','687558','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-03-31 22:38:55',NULL,NULL,NULL,'2021-03-31 22:38:55',NULL,NULL,NULL),('1377435737464582146',NULL,'1377435737464582146',2,1,NULL,'13788829369','798540','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 09:40:45',NULL,NULL,NULL,'2021-04-01 09:40:45',NULL,NULL,NULL),('1377445222153269249',NULL,'1377445222153269249',2,1,NULL,'13506085037','463648','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 10:18:27',NULL,NULL,NULL,'2021-04-01 10:18:27',NULL,NULL,NULL),('1377455325682151425',NULL,'1377455325682151425',2,1,NULL,'19959797889','223680','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 10:58:36',NULL,NULL,NULL,'2021-04-01 10:58:36',NULL,NULL,NULL),('1377457608482435074',NULL,'1377457608482435074',2,1,NULL,'19959797889','610642','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 11:07:40',NULL,NULL,NULL,'2021-04-01 11:07:40',NULL,NULL,NULL),('1377458187627737089',NULL,'1377458187627737089',2,1,NULL,'19959797889','787761','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 11:09:58',NULL,NULL,NULL,'2021-04-01 11:09:58',NULL,NULL,NULL),('1377461493997580289',NULL,'1377461493997580289',2,1,NULL,'18150505789','241217','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 11:23:06',NULL,NULL,NULL,'2021-04-01 11:23:06',NULL,NULL,NULL),('1377462896845467649',NULL,'1377462896845467649',2,1,NULL,'18150505789','908167','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 11:28:41',NULL,NULL,NULL,'2021-04-01 11:28:41',NULL,NULL,NULL),('1377546733428486145',NULL,'1377546733428486145',2,1,NULL,'18150505789','823493','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 17:01:49',NULL,NULL,NULL,'2021-04-01 17:01:49',NULL,NULL,NULL),('1377549365140336641',NULL,'1377549365140336641',2,1,NULL,'13505057971','457587','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-01 17:12:16',NULL,NULL,NULL,'2021-04-01 17:12:16',NULL,NULL,NULL),('1377785669857918978','1377458375247343618','1377785669857918978',2,2,'福建省晋江智融财务管理有限责任公司','19959797889','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-02 08:51:16',NULL,NULL,NULL,'2021-04-02 08:51:16',NULL,NULL,NULL),('1377785874254741506','1377549464457261057','1377785874254741506',2,2,'晋江市东石群艺木雕有限公司','13505057971','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-02 08:52:05',NULL,NULL,NULL,'2021-04-02 08:52:05',NULL,NULL,NULL),('1377790378605887489','1377458375247343618','1377790378605887489',2,2,'福建省晋江智融财务管理有限责任公司','19959797889','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-02 09:09:59',NULL,NULL,NULL,'2021-04-02 09:09:59',NULL,NULL,NULL),('1377825074211536897',NULL,'1377825074211536897',2,1,NULL,'13489387611','272928','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 11:27:51',NULL,NULL,NULL,'2021-04-02 11:27:51',NULL,NULL,NULL),('1377864025269944321',NULL,'1377864025269944321',2,1,NULL,'13489387611','730389','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 14:02:37',NULL,NULL,NULL,'2021-04-02 14:02:37',NULL,NULL,NULL),('1377908238795751425',NULL,'1377908238795751425',2,1,NULL,'13805942127','558590','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 16:58:19',NULL,NULL,NULL,'2021-04-02 16:58:19',NULL,NULL,NULL),('1377909229121257473',NULL,'1377909229121257473',2,1,NULL,'13805942127','406937','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 17:02:15',NULL,NULL,NULL,'2021-04-02 17:02:15',NULL,NULL,NULL),('1377910864820125698','1377908314343555073','1377910864820125698',2,2,'福建晋兴建设有限公司','13805942127','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-02 17:08:45',NULL,NULL,NULL,'2021-04-02 17:08:45',NULL,NULL,NULL),('1377911937651785729',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','18959858592','18959858592','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937655980033',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059551567','\n15059551567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937655980034',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965129895','\n18965129895','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937660174337',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13255957226','\n13255957226','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937660174338',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13666026522','\n13666026522','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937660174339',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13801333177','\n13801333177','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937660174340',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15106096021','\n15106096021','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937660174341',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959847128','\n18959847128','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937660174342',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13802609526','\n13802609526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937660174343',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506086731','\n13506086731','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937664368641',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18016585576','\n18016585576','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937664368642',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13655986799','\n13655986799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937664368643',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959798579','\n15959798579','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937664368644',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859971221','\n18859971221','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937664368645',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13338562717','\n13338562717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937664368646',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18250298076','\n18250298076','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937664368647',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18065376686','\n18065376686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937668562945',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15602265352','\n15602265352','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937668562946',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906099888','\n13906099888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937668562947',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13809549382','\n13809549382','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937668562948',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905070552','\n13905070552','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937668562949',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506056368','\n13506056368','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937668562950',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13705941428','\n13705941428','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937668562951',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15159878799','\n15159878799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937672757249',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905089190','\n13905089190','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937672757250',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960381057','\n13960381057','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937672757251',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980788802','\n15980788802','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937672757252',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15985952242','\n15985952242','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937672757253',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950920100','\n13950920100','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937672757254',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905958730','\n13905958730','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937672757255',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13105079935','\n13105079935','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937702117378',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799966695','\n13799966695','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937706311681',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805032333','\n15805032333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937706311682',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505080996','\n13505080996','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937706311683',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959705077','\n18959705077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937706311684',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965689935','\n18965689935','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937710505985',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18960206656','\n18960206656','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937710505986',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13774825517','\n13774825517','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937710505987',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880720190','\n15880720190','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937710505988',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15810812160','\n15810812160','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937710505989',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905975119','\n13905975119','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937710505990',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13509362773','\n13509362773','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937710505991',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18960278086','\n18960278086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937714700290',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18759429880','\n18759429880','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937714700291',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18609586661','\n18609586661','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937714700292',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13306995188','\n13306995188','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937714700293',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059792958','\n15059792958','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937714700294',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13305967663','\n13305967663','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937714700295',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13306995039','\n13306995039','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937714700296',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959896966','\n15959896966','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937718894593',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905952020','\n13905952020','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937718894594',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959995705','\n18959995705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937718894595',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13559566696','\n13559566696','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937718894596',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859990000','\n18859990000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937718894597',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15860395678','\n15860395678','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937718894598',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980325929','\n15980325929','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937718894599',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15859759601','\n15859759601','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937723088897',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13805946193','\n13805946193','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937723088898',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15906092370','\n15906092370','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937723088899',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13044554499','\n13044554499','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937723088900',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799555666','\n13799555666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937748254721',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18006037555','\n18006037555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937748254722',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18605008168','\n18605008168','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937752449025',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18350782990','\n18350782990','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937752449026',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599162155','\n13599162155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937752449027',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905907962','\n15905907962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937752449028',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506060342','\n13506060342','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937752449029',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13788851759','\n13788851759','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937752449030',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13615901213','\n13615901213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937756643330',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599212929','\n13599212929','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937756643331',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805021228','\n15805021228','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937756643332',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15750768536','\n15750768536','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937756643333',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506000615','\n13506000615','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937756643334',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905974006','\n13905974006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937756643335',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13358591930','\n13358591930','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937756643336',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959995535','\n15959995535','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937760837634',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13559593361','\n13559593361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937760837635',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960417367','\n13960417367','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937760837636',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599109151','\n13599109151','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937760837637',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15659878695','\n15659878695','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937760837638',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965689828','\n18965689828','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937760837639',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859969666','\n18859969666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937760837640',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13144828970','\n13144828970','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937765031937',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18960357668','\n18960357668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937765031938',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260875883','\n15260875883','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937765031939',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15160423086','\n15160423086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937765031940',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13705943966','\n13705943966','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937765031941',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15559162475','\n15559162475','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937765031942',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13850778776','\n13850778776','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937765031943',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18559161283','\n18559161283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937769226242',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15611255393','\n15611255393','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937794392065',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13636963633','\n13636963633','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937794392066',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18650100145','\n18650100145','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937794392067',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18721796963','\n18721796963','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937794392068',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13656038332','\n13656038332','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937798586369',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13675953607','\n13675953607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937798586370',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959210622','\n18959210622','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937798586371',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13805900098','\n13805900098','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937798586372',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859932277','\n18859932277','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937798586373',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15306089555','\n15306089555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937798586374',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905079361','\n15905079361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937802780673',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18618285267','\n18618285267','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937802780674',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859799829','\n18859799829','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937802780675',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13337211223','\n13337211223','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937802780676',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13600757303','\n13600757303','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937802780677',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13626072564','\n13626072564','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937806974977',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13615950806','\n13615950806','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937806974978',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906933286','\n13906933286','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937806974979',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13788846820','\n13788846820','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937806974980',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260782666','\n15260782666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937806974981',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905985809','\n13905985809','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937806974982',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260803666','\n15260803666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937806974983',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659030309','\n18659030309','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937811169282',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13685908658','\n13685908658','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937811169283',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13805919195','\n13805919195','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937811169284',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15392288855','\n15392288855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937811169285',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599717008','\n13599717008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937811169286',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880785555','\n15880785555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937811169287',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15960692650','\n15960692650','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937811169288',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259571333','\n15259571333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937815363585',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259546913','\n15259546913','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937836335105',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959712401','\n13959712401','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937840529410',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260899107','\n15260899107','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937840529411',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18516157979','\n18516157979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937840529412',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13328509988','\n13328509988','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937840529413',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13395096999','\n13395096999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937844723714',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959858506','\n18959858506','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937844723715',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15985918296','\n15985918296','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937844723716',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960341716','\n13960341716','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937844723717',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880972652','\n15880972652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937844723718',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980313135','\n15980313135','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937844723719',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980066202','\n15980066202','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937844723720',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906096567','\n13906096567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937848918017',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15080070385','\n15080070385','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937848918018',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13675995249','\n13675995249','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937848918019',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15995216889','\n15995216889','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937848918020',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260429705','\n15260429705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937848918021',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959778888','\n13959778888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937848918022',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059157225','\n15059157225','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937848918023',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905968151','\n13905968151','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937853112322',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799521561','\n13799521561','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937853112323',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15759488187','\n15759488187','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937853112324',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13720842620','\n13720842620','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937853112325',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13205061526','\n13205061526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937853112326',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13774828120','\n13774828120','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937853112327',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060626155','\n15060626155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937853112328',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18771094578','\n18771094578','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937857306625',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959237668','\n13959237668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937857306626',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13400820519','\n13400820519','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937857306627',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13779911861','\n13779911861','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937857306628',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13601032833','\n13601032833','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937882472449',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959805200','\n18959805200','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937886666754',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506042338','\n13506042338','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937886666755',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18567651331','\n18567651331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937886666756',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18695665035','\n18695665035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937886666757',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13859727077','\n13859727077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937886666758',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15345952654','\n15345952654','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937890861057',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15659972175','\n15659972175','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937890861058',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15359383363','\n15359383363','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937890861059',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959959200','\n15959959200','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937890861060',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960291518','\n13960291518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937890861061',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13625979936','\n13625979936','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937890861062',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13514019395','\n13514019395','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937890861063',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15396608587','\n15396608587','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937895055362',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13969010619','\n13969010619','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937895055363',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13859796953','\n13859796953','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937895055364',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15850693987','\n15850693987','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937895055365',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959870601','\n15959870601','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937895055366',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805981750','\n15805981750','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937895055367',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13842019660','\n13842019660','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937895055368',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13940108782','\n13940108782','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937899249666',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876572155','\n18876572155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937899249667',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959753823','\n13959753823','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937899249668',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13459034477','\n13459034477','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937899249669',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18862155925','\n18862155925','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937899249670',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859596380','\n18859596380','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937899249671',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18275745728','\n18275745728','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937903443969',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799487213','\n13799487213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937903443970',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15086777305','\n15086777305','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937903443971',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18850528121','\n18850528121','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937903443972',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18052150317','\n18052150317','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937928609794',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859757759','\n18859757759','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937928609795',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18359810815','\n18359810815','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937932804098',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15960707755','\n15960707755','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937932804099',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13696949262','\n13696949262','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937932804100',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860116953','\n13860116953','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937932804101',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18805920922','\n18805920922','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937932804102',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659030881','\n18659030881','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937932804103',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059803792','\n15059803792','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937932804104',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959813876','\n18959813876','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998401',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13436970465','\n13436970465','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998402',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980013301','\n15980013301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998403',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13805924801','\n13805924801','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998404',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950430719','\n13950430719','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998405',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18250169959','\n18250169959','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998406',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18900336517','\n18900336517','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998407',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18105907301','\n18105907301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937936998408',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18851401527','\n18851401527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937941192705',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18020867909','\n18020867909','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937941192706',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15860257142','\n15860257142','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937941192707',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876336921','\n18876336921','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937941192708',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15806032297','\n15806032297','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937941192709',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965785175','\n18965785175','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937941192710',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15005062379','\n15005062379','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937941192711',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18950700105','\n18950700105','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937945387009',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15005059367','\n15005059367','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937945387010',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18741355270','\n18741355270','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937945387011',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18150563203','\n18150563203','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937945387012',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13075572292','\n13075572292','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937945387013',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15502207706','\n15502207706','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937945387014',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18649652527','\n18649652527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937978941442',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17741357996','\n17741357996','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937978941443',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15090088338','\n15090088338','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937983135746',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599220676','\n13599220676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937983135747',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18900371513','\n18900371513','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937983135748',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13788829369','\n13788829369','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937983135749',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15191818740','\n15191818740','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937983135750',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18059037101','\n18059037101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937983135751',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18696960184','\n18696960184','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937983135752',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859760088','\n18859760088','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330049',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15392286115','\n15392286115','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330050',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13636957868','\n13636957868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330051',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880974760','\n15880974760','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330052',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13794913769','\n13794913769','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330053',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259555555','\n15259555555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330054',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905037555','\n15905037555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330055',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18960285333','\n18960285333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937987330056',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959997270','\n18959997270','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937991524354',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15960551920','\n15960551920','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937991524355',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15392288851','\n15392288851','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937991524356',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960207400','\n13960207400','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937991524357',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15629795466','\n15629795466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937991524358',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15946798736','\n15946798736','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937991524359',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17750799505','\n17750799505','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937991524360',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13666988888','\n13666988888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937995718657',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17750103317','\n17750103317','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937995718658',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959941093','\n18959941093','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937995718659',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15622174598','\n15622174598','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937995718660',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260807555','\n15260807555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937995718661',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905958858','\n15905958858','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911937995718662',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599279399','\n13599279399','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938025078786',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505906457','\n13505906457','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938029273090',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15080458330','\n15080458330','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938033467394',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15359585555','\n15359585555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938033467395',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059748612','\n15059748612','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938033467396',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18571081281','\n18571081281','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938033467397',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18065333731','\n18065333731','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938033467398',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959889099','\n15959889099','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938033467399',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13459504545','\n13459504545','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938033467400',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15396597171','\n15396597171','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661697',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18605001616','\n18605001616','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661698',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260785666','\n15260785666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661699',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18106980703','\n18106980703','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661700',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859464970','\n18859464970','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661701',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13027105101','\n13027105101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661702',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959975329','\n13959975329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661703',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17758709290','\n17758709290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938037661704',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13285030066','\n13285030066','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938041856002',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599229258','\n13599229258','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938041856003',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959855726','\n18959855726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938041856004',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18046360864','\n18046360864','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938041856005',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13459556182','\n13459556182','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938041856006',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060456431','\n15060456431','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938041856007',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18050929268','\n18050929268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938041856008',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860300607','\n13860300607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938046050305',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13306995027','\n13306995027','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938046050306',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18796922940','\n18796922940','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938046050307',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13325253201','\n13325253201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938046050308',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18350777627','\n18350777627','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938046050309',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599159330','\n13599159330','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938046050310',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18020650858','\n18020650858','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938075410434',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13328963385','\n13328963385','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938075410435',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13816975274','\n13816975274','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938079604737',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13489312968','\n13489312968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938079604738',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15960408186','\n15960408186','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938079604739',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859780809','\n18859780809','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938079604740',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15359590811','\n15359590811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938079604741',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959119986','\n13959119986','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938083799042',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13178336506','\n13178336506','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938083799043',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13600703008','\n13600703008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938083799044',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505951467','\n13505951467','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938083799045',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n14759154723','\n14759154723','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938083799046',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15141327771','\n15141327771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938083799047',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599949096','\n13599949096','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938083799048',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980000372','\n15980000372','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938087993346',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905089834','\n13905089834','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938087993347',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965687332','\n18965687332','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938087993348',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959951039','\n13959951039','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938087993349',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960259639','\n13960259639','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938087993350',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18250155553','\n18250155553','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938087993351',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18359714502','\n18359714502','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938087993352',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965687331','\n18965687331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938092187650',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905085845','\n13905085845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938092187651',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980060559','\n15980060559','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938092187652',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960359859','\n13960359859','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938092187653',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965523733','\n18965523733','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938092187654',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17759991213','\n17759991213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938092187655',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959579818','\n15959579818','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938092187656',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18262283166','\n18262283166','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938096381954',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059719567','\n15059719567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938096381955',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505008588','\n13505008588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938121547777',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15029265211','\n15029265211','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938125742082',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18650908918','\n18650908918','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938125742083',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980000359','\n15980000359','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938125742084',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15960402869','\n15960402869','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938125742085',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18829340451','\n18829340451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938125742086',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17755092627','\n17755092627','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938129936386',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960256299','\n13960256299','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938129936387',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15559110466','\n15559110466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938129936388',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15191845928','\n15191845928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938129936389',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13122120652','\n13122120652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938129936390',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15191815436','\n15191815436','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938129936391',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980000660','\n15980000660','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938129936392',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959264368','\n13959264368','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938134130690',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15080318157','\n15080318157','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938134130691',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060823577','\n15060823577','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938134130692',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659066928','\n18659066928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938134130693',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18559472664','\n18559472664','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938134130694',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18150591518','\n18150591518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938134130695',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18722290558','\n18722290558','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938138324994',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13636950764','\n13636950764','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938138324995',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860752060','\n13860752060','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938138324996',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13328555097','\n13328555097','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938138324997',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18539456470','\n18539456470','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938138324998',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17759892862','\n17759892862','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938142519298',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876272213','\n18876272213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938142519299',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13669274728','\n13669274728','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938142519300',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18829298483','\n18829298483','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938142519301',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659003978','\n18659003978','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938142519302',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13313825373','\n13313825373','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938142519303',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18250850010','\n18250850010','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938171879425',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959517575','\n15959517575','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938176073730',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906095618','\n13906095618','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938176073731',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13559554933','\n13559554933','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938176073732',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15389303652','\n15389303652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938176073733',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505986964','\n13505986964','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938176073734',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18740431050','\n18740431050','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938176073735',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805955751','\n15805955751','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938176073736',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505050069','\n13505050069','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938180268034',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13649283497','\n13649283497','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938180268035',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959590927','\n15959590927','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938180268036',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18759919815','\n18759919815','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938180268037',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13314987388','\n13314987388','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938180268038',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18065606507','\n18065606507','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938180268039',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15759496852','\n15759496852','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938180268040',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059556400','\n15059556400','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938184462337',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859996145','\n18859996145','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938184462338',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18192276329','\n18192276329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938184462339',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13400808814','\n13400808814','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938184462340',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15759590781','\n15759590781','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938184462341',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15960753968','\n15960753968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938184462342',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15315563156','\n15315563156','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938184462343',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13614268392','\n13614268392','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656642',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13665959771','\n13665959771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656643',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906903291','\n13906903291','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656644',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18705052323','\n18705052323','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656645',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18701704136','\n18701704136','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656646',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18898408023','\n18898408023','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656647',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18506966086','\n18506966086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656648',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959505915','\n15959505915','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938188656649',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505932929','\n13505932929','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938213822466',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15702950980','\n15702950980','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938218016769',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18159276351','\n18159276351','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938218016770',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960282791','\n13960282791','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938218016771',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799552053','\n13799552053','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938218016772',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13626066721','\n13626066721','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938222211073',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18806028372','\n18806028372','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938222211074',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13030981560','\n13030981560','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938222211075',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18605914467','\n18605914467','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938222211076',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259223745','\n15259223745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938222211077',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659568811','\n18659568811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938222211078',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15559544571','\n15559544571','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938222211079',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18065525518','\n18065525518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938226405378',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17750792370','\n17750792370','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938226405379',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959873463','\n15959873463','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938226405380',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506054328','\n13506054328','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938226405381',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15759733818','\n15759733818','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938226405382',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15191815139','\n15191815139','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938226405383',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15860902967','\n15860902967','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938226405384',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13067154015','\n13067154015','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599682',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059850519','\n15059850519','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599683',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18392859639','\n18392859639','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599684',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13484917236','\n13484917236','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599685',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15029140185','\n15029140185','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599686',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13328500766','\n13328500766','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599687',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799557193','\n13799557193','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599688',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905055474','\n13905055474','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938230599689',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18606985861','\n18606985861','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938234793985',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876223641','\n18876223641','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938234793986',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13788869420','\n13788869420','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938234793987',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18606056998','\n18606056998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938259959810',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15903645816','\n15903645816','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938264154114',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659719331','\n18659719331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938264154115',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659003000','\n18659003000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938264154116',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506969315','\n13506969315','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938264154117',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13313872221','\n13313872221','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938268348417',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13328989299','\n13328989299','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938268348418',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260704530','\n15260704530','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938268348419',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799564888','\n13799564888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938268348420',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18350770992','\n18350770992','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938268348421',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15659512626','\n15659512626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938268348422',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905089465','\n13905089465','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938268348423',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15559067588','\n15559067588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938272542721',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18603006276','\n18603006276','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938272542722',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959953589','\n13959953589','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938272542723',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13489858089','\n13489858089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938272542724',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13400840823','\n13400840823','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938272542725',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13805957117','\n13805957117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938272542726',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960311095','\n13960311095','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938272542727',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860750864','\n13860750864','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737025',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13808556705','\n13808556705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737026',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13256678813','\n13256678813','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737027',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13072350035','\n13072350035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737028',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905957105','\n13905957105','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737029',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506928380','\n13506928380','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737030',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905050688','\n15905050688','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737031',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13805959366','\n13805959366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938276737032',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15202404290','\n15202404290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938280931330',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15821998683','\n15821998683','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938280931331',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15029279845','\n15029279845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938280931332',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15111982965','\n15111982965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938306097153',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15979017673','\n15979017673','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938310291457',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15620636649','\n15620636649','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938310291458',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13484540329','\n13484540329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938310291459',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18316739194','\n18316739194','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938310291460',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18359877950','\n18359877950','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938310291461',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13488103520','\n13488103520','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938310291462',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259519391','\n15259519391','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938310291463',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15202427957','\n15202427957','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938314485762',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13501115138','\n13501115138','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938314485763',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959581739','\n15959581739','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938314485764',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18850496760','\n18850496760','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938314485765',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13572104402','\n13572104402','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938314485766',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15527179406','\n15527179406','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938314485767',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659262866','\n18659262866','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938314485768',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15985751705','\n15985751705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680065',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799898116','\n13799898116','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680066',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805010196','\n15805010196','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680067',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505056755','\n13505056755','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680068',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506069249','\n13506069249','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680069',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906998897','\n13906998897','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680070',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13696900561','\n13696900561','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680071',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13774878631','\n13774878631','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938318680072',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599161927','\n13599161927','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938322874369',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15759653345','\n15759653345','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938322874370',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18516970130','\n18516970130','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938322874371',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18046311397','\n18046311397','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938322874372',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18292635234','\n18292635234','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938322874373',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15029278847','\n15029278847','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938322874374',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15029236362','\n15029236362','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938322874375',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13920285434','\n13920285434','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938348040194',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15829907184','\n15829907184','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938352234497',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13489848301','\n13489848301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938352234498',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13625959920','\n13625959920','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938352234499',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13808549828','\n13808549828','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938352234500',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950238890','\n13950238890','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938352234501',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13004886898','\n13004886898','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938356428801',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599936037','\n13599936037','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938356428802',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13612150403','\n13612150403','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938356428803',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13720852551','\n13720852551','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938356428804',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13410024480','\n13410024480','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938356428805',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13600738975','\n13600738975','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938356428806',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599127767','\n13599127767','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938356428807',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13659192458','\n13659192458','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623106',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060832111','\n15060832111','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623107',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13788811853','\n13788811853','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623108',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060998567','\n15060998567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623109',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13850799806','\n13850799806','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623110',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15623564761','\n15623564761','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623111',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959553375','\n15959553375','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623112',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13459562051','\n13459562051','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938360623113',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15605003638','\n15605003638','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938364817410',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905996868','\n15905996868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938364817411',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15080421696','\n15080421696','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938364817412',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905095955','\n15905095955','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938364817413',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13512216307','\n13512216307','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938364817414',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17706067083','\n17706067083','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938364817415',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13559532808','\n13559532808','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938364817416',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15859495050','\n15859495050','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938369011714',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980036243','\n15980036243','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938369011715',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805952318','\n15805952318','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938394177537',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799239878','\n13799239878','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938394177538',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880931696','\n15880931696','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371842',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13600751875','\n13600751875','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371843',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13859775220','\n13859775220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371844',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905006716','\n15905006716','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371845',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13055667605','\n13055667605','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371846',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13850777555','\n13850777555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371847',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18350062033','\n18350062033','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371848',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13625994626','\n13625994626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938398371849',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18359837870','\n18359837870','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938402566145',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860763453','\n13860763453','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938402566146',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13004800144','\n13004800144','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938402566147',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13850777672','\n13850777672','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938402566148',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18059983988','\n18059983988','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1377911938402566149',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799240204','\n13799240204','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938402566150',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13636903309','\n13636903309','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938402566151',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905971030','\n13905971030','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760449',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959596201','\n15959596201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760450',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13515055988','\n13515055988','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760451',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959888180','\n15959888180','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760452',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799850617','\n13799850617','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760453',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13774877242','\n13774877242','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760454',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13850772504','\n13850772504','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760455',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13808512082','\n13808512082','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938406760456',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13615940087','\n13615940087','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938410954753',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959926888','\n13959926888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938410954754',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13559591215','\n13559591215','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938410954755',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059557916','\n15059557916','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938410954756',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260399516','\n15260399516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938410954757',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950108669','\n13950108669','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938436120578',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799797017','\n13799797017','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938440314882',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13850755588','\n13850755588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938440314883',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505992220','\n13505992220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938440314884',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15985905430','\n15985905430','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938440314885',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959941521','\n13959941521','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938440314886',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860703356','\n13860703356','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938440314887',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18633637251','\n18633637251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938444509185',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959910000','\n13959910000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938444509186',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880881006','\n15880881006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938444509187',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18959996388','\n18959996388','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938444509188',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13489719977','\n13489719977','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938444509189',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15906066156','\n15906066156','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938444509190',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18815985602','\n18815985602','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938444509191',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959592127','\n15959592127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703489',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18950026794','\n18950026794','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703490',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13859989821','\n13859989821','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703491',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506045449','\n13506045449','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703492',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18750931024','\n18750931024','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703493',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960391700','\n13960391700','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703494',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960459977','\n13960459977','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703495',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876539791','\n18876539791','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938448703496',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15860302368','\n15860302368','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938452897793',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505961108','\n13505961108','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938452897794',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659060047','\n18659060047','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938452897795',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599994541','\n13599994541','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938452897796',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13559045209','\n13559045209','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938452897797',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980065535','\n15980065535','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938452897798',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260101691','\n15260101691','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938452897799',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18759508729','\n18759508729','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938457092098',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799896025','\n13799896025','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938482257921',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906934045','\n13906934045','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938482257922',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18905951960','\n18905951960','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938482257923',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880161129','\n15880161129','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938482257924',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599507077','\n13599507077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938486452226',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950299290','\n13950299290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938486452227',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505907585','\n13505907585','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938486452228',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260852001','\n15260852001','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938486452229',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15601588313','\n15601588313','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938486452230',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506066359','\n13506066359','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938486452231',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13799899315','\n13799899315','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938486452232',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860703516','\n13860703516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646529',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980456333','\n15980456333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646530',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506083126','\n13506083126','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646531',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15005936026','\n15005936026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646532',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060806451','\n15060806451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646533',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13905350771','\n13905350771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646534',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959752857','\n13959752857','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646535',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15859796399','\n15859796399','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938490646536',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059832543','\n15059832543','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938494840833',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18150983366','\n18150983366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938494840834',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15359493923','\n15359493923','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938494840835',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980235626','\n15980235626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938494840836',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13959882723','\n13959882723','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938494840837',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15074870926','\n15074870926','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938494840838',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659737170','\n18659737170','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938494840839',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15106087765','\n15106087765','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938499035137',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13774898032','\n13774898032','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938499035138',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13110816682','\n13110816682','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938499035139',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15659450305','\n15659450305','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938499035140',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13675930836','\n13675930836','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938524200962',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18650917845','\n18650917845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938528395266',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15505952026','\n15505952026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938528395267',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18850547191','\n18850547191','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938528395268',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950362316','\n13950362316','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938528395269',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13788852001','\n13788852001','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938528395270',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13685910527','\n13685910527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938528395271',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15083847155','\n15083847155','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938528395272',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15106037664','\n15106037664','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589569',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13615922291','\n13615922291','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589570',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18965636930','\n18965636930','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589571',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960296362','\n13960296362','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589572',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13063191843','\n13063191843','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589573',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15911052916','\n15911052916','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589574',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506062515','\n13506062515','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589575',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259555117','\n15259555117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938532589576',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659822922','\n18659822922','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938536783874',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13520554703','\n13520554703','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938536783875',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13655601013','\n13655601013','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938536783876',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15806036626','\n15806036626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938536783877',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15080417163','\n15080417163','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938536783878',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15827609588','\n15827609588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938536783879',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880825431','\n15880825431','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938536783880',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859785085','\n18859785085','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938540978177',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13159012670','\n13159012670','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938540978178',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15359383458','\n15359383458','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938540978179',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18259060411','\n18259060411','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938540978180',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13075877415','\n13075877415','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938540978181',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905076266','\n15905076266','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938540978182',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980271486','\n15980271486','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938540978183',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13110592357','\n13110592357','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938566144001',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15859775715','\n15859775715','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938566144002',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860631416','\n13860631416','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938570338306',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15392481724','\n15392481724','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938570338307',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880975265','\n15880975265','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938570338308',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15860328381','\n15860328381','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938570338309',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060933526','\n15060933526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938570338310',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18605001313','\n18605001313','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938570338311',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18225662357','\n18225662357','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938570338312',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18905080205','\n18905080205','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532610',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506057070','\n13506057070','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532611',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18250292550','\n18250292550','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532612',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060985107','\n15060985107','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532613',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18050056871','\n18050056871','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532614',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15060032495','\n15060032495','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532615',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860726225','\n13860726225','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532616',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18159235825','\n18159235825','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938574532617',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18350535110','\n18350535110','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938578726913',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13121833855','\n13121833855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938578726914',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15980063533','\n15980063533','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938578726915',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13860143467','\n13860143467','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938578726916',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260237093','\n15260237093','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938578726917',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13960250701','\n13960250701','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938578726918',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15859468355','\n15859468355','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938578726919',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599505962','\n13599505962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938582921217',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259471016','\n15259471016','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938582921218',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18559273254','\n18559273254','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938582921219',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18950070276','\n18950070276','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938582921220',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13404252272','\n13404252272','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938582921221',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15259729821','\n15259729821','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938582921222',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18350505757','\n18350505757','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938612281345',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059823968','\n15059823968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938612281346',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13407735197','\n13407735197','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938612281347',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n17715205257','\n17715205257','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938612281348',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15326179637','\n15326179637','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938612281349',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15860301827','\n15860301827','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938616475649',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905057579','\n15905057579','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938616475650',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18060501876','\n18060501876','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938616475651',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880758500','\n15880758500','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938616475652',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15960581457','\n15960581457','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938616475653',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13400887176','\n13400887176','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938616475654',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18050020726','\n18050020726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938616475655',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13459246092','\n13459246092','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669953',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13055224466','\n13055224466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669954',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15106033846','\n15106033846','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669955',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13627292269','\n13627292269','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669956',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880990268','\n15880990268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669957',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18698399527','\n18698399527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669958',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13599719905','\n13599719905','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669959',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15846593350','\n15846593350','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938620669960',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18314463516','\n18314463516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864257',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950364429','\n13950364429','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864258',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805026065','\n15805026065','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864259',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18750530127','\n18750530127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864260',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950092022','\n13950092022','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864261',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15810298887','\n15810298887','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864262',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260200619','\n15260200619','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864263',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059755771','\n15059755771','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938624864264',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15827436094','\n15827436094','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938629058562',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13459533442','\n13459533442','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938629058563',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13696856720','\n13696856720','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938654224385',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15159887877','\n15159887877','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938654224386',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505008000','\n13505008000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938654224387',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880754887','\n15880754887','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938654224388',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15059510022','\n15059510022','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938658418689',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15880818089','\n15880818089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938658418690',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18606031846','\n18606031846','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938658418691',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18698360960','\n18698360960','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938658418692',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13689056004','\n13689056004','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938658418693',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13085059001','\n13085059001','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938658418694',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905070935','\n15905070935','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938658418695',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15805003589','\n15805003589','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662612994',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15859554650','\n15859554650','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662612995',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15260720911','\n15260720911','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662612996',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18859498656','\n18859498656','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662612997',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876284599','\n18876284599','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662612998',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18750537614','\n18750537614','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662612999',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18050869127','\n18050869127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662613000',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876377906','\n18876377906','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938662613001',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13950317095','\n13950317095','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938666807297',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15905055709','\n15905055709','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938666807298',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13159060909','\n13159060909','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938666807299',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15201615843','\n15201615843','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938666807300',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18876240048','\n18876240048','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938666807301',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18065589080','\n18065589080','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938666807302',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505054724','\n13505054724','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938666807303',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18805921912','\n18805921912','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938671001602',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18835792826','\n18835792826','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938671001603',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15906061807','\n15906061807','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938671001604',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18659923130','\n18659923130','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938671001605',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15859565605','\n15859565605','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938696167425',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18682261122','\n18682261122','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938696167426',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15159724662','\n15159724662','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938696167427',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18698372705','\n18698372705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938696167428',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13906998716','\n13906998716','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361730',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15860900865','\n15860900865','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361731',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18815997296','\n18815997296','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361732',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959232693','\n15959232693','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361733',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18159595252','\n18159595252','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361734',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18215628161','\n18215628161','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361735',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13505990915','\n13505990915','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361736',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13779982480','\n13779982480','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938700361737',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13615963766','\n13615963766','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938704556033',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15959966729','\n15959966729','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938704556034',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13825584576','\n13825584576','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938704556035',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15122460079','\n15122460079','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938704556036',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13788803006','\n13788803006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938704556037',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18722334354','\n18722334354','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938704556038',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n13506061896','\n13506061896','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938704556039',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n18202655266','\n18202655266','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377911938708750338',NULL,'1377911937173635074',2,2,'批量发送(津补贴申报截止提醒120210402)','\n15922263220\n','\n15922263220\n','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL,'2021-04-02 17:13:00',NULL,NULL,NULL),('1377916267977064450',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','18581998214','18581998214','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267981258754',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','15059839423','15059839423','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267985453057',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','13600759390','13600759390','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267985453058',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860358661','\n15860358661','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267985453059',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18559511816','\n18559511816','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267985453060',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13275049035','\n13275049035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267985453061',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13030982553','\n13030982553','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267985453062',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18559552007','\n18559552007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267985453063',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959264462','\n15959264462','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267989647362',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599710039','\n13599710039','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267989647363',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15559528807','\n15559528807','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267989647364',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799239129','\n13799239129','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267989647365',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880027485','\n15880027485','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267989647366',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18292491251','\n18292491251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267989647367',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15159739903','\n15159739903','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267989647368',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859781366','\n18859781366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267993841666',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13706991487','\n13706991487','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267993841667',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18006037070','\n18006037070','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267993841668',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13055336977','\n13055336977','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267993841669',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18906999069','\n18906999069','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267993841670',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876569027','\n18876569027','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267998035970',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859553823','\n15859553823','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267998035971',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15906066000','\n15906066000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267998035972',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980274172','\n15980274172','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267998035973',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506998846','\n13506998846','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267998035974',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960259810','\n13960259810','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267998035975',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876539839','\n18876539839','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916267998035976',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659069495','\n18659069495','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268002230273',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18006990697','\n18006990697','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268002230274',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15280404202','\n15280404202','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268002230275',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13328979519','\n13328979519','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268031590402',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959812033','\n13959812033','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268035784706',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15159790586','\n15159790586','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268035784707',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18350776066','\n18350776066','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268035784708',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18868801836','\n18868801836','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268039979009',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13859085700','\n13859085700','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268039979010',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859716793','\n18859716793','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268039979011',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15806017885','\n15806017885','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268039979012',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15805956361','\n15805956361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268039979013',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880480928','\n15880480928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268039979014',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980232523','\n15980232523','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268039979015',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13635240509','\n13635240509','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268044173314',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15259758239','\n15259758239','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268044173315',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18046040451','\n18046040451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268044173316',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18250882613','\n18250882613','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268044173317',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18805025309','\n18805025309','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268044173318',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18965513668','\n18965513668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268044173319',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18046009745','\n18046009745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268044173320',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13055650678','\n13055650678','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268048367618',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960254757','\n13960254757','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268048367619',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15806019077','\n15806019077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268048367620',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505097888','\n13505097888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268048367621',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599106745','\n13599106745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268048367622',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15160441962','\n15160441962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268048367623',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959717283','\n13959717283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268048367624',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13636959434','\n13636959434','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268052561921',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960746554','\n15960746554','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268052561922',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905985743','\n13905985743','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268052561923',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905079763','\n13905079763','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268052561924',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599978051','\n13599978051','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268052561925',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15280422458','\n15280422458','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268077727745',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13906099550','\n13906099550','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268081922050',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13685000414','\n13685000414','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268081922051',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13665001804','\n13665001804','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268081922052',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18960877567','\n18960877567','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268081922053',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759296423','\n15759296423','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268086116353',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959552577','\n15959552577','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268086116354',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876568900','\n18876568900','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268086116355',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15205011506','\n15205011506','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268086116356',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18605007853','\n18605007853','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268086116357',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18250422227','\n18250422227','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268086116358',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18606942212','\n18606942212','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268086116359',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13067198079','\n13067198079','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310658',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18950490831','\n18950490831','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310659',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13400539210','\n13400539210','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310660',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959530855','\n15959530855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310661',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18825160801','\n18825160801','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310662',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13163906685','\n13163906685','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310663',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18817333998','\n18817333998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310664',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15705923619','\n15705923619','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268090310665',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559546275','\n13559546275','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268094504962',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980478011','\n15980478011','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268094504963',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15259597676','\n15259597676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268094504964',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18559672261','\n18559672261','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268094504965',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18862155979','\n18862155979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268094504966',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659097395','\n18659097395','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268094504967',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15259727676','\n15259727676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268094504968',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15606087056','\n15606087056','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268098699266',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18782977456','\n18782977456','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268098699267',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13906091302','\n13906091302','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268098699268',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n17705061101','\n17705061101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268123865089',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15985900838','\n15985900838','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268123865090',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13615926622','\n13615926622','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268123865091',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959990198','\n15959990198','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268128059394',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15260225737','\n15260225737','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268128059395',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905079280','\n13905079280','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268128059396',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13606021816','\n13606021816','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268128059397',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980056221','\n15980056221','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268128059398',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805997206','\n13805997206','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268128059399',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489887652','\n13489887652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268128059400',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506009833','\n13506009833','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253698',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18703659101','\n18703659101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253699',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13646031399','\n13646031399','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253700',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599177919','\n13599177919','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253701',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13696857207','\n13696857207','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253702',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805941850','\n13805941850','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253703',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15392121201','\n15392121201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253704',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505905685','\n13505905685','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268132253705',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959981231','\n18959981231','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268136448002',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959952350','\n13959952350','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268136448003',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489512117','\n13489512117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268136448004',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759500600','\n15759500600','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268136448005',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959921098','\n13959921098','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268136448006',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799870758','\n13799870758','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268136448007',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13850753398','\n13850753398','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268136448008',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980025829','\n15980025829','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268140642306',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799855086','\n13799855086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268140642307',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959599793','\n15959599793','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268140642308',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13242884288','\n13242884288','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268140642309',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559550686','\n13559550686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268140642310',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805951761','\n13805951761','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268170002434',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15710646360','\n15710646360','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268170002435',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15260838513','\n15260838513','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268170002436',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600704238','\n13600704238','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196737',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13316225195','\n13316225195','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196738',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13860708740','\n13860708740','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196739',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15805972719','\n15805972719','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196740',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960257652','\n13960257652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196741',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18050888018','\n18050888018','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196742',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15080426614','\n15080426614','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196743',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959975903','\n13959975903','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268174196744',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18750651805','\n18750651805','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268178391042',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659005089','\n18659005089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268178391043',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506095562','\n13506095562','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268178391044',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13665903960','\n13665903960','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268178391045',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960256111','\n13960256111','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268178391046',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13601076764','\n13601076764','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268178391047',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18905060268','\n18905060268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268182585346',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15377953096','\n15377953096','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268182585347',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13788826386','\n13788826386','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268182585348',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13459523253','\n13459523253','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268182585349',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18965667777','\n18965667777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268182585350',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489512136','\n13489512136','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268182585351',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13107880950','\n13107880950','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268182585352',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15750898928','\n15750898928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268186779649',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18950498312','\n18950498312','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268186779650',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15375886386','\n15375886386','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268186779651',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13400507028','\n13400507028','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268186779652',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13587756546','\n13587756546','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268186779653',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959737339','\n13959737339','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268186779654',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659916888','\n18659916888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268216139778',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859525583','\n18859525583','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268220334082',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506059007','\n13506059007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268220334083',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505955666','\n13505955666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268220334084',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18759922187','\n18759922187','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268220334085',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505902557','\n13505902557','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268224528386',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13636951165','\n13636951165','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268224528387',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859590857','\n15859590857','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268224528388',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13850757007','\n13850757007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268224528389',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805957070','\n13805957070','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268224528390',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13860602468','\n13860602468','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268224528391',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13305962813','\n13305962813','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268224528392',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859225776','\n18859225776','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268228722690',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13661356074','\n13661356074','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268228722691',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13645019389','\n13645019389','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268228722692',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600788662','\n13600788662','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268228722693',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18030243370','\n18030243370','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268228722694',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18344910844','\n18344910844','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268228722695',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18059147928','\n18059147928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268228722696',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15260708136','\n15260708136','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268232916993',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880824003','\n15880824003','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268232916994',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18259061182','\n18259061182','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268232916995',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799857333','\n13799857333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268232916996',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13365952758','\n13365952758','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268232916997',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805951603','\n13805951603','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268232916998',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15375754488','\n15375754488','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268232916999',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13918199745','\n13918199745','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268237111298',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859577777','\n15859577777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268237111299',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059597777','\n15059597777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268237111300',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15606946335','\n15606946335','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268237111301',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805997578','\n13805997578','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268262277121',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599751999','\n13599751999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268266471425',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13906099845','\n13906099845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268266471426',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059720864','\n15059720864','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268266471427',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15620633941','\n15620633941','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268266471428',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18396220746','\n18396220746','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268266471429',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18559477701','\n18559477701','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268266471430',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13605944765','\n13605944765','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268266471431',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808552366','\n13808552366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268270665730',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13655928585','\n13655928585','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268270665731',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13386880667','\n13386880667','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268270665732',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959882366','\n15959882366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268270665733',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13788833384','\n13788833384','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268270665734',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13338583366','\n13338583366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268270665735',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960250972','\n15960250972','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268270665736',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505905737','\n13505905737','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268274860033',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15280081010','\n15280081010','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268274860034',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13788805366','\n13788805366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268274860035',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559369710','\n13559369710','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268274860036',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13067166871','\n13067166871','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268274860037',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600785508','\n13600785508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268274860038',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805065379','\n13805065379','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268274860039',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13459218283','\n13459218283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268279054337',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18005073259','\n18005073259','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268279054338',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18005065560','\n18005065560','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268279054339',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13107891508','\n13107891508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268279054340',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15605959006','\n15605959006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268279054341',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13645971717','\n13645971717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268279054342',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15396503999','\n15396503999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268279054343',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18705045726','\n18705045726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268283248642',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18050270931','\n18050270931','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268312608770',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n17758766631','\n17758766631','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268312608771',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15071360501','\n15071360501','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268312608772',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13305952629','\n13305952629','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268316803073',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15659132085','\n15659132085','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268316803074',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13400886486','\n13400886486','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268316803075',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15305009255','\n15305009255','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268316803076',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15080406979','\n15080406979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268316803077',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18359592597','\n18359592597','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268316803078',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18050916965','\n18050916965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268316803079',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18050876301','\n18050876301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268320997377',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15905903705','\n15905903705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268320997378',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13328505767','\n13328505767','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268320997379',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799866661','\n13799866661','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268320997380',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13285957289','\n13285957289','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268320997381',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15396596855','\n15396596855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268320997382',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559513508','\n13559513508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268320997383',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13229424859','\n13229424859','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191682',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13645032611','\n13645032611','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191683',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059154896','\n15059154896','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191684',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18650591551','\n18650591551','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191685',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18965662565','\n18965662565','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191686',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759216753','\n15759216753','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191687',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960217968','\n15960217968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191688',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960326290','\n13960326290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268325191689',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18905051668','\n18905051668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268329385986',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13159037366','\n13159037366','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268329385987',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600703555','\n13600703555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268329385988',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489387611','\n13489387611','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268329385989',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15060619686','\n15060619686','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268329385990',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18084725997','\n18084725997','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268358746113',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13901318357','\n13901318357','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268362940417',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13295908788','\n13295908788','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268362940418',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13328883775','\n13328883775','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268362940419',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600704026','\n13600704026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268362940420',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18030041938','\n18030041938','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268362940421',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18159338898','\n18159338898','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268367134722',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959989905','\n13959989905','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268367134723',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15995216889','\n15995216889','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268367134724',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059821270','\n15059821270','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268367134725',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13850728390','\n13850728390','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268367134726',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13906091693','\n13906091693','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268367134727',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808557909','\n13808557909','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268367134728',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18072769019','\n18072769019','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268371329026',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599921781','\n13599921781','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268371329027',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659091166','\n18659091166','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268371329028',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859757978','\n18859757978','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268371329029',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759599327','\n15759599327','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268371329030',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15906068079','\n15906068079','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268371329031',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505962962','\n13505962962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268371329032',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505955680','\n13505955680','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523330',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18960251008','\n18960251008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523331',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860509861','\n15860509861','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523332',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960295758','\n15960295758','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523333',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13788806309','\n13788806309','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523334',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959996652','\n18959996652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523335',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059750761','\n15059750761','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523336',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959522909','\n15959522909','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268375523337',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659516267','\n18659516267','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268379717633',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13950287905','\n13950287905','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268379717634',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18965526351','\n18965526351','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268404883457',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960270097','\n13960270097','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268409077762',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13950175990','\n13950175990','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268409077763',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559421422','\n13559421422','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268409077764',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13788800635','\n13788800635','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268409077765',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18065955602','\n18065955602','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268409077766',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13806060409','\n13806060409','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268413272065',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859933888','\n18859933888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268413272066',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n17727971605','\n17727971605','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268413272067',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13705011089','\n13705011089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268413272068',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18750597755','\n18750597755','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268413272069',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980005213','\n15980005213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268413272070',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13588114500','\n13588114500','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268413272071',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15106035553','\n15106035553','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268417466369',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15392271725','\n15392271725','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268417466370',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905966797','\n13905966797','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268417466371',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13055620088','\n13055620088','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268417466372',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859791928','\n15859791928','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268417466373',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13645976990','\n13645976990','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268417466374',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15750783120','\n15750783120','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268421660673',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599781990','\n13599781990','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268421660674',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959566799','\n15959566799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268421660675',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13306995198','\n13306995198','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268421660676',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13400848317','\n13400848317','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268421660677',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15905984868','\n15905984868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268421660678',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15201587824','\n15201587824','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268425854977',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15060000306','\n15060000306','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268425854978',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15891723537','\n15891723537','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268425854979',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808518434','\n13808518434','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268425854980',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805901476','\n13805901476','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268425854981',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980009090','\n15980009090','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268451020801',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505903824','\n13505903824','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268455215105',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859530042','\n18859530042','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268455215106',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808558323','\n13808558323','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268455215107',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13850757884','\n13850757884','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268459409409',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18765863215','\n18765863215','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268459409410',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13233863311','\n13233863311','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268459409411',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489316674','\n13489316674','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268459409412',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659919980','\n18659919980','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268459409413',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15057898570','\n15057898570','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268459409414',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659003872','\n18659003872','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268459409415',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15359727981','\n15359727981','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268463603713',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959773710','\n13959773710','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268463603714',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13515050886','\n13515050886','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268463603715',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506903117','\n13506903117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268463603716',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13225957141','\n13225957141','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268463603717',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18649949741','\n18649949741','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268463603718',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759507886','\n15759507886','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268467798018',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759552267','\n15759552267','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268467798019',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13908098781','\n13908098781','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268467798020',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805928096','\n13805928096','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268467798021',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18960183028','\n18960183028','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268467798022',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13305973798','\n13305973798','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268467798023',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659803842','\n18659803842','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268467798024',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13774648357','\n13774648357','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268471992322',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799505750','\n13799505750','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268471992323',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805943888','\n13805943888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268471992324',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15160418919','\n15160418919','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268471992325',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13907259322','\n13907259322','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268471992326',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15159593606','\n15159593606','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268471992327',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15280871258','\n15280871258','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268501352450',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959996091','\n18959996091','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268501352451',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505940442','\n13505940442','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268501352452',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15060000939','\n15060000939','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268505546753',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n17750971868','\n17750971868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268505546754',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18960410787','\n18960410787','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268505546755',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15559050207','\n15559050207','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268505546756',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18906997782','\n18906997782','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268505546757',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959885072','\n15959885072','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268505546758',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959885071','\n15959885071','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268505546759',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959995202','\n18959995202','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268509741057',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959508318','\n15959508318','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268509741058',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13901217030','\n13901217030','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268509741059',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489545332','\n13489545332','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268509741060',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15985992783','\n15985992783','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268509741061',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15259175127','\n15259175127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268509741062',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959551888','\n15959551888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268509741063',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859210518','\n18859210518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268513935361',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13860748042','\n13860748042','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268513935362',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15711509473','\n15711509473','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268513935363',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980006865','\n15980006865','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268513935364',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13459315586','\n13459315586','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268513935365',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959857934','\n13959857934','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268513935366',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18650675858','\n18650675858','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268513935367',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15260875781','\n15260875781','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268518129665',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860513396','\n15860513396','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268518129666',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659811117','\n18659811117','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268518129667',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959599590','\n15959599590','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268518129668',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959994811','\n15959994811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268518129669',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15060816666','\n15060816666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268518129670',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489990595','\n13489990595','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268543295489',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876383640','\n18876383640','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268547489794',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18605956664','\n18605956664','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268547489795',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18883111607','\n18883111607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268547489796',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506941256','\n13506941256','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268547489797',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960271385','\n13960271385','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268551684098',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13004856578','\n13004856578','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268551684099',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15129486503','\n15129486503','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268551684100',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880750160','\n15880750160','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268551684101',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959010902','\n18959010902','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268551684102',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13459573303','\n13459573303','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268551684103',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18606986888','\n18606986888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268551684104',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18606985868','\n18606985868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878401',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859559516','\n15859559516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878402',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18606985869','\n18606985869','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878403',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13636951175','\n13636951175','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878404',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15659203602','\n15659203602','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878405',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13509397968','\n13509397968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878406',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859506607','\n15859506607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878407',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599168201','\n13599168201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268555878408',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559445905','\n13559445905','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268560072705',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659120968','\n18659120968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268560072706',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15905958001','\n15905958001','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268560072707',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959237079','\n18959237079','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268560072708',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13655098365','\n13655098365','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268560072709',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980270669','\n15980270669','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268560072710',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13178114650','\n13178114650','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268560072711',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13850100395','\n13850100395','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268564267010',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599398272','\n13599398272','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268564267011',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18020881775','\n18020881775','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268564267012',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960074890','\n15960074890','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268589432833',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959111811','\n18959111811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268593627137',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15905912099','\n15905912099','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268593627138',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18059869884','\n18059869884','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268597821442',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799241311','\n13799241311','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268597821443',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506060430','\n13506060430','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268597821444',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13205074996','\n13205074996','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268597821445',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505958627','\n13505958627','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268597821446',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960759601','\n15960759601','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268597821447',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505057557','\n13505057557','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268597821448',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506055960','\n13506055960','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268602015746',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18683138068','\n18683138068','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268602015747',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13074992803','\n13074992803','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268602015748',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600708564','\n13600708564','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268602015749',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959982171','\n15959982171','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268602015750',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599176042','\n13599176042','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268602015751',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13859755349','\n13859755349','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268602015752',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15396317185','\n15396317185','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268606210049',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489767598','\n13489767598','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268606210050',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905072451','\n13905072451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268606210051',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960775979','\n15960775979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268606210052',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15750950999','\n15750950999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268606210053',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059529817','\n15059529817','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268606210054',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18350509887','\n18350509887','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268606210055',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599111348','\n13599111348','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268610404353',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13774813569','\n13774813569','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268610404354',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659092800','\n18659092800','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268610404355',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905051776','\n13905051776','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268610404356',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059788121','\n15059788121','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268610404357',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13901806819','\n13901806819','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268610404358',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960285908','\n13960285908','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268753010690',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13998848351','\n13998848351','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268753010691',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13606979163','\n13606979163','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268757204994',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505955856','\n13505955856','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268757204995',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905979302','\n13905979302','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268757204996',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13306051592','\n13306051592','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268757204997',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959708032','\n18959708032','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268757204998',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808556408','\n13808556408','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268757204999',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18558994473','\n18558994473','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268757205000',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799899050','\n13799899050','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268761399298',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18750551999','\n18750551999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268761399299',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18242352269','\n18242352269','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268761399300',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13450801637','\n13450801637','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268761399301',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18005066989','\n18005066989','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268761399302',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959980017','\n15959980017','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268761399303',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18971581341','\n18971581341','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268761399304',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959593360','\n15959593360','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268765593602',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860929526','\n15860929526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268765593603',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13655959379','\n13655959379','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268765593604',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905075571','\n13905075571','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268765593605',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13459480239','\n13459480239','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268765593606',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859598898','\n15859598898','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268765593607',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13860736349','\n13860736349','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268765593608',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059791111','\n15059791111','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268769787905',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959598078','\n15959598078','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268769787906',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18759279125','\n18759279125','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268769787907',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15985991330','\n15985991330','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268769787908',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959944053','\n13959944053','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268769787909',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15060997885','\n15060997885','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268769787910',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13675965549','\n13675965549','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268769787911',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13338289406','\n13338289406','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268794953729',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18650708777','\n18650708777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268799148034',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859488368','\n15859488368','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268799148035',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980023645','\n15980023645','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268799148036',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13840575460','\n13840575460','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268803342338',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15505950234','\n15505950234','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268803342339',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15906086726','\n15906086726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268803342340',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959806100','\n18959806100','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268803342341',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15106011789','\n15106011789','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268803342342',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13906095080','\n13906095080','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268803342343',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13603600400','\n13603600400','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268803342344',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18957137209','\n18957137209','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536642',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860362000','\n15860362000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536643',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13215952676','\n13215952676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536644',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15141988697','\n15141988697','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536645',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959858508','\n18959858508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536646',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13685905122','\n13685905122','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536647',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13481067154','\n13481067154','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536648',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15964917281','\n15964917281','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268807536649',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15905071236','\n15905071236','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268811730945',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13400631331','\n13400631331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268811730946',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13788828099','\n13788828099','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268811730947',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15645826505','\n15645826505','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268811730948',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15710661733','\n15710661733','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268811730949',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506085037','\n13506085037','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268811730950',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860407467','\n15860407467','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268811730951',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489817872','\n13489817872','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268815925249',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980008518','\n15980008518','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268815925250',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15396656786','\n15396656786','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268815925251',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15985966262','\n15985966262','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268815925252',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505055213','\n13505055213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268841091074',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559076739','\n13559076739','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268845285377',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15840415838','\n15840415838','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268845285378',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15105955127','\n15105955127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268845285379',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13159272998','\n13159272998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268845285380',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15959858886','\n15959858886','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479682',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13110961526','\n13110961526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479683',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15347974220','\n15347974220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479684',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18965042522','\n18965042522','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479685',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15396380625','\n15396380625','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479686',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18060863322','\n18060863322','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479687',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13260186693','\n13260186693','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479688',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13152326775','\n13152326775','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268849479689',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13062446600','\n13062446600','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268853673986',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15605917025','\n15605917025','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268853673987',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n17750066666','\n17750066666','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268853673988',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13235950077','\n13235950077','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268853673989',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15750715717','\n15750715717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268853673990',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15396397231','\n15396397231','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268853673991',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13910755640','\n13910755640','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268853673992',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659597668','\n18659597668','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268857868289',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876508052','\n18876508052','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268857868290',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659596911','\n18659596911','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268857868291',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905013655','\n13905013655','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268857868292',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15985940260','\n15985940260','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268857868293',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15805967556','\n15805967556','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268857868294',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880787777','\n15880787777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268857868295',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18159138892','\n18159138892','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268862062593',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18009936110','\n18009936110','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268862062594',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13665987766','\n13665987766','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268862062595',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13123022338','\n13123022338','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268887228418',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805922890','\n13805922890','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268891422721',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808505006','\n13808505006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268891422722',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905974002','\n13905974002','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268891422723',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13850797282','\n13850797282','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268891422724',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15396562536','\n15396562536','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268891422725',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805943012','\n13805943012','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268891422726',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659505199','\n18659505199','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268891422727',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960477828','\n13960477828','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268895617026',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13591688813','\n13591688813','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268895617027',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15818712364','\n15818712364','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268895617028',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13898876321','\n13898876321','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268895617029',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489374437','\n13489374437','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268895617030',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960728823','\n15960728823','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268895617031',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13130688192','\n13130688192','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268895617032',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13779941403','\n13779941403','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268899811329',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905977597','\n13905977597','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268899811330',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15622309913','\n15622309913','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268899811331',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15659050608','\n15659050608','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268899811332',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15375771216','\n15375771216','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268899811333',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18366880003','\n18366880003','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268899811334',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n17750530050','\n17750530050','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268899811335',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13489807075','\n13489807075','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268904005634',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18912600868','\n18912600868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268904005635',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18805000987','\n18805000987','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268904005636',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15939820272','\n15939820272','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268904005637',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905981361','\n13905981361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268904005638',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13636956222','\n13636956222','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268904005639',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18976017695','\n18976017695','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268904005640',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859219269','\n18859219269','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268908199938',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18016563557','\n18016563557','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268933365761',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18342391527','\n18342391527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268933365762',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15608856832','\n15608856832','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268937560065',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960732777','\n15960732777','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268937560066',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13313880008','\n13313880008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268937560067',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506953825','\n13506953825','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268937560068',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559023528','\n13559023528','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268937560069',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13788822586','\n13788822586','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268937560070',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n17716366562','\n17716366562','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268937560071',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799888954','\n13799888954','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268941754370',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18150211016','\n18150211016','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268941754371',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659218866','\n18659218866','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268941754372',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959995205','\n18959995205','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268941754373',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960279332','\n13960279332','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268941754374',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059754283','\n15059754283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268941754375',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959305510','\n13959305510','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268941754376',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599119171','\n13599119171','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268945948674',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600778680','\n13600778680','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268945948675',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799870200','\n13799870200','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268945948676',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960376269','\n13960376269','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268945948677',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13943133715','\n13943133715','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268945948678',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13636983796','\n13636983796','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268945948679',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960238699','\n13960238699','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142978',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13959713966','\n13959713966','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142979',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960457500','\n13960457500','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142980',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880815752','\n15880815752','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142981',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15906094942','\n15906094942','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142982',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18060022322','\n18060022322','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142983',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960729985','\n15960729985','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142984',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15659605296','\n15659605296','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268950142985',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13625958406','\n13625958406','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268975308802',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599703460','\n13599703460','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268979503106',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15606978588','\n15606978588','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268979503107',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905085139','\n13905085139','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268979503108',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659936998','\n18659936998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268983697409',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13600709402','\n13600709402','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268983697410',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18050878520','\n18050878520','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268983697411',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659837707','\n18659837707','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268983697412',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15060990065','\n15060990065','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268983697413',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18717727991','\n18717727991','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268983697414',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13237964538','\n13237964538','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268983697415',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13814512607','\n13814512607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891713',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980061606','\n15980061606','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891714',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15859231310','\n15859231310','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891715',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18350770057','\n18350770057','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891716',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759559009','\n15759559009','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891717',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18811724563','\n18811724563','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891718',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18896733376','\n18896733376','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891719',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18225426199','\n18225426199','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268987891720',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959201571','\n18959201571','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268992086017',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059855555','\n15059855555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268992086018',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18106980530','\n18106980530','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268992086019',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18905953233','\n18905953233','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268992086020',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13966823479','\n13966823479','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268992086021',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15805999851','\n15805999851','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268992086022',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980853269','\n15980853269','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268992086023',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13395955061','\n13395955061','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268996280322',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15106005598','\n15106005598','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268996280323',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13290719799','\n13290719799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268996280324',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659281177','\n18659281177','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916268996280325',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13649278723','\n13649278723','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269021446145',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13055336639','\n13055336639','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269025640450',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808552442','\n13808552442','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269025640451',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13505908167','\n13505908167','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269025640452',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905077186','\n13905077186','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269025640453',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960285632','\n13960285632','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269025640454',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805957615','\n13805957615','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269025640455',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13808505700','\n13808505700','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269029834754',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960830182','\n13960830182','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269029834755',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15159639962','\n15159639962','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269029834756',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13826087143','\n13826087143','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269029834757',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13700242731','\n13700242731','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269029834758',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860351538','\n15860351538','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269029834759',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880719513','\n15880719513','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269029834760',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506032972','\n13506032972','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269034029057',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15259546326','\n15259546326','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269034029058',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15260391931','\n15260391931','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269034029059',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18559585690','\n18559585690','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269034029060',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15659035363','\n15659035363','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269034029061',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880013807','\n15880013807','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269034029062',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13313879168','\n13313879168','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269034029063',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18606061141','\n18606061141','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269038223361',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18344989075','\n18344989075','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269038223362',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15160324285','\n15160324285','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269038223363',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960208028','\n13960208028','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269038223364',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18065217618','\n18065217618','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269038223365',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18250401640','\n18250401640','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269038223366',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659015765','\n18659015765','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269038223367',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18344990362','\n18344990362','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269042417666',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559056528','\n13559056528','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269042417667',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13235950187','\n13235950187','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269067583489',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13860703568','\n13860703568','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269071777794',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15705939067','\n15705939067','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269071777795',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13665966151','\n13665966151','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269071777796',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15659606707','\n15659606707','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269071777797',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18060518242','\n18060518242','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269071777798',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805955600','\n13805955600','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269075972097',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18859594251','\n18859594251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269075972098',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506905868','\n13506905868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269075972099',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15695902293','\n15695902293','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269075972100',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15159281608','\n15159281608','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269080166401',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805530817','\n13805530817','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269080166402',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876305138','\n18876305138','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269080166403',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15860767176','\n15860767176','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269080166404',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15906091877','\n15906091877','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269080166405',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18750207251','\n18750207251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360705',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15991630558','\n15991630558','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360706',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13655021807','\n13655021807','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360707',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876209230','\n18876209230','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360708',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905964216','\n13905964216','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360709',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13672230321','\n13672230321','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360710',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15359550707','\n15359550707','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360711',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959703937','\n18959703937','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269084360712',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18905057979','\n18905057979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269088555010',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15905995161','\n15905995161','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269088555011',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506021997','\n13506021997','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269088555012',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18060475820','\n18060475820','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269088555013',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13859722739','\n13859722739','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269088555014',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15106023133','\n15106023133','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269088555015',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13950251176','\n13950251176','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269088555016',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959892616','\n18959892616','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269113720834',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13004887703','\n13004887703','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269117915137',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18876395670','\n18876395670','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269117915138',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18759519215','\n18759519215','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269117915139',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13675904007','\n13675904007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269117915140',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13348904466','\n13348904466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269122109441',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13810782015','\n13810782015','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269122109442',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599036997','\n13599036997','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269122109443',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18959708869','\n18959708869','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269122109444',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13636981157','\n13636981157','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269122109445',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599247841','\n13599247841','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269122109446',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559527997','\n13559527997','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269122109447',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18559583965','\n18559583965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303745',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13799526543','\n13799526543','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303746',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13675961121','\n13675961121','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303747',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15060461417','\n15060461417','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303748',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13132285232','\n13132285232','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303749',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880896188','\n15880896188','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303750',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15905095105','\n15905095105','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303751',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13805145645','\n13805145645','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269126303752',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13506058391','\n13506058391','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269130498050',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13906099955','\n13906099955','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269130498051',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18659592263','\n18659592263','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269130498052',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960232793','\n13960232793','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269130498053',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13599937888','\n13599937888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269130498054',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18106968679','\n18106968679','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269130498055',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15980033802','\n15980033802','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269134692353',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13685925682','\n13685925682','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269134692354',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13088852722','\n13088852722','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269134692355',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13004878129','\n13004878129','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269134692356',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18965875616','\n18965875616','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269159858177',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15759596816','\n15759596816','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269164052481',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18250199000','\n18250199000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269164052482',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13509365965','\n13509365965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269164052483',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905920592','\n13905920592','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269164052484',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15058326850','\n15058326850','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269164052485',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13559172702','\n13559172702','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269168246785',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15005028826','\n15005028826','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269168246786',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15880762340','\n15880762340','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269168246787',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905955116','\n13905955116','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269168246788',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13906926963','\n13906926963','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269168246789',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18850458762','\n18850458762','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269168246790',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18759147839','\n18759147839','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269168246791',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15960214531','\n15960214531','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269172441089',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905969901','\n13905969901','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269172441090',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13960289675','\n13960289675','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269172441091',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13636966999','\n13636966999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269172441092',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13825737189','\n13825737189','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269172441093',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18350210282','\n18350210282','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269172441094',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18359566229','\n18359566229','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269172441095',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13237076821','\n13237076821','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269176635393',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18906060102','\n18906060102','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269176635394',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13601307539','\n13601307539','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269176635395',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13601013614','\n13601013614','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269176635396',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13950493380','\n13950493380','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269176635397',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13385910089','\n13385910089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269176635398',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n13905065955','\n13905065955','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269176635399',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n18649712545','\n18649712545','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269180829697',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15106023277','\n15106023277','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377916269180829698',NULL,'1377916267494719489',2,2,'批量发送(津补贴申报截止提醒220210402)','\n15059155128','\n15059155128','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。联系电话：0595-85633128 ，0595-85662310。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL,'2021-04-02 17:30:13',NULL,NULL,NULL),('1377950380477988865',NULL,'1377950380477988865',2,1,NULL,'13959910000','773591','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 19:45:46',NULL,NULL,NULL,'2021-04-02 19:45:46',NULL,NULL,NULL),('1377950673626284034',NULL,'1377950673626284034',2,1,NULL,'18259591998','441710','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 19:46:56',NULL,NULL,NULL,'2021-04-02 19:46:56',NULL,NULL,NULL),('1377951563808587777',NULL,'1377951563808587777',2,1,NULL,'18344990362','356209','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 19:50:28',NULL,NULL,NULL,'2021-04-02 19:50:28',NULL,NULL,NULL),('1377954445626785794',NULL,'1377954445626785794',2,1,NULL,'18344990362','753078','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-02 20:01:55',NULL,NULL,NULL,'2021-04-02 20:01:55',NULL,NULL,NULL),('1378169835254530050',NULL,'1378169835254530050',2,1,NULL,'15106010099','116237','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-03 10:17:48',NULL,NULL,NULL,'2021-04-03 10:17:48',NULL,NULL,NULL),('1378176399612919809',NULL,'1378176399612919809',2,1,NULL,'19942311997','642580','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-03 10:43:53',NULL,NULL,NULL,'2021-04-03 10:43:53',NULL,NULL,NULL),('1378243281162420226',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18859971221','18859971221','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281166614529',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18250298076','18250298076','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281166614530',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13809549382','13809549382','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281166614531',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19852121931','19852121931','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281166614532',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18006037555','18006037555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281166614533',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13705943966','13705943966','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281166614534',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','1367595307','1367595307','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'错误的电话号码','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281170808834',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13805919195','13805919195','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'未知错误','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281170808835',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15392288855','15392288855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281170808836',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13599717008','13599717008','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281170808837',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15260429705','15260429705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281170808838',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13959778888','13959778888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281170808839',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13205061526','13205061526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281170808840',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15345952654','15345952654','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281175003137',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19859453365','19859453365','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281175003138',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15086777305','15086777305','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'空号','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281175003139',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17689683160','17689683160','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281175003140',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18859757759','18859757759','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281175003141',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13860116953','13860116953','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281175003142',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17359711663','17359711663','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281175003143',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18250169959','18250169959','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281179197442',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18876336921','18876336921','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281179197443',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18965785175','18965785175','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281179197444',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15005059367','15005059367','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281179197445',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18150563203','18150563203','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281179197446',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18649652527','18649652527','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281179197447',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17741357996','17741357996','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'消息因为某些原因被网关驳回','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281179197448',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15960551920','15960551920','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281183391745',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13960207400','13960207400','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281183391746',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17750799505','17750799505','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281183391747',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15080458330','15080458330','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281225334786',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17605014353','17605014353','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281229529090',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18859464970','18859464970','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281229529091',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13027105101','13027105101','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281229529092',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13860300607','13860300607','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281229529093',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','14759154723','14759154723','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281229529094',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15980060559','15980060559','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281233723394',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18262283166','18262283166','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281233723395',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15029265211','15029265211','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281233723396',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15960402869','15960402869','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281233723397',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18829340451','18829340451','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281233723398',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15559110466','15559110466','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281237917698',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13122120652','13122120652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281237917699',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15191815436','15191815436','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281237917700',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13860752060','13860752060','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281237917701',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18539456470','18539456470','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281237917702',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17759892862','17759892862','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281242112001',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18876272213','18876272213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281242112002',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19959848541','19959848541','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281242112003',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13313825373','13313825373','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281242112004',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18250850010','18250850010','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281242112005',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15389303652','15389303652','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281242112006',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13505986964','13505986964','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281242112007',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18740431050','18740431050','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281246306306',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13314987388','13314987388','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281246306307',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18859996145','18859996145','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281246306308',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18192276329','18192276329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281246306309',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15759590781','15759590781','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281246306310',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15315563156','15315563156','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281246306311',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15702950980','15702950980','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281250500610',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18806028372','18806028372','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281279860737',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18659568811','18659568811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281284055041',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15059850519','15059850519','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281284055042',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18392859639','18392859639','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281288249346',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13484917236','13484917236','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281288249347',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15029140185','15029140185','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281288249348',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18876223641','18876223641','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281288249349',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18659719331','18659719331','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281288249350',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19906870165','19906870165','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281292443649',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13489858089','13489858089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281292443650',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13960311095','13960311095','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281292443651',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13072350035','13072350035','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281292443652',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15905050688','15905050688','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281292443653',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15202404290','15202404290','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281292443654',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15821998683','15821998683','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281296637954',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15029279845','15029279845','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281296637955',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15111982965','15111982965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281296637956',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13484540329','13484540329','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281296637957',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13488103520','13488103520','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281296637958',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15202427957','15202427957','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281296637959',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18659262866','18659262866','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281300832258',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13506069249','13506069249','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281300832259',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13774878631','13774878631','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281300832260',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13599161927','13599161927','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281300832261',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15759653345','15759653345','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281300832262',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18292635234','18292635234','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281300832263',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15029278847','15029278847','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281305026562',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15029236362','15029236362','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281305026563',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13808549828','13808549828','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281305026564',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13599936037','13599936037','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281305026565',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13410024480','13410024480','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281334386690',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15905095955','15905095955','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281338580993',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13512216307','13512216307','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281338580994',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13600751875','13600751875','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281342775298',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13859775220','13859775220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281342775299',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13850777555','13850777555','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'手机端与网关连接失败，可先确认下号码是否正常使用中。','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281342775300',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13860763453','13860763453','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281342775301',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13004800144','13004800144','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281346969602',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13799240204','13799240204','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281346969603',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13615940087','13615940087','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281346969604',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13959910000','13959910000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281346969605',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15880881006','15880881006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281351163906',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13506066359','13506066359','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281351163907',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15980456333','15980456333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281351163908',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15359493923','15359493923','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281351163909',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13520554703','13520554703','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281351163910',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15806036626','15806036626','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281351163911',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18605001313','18605001313','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281355358209',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18905080205','18905080205','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281355358210',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13860726225','13860726225','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281355358211',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15259471016','15259471016','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281355358212',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18350505757','18350505757','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281355358213',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17715205257','17715205257','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281355358214',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15880758500','15880758500','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281359552513',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15880990268','15880990268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281359552514',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15059510022','15059510022','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281359552515',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18606031846','18606031846','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281359552516',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13950317095','13950317095','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281359552517',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18835792826','18835792826','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281363746817',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18906999069','18906999069','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281363746818',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13055650678','13055650678','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281393106945',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13505097888','13505097888','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281393106946',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13959717283','13959717283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281397301250',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13905985743','13905985743','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281397301251',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13905079763','13905079763','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281397301252',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15759296423','15759296423','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281397301253',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18605007853','18605007853','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281397301254',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15705923619','15705923619','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281401495553',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15980478011','15980478011','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281401495554',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18559672261','18559672261','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281401495555',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15985900838','15985900838','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281401495556',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15959990198','15959990198','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281401495557',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13905079280','13905079280','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281401495558',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13805997206','13805997206','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281401495559',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13506009833','13506009833','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281405689857',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13646031399','13646031399','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281405689858',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15392121201','15392121201','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281405689859',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13959921098','13959921098','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281405689860',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13799855086','13799855086','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281405689861',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18905060268','18905060268','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281405689862',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15377953096','15377953096','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281405689863',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13400507028','13400507028','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884162',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13959737339','13959737339','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884163',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13506059007','13506059007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884164',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18759922187','18759922187','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884165',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15859590857','15859590857','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884166',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13850757007','13850757007','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884167',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13305962813','13305962813','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884168',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13799857333','13799857333','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281409884169',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13365952758','13365952758','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281414078466',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13805951603','13805951603','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281439244290',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15375754488','15375754488','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281443438593',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15606946335','15606946335','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281443438594',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17850929207','17850929207','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281443438595',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15059720864','15059720864','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281443438596',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13600785508','13600785508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281447632897',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13805065379','13805065379','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281447632898',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13459218283','13459218283','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281447632899',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18005073259','18005073259','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281447632900',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18005065560','18005065560','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281447632901',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13107891508','13107891508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281447632902',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15605959006','15605959006','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281447632903',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13645971717','13645971717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827201',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15396503999','15396503999','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827202',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18705045726','18705045726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827203',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18050270931','18050270931','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827204',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17758766631','17758766631','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827205',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15071360501','15071360501','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827206',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13305952629','13305952629','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827207',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15659132085','15659132085','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281451827208',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15305009255','15305009255','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281456021505',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15080406979','15080406979','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281456021506',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18050876301','18050876301','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281456021507',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15905903705','15905903705','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281456021508',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13328505767','13328505767','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281456021509',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13285957289','13285957289','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281456021510',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15396596855','15396596855','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281456021511',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13559513508','13559513508','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281460215810',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13229424859','13229424859','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281460215811',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13645032611','13645032611','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281460215812',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15059154896','15059154896','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281489575938',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18650591551','18650591551','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281493770241',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18965662565','18965662565','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281493770242',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15759216753','15759216753','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281497964546',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15960217968','15960217968','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281497964547',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19959958737','19959958737','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281497964548',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13489387611','13489387611','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281497964549',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18084725997','18084725997','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281497964550',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13295908788','13295908788','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281502158849',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13328883775','13328883775','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281502158850',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13600704026','13600704026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281502158851',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13959989905','13959989905','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281502158852',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18072769019','18072769019','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',1,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281502158853',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13559421422','13559421422','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281506353154',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13788800635','13788800635','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281506353155',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18065955602','18065955602','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281506353156',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13850757884','13850757884','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281506353157',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18906997782','18906997782','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281506353158',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13860748042','13860748042','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281506353159',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15980006865','15980006865','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281506353160',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13489990595','13489990595','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281510547458',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15859559516','15859559516','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281510547459',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15960074890','15960074890','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281510547460',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18959111811','18959111811','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281510547461',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15905912099','15905912099','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281510547462',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18059869884','18059869884','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281510547463',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13799241311','13799241311','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281510547464',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13506060430','13506060430','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281514741761',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18683138068','18683138068','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281514741762',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13859755349','13859755349','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281514741763',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13306051592','13306051592','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281544101889',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18558994473','18558994473','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'黑名单','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281548296193',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18242352269','18242352269','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281548296194',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13459480239','13459480239','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281548296195',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15059791111','15059791111','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281548296196',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18759279125','18759279125','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281548296197',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15985991330','15985991330','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281552490498',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13675965549','13675965549','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281552490499',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15906086726','15906086726','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281552490500',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18959806100','18959806100','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281552490501',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13603600400','13603600400','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281552490502',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18957137209','18957137209','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281552490503',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15860362000','15860362000','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281556684802',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13215952676','13215952676','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281556684803',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13685905122','13685905122','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281556684804',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13481067154','13481067154','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',2,'手机端与网关连接失败，可先确认下号码是否正常使用中。','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281556684805',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15645826505','15645826505','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281556684806',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15710661733','15710661733','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281556684807',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17824951355','17824951355','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281556684808',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13505055213','13505055213','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879105',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19523558089','19523558089','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879106',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19523558862','19523558862','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879107',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15840415838','15840415838','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879108',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15105955127','15105955127','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879109',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13159272998','13159272998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879110',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15959858886','15959858886','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879111',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13110961526','13110961526','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281560879112',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15347974220','15347974220','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281565073409',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18965042522','18965042522','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281565073410',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18060863322','18060863322','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281565073411',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13152326775','13152326775','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281598627842',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15750715717','15750715717','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281602822146',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18009936110','18009936110','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281602822147',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13123022338','13123022338','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281602822148',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13805943012','13805943012','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281602822149',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13905981361','13905981361','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281602822150',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18976017695','18976017695','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281602822151',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17689940142','17689940142','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281602822152',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15608856832','15608856832','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281607016449',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17716366562','17716366562','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281607016450',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13943133715','13943133715','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281607016451',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15659605296','15659605296','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281607016452',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','19959529856','19959529856','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281607016453',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18659936998','18659936998','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281607016454',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13600709402','13600709402','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281607016455',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18106980530','18106980530','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281611210753',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13966823479','13966823479','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281611210754',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15106005598','15106005598','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281611210755',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13290719799','13290719799','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281611210756',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18659281177','18659281177','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281611210757',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13808552442','13808552442','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281611210758',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13826087143','13826087143','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281615405057',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','17399655173','17399655173','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281615405058',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15260391931','15260391931','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281615405059',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18559585690','18559585690','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281615405060',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15659035363','15659035363','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281615405061',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15880013807','15880013807','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281619599362',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13313879168','13313879168','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281619599363',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18606061141','18606061141','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281623793665',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18344989075','18344989075','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281623793666',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18250401640','18250401640','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281653153793',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18659015765','18659015765','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281657348098',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18344990362','18344990362','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281657348099',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13559056528','13559056528','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281657348100',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13235950187','13235950187','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281661542402',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15705939067','15705939067','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281661542403',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13665966151','13665966151','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281661542404',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15659606707','15659606707','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281661542405',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18060518242','18060518242','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281661542406',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18859594251','18859594251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281665736705',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13506905868','13506905868','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281665736706',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18876305138','18876305138','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281665736707',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18750207251','18750207251','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281665736708',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18876209230','18876209230','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281665736709',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13132285232','13132285232','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281665736710',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13805145645','13805145645','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281665736711',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13960232793','13960232793','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931009',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13509365965','13509365965','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931010',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13905920592','13905920592','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931011',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13559172702','13559172702','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931012',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','15005028826','15005028826','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931013',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18850458762','18850458762','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931014',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13960289675','13960289675','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931015',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13601013614','13601013614','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281669931016',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','13950493380','13950493380','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378243281674125313',NULL,'1378243280583606273',2,2,'批量发送(津补贴申报截止提醒420210403)','18649712545','18649712545','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交申请，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-03 15:09:39',NULL,NULL,NULL,'2021-04-03 15:09:39',NULL,NULL,NULL),('1378252314346864641',NULL,'1378252314346864641',2,1,NULL,'15860915743','208734','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-03 15:45:33',NULL,NULL,NULL,'2021-04-03 15:45:33',NULL,NULL,NULL),('1378907923576602626',NULL,'1378907923169755138',2,2,'批量发送(津补贴提醒20210405)','13600704026','13600704026','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交待审核，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-05 11:10:42',NULL,NULL,NULL,'2021-04-05 11:10:42',NULL,NULL,NULL),('1378907923580796930',NULL,'1378907923169755138',2,2,'批量发送(津补贴提醒20210405)','13365952758','13365952758','【晋江市人才服务平台】尊敬的晋江市优秀人才：我市于2021年3月15日至4月5日组织开展2020年度优秀人才津补贴申报工作，此次申报采用线上申报方式，具体申报通知可关注“人才晋江”、“晋江市人社局”微信公众号。因已临近申报截止时间，若有意愿申请津补贴但还未提交申请的人才，请务必于4月5日前提交申请。如材料暂未备齐，也要于4月5日下午17：30前先提交待审核，等待审核驳回后可继续补充材料。(此条为群发短信，若已有提交申请请忽略)',3,'短信发送成功','2021-04-05 11:10:42',NULL,NULL,NULL,'2021-04-05 11:10:42',NULL,NULL,NULL),('1379231988262715393','1378170232669028354','1379231988262715393',2,2,'晋江市艺达古建筑工程有限公司','15106010099','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-06 08:38:25',NULL,NULL,NULL,'2021-04-06 08:38:25',NULL,NULL,NULL),('1379233575316045826','1371653548550500354','1379233575316045826',2,2,'晋江市梅岭街道社区卫生服务中心','15159793788','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-06 08:44:43',NULL,NULL,NULL,'2021-04-06 08:44:43',NULL,NULL,NULL),('1379234336754188290','1377458375247343618','1379234336754188290',2,2,'福建省晋江智融财务管理有限责任公司','15375759779','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-06 08:47:45',NULL,NULL,NULL,'2021-04-06 08:47:45',NULL,NULL,NULL),('1379427094144040962',NULL,'1379427094144040962',2,1,NULL,'15382218695','234872','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-06 21:33:42',NULL,NULL,NULL,'2021-04-06 21:33:42',NULL,NULL,NULL),('1379427436239863810',NULL,'1379427436239863810',2,1,NULL,'15382218695','536623','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-06 21:35:03',NULL,NULL,NULL,'2021-04-06 21:35:03',NULL,NULL,NULL),('1379578563610624002',NULL,'1379578563610624002',2,1,NULL,'13788829369','632923','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-07 07:35:35',NULL,NULL,NULL,'2021-04-07 07:35:35',NULL,NULL,NULL),('1379579017040052226',NULL,'1379579017040052226',2,1,NULL,'18016623555','035645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-07 07:37:23',NULL,NULL,NULL,'2021-04-07 07:37:23',NULL,NULL,NULL),('1379988474236583938',NULL,'1379988474236583938',2,1,NULL,'15906059470','243596','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-08 10:44:25',NULL,NULL,NULL,'2021-04-08 10:44:25',NULL,NULL,NULL),('1379989465908461570',NULL,'1379989465908461570',2,1,NULL,'15906059470','692003','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-08 10:48:22',NULL,NULL,NULL,'2021-04-08 10:48:22',NULL,NULL,NULL),('1380003503975514114',NULL,'1380003503975514114',2,1,NULL,'18558982580','596758','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-08 11:44:09',NULL,NULL,NULL,'2021-04-08 11:44:09',NULL,NULL,NULL),('1380069897316417537',NULL,'1380069897316417537',2,1,NULL,'13600704026','162012','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-08 16:07:58',NULL,NULL,NULL,'2021-04-08 16:07:58',NULL,NULL,NULL),('1380320019472269313',NULL,'1380320019472269313',2,1,NULL,'15759508826','696272','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-09 08:41:52',NULL,NULL,NULL,'2021-04-09 08:41:52',NULL,NULL,NULL),('1380433362958761985','1379988765530996738','1380433362958761985',2,2,'泉州鑫泰鞋材有限公司','15906059470','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-09 16:12:15',NULL,NULL,NULL,'2021-04-09 16:12:15',NULL,NULL,NULL),('1381252616465498114',NULL,'1381252616465498114',2,1,NULL,'15060910357','913339','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-11 22:27:40',NULL,NULL,NULL,'2021-04-11 22:27:40',NULL,NULL,NULL),('1381491991342301185',NULL,'1381491991342301185',2,1,NULL,'13808538654','303740','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-12 14:18:52',NULL,NULL,NULL,'2021-04-12 14:18:52',NULL,NULL,NULL),('1381492275992936450',NULL,'1381492275992936450',2,1,NULL,'13808538654','199197','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-12 14:20:00',NULL,NULL,NULL,'2021-04-12 14:20:00',NULL,NULL,NULL),('1381493540122607618',NULL,'1381493540122607618',2,1,NULL,'13808538654','937640','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-12 14:25:01',NULL,NULL,NULL,'2021-04-12 14:25:01',NULL,NULL,NULL),('1381494917053890561',NULL,'1381494917053890561',2,1,NULL,'13808538654','994172','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-12 14:30:29',NULL,NULL,NULL,'2021-04-12 14:30:29',NULL,NULL,NULL),('1381496486352732162',NULL,'1381496486352732162',2,1,NULL,'13808538654','790852','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-12 14:36:43',NULL,NULL,NULL,'2021-04-12 14:36:43',NULL,NULL,NULL),('1381531489384087553',NULL,'1381531489384087553',2,1,NULL,'18860028825','178997','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-12 16:55:49',NULL,NULL,NULL,'2021-04-12 16:55:49',NULL,NULL,NULL),('1381598150602649602',NULL,'1381598150602649602',2,1,NULL,'15880956833','717993','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-12 21:20:42',NULL,NULL,NULL,'2021-04-12 21:20:42',NULL,NULL,NULL),('1381765375703773185',NULL,'1381765375703773185',2,1,NULL,'18860028825','330387','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-13 08:25:12',NULL,NULL,NULL,'2021-04-13 08:25:12',NULL,NULL,NULL),('1381785976963198977','1381765447682224129','1381785976963198977',2,2,'晋江市质量计量检测所','18860028825','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-13 09:47:03',NULL,NULL,NULL,'2021-04-13 09:47:03',NULL,NULL,NULL),('1381787540301934594','1381495285875818498','1381787540301934594',2,2,'晋江市子泉拉链制造有限公司','13808538654','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-13 09:53:16',NULL,NULL,NULL,'2021-04-13 09:53:16',NULL,NULL,NULL),('1381789164667793410',NULL,'1381789164667793410',2,1,NULL,'15906017400','853877','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-13 09:59:43',NULL,NULL,NULL,'2021-04-13 09:59:43',NULL,NULL,NULL),('1381790723006918658',NULL,'1381790723006918658',2,1,NULL,'15906017400','346183','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-13 10:05:55',NULL,NULL,NULL,'2021-04-13 10:05:55',NULL,NULL,NULL),('1381799826743750657',NULL,'1381799826743750657',2,1,NULL,'15880928010','606424','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-13 10:42:05',NULL,NULL,NULL,'2021-04-13 10:42:05',NULL,NULL,NULL),('1381802774764843009',NULL,'1381802774764843009',2,1,NULL,'15880928010','774571','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-13 10:53:48',NULL,NULL,NULL,'2021-04-13 10:53:48',NULL,NULL,NULL),('1381886721439952897',NULL,'1381886721439952897',2,1,NULL,'13505057971','761111','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-13 16:27:23',NULL,NULL,NULL,'2021-04-13 16:27:23',NULL,NULL,NULL),('1381965263347511298',NULL,'1381965263347511298',2,1,NULL,'13505903824','887645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-13 21:39:29',NULL,NULL,NULL,'2021-04-13 21:39:29',NULL,NULL,NULL),('1382610061184069634','1376725268030316545','1382610061184069634',2,2,'福建省瑞桐集成电路研究院有限责任公司','18105086003','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-15 16:21:40',NULL,NULL,NULL,'2021-04-15 16:21:40',NULL,NULL,NULL),('1382617962288115713','1376725268030316545','1382617962288115713',2,2,'福建省瑞桐集成电路研究院有限责任公司','18105086003','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-15 16:53:04',NULL,NULL,NULL,'2021-04-15 16:53:04',NULL,NULL,NULL),('1382618447288070145','1376725268030316545','1382618447288070145',2,2,'福建省瑞桐集成电路研究院有限责任公司','18105086003','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-15 16:55:00',NULL,NULL,NULL,'2021-04-15 16:55:00',NULL,NULL,NULL),('1382853069171191810','1381790922282496002','1382853069171191810',2,2,'泉州安平供水有限公司','15906017400','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-16 08:27:18',NULL,NULL,NULL,'2021-04-16 08:27:18',NULL,NULL,NULL),('1382943704318341121',NULL,'1382943704318341121',2,1,NULL,'15260748200','636119','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-16 14:27:27',NULL,NULL,NULL,'2021-04-16 14:27:27',NULL,NULL,NULL),('1382945390696984578',NULL,'1382945390696984578',2,1,NULL,'15260748200','365672','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-16 14:34:09',NULL,NULL,NULL,'2021-04-16 14:34:09',NULL,NULL,NULL),('1383528704348647426',NULL,'1383528704348647426',2,1,NULL,'15005933550','565081','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-18 05:12:02',NULL,NULL,NULL,'2021-04-18 05:12:02',NULL,NULL,NULL),('1383705258496225282',NULL,'1383705258496225282',2,1,NULL,'15906059470','189541','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-18 16:53:36',NULL,NULL,NULL,'2021-04-18 16:53:36',NULL,NULL,NULL),('1383954031432560641',NULL,'1383954031432560641',2,1,NULL,'18559511816','373927','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-19 09:22:08',NULL,NULL,NULL,'2021-04-19 09:22:08',NULL,NULL,NULL),('1384034754747297793',NULL,'1384034754747297793',2,1,NULL,'17091305920','021070','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-19 14:42:54',NULL,NULL,NULL,'2021-04-19 14:42:54',NULL,NULL,NULL),('1384035170629316609',NULL,'1384035170629316609',2,1,NULL,'17091305920','434130','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-19 14:44:33',NULL,NULL,NULL,'2021-04-19 14:44:33',NULL,NULL,NULL),('1384035484082237442',NULL,'1384035484082237442',2,1,NULL,'17091305920','356170','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-19 14:45:48',NULL,NULL,NULL,'2021-04-19 14:45:48',NULL,NULL,NULL),('1384301633227194369','1381802869983932418','1384301633227194369',2,2,'晋江市南音协会','15880928010','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-20 08:23:23',NULL,NULL,NULL,'2021-04-20 08:23:23',NULL,NULL,NULL),('1384316920827740161',NULL,'1384316920827740161',2,1,NULL,'17091305920','474850','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-20 09:24:07',NULL,NULL,NULL,'2021-04-20 09:24:07',NULL,NULL,NULL),('1384317174922870785',NULL,'1384317174922870785',2,1,NULL,'18859757978','572527','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-20 09:25:08',NULL,NULL,NULL,'2021-04-20 09:25:08',NULL,NULL,NULL),('1384413096965046274','1381802869983932418','1384413096965046274',2,2,'晋江市南音协会','15880928010','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-20 15:46:18',NULL,NULL,NULL,'2021-04-20 15:46:18',NULL,NULL,NULL),('1384414921499869186','1381802869983932418','1384414921499869186',2,2,'晋江市南音协会','15880928010','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-20 15:53:33',NULL,NULL,NULL,'2021-04-20 15:53:33',NULL,NULL,NULL),('1384710007227940865',NULL,'1384710007227940865',2,1,NULL,'15280112534','385590','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-21 11:26:07',NULL,NULL,NULL,'2021-04-21 11:26:07',NULL,NULL,NULL),('1385045406878007297',NULL,'1385045406878007297',2,1,NULL,'16653129639','524930','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-22 09:38:52',NULL,NULL,NULL,'2021-04-22 09:38:52',NULL,NULL,NULL),('1385526389570011137',NULL,'1385526389570011137',2,1,NULL,'13960253023','432683','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-23 17:30:07',NULL,NULL,NULL,'2021-04-23 17:30:07',NULL,NULL,NULL),('1385858311538081794',NULL,'1385858311538081794',2,1,NULL,'18046369106','415623','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-24 15:29:04',NULL,NULL,NULL,'2021-04-24 15:29:04',NULL,NULL,NULL),('1386487541267431425',NULL,'1386487540780892161',2,2,'批量发送(测试20210426)','17362523273','17362523273','【晋江市人才服务平台】测试',3,'短信发送成功','2021-04-26 09:09:24',NULL,NULL,NULL,'2021-04-26 09:09:24',NULL,NULL,NULL),('1386525399697145857',NULL,'1386525399697145857',2,1,NULL,'13860755678','820780','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-26 11:39:50',NULL,NULL,NULL,'2021-04-26 11:39:50',NULL,NULL,NULL),('1386564489960275969','58','1386564489960275969',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-26 14:15:10',NULL,NULL,NULL,'2021-04-26 14:15:10',NULL,NULL,NULL),('1386564511464472577','87','1386564511464472577',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-26 14:15:15',NULL,NULL,NULL,'2021-04-26 14:15:15',NULL,NULL,NULL),('1386564511678382082','102','1386564511678382082',1,2,'颜思思','15059886866','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-26 14:15:15',NULL,NULL,NULL,'2021-04-26 14:15:15',NULL,NULL,NULL),('1386616191400853505','1385046095385591809','1386616191400853505',2,2,'晋江全亿无纺布有限责任公司','16653129639','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-26 17:40:36',NULL,NULL,NULL,'2021-04-26 17:40:36',NULL,NULL,NULL),('1386837955405987841',NULL,'1386837955405987841',2,1,NULL,'13959882555','463211','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-27 08:21:49',NULL,NULL,NULL,'2021-04-27 08:21:49',NULL,NULL,NULL),('1386840400278372354',NULL,'1386840400278372354',2,1,NULL,'13959882555','405251','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-27 08:31:32',NULL,NULL,NULL,'2021-04-27 08:31:32',NULL,NULL,NULL),('1386847563121999873','1211453814360555522','1386847563121999873',2,2,'伟志股份公司','15859813817','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:00',NULL,NULL,NULL,'2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563243634690','1211561316616028162','1386847563243634690',2,2,'福建盼盼饮料有限公司','15959993860','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:00',NULL,NULL,NULL,'2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563264606209','1211490953219588098','1386847563264606209',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:00',NULL,NULL,NULL,'2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563520458753','58','1386847563520458753',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-27 09:00:00',NULL,NULL,NULL,'2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563524653057','58','1386847563524653057',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-27 09:00:00',NULL,NULL,NULL,'2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563738562562','83','1386847563738562562',1,2,'李女元','15359825666','9,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-27 09:00:00',NULL,NULL,NULL,'2021-04-27 09:00:00',NULL,NULL,NULL),('1386847584454230017','1211515979058692097','1386847584454230017',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584454230018','1211461407799820290','1386847584454230018',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584491978754','1211931259509456897','1386847584491978754',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584517144578','87','1386847584517144578',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584575864834','87','1386847584575864834',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584626196481','1211554636561956866','1386847584626196481',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584651362305','1211473406755651586','1386847584651362305',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584663945217','1212253296765505538','1386847584663945217',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584697499650','102','1386847584697499650',1,2,'颜思思','15059886866','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584739442689','102','1386847584739442689',1,2,'颜思思','15059886866','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584806551554','1211920348237316098','1386847584806551554',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584856883201','1212580494957416450','1386847584856883201',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584856883202','1211474926804975617','1386847584856883202',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847584986906625','1212685717864517633','1386847584986906625',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585020461058','1211490953219588098','1386847585020461058',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585041432578','1212685717864517633','1386847585041432578',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585205010434','1213007171541864449','1386847585205010434',2,2,'福建省兆亨科技有限公司','18659568811','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585205010435','1211539398999457793','1386847585205010435',2,2,'海西纺织新材料工业技术晋江研究院','15280796970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585364393986','1211837849989595138','1386847585364393986',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585372782594','1214020915189272577','1386847585372782594',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585519583233','1212535414099873794','1386847585519583233',2,2,'安踏体育用品集团有限公司','18120662230','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585523777537','1214025654970896386','1386847585523777537',2,2,'泉州盈众福海汽车销售有限公司','13489858089','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585670578177','1212685717864517633','1386847585670578177',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585674772482','1214097817526620161','1386847585674772482',2,2,'福建恒安集团有限公司','13960315655','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585838350338','1215207699331989506','1386847585838350338',2,2,'晋江市医院','18350528526','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585838350339','1216568840104734722','1386847585838350339',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585993539585','1218097536540147714','1386847585993539585',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847585993539586','1215532466647908353','1386847585993539586',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586144534529','1219241646047223809','1386847586144534529',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586144534530','1219451161745080321','1386847586144534530',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586303918081','1241252588561698817','1386847586303918081',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586303918082','1318179870542442498','1386847586303918082',2,2,'晋江市合豪果蔬种植有限公司','15960418149','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586454913026','1324980845383110658','1386847586454913026',2,2,'晋江市澳雷朗照明科技有限公司','18876305138','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586454913027','1290850604855361537','1386847586454913027',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586605907970','1295900371603947522','1386847586605907970',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586765291522','1348924009986654209','1386847586765291522',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847586924675074','1351830895278948354','1386847586924675074',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847587088252930','1364063273527320578','1386847587088252930',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847587268608002','1372491588135133185','1386847587268608002',2,2,'厦门市住宅设计院有限公司晋江分公司','15880889992','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847587419602946','1373900784671936513','1386847587419602946',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386847587574792193','1378170232669028354','1386847587574792193',2,2,'晋江市艺达古建筑工程有限公司','15106010099','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-27 09:00:05',NULL,NULL,NULL,'2021-04-27 09:00:05',NULL,NULL,NULL),('1386848553510420481','1211457961772236801','1386848553510420481',2,2,'灵源药业有限公司','18350770050','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-27 09:03:56',NULL,NULL,NULL,'2021-04-27 09:03:56',NULL,NULL,NULL),('1386849083662057474',NULL,'1386849083662057474',2,1,NULL,'18965687337','234320','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-27 09:06:02',NULL,NULL,NULL,'2021-04-27 09:06:02',NULL,NULL,NULL),('1386879962987937794',NULL,'1386879962987937794',2,1,NULL,'18046334282','700577','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-27 11:08:44',NULL,NULL,NULL,'2021-04-27 11:08:44',NULL,NULL,NULL),('1387209950891130882','1211461407799820290','1387209950891130882',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:00',NULL,NULL,NULL,'2021-04-28 09:00:00',NULL,NULL,NULL),('1387209950987599876','1211495827340574722','1387209950987599876',2,2,'晋江市品质陶瓷建材有限公司','13808558152','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:00',NULL,NULL,NULL,'2021-04-28 09:00:00',NULL,NULL,NULL),('1387209951042125825','1211554636561956866','1387209951042125825',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:00',NULL,NULL,NULL,'2021-04-28 09:00:00',NULL,NULL,NULL),('1387209951046320129','58','1387209951046320129',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-28 09:00:00',NULL,NULL,NULL,'2021-04-28 09:00:00',NULL,NULL,NULL),('1387209972206583809','1211561316616028162','1387209972206583809',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972214972417','1211920348237316098','1387209972214972417',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972214972418','1211473406755651586','1387209972214972418',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972298858498','87','1387209972298858498',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972424687617','1211474926804975617','1387209972424687617',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972424687618','1211920348237316098','1387209972424687618',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972424687619','1212685717864517633','1387209972424687619',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972605042690','1211539398999457793','1387209972605042690',2,2,'海西纺织新材料工业技术晋江研究院','15280796970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972630208513','1211931259509456897','1387209972630208513',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972709900289','102','1387209972709900289',1,2,'颜思思','15059886866','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972768620545','1211837849989595138','1387209972768620545',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972777009154','1212253296765505538','1387209972777009154',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972877672449','104','1387209972877672449',1,2,'人力资本','12345678900','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972953169922','1214020915189272577','1387209972953169922',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209972965752834','1212535414099873794','1387209972965752834',2,2,'安踏体育用品集团有限公司','18120662230','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973137719298','1214025654970896386','1387209973137719298',2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973150302210','1212685717864517633','1387209973150302210',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973292908546','1214097817526620161','1387209973292908546',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973322268673','1216568840104734722','1387209973322268673',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973473263617','1215207699331989506','1387209973473263617',2,2,'晋江市医院','18350528526','53,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973515206657','1218097536540147714','1387209973515206657',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973636841473','1215532466647908353','1387209973636841473',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973724921857','1219241646047223809','1387209973724921857',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973800419329','1217041144660119553','1387209973800419329',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973909471234','1241252588561698817','1387209973909471234',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209973968191490','1219451161745080321','1387209973968191490',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974077243394','1290850604855361537','1387209974077243394',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974135963650','1245615593177055233','1387209974135963650',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974240821250','1295900371603947522','1387209974240821250',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974320513025','1318179870542442498','1387209974320513025',2,2,'晋江市合豪果蔬种植有限公司','15960418149','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974404399106','1348924009986654209','1387209974404399106',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974534422529','1324980845383110658','1387209974534422529',2,2,'晋江市澳雷朗照明科技有限公司','18876305138','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974563782657','1351830895278948354','1387209974563782657',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974723166209','1364063273527320578','1387209974723166209',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387209974890938369','1373900784671936513','1387209974890938369',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-28 09:00:05',NULL,NULL,NULL,'2021-04-28 09:00:05',NULL,NULL,NULL),('1387294724053843970',NULL,'1387294724053843970',2,1,NULL,'15659885820','983433','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-28 14:36:51',NULL,NULL,NULL,'2021-04-28 14:36:51',NULL,NULL,NULL),('1387316443653128193',NULL,'1387316443653128193',2,1,NULL,'13075963031','083378','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-28 16:03:09',NULL,NULL,NULL,'2021-04-28 16:03:09',NULL,NULL,NULL),('1387572338689622018','1211495827340574722','1387572338689622018',2,2,'晋江市品质陶瓷建材有限公司','13808558152','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:00',NULL,NULL,NULL,'2021-04-29 09:00:00',NULL,NULL,NULL),('1387572338765119489','1211461407799820290','1387572338765119489',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:00',NULL,NULL,NULL,'2021-04-29 09:00:00',NULL,NULL,NULL),('1387572338811256833','1211554636561956866','1387572338811256833',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:00',NULL,NULL,NULL,'2021-04-29 09:00:00',NULL,NULL,NULL),('1387572338949668865','58','1387572338949668865',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-29 09:00:00',NULL,NULL,NULL,'2021-04-29 09:00:00',NULL,NULL,NULL),('1387572360109932545','1211561316616028162','1387572360109932545',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360122515458','1211473406755651586','1387572360122515458',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360168652801','1211920348237316098','1387572360168652801',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360206401538','87','1387572360206401538',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360302870530','1211474926804975617','1387572360302870530',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360319647745','1211931259509456897','1387572360319647745',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360369979394','102','1387572360369979394',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360369979395','1212685717864517633','1387572360369979395',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360491614210','1211837849989595138','1387572360491614210',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360491614211','1212195053699665922','1387572360491614211',2,2,'泉州建发凯迪汽车有限公司','13656038332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360663580673','1212253296765505538','1387572360663580673',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360671969281','1212535414099873794','1387572360671969281',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360843935746','1214020915189272577','1387572360843935746',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572360860712961','1212685717864517633','1387572360860712961',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361007513601','1214025654970896386','1387572361007513601',2,2,'泉州盈众福海汽车销售有限公司','13489858089','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361024290817','1216568840104734722','1387572361024290817',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361187868674','1214097817526620161','1387572361187868674',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361217228802','1218097536540147714','1387572361217228802',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361405972481','1219241646047223809','1387572361405972481',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361405972482','1215207699331989506','1387572361405972482',2,2,'晋江市医院','18350528526','64,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361577938946','1215532466647908353','1387572361577938946',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361582133249','1241252588561698817','1387572361582133249',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361749905410','1216537288914268162','1387572361749905410',2,2,'耀华园林股份有限公司','13959882723','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361758294018','1290850604855361537','1387572361758294018',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361934454786','1295900371603947522','1387572361934454786',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572361972203521','1217041144660119553','1387572361972203521',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362131587074','1348924009986654209','1387572362131587074',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362131587075','1218097536540147714','1387572362131587075',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362303553538','1351830895278948354','1387572362303553538',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362320330754','1219241646047223809','1387572362320330754',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362462937090','1364063273527320578','1387572362462937090',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362509074434','1219436923634892801','1387572362509074434',2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362639097858','1373900784671936513','1387572362639097858',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362702012418','1219451161745080321','1387572362702012418',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572362899144705','1245615593177055233','1387572362899144705',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572363050139649','1318179870542442498','1387572363050139649',2,2,'晋江市合豪果蔬种植有限公司','15960418149','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387572363264049154','1324980845383110658','1387572363264049154',2,2,'晋江市澳雷朗照明科技有限公司','18876305138','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 09:00:05',NULL,NULL,NULL,'2021-04-29 09:00:05',NULL,NULL,NULL),('1387597192549679105',NULL,'1387597192549679105',2,1,NULL,'19959711592','259198','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-04-29 10:38:45',NULL,NULL,NULL,'2021-04-29 10:38:45',NULL,NULL,NULL),('1387610309174280194','1214451511434743809','1387610309174280194',2,2,'福建北电新材料科技有限公司','19959711592','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-29 11:30:52',NULL,NULL,NULL,'2021-04-29 11:30:52',NULL,NULL,NULL),('1387662514602426369','1214451511434743809','1387662514602426369',2,2,'福建北电新材料科技有限公司','19959711592','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-04-29 14:58:19',NULL,NULL,NULL,'2021-04-29 14:58:19',NULL,NULL,NULL),('1387687181673345026',NULL,'1387687159615500289',2,2,'批量发送(实验120210429)','13675957398','13675957398','【晋江市人才服务平台】中国军网文昌4月29日电(记者霍雨佳)2021年4月29日11时23分，搭载空间站天和核心舱的长征五号B遥二运载火箭，在我国文昌航天发射场点火升空，约494秒后，天和核心舱与火箭成功分离，进入预定轨道，12时36分，太阳能帆板两翼顺利展开且工作正常，发射任务取得圆满成功。此次发射任务成功，标志着中国空间站在轨组装建造全面展开，为后续关键技术验证和空间站组装建造顺利实施奠定了坚实基础。天和核心舱是中国空间站发射入轨的首个舱段，主要用于空间站统一控制和管理，具备长期自主飞行能力，可支持航天员长期驻留，开展航天医学、空间科学实验和技术试验，起飞质量22.5吨，是目前我国自主研制的规模最大、系统最复杂的航天器。后续，天和核心舱将先后迎接天舟货运飞船和神舟载人飞船的访问，在全面完成空间站关键技术验证后，与问天实验舱、梦天实验舱实施交会对接，完成空间站三舱组合体在轨组装建造。参加此次发射任务的运载火箭及天和核心舱，分别由中国航天科技集团有限公司所属的中国运载火箭技术研究院和中国空间技术研究院抓总研制。这是长征系列运载火箭的第367次飞行。',3,'短信发送成功','2021-04-29 16:36:15',NULL,NULL,NULL,'2021-04-29 16:36:15',NULL,NULL,NULL),('1387687605402906625',NULL,'1387687584091648002',2,2,'批量发送(实验20210429)','13675957398','13675957398','【晋江市人才服务平台】美现政府就职以来，美军舰在中国当面海域活动频次比去年同期增加逾20%，侦察机活动频次超40%。美方频繁派遣舰机赴中国周边海空域活动，推动地区军事化，威胁地区和平稳定，中方对此坚决反对。我们敦促美方严格约束一线部队，遵守“中美海空相遇安全行为准则”“国际海上避碰规则”等规则，杜绝再次发生类似危险事件。',3,'短信发送成功','2021-04-29 16:37:56',NULL,NULL,NULL,'2021-04-29 16:37:56',NULL,NULL,NULL),('1387934726987231234','1211120827064496130','1387934726987231234',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:00',NULL,NULL,NULL,'2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727008202753','1211461407799820290','1387934727008202753',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:00',NULL,NULL,NULL,'2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727020785666','1211554636561956866','1387934727020785666',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:00',NULL,NULL,NULL,'2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727167586305','58','1387934727167586305',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-30 09:00:00',NULL,NULL,NULL,'2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727205335042','58','1387934727205335042',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-30 09:00:00',NULL,NULL,NULL,'2021-04-30 09:00:00',NULL,NULL,NULL),('1387934748315267073','1211473406755651586','1387934748315267073',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748315267074','1212685717864517633','1387934748315267074',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748373987329','1211495827340574722','1387934748373987329',2,2,'晋江市品质陶瓷建材有限公司','13808558152','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748403347458','87','1387934748403347458',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748403347459','87','1387934748403347459',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748491427842','1211474926804975617','1387934748491427842',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748533370881','1211561316616028162','1387934748533370881',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748562731009','102','1387934748562731009',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748579508226','102','1387934748579508226',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748646617090','1211837849989595138','1387934748646617090',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748692754433','1211836173303988226','1387934748692754433',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748793417729','1212535414099873794','1387934748793417729',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748864720898','1211914077576675329','1387934748864720898',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934748982161409','1212685717864517633','1387934748982161409',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749032493057','1211920348237316098','1387934749032493057',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749154127873','1216568840104734722','1387934749154127873',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749200265217','1211925547903401986','1387934749200265217',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749326094338','1218097536540147714','1387934749326094338',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749359648770','1211931259509456897','1387934749359648770',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749481283586','1219241646047223809','1387934749481283586',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749506449410','1212253296765505538','1387934749506449410',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749661638658','1241252588561698817','1387934749661638658',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749682610177','1212540446794911745','1387934749682610177',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749854576642','1214020915189272577','1387934749854576642',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934749854576643','1290850604855361537','1387934749854576643',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750022348802','1295900371603947522','1387934750022348802',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750022348803','1214025654970896386','1387934750022348803',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750202703874','1214041673798012930','1387934750202703874',2,2,'福建省全杰生物科技有限公司','19905050771','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750202703875','1348924009986654209','1387934750202703875',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750362087426','1214097817526620161','1387934750362087426',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750370476033','1351830895278948354','1387934750370476033',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1387934750550831105','1364063273527320578','1387934750550831105',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750559219714','1215207699331989506','1387934750559219714',2,2,'晋江市医院','18350528526','64,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750718603265','1373900784671936513','1387934750718603265',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750718603266','1215532466647908353','1387934750718603266',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934750903152642','1215548205433929729','1387934750903152642',2,2,'龙之族（中国）有限公司','15805972719','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934751062536193','1216537288914268162','1387934751062536193',2,2,'耀华园林股份有限公司','13959882723','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934751226114049','1216559724997144578','1387934751226114049',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934751398080513','1217041144660119553','1387934751398080513',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:05',NULL,NULL,NULL,'2021-04-30 09:00:05',NULL,NULL,NULL),('1387934751553269761','1218097536540147714','1387934751553269761',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1387934751729430529','1219241646047223809','1387934751729430529',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1387934751893008386','1219436923634892801','1387934751893008386',2,2,'三斯达（福建）塑胶有限公司','15375886386','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1387934752069169154','1219451161745080321','1387934752069169154',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1387934752241135618','1219530010977681410','1387934752241135618',2,2,'福州博厚教育有限公司泉州分公司','18659822322','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1387934752396324866','1245615593177055233','1387934752396324866',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1387934752547319809','1318179870542442498','1387934752547319809',2,2,'晋江市合豪果蔬种植有限公司','15960418149','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1387934752719286273','1324980845383110658','1387934752719286273',2,2,'晋江市澳雷朗照明科技有限公司','18876305138','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-04-30 09:00:06',NULL,NULL,NULL,'2021-04-30 09:00:06',NULL,NULL,NULL),('1389021890193960961','1211554636561956866','1389021890193960961',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:00',NULL,NULL,NULL,'2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890231709697','1211461407799820290','1389021890231709697',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:00',NULL,NULL,NULL,'2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890361733122','1211120827064496130','1389021890361733122',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:00',NULL,NULL,NULL,'2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890512728066','58','1389021890512728066',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-03 09:00:00',NULL,NULL,NULL,'2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890554671106','58','1389021890554671106',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-03 09:00:00',NULL,NULL,NULL,'2021-05-03 09:00:00',NULL,NULL,NULL),('1389021911584911361','1211442194934710274','1389021911584911361',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911618465793','1212685717864517633','1389021911618465793',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911672991746','87','1389021911672991746',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911672991747','87','1389021911672991747',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911677186049','1211473406755651586','1389021911677186049',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911777849345','1211559758373371905','1389021911777849345',2,2,'福建盼盼食品有限公司','13665929319','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911870124033','102','1389021911870124033',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911870124034','102','1389021911870124034',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021911874318338','1211474926804975617','1389021911874318338',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912063062017','1211837849989595138','1389021912063062017',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912088227842','1211561316616028162','1389021912088227842',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912218251266','1212535414099873794','1389021912218251266',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912239222786','1211805224986001409','1389021912239222786',2,2,'浩沙实业（福建）有限公司','13905089190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912377634817','1212685717864517633','1389021912377634817',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912394412033','1211820100991107074','1389021912394412033',2,2,'福建星宏新材料科技有限公司','13805992036','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912671236097','1216568840104734722','1389021912671236097',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912671236098','1211836173303988226','1389021912671236098',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912826425345','1218097536540147714','1389021912826425345',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021912826425346','1211914077576675329','1389021912826425346',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913015169025','1211920348237316098','1389021913015169025',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913015169026','1219241646047223809','1389021913015169026',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913174552578','1211925547903401986','1389021913174552578',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913203912706','1241252588561698817','1389021913203912706',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913329741826','1211931259509456897','1389021913329741826',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913359101954','1290850604855361537','1389021913359101954',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913497513986','1212253296765505538','1389021913497513986',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913518485505','1295900371603947522','1389021913518485505',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913665286146','1212536999949438978','1389021913665286146',2,2,'晋江市医院晋南分院','15396486268','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913665286147','1348924009986654209','1389021913665286147',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913820475394','1212540446794911745','1389021913820475394',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913837252609','1351830895278948354','1389021913837252609',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021913979858946','1212568548061286401','1389021913979858946',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021914000830466','1364063273527320578','1389021914000830466',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021914139242498','1213345803519725570','1389021914139242498',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021914302820354','1214020915189272577','1389021914302820354',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021914458009601','1214041673798012930','1389021914458009601',2,2,'福建省全杰生物科技有限公司','19905050771','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021914621587458','1214097817526620161','1389021914621587458',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021914789359617','1215207699331989506','1389021914789359617',2,2,'晋江市医院','18350528526','64,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021914948743170','1215532466647908353','1389021914948743170',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:05',NULL,NULL,NULL,'2021-05-03 09:00:05',NULL,NULL,NULL),('1389021915124903938','1215548205433929729','1389021915124903938',2,2,'龙之族（中国）有限公司','15805972719','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021915305259010','1216537288914268162','1389021915305259010',2,2,'耀华园林股份有限公司','13959882723','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021915489808385','1216559724997144578','1389021915489808385',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021915653386241','1217041144660119553','1389021915653386241',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021915812769793','1218097536540147714','1389021915812769793',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021915993124866','1219241646047223809','1389021915993124866',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021916148314113','1219428616866152449','1389021916148314113',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021916345446401','1219436923634892801','1389021916345446401',2,2,'三斯达（福建）塑胶有限公司','15375886386','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021916500635649','1219451161745080321','1389021916500635649',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021916655824897','1219530010977681410','1389021916655824897',2,2,'福州博厚教育有限公司泉州分公司','18659822322','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021916831985666','1245615593177055233','1389021916831985666',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021917008146433','1374909187762532354','1389021917008146433',2,2,'福建锦科新材料有限责任公司','15959999006','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389021917180112897','1374975706999595010','1389021917180112897',2,2,'向维智联(福建)科技有限公司','13799238690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-03 09:00:06',NULL,NULL,NULL,'2021-05-03 09:00:06',NULL,NULL,NULL),('1389063543189450754',NULL,'1389063543189450754',2,1,NULL,'13960253023','799662','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-03 11:45:30',NULL,NULL,NULL,'2021-05-03 11:45:30',NULL,NULL,NULL),('1389384278063755266','1211461407799820290','1389384278063755266',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:00',NULL,NULL,NULL,'2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278072143873','1211554636561956866','1389384278072143873',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:00',NULL,NULL,NULL,'2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278126669826','1211120827064496130','1389384278126669826',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:00',NULL,NULL,NULL,'2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278210555905','58','1389384278210555905',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-04 09:00:00',NULL,NULL,NULL,'2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278294441985','58','1389384278294441985',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-04 09:00:00',NULL,NULL,NULL,'2021-05-04 09:00:00',NULL,NULL,NULL),('1389384299450511361','1211442194934710274','1389384299450511361',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299454705666','1212685717864517633','1389384299454705666',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299454705667','1211473406755651586','1389384299454705667',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299530203137','87','1389384299530203137',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299555368961','87','1389384299555368961',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299618283522','1211474926804975617','1389384299618283522',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299630866434','1211559758373371905','1389384299630866434',2,2,'福建盼盼食品有限公司','13665929319','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299677003777','102','1389384299677003777',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299697975298','102','1389384299697975298',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299773472769','1211561316616028162','1389384299773472769',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299777667073','1211837849989595138','1389384299777667073',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299928662017','1212535414099873794','1389384299928662017',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384299932856321','1211820100991107074','1389384299932856321',2,2,'福建星宏新材料科技有限公司','13805992036','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300083851266','1211836173303988226','1389384300083851266',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300117405698','1216568840104734722','1389384300117405698',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300239040514','1211914077576675329','1389384300239040514',2,2,'蜡笔小新（福建）食品工业有限公司','18965690059','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300264206338','1218097536540147714','1389384300264206338',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300381646849','1211920348237316098','1389384300381646849',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300423589889','1219241646047223809','1389384300423589889',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300532641794','1211925547903401986','1389384300532641794',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300599750658','1241252588561698817','1389384300599750658',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300696219650','1211931259509456897','1389384300696219650',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300754939905','1290850604855361537','1389384300754939905',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300859797506','1212253296765505538','1389384300859797506',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384300922712066','1295900371603947522','1389384300922712066',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301002403841','1212536999949438978','1389384301002403841',2,2,'晋江市医院晋南分院','15396486268','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301077901313','1348924009986654209','1389384301077901313',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301153398785','1212540446794911745','1389384301153398785',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301237284866','1351830895278948354','1389384301237284866',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301296005121','1214020915189272577','1389384301296005121',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301396668418','1364063273527320578','1389384301396668418',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301447000065','1214041673798012930','1389384301447000065',2,2,'福建省全杰生物科技有限公司','19905050771','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301593800706','1214097817526620161','1389384301593800706',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301744795650','1215207699331989506','1389384301744795650',2,2,'晋江市医院','18350528526','64,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384301891596290','1215532466647908353','1389384301891596290',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384302071951362','1215548205433929729','1389384302071951362',2,2,'龙之族（中国）有限公司','15805972719','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384302222946306','1216537288914268162','1389384302222946306',2,2,'耀华园林股份有限公司','13959882723','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384302407495681','1216559724997144578','1389384302407495681',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384302621405185','1217041144660119553','1389384302621405185',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384302801760258','1218097536540147714','1389384302801760258',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384302973726721','1219241646047223809','1389384302973726721',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:05',NULL,NULL,NULL,'2021-05-04 09:00:05',NULL,NULL,NULL),('1389384303175053313','1219428616866152449','1389384303175053313',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:06',NULL,NULL,NULL,'2021-05-04 09:00:06',NULL,NULL,NULL),('1389384303338631170','1219436923634892801','1389384303338631170',2,2,'三斯达（福建）塑胶有限公司','15375886386','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:06',NULL,NULL,NULL,'2021-05-04 09:00:06',NULL,NULL,NULL),('1389384303506403329','1219451161745080321','1389384303506403329',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:06',NULL,NULL,NULL,'2021-05-04 09:00:06',NULL,NULL,NULL),('1389384303657398273','1219530010977681410','1389384303657398273',2,2,'福州博厚教育有限公司泉州分公司','18659822322','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:06',NULL,NULL,NULL,'2021-05-04 09:00:06',NULL,NULL,NULL),('1389384303812587522','1245615593177055233','1389384303812587522',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:06',NULL,NULL,NULL,'2021-05-04 09:00:06',NULL,NULL,NULL),('1389384303971971074','1374909187762532354','1389384303971971074',2,2,'福建锦科新材料有限责任公司','15959999006','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-04 09:00:06',NULL,NULL,NULL,'2021-05-04 09:00:06',NULL,NULL,NULL),('1389417459177533442',NULL,'1389417459177533442',2,1,NULL,'13960571971','281028','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-04 11:11:51',NULL,NULL,NULL,'2021-05-04 11:11:51',NULL,NULL,NULL),('1389746666004852738','1211554636561956866','1389746666004852738',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:00',NULL,NULL,NULL,'2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666013241346','1211461407799820290','1389746666013241346',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:00',NULL,NULL,NULL,'2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666021629954','1211120827064496130','1389746666021629954',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:00',NULL,NULL,NULL,'2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666340397057','58','1389746666340397057',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-05 09:00:00',NULL,NULL,NULL,'2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666340397058','58','1389746666340397058',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-05 09:00:00',NULL,NULL,NULL,'2021-05-05 09:00:00',NULL,NULL,NULL),('1389746687337082882','1211473406755651586','1389746687337082882',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687337082883','1211442194934710274','1389746687337082883',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687379025922','1212685717864517633','1389746687379025922',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687437746177','87','1389746687437746177',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687437746178','87','1389746687437746178',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687509049345','1211559758373371905','1389746687509049345',2,2,'福建盼盼食品有限公司','13665929319','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687546798082','1211474926804975617','1389746687546798082',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687592935426','102','1389746687592935426',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687681015810','1211561316616028162','1389746687681015810',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687706181633','1211837849989595138','1389746687706181633',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687852982273','1211820100991107074','1389746687852982273',2,2,'福建星宏新材料科技有限公司','13805992036','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687852982274','102','1389746687852982274',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746687869759489','1212535414099873794','1389746687869759489',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688003977217','1211836173303988226','1389746688003977217',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688020754433','1216568840104734722','1389746688020754433',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688159166465','1211920348237316098','1389746688159166465',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688171749377','1218097536540147714','1389746688171749377',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688322744322','1219241646047223809','1389746688322744322',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688335327233','1211925547903401986','1389746688335327233',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688490516481','1241252588561698817','1389746688490516481',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688490516482','1211931259509456897','1389746688490516482',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688641511426','1290850604855361537','1389746688641511426',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688658288641','1212253296765505538','1389746688658288641',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688821866498','1295900371603947522','1389746688821866498',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688834449409','1212536999949438978','1389746688834449409',2,2,'晋江市医院晋南分院','15396486268','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688972861441','1348924009986654209','1389746688972861441',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746688972861442','1212540446794911745','1389746688972861442',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689123856385','1351830895278948354','1389746689123856385',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689174188034','1214020915189272577','1389746689174188034',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689308405761','1364063273527320578','1389746689308405761',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689329377281','1214041673798012930','1389746689329377281',2,2,'福建省全杰生物科技有限公司','19905050771','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689497149442','1214097817526620161','1389746689497149442',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689660727298','1215207699331989506','1389746689660727298',2,2,'晋江市医院','18350528526','64,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689811722242','1215532466647908353','1389746689811722242',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746689966911489','1215548205433929729','1389746689966911489',2,2,'龙之族（中国）有限公司','15805972719','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746690122100737','1216537288914268162','1389746690122100737',2,2,'耀华园林股份有限公司','13959882723','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746690268901377','1216559724997144578','1389746690268901377',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746690436673538','1217041144660119553','1389746690436673538',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746690600251393','1218097536540147714','1389746690600251393',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746690763829250','1219241646047223809','1389746690763829250',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:05',NULL,NULL,NULL,'2021-05-05 09:00:05',NULL,NULL,NULL),('1389746690944184321','1219428616866152449','1389746690944184321',2,2,'初创投资有限公司','13506095562','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:06',NULL,NULL,NULL,'2021-05-05 09:00:06',NULL,NULL,NULL),('1389746691107762178','1219451161745080321','1389746691107762178',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:06',NULL,NULL,NULL,'2021-05-05 09:00:06',NULL,NULL,NULL),('1389746691283922945','1219530010977681410','1389746691283922945',2,2,'福州博厚教育有限公司泉州分公司','18659822322','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:06',NULL,NULL,NULL,'2021-05-05 09:00:06',NULL,NULL,NULL),('1389746691443306498','1245615593177055233','1389746691443306498',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:06',NULL,NULL,NULL,'2021-05-05 09:00:06',NULL,NULL,NULL),('1389746691611078657','1374909187762532354','1389746691611078657',2,2,'福建锦科新材料有限责任公司','15959999006','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-05 09:00:06',NULL,NULL,NULL,'2021-05-05 09:00:06',NULL,NULL,NULL),('1390109053966921729','1211461407799820290','1390109053966921729',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:00',NULL,NULL,NULL,'2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054017253378','1211554636561956866','1390109054017253378',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:00',NULL,NULL,NULL,'2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054055002114','1211120827064496130','1390109054055002114',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:00',NULL,NULL,NULL,'2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054168248321','58','1390109054168248321',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-06 09:00:00',NULL,NULL,NULL,'2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054180831234','58','1390109054180831234',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-06 09:00:00',NULL,NULL,NULL,'2021-05-06 09:00:00',NULL,NULL,NULL),('1390109075341094914','1211473406755651586','1390109075341094914',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075341094915','1211442194934710274','1390109075341094915',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075341094916','1212685717864517633','1390109075341094916',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075412398081','87','1390109075412398081',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075454341122','87','1390109075454341122',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075525644289','1211474926804975617','1390109075525644289',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075546615810','1211559758373371905','1390109075546615810',2,2,'福建盼盼食品有限公司','13665929319','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075617918977','102','1390109075617918977',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075617918978','102','1390109075617918978',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075685027842','1211837849989595138','1390109075685027842',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075714387969','1211561316616028162','1390109075714387969',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075852800001','1216568840104734722','1390109075852800001',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109075877965826','1211820100991107074','1390109075877965826',2,2,'福建星宏新材料科技有限公司','13805992036','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076016377857','1218097536540147714','1390109076016377857',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076033155074','1211836173303988226','1390109076033155074',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076171567106','1219241646047223809','1390109076171567106',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076188344321','1211920348237316098','1390109076188344321',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076343533570','1211925547903401986','1390109076343533570',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076343533571','1241252588561698817','1390109076343533571',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076498722818','1211931259509456897','1390109076498722818',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076515500034','1290850604855361537','1390109076515500034',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076670689281','1295900371603947522','1390109076670689281',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076670689282','1212253296765505538','1390109076670689282',2,2,'泉州寰球鞋服有限公司','18959708869','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076838461442','1212536999949438978','1390109076838461442',2,2,'晋江市医院晋南分院','15396486268','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076838461443','1348924009986654209','1390109076838461443',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109076997844993','1351830895278948354','1390109076997844993',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077002039297','1212540446794911745','1390109077002039297',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077165617153','1364063273527320578','1390109077165617153',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077165617154','1214020915189272577','1390109077165617154',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077320806402','1214041673798012930','1390109077320806402',2,2,'福建省全杰生物科技有限公司','19905050771','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077484384258','1214097817526620161','1390109077484384258',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077643767809','1215207699331989506','1390109077643767809',2,2,'晋江市医院','18350528526','64,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077807345666','1215532466647908353','1390109077807345666',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109077979312129','1216537288914268162','1390109077979312129',2,2,'耀华园林股份有限公司','13959882723','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109078159667202','1217041144660119553','1390109078159667202',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109078327439361','1218097536540147714','1390109078327439361',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109078478434306','1219241646047223809','1390109078478434306',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109078633623554','1219451161745080321','1390109078633623554',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:05',NULL,NULL,NULL,'2021-05-06 09:00:05',NULL,NULL,NULL),('1390109078801395713','1219530010977681410','1390109078801395713',2,2,'福州博厚教育有限公司泉州分公司','18659822322','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:06',NULL,NULL,NULL,'2021-05-06 09:00:06',NULL,NULL,NULL),('1390109078948196354','1245615593177055233','1390109078948196354',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:06',NULL,NULL,NULL,'2021-05-06 09:00:06',NULL,NULL,NULL),('1390109079111774209','1374909187762532354','1390109079111774209',2,2,'福建锦科新材料有限责任公司','15959999006','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-06 09:00:06',NULL,NULL,NULL,'2021-05-06 09:00:06',NULL,NULL,NULL),('1390152342837440514',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599222388','13599222388','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342841634818',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396593822','15396593822','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342841634819',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960406441','15960406441','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342841634820',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808510599','13808510599','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342841634821',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905969997','13905969997','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342845829121',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959851597','18959851597','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342845829122',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159771234','15159771234','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342845829123',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905075569','13905075569','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342845829124',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15980007741','15980007741','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342845829125',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15160347806','15160347806','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342850023426',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13615915452','13615915452','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342850023427',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808517722','13808517722','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342850023428',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506068255','13506068255','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342850023429',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392288802','15392288802','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342854217729',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15260838364','15260838364','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342854217730',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905963651','13905963651','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342854217731',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905955285','13905955285','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342854217732',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396555037','15396555037','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342854217733',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905959957','13905959957','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342854217734',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905951359','18905951359','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342854217735',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808519008','13808519008','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342858412034',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905085142','13905085142','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342858412035',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960256771','18960256771','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342858412036',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15659876828','15659876828','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342858412037',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506066009','13506066009','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342862606338',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805945182','13805945182','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342862606339',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505028393','13505028393','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342862606340',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','\n13599781088','\n13599781088','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342862606341',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18750656736','18750656736','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342866800642',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15375754676','15375754676','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342866800643',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13665928771','13665928771','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342975852545',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959590513','15959590513','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342975852546',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599758027','13599758027','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342975852547',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965690608','18965690608','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342980046849',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059552066','15059552066','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342980046850',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960581568','15960581568','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342980046851',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505052952','13505052952','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342980046852',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13358555590','13358555590','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342980046853',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13636997772','13636997772','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342980046854',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','17750898564','17750898564','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342980046855',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15980006605','15980006605','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342984241153',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505900831','13505900831','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342984241154',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18695655037','18695655037','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342984241155',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808559795','13808559795','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342984241156',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599251367','13599251367','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435457',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959599950','15959599950','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435458',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506062917','13506062917','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435459',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905059248','13905059248','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435460',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328886733','13328886733','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435461',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788858263','13788858263','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435462',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960308278','13960308278','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435463',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880736133','15880736133','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342988435464',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880725658','15880725658','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629762',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15805030428','15805030428','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629763',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960386748','18960386748','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629764',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960259796','13960259796','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629765',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799556139','13799556139','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629766',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059555159','15059555159','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629767',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960417929','13960417929','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629768',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905089504','13905089504','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152342992629769',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396580953','15396580953','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343017795585',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359853678','15359853678','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343021989890',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13655921120','13655921120','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343021989891',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359382301','15359382301','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343021989892',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799871828','13799871828','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343021989893',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506056478','13506056478','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343021989894',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965726116','18965726116','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343021989895',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960441111','15960441111','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343026184194',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13636999438','13636999438','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343026184195',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960414268','18960414268','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343026184196',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960588431','13960588431','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343026184197',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959913339','13959913339','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343026184198',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359996345','15359996345','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343026184199',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13105072871','13105072871','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343026184200',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959553436','15959553436','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378498',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599758686','13599758686','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378499',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18159337367','18159337367','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378500',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506057909','13506057909','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378501',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18059205852','18059205852','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378502',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599790523','13599790523','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378503',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13559050030','13559050030','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378504',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','\n15759762285','\n15759762285','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343030378505',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13655967775','13655967775','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343034572801',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15985927979','15985927979','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343034572802',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965695529','18965695529','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343034572803',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15259751258','15259751258','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343034572804',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13760492921','13760492921','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343034572805',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13723468278','13723468278','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343038767105',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960419666','18960419666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343038767106',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860758506','13860758506','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343038767107',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15106034917','15106034917','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343063932930',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600716282','13600716282','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343068127234',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13774896955','13774896955','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343068127235',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13850756266','13850756266','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343068127236',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860708877','13860708877','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343068127237',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960456221','13960456221','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343072321538',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600759232','13600759232','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343072321539',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18906098777','18906098777','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343072321540',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13515050181','13515050181','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343072321541',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13358571088','13358571088','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343072321542',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13225951999','13225951999','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343072321543',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905066958','18905066958','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343072321544',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799563344','13799563344','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515842',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13559047001','13559047001','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515843',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788854798','13788854798','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515844',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060939707','15060939707','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515845',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880966399','15880966399','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515846',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965699089','18965699089','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515847',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','\n13505980111','\n13505980111','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515848',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799856519','13799856519','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343076515849',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905902901','15905902901','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710145',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15375880588','15375880588','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710146',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13675924146','13675924146','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710147',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960452150','13960452150','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710148',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13305089291','13305089291','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710149',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','17350066826','17350066826','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710150',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15759853939','15759853939','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710151',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905982127','13905982127','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343080710152',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860704776','13860704776','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343084904450',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15559020740','15559020740','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343084904451',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159719590','15159719590','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343114264577',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599158679','13599158679','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343118458881',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960252706','18960252706','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343118458882',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15759776357','15759776357','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343122653186',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13559556976','13559556976','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343122653187',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965868147','18965868147','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343122653188',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359556683','15359556683','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343122653189',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960355911','13960355911','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343122653190',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18006055159','18006055159','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343126847489',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960295738','18960295738','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343126847490',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328881890','13328881890','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343126847491',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880777703','15880777703','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343126847492',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13636951781','13636951781','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343126847493',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13110830777','13110830777','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041794',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805940500','13805940500','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041795',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','\n13305986666','\n13305986666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041796',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905060517','18905060517','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041797',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506060287','13506060287','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041798',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880731672','15880731672','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041799',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959889921','15959889921','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041800',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959856588','18959856588','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343131041801',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13159009775','13159009775','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236097',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13459582022','13459582022','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236098',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788851700','13788851700','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236099',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905075588','18905075588','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236100',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959957825','13959957825','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236101',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600709128','13600709128','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236102',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880733889','15880733889','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236103',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13774898222','13774898222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343135236104',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960788771','15960788771','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343139430401',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18059993732','18059993732','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343168790530',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905062713','13905062713','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343172984833',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905062713','18905062713','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343172984834',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060460618','15060460618','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343172984835',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13850757755','13850757755','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343172984836',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392166570','15392166570','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343172984837',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960258030','13960258030','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179138',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18750699882','18750699882','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179139',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505955658','13505955658','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179140',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960258008','18960258008','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179141',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13313877175','13313877175','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179142',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799857343','13799857343','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179143',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18159591909','18159591909','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179144',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13910988678','13910988678','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343177179145',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15985971586','15985971586','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373442',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905052952','13905052952','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373443',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15260974479','15260974479','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373444',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959557003','15959557003','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373445',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15859733280','15859733280','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373446',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18065337022','18065337022','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373447',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905973636','13905973636','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373448',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059753988','15059753988','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343181373449',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599998337','13599998337','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567745',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18065311373','18065311373','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567746',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13615940198','13615940198','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567747',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','17305063383','17305063383','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567748',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059720035','15059720035','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567749',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808510035','13808510035','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567750',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959750863','13959750863','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567751',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18250603230','18250603230','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343185567752',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13205955600','13205955600','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343210733570',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799559177','13799559177','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343214927873',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13338587996','13338587996','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343214927874',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13305063744','13305063744','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343214927875',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18562250428','18562250428','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343214927876',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960254917','13960254917','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343214927877',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15805030033','15805030033','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343214927878',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905050404','15905050404','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343214927879',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359991284','15359991284','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343219122178',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359551975','15359551975','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343219122179',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860705819','13860705819','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343219122180',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959889392','15959889392','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343219122181',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599980831','13599980831','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343219122182',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060991797','15060991797','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343219122183',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959891136','13959891136','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343219122184',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15345953926','15345953926','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316482',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13489472331','13489472331','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316483',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13675932720','13675932720','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316484',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359850387','15359850387','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316485',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959988292','18959988292','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316486',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13178366222','13178366222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316487',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960783033','15960783033','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316488',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960207078','13960207078','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343223316489',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959555606','15959555606','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343227510786',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965539503','18965539503','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343227510787',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18805955055','18805955055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343227510788',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15259753033','15259753033','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343227510789',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13535244244','13535244244','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343227510790',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505903389','13505903389','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343227510791',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959852878','15959852878','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343227510792',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788863576','13788863576','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343256870914',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396572925','15396572925','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343256870915',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18859798123','18859798123','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343256870916',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359386925','15359386925','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065217',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13067060933','13067060933','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065218',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960231100','13960231100','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065219',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905950869','13905950869','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065220',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396566005','15396566005','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065221',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959702658','18959702658','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065222',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599719980','13599719980','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065223',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15860390355','15860390355','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343261065224',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060919552','15060919552','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259522',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960389076','18960389076','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259523',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808551248','13808551248','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259524',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15980047703','15980047703','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259525',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905986032','15905986032','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259526',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788809923','13788809923','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259527',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359609230','15359609230','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259528',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505959397','13505959397','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343265259529',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599162524','13599162524','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453826',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159542525','15159542525','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453827',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506958129','13506958129','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453828',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13375952931','13375952931','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453829',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13358571050','13358571050','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453830',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905056363','18905056363','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453831',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905960784','13905960784','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453832',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799236698','13799236698','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453833',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13859756588','13859756588','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343269453834',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905030980','15905030980','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343273648130',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880907677','15880907677','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343273648131',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805980628','13805980628','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343298813953',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392073532','15392073532','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343303008258',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506002023','13506002023','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343303008259',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13859793231','13859793231','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343303008260',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505052616','13505052616','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343303008261',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805923137','13805923137','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343303008262',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960270470','18960270470','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202561',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15659517933','15659517933','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202562',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599753587','13599753587','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202563',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392120761','15392120761','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202564',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059721768','15059721768','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202565',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905058844','18905058844','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202566',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960301870','18960301870','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202567',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13515051557','13515051557','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343307202568',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505904365','13505904365','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396866',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506945295','13506945295','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396867',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18159363986','18159363986','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396868',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13645980596','13645980596','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396869',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959881719','15959881719','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396870',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905037232','15905037232','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396871',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799875556','13799875556','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396872',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13489388088','13489388088','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343311396873',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13107832998','13107832998','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591169',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328575316','13328575316','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591170',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788858522','13788858522','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591171',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599728430','13599728430','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591172',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505955801','13505955801','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591173',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396562615','15396562615','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591174',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506006509','13506006509','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591175',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959750510','13959750510','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343315591176',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880203993','15880203993','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343344951298',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965869191','18965869191','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343344951299',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905065186','13905065186','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343344951300',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959854966','18959854966','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343344951301',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506061262','13506061262','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343349145601',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18759567666','18759567666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343349145602',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799456300','13799456300','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343349145603',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905055077','18905055077','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343349145604',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960582583','15960582583','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343349145605',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960261917','18960261917','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343349145606',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965500308','18965500308','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343349145607',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13004842051','13004842051','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339906',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599750733','13599750733','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339907',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13375956399','13375956399','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339908',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505928251','13505928251','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339909',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959836702','13959836702','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339910',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808550786','13808550786','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339911',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808542188','13808542188','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339912',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15980033399','15980033399','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343353339913',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392127837','15392127837','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534209',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960266989','18960266989','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534210',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505073150','13505073150','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534211',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960551728','15960551728','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534212',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15805950191','15805950191','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534213',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13859752798','13859752798','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534214',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506053635','13506053635','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534215',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392120886','15392120886','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343357534216',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599275085','13599275085','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343361728513',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808510285','13808510285','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343361728514',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805950973','13805950973','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343361728515',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959595928','15959595928','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343382700034',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805941891','13805941891','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343386894337',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392288755','15392288755','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343386894338',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600773277','13600773277','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343386894339',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799883963','13799883963','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343386894340',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506953116','13506953116','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343386894341',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506964667','13506964667','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088642',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13205059264','13205059264','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088643',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359381117','15359381117','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088644',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600759876','13600759876','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088645',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960387567','18960387567','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088646',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13636908871','13636908871','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088647',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905054170','18905054170','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088648',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13365961089','13365961089','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343391088649',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18050976868','18050976868','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282945',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959853326','18959853326','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282946',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505008120','13505008120','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282947',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505996792','13505996792','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282948',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13375954990','13375954990','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282949',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15375888110','15375888110','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282950',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15375752723','15375752723','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282951',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905068337','18905068337','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343395282952',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15860322848','15860322848','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477249',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880886877','15880886877','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477250',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805956821','13805956821','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477251',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960295698','13960295698','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477252',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396552850','15396552850','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477253',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13110802201','13110802201','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477254',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13358661231','13358661231','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'消息因为某些原因被网关驳回','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477255',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960458991','13960458991','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343399477256',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15377958135','15377958135','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343424643074',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13791700222','13791700222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343424643075',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13489578811','13489578811','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837377',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860729456','13860729456','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837378',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959598911','15959598911','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837379',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905079250','13905079250','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837380',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359992639','15359992639','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837381',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13615947582','13615947582','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837382',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959503616','15959503616','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837383',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359468087','15359468087','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343428837384',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13906099686','13906099686','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031681',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959852526','15959852526','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031682',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15860512282','15860512282','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031683',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960233951','13960233951','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031684',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13585696868','13585696868','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031685',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060909995','15060909995','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031686',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799456182','13799456182','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031687',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959591113','15959591113','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343433031688',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599136400','13599136400','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225986',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959705508','18959705508','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225987',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506013035','13506013035','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225988',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15859530303','15859530303','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225989',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905985981','15905985981','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225990',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505085006','13505085006','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225991',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506942202','13506942202','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225992',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860708539','13860708539','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343437225993',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599720800','13599720800','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343441420289',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13365973666','13365973666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343441420290',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599115580','13599115580','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343441420291',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159711706','15159711706','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343441420292',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905975100','15905975100','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343462391810',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959859225','13959859225','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343466586114',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505958590','13505958590','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343466586115',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799857345','13799857345','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343466586116',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860708119','13860708119','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343466586117',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13906095646','13906095646','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343466586118',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505055318','13505055318','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343466586119',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159792639','15159792639','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343466586120',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880933011','15880933011','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780417',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905035368','15905035368','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780418',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505052982','13505052982','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780419',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599106789','13599106789','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780420',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880920675','15880920675','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780421',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506900328','13506900328','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780422',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159766997','15159766997','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780423',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959750568','13959750568','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343470780424',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','\n13505092969','\n13505092969','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974722',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060939828','15060939828','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974723',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15392127211','15392127211','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974724',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15259750816','15259750816','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974725',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18006055313','18006055313','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974726',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328558379','13328558379','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974727',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860717621','13860717621','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974728',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505902994','13505902994','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343474974729',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799212226','13799212226','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343479169026',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599719378','13599719378','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343479169027',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805957043','13805957043','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343479169028',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328999154','13328999154','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343479169029',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959842329','13959842329','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343479169030',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15375752077','15375752077','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343479169031',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328536681','13328536681','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343500140546',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808542340','13808542340','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343504334849',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505045670','13505045670','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343504334850',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13215951927','13215951927','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343504334851',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18050872639','18050872639','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343504334852',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959754319','18959754319','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529153',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13004891343','13004891343','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529154',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959995431','13959995431','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529155',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18650905589','18650905589','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529156',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18859724972','18859724972','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529157',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505057819','13505057819','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529158',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505959938','13505959938','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529159',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18559492957','18559492957','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343508529160',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788851038','13788851038','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723458',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799545537','13799545537','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723459',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505950299','13505950299','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723460',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13255007192','13255007192','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723461',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359558666','15359558666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723462',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959867168','13959867168','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723463',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18105075959','18105075959','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723464',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599755471','13599755471','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343512723465',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059861900','15059861900','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917762',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808555872','13808555872','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917763',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960267046','13960267046','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917764',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15985956130','15985956130','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917765',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600759789','13600759789','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917766',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059869519','15059869519','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917767',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960417573','18960417573','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917768',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905955005','18905955005','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343516917769',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505057026','13505057026','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343521112065',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059865998','15059865998','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343542083586',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506944936','13506944936','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343546277889',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505953090','13505953090','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343546277890',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860718383','13860718383','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343546277891',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15985952123','15985952123','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343546277892',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13859753062','13859753062','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343546277893',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506060344','13506060344','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343546277894',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959990588','18959990588','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472193',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15805020679','15805020679','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472194',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959758903','18959758903','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472195',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13559518810','13559518810','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472196',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','17759518013','17759518013','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472197',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965488002','18965488002','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472198',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396580292','15396580292','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472199',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959853008','18959853008','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343550472200',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599163743','13599163743','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666498',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15659871980','15659871980','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666499',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505901163','13505901163','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666500',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13313827055','13313827055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666501',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960273689','18960273689','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666502',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959859922','13959859922','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666503',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959993394','18959993394','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666504',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960351686','18960351686','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343554666505',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15859496237','15859496237','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343558860801',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959992887','13959992887','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343558860802',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396580622','15396580622','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343558860803',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060931568','15060931568','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343558860804',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13515059386','13515059386','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343558860805',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13400821823','13400821823','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343558860806',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799853703','13799853703','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343558860807',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959907519','13959907519','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343584026626',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965689638','18965689638','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343584026627',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159715893','15159715893','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343584026628',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396590631','15396590631','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343584026629',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359591895','15359591895','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220929',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060627771','15060627771','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220930',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359388733','15359388733','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220931',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15960402079','15960402079','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220932',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905076369','13905076369','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220933',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506958465','13506958465','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220934',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808515282','13808515282','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220935',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18859552300','18859552300','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343588220936',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13960359769','13960359769','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415233',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396555363','15396555363','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415234',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860718427','13860718427','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415235',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505906819','13505906819','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415236',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599272010','13599272010','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415237',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505010097','13505010097','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415238',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328986006','13328986006','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415239',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18065367890','18065367890','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343592415240',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15559523883','15559523883','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609537',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960260372','18960260372','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609538',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960418303','18960418303','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609539',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18065236305','18065236305','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609540',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505958550','13505958550','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609541',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506090785','13506090785','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609542',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905079310','13905079310','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609543',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18006054692','18006054692','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343596609544',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965694567','18965694567','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343600803841',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965680673','18965680673','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343600803842',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18859550681','18859550681','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343625969665',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15805032337','15805032337','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343625969666',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18105059222','18105059222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163969',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18659575959','18659575959','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163970',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600772229','13600772229','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163971',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506954021','13506954021','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163972',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13655952858','13655952858','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163973',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599710603','13599710603','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163974',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13348573850','13348573850','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163975',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506045205','13506045205','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343630163976',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13305953569','13305953569','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358274',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15260833123','15260833123','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358275',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15860901929','15860901929','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358276',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18750533685','18750533685','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358277',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959599411','15959599411','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358278',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960415486','18960415486','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358279',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808518989','13808518989','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358280',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15985922722','15985922722','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343634358281',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13559629911','13559629911','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343638552578',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505900213','13505900213','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343638552579',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13515059059','13515059059','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343638552580',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506066200','13506066200','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343638552581',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960386826','18960386826','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343638552582',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505901327','13505901327','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343642746881',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18859794900','18859794900','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343642746882',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506058839','13506058839','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343642746883',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959906801','13959906801','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343642746884',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18905058806','18905058806','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343642746885',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15059755778','15059755778','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343646941186',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506029851','13506029851','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343646941187',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15880992695','15880992695','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343672107010',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506007200','13506007200','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343672107011',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15160392118','15160392118','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343672107012',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15985908978','15985908978','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343672107013',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505958696','13505958696','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343676301313',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506056301','13506056301','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343676301314',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599799678','13599799678','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343676301315',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13489318487','13489318487','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343676301316',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15860532032','15860532032','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343676301317',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','17759993378','17759993378','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343676301318',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505059007','13505059007','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495618',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506000593','13506000593','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495619',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960272618','18960272618','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495620',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905075502','13905075502','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495621',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13559558222','13559558222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495622',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960269697','18960269697','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495623',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505023958','13505023958','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495624',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808512654','13808512654','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495625',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506954580','13506954580','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343680495626',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18859932233','18859932233','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689921',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506068844','13506068844','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689922',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600789078','13600789078','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'黑名单','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689923',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905916982','15905916982','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689924',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505950649','13505950649','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689925',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13645950989','13645950989','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689926',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808516415','13808516415','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689927',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805958478','13805958478','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343684689928',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','\n13850799625','\n13850799625','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343688884225',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396572998','15396572998','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343688884226',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13313897125','13313897125','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343688884227',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15359382020','15359382020','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343709855746',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13358555292','13358555292','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343714050049',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15805016799','15805016799','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343714050050',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808518697','13808518697','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343714050051',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13905969705','13905969705','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343714050052',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505900358','13505900358','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343714050053',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15906010444','15906010444','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343714050054',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960356161','18960356161','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343714050055',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18965798786','18965798786','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244353',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18050852372','18050852372','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244354',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960382525','18960382525','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244355',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799224198','13799224198','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244356',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13808511770','13808511770','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244357',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905032377','15905032377','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244358',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328519611','13328519611','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244359',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13459555468','13459555468','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343718244360',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15060930057','15060930057','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438657',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13067486425','13067486425','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438658',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600752381','13600752381','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438659',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505908092','13505908092','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438660',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13959955766','13959955766','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438661',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959758955','18959758955','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438662',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960266336','18960266336','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438663',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505953688','13505953688','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438664',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13600701237','13600701237','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343722438665',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','19959996196','19959996196','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343726632962',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13489311961','13489311961','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343726632963',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13328876859','13328876859','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343726632964',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15396588855','15396588855','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343726632965',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13459578866','13459578866','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343726632966',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13860751480','13860751480','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343747604482',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505903337','13505903337','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343751798785',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13489265077','13489265077','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343751798786',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15905905960','15905905960','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343751798787',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18695659585','18695659585','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343751798788',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13559027758','13559027758','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343751798789',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18698382780','18698382780','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993090',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13788865055','13788865055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993091',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599992293','13599992293','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993092',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15159825288','15159825288','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993093',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13067127679','13067127679','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993094',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506083950','13506083950','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993095',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506952603','13506952603','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993096',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13599165859','13599165859','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343755993097',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18050927766','18050927766','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187393',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13850759875','13850759875','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187394',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','15959370254','15959370254','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187395',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13805942800','13805942800','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187396',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18960382205','18960382205','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187397',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','18959757285','18959757285','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187398',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13505950262','13505950262','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187399',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13506922110','13506922110','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390152343760187400',NULL,'1390152321450684418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报20210506)','13799592878','13799592878','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 11:51:55',NULL,NULL,NULL,'2021-05-06 11:51:55',NULL,NULL,NULL),('1390200745210458113',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','18960388252','18960388252','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745214652417',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	18959757285','	18959757285','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745218846721',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	13489716209','	13489716209','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745218846722',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	18050927766','	18050927766','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745218846723',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	15392285188','	15392285188','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745218846724',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	18965869191','	18965869191','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745218846725',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	13788851038','	13788851038','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745223041025',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	18065225866','	18065225866','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745223041026',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	13905965808','	13905965808','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745223041027',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	13559046000','	13559046000','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745223041028',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	18960259973','	18960259973','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745223041029',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	13506951138','	13506951138','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745227235329',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	18960382205','	18960382205','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745227235330',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	13505026292','	13505026292','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745227235331',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	15906090837','	15906090837','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745227235332',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	18960388438','	18960388438','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745231429634',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	15359555522','	15359555522','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390200745231429635',NULL,'1390200723962114049',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(2)20210506)','	13788806055','	13788806055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL,'2021-05-06 15:04:15',NULL,NULL,NULL),('1390208610981687297',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960388252','18960388252','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610985881601',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959757285','18959757285','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610985881602',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489716209','13489716209','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610990075905',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18050927766','18050927766','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610990075906',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392285188','15392285188','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610990075907',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965869191','18965869191','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610990075908',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13788851038','13788851038','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610994270209',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18065225866','18065225866','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610994270210',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905965808','13905965808','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610994270211',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559046000','13559046000','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610994270212',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960259973','18960259973','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610994270213',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506951138','13506951138','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610998464513',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960382205','18960382205','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610998464514',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505026292','13505026292','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610998464515',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15906090837','15906090837','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208610998464516',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960388438','18960388438','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611002658817',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359555522','15359555522','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611002658818',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13788806055','13788806055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611002658819',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559556256','13559556256','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'未知错误','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611002658820',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505900831','13505900831','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611002658821',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359609230','15359609230','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611002658822',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392277008','15392277008','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611006853122',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960404716','15960404716','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611006853123',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506057672','13506057672','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611006853124',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18562250426','18562250426','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611006853125',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','17705061377','17705061377','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611006853126',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959990225','18959990225','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611006853127',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506051429','13506051429','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611006853128',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599995214','13599995214','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611011047425',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960250482','18960250482','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611011047426',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960785898','15960785898','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611036213250',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13313837882','13313837882','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611040407554',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18050852372','18050852372','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611040407555',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18159225225','18159225225','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611040407556',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960457120','13960457120','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611044601858',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959891136','13959891136','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611044601859',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960315949','13960315949','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611044601860',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506061262','13506061262','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611044601861',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960262881','13960262881','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611044601862',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13123103122','13123103122','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611044601863',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805941266','13805941266','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796161',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959855803','15959855803','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796162',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13636902628','13636902628','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796163',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960551728','15960551728','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796164',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13055806886','13055806886','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796165',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489318200','13489318200','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796166',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506008029','13506008029','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796167',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15980455855','15980455855','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611048796168',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359999609','15359999609','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990466',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960582583','15960582583','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990467',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965681578','18965681578','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990468',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808518697','13808518697','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990469',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13515044299','13515044299','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990470',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905065152','18905065152','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990471',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960257845','13960257845','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990472',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13356981256','13356981256','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611052990473',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506068844','13506068844','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611057184770',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599115580','13599115580','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611057184771',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600704317','13600704317','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611057184772',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805956086','13805956086','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611057184773',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600708008','13600708008','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611082350593',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805943868','13805943868','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611086544898',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880719995','15880719995','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611086544899',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059721768','15059721768','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611086544900',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328873902','13328873902','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611086544901',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960582052','15960582052','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611086544902',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15259750073','15259750073','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611090739201',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505928251','13505928251','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611090739202',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505950649','13505950649','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611090739203',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13375993821','13375993821','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611090739204',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808505917','13808505917','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611090739205',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959990644','13959990644','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611090739206',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805955356','13805955356','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611090739207',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15805016799','15805016799','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611094933506',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506945295','13506945295','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611094933507',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960252754','13960252754','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611094933508',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13067486425','13067486425','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611094933509',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808550786','13808550786','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611094933510',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505901163','13505901163','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611094933511',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13365973666','13365973666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611094933512',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959852878','15959852878','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127810',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600756500','13600756500','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127811',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13205059264','13205059264','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127812',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506068248','13506068248','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127813',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13255007192','13255007192','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127814',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905068337','18905068337','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127815',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905032377','15905032377','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127816',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15159542525','15159542525','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611099127817',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15980047703','15980047703','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611103322113',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18050871916','18050871916','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611103322114',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959842329','13959842329','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611124293634',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960388503','18960388503','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611128487937',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805957043','13805957043','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611132682242',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959995431','13959995431','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611132682243',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600701237','13600701237','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611132682244',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960267046','13960267046','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611132682245',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396555363','15396555363','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611132682246',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506944936','13506944936','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611136876546',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505052616','13505052616','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611136876547',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15106062828','15106062828','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611136876548',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15106067575','15106067575','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611136876549',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600759876','13600759876','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611136876550',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960260372','18960260372','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611136876551',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13675932720','13675932720','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611141070850',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505057819','13505057819','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611141070851',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965680673','18965680673','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611141070852',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808508263','13808508263','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611141070853',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13205955600','13205955600','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611141070854',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13636999539','13636999539','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611141070855',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905991515','15905991515','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611145265154',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059861900','15059861900','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611145265155',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505906819','13505906819','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611145265156',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506060629','13506060629','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611145265157',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799248864','13799248864','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611145265158',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13358597360','13358597360','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611145265159',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959750510','13959750510','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611149459458',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880759996','15880759996','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611149459459',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905985981','15905985981','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611149459460',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505955801','13505955801','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611149459461',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960295698','13960295698','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611149459462',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506090785','13506090785','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611174625281',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808515282','13808515282','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611178819586',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599106789','13599106789','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611178819587',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599753398','13599753398','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611178819588',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359992543','15359992543','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611178819589',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799576101','13799576101','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611178819590',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392120761','15392120761','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611178819591',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505959522','13505959522','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611178819592',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359551975','15359551975','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611183013889',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960272357','18960272357','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611183013890',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600773277','13600773277','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611183013891',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599278323','13599278323','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611183013892',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506060344','13506060344','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611183013893',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959854966','18959854966','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611183013894',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505083385','13505083385','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611183013895',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559557456','13559557456','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208193',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328570622','13328570622','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208194',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960292445','13960292445','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208195',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965682109','18965682109','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208196',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15375883202','15375883202','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208197',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506053635','13506053635','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208198',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959552368','15959552368','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208199',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13645980596','13645980596','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611187208200',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905066986','15905066986','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611191402498',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328575316','13328575316','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611191402499',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359992639','15359992639','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611191402500',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905970909','13905970909','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611191402501',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965488002','18965488002','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611191402502',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959857467','13959857467','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611191402503',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059555393','15059555393','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611191402504',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396590631','15396590631','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611220762626',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396580622','15396580622','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611220762627',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905062729','18905062729','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956930',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506942212','13506942212','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956931',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489331551','13489331551','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'未知错误','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956932',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959750568','13959750568','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956933',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808542188','13808542188','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956934',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905930930','15905930930','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956935',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15759732261','15759732261','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956936',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15980065328','15980065328','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611224956937',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505073150','13505073150','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611229151233',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799236698','13799236698','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611229151234',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960252898','13960252898','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611229151235',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905035368','15905035368','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611229151236',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559518810','13559518810','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611229151237',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599750638','13599750638','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611229151238',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328536681','13328536681','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611229151239',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599718107','13599718107','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345537',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15375882910','15375882910','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345538',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359468087','15359468087','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345539',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13375956399','13375956399','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345540',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396580388','15396580388','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345541',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505950299','13505950299','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345542',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905056363','18905056363','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345543',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599755262','13599755262','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611233345544',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15345993578','15345993578','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611237539842',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506958465','13506958465','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611237539843',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396586155','15396586155','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'黑名单','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611237539844',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905901506','15905901506','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611237539845',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959867168','13959867168','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611237539846',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959750863','13959750863','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611262705666',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392127837','15392127837','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611266899970',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13636908871','13636908871','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611266899971',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600706015','13600706015','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611266899972',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060999668','15060999668','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611266899973',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960382525','18960382525','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611266899974',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808551248','13808551248','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611266899975',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15159788575','15159788575','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611271094273',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506964667','13506964667','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611271094274',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860705055','13860705055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611271094275',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959370254','15959370254','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611271094276',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15805955955','15805955955','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611271094277',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15375888110','15375888110','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611271094278',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505958550','13505958550','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611271094279',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959853008','18959853008','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288577',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18006055313','18006055313','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288578',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600789078','13600789078','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'黑名单','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288579',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505959397','13505959397','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288580',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328986006','13328986006','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288581',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965798786','18965798786','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288582',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808516502','13808516502','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288583',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799553939','13799553939','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611275288584',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505092969','13505092969','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611279482882',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18016613377','18016613377','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611279482883',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059858160','15059858160','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611279482884',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959836702','13959836702','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611279482885',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799856528','13799856528','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611279482886',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960207078','13960207078','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611279482887',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13338577993','13338577993','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611279482888',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15259752177','15259752177','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611283677185',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18650905589','18650905589','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611304648706',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13850717368','13850717368','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611308843009',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15306960730','15306960730','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611308843010',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905079250','13905079250','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611308843011',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060999766','15060999766','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611308843012',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960279278','18960279278','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037313',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13055674813','13055674813','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037314',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506953910','13506953910','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037315',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559554884','13559554884','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037316',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959705243','18959705243','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037317',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960388107','18960388107','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037318',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599161288','13599161288','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037319',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18006054692','18006054692','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611313037320',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359381117','15359381117','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611317231617',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960263298','13960263298','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611317231618',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506968547','13506968547','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611317231619',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959591113','15959591113','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611317231620',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13394071568','13394071568','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611317231621',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13859753062','13859753062','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611317231622',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506953116','13506953116','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611317231623',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13205953700','13205953700','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425922',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808510285','13808510285','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425923',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13788856524','13788856524','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425924',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18559492957','18559492957','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425925',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15860512282','15860512282','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425926',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959992887','13959992887','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425927',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506002023','13506002023','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425928',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505085006','13505085006','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611321425929',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13067060933','13067060933','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611325620225',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960344930','13960344930','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611325620226',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13305063744','13305063744','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611350786050',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18859932233','18859932233','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980353',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905037232','15905037232','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980354',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','\n18965500308','\n18965500308','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980355',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505010097','13505010097','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980356',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489388088','13489388088','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980357',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13024860806','13024860806','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'联通停机或关机,个别情况与手机信号不稳定导致.','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980358',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905058844','18905058844','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980359',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559577759','13559577759','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611354980360',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13906095646','13906095646','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174658',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599781787','13599781787','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174659',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799553100','13799553100','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174660',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059722120','15059722120','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174661',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15759776890','15759776890','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174662',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13338597780','13338597780','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174663',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799456182','13799456182','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174664',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13358561231','13358561231','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611359174665',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13788863576','13788863576','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611363368961',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18759913178','18759913178','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611363368962',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600759789','13600759789','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611363368963',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960254917','13960254917','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611363368964',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959956589','13959956589','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611363368965',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13375952931','13375952931','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611363368966',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13859746283','13859746283','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611363368967',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960352922','13960352922','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611367563266',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880886877','15880886877','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611367563267',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13365961089','13365961089','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611367563268',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799239500','13799239500','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611367563269',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13178366222','13178366222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611367563270',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18759567666','18759567666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611367563271',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506062329','13506062329','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611392729089',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799500829','13799500829','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611396923394',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505055318','13505055318','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611396923395',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15805029195','15805029195','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611396923396',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13365955660','13365955660','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611396923397',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13636950785','13636950785','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611396923398',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489311961','13489311961','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611401117697',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359991834','15359991834','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611401117698',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060931568','15060931568','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611401117699',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392073532','15392073532','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611401117700',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13110802201','13110802201','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611401117701',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808541431','13808541431','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611401117702',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960236682','18960236682','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611401117703',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959852526','15959852526','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312001',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600737807','13600737807','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312002',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15306088016','15306088016','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312003',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13358572950','13358572950','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312004',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599163743','13599163743','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312005',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13313897125','13313897125','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312006',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15985947473','15985947473','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312007',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15860322848','15860322848','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611405312008',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959955933','13959955933','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506305',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599272010','13599272010','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506306',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860705819','13860705819','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506307',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805956821','13805956821','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506308',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060909995','15060909995','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506309',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959955766','13959955766','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506310',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13395095770','13395095770','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506311',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489358363','13489358363','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611409506312',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506942202','13506942202','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611413700610',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15860390355','15860390355','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611434672130',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959701122','18959701122','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611438866433',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13906095855','13906095855','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611438866434',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15159846789','15159846789','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611438866435',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13313885735','13313885735','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060737',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18859724972','18859724972','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060738',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18016560263','18016560263','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060739',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965625107','18965625107','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060740',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959754319','18959754319','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060741',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13636900375','13636900375','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060742',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392288755','15392288755','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060743',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505052982','13505052982','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611443060744',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505052914','13505052914','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255041',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15375752077','15375752077','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255042',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505903389','13505903389','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255043',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13615940198','13615940198','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255044',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959503616','15959503616','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255045',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506013035','13506013035','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255046',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599720800','13599720800','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255047',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799224198','13799224198','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611447255048',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396571181','15396571181','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449346',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396588037','15396588037','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449347',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13859793231','13859793231','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449348',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799212226','13799212226','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449349',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13788853086','13788853086','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449350',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392108829','15392108829','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449351',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860718427','13860718427','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449352',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506068820','13506068820','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611451449353',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905076369','13905076369','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611455643649',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13313832163','13313832163','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611455643650',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505903533','13505903533','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611480809474',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15559533007','15559533007','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611485003777',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15980033399','15980033399','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611485003778',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18105075959','18105075959','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611485003779',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600702802','13600702802','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198082',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905054170','18905054170','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198083',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905956597','18905956597','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198084',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559557906','13559557906','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198085',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905975796','15905975796','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198086',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799456552','13799456552','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198087',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060930057','15060930057','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198088',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905916982','15905916982','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611489198089',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396306663','15396306663','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392385',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599162524','13599162524','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392386',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396563456','15396563456','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392387',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359850387','15359850387','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392388',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13859768964','13859768964','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392389',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599136400','13599136400','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392390',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13400821823','13400821823','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392391',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13015820189','13015820189','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611493392392',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13979233620','13979233620','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'空号','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586690',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15859795832','15859795832','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586691',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13515057790','13515057790','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586692',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860708119','13860708119','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586693',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328852034','13328852034','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586694',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13375954990','13375954990','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586695',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960783033','15960783033','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586696',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396572998','15396572998','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611497586697',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15659871980','15659871980','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611501780993',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965539503','18965539503','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611501780994',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600752623','13600752623','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611526946818',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960279870','18960279870','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611531141121',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599275085','13599275085','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611531141122',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960359769','13960359769','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611531141123',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392231831','15392231831','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611531141124',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15860356589','15860356589','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611531141125',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960201050','13960201050','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611531141126',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13515059386','13515059386','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335425',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13338587996','13338587996','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335426',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13602032066','13602032066','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335427',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359558298','15359558298','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335428',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15985994860','15985994860','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335429',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960340669','13960340669','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335430',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15805950191','15805950191','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335431',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15159733085','15159733085','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611535335432',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960273689','18960273689','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529729',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392127211','15392127211','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529730',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959943303','18959943303','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529731',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880818910','15880818910','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529732',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959758903','18959758903','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529733',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905972276','13905972276','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529734',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960351686','18960351686','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529735',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18859550681','18859550681','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611539529736',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505089002','13505089002','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611543724034',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600756078','13600756078','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611543724035',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880812717','15880812717','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611543724036',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15345941986','15345941986','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611543724037',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13774878513','13774878513','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611543724038',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','17305063383','17305063383','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611543724039',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18016535499','18016535499','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611543724040',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905030980','15905030980','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611568889857',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059865998','15059865998','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611573084161',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905065186','13905065186','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611573084162',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805953016','13805953016','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611573084163',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960388482','18960388482','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611573084164',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960351955','13960351955','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611573084165',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599980831','13599980831','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611577278465',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18859798123','18859798123','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611577278466',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808510035','13808510035','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611577278467',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18006992345','18006992345','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611577278468',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880907677','15880907677','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611577278469',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808556408','13808556408','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'黑名单','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611577278470',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13665971315','13665971315','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611577278471',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960266989','18960266989','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472770',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959993394','18959993394','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472771',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860750628','13860750628','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472772',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505007821','13505007821','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472773',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059720035','15059720035','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472774',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960387567','18960387567','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472775',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960458991','13960458991','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472776',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489578811','13489578811','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611581472777',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060912761','15060912761','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611585667074',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15377958135','15377958135','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611585667075',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506958129','13506958129','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611585667076',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13515059558','13515059558','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611585667077',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13906099101','13906099101','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611585667078',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13774855125','13774855125','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611585667079',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600737290','13600737290','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611589861378',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965689638','18965689638','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611589861379',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396572976','15396572976','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611589861380',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959990538','15959990538','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611615027201',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505054636','13505054636','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611615027202',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060627771','15060627771','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611619221505',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15985956130','15985956130','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611619221506',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905900054','15905900054','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'超时(因用户长时间关机或者不在服务区导短信息超时没有递交到用户手机上)','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611619221507',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960417573','18960417573','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611619221508',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18250603230','18250603230','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611619221509',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15392120886','15392120886','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611619221510',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599719980','13599719980','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611619221511',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13585696868','13585696868','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415809',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359591895','15359591895','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415810',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15375752723','15375752723','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415811',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359382020','15359382020','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415812',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905955005','18905955005','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415813',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960354708','18960354708','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415814',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599719378','13599719378','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415815',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13535244244','13535244244','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611623415816',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359855798','15359855798','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610113',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959555606','15959555606','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610114',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506082192','13506082192','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610115',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860717621','13860717621','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610116',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396588855','15396588855','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610117',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905055887','18905055887','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610118',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599259479','13599259479','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610119',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15159711706','15159711706','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611627610120',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960257912','18960257912','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611631804417',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805958018','13805958018','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611631804418',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860753004','13860753004','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611631804419',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960230424','13960230424','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611631804420',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505902994','13505902994','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611631804421',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959859922','13959859922','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611656970241',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599750733','13599750733','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611661164545',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13791700222','13791700222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611661164546',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965699009','18965699009','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611661164547',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799883963','13799883963','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611661164548',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960265888','18960265888','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611665358849',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13850799625','13850799625','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611665358850',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18050976868','18050976868','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611665358851',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13313827055','13313827055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611665358852',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15345953926','15345953926','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611665358853',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15345957866','15345957866','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611665358854',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905975100','15905975100','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611665358855',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505045670','13505045670','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553153',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805942800','13805942800','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553154',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505900358','13505900358','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553155',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359552723','15359552723','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553156',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808557100','13808557100','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553157',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880933011','15880933011','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553158',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489858587','13489858587','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553159',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505955941','13505955941','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611669553160',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880811511','15880811511','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747457',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18805955055','18805955055','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747458',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13316959444','13316959444','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747459',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506002388','13506002388','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747460',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599728430','13599728430','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747461',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18065236305','18065236305','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747462',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15160399805','15160399805','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747463',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960414441','18960414441','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611673747464',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359991284','15359991284','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611677941762',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13788809923','13788809923','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611677941763',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960301870','18960301870','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611703107585',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799501163','13799501163','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611707301890',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13515051557','13515051557','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611707301891',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15859492448','15859492448','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611707301892',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15859489728','15859489728','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611707301893',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599720185','13599720185','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611711496194',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','\n18960257165','\n18960257165','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611711496195',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805959345','13805959345','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611711496196',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959702658','18959702658','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611711496197',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599110009','13599110009','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611711496198',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959701969','18959701969','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611711496199',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905979519','13905979519','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611711496200',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','17706050555','17706050555','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611715690497',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799545537','13799545537','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611715690498',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808543726','13808543726','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611715690499',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13459532298','13459532298','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611715690500',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960554543','15960554543','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611715690501',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505958590','13505958590','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611715690502',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600752381','13600752381','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611719884802',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13859798206','13859798206','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611719884803',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13358571050','13358571050','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611719884804',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13365953459','13365953459','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611719884805',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960402079','15960402079','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611719884806',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960413849','13960413849','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611719884807',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505904365','13505904365','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611719884808',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960383946','18960383946','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611724079106',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396552850','15396552850','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611724079107',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13850760626','13850760626','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611724079108',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396585896','15396585896','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611724079109',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506966520','13506966520','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611724079110',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18159337398','18159337398','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611749244929',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13305953012','13305953012','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611753439234',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13906099686','13906099686','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611753439235',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396566005','15396566005','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611753439236',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15306967822','15306967822','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611753439237',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060991797','15060991797','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611753439238',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505052020','13505052020','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'黑名单','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611753439239',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13636968007','13636968007','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611757633538',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15906039799','15906039799','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611757633539',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559051128','13559051128','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611757633540',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15859553338','15859553338','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611757633541',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960279731','18960279731','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611757633542',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15375752263','15375752263','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611757633543',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959705508','18959705508','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611757633544',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505950639','13505950639','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827842',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328522803','13328522803','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827843',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359821827','15359821827','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827844',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13774898222','13774898222','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827845',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15259750816','15259750816','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827846',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506900328','13506900328','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827847',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959990588','18959990588','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827848',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15715958210','15715958210','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611761827849',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808555872','13808555872','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022146',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960256435','13960256435','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022147',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965694567','18965694567','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022148',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959953108','13959953108','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'超时(因用户长时间关机或者不在服务区导短信息超时没有递交到用户手机上)','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022149',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799557853','13799557853','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022150',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808542340','13808542340','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022151',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905079310','13905079310','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022152',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599119181','13599119181','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611766022153',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13655939161','13655939161','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611791187969',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905985444','13905985444','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611795382274',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15059729082','15059729082','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611795382275',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960266336','18960266336','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611795382276',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13159007862','13159007862','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611799576577',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805943667','13805943667','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611799576578',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13859750573','13859750573','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611799576579',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599173918','13599173918','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611799576580',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328558379','13328558379','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611799576581',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799559177','13799559177','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611799576582',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905959083','13905959083','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611799576583',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960262623','13960262623','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770882',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13004891343','13004891343','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770883',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18050872639','18050872639','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770884',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396580292','15396580292','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770885',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13305952329','13305952329','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770886',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960410523','18960410523','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770887',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960351897','18960351897','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770888',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15860510225','15860510225','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611803770889',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599286359','13599286359','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965185',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599255382','13599255382','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965186',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880203993','15880203993','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965187',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959868814','18959868814','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965188',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959598911','15959598911','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965189',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15306085502','15306085502','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965190',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15159792639','15159792639','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965191',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15980005855','15980005855','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611807965192',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','\n13505908092','\n13505908092','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611812159490',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18859552300','18859552300','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611812159491',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13305950745','13305950745','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611812159492',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600702904','13600702904','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611837325313',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959750414','13959750414','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611837325314',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18396225111','18396225111','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611837325315',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13030979735','13030979735','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519617',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13850754196','13850754196','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519618',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880920675','15880920675','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519619',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359821189','15359821189','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519620',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960262663','13960262663','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519621',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359388733','15359388733','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519622',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960231100','13960231100','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519623',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905950869','13905950869','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611841519624',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505057026','13505057026','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713922',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505052676','13505052676','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713923',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600700303','13600700303','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713924',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805941891','13805941891','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713925',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860729456','13860729456','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713926',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18016660208','18016660208','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713927',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506900246','13506900246','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713928',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959994568','18959994568','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611845713929',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506922110','13506922110','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611849908226',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960233951','13960233951','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611849908227',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13459555468','13459555468','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611849908228',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905960784','13905960784','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611849908229',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13960451110','13960451110','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611849908230',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359551931','15359551931','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611849908231',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860706292','13860706292','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611849908232',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15060919552','15060919552','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611854102529',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15905050404','15905050404','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611854102530',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15985987567','15985987567','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611854102531',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13509543586','13509543586','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611854102532',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13645950989','13645950989','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611875074050',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599755471','13599755471','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611879268354',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799857345','13799857345','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611879268355',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959859225','13959859225','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611879268356',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15985952123','15985952123','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611879268357',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18959758955','18959758955','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462657',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599753587','13599753587','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462658',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506058128','13506058128','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462659',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13215951927','13215951927','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462660',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15805020679','15805020679','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462661',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13385957312','13385957312','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462662',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905955953','13905955953','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462663',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359382958','15359382958','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611883462664',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15715987329','15715987329','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656962',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328999154','13328999154','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656963',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505953090','13505953090','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656964',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799548353','13799548353','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656965',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359380769','15359380769','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656966',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','17759518013','17759518013','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656967',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396562615','15396562615','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656968',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506956111','13506956111','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611887656969',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505950262','13505950262','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611891851265',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805980628','13805980628','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611891851266',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18905056075','18905056075','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611891851267',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808555804','13808555804','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611891851268',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13905971037','13905971037','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611891851269',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15985929178','15985929178','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611891851270',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808557402','13808557402','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611891851271',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18350574368','18350574368','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611896045569',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808511770','13808511770','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611896045570',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15960550187','15960550187','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611921211394',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13375992986','13375992986','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611921211395',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13559427188','13559427188','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611921211396',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13365971897','13365971897','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611921211397',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506060960','13506060960','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405698',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805923137','13805923137','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405699',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15259753033','15259753033','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405700',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13799853703','13799853703','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405701',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13395091008','13395091008','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405702',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18060026078','18060026078','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405703',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960358785','18960358785','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405704',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13860708539','13860708539','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611925405705',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15159766997','15159766997','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611929600001',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959889392','15959889392','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611929600002',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13774800345','13774800345','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611929600003',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15359558666','15359558666','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611929600004',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15860523838','15860523838','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611929600005',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505996792','13505996792','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611929600006',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15959595982','15959595982','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611929600007',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13906095662','13906095662','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794306',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805958478','13805958478','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794307',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505008120','13505008120','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794308',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13055801856','13055801856','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794309',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13328895575','13328895575','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794310',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13489716821','13489716821','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794311',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13505052438','13505052438','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794312',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13506959033','13506959033','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611933794313',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13600766814','13600766814','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611937988609',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805943166','13805943166','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611937988610',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13805951138','13805951138','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611937988611',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13808541586','13808541586','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611963154434',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13850759875','13850759875','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611963154435',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13859792438','13859792438','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611963154436',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13959952020','13959952020','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348737',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15160332825','15160332825','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348738',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15396576526','15396576526','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348739',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15559123523','15559123523','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348740',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15859561857','15859561857','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348741',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15859738286','15859738286','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348742',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','15880721699','15880721699','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348743',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18059988536','18059988536','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611967348744',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18850547545','18850547545','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611971543041',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960244633','18960244633','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611971543042',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960384438','18960384438','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611971543043',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18960460429','18960460429','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611971543044',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','18965513289','18965513289','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',3,'短信发送成功','2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390208611971543045',NULL,'1390208589611708418',2,2,'批量发送(2020年度灵活就业社会保险补贴申报(第二批)20210506)','13599757612\n','13599757612\n','【晋江市人才服务平台】晋江市2020年度灵活就业社会保险补贴申报时间将于5月8日启动，详情请登录侨乡人才网(www.qxrc.com)“最新公告”栏目查询。咨询电话：0595-85661234',1,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL,'2021-05-06 15:35:31',NULL,NULL,NULL),('1390214058455642114',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18859907988','18859907988','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058455642115',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13905968151','13905968151','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058459836418',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18050303359','18050303359','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058459836419',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15259597676','15259597676','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058459836420',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13055224466','13055224466','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058459836421',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13959753823','13959753823','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058459836422',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15880815069','15880815069','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058459836423',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13906095618','13906095618','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058459836424',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18950351553','18950351553','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058464030722',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','17750798475','17750798475','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058464030723',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15859813817','15859813817','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058464030724',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18050878981','18050878981','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058464030725',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18965636930','18965636930','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058464030726',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15805003589','15805003589','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058464030727',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18606031846','18606031846','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058464030728',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13802609526','13802609526','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225026',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13801333177','13801333177','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225027',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18314463516','18314463516','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225028',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15059157330','15059157330','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225029',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18050929268','18050929268','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225030',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15860517253','15860517253','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225031',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18959218329','18959218329','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225032',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13559593361','13559593361','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058468225033',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15105978225','15105978225','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058472419330',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15060626155','15060626155','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058472419331',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15375754488','15375754488','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058472419332',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18030358668','18030358668','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058472419333',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18959858592','18959858592','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058472419334',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13305967663','13305967663','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058472419335',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13906099888','13906099888','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058472419336',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13799896025','13799896025','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058505973761',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13505082577','13505082577','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058505973762',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13600703008','13600703008','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058505973763',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','17705066726','17705066726','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058510168066',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13559550686','13559550686','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058510168067',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15959599793','15959599793','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058510168068',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13805951761','13805951761','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058510168069',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13163906685','13163906685','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058510168070',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13505902557','13505902557','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058510168071',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13506095562','13506095562','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058510168072',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13559087665','13559087665','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058514362370',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18606989899','18606989899','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058514362371',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13599611717','13599611717','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058514362372',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18050303111','18050303111','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058514362373',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18805956568','18805956568','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058514362374',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13959783399','13959783399','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058514362375',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18815980119','18815980119','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058514362376',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13599109151','13599109151','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058518556673',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18959705077','18959705077','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058518556674',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','13960457127','13960457127','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058518556675',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','18659099600','18659099600','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390214058518556676',NULL,'1390214037165355009',2,2,'批量发送(泉州高层次人才重新认定短信(截止有效日期2021-07-19)20210506)','15880785555','15880785555','【晋江市人才服务平台】尊敬的泉州市高层次人才：您的泉州市高层次人才证书已到期(或即将到期)，请登陆“泉州市高层次人才网”(http://www.qzgccrc.com/)点击“人才政策”，进入“泉州政策”栏目查看“泉州市高层次人才认定规定”该份文件，对照认定标准重新进行人才申报，申报方式：登陆“泉州市高层次人才一站式服务大厅” (http://27.155.98.16/)进入“申报登录”，操作手册可登陆“泉州市高层次人才网”点击“泉州高层次人才‘一站式 ’服务系统操作手册”详阅。(若已重新申报请忽略该条信息)',3,'短信发送成功','2021-05-06 15:57:10',NULL,NULL,NULL,'2021-05-06 15:57:10',NULL,NULL,NULL),('1390471441585057794','1211461407799820290','1390471441585057794',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:00',NULL,NULL,NULL,'2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441627000833','1211554636561956866','1390471441627000833',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:00',NULL,NULL,NULL,'2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441635389442','1211120827064496130','1390471441635389442',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:00',NULL,NULL,NULL,'2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441765412865','58','1390471441765412865',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-07 09:00:00',NULL,NULL,NULL,'2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441819938817','58','1390471441819938817',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-07 09:00:00',NULL,NULL,NULL,'2021-05-07 09:00:00',NULL,NULL,NULL),('1390471462959230977','1211150098789150721','1390471462959230977',2,2,'泉州永实工程质量检测有限公司','15759559009','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471462971813889','1212685717864517633','1390471462971813889',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471462988591105','1211473406755651586','1390471462988591105',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463030534145','87','1390471463030534145',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463030534146','87','1390471463030534146',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463160557570','1211459203080699905','1390471463160557570',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463177334786','102','1390471463177334786',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463177334787','1211474926804975617','1390471463177334787',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463332524034','1211837849989595138','1390471463332524034',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463366078465','1211559758373371905','1390471463366078465',2,2,'福建盼盼食品有限公司','13665929319','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463424798721','102','1390471463424798721',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463500296194','1216568840104734722','1390471463500296194',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463559016450','1211561316616028162','1390471463559016450',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463718400002','1211836173303988226','1390471463718400002',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463718400003','1218097536540147714','1390471463718400003',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463881977857','1211837849989595138','1390471463881977857',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471463894560770','1219241646047223809','1390471463894560770',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464045555713','1241252588561698817','1390471464045555713',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464062332930','1211920348237316098','1390471464062332930',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464217522177','1295900371603947522','1390471464217522177',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464217522178','1211925547903401986','1390471464217522178',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464381100034','1211931259509456897','1390471464381100034',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464406265857','1348924009986654209','1390471464406265857',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464527900674','1212536999949438978','1390471464527900674',2,2,'晋江市医院晋南分院','15396486268','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464574038017','1351830895278948354','1390471464574038017',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464699867138','1212540446794911745','1390471464699867138',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464754393090','1364063273527320578','1390471464754393090',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471464855056385','1212580494957416450','1390471464855056385',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471465010245633','1214020915189272577','1390471465010245633',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471465161240578','1214097817526620161','1390471465161240578',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471465312235521','1215207699331989506','1390471465312235521',2,2,'晋江市医院','18350528526','63,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471465475813378','1215532466647908353','1390471465475813378',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471465631002625','1218097536540147714','1390471465631002625',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471465811357698','1219140374220627970','1390471465811357698',2,2,'福建亲亲股份有限公司','15960735252','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471465979129858','1219144052960780289','1390471465979129858',2,2,'福建冠泓工业有限公司','15396395062','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471466134319106','1219147136575332354','1390471466134319106',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471466285314050','1219241646047223809','1390471466285314050',2,2,'福建晋江农村商业银行股份有限公司','15260663037','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471466440503297','1219451161745080321','1390471466440503297',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:05',NULL,NULL,NULL,'2021-05-07 09:00:05',NULL,NULL,NULL),('1390471466591498242','1219530010977681410','1390471466591498242',2,2,'福州博厚教育有限公司泉州分公司','18659822322','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:06',NULL,NULL,NULL,'2021-05-07 09:00:06',NULL,NULL,NULL),('1390471466755076098','1291608243923095553','1390471466755076098',2,2,'福建意乐焙宝生物科技有限公司','15559079841','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:06',NULL,NULL,NULL,'2021-05-07 09:00:06',NULL,NULL,NULL),('1390471466927042562','1372467780753924097','1390471466927042562',2,2,'晋江市嘉景汽车配件有限公司','13636905586','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:06',NULL,NULL,NULL,'2021-05-07 09:00:06',NULL,NULL,NULL),('1390471467090620417','1374909187762532354','1390471467090620417',2,2,'福建锦科新材料有限责任公司','15959999006','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-07 09:00:06',NULL,NULL,NULL,'2021-05-07 09:00:06',NULL,NULL,NULL),('1390563335937765377',NULL,'1390563335937765377',2,1,NULL,'15959982171','174040','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-07 15:05:09',NULL,NULL,NULL,'2021-05-07 15:05:09',NULL,NULL,NULL),('1390563769809154049',NULL,'1390563769809154049',2,1,NULL,'15959982171','885267','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-07 15:06:52',NULL,NULL,NULL,'2021-05-07 15:06:52',NULL,NULL,NULL),('1390587152101847041',NULL,'1390587152101847041',2,1,NULL,'15959982171','823409','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-07 16:39:47',NULL,NULL,NULL,'2021-05-07 16:39:47',NULL,NULL,NULL),('1391558605219606529','1211120827064496130','1391558605219606529',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:00',NULL,NULL,NULL,'2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605240578050','1211461407799820290','1391558605240578050',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:00',NULL,NULL,NULL,'2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605450293250','1211554636561956866','1391558605450293250',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:00',NULL,NULL,NULL,'2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605496430593','58','1391558605496430593',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-10 09:00:00',NULL,NULL,NULL,'2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605513207809','58','1391558605513207809',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-10 09:00:00',NULL,NULL,NULL,'2021-05-10 09:00:00',NULL,NULL,NULL),('1391558626715414530','1211450215958102018','1391558626715414530',2,2,'福建夜光达科技股份有限公司','15659878695','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626786717698','87','1391558626786717698',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626786717699','87','1391558626786717699',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626795106306','1211473406755651586','1391558626795106306',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626904158210','1212685717864517633','1391558626904158210',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626904158211','1211456847907700737','1391558626904158211',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626958684162','102','1391558626958684162',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626958684163','102','1391558626958684163',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558626996432897','1211474926804975617','1391558626996432897',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627122262017','1211525473977286657','1391558627122262017',2,2,'凯毅（福建）体育用品有限公司','18960357668','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627168399362','1211837849989595138','1391558627168399362',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627294228481','1211548619757371393','1391558627294228481',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627315200002','1216568840104734722','1391558627315200002',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627470389250','1218097536540147714','1391558627470389250',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627487166466','1211559758373371905','1391558627487166466',2,2,'福建盼盼食品有限公司','13665929319','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627629772801','1219241646047223809','1391558627629772801',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627646550018','1211561316616028162','1391558627646550018',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627780767745','1241252588561698817','1391558627780767745',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627873042434','1211576021401255937','1391558627873042434',2,2,'泉州鑫豪工程机械科技有限公司','18900399682','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558627935956993','1295900371603947522','1391558627935956993',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628045008898','1211836173303988226','1391558628045008898',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628086951938','1348924009986654209','1391558628086951938',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628204392449','1211837849989595138','1391558628204392449',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628254724098','1351830895278948354','1391558628254724098',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628367970306','1211920348237316098','1391558628367970306',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628443467777','1364063273527320578','1391558628443467777',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628577685505','1211931259509456897','1391558628577685505',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628737069057','1212535414099873794','1391558628737069057',2,2,'安踏体育用品集团有限公司','18120662230','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558628900646913','1212536999949438978','1391558628900646913',2,2,'晋江市医院晋南分院','15396486268','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558629051641857','1212580494957416450','1391558629051641857',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558629651427330','1212620045818073089','1391558629651427330',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558629856948226','1212665763958165505','1391558629856948226',2,2,'泉州安踏鞋材有限公司','18250638258','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558630041497601','1213031390673702913','1391558630041497601',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:05',NULL,NULL,NULL,'2021-05-10 09:00:05',NULL,NULL,NULL),('1391558630200881153','1214020915189272577','1391558630200881153',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558630431567874','1214041673798012930','1391558630431567874',2,2,'福建省全杰生物科技有限公司','19905050771','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558630599340034','1214079030446280705','1391558630599340034',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558630804860929','1214097817526620161','1391558630804860929',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558630976827393','1214142410787934209','1391558630976827393',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558631136210946','1214821655621230594','1391558631136210946',2,2,'福建省百安物业服务有限公司晋江分公司','13489848301','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558631295594498','1215532466647908353','1391558631295594498',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558631446589441','1215550908977430529','1391558631446589441',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558631618555905','1218097536540147714','1391558631618555905',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558631786328066','1218376015684952065','1391558631786328066',2,2,'福建省兴泰物业管理有限公司','15260225737','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558631954100225','1219140374220627970','1391558631954100225',2,2,'福建亲亲股份有限公司','15960735252','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558632134455298','1219144052960780289','1391558632134455298',2,2,'福建冠泓工业有限公司','15396395062','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558632293838849','1219147136575332354','1391558632293838849',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558632449028098','1219451161745080321','1391558632449028098',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558632600023042','1220180021985951745','1391558632600023042',2,2,'晋江市新合发塑胶印刷有限公司','13599703460','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558632755212290','1275260777149808641','1391558632755212290',2,2,'晋江海纳机械有限公司','15159875837','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391558632910401538','1338784953806094337','1391558632910401538',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-10 09:00:06',NULL,NULL,NULL,'2021-05-10 09:00:06',NULL,NULL,NULL),('1391920992955183106','1211461407799820290','1391920992955183106',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:00',NULL,NULL,NULL,'2021-05-11 09:00:00',NULL,NULL,NULL),('1391920992955183107','1211554636561956866','1391920992955183107',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:00',NULL,NULL,NULL,'2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993122955265','1211120827064496130','1391920993122955265',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:00',NULL,NULL,NULL,'2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993190064130','58','1391920993190064130',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-11 09:00:00',NULL,NULL,NULL,'2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993190064131','58','1391920993190064131',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-11 09:00:00',NULL,NULL,NULL,'2021-05-11 09:00:00',NULL,NULL,NULL),('1391921014329356290','1211473406755651586','1391921014329356290',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014333550594','1212685717864517633','1391921014333550594',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014371299329','1211456847907700737','1391921014371299329',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014413242370','87','1391921014413242370',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014417436673','87','1391921014417436673',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014492934146','1211474926804975617','1391921014492934146',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014543265793','1211548619757371393','1391921014543265793',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014581014530','102','1391921014581014530',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014593597441','102','1391921014593597441',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014702649346','1211837849989595138','1391921014702649346',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014711037953','1211561316616028162','1391921014711037953',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014870421506','1211837849989595138','1391921014870421506',2,2,'利郎（中国）有限公司','15959420909','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921014916558850','1216568840104734722','1391921014916558850',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015017222145','1211920348237316098','1391921015017222145',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015075942402','1219241646047223809','1391921015075942402',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015189188610','1211931259509456897','1391921015189188610',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015247908865','1241252588561698817','1391921015247908865',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015348572162','1212536999949438978','1391921015348572162',2,2,'晋江市医院晋南分院','15396486268','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015415681025','1295900371603947522','1391921015415681025',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015512150017','1212580494957416450','1391921015512150017',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015579258881','1348924009986654209','1391921015579258881',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015675727873','1212620045818073089','1391921015675727873',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015755419649','1351830895278948354','1391921015755419649',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921015851888641','1212626739503632385','1391921015851888641',2,2,'晋江宏基机械有限公司','15905958858','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016011272193','1212665763958165505','1391921016011272193',2,2,'泉州安踏鞋材有限公司','18250638258','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016015466498','1364063273527320578','1391921016015466498',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016183238657','1213031390673702913','1391921016183238657',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016191627265','1374554432229978113','1391921016191627265',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016338427905','1213274113339101185','1391921016338427905',2,2,'福建省群策环境检测有限公司','17758709290','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016489422850','1214020915189272577','1391921016489422850',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016657195009','1214079030446280705','1391921016657195009',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016812384257','1214097817526620161','1391921016812384257',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921016967573505','1214142410787934209','1391921016967573505',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921017135345665','1215550908977430529','1391921017135345665',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921017286340609','1215568298586980354','1391921017286340609',2,2,'福建永恒能源管理有限公司','19959813350','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921017449918466','1218097536540147714','1391921017449918466',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921017596719106','1218376015684952065','1391921017596719106',2,2,'福建省兴泰物业管理有限公司','15260225737','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921017756102658','1218794464953360385','1391921017756102658',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921017982595073','1219140374220627970','1391921017982595073',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:05',NULL,NULL,NULL,'2021-05-11 09:00:05',NULL,NULL,NULL),('1391921018150367233','1219144052960780289','1391921018150367233',2,2,'福建冠泓工业有限公司','15396395062','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1391921018309750786','1219147136575332354','1391921018309750786',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1391921018469134337','1219166759144251393','1391921018469134337',2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1391921018632712193','1219451161745080321','1391921018632712193',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1391921018792095745','1275260777149808641','1391921018792095745',2,2,'晋江海纳机械有限公司','15159875837','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1391921018943090689','1290207451647430657','1391921018943090689',2,2,'晋江国盛新材料科技有限公司','13860736349','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1391921019106668545','1337321333503033345','1391921019106668545',2,2,'福建晋创置业有限公司','15106023277','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1391921019270246401','1338784953806094337','1391921019270246401',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-11 09:00:06',NULL,NULL,NULL,'2021-05-11 09:00:06',NULL,NULL,NULL),('1392283381034692609','1211554636561956866','1392283381034692609',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:00',NULL,NULL,NULL,'2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381034692610','1211110678463623169','1392283381034692610',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:00',NULL,NULL,NULL,'2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381034692611','1211461407799820290','1392283381034692611',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:00',NULL,NULL,NULL,'2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381307322370','58','1392283381307322370',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-12 09:00:00',NULL,NULL,NULL,'2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381366042626','58','1392283381366042626',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-12 09:00:00',NULL,NULL,NULL,'2021-05-12 09:00:00',NULL,NULL,NULL),('1392283402371117057','1212685717864517633','1392283402371117057',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402383699970','1211473406755651586','1392283402383699970',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402383699971','1211120827064496130','1392283402383699971',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402442420226','87','1392283402442420226',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402475974657','87','1392283402475974657',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402559860738','1211474926804975617','1392283402559860738',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402564055042','1211240519515090946','1392283402564055042',2,2,'晋江友峰鞋业有限公司','15306089555','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402585026561','102','1392283402585026561',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402639552513','102','1392283402639552513',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402719244290','1211453814360555522','1392283402719244290',2,2,'伟志股份公司','15859813817','18,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402761187329','1211837849989595138','1392283402761187329',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402887016450','1211456847907700737','1392283402887016450',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283402916376577','1216568840104734722','1392283402916376577',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403046400002','1211465260200935426','1392283403046400002',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403109314562','1219241646047223809','1392283403109314562',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403209977858','1211490446086291458','1392283403209977858',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403277086721','1241252588561698817','1392283403277086721',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403365167105','1211490953219588098','1392283403365167105',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403453247489','1295900371603947522','1392283403453247489',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403528744962','1211548619757371393','1392283403528744962',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403650379778','1348924009986654209','1392283403650379778',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403683934209','1211561316616028162','1392283403683934209',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403809763329','1351830895278948354','1392283403809763329',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403834929154','1211837849989595138','1392283403834929154',2,2,'利郎（中国）有限公司','15959420909','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403960758274','1364063273527320578','1392283403960758274',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283403998507010','1211931259509456897','1392283403998507010',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283404128530434','1374554432229978113','1392283404128530434',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283404141113346','1212561377781157890','1392283404141113346',2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283404304691202','1212568548061286401','1392283404304691202',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283404455686146','1212580494957416450','1392283404455686146',2,2,'舒华体育股份有限公司','13599295908','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283404619264001','1212620045818073089','1392283404619264001',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283404812201986','1212626739503632385','1392283404812201986',2,2,'晋江宏基机械有限公司','15905958858','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283404963196929','1212665763958165505','1392283404963196929',2,2,'泉州安踏鞋材有限公司','18250638258','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283405126774786','1213274113339101185','1392283405126774786',2,2,'福建省群策环境检测有限公司','17758709290','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283405290352641','1214020915189272577','1392283405290352641',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283405453930497','1214079030446280705','1392283405453930497',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283405613314050','1214097817526620161','1392283405613314050',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283405768503298','1214142410787934209','1392283405768503298',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:05',NULL,NULL,NULL,'2021-05-12 09:00:05',NULL,NULL,NULL),('1392283405974024193','1215100340257472514','1392283405974024193',2,2,'晋江万兴隆染织实业有限公司','15880742575','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283406129213442','1215550908977430529','1392283406129213442',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283406284402690','1215608523329683457','1392283406284402690',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283406435397634','1218097536540147714','1392283406435397634',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283406586392577','1218794464953360385','1392283406586392577',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283406758359041','1219140374220627970','1392283406758359041',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283406921936897','1219144052960780289','1392283406921936897',2,2,'福建冠泓工业有限公司','15396395062','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283407085514754','1219147136575332354','1392283407085514754',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283407244898305','1219166759144251393','1392283407244898305',2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283407408476162','1219451161745080321','1392283407408476162',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283407563665409','1275260777149808641','1392283407563665409',2,2,'晋江海纳机械有限公司','15159875837','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283407865655298','1277434198482796545','1392283407865655298',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283408016650241','1290207451647430657','1392283408016650241',2,2,'晋江国盛新材料科技有限公司','13860736349','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283408238948353','1294076991682641922','1392283408238948353',2,2,'福建意尔康体育用品有限公司','15905071236','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392283408410914818','1338784953806094337','1392283408410914818',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 09:00:06',NULL,NULL,NULL,'2021-05-12 09:00:06',NULL,NULL,NULL),('1392287945402134529',NULL,'1392287945402134529',2,1,NULL,'13799555666','803439','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-12 09:18:08',NULL,NULL,NULL,'2021-05-12 09:18:08',NULL,NULL,NULL),('1392386721559130113',NULL,'1392386721559130113',2,1,NULL,'13850718606','605115','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-12 15:50:38',NULL,NULL,NULL,'2021-05-12 15:50:38',NULL,NULL,NULL),('1392396800912044033',NULL,'1392396800912044033',2,1,NULL,'13960937795','183998','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-12 16:30:41',NULL,NULL,NULL,'2021-05-12 16:30:41',NULL,NULL,NULL),('1392406967913328642','1392396939873529858','1392406967913328642',2,2,'晋江市万芯晨电子科技有限公司','13960937795','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-12 17:11:05',NULL,NULL,NULL,'2021-05-12 17:11:05',NULL,NULL,NULL),('1392425904919064578',NULL,'1392425904919064578',2,1,NULL,'15905909478','472166','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-12 18:26:20',NULL,NULL,NULL,'2021-05-12 18:26:20',NULL,NULL,NULL),('1392426837019242497','1392426372634292225','1392426837019242497',2,2,'晋江三伍微电子有限公司','15905909478','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-12 18:30:02',NULL,NULL,NULL,'2021-05-12 18:30:02',NULL,NULL,NULL),('1392645768845766658','1211110678463623169','1392645768845766658',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:00',NULL,NULL,NULL,'2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768896098305','1211461407799820290','1392645768896098305',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:00',NULL,NULL,NULL,'2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768912875522','1211554636561956866','1392645768912875522',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:00',NULL,NULL,NULL,'2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768975790082','58','1392645768975790082',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-13 09:00:00',NULL,NULL,NULL,'2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768975790083','58','1392645768975790083',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-13 09:00:00',NULL,NULL,NULL,'2021-05-13 09:00:00',NULL,NULL,NULL),('1392645790215745537','1211120827064496130','1392645790215745537',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790215745538','1211473406755651586','1392645790215745538',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790215745539','1212685717864517633','1392645790215745539',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790291243010','87','1392645790291243010',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790299631618','87','1392645790299631618',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790446432257','1211240519515090946','1392645790446432257',2,2,'晋江友峰鞋业有限公司','15306089555','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790454820865','1211474926804975617','1392645790454820865',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790463209474','102','1392645790463209474',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790467403778','102','1392645790467403778',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790614204417','1211837849989595138','1392645790614204417',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790626787329','1211453814360555522','1392645790626787329',2,2,'伟志股份公司','15859813817','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790781976578','1216568840104734722','1392645790781976578',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790781976579','1211456847907700737','1392645790781976579',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790941360129','1211460115408928770','1392645790941360129',2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645790949748737','1219241646047223809','1392645790949748737',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791113326593','1211460918949494786','1392645791113326593',2,2,'大发科技集团有限公司','18959857088','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791155269634','1241252588561698817','1392645791155269634',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791268515841','1211465260200935426','1392645791268515841',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791318847489','1295900371603947522','1392645791318847489',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791448870914','1211467701302640642','1392645791448870914',2,2,'福建凤竹环保有限公司','13365978588','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791478231041','1348924009986654209','1392645791478231041',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791620837377','1211489025517469698','1392645791620837377',2,2,'泉州星城纸业有限公司','15959856777','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791625031681','1351830895278948354','1392645791625031681',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791780220930','1364063273527320578','1392645791780220930',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791784415234','1211490446086291458','1392645791784415234',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791943798785','1211490953219588098','1392645791943798785',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645791943798786','1374554432229978113','1392645791943798786',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645792111570945','1211492544651771905','1392645792111570945',2,2,'福建省晋江凯燕新材料研究院有限公司','13255957226','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645792270954497','1211535199725207554','1392645792270954497',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645792426143746','1211548619757371393','1392645792426143746',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645792598110209','1211561316616028162','1392645792598110209',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645792757493762','1211837828162437121','1392645792757493762',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645792929460225','1211837849989595138','1392645792929460225',2,2,'利郎（中国）有限公司','15959420909','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645793172729857','1211931259509456897','1392645793172729857',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645793336307714','1211936041519333377','1392645793336307714',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645793491496962','1212561377781157890','1392645793491496962',2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645793692823553','1212580494957416450','1392645793692823553',2,2,'舒华体育股份有限公司','13599295908','9,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:05',NULL,NULL,NULL,'2021-05-13 09:00:05',NULL,NULL,NULL),('1392645793877372929','1212604591955316738','1392645793877372929',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645794049339393','1212620045818073089','1392645794049339393',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645794221305857','1212627500790779906','1392645794221305857',2,2,'福建省烨烽软件科技有限公司','13905050770','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645794384883713','1212665763958165505','1392645794384883713',2,2,'泉州安踏鞋材有限公司','18250638258','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645794590404610','1214020915189272577','1392645794590404610',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645794745593858','1214079030446280705','1392645794745593858',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645794946920449','1214097817526620161','1392645794946920449',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645795127275522','1215100340257472514','1392645795127275522',2,2,'晋江万兴隆染织实业有限公司','15880742575','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645795286659073','1215550908977430529','1392645795286659073',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645795538317314','1215608523329683457','1392645795538317314',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645795697700866','1218097536540147714','1392645795697700866',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645795857084417','1219140374220627970','1392645795857084417',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645796008079362','1219147136575332354','1392645796008079362',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645796163268609','1219166759144251393','1392645796163268609',2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645796318457857','1219451161745080321','1392645796318457857',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645796477841410','1275240508809068545','1392645796477841410',2,2,'福建省百亩洋农业科技有限公司','13905966797','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645796633030658','1275632103135952897','1392645796633030658',2,2,'福建省信芯长盈科技有限公司','15059788121','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645796788219906','1277434198482796545','1392645796788219906',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645796943409153','1290207451647430657','1392645796943409153',2,2,'晋江国盛新材料科技有限公司','13860736349','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645797094404098','1294076991682641922','1392645797094404098',2,2,'福建意尔康体育用品有限公司','15905071236','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645797274759169','1316201027820630017','1392645797274759169',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645797442531329','1316537973814112258','1392645797442531329',2,2,'泉州市民顺机动车检测有限公司','19523637289','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645797631275009','1335771058392793090','1392645797631275009',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1392645797794852866','1338784953806094337','1392645797794852866',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-13 09:00:06',NULL,NULL,NULL,'2021-05-13 09:00:06',NULL,NULL,NULL),('1393003235006001153',NULL,'1393003235006001153',2,1,NULL,'13559422543','374745','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-14 08:40:26',NULL,NULL,NULL,'2021-05-14 08:40:26',NULL,NULL,NULL),('1393008156749115394','1211110678463623169','1393008156749115394',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:00',NULL,NULL,NULL,'2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156828807170','58','1393008156828807170',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-14 09:00:00',NULL,NULL,NULL,'2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156862361602','1211554636561956866','1393008156862361602',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:00',NULL,NULL,NULL,'2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156891721729','1211461407799820290','1393008156891721729',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:00',NULL,NULL,NULL,'2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156983996417','58','1393008156983996417',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-14 09:00:00',NULL,NULL,NULL,'2021-05-14 09:00:00',NULL,NULL,NULL),('1393008178098122753','1211120827064496130','1393008178098122753',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178106511362','1211473406755651586','1393008178106511362',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178106511363','1212685717864517633','1393008178106511363',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178165231617','87','1393008178165231617',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178169425922','87','1393008178169425922',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178282672130','1211128473930805250','1393008178282672130',2,2,'福建晋江凤竹鞋业发展有限公司','13959957107','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178295255042','1211474926804975617','1393008178295255042',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178353975297','102','1393008178353975297',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178366558210','102','1393008178366558210',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178446249985','1211837849989595138','1393008178446249985',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178450444289','1211164549680574466','1393008178450444289',2,2,'中乔体育股份有限公司','18659597668','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178601439233','1211453814360555522','1393008178601439233',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178647576578','1216568840104734722','1393008178647576578',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178819543041','1219241646047223809','1393008178819543041',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178966343682','1211456847907700737','1393008178966343682',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008178983120898','1241252588561698817','1393008178983120898',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179176058881','1295900371603947522','1393008179176058881',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179364802562','1211460918949494786','1393008179364802562',2,2,'大发科技集团有限公司','18959857088','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179410939906','1348924009986654209','1393008179410939906',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179549351938','1211535199725207554','1393008179549351938',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179704541186','1351830895278948354','1393008179704541186',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179780038657','1211548619757371393','1393008179780038657',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179918450690','1364063273527320578','1393008179918450690',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008179947810818','1211561316616028162','1393008179947810818',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008180111388673','1374554432229978113','1393008180111388673',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008180119777282','1211837849989595138','1393008180119777282',2,2,'利郎（中国）有限公司','15959420909','8,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008180312715265','1211920348237316098','1393008180312715265',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008180476293121','1211931259509456897','1393008180476293121',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008180665036802','1211936041519333377','1393008180665036802',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008180832808961','1212561377781157890','1393008180832808961',2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008181013164033','1212580494957416450','1393008181013164033',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008181189324802','1212604591955316738','1393008181189324802',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008181361291265','1212665763958165505','1393008181361291265',2,2,'泉州安踏鞋材有限公司','18250638258','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008181524869121','1212903777946898433','1393008181524869121',2,2,'福建兴翼机械有限公司','18606981162','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:05',NULL,NULL,NULL,'2021-05-14 09:00:05',NULL,NULL,NULL),('1393008181705224193','1214020915189272577','1393008181705224193',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008181872996354','1214079030446280705','1393008181872996354',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008182036574210','1214097817526620161','1393008182036574210',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008182212734977','1215100340257472514','1393008182212734977',2,2,'晋江万兴隆染织实业有限公司','15880742575','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008182518919170','1215550908977430529','1393008182518919170',2,2,'晋江邓禄普太古飞机轮胎有限公司','18959995205','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008182686691329','1215608523329683457','1393008182686691329',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008182862852098','1218097536540147714','1393008182862852098',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008183022235650','1219140374220627970','1393008183022235650',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008183206785026','1219147136575332354','1393008183206785026',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008183378751489','1219166759144251393','1393008183378751489',2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008183550717953','1219451161745080321','1393008183550717953',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008183722684418','1277434198482796545','1393008183722684418',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008184045645825','1290207451647430657','1393008184045645825',2,2,'晋江国盛新材料科技有限公司','13860736349','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008184230195201','1291608243923095553','1393008184230195201',2,2,'福建意乐焙宝生物科技有限公司','15559079841','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008184406355970','1316201027820630017','1393008184406355970',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008184590905346','1316537973814112258','1393008184590905346',2,2,'泉州市民顺机动车检测有限公司','19523637289','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008184771260418','1328179674966147074','1393008184771260418',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008184939032578','1338784953806094337','1393008184939032578',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393008185131970561','1339090713744244738','1393008185131970561',2,2,'梅花(晋江)伞业有限公司','13489319022','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-14 09:00:06',NULL,NULL,NULL,'2021-05-14 09:00:06',NULL,NULL,NULL),('1393054608120655873',NULL,'1393054608120655873',2,1,NULL,'18959906986','804273','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-14 12:04:34',NULL,NULL,NULL,'2021-05-14 12:04:34',NULL,NULL,NULL),('1393090119409381377',NULL,'1393090119409381377',2,1,NULL,'18959906986','836652','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-14 14:25:41',NULL,NULL,NULL,'2021-05-14 14:25:41',NULL,NULL,NULL),('1393093058412720129','1392396939873529858','1393093058412720129',2,2,'晋江万芯晨电子科技有限公司','13960937795','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-14 14:37:22',NULL,NULL,NULL,'2021-05-14 14:37:22',NULL,NULL,NULL),('1393131143477374978',NULL,'1393131143477374978',2,1,NULL,'18959906986','380276','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-14 17:08:42',NULL,NULL,NULL,'2021-05-14 17:08:42',NULL,NULL,NULL),('1393132469200400386','1393131543144214530','1393132469200400386',2,2,'泉州思力科电子科技有限公司','18959906986','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-14 17:13:58',NULL,NULL,NULL,'2021-05-14 17:13:58',NULL,NULL,NULL),('1393250135047188482',NULL,'1393250135047188482',2,1,NULL,'17715839505','502183','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-15 01:01:32',NULL,NULL,NULL,'2021-05-15 01:01:32',NULL,NULL,NULL),('1393253412895764481',NULL,'1393253412895764481',2,1,NULL,'17715839505','401237','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-15 01:14:33',NULL,NULL,NULL,'2021-05-15 01:14:33',NULL,NULL,NULL),('1394095320161366017','1211120827064496130','1394095320161366017',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320278806529','1211554636561956866','1394095320278806529',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320287195137','1211461407799820290','1394095320287195137',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320425607170','58','1394095320425607170',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320433995777','58','1394095320433995777',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320538853378','1211453814360555522','1394095320538853378',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320597573633','1212685717864517633','1394095320597573633',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320597573634','1211473406755651586','1394095320597573634',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320761151489','1211456847907700737','1394095320761151489',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320761151490','1211474926804975617','1394095320761151490',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320794705921','87','1394095320794705921',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320828260353','87','1394095320828260353',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320916340738','1211837849989595138','1394095320916340738',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320987643905','102','1394095320987643905',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320987643906','1211471774600970241','1394095320987643906',2,2,'泉州鸿展模具制造有限公司','18959708027','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321046364161','102','1394095321046364161',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321071529985','1216568840104734722','1394095321071529985',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321188970497','1211473406755651586','1394095321188970497',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321218330626','1219241646047223809','1394095321218330626',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321335771138','1211476436687306754','1394095321335771138',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321373519874','1241252588561698817','1394095321373519874',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321490960385','1211489025517469698','1394095321490960385',2,2,'泉州星城纸业有限公司','15959856777','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321549680641','1295900371603947522','1394095321549680641',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321675509762','1211491083737939970','1394095321675509762',2,2,'晋江市三福纺织实业有限公司','15959566799','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321696481281','1348924009986654209','1394095321696481281',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321822310401','1211515979058692097','1394095321822310401',2,2,'福建佶龙机械科技股份有限公司','15960791997','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321872642050','1351830895278948354','1394095321872642050',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095321981693954','1211529007779069954','1394095321981693954',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322052997122','1364063273527320578','1394095322052997122',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322132688898','1211548619757371393','1394095322132688898',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322212380674','1374554432229978113','1394095322212380674',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322287878145','1211561316616028162','1394095322287878145',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322451456002','1211819923995672577','1394095322451456002',2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322610839554','1211837849989595138','1394095322610839554',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322766028802','1211920348237316098','1394095322766028802',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095322921218049','1211931259509456897','1394095322921218049',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095323076407297','1212561377781157890','1394095323076407297',2,2,'泉州育英服装有限公司','13860706464','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095323223207938','1212604591955316738','1394095323223207938',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095323386785793','1212675031784558593','1394095323386785793',2,2,'晋江市聚艺健身有限公司','18900300373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095323554557954','1212930369930727426','1394095323554557954',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095323722330114','1213100306318036993','1394095323722330114',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095323873325057','1213376299297476609','1394095323873325057',2,2,'福建省海峡建设发展有限公司','15805967556','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095324028514305','1214017346281164801','1394095324028514305',2,2,'晋江富海鸿汽车贸易有限公司','18050888018','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095324196286465','1214097817526620161','1394095324196286465',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:00',NULL,NULL,NULL,'2021-05-17 09:00:00',NULL,NULL,NULL),('1394095324359864321','1214106170453676034','1394095324359864321',2,2,'晋江丰顺食品有限公司','13850777672','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095324506664962','1214375861688553474','1394095324506664962',2,2,'晋江一岂科技有限公司','13950116705','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095324678631426','1215100340257472514','1394095324678631426',2,2,'晋江万兴隆染织实业有限公司','15880742575','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095324833820673','1215207699331989506','1394095324833820673',2,2,'晋江市医院','18350528526','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095325005787137','1215542604263899137','1394095325005787137',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095325169364994','1216185557357457410','1394095325169364994',2,2,'晋江太古飞机复合材料有限公司','18959996091','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095325324554242','1216609110485639170','1394095325324554242',2,2,'泉州时空文化传媒有限公司','13905985153','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095325467160577','1218097536540147714','1394095325467160577',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095325626544129','1219140374220627970','1394095325626544129',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095325790121985','1219147136575332354','1394095325790121985',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095325949505537','1219166759144251393','1394095325949505537',2,2,'泉州市诺伊曼信息科技股份公司','13850752082','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095326108889089','1219451161745080321','1394095326108889089',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095326259884033','1286499346338045953','1394095326259884033',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095326410878978','1290207451647430657','1394095326410878978',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095326561873921','1314481312186277890','1394095326561873921',2,2,'福建逸锦化纤有限公司','19905065506','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095326738034690','1316201027820630017','1394095326738034690',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095326884835329','1316537973814112258','1394095326884835329',2,2,'泉州市民顺机动车检测有限公司','19523637289','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095327040024577','1328179674966147074','1394095327040024577',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095327186825217','1338784953806094337','1394095327186825217',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394095327333625858','1339103086685192194','1394095327333625858',2,2,'奇峰(福建)食品有限公司','15260850530','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-17 09:00:01',NULL,NULL,NULL,'2021-05-17 09:00:01',NULL,NULL,NULL),('1394294204535975938',NULL,'1394294204535975938',2,1,NULL,'15059066119','111014','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-17 22:10:17',NULL,NULL,NULL,'2021-05-17 22:10:17',NULL,NULL,NULL),('1394457708136017921','1211453814360555522','1394457708136017921',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:00',NULL,NULL,NULL,'2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708169572354','1211120827064496130','1394457708169572354',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:00',NULL,NULL,NULL,'2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708194738177','1211554636561956866','1394457708194738177',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:00',NULL,NULL,NULL,'2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708270235650','58','1394457708270235650',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-18 09:00:00',NULL,NULL,NULL,'2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708291207169','58','1394457708291207169',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-18 09:00:00',NULL,NULL,NULL,'2021-05-18 09:00:00',NULL,NULL,NULL),('1394457729522774017','1212685717864517633','1394457729522774017',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729522774018','87','1394457729522774018',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729543745538','87','1394457729543745538',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729543745539','1211473406755651586','1394457729543745539',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729543745540','1211461407799820290','1394457729543745540',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729761849345','1211473406755651586','1394457729761849345',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729828958210','102','1394457729828958210',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729912844290','1211474926804975617','1394457729912844290',2,2,'泉州轻工职业学院','13799550180','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729963175938','1211474926804975617','1394457729963175938',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457729992536065','102','1394457729992536065',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730114170882','1211476436687306754','1394457730114170882',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730177085442','1216568840104734722','1394457730177085442',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730332274690','1211489025517469698','1394457730332274690',2,2,'泉州星城纸业有限公司','15959856777','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730336468994','1219241646047223809','1394457730336468994',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730500046850','1211515979058692097','1394457730500046850',2,2,'福建佶龙机械科技股份有限公司','15960791997','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730500046851','1241252588561698817','1394457730500046851',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730659430401','1211529007779069954','1394457730659430401',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730701373442','1295900371603947522','1394457730701373442',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730885922818','1211548619757371393','1394457730885922818',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457730940448769','1348924009986654209','1394457730940448769',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731062083586','1211561316616028162','1394457731062083586',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731145969666','1351830895278948354','1394457731145969666',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731225661441','1211819923995672577','1394457731225661441',2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731372462081','1211837849989595138','1394457731372462081',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731435376641','1364063273527320578','1394457731435376641',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731527651330','1211931259509456897','1394457731527651330',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731590565890','1374554432229978113','1394457731590565890',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731678646273','1212604591955316738','1394457731678646273',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731838029825','1212930369930727426','1394457731838029825',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457731984830466','1213376299297476609','1394457731984830466',2,2,'福建省海峡建设发展有限公司','15805967556','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457732140019713','1214106170453676034','1394457732140019713',2,2,'晋江丰顺食品有限公司','13850777672','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457732295208961','1215207699331989506','1394457732295208961',2,2,'晋江市医院','18350528526','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457732450398210','1215542604263899137','1394457732450398210',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457732630753281','1216185557357457410','1394457732630753281',2,2,'晋江太古飞机复合材料有限公司','18959996091','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457732777553922','1218097536540147714','1394457732777553922',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457732936937473','1219140374220627970','1394457732936937473',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457733096321026','1219147136575332354','1394457733096321026',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:05',NULL,NULL,NULL,'2021-05-18 09:00:05',NULL,NULL,NULL),('1394457733268287490','1219451161745080321','1394457733268287490',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:06',NULL,NULL,NULL,'2021-05-18 09:00:06',NULL,NULL,NULL),('1394457733419282433','1286499346338045953','1394457733419282433',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:06',NULL,NULL,NULL,'2021-05-18 09:00:06',NULL,NULL,NULL),('1394457733578665986','1290207451647430657','1394457733578665986',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:06',NULL,NULL,NULL,'2021-05-18 09:00:06',NULL,NULL,NULL),('1394457733733855234','1314481312186277890','1394457733733855234',2,2,'福建逸锦化纤有限公司','19905065506','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:06',NULL,NULL,NULL,'2021-05-18 09:00:06',NULL,NULL,NULL),('1394457733943570434','1316201027820630017','1394457733943570434',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:06',NULL,NULL,NULL,'2021-05-18 09:00:06',NULL,NULL,NULL),('1394457734144897026','1328179674966147074','1394457734144897026',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:06',NULL,NULL,NULL,'2021-05-18 09:00:06',NULL,NULL,NULL),('1394457734308474882','1338784953806094337','1394457734308474882',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-18 09:00:06',NULL,NULL,NULL,'2021-05-18 09:00:06',NULL,NULL,NULL),('1394488662045011970',NULL,'1394488662045011970',2,1,NULL,'15059217106','794627','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-18 11:03:00',NULL,NULL,NULL,'2021-05-18 11:03:00',NULL,NULL,NULL),('1394490183864332290','1394489136026529794','1394490183864332290',2,2,'福建信同信息科技有限公司','15059217106','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-18 11:09:02',NULL,NULL,NULL,'2021-05-18 11:09:02',NULL,NULL,NULL),('1394647401704239105',NULL,'1394647401704239105',2,1,NULL,'15618496095','264597','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-18 21:33:46',NULL,NULL,NULL,'2021-05-18 21:33:46',NULL,NULL,NULL),('1394816813430255618',NULL,'1394816813430255618',2,1,NULL,'13105090000','325411','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 08:46:57',NULL,NULL,NULL,'2021-05-19 08:46:57',NULL,NULL,NULL),('1394817064769728513',NULL,'1394817064769728513',2,1,NULL,'15859813817','180702','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 08:47:57',NULL,NULL,NULL,'2021-05-19 08:47:57',NULL,NULL,NULL),('1394817526646484994',NULL,'1394817526646484994',2,1,NULL,'18859990000','353906','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 08:49:47',NULL,NULL,NULL,'2021-05-19 08:49:47',NULL,NULL,NULL),('1394818081464823809',NULL,'1394818081464823809',2,1,NULL,'15859813817','800192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 08:51:59',NULL,NULL,NULL,'2021-05-19 08:51:59',NULL,NULL,NULL),('1394820096051949570','1211120827064496130','1394820096051949570',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096072921090','1211554636561956866','1394820096072921090',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096102281218','1210885744126701570','1394820096102281218',2,2,'福建省维德福消防工程有限公司','13505044247','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096249081858','58','1394820096249081858',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096265859073','58','1394820096265859073',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096349745154','83','1394820096349745154',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096467185666','1211441648983130114','1394820096467185666',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096479768577','1212685717864517633','1394820096479768577',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096479768578','1211473406755651586','1394820096479768578',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096580431873','87','1394820096580431873',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096618180610','87','1394820096618180610',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096685289473','1211474926804975617','1394820096685289473',2,2,'泉州轻工职业学院','13799550180','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096685289474','1211453814360555522','1394820096685289474',2,2,'伟志股份公司','15859813817','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096748204034','102','1394820096748204034',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096949530626','1211461407799820290','1394820096949530626',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097020833793','1211476436687306754','1394820097020833793',2,2,'晋江裕福集团有限公司','18759429880','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097020833794','102','1394820097020833794',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097196994562','1211473406755651586','1394820097196994562',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097205383169','1211515979058692097','1394820097205383169',2,2,'福建佶龙机械科技股份有限公司','15960791997','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097360572418','1211529007779069954','1394820097360572418',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097360572419','1211474926804975617','1394820097360572419',2,2,'泉州轻工职业学院','13799550180','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097536733186','1211572731150123009','1394820097536733186',2,2,'三六一度(福建)体育用品有限公司','13600745760','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097557704705','1211548619757371393','1394820097557704705',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097679339522','1211920348237316098','1394820097679339522',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097700311041','1211561316616028162','1394820097700311041',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097838723074','1216568840104734722','1394820097838723074',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820097859694593','1211819923995672577','1394820097859694593',2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098023272449','1219241646047223809','1394820098023272449',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098128130049','1211837849989595138','1394820098128130049',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098212016130','1241252588561698817','1394820098212016130',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098291707906','1211931259509456897','1394820098291707906',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098409148418','1295900371603947522','1394820098409148418',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098434314242','1212604591955316738','1394820098434314242',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098585309185','1348924009986654209','1394820098585309185',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098602086401','1213376299297476609','1394820098602086401',2,2,'福建省海峡建设发展有限公司','15805967556','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098753081345','1215207699331989506','1394820098753081345',2,2,'晋江市医院','18350528526','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098811801601','1351830895278948354','1394820098811801601',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098908270594','1215542604263899137','1394820098908270594',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820098975379457','1364063273527320578','1394820098975379457',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099080237057','1218097536540147714','1394820099080237057',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099134763010','1364861648258506753','1394820099134763010',2,2,'晋江国家体育产业基地发展中心','13215958966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099252203522','1219140374220627970','1394820099252203522',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099369644033','1366943804480856065','1394820099369644033',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099403198466','1219147136575332354','1394820099403198466',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099529027586','1373900784671936513','1394820099529027586',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099562582017','1219451161745080321','1394820099562582017',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099713576962','1374554432229978113','1394820099713576962',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099721965570','1286499346338045953','1394820099721965570',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099881349121','1374922080805564418','1394820099881349121',2,2,'晋江市文物保护中心','18815995111','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820099893932034','1290207451647430657','1394820099893932034',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:00',NULL,NULL,NULL,'2021-05-19 09:00:00',NULL,NULL,NULL),('1394820100061704194','1316201027820630017','1394820100061704194',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:01',NULL,NULL,NULL,'2021-05-19 09:00:01',NULL,NULL,NULL),('1394820100221087746','1328179674966147074','1394820100221087746',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:01',NULL,NULL,NULL,'2021-05-19 09:00:01',NULL,NULL,NULL),('1394820100372082689','1338784953806094337','1394820100372082689',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 09:00:01',NULL,NULL,NULL,'2021-05-19 09:00:01',NULL,NULL,NULL),('1394873629379964929',NULL,'1394873629379964929',2,1,NULL,'18650478001','907462','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 12:32:43',NULL,NULL,NULL,'2021-05-19 12:32:43',NULL,NULL,NULL),('1394875525066960897',NULL,'1394875525066960897',2,1,NULL,'18650478001','594214','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 12:40:15',NULL,NULL,NULL,'2021-05-19 12:40:15',NULL,NULL,NULL),('1394901251455496194',NULL,'1394901251455496194',2,1,NULL,'17759147215','749567','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 14:22:29',NULL,NULL,NULL,'2021-05-19 14:22:29',NULL,NULL,NULL),('1394912297654202369',NULL,'1394912297654202369',2,1,NULL,'13600745895','229634','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 15:06:22',NULL,NULL,NULL,'2021-05-19 15:06:22',NULL,NULL,NULL),('1394912324225118210','1394875586618372097','1394912324225118210',2,2,'晋江市博感电子科技有限公司','18650478001','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-19 15:06:28',NULL,NULL,NULL,'2021-05-19 15:06:28',NULL,NULL,NULL),('1394912705709649922',NULL,'1394912705709649922',2,1,NULL,'13600745895','095563','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 15:07:59',NULL,NULL,NULL,'2021-05-19 15:07:59',NULL,NULL,NULL),('1394913628179705858',NULL,'1394913628179705858',2,1,NULL,'18650478001','957683','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 15:11:39',NULL,NULL,NULL,'2021-05-19 15:11:39',NULL,NULL,NULL),('1394916531669872642','1394875586618372097','1394916531669872642',2,2,'晋江市博感电子科技有限公司','18650478001','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-19 15:23:12',NULL,NULL,NULL,'2021-05-19 15:23:12',NULL,NULL,NULL),('1394922456707280897',NULL,'1394922456707280897',2,1,NULL,'13505055289','503076','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 15:46:44',NULL,NULL,NULL,'2021-05-19 15:46:44',NULL,NULL,NULL),('1394923089246072834',NULL,'1394923089246072834',2,1,NULL,'13505055289','037560','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 15:49:15',NULL,NULL,NULL,'2021-05-19 15:49:15',NULL,NULL,NULL),('1394924653197176833',NULL,'1394924653197176833',2,1,NULL,'13505055289','312428','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 15:55:28',NULL,NULL,NULL,'2021-05-19 15:55:28',NULL,NULL,NULL),('1394940553233215489',NULL,'1394940553233215489',2,1,NULL,'15759724056','788426','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 16:58:39',NULL,NULL,NULL,'2021-05-19 16:58:39',NULL,NULL,NULL),('1394945239935922178',NULL,'1394945239935922178',2,1,NULL,'13575056635','886998','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 17:17:16',NULL,NULL,NULL,'2021-05-19 17:17:16',NULL,NULL,NULL),('1394952421897187329',NULL,'1394952421897187329',2,1,NULL,'15260803666','044263','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 17:45:49',NULL,NULL,NULL,'2021-05-19 17:45:49',NULL,NULL,NULL),('1394952786101186562',NULL,'1394952786101186562',2,1,NULL,'15880720190','109242','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 17:47:15',NULL,NULL,NULL,'2021-05-19 17:47:15',NULL,NULL,NULL),('1394953135717396482',NULL,'1394953135717396482',2,1,NULL,'15260803666','809756','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 17:48:39',NULL,NULL,NULL,'2021-05-19 17:48:39',NULL,NULL,NULL),('1394953230219259905',NULL,'1394953230219259905',2,1,NULL,'15880720190','870756','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 17:49:01',NULL,NULL,NULL,'2021-05-19 17:49:01',NULL,NULL,NULL),('1395017589733765122',NULL,'1395017589733765122',2,1,NULL,'13506060342','242765','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 22:04:46',NULL,NULL,NULL,'2021-05-19 22:04:46',NULL,NULL,NULL),('1395017921423519746',NULL,'1395017921423519746',2,1,NULL,'13506060342','824118','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 22:06:05',NULL,NULL,NULL,'2021-05-19 22:06:05',NULL,NULL,NULL),('1395019388624613378',NULL,'1395019388624613378',2,1,NULL,'13506060342','573082','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 22:11:55',NULL,NULL,NULL,'2021-05-19 22:11:55',NULL,NULL,NULL),('1395019956046835713',NULL,'1395019956046835713',2,1,NULL,'13506060342','508787','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-19 22:14:10',NULL,NULL,NULL,'2021-05-19 22:14:10',NULL,NULL,NULL),('1395169908614017025',NULL,'1395169908614017025',2,1,NULL,'13600759390','441633','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-20 08:10:01',NULL,NULL,NULL,'2021-05-20 08:10:01',NULL,NULL,NULL),('1395179734786158594',NULL,'1395179734786158594',2,1,NULL,'18850547191','022323','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-20 08:49:04',NULL,NULL,NULL,'2021-05-20 08:49:04',NULL,NULL,NULL),('1395182483917549570','1211554636561956866','1395182483917549570',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:00',NULL,NULL,NULL,'2021-05-20 09:00:00',NULL,NULL,NULL),('1395182483930132481','1211120827064496130','1395182483930132481',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:00',NULL,NULL,NULL,'2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484018212865','1210885744126701570','1395182484018212865',2,2,'福建省维德福消防工程有限公司','13505044247','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:00',NULL,NULL,NULL,'2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484089516033','58','1395182484089516033',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-20 09:00:00',NULL,NULL,NULL,'2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484144041986','58','1395182484144041986',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-20 09:00:00',NULL,NULL,NULL,'2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484223733762','83','1395182484223733762',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-20 09:00:00',NULL,NULL,NULL,'2021-05-20 09:00:00',NULL,NULL,NULL),('1395182505329471490','1212685717864517633','1395182505329471490',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505329471491','1211439642532954113','1395182505329471491',2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505329471492','1211473406755651586','1395182505329471492',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505400774658','87','1395182505400774658',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505404968962','87','1395182505404968962',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505484660738','1211474926804975617','1395182505484660738',2,2,'泉州轻工职业学院','13799550180','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505514020865','1211441648983130114','1395182505514020865',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505514020866','1216559724997144578','1395182505514020866',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505665015809','1211515979058692097','1395182505665015809',2,2,'福建佶龙机械科技股份有限公司','15960791997','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505811816450','102','1395182505811816450',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505820205057','1211453814360555522','1395182505820205057',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505820205058','1211529007779069954','1395182505820205058',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505824399362','102','1395182505824399362',1,2,'颜思思','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182505996365825','1211548619757371393','1395182505996365825',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506004754434','1211461407799820290','1395182506004754434',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506147360770','1211561316616028162','1395182506147360770',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506252218370','1211473406755651586','1395182506252218370',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506327715841','1211819923995672577','1395182506327715841',2,2,'福建省卓展信息科技股份有限公司','17350926157','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506407407617','1211474926804975617','1395182506407407617',2,2,'泉州轻工职业学院','13799550180','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506482905090','1211837849989595138','1395182506482905090',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506562596865','1211572731150123009','1395182506562596865',2,2,'三六一度(福建)体育用品有限公司','13600745760','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506659065858','1212604591955316738','1395182506659065858',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506717786114','1211920348237316098','1395182506717786114',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506814255106','1213376299297476609','1395182506814255106',2,2,'福建省海峡建设发展有限公司','15805967556','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506931695617','1216568840104734722','1395182506931695617',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182506982027265','1215207699331989506','1395182506982027265',2,2,'晋江市医院','18350528526','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507120439298','1219241646047223809','1395182507120439298',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507183353857','1215542604263899137','1395182507183353857',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507284017154','1241252588561698817','1395182507284017154',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507338543106','1218097536540147714','1395182507338543106',2,2,'福建浔兴拉链科技股份有限公司','13799855086','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507455983617','1295900371603947522','1395182507455983617',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507506315265','1219140374220627970','1395182507506315265',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507648921602','1348924009986654209','1395182507648921602',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507695058946','1219147136575332354','1395182507695058946',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507804110849','1351830895278948354','1395182507804110849',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507850248194','1219451161745080321','1395182507850248194',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182507976077313','1364063273527320578','1395182507976077313',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508001243138','1286499346338045953','1395182508001243138',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508143849473','1366943804480856065','1395182508143849473',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508219346946','1290207451647430657','1395182508219346946',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508307427330','1373900784671936513','1395182508307427330',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508408090625','1316201027820630017','1395182508408090625',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508471005186','1374554432229978113','1395182508471005186',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508559085570','1328179674966147074','1395182508559085570',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508622000130','1374922080805564418','1395182508622000130',2,2,'晋江市文物保护中心','18815995111','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395182508718469121','1338784953806094337','1395182508718469121',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 09:00:05',NULL,NULL,NULL,'2021-05-20 09:00:05',NULL,NULL,NULL),('1395192035392139265',NULL,'1395192035392139265',2,1,NULL,'15606948991','837209','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-20 09:37:57',NULL,NULL,NULL,'2021-05-20 09:37:57',NULL,NULL,NULL),('1395207578719399938','1395192096893218818','1395207578719399938',2,2,'晋江亿芯源半导体科技有限公司','15606948991','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-20 10:39:43',NULL,NULL,NULL,'2021-05-20 10:39:43',NULL,NULL,NULL),('1395270675517714434',NULL,'1395270675517714434',2,1,NULL,'18359257458','574890','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-20 14:50:26',NULL,NULL,NULL,'2021-05-20 14:50:26',NULL,NULL,NULL),('1395271179400425473',NULL,'1395271179400425473',2,1,NULL,'18359257458','776657','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-20 14:52:26',NULL,NULL,NULL,'2021-05-20 14:52:26',NULL,NULL,NULL),('1395275786495242241',NULL,'1395275786495242241',2,1,NULL,'18050056871','651991','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-20 15:10:45',NULL,NULL,NULL,'2021-05-20 15:10:45',NULL,NULL,NULL),('1395290782692323329','1395192096893218818','1395290782692323329',2,2,'晋江亿芯源半导体科技有限公司','15606948991','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-20 16:10:20',NULL,NULL,NULL,'2021-05-20 16:10:20',NULL,NULL,NULL),('1395291725928378370','1260474359613534209','1395291725928378370',2,2,'晋江市银达锦信息科技有限公司','18359797834','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-20 16:14:05',NULL,NULL,NULL,'2021-05-20 16:14:05',NULL,NULL,NULL),('1395305381994999810',NULL,'1395305381994999810',2,1,NULL,'18559268083','768639','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-20 17:08:21',NULL,NULL,NULL,'2021-05-20 17:08:21',NULL,NULL,NULL),('1395532268784627713',NULL,'1395532268784627713',2,1,NULL,'15057898570','258895','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 08:09:55',NULL,NULL,NULL,'2021-05-21 08:09:55',NULL,NULL,NULL),('1395544871720235010','1211441648983130114','1395544871720235010',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:00',NULL,NULL,NULL,'2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871749595137','1210918631014248450','1395544871749595137',2,2,'茂泰（福建）鞋材有限公司','18959705077','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:00',NULL,NULL,NULL,'2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871749595138','1211095022649323522','1395544871749595138',2,2,'福建晋工机械有限公司','13799553654','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:00',NULL,NULL,NULL,'2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871846064130','58','1395544871846064130',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-21 09:00:00',NULL,NULL,NULL,'2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871896395777','72','1395544871896395777',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-21 09:00:00',NULL,NULL,NULL,'2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871976087554','83','1395544871976087554',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-21 09:00:00',NULL,NULL,NULL,'2021-05-21 09:00:00',NULL,NULL,NULL),('1395544893052465153','1211453814360555522','1395544893052465153',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893060853761','1211120827064496130','1395544893060853761',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893060853762','1211554636561956866','1395544893060853762',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893161517058','58','1395544893161517058',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893220237313','87','1395544893220237313',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893249597441','1211461407799820290','1395544893249597441',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893266374657','1211473406755651586','1395544893266374657',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893299929090','1212685717864517633','1395544893299929090',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893379620865','102','1395544893379620865',1,2,'颜思思','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893429952514','1211465260200935426','1395544893429952514',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893459312642','87','1395544893459312642',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893471895554','1211474926804975617','1395544893471895554',2,2,'泉州轻工职业学院','13799550180','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893572558849','1216559724997144578','1395544893572558849',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893622890498','1211473406755651586','1395544893622890498',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893669027842','1211515979058692097','1395544893669027842',2,2,'福建佶龙机械科技股份有限公司','15960791997','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893669027843','102','1395544893669027843',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893824217089','1211529007779069954','1395544893824217089',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893824217090','1211474926804975617','1395544893824217090',2,2,'泉州轻工职业学院','13799550180','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893979406337','1211572731150123009','1395544893979406337',2,2,'三六一度(福建)体育用品有限公司','13600745760','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544893991989249','1211548619757371393','1395544893991989249',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894142984194','1211920348237316098','1395544894142984194',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894252036097','1211561316616028162','1395544894252036097',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894335922178','1216568840104734722','1395544894335922178',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894407225345','1211837849989595138','1395544894407225345',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894499500034','1241252588561698817','1395544894499500034',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894587580417','1212604591955316738','1395544894587580417',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894671466497','1295900371603947522','1395544894671466497',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894751158274','1215207699331989506','1395544894751158274',2,2,'晋江市医院','18350528526','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894835044353','1301823981006909441','1395544894835044353',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894910541826','1215542604263899137','1395544894910541826',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544894994427906','1348924009986654209','1395544894994427906',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895057342466','1218097536540147714','1395544895057342466',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895153811457','1351830895278948354','1395544895153811457',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895204143105','1219140374220627970','1395544895204143105',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895334166530','1364063273527320578','1395544895334166530',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895346749441','1219147136575332354','1395544895346749441',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895480967169','1366943804480856065','1395544895480967169',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895506132994','1219451161745080321','1395544895506132994',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895627767809','1373900784671936513','1395544895627767809',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895657127937','1286499346338045953','1395544895657127937',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895787151362','1374554432229978113','1395544895787151362',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895820705794','1290207451647430657','1395544895820705794',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895942340610','1374922080805564418','1395544895942340610',2,2,'晋江市文物保护中心','18815995111','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544895988477953','1316201027820630017','1395544895988477953',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544896105918465','1376712565047975937','1395544896105918465',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395544896143667201','1328179674966147074','1395544896143667201',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1395544896332410882','1338784953806094337','1395544896332410882',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-21 09:00:05',NULL,NULL,NULL,'2021-05-21 09:00:05',NULL,NULL,NULL),('1395552887622381570',NULL,'1395552887622381570',2,1,NULL,'13559275295','676072','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 09:31:51',NULL,NULL,NULL,'2021-05-21 09:31:51',NULL,NULL,NULL),('1395561601259581442',NULL,'1395561601259581442',2,1,NULL,'13552399216','957994','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 10:06:28',NULL,NULL,NULL,'2021-05-21 10:06:28',NULL,NULL,NULL),('1395561962221383682',NULL,'1395561962221383682',2,1,NULL,'15759495831','758348','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 10:07:54',NULL,NULL,NULL,'2021-05-21 10:07:54',NULL,NULL,NULL),('1395563011812405249',NULL,'1395563011812405249',2,1,NULL,'15759495831','789677','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 10:12:04',NULL,NULL,NULL,'2021-05-21 10:12:04',NULL,NULL,NULL),('1395563471633952770',NULL,'1395563471633952770',2,1,NULL,'18318040909','345176','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 10:13:54',NULL,NULL,NULL,'2021-05-21 10:13:54',NULL,NULL,NULL),('1395569874239008769',NULL,'1395569874239008769',2,1,NULL,'15759495831','926446','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 10:39:21',NULL,NULL,NULL,'2021-05-21 10:39:21',NULL,NULL,NULL),('1395572223661617153',NULL,'1395572223661617153',2,1,NULL,'18318040909','084695','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 10:48:41',NULL,NULL,NULL,'2021-05-21 10:48:41',NULL,NULL,NULL),('1395573553931268098',NULL,'1395573553931268098',2,1,NULL,'18318040909','251750','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 10:53:58',NULL,NULL,NULL,'2021-05-21 10:53:58',NULL,NULL,NULL),('1395623024006311937',NULL,'1395623024006311937',2,1,NULL,'13906099888','832525','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 14:10:33',NULL,NULL,NULL,'2021-05-21 14:10:33',NULL,NULL,NULL),('1395637722403614721',NULL,'1395637722403614721',2,1,NULL,'13599991214','567402','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 15:08:57',NULL,NULL,NULL,'2021-05-21 15:08:57',NULL,NULL,NULL),('1395653620782903298','1395562221148352513','1395653620782903298',2,2,'泉州凡硕知识产权代理有限公司','15759495831','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-21 16:12:07',NULL,NULL,NULL,'2021-05-21 16:12:07',NULL,NULL,NULL),('1395653954955685890','1395563657722638337','1395653954955685890',2,2,'晋江汇杰企业管理有限责任公司','18318040909','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-21 16:13:27',NULL,NULL,NULL,'2021-05-21 16:13:27',NULL,NULL,NULL),('1395667813217120258',NULL,'1395667813217120258',2,1,NULL,'15905958001','946793','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 17:08:31',NULL,NULL,NULL,'2021-05-21 17:08:31',NULL,NULL,NULL),('1395675544493797378',NULL,'1395675544493797378',2,1,NULL,'13400887176','538140','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 17:39:14',NULL,NULL,NULL,'2021-05-21 17:39:14',NULL,NULL,NULL),('1395743334902837250',NULL,'1395743334902837250',2,1,NULL,'18965616589','192565','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 22:08:37',NULL,NULL,NULL,'2021-05-21 22:08:37',NULL,NULL,NULL),('1395744442241036290',NULL,'1395744442241036290',2,1,NULL,'18965616589','465215','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-21 22:13:01',NULL,NULL,NULL,'2021-05-21 22:13:01',NULL,NULL,NULL),('1396123147312345089',NULL,'1396123147312345089',2,1,NULL,'13788805513','679951','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-22 23:17:51',NULL,NULL,NULL,'2021-05-22 23:17:51',NULL,NULL,NULL),('1396632035254120450','1211461407799820290','1396632035254120450',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035384143873','1211117113914273793','1396632035384143873',2,2,'福建柒牌时装科技股份有限公司','13163991887','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035409309698','1211554636561956866','1396632035409309698',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035585470466','58','1396632035585470466',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035635802114','72','1396632035635802114',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035694522370','1211473406755651586','1396632035694522370',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035715493889','83','1396632035715493889',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035803574274','1212685717864517633','1396632035803574274',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035807768577','1211120827064496130','1396632035807768577',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035916820482','58','1396632035916820482',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035937792002','87','1396632035937792002',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035967152129','1211474926804975617','1396632035967152129',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036021678082','1216559724997144578','1396632036021678082',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036063621122','1211473406755651586','1396632036063621122',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036130729986','87','1396632036130729986',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036189450242','1211572731150123009','1396632036189450242',2,2,'三六一度(福建)体育用品有限公司','13600745760','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036256559105','1211474926804975617','1396632036256559105',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036277530625','1211920348237316098','1396632036277530625',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036277530626','102','1396632036277530626',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036436914178','102','1396632036436914178',1,2,'颜思思','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036499828738','1211515979058692097','1396632036499828738',2,2,'福建佶龙机械科技股份有限公司','15960791997','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036524994562','1216568840104734722','1396632036524994562',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036671795201','1211529007779069954','1396632036671795201',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036671795202','1241252588561698817','1396632036671795202',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036826984449','1211548619757371393','1396632036826984449',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036852150273','1295900371603947522','1396632036852150273',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632036994756609','1211561316616028162','1396632036994756609',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037007339521','1348924009986654209','1396632037007339521',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037154140161','1211837849989595138','1396632037154140161',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037170917377','1351830895278948354','1396632037170917377',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037317718017','1212604591955316738','1396632037317718017',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037326106625','1364063273527320578','1396632037326106625',2,2,'福建省辅城网络科技有限公司','18859998598','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037468712962','1215207699331989506','1396632037468712962',2,2,'晋江市医院','18350528526','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037493878786','1366943804480856065','1396632037493878786',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037632290818','1373900784671936513','1396632037632290818',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037632290819','1215542604263899137','1396632037632290819',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037795868673','1374554432229978113','1396632037795868673',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037795868674','1218097536540147714','1396632037795868674',2,2,'福建浔兴拉链科技股份有限公司','13799855086','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037993000962','1376712565047975937','1396632037993000962',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632037997195265','1219140374220627970','1396632037997195265',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038143995906','1393131543144214530','1396632038143995906',2,2,'泉州思力科电子科技有限公司','18959906986','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038156578818','1219147136575332354','1396632038156578818',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038294990849','1394489136026529794','1396632038294990849',2,2,'福建信同信息科技有限公司','15059217106','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038311768065','1219451161745080321','1396632038311768065',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038458568705','1394875586618372097','1396632038458568705',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038475345922','1286499346338045953','1396632038475345922',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038638923777','1290207451647430657','1396632038638923777',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038810890242','1316201027820630017','1396632038810890242',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632038966079490','1328179674966147074','1396632038966079490',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396632039142240257','1338784953806094337','1396632039142240257',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-24 09:00:00',NULL,NULL,NULL,'2021-05-24 09:00:00',NULL,NULL,NULL),('1396728222292422658',NULL,'1396728222292422658',2,1,NULL,'15396277153','006821','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-24 15:22:12',NULL,NULL,NULL,'2021-05-24 15:22:12',NULL,NULL,NULL),('1396746902862606338',NULL,'1396746902862606338',2,1,NULL,'15960125779','667951','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-24 16:36:26',NULL,NULL,NULL,'2021-05-24 16:36:26',NULL,NULL,NULL),('1396747536248647681',NULL,'1396747536248647681',2,1,NULL,'15960125779','210920','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-24 16:38:57',NULL,NULL,NULL,'2021-05-24 16:38:57',NULL,NULL,NULL),('1396747837714247681',NULL,'1396747837714247681',2,1,NULL,'15960125779','378417','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-24 16:40:09',NULL,NULL,NULL,'2021-05-24 16:40:09',NULL,NULL,NULL),('1396815551698874370',NULL,'1396815551698874370',2,1,NULL,'15959566909','373113','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-24 21:09:13',NULL,NULL,NULL,'2021-05-24 21:09:13',NULL,NULL,NULL),('1396994423186829314','1211441648983130114','1396994423186829314',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423186829315','1211120827064496130','1396994423186829315',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423325241346','1211554636561956866','1396994423325241346',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423404933121','58','1396994423404933121',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423438487553','83','1396994423438487553',1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423446876161','72','1396994423446876161',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423597871105','1211461407799820290','1396994423597871105',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423597871106','1211473406755651586','1396994423597871106',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423627231233','1211559758373371905','1396994423627231233',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423736283138','87','1396994423736283138',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423790809089','58','1396994423790809089',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423803392001','1211474926804975617','1396994423803392001',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423811780609','1212685717864517633','1396994423811780609',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423828557826','1211473406755651586','1396994423828557826',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423887278081','102','1396994423887278081',1,2,'颜思思','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423966969858','87','1396994423966969858',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423966969859','1211515979058692097','1396994423966969859',2,2,'福建佶龙机械科技股份有限公司','15960791997','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423975358465','1216559724997144578','1396994423975358465',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423996329985','1211474926804975617','1396994423996329985',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424109576194','102','1396994424109576194',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424122159106','1211529007779069954','1396994424122159106',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424143130625','1211572731150123009','1396994424143130625',2,2,'三六一度(福建)体育用品有限公司','13600745760','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424289931266','1211548619757371393','1396994424289931266',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424298319873','1214097817526620161','1396994424298319873',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424449314817','1211561316616028162','1396994424449314817',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424449314818','1216568840104734722','1396994424449314818',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424625475585','1241252588561698817','1396994424625475585',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424629669890','1211837849989595138','1396994424629669890',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424793247746','1295900371603947522','1396994424793247746',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424797442049','1212604591955316738','1396994424797442049',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424952631298','1315551775847133185','1396994424952631298',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994424965214209','1215207699331989506','1396994424965214209',2,2,'晋江市医院','18350528526','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425107820546','1336570514910478338','1396994425107820546',2,2,'泉州华夏生态养生文化有限公司','18965616589','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425116209153','1215542604263899137','1396994425116209153',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425258815490','1345975175715225602','1396994425258815490',2,2,'泉州凯迪知识产权代理事务所(普通合伙)','15259759208','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425275592706','1218097536540147714','1396994425275592706',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425409810433','1348924009986654209','1396994425409810433',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425439170562','1219140374220627970','1396994425439170562',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425585971201','1351830895278948354','1396994425585971201',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425615331330','1219147136575332354','1396994425615331330',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425753743362','1366943804480856065','1396994425753743362',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425783103489','1219451161745080321','1396994425783103489',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425934098433','1371288651551584257','1396994425934098433',2,2,'泉州市爱优恩纺织品科技有限公司','13506003779','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994425980235777','1286499346338045953','1396994425980235777',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426097676290','1373900784671936513','1396994426097676290',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426152202242','1290207451647430657','1396994426152202242',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426261254146','1374554432229978113','1396994426261254146',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426336751617','1316201027820630017','1396994426336751617',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426437414913','1376712565047975937','1396994426437414913',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426491940866','1328179674966147074','1396994426491940866',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426609381378','1394875586618372097','1396994426609381378',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396994426693267457','1338784953806094337','1396994426693267457',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:00:00',NULL,NULL,NULL,'2021-05-25 09:00:00',NULL,NULL,NULL),('1396997389159542786','1396123284294119425','1396997389159542786',2,2,'晋江市润丰鞋业有限公司','13788805513','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:11:47',NULL,NULL,NULL,'2021-05-25 09:11:47',NULL,NULL,NULL),('1396997597188632578','1396728812565213185','1396997597188632578',2,2,'晋江市娓娓橡塑制品有限公司','15396277153','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-25 09:12:36',NULL,NULL,NULL,'2021-05-25 09:12:36',NULL,NULL,NULL),('1396997899497287682','1394924703138754562','1396997899497287682',2,2,'晋江市南岳中学','13505055289','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-25 09:13:48',NULL,NULL,NULL,'2021-05-25 09:13:48',NULL,NULL,NULL),('1397003854201008130',NULL,'1397003854201008130',2,1,NULL,'15959566909','329273','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-25 09:37:28',NULL,NULL,NULL,'2021-05-25 09:37:28',NULL,NULL,NULL),('1397005552755716098',NULL,'1397005552755716098',2,1,NULL,'15959566909','317125','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-25 09:44:13',NULL,NULL,NULL,'2021-05-25 09:44:13',NULL,NULL,NULL),('1397357919569309698','1316537973814112258','1397357919569309698',2,2,'泉州市民顺机动车检测有限公司','17895957919','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-26 09:04:24',NULL,NULL,NULL,'2021-05-26 09:04:24',NULL,NULL,NULL),('1397386461459902466','1397005602617602050','1397386461459902466',2,2,'晋江市池店镇兴源武术馆','15959566909','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-26 10:57:49',NULL,NULL,NULL,'2021-05-26 10:57:49',NULL,NULL,NULL),('1397399209463902210',NULL,'1397399209463902210',2,1,NULL,'13600700773','028109','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-26 11:48:28',NULL,NULL,NULL,'2021-05-26 11:48:28',NULL,NULL,NULL),('1397401105331253250',NULL,'1397401105331253250',2,1,NULL,'13600700773','846426','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-26 11:56:00',NULL,NULL,NULL,'2021-05-26 11:56:00',NULL,NULL,NULL),('1397410375963537410',NULL,'1397410375963537410',2,1,NULL,'13600700773','304475','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-26 12:32:50',NULL,NULL,NULL,'2021-05-26 12:32:50',NULL,NULL,NULL),('1397447138056630274',NULL,'1397447138056630274',2,1,NULL,'15960565293','919656','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-26 14:58:55',NULL,NULL,NULL,'2021-05-26 14:58:55',NULL,NULL,NULL),('1397554297658437634',NULL,'1397554297658437634',2,1,NULL,'18850547191','561272','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-26 22:04:44',NULL,NULL,NULL,'2021-05-26 22:04:44',NULL,NULL,NULL),('1397744547290705922',NULL,'1397744547290705922',2,1,NULL,'15810298887','339677','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-27 10:40:43',NULL,NULL,NULL,'2021-05-27 10:40:43',NULL,NULL,NULL),('1397806667755712514',NULL,'1397806667755712514',2,1,NULL,'13860750864','915173','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-27 14:47:34',NULL,NULL,NULL,'2021-05-27 14:47:34',NULL,NULL,NULL),('1397806976955609089',NULL,'1397806976955609089',2,1,NULL,'13860750864','147397','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-27 14:48:47',NULL,NULL,NULL,'2021-05-27 14:48:47',NULL,NULL,NULL),('1397807270024212482',NULL,'1397807270024212482',2,1,NULL,'13860750864','478853','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-27 14:49:57',NULL,NULL,NULL,'2021-05-27 14:49:57',NULL,NULL,NULL),('1397808695286460418',NULL,'1397808695286460418',2,1,NULL,'13860750864','352227','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-27 14:55:37',NULL,NULL,NULL,'2021-05-27 14:55:37',NULL,NULL,NULL),('1397837475686150145',NULL,'1397837475686150145',2,1,NULL,'18959750578','375104','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-27 16:49:59',NULL,NULL,NULL,'2021-05-27 16:49:59',NULL,NULL,NULL),('1397859677655560193',NULL,'1397859677655560193',2,1,NULL,'18805921126','297300','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-27 18:18:12',NULL,NULL,NULL,'2021-05-27 18:18:12',NULL,NULL,NULL),('1397962808632573953',NULL,'1397962808632573953',2,1,NULL,'15960787976','588784','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-28 01:08:01',NULL,NULL,NULL,'2021-05-28 01:08:01',NULL,NULL,NULL),('1398081588025131009','1211453814360555522','1398081588025131009',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588218068993','1211120827064496130','1398081588218068993',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588230651905','1211559758373371905','1398081588230651905',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588918517761','1211473406755651586','1398081588918517761',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588973043714','1212685717864517633','1398081588973043714',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588973043716','1211461407799820290','1398081588973043716',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589178564610','70','1398081589178564610',1,2,'陈瑞清','13788864979','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589241479169','58','1398081589241479169',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589270839298','1211474926804975617','1398081589270839298',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589270839299','72','1398081589270839299',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589497331714','1216559724997144578','1398081589497331714',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589505720322','1211465260200935426','1398081589505720322',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589522497538','76','1398081589522497538',1,2,'陈灿峰','13599718877','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589644132353','58','1398081589644132353',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589686075393','87','1398081589686075393',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589740601345','1211529007779069954','1398081589740601345',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590080339969','1211473406755651586','1398081590080339969',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590080339970','83','1398081590080339970',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590092922882','87','1398081590092922882',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590118088705','1211548619757371393','1398081590118088705',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590143254529','102','1398081590143254529',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590407495681','1211561316616028162','1398081590407495681',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590407495682','1211474926804975617','1398081590407495682',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590407495683','102','1398081590407495683',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590675931137','1212535414099873794','1398081590675931137',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590688514050','1211837849989595138','1398081590688514050',2,2,'利郎（中国）有限公司','15959420909','10,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:00',NULL,NULL,NULL,'2021-05-28 09:00:00',NULL,NULL,NULL),('1398081590994698241','1212604591955316738','1398081590994698241',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081591024058370','1212580494957416450','1398081591024058370',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081591393157122','1218097536540147714','1398081591393157122',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081591560929281','1216568840104734722','1398081591560929281',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081591653203970','1219140374220627970','1398081591653203970',2,2,'福建亲亲股份有限公司','15960735252','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081591762255873','1241252588561698817','1398081591762255873',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081591867113473','1219147136575332354','1398081591867113473',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081591984553986','1295900371603947522','1398081591984553986',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592101994498','1219451161745080321','1398081592101994498',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592202657793','1336570514910478338','1398081592202657793',2,2,'泉州华夏生态养生文化有限公司','18965616589','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592387207169','1286499346338045953','1398081592387207169',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592458510337','1348924009986654209','1398081592458510337',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592609505281','1290207451647430657','1398081592609505281',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592647254018','1351830895278948354','1398081592647254018',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592873746433','1316201027820630017','1398081592873746433',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081592894717953','1366943804480856065','1398081592894717953',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081593100238850','1338784953806094337','1398081593100238850',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081593125404673','1373900784671936513','1398081593125404673',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081593460948993','1374554432229978113','1398081593460948993',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081593725190146','1376712565047975937','1398081593725190146',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398081593972654081','1394875586618372097','1398081593972654081',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-28 09:00:01',NULL,NULL,NULL,'2021-05-28 09:00:01',NULL,NULL,NULL),('1398105386736713729','1397005602617602050','1398105386736713729',2,2,'晋江市池店镇兴源武术馆','15959566909','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-28 10:34:34',NULL,NULL,NULL,'2021-05-28 10:34:34',NULL,NULL,NULL),('1398110458942095361',NULL,'1398110458942095361',2,1,NULL,'18815985602','815973','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-28 10:54:43',NULL,NULL,NULL,'2021-05-28 10:54:43',NULL,NULL,NULL),('1399165671522205697','1397410750934315009','1399165671522205697',2,2,'晋江市英林镇宝质时装织造有限公司','13600700773','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-05-31 08:47:45',NULL,NULL,NULL,'2021-05-31 08:47:45',NULL,NULL,NULL),('1399168750820818945','1211461407799820290','1399168750820818945',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168750862761985','1211559758373371905','1399168750862761985',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168750992785409','1211120827064496130','1399168750992785409',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751408021506','1212685717864517633','1399168751408021506',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751458353154','1211473406755651586','1399168751458353154',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751538044929','58','1399168751538044929',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751647096834','70','1399168751647096834',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751689039874','1211473406755651586','1399168751689039874',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751689039875','72','1399168751689039875',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751856812033','1216559724997144578','1399168751856812033',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751881977857','1211474926804975617','1399168751881977857',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751978446849','1211484578443739137','1399168751978446849',2,2,'晋江市锦福化纤聚合有限公司','13599749329','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752053944321','58','1399168752053944321',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752058138626','87','1399168752058138626',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752058138627','76','1399168752058138627',1,2,'陈灿峰','13599718877','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752129441794','1212535414099873794','1399168752129441794',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752162996226','1211529007779069954','1399168752162996226',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752355934210','87','1399168752355934210',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752360128513','102','1399168752360128513',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752406265858','1216568840104734722','1399168752406265858',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752561455105','1211548619757371393','1399168752561455105',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752599203842','102','1399168752599203842',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752733421570','1241252588561698817','1399168752733421570',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752792141825','1211561316616028162','1399168752792141825',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752909582337','1295900371603947522','1399168752909582337',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168752964108289','1211837849989595138','1399168752964108289',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753098326017','1336570514910478338','1399168753098326017',2,2,'泉州华夏生态养生文化有限公司','18965616589','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753249320961','1212604591955316738','1399168753249320961',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753291264001','1348924009986654209','1399168753291264001',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753438064642','1218097536540147714','1399168753438064642',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753509367810','1351830895278948354','1399168753509367810',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753631002626','1219140374220627970','1399168753631002626',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753685528577','1366943804480856065','1399168753685528577',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753832329218','1219147136575332354','1399168753832329218',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168753853300737','1373900784671936513','1399168753853300737',2,2,'晋江市国邦建材有限公司','15860325253','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168754033655810','1219451161745080321','1399168754033655810',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168754050433025','1374554432229978113','1399168754050433025',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168754239176706','1219868423635353602','1399168754239176706',2,2,'福建省晋江市和盛机械有限公司','13808552366','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168754239176707','1376712565047975937','1399168754239176707',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:00',NULL,NULL,NULL,'2021-05-31 09:00:00',NULL,NULL,NULL),('1399168754423726082','1394875586618372097','1399168754423726082',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:01',NULL,NULL,NULL,'2021-05-31 09:00:01',NULL,NULL,NULL),('1399168754423726083','1286499346338045953','1399168754423726083',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:01',NULL,NULL,NULL,'2021-05-31 09:00:01',NULL,NULL,NULL),('1399168754604081154','1290207451647430657','1399168754604081154',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:01',NULL,NULL,NULL,'2021-05-31 09:00:01',NULL,NULL,NULL),('1399168754809602049','1316201027820630017','1399168754809602049',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:01',NULL,NULL,NULL,'2021-05-31 09:00:01',NULL,NULL,NULL),('1399168755119980546','1338784953806094337','1399168755119980546',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-05-31 09:00:01',NULL,NULL,NULL,'2021-05-31 09:00:01',NULL,NULL,NULL),('1399307794372395010',NULL,'1399307794372395010',2,1,NULL,'15860398018','268999','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-31 18:12:30',NULL,NULL,NULL,'2021-05-31 18:12:30',NULL,NULL,NULL),('1399354795394891777',NULL,'1399354795394891777',2,1,NULL,'13788805513','397494','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-05-31 21:19:16',NULL,NULL,NULL,'2021-05-31 21:19:16',NULL,NULL,NULL),('1399531138745139202','1211461407799820290','1399531138745139202',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531138795470849','1211559758373371905','1399531138795470849',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531138891939842','1211120827064496130','1399531138891939842',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139244261377','58','1399531139244261377',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139269427201','72','1399531139269427201',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139357507585','70','1399531139357507585',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140548689922','1212685717864517633','1399531140548689922',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140548689923','87','1399531140548689923',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140548689924','1211473406755651586','1399531140548689924',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140561272834','58','1399531140561272834',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140636770306','1211473406755651586','1399531140636770306',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140888428545','1211484578443739137','1399531140888428545',2,2,'晋江市锦福化纤聚合有限公司','13599749329','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140905205761','102','1399531140905205761',1,2,'颜思思','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531140938760194','1216559724997144578','1399531140938760194',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141005869057','87','1399531141005869057',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141026840577','1211474926804975617','1399531141026840577',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141081366530','1211529007779069954','1399531141081366530',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141257527297','102','1399531141257527297',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141270110210','1211548619757371393','1399531141270110210',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141274304513','1216568840104734722','1399531141274304513',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141458853890','1211561316616028162','1399531141458853890',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141463048193','1241252588561698817','1399531141463048193',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141752455170','1211837849989595138','1399531141752455170',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141752455171','1295900371603947522','1399531141752455171',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141978947585','1212198922987048961','1399531141978947585',2,2,'卡尔美体育用品有限公司','17759990690','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531141987336194','1336570514910478338','1399531141987336194',2,2,'泉州华夏生态养生文化有限公司','18965616589','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531142238994434','1212604591955316738','1399531142238994434',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531142238994435','1348924009986654209','1399531142238994435',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:00',NULL,NULL,NULL,'2021-06-01 09:00:00',NULL,NULL,NULL),('1399531142431932418','1351830895278948354','1399531142431932418',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531142616481794','1212903777946898433','1399531142616481794',2,2,'福建兴翼机械有限公司','18606981162','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531142624870401','1366943804480856065','1399531142624870401',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531142822002689','1218097536540147714','1399531142822002689',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531142826196993','1374554432229978113','1399531142826196993',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531143010746369','1219140374220627970','1399531143010746369',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531143023329282','1376712565047975937','1399531143023329282',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531143321124866','1394875586618372097','1399531143321124866',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531143321124867','1219144052960780289','1399531143321124867',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531143593754626','1219147136575332354','1399531143593754626',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531143870578690','1219451161745080321','1399531143870578690',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531144097071106','1219868423635353602','1399531144097071106',2,2,'福建省晋江市和盛机械有限公司','13808552366','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531144315174913','1286499346338045953','1399531144315174913',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531144571027457','1290207451647430657','1399531144571027457',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531144847851522','1314481312186277890','1399531144847851522',2,2,'福建逸锦化纤有限公司','19905065506','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531145040789506','1316201027820630017','1399531145040789506',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399531145288253442','1338784953806094337','1399531145288253442',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-01 09:00:01',NULL,NULL,NULL,'2021-06-01 09:00:01',NULL,NULL,NULL),('1399576578408611842',NULL,'1399576578408611842',2,1,NULL,'13960391906','489903','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-01 12:00:33',NULL,NULL,NULL,'2021-06-01 12:00:33',NULL,NULL,NULL),('1399629649465606145',NULL,'1399629649465606145',2,1,NULL,'18159338867','430108','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-01 15:31:26',NULL,NULL,NULL,'2021-06-01 15:31:26',NULL,NULL,NULL),('1399629922321858561',NULL,'1399629922321858561',2,1,NULL,'13044554499','452605','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-01 15:32:32',NULL,NULL,NULL,'2021-06-01 15:32:32',NULL,NULL,NULL),('1399636876645662721','1399577737844260865','1399636876645662721',2,2,'厦门航空有限公司泉州分公司','13960391906','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-01 16:00:10',NULL,NULL,NULL,'2021-06-01 16:00:10',NULL,NULL,NULL),('1399893526564601857','1211559758373371905','1399893526564601857',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893526686236673','1211120827064496130','1399893526686236673',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893526686236674','1211461407799820290','1399893526686236674',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527260856321','58','1399893527260856321',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527269244929','72','1399893527269244929',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527273439234','70','1399893527273439234',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527764172802','58','1399893527764172802',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527764172803','1211457535089885185','1399893527764172803',2,2,'晋江市艺达木雕美术有限公司','18150505789','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527764172804','1211473406755651586','1399893527764172804',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527764172805','87','1399893527764172805',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527793532930','1212685717864517633','1399893527793532930',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528007442433','1211473406755651586','1399893528007442433',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528032608258','87','1399893528032608258',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528045191169','1211474926804975617','1399893528045191169',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528053579778','102','1399893528053579778',1,2,'颜思思','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528162631681','1216559724997144578','1399893528162631681',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528233934850','1216568840104734722','1399893528233934850',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528250712066','102','1399893528250712066',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528280072193','1211484578443739137','1399893528280072193',2,2,'晋江市锦福化纤聚合有限公司','13599749329','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528456232962','1241252588561698817','1399893528456232962',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528485593089','1211529007779069954','1399893528485593089',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528682725377','1295900371603947522','1399893528682725377',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528703696898','1211548619757371393','1399893528703696898',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528951160834','1211561316616028162','1399893528951160834',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893528959549442','1348924009986654209','1399893528959549442',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529135710210','1351830895278948354','1399893529135710210',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529144098818','1211837849989595138','1399893529144098818',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529366396929','1366943804480856065','1399893529366396929',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529383174145','1211920348237316098','1399893529383174145',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529567723521','1374554432229978113','1399893529567723521',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529576112129','1211945706491789313','1399893529576112129',2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529764855809','1376712565047975937','1399893529764855809',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529857130497','1212198922987048961','1399893529857130497',2,2,'卡尔美体育用品有限公司','17759990690','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893529953599490','1394875586618372097','1399893529953599490',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893530037485569','1212535414099873794','1399893530037485569',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:00',NULL,NULL,NULL,'2021-06-02 09:00:00',NULL,NULL,NULL),('1399893530230423553','1212604591955316738','1399893530230423553',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893530465304577','1218097536540147714','1399893530465304577',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893530695991298','1219140374220627970','1399893530695991298',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893530901512193','1219144052960780289','1399893530901512193',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893531178336257','1219147136575332354','1399893531178336257',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893531404828674','1219451161745080321','1399893531404828674',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893531681652738','1219868423635353602','1399893531681652738',2,2,'福建省晋江市和盛机械有限公司','13808552366','7,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893531912339458','1286499346338045953','1399893531912339458',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893532130443265','1290207451647430657','1399893532130443265',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893532340158466','1315551775847133185','1399893532340158466',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893532579233793','1316201027820630017','1399893532579233793',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399893532835086338','1338784953806094337','1399893532835086338',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-02 09:00:01',NULL,NULL,NULL,'2021-06-02 09:00:01',NULL,NULL,NULL),('1399905687001137153','1216626668072869889','1399905687001137153',2,2,'晋江市融媒体中心','13505079029','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-02 09:48:19',NULL,NULL,NULL,'2021-06-02 09:48:19',NULL,NULL,NULL),('1399978215224672257',NULL,'1399978215224672257',2,1,NULL,'18039071966','389813','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 14:36:31',NULL,NULL,NULL,'2021-06-02 14:36:31',NULL,NULL,NULL),('1399978502358335490',NULL,'1399978502358335490',2,1,NULL,'18039071966','129691','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 14:37:39',NULL,NULL,NULL,'2021-06-02 14:37:39',NULL,NULL,NULL),('1399978793208152066',NULL,'1399978793208152066',2,1,NULL,'18039071966','152954','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 14:38:49',NULL,NULL,NULL,'2021-06-02 14:38:49',NULL,NULL,NULL),('1399979764009172994',NULL,'1399979764009172994',2,1,NULL,'18005066989','999350','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 14:42:40',NULL,NULL,NULL,'2021-06-02 14:42:40',NULL,NULL,NULL),('1400005412115218434',NULL,'1400005412115218434',2,1,NULL,'15905035188','791058','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 16:24:35',NULL,NULL,NULL,'2021-06-02 16:24:35',NULL,NULL,NULL),('1400005924625612802',NULL,'1400005924625612802',2,1,NULL,'15905035188','188514','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 16:26:37',NULL,NULL,NULL,'2021-06-02 16:26:37',NULL,NULL,NULL),('1400009030344146945','1400005983526223873','1400009030344146945',2,2,'福建舒雨伞业有限公司','15905035188','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-02 16:38:58',NULL,NULL,NULL,'2021-06-02 16:38:58',NULL,NULL,NULL),('1400011442261884930',NULL,'1400011442261884930',2,1,NULL,'15860398018','143172','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 16:48:33',NULL,NULL,NULL,'2021-06-02 16:48:33',NULL,NULL,NULL),('1400024983542988802',NULL,'1400024983542988802',2,1,NULL,'13799239129','928891','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 17:42:21',NULL,NULL,NULL,'2021-06-02 17:42:21',NULL,NULL,NULL),('1400080374809264130',NULL,'1400080374809264130',2,1,NULL,'18314463516','761823','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-02 21:22:28',NULL,NULL,NULL,'2021-06-02 21:22:28',NULL,NULL,NULL),('1400244242583945218',NULL,'1400244242583945218',2,1,NULL,'15960565293','040604','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-03 08:13:37',NULL,NULL,NULL,'2021-06-03 08:13:37',NULL,NULL,NULL),('1400255914430201858','1211120827064496130','1400255914430201858',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914560225281','1211559758373371905','1400255914560225281',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914577002498','1211461407799820290','1400255914577002498',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914904158210','1212685717864517633','1400255914904158210',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914925129730','1211184671690436610','1400255914925129730',2,2,'泉州市里仁财务咨询有限公司','15880720190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914967072770','1211473406755651586','1400255914967072770',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915071930370','58','1400255915071930370',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915151622146','72','1400255915151622146',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915218731010','70','1400255915218731010',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915294228482','1216559724997144578','1400255915294228482',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915306811394','1211484578443739137','1400255915306811394',2,2,'晋江市锦福化纤聚合有限公司','13599749329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915369725953','1211474926804975617','1400255915369725953',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915441029121','87','1400255915441029121',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915466194946','58','1400255915466194946',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915520720898','1211529007779069954','1400255915520720898',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915646550018','102','1400255915646550018',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915659132930','87','1400255915659132930',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915663327233','1216568840104734722','1400255915663327233',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915726241793','1211543330165407746','1400255915726241793',2,2,'福建省咭咭文化传播有限公司','18698390251','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915994677250','102','1400255915994677250',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916007260161','1241252588561698817','1400255916007260161',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916049203202','1211548619757371393','1400255916049203202',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916242141186','1211561316616028162','1400255916242141186',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916242141187','1295900371603947522','1400255916242141187',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916468633601','1211837849989595138','1400255916468633601',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916468633602','1348924009986654209','1400255916468633602',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916653182978','1351830895278948354','1400255916653182978',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916695126017','1211920348237316098','1400255916695126017',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916930007041','1366943804480856065','1400255916930007041',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255916963561474','1211936041519333377','1400255916963561474',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255917181665282','1374554432229978113','1400255917181665282',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255917273939970','1211945706491789313','1400255917273939970',2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255917378797569','1376712565047975937','1400255917378797569',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255917542375425','1212198922987048961','1400255917542375425',2,2,'卡尔美体育用品有限公司','17759990690','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255917861142529','1394875586618372097','1400255917861142529',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255917886308353','1212535414099873794','1400255917886308353',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:00',NULL,NULL,NULL,'2021-06-03 09:00:00',NULL,NULL,NULL),('1400255918091829250','1212604591955316738','1400255918091829250',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255918347681793','1212996449227313153','1400255918347681793',2,2,'晋江闽古食品有限公司','18250155553','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255918532231170','1218097536540147714','1400255918532231170',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255918783889409','1219140374220627970','1400255918783889409',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255919031353346','1219144052960780289','1400255919031353346',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255919215902722','1219147136575332354','1400255919215902722',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255919438200834','1219451161745080321','1400255919438200834',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255919635333122','1286499346338045953','1400255919635333122',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255919832465410','1288431323949613058','1400255919832465410',2,2,'泉州市荣兴丝绸材料研究院有限公司','13159037366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255920079929345','1290207451647430657','1400255920079929345',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255920285450242','1315551775847133185','1400255920285450242',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255920574857218','1316201027820630017','1400255920574857218',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400255920805543937','1338784953806094337','1400255920805543937',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-03 09:00:01',NULL,NULL,NULL,'2021-06-03 09:00:01',NULL,NULL,NULL),('1400262735777792002',NULL,'1400262735777792002',2,1,NULL,'18606050830','350122','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-03 09:27:06',NULL,NULL,NULL,'2021-06-03 09:27:06',NULL,NULL,NULL),('1400300777590784001',NULL,'1400300777590784001',2,1,NULL,'18373269659','697536','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-03 11:58:16',NULL,NULL,NULL,'2021-06-03 11:58:16',NULL,NULL,NULL),('1400338113955397634',NULL,'1400338113955397634',2,1,NULL,'13559052503','933253','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-03 14:26:38',NULL,NULL,NULL,'2021-06-03 14:26:38',NULL,NULL,NULL),('1400379571810893826',NULL,'1400379571810893826',2,1,NULL,'15980306854','500285','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-03 17:11:22',NULL,NULL,NULL,'2021-06-03 17:11:22',NULL,NULL,NULL),('1400618302279024641','1211120827064496130','1400618302279024641',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302308384769','1211461407799820290','1400618302308384769',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302333550594','1211559758373371905','1400618302333550594',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302794924034','72','1400618302794924034',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302794924035','58','1400618302794924035',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302811701249','70','1400618302811701249',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302887198722','1211473406755651586','1400618302887198722',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302903975938','1212685717864517633','1400618302903975938',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302920753153','1211167966465470465','1400618302920753153',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303096913921','58','1400618303096913921',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303096913922','87','1400618303096913922',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303096913923','1211474926804975617','1400618303096913923',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303096913924','1211184671690436610','1400618303096913924',2,2,'泉州市里仁财务咨询有限公司','15880720190','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303122079746','1216559724997144578','1400618303122079746',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303386320898','102','1400618303386320898',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303386320899','1216568840104734722','1400618303386320899',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303495372801','87','1400618303495372801',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303776391169','1211490446086291458','1400618303776391169',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303986106370','102','1400618303986106370',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618303986106371','1241252588561698817','1400618303986106371',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618304179044354','1211529007779069954','1400618304179044354',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618304397148162','1295900371603947522','1400618304397148162',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618304812384258','1211543330165407746','1400618304812384258',2,2,'福建省咭咭文化传播有限公司','18698390251','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618304833355777','1348924009986654209','1400618304833355777',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305038876674','1351830895278948354','1400618305038876674',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305055653889','1211561316616028162','1400618305055653889',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305252786178','1366943804480856065','1400618305252786178',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305277952002','1211837849989595138','1400618305277952002',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305496055810','1374554432229978113','1400618305496055810',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305500250114','1211920348237316098','1400618305500250114',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305693188097','1212198922987048961','1400618305693188097',2,2,'卡尔美体育用品有限公司','17759990690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305701576705','1376712565047975937','1400618305701576705',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:00',NULL,NULL,NULL,'2021-06-04 09:00:00',NULL,NULL,NULL),('1400618305898708994','1394875586618372097','1400618305898708994',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618305915486210','1212535414099873794','1400618305915486210',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618306137784322','1212604591955316738','1400618306137784322',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618306334916609','1214142410787934209','1400618306334916609',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618306561409026','1218097536540147714','1400618306561409026',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618306792095745','1219140374220627970','1400618306792095745',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618307052142594','1219144052960780289','1400618307052142594',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618307228303362','1219147136575332354','1400618307228303362',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618307463184385','1219451161745080321','1400618307463184385',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618307647733762','1265077426581430273','1400618307647733762',2,2,'晋江市达树机械科技有限公司','13205059567','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618307878420482','1270198206789111809','1400618307878420482',2,2,'泉州市威豹保安服务有限公司','15905984868','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618308117495810','1286499346338045953','1400618308117495810',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618308314628098','1288431323949613058','1400618308314628098',2,2,'泉州市荣兴丝绸材料研究院有限公司','13159037366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618308532731906','1290207451647430657','1400618308532731906',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618308729864194','1298462952558555137','1400618308729864194',2,2,'熊仔动漫有限公司','15375882135','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618308922802177','1315551775847133185','1400618308922802177',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618309266735106','1316201027820630017','1400618309266735106',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618309476450305','1323539148186906626','1400618309476450305',2,2,'晋江市恒溢雨具有限公司','13960285632','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400618309715525634','1338784953806094337','1400618309715525634',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-04 09:00:01',NULL,NULL,NULL,'2021-06-04 09:00:01',NULL,NULL,NULL),('1400634986612162562',NULL,'1400634986612162562',2,1,NULL,'15906051055','159928','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-04 10:06:18',NULL,NULL,NULL,'2021-06-04 10:06:18',NULL,NULL,NULL),('1400737777854742530',NULL,'1400737777854742530',2,1,NULL,'13489858089','735717','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-04 16:54:45',NULL,NULL,NULL,'2021-06-04 16:54:45',NULL,NULL,NULL),('1401705465900990466','1211559758373371905','1401705465900990466',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705465930350594','1211120827064496130','1401705465930350594',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705466089734145','1211461407799820290','1401705466089734145',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467046035459','58','1401705467046035459',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467079589889','72','1401705467079589889',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467222196225','70','1401705467222196225',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467364802562','1211167966465470465','1401705467364802562',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467373191170','1212685717864517633','1401705467373191170',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467373191171','1211473406755651586','1401705467373191171',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467591294978','58','1401705467591294978',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467591294979','87','1401705467591294979',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468019113985','102','1401705468019113985',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468061057025','1211221341013913601','1401705468061057025',2,2,'中菱（福建）电梯有限公司','18959847128','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468153331714','1211474926804975617','1401705468153331714',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468195274754','1216559724997144578','1401705468195274754',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468316909570','87','1401705468316909570',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468786671617','1211454669394591746','1401705468786671617',2,2,'福建凤竹纺织科技股份有限公司','13506060342','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468786671618','1216568840104734722','1401705468786671618',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705468937666561','102','1401705468937666561',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705469151576065','1211490446086291458','1401705469151576065',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705469319348225','1241252588561698817','1401705469319348225',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705469386457090','1211529007779069954','1401705469386457090',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:00',NULL,NULL,NULL,'2021-06-07 09:00:00',NULL,NULL,NULL),('1401705469554229249','1295900371603947522','1401705469554229249',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705469675864065','1211543330165407746','1401705469675864065',2,2,'福建省咭咭文化传播有限公司','18698390251','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705469784915970','1348924009986654209','1401705469784915970',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705469898162177','1211561316616028162','1401705469898162177',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705470070128642','1351830895278948354','1401705470070128642',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705470212734978','1211572731150123009','1401705470212734978',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705470367924225','1366943804480856065','1401705470367924225',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705470506336257','1211574035113099265','1401705470506336257',2,2,'三六一度(中国)有限公司','13600745760','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705470644748290','1374554432229978113','1401705470644748290',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705470757994498','1211837849989595138','1401705470757994498',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705470963515394','1376712565047975937','1401705470963515394',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705471143870465','1212198922987048961','1401705471143870465',2,2,'卡尔美体育用品有限公司','17759990690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705471185813505','1394875586618372097','1401705471185813505',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705471433277441','1212535414099873794','1401705471433277441',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705471693324289','1212604591955316738','1401705471693324289',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705471986925569','1212903777946898433','1401705471986925569',2,2,'福建兴翼机械有限公司','18606981162','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705472280526849','1213451329813417985','1401705472280526849',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705472494436353','1214142410787934209','1401705472494436353',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705472767066114','1215259455701172226','1401705472767066114',2,2,'福建新宇拉链织造有限公司','15259555117','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705473010335746','1218097536540147714','1401705473010335746',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705473245216770','1219140374220627970','1401705473245216770',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705473513652225','1219144052960780289','1401705473513652225',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:01',NULL,NULL,NULL,'2021-06-07 09:00:01',NULL,NULL,NULL),('1401705473723367425','1219147136575332354','1401705473723367425',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705473987608578','1219451161745080321','1401705473987608578',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705474272821249','1269831043272200193','1401705474272821249',2,2,'晋江隆旺再生资源有限公司','13774648357','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705474499313666','1270198206789111809','1401705474499313666',2,2,'泉州市威豹保安服务有限公司','15905984868','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705474742583298','1286499346338045953','1401705474742583298',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705474977464321','1288431323949613058','1401705474977464321',2,2,'泉州市荣兴丝绸材料研究院有限公司','13159037366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705475208151041','1290207451647430657','1401705475208151041',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705475422060545','1298462952558555137','1401705475422060545',2,2,'熊仔动漫有限公司','15375882135','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705475661135873','1315551775847133185','1401705475661135873',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705475891822594','1316201027820630017','1401705475891822594',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705476088954882','1323539148186906626','1401705476088954882',2,2,'晋江市恒溢雨具有限公司','13960285632','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401705476437082114','1338784953806094337','1401705476437082114',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-07 09:00:02',NULL,NULL,NULL,'2021-06-07 09:00:02',NULL,NULL,NULL),('1401724504887033857',NULL,'1401724504887033857',2,1,NULL,'15960565293','253008','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-07 10:15:39',NULL,NULL,NULL,'2021-06-07 10:15:39',NULL,NULL,NULL),('1401732226151907329','1348924009986654209','1401732226151907329',2,2,'福建力利实业有限公司','13459503551','13459503551','【晋江市人才服务平台】您好，您在晋江市人才综合服务平台的反馈已被回复，请及时查看。',3,'短信发送成功','2021-06-07 10:46:20',NULL,NULL,NULL,'2021-06-07 10:46:20',NULL,NULL,NULL),('1401798069955100674',NULL,'1401798069955100674',2,1,NULL,'13850100395','119994','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-07 15:07:58',NULL,NULL,NULL,'2021-06-07 15:07:58',NULL,NULL,NULL),('1401946361720504321',NULL,'1401946361720504321',2,1,NULL,'15205050911','665748','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 00:57:14',NULL,NULL,NULL,'2021-06-08 00:57:14',NULL,NULL,NULL),('1402067853636567042','1211559758373371905','1402067853636567042',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067853674315777','1211461407799820290','1402067853674315777',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067853716258817','1211120827064496130','1402067853716258817',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854181826562','58','1402067854181826562',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854194409474','70','1402067854194409474',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854248935425','72','1402067854248935425',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854618034178','1211473406755651586','1402067854618034178',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854618034179','1212685717864517633','1402067854618034179',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854618034180','87','1402067854618034180',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854618034181','1211167966465470465','1402067854618034181',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854618034182','58','1402067854618034182',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854894858242','1211474926804975617','1402067854894858242',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854894858243','1216559724997144578','1402067854894858243',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854949384193','1211454669394591746','1402067854949384193',2,2,'福建凤竹纺织科技股份有限公司','13506060342','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854991327234','102','1402067854991327234',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854991327235','87','1402067854991327235',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067855284928514','1211473406755651586','1402067855284928514',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067855356231682','1216568840104734722','1402067855356231682',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067855431729154','102','1402067855431729154',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067855662415873','1241252588561698817','1402067855662415873',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067855691776001','1211490446086291458','1402067855691776001',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067855884713986','1295900371603947522','1402067855884713986',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067855918268418','1211529007779069954','1402067855918268418',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856107012098','1348924009986654209','1402067856107012098',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856153149442','1211561316616028162','1402067856153149442',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856304144386','1351830895278948354','1402067856304144386',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856337698818','1211837849989595138','1402067856337698818',2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856585162753','1366943804480856065','1402067856585162753',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856589357057','1212198922987048961','1402067856589357057',2,2,'卡尔美体育用品有限公司','17759990690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856786489346','1374554432229978113','1402067856786489346',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067856790683649','1212535414099873794','1402067856790683649',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067857029758977','1212604591955316738','1402067857029758977',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067857033953282','1376712565047975937','1402067857033953282',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067857243668482','1212626739503632385','1402067857243668482',2,2,'晋江宏基机械有限公司','15905958858','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067857243668483','1394875586618372097','1402067857243668483',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:00',NULL,NULL,NULL,'2021-06-08 09:00:00',NULL,NULL,NULL),('1402067857444995073','1399577737844260865','1402067857444995073',2,2,'厦门航空有限公司泉州分公司','13960391906','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067857453383682','1214142410787934209','1402067857453383682',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067857705041921','1214796116982325250','1402067857705041921',2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067857881202690','1215259455701172226','1402067857881202690',2,2,'福建新宇拉链织造有限公司','15259555117','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067858057363457','1218097536540147714','1402067858057363457',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067858237718529','1219140374220627970','1402067858237718529',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067858422267906','1219144052960780289','1402067858422267906',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067858598428673','1219147136575332354','1402067858598428673',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067858782978050','1219451161745080321','1402067858782978050',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067858971721730','1270198206789111809','1402067858971721730',2,2,'泉州市威豹保安服务有限公司','15905984868','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067859189825538','1277434198482796545','1402067859189825538',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067859378569217','1286499346338045953','1402067859378569217',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067859651198978','1290207451647430657','1402067859651198978',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067859877691394','1315551775847133185','1402067859877691394',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067860179681282','1316201027820630017','1402067860179681282',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402067860422950914','1338784953806094337','1402067860422950914',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-08 09:00:01',NULL,NULL,NULL,'2021-06-08 09:00:01',NULL,NULL,NULL),('1402068144276668417',NULL,'1402068144276668417',2,1,NULL,'18850547191','444790','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 09:01:09',NULL,NULL,NULL,'2021-06-08 09:01:09',NULL,NULL,NULL),('1402068427769675778',NULL,'1402068427769675778',2,1,NULL,'18850547191','301359','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 09:02:17',NULL,NULL,NULL,'2021-06-08 09:02:17',NULL,NULL,NULL),('1402091130467680258',NULL,'1402091130467680258',2,1,NULL,'15960565293','970417','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 10:32:29',NULL,NULL,NULL,'2021-06-08 10:32:29',NULL,NULL,NULL),('1402103344339648514',NULL,'1402103344339648514',2,1,NULL,'15885194064','073977','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 11:21:01',NULL,NULL,NULL,'2021-06-08 11:21:01',NULL,NULL,NULL),('1402185471659900929',NULL,'1402185471659900929',2,1,NULL,'15860556902','526308','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 16:47:22',NULL,NULL,NULL,'2021-06-08 16:47:22',NULL,NULL,NULL),('1402187090107596802',NULL,'1402187090107596802',2,1,NULL,'18965531731','266642','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 16:53:48',NULL,NULL,NULL,'2021-06-08 16:53:48',NULL,NULL,NULL),('1402188992698417154',NULL,'1402188992698417154',2,1,NULL,'15959590124','291563','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 17:01:21',NULL,NULL,NULL,'2021-06-08 17:01:21',NULL,NULL,NULL),('1402189666395914241',NULL,'1402189666395914241',2,1,NULL,'13960258115','072300','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 17:04:02',NULL,NULL,NULL,'2021-06-08 17:04:02',NULL,NULL,NULL),('1402189751859052546',NULL,'1402189751859052546',2,1,NULL,'15880727992','066075','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 17:04:22',NULL,NULL,NULL,'2021-06-08 17:04:22',NULL,NULL,NULL),('1402190623498338306',NULL,'1402190623498338306',2,1,NULL,'15880884973','201036','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-08 17:07:50',NULL,NULL,NULL,'2021-06-08 17:07:50',NULL,NULL,NULL),('1402427018326343682',NULL,'1402427018326343682',2,1,NULL,'18850547191','328487','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-09 08:47:11',NULL,NULL,NULL,'2021-06-09 08:47:11',NULL,NULL,NULL),('1402430241460224001','1211559758373371905','1402430241460224001',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241510555650','1211120827064496130','1402430241510555650',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241527332866','1211461407799820290','1402430241527332866',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241963540481','70','1402430241963540481',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241963540482','58','1402430241963540482',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242018066434','1212685717864517633','1402430242018066434',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242026455041','72','1402430242026455041',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242127118338','1211167966465470465','1402430242127118338',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242152284161','1211473406755651586','1402430242152284161',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242231975938','87','1402430242231975938',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242311667714','58','1402430242311667714',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242328444929','1216559724997144578','1402430242328444929',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242328444930','1211454669394591746','1402430242328444930',2,2,'福建凤竹纺织科技股份有限公司','13506060342','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242332639234','1211474926804975617','1402430242332639234',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242475245569','102','1402430242475245569',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242504605697','87','1402430242504605697',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242512994305','1211473406755651586','1402430242512994305',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242575908865','1216568840104734722','1402430242575908865',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242676572162','102','1402430242676572162',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242714320898','1211490446086291458','1402430242714320898',2,2,'泉州职业技术大学','18060007601','18,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242814984194','1241252588561698817','1402430242814984194',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430242982756354','1211529007779069954','1402430242982756354',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243016310785','1295900371603947522','1402430243016310785',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243196665858','1211561316616028162','1402430243196665858',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243230220290','1348924009986654209','1402430243230220290',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243381215234','1211568776709980162','1402430243381215234',2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243427352578','1351830895278948354','1402430243427352578',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243565764609','1211837849989595138','1402430243565764609',2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243637067777','1366943804480856065','1402430243637067777',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243775479810','1211840469537964033','1402430243775479810',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243838394370','1374554432229978113','1402430243838394370',2,2,'福建省晋华集成电路有限公司','15059820805','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430243947446274','1211931259509456897','1402430243947446274',2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430244111024129','1376712565047975937','1402430244111024129',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430244136189954','1212198922987048961','1402430244136189954',2,2,'卡尔美体育用品有限公司','17759990690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430244299767810','1394875586618372097','1402430244299767810',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430244308156417','1212535414099873794','1402430244308156417',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430244484317186','1212604591955316738','1402430244484317186',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430244656283650','1212731840222269441','1402430244656283650',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430244824055810','1212929090869334017','1402430244824055810',2,2,'福建省晋江市辉源建材物资有限公司','15106027935','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430245033771010','1213031390673702913','1402430245033771010',2,2,'海峡（晋江）伞业科技创新中心有限公司','13400808814','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:00',NULL,NULL,NULL,'2021-06-09 09:00:00',NULL,NULL,NULL),('1402430245226708993','1213100306318036993','1402430245226708993',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430245398675458','1214142410787934209','1402430245398675458',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430245587419138','1218097536540147714','1402430245587419138',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430245801328641','1219140374220627970','1402430245801328641',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430246002655234','1219144052960780289','1402430246002655234',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430246203981825','1219147136575332354','1402430246203981825',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430246396919810','1219159854892048385','1402430246396919810',2,2,'福建省正基检测技术有限公司','15080426614','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430246568886274','1219451161745080321','1402430246568886274',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430246774407169','1270198206789111809','1402430246774407169',2,2,'泉州市威豹保安服务有限公司','15905984868','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430247000899585','1275343906086633473','1402430247000899585',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430247248363521','1277434198482796545','1402430247248363521',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430247449690113','1286499346338045953','1402430247449690113',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430247630045186','1290207451647430657','1402430247630045186',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430247806205954','1301682900063776769','1402430247806205954',2,2,'福建天工房地产开发有限公司','15659885820','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430248150138881','1315551775847133185','1402430248150138881',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430248347271170','1316201027820630017','1402430248347271170',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430248540209153','1338449877369094145','1402430248540209153',2,2,'欧中(晋江)工业技术开发有限责任公司','18906060102','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430248724758529','1338784953806094337','1402430248724758529',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402430248947056642','1357603793218347009','1402430248947056642',2,2,'泉州市丰裕泰企业管理有限公司','13055679900','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-09 09:00:01',NULL,NULL,NULL,'2021-06-09 09:00:01',NULL,NULL,NULL),('1402447521757822977',NULL,'1402447521757822977',2,1,NULL,'18859717781','614636','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-09 10:08:40',NULL,NULL,NULL,'2021-06-09 10:08:40',NULL,NULL,NULL),('1402482094399062018',NULL,'1402482094399062018',2,1,NULL,'15905971778','952268','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-09 12:26:02',NULL,NULL,NULL,'2021-06-09 12:26:02',NULL,NULL,NULL),('1402547478225518594',NULL,'1402547478225518594',2,1,NULL,'13960279332','226535','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-09 16:45:51',NULL,NULL,NULL,'2021-06-09 16:45:51',NULL,NULL,NULL),('1402647261577510914',NULL,'1402647261577510914',2,1,NULL,'18060117021','144030','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-09 23:22:21',NULL,NULL,NULL,'2021-06-09 23:22:21',NULL,NULL,NULL),('1402792629501984769','1211120827064496130','1402792629501984769',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792629661368321','1211461407799820290','1402792629661368321',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792629837529090','1211559758373371905','1402792629837529090',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630202433538','72','1402792630202433538',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630202433539','58','1402792630202433539',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630370205697','1211473406755651586','1402792630370205697',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630378594306','1211167966465470465','1402792630378594306',2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630424731650','1212685717864517633','1402792630424731650',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630529589250','58','1402792630529589250',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630571532290','1211442194934710274','1402792630571532290',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630571532291','87','1402792630571532291',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630638641154','1211474926804975617','1402792630638641154',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630806413314','87','1402792630806413314',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630860939265','102','1402792630860939265',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630860939266','1211454669394591746','1402792630860939266',2,2,'福建凤竹纺织科技股份有限公司','13506060342','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630894493698','1216559724997144578','1402792630894493698',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631032905729','1216568840104734722','1402792631032905729',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631053877250','1211456215943528450','1402792631053877250',2,2,'福建泉成机械有限公司','15392286115','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631070654465','102','1402792631070654465',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631309729793','1211460115408928770','1402792631309729793',2,2,'泉州星德宝汽车销售服务有限责任公司','18159338867','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631355867138','1295900371603947522','1402792631355867138',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631498473474','1211473406755651586','1402792631498473474',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631695605761','1348924009986654209','1402792631695605761',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631695605762','1211490446086291458','1402792631695605762',2,2,'泉州职业技术大学','18060007601','23,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631875960833','1351830895278948354','1402792631875960833',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792631875960834','1211494978245672962','1402792631875960834',2,2,'福建省德腾智能科技有限公司','18050996325','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632131813377','1211529007779069954','1402792632131813377',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632131813378','1366943804480856065','1402792632131813378',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632320557058','1374554432229978113','1402792632320557058',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632324751361','1211535199725207554','1402792632324751361',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632492523521','1376712565047975937','1402792632492523521',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632500912130','1211561316616028162','1402792632500912130',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632702238721','1211568776709980162','1402792632702238721',2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632706433026','1394875586618372097','1402792632706433026',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792632899371010','1211815946042261505','1402792632899371010',2,2,'泉州市陶源环保科技有限公司','13666026522','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:00',NULL,NULL,NULL,'2021-06-10 09:00:00',NULL,NULL,NULL),('1402792633201360898','1211837849989595138','1402792633201360898',2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792633432047617','1211840469537964033','1402792633432047617',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792633633374209','1211931259509456897','1402792633633374209',2,2,'泉州市数坊信息科技有限公司','13506042338','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792633864060930','1212198922987048961','1402792633864060930',2,2,'卡尔美体育用品有限公司','17759990690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792634044416001','1212535414099873794','1402792634044416001',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792634245742594','1212604591955316738','1402792634245742594',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792634434486273','1214123943149981698','1402792634434486273',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792634610647041','1214142410787934209','1402792634610647041',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792634807779329','1218097536540147714','1402792634807779329',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792635030077442','1219140374220627970','1402792635030077442',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792635252375554','1219144052960780289','1402792635252375554',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792635545976833','1219147136575332354','1402792635545976833',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792635751497729','1219159854892048385','1402792635751497729',2,2,'福建省正基检测技术有限公司','15080426614','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792635957018626','1219451161745080321','1402792635957018626',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792636267397122','1275223626664165377','1402792636267397122',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792636485500929','1275343906086633473','1402792636485500929',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792636745547778','1277434198482796545','1402792636745547778',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792636938485761','1286499346338045953','1402792636938485761',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792637123035137','1290207451647430657','1402792637123035137',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:01',NULL,NULL,NULL,'2021-06-10 09:00:01',NULL,NULL,NULL),('1402792637441802242','1315551775847133185','1402792637441802242',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:02',NULL,NULL,NULL,'2021-06-10 09:00:02',NULL,NULL,NULL),('1402792637647323137','1316201027820630017','1402792637647323137',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:02',NULL,NULL,NULL,'2021-06-10 09:00:02',NULL,NULL,NULL),('1402792637869621250','1321093914727346178','1402792637869621250',2,2,'泉州市壹合食品研究院有限公司','13788806309','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:02',NULL,NULL,NULL,'2021-06-10 09:00:02',NULL,NULL,NULL),('1402792638129668097','1331802046063443969','1402792638129668097',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:02',NULL,NULL,NULL,'2021-06-10 09:00:02',NULL,NULL,NULL),('1402792638330994689','1335771058392793090','1402792638330994689',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:02',NULL,NULL,NULL,'2021-06-10 09:00:02',NULL,NULL,NULL),('1402792638708482050','1338784953806094337','1402792638708482050',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:02',NULL,NULL,NULL,'2021-06-10 09:00:02',NULL,NULL,NULL),('1402792638914002945','1357603793218347009','1402792638914002945',2,2,'泉州市丰裕泰企业管理有限公司','13055679900','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-10 09:00:02',NULL,NULL,NULL,'2021-06-10 09:00:02',NULL,NULL,NULL),('1402819681068285954',NULL,'1402819681068285954',2,1,NULL,'15880886611','056311','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 10:47:29',NULL,NULL,NULL,'2021-06-10 10:47:29',NULL,NULL,NULL),('1402835025103192065','1402819845443059714','1402835025103192065',2,2,'晋江市文化和旅游局','15880886611','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-10 11:48:28',NULL,NULL,NULL,'2021-06-10 11:48:28',NULL,NULL,NULL),('1402837491198754818',NULL,'1402837491198754818',2,1,NULL,'13959708090','401822','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 11:58:16',NULL,NULL,NULL,'2021-06-10 11:58:16',NULL,NULL,NULL),('1402838764933382146',NULL,'1402838764933382146',2,1,NULL,'13959708090','701587','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 12:03:19',NULL,NULL,NULL,'2021-06-10 12:03:19',NULL,NULL,NULL),('1402892354699952129',NULL,'1402892354699952129',2,1,NULL,'13489990595','495131','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 15:36:16',NULL,NULL,NULL,'2021-06-10 15:36:16',NULL,NULL,NULL),('1402910440593326081',NULL,'1402910440593326081',2,1,NULL,'18050869127','956872','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 16:48:08',NULL,NULL,NULL,'2021-06-10 16:48:08',NULL,NULL,NULL),('1402913905256202242',NULL,'1402913905256202242',2,1,NULL,'18050869127','448969','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 17:01:54',NULL,NULL,NULL,'2021-06-10 17:01:54',NULL,NULL,NULL),('1402914349995032577',NULL,'1402914349995032577',2,1,NULL,'18050869127','154476','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 17:03:40',NULL,NULL,NULL,'2021-06-10 17:03:40',NULL,NULL,NULL),('1402918062503526402',NULL,'1402918062503526402',2,1,NULL,'18050869127','657705','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 17:18:25',NULL,NULL,NULL,'2021-06-10 17:18:25',NULL,NULL,NULL),('1402963742169268225',NULL,'1402963742169268225',2,1,NULL,'15905070720','398448','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-10 20:19:56',NULL,NULL,NULL,'2021-06-10 20:19:56',NULL,NULL,NULL),('1403022419676921857',NULL,'1403022419676921857',2,1,NULL,'15959857789','793766','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 00:13:06',NULL,NULL,NULL,'2021-06-11 00:13:06',NULL,NULL,NULL),('1403140292919459841',NULL,'1403140292919459841',2,1,NULL,'18060505251','791303','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 08:01:29',NULL,NULL,NULL,'2021-06-11 08:01:29',NULL,NULL,NULL),('1403155017258532866','1211559758373371905','1403155017258532866',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017279504386','1211120827064496130','1403155017279504386',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017313058817','1211461407799820290','1403155017313058817',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017845735426','58','1403155017845735426',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017845735427','72','1403155017845735427',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018210639873','1212685717864517633','1403155018210639873',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018219028481','1211167966465470465','1403155018219028481',2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018219028482','1211473406755651586','1403155018219028482',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018260971522','87','1403155018260971522',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018265165825','58','1403155018265165825',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018525212673','102','1403155018525212673',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018525212674','87','1403155018525212674',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018533601281','1211474926804975617','1403155018533601281',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018571350018','1211453814360555522','1403155018571350018',2,2,'伟志股份公司','15859813817','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018571350019','1216559724997144578','1403155018571350019',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018802036737','1211454669394591746','1403155018802036737',2,2,'福建凤竹纺织科技股份有限公司','13506060342','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018814619649','102','1403155018814619649',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018885922817','1216568840104734722','1403155018885922817',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155018994974722','1211456215943528450','1403155018994974722',2,2,'福建泉成机械有限公司','15392286115','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019062083585','1295900371603947522','1403155019062083585',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019175329793','1211460918949494786','1403155019175329793',2,2,'大发科技集团有限公司','18959857088','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019242438658','1348924009986654209','1403155019242438658',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019347296258','1211473406755651586','1403155019347296258',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019443765249','1351830895278948354','1403155019443765249',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019561205761','1211490446086291458','1403155019561205761',2,2,'泉州职业技术大学','18060007601','23,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019611537410','1366943804480856065','1403155019611537410',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019733172226','1211529007779069954','1403155019733172226',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019787698177','1374554432229978113','1403155019787698177',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019909332993','1211535199725207554','1403155019909332993',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155019955470338','1376712565047975937','1403155019955470338',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155020135825410','1211561316616028162','1403155020135825410',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155020353929217','1211568776709980162','1403155020353929217',2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155020404260866','1394875586618372097','1403155020404260866',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155020534284290','1211815946042261505','1403155020534284290',2,2,'泉州市陶源环保科技有限公司','13666026522','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155020735610881','1211837828162437121','1403155020735610881',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:00',NULL,NULL,NULL,'2021-06-11 09:00:00',NULL,NULL,NULL),('1403155020915965953','1211837849989595138','1403155020915965953',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155021087932417','1212198922987048961','1403155021087932417',2,2,'卡尔美体育用品有限公司','17759990690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155021251510273','1212535414099873794','1403155021251510273',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155021452836865','1212568548061286401','1403155021452836865',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155021624803330','1212604591955316738','1403155021624803330',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155021796769793','1212903777946898433','1403155021796769793',2,2,'福建兴翼机械有限公司','18606981162','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155021960347649','1214123943149981698','1403155021960347649',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155022132314114','1214142410787934209','1403155022132314114',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155022321057793','1218097536540147714','1403155022321057793',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155022518190082','1219140374220627970','1403155022518190082',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155022727905281','1219144052960780289','1403155022727905281',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155023029895170','1219147136575332354','1403155023029895170',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155023256387585','1219451161745080321','1403155023256387585',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155023466102786','1275223626664165377','1403155023466102786',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155023663235073','1275343906086633473','1403155023663235073',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155023889727490','1277434198482796545','1403155023889727490',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155024132997122','1286499346338045953','1403155024132997122',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155024325935106','1290207451647430657','1403155024325935106',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155024523067393','1294076991682641922','1403155024523067393',2,2,'福建意尔康体育用品有限公司','15905071236','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155024711811074','1315551775847133185','1403155024711811074',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155025030578178','1316201027820630017','1403155025030578178',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:01',NULL,NULL,NULL,'2021-06-11 09:00:01',NULL,NULL,NULL),('1403155025223516162','1321093914727346178','1403155025223516162',2,2,'泉州市壹合食品研究院有限公司','13788806309','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:02',NULL,NULL,NULL,'2021-06-11 09:00:02',NULL,NULL,NULL),('1403155025466785794','1331802046063443969','1403155025466785794',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:02',NULL,NULL,NULL,'2021-06-11 09:00:02',NULL,NULL,NULL),('1403155025663918081','1335771058392793090','1403155025663918081',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:02',NULL,NULL,NULL,'2021-06-11 09:00:02',NULL,NULL,NULL),('1403155025856856066','1338784953806094337','1403155025856856066',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-11 09:00:02',NULL,NULL,NULL,'2021-06-11 09:00:02',NULL,NULL,NULL),('1403156383196545026',NULL,'1403156383196545026',2,1,NULL,'15359991222','025804','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 09:05:25',NULL,NULL,NULL,'2021-06-11 09:05:25',NULL,NULL,NULL),('1403160237619314690',NULL,'1403160237619314690',2,1,NULL,'15059066119','004235','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 09:20:44',NULL,NULL,NULL,'2021-06-11 09:20:44',NULL,NULL,NULL),('1403162932883259394',NULL,'1403162932883259394',2,1,NULL,'18659595539','429878','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 09:31:27',NULL,NULL,NULL,'2021-06-11 09:31:27',NULL,NULL,NULL),('1403164082688786433',NULL,'1403164082688786433',2,1,NULL,'18659595539','386155','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 09:36:01',NULL,NULL,NULL,'2021-06-11 09:36:01',NULL,NULL,NULL),('1403194843567521794',NULL,'1403194843567521794',2,1,NULL,'18350533399','003291','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 11:38:15',NULL,NULL,NULL,'2021-06-11 11:38:15',NULL,NULL,NULL),('1403195224506793986',NULL,'1403195224506793986',2,1,NULL,'18350533399','500084','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 11:39:46',NULL,NULL,NULL,'2021-06-11 11:39:46',NULL,NULL,NULL),('1403195561720446978',NULL,'1403195561720446978',2,1,NULL,'15960408186','258471','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 11:41:06',NULL,NULL,NULL,'2021-06-11 11:41:06',NULL,NULL,NULL),('1403201103171977218',NULL,'1403201103171977218',2,1,NULL,'18350533399','229193','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 12:03:07',NULL,NULL,NULL,'2021-06-11 12:03:07',NULL,NULL,NULL),('1403201515493031938',NULL,'1403201515493031938',2,1,NULL,'18350533399','556671','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 12:04:46',NULL,NULL,NULL,'2021-06-11 12:04:46',NULL,NULL,NULL),('1403225934198243330',NULL,'1403225934198243330',2,1,NULL,'13655902993','930343','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 13:41:48',NULL,NULL,NULL,'2021-06-11 13:41:48',NULL,NULL,NULL),('1403244614747455490',NULL,'1403244614747455490',2,1,NULL,'13400888180','005904','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-11 14:56:01',NULL,NULL,NULL,'2021-06-11 14:56:01',NULL,NULL,NULL),('1403623052989726721',NULL,'1403623052989726721',2,1,NULL,'15205097087','848459','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-12 15:59:48',NULL,NULL,NULL,'2021-06-12 15:59:48',NULL,NULL,NULL),('1404055614887329793',NULL,'1404055614887329793',2,1,NULL,'13600708564','373876','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-13 20:38:39',NULL,NULL,NULL,'2021-06-13 20:38:39',NULL,NULL,NULL),('1404242180897275905','1211120827064496130','1404242180897275905',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242180926636033','1211559758373371905','1404242180926636033',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242180943413250','1211461407799820290','1404242180943413250',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181312512001','58','1404242181312512001',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181316706305','72','1404242181316706305',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182440779777','1211167966465470465','1404242182440779777',2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182444974082','87','1404242182444974082',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182444974083','58','1404242182444974083',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182444974084','1211473406755651586','1404242182444974084',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182482722818','1212685717864517633','1404242182482722818',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182679855105','1211474926804975617','1404242182679855105',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182679855106','87','1404242182679855106',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182705020930','102','1404242182705020930',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182713409538','1211456847907700737','1404242182713409538',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182772129794','1216559724997144578','1404242182772129794',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182906347521','1211460918949494786','1404242182906347521',2,2,'大发科技集团有限公司','18959857088','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242182914736130','102','1404242182914736130',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183082508290','1211473406755651586','1404242183082508290',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183090896898','1216568840104734722','1404242183090896898',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183258669058','1211490446086291458','1404242183258669058',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183300612098','1295900371603947522','1404242183300612098',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183497744386','1348924009986654209','1404242183497744386',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183497744387','1211529007779069954','1404242183497744387',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183682293762','1211535199725207554','1404242183682293762',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183690682370','1351830895278948354','1404242183690682370',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183871037442','1366943804480856065','1404242183871037442',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242183883620354','1211561316616028162','1404242183883620354',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242184055586817','1374554432229978113','1404242184055586817',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242184089141249','1211568776709980162','1404242184089141249',2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242184248524801','1376712565047975937','1404242184248524801',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242184290467841','1211815946042261505','1404242184290467841',2,2,'泉州市陶源环保科技有限公司','13666026522','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:00',NULL,NULL,NULL,'2021-06-14 09:00:00',NULL,NULL,NULL),('1404242184516960258','1394875586618372097','1404242184516960258',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242184516960259','1211837828162437121','1404242184516960259',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242184714092545','1211837849989595138','1404242184714092545',2,2,'利郎（中国）有限公司','15959420909','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242184965750785','1212535414099873794','1404242184965750785',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242185154494466','1212568548061286401','1404242185154494466',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242185351626753','1212604591955316738','1404242185351626753',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242185573924865','1212903777946898433','1404242185573924865',2,2,'福建兴翼机械有限公司','18606981162','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242185846554626','1212930369930727426','1404242185846554626',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242186135961601','1214123943149981698','1404242186135961601',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242186354065410','1219140374220627970','1404242186354065410',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242186547003393','1219144052960780289','1404242186547003393',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242186739941378','1219147136575332354','1404242186739941378',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242186949656577','1219451161745080321','1404242186949656577',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242187176148994','1275223626664165377','1404242187176148994',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242187385864193','1275343906086633473','1404242187385864193',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242187578802178','1277434198482796545','1404242187578802178',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242187822071809','1286499346338045953','1404242187822071809',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242188082118657','1290207451647430657','1404242188082118657',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242188337971202','1315551775847133185','1404242188337971202',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242188602212353','1316201027820630017','1404242188602212353',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:01',NULL,NULL,NULL,'2021-06-14 09:00:01',NULL,NULL,NULL),('1404242188786761730','1328179674966147074','1404242188786761730',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:02',NULL,NULL,NULL,'2021-06-14 09:00:02',NULL,NULL,NULL),('1404242189051002881','1331802046063443969','1404242189051002881',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:02',NULL,NULL,NULL,'2021-06-14 09:00:02',NULL,NULL,NULL),('1404242189273300993','1335771058392793090','1404242189273300993',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:02',NULL,NULL,NULL,'2021-06-14 09:00:02',NULL,NULL,NULL),('1404242189571096577','1338784953806094337','1404242189571096577',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:02',NULL,NULL,NULL,'2021-06-14 09:00:02',NULL,NULL,NULL),('1404242189805977601','1339103086685192194','1404242189805977601',2,2,'奇峰(福建)食品有限公司','15260850530','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-14 09:00:02',NULL,NULL,NULL,'2021-06-14 09:00:02',NULL,NULL,NULL),('1404604568909676545','1211461407799820290','1404604568909676545',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604568909676546','1211559758373371905','1404604568909676546',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569001951233','1211120827064496130','1404604569001951233',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569555599362','58','1404604569555599362',1,2,'张荣荣','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569618513921','72','1404604569618513921',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570075693058','58','1404604570075693058',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570075693059','1211473406755651586','1404604570075693059',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570096664577','1211167966465470465','1404604570096664577',2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570113441793','1212685717864517633','1404604570113441793',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570113441794','87','1404604570113441794',1,2,'叶志钦','13675957398','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570386071554','87','1404604570386071554',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570407043073','1211474926804975617','1404604570407043073',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570448986113','1211456847907700737','1404604570448986113',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570490929153','102','1404604570490929153',1,2,'颜思思','15280619456','5,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570495123457','1216559724997144578','1404604570495123457',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570583203842','1216568840104734722','1404604570583203842',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570591592449','102','1404604570591592449',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570667089921','1211473406755651586','1404604570667089921',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570818084865','1295900371603947522','1404604570818084865',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570847444993','1211490446086291458','1404604570847444993',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604570994245633','1348924009986654209','1404604570994245633',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571011022850','1211529007779069954','1404604571011022850',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571208155137','1351830895278948354','1404604571208155137',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571212349442','1211535199725207554','1404604571212349442',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571409481730','1366943804480856065','1404604571409481730',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571426258946','1211561316616028162','1404604571426258946',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571602419713','1374554432229978113','1404604571602419713',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571644362753','1211568776709980162','1404604571644362753',2,2,'艾派集团（中国）有限公司','13959757688','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571782774786','1376712565047975937','1404604571782774786',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571816329218','1211815946042261505','1404604571816329218',2,2,'泉州市陶源环保科技有限公司','13666026522','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604571963129858','1394875586618372097','1404604571963129858',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604572055404546','1211837828162437121','1404604572055404546',2,2,'福建一品嘉云创信息技术股份有限公司','15960778794','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604572265119745','1211837849989595138','1404604572265119745',2,2,'利郎（中国）有限公司','15959420909','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:00',NULL,NULL,NULL,'2021-06-15 09:00:00',NULL,NULL,NULL),('1404604572470640642','1212535414099873794','1404604572470640642',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604572688744450','1212568548061286401','1404604572688744450',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604572957179905','1212604591955316738','1404604572957179905',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604573229809665','1212903777946898433','1404604573229809665',2,2,'福建兴翼机械有限公司','18606981162','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604573410164737','1212930369930727426','1404604573410164737',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604573598908417','1214123943149981698','1404604573598908417',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604573787652097','1219140374220627970','1404604573787652097',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604574127390721','1219144052960780289','1404604574127390721',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604574316134402','1219147136575332354','1404604574316134402',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604574530043906','1219451161745080321','1404604574530043906',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604574777507841','1275223626664165377','1404604574777507841',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604574991417345','1275343906086633473','1404604574991417345',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604575247269890','1277434198482796545','1404604575247269890',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604575427624962','1286499346338045953','1404604575427624962',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604575662505986','1290207451647430657','1404604575662505986',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604575868026881','1315551775847133185','1404604575868026881',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604576060964865','1316201027820630017','1404604576060964865',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604576279068674','1328179674966147074','1404604576279068674',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604576472006657','1331802046063443969','1404604576472006657',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:01',NULL,NULL,NULL,'2021-06-15 09:00:01',NULL,NULL,NULL),('1404604576765607938','1335771058392793090','1404604576765607938',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:02',NULL,NULL,NULL,'2021-06-15 09:00:02',NULL,NULL,NULL),('1404604576992100353','1338784953806094337','1404604576992100353',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-15 09:00:02',NULL,NULL,NULL,'2021-06-15 09:00:02',NULL,NULL,NULL),('1404606553692078082',NULL,'1404606553692078082',2,1,NULL,'15359991222','279635','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-15 09:07:53',NULL,NULL,NULL,'2021-06-15 09:07:53',NULL,NULL,NULL),('1404624837527240705',NULL,'1404624837527240705',2,1,NULL,'15980788802','244683','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-15 10:20:32',NULL,NULL,NULL,'2021-06-15 10:20:32',NULL,NULL,NULL),('1404633988957503489',NULL,'1404633988957503489',2,1,NULL,'13599106745','054818','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-15 10:56:54',NULL,NULL,NULL,'2021-06-15 10:56:54',NULL,NULL,NULL),('1404729461227704322',NULL,'1404729461227704322',2,1,NULL,'13506003779','653089','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-15 17:16:16',NULL,NULL,NULL,'2021-06-15 17:16:16',NULL,NULL,NULL),('1404730986511519745',NULL,'1404730986511519745',2,1,NULL,'18606967777','522048','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-15 17:22:20',NULL,NULL,NULL,'2021-06-15 17:22:20',NULL,NULL,NULL),('1404737456691007489',NULL,'1404737456691007489',2,1,NULL,'13105079935','394589','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-15 17:48:03',NULL,NULL,NULL,'2021-06-15 17:48:03',NULL,NULL,NULL),('1404960943451983873',NULL,'1404960943451983873',2,1,NULL,'13960306700','255986','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 08:36:06',NULL,NULL,NULL,'2021-06-16 08:36:06',NULL,NULL,NULL),('1404966956536221698','1211461407799820290','1404966956536221698',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966956712382466','1211110678463623169','1404966956712382466',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966956745936897','1211559758373371905','1404966956745936897',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957131812865','58','1404966957131812865',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957131812866','72','1404966957131812866',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957173755905','1211473406755651586','1404966957173755905',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957203116034','1211120827064496130','1404966957203116034',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957257641985','1212685717864517633','1404966957257641985',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957387665410','1211167966465470465','1404966957387665410',2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957437997057','87','1404966957437997057',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957458968578','58','1404966957458968578',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957530271746','1211474926804975617','1404966957530271746',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957576409089','1211473406755651586','1404966957576409089',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957597380609','1216559724997144578','1404966957597380609',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957605769217','102','1404966957605769217',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957714821122','87','1404966957714821122',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957727404033','1216568840104734722','1404966957727404033',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957798707201','1211474926804975617','1404966957798707201',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957890981890','102','1404966957890981890',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957911953409','1295900371603947522','1404966957911953409',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958033588225','1211489025517469698','1404966958033588225',2,2,'泉州星城纸业有限公司','15959856777','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958079725570','1348924009986654209','1404966958079725570',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958247497730','1211490446086291458','1404966958247497730',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958260080642','1351830895278948354','1404966958260080642',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958444630017','1211529007779069954','1404966958444630017',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958444630018','1366943804480856065','1404966958444630018',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958666928130','1211561316616028162','1404966958666928130',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958671122434','1374554432229978113','1404966958671122434',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958910197762','1376712565047975937','1404966958910197762',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966958935363586','1211837849989595138','1404966958935363586',2,2,'利郎（中国）有限公司','15959420909','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966959090552834','1394875586618372097','1404966959090552834',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966959119912961','1212568548061286401','1404966959119912961',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966959296073729','1212604591955316738','1404966959296073729',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966959484817409','1212903777946898433','1404966959484817409',2,2,'福建兴翼机械有限公司','18606981162','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966959673561090','1212930369930727426','1404966959673561090',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966959891664897','1219140374220627970','1404966959891664897',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966960109768705','1219144052960780289','1404966960109768705',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:00',NULL,NULL,NULL,'2021-06-16 09:00:00',NULL,NULL,NULL),('1404966960353038338','1219147136575332354','1404966960353038338',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966960537587714','1219451161745080321','1404966960537587714',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966960717942786','1275223626664165377','1404966960717942786',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966960919269377','1275343906086633473','1404966960919269377',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966961208676354','1277434198482796545','1404966961208676354',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966961435168769','1286499346338045953','1404966961435168769',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966961682632706','1290207451647430657','1404966961682632706',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966961904930818','1315551775847133185','1404966961904930818',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966962106257409','1316201027820630017','1404966962106257409',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966962311778305','1328179674966147074','1404966962311778305',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966962525687809','1331802046063443969','1404966962525687809',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966962731208706','1335771058392793090','1404966962731208706',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404966962945118209','1338784953806094337','1404966962945118209',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-16 09:00:01',NULL,NULL,NULL,'2021-06-16 09:00:01',NULL,NULL,NULL),('1404976349919105026',NULL,'1404976349919105026',2,1,NULL,'13850759758','991336','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 09:37:19',NULL,NULL,NULL,'2021-06-16 09:37:19',NULL,NULL,NULL),('1404978491006439425',NULL,'1404978491006439425',2,1,NULL,'13788803455','826346','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 09:45:50',NULL,NULL,NULL,'2021-06-16 09:45:50',NULL,NULL,NULL),('1404986144994676737',NULL,'1404986144994676737',2,1,NULL,'13506003779','368088','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 10:16:15',NULL,NULL,NULL,'2021-06-16 10:16:15',NULL,NULL,NULL),('1404986395705004034',NULL,'1404986395705004034',2,1,NULL,'18606967777','713830','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 10:17:14',NULL,NULL,NULL,'2021-06-16 10:17:14',NULL,NULL,NULL),('1405057181962784769',NULL,'1405057181962784769',2,1,NULL,'15259741125','266244','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 14:58:31',NULL,NULL,NULL,'2021-06-16 14:58:31',NULL,NULL,NULL),('1405059256499097602',NULL,'1405059256499097602',2,1,NULL,'15260798988','592356','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 15:06:46',NULL,NULL,NULL,'2021-06-16 15:06:46',NULL,NULL,NULL),('1405077543035392002',NULL,'1405077543035392002',2,1,NULL,'13163991887','282039','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-16 16:19:25',NULL,NULL,NULL,'2021-06-16 16:19:25',NULL,NULL,NULL),('1405328018829791234',NULL,'1405328018829791234',2,1,NULL,'15750965793','050833','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-17 08:54:44',NULL,NULL,NULL,'2021-06-17 08:54:44',NULL,NULL,NULL),('1405329344502484993','1211461407799820290','1405329344502484993',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344611536897','1211559758373371905','1405329344611536897',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344611536898','1211110678463623169','1405329344611536898',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345077104641','58','1405329345077104641',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345081298946','72','1405329345081298946',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345173573633','1211120827064496130','1405329345173573633',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345177767938','1212685717864517633','1405329345177767938',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345177767939','1211473406755651586','1405329345177767939',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345366511617','87','1405329345366511617',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345366511618','58','1405329345366511618',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345462980609','1216559724997144578','1405329345462980609',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345488146434','1211474926804975617','1405329345488146434',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345534283777','1211167966465470465','1405329345534283777',2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345685278722','102','1405329345685278722',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345920159746','87','1405329345920159746',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329345983074306','1216568840104734722','1405329345983074306',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346062766082','1211191315514109954','1405329346062766082',2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346117292034','102','1405329346117292034',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346444447745','1295900371603947522','1405329346444447745',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346482196482','1211236784814534658','1405329346482196482',2,2,'晋江乐康医院有限公司','15109613666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346620608514','1348924009986654209','1405329346620608514',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346704494593','1211461407799820290','1405329346704494593',2,2,'晋江经济报发展有限责任公司','13505004167','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346889043970','1211473406755651586','1405329346889043970',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329346893238273','1351830895278948354','1405329346893238273',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347069399042','1211474926804975617','1405329347069399042',2,2,'泉州轻工职业学院','13799550180','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347081981954','1366943804480856065','1405329347081981954',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347253948417','1374554432229978113','1405329347253948417',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347258142722','1211490446086291458','1405329347258142722',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347463663618','1211529007779069954','1405329347463663618',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347488829442','1376712565047975937','1405329347488829442',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347660795905','1211535199725207554','1405329347660795905',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347715321857','1394875586618372097','1405329347715321857',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329347908259842','1211561316616028162','1405329347908259842',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329348092809217','1211609839420096513','1405329348092809217',2,2,'福建省晋江产业发展投资集团有限公司','13599789599','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:00',NULL,NULL,NULL,'2021-06-17 09:00:00',NULL,NULL,NULL),('1405329348281552897','1211837849989595138','1405329348281552897',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329348466102274','1211920348237316098','1405329348466102274',2,2,'安踏（中国）有限公司','15160330306','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329348688400385','1211936041519333377','1405329348688400385',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329348927475713','1212535414099873794','1405329348927475713',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329349166551042','1212604591955316738','1405329349166551042',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329349372071938','1212930369930727426','1405329349372071938',2,2,'福建正扬科技股份有限公司','15880713988','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329349548232706','1219140374220627970','1405329349548232706',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329349736976385','1219144052960780289','1405329349736976385',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329349925720066','1219147136575332354','1405329349925720066',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329350156406785','1219451161745080321','1405329350156406785',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329350403870722','1274912838720167938','1405329350403870722',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329350605197313','1275223626664165377','1405329350605197313',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329350861049858','1275343906086633473','1405329350861049858',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329351070765058','1277434198482796545','1405329351070765058',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329351267897346','1286499346338045953','1405329351267897346',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329351473418241','1290207451647430657','1405329351473418241',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329351699910657','1298925594909732865','1405329351699910657',2,2,'福建柒牌集团有限公司','15959993797','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329351901237250','1300227590451228674','1405329351901237250',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329352115146754','1315551775847133185','1405329352115146754',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:01',NULL,NULL,NULL,'2021-06-17 09:00:01',NULL,NULL,NULL),('1405329352329056257','1316201027820630017','1405329352329056257',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:02',NULL,NULL,NULL,'2021-06-17 09:00:02',NULL,NULL,NULL),('1405329352530382850','1331802046063443969','1405329352530382850',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:02',NULL,NULL,NULL,'2021-06-17 09:00:02',NULL,NULL,NULL),('1405329352714932226','1335771058392793090','1405329352714932226',2,2,'晋江力绿食品有限公司','18059998188','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:02',NULL,NULL,NULL,'2021-06-17 09:00:02',NULL,NULL,NULL),('1405329353050476545','1338784953806094337','1405329353050476545',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:02',NULL,NULL,NULL,'2021-06-17 09:00:02',NULL,NULL,NULL),('1405329353314717697','1341906391132053505','1405329353314717697',2,2,'晋江市华天市政工程有限公司','15880816775','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 09:00:02',NULL,NULL,NULL,'2021-06-17 09:00:02',NULL,NULL,NULL),('1405424677966368769','1400338869487960065','1405424677966368769',2,2,'晋江市恒丰进出口贸易有限公司','13559052503','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-17 15:18:49',NULL,NULL,NULL,'2021-06-17 15:18:49',NULL,NULL,NULL),('1405429225778892801','1400338869487960065','1405429225778892801',2,2,'晋江市恒丰进出口贸易有限公司','13559052503','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-17 15:36:53',NULL,NULL,NULL,'2021-06-17 15:36:53',NULL,NULL,NULL),('1405462113094258690',NULL,'1405462113094258690',2,1,NULL,'13615952645','634858','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-17 17:47:34',NULL,NULL,NULL,'2021-06-17 17:47:34',NULL,NULL,NULL),('1405639303857491969',NULL,'1405639303857491969',2,1,NULL,'15260237093','509973','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 05:31:40',NULL,NULL,NULL,'2021-06-18 05:31:40',NULL,NULL,NULL),('1405691732372279298','1211461407799820290','1405691732372279298',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691732590383106','1211110678463623169','1405691732590383106',2,2,'琪尔特股份有限公司','18859969666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691732653297666','1211559758373371905','1405691732653297666',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733441826817','1211473406755651586','1405691733441826817',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733441826818','1211120827064496130','1405691733441826818',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733718650881','72','1405691733718650881',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733718650882','1212685717864517633','1405691733718650882',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733857062914','58','1405691733857062914',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733903200258','1211167966465470465','1405691733903200258',2,2,'晋江易库物联网科技有限公司','18959210622','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733982892034','1211474926804975617','1405691733982892034',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734104526850','58','1405691734104526850',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734121304066','1216559724997144578','1405691734121304066',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734192607233','1216568840104734722','1405691734192607233',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734192607234','1211191315514109954','1405691734192607234',2,2,'厦门中鑫之宝汽车服务有限公司晋江分公司','13295959911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734192607235','87','1405691734192607235',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734490402818','1295900371603947522','1405691734490402818',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734515568642','87','1405691734515568642',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734591066114','102','1405691734591066114',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734628814850','1211236784814534658','1405691734628814850',2,2,'晋江乐康医院有限公司','15109613666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'关机','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734712700930','1348924009986654209','1405691734712700930',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734737866754','102','1405691734737866754',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734813364225','1211439642532954113','1405691734813364225',2,2,'福建省晋江城市建设投资开发集团有限责任公司','13799766670','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691734914027522','1351830895278948354','1405691734914027522',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735027273729','1211461407799820290','1405691735027273729',2,2,'晋江经济报发展有限责任公司','13505004167','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735127937025','1366943804480856065','1405691735127937025',2,2,'晋江市陈埭镇芳惠农场','18659203084','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'非法操作GNS(手机关机，停机及黑名单用户)','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735253766146','1211473406755651586','1405691735253766146',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735341846529','1374554432229978113','1405691735341846529',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735559950337','1211474926804975617','1405691735559950337',2,2,'泉州轻工职业学院','13799550180','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735576727554','1376712565047975937','1405691735576727554',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735882911746','1211490446086291458','1405691735882911746',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691735882911747','1394875586618372097','1405691735882911747',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:00',NULL,NULL,NULL,'2021-06-18 09:00:00',NULL,NULL,NULL),('1405691736109404162','1211529007779069954','1405691736109404162',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691736298147841','1211561316616028162','1405691736298147841',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691736503668737','1211837849989595138','1405691736503668737',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691736704995329','1212535414099873794','1405691736704995329',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691736914710529','1212604591955316738','1405691736914710529',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691737254449153','1212692778300018689','1405691737254449153',2,2,'晋江市路桥建设开发有限公司','17350011170','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691737459970050','1219140374220627970','1405691737459970050',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691737657102338','1219144052960780289','1405691737657102338',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691737875206145','1219147136575332354','1405691737875206145',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691738076532737','1219451161745080321','1405691738076532737',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691738303025154','1274912838720167938','1405691738303025154',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691738596626434','1275223626664165377','1405691738596626434',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691738873450498','1275343906086633473','1405691738873450498',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691739099942913','1277434198482796545','1405691739099942913',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691739351601154','1286499346338045953','1405691739351601154',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691739582287874','1290207451647430657','1405691739582287874',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691739771031554','1298925594909732865','1405691739771031554',2,2,'福建柒牌集团有限公司','15959993797','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691740114964482','1300227590451228674','1405691740114964482',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:01',NULL,NULL,NULL,'2021-06-18 09:00:01',NULL,NULL,NULL),('1405691740307902465','1303977759655100418','1405691740307902465',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:02',NULL,NULL,NULL,'2021-06-18 09:00:02',NULL,NULL,NULL),('1405691740685389825','1315551775847133185','1405691740685389825',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:02',NULL,NULL,NULL,'2021-06-18 09:00:02',NULL,NULL,NULL),('1405691740949630977','1316201027820630017','1405691740949630977',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:02',NULL,NULL,NULL,'2021-06-18 09:00:02',NULL,NULL,NULL),('1405691741176123394','1331802046063443969','1405691741176123394',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:02',NULL,NULL,NULL,'2021-06-18 09:00:02',NULL,NULL,NULL),('1405691741431975937','1338784953806094337','1405691741431975937',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:02',NULL,NULL,NULL,'2021-06-18 09:00:02',NULL,NULL,NULL),('1405691741666856962','1341906391132053505','1405691741666856962',2,2,'晋江市华天市政工程有限公司','15880816775','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-18 09:00:02',NULL,NULL,NULL,'2021-06-18 09:00:02',NULL,NULL,NULL),('1405726838235385858',NULL,'1405726838235385858',2,1,NULL,'18250919608','033003','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 11:19:30',NULL,NULL,NULL,'2021-06-18 11:19:30',NULL,NULL,NULL),('1405727090547937281',NULL,'1405727090547937281',2,1,NULL,'18350919608','865473','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 11:20:30',NULL,NULL,NULL,'2021-06-18 11:20:30',NULL,NULL,NULL),('1405755898965577730',NULL,'1405755898965577730',2,1,NULL,'18859656928','725792','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 13:14:58',NULL,NULL,NULL,'2021-06-18 13:14:58',NULL,NULL,NULL),('1405773410209943553',NULL,'1405773410209943553',2,1,NULL,'18350773795','185573','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 14:24:33',NULL,NULL,NULL,'2021-06-18 14:24:33',NULL,NULL,NULL),('1405792880089419778',NULL,'1405792880089419778',2,1,NULL,'13799898116','887776','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 15:41:55',NULL,NULL,NULL,'2021-06-18 15:41:55',NULL,NULL,NULL),('1405793104975417345',NULL,'1405793104975417345',2,1,NULL,'13799898116','161269','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 15:42:49',NULL,NULL,NULL,'2021-06-18 15:42:49',NULL,NULL,NULL),('1405796921964023810',NULL,'1405796921964023810',2,1,NULL,'13799898116','670905','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 15:57:59',NULL,NULL,NULL,'2021-06-18 15:57:59',NULL,NULL,NULL),('1405907942531715073',NULL,'1405907942531715073',2,1,NULL,'13859750690','422287','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-18 23:19:08',NULL,NULL,NULL,'2021-06-18 23:19:08',NULL,NULL,NULL),('1406159594916466689',NULL,'1406159594916466689',2,1,NULL,'15759539090','375396','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-19 15:59:07',NULL,NULL,NULL,'2021-06-19 15:59:07',NULL,NULL,NULL),('1406171348060917762',NULL,'1406171348060917762',2,1,NULL,'15750921359','163545','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-19 16:45:49',NULL,NULL,NULL,'2021-06-19 16:45:49',NULL,NULL,NULL),('1406180114579902466',NULL,'1406180114579902466',2,1,NULL,'13959868397','503585','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-19 17:20:39',NULL,NULL,NULL,'2021-06-19 17:20:39',NULL,NULL,NULL),('1406218234893488129',NULL,'1406218234893488129',2,1,NULL,'15905907962','298126','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-19 19:52:08',NULL,NULL,NULL,'2021-06-19 19:52:08',NULL,NULL,NULL),('1406218931407998977',NULL,'1406218931407998977',2,1,NULL,'15905907962','214915','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-19 19:54:54',NULL,NULL,NULL,'2021-06-19 19:54:54',NULL,NULL,NULL),('1406219394564018178',NULL,'1406219394564018178',2,1,NULL,'15905907962','774326','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-19 19:56:44',NULL,NULL,NULL,'2021-06-19 19:56:44',NULL,NULL,NULL),('1406472430863568897',NULL,'1406472430863568897',2,1,NULL,'15759529298','639008','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-20 12:42:13',NULL,NULL,NULL,'2021-06-20 12:42:13',NULL,NULL,NULL),('1406473413207314433',NULL,'1406473413207314433',2,1,NULL,'15759529298','353799','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-20 12:46:07',NULL,NULL,NULL,'2021-06-20 12:46:07',NULL,NULL,NULL),('1406512364181835778',NULL,'1406512364181835778',2,1,NULL,'15392088258','498618','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-20 15:20:54',NULL,NULL,NULL,'2021-06-20 15:20:54',NULL,NULL,NULL),('1406528277635452929',NULL,'1406528277635452929',2,1,NULL,'19959951336','562847','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-20 16:24:08',NULL,NULL,NULL,'2021-06-20 16:24:08',NULL,NULL,NULL),('1406528567449276417',NULL,'1406528567449276417',2,1,NULL,'19959951336','699462','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-20 16:25:17',NULL,NULL,NULL,'2021-06-20 16:25:17',NULL,NULL,NULL),('1406610648829317122',NULL,'1406610648829317122',2,1,NULL,'15959267002','402381','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-20 21:51:26',NULL,NULL,NULL,'2021-06-20 21:51:26',NULL,NULL,NULL),('1406778898296918018','1211461407799820290','1406778898296918018',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:00',NULL,NULL,NULL,'2021-06-21 09:00:00',NULL,NULL,NULL),('1406778898301112321','1211559758373371905','1406778898301112321',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:00',NULL,NULL,NULL,'2021-06-21 09:00:00',NULL,NULL,NULL),('1406778898854760450','1211120827064496130','1406778898854760450',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:00',NULL,NULL,NULL,'2021-06-21 09:00:00',NULL,NULL,NULL),('1406778899492294658','1211473406755651586','1406778899492294658',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:00',NULL,NULL,NULL,'2021-06-21 09:00:00',NULL,NULL,NULL),('1406778899500683266','1212685717864517633','1406778899500683266',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778899664261121','1211167966465470465','1406778899664261121',2,2,'晋江易库物联网科技有限公司','18959210622','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900045942785','1216559724997144578','1406778900045942785',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900175966209','1211474926804975617','1406778900175966209',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900268240898','1211236784814534658','1406778900268240898',2,2,'晋江乐康医院有限公司','15109613666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900352126978','58','1406778900352126978',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900352126979','72','1406778900352126979',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900524093441','1211837849989595138','1406778900524093441',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900549259265','58','1406778900549259265',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900670894081','1211461407799820290','1406778900670894081',2,2,'晋江经济报发展有限责任公司','13505004167','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900683476994','1215608523329683457','1406778900683476994',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900683476995','87','1406778900683476995',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778901618806786','87','1406778901618806786',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778901694304258','102','1406778901694304258',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778901753024514','1211473406755651586','1406778901753024514',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778901866270721','1216568840104734722','1406778901866270721',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778901979516930','1211474926804975617','1406778901979516930',2,2,'泉州轻工职业学院','13799550180','6,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778901979516931','102','1406778901979516931',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902101151745','1295900371603947522','1406778902101151745',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902348615682','1348924009986654209','1406778902348615682',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902348615683','1211490446086291458','1406778902348615683',2,2,'泉州职业技术大学','18060007601','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902562525186','70','1406778902562525186',1,2,'陈瑞清','13788864979','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902642216962','1351830895278948354','1406778902642216962',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902642216963','1211529007779069954','1406778902642216963',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902822572034','76','1406778902822572034',1,2,'陈颖颖','13505079029','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902948401154','1211561316616028162','1406778902948401154',2,2,'福建盼盼饮料有限公司','15959993860','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778902965178369','1374554432229978113','1406778902965178369',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778903049064449','83','1406778903049064449',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778903221030913','1376712565047975937','1406778903221030913',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778903242002434','1211837849989595138','1406778903242002434',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778903632072705','1212535414099873794','1406778903632072705',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778903632072706','1394875586618372097','1406778903632072706',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:01',NULL,NULL,NULL,'2021-06-21 09:00:01',NULL,NULL,NULL),('1406778903967617025','1212604591955316738','1406778903967617025',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778903996977153','1395562221148352513','1406778903996977153',2,2,'泉州凡硕知识产权代理有限公司','15759495831','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778904194109441','1212692778300018689','1406778904194109441',2,2,'晋江市路桥建设开发有限公司','17350011170','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778904194109442','1397005602617602050','1406778904194109442',2,2,'晋江市池店镇兴源武术馆','15959566909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778904391241730','1400005983526223873','1406778904391241730',2,2,'福建舒雨伞业有限公司','15905035188','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778904483516418','1214802166888357889','1406778904483516418',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778904701620226','1216568840104734722','1406778904701620226',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778904978444289','1219140374220627970','1406778904978444289',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778905221713921','1219144052960780289','1406778905221713921',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778905523703809','1219147136575332354','1406778905523703809',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778905909579778','1219451161745080321','1406778905909579778',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778906249318401','1274912838720167938','1406778906249318401',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778906467422210','1275223626664165377','1406778906467422210',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778906748440577','1275343906086633473','1406778906748440577',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778906983321602','1277434198482796545','1406778906983321602',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778907184648193','1280319682515079169','1406778907184648193',2,2,'晋江市集成电路科技投资有限责任公司','15960586822','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778907390169089','1286499346338045953','1406778907390169089',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778907591495681','1290207451647430657','1406778907591495681',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778907788627969','1298925594909732865','1406778907788627969',2,2,'福建柒牌集团有限公司','15959993797','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:02',NULL,NULL,NULL,'2021-06-21 09:00:02',NULL,NULL,NULL),('1406778907981565954','1300227590451228674','1406778907981565954',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406778908187086850','1303977759655100418','1406778908187086850',2,2,'福建省晋江自来水股份有限公司','13505952596','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406778908472299521','1311218079904079874','1406778908472299521',2,2,'晋江市企业上市服务中心','13788822586','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406778908723957761','1315551775847133185','1406778908723957761',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406778908942061569','1316201027820630017','1406778908942061569',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406778909508292610','1331802046063443969','1406778909508292610',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406778910162604034','1338784953806094337','1406778910162604034',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406778910728835074','1341906391132053505','1406778910728835074',2,2,'晋江市华天市政工程有限公司','15880816775','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 09:00:03',NULL,NULL,NULL,'2021-06-21 09:00:03',NULL,NULL,NULL),('1406780426252505089',NULL,'1406780426252505089',2,1,NULL,'15260852193','852006','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 09:06:04',NULL,NULL,NULL,'2021-06-21 09:06:04',NULL,NULL,NULL),('1406788839489458178',NULL,'1406788839489458178',2,1,NULL,'15392288855','654230','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 09:39:30',NULL,NULL,NULL,'2021-06-21 09:39:30',NULL,NULL,NULL),('1406790164033884161',NULL,'1406790164033884161',2,1,NULL,'15392288855','051255','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 09:44:46',NULL,NULL,NULL,'2021-06-21 09:44:46',NULL,NULL,NULL),('1406791202749075458',NULL,'1406791202749075458',2,1,NULL,'15392288855','914981','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 09:48:54',NULL,NULL,NULL,'2021-06-21 09:48:54',NULL,NULL,NULL),('1406801620481658882',NULL,'1406801620481658882',2,1,NULL,'15260860140','293755','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 10:30:18',NULL,NULL,NULL,'2021-06-21 10:30:18',NULL,NULL,NULL),('1406803192473243649',NULL,'1406803192473243649',2,1,NULL,'15880819707','132173','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 10:36:32',NULL,NULL,NULL,'2021-06-21 10:36:32',NULL,NULL,NULL),('1406804609426575361',NULL,'1406804609426575361',2,1,NULL,'15880819707','239025','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 10:42:10',NULL,NULL,NULL,'2021-06-21 10:42:10',NULL,NULL,NULL),('1406810107618054145','1406804667970670593','1406810107618054145',2,2,'晋江市“120”急救指挥中心','15880819707','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-21 11:04:01',NULL,NULL,NULL,'2021-06-21 11:04:01',NULL,NULL,NULL),('1406818294131904514',NULL,'1406818294131904514',2,1,NULL,'13295035068','250442','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 11:36:33',NULL,NULL,NULL,'2021-06-21 11:36:33',NULL,NULL,NULL),('1406822756275769345',NULL,'1406822756275769345',2,1,NULL,'13799551137','605601','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 11:54:17',NULL,NULL,NULL,'2021-06-21 11:54:17',NULL,NULL,NULL),('1406865235452678146',NULL,'1406865235452678146',2,1,NULL,'15880819707','209689','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 14:43:05',NULL,NULL,NULL,'2021-06-21 14:43:05',NULL,NULL,NULL),('1406903937981841409',NULL,'1406903937981841409',2,1,NULL,'13636902899','698107','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 17:16:52',NULL,NULL,NULL,'2021-06-21 17:16:52',NULL,NULL,NULL),('1406917913969000450',NULL,'1406917913969000450',2,1,NULL,'13959775001','451331','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-21 18:12:24',NULL,NULL,NULL,'2021-06-21 18:12:24',NULL,NULL,NULL),('1406954381999439874','1396123284294119425','1406954381999439874',2,2,'晋江市润丰鞋业有限公司','13788805513','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-21 20:37:19',NULL,NULL,NULL,'2021-06-21 20:37:19',NULL,NULL,NULL),('1406954801937350658','1386881177972948993','1406954801937350658',2,2,'四相科技(晋江)有限公司','18046334282','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-21 20:38:59',NULL,NULL,NULL,'2021-06-21 20:38:59',NULL,NULL,NULL),('1406955215986458626','1400263296149389313','1406955215986458626',2,2,'晋江市金秀叶雨具有限责任公司','18606050830','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-21 20:40:38',NULL,NULL,NULL,'2021-06-21 20:40:38',NULL,NULL,NULL),('1406956117623406593','1405774133261815809','1406956117623406593',2,2,'晋江市园绿园农林专业合作社','18350773795','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-21 20:44:13',NULL,NULL,NULL,'2021-06-21 20:44:13',NULL,NULL,NULL),('1407257464943976450',NULL,'1407257464943976450',2,1,NULL,'18350773795','244816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-22 16:41:39',NULL,NULL,NULL,'2021-06-22 16:41:39',NULL,NULL,NULL),('1407273971174383617',NULL,'1407273971174383617',2,1,NULL,'13506062515','361918','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-22 17:47:15',NULL,NULL,NULL,'2021-06-22 17:47:15',NULL,NULL,NULL),('1407340190137098241',NULL,'1407340190137098241',2,1,NULL,'15860583758','197233','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-22 22:10:23',NULL,NULL,NULL,'2021-06-22 22:10:23',NULL,NULL,NULL),('1407340779025768449',NULL,'1407340779025768449',2,1,NULL,'15860583758','147841','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-22 22:12:43',NULL,NULL,NULL,'2021-06-22 22:12:43',NULL,NULL,NULL),('1407503671566049282','1211120827064496130','1407503671566049282',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671570243586','1211171114114461697','1407503671570243586',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671687684098','1211442194934710274','1407503671687684098',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671985479681','58','1407503671985479681',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672023228417','72','1407503672023228417',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672056782849','1211490446086291458','1407503672056782849',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672069365762','1211453814360555522','1407503672069365762',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672077754369','1211236784814534658','1407503672077754369',2,2,'晋江乐康医院有限公司','15109613666','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672123891713','70','1407503672123891713',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672224555009','87','1407503672224555009',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672249720833','58','1407503672249720833',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672279080961','1211490953219588098','1407503672279080961',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672404910082','76','1407503672404910082',1,2,'陈颖颖','13505079029','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672409104385','102','1407503672409104385',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672409104386','1211461407799820290','1407503672409104386',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672421687297','87','1407503672421687297',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672425881602','1211473406755651586','1407503672425881602',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672472018946','1211554636561956866','1407503672472018946',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672614625282','83','1407503672614625282',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672618819585','1211473406755651586','1407503672618819585',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672643985409','102','1407503672643985409',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672643985410','1211474926804975617','1407503672643985410',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672685928449','1211559758373371905','1407503672685928449',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672794980354','1211474926804975617','1407503672794980354',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672862089217','1211490446086291458','1407503672862089217',2,2,'泉州职业技术大学','18060007601','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672874672130','1211855307945328641','1407503672874672130',2,2,'福建好来屋食品工业有限公司','15160423086','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503672979529730','1211572731150123009','1407503672979529730',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673029861378','1211529007779069954','1407503673029861378',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673042444289','1212685717864517633','1407503673042444289',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673151496194','1211837849989595138','1407503673151496194',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673201827842','1211837849989595138','1407503673201827842',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673226993665','1216559724997144578','1407503673226993665',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673331851265','1212535414099873794','1407503673331851265',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673373794305','1212604591955316738','1407503673373794305',2,2,'福建约克新材料科技有限公司','18900370886','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673390571521','1328179674966147074','1407503673390571521',2,2,'泉州三允知识产权代理事务所(普通合伙)','18016660902','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673528983554','1212685717864517633','1407503673528983554',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673545760770','1212692778300018689','1407503673545760770',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673705144321','1214118511954120705','1407503673705144321',2,2,'泉州协创知识产权代理事务所(普通合伙)','18965727570','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673747087361','1214802166888357889','1407503673747087361',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503673877110786','1215608523329683457','1407503673877110786',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674002939905','1216568840104734722','1407503674002939905',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674103603201','1216568840104734722','1407503674103603201',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674195877889','1219140374220627970','1407503674195877889',2,2,'福建亲亲股份有限公司','15960735252','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674283958273','1241252588561698817','1407503674283958273',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674388815873','1219144052960780289','1407503674388815873',2,2,'福建冠泓工业有限公司','15396395062','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674544005121','1285493408407756802','1407503674544005121',2,2,'福建晋江热电有限公司','18659595539','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674640474113','1219451161745080321','1407503674640474113',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674736943106','1290850604855361537','1407503674736943106',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674829217794','1274912838720167938','1407503674829217794',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503674976018434','1295900371603947522','1407503674976018434',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503675118624770','1275223626664165377','1407503675118624770',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503675160567809','1348924009986654209','1407503675160567809',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:00',NULL,NULL,NULL,'2021-06-23 09:00:00',NULL,NULL,NULL),('1407503675319951362','1275343906086633473','1407503675319951362',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503675340922881','1351830895278948354','1407503675340922881',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503675508695042','1277434198482796545','1407503675508695042',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503675538055170','1364861648258506753','1407503675538055170',2,2,'晋江国家体育产业基地发展中心','13215958966','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503675722604545','1286499346338045953','1407503675722604545',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503675777130498','1374554432229978113','1407503675777130498',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503675944902657','1290207451647430657','1407503675944902657',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503675961679874','1376007099934351361','1407503675961679874',2,2,'福建省恺思智能设备有限公司','13850759758','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503676150423553','1315551775847133185','1407503676150423553',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503676171395073','1376712565047975937','1407503676171395073',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503676364333057','1394875586618372097','1407503676364333057',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503676418859010','1316201027820630017','1407503676418859010',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503676595019777','1395562221148352513','1407503676595019777',2,2,'泉州凡硕知识产权代理有限公司','15759495831','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503676762791938','1395563657722638337','1407503676762791938',2,2,'晋江汇杰企业管理有限责任公司','18318040909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503676972507137','1397005602617602050','1407503676972507137',2,2,'晋江市池店镇兴源武术馆','15959566909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503677144473602','1400338869487960065','1407503677144473602',2,2,'晋江市恒丰进出口贸易有限公司','13559052503','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407503677316440065','1402819845443059714','1407503677316440065',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-23 09:00:01',NULL,NULL,NULL,'2021-06-23 09:00:01',NULL,NULL,NULL),('1407506914870337538',NULL,'1407506914870337538',2,1,NULL,'18065338355','675203','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 09:12:53',NULL,NULL,NULL,'2021-06-23 09:12:53',NULL,NULL,NULL),('1407507824442908674',NULL,'1407507824442908674',2,1,NULL,'18065338355','078291','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 09:16:30',NULL,NULL,NULL,'2021-06-23 09:16:30',NULL,NULL,NULL),('1407524152377647106',NULL,'1407524152377647106',2,1,NULL,'15959959600','978428','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 10:21:23',NULL,NULL,NULL,'2021-06-23 10:21:23',NULL,NULL,NULL),('1407526590753054722',NULL,'1407526590753054722',2,1,NULL,'13489990595','820419','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 10:31:04',NULL,NULL,NULL,'2021-06-23 10:31:04',NULL,NULL,NULL),('1407546740583735297',NULL,'1407546740583735297',2,1,NULL,'15759596816','614623','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 11:51:08',NULL,NULL,NULL,'2021-06-23 11:51:08',NULL,NULL,NULL),('1407578760911298561',NULL,'1407578760911298561',2,1,NULL,'13905069908','176310','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 13:58:22',NULL,NULL,NULL,'2021-06-23 13:58:22',NULL,NULL,NULL),('1407597339492786178',NULL,'1407597339492786178',2,1,NULL,'13489298516','115645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 15:12:12',NULL,NULL,NULL,'2021-06-23 15:12:12',NULL,NULL,NULL),('1407623366990405633',NULL,'1407623366990405633',2,1,NULL,'13074937542','750395','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 16:55:37',NULL,NULL,NULL,'2021-06-23 16:55:37',NULL,NULL,NULL),('1407687656468422658',NULL,'1407687656468422658',2,1,NULL,'15905907962','258602','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 21:11:05',NULL,NULL,NULL,'2021-06-23 21:11:05',NULL,NULL,NULL),('1407706203080925186',NULL,'1407706203080925186',2,1,NULL,'18759222567','679517','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 22:24:47',NULL,NULL,NULL,'2021-06-23 22:24:47',NULL,NULL,NULL),('1407709449115705345',NULL,'1407709449115705345',2,1,NULL,'15813354635','961424','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-23 22:37:41',NULL,NULL,NULL,'2021-06-23 22:37:41',NULL,NULL,NULL),('1407866059393900546','1211171114114461697','1407866059393900546',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059393900547','1211120827064496130','1407866059393900547',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059452620802','1211442194934710274','1407866059452620802',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059721056258','58','1407866059721056258',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059821719554','72','1407866059821719554',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059830108162','70','1407866059830108162',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059968520194','1211453814360555522','1407866059968520194',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060006268930','87','1407866060006268930',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060027240450','1211473406755651586','1407866060027240450',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060064989186','1211490446086291458','1407866060064989186',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060111126530','58','1407866060111126530',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060190818306','1211461407799820290','1407866060190818306',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060262121473','83','1407866060262121473',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060283092994','102','1407866060283092994',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060304064514','1211490446086291458','1407866060304064514',2,2,'泉州职业技术大学','18060007601','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060350201858','87','1407866060350201858',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060392144897','1211473406755651586','1407866060392144897',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060434087938','1211554636561956866','1407866060434087938',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060501196802','86','1407866060501196802',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060614443010','1211529007779069954','1407866060614443010',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060614443011','1211474926804975617','1407866060614443011',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060631220226','102','1407866060631220226',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060639608834','1211559758373371905','1407866060639608834',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060866101249','1211490953219588098','1407866060866101249',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060866101250','1211572731150123009','1407866060866101250',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866060899655682','1211837849989595138','1407866060899655682',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061084205057','1211837849989595138','1407866061084205057',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061092593666','1212692778300018689','1407866061092593666',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061100982273','1212685717864517633','1407866061100982273',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061289725953','1214142410787934209','1407866061289725953',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061314891777','1212535414099873794','1407866061314891777',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061348446210','1216559724997144578','1407866061348446210',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061562355714','1212685717864517633','1407866061562355714',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061562355715','1214802166888357889','1407866061562355715',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061734322177','1216568840104734722','1407866061734322177',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061742710786','1214118511954120705','1407866061742710786',2,2,'泉州协创知识产权代理事务所(普通合伙)','18965727570','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061902094338','1219451161745080321','1407866061902094338',2,2,'泉州福林汽车销售服务有限公司','13675966551','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866061906288642','1215608523329683457','1407866061906288642',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062099226626','1274912838720167938','1407866062099226626',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062099226627','1216568840104734722','1407866062099226627',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062279581698','1275223626664165377','1407866062279581698',2,2,'福建爱乡亲食品股份有限公司','18750536470','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062283776001','1216626668072869889','1407866062283776001',2,2,'晋江市融媒体中心','13505079029','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062518657025','1275343906086633473','1407866062518657025',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062518657026','1241252588561698817','1407866062518657026',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062690623490','1290850604855361537','1407866062690623490',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062703206401','1277434198482796545','1407866062703206401',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062891950081','1295900371603947522','1407866062891950081',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866062996807682','1277910183363776514','1407866062996807682',2,2,'泉州市顺时针电子商务有限公司','15985992783','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866063068110850','1348924009986654209','1407866063068110850',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:00',NULL,NULL,NULL,'2021-06-24 09:00:00',NULL,NULL,NULL),('1407866063206522881','1286499346338045953','1407866063206522881',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866063231688705','1351830895278948354','1407866063231688705',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866063407849474','1290207451647430657','1407866063407849474',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866063428820993','1374554432229978113','1407866063428820993',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866063621758978','1315551775847133185','1407866063621758978',2,2,'福建安踏物流信息科技有限公司','15850575332','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866063621758979','1376712565047975937','1407866063621758979',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866063865028610','1394875586618372097','1407866063865028610',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866063894388737','1316201027820630017','1407866063894388737',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407866064049577985','1402819845443059714','1407866064049577985',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-24 09:00:01',NULL,NULL,NULL,'2021-06-24 09:00:01',NULL,NULL,NULL),('1407880979741188098',NULL,'1407880979741188098',2,1,NULL,'15880880291','088776','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-24 09:59:17',NULL,NULL,NULL,'2021-06-24 09:59:17',NULL,NULL,NULL),('1407881026964856833',NULL,'1407881026964856833',2,1,NULL,'13506907912','975159','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-24 09:59:28',NULL,NULL,NULL,'2021-06-24 09:59:28',NULL,NULL,NULL),('1407977301999656961',NULL,'1407977301999656961',2,1,NULL,'18659595539','163207','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-24 16:22:02',NULL,NULL,NULL,'2021-06-24 16:22:02',NULL,NULL,NULL),('1408228447217557505','1211120827064496130','1408228447217557505',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447221751810','1216568840104734722','1408228447221751810',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447305637890','1211490446086291458','1408228447305637890',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447368552450','1211442194934710274','1408228447368552450',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447821537282','58','1408228447821537282',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447825731586','70','1408228447825731586',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447829925890','72','1408228447829925890',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448014475266','1211529007779069954','1408228448014475266',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448014475267','1211554636561956866','1408228448014475267',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448043835394','1211453814360555522','1408228448043835394',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448157081601','83','1408228448157081601',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448211607553','87','1408228448211607553',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448224190466','1211559758373371905','1408228448224190466',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448224190467','1211837849989595138','1408228448224190467',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448228384770','58','1408228448228384770',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448228384771','1211461407799820290','1408228448228384771',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448421322753','102','1408228448421322753',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448433905665','87','1408228448433905665',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448442294274','1212692778300018689','1408228448442294274',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448442294275','1211572731150123009','1408228448442294275',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448442294276','1211473406755651586','1408228448442294276',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448622649346','102','1408228448622649346',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448631037953','1212685717864517633','1408228448631037953',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448635232258','1211474926804975617','1408228448635232258',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448643620866','1214142410787934209','1408228448643620866',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448798810113','1211490953219588098','1408228448798810113',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448815587329','1216559724997144578','1408228448815587329',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448819781633','1214802166888357889','1408228448819781633',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228448995942402','1211837849989595138','1408228448995942402',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449004331009','1219451161745080321','1408228449004331009',2,2,'泉州福林汽车销售服务有限公司','13675966551','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449176297473','1212535414099873794','1408228449176297473',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449205657601','1274912838720167938','1408228449205657601',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449436344321','1212685717864517633','1408228449436344321',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449448927233','1275343906086633473','1408228449448927233',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449696391169','1215608523329683457','1408228449696391169',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449717362689','1277434198482796545','1408228449717362689',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449893523457','1216568840104734722','1408228449893523457',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228449960632322','1286499346338045953','1408228449960632322',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228450073878529','1241252588561698817','1408228450073878529',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228450216484866','1290207451647430657','1408228450216484866',2,2,'晋江国盛新材料科技有限公司','13860736349','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228450271010817','1290850604855361537','1408228450271010817',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228450568806401','1295900371603947522','1408228450568806401',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228450648498177','1316201027820630017','1408228450648498177',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228450816270338','1348924009986654209','1408228450816270338',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:00',NULL,NULL,NULL,'2021-06-25 09:00:00',NULL,NULL,NULL),('1408228451080511489','1351830895278948354','1408228451080511489',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:01',NULL,NULL,NULL,'2021-06-25 09:00:01',NULL,NULL,NULL),('1408228451256672258','1374554432229978113','1408228451256672258',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:01',NULL,NULL,NULL,'2021-06-25 09:00:01',NULL,NULL,NULL),('1408228451499941889','1376712565047975937','1408228451499941889',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:01',NULL,NULL,NULL,'2021-06-25 09:00:01',NULL,NULL,NULL),('1408228451730628610','1394875586618372097','1408228451730628610',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:01',NULL,NULL,NULL,'2021-06-25 09:00:01',NULL,NULL,NULL),('1408228451923566594','1402819845443059714','1408228451923566594',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-25 09:00:01',NULL,NULL,NULL,'2021-06-25 09:00:01',NULL,NULL,NULL),('1408260499660906497',NULL,'1408260499660906497',2,1,NULL,'15960565293','656086','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-25 11:07:21',NULL,NULL,NULL,'2021-06-25 11:07:21',NULL,NULL,NULL),('1408342189557194753',NULL,'1408342189557194753',2,1,NULL,'13788854137','750362','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-25 16:31:58',NULL,NULL,NULL,'2021-06-25 16:31:58',NULL,NULL,NULL),('1408397507528007682',NULL,'1408397507528007682',2,1,NULL,'13960755820','594299','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-25 20:11:47',NULL,NULL,NULL,'2021-06-25 20:11:47',NULL,NULL,NULL),('1408973792100786177',NULL,'1408973792100786177',2,1,NULL,'18960679210','340784','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-27 10:21:44',NULL,NULL,NULL,'2021-06-27 10:21:44',NULL,NULL,NULL),('1408990919063019522',NULL,'1408990919063019522',2,1,NULL,'18396115458','008639','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-27 11:29:47',NULL,NULL,NULL,'2021-06-27 11:29:47',NULL,NULL,NULL),('1409308583882956802',NULL,'1409308583882956802',2,1,NULL,'15905054477','875631','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-28 08:32:04',NULL,NULL,NULL,'2021-06-28 08:32:04',NULL,NULL,NULL),('1409315610768220162','1211120827064496130','1409315610768220162',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315610839523329','1211490446086291458','1409315610839523329',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315610885660674','1211442194934710274','1409315610885660674',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611149901826','58','1409315611149901826',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611154096129','72','1409315611154096129',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611204427778','70','1409315611204427778',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611225399297','1211453814360555522','1409315611225399297',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611246370818','1211138539417350145','1409315611246370818',2,2,'福建百宏聚纤科技实业有限公司','18959858592','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611263148033','1211554636561956866','1409315611263148033',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611405754370','83','1409315611405754370',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611409948674','87','1409315611409948674',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611447697409','58','1409315611447697409',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611447697410','1211461407799820290','1409315611447697410',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611498029058','1211139634755645442','1409315611498029058',2,2,'福建百宏高新材料实业有限公司','13305967663','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611602886658','1211572731150123009','1409315611602886658',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611615469570','102','1409315611615469570',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611644829698','1211473406755651586','1409315611644829698',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611661606913','87','1409315611661606913',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611703549954','1211490446086291458','1409315611703549954',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611779047425','1212685717864517633','1409315611779047425',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611829379074','1211474926804975617','1409315611829379074',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611858739202','102','1409315611858739202',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611925848065','1211515979058692097','1409315611925848065',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611942625282','1216559724997144578','1409315611942625282',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612018122753','1211490953219588098','1409315612018122753',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612106203138','1211529007779069954','1409315612106203138',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612194283522','1211837849989595138','1409315612194283522',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612315918338','1211837849989595138','1409315612315918338',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612399804418','1212535414099873794','1409315612399804418',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612500467714','1212692778300018689','1409315612500467714',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612575965185','1212685717864517633','1409315612575965185',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612710182914','1214802166888357889','1409315612710182914',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612752125954','1216568840104734722','1409315612752125954',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612907315202','1218097536540147714','1409315612907315202',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315612924092417','1241252588561698817','1409315612924092417',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613100253186','1219451161745080321','1409315613100253186',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613129613313','1290850604855361537','1409315613129613313',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613297385474','1274912838720167938','1409315613297385474',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613314162689','1295900371603947522','1409315613314162689',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613490323458','1275343906086633473','1409315613490323458',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613515489281','1348924009986654209','1409315613515489281',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613687455746','1277434198482796545','1409315613687455746',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613687455747','1351830895278948354','1409315613687455747',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613863616513','1374554432229978113','1409315613863616513',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315613867810817','1286499346338045953','1409315613867810817',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315614077526017','1290207451647430657','1409315614077526017',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315614077526018','1376712565047975937','1409315614077526018',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315614316601346','1394875586618372097','1409315614316601346',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409315614324989953','1316201027820630017','1409315614324989953',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-28 09:00:00',NULL,NULL,NULL,'2021-06-28 09:00:00',NULL,NULL,NULL),('1409363635284779009',NULL,'1409363635284779009',2,1,NULL,'15905907962','482289','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-28 12:10:50',NULL,NULL,NULL,'2021-06-28 12:10:50',NULL,NULL,NULL),('1409406206195310594',NULL,'1409406206195310594',2,1,NULL,'17759728979','397333','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-28 14:59:59',NULL,NULL,NULL,'2021-06-28 14:59:59',NULL,NULL,NULL),('1409412921510895617','1408342930711683074','1409412921510895617',2,2,'福建恒安卫生材料有限公司','13788854137','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-06-28 15:26:40',NULL,NULL,NULL,'2021-06-28 15:26:40',NULL,NULL,NULL),('1409441402894458882',NULL,'1409441402894458882',2,1,NULL,'18650675858','965080','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-28 17:19:51',NULL,NULL,NULL,'2021-06-28 17:19:51',NULL,NULL,NULL),('1409677998734483457','1211120827064496130','1409677998734483457',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677998776426498','1211490446086291458','1409677998776426498',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677998851923970','1211442194934710274','1409677998851923970',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999405572097','70','1409677999405572097',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999409766402','58','1409677999409766402',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999413960705','72','1409677999413960705',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999502041089','1211453814360555522','1409677999502041089',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999502041090','1211484578443739137','1409677999502041090',2,2,'晋江市锦福化纤聚合有限公司','13599749329','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999506235393','1211554636561956866','1409677999506235393',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999665618945','87','1409677999665618945',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999678201858','58','1409677999678201858',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999711756290','1211572731150123009','1409677999711756290',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999711756291','1211490446086291458','1409677999711756291',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999715950593','1211461407799820290','1409677999715950593',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999887917057','102','1409677999887917057',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999904694273','1212685717864517633','1409677999904694273',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999904694274','1211473406755651586','1409677999904694274',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999934054401','87','1409677999934054401',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999988580353','1211515979058692097','1409677999988580353',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000068272129','1216559724997144578','1409678000068272129',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000080855042','1211474926804975617','1409678000080855042',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000085049346','102','1409678000085049346',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000181518338','1211529007779069954','1409678000181518338',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000315736065','1211490953219588098','1409678000315736065',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000361873409','1211837849989595138','1409678000361873409',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000538034177','1211837849989595138','1409678000538034177',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000546422786','1212580494957416450','1409678000546422786',2,2,'舒华体育股份有限公司','13599295908','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000751943681','1212535414099873794','1409678000751943681',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000873578498','1212692778300018689','1409678000873578498',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678000923910145','1212685717864517633','1409678000923910145',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001058127873','1214802166888357889','1409678001058127873',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001133625345','1216568840104734722','1409678001133625345',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001272037377','1215608523329683457','1409678001272037377',2,2,'晋江大长江奥通汽车销售服务有限公司','13506062515','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001427226626','1241252588561698817','1409678001427226626',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001456586753','1218097536540147714','1409678001456586753',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001649524738','1295900371603947522','1409678001649524738',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001670496258','1219451161745080321','1409678001670496258',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001934737410','1348924009986654209','1409678001934737410',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678001989263361','1274912838720167938','1409678001989263361',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678002211561474','1275343906086633473','1409678002211561474',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678002228338690','1351830895278948354','1409678002228338690',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678002417082369','1374554432229978113','1409678002417082369',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678002421276673','1277434198482796545','1409678002421276673',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:00',NULL,NULL,NULL,'2021-06-29 09:00:00',NULL,NULL,NULL),('1409678002593243137','1286499346338045953','1409678002593243137',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:01',NULL,NULL,NULL,'2021-06-29 09:00:01',NULL,NULL,NULL),('1409678002635186177','1376712565047975937','1409678002635186177',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:01',NULL,NULL,NULL,'2021-06-29 09:00:01',NULL,NULL,NULL),('1409678002777792513','1290207451647430657','1409678002777792513',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:01',NULL,NULL,NULL,'2021-06-29 09:00:01',NULL,NULL,NULL),('1409678002823929858','1394875586618372097','1409678002823929858',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:01',NULL,NULL,NULL,'2021-06-29 09:00:01',NULL,NULL,NULL),('1409678002958147585','1316201027820630017','1409678002958147585',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-29 09:00:01',NULL,NULL,NULL,'2021-06-29 09:00:01',NULL,NULL,NULL),('1409681306903683074',NULL,'1409681306903683074',2,1,NULL,'15880993753','753214','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-29 09:13:08',NULL,NULL,NULL,'2021-06-29 09:13:08',NULL,NULL,NULL),('1409684351397961729',NULL,'1409684351397961729',2,1,NULL,'13960600100','181079','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-29 09:25:14',NULL,NULL,NULL,'2021-06-29 09:25:14',NULL,NULL,NULL),('1409783099981602817',NULL,'1409783099981602817',2,1,NULL,'15880719022','062652','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-29 15:57:38',NULL,NULL,NULL,'2021-06-29 15:57:38',NULL,NULL,NULL),('1409795439410061314',NULL,'1409795439410061314',2,1,NULL,'15059066119','361344','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-29 16:46:40',NULL,NULL,NULL,'2021-06-29 16:46:40',NULL,NULL,NULL),('1410040163815432193',NULL,'1410040163815432193',2,1,NULL,'15059066119','121714','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-06-30 08:59:06',NULL,NULL,NULL,'2021-06-30 08:59:06',NULL,NULL,NULL),('1410040386545557506','1211120827064496130','1410040386545557506',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386562334721','1211490446086291458','1410040386562334721',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386591694850','1211442194934710274','1410040386591694850',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387040485377','1211167966465470465','1410040387040485377',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387048873986','1211453814360555522','1410040387048873986',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387057262593','1211554636561956866','1410040387057262593',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387174703106','58','1410040387174703106',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387174703107','72','1410040387174703107',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387174703108','70','1410040387174703108',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387359252482','1211572731150123009','1410040387359252482',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387359252483','1211461407799820290','1410040387359252483',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387359252484','1211456215943528450','1410040387359252484',2,2,'福建泉成机械有限公司','15392286115','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387485081602','58','1410040387485081602',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387514441729','87','1410040387514441729',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387648659458','1211473406755651586','1410040387648659458',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387669630978','1212685717864517633','1410040387669630978',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387669630979','1211484578443739137','1410040387669630979',2,2,'晋江市锦福化纤聚合有限公司','13599749329','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387715768322','102','1410040387715768322',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387715768323','87','1410040387715768323',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387858374657','1211474926804975617','1410040387858374657',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387870957569','1216559724997144578','1410040387870957569',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387870957570','1211490446086291458','1410040387870957570',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387963232257','102','1410040387963232257',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388093255682','1211490953219588098','1410040388093255682',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388105838594','1211515979058692097','1410040388105838594',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388336525314','1211529007779069954','1410040388336525314',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388344913922','1211837849989595138','1410040388344913922',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388525268993','1211548619757371393','1410040388525268993',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388575600641','1212535414099873794','1410040388575600641',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388764344322','1211554636561956866','1410040388764344322',2,2,'泉州华祥纸业有限公司','13860748042','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388818870273','1212685717864517633','1410040388818870273',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388957282305','1211576021401255937','1410040388957282305',2,2,'泉州鑫豪工程机械科技有限公司','18900399682','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040388999225346','1216568840104734722','1410040388999225346',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389137637377','1211609839420096513','1410040389137637377',2,2,'福建省晋江产业发展投资集团有限公司','13599789599','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389246689281','1241252588561698817','1410040389246689281',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389477376002','1211837849989595138','1410040389477376002',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389510930433','1295900371603947522','1410040389510930433',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389687091201','1211936041519333377','1410040389687091201',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389737422850','1348924009986654209','1410040389737422850',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389892612097','1212568548061286401','1410040389892612097',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040389972303874','1351830895278948354','1410040389972303874',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040390081355777','1212580494957416450','1410040390081355777',2,2,'舒华体育股份有限公司','13599295908','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040390194601985','1374554432229978113','1410040390194601985',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040390261710850','1212692778300018689','1410040390261710850',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL,'2021-06-30 09:00:00',NULL,NULL,NULL),('1410040390383345666','1376712565047975937','1410040390383345666',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040390437871617','1214025654970896386','1410040390437871617',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040390580477954','1394875586618372097','1410040390580477954',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040390668558337','1214802166888357889','1410040390668558337',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040390853107713','1218097536540147714','1410040390853107713',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040391050240002','1219451161745080321','1410040391050240002',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040391238983681','1274912838720167938','1410040391238983681',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040391490641921','1275260777149808641','1410040391490641921',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040391675191297','1275343906086633473','1410040391675191297',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040391880712194','1277434198482796545','1410040391880712194',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040392069455874','1286499346338045953','1410040392069455874',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040392258199554','1290207451647430657','1410040392258199554',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410040392442748929','1316201027820630017','1410040392442748929',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL,'2021-06-30 09:00:01',NULL,NULL,NULL),('1410069630780743681',NULL,'1410069630780743681',2,1,NULL,'15059066119','952350','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 10:56:12',NULL,NULL,NULL,'2021-06-30 10:56:12',NULL,NULL,NULL),('1410070068594778114',NULL,'1410070068594778114',2,1,NULL,'15059066119','768716','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 10:57:56',NULL,NULL,NULL,'2021-06-30 10:57:56',NULL,NULL,NULL),('1410082296349892610',NULL,'1410082296349892610',2,1,NULL,'15059066119','119816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 11:46:32',NULL,NULL,NULL,'2021-06-30 11:46:32',NULL,NULL,NULL),('1410083449703800833',NULL,'1410083449703800833',2,1,NULL,'15059066119','344202','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 11:51:07',NULL,NULL,NULL,'2021-06-30 11:51:07',NULL,NULL,NULL),('1410083723994505217',NULL,'1410083723994505217',2,1,NULL,'15059066119','443359','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 11:52:12',NULL,NULL,NULL,'2021-06-30 11:52:12',NULL,NULL,NULL),('1410083820383805441',NULL,'1410083820383805441',2,1,NULL,'15059066119','023134','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 11:52:35',NULL,NULL,NULL,'2021-06-30 11:52:35',NULL,NULL,NULL),('1410083919725895681',NULL,'1410083919725895681',2,1,NULL,'15059066119','489816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 11:52:59',NULL,NULL,NULL,'2021-06-30 11:52:59',NULL,NULL,NULL),('1410114743934427137',NULL,'1410114743934427137',2,1,NULL,'15059066119','745435','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',1,NULL,'2021-06-30 13:55:28',NULL,NULL,NULL,'2021-06-30 13:55:28',NULL,NULL,NULL),('1410402774524403714','1211442194934710274','1410402774524403714',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774549569537','1211490446086291458','1410402774549569537',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774641844225','1211120827064496130','1410402774641844225',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774859948033','58','1410402774859948033',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774864142338','70','1410402774864142338',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774876725249','72','1410402774876725249',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776017575937','58','1410402776017575937',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776025964545','1211453814360555522','1410402776025964545',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776025964546','1211554636561956866','1410402776025964546',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776025964547','1211167966465470465','1410402776025964547',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776038547458','87','1410402776038547458',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776206319618','1211572731150123009','1410402776206319618',2,2,'三六一度(福建)体育用品有限公司','13600745760','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776223096834','87','1410402776223096834',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776223096835','1211461407799820290','1410402776223096835',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776235679745','1211240519515090946','1410402776235679745',2,2,'晋江友峰鞋业有限公司','15306089555','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776239874049','102','1410402776239874049',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776378286081','102','1410402776378286081',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776395063298','1212685717864517633','1410402776395063298',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776399257602','1211473406755651586','1410402776399257602',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776453783553','1211456215943528450','1410402776453783553',2,2,'福建泉成机械有限公司','15392286115','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776575418369','1211474926804975617','1410402776575418369',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776604778497','1216559724997144578','1410402776604778497',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776617361409','1211456847907700737','1410402776617361409',2,2,'峰安皮业股份有限公司','15059821270','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776831270913','1211471774600970241','1410402776831270913',2,2,'泉州鸿展模具制造有限公司','18959708027','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402776831270914','1211837849989595138','1410402776831270914',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777015820290','1211484578443739137','1410402777015820290',2,2,'晋江市锦福化纤聚合有限公司','13599749329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777057763330','1212535414099873794','1410402777057763330',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777204563969','1211490446086291458','1410402777204563969',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777267478530','1216568840104734722','1410402777267478530',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777372336130','1211515979058692097','1410402777372336130',2,2,'福建佶龙机械科技股份有限公司','15960791997','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777468805122','1241252588561698817','1410402777468805122',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777615605762','1211529007779069954','1410402777615605762',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777636577281','1295900371603947522','1410402777636577281',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777821126657','1211548619757371393','1410402777821126657',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','5,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402777821126658','1348924009986654209','1410402777821126658',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402778009870338','1351830895278948354','1410402778009870338',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402778022453250','1211554636561956866','1410402778022453250',2,2,'泉州华祥纸业有限公司','13860748042','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402778194419713','1374554432229978113','1410402778194419713',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402778198614017','1211559758373371905','1410402778198614017',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:00',NULL,NULL,NULL,'2021-07-01 09:00:00',NULL,NULL,NULL),('1410402778391552001','1376712565047975937','1410402778391552001',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402778399940610','1211576021401255937','1410402778399940610',2,2,'泉州鑫豪工程机械科技有限公司','18900399682','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402778563518465','1394875586618372097','1410402778563518465',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402778588684290','1211609839420096513','1410402778588684290',2,2,'福建省晋江产业发展投资集团有限公司','13599789599','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402778781622274','1211837849989595138','1410402778781622274',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402779050057730','1211925547903401986','1410402779050057730',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402779276550145','1211931259509456897','1410402779276550145',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402779456905218','1211936041519333377','1410402779456905218',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402779670814722','1212253296765505538','1410402779670814722',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402779846975490','1212568548061286401','1410402779846975490',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402780031524865','1212580494957416450','1410402780031524865',2,2,'舒华体育股份有限公司','13599295908','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402780211879937','1212692778300018689','1410402780211879937',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402780421595137','1212930279740608514','1410402780421595137',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402780597755906','1213345803519725570','1410402780597755906',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402780786499586','1213451329813417985','1410402780786499586',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402781008797698','1214025654970896386','1410402781008797698',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402781214318593','1214041673798012930','1410402781214318593',2,2,'福建省全杰生物科技有限公司','19905050771','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402781390479361','1214079030446280705','1410402781390479361',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402781570834433','1214123943149981698','1410402781570834433',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402781738606594','1214802166888357889','1410402781738606594',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402781923155969','1216626668072869889','1410402781923155969',2,2,'晋江市融媒体中心','13505079029','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402782103511042','1218097536540147714','1410402782103511042',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402782304837633','1219241646047223809','1410402782304837633',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:01',NULL,NULL,NULL,'2021-07-01 09:00:01',NULL,NULL,NULL),('1410402782497775617','1219451161745080321','1410402782497775617',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402782707490818','1274912838720167938','1410402782707490818',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402782879457282','1275260777149808641','1410402782879457282',2,2,'晋江海纳机械有限公司','15159875837','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402783273721857','1275343906086633473','1410402783273721857',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402783454076930','1277434198482796545','1410402783454076930',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402783617654785','1286499346338045953','1410402783617654785',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402783806398465','1290207451647430657','1410402783806398465',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402784028696578','1316201027820630017','1410402784028696578',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410402784280354817','1372467780753924097','1410402784280354817',2,2,'晋江市嘉景汽车配件有限公司','13636905586','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-01 09:00:02',NULL,NULL,NULL,'2021-07-01 09:00:02',NULL,NULL,NULL),('1410430848326475778',NULL,'1410430848326475778',2,1,NULL,'18359599223','040358','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-01 10:51:33',NULL,NULL,NULL,'2021-07-01 10:51:33',NULL,NULL,NULL),('1410466546949595138',NULL,'1410466546949595138',2,1,NULL,'13599109151','554603','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-01 13:13:24',NULL,NULL,NULL,'2021-07-01 13:13:24',NULL,NULL,NULL),('1410513268308484098',NULL,'1410513268308484098',2,1,NULL,'15059066119','860255','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-01 16:19:03',NULL,NULL,NULL,'2021-07-01 16:19:03',NULL,NULL,NULL),('1410513613889773569',NULL,'1410513613889773569',2,1,NULL,'15805018089','267094','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-01 16:20:26',NULL,NULL,NULL,'2021-07-01 16:20:26',NULL,NULL,NULL),('1410514103146946561',NULL,'1410514103146946561',2,1,NULL,'13030997371','645395','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-01 16:22:22',NULL,NULL,NULL,'2021-07-01 16:22:22',NULL,NULL,NULL),('1410525899807301634',NULL,'1410525899807301634',2,1,NULL,'13505951467','283498','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-01 17:09:15',NULL,NULL,NULL,'2021-07-01 17:09:15',NULL,NULL,NULL),('1410765162247397378','1211442194934710274','1410765162247397378',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162251591681','1211490446086291458','1410765162251591681',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162314506242','1211120827064496130','1410765162314506242',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162700382209','70','1410765162700382209',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162708770818','58','1410765162708770818',1,2,'张荣荣','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162717159425','72','1410765162717159425',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162964623362','1211150098789150721','1410765162964623362',2,2,'泉州永实工程质量检测有限公司','15759559009','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162964623363','1211554636561956866','1410765162964623363',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162993983489','1211453814360555522','1410765162993983489',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163073675265','58','1410765163073675265',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163086258178','87','1410765163086258178',1,2,'叶志钦','13675957398','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163161755649','1212685717864517633','1410765163161755649',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163182727170','1211461407799820290','1410765163182727170',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163195310082','1211167966465470465','1410765163195310082',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163258224641','87','1410765163258224641',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163295973377','102','1410765163295973377',1,2,'颜思思','15280619456','6,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163354693634','1211473406755651586','1410765163354693634',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163354693635','1216559724997144578','1410765163354693635',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163413413890','1211240519515090946','1410765163413413890',2,2,'晋江友峰鞋业有限公司','15306089555','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163425996802','102','1410765163425996802',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163551825921','1211474926804975617','1410765163551825921',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163593768961','1211456215943528450','1410765163593768961',2,2,'福建泉成机械有限公司','15392286115','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163757346818','1211837849989595138','1410765163757346818',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163799289858','1211490446086291458','1410765163799289858',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765163937701890','1212535414099873794','1410765163937701890',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164076113922','1211515979058692097','1410765164076113922',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164118056961','1216568840104734722','1410765164118056961',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164269051906','1211529007779069954','1410765164269051906',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164294217729','1241252588561698817','1410765164294217729',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164453601282','1211548619757371393','1410765164453601282',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164474572801','1295900371603947522','1410765164474572801',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164617179138','1211554636561956866','1410765164617179138',2,2,'泉州华祥纸业有限公司','13860748042','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164663316482','1348924009986654209','1410765164663316482',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164793339906','1211559758373371905','1410765164793339906',2,2,'福建盼盼食品有限公司','13665929319','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164822700034','1351830895278948354','1410765164822700034',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164982083585','1211561316616028162','1410765164982083585',2,2,'福建盼盼饮料有限公司','15959993860','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765164990472193','1374554432229978113','1410765164990472193',2,2,'福建省晋华集成电路有限公司','15059820805','251,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765165187604481','1211836173303988226','1410765165187604481',2,2,'福建陆地港集团有限责任公司','17759539230','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765165191798786','1376712565047975937','1410765165191798786',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765165363765249','1211837849989595138','1410765165363765249',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765165367959554','1394875586618372097','1410765165367959554',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765165535731714','1211840469537964033','1410765165535731714',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765165711892481','1211925547903401986','1410765165711892481',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765165900636162','1211931259509456897','1410765165900636162',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:00',NULL,NULL,NULL,'2021-07-02 09:00:00',NULL,NULL,NULL),('1410765166114545666','1212253296765505538','1410765166114545666',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765166311677953','1212568548061286401','1410765166311677953',2,2,'贵人鸟股份有限公司','15359991222','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765166496227329','1212580494957416450','1410765166496227329',2,2,'舒华体育股份有限公司','13599295908','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765166697553922','1212620045818073089','1410765166697553922',2,2,'晋江市达胜纺织实业有限公司','15959886256','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765166903074818','1212665763958165505','1410765166903074818',2,2,'泉州安踏鞋材有限公司','18250638258','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765167079235585','1212675031784558593','1410765167079235585',2,2,'晋江市聚艺健身有限公司','18900300373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765167301533698','1212692778300018689','1410765167301533698',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765167532220417','1212930279740608514','1410765167532220417',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765167699992577','1213274113339101185','1410765167699992577',2,2,'福建省群策环境检测有限公司','17758709290','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765167909707777','1213345803519725570','1410765167909707777',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765168123617281','1213451329813417985','1410765168123617281',2,2,'晋江市润通汽车销售服务有限责任公司','13665987766','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765168366886913','1214020915189272577','1410765168366886913',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765168547241986','1214025654970896386','1410765168547241986',2,2,'泉州盈众福海汽车销售有限公司','13489858089','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765168752762881','1214041673798012930','1410765168752762881',2,2,'福建省全杰生物科技有限公司','19905050771','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765168933117954','1214079030446280705','1410765168933117954',2,2,'摩尔工业设计（晋江）有限公司','18106990767','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765169130250242','1214097817526620161','1410765169130250242',2,2,'福建恒安集团有限公司','13960315655','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765169335771138','1214123943149981698','1410765169335771138',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765169503543298','1214796116982325250','1410765169503543298',2,2,'福建盼福食品有限公司','13600737691','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765169671315458','1214802166888357889','1410765169671315458',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765169851670530','1215532466647908353','1410765169851670530',2,2,'泉州晨鑫自动化科技有限公司','13489387611','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765170036219905','1216626668072869889','1410765170036219905',2,2,'晋江市融媒体中心','13505079029','4,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:01',NULL,NULL,NULL,'2021-07-02 09:00:01',NULL,NULL,NULL),('1410765170300461057','1217041144660119553','1410765170300461057',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765170485010433','1218097536540147714','1410765170485010433',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765170669559810','1219147136575332354','1410765170669559810',2,2,'泉州众骋汽车有限公司','18159581122','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765170891857922','1219241646047223809','1410765170891857922',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765171114156034','1219451161745080321','1410765171114156034',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765171311288322','1219530010977681410','1410765171311288322',2,2,'福州博厚教育有限公司泉州分公司','18659822322','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765171487449090','1245615593177055233','1410765171487449090',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765171663609858','1274912838720167938','1410765171663609858',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765171839770626','1275235140389355521','1410765171839770626',2,2,'元丰(泉州)纺织有限公司','13600753747','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765172011737090','1275343906086633473','1410765172011737090',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765172238229506','1277434198482796545','1410765172238229506',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765172464721922','1286499346338045953','1410765172464721922',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765172678631425','1290207451647430657','1410765172678631425',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765172854792193','1291608243923095553','1410765172854792193',2,2,'福建意乐焙宝生物科技有限公司','15559079841','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765173072896001','1316201027820630017','1410765173072896001',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765173303582722','1331802046063443969','1410765173303582722',2,2,'福建省希领服饰有限责任公司','13573266846','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765173471354881','1338784953806094337','1410765173471354881',2,2,'福建盼盼投资有限公司','18750503035','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765173739790337','1357603793218347009','1410765173739790337',2,2,'泉州市丰裕泰企业管理有限公司','13055679900','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410765173911756801','1374975706999595010','1410765173911756801',2,2,'向维智联(福建)科技有限公司','13799238690','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 09:00:02',NULL,NULL,NULL,'2021-07-02 09:00:02',NULL,NULL,NULL),('1410842676210737153',NULL,'1410842676210737153',2,1,NULL,'15059066119','943434','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-02 14:08:00',NULL,NULL,NULL,'2021-07-02 14:08:00',NULL,NULL,NULL),('1410864003621625857','1409682434043191297','1410864003621625857',2,2,'晋江市农业农村局','15880993753','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-02 15:32:45',NULL,NULL,NULL,'2021-07-02 15:32:45',NULL,NULL,NULL),('1410864442786226177','1407508110968397826','1410864442786226177',2,2,'福建顺成面业发展股份有限公司','18065338355','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-02 15:34:30',NULL,NULL,NULL,'2021-07-02 15:34:30',NULL,NULL,NULL),('1410867887790399490',NULL,'1410867887790399490',2,1,NULL,'18650130807','926103','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-02 15:48:11',NULL,NULL,NULL,'2021-07-02 15:48:11',NULL,NULL,NULL),('1410985680737181697',NULL,'1410985680737181697',2,1,NULL,'15259518859','686518','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-02 23:36:15',NULL,NULL,NULL,'2021-07-02 23:36:15',NULL,NULL,NULL),('1411591718964338689',NULL,'1411591718964338689',2,1,NULL,'15059066119','235845','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-04 15:44:26',NULL,NULL,NULL,'2021-07-04 15:44:26',NULL,NULL,NULL),('1411852325936472066','1211490446086291458','1411852325936472066',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852325978415106','1211442194934710274','1411852325978415106',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326087467009','1211120827064496130','1411852326087467009',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326443982850','58','1411852326443982850',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326452371458','72','1411852326452371458',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326515286018','1211554636561956866','1411852326515286018',2,2,'泉州华祥纸业有限公司','13860748042','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326553034753','1211150098789150721','1411852326553034753',2,2,'泉州永实工程质量检测有限公司','15759559009','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326599172097','70','1411852326599172097',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326607560705','1211453814360555522','1411852326607560705',2,2,'伟志股份公司','15859813817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326729195522','87','1411852326729195522',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326741778433','58','1411852326741778433',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326800498689','1212685717864517633','1411852326800498689',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326901161985','1211461407799820290','1411852326901161985',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326985048066','1211167966465470465','1411852326985048066',2,2,'晋江易库物联网科技有限公司','18959210622','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327064739842','87','1411852327064739842',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327064739843','102','1411852327064739843',1,2,'颜思思','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327102488577','1216559724997144578','1411852327102488577',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327131848705','1211473406755651586','1411852327131848705',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327224123394','1211456215943528450','1411852327224123394',2,2,'福建泉成机械有限公司','15392286115','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327324786690','102','1411852327324786690',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327362535426','1211474926804975617','1411852327362535426',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327429644289','1211529007779069954','1411852327429644289',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327551279105','1211837849989595138','1411852327551279105',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327660331010','1211548619757371393','1411852327660331010',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327744217090','1212535414099873794','1411852327744217090',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327849074689','1211554636561956866','1411852327849074689',2,2,'泉州华祥纸业有限公司','13860748042','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852327916183554','1216568840104734722','1411852327916183554',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328046206977','1211559758373371905','1411852328046206977',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328092344321','1241252588561698817','1411852328092344321',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328255922177','1211609839420096513','1411852328255922177',2,2,'福建省晋江产业发展投资集团有限公司','13599789599','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328289476610','1290850604855361537','1411852328289476610',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328444665858','1211837849989595138','1411852328444665858',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328494997505','1295900371603947522','1411852328494997505',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328658575361','1211925547903401986','1411852328658575361',2,2,'泉州市泽西生物科技有限公司','17359269810','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328675352577','1348924009986654209','1411852328675352577',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328901844993','1351830895278948354','1411852328901844993',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852328914427905','1211931259509456897','1411852328914427905',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852329103171586','1374554432229978113','1411852329103171586',2,2,'福建省晋华集成电路有限公司','15059820805','215,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852329107365890','1212253296765505538','1411852329107365890',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852329279332353','1376712565047975937','1411852329279332353',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852329296109569','1212692778300018689','1411852329296109569',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852329468076034','1213345803519725570','1411852329468076034',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852329480658946','1394875586618372097','1411852329480658946',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:00',NULL,NULL,NULL,'2021-07-05 09:00:00',NULL,NULL,NULL),('1411852329681985537','1213376299297476609','1411852329681985537',2,2,'福建省海峡建设发展有限公司','15805967556','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852329908477954','1214020915189272577','1411852329908477954',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852330118193153','1214041673798012930','1411852330118193153',2,2,'福建省全杰生物科技有限公司','19905050771','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852330336296962','1214097817526620161','1411852330336296962',2,2,'福建恒安集团有限公司','13960315655','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852330575372290','1214123943149981698','1411852330575372290',2,2,'福建帝霖食品有限公司','13960256299','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852330793476098','1214142410787934209','1411852330793476098',2,2,'晋江清源津工环保科技有限公司','13328567990','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852331074494466','1214802166888357889','1411852331074494466',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852331284209666','1215532466647908353','1411852331284209666',2,2,'泉州晨鑫自动化科技有限公司','13489387611','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852331493924866','1215542604263899137','1411852331493924866',2,2,'福建美溪通信科技股份有限公司','15906066156','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852331787526145','1217041144660119553','1411852331787526145',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852332034990081','1217348495564886017','1411852332034990081',2,2,'晋江劲霸男装有限公司','13505959911','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852332265676802','1218097536540147714','1411852332265676802',2,2,'福建浔兴拉链科技股份有限公司','13799855086','3,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852332504752129','1219140374220627970','1411852332504752129',2,2,'福建亲亲股份有限公司','15960735252','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852332689301506','1219241646047223809','1411852332689301506',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852332932571137','1219451161745080321','1411852332932571137',2,2,'泉州福林汽车销售服务有限公司','13675966551','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852333196812290','1245615593177055233','1411852333196812290',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852333410721793','1274912838720167938','1411852333410721793',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852333603659777','1275235140389355521','1411852333603659777',2,2,'元丰(泉州)纺织有限公司','13600753747','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852333821763586','1275343906086633473','1411852333821763586',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:01',NULL,NULL,NULL,'2021-07-05 09:00:01',NULL,NULL,NULL),('1411852334035673089','1277434198482796545','1411852334035673089',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:02',NULL,NULL,NULL,'2021-07-05 09:00:02',NULL,NULL,NULL),('1411852334400577538','1277910183363776514','1411852334400577538',2,2,'泉州市顺时针电子商务有限公司','15985992783','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:02',NULL,NULL,NULL,'2021-07-05 09:00:02',NULL,NULL,NULL),('1411852334606098434','1286499346338045953','1411852334606098434',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:02',NULL,NULL,NULL,'2021-07-05 09:00:02',NULL,NULL,NULL),('1411852334828396545','1290207451647430657','1411852334828396545',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:02',NULL,NULL,NULL,'2021-07-05 09:00:02',NULL,NULL,NULL),('1411852335017140226','1316201027820630017','1411852335017140226',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:02',NULL,NULL,NULL,'2021-07-05 09:00:02',NULL,NULL,NULL),('1411852335277187073','1374909187762532354','1411852335277187073',2,2,'福建锦科新材料有限责任公司','15959999006','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-05 09:00:02',NULL,NULL,NULL,'2021-07-05 09:00:02',NULL,NULL,NULL),('1411872099303202818','1216609110485639170','1411872099303202818',2,2,'泉州时空文化传媒有限公司','13905985153','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-05 10:18:34',NULL,NULL,NULL,'2021-07-05 10:18:34',NULL,NULL,NULL),('1411961833929089025',NULL,'1411961833929089025',2,1,NULL,'15059066119','926887','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-05 16:15:08',NULL,NULL,NULL,'2021-07-05 16:15:08',NULL,NULL,NULL),('1411987912274255874',NULL,'1411987912274255874',2,1,NULL,'18659019688','303187','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-05 17:58:46',NULL,NULL,NULL,'2021-07-05 17:58:46',NULL,NULL,NULL),('1412037859329744898',NULL,'1412037859329744898',2,1,NULL,'18659019688','898857','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-05 21:17:14',NULL,NULL,NULL,'2021-07-05 21:17:14',NULL,NULL,NULL),('1412214713772711937','1211442194934710274','1412214713772711937',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214713776906241','1211490446086291458','1412214713776906241',2,2,'泉州职业技术大学','18060007601','6,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214713802072065','1211120827064496130','1412214713802072065',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214713806266370','1211100599215566849','1412214713806266370',2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214713814654978','1211490446086291458','1412214713814654978',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714070507522','58','1412214714070507522',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714183753729','70','1412214714183753729',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714183753730','72','1412214714183753730',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714485743618','58','1412214714485743618',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714485743619','1211461407799820290','1412214714485743619',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714485743620','87','1412214714485743620',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714489937921','1211529007779069954','1412214714489937921',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714494132225','1212685717864517633','1412214714494132225',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714498326530','1211482027447074818','1412214714498326530',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714657710082','102','1412214714657710082',1,2,'颜思思','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714695458818','1211473406755651586','1412214714695458818',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714699653121','87','1412214714699653121',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714703847425','1211837849989595138','1412214714703847425',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714812899329','1216559724997144578','1412214714812899329',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715031003138','102','1412214715031003138',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715106500610','1211931259509456897','1412214715106500610',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715119083522','1211474926804975617','1412214715119083522',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715454627841','1211837849989595138','1412214715454627841',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715525931009','1212253296765505538','1412214715525931009',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715664343042','1212535414099873794','1412214715664343042',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715718868993','1212692778300018689','1412214715718868993',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715903418369','1216568840104734722','1412214715903418369',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214715957944321','1213345803519725570','1412214715957944321',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716104744962','1290850604855361537','1412214716104744962',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716159270914','1214802166888357889','1412214716159270914',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716318654465','1295900371603947522','1412214716318654465',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716318654466','1219451161745080321','1412214716318654466',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716536758274','1245615593177055233','1412214716536758274',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716545146882','1348924009986654209','1412214716545146882',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716712919041','1274912838720167938','1412214716712919041',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716784222209','1351830895278948354','1412214716784222209',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214716935217154','1275343906086633473','1412214716935217154',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214717014908930','1374554432229978113','1412214717014908930',2,2,'福建省晋华集成电路有限公司','15059820805','215,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214717094600706','1277434198482796545','1412214717094600706',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214717325287426','1376712565047975937','1412214717325287426',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214717337870337','1286499346338045953','1412214717337870337',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214717493059586','1394875586618372097','1412214717493059586',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214717509836802','1290207451647430657','1412214717509836802',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:00',NULL,NULL,NULL,'2021-07-06 09:00:00',NULL,NULL,NULL),('1412214717681803266','1316201027820630017','1412214717681803266',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-06 09:00:01',NULL,NULL,NULL,'2021-07-06 09:00:01',NULL,NULL,NULL),('1412244063435923457',NULL,'1412244063435923457',2,1,NULL,'15260399516','288086','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-06 10:56:37',NULL,NULL,NULL,'2021-07-06 10:56:37',NULL,NULL,NULL),('1412244321096212482',NULL,'1412244321096212482',2,1,NULL,'15260399516','608926','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-06 10:57:39',NULL,NULL,NULL,'2021-07-06 10:57:39',NULL,NULL,NULL),('1412248340355129346',NULL,'1412248340355129346',2,1,NULL,'15259759208','547178','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-06 11:13:37',NULL,NULL,NULL,'2021-07-06 11:13:37',NULL,NULL,NULL),('1412248814617665538',NULL,'1412248814617665538',2,1,NULL,'15259759208','227864','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-06 11:15:30',NULL,NULL,NULL,'2021-07-06 11:15:30',NULL,NULL,NULL),('1412249128443879425',NULL,'1412249128443879425',2,1,NULL,'18150501022','275417','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-06 11:16:45',NULL,NULL,NULL,'2021-07-06 11:16:45',NULL,NULL,NULL),('1412258547604955137','1412249192901943298','1412258547604955137',2,2,'福建省财徳电子商务有限公司','18150501022','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-06 11:54:10',NULL,NULL,NULL,'2021-07-06 11:54:10',NULL,NULL,NULL),('1412329578193526785',NULL,'1412329578193526785',2,1,NULL,'15160779696','109099','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-06 16:36:25',NULL,NULL,NULL,'2021-07-06 16:36:25',NULL,NULL,NULL),('1412341196356886530',NULL,'1412341196356886530',2,1,NULL,'15059066119','490095','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-06 17:22:35',NULL,NULL,NULL,'2021-07-06 17:22:35',NULL,NULL,NULL),('1412553703407263745',NULL,'1412553703407263745',2,1,NULL,'15260399516','241880','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-07 07:27:01',NULL,NULL,NULL,'2021-07-07 07:27:01',NULL,NULL,NULL),('1412577101587980289','1211120827064496130','1412577101587980289',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101634117633','1211461407799820290','1412577101634117633',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101659283458','1211100599215566849','1412577101659283458',2,2,'劲派经编科技有限公司','15859799211','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101697032193','1211490446086291458','1412577101697032193',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101697032194','1211490446086291458','1412577101697032194',2,2,'泉州职业技术大学','18060007601','6,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101906747393','58','1412577101906747393',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101915136001','72','1412577101915136001',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101969661954','70','1412577101969661954',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102024187905','1211482027447074818','1412577102024187905',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102028382210','1211473406755651586','1412577102028382210',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102070325249','1211529007779069954','1412577102070325249',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102124851201','1212685717864517633','1412577102124851201',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102204542977','87','1412577102204542977',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102204542978','58','1412577102204542978',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102301011970','1211837849989595138','1412577102301011970',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102301011971','1211474926804975617','1412577102301011971',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102359732225','1216559724997144578','1412577102359732225',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102418452481','102','1412577102418452481',1,2,'颜思思','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102431035393','87','1412577102431035393',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102456201218','1211837849989595138','1412577102456201218',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102477172737','1211931259509456897','1412577102477172737',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102598807553','102','1412577102598807553',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102632361986','1216568840104734722','1412577102632361986',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102636556289','1212253296765505538','1412577102636556289',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102871437314','1212692778300018689','1412577102871437314',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577102871437315','1295900371603947522','1412577102871437315',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103261507586','1348924009986654209','1412577103261507586',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103265701890','1213345803519725570','1412577103265701890',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103454445570','1351830895278948354','1412577103454445570',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103458639874','1214802166888357889','1412577103458639874',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103685132290','1374554432229978113','1412577103685132290',2,2,'福建省晋华集成电路有限公司','15059820805','159,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103689326594','1219451161745080321','1412577103689326594',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103903236098','1245615593177055233','1412577103903236098',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577103920013313','1376712565047975937','1412577103920013313',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577104112951298','1274912838720167938','1412577104112951298',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577104112951299','1394875586618372097','1412577104112951299',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577104456884226','1275343906086633473','1412577104456884226',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577104645627906','1277434198482796545','1412577104645627906',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577104830177281','1286499346338045953','1412577104830177281',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577105052475393','1290207451647430657','1412577105052475393',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412577105228636161','1316201027820630017','1412577105228636161',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-07 09:00:00',NULL,NULL,NULL,'2021-07-07 09:00:00',NULL,NULL,NULL),('1412595002525130754',NULL,'1412595002525130754',2,1,NULL,'13365978588','277109','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-07 10:11:08',NULL,NULL,NULL,'2021-07-07 10:11:08',NULL,NULL,NULL),('1412644402882453505',NULL,'1412644402882453505',2,1,NULL,'15005930663','660736','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-07 13:27:25',NULL,NULL,NULL,'2021-07-07 13:27:25',NULL,NULL,NULL),('1412666779670454274',NULL,'1412666779670454274',2,1,NULL,'15005930663','317482','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-07 14:56:21',NULL,NULL,NULL,'2021-07-07 14:56:21',NULL,NULL,NULL),('1412939489503911938','1211461407799820290','1412939489503911938',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489554243586','1212685717864517633','1412939489554243586',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489558437889','1211120827064496130','1412939489558437889',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489562632194','1211482027447074818','1412939489562632194',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489914953729','58','1412939489914953729',1,2,'张荣荣','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489986256898','72','1412939489986256898',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490011422721','70','1412939490011422721',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490099503106','1211529007779069954','1412939490099503106',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490099503107','1211473406755651586','1412939490099503107',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490145640450','1216559724997144578','1412939490145640450',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490229526530','87','1412939490229526530',1,2,'叶志钦','13675957398','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490309218306','58','1412939490309218306',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490367938562','1211837849989595138','1412939490367938562',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490388910082','1211474926804975617','1412939490388910082',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490426658818','102','1412939490426658818',1,2,'颜思思','15280619456','7,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490485379073','87','1412939490485379073',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490556682241','1211931259509456897','1412939490556682241',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490560876545','1211837849989595138','1412939490560876545',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490699288578','102','1412939490699288578',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490724454401','1212253296765505538','1412939490724454401',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490724454402','1216568840104734722','1412939490724454402',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490971918338','1212692778300018689','1412939490971918338',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939490971918339','1295900371603947522','1412939490971918339',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939491169050625','1213345803519725570','1412939491169050625',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939491181633537','1348924009986654209','1412939491181633537',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939491341017090','1214802166888357889','1412939491341017090',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939491395543042','1351830895278948354','1412939491395543042',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939491638812673','1219451161745080321','1412939491638812673',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939491756253186','1374554432229978113','1412939491756253186',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939491835944961','1245615593177055233','1412939491835944961',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939492003717121','1376712565047975937','1412939492003717121',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939492007911425','1274912838720167938','1412939492007911425',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939492226015233','1394875586618372097','1412939492226015233',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939492234403842','1275343906086633473','1412939492234403842',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939492418953217','1277434198482796545','1412939492418953217',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939492595113985','1286499346338045953','1412939492595113985',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939492842577922','1290207451647430657','1412939492842577922',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412939493043904514','1316201027820630017','1412939493043904514',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-08 09:00:00',NULL,NULL,NULL,'2021-07-08 09:00:00',NULL,NULL,NULL),('1412954489391980546',NULL,'1412954489391980546',2,1,NULL,'15160033075','189066','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-08 09:59:36',NULL,NULL,NULL,'2021-07-08 09:59:36',NULL,NULL,NULL),('1413059278083760129',NULL,'1413059278083760129',2,1,NULL,'15905907962','604669','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-08 16:55:59',NULL,NULL,NULL,'2021-07-08 16:55:59',NULL,NULL,NULL),('1413085922022432770',NULL,'1413085922022432770',2,1,NULL,'18960248562','192067','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-08 18:41:52',NULL,NULL,NULL,'2021-07-08 18:41:52',NULL,NULL,NULL),('1413301877256265730','1211120827064496130','1413301877256265730',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877298208770','1212685717864517633','1413301877298208770',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877310791681','1211482027447074818','1413301877310791681',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877340151810','1211461407799820290','1413301877340151810',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877696667649','72','1413301877696667649',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877717639169','72','1413301877717639169',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877717639170','70','1413301877717639170',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877952520194','1216559724997144578','1413301877952520194',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877965103106','1211473406755651586','1413301877965103106',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877965103107','1211529007779069954','1413301877965103107',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877965103108','58','1413301877965103108',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877981880322','58','1413301877981880322',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878199984130','1211837849989595138','1413301878199984130',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878199984131','1211474926804975617','1413301878199984131',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878199984132','87','1413301878199984132',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878241927169','87','1413301878241927169',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878388727809','1211931259509456897','1413301878388727809',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878409699330','1211837849989595138','1413301878409699330',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878413893634','102','1413301878413893634',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878476808193','102','1413301878476808193',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878606831618','1212253296765505538','1413301878606831618',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878619414530','1216568840104734722','1413301878619414530',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878787186690','1212692778300018689','1413301878787186690',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878879461377','1295900371603947522','1413301878879461377',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301878967541762','1213345803519725570','1413301878967541762',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879093370881','1348924009986654209','1413301879093370881',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879185645569','1214802166888357889','1413301879185645569',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879265337346','1351830895278948354','1413301879265337346',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879399555073','1219451161745080321','1413301879399555073',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879458275329','1374554432229978113','1413301879458275329',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879634436097','1245615593177055233','1413301879634436097',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879634436098','1376712565047975937','1413301879634436098',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879835762689','1394875586618372097','1413301879835762689',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301879949008897','1274912838720167938','1413301879949008897',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301880171307010','1275343906086633473','1413301880171307010',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301880410382337','1277434198482796545','1413301880410382337',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301880662040578','1286499346338045953','1413301880662040578',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301880859172866','1290207451647430657','1413301880859172866',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413301881127608322','1316201027820630017','1413301881127608322',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-09 09:00:00',NULL,NULL,NULL,'2021-07-09 09:00:00',NULL,NULL,NULL),('1413333849143812097',NULL,'1413333849143812097',2,1,NULL,'13276083102','442455','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-09 11:07:02',NULL,NULL,NULL,'2021-07-09 11:07:02',NULL,NULL,NULL),('1413335385324429313',NULL,'1413335385324429313',2,1,NULL,'13276083102','367089','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-09 11:13:09',NULL,NULL,NULL,'2021-07-09 11:13:09',NULL,NULL,NULL),('1413346322932604929',NULL,'1413346322932604929',2,1,NULL,'15080429951','392615','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-09 11:56:36',NULL,NULL,NULL,'2021-07-09 11:56:36',NULL,NULL,NULL),('1413378620629491713',NULL,'1413378620629491713',2,1,NULL,'13522580611','293069','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-09 14:04:57',NULL,NULL,NULL,'2021-07-09 14:04:57',NULL,NULL,NULL),('1413379331861815297',NULL,'1413379331861815297',2,1,NULL,'13522580611','210582','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-09 14:07:46',NULL,NULL,NULL,'2021-07-09 14:07:46',NULL,NULL,NULL),('1413379871836512258',NULL,'1413379871836512258',2,1,NULL,'13522580611','591709','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-09 14:09:55',NULL,NULL,NULL,'2021-07-09 14:09:55',NULL,NULL,NULL),('1413381275271602177',NULL,'1413381275271602177',2,1,NULL,'13522580611','307353','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-09 14:15:30',NULL,NULL,NULL,'2021-07-09 14:15:30',NULL,NULL,NULL),('1413763419240177665',NULL,'1413763419240177665',2,1,NULL,'15906059470','797019','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-10 15:34:00',NULL,NULL,NULL,'2021-07-10 15:34:00',NULL,NULL,NULL),('1413859237737570305',NULL,'1413859237737570305',2,1,NULL,'18965678168','590046','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-10 21:54:45',NULL,NULL,NULL,'2021-07-10 21:54:45',NULL,NULL,NULL),('1414169665923489794',NULL,'1414169665923489794',2,1,NULL,'15880884973','357232','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-11 18:28:17',NULL,NULL,NULL,'2021-07-11 18:28:17',NULL,NULL,NULL),('1414246423343439873',NULL,'1414246423343439873',2,1,NULL,'18650756886','551333','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-11 23:33:17',NULL,NULL,NULL,'2021-07-11 23:33:17',NULL,NULL,NULL),('1414389040915980290','1211482027447074818','1414389040915980290',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389040945340417','1211461407799820290','1414389040945340417',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389040957923329','1212685717864517633','1414389040957923329',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389040995672066','1211120827064496130','1414389040995672066',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041423491073','72','1414389041423491073',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041431879681','72','1414389041431879681',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041440268290','70','1414389041440268290',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041452851202','1211473406755651586','1414389041452851202',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041452851203','1211529007779069954','1414389041452851203',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041469628417','1216559724997144578','1414389041469628417',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041616429057','58','1414389041616429057',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041624817666','58','1414389041624817666',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041679343618','1211474926804975617','1414389041679343618',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041788395522','1211837849989595138','1414389041788395522',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041792589826','87','1414389041792589826',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041800978433','87','1414389041800978433',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041855504386','1211837849989595138','1414389041855504386',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041956167681','102','1414389041956167681',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041977139201','102','1414389041977139201',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041981333505','1211931259509456897','1414389041981333505',2,2,'泉州市数坊信息科技有限公司','13506042338','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042031665154','1216568840104734722','1414389042031665154',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042165882882','1212253296765505538','1414389042165882882',2,2,'泉州寰球鞋服有限公司','18959708869','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042195243010','1295900371603947522','1414389042195243010',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042333655042','1212692778300018689','1414389042333655042',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042363015169','1348924009986654209','1414389042363015169',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042497232897','1213345803519725570','1414389042497232897',2,2,'晋江元素设计有限公司','13030981560','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042648227842','1351830895278948354','1414389042648227842',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042681782273','1214802166888357889','1414389042681782273',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042841165825','1374554432229978113','1414389042841165825',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389042845360130','1219451161745080321','1414389042845360130',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389043017326593','1245615593177055233','1414389043017326593',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389043034103809','1376712565047975937','1414389043034103809',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389043306733570','1274912838720167938','1414389043306733570',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389043310927873','1394875586618372097','1414389043310927873',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389043482894337','1275343906086633473','1414389043482894337',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389043742941186','1277434198482796545','1414389043742941186',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389043990405122','1286499346338045953','1414389043990405122',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389044204314625','1290207451647430657','1414389044204314625',2,2,'晋江国盛新材料科技有限公司','13860736349','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414389044422418434','1316201027820630017','1414389044422418434',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-12 09:00:00',NULL,NULL,NULL,'2021-07-12 09:00:00',NULL,NULL,NULL),('1414467553425661953',NULL,'1414467553425661953',2,1,NULL,'18084764083','312759','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-12 14:11:58',NULL,NULL,NULL,'2021-07-12 14:11:58',NULL,NULL,NULL),('1414480877299212289',NULL,'1414480877299212289',2,1,NULL,'18559583906','091595','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-12 15:04:55',NULL,NULL,NULL,'2021-07-12 15:04:55',NULL,NULL,NULL),('1414512527936626690',NULL,'1414512527936626690',2,1,NULL,'13489719977','254186','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-12 17:10:41',NULL,NULL,NULL,'2021-07-12 17:10:41',NULL,NULL,NULL),('1414751428810940418','1212685717864517633','1414751428810940418',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751428827717634','1211482027447074818','1414751428827717634',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751428882243586','1211461407799820290','1414751428882243586',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751428949352450','1211120827064496130','1414751428949352450',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429112930305','72','1414751429112930305',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429133901826','72','1414751429133901826',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429385560065','70','1414751429385560065',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429708521474','58','1414751429708521474',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429708521475','1211473406755651586','1414751429708521475',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429708521476','1216559724997144578','1414751429708521476',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429712715777','58','1414751429712715777',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429721104385','1211529007779069954','1414751429721104385',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429939208194','1211474926804975617','1414751429939208194',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429968568321','87','1414751429968568321',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429976956930','87','1414751429976956930',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429976956931','1211837849989595138','1414751429976956931',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430140534786','1211490446086291458','1414751430140534786',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430299918338','102','1414751430299918338',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430320889857','102','1414751430320889857',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430333472769','1212692778300018689','1414751430333472769',2,2,'晋江市路桥建设开发有限公司','17350011170','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430392193025','1211837849989595138','1414751430392193025',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430614491138','1214020915189272577','1414751430614491138',2,2,'泉州国科文化有限公司','18259591998','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430723543042','1214451511434743809','1414751430723543042',2,2,'福建北电新材料科技有限公司','19959711592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430857760769','1214097817526620161','1414751430857760769',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751430924869634','1216568840104734722','1414751430924869634',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431101030401','1295900371603947522','1414751431101030401',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431105224706','1214802166888357889','1414751431105224706',2,2,'福建省晋江人力资本有限公司','13636905051','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431335911425','1217041144660119553','1414751431335911425',2,2,'晋江市天泽农业开发有限公司','18859781366','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431344300034','1348924009986654209','1414751431344300034',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431533043713','1218097536540147714','1414751431533043713',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431533043714','1351830895278948354','1414751431533043714',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431755341825','1219140374220627970','1414751431755341825',2,2,'福建亲亲股份有限公司','15960735252','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751431755341826','1374554432229978113','1414751431755341826',2,2,'福建省晋华集成电路有限公司','15059820805','12,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751432032165890','1219241646047223809','1414751432032165890',2,2,'福建晋江农村商业银行股份有限公司','15260663037','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751432032165891','1376712565047975937','1414751432032165891',2,2,'渠梁电子有限公司','18359882323','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751432271241218','1219451161745080321','1414751432271241218',2,2,'泉州福林汽车销售服务有限公司','13675966551','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751432271241219','1392426372634292225','1414751432271241219',2,2,'晋江三伍微电子有限公司','15905909478','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751432464179202','1394875586618372097','1414751432464179202',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751432489345026','1245615593177055233','1414751432489345026',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:00',NULL,NULL,NULL,'2021-07-13 09:00:00',NULL,NULL,NULL),('1414751432795529217','1274912838720167938','1414751432795529217',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:01',NULL,NULL,NULL,'2021-07-13 09:00:01',NULL,NULL,NULL),('1414751433026215938','1275343906086633473','1414751433026215938',2,2,'晋江市安海镇邱明耀雕刻工艺品加工坊','15160326656','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:01',NULL,NULL,NULL,'2021-07-13 09:00:01',NULL,NULL,NULL),('1414751433198182402','1277434198482796545','1414751433198182402',2,2,'晋江爱尔眼科医院有限公司','15959529925','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:01',NULL,NULL,NULL,'2021-07-13 09:00:01',NULL,NULL,NULL),('1414751433374343169','1286499346338045953','1414751433374343169',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:01',NULL,NULL,NULL,'2021-07-13 09:00:01',NULL,NULL,NULL),('1414751433554698241','1316201027820630017','1414751433554698241',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-13 09:00:01',NULL,NULL,NULL,'2021-07-13 09:00:01',NULL,NULL,NULL),('1414788577572716545',NULL,'1414788577572716545',2,1,NULL,'13365978588','215827','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-13 11:27:37',NULL,NULL,NULL,'2021-07-13 11:27:37',NULL,NULL,NULL),('1414802519061725186',NULL,'1414802519061725186',2,1,NULL,'18271695737','542852','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-13 12:23:00',NULL,NULL,NULL,'2021-07-13 12:23:00',NULL,NULL,NULL),('1414813441767538690',NULL,'1414813441767538690',2,1,NULL,'18271695737','611505','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-13 13:06:25',NULL,NULL,NULL,'2021-07-13 13:06:25',NULL,NULL,NULL),('1414837069527678978',NULL,'1414837069527678978',2,1,NULL,'18659919888','050382','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-13 14:40:18',NULL,NULL,NULL,'2021-07-13 14:40:18',NULL,NULL,NULL),('1414837496675598338',NULL,'1414837496675598338',2,1,NULL,'18659919888','096530','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-13 14:42:00',NULL,NULL,NULL,'2021-07-13 14:42:00',NULL,NULL,NULL),('1414874383557623809',NULL,'1414874383557623809',2,1,NULL,'13123130025','229864','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-13 17:08:34',NULL,NULL,NULL,'2021-07-13 17:08:34',NULL,NULL,NULL),('1415113816773001218','1211482027447074818','1415113816773001218',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816802361346','1211461407799820290','1415113816802361346',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816823332866','1211120827064496130','1415113816823332866',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816835915778','1212685717864517633','1415113816835915778',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816835915779','72','1415113816835915779',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817087574018','72','1415113817087574018',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817288900609','58','1415113817288900609',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817293094914','70','1415113817293094914',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817301483522','1216559724997144578','1415113817301483522',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817301483523','1211473406755651586','1415113817301483523',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817322455042','1211529007779069954','1415113817322455042',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817364398082','58','1415113817364398082',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817486032898','87','1415113817486032898',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817536364546','1211474926804975617','1415113817536364546',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817536364547','1211837849989595138','1415113817536364547',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817569918978','87','1415113817569918978',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817662193666','102','1415113817662193666',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817708331009','1214097817526620161','1415113817708331009',2,2,'福建恒安集团有限公司','13960315655','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817720913922','1211490446086291458','1415113817720913922',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817750274049','102','1415113817750274049',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817876103169','1211837849989595138','1415113817876103169',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817884491778','1218097536540147714','1415113817884491778',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818069041153','1219451161745080321','1415113818069041153',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818077429762','1214451511434743809','1415113818077429762',2,2,'福建北电新材料科技有限公司','19959711592','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818236813313','1245615593177055233','1415113818236813313',2,2,'晋江市新迪新材料科技有限公司','13950287905','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818261979138','1216568840104734722','1415113818261979138',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818408779778','1274912838720167938','1415113818408779778',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818446528513','1295900371603947522','1415113818446528513',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818580746241','1286499346338045953','1415113818580746241',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818622689282','1348924009986654209','1415113818622689282',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818803044353','1316201027820630017','1415113818803044353',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818811432962','1351830895278948354','1415113818811432962',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113818983399425','1374554432229978113','1415113818983399425',2,2,'福建省晋华集成电路有限公司','15059820805','11,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113819264417793','1376712565047975937','1415113819264417793',2,2,'渠梁电子有限公司','18359882323','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113819444772865','1392396939873529858','1415113819444772865',2,2,'晋江万芯晨电子科技有限公司','13960937795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415113819616739330','1394875586618372097','1415113819616739330',2,2,'晋江市博感电子科技有限公司','18650478001','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-14 09:00:00',NULL,NULL,NULL,'2021-07-14 09:00:00',NULL,NULL,NULL),('1415125935748841473',NULL,'1415125935748841473',2,1,NULL,'13522580611','641617','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-14 09:48:09',NULL,NULL,NULL,'2021-07-14 09:48:09',NULL,NULL,NULL),('1415149382113722370',NULL,'1415149382113722370',2,1,NULL,'18965531731','294603','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-14 11:21:19',NULL,NULL,NULL,'2021-07-14 11:21:19',NULL,NULL,NULL),('1415192875607556098',NULL,'1415192875607556098',2,1,NULL,'17330182531','948294','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-14 14:14:09',NULL,NULL,NULL,'2021-07-14 14:14:09',NULL,NULL,NULL),('1415223255144366082','1214097817526620161','1415223255144366082',2,2,'福建恒安集团有限公司','13788854137','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-14 16:14:52',NULL,NULL,NULL,'2021-07-14 16:14:52',NULL,NULL,NULL),('1415223338451632130','1212665763958165505','1415223338451632130',2,2,'泉州安踏鞋材有限公司','15960586807','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-14 16:15:12',NULL,NULL,NULL,'2021-07-14 16:15:12',NULL,NULL,NULL),('1415476204584075266','1211120827064496130','1415476204584075266',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204592463873','1211461407799820290','1415476204592463873',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204630212609','1212685717864517633','1415476204630212609',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204655378434','1211482027447074818','1415476204655378434',2,2,'福建晋江天然气发电有限公司','18876509838','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204990922754','72','1415476204990922754',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204999311361','72','1415476204999311361',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205003505665','70','1415476205003505665',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205326467073','58','1415476205326467073',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205326467074','58','1415476205326467074',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205330661378','1211529007779069954','1415476205330661378',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205343244289','1216559724997144578','1415476205343244289',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205343244290','1211473406755651586','1415476205343244290',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205515210753','87','1415476205515210753',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205515210754','87','1415476205515210754',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205536182273','1211837849989595138','1415476205536182273',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205615874050','1211474926804975617','1415476205615874050',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205712343042','102','1415476205712343042',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205712343043','102','1415476205712343043',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205758480386','1219451161745080321','1415476205758480386',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205817200642','1211837849989595138','1415476205817200642',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205934641153','1274912838720167938','1415476205934641153',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476205984972802','1216568840104734722','1415476205984972802',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476206094024706','1286499346338045953','1415476206094024706',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476206144356353','1295900371603947522','1415476206144356353',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476206265991169','1316201027820630017','1415476206265991169',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476206316322817','1348924009986654209','1415476206316322817',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415476206513455106','1351830895278948354','1415476206513455106',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-15 09:00:00',NULL,NULL,NULL,'2021-07-15 09:00:00',NULL,NULL,NULL),('1415572907349803009',NULL,'1415572907349803009',2,1,NULL,'18960679210','557314','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-15 15:24:15',NULL,NULL,NULL,'2021-07-15 15:24:15',NULL,NULL,NULL),('1415574534005751810',NULL,'1415574534005751810',2,1,NULL,'18859945269','358554','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-15 15:30:43',NULL,NULL,NULL,'2021-07-15 15:30:43',NULL,NULL,NULL),('1415609798191251458',NULL,'1415609798191251458',2,1,NULL,'18059998188','124035','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-15 17:50:51',NULL,NULL,NULL,'2021-07-15 17:50:51',NULL,NULL,NULL),('1415617926400081922','1211473627321516033','1415617926400081922',2,2,'福建省晋江新佳园控股有限公司','13255006151','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-15 18:23:09',NULL,NULL,NULL,'2021-07-15 18:23:09',NULL,NULL,NULL),('1415618315660853250','1216609110485639170','1415618315660853250',2,2,'泉州时空文化传媒有限公司','15587032545','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-15 18:24:42',NULL,NULL,NULL,'2021-07-15 18:24:42',NULL,NULL,NULL),('1415832134853099521',NULL,'1415832134853099521',2,1,NULL,'18905957685','110475','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-16 08:34:20',NULL,NULL,NULL,'2021-07-16 08:34:20',NULL,NULL,NULL),('1415838592407732225','1211461407799820290','1415838592407732225',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592411926530','1212685717864517633','1415838592411926530',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592487424002','1211120827064496130','1415838592487424002',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592684556290','58','1415838592684556290',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592713916418','72','1415838592713916418',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592764248066','70','1415838592764248066',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592835551233','1211473406755651586','1415838592835551233',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592869105666','1216559724997144578','1415838592869105666',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592894271490','1211529007779069954','1415838592894271490',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592969768961','87','1415838592969768961',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592986546178','58','1415838592986546178',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593024294913','1211474926804975617','1415838593024294913',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593087209474','1211837849989595138','1415838593087209474',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593242398721','87','1415838593242398721',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593254981633','102','1415838593254981633',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593267564545','1211837849989595138','1415838593267564545',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593313701889','1219451161745080321','1415838593313701889',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593569554433','1216568840104734722','1415838593569554433',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593569554434','102','1415838593569554434',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593573748738','1274912838720167938','1415838593573748738',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593770881025','1286499346338045953','1415838593770881025',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838593854767105','1295900371603947522','1415838593854767105',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838594295169026','1316201027820630017','1415838594295169026',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838594446163970','1348924009986654209','1415838594446163970',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415838594660073473','1351830895278948354','1415838594660073473',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-16 09:00:00',NULL,NULL,NULL,'2021-07-16 09:00:00',NULL,NULL,NULL),('1415855326053302274',NULL,'1415855326053302274',2,1,NULL,'15906079555','915266','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-16 10:06:29',NULL,NULL,NULL,'2021-07-16 10:06:29',NULL,NULL,NULL),('1415912776278245377',NULL,'1415912776278245377',2,1,NULL,'18750509997','835409','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-16 13:54:46',NULL,NULL,NULL,'2021-07-16 13:54:46',NULL,NULL,NULL),('1415949296477437954',NULL,'1415949296477437954',2,1,NULL,'18250449411','582919','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-16 16:19:54',NULL,NULL,NULL,'2021-07-16 16:19:54',NULL,NULL,NULL),('1416333716455718914',NULL,'1416333716455718914',2,1,NULL,'18659592008','898028','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-17 17:47:26',NULL,NULL,NULL,'2021-07-17 17:47:26',NULL,NULL,NULL),('1416370761161015297',NULL,'1416370761161015297',2,1,NULL,'13255009792','674590','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-17 20:14:39',NULL,NULL,NULL,'2021-07-17 20:14:39',NULL,NULL,NULL),('1416925756113584130','1212685717864517633','1416925756113584130',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756142944258','1211120827064496130','1416925756142944258',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756151332865','1211461407799820290','1416925756151332865',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756491071489','58','1416925756491071489',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756549791746','72','1416925756549791746',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756553986050','70','1416925756553986050',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756881141761','1216559724997144578','1416925756881141761',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756889530370','58','1416925756889530370',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756897918977','1211529007779069954','1416925756897918977',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756897918978','1211473406755651586','1416925756897918978',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756960833537','87','1416925756960833537',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757103439873','87','1416925757103439873',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757136994305','1211837849989595138','1416925757136994305',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757136994306','1211474926804975617','1416925757136994306',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757250240514','102','1416925757250240514',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757292183553','102','1416925757292183553',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757426401282','1211837849989595138','1416925757426401282',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757426401283','1219451161745080321','1416925757426401283',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757610950657','1274912838720167938','1416925757610950657',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757615144962','1216568840104734722','1416925757615144962',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757841637378','1286499346338045953','1416925757841637378',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925757841637379','1295900371603947522','1416925757841637379',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925758021992450','1316201027820630017','1416925758021992450',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925758021992451','1348924009986654209','1416925758021992451',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1416925759347392514','1351830895278948354','1416925759347392514',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-19 09:00:00',NULL,NULL,NULL,'2021-07-19 09:00:00',NULL,NULL,NULL),('1417288143773663234','1212685717864517633','1417288143773663234',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288143865937922','1211120827064496130','1417288143865937922',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288143886909442','1211461407799820290','1417288143886909442',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144084041730','58','1417288144084041730',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144113401858','72','1417288144113401858',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144142761986','70','1417288144142761986',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144365060097','1211473406755651586','1417288144365060097',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144373448705','1216559724997144578','1417288144373448705',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144373448706','87','1417288144373448706',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144444751873','1211529007779069954','1417288144444751873',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144490889218','58','1417288144490889218',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144595746818','102','1417288144595746818',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144595746819','1211474926804975617','1417288144595746819',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144713187329','1211837849989595138','1417288144713187329',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144725770242','87','1417288144725770242',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144809656321','1211837849989595138','1417288144809656321',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144927096833','102','1417288144927096833',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144931291138','1219451161745080321','1417288144931291138',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288145010982914','1216568840104734722','1417288145010982914',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288145195532290','1295900371603947522','1417288145195532290',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288145199726594','1274912838720167938','1417288145199726594',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288145375887362','1348924009986654209','1417288145375887362',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288145384275969','1286499346338045953','1417288145384275969',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288145564631041','1351830895278948354','1417288145564631041',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417288145581408257','1316201027820630017','1417288145581408257',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-20 09:00:00',NULL,NULL,NULL,'2021-07-20 09:00:00',NULL,NULL,NULL),('1417307754892132353',NULL,'1417307754892132353',2,1,NULL,'18876215713','381591','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-20 10:17:55',NULL,NULL,NULL,'2021-07-20 10:17:55',NULL,NULL,NULL),('1417359803558166529',NULL,'1417359803558166529',2,1,NULL,'18507031618','205788','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-20 13:44:45',NULL,NULL,NULL,'2021-07-20 13:44:45',NULL,NULL,NULL),('1417388540974628865','1417360746219601921','1417388540974628865',2,2,'福建康芯科技有限公司','18507031618','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-20 15:38:56',NULL,NULL,NULL,'2021-07-20 15:38:56',NULL,NULL,NULL),('1417650531614097409','1212685717864517633','1417650531614097409',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650531618291713','1211442194934710274','1417650531618291713',2,2,'信泰（福建）科技有限公司','15659222652','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650531718955010','1211120827064496130','1417650531718955010',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650531970613249','70','1417650531970613249',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532121608193','72','1417650532121608193',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532121608194','58','1417650532121608194',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532536844289','1211529007779069954','1417650532536844289',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532536844290','87','1417650532536844290',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532536844291','58','1417650532536844291',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532541038593','1211461407799820290','1417650532541038593',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532545232898','1216559724997144578','1417650532545232898',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532549427201','83','1417650532549427201',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532754948097','102','1417650532754948097',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532780113922','87','1417650532780113922',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532784308226','1211473406755651586','1417650532784308226',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532796891138','1211837849989595138','1417650532796891138',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533027577858','1219451161745080321','1417650533027577858',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533056937985','102','1417650533056937985',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533077909506','1211474926804975617','1417650533077909506',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533216321538','1274912838720167938','1417650533216321538',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533262458881','1211490446086291458','1417650533262458881',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533530894338','1286499346338045953','1417650533530894338',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533535088642','1211837849989595138','1417650533535088642',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533719638017','1316201027820630017','1417650533719638017',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533732220930','1216568840104734722','1417650533732220930',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650533908381697','1290850604855361537','1417650533908381697',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650534092931074','1295900371603947522','1417650534092931074',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650534269091841','1348924009986654209','1417650534269091841',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417650534436864002','1351830895278948354','1417650534436864002',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-21 09:00:00',NULL,NULL,NULL,'2021-07-21 09:00:00',NULL,NULL,NULL),('1417659203849322498',NULL,'1417659203849322498',2,1,NULL,'15880241957','909812','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 09:34:27',NULL,NULL,NULL,'2021-07-21 09:34:27',NULL,NULL,NULL),('1417674688565379074',NULL,'1417674688565379074',2,1,NULL,'13774889061','852276','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 10:35:59',NULL,NULL,NULL,'2021-07-21 10:35:59',NULL,NULL,NULL),('1417687411214811137',NULL,'1417687411214811137',2,1,NULL,'17759998967','506567','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 11:26:32',NULL,NULL,NULL,'2021-07-21 11:26:32',NULL,NULL,NULL),('1417723710462263298',NULL,'1417723710462263298',2,1,NULL,'18965688836','484863','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 13:50:47',NULL,NULL,NULL,'2021-07-21 13:50:47',NULL,NULL,NULL),('1417729217797324802',NULL,'1417729217797324802',2,1,NULL,'13959864820','028223','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 14:12:40',NULL,NULL,NULL,'2021-07-21 14:12:40',NULL,NULL,NULL),('1417740525699629058',NULL,'1417740525699629058',2,1,NULL,'13506059007','133375','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 14:57:36',NULL,NULL,NULL,'2021-07-21 14:57:36',NULL,NULL,NULL),('1417741065502359554',NULL,'1417741065502359554',2,1,NULL,'13506059007','721410','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 14:59:45',NULL,NULL,NULL,'2021-07-21 14:59:45',NULL,NULL,NULL),('1417741339323301889',NULL,'1417741339323301889',2,1,NULL,'13506059007','567132','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 15:00:50',NULL,NULL,NULL,'2021-07-21 15:00:50',NULL,NULL,NULL),('1417741767473659905',NULL,'1417741767473659905',2,1,NULL,'15750992059','266051','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 15:02:32',NULL,NULL,NULL,'2021-07-21 15:02:32',NULL,NULL,NULL),('1417744737183498241',NULL,'1417744737183498241',2,1,NULL,'15880999770','925905','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 15:14:20',NULL,NULL,NULL,'2021-07-21 15:14:20',NULL,NULL,NULL),('1417745198359805954',NULL,'1417745198359805954',2,1,NULL,'14759598080','750900','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 15:16:10',NULL,NULL,NULL,'2021-07-21 15:16:10',NULL,NULL,NULL),('1417746288434249729',NULL,'1417746288434249729',2,1,NULL,'15880999770','490163','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 15:20:30',NULL,NULL,NULL,'2021-07-21 15:20:30',NULL,NULL,NULL),('1417751459457433601',NULL,'1417751459457433601',2,1,NULL,'13720868701','385284','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 15:41:03',NULL,NULL,NULL,'2021-07-21 15:41:03',NULL,NULL,NULL),('1417756615712473089',NULL,'1417756615712473089',2,1,NULL,'13850751075','102599','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 16:01:32',NULL,NULL,NULL,'2021-07-21 16:01:32',NULL,NULL,NULL),('1417757343487131649',NULL,'1417757343487131649',2,1,NULL,'13850751075','131119','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 16:04:26',NULL,NULL,NULL,'2021-07-21 16:04:26',NULL,NULL,NULL),('1417760787874742274',NULL,'1417760787874742274',2,1,NULL,'18965531360','210251','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 16:18:07',NULL,NULL,NULL,'2021-07-21 16:18:07',NULL,NULL,NULL),('1417762067607224322',NULL,'1417762067607224322',2,1,NULL,'18817333998','932052','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 16:23:12',NULL,NULL,NULL,'2021-07-21 16:23:12',NULL,NULL,NULL),('1417774311279722497',NULL,'1417774311279722497',2,1,NULL,'17620121381','959439','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 17:11:51',NULL,NULL,NULL,'2021-07-21 17:11:51',NULL,NULL,NULL),('1417782928393404418',NULL,'1417782928393404418',2,1,NULL,'18759918618','108945','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 17:46:05',NULL,NULL,NULL,'2021-07-21 17:46:05',NULL,NULL,NULL),('1417837396896022529',NULL,'1417837396896022529',2,1,NULL,'13960307836','602003','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 21:22:32',NULL,NULL,NULL,'2021-07-21 21:22:32',NULL,NULL,NULL),('1417840027672543233',NULL,'1417840027672543233',2,1,NULL,'15160331115','461553','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-21 21:32:59',NULL,NULL,NULL,'2021-07-21 21:32:59',NULL,NULL,NULL),('1418006471416774658','1417659301589188609','1418006471416774658',2,2,'福建晋润半导体技术有限公司','15880241957','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-22 08:34:22',NULL,NULL,NULL,'2021-07-22 08:34:22',NULL,NULL,NULL),('1418012919576166401','1212685717864517633','1418012919576166401',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919576166402','1211461407799820290','1418012919576166402',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919660052482','1211120827064496130','1418012919660052482',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920029151233','58','1418012920029151233',1,2,'张荣荣','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920045928449','72','1418012920045928449',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920108843009','1211529007779069954','1418012920108843009',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920117231618','1211473406755651586','1418012920117231618',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920117231619','1216559724997144578','1418012920117231619',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920184340481','70','1418012920184340481',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920280809474','87','1418012920280809474',1,2,'叶志钦','13675957398','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920285003777','58','1418012920285003777',1,2,'张荣荣','15280619456','13,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920360501249','1211837849989595138','1418012920360501249',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920448581634','1211474926804975617','1418012920448581634',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920486330369','83','1418012920486330369',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920486330370','87','1418012920486330370',1,2,'叶志钦','13675957398','13,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920490524674','102','1418012920490524674',1,2,'颜思思','15280619456','8,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920574410754','1219451161745080321','1418012920574410754',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920645713922','1211837849989595138','1418012920645713922',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920721211393','102','1418012920721211393',1,2,'颜思思','15280619456','13,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920779931650','1274912838720167938','1418012920779931650',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920842846210','1216568840104734722','1418012920842846210',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920981258242','1286499346338045953','1418012920981258242',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012921027395586','1290850604855361537','1418012921027395586',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012921232916482','1316201027820630017','1418012921232916482',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012921232916483','1295900371603947522','1418012921232916483',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012921425854466','1348924009986654209','1418012921425854466',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418012921610403842','1351830895278948354','1418012921610403842',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-22 09:00:00',NULL,NULL,NULL,'2021-07-22 09:00:00',NULL,NULL,NULL),('1418024268783976450',NULL,'1418024268783976450',2,1,NULL,'15080160279','685953','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 09:45:05',NULL,NULL,NULL,'2021-07-22 09:45:05',NULL,NULL,NULL),('1418042604448153602',NULL,'1418042604448153602',2,1,NULL,'13850751075','996828','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 10:57:57',NULL,NULL,NULL,'2021-07-22 10:57:57',NULL,NULL,NULL),('1418084677029232641',NULL,'1418084677029232641',2,1,NULL,'13559559036','735531','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 13:45:08',NULL,NULL,NULL,'2021-07-22 13:45:08',NULL,NULL,NULL),('1418108371252314114','1417746338413576194','1418108371252314114',2,2,'福建嘉怡塑胶有限公司','15880999770','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-22 15:19:17',NULL,NULL,NULL,'2021-07-22 15:19:17',NULL,NULL,NULL),('1418128170057498626',NULL,'1418128170057498626',2,1,NULL,'13859160726','246548','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 16:37:57',NULL,NULL,NULL,'2021-07-22 16:37:57',NULL,NULL,NULL),('1418170698819469313',NULL,'1418170698819469313',2,1,NULL,'13799887398','556547','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 19:26:57',NULL,NULL,NULL,'2021-07-22 19:26:57',NULL,NULL,NULL),('1418177849935822850',NULL,'1418177849935822850',2,1,NULL,'13599100513','406720','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 19:55:22',NULL,NULL,NULL,'2021-07-22 19:55:22',NULL,NULL,NULL),('1418181007785361409',NULL,'1418181007785361409',2,1,NULL,'13599100513','487043','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 20:07:55',NULL,NULL,NULL,'2021-07-22 20:07:55',NULL,NULL,NULL),('1418189869385023489',NULL,'1418189869385023489',2,1,NULL,'13159097691','033447','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-22 20:43:08',NULL,NULL,NULL,'2021-07-22 20:43:08',NULL,NULL,NULL),('1418362326419013634',NULL,'1418362326419013634',2,1,NULL,'18606063165','492015','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-23 08:08:25',NULL,NULL,NULL,'2021-07-23 08:08:25',NULL,NULL,NULL),('1418375307412406274','1212685717864517633','1418375307412406274',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307458543617','1211092856509411330','1418375307458543617',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307492098050','1211120827064496130','1418375307492098050',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307794087937','58','1418375307794087937',1,2,'张荣荣','15280619456','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307848613889','1211461407799820290','1418375307848613889',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307857002497','1216559724997144578','1418375307857002497',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307886362626','72','1418375307886362626',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307907334146','70','1418375307907334146',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307991220225','1211529007779069954','1418375307991220225',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308062523393','87','1418375308062523393',1,2,'叶志钦','13675957398','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308179963905','83','1418375308179963905',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308179963906','58','1418375308179963906',1,2,'张荣荣','15280619456','14,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308192546818','1211837849989595138','1418375308192546818',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308196741122','1211473406755651586','1418375308196741122',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308238684161','102','1418375308238684161',1,2,'颜思思','15280619456','10,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308368707586','87','1418375308368707586',1,2,'叶志钦','13675957398','14,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308402262018','1219451161745080321','1418375308402262018',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308431622146','1211474926804975617','1418375308431622146',2,2,'泉州轻工职业学院','13799550180','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308553256962','102','1418375308553256962',1,2,'颜思思','15280619456','14,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308599394305','1274912838720167938','1418375308599394305',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308607782914','1211837849989595138','1418375308607782914',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308758777858','1286499346338045953','1418375308758777858',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308804915202','1211945767430832130','1418375308804915202',2,2,'晋江市安海医院','13860758785','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375308968493058','1316201027820630017','1418375308968493058',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375309010436098','1214142410787934209','1418375309010436098',2,2,'晋江清源津工环保科技有限公司','13328567990','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375309190791169','1216568840104734722','1418375309190791169',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375309392117762','1290850604855361537','1418375309392117762',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375309580861442','1295900371603947522','1418375309580861442',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375309849296898','1348924009986654209','1418375309849296898',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375310021263361','1351830895278948354','1418375310021263361',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375310268727298','1385046095385591809','1418375310268727298',2,2,'晋江全亿无纺布有限责任公司','16653129639','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375310511996930','1402819845443059714','1418375310511996930',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418375310692352002','1405774133261815809','1418375310692352002',2,2,'晋江市园绿园农林专业合作社','18350773795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 09:00:00',NULL,NULL,NULL,'2021-07-23 09:00:00',NULL,NULL,NULL),('1418392674079113218',NULL,'1418392674079113218',2,1,NULL,'18659592008','379995','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-23 10:09:00',NULL,NULL,NULL,'2021-07-23 10:09:00',NULL,NULL,NULL),('1418393524038041602','1371630658811703297','1418393524038041602',2,2,'福建华清电子材料科技有限公司','13959775727','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 10:12:23',NULL,NULL,NULL,'2021-07-23 10:12:23',NULL,NULL,NULL),('1418401514036166658',NULL,'1418401514036166658',2,1,NULL,'15880822838','889764','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-23 10:44:08',NULL,NULL,NULL,'2021-07-23 10:44:08',NULL,NULL,NULL),('1418417361660182529','1418025002690707457','1418417361660182529',2,2,'福建省统一环保科技有限公司','15080160279','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 11:47:06',NULL,NULL,NULL,'2021-07-23 11:47:06',NULL,NULL,NULL),('1418417623284088834','1417783431126876161','1418417623284088834',2,2,'福建富利恩卫浴科技有限公司','18759918618','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 11:48:08',NULL,NULL,NULL,'2021-07-23 11:48:08',NULL,NULL,NULL),('1418418013920591873','1417758306943926274','1418418013920591873',2,2,'厦门航空国际旅行社有限公司晋江安海金沙城营业部','13850751075','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 11:49:42',NULL,NULL,NULL,'2021-07-23 11:49:42',NULL,NULL,NULL),('1418418215050051585','1417742593315340290','1418418215050051585',2,2,'泉州爱杉尼贸易有限公司','15750992059','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-23 11:50:30',NULL,NULL,NULL,'2021-07-23 11:50:30',NULL,NULL,NULL),('1418419266109079554','1413381724808716289','1418419266109079554',2,2,'医合家(泉州)医疗科技有限公司','13522580611','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 11:54:40',NULL,NULL,NULL,'2021-07-23 11:54:40',NULL,NULL,NULL),('1418470741359230977',NULL,'1418470741359230977',2,1,NULL,'15860935954','676342','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-23 15:19:13',NULL,NULL,NULL,'2021-07-23 15:19:13',NULL,NULL,NULL),('1418491532209586177','1212661969526525954','1418491532209586177',2,2,'福建正麒高纤科技股份有限公司','15859731637','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:41:50',NULL,NULL,NULL,'2021-07-23 16:41:50',NULL,NULL,NULL),('1418492432210755585','1212666561777700865','1418492432210755585',2,2,'锦兴(福建)化纤纺织实业有限公司','15859731637','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:45:24',NULL,NULL,NULL,'2021-07-23 16:45:24',NULL,NULL,NULL),('1418492514595274753','1294076991682641922','1418492514595274753',2,2,'福建意尔康体育用品有限公司','15905071236','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:45:44',NULL,NULL,NULL,'2021-07-23 16:45:44',NULL,NULL,NULL),('1418492676159864833','1211561316616028162','1418492676159864833',2,2,'福建盼盼饮料有限公司','15959993860','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:46:22',NULL,NULL,NULL,'2021-07-23 16:46:22',NULL,NULL,NULL),('1418492732254486529','1211456847907700737','1418492732254486529',2,2,'峰安皮业股份有限公司','13055559656','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:46:36',NULL,NULL,NULL,'2021-07-23 16:46:36',NULL,NULL,NULL),('1418493407218663426','1211450215958102018','1418493407218663426',2,2,'福建夜光达科技股份有限公司','18350782990','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:49:17',NULL,NULL,NULL,'2021-07-23 16:49:17',NULL,NULL,NULL),('1418493470292606977','1374975706999595010','1418493470292606977',2,2,'向维智联(福建)科技有限公司','15659222652','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:49:32',NULL,NULL,NULL,'2021-07-23 16:49:32',NULL,NULL,NULL),('1418493519152054274','1212604591955316738','1418493519152054274',2,2,'福建约克新材料科技有限公司','15159842227','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:49:43',NULL,NULL,NULL,'2021-07-23 16:49:43',NULL,NULL,NULL),('1418493574214877185','1211484578443739137','1418493574214877185',2,2,'晋江市锦福化纤聚合有限公司','18750650129','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-23 16:49:57',NULL,NULL,NULL,'2021-07-23 16:49:57',NULL,NULL,NULL),('1418497814341648386',NULL,'1418497814341648386',2,1,NULL,'15980755279','711991','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-23 17:06:48',NULL,NULL,NULL,'2021-07-23 17:06:48',NULL,NULL,NULL),('1418745091861807106',NULL,'1418745091861807106',2,1,NULL,'15080160279','501816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-24 09:29:23',NULL,NULL,NULL,'2021-07-24 09:29:23',NULL,NULL,NULL),('1418759874732392450',NULL,'1418759874732392450',2,1,NULL,'13808518477','168228','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-24 10:28:08',NULL,NULL,NULL,'2021-07-24 10:28:08',NULL,NULL,NULL),('1418789090026881026',NULL,'1418789090026881026',2,1,NULL,'15060807141','674660','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-24 12:24:13',NULL,NULL,NULL,'2021-07-24 12:24:13',NULL,NULL,NULL),('1418863831655940098',NULL,'1418863831655940098',2,1,NULL,'15960788001','602189','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-24 17:21:13',NULL,NULL,NULL,'2021-07-24 17:21:13',NULL,NULL,NULL),('1419186864874618881',NULL,'1419186864874618881',2,1,NULL,'15980755279','614999','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-25 14:44:50',NULL,NULL,NULL,'2021-07-25 14:44:50',NULL,NULL,NULL),('1419462471151812609','1211171114114461697','1419462471151812609',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471189561346','1211482027447074818','1419462471189561346',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471202144258','1211092856509411330','1419462471202144258',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471286030337','1211120827064496130','1419462471286030337',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471546077185','58','1419462471546077185',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471718043649','72','1419462471718043649',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471919370241','1211529007779069954','1419462471919370241',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471923564545','1211167966465470465','1419462471923564545',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471952924674','1211490446086291458','1419462471952924674',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471952924675','87','1419462471952924675',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472183611394','1211837849989595138','1419462472183611394',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472187805697','58','1419462472187805697',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472187805698','102','1419462472187805698',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472217165826','1211171114114461697','1419462472217165826',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472296857601','1211490953219588098','1419462472296857601',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472305246209','70','1419462472305246209',1,2,'陈瑞清','13788864979','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472401715202','87','1419462472401715202',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472473018369','1219451161745080321','1419462472473018369',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472473018370','1211461407799820290','1419462472473018370',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472531738626','1211559758373371905','1419462472531738626',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472619819009','75','1419462472619819009',1,2,'陈丽瓶','15059855678','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472619819010','102','1419462472619819010',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472653373441','1274912838720167938','1419462472653373441',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472661762049','1211473406755651586','1419462472661762049',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472707899394','1212568548061286401','1419462472707899394',2,2,'贵人鸟股份有限公司','15359991222','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472787591169','83','1419462472787591169',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472846311425','1286499346338045953','1419462472846311425',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472846311426','1211474926804975617','1419462472846311426',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472913420290','1212685717864517633','1419462472913420290',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462473081192449','1211837849989595138','1419462473081192449',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462473093775362','1216559724997144578','1419462473093775362',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462473093775363','1316201027820630017','1419462473093775363',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462473248964609','1211936041519333377','1419462473248964609',2,2,'福建集成伞业有限公司','13788829369','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462473441902594','1211945767430832130','1419462473441902594',2,2,'晋江市安海医院','13860758785','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462473626451970','1216568840104734722','1419462473626451970',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462473798418433','1286499346338045953','1419462473798418433',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462474008133633','1290850604855361537','1419462474008133633',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462474180100098','1295900371603947522','1419462474180100098',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462474381426690','1339090713744244738','1419462474381426690',2,2,'梅花(晋江)伞业有限公司','13489319022','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462474654056450','1348924009986654209','1419462474654056450',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:00',NULL,NULL,NULL,'2021-07-26 09:00:00',NULL,NULL,NULL),('1419462474855383041','1351830895278948354','1419462474855383041',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:01',NULL,NULL,NULL,'2021-07-26 09:00:01',NULL,NULL,NULL),('1419462475111235585','1385046095385591809','1419462475111235585',2,2,'晋江全亿无纺布有限责任公司','16653129639','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:01',NULL,NULL,NULL,'2021-07-26 09:00:01',NULL,NULL,NULL),('1419462475312562177','1402819845443059714','1419462475312562177',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:01',NULL,NULL,NULL,'2021-07-26 09:00:01',NULL,NULL,NULL),('1419462475497111553','1409682434043191297','1419462475497111553',2,2,'晋江市农业农村局','15880993753','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-26 09:00:01',NULL,NULL,NULL,'2021-07-26 09:00:01',NULL,NULL,NULL),('1419495697253695489',NULL,'1419495697253695489',2,1,NULL,'15059820805','411844','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-26 11:12:01',NULL,NULL,NULL,'2021-07-26 11:12:01',NULL,NULL,NULL),('1419520701324361730',NULL,'1419520701324361730',2,1,NULL,'13812752721','917602','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-26 12:51:23',NULL,NULL,NULL,'2021-07-26 12:51:23',NULL,NULL,NULL),('1419824858916749313','1211490953219588098','1419824858916749313',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824858954498050','1211120827064496130','1419824858954498050',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824858979663874','1211482027447074818','1419824858979663874',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859084521473','1211092856509411330','1419824859084521473',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859558477825','72','1419824859558477825',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859558477826','58','1419824859558477826',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859575255042','83','1419824859575255042',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859613003778','1211529007779069954','1419824859613003778',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859621392386','1211167966465470465','1419824859621392386',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859621392387','1211559758373371905','1419824859621392387',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859801747458','87','1419824859801747458',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859822718978','58','1419824859822718978',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859885633538','1212685717864517633','1419824859885633538',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859885633539','1211837849989595138','1419824859885633539',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859898216450','1211171114114461697','1419824859898216450',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860024045569','87','1419824860024045569',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860024045570','102','1419824860024045570',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860074377217','1211461407799820290','1419824860074377217',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860078571521','1213844233778122754','1419824860078571521',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860082765825','1219451161745080321','1419824860082765825',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860221177857','102','1419824860221177857',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860258926594','1211473406755651586','1419824860258926594',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860275703810','1216559724997144578','1419824860275703810',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860305063937','1274912838720167938','1419824860305063937',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860493807618','1211474926804975617','1419824860493807618',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860506390529','1286499346338045953','1419824860506390529',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860716105730','1211539398999457793','1419824860716105730',2,2,'海西纺织新材料工业技术晋江研究院','15280796970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860724494337','1316201027820630017','1419824860724494337',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824860930015233','1211837849989595138','1419824860930015233',2,2,'利郎（中国）有限公司','15959420909','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824861164896258','1213032291266269186','1419824861164896258',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824861433331714','1216568840104734722','1419824861433331714',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824861668212737','1241252588561698817','1419824861668212737',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824861936648194','1286499346338045953','1419824861936648194',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824862167334914','1290850604855361537','1419824862167334914',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824862431576065','1295900371603947522','1419824862431576065',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824862632902658','1331809968285810690','1419824862632902658',2,2,'福建省向兴纺织科技有限公司','15880881998','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:00',NULL,NULL,NULL,'2021-07-27 09:00:00',NULL,NULL,NULL),('1419824862830034945','1339090713744244738','1419824862830034945',2,2,'梅花(晋江)伞业有限公司','13489319022','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:01',NULL,NULL,NULL,'2021-07-27 09:00:01',NULL,NULL,NULL),('1419824863035555842','1348924009986654209','1419824863035555842',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:01',NULL,NULL,NULL,'2021-07-27 09:00:01',NULL,NULL,NULL),('1419824863241076737','1351830895278948354','1419824863241076737',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:01',NULL,NULL,NULL,'2021-07-27 09:00:01',NULL,NULL,NULL),('1419824863413043201','1374592097176367105','1419824863413043201',2,2,'泉州恒度微纳科技有限公司','13290782758','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:01',NULL,NULL,NULL,'2021-07-27 09:00:01',NULL,NULL,NULL),('1419824863601786881','1381802869983932418','1419824863601786881',2,2,'晋江市南音协会','15880928010','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:01',NULL,NULL,NULL,'2021-07-27 09:00:01',NULL,NULL,NULL),('1419824863790530562','1402819845443059714','1419824863790530562',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:01',NULL,NULL,NULL,'2021-07-27 09:00:01',NULL,NULL,NULL),('1419824863983468546','1409682434043191297','1419824863983468546',2,2,'晋江市农业农村局','15880993753','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-27 09:00:01',NULL,NULL,NULL,'2021-07-27 09:00:01',NULL,NULL,NULL),('1419923720293634049',NULL,'1419923720293634049',2,1,NULL,'15750998817','124394','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-27 15:32:50',NULL,NULL,NULL,'2021-07-27 15:32:50',NULL,NULL,NULL),('1419925200987803649',NULL,'1419925200987803649',2,1,NULL,'15750998817','469151','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-27 15:38:43',NULL,NULL,NULL,'2021-07-27 15:38:43',NULL,NULL,NULL),('1419926173235859457',NULL,'1419926173235859457',2,1,NULL,'15750998817','639309','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-27 15:42:35',NULL,NULL,NULL,'2021-07-27 15:42:35',NULL,NULL,NULL),('1419940891652575234',NULL,'1419940891652575234',2,1,NULL,'15750998817','872139','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-27 16:41:04',NULL,NULL,NULL,'2021-07-27 16:41:04',NULL,NULL,NULL),('1419991365646864386',NULL,'1419991365646864386',2,1,NULL,'15080421696','637796','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-27 20:01:38',NULL,NULL,NULL,'2021-07-27 20:01:38',NULL,NULL,NULL),('1419995138289094658',NULL,'1419995138289094658',2,1,NULL,'15080421696','524180','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-27 20:16:37',NULL,NULL,NULL,'2021-07-27 20:16:37',NULL,NULL,NULL),('1420187247638007810','1211092856509411330','1420187247638007810',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187247654785026','1211120827064496130','1420187247654785026',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187247814168578','1211482027447074818','1420187247814168578',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187247977746433','1211490953219588098','1420187247977746433',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248627863553','1211167966465470465','1420187248627863553',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248661417985','1211529007779069954','1420187248661417985',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248741109762','58','1420187248741109762',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248850161666','1211559758373371905','1420187248850161666',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248858550273','72','1420187248858550273',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249143762946','1211171114114461697','1420187249143762946',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249168928770','1211837849989595138','1420187249168928770',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249324118017','58','1420187249324118017',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249324118018','87','1420187249324118018',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249357672449','83','1420187249357672449',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249458335745','1211461407799820290','1420187249458335745',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249554804738','1219451161745080321','1420187249554804738',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249563193346','1212685717864517633','1420187249563193346',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249563193347','87','1420187249563193347',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249659662337','102','1420187249659662337',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249844211713','1211473406755651586','1420187249844211713',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249978429442','102','1420187249978429442',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249991012354','1274912838720167938','1420187249991012354',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187250146201601','1213844233778122754','1420187250146201601',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187250150395906','1211474926804975617','1420187250150395906',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187250309779457','1286499346338045953','1420187250309779457',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187250406248450','1216559724997144578','1420187250406248450',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187250423025666','1211539398999457793','1420187250423025666',2,2,'海西纺织新材料工业技术晋江研究院','15280796970','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187250523688962','1316201027820630017','1420187250523688962',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:00',NULL,NULL,NULL,'2021-07-28 09:00:00',NULL,NULL,NULL),('1420187250603380738','1213032291266269186','1420187250603380738',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187250834067457','1216568840104734722','1420187250834067457',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187250926342146','1241252588561698817','1420187250926342146',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187251236720641','1286499346338045953','1420187251236720641',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187251421270018','1290850604855361537','1420187251421270018',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187251605819393','1295900371603947522','1420187251605819393',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187251819728897','1348924009986654209','1420187251819728897',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187252037832705','1351830895278948354','1420187252037832705',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187252218187778','1381802869983932418','1420187252218187778',2,2,'晋江市南音协会','15880928010','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420187252406931457','1402819845443059714','1420187252406931457',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-28 09:00:01',NULL,NULL,NULL,'2021-07-28 09:00:01',NULL,NULL,NULL),('1420208365384028162',NULL,'1420208365384028162',2,1,NULL,'13559579090','652166','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-28 10:23:55',NULL,NULL,NULL,'2021-07-28 10:23:55',NULL,NULL,NULL),('1420291056242577410',NULL,'1420291056242577410',2,1,NULL,'13905960809','349087','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-28 15:52:30',NULL,NULL,NULL,'2021-07-28 15:52:30',NULL,NULL,NULL),('1420549634715078658','1211559758373371905','1420549634715078658',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549634723467265','1211482027447074818','1420549634723467265',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549634777993218','1211167966465470465','1420549634777993218',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549634824130562','1211120827064496130','1420549634824130562',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635251949570','58','1420549635251949570',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635285504002','72','1420549635285504002',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635289698306','83','1420549635289698306',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635377778690','1212685717864517633','1420549635377778690',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635377778691','1211171114114461697','1420549635377778691',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635465859073','1211529007779069954','1420549635465859073',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635553939458','87','1420549635553939458',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635591688193','58','1420549635591688193',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635683962882','1213844233778122754','1420549635683962882',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635725905922','1211837849989595138','1420549635725905922',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635725905923','1211461407799820290','1420549635725905923',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635839152129','87','1420549635839152129',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635839152130','102','1420549635839152130',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635893678081','1216559724997144578','1420549635893678081',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635897872386','1211473406755651586','1420549635897872386',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635918843906','1219451161745080321','1420549635918843906',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636086616066','102','1420549636086616066',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636162113538','1211474926804975617','1420549636162113538',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636174696450','1274912838720167938','1420549636174696450',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636342468610','1213032291266269186','1420549636342468610',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636350857218','1286499346338045953','1420549636350857218',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636539600897','1216568840104734722','1420549636539600897',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636552183809','1316201027820630017','1420549636552183809',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636724150273','1241252588561698817','1420549636724150273',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549636900311041','1286499346338045953','1420549636900311041',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549637139386370','1290850604855361537','1420549637139386370',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549637382656001','1295900371603947522','1420549637382656001',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549637592371202','1348924009986654209','1420549637592371202',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549637789503489','1351830895278948354','1420549637789503489',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549638015995906','1374554432229978113','1420549638015995906',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549638276042754','1381802869983932418','1420549638276042754',2,2,'晋江市南音协会','15880928010','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:00',NULL,NULL,NULL,'2021-07-29 09:00:00',NULL,NULL,NULL),('1420549638624169985','1402819845443059714','1420549638624169985',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-29 09:00:01',NULL,NULL,NULL,'2021-07-29 09:00:01',NULL,NULL,NULL),('1420555558028627970',NULL,'1420555558028627970',2,1,NULL,'13110957587','507049','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-29 09:23:32',NULL,NULL,NULL,'2021-07-29 09:23:32',NULL,NULL,NULL),('1420556060430749698',NULL,'1420556060430749698',2,1,NULL,'13110957587','833004','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-29 09:25:32',NULL,NULL,NULL,'2021-07-29 09:25:32',NULL,NULL,NULL),('1420646401347428353',NULL,'1420646401347428353',2,1,NULL,'15880941089','439241','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-29 15:24:31',NULL,NULL,NULL,'2021-07-29 15:24:31',NULL,NULL,NULL),('1420652603779325954',NULL,'1420652603779325954',2,1,NULL,'18915331371','579939','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-29 15:49:09',NULL,NULL,NULL,'2021-07-29 15:49:09',NULL,NULL,NULL),('1420657357070802946',NULL,'1420657357070802946',2,1,NULL,'18915331371','205096','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-29 16:08:03',NULL,NULL,NULL,'2021-07-29 16:08:03',NULL,NULL,NULL),('1420677673830588418','1420657459164356609','1420677673830588418',2,2,'科山芯创(福建)科技有限公司','18915331371','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-07-29 17:28:47',NULL,NULL,NULL,'2021-07-29 17:28:47',NULL,NULL,NULL),('1420905709876289537',NULL,'1420905709876289537',2,1,NULL,'15080421696','846093','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 08:34:55',NULL,NULL,NULL,'2021-07-30 08:34:55',NULL,NULL,NULL),('1420912022731628546','1211559758373371905','1420912022731628546',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912022744211458','1211167966465470465','1420912022744211458',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912022786154498','1211120827064496130','1420912022786154498',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912022849069058','1211482027447074818','1420912022849069058',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023155253250','58','1420912023155253250',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023188807681','72','1420912023188807681',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023226556418','1212685717864517633','1420912023226556418',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023230750721','83','1420912023230750721',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023276888065','1211171114114461697','1420912023276888065',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023285276674','1211529007779069954','1420912023285276674',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023381745665','58','1420912023381745665',1,2,'张荣荣','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1420912023436271618','87','1420912023436271618',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023469826050','1213844233778122754','1420912023469826050',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023503380481','1211461407799820290','1420912023503380481',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023524352002','1211837849989595138','1420912023524352002',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023696318465','102','1420912023696318465',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023704707074','87','1420912023704707074',1,2,'叶志钦','13675957398','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023717289986','1216559724997144578','1420912023717289986',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023734067201','1211473406755651586','1420912023734067201',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023809564673','1219451161745080321','1420912023809564673',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023918616577','102','1420912023918616577',1,2,'颜思思','15280619456','10,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024006696962','1211474926804975617','1420912024006696962',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024069611521','1274912838720167938','1420912024069611521',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024203829249','1213032291266269186','1420912024203829249',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024308686849','1286499346338045953','1420912024308686849',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024409350145','1216568840104734722','1420912024409350145',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024493236226','1316201027820630017','1420912024493236226',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024602288130','1241252588561698817','1420912024602288130',2,2,'福建哲创新材料科技有限公司','18160999097','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912024795226114','1286499346338045953','1420912024795226114',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912025009135617','1290850604855361537','1420912025009135617',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912025239822338','1295900371603947522','1420912025239822338',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912025445343233','1348924009986654209','1420912025445343233',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420912025655058433','1351830895278948354','1420912025655058433',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-07-30 09:00:00',NULL,NULL,NULL,'2021-07-30 09:00:00',NULL,NULL,NULL),('1420913538150440962',NULL,'1420913538150440962',2,1,NULL,'15559079841','844939','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 09:06:01',NULL,NULL,NULL,'2021-07-30 09:06:01',NULL,NULL,NULL),('1420919608319156225',NULL,'1420919608319156225',2,1,NULL,'15392079089','051317','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 09:30:08',NULL,NULL,NULL,'2021-07-30 09:30:08',NULL,NULL,NULL),('1420924159029960705',NULL,'1420924159029960705',2,1,NULL,'15392079089','745555','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 09:48:13',NULL,NULL,NULL,'2021-07-30 09:48:13',NULL,NULL,NULL),('1420962509820551170',NULL,'1420962509820551170',2,1,NULL,'17330182531','481230','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 12:20:37',NULL,NULL,NULL,'2021-07-30 12:20:37',NULL,NULL,NULL),('1420979250558689282',NULL,'1420979250558689282',2,1,NULL,'18350533399','730724','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 13:27:08',NULL,NULL,NULL,'2021-07-30 13:27:08',NULL,NULL,NULL),('1420979636313022465',NULL,'1420979636313022465',2,1,NULL,'18350533399','492973','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 13:28:40',NULL,NULL,NULL,'2021-07-30 13:28:40',NULL,NULL,NULL),('1421017919696953345',NULL,'1421017919696953345',2,1,NULL,'13960373960','399768','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 16:00:47',NULL,NULL,NULL,'2021-07-30 16:00:47',NULL,NULL,NULL),('1421020561185726465',NULL,'1421020561185726465',2,1,NULL,'13306990416','145216','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 16:11:17',NULL,NULL,NULL,'2021-07-30 16:11:17',NULL,NULL,NULL),('1421031810841731073',NULL,'1421031810841731073',2,1,NULL,'13400681003','525835','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 16:55:59',NULL,NULL,NULL,'2021-07-30 16:55:59',NULL,NULL,NULL),('1421104082801680385',NULL,'1421104082801680385',2,1,NULL,'13805951603','690540','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 21:43:10',NULL,NULL,NULL,'2021-07-30 21:43:10',NULL,NULL,NULL),('1421104335760154626',NULL,'1421104335760154626',2,1,NULL,'15375754488','565911','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 21:44:11',NULL,NULL,NULL,'2021-07-30 21:44:11',NULL,NULL,NULL),('1421106900589633538',NULL,'1421106900589633538',2,1,NULL,'13110829805','667356','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 21:54:22',NULL,NULL,NULL,'2021-07-30 21:54:22',NULL,NULL,NULL),('1421110989205561346',NULL,'1421110989205561346',2,1,NULL,'13110829805','032334','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-30 22:10:37',NULL,NULL,NULL,'2021-07-30 22:10:37',NULL,NULL,NULL),('1421413207641186306',NULL,'1421413207641186306',2,1,NULL,'15960417947','349071','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-07-31 18:11:31',NULL,NULL,NULL,'2021-07-31 18:11:31',NULL,NULL,NULL),('1421999186341027841','1211559758373371905','1421999186341027841',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186412331010','1211482027447074818','1421999186412331010',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186412331011','1211120827064496130','1421999186412331011',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186521382913','1211167966465470465','1421999186521382913',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186945007618','58','1421999186945007618',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186945007619','72','1421999186945007619',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187054059521','83','1421999187054059521',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187242803202','58','1421999187242803202',1,2,'张荣荣','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187242803203','1211171114114461697','1421999187242803203',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187242803204','1212685717864517633','1421999187242803204',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187242803205','1211529007779069954','1421999187242803205',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187263774721','87','1421999187263774721',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187544793090','1211461407799820290','1421999187544793090',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187544793091','87','1421999187544793091',1,2,'叶志钦','13675957398','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187544793092','1213844233778122754','1421999187544793092',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187553181697','1211837849989595138','1421999187553181697',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187582541825','102','1421999187582541825',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187817422849','1211473406755651586','1421999187817422849',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187830005762','102','1421999187830005762',1,2,'颜思思','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187876143106','1219451161745080321','1421999187876143106',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999187876143107','1216559724997144578','1421999187876143107',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188006166529','1211474926804975617','1421999188006166529',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188119412737','1274912838720167938','1421999188119412737',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188215881730','1213032291266269186','1421999188215881730',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188358488066','1286499346338045953','1421999188358488066',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188429791234','1216568840104734722','1421999188429791234',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188622729217','1316201027820630017','1421999188622729217',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188631117826','1286499346338045953','1421999188631117826',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999188836638721','1290850604855361537','1421999188836638721',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999189096685569','1295900371603947522','1421999189096685569',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999189402869761','1348924009986654209','1421999189402869761',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999189641945090','1351830895278948354','1421999189641945090',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:00',NULL,NULL,NULL,'2021-08-02 09:00:00',NULL,NULL,NULL),('1421999189914574849','1374554432229978113','1421999189914574849',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-02 09:00:01',NULL,NULL,NULL,'2021-08-02 09:00:01',NULL,NULL,NULL),('1422135257116729345',NULL,'1422135257116729345',2,1,NULL,'15905077733','348618','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-02 18:00:41',NULL,NULL,NULL,'2021-08-02 18:00:41',NULL,NULL,NULL),('1422136969894322177',NULL,'1422136969894322177',2,1,NULL,'15905077733','226468','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-02 18:07:30',NULL,NULL,NULL,'2021-08-02 18:07:30',NULL,NULL,NULL),('1422361574034661378','1211535199725207554','1422361574034661378',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574105964545','1211482027447074818','1422361574105964545',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574135324674','1211167966465470465','1422361574135324674',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574206627841','1211120827064496130','1422361574206627841',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574479257601','58','1422361574479257601',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574483451906','72','1422361574483451906',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574609281025','83','1422361574609281025',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575104208897','1211529007779069954','1422361575104208897',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575104208898','58','1422361575104208898',1,2,'张荣荣','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575108403202','87','1422361575108403202',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575112597505','1211559758373371905','1422361575112597505',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575116791810','1211171114114461697','1422361575116791810',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575343284226','1211837849989595138','1422361575343284226',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575368450050','102','1422361575368450050',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575368450051','87','1422361575368450051',1,2,'叶志钦','13675957398','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575397810177','1212685717864517633','1422361575397810177',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575402004482','1211461407799820290','1422361575402004482',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575565582338','1219451161745080321','1422361575565582338',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575594942466','1211473406755651586','1422361575594942466',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575594942467','1213844233778122754','1422361575594942467',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575762714626','102','1422361575762714626',1,2,'颜思思','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575779491841','1216559724997144578','1422361575779491841',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575787880449','1211474926804975617','1422361575787880449',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575787880450','1274912838720167938','1422361575787880450',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575968235522','1219868423635353602','1422361575968235522',2,2,'福建省晋江市和盛机械有限公司','13808552366','3,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575972429826','1286499346338045953','1422361575972429826',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361575972429827','1213032291266269186','1422361575972429827',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361576198922241','1216568840104734722','1422361576198922241',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361576211505153','1316201027820630017','1422361576211505153',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361576437997569','1286499346338045953','1422361576437997569',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361576622546945','1295900371603947522','1422361576622546945',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361576886788098','1348924009986654209','1422361576886788098',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361577180389378','1351830895278948354','1422361577180389378',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422361577369133058','1374554432229978113','1422361577369133058',2,2,'福建省晋华集成电路有限公司','15059820805','24,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-03 09:00:00',NULL,NULL,NULL,'2021-08-03 09:00:00',NULL,NULL,NULL),('1422370439975428097',NULL,'1422370439975428097',2,1,NULL,'15905077733','056015','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 09:35:13',NULL,NULL,NULL,'2021-08-03 09:35:13',NULL,NULL,NULL),('1422372932054704130',NULL,'1422372932054704130',2,1,NULL,'15659377356','587988','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 09:45:08',NULL,NULL,NULL,'2021-08-03 09:45:08',NULL,NULL,NULL),('1422387376826638337',NULL,'1422387376826638337',2,1,NULL,'13799522897','706512','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 10:42:31',NULL,NULL,NULL,'2021-08-03 10:42:31',NULL,NULL,NULL),('1422387435626586114',NULL,'1422387435626586114',2,1,NULL,'13599282110','792890','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 10:42:45',NULL,NULL,NULL,'2021-08-03 10:42:45',NULL,NULL,NULL),('1422387765777031169',NULL,'1422387765777031169',2,1,NULL,'18100535213','015226','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 10:44:04',NULL,NULL,NULL,'2021-08-03 10:44:04',NULL,NULL,NULL),('1422387989039833089',NULL,'1422387989039833089',2,1,NULL,'13799550077','543231','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 10:44:57',NULL,NULL,NULL,'2021-08-03 10:44:57',NULL,NULL,NULL),('1422391881253281793',NULL,'1422391881253281793',2,1,NULL,'17689684417','882355','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 11:00:25',NULL,NULL,NULL,'2021-08-03 11:00:25',NULL,NULL,NULL),('1422393173837111298',NULL,'1422393173837111298',2,1,NULL,'15750998817','307960','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 11:05:34',NULL,NULL,NULL,'2021-08-03 11:05:34',NULL,NULL,NULL),('1422393825065721857',NULL,'1422393825065721857',2,1,NULL,'15173662302','180459','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 11:08:09',NULL,NULL,NULL,'2021-08-03 11:08:09',NULL,NULL,NULL),('1422394389593874433',NULL,'1422394389593874433',2,1,NULL,'15750801189','863779','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 11:10:23',NULL,NULL,NULL,'2021-08-03 11:10:23',NULL,NULL,NULL),('1422395713161027585',NULL,'1422395713161027585',2,1,NULL,'15750998817','315548','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 11:15:39',NULL,NULL,NULL,'2021-08-03 11:15:39',NULL,NULL,NULL),('1422403540994777089',NULL,'1422403540994777089',2,1,NULL,'15750998817','250858','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 11:46:45',NULL,NULL,NULL,'2021-08-03 11:46:45',NULL,NULL,NULL),('1422403915319631874',NULL,'1422403915319631874',2,1,NULL,'15173662302','236600','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 11:48:15',NULL,NULL,NULL,'2021-08-03 11:48:15',NULL,NULL,NULL),('1422414380703703041',NULL,'1422414380703703041',2,1,NULL,'15559117373','227581','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 12:29:50',NULL,NULL,NULL,'2021-08-03 12:29:50',NULL,NULL,NULL),('1422414848431513602',NULL,'1422414848431513602',2,1,NULL,'18606086461','889872','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 12:31:41',NULL,NULL,NULL,'2021-08-03 12:31:41',NULL,NULL,NULL),('1422415988816633858',NULL,'1422415988816633858',2,1,NULL,'13950383926','083895','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 12:36:13',NULL,NULL,NULL,'2021-08-03 12:36:13',NULL,NULL,NULL),('1422417469833764865',NULL,'1422417469833764865',2,1,NULL,'13950383926','379773','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 12:42:06',NULL,NULL,NULL,'2021-08-03 12:42:06',NULL,NULL,NULL),('1422528005179203585',NULL,'1422528005179203585',2,1,NULL,'15392077757','605478','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-03 20:01:20',NULL,NULL,NULL,'2021-08-03 20:01:20',NULL,NULL,NULL),('1422714284906930178',NULL,'1422714284906930178',2,1,NULL,'13808533094','272656','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-04 08:21:32',NULL,NULL,NULL,'2021-08-04 08:21:32',NULL,NULL,NULL),('1422723961728294914','1211167966465470465','1422723961728294914',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723961828958209','1211535199725207554','1422723961828958209',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723961883484162','1211482027447074818','1422723961883484162',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723961971564546','1211120827064496130','1422723961971564546',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962206445569','1211461407799820290','1422723962206445569',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962244194307','58','1422723962244194307',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962307108865','1211559758373371905','1422723962307108865',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962386800642','1211529007779069954','1422723962386800642',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962533601281','1211473406755651586','1422723962533601281',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962634264578','72','1422723962634264578',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962709762050','83','1422723962709762050',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962722344961','87','1422723962722344961',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962764288001','1212685717864517633','1422723962764288001',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962818813953','1211474926804975617','1422723962818813953',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962818813954','1211837849989595138','1422723962818813954',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962869145602','58','1422723962869145602',1,2,'张荣荣','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962978197506','1213844233778122754','1422723962978197506',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963032723457','1213032291266269186','1422723963032723457',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963032723458','1219451161745080321','1422723963032723458',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963036917762','102','1422723963036917762',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963057889282','87','1422723963057889282',1,2,'叶志钦','13675957398','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963158552578','1216559724997144578','1422723963158552578',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963225661441','1216568840104734722','1422723963225661441',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963238244353','1274912838720167938','1422723963238244353',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963284381698','102','1422723963284381698',1,2,'颜思思','15280619456','12,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963485708290','1286499346338045953','1422723963485708290',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963485708291','1286499346338045953','1422723963485708291',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963695423490','1316201027820630017','1422723963695423490',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963708006401','1295900371603947522','1422723963708006401',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723963905138690','1348924009986654209','1422723963905138690',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723964169379841','1351830895278948354','1422723964169379841',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422723964437815297','1374554432229978113','1422723964437815297',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 09:00:00',NULL,NULL,NULL,'2021-08-04 09:00:00',NULL,NULL,NULL),('1422724714115129345',NULL,'1422724714115129345',2,1,NULL,'17805988022','602026','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-04 09:02:59',NULL,NULL,NULL,'2021-08-04 09:02:59',NULL,NULL,NULL),('1422826040853553153',NULL,'1422826040853553153',2,1,NULL,'15659922593','173596','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-04 15:45:37',NULL,NULL,NULL,'2021-08-04 15:45:37',NULL,NULL,NULL),('1422831306521206785','1418025002690707457','1422831306521206785',2,2,'福建省统一环保科技有限公司','15080160279','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-04 16:06:33',NULL,NULL,NULL,'2021-08-04 16:06:33',NULL,NULL,NULL),('1422832323568623618','1420924342417514497','1422832323568623618',2,2,'福建灵雀谷生物科技有限公司','15392079089','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-04 16:10:35',NULL,NULL,NULL,'2021-08-04 16:10:35',NULL,NULL,NULL),('1422833609248628737',NULL,'1422833609248628737',2,1,NULL,'15080160279','588215','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-04 16:15:42',NULL,NULL,NULL,'2021-08-04 16:15:42',NULL,NULL,NULL),('1422835694769823745','1421017982661844994','1422835694769823745',2,2,'泉州步致新材料科技有限公司','13960373960','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-04 16:23:59',NULL,NULL,NULL,'2021-08-04 16:23:59',NULL,NULL,NULL),('1422835764235886593','1418025002690707457','1422835764235886593',2,2,'福建省统一环保科技有限公司','15080160279','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-04 16:24:15',NULL,NULL,NULL,'2021-08-04 16:24:15',NULL,NULL,NULL),('1422836599867072514','1371630658811703297','1422836599867072514',2,2,'福建华清电子材料科技有限公司','13959775727','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-04 16:27:35',NULL,NULL,NULL,'2021-08-04 16:27:35',NULL,NULL,NULL),('1422867678703411201',NULL,'1422867678703411201',2,1,NULL,'13110535732','352161','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-04 18:31:04',NULL,NULL,NULL,'2021-08-04 18:31:04',NULL,NULL,NULL),('1423086349686169601','1211535199725207554','1423086349686169601',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086349732306946','1211482027447074818','1423086349732306946',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086349744889857','1211167966465470465','1423086349744889857',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086349774249986','1211120827064496130','1423086349774249986',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350067851265','58','1423086350067851265',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350118182914','72','1423086350118182914',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350617305090','58','1423086350617305090',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350655053825','1211461407799820290','1423086350655053825',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350655053826','1211529007779069954','1423086350655053826',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350655053827','87','1423086350655053827',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350663442433','1211559758373371905','1423086350663442433',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350898323458','102','1423086350898323458',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350906712066','87','1423086350906712066',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350906712067','1211473406755651586','1423086350906712067',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350923489282','1211837849989595138','1423086350923489282',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350969626626','1212685717864517633','1423086350969626626',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351116427265','102','1423086351116427265',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351137398786','1211474926804975617','1423086351137398786',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351145787394','1219451161745080321','1423086351145787394',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351162564609','1213844233778122754','1423086351162564609',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351351308289','1213032291266269186','1423086351351308289',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351355502594','1274912838720167938','1423086351355502594',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351363891202','1216559724997144578','1423086351363891202',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351523274753','1216568840104734722','1423086351523274753',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351548440578','1286499346338045953','1423086351548440578',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351699435522','1286499346338045953','1423086351699435522',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351720407041','1316201027820630017','1423086351720407041',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086351871401986','1295900371603947522','1423086351871401986',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086352072728577','1348924009986654209','1423086352072728577',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086352257277953','1351830895278948354','1423086352257277953',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423086352504741889','1374554432229978113','1423086352504741889',2,2,'福建省晋华集成电路有限公司','15059820805','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-05 09:00:00',NULL,NULL,NULL,'2021-08-05 09:00:00',NULL,NULL,NULL),('1423088123641880578',NULL,'1423088123641880578',2,1,NULL,'18259263128','436096','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-05 09:07:03',NULL,NULL,NULL,'2021-08-05 09:07:03',NULL,NULL,NULL),('1423092436443369474',NULL,'1423092436443369474',2,1,NULL,'15659088968','696892','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-05 09:24:11',NULL,NULL,NULL,'2021-08-05 09:24:11',NULL,NULL,NULL),('1423200498927833089',NULL,'1423200498927833089',2,1,NULL,'18233568861','730253','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-05 16:33:35',NULL,NULL,NULL,'2021-08-05 16:33:35',NULL,NULL,NULL),('1423246917017575426',NULL,'1423246917017575426',2,1,NULL,'18650901983','413870','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-05 19:38:02',NULL,NULL,NULL,'2021-08-05 19:38:02',NULL,NULL,NULL),('1423448737899913218','1211535199725207554','1423448737899913218',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448737975410689','1211482027447074818','1423448737975410689',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448738399035393','1211167966465470465','1423448738399035393',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448738696830978','1211120827064496130','1423448738696830978',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448738734579714','1211559758373371905','1423448738734579714',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739292422145','58','1423448739292422145',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739305005058','1211461407799820290','1423448739305005058',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739351142402','72','1423448739351142402',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739493748737','1212685717864517633','1423448739493748737',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739623772161','1211473406755651586','1423448739623772161',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739665715201','87','1423448739665715201',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739716046850','1211529007779069954','1423448739716046850',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739762184193','58','1423448739762184193',1,2,'张荣荣','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739820904449','1213844233778122754','1423448739820904449',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739858653186','1211474926804975617','1423448739858653186',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739921567746','102','1423448739921567746',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740051591170','1211837849989595138','1423448740051591170',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740106117121','87','1423448740106117121',1,2,'叶志钦','13675957398','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740135477249','1216559724997144578','1423448740135477249',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740185808898','1213032291266269186','1423448740185808898',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740336803841','102','1423448740336803841',1,2,'颜思思','15280619456','9,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740345192450','1219451161745080321','1423448740345192450',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740529741825','1216568840104734722','1423448740529741825',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740622016514','1274912838720167938','1423448740622016514',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740806565890','1286499346338045953','1423448740806565890',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448740814954498','1286499346338045953','1423448740814954498',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448741049835522','1295900371603947522','1423448741049835522',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448741087584257','1316201027820630017','1423448741087584257',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448741301493762','1348924009986654209','1423448741301493762',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:00',NULL,NULL,NULL,'2021-08-06 09:00:00',NULL,NULL,NULL),('1423448741574123522','1351830895278948354','1423448741574123522',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:01',NULL,NULL,NULL,'2021-08-06 09:00:01',NULL,NULL,NULL),('1423448741817393154','1374554432229978113','1423448741817393154',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 09:00:01',NULL,NULL,NULL,'2021-08-06 09:00:01',NULL,NULL,NULL),('1423449040971931650',NULL,'1423449040971931650',2,1,NULL,'15750998817','839834','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 09:01:12',NULL,NULL,NULL,'2021-08-06 09:01:12',NULL,NULL,NULL),('1423457293051142146',NULL,'1423457293051142146',2,1,NULL,'13732111872','694240','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 09:33:59',NULL,NULL,NULL,'2021-08-06 09:33:59',NULL,NULL,NULL),('1423462145617600513',NULL,'1423462145617600513',2,1,NULL,'13960255305','279801','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 09:53:16',NULL,NULL,NULL,'2021-08-06 09:53:16',NULL,NULL,NULL),('1423463458275368962',NULL,'1423463458275368962',2,1,NULL,'13960255305','081497','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 09:58:29',NULL,NULL,NULL,'2021-08-06 09:58:29',NULL,NULL,NULL),('1423464071386144770',NULL,'1423464071386144770',2,1,NULL,'13960255305','597721','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 10:00:55',NULL,NULL,NULL,'2021-08-06 10:00:55',NULL,NULL,NULL),('1423483662699110401',NULL,'1423483662699110401',2,1,NULL,'13960255305','643465','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 11:18:46',NULL,NULL,NULL,'2021-08-06 11:18:46',NULL,NULL,NULL),('1423552427885371394','1423483722950287362','1423552427885371394',2,2,'晋江市中德顺机械有限公司','13960255305','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-06 15:52:01',NULL,NULL,NULL,'2021-08-06 15:52:01',NULL,NULL,NULL),('1423553278909652993','1402190798904131586','1423553278909652993',2,2,'泉州华威国维电子科技有限公司','13960258115','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-06 15:55:24',NULL,NULL,NULL,'2021-08-06 15:55:24',NULL,NULL,NULL),('1423553946223419394','1219173440183984129','1423553946223419394',2,2,'福建省宏泰建设发展有限公司','18159506258','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-06 15:58:03',NULL,NULL,NULL,'2021-08-06 15:58:03',NULL,NULL,NULL),('1423554149781381121','1213376299297476609','1423554149781381121',2,2,'福建省海峡建设发展有限公司','15805967556','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-06 15:58:52',NULL,NULL,NULL,'2021-08-06 15:58:52',NULL,NULL,NULL),('1423574282922926081',NULL,'1423574282922926081',2,1,NULL,'13600777770','744494','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 17:18:52',NULL,NULL,NULL,'2021-08-06 17:18:52',NULL,NULL,NULL),('1423635683800555521',NULL,'1423635683800555521',2,1,NULL,'15985918977','863842','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 21:22:51',NULL,NULL,NULL,'2021-08-06 21:22:51',NULL,NULL,NULL),('1423642033205059585',NULL,'1423642033205059585',2,1,NULL,'18050959135','140745','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-06 21:48:05',NULL,NULL,NULL,'2021-08-06 21:48:05',NULL,NULL,NULL),('1423819948744024066',NULL,'1423819948744024066',2,1,NULL,'13860748042','365846','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-07 09:35:03',NULL,NULL,NULL,'2021-08-07 09:35:03',NULL,NULL,NULL),('1423820208493076481',NULL,'1423820208493076481',2,1,NULL,'13860748042','530073','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-07 09:36:05',NULL,NULL,NULL,'2021-08-07 09:36:05',NULL,NULL,NULL),('1423820842093027330',NULL,'1423820842093027330',2,1,NULL,'13860748042','907192','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-07 09:38:36',NULL,NULL,NULL,'2021-08-07 09:38:36',NULL,NULL,NULL),('1423863572026400770',NULL,'1423863572026400770',2,1,NULL,'18650901983','878273','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-07 12:28:24',NULL,NULL,NULL,'2021-08-07 12:28:24',NULL,NULL,NULL),('1423868418209128449',NULL,'1423868418209128449',2,1,NULL,'13960440661','991944','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-07 12:47:39',NULL,NULL,NULL,'2021-08-07 12:47:39',NULL,NULL,NULL),('1424272861329137666',NULL,'1424272861329137666',2,1,NULL,'18233568861','424378','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-08 15:34:46',NULL,NULL,NULL,'2021-08-08 15:34:46',NULL,NULL,NULL),('1424280389081407489',NULL,'1424280389081407489',2,1,NULL,'15359978413','330668','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-08 16:04:41',NULL,NULL,NULL,'2021-08-08 16:04:41',NULL,NULL,NULL),('1424532946945089538','1423864261142159361','1424532946945089538',2,2,'婴舒宝(中国)有限公司','18650901983','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-09 08:48:15',NULL,NULL,NULL,'2021-08-09 08:48:15',NULL,NULL,NULL),('1424535901677068290','1211482027447074818','1424535901677068290',2,2,'福建晋江天然气发电有限公司','18876509838','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535901735788546','1212685717864517633','1424535901735788546',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535901769342978','1211120827064496130','1424535901769342978',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535901786120194','1211092856509411330','1424535901786120194',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902079721473','58','1424535902079721473',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902125858818','72','1424535902125858818',1,2,'翁海勇','13599173733','3,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902213939202','1213844233778122754','1424535902213939202',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902213939203','1211167966465470465','1424535902213939203',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902251687937','1211529007779069954','1424535902251687937',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902394294273','87','1424535902394294273',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902398488577','58','1424535902398488577',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902453014529','1211461407799820290','1424535902453014529',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902457208834','1216559724997144578','1424535902457208834',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902465597442','1211837849989595138','1424535902465597442',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902683701249','102','1424535902683701249',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902704672770','1211473406755651586','1424535902704672770',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902721449985','87','1424535902721449985',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902763393025','1219451161745080321','1424535902763393025',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902960525314','1211474926804975617','1424535902960525314',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902981496833','102','1424535902981496833',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902981496834','1274912838720167938','1424535902981496834',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535903342206978','1211837849989595138','1424535903342206978',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535903342206979','1286499346338045953','1424535903342206979',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535903619031042','1316201027820630017','1424535903619031042',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535903627419650','1213032291266269186','1424535903627419650',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535903837134850','1216568840104734722','1424535903837134850',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535904055238657','1286499346338045953','1424535904055238657',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535904277536770','1295900371603947522','1424535904277536770',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535904491446273','1348924009986654209','1424535904491446273',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535904684384258','1351830895278948354','1424535904684384258',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535904868933633','1374554432229978113','1424535904868933633',2,2,'福建省晋华集成电路有限公司','15059820805','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:00',NULL,NULL,NULL,'2021-08-09 09:00:00',NULL,NULL,NULL),('1424535905200283649','1381802869983932418','1424535905200283649',2,2,'晋江市南音协会','15880928010','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:00:01',NULL,NULL,NULL,'2021-08-09 09:00:01',NULL,NULL,NULL),('1424536183794343938','1418181190581518337','1424536183794343938',2,2,'福建杰斐逊律师事务所','13599100513','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-09 09:01:07',NULL,NULL,NULL,'2021-08-09 09:01:07',NULL,NULL,NULL),('1424537207837859841','1413335484670713858','1424537207837859841',2,2,'晋江市晋尚资产运营有限公司','13276083102','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-09 09:05:11',NULL,NULL,NULL,'2021-08-09 09:05:11',NULL,NULL,NULL),('1424537258647658498','1402838840355356673','1424537258647658498',2,2,'晋江市城市房屋征收有限公司','13959708090','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-09 09:05:23',NULL,NULL,NULL,'2021-08-09 09:05:23',NULL,NULL,NULL),('1424539108314750977','1395306414603284482','1424539108314750977',2,2,'中化(晋江)石油销售有限公司','18559268083','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-09 09:12:44',NULL,NULL,NULL,'2021-08-09 09:12:44',NULL,NULL,NULL),('1424669705699893249',NULL,'1424669705699893249',2,1,NULL,'13600777770','227765','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-09 17:51:41',NULL,NULL,NULL,'2021-08-09 17:51:41',NULL,NULL,NULL),('1424898289270038530','1211535199725207554','1424898289270038530',2,2,'福建亿龙建工有限公司','13506069172','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289295204354','1211092856509411330','1424898289295204354',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289320370178','1211120827064496130','1424898289320370178',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289685274625','58','1424898289685274625',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289714634754','58','1424898289714634754',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289731411969','1211167966465470465','1424898289731411969',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289748189186','1211529007779069954','1424898289748189186',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289748189187','1211559758373371905','1424898289748189187',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289882406914','83','1424898289882406914',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289970487297','87','1424898289970487297',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289970487298','1211171114114461697','1424898289970487298',2,2,'中轻(晋江)卫生用品研究有限公司','15959520077','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290020818945','87','1424898290020818945',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290180202497','1211837849989595138','1424898290180202497',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290192785410','1212685717864517633','1424898290192785410',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290385723393','102','1424898290385723393',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290385723394','102','1424898290385723394',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290385723395','1219451161745080321','1424898290385723395',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290398306305','1211461407799820290','1424898290398306305',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290415083522','1212731840222269441','1424898290415083522',2,2,'福建中策光电股份公司','18006999862','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290574467074','1274912838720167938','1424898290574467074',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290578661378','1213844233778122754','1424898290578661378',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290578661379','1211473406755651586','1424898290578661379',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290771599362','1286499346338045953','1424898290771599362',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290775793666','1211474926804975617','1424898290775793666',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290784182274','1216559724997144578','1424898290784182274',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290960343042','1316201027820630017','1424898290960343042',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898290960343043','1211837849989595138','1424898290960343043',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898291123920898','1213032291266269186','1424898291123920898',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898291304275969','1216568840104734722','1424898291304275969',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898291484631041','1286499346338045953','1424898291484631041',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898291669180418','1295900371603947522','1424898291669180418',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898291857924098','1348924009986654209','1424898291857924098',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898292050862081','1351830895278948354','1424898292050862081',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898292227022849','1374554432229978113','1424898292227022849',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898292411572226','1374592097176367105','1424898292411572226',2,2,'泉州恒度微纳科技有限公司','13290782758','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424898292600315905','1381802869983932418','1424898292600315905',2,2,'晋江市南音协会','15880928010','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-10 09:00:00',NULL,NULL,NULL,'2021-08-10 09:00:00',NULL,NULL,NULL),('1424912522514833409','1424670155656437762','1424912522514833409',2,2,'福建省扬远环保科技有限公司','13600777770','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-10 09:56:33',NULL,NULL,NULL,'2021-08-10 09:56:33',NULL,NULL,NULL),('1424927230974271490',NULL,'1424927230974271490',2,1,NULL,'15860477388','380177','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-10 10:55:00',NULL,NULL,NULL,'2021-08-10 10:55:00',NULL,NULL,NULL),('1424991092801052673',NULL,'1424991092801052673',2,1,NULL,'15359845632','724984','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-10 15:08:46',NULL,NULL,NULL,'2021-08-10 15:08:46',NULL,NULL,NULL),('1425008417025597441',NULL,'1425008417025597441',2,1,NULL,'19184577761','013214','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-10 16:17:36',NULL,NULL,NULL,'2021-08-10 16:17:36',NULL,NULL,NULL),('1425259377987723265',NULL,'1425259377987723265',2,1,NULL,'13599161367','695401','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-11 08:54:50',NULL,NULL,NULL,'2021-08-11 08:54:50',NULL,NULL,NULL),('1425260677014003714','1211120827064496130','1425260677014003714',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677030780930','1211559758373371905','1425260677030780930',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677051752449','1211092856509411330','1425260677051752449',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677425045506','58','1425260677425045506',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677454405633','1211529007779069954','1425260677454405633',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677454405634','1212685717864517633','1425260677454405634',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677454405635','1211167966465470465','1425260677454405635',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677462794241','58','1425260677462794241',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677576040449','83','1425260677576040449',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677731229697','1211837849989595138','1425260677731229697',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677764784130','1213844233778122754','1425260677764784130',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677773172737','87','1425260677773172737',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677882224642','87','1425260677882224642',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677882224643','1211441648983130114','1425260677882224643',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677928361985','1219451161745080321','1425260677928361985',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677978693633','102','1425260677978693633',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677978693634','1216559724997144578','1425260677978693634',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678070968322','1211461407799820290','1425260678070968322',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678079356930','102','1425260678079356930',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678129688578','1274912838720167938','1425260678129688578',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678247129089','1211473406755651586','1425260678247129089',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678381346817','1286499346338045953','1425260678381346817',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678452649986','1211474926804975617','1425260678452649986',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678599450625','1316201027820630017','1425260678599450625',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678620422146','1211515979058692097','1425260678620422146',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678809165826','1211559758373371905','1425260678809165826',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260678997909505','1211837849989595138','1425260678997909505',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260679186653186','1212910711521480705','1425260679186653186',2,2,'泉州恒毅机械有限公司','15750998817','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260679367008258','1213032291266269186','1425260679367008258',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260679564140545','1216568840104734722','1425260679564140545',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260679744495618','1219253246086995969','1425260679744495618',2,2,'泉州市勾勾手电子商务有限公司','13959737339','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260679962599425','1286499346338045953','1425260679962599425',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260680184897538','1295900371603947522','1425260680184897538',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260680403001345','1300227590451228674','1425260680403001345',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260680600133633','1348924009986654209','1425260680600133633',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:00',NULL,NULL,NULL,'2021-08-11 09:00:00',NULL,NULL,NULL),('1425260680822431745','1351830895278948354','1425260680822431745',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:01',NULL,NULL,NULL,'2021-08-11 09:00:01',NULL,NULL,NULL),('1425260681023758338','1374554432229978113','1425260681023758338',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:01',NULL,NULL,NULL,'2021-08-11 09:00:01',NULL,NULL,NULL),('1425260681241862145','1413335484670713858','1425260681241862145',2,2,'晋江市晋尚资产运营有限公司','13276083102','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:01',NULL,NULL,NULL,'2021-08-11 09:00:01',NULL,NULL,NULL),('1425260681455771649','1421017982661844994','1425260681455771649',2,2,'泉州步致新材料科技有限公司','13960373960','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:01',NULL,NULL,NULL,'2021-08-11 09:00:01',NULL,NULL,NULL),('1425260681724207106','1423483722950287362','1425260681724207106',2,2,'晋江市中德顺机械有限公司','13960255305','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-11 09:00:01',NULL,NULL,NULL,'2021-08-11 09:00:01',NULL,NULL,NULL),('1425289816035074049',NULL,'1425289816035074049',2,1,NULL,'13505986964','731252','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-11 10:55:47',NULL,NULL,NULL,'2021-08-11 10:55:47',NULL,NULL,NULL),('1425390660185268225',NULL,'1425390657270226945',2,2,'侯岩松','18850012081','18850012081,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660193656833',NULL,'1425390657270226945',2,2,'郑钦龙','13514063629','13514063629,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660193656834',NULL,'1425390657270226945',2,2,'黄少川','13805022370','13805022370,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660197851138',NULL,'1425390657270226945',2,2,'徐文贵','13459488725','13459488725,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660197851139',NULL,'1425390657270226945',2,2,'陈锟','15215196737','15215196737,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660197851140',NULL,'1425390657270226945',2,2,'林俊宇','15059155017','15059155017,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660202045442',NULL,'1425390657270226945',2,2,'聂保威','18629312652','18629312652,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660202045443',NULL,'1425390657270226945',2,2,'罗友志','15659708095','15659708095,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660202045444',NULL,'1425390657270226945',2,2,'陈笋弘','13155165477','13155165477,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660206239746',NULL,'1425390657270226945',2,2,'陈恒泽','18050888123','18050888123,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660206239747',NULL,'1425390657270226945',2,2,'李明修','18505211876','18505211876,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660206239748',NULL,'1425390657270226945',2,2,'凃羽贤','13023053216','13023053216,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660210434050',NULL,'1425390657270226945',2,2,'上官明沁','18860015293','18860015293,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660210434051',NULL,'1425390657270226945',2,2,'张河健','15306982536','15306982536,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660214628354',NULL,'1425390657270226945',2,2,'司马德文','18150155696','18150155696,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660214628355',NULL,'1425390657270226945',2,2,'郭英雄','13625035686','13625035686,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660214628356',NULL,'1425390657270226945',2,2,'金晶莹','15160388662','15160388662,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660218822657',NULL,'1425390657270226945',2,2,'龚明杰','15927005094','15927005094,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660218822658',NULL,'1425390657270226945',2,2,'毛嘉辉','18706789006','18706789006,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660218822659',NULL,'1425390657270226945',2,2,'姚培芬','15659116352','15659116352,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660227211266',NULL,'1425390657270226945',2,2,'张悦','13022955975','13022955975,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660227211267',NULL,'1425390657270226945',2,2,'吕承洵','13691780986','13691780986,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660227211268',NULL,'1425390657270226945',2,2,'明自强','18250710629','18250710629,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660227211269',NULL,'1425390657270226945',2,2,'陈志伟','18050010700','18050010700,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660231405569',NULL,'1425390657270226945',2,2,'黄文旭','15005990517','15005990517,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660231405570',NULL,'1425390657270226945',2,2,'梁毅浩','13260673693','13260673693,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660231405571',NULL,'1425390657270226945',2,2,'段瑞明','15259121562','15259121562,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660231405572',NULL,'1425390657270226945',2,2,'徐美珍','17720805836','17720805836,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660231405573',NULL,'1425390657270226945',2,2,'陈惠敏','18101825231','18101825231,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660231405574',NULL,'1425390657270226945',2,2,'李文焰','18396533731','18396533731,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660231405575',NULL,'1425390657270226945',2,2,'李武祥','18261770980','18261770980,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660340457474',NULL,'1425390657270226945',2,2,'朱冬祥','18297988539','18297988539,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660344651777',NULL,'1425390657270226945',2,2,'吴冈','18297988539','18297988539,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',1,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660344651778',NULL,'1425390657270226945',2,2,'李恒梅','13173047621','13173047621,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660344651779',NULL,'1425390657270226945',2,2,'俞露兵','18305919285','18305919285,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660348846081',NULL,'1425390657270226945',2,2,'颜如彩','13067202598','13067202598,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660348846082',NULL,'1425390657270226945',2,2,'刘强','18020739958','18020739958,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660348846083',NULL,'1425390657270226945',2,2,'黄仕璋','13056022180','13056022180,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660348846084',NULL,'1425390657270226945',2,2,'赵国文','15141152891','15141152891,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660348846085',NULL,'1425390657270226945',2,2,'戴灿发','13735238572','13735238572,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660353040385',NULL,'1425390657270226945',2,2,'柯少杰','15603329518','15603329518,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660353040386',NULL,'1425390657270226945',2,2,'许培育','15396282018','15396282018,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660353040387',NULL,'1425390657270226945',2,2,'周生晖','15500620915','15500620915,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660353040388',NULL,'1425390657270226945',2,2,'李洪旭','18604025790','18604025790,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660357234689',NULL,'1425390657270226945',2,2,'蔡其鹏','18850041996','18850041996,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660357234690',NULL,'1425390657270226945',2,2,'朱勇杰','18382435545','18382435545,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660357234691',NULL,'1425390657270226945',2,2,'邬靖','15016766570','15016766570,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660361428993',NULL,'1425390657270226945',2,2,'汪善贵','15759808980','15759808980,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660361428994',NULL,'1425390657270226945',2,2,'周其锋','13098841705','13098841705,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660365623297',NULL,'1425390657270226945',2,2,'王彦博','13859757591','13859757591,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660365623298',NULL,'1425390657270226945',2,2,'董晨浩','18239841996','18239841996,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',2,'黑名单','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660365623299',NULL,'1425390657270226945',2,2,'黄静','14730332878','14730332878,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660369817601',NULL,'1425390657270226945',2,2,'曾智浩','15705902768','15705902768,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660369817602',NULL,'1425390657270226945',2,2,'林宝泉','18016722859','18016722859,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660369817603',NULL,'1425390657270226945',2,2,'邱艺伟','13950092413','13950092413,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660374011905',NULL,'1425390657270226945',2,2,'林烺锋','15305043292','15305043292,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660374011906',NULL,'1425390657270226945',2,2,'张剑雄','19959860166','19959860166,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660378206209',NULL,'1425390657270226945',2,2,'傅恬','13666096468','13666096468,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660378206210',NULL,'1425390657270226945',2,2,'周芷伊','13129902742','13129902742,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660382400513',NULL,'1425390657270226945',2,2,'蔡美君','15105970853','15105970853,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660382400514',NULL,'1425390657270226945',2,2,'徐浩川','18960637781','18960637781,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660449509377',NULL,'1425390657270226945',2,2,'曾旭烽','15059552779','15059552779,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660453703681',NULL,'1425390657270226945',2,2,'林晓鑫','15359143992','15359143992,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660453703682',NULL,'1425390657270226945',2,2,'刘乃源','13359175187','13359175187,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660457897986',NULL,'1425390657270226945',2,2,'潘瑶琪','13075807594','13075807594,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660457897987',NULL,'1425390657270226945',2,2,'黄佩琼','18314674206','18314674206,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660457897988',NULL,'1425390657270226945',2,2,'李彩红','18876503813','18876503813,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660457897989',NULL,'1425390657270226945',2,2,'郭博庚','15715930918','15715930918,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660462092289',NULL,'1425390657270226945',2,2,'陈炳旭','15629112651','15629112651,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660462092290',NULL,'1425390657270226945',2,2,'苏浚翔','13675986678','13675986678,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660462092291',NULL,'1425390657270226945',2,2,'沈洪','13950093564','13950093564,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660462092292',NULL,'1425390657270226945',2,2,'吴宗祐','18605170115','18605170115,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660462092293',NULL,'1425390657270226945',2,2,'黄阿智','18050679194','18050679194,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660466286593',NULL,'1425390657270226945',2,2,'刘利晨','13225070039','13225070039,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390660466286594',NULL,'1425390657270226945',2,2,'Sun Lizhong','13812752721','13812752721,晋江市集成电路产业优秀人才认定,福建省集成电路产业园建设筹备工作组及企业内部,2021年08月11日,2021年08月17日,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:36:29',NULL,NULL,NULL,'2021-08-11 17:36:29',NULL,NULL,NULL),('1425390834177581058',NULL,'1425390833770733570',2,2,'刘安淇','13030983621','13030983621,晋江市集成电路产业优秀人才层次变更,福建省集成电路产业园建设筹备工作组及企业内部,2021-08-11,2021-08-17,福建省集成电路产业园建设筹备工作组,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-11 17:37:11',NULL,NULL,NULL,'2021-08-11 17:37:11',NULL,NULL,NULL),('1425623064766357505','1211092856509411330','1425623064766357505',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623064812494850','1211559758373371905','1425623064812494850',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623064854437890','1211120827064496130','1425623064854437890',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065097707521','58','1425623065097707521',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065122873345','58','1425623065122873345',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065127067650','83','1425623065127067650',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065240313858','1212685717864517633','1425623065240313858',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065257091073','1211167966465470465','1425623065257091073',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065282256897','1211529007779069954','1425623065282256897',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065416474626','87','1425623065416474626',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065420668929','87','1425623065420668929',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065437446145','1213844233778122754','1425623065437446145',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065466806274','1211441648983130114','1425623065466806274',2,2,'兴业皮革科技股份有限公司','18859716647','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065479389185','1211837849989595138','1425623065479389185',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065613606914','102','1425623065613606914',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065634578433','102','1425623065634578433',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065651355649','1216559724997144578','1425623065651355649',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065689104385','1211461407799820290','1425623065689104385',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065705881601','1219451161745080321','1425623065705881601',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065949151233','1211473406755651586','1425623065949151233',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065961734145','1274912838720167938','1425623065961734145',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623066163060737','1286499346338045953','1425623066163060737',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623066205003778','1211474926804975617','1425623066205003778',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623066360193026','1316201027820630017','1425623066360193026',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623066435690497','1211515979058692097','1425623066435690497',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623066616045569','1211559758373371905','1425623066616045569',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623066796400641','1211837849989595138','1425623066796400641',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623066976755714','1213032291266269186','1425623066976755714',2,2,'福建优安纳伞业科技有限公司','15959508318','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623067152916481','1216568840104734722','1425623067152916481',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623067333271553','1286499346338045953','1425623067333271553',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623067526209537','1295900371603947522','1425623067526209537',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623067735924737','1300227590451228674','1425623067735924737',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623067987582978','1348924009986654209','1425623067987582978',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623068193103873','1351830895278948354','1425623068193103873',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623068386041858','1374554432229978113','1425623068386041858',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:00',NULL,NULL,NULL,'2021-08-12 09:00:00',NULL,NULL,NULL),('1425623068604145666','1413335484670713858','1425623068604145666',2,2,'晋江市晋尚资产运营有限公司','13276083102','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:01',NULL,NULL,NULL,'2021-08-12 09:00:01',NULL,NULL,NULL),('1425623068855803905','1423483722950287362','1425623068855803905',2,2,'晋江市中德顺机械有限公司','13960255305','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-12 09:00:01',NULL,NULL,NULL,'2021-08-12 09:00:01',NULL,NULL,NULL),('1425659495333232642',NULL,'1425659495333232642',2,1,NULL,'13163991887','898925','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-12 11:24:45',NULL,NULL,NULL,'2021-08-12 11:24:45',NULL,NULL,NULL),('1425660181601058817',NULL,'1425660181601058817',2,1,NULL,'15959552877','876836','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-12 11:27:29',NULL,NULL,NULL,'2021-08-12 11:27:29',NULL,NULL,NULL),('1425673192877326337',NULL,'1425673192877326337',2,1,NULL,'13599298229','587351','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-12 12:19:11',NULL,NULL,NULL,'2021-08-12 12:19:11',NULL,NULL,NULL),('1425673448780201986',NULL,'1425673448780201986',2,1,NULL,'13599298229','440394','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-12 12:20:12',NULL,NULL,NULL,'2021-08-12 12:20:12',NULL,NULL,NULL),('1425674276660314113',NULL,'1425674276660314113',2,1,NULL,'13599298229','030471','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-12 12:23:29',NULL,NULL,NULL,'2021-08-12 12:23:29',NULL,NULL,NULL),('1425724614041927682','1425660338317033473','1425724614041927682',2,2,'晋江德源技术检测有限公司','15959552877','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-12 15:43:31',NULL,NULL,NULL,'2021-08-12 15:43:31',NULL,NULL,NULL),('1425750449478172673',NULL,'1425750449478172673',2,1,NULL,'15880769738','723710','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-12 17:26:10',NULL,NULL,NULL,'2021-08-12 17:26:10',NULL,NULL,NULL),('1425756833888337922',NULL,'1425756833888337922',2,1,NULL,'18606980726','122371','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-12 17:51:33',NULL,NULL,NULL,'2021-08-12 17:51:33',NULL,NULL,NULL),('1425984392362196993',NULL,'1425984392362196993',2,1,NULL,'13600745760','498920','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-13 08:55:47',NULL,NULL,NULL,'2021-08-13 08:55:47',NULL,NULL,NULL),('1425985327293530114',NULL,'1425985327293530114',2,1,NULL,'13505099555','962003','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-13 08:59:30',NULL,NULL,NULL,'2021-08-13 08:59:30',NULL,NULL,NULL),('1425985452774522881','1211120827064496130','1425985452774522881',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985452795494402','1211092856509411330','1425985452795494402',2,2,'晋江市鑫腾连盛机械有限公司','15759732363','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985452858408961','1211559758373371905','1425985452858408961',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453269450753','1211167966465470465','1425985453269450753',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453277839361','1211529007779069954','1425985453277839361',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453298810881','58','1425985453298810881',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453332365314','58','1425985453332365314',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453512720385','1212685717864517633','1425985453512720385',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453546274817','1211461407799820290','1425985453546274817',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453567246338','83','1425985453567246338',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453680492545','87','1425985453680492545',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453684686849','1211837849989595138','1425985453684686849',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453751795713','87','1425985453751795713',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453915373569','1213844233778122754','1425985453915373569',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453948928002','102','1425985453948928002',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453995065346','1211473406755651586','1425985453995065346',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454062174210','1219451161745080321','1425985454062174210',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454175420417','1216559724997144578','1425985454175420417',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454183809025','102','1425985454183809025',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454376747010','1211474926804975617','1425985454376747010',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454397718529','1274912838720167938','1425985454397718529',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454624210945','1286499346338045953','1425985454624210945',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454741651458','1211515979058692097','1425985454741651458',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454825537538','1316201027820630017','1425985454825537538',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985454993309698','1211559758373371905','1425985454993309698',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985455207219201','1216568840104734722','1425985455207219201',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985455391768577','1286499346338045953','1425985455391768577',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985455639232513','1295900371603947522','1425985455639232513',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985455882502145','1300227590451228674','1425985455882502145',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985456121577473','1348924009986654209','1425985456121577473',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985456331292673','1351830895278948354','1425985456331292673',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:00',NULL,NULL,NULL,'2021-08-13 09:00:00',NULL,NULL,NULL),('1425985456557785090','1374554432229978113','1425985456557785090',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:01',NULL,NULL,NULL,'2021-08-13 09:00:01',NULL,NULL,NULL),('1425985456733945857','1423483722950287362','1425985456733945857',2,2,'晋江市中德顺机械有限公司','13960255305','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-13 09:00:01',NULL,NULL,NULL,'2021-08-13 09:00:01',NULL,NULL,NULL),('1425988382663639042','1425751100266381313','1425988382663639042',2,2,'泉州三基设创意设计有限公司','15880769738','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-13 09:11:38',NULL,NULL,NULL,'2021-08-13 09:11:38',NULL,NULL,NULL),('1425988834570534913','1425985408453312513','1425988834570534913',2,2,'福建腾盈贸易有限公司','13505099555','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-13 09:13:26',NULL,NULL,NULL,'2021-08-13 09:13:26',NULL,NULL,NULL),('1425990277645991938',NULL,'1425990277645991938',2,1,NULL,'15191454197','514567','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-13 09:19:10',NULL,NULL,NULL,'2021-08-13 09:19:10',NULL,NULL,NULL),('1425991091139641346',NULL,'1425991091139641346',2,1,NULL,'13808540512','794701','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-13 09:22:24',NULL,NULL,NULL,'2021-08-13 09:22:24',NULL,NULL,NULL),('1426005033492676609',NULL,'1426005033492676609',2,1,NULL,'15960417947','734046','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-13 10:17:48',NULL,NULL,NULL,'2021-08-13 10:17:48',NULL,NULL,NULL),('1426006784748814338',NULL,'1426006784748814338',2,1,NULL,'13502099671','050990','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',2,'移动停机或关机','2021-08-13 10:24:46',NULL,NULL,NULL,'2021-08-13 10:24:46',NULL,NULL,NULL),('1426007193999638530',NULL,'1426007193999638530',2,1,NULL,'13506099671','686986','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-13 10:26:23',NULL,NULL,NULL,'2021-08-13 10:26:23',NULL,NULL,NULL),('1426008677449465857','1426007262022860802','1426008677449465857',2,2,'福建普斯特服饰有限公司','13506099671','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-13 10:32:17',NULL,NULL,NULL,'2021-08-13 10:32:17',NULL,NULL,NULL),('1426009695918751745','1426007262022860802','1426009695918751745',2,2,'福建普斯特服饰有限公司','15960417947','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-13 10:36:20',NULL,NULL,NULL,'2021-08-13 10:36:20',NULL,NULL,NULL),('1426426591331745794',NULL,'1426426591331745794',2,1,NULL,'15027340243','901443','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-14 14:12:55',NULL,NULL,NULL,'2021-08-14 14:12:55',NULL,NULL,NULL),('1426567534550712322',NULL,'1426567534550712322',2,1,NULL,'17750513690','732657','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-14 23:32:59',NULL,NULL,NULL,'2021-08-14 23:32:59',NULL,NULL,NULL),('1426872440457265154',NULL,'1426872440457265154',2,1,NULL,'13735238572','192950','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-15 19:44:34',NULL,NULL,NULL,'2021-08-15 19:44:34',NULL,NULL,NULL),('1427072616442626050','1211559758373371905','1427072616442626050',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616463597569','1211120827064496130','1427072616463597569',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616484569090','1211167966465470465','1427072616484569090',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616627175425','58','1427072616627175425',1,2,'张荣荣','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616941748225','58','1427072616941748225',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616966914049','1211461407799820290','1427072616966914049',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616966914050','83','1427072616966914050',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616992079873','1211529007779069954','1427072616992079873',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616992079874','87','1427072616992079874',1,2,'叶志钦','13675957398','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616992079875','1212685717864517633','1427072616992079875',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617172434945','87','1427072617172434945',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617239543810','1211473406755651586','1427072617239543810',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617264709634','102','1427072617264709634',1,2,'颜思思','15280619456','4,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617268903938','1213844233778122754','1427072617268903938',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617369567233','1211837849989595138','1427072617369567233',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617415704577','102','1427072617415704577',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617537339394','1211474926804975617','1427072617537339394',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617558310913','1216559724997144578','1427072617558310913',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617675751425','1219451161745080321','1427072617675751425',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617906438146','1211515979058692097','1427072617906438146',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072617956769794','1274912838720167938','1427072617956769794',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072618090987521','1211559758373371905','1427072618090987521',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072618413948930','1286499346338045953','1427072618413948930',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072618443309057','1216568840104734722','1427072618443309057',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072618736910338','1316201027820630017','1427072618736910338',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072618736910339','1286499346338045953','1427072618736910339',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072618925654018','1295900371603947522','1427072618925654018',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072619126980609','1300227590451228674','1427072619126980609',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072619311529985','1348924009986654209','1427072619311529985',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072619491885057','1351830895278948354','1427072619491885057',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427072619760320513','1374554432229978113','1427072619760320513',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:00:00',NULL,NULL,NULL,'2021-08-16 09:00:00',NULL,NULL,NULL),('1427076705150828545','1426427197811326978','1427076705150828545',2,2,'灰犀牛(泉州)医疗科技有限公司','15027340243','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-16 09:16:14',NULL,NULL,NULL,'2021-08-16 09:16:14',NULL,NULL,NULL),('1427078803640811521',NULL,'1427078803640811521',2,1,NULL,'15260603621','600611','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-16 09:24:35',NULL,NULL,NULL,'2021-08-16 09:24:35',NULL,NULL,NULL),('1427079279874670594','1426567622584958978','1427079279874670594',2,2,'晋江镱锶润商贸有限公司','17750513690','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-16 09:26:28',NULL,NULL,NULL,'2021-08-16 09:26:28',NULL,NULL,NULL),('1427101458922209282','1211442194934710274','1427101458922209282',2,2,'信泰(福建)科技有限公司','15027340243','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-16 10:54:36',NULL,NULL,NULL,'2021-08-16 10:54:36',NULL,NULL,NULL),('1427101502459084801','1211444027140915202','1427101502459084801',2,2,'福建省万物智联科技有限公司','15027340243','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-16 10:54:47',NULL,NULL,NULL,'2021-08-16 10:54:47',NULL,NULL,NULL),('1427101531915681793','1374975706999595010','1427101531915681793',2,2,'向维智联(福建)科技有限公司','15027340243','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-16 10:54:54',NULL,NULL,NULL,'2021-08-16 10:54:54',NULL,NULL,NULL),('1427111937392508929',NULL,'1427111937392508929',2,1,NULL,'15861163272','986954','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-16 11:36:14',NULL,NULL,NULL,'2021-08-16 11:36:14',NULL,NULL,NULL),('1427136334014709762',NULL,'1427136334014709762',2,1,NULL,'13788844879','537571','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-16 13:13:11',NULL,NULL,NULL,'2021-08-16 13:13:11',NULL,NULL,NULL),('1427153532057812994',NULL,'1427153532057812994',2,1,NULL,'15960555772','905037','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-16 14:21:31',NULL,NULL,NULL,'2021-08-16 14:21:31',NULL,NULL,NULL),('1427168091317469186','1425991153320198145','1427168091317469186',2,2,'中轻检验认证(晋江)有限公司','13808540512','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-16 15:19:23',NULL,NULL,NULL,'2021-08-16 15:19:23',NULL,NULL,NULL),('1427170060023103490','1427153868201918465','1427170060023103490',2,2,'晋江市天守服装织造有限公司','15960555772','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-16 15:27:12',NULL,NULL,NULL,'2021-08-16 15:27:12',NULL,NULL,NULL),('1427435004245311489','1211167966465470465','1427435004245311489',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004262088705','1211559758373371905','1427435004262088705',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004278865922','1212665763958165505','1427435004278865922',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004287254530','1211120827064496130','1427435004287254530',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004694102017','1212685717864517633','1427435004694102017',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004694102018','1211461407799820290','1427435004694102018',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004727656450','1211529007779069954','1427435004727656450',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004773793794','58','1427435004773793794',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004824125441','72','1427435004824125441',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004945760258','83','1427435004945760258',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005067395074','1211473406755651586','1427435005067395074',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005071589377','1213844233778122754','1427435005071589377',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005071589378','87','1427435005071589378',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005084172290','1211837849989595138','1427435005084172290',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005176446977','58','1427435005176446977',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005293887489','102','1427435005293887489',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005340024834','1216559724997144578','1427435005340024834',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005365190657','1211474926804975617','1427435005365190657',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005369384962','1219451161745080321','1427435005369384962',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005444882434','87','1427435005444882434',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005574905858','1274912838720167938','1427435005574905858',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005600071682','1211490446086291458','1427435005600071682',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005642014721','102','1427435005642014721',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005780426753','1286499346338045953','1427435005780426753',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435005788815362','1211515979058692097','1427435005788815362',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435006032084993','1316201027820630017','1427435006032084993',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435006032084994','1211840469537964033','1427435006032084994',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435006212440065','1216568840104734722','1427435006212440065',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435006384406529','1286499346338045953','1427435006384406529',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435006568955905','1295900371603947522','1427435006568955905',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435006782865409','1348924009986654209','1427435006782865409',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435007055495170','1351830895278948354','1427435007055495170',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435007281987585','1374554432229978113','1427435007281987585',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427435007500091393','1424670155656437762','1427435007500091393',2,2,'福建省扬远环保科技有限公司','13600777770','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-17 09:00:00',NULL,NULL,NULL,'2021-08-17 09:00:00',NULL,NULL,NULL),('1427472949304098818',NULL,'1427472949304098818',2,1,NULL,'15252343476','793835','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-17 11:30:46',NULL,NULL,NULL,'2021-08-17 11:30:46',NULL,NULL,NULL),('1427478196206436353',NULL,'1427478196206436353',2,1,NULL,'13030997371','012224','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-17 11:51:37',NULL,NULL,NULL,'2021-08-17 11:51:37',NULL,NULL,NULL),('1427534032916185089',NULL,'1427534032916185089',2,1,NULL,'18065355372','293575','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-17 15:33:30',NULL,NULL,NULL,'2021-08-17 15:33:30',NULL,NULL,NULL),('1427570398525915137','1427478255639724034','1427570398525915137',2,2,'晋江市达亿经编织造有限公司','13030997371','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-17 17:58:00',NULL,NULL,NULL,'2021-08-17 17:58:00',NULL,NULL,NULL),('1427570460270264322','1426427197811326978','1427570460270264322',2,2,'灰犀牛(泉州)医疗科技有限公司','150273402423','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2021-08-17 17:58:15',NULL,NULL,NULL,'2021-08-17 17:58:15',NULL,NULL,NULL),('1427581215094865922',NULL,'1427581215094865922',2,1,NULL,'13110535732','955310','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-17 18:40:59',NULL,NULL,NULL,'2021-08-17 18:40:59',NULL,NULL,NULL),('1427797392043802626','1211167966465470465','1427797392043802626',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392089939970','1212665763958165505','1427797392089939970',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392094134273','1211559758373371905','1427797392094134273',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392144465921','1211120827064496130','1427797392144465921',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392438067202','72','1427797392438067202',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392450650114','58','1427797392450650114',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392488398849','83','1427797392488398849',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392530341890','1212685717864517633','1427797392530341890',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392530341891','1211461407799820290','1427797392530341891',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392551313409','1211529007779069954','1427797392551313409',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392706502657','58','1427797392706502657',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392719085569','87','1427797392719085569',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392761028610','1211473406755651586','1427797392761028610',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392811360257','1211837849989595138','1427797392811360257',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392811360258','1213844233778122754','1427797392811360258',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392949772289','102','1427797392949772289',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392949772290','87','1427797392949772290',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392983326722','1211474926804975617','1427797392983326722',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393054629890','1216559724997144578','1427797393054629890',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393058824194','1219451161745080321','1427797393058824194',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393193041921','102','1427797393193041921',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393226596353','1211490446086291458','1427797393226596353',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393247567873','1218097536540147714','1427797393247567873',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393264345090','1274912838720167938','1427797393264345090',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393436311554','1286499346338045953','1427797393436311554',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393440505857','1211515979058692097','1427797393440505857',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393847353346','1211559758373371905','1427797393847353346',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797393851547650','1316201027820630017','1427797393851547650',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797394036097026','1216537288914268162','1427797394036097026',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797394220646402','1216568840104734722','1427797394220646402',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797394421972993','1286499346338045953','1427797394421972993',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797394606522370','1290850604855361537','1427797394606522370',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797394853986305','1295900371603947522','1427797394853986305',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797395021758465','1300227590451228674','1427797395021758465',2,2,'晋江劲拓体育有限公司','13489708373','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797395193724929','1348924009986654209','1427797395193724929',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797395395051522','1351830895278948354','1427797395395051522',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797395613155330','1374554432229978113','1427797395613155330',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:00',NULL,NULL,NULL,'2021-08-18 09:00:00',NULL,NULL,NULL),('1427797395948699649','1423864261142159361','1427797395948699649',2,2,'婴舒宝(中国)有限公司','18650901983','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:01',NULL,NULL,NULL,'2021-08-18 09:00:01',NULL,NULL,NULL),('1427797396259078145','1424670155656437762','1427797396259078145',2,2,'福建省扬远环保科技有限公司','13600777770','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:01',NULL,NULL,NULL,'2021-08-18 09:00:01',NULL,NULL,NULL),('1427797396561068033','1425751100266381313','1427797396561068033',2,2,'泉州三基设创意设计有限公司','15880769738','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-18 09:00:01',NULL,NULL,NULL,'2021-08-18 09:00:01',NULL,NULL,NULL),('1427840623695679490',NULL,'1427840623695679490',2,1,NULL,'15059821270','827735','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-18 11:51:47',NULL,NULL,NULL,'2021-08-18 11:51:47',NULL,NULL,NULL),('1427840874213068801',NULL,'1427840874213068801',2,1,NULL,'13055559656','280250','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-18 11:52:47',NULL,NULL,NULL,'2021-08-18 11:52:47',NULL,NULL,NULL),('1427878370921730050',NULL,'1427878370921730050',2,1,NULL,'15860578888','648105','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-18 14:21:46',NULL,NULL,NULL,'2021-08-18 14:21:46',NULL,NULL,NULL),('1427879087124303874',NULL,'1427879087124303874',2,1,NULL,'13636909688','520782','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',2,'未知错误','2021-08-18 14:24:37',NULL,NULL,NULL,'2021-08-18 14:24:37',NULL,NULL,NULL),('1427909873097560066',NULL,'1427909873097560066',2,1,NULL,'17750513690','715874','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-18 16:26:57',NULL,NULL,NULL,'2021-08-18 16:26:57',NULL,NULL,NULL),('1428159779972370434','1211559758373371905','1428159779972370434',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780035284993','1212665763958165505','1428159780035284993',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780077228033','1211167966465470465','1428159780077228033',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780148531202','1211120827064496130','1428159780148531202',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780446326785','72','1428159780446326785',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780458909698','58','1428159780458909698',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780458909699','83','1428159780458909699',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780479881218','1211529007779069954','1428159780479881218',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780479881219','1211461407799820290','1428159780479881219',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780479881220','1212685717864517633','1428159780479881220',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780760899586','58','1428159780760899586',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780765093889','87','1428159780765093889',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780765093890','1211473406755651586','1428159780765093890',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780958031874','1213844233778122754','1428159780958031874',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781025140738','102','1428159781025140738',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781025140739','87','1428159781025140739',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781025140740','1211474926804975617','1428159781025140740',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781033529345','1211837849989595138','1428159781033529345',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781201301506','1216559724997144578','1428159781201301506',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781213884418','102','1428159781213884418',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781218078722','1211490446086291458','1428159781218078722',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781218078723','1219451161745080321','1428159781218078723',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781431988225','1218097536540147714','1428159781431988225',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781431988226','1211515979058692097','1428159781431988226',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781457154050','1274912838720167938','1428159781457154050',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781666869250','1212930279740608514','1428159781666869250',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781683646466','1286499346338045953','1428159781683646466',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781855612930','1216537288914268162','1428159781855612930',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159781910138881','1316201027820630017','1428159781910138881',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159782048550913','1216568840104734722','1428159782048550913',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159782270849026','1286499346338045953','1428159782270849026',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159782472175618','1290850604855361537','1428159782472175618',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159782669307905','1295900371603947522','1428159782669307905',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159782899994625','1348924009986654209','1428159782899994625',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159783126487042','1351830895278948354','1428159783126487042',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428159783311036417','1374554432229978113','1428159783311036417',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 09:00:00',NULL,NULL,NULL,'2021-08-19 09:00:00',NULL,NULL,NULL),('1428173197416648705',NULL,'1428173197416648705',2,1,NULL,'18905070905','818106','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-19 09:53:19',NULL,NULL,NULL,'2021-08-19 09:53:19',NULL,NULL,NULL),('1428177378512785410','1211482027447074818','1428177378512785410',2,2,'福建晋江天然气发电有限公司','18876398522','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-19 10:09:55',NULL,NULL,NULL,'2021-08-19 10:09:55',NULL,NULL,NULL),('1428177730612023297',NULL,'1428177730612023297',2,1,NULL,'18905070905','388624','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-19 10:11:19',NULL,NULL,NULL,'2021-08-19 10:11:19',NULL,NULL,NULL),('1428187294199762946','1428178535431852034','1428187294199762946',2,2,'晋江标普质量技术服务有限公司','18905070905','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-19 10:49:20',NULL,NULL,NULL,'2021-08-19 10:49:20',NULL,NULL,NULL),('1428256652146036738','1427136557067796481','1428256652146036738',2,2,'晋江市内坑镇宅内村第一卫生所','13788844879','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-19 15:24:56',NULL,NULL,NULL,'2021-08-19 15:24:56',NULL,NULL,NULL),('1428279577431560194','1289035100629032961','1428279577431560194',2,2,'中国电信股份有限公司晋江分公司','18120695050','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-19 16:56:02',NULL,NULL,NULL,'2021-08-19 16:56:02',NULL,NULL,NULL),('1428521001381056513','1427136557067796481','1428521001381056513',2,2,'晋江市内坑镇宅内村第一卫生所','13788844879','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-20 08:55:22',NULL,NULL,NULL,'2021-08-20 08:55:22',NULL,NULL,NULL),('1428522167724724226','1212665763958165505','1428522167724724226',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167737307137','1211559758373371905','1428522167737307137',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167770861570','1211120827064496130','1428522167770861570',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167825387522','1211167966465470465','1428522167825387522',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167934439425','58','1428522167934439425',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168072851458','58','1428522168072851458',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168173514754','1211461407799820290','1428522168173514754',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168173514755','1420924342417514497','1428522168173514755',2,2,'福建灵雀谷生物科技有限公司','15392079089','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168173514756','1211529007779069954','1428522168173514756',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168173514757','1212685717864517633','1428522168173514757',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168249012226','87','1428522168249012226',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168349675522','87','1428522168349675522',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168374841346','1211837849989595138','1428522168374841346',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168433561602','1211473406755651586','1428522168433561602',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168483893249','102','1428522168483893249',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168496476162','1213844233778122754','1428522168496476162',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168542613505','102','1428522168542613505',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168597139458','1211474926804975617','1428522168597139458',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168655859714','1219451161745080321','1428522168655859714',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168743940097','1216559724997144578','1428522168743940097',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168861380610','1211490446086291458','1428522168861380610',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168886546434','1274912838720167938','1428522168886546434',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522168903323649','1218097536540147714','1428522168903323649',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522169054318593','1211515979058692097','1428522169054318593',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522169058512898','1286499346338045953','1428522169058512898',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522169238867969','1316201027820630017','1428522169238867969',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522169243062274','1212930279740608514','1428522169243062274',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522169406640130','1215207699331989506','1428522169406640130',2,2,'晋江市医院','18350528526','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522169599578113','1216537288914268162','1428522169599578113',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522169851236353','1216568840104734722','1428522169851236353',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522170035785730','1286499346338045953','1428522170035785730',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522170203557890','1290850604855361537','1428522170203557890',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522170371330049','1295900371603947522','1428522170371330049',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522170543296513','1348924009986654209','1428522170543296513',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522170723651586','1351830895278948354','1428522170723651586',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522170950144002','1374554432229978113','1428522170950144002',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428522171143081985','1402819845443059714','1428522171143081985',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-20 09:00:00',NULL,NULL,NULL,'2021-08-20 09:00:00',NULL,NULL,NULL),('1428609768422952962',NULL,'1428609768422952962',2,1,NULL,'15394522217','522101','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-20 14:48:05',NULL,NULL,NULL,'2021-08-20 14:48:05',NULL,NULL,NULL),('1429609331308941313','1212665763958165505','1429609331308941313',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331392827394','1211120827064496130','1429609331392827394',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331405410306','1211559758373371905','1429609331405410306',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331518656513','1211167966465470465','1429609331518656513',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332143607809','58','1429609332143607809',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332156190722','1211529007779069954','1429609332156190722',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332189745153','58','1429609332189745153',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332240076801','1212685717864517633','1429609332240076801',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332340740097','1211461407799820290','1429609332340740097',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332374294529','87','1429609332374294529',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332391071746','1211837849989595138','1429609332391071746',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332458180610','87','1429609332458180610',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332491735041','1213844233778122754','1429609332491735041',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332554649602','1211473406755651586','1429609332554649602',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332563038209','102','1429609332563038209',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332634341377','102','1429609332634341377',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332722421761','1219451161745080321','1429609332722421761',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332722421762','1216559724997144578','1429609332722421762',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609332768559105','1211474926804975617','1429609332768559105',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333007634433','1218097536540147714','1429609333007634433',2,2,'福建浔兴拉链科技股份有限公司','13799855086','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333007634434','1274912838720167938','1429609333007634434',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333045383169','1211490446086291458','1429609333045383169',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333221543937','1286499346338045953','1429609333221543937',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333263486978','1211515979058692097','1429609333263486978',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333443842050','1316201027820630017','1429609333443842050',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333443842051','1212930279740608514','1429609333443842051',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333737443329','1216537288914268162','1429609333737443329',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609333951352833','1216568840104734722','1429609333951352833',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609334152679426','1286499346338045953','1429609334152679426',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609334479835138','1290850604855361537','1429609334479835138',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609334702133249','1295900371603947522','1429609334702133249',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609334911848450','1348924009986654209','1429609334911848450',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:00',NULL,NULL,NULL,'2021-08-23 09:00:00',NULL,NULL,NULL),('1429609335117369345','1351830895278948354','1429609335117369345',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:01',NULL,NULL,NULL,'2021-08-23 09:00:01',NULL,NULL,NULL),('1429609335348056065','1374554432229978113','1429609335348056065',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:01',NULL,NULL,NULL,'2021-08-23 09:00:01',NULL,NULL,NULL),('1429609335549382657','1402819845443059714','1429609335549382657',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:01',NULL,NULL,NULL,'2021-08-23 09:00:01',NULL,NULL,NULL),('1429609335742320641','1426567622584958978','1429609335742320641',2,2,'晋江镱锶润商贸有限公司','17750513690','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-23 09:00:01',NULL,NULL,NULL,'2021-08-23 09:00:01',NULL,NULL,NULL),('1429621267618648066',NULL,'1429621267618648066',2,1,NULL,'15880297290','789577','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-23 09:47:25',NULL,NULL,NULL,'2021-08-23 09:47:25',NULL,NULL,NULL),('1429971719199707138','1212665763958165505','1429971719199707138',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719203901442','1211559758373371905','1429971719203901442',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719254233089','1211120827064496130','1429971719254233089',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719258427394','1211167966465470465','1429971719258427394',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719476531202','58','1429971719476531202',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719602360322','58','1429971719602360322',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720009207810','1211461407799820290','1429971720009207810',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720009207811','87','1429971720009207811',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720013402114','87','1429971720013402114',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720017596418','1212685717864517633','1429971720017596418',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720038567938','1211529007779069954','1429971720038567938',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720231505921','102','1429971720231505921',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720256671746','1211473406755651586','1429971720256671746',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720269254658','102','1429971720269254658',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720269254659','1213844233778122754','1429971720269254659',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720269254660','1211837849989595138','1429971720269254660',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720462192642','1211474926804975617','1429971720462192642',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720474775553','1216559724997144578','1429971720474775553',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720483164162','1219451161745080321','1429971720483164162',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720650936322','1211490446086291458','1429971720650936322',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720650936323','1274912838720167938','1429971720650936323',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720856457218','1286499346338045953','1429971720856457218',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971720864845825','1212930279740608514','1429971720864845825',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971721049395202','1216537288914268162','1429971721049395202',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971721061978113','1316201027820630017','1429971721061978113',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971721238138881','1216568840104734722','1429971721238138881',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971721443659778','1286499346338045953','1429971721443659778',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971721632403458','1290850604855361537','1429971721632403458',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971721833730050','1295900371603947522','1429971721833730050',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971722106359809','1348924009986654209','1429971722106359809',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971722316075009','1351830895278948354','1429971722316075009',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971722580316161','1374554432229978113','1429971722580316161',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971722790031361','1402819845443059714','1429971722790031361',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:00',NULL,NULL,NULL,'2021-08-24 09:00:00',NULL,NULL,NULL),('1429971722974580737','1409682434043191297','1429971722974580737',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:01',NULL,NULL,NULL,'2021-08-24 09:00:01',NULL,NULL,NULL),('1429971723310125057','1413335484670713858','1429971723310125057',2,2,'晋江市晋尚资产运营有限公司','13276083102','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-24 09:00:01',NULL,NULL,NULL,'2021-08-24 09:00:01',NULL,NULL,NULL),('1429980847213170689',NULL,'1429980847213170689',2,1,NULL,'18450251231','534411','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-24 09:36:16',NULL,NULL,NULL,'2021-08-24 09:36:16',NULL,NULL,NULL),('1430111187374231554','1423864261142159361','1430111187374231554',2,2,'婴舒宝(中国)有限公司','18650901983','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-24 18:14:11',NULL,NULL,NULL,'2021-08-24 18:14:11',NULL,NULL,NULL),('1430334107094667266','1211167966465470465','1430334107094667266',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107119833089','1211559758373371905','1430334107119833089',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107124027393','1211120827064496130','1430334107124027393',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107144998914','1212665763958165505','1430334107144998914',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107421822977','58','1430334107421822977',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107451183105','58','1430334107451183105',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107463766017','83','1430334107463766017',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107539263490','1212685717864517633','1430334107539263490',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107539263491','1211461407799820290','1430334107539263491',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107560235009','1211529007779069954','1430334107560235009',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107681869825','87','1430334107681869825',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107711229954','87','1430334107711229954',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107774144514','1211837849989595138','1430334107774144514',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107778338818','1213844233778122754','1430334107778338818',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107883196417','102','1430334107883196417',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107883196418','1211473406755651586','1430334107883196418',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107887390721','102','1430334107887390721',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107950305282','1219451161745080321','1430334107950305282',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107979665409','1216559724997144578','1430334107979665409',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108050968577','1211474926804975617','1430334108050968577',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108134854657','1274912838720167938','1430334108134854657',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108151631873','1374554432229978113','1430334108151631873',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108235517953','1211515979058692097','1430334108235517953',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108315209729','1286499346338045953','1430334108315209729',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108411678721','1212930279740608514','1430334108411678721',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108499759106','1316201027820630017','1430334108499759106',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108575256578','1216537288914268162','1430334108575256578',2,2,'耀华园林股份有限公司','13959882723','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108747223041','1216568840104734722','1430334108747223041',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334108919189506','1241252588561698817','1430334108919189506',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334109128904705','1286499346338045953','1430334109128904705',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334109321842689','1290850604855361537','1430334109321842689',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334109514780674','1295900371603947522','1430334109514780674',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334109728690177','1348924009986654209','1430334109728690177',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334109904850946','1351830895278948354','1430334109904850946',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334110114566145','1374554432229978113','1430334110114566145',2,2,'福建省晋华集成电路有限公司','15059820805','9,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334110324281346','1402819845443059714','1430334110324281346',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430334110513025025','1409682434043191297','1430334110513025025',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-25 09:00:00',NULL,NULL,NULL,'2021-08-25 09:00:00',NULL,NULL,NULL),('1430680843587735553',NULL,'1430680843587735553',2,1,NULL,'13536632254','732162','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 07:57:48',NULL,NULL,NULL,'2021-08-26 07:57:48',NULL,NULL,NULL),('1430682527420436481',NULL,'1430682527420436481',2,1,NULL,'13536632254','150651','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 08:04:29',NULL,NULL,NULL,'2021-08-26 08:04:29',NULL,NULL,NULL),('1430682933227737090',NULL,'1430682933227737090',2,1,NULL,'13536632254','789696','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 08:06:06',NULL,NULL,NULL,'2021-08-26 08:06:06',NULL,NULL,NULL),('1430687293647147010',NULL,'1430687293647147010',2,1,NULL,'18217618815','670801','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 08:23:26',NULL,NULL,NULL,'2021-08-26 08:23:26',NULL,NULL,NULL),('1430696494922518529','1211559758373371905','1430696494922518529',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696494930907138','1212665763958165505','1430696494930907138',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696494939295745','1211120827064496130','1430696494939295745',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696494972850177','1211167966465470465','1430696494972850177',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495195148290','58','1430696495195148290',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495358726145','1211529007779069954','1430696495358726145',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495358726146','1212685717864517633','1430696495358726146',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495396474881','58','1430696495396474881',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495409057794','1211461407799820290','1430696495409057794',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495518109698','83','1430696495518109698',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495614578690','87','1430696495614578690',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495635550209','1213844233778122754','1430696495635550209',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495639744513','87','1430696495639744513',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495639744514','1211837849989595138','1430696495639744514',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495748796417','1211473406755651586','1430696495748796417',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495799128066','102','1430696495799128066',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495836876801','1219451161745080321','1430696495836876801',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495836876802','1216559724997144578','1430696495836876802',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495836876803','102','1430696495836876803',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495929151489','1211474926804975617','1430696495929151489',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496017231874','1374554432229978113','1430696496017231874',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496017231875','1274912838720167938','1430696496017231875',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496134672386','1211515979058692097','1430696496134672386',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496193392642','1286499346338045953','1430696496193392642',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496340193282','1216568840104734722','1430696496340193282',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496499576833','1316201027820630017','1430696496499576833',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496541519874','1241252588561698817','1430696496541519874',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496747040769','1286499346338045953','1430696496747040769',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696496927395841','1290850604855361537','1430696496927395841',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696497145499649','1295900371603947522','1430696497145499649',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696497334243330','1348924009986654209','1430696497334243330',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696497535569922','1351830895278948354','1430696497535569922',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696497741090818','1374554432229978113','1430696497741090818',2,2,'福建省晋华集成电路有限公司','15059820805','8,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696497950806017','1402819845443059714','1430696497950806017',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430696498143744001','1409682434043191297','1430696498143744001',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-26 09:00:00',NULL,NULL,NULL,'2021-08-26 09:00:00',NULL,NULL,NULL),('1430715857700442114',NULL,'1430715857700442114',2,1,NULL,'18259263128','964787','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 10:16:56',NULL,NULL,NULL,'2021-08-26 10:16:56',NULL,NULL,NULL),('1430819446427013122',NULL,'1430819446427013122',2,1,NULL,'13205059567','563832','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 17:08:34',NULL,NULL,NULL,'2021-08-26 17:08:34',NULL,NULL,NULL),('1430819805925003266',NULL,'1430819805925003266',2,1,NULL,'13205059567','039238','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 17:09:59',NULL,NULL,NULL,'2021-08-26 17:09:59',NULL,NULL,NULL),('1430828165416144897',NULL,'1430828165416144897',2,1,NULL,'13805350771','807893','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-26 17:43:12',NULL,NULL,NULL,'2021-08-26 17:43:12',NULL,NULL,NULL),('1431058882783924225','1211167966465470465','1431058882783924225',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882821672962','1212665763958165505','1431058882821672962',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882855227393','1212685717864517633','1431058882855227393',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882863616002','1211120827064496130','1431058882863616002',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883106885633','58','1431058883106885633',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883157217282','58','1431058883157217282',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883304017921','1211461407799820290','1431058883304017921',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883324989442','1211529007779069954','1431058883324989442',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883324989443','1213844233778122754','1431058883324989443',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883425652738','87','1431058883425652738',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883488567297','87','1431058883488567297',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883534704642','1211473406755651586','1431058883534704642',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883538898945','1211837849989595138','1431058883538898945',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883559870465','1216559724997144578','1431058883559870465',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883689893889','102','1431058883689893889',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883723448322','102','1431058883723448322',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883765391361','1211474926804975617','1431058883765391361',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883765391362','1374554432229978113','1431058883765391362',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883769585665','1219451161745080321','1431058883769585665',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883945746434','1274912838720167938','1431058883945746434',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058883945746435','1211515979058692097','1431058883945746435',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058884142878721','1286499346338045953','1431058884142878721',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058884151267330','1216568840104734722','1431058884151267330',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058884319039490','1316201027820630017','1431058884319039490',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058884319039491','1241252588561698817','1431058884319039491',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058884491005954','1286499346338045953','1431058884491005954',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058884713304065','1290850604855361537','1431058884713304065',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058884943990785','1295900371603947522','1431058884943990785',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058885191454721','1348924009986654209','1431058885191454721',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058885426335745','1351830895278948354','1431058885426335745',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058885598302209','1374554432229978113','1431058885598302209',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431058885782851585','1402819845443059714','1431058885782851585',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-27 09:00:00',NULL,NULL,NULL,'2021-08-27 09:00:00',NULL,NULL,NULL),('1431248940317069313',NULL,'1431248940317069313',2,1,NULL,'18060037567','140312','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-27 21:35:13',NULL,NULL,NULL,'2021-08-27 21:35:13',NULL,NULL,NULL),('1431249975429353474',NULL,'1431249975429353474',2,1,NULL,'18060037567','740912','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-27 21:39:20',NULL,NULL,NULL,'2021-08-27 21:39:20',NULL,NULL,NULL),('1431539866553864194',NULL,'1431539866553864194',2,1,NULL,'15906066156','299058','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-28 16:51:15',NULL,NULL,NULL,'2021-08-28 16:51:15',NULL,NULL,NULL),('1431540532676448258',NULL,'1431540532676448258',2,1,NULL,'15906066156','772745','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-28 16:53:54',NULL,NULL,NULL,'2021-08-28 16:53:54',NULL,NULL,NULL),('1431542891095838722',NULL,'1431542891095838722',2,1,NULL,'15906066156','061995','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-28 17:03:16',NULL,NULL,NULL,'2021-08-28 17:03:16',NULL,NULL,NULL),('1431543667692195842',NULL,'1431543667692195842',2,1,NULL,'15906066156','149174','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-28 17:06:21',NULL,NULL,NULL,'2021-08-28 17:06:21',NULL,NULL,NULL),('1431544388617555970',NULL,'1431544388617555970',2,1,NULL,'18016605819','067811','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-28 17:09:13',NULL,NULL,NULL,'2021-08-28 17:09:13',NULL,NULL,NULL),('1432146046456221698','1211120827064496130','1432146046456221698',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046493970433','1212685717864517633','1432146046493970433',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046514941954','1211167966465470465','1432146046514941954',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046523330562','1212665763958165505','1432146046523330562',2,2,'泉州安踏鞋材有限公司','15960586807','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047030841346','1213844233778122754','1432146047030841346',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047030841347','1211529007779069954','1432146047030841347',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047030841348','1211461407799820290','1432146047030841348',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047085367297','58','1432146047085367297',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047097950209','58','1432146047097950209',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047257333762','1211473406755651586','1432146047257333762',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047307665410','1211837849989595138','1432146047307665410',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047324442625','1216559724997144578','1432146047324442625',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047324442626','87','1432146047324442626',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047500603394','1211474926804975617','1432146047500603394',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047508992001','87','1432146047508992001',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047542546433','1219451161745080321','1432146047542546433',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047601266689','102','1432146047601266689',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047668375553','102','1432146047668375553',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047676764161','1374554432229978113','1432146047676764161',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047676764162','1216568840104734722','1432146047676764162',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047731290113','1274912838720167938','1432146047731290113',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047882285057','1241252588561698817','1432146047882285057',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146047907450882','1286499346338045953','1432146047907450882',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146048054251522','1286499346338045953','1432146048054251522',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146048129748994','1316201027820630017','1432146048129748994',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146048217829377','1295900371603947522','1432146048217829377',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146048444321793','1348924009986654209','1432146048444321793',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146048754700290','1351830895278948354','1432146048754700290',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146048939249666','1374554432229978113','1432146048939249666',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432146049148964865','1402819845443059714','1432146049148964865',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-30 09:00:00',NULL,NULL,NULL,'2021-08-30 09:00:00',NULL,NULL,NULL),('1432149053591834626',NULL,'1432149053591834626',2,1,NULL,'15159788561','129259','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-30 09:11:57',NULL,NULL,NULL,'2021-08-30 09:11:57',NULL,NULL,NULL),('1432170716303773698','1431544548139520002','1432170716303773698',2,2,'福建彩驰鞋服有限公司','18016605819','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-08-30 10:38:01',NULL,NULL,NULL,'2021-08-30 10:38:01',NULL,NULL,NULL),('1432501710164643841','1430716195874590722','1432501710164643841',2,2,'福建省福禧种子有限公司','18259263128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 08:33:16',NULL,NULL,NULL,'2021-08-31 08:33:16',NULL,NULL,NULL),('1432508434489593857','1211167966465470465','1432508434489593857',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434506371074','1211120827064496130','1432508434506371074',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434556702721','1212685717864517633','1432508434556702721',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434837721090','58','1432508434837721090',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434841915393','58','1432508434841915393',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435076796418','1211461407799820290','1432508435076796418',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435093573634','1211529007779069954','1432508435093573634',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435093573635','1213844233778122754','1432508435093573635',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435336843266','87','1432508435336843266',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435336843267','87','1432508435336843267',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435395563521','1216559724997144578','1432508435395563521',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435412340737','1211837849989595138','1432508435412340737',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435412340738','1211473406755651586','1432508435412340738',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435508809730','102','1432508435508809730',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435521392642','102','1432508435521392642',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435634638849','1219451161745080321','1432508435634638849',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435643027457','1211474926804975617','1432508435643027457',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435865325569','1216568840104734722','1432508435865325569',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508435869519874','1274912838720167938','1432508435869519874',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508436049874946','1286499346338045953','1432508436049874946',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508436049874947','1241252588561698817','1432508436049874947',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508436255395842','1286499346338045953','1432508436255395842',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508436297338881','1316201027820630017','1432508436297338881',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508436511248385','1295900371603947522','1432508436511248385',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508436695797762','1348924009986654209','1432508436695797762',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508436859375617','1351830895278948354','1432508436859375617',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508437022953474','1374554432229978113','1432508437022953474',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432508437211697153','1402819845443059714','1432508437211697153',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-08-31 09:00:00',NULL,NULL,NULL,'2021-08-31 09:00:00',NULL,NULL,NULL),('1432523286847213569',NULL,'1432523286423588866',2,2,'樊园','18500487523','18500487523,晋江市集成电路产业优秀人才层次变更,福建省集成电路产业园公告栏及企业内部,2021-08-31,2021-09-06,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 09:59:01',NULL,NULL,NULL,'2021-08-31 09:59:01',NULL,NULL,NULL),('1432523286855602178',NULL,'1432523286423588866',2,2,'吴姗姗','18850203633','18850203633,晋江市集成电路产业优秀人才层次变更,福建省集成电路产业园公告栏及企业内部,2021-08-31,2021-09-06,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 09:59:01',NULL,NULL,NULL,'2021-08-31 09:59:01',NULL,NULL,NULL),('1432523552459902977',NULL,'1432523551360995330',2,2,'林青峰','18650497837','18650497837,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552459902978',NULL,'1432523551360995330',2,2,'张德鑫','17333076507','17333076507,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552464097282',NULL,'1432523551360995330',2,2,'陈俊坤','18060518242','18060518242,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552464097283',NULL,'1432523551360995330',2,2,'肖波','18216089079','18216089079,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552464097284',NULL,'1432523551360995330',2,2,'梁廷钰','17874171447','17874171447,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552464097285',NULL,'1432523551360995330',2,2,'梁俊玲','18779422634','18779422634,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552468291585',NULL,'1432523551360995330',2,2,'任康俊','18737598563','18737598563,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552468291586',NULL,'1432523551360995330',2,2,'陈新祥','13282016697','13282016697,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552468291587',NULL,'1432523551360995330',2,2,'林碧婷','15521432459','15521432459,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552468291588',NULL,'1432523551360995330',2,2,'张少铜','15060807141','15060807141,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552468291589',NULL,'1432523551360995330',2,2,'乔旭','13171488504','13171488504,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552472485889',NULL,'1432523551360995330',2,2,'张永淳','13205023508','13205023508,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552472485890',NULL,'1432523551360995330',2,2,'刘欢','13906041139','13906041139,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552472485891',NULL,'1432523551360995330',2,2,'王卿权','15528081232','15528081232,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552472485892',NULL,'1432523551360995330',2,2,'林晓毅','15160338787','15160338787,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552472485893',NULL,'1432523551360995330',2,2,'杨双婷','15059181572','15059181572,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552476680194',NULL,'1432523551360995330',2,2,'吴玉武','18650109195','18650109195,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552476680195',NULL,'1432523551360995330',2,2,'刘伟浓','13692157144','13692157144,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552476680196',NULL,'1432523551360995330',2,2,'陈荣华','18225860850','18225860850,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552476680197',NULL,'1432523551360995330',2,2,'荣翔','15764236775','15764236775,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552476680198',NULL,'1432523551360995330',2,2,'张景铭','15009289680','15009289680,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432523552480874497',NULL,'1432523551360995330',2,2,'陈善华','13997707587','13997707587,晋江市集成电路产业优秀人才认定,福建省集成电路产业园公告栏及企业内部,2021年08月31日,2021年09月06日,集成电路产业园区,0595-82250007、0595-82250001,jjjcdr@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',3,'短信发送成功','2021-08-31 10:00:04',NULL,NULL,NULL,'2021-08-31 10:00:04',NULL,NULL,NULL),('1432575311513440258',NULL,'1432575311513440258',2,1,NULL,'18160996788','386419','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-08-31 13:25:44',NULL,NULL,NULL,'2021-08-31 13:25:44',NULL,NULL,NULL),('1432870822271307777','1211120827064496130','1432870822271307777',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822279696386','1211167966465470465','1432870822279696386',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822288084993','1212685717864517633','1432870822288084993',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822506188802','58','1432870822506188802',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822539743234','58','1432870822539743234',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822720098306','1211529007779069954','1432870822720098306',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822724292610','1211461407799820290','1432870822724292610',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822728486914','1213844233778122754','1432870822728486914',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822795595777','87','1432870822795595777',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822816567298','87','1432870822816567298',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822934007810','1211837849989595138','1432870822934007810',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822942396418','1211473406755651586','1432870822942396418',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822942396419','1216559724997144578','1432870822942396419',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823009505282','102','1432870823009505282',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823009505283','102','1432870823009505283',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823173083137','1219451161745080321','1432870823173083137',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823173083138','1211474926804975617','1432870823173083138',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823445712897','1274912838720167938','1432870823445712897',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823445712898','1216568840104734722','1432870823445712898',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823718342657','1241252588561698817','1432870823718342657',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823726731265','1286499346338045953','1432870823726731265',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823898697729','1286499346338045953','1432870823898697729',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870823915474946','1316201027820630017','1432870823915474946',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870824091635713','1295900371603947522','1432870824091635713',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870824372654082','1348924009986654209','1432870824372654082',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870824557203457','1351830895278948354','1432870824557203457',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870824750141441','1374554432229978113','1432870824750141441',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432870824955662337','1402819845443059714','1432870824955662337',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-01 09:00:00',NULL,NULL,NULL,'2021-09-01 09:00:00',NULL,NULL,NULL),('1432987753158594561',NULL,'1432987753158594561',2,1,NULL,'18859449954','329024','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-01 16:44:38',NULL,NULL,NULL,'2021-09-01 16:44:38',NULL,NULL,NULL),('1433233209847500801','1211167966465470465','1433233209847500801',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233209897832449','1211120827064496130','1433233209897832449',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233209906221058','1212685717864517633','1433233209906221058',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210216599554','58','1433233210216599554',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210224988162','58','1433233210224988162',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210283708418','1211461407799820290','1433233210283708418',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210308874242','1213844233778122754','1433233210308874242',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210334040065','1211529007779069954','1433233210334040065',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210497617922','1211473406755651586','1433233210497617922',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210497617923','1216559724997144578','1433233210497617923',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210497617924','87','1433233210497617924',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210501812225','87','1433233210501812225',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210573115394','1211837849989595138','1433233210573115394',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210707333121','1211474926804975617','1433233210707333121',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210707333122','102','1433233210707333122',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210711527426','102','1433233210711527426',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210824773633','1219451161745080321','1433233210824773633',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210904465410','1211490446086291458','1433233210904465410',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211114180610','1274912838720167938','1433233211114180610',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211114180611','1216568840104734722','1433233211114180611',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211311312898','1241252588561698817','1433233211311312898',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211332284418','1286499346338045953','1433233211332284418',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211541999617','1316201027820630017','1433233211541999617',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211541999618','1286499346338045953','1433233211541999618',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211726548993','1295900371603947522','1433233211726548993',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233211915292674','1348924009986654209','1433233211915292674',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233212091453441','1351830895278948354','1433233212091453441',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233212271808514','1374554432229978113','1433233212271808514',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433233212452163586','1402819845443059714','1433233212452163586',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-02 09:00:00',NULL,NULL,NULL,'2021-09-02 09:00:00',NULL,NULL,NULL),('1433595598098948098','1212685717864517633','1433595598098948098',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598098948099','1211120827064496130','1433595598098948099',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598103142401','1211167966465470465','1433595598103142401',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598245748738','58','1433595598245748738',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598476435457','58','1433595598476435457',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598736482306','1211529007779069954','1433595598736482306',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598736482307','1213844233778122754','1433595598736482307',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598736482308','87','1433595598736482308',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598744870914','1211461407799820290','1433595598744870914',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598795202561','87','1433595598795202561',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599088803842','102','1433595599088803842',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599092998145','1211473406755651586','1433595599092998145',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599105581057','102','1433595599105581057',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599105581058','1216559724997144578','1433595599105581058',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599105581059','1211837849989595138','1433595599105581059',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599365627905','1219451161745080321','1433595599365627905',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599369822210','1211474926804975617','1433595599369822210',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599562760193','1274912838720167938','1433595599562760193',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599562760194','1216568840104734722','1433595599562760194',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599822807042','1286499346338045953','1433595599822807042',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595599839584258','1241252588561698817','1433595599839584258',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595600040910850','1316201027820630017','1433595600040910850',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595600040910851','1286499346338045953','1433595600040910851',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595600259014657','1295900371603947522','1433595600259014657',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595600460341250','1348924009986654209','1433595600460341250',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595600670056449','1351830895278948354','1433595600670056449',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595600879771650','1374554432229978113','1433595600879771650',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433595601110458370','1402819845443059714','1433595601110458370',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-03 09:00:00',NULL,NULL,NULL,'2021-09-03 09:00:00',NULL,NULL,NULL),('1433627362074845186',NULL,'1433627362074845186',2,1,NULL,'15959553375','146901','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-03 11:06:13',NULL,NULL,NULL,'2021-09-03 11:06:13',NULL,NULL,NULL),('1434003740620251138',NULL,'1434003740620251138',2,1,NULL,'15859752886','077555','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-04 12:01:48',NULL,NULL,NULL,'2021-09-04 12:01:48',NULL,NULL,NULL),('1434682761590890497','1211167966465470465','1434682761590890497',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682761607667714','1212685717864517633','1434682761607667714',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682761637027841','1211120827064496130','1434682761637027841',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762031292418','58','1434682762031292418',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762039681025','1213844233778122754','1434682762039681025',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762039681026','1211461407799820290','1434682762039681026',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762043875330','58','1434682762043875330',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762052263937','1211529007779069954','1434682762052263937',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762266173442','87','1434682762266173442',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762287144961','1211473406755651586','1434682762287144961',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762303922178','1211837849989595138','1434682762303922178',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762408779777','87','1434682762408779777',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762408779778','1216559724997144578','1434682762408779778',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762475888641','1211474926804975617','1434682762475888641',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762475888642','102','1434682762475888642',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762484277250','1219451161745080321','1434682762484277250',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762618494978','102','1434682762618494978',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762693992450','1274912838720167938','1434682762693992450',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762702381058','1216568840104734722','1434682762702381058',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762886930433','1241252588561698817','1434682762886930433',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682762886930434','1286499346338045953','1434682762886930434',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682763188920322','1286499346338045953','1434682763188920322',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682763188920323','1316201027820630017','1434682763188920323',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682763532853250','1295900371603947522','1434682763532853250',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682763713208321','1348924009986654209','1434682763713208321',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682763948089345','1351830895278948354','1434682763948089345',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682764178776065','1374554432229978113','1434682764178776065',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434682764375908354','1402819845443059714','1434682764375908354',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-06 09:00:00',NULL,NULL,NULL,'2021-09-06 09:00:00',NULL,NULL,NULL),('1434687441297498113',NULL,'1434687441297498113',2,1,NULL,'13599778158','366133','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-06 09:18:35',NULL,NULL,NULL,'2021-09-06 09:18:35',NULL,NULL,NULL),('1434688462610522113',NULL,'1434688462610522113',2,1,NULL,'13599778158','444797','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-06 09:22:39',NULL,NULL,NULL,'2021-09-06 09:22:39',NULL,NULL,NULL),('1434690087618109442',NULL,'1434690087618109442',2,1,NULL,'13599778158','173872','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-06 09:29:06',NULL,NULL,NULL,'2021-09-06 09:29:06',NULL,NULL,NULL),('1435045149276135425','1211120827064496130','1435045149276135425',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149284524033','1212685717864517633','1435045149284524033',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149301301250','1211167966465470465','1435045149301301250',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149372604418','58','1435045149372604418',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149376798722','58','1435045149376798722',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149670400002','1211461407799820290','1435045149670400002',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149674594305','87','1435045149674594305',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149674594306','1213844233778122754','1435045149674594306',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149674594307','87','1435045149674594307',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149682982913','1211529007779069954','1435045149682982913',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149888503809','102','1435045149888503809',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149917863938','1216559724997144578','1435045149917863938',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149917863939','102','1435045149917863939',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149930446850','1211473406755651586','1435045149930446850',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149938835457','1211837849989595138','1435045149938835457',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150161133570','1211474926804975617','1435045150161133570',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150169522178','1219451161745080321','1435045150169522178',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150337294338','1216568840104734722','1435045150337294338',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150345682946','1274912838720167938','1435045150345682946',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150517649409','1241252588561698817','1435045150517649409',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150517649410','1286499346338045953','1435045150517649410',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150698004481','1286499346338045953','1435045150698004481',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150710587393','1316201027820630017','1435045150710587393',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045150974828545','1295900371603947522','1435045150974828545',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045151176155138','1348924009986654209','1435045151176155138',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045151369093121','1351830895278948354','1435045151369093121',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045151578808322','1374554432229978113','1435045151578808322',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435045151759163394','1402819845443059714','1435045151759163394',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-07 09:00:00',NULL,NULL,NULL,'2021-09-07 09:00:00',NULL,NULL,NULL),('1435407537422778369','1211167966465470465','1435407537422778369',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537477304321','1211120827064496130','1435407537477304321',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537510858754','1212685717864517633','1435407537510858754',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537993203713','58','1435407537993203713',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538009980929','58','1435407538009980929',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538152587265','1213844233778122754','1435407538152587265',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538152587266','1211461407799820290','1435407538152587266',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538152587267','1211529007779069954','1435407538152587267',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538370691074','87','1435407538370691074',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538374885377','87','1435407538374885377',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538379079682','1211473406755651586','1435407538379079682',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538521686017','1211837849989595138','1435407538521686017',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538525880322','1216559724997144578','1435407538525880322',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538555240449','102','1435407538555240449',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538559434753','1211474926804975617','1435407538559434753',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538559434754','102','1435407538559434754',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538710429697','1219451161745080321','1435407538710429697',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538748178434','1216568840104734722','1435407538748178434',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538932727810','1241252588561698817','1435407538932727810',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407538936922114','1274912838720167938','1435407538936922114',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407539222134786','1286499346338045953','1435407539222134786',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407539226329090','1286499346338045953','1435407539226329090',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407539406684162','1316201027820630017','1435407539406684162',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407539415072769','1295900371603947522','1435407539415072769',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407539649953793','1348924009986654209','1435407539649953793',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407539842891778','1351830895278948354','1435407539842891778',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407540040024065','1374554432229978113','1435407540040024065',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435407540241350657','1402819845443059714','1435407540241350657',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-08 09:00:00',NULL,NULL,NULL,'2021-09-08 09:00:00',NULL,NULL,NULL),('1435769925200297985','1211167966465470465','1435769925200297985',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925238046722','1212685717864517633','1435769925238046722',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925313544193','1211120827064496130','1435769925313544193',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925678448641','1213844233778122754','1435769925678448641',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925686837250','1211461407799820290','1435769925686837250',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925741363202','58','1435769925741363202',1,2,'张荣荣','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925741363203','58','1435769925741363203',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925833637890','1211529007779069954','1435769925833637890',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925951078401','1211473406755651586','1435769925951078401',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925955272705','87','1435769925955272705',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926009798657','1211837849989595138','1435769926009798657',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926043353090','87','1435769926043353090',1,2,'叶志钦','13675957398','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926064324609','1216559724997144578','1435769926064324609',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926232096769','1211474926804975617','1435769926232096769',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926236291073','102','1435769926236291073',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926257262594','1219451161745080321','1435769926257262594',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926257262595','102','1435769926257262595',1,2,'颜思思','15280619456','4,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926508920833','1216568840104734722','1435769926508920833',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926508920834','1274912838720167938','1435769926508920834',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926693470210','1286499346338045953','1435769926693470210',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926693470211','1241252588561698817','1435769926693470211',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926911574018','1286499346338045953','1435769926911574018',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769926911574019','1316201027820630017','1435769926911574019',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769927125483521','1295900371603947522','1435769927125483521',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769927347781633','1348924009986654209','1435769927347781633',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769927540719617','1351830895278948354','1435769927540719617',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769927796572162','1374554432229978113','1435769927796572162',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435769927997898754','1402819845443059714','1435769927997898754',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-09 09:00:00',NULL,NULL,NULL,'2021-09-09 09:00:00',NULL,NULL,NULL),('1435881524498055170',NULL,'1435881524498055170',2,1,NULL,'15359850577','517969','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-09 16:23:27',NULL,NULL,NULL,'2021-09-09 16:23:27',NULL,NULL,NULL),('1435889099872452609',NULL,'1435889099872452609',2,1,NULL,'13004358542','669194','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-09 16:53:33',NULL,NULL,NULL,'2021-09-09 16:53:33',NULL,NULL,NULL),('1435900156783411202','1309396118605459457','1435900156783411202',2,2,'晋江超特精铸有限公司','13506953825','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-09 17:37:29',NULL,NULL,NULL,'2021-09-09 17:37:29',NULL,NULL,NULL),('1435963120756506626',NULL,'1435963120756506626',2,1,NULL,'15659797483','167478','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-09 21:47:41',NULL,NULL,NULL,'2021-09-09 21:47:41',NULL,NULL,NULL),('1436132312860377090','1211120827064496130','1436132312860377090',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132312885542914','1211167966465470465','1436132312885542914',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132312889737218','1212685717864517633','1436132312889737218',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313254641665','58','1436132313254641665',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313258835970','58','1436132313258835970',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313380470785','1211529007779069954','1436132313380470785',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313393053697','1213844233778122754','1436132313393053697',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313393053698','1211461407799820290','1436132313393053698',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313527271426','87','1436132313527271426',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313615351810','87','1436132313615351810',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313732792321','1211837849989595138','1436132313732792321',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313745375234','1216559724997144578','1436132313745375234',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313753763842','1211473406755651586','1436132313753763842',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313770541058','102','1436132313770541058',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314005422082','102','1436132314005422082',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314005422083','1211474926804975617','1436132314005422083',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314030587906','1219451161745080321','1436132314030587906',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314307411970','1216568840104734722','1436132314307411970',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314319994882','1274912838720167938','1436132314319994882',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314559070209','1241252588561698817','1436132314559070209',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314559070210','1286499346338045953','1436132314559070210',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314810728450','1286499346338045953','1436132314810728450',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132314819117058','1316201027820630017','1436132314819117058',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132315007860737','1295900371603947522','1436132315007860737',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132315238547458','1348924009986654209','1436132315238547458',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132315473428481','1351830895278948354','1436132315473428481',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132315662172161','1374554432229978113','1436132315662172161',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436132315859304450','1402819845443059714','1436132315859304450',2,2,'晋江市文化和旅游局','15880886611','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-10 09:00:00',NULL,NULL,NULL,'2021-09-10 09:00:00',NULL,NULL,NULL),('1436134760979152898','1435881910797647874','1436134760979152898',2,2,'晋江风笙电子商务有限公司','15359850577','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-10 09:09:43',NULL,NULL,NULL,'2021-09-10 09:09:43',NULL,NULL,NULL),('1436143724735283201',NULL,'1436143724735283201',2,1,NULL,'13799487213','652712','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 09:45:20',NULL,NULL,NULL,'2021-09-10 09:45:20',NULL,NULL,NULL),('1436144217553420289',NULL,'1436144217553420289',2,1,NULL,'19959877368','708936','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 09:47:18',NULL,NULL,NULL,'2021-09-10 09:47:18',NULL,NULL,NULL),('1436144757242904577','1436144268304498689','1436144757242904577',2,2,'泉州椰子科技有限公司','19959877368','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-10 09:49:27',NULL,NULL,NULL,'2021-09-10 09:49:27',NULL,NULL,NULL),('1436144855863574530','1430716195874590722','1436144855863574530',2,2,'福建省福禧种子有限公司','18259263128','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-10 09:49:50',NULL,NULL,NULL,'2021-09-10 09:49:50',NULL,NULL,NULL),('1436229652396929026',NULL,'1436229652396929026',2,1,NULL,'18850585101','298256','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 15:26:47',NULL,NULL,NULL,'2021-09-10 15:26:47',NULL,NULL,NULL),('1436230703778918402',NULL,'1436230703778918402',2,1,NULL,'18850585101','546291','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 15:30:58',NULL,NULL,NULL,'2021-09-10 15:30:58',NULL,NULL,NULL),('1436232403659026433',NULL,'1436232403659026433',2,1,NULL,'18850585101','077240','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 15:37:43',NULL,NULL,NULL,'2021-09-10 15:37:43',NULL,NULL,NULL),('1436232684585119746',NULL,'1436232684585119746',2,1,NULL,'13055285626','403724','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 15:38:50',NULL,NULL,NULL,'2021-09-10 15:38:50',NULL,NULL,NULL),('1436237241759330306',NULL,'1436237241759330306',2,1,NULL,'15806030380','754724','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 15:56:57',NULL,NULL,NULL,'2021-09-10 15:56:57',NULL,NULL,NULL),('1436237665254010881',NULL,'1436237665254010881',2,1,NULL,'15806030380','012625','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 15:58:38',NULL,NULL,NULL,'2021-09-10 15:58:38',NULL,NULL,NULL),('1436238178259333122',NULL,'1436238178259333122',2,1,NULL,'15806030380','042513','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-10 16:00:40',NULL,NULL,NULL,'2021-09-10 16:00:40',NULL,NULL,NULL),('1436241060522127361','1436229755434201090','1436241060522127361',2,2,'福建晋江经济开发区管理委员会','18850585101','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-10 16:12:07',NULL,NULL,NULL,'2021-09-10 16:12:07',NULL,NULL,NULL),('1437219476499099650','1211167966465470465','1437219476499099650',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219476499099651','1211120827064496130','1437219476499099651',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219476578791426','1212685717864517633','1437219476578791426',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219476994027521','1213844233778122754','1437219476994027521',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219476994027522','1211529007779069954','1437219476994027522',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219476994027523','1211461407799820290','1437219476994027523',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477115662338','72','1437219477115662338',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477119856641','58','1437219477119856641',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477228908545','1216559724997144578','1437219477228908545',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477275045890','1211473406755651586','1437219477275045890',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477287628802','1211837849989595138','1437219477287628802',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477396680706','58','1437219477396680706',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477400875010','87','1437219477400875010',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477472178178','1219451161745080321','1437219477472178178',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477497344001','1211474926804975617','1437219477497344001',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477627367426','102','1437219477627367426',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477635756033','87','1437219477635756033',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477681893378','1216568840104734722','1437219477681893378',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477711253506','1274912838720167938','1437219477711253506',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477866442753','102','1437219477866442753',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477946134530','1241252588561698817','1437219477946134530',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219478013243394','1286499346338045953','1437219478013243394',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219478147461121','1286499346338045953','1437219478147461121',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219478298456066','1316201027820630017','1437219478298456066',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219478390730754','1295900371603947522','1437219478390730754',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219478596251650','1348924009986654209','1437219478596251650',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219478839521282','1351830895278948354','1437219478839521282',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437219479053430785','1374554432229978113','1437219479053430785',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 09:00:00',NULL,NULL,NULL,'2021-09-13 09:00:00',NULL,NULL,NULL),('1437238847590133762','1418181190581518337','1437238847590133762',2,2,'福建杰斐逊律师事务所','13599100513','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-13 10:16:58',NULL,NULL,NULL,'2021-09-13 10:16:58',NULL,NULL,NULL),('1437310020583714817',NULL,'1437310020583714817',2,1,NULL,'15959560130','080136','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-13 14:59:47',NULL,NULL,NULL,'2021-09-13 14:59:47',NULL,NULL,NULL),('1437581864461168642','1212685717864517633','1437581864461168642',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864465362946','1211167966465470465','1437581864465362946',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864553443330','1211120827064496130','1437581864553443330',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864914153473','58','1437581864914153473',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864993845250','72','1437581864993845250',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865014816770','1213844233778122754','1437581865014816770',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865014816771','1211461407799820290','1437581865014816771',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865073537025','1211529007779069954','1437581865073537025',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865153228801','87','1437581865153228801',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865270669314','58','1437581865270669314',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865279057921','1216559724997144578','1437581865279057921',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865350361090','1211837849989595138','1437581865350361090',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865383915521','1211473406755651586','1437581865383915521',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865446830081','102','1437581865446830081',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865497161729','87','1437581865497161729',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865555881986','1219451161745080321','1437581865555881986',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865614602242','1211474926804975617','1437581865614602242',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865719459842','102','1437581865719459842',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865740431361','1274912838720167938','1437581865740431361',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865820123138','1216568840104734722','1437581865820123138',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581865924980738','1286499346338045953','1437581865924980738',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581866000478209','1241252588561698817','1437581866000478209',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581866151473154','1316201027820630017','1437581866151473154',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581866214387713','1286499346338045953','1437581866214387713',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581866411520001','1295900371603947522','1437581866411520001',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581866575097857','1348924009986654209','1437581866575097857',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581866768035842','1351830895278948354','1437581866768035842',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437581867002916865','1374554432229978113','1437581867002916865',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-14 09:00:00',NULL,NULL,NULL,'2021-09-14 09:00:00',NULL,NULL,NULL),('1437586142512836609','70','1437586142512836609',1,2,'陈瑞清','13788864979','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:17:00',NULL,NULL,NULL,'2021-09-14 09:17:00',NULL,NULL,NULL),('1437586142907101185','76','1437586142907101185',1,2,'陈颖颖','13505079029','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:17:00',NULL,NULL,NULL,'2021-09-14 09:17:00',NULL,NULL,NULL),('1437586143074873345','83','1437586143074873345',1,2,'李女元','15359825666','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-14 09:17:00',NULL,NULL,NULL,'2021-09-14 09:17:00',NULL,NULL,NULL),('1437715933320736770',NULL,'1437715933320736770',2,1,NULL,'18350103126','416085','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-14 17:52:44',NULL,NULL,NULL,'2021-09-14 17:52:44',NULL,NULL,NULL),('1437726269256003586',NULL,'1437726269256003586',2,1,NULL,'18050976963','666010','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-14 18:33:48',NULL,NULL,NULL,'2021-09-14 18:33:48',NULL,NULL,NULL),('1437756523060162561',NULL,'1437756523060162561',2,1,NULL,'15960552667','051109','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-14 20:34:01',NULL,NULL,NULL,'2021-09-14 20:34:01',NULL,NULL,NULL),('1437761992239640578',NULL,'1437761992239640578',2,1,NULL,'15960552667','758121','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-14 20:55:45',NULL,NULL,NULL,'2021-09-14 20:55:45',NULL,NULL,NULL),('1437944252406460418','1211167966465470465','1437944252406460418',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252435820546','1211120827064496130','1437944252435820546',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252481957890','1212685717864517633','1437944252481957890',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252708450306','58','1437944252708450306',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252783947778','72','1437944252783947778',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252905582593','1211529007779069954','1437944252905582593',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252918165506','1213844233778122754','1437944252918165506',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252918165507','1211461407799820290','1437944252918165507',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253031411713','87','1437944253031411713',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253085937666','58','1437944253085937666',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253094326274','1211473406755651586','1437944253094326274',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253174018049','1211837849989595138','1437944253174018049',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253174018050','1216559724997144578','1437944253174018050',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253337595905','102','1437944253337595905',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253362761729','87','1437944253362761729',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253396316162','1211474926804975617','1437944253396316162',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253404704770','1219451161745080321','1437944253404704770',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253610225665','102','1437944253610225665',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253627002882','1216568840104734722','1437944253627002882',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253627002883','1274912838720167938','1437944253627002883',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253798969345','1241252588561698817','1437944253798969345',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944253811552258','1286499346338045953','1437944253811552258',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944254079987714','1316201027820630017','1437944254079987714',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944254084182018','1286499346338045953','1437944254084182018',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944254398754818','1295900371603947522','1437944254398754818',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944254658801666','1348924009986654209','1437944254658801666',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944254843351041','1351830895278948354','1437944254843351041',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944255023706113','1374554432229978113','1437944255023706113',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437944255229227009','1376712565047975937','1437944255229227009',2,2,'渠梁电子有限公司','18359882323','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-15 09:00:00',NULL,NULL,NULL,'2021-09-15 09:00:00',NULL,NULL,NULL),('1437946126706700290',NULL,'1437946126706700290',2,1,NULL,'15960552667','780856','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-15 09:07:27',NULL,NULL,NULL,'2021-09-15 09:07:27',NULL,NULL,NULL),('1437948530504265730','70','1437948530504265730',1,2,'陈瑞清','13788864979','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:17:00',NULL,NULL,NULL,'2021-09-15 09:17:00',NULL,NULL,NULL),('1437948530885947393','76','1437948530885947393',1,2,'陈颖颖','13505079029','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:17:00',NULL,NULL,NULL,'2021-09-15 09:17:00',NULL,NULL,NULL),('1437948531087273985','83','1437948531087273985',1,2,'李女元','15359825666','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-15 09:17:00',NULL,NULL,NULL,'2021-09-15 09:17:00',NULL,NULL,NULL),('1437973820022484994',NULL,'1437973820022484994',2,1,NULL,'15985992783','041883','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-15 10:57:29',NULL,NULL,NULL,'2021-09-15 10:57:29',NULL,NULL,NULL),('1438306640167202818','1212685717864517633','1438306640167202818',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640183980033','1211167966465470465','1438306640183980033',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640209145858','1211120827064496130','1438306640209145858',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640452415489','58','1438306640452415489',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640481775618','72','1438306640481775618',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640590827522','1213844233778122754','1438306640590827522',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640590827523','1211461407799820290','1438306640590827523',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640712462337','1211529007779069954','1438306640712462337',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640729239554','87','1438306640729239554',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640766988290','58','1438306640766988290',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640804737026','1211473406755651586','1438306640804737026',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640808931330','1216559724997144578','1438306640808931330',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640972509186','1211837849989595138','1438306640972509186',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641006063617','87','1438306641006063617',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641006063618','1211474926804975617','1438306641006063618',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641006063619','102','1438306641006063619',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641186418690','102','1438306641186418690',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641224167426','1216568840104734722','1438306641224167426',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641236750337','1219451161745080321','1438306641236750337',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641459048450','1241252588561698817','1438306641459048450',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641492602882','1274912838720167938','1438306641492602882',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641626820610','1286499346338045953','1438306641626820610',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641702318081','1286499346338045953','1438306641702318081',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641865895938','1295900371603947522','1438306641865895938',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306641895256065','1316201027820630017','1438306641895256065',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306642054639617','1348924009986654209','1438306642054639617',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306642226606082','1351830895278948354','1438306642226606082',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306642411155458','1374554432229978113','1438306642411155458',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438306642641842178','1376712565047975937','1438306642641842178',2,2,'渠梁电子有限公司','18359882323','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 09:00:00',NULL,NULL,NULL,'2021-09-16 09:00:00',NULL,NULL,NULL),('1438310918155956226','70','1438310918155956226',1,2,'陈瑞清','13788864979','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:17:00',NULL,NULL,NULL,'2021-09-16 09:17:00',NULL,NULL,NULL),('1438310918520860673','76','1438310918520860673',1,2,'陈颖颖','13505079029','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:17:00',NULL,NULL,NULL,'2021-09-16 09:17:00',NULL,NULL,NULL),('1438310918680244226','83','1438310918680244226',1,2,'李女元','15359825666','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-16 09:17:00',NULL,NULL,NULL,'2021-09-16 09:17:00',NULL,NULL,NULL),('1438346704389697537','1437716717978546177','1438346704389697537',2,2,'福建省晋江福源有限公司','18350103126','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-16 11:39:12',NULL,NULL,NULL,'2021-09-16 11:39:12',NULL,NULL,NULL),('1438349765711523841',NULL,'1438349765711523841',2,1,NULL,'19523645051','453490','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-16 11:51:22',NULL,NULL,NULL,'2021-09-16 11:51:22',NULL,NULL,NULL),('1438407248899502082','1438350099058028546','1438407248899502082',2,2,'晋江市商务局','19523645051','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-16 15:39:47',NULL,NULL,NULL,'2021-09-16 15:39:47',NULL,NULL,NULL),('1438437728747286530',NULL,'1438437728747286530',2,1,NULL,'19523645051','230877','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-16 17:40:54',NULL,NULL,NULL,'2021-09-16 17:40:54',NULL,NULL,NULL),('1438438016677867522',NULL,'1438438016677867522',2,1,NULL,'17705083808','353261','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-16 17:42:02',NULL,NULL,NULL,'2021-09-16 17:42:02',NULL,NULL,NULL),('1438439146770165762','1438438145149399041','1438439146770165762',2,2,'晋江市晋南口岸服务中心','17705083808','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-16 17:46:32',NULL,NULL,NULL,'2021-09-16 17:46:32',NULL,NULL,NULL),('1438669028066357250','1212685717864517633','1438669028066357250',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028087328769','1211167966465470465','1438669028087328769',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028133466113','1211120827064496130','1438669028133466113',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028213157890','58','1438669028213157890',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028406095873','72','1438669028406095873',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028510953473','1213844233778122754','1438669028510953473',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028523536386','1211461407799820290','1438669028523536386',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028523536387','1211529007779069954','1438669028523536387',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028649365506','87','1438669028649365506',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028699697153','58','1438669028699697153',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028804554753','1216559724997144578','1438669028804554753',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028804554754','1211473406755651586','1438669028804554754',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028833914882','1211837849989595138','1438669028833914882',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028930383874','87','1438669028930383874',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028930383875','102','1438669028930383875',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029081378818','1211474926804975617','1438669029081378818',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029110738945','1219451161745080321','1438669029110738945',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029203013634','102','1438669029203013634',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029282705409','1216568840104734722','1438669029282705409',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029366591489','1274912838720167938','1438669029366591489',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029551140866','1241252588561698817','1438669029551140866',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029647609857','1286499346338045953','1438669029647609857',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029727301634','1286499346338045953','1438669029727301634',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029844742145','1316201027820630017','1438669029844742145',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669029903462401','1295900371603947522','1438669029903462401',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669030104788994','1348924009986654209','1438669030104788994',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669030503247874','1351830895278948354','1438669030503247874',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669030767489026','1374554432229978113','1438669030767489026',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438669031006564354','1376712565047975937','1438669031006564354',2,2,'渠梁电子有限公司','18359882323','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-17 09:00:00',NULL,NULL,NULL,'2021-09-17 09:00:00',NULL,NULL,NULL),('1438673306159968257','83','1438673306159968257',1,2,'李女元','15359825666','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-17 09:17:00',NULL,NULL,NULL,'2021-09-17 09:17:00',NULL,NULL,NULL),('1439425870920970242',NULL,'1439425870920970242',2,1,NULL,'18859791858','486983','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-19 11:07:25',NULL,NULL,NULL,'2021-09-19 11:07:25',NULL,NULL,NULL),('1439426973502828545',NULL,'1439426973502828545',2,1,NULL,'13774648357','919662','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-19 11:11:48',NULL,NULL,NULL,'2021-09-19 11:11:48',NULL,NULL,NULL),('1439428445661589506',NULL,'1439428445661589506',2,1,NULL,'15392169697','361212','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-19 11:17:39',NULL,NULL,NULL,'2021-09-19 11:17:39',NULL,NULL,NULL),('1439468139690618882',NULL,'1439468139690618882',2,1,NULL,'13489470092','360003','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-19 13:55:23',NULL,NULL,NULL,'2021-09-19 13:55:23',NULL,NULL,NULL),('1439493051859890177','1439428764097343490','1439493051859890177',2,2,'晋江隆益纸业有限公司','15392169697','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-19 15:34:22',NULL,NULL,NULL,'2021-09-19 15:34:22',NULL,NULL,NULL),('1439512232248504322',NULL,'1439512232248504322',2,1,NULL,'19523645051','889072','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-19 16:50:35',NULL,NULL,NULL,'2021-09-19 16:50:35',NULL,NULL,NULL),('1439756191591854081','1212685717864517633','1439756191591854081',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191621214210','1211167966465470465','1439756191621214210',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191684128769','1211120827064496130','1439756191684128769',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192074199042','58','1439756192074199042',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192074199043','72','1439756192074199043',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192107753474','1211461407799820290','1439756192107753474',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192145502209','1211529007779069954','1439756192145502209',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192145502210','1213844233778122754','1439756192145502210',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192271331330','58','1439756192271331330',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192317468673','87','1439756192317468673',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192346828801','1211473406755651586','1439756192346828801',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192476852225','1211837849989595138','1439756192476852225',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192476852226','87','1439756192476852226',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192481046529','1216559724997144578','1439756192481046529',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192556544002','102','1439756192556544002',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192573321218','1211474926804975617','1439756192573321218',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192749481985','102','1439756192749481985',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192749481986','1219451161745080321','1439756192749481986',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756192766259202','1216568840104734722','1439756192766259202',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193038888962','1241252588561698817','1439756193038888962',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193043083265','1274912838720167938','1439756193043083265',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193256992769','1286499346338045953','1439756193256992769',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193269575682','1286499346338045953','1439756193269575682',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193454125058','1295900371603947522','1439756193454125058',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193458319361','1316201027820630017','1439756193458319361',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193672228866','1348924009986654209','1439756193672228866',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756193873555458','1351830895278948354','1439756193873555458',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756194146185217','1374554432229978113','1439756194146185217',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439756194360094722','1376712565047975937','1439756194360094722',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-20 09:00:00',NULL,NULL,NULL,'2021-09-20 09:00:00',NULL,NULL,NULL),('1439760469660299265','83','1439760469660299265',1,2,'李女元','15359825666','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-20 09:17:00',NULL,NULL,NULL,'2021-09-20 09:17:00',NULL,NULL,NULL),('1439846641908609025',NULL,'1439846641908609025',2,1,NULL,'13905050759','594601','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-20 14:59:25',NULL,NULL,NULL,'2021-09-20 14:59:25',NULL,NULL,NULL),('1439881212687577090',NULL,'1439881212687577090',2,1,NULL,'15059830861','739708','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-20 17:16:47',NULL,NULL,NULL,'2021-09-20 17:16:47',NULL,NULL,NULL),('1439882759798550530',NULL,'1439882759798550530',2,1,NULL,'15059830861','058439','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-20 17:22:56',NULL,NULL,NULL,'2021-09-20 17:22:56',NULL,NULL,NULL),('1440118579516174338','1211167966465470465','1440118579516174338',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579524562946','1212685717864517633','1440118579524562946',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579612643330','1211120827064496130','1440118579612643330',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579662974977','58','1440118579662974977',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579809775618','72','1440118579809775618',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579977547778','1211529007779069954','1440118579977547778',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579985936386','1211461407799820290','1440118579985936386',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579985936387','1213844233778122754','1440118579985936387',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580019490817','87','1440118580019490817',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580107571202','71','1440118580107571202',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580178874370','1211837849989595138','1440118580178874370',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580191457282','1211473406755651586','1440118580191457282',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580212428801','1216559724997144578','1440118580212428801',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580271149057','102','1440118580271149057',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580317286401','58','1440118580317286401',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580359229442','1211474926804975617','1440118580359229442',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580455698433','1219451161745080321','1440118580455698433',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580489252865','87','1440118580489252865',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580531195906','1216568840104734722','1440118580531195906',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580665413633','1274912838720167938','1440118580665413633',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580669607937','102','1440118580669607937',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580698968065','1241252588561698817','1440118580698968065',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580833185794','1286499346338045953','1440118580833185794',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118580858351618','1286499346338045953','1440118580858351618',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118581055483905','1316201027820630017','1440118581055483905',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118581059678210','1295900371603947522','1440118581059678210',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118581290364929','1348924009986654209','1440118581290364929',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118581462331394','1351830895278948354','1440118581462331394',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118581646880770','1374554432229978113','1440118581646880770',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440118581894344705','1376712565047975937','1440118581894344705',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-21 09:00:00',NULL,NULL,NULL,'2021-09-21 09:00:00',NULL,NULL,NULL),('1440121005426110465','1439882847975403522','1440121005426110465',2,2,'晋江市龙腾保安职业培训中心','15059830861','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-21 09:09:38',NULL,NULL,NULL,'2021-09-21 09:09:38',NULL,NULL,NULL),('1440480967356608514','1212685717864517633','1440480967356608514',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967419523074','1211120827064496130','1440480967419523074',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967499214850','1211167966465470465','1440480967499214850',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967838953473','1213844233778122754','1440480967838953473',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967918645250','72','1440480967918645250',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967981559809','58','1440480967981559809',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968002531329','83','1440480968002531329',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968010919937','1211529007779069954','1440480968010919937',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968044474370','1211461407799820290','1440480968044474370',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968124166145','1216559724997144578','1440480968124166145',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968208052226','87','1440480968208052226',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968254189569','58','1440480968254189569',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968317104130','1211473406755651586','1440480968317104130',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968371630082','1211837849989595138','1440480968371630082',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968438738945','102','1440480968438738945',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968518430722','87','1440480968518430722',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968568762370','1211474926804975617','1440480968568762370',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968602316802','1219451161745080321','1440480968602316802',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968866557954','1211490446086291458','1440480968866557954',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968887529473','1274912838720167938','1440480968887529473',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480968895918082','102','1440480968895918082',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480969093050369','1286499346338045953','1440480969093050369',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480969093050370','1216568840104734722','1440480969093050370',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480969315348482','1316201027820630017','1440480969315348482',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480969332125697','1241252588561698817','1440480969332125697',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480969541840898','1286499346338045953','1440480969541840898',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480969713807362','1295900371603947522','1440480969713807362',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480969902551042','1348924009986654209','1440480969902551042',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480970145820674','1351830895278948354','1440480970145820674',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480970368118786','1374554432229978113','1440480970368118786',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480970653331458','1376712565047975937','1440480970653331458',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440480970854658049','1438438145149399041','1440480970854658049',2,2,'晋江市晋南口岸服务中心','17705083808','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-22 09:00:00',NULL,NULL,NULL,'2021-09-22 09:00:00',NULL,NULL,NULL),('1440843355259957250','1212685717864517633','1440843355259957250',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355268345858','1211167966465470465','1440843355268345858',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355327066113','1211120827064496130','1440843355327066113',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355511615490','58','1440843355511615490',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355540975617','72','1440843355540975617',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355553558530','83','1440843355553558530',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355729719297','1211461407799820290','1440843355729719297',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355729719298','1211529007779069954','1440843355729719298',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355729719299','1213844233778122754','1440843355729719299',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355784245250','87','1440843355784245250',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355792633857','58','1440843355792633857',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355910074369','1216559724997144578','1440843355910074369',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355914268673','1211473406755651586','1440843355914268673',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355914268674','1211837849989595138','1440843355914268674',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355956211713','87','1440843355956211713',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355956211714','102','1440843355956211714',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356128178177','1219451161745080321','1440843356128178177',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356128178178','1211474926804975617','1440843356128178178',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356186898433','102','1440843356186898433',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356308533249','1274912838720167938','1440843356308533249',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356321116161','1216568840104734722','1440843356321116161',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356480499713','1286499346338045953','1440843356480499713',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356484694017','1241252588561698817','1440843356484694017',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356656660481','1286499346338045953','1440843356656660481',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356656660482','1316201027820630017','1440843356656660482',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843356845404162','1295900371603947522','1440843356845404162',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843357025759234','1348924009986654209','1440843357025759234',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843357197725697','1351830895278948354','1440843357197725697',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1440843357394857986','1374554432229978113','1440843357394857986',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-23 09:00:00',NULL,NULL,NULL,'2021-09-23 09:00:00',NULL,NULL,NULL),('1441205743003922433','1212685717864517633','1441205743003922433',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743029088258','1211167966465470465','1441205743029088258',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743121362946','1211120827064496130','1441205743121362946',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743352049666','83','1441205743352049666',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743356243969','58','1441205743356243969',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743423352834','72','1441205743423352834',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743591124993','1213844233778122754','1441205743591124993',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743603707905','1211461407799820290','1441205743603707905',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743603707906','1211529007779069954','1441205743603707906',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743675011073','58','1441205743675011073',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743675011074','87','1441205743675011074',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743809228801','1216559724997144578','1441205743809228801',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743842783233','1211837849989595138','1441205743842783233',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743842783234','1211473406755651586','1441205743842783234',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743922475009','102','1441205743922475009',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743922475010','87','1441205743922475010',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744073469954','102','1441205744073469954',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744077664257','1211474926804975617','1441205744077664257',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744081858562','1219451161745080321','1441205744081858562',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744241242114','1274912838720167938','1441205744241242114',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744249630722','1211490446086291458','1441205744249630722',2,2,'泉州职业技术大学','18060007601','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744459345922','1286499346338045953','1441205744459345922',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744463540225','1211559758373371905','1441205744463540225',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744631312386','1316201027820630017','1441205744631312386',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744631312387','1216568840104734722','1441205744631312387',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744803278850','1241252588561698817','1441205744803278850',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205744962662402','1286499346338045953','1441205744962662402',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205745138823170','1290850604855361537','1441205745138823170',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205745331761154','1295900371603947522','1441205745331761154',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205745528893441','1348924009986654209','1441205745528893441',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205745713442818','1351830895278948354','1441205745713442818',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441205745910575106','1374554432229978113','1441205745910575106',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-24 09:00:00',NULL,NULL,NULL,'2021-09-24 09:00:00',NULL,NULL,NULL),('1441225870281830401',NULL,'1441225870281830401',2,1,NULL,'13459402309','534185','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-24 10:19:58',NULL,NULL,NULL,'2021-09-24 10:19:58',NULL,NULL,NULL),('1441243534471491585',NULL,'1441243534471491585',2,1,NULL,'15860499469','810229','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-24 11:30:10',NULL,NULL,NULL,'2021-09-24 11:30:10',NULL,NULL,NULL),('1441251533671919617',NULL,'1441251533671919617',2,1,NULL,'15860499469','792185','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-24 12:01:57',NULL,NULL,NULL,'2021-09-24 12:01:57',NULL,NULL,NULL),('1441971152778981377','1441226350139568129','1441971152778981377',2,2,'泉州浩然机械科技有限公司','13459402309','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-26 11:41:28',NULL,NULL,NULL,'2021-09-26 11:41:28',NULL,NULL,NULL),('1442292906667831298','1212685717864517633','1442292906667831298',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292906676219905','1211120827064496130','1442292906676219905',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292906697191425','1211167966465470465','1442292906697191425',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907053707266','58','1442292907053707266',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907104038914','72','1442292907104038914',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907112427522','1211529007779069954','1442292907112427522',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907116621825','1211461407799820290','1442292907116621825',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907125010434','1213844233778122754','1442292907125010434',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907292782594','87','1442292907292782594',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907309559810','83','1442292907309559810',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907326337025','58','1442292907326337025',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907326337026','1211837849989595138','1442292907326337026',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907439583234','1211473406755651586','1442292907439583234',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907439583235','1216559724997144578','1442292907439583235',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907515080705','102','1442292907515080705',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907523469314','87','1442292907523469314',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907540246529','1219451161745080321','1442292907540246529',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907628326913','1211474926804975617','1442292907628326913',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907741573122','102','1442292907741573122',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907766738946','1274912838720167938','1442292907766738946',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907800293377','1211490446086291458','1442292907800293377',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292908010008578','1286499346338045953','1442292908010008578',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292908014202881','1211559758373371905','1442292908014202881',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292908194557953','1216568840104734722','1442292908194557953',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292908194557954','1316201027820630017','1442292908194557954',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292908408467458','1241252588561698817','1442292908408467458',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292908601405442','1286499346338045953','1442292908601405442',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292908865646594','1290850604855361537','1442292908865646594',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292909100527618','1295900371603947522','1442292909100527618',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292909293465602','1348924009986654209','1442292909293465602',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292909498986498','1351830895278948354','1442292909498986498',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442292909721284610','1374554432229978113','1442292909721284610',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-27 09:00:00',NULL,NULL,NULL,'2021-09-27 09:00:00',NULL,NULL,NULL),('1442655294499876866','1212685717864517633','1442655294499876866',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294571180033','1211120827064496130','1442655294571180033',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294587957249','1211167966465470465','1442655294587957249',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295019970561','58','1442655295019970561',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295019970562','1211529007779069954','1442655295019970562',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295040942081','1213844233778122754','1442655295040942081',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295066107906','72','1442655295066107906',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295091273730','1211461407799820290','1442655295091273730',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295254851586','87','1442655295254851586',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295267434497','1211837849989595138','1442655295267434497',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295292600321','58','1442655295292600321',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295380680706','1216559724997144578','1442655295380680706',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295410040834','1211473406755651586','1442655295410040834',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295443595266','102','1442655295443595266',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295447789570','1219451161745080321','1442655295447789570',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295472955394','87','1442655295472955394',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295598784514','1211474926804975617','1442655295598784514',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295619756033','1274912838720167938','1442655295619756033',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295661699073','102','1442655295661699073',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295808499713','1216568840104734722','1442655295808499713',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295829471233','1286499346338045953','1442655295829471233',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655295988854786','1241252588561698817','1442655295988854786',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655296014020610','1316201027820630017','1442655296014020610',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655296190181377','1286499346338045953','1442655296190181377',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655296483782658','1290850604855361537','1442655296483782658',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655296655749121','1295900371603947522','1442655296655749121',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655296827715585','1348924009986654209','1442655296827715585',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655297012264962','1351830895278948354','1442655297012264962',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1442655297192620033','1374554432229978113','1442655297192620033',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-28 09:00:00',NULL,NULL,NULL,'2021-09-28 09:00:00',NULL,NULL,NULL),('1443017682302562305','1211167966465470465','1443017682302562305',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682432585729','1211559758373371905','1443017682432585729',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682474528770','1211120827064496130','1443017682474528770',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682709409794','58','1443017682709409794',1,2,'张荣荣','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682734575617','72','1443017682734575617',1,2,'翁海勇','13599173733','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682805878785','83','1443017682805878785',1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682835238914','1211454669394591746','1443017682835238914',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682835238915','1212685717864517633','1443017682835238915',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682990428162','58','1443017682990428162',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682990428163','1211529007779069954','1443017682990428163',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683023982593','87','1443017683023982593',1,2,'叶志钦','13675957398','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683204337666','1211459203080699905','1443017683204337666',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683208531970','1213844233778122754','1443017683208531970',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683233697794','102','1443017683233697794',1,2,'颜思思','15280619456','3,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683246280705','87','1443017683246280705',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683363721217','1211837849989595138','1443017683363721217',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683451801602','102','1443017683451801602',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683493744642','1216559724997144578','1443017683493744642',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683506327554','1211461407799820290','1443017683506327554',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683569242113','1219451161745080321','1443017683569242113',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683762180097','1274912838720167938','1443017683762180097',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017683774763010','1211473406755651586','1443017683774763010',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017684001255425','1211474926804975617','1443017684001255425',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017684013838338','1286499346338045953','1443017684013838338',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017684231942145','1211515979058692097','1443017684231942145',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017684282273793','1316201027820630017','1443017684282273793',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017684550709250','1211837849989595138','1443017684550709250',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017684814950402','1216568840104734722','1443017684814950402',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017685007888385','1218794464953360385','1443017685007888385',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017685213409282','1241252588561698817','1443017685213409282',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017685469261825','1245239948823592961','1443017685469261825',2,2,'晋江五店市晋文坊房地产开发有限公司','13959941699','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017685683171330','1286499346338045953','1443017685683171330',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017685863526401','1290850604855361537','1443017685863526401',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017686060658689','1295900371603947522','1443017686060658689',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:00',NULL,NULL,NULL,'2021-09-29 09:00:00',NULL,NULL,NULL),('1443017686249402369','1301823981006909441','1443017686249402369',2,2,'中国人寿保险股份有限公司晋江市支公司','13489551288','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:01',NULL,NULL,NULL,'2021-09-29 09:00:01',NULL,NULL,NULL),('1443017686429757442','1341318122925195265','1443017686429757442',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:01',NULL,NULL,NULL,'2021-09-29 09:00:01',NULL,NULL,NULL),('1443017686647861250','1348924009986654209','1443017686647861250',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:01',NULL,NULL,NULL,'2021-09-29 09:00:01',NULL,NULL,NULL),('1443017686832410625','1351830895278948354','1443017686832410625',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:01',NULL,NULL,NULL,'2021-09-29 09:00:01',NULL,NULL,NULL),('1443017687037931522','1374554432229978113','1443017687037931522',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:01',NULL,NULL,NULL,'2021-09-29 09:00:01',NULL,NULL,NULL),('1443017687272812546','1435881910797647874','1443017687272812546',2,2,'晋江风笙电子商务有限公司','15359850577','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:01',NULL,NULL,NULL,'2021-09-29 09:00:01',NULL,NULL,NULL),('1443017687461556225','1439882847975403522','1443017687461556225',2,2,'晋江市龙腾保安职业培训中心','15059830861','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-29 09:00:01',NULL,NULL,NULL,'2021-09-29 09:00:01',NULL,NULL,NULL),('1443042070414520322',NULL,'1443042070414520322',2,1,NULL,'15980086288','470546','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-29 10:36:54',NULL,NULL,NULL,'2021-09-29 10:36:54',NULL,NULL,NULL),('1443053783243321346','1211484578443739137','1443053783243321346',2,2,'晋江市锦福化纤聚合有限公司','15859731637','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-29 11:23:27',NULL,NULL,NULL,'2021-09-29 11:23:27',NULL,NULL,NULL),('1443053825609986050','1324980845383110658','1443053825609986050',2,2,'晋江市澳雷朗照明科技有限公司','18925477267','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-29 11:23:37',NULL,NULL,NULL,'2021-09-29 11:23:37',NULL,NULL,NULL),('1443057340113776642',NULL,'1443057340113776642',2,1,NULL,'13599155640','098072','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-29 11:37:35',NULL,NULL,NULL,'2021-09-29 11:37:35',NULL,NULL,NULL),('1443146133705617409','1436232752927109121','1443146133705617409',2,2,'福建省晋江经济开发区投资有限责任公司','13055285626','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-09-29 17:30:25',NULL,NULL,NULL,'2021-09-29 17:30:25',NULL,NULL,NULL),('1443380070155579394','1211120827064496130','1443380070155579394',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070239465474','1211167966465470465','1443380070239465474',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070247854081','1212685717864517633','1443380070247854081',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070277214210','1211490953219588098','1443380070277214210',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070289797121','1290495759225049090','1443380070289797121',2,2,'晋江市石达塑胶精细有限公司','13599778158','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070562426881','1211529007779069954','1443380070562426881',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070608564225','1211454669394591746','1443380070608564225',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070608564226','58','1443380070608564226',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070612758530','1211559758373371905','1443380070612758530',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070705033218','58','1443380070705033218',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070897971202','1211837849989595138','1443380070897971202',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070897971203','1212626739503632385','1443380070897971203',2,2,'晋江宏基机械有限公司','15905958858','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070897971204','1211459203080699905','1443380070897971204',2,2,'福建省育才建设发展有限公司','13788846820','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070906359810','83','1443380070906359810',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070965080066','87','1443380070965080066',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070981857281','87','1443380070981857281',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071090909186','1219451161745080321','1443380071090909186',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071090909187','1212685717864517633','1443380071090909187',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071090909188','1211461407799820290','1443380071090909188',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071137046530','102','1443380071137046530',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071162212353','102','1443380071162212353',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071309012994','1213032291266269186','1443380071309012994',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071342567425','1274912838720167938','1443380071342567425',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071359344641','1211473406755651586','1443380071359344641',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071602614274','1286499346338045953','1443380071602614274',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071611002881','1211474926804975617','1443380071611002881',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071623585793','1213844233778122754','1443380071623585793',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071799746562','1211490446086291458','1443380071799746562',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071808135169','1316201027820630017','1443380071808135169',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380071812329473','1216559724997144578','1443380071812329473',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380072047210498','1211515979058692097','1443380072047210498',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380072219176961','1211837849989595138','1443380072219176961',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380072437280770','1212930279740608514','1443380072437280770',2,2,'福建省晋江市华宇织造有限公司','18606984919','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380072638607361','1216568840104734722','1443380072638607361',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380072835739649','1218794464953360385','1443380072835739649',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380073099980802','1241252588561698817','1443380073099980802',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380073368416258','1286499346338045953','1443380073368416258',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380073552965633','1290850604855361537','1443380073552965633',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380073800429569','1295900371603947522','1443380073800429569',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:00',NULL,NULL,NULL,'2021-09-30 09:00:00',NULL,NULL,NULL),('1443380073984978945','1341318122925195265','1443380073984978945',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:01',NULL,NULL,NULL,'2021-09-30 09:00:01',NULL,NULL,NULL),('1443380074169528322','1348924009986654209','1443380074169528322',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:01',NULL,NULL,NULL,'2021-09-30 09:00:01',NULL,NULL,NULL),('1443380074362466306','1351830895278948354','1443380074362466306',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:01',NULL,NULL,NULL,'2021-09-30 09:00:01',NULL,NULL,NULL),('1443380074538627074','1374554432229978113','1443380074538627074',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:01',NULL,NULL,NULL,'2021-09-30 09:00:01',NULL,NULL,NULL),('1443380074727370753','1425660338317033473','1443380074727370753',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-09-30 09:00:01',NULL,NULL,NULL,'2021-09-30 09:00:01',NULL,NULL,NULL),('1443384348412768258','83','1443384348412768258',1,2,'李女元','15359825666','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-09-30 09:17:00',NULL,NULL,NULL,'2021-09-30 09:17:00',NULL,NULL,NULL),('1443390964826664961',NULL,'1443390964826664961',2,1,NULL,'15059819952','178246','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-30 09:43:17',NULL,NULL,NULL,'2021-09-30 09:43:17',NULL,NULL,NULL),('1443559215502225409',NULL,'1443559215502225409',2,1,NULL,'15880293393','425397','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-09-30 20:51:51',NULL,NULL,NULL,'2021-09-30 20:51:51',NULL,NULL,NULL),('1443742458193145857','1211490953219588098','1443742458193145857',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458193145858','1290495759225049090','1443742458193145858',2,2,'晋江市石达塑胶精细有限公司','13599778158','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458201534465','1211120827064496130','1443742458201534465',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458201534466','1211167966465470465','1443742458201534466',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458218311681','1212685717864517633','1443742458218311681',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458524495873','58','1443742458524495873',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458549661697','58','1443742458549661697',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458662907905','1211529007779069954','1443742458662907905',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458671296514','1211454669394591746','1443742458671296514',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458683879426','1211559758373371905','1443742458683879426',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458868428801','87','1443742458868428801',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458889400321','87','1443742458889400321',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458910371841','1211837849989595138','1443742458910371841',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458918760449','1211461407799820290','1443742458918760449',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459078144001','1212685717864517633','1443742459078144001',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459086532610','102','1443742459086532610',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459099115522','102','1443742459099115522',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459124281345','1211473406755651586','1443742459124281345',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459187195906','1219451161745080321','1443742459187195906',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459359162370','1213032291266269186','1443742459359162370',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459396911106','1274912838720167938','1443742459396911106',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459396911107','1211474926804975617','1443742459396911107',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459543711745','1213844233778122754','1443742459543711745',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459669540865','1286499346338045953','1443742459669540865',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459669540866','1211490446086291458','1443742459669540866',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459791175682','1216559724997144578','1443742459791175682',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459917004801','1211515979058692097','1443742459917004801',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742459917004802','1316201027820630017','1443742459917004802',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742460177051650','1211837849989595138','1443742460177051650',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742460382572546','1216568840104734722','1443742460382572546',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742460596482050','1218794464953360385','1443742460596482050',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742460797808642','1241252588561698817','1443742460797808642',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742460978163713','1286499346338045953','1443742460978163713',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742461171101698','1290850604855361537','1443742461171101698',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742461397594114','1295900371603947522','1443742461397594114',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742461598920706','1341318122925195265','1443742461598920706',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742461787664386','1348924009986654209','1443742461787664386',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:00',NULL,NULL,NULL,'2021-10-01 09:00:00',NULL,NULL,NULL),('1443742461993185281','1351830895278948354','1443742461993185281',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:01',NULL,NULL,NULL,'2021-10-01 09:00:01',NULL,NULL,NULL),('1443742462177734657','1374554432229978113','1443742462177734657',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:01',NULL,NULL,NULL,'2021-10-01 09:00:01',NULL,NULL,NULL),('1443742462404227074','1425660338317033473','1443742462404227074',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-01 09:00:01',NULL,NULL,NULL,'2021-10-01 09:00:01',NULL,NULL,NULL),('1443746736156733442','83','1443746736156733442',1,2,'李女元','15359825666','1,人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-01 09:17:00',NULL,NULL,NULL,'2021-10-01 09:17:00',NULL,NULL,NULL),('1444549848991821825',NULL,'1444549848991821825',2,1,NULL,'17606011420','170736','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-03 14:28:17',NULL,NULL,NULL,'2021-10-03 14:28:17',NULL,NULL,NULL),('1444829621756391425','1211120827064496130','1444829621756391425',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829621764780033','1211490953219588098','1444829621764780033',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829621764780034','1290495759225049090','1444829621764780034',2,2,'晋江市石达塑胶精细有限公司','13599778158','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829621785751553','1212685717864517633','1444829621785751553',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829621819305985','1211167966465470465','1444829621819305985',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622171627522','1211529007779069954','1444829622171627522',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622188404738','1211559758373371905','1444829622188404738',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622255513602','58','1444829622255513602',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622326816770','1211454669394591746','1444829622326816770',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622326816771','58','1444829622326816771',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622494588930','1211837849989595138','1444829622494588930',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622515560449','1212685717864517633','1444829622515560449',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622515560450','87','1444829622515560450',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622540726274','1211461407799820290','1444829622540726274',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622549114881','87','1444829622549114881',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622716887041','102','1444829622716887041',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622721081345','1213032291266269186','1444829622721081345',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622721081346','1219451161745080321','1444829622721081346',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622725275650','1211473406755651586','1444829622725275650',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622729469953','102','1444829622729469953',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622893047809','1274912838720167938','1444829622893047809',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622901436418','1213844233778122754','1444829622901436418',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622922407937','1211474926804975617','1444829622922407937',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623077597185','1216559724997144578','1444829623077597185',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623081791490','1211490446086291458','1444829623081791490',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623098568706','1286499346338045953','1444829623098568706',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623274729474','1211515979058692097','1444829623274729474',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623291506689','1316201027820630017','1444829623291506689',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623471861762','1211837849989595138','1444829623471861762',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623664799746','1212535414099873794','1444829623664799746',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829623861932033','1216568840104734722','1444829623861932033',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829624046481410','1218794464953360385','1444829624046481410',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829624231030786','1241252588561698817','1444829624231030786',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829624461717506','1286499346338045953','1444829624461717506',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829624763707394','1290850604855361537','1444829624763707394',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829625099251714','1295900371603947522','1444829625099251714',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829625283801089','1341318122925195265','1444829625283801089',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:00',NULL,NULL,NULL,'2021-10-04 09:00:00',NULL,NULL,NULL),('1444829625497710594','1348924009986654209','1444829625497710594',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:01',NULL,NULL,NULL,'2021-10-04 09:00:01',NULL,NULL,NULL),('1444829625703231490','1351830895278948354','1444829625703231490',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:01',NULL,NULL,NULL,'2021-10-04 09:00:01',NULL,NULL,NULL),('1444829625904558081','1374554432229978113','1444829625904558081',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:01',NULL,NULL,NULL,'2021-10-04 09:00:01',NULL,NULL,NULL),('1444829626156216321','1409682434043191297','1444829626156216321',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:01',NULL,NULL,NULL,'2021-10-04 09:00:01',NULL,NULL,NULL),('1444829626374320130','1425660338317033473','1444829626374320130',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:01',NULL,NULL,NULL,'2021-10-04 09:00:01',NULL,NULL,NULL),('1444829626588229634','1439882847975403522','1444829626588229634',2,2,'晋江市龙腾保安职业培训中心','15059830861','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-04 09:00:01',NULL,NULL,NULL,'2021-10-04 09:00:01',NULL,NULL,NULL),('1444931257887649794',NULL,'1444931257887649794',2,1,NULL,'18159227722','441538','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-04 15:43:52',NULL,NULL,NULL,'2021-10-04 15:43:52',NULL,NULL,NULL),('1445192009718460417','1211120827064496130','1445192009718460417',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192009718460418','1211490953219588098','1445192009718460418',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192009731043330','1290495759225049090','1445192009731043330',2,2,'晋江市石达塑胶精细有限公司','13599778158','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192009735237633','1212685717864517633','1445192009735237633',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192009793957889','1211167966465470465','1445192009793957889',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010163056642','58','1445192010163056642',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010167250945','58','1445192010167250945',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010184028161','83','1445192010184028161',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010196611073','1211559758373371905','1445192010196611073',2,2,'福建盼盼食品有限公司','13665929319','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010204999682','1211529007779069954','1445192010204999682',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010234359809','1211454669394591746','1445192010234359809',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010368577537','87','1445192010368577537',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010406326274','87','1445192010406326274',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010456657922','1212685717864517633','1445192010456657922',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010486018050','1211837849989595138','1445192010486018050',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010511183873','1211461407799820290','1445192010511183873',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010561515521','102','1445192010561515521',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010670567426','1213032291266269186','1445192010670567426',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010670567427','102','1445192010670567427',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010699927553','1211473406755651586','1445192010699927553',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010699927554','1219451161745080321','1445192010699927554',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010913837058','1213844233778122754','1445192010913837058',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010913837059','1274912838720167938','1445192010913837059',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011056443393','1211474926804975617','1445192011056443393',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011106775041','1286499346338045953','1445192011106775041',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011211632641','1216559724997144578','1445192011211632641',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011240992769','1211515979058692097','1445192011240992769',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011299713026','1316201027820630017','1445192011299713026',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011404570625','1211837849989595138','1445192011404570625',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011563954177','1212535414099873794','1445192011563954177',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011782057985','1216568840104734722','1445192011782057985',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192011958218754','1218794464953360385','1445192011958218754',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192012159545345','1241252588561698817','1445192012159545345',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192012327317506','1286499346338045953','1445192012327317506',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192012558004225','1290850604855361537','1445192012558004225',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192012725776386','1295900371603947522','1445192012725776386',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192012901937154','1341318122925195265','1445192012901937154',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192013115846658','1348924009986654209','1445192013115846658',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:00',NULL,NULL,NULL,'2021-10-05 09:00:00',NULL,NULL,NULL),('1445192013333950466','1351830895278948354','1445192013333950466',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:01',NULL,NULL,NULL,'2021-10-05 09:00:01',NULL,NULL,NULL),('1445192013539471362','1374554432229978113','1445192013539471362',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:01',NULL,NULL,NULL,'2021-10-05 09:00:01',NULL,NULL,NULL),('1445192013719826434','1409682434043191297','1445192013719826434',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:01',NULL,NULL,NULL,'2021-10-05 09:00:01',NULL,NULL,NULL),('1445192013895987202','1425660338317033473','1445192013895987202',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:01',NULL,NULL,NULL,'2021-10-05 09:00:01',NULL,NULL,NULL),('1445192014143451137','1439882847975403522','1445192014143451137',2,2,'晋江市龙腾保安职业培训中心','15059830861','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-05 09:00:01',NULL,NULL,NULL,'2021-10-05 09:00:01',NULL,NULL,NULL),('1445554397512757249','1211120827064496130','1445554397512757249',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397512757250','1211490953219588098','1445554397512757250',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397533728770','1290495759225049090','1445554397533728770',2,2,'晋江市石达塑胶精细有限公司','13599778158','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397533728771','1212685717864517633','1445554397533728771',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397630197761','1211167966465470465','1445554397630197761',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397957353473','1211529007779069954','1445554397957353473',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397969936385','1212685717864517633','1445554397969936385',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398007685122','58','1445554398007685122',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398146097154','83','1445554398146097154',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398146097155','58','1445554398146097155',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398179651585','1211454669394591746','1445554398179651585',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398339035138','1213032291266269186','1445554398339035138',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398339035139','1211837849989595138','1445554398339035139',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398477447169','87','1445554398477447169',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398506807297','87','1445554398506807297',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398506807298','1211461407799820290','1445554398506807298',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398620053505','1213844233778122754','1445554398620053505',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398762659841','102','1445554398762659841',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398762659842','1219451161745080321','1445554398762659842',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398762659843','102','1445554398762659843',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398783631361','1211473406755651586','1445554398783631361',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554398875906049','1216559724997144578','1445554398875906049',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399106592770','1211474926804975617','1445554399106592770',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399114981377','1274912838720167938','1445554399114981377',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399337279490','1211515979058692097','1445554399337279490',2,2,'福建佶龙机械科技股份有限公司','15960791997','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399362445314','1286499346338045953','1445554399362445314',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399526023170','1211837849989595138','1445554399526023170',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399580549122','1316201027820630017','1445554399580549122',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399731544065','1212535414099873794','1445554399731544065',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554399911899137','1216568840104734722','1445554399911899137',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554400096448513','1218794464953360385','1445554400096448513',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554400289386497','1241252588561698817','1445554400289386497',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554400524267521','1286499346338045953','1445554400524267521',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554400788508673','1290850604855361537','1445554400788508673',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554401103081474','1295900371603947522','1445554401103081474',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:00',NULL,NULL,NULL,'2021-10-06 09:00:00',NULL,NULL,NULL),('1445554401354739714','1341318122925195265','1445554401354739714',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:01',NULL,NULL,NULL,'2021-10-06 09:00:01',NULL,NULL,NULL),('1445554401602203650','1348924009986654209','1445554401602203650',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:01',NULL,NULL,NULL,'2021-10-06 09:00:01',NULL,NULL,NULL),('1445554401870639106','1351830895278948354','1445554401870639106',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:01',NULL,NULL,NULL,'2021-10-06 09:00:01',NULL,NULL,NULL),('1445554402084548609','1374554432229978113','1445554402084548609',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:01',NULL,NULL,NULL,'2021-10-06 09:00:01',NULL,NULL,NULL),('1445554402281680898','1409682434043191297','1445554402281680898',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:01',NULL,NULL,NULL,'2021-10-06 09:00:01',NULL,NULL,NULL),('1445554402474618882','1425660338317033473','1445554402474618882',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:01',NULL,NULL,NULL,'2021-10-06 09:00:01',NULL,NULL,NULL),('1445554402680139777','1439882847975403522','1445554402680139777',2,2,'晋江市龙腾保安职业培训中心','15059830861','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-06 09:00:01',NULL,NULL,NULL,'2021-10-06 09:00:01',NULL,NULL,NULL),('1445596026965618689',NULL,'1445596026965618689',2,1,NULL,'18350777721','383650','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-06 11:45:25',NULL,NULL,NULL,'2021-10-06 11:45:25',NULL,NULL,NULL),('1445602553516552193',NULL,'1445602553516552193',2,1,NULL,'18350777721','733093','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-06 12:11:21',NULL,NULL,NULL,'2021-10-06 12:11:21',NULL,NULL,NULL),('1445628423148957698',NULL,'1445628423148957698',2,1,NULL,'18350777721','726067','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-06 13:54:09',NULL,NULL,NULL,'2021-10-06 13:54:09',NULL,NULL,NULL),('1445916785269305346','1211490953219588098','1445916785269305346',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785311248386','1211167966465470465','1445916785311248386',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785323831297','1212685717864517633','1445916785323831297',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785411911682','1211120827064496130','1445916785411911682',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785646792705','58','1445916785646792705',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785734873090','83','1445916785734873090',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785747456002','58','1445916785747456002',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785789399041','1211454669394591746','1445916785789399041',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785843924994','1212685717864517633','1445916785843924994',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785919422465','1211529007779069954','1445916785919422465',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785957171202','87','1445916785957171202',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785994919937','87','1445916785994919937',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786003308545','1211461407799820290','1445916786003308545',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786116554753','1211837849989595138','1445916786116554753',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786141720578','1213032291266269186','1445916786141720578',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786141720579','102','1445916786141720579',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786317881345','102','1445916786317881345',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786368212993','1211473406755651586','1445916786368212993',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786414350337','1219451161745080321','1445916786414350337',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786447904770','1213844233778122754','1445916786447904770',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786548568065','1211474926804975617','1445916786548568065',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786628259841','1274912838720167938','1445916786628259841',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786632454146','1216559724997144578','1445916786632454146',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786787643393','1211837849989595138','1445916786787643393',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916786812809218','1286499346338045953','1445916786812809218',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916787001552898','1212535414099873794','1445916787001552898',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916787009941506','1316201027820630017','1445916787009941506',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916787198685185','1216568840104734722','1445916787198685185',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916787412594690','1218794464953360385','1445916787412594690',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916787647475713','1241252588561698817','1445916787647475713',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916787857190914','1286499346338045953','1445916787857190914',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916788066906113','1290850604855361537','1445916788066906113',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916788289204226','1295900371603947522','1445916788289204226',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916788473753601','1341318122925195265','1445916788473753601',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916788750577665','1348924009986654209','1445916788750577665',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916788977070082','1351830895278948354','1445916788977070082',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:00',NULL,NULL,NULL,'2021-10-07 09:00:00',NULL,NULL,NULL),('1445916789262282753','1374554432229978113','1445916789262282753',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:01',NULL,NULL,NULL,'2021-10-07 09:00:01',NULL,NULL,NULL),('1445916789618798594','1409682434043191297','1445916789618798594',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:01',NULL,NULL,NULL,'2021-10-07 09:00:01',NULL,NULL,NULL),('1445916789857873921','1425660338317033473','1445916789857873921',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:01',NULL,NULL,NULL,'2021-10-07 09:00:01',NULL,NULL,NULL),('1445916790063394818','1439882847975403522','1445916790063394818',2,2,'晋江市龙腾保安职业培训中心','15059830861','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-07 09:00:01',NULL,NULL,NULL,'2021-10-07 09:00:01',NULL,NULL,NULL),('1446279173210402817','1212685717864517633','1446279173210402817',2,2,'晋江市中医院','15960586523','2,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173227180033','1211490953219588098','1446279173227180033',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173269123074','1211167966465470465','1446279173269123074',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173273317378','1211120827064496130','1446279173273317378',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173688553473','58','1446279173688553473',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173705330689','1212685717864517633','1446279173705330689',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173730496514','58','1446279173730496514',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173751468033','1211454669394591746','1446279173751468033',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173755662337','1211529007779069954','1446279173755662337',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173805993985','83','1446279173805993985',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173969571841','1213032291266269186','1446279173969571841',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174011514882','87','1446279174011514882',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174078623745','87','1446279174078623745',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174137344001','1211837849989595138','1446279174137344001',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174217035778','1213844233778122754','1446279174217035778',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174229618690','1211461407799820290','1446279174229618690',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174271561729','102','1446279174271561729',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174309310466','102','1446279174309310466',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174401585153','1219451161745080321','1446279174401585153',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174489665537','1211473406755651586','1446279174489665537',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174514831362','1216559724997144578','1446279174514831362',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174779072513','1211474926804975617','1446279174779072513',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174779072514','1274912838720167938','1446279174779072514',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174972010498','1211837849989595138','1446279174972010498',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279174992982018','1286499346338045953','1446279174992982018',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279175332720642','1316201027820630017','1446279175332720642',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279175336914946','1212535414099873794','1446279175336914946',2,2,'安踏体育用品集团有限公司','18120662230','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279175643099138','1216568840104734722','1446279175643099138',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279175823454209','1218794464953360385','1446279175823454209',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279175999614977','1241252588561698817','1446279175999614977',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279176179970050','1286499346338045953','1446279176179970050',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279176356130818','1290850604855361537','1446279176356130818',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279176536485889','1295900371603947522','1446279176536485889',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279176746201089','1341318122925195265','1446279176746201089',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:00',NULL,NULL,NULL,'2021-10-08 09:00:00',NULL,NULL,NULL),('1446279176939139073','1348924009986654209','1446279176939139073',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:01',NULL,NULL,NULL,'2021-10-08 09:00:01',NULL,NULL,NULL),('1446279177119494145','1351830895278948354','1446279177119494145',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:01',NULL,NULL,NULL,'2021-10-08 09:00:01',NULL,NULL,NULL),('1446279177291460609','1374554432229978113','1446279177291460609',2,2,'福建省晋华集成电路有限公司','15059820805','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:01',NULL,NULL,NULL,'2021-10-08 09:00:01',NULL,NULL,NULL),('1446279177480204289','1409682434043191297','1446279177480204289',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:01',NULL,NULL,NULL,'2021-10-08 09:00:01',NULL,NULL,NULL),('1446279177668947970','1425660338317033473','1446279177668947970',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:01',NULL,NULL,NULL,'2021-10-08 09:00:01',NULL,NULL,NULL),('1446279177882857473','1439882847975403522','1446279177882857473',2,2,'晋江市龙腾保安职业培训中心','15059830861','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 09:00:01',NULL,NULL,NULL,'2021-10-08 09:00:01',NULL,NULL,NULL),('1446392822277107714',NULL,'1446392822277107714',2,1,NULL,'13489311953','234411','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-08 16:31:36',NULL,NULL,NULL,'2021-10-08 16:31:36',NULL,NULL,NULL),('1446394259912552449',NULL,'1446394259912552449',2,1,NULL,'13489311953','934941','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-08 16:37:18',NULL,NULL,NULL,'2021-10-08 16:37:18',NULL,NULL,NULL),('1446394780039802881',NULL,'1446394780039802881',2,1,NULL,'13489311953','362154','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-08 16:39:22',NULL,NULL,NULL,'2021-10-08 16:39:22',NULL,NULL,NULL),('1446395930851962881','1446394329768685570','1446395930851962881',2,2,'泉州市兰陵形象设计有限公司','13489311953','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-08 16:43:57',NULL,NULL,NULL,'2021-10-08 16:43:57',NULL,NULL,NULL),('1446396313737392130','1446394329768685570','1446396313737392130',2,2,'泉州市兰陵形象设计有限公司','13489311953','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-08 16:45:28',NULL,NULL,NULL,'2021-10-08 16:45:28',NULL,NULL,NULL),('1446752649440423938',NULL,'1446752649440423938',2,1,NULL,'13505950585','199392','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-09 16:21:25',NULL,NULL,NULL,'2021-10-09 16:21:25',NULL,NULL,NULL),('1446753051686760450','1418181190581518337','1446753051686760450',2,2,'福建杰斐逊律师事务所','13599100513','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-09 16:23:01',NULL,NULL,NULL,'2021-10-09 16:23:01',NULL,NULL,NULL),('1446753551190618114','1444932368895864833','1446753551190618114',2,2,'福建华达(晋江)律师事务所','18159227722','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-09 16:25:00',NULL,NULL,NULL,'2021-10-09 16:25:00',NULL,NULL,NULL),('1446754010148139010','1446752797012815874','1446754010148139010',2,2,'泉州市安缔计算机科技有限公司','13505950585','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-09 16:26:50',NULL,NULL,NULL,'2021-10-09 16:26:50',NULL,NULL,NULL),('1447366336706539521','1211167966465470465','1447366336706539521',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336731705346','1212685717864517633','1447366336731705346',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336823980033','1211120827064496130','1447366336823980033',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336949809154','58','1447366336949809154',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336962392065','58','1447366336962392065',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337159524354','83','1447366337159524354',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337222438913','1211454669394591746','1447366337222438913',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337230827521','1213032291266269186','1447366337230827521',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337230827522','1211529007779069954','1447366337230827522',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337352462337','87','1447366337352462337',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337360850946','87','1447366337360850946',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337453125634','1211461407799820290','1447366337453125634',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337465708546','1211837849989595138','1447366337465708546',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337545400321','1213844233778122754','1447366337545400321',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337637675010','102','1447366337637675010',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337646063617','102','1447366337646063617',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337662840834','1219451161745080321','1447366337662840834',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337667035138','1211473406755651586','1447366337667035138',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337721561090','1216559724997144578','1447366337721561090',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337859973121','1274912838720167938','1447366337859973121',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337897721858','1211474926804975617','1447366337897721858',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366338090659841','1211837849989595138','1447366338090659841',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366338090659842','1286499346338045953','1447366338090659842',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366338342318082','1316201027820630017','1447366338342318082',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366338346512386','1216568840104734722','1447366338346512386',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366338577199105','1218794464953360385','1447366338577199105',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366338757554178','1241252588561698817','1447366338757554178',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366338979852289','1285862298023370753','1447366338979852289',2,2,'金鹰(福建)印刷有限公司','13599937223','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366339156013058','1286499346338045953','1447366339156013058',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366339353145346','1290850604855361537','1447366339353145346',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366339529306113','1295900371603947522','1447366339529306113',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366339726438402','1341318122925195265','1447366339726438402',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366339952930817','1348924009986654209','1447366339952930817',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366340212977666','1351830895278948354','1447366340212977666',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366340426887170','1374554432229978113','1447366340426887170',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:00',NULL,NULL,NULL,'2021-10-11 09:00:00',NULL,NULL,NULL),('1447366340624019457','1409682434043191297','1447366340624019457',2,2,'晋江市农业农村局','15880993753','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:01',NULL,NULL,NULL,'2021-10-11 09:00:01',NULL,NULL,NULL),('1447366340946980865','1425660338317033473','1447366340946980865',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-11 09:00:01',NULL,NULL,NULL,'2021-10-11 09:00:01',NULL,NULL,NULL),('1447386309835386881',NULL,'1447386309835386881',2,1,NULL,'13959897058','950289','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-11 10:19:22',NULL,NULL,NULL,'2021-10-11 10:19:22',NULL,NULL,NULL),('1447461313058992130',NULL,'1447461313058992130',2,1,NULL,'18350777721','454186','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-11 15:17:24',NULL,NULL,NULL,'2021-10-11 15:17:24',NULL,NULL,NULL),('1447512931196497922',NULL,'1447512931196497922',2,1,NULL,'15395952572','836837','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-11 18:42:30',NULL,NULL,NULL,'2021-10-11 18:42:30',NULL,NULL,NULL),('1447522491609149441',NULL,'1447522491609149441',2,1,NULL,'15395952572','713124','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-11 19:20:30',NULL,NULL,NULL,'2021-10-11 19:20:30',NULL,NULL,NULL),('1447533958194556930',NULL,'1447533958194556930',2,1,NULL,'18350777721','247687','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-11 20:06:04',NULL,NULL,NULL,'2021-10-11 20:06:04',NULL,NULL,NULL),('1447728724714745858','1211120827064496130','1447728724714745858',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728724744105986','1211167966465470465','1447728724744105986',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728724773466114','1212685717864517633','1447728724773466114',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725075456001','58','1447728725075456001',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725079650305','58','1447728725079650305',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725100621826','83','1447728725100621826',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725205479425','1211454669394591746','1447728725205479425',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725218062338','1211529007779069954','1447728725218062338',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725218062339','1213032291266269186','1447728725218062339',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725369057281','87','1447728725369057281',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725369057282','87','1447728725369057282',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725448749058','1213844233778122754','1447728725448749058',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725494886401','1211461407799820290','1447728725494886401',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725494886402','1211837849989595138','1447728725494886402',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725578772482','102','1447728725578772482',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725641687041','102','1447728725641687041',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725717184514','1216559724997144578','1447728725717184514',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725733961730','1211473406755651586','1447728725733961730',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725771710466','1219451161745080321','1447728725771710466',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725901733890','1392396939873529858','1447728725901733890',2,2,'晋江万芯晨电子科技有限公司','13960937795','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725905928193','1211474926804975617','1447728725905928193',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725994008577','1274912838720167938','1447728725994008577',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728726140809218','1211837849989595138','1447728726140809218',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728726178557953','1286499346338045953','1447728726178557953',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728726514102274','1316201027820630017','1447728726514102274',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728726514102275','1216568840104734722','1447728726514102275',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728726845452289','1218794464953360385','1447728726845452289',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728727038390274','1241252588561698817','1447728727038390274',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728727243911169','1285862298023370753','1447728727243911169',2,2,'金鹰(福建)印刷有限公司','13599937223','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728727415877634','1290850604855361537','1447728727415877634',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728727592038402','1295900371603947522','1447728727592038402',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728727801753601','1341318122925195265','1447728727801753601',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728728024051714','1348924009986654209','1447728728024051714',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728728254738434','1351830895278948354','1447728728254738434',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:00',NULL,NULL,NULL,'2021-10-12 09:00:00',NULL,NULL,NULL),('1447728728451870722','1374554432229978113','1447728728451870722',2,2,'福建省晋华集成电路有限公司','15059820805','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:01',NULL,NULL,NULL,'2021-10-12 09:00:01',NULL,NULL,NULL),('1447728728653197314','1425660338317033473','1447728728653197314',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-12 09:00:01',NULL,NULL,NULL,'2021-10-12 09:00:01',NULL,NULL,NULL),('1447740613138083842',NULL,'1447740613138083842',2,1,NULL,'13799500535','985315','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-12 09:47:14',NULL,NULL,NULL,'2021-10-12 09:47:14',NULL,NULL,NULL),('1447825218113400834',NULL,'1447825218113400834',2,1,NULL,'17350030786','666752','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-12 15:23:25',NULL,NULL,NULL,'2021-10-12 15:23:25',NULL,NULL,NULL),('1447975828246786050',NULL,'1447975828246786050',2,1,NULL,'18350777721','748326','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-13 01:21:54',NULL,NULL,NULL,'2021-10-13 01:21:54',NULL,NULL,NULL),('1448091112513236994','1211120827064496130','1448091112513236994',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112530014210','1211167966465470465','1448091112530014210',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112584540161','1212685717864517633','1448091112584540161',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112945250306','58','1448091112945250306',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113029136385','58','1448091113029136385',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113045913601','1211529007779069954','1448091113045913601',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113045913602','1211454669394591746','1448091113045913602',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113058496514','1213032291266269186','1448091113058496514',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113209491458','87','1448091113209491458',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113243045889','87','1448091113243045889',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113280794625','1213844233778122754','1448091113280794625',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113373069314','1211461407799820290','1448091113373069314',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113415012353','1211837849989595138','1448091113415012353',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113427595266','102','1448091113427595266',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113582784513','102','1448091113582784513',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113641504769','1211473406755651586','1448091113641504769',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113658281986','1219451161745080321','1448091113658281986',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113662476289','1216559724997144578','1448091113662476289',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113834442754','1274912838720167938','1448091113834442754',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113838637057','1211474926804975617','1448091113838637057',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091113851219970','1374554432229978113','1448091113851219970',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091114341953537','1211837849989595138','1448091114341953537',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091114341953538','1392396939873529858','1448091114341953538',2,2,'晋江万芯晨电子科技有限公司','13960937795','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091114341953539','1286499346338045953','1448091114341953539',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091114518114305','1216568840104734722','1448091114518114305',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091114522308609','1316201027820630017','1448091114522308609',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091114711052290','1218794464953360385','1448091114711052290',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091114895601665','1241252588561698817','1448091114895601665',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091115113705473','1290850604855361537','1448091115113705473',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091115319226370','1295900371603947522','1448091115319226370',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091115520552962','1348924009986654209','1448091115520552962',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091115726073857','1351830895278948354','1448091115726073857',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091115969343489','1374554432229978113','1448091115969343489',2,2,'福建省晋华集成电路有限公司','15059820805','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:00',NULL,NULL,NULL,'2021-10-13 09:00:00',NULL,NULL,NULL),('1448091116271333378','1394875586618372097','1448091116271333378',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:01',NULL,NULL,NULL,'2021-10-13 09:00:01',NULL,NULL,NULL),('1448091116522991618','1425660338317033473','1448091116522991618',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:00:01',NULL,NULL,NULL,'2021-10-13 09:00:01',NULL,NULL,NULL),('1448098763838091266','1447741005896904706','1448098763838091266',2,2,'晋江市口腔医院','13799500535','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:30:24',NULL,NULL,NULL,'2021-10-13 09:30:24',NULL,NULL,NULL),('1448100042475859970','1447825572620169218','1448100042475859970',2,2,'泉州正朗置业有限公司','17350030786','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-13 09:35:29',NULL,NULL,NULL,'2021-10-13 09:35:29',NULL,NULL,NULL),('1448101200816795650','1447741005896904706','1448101200816795650',2,2,'晋江市口腔医院','13799500535','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-13 09:40:05',NULL,NULL,NULL,'2021-10-13 09:40:05',NULL,NULL,NULL),('1448206428547346433',NULL,'1448206428547346433',2,1,NULL,'18860028825','781197','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-13 16:38:13',NULL,NULL,NULL,'2021-10-13 16:38:13',NULL,NULL,NULL),('1448208940310491137',NULL,'1448208940310491137',2,1,NULL,'18860028825','856839','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-13 16:48:12',NULL,NULL,NULL,'2021-10-13 16:48:12',NULL,NULL,NULL),('1448209401960755202',NULL,'1448209401960755202',2,1,NULL,'18860028825','300616','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-13 16:50:02',NULL,NULL,NULL,'2021-10-13 16:50:02',NULL,NULL,NULL),('1448253988968361986',NULL,'1448253988968361986',2,1,NULL,'13860917850','782248','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-13 19:47:12',NULL,NULL,NULL,'2021-10-13 19:47:12',NULL,NULL,NULL),('1448453500420780034','1212685717864517633','1448453500420780034',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500424974337','1211167966465470465','1448453500424974337',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500517249026','1211120827064496130','1448453500517249026',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500718575618','58','1448453500718575618',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500752130050','58','1448453500752130050',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500861181954','1213032291266269186','1448453500861181954',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500861181955','1211454669394591746','1448453500861181955',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500919902210','1211529007779069954','1448453500919902210',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500982816769','87','1448453500982816769',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501045731330','1211461407799820290','1448453501045731330',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501045731331','1213844233778122754','1448453501045731331',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501045731332','87','1448453501045731332',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501188337666','102','1448453501188337666',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501213503490','1211837849989595138','1448453501213503490',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501268029442','102','1448453501268029442',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501272223745','1216559724997144578','1448453501272223745',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501284806658','1211473406755651586','1448453501284806658',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501385469953','1219451161745080321','1448453501385469953',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501444190210','1374554432229978113','1448453501444190210',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501452578817','1211474926804975617','1448453501452578817',2,2,'泉州轻工职业学院','13799550180','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501599379457','1274912838720167938','1448453501599379457',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501637128193','1216568840104734722','1448453501637128193',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501771345921','1286499346338045953','1448453501771345921',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453501804900354','1218794464953360385','1448453501804900354',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453502102695938','1241252588561698817','1448453502102695938',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453502102695939','1316201027820630017','1448453502102695939',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453502400491522','1290850604855361537','1448453502400491522',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453502723452930','1295900371603947522','1448453502723452930',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453502899613697','1348924009986654209','1448453502899613697',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453503130300417','1351830895278948354','1448453503130300417',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453503314849793','1374554432229978113','1448453503314849793',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453503520370690','1394875586618372097','1448453503520370690',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448453503683948546','1425660338317033473','1448453503683948546',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 09:00:00',NULL,NULL,NULL,'2021-10-14 09:00:00',NULL,NULL,NULL),('1448470331269345282',NULL,'1448470331269345282',2,1,NULL,'15960762288','100809','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 10:06:52',NULL,NULL,NULL,'2021-10-14 10:06:52',NULL,NULL,NULL),('1448472495618289665',NULL,'1448472495618289665',2,1,NULL,'15960762288','601389','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 10:15:28',NULL,NULL,NULL,'2021-10-14 10:15:28',NULL,NULL,NULL),('1448475358562119681',NULL,'1448475358562119681',2,1,NULL,'15960762288','328677','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 10:26:51',NULL,NULL,NULL,'2021-10-14 10:26:51',NULL,NULL,NULL),('1448475609373110274',NULL,'1448475609373110274',2,1,NULL,'15260896313','575271','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 10:27:51',NULL,NULL,NULL,'2021-10-14 10:27:51',NULL,NULL,NULL),('1448475859752087553',NULL,'1448475859752087553',2,1,NULL,'15960762288','215738','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 10:28:51',NULL,NULL,NULL,'2021-10-14 10:28:51',NULL,NULL,NULL),('1448479818541723649',NULL,'1448479818541723649',2,1,NULL,'13960382572','334573','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 10:44:34',NULL,NULL,NULL,'2021-10-14 10:44:34',NULL,NULL,NULL),('1448480920205029377','1274941001584091137','1448480920205029377',2,2,'福建佳汇律师事务所','13275085383','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-14 10:48:57',NULL,NULL,NULL,'2021-10-14 10:48:57',NULL,NULL,NULL),('1448490320135221249',NULL,'1448490320135221249',2,1,NULL,'15960762288','557751','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 11:26:18',NULL,NULL,NULL,'2021-10-14 11:26:18',NULL,NULL,NULL),('1448491553545809922',NULL,'1448491553545809922',2,1,NULL,'15960762288','368335','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 11:31:12',NULL,NULL,NULL,'2021-10-14 11:31:12',NULL,NULL,NULL),('1448493523308408834','1448490535886024706','1448493523308408834',2,2,'福建亚特家具有限公司','15960762288','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-14 11:39:02',NULL,NULL,NULL,'2021-10-14 11:39:02',NULL,NULL,NULL),('1448493826338484226','1448254659343970305','1448493826338484226',2,2,'福建兰峰房地产开发有限公司','13860917850','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-14 11:40:14',NULL,NULL,NULL,'2021-10-14 11:40:14',NULL,NULL,NULL),('1448493954218618882','1447825572620169218','1448493954218618882',2,2,'泉州正朗置业有限公司','17350030786','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-14 11:40:45',NULL,NULL,NULL,'2021-10-14 11:40:45',NULL,NULL,NULL),('1448499147811352578',NULL,'1448499147811352578',2,1,NULL,'18815982681','465183','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 12:01:23',NULL,NULL,NULL,'2021-10-14 12:01:23',NULL,NULL,NULL),('1448546737818988545','1448499254950653954','1448546737818988545',2,2,'泉州市闽运兴物流股份有限公司','18815982681','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-14 15:10:29',NULL,NULL,NULL,'2021-10-14 15:10:29',NULL,NULL,NULL),('1448558720702246913',NULL,'1448558720702246913',2,1,NULL,'18695658252','184477','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 15:58:06',NULL,NULL,NULL,'2021-10-14 15:58:06',NULL,NULL,NULL),('1448558727362801665',NULL,'1448558727362801665',2,1,NULL,'13506026262','296574','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 15:58:08',NULL,NULL,NULL,'2021-10-14 15:58:08',NULL,NULL,NULL),('1448560807972466689',NULL,'1448560807972466689',2,1,NULL,'18350777721','496409','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-14 16:06:24',NULL,NULL,NULL,'2021-10-14 16:06:24',NULL,NULL,NULL),('1448815888261214209','1211167966465470465','1448815888261214209',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888324128770','1212685717864517633','1448815888324128770',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888382849025','1211120827064496130','1448815888382849025',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888718393346','58','1448815888718393346',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888798085121','58','1448815888798085121',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889045549057','1211454669394591746','1448815889045549057',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889062326274','1213032291266269186','1448815889062326274',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889062326275','87','1448815889062326275',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889066520578','1211529007779069954','1448815889066520578',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889104269313','87','1448815889104269313',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889280430081','1211461407799820290','1448815889280430081',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889297207298','1213844233778122754','1448815889297207298',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889297207299','102','1448815889297207299',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889305595906','1211837849989595138','1448815889305595906',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889355927553','102','1448815889355927553',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889490145282','1211473406755651586','1448815889490145282',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889532088321','1219451161745080321','1448815889532088321',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889532088322','1216559724997144578','1448815889532088322',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889704054785','1211474926804975617','1448815889704054785',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889766969346','1274912838720167938','1448815889766969346',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889808912386','1374554432229978113','1448815889808912386',2,2,'福建省晋华集成电路有限公司','15059820805','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889959907330','1216568840104734722','1448815889959907330',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889964101634','1286499346338045953','1448815889964101634',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815889980878850','1417746338413576194','1448815889980878850',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815890207371265','1218794464953360385','1448815890207371265',2,2,'晋江新奥燃气有限公司','13506098847','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815890207371266','1316201027820630017','1448815890207371266',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815890396114945','1241252588561698817','1448815890396114945',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815890610024449','1290850604855361537','1448815890610024449',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815890849099777','1295900371603947522','1448815890849099777',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815891025260546','1348924009986654209','1448815891025260546',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815891243364354','1351830895278948354','1448815891243364354',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815891415330818','1374554432229978113','1448815891415330818',2,2,'福建省晋华集成电路有限公司','15059820805','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815891599880193','1394875586618372097','1448815891599880193',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448815891864121346','1425660338317033473','1448815891864121346',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-15 09:00:00',NULL,NULL,NULL,'2021-10-15 09:00:00',NULL,NULL,NULL),('1448821843417919490',NULL,'1448821843417919490',2,1,NULL,'13636956565','546508','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-15 09:23:39',NULL,NULL,NULL,'2021-10-15 09:23:39',NULL,NULL,NULL),('1448825328708382721',NULL,'1448825328708382721',2,1,NULL,'13636956565','029281','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-15 09:37:30',NULL,NULL,NULL,'2021-10-15 09:37:30',NULL,NULL,NULL),('1448840365330165762',NULL,'1448840365330165762',2,1,NULL,'18606037872','857695','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-15 10:37:15',NULL,NULL,NULL,'2021-10-15 10:37:15',NULL,NULL,NULL),('1448865007688249346',NULL,'1448865007688249346',2,1,NULL,'18959847128','559516','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-15 12:15:11',NULL,NULL,NULL,'2021-10-15 12:15:11',NULL,NULL,NULL),('1449025560377323522',NULL,'1449025560377323522',2,1,NULL,'18350777721','452407','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-15 22:53:09',NULL,NULL,NULL,'2021-10-15 22:53:09',NULL,NULL,NULL),('1449764230201896961',NULL,'1449764230201896961',2,1,NULL,'17370482780','106028','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-17 23:48:22',NULL,NULL,NULL,'2021-10-17 23:48:22',NULL,NULL,NULL),('1449903051807682562','1211167966465470465','1449903051807682562',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903051870597122','1212685717864517633','1449903051870597122',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903051925123073','1211120827064496130','1449903051925123073',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052252278786','58','1449903052252278786',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052256473090','58','1449903052256473090',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052365524994','1213032291266269186','1449903052365524994',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052365524995','1211454669394591746','1449903052365524995',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052461993986','1211529007779069954','1449903052461993986',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052562657281','1213844233778122754','1449903052562657281',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052579434497','1211461407799820290','1449903052579434497',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052579434498','87','1449903052579434498',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052583628801','87','1449903052583628801',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052717846530','1211837849989595138','1449903052717846530',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052797538306','1216559724997144578','1449903052797538306',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052873035778','102','1449903052873035778',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052906590209','102','1449903052906590209',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052906590210','1211473406755651586','1449903052906590210',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052927561730','1219451161745080321','1449903052927561730',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052998864897','1417746338413576194','1449903052998864897',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053103722497','1211474926804975617','1449903053103722497',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053107916801','1274912838720167938','1449903053107916801',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053300854786','1216568840104734722','1449903053300854786',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053309243393','1286499346338045953','1449903053309243393',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053477015553','1316201027820630017','1449903053477015553',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053485404162','1241252588561698817','1449903053485404162',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053657370625','1290850604855361537','1449903053657370625',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903053854502913','1295900371603947522','1449903053854502913',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903054060023809','1348924009986654209','1449903054060023809',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903054248767490','1351830895278948354','1449903054248767490',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903054445899777','1374554432229978113','1449903054445899777',2,2,'福建省晋华集成电路有限公司','15059820805','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903054643032066','1394875586618372097','1449903054643032066',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449903054861135874','1425660338317033473','1449903054861135874',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-18 09:00:00',NULL,NULL,NULL,'2021-10-18 09:00:00',NULL,NULL,NULL),('1449906696116793345',NULL,'1449906696116793345',2,1,NULL,'17605950810','846792','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-18 09:14:28',NULL,NULL,NULL,'2021-10-18 09:14:28',NULL,NULL,NULL),('1449916185658290178','1448840628640182273','1449916185658290178',2,2,'晋江友雅服饰有限公司','18606037872','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-18 09:52:11',NULL,NULL,NULL,'2021-10-18 09:52:11',NULL,NULL,NULL),('1449983640103579649',NULL,'1449983640103579649',2,1,NULL,'15959591503','653811','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-18 14:20:13',NULL,NULL,NULL,'2021-10-18 14:20:13',NULL,NULL,NULL),('1449984660061843458',NULL,'1449984660061843458',2,1,NULL,'15959591503','470838','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-18 14:24:17',NULL,NULL,NULL,'2021-10-18 14:24:17',NULL,NULL,NULL),('1449986411334758402',NULL,'1449986411334758402',2,1,NULL,'15959591503','501971','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-18 14:31:14',NULL,NULL,NULL,'2021-10-18 14:31:14',NULL,NULL,NULL),('1449987592513679362',NULL,'1449987592513679362',2,1,NULL,'15959591503','073111','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-18 14:35:56',NULL,NULL,NULL,'2021-10-18 14:35:56',NULL,NULL,NULL),('1449987846571061249',NULL,'1449987846571061249',2,1,NULL,'15959599010','152883','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-18 14:36:56',NULL,NULL,NULL,'2021-10-18 14:36:56',NULL,NULL,NULL),('1449995231809269762',NULL,'1449995231809269762',2,1,NULL,'15960782997','297711','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-18 15:06:17',NULL,NULL,NULL,'2021-10-18 15:06:17',NULL,NULL,NULL),('1450261482485870594','1449984044086358017','1450261482485870594',2,2,'佳福(福建)染整有限公司','15959591503','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-10-19 08:44:16',NULL,NULL,NULL,'2021-10-19 08:44:16',NULL,NULL,NULL),('1450265439694254082','1211167966465470465','1450265439694254082',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265439723614209','1211120827064496130','1450265439723614209',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265439794917378','1212685717864517633','1450265439794917378',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440164016130','1211454669394591746','1450265440164016130',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440168210433','58','1450265440168210433',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440176599041','1211529007779069954','1450265440176599041',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440193376257','1213032291266269186','1450265440193376257',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440235319297','58','1450265440235319297',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440377925634','1211461407799820290','1450265440377925634',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440382119937','87','1450265440382119937',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440398897154','1211837849989595138','1450265440398897154',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440512143362','87','1450265440512143362',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440533114881','1213844233778122754','1450265440533114881',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440541503489','102','1450265440541503489',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440558280706','1211473406755651586','1450265440558280706',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440596029441','1219451161745080321','1450265440596029441',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440684109826','102','1450265440684109826',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440705081345','1216559724997144578','1450265440705081345',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440738635778','1211474926804975617','1450265440738635778',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440818327554','1274912838720167938','1450265440818327554',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440881242114','1417746338413576194','1450265440881242114',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440906407937','1214097817526620161','1450265440906407937',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440994488322','1286499346338045953','1450265440994488322',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265441145483266','1216568840104734722','1450265441145483266',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265441170649089','1316201027820630017','1450265441170649089',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265441304866818','1217348495564886017','1450265441304866818',2,2,'晋江劲霸男装有限公司','13505959911','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265441493610497','1241252588561698817','1450265441493610497',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265441720102913','1290850604855361537','1450265441720102913',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265441904652290','1295900371603947522','1450265441904652290',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265442147921922','1336495794064195585','1450265442147921922',2,2,'晋江市高甲柯派表演艺术中心','15980092234','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265442332471298','1348924009986654209','1450265442332471298',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265442525409281','1351830895278948354','1450265442525409281',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265442739318786','1374554432229978113','1450265442739318786',2,2,'福建省晋华集成电路有限公司','15059820805','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265442940645377','1394875586618372097','1450265442940645377',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265443158749185','1425660338317033473','1450265443158749185',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265443364270082','1436229755434201090','1450265443364270082',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:00',NULL,NULL,NULL,'2021-10-19 09:00:00',NULL,NULL,NULL),('1450265443586568193','1441226350139568129','1450265443586568193',2,2,'泉州浩然机械科技有限公司','13459402309','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-19 09:00:01',NULL,NULL,NULL,'2021-10-19 09:00:01',NULL,NULL,NULL),('1450279235175346178',NULL,'1450279235175346178',2,1,NULL,'15123961004','396288','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-19 09:54:49',NULL,NULL,NULL,'2021-10-19 09:54:49',NULL,NULL,NULL),('1450281327252238337',NULL,'1450281327252238337',2,1,NULL,'15123961004','606953','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-19 10:03:07',NULL,NULL,NULL,'2021-10-19 10:03:07',NULL,NULL,NULL),('1450627827467579393','1212685717864517633','1450627827467579393',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827480162305','1211167966465470465','1450627827480162305',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827513716738','1211120827064496130','1450627827513716738',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827694071810','58','1450627827694071810',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827744403458','58','1450627827744403458',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827941535745','1211529007779069954','1450627827941535745',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827954118657','1211454669394591746','1450627827954118657',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827958312962','1213032291266269186','1450627827958312962',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828004450305','87','1450627828004450305',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828008644609','87','1450627828008644609',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828126085122','1213844233778122754','1450627828126085122',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828134473730','1211461407799820290','1450627828134473730',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828138668033','1211837849989595138','1450627828138668033',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828176416769','102','1450627828176416769',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828197388290','102','1450627828197388290',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828323217409','1216559724997144578','1450627828323217409',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828327411713','1211465260200935426','1450627828327411713',2,2,'福建金石能源有限公司','13615901213','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828348383233','1219451161745080321','1450627828348383233',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828503572481','1417746338413576194','1450627828503572481',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828511961089','1211473406755651586','1450627828511961089',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828516155393','1274912838720167938','1450627828516155393',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828683927553','1211474926804975617','1450627828683927553',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828692316162','1286499346338045953','1450627828692316162',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828868476929','1211490953219588098','1450627828868476929',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627828872671233','1316201027820630017','1450627828872671233',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627829078192129','1214097817526620161','1450627829078192129',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627829254352897','1216568840104734722','1450627829254352897',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627829438902274','1241252588561698817','1450627829438902274',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627829623451650','1290850604855361537','1450627829623451650',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627829799612417','1295900371603947522','1450627829799612417',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627830068047874','1331809968285810690','1450627830068047874',2,2,'福建省向兴纺织科技有限公司','15880881998','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627830277763074','1348924009986654209','1450627830277763074',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627830500061185','1351830895278948354','1450627830500061185',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627830684610561','1374554432229978113','1450627830684610561',2,2,'福建省晋华集成电路有限公司','15059820805','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627830856577026','1394875586618372097','1450627830856577026',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627831045320705','1418181190581518337','1450627831045320705',2,2,'福建杰斐逊律师事务所','13599100513','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627831234064386','1425660338317033473','1450627831234064386',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:00',NULL,NULL,NULL,'2021-10-20 09:00:00',NULL,NULL,NULL),('1450627831494111233','1436229755434201090','1450627831494111233',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:01',NULL,NULL,NULL,'2021-10-20 09:00:01',NULL,NULL,NULL),('1450627831770935297','1441226350139568129','1450627831770935297',2,2,'泉州浩然机械科技有限公司','13459402309','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-20 09:00:01',NULL,NULL,NULL,'2021-10-20 09:00:01',NULL,NULL,NULL),('1450720920799834113',NULL,'1450720920799834113',2,1,NULL,'15156574542','060312','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-20 15:09:55',NULL,NULL,NULL,'2021-10-20 15:09:55',NULL,NULL,NULL),('1450990215509340162','1211120827064496130','1450990215509340162',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215643557889','1211167966465470465','1450990215643557889',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215668723714','1212685717864517633','1450990215668723714',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215832301569','58','1450990215832301569',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215849078786','58','1450990215849078786',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215970713602','1211529007779069954','1450990215970713602',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216016850945','1213032291266269186','1450990216016850945',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216021045249','1211454669394591746','1450990216021045249',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216138485761','87','1450990216138485761',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216167845890','87','1450990216167845890',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216167845891','1211837849989595138','1450990216167845891',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216276897794','1211461407799820290','1450990216276897794',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216306257921','1213844233778122754','1450990216306257921',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216360783874','102','1450990216360783874',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216419504130','102','1450990216419504130',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216419504131','1219451161745080321','1450990216419504131',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216503390210','1216559724997144578','1450990216503390210',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216507584514','1211465260200935426','1450990216507584514',2,2,'福建金石能源有限公司','13615901213','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216654385154','1274912838720167938','1450990216654385154',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216687939585','1211473406755651586','1450990216687939585',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216696328194','1417746338413576194','1450990216696328194',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216834740226','1286499346338045953','1450990216834740226',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990216872488962','1211474926804975617','1450990216872488962',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990217015095297','1316201027820630017','1450990217015095297',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990217048649730','1211490953219588098','1450990217048649730',2,2,'中国科学院海西研究院泉州装备制造研究所','15980788802','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990217291919361','1214097817526620161','1450990217291919361',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990217526800385','1216568840104734722','1450990217526800385',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990217770070017','1241252588561698817','1450990217770070017',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990217942036481','1290850604855361537','1450990217942036481',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990218139168769','1295900371603947522','1450990218139168769',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990218327912449','1348924009986654209','1450990218327912449',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990218533433346','1351830895278948354','1450990218533433346',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990218789285889','1374554432229978113','1450990218789285889',2,2,'福建省晋华集成电路有限公司','15059820805','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990219036749825','1394875586618372097','1450990219036749825',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:00',NULL,NULL,NULL,'2021-10-21 09:00:00',NULL,NULL,NULL),('1450990219233882114','1425660338317033473','1450990219233882114',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:01',NULL,NULL,NULL,'2021-10-21 09:00:01',NULL,NULL,NULL),('1450990219607175169','1441226350139568129','1450990219607175169',2,2,'泉州浩然机械科技有限公司','13459402309','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-21 09:00:01',NULL,NULL,NULL,'2021-10-21 09:00:01',NULL,NULL,NULL),('1451106554978791425',NULL,'1451106554978791425',2,1,NULL,'13860758321','577117','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-21 16:42:17',NULL,NULL,NULL,'2021-10-21 16:42:17',NULL,NULL,NULL),('1451253206997823490',NULL,'1451253206997823490',2,1,NULL,'18468105414','327378','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-22 02:25:02',NULL,NULL,NULL,'2021-10-22 02:25:02',NULL,NULL,NULL),('1451352603316219905','1212685717864517633','1451352603316219905',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603332997122','1211167966465470465','1451352603332997122',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603391717378','1211120827064496130','1451352603391717378',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603572072450','58','1451352603572072450',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603614015490','58','1451352603614015490',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603798564865','1213032291266269186','1451352603798564865',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603802759169','1211454669394591746','1451352603802759169',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603811147778','1211529007779069954','1451352603811147778',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603844702209','87','1451352603844702209',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603899228161','87','1451352603899228161',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604029251585','1211461407799820290','1451352604029251585',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604058611714','102','1451352604058611714',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604062806017','1213844233778122754','1451352604062806017',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604075388929','1211837849989595138','1451352604075388929',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604217995266','1211473406755651586','1451352604217995266',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604217995267','102','1451352604217995267',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604301881346','1216559724997144578','1451352604301881346',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604306075649','1219451161745080321','1451352604306075649',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604398350338','1211474926804975617','1451352604398350338',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604494819329','1417746338413576194','1451352604494819329',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604499013633','1274912838720167938','1451352604499013633',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604616454146','1214097817526620161','1451352604616454146',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604754866178','1286499346338045953','1451352604754866178',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604905861122','1216568840104734722','1451352604905861122',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352604960387073','1316201027820630017','1451352604960387073',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352605178490882','1241252588561698817','1451352605178490882',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352605354651650','1290850604855361537','1451352605354651650',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352605543395330','1295900371603947522','1451352605543395330',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352605765693442','1341318122925195265','1451352605765693442',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352606013157378','1348924009986654209','1451352606013157378',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352606193512449','1351830895278948354','1451352606193512449',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352606432587778','1374554432229978113','1451352606432587778',2,2,'福建省晋华集成电路有限公司','15059820805','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352606646497281','1394875586618372097','1451352606646497281',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352606835240961','1425660338317033473','1451352606835240961',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:00',NULL,NULL,NULL,'2021-10-22 09:00:00',NULL,NULL,NULL),('1451352607082704898','1441226350139568129','1451352607082704898',2,2,'泉州浩然机械科技有限公司','13459402309','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-22 09:00:01',NULL,NULL,NULL,'2021-10-22 09:00:01',NULL,NULL,NULL),('1451550356877111298',NULL,'1451550356877111298',2,1,NULL,'13067249699','012401','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-22 22:05:48',NULL,NULL,NULL,'2021-10-22 22:05:48',NULL,NULL,NULL),('1452439766812356609','1212685717864517633','1452439766812356609',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439766896242690','1211120827064496130','1452439766896242690',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439766950768642','1211167966465470465','1452439766950768642',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767303090177','58','1452439767303090177',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767303090178','1211529007779069954','1452439767303090178',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767311478785','58','1452439767311478785',1,2,'张荣荣','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767311478786','83','1452439767311478786',1,2,'李女元','15359825666','2,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767319867394','1213032291266269186','1452439767319867394',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767437307905','1211442194934710274','1452439767437307905',2,2,'信泰(福建)科技有限公司','15027340243','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767546359809','86','1452439767546359809',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767592497153','1211837849989595138','1452439767592497153',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767638634497','87','1452439767638634497',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767642828802','1211454669394591746','1452439767642828802',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767651217409','1213844233778122754','1452439767651217409',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767659606018','87','1452439767659606018',1,2,'叶志钦','13675957398','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767793823746','1219451161745080321','1452439767793823746',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767848349698','102','1452439767848349698',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767928041473','102','1452439767928041473',1,2,'颜思思','15280619456','5,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767928041474','1211461407799820290','1452439767928041474',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767940624386','1216559724997144578','1452439767940624386',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768032899073','1274912838720167938','1452439768032899073',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768112590850','1211473406755651586','1452439768112590850',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768129368065','1417746338413576194','1452439768129368065',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768204865537','1286499346338045953','1452439768204865537',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768297140226','1211474926804975617','1452439768297140226',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768381026305','1316201027820630017','1452439768381026305',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768477495298','1211837849989595138','1452439768477495298',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768670433281','1212580494957416450','1452439768670433281',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439768854982657','1214097817526620161','1452439768854982657',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439769031143425','1215115207978827777','1452439769031143425',2,2,'福州大学晋江科教园管委会','15980228632','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439769211498497','1216568840104734722','1452439769211498497',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439769387659265','1241252588561698817','1452439769387659265',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439769635123201','1290850604855361537','1452439769635123201',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439769886781441','1295900371603947522','1452439769886781441',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439770109079553','1341318122925195265','1452439770109079553',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439770352349186','1348924009986654209','1452439770352349186',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439770549481474','1351830895278948354','1452439770549481474',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:00',NULL,NULL,NULL,'2021-10-25 09:00:00',NULL,NULL,NULL),('1452439770843082753','1374554432229978113','1452439770843082753',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:01',NULL,NULL,NULL,'2021-10-25 09:00:01',NULL,NULL,NULL),('1452439771048603650','1394875586618372097','1452439771048603650',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:01',NULL,NULL,NULL,'2021-10-25 09:00:01',NULL,NULL,NULL),('1452439771312844801','1425660338317033473','1452439771312844801',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:01',NULL,NULL,NULL,'2021-10-25 09:00:01',NULL,NULL,NULL),('1452439771501588481','1448499254950653954','1452439771501588481',2,2,'泉州市闽运兴物流股份有限公司','18815982681','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-25 09:00:01',NULL,NULL,NULL,'2021-10-25 09:00:01',NULL,NULL,NULL),('1452468059817144322',NULL,'1452468059817144322',2,1,NULL,'17759502791','620082','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-25 10:52:25',NULL,NULL,NULL,'2021-10-25 10:52:25',NULL,NULL,NULL),('1452469379064164353',NULL,'1452469379064164353',2,1,NULL,'18815981178','166099','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-25 10:57:40',NULL,NULL,NULL,'2021-10-25 10:57:40',NULL,NULL,NULL),('1452530164947775490',NULL,'1452530164947775490',2,1,NULL,'13489272625','784673','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-25 14:59:12',NULL,NULL,NULL,'2021-10-25 14:59:12',NULL,NULL,NULL),('1452530755459641345',NULL,'1452530755459641345',2,1,NULL,'13489272625','728930','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-25 15:01:33',NULL,NULL,NULL,'2021-10-25 15:01:33',NULL,NULL,NULL),('1452547470134374402',NULL,'1452547470134374402',2,1,NULL,'15960551920','351982','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-25 16:07:58',NULL,NULL,NULL,'2021-10-25 16:07:58',NULL,NULL,NULL),('1452802154648596481','1211167966465470465','1452802154648596481',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802154770231297','1212685717864517633','1452802154770231297',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802154828951554','1211120827064496130','1452802154828951554',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155114164225','58','1452802155114164225',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155239993345','72','1452802155239993345',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155239993346','83','1452802155239993346',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155281936385','1213032291266269186','1452802155281936385',2,2,'福建优安纳伞业科技有限公司','15959508318','2,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155290324993','1211442194934710274','1452802155290324993',2,2,'信泰(福建)科技有限公司','15027340243','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155416154113','1211529007779069954','1452802155416154113',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155474874369','87','1452802155474874369',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155483262977','86','1452802155483262977',1,2,'洪嘉靖','13600737303','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155491651585','58','1452802155491651585',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155604897793','1211454669394591746','1452802155604897793',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155617480706','1213844233778122754','1452802155617480706',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155659423746','1211837849989595138','1452802155659423746',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155659423747','87','1452802155659423747',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155676200962','102','1452802155676200962',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155848167425','1211461407799820290','1452802155848167425',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155848167426','1216559724997144578','1452802155848167426',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155881721858','1219451161745080321','1452802155881721858',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155881721859','102','1452802155881721859',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802156074659842','1211473406755651586','1452802156074659842',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802156074659843','1274912838720167938','1452802156074659843',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802156355678209','1211474926804975617','1452802156355678209',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802156355678210','1286499346338045953','1452802156355678210',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802156586364930','1316201027820630017','1452802156586364930',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802156603142145','1211837849989595138','1452802156603142145',2,2,'利郎（中国）有限公司','15959420909','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802156825440257','1212580494957416450','1452802156825440257',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL);
INSERT INTO `sys_message_record` VALUES ('1452802157018378242','1214097817526620161','1452802157018378242',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802157215510529','1215115207978827777','1452802157215510529',2,2,'福州大学晋江科教园管委会','15980228632','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802157408448514','1216568840104734722','1452802157408448514',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802157697855489','1241252588561698817','1452802157697855489',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802157957902338','1286499346338045953','1452802157957902338',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802158176006145','1290850604855361537','1452802158176006145',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802158398304257','1295900371603947522','1452802158398304257',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:00',NULL,NULL,NULL,'2021-10-26 09:00:00',NULL,NULL,NULL),('1452802158587047937','1341318122925195265','1452802158587047937',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:01',NULL,NULL,NULL,'2021-10-26 09:00:01',NULL,NULL,NULL),('1452802158784180226','1348924009986654209','1452802158784180226',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:01',NULL,NULL,NULL,'2021-10-26 09:00:01',NULL,NULL,NULL),('1452802158985506818','1351830895278948354','1452802158985506818',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:01',NULL,NULL,NULL,'2021-10-26 09:00:01',NULL,NULL,NULL),('1452802159195222018','1374554432229978113','1452802159195222018',2,2,'福建省晋华集成电路有限公司','15059820805','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:01',NULL,NULL,NULL,'2021-10-26 09:00:01',NULL,NULL,NULL),('1452802159388160002','1394875586618372097','1452802159388160002',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:01',NULL,NULL,NULL,'2021-10-26 09:00:01',NULL,NULL,NULL),('1452802159589486593','1425660338317033473','1452802159589486593',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:01',NULL,NULL,NULL,'2021-10-26 09:00:01',NULL,NULL,NULL),('1452802159790813185','1446394329768685570','1452802159790813185',2,2,'泉州市兰陵形象设计有限公司','13489311953','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-26 09:00:01',NULL,NULL,NULL,'2021-10-26 09:00:01',NULL,NULL,NULL),('1453164542740688898','1212685717864517633','1453164542740688898',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542740688899','1211120827064496130','1453164542740688899',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542795214850','1211167966465470465','1453164542795214850',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542979764225','58','1453164542979764225',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543134953473','72','1453164543134953473',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543147536385','83','1453164543147536385',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543227228161','1211442194934710274','1453164543227228161',2,2,'信泰(福建)科技有限公司','15027340243','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543239811073','1211529007779069954','1453164543239811073',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543248199682','1213844233778122754','1453164543248199682',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543361445889','87','1453164543361445889',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543403388929','58','1453164543403388929',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543466303489','1211454669394591746','1453164543466303489',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543466303490','1216559724997144578','1453164543466303490',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543474692097','1211837849989595138','1453164543474692097',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543566966786','102','1453164543566966786',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543625687041','87','1453164543625687041',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543701184513','1219451161745080321','1453164543701184513',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543701184514','1211461407799820290','1453164543701184514',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543810236418','102','1453164543810236418',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543936065538','1211473406755651586','1453164543936065538',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543952842754','1274912838720167938','1453164543952842754',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164544112226305','1211474926804975617','1453164544112226305',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164544129003522','1286499346338045953','1453164544129003522',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164544288387073','1214097817526620161','1453164544288387073',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164544300969985','1316201027820630017','1453164544300969985',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164544472936450','1216568840104734722','1453164544472936450',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164544737177601','1241252588561698817','1453164544737177601',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164544963670018','1290850604855361537','1453164544963670018',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164545215328258','1295900371603947522','1453164545215328258',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164545412460545','1341318122925195265','1453164545412460545',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164545685090305','1348924009986654209','1453164545685090305',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164546045800449','1351830895278948354','1453164546045800449',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164546284875778','1374549152519794689','1453164546284875778',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:00',NULL,NULL,NULL,'2021-10-27 09:00:00',NULL,NULL,NULL),('1453164546540728321','1374554432229978113','1453164546540728321',2,2,'福建省晋华集成电路有限公司','15059820805','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:01',NULL,NULL,NULL,'2021-10-27 09:00:01',NULL,NULL,NULL),('1453164546721083394','1394875586618372097','1453164546721083394',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:01',NULL,NULL,NULL,'2021-10-27 09:00:01',NULL,NULL,NULL),('1453164546960158721','1425660338317033473','1453164546960158721',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-27 09:00:01',NULL,NULL,NULL,'2021-10-27 09:00:01',NULL,NULL,NULL),('1453378583903891458',NULL,'1453378583903891458',2,1,NULL,'19959889215','388633','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-27 23:10:31',NULL,NULL,NULL,'2021-10-27 23:10:31',NULL,NULL,NULL),('1453526930514014210','1211167966465470465','1453526930514014210',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930581123074','1211120827064496130','1453526930581123074',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930585317378','1212685717864517633','1453526930585317378',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930765672449','58','1453526930765672449',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'未知错误','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930799226881','72','1453526930799226881',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930828587010','83','1453526930828587010',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930983776257','1211442194934710274','1453526930983776257',2,2,'信泰(福建)科技有限公司','15027340243','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930992164866','1213844233778122754','1453526930992164866',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930992164867','1211529007779069954','1453526930992164867',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931042496513','58','1453526931042496513',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931050885121','87','1453526931050885121',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931218657281','1211454669394591746','1453526931218657281',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931222851585','1211837849989595138','1453526931222851585',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931227045889','87','1453526931227045889',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931227045890','1216559724997144578','1453526931227045890',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931248017409','102','1453526931248017409',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931428372481','1211461407799820290','1453526931428372481',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931428372482','102','1453526931428372482',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931428372483','1219451161745080321','1453526931428372483',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931642281985','1211473406755651586','1453526931642281985',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931650670593','1274912838720167938','1453526931650670593',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931818442754','1211474926804975617','1453526931818442754',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526931826831362','1286499346338045953','1453526931826831362',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526932002992130','1214097817526620161','1453526932002992130',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526932002992131','1316201027820630017','1453526932002992131',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526932187541505','1216568840104734722','1453526932187541505',2,2,'晋江市福大科教园区发展中心','15880272172','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526932376285185','1241252588561698817','1453526932376285185',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526932556640258','1290850604855361537','1453526932556640258',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526932736995330','1295900371603947522','1453526932736995330',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526932955099138','1341318122925195265','1453526932955099138',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526933206757378','1348924009986654209','1453526933206757378',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526933525524482','1351830895278948354','1453526933525524482',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526933714268162','1374549152519794689','1453526933714268162',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526933898817537','1374554432229978113','1453526933898817537',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526934129504257','1376712565047975937','1453526934129504257',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:00',NULL,NULL,NULL,'2021-10-28 09:00:00',NULL,NULL,NULL),('1453526934343413762','1394875586618372097','1453526934343413762',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-28 09:00:01',NULL,NULL,NULL,'2021-10-28 09:00:01',NULL,NULL,NULL),('1453526934548934657','1425660338317033473','1453526934548934657',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2021-10-28 09:00:01',NULL,NULL,NULL,'2021-10-28 09:00:01',NULL,NULL,NULL),('1453566272812904450',NULL,'1453566272812904450',2,1,NULL,'18862155979','906780','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-28 11:36:20',NULL,NULL,NULL,'2021-10-28 11:36:20',NULL,NULL,NULL),('1453889318346059777','1211920348237316098','1453889318346059777',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318404780033','1211120827064496130','1453889318404780033',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318425751554','1211167966465470465','1453889318425751554',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318803238914','1211529007779069954','1453889318803238914',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318820016130','1211442194934710274','1453889318820016130',2,2,'信泰(福建)科技有限公司','15027340243','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318820016131','1212685717864517633','1453889318820016131',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318832599041','58','1453889318832599041',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318857764865','72','1453889318857764865',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318891319298','83','1453889318891319298',1,2,'李女元','15359825666','5,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319021342721','1213844233778122754','1453889319021342721',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319046508545','1211837849989595138','1453889319046508545',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319084257281','1211454669394591746','1453889319084257281',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319172337666','58','1453889319172337666',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319176531970','87','1453889319176531970',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319214280706','1215207699331989506','1453889319214280706',2,2,'晋江市医院','18350528526','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319226863618','1219451161745080321','1453889319226863618',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319335915521','1211461407799820290','1453889319335915521',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319348498433','102','1453889319348498433',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319361081345','87','1453889319361081345',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319386247169','1216559724997144578','1453889319386247169',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319423995905','1274912838720167938','1453889319423995905',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319512076290','1211473406755651586','1453889319512076290',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319587573762','102','1453889319587573762',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319600156674','1286499346338045953','1453889319600156674',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'被叫挂断、超时未接、关机、停机、欠费、手机号码错误导致失败。','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319604350977','1417746338413576194','1453889319604350977',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319684042753','1211474926804975617','1453889319684042753',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319767928834','1316201027820630017','1453889319767928834',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889319839232002','1211482027447074818','1453889319839232002',2,2,'福建晋江天然气发电有限公司','18876398522','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889320015392769','1211490446086291458','1453889320015392769',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889320187359234','1212580494957416450','1453889320187359234',2,2,'舒华体育股份有限公司','13599295908','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889320388685826','1214097817526620161','1453889320388685826',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889320556457985','1216568840104734722','1453889320556457985',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889320795533314','1241252588561698817','1453889320795533314',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889321030414337','1290850604855361537','1453889321030414337',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889321256906754','1295900371603947522','1453889321256906754',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889321449844737','1298548254794969089','1453889321449844737',2,2,'福建省晋江市金童蚊香制品有限公司','13506085037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889321701502977','1341318122925195265','1453889321701502977',2,2,'泉州晋江国际机场股份有限公司','15980019030','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889321894440962','1348924009986654209','1453889321894440962',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889322066407425','1351830895278948354','1453889322066407425',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:00',NULL,NULL,NULL,'2021-10-29 09:00:00',NULL,NULL,NULL),('1453889322242568194','1374549152519794689','1453889322242568194',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453889322422923266','1374554432229978113','1453889322422923266',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453889322754273281','1376712565047975937','1453889322754273281',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453889322984960002','1394875586618372097','1453889322984960002',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453889323219841025','1399577737844260865','1453889323219841025',2,2,'厦门航空有限公司泉州分公司','13960391906','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453889323546996737','1425660338317033473','1453889323546996737',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453889323832209409','1436229755434201090','1453889323832209409',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'未知错误','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453889324008370178','1447825572620169218','1453889324008370178',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-10-29 09:00:01',NULL,NULL,NULL,'2021-10-29 09:00:01',NULL,NULL,NULL),('1453892185333198850',NULL,'1453892185333198850',2,1,NULL,'17750981257','829552','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-29 09:11:23',NULL,NULL,NULL,'2021-10-29 09:11:23',NULL,NULL,NULL),('1454024359822782465',NULL,'1454024359822782465',2,1,NULL,'15160799171','506979','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-10-29 17:56:36',NULL,NULL,NULL,'2021-10-29 17:56:36',NULL,NULL,NULL),('1454976481913499649','1211167966465470465','1454976481913499649',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976481917693953','1211479976335949826','1454976481917693953',2,2,'福建省晋江市兴达机电器材有限公司','18960355033','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976481968025602','1211945706491789313','1454976481968025602',2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482026745857','1211120827064496130','1454976482026745857',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482429399043','1211454669394591746','1454976482429399043',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482429399046','1211548619757371393','1454976482429399046',2,2,'晋江市城乡规划设计研究院有限责任公司','15059528886','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482538450945','58','1454976482538450945',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482538450946','72','1454976482538450946',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482542645249','83','1454976482542645249',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482605559809','1211529007779069954','1454976482605559809',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482655891457','1211461407799820290','1454976482655891457',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482693640193','1211920348237316098','1454976482693640193',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482752360449','87','1454976482752360449',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482769137665','71','1454976482769137665',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482857218049','1211465260200935426','1454976482857218049',2,2,'福建金石能源有限公司','13615901213','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482857218050','1211837849989595138','1454976482857218050',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482873995265','1212685717864517633','1454976482873995265',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483004018689','102','1454976483004018689',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483033378818','58','1454976483033378818',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483054350338','1219451161745080321','1454976483054350338',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483058544642','1213844233778122754','1454976483058544642',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483062738946','1211473406755651586','1454976483062738946',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483188568066','87','1454976483188568066',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483234705409','1274912838720167938','1454976483234705409',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483234705410','1215446302779817985','1454976483234705410',2,2,'福建省力和勘察设计有限公司','13950238890','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483268259841','1211474926804975617','1454976483268259841',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483352145921','102','1454976483352145921',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483457003521','1286499346338045953','1454976483457003521',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483461197825','1216559724997144578','1454976483461197825',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483469586434','1211482027447074818','1454976483469586434',2,2,'福建晋江天然气发电有限公司','18876398522','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483637358593','1316201027820630017','1454976483637358593',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483637358594','1417746338413576194','1454976483637358594',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483641552898','1212580494957416450','1454976483641552898',2,2,'舒华体育股份有限公司','13599295908','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483872239617','1216568840104734722','1454976483872239617',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976483876433921','1420924342417514497','1454976483876433921',2,2,'福建灵雀谷生物科技有限公司','15392079089','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976484044206082','1241252588561698817','1454976484044206082',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976484228755457','1286499346338045953','1454976484228755457',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976484484608001','1290850604855361537','1454976484484608001',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976484794986498','1295900371603947522','1454976484794986498',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976485008896001','1298548254794969089','1454976485008896001',2,2,'福建省晋江市金童蚊香制品有限公司','13506085037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976485193445377','1341318122925195265','1454976485193445377',2,2,'泉州晋江国际机场股份有限公司','15980019030','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976485554155521','1348924009986654209','1454976485554155521',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:00',NULL,NULL,NULL,'2021-11-01 09:00:00',NULL,NULL,NULL),('1454976485726121985','1351830895278948354','1454976485726121985',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976485973585922','1374549152519794689','1454976485973585922',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976486221049858','1374554432229978113','1454976486221049858',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976486422376449','1376712565047975937','1454976486422376449',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976486611120129','1394875586618372097','1454976486611120129',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976486955053058','1399577737844260865','1454976486955053058',2,2,'厦门航空有限公司泉州分公司','13960391906','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976487168962562','1425660338317033473','1454976487168962562',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976487345123330','1441226350139568129','1454976487345123330',2,2,'泉州浩然机械科技有限公司','13459402309','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454976487571615745','1447825572620169218','1454976487571615745',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-01 09:00:01',NULL,NULL,NULL,'2021-11-01 09:00:01',NULL,NULL,NULL),('1454978456537296898','1453892385195978753','1454978456537296898',2,2,'晋江市鹏星社会工作发展与评估中心','17750981257','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-01 09:07:50',NULL,NULL,NULL,'2021-11-01 09:07:50',NULL,NULL,NULL),('1455100744737779714',NULL,'1455100744737779714',2,1,NULL,'13675957398','788712','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-01 17:13:46',NULL,NULL,NULL,'2021-11-01 17:13:46',NULL,NULL,NULL),('1455101157251772418','1455101079799754754','1455101157251772418',2,2,'测试账号A','13675957398','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-01 17:15:25',NULL,NULL,NULL,'2021-11-01 17:15:25',NULL,NULL,NULL),('1455101349875183618',NULL,'1455101349875183618',2,1,NULL,'13675957398','690513','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-01 17:16:10',NULL,NULL,NULL,'2021-11-01 17:16:10',NULL,NULL,NULL),('1455338869749739521','1211167966465470465','1455338869749739521',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338869770711042','1211920348237316098','1455338869770711042',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338869804265474','1211945706491789313','1455338869804265474',2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338869846208514','1211120827064496130','1455338869846208514',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870181752833','58','1455338870181752833',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870248861698','83','1455338870248861698',1,2,'李女元','15359825666','6,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870269833217','72','1455338870269833217',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870278221825','1211454669394591746','1455338870278221825',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870286610434','1212540446794911745','1455338870286610434',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870378885121','1211529007779069954','1455338870378885121',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870487937025','87','1455338870487937025',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870492131330','1211461407799820290','1455338870492131330',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870508908546','1212685717864517633','1455338870508908546',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870555045889','58','1455338870555045889',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870563434497','1211837849989595138','1455338870563434497',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870659903490','102','1455338870659903490',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870710235137','1211465260200935426','1455338870710235137',2,2,'福建金石能源有限公司','13615901213','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870735400962','1213100306318036993','1455338870735400962',2,2,'华兴诚信（晋江）财务咨询有限公司','13960259639','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870760566786','1219451161745080321','1455338870760566786',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870798315522','87','1455338870798315522',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870907367426','1213844233778122754','1455338870907367426',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870924144641','1211473406755651586','1455338870924144641',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870970281986','1274912838720167938','1455338870970281986',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871008030722','102','1455338871008030722',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871087722498','1215446302779817985','1455338871087722498',2,2,'福建省力和勘察设计有限公司','13950238890','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871159025665','1211474926804975617','1455338871159025665',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871179997186','1286499346338045953','1455338871179997186',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871251300354','1216559724997144578','1455338871251300354',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871330992129','1211482027447074818','1455338871330992129',2,2,'福建晋江天然气发电有限公司','18876398522','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871339380737','1316201027820630017','1455338871339380737',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871448432641','1417746338413576194','1455338871448432641',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871498764290','1211840469537964033','1455338871498764290',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338871666536449','1212580494957416450','1455338871666536449',2,2,'舒华体育股份有限公司','13599295908','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338873444921345','1214097817526620161','1455338873444921345',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:00',NULL,NULL,NULL,'2021-11-02 09:00:00',NULL,NULL,NULL),('1455338873642053634','1216568840104734722','1455338873642053634',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338873826603010','1216626668072869889','1455338873826603010',2,2,'晋江市融媒体中心','13505079029','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338874048901121','1241252588561698817','1455338874048901121',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338874250227714','1290850604855361537','1455338874250227714',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338874447360001','1295900371603947522','1455338874447360001',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338874615132161','1298548254794969089','1455338874615132161',2,2,'福建省晋江市金童蚊香制品有限公司','13506085037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338874795487234','1341318122925195265','1455338874795487234',2,2,'泉州晋江国际机场股份有限公司','15980019030','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338875001008130','1348924009986654209','1455338875001008130',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338875189751810','1351830895278948354','1455338875189751810',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338875361718273','1374549152519794689','1455338875361718273',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338875617570817','1374554432229978113','1455338875617570817',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338875793731586','1376712565047975937','1455338875793731586',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338875999252481','1394875586618372097','1455338875999252481',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338876204773378','1399577737844260865','1455338876204773378',2,2,'厦门航空有限公司泉州分公司','13960391906','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338876380934145','1425660338317033473','1455338876380934145',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338876548706306','1436229755434201090','1455338876548706306',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455338876733255682','1447825572620169218','1455338876733255682',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-02 09:00:01',NULL,NULL,NULL,'2021-11-02 09:00:01',NULL,NULL,NULL),('1455343831678480386',NULL,'1455343831678480386',2,1,NULL,'15159641350','149626','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-02 09:19:43',NULL,NULL,NULL,'2021-11-02 09:19:43',NULL,NULL,NULL),('1455701257648893953','1211945706491789313','1455701257648893953',2,2,'福建七匹狼实业股份有限公司','13859769696','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701257749557249','1211920348237316098','1455701257749557249',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701257766334466','1211167966465470465','1455701257766334466',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701257791500290','1211120827064496130','1455701257791500290',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258252873730','1211454669394591746','1455701258252873730',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258286428161','1211529007779069954','1455701258286428161',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258286428162','58','1455701258286428162',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258294816769','72','1455701258294816769',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258366119938','1212540446794911745','1455701258366119938',2,2,'晋江七匹狼服装制造有限公司','13489768628','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258512920577','1211461407799820290','1455701258512920577',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258521309186','87','1455701258521309186',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258546475009','1211837849989595138','1455701258546475009',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258546475010','58','1455701258546475010',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258668109826','1212685717864517633','1455701258668109826',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258781356034','102','1455701258781356034',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258793938945','1219451161745080321','1455701258793938945',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258793938946','1211465260200935426','1455701258793938946',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258793938947','87','1455701258793938947',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258936545281','1213844233778122754','1455701258936545281',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258965905409','102','1455701258965905409',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258986876930','1211473406755651586','1455701258986876930',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258986876931','1274912838720167938','1455701258986876931',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259129483265','1215446302779817985','1455701259129483265',2,2,'福建省力和勘察设计有限公司','13950238890','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259154649089','1286499346338045953','1455701259154649089',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259184009217','1211474926804975617','1455701259184009217',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259343392770','1316201027820630017','1455701259343392770',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259351781378','1216559724997144578','1455701259351781378',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259435667457','1211482027447074818','1455701259435667457',2,2,'福建晋江天然气发电有限公司','18876398522','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259657965570','1211490446086291458','1455701259657965570',2,2,'泉州职业技术大学','18060007601','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259662159874','1417746338413576194','1455701259662159874',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701259838320642','1211840469537964033','1455701259838320642',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701260031258625','1212580494957416450','1455701260031258625',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701260220002306','1214097817526620161','1455701260220002306',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701260404551681','1216568840104734722','1455701260404551681',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701260589101058','1216626668072869889','1455701260589101058',2,2,'晋江市融媒体中心','13505079029','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701260815593473','1241252588561698817','1455701260815593473',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701261004337153','1290850604855361537','1455701261004337153',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701261188886530','1295900371603947522','1455701261188886530',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701261390213122','1298548254794969089','1455701261390213122',2,2,'福建省晋江市金童蚊香制品有限公司','13506085037','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:00',NULL,NULL,NULL,'2021-11-03 09:00:00',NULL,NULL,NULL),('1455701261566373890','1341318122925195265','1455701261566373890',2,2,'泉州晋江国际机场股份有限公司','15980019030','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701261763506178','1348924009986654209','1455701261763506178',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701261956444161','1351830895278948354','1455701261956444161',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701262182936578','1374549152519794689','1455701262182936578',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701262375874561','1374554432229978113','1455701262375874561',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701262585589762','1376712565047975937','1455701262585589762',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701262854025217','1394875586618372097','1455701262854025217',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701263051157506','1425660338317033473','1455701263051157506',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701263235706881','1436229755434201090','1455701263235706881',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1455701263437033473','1447825572620169218','1455701263437033473',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-03 09:00:01',NULL,NULL,NULL,'2021-11-03 09:00:01',NULL,NULL,NULL),('1456063645694849026','1211120827064496130','1456063645694849026',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645699043330','1211167966465470465','1456063645699043330',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645699043331','1211920348237316098','1456063645699043331',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645988450305','58','1456063645988450305',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646101696513','1211529007779069954','1456063646101696513',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646135250945','1211454669394591746','1456063646135250945',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646160416770','72','1456063646160416770',1,2,'翁海勇','13599173733','2,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646235914241','1212685717864517633','1456063646235914241',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646349160449','87','1456063646349160449',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646449823746','1211461407799820290','1456063646449823746',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646449823747','1211837849989595138','1456063646449823747',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646474989569','58','1456063646474989569',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646516932609','1213844233778122754','1456063646516932609',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646609207297','102','1456063646609207297',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646663733249','87','1456063646663733249',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646684704770','1219451161745080321','1456063646684704770',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646684704771','1211465260200935426','1456063646684704771',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646802145281','1216559724997144578','1456063646802145281',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646852476930','102','1456063646852476930',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646881837058','1274912838720167938','1456063646881837058',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063646881837059','1211473406755651586','1456063646881837059',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647028637697','1417746338413576194','1456063647028637697',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647053803522','1211474926804975617','1456063647053803522',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647053803523','1286499346338045953','1456063647053803523',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647217381378','1211482027447074818','1456063647217381378',2,2,'福建晋江天然气发电有限公司','18876398522','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647221575681','1316201027820630017','1456063647221575681',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647448068098','1212580494957416450','1456063647448068098',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647628423170','1214097817526620161','1456063647628423170',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647800389634','1216568840104734722','1456063647800389634',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063647968161793','1216626668072869889','1456063647968161793',2,2,'晋江市融媒体中心','13505079029','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063648131739649','1241252588561698817','1456063648131739649',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063648354037761','1290850604855361537','1456063648354037761',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063648588918785','1295900371603947522','1456063648588918785',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063648769273858','1341318122925195265','1456063648769273858',2,2,'泉州晋江国际机场股份有限公司','15980019030','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063649020932098','1348924009986654209','1456063649020932098',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063649243230210','1351830895278948354','1456063649243230210',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:00',NULL,NULL,NULL,'2021-11-04 09:00:00',NULL,NULL,NULL),('1456063649482305538','1374549152519794689','1456063649482305538',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:01',NULL,NULL,NULL,'2021-11-04 09:00:01',NULL,NULL,NULL),('1456063649666854914','1374554432229978113','1456063649666854914',2,2,'福建省晋华集成电路有限公司','15059820805','5,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:01',NULL,NULL,NULL,'2021-11-04 09:00:01',NULL,NULL,NULL),('1456063649952067586','1376712565047975937','1456063649952067586',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:01',NULL,NULL,NULL,'2021-11-04 09:00:01',NULL,NULL,NULL),('1456063650145005570','1394875586618372097','1456063650145005570',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:01',NULL,NULL,NULL,'2021-11-04 09:00:01',NULL,NULL,NULL),('1456063650451189761','1425660338317033473','1456063650451189761',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:01',NULL,NULL,NULL,'2021-11-04 09:00:01',NULL,NULL,NULL),('1456063650631544834','1436229755434201090','1456063650631544834',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:01',NULL,NULL,NULL,'2021-11-04 09:00:01',NULL,NULL,NULL),('1456063650862231554','1447825572620169218','1456063650862231554',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-04 09:00:01',NULL,NULL,NULL,'2021-11-04 09:00:01',NULL,NULL,NULL),('1456074042426552321','1452530245683933185','1456074042426552321',2,2,'晋江智信大数据科技有限公司','13489272625','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-04 09:41:18',NULL,NULL,NULL,'2021-11-04 09:41:18',NULL,NULL,NULL),('1456074096247861249','1452469610119983105','1456074096247861249',2,2,'晋江市清新文旅产业运营管理有限公司','18815981178','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-04 09:41:31',NULL,NULL,NULL,'2021-11-04 09:41:31',NULL,NULL,NULL),('1456155972169920513',NULL,'1456155972169920513',2,1,NULL,'15280112534','988448','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-04 15:06:52',NULL,NULL,NULL,'2021-11-04 15:06:52',NULL,NULL,NULL),('1456157931698417666',NULL,'1456157931698417666',2,1,NULL,'15280112534','466816','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-04 15:14:39',NULL,NULL,NULL,'2021-11-04 15:14:39',NULL,NULL,NULL),('1456160409550614530',NULL,'1456160409550614530',2,1,NULL,'15280112534','553077','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-04 15:24:30',NULL,NULL,NULL,'2021-11-04 15:24:30',NULL,NULL,NULL),('1456161008841158657',NULL,'1456161008841158657',2,1,NULL,'15280112534','200763','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-04 15:26:53',NULL,NULL,NULL,'2021-11-04 15:26:53',NULL,NULL,NULL),('1456162584733446145',NULL,'1456162584733446145',2,1,NULL,'15280112534','934333','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-04 15:33:09',NULL,NULL,NULL,'2021-11-04 15:33:09',NULL,NULL,NULL),('1456426033434619906','1211167966465470465','1456426033434619906',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033438814209','1211920348237316098','1456426033438814209',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033514311682','1211120827064496130','1456426033514311682',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033791135746','72','1456426033791135746',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033862438913','1212685717864517633','1456426033862438913',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033866633217','58','1456426033866633217',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033971490818','1211454669394591746','1456426033971490818',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034009239554','1211529007779069954','1456426034009239554',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034026016770','58','1456426034026016770',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034130874369','87','1456426034130874369',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034147651586','1213844233778122754','1456426034147651586',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034193788929','1211837849989595138','1456426034193788929',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034277675009','1211461407799820290','1456426034277675009',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034319618049','87','1456426034319618049',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034437058561','1216559724997144578','1456426034437058561',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034437058562','102','1456426034437058562',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034437058563','1219451161745080321','1456426034437058563',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034516750338','1211465260200935426','1456426034516750338',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034537721857','102','1456426034537721857',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034667745282','1274912838720167938','1456426034667745282',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034676133889','1417746338413576194','1456426034676133889',2,2,'福建嘉怡塑胶有限公司','15880999770','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034709688322','1211473406755651586','1456426034709688322',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034873266178','1286499346338045953','1456426034873266178',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426034948763649','1211474926804975617','1456426034948763649',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426035141701633','1316201027820630017','1456426035141701633',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426035141701634','1212580494957416450','1456426035141701634',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426035351416833','1214097817526620161','1456426035351416833',2,2,'福建恒安集团有限公司','13788854137','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426035577909250','1216568840104734722','1456426035577909250',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426035816984577','1216626668072869889','1456426035816984577',2,2,'晋江市融媒体中心','13505079029','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426035988951042','1241252588561698817','1456426035988951042',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426036152528898','1290850604855361537','1456426036152528898',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426036324495362','1295900371603947522','1456426036324495362',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426036915892225','1348924009986654209','1456426036915892225',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426037096247297','1351830895278948354','1456426037096247297',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:00',NULL,NULL,NULL,'2021-11-05 09:00:00',NULL,NULL,NULL),('1456426037272408066','1374549152519794689','1456426037272408066',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:01',NULL,NULL,NULL,'2021-11-05 09:00:01',NULL,NULL,NULL),('1456426037498900482','1374554432229978113','1456426037498900482',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:01',NULL,NULL,NULL,'2021-11-05 09:00:01',NULL,NULL,NULL),('1456426037675061249','1376712565047975937','1456426037675061249',2,2,'渠梁电子有限公司','18359882323','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:01',NULL,NULL,NULL,'2021-11-05 09:00:01',NULL,NULL,NULL),('1456426037838639106','1394875586618372097','1456426037838639106',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:01',NULL,NULL,NULL,'2021-11-05 09:00:01',NULL,NULL,NULL),('1456426038014799873','1425660338317033473','1456426038014799873',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:01',NULL,NULL,NULL,'2021-11-05 09:00:01',NULL,NULL,NULL),('1456426038182572034','1436229755434201090','1456426038182572034',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:01',NULL,NULL,NULL,'2021-11-05 09:00:01',NULL,NULL,NULL),('1456426038392287234','1447825572620169218','1456426038392287234',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-05 09:00:01',NULL,NULL,NULL,'2021-11-05 09:00:01',NULL,NULL,NULL),('1456495214964273154',NULL,'1456495214964273154',2,1,NULL,'18925477267','964690','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-05 13:34:54',NULL,NULL,NULL,'2021-11-05 13:34:54',NULL,NULL,NULL),('1456495978260492290',NULL,'1456495978260492290',2,1,NULL,'18925477267','781511','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-05 13:37:56',NULL,NULL,NULL,'2021-11-05 13:37:56',NULL,NULL,NULL),('1456496257240428545',NULL,'1456496257240428545',2,1,NULL,'18925477267','723461','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-05 13:39:02',NULL,NULL,NULL,'2021-11-05 13:39:02',NULL,NULL,NULL),('1456497473257238529',NULL,'1456497473257238529',2,1,NULL,'15305957900','871577','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-05 13:43:52',NULL,NULL,NULL,'2021-11-05 13:43:52',NULL,NULL,NULL),('1456498929146294273',NULL,'1456498929146294273',2,1,NULL,'15305957900','868706','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-05 13:49:39',NULL,NULL,NULL,'2021-11-05 13:49:39',NULL,NULL,NULL),('1456499820767244290',NULL,'1456499820767244290',2,1,NULL,'18925477267','008457','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-05 13:53:12',NULL,NULL,NULL,'2021-11-05 13:53:12',NULL,NULL,NULL),('1456520629984456705',NULL,'1456520629984456705',2,1,NULL,'15659222121','003037','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-05 15:15:53',NULL,NULL,NULL,'2021-11-05 15:15:53',NULL,NULL,NULL),('1456789225272799233',NULL,'1456789225272799233',2,1,NULL,'13034310023','539796','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-06 09:03:11',NULL,NULL,NULL,'2021-11-06 09:03:11',NULL,NULL,NULL),('1456789811871379457',NULL,'1456789811871379457',2,1,NULL,'13034310023','004312','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-06 09:05:31',NULL,NULL,NULL,'2021-11-06 09:05:31',NULL,NULL,NULL),('1456852846531080193',NULL,'1456852846531080193',2,1,NULL,'15375862630','739562','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-06 13:16:00',NULL,NULL,NULL,'2021-11-06 13:16:00',NULL,NULL,NULL),('1457513197002059778','1211167966465470465','1457513197002059778',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197064974337','1211120827064496130','1457513197064974337',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197081751554','1211920348237316098','1457513197081751554',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197404712961','58','1457513197404712961',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197438267394','72','1457513197438267394',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197463433217','1212685717864517633','1457513197463433217',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197476016130','1211529007779069954','1457513197476016130',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197476016131','1211454669394591746','1457513197476016131',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197681537025','87','1457513197681537025',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197752840193','58','1457513197752840193',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197798977538','1211461407799820290','1457513197798977538',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197803171842','1211837849989595138','1457513197803171842',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197933195265','102','1457513197933195265',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197933195266','1213844233778122754','1457513197933195266',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197945778177','87','1457513197945778177',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197983526914','1211465260200935426','1457513197983526914',2,2,'福建金石能源有限公司','13615901213','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198017081345','1219451161745080321','1457513198017081345',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198142910465','102','1457513198142910465',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198147104769','1216559724997144578','1457513198147104769',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198189047809','1211473406755651586','1457513198189047809',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198243573762','1274912838720167938','1457513198243573762',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198461677570','1211474926804975617','1457513198461677570',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198541369345','1286499346338045953','1457513198541369345',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198788833281','1212580494957416450','1457513198788833281',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513198805610498','1316201027820630017','1457513198805610498',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513199170514945','1216568840104734722','1457513199170514945',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513199426367490','1216626668072869889','1457513199426367490',2,2,'晋江市融媒体中心','13505079029','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513199648665601','1241252588561698817','1457513199648665601',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513199824826369','1290850604855361537','1457513199824826369',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513200424611841','1295900371603947522','1457513200424611841',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513200609161217','1348924009986654209','1457513200609161217',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:00',NULL,NULL,NULL,'2021-11-08 09:00:00',NULL,NULL,NULL),('1457513200848236545','1351830895278948354','1457513200848236545',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457513201129254914','1374549152519794689','1457513201129254914',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457513201326387201','1374554432229978113','1457513201326387201',2,2,'福建省晋华集成电路有限公司','15059820805','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457513201523519490','1376712565047975937','1457513201523519490',2,2,'渠梁电子有限公司','18359882323','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457513201787760641','1394875586618372097','1457513201787760641',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457513202018447362','1425660338317033473','1457513202018447362',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457513202194608129','1436229755434201090','1457513202194608129',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457513202416906242','1447825572620169218','1457513202416906242',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-08 09:00:01',NULL,NULL,NULL,'2021-11-08 09:00:01',NULL,NULL,NULL),('1457547945279778818','1456521031018639362','1457547945279778818',2,2,'晋江航空假日旅行社有限公司','15659222121','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-08 11:18:04',NULL,NULL,NULL,'2021-11-08 11:18:04',NULL,NULL,NULL),('1457550412813987842',NULL,'1457550412813987842',2,1,NULL,'15280112534','123135','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-08 11:27:53',NULL,NULL,NULL,'2021-11-08 11:27:53',NULL,NULL,NULL),('1457552087758958593',NULL,'1457552087758958593',2,1,NULL,'15659222121','642749','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-08 11:34:32',NULL,NULL,NULL,'2021-11-08 11:34:32',NULL,NULL,NULL),('1457723388960206850',NULL,'1457723388960206850',2,1,NULL,'13799550683','329011','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-08 22:55:13',NULL,NULL,NULL,'2021-11-08 22:55:13',NULL,NULL,NULL),('1457875584766996482','1211920348237316098','1457875584766996482',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875584796356610','1211167966465470465','1457875584796356610',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875584863465473','1211120827064496130','1457875584863465473',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585245147137','72','1457875585245147137',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585245147138','1211454669394591746','1457875585245147138',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585253535746','1212685717864517633','1457875585253535746',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585383559169','1211529007779069954','1457875585383559169',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585408724994','58','1457875585408724994',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585488416770','1211461407799820290','1457875585488416770',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585509388290','58','1457875585509388290',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585614245890','1211837849989595138','1457875585614245890',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585618440194','87','1457875585618440194',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585618440195','1213844233778122754','1457875585618440195',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585727492097','1211473406755651586','1457875585727492097',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585794600962','1219451161745080321','1457875585794600962',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585886875649','102','1457875585886875649',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585886875650','1216559724997144578','1457875585886875650',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585886875651','87','1457875585886875651',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585966567425','1211474926804975617','1457875585966567425',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586163699714','1274912838720167938','1457875586163699714',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586163699715','102','1457875586163699715',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586193059841','1216568840104734722','1457875586193059841',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586369220610','1241252588561698817','1457875586369220610',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586390192130','1286499346338045953','1457875586390192130',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586604101633','1290850604855361537','1457875586604101633',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586662821889','1316201027820630017','1457875586662821889',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875586885120001','1295900371603947522','1457875586885120001',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875587094835201','1348924009986654209','1457875587094835201',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875587287773186','1351830895278948354','1457875587287773186',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875587627511809','1374549152519794689','1457875587627511809',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875587942084609','1374554432229978113','1457875587942084609',2,2,'福建省晋华集成电路有限公司','15059820805','7,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875588181159937','1376712565047975937','1457875588181159937',2,2,'渠梁电子有限公司','18359882323','6,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875588378292226','1392396939873529858','1457875588378292226',2,2,'晋江万芯晨电子科技有限公司','13960937795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875588583813122','1394875586618372097','1457875588583813122',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:00',NULL,NULL,NULL,'2021-11-09 09:00:00',NULL,NULL,NULL),('1457875588806111234','1425660338317033473','1457875588806111234',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:01',NULL,NULL,NULL,'2021-11-09 09:00:01',NULL,NULL,NULL),('1457875588990660609','1436229755434201090','1457875588990660609',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:01',NULL,NULL,NULL,'2021-11-09 09:00:01',NULL,NULL,NULL),('1457875589179404289','1447825572620169218','1457875589179404289',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-09 09:00:01',NULL,NULL,NULL,'2021-11-09 09:00:01',NULL,NULL,NULL),('1457925363945467905',NULL,'1457925363945467905',2,1,NULL,'17350030786','465615','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-09 12:17:48',NULL,NULL,NULL,'2021-11-09 12:17:48',NULL,NULL,NULL),('1457925650466762754',NULL,'1457925650466762754',2,1,NULL,'15659085663','978238','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-09 12:18:56',NULL,NULL,NULL,'2021-11-09 12:18:56',NULL,NULL,NULL),('1458237972771008514','1211167966465470465','1458237972771008514',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972783591425','1211120827064496130','1458237972783591425',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972796174338','1211920348237316098','1458237972796174338',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973148495874','72','1458237973148495874',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973198827522','58','1458237973198827522',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973219799041','1211529007779069954','1458237973219799041',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973232381954','1211454669394591746','1458237973232381954',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973232381955','1212685717864517633','1458237973232381955',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973395959809','87','1458237973395959809',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973442097154','58','1458237973442097154',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973505011713','1213844233778122754','1458237973505011713',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973509206017','1211837849989595138','1458237973509206017',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973593092098','102','1458237973593092098',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973601480705','1211461407799820290','1458237973601480705',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973689561089','87','1458237973689561089',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973710532609','1219451161745080321','1458237973710532609',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973718921217','1216559724997144578','1458237973718921217',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973777641474','116','1458237973777641474',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973786030081','1211473406755651586','1458237973786030081',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973932830721','102','1458237973932830721',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973941219330','1274912838720167938','1458237973941219330',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237973957996546','1211474926804975617','1458237973957996546',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974134157314','116','1458237974134157314',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974146740225','1286499346338045953','1458237974146740225',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974146740226','1216568840104734722','1458237974146740226',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974356455426','1241252588561698817','1458237974356455426',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974369038338','1316201027820630017','1458237974369038338',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974532616194','1290850604855361537','1458237974532616194',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974704582657','1295900371603947522','1458237974704582657',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237974880743426','1348924009986654209','1458237974880743426',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237975061098498','1351830895278948354','1458237975061098498',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237975295979522','1374549152519794689','1458237975295979522',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237975484723201','1374554432229978113','1458237975484723201',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237975669272577','1376712565047975937','1458237975669272577',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237975908347905','1392396939873529858','1458237975908347905',2,2,'晋江万芯晨电子科技有限公司','13960937795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237976143228929','1394875586618372097','1458237976143228929',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237976390692865','1425660338317033473','1458237976390692865',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:00',NULL,NULL,NULL,'2021-11-10 09:00:00',NULL,NULL,NULL),('1458237976600408066','1436229755434201090','1458237976600408066',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-10 09:00:01',NULL,NULL,NULL,'2021-11-10 09:00:01',NULL,NULL,NULL),('1458384026195750914',NULL,'1458384026195750914',2,1,NULL,'18106990767','073350','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-10 18:40:21',NULL,NULL,NULL,'2021-11-10 18:40:21',NULL,NULL,NULL),('1458394875484467201',NULL,'1458394875484467201',2,1,NULL,'15750910990','679327','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-10 19:23:28',NULL,NULL,NULL,'2021-11-10 19:23:28',NULL,NULL,NULL),('1458600360384950274','1211920348237316098','1458600360384950274',2,2,'安踏（中国）有限公司','15160330306','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360426893313','1211167966465470465','1458600360426893313',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360447864834','1211120827064496130','1458600360447864834',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360800186370','72','1458600360800186370',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360808574977','58','1458600360808574977',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360846323714','1211529007779069954','1458600360846323714',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360867295233','1211454669394591746','1458600360867295233',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360875683842','1212685717864517633','1458600360875683842',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360997318657','87','1458600360997318657',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361072816129','1211461407799820290','1458600361072816129',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361077010433','1211837849989595138','1458600361077010433',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361085399041','58','1458600361085399041',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361190256641','102','1458600361190256641',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361190256642','1213844233778122754','1458600361190256642',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361387388929','1211473406755651586','1458600361387388929',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361404166145','1219451161745080321','1458600361404166145',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361462886401','116','1458600361462886401',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361462886402','87','1458600361462886402',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361475469313','1216559724997144578','1458600361475469313',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361613881346','1211474926804975617','1458600361613881346',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361634852865','1274912838720167938','1458600361634852865',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361639047169','102','1458600361639047169',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361865539586','116','1458600361865539586',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361865539587','1286499346338045953','1458600361865539587',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600361865539588','1216568840104734722','1458600361865539588',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600362171723777','1241252588561698817','1458600362171723777',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600362184306689','1316201027820630017','1458600362184306689',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600362402410498','1290850604855361537','1458600362402410498',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600362607931393','1295900371603947522','1458600362607931393',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600362805063681','1348924009986654209','1458600362805063681',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600362977030146','1351830895278948354','1458600362977030146',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600363211911170','1374549152519794689','1458600363211911170',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600363388071938','1374554432229978113','1458600363388071938',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600363593592833','1376712565047975937','1458600363593592833',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600363845251073','1392396939873529858','1458600363845251073',2,2,'晋江万芯晨电子科技有限公司','13960937795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600364050771970','1394875586618372097','1458600364050771970',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600364235321345','1425660338317033473','1458600364235321345',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:00',NULL,NULL,NULL,'2021-11-11 09:00:00',NULL,NULL,NULL),('1458600364415676418','1436229755434201090','1458600364415676418',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-11 09:00:01',NULL,NULL,NULL,'2021-11-11 09:00:01',NULL,NULL,NULL),('1458697331976204289',NULL,'1458697331976204289',2,1,NULL,'13600771760','960072','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-11 15:25:19',NULL,NULL,NULL,'2021-11-11 15:25:19',NULL,NULL,NULL),('1458708691397144577',NULL,'1458708691397144577',2,1,NULL,'18233568861','002212','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-11 16:10:28',NULL,NULL,NULL,'2021-11-11 16:10:28',NULL,NULL,NULL),('1458748580561973250',NULL,'1458748580561973250',2,1,NULL,'18059848253','364411','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-11 18:48:58',NULL,NULL,NULL,'2021-11-11 18:48:58',NULL,NULL,NULL),('1458750880693121025',NULL,'1458750880693121025',2,1,NULL,'18059848253','251455','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-11 18:58:06',NULL,NULL,NULL,'2021-11-11 18:58:06',NULL,NULL,NULL),('1458962748565123074','1212685717864517633','1458962748565123074',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748653203458','1211120827064496130','1458962748653203458',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748695146498','1211167966465470465','1458962748695146498',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748997136386','58','1458962748997136386',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749001330689','72','1458962749001330689',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749131354114','1211529007779069954','1458962749131354114',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749139742721','1213844233778122754','1458962749139742721',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749173297154','1211454669394591746','1458962749173297154',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749273960449','58','1458962749273960449',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749286543362','87','1458962749286543362',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749336875010','1216559724997144578','1458962749336875010',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749391400962','1211837849989595138','1458962749391400962',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749416566786','1211461407799820290','1458962749416566786',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749471092738','102','1458962749471092738',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749479481346','87','1458962749479481346',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749571756034','1219451161745080321','1458962749571756034',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749592727553','1211473406755651586','1458962749592727553',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749638864898','116','1458962749638864898',1,2,'苏志英','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749668225026','102','1458962749668225026',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749747916802','1274912838720167938','1458962749747916802',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749756305409','1211474926804975617','1458962749756305409',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749844385793','116','1458962749844385793',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749919883266','1286499346338045953','1458962749919883266',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962749953437697','1216568840104734722','1458962749953437697',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962750125404162','1316201027820630017','1458962750125404162',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962750154764290','1241252588561698817','1458962750154764290',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962750322536450','1290850604855361537','1458962750322536450',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962750507085826','1295900371603947522','1458962750507085826',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962750683246594','1348924009986654209','1458962750683246594',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962750855213057','1351830895278948354','1458962750855213057',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962751069122562','1374549152519794689','1458962751069122562',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962751308197890','1374554432229978113','1458962751308197890',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962751547273218','1376712565047975937','1458962751547273218',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962752058978305','1392396939873529858','1458962752058978305',2,2,'晋江万芯晨电子科技有限公司','13960937795','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:00',NULL,NULL,NULL,'2021-11-12 09:00:00',NULL,NULL,NULL),('1458962752239333378','1394875586618372097','1458962752239333378',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:01',NULL,NULL,NULL,'2021-11-12 09:00:01',NULL,NULL,NULL),('1458962752461631490','1425660338317033473','1458962752461631490',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:01',NULL,NULL,NULL,'2021-11-12 09:00:01',NULL,NULL,NULL),('1458962752658763778','1436229755434201090','1458962752658763778',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-12 09:00:01',NULL,NULL,NULL,'2021-11-12 09:00:01',NULL,NULL,NULL),('1458964767589822465',NULL,'1458964767589822465',2,1,NULL,'18059848253','956021','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-12 09:08:01',NULL,NULL,NULL,'2021-11-12 09:08:01',NULL,NULL,NULL),('1458966459085516802',NULL,'1458966459085516802',2,1,NULL,'18059848253','603729','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-12 09:14:44',NULL,NULL,NULL,'2021-11-12 09:14:44',NULL,NULL,NULL),('1458970885842038786','1458709682104332290','1458970885842038786',2,2,'福建圆通速递有限公司','18233568861','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-12 09:32:20',NULL,NULL,NULL,'2021-11-12 09:32:20',NULL,NULL,NULL),('1459130437933756418',NULL,'1459130437933756418',2,1,NULL,'15959212491','163048','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-12 20:06:20',NULL,NULL,NULL,'2021-11-12 20:06:20',NULL,NULL,NULL),('1459133954324983810',NULL,'1459133954324983810',2,1,NULL,'15959212491','723026','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-12 20:20:18',NULL,NULL,NULL,'2021-11-12 20:20:18',NULL,NULL,NULL),('1460049912094814210','1212685717864517633','1460049912094814210',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912111591425','1211167966465470465','1460049912111591425',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912166117378','1211120827064496130','1460049912166117378',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912673628161','58','1460049912673628161',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912682016769','72','1460049912682016769',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912736542721','1211454669394591746','1460049912736542721',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912749125634','1213844233778122754','1460049912749125634',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912812040193','1211529007779069954','1460049912812040193',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912916897793','58','1460049912916897793',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912946257921','1216559724997144578','1460049912946257921',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912975618049','87','1460049912975618049',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912984006657','1211837849989595138','1460049912984006657',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913030144002','1211461407799820290','1460049913030144002',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913101447169','87','1460049913101447169',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913206304770','102','1460049913206304770',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913223081986','1211473406755651586','1460049913223081986',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913231470593','1219451161745080321','1460049913231470593',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913265025025','102','1460049913265025025',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913395048450','1274912838720167938','1460049913395048450',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913395048451','116','1460049913395048451',1,2,'苏志英','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913403437057','1211474926804975617','1460049913403437057',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913537654785','116','1460049913537654785',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913642512386','1286499346338045953','1460049913642512386',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913650900994','1216568840104734722','1460049913650900994',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913818673153','1241252588561698817','1460049913818673153',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049913822867457','1316201027820630017','1460049913822867457',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049914028388353','1290850604855361537','1460049914028388353',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049914187771906','1295900371603947522','1460049914187771906',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049914376515586','1348924009986654209','1460049914376515586',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049914548482049','1351830895278948354','1460049914548482049',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049914808528897','1374549152519794689','1460049914808528897',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049915055992833','1374554432229978113','1460049915055992833',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049915223764994','1376712565047975937','1460049915223764994',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049915412508674','1394875586618372097','1460049915412508674',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049915760635905','1425660338317033473','1460049915760635905',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:00',NULL,NULL,NULL,'2021-11-15 09:00:00',NULL,NULL,NULL),('1460049915949379585','1436229755434201090','1460049915949379585',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-15 09:00:01',NULL,NULL,NULL,'2021-11-15 09:00:01',NULL,NULL,NULL),('1460058481804472322',NULL,'1460058481804472322',2,1,NULL,'15959212491','084008','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-15 09:34:03',NULL,NULL,NULL,'2021-11-15 09:34:03',NULL,NULL,NULL),('1460059948812627969',NULL,'1460059948812627969',2,1,NULL,'15959212491','495485','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-15 09:39:53',NULL,NULL,NULL,'2021-11-15 09:39:53',NULL,NULL,NULL),('1460412300140769282','1212685717864517633','1460412300140769282',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300165935105','1211167966465470465','1460412300165935105',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300228849665','1211120827064496130','1460412300228849665',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300459536386','72','1460412300459536386',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300501479425','58','1460412300501479425',1,2,'张荣荣','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300576976898','1213844233778122754','1460412300576976898',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300660862978','1211529007779069954','1460412300660862978',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300660862979','1211454669394591746','1460412300660862979',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300719583233','58','1460412300719583233',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300820246529','87','1460412300820246529',1,2,'叶志钦','13675957398','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300849606658','1216559724997144578','1460412300849606658',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300883161089','1211837849989595138','1460412300883161089',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300883161090','1211461407799820290','1460412300883161090',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300929298434','87','1460412300929298434',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300975435778','102','1460412300975435778',1,2,'颜思思','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301046738945','1211473406755651586','1460412301046738945',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301059321857','1219451161745080321','1460412301059321857',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301126430722','102','1460412301126430722',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301134819329','116','1460412301134819329',1,2,'苏志英','15280619456','8,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301222899714','1211474926804975617','1460412301222899714',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301256454146','1274912838720167938','1460412301256454146',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301298397185','116','1460412301298397185',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301382283266','1216568840104734722','1460412301382283266',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301441003522','1286499346338045953','1460412301441003522',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301554249730','1241252588561698817','1460412301554249730',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301608775681','1316201027820630017','1460412301608775681',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301759770626','1290850604855361537','1460412301759770626',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412301948514305','1295900371603947522','1460412301948514305',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412302137257985','1348924009986654209','1460412302137257985',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412302355361794','1351830895278948354','1460412302355361794',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412302514745346','1374549152519794689','1460412302514745346',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412302728654850','1374554432229978113','1460412302728654850',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412302938370049','1376712565047975937','1460412302938370049',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412303122919426','1394875586618372097','1460412303122919426',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412303303274497','1425660338317033473','1460412303303274497',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460412303479435265','1436229755434201090','1460412303479435265',2,2,'福建晋江经济开发区管理委员会','18850585101','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-16 09:00:00',NULL,NULL,NULL,'2021-11-16 09:00:00',NULL,NULL,NULL),('1460533265638125569','1459134035031781378','1460533265638125569',2,2,'泉州海陶之路文化创意有限公司','15959212491','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-16 17:00:40',NULL,NULL,NULL,'2021-11-16 17:00:40',NULL,NULL,NULL),('1460774687872151553','1212685717864517633','1460774687872151553',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774687897317377','1211167966465470465','1460774687897317377',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774687947649025','1211120827064496130','1460774687947649025',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688371273729','72','1460774688371273729',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688396439554','58','1460774688396439554',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688446771202','1213844233778122754','1460774688446771202',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688492908546','1211454669394591746','1460774688492908546',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688492908547','1211529007779069954','1460774688492908547',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688622931970','87','1460774688622931970',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688673263617','58','1460774688673263617',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688685846529','1216559724997144578','1460774688685846529',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688685846530','1211461407799820290','1460774688685846530',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688778121217','1211837849989595138','1460774688778121217',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688790704129','102','1460774688790704129',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688887173122','87','1460774688887173122',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688903950338','1211473406755651586','1460774688903950338',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688979447810','1219451161745080321','1460774688979447810',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689021390849','116','1460774689021390849',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689096888322','102','1460774689096888322',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689096888323','1211474926804975617','1460774689096888323',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689180774401','1274912838720167938','1460774689180774401',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689314992130','116','1460774689314992130',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689319186433','1216568840104734722','1460774689319186433',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689369518081','1286499346338045953','1460774689369518081',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689516318722','1241252588561698817','1460774689516318722',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689579233281','1316201027820630017','1460774689579233281',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774689793142786','1290850604855361537','1460774689793142786',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774690036412418','1295900371603947522','1460774690036412418',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774690229350402','1348924009986654209','1460774690229350402',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774690451648513','1351830895278948354','1460774690451648513',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774690665558017','1374549152519794689','1460774690665558017',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774690850107394','1374554432229978113','1460774690850107394',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774691147902978','1376712565047975937','1460774691147902978',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774691336646657','1394875586618372097','1460774691336646657',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:00',NULL,NULL,NULL,'2021-11-17 09:00:00',NULL,NULL,NULL),('1460774691542167553','1425660338317033473','1460774691542167553',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-17 09:00:01',NULL,NULL,NULL,'2021-11-17 09:00:01',NULL,NULL,NULL),('1460889357006172162',NULL,'1460889357006172162',2,1,NULL,'13810782015','608166','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-17 16:35:39',NULL,NULL,NULL,'2021-11-17 16:35:39',NULL,NULL,NULL),('1461137075511259137','1211167966465470465','1461137075511259137',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075536424961','1212685717864517633','1461137075536424961',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075578368001','1211120827064496130','1461137075578368001',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075934883841','58','1461137075934883841',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075981021185','1213844233778122754','1461137075981021185',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075989409794','1211454669394591746','1461137075989409794',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075993604097','72','1461137075993604097',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076056518658','1211529007779069954','1461137076056518658',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076140404738','87','1461137076140404738',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076186542081','1211461407799820290','1461137076186542081',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076194930689','58','1461137076194930689',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076308176898','102','1461137076308176898',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076320759810','1216559724997144578','1461137076320759810',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076333342722','1211837849989595138','1461137076333342722',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076396257281','87','1461137076396257281',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076404645889','1211473406755651586','1461137076404645889',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076509503490','116','1461137076509503490',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076530475010','1219451161745080321','1461137076530475010',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076631138305','102','1461137076631138305',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076635332610','1211474926804975617','1461137076635332610',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076723412994','1274912838720167938','1461137076723412994',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076815687682','1216568840104734722','1461137076815687682',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076819881986','116','1461137076819881986',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076886990849','1286499346338045953','1461137076886990849',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137076979265538','1241252588561698817','1461137076979265538',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137077063151617','1316201027820630017','1461137077063151617',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137077147037698','1290850604855361537','1461137077147037698',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137077339975682','1295900371603947522','1461137077339975682',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137077524525057','1348924009986654209','1461137077524525057',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137077688102914','1351830895278948354','1461137077688102914',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137077902012418','1374549152519794689','1461137077902012418',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137078229168130','1374554432229978113','1461137078229168130',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137078409523202','1376712565047975937','1461137078409523202',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137078568906754','1394875586618372097','1461137078568906754',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461137078854119426','1425660338317033473','1461137078854119426',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-18 09:00:00',NULL,NULL,NULL,'2021-11-18 09:00:00',NULL,NULL,NULL),('1461222483012120578',NULL,'1461222483012120578',2,1,NULL,'13859160726','059044','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-18 14:39:22',NULL,NULL,NULL,'2021-11-18 14:39:22',NULL,NULL,NULL),('1461222767922802690',NULL,'1461222767922802690',2,1,NULL,'13859160726','999949','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-18 14:40:30',NULL,NULL,NULL,'2021-11-18 14:40:30',NULL,NULL,NULL),('1461499463771123713','1211120827064496130','1461499463771123713',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499463792095234','1211167966465470465','1461499463792095234',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499463821455361','1212685717864517633','1461499463821455361',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464169582593','58','1461499464169582593',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464169582594','72','1461499464169582594',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464299606018','1213844233778122754','1461499464299606018',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464324771841','1211454669394591746','1461499464324771841',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464324771842','1211529007779069954','1461499464324771842',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464425435138','58','1461499464425435138',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464492544002','1216559724997144578','1461499464492544002',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464513515521','87','1461499464513515521',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464530292737','1211461407799820290','1461499464530292737',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464584818689','1211837849989595138','1461499464584818689',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464597401601','87','1461499464597401601',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464693870594','102','1461499464693870594',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464714842114','1211473406755651586','1461499464714842114',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464769368065','1219451161745080321','1461499464769368065',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464769368066','102','1461499464769368066',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464853254146','116','1461499464853254146',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464899391490','1211474926804975617','1461499464899391490',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464928751618','116','1461499464928751618',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464958111745','1274912838720167938','1461499464958111745',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499465088135170','1216568840104734722','1461499465088135170',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499465130078210','1286499346338045953','1461499465130078210',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499465268490242','1241252588561698817','1461499465268490242',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499465297850370','1316201027820630017','1461499465297850370',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499465541120002','1290850604855361537','1461499465541120002',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499465717280769','1295900371603947522','1461499465717280769',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499465901830145','1348924009986654209','1461499465901830145',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499466086379522','1351830895278948354','1461499466086379522',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499466287706114','1374549152519794689','1461499466287706114',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499466476449794','1374554432229978113','1461499466476449794',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499466656804865','1376712565047975937','1461499466656804865',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499466912657409','1394875586618372097','1461499466912657409',2,2,'晋江市博感电子科技有限公司','18650478001','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461499467113984002','1425660338317033473','1461499467113984002',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-19 09:00:00',NULL,NULL,NULL,'2021-11-19 09:00:00',NULL,NULL,NULL),('1461631927105646594',NULL,'1461631927105646594',2,1,NULL,'15659085663','858680','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-19 17:46:21',NULL,NULL,NULL,'2021-11-19 17:46:21',NULL,NULL,NULL),('1461632647649325058',NULL,'1461632647649325058',2,1,NULL,'15659085663','166589','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-19 17:49:13',NULL,NULL,NULL,'2021-11-19 17:49:13',NULL,NULL,NULL),('1462001957496451073',NULL,'1462001957496451073',2,1,NULL,'15059792127','987645','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-20 18:16:44',NULL,NULL,NULL,'2021-11-20 18:16:44',NULL,NULL,NULL),('1462302981310410754',NULL,'1462302981310410754',2,1,NULL,'15960716246','557880','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-21 14:12:53',NULL,NULL,NULL,'2021-11-21 14:12:53',NULL,NULL,NULL),('1462322887263285250',NULL,'1462322887263285250',2,1,NULL,'13405972790','153456','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-21 15:31:59',NULL,NULL,NULL,'2021-11-21 15:31:59',NULL,NULL,NULL),('1462441069357592578',NULL,'1462441069357592578',2,1,NULL,'15759736536','860850','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-21 23:21:36',NULL,NULL,NULL,'2021-11-21 23:21:36',NULL,NULL,NULL),('1462464714293407745',NULL,'1462464714293407745',2,1,NULL,'18850281656','730295','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-22 00:55:33',NULL,NULL,NULL,'2021-11-22 00:55:33',NULL,NULL,NULL),('1462482740560556033',NULL,'1462482740560556033',2,1,NULL,'13706085081','004607','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-22 02:07:11',NULL,NULL,NULL,'2021-11-22 02:07:11',NULL,NULL,NULL),('1462586335633108994',NULL,'1462586335633108994',2,1,NULL,'15059757597','288618','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-22 08:58:50',NULL,NULL,NULL,'2021-11-22 08:58:50',NULL,NULL,NULL),('1462586627187568641','1211167966465470465','1462586627187568641',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627195957249','1212685717864517633','1462586627195957249',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627275649025','1211120827064496130','1462586627275649025',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627581833217','72','1462586627581833217',1,2,'翁海勇','13599173733','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627590221825','58','1462586627590221825',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627590221826','1211454669394591746','1462586627590221826',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627632164865','1213844233778122754','1462586627632164865',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627707662337','1211529007779069954','1462586627707662337',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627833491457','87','1462586627833491457',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627867045889','58','1462586627867045889',1,2,'张荣荣','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627879628801','1211461407799820290','1462586627879628801',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627971903489','1216559724997144578','1462586627971903489',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627976097793','1211837849989595138','1462586627976097793',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627997069313','102','1462586627997069313',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628089344002','87','1462586628089344002',1,2,'叶志钦','13675957398','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628093538306','1211473406755651586','1462586628093538306',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628181618689','1219451161745080321','1462586628181618689',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628194201602','116','1462586628194201602',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628299059202','102','1462586628299059202',1,2,'颜思思','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628320030722','1211474926804975617','1462586628320030722',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628366168066','1274912838720167938','1462586628366168066',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628483608577','116','1462586628483608577',1,2,'苏志英','15280619456','2,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628496191489','1216568840104734722','1462586628496191489',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628584271874','1286499346338045953','1462586628584271874',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628684935170','1241252588561698817','1462586628684935170',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628760432641','1316201027820630017','1462586628760432641',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586628928204801','1290850604855361537','1462586628928204801',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586629087588354','1295900371603947522','1462586629087588354',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586629293109249','1348924009986654209','1462586629293109249',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586629494435842','1351830895278948354','1462586629494435842',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586629653819393','1374549152519794689','1462586629653819393',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586629821591553','1374554432229978113','1462586629821591553',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586630052278273','1376712565047975937','1462586630052278273',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462586630282964993','1425660338317033473','1462586630282964993',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 09:00:00',NULL,NULL,NULL,'2021-11-22 09:00:00',NULL,NULL,NULL),('1462599829816373249',NULL,'1462599829816373249',2,1,NULL,'15880881006','829561','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-22 09:52:27',NULL,NULL,NULL,'2021-11-22 09:52:27',NULL,NULL,NULL),('1462707344906416130',NULL,'1462707344906416130',2,1,NULL,'15960735252','639759','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-22 16:59:41',NULL,NULL,NULL,'2021-11-22 16:59:41',NULL,NULL,NULL),('1462713800955293697',NULL,'1462713800955293697',2,1,NULL,'18960203812','165256','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-22 17:25:20',NULL,NULL,NULL,'2021-11-22 17:25:20',NULL,NULL,NULL),('1462714502104510466','1462713906911801345','1462714502104510466',2,2,'泉州亲亲食品有限公司','18960203812','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-22 17:28:07',NULL,NULL,NULL,'2021-11-22 17:28:07',NULL,NULL,NULL),('1462732245260333058','1452469610119983105','1462732245260333058',2,2,'晋江市清新文旅产业运营管理有限公司','18815981178','企业信息变更','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-22 18:38:38',NULL,NULL,NULL,'2021-11-22 18:38:38',NULL,NULL,NULL),('1462801236611854338','1457925699133272065','1462801236611854338',2,2,'泉州荣晋置业有限公司','15659085663','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-22 23:12:46',NULL,NULL,NULL,'2021-11-22 23:12:46',NULL,NULL,NULL),('1462946851270455297',NULL,'1462946851270455297',2,1,NULL,'15659085663','266517','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-23 08:51:24',NULL,NULL,NULL,'2021-11-23 08:51:24',NULL,NULL,NULL),('1462947969643868162','1462586677892509698','1462947969643868162',2,2,'福建博厚人力资源服务有限公司','15059757597','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-23 08:55:50',NULL,NULL,NULL,'2021-11-23 08:55:50',NULL,NULL,NULL),('1462948092172070914','1457925699133272065','1462948092172070914',2,2,'泉州荣晋置业有限公司','15659085663','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-23 08:56:20',NULL,NULL,NULL,'2021-11-23 08:56:20',NULL,NULL,NULL),('1462949014969282561','1212685717864517633','1462949014969282561',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949014969282562','1211167966465470465','1462949014969282562',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015053168641','1211120827064496130','1462949015053168641',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015359352833','58','1462949015359352833',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015376130050','58','1462949015376130050',1,2,'张荣荣','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015380324354','83','1462949015380324354',1,2,'李女元','15359825666','1,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015401295874','1213844233778122754','1462949015401295874',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015413878786','1211454669394591746','1462949015413878786',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015535513601','1211529007779069954','1462949015535513601',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015577456641','87','1462949015577456641',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015577456642','87','1462949015577456642',1,2,'叶志钦','13675957398','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015715868674','1216559724997144578','1462949015715868674',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015715868675','1211461407799820290','1462949015715868675',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015732645889','1211837849989595138','1462949015732645889',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015741034497','102','1462949015741034497',1,2,'颜思思','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015757811713','102','1462949015757811713',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015900418050','1211473406755651586','1462949015900418050',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015938166786','116','1462949015938166786',1,2,'苏志英','15280619456','6,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015938166787','1219451161745080321','1462949015938166787',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015942361090','116','1462949015942361090',1,2,'苏志英','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949016110133249','1211474926804975617','1462949016110133249',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949016160464897','1274912838720167938','1462949016160464897',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949016340819970','1211840469537964033','1462949016340819970',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949016353402881','1286499346338045953','1462949016353402881',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949016563118081','1316201027820630017','1462949016563118081',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949016579895298','1212580494957416450','1462949016579895298',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949016839942145','1216568840104734722','1462949016839942145',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949017020297218','1241252588561698817','1462949017020297218',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949017192263682','1290850604855361537','1462949017192263682',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949017401978882','1295900371603947522','1462949017401978882',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949017662025729','1341318122925195265','1462949017662025729',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949017880129538','1348924009986654209','1462949017880129538',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949018131787778','1351830895278948354','1462949018131787778',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949018333114369','1374549152519794689','1462949018333114369',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949018530246657','1374554432229978113','1462949018530246657',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:00',NULL,NULL,NULL,'2021-11-23 09:00:00',NULL,NULL,NULL),('1462949018731573249','1376712565047975937','1462949018731573249',2,2,'渠梁电子有限公司','18359882323','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949018903539714','1418181190581518337','1462949018903539714',2,2,'福建杰斐逊律师事务所','13599100513','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949019146809346','1425660338317033473','1462949019146809346',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949019322970114','1436144268304498689','1462949019322970114',2,2,'泉州椰子科技有限公司','19959877368','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949019524296705','1447825572620169218','1462949019524296705',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949019696263169','1448840628640182273','1462949019696263169',2,2,'晋江友雅服饰有限公司','18606037872','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949019889201154','1452469610119983105','1462949019889201154',2,2,'晋江市清新文旅产业运营管理有限公司','18815981178','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949020115693570','1453892385195978753','1462949020115693570',2,2,'晋江市鹏星社会工作发展与评估中心','17750981257','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462949020304437250','1458709682104332290','1462949020304437250',2,2,'福建圆通速递有限公司','18233568861','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-23 09:00:01',NULL,NULL,NULL,'2021-11-23 09:00:01',NULL,NULL,NULL),('1462996637528911874',NULL,'1462996637528911874',2,1,NULL,'15160326656','727581','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-23 12:09:14',NULL,NULL,NULL,'2021-11-23 12:09:14',NULL,NULL,NULL),('1462997241575796737',NULL,'1462997241575796737',2,1,NULL,'13808556408','380320','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-23 12:11:38',NULL,NULL,NULL,'2021-11-23 12:11:38',NULL,NULL,NULL),('1463053250876960769','1462997460363276289','1463053250876960769',2,2,'泉州邱氏山国木雕工艺品有限公司','13808556408','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',2,'黑名单','2021-11-23 15:54:11',NULL,NULL,NULL,'2021-11-23 15:54:11',NULL,NULL,NULL),('1463067691244875777',NULL,'1463067691244875777',2,1,NULL,'18060909114','398481','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-23 16:51:34',NULL,NULL,NULL,'2021-11-23 16:51:34',NULL,NULL,NULL),('1463070747369959425',NULL,'1463070747369959425',2,1,NULL,'18060909114','661369','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-23 17:03:43',NULL,NULL,NULL,'2021-11-23 17:03:43',NULL,NULL,NULL),('1463076047632232450',NULL,'1463076047632232450',2,1,NULL,'18060909114','123294','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-23 17:24:47',NULL,NULL,NULL,'2021-11-23 17:24:47',NULL,NULL,NULL),('1463137821253464066',NULL,'1463137821253464066',2,1,NULL,'18905068762','149166','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-23 21:30:15',NULL,NULL,NULL,'2021-11-23 21:30:15',NULL,NULL,NULL),('1463311403044597761','1211120827064496130','1463311403044597761',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403115900930','1211167966465470465','1463311403115900930',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403124289538','1212685717864517633','1463311403124289538',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403438862337','58','1463311403438862337',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403443056642','83','1463311403443056642',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403443056643','71','1463311403443056643',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403707297794','1211454669394591746','1463311403707297794',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403719880705','1213844233778122754','1463311403719880705',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403719880706','1211529007779069954','1463311403719880706',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403719880707','87','1463311403719880707',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403732463617','58','1463311403732463617',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403967344642','1211837849989595138','1463311403967344642',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404013481985','87','1463311404013481985',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404013481986','1216559724997144578','1463311404013481986',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404013481987','102','1463311404013481987',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404013481988','1211461407799820290','1463311404013481988',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404223197186','1211473406755651586','1463311404223197186',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404223197187','1219451161745080321','1463311404223197187',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404223197188','116','1463311404223197188',1,2,'苏志英','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404256751618','102','1463311404256751618',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404516798465','1211474926804975617','1463311404516798465',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404516798466','1274912838720167938','1463311404516798466',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404516798467','116','1463311404516798467',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404709736450','1211840469537964033','1463311404709736450',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311404713930754','1286499346338045953','1463311404713930754',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311405032697858','1212580494957416450','1463311405032697858',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311405036892161','1316201027820630017','1463311405036892161',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311405208858626','1216568840104734722','1463311405208858626',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311405435351042','1241252588561698817','1463311405435351042',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311405615706113','1290850604855361537','1463311405615706113',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311405783478274','1295900371603947522','1463311405783478274',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311405997387778','1341318122925195265','1463311405997387778',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311406320349185','1348924009986654209','1463311406320349185',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311406500704257','1351830895278948354','1463311406500704257',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:00',NULL,NULL,NULL,'2021-11-24 09:00:00',NULL,NULL,NULL),('1463311406676865025','1374549152519794689','1463311406676865025',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311406848831490','1374554432229978113','1463311406848831490',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311407037575170','1376712565047975937','1463311407037575170',2,2,'渠梁电子有限公司','18359882323','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311407205347329','1418181190581518337','1463311407205347329',2,2,'福建杰斐逊律师事务所','13599100513','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311407385702402','1425660338317033473','1463311407385702402',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311407557668865','1436144268304498689','1463311407557668865',2,2,'泉州椰子科技有限公司','19959877368','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311407729635329','1447825572620169218','1463311407729635329',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311407901601793','1448840628640182273','1463311407901601793',2,2,'晋江友雅服饰有限公司','18606037872','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311408086151170','1453892385195978753','1463311408086151170',2,2,'晋江市鹏星社会工作发展与评估中心','17750981257','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463311408308449281','1457925699133272065','1463311408308449281',2,2,'泉州荣晋置业有限公司','15659085663','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-24 09:00:01',NULL,NULL,NULL,'2021-11-24 09:00:01',NULL,NULL,NULL),('1463426424382713857',NULL,'1463426424382713857',2,1,NULL,'13645950989','457136','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-24 16:37:03',NULL,NULL,NULL,'2021-11-24 16:37:03',NULL,NULL,NULL),('1463673790662733826','1211120827064496130','1463673790662733826',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790671122433','1211167966465470465','1463673790671122433',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790700482561','1212685717864517633','1463673790700482561',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790973112321','58','1463673790973112321',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790981500930','71','1463673790981500930',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790985695233','83','1463673790985695233',1,2,'李女元','15359825666','3,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791119912962','1211529007779069954','1463673791119912962',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791132495873','1213844233778122754','1463673791132495873',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791132495874','1211454669394591746','1463673791132495874',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791237353473','58','1463673791237353473',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791258324994','87','1463673791258324994',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791312850945','1211837849989595138','1463673791312850945',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791317045249','1216559724997144578','1463673791317045249',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791325433857','1211461407799820290','1463673791325433857',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791413514242','87','1463673791413514242',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791447068674','102','1463673791447068674',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791489011714','1211473406755651586','1463673791489011714',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791493206017','1219451161745080321','1463673791493206017',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791619035138','102','1463673791619035138',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791623229442','116','1463673791623229442',1,2,'苏志英','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791669366785','1274912838720167938','1463673791669366785',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791686144001','1211474926804975617','1463673791686144001',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791828750338','116','1463673791828750338',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791841333250','1286499346338045953','1463673791841333250',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673791849721858','1211840469537964033','1463673791849721858',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673792004911105','1316201027820630017','1463673792004911105',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673792013299714','1216568840104734722','1463673792013299714',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673792176877570','1241252588561698817','1463673792176877570',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673792374009857','1290850604855361537','1463673792374009857',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673792550170626','1295900371603947522','1463673792550170626',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673792743108610','1341318122925195265','1463673792743108610',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673792915075073','1348924009986654209','1463673792915075073',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673793116401666','1351830895278948354','1463673793116401666',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673793334505473','1374549152519794689','1463673793334505473',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673793531637761','1374554432229978113','1463673793531637761',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673793716187138','1376712565047975937','1463673793716187138',2,2,'渠梁电子有限公司','18359882323','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673793883959297','1418181190581518337','1463673793883959297',2,2,'福建杰斐逊律师事务所','13599100513','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673794127228929','1425660338317033473','1463673794127228929',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673794307584001','1436144268304498689','1463673794307584001',2,2,'泉州椰子科技有限公司','19959877368','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:00',NULL,NULL,NULL,'2021-11-25 09:00:00',NULL,NULL,NULL),('1463673794479550465','1447825572620169218','1463673794479550465',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:01',NULL,NULL,NULL,'2021-11-25 09:00:01',NULL,NULL,NULL),('1463673794685071362','1457925699133272065','1463673794685071362',2,2,'泉州荣晋置业有限公司','15659085663','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-25 09:00:01',NULL,NULL,NULL,'2021-11-25 09:00:01',NULL,NULL,NULL),('1463777212787355649',NULL,'1463777212787355649',2,1,NULL,'18659568811','557422','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-25 15:50:57',NULL,NULL,NULL,'2021-11-25 15:50:57',NULL,NULL,NULL),('1463777703185379330',NULL,'1463777703185379330',2,1,NULL,'18659568811','867346','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-25 15:52:54',NULL,NULL,NULL,'2021-11-25 15:52:54',NULL,NULL,NULL),('1463777963408388097',NULL,'1463777963408388097',2,1,NULL,'18659568811','761891','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-25 15:53:56',NULL,NULL,NULL,'2021-11-25 15:53:56',NULL,NULL,NULL),('1464036178612219906','1211474926804975617','1464036178612219906',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178616414209','1212685717864517633','1464036178616414209',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178624802817','1449984044086358017','1464036178624802817',2,2,'佳福(福建)染整有限公司','15959591503','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178662551554','1211120827064496130','1464036178662551554',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178666745857','1211167966465470465','1464036178666745857',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178935181314','58','1464036178935181314',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179061010434','1452469610119983105','1464036179061010434',2,2,'晋江市清新文旅产业运营管理有限公司','18815981178','2,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179073593346','1211454669394591746','1464036179073593346',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179073593347','1213844233778122754','1464036179073593347',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179073593348','83','1464036179073593348',1,2,'李女元','15359825666','4,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179077787649','71','1464036179077787649',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179115536385','1211529007779069954','1464036179115536385',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179220393985','87','1464036179220393985',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179325251586','1452530245683933185','1464036179325251586',2,2,'晋江智信大数据科技有限公司','13489272625','1,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179329445890','1211837849989595138','1464036179329445890',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179329445891','1211461407799820290','1464036179329445891',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179379777537','102','1464036179379777537',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179379777538','58','1464036179379777538',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179400749058','1216559724997144578','1464036179400749058',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179551744001','1219451161745080321','1464036179551744001',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179551744002','1211473406755651586','1464036179551744002',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179576909825','87','1464036179576909825',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179673378817','116','1464036179673378817',1,2,'苏志英','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179857928194','1274912838720167938','1464036179857928194',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179862122497','102','1464036179862122497',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036179862122498','1211474926804975617','1464036179862122498',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180050866178','1211840469537964033','1464036180050866178',2,2,'福建省致慧医疗科技有限公司','19942826787','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180050866179','1286499346338045953','1464036180050866179',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180050866180','116','1464036180050866180',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180256387073','1212580494957416450','1464036180256387073',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180264775681','1316201027820630017','1464036180264775681',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180440936449','1216568840104734722','1464036180440936449',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180625485825','1241252588561698817','1464036180625485825',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036180843589634','1290850604855361537','1464036180843589634',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036181044916225','1295900371603947522','1464036181044916225',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036181246242818','1341318122925195265','1464036181246242818',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036181414014978','1348924009986654209','1464036181414014978',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036181577592834','1351830895278948354','1464036181577592834',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036181736976385','1374549152519794689','1464036181736976385',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036181921525761','1374554432229978113','1464036181921525761',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036182085103617','1376712565047975937','1464036182085103617',2,2,'渠梁电子有限公司','18359882323','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036182273847298','1418181190581518337','1464036182273847298',2,2,'福建杰斐逊律师事务所','13599100513','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:00',NULL,NULL,NULL,'2021-11-26 09:00:00',NULL,NULL,NULL),('1464036182454202370','1425660338317033473','1464036182454202370',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:01',NULL,NULL,NULL,'2021-11-26 09:00:01',NULL,NULL,NULL),('1464036182626168834','1447825572620169218','1464036182626168834',2,2,'泉州正朗置业有限公司','17350030786','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:01',NULL,NULL,NULL,'2021-11-26 09:00:01',NULL,NULL,NULL),('1464036182802329601','1457925699133272065','1464036182802329601',2,2,'泉州荣晋置业有限公司','15659085663','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-26 09:00:01',NULL,NULL,NULL,'2021-11-26 09:00:01',NULL,NULL,NULL),('1464085835317014530',NULL,'1464085835317014530',2,1,NULL,'13615940087','288266','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-26 12:17:19',NULL,NULL,NULL,'2021-11-26 12:17:19',NULL,NULL,NULL),('1464901995545522177',NULL,'1464901995545522177',2,1,NULL,'17689467640','185775','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-28 18:20:26',NULL,NULL,NULL,'2021-11-28 18:20:26',NULL,NULL,NULL),('1465123342422929409','1212685717864517633','1465123342422929409',2,2,'晋江市中医院','15960586523','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342443900930','1211167966465470465','1465123342443900930',2,2,'晋江易库物联网科技有限公司','18959210622','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',2,'消息因为某些原因被网关驳回','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342456483842','1211474926804975617','1465123342456483842',2,2,'泉州轻工职业学院','13799550180','1,晋江市优秀人才离职申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342506815489','1452469610119983105','1465123342506815489',2,2,'晋江市清新文旅产业运营管理有限公司','18815981178','2,晋江市优秀人才工作单位变更申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342867525634','1211120827064496130','1465123342867525634',2,2,'泉州市至真工具科技有限公司','13313825373','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343190487042','83','1465123343190487042',1,2,'李女元','15359825666','7,人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343257595905','58','1465123343257595905',1,2,'张荣荣','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343265984513','71','1465123343265984513',1,2,'王小阳','13559621092','1,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343320510466','1211529007779069954','1465123343320510466',2,2,'泉州文华轩信息科技有限公司','15805021228','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343328899074','1211454669394591746','1465123343328899074',2,2,'福建凤竹纺织科技股份有限公司','13506060342','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343354064897','1213844233778122754','1465123343354064897',2,2,'泉州市一听文化艺术有限公司','17750799505','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343463116802','87','1465123343463116802',1,2,'叶志钦','13675957398','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343471505410','58','1465123343471505410',1,2,'张荣荣','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343588945921','1211461407799820290','1465123343588945921',2,2,'晋江经济报发展有限责任公司','13505004167','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343597334530','1216559724997144578','1465123343597334530',2,2,'晋江市内坑兿林苑文化艺术中心','15160050023','1,晋江市优秀人才层次变更','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343626694657','1211837849989595138','1465123343626694657',2,2,'利郎（中国）有限公司','15959420909','2,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343656054786','102','1465123343656054786',1,2,'颜思思','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343656054787','87','1465123343656054787',1,2,'叶志钦','13675957398','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343802855426','1211473406755651586','1465123343802855426',2,2,'福建省麦都食品发展有限公司','13788809209','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343857381377','1219451161745080321','1465123343857381377',2,2,'泉州福林汽车销售服务有限公司','13675966551','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343949656065','102','1465123343949656065',1,2,'颜思思','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343966433282','116','1465123343966433282',1,2,'苏志英','15280619456','1,企业变更','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343974821890','1211474926804975617','1465123343974821890',2,2,'泉州轻工职业学院','13799550180','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123344046125058','1274912838720167938','1465123344046125058',2,2,'晋江市梅岭索风鞋业商行','15392271725','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123344176148481','116','1465123344176148481',1,2,'苏志英','15280619456','7,企业注册','【晋江市人才服务平台】您好！您有{$var}条{$var}信息尚未审核，请及时登录申报系统审核',2,'发送条数超限制','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123344180342785','1212580494957416450','1465123344180342785',2,2,'舒华体育股份有限公司','13599295908','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123344251645954','1286499346338045953','1465123344251645954',2,2,'瀚蓝(晋江)固废处理有限公司','15359826329','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123344436195329','1316201027820630017','1465123344436195329',2,2,'福建泉州晨曦知识产权代理有限公司','15160312213','1,晋江市优秀人才津补贴申报','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123345711263745','1216568840104734722','1465123345711263745',2,2,'晋江市福大科教园区发展中心','15880272172','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123345895813122','1241252588561698817','1465123345895813122',2,2,'福建哲创新材料科技有限公司','18160999097','4,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',1,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL,'2021-11-29 09:00:00',NULL,NULL,NULL),('1465123346067779586','1290850604855361537','1465123346067779586',2,2,'国网福建省电力有限公司晋江市供电公司','15606088075','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123346239746050','1295900371603947522','1465123346239746050',2,2,'雅客(中国)有限公司','18250600713','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123346420101121','1341318122925195265','1465123346420101121',2,2,'泉州晋江国际机场股份有限公司','15980019030','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123346604650498','1348924009986654209','1465123346604650498',2,2,'福建力利实业有限公司','13459503551','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123346785005569','1351830895278948354','1465123346785005569',2,2,'泉州顺丰运输有限公司晋江分公司','18876290332','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123347208630274','1374549152519794689','1465123347208630274',2,2,'泉州市盛维电子科技有限公司','15880975588','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123347665809409','1374554432229978113','1465123347665809409',2,2,'福建省晋华集成电路有限公司','15059820805','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123347955216386','1376712565047975937','1465123347955216386',2,2,'渠梁电子有限公司','18359882323','3,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123348194291714','1418181190581518337','1465123348194291714',2,2,'福建杰斐逊律师事务所','13599100513','2,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123348366258177','1425660338317033473','1465123348366258177',2,2,'晋江德源技术检测有限公司','15959552877','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465123348555001858','1457925699133272065','1465123348555001858',2,2,'泉州荣晋置业有限公司','15659085663','1,晋江市优秀人才认定','【晋江市人才服务平台】您好！您有{$var}条{$var}因信息填写错误或上传不完整已被退回，请及时登录申报系统查看审核意见并重新提交。',3,'短信发送成功','2021-11-29 09:00:01',NULL,NULL,NULL,'2021-11-29 09:00:01',NULL,NULL,NULL),('1465146332187488257',NULL,'1465146332187488257',2,1,NULL,'13055285626','707059','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-29 10:31:21',NULL,NULL,NULL,'2021-11-29 10:31:21',NULL,NULL,NULL),('1465150137599815682',NULL,'1465150137599815682',2,1,NULL,'13055285626','659130','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-29 10:46:28',NULL,NULL,NULL,'2021-11-29 10:46:28',NULL,NULL,NULL),('1465150781605834754',NULL,'1465150781605834754',2,1,NULL,'18459181930','642930','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-29 10:49:02',NULL,NULL,NULL,'2021-11-29 10:49:02',NULL,NULL,NULL),('1465152522971803649','1465150834340818946','1465152522971803649',2,2,'福建晋江经济开发区综合服务中心','18459181930','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',3,'短信发送成功','2021-11-29 10:55:57',NULL,NULL,NULL,'2021-11-29 10:55:57',NULL,NULL,NULL),('1465152725464412161',NULL,'1465152725464412161',2,1,NULL,'17750414596','963065','【晋江市人才服务平台】尊敬的用户，您的短信验证码为{$var}，5分钟内有效。若非本人操作请忽略。',3,'短信发送成功','2021-11-29 10:56:45',NULL,NULL,NULL,'2021-11-29 10:56:45',NULL,NULL,NULL),('1495585654787117058',NULL,'1495585653117784065',2,2,'Lana Thornton','17362523273','17362523273,晋江市硕博人才生活补贴申报,聚才网/人才晋江微信公众号,2022年02月21日,2022年02月22日,中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心,0595-85633128,jjrc85661234@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',1,NULL,'2022-02-21 10:26:21',NULL,NULL,NULL,'2022-02-21 10:26:21',NULL,NULL,NULL),('1495585654829060097',NULL,'1495585653117784065',2,2,'Malachi Little','17362523273','17362523273,晋江市硕博人才生活补贴申报,聚才网/人才晋江微信公众号,2022年02月21日,2022年02月22日,中共晋江市委人才办、晋江市纪委监委驻市人力资源和社会保障局纪检监察组或晋江市公共就业和人才服务中心,0595-85633128,jjrc85661234@163.com','【晋江市人才服务平台】您好！您提交申请的{$var}已完成初步审核，现通过{$var}将审核结果予以公示，公示时间{$var}至{$var}。公示期间如有异议，请及时向{$var}反映。电话{$var}，电子邮箱{$var}。',1,NULL,'2022-02-21 10:26:21',NULL,NULL,NULL,'2022-02-21 10:26:21',NULL,NULL,NULL),('1560678938777227266','1560676248278011905','1560678938777227266',2,2,'agenttest','13860786698','机构注册信息','【晋江市人才服务平台】您好！您提交申请的优秀人才{$var}已审核通过，可登录申报系统做相关事宜申报。',1,NULL,'2022-08-20 01:23:49',NULL,NULL,NULL,'2022-08-20 01:23:49',NULL,NULL,NULL);
/*!40000 ALTER TABLE `sys_message_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_notice`
--

DROP TABLE IF EXISTS `sys_notice`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_notice` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `title` varchar(255) DEFAULT NULL COMMENT '标题',
  `type` int(11) DEFAULT NULL COMMENT '类型',
  `content` text DEFAULT NULL COMMENT '内容',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `creater` int(11) DEFAULT NULL COMMENT '创建人',
  `topTime` varchar(50) DEFAULT NULL,
  `isTop` smallint(1) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=38 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='通知表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_notice`
--

LOCK TABLES `sys_notice` WRITE;
/*!40000 ALTER TABLE `sys_notice` DISABLE KEYS */;
INSERT INTO `sys_notice` VALUES (6,'欢迎',10,'<p><b>​欢迎来到晋江市人才综合服务平台</b><span style=\"color: inherit;\">?</span><br></p>','2017-01-11 08:53:20',1,'2017-01-11 08:53:20',2),(10,'通知',NULL,'<h5>为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</h5>','2020-03-23 06:25:46',1,'2020-03-23 06:25:46',2),(11,'注意',NULL,'<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。​</b></p>','2020-07-01 01:05:44',1,'2020-07-01 01:05:44',2),(12,'通知',NULL,'<p><span style=\"font-weight: bold;\">根据《晋江市人民政府关于印发促进制造业全链条全流程升级工作意见等11份政策的通知》（晋政文[2019]107号）精神，近期我市即将开展晋江市优秀人才子女择校申报工作，此次申报采用线上形式，具体操作如下：登录“聚才网→晋江市人才综合服务平台→注册新用户（个人用户注册）”。经与教育局沟通，申报材料无需提供晋江市优秀人才证书或公布入选批文，申报时间为2020年7月13日至7月20日，请大家相互转告，不要错过申报时间！联系电话：0595-85682803晋江市教育局初幼教科，0595-85633128晋江市公共就业和人才服务中心人才服务科</span></p>','2020-07-10 09:36:35',1,'2020-07-10 09:36:35',2),(15,'关于公布2019年度晋江市优秀人才入选名单的通知（晋人社〔2020〕65号）',NULL,'<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202007/1282941973271011329.pdf\" target=\"_blank\">关于公布2019年度晋江市优秀人才入选名单的通知（晋人社〔2020〕65号）</a><br></p>','2020-07-14 07:36:58',87,'2020-07-14 07:36:58',2),(16,'晋江市人力资源和社会保障局关于公布2020年度第一批晋江市优秀人才入选名单的通知（晋人社〔2020〕82号）',NULL,'<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202007/1283934898259763201.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2020年度第一批晋江市优秀人才入选名单的通知（晋人社〔2020〕82号）</a><br></p>','2020-07-17 01:23:41',87,'2020-07-17 01:23:41',2),(19,'2019优秀人才津补贴申报工作',NULL,'<p><!--StartFragment--><span style=\"color: inherit;\">?</span><b style=\"\"><font color=\"#8baa4a\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!--EndFragment-->&nbsp;</font></b></p>','2020-07-29 10:04:54',1,'2020-07-29 10:04:54',2),(20,'晋江市人力资源和社会保障局关于公布2020年度第二批晋江市优秀人才入选名单的通知（晋人社〔2020〕101号 ）',NULL,'<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202009/1302924824552734721.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2020年度第二批晋江市优秀人才入选名单的通知（晋人社〔2020〕101号 ）</a><br></p>','2020-09-07 11:03:54',87,'2020-09-07 19:03:54',2),(21,'关于密码强化的通知',NULL,'<p><span style=\"font-weight: bold; font-family: 微软雅黑; color: rgb(194, 79, 74);\">请各位使用弱密码(如123456)登陆的用户及时修改密码，防止密码被盗。</span></p>','2020-09-28 08:22:20',1,'2020-09-28 16:22:20',2),(22,'晋江市人力资源和社会保障局关于公布2020年度第三批晋江市优秀人才入选名单的通知（晋人社〔2020〕134号）	',NULL,'<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202011/1328592446891769857.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2020年度第三批晋江市优秀人才入选名单的通知（晋人社〔2020〕134号）</a><br></p>','2020-11-18 01:10:19',87,'2020-11-18 09:10:19',2),(23,'晋江市人力资源和社会保障局关于公布2020年度第四批晋江市优秀人才入选名单的通知（晋人社〔2020〕151号）',NULL,'<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202012/1341201837486768129.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2020年度第四批晋江市优秀人才入选名单的通知（晋人社〔2020〕151号）</a><br></p>','2020-12-22 02:02:22',87,'2020-12-22 10:02:22',2),(25,'晋江市人力资源和社会保障局关于公布2020年度第五批晋江市优秀人才入选名单的通知（晋人社〔2020〕157号）	',NULL,'<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202012/1344484826580779009.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2020年度第五批晋江市优秀人才入选名单的通知（晋人社〔2020〕157号）</a><br></p>','2021-01-18 09:59:10',87,'2021-01-18 17:59:10',2),(26,'晋江市人力资源和社会保障局关于公布2020年度第六批晋江市优秀人才入选名单的通知（晋人社〔2021〕12号）',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202102/1362243021365616642.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2020年度第六批晋江市优秀人才入选名单的通知（晋人社〔2021〕12号）</a><br></p>','2021-02-18 03:32:05',87,'2021-02-18 11:32:04',2),(27,'晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）',NULL,'<p><br></p><p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202103/1369567832454504450.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）</a><br></p>','2021-03-10 08:37:13',87,'2021-03-10 16:37:13',2),(28,'关于开展晋江市2020年度优秀人才津补贴申报工作的通知',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202103/1371616362530713601.doc\" target=\"_blank\">关于开展晋江市2020年度优秀人才津补贴申报工作的通知.doc</a><br></p>','2021-03-16 00:17:15',87,'2021-03-16 08:17:15',2),(29,'晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知（晋人社〔2021〕41号）',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202104/1379345403090124802.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知（晋人社〔2021〕41号）</a><br></p><p><br></p>','2021-04-06 08:09:58',87,'2021-04-06 16:09:57',2),(30,'晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知（晋人社〔2021〕58号）.pdf	',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202105/1390943601608929281.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知（晋人社〔2021〕58号）</a><br></p>','2021-05-08 08:17:21',87,'2021-05-08 16:17:21',2),(31,'晋江市人力资源和社会保障局关于公布2021年度第四批晋江市优秀人才入选名单的函（晋人社函〔2021〕62号）',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202106/1402103718983270402.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第四批晋江市优秀人才入选名单的函（晋人社函〔2021〕62号）</a><br></p>','2021-06-08 03:23:26',87,'2021-06-08 11:23:25',2),(33,'晋江市人力资源和社会保障局关于公布2021年度第五批晋江市优秀人才入选名单的函（晋人社函〔2021〕118号）.pdf	',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202107/1412677120609525761.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第五批晋江市优秀人才入选名单的函（晋人社函〔2021〕118号）</a><br></p>','2021-07-07 07:37:51',87,'2021-07-07 15:37:51',2),(34,'晋江市人力资源和社会保障局关于公布2021年度第六批晋江市优秀人才入选名单的函（晋人社函〔2021〕143号）.pdf	',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202108/1422834282421837825.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第六批晋江市优秀人才入选名单的函（晋人社函〔2021〕143号）</a><br></p>','2021-08-04 08:19:42',87,'2021-08-04 16:19:41',2),(35,'晋江市人力资源和社会保障局关于公布2021年度第七批晋江市优秀人才入选名单的函（晋人社函〔2021〕155号）.pdf',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202109/1432999730077552642.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第七批晋江市优秀人才入选名单的函（晋人社函〔2021〕155号）</a><br></p>','2021-09-01 09:33:39',87,'2021-09-01 17:33:39',2),(36,'晋江市人力资源和社会保障局关于公布2021年度第八批晋江市优秀人才入选名单的函（晋人社函〔2021〕171号）.pdf',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202110/1450270640039817217.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第八批晋江市优秀人才入选名单的函（晋人社函〔2021〕171号）</a><br></p>','2021-10-19 01:23:14',87,'2021-10-19 09:23:13',2),(37,'晋江市人力资源和社会保障局关于公布2021年度第九批晋江市优秀人才入选名单的函（晋人社函〔2021〕173号）.pdf	',NULL,'<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202111/1458728244822962177.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第九批晋江市优秀人才入选名单的函（晋人社函〔2021〕173号）</a><br></p><p><br></p>','2021-11-11 09:29:23',87,'2021-11-11 17:29:22',2);
/*!40000 ALTER TABLE `sys_notice` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_operation_log`
--

DROP TABLE IF EXISTS `sys_operation_log`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_operation_log` (
  `id` int(65) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `logtype` varchar(255) DEFAULT NULL COMMENT '日志类型',
  `logname` varchar(255) DEFAULT NULL COMMENT '日志名称',
  `userid` int(65) DEFAULT NULL COMMENT '用户id',
  `classname` varchar(255) DEFAULT NULL COMMENT '类名称',
  `method` text DEFAULT NULL COMMENT '方法名称',
  `createtime` datetime DEFAULT NULL COMMENT '创建时间',
  `succeed` varchar(255) DEFAULT NULL COMMENT '是否成功',
  `message` text DEFAULT NULL COMMENT '备注',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=2736 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='操作日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_operation_log`
--

LOCK TABLES `sys_operation_log` WRITE;
/*!40000 ALTER TABLE `sys_operation_log` DISABLE KEYS */;
INSERT INTO `sys_operation_log` VALUES (2014,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2019-12-29 08:35:20','成功','菜单名称=重新发送'),(2015,'异常日志','',58,NULL,NULL,'2019-12-30 00:56:21','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2016,'异常日志','',58,NULL,NULL,'2019-12-30 00:56:24','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2017,'异常日志','',58,NULL,NULL,'2019-12-30 00:56:54','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2018,'业务日志','修改管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2019-12-30 01:03:33','成功','账号=zrr;;;字段名称:头像,旧值:http://rc.jucai.gov.cn/ftp/jjrcw/headPortrait/201912/1207223535266881537.jpg,新值:[object Object];;;字段名称:null,旧值:b4fe476c1961aa2657819babb365425e,新值:;;;字段名称:null,旧值:1197443773921181697,新值:'),(2019,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2019-12-30 01:05:17','成功','账号=rsj1,角色名称集合=晋江市优秀人才-超级管理员'),(2020,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2019-12-30 01:41:53','成功','账号=rsj3;;;字段名称:账号,旧值:rsj2,新值:rsj3;;;字段名称:null,旧值:4b2ca3b469370f8999d36551e2655c47,新值:'),(2021,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2019-12-30 01:43:12','成功','账号=rsj2;;;字段名称:头像,旧值:jjrcw/headPortrait/201912/1211452722428035074.jpg,新值:;;;字段名称:账号,旧值:zrr,新值:rsj2;;;字段名称:null,旧值:b4fe476c1961aa2657819babb365425e,新值:'),(2022,'异常日志','',58,NULL,NULL,'2019-12-30 02:49:24','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2023,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2019-12-30 02:51:00','成功','账号=rsjzjk1'),(2024,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2019-12-30 02:51:35','成功','账号=rsjzjk1,角色名称集合=优秀人才认定部门审核'),(2025,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2019-12-30 02:52:37','成功','账号=rsjbsh'),(2026,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2019-12-30 02:53:14','成功','账号=rsjbsh'),(2027,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2019-12-30 02:54:01','成功','账号=rsjbsh1'),(2028,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2019-12-30 02:54:27','成功','账号=rsjbsh1,角色名称集合=优秀人才认定部门审核'),(2029,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:14','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2030,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:20','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2031,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:20','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2032,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:21','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2033,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:21','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2034,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:41','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2035,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:42','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2036,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:42','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2037,'异常日志','',58,NULL,NULL,'2019-12-30 02:55:42','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2038,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2019-12-30 02:56:01','成功','账号=rsj3'),(2039,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2019-12-30 02:56:04','成功','账号=rsj4'),(2040,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2019-12-30 02:56:54','成功','账号=rsj2'),(2041,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2019-12-30 02:57:39','成功','账号=rsj3'),(2042,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2019-12-30 02:58:12','成功','账号=rsj3,角色名称集合=晋江市优秀人才-超级管理员'),(2043,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2019-12-30 02:58:31','成功','账号=rsj1'),(2044,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2019-12-30 02:59:41','成功','账号=rsj2'),(2045,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2019-12-30 03:00:03','成功','账号=rsj2,角色名称集合=晋江市优秀人才-超级管理员'),(2046,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:14','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2047,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:15','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2048,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:15','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2049,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:16','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2050,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:50','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2051,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:51','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2052,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:51','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2053,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:51','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2054,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:51','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2055,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:51','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2056,'异常日志','',58,NULL,NULL,'2019-12-30 03:00:52','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2057,'异常日志','',58,NULL,NULL,'2019-12-30 03:06:20','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2058,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2019-12-30 03:11:04','成功','账号=rsj2'),(2059,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2019-12-30 03:13:54','成功','账号=rsj2'),(2060,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2019-12-30 03:14:00','成功','账号=rsj2,角色名称集合=晋江市优秀人才-超级管理员'),(2061,'异常日志','',87,NULL,NULL,'2019-12-30 08:59:34','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:243)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor130.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor526.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT58cf2bc5.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor543.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2062,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2019-12-30 14:22:15','成功','菜单名称=用户反馈'),(2063,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2019-12-30 14:22:37','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2064,'异常日志','',58,NULL,NULL,'2019-12-31 01:22:12','失败','com.stylefeng.guns.core.exception.GunsException: 该用户已经注册\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:237)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor142.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT5b825c12.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2065,'异常日志','',58,NULL,NULL,'2019-12-31 01:22:53','失败','com.stylefeng.guns.core.exception.GunsException: 该用户已经注册\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:237)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor142.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT5b825c12.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2066,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2019-12-31 01:43:20','成功','账号=adminIC1;;;字段名称:账号,旧值:adminIC,新值:adminIC1;;;字段名称:null,旧值:9f9c87e0bcd5ad08cda4054bcea85665,新值:'),(2067,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2019-12-31 01:43:25','成功','账号=adminIC;;;字段名称:账号,旧值:adminIC1,新值:adminIC;;;字段名称:null,旧值:9f9c87e0bcd5ad08cda4054bcea85665,新值:'),(2068,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2019-12-31 01:44:35','成功','字典名称=行业领域,字典内容=01:纺织鞋服:1;02:石油化工:2;03:机械设备:3;04:建材家居:4;05:食品:5;06:工艺制品:6;07:纸业印刷:7;08:新一代信息技术:8;09:生物与新医药:9;10:新材料:10;11:节能环保:11;12:光电:12;13:现代物流:13;14:电子商务:14;15:金融:15;16:旅游:16;17:文化创意:17;18:医疗:18;19:其他:19;;;;'),(2069,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2019-12-31 01:45:02','成功','字典名称=行业领域,字典内容=01:纺织鞋服:1;02:石油化工:2;03:机械设备:3;04:建材家居:4;05:食品:5;06:工艺制品:6;07:纸业印刷:7;08:新一代信息技术:8;09:生物与新医药:9;10:新材料:10;11:节能环保:11;12:光电:12;13:现代物流:13;14:电子商务:14;15:金融:15;16:旅游:16;17:文化创意:17;18:医疗:18;19:其他:20;20:教育:19;;;;'),(2070,'异常日志','',1,NULL,NULL,'2019-12-31 01:45:38','失败','com.stylefeng.guns.core.exception.GunsException: 该用户已经注册\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:237)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor142.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT5b825c12.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2071,'异常日志','',1,NULL,NULL,'2019-12-31 01:46:18','失败','com.stylefeng.guns.core.exception.GunsException: 该用户已经注册\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:237)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor142.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT5b825c12.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2072,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2019-12-31 02:34:42','成功','字典名称=行业领域,字典内容=01:纺织鞋服:1;02:石油化工:2;03:机械设备:3;04:建材家居:4;05:食品:5;06:工艺制品:6;07:纸业印刷:7;08:新一代信息技术:8;09:生物与新医药:9;10:新材料:10;11:节能环保:11;12:光电:12;13:现代物流:13;14:电子商务:14;15:金融:15;16:旅游:16;17:文化创意:17;19:其他:20;;;;'),(2073,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2019-12-31 07:47:07','成功','字典名称=行业领域,字典内容=01:纺织鞋服:1;02:石油化工:2;03:机械装备:3;04:建材家居:4;05:食品:5;06:工艺制品:6;07:纸业印刷:7;08:新一代信息技术:8;09:生物与新医药:9;10:新材料:10;11:节能环保:11;12:光电:12;13:现代物流:13;14:电子商务:14;15:金融:15;16:旅游:16;17:文化创意:17;19:其他:20;;;;'),(2074,'异常日志','',58,NULL,NULL,'2020-01-02 02:58:37','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:250)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTda7f3d36.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2075,'异常日志','',58,NULL,NULL,'2020-01-02 02:58:39','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:250)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTda7f3d36.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2076,'异常日志','',58,NULL,NULL,'2020-01-02 02:58:46','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:250)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTda7f3d36.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2077,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-02 03:02:06','成功','账号=rs03;;;字段名称:账号,旧值:rsj3,新值:rs03;;;字段名称:null,旧值:27b5454115ef347a4997dbdabdc5587f,新值:'),(2078,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-02 03:03:59','成功','账号=rs01;;;字段名称:账号,旧值:rsj2,新值:rs01;;;字段名称:null,旧值:8a301e27d071743655d0c3c1a806e6a4,新值:'),(2079,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-02 03:05:08','成功','账号=rs02;;;字段名称:头像,旧值:jjrcw/headPortrait/201912/1211452722428035074.jpg,新值:;;;字段名称:账号,旧值:zrr,新值:rs02;;;字段名称:null,旧值:cebc37bd7b79efabf89b2be0b9102ba1,新值:;;;字段名称:生日,旧值:1994-10-23,新值:1990-10-21'),(2080,'业务日志','添加管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-01-02 03:08:12','成功','账号=rs04'),(2081,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-01-02 03:12:39','成功','账号=rs04,角色名称集合=晋江市优秀人才-超级管理员'),(2082,'异常日志','',1,NULL,NULL,'2020-01-02 08:46:53','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoController.toCheckPage(TalentAllowanceInfoController.java:117)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoControllerTTFastClassBySpringCGLIBTTa57ca3d3.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoControllerTTEnhancerBySpringCGLIBTT3e58f7c6.toCheckPage(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2083,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:09','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2084,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:11','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2085,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:16','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2086,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:17','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2087,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:17','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2088,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:17','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2089,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:20','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2090,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:23','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2091,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:24','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2092,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:24','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2093,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:35','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2094,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:39','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2095,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:39','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2096,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:40','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2097,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:40','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2098,'异常日志','',58,NULL,NULL,'2020-01-02 09:08:44','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseController.findEnterpriseByPage(EnterpriseController.java:110)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTFastClassBySpringCGLIBTT39976a4f.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.enterprise.controller.EnterpriseControllerTTEnhancerBySpringCGLIBTT25eb38ba.findEnterpriseByPage(<generated>)\n	at sun.reflect.GeneratedMethodAccessor663.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2099,'异常日志','',58,NULL,NULL,'2020-01-03 00:43:55','失败','java.lang.NullPointerException\n	at com.stylefeng.guns.modular.talentIdentify.controller.IdentifyConditionController.list(IdentifyConditionController.java:90)\n	at com.stylefeng.guns.modular.talentIdentify.controller.IdentifyConditionControllerTTFastClassBySpringCGLIBTT29b6d5a2.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor88.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentIdentify.controller.IdentifyConditionControllerTTEnhancerBySpringCGLIBTTdf31a693.list(<generated>)\n	at sun.reflect.GeneratedMethodAccessor1057.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2100,'业务日志','新增通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-01-04 12:08:23','成功','标题=提醒'),(2101,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-01-04 12:09:09','成功','标题=提醒;;;字段名称:内容,旧值:<p>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</p>,新值:<h3><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</h3><p><br></p>'),(2102,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-01-04 12:09:37','成功','标题=提醒;;;字段名称:内容,旧值:<h3><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</h3><p><br></p>,新值:<h4><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</h4><h5><br></h5>'),(2103,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-01-04 12:10:16','成功','标题=提醒;;;字段名称:内容,旧值:<h4><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</h4><h5><br></h5>,新值:<p><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</p>'),(2104,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-01-06 01:18:41','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2105,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-01-06 12:33:58','成功','字典名称=申报类别,字典内容=1:津补贴-晋江市优秀人才:1;2:津补贴-集成电路:2;3:海峡计划申报:3;4:人才认定-晋江市优秀人才:4;;;;'),(2106,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-01-07 09:11:23','成功','标题=提醒;;;字段名称:内容,旧值:<p><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</p>,新值:<p><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</p><p>&nbsp; &nbsp;&nbsp;<b><span style=\"color: inherit;\">晋江市公共</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">就业和</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">人才服务中心：0595-</span><span style=\"color: inherit;\">85633128，0595-85662310</span></b></p><p><br></p>'),(2107,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-01-07 09:11:53','成功','标题=提醒;;;字段名称:内容,旧值:<p><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?</p><p>&nbsp; &nbsp;&nbsp;<b><span style=\"color: inherit;\">晋江市公共</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">就业和</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">人才服务中心：0595-</span><span style=\"color: inherit;\">85633128，0595-85662310</span></b></p><p><br></p>,新值:<p><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?（<b style=\"color: inherit;\"><span style=\"color: inherit;\">晋江市公共</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">就业和</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">人才服务中心：0595-</span><span style=\"color: inherit;\">85633128，0595-85662310）</span></b></p><p><br></p>'),(2108,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-01-07 09:12:16','成功','标题=提醒;;;字段名称:内容,旧值:<p><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?（<b style=\"color: inherit;\"><span style=\"color: inherit;\">晋江市公共</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">就业和</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">人才服务中心：0595-</span><span style=\"color: inherit;\">85633128，0595-85662310）</span></b></p><p><br></p>,新值:<p><b>由于系统初次上线，可能存在一些问题，希望大家多多理解。一旦发现异常，请直接联系相关单位，无需多次尝试，以免耽误各位宝贵的时间。</b>?（<b style=\"color: inherit;\"><span style=\"color: inherit;\">晋江市公共</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">就业和</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">​</span><span style=\"color: inherit;\">人才服务中心：0595-</span><span style=\"color: inherit;\">85633128，0595-85662310）</span></b></p>'),(2109,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-08 07:15:05','成功','账号=admin;;;字段名称:头像,旧值:jjrcw/headPortrait/201912/1210533750539137026.png,新值:;;;字段名称:null,旧值:d8696556df580605ca83bbb96448b276,新值:'),(2110,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-08 07:15:35','成功','账号=admin;;;字段名称:头像,旧值:jjrcw/headPortrait/201912/1210533750539137026.png,新值:;;;字段名称:null,旧值:d8696556df580605ca83bbb96448b276,新值:'),(2111,'业务日志','添加角色',1,'com.stylefeng.guns.modular.system.controller.RoleController','add','2020-01-08 08:03:43','成功','角色名称=街道办事员'),(2112,'业务日志','修改管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-13 08:42:13','成功','账号=rs03;;;字段名称:头像,旧值:,新值:[object Object];;;字段名称:null,旧值:27b5454115ef347a4997dbdabdc5587f,新值:;;;字段名称:null,旧值:1197443773921181697,新值:'),(2113,'业务日志','修改管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-13 08:42:19','成功','账号=rs03;;;字段名称:头像,旧值:,新值:[object Object];;;字段名称:null,旧值:27b5454115ef347a4997dbdabdc5587f,新值:;;;字段名称:null,旧值:1197443773921181697,新值:'),(2114,'业务日志','修改管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-01-13 08:42:40','成功','账号=rs03;;;字段名称:null,旧值:27b5454115ef347a4997dbdabdc5587f,新值:;;;字段名称:null,旧值:1197443773921181697,新值:'),(2115,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-01-19 07:24:42','成功','菜单名称=统计分析'),(2116,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-01-19 07:29:10','成功','菜单名称=数据统计'),(2117,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-01-20 15:21:49','成功','字典名称=人才标签,字典内容=gzh:国字号平台:1;xzry:行政人员（高校）:2;zzjs:专职教师（高校）:3;wpjs:外聘教师（高校）:4;wpfjs:外聘非教师（高校）:5;gbwszb:公办医疗卫生机构（卫生在编）:20;gbwsbw:公办医疗卫生机构（卫生编外）:22;zzbsh:在站博士后:24;qzrygwh:全职人员（管委会）（高校）:6;qzrybz:全职人员（晋江编制、常驻校区）（高校）:7;zbzgjsjx:在编在岗教师（教学）（高校）:8;zbzgjskyzd:在编在岗教师（科研指导）（高校）:9;zbzgjsjxky:在编在岗教师（教学科研）（高校）:10;myqy:民营企业:11;mtdw:媒体单位:12;mbfqy:民办非企业:13;gyqyl:国有企业（我市本级国有股比未超过50％）:14;sydw:事业单位（医疗教育除外）:16;mbylwsjg:民办医疗卫生机构:17;other:其他:18;gyqyh:国有企业 （我市本级国有股比超过50％）:15;other:其他:19;;;;'),(2118,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-01-20 15:22:18','成功','字典名称=企业标签,字典内容=gzh:国字号平台:1;myqy:民营企业:2;gbylwsjg:公办医疗卫生机构:3;mtdw:媒体单位:5;mbfqy:民办非企业（含民办医疗机构）:6;gyqyh:国有企业 （我市本级国有股比超过50％）:7;sydw:事业单位（医疗教育除外）:9;zzbsh:在站博士后:10;gx:高校:11;gyqyl:国有企业（我市本级国有股比未超过50％）:8;other:其他:12;;;;'),(2119,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-01-22 03:47:16','成功','字典名称=人才标签,字典内容=gzh:国字号平台:1;xzry:行政人员（高校）:2;zzjs:专职教师（高校）:3;wpjs:外聘教师（高校）:4;wpfjs:外聘非教师（高校）:5;gbwszb:公办医疗卫生机构（卫生在编）:20;gbwsbw:公办医疗卫生机构（卫生编外）:22;zzbsh:在站博士后:24;qzrygwh:全职人员（管委会）（高校）:6;qzrybz:全职人员（晋江编制、常驻校区）（高校）:7;zbzgjsjx:在编在岗教师（教学）（高校）:8;zbzgjskyzd:在编在岗教师（科研指导）（高校）:9;zbzgjsjxky:在编在岗教师（教学科研）（高校）:10;myqy:民营企业:11;mtdw:媒体单位:12;mbfqy:民办非企业:13;gyqyl:国有企业（我市本级国有股比未超过50％）:14;sydw:事业单位（医疗教育除外）:16;mbylwsjg:民办医疗卫生机构:17;other:其他:18;gyqyh:国有企业 （我市本级国有股比超过50％）:15;;;;'),(2120,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-02-27 07:27:44','成功','字典名称=企业标签,字典内容=gzh:国字号平台:1;myqy:民营企业:2;gbylwsjg:公办医疗卫生机构:3;mtdw:媒体单位:5;mbfqy:民办非企业（含民办医疗机构）:6;gyqyh:国有企业 （我市本级国有股比超过50％）:7;sydw:事业单位（医疗教育除外）:9;gx:高校:11;gyqyl:国有企业（我市本级国有股比未超过50％）:8;other:其他:12;;;;'),(2121,'异常日志','',58,NULL,NULL,'2020-03-04 09:20:22','失败','com.stylefeng.guns.core.exception.GunsException: 该用户已经注册\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:207)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor146.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT8544db3e.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2122,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-04 09:51:55','成功','账号=xcb2,角色名称集合=优秀人才认定部门审核,优秀人才-企业注册兼部门审核'),(2123,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-04 10:05:06','成功','账号=xcb2,角色名称集合=优秀人才认定部门审核'),(2124,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-04 10:08:06','成功','账号=xcb1,角色名称集合=企业账号审核,优秀人才认定部门审核'),(2125,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-04 10:10:00','成功','账号=xcb1,角色名称集合=企业账号审核'),(2126,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-04 10:10:25','成功','账号=xcb2,角色名称集合=优秀人才认定部门审核'),(2127,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-04 11:32:22','成功','账号=xcb2,角色名称集合=优秀人才-企业注册兼部门审核'),(2128,'业务日志','修改管理员',82,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-03-05 02:26:58','成功','账号=sjj1;;;字段名称:null,旧值:e4403d82357acc141814793d463b6d29,新值:;;;字段名称:性别,旧值:男,新值:女;;;字段名称:null,旧值:1210488645792022529,新值:'),(2129,'异常日志','',87,NULL,NULL,'2020-03-05 07:16:13','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:250)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor362.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf22afb3b.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2130,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-05 07:17:54','成功','账号=gxj,角色名称集合=晋江市优秀人才-超级管理员,优秀人才认定部门审核'),(2131,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-03-05 07:18:03','成功','账号=gxj,角色名称集合=优秀人才认定部门审核'),(2132,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-03-19 14:42:30','成功','菜单名称=修改驳回字段'),(2133,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-03-19 14:43:04','成功','角色名称=晋江市优秀人才-初审,资源名称=人才认定管理,初级审核,审核,导出,下载,修改驳回字段,人才层次变更,初级审核,审核,查看,导出,下载'),(2134,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-03-19 14:43:13','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2135,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-03-19 14:43:31','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2136,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-03-23 05:54:12','成功','菜单名称=发送短信'),(2137,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-03-23 05:54:41','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2138,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-03-23 05:54:50','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2139,'业务日志','新增通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-03-23 06:25:46','成功','标题=通知'),(2140,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-03-23 06:26:07','成功','标题=通知;;;字段名称:内容,旧值:<h4><span style=\"font-weight: bold;\">为了避免经办人一天受到大量短信骚扰，人才认定驳</span>回提醒已修改为每日一次短信提醒，不再及时发送短信<span style=\"font-weight: bold;\"></span>。</h4>,新值:<h4><span style=\"font-weight: bold;\">为了避免经办人一天受到大量短信骚扰，人才认定驳</span>回提醒已修改为每日一次短信提醒，不再及时发送短信<span style=\"font-weight: bold;\"></span>。</h4><p><br></p>'),(2141,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-03-23 06:26:18','成功','标题=通知;;;字段名称:内容,旧值:<h4><span style=\"font-weight: bold;\">为了避免经办人一天受到大量短信骚扰，人才认定驳</span>回提醒已修改为每日一次短信提醒，不再及时发送短信<span style=\"font-weight: bold;\"></span>。</h4><p><br></p>,新值:<h5><span style=\"font-weight: bold;\">为了避免经办人一天受到大量短信骚扰，人才认定驳</span>回提醒已修改为每日一次短信提醒，不再及时发送短信<span style=\"font-weight: bold;\"></span>。</h5><p><br></p>'),(2142,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-03-23 06:26:49','成功','标题=通知;;;字段名称:内容,旧值:<h5><span style=\"font-weight: bold;\">为了避免经办人一天受到大量短信骚扰，人才认定驳</span>回提醒已修改为每日一次短信提醒，不再及时发送短信<span style=\"font-weight: bold;\"></span>。</h5><p><br></p>,新值:<h5><span style=\"font-weight: normal;\">为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</span></h5><p><br></p>'),(2143,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-03-23 06:26:57','成功','标题=通知;;;字段名称:内容,旧值:<h5><span style=\"font-weight: normal;\">为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</span></h5><p><br></p>,新值:<h5><span style=\"font-weight: normal;\">为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</span></h5>'),(2144,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-03-23 06:27:18','成功','标题=通知;;;字段名称:内容,旧值:<h5><span style=\"font-weight: normal;\">为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</span></h5>,新值:<h5>为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</h5><p><br></p>'),(2145,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-03-23 06:27:36','成功','标题=通知;;;字段名称:内容,旧值:<h5>为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</h5><p><br></p>,新值:<h5>为了避免经办人一天受到大量短信骚扰，人才认定驳回提醒已修改为每日一次短信提醒，不再及时发送短信。</h5>'),(2146,'异常日志','',83,NULL,NULL,'2020-03-24 01:51:58','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor146.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTbcbff21b.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2147,'异常日志','',83,NULL,NULL,'2020-03-24 01:52:10','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor146.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTbcbff21b.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2148,'异常日志','',83,NULL,NULL,'2020-03-24 01:52:49','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor146.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTbcbff21b.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2149,'异常日志','',83,NULL,NULL,'2020-03-24 01:52:51','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor146.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTbcbff21b.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2150,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-03-24 02:12:35','成功','菜单名称=回复'),(2151,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-03-24 02:39:54','成功','字典名称=申报类别,字典内容=1:津补贴-晋江市优秀人才:1;2:津补贴-晋江市集成电路:2;3:海峡计划申报:3;4:人才认定-晋江市优秀人才:4;;;;'),(2152,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-03-24 02:40:16','成功','字典名称=申报类别,字典内容=1:津补贴-晋江市优秀人才:1;2:津补贴-晋江市集成电路:2;3:海峡计划申报:3;4:人才认定-晋江市优秀人才:4;5:人才认定-晋江市集成电路:5;;;;'),(2153,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-03-24 03:04:52','成功','字典名称=申报类别,字典内容=1:津补贴（晋江市优秀人才）:1;2:津补贴（晋江市集成电路）:2;3:海峡计划申报:3;4:人才认定（晋江市优秀人才）:4;5:人才认定（晋江市集成电路）:5;6:离职申报（晋江市优秀人才）:6;7:离职申报（晋江市集成电路）:7;8:工作单位变更（晋江市优秀人才）:8;9:工作单位变更（晋江市集成电路）:9;;;;'),(2154,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-03-24 05:34:51','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2155,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-03-24 05:34:59','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2156,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2020-03-31 02:13:34','成功','字典名称=婚姻状态,字典内容=1:未婚:1;2:已婚:2;3:丧偶:3;4:离异:4;'),(2157,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-04-03 00:31:25','成功','账号=rs05'),(2158,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-04-03 00:34:25','成功','账号=rs05,角色名称集合=晋江市优秀人才-初审'),(2159,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-04-07 02:17:11','成功','账号=rs05,角色名称集合=企业账号审核,晋江市优秀人才-初审,晋江市优秀人才-复核'),(2160,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2020-04-08 01:59:28','成功','字典名称=证件类型,字典内容=1:身份证:1;2:通行证:2;3:护照:3;'),(2161,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-04-08 02:01:13','成功','字典名称=申报类别,字典内容=1:津补贴（晋江市优秀人才）:1;2:津补贴（晋江市集成电路）:2;3:海峡计划申报:3;4:人才认定（晋江市优秀人才）:4;5:人才认定（晋江市集成电路）:5;6:离职申报（晋江市优秀人才）:6;7:离职申报（晋江市集成电路）:7;8:工作单位变更（晋江市优秀人才）:8;9:工作单位变更（晋江市集成电路）:9;10:购房补贴（晋江市优秀人才）:10;;;;'),(2162,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2020-04-08 02:05:20','成功','字典名称=与申报人关系,字典内容=1:父子:1;2:父女:2;3:母子:3;4:母女:4;'),(2163,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2020-04-08 02:19:44','成功','字典名称=年级,字典内容=-1:学前教育:1;1:一年级:2;2:二年级:3;3:三年级:4;4:四年级:5;5:五年级:6;6:六年级:7;7:七年级（初一）:8;8:八年级（初二）:9;9:九年级（初三）:10;'),(2164,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-04-08 08:10:54','成功','字典名称=申报类别,字典内容=1:津补贴（晋江市优秀人才）:1;2:津补贴（晋江市集成电路）:2;3:海峡计划申报:3;4:人才认定（晋江市优秀人才）:4;5:人才认定（晋江市集成电路）:5;6:离职申报（晋江市优秀人才）:6;7:离职申报（晋江市集成电路）:7;8:工作单位变更（晋江市优秀人才）:8;9:工作单位变更（晋江市集成电路）:9;10:购房补贴（晋江市优秀人才）:10;30:子女就学（晋江市优秀人才）:30;31:子女就学（晋江市集成电路）:31;;;;'),(2165,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2020-04-08 10:02:20','成功','字典名称=申报项目,字典内容=1:人才认定:1;2:津补贴申报:2;3:离职变更:3;4:工作单位变更:4;5:购房补贴:5;6:子女就学:6;8:人才层次变更:8;'),(2166,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-04-10 03:39:35','成功','菜单名称=子女就学'),(2167,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-04-10 03:40:38','成功','菜单名称=子女择校'),(2168,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-04-10 03:42:23','成功','菜单名称=审核'),(2169,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-04-10 03:43:22','成功','菜单名称=导出'),(2170,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-04-12 06:04:38','成功','菜单名称=审核不通过'),(2171,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-04-12 07:48:42','成功','字典名称=申报项目,字典内容=1:人才认定:1;2:津补贴申报:2;3:离职变更:3;4:工作单位变更:4;5:购房补贴:5;6:子女就学:6;8:人才层次变更:8;7:银行账号变更:7;;;;'),(2172,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2020-04-12 07:50:30','成功','字典名称=子女择校申报项目,字典内容=1:择校:2;1:中考加分:2;'),(2173,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-04-12 08:01:36','成功','字典名称=年级,字典内容=1:学前教育（小班）:1;2:学前教育（中班）:2;3:学前教育（大班）:3;4:一年级:4;5:二年级:5;6:三年级:6;7:四年级:7;8:五年级:8;9:六年级:9;10:七年级（初一）:10;11:八年级（初二）:11;12:九年级（初三）:12;13:高一:13;14:高二:14;15:高三:15;;;;'),(2174,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-04-13 02:23:04','成功','菜单名称=导出'),(2175,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-04-15 01:13:12','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2176,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-04-15 01:13:51','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2177,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-04-23 01:37:23','成功','账号=admin;;;字段名称:头像,旧值:http://rc.jucai.gov.cn/ftp/jjrcw/headPortrait/201912/1210533750539137026.png,新值:[object Object];;;字段名称:null,旧值:d8696556df580605ca83bbb96448b276,新值:;;;字段名称:null,旧值:1196347541488906242,新值:'),(2178,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-04-30 02:25:51','成功','菜单名称=撤销复核'),(2179,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-04-30 06:03:16','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2180,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-04-30 06:03:25','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2181,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-04-30 06:04:11','成功','角色名称=集成电路-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,人才津贴配置,添加,修改,删除,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2182,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-04-30 06:04:22','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2183,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-05-06 01:02:58','成功','字典名称=婚姻状态,字典内容=1:未婚:1;2:已婚:2;3:丧偶:3;4:离异:4;;;;'),(2184,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-05-07 01:10:53','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-05-13 17:30:00;;;字段名称:提交截止时间,旧值:2020-04-13 09:00:00,新值:2020-05-13 17:30:00'),(2185,'业务日志','修改批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-05-13 09:30:14','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-05-14 17:30:00;;;字段名称:提交截止时间,旧值:2020-05-13 17:30:00,新值:2020-05-14 17:30:00'),(2186,'异常日志','',83,NULL,NULL,'2020-05-15 07:44:10','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor372.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTeed089de.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2187,'异常日志','',83,NULL,NULL,'2020-05-15 07:44:19','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor372.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTeed089de.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2188,'异常日志','',83,NULL,NULL,'2020-05-15 07:44:41','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor372.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTeed089de.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2189,'异常日志','',83,NULL,NULL,'2020-05-15 07:45:32','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor372.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTeed089de.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2190,'业务日志','重置管理员密码',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2020-05-15 09:02:08','成功','账号=jyj1'),(2191,'异常日志','',83,NULL,NULL,'2020-05-15 09:11:36','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor372.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTeed089de.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2192,'业务日志','重置管理员密码',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2020-05-18 08:35:50','成功','账号=jyj1'),(2193,'异常日志','',83,NULL,NULL,'2020-05-18 08:56:11','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor372.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTeed089de.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2194,'异常日志','',83,NULL,NULL,'2020-05-18 08:56:49','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor372.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTeed089de.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2195,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-05-20 00:59:03','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-05-20 17:30:00;;;字段名称:提交截止时间,旧值:2020-05-14 17:30:00,新值:2020-05-20 17:30:00'),(2196,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-05-20 01:35:23','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-05-14 17:30:00;;;字段名称:提交截止时间,旧值:2020-05-20 17:30:00,新值:2020-05-14 17:30:00'),(2197,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-05-25 02:04:41','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-05-25 17:30:00;;;字段名称:提交截止时间,旧值:2020-05-14 17:30:00,新值:2020-05-25 17:30:00'),(2198,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-05-25 08:35:50','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-05-26 17:30:00;;;字段名称:提交截止时间,旧值:2020-05-25 17:30:00,新值:2020-05-26 17:30:00'),(2199,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-05-26 08:40:52','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-05-27 17:30:00;;;字段名称:提交截止时间,旧值:2020-05-26 17:30:00,新值:2020-05-27 17:30:00'),(2200,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-06-04 07:26:59','成功','菜单名称=公示预览'),(2201,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-06-04 07:27:29','成功','菜单名称=公布预览'),(2202,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-06-04 07:27:48','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2203,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-06-04 07:27:59','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2204,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-10 00:44:46','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2021-05-10 17:30:00;;;字段名称:提交截止时间,旧值:2020-05-27 17:30:00,新值:2021-05-10 17:30:00'),(2205,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-10 00:45:01','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-06-10 17:30:00;;;字段名称:提交截止时间,旧值:2021-05-10 17:30:00,新值:2020-06-10 17:30:00'),(2206,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-10 09:09:54','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-06-11 17:30:00;;;字段名称:提交截止时间,旧值:2020-06-10 17:30:00,新值:2020-06-11 17:30:00'),(2207,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-17 07:20:31','成功','申报类型=1,申报批次=2019,开始时间=2019-10-28 00:00:00,截止时间=2019-12-31 00:00:00,提交截止时间=;;;'),(2208,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-17 07:20:43','成功','申报类型=2,申报批次=2018,开始时间=2019-10-29 00:00:00,截止时间=2020-10-29 00:00:00,提交截止时间=;;;'),(2209,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-17 07:20:49','成功','申报类型=4,申报批次=2019,开始时间=2019-12-28 00:00:00,截止时间=2020-01-24 00:00:00,提交截止时间=2020-06-11 17:30:00;;;'),(2210,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2020-06-19 02:05:08','成功','申报类型=1,申报批次=2020,开始时间=2020-06-19 10:03:57,截止时间=2020-12-31 17:30:00,提交截止时间='),(2211,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-06-19 02:05:14','成功','批次id=1273798939744698370'),(2212,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-19 02:13:04','成功','申报类型=3,申报批次=2020,开始时间=2020-06-19 10:11:48,截止时间=2020-12-31 17:30:00,提交截止时间=;;;字段名称:申报类型,旧值:4,新值:3;;;字段名称:申报批次,旧值:2019,新值:2020;;;字段名称:开始时间,旧值:2019-12-28 00:00:00,新值:2020-06-19 10:11:48;;;字段名称:截止时间,旧值:2020-01-24 00:00:00,新值:2020-12-31 17:30:00;;;字段名称:提交截止时间,旧值:2020-06-11 17:30:00,新值:'),(2213,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2020-06-19 02:14:05','成功','申报类型=4,申报批次=2020,开始时间=2020-06-19 10:13:32,截止时间=2020-12-31 17:30:00,提交截止时间='),(2214,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-06-19 02:15:03','成功','批次id=1273801192236941314'),(2215,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2020-06-19 02:16:04','成功','申报类型=7,申报批次=2020,开始时间=2020-06-19 10:15:51,截止时间=2020-12-31 17:30:00,提交截止时间='),(2216,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-06-19 02:16:07','成功','批次id=1273801692315418626'),(2217,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-19 02:16:56','成功','申报类型=8,申报批次=2020,开始时间=2020-06-19 10:16:41,截止时间=2020-12-31 17:30:00,提交截止时间=;;;字段名称:申报类型,旧值:2,新值:8;;;字段名称:申报批次,旧值:2018,新值:2020;;;字段名称:开始时间,旧值:2019-10-29 00:00:00,新值:2020-06-19 10:16:41;;;字段名称:截止时间,旧值:2020-10-29 00:00:00,新值:2020-12-31 17:30:00'),(2218,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-19 02:32:03','成功','申报类型=7,申报批次=2020,开始时间=2020-06-19 10:15:51,截止时间=2020-12-31 17:30:00,提交截止时间=;;;字段名称:是否生效,旧值:1,新值:2'),(2219,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-19 02:32:31','成功','申报类型=4,申报批次=2020,开始时间=2020-06-19 10:13:32,截止时间=2020-12-31 17:30:00,提交截止时间=;;;字段名称:是否生效,旧值:1,新值:2'),(2220,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-06-19 02:33:19','成功','申报类型=3,申报批次=2020,开始时间=2020-06-19 10:11:48,截止时间=2020-12-31 17:30:00,提交截止时间=;;;字段名称:是否生效,旧值:1,新值:2'),(2221,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-06-19 02:39:08','成功','菜单名称=设置失效'),(2222,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-06-19 02:55:57','成功','批次id=1214163377287417857'),(2223,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-06-19 02:56:03','成功','批次id=1273801192236941314'),(2224,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-06-19 02:56:06','成功','批次id=1273801692315418626'),(2225,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-06-24 00:54:49','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,设置失效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载'),(2226,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-06-24 00:54:57','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,设置失效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出,导出项目录入模板,导入项目核查结果,走访核查,审核,导出,导出项目录入模板,导入项目核查结果,复核,审核,导出,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现'),(2227,'业务日志','修改管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-06-24 09:38:03','成功','账号=rs02;;;字段名称:头像,旧值:http://rc.jucai.gov.cn/ftp/jjrcw/headPortrait/201912/1211452722428035074.jpg,新值:[object Object];;;字段名称:null,旧值:cebc37bd7b79efabf89b2be0b9102ba1,新值:'),(2228,'业务日志','修改管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-06-28 01:33:04','成功','账号=rs02;;;字段名称:头像,旧值:http://rc.jucai.gov.cn/ftp/jjrcw/headPortrait/202006/1275724852157792258.jpg,新值:[object Object];;;字段名称:null,旧值:cebc37bd7b79efabf89b2be0b9102ba1,新值:;;;字段名称:生日,旧值:1990-10-19,新值:2000-10-01'),(2229,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-06-28 03:41:14','成功','字典名称=企业标签,字典内容=gzh:国字号平台:1;myqy:民营企业:2;gbylwsjg:公办医疗卫生机构:3;mtdw:媒体单位:5;mbfqy:民办非企业(含民办医疗机构):6;gyqyh:国有企业 (我市本级国有股比超过50％):7;gyqyl:国有企业(我市本级国有股比未超过50％):8;sydw:事业单位(医疗教育除外):9;gx:高校:11;other:其他:12;sydwyljy:事业单位(医疗教育):13;;;;'),(2230,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-06-28 03:44:36','成功','字典名称=人才标签,字典内容=gzh:国字号平台:1;xzry:行政人员(高校):2;zzjs:专职教师(高校):3;wpjs:外聘教师(高校):4;wpfjs:外聘非教师(高校):5;qzrygwh:全职人员(管委会)(高校):6;qzrybz:全职人员(晋江编制、常驻校区)(高校):7;zbzgjsjx:在编在岗教师(教学)(高校):8;zbzgjskyzd:在编在岗教师(科研指导)(高校):9;zbzgjsjxky:在编在岗教师(教学科研)(高校):10;myqy:民营企业:11;mtdw:媒体单位:12;mbfqy:民办非企业:13;gyqyl:国有企业(我市本级国有股比未超过50％):14;gyqyh:国有企业 (我市本级国有股比超过50％):15;sydw:事业单位(医疗教育除外):16;mbylwsjg:民办医疗卫生机构:17;other:其他:18;gbwszb:公办医疗卫生机构(卫生在编):20;gbwsbw:公办医疗卫生机构(卫生编外):22;zzbsh:在站博士后:24;sydwyljybzry:事业单位(医疗教育)(编制人员):25;sydwyljypyry:事业单位(医疗教育)(聘用人员):26;;;;'),(2231,'异常日志','',87,NULL,NULL,'2020-06-30 00:23:24','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2232,'异常日志','',87,NULL,NULL,'2020-06-30 00:24:19','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2233,'异常日志','',87,NULL,NULL,'2020-06-30 00:24:23','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2234,'异常日志','',87,NULL,NULL,'2020-06-30 00:24:24','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2235,'异常日志','',87,NULL,NULL,'2020-06-30 00:24:28','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2236,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-06-30 01:43:27','成功','账号=z'),(2237,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-06-30 01:43:48','成功','账号=z,角色名称集合=超级管理员,晋江市优秀人才-超级管理员,企业账号审核,优秀人才认定部门审核,优秀人才-企业注册兼部门审核,晋江市优秀人才-初审,晋江市优秀人才-复核,街道办事员'),(2238,'业务日志','删除管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2020-06-30 01:44:42','成功','账号=z'),(2239,'业务日志','删除通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','delete','2020-07-01 01:05:01','成功','null=9'),(2240,'业务日志','新增通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-01 01:05:44','成功','标题=注意'),(2241,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-01 01:07:33','成功','标题=注意;;;字段名称:内容,旧值:<p>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</p>,新值:<p><font color=\"#f9963b\">请<b>已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b></font><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\">泉州市高层次人才“一站式”服务系统</a><font color=\"#f9963b\"><b>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p><p><strike>​</strike><span style=\"color: inherit;\">​</span><br></p>'),(2242,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-01 01:08:15','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#f9963b\">请<b>已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b></font><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\">泉州市高层次人才“一站式”服务系统</a><font color=\"#f9963b\"><b>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p><p><strike>​</strike><span style=\"color: inherit;\">​</span><br></p>,新值:<p><font color=\"#f9963b\">请<b>已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b></font><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\">泉州市高层次人才“一站式”服务系统</a><font color=\"#f9963b\"><b>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p>'),(2243,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-01 01:09:57','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#f9963b\">请<b>已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b></font><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\">泉州市高层次人才“一站式”服务系统</a><font color=\"#f9963b\"><b>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p>,新值:<p><font color=\"#c24f4a\" style=\"background-color: rgb(70, 172, 200);\">请<b style=\"\">已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\">泉州市高层次人才“一站式”服务系统</a><b style=\"\">，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p><p><br></p>'),(2244,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-01 01:12:22','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#c24f4a\" style=\"background-color: rgb(70, 172, 200);\">请<b style=\"\">已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\">泉州市高层次人才“一站式”服务系统</a><b style=\"\">，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p><p><br></p>,新值:<p><font color=\"#c24f4a\"><b>请<u>已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象</u>注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\"><u>泉州市高层次人才“一站式”服务系统</u></a><b style=\"\">，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p>'),(2245,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2020-07-02 08:52:52','成功','账号=rs05'),(2246,'异常日志','',58,NULL,NULL,'2020-07-02 08:55:25','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2247,'异常日志','',58,NULL,NULL,'2020-07-02 08:55:30','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1197.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2248,'异常日志','',58,NULL,NULL,'2020-07-02 08:55:39','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor159.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1197.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT1ca1c213.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2249,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-07-02 08:58:06','成功','账号=rs04;;;字段名称:null,旧值:28a4c487172d93659efcf8ae62040fe8,新值:;;;字段名称:名字,旧值:丁煌权,新值:蔡彬彬;;;字段名称:生日,旧值:1994-09-30,新值:2019-06-02;;;字段名称:电话,旧值:13959757007,新值:13489302500'),(2250,'业务日志','分配角色',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-07-02 08:59:39','成功','账号=rs02,角色名称集合=集成电路-超级管理员'),(2251,'业务日志','分配角色',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-07-02 09:00:36','成功','账号=rs02,角色名称集合=超级管理员'),(2252,'业务日志','重置管理员密码',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2020-07-02 09:25:34','成功','账号=rs04'),(2253,'业务日志','修改管理员',90,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-07-02 09:31:05','成功','账号=rs04;;;字段名称:null,旧值:e183c82948bef0d85ce4269905b431a3,新值:;;;字段名称:生日,旧值:2019-06-01,新值:2020-07-02'),(2254,'业务日志','修改管理员',90,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-07-02 09:31:07','成功','账号=rs04;;;字段名称:null,旧值:e183c82948bef0d85ce4269905b431a3,新值:;;;字段名称:生日,旧值:2019-06-01,新值:2020-07-02'),(2255,'业务日志','修改管理员',90,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-07-02 09:31:07','成功','账号=rs04;;;字段名称:null,旧值:e183c82948bef0d85ce4269905b431a3,新值:;;;字段名称:生日,旧值:2019-06-01,新值:2020-07-02'),(2256,'业务日志','修改管理员',90,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-07-02 09:31:08','成功','账号=rs04;;;字段名称:null,旧值:e183c82948bef0d85ce4269905b431a3,新值:;;;字段名称:生日,旧值:2019-06-01,新值:2020-07-02'),(2257,'业务日志','修改管理员',90,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-07-02 09:31:47','成功','账号=rs04;;;字段名称:null,旧值:e183c82948bef0d85ce4269905b431a3,新值:;;;字段名称:性别,旧值:男,新值:女;;;字段名称:null,旧值:1197443773921181697,新值:'),(2258,'业务日志','修改管理员',90,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-07-02 09:31:51','成功','账号=rs04;;;字段名称:null,旧值:e183c82948bef0d85ce4269905b431a3,新值:;;;字段名称:性别,旧值:男,新值:女;;;字段名称:null,旧值:1197443773921181697,新值:'),(2259,'业务日志','修改通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-07 00:43:59','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#c24f4a\"><b>请<u>已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象</u>注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\"><u>泉州市高层次人才“一站式”服务系统</u></a><b style=\"\">，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p>,新值:<p><font color=\"#f9963b\" style=\"background-color: rgb(238, 236, 224);\"><b style=\"\">请<u style=\"\">已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象</u>注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\"><u>泉州市高层次人才“一站式”服务系统</u></a><b style=\"\">，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p><p><br></p>'),(2260,'业务日志','修改通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-07 00:45:03','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#f9963b\" style=\"background-color: rgb(238, 236, 224);\"><b style=\"\">请<u style=\"\">已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象</u>注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录</b><a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\"><u>泉州市高层次人才“一站式”服务系统</u></a><b style=\"\">，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></font></p><p><br></p>,新值:<p><font style=\"background-color: rgb(238, 236, 224);\" color=\"#000000\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font></p><p><br></p>'),(2261,'业务日志','修改通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-07 00:46:00','成功','标题=注意;;;字段名称:内容,旧值:<p><font style=\"background-color: rgb(238, 236, 224);\" color=\"#000000\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font></p><p><br></p>,新值:<h3><span style=\"font-weight: normal;\"><font style=\"background-color: rgb(238, 236, 224);\" color=\"#f9963b\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</span></h3>'),(2262,'业务日志','修改通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-07 00:46:36','成功','标题=注意;;;字段名称:内容,旧值:<h3><span style=\"font-weight: normal;\"><font style=\"background-color: rgb(238, 236, 224);\" color=\"#f9963b\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</span></h3>,新值:<h3><font color=\"#8baa4a\"><font style=\"background-color: rgb(238, 236, 224);\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></h3><p><br></p>'),(2263,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:41:03','成功','标题=注意;;;字段名称:内容,旧值:<h3><font color=\"#8baa4a\"><font style=\"background-color: rgb(238, 236, 224);\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></h3><p><br></p>,新值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p><p><br></p>'),(2264,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:41:09','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p><p><br></p>,新值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p>'),(2265,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:41:35','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p>,新值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p><p><br></p>'),(2266,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:41:41','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p><p><br></p>,新值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p>'),(2267,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:42:12','成功','标题=注意;;;字段名称:内容,旧值:<p><font color=\"#8baa4a\" style=\"background-color: rgb(255, 255, 255);\"><font style=\"\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录<a href=\"http://www.qzrc.gov.cn/\" target=\"_blank\" style=\"\">泉州市高层次人才“一站式”服务系统</a>，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</font>​​</font></p>,新值:<p>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</p><p><br></p>'),(2268,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:42:17','成功','标题=注意;;;字段名称:内容,旧值:<p>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</p><p><br></p>,新值:<p>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</p>'),(2269,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:42:29','成功','标题=注意;;;字段名称:内容,旧值:<p>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</p>,新值:<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p><p><br></p>'),(2270,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:42:34','成功','标题=注意;;;字段名称:内容,旧值:<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p><p><br></p>,新值:<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p>'),(2271,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:44:32','成功','标题=注意;;;字段名称:内容,旧值:<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p>,新值:<p><span style=\"color: inherit;\"></span><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p><p><br></p>'),(2272,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:45:08','成功','标题=注意;;;字段名称:内容,旧值:<p><span style=\"color: inherit;\"></span><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p><p><br></p>,新值:<blockquote><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></blockquote>'),(2273,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:45:44','成功','标题=注意;;;字段名称:内容,旧值:<blockquote><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></blockquote>,新值:<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p>'),(2274,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:46:43','成功','标题=注意;;;字段名称:内容,旧值:<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b></p>,新值:<pre><code>&lt;i class=\"layui-icon layui-icon-fire\"&gt;&lt;/i&gt;</code></pre><p><b style=\"color: inherit;\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b><br></p><p><br></p>'),(2275,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:47:01','成功','标题=注意;;;字段名称:内容,旧值:<pre><code>&lt;i class=\"layui-icon layui-icon-fire\"&gt;&lt;/i&gt;</code></pre><p><b style=\"color: inherit;\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b><br></p><p><br></p>,新值:<pre><code><b style=\"background-color: rgb(255, 255, 255); color: inherit; font-family: &quot;open sans&quot;, &quot;Helvetica Neue&quot;, Helvetica, Arial, sans-serif;\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b><i class=\"layui-icon layui-icon-fire\"></i></code></pre><p><br></p>'),(2276,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-08 09:47:35','成功','标题=注意;;;字段名称:内容,旧值:<pre><code><b style=\"background-color: rgb(255, 255, 255); color: inherit; font-family: &quot;open sans&quot;, &quot;Helvetica Neue&quot;, Helvetica, Arial, sans-serif;\">请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。</b><i class=\"layui-icon layui-icon-fire\"></i></code></pre><p><br></p>,新值:<p><b>请已公布入选为泉州市高层次人才但尚未取得泉州市高层次人才证的对象注意了！！因泉州市高层次人才证制作需一段时间，可能会导致部分对象在提交晋江市优秀人才认定无法填写证书有效期问题，请大家不用担心，可先上传公布入选文件（登录泉州市高层次人才“一站式”服务系统，进入到个人信息页面底部下载），证书发证日期为文件落款时间，证书有效期为往后推三年再减一天。​</b></p>'),(2277,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-09 01:24:32','成功','标题=注意;;;'),(2278,'业务日志','添加管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-07-10 01:30:02','成功','账号=jyj02'),(2279,'业务日志','添加管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-07-10 01:31:09','成功','账号=jyj03'),(2280,'业务日志','添加角色',1,'com.stylefeng.guns.modular.system.controller.RoleController','add','2020-07-10 01:31:38','成功','角色名称=子女就学'),(2281,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-10 01:32:53','成功','角色名称=子女就学,资源名称=系统管理,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理详情,批次管理设置生效,短信日志,发送短信,导出,附件类别管理,人才认定申报,添加,修改,个人用户信息,查看详情,设置冻结,重置密码,子女就学,子女择校,审核,导出'),(2282,'业务日志','分配角色',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-07-10 01:33:07','成功','账号=jyj02,角色名称集合=子女就学'),(2283,'业务日志','分配角色',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-07-10 01:33:11','成功','账号=jyj03,角色名称集合=子女就学'),(2284,'业务日志','新增批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','add','2020-07-10 03:02:01','成功','申报类型=6,申报批次=2020,开始时间=2020-07-11 00:00:00,截止时间=2020-07-17 00:00:00,提交截止时间='),(2285,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-07-10 03:02:10','成功','申报类型=6,申报批次=2019,开始时间=2019-10-28 00:00:00,截止时间=2019-12-31 00:00:00,提交截止时间=;;;字段名称:申报类型,旧值:1,新值:6'),(2286,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-07-10 03:02:34','成功','申报类型=1,申报批次=2019,开始时间=2019-10-28 00:00:00,截止时间=2019-12-31 00:00:00,提交截止时间=;;;字段名称:申报类型,旧值:6,新值:1'),(2287,'业务日志','设置批次生效',1,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-07-10 03:02:47','成功','批次id=1281423401541447681'),(2288,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-07-10 03:03:29','成功','申报类型=6,申报批次=2020,开始时间=2020-07-13 00:00:00,截止时间=2020-07-20 00:00:00,提交截止时间=;;;字段名称:开始时间,旧值:2020-07-11 00:00:00,新值:2020-07-13 00:00:00;;;字段名称:截止时间,旧值:2020-07-17 00:00:00,新值:2020-07-20 00:00:00'),(2289,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-10 03:23:21','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2290,'业务日志','新增通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-10 09:36:35','成功','标题=通知'),(2291,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-13 01:12:52','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2292,'业务日志','分配角色',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-07-13 02:06:59','成功','账号=rs02,角色名称集合=晋江市优秀人才-超级管理员'),(2293,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-13 03:43:47','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,修改驳回字段,批量提交审核(社保局),导出社保核查结果,子女就学,子女择校,审核,导出'),(2294,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-13 07:33:50','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,修改驳回字段,批量提交审核(社保局),导出社保核查结果,子女就学,子女择校,审核,导出'),(2295,'业务日志','重置管理员密码',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2020-07-13 09:42:31','成功','账号=jyj1'),(2296,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-07-14 01:42:11','成功','菜单名称=附件管理'),(2297,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-14 01:42:21','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2298,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-14 01:43:35','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,修改驳回字段,批量提交审核(社保局),导出社保核查结果,子女就学,子女择校,审核,导出'),(2299,'业务日志','新增通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-14 01:53:36','成功','标题=关于公布2019年度晋江市优秀人才入选名单的通知(晋人社〔2020〕65号）'),(2300,'业务日志','删除通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','delete','2020-07-14 02:23:54','成功','null=13'),(2301,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-14 02:24:57','成功','标题=关于公布2019年度晋江市优秀人才入选名单的通知(晋人社〔2020〕65号）	'),(2302,'业务日志','修改通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-14 02:25:34','成功','标题=关于公布2019年度晋江市优秀人才入选名单的通知(晋人社〔2020〕65号）	;;;字段名称:内容,旧值:<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202007/1282862422335545345.pdf\" target=\"_blank\">关于公布2019年度晋江市优秀人才入选名单的通知(晋人社〔2020〕65号）</a><br></p><p><br></p>,新值:<p><a href=\"http://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202007/1282862422335545345.pdf\" target=\"_blank\">关于公布2019年度晋江市优秀人才入选名单的通知(晋人社〔2020〕65号）</a></p>'),(2303,'业务日志','删除通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','delete','2020-07-14 07:36:02','成功','null=14'),(2304,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-14 07:36:58','成功','标题=关于公布2019年度晋江市优秀人才入选名单的通知（晋人社〔2020〕65号）'),(2305,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-07-15 02:37:31','成功','字典名称=年级,字典内容=1:学前教育(小班):1;2:学前教育(中班):2;3:学前教育(大班):3;4:一年级:4;5:二年级:5;6:三年级:6;7:四年级:7;8:五年级:8;9:六年级:9;10:七年级(初一):10;11:八年级(初二):11;12:九年级(初三):12;13:高一:13;14:高二:14;15:高三:15;16:无:0;;;;'),(2306,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-07-15 03:52:12','成功','菜单名称=公示预览(不予兑现)'),(2307,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-07-15 03:52:50','成功','菜单名称=公示预览(兑现)'),(2308,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-15 03:53:26','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2309,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-17 01:23:41','成功','标题=晋江市人力资源和社会保障局关于公布2020年度第一批晋江市优秀人才入选名单的通知（晋人社〔2020〕82号）'),(2310,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-07-23 05:24:28','成功','菜单名称=修改驳回字段'),(2311,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-23 05:24:38','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2312,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-23 05:25:05','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,修改驳回字段,批量提交审核(社保局),导出社保核查结果,子女就学,子女择校,审核,导出'),(2313,'业务日志','新增批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','add','2020-07-27 03:06:37','成功','申报类型=2,申报批次=2019,开始时间=,截止时间=,提交截止时间='),(2314,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-27 08:12:09','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出'),(2315,'业务日志','修改批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-07-29 00:39:54','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-12 18:00:00,提交截止时间=;;;字段名称:开始时间,旧值:,新值:2020-07-29 08:35:00;;;字段名称:截止时间,旧值:,新值:2020-08-12 18:00:00'),(2316,'业务日志','修改批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-07-29 00:42:25','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-12 18:00:00,提交截止时间=;;;'),(2317,'业务日志','设置批次生效',58,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-07-29 00:42:35','成功','批次id=1287585152280584193'),(2318,'业务日志','新增通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-29 02:24:50','成功','标题=关于开展晋江市2019年度优秀人才津补贴申报工作的通知'),(2319,'业务日志','删除通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','delete','2020-07-29 02:25:41','成功','null=17'),(2320,'业务日志','新增通知',58,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-29 02:26:25','成功','标题=关于开展晋江市2019年度优秀人才津补贴申报工作的通知'),(2321,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-29 10:01:23','成功','标题=关于开展晋江市2019年度优秀人才津补贴申报工作的通知;;;字段名称:内容,旧值:<p><!--[if gte mso 9]><xml><w:LatentStyles DefLockedState=\"false\"  DefUnhideWhenUsed=\"true\"  DefSemiHidden=\"true\"  DefQFormat=\"false\"  DefPriority=\"99\"  LatentStyleCount=\"260\" >\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footer\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"caption\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of figures\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope return\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"line number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"page number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of authorities\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"macro\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toa heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Title\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Closing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Default Paragraph Font\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Message Header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Subtitle\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Salutation\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Date\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Note Heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Block Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Hyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"FollowedHyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Strong\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Emphasis\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Document Map\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Plain Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"E-mail Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal (Web)\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Acronym\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Cite\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Code\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Definition\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Keyboard\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Preformatted\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Sample\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Typewriter\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Variable\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Table\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation subject\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / a / i\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / 1.1 / 1.1.1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Article / Section\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Contemporary\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Elegant\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Professional\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Balloon Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Theme\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Placeholder Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No Spacing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Paragraph\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Intense Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 6\" ></w:LsdException>\n</w:LatentStyles></xml><![endif]--></p><p class=\"MsoNormal\"><spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"font-size: small;\"><span style=\"font-family: 宋体;\">我市于</span><spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\"><span style=\"font-family: 宋体;\">2020</span><spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"font-family: 宋体;\">年<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">7月29<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">日至<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">8<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">月<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">12<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">日组织开展201<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">9<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">年度优秀人才津补贴申报工作，<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">此次申报采用线上、线下相结合的方式，<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">具体申报工作通知可关注“人才晋江”<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">、“晋江市人社局”<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">微信公众号下载。<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">请<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">各用人单位<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">相互转告，务必对照通知内容的要求抓紧时间报送材料，<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">逾期未报送申报材料者将不予兑现相关政策待遇<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">APP<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">扫码登记，感谢<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\" style=\"\">配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></p>,新值:<p><![if gte mso 9]><xml><w:LatentStyles DefLockedState=\"false\"  DefUnhideWhenUsed=\"true\"  DefSemiHidden=\"true\"  DefQFormat=\"false\"  DefPriority=\"99\"  LatentStyleCount=\"260\" >\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footer\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"caption\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of figures\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope return\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"line number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"page number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of authorities\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"macro\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toa heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Title\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Closing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Default Paragraph Font\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Message Header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Subtitle\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Salutation\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Date\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Note Heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Block Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Hyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"FollowedHyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Strong\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Emphasis\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Document Map\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Plain Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"E-mail Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal (Web)\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Acronym\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Cite\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Code\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Definition\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Keyboard\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Preformatted\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Sample\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Typewriter\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Variable\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Table\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation subject\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / a / i\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / 1.1 / 1.1.1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Article / Section\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Contemporary\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Elegant\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Professional\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Balloon Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Theme\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Placeholder Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No Spacing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Paragraph\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Intense Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 6\" ></w:LsdException>\n</w:LatentStyles></xml><![endif]></p><p class=\"MsoNormal\"></p><p><!StartFragment><b>我市于<spanyes>&nbsp;​&nbsp;</b><br></p>'),(2322,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-29 10:01:53','成功','标题=关于开展晋江市2019年度优秀人才津补贴申报工作的通知;;;字段名称:内容,旧值:<p><!--[if gte mso 9]><xml><w:LatentStyles DefLockedState=\"false\"  DefUnhideWhenUsed=\"true\"  DefSemiHidden=\"true\"  DefQFormat=\"false\"  DefPriority=\"99\"  LatentStyleCount=\"260\" >\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footer\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"caption\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of figures\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope return\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"line number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"page number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of authorities\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"macro\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toa heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Title\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Closing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Default Paragraph Font\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Message Header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Subtitle\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Salutation\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Date\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Note Heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Block Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Hyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"FollowedHyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Strong\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Emphasis\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Document Map\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Plain Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"E-mail Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal (Web)\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Acronym\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Cite\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Code\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Definition\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Keyboard\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Preformatted\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Sample\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Typewriter\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Variable\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Table\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation subject\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / a / i\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / 1.1 / 1.1.1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Article / Section\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Contemporary\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Elegant\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Professional\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Balloon Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Theme\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Placeholder Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No Spacing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Paragraph\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Intense Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 6\" ></w:LsdException>\n</w:LatentStyles></xml><![endif]--></p><p class=\"MsoNormal\"></p><p><!--StartFragment--><b>我市于<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">2020<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">年<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">7月29<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">日至<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">8<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">月<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">12<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">日组织开展201<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">9<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">年度优秀人才津补贴申报工作，<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">此次申报采用线上、线下相结合的方式，<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">具体申报工作通知可关注“人才晋江”<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">、“晋江市人社局”<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">微信公众号下载。<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">请<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">各用人单位<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">相互转告，务必对照通知内容的要求抓紧时间报送材料，<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">逾期未报送申报材料者将不予兑现相关政策待遇<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">APP<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">扫码登记，感谢<spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt; mso-font-kerning:0.0000pt;\"=\"\">配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;></spanyes\';font-family:仿宋_gb2312;font-size:16.0000pt;><!--EndFragment-->&nbsp;​&nbsp;</b><br></p>,新值:<p><![if gte mso 9]><xml><w:LatentStyles DefLockedState=\"false\"  DefUnhideWhenUsed=\"true\"  DefSemiHidden=\"true\"  DefQFormat=\"false\"  DefPriority=\"99\"  LatentStyleCount=\"260\" >\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"heading 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toc 9\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footer\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"index heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"caption\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of figures\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"envelope return\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"footnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"line number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"page number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote reference\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"endnote text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"table of authorities\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"macro\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"toa heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Bullet 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Number 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Title\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Closing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Default Paragraph Font\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Continue 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Message Header\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Subtitle\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Salutation\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Date\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text First Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Note Heading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Body Text Indent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Block Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Hyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"FollowedHyperlink\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Strong\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Emphasis\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Document Map\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Plain Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"E-mail Signature\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal (Web)\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Acronym\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Address\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Cite\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Code\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Definition\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Keyboard\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Preformatted\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Sample\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Typewriter\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"HTML Variable\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Normal Table\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"annotation subject\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / a / i\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"1 / 1.1 / 1.1.1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Article / Section\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Simple 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Classic 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Colorful 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Columns 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 7\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table List 8\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table 3D effects 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Contemporary\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Elegant\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Professional\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Subtle 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Web 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Balloon Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Table Theme\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Placeholder Text\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"No Spacing\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"List Paragraph\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Intense Quote\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 1\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 2\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 3\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 4\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 5\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Light Grid Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Shading 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium List 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 1 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 2 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Medium Grid 3 Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Dark List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Shading Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful List Accent 6\" ></w:LsdException>\n<w:LsdException Locked=\"false\"  Priority=\"99\"  SemiHidden=\"false\"  Name=\"Colorful Grid Accent 6\" ></w:LsdException>\n</w:LatentStyles></xml><![endif]></p><p class=\"MsoNormal\"></p><p><!StartFragment><b>我市于<span style=\"color: inherit;\">2020</span><spanyes>'),(2323,'业务日志','删除通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','delete','2020-07-29 10:02:48','成功','null=18'),(2324,'业务日志','新增通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-07-29 10:04:54','成功','标题=优秀人才津补贴申报工作'),(2325,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-29 10:05:01','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:标题,旧值:优秀人才津补贴申报工作,新值:2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><span style=\"font-weight: bold;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></p>,新值:<p><span style=\"font-weight: bold;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></p><p><br></p>'),(2326,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-29 10:05:14','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><span style=\"font-weight: bold;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></p><p><br></p>,新值:<p><span style=\"font-weight: bold;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></p>');
INSERT INTO `sys_operation_log` VALUES (2327,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-30 02:04:52','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><span style=\"font-weight: bold;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></p>,新值:<p><span style=\"color: inherit;\"></span><span style=\"font-weight: bold;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></p><p><br></p>'),(2328,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-30 02:05:58','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><span style=\"color: inherit;\"></span><span style=\"font-weight: bold;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></p><p><br></p>,新值:<pre><code>&lt;i class=\"fa fa-edit\"&gt;&lt;/i&gt;<span style=\"color: inherit; font-weight: bold; background-color: rgb(255, 255, 255); font-family: &quot;open sans&quot;, &quot;Helvetica Neue&quot;, Helvetica, Arial, sans-serif;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></code></pre><p><br></p>'),(2329,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-30 02:06:30','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<pre><code>&lt;i class=\"fa fa-edit\"&gt;&lt;/i&gt;<span style=\"color: inherit; font-weight: bold; background-color: rgb(255, 255, 255); font-family: &quot;open sans&quot;, &quot;Helvetica Neue&quot;, Helvetica, Arial, sans-serif;\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span></code></pre><p><br></p>,新值:<p><!StartFragment><b><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!EndFragment>&nbsp;&nbsp;</b><br></p>'),(2330,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-30 02:07:19','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><!--StartFragment--><b><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!--EndFragment-->&nbsp;&nbsp;</b><br></p>,新值:<p><!StartFragment><font color=\"#c24f4a\"><b style=\"\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!EndFragment>&nbsp;&nbsp;</b><br></font></p><p><br></p>'),(2331,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-30 02:07:26','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><!--StartFragment--><font color=\"#c24f4a\"><b style=\"\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!--EndFragment-->&nbsp;&nbsp;</b><br></font></p><p><br></p>,新值:<p><!StartFragment><font color=\"#c24f4a\"><b style=\"\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!EndFragment>&nbsp;</b></font></p>'),(2332,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-30 02:09:21','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><!--StartFragment--><font color=\"#c24f4a\"><b style=\"\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!--EndFragment-->&nbsp;</b></font></p>,新值:<p><!StartFragment><span style=\"color: inherit;\">?</span><font color=\"#c24f4a\"><b style=\"\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!EndFragment>&nbsp;</b></font></p><p><br></p>'),(2333,'业务日志','修改通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2020-07-30 02:09:35','成功','标题=2019优秀人才津补贴申报工作;;;字段名称:内容,旧值:<p><!--StartFragment--><span style=\"color: inherit;\">?</span><font color=\"#c24f4a\"><b style=\"\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!--EndFragment-->&nbsp;</b></font></p><p><br></p>,新值:<p><!StartFragment><span style=\"color: inherit;\">?</span><b style=\"\"><font color=\"#8baa4a\"><i></i><span open=\"\" sans\",=\"\" \"helvetica=\"\" neue\",=\"\" helvetica,=\"\" arial,=\"\" sans-serif;\"=\"\" style=\"\">我市于2020年7月29日至8月12日组织开展2019年度优秀人才津补贴申报工作，此次申报采用线上、线下相结合的方式，具体申报工作通知可关注“人才晋江”、“晋江市人社局”微信公众号下载。请各用人单位相互转告，务必对照通知内容的要求抓紧时间报送材料，逾期未报送申报材料者将不予兑现相关政策待遇。另外，根据市防控办要求，现场办理业务者请出示“闽政通”手机APP扫码登记，感谢配合！联系地址：晋江市青阳崇德路196号农商银行三楼人才服务科，联系电话：0595-85633128 ，0595-85662310。</span><!EndFragment>&nbsp;</font></b></p>'),(2334,'业务日志','添加管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-07-31 02:54:48','成功','账号=sw01'),(2335,'业务日志','添加管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-07-31 02:55:46','成功','账号=sb01'),(2336,'业务日志','添加角色',1,'com.stylefeng.guns.modular.system.controller.RoleController','add','2020-07-31 02:56:54','成功','角色名称=津补贴初审'),(2337,'业务日志','修改角色',1,'com.stylefeng.guns.modular.system.controller.RoleController','edit','2020-07-31 02:57:27','成功','角色名称=津补贴初审-税务;;;字段名称:角色名称,旧值:津补贴初审,新值:津补贴初审-税务;;;字段名称:备注,旧值:津补贴初审,新值:津补贴初审-税务'),(2338,'业务日志','添加角色',1,'com.stylefeng.guns.modular.system.controller.RoleController','add','2020-07-31 02:57:39','成功','角色名称=津补贴初审-社保'),(2339,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-31 02:58:18','成功','角色名称=津补贴初审-税务,资源名称=津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,导出项目核查结果,查看'),(2340,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-07-31 02:58:31','成功','角色名称=津补贴初审-社保,资源名称=津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看'),(2341,'业务日志','分配角色',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-07-31 02:58:40','成功','账号=sw01,角色名称集合=津补贴初审-税务'),(2342,'业务日志','分配角色',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-07-31 02:58:44','成功','账号=sb01,角色名称集合=津补贴初审-社保'),(2343,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-08-04 02:01:55','成功','账号=rs02;;;字段名称:头像,旧值:jjrcw/headPortrait/202006/1277052250648264705.jpg,新值:;;;字段名称:null,旧值:cebc37bd7b79efabf89b2be0b9102ba1,新值:;;;字段名称:生日,旧值:2000-09-30,新值:2020-08-04;;;字段名称:null,旧值:1197443773921181697,新值:1196347541488906242'),(2344,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-08-04 02:02:14','成功','账号=rs03;;;字段名称:头像,旧值:jjrcw/headPortrait/202001/1216641580266430466.jpg,新值:;;;字段名称:null,旧值:d9797e1af7899634f533b47b36190705,新值:;;;字段名称:生日,旧值:1994-10-22,新值:1994-10-23;;;字段名称:null,旧值:1197443773921181697,新值:1196347541488906242'),(2345,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2020-08-05 02:58:10','成功','字典名称=申报项目,字典内容=1:人才认定:1;2:津补贴申报:2;3:离职申报:3;4:工作单位变更:4;5:购房补贴:5;6:子女就学:6;7:银行账号变更:7;8:人才层次变更:8;11:培训补贴:11;12:重大专项经费:12;13:学杂费补助:13;14:医疗补助:14;15:租房申请:15;16:房租补助:16;17:购房申请:17;18:购房补助:18;9:人才基础信息变更:9;;;;'),(2346,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-08-05 10:04:25','成功','菜单名称=基础信息变更'),(2347,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-08-05 10:04:58','成功','菜单名称=审核'),(2348,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-08-05 10:05:25','成功','菜单名称=导出'),(2349,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-08-05 10:14:38','成功','账号=rs02;;;字段名称:头像,旧值:jjrcw/headPortrait/202006/1277052250648264705.jpg,新值:;;;字段名称:null,旧值:cebc37bd7b79efabf89b2be0b9102ba1,新值:;;;字段名称:生日,旧值:2020-08-03,新值:1994-10-23;;;字段名称:null,旧值:1196347541488906242,新值:1197443773921181697'),(2350,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-08-05 10:15:02','成功','账号=rs03;;;字段名称:头像,旧值:jjrcw/headPortrait/202001/1216641580266430466.jpg,新值:;;;字段名称:null,旧值:d9797e1af7899634f533b47b36190705,新值:;;;字段名称:生日,旧值:1994-10-22,新值:2020-08-05;;;字段名称:null,旧值:1196347541488906242,新值:1197443773921181697'),(2351,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-08-05 10:15:17','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2352,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-08-05 10:15:32','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出'),(2353,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-08-12 10:21:32','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-12 23:59:59,提交截止时间=;;;字段名称:截止时间,旧值:2020-08-12 18:00:00,新值:2020-08-12 23:59:59'),(2354,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-08-12 12:18:36','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-12 18:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2020-08-12 23:59:59,新值:2020-08-12 18:00:00'),(2355,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-08-20 01:00:02','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-20 18:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2020-08-12 18:00:00,新值:2020-08-20 18:00:00'),(2356,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-08-20 01:04:52','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-12 18:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2020-08-20 18:00:00,新值:2020-08-12 18:00:00'),(2357,'业务日志','修改批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-08-28 01:58:52','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-28 18:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2020-08-12 18:00:00,新值:2020-08-28 18:00:00'),(2358,'业务日志','修改批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-08-28 08:55:42','成功','申报类型=2,申报批次=2019,开始时间=2020-07-29 08:35:00,截止时间=2020-08-28 16:50:00,提交截止时间=;;;字段名称:截止时间,旧值:2020-08-28 18:00:00,新值:2020-08-28 16:50:00'),(2359,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-09-03 00:51:08','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2360,'业务日志','新增批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','add','2020-09-07 09:38:16','成功','申报类型=5,申报批次=2019,开始时间=,截止时间=,提交截止时间='),(2361,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-09-07 11:03:54','成功','标题=晋江市人力资源和社会保障局关于公布2020年度第二批晋江市优秀人才入选名单的通知（晋人社〔2020〕101号 ）'),(2362,'业务日志','修改批次',58,'com.stylefeng.guns.modular.system.controller.BatchController','update','2020-09-08 10:12:34','成功','申报类型=5,申报批次=2019,开始时间=2020-09-09 08:00:00,截止时间=2020-09-17 18:00:00,提交截止时间=;;;字段名称:开始时间,旧值:,新值:2020-09-09 08:00:00;;;字段名称:截止时间,旧值:,新值:2020-09-17 18:00:00'),(2363,'业务日志','设置批次生效',1,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2020-09-09 00:43:37','成功','批次id=1302904003998281730'),(2364,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-09-09 07:29:18','成功','账号=rs05'),(2365,'异常日志','',58,NULL,NULL,'2020-09-09 07:30:04','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor89.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTc3012091.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2366,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-09-09 07:30:24','成功','账号=rs05,角色名称集合=晋江市优秀人才-超级管理员'),(2367,'异常日志','',58,NULL,NULL,'2020-09-22 03:29:31','失败','java.lang.StringIndexOutOfBoundsException: String index out of range: 17\n	at java.lang.String.substring(String.java:1963)\n	at com.stylefeng.guns.core.util.IdcardValidator.getGenderByIdCard(IdcardValidator.java:543)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportSbExcel(TalentAllowanceInfoExportController.java:283)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportProjectTemplate(TalentAllowanceInfoExportController.java:203)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTFastClassBySpringCGLIBTT30103d67.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor119.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTEnhancerBySpringCGLIBTTaa4900ef.exportProjectTemplate(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2368,'业务日志','重置管理员密码',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2020-09-27 01:16:26','成功','账号=rs05'),(2369,'异常日志','',1,NULL,NULL,'2020-09-28 00:50:22','失败','java.lang.StringIndexOutOfBoundsException: String index out of range: 17\n	at java.lang.String.substring(String.java:1963)\n	at com.stylefeng.guns.core.util.IdcardValidator.getGenderByIdCard(IdcardValidator.java:543)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportSbExcel(TalentAllowanceInfoExportController.java:283)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportProjectTemplate(TalentAllowanceInfoExportController.java:203)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTFastClassBySpringCGLIBTT30103d67.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor119.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTEnhancerBySpringCGLIBTTaa4900ef.exportProjectTemplate(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2370,'异常日志','',1,NULL,NULL,'2020-09-28 00:51:15','失败','java.lang.StringIndexOutOfBoundsException: String index out of range: 17\n	at java.lang.String.substring(String.java:1963)\n	at com.stylefeng.guns.core.util.IdcardValidator.getGenderByIdCard(IdcardValidator.java:543)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportSbExcel(TalentAllowanceInfoExportController.java:283)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportProjectTemplate(TalentAllowanceInfoExportController.java:203)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTFastClassBySpringCGLIBTT30103d67.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor119.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTEnhancerBySpringCGLIBTTaa4900ef.exportProjectTemplate(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2371,'异常日志','',1,NULL,NULL,'2020-09-28 00:53:49','失败','java.lang.StringIndexOutOfBoundsException: String index out of range: 17\n	at java.lang.String.substring(String.java:1963)\n	at com.stylefeng.guns.core.util.IdcardValidator.getGenderByIdCard(IdcardValidator.java:543)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportSbExcel(TalentAllowanceInfoExportController.java:283)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportProjectTemplate(TalentAllowanceInfoExportController.java:203)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTFastClassBySpringCGLIBTT30103d67.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor119.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTEnhancerBySpringCGLIBTTaa4900ef.exportProjectTemplate(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2372,'异常日志','',1,NULL,NULL,'2020-09-28 01:01:42','失败','java.lang.StringIndexOutOfBoundsException: String index out of range: 17\n	at java.lang.String.substring(String.java:1963)\n	at com.stylefeng.guns.core.util.IdcardValidator.getGenderByIdCard(IdcardValidator.java:543)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportSbExcel(TalentAllowanceInfoExportController.java:283)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportProjectTemplate(TalentAllowanceInfoExportController.java:203)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTFastClassBySpringCGLIBTT30103d67.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor119.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTEnhancerBySpringCGLIBTTaa4900ef.exportProjectTemplate(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2373,'业务日志','新增通知',1,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-09-28 08:22:20','成功','标题=关于密码强化的通知'),(2374,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-09-28 09:34:07','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2375,'异常日志','',1,NULL,NULL,'2020-09-29 03:09:31','失败','java.lang.StringIndexOutOfBoundsException: String index out of range: 17\n	at java.lang.String.substring(String.java:1963)\n	at com.stylefeng.guns.core.util.IdcardValidator.getGenderByIdCard(IdcardValidator.java:543)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportZfhcExcel(TalentAllowanceInfoExportController.java:431)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportProjectTemplate(TalentAllowanceInfoExportController.java:224)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTFastClassBySpringCGLIBTT30103d67.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor158.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTEnhancerBySpringCGLIBTTaa4900ef.exportProjectTemplate(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2376,'异常日志','',1,NULL,NULL,'2020-09-29 03:50:49','失败','java.lang.StringIndexOutOfBoundsException: String index out of range: 17\n	at java.lang.String.substring(String.java:1963)\n	at com.stylefeng.guns.core.util.IdcardValidator.getGenderByIdCard(IdcardValidator.java:543)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportZfhcExcel(TalentAllowanceInfoExportController.java:431)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportController.exportProjectTemplate(TalentAllowanceInfoExportController.java:224)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTFastClassBySpringCGLIBTT30103d67.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor158.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.talentAllowance.controller.TalentAllowanceInfoExportControllerTTEnhancerBySpringCGLIBTTaa4900ef.exportProjectTemplate(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doGet(FrameworkServlet.java:866)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:634)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2377,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-09-30 02:49:37','成功','菜单名称=查看首次申报信息'),(2378,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-09-30 02:49:50','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2379,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-09-30 02:50:00','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2380,'业务日志','重置管理员密码',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2020-11-03 01:57:25','成功','账号=gdj1'),(2381,'业务日志','添加角色',1,'com.stylefeng.guns.modular.system.controller.RoleController','add','2020-11-03 02:31:24','成功','角色名称=走访核查小组'),(2382,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-11-03 02:32:57','成功','角色名称=走访核查小组,资源名称=津补贴管理,走访核查,导入项目核查结果,导出项目核查结果,查看'),(2383,'异常日志','',87,NULL,NULL,'2020-11-03 02:34:16','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2384,'异常日志','',87,NULL,NULL,'2020-11-03 02:34:27','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2385,'异常日志','',87,NULL,NULL,'2020-11-03 02:34:32','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2386,'异常日志','',87,NULL,NULL,'2020-11-03 02:34:33','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2387,'异常日志','',87,NULL,NULL,'2020-11-03 02:34:49','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2388,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-11-03 02:41:12','成功','账号=hcxz1'),(2389,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-11-03 02:43:12','成功','账号=hcxz1,角色名称集合=走访核查小组'),(2390,'异常日志','',87,NULL,NULL,'2020-11-03 02:46:53','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2391,'异常日志','',87,NULL,NULL,'2020-11-03 02:46:58','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2392,'异常日志','',87,NULL,NULL,'2020-11-03 02:46:59','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2393,'异常日志','',87,NULL,NULL,'2020-11-03 02:47:00','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2394,'业务日志','删除管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2020-11-03 02:47:06','成功','账号=hcxz1'),(2395,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-11-03 02:47:34','成功','账号=hcxz1'),(2396,'异常日志','',87,NULL,NULL,'2020-11-03 02:47:59','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1900.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2397,'异常日志','',87,NULL,NULL,'2020-11-03 02:48:01','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1900.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2398,'异常日志','',87,NULL,NULL,'2020-11-03 02:48:01','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1900.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2399,'异常日志','',87,NULL,NULL,'2020-11-03 02:48:01','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1900.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2400,'异常日志','',87,NULL,NULL,'2020-11-03 02:48:01','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1900.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2401,'异常日志','',87,NULL,NULL,'2020-11-03 02:48:02','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1900.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2402,'异常日志','',87,NULL,NULL,'2020-11-03 02:48:02','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor121.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1900.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTa4e6a591.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2403,'业务日志','删除管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2020-11-03 02:48:08','成功','账号=hcxz1'),(2404,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-11-03 02:48:48','成功','账号=hcxz2'),(2405,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-11-03 02:49:01','成功','账号=hcxz2,角色名称集合=走访核查小组'),(2406,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2020-11-05 01:10:12','成功','账号=hcxz1'),(2407,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2020-11-05 01:10:21','成功','账号=hcxz1,角色名称集合=走访核查小组'),(2408,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2020-11-11 07:32:50','成功','菜单名称=修改驳回字段'),(2409,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-11-11 07:33:02','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2410,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2020-11-11 07:33:36','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2411,'业务日志','修改管理员',78,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2020-11-12 08:41:52','成功','账号=tyj1;;;字段名称:null,旧值:875c255dc30058567184b5f1f936d1b3,新值:;;;字段名称:名字,旧值:李真珠,新值:陈一帆;;;字段名称:生日,旧值:1995-06-12,新值:1988-10-01'),(2412,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-11-18 01:10:19','成功','标题=晋江市人力资源和社会保障局关于公布2020年度第三批晋江市优秀人才入选名单的通知（晋人社〔2020〕134号）	'),(2413,'异常日志','',87,NULL,NULL,'2020-12-09 01:34:02','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor94.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTef2ccbef.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2414,'异常日志','',87,NULL,NULL,'2020-12-09 01:34:08','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor94.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTef2ccbef.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2415,'业务日志','重置管理员密码',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2020-12-09 01:38:28','成功','账号=tyj1'),(2416,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-12-22 02:02:22','成功','标题=晋江市人力资源和社会保障局关于公布2020年度第四批晋江市优秀人才入选名单的通知（晋人社〔2020〕151号）'),(2417,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2020-12-31 03:27:42','成功','标题=晋江市人力资源和社会保障局关于公布2020年度第五批晋江市优秀人才入选名单的通知（晋人社〔2020〕157号 ）'),(2418,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-01-04 06:51:24','成功','申报类型=1,申报批次=2021,开始时间=2021-01-04 14:50:28,截止时间=2021-12-31 17:30:00,提交截止时间='),(2419,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-01-05 01:51:09','成功','批次id=1345986168558190593'),(2420,'业务日志','删除通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','delete','2021-01-07 07:38:35','成功','null=24'),(2421,'业务日志','重置管理员密码',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2021-01-08 09:34:44','成功','账号=rs05'),(2422,'业务日志','分配角色',97,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-01-08 09:36:10','成功','账号=rs05,角色名称集合=晋江市优秀人才-超级管理员,晋江市优秀人才-初审'),(2423,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-01-08 09:37:00','成功','账号=rs05,角色名称集合=晋江市优秀人才-初审'),(2424,'异常日志','',58,NULL,NULL,'2021-01-15 00:22:00','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor131.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT251a6962.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2425,'异常日志','',58,NULL,NULL,'2021-01-15 00:22:17','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor131.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT251a6962.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2426,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-01-15 00:22:26','成功','账号=rs06'),(2427,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-01-15 00:23:12','成功','账号=rs06,角色名称集合=晋江市优秀人才-超级管理员'),(2428,'异常日志','',58,NULL,NULL,'2021-01-15 00:23:30','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.setRole(UserMgrController.java:350)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor131.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT251a6962.setRole(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:449)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2429,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-01-15 00:24:51','成功','账号=rs06,角色名称集合=晋江市优秀人才-复核'),(2430,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-01-15 07:41:59','成功','账号=rs06,角色名称集合=晋江市优秀人才-超级管理员'),(2431,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-01-18 01:48:35','成功','申报类型=1,申报批次=2020,开始时间=2020-06-19 10:03:57,截止时间=2020-12-31 17:30:00,提交截止时间=2021-02-11 00:00:00;;;字段名称:提交截止时间,旧值:,新值:2021-02-11 00:00:00'),(2432,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-01-18 09:59:10','成功','标题=晋江市人力资源和社会保障局关于公布2020年度第五批晋江市优秀人才入选名单的通知（晋人社〔2020〕157号）	'),(2433,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-02-01 09:47:56','成功','申报类型=3,申报批次=2021,开始时间=2021-01-01 00:00:00,截止时间=2021-12-31 00:00:00,提交截止时间='),(2434,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-02-01 09:47:59','成功','批次id=1356177451780145154'),(2435,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-02-02 02:28:37','成功','申报类型=4,申报批次=2021,开始时间=2021-01-01 00:00:00,截止时间=2021-12-31 00:00:00,提交截止时间='),(2436,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-02-02 02:28:41','成功','批次id=1356429281521041410'),(2437,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-02-02 02:29:41','成功','申报类型=8,申报批次=2021,开始时间=2021-01-01 00:00:00,截止时间=2021-12-31 00:00:00,提交截止时间='),(2438,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-02-02 02:29:44','成功','批次id=1356429551260925953'),(2439,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-02-02 02:30:08','成功','申报类型=7,申报批次=2021,开始时间=2021-01-01 00:00:00,截止时间=2021-12-31 00:00:00,提交截止时间='),(2440,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-02-02 02:30:11','成功','批次id=1356429664683294721'),(2441,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-02-18 03:32:05','成功','标题=晋江市人力资源和社会保障局关于公布2020年度第六批晋江市优秀人才入选名单的通知（晋人社〔2021〕12号）'),(2442,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-02-18 07:03:44','成功','申报类型=1,申报批次=2020,开始时间=2020-06-19 10:03:57,截止时间=2020-12-31 17:30:00,提交截止时间=2021-12-31 00:00:00;;;字段名称:提交截止时间,旧值:2021-02-11 00:00:00,新值:2021-12-31 00:00:00'),(2443,'异常日志','',67,NULL,NULL,'2021-03-10 01:25:27','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor313.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf316b6cb.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2444,'业务日志','修改管理员',67,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-03-10 01:25:32','成功','账号=adminIC;;;字段名称:null,旧值:9f9c87e0bcd5ad08cda4054bcea85665,新值:;;;字段名称:生日,旧值:1994-10-22,新值:2021-03-04;;;字段名称:null,旧值:1196347541488906242,新值:1197345219366043649'),(2445,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-03-10 08:37:13','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）.pdf	'),(2446,'业务日志','修改通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2021-03-10 08:38:06','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）;;;字段名称:标题,旧值:晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）.pdf	,新值:晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）;;;字段名称:内容,旧值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202103/1369567832454504450.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）.pdf</a><br></p>,新值:<p><br></p><p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202103/1369567832454504450.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第一批晋江市优秀人才入选名单的通知（晋人社〔2021〕25号 ）</a><br></p>'),(2447,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-16 00:15:11','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=,提交截止时间='),(2448,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-03-16 00:15:54','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-05 17:30:00,提交截止时间=;;;字段名称:截止时间,旧值:,新值:2021-04-05 17:30:00'),(2449,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-16 00:16:21','成功','批次id=1371615991922012162'),(2450,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-03-16 00:17:15','成功','标题=关于开展晋江市2020年度优秀人才津补贴申报工作的通知'),(2451,'业务日志','修改管理员',78,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-03-16 09:11:09','成功','账号=tyj1;;;字段名称:null,旧值:6da78e3740ce2c66be69367b172babd7,新值:'),(2452,'业务日志','重置管理员密码',67,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2021-03-22 12:27:14','成功','账号=caicongying'),(2453,'业务日志','重置管理员密码',67,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2021-03-22 12:27:17','成功','账号=scy'),(2454,'业务日志','修改管理员',59,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-03-22 12:31:02','成功','账号=caicongying;;;字段名称:null,旧值:4ff810943e2e3f605c8bacdc682622bf,新值:;;;字段名称:null,旧值:1197345219366043649,新值:'),(2455,'业务日志','修改管理员',68,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-03-23 01:25:07','成功','账号=scy;;;字段名称:null,旧值:874de6c332fbd56b85a723df694b30ee,新值:;;;字段名称:电子邮件,旧值:1508798227@qq.com,新值:jjjcdr@163.com;;;字段名称:电话,旧值:17362523273,新值:15880738158;;;字段名称:null,旧值:1197345219366043649,新值:'),(2456,'业务日志','新增批次',59,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-23 10:22:20','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-04-23 00:00:00,提交截止时间=2021-04-23 00:00:00'),(2457,'业务日志','设置批次生效',59,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-23 10:23:33','成功','批次id=1374305502212763649'),(2458,'异常日志','',59,NULL,NULL,'2021-03-23 11:06:42','失败','com.stylefeng.guns.core.exception.GunsException: 两次输入密码不一致\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:151)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor136.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTac3a5a48.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2459,'业务日志','修改管理员',59,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-03-23 11:07:02','成功','账号=caicongying;;;字段名称:null,旧值:626e498cc687900a7a707bcbb0e86dde,新值:;;;字段名称:null,旧值:1197345219366043649,新值:'),(2460,'业务日志','新增批次',59,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-25 02:56:55','成功','申报类型=11,申报批次=1,开始时间=2021-03-25 10:55:28,截止时间=2021-03-26 00:00:00,提交截止时间=2021-03-31 00:00:00'),(2461,'业务日志','设置批次生效',59,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-25 02:57:10','成功','批次id=1374918185668685825'),(2462,'业务日志','删除批次',59,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-03-25 02:59:41','成功','批次id=1374918185668685825'),(2463,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-26 07:35:52','成功','申报类型=11,申报批次=2020,开始时间=2021-03-26 00:00:00,截止时间=2021-03-30 00:00:00,提交截止时间='),(2464,'业务日志','新增批次',59,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-26 07:38:45','成功','申报类型=11,申报批次=2020,开始时间=2021-03-26 00:00:00,截止时间=2021-03-31 00:00:00,提交截止时间='),(2465,'业务日志','设置批次生效',59,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-26 07:39:41','成功','批次id=1375351501014212609'),(2466,'业务日志','删除批次',59,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-03-26 07:44:36','成功','批次id=1375351501014212609'),(2467,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2021-03-26 07:47:06','成功','角色名称=集成电路-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,人才津贴配置,添加,修改,删除,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,复核,审核& #40;非集成电路& #41;,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2468,'业务日志','修改批次',59,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-03-26 09:28:45','成功','申报类型=1,申报批次=201701,开始时间=2021-03-23 00:00:00,截止时间=2021-04-23 00:00:00,提交截止时间=2021-04-23 00:00:00;;;字段名称:申报批次,旧值:1,新值:201701'),(2469,'业务日志','修改批次',59,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-03-26 09:36:14','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-04-23 00:00:00,提交截止时间=2021-04-23 00:00:00;;;字段名称:申报批次,旧值:201701,新值:1'),(2470,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-29 00:45:32','成功','申报类型=11,申报批次=2020,开始时间=2021-03-29 08:45:14,截止时间=2021-03-30 00:00:00,提交截止时间='),(2471,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-29 00:46:04','成功','批次id=1376334673403224066'),(2472,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-29 00:59:36','成功','申报类型=11,申报批次=2019,开始时间=2021-03-29 08:59:28,截止时间=2021-03-31 00:00:00,提交截止时间='),(2473,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-29 00:59:41','成功','批次id=1376338212926038017'),(2474,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-29 01:34:14','成功','申报类型=11,申报批次=2010,开始时间=2021-03-29 09:34:05,截止时间=2021-03-31 00:00:00,提交截止时间='),(2475,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-29 01:34:20','成功','批次id=1376346930468134913'),(2476,'业务日志','设置批次生效',59,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-29 12:04:04','成功','批次id=1376338212926038017'),(2477,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-30 02:08:10','成功','批次id=1376346930468134913'),(2478,'业务日志','删除批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-03-30 02:11:21','成功','批次id=1376338212926038017'),(2479,'业务日志','删除批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-03-30 02:11:26','成功','批次id=1376334673403224066'),(2480,'业务日志','删除批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-03-30 02:11:30','成功','批次id=1376346930468134913'),(2481,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-03-30 02:11:48','成功','申报类型=11,申报批次=2010,开始时间=2021-03-30 10:11:43,截止时间=2021-03-31 00:00:00,提交截止时间='),(2482,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-03-30 02:11:52','成功','批次id=1376718773389647874'),(2483,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-04-06 01:10:16','成功','申报类型=1,申报批次=2,开始时间=2021-04-06 09:09:45,截止时间=2021-04-06 09:10:00,提交截止时间=2021-05-06 00:00:00'),(2484,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-06 01:27:34','成功','申报类型=1,申报批次=2017,开始时间=2021-03-23 00:00:00,截止时间=2021-04-23 00:00:00,提交截止时间=2021-04-23 00:00:00;;;字段名称:申报批次,旧值:1,新值:2017'),(2485,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-06 01:28:12','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-04-23 00:00:00,提交截止时间=2021-04-23 00:00:00;;;字段名称:申报批次,旧值:2017,新值:1'),(2486,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-04-06 01:42:40','成功','批次id=1379240002373894146'),(2487,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-06 01:52:43','成功','申报类型=11,申报批次=2010,开始时间=2021-03-30 10:11:43,截止时间=2021-04-10 09:52:35,提交截止时间=;;;字段名称:截止时间,旧值:2021-03-31 00:00:00,新值:2021-04-10 09:52:35'),(2488,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-06 07:45:33','成功','申报类型=1,申报批次=2,开始时间=2021-04-06 09:09:45,截止时间=2021-04-06 09:10:00,提交截止时间=2021-05-06 00:00:00;;;'),(2489,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-04-06 07:47:22','成功','批次id=1374305502212763649'),(2490,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-04-06 08:00:26','成功','批次id=1379240002373894146'),(2491,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-04-06 08:05:55','成功','申报类型=11,申报批次=2011,开始时间=2021-04-06 16:05:39,截止时间=2021-04-30 00:00:00,提交截止时间=2021-04-30 00:00:00'),(2492,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-04-06 08:06:00','成功','批次id=1379344603005665282'),(2493,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-04-06 08:09:58','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知'),(2494,'业务日志','修改通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2021-04-06 08:10:29','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知（晋人社〔2021〕41号）;;;字段名称:标题,旧值:晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知,新值:晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知（晋人社〔2021〕41号）;;;字段名称:内容,旧值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202104/1379345403090124802.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知</a><br></p>,新值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202104/1379345403090124802.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第二批晋江市优秀人才入选名单的通知（晋人社〔2021〕41号）</a><br></p><p><br></p>'),(2495,'业务日志','删除批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-04-06 08:16:02','成功','批次id=1376718773389647874'),(2496,'业务日志','删除批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-04-06 08:16:05','成功','批次id=1379344603005665282'),(2497,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-04-06 08:32:17','成功','批次id=1374305502212763649'),(2498,'业务日志','删除批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','delete','2021-04-06 08:32:21','成功','批次id=1379240002373894146'),(2499,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 06:49:19','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-12 16:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-04-05 17:30:00,新值:2021-04-12 16:00:00'),(2500,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 06:49:29','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-12 16:00:00,提交截止时间=;;;'),(2501,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 06:49:49','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-12 16:00:00,提交截止时间=;;;'),(2502,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 06:49:54','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-12 16:00:00,提交截止时间=;;;'),(2503,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 06:50:01','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-12 16:00:00,提交截止时间=;;;'),(2504,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 07:55:33','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-12 17:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-04-12 16:00:00,新值:2021-04-12 17:00:00'),(2505,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 08:11:10','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-12 17:00:00,提交截止时间=2021-10-01 17:30:00;;;字段名称:提交截止时间,旧值:,新值:2021-10-01 17:30:00'),(2506,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-12 08:23:54','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-05 17:30:00,提交截止时间=2021-10-01 17:30:00;;;字段名称:截止时间,旧值:2021-04-12 17:00:00,新值:2021-04-05 17:30:00'),(2507,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-04-14 07:26:14','成功','申报类型=11,申报批次=2020,开始时间=2021-04-14 15:24:21,截止时间=2021-05-15 00:00:00,提交截止时间='),(2508,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-04-14 07:35:29','成功','批次id=1382233718340579330'),(2509,'异常日志','',68,NULL,NULL,'2021-04-15 08:22:39','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor380.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT85290056.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2510,'异常日志','',68,NULL,NULL,'2021-04-15 08:22:44','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor380.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT85290056.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2511,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-04-23 05:57:13','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-06-01 00:00:00,提交截止时间=2021-06-01 00:00:00;;;字段名称:截止时间,旧值:2021-04-23 00:00:00,新值:2021-06-01 00:00:00;;;字段名称:提交截止时间,旧值:2021-04-23 00:00:00,新值:2021-06-01 00:00:00;;;字段名称:null,旧值:2021-03-23 00:00:00,新值:2021-06-01 00:00:00;;;字段名称:null,旧值:2021-04-23 00:00:00,新值:2021-06-01 00:00:00'),(2512,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-04-26 00:49:14','成功','账号=rs07'),(2513,'业务日志','添加角色',1,'com.stylefeng.guns.modular.system.controller.RoleController','add','2021-04-26 00:57:44','成功','角色名称=晋江市优秀人才-津补贴初审'),(2514,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2021-04-26 00:58:26','成功','角色名称=晋江市优秀人才-津补贴初审,资源名称=津补贴管理,初级审核,审核,修改驳回字段,查看'),(2515,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-04-26 00:59:38','成功','账号=rs07,角色名称集合=晋江市优秀人才-津补贴初审'),(2516,'业务日志','冻结用户',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','freeze','2021-04-26 01:01:27','成功','账号=rs05'),(2517,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-04-27 07:11:59','成功','账号=rs08'),(2518,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-04-27 07:14:18','成功','账号=rs08,角色名称集合=优秀人才认定部门审核,晋江市优秀人才-初审,晋江市优秀人才-复核,走访核查小组,晋江市优秀人才-津补贴初审'),(2519,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-04-27 07:36:44','成功','账号=rs08,角色名称集合=晋江市优秀人才-超级管理员,走访核查小组,优秀人才认定部门审核,晋江市优秀人才-初审,晋江市优秀人才-复核,晋江市优秀人才-津补贴初审'),(2520,'异常日志','',58,NULL,NULL,'2021-04-28 01:01:16','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2521,'异常日志','',58,NULL,NULL,'2021-04-28 01:01:19','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2522,'异常日志','',58,NULL,NULL,'2021-04-28 01:02:29','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2523,'异常日志','',58,NULL,NULL,'2021-04-28 01:02:30','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2524,'异常日志','',58,NULL,NULL,'2021-04-28 01:02:45','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2525,'异常日志','',58,NULL,NULL,'2021-04-28 01:02:56','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2526,'异常日志','',58,NULL,NULL,'2021-04-28 01:03:08','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2527,'异常日志','',58,NULL,NULL,'2021-04-28 01:03:09','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2528,'异常日志','',58,NULL,NULL,'2021-04-28 01:03:40','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2529,'异常日志','',58,NULL,NULL,'2021-04-28 01:03:42','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2530,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:03','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2531,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:06','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2532,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:10','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2533,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:11','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2534,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:11','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2535,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:11','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2536,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:12','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2537,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:12','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2538,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:16','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2539,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:20','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2540,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:25','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2541,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:27','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2542,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:28','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2543,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:34','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2544,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:35','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2545,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:36','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2546,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:45','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2547,'异常日志','',58,NULL,NULL,'2021-04-28 01:04:46','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2548,'异常日志','',58,NULL,NULL,'2021-04-28 01:06:07','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2549,'异常日志','',1,NULL,NULL,'2021-04-28 01:07:38','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2550,'异常日志','',1,NULL,NULL,'2021-04-28 01:07:41','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2551,'异常日志','',1,NULL,NULL,'2021-04-28 01:07:41','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor157.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor2082.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT7c76e718.edit(<generated>)\n	at sun.reflect.GeneratedMethodAccessor2099.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2552,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-04-28 01:07:48','成功','账号=rs06;;;字段名称:null,旧值:08a63371469c78c702f8e33dd5705e92,新值:;;;字段名称:生日,旧值:2021-01-14,新值:2021-04-01;;;字段名称:电话,旧值:15059886866,新值:15280619456'),(2553,'业务日志','重置管理员密码',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2021-04-28 10:34:30','成功','账号=rs08'),(2554,'业务日志','删除管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2021-04-28 10:34:40','成功','账号=rs08'),(2555,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2021-04-29 06:38:35','成功','菜单名称=撤销初审'),(2556,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2021-04-29 06:38:48','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2557,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2021-04-29 07:07:59','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2558,'异常日志','',87,NULL,NULL,'2021-04-29 08:37:16','失败','com.baomidou.mybatisplus.exceptions.MybatisPlusException: Error: Cannot execute insertBatch Method. Cause\n	at com.baomidou.mybatisplus.service.impl.ServiceImpl.insertBatch(ServiceImpl.java:137)\n	at com.baomidou.mybatisplus.service.impl.ServiceImpl.insertBatch(ServiceImpl.java:110)\n	at com.baomidou.mybatisplus.service.impl.ServiceImplTTFastClassBySpringCGLIBTT3e2398a4.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at com.alibaba.druid.support.spring.stat.DruidStatInterceptor.invoke(DruidStatInterceptor.java:72)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.service.impl.MessageRecordServiceImplTTEnhancerBySpringCGLIBTTe0199f35.insertBatch(<generated>)\n	at com.stylefeng.guns.modular.system.controller.MessageRecordController.sendMessage(MessageRecordController.java:139)\n	at com.stylefeng.guns.modular.system.controller.MessageRecordControllerTTFastClassBySpringCGLIBTT3463c734.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor102.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.MessageRecordControllerTTEnhancerBySpringCGLIBTT486c8689.sendMessage(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.ibatis.exceptions.PersistenceException: \n### Error flushing statements.  Cause: org.apache.ibatis.executor.BatchExecutorException: com.stylefeng.guns.modular.system.dao.MessageRecordMapper.insert (batch index #1) failed. Cause: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n### Cause: org.apache.ibatis.executor.BatchExecutorException: com.stylefeng.guns.modular.system.dao.MessageRecordMapper.insert (batch index #1) failed. Cause: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n	at org.apache.ibatis.exceptions.ExceptionFactory.wrapException(ExceptionFactory.java:30)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.flushStatements(DefaultSqlSession.java:255)\n	at com.baomidou.mybatisplus.service.impl.ServiceImpl.insertBatch(ServiceImpl.java:135)\n	... 116 more\nCaused by: org.apache.ibatis.executor.BatchExecutorException: com.stylefeng.guns.modular.system.dao.MessageRecordMapper.insert (batch index #1) failed. Cause: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n	at org.apache.ibatis.executor.BatchExecutor.doFlushStatements(BatchExecutor.java:148)\n	at org.apache.ibatis.executor.BaseExecutor.flushStatements(BaseExecutor.java:129)\n	at org.apache.ibatis.executor.BaseExecutor.flushStatements(BaseExecutor.java:122)\n	at org.apache.ibatis.executor.CachingExecutor.flushStatements(CachingExecutor.java:114)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.TProxy199.flushStatements(Unknown Source)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.flushStatements(DefaultSqlSession.java:253)\n	... 117 more\nCaused by: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.cj.util.Util.handleNewInstance(Util.java:210)\n	at com.mysql.cj.util.Util.getInstance(Util.java:185)\n	at com.mysql.cj.util.Util.getInstance(Util.java:192)\n	at com.mysql.cj.jdbc.exceptions.SQLError.createBatchUpdateException(SQLError.java:218)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeBatchSerially(ClientPreparedStatement.java:864)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeBatchInternal(ClientPreparedStatement.java:453)\n	at com.mysql.cj.jdbc.StatementImpl.executeBatch(StatementImpl.java:839)\n	at com.alibaba.druid.filter.FilterChainImpl.statement_executeBatch(FilterChainImpl.java:3066)\n	at com.alibaba.druid.filter.FilterAdapter.statement_executeBatch(FilterAdapter.java:2496)\n	at com.alibaba.druid.filter.FilterEventAdapter.statement_executeBatch(FilterEventAdapter.java:279)\n	at com.alibaba.druid.filter.FilterChainImpl.statement_executeBatch(FilterChainImpl.java:3064)\n	at com.alibaba.druid.proxy.jdbc.StatementProxyImpl.executeBatch(StatementProxyImpl.java:202)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeBatch(DruidPooledPreparedStatement.java:566)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:78)\n	at com.sun.proxy.TProxy202.executeBatch(Unknown Source)\n	at org.apache.ibatis.executor.BatchExecutor.doFlushStatements(BatchExecutor.java:122)\n	... 127 more\nCaused by: com.mysql.cj.jdbc.exceptions.MysqlDataTruncation: Data truncation: Data too long for column \'templateCode\' at row 1\n	at com.mysql.cj.jdbc.exceptions.SQLExceptionsMapping.translateException(SQLExceptionsMapping.java:104)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeInternal(ClientPreparedStatement.java:960)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeUpdateInternal(ClientPreparedStatement.java:1116)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeBatchSerially(ClientPreparedStatement.java:843)\n	... 142 more\n'),(2559,'异常日志','',87,NULL,NULL,'2021-04-29 08:37:27','失败','com.baomidou.mybatisplus.exceptions.MybatisPlusException: Error: Cannot execute insertBatch Method. Cause\n	at com.baomidou.mybatisplus.service.impl.ServiceImpl.insertBatch(ServiceImpl.java:137)\n	at com.baomidou.mybatisplus.service.impl.ServiceImpl.insertBatch(ServiceImpl.java:110)\n	at com.baomidou.mybatisplus.service.impl.ServiceImplTTFastClassBySpringCGLIBTT3e2398a4.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at com.alibaba.druid.support.spring.stat.DruidStatInterceptor.invoke(DruidStatInterceptor.java:72)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.transaction.interceptor.TransactionAspectSupport.invokeWithinTransaction(TransactionAspectSupport.java:294)\n	at org.springframework.transaction.interceptor.TransactionInterceptor.invoke(TransactionInterceptor.java:98)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.service.impl.MessageRecordServiceImplTTEnhancerBySpringCGLIBTTe0199f35.insertBatch(<generated>)\n	at com.stylefeng.guns.modular.system.controller.MessageRecordController.sendMessage(MessageRecordController.java:139)\n	at com.stylefeng.guns.modular.system.controller.MessageRecordControllerTTFastClassBySpringCGLIBTT3463c734.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor102.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.MessageRecordControllerTTEnhancerBySpringCGLIBTT486c8689.sendMessage(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:660)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:741)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:199)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:528)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:139)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:747)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:678)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:343)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:798)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:810)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2129)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\nCaused by: org.apache.ibatis.exceptions.PersistenceException: \n### Error flushing statements.  Cause: org.apache.ibatis.executor.BatchExecutorException: com.stylefeng.guns.modular.system.dao.MessageRecordMapper.insert (batch index #1) failed. Cause: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n### Cause: org.apache.ibatis.executor.BatchExecutorException: com.stylefeng.guns.modular.system.dao.MessageRecordMapper.insert (batch index #1) failed. Cause: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n	at org.apache.ibatis.exceptions.ExceptionFactory.wrapException(ExceptionFactory.java:30)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.flushStatements(DefaultSqlSession.java:255)\n	at com.baomidou.mybatisplus.service.impl.ServiceImpl.insertBatch(ServiceImpl.java:135)\n	... 116 more\nCaused by: org.apache.ibatis.executor.BatchExecutorException: com.stylefeng.guns.modular.system.dao.MessageRecordMapper.insert (batch index #1) failed. Cause: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n	at org.apache.ibatis.executor.BatchExecutor.doFlushStatements(BatchExecutor.java:148)\n	at org.apache.ibatis.executor.BaseExecutor.flushStatements(BaseExecutor.java:129)\n	at org.apache.ibatis.executor.BaseExecutor.flushStatements(BaseExecutor.java:122)\n	at org.apache.ibatis.executor.CachingExecutor.flushStatements(CachingExecutor.java:114)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.plugin.Plugin.invoke(Plugin.java:63)\n	at com.sun.proxy.TProxy199.flushStatements(Unknown Source)\n	at org.apache.ibatis.session.defaults.DefaultSqlSession.flushStatements(DefaultSqlSession.java:253)\n	... 117 more\nCaused by: java.sql.BatchUpdateException: Data truncation: Data too long for column \'templateCode\' at row 1\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance0(Native Method)\n	at sun.reflect.NativeConstructorAccessorImpl.newInstance(NativeConstructorAccessorImpl.java:62)\n	at sun.reflect.DelegatingConstructorAccessorImpl.newInstance(DelegatingConstructorAccessorImpl.java:45)\n	at java.lang.reflect.Constructor.newInstance(Constructor.java:423)\n	at com.mysql.cj.util.Util.handleNewInstance(Util.java:210)\n	at com.mysql.cj.util.Util.getInstance(Util.java:185)\n	at com.mysql.cj.util.Util.getInstance(Util.java:192)\n	at com.mysql.cj.jdbc.exceptions.SQLError.createBatchUpdateException(SQLError.java:218)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeBatchSerially(ClientPreparedStatement.java:864)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeBatchInternal(ClientPreparedStatement.java:453)\n	at com.mysql.cj.jdbc.StatementImpl.executeBatch(StatementImpl.java:839)\n	at com.alibaba.druid.filter.FilterChainImpl.statement_executeBatch(FilterChainImpl.java:3066)\n	at com.alibaba.druid.filter.FilterAdapter.statement_executeBatch(FilterAdapter.java:2496)\n	at com.alibaba.druid.filter.FilterEventAdapter.statement_executeBatch(FilterEventAdapter.java:279)\n	at com.alibaba.druid.filter.FilterChainImpl.statement_executeBatch(FilterChainImpl.java:3064)\n	at com.alibaba.druid.proxy.jdbc.StatementProxyImpl.executeBatch(StatementProxyImpl.java:202)\n	at com.alibaba.druid.pool.DruidPooledPreparedStatement.executeBatch(DruidPooledPreparedStatement.java:566)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.apache.ibatis.logging.jdbc.PreparedStatementLogger.invoke(PreparedStatementLogger.java:78)\n	at com.sun.proxy.TProxy202.executeBatch(Unknown Source)\n	at org.apache.ibatis.executor.BatchExecutor.doFlushStatements(BatchExecutor.java:122)\n	... 127 more\nCaused by: com.mysql.cj.jdbc.exceptions.MysqlDataTruncation: Data truncation: Data too long for column \'templateCode\' at row 1\n	at com.mysql.cj.jdbc.exceptions.SQLExceptionsMapping.translateException(SQLExceptionsMapping.java:104)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeInternal(ClientPreparedStatement.java:960)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeUpdateInternal(ClientPreparedStatement.java:1116)\n	at com.mysql.cj.jdbc.ClientPreparedStatement.executeBatchSerially(ClientPreparedStatement.java:843)\n	... 142 more\n'),(2560,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-05-08 08:17:21','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知（晋人社〔2021〕58号）.pdf	'),(2561,'业务日志','修改通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2021-05-08 08:18:43','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知（晋人社〔2021〕58号）.pdf	;;;字段名称:内容,旧值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202105/1390943601608929281.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知（晋人社〔2021〕58号）.pdf</a><br></p>,新值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202105/1390943601608929281.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知</a><br></p><p><br></p>'),(2562,'业务日志','修改通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2021-05-08 08:19:27','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知（晋人社〔2021〕58号）.pdf	;;;字段名称:内容,旧值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202105/1390943601608929281.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知</a><br></p><p><br></p>,新值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202105/1390943601608929281.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第三批晋江市优秀人才入选名单的通知（晋人社〔2021〕58号）</a><br></p>'),(2563,'业务日志','新增批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-05-19 08:27:46','成功','申报类型=6,申报批次=2021,开始时间=2021-05-19 14:30:00,截止时间=2021-05-25 17:30:00,提交截止时间='),(2564,'业务日志','设置批次生效',87,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-05-19 08:27:50','成功','批次id=1394932780927856641'),(2565,'业务日志','修改管理员',94,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-05-20 00:28:24','成功','账号=jyj03;;;字段名称:null,旧值:708e02278e7d0081146727753f894c18,新值:'),(2566,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2021-05-20 06:35:26','成功','字典名称=街道,字典内容=00001:青阳:1;00002:罗山:2;00003:梅岭:3;00004:西园:4;00005:灵源:5;00006:新塘:6;00007:陈埭:7;00008:磁灶:8;00009:池店:9;00010:紫帽:10;00011:西滨:11;00012:内坑:12;00013:安海:13;00014:东石:14;00015:永和:15;00016:英林:16;00017:金井:17;00018:深沪:18;00019:龙湖:19;00020:经济开发区:20;00021:综合保税区:21;;;;'),(2567,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2021-05-20 06:35:53','成功','字典名称=街道,字典内容=00001:青阳:1;00002:罗山:2;00003:梅岭:3;00004:西园:4;00005:灵源:5;00006:新塘:6;00007:陈埭:7;00008:磁灶:8;00009:池店:9;00010:紫帽:10;00011:西滨:11;00012:内坑:12;00013:安海:13;00014:东石:14;00015:永和:15;00016:英林:16;00017:金井:17;00018:深沪:18;00019:龙湖:19;00020:经济开发区:20;00021:综合保税区:21;00000:无:22;;;;'),(2568,'业务日志','冻结用户',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','freeze','2021-05-21 06:46:28','成功','账号=rs07'),(2569,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-05-25 06:59:44','成功','账号=rs08'),(2570,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-05-25 07:00:10','成功','账号=rs08,角色名称集合=晋江市优秀人才-津补贴初审'),(2571,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-05-26 07:19:28','成功','申报类型=6,申报批次=2021,开始时间=2021-05-19 14:30:00,截止时间=2021-06-30 17:30:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-05-25 17:30:00,新值:2021-06-30 17:30:00'),(2572,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-05-26 07:19:43','成功','申报类型=6,申报批次=2021,开始时间=2021-05-19 14:30:00,截止时间=2021-06-30 17:30:00,提交截止时间=;;;'),(2573,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-05-26 07:19:51','成功','申报类型=6,申报批次=2021,开始时间=2021-05-19 14:30:00,截止时间=2021-06-30 17:30:00,提交截止时间=;;;'),(2574,'业务日志','重置管理员密码',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2021-05-31 02:05:19','成功','账号=gdj1'),(2575,'异常日志','',58,NULL,NULL,'2021-06-02 01:49:13','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor165.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT943bb81.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2576,'异常日志','',58,NULL,NULL,'2021-06-02 01:49:22','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor165.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT943bb81.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2577,'异常日志','',58,NULL,NULL,'2021-06-02 01:49:25','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor165.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT943bb81.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2578,'异常日志','',58,NULL,NULL,'2021-06-02 01:49:26','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor165.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT943bb81.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2579,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-06-03 03:28:51','成功','账号=gdj1;;;字段名称:null,旧值:36fc04ea972b9f02b54d23eec4c7a14c,新值:;;;字段名称:名字,旧值:陈灿峰,新值:陈颖颖;;;字段名称:生日,旧值:1994-10-23,新值:2021-06-03;;;字段名称:电子邮件,旧值:123@163.com,新值:jjgd_5683864@163.com;;;字段名称:电话,旧值:13599718877,新值:13505079029'),(2580,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-06-08 03:23:26','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第四批晋江市优秀人才入选名单的函（晋人社函〔2021〕62号）'),(2581,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-06-08 08:11:06','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-07-01 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-06-01 00:00:00,新值:2021-07-01 00:00:00;;;字段名称:提交截止时间,旧值:2021-06-01 00:00:00,新值:;;;字段名称:null,旧值:2021-06-01 00:00:00,新值:;;;字段名称:null,旧值:2021-06-01 00:00:00,新值:'),(2582,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-05 08:06:52','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-05 17:30:00,提交截止时间=2021-07-05 18:00:00;;;字段名称:提交截止时间,旧值:2021-10-01 17:30:00,新值:2021-07-05 18:00:00'),(2583,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-07-07 07:34:48','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第五批晋江市优秀人才入选名单的函（晋人社函〔2021〕118号）.pdf	'),(2584,'业务日志','修改通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2021-07-07 07:35:40','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第五批晋江市优秀人才入选名单的函（晋人社函〔2021〕118号）.pdf	;;;字段名称:内容,旧值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202107/1412676142736908289.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第五批晋江市优秀人才入选名单的函（晋人社函〔2021〕118号）.pdf</a><br></p><p><!--StartFragment--><br><!--EndFragment--></p>,新值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202107/1412676142736908289.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第五批晋江市优秀人才入选名单的函（晋人社函〔2021〕118号）</a><br></p><p><!StartFragment><br><!EndFragment></p><p><br></p>'),(2585,'业务日志','删除通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','delete','2021-07-07 07:37:07','成功','null=32'),(2586,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-07-07 07:37:51','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第五批晋江市优秀人才入选名单的函（晋人社函〔2021〕118号）.pdf	'),(2587,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-12 08:41:34','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-05 17:30:00,提交截止时间=2021-07-14 18:00:00;;;字段名称:提交截止时间,旧值:2021-07-05 18:00:00,新值:2021-07-14 18:00:00'),(2588,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-14 03:49:41','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-08-01 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-01 00:00:00,新值:2021-08-01 00:00:00'),(2589,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-14 03:50:46','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-07-01 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-08-01 00:00:00,新值:2021-07-01 00:00:00'),(2590,'业务日志','修改批次',87,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-14 07:29:04','成功','申报类型=2,申报批次=2020,开始时间=2021-03-15 00:00:00,截止时间=2021-04-05 17:30:00,提交截止时间=2021-07-14 23:59:00;;;字段名称:提交截止时间,旧值:2021-07-14 18:00:00,新值:2021-07-14 23:59:00'),(2591,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-14 09:32:44','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-08-01 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-01 00:00:00,新值:2021-08-01 00:00:00'),(2592,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-14 10:01:01','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-07-14 18:00:56,提交截止时间=;;;字段名称:截止时间,旧值:2021-08-01 00:00:00,新值:2021-07-14 18:00:56'),(2593,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-20 01:29:18','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-07-23 09:29:12,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-14 18:00:56,新值:2021-07-23 09:29:12'),(2594,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-07-20 03:31:03','成功','账号=rs09'),(2595,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-07-20 03:32:01','成功','账号=rs09,角色名称集合=晋江市优秀人才-津补贴初审'),(2596,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-20 09:53:59','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-07-20 17:53:55,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-23 09:29:12,新值:2021-07-20 17:53:55'),(2597,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-21 02:13:46','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-07-31 17:53:55,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-20 17:53:55,新值:2021-07-31 17:53:55'),(2598,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-07-21 02:14:21','成功','申报类型=3,申报批次=1,开始时间=2021-07-21 10:14:03,截止时间=2021-07-31 00:00:00,提交截止时间='),(2599,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-07-21 02:14:54','成功','批次id=1417669243821916162'),(2600,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-21 02:16:20','成功','申报类型=3,申报批次=1,开始时间=2021-07-21 10:14:03,截止时间=2021-12-31 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-31 00:00:00,新值:2021-12-31 00:00:00'),(2601,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-07-24 07:56:26','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-07-24 15:56:22,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-31 17:53:55,新值:2021-07-24 15:56:22'),(2602,'异常日志','',75,NULL,NULL,'2021-07-26 01:34:27','失败','com.stylefeng.guns.core.exception.GunsException: 原密码不正确\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:162)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor195.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTe9e51532.changePwd(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2603,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-07-26 02:24:03','成功','申报类型=1,申报批次=202101,开始时间=2021-07-26 00:00:00,截止时间=2021-08-31 00:00:00,提交截止时间='),(2604,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-07-26 02:24:06','成功','批次id=1419483621667930114'),(2605,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-07-26 09:01:31','成功','申报类型=8,申报批次=1,开始时间=2021-07-26 17:01:15,截止时间=2021-12-31 00:00:00,提交截止时间='),(2606,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-07-26 09:01:37','成功','批次id=1419583649254244353'),(2607,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-07-28 10:00:05','成功','账号=hcxz02'),(2608,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-07-28 10:00:45','成功','账号=hcxz02,角色名称集合=走访核查小组'),(2609,'异常日志','',58,NULL,NULL,'2021-07-29 02:39:52','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor160.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT8ea3a3d.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2610,'异常日志','',58,NULL,NULL,'2021-07-29 02:40:02','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor160.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT8ea3a3d.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2611,'异常日志','',58,NULL,NULL,'2021-07-29 02:40:05','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor160.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT8ea3a3d.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2612,'异常日志','',58,NULL,NULL,'2021-07-29 02:40:06','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor160.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT8ea3a3d.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2613,'异常日志','',58,NULL,NULL,'2021-07-29 02:40:08','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor160.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT8ea3a3d.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2614,'异常日志','',58,NULL,NULL,'2021-07-29 02:40:34','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:228)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor160.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT8ea3a3d.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2615,'业务日志','修改管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','edit','2021-07-29 02:40:52','成功','账号=hcxz02;;;字段名称:null,旧值:9f59d948a3c47b00e381c56e96271b9f,新值:;;;字段名称:生日,旧值:1994-10-22,新值:2021-07-29;;;字段名称:null,旧值:,新值:2'),(2616,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-08-03 03:42:23','成功','申报类型=4,申报批次=1,开始时间=2021-08-03 11:42:19,截止时间=,提交截止时间='),(2617,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-08-03 03:42:32','成功','批次id=1422402438622633985'),(2618,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-03 03:42:43','成功','申报类型=3,申报批次=1,开始时间=2021-07-21 10:14:03,截止时间=,提交截止时间=;;;字段名称:截止时间,旧值:2021-12-31 00:00:00,新值:'),(2619,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-03 03:42:56','成功','申报类型=8,申报批次=1,开始时间=2021-07-26 17:01:15,截止时间=,提交截止时间=;;;字段名称:截止时间,旧值:2021-12-31 00:00:00,新值:'),(2620,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-03 03:44:00','成功','申报类型=1,申报批次=202101,开始时间=2021-07-26 00:00:00,截止时间=2021-12-31 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-08-31 00:00:00,新值:2021-12-31 00:00:00'),(2621,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-03 03:44:30','成功','申报类型=1,申报批次=202101,开始时间=2021-07-26 00:00:00,截止时间=2021-12-31 23:59:59,提交截止时间=;;;字段名称:截止时间,旧值:2021-12-31 00:00:00,新值:2021-12-31 23:59:59'),(2622,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-08-04 08:19:42','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第六批晋江市优秀人才入选名单的函（晋人社函〔2021〕143号）.pdf	'),(2623,'业务日志','修改批次',67,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-06 07:44:01','成功','申报类型=3,申报批次=1,开始时间=2021-07-21 10:14:03,截止时间=2021-12-31 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:,新值:2021-12-31 00:00:00'),(2624,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-06 07:48:05','成功','申报类型=8,申报批次=1,开始时间=2021-07-26 17:01:15,截止时间=2021-12-31 23:59:59,提交截止时间=;;;字段名称:截止时间,旧值:,新值:2021-12-31 23:59:59'),(2625,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-06 07:48:21','成功','申报类型=4,申报批次=1,开始时间=2021-08-03 11:42:19,截止时间=2021-12-31 23:59:59,提交截止时间=;;;字段名称:截止时间,旧值:,新值:2021-12-31 23:59:59'),(2626,'业务日志','新增批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-08-10 08:04:42','成功','申报类型=9,申报批次=1,开始时间=2021-08-10 16:04:22,截止时间=2021-12-10 23:59:59,提交截止时间='),(2627,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-08-10 08:04:46','成功','批次id=1425005166448386050'),(2628,'业务日志','菜单新增',67,'com.stylefeng.guns.modular.system.controller.MenuController','add','2021-08-18 01:45:05','成功','菜单名称=撤回审核'),(2629,'业务日志','配置权限',67,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2021-08-18 01:45:23','成功','角色名称=集成电路-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,人才津贴配置,添加,修改,删除,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,复核,审核& #40;非集成电路& #41;,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,人才层次变更,初级审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2630,'业务日志','配置权限',67,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2021-08-18 01:45:38','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2631,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-25 10:23:40','成功','申报类型=1,申报批次=2021,开始时间=2021-07-26 00:00:00,截止时间=2021-12-31 23:59:59,提交截止时间=;;;字段名称:申报批次,旧值:202101,新值:2021'),(2632,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-08-25 10:24:25','成功','申报类型=1,申报批次=202101,开始时间=2021-07-26 00:00:00,截止时间=2021-12-31 23:59:59,提交截止时间=;;;字段名称:申报批次,旧值:2021,新值:202101'),(2633,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-09-01 09:33:39','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第七批晋江市优秀人才入选名单的函（晋人社函〔2021〕155号）.pdf'),(2634,'业务日志','重置管理员密码',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2021-09-02 01:15:14','成功','账号=rs01'),(2635,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-02 08:00:03','成功','账号=hcxz01'),(2636,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-02 08:00:38','成功','账号=hcxz01,角色名称集合=走访核查小组'),(2637,'异常日志','',87,NULL,NULL,'2021-09-02 09:06:09','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2638,'异常日志','',87,NULL,NULL,'2021-09-02 09:06:14','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2639,'异常日志','',87,NULL,NULL,'2021-09-02 09:06:22','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2640,'异常日志','',87,NULL,NULL,'2021-09-02 09:06:31','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2641,'异常日志','',87,NULL,NULL,'2021-09-02 09:07:07','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2642,'异常日志','',87,NULL,NULL,'2021-09-02 09:07:10','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n');
INSERT INTO `sys_operation_log` VALUES (2643,'异常日志','',87,NULL,NULL,'2021-09-02 09:07:10','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2644,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:14','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2645,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:15','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2646,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:15','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2647,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:15','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2648,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:16','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2649,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:16','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2650,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:16','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2651,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:16','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1341.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2652,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:17','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1341.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.GeneratedMethodAccessor1352.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2653,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:17','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1341.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.GeneratedMethodAccessor1352.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2654,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:18','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1341.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.GeneratedMethodAccessor1352.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2655,'异常日志','',87,NULL,NULL,'2021-09-02 09:08:19','失败','com.stylefeng.guns.core.exception.GunsException: 请求有错误\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.add(UserMgrController.java:201)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1341.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.add(<generated>)\n	at sun.reflect.GeneratedMethodAccessor1352.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2656,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-02 09:08:35','成功','账号=hcxz03'),(2657,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-02 09:09:13','成功','账号=hcxz04'),(2658,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-02 09:09:25','成功','账号=hcxz03,角色名称集合=走访核查小组'),(2659,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-02 09:09:36','成功','账号=hcxz04,角色名称集合=走访核查小组'),(2660,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-02 09:10:03','成功','账号=hcxz05'),(2661,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-02 09:10:15','成功','账号=hcxz05,角色名称集合=走访核查小组'),(2662,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-02 09:10:50','成功','账号=hcxz06'),(2663,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-02 09:10:57','成功','账号=hcxz06,角色名称集合=走访核查小组'),(2664,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-02 09:12:05','成功','账号=hcxz07'),(2665,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-02 09:12:12','成功','账号=hcxz07,角色名称集合=走访核查小组'),(2666,'异常日志','',87,NULL,NULL,'2021-09-02 09:12:22','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1341.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2667,'异常日志','',87,NULL,NULL,'2021-09-03 01:55:49','失败','com.stylefeng.guns.core.exception.GunsException: 权限异常\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.edit(UserMgrController.java:248)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\n	at sun.reflect.GeneratedMethodAccessor198.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\n	at com.stylefeng.guns.core.aop.LogAop.recordSysLog(LogAop.java:45)\n	at sun.reflect.GeneratedMethodAccessor1341.invoke(Unknown Source)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:174)\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTTf2f37553.edit(<generated>)\n	at sun.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\n	at sun.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\n	at sun.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\n	at java.lang.reflect.Method.invoke(Method.java:498)\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:652)\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:733)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:117)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.accessT000(ErrorPageFilter.java:61)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilterT1.doFilterInternal(ErrorPageFilter.java:92)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.springframework.boot.web.servlet.support.ErrorPageFilter.doFilter(ErrorPageFilter.java:110)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:201)\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:97)\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:544)\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:143)\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\n	at org.apache.catalina.valves.RemoteIpValve.invoke(RemoteIpValve.java:764)\n	at org.apache.catalina.valves.AbstractAccessLogValve.invoke(AbstractAccessLogValve.java:698)\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:78)\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:364)\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:616)\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:65)\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:831)\n	at org.apache.tomcat.util.net.AprEndpointTSocketWithOptionsProcessor.run(AprEndpoint.java:2045)\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\n	at java.lang.Thread.run(Thread.java:748)\n'),(2668,'业务日志','删除管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2021-09-03 01:56:13','成功','账号=hcxz03'),(2669,'业务日志','添加管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-03 01:57:05','成功','账号=hcxz03'),(2670,'业务日志','分配角色',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-03 01:57:46','成功','账号=hcxz03,角色名称集合=走访核查小组'),(2671,'业务日志','重置管理员密码',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','reset','2021-09-03 07:49:34','成功','账号=hcxz02'),(2672,'业务日志','删除管理员',87,'com.stylefeng.guns.modular.system.controller.UserMgrController','delete','2021-09-05 02:28:15','成功','账号=rs09'),(2673,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-09-06 03:05:25','成功','申报类型=4,申报批次=1,开始时间=2021-08-03 11:42:19,截止时间=2021-12-31 23:59:59,提交截止时间=;;;'),(2674,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-09-06 07:30:16','成功','批次id=1374305502212763649'),(2675,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-09-06 07:33:30','成功','申报类型=1,申报批次=1,开始时间=2021-03-23 00:00:00,截止时间=2021-09-07 15:56:22,提交截止时间=;;;字段名称:截止时间,旧值:2021-07-24 15:56:22,新值:2021-09-07 15:56:22'),(2676,'业务日志','设置批次生效',68,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-09-06 08:19:15','成功','批次id=1419483621667930114'),(2677,'业务日志','修改批次',68,'com.stylefeng.guns.modular.system.controller.BatchController','update','2021-09-10 03:00:18','成功','申报类型=9,申报批次=1,开始时间=2021-08-10 16:04:22,截止时间=2021-12-31 23:59:59,提交截止时间=;;;字段名称:截止时间,旧值:2021-12-10 23:59:59,新值:2021-12-31 23:59:59'),(2678,'业务日志','添加管理员',59,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-09-10 03:02:18','成功','账号=hym'),(2679,'业务日志','分配角色',59,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-10 03:03:42','成功','账号=hym,角色名称集合=集成电路-初审,集成电路-人才库'),(2680,'业务日志','分配角色',59,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-09-10 03:03:59','成功','账号=hym,角色名称集合=集成电路-超级管理员,集成电路-初审,集成电路-人才库'),(2681,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-10-19 01:23:14','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第八批晋江市优秀人才入选名单的函（晋人社函〔2021〕171号）.pdf'),(2682,'业务日志','添加管理员',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2021-11-09 02:44:53','成功','账号=rcb'),(2683,'业务日志','分配角色',58,'com.stylefeng.guns.modular.system.controller.UserMgrController','setRole','2021-11-09 02:45:31','成功','账号=rcb,角色名称集合=晋江市优秀人才-超级管理员'),(2684,'业务日志','新增通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','add','2021-11-11 09:29:23','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第九批晋江市优秀人才入选名单的函（晋人社函〔2021〕173号）.pdf	'),(2685,'业务日志','修改通知',87,'com.stylefeng.guns.modular.system.controller.NoticeController','update','2021-11-11 09:30:29','成功','标题=晋江市人力资源和社会保障局关于公布2021年度第九批晋江市优秀人才入选名单的函（晋人社函〔2021〕173号）.pdf	;;;字段名称:内容,旧值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202111/1458728244822962177.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第九批晋江市优秀人才入选名单的函</a><br></p>,新值:<p><a href=\"https://rc.jucai.gov.cn/ftp/jjrcw/commonfile/202111/1458728244822962177.pdf\" target=\"_blank\">晋江市人力资源和社会保障局关于公布2021年度第九批晋江市优秀人才入选名单的函（晋人社函〔2021〕173号）</a><br></p><p><br></p>'),(2686,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2021-11-29 02:52:08','成功','菜单名称=修复'),(2687,'业务日志','新增批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','add','2021-12-02 01:17:32','成功','申报类型=5,申报批次=2020,开始时间=2021-12-01 00:00:00,截止时间=2021-12-11 00:00:00,提交截止时间='),(2688,'业务日志','设置批次生效',1,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2021-12-02 01:17:37','成功','批次id=1466214915673653249'),(2689,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-02-09 02:59:19','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,代码生成,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出'),(2690,'业务日志','修改字典',1,'com.stylefeng.guns.modular.system.controller.DictController','update','2022-02-09 07:33:29','成功','字典名称=申报项目,字典内容=1:人才认定:1;2:津补贴申报:2;3:离职申报:3;4:工作单位变更:4;5:购房补贴:5;6:子女就学:6;7:银行账号变更:7;8:人才层次变更:8;9:人才基础信息变更:9;11:培训补贴:11;12:重大专项经费:12;13:学杂费补助:13;14:医疗补助:14;15:租房申请:15;16:房租补助:16;17:购房申请:17;18:购房补助:18;19:硕博人才生活补贴:19;;;;'),(2691,'业务日志','新增批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','add','2022-02-09 07:34:14','成功','申报类型=19,申报批次=2021,开始时间=2022-02-08 00:00:00,截止时间=2022-03-09 00:00:00,提交截止时间=2022-03-18 00:00:00'),(2692,'业务日志','设置批次生效',1,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2022-02-09 07:34:20','成功','批次id=1491314478457499649'),(2693,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-09 07:36:47','成功','菜单名称=硕博人才管理'),(2694,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-09 07:37:30','成功','菜单名称=生活补贴'),(2695,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-02-11 07:53:03','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,代码生成,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴'),(2696,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2022-02-11 08:21:29','成功','字典名称=硕博人才学位,字典内容=1:硕士:1;2:博士:2;'),(2697,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-14 02:31:16','成功','菜单名称=审核'),(2698,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-02-14 02:32:12','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,代码生成,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴,审核'),(2699,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2022-02-15 02:55:28','成功','字典名称=硕士人才生活补贴,字典内容=1:30000:1;2:20000:2;3:10000:3;'),(2700,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2022-02-15 02:56:45','成功','字典名称=博士研究生生活补贴金额,字典内容=1:50000:1;2:30000:2;3:30000:3;'),(2701,'业务日志','新增批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','add','2022-02-17 01:28:40','成功','申报类型=1,申报批次=2022,开始时间=2022-02-01 00:00:00,截止时间=2022-12-31 00:00:00,提交截止时间=2022-12-31 00:00:00'),(2702,'业务日志','设置批次生效',1,'com.stylefeng.guns.modular.system.controller.BatchController','setupActive','2022-02-17 01:29:05','成功','批次id=1494121582884827138'),(2703,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 02:39:34','成功','菜单名称=生活补贴初审'),(2704,'业务日志','修改菜单',1,'com.stylefeng.guns.modular.system.controller.MenuController','edit','2022-02-18 02:40:42','成功','菜单名称=生活补贴复核;;;字段名称:菜单编号,旧值:livingAllowanceInfo,新值:livingAllowanceInfo3;;;字段名称:菜单名称,旧值:生活补贴,新值:生活补贴复核;;;字段名称:url地址,旧值:/livingAllowanceInfo,新值:/livingAllowanceInfo?process=3'),(2705,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 02:43:05','成功','菜单名称=审核'),(2706,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 02:43:38','成功','菜单名称=审核'),(2707,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-02-18 02:44:00','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,代码生成,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,生活补贴初审,审核,审核'),(2708,'业务日志','修改菜单',1,'com.stylefeng.guns.modular.system.controller.MenuController','edit','2022-02-18 02:47:40','成功','菜单名称=硕博人才管理;;;字段名称:菜单排序号,旧值:20,新值:25'),(2709,'业务日志','修改菜单',1,'com.stylefeng.guns.modular.system.controller.MenuController','edit','2022-02-18 02:48:37','成功','菜单名称=生活补贴复核;;;字段名称:菜单排序号,旧值:1,新值:2'),(2710,'业务日志','修改菜单',1,'com.stylefeng.guns.modular.system.controller.MenuController','edit','2022-02-18 02:48:38','成功','菜单名称=生活补贴复核;;;字段名称:菜单排序号,旧值:1,新值:2'),(2711,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 09:25:51','成功','菜单名称=生活补贴兑现'),(2712,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 09:27:40','成功','菜单名称=导出核查征信'),(2713,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 09:28:17','成功','菜单名称=征信失信'),(2714,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 09:29:29','成功','菜单名称=征信通过'),(2715,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 09:30:48','成功','菜单名称=公示'),(2716,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-18 09:31:22','成功','菜单名称=公示导出'),(2717,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-02-18 09:31:41','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,代码生成,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,生活补贴初审,审核,生活补贴兑现,导出核查征信,征信失信,征信通过,公示,公示导出,审核'),(2718,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-21 02:33:31','成功','菜单名称=公示预览'),(2719,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-21 02:34:17','成功','菜单名称=公示再审核'),(2720,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-21 02:34:49','成功','菜单名称=公示通过'),(2721,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-21 02:35:24','成功','菜单名称=发放'),(2722,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-02-21 02:38:49','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,代码生成,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,生活补贴初审,审核,生活补贴兑现,导出核查征信,征信失信,征信通过,公示,公示导出,公示预览,公示再审核,公示通过,发放,审核'),(2723,'业务日志','菜单新增',1,'com.stylefeng.guns.modular.system.controller.MenuController','add','2022-02-21 08:28:19','成功','菜单名称=导出'),(2724,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-02-21 08:28:55','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,代码生成,附件类别管理,人才认定申报,添加,修改,删除,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,导出,生活补贴初审,审核,生活补贴兑现,导出核查征信,征信失信,征信通过,公示,公示导出,公示预览,公示再审核,公示通过,发放,审核'),(2725,'业务日志','修改批次',1,'com.stylefeng.guns.modular.system.controller.BatchController','update','2022-02-25 03:22:55','成功','申报类型=5,申报批次=2020,开始时间=2021-12-01 00:00:00,截止时间=2022-03-11 00:00:00,提交截止时间=;;;字段名称:截止时间,旧值:2021-12-11 00:00:00,新值:2022-03-11 00:00:00'),(2726,'异常日志','',1,NULL,NULL,'2022-02-25 06:35:59','失败','org.springframework.http.converter.HttpMessageNotReadableException: JSON parse error: parseDecimal error, field : amount; nested exception is com.alibaba.fastjson.JSONException: parseDecimal error, field : amount\r\n	at com.alibaba.fastjson.support.spring.FastJsonHttpMessageConverter.readType(FastJsonHttpMessageConverter.java:205)\r\n	at com.alibaba.fastjson.support.spring.FastJsonHttpMessageConverter.read(FastJsonHttpMessageConverter.java:177)\r\n	at org.springframework.web.servlet.mvc.method.annotation.AbstractMessageConverterMethodArgumentResolver.readWithMessageConverters(AbstractMessageConverterMethodArgumentResolver.java:206)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.readWithMessageConverters(RequestResponseBodyMethodProcessor.java:157)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestResponseBodyMethodProcessor.resolveArgument(RequestResponseBodyMethodProcessor.java:130)\r\n	at org.springframework.web.method.support.HandlerMethodArgumentResolverComposite.resolveArgument(HandlerMethodArgumentResolverComposite.java:124)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.getMethodArgumentValues(InvocableHandlerMethod.java:161)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:131)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:661)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:742)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\r\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\r\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\r\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\r\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\r\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\r\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\r\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\r\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\r\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\r\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\r\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:198)\r\n	at org.apache.catalina.core.StandardContextValve.__invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:41002)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:496)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:140)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:342)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:803)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:790)\r\n	at org.apache.tomcat.util.net.NioEndpointTSocketProcessor.doRun(NioEndpoint.java:1459)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1149)\r\n	at java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:624)\r\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\r\n	at java.lang.Thread.run(Thread.java:748)\r\nCaused by: com.alibaba.fastjson.JSONException: parseDecimal error, field : amount\r\n	at com.alibaba.fastjson.serializer.BigDecimalCodec.deserialze(BigDecimalCodec.java:63)\r\n	at com.alibaba.fastjson.parser.deserializer.DefaultFieldDeserializer.parseField(DefaultFieldDeserializer.java:86)\r\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseField(JavaBeanDeserializer.java:1078)\r\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:773)\r\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseRest(JavaBeanDeserializer.java:1283)\r\n	at com.alibaba.fastjson.parser.deserializer.FastjsonASMDeserializer_2_HousepurchaseResettlementAllowance.deserialze(Unknown Source)\r\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:267)\r\n	at com.alibaba.fastjson.parser.deserializer.ArrayListTypeFieldDeserializer.parseArray(ArrayListTypeFieldDeserializer.java:177)\r\n	at com.alibaba.fastjson.parser.deserializer.ArrayListTypeFieldDeserializer.parseField(ArrayListTypeFieldDeserializer.java:65)\r\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:745)\r\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.parseRest(JavaBeanDeserializer.java:1283)\r\n	at com.alibaba.fastjson.parser.deserializer.FastjsonASMDeserializer_1_Housepurchase.deserialze(Unknown Source)\r\n	at com.alibaba.fastjson.parser.deserializer.JavaBeanDeserializer.deserialze(JavaBeanDeserializer.java:267)\r\n	at com.alibaba.fastjson.parser.DefaultJSONParser.parseObject(DefaultJSONParser.java:661)\r\n	at com.alibaba.fastjson.JSON.parseObject(JSON.java:365)\r\n	at com.alibaba.fastjson.JSON.parseObject(JSON.java:333)\r\n	at com.alibaba.fastjson.JSON.parseObject(JSON.java:296)\r\n	at com.alibaba.fastjson.JSON.parseObject(JSON.java:402)\r\n	at com.alibaba.fastjson.JSON.parseObject(JSON.java:484)\r\n	at com.alibaba.fastjson.support.spring.FastJsonHttpMessageConverter.readType(FastJsonHttpMessageConverter.java:203)\r\n	... 80 more\r\nCaused by: java.lang.NumberFormatException\r\n	at java.math.BigDecimal.<init>(BigDecimal.java:497)\r\n	at java.math.BigDecimal.<init>(BigDecimal.java:383)\r\n	at java.math.BigDecimal.<init>(BigDecimal.java:809)\r\n	at com.alibaba.fastjson.util.TypeUtils.castToBigDecimal(TypeUtils.java:208)\r\n	at com.alibaba.fastjson.serializer.BigDecimalCodec.deserialze(BigDecimalCodec.java:85)\r\n	at com.alibaba.fastjson.serializer.BigDecimalCodec.deserialze(BigDecimalCodec.java:61)\r\n	... 99 more\r\n'),(2727,'异常日志','',1,NULL,NULL,'2022-08-11 07:07:31','失败','com.stylefeng.guns.core.exception.GunsException: 密码必须包含字母、数字、特殊字符且长度超过8位\r\n	at com.stylefeng.guns.modular.system.controller.UserMgrController.changePwd(UserMgrController.java:155)\r\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTFastClassBySpringCGLIBTT87f11409.invoke(<generated>)\r\n	at org.springframework.cglib.proxy.MethodProxy.invoke(MethodProxy.java:204)\r\n	at org.springframework.aop.framework.CglibAopProxyTCglibMethodInvocation.invokeJoinpoint(CglibAopProxy.java:747)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:163)\r\n	at org.springframework.aop.aspectj.MethodInvocationProceedingJoinPoint.proceed(MethodInvocationProceedingJoinPoint.java:89)\r\n	at com.stylefeng.guns.core.intercept.SessionHolderInterceptor.sessionKit(SessionHolderInterceptor.java:29)\r\n	at jdk.internal.reflect.GeneratedMethodAccessor127.invoke(Unknown Source)\r\n	at java.base/jdk.internal.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.base/java.lang.reflect.Method.invoke(Method.java:567)\r\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethodWithGivenArgs(AbstractAspectJAdvice.java:644)\r\n	at org.springframework.aop.aspectj.AbstractAspectJAdvice.invokeAdviceMethod(AbstractAspectJAdvice.java:633)\r\n	at org.springframework.aop.aspectj.AspectJAroundAdvice.invoke(AspectJAroundAdvice.java:70)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\r\n	at org.springframework.aop.interceptor.ExposeInvocationInterceptor.invoke(ExposeInvocationInterceptor.java:92)\r\n	at org.springframework.aop.framework.ReflectiveMethodInvocation.proceed(ReflectiveMethodInvocation.java:185)\r\n	at org.springframework.aop.framework.CglibAopProxyTDynamicAdvisedInterceptor.intercept(CglibAopProxy.java:689)\r\n	at com.stylefeng.guns.modular.system.controller.UserMgrControllerTTEnhancerBySpringCGLIBTT919fb8da.changePwd(<generated>)\r\n	at java.base/jdk.internal.reflect.NativeMethodAccessorImpl.invoke0(Native Method)\r\n	at java.base/jdk.internal.reflect.NativeMethodAccessorImpl.invoke(NativeMethodAccessorImpl.java:62)\r\n	at java.base/jdk.internal.reflect.DelegatingMethodAccessorImpl.invoke(DelegatingMethodAccessorImpl.java:43)\r\n	at java.base/java.lang.reflect.Method.invoke(Method.java:567)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.doInvoke(InvocableHandlerMethod.java:209)\r\n	at org.springframework.web.method.support.InvocableHandlerMethod.invokeForRequest(InvocableHandlerMethod.java:136)\r\n	at org.springframework.web.servlet.mvc.method.annotation.ServletInvocableHandlerMethod.invokeAndHandle(ServletInvocableHandlerMethod.java:102)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.invokeHandlerMethod(RequestMappingHandlerAdapter.java:877)\r\n	at org.springframework.web.servlet.mvc.method.annotation.RequestMappingHandlerAdapter.handleInternal(RequestMappingHandlerAdapter.java:783)\r\n	at org.springframework.web.servlet.mvc.method.AbstractHandlerMethodAdapter.handle(AbstractHandlerMethodAdapter.java:87)\r\n	at org.springframework.web.servlet.DispatcherServlet.doDispatch(DispatcherServlet.java:991)\r\n	at org.springframework.web.servlet.DispatcherServlet.doService(DispatcherServlet.java:925)\r\n	at org.springframework.web.servlet.FrameworkServlet.processRequest(FrameworkServlet.java:974)\r\n	at org.springframework.web.servlet.FrameworkServlet.doPost(FrameworkServlet.java:877)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:661)\r\n	at org.springframework.web.servlet.FrameworkServlet.service(FrameworkServlet.java:851)\r\n	at javax.servlet.http.HttpServlet.service(HttpServlet.java:742)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:231)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.tomcat.websocket.server.WsFilter.doFilter(WsFilter.java:52)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:61)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\r\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\r\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.executeChain(AdviceFilter.java:108)\r\n	at org.apache.shiro.web.servlet.AdviceFilter.doFilterInternal(AdviceFilter.java:137)\r\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\r\n	at org.apache.shiro.web.servlet.ProxiedFilterChain.doFilter(ProxiedFilterChain.java:66)\r\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.executeChain(AbstractShiroFilter.java:450)\r\n	at org.apache.shiro.web.servlet.AbstractShiroFilterT1.call(AbstractShiroFilter.java:365)\r\n	at org.apache.shiro.subject.support.SubjectCallable.doCall(SubjectCallable.java:90)\r\n	at org.apache.shiro.subject.support.SubjectCallable.call(SubjectCallable.java:83)\r\n	at org.apache.shiro.subject.support.DelegatingSubject.execute(DelegatingSubject.java:387)\r\n	at org.apache.shiro.web.servlet.AbstractShiroFilter.doFilterInternal(AbstractShiroFilter.java:362)\r\n	at org.apache.shiro.web.servlet.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:125)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.stylefeng.guns.core.xss.XssFilter.doFilter(XssFilter.java:31)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at com.alibaba.druid.support.http.WebStatFilter.doFilter(WebStatFilter.java:123)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.RequestContextFilter.doFilterInternal(RequestContextFilter.java:99)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HttpPutFormContentFilter.doFilterInternal(HttpPutFormContentFilter.java:109)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.HiddenHttpMethodFilter.doFilterInternal(HiddenHttpMethodFilter.java:81)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.springframework.web.filter.CharacterEncodingFilter.doFilterInternal(CharacterEncodingFilter.java:200)\r\n	at org.springframework.web.filter.OncePerRequestFilter.doFilter(OncePerRequestFilter.java:107)\r\n	at org.apache.catalina.core.ApplicationFilterChain.internalDoFilter(ApplicationFilterChain.java:193)\r\n	at org.apache.catalina.core.ApplicationFilterChain.doFilter(ApplicationFilterChain.java:166)\r\n	at org.apache.catalina.core.StandardWrapperValve.invoke(StandardWrapperValve.java:198)\r\n	at org.apache.catalina.core.StandardContextValve.invoke(StandardContextValve.java:96)\r\n	at org.apache.catalina.authenticator.AuthenticatorBase.invoke(AuthenticatorBase.java:496)\r\n	at org.apache.catalina.core.StandardHostValve.invoke(StandardHostValve.java:140)\r\n	at org.apache.catalina.valves.ErrorReportValve.invoke(ErrorReportValve.java:81)\r\n	at org.apache.catalina.core.StandardEngineValve.invoke(StandardEngineValve.java:87)\r\n	at org.apache.catalina.connector.CoyoteAdapter.service(CoyoteAdapter.java:342)\r\n	at org.apache.coyote.http11.Http11Processor.service(Http11Processor.java:803)\r\n	at org.apache.coyote.AbstractProcessorLight.process(AbstractProcessorLight.java:66)\r\n	at org.apache.coyote.AbstractProtocolTConnectionHandler.process(AbstractProtocol.java:790)\r\n	at org.apache.tomcat.util.net.NioEndpointTSocketProcessor.doRun(NioEndpoint.java:1459)\r\n	at org.apache.tomcat.util.net.SocketProcessorBase.run(SocketProcessorBase.java:49)\r\n	at java.base/java.util.concurrent.ThreadPoolExecutor.runWorker(ThreadPoolExecutor.java:1128)\r\n	at java.base/java.util.concurrent.ThreadPoolExecutorTWorker.run(ThreadPoolExecutor.java:628)\r\n	at org.apache.tomcat.util.threads.TaskThreadTWrappingRunnable.run(TaskThread.java:61)\r\n	at java.base/java.lang.Thread.run(Thread.java:835)\r\n'),(2728,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-08-11 07:11:17','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,通知,代码生成,接口文档,附件类别管理,人才认定申报,添加,修改,删除,海峡计划申报,海峡计划申报列表,海峡计划申报添加,海峡计划申报更新,海峡计划申报删除,海峡计划申报详情,人才津贴申报,添加,修改,导出,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,海峡计划管理,评分标准,添加,修改,删除,海峡计划申报,详情,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,修复,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,导出,生活补贴初审,审核,生活补贴兑现,导出核查征信,征信失信,征信通过,公示,公示导出,公示预览,公示再审核,公示通过,发放,审核'),(2729,'业务日志','添加字典记录',1,'com.stylefeng.guns.modular.system.controller.DictController','add','2022-08-19 13:02:41','成功','字典名称=性别,字典内容=1:男:1;2:女:2;'),(2730,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-08-21 05:27:48','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,通知,代码生成,接口文档,附件类别管理,人才认定申报,添加,修改,删除,海峡计划申报,海峡计划申报列表,海峡计划申报添加,海峡计划申报更新,海峡计划申报删除,海峡计划申报详情,人才津贴申报,添加,修改,导出,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,海峡计划管理,评分标准,添加,修改,删除,海峡计划申报,详情,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,修复,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,导出,生活补贴初审,审核,生活补贴兑现,导出核查征信,征信失信,征信通过,公示,公示导出,公示预览,公示再审核,公示通过,发放,审核'),(2731,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-08-21 05:38:46','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,通知,代码生成,接口文档,附件类别管理,人才认定申报,添加,修改,删除,海峡计划申报,海峡计划申报列表,海峡计划申报添加,海峡计划申报更新,海峡计划申报删除,海峡计划申报详情,人才津贴申报,添加,修改,导出,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,海峡计划管理,评分标准,添加,修改,删除,海峡计划申报,详情,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,修复,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,导出,生活补贴初审,审核,生活补贴兑现,导出核查征信,征信失信,征信通过,公示,公示导出,公示预览,公示再审核,公示通过,发放,审核'),(2732,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-08-21 05:41:25','成功','角色名称=超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,修改角色跳转,角色分配跳转,角色列表,菜单管理,添加菜单,修改菜单,删除菜单,菜单编辑跳转,菜单列表,业务日志,清空日志,日志列表,日志详情,监控管理,部门管理,添加部门,修改部门,删除部门,修改部门跳转,部门列表,部门详情,字典管理,添加字典,修改字典,删除字典,修改菜单跳转,字典列表,字典详情,登录日志,清空登录日志,登录日志列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,专家管理,添加,修改,删除,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,定时任务,添加,修改,删除,短信日志,重新发送,发送短信,导出,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,通知,代码生成,接口文档,附件类别管理,人才认定申报,添加,修改,删除,海峡计划申报,海峡计划申报列表,海峡计划申报添加,海峡计划申报更新,海峡计划申报删除,海峡计划申报详情,人才津贴申报,添加,修改,导出,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别删除,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,海峡计划管理,评分标准,添加,修改,删除,海峡计划申报,详情,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,主管部门审核配置,添加,部门初审,审核,导出,下载,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,部门初审,审核,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,修复,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),统计分析,数据统计,子女就学,子女择校,审核,导出,学杂费补助,审核,导出,公示预览,公示,公示再审核,公示通过,兑现,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出,培训补贴,培训补贴,审核,导出,公示,公示再审核,公示通过,兑现,撤回审核,医疗补助,医疗补助,审核,公式预览,公示,公示再审核,公示通过,兑现,导出,租房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,入住登记,登记,房租补助,房租补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,购房申请,初级审核,审核,导出,部门审核,审核,导出,复核,审核,导出,购房补助,购房补助,审核,公示预览,公示,公示再审核,公示通过,兑现,导出,硕博人才管理,生活补贴复核,审核,导出,生活补贴初审,审核,生活补贴兑现,导出核查征信,征信失信,征信通过,公示,公示导出,公示预览,公示再审核,公示通过,发放,审核'),(2733,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-08-21 06:00:21','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,角色列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2734,'业务日志','配置权限',1,'com.stylefeng.guns.modular.system.controller.RoleController','setAuthority','2022-08-21 06:02:26','成功','角色名称=晋江市优秀人才-超级管理员,资源名称=系统管理,用户管理,添加用户,修改用户,删除用户,重置密码,冻结用户,解除冻结用户,分配角色,分配角色跳转,编辑用户跳转,用户列表,角色管理,添加角色,修改角色,删除角色,配置权限,角色分配跳转,角色列表,通知管理,添加通知,修改通知,删除通知,单位管理,添加,修改,删除,查看,批次管理,批次管理列表,批次管理添加,批次管理更新,批次管理删除,批次管理详情,批次管理设置生效,短信日志,重新发送,发送短信,人才津贴配置,添加,修改,删除,企业标签配置,添加,修改,删除,用户反馈,回复,走访小组配置,新增,修改,删除,附件管理,附件类别管理,人才认定申报,添加,修改,通用附件类别,通用附件类别列表,通用附件类别添加,通用附件类别更新,通用附件类别详情,企业信息,企业用户,设置冻结,审核,删除,重置密码,导出,企业信息变更,查看详情,审核,导出,个人用户信息,查看详情,设置冻结,重置密码,人才认定管理,认定条件管理,认定条件管理列表,认定条件管理添加,认定条件管理更新,认定条件管理删除,认定条件管理详情,导入,模板下载,初级审核,审核,导出,下载,修改驳回字段,审核不通过,部门审核,审核,导出,下载,复核,审核& #40;非集成电路& #41;,导出,下载,撤销复核,预备人才库,公示,公示导出,核查征信,征信失信,公示再审核,公示通过,公布,发证,征信通过,公布导出,撤销公布,导出,下载,公示预览,公布预览,优秀人才库,优秀人才库,查看,导出,取消优秀人才,下载,恢复优秀人才,查看首次申报信息,离职申报,审核,查看,导出,下载,工作单位变更,审核,查看,导出,下载,银行账号变更,审核,查看,导出,基础信息变更,审核,导出,人才层次变更,初级审核,审核,查看,导出,下载,修改驳回字段,部门审核,审核,查看,导出,下载,复核,审核,查看,导出,下载,预备变更库,导出核查征信,征信失信,公示,公示导出,公示再审核,公示通过,公布,发证,查看,征信通过,公布导出,撤销公布,导出,下载,津补贴管理,初级审核,审核,导出基础信息,导出项目录入模板,导入项目核查结果,修改驳回字段,批量提交审核(社保局),导出社保核查结果,导出项目核查结果,查看,撤销初审,走访核查,审核,导出基础信息,导出项目录入模板,导入项目核查结果,批量提交审核,导出项目核查结果,查看,复核,审核,导出基础信息,导出项目核查结果,查看,撤销审核,预备津贴库,导出核查征信,征信失信,征信通过,公示& #40;兑现& #41;,公示再审核,公示通过,查看,公示& #40;不予兑现& #41;,兑现,导出基础信息,导出项目核查结果,公示预览(不予兑现),公示预览(兑现),子女就学,子女择校,审核,导出,购房补贴,初级审核,审核,导出,修改驳回字段,部门审核,审核,导出,公示兑现,公示(兑现),公示再审核,公示通过,兑现,导出,查看,公示(不予兑现),公示预览(兑现),公示预览(不予兑现),复核,审核,导出'),(2735,'业务日志','添加管理员',1,'com.stylefeng.guns.modular.system.controller.UserMgrController','add','2022-08-21 06:24:41','成功','账号=test');
/*!40000 ALTER TABLE `sys_operation_log` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_relation`
--

DROP TABLE IF EXISTS `sys_relation`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_relation` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键',
  `menuid` bigint(11) DEFAULT NULL COMMENT '菜单id',
  `roleid` int(11) DEFAULT NULL COMMENT '角色id',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=35735 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='角色和菜单关联表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_relation`
--

LOCK TABLES `sys_relation` WRITE;
/*!40000 ALTER TABLE `sys_relation` DISABLE KEYS */;
INSERT INTO `sys_relation` VALUES (17303,215,13),(17304,195,13),(17305,196,13),(17306,197,13),(17307,198,13),(17309,200,13),(17310,214,13),(17311,216,13),(17312,219,13),(17313,220,13),(17314,333,13),(21184,215,15),(21185,195,15),(21186,196,15),(21187,197,15),(21188,198,15),(21189,200,15),(21190,214,15),(21191,216,15),(21192,219,15),(21193,220,15),(21194,333,15),(21195,240,15),(21196,257,15),(21197,258,15),(21198,386,15),(21199,398,15),(21200,292,15),(21201,293,15),(21202,296,15),(21203,298,15),(21204,391,15),(21205,406,15),(21206,240,14),(21207,257,14),(21208,258,14),(21209,292,14),(21210,293,14),(21211,296,14),(21212,298,14),(21213,391,14),(21214,406,14),(21370,240,20),(21371,307,20),(21372,282,20),(21373,286,20),(21374,308,20),(21375,309,20),(21376,312,20),(21377,314,20),(21378,316,20),(21379,318,20),(21380,334,20),(21381,379,20),(21382,382,20),(21383,388,20),(21384,401,20),(21385,264,20),(21386,265,20),(21387,266,20),(21388,331,20),(21389,383,20),(21390,402,20),(21391,410,20),(21392,292,20),(21393,295,20),(21394,322,20),(21395,323,20),(21396,324,20),(21397,325,20),(21398,326,20),(21399,327,20),(21400,328,20),(21401,329,20),(21402,330,20),(21403,342,20),(21404,380,20),(21405,381,20),(21406,393,20),(21407,408,20),(21408,240,18),(21409,254,18),(21410,255,18),(21411,385,18),(21412,397,18),(21413,292,18),(21414,272,18),(21415,279,18),(21416,280,18),(21417,390,18),(21418,407,18),(21419,240,19),(21420,260,19),(21421,261,19),(21422,387,19),(21423,400,19),(21424,292,19),(21425,294,19),(21426,299,19),(21427,301,19),(21428,392,19),(21429,409,19),(21805,240,16),(21806,254,16),(21807,255,16),(21808,385,16),(21809,397,16),(21810,415,16),(21811,292,16),(21812,272,16),(21813,279,16),(21814,280,16),(21815,390,16),(21816,407,16),(24884,105,22),(24885,229,22),(24886,230,22),(24887,231,22),(24888,232,22),(24889,234,22),(24890,239,22),(24891,343,22),(24892,416,22),(24893,423,22),(24894,191,22),(24895,173,22),(24896,217,22),(24897,218,22),(24898,221,22),(24899,222,22),(24900,223,22),(24901,224,22),(24902,418,22),(24903,419,22),(24904,420,22),(24905,421,22),(27434,350,23),(27435,351,23),(27436,354,23),(27437,357,23),(27438,360,23),(27439,362,23),(27440,424,23),(27441,428,23),(27442,429,23),(27443,350,24),(27444,351,24),(27445,354,24),(27446,357,24),(27447,360,24),(27448,362,24),(27449,424,24),(27450,426,24),(27451,427,24),(27452,428,24),(27453,429,24),(29050,350,25),(29051,352,25),(29052,363,25),(29053,431,25),(29054,432,25),(29903,350,26),(29904,351,26),(29905,354,26),(29906,424,26),(29907,429,26),(30496,105,12),(30497,106,12),(30498,107,12),(30499,108,12),(30500,109,12),(30501,110,12),(30502,111,12),(30503,112,12),(30504,113,12),(30505,165,12),(30506,166,12),(30507,167,12),(30508,114,12),(30509,115,12),(30510,116,12),(30511,117,12),(30512,118,12),(30513,162,12),(30514,163,12),(30515,164,12),(30516,185,12),(30517,186,12),(30518,192,12),(30519,193,12),(30520,194,12),(30521,229,12),(30522,230,12),(30523,231,12),(30524,232,12),(30525,233,12),(30526,234,12),(30527,239,12),(30528,343,12),(30529,346,12),(30530,347,12),(30531,348,12),(30532,349,12),(30533,191,12),(30534,173,12),(30535,217,12),(30536,218,12),(30537,248,12),(30538,249,12),(30539,250,12),(30540,251,12),(30541,253,12),(30542,215,12),(30543,195,12),(30544,196,12),(30545,197,12),(30546,198,12),(30547,200,12),(30548,214,12),(30549,216,12),(30550,219,12),(30551,220,12),(30552,333,12),(30553,221,12),(30554,222,12),(30555,223,12),(30556,224,12),(30557,240,12),(30558,242,12),(30559,243,12),(30560,244,12),(30561,245,12),(30562,246,12),(30563,247,12),(30564,336,12),(30565,337,12),(30566,254,12),(30567,255,12),(30568,385,12),(30569,397,12),(30570,415,12),(30571,422,12),(30572,260,12),(30573,261,12),(30574,387,12),(30575,400,12),(30576,307,12),(30577,282,12),(30578,286,12),(30579,308,12),(30580,309,12),(30581,312,12),(30582,314,12),(30583,316,12),(30584,318,12),(30585,334,12),(30586,379,12),(30587,382,12),(30588,388,12),(30589,401,12),(30590,264,12),(30591,265,12),(30592,266,12),(30593,331,12),(30594,383,12),(30595,402,12),(30596,410,12),(30597,269,12),(30598,273,12),(30599,274,12),(30600,394,12),(30601,403,12),(30602,270,12),(30603,275,12),(30604,276,12),(30605,395,12),(30606,404,12),(30607,271,12),(30608,277,12),(30609,278,12),(30610,396,12),(30611,292,12),(30612,272,12),(30613,279,12),(30614,280,12),(30615,390,12),(30616,407,12),(30617,294,12),(30618,299,12),(30619,301,12),(30620,392,12),(30621,409,12),(30622,295,12),(30623,322,12),(30624,323,12),(30625,324,12),(30626,325,12),(30627,326,12),(30628,327,12),(30629,328,12),(30630,329,12),(30631,330,12),(30632,342,12),(30633,380,12),(30634,381,12),(30635,393,12),(30636,408,12),(30637,350,12),(30638,351,12),(30639,354,12),(30640,357,12),(30641,360,12),(30642,362,12),(30643,424,12),(30644,426,12),(30645,427,12),(30646,428,12),(30647,429,12),(30648,352,12),(30649,355,12),(30650,358,12),(30651,361,12),(30652,363,12),(30653,430,12),(30654,431,12),(30655,432,12),(30656,353,12),(30657,356,12),(30658,359,12),(30659,433,12),(30660,434,12),(30661,458,12),(30662,369,12),(30663,370,12),(30664,371,12),(30665,372,12),(30666,373,12),(30667,374,12),(30668,375,12),(30669,376,12),(30670,377,12),(30671,378,12),(30672,435,12),(30673,436,12),(30674,530,12),(30675,531,12),(30676,418,12),(30677,419,12),(30678,420,12),(30679,421,12),(30680,437,12),(30681,438,12),(30682,441,12),(30683,442,12),(30684,537,12),(30685,439,12),(30686,443,12),(30687,444,12),(30688,440,12),(30689,445,12),(30690,446,12),(30691,447,12),(30692,448,12),(30693,449,12),(30694,450,12),(30695,459,12),(30696,499,12),(30697,500,12),(30698,451,12),(30699,452,12),(30700,453,12),(30701,460,12),(30702,461,12),(30703,462,12),(30704,463,12),(30705,464,12),(30706,465,12),(30707,466,12),(30708,467,12),(30709,539,12),(30710,478,12),(30711,479,12),(30712,480,12),(30713,481,12),(30714,482,12),(30715,483,12),(30716,484,12),(30717,485,12),(30718,486,12),(30719,487,12),(30720,488,12),(30721,491,12),(30722,492,12),(30723,489,12),(30724,493,12),(30725,494,12),(30726,490,12),(30727,495,12),(30728,496,12),(30729,497,12),(30730,498,12),(30731,501,12),(30732,502,12),(30733,503,12),(30734,504,12),(30735,505,12),(30736,506,12),(30737,507,12),(30738,508,12),(30739,509,12),(30740,510,12),(30741,511,12),(30742,514,12),(30743,515,12),(30744,512,12),(30745,516,12),(30746,517,12),(30747,513,12),(30748,518,12),(30749,519,12),(30750,520,12),(30751,521,12),(30752,522,12),(30753,523,12),(30754,524,12),(30755,525,12),(30756,526,12),(30757,527,12),(30758,528,12),(34863,105,1),(34864,106,1),(34865,107,1),(34866,108,1),(34867,109,1),(34868,110,1),(34869,111,1),(34870,112,1),(34871,113,1),(34872,165,1),(34873,166,1),(34874,167,1),(34875,114,1),(34876,115,1),(34877,116,1),(34878,117,1),(34879,118,1),(34880,162,1),(34881,163,1),(34882,164,1),(34883,119,1),(34884,120,1),(34885,121,1),(34886,122,1),(34887,150,1),(34888,151,1),(34889,128,1),(34890,134,1),(34891,158,1),(34892,159,1),(34893,130,1),(34894,131,1),(34895,135,1),(34896,136,1),(34897,137,1),(34898,152,1),(34899,153,1),(34900,154,1),(34901,132,1),(34902,138,1),(34903,139,1),(34904,140,1),(34905,155,1),(34906,156,1),(34907,157,1),(34908,133,1),(34909,160,1),(34910,161,1),(34911,141,1),(34912,142,1),(34913,143,1),(34914,144,1),(34915,185,1),(34916,186,1),(34917,192,1),(34918,193,1),(34919,194,1),(34920,187,1),(34921,188,1),(34922,189,1),(34923,190,1),(34924,229,1),(34925,230,1),(34926,231,1),(34927,232,1),(34928,233,1),(34929,234,1),(34930,239,1),(34931,338,1),(34932,339,1),(34933,340,1),(34934,341,1),(34935,343,1),(34936,411,1),(34937,416,1),(34938,423,1),(34939,346,1),(34940,347,1),(34941,348,1),(34942,349,1),(34943,365,1),(34944,366,1),(34945,367,1),(34946,368,1),(34947,412,1),(34948,417,1),(34949,454,1),(34950,455,1),(34951,456,1),(34952,457,1),(34953,529,1),(34954,145,1),(34955,148,1),(34956,149,1),(34957,191,1),(34958,173,1),(34959,217,1),(34960,218,1),(34961,364,1),(34962,201,1),(34963,202,1),(34964,203,1),(34965,204,1),(34966,205,1),(34967,206,1),(34968,225,1),(34969,226,1),(34970,227,1),(34971,228,1),(34972,248,1),(34973,249,1),(34974,250,1),(34975,251,1),(34976,252,1),(34977,253,1),(34978,215,1),(34979,195,1),(34980,196,1),(34981,197,1),(34982,198,1),(34983,200,1),(34984,214,1),(34985,216,1),(34986,219,1),(34987,220,1),(34988,333,1),(34989,221,1),(34990,222,1),(34991,223,1),(34992,224,1),(34993,235,1),(34994,236,1),(34995,237,1),(34996,238,1),(34997,241,1),(34998,267,1),(34999,268,1),(35000,240,1),(35001,242,1),(35002,243,1),(35003,244,1),(35004,245,1),(35005,246,1),(35006,247,1),(35007,336,1),(35008,337,1),(35009,254,1),(35010,255,1),(35011,385,1),(35012,397,1),(35013,415,1),(35014,422,1),(35015,257,1),(35016,258,1),(35017,386,1),(35018,398,1),(35019,260,1),(35020,261,1),(35021,387,1),(35022,400,1),(35023,425,1),(35024,302,1),(35025,303,1),(35026,304,1),(35027,305,1),(35028,384,1),(35029,399,1),(35030,307,1),(35031,282,1),(35032,286,1),(35033,308,1),(35034,309,1),(35035,312,1),(35036,314,1),(35037,316,1),(35038,318,1),(35039,334,1),(35040,379,1),(35041,382,1),(35042,388,1),(35043,401,1),(35044,468,1),(35045,469,1),(35046,264,1),(35047,265,1),(35048,266,1),(35049,331,1),(35050,383,1),(35051,402,1),(35052,410,1),(35053,536,1),(35054,269,1),(35055,273,1),(35056,274,1),(35057,394,1),(35058,403,1),(35059,270,1),(35060,275,1),(35061,276,1),(35062,395,1),(35063,404,1),(35064,271,1),(35065,277,1),(35066,278,1),(35067,396,1),(35068,533,1),(35069,534,1),(35070,535,1),(35071,292,1),(35072,272,1),(35073,279,1),(35074,280,1),(35075,390,1),(35076,407,1),(35077,532,1),(35078,293,1),(35079,296,1),(35080,298,1),(35081,391,1),(35082,406,1),(35083,294,1),(35084,299,1),(35085,301,1),(35086,392,1),(35087,409,1),(35088,295,1),(35089,322,1),(35090,323,1),(35091,324,1),(35092,325,1),(35093,326,1),(35094,327,1),(35095,328,1),(35096,329,1),(35097,330,1),(35098,342,1),(35099,380,1),(35100,381,1),(35101,393,1),(35102,408,1),(35103,320,1),(35104,321,1),(35105,389,1),(35106,405,1),(35107,350,1),(35108,351,1),(35109,354,1),(35110,357,1),(35111,360,1),(35112,362,1),(35113,424,1),(35114,426,1),(35115,427,1),(35116,428,1),(35117,429,1),(35118,538,1),(35119,352,1),(35120,355,1),(35121,358,1),(35122,361,1),(35123,363,1),(35124,430,1),(35125,431,1),(35126,432,1),(35127,353,1),(35128,356,1),(35129,359,1),(35130,433,1),(35131,434,1),(35132,458,1),(35133,540,1),(35134,369,1),(35135,370,1),(35136,371,1),(35137,372,1),(35138,373,1),(35139,374,1),(35140,375,1),(35141,376,1),(35142,377,1),(35143,378,1),(35144,435,1),(35145,436,1),(35146,530,1),(35147,531,1),(35148,413,1),(35149,414,1),(35150,418,1),(35151,419,1),(35152,420,1),(35153,421,1),(35154,470,1),(35155,471,1),(35156,472,1),(35157,473,1),(35158,474,1),(35159,475,1),(35160,476,1),(35161,477,1),(35162,437,1),(35163,438,1),(35164,441,1),(35165,442,1),(35166,537,1),(35167,439,1),(35168,443,1),(35169,444,1),(35170,440,1),(35171,445,1),(35172,446,1),(35173,447,1),(35174,448,1),(35175,449,1),(35176,450,1),(35177,459,1),(35178,499,1),(35179,500,1),(35180,451,1),(35181,452,1),(35182,453,1),(35183,460,1),(35184,461,1),(35185,462,1),(35186,463,1),(35187,464,1),(35188,465,1),(35189,466,1),(35190,467,1),(35191,539,1),(35192,478,1),(35193,479,1),(35194,480,1),(35195,481,1),(35196,482,1),(35197,483,1),(35198,484,1),(35199,485,1),(35200,486,1),(35201,487,1),(35202,488,1),(35203,491,1),(35204,492,1),(35205,489,1),(35206,493,1),(35207,494,1),(35208,490,1),(35209,495,1),(35210,496,1),(35211,497,1),(35212,498,1),(35213,501,1),(35214,502,1),(35215,503,1),(35216,504,1),(35217,505,1),(35218,506,1),(35219,507,1),(35220,508,1),(35221,509,1),(35222,510,1),(35223,511,1),(35224,514,1),(35225,515,1),(35226,512,1),(35227,516,1),(35228,517,1),(35229,513,1),(35230,518,1),(35231,519,1),(35232,520,1),(35233,521,1),(35234,522,1),(35235,523,1),(35236,524,1),(35237,525,1),(35238,526,1),(35239,527,1),(35240,528,1),(35241,541,1),(35242,542,1),(35243,546,1),(35244,557,1),(35245,544,1),(35246,545,1),(35247,547,1),(35248,548,1),(35249,549,1),(35250,550,1),(35251,551,1),(35252,552,1),(35253,553,1),(35254,554,1),(35255,555,1),(35256,556,1),(35257,543,1),(35496,105,9),(35497,106,9),(35498,107,9),(35499,108,9),(35500,109,9),(35501,110,9),(35502,111,9),(35503,112,9),(35504,113,9),(35505,165,9),(35506,166,9),(35507,167,9),(35508,114,9),(35509,115,9),(35510,116,9),(35511,117,9),(35512,118,9),(35513,163,9),(35514,164,9),(35515,141,9),(35516,142,9),(35517,143,9),(35518,144,9),(35519,185,9),(35520,186,9),(35521,192,9),(35522,193,9),(35523,194,9),(35524,229,9),(35525,230,9),(35526,231,9),(35527,232,9),(35528,233,9),(35529,234,9),(35530,239,9),(35531,343,9),(35532,411,9),(35533,416,9),(35534,346,9),(35535,347,9),(35536,348,9),(35537,349,9),(35538,365,9),(35539,366,9),(35540,367,9),(35541,368,9),(35542,412,9),(35543,417,9),(35544,454,9),(35545,455,9),(35546,456,9),(35547,457,9),(35548,529,9),(35549,191,9),(35550,173,9),(35551,217,9),(35552,218,9),(35553,248,9),(35554,249,9),(35555,250,9),(35556,251,9),(35557,253,9),(35558,215,9),(35559,195,9),(35560,196,9),(35561,197,9),(35562,198,9),(35563,200,9),(35564,214,9),(35565,216,9),(35566,219,9),(35567,220,9),(35568,333,9),(35569,221,9),(35570,222,9),(35571,223,9),(35572,224,9),(35573,240,9),(35574,242,9),(35575,243,9),(35576,244,9),(35577,245,9),(35578,246,9),(35579,247,9),(35580,336,9),(35581,337,9),(35582,254,9),(35583,255,9),(35584,385,9),(35585,397,9),(35586,415,9),(35587,422,9),(35588,257,9),(35589,258,9),(35590,386,9),(35591,398,9),(35592,260,9),(35593,261,9),(35594,387,9),(35595,400,9),(35596,425,9),(35597,307,9),(35598,282,9),(35599,286,9),(35600,308,9),(35601,309,9),(35602,312,9),(35603,314,9),(35604,316,9),(35605,318,9),(35606,334,9),(35607,379,9),(35608,382,9),(35609,388,9),(35610,401,9),(35611,468,9),(35612,469,9),(35613,264,9),(35614,265,9),(35615,266,9),(35616,331,9),(35617,383,9),(35618,402,9),(35619,410,9),(35620,536,9),(35621,269,9),(35622,273,9),(35623,274,9),(35624,394,9),(35625,403,9),(35626,270,9),(35627,275,9),(35628,276,9),(35629,395,9),(35630,404,9),(35631,271,9),(35632,277,9),(35633,278,9),(35634,396,9),(35635,533,9),(35636,534,9),(35637,535,9),(35638,292,9),(35639,272,9),(35640,279,9),(35641,280,9),(35642,390,9),(35643,407,9),(35644,532,9),(35645,293,9),(35646,296,9),(35647,298,9),(35648,391,9),(35649,406,9),(35650,294,9),(35651,299,9),(35652,301,9),(35653,392,9),(35654,409,9),(35655,295,9),(35656,322,9),(35657,323,9),(35658,324,9),(35659,325,9),(35660,326,9),(35661,327,9),(35662,328,9),(35663,329,9),(35664,330,9),(35665,342,9),(35666,380,9),(35667,381,9),(35668,393,9),(35669,408,9),(35670,350,9),(35671,351,9),(35672,354,9),(35673,357,9),(35674,360,9),(35675,362,9),(35676,424,9),(35677,426,9),(35678,427,9),(35679,428,9),(35680,429,9),(35681,538,9),(35682,352,9),(35683,355,9),(35684,358,9),(35685,361,9),(35686,363,9),(35687,430,9),(35688,431,9),(35689,432,9),(35690,353,9),(35691,356,9),(35692,359,9),(35693,433,9),(35694,434,9),(35695,458,9),(35696,369,9),(35697,370,9),(35698,371,9),(35699,372,9),(35700,373,9),(35701,374,9),(35702,375,9),(35703,376,9),(35704,377,9),(35705,378,9),(35706,435,9),(35707,436,9),(35708,530,9),(35709,531,9),(35710,418,9),(35711,419,9),(35712,420,9),(35713,421,9),(35714,437,9),(35715,438,9),(35716,441,9),(35717,442,9),(35718,537,9),(35719,439,9),(35720,443,9),(35721,444,9),(35722,440,9),(35723,445,9),(35724,446,9),(35725,447,9),(35726,448,9),(35727,449,9),(35728,450,9),(35729,459,9),(35730,499,9),(35731,500,9),(35732,451,9),(35733,452,9),(35734,453,9);
/*!40000 ALTER TABLE `sys_relation` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_role`
--

DROP TABLE IF EXISTS `sys_role`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_role` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `num` int(11) DEFAULT NULL COMMENT '序号',
  `pid` int(11) DEFAULT NULL COMMENT '父角色id',
  `name` varchar(255) DEFAULT NULL COMMENT '角色名称',
  `deptid` int(11) DEFAULT NULL COMMENT '部门名称',
  `tips` varchar(255) DEFAULT NULL COMMENT '提示',
  `version` int(11) DEFAULT NULL COMMENT '保留字段(暂时没用）',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=27 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='角色表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_role`
--

LOCK TABLES `sys_role` WRITE;
/*!40000 ALTER TABLE `sys_role` DISABLE KEYS */;
INSERT INTO `sys_role` VALUES (1,1,0,'超级管理员',24,'administrator',1),(9,2,1,'晋江市优秀人才-超级管理员',0,'晋江市优秀人才-超级管理员',NULL),(12,1,1,'集成电路-超级管理员',NULL,'集成电路-超级管理员',NULL),(13,1,9,'企业账号审核',NULL,'企业账号审核',NULL),(14,2,9,'优秀人才认定部门审核',NULL,'优秀人才认定-部门审核',NULL),(15,3,9,'优秀人才-企业注册兼部门审核',NULL,'优秀人才-企业注册兼部门审核',NULL),(16,5,9,'晋江市优秀人才-初审',NULL,'晋江市优秀人才-初审',NULL),(17,6,9,'晋江市优秀人才-复核',NULL,'晋江市优秀人才-复核',NULL),(18,1,12,'集成电路-初审',NULL,'集成电路-初审',NULL),(19,2,12,'集成电路-复核',NULL,'集成电路-复核',NULL),(20,3,12,'集成电路-人才库',NULL,'集成电路-人才库',NULL),(21,10,9,'街道办事员',NULL,'街道办事员',NULL),(22,NULL,1,'子女就学',NULL,'子女就学',NULL),(23,NULL,1,'津补贴初审-税务',NULL,'津补贴初审-税务',NULL),(24,NULL,1,'津补贴初审-社保',NULL,'津补贴初审-社保',NULL),(25,NULL,9,'走访核查小组',NULL,'走访小组',NULL),(26,10,9,'晋江市优秀人才-津补贴初审',NULL,'晋江市优秀人才-津补贴初审',NULL);
/*!40000 ALTER TABLE `sys_role` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_schedule`
--

DROP TABLE IF EXISTS `sys_schedule`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_schedule` (
  `id` varchar(40) NOT NULL,
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `url` varchar(100) DEFAULT NULL COMMENT '请求url',
  `timeStr` varchar(100) DEFAULT NULL COMMENT '时间设置',
  `state` tinyint(1) DEFAULT NULL COMMENT '状态',
  `description` varchar(255) DEFAULT NULL COMMENT '说明',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='定时任务';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_schedule`
--

LOCK TABLES `sys_schedule` WRITE;
/*!40000 ALTER TABLE `sys_schedule` DISABLE KEYS */;
INSERT INTO `sys_schedule` VALUES ('1186101983469883393','checkTalentInfoEffect','https://rc.jucai.gov.cn/api/talentSchedule/checkTalentInfoEffect','0 0 4  * * ?',1,'检查人才认定是否过期',NULL,NULL,NULL,NULL),('1187532545879326721','checkEnterpriseNeedCheck','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseNeedCheck','0 0 9 ? * MON-FRI',1,'统计企业注册待审核的数据',NULL,NULL,NULL,NULL),('1211200622632742914','checkEnterpriseChangeNeedCheck','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseChangeNeedCheck','0 0 9 ? * MON-FRI',1,'企业信息变更待审核数据统计',NULL,NULL,NULL,NULL),('1235141655871471618','checkTalentInfoNeedDepCheck','https://rc.jucai.gov.cn/api/talentSchedule/checkTalentInfoNeedDepCheck','0 0 9 ? * MON-FRI',1,'统计人才认定部门审核数据',NULL,NULL,NULL,NULL),('1241967338220195842','checkEnterpriseIdentifyNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseIdentifyNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业被驳回数据并短信通知',NULL,NULL,NULL,NULL),('1287945875582124033','checkIdentifyOutTimeWarn','https://rc.jucai.gov.cn/api/talentSchedule/identifyOutTimeWarn','0 0 9 * * ?',1,'检测人才证书过期(前三个月短信提醒)',NULL,NULL,NULL,NULL),('1293218558511177729','checkEnterpriseAllowanceNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseAllowanceNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业津补贴驳回并短信提醒',NULL,NULL,NULL,NULL),('1293743874035941377','checkEnterpriseTypeChangeNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseTypeChangeNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业被驳回的人才层次变更申报并短信通知',NULL,NULL,NULL,NULL),('1293744149882732546','checkEnterpriseQuitNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseQuitNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业被驳回的离职变更数据并短信通知',NULL,NULL,NULL,NULL),('1293744381806772226','checkEnterpriseUnitChangeNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseUnitChangeNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业被驳回的工作单位变更申报并短信通知',NULL,NULL,NULL,NULL),('1293744574249828353','checkEnterpriseBankChangeNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseBankChangeNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业被驳回的银行账号变更并短信通知',NULL,NULL,NULL,NULL),('1293744827850031105','checkEnterpriseBasicChangeNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseBasicChangeNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业被驳回人才基础信息变更并短信通知',NULL,NULL,NULL,NULL),('1315542971394863106','checkEnterpriseHousePurchaseNeedEdit','https://rc.jucai.gov.cn/api/talentSchedule/checkEnterpriseHousePurchaseNeedEdit','0 0 9 ? * MON-FRI',1,'统计各企业购房补贴被驳回数量并短信通知',NULL,NULL,NULL,NULL),('1437585705764155393','checkTalentTypeChangeNeedDepCheck','https://rc.jucai.gov.cn/api/talentSchedule/checkTalentTypeChangeNeedDepCheck','0 17 9 ? * MON-FRI',1,'统计人才层次变更待部门审核并短信通知',NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `sys_schedule` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_score`
--

DROP TABLE IF EXISTS `sys_score`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_score` (
  `id` varchar(30) NOT NULL COMMENT '唯一标志',
  `parentId` varchar(30) DEFAULT NULL COMMENT '父级Id',
  `sname` varchar(100) DEFAULT NULL COMMENT '名称',
  `stage` varchar(255) DEFAULT NULL COMMENT '评审阶段(1-函审，2-现场评审）',
  `score` int(11) DEFAULT NULL COMMENT '分值（父级分值=子类分值总和）',
  `level` tinyint(4) DEFAULT NULL COMMENT '层级',
  `sort` tinyint(4) DEFAULT NULL COMMENT '排序',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='评分管理⁮表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_score`
--

LOCK TABLES `sys_score` WRITE;
/*!40000 ALTER TABLE `sys_score` DISABLE KEYS */;
/*!40000 ALTER TABLE `sys_score` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_task`
--

DROP TABLE IF EXISTS `sys_task`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_task` (
  `id` varchar(40) NOT NULL COMMENT '主键',
  `userId` varchar(40) DEFAULT NULL COMMENT '用户id',
  `type` tinyint(2) DEFAULT NULL COMMENT '事件类型',
  `active` tinyint(2) DEFAULT NULL COMMENT '是否已读',
  `description` varchar(255) DEFAULT NULL COMMENT '说明',
  `createTime` varchar(40) DEFAULT NULL,
  `createUser` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='待办事项';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_task`
--

LOCK TABLES `sys_task` WRITE;
/*!40000 ALTER TABLE `sys_task` DISABLE KEYS */;
INSERT INTO `sys_task` VALUES ('1187537008023269378','52',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:11:00',NULL,NULL,NULL),('1187537008023269379','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:11:00',NULL,NULL,NULL),('1187538561375342593','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:17:10',NULL,NULL,NULL),('1187540766455209985','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:25:56',NULL,NULL,NULL),('1187540766467792897','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:25:56',NULL,NULL,NULL),('1187540781307240449','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:26:00',NULL,NULL,NULL),('1187540802354257922','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:26:05',NULL,NULL,NULL),('1187542682463571970','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:33:33',NULL,NULL,NULL),('1187542693586866178','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:33:36',NULL,NULL,NULL),('1187542710443773954','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:33:40',NULL,NULL,NULL),('1187542740756008961','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:33:47',NULL,NULL,NULL),('1187542740772786178','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:33:47',NULL,NULL,NULL),('1187542753796100097','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:33:50',NULL,NULL,NULL),('1187542753800294401','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:33:50',NULL,NULL,NULL),('1187542775874916353','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:33:55',NULL,NULL,NULL),('1187542775887499265','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:33:55',NULL,NULL,NULL),('1187545187746480129','52',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:43:30',NULL,NULL,NULL),('1187545187759063042','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:43:30',NULL,NULL,NULL),('1187545187759063043','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:43:30',NULL,NULL,NULL),('1187545208357289985','52',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:43:35',NULL,NULL,NULL),('1187545208374067202','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:43:35',NULL,NULL,NULL),('1187545208378261505','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:43:35',NULL,NULL,NULL),('1187548591268982786','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:57:01',NULL,NULL,NULL),('1187548591281565698','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:57:01',NULL,NULL,NULL),('1187548605470896130','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 09:57:05',NULL,NULL,NULL),('1187548605483479041','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:57:05',NULL,NULL,NULL),('1187548624664031234','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 09:57:10',NULL,NULL,NULL),('1187626578786045954','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 15:06:55',NULL,NULL,NULL),('1187626596712501250','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 15:07:00',NULL,NULL,NULL),('1187626618124423169','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 15:07:05',NULL,NULL,NULL),('1187627459178901506','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 15:10:25',NULL,NULL,NULL),('1187627459199873026','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 15:10:25',NULL,NULL,NULL),('1187628423155789826','53',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-10-25 15:14:15',NULL,NULL,NULL),('1187628423168372737','54',1,1,'您有4条企业注册信息待审核，请及时审核！','2019-10-25 15:14:15',NULL,NULL,NULL),('1201852817491025922','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:15:36',NULL,NULL,NULL),('1201853109116788737','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:17:43',NULL,NULL,NULL),('1201853116536512514','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:17:43',NULL,NULL,NULL),('1201853236246142977','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:18:05',NULL,NULL,NULL),('1201853293078962178','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:18:42',NULL,NULL,NULL),('1201853301144608770','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:18:49',NULL,NULL,NULL),('1201853495798063106','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:19:00',NULL,NULL,NULL),('1201853507680526337','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:19:40',NULL,NULL,NULL),('1201853591549829122','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-03 21:20:00',NULL,NULL,NULL),('1202028077754601473','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-04 08:53:20',NULL,NULL,NULL),('1202028077762990081','61',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-04 08:53:20',NULL,NULL,NULL),('1202028077767184386','62',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-04 08:53:20',NULL,NULL,NULL),('1204680469037395969','63',1,1,'您有1条企业注册信息待审核，请及时审核！','2019-12-11 16:33:00',NULL,NULL,NULL),('1204680469037395970','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2019-12-11 16:33:00',NULL,NULL,NULL),('1204680469037395971','61',1,1,'您有3条企业注册信息待审核，请及时审核！','2019-12-11 16:33:00',NULL,NULL,NULL),('1204680469037395972','62',1,1,'您有3条企业注册信息待审核，请及时审核！','2019-12-11 16:33:00',NULL,NULL,NULL),('1211451857063428098','64',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857076011009','69',1,1,'您有1条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857076011010','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857080205313','70',1,1,'您有1条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857080205314','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857096982529','58',1,1,'您有36条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857096982530','61',1,1,'您有36条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857101176833','62',1,1,'您有36条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1211451857105371137','74',1,1,'您有36条企业注册信息待审核，请及时审核！','2019-12-30 09:00:05',NULL,NULL,NULL),('1212539021209702401','69',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021213896706','70',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021218091010','71',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021218091011','58',1,1,'您有59条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021222285314','61',1,1,'您有59条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021226479617','62',1,1,'您有59条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021226479618','73',1,1,'您有59条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021230673921','74',1,1,'您有59条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021230673922','87',1,1,'您有59条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212539021234868225','89',1,1,'您有59条企业注册信息待审核，请及时审核！','2020-01-02 09:00:05',NULL,NULL,NULL),('1212901408500682754','64',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408504877058','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408504877059','58',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408504877060','61',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408504877061','62',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408504877062','73',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408509071361','74',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408509071362','87',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408513265665','89',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1212901408513265666','90',1,1,'您有49条企业注册信息待审核，请及时审核！','2020-01-03 09:00:05',NULL,NULL,NULL),('1214713348394934273','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348394934274','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348403322881','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348403322882','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348403322883','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348407517186','89',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348407517187','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214713348407517188','90',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-01-08 09:00:05',NULL,NULL,NULL),('1214803944761548801','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-08 15:00:05',NULL,NULL,NULL),('1214803944765743105','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-01-08 15:00:05',NULL,NULL,NULL),('1214803944765743106','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-01-08 15:00:05',NULL,NULL,NULL),('1215075736344379394','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-09 09:00:05',NULL,NULL,NULL),('1215075736352768001','58',1,1,'您有11条企业注册信息待审核，请及时审核！','2020-01-09 09:00:05',NULL,NULL,NULL),('1215075736352768002','87',1,1,'您有11条企业注册信息待审核，请及时审核！','2020-01-09 09:00:05',NULL,NULL,NULL),('1215166332555804673','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-09 15:00:05',NULL,NULL,NULL),('1215166332559998978','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-09 15:00:05',NULL,NULL,NULL),('1215166332564193282','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-09 15:00:05',NULL,NULL,NULL),('1215438123622776834','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-10 09:00:05',NULL,NULL,NULL),('1215438123626971137','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-01-10 09:00:05',NULL,NULL,NULL),('1215438123631165441','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-01-10 09:00:05',NULL,NULL,NULL),('1215528720366878721','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-10 15:00:05',NULL,NULL,NULL),('1215528720366878722','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-10 15:00:05',NULL,NULL,NULL),('1215528720371073025','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-10 15:00:05',NULL,NULL,NULL),('1215528720371073026','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-10 15:00:05',NULL,NULL,NULL),('1216525287576072194','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-13 09:00:05',NULL,NULL,NULL),('1216525287576072195','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-13 09:00:05',NULL,NULL,NULL),('1216525287576072196','58',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-01-13 09:00:05',NULL,NULL,NULL),('1216525287576072197','87',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-01-13 09:00:05',NULL,NULL,NULL),('1216887675164839938','69',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-14 09:00:05',NULL,NULL,NULL),('1216887675185811457','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-14 09:00:05',NULL,NULL,NULL),('1216887675185811458','70',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-14 09:00:05',NULL,NULL,NULL),('1216887675190005761','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-14 09:00:05',NULL,NULL,NULL),('1216887675190005762','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-14 09:00:05',NULL,NULL,NULL),('1217250062766198785','71',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-15 09:00:05',NULL,NULL,NULL),('1217250062770393090','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-15 09:00:05',NULL,NULL,NULL),('1217250062770393091','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-15 09:00:05',NULL,NULL,NULL),('1217612450870919169','71',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-16 09:00:05',NULL,NULL,NULL),('1217612450879307778','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-16 09:00:05',NULL,NULL,NULL),('1217612450879307779','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-16 09:00:05',NULL,NULL,NULL),('1217974838468083714','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-17 09:00:05',NULL,NULL,NULL),('1217974838472278018','71',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-01-17 09:00:05',NULL,NULL,NULL),('1217974838476472322','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-17 09:00:05',NULL,NULL,NULL),('1217974838476472323','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-17 09:00:05',NULL,NULL,NULL),('1218702634337296386','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-19 09:12:05',NULL,NULL,NULL),('1218702634345684994','58',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-19 09:12:05',NULL,NULL,NULL),('1218702634349879298','87',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-19 09:12:05',NULL,NULL,NULL),('1219062002106884098','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-20 09:00:05',NULL,NULL,NULL),('1219062002106884099','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-20 09:00:05',NULL,NULL,NULL),('1219062002106884100','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-20 09:00:05',NULL,NULL,NULL),('1219062002106884101','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-01-20 09:00:05',NULL,NULL,NULL),('1219442761191702530','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-21 10:13:05',NULL,NULL,NULL),('1219442761200091137','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-21 10:13:05',NULL,NULL,NULL),('1219786778131578881','72',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-01-22 09:00:05',NULL,NULL,NULL),('1219786778139967490','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-22 09:00:05',NULL,NULL,NULL),('1219786778139967491','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-01-22 09:00:05',NULL,NULL,NULL),('1220149165758103554','58',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-23 09:00:05',NULL,NULL,NULL),('1220149165762297857','87',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-01-23 09:00:05',NULL,NULL,NULL),('1220511553581760514','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-24 09:00:05',NULL,NULL,NULL),('1220511553585954817','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-24 09:00:05',NULL,NULL,NULL),('1221598717375692802','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-27 09:00:05',NULL,NULL,NULL),('1221598717384081409','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-27 09:00:05',NULL,NULL,NULL),('1221961105023188994','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-28 09:00:05',NULL,NULL,NULL),('1221961105023188995','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-28 09:00:05',NULL,NULL,NULL),('1222323493123670018','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-29 09:00:05',NULL,NULL,NULL),('1222323493127864322','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-29 09:00:05',NULL,NULL,NULL),('1222685880737611777','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-30 09:00:05',NULL,NULL,NULL),('1222685880741806081','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-30 09:00:05',NULL,NULL,NULL),('1223048268657737729','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-31 09:00:05',NULL,NULL,NULL),('1223048268661932033','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-01-31 09:00:05',NULL,NULL,NULL),('1224135432380366850','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-03 09:00:05',NULL,NULL,NULL),('1224135432384561154','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-03 09:00:05',NULL,NULL,NULL),('1224497820082388993','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-04 09:00:05',NULL,NULL,NULL),('1224497820086583297','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-04 09:00:05',NULL,NULL,NULL),('1224860208208035841','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-05 09:00:05',NULL,NULL,NULL),('1224860208212230146','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-05 09:00:05',NULL,NULL,NULL),('1225222595801006082','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-06 09:00:05',NULL,NULL,NULL),('1225222595805200386','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-06 09:00:05',NULL,NULL,NULL),('1225584984530665473','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-07 09:00:05',NULL,NULL,NULL),('1225584984530665474','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-02-07 09:00:05',NULL,NULL,NULL),('1225584984543248385','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-07 09:00:05',NULL,NULL,NULL),('1225584984543248386','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-02-07 09:00:05',NULL,NULL,NULL),('1227759311715954690','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-13 09:00:05',NULL,NULL,NULL),('1227759311715954691','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-13 09:00:05',NULL,NULL,NULL),('1228121698746888194','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-14 09:00:05',NULL,NULL,NULL),('1228121698746888195','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-14 09:00:05',NULL,NULL,NULL),('1229208862343688194','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-17 09:00:05',NULL,NULL,NULL),('1229208862352076801','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-17 09:00:05',NULL,NULL,NULL),('1229571250167345153','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-18 09:00:05',NULL,NULL,NULL),('1229571250175733762','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-18 09:00:05',NULL,NULL,NULL),('1229933638058110978','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-02-19 09:00:05',NULL,NULL,NULL),('1229933638062305282','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-02-19 09:00:05',NULL,NULL,NULL),('1229933638062305283','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-02-19 09:00:05',NULL,NULL,NULL),('1230296025969848322','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-20 09:00:05',NULL,NULL,NULL),('1230296025974042626','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-20 09:00:05',NULL,NULL,NULL),('1230658413835448321','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-21 09:00:05',NULL,NULL,NULL),('1230658413839642625','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-21 09:00:05',NULL,NULL,NULL),('1231745577365139458','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-24 09:00:05',NULL,NULL,NULL),('1231745577369333762','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-02-24 09:00:05',NULL,NULL,NULL),('1232107965285265409','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-02-25 09:00:05',NULL,NULL,NULL),('1232107965289459713','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-02-25 09:00:05',NULL,NULL,NULL),('1232107965289459714','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-02-25 09:00:05',NULL,NULL,NULL),('1232470353184419841','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-02-26 09:00:05',NULL,NULL,NULL),('1232470353184419842','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-02-26 09:00:05',NULL,NULL,NULL),('1232470353184419843','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-02-26 09:00:05',NULL,NULL,NULL),('1240805275296927746','83',5,1,'您有199条人才认定信息尚未审核，请及时审核','2020-03-20 09:00:05',NULL,NULL,NULL),('1240805275301122049','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-03-20 09:00:05',NULL,NULL,NULL),('1240805275309510657','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-03-20 09:00:05',NULL,NULL,NULL),('1240805275309510658','86',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-03-20 09:00:05',NULL,NULL,NULL),('1240805275376619521','58',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-03-20 09:00:05',NULL,NULL,NULL),('1240805275389202433','87',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-03-20 09:00:05',NULL,NULL,NULL),('1241892437660602369','83',5,1,'您有222条人才认定信息尚未审核，请及时审核','2020-03-23 09:00:05',NULL,NULL,NULL),('1241892437681573890','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-03-23 09:00:05',NULL,NULL,NULL),('1241892437685768194','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-03-23 09:00:05',NULL,NULL,NULL),('1242254826335649794','83',5,1,'您有186条人才认定信息尚未审核，请及时审核','2020-03-24 09:00:05',NULL,NULL,NULL),('1242254826335649795','86',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-03-24 09:00:05',NULL,NULL,NULL),('1242254826344038401','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-03-24 09:00:05',NULL,NULL,NULL),('1242254826356621314','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-03-24 09:00:05',NULL,NULL,NULL),('1242617213756710913','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-25 09:00:05',NULL,NULL,NULL),('1242617213760905217','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-25 09:00:05',NULL,NULL,NULL),('1242617213786071041','83',5,1,'您有173条人才认定信息尚未审核，请及时审核','2020-03-25 09:00:05',NULL,NULL,NULL),('1242617213790265346','86',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-03-25 09:00:05',NULL,NULL,NULL),('1242979601236434946','83',5,1,'您有133条人才认定信息尚未审核，请及时审核','2020-03-26 09:00:05',NULL,NULL,NULL),('1242979601249017858','86',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-03-26 09:00:05',NULL,NULL,NULL),('1242979601286766594','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-26 09:00:05',NULL,NULL,NULL),('1242979601290960898','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-26 09:00:05',NULL,NULL,NULL),('1243341989139783682','70',5,1,'您有11条人才认定信息尚未审核，请及时审核','2020-03-27 09:00:05',NULL,NULL,NULL),('1243341989148172289','76',5,1,'您有11条人才认定信息尚未审核，请及时审核','2020-03-27 09:00:05',NULL,NULL,NULL),('1243341989148172290','83',5,1,'您有60条人才认定信息尚未审核，请及时审核','2020-03-27 09:00:05',NULL,NULL,NULL),('1243341989148172291','86',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-03-27 09:00:05',NULL,NULL,NULL),('1243341989152366594','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-27 09:00:05',NULL,NULL,NULL),('1243341989160755202','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-27 09:00:05',NULL,NULL,NULL),('1244791540962918402','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-03-31 09:00:05',NULL,NULL,NULL),('1244791540962918403','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-31 09:00:05',NULL,NULL,NULL),('1244791540967112705','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-03-31 09:00:05',NULL,NULL,NULL),('1244791540967112706','76',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-03-31 09:00:05',NULL,NULL,NULL),('1244791540967112707','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-03-31 09:00:05',NULL,NULL,NULL),('1244791540971307009','84',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-03-31 09:00:05',NULL,NULL,NULL),('1245153928425865218','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-04-01 09:00:05',NULL,NULL,NULL),('1245153928430059522','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-01 09:00:05',NULL,NULL,NULL),('1245153928430059523','84',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-01 09:00:05',NULL,NULL,NULL),('1245153928497168386','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-04-01 09:00:05',NULL,NULL,NULL),('1245153928497168387','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-04-01 09:00:05',NULL,NULL,NULL),('1245516316413100034','83',5,1,'您有15条人才认定信息尚未审核，请及时审核','2020-04-02 09:00:05',NULL,NULL,NULL),('1245516316417294338','84',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-02 09:00:05',NULL,NULL,NULL),('1245516316484403202','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-04-02 09:00:05',NULL,NULL,NULL),('1245516316488597506','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-04-02 09:00:05',NULL,NULL,NULL),('1247690644034490370','83',5,1,'您有27条人才认定信息尚未审核，请及时审核','2020-04-08 09:00:05',NULL,NULL,NULL),('1247690644051267586','84',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-08 09:00:05',NULL,NULL,NULL),('1247690644118376449','91',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-08 09:00:05',NULL,NULL,NULL),('1247690644126765058','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-08 09:00:05',NULL,NULL,NULL),('1247690644126765059','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-08 09:00:05',NULL,NULL,NULL),('1248053031329665025','70',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031338053634','76',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031338053635','83',5,1,'您有50条人才认定信息尚未审核，请及时审核','2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031338053636','84',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031338053637','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031413551106','91',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031413551107','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-09 09:00:05',NULL,NULL,NULL),('1248053031413551108','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-09 09:00:05',NULL,NULL,NULL),('1248415419237208066','76',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-10 09:00:05',NULL,NULL,NULL),('1248415419241402369','83',5,1,'您有49条人才认定信息尚未审核，请及时审核','2020-04-10 09:00:05',NULL,NULL,NULL),('1248415419241402370','84',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-10 09:00:05',NULL,NULL,NULL),('1248415419266568193','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-04-10 09:00:05',NULL,NULL,NULL),('1248415419291734018','91',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-10 09:00:05',NULL,NULL,NULL),('1248415419295928321','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-10 09:00:05',NULL,NULL,NULL),('1248415419295928322','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-04-10 09:00:05',NULL,NULL,NULL),('1252428844099534850','83',5,1,'您有10条人才认定信息尚未审核，请及时审核','2020-04-21 10:48:00',NULL,NULL,NULL),('1252428844103729154','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-21 10:48:00',NULL,NULL,NULL),('1252428844107923457','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-04-21 10:48:00',NULL,NULL,NULL),('1252764052711636994','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-04-22 09:00:00',NULL,NULL,NULL),('1252764052715831298','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-22 09:00:00',NULL,NULL,NULL),('1252764052724219905','86',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-04-22 09:00:00',NULL,NULL,NULL),('1253126440577236994','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-04-23 09:00:00',NULL,NULL,NULL),('1253126440585625601','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-23 09:00:00',NULL,NULL,NULL),('1253488828300230658','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-04-24 09:00:00',NULL,NULL,NULL),('1253488828304424961','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-24 09:00:00',NULL,NULL,NULL),('1254575991972528129','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-04-27 09:00:00',NULL,NULL,NULL),('1254575991976722434','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-27 09:00:00',NULL,NULL,NULL),('1254938379922014210','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-04-28 09:00:00',NULL,NULL,NULL),('1254938379930402818','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-28 09:00:00',NULL,NULL,NULL),('1255300767661785089','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-04-29 09:00:00',NULL,NULL,NULL),('1255300767665979394','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-29 09:00:00',NULL,NULL,NULL),('1255663155628048386','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-04-30 09:00:00',NULL,NULL,NULL),('1255663155632242690','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-04-30 09:00:00',NULL,NULL,NULL),('1256025543887872002','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543896260610','91',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543900454913','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543900454914','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543908843521','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543913037826','91',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543917232130','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-01 09:00:00',NULL,NULL,NULL),('1256025543921426433','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-01 09:00:00',NULL,NULL,NULL),('1257112707098796033','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707102990338','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707153321985','91',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707157516290','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707157516291','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707174293506','91',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707178487810','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-04 09:00:00',NULL,NULL,NULL),('1257112707182682114','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-04 09:00:00',NULL,NULL,NULL),('1257475094985367553','91',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-05 09:00:00',NULL,NULL,NULL),('1257475094985367554','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-05 09:00:00',NULL,NULL,NULL),('1257475094985367555','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-05 09:00:00',NULL,NULL,NULL),('1257475094985367556','91',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-05 09:00:00',NULL,NULL,NULL),('1257475094985367557','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-05 09:00:00',NULL,NULL,NULL),('1257475094985367558','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-05 09:00:00',NULL,NULL,NULL),('1257475094985367560','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-05-05 09:00:00',NULL,NULL,NULL),('1257475094985367561','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-05-05 09:00:00',NULL,NULL,NULL),('1257837482725138433','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482725138434','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482800635905','91',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482800635906','91',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482800635907','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482800635908','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482800635909','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-05-06 09:00:00',NULL,NULL,NULL),('1257837482800635910','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-06 09:00:00',NULL,NULL,NULL),('1258199870624292865','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870628487170','84',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870645264385','91',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870649458689','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870649458690','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870691401729','91',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870695596033','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-07 09:00:00',NULL,NULL,NULL),('1258199870695596034','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-07 09:00:00',NULL,NULL,NULL),('1258562259068678146','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259068678147','91',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259081261058','58',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259085455362','87',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259085455363','91',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259098038274','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-08 09:00:00',NULL,NULL,NULL),('1258562259102232577','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-05-08 09:00:00',NULL,NULL,NULL),('1263635688868306945','91',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-05-22 09:00:00',NULL,NULL,NULL),('1263635688876695553','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-05-22 09:00:00',NULL,NULL,NULL),('1263635688876695554','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-05-22 09:00:00',NULL,NULL,NULL),('1264722852200865793','91',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-05-25 09:00:00',NULL,NULL,NULL),('1264722852205060098','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-05-25 09:00:00',NULL,NULL,NULL),('1264722852209254402','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-05-25 09:00:00',NULL,NULL,NULL),('1265085241240870913','91',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-05-26 09:00:00',NULL,NULL,NULL),('1265085241270231042','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-05-26 09:00:00',NULL,NULL,NULL),('1265085241307979777','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-05-26 09:00:00',NULL,NULL,NULL),('1265447628095643650','91',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-05-27 09:00:00',NULL,NULL,NULL),('1265447628099837953','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-05-27 09:00:00',NULL,NULL,NULL),('1265447628104032257','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-05-27 09:00:00',NULL,NULL,NULL),('1282479857686667265','83',5,1,'您有7条人才认定信息尚未审核，请及时审核','2020-07-13 09:00:00',NULL,NULL,NULL),('1282479857728610306','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-07-13 09:00:00',NULL,NULL,NULL),('1282479857732804609','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-07-13 09:00:00',NULL,NULL,NULL),('1282479857736998914','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-07-13 09:00:00',NULL,NULL,NULL),('1282842245451603969','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-07-14 09:00:00',NULL,NULL,NULL),('1282842245459992578','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-07-14 09:00:00',NULL,NULL,NULL),('1282842245464186881','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-07-14 09:00:00',NULL,NULL,NULL),('1286103736359346178','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-07-23 09:00:00',NULL,NULL,NULL),('1286103736363540482','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-07-23 09:00:00',NULL,NULL,NULL),('1286103736367734786','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-07-23 09:00:00',NULL,NULL,NULL),('1288640451393404929','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451393404930','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451397599233','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451397599234','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451477291009','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451485679618','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-07-30 09:00:00',NULL,NULL,NULL),('1288640451485679619','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-07-30 09:00:00',NULL,NULL,NULL),('1289002839451951105','69',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839456145410','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839456145411','70',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839460339713','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839460339714','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839464534018','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839464534019','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839468728321','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839468728322','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1289002839468728323','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-07-31 09:00:00',NULL,NULL,NULL),('1290090002826412033','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002830606338','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002843189249','69',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002847383554','70',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002847383555','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002851577858','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002889326594','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002893520897','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002893520898','58',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290090002893520899','87',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-08-03 09:00:00',NULL,NULL,NULL),('1290452390784389122','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-08-04 09:00:00',NULL,NULL,NULL),('1290452390788583425','58',1,1,'您有11条企业注册信息待审核，请及时审核！','2020-08-04 09:00:00',NULL,NULL,NULL),('1290452390788583426','87',1,1,'您有11条企业注册信息待审核，请及时审核！','2020-08-04 09:00:00',NULL,NULL,NULL),('1290452390822137858','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-08-04 09:00:00',NULL,NULL,NULL),('1290452390826332162','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-08-04 09:00:00',NULL,NULL,NULL),('1290814778528268289','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-08-05 09:00:00',NULL,NULL,NULL),('1291177166448431106','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-08-06 09:00:00',NULL,NULL,NULL),('1291177166549094401','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-08-06 09:00:00',NULL,NULL,NULL),('1291177166549094402','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-08-06 09:00:00',NULL,NULL,NULL),('1291177166599426049','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-08-06 09:00:00',NULL,NULL,NULL),('1291177166599426050','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-08-06 09:00:00',NULL,NULL,NULL),('1291539554263633922','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554263633923','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554263633924','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554267828225','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-07 09:00:00',NULL,NULL,NULL),('1291539554267828226','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-08-07 09:00:00',NULL,NULL,NULL),('1292626718233833473','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718279970817','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718279970818','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718296748034','58',1,1,'您有11条企业注册信息待审核，请及时审核！','2020-08-10 09:00:00',NULL,NULL,NULL),('1292626718296748035','87',1,1,'您有11条企业注册信息待审核，请及时审核！','2020-08-10 09:00:00',NULL,NULL,NULL),('1295163433796239361','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433796239362','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433808822274','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433808822275','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433808822276','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-08-17 09:00:00',NULL,NULL,NULL),('1295163433821405186','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-08-17 09:00:00',NULL,NULL,NULL),('1295525821041082369','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821045276674','78',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821045276675','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821045276676','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821049470978','83',5,1,'您有10条人才认定信息尚未审核，请及时审核','2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821057859586','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-18 09:00:00',NULL,NULL,NULL),('1295525821062053890','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-18 09:00:00',NULL,NULL,NULL),('1295888208931848194','78',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208936042497','83',5,1,'您有10条人才认定信息尚未审核，请及时审核','2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208961208321','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208969596930','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208973791234','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208977985537','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-19 09:00:00',NULL,NULL,NULL),('1295888208982179841','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-19 09:00:00',NULL,NULL,NULL),('1296250596705173505','78',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596709367809','83',5,1,'您有13条人才认定信息尚未审核，请及时审核','2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596772282370','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596772282371','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596776476674','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596776476675','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-20 09:00:00',NULL,NULL,NULL),('1296250596780670977','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-08-20 09:00:00',NULL,NULL,NULL),('1296612984516247554','83',5,1,'您有14条人才认定信息尚未审核，请及时审核','2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984591745026','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984591745027','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984650465281','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984663048194','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-21 09:00:00',NULL,NULL,NULL),('1296612984663048195','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-21 09:00:00',NULL,NULL,NULL),('1297700148280946690','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148285140994','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148285140995','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148322889730','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148331278338','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-24 09:00:00',NULL,NULL,NULL),('1297700148335472642','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-08-24 09:00:00',NULL,NULL,NULL),('1298062536003940354','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536012328962','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536012328963','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536045883394','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536050077698','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-25 09:00:00',NULL,NULL,NULL),('1298062536050077699','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-25 09:00:00',NULL,NULL,NULL),('1298424923949232130','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923957620738','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923957620739','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923986980866','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923986980867','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-26 09:00:00',NULL,NULL,NULL),('1298424923991175169','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-26 09:00:00',NULL,NULL,NULL),('1298787311793860609','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311793860610','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311798054913','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311831609345','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311831609346','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-27 09:00:00',NULL,NULL,NULL),('1298787311831609347','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-08-27 09:00:00',NULL,NULL,NULL),('1299149699537825793','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699550408705','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699550408706','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699575574529','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699579768833','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-28 09:00:00',NULL,NULL,NULL),('1299149699579768834','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2020-08-28 09:00:00',NULL,NULL,NULL),('1300236863126237185','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863126237186','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863130431489','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863147208706','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863147208707','58',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-08-31 09:00:00',NULL,NULL,NULL),('1300236863147208709','87',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-08-31 09:00:00',NULL,NULL,NULL),('1300599251247624193','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251251818497','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251251818498','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251260207105','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251260207106','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-01 09:00:00',NULL,NULL,NULL),('1300599251272790017','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-01 09:00:00',NULL,NULL,NULL),('1300961639205466113','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639226437634','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639226437635','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639239020545','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639239020546','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-02 09:00:00',NULL,NULL,NULL),('1300961639251603458','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-02 09:00:00',NULL,NULL,NULL),('1301324026731327489','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026739716098','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026739716099','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026764881921','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026769076226','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-03 09:00:00',NULL,NULL,NULL),('1301324026769076227','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-03 09:00:00',NULL,NULL,NULL),('1301686414689202177','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414693396482','58',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414693396483','87',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414693396484','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414697590786','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-04 09:00:00',NULL,NULL,NULL),('1301686414697590787','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-04 09:00:00',NULL,NULL,NULL),('1302773578151784449','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578151784450','58',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578151784451','87',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578176950274','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578181144578','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-07 09:00:00',NULL,NULL,NULL),('1302773578181144579','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-07 09:00:00',NULL,NULL,NULL),('1303135966491377666','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966495571970','58',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966499766273','87',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966499766274','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966503960578','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-08 09:00:00',NULL,NULL,NULL),('1303135966508154882','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-08 09:00:00',NULL,NULL,NULL),('1303498354189156354','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354197544961','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354197544962','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354222710785','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354226905089','58',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-09 09:00:00',NULL,NULL,NULL),('1303498354256265218','87',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-09 09:00:00',NULL,NULL,NULL),('1303860742541312001','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742549700610','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742549700611','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742553894914','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742574866434','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742600032257','58',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742604226561','87',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1303860742604226562','97',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-10 09:00:00',NULL,NULL,NULL),('1304223129719046145','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129723240450','58',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129727434754','87',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129727434755','97',1,1,'您有9条企业变更信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129769377794','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129769377795','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129773572097','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1304223129773572098','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-11 09:00:00',NULL,NULL,NULL),('1305310293244542977','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293257125889','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293269708801','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293269708802','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293282291713','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293286486018','58',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293286486019','87',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305310293286486020','97',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-14 09:00:00',NULL,NULL,NULL),('1305672681726726145','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681735114754','58',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681735114755','87',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681735114756','97',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681751891969','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681772863489','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681772863490','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1305672681772863491','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-15 09:00:00',NULL,NULL,NULL),('1306035068971569154','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306035068975763458','58',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306035068975763459','87',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306035068975763460','97',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306035068992540674','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069021900801','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069026095105','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306035069026095106','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-16 09:00:00',NULL,NULL,NULL),('1306397457306939394','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457306939395','58',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457327910913','87',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457327910914','97',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457353076737','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457378242562','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457378242563','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306397457378242564','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-17 09:00:00',NULL,NULL,NULL),('1306759844811829249','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844820217857','58',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844820217858','87',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844820217859','97',1,1,'您有10条企业变更信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844824412161','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844853772289','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844857966593','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844857966594','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1306759844857966595','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-18 09:00:00',NULL,NULL,NULL),('1307847008387657730','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008433795074','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008437989378','58',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008437989379','87',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008437989380','97',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008463155202','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008467349505','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008467349506','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1307847008467349507','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-21 09:00:00',NULL,NULL,NULL),('1308209396228091906','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396232286210','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396232286211','58',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396236480514','87',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396236480515','97',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396240674817','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396244869121','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396244869122','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308209396244869123','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-22 09:00:00',NULL,NULL,NULL),('1308571784248881153','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784253075458','58',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784253075459','87',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784253075460','97',1,1,'您有11条企业变更信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784269852674','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784278241282','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784278241283','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308571784282435585','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-09-23 09:00:00',NULL,NULL,NULL),('1308934172064149505','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172072538113','58',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172072538114','87',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172072538115','97',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172114481154','83',5,1,'您有11条人才认定信息尚未审核，请及时审核','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172127064065','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172127064066','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172131258369','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1308934172131258370','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-09-24 09:00:00',NULL,NULL,NULL),('1309296559824891906','83',5,1,'您有11条人才认定信息尚未审核，请及时审核','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559871029249','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559871029250','58',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559871029251','87',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559871029252','97',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559883612162','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559887806466','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559887806468','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1309296559887806469','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-09-25 09:00:00',NULL,NULL,NULL),('1310383723480412161','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723480412162','58',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723484606465','87',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723484606466','97',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723522355202','83',5,1,'您有15条人才认定信息尚未审核，请及时审核','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723534938113','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723539132418','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723539132419','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310383723539132420','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-28 09:00:00',NULL,NULL,NULL),('1310746111509549057','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111513743361','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111513743362','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111513743363','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111517937665','83',5,1,'您有16条人才认定信息尚未审核，请及时审核','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111538909187','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111543103490','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111547297794','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1310746111551492097','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-09-29 09:00:00',NULL,NULL,NULL),('1311470887467261954','83',5,1,'您有17条人才认定信息尚未审核，请及时审核','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887475650561','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887509204993','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887513399297','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887513399298','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887530176514','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887576313857','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887576313858','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311470887576313859','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-01 09:00:00',NULL,NULL,NULL),('1311833274967957505','83',5,1,'您有17条人才认定信息尚未审核，请及时审核','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275009900546','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275014094849','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275018289153','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275018289154','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275018289155','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275018289156','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275018289157','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1311833275018289158','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-02 09:00:00',NULL,NULL,NULL),('1312920438711558146','83',5,1,'您有17条人才认定信息尚未审核，请及时审核','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438736723969','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438745112578','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438745112579','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438745112580','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438749306881','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438749306882','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438749306883','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1312920438749306884','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-05 09:00:00',NULL,NULL,NULL),('1313282826409385986','83',5,1,'您有17条人才认定信息尚未审核，请及时审核','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826468106242','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826468106243','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826468106244','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826468106245','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826518437890','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826522632194','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826522632195','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313282826522632196','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-06 09:00:00',NULL,NULL,NULL),('1313645214337900545','83',5,1,'您有17条人才认定信息尚未审核，请及时审核','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214354677761','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214354677762','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214358872065','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214358872066','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214405009409','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214413398017','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214413398018','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1313645214413398019','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-07 09:00:00',NULL,NULL,NULL),('1314007602119614466','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602123808769','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602128003073','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602128003074','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602132197377','83',5,1,'您有17条人才认定信息尚未审核，请及时审核','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602136391682','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602140585985','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602140585986','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314007602140585987','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-08 09:00:00',NULL,NULL,NULL),('1314369989960048641','72',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989960048642','58',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989968437250','87',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989968437251','97',1,1,'您有14条企业变更信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989976825858','83',5,1,'您有17条人才认定信息尚未审核，请及时审核','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989976825859','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989981020162','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989981020163','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1314369989981020164','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-09 09:00:00',NULL,NULL,NULL),('1315457153997217794','83',5,1,'您有28条人才认定信息尚未审核，请及时审核','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154013995010','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154051743746','72',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154051743747','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154060132354','58',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154068520961','87',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154072715265','97',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154097881090','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154102075394','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315457154102075395','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-12 09:00:00',NULL,NULL,NULL),('1315819541607002114','83',5,1,'您有30条人才认定信息尚未审核，请及时审核','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541644750850','72',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541648945153','58',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541648945154','87',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541653139458','97',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541724442626','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541732831234','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541732831235','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1315819541732831236','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-13 09:00:00',NULL,NULL,NULL),('1316181929275469826','72',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929279664130','58',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929279664131','87',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929279664132','97',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929283858433','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929283858434','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929283858435','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929283858436','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-14 09:00:00',NULL,NULL,NULL),('1316181929309024257','83',5,1,'您有33条人才认定信息尚未审核，请及时审核','2020-10-14 09:00:00',NULL,NULL,NULL),('1316544317128486914','72',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317136875521','58',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317136875522','87',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317136875523','97',1,1,'您有15条企业变更信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317153652737','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317162041347','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317162041348','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317162041349','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-15 09:00:00',NULL,NULL,NULL),('1316544317174624257','83',5,1,'您有33条人才认定信息尚未审核，请及时审核','2020-10-15 09:00:00',NULL,NULL,NULL),('1316906704994086914','72',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705002475522','58',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705015058434','87',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705015058435','97',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705036029953','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705040224258','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705044418561','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705044418562','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-16 09:00:00',NULL,NULL,NULL),('1316906705082167298','83',5,1,'您有33条人才认定信息尚未审核，请及时审核','2020-10-16 09:00:00',NULL,NULL,NULL),('1317993868746076161','72',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868750270466','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868754464770','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868754464771','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868754464772','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868767047682','58',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868775436289','87',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868775436290','97',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-19 09:00:00',NULL,NULL,NULL),('1317993868792213506','83',5,1,'您有9条人才认定信息尚未审核，请及时审核','2020-10-19 09:00:00',NULL,NULL,NULL),('1318356256695562241','72',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256699756545','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256703950849','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256703950850','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256708145154','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256708145155','58',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256708145156','87',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256708145157','97',1,1,'您有13条企业变更信息待审核，请及时审核！','2020-10-20 09:00:00',NULL,NULL,NULL),('1318356256729116674','83',5,1,'您有9条人才认定信息尚未审核，请及时审核','2020-10-20 09:00:00',NULL,NULL,NULL),('1318718644460498946','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644468887553','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644468887554','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644485664769','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-10-21 09:00:00',NULL,NULL,NULL),('1318718644510830593','83',5,1,'您有10条人才认定信息尚未审核，请及时审核','2020-10-21 09:00:00',NULL,NULL,NULL),('1319081032456138753','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032464527362','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032464527363','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032464527364','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-22 09:00:00',NULL,NULL,NULL),('1319081032472915970','83',5,1,'您有10条人才认定信息尚未审核，请及时审核','2020-10-22 09:00:00',NULL,NULL,NULL),('1319443420233658369','83',5,1,'您有10条人才认定信息尚未审核，请及时审核','2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420292378625','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420296572929','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420296572930','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-23 09:00:00',NULL,NULL,NULL),('1319443420296572931','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-23 09:00:00',NULL,NULL,NULL),('1320530583582994433','83',5,1,'您有9条人才认定信息尚未审核，请及时审核','2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583582994434','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583612354561','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583612354562','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583612354563','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-26 09:00:00',NULL,NULL,NULL),('1320530583612354564','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-26 09:00:00',NULL,NULL,NULL),('1320892971490537474','83',5,1,'您有10条人才认定信息尚未审核，请及时审核','2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971498926081','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971536674818','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971540869122','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971540869123','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-27 09:00:00',NULL,NULL,NULL),('1320892971540869124','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-27 09:00:00',NULL,NULL,NULL),('1321255359448412162','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359452606465','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359452606466','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-28 09:00:00',NULL,NULL,NULL),('1321255359456800769','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-28 09:00:00',NULL,NULL,NULL),('1321617747376926721','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747376926722','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747376926723','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747376926724','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747414675458','70',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747423064065','76',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-29 09:00:00',NULL,NULL,NULL),('1321617747423064066','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-29 09:00:00',NULL,NULL,NULL),('1321980135431270401','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135435464706','70',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135439659009','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135439659010','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135439659011','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135464824834','76',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-10-30 09:00:00',NULL,NULL,NULL),('1321980135464824835','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-10-30 09:00:00',NULL,NULL,NULL),('1323067298839326721','70',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298843521026','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298847715329','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298847715330','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298847715331','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298851909633','76',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-11-02 09:00:00',NULL,NULL,NULL),('1323067298851909634','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-11-02 09:00:00',NULL,NULL,NULL),('1323429686772035586','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686776229889','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686776229890','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686776229891','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686809784322','76',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-11-03 09:00:00',NULL,NULL,NULL),('1323429686813978625','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2020-11-03 09:00:00',NULL,NULL,NULL),('1323792095583989762','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095592378370','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095596572673','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095600766977','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095600766978','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-04 09:00:05',NULL,NULL,NULL),('1323792095600766979','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-04 09:00:05',NULL,NULL,NULL),('1324154462956220418','83',5,1,'您有7条人才认定信息尚未审核，请及时审核','2020-11-05 09:00:00',NULL,NULL,NULL),('1324154462968803329','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463090438145','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463090438146','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463094632450','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-05 09:00:00',NULL,NULL,NULL),('1324154463144964098','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-11-05 09:00:00',NULL,NULL,NULL),('1324516850444300289','83',5,1,'您有7条人才认定信息尚未审核，请及时审核','2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850469466113','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850473660418','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850477854721','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-06 09:00:00',NULL,NULL,NULL),('1324516850477854722','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-06 09:00:00',NULL,NULL,NULL),('1325604014175408130','83',5,1,'您有7条人才认定信息尚未审核，请及时审核','2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014318014466','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014322208769','58',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014326403073','87',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-11-09 09:00:00',NULL,NULL,NULL),('1325604014326403074','97',1,1,'您有12条企业注册信息待审核，请及时审核！','2020-11-09 09:00:00',NULL,NULL,NULL),('1325966401764184066','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-11-10 09:00:00',NULL,NULL,NULL),('1325966401801932802','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-11-10 09:00:00',NULL,NULL,NULL),('1325966401806127105','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-11-10 09:00:00',NULL,NULL,NULL),('1325966401806127106','97',1,1,'您有9条企业注册信息待审核，请及时审核！','2020-11-10 09:00:00',NULL,NULL,NULL),('1326328789852008449','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-11 09:00:00',NULL,NULL,NULL),('1326328789856202753','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-11 09:00:00',NULL,NULL,NULL),('1326328789856202754','97',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-11 09:00:00',NULL,NULL,NULL),('1326691177415618561','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177503698946','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-12 09:00:00',NULL,NULL,NULL),('1326691177516281857','97',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-12 09:00:00',NULL,NULL,NULL),('1327053579462242306','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579466436610','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-13 09:00:03',NULL,NULL,NULL),('1327053579466436611','97',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-13 09:00:03',NULL,NULL,NULL),('1328140729020596225','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729028984834','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-16 09:00:00',NULL,NULL,NULL),('1328140729028984835','97',1,1,'您有10条企业注册信息待审核，请及时审核！','2020-11-16 09:00:00',NULL,NULL,NULL),('1328503116743589890','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-11-17 09:00:00',NULL,NULL,NULL),('1328503116747784193','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-11-17 09:00:00',NULL,NULL,NULL),('1328503116751978498','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-11-17 09:00:00',NULL,NULL,NULL),('1328865815008657410','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-11-18 09:01:14',NULL,NULL,NULL),('1328865815008657411','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-11-18 09:01:14',NULL,NULL,NULL),('1328865815008657412','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-11-18 09:01:14',NULL,NULL,NULL),('1329227892692877313','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892692877314','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-19 09:00:00',NULL,NULL,NULL),('1329227892692877315','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-19 09:00:00',NULL,NULL,NULL),('1329590280998879234','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281099542529','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-20 09:00:00',NULL,NULL,NULL),('1329590281116319745','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-20 09:00:00',NULL,NULL,NULL),('1330677443899424769','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443907813377','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443916201985','97',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443916201986','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443924590593','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-23 09:00:00',NULL,NULL,NULL),('1330677443928784898','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-23 09:00:00',NULL,NULL,NULL),('1331039831945379842','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831949574145','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831949574146','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831953768450','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831953768451','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-24 09:00:00',NULL,NULL,NULL),('1331039831953768452','97',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-11-24 09:00:00',NULL,NULL,NULL),('1331402219592876033','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219592876034','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219597070338','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219622236161','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219626430465','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-25 09:00:00',NULL,NULL,NULL),('1331402219626430466','97',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-25 09:00:00',NULL,NULL,NULL),('1331764607622053889','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607626248193','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607630442498','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607630442499','97',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607651414018','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607659802626','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-11-26 09:00:00',NULL,NULL,NULL),('1331764607663996930','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-11-26 09:00:00',NULL,NULL,NULL),('1332126995298910210','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995298910211','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995298910212','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995298910213','97',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995378601985','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995378601986','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-27 09:00:00',NULL,NULL,NULL),('1332126995378601987','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-27 09:00:00',NULL,NULL,NULL),('1333214159101231106','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159101231107','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159101231108','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159105425410','97',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159105425411','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159105425412','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-30 09:00:00',NULL,NULL,NULL),('1333214159105425413','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-11-30 09:00:00',NULL,NULL,NULL),('1333576546765504514','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546765504515','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546765504516','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546807447554','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546807447555','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-01 09:00:00',NULL,NULL,NULL),('1333576546807447556','97',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-01 09:00:00',NULL,NULL,NULL),('1333938934748545026','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934748545027','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934748545028','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934748545029','97',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934748545030','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934761127938','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934765322242','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-02 09:00:00',NULL,NULL,NULL),('1333938934765322243','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-02 09:00:00',NULL,NULL,NULL),('1334301323272650754','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323281039361','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323281039362','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323314593793','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323314593794','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323385896961','97',1,1,'您有2条企业变更信息待审核，请及时审核！','2020-12-03 09:00:00',NULL,NULL,NULL),('1334301323394285571','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-12-03 09:00:00',NULL,NULL,NULL),('1334663710555242498','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710559436801','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710559436802','97',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710584602625','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710588796929','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710588796930','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-04 09:00:00',NULL,NULL,NULL),('1334663710588796931','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-04 09:00:00',NULL,NULL,NULL),('1335750874042990593','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874042990594','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874063962113','76',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874063962114','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874063962115','97',1,1,'您有3条企业变更信息待审核，请及时审核！','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874068156417','83',5,1,'您有18条人才认定信息尚未审核，请及时审核','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874076545025','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874084933634','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-07 09:00:00',NULL,NULL,NULL),('1335750874084933635','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-07 09:00:00',NULL,NULL,NULL),('1336113261883424770','70',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261883424771','76',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261883424772','83',5,1,'您有21条人才认定信息尚未审核，请及时审核','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261883424773','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261883424774','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261883424775','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261896007682','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261896007683','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261896007684','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-08 09:00:00',NULL,NULL,NULL),('1336113261896007685','97',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-08 09:00:00',NULL,NULL,NULL),('1336475649790967810','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649795162113','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649795162114','97',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649803550722','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649807745026','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649807745027','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649858076674','70',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649862270977','78',5,1,'您有1条人才认定信息尚未审核，请及时审核','2020-12-09 09:00:00',NULL,NULL,NULL),('1336475649862270978','83',5,1,'您有27条人才认定信息尚未审核，请及时审核','2020-12-09 09:00:00',NULL,NULL,NULL),('1336838037627207681','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037627207682','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037635596290','97',1,1,'您有4条企业变更信息待审核，请及时审核！','2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037694316547','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037698510850','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037702705153','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037736259587','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-10 09:00:00',NULL,NULL,NULL),('1336838037744648193','83',5,1,'您有27条人才认定信息尚未审核，请及时审核','2020-12-10 09:00:00',NULL,NULL,NULL),('1337200425757048833','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425761243138','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425761243139','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425765437442','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425769631745','83',5,1,'您有27条人才认定信息尚未审核，请及时审核','2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425786408962','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425790603265','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-11 09:00:00',NULL,NULL,NULL),('1337200425790603266','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-11 09:00:00',NULL,NULL,NULL),('1338287589253185537','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589253185538','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589257379842','83',5,1,'您有29条人才认定信息尚未审核，请及时审核','2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589257379843','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589257379844','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589257379845','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589261574145','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-14 09:00:00',NULL,NULL,NULL),('1338287589261574146','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-14 09:00:00',NULL,NULL,NULL),('1338649977211060225','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977215254529','83',5,1,'您有29条人才认定信息尚未审核，请及时审核','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977248808962','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977248808963','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977248808964','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977248808965','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977324306434','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977332695041','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-15 09:00:00',NULL,NULL,NULL),('1338649977332695042','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-15 09:00:00',NULL,NULL,NULL),('1339012365059883009','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365064077313','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365068271617','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365106020354','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365106020355','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365106020356','83',5,1,'您有29条人才认定信息尚未审核，请及时审核','2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365118603265','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-12-16 09:00:00',NULL,NULL,NULL),('1339012365122797570','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2020-12-16 09:00:00',NULL,NULL,NULL),('1339374752686407682','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752686407683','83',5,1,'您有29条人才认定信息尚未审核，请及时审核','2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752728350721','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752736739330','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752736739331','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752757710849','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752761905153','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-17 09:00:00',NULL,NULL,NULL),('1339374752761905154','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-17 09:00:00',NULL,NULL,NULL),('1339737140505870338','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140510064641','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140510064642','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140535230466','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140539424770','70',5,1,'您有3条人才认定信息尚未审核，请及时审核','2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140539424771','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140539424772','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-18 09:00:00',NULL,NULL,NULL),('1339737140543619074','83',5,1,'您有30条人才认定信息尚未审核，请及时审核','2020-12-18 09:00:00',NULL,NULL,NULL),('1340824304257859586','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304266248193','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304266248194','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304266248195','97',1,1,'您有4条企业注册信息待审核，请及时审核！','2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304278831105','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-21 09:00:00',NULL,NULL,NULL),('1340824304278831106','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-21 09:00:00',NULL,NULL,NULL),('1341186691938910210','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691938910211','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691938910212','97',1,1,'您有5条企业变更信息待审核，请及时审核！','2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691972464642','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691976658945','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691976658946','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-22 09:00:00',NULL,NULL,NULL),('1341186691989241857','97',1,1,'您有6条企业注册信息待审核，请及时审核！','2020-12-22 09:00:00',NULL,NULL,NULL),('1341186692014407682','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2020-12-22 09:00:00',NULL,NULL,NULL),('1341549079905173506','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-23 09:00:00',NULL,NULL,NULL),('1341549079968088066','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2020-12-23 09:00:00',NULL,NULL,NULL),('1341549079968088067','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080005836801','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080005836802','97',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080005836803','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-23 09:00:00',NULL,NULL,NULL),('1341549080005836804','97',1,1,'您有5条企业注册信息待审核，请及时审核！','2020-12-23 09:00:00',NULL,NULL,NULL),('1344085795140534273','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795148922882','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795148922883','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795211837442','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795220226049','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-30 09:00:00',NULL,NULL,NULL),('1344085795228614658','97',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-30 09:00:00',NULL,NULL,NULL),('1344448182855139329','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182863527937','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182863527938','97',1,1,'您有6条企业变更信息待审核，请及时审核！','2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182871916545','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182876110849','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-31 09:00:00',NULL,NULL,NULL),('1344448182876110850','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2020-12-31 09:00:00',NULL,NULL,NULL),('1344810570842374145','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570846568449','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570846568450','97',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570896900097','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570901094402','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-01-01 09:00:00',NULL,NULL,NULL),('1344810570901094403','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-01-01 09:00:00',NULL,NULL,NULL),('1345897734250430465','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734254624770','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734254624771','97',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734267207682','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734271401986','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-01-04 09:00:00',NULL,NULL,NULL),('1345897734271401987','97',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-01-04 09:00:00',NULL,NULL,NULL),('1346260122178945026','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122183139329','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122183139330','97',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122212499458','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122212499459','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-01-05 09:00:00',NULL,NULL,NULL),('1346260122212499460','97',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-01-05 09:00:00',NULL,NULL,NULL),('1346622509964853250','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-06 09:00:00',NULL,NULL,NULL),('1346622509964853251','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-06 09:00:00',NULL,NULL,NULL),('1346622509964853252','97',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510086488066','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510090682370','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510090682371','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-06 09:00:00',NULL,NULL,NULL),('1346622510090682372','97',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-06 09:00:00',NULL,NULL,NULL),('1346984898115665922','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898119860225','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898119860226','97',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898140831745','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898145026049','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898145026050','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-07 09:00:00',NULL,NULL,NULL),('1346984898149220353','97',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-07 09:00:00',NULL,NULL,NULL),('1347347285691858945','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285696053250','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285700247553','97',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285708636161','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285712830465','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-08 09:00:00',NULL,NULL,NULL),('1347347285712830466','97',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-01-08 09:00:00',NULL,NULL,NULL),('1348434449368350722','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449372545025','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449372545026','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-11 09:00:00',NULL,NULL,NULL),('1348434449376739330','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-11 09:00:00',NULL,NULL,NULL),('1348796837087150082','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837087150083','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837116510210','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-01-12 09:00:00',NULL,NULL,NULL),('1348796837116510211','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-01-12 09:00:00',NULL,NULL,NULL),('1349159224994693121','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-13 09:00:00',NULL,NULL,NULL),('1349159224994693122','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225028247553','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225028247554','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-01-13 09:00:00',NULL,NULL,NULL),('1349159225028247555','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-01-13 09:00:00',NULL,NULL,NULL),('1349521612956762113','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-14 09:00:00',NULL,NULL,NULL),('1349521612956762114','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-01-14 09:00:00',NULL,NULL,NULL),('1349521612973539329','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-14 09:00:00',NULL,NULL,NULL),('1349521612973539330','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-14 09:00:00',NULL,NULL,NULL),('1349884000902053889','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-15 09:00:00',NULL,NULL,NULL),('1349884000918831106','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-15 09:00:00',NULL,NULL,NULL),('1349884000918831107','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-15 09:00:00',NULL,NULL,NULL),('1349884000918831108','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-15 09:00:00',NULL,NULL,NULL),('1350971164373024769','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164373024770','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164373024771','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164398190594','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164402384898','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-18 09:00:00',NULL,NULL,NULL),('1350971164402384899','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-18 09:00:00',NULL,NULL,NULL),('1351333552385425409','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552393814017','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552398008322','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552398008323','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552410591233','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-19 09:00:00',NULL,NULL,NULL),('1351333552414785538','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-19 09:00:00',NULL,NULL,NULL),('1351695940209082369','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940225859586','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940225859587','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940246831106','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940255219713','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940263608322','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-20 09:00:00',NULL,NULL,NULL),('1351695940263608323','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-20 09:00:00',NULL,NULL,NULL),('1352058327957241857','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-21 09:00:00',NULL,NULL,NULL),('1352058327961436162','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-21 09:00:00',NULL,NULL,NULL),('1352058327961436163','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-21 09:00:00',NULL,NULL,NULL),('1352058327961436164','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-21 09:00:00',NULL,NULL,NULL),('1352058327965630465','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-21 09:00:00',NULL,NULL,NULL),('1352058327965630466','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-21 09:00:00',NULL,NULL,NULL),('1352058327974019074','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-01-21 09:00:00',NULL,NULL,NULL),('1352420715822841857','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715822841858','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715831230466','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715831230467','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715852201986','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715856396290','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-22 09:00:00',NULL,NULL,NULL),('1352420715856396291','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-01-22 09:00:00',NULL,NULL,NULL),('1353507879394476034','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879394476035','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879394476036','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879411253249','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879411253250','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879415447553','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-25 09:00:00',NULL,NULL,NULL),('1353507879415447554','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-01-25 09:00:00',NULL,NULL,NULL),('1386564489868001282','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-26 14:15:00',NULL,NULL,NULL),('1386564489880584194','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-26 14:15:00',NULL,NULL,NULL),('1386564489884778497','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-26 14:15:00',NULL,NULL,NULL),('1386847563428184065','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563428184066','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563440766978','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563440766979','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563440766980','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563440766981','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-04-27 09:00:00',NULL,NULL,NULL),('1386847563633704961','83',5,1,'您有9条人才认定信息尚未审核，请及时审核','2021-04-27 09:00:00',NULL,NULL,NULL),('1387209950979211266','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-28 09:00:00',NULL,NULL,NULL),('1387209950987599873','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-28 09:00:00',NULL,NULL,NULL),('1387209950987599874','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-28 09:00:00',NULL,NULL,NULL),('1387209950987599875','104',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-28 09:00:00',NULL,NULL,NULL),('1387572338899337217','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-29 09:00:00',NULL,NULL,NULL),('1387572338907725825','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-29 09:00:00',NULL,NULL,NULL),('1387572338907725826','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-29 09:00:00',NULL,NULL,NULL),('1387934727129837570','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727129837571','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727134031873','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727138226178','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727138226179','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-30 09:00:00',NULL,NULL,NULL),('1387934727163392001','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-04-30 09:00:00',NULL,NULL,NULL),('1389021890487562241','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890495950850','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890495950851','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890537893890','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890542088193','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-03 09:00:00',NULL,NULL,NULL),('1389021890542088194','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-03 09:00:00',NULL,NULL,NULL),('1389384278197972993','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278197972994','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278202167297','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278269276162','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278273470465','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-04 09:00:00',NULL,NULL,NULL),('1389384278273470466','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-04 09:00:00',NULL,NULL,NULL),('1389746666134876161','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666134876162','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666139070465','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666147459074','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666151653377','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-05 09:00:00',NULL,NULL,NULL),('1389746666151653378','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-05 09:00:00',NULL,NULL,NULL),('1390109054147276802','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054151471106','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054151471107','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054151471108','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054155665410','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-06 09:00:00',NULL,NULL,NULL),('1390109054155665411','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-06 09:00:00',NULL,NULL,NULL),('1390471441740247041','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441740247042','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441740247043','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441803161602','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441803161603','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-07 09:00:00',NULL,NULL,NULL),('1390471441803161604','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-07 09:00:00',NULL,NULL,NULL),('1391558605467070465','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605471264769','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605471264770','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605475459073','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605479653378','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-10 09:00:00',NULL,NULL,NULL),('1391558605479653379','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-10 09:00:00',NULL,NULL,NULL),('1391920993143926785','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993160704001','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993160704002','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993164898305','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993169092610','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-11 09:00:00',NULL,NULL,NULL),('1391920993169092611','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-11 09:00:00',NULL,NULL,NULL),('1392283381248602114','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381252796418','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381252796419','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381340876801','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381345071105','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-12 09:00:00',NULL,NULL,NULL),('1392283381345071106','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-12 09:00:00',NULL,NULL,NULL),('1392645768900292609','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768912875523','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768912875524','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768946429954','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768954818561','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-13 09:00:00',NULL,NULL,NULL),('1392645768954818562','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-13 09:00:00',NULL,NULL,NULL),('1393008156749115393','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156757504002','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156757504003','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156958830593','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156963024898','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-14 09:00:00',NULL,NULL,NULL),('1393008156963024899','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-14 09:00:00',NULL,NULL,NULL),('1394095320404635649','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320408829953','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320408829954','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320417218562','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320421412866','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-17 09:00:00',NULL,NULL,NULL),('1394095320421412867','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-17 09:00:00',NULL,NULL,NULL),('1394457708253458434','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708257652738','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708257652739','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708270235649','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708278624258','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-18 09:00:00',NULL,NULL,NULL),('1394457708278624259','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-18 09:00:00',NULL,NULL,NULL),('1394820096156807169','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096156807170','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096156807171','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096232304641','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096236498946','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096236498947','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-19 09:00:00',NULL,NULL,NULL),('1394820096274247682','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-05-19 09:00:00',NULL,NULL,NULL),('1395182484055961602','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484055961603','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484055961604','102',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484106293249','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484110487554','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484110487555','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-05-20 09:00:00',NULL,NULL,NULL),('1395182484190179329','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-05-20 09:00:00',NULL,NULL,NULL),('1395544871820898306','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871825092609','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871825092610','102',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871875424257','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871875424258','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871875424259','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871879618562','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-05-21 09:00:00',NULL,NULL,NULL),('1395544871959310337','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-05-21 09:00:00',NULL,NULL,NULL),('1396632035564498945','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035564498946','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035568693250','102',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035619024898','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035619024899','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035619024900','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035619024901','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-05-24 09:00:00',NULL,NULL,NULL),('1396632035660967937','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-05-24 09:00:00',NULL,NULL,NULL),('1396994423367184386','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423371378689','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423371378690','102',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423396544514','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423400738817','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423400738818','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423400738819','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-05-25 09:00:00',NULL,NULL,NULL),('1396994423417516034','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2021-05-25 09:00:00',NULL,NULL,NULL),('1398081588973043713','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588973043715','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588973043717','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588994015234','70',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588994015235','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081588994015236','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589035958273','76',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589035958274','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589044346881','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-28 09:00:00',NULL,NULL,NULL),('1398081589082095618','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-28 09:00:00',NULL,NULL,NULL),('1399168751395438593','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751395438594','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751395438595','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751470936066','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751470936067','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751483518977','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751483518978','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751542239233','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-05-31 09:00:00',NULL,NULL,NULL),('1399168751546433538','76',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-05-31 09:00:00',NULL,NULL,NULL),('1399531139030351874','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139042934786','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139042934787','102',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139084877825','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139097460738','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139097460739','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139097460740','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-01 09:00:00',NULL,NULL,NULL),('1399531139261038593','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-01 09:00:00',NULL,NULL,NULL),('1399893527046946817','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527051141121','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527051141122','102',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527122444289','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527135027202','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527139221506','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527139221507','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-02 09:00:00',NULL,NULL,NULL),('1399893527218913281','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-02 09:00:00',NULL,NULL,NULL),('1400255914795106306','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914811883522','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914816077825','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914925129731','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914929324033','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914929324034','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-03 09:00:00',NULL,NULL,NULL),('1400255914929324035','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-06-03 09:00:00',NULL,NULL,NULL),('1400255915139039233','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-03 09:00:00',NULL,NULL,NULL),('1400618302677483522','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302677483523','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302681677825','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302681677826','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302711037953','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302715232258','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302715232259','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-04 09:00:00',NULL,NULL,NULL),('1400618302778146817','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-04 09:00:00',NULL,NULL,NULL),('1401705466865680386','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-07 09:00:00',NULL,NULL,NULL),('1401705466869874690','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-07 09:00:00',NULL,NULL,NULL),('1401705466869874691','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-07 09:00:00',NULL,NULL,NULL),('1401705466869874692','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-07 09:00:00',NULL,NULL,NULL),('1401705466869874693','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-07 09:00:00',NULL,NULL,NULL),('1401705466869874694','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-07 09:00:00',NULL,NULL,NULL),('1401705466899234818','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-07 09:00:00',NULL,NULL,NULL),('1401705467046035458','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-07 09:00:00',NULL,NULL,NULL),('1402067854072774657','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854085357570','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854085357571','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854131494913','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854169243650','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854169243651','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854169243652','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-08 09:00:00',NULL,NULL,NULL),('1402067854169243653','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-08 09:00:00',NULL,NULL,NULL),('1402430241858682881','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241862877185','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241862877186','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241883848706','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241904820226','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241913208834','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241913208835','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-09 09:00:00',NULL,NULL,NULL),('1402430241917403137','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-09 09:00:00',NULL,NULL,NULL),('1402792630105964545','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630105964546','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630105964547','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630105964548','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630105964549','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630105964550','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-10 09:00:00',NULL,NULL,NULL),('1402792630135324674','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-10 09:00:00',NULL,NULL,NULL),('1403155017564717058','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017568911361','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017568911362','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017703129090','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017707323394','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017707323395','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-11 09:00:00',NULL,NULL,NULL),('1403155017711517697','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-11 09:00:00',NULL,NULL,NULL),('1404242181257986050','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181257986051','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181266374658','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181266374659','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181266374660','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181270568962','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-14 09:00:00',NULL,NULL,NULL),('1404242181270568963','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-14 09:00:00',NULL,NULL,NULL),('1404604569496879105','58',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569501073410','87',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569505267714','102',1,1,'您有5条企业变更信息待审核，请及时审核！','2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569534627842','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569538822146','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569538822147','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-15 09:00:00',NULL,NULL,NULL),('1404604569538822148','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-15 09:00:00',NULL,NULL,NULL),('1404966957064704002','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957068898306','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957073092609','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957073092610','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957073092611','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957081481217','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-16 09:00:00',NULL,NULL,NULL),('1404966957089869825','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-16 09:00:00',NULL,NULL,NULL),('1405329344838029314','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344842223617','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344842223618','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344968052737','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344980635649','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344980635650','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-17 09:00:00',NULL,NULL,NULL),('1405329344984829954','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-17 09:00:00',NULL,NULL,NULL),('1405691733668319234','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733672513537','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733672513538','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733672513539','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733676707842','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733680902145','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-18 09:00:00',NULL,NULL,NULL),('1405691733680902146','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-18 09:00:00',NULL,NULL,NULL),('1406778899974639617','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778899974639618','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900045942786','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900045942787','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900134023170','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900134023171','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900134023172','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900352126980','70',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900352126981','76',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-21 09:00:01',NULL,NULL,NULL),('1406778900352126982','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-21 09:00:01',NULL,NULL,NULL),('1407503671868039170','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671872233473','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671876427777','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671876427778','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671876427779','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671884816386','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671884816387','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671989673986','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671998062594','76',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-23 09:00:00',NULL,NULL,NULL),('1407503671998062595','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-23 09:00:00',NULL,NULL,NULL),('1407866059620392961','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059628781570','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059628781571','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059695890433','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059704279042','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059704279043','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059708473345','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059721056257','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059729444866','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-24 09:00:00',NULL,NULL,NULL),('1407866059729444867','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-24 09:00:00',NULL,NULL,NULL),('1408228447670542338','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447674736642','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447674736643','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447674736644','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447678930945','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447683125250','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447687319554','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447754428418','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-25 09:00:00',NULL,NULL,NULL),('1408228447762817026','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-25 09:00:00',NULL,NULL,NULL),('1409315611015684097','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611019878401','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611019878402','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611019878403','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611024072706','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611024072707','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611024072708','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611158290434','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-28 09:00:00',NULL,NULL,NULL),('1409315611166679042','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-06-28 09:00:00',NULL,NULL,NULL),('1409677999363629057','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999363629058','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999367823362','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999367823363','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999372017665','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999372017666','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999372017667','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-29 09:00:00',NULL,NULL,NULL),('1409677999376211969','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-06-29 09:00:00',NULL,NULL,NULL),('1410040386843353090','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386851741697','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386851741698','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386948210690','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386952404994','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386952404995','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-30 09:00:00',NULL,NULL,NULL),('1410040386952404996','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-06-30 09:00:00',NULL,NULL,NULL),('1410040387036291073','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-06-30 09:00:00',NULL,NULL,NULL),('1410402774813810690','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774813810691','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774818004994','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774834782210','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774838976513','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774838976514','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774843170817','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-01 09:00:00',NULL,NULL,NULL),('1410402774843170818','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-01 09:00:00',NULL,NULL,NULL),('1410765162641661953','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162641661954','58',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162645856258','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162650050562','87',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162650050563','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162650050564','102',1,1,'您有6条企业变更信息待审核，请及时审核！','2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162650050565','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-02 09:00:00',NULL,NULL,NULL),('1410765162654244866','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-02 09:00:00',NULL,NULL,NULL),('1411852326334930946','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326339125250','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326343319553','102',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326343319554','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326347513858','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326347513859','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326347513860','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-05 09:00:00',NULL,NULL,NULL),('1411852326460760065','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-05 09:00:00',NULL,NULL,NULL),('1412214713969844226','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-06 09:00:00',NULL,NULL,NULL),('1412214713978232833','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-06 09:00:00',NULL,NULL,NULL),('1412214713978232834','102',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714041147394','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714045341697','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714045341698','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714045341699','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-06 09:00:00',NULL,NULL,NULL),('1412214714078896129','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-06 09:00:00',NULL,NULL,NULL),('1412577101734780930','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101738975234','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101738975235','102',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101755752450','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101764141057','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101764141058','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101764141059','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-07 09:00:00',NULL,NULL,NULL),('1412577101915136002','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-07 09:00:00',NULL,NULL,NULL),('1412939489692655617','58',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489696849922','87',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489696849923','102',1,1,'您有7条企业变更信息待审核，请及时审核！','2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489826873346','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489835261953','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489835261954','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489835261955','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-08 09:00:00',NULL,NULL,NULL),('1412939489977868290','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-08 09:00:00',NULL,NULL,NULL),('1413301877457592321','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877474369538','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877478563841','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877478563842','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877549867010','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877554061314','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877558255618','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877558255619','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-07-09 09:00:00',NULL,NULL,NULL),('1413301877667307522','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-09 09:00:00',NULL,NULL,NULL),('1414389041268301826','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041272496129','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041276690434','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041276690435','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041276690436','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041280884738','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041280884739','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041280884740','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-12 09:00:00',NULL,NULL,NULL),('1414389041410908161','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-12 09:00:00',NULL,NULL,NULL),('1414751429033238529','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429037432833','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429037432834','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429037432835','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429058404354','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429062598658','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429066792961','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429066792962','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-13 09:00:00',NULL,NULL,NULL),('1414751429356199938','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-13 09:00:00',NULL,NULL,NULL),('1415113816789778434','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816793972738','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816802361345','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816802361347','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816978522114','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816995299330','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816995299331','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113816999493633','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-14 09:00:00',NULL,NULL,NULL),('1415113817234374657','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-14 09:00:00',NULL,NULL,NULL),('1415476204785401858','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204785401859','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204793790466','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204793790467','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204793790468','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204793790469','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204793790470','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204793790471','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-15 09:00:00',NULL,NULL,NULL),('1415476204957368321','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-15 09:00:00',NULL,NULL,NULL),('1415838592529367041','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592533561345','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592537755650','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592613253122','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592617447426','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592621641730','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592621641731','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-16 09:00:00',NULL,NULL,NULL),('1415838592718110722','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-16 09:00:00',NULL,NULL,NULL),('1416925756264579074','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756268773378','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756268773379','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756461711361','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756465905666','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756470099969','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756470099970','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-19 09:00:00',NULL,NULL,NULL),('1416925756474294273','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-19 09:00:00',NULL,NULL,NULL),('1417288143966601218','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-20 09:00:00',NULL,NULL,NULL),('1417288143970795522','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-20 09:00:00',NULL,NULL,NULL),('1417288143974989825','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144063070209','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144067264514','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144067264515','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144071458818','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-20 09:00:00',NULL,NULL,NULL),('1417288144096624641','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-20 09:00:00',NULL,NULL,NULL),('1417650531920281602','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650531924475905','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650531953836033','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650531962224641','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650531962224642','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532004167682','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532004167683','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532008361986','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-21 09:00:00',NULL,NULL,NULL),('1417650532008361987','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-07-21 09:00:00',NULL,NULL,NULL),('1418012919714578434','58',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919718772737','87',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919718772738','102',1,1,'您有8条企业变更信息待审核，请及时审核！','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919769104385','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919773298689','58',1,1,'您有13条企业注册信息待审核，请及时审核！','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919777492994','87',1,1,'您有13条企业注册信息待审核，请及时审核！','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012919777492995','102',1,1,'您有13条企业注册信息待审核，请及时审核！','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920062705666','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-22 09:00:00',NULL,NULL,NULL),('1418012920066899970','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-07-22 09:00:00',NULL,NULL,NULL),('1418375307529846786','58',1,1,'您有10条企业变更信息待审核，请及时审核！','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307534041089','87',1,1,'您有10条企业变更信息待审核，请及时审核！','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307534041090','102',1,1,'您有10条企业变更信息待审核，请及时审核！','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307785699330','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307785699331','58',1,1,'您有14条企业注册信息待审核，请及时审核！','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307789893634','87',1,1,'您有14条企业注册信息待审核，请及时审核！','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307789893635','102',1,1,'您有14条企业注册信息待审核，请及时审核！','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307840225282','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-23 09:00:00',NULL,NULL,NULL),('1418375307844419586','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2021-07-23 09:00:00',NULL,NULL,NULL),('1419462471378305026','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471382499330','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471382499331','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471550271490','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471558660097','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471558660098','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462471558660099','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472175222786','70',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472179417090','75',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-07-26 09:00:00',NULL,NULL,NULL),('1419462472183611393','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-07-26 09:00:00',NULL,NULL,NULL),('1419824859256487938','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859260682242','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859260682243','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859319402498','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859327791105','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859327791106','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859327791107','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-27 09:00:00',NULL,NULL,NULL),('1419824859495563266','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-07-27 09:00:00',NULL,NULL,NULL),('1420187248548171778','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248548171779','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248556560385','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248556560386','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248556560387','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248577531905','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-28 09:00:00',NULL,NULL,NULL),('1420187248590114818','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-28 09:00:00',NULL,NULL,NULL),('1420187249185705985','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-07-28 09:00:00',NULL,NULL,NULL),('1420549635075788802','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635079983106','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635079983107','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635214200834','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635226783745','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635230978049','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635230978050','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-29 09:00:00',NULL,NULL,NULL),('1420549635239366657','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-07-29 09:00:00',NULL,NULL,NULL),('1420912022953926658','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-30 09:00:00',NULL,NULL,NULL),('1420912022962315266','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-30 09:00:00',NULL,NULL,NULL),('1420912022962315267','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023050395649','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023062978562','58',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023071367169','87',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023075561473','102',1,1,'您有10条企业注册信息待审核，请及时审核！','2021-07-30 09:00:00',NULL,NULL,NULL),('1420912023184613378','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-07-30 09:00:00',NULL,NULL,NULL),('1421999186831761409','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186831761410','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186840150017','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186840150018','58',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186840150019','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186840150020','87',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186852732930','102',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-02 09:00:00',NULL,NULL,NULL),('1421999186919841793','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-08-02 09:00:00',NULL,NULL,NULL),('1422361574282125313','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574286319618','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574298902530','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574386982914','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574395371522','58',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574395371523','87',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574399565826','102',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-03 09:00:00',NULL,NULL,NULL),('1422361574496034817','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-08-03 09:00:00',NULL,NULL,NULL),('1422723962114170881','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962122559489','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962122559490','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962244194306','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962248388610','58',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962248388611','87',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962252582914','102',1,1,'您有12条企业注册信息待审核，请及时审核！','2021-08-04 09:00:00',NULL,NULL,NULL),('1422723962663624706','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-08-04 09:00:00',NULL,NULL,NULL),('1423086349870718977','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-05 09:00:00',NULL,NULL,NULL),('1423086349874913281','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-05 09:00:00',NULL,NULL,NULL),('1423086349874913282','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350038491138','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350042685442','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350042685443','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-08-05 09:00:00',NULL,NULL,NULL),('1423086350046879746','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-08-05 09:00:00',NULL,NULL,NULL),('1423448739174981634','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739191758849','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739195953154','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739246284801','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739258867713','58',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739275644930','87',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-08-06 09:00:00',NULL,NULL,NULL),('1423448739275644931','102',1,1,'您有9条企业注册信息待审核，请及时审核！','2021-08-06 09:00:00',NULL,NULL,NULL),('1424535901911949314','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-09 09:00:00',NULL,NULL,NULL),('1424535901916143618','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-09 09:00:00',NULL,NULL,NULL),('1424535901916143619','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902058749954','72',1,1,'您有3条企业注册信息待审核，请及时审核！','2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902067138561','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902067138562','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-08-09 09:00:00',NULL,NULL,NULL),('1424535902067138563','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-08-09 09:00:00',NULL,NULL,NULL),('1424898289404256258','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289421033473','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289421033474','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289421033475','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289421033476','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289421033477','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-10 09:00:00',NULL,NULL,NULL),('1424898289723023362','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-08-10 09:00:00',NULL,NULL,NULL),('1425260677127249922','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677131444226','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677131444227','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677131444228','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677135638530','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677139832833','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-11 09:00:00',NULL,NULL,NULL),('1425260677378908162','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-08-11 09:00:00',NULL,NULL,NULL),('1425623064997044226','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065001238530','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065001238531','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065047375874','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065051570177','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065051570178','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-12 09:00:00',NULL,NULL,NULL),('1425623065068347393','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-08-12 09:00:00',NULL,NULL,NULL),('1425985453042958338','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453055541249','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453059735554','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453131038722','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453135233026','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453143621633','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-13 09:00:00',NULL,NULL,NULL),('1425985453382696961','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-08-13 09:00:00',NULL,NULL,NULL),('1427072616530706434','58',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616539095042','87',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616539095043','102',1,1,'您有4条企业变更信息待审核，请及时审核！','2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616702672898','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616711061505','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616711061506','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-08-16 09:00:00',NULL,NULL,NULL),('1427072616912388098','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-08-16 09:00:00',NULL,NULL,NULL),('1427435004496969730','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004501164034','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004501164035','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004505358338','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004505358339','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004505358340','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004505358341','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-17 09:00:00',NULL,NULL,NULL),('1427435004903817217','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-08-17 09:00:00',NULL,NULL,NULL),('1427797392295460865','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392299655170','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392303849473','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392303849474','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392324820994','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392333209601','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392333209602','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-18 09:00:00',NULL,NULL,NULL),('1427797392433872897','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-08-18 09:00:00',NULL,NULL,NULL),('1428159780257583105','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780265971714','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780265971715','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780274360321','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780278554626','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780286943233','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780286943234','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-08-19 09:00:00',NULL,NULL,NULL),('1428159780387606529','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-08-19 09:00:00',NULL,NULL,NULL),('1428522167896690689','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167900884994','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167900884995','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167913467905','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167917662210','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-20 09:00:00',NULL,NULL,NULL),('1428522167917662211','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-20 09:00:00',NULL,NULL,NULL),('1429609331862589441','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331870978050','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331870978051','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331870978052','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331870978053','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-23 09:00:00',NULL,NULL,NULL),('1429609331875172354','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-23 09:00:00',NULL,NULL,NULL),('1429971719342313474','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719346507778','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719346507779','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719384256513','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719388450818','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-24 09:00:00',NULL,NULL,NULL),('1429971719388450819','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-24 09:00:00',NULL,NULL,NULL),('1430334107186941954','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107191136257','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107191136258','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107237273602','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107245662210','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107245662211','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-25 09:00:00',NULL,NULL,NULL),('1430334107434405889','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-08-25 09:00:00',NULL,NULL,NULL),('1430696495073513473','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495077707778','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495081902081','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495119650817','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495119650818','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495123845121','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-26 09:00:00',NULL,NULL,NULL),('1430696495480360961','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-08-26 09:00:00',NULL,NULL,NULL),('1431058882964279297','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882964279298','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882968473602','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882985250818','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882989445121','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-27 09:00:00',NULL,NULL,NULL),('1431058882989445122','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-08-27 09:00:00',NULL,NULL,NULL),('1432146046938566658','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046942760961','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046942760962','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046951149570','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046955343873','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-08-30 09:00:00',NULL,NULL,NULL),('1432146046955343874','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-08-30 09:00:00',NULL,NULL,NULL),('1432508434745446402','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434753835009','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434753835010','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434758029313','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434762223617','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-31 09:00:00',NULL,NULL,NULL),('1432508434762223618','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-08-31 09:00:00',NULL,NULL,NULL),('1432870822363582465','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822363582466','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822367776769','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822371971073','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822371971074','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-01 09:00:00',NULL,NULL,NULL),('1432870822371971075','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-01 09:00:00',NULL,NULL,NULL),('1433233210073993218','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210082381826','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210082381827','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210145296385','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210149490690','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-02 09:00:00',NULL,NULL,NULL),('1433233210153684993','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-02 09:00:00',NULL,NULL,NULL),('1433595598174445569','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598178639874','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598178639875','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598379966465','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598388355073','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-03 09:00:00',NULL,NULL,NULL),('1433595598400937986','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-03 09:00:00',NULL,NULL,NULL),('1434682761892880386','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-06 09:00:00',NULL,NULL,NULL),('1434682761897074690','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-06 09:00:00',NULL,NULL,NULL),('1434682761897074691','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-06 09:00:00',NULL,NULL,NULL),('1434682761905463298','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-06 09:00:00',NULL,NULL,NULL),('1434682761909657601','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-06 09:00:00',NULL,NULL,NULL),('1434682761913851906','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-06 09:00:00',NULL,NULL,NULL),('1435045149334855682','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149343244290','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149347438594','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149347438595','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149347438596','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-07 09:00:00',NULL,NULL,NULL),('1435045149347438597','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-07 09:00:00',NULL,NULL,NULL),('1435407537779294210','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537779294211','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537791877122','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537791877123','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537791877124','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-08 09:00:00',NULL,NULL,NULL),('1435407537804460034','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-08 09:00:00',NULL,NULL,NULL),('1435769925460344834','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925464539137','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925464539138','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925569396738','58',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925577785346','87',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-09 09:00:00',NULL,NULL,NULL),('1435769925577785347','102',1,1,'您有4条企业注册信息待审核，请及时审核！','2021-09-09 09:00:00',NULL,NULL,NULL),('1436132313091063810','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313095258113','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313099452417','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313116229633','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313120423937','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-10 09:00:00',NULL,NULL,NULL),('1436132313120423938','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-10 09:00:00',NULL,NULL,NULL),('1437219476994027524','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-13 09:00:00',NULL,NULL,NULL),('1437219476998221826','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477002416130','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477010804737','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477048553474','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477056942081','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-13 09:00:00',NULL,NULL,NULL),('1437219477056942082','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-13 09:00:00',NULL,NULL,NULL),('1437581864813490178','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864826073089','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864826073090','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864897376257','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864901570562','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864905764865','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-14 09:00:00',NULL,NULL,NULL),('1437581864905764866','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-14 09:00:00',NULL,NULL,NULL),('1437586142470893570','70',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-14 09:17:00',NULL,NULL,NULL),('1437586142475087874','76',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-14 09:17:00',NULL,NULL,NULL),('1437586142475087875','83',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-14 09:17:00',NULL,NULL,NULL),('1437944252645535745','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252649730049','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252653924354','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252695867394','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252704256001','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252708450305','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-15 09:00:00',NULL,NULL,NULL),('1437944252708450307','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-15 09:00:00',NULL,NULL,NULL),('1437948530449739777','70',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-15 09:17:00',NULL,NULL,NULL),('1437948530458128386','76',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-15 09:17:00',NULL,NULL,NULL),('1437948530458128387','83',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-15 09:17:00',NULL,NULL,NULL),('1438306640288837633','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640293031938','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640293031939','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640360140802','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640368529410','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640368529411','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-16 09:00:00',NULL,NULL,NULL),('1438306640368529412','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-16 09:00:00',NULL,NULL,NULL),('1438310918126596097','70',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-16 09:17:00',NULL,NULL,NULL),('1438310918130790401','76',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-16 09:17:00',NULL,NULL,NULL),('1438310918130790402','83',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-16 09:17:00',NULL,NULL,NULL),('1438669028154437634','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028154437635','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028154437636','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028192186370','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028196380674','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028200574977','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-17 09:00:00',NULL,NULL,NULL),('1438669028200574978','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-17 09:00:00',NULL,NULL,NULL),('1438673306101248001','83',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-17 09:17:00',NULL,NULL,NULL),('1439756191889649666','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191889649667','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191893843969','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191893843970','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191893843971','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191898038273','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-20 09:00:00',NULL,NULL,NULL),('1439756191898038274','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-20 09:00:00',NULL,NULL,NULL),('1439760469622550529','83',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-20 09:17:00',NULL,NULL,NULL),('1440118579612643331','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579616837633','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579616837634','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579658780674','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579662974978','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579662974979','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579662974980','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440118579662974981','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-09-21 09:00:00',NULL,NULL,NULL),('1440480967528574977','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967536963585','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967549546497','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967549546498','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967750873090','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967755067393','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967755067394','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-22 09:00:00',NULL,NULL,NULL),('1440480967889285122','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-09-22 09:00:00',NULL,NULL,NULL),('1440843355369009153','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355389980673','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355389980674','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355486449665','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355494838273','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355494838274','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355499032578','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-23 09:00:00',NULL,NULL,NULL),('1440843355524198402','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-09-23 09:00:00',NULL,NULL,NULL),('1441205743301718017','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743318495233','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743318495234','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743322689537','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743322689538','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743326883841','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743326883842','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-24 09:00:00',NULL,NULL,NULL),('1441205743326883843','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-24 09:00:00',NULL,NULL,NULL),('1442292906940461057','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-27 09:00:00',NULL,NULL,NULL),('1442292906944655362','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-27 09:00:00',NULL,NULL,NULL),('1442292906944655363','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907028541441','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907028541442','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907032735745','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907032735746','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-27 09:00:00',NULL,NULL,NULL),('1442292907217285122','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2021-09-27 09:00:00',NULL,NULL,NULL),('1442655294747340802','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294751535105','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294751535106','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294961250306','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294965444610','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294969638913','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-28 09:00:00',NULL,NULL,NULL),('1442655294969638914','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-28 09:00:00',NULL,NULL,NULL),('1443017682524860418','58',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682529054722','87',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682529054723','102',1,1,'您有3条企业变更信息待审核，请及时审核！','2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682629718018','72',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682638106625','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682638106626','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682638106627','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-09-29 09:00:00',NULL,NULL,NULL),('1443017682709409795','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2021-09-29 09:00:00',NULL,NULL,NULL),('1443380070390460417','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070394654722','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070398849026','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070516289537','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070524678145','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070524678146','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-09-30 09:00:00',NULL,NULL,NULL),('1443380070734393346','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2021-09-30 09:00:00',NULL,NULL,NULL),('1443384348358242306','83',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-09-30 09:17:00',NULL,NULL,NULL),('1443742458335752193','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458339946498','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458344140801','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458373500929','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458377695233','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-01 09:00:00',NULL,NULL,NULL),('1443742458377695234','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-01 09:00:00',NULL,NULL,NULL),('1443746736106401793','83',10,1,'您有1条人才层次变更信息尚未审核，请及时审核','2021-10-01 09:17:00',NULL,NULL,NULL),('1444829622150656001','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622154850306','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622154850307','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622159044610','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622159044611','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-04 09:00:00',NULL,NULL,NULL),('1444829622159044612','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-04 09:00:00',NULL,NULL,NULL),('1445192010007867394','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010012061697','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010012061698','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010079170562','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010083364865','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010083364866','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-05 09:00:00',NULL,NULL,NULL),('1445192010150473730','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-10-05 09:00:00',NULL,NULL,NULL),('1445554397797969921','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397802164226','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397802164227','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397894438913','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397898633218','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397898633219','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-06 09:00:00',NULL,NULL,NULL),('1445554397990907905','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-10-06 09:00:00',NULL,NULL,NULL),('1445916785550323713','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785554518017','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785554518018','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785625821185','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785634209793','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785634209794','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-07 09:00:00',NULL,NULL,NULL),('1445916785638404098','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-10-07 09:00:00',NULL,NULL,NULL),('1446279173436895234','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173441089538','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173441089539','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173545947138','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173545947139','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173545947140','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-08 09:00:00',NULL,NULL,NULL),('1446279173650804737','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-10-08 09:00:00',NULL,NULL,NULL),('1447366336891088898','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336895283201','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336895283202','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336899477506','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336899477507','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-11 09:00:00',NULL,NULL,NULL),('1447366336899477508','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-11 09:00:00',NULL,NULL,NULL),('1447366337117581314','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-10-11 09:00:00',NULL,NULL,NULL),('1447728724886712322','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-12 09:00:00',NULL,NULL,NULL),('1447728724890906625','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-12 09:00:00',NULL,NULL,NULL),('1447728724890906626','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-12 09:00:00',NULL,NULL,NULL),('1447728724983181313','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-12 09:00:00',NULL,NULL,NULL),('1447728724991569922','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-12 09:00:00',NULL,NULL,NULL),('1447728724995764226','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-12 09:00:00',NULL,NULL,NULL),('1447728725062873089','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-10-12 09:00:00',NULL,NULL,NULL),('1448091112760700930','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112764895233','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112764895234','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112936861697','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112945250305','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-13 09:00:00',NULL,NULL,NULL),('1448091112945250307','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-13 09:00:00',NULL,NULL,NULL),('1448453500588552193','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500592746497','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500592746498','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500634689538','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500638883842','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-14 09:00:00',NULL,NULL,NULL),('1448453500638883843','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-14 09:00:00',NULL,NULL,NULL),('1448815888676450305','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888680644609','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888680644610','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888684838914','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888684838915','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-15 09:00:00',NULL,NULL,NULL),('1448815888684838916','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-15 09:00:00',NULL,NULL,NULL),('1449903052097089538','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052101283842','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052101283843','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052172587010','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052176781313','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-18 09:00:00',NULL,NULL,NULL),('1449903052176781314','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-18 09:00:00',NULL,NULL,NULL),('1450265439966883842','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-19 09:00:00',NULL,NULL,NULL),('1450265439971078145','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-19 09:00:00',NULL,NULL,NULL),('1450265439971078146','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440088518658','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440092712962','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-19 09:00:00',NULL,NULL,NULL),('1450265440092712963','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-19 09:00:00',NULL,NULL,NULL),('1450627827605991426','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827618574338','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827618574339','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827689877505','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827694071811','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-20 09:00:00',NULL,NULL,NULL),('1450627827698266113','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-20 09:00:00',NULL,NULL,NULL),('1450990215781969921','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215786164226','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215786164227','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215802941442','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215807135746','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-21 09:00:00',NULL,NULL,NULL),('1450990215807135747','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-21 09:00:00',NULL,NULL,NULL),('1451352603492380674','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603496574977','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603496574978','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603555295233','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603563683841','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-22 09:00:00',NULL,NULL,NULL),('1451352603563683842','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-22 09:00:00',NULL,NULL,NULL),('1452439767181455361','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767185649665','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767185649666','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767198232578','58',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767202426881','87',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767206621186','102',1,1,'您有5条企业注册信息待审核，请及时审核！','2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767227592706','83',5,1,'您有2条人才认定信息尚未审核，请及时审核','2021-10-25 09:00:00',NULL,NULL,NULL),('1452439767227592707','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-10-25 09:00:00',NULL,NULL,NULL),('1452802154938003457','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802154942197761','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802154942197762','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155118358530','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155126747137','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155126747138','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155126747139','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155135135745','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-10-26 09:00:00',NULL,NULL,NULL),('1452802155135135746','86',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-10-26 09:00:00',NULL,NULL,NULL),('1453164542933626881','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542937821186','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542937821187','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542954598401','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542962987010','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542967181314','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-27 09:00:00',NULL,NULL,NULL),('1453164542967181315','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-27 09:00:00',NULL,NULL,NULL),('1453164543105593346','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-10-27 09:00:00',NULL,NULL,NULL),('1453526930644037633','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930648231938','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930648231939','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930673397762','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930677592066','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930681786370','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930681786371','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-28 09:00:00',NULL,NULL,NULL),('1453526930790838274','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-10-28 09:00:00',NULL,NULL,NULL),('1453889318673215489','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318673215490','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318673215491','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318731935746','83',5,1,'您有5条人才认定信息尚未审核，请及时审核','2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318748712962','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318748712963','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318748712964','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-29 09:00:00',NULL,NULL,NULL),('1453889318752907265','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-10-29 09:00:00',NULL,NULL,NULL),('1454976482425204738','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482425204739','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482429399042','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482429399044','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482429399045','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482441981954','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482441981955','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482441981956','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-01 09:00:00',NULL,NULL,NULL),('1454976482450370561','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2021-11-01 09:00:00',NULL,NULL,NULL),('1455338869972037634','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-02 09:00:00',NULL,NULL,NULL),('1455338869972037635','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-02 09:00:00',NULL,NULL,NULL),('1455338869972037636','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870177558529','83',5,1,'您有6条人才认定信息尚未审核，请及时审核','2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870211112962','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870219501570','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870219501571','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-02 09:00:00',NULL,NULL,NULL),('1455338870219501572','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-02 09:00:00',NULL,NULL,NULL),('1455701258139627522','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258143821825','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258143821826','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258156404737','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258160599042','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258160599043','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-03 09:00:00',NULL,NULL,NULL),('1455701258164793346','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-03 09:00:00',NULL,NULL,NULL),('1456063645778735106','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645787123714','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645787123715','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645938118658','72',1,1,'您有2条企业注册信息待审核，请及时审核！','2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645946507265','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645946507266','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-04 09:00:00',NULL,NULL,NULL),('1456063645946507267','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-04 09:00:00',NULL,NULL,NULL),('1456426033627557889','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033631752194','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033631752195','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033631752196','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033736609793','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033740804097','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-05 09:00:00',NULL,NULL,NULL),('1456426033740804098','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-05 09:00:00',NULL,NULL,NULL),('1457513197362769921','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197362769922','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197366964225','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197366964226','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197366964227','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197366964228','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-08 09:00:00',NULL,NULL,NULL),('1457513197371158529','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-08 09:00:00',NULL,NULL,NULL),('1457875585110929410','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585115123713','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585115123714','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585115123715','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585127706625','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585131900929','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-09 09:00:00',NULL,NULL,NULL),('1457875585131900930','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-09 09:00:00',NULL,NULL,NULL),('1458237972980723713','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972980723714','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972984918018','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972984918019','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972984918020','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972984918021','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972984918022','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972984918023','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458237972984918024','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-10 09:00:00',NULL,NULL,NULL),('1458600360644997121','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360653385730','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360653385731','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360653385732','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360653385733','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360775020546','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360779214850','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360779214851','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458600360779214852','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-11 09:00:00',NULL,NULL,NULL),('1458962748934221826','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748938416129','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748938416130','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748938416131','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748938416132','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748942610434','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748942610435','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748946804737','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1458962748946804738','116',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-12 09:00:00',NULL,NULL,NULL),('1460049912451330049','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912455524354','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912459718657','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912459718658','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912459718659','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912472301570','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912476495873','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912476495874','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460049912476495875','116',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-15 09:00:00',NULL,NULL,NULL),('1460412300375650305','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300375650306','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300375650307','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300375650308','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300375650309','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300455342081','58',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300459536387','87',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300463730690','102',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460412300463730691','116',1,1,'您有8条企业注册信息待审核，请及时审核！','2021-11-16 09:00:00',NULL,NULL,NULL),('1460774688278999042','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688287387649','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688287387650','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688287387651','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688291581954','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688291581955','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688295776257','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688299970561','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1460774688299970562','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-17 09:00:00',NULL,NULL,NULL),('1461137075813249026','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075817443330','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075817443331','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075817443332','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075817443333','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075821637633','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075821637634','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075821637635','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461137075821637636','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-18 09:00:00',NULL,NULL,NULL),('1461499464010199041','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464014393345','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464014393346','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464018587650','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464094085121','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464098279425','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464098279426','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464102473729','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1461499464102473730','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-19 09:00:00',NULL,NULL,NULL),('1462586627485364226','72',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627489558530','58',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627489558531','87',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627493752833','102',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627493752834','116',1,1,'您有2条企业变更信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627506335746','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627510530049','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627510530050','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462586627514724354','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-22 09:00:00',NULL,NULL,NULL),('1462949015170609153','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015174803457','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015174803458','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015174803459','116',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015279661057','58',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015283855362','87',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015288049665','102',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015288049666','116',1,1,'您有6条企业注册信息待审核，请及时审核！','2021-11-23 09:00:00',NULL,NULL,NULL),('1462949015317409794','83',5,1,'您有1条人才认定信息尚未审核，请及时审核','2021-11-23 09:00:00',NULL,NULL,NULL),('1463311403354976258','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403359170561','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403359170562','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403363364865','116',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403388530689','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403392724993','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403396919297','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403401113601','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403401113602','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463311403401113603','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-24 09:00:00',NULL,NULL,NULL),('1463673790763397122','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790763397123','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790767591425','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790767591426','116',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790868254721','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790872449025','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790872449026','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790872449027','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790872449028','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-25 09:00:00',NULL,NULL,NULL),('1463673790926974978','83',5,1,'您有3条人才认定信息尚未审核，请及时审核','2021-11-25 09:00:00',NULL,NULL,NULL),('1464036178742243330','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178746437633','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178746437634','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178746437635','116',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178910015489','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178910015490','83',5,1,'您有4条人才认定信息尚未审核，请及时审核','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178914209794','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178914209795','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178918404097','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1464036178918404098','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-26 09:00:00',NULL,NULL,NULL),('1465123342909468673','83',5,1,'您有7条人才认定信息尚未审核，请及时审核','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342913662978','58',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342917857282','87',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342917857283','102',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123342917857284','116',1,1,'您有1条企业变更信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343043686402','71',1,1,'您有1条企业注册信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343047880705','58',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343047880706','87',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343052075009','102',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL),('1465123343052075010','116',1,1,'您有7条企业注册信息待审核，请及时审核！','2021-11-29 09:00:00',NULL,NULL,NULL);
/*!40000 ALTER TABLE `sys_task` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_user`
--

DROP TABLE IF EXISTS `sys_user`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_user` (
  `id` int(11) NOT NULL AUTO_INCREMENT COMMENT '主键id',
  `type` int(1) DEFAULT NULL,
  `account` varchar(45) DEFAULT NULL COMMENT '账号',
  `password` varchar(45) DEFAULT NULL COMMENT '密码',
  `name` varchar(45) DEFAULT NULL COMMENT '名字',
  `phone` varchar(45) DEFAULT NULL COMMENT '电话',
  `email` varchar(45) DEFAULT NULL COMMENT '电子邮件',
  `companyId` varchar(255) NOT NULL COMMENT '所属单位',
  `post` varchar(255) DEFAULT NULL COMMENT '职务',
  `roleid` varchar(255) DEFAULT NULL COMMENT '角色id',
  `groupCode` varchar(40) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL,
  `createTime` datetime DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(255) DEFAULT NULL,
  `updateTime` datetime DEFAULT NULL,
  `updateUser` datetime DEFAULT NULL,
  `avatar` varchar(255) DEFAULT NULL COMMENT '头像',
  `salt` varchar(45) DEFAULT NULL COMMENT 'md5密码盐',
  `birthday` date DEFAULT NULL COMMENT '生日',
  `sex` int(11) DEFAULT NULL COMMENT '性别（1：男 2：女）',
  `deptid` int(11) DEFAULT NULL COMMENT '部门id',
  `status` int(11) DEFAULT NULL COMMENT '状态(1：启用  2：冻结  3：删除）',
  `version` int(11) DEFAULT NULL COMMENT '保留字段',
  `freeze` tinyint(2) DEFAULT NULL,
  `errorCount` tinyint(2) DEFAULT NULL,
  `freezeTime` varchar(20) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=118 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='管理员表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_user`
--

LOCK TABLES `sys_user` WRITE;
/*!40000 ALTER TABLE `sys_user` DISABLE KEYS */;
INSERT INTO `sys_user` VALUES (1,1,'admin','3039879f5024d6e1ce9d5bd1d8160bc3','刘建锋','17362523273','1508798227@qq.com','1196347541488906242',NULL,'1',NULL,NULL,'2016-01-29 16:49:53',NULL,NULL,NULL,'jjrcw/headPortrait/202208/1561202112413569026.jpg','8pgby','2017-05-04',1,27,1,25,1,NULL,NULL),(58,1,'rs02','3039879f5024d6e1ce9d5bd1d8160bc3','张荣荣','15280619456','1508798227@qq.com','1197443773921181697',NULL,'9',NULL,NULL,'2019-11-18 07:28:13',NULL,NULL,NULL,'jjrcw/headPortrait/202006/1277052250648264705.jpg','8pgby','1994-10-22',2,NULL,1,NULL,1,NULL,NULL),(59,2,'caicongying','626e498cc687900a7a707bcbb0e86dde','蔡聪颖','13599110629','262021227@qq.com','1197345219366043649',NULL,'12',NULL,NULL,'2019-11-21 02:16:49',NULL,NULL,NULL,'','28enu','1994-10-20',1,NULL,1,NULL,1,NULL,NULL),(60,1,'gyqy','650e672bc85b289430a0e535f20b7764','gyqy','17362523273','','1197443773921181697',NULL,'11',NULL,NULL,'2019-11-27 09:03:57',NULL,NULL,NULL,'','d2d8s','1994-10-22',1,NULL,3,NULL,1,NULL,NULL),(61,1,'yzq','6f964f618f47fef6dfd861d41eca5ef9','叶志钦','17362523273','','1197443773921181697',NULL,'9',NULL,NULL,'2019-12-02 08:21:27',NULL,NULL,NULL,'','n0byb','1994-10-22',1,NULL,3,NULL,1,NULL,NULL),(62,1,'lmy','127bcd7db280d83e03adb798fc8ad8a9','林曼雅','17362523273','','1197443773921181697',NULL,'9',NULL,NULL,'2019-12-02 08:21:59',NULL,NULL,NULL,'','r1hgg','1994-10-22',2,NULL,3,NULL,1,NULL,NULL),(63,1,'xcb','4fa5eea2e91cbfc059140ba710339700','宣传部','15280619456','','1196328018018181122',NULL,'14',NULL,NULL,'2019-12-03 01:20:25',NULL,NULL,NULL,'jjrcw/headPortrait/201912/1209017729920704513.png','0jq5k','1994-10-22',1,NULL,3,NULL,1,NULL,NULL),(64,1,'czj','bdeda3e278da1e8570f2db5eea459b28','财政局','17362523273','','1201673316928286721',NULL,'13',NULL,NULL,'2019-12-03 01:25:16',NULL,NULL,NULL,'','jpwt1','1994-10-22',2,NULL,3,NULL,1,NULL,NULL),(65,1,'gzj','c567ee5b725311d1022cfd2ef420493c','广电局','17362523273','','1196328242593800193',NULL,'14',NULL,NULL,'2019-12-03 02:20:06',NULL,NULL,NULL,'','6br0z','1994-10-22',1,NULL,3,NULL,1,NULL,NULL),(66,1,'jyj','5b608435cc044293e2aa3b08d85975df','教育局','17362523273','1508798227@qq.com','1196331850672513026',NULL,'14',NULL,NULL,'2019-12-16 09:16:28',NULL,NULL,NULL,'','5hisn','1994-10-22',1,NULL,3,NULL,1,NULL,NULL),(67,2,'adminIC','3039879f5024d6e1ce9d5bd1d8160bc3','刘建锋','17362523273','1508798227@qq.com','1197345219366043649',NULL,'1',NULL,NULL,'2019-12-19 01:16:45',NULL,NULL,NULL,'','t7zu6','2021-03-03',1,NULL,1,NULL,1,NULL,NULL),(68,2,'scy','abca22b6c55180d1c0ff95e3d03f3f56','scy','15880738158','jjjcdr@163.com','1197345219366043649',NULL,'12',NULL,NULL,'2019-12-21 11:55:29',NULL,NULL,NULL,'','ogk7v','1994-10-21',2,NULL,1,NULL,1,NULL,NULL),(69,1,'xcb1','991506cfb1a61db7c38e29e6009427ed','陈文经','13599795023','','1196328018018181122',NULL,'13',NULL,NULL,'2019-12-27 02:54:55',NULL,NULL,NULL,'','51fc3','1994-10-22',1,NULL,1,NULL,1,NULL,NULL),(70,1,'xcb2','4d5cf9edbe2958e472d0ecc437b96d96','陈瑞清','13788864979','','1196328018018181122',NULL,'15',NULL,NULL,'2019-12-27 05:05:56',NULL,NULL,NULL,'','43plp','1994-10-22',1,NULL,1,NULL,1,NULL,NULL),(71,1,'mzj1','bf2fdba8e1d849e81dfe22af67b3cde9','王小阳','13559621092','','1196327955313336322',NULL,'15',NULL,NULL,'2019-12-27 05:09:20',NULL,NULL,NULL,'','9o8qk','1994-10-22',1,NULL,1,NULL,1,NULL,NULL),(72,1,'czj1','e69955a5a5cc94785814dbffcea21c3e','翁海勇','13599173733','','1201673316928286721',NULL,'13',NULL,NULL,'2019-12-27 05:10:52',NULL,NULL,NULL,'','iqy3x','1994-10-22',1,NULL,1,NULL,1,NULL,NULL),(73,1,'rsj1','76fa2b015a922412d12c031550280010','张荣荣','15280619456','','1197443773921181697',NULL,'9',NULL,NULL,'2019-12-27 05:12:14',NULL,NULL,NULL,'','xk309','1994-10-22',2,NULL,3,NULL,1,NULL,NULL),(74,1,'rsj2','4b2ca3b469370f8999d36551e2655c47','叶志钦','13675957398','','1197443773921181697',NULL,'9',NULL,NULL,'2019-12-27 05:12:53',NULL,NULL,NULL,'','88zdr','1994-10-22',1,NULL,3,NULL,1,NULL,NULL),(75,1,'gxj','c4dc65f4f17ca5e032ca89bd8d8d1395','陈丽瓶','15059855678','123@163.com','1196327814145646594',NULL,'14',NULL,NULL,'2019-12-27 06:53:44',NULL,NULL,NULL,'','pswr7','2019-12-31',2,NULL,1,NULL,1,NULL,NULL),(76,1,'gdj1','36fc04ea972b9f02b54d23eec4c7a14c','陈颖颖','13505079029','jjgd_5683864@163.com','1196328242593800193',NULL,'14',NULL,NULL,'2019-12-27 08:58:25',NULL,NULL,NULL,'','77wku','2021-06-02',1,NULL,1,NULL,1,NULL,NULL),(77,1,'wlj1','dc80255cb7bb738a2bd4a802cc849575','叶松青','18314645727','','1196332086363037697',NULL,'14',NULL,NULL,'2019-12-27 09:01:48',NULL,NULL,NULL,'','3y42y','1994-10-23',1,NULL,1,NULL,1,NULL,NULL),(78,1,'tyj1','30b24ff8db10fc9290ca67a40a477cef','陈一帆','13489760211','','1196332383294595073',NULL,'14',NULL,NULL,'2019-12-27 09:03:13',NULL,NULL,NULL,'','7h3q5','1988-09-29',2,NULL,1,NULL,1,NULL,NULL),(79,1,'rsj3','e505a3ec8f8004881ddc47e8bcd35af5','洪全益','13808555296','','1196332264142807042',NULL,'14',NULL,NULL,'2019-12-27 09:06:46',NULL,NULL,NULL,'','y1hfc','1995-06-12',1,NULL,3,NULL,1,NULL,NULL),(80,1,'rsj4','67c23795c209766757d00bbb3dd3c48a','洪嘉靖','13600737303','','1196328965217853442',NULL,'14',NULL,NULL,'2019-12-27 09:07:51',NULL,NULL,NULL,'','uz8p4','1995-06-12',1,NULL,3,NULL,1,NULL,NULL),(81,1,'scb1','1f2b9d3e8db28625680498161ef933f8','柯真真','18606059995','','1210488527915302913',NULL,'14',NULL,NULL,'2019-12-27 09:14:26',NULL,NULL,NULL,'','sz3iq','1995-06-12',2,NULL,1,NULL,1,NULL,NULL),(82,1,'sjj1','f492d9b88d404a95a6e39bf7efe42b85','施晖程','18965688972','','1210488645792022529',NULL,'14',NULL,NULL,'2019-12-27 09:19:57',NULL,NULL,NULL,'','myhej','1995-06-12',2,NULL,1,NULL,1,NULL,NULL),(83,1,'jyj1','94f27985149189e3b1bf0ff8b111dc09','李女元','15359825666','','1196331850672513026',NULL,'14',NULL,NULL,'2019-12-27 09:21:08',NULL,NULL,NULL,'','5u8il','1995-06-12',2,NULL,1,NULL,1,NULL,NULL),(84,1,'rsjzjk1','584ca6e51c777e6e56d35f37441fb5ca',' 洪全益','13808555296','123@163.com','1196332264142807042',NULL,'14',NULL,NULL,'2019-12-30 02:50:59',NULL,NULL,NULL,'','ion5h','2019-12-31',1,NULL,1,NULL,1,NULL,NULL),(85,1,'rsjbsh','38636864a10315187fc70a5620265ef9','洪嘉靖','13600737303','123@163.com','1196328965217853442',NULL,NULL,NULL,NULL,'2019-12-30 02:52:37',NULL,NULL,NULL,'','c1r88','2019-12-31',1,NULL,3,NULL,1,NULL,NULL),(86,1,'rsjbsh1','e47aa2eb24ed3531bdb675034fcf2112','洪嘉靖','13600737303','123@163.com','1196328965217853442',NULL,'14',NULL,NULL,'2019-12-30 02:54:01',NULL,NULL,NULL,'','dqfh8','2019-12-31',1,NULL,1,NULL,1,NULL,NULL),(87,1,'rs03','fd96af5831e5702260d4373f9c2b6033','叶志钦','13675957398','123@163.com','1197443773921181697',NULL,'9',NULL,NULL,'2019-12-30 02:57:39',NULL,NULL,NULL,'jjrcw/headPortrait/202001/1216641580266430466.jpg','7db67','2020-08-04',1,NULL,1,NULL,1,NULL,NULL),(88,1,'rsj2','2fb0ea9a1907339dc4f9222e47b0b174','张荣荣','15280619456','126@163.com','1196332264142807042',NULL,'9',NULL,NULL,'2019-12-30 02:59:41',NULL,NULL,NULL,'','8f07y','1990-10-20',2,NULL,3,NULL,1,NULL,NULL),(89,1,'rs01','333a6c06d895b4cac282e4e27105247f','林曼雅','13799500668','123@163.com','1197443773921181697',NULL,'9',NULL,NULL,'2019-12-30 03:13:54',NULL,NULL,NULL,'','ot81v','1990-10-20',2,NULL,1,NULL,1,NULL,NULL),(90,1,'rs04','e183c82948bef0d85ce4269905b431a3','蔡彬彬','13489302500','123@163.com','1197443773921181697',NULL,'9',NULL,NULL,'2020-01-02 03:08:12',NULL,NULL,NULL,'','9i3bb','2020-06-30',2,NULL,1,NULL,1,NULL,NULL),(91,1,'rs05','497ae40b1bae411728365d4f31f2ea93','吴晓婷','15280619456','123@163.com','1197443773921181697',NULL,'13,16,17',NULL,NULL,'2020-04-03 00:31:25',NULL,NULL,NULL,'','w8n4v','1994-10-22',2,NULL,3,NULL,1,NULL,NULL),(92,1,'z','d3f2f1d9d7e17dad2deffddd73cae62b','z','13675957398','','1235132762164412417',NULL,'1,9,13,14,15,16,17,21','',NULL,'2020-06-30 01:43:27',NULL,NULL,NULL,'','3qbjw','1992-12-13',1,NULL,3,NULL,1,NULL,NULL),(93,1,'jyj02','3397d15f2d38d3408d50c44c5097056d','洪青松','17362523273','','1196331850672513026',NULL,'22','',NULL,'2020-07-10 01:30:02',NULL,NULL,NULL,'','aey8e','1994-10-22',1,NULL,1,NULL,1,NULL,NULL),(94,1,'jyj03','708e02278e7d0081146727753f894c18','吴扬加','18965865390','46570625@qq.com','1196331850672513026',NULL,'22','',NULL,'2020-07-10 01:31:09',NULL,NULL,NULL,'','cd0yw','1994-10-21',1,NULL,1,NULL,1,NULL,NULL),(95,1,'sw01','af12bfceff88c33ca3520e3924648e78','叶志钦','17362523273','1508798227@qq.com','1272726686756032513',NULL,'23','',NULL,'2020-07-31 02:54:48',NULL,NULL,NULL,'','va3hk','2020-07-30',1,NULL,1,NULL,1,NULL,NULL),(96,1,'sb01','e57b242996a634b158865149885f6b62','叶志钦','17362523273','150898227@qq.com','1272726463010885634',NULL,'24','',NULL,'2020-07-31 02:55:46',NULL,NULL,NULL,'','h2qfg','1994-10-22',1,NULL,1,NULL,1,NULL,NULL),(97,1,'rs05','288259dbc9664b89f688f7c712019328','吴思莹','12345674868','','1197443773921181697',NULL,'16','',NULL,'2020-09-09 07:29:18',NULL,NULL,NULL,'','z2lk3','1994-10-22',2,NULL,2,NULL,1,NULL,NULL),(98,1,'hcxz1','7ccefd60da56c05cbee3003b3478eb98','核查小组1','13675957398','','1196347541488906242',NULL,'25','',NULL,'2020-11-03 02:41:12',NULL,NULL,NULL,'','3c3at','1995-06-12',1,NULL,3,NULL,1,NULL,NULL),(99,1,'hcxz1','9e85bfdac0b24f12b5c66f5bc9916c69','核查小组1','13675957398','','1323456497744670722',NULL,NULL,'',NULL,'2020-11-03 02:47:34',NULL,NULL,NULL,'','okhsq','2020-11-02',1,NULL,3,NULL,1,NULL,NULL),(100,1,'hcxz2','b30562013e7f6f5d0089085b63260336','走访核查小组2','13675957398','','1323456497744670722',NULL,'25','',NULL,'2020-11-03 02:48:48',NULL,NULL,NULL,'','fuzwh','1992-12-13',1,NULL,1,NULL,1,NULL,NULL),(101,1,'hcxz1','4f76b1613dd726045154961a4d2336a6','走访核查小组1','13675957398','','1323456497744670722',NULL,'25','',NULL,'2020-11-05 01:10:12',NULL,NULL,NULL,'','21iqw','1991-03-21',1,NULL,1,NULL,1,NULL,NULL),(102,1,'rs06','08a63371469c78c702f8e33dd5705e92','颜思思','15280619456','526348857@qq.com','1197443773921181697',NULL,'9','',NULL,'2021-01-15 00:22:26',NULL,NULL,NULL,'','qnjeg','2021-03-31',2,NULL,1,NULL,1,NULL,NULL),(103,1,'rs07','27530a9402171372c65fea4f8bd388b8','吴婉玲','12345678901','526348857@qq.com','1197443773921181697',NULL,'26','',NULL,'2021-04-26 00:49:14',NULL,NULL,NULL,'','u7hhw','2021-04-25',2,NULL,2,NULL,1,NULL,NULL),(104,1,'rs08','2a5c9c6140aeadb875e477896a2c4e18','人力资本','12345678900','526348857@qq.com','1197443773921181697',NULL,'9,25,14,16,17,26','',NULL,'2021-04-27 07:11:59',NULL,NULL,NULL,'','4ebzq','1994-10-22',1,NULL,3,NULL,1,NULL,NULL),(105,1,'rs08','14e7e65ec91981c1e8302e585a56eb8d','李露','15280619456','526348857@qq.com','1197443773921181697',NULL,'26','',NULL,'2021-05-25 06:59:44',NULL,NULL,NULL,'','fdonh','1994-10-22',2,NULL,1,NULL,1,NULL,NULL),(106,1,'rs09','3b2e09838106fd0fd1f50a806acfe218','陈礼贤','11111111111','222222@126.com','1197443773921181697',NULL,'26','',NULL,'2021-07-20 03:31:03',NULL,NULL,NULL,'','2yr7u','2000-11-12',1,NULL,3,NULL,1,NULL,NULL),(107,1,'hcxz02','ea0b723e0e5f9c0161c8e72c3e9b3b94','2020年度核查小组2','15280619456','jjrc85661234@163.com','1323456497744670722',NULL,'25','2',NULL,'2021-07-28 10:00:05',NULL,NULL,NULL,'','nfir1','2021-07-28',1,NULL,1,NULL,1,NULL,NULL),(108,1,'hcxz01','08396a187e5446fb250a949517c771f2','2020年度核查小组1','13333333333','123905827@qq.com','1323456497744670722',NULL,'25','1',NULL,'2021-09-02 08:00:03',NULL,NULL,NULL,'','f0bgi','2017-09-01',1,NULL,1,NULL,1,NULL,NULL),(110,1,'hcxz04','5de37130409d556153cfc186c46ede52','2020年度核查小组4','14444444444','123905827@qq.com','1323456497744670722',NULL,'25','4',NULL,'2021-09-02 09:09:13',NULL,NULL,NULL,'','zcahd','2018-08-31',1,NULL,1,NULL,1,NULL,NULL),(111,1,'hcxz05','8dd6d7618fd214550d4f21242b2f4dd9','2020年度核查小组5','13400886486','554364545@qq.com','1323456497744670722',NULL,'25','5',NULL,'2021-09-02 09:10:03',NULL,NULL,NULL,'','qtwrh','2018-08-31',1,NULL,1,NULL,1,NULL,NULL),(112,1,'hcxz06','b534398cdb67eb60459e82d26099def5','2020年度核查小组6','16666666666','2058149990@qq.com','1323456497744670722',NULL,'25','6',NULL,'2021-09-02 09:10:50',NULL,NULL,NULL,'','m0gjs','2018-08-31',1,NULL,1,NULL,1,NULL,NULL),(113,1,'hcxz07','0f589f00d925d7c97300cac72361066d','2020年度核查小组7','17777777777','123905827@qq.com','1323456497744670722',NULL,'25','7',NULL,'2021-09-02 09:12:05',NULL,NULL,NULL,'','182m4','2018-08-31',1,NULL,1,NULL,1,NULL,NULL),(114,1,'hcxz03','0e722109ba75a3735bba7b99c6ba33f6','2020年度核查小组3','13333333333','jjrc85661234@163.com','1323456497744670722',NULL,'25','3',NULL,'2021-09-03 01:57:05',NULL,NULL,NULL,'','zdbz7','2018-08-31',1,NULL,1,NULL,1,NULL,NULL),(115,2,'hym','603a5ef0b9451ace5ef7f3ec885c60ec','何渊铭','18250605595','','1197345219366043649',NULL,'12,18,20','',NULL,'2021-09-10 03:02:18',NULL,NULL,NULL,'','yjq3e','2021-09-09',1,NULL,1,NULL,1,NULL,NULL),(116,1,'rcb','b76c9159773400a2e80c32c3f0db6746','苏志英','15280619456','jjrc85661234@163.com','1197443773921181697',NULL,'9','',NULL,'2021-11-09 02:44:53',NULL,NULL,NULL,'','71ymc','2015-11-08',2,NULL,1,NULL,1,NULL,NULL),(117,1,'test','a9500faca4851162198b08eb2d71bdfd','测试123','11111111111','','1196332383294595073',NULL,'9','',NULL,'2022-08-21 06:24:41',NULL,NULL,NULL,'','wbfw2','2022-08-20',1,NULL,1,NULL,1,NULL,NULL);
/*!40000 ALTER TABLE `sys_user` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_verification_code`
--

DROP TABLE IF EXISTS `sys_verification_code`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_verification_code` (
  `id` varchar(50) NOT NULL,
  `phone` varchar(15) DEFAULT NULL COMMENT '手机号码',
  `content` varchar(50) DEFAULT NULL COMMENT '验证码内容',
  `templateCode` varchar(30) DEFAULT NULL COMMENT '发送模板',
  `state` int(1) DEFAULT NULL COMMENT '发送状态',
  `msg` varchar(100) DEFAULT NULL COMMENT '发送失败原因',
  `sendingDate` varchar(20) DEFAULT NULL COMMENT '发送日期{yyyy-MM-dd}',
  `countNum` int(3) DEFAULT NULL COMMENT '发送日期内对应的发送次数',
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(30) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(30) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='手机验证码表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_verification_code`
--

LOCK TABLES `sys_verification_code` WRITE;
/*!40000 ALTER TABLE `sys_verification_code` DISABLE KEYS */;
INSERT INTO `sys_verification_code` VALUES ('1166608326184079361','17362523273','{\"code\":\"542498\"}',NULL,1,'签名不合法(不存在或被拉黑)','2019-08-28',3,NULL,'2019-08-28 15:07:54',NULL,'2019-08-28 15:13:39'),('1174888685626494978','13115785528','{\"code\":\"966491\"}','SMS_127035053',1,NULL,'2019-10-14',1,NULL,'2019-09-20 11:31:05',NULL,'2019-10-14 11:49:39'),('1176402647867117569','13895528904','{\"code\":\"250439\"}','SMS_127035053',1,NULL,'2019-09-24',1,NULL,'2019-09-24 15:47:02',NULL,'2019-09-24 15:47:02'),('1176402981641441281','15280619456','{\"code\":\"365142\"}','SMS_127035053',1,NULL,'2019-12-03',1,NULL,'2019-09-24 15:48:21',NULL,'2019-12-03 09:00:32'),('1177147687916965890','17362523273','{\"code\":\"872943\"}','SMS_127035053',1,NULL,'2019-12-03',1,NULL,'2019-09-26 17:07:33',NULL,'2019-12-03 15:21:09'),('1182184185720418305','13313876229','{\"code\":\"779573\"}','SMS_127035053',1,NULL,'2019-11-29',1,NULL,'2019-10-10 14:40:48',NULL,'2019-11-29 09:42:35'),('1182216764246929409','15880921912','{\"code\":\"605407\"}','SMS_127035053',1,NULL,'2019-10-10',1,NULL,'2019-10-10 16:50:15',NULL,'2019-10-10 16:50:15'),('1182625316520763394','18372551198','{\"code\":\"324846\"}','SMS_127035053',1,NULL,'2019-10-11',1,NULL,'2019-10-11 19:53:42',NULL,'2019-10-11 19:53:42'),('1182879330237579265','18372562347','{\"code\":\"596142\"}','SMS_127035053',1,NULL,'2019-10-21',1,NULL,'2019-10-12 12:43:03',NULL,'2019-10-21 14:41:21'),('1183592161097363458','13115785528','{\"code\":\"569649\"}','SMS_127035051',1,NULL,'2019-10-14',1,NULL,'2019-10-14 11:55:36',NULL,'2019-10-14 15:48:36'),('1183673746157969409','13959757007','{\"code\":\"426808\"}','SMS_127035053',1,'没有访问权限','2019-10-22',2,NULL,'2019-10-14 17:19:47',NULL,'2019-10-22 09:24:48'),('1184017121553915906','13675957398','{\"code\":\"894708\"}','SMS_127035053',1,'没有访问权限','2019-12-03',1,NULL,'2019-10-15 16:04:14',NULL,'2019-12-03 08:26:14'),('1184380929672175617','19971782113','{\"code\":\"950577\"}','SMS_127035053',1,'没有访问权限','2019-11-28',1,NULL,'2019-10-16 16:09:53',NULL,'2019-11-28 14:41:22'),('1184385495503429634','19971787215','{\"code\":\"959831\"}','SMS_127035053',2,'没有访问权限','2019-10-16',2,NULL,'2019-10-16 16:28:01',NULL,'2019-10-16 17:00:54'),('1184394083441532929','19971787213','{\"code\":\"760812\"}','SMS_127035053',1,'没有访问权限','2019-11-21',2,NULL,'2019-10-16 17:02:09',NULL,'2019-11-21 18:11:24'),('1184642839829868545','17610042775','{\"code\":\"058053\"}','SMS_127035053',2,'没有访问权限','2019-10-17',4,NULL,'2019-10-17 09:30:37',NULL,'2019-10-17 09:34:45'),('1186170928868593666','18372503381','{\"code\":\"733718\"}','SMS_127035053',1,NULL,'2019-10-21',1,NULL,'2019-10-21 14:42:42',NULL,'2019-10-21 14:42:42'),('1186535840364580865','15880738158','{\"code\":\"389706\"}','SMS_127035053',1,NULL,'2019-10-22',3,NULL,'2019-10-22 14:52:44',NULL,'2019-10-22 14:57:29'),('1197052415960645634','15327039271','{\"code\":\"636650\"}','SMS_127035053',1,NULL,'2019-11-20',1,NULL,'2019-11-20 15:21:50',NULL,'2019-11-20 15:21:50'),('1197441284362682369','15959420909','{\"code\":\"075438\"}','SMS_127035053',1,NULL,'2019-11-21',1,NULL,'2019-11-21 17:07:04',NULL,'2019-11-21 17:07:04'),('1198788332714455041','18959858592','{\"code\":\"792076\"}','SMS_127035053',1,NULL,'2019-11-25',1,NULL,'2019-11-25 10:19:45',NULL,'2019-11-25 10:19:45'),('1198870028931559425','15396486268','{\"code\":\"831749\"}','SMS_127035053',1,NULL,'2019-11-25',1,NULL,'2019-11-25 15:44:23',NULL,'2019-11-25 15:44:23'),('1199133730587013121','18350528526','{\"code\":\"319863\"}','SMS_127035053',1,NULL,'2019-11-26',1,NULL,'2019-11-26 09:12:14',NULL,'2019-11-26 09:12:14'),('1199943330542350338','13599110629','{\"code\":\"706101\"}','SMS_127035053',1,NULL,'2019-11-28',1,NULL,'2019-11-28 14:49:18',NULL,'2019-11-28 14:49:18');
/*!40000 ALTER TABLE `sys_verification_code` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_verification_history`
--

DROP TABLE IF EXISTS `sys_verification_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_verification_history` (
  `id` varchar(50) NOT NULL,
  `phone` varchar(15) DEFAULT NULL COMMENT '手机号码',
  `content` varchar(50) DEFAULT NULL COMMENT '验证码内容',
  `templateCode` varchar(30) DEFAULT NULL COMMENT '发送模板',
  `state` int(1) DEFAULT NULL COMMENT '发送状态{1-成功，2-失败}',
  `msg` varchar(100) DEFAULT NULL COMMENT '发送失败原因',
  `sendingDate` varchar(20) DEFAULT NULL COMMENT '发送日期{yyyy-MM-dd}',
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(30) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(30) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='手机验证码历史记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_verification_history`
--

LOCK TABLES `sys_verification_history` WRITE;
/*!40000 ALTER TABLE `sys_verification_history` DISABLE KEYS */;
INSERT INTO `sys_verification_history` VALUES ('1166608327115214850','17362523273','{\"code\":\"057463\"}',NULL,2,'签名不合法(不存在或被拉黑)','2019-08-28',NULL,'2019-08-28 15:07:54',NULL,'2019-08-28 15:07:54'),('1166609132648058881','17362523273','{\"code\":\"701279\"}',NULL,2,'签名不合法(不存在或被拉黑)','2019-08-28',NULL,'2019-08-28 15:11:06',NULL,'2019-08-28 15:11:06'),('1166609775769083905','17362523273','{\"code\":\"542498\"}',NULL,1,'签名不合法(不存在或被拉黑)','2019-08-28',NULL,'2019-08-28 15:13:39',NULL,'2019-08-28 15:13:39'),('1174888686456967169','13115785528','{\"code\":\"811463\"}','SMS_127035053',1,NULL,'2019-09-20',NULL,'2019-09-20 11:31:05',NULL,'2019-09-20 11:31:05'),('1176402650408865794','13895528904','{\"code\":\"250439\"}','SMS_127035053',1,NULL,'2019-09-24',NULL,'2019-09-24 15:47:03',NULL,'2019-09-24 15:47:03'),('1176402981838573569','15280619456','{\"code\":\"438212\"}','SMS_127035053',1,NULL,'2019-09-24',NULL,'2019-09-24 15:48:22',NULL,'2019-09-24 15:48:22'),('1176417103280001025','15280619456','{\"code\":\"588520\"}','SMS_127035053',1,NULL,'2019-09-24',NULL,'2019-09-24 16:44:28',NULL,'2019-09-24 16:44:28'),('1177147688814546946','17362523273','{\"code\":\"272061\"}','SMS_127035053',1,NULL,'2019-09-26',NULL,'2019-09-26 17:07:34',NULL,'2019-09-26 17:07:34'),('1182184186743828481','13313876229','{\"code\":\"325026\"}','SMS_127035053',1,NULL,'2019-10-10',NULL,'2019-10-10 14:40:48',NULL,'2019-10-10 14:40:48'),('1182216473611022338','15280619456','{\"code\":\"980687\"}','SMS_127035053',1,NULL,'2019-10-10',NULL,'2019-10-10 16:49:06',NULL,'2019-10-10 16:49:06'),('1182216764418895873','15880921912','{\"code\":\"605407\"}','SMS_127035053',1,NULL,'2019-10-10',NULL,'2019-10-10 16:50:15',NULL,'2019-10-10 16:50:15'),('1182625316969553922','18372551198','{\"code\":\"324846\"}','SMS_127035053',1,NULL,'2019-10-11',NULL,'2019-10-11 19:53:42',NULL,'2019-10-11 19:53:42'),('1182879330954805250','18372562347','{\"code\":\"613396\"}','SMS_127035053',1,NULL,'2019-10-12',NULL,'2019-10-12 12:43:03',NULL,'2019-10-12 12:43:03'),('1183590668608778241','13115785528','{\"code\":\"966491\"}','SMS_127035053',1,NULL,'2019-10-14',NULL,'2019-10-14 11:49:40',NULL,'2019-10-14 11:49:40'),('1183592161848143874','13115785528','{\"code\":\"569649\"}','SMS_127035051',1,NULL,'2019-10-14',NULL,'2019-10-14 11:55:36',NULL,'2019-10-14 11:55:36'),('1183673748171235330','13959757007','{\"code\":\"151488\"}','SMS_127035053',2,'没有访问权限','2019-10-14',NULL,'2019-10-14 17:19:47',NULL,'2019-10-14 17:19:47'),('1183674002715156482','13959757007','{\"code\":\"972371\"}','SMS_127035053',2,'没有访问权限','2019-10-14',NULL,'2019-10-14 17:20:48',NULL,'2019-10-14 17:20:48'),('1183674357033181185','13959757007','{\"code\":\"020981\"}','SMS_127035053',2,'没有访问权限','2019-10-14',NULL,'2019-10-14 17:22:12',NULL,'2019-10-14 17:22:12'),('1184017121725882369','13675957398','{\"code\":\"638351\"}','SMS_127035053',2,'没有访问权限','2019-10-15',NULL,'2019-10-15 16:04:14',NULL,'2019-10-15 16:04:14'),('1184017375992979458','13675957398','{\"code\":\"761090\"}','SMS_127035053',2,'没有访问权限','2019-10-15',NULL,'2019-10-15 16:05:15',NULL,'2019-10-15 16:05:15'),('1184018639107629057','13675957398','{\"code\":\"770102\"}','SMS_127035053',2,'没有访问权限','2019-10-15',NULL,'2019-10-15 16:10:16',NULL,'2019-10-15 16:10:16'),('1184019096127381505','13675957398','{\"code\":\"472004\"}','SMS_127035053',2,'没有访问权限','2019-10-15',NULL,'2019-10-15 16:12:05',NULL,'2019-10-15 16:12:05'),('1184019350700662786','13675957398','{\"code\":\"544130\"}','SMS_127035053',2,'没有访问权限','2019-10-15',NULL,'2019-10-15 16:13:05',NULL,'2019-10-15 16:13:05'),('1184019774686076930','13675957398','{\"code\":\"047568\"}','SMS_127035053',2,'没有访问权限','2019-10-15',NULL,'2019-10-15 16:14:46',NULL,'2019-10-15 16:14:46'),('1184035878489792513','13959757007','{\"code\":\"341475\"}','SMS_127035053',2,'没有访问权限','2019-10-15',NULL,'2019-10-15 17:18:46',NULL,'2019-10-15 17:18:46'),('1184263204842479618','13675957398','{\"code\":\"016291\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 08:22:05',NULL,'2019-10-16 08:22:05'),('1184297329582350338','13675957398','{\"code\":\"865185\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 10:37:41',NULL,'2019-10-16 10:37:41'),('1184357661352861697','13675957398','{\"code\":\"721106\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 14:37:25',NULL,'2019-10-16 14:37:25'),('1184380930372624385','19971782113','{\"code\":\"602725\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 16:09:53',NULL,'2019-10-16 16:09:53'),('1184385495822196738','19971787215','{\"code\":\"740829\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 16:28:01',NULL,'2019-10-16 16:28:01'),('1184392440222277633','19971782113','{\"code\":\"881783\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 16:55:37',NULL,'2019-10-16 16:55:37'),('1184393521257996290','19971782113','{\"code\":\"152625\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 16:59:55',NULL,'2019-10-16 16:59:55'),('1184393772052209666','19971787215','{\"code\":\"959831\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 17:00:54',NULL,'2019-10-16 17:00:54'),('1184394083735134209','19971787213','{\"code\":\"210451\"}','SMS_127035053',2,'没有访问权限','2019-10-16',NULL,'2019-10-16 17:02:09',NULL,'2019-10-16 17:02:09'),('1184642840622592002','17610042775','{\"code\":\"170708\"}','SMS_127035053',2,'没有访问权限','2019-10-17',NULL,'2019-10-17 09:30:37',NULL,'2019-10-17 09:30:37'),('1184643241199595522','17610042775','{\"code\":\"896025\"}','SMS_127035053',2,'没有访问权限','2019-10-17',NULL,'2019-10-17 09:32:12',NULL,'2019-10-17 09:32:12'),('1184643495726739458','17610042775','{\"code\":\"991133\"}','SMS_127035053',2,'没有访问权限','2019-10-17',NULL,'2019-10-17 09:33:13',NULL,'2019-10-17 09:33:13'),('1184643880604463106','17610042775','{\"code\":\"058053\"}','SMS_127035053',2,'没有访问权限','2019-10-17',NULL,'2019-10-17 09:34:45',NULL,'2019-10-17 09:34:45'),('1184740201691529217','13675957398','{\"code\":\"588901\"}','SMS_127035053',2,'没有访问权限','2019-10-17',NULL,'2019-10-17 15:57:30',NULL,'2019-10-17 15:57:30'),('1185465534215065601','19971782113','{\"code\":\"192796\"}','SMS_127035053',2,'没有访问权限','2019-10-19',NULL,'2019-10-19 15:59:42',NULL,'2019-10-19 15:59:42'),('1186170593919864833','18372562347','{\"code\":\"596142\"}','SMS_127035053',1,NULL,'2019-10-21',NULL,'2019-10-21 14:41:22',NULL,'2019-10-21 14:41:22'),('1186170929191555073','18372503381','{\"code\":\"733718\"}','SMS_127035053',1,NULL,'2019-10-21',NULL,'2019-10-21 14:42:42',NULL,'2019-10-21 14:42:42'),('1186203086305292289','13675957398','{\"code\":\"784208\"}','SMS_127035053',1,'没有访问权限','2019-10-21',NULL,'2019-10-21 16:50:29',NULL,'2019-10-21 16:50:29'),('1186203493677068290','15280619456','{\"code\":\"921262\"}','SMS_127035053',1,NULL,'2019-10-21',NULL,'2019-10-21 16:52:06',NULL,'2019-10-21 16:52:06'),('1186451685521989633','13959757007','{\"code\":\"844222\"}','SMS_127035053',1,'没有访问权限','2019-10-22',NULL,'2019-10-22 09:18:19',NULL,'2019-10-22 09:18:19'),('1186453317517287425','13959757007','{\"code\":\"426808\"}','SMS_127035053',1,'没有访问权限','2019-10-22',NULL,'2019-10-22 09:24:48',NULL,'2019-10-22 09:24:48'),('1186535841849364482','15880738158','{\"code\":\"217659\"}','SMS_127035053',1,NULL,'2019-10-22',NULL,'2019-10-22 14:52:44',NULL,'2019-10-22 14:52:44'),('1186536741900865538','15880738158','{\"code\":\"133754\"}','SMS_127035053',1,NULL,'2019-10-22',NULL,'2019-10-22 14:56:18',NULL,'2019-10-22 14:56:18'),('1186537038136168450','15880738158','{\"code\":\"389706\"}','SMS_127035053',1,NULL,'2019-10-22',NULL,'2019-10-22 14:57:29',NULL,'2019-10-22 14:57:29'),('1194151903537344513','19971782113','{\"code\":\"301552\"}','SMS_127035053',1,'没有访问权限','2019-11-12',NULL,'2019-11-12 15:16:14',NULL,'2019-11-12 15:16:14'),('1194153041355550721','19971782113','{\"code\":\"910391\"}','SMS_127035053',1,'没有访问权限','2019-11-12',NULL,'2019-11-12 15:20:46',NULL,'2019-11-12 15:20:46'),('1196322532036947969','17362523273','{\"code\":\"859302\"}','SMS_127035053',1,NULL,'2019-11-18',NULL,'2019-11-18 15:01:32',NULL,'2019-11-18 15:01:32'),('1196695379079024641','19971782113','{\"code\":\"563388\"}','SMS_127035053',1,'没有访问权限','2019-11-19',NULL,'2019-11-19 15:43:06',NULL,'2019-11-19 15:43:06'),('1197052416640122882','15327039271','{\"code\":\"636650\"}','SMS_127035053',1,NULL,'2019-11-20',NULL,'2019-11-20 15:21:50',NULL,'2019-11-20 15:21:50'),('1197441284664672257','15959420909','{\"code\":\"075438\"}','SMS_127035053',1,NULL,'2019-11-21',NULL,'2019-11-21 17:07:04',NULL,'2019-11-21 17:07:04'),('1197454894619684865','19971787213','{\"code\":\"827058\"}','SMS_127035053',1,'没有访问权限','2019-11-21',NULL,'2019-11-21 18:01:09',NULL,'2019-11-21 18:01:09'),('1197457477270650881','19971787213','{\"code\":\"760812\"}','SMS_127035053',1,'没有访问权限','2019-11-21',NULL,'2019-11-21 18:11:24',NULL,'2019-11-21 18:11:24'),('1198788332957724674','18959858592','{\"code\":\"792076\"}','SMS_127035053',1,NULL,'2019-11-25',NULL,'2019-11-25 10:19:45',NULL,'2019-11-25 10:19:45'),('1198870029208383490','15396486268','{\"code\":\"831749\"}','SMS_127035053',1,NULL,'2019-11-25',NULL,'2019-11-25 15:44:23',NULL,'2019-11-25 15:44:23'),('1199133730868031489','18350528526','{\"code\":\"319863\"}','SMS_127035053',1,NULL,'2019-11-26',NULL,'2019-11-26 09:12:14',NULL,'2019-11-26 09:12:14'),('1199593292301594625','15280619456','{\"code\":\"185619\"}','SMS_127035053',1,NULL,'2019-11-27',NULL,'2019-11-27 15:38:22',NULL,'2019-11-27 15:38:22'),('1199608674898931714','15280619456','{\"code\":\"844297\"}','SMS_127035053',1,NULL,'2019-11-27',NULL,'2019-11-27 16:39:30',NULL,'2019-11-27 16:39:30'),('1199941334313693185','19971782113','{\"code\":\"950577\"}','SMS_127035053',1,'没有访问权限','2019-11-28',NULL,'2019-11-28 14:41:22',NULL,'2019-11-28 14:41:22'),('1199943330844340225','13599110629','{\"code\":\"706101\"}','SMS_127035053',1,NULL,'2019-11-28',NULL,'2019-11-28 14:49:18',NULL,'2019-11-28 14:49:18'),('1200228530841153538','13313876229','{\"code\":\"779573\"}','SMS_127035053',1,NULL,'2019-11-29',NULL,'2019-11-29 09:42:35',NULL,'2019-11-29 09:42:35'),('1201432939658964993','13675957398','{\"code\":\"582985\"}','SMS_127035053',1,'没有访问权限','2019-12-02',NULL,'2019-12-02 17:28:29',NULL,'2019-12-02 17:28:29'),('1201658867873968129','13675957398','{\"code\":\"894708\"}','SMS_127035053',1,'没有访问权限','2019-12-03',NULL,'2019-12-03 08:26:14',NULL,'2019-12-03 08:26:14'),('1201667500926005250','15280619456','{\"code\":\"365142\"}','SMS_127035053',1,NULL,'2019-12-03',NULL,'2019-12-03 09:00:32',NULL,'2019-12-03 09:00:32'),('1201763287622713345','17362523273','{\"code\":\"872943\"}','SMS_127035053',1,NULL,'2019-12-03',NULL,'2019-12-03 15:21:10',NULL,'2019-12-03 15:21:10');
/*!40000 ALTER TABLE `sys_verification_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `sys_visit_group`
--

DROP TABLE IF EXISTS `sys_visit_group`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `sys_visit_group` (
  `id` varchar(40) NOT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `year` varchar(6) DEFAULT NULL COMMENT '申报年度',
  `name` varchar(100) DEFAULT NULL COMMENT '核查小组',
  `talentType` varchar(1000) DEFAULT NULL COMMENT '人才标签',
  `street` varchar(255) DEFAULT NULL COMMENT '所属镇街',
  `description` varchar(255) DEFAULT NULL,
  `createTime` varchar(50) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(50) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `sys_visit_group`
--

LOCK TABLES `sys_visit_group` WRITE;
/*!40000 ALTER TABLE `sys_visit_group` DISABLE KEYS */;
INSERT INTO `sys_visit_group` VALUES ('1423100539360546818',1,'2020','2','gzh-00001,00002,00004;myqy-00002,00013,00014',NULL,NULL,NULL,NULL,NULL,NULL),('1433357633254875138',1,'2020','5','myqy-00003,00008,00010,00021;mtdw-00003;gyqyh-00003,00008,00010,00021',NULL,NULL,NULL,NULL,NULL,NULL),('1433369099928363009',1,'2020','6','myqy-00016,00017,00018;qzrygwh-00017;qzrybz-00017;zbzgjskyzd-00017;zbzgjsjxky-00017;zbzgjsjx-00017;zzjs-00017',NULL,NULL,NULL,NULL,NULL,NULL),('1433610893253435393',1,'2020','3','myqy-00005,00015,00019,00020',NULL,NULL,NULL,NULL,NULL,NULL),('1433637528530870273',1,'2020','1','myqy-00001,00002,00006;mtdw-00001;sydw-00001;gyqyh-00001,00002,00006;mbfqy-00001',NULL,NULL,NULL,NULL,NULL,NULL),('1435046066226487297',1,'2020','4','myqy-00007,00009,00011;gbwszb-00003,00007,00013,00019;gbwsbw-00003,00007,00013,00019',NULL,NULL,NULL,NULL,NULL,NULL),('1435071331321274369',1,'2020','7','myqy-00004,00012;xzry-00004,00012;zzjs-00004,00012;wpjs-00004,00012',NULL,NULL,NULL,NULL,NULL,NULL),('1465238241052479489',1,'2020','1','other-00002,00003;mbylwsjg-00002',NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `sys_visit_group` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `talent_allowance_filetype`
--

DROP TABLE IF EXISTS `talent_allowance_filetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `talent_allowance_filetype` (
  `id` varchar(255) NOT NULL COMMENT '唯一标识',
  `talentType` varchar(20) NOT NULL DEFAULT '' COMMENT '申报人才类型',
  `inputPerson` varchar(20) NOT NULL COMMENT '录入人员',
  `name` varchar(50) NOT NULL COMMENT '附件类型名称',
  `api` varchar(20) NOT NULL COMMENT '附件类型api',
  `must` tinyint(4) NOT NULL DEFAULT 2 COMMENT '是否必传',
  `active` tinyint(4) NOT NULL DEFAULT 2 COMMENT '是否有效',
  `checkCompany` varchar(30) DEFAULT NULL COMMENT '审核单位',
  `sn` tinyint(4) NOT NULL COMMENT '排序',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` datetime DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` datetime DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '更新用户',
  `templateUrl` varchar(255) DEFAULT NULL COMMENT '模板',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `talent_allowance_filetype`
--

LOCK TABLES `talent_allowance_filetype` WRITE;
/*!40000 ALTER TABLE `talent_allowance_filetype` DISABLE KEYS */;
INSERT INTO `talent_allowance_filetype` VALUES ('1160832740686684161','gzh','1','2','2',2,2,'1158293574504660993',2,'2','2019-08-12 16:37:47','1','2019-10-29 09:59:50','1',NULL);
/*!40000 ALTER TABLE `talent_allowance_filetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channel_plan_filetype`
--

DROP TABLE IF EXISTS `un_channel_plan_filetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channel_plan_filetype` (
  `id` varchar(50) NOT NULL COMMENT 'id主键',
  `name` varchar(80) DEFAULT NULL COMMENT '附件名称',
  `api` varchar(20) DEFAULT NULL COMMENT 'api',
  `must` tinyint(1) unsigned zerofill DEFAULT 0 COMMENT '是否必传',
  `member` tinyint(1) DEFAULT 1 COMMENT '是否成员',
  `active` tinyint(1) DEFAULT 1 COMMENT '是否有效',
  `sn` tinyint(2) DEFAULT 1 COMMENT '排序',
  `checkCompany` varchar(50) DEFAULT NULL COMMENT '审核单位',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `templateUrl` varchar(255) DEFAULT NULL COMMENT '模板',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报附件表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channel_plan_filetype`
--

LOCK TABLES `un_channel_plan_filetype` WRITE;
/*!40000 ALTER TABLE `un_channel_plan_filetype` DISABLE KEYS */;
INSERT INTO `un_channel_plan_filetype` VALUES ('1160739669725859842','毕业证','graduate',1,1,1,1,'1158293574504660993','','2019-08-12 10:27:57','1','2019-08-30 09:29:59','1','jjrcw/fileTypeTemplate/201908/1167248057754345474.jpg'),('1160760708505690114','身份证','idCard',1,1,1,2,'1158667798779936769','','2019-08-12 11:51:33','1','2019-08-24 17:24:38','1','jjrcw/fileTypeTemplate/201908/1165193183539888130.docx'),('1165289140952719362','历史记录','doExport-but',1,1,1,3,'1158293574504660993','','2019-08-24 23:45:55','1','2019-08-24 23:51:14','1','jjrcw/fileTypeTemplate/201908/1165290472895889410.jpg'),('1169899622106513409','项目承载单位资料','companyFile',1,2,1,4,'1168171264919609345','','2019-09-06 17:06:20','1',NULL,NULL,'jjrcw/fileTypeTemplate/201909/1169899617928986626.gif'),('1169900506202882049','项目知识产权相关证明文件','patentFile',2,2,1,5,'1168171264919609345','','2019-09-06 17:09:50','1',NULL,NULL,'jjrcw/fileTypeTemplate/201909/1169900503556276225.gif'),('1169902235178876930','项目入选其他专项或者计划的相关证明文件','otherPlanFile',2,2,1,6,'1158293574504660993','','2019-09-06 17:16:43','1','2019-09-06 17:26:35','1','jjrcw/fileTypeTemplate/201909/1169902232536465410.png'),('1169904412530163713','其他相关资格、业绩、科研成果等证明材料','otherEvidence',2,2,1,7,'1168171264919609345','','2019-09-06 17:25:22','1',NULL,NULL,'jjrcw/fileTypeTemplate/201909/1169904410202324993.gif');
/*!40000 ALTER TABLE `un_channel_plan_filetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_basicinfo`
--

DROP TABLE IF EXISTS `un_channelplan_basicinfo`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_basicinfo` (
  `id` varchar(30) NOT NULL COMMENT '唯一标志',
  `project` varchar(100) NOT NULL COMMENT '申报项目',
  `type` varchar(30) NOT NULL COMMENT '申报类型',
  `batchId` varchar(30) NOT NULL COMMENT '申报批次ID',
  `enterprise` varchar(255) NOT NULL COMMENT '项目承载单位',
  `idCard` varchar(50) NOT NULL COMMENT '企业信用代码',
  `field` varchar(30) NOT NULL COMMENT '专业领域',
  `contactsName` varchar(50) DEFAULT NULL COMMENT '联系人',
  `contactsPhone` varchar(20) DEFAULT NULL COMMENT '联系电话（办公）',
  `contactsMobile` varchar(11) DEFAULT NULL COMMENT '联系电话（手机）',
  `bankName` varchar(100) DEFAULT NULL COMMENT '开户银行',
  `bankAddress` varchar(100) DEFAULT NULL COMMENT '开户网点',
  `bankNumber` varchar(30) DEFAULT NULL COMMENT '银行账号',
  `patentDetail` text DEFAULT NULL COMMENT '自主产权专利情况',
  `projectDetail` text DEFAULT NULL COMMENT '项目介绍',
  `teamProfile` text DEFAULT NULL COMMENT '团队简介',
  `supportUnit` varchar(500) DEFAULT NULL COMMENT '项目实施实验平台支撑单位',
  `registMonney` varchar(10) DEFAULT NULL COMMENT '注册资金',
  `doctorsNumber` tinyint(5) DEFAULT NULL COMMENT '博士人数',
  `masterNumber` tinyint(5) DEFAULT NULL COMMENT '硕士人数',
  `undergraduateNumber` tinyint(5) DEFAULT NULL COMMENT '本科人数',
  `otherNumber` tinyint(5) DEFAULT NULL COMMENT '其他人数',
  `enterpriseDetail` text DEFAULT NULL COMMENT '企业基本情况简介',
  `zbgcAndGqjg` text DEFAULT NULL COMMENT '资本构成和股权结构',
  `technicalAndManageTeam` text DEFAULT NULL COMMENT '技术团队和管理团队',
  `projectAndManageRes` text DEFAULT NULL COMMENT '创业项目及主要研发成果',
  `coreTechnology` text DEFAULT NULL COMMENT '核心技术优势及产品竞争力介绍',
  `enterpriseSocietyResult` text DEFAULT NULL COMMENT '企业社会效益（含节能减排）',
  `productForeground` text DEFAULT NULL COMMENT '企业及产品市场前景',
  `workTarget` text DEFAULT NULL COMMENT '工作目标',
  `mainWay` text DEFAULT NULL COMMENT '主要方式',
  `foundation` text DEFAULT NULL COMMENT '现有基础',
  `projectDegree` text DEFAULT NULL COMMENT '项目计划进度',
  `projectScheme` text DEFAULT NULL COMMENT '项目实施方案',
  `expectedContribution` text DEFAULT NULL COMMENT '预期贡献',
  `group` varchar(30) DEFAULT NULL COMMENT '评审分组',
  `checkState` tinyint(3) NOT NULL COMMENT '审核状态',
  `secScore` decimal(10,0) DEFAULT NULL COMMENT '函审得分',
  `secType` varchar(30) DEFAULT NULL COMMENT '函审推荐类型',
  `secMsg` varchar(255) DEFAULT NULL COMMENT '函审意见',
  `thirdScore` decimal(10,0) DEFAULT NULL COMMENT '现场评审得分',
  `thirdType` varchar(30) DEFAULT NULL COMMENT '现场评审推荐类型',
  `thirdMsg` varchar(255) DEFAULT NULL COMMENT '现场评审意见',
  `lastType` varchar(30) DEFAULT NULL COMMENT '终审推荐类型',
  `lastMsg` varchar(255) DEFAULT NULL COMMENT '终审意见',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_basicinfo`
--

LOCK TABLES `un_channelplan_basicinfo` WRITE;
/*!40000 ALTER TABLE `un_channelplan_basicinfo` DISABLE KEYS */;
INSERT INTO `un_channelplan_basicinfo` VALUES ('1169092577866309633','测试01','ds_1','1168804093268168706','1161200620462718978','9527','pf_xjzz','qjc','18771042766','15920046749','中国银行','江夏分行','95789','9527','9527','中华小当家','海贼王','1200',1,1,1,1,'火影忍者','罗小黑战纪','夏目友人帐','蝙蝠侠','超人','神奇女侠','海王','绿灯侠','绿箭侠','蝙蝠女侠','Batgirl','罗宾','红罗宾',NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','2019-09-04 11:39:25','1161200620462718978',NULL,NULL),('1171326538470420482','中国','ds_2','1179623225550778370','1161200620462718978','123','pf_xcl','qjc','123123','18771042766','12','123','12','1231314','1323131','123','123','23',123,12,12,13,'12','31','23','13','12','31','321','123','123','13','12','31','23',NULL,25,30,'ds_2','真是好',30,'ds_2','真的好','ds_2','123456','','2019-09-10 15:36:23','1161200620462718978','2019-10-11 15:08:46','1161200620462718978'),('1179739450847080449','中华人民','ds_2','1179623225550778370','1161200620462718978','12','pf_xjzz','32','132','12','12','31','32','13','12','3212','1231','12324',12,12,12,12,'12312','12313','2123321','123123','123123','12123','3231123','12','32','12','32','12','32',NULL,5,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'','2019-10-03 20:46:18','1161200620462718978','2019-10-04 21:59:16','1161200620462718978'),('1184291340205449218','中国火箭研发','ds_2','1179623225550778370','1182879508302561282','123131','pf_jcdl','adada','17610246755','18372562347','中华银行','中华银行','4423231324689087','奥米比亚','借风使船','中国哲学','中的若干','21',21,21,21,21,'一帆风顺','吉祥如意','抗战期间','趋炎附势','入伍服役','节能减排','以人为本','','','','','','',NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2019-10-16 10:13:52','1182879508302561282','2019-10-23 16:55:18','1182879508302561282'),('1184306689009278977','哥谭学院','ds_1','1179623225550778370','1182879508302561282','123131','pf_xcl','adada','','18372562347','','中华银行','','','','','','',NULL,NULL,NULL,NULL,'','','','','','','','','','','','','',NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2019-10-16 11:14:52','1182879508302561282','2019-10-16 16:18:22','1182879508302561282'),('1184747722939625473','中华小字典','ds_1','1182863739255529473','1182879508302561282','123131','pf_xjzz','adada','17610042775','18372562347','','中华银行','42282534233452435','','','','','',NULL,NULL,NULL,NULL,'','','','','','','','','','','','','',NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2019-10-17 16:27:23','1182879508302561282','2019-10-24 16:44:12','1182879508302561282'),('1187281378296016898','测试','','','1182879508302561282','123131','','adada','','18372562347','','','','','','','','',NULL,NULL,NULL,NULL,'','','','','','','','','','','','','',NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,'2019-10-24 16:15:13','1182879508302561282','2019-10-24 16:16:38','1182879508302561282');
/*!40000 ALTER TABLE `un_channelplan_basicinfo` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_checklog`
--

DROP TABLE IF EXISTS `un_channelplan_checklog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_checklog` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `cpId` varchar(30) DEFAULT NULL COMMENT '海峡计划申报Id',
  `operatorId` varchar(30) DEFAULT NULL COMMENT '操作员Id(非用户操作为单位Id或管理员Id;用户操作为企业Id)',
  `type` tinyint(1) DEFAULT NULL COMMENT '操作类型（1-用户操作，2-初审，3-函审，4-现场评审，5-终审）',
  `operation` varchar(255) DEFAULT NULL COMMENT '具体操作',
  `operationTime` varchar(40) DEFAULT NULL COMMENT '操作时间',
  `reason` varchar(255) DEFAULT NULL COMMENT '操作理由（审核意见）',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报操作日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_checklog`
--

LOCK TABLES `un_channelplan_checklog` WRITE;
/*!40000 ALTER TABLE `un_channelplan_checklog` DISABLE KEYS */;
INSERT INTO `un_channelplan_checklog` VALUES ('1171329627650818050','1171326538470420482','1161200620462718978',1,'保存未提交 ==》待初审','2019-09-10 15:48:40',NULL,NULL,NULL,NULL,NULL,NULL),('1171330009273761794','1171326538470420482','1161200620462718978',1,'保存未提交 ==》待初审','2019-09-10 15:50:10',NULL,NULL,NULL,NULL,NULL,NULL),('1171330289574903810','1171326538470420482','1161200620462718978',1,'保存未提交 ==》待初审','2019-09-10 15:51:13',NULL,NULL,NULL,NULL,NULL,NULL),('1171330709995159553','1171326538470420482','1161200620462718978',1,'保存未提交 ==》待初审','2019-09-10 15:52:57',NULL,NULL,NULL,NULL,NULL,NULL),('1171330867256393729','1171326538470420482','1161200620462718978',1,'保存未提交 ==》待初审','2019-09-10 15:53:35',NULL,NULL,NULL,NULL,NULL,NULL),('1171335745601044481',NULL,'1',2,'待初审 ==》退回','2019-09-10 16:12:54',NULL,NULL,NULL,NULL,NULL,NULL),('1171342971669610498',NULL,'1',2,'待初审 ==》待函审','2019-09-10 16:41:41',NULL,NULL,NULL,NULL,NULL,NULL),('1174944289323773954','1171326538470420482','1',3,'待函审==》待现场评审','2019-09-20 15:12:02',NULL,NULL,'2019-09-20 15:12:02','1',NULL,NULL),('1174944366213754881','1171326538470420482','1',3,'待函审==》待现场评审','2019-09-20 15:12:20',NULL,NULL,'2019-09-20 15:12:20','1',NULL,NULL),('1174944373159522306','1171326538470420482','1',3,'待函审==》待现场评审','2019-09-20 15:12:22',NULL,NULL,'2019-09-20 15:12:22','1',NULL,NULL),('1174944375281840130','1171326538470420482','1',3,'待函审==》待现场评审','2019-09-20 15:12:23',NULL,NULL,'2019-09-20 15:12:23','1',NULL,NULL),('1175967796081987586','1171326538470420482','1',3,'待函审==》待现场评审','2019-09-23 10:59:05',NULL,NULL,'2019-09-23 10:59:05','1',NULL,NULL),('1175967798065893377','1171326538470420482','1',3,'待函审==》待现场评审','2019-09-23 10:59:06',NULL,NULL,'2019-09-23 10:59:06','1',NULL,NULL),('1176037918645686273','1171326538470420482','1',3,'待函审==》待现场评审','2019-09-23 15:37:44',NULL,NULL,'2019-09-23 15:37:44','1',NULL,NULL),('1176038909902327810','1171326538470420482','1',4,'待现场评审 ==》待终审','2019-09-23 15:41:39',NULL,NULL,'2019-09-23 15:41:39','1',NULL,NULL),('1176060778693005314',NULL,'1',5,'待终审 ==》 退回','2019-09-23 17:08:34','123',NULL,'2019-09-23 17:08:34','1',NULL,NULL),('1176060780442030082',NULL,'1',5,'待终审 ==》 退回','2019-09-23 17:08:34','123',NULL,'2019-09-23 17:08:34','1',NULL,NULL),('1176062058622619650',NULL,'1',5,'待终审 ==》 审核通过','2019-09-23 17:13:39',NULL,NULL,'2019-09-23 17:13:39','1',NULL,NULL),('1180120213807448066','1179739450847080449','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-04 21:59:18',NULL,NULL,NULL,NULL,NULL,NULL),('1181204848704512001','1181204847051956225','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:49:16',NULL,NULL,NULL,NULL,NULL,NULL),('1181204956330352641','1181204955239833601','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:49:41',NULL,NULL,NULL,NULL,NULL,NULL),('1181205022654881793','1181205021606305793','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:49:57',NULL,NULL,NULL,NULL,NULL,NULL),('1181205105790181378','1181205104749993985','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:50:17',NULL,NULL,NULL,NULL,NULL,NULL),('1181205278679392258','1181205277651787777','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:50:58',NULL,NULL,NULL,NULL,NULL,NULL),('1181205433386295298','1181205432362885122','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:51:35',NULL,NULL,NULL,NULL,NULL,NULL),('1181205637183332354','1181205636218642433','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:52:24',NULL,NULL,NULL,NULL,NULL,NULL),('1181207245858299905','1181207244830695425','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-07 21:58:47',NULL,NULL,NULL,NULL,NULL,NULL),('1182492578403348481','1182492576968896514','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-11 11:06:14',NULL,NULL,NULL,NULL,NULL,NULL),('1182492582954168321','1182492581226115073','1161200620462718978',1,'保存未提交 ==》待初审','2019-10-11 11:06:16',NULL,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_checklog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_depcheck`
--

DROP TABLE IF EXISTS `un_channelplan_depcheck`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_depcheck` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `cpId` varchar(30) DEFAULT NULL COMMENT '海峡计划申报ID',
  `companyId` varchar(30) DEFAULT NULL COMMENT '单位Id',
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态（1-未审核，2-退回，3-审核通过）',
  `checkMsg` varchar(500) DEFAULT NULL COMMENT '审核意见',
  `description` varchar(255) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报部门审核情况表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_depcheck`
--

LOCK TABLES `un_channelplan_depcheck` WRITE;
/*!40000 ALTER TABLE `un_channelplan_depcheck` DISABLE KEYS */;
INSERT INTO `un_channelplan_depcheck` VALUES ('1171271214002630657','1169092577866309633','1166546182209974274',3,'1323',NULL,'2019-09-10 11:56:33','1','2019-09-23 10:49:53','1'),('1171330868405633025','1171326538470420482','1168171264919609345',3,NULL,NULL,'2019-09-10 15:53:35',NULL,'2019-09-10 16:37:01','50'),('1171330868439187458','1171326538470420482','1158293574504660993',3,NULL,NULL,'2019-09-10 15:53:35',NULL,'2019-09-10 16:39:17','49'),('1171330868447576066','1171326538470420482','1158667798779936769',3,NULL,NULL,'2019-09-10 15:53:35',NULL,'2019-09-10 16:41:27','1'),('1180120215082516481','1179739450847080449','1168171264919609345',1,NULL,NULL,'2019-10-04 21:59:19',NULL,NULL,NULL),('1180120215095099394','1179739450847080449','1158293574504660993',1,NULL,NULL,'2019-10-04 21:59:19',NULL,NULL,NULL),('1180120215103488001','1179739450847080449','1158667798779936769',1,NULL,NULL,'2019-10-04 21:59:19',NULL,NULL,NULL),('1181204849832779777','1181204847051956225','1168171264919609345',1,NULL,NULL,'2019-10-07 21:49:16',NULL,NULL,NULL),('1181204849845362690','1181204847051956225','1158293574504660993',1,NULL,NULL,'2019-10-07 21:49:16',NULL,NULL,NULL),('1181204849853751297','1181204847051956225','1158667798779936769',1,NULL,NULL,'2019-10-07 21:49:16',NULL,NULL,NULL),('1181204957387317249','1181204955239833601','1168171264919609345',1,NULL,NULL,'2019-10-07 21:49:42',NULL,NULL,NULL),('1181204957395705858','1181204955239833601','1158293574504660993',1,NULL,NULL,'2019-10-07 21:49:42',NULL,NULL,NULL),('1181204957395705859','1181204955239833601','1158667798779936769',1,NULL,NULL,'2019-10-07 21:49:42',NULL,NULL,NULL),('1181205023707652098','1181205021606305793','1168171264919609345',1,NULL,NULL,'2019-10-07 21:49:58',NULL,NULL,NULL),('1181205023711846402','1181205021606305793','1158293574504660993',1,NULL,NULL,'2019-10-07 21:49:58',NULL,NULL,NULL),('1181205023711846403','1181205021606305793','1158667798779936769',1,NULL,NULL,'2019-10-07 21:49:58',NULL,NULL,NULL),('1181205106889089026','1181205104749993985','1168171264919609345',1,NULL,NULL,'2019-10-07 21:50:17',NULL,NULL,NULL),('1181205106897477633','1181205104749993985','1158293574504660993',1,NULL,NULL,'2019-10-07 21:50:17',NULL,NULL,NULL),('1181205106897477634','1181205104749993985','1158667798779936769',1,NULL,NULL,'2019-10-07 21:50:17',NULL,NULL,NULL),('1181205279723773954','1181205277651787777','1168171264919609345',1,NULL,NULL,'2019-10-07 21:50:59',NULL,NULL,NULL),('1181205279727968258','1181205277651787777','1158293574504660993',1,NULL,NULL,'2019-10-07 21:50:59',NULL,NULL,NULL),('1181205279727968259','1181205277651787777','1158667798779936769',1,NULL,NULL,'2019-10-07 21:50:59',NULL,NULL,NULL),('1181205434447454209','1181205432362885122','1168171264919609345',1,NULL,NULL,'2019-10-07 21:51:35',NULL,NULL,NULL),('1181205434460037121','1181205432362885122','1158293574504660993',1,NULL,NULL,'2019-10-07 21:51:35',NULL,NULL,NULL),('1181205434460037122','1181205432362885122','1158667798779936769',1,NULL,NULL,'2019-10-07 21:51:35',NULL,NULL,NULL),('1181205638148022274','1181205636218642433','1168171264919609345',1,NULL,NULL,'2019-10-07 21:52:24',NULL,NULL,NULL),('1181205638156410881','1181205636218642433','1158293574504660993',1,NULL,NULL,'2019-10-07 21:52:24',NULL,NULL,NULL),('1181205638156410882','1181205636218642433','1158667798779936769',1,NULL,NULL,'2019-10-07 21:52:24',NULL,NULL,NULL),('1181207246915264513','1181207244830695425','1168171264919609345',1,NULL,NULL,'2019-10-07 21:58:48',NULL,NULL,NULL),('1181207246923653122','1181207244830695425','1158293574504660993',1,NULL,NULL,'2019-10-07 21:58:48',NULL,NULL,NULL),('1181207246923653123','1181207244830695425','1158667798779936769',1,NULL,NULL,'2019-10-07 21:58:48',NULL,NULL,NULL),('1182492579737137153','1182492576968896514','1168171264919609345',1,NULL,NULL,'2019-10-11 11:06:15',NULL,NULL,NULL),('1182492579762302978','1182492576968896514','1158293574504660993',1,NULL,NULL,'2019-10-11 11:06:15',NULL,NULL,NULL),('1182492579770691585','1182492576968896514','1158667798779936769',1,NULL,NULL,'2019-10-11 11:06:15',NULL,NULL,NULL),('1182492583860137985','1182492581226115073','1168171264919609345',1,NULL,NULL,'2019-10-11 11:06:16',NULL,NULL,NULL),('1182492583860137986','1182492581226115073','1158293574504660993',1,NULL,NULL,'2019-10-11 11:06:16',NULL,NULL,NULL),('1182492583860137987','1182492581226115073','1158667798779936769',1,NULL,NULL,'2019-10-11 11:06:16',NULL,NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_depcheck` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_enterprise_income`
--

DROP TABLE IF EXISTS `un_channelplan_enterprise_income`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_enterprise_income` (
  `id` varchar(30) NOT NULL COMMENT '唯一标志',
  `cpid` varchar(30) NOT NULL COMMENT '海峡计划申报ID',
  `year` varchar(20) NOT NULL COMMENT '年度',
  `researchIn` decimal(10,0) NOT NULL DEFAULT 0 COMMENT '研发投入（万元）',
  `coreProduct` decimal(10,0) NOT NULL DEFAULT 0 COMMENT '核心产品年销售额（万元）',
  `proportion` decimal(10,0) NOT NULL DEFAULT 0 COMMENT '研发投入占销售收入的比重（%）',
  `addTax` decimal(10,0) NOT NULL DEFAULT 0 COMMENT '增值税（万元）',
  `incomeTax` decimal(10,0) NOT NULL DEFAULT 0 COMMENT '所得税（万元）',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报企业收入情况表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_enterprise_income`
--

LOCK TABLES `un_channelplan_enterprise_income` WRITE;
/*!40000 ALTER TABLE `un_channelplan_enterprise_income` DISABLE KEYS */;
INSERT INTO `un_channelplan_enterprise_income` VALUES ('1165550066367586305','1165549954081873921','2015',2015,12,12,21,12,NULL,NULL,NULL,NULL,NULL),('1165550066380169217','1165549954081873921','2016',2016,21,12,12,21,NULL,NULL,NULL,NULL,NULL),('1165550066392752130','1165549954081873921','2017',2017,21,12,12,12,NULL,NULL,NULL,NULL,NULL),('1165550066396946433','1165549954081873921','2018',2018,12,21,21,21,NULL,NULL,NULL,NULL,NULL),('1165550066396946434','1165549954081873921','2019',2019,21,21,12,12,NULL,NULL,NULL,NULL,NULL),('1165570086657077249','1165569991362490369','2015',2015,1,21,12,12,NULL,NULL,NULL,NULL,NULL),('1165570086715797506','1165569991362490369','2016',2016,12,12,21,21,NULL,NULL,NULL,NULL,NULL),('1165570086736769026','1165569991362490369','2017',2017,12,21,12,21,NULL,NULL,NULL,NULL,NULL),('1165570086745157634','1165569991362490369','2018',2018,12,12,12,21,NULL,NULL,NULL,NULL,NULL),('1165570086761934850','1165569991362490369','2019',2019,21,12,12,12,NULL,NULL,NULL,NULL,NULL),('1165571133236588545','1165571119575740418','2015',12,12,21,12,21,NULL,NULL,NULL,NULL,NULL),('1165571133236588546','1165571119575740418','2016',12,2112,21,12,12,NULL,NULL,NULL,NULL,NULL),('1165571133236588547','1165571119575740418','2017',2,21,21,12,21,NULL,NULL,NULL,NULL,NULL),('1165571133236588548','1165571119575740418','2018',3,21,21,12,12,NULL,NULL,NULL,NULL,NULL),('1165571133236588549','1165571119575740418','2019',21,21,12,12,21,NULL,NULL,NULL,NULL,NULL),('1165818138819149826','1165818135912497153','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1165818138856898561','1165818135912497153','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1165818138865287169','1165818135912497153','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1165818138873675777','1165818135912497153','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1165818138877870082','1165818135912497153','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166971879282831361','1166971876803997697','2015',13,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166971879312191490','1166971876803997697','2016',21,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166971879316385793','1166971876803997697','2017',31,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166971879316385794','1166971876803997697','2018',123,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166971879328968706','1166971876803997697','2019',131,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166999675370631170','1166999671990022146','2015',23,23,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166999675391602690','1166999671990022146','2016',23,23,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166999675404185601','1166999671990022146','2017',32,23,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166999675412574210','1166999671990022146','2018',23,23,0,0,0,NULL,NULL,NULL,NULL,NULL),('1166999675420962818','1166999671990022146','2019',23,23,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729088735850497','1168729086588366849','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729088769404929','1168729086588366849','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729088769404930','1168729086588366849','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729088781987841','1168729086588366849','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729088790376449','1168729086588366849','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729830867611650','1168729828262948866','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729830888583169','1168729828262948866','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729830896971777','1168729828262948866','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729830905360386','1168729828262948866','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168729830905360387','1168729828262948866','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168786973918597122','1168786970059837442','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168786974015066114','1168786970059837442','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168786974023454722','1168786970059837442','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168786974040231938','1168786970059837442','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168786974040231939','1168786970059837442','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168787562941485057','1168787561502838786','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168787562941485058','1168787561502838786','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168787562941485059','1168787561502838786','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168787562941485060','1168787561502838786','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168787562941485061','1168787561502838786','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788762734727169','1168788761308663810','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788762734727170','1168788761308663810','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788762734727171','1168788761308663810','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788762734727172','1168788761308663810','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788762734727173','1168788761308663810','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788935514886146','1168788934013325314','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788935514886147','1168788934013325314','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788935514886148','1168788934013325314','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788935514886149','1168788934013325314','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168788935514886150','1168788934013325314','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789133880299521','1168789132466819074','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789133880299522','1168789132466819074','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789133880299523','1168789132466819074','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789133880299524','1168789132466819074','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789133880299525','1168789132466819074','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789608897810433','1168789607593381890','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789608897810434','1168789607593381890','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789608897810435','1168789607593381890','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789608897810436','1168789607593381890','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789608897810437','1168789607593381890','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789862837751810','1168789861420077058','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789862837751811','1168789861420077058','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789862871306241','1168789861420077058','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789862871306242','1168789861420077058','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168789862879694850','1168789861420077058','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790034879713281','1168790033575284737','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790034888101890','1168790033575284737','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790034888101891','1168790033575284737','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790034896490497','1168790033575284737','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790034900684802','1168790033575284737','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790932678873089','1168790931269586945','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790932678873090','1168790931269586945','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790932678873091','1168790931269586945','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790932678873092','1168790931269586945','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168790932678873093','1168790931269586945','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168791218046734338','1168791216784248834','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168791218055122945','1168791216784248834','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168791218055122946','1168791216784248834','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168791218055122947','1168791216784248834','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168791218055122948','1168791216784248834','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792012254973954','1168792010841493506','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792012254973955','1168792010841493506','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792012254973956','1168792010841493506','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792012254973957','1168792010841493506','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792012254973958','1168792010841493506','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792156702609410','1168792155440123905','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792156702609411','1168792155440123905','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792156702609412','1168792155440123905','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792156702609413','1168792155440123905','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168792156702609414','1168792155440123905','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168795508706480130','1168795507133616129','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168795508740034562','1168795507133616129','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168795508748423170','1168795507133616129','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168795508748423171','1168795507133616129','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168795508756811777','1168795507133616129','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168796017194536961','1168796015785250818','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168796017194536962','1168796015785250818','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168796017194536963','1168796015785250818','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168796017211314177','1168796015785250818','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168796017211314178','1168796015785250818','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168802576523956225','1168802574951092225','2015',23,31,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168802576574287873','1168802574951092225','2016',21,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168802576591065089','1168802574951092225','2017',31,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168802576599453698','1168802574951092225','2018',23,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1168802576603648002','1168802574951092225','2019',12,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1169092580340948994','1169092577866309633','2015',1,1,1,1,1,NULL,NULL,NULL,NULL,NULL),('1169092580370309122','1169092577866309633','2016',2,2,2,2,2,NULL,NULL,NULL,NULL,NULL),('1169092580374503425','1169092577866309633','2017',3,3,3,3,3,NULL,NULL,NULL,NULL,NULL),('1169092580382892033','1169092577866309633','2018',4,4,4,4,4,NULL,NULL,NULL,NULL,NULL),('1169092580382892034','1169092577866309633','2019',5,5,5,5,5,NULL,NULL,NULL,NULL,NULL),('1171326540877950978','1171326538470420482','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1171326540915699713','1171326538470420482','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1171326540928282625','1171326538470420482','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1171326540936671234','1171326538470420482','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1171326540936671235','1171326538470420482','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179624041842028546','1179624040248193025','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179624041858805761','1179624040248193025','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179624041867194370','1179624040248193025','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179624041867194371','1179624040248193025','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179624041867194372','1179624040248193025','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179739451933405185','1179739450847080449','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179739451945988098','1179739450847080449','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179739451945988099','1179739450847080449','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179739451954376705','1179739450847080449','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1179739451954376706','1179739450847080449','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482588792340481','1180482585759858690','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482588817506306','1180482585759858690','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482588825894914','1180482585759858690','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482588825894915','1180482585759858690','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482588825894916','1180482585759858690','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482950811107329','1180482915721560065','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482950819495937','1180482915721560065','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482950823690241','1180482915721560065','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482950823690242','1180482915721560065','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180482950823690243','1180482915721560065','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180484018999672834','1180484001245184002','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180484019008061442','1180484001245184002','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180484019008061443','1180484001245184002','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180484019008061444','1180484001245184002','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180484019016450049','1180484001245184002','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180485985251639298','1180485976380686337','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180485985268416514','1180485976380686337','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180485985272610817','1180485976380686337','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180485985272610818','1180485976380686337','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180485985272610819','1180485976380686337','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180486131112755202','1180486122837393410','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180486131112755203','1180486122837393410','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180486131121143810','1180486122837393410','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180486131121143811','1180486122837393410','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180486131121143812','1180486122837393410','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180489108225540097','1180489106988220417','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180489108229734401','1180489106988220417','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180489108229734402','1180489106988220417','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180489108229734403','1180489106988220417','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180489108229734404','1180489106988220417','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490574587772930','1180490573375619074','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490574596161537','1180490573375619074','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490574596161538','1180490573375619074','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490574596161539','1180490573375619074','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490574604550145','1180490573375619074','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490690254094338','1180490689029357570','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490690262482946','1180490689029357570','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490690270871553','1180490689029357570','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490690270871554','1180490689029357570','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490690270871555','1180490689029357570','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490812635496450','1180490811377205249','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490812643885057','1180490811377205249','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490812643885058','1180490811377205249','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490812643885059','1180490811377205249','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180490812643885060','1180490811377205249','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180491590624362498','1180491589366071298','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180491590632751106','1180491589366071298','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180491590632751107','1180491589366071298','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180491590632751108','1180491589366071298','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180491590632751109','1180491589366071298','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180499513211633666','1180499511877844994','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180499513224216578','1180499511877844994','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180499513224216579','1180499511877844994','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180499513224216580','1180499511877844994','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180499513232605186','1180499511877844994','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180502026086268930','1180502024949612545','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180502026094657537','1180502024949612545','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180502026094657538','1180502024949612545','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180502026103046146','1180502024949612545','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1180502026103046147','1180502024949612545','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204851539861505','1181204847051956225','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204851548250114','1181204847051956225','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204851548250115','1181204847051956225','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204851548250116','1181204847051956225','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204851556638721','1181204847051956225','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204958649802754','1181204955239833601','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204958653997058','1181204955239833601','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204958662385665','1181204955239833601','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204958662385666','1181204955239833601','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181204958666579970','1181204955239833601','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205024995303426','1181205021606305793','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205025003692034','1181205021606305793','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205025012080642','1181205021606305793','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205025012080643','1181205021606305793','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205025012080644','1181205021606305793','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205108105437186','1181205104749993985','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205108105437187','1181205104749993985','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205108105437188','1181205104749993985','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205108113825793','1181205104749993985','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205108113825794','1181205104749993985','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205280931733506','1181205277651787777','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205280940122113','1181205277651787777','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205280940122114','1181205277651787777','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205280940122115','1181205277651787777','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205280940122116','1181205277651787777','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205435688968194','1181205432362885122','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205435688968195','1181205432362885122','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205435697356801','1181205432362885122','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205435697356802','1181205432362885122','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205435697356803','1181205432362885122','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205639284678658','1181205636218642433','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205639284678659','1181205636218642433','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205639293067265','1181205636218642433','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205639293067266','1181205636218642433','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181205639293067267','1181205636218642433','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206397988134914','','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206397992329218','','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206397992329219','','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206397992329220','','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206397992329221','','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206643048734721','','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206643057123329','','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206643057123330','','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206643057123331','','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206643057123332','','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206880651862018','','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206880660250626','','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206880660250627','','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206880660250628','','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181206880660250629','','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181207264510369794','1181207244830695425','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181207264514564097','1181207244830695425','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181207264514564098','1181207244830695425','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181207264522952705','1181207244830695425','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181207264522952706','1181207244830695425','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181208752943030273','1181208751881871362','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181208752951418882','1181208751881871362','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181208752951418883','1181208751881871362','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181208752959807489','1181208751881871362','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181208752959807490','1181208751881871362','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181209483238465538','1181209482135363586','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181209483238465539','1181209482135363586','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181209483242659842','1181209482135363586','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181209483242659843','1181209482135363586','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181209483242659844','1181209482135363586','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181210964075241473','1181210962372354050','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181210964075241474','1181210962372354050','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181210964075241475','1181210962372354050','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181210964083630081','1181210962372354050','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181210964083630082','1181210962372354050','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181211743553085442','1181211742525480961','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181211743561474050','1181211742525480961','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181211743561474051','1181211742525480961','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181211743561474052','1181211742525480961','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1181211743561474053','1181211742525480961','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492581779763201','1182492576968896514','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492581796540417','1182492576968896514','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492581804929026','1182492576968896514','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492581809123329','1182492576968896514','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492581817511938','1182492576968896514','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492584971628546','1182492581226115073','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492584971628547','1182492581226115073','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492584971628548','1182492581226115073','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492584971628549','1182492581226115073','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182492584971628550','1182492581226115073','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182569898694701057','1182569897344135170','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182569898711478273','1182569897344135170','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182569898715672577','1182569897344135170','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182569898724061186','1182569897344135170','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182569898724061187','1182569897344135170','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182572774976417794','1182572752184569858','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182572774997389313','1182572752184569858','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182572775005777922','1182572752184569858','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182572775014166529','1182572752184569858','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182572775022555137','1182572752184569858','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182573981547655170','1182573963176603650','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182573981547655171','1182573963176603650','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182573981547655172','1182573963176603650','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182573981547655173','1182573963176603650','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182573981547655174','1182573963176603650','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576061104549889','1182576059967893506','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576061104549890','1182576059967893506','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576061104549891','1182576059967893506','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576061129715713','1182576059967893506','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576061129715714','1182576059967893506','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576327329607682','1182576326239088641','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576327346384897','1182576326239088641','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576327346384898','1182576326239088641','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576327346384899','1182576326239088641','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182576327354773505','1182576326239088641','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182583922211713026','1182583921100222466','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182583922245267457','1182583921100222466','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182583922253656065','1182583921100222466','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182583922253656066','1182583921100222466','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182583922262044673','1182583921100222466','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182857146027745282','1182857144450686978','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182857146052911106','1182857144450686978','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182915887091687425','1182915886110220290','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182915887108464641','1182915886110220290','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182915887116853250','1182915886110220290','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182915887129436162','1182915886110220290','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182915887129436163','1182915886110220290','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943391051423746','1182943389944127489','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943391068200961','1182943389944127489','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943391068200962','1182943389944127489','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943391076589569','1182943389944127489','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943391076589570','1182943389944127489','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943508030562305','1182943506709356545','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943508047339521','1182943506709356545','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943508055728129','1182943506709356545','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943508059922433','1182943506709356545','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182943508059922434','1182943506709356545','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182950122414415874','1182950121361645569','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182950122443776001','1182950121361645569','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182950122452164609','1182950121361645569','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182950122452164610','1182950121361645569','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1182950122460553217','1182950121361645569','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183570662703611906','1183570659524329474','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183570662749749249','1183570659524329474','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183570662758137857','1183570659524329474','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183570662758137858','1183570659524329474','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183570662766526466','1183570659524329474','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573009265704961','1183573007822864386','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573009282482177','1183573007822864386','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573009286676482','1183573007822864386','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573009295065090','1183573007822864386','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573009299259394','1183573007822864386','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573573336678402','1183573571864477698','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573573353455618','1183573571864477698','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573573370232834','1183573571864477698','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573573378621441','1183573571864477698','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573573391204353','1183573571864477698','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573995111694338','1183573993660465154','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573995111694339','1183573993660465154','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573995111694340','1183573993660465154','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573995111694341','1183573993660465154','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183573995111694342','1183573993660465154','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574283763695617','1183574282375380993','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574283772084225','1183574282375380993','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574283776278530','1183574282375380993','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574283776278531','1183574282375380993','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574283788861441','1183574282375380993','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574784232243202','1183574782873288705','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574784240631810','1183574782873288705','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574784249020418','1183574782873288705','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574784257409025','1183574782873288705','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183574784265797633','1183574782873288705','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183575170473115649','1183575169072218113','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183575170485698562','1183575169072218113','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183575170485698563','1183575169072218113','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183575170494087170','1183575169072218113','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183575170494087171','1183575169072218113','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183576445516365826','1183576444086108162','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183576445516365827','1183576444086108162','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183576445516365828','1183576444086108162','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183576445549920257','1183576444086108162','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183576445549920258','1183576444086108162','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577562820231169','1183577561444499458','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577562828619778','1183577561444499458','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577562841202689','1183577561444499458','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577562845396993','1183577561444499458','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577562845396994','1183577561444499458','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577615613935617','1183577614296924162','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577615634907138','1183577614296924162','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577615634907139','1183577614296924162','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577615643295746','1183577614296924162','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183577615643295747','1183577614296924162','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183664892629336065','1183664891215855618','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183664892637724673','1183664891215855618','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183664892646113281','1183664891215855618','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183664892646113282','1183664891215855618','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183664892646113283','1183664891215855618','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183954964712898561','1183954962271813633','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183954964729675778','1183954962271813633','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183954964746452993','1183954962271813633','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183954964754841601','1183954962271813633','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1183954964759035906','1183954962271813633','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1184306690187878402','1184306689009278977','2015',12,21,11,0,0,NULL,NULL,NULL,NULL,NULL),('1184306690200461313','1184306689009278977','2016',21,21,0,0,0,NULL,NULL,NULL,NULL,NULL),('1184306690200461314','1184306689009278977','2017',12,21,0,0,0,NULL,NULL,NULL,NULL,NULL),('1184306690208849922','1184306689009278977','2018',21,21,0,0,0,NULL,NULL,NULL,NULL,NULL),('1184306690208849923','1184306689009278977','2019',22,21,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186921770326958082','1186921691029446658','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186921770326958083','1186921691029446658','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186921770347929601','1186921691029446658','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186921770356318209','1186921691029446658','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186921770356318210','1186921691029446658','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186922829074145282','1186922757448015874','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186922829074145283','1186922757448015874','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186922829074145284','1186922757448015874','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186922829074145285','1186922757448015874','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186922829074145286','1186922757448015874','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186925407962931201','1186925391710003201','2015',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186925407962931202','1186925391710003201','2016',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186925407962931203','1186925391710003201','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186925408017457153','1186925391710003201','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1186925408017457154','1186925391710003201','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1187281414736130050','1187281378296016898','2015',12,0,21,0,0,NULL,NULL,NULL,NULL,NULL),('1187281414778073090','1187281378296016898','2016',12,32,0,0,0,NULL,NULL,NULL,NULL,NULL),('1187281414794850306','1187281378296016898','2017',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1187281414807433218','1187281378296016898','2018',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL),('1187281414815821825','1187281378296016898','2019',0,0,0,0,0,NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_enterprise_income` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_expert`
--

DROP TABLE IF EXISTS `un_channelplan_expert`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_expert` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `step` tinyint(1) NOT NULL COMMENT '流程',
  `cpId` varchar(30) NOT NULL COMMENT '海峡计划申报ID',
  `score` decimal(10,0) DEFAULT NULL COMMENT '总分',
  `expertId` varchar(30) NOT NULL COMMENT '专家Id',
  `group` varchar(30) NOT NULL COMMENT '评审分组',
  `checkMsg` varchar(500) DEFAULT NULL COMMENT '评审意见',
  `recommendType` varchar(30) NOT NULL COMMENT '推荐类型',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL,
  `createUser` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报专家评分表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_expert`
--

LOCK TABLES `un_channelplan_expert` WRITE;
/*!40000 ALTER TABLE `un_channelplan_expert` DISABLE KEYS */;
INSERT INTO `un_channelplan_expert` VALUES ('1174605355209248769',1,'1171326538470420482',46,'1159630918152204289','group1','122','ds_1','23',NULL,NULL,NULL,NULL),('1174850377905106945',1,'1171326538470420482',35,'1159630918152204289','group3','122','ds_3','2',NULL,NULL,NULL,NULL),('1174941788662951938',1,'1171326538470420482',46,'1159630918152204289','group2','122','ds_3','23',NULL,NULL,NULL,NULL),('1174942222144270337',1,'1171326538470420482',35,'1159630918152204289','group2','122','ds_2','2',NULL,NULL,NULL,NULL),('1174942970303246338',1,'1171326538470420482',55,'1159630918152204289','group2','122','ds_3','1',NULL,NULL,NULL,NULL),('1175971707970916354',1,'1171326538470420482',44,'','group2','122','ds_1','2','2019-09-23 11:14:38','1',NULL,NULL),('1175971959239086082',1,'1171326538470420482',55,'1159630918152204289','group2','122','ds_1','12','2019-09-23 11:15:38','1',NULL,NULL),('1175972015715389442',1,'1171326538470420482',55,'1159630918152204289','group2','122','ds_1','12','2019-09-23 11:15:51','1',NULL,NULL),('1175981222908923905',2,'1171326538470420482',35,'1159630918152204289','group2','122','ds_2','1','2019-09-23 11:52:26','1',NULL,NULL),('1176029050389663746',2,'1171326538470420482',33,'1159630918152204289','group2','122','ds_2','1233','2019-09-23 15:02:29','1',NULL,NULL),('1176030633278050305',2,'1171326538470420482',44,'1159630918152204289','group2','122','ds_3','2','2019-09-23 15:08:47','1',NULL,NULL),('1176030654505422850',2,'1171326538470420482',44,'1159630918152204289','group2','122','ds_3','2','2019-09-23 15:08:52','1',NULL,NULL),('1176030892909662209',2,'1171326538470420482',25,'1159630918152204289','group2','122','ds_2','2','2019-09-23 15:09:49','1',NULL,NULL),('1176031540988350465',2,'1171326538470420482',44,'1159630918152204289','group2','122','ds_2','2','2019-09-23 15:12:23','1',NULL,NULL),('1176032433280389121',2,'1171326538470420482',2,'1159630918152204289','group1','122','ds_2','1','2019-09-23 15:15:56','1',NULL,NULL),('1176033384326238210',2,'1171326538470420482',13,'1159630918152204289','group1','122','ds_2','2','2019-09-23 15:19:43','1',NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_expert` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_expert_detail`
--

DROP TABLE IF EXISTS `un_channelplan_expert_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_expert_detail` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `expertId` varchar(30) DEFAULT NULL COMMENT '海峡计划申报专家评分id',
  `cpId` varchar(30) DEFAULT NULL COMMENT '海峡计划Id',
  `standardId` varchar(30) DEFAULT NULL COMMENT '评分标准ID',
  `score` varchar(30) DEFAULT NULL COMMENT '等级得分',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报专家评分详情表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_expert_detail`
--

LOCK TABLES `un_channelplan_expert_detail` WRITE;
/*!40000 ALTER TABLE `un_channelplan_expert_detail` DISABLE KEYS */;
INSERT INTO `un_channelplan_expert_detail` VALUES ('1174589119557586945','1159630918152204289',NULL,'1173780492273864705','23',NULL,NULL,NULL,NULL,NULL),('1174589119616307202','1159630918152204289',NULL,'1174134430617583617','32',NULL,NULL,NULL,NULL,NULL),('1174590480839921666','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174590480919613441','1159630918152204289','1171326538470420482','1174134430617583617','123',NULL,NULL,NULL,NULL,NULL),('1174590928166637569','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174590928183414785','1159630918152204289','1171326538470420482','1174134430617583617','123',NULL,NULL,NULL,NULL,NULL),('1174591004150648833','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174591004163231746','1159630918152204289','1171326538470420482','1174134430617583617','123',NULL,NULL,NULL,NULL,NULL),('1174593345331449858','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174593345344032770','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1174593951379017730','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174593951408377858','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1174595668703236098','1159630918152204289','1171326538470420482','1173780492273864705','23',NULL,NULL,NULL,NULL,NULL),('1174595668720013314','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1174601593493180418','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174601593518346241','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1174601594671779841','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174601594696945665','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1174850360159006722','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174850360213532674','1159630918152204289','1171326538470420482','1174134430617583617','23',NULL,NULL,NULL,NULL,NULL),('1174850362566537217','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1174850362621063169','1159630918152204289','1171326538470420482','1174134430617583617','23',NULL,NULL,NULL,NULL,NULL),('1174940193200041986','null','1171326538470420482','1173780492273864705','32',NULL,NULL,NULL,NULL,NULL),('1174940193237790722','null','1171326538470420482','1174134430617583617','1',NULL,NULL,NULL,NULL,NULL),('1174941745008635906','1159630918152204289','1171326538470420482','1173780492273864705','23',NULL,NULL,NULL,NULL,NULL),('1174941745017024513','1159630918152204289','1171326538470420482','1174134430617583617','23',NULL,NULL,NULL,NULL,NULL),('1174942200174505985','1159630918152204289','1171326538470420482','1173780492273864705','23',NULL,NULL,NULL,NULL,NULL),('1174942200182894594','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1174942953651859457','1159630918152204289','1171326538470420482','1173780492273864705','32',NULL,NULL,NULL,NULL,NULL),('1174942953681219585','1159630918152204289','1171326538470420482','1174134430617583617','23',NULL,NULL,NULL,NULL,NULL),('1174942954960482306','1159630918152204289','1171326538470420482','1173780492273864705','32',NULL,NULL,NULL,NULL,NULL),('1174942954973065217','1159630918152204289','1171326538470420482','1174134430617583617','23',NULL,NULL,NULL,NULL,NULL),('1175971683996274690','null','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1175971684021440514','null','1171326538470420482','1174134430617583617','32',NULL,NULL,NULL,NULL,NULL),('1175971943707578369','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1175971943720161282','1159630918152204289','1171326538470420482','1174134430617583617','43',NULL,NULL,NULL,NULL,NULL),('1175979917234671618','null','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1175979917247254529','null','1171326538470420482','1174134430617583617','23',NULL,NULL,NULL,NULL,NULL),('1176028999403704321','1159630918152204289','1171326538470420482','1173780492273864705','21',NULL,NULL,NULL,NULL,NULL),('1176028999416287233','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1176029000628441089','1159630918152204289','1171326538470420482','1173780492273864705','21',NULL,NULL,NULL,NULL,NULL),('1176029000649412609','1159630918152204289','1171326538470420482','1174134430617583617','12',NULL,NULL,NULL,NULL,NULL),('1176030614789558274','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1176030614797946881','1159630918152204289','1171326538470420482','1174134430617583617','32',NULL,NULL,NULL,NULL,NULL),('1176030879232036866','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1176030879240425473','1159630918152204289','1171326538470420482','1174134430617583617','13',NULL,NULL,NULL,NULL,NULL),('1176031474143727618','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1176031474156310529','1159630918152204289','1171326538470420482','1174134430617583617','32',NULL,NULL,NULL,NULL,NULL),('1176031475305549826','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1176031475318132737','1159630918152204289','1171326538470420482','1174134430617583617','32',NULL,NULL,NULL,NULL,NULL),('1176032421435674626','1159630918152204289','1171326538470420482','1173780492273864705','1',NULL,NULL,NULL,NULL,NULL),('1176032421460840449','1159630918152204289','1171326538470420482','1174134430617583617','1',NULL,NULL,NULL,NULL,NULL),('1176033373593014274','1159630918152204289','1171326538470420482','1173780492273864705','12',NULL,NULL,NULL,NULL,NULL),('1176033373601402881','1159630918152204289','1171326538470420482','1174134430617583617','1',NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_expert_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_file`
--

DROP TABLE IF EXISTS `un_channelplan_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_file` (
  `id` varchar(30) NOT NULL,
  `cpId` varchar(30) NOT NULL COMMENT '海峡申报计划ID',
  `memberTypeId` varchar(30) DEFAULT NULL COMMENT '成员ID',
  `typeId` varchar(30) NOT NULL COMMENT '附件类别ID',
  `oldName` varchar(255) NOT NULL COMMENT '附件原名',
  `url` varchar(255) NOT NULL COMMENT '附件新名',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报附件表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_file`
--

LOCK TABLES `un_channelplan_file` WRITE;
/*!40000 ALTER TABLE `un_channelplan_file` DISABLE KEYS */;
INSERT INTO `un_channelplan_file` VALUES ('1169509001466245122','1169092577866309633','teamLeader','1160739669725859842','C:\\Users\\Administrator\\Desktop\\fbdbcb28a27d2b3551027cb0ec3526b6.png','jjrcw/talentFile/talentIdentifyFile/201909/1169508998471512066.png',NULL,NULL,NULL,NULL,NULL),('1169510056014934017','1169092577866309633','teamLeader','1160760708505690114','C:\\Users\\Administrator\\Desktop\\1168537294691074050.gif','jjrcw/talentFile/talentIdentifyFile/201909/1169510053540294658.gif',NULL,NULL,NULL,NULL,NULL),('1169510367593000962','1169092577866309633','teamLeader','1165289140952719362','C:\\Users\\Administrator\\Desktop\\1168537294691074050.gif','jjrcw/talentFile/talentIdentifyFile/201909/1169510365030281218.gif',NULL,NULL,NULL,NULL,NULL),('1169513020196765698','1169092577866309633','team01','1160739669725859842','C:\\Users\\Administrator\\Desktop\\fbdbcb28a27d2b3551027cb0ec3526b6.png','jjrcw/talentFile/talentIdentifyFile/201909/1169513017357221889.png',NULL,NULL,NULL,NULL,NULL),('1169513073170825218','1169092577866309633','team01','1160760708505690114','C:\\Users\\Administrator\\Desktop\\1168537294691074050.gif','jjrcw/talentFile/talentIdentifyFile/201909/1169513070822014978.gif',NULL,NULL,NULL,NULL,NULL),('1171329529567019010','1171326538470420482','teamLeader','1160739669725859842','C:\\Users\\Administrator\\Desktop\\test1.gif','jjrcw/talentFile/talentIdentifyFile/201909/1171329525771173889.gif',NULL,NULL,NULL,NULL,NULL),('1171329556909686785','1171326538470420482','teamLeader','1160760708505690114','C:\\Users\\Administrator\\Desktop\\testFile.gif','jjrcw/talentFile/talentIdentifyFile/201909/1171329553868816386.gif',NULL,NULL,NULL,NULL,NULL),('1171329583346384897','1171326538470420482','teamLeader','1165289140952719362','C:\\Users\\Administrator\\Desktop\\test2.png','jjrcw/talentFile/talentIdentifyFile/201909/1171329580796248065.png',NULL,NULL,NULL,NULL,NULL),('1179741155735187458','1179739450847080449','teamLeader','1160739669725859842','阿里Java代码规范.pdf','jjrcw/talentFile/talentIdentifyFile/201910/1179741151427637250.pdf',NULL,NULL,NULL,NULL,NULL),('1179741438523551745','1179739450847080449','teamLeader','1160760708505690114','阿里Java代码规范.pdf','jjrcw/talentFile/talentIdentifyFile/201910/1179741432416645121.pdf',NULL,NULL,NULL,NULL,NULL),('1183577512798961665','','','1169899622106513409','qjc.jpg.txt','jjrcw/talentFile/talentIdentifyFile/201910/1183577476811833345.txt',NULL,NULL,NULL,NULL,NULL),('1183577821071917057','1183577614296924162','','1169899622106513409','qjc.jpg.txt','jjrcw/talentFile/talentIdentifyFile/201910/1183577738725146626.txt',NULL,NULL,NULL,NULL,NULL),('1183578213436473345','1183577614296924162','','1169900506202882049','test1.gif','jjrcw/talentFile/talentIdentifyFile/201910/1183578210756313090.gif',NULL,NULL,NULL,NULL,NULL),('1183578531469574145','1183577614296924162','','1169900506202882049','icon_pdf.gif','jjrcw/talentFile/talentIdentifyFile/201910/1183578484782776321.gif',NULL,NULL,NULL,NULL,NULL),('1183578897682644994','1183577614296924162','','1169899622106513409','icon_pdf.gif','jjrcw/talentFile/talentIdentifyFile/201910/1183578863637479426.gif',NULL,NULL,NULL,NULL,NULL),('1183585785417678850','','teamLeader','1160739669725859842','testFile.gif','jjrcw/talentFile/talentIdentifyFile/201910/1183585782410362882.gif',NULL,NULL,NULL,NULL,NULL),('1183585846448996353','','team01','1160760708505690114','test2.png','jjrcw/talentFile/talentIdentifyFile/201910/1183585843924025346.png',NULL,NULL,NULL,NULL,NULL),('1183586894177746945','','teamLeader','1160739669725859842','timg.jpg','jjrcw/talentFile/talentIdentifyFile/201910/1183586890054746114.jpg',NULL,NULL,NULL,NULL,NULL),('1183671496355422209','1183664891215855618','teamLeader','1160760708505690114','test2.png','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183671398816882689.png',NULL,NULL,NULL,NULL,NULL),('1183673181823901697','1183664891215855618','','1169899622106513409','test2.png','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183673178904666113.png',NULL,NULL,NULL,NULL,NULL),('1183673451567980545','1183664891215855618','teamLeader','1165289140952719362','work.pdf.txt','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183673448871043074.txt',NULL,NULL,NULL,NULL,NULL),('1183673584087015425','1183664891215855618','teamLeader','1160739669725859842','timg.jpg','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183673564927434754.jpg',NULL,NULL,NULL,NULL,NULL),('1183673813981011969','1183664891215855618','team01','1160739669725859842','timg.jpg','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183673805533683713.jpg',NULL,NULL,NULL,NULL,NULL),('1183673891604996097','1183664891215855618','team01','1160760708505690114','testFile.gif','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183673888652206081.gif',NULL,NULL,NULL,NULL,NULL),('1183674221814161410','1183664891215855618','team03','1160760708505690114','test2.png','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183674209440964609.png',NULL,NULL,NULL,NULL,NULL),('1183674290617524225','1183664891215855618','team01','1165289140952719362','testFile.gif','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1183674280689606657.gif',NULL,NULL,NULL,NULL,NULL),('1184750311886352385','1184747722939625473','teamLeader','1160739669725859842','testFile.gif','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1184750308174393345.gif',NULL,NULL,NULL,NULL,NULL),('1184751384462159873','1184747722939625473','teamLeader','1160760708505690114','test2.png','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1184751380305604610.png',NULL,NULL,NULL,NULL,NULL),('1184752844226752513','1184747722939625473','teamLeader','1165289140952719362','testFile.gif','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1184752841374625793.gif',NULL,NULL,NULL,NULL,NULL),('1184756609445064706','1184747722939625473','','1169899622106513409','timg.jpg','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1184756598309187586.jpg',NULL,NULL,NULL,NULL,NULL),('1184757024152678402','1184747722939625473','','1169900506202882049','testFile.gif','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1184757021246025729.gif',NULL,NULL,NULL,NULL,NULL),('1187294021190758401','1184747722939625473','teamLeader','1160739669725859842','test1.gif','jjrcw/channelPlanFile/channelPlanDeclareFile/201910/1187294016132427778.gif',NULL,NULL,NULL,NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_member_eduction`
--

DROP TABLE IF EXISTS `un_channelplan_member_eduction`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_member_eduction` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `memberId` varchar(30) NOT NULL COMMENT '成员ID',
  `degree` varchar(50) NOT NULL COMMENT '学位（加注英文）',
  `startTime` varchar(30) NOT NULL COMMENT '开始时间',
  `endTime` varchar(30) NOT NULL COMMENT '结束时间',
  `country` varchar(50) NOT NULL COMMENT '国家',
  `college` varchar(50) NOT NULL COMMENT '院校',
  `major` varchar(50) NOT NULL COMMENT '专业',
  `descriptione` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报成员教育经历表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_member_eduction`
--

LOCK TABLES `un_channelplan_member_eduction` WRITE;
/*!40000 ALTER TABLE `un_channelplan_member_eduction` DISABLE KEYS */;
INSERT INTO `un_channelplan_member_eduction` VALUES ('1169150202024845314','1169137934176378882','1','2019/9/7','2019/11/6','Canada','温斯顿','猴子','12','2019-09-04 15:28:24','1161200620462718978','2019-09-04 15:29:25','1161200620462718978'),('1169150203622875138','1169137934176378882','1','2019/9/7','2019/11/6','Canada','温斯顿','猩猩','12','2019-09-04 15:28:24','1161200620462718978',NULL,NULL),('1169160927896166401','1169152120428191745','21','23','1','3','12','2','3','2019-09-04 16:11:01','1161200620462718978',NULL,NULL),('1169160929313841154','1169152120428191745','21','23','1','3','12','2','3','2019-09-04 16:11:02','1161200620462718978',NULL,NULL),('1169161991349362690','1169137934176378882','1','1','1','1','1','11','1','2019-09-04 16:15:15','1161200620462718978',NULL,NULL),('1171328141042675713','1171327109118062593','12','3','12','12','3','12','31','2019-09-10 15:42:45','1161200620462718978',NULL,NULL),('1181209205432934401','1181209011219881985','12','','','123','231','231','213','2019-10-07 22:06:34','1161200620462718978',NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_member_eduction` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_member_info`
--

DROP TABLE IF EXISTS `un_channelplan_member_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_member_info` (
  `id` varchar(30) NOT NULL COMMENT '唯一标志',
  `cpId` varchar(30) NOT NULL COMMENT '海峡计划申报id',
  `cName` varchar(50) NOT NULL COMMENT '姓名（中文）',
  `eName` varchar(50) DEFAULT NULL COMMENT '姓名（英文）',
  `sex` tinyint(1) NOT NULL COMMENT '性别',
  `birthday` varchar(20) NOT NULL,
  `birthplace` varchar(50) NOT NULL COMMENT '出生地',
  `photoUrl` varchar(50) NOT NULL COMMENT '证件照',
  `nationality` varchar(50) NOT NULL COMMENT '国籍',
  `cGraduate` varchar(200) NOT NULL COMMENT '毕业院校及专业，学位（中文）',
  `eGraduate` varchar(200) NOT NULL COMMENT '毕业院校及专业，学位（英文）',
  `cWorkUnit` varchar(200) NOT NULL COMMENT '回国（来晋）前工作单位及职务（中文）',
  `eWorkUnit` varchar(200) NOT NULL COMMENT '回国（来晋）前工作单位及职务（英文）',
  `education` varchar(100) NOT NULL COMMENT '学历学位',
  `companyName` varchar(100) NOT NULL COMMENT '公司名称',
  `post` varchar(50) NOT NULL COMMENT '职务（岗位）',
  `companyAddress` varchar(100) NOT NULL COMMENT '公司地址',
  `zipCode` varchar(10) DEFAULT NULL COMMENT '邮编',
  `field` varchar(50) NOT NULL COMMENT '研究领域',
  `workTime` varchar(20) DEFAULT NULL COMMENT '工作时间',
  `memberType` varchar(30) NOT NULL COMMENT '成员类别',
  `fieldSummary` text DEFAULT NULL COMMENT '研究领域概述',
  `developProduct` text DEFAULT NULL COMMENT '研究成果产品',
  `publishThesis` varchar(500) DEFAULT NULL COMMENT '发表的论文',
  `getAwardsDetail` text DEFAULT NULL COMMENT '获得各级奖励情况',
  `banProtocol` text DEFAULT NULL COMMENT '禁止协议',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报成员信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_member_info`
--

LOCK TABLES `un_channelplan_member_info` WRITE;
/*!40000 ALTER TABLE `un_channelplan_member_info` DISABLE KEYS */;
INSERT INTO `un_channelplan_member_info` VALUES ('1169137934176378882','1169092577866309633','二桶','todd',1,'2019-10-01','哥谭','123','05','哥谭大学','Gotham University','罗宾','Robin','16','歌谭市韦恩股份有限公司','惩罚者','歌谭市韦恩股份有限公司','445500','pf_xjzz','2019-10-01','teamLeader','神奇少女','神奇少年','神奇先生','神奇女士','停止推理','嗯嗯','2019-09-04 14:39:39','1161200620462718978','2019-10-14 14:49:17','1161200620462718978'),('1169152120428191745','1169092577866309633','蝙蝠侠','BatMan',1,'2010-10-01','哥谭','蝙蝠','05','歌坛大虚','Gotham University','超级英雄','SuperHero','03','歌谭市韦恩股份有限公司','SuperHero','歌谭市韦恩股份有限公司','9527','pf_xjzz','70','team01','中国','歌谭市','哥谭如何崛起','神奇女侠','禁止协作','123','2019-09-04 15:36:01','1161200620462718978','2019-10-14 14:34:48','1161200620462718978'),('1171327109118062593','1171326538470420482','21','32',1,'12','3','1','2','3','1','2','3','','','','4','3','pf_xcl','1','teamLeader','2','1','2','1','2','1','2019-09-10 15:38:39','1161200620462718978',NULL,NULL),('1179751018502631425','1179739450847080449','123','12',12,'23','12','123','132','23','12','32','23','03','12','31','21','32','pf_xjzz','123','23','23','123','32','13','23','13','2019-10-03 21:32:16','1161200620462718978',NULL,NULL),('1180490954948231170','1180490811377205249','12','23',1,'1','23','123','12','32','1233','12','23','19','32','23','23','12','','23','23','123','23','12','312','23','23','2019-10-05 22:32:30','1161200620462718978',NULL,NULL),('1180493131045421057','1180491589366071298','231','123',123,'12','123','13','123','13','23','13','','','','','','','','','','','','','','','','2019-10-05 22:41:09','1161200620462718978',NULL,NULL),('1180493549192364033','1169092577866309633','中古','231',1,'23','','','','','','','','','','','','','pf_xjzz','','','','','','','','','2019-10-05 22:42:49','1161200620462718978',NULL,NULL),('1180494230569631745','1169092577866309633','12','231',1,'2019-10-01','12','','03','12','12','32','123','18','cliase','superboy','claasifc','1231','pf_xjzz','2','team02','32','123','123','13','23','12','2019-10-05 22:45:31','1161200620462718978','2019-10-14 14:35:48','1161200620462718978'),('1180499730627575810','1180499511877844994','中国人','2',1,'1','12','','12','12','','','','','','','','','','','teamLeader','','','','','','','2019-10-05 23:07:23','1161200620462718978',NULL,NULL),('1180500354630959106','1180499511877844994','中国人','2',1,'1','12','','12','12','','','','','','','','','','','teamLeader','','','','','','','2019-10-05 23:09:51','1161200620462718978',NULL,NULL),('1180500666343243777','1180499511877844994','中国人','2',1,'1','12','','zhongguo','12','','','','18','','','','','','','teamLeader','','','','','','','2019-10-05 23:11:06','1161200620462718978',NULL,NULL),('1180500818139299841','1180499511877844994','中国人','2',1,'1','12','','zhongguo','12','','','','18','','','','','','','teamLeader','','','','','','','2019-10-05 23:11:42','1161200620462718978',NULL,NULL),('1180502145204502529','1180502024949612545','12','',1,'1','','','','','','','','','','','','','','','teamLeader','','','','','','','2019-10-05 23:16:58','1161200620462718978',NULL,NULL),('1181209011219881985','1181208751881871362','12','32',1,'1','1','1','1','1','1','1','1','16','12','31','12','12','pf_xjzz','12','teamLeader','12','21','21','12','12','12','2019-10-07 22:05:48','1161200620462718978',NULL,NULL),('1181209616571195393','1181209482135363586','12','231',12,'12','12','12','12','12','12','12','21','16','12','21','12','12','','12','12','12','12','12','12','12','21','2019-10-07 22:08:13','1161200620462718978',NULL,NULL),('1181209684313399298','1181209482135363586','12','231',12,'12','12','12','12','12','12','12','21','16','12','21','12','12','','12','teamLeader','12','12','12','12','12','21','2019-10-07 22:08:29','1161200620462718978',NULL,NULL),('1181211120627638273','1181210962372354050','12','231',12,'23','13','23','12','12','12','12','21','','12','12','12','12','','21','teamLeader','12','12','21','1221','21','12','2019-10-07 22:14:11','1161200620462718978',NULL,NULL),('1182545545055727618','1171326538470420482','忠臣','Charon',1,'2019-10-01','湖北恩施','','04','ks','fck','中文','英文','20','份的人','中层','顺丰到付','审得分','pf_xcl','2年','team01','是否','对的','论文发表','中文审得分','逻辑','科技','2019-10-11 14:36:43','1161200620462718978',NULL,NULL),('1182547090312818690','1171326538470420482','123','213',1,'2019-10-04','123','123','03','231','231','22','222','19','333','444','555','666','pf_xcl','2','team02','123','122','23','12','3','12','2019-10-11 14:42:51','1161200620462718978',NULL,NULL),('1182547434732285953','1171326538470420482','12','23',1,'2019-10-14','123','12','01','12','21','12','12','17','12','12','12','212','pf_xcl','121','team04','212','12','12','12','21','21','2019-10-11 14:44:13','1161200620462718978',NULL,NULL),('1182552263240216578','','123','去2',1,'2019-10-04','323','123','02','123','123','123','123','16','12','21','12','1212','','21','teamLeader','12','12','12','21','21','21','2019-10-11 15:03:24','1161200620462718978',NULL,NULL),('1182557901303345153','','123','onetwothree',1,'2019-10-01','中国','','02','香港中文大学','China University','发的','对方的','15','是否','得分','中国','23423','','2','teamLeader','啊',' 反对法','发的','得分','发的','发的','2019-10-11 15:25:49','1161200620462718978',NULL,NULL),('1182943706240786434','1182943506709356545','123','12',1,'2019-10-14','12','12','02','12','12','12','12','19','21','21','12','12','','21','teamLeader','12','12','21','21','21','21','2019-10-12 16:58:52','1161200620462718978',NULL,NULL),('1183949656078794753','1183664891215855618','二桶','todd',1,'2019-10-01','哥谭','123','05','哥谭大学','Gotham University','罗宾','Robin','05','歌谭市韦恩股份有限公司','惩罚者','歌谭市韦恩股份有限公司','445500','pf_xjzz','2019-10-01','teamLeader','神奇少女','神奇少年','神奇先生','神奇女士','停止推理','嗯嗯','2019-10-15 11:36:08','1182879508302561282','2019-10-15 11:43:42','1182879508302561282');
/*!40000 ALTER TABLE `un_channelplan_member_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_member_patent`
--

DROP TABLE IF EXISTS `un_channelplan_member_patent`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_member_patent` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `memberId` varchar(30) NOT NULL COMMENT '成员ID',
  `endTime` varchar(30) NOT NULL COMMENT '专利保护期',
  `name` varchar(100) NOT NULL COMMENT '专利名称',
  `country` varchar(50) NOT NULL COMMENT '授权国家',
  `owner` varchar(50) NOT NULL COMMENT '专利所有者',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报成员专利表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_member_patent`
--

LOCK TABLES `un_channelplan_member_patent` WRITE;
/*!40000 ALTER TABLE `un_channelplan_member_patent` DISABLE KEYS */;
INSERT INTO `un_channelplan_member_patent` VALUES ('1169789978050572289','1169137934176378882','123','123','123','123','123','2019-09-06 09:50:39','1161200620462718978',NULL,NULL),('1171328325747240962','1171327109118062593','23','12','23','123','13','2019-09-10 15:43:29','1161200620462718978',NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_member_patent` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_member_project`
--

DROP TABLE IF EXISTS `un_channelplan_member_project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_member_project` (
  `id` varchar(30) NOT NULL COMMENT '唯一标志',
  `memberId` varchar(30) NOT NULL COMMENT '成员id',
  `startTime` varchar(30) NOT NULL COMMENT '开始时间',
  `endTime` varchar(30) NOT NULL COMMENT '结束时间',
  `source` varchar(100) NOT NULL COMMENT '项目性质和来源',
  `totalMoney` decimal(10,0) NOT NULL COMMENT '经费总额',
  `number` tinyint(4) NOT NULL COMMENT '参与人数',
  `position` varchar(200) NOT NULL COMMENT '申报人的具体职务和任务',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报成员主要项目表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_member_project`
--

LOCK TABLES `un_channelplan_member_project` WRITE;
/*!40000 ALTER TABLE `un_channelplan_member_project` DISABLE KEYS */;
INSERT INTO `un_channelplan_member_project` VALUES ('1169789054938787841','1169137934176378882','1234','1234','1234',1234,1,'1234','1234','2019-09-06 09:46:58','1161200620462718978',NULL,NULL),('1171328257816293377','1171327109118062593','23','12','31',23,12,'12','31','2019-09-10 15:43:13','1161200620462718978',NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_member_project` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_member_work`
--

DROP TABLE IF EXISTS `un_channelplan_member_work`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_member_work` (
  `id` varchar(30) NOT NULL COMMENT '唯一标志',
  `memberId` varchar(30) NOT NULL COMMENT '成员Id',
  `post` varchar(50) NOT NULL COMMENT '职务（加注英文）',
  `startTime` varchar(30) NOT NULL COMMENT '开始时间',
  `endTime` varchar(30) NOT NULL COMMENT '结束时间',
  `country` varchar(50) NOT NULL COMMENT '国家',
  `unit` varchar(100) NOT NULL COMMENT '单位（加注英文）',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='海峡计划申报成员教育经历表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_member_work`
--

LOCK TABLES `un_channelplan_member_work` WRITE;
/*!40000 ALTER TABLE `un_channelplan_member_work` DISABLE KEYS */;
INSERT INTO `un_channelplan_member_work` VALUES ('1169150693937012737','1169137934176378882','12','323','123','12','31','23','2019-09-04 15:30:21','1161200620462718978',NULL,NULL),('1171328198282342401','1171327109118062593','23','12','31','12','31','12','2019-09-10 15:42:59','1161200620462718978',NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_member_work` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_channelplan_score_standard`
--

DROP TABLE IF EXISTS `un_channelplan_score_standard`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_channelplan_score_standard` (
  `id` varchar(30) NOT NULL COMMENT '唯一标志',
  `parentId` varchar(30) DEFAULT NULL COMMENT '父id',
  `step` tinyint(1) DEFAULT NULL COMMENT '评分步骤',
  `name` varchar(100) DEFAULT NULL COMMENT '名称',
  `score` varchar(5) DEFAULT NULL COMMENT '分值',
  `sn` tinyint(3) DEFAULT NULL COMMENT '排序',
  `description` varchar(255) DEFAULT NULL COMMENT '分值说明',
  `createTime` varchar(255) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(255) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='评分标准表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_channelplan_score_standard`
--

LOCK TABLES `un_channelplan_score_standard` WRITE;
/*!40000 ALTER TABLE `un_channelplan_score_standard` DISABLE KEYS */;
INSERT INTO `un_channelplan_score_standard` VALUES ('1','0',NULL,'顶级',NULL,NULL,NULL,NULL,NULL,NULL,NULL),('1162278009655529474','1',3,'中文','123',2,'2313','2019-08-16 16:20:46','1','2019-08-16 16:41:45','1'),('1173780492273864705','1162278009655529474',3,'23','10',1,'1','2019-09-17 10:07:31','1','2019-09-23 11:25:52','1'),('1174134430617583617','1162278009655529474',3,'诗歌','20',2,'2','2019-09-18 09:33:56','1','2019-09-23 11:26:00','1'),('1175974842797920257','1',2,'法文','24',2,'1','2019-09-23 11:27:05','1','2019-09-23 11:29:15','1'),('1175975518017949698','1175974842797920257',2,'异地','20',1,'1','2019-09-23 11:29:46','1',NULL,NULL),('1175975693042061314','1175974842797920257',2,'中文真的','24',23,'1','2019-09-23 11:30:28','1',NULL,NULL);
/*!40000 ALTER TABLE `un_channelplan_score_standard` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_childschool_fees`
--

DROP TABLE IF EXISTS `un_childschool_fees`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_childschool_fees` (
  `id` varchar(50) NOT NULL DEFAULT '' COMMENT '主键',
  `year` smallint(4) DEFAULT NULL COMMENT '申报年度',
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `talentId` varchar(40) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `pName` varchar(50) DEFAULT NULL COMMENT '父母姓名',
  `pSex` tinyint(1) DEFAULT NULL COMMENT '父母性别',
  `pCardType` varchar(10) DEFAULT NULL,
  `pIdcard` varchar(30) DEFAULT NULL COMMENT '父母证件号码',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `certificateNo` varchar(20) DEFAULT NULL COMMENT '证书编号',
  `nativePlace` varchar(50) DEFAULT NULL COMMENT '籍贯',
  `address` varchar(200) DEFAULT NULL COMMENT '现居地址',
  `phone` varchar(22) DEFAULT NULL COMMENT '联系电话',
  `cName` varchar(50) DEFAULT NULL COMMENT '子女姓名',
  `cSex` tinyint(1) DEFAULT NULL COMMENT '子女性别',
  `cCardType` varchar(20) DEFAULT NULL,
  `cIdcard` varchar(40) DEFAULT NULL COMMENT '子女证件号码',
  `cBirthday` varchar(20) DEFAULT NULL COMMENT '子女出生日期',
  `stuNumber` varchar(255) DEFAULT NULL COMMENT '学籍号',
  `cRelation` varchar(50) DEFAULT NULL COMMENT '与申报人关系',
  `nowSchool` varchar(100) DEFAULT NULL COMMENT '现就读学校',
  `nowGrade` varchar(50) DEFAULT NULL COMMENT '现就读年级',
  `paidInMoeny` decimal(10,2) DEFAULT NULL COMMENT '实缴学杂费金额',
  `bankName` varchar(100) DEFAULT NULL COMMENT '开户银行',
  `bankAddress` varchar(100) DEFAULT NULL COMMENT '开户银行网点',
  `bankNumber` varchar(50) DEFAULT NULL COMMENT '银行账号',
  `cashMoney` decimal(10,2) DEFAULT NULL COMMENT '兑现金额',
  `pensionDetail` varchar(50) DEFAULT NULL COMMENT '养老保险缴纳月份',
  `injuryDetai` varchar(50) DEFAULT NULL,
  `unemploymentDetail` varchar(50) DEFAULT NULL,
  `medicaDetail` varchar(50) DEFAULT NULL,
  `birthDetail` varchar(50) DEFAULT NULL,
  `taxDetail` varchar(50) DEFAULT NULL,
  `checkState` tinyint(3) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `files` varchar(500) DEFAULT NULL COMMENT '驳回附件',
  `fields` varchar(500) DEFAULT NULL COMMENT '驳回字段',
  `firstSubmitTime` varchar(50) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(50) DEFAULT NULL COMMENT '最新提交时间',
  `passTime` varchar(40) DEFAULT NULL,
  `publicState` tinyint(1) DEFAULT NULL COMMENT '公示状态',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_childschool_fees`
--

LOCK TABLES `un_childschool_fees` WRITE;
/*!40000 ALTER TABLE `un_childschool_fees` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_childschool_fees` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_common_filetype`
--

DROP TABLE IF EXISTS `un_common_filetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_common_filetype` (
  `id` varchar(50) NOT NULL,
  `type` int(2) DEFAULT NULL COMMENT '申报优秀人才类别',
  `source` int(1) DEFAULT 0 COMMENT '来源',
  `project` int(2) DEFAULT NULL COMMENT '申报项目',
  `name` varchar(200) DEFAULT NULL COMMENT '附件类型名称',
  `api` varchar(100) DEFAULT NULL COMMENT '附件类型api',
  `must` int(1) DEFAULT NULL COMMENT '是否必传',
  `active` int(1) DEFAULT NULL COMMENT '是否生效',
  `checkCompany` varchar(30) DEFAULT NULL COMMENT '审核单位',
  `sn` int(5) DEFAULT NULL COMMENT '排序',
  `description` varchar(3000) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `templateUrl` varchar(255) DEFAULT NULL COMMENT '模板',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='人才认定申报所需附件类别表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_common_filetype`
--

LOCK TABLES `un_common_filetype` WRITE;
/*!40000 ALTER TABLE `un_common_filetype` DISABLE KEYS */;
INSERT INTO `un_common_filetype` VALUES ('1178131640547270658',1,0,1,'身份证或护照正、反面',NULL,1,1,NULL,1,'','67','2019-12-24 11:04:06',NULL,NULL,NULL),('1185025144825004034',1,0,1,'本人承诺照（持有效身份证件拍照）','crz',1,1,'1158293574504660993',3,'','51','2019-10-18 10:49:45','1','2019-11-18 16:19:00',NULL),('1185025499830894594',1,0,1,'本人具备的认定条件相关材料','认定条件材料',1,1,'1158293574504660993',4,'包括： （1）最高学历证书（具有中专及以上学历人员提供，国境外学历证书需经教育部留学服务中心认证）。 （2）最高学位证书（具有学位的人员提供，国境外学位证书需经教育部留学服务中心认证）。 （3）专业技术职务任职资格证书（具有专业技术的人员提供，如专业技术职务任职资格是在外省评审通过的，须提供批文及评审表）。 （4）职业资格等级证书（具有职业资格证书的人员提供）。 （5）荣誉证书、获奖证书、专利证书、任职证明、项目成果、研究课题结题材料、论文检索报告等，其中，外文材料需提供翻译件并经驻外使领馆或公证处认证。','51','2019-10-18 10:51:10','1','2019-11-18 16:20:07',NULL),('1185026393880346625',1,0,1,'在我市工作或创业的有关凭证','凭证',1,1,'1158293574504660993',5,'申请人属受聘（受派）人才的，需提供申请人与用人单位签订的符合国家规定的劳动聘用合同（达到国家法定退休年龄的需提供工作协议）、任职证明；申请人属创业人才且担任法人的，需提供其创办企业的营业执照；申请人属项目合作人才的，需提供项目合作协议、任职证明。','51','2019-10-18 10:54:43','1','2019-11-18 16:20:40',NULL),('1185029319591936001',1,0,1,'其他（属近3年来晋的，需补充提供此栏材料）','qita',2,1,'1158293574504660993',7,'（1）提供来晋前上一家工作单位的离职证明及在当地缴交的社医保证明；（2）来晋后与首家企业签订的劳动合同及社医保证明。','51','2019-10-18 11:06:21','58','2019-12-30 17:32:01',NULL),('1191632569588469762',1,0,2,'《晋江市优秀人才津补贴申请表》','津补贴申请表',1,1,NULL,1,'请同时上传盖章扫描件(需人才联络员签名、单位负责人签章及用人单位加盖公章)和excel电子表格。','1','2019-11-05 16:25:18','87','2021-03-12 15:23:19','jjrcw/fileTypeTemplate/202103/1370274185829511169.xlsx'),('1191632641579503617',1,0,2,'申请人与用人单位签订的符合国家规定的劳动聘用合同','jbt_concat',1,1,NULL,2,'请提供劳动合同原件(如属复印件的，需注明原件复印并加盖公章)。','1','2019-11-05 16:25:35','58','2020-07-31 18:29:55',NULL),('1191632729605361666',1,0,2,'2020年度在我市个人所得税缴交证明，即个人所得税纳税记录(原《税收完税证明》)，以及“个人所得税”APP截图(进入首页中的常用业务—收入纳税明细查询—2020年度所得类型为工资薪金—截图打印2020年1月至12月的收入情况)','jbt_tax',2,1,NULL,3,'个人所得税手机截图需经本人承诺写明“本截图与个人所得税APP一致”后签名盖手印，并加盖用人单位公章。','1','2019-11-05 16:25:56','87','2021-03-12 15:37:26',NULL),('1196343628982788098',1,0,8,'本人具备的新认定条件相关材料',NULL,1,1,NULL,1,'（1）最高学历证书（具有中专及以上学历人员提供，国境外学历证书需经教育部留学服务中心认证）。 （2）最高学位证书（具有学位的人员提供，国境外学位证书需经教育部留学服务中心认证）。 （3）专业技术职务任职资格证书（具有专业技术的人员提供，如专业技术职务任职资格是在外省评审通过的，须提供批文及评审表）。 （4）职业资格等级证书（具有职业资格证书的人员提供）。 （5）荣誉证书、获奖证书、专利证书、任职证明、项目成果、研究课题结题材料、论文检索报告等，其中，外文材料需提供翻译件并经驻外使领馆或公证处认证。','1','2019-11-18 16:25:22','58','2019-12-27 10:32:58',NULL),('1196343732812783618',1,0,8,'在我市工作或创业的有关凭证',NULL,1,1,NULL,2,'申请人属受聘（受派）人才的，需提供申请人与用人单位签订的符合国家规定的劳动聘用合同（达到国家法定退休年龄的需提供工作协议）、任职证明；申请人属创业人才且担任法人的，需提供其创办企业的营业执照；申请人属项目合作人才的，需提供项目合作协议、任职证明。','1','2019-11-18 16:25:47','58','2019-12-27 10:33:03',NULL),('1196344467621289985',1,0,8,'其他（已公布入选的泉州市第一至第七层次人才，需补充提供此栏材料）',NULL,2,1,NULL,3,'经泉州市公布入选的泉州第一至第五层次人才，需上传公布入选批文及泉州市高层次人才证书；经我市公布入选的泉州第六七层次人才，只需提供入选批文。','1','2019-11-18 16:28:42','58','2020-03-20 10:31:57',NULL),('1197359440011149314',2,0,1,'本人具备的符合认定条件相关材料',NULL,1,1,NULL,3,'包括：学位证书、专业技术职务资格证书、职业资格证书、获奖证书、专利证书、任职文件、项目成果、杂志期刊等，其中：国（境）外学位证书需经教育部留学服务中心认证，外文材料需提供翻译件并经驻外使领馆或公证处认证；','59','2019-11-21 11:41:50','59','2019-12-25 20:19:13',NULL),('1197359624057208833',2,0,1,'在我市工作或创业的有关凭证',NULL,1,1,NULL,4,'申请人属受聘（受派）人才的，需提供申请人与用人单位签订的符合国家规定的劳动（聘用）合同、任职文件，用人单位还需提供《营业执照》；申请人属创业人才的，需提供其创办企业的《营业执照》、经市场监督管理部门备案的公司章程。','59','2019-11-21 11:42:34',NULL,NULL,NULL),('1207221285556019202',1,0,3,'优秀人才相关离职手续',NULL,1,1,NULL,1,'','1','2019-12-18 16:49:17',NULL,NULL,NULL),('1207221371723800578',1,0,3,'其他',NULL,2,1,NULL,2,'','1','2019-12-18 16:49:38',NULL,NULL,NULL),('1207570630070976514',1,0,4,'与用人单位签订的符合国家规定的劳动（聘用）合同、任职证明',NULL,1,1,NULL,1,'','1','2019-12-19 15:57:28','1','2019-12-19 15:58:44',NULL),('1207570733326352385',1,0,4,'其他(如行政介绍信、其他补充材料等)','',2,1,NULL,2,'','1','2019-12-19 15:57:53','58','2020-06-19 11:11:07',NULL),('1209379284185239553',2,0,1,'身份证件（身份证、通行证或护照）',NULL,1,1,NULL,2,'','59','2019-12-24 15:44:25',NULL,NULL,NULL),('1209381032522141698',2,0,1,'其他需补充材料',NULL,2,1,NULL,4,'','59','2019-12-24 15:51:21',NULL,NULL,NULL),('1209810430937235457',2,0,8,'本人具备的符合认定条件的相关材料',NULL,1,1,NULL,1,'包括：学位证书、专业技术职务资格证书、职业资格证书、获奖证书、专利证书、任职文件、项目成果、杂志期刊等，其中：国（境）外学位证书需经教育部留学服务中心认证，外文材料需提供翻译件并经驻外使领馆或公证处认证；','59','2019-12-25 20:17:38','59','2019-12-25 20:19:20',NULL),('1209811013886771202',2,0,3,'离职证明材料',NULL,1,1,NULL,1,'','59','2019-12-25 20:19:57',NULL,NULL,NULL),('1209811775526240257',2,0,4,'变更工作单位后在我市工作或创业的相关凭证',NULL,1,1,NULL,1,'申请人属受聘（受派）人才的，需提供申请人与用人单位签订的符合国家规定的劳动（聘用）合同、任职文件，用人单位还需提供《营业执照》；申请人属创业人才的，需提供其创办企业的《营业执照》、经市场监督管理部门备案的公司章程。','59','2019-12-25 20:22:59','59','2019-12-25 20:24:18',NULL),('1210382500880424962',1,0,1,'其他（已公布入选的泉州第一至第七层次人才，需补充提供此栏材料）',NULL,2,1,NULL,6,'经泉州市公布入选的泉州第一至第五层次人才，需上传公布入选批文及泉州市高层次人才证书；经我市公布入选的泉州第六七层次人才，只需提供入选批文。','58','2019-12-27 10:10:50','58','2020-03-20 10:32:06',NULL),('1211580107710316546',1,0,1,'其他（如行政介绍信、高中及以上毕业证书、其他补充材料等）',NULL,2,1,NULL,8,'','58','2019-12-30 17:29:42','58','2020-01-16 17:37:47',NULL),('1211581419462115330',1,0,8,'其他(如行政介绍信、高中及以上毕业证书、其他补充材料等)','rcccbg_other2',2,1,NULL,4,'','58','2019-12-30 17:34:55','1','2020-06-19 11:19:23',NULL),('1281431496145514498',1,0,6,'《户口簿》或子女的出生证明(能体现亲子关系的证明材料)','school_child',1,1,NULL,1,'','1','2020-07-10 11:34:11','1','2020-07-10 17:15:47',NULL),('1281431787884523521',1,0,6,'《房产证》(或发证机关盖章认定的《房产证》','school_house',2,1,NULL,2,'','1','2020-07-10 11:35:20','1','2020-07-10 17:16:20',NULL),('1281433887414693889',1,0,6,'《不动产权证书》复印件，经住建局备案的《购房合同》)或《劳动合同书》','school_concat',2,1,NULL,4,'','1','2020-07-10 11:43:41','1','2020-07-10 17:16:37',NULL),('1288017909511127041',1,0,2,'其他','津补贴其他',2,1,NULL,4,'','58','2020-07-28 15:46:14',NULL,NULL,NULL),('1290955423330926593',1,0,9,'其他','基础信息变更',1,1,NULL,1,'请上传相关的证明材料。','58','2020-08-05 18:18:52','58','2020-08-06 09:46:21',NULL),('1302805538890870785',1,0,5,'《晋江市优秀人才购房补贴申请表》','购房补贴申请表',1,1,NULL,1,'请同时上传盖章扫描件和excel电子表格。','58','2020-09-07 11:07:00','58','2020-09-09 17:57:15','jjrcw/fileTypeTemplate/202009/1303633559440883714.xlsx'),('1302806429249335298',1,0,5,'相关材料：1、申请人及其配偶、未成年子女户口簿(或公安部门出具的户籍证明)、身份证；2、申请人的婚姻关系证明(结婚证、离婚证、离婚生效文书、丧偶证明等)','相关材料',1,1,NULL,2,'','58','2020-09-07 11:10:32',NULL,NULL,NULL),('1302807816649601025',1,0,5,'首次申请兑现购房补贴的，还需提供经市住建局备案的购房合同(已办理不动产权证书的需提供不动产权证书)原件扫描件，其中：一次性付全款购买房产的，还需提供购房全款发票原件扫描件，若按揭购买房产的，还需提供房贷借款合同原件扫描件。','购房补贴扫描件',2,1,NULL,3,'非首次申请兑现购房补贴的，无需提供此栏材料。','58','2020-09-07 11:16:03',NULL,NULL,NULL),('1302808116395536385',1,0,5,'其他','购房补贴其他',2,1,NULL,4,'','58','2020-09-07 11:17:14',NULL,NULL,NULL),('1375358083915620354',2,0,11,'上一年度个人所得税纳税记录','individual income tax',1,1,NULL,1,'上一年度个人所得税缴纳记录，','59','2021-03-26 16:04:54',NULL,NULL,NULL),('1491690854880550913',1,0,19,'身份证','sb_idCard',1,1,NULL,1,'','1','2022-02-10 16:29:48',NULL,NULL,'jjrcw/fileTypeTemplate/202202/1491690852137476098.xlsx');
/*!40000 ALTER TABLE `un_common_filetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_common_location`
--

DROP TABLE IF EXISTS `un_common_location`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_common_location` (
  `id` int(11) NOT NULL AUTO_INCREMENT,
  `createdAt` datetime DEFAULT NULL,
  `updatedAt` datetime DEFAULT NULL,
  `name` varchar(50) NOT NULL,
  `code` char(6) NOT NULL,
  `fullName` varchar(200) NOT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=3615 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_common_location`
--

LOCK TABLES `un_common_location` WRITE;
/*!40000 ALTER TABLE `un_common_location` DISABLE KEYS */;
INSERT INTO `un_common_location` VALUES (1,'2016-03-18 11:28:48','2016-03-18 11:28:48','北京市','110000','北京市'),(2,'2016-03-18 11:28:48','2016-03-18 11:28:48','市辖区','110100','北京市市辖区'),(3,'2016-03-18 11:28:48','2016-03-18 11:28:48','东城区','110101','北京市东城区'),(4,'2016-03-18 11:28:48','2016-03-18 11:28:48','西城区','110102','北京市西城区'),(5,'2016-03-18 11:28:48','2016-03-18 11:28:48','朝阳区','110105','北京市朝阳区'),(6,'2016-03-18 11:28:49','2016-03-18 11:28:49','丰台区','110106','北京市丰台区'),(7,'2016-03-18 11:28:49','2016-03-18 11:28:49','石景山区','110107','北京市石景山区'),(8,'2016-03-18 11:28:49','2016-03-18 11:28:49','海淀区','110108','北京市海淀区'),(9,'2016-03-18 11:28:49','2016-03-18 11:28:49','门头沟区','110109','北京市门头沟区'),(10,'2016-03-18 11:28:49','2016-03-18 11:28:49','房山区','110111','北京市房山区'),(11,'2016-03-18 11:28:49','2016-03-18 11:28:49','通州区','110112','北京市通州区'),(12,'2016-03-18 11:28:49','2016-03-18 11:28:49','顺义区','110113','北京市顺义区'),(13,'2016-03-18 11:28:49','2016-03-18 11:28:49','昌平区','110114','北京市昌平区'),(14,'2016-03-18 11:28:49','2016-03-18 11:28:49','大兴区','110115','北京市大兴区'),(15,'2016-03-18 11:28:49','2016-03-18 11:28:49','怀柔区','110116','北京市怀柔区'),(16,'2016-03-18 11:28:49','2016-03-18 11:28:49','平谷区','110117','北京市平谷区'),(17,'2016-03-18 11:28:49','2016-03-18 11:28:49','县','110200','北京市县'),(18,'2016-03-18 11:28:49','2016-03-18 11:28:49','密云县','110228','北京市密云县'),(19,'2016-03-18 11:28:50','2016-03-18 11:28:50','延庆县','110229','北京市延庆县'),(20,'2016-03-18 11:28:50','2016-03-18 11:28:50','天津市','120000','天津市'),(21,'2016-03-18 11:28:50','2016-03-18 11:28:50','市辖区','120100','天津市市辖区'),(22,'2016-03-18 11:28:50','2016-03-18 11:28:50','和平区','120101','天津市和平区'),(23,'2016-03-18 11:28:50','2016-03-18 11:28:50','河东区','120102','天津市河东区'),(24,'2016-03-18 11:28:50','2016-03-18 11:28:50','河西区','120103','天津市河西区'),(25,'2016-03-18 11:28:50','2016-03-18 11:28:50','南开区','120104','天津市南开区'),(26,'2016-03-18 11:28:50','2016-03-18 11:28:50','河北区','120105','天津市河北区'),(27,'2016-03-18 11:28:50','2016-03-18 11:28:50','红桥区','120106','天津市红桥区'),(28,'2016-03-18 11:28:50','2016-03-18 11:28:50','东丽区','120110','天津市东丽区'),(29,'2016-03-18 11:28:50','2016-03-18 11:28:50','西青区','120111','天津市西青区'),(30,'2016-03-18 11:28:51','2016-03-18 11:28:51','津南区','120112','天津市津南区'),(31,'2016-03-18 11:28:51','2016-03-18 11:28:51','北辰区','120113','天津市北辰区'),(32,'2016-03-18 11:28:51','2016-03-18 11:28:51','武清区','120114','天津市武清区'),(33,'2016-03-18 11:28:51','2016-03-18 11:28:51','宝坻区','120115','天津市宝坻区'),(34,'2016-03-18 11:28:51','2016-03-18 11:28:51','滨海新区','120116','天津市滨海新区'),(35,'2016-03-18 11:28:51','2016-03-18 11:28:51','县','120200','天津市县'),(36,'2016-03-18 11:28:51','2016-03-18 11:28:51','宁河县','120221','天津市宁河县'),(37,'2016-03-18 11:28:51','2016-03-18 11:28:51','静海县','120223','天津市静海县'),(38,'2016-03-18 11:28:51','2016-03-18 11:28:51','蓟县','120225','天津市蓟县'),(39,'2016-03-18 11:28:51','2016-03-18 11:28:51','河北省','130000','河北省'),(40,'2016-03-18 11:28:51','2016-03-18 11:28:51','石家庄市','130100','河北省石家庄市'),(41,'2016-03-18 11:28:51','2016-03-18 11:28:51','市辖区','130101','河北省石家庄市市辖区'),(42,'2016-03-18 11:28:51','2016-03-18 11:28:51','长安区','130102','河北省石家庄市长安区'),(43,'2016-03-18 11:28:51','2016-03-18 11:28:51','桥西区','130104','河北省石家庄市桥西区'),(44,'2016-03-18 11:28:51','2016-03-18 11:28:51','新华区','130105','河北省石家庄市新华区'),(45,'2016-03-18 11:28:51','2016-03-18 11:28:51','井陉矿区','130107','河北省石家庄市井陉矿区'),(46,'2016-03-18 11:28:52','2016-03-18 11:28:52','裕华区','130108','河北省石家庄市裕华区'),(47,'2016-03-18 11:28:52','2016-03-18 11:28:52','藁城区','130109','河北省石家庄市藁城区'),(48,'2016-03-18 11:28:52','2016-03-18 11:28:52','鹿泉区','130110','河北省石家庄市鹿泉区'),(49,'2016-03-18 11:28:52','2016-03-18 11:28:52','栾城区','130111','河北省石家庄市栾城区'),(50,'2016-03-18 11:28:52','2016-03-18 11:28:52','井陉县','130121','河北省石家庄市井陉县'),(51,'2016-03-18 11:28:52','2016-03-18 11:28:52','正定县','130123','河北省石家庄市正定县'),(52,'2016-03-18 11:28:52','2016-03-18 11:28:52','行唐县','130125','河北省石家庄市行唐县'),(53,'2016-03-18 11:28:52','2016-03-18 11:28:52','灵寿县','130126','河北省石家庄市灵寿县'),(54,'2016-03-18 11:28:52','2016-03-18 11:28:52','高邑县','130127','河北省石家庄市高邑县'),(55,'2016-03-18 11:28:52','2016-03-18 11:28:52','深泽县','130128','河北省石家庄市深泽县'),(56,'2016-03-18 11:28:52','2016-03-18 11:28:52','赞皇县','130129','河北省石家庄市赞皇县'),(57,'2016-03-18 11:28:52','2016-03-18 11:28:52','无极县','130130','河北省石家庄市无极县'),(58,'2016-03-18 11:28:52','2016-03-18 11:28:52','平山县','130131','河北省石家庄市平山县'),(59,'2016-03-18 11:28:52','2016-03-18 11:28:52','元氏县','130132','河北省石家庄市元氏县'),(60,'2016-03-18 11:28:52','2016-03-18 11:28:52','赵县','130133','河北省石家庄市赵县'),(61,'2016-03-18 11:28:52','2016-03-18 11:28:52','辛集市','130181','河北省石家庄市辛集市'),(62,'2016-03-18 11:28:52','2016-03-18 11:28:52','晋州市','130183','河北省石家庄市晋州市'),(63,'2016-03-18 11:28:52','2016-03-18 11:28:52','新乐市','130184','河北省石家庄市新乐市'),(64,'2016-03-18 11:28:52','2016-03-18 11:28:52','唐山市','130200','河北省唐山市'),(65,'2016-03-18 11:28:52','2016-03-18 11:28:52','市辖区','130201','河北省唐山市市辖区'),(66,'2016-03-18 11:28:53','2016-03-18 11:28:53','路南区','130202','河北省唐山市路南区'),(67,'2016-03-18 11:28:53','2016-03-18 11:28:53','路北区','130203','河北省唐山市路北区'),(68,'2016-03-18 11:28:53','2016-03-18 11:28:53','古冶区','130204','河北省唐山市古冶区'),(69,'2016-03-18 11:28:53','2016-03-18 11:28:53','开平区','130205','河北省唐山市开平区'),(70,'2016-03-18 11:28:53','2016-03-18 11:28:53','丰南区','130207','河北省唐山市丰南区'),(71,'2016-03-18 11:28:53','2016-03-18 11:28:53','丰润区','130208','河北省唐山市丰润区'),(72,'2016-03-18 11:28:53','2016-03-18 11:28:53','曹妃甸区','130209','河北省唐山市曹妃甸区'),(73,'2016-03-18 11:28:53','2016-03-18 11:28:53','滦县','130223','河北省唐山市滦县'),(74,'2016-03-18 11:28:53','2016-03-18 11:28:53','滦南县','130224','河北省唐山市滦南县'),(75,'2016-03-18 11:28:53','2016-03-18 11:28:53','乐亭县','130225','河北省唐山市乐亭县'),(76,'2016-03-18 11:28:53','2016-03-18 11:28:53','迁西县','130227','河北省唐山市迁西县'),(77,'2016-03-18 11:28:53','2016-03-18 11:28:53','玉田县','130229','河北省唐山市玉田县'),(78,'2016-03-18 11:28:53','2016-03-18 11:28:53','遵化市','130281','河北省唐山市遵化市'),(79,'2016-03-18 11:28:53','2016-03-18 11:28:53','迁安市','130283','河北省唐山市迁安市'),(80,'2016-03-18 11:28:53','2016-03-18 11:28:53','秦皇岛市','130300','河北省秦皇岛市'),(81,'2016-03-18 11:28:53','2016-03-18 11:28:53','市辖区','130301','河北省秦皇岛市市辖区'),(82,'2016-03-18 11:28:53','2016-03-18 11:28:53','海港区','130302','河北省秦皇岛市海港区'),(83,'2016-03-18 11:28:53','2016-03-18 11:28:53','山海关区','130303','河北省秦皇岛市山海关区'),(84,'2016-03-18 11:28:53','2016-03-18 11:28:53','北戴河区','130304','河北省秦皇岛市北戴河区'),(85,'2016-03-18 11:28:54','2016-03-18 11:28:54','青龙满族自治县','130321','河北省秦皇岛市青龙满族自治县'),(86,'2016-03-18 11:28:54','2016-03-18 11:28:54','昌黎县','130322','河北省秦皇岛市昌黎县'),(87,'2016-03-18 11:28:54','2016-03-18 11:28:54','抚宁县','130323','河北省秦皇岛市抚宁县'),(88,'2016-03-18 11:28:54','2016-03-18 11:28:54','卢龙县','130324','河北省秦皇岛市卢龙县'),(89,'2016-03-18 11:28:54','2016-03-18 11:28:54','邯郸市','130400','河北省邯郸市'),(90,'2016-03-18 11:28:54','2016-03-18 11:28:54','市辖区','130401','河北省邯郸市市辖区'),(91,'2016-03-18 11:28:54','2016-03-18 11:28:54','邯山区','130402','河北省邯郸市邯山区'),(92,'2016-03-18 11:28:54','2016-03-18 11:28:54','丛台区','130403','河北省邯郸市丛台区'),(93,'2016-03-18 11:28:54','2016-03-18 11:28:54','复兴区','130404','河北省邯郸市复兴区'),(94,'2016-03-18 11:28:54','2016-03-18 11:28:54','峰峰矿区','130406','河北省邯郸市峰峰矿区'),(95,'2016-03-18 11:28:54','2016-03-18 11:28:54','邯郸县','130421','河北省邯郸市邯郸县'),(96,'2016-03-18 11:28:54','2016-03-18 11:28:54','临漳县','130423','河北省邯郸市临漳县'),(97,'2016-03-18 11:28:54','2016-03-18 11:28:54','成安县','130424','河北省邯郸市成安县'),(98,'2016-03-18 11:28:54','2016-03-18 11:28:54','大名县','130425','河北省邯郸市大名县'),(99,'2016-03-18 11:28:54','2016-03-18 11:28:54','涉县','130426','河北省邯郸市涉县'),(100,'2016-03-18 11:28:54','2016-03-18 11:28:54','磁县','130427','河北省邯郸市磁县'),(101,'2016-03-18 11:28:54','2016-03-18 11:28:54','肥乡县','130428','河北省邯郸市肥乡县'),(102,'2016-03-18 11:28:54','2016-03-18 11:28:54','永年县','130429','河北省邯郸市永年县'),(103,'2016-03-18 11:28:55','2016-03-18 11:28:55','邱县','130430','河北省邯郸市邱县'),(104,'2016-03-18 11:28:55','2016-03-18 11:28:55','鸡泽县','130431','河北省邯郸市鸡泽县'),(105,'2016-03-18 11:28:55','2016-03-18 11:28:55','广平县','130432','河北省邯郸市广平县'),(106,'2016-03-18 11:28:55','2016-03-18 11:28:55','馆陶县','130433','河北省邯郸市馆陶县'),(107,'2016-03-18 11:28:55','2016-03-18 11:28:55','魏县','130434','河北省邯郸市魏县'),(108,'2016-03-18 11:28:55','2016-03-18 11:28:55','曲周县','130435','河北省邯郸市曲周县'),(109,'2016-03-18 11:28:55','2016-03-18 11:28:55','武安市','130481','河北省邯郸市武安市'),(110,'2016-03-18 11:28:55','2016-03-18 11:28:55','邢台市','130500','河北省邢台市'),(111,'2016-03-18 11:28:55','2016-03-18 11:28:55','市辖区','130501','河北省邢台市市辖区'),(112,'2016-03-18 11:28:55','2016-03-18 11:28:55','桥东区','130502','河北省邢台市桥东区'),(113,'2016-03-18 11:28:55','2016-03-18 11:28:55','桥西区','130503','河北省邢台市桥西区'),(114,'2016-03-18 11:28:55','2016-03-18 11:28:55','邢台县','130521','河北省邢台市邢台县'),(115,'2016-03-18 11:28:55','2016-03-18 11:28:55','临城县','130522','河北省邢台市临城县'),(116,'2016-03-18 11:28:55','2016-03-18 11:28:55','内丘县','130523','河北省邢台市内丘县'),(117,'2016-03-18 11:28:55','2016-03-18 11:28:55','柏乡县','130524','河北省邢台市柏乡县'),(118,'2016-03-18 11:28:55','2016-03-18 11:28:55','隆尧县','130525','河北省邢台市隆尧县'),(119,'2016-03-18 11:28:55','2016-03-18 11:28:55','任县','130526','河北省邢台市任县'),(120,'2016-03-18 11:28:55','2016-03-18 11:28:55','南和县','130527','河北省邢台市南和县'),(121,'2016-03-18 11:28:56','2016-03-18 11:28:56','宁晋县','130528','河北省邢台市宁晋县'),(122,'2016-03-18 11:28:56','2016-03-18 11:28:56','巨鹿县','130529','河北省邢台市巨鹿县'),(123,'2016-03-18 11:28:56','2016-03-18 11:28:56','新河县','130530','河北省邢台市新河县'),(124,'2016-03-18 11:28:56','2016-03-18 11:28:56','广宗县','130531','河北省邢台市广宗县'),(125,'2016-03-18 11:28:56','2016-03-18 11:28:56','平乡县','130532','河北省邢台市平乡县'),(126,'2016-03-18 11:28:56','2016-03-18 11:28:56','威县','130533','河北省邢台市威县'),(127,'2016-03-18 11:28:56','2016-03-18 11:28:56','清河县','130534','河北省邢台市清河县'),(128,'2016-03-18 11:28:56','2016-03-18 11:28:56','临西县','130535','河北省邢台市临西县'),(129,'2016-03-18 11:28:56','2016-03-18 11:28:56','南宫市','130581','河北省邢台市南宫市'),(130,'2016-03-18 11:28:56','2016-03-18 11:28:56','沙河市','130582','河北省邢台市沙河市'),(131,'2016-03-18 11:28:56','2016-03-18 11:28:56','保定市','130600','河北省保定市'),(132,'2016-03-18 11:28:56','2016-03-18 11:28:56','市辖区','130601','河北省保定市市辖区'),(133,'2016-03-18 11:28:56','2016-03-18 11:28:56','新市区','130602','河北省保定市新市区'),(134,'2016-03-18 11:28:56','2016-03-18 11:28:56','北市区','130603','河北省保定市北市区'),(135,'2016-03-18 11:28:56','2016-03-18 11:28:56','南市区','130604','河北省保定市南市区'),(136,'2016-03-18 11:28:57','2016-03-18 11:28:57','满城县','130621','河北省保定市满城县'),(137,'2016-03-18 11:28:57','2016-03-18 11:28:57','清苑县','130622','河北省保定市清苑县'),(138,'2016-03-18 11:28:57','2016-03-18 11:28:57','涞水县','130623','河北省保定市涞水县'),(139,'2016-03-18 11:28:57','2016-03-18 11:28:57','阜平县','130624','河北省保定市阜平县'),(140,'2016-03-18 11:28:57','2016-03-18 11:28:57','徐水县','130625','河北省保定市徐水县'),(141,'2016-03-18 11:28:57','2016-03-18 11:28:57','定兴县','130626','河北省保定市定兴县'),(142,'2016-03-18 11:28:57','2016-03-18 11:28:57','唐县','130627','河北省保定市唐县'),(143,'2016-03-18 11:28:57','2016-03-18 11:28:57','高阳县','130628','河北省保定市高阳县'),(144,'2016-03-18 11:28:57','2016-03-18 11:28:57','容城县','130629','河北省保定市容城县'),(145,'2016-03-18 11:28:57','2016-03-18 11:28:57','涞源县','130630','河北省保定市涞源县'),(146,'2016-03-18 11:28:57','2016-03-18 11:28:57','望都县','130631','河北省保定市望都县'),(147,'2016-03-18 11:28:57','2016-03-18 11:28:57','安新县','130632','河北省保定市安新县'),(148,'2016-03-18 11:28:57','2016-03-18 11:28:57','易县','130633','河北省保定市易县'),(149,'2016-03-18 11:28:57','2016-03-18 11:28:57','曲阳县','130634','河北省保定市曲阳县'),(150,'2016-03-18 11:28:57','2016-03-18 11:28:57','蠡县','130635','河北省保定市蠡县'),(151,'2016-03-18 11:28:58','2016-03-18 11:28:58','顺平县','130636','河北省保定市顺平县'),(152,'2016-03-18 11:28:58','2016-03-18 11:28:58','博野县','130637','河北省保定市博野县'),(153,'2016-03-18 11:28:58','2016-03-18 11:28:58','雄县','130638','河北省保定市雄县'),(154,'2016-03-18 11:28:58','2016-03-18 11:28:58','涿州市','130681','河北省保定市涿州市'),(155,'2016-03-18 11:28:58','2016-03-18 11:28:58','定州市','130682','河北省保定市定州市'),(156,'2016-03-18 11:28:58','2016-03-18 11:28:58','安国市','130683','河北省保定市安国市'),(157,'2016-03-18 11:28:58','2016-03-18 11:28:58','高碑店市','130684','河北省保定市高碑店市'),(158,'2016-03-18 11:28:58','2016-03-18 11:28:58','张家口市','130700','河北省张家口市'),(159,'2016-03-18 11:28:58','2016-03-18 11:28:58','市辖区','130701','河北省张家口市市辖区'),(160,'2016-03-18 11:28:58','2016-03-18 11:28:58','桥东区','130702','河北省张家口市桥东区'),(161,'2016-03-18 11:28:58','2016-03-18 11:28:58','桥西区','130703','河北省张家口市桥西区'),(162,'2016-03-18 11:28:58','2016-03-18 11:28:58','宣化区','130705','河北省张家口市宣化区'),(163,'2016-03-18 11:28:58','2016-03-18 11:28:58','下花园区','130706','河北省张家口市下花园区'),(164,'2016-03-18 11:28:59','2016-03-18 11:28:59','宣化县','130721','河北省张家口市宣化县'),(165,'2016-03-18 11:28:59','2016-03-18 11:28:59','张北县','130722','河北省张家口市张北县'),(166,'2016-03-18 11:28:59','2016-03-18 11:28:59','康保县','130723','河北省张家口市康保县'),(167,'2016-03-18 11:28:59','2016-03-18 11:28:59','沽源县','130724','河北省张家口市沽源县'),(168,'2016-03-18 11:28:59','2016-03-18 11:28:59','尚义县','130725','河北省张家口市尚义县'),(169,'2016-03-18 11:28:59','2016-03-18 11:28:59','蔚县','130726','河北省张家口市蔚县'),(170,'2016-03-18 11:28:59','2016-03-18 11:28:59','阳原县','130727','河北省张家口市阳原县'),(171,'2016-03-18 11:28:59','2016-03-18 11:28:59','怀安县','130728','河北省张家口市怀安县'),(172,'2016-03-18 11:28:59','2016-03-18 11:28:59','万全县','130729','河北省张家口市万全县'),(173,'2016-03-18 11:28:59','2016-03-18 11:28:59','怀来县','130730','河北省张家口市怀来县'),(174,'2016-03-18 11:28:59','2016-03-18 11:28:59','涿鹿县','130731','河北省张家口市涿鹿县'),(175,'2016-03-18 11:28:59','2016-03-18 11:28:59','赤城县','130732','河北省张家口市赤城县'),(176,'2016-03-18 11:29:00','2016-03-18 11:29:00','崇礼县','130733','河北省张家口市崇礼县'),(177,'2016-03-18 11:29:00','2016-03-18 11:29:00','承德市','130800','河北省承德市'),(178,'2016-03-18 11:29:00','2016-03-18 11:29:00','市辖区','130801','河北省承德市市辖区'),(179,'2016-03-18 11:29:00','2016-03-18 11:29:00','双桥区','130802','河北省承德市双桥区'),(180,'2016-03-18 11:29:00','2016-03-18 11:29:00','双滦区','130803','河北省承德市双滦区'),(181,'2016-03-18 11:29:00','2016-03-18 11:29:00','鹰手营子矿区','130804','河北省承德市鹰手营子矿区'),(182,'2016-03-18 11:29:00','2016-03-18 11:29:00','承德县','130821','河北省承德市承德县'),(183,'2016-03-18 11:29:00','2016-03-18 11:29:00','兴隆县','130822','河北省承德市兴隆县'),(184,'2016-03-18 11:29:00','2016-03-18 11:29:00','平泉县','130823','河北省承德市平泉县'),(185,'2016-03-18 11:29:00','2016-03-18 11:29:00','滦平县','130824','河北省承德市滦平县'),(186,'2016-03-18 11:29:00','2016-03-18 11:29:00','隆化县','130825','河北省承德市隆化县'),(187,'2016-03-18 11:29:00','2016-03-18 11:29:00','丰宁满族自治县','130826','河北省承德市丰宁满族自治县'),(188,'2016-03-18 11:29:00','2016-03-18 11:29:00','宽城满族自治县','130827','河北省承德市宽城满族自治县'),(189,'2016-03-18 11:29:01','2016-03-18 11:29:01','围场满族蒙古族自治县','130828','河北省承德市围场满族蒙古族自治县'),(190,'2016-03-18 11:29:01','2016-03-18 11:29:01','沧州市','130900','河北省沧州市'),(191,'2016-03-18 11:29:01','2016-03-18 11:29:01','市辖区','130901','河北省沧州市市辖区'),(192,'2016-03-18 11:29:01','2016-03-18 11:29:01','新华区','130902','河北省沧州市新华区'),(193,'2016-03-18 11:29:01','2016-03-18 11:29:01','运河区','130903','河北省沧州市运河区'),(194,'2016-03-18 11:29:01','2016-03-18 11:29:01','沧县','130921','河北省沧州市沧县'),(195,'2016-03-18 11:29:01','2016-03-18 11:29:01','青县','130922','河北省沧州市青县'),(196,'2016-03-18 11:29:01','2016-03-18 11:29:01','东光县','130923','河北省沧州市东光县'),(197,'2016-03-18 11:29:01','2016-03-18 11:29:01','海兴县','130924','河北省沧州市海兴县'),(198,'2016-03-18 11:29:01','2016-03-18 11:29:01','盐山县','130925','河北省沧州市盐山县'),(199,'2016-03-18 11:29:01','2016-03-18 11:29:01','肃宁县','130926','河北省沧州市肃宁县'),(200,'2016-03-18 11:29:01','2016-03-18 11:29:01','南皮县','130927','河北省沧州市南皮县'),(201,'2016-03-18 11:29:01','2016-03-18 11:29:01','吴桥县','130928','河北省沧州市吴桥县'),(202,'2016-03-18 11:29:01','2016-03-18 11:29:01','献县','130929','河北省沧州市献县'),(203,'2016-03-18 11:29:01','2016-03-18 11:29:01','孟村回族自治县','130930','河北省沧州市孟村回族自治县'),(204,'2016-03-18 11:29:01','2016-03-18 11:29:01','泊头市','130981','河北省沧州市泊头市'),(205,'2016-03-18 11:29:01','2016-03-18 11:29:01','任丘市','130982','河北省沧州市任丘市'),(206,'2016-03-18 11:29:01','2016-03-18 11:29:01','黄骅市','130983','河北省沧州市黄骅市'),(207,'2016-03-18 11:29:01','2016-03-18 11:29:01','河间市','130984','河北省沧州市河间市'),(208,'2016-03-18 11:29:02','2016-03-18 11:29:02','廊坊市','131000','河北省廊坊市'),(209,'2016-03-18 11:29:02','2016-03-18 11:29:02','市辖区','131001','河北省廊坊市市辖区'),(210,'2016-03-18 11:29:02','2016-03-18 11:29:02','安次区','131002','河北省廊坊市安次区'),(211,'2016-03-18 11:29:02','2016-03-18 11:29:02','广阳区','131003','河北省廊坊市广阳区'),(212,'2016-03-18 11:29:02','2016-03-18 11:29:02','固安县','131022','河北省廊坊市固安县'),(213,'2016-03-18 11:29:02','2016-03-18 11:29:02','永清县','131023','河北省廊坊市永清县'),(214,'2016-03-18 11:29:02','2016-03-18 11:29:02','香河县','131024','河北省廊坊市香河县'),(215,'2016-03-18 11:29:02','2016-03-18 11:29:02','大城县','131025','河北省廊坊市大城县'),(216,'2016-03-18 11:29:02','2016-03-18 11:29:02','文安县','131026','河北省廊坊市文安县'),(217,'2016-03-18 11:29:02','2016-03-18 11:29:02','大厂回族自治县','131028','河北省廊坊市大厂回族自治县'),(218,'2016-03-18 11:29:02','2016-03-18 11:29:02','霸州市','131081','河北省廊坊市霸州市'),(219,'2016-03-18 11:29:02','2016-03-18 11:29:02','三河市','131082','河北省廊坊市三河市'),(220,'2016-03-18 11:29:02','2016-03-18 11:29:02','衡水市','131100','河北省衡水市'),(221,'2016-03-18 11:29:02','2016-03-18 11:29:02','市辖区','131101','河北省衡水市市辖区'),(222,'2016-03-18 11:29:02','2016-03-18 11:29:02','桃城区','131102','河北省衡水市桃城区'),(223,'2016-03-18 11:29:02','2016-03-18 11:29:02','枣强县','131121','河北省衡水市枣强县'),(224,'2016-03-18 11:29:02','2016-03-18 11:29:02','武邑县','131122','河北省衡水市武邑县'),(225,'2016-03-18 11:29:02','2016-03-18 11:29:02','武强县','131123','河北省衡水市武强县'),(226,'2016-03-18 11:29:02','2016-03-18 11:29:02','饶阳县','131124','河北省衡水市饶阳县'),(227,'2016-03-18 11:29:02','2016-03-18 11:29:02','安平县','131125','河北省衡水市安平县'),(228,'2016-03-18 11:29:02','2016-03-18 11:29:02','故城县','131126','河北省衡水市故城县'),(229,'2016-03-18 11:29:03','2016-03-18 11:29:03','景县','131127','河北省衡水市景县'),(230,'2016-03-18 11:29:03','2016-03-18 11:29:03','阜城县','131128','河北省衡水市阜城县'),(231,'2016-03-18 11:29:03','2016-03-18 11:29:03','冀州市','131181','河北省衡水市冀州市'),(232,'2016-03-18 11:29:03','2016-03-18 11:29:03','深州市','131182','河北省衡水市深州市'),(233,'2016-03-18 11:29:03','2016-03-18 11:29:03','山西省','140000','山西省'),(234,'2016-03-18 11:29:03','2016-03-18 11:29:03','太原市','140100','山西省太原市'),(235,'2016-03-18 11:29:03','2016-03-18 11:29:03','市辖区','140101','山西省太原市市辖区'),(236,'2016-03-18 11:29:03','2016-03-18 11:29:03','小店区','140105','山西省太原市小店区'),(237,'2016-03-18 11:29:03','2016-03-18 11:29:03','迎泽区','140106','山西省太原市迎泽区'),(238,'2016-03-18 11:29:03','2016-03-18 11:29:03','杏花岭区','140107','山西省太原市杏花岭区'),(239,'2016-03-18 11:29:03','2016-03-18 11:29:03','尖草坪区','140108','山西省太原市尖草坪区'),(240,'2016-03-18 11:29:03','2016-03-18 11:29:03','万柏林区','140109','山西省太原市万柏林区'),(241,'2016-03-18 11:29:03','2016-03-18 11:29:03','晋源区','140110','山西省太原市晋源区'),(242,'2016-03-18 11:29:03','2016-03-18 11:29:03','清徐县','140121','山西省太原市清徐县'),(243,'2016-03-18 11:29:03','2016-03-18 11:29:03','阳曲县','140122','山西省太原市阳曲县'),(244,'2016-03-18 11:29:03','2016-03-18 11:29:03','娄烦县','140123','山西省太原市娄烦县'),(245,'2016-03-18 11:29:03','2016-03-18 11:29:03','古交市','140181','山西省太原市古交市'),(246,'2016-03-18 11:29:03','2016-03-18 11:29:03','大同市','140200','山西省大同市'),(247,'2016-03-18 11:29:03','2016-03-18 11:29:03','市辖区','140201','山西省大同市市辖区'),(248,'2016-03-18 11:29:04','2016-03-18 11:29:04','城区','140202','山西省大同市城区'),(249,'2016-03-18 11:29:04','2016-03-18 11:29:04','矿区','140203','山西省大同市矿区'),(250,'2016-03-18 11:29:04','2016-03-18 11:29:04','南郊区','140211','山西省大同市南郊区'),(251,'2016-03-18 11:29:04','2016-03-18 11:29:04','新荣区','140212','山西省大同市新荣区'),(252,'2016-03-18 11:29:04','2016-03-18 11:29:04','阳高县','140221','山西省大同市阳高县'),(253,'2016-03-18 11:29:04','2016-03-18 11:29:04','天镇县','140222','山西省大同市天镇县'),(254,'2016-03-18 11:29:04','2016-03-18 11:29:04','广灵县','140223','山西省大同市广灵县'),(255,'2016-03-18 11:29:04','2016-03-18 11:29:04','灵丘县','140224','山西省大同市灵丘县'),(256,'2016-03-18 11:29:04','2016-03-18 11:29:04','浑源县','140225','山西省大同市浑源县'),(257,'2016-03-18 11:29:04','2016-03-18 11:29:04','左云县','140226','山西省大同市左云县'),(258,'2016-03-18 11:29:04','2016-03-18 11:29:04','大同县','140227','山西省大同市大同县'),(259,'2016-03-18 11:29:04','2016-03-18 11:29:04','阳泉市','140300','山西省阳泉市'),(260,'2016-03-18 11:29:04','2016-03-18 11:29:04','市辖区','140301','山西省阳泉市市辖区'),(261,'2016-03-18 11:29:04','2016-03-18 11:29:04','城区','140302','山西省阳泉市城区'),(262,'2016-03-18 11:29:04','2016-03-18 11:29:04','矿区','140303','山西省阳泉市矿区'),(263,'2016-03-18 11:29:04','2016-03-18 11:29:04','郊区','140311','山西省阳泉市郊区'),(264,'2016-03-18 11:29:04','2016-03-18 11:29:04','平定县','140321','山西省阳泉市平定县'),(265,'2016-03-18 11:29:04','2016-03-18 11:29:04','盂县','140322','山西省阳泉市盂县'),(266,'2016-03-18 11:29:04','2016-03-18 11:29:04','长治市','140400','山西省长治市'),(267,'2016-03-18 11:29:04','2016-03-18 11:29:04','市辖区','140401','山西省长治市市辖区'),(268,'2016-03-18 11:29:05','2016-03-18 11:29:05','城区','140402','山西省长治市城区'),(269,'2016-03-18 11:29:05','2016-03-18 11:29:05','郊区','140411','山西省长治市郊区'),(270,'2016-03-18 11:29:05','2016-03-18 11:29:05','长治县','140421','山西省长治市长治县'),(271,'2016-03-18 11:29:05','2016-03-18 11:29:05','襄垣县','140423','山西省长治市襄垣县'),(272,'2016-03-18 11:29:05','2016-03-18 11:29:05','屯留县','140424','山西省长治市屯留县'),(273,'2016-03-18 11:29:05','2016-03-18 11:29:05','平顺县','140425','山西省长治市平顺县'),(274,'2016-03-18 11:29:05','2016-03-18 11:29:05','黎城县','140426','山西省长治市黎城县'),(275,'2016-03-18 11:29:05','2016-03-18 11:29:05','壶关县','140427','山西省长治市壶关县'),(276,'2016-03-18 11:29:05','2016-03-18 11:29:05','长子县','140428','山西省长治市长子县'),(277,'2016-03-18 11:29:05','2016-03-18 11:29:05','武乡县','140429','山西省长治市武乡县'),(278,'2016-03-18 11:29:05','2016-03-18 11:29:05','沁县','140430','山西省长治市沁县'),(279,'2016-03-18 11:29:05','2016-03-18 11:29:05','沁源县','140431','山西省长治市沁源县'),(280,'2016-03-18 11:29:05','2016-03-18 11:29:05','潞城市','140481','山西省长治市潞城市'),(281,'2016-03-18 11:29:05','2016-03-18 11:29:05','晋城市','140500','山西省晋城市'),(282,'2016-03-18 11:29:05','2016-03-18 11:29:05','市辖区','140501','山西省晋城市市辖区'),(283,'2016-03-18 11:29:05','2016-03-18 11:29:05','城区','140502','山西省晋城市城区'),(284,'2016-03-18 11:29:05','2016-03-18 11:29:05','沁水县','140521','山西省晋城市沁水县'),(285,'2016-03-18 11:29:05','2016-03-18 11:29:05','阳城县','140522','山西省晋城市阳城县'),(286,'2016-03-18 11:29:06','2016-03-18 11:29:06','陵川县','140524','山西省晋城市陵川县'),(287,'2016-03-18 11:29:06','2016-03-18 11:29:06','泽州县','140525','山西省晋城市泽州县'),(288,'2016-03-18 11:29:06','2016-03-18 11:29:06','高平市','140581','山西省晋城市高平市'),(289,'2016-03-18 11:29:06','2016-03-18 11:29:06','朔州市','140600','山西省朔州市'),(290,'2016-03-18 11:29:06','2016-03-18 11:29:06','市辖区','140601','山西省朔州市市辖区'),(291,'2016-03-18 11:29:06','2016-03-18 11:29:06','朔城区','140602','山西省朔州市朔城区'),(292,'2016-03-18 11:29:06','2016-03-18 11:29:06','平鲁区','140603','山西省朔州市平鲁区'),(293,'2016-03-18 11:29:06','2016-03-18 11:29:06','山阴县','140621','山西省朔州市山阴县'),(294,'2016-03-18 11:29:06','2016-03-18 11:29:06','应县','140622','山西省朔州市应县'),(295,'2016-03-18 11:29:06','2016-03-18 11:29:06','右玉县','140623','山西省朔州市右玉县'),(296,'2016-03-18 11:29:06','2016-03-18 11:29:06','怀仁县','140624','山西省朔州市怀仁县'),(297,'2016-03-18 11:29:06','2016-03-18 11:29:06','晋中市','140700','山西省晋中市'),(298,'2016-03-18 11:29:06','2016-03-18 11:29:06','市辖区','140701','山西省晋中市市辖区'),(299,'2016-03-18 11:29:06','2016-03-18 11:29:06','榆次区','140702','山西省晋中市榆次区'),(300,'2016-03-18 11:29:06','2016-03-18 11:29:06','榆社县','140721','山西省晋中市榆社县'),(301,'2016-03-18 11:29:06','2016-03-18 11:29:06','左权县','140722','山西省晋中市左权县'),(302,'2016-03-18 11:29:06','2016-03-18 11:29:06','和顺县','140723','山西省晋中市和顺县'),(303,'2016-03-18 11:29:06','2016-03-18 11:29:06','昔阳县','140724','山西省晋中市昔阳县'),(304,'2016-03-18 11:29:06','2016-03-18 11:29:06','寿阳县','140725','山西省晋中市寿阳县'),(305,'2016-03-18 11:29:06','2016-03-18 11:29:06','太谷县','140726','山西省晋中市太谷县'),(306,'2016-03-18 11:29:07','2016-03-18 11:29:07','祁县','140727','山西省晋中市祁县'),(307,'2016-03-18 11:29:07','2016-03-18 11:29:07','平遥县','140728','山西省晋中市平遥县'),(308,'2016-03-18 11:29:07','2016-03-18 11:29:07','灵石县','140729','山西省晋中市灵石县'),(309,'2016-03-18 11:29:07','2016-03-18 11:29:07','介休市','140781','山西省晋中市介休市'),(310,'2016-03-18 11:29:07','2016-03-18 11:29:07','运城市','140800','山西省运城市'),(311,'2016-03-18 11:29:07','2016-03-18 11:29:07','市辖区','140801','山西省运城市市辖区'),(312,'2016-03-18 11:29:07','2016-03-18 11:29:07','盐湖区','140802','山西省运城市盐湖区'),(313,'2016-03-18 11:29:07','2016-03-18 11:29:07','临猗县','140821','山西省运城市临猗县'),(314,'2016-03-18 11:29:07','2016-03-18 11:29:07','万荣县','140822','山西省运城市万荣县'),(315,'2016-03-18 11:29:07','2016-03-18 11:29:07','闻喜县','140823','山西省运城市闻喜县'),(316,'2016-03-18 11:29:07','2016-03-18 11:29:07','稷山县','140824','山西省运城市稷山县'),(317,'2016-03-18 11:29:07','2016-03-18 11:29:07','新绛县','140825','山西省运城市新绛县'),(318,'2016-03-18 11:29:07','2016-03-18 11:29:07','绛县','140826','山西省运城市绛县'),(319,'2016-03-18 11:29:07','2016-03-18 11:29:07','垣曲县','140827','山西省运城市垣曲县'),(320,'2016-03-18 11:29:07','2016-03-18 11:29:07','夏县','140828','山西省运城市夏县'),(321,'2016-03-18 11:29:07','2016-03-18 11:29:07','平陆县','140829','山西省运城市平陆县'),(322,'2016-03-18 11:29:07','2016-03-18 11:29:07','芮城县','140830','山西省运城市芮城县'),(323,'2016-03-18 11:29:07','2016-03-18 11:29:07','永济市','140881','山西省运城市永济市'),(324,'2016-03-18 11:29:07','2016-03-18 11:29:07','河津市','140882','山西省运城市河津市'),(325,'2016-03-18 11:29:07','2016-03-18 11:29:07','忻州市','140900','山西省忻州市'),(326,'2016-03-18 11:29:07','2016-03-18 11:29:07','市辖区','140901','山西省忻州市市辖区'),(327,'2016-03-18 11:29:08','2016-03-18 11:29:08','忻府区','140902','山西省忻州市忻府区'),(328,'2016-03-18 11:29:08','2016-03-18 11:29:08','定襄县','140921','山西省忻州市定襄县'),(329,'2016-03-18 11:29:08','2016-03-18 11:29:08','五台县','140922','山西省忻州市五台县'),(330,'2016-03-18 11:29:08','2016-03-18 11:29:08','代县','140923','山西省忻州市代县'),(331,'2016-03-18 11:29:08','2016-03-18 11:29:08','繁峙县','140924','山西省忻州市繁峙县'),(332,'2016-03-18 11:29:08','2016-03-18 11:29:08','宁武县','140925','山西省忻州市宁武县'),(333,'2016-03-18 11:29:08','2016-03-18 11:29:08','静乐县','140926','山西省忻州市静乐县'),(334,'2016-03-18 11:29:08','2016-03-18 11:29:08','神池县','140927','山西省忻州市神池县'),(335,'2016-03-18 11:29:08','2016-03-18 11:29:08','五寨县','140928','山西省忻州市五寨县'),(336,'2016-03-18 11:29:08','2016-03-18 11:29:08','岢岚县','140929','山西省忻州市岢岚县'),(337,'2016-03-18 11:29:08','2016-03-18 11:29:08','河曲县','140930','山西省忻州市河曲县'),(338,'2016-03-18 11:29:08','2016-03-18 11:29:08','保德县','140931','山西省忻州市保德县'),(339,'2016-03-18 11:29:08','2016-03-18 11:29:08','偏关县','140932','山西省忻州市偏关县'),(340,'2016-03-18 11:29:08','2016-03-18 11:29:08','原平市','140981','山西省忻州市原平市'),(341,'2016-03-18 11:29:08','2016-03-18 11:29:08','临汾市','141000','山西省临汾市'),(342,'2016-03-18 11:29:08','2016-03-18 11:29:08','市辖区','141001','山西省临汾市市辖区'),(343,'2016-03-18 11:29:08','2016-03-18 11:29:08','尧都区','141002','山西省临汾市尧都区'),(344,'2016-03-18 11:29:08','2016-03-18 11:29:08','曲沃县','141021','山西省临汾市曲沃县'),(345,'2016-03-18 11:29:08','2016-03-18 11:29:08','翼城县','141022','山西省临汾市翼城县'),(346,'2016-03-18 11:29:09','2016-03-18 11:29:09','襄汾县','141023','山西省临汾市襄汾县'),(347,'2016-03-18 11:29:09','2016-03-18 11:29:09','洪洞县','141024','山西省临汾市洪洞县'),(348,'2016-03-18 11:29:09','2016-03-18 11:29:09','古县','141025','山西省临汾市古县'),(349,'2016-03-18 11:29:09','2016-03-18 11:29:09','安泽县','141026','山西省临汾市安泽县'),(350,'2016-03-18 11:29:09','2016-03-18 11:29:09','浮山县','141027','山西省临汾市浮山县'),(351,'2016-03-18 11:29:09','2016-03-18 11:29:09','吉县','141028','山西省临汾市吉县'),(352,'2016-03-18 11:29:09','2016-03-18 11:29:09','乡宁县','141029','山西省临汾市乡宁县'),(353,'2016-03-18 11:29:09','2016-03-18 11:29:09','大宁县','141030','山西省临汾市大宁县'),(354,'2016-03-18 11:29:09','2016-03-18 11:29:09','隰县','141031','山西省临汾市隰县'),(355,'2016-03-18 11:29:09','2016-03-18 11:29:09','永和县','141032','山西省临汾市永和县'),(356,'2016-03-18 11:29:09','2016-03-18 11:29:09','蒲县','141033','山西省临汾市蒲县'),(357,'2016-03-18 11:29:09','2016-03-18 11:29:09','汾西县','141034','山西省临汾市汾西县'),(358,'2016-03-18 11:29:09','2016-03-18 11:29:09','侯马市','141081','山西省临汾市侯马市'),(359,'2016-03-18 11:29:09','2016-03-18 11:29:09','霍州市','141082','山西省临汾市霍州市'),(360,'2016-03-18 11:29:09','2016-03-18 11:29:09','吕梁市','141100','山西省吕梁市'),(361,'2016-03-18 11:29:09','2016-03-18 11:29:09','市辖区','141101','山西省吕梁市市辖区'),(362,'2016-03-18 11:29:09','2016-03-18 11:29:09','离石区','141102','山西省吕梁市离石区'),(363,'2016-03-18 11:29:09','2016-03-18 11:29:09','文水县','141121','山西省吕梁市文水县'),(364,'2016-03-18 11:29:09','2016-03-18 11:29:09','交城县','141122','山西省吕梁市交城县'),(365,'2016-03-18 11:29:09','2016-03-18 11:29:09','兴县','141123','山西省吕梁市兴县'),(366,'2016-03-18 11:29:10','2016-03-18 11:29:10','临县','141124','山西省吕梁市临县'),(367,'2016-03-18 11:29:10','2016-03-18 11:29:10','柳林县','141125','山西省吕梁市柳林县'),(368,'2016-03-18 11:29:10','2016-03-18 11:29:10','石楼县','141126','山西省吕梁市石楼县'),(369,'2016-03-18 11:29:10','2016-03-18 11:29:10','岚县','141127','山西省吕梁市岚县'),(370,'2016-03-18 11:29:10','2016-03-18 11:29:10','方山县','141128','山西省吕梁市方山县'),(371,'2016-03-18 11:29:10','2016-03-18 11:29:10','中阳县','141129','山西省吕梁市中阳县'),(372,'2016-03-18 11:29:10','2016-03-18 11:29:10','交口县','141130','山西省吕梁市交口县'),(373,'2016-03-18 11:29:10','2016-03-18 11:29:10','孝义市','141181','山西省吕梁市孝义市'),(374,'2016-03-18 11:29:10','2016-03-18 11:29:10','汾阳市','141182','山西省吕梁市汾阳市'),(375,'2016-03-18 11:29:10','2016-03-18 11:29:10','内蒙古自治区','150000','内蒙古自治区'),(376,'2016-03-18 11:29:10','2016-03-18 11:29:10','呼和浩特市','150100','内蒙古自治区呼和浩特市'),(377,'2016-03-18 11:29:10','2016-03-18 11:29:10','市辖区','150101','内蒙古自治区呼和浩特市市辖区'),(378,'2016-03-18 11:29:10','2016-03-18 11:29:10','新城区','150102','内蒙古自治区呼和浩特市新城区'),(379,'2016-03-18 11:29:10','2016-03-18 11:29:10','回民区','150103','内蒙古自治区呼和浩特市回民区'),(380,'2016-03-18 11:29:10','2016-03-18 11:29:10','玉泉区','150104','内蒙古自治区呼和浩特市玉泉区'),(381,'2016-03-18 11:29:10','2016-03-18 11:29:10','赛罕区','150105','内蒙古自治区呼和浩特市赛罕区'),(382,'2016-03-18 11:29:10','2016-03-18 11:29:10','土默特左旗','150121','内蒙古自治区呼和浩特市土默特左旗'),(383,'2016-03-18 11:29:11','2016-03-18 11:29:11','托克托县','150122','内蒙古自治区呼和浩特市托克托县'),(384,'2016-03-18 11:29:11','2016-03-18 11:29:11','和林格尔县','150123','内蒙古自治区呼和浩特市和林格尔县'),(385,'2016-03-18 11:29:11','2016-03-18 11:29:11','清水河县','150124','内蒙古自治区呼和浩特市清水河县'),(386,'2016-03-18 11:29:11','2016-03-18 11:29:11','武川县','150125','内蒙古自治区呼和浩特市武川县'),(387,'2016-03-18 11:29:11','2016-03-18 11:29:11','包头市','150200','内蒙古自治区包头市'),(388,'2016-03-18 11:29:11','2016-03-18 11:29:11','市辖区','150201','内蒙古自治区包头市市辖区'),(389,'2016-03-18 11:29:11','2016-03-18 11:29:11','东河区','150202','内蒙古自治区包头市东河区'),(390,'2016-03-18 11:29:11','2016-03-18 11:29:11','昆都仑区','150203','内蒙古自治区包头市昆都仑区'),(391,'2016-03-18 11:29:11','2016-03-18 11:29:11','青山区','150204','内蒙古自治区包头市青山区'),(392,'2016-03-18 11:29:11','2016-03-18 11:29:11','石拐区','150205','内蒙古自治区包头市石拐区'),(393,'2016-03-18 11:29:11','2016-03-18 11:29:11','白云鄂博矿区','150206','内蒙古自治区包头市白云鄂博矿区'),(394,'2016-03-18 11:29:11','2016-03-18 11:29:11','九原区','150207','内蒙古自治区包头市九原区'),(395,'2016-03-18 11:29:11','2016-03-18 11:29:11','土默特右旗','150221','内蒙古自治区包头市土默特右旗'),(396,'2016-03-18 11:29:11','2016-03-18 11:29:11','固阳县','150222','内蒙古自治区包头市固阳县'),(397,'2016-03-18 11:29:11','2016-03-18 11:29:11','达尔罕茂明安联合旗','150223','内蒙古自治区包头市达尔罕茂明安联合旗'),(398,'2016-03-18 11:29:12','2016-03-18 11:29:12','乌海市','150300','内蒙古自治区乌海市'),(399,'2016-03-18 11:29:12','2016-03-18 11:29:12','市辖区','150301','内蒙古自治区乌海市市辖区'),(400,'2016-03-18 11:29:12','2016-03-18 11:29:12','海勃湾区','150302','内蒙古自治区乌海市海勃湾区'),(401,'2016-03-18 11:29:12','2016-03-18 11:29:12','海南区','150303','内蒙古自治区乌海市海南区'),(402,'2016-03-18 11:29:12','2016-03-18 11:29:12','乌达区','150304','内蒙古自治区乌海市乌达区'),(403,'2016-03-18 11:29:12','2016-03-18 11:29:12','赤峰市','150400','内蒙古自治区赤峰市'),(404,'2016-03-18 11:29:12','2016-03-18 11:29:12','市辖区','150401','内蒙古自治区赤峰市市辖区'),(405,'2016-03-18 11:29:12','2016-03-18 11:29:12','红山区','150402','内蒙古自治区赤峰市红山区'),(406,'2016-03-18 11:29:12','2016-03-18 11:29:12','元宝山区','150403','内蒙古自治区赤峰市元宝山区'),(407,'2016-03-18 11:29:12','2016-03-18 11:29:12','松山区','150404','内蒙古自治区赤峰市松山区'),(408,'2016-03-18 11:29:12','2016-03-18 11:29:12','阿鲁科尔沁旗','150421','内蒙古自治区赤峰市阿鲁科尔沁旗'),(409,'2016-03-18 11:29:12','2016-03-18 11:29:12','巴林左旗','150422','内蒙古自治区赤峰市巴林左旗'),(410,'2016-03-18 11:29:12','2016-03-18 11:29:12','巴林右旗','150423','内蒙古自治区赤峰市巴林右旗'),(411,'2016-03-18 11:29:12','2016-03-18 11:29:12','林西县','150424','内蒙古自治区赤峰市林西县'),(412,'2016-03-18 11:29:12','2016-03-18 11:29:12','克什克腾旗','150425','内蒙古自治区赤峰市克什克腾旗'),(413,'2016-03-18 11:29:13','2016-03-18 11:29:13','翁牛特旗','150426','内蒙古自治区赤峰市翁牛特旗'),(414,'2016-03-18 11:29:13','2016-03-18 11:29:13','喀喇沁旗','150428','内蒙古自治区赤峰市喀喇沁旗'),(415,'2016-03-18 11:29:13','2016-03-18 11:29:13','宁城县','150429','内蒙古自治区赤峰市宁城县'),(416,'2016-03-18 11:29:13','2016-03-18 11:29:13','敖汉旗','150430','内蒙古自治区赤峰市敖汉旗'),(417,'2016-03-18 11:29:13','2016-03-18 11:29:13','通辽市','150500','内蒙古自治区通辽市'),(418,'2016-03-18 11:29:13','2016-03-18 11:29:13','市辖区','150501','内蒙古自治区通辽市市辖区'),(419,'2016-03-18 11:29:13','2016-03-18 11:29:13','科尔沁区','150502','内蒙古自治区通辽市科尔沁区'),(420,'2016-03-18 11:29:13','2016-03-18 11:29:13','科尔沁左翼中旗','150521','内蒙古自治区通辽市科尔沁左翼中旗'),(421,'2016-03-18 11:29:13','2016-03-18 11:29:13','科尔沁左翼后旗','150522','内蒙古自治区通辽市科尔沁左翼后旗'),(422,'2016-03-18 11:29:13','2016-03-18 11:29:13','开鲁县','150523','内蒙古自治区通辽市开鲁县'),(423,'2016-03-18 11:29:13','2016-03-18 11:29:13','库伦旗','150524','内蒙古自治区通辽市库伦旗'),(424,'2016-03-18 11:29:13','2016-03-18 11:29:13','奈曼旗','150525','内蒙古自治区通辽市奈曼旗'),(425,'2016-03-18 11:29:14','2016-03-18 11:29:14','扎鲁特旗','150526','内蒙古自治区通辽市扎鲁特旗'),(426,'2016-03-18 11:29:14','2016-03-18 11:29:14','霍林郭勒市','150581','内蒙古自治区通辽市霍林郭勒市'),(427,'2016-03-18 11:29:14','2016-03-18 11:29:14','鄂尔多斯市','150600','内蒙古自治区鄂尔多斯市'),(428,'2016-03-18 11:29:14','2016-03-18 11:29:14','市辖区','150601','内蒙古自治区鄂尔多斯市市辖区'),(429,'2016-03-18 11:29:14','2016-03-18 11:29:14','东胜区','150602','内蒙古自治区鄂尔多斯市东胜区'),(430,'2016-03-18 11:29:14','2016-03-18 11:29:14','达拉特旗','150621','内蒙古自治区鄂尔多斯市达拉特旗'),(431,'2016-03-18 11:29:14','2016-03-18 11:29:14','准格尔旗','150622','内蒙古自治区鄂尔多斯市准格尔旗'),(432,'2016-03-18 11:29:14','2016-03-18 11:29:14','鄂托克前旗','150623','内蒙古自治区鄂尔多斯市鄂托克前旗'),(433,'2016-03-18 11:29:14','2016-03-18 11:29:14','鄂托克旗','150624','内蒙古自治区鄂尔多斯市鄂托克旗'),(434,'2016-03-18 11:29:15','2016-03-18 11:29:15','杭锦旗','150625','内蒙古自治区鄂尔多斯市杭锦旗'),(435,'2016-03-18 11:29:15','2016-03-18 11:29:15','乌审旗','150626','内蒙古自治区鄂尔多斯市乌审旗'),(436,'2016-03-18 11:29:15','2016-03-18 11:29:15','伊金霍洛旗','150627','内蒙古自治区鄂尔多斯市伊金霍洛旗'),(437,'2016-03-18 11:29:15','2016-03-18 11:29:15','呼伦贝尔市','150700','内蒙古自治区呼伦贝尔市'),(438,'2016-03-18 11:29:15','2016-03-18 11:29:15','市辖区','150701','内蒙古自治区呼伦贝尔市市辖区'),(439,'2016-03-18 11:29:15','2016-03-18 11:29:15','海拉尔区','150702','内蒙古自治区呼伦贝尔市海拉尔区'),(440,'2016-03-18 11:29:15','2016-03-18 11:29:15','扎赉诺尔区','150703','内蒙古自治区呼伦贝尔市扎赉诺尔区'),(441,'2016-03-18 11:29:15','2016-03-18 11:29:15','阿荣旗','150721','内蒙古自治区呼伦贝尔市阿荣旗'),(442,'2016-03-18 11:29:15','2016-03-18 11:29:15','莫力达瓦达斡尔族自治旗','150722','内蒙古自治区呼伦贝尔市莫力达瓦达斡尔族自治旗'),(443,'2016-03-18 11:29:15','2016-03-18 11:29:15','鄂伦春自治旗','150723','内蒙古自治区呼伦贝尔市鄂伦春自治旗'),(444,'2016-03-18 11:29:15','2016-03-18 11:29:15','鄂温克族自治旗','150724','内蒙古自治区呼伦贝尔市鄂温克族自治旗'),(445,'2016-03-18 11:29:15','2016-03-18 11:29:15','陈巴尔虎旗','150725','内蒙古自治区呼伦贝尔市陈巴尔虎旗'),(446,'2016-03-18 11:29:15','2016-03-18 11:29:15','新巴尔虎左旗','150726','内蒙古自治区呼伦贝尔市新巴尔虎左旗'),(447,'2016-03-18 11:29:15','2016-03-18 11:29:15','新巴尔虎右旗','150727','内蒙古自治区呼伦贝尔市新巴尔虎右旗'),(448,'2016-03-18 11:29:15','2016-03-18 11:29:15','满洲里市','150781','内蒙古自治区呼伦贝尔市满洲里市'),(449,'2016-03-18 11:29:15','2016-03-18 11:29:15','牙克石市','150782','内蒙古自治区呼伦贝尔市牙克石市'),(450,'2016-03-18 11:29:15','2016-03-18 11:29:15','扎兰屯市','150783','内蒙古自治区呼伦贝尔市扎兰屯市'),(451,'2016-03-18 11:29:15','2016-03-18 11:29:15','额尔古纳市','150784','内蒙古自治区呼伦贝尔市额尔古纳市'),(452,'2016-03-18 11:29:16','2016-03-18 11:29:16','根河市','150785','内蒙古自治区呼伦贝尔市根河市'),(453,'2016-03-18 11:29:16','2016-03-18 11:29:16','巴彦淖尔市','150800','内蒙古自治区巴彦淖尔市'),(454,'2016-03-18 11:29:16','2016-03-18 11:29:16','市辖区','150801','内蒙古自治区巴彦淖尔市市辖区'),(455,'2016-03-18 11:29:16','2016-03-18 11:29:16','临河区','150802','内蒙古自治区巴彦淖尔市临河区'),(456,'2016-03-18 11:29:16','2016-03-18 11:29:16','五原县','150821','内蒙古自治区巴彦淖尔市五原县'),(457,'2016-03-18 11:29:16','2016-03-18 11:29:16','磴口县','150822','内蒙古自治区巴彦淖尔市磴口县'),(458,'2016-03-18 11:29:16','2016-03-18 11:29:16','乌拉特前旗','150823','内蒙古自治区巴彦淖尔市乌拉特前旗'),(459,'2016-03-18 11:29:16','2016-03-18 11:29:16','乌拉特中旗','150824','内蒙古自治区巴彦淖尔市乌拉特中旗'),(460,'2016-03-18 11:29:16','2016-03-18 11:29:16','乌拉特后旗','150825','内蒙古自治区巴彦淖尔市乌拉特后旗'),(461,'2016-03-18 11:29:16','2016-03-18 11:29:16','杭锦后旗','150826','内蒙古自治区巴彦淖尔市杭锦后旗'),(462,'2016-03-18 11:29:16','2016-03-18 11:29:16','乌兰察布市','150900','内蒙古自治区乌兰察布市'),(463,'2016-03-18 11:29:16','2016-03-18 11:29:16','市辖区','150901','内蒙古自治区乌兰察布市市辖区'),(464,'2016-03-18 11:29:16','2016-03-18 11:29:16','集宁区','150902','内蒙古自治区乌兰察布市集宁区'),(465,'2016-03-18 11:29:16','2016-03-18 11:29:16','卓资县','150921','内蒙古自治区乌兰察布市卓资县'),(466,'2016-03-18 11:29:16','2016-03-18 11:29:16','化德县','150922','内蒙古自治区乌兰察布市化德县'),(467,'2016-03-18 11:29:16','2016-03-18 11:29:16','商都县','150923','内蒙古自治区乌兰察布市商都县'),(468,'2016-03-18 11:29:16','2016-03-18 11:29:16','兴和县','150924','内蒙古自治区乌兰察布市兴和县'),(469,'2016-03-18 11:29:16','2016-03-18 11:29:16','凉城县','150925','内蒙古自治区乌兰察布市凉城县'),(470,'2016-03-18 11:29:17','2016-03-18 11:29:17','察哈尔右翼前旗','150926','内蒙古自治区乌兰察布市察哈尔右翼前旗'),(471,'2016-03-18 11:29:17','2016-03-18 11:29:17','察哈尔右翼中旗','150927','内蒙古自治区乌兰察布市察哈尔右翼中旗'),(472,'2016-03-18 11:29:17','2016-03-18 11:29:17','察哈尔右翼后旗','150928','内蒙古自治区乌兰察布市察哈尔右翼后旗'),(473,'2016-03-18 11:29:17','2016-03-18 11:29:17','四子王旗','150929','内蒙古自治区乌兰察布市四子王旗'),(474,'2016-03-18 11:29:17','2016-03-18 11:29:17','丰镇市','150981','内蒙古自治区乌兰察布市丰镇市'),(475,'2016-03-18 11:29:17','2016-03-18 11:29:17','兴安盟','152200','内蒙古自治区兴安盟'),(476,'2016-03-18 11:29:17','2016-03-18 11:29:17','乌兰浩特市','152201','内蒙古自治区兴安盟乌兰浩特市'),(477,'2016-03-18 11:29:17','2016-03-18 11:29:17','阿尔山市','152202','内蒙古自治区兴安盟阿尔山市'),(478,'2016-03-18 11:29:17','2016-03-18 11:29:17','科尔沁右翼前旗','152221','内蒙古自治区兴安盟科尔沁右翼前旗'),(479,'2016-03-18 11:29:17','2016-03-18 11:29:17','科尔沁右翼中旗','152222','内蒙古自治区兴安盟科尔沁右翼中旗'),(480,'2016-03-18 11:29:17','2016-03-18 11:29:17','扎赉特旗','152223','内蒙古自治区兴安盟扎赉特旗'),(481,'2016-03-18 11:29:17','2016-03-18 11:29:17','突泉县','152224','内蒙古自治区兴安盟突泉县'),(482,'2016-03-18 11:29:17','2016-03-18 11:29:17','锡林郭勒盟','152500','内蒙古自治区锡林郭勒盟'),(483,'2016-03-18 11:29:17','2016-03-18 11:29:17','二连浩特市','152501','内蒙古自治区锡林郭勒盟二连浩特市'),(484,'2016-03-18 11:29:18','2016-03-18 11:29:18','锡林浩特市','152502','内蒙古自治区锡林郭勒盟锡林浩特市'),(485,'2016-03-18 11:29:18','2016-03-18 11:29:18','阿巴嘎旗','152522','内蒙古自治区锡林郭勒盟阿巴嘎旗'),(486,'2016-03-18 11:29:18','2016-03-18 11:29:18','苏尼特左旗','152523','内蒙古自治区锡林郭勒盟苏尼特左旗'),(487,'2016-03-18 11:29:18','2016-03-18 11:29:18','苏尼特右旗','152524','内蒙古自治区锡林郭勒盟苏尼特右旗'),(488,'2016-03-18 11:29:18','2016-03-18 11:29:18','东乌珠穆沁旗','152525','内蒙古自治区锡林郭勒盟东乌珠穆沁旗'),(489,'2016-03-18 11:29:18','2016-03-18 11:29:18','西乌珠穆沁旗','152526','内蒙古自治区锡林郭勒盟西乌珠穆沁旗'),(490,'2016-03-18 11:29:18','2016-03-18 11:29:18','太仆寺旗','152527','内蒙古自治区锡林郭勒盟太仆寺旗'),(491,'2016-03-18 11:29:18','2016-03-18 11:29:18','镶黄旗','152528','内蒙古自治区锡林郭勒盟镶黄旗'),(492,'2016-03-18 11:29:18','2016-03-18 11:29:18','正镶白旗','152529','内蒙古自治区锡林郭勒盟正镶白旗'),(493,'2016-03-18 11:29:18','2016-03-18 11:29:18','正蓝旗','152530','内蒙古自治区锡林郭勒盟正蓝旗'),(494,'2016-03-18 11:29:18','2016-03-18 11:29:18','多伦县','152531','内蒙古自治区锡林郭勒盟多伦县'),(495,'2016-03-18 11:29:18','2016-03-18 11:29:18','阿拉善盟','152900','内蒙古自治区阿拉善盟'),(496,'2016-03-18 11:29:18','2016-03-18 11:29:18','阿拉善左旗','152921','内蒙古自治区阿拉善盟阿拉善左旗'),(497,'2016-03-18 11:29:18','2016-03-18 11:29:18','阿拉善右旗','152922','内蒙古自治区阿拉善盟阿拉善右旗'),(498,'2016-03-18 11:29:18','2016-03-18 11:29:18','额济纳旗','152923','内蒙古自治区阿拉善盟额济纳旗'),(499,'2016-03-18 11:29:18','2016-03-18 11:29:18','辽宁省','210000','辽宁省'),(500,'2016-03-18 11:29:18','2016-03-18 11:29:18','沈阳市','210100','辽宁省沈阳市'),(501,'2016-03-18 11:29:18','2016-03-18 11:29:18','市辖区','210101','辽宁省沈阳市市辖区'),(502,'2016-03-18 11:29:18','2016-03-18 11:29:18','和平区','210102','辽宁省沈阳市和平区'),(503,'2016-03-18 11:29:18','2016-03-18 11:29:18','沈河区','210103','辽宁省沈阳市沈河区'),(504,'2016-03-18 11:29:19','2016-03-18 11:29:19','大东区','210104','辽宁省沈阳市大东区'),(505,'2016-03-18 11:29:19','2016-03-18 11:29:19','皇姑区','210105','辽宁省沈阳市皇姑区'),(506,'2016-03-18 11:29:19','2016-03-18 11:29:19','铁西区','210106','辽宁省沈阳市铁西区'),(507,'2016-03-18 11:29:19','2016-03-18 11:29:19','苏家屯区','210111','辽宁省沈阳市苏家屯区'),(508,'2016-03-18 11:29:19','2016-03-18 11:29:19','浑南区','210112','辽宁省沈阳市浑南区'),(509,'2016-03-18 11:29:19','2016-03-18 11:29:19','沈北新区','210113','辽宁省沈阳市沈北新区'),(510,'2016-03-18 11:29:19','2016-03-18 11:29:19','于洪区','210114','辽宁省沈阳市于洪区'),(511,'2016-03-18 11:29:19','2016-03-18 11:29:19','辽中县','210122','辽宁省沈阳市辽中县'),(512,'2016-03-18 11:29:19','2016-03-18 11:29:19','康平县','210123','辽宁省沈阳市康平县'),(513,'2016-03-18 11:29:19','2016-03-18 11:29:19','法库县','210124','辽宁省沈阳市法库县'),(514,'2016-03-18 11:29:19','2016-03-18 11:29:19','新民市','210181','辽宁省沈阳市新民市'),(515,'2016-03-18 11:29:19','2016-03-18 11:29:19','大连市','210200','辽宁省大连市'),(516,'2016-03-18 11:29:19','2016-03-18 11:29:19','市辖区','210201','辽宁省大连市市辖区'),(517,'2016-03-18 11:29:19','2016-03-18 11:29:19','中山区','210202','辽宁省大连市中山区'),(518,'2016-03-18 11:29:19','2016-03-18 11:29:19','西岗区','210203','辽宁省大连市西岗区'),(519,'2016-03-18 11:29:19','2016-03-18 11:29:19','沙河口区','210204','辽宁省大连市沙河口区'),(520,'2016-03-18 11:29:19','2016-03-18 11:29:19','甘井子区','210211','辽宁省大连市甘井子区'),(521,'2016-03-18 11:29:19','2016-03-18 11:29:19','旅顺口区','210212','辽宁省大连市旅顺口区'),(522,'2016-03-18 11:29:19','2016-03-18 11:29:19','金州区','210213','辽宁省大连市金州区'),(523,'2016-03-18 11:29:19','2016-03-18 11:29:19','长海县','210224','辽宁省大连市长海县'),(524,'2016-03-18 11:29:20','2016-03-18 11:29:20','瓦房店市','210281','辽宁省大连市瓦房店市'),(525,'2016-03-18 11:29:20','2016-03-18 11:29:20','普兰店市','210282','辽宁省大连市普兰店市'),(526,'2016-03-18 11:29:20','2016-03-18 11:29:20','庄河市','210283','辽宁省大连市庄河市'),(527,'2016-03-18 11:29:20','2016-03-18 11:29:20','鞍山市','210300','辽宁省鞍山市'),(528,'2016-03-18 11:29:20','2016-03-18 11:29:20','市辖区','210301','辽宁省鞍山市市辖区'),(529,'2016-03-18 11:29:20','2016-03-18 11:29:20','铁东区','210302','辽宁省鞍山市铁东区'),(530,'2016-03-18 11:29:20','2016-03-18 11:29:20','铁西区','210303','辽宁省鞍山市铁西区'),(531,'2016-03-18 11:29:20','2016-03-18 11:29:20','立山区','210304','辽宁省鞍山市立山区'),(532,'2016-03-18 11:29:20','2016-03-18 11:29:20','千山区','210311','辽宁省鞍山市千山区'),(533,'2016-03-18 11:29:20','2016-03-18 11:29:20','台安县','210321','辽宁省鞍山市台安县'),(534,'2016-03-18 11:29:20','2016-03-18 11:29:20','岫岩满族自治县','210323','辽宁省鞍山市岫岩满族自治县'),(535,'2016-03-18 11:29:20','2016-03-18 11:29:20','海城市','210381','辽宁省鞍山市海城市'),(536,'2016-03-18 11:29:20','2016-03-18 11:29:20','抚顺市','210400','辽宁省抚顺市'),(537,'2016-03-18 11:29:20','2016-03-18 11:29:20','市辖区','210401','辽宁省抚顺市市辖区'),(538,'2016-03-18 11:29:20','2016-03-18 11:29:20','新抚区','210402','辽宁省抚顺市新抚区'),(539,'2016-03-18 11:29:21','2016-03-18 11:29:21','东洲区','210403','辽宁省抚顺市东洲区'),(540,'2016-03-18 11:29:21','2016-03-18 11:29:21','望花区','210404','辽宁省抚顺市望花区'),(541,'2016-03-18 11:29:21','2016-03-18 11:29:21','顺城区','210411','辽宁省抚顺市顺城区'),(542,'2016-03-18 11:29:21','2016-03-18 11:29:21','抚顺县','210421','辽宁省抚顺市抚顺县'),(543,'2016-03-18 11:29:21','2016-03-18 11:29:21','新宾满族自治县','210422','辽宁省抚顺市新宾满族自治县'),(544,'2016-03-18 11:29:22','2016-03-18 11:29:22','清原满族自治县','210423','辽宁省抚顺市清原满族自治县'),(545,'2016-03-18 11:29:22','2016-03-18 11:29:22','本溪市','210500','辽宁省本溪市'),(546,'2016-03-18 11:29:22','2016-03-18 11:29:22','市辖区','210501','辽宁省本溪市市辖区'),(547,'2016-03-18 11:29:22','2016-03-18 11:29:22','平山区','210502','辽宁省本溪市平山区'),(548,'2016-03-18 11:29:23','2016-03-18 11:29:23','溪湖区','210503','辽宁省本溪市溪湖区'),(549,'2016-03-18 11:29:23','2016-03-18 11:29:23','明山区','210504','辽宁省本溪市明山区'),(550,'2016-03-18 11:29:23','2016-03-18 11:29:23','南芬区','210505','辽宁省本溪市南芬区'),(551,'2016-03-18 11:29:23','2016-03-18 11:29:23','本溪满族自治县','210521','辽宁省本溪市本溪满族自治县'),(552,'2016-03-18 11:29:23','2016-03-18 11:29:23','桓仁满族自治县','210522','辽宁省本溪市桓仁满族自治县'),(553,'2016-03-18 11:29:23','2016-03-18 11:29:23','丹东市','210600','辽宁省丹东市'),(554,'2016-03-18 11:29:23','2016-03-18 11:29:23','市辖区','210601','辽宁省丹东市市辖区'),(555,'2016-03-18 11:29:23','2016-03-18 11:29:23','元宝区','210602','辽宁省丹东市元宝区'),(556,'2016-03-18 11:29:23','2016-03-18 11:29:23','振兴区','210603','辽宁省丹东市振兴区'),(557,'2016-03-18 11:29:23','2016-03-18 11:29:23','振安区','210604','辽宁省丹东市振安区'),(558,'2016-03-18 11:29:23','2016-03-18 11:29:23','宽甸满族自治县','210624','辽宁省丹东市宽甸满族自治县'),(559,'2016-03-18 11:29:23','2016-03-18 11:29:23','东港市','210681','辽宁省丹东市东港市'),(560,'2016-03-18 11:29:23','2016-03-18 11:29:23','凤城市','210682','辽宁省丹东市凤城市'),(561,'2016-03-18 11:29:24','2016-03-18 11:29:24','锦州市','210700','辽宁省锦州市'),(562,'2016-03-18 11:29:24','2016-03-18 11:29:24','市辖区','210701','辽宁省锦州市市辖区'),(563,'2016-03-18 11:29:24','2016-03-18 11:29:24','古塔区','210702','辽宁省锦州市古塔区'),(564,'2016-03-18 11:29:24','2016-03-18 11:29:24','凌河区','210703','辽宁省锦州市凌河区'),(565,'2016-03-18 11:29:24','2016-03-18 11:29:24','太和区','210711','辽宁省锦州市太和区'),(566,'2016-03-18 11:29:24','2016-03-18 11:29:24','黑山县','210726','辽宁省锦州市黑山县'),(567,'2016-03-18 11:29:24','2016-03-18 11:29:24','义县','210727','辽宁省锦州市义县'),(568,'2016-03-18 11:29:24','2016-03-18 11:29:24','凌海市','210781','辽宁省锦州市凌海市'),(569,'2016-03-18 11:29:24','2016-03-18 11:29:24','北镇市','210782','辽宁省锦州市北镇市'),(570,'2016-03-18 11:29:24','2016-03-18 11:29:24','营口市','210800','辽宁省营口市'),(571,'2016-03-18 11:29:24','2016-03-18 11:29:24','市辖区','210801','辽宁省营口市市辖区'),(572,'2016-03-18 11:29:24','2016-03-18 11:29:24','站前区','210802','辽宁省营口市站前区'),(573,'2016-03-18 11:29:24','2016-03-18 11:29:24','西市区','210803','辽宁省营口市西市区'),(574,'2016-03-18 11:29:24','2016-03-18 11:29:24','鲅鱼圈区','210804','辽宁省营口市鲅鱼圈区'),(575,'2016-03-18 11:29:24','2016-03-18 11:29:24','老边区','210811','辽宁省营口市老边区'),(576,'2016-03-18 11:29:24','2016-03-18 11:29:24','盖州市','210881','辽宁省营口市盖州市'),(577,'2016-03-18 11:29:24','2016-03-18 11:29:24','大石桥市','210882','辽宁省营口市大石桥市'),(578,'2016-03-18 11:29:25','2016-03-18 11:29:25','阜新市','210900','辽宁省阜新市'),(579,'2016-03-18 11:29:25','2016-03-18 11:29:25','市辖区','210901','辽宁省阜新市市辖区'),(580,'2016-03-18 11:29:25','2016-03-18 11:29:25','海州区','210902','辽宁省阜新市海州区'),(581,'2016-03-18 11:29:25','2016-03-18 11:29:25','新邱区','210903','辽宁省阜新市新邱区'),(582,'2016-03-18 11:29:25','2016-03-18 11:29:25','太平区','210904','辽宁省阜新市太平区'),(583,'2016-03-18 11:29:25','2016-03-18 11:29:25','清河门区','210905','辽宁省阜新市清河门区'),(584,'2016-03-18 11:29:25','2016-03-18 11:29:25','细河区','210911','辽宁省阜新市细河区'),(585,'2016-03-18 11:29:25','2016-03-18 11:29:25','阜新蒙古族自治县','210921','辽宁省阜新市阜新蒙古族自治县'),(586,'2016-03-18 11:29:25','2016-03-18 11:29:25','彰武县','210922','辽宁省阜新市彰武县'),(587,'2016-03-18 11:29:25','2016-03-18 11:29:25','辽阳市','211000','辽宁省辽阳市'),(588,'2016-03-18 11:29:25','2016-03-18 11:29:25','市辖区','211001','辽宁省辽阳市市辖区'),(589,'2016-03-18 11:29:25','2016-03-18 11:29:25','白塔区','211002','辽宁省辽阳市白塔区'),(590,'2016-03-18 11:29:25','2016-03-18 11:29:25','文圣区','211003','辽宁省辽阳市文圣区'),(591,'2016-03-18 11:29:25','2016-03-18 11:29:25','宏伟区','211004','辽宁省辽阳市宏伟区'),(592,'2016-03-18 11:29:25','2016-03-18 11:29:25','弓长岭区','211005','辽宁省辽阳市弓长岭区'),(593,'2016-03-18 11:29:25','2016-03-18 11:29:25','太子河区','211011','辽宁省辽阳市太子河区'),(594,'2016-03-18 11:29:25','2016-03-18 11:29:25','辽阳县','211021','辽宁省辽阳市辽阳县'),(595,'2016-03-18 11:29:25','2016-03-18 11:29:25','灯塔市','211081','辽宁省辽阳市灯塔市'),(596,'2016-03-18 11:29:26','2016-03-18 11:29:26','盘锦市','211100','辽宁省盘锦市'),(597,'2016-03-18 11:29:26','2016-03-18 11:29:26','市辖区','211101','辽宁省盘锦市市辖区'),(598,'2016-03-18 11:29:26','2016-03-18 11:29:26','双台子区','211102','辽宁省盘锦市双台子区'),(599,'2016-03-18 11:29:26','2016-03-18 11:29:26','兴隆台区','211103','辽宁省盘锦市兴隆台区'),(600,'2016-03-18 11:29:26','2016-03-18 11:29:26','大洼县','211121','辽宁省盘锦市大洼县'),(601,'2016-03-18 11:29:26','2016-03-18 11:29:26','盘山县','211122','辽宁省盘锦市盘山县'),(602,'2016-03-18 11:29:26','2016-03-18 11:29:26','铁岭市','211200','辽宁省铁岭市'),(603,'2016-03-18 11:29:26','2016-03-18 11:29:26','市辖区','211201','辽宁省铁岭市市辖区'),(604,'2016-03-18 11:29:26','2016-03-18 11:29:26','银州区','211202','辽宁省铁岭市银州区'),(605,'2016-03-18 11:29:26','2016-03-18 11:29:26','清河区','211204','辽宁省铁岭市清河区'),(606,'2016-03-18 11:29:26','2016-03-18 11:29:26','铁岭县','211221','辽宁省铁岭市铁岭县'),(607,'2016-03-18 11:29:26','2016-03-18 11:29:26','西丰县','211223','辽宁省铁岭市西丰县'),(608,'2016-03-18 11:29:26','2016-03-18 11:29:26','昌图县','211224','辽宁省铁岭市昌图县'),(609,'2016-03-18 11:29:26','2016-03-18 11:29:26','调兵山市','211281','辽宁省铁岭市调兵山市'),(610,'2016-03-18 11:29:26','2016-03-18 11:29:26','开原市','211282','辽宁省铁岭市开原市'),(611,'2016-03-18 11:29:26','2016-03-18 11:29:26','朝阳市','211300','辽宁省朝阳市'),(612,'2016-03-18 11:29:27','2016-03-18 11:29:27','市辖区','211301','辽宁省朝阳市市辖区'),(613,'2016-03-18 11:29:27','2016-03-18 11:29:27','双塔区','211302','辽宁省朝阳市双塔区'),(614,'2016-03-18 11:29:27','2016-03-18 11:29:27','龙城区','211303','辽宁省朝阳市龙城区'),(615,'2016-03-18 11:29:27','2016-03-18 11:29:27','朝阳县','211321','辽宁省朝阳市朝阳县'),(616,'2016-03-18 11:29:27','2016-03-18 11:29:27','建平县','211322','辽宁省朝阳市建平县'),(617,'2016-03-18 11:29:27','2016-03-18 11:29:27','喀喇沁左翼蒙古族自治县','211324','辽宁省朝阳市喀喇沁左翼蒙古族自治县'),(618,'2016-03-18 11:29:27','2016-03-18 11:29:27','北票市','211381','辽宁省朝阳市北票市'),(619,'2016-03-18 11:29:27','2016-03-18 11:29:27','凌源市','211382','辽宁省朝阳市凌源市'),(620,'2016-03-18 11:29:27','2016-03-18 11:29:27','葫芦岛市','211400','辽宁省葫芦岛市'),(621,'2016-03-18 11:29:27','2016-03-18 11:29:27','市辖区','211401','辽宁省葫芦岛市市辖区'),(622,'2016-03-18 11:29:27','2016-03-18 11:29:27','连山区','211402','辽宁省葫芦岛市连山区'),(623,'2016-03-18 11:29:27','2016-03-18 11:29:27','龙港区','211403','辽宁省葫芦岛市龙港区'),(624,'2016-03-18 11:29:27','2016-03-18 11:29:27','南票区','211404','辽宁省葫芦岛市南票区'),(625,'2016-03-18 11:29:27','2016-03-18 11:29:27','绥中县','211421','辽宁省葫芦岛市绥中县'),(626,'2016-03-18 11:29:28','2016-03-18 11:29:28','建昌县','211422','辽宁省葫芦岛市建昌县'),(627,'2016-03-18 11:29:28','2016-03-18 11:29:28','兴城市','211481','辽宁省葫芦岛市兴城市'),(628,'2016-03-18 11:29:28','2016-03-18 11:29:28','吉林省','220000','吉林省'),(629,'2016-03-18 11:29:28','2016-03-18 11:29:28','长春市','220100','吉林省长春市'),(630,'2016-03-18 11:29:28','2016-03-18 11:29:28','市辖区','220101','吉林省长春市市辖区'),(631,'2016-03-18 11:29:28','2016-03-18 11:29:28','南关区','220102','吉林省长春市南关区'),(632,'2016-03-18 11:29:28','2016-03-18 11:29:28','宽城区','220103','吉林省长春市宽城区'),(633,'2016-03-18 11:29:28','2016-03-18 11:29:28','朝阳区','220104','吉林省长春市朝阳区'),(634,'2016-03-18 11:29:28','2016-03-18 11:29:28','二道区','220105','吉林省长春市二道区'),(635,'2016-03-18 11:29:28','2016-03-18 11:29:28','绿园区','220106','吉林省长春市绿园区'),(636,'2016-03-18 11:29:28','2016-03-18 11:29:28','双阳区','220112','吉林省长春市双阳区'),(637,'2016-03-18 11:29:28','2016-03-18 11:29:28','九台区','220113','吉林省长春市九台区'),(638,'2016-03-18 11:29:28','2016-03-18 11:29:28','农安县','220122','吉林省长春市农安县'),(639,'2016-03-18 11:29:28','2016-03-18 11:29:28','榆树市','220182','吉林省长春市榆树市'),(640,'2016-03-18 11:29:29','2016-03-18 11:29:29','德惠市','220183','吉林省长春市德惠市'),(641,'2016-03-18 11:29:29','2016-03-18 11:29:29','吉林市','220200','吉林省吉林市'),(642,'2016-03-18 11:29:29','2016-03-18 11:29:29','市辖区','220201','吉林省吉林市市辖区'),(643,'2016-03-18 11:29:29','2016-03-18 11:29:29','昌邑区','220202','吉林省吉林市昌邑区'),(644,'2016-03-18 11:29:29','2016-03-18 11:29:29','龙潭区','220203','吉林省吉林市龙潭区'),(645,'2016-03-18 11:29:29','2016-03-18 11:29:29','船营区','220204','吉林省吉林市船营区'),(646,'2016-03-18 11:29:29','2016-03-18 11:29:29','丰满区','220211','吉林省吉林市丰满区'),(647,'2016-03-18 11:29:29','2016-03-18 11:29:29','永吉县','220221','吉林省吉林市永吉县'),(648,'2016-03-18 11:29:29','2016-03-18 11:29:29','蛟河市','220281','吉林省吉林市蛟河市'),(649,'2016-03-18 11:29:29','2016-03-18 11:29:29','桦甸市','220282','吉林省吉林市桦甸市'),(650,'2016-03-18 11:29:29','2016-03-18 11:29:29','舒兰市','220283','吉林省吉林市舒兰市'),(651,'2016-03-18 11:29:29','2016-03-18 11:29:29','磐石市','220284','吉林省吉林市磐石市'),(652,'2016-03-18 11:29:29','2016-03-18 11:29:29','四平市','220300','吉林省四平市'),(653,'2016-03-18 11:29:29','2016-03-18 11:29:29','市辖区','220301','吉林省四平市市辖区'),(654,'2016-03-18 11:29:30','2016-03-18 11:29:30','铁西区','220302','吉林省四平市铁西区'),(655,'2016-03-18 11:29:30','2016-03-18 11:29:30','铁东区','220303','吉林省四平市铁东区'),(656,'2016-03-18 11:29:30','2016-03-18 11:29:30','梨树县','220322','吉林省四平市梨树县'),(657,'2016-03-18 11:29:30','2016-03-18 11:29:30','伊通满族自治县','220323','吉林省四平市伊通满族自治县'),(658,'2016-03-18 11:29:30','2016-03-18 11:29:30','公主岭市','220381','吉林省四平市公主岭市'),(659,'2016-03-18 11:29:30','2016-03-18 11:29:30','双辽市','220382','吉林省四平市双辽市'),(660,'2016-03-18 11:29:30','2016-03-18 11:29:30','辽源市','220400','吉林省辽源市'),(661,'2016-03-18 11:29:30','2016-03-18 11:29:30','市辖区','220401','吉林省辽源市市辖区'),(662,'2016-03-18 11:29:30','2016-03-18 11:29:30','龙山区','220402','吉林省辽源市龙山区'),(663,'2016-03-18 11:29:30','2016-03-18 11:29:30','西安区','220403','吉林省辽源市西安区'),(664,'2016-03-18 11:29:30','2016-03-18 11:29:30','东丰县','220421','吉林省辽源市东丰县'),(665,'2016-03-18 11:29:30','2016-03-18 11:29:30','东辽县','220422','吉林省辽源市东辽县'),(666,'2016-03-18 11:29:30','2016-03-18 11:29:30','通化市','220500','吉林省通化市'),(667,'2016-03-18 11:29:31','2016-03-18 11:29:31','市辖区','220501','吉林省通化市市辖区'),(668,'2016-03-18 11:29:31','2016-03-18 11:29:31','东昌区','220502','吉林省通化市东昌区'),(669,'2016-03-18 11:29:31','2016-03-18 11:29:31','二道江区','220503','吉林省通化市二道江区'),(670,'2016-03-18 11:29:31','2016-03-18 11:29:31','通化县','220521','吉林省通化市通化县'),(671,'2016-03-18 11:29:31','2016-03-18 11:29:31','辉南县','220523','吉林省通化市辉南县'),(672,'2016-03-18 11:29:31','2016-03-18 11:29:31','柳河县','220524','吉林省通化市柳河县'),(673,'2016-03-18 11:29:31','2016-03-18 11:29:31','梅河口市','220581','吉林省通化市梅河口市'),(674,'2016-03-18 11:29:31','2016-03-18 11:29:31','集安市','220582','吉林省通化市集安市'),(675,'2016-03-18 11:29:31','2016-03-18 11:29:31','白山市','220600','吉林省白山市'),(676,'2016-03-18 11:29:31','2016-03-18 11:29:31','市辖区','220601','吉林省白山市市辖区'),(677,'2016-03-18 11:29:32','2016-03-18 11:29:32','浑江区','220602','吉林省白山市浑江区'),(678,'2016-03-18 11:29:32','2016-03-18 11:29:32','江源区','220605','吉林省白山市江源区'),(679,'2016-03-18 11:29:32','2016-03-18 11:29:32','抚松县','220621','吉林省白山市抚松县'),(680,'2016-03-18 11:29:32','2016-03-18 11:29:32','靖宇县','220622','吉林省白山市靖宇县'),(681,'2016-03-18 11:29:32','2016-03-18 11:29:32','长白朝鲜族自治县','220623','吉林省白山市长白朝鲜族自治县'),(682,'2016-03-18 11:29:32','2016-03-18 11:29:32','临江市','220681','吉林省白山市临江市'),(683,'2016-03-18 11:29:32','2016-03-18 11:29:32','松原市','220700','吉林省松原市'),(684,'2016-03-18 11:29:32','2016-03-18 11:29:32','市辖区','220701','吉林省松原市市辖区'),(685,'2016-03-18 11:29:32','2016-03-18 11:29:32','宁江区','220702','吉林省松原市宁江区'),(686,'2016-03-18 11:29:32','2016-03-18 11:29:32','前郭尔罗斯蒙古族自治县','220721','吉林省松原市前郭尔罗斯蒙古族自治县'),(687,'2016-03-18 11:29:32','2016-03-18 11:29:32','长岭县','220722','吉林省松原市长岭县'),(688,'2016-03-18 11:29:32','2016-03-18 11:29:32','乾安县','220723','吉林省松原市乾安县'),(689,'2016-03-18 11:29:32','2016-03-18 11:29:32','扶余市','220781','吉林省松原市扶余市'),(690,'2016-03-18 11:29:32','2016-03-18 11:29:32','白城市','220800','吉林省白城市'),(691,'2016-03-18 11:29:32','2016-03-18 11:29:32','市辖区','220801','吉林省白城市市辖区'),(692,'2016-03-18 11:29:32','2016-03-18 11:29:32','洮北区','220802','吉林省白城市洮北区'),(693,'2016-03-18 11:29:32','2016-03-18 11:29:32','镇赉县','220821','吉林省白城市镇赉县'),(694,'2016-03-18 11:29:33','2016-03-18 11:29:33','通榆县','220822','吉林省白城市通榆县'),(695,'2016-03-18 11:29:33','2016-03-18 11:29:33','洮南市','220881','吉林省白城市洮南市'),(696,'2016-03-18 11:29:33','2016-03-18 11:29:33','大安市','220882','吉林省白城市大安市'),(697,'2016-03-18 11:29:33','2016-03-18 11:29:33','延边朝鲜族自治州','222400','吉林省延边朝鲜族自治州'),(698,'2016-03-18 11:29:33','2016-03-18 11:29:33','延吉市','222401','吉林省延边朝鲜族自治州延吉市'),(699,'2016-03-18 11:29:33','2016-03-18 11:29:33','图们市','222402','吉林省延边朝鲜族自治州图们市'),(700,'2016-03-18 11:29:33','2016-03-18 11:29:33','敦化市','222403','吉林省延边朝鲜族自治州敦化市'),(701,'2016-03-18 11:29:33','2016-03-18 11:29:33','珲春市','222404','吉林省延边朝鲜族自治州珲春市'),(702,'2016-03-18 11:29:33','2016-03-18 11:29:33','龙井市','222405','吉林省延边朝鲜族自治州龙井市'),(703,'2016-03-18 11:29:33','2016-03-18 11:29:33','和龙市','222406','吉林省延边朝鲜族自治州和龙市'),(704,'2016-03-18 11:29:33','2016-03-18 11:29:33','汪清县','222424','吉林省延边朝鲜族自治州汪清县'),(705,'2016-03-18 11:29:33','2016-03-18 11:29:33','安图县','222426','吉林省延边朝鲜族自治州安图县'),(706,'2016-03-18 11:29:33','2016-03-18 11:29:33','黑龙江省','230000','黑龙江省'),(707,'2016-03-18 11:29:33','2016-03-18 11:29:33','哈尔滨市','230100','黑龙江省哈尔滨市'),(708,'2016-03-18 11:29:33','2016-03-18 11:29:33','市辖区','230101','黑龙江省哈尔滨市市辖区'),(709,'2016-03-18 11:29:33','2016-03-18 11:29:33','道里区','230102','黑龙江省哈尔滨市道里区'),(710,'2016-03-18 11:29:33','2016-03-18 11:29:33','南岗区','230103','黑龙江省哈尔滨市南岗区'),(711,'2016-03-18 11:29:33','2016-03-18 11:29:33','道外区','230104','黑龙江省哈尔滨市道外区'),(712,'2016-03-18 11:29:33','2016-03-18 11:29:33','平房区','230108','黑龙江省哈尔滨市平房区'),(713,'2016-03-18 11:29:33','2016-03-18 11:29:33','松北区','230109','黑龙江省哈尔滨市松北区'),(714,'2016-03-18 11:29:34','2016-03-18 11:29:34','香坊区','230110','黑龙江省哈尔滨市香坊区'),(715,'2016-03-18 11:29:34','2016-03-18 11:29:34','呼兰区','230111','黑龙江省哈尔滨市呼兰区'),(716,'2016-03-18 11:29:34','2016-03-18 11:29:34','阿城区','230112','黑龙江省哈尔滨市阿城区'),(717,'2016-03-18 11:29:34','2016-03-18 11:29:34','依兰县','230123','黑龙江省哈尔滨市依兰县'),(718,'2016-03-18 11:29:34','2016-03-18 11:29:34','方正县','230124','黑龙江省哈尔滨市方正县'),(719,'2016-03-18 11:29:34','2016-03-18 11:29:34','宾县','230125','黑龙江省哈尔滨市宾县'),(720,'2016-03-18 11:29:34','2016-03-18 11:29:34','巴彦县','230126','黑龙江省哈尔滨市巴彦县'),(721,'2016-03-18 11:29:34','2016-03-18 11:29:34','木兰县','230127','黑龙江省哈尔滨市木兰县'),(722,'2016-03-18 11:29:34','2016-03-18 11:29:34','通河县','230128','黑龙江省哈尔滨市通河县'),(723,'2016-03-18 11:29:34','2016-03-18 11:29:34','延寿县','230129','黑龙江省哈尔滨市延寿县'),(724,'2016-03-18 11:29:34','2016-03-18 11:29:34','双城市','230182','黑龙江省哈尔滨市双城市'),(725,'2016-03-18 11:29:34','2016-03-18 11:29:34','尚志市','230183','黑龙江省哈尔滨市尚志市'),(726,'2016-03-18 11:29:34','2016-03-18 11:29:34','五常市','230184','黑龙江省哈尔滨市五常市'),(727,'2016-03-18 11:29:34','2016-03-18 11:29:34','齐齐哈尔市','230200','黑龙江省齐齐哈尔市'),(728,'2016-03-18 11:29:34','2016-03-18 11:29:34','市辖区','230201','黑龙江省齐齐哈尔市市辖区'),(729,'2016-03-18 11:29:34','2016-03-18 11:29:34','龙沙区','230202','黑龙江省齐齐哈尔市龙沙区'),(730,'2016-03-18 11:29:34','2016-03-18 11:29:34','建华区','230203','黑龙江省齐齐哈尔市建华区'),(731,'2016-03-18 11:29:34','2016-03-18 11:29:34','铁锋区','230204','黑龙江省齐齐哈尔市铁锋区'),(732,'2016-03-18 11:29:34','2016-03-18 11:29:34','昂昂溪区','230205','黑龙江省齐齐哈尔市昂昂溪区'),(733,'2016-03-18 11:29:35','2016-03-18 11:29:35','富拉尔基区','230206','黑龙江省齐齐哈尔市富拉尔基区'),(734,'2016-03-18 11:29:35','2016-03-18 11:29:35','碾子山区','230207','黑龙江省齐齐哈尔市碾子山区'),(735,'2016-03-18 11:29:35','2016-03-18 11:29:35','梅里斯达斡尔族区','230208','黑龙江省齐齐哈尔市梅里斯达斡尔族区'),(736,'2016-03-18 11:29:35','2016-03-18 11:29:35','龙江县','230221','黑龙江省齐齐哈尔市龙江县'),(737,'2016-03-18 11:29:35','2016-03-18 11:29:35','依安县','230223','黑龙江省齐齐哈尔市依安县'),(738,'2016-03-18 11:29:35','2016-03-18 11:29:35','泰来县','230224','黑龙江省齐齐哈尔市泰来县'),(739,'2016-03-18 11:29:35','2016-03-18 11:29:35','甘南县','230225','黑龙江省齐齐哈尔市甘南县'),(740,'2016-03-18 11:29:35','2016-03-18 11:29:35','富裕县','230227','黑龙江省齐齐哈尔市富裕县'),(741,'2016-03-18 11:29:35','2016-03-18 11:29:35','克山县','230229','黑龙江省齐齐哈尔市克山县'),(742,'2016-03-18 11:29:35','2016-03-18 11:29:35','克东县','230230','黑龙江省齐齐哈尔市克东县'),(743,'2016-03-18 11:29:35','2016-03-18 11:29:35','拜泉县','230231','黑龙江省齐齐哈尔市拜泉县'),(744,'2016-03-18 11:29:35','2016-03-18 11:29:35','讷河市','230281','黑龙江省齐齐哈尔市讷河市'),(745,'2016-03-18 11:29:35','2016-03-18 11:29:35','鸡西市','230300','黑龙江省鸡西市'),(746,'2016-03-18 11:29:35','2016-03-18 11:29:35','市辖区','230301','黑龙江省鸡西市市辖区'),(747,'2016-03-18 11:29:36','2016-03-18 11:29:36','鸡冠区','230302','黑龙江省鸡西市鸡冠区'),(748,'2016-03-18 11:29:36','2016-03-18 11:29:36','恒山区','230303','黑龙江省鸡西市恒山区'),(749,'2016-03-18 11:29:36','2016-03-18 11:29:36','滴道区','230304','黑龙江省鸡西市滴道区'),(750,'2016-03-18 11:29:36','2016-03-18 11:29:36','梨树区','230305','黑龙江省鸡西市梨树区'),(751,'2016-03-18 11:29:36','2016-03-18 11:29:36','城子河区','230306','黑龙江省鸡西市城子河区'),(752,'2016-03-18 11:29:36','2016-03-18 11:29:36','麻山区','230307','黑龙江省鸡西市麻山区'),(753,'2016-03-18 11:29:36','2016-03-18 11:29:36','鸡东县','230321','黑龙江省鸡西市鸡东县'),(754,'2016-03-18 11:29:36','2016-03-18 11:29:36','虎林市','230381','黑龙江省鸡西市虎林市'),(755,'2016-03-18 11:29:36','2016-03-18 11:29:36','密山市','230382','黑龙江省鸡西市密山市'),(756,'2016-03-18 11:29:36','2016-03-18 11:29:36','鹤岗市','230400','黑龙江省鹤岗市'),(757,'2016-03-18 11:29:36','2016-03-18 11:29:36','市辖区','230401','黑龙江省鹤岗市市辖区'),(758,'2016-03-18 11:29:36','2016-03-18 11:29:36','向阳区','230402','黑龙江省鹤岗市向阳区'),(759,'2016-03-18 11:29:36','2016-03-18 11:29:36','工农区','230403','黑龙江省鹤岗市工农区'),(760,'2016-03-18 11:29:36','2016-03-18 11:29:36','南山区','230404','黑龙江省鹤岗市南山区'),(761,'2016-03-18 11:29:37','2016-03-18 11:29:37','兴安区','230405','黑龙江省鹤岗市兴安区'),(762,'2016-03-18 11:29:37','2016-03-18 11:29:37','东山区','230406','黑龙江省鹤岗市东山区'),(763,'2016-03-18 11:29:37','2016-03-18 11:29:37','兴山区','230407','黑龙江省鹤岗市兴山区'),(764,'2016-03-18 11:29:37','2016-03-18 11:29:37','萝北县','230421','黑龙江省鹤岗市萝北县'),(765,'2016-03-18 11:29:37','2016-03-18 11:29:37','绥滨县','230422','黑龙江省鹤岗市绥滨县'),(766,'2016-03-18 11:29:37','2016-03-18 11:29:37','双鸭山市','230500','黑龙江省双鸭山市'),(767,'2016-03-18 11:29:37','2016-03-18 11:29:37','市辖区','230501','黑龙江省双鸭山市市辖区'),(768,'2016-03-18 11:29:37','2016-03-18 11:29:37','尖山区','230502','黑龙江省双鸭山市尖山区'),(769,'2016-03-18 11:29:37','2016-03-18 11:29:37','岭东区','230503','黑龙江省双鸭山市岭东区'),(770,'2016-03-18 11:29:37','2016-03-18 11:29:37','四方台区','230505','黑龙江省双鸭山市四方台区'),(771,'2016-03-18 11:29:37','2016-03-18 11:29:37','宝山区','230506','黑龙江省双鸭山市宝山区'),(772,'2016-03-18 11:29:37','2016-03-18 11:29:37','集贤县','230521','黑龙江省双鸭山市集贤县'),(773,'2016-03-18 11:29:37','2016-03-18 11:29:37','友谊县','230522','黑龙江省双鸭山市友谊县'),(774,'2016-03-18 11:29:37','2016-03-18 11:29:37','宝清县','230523','黑龙江省双鸭山市宝清县'),(775,'2016-03-18 11:29:37','2016-03-18 11:29:37','饶河县','230524','黑龙江省双鸭山市饶河县'),(776,'2016-03-18 11:29:37','2016-03-18 11:29:37','大庆市','230600','黑龙江省大庆市'),(777,'2016-03-18 11:29:38','2016-03-18 11:29:38','市辖区','230601','黑龙江省大庆市市辖区'),(778,'2016-03-18 11:29:38','2016-03-18 11:29:38','萨尔图区','230602','黑龙江省大庆市萨尔图区'),(779,'2016-03-18 11:29:38','2016-03-18 11:29:38','龙凤区','230603','黑龙江省大庆市龙凤区'),(780,'2016-03-18 11:29:38','2016-03-18 11:29:38','让胡路区','230604','黑龙江省大庆市让胡路区'),(781,'2016-03-18 11:29:38','2016-03-18 11:29:38','红岗区','230605','黑龙江省大庆市红岗区'),(782,'2016-03-18 11:29:38','2016-03-18 11:29:38','大同区','230606','黑龙江省大庆市大同区'),(783,'2016-03-18 11:29:38','2016-03-18 11:29:38','肇州县','230621','黑龙江省大庆市肇州县'),(784,'2016-03-18 11:29:38','2016-03-18 11:29:38','肇源县','230622','黑龙江省大庆市肇源县'),(785,'2016-03-18 11:29:38','2016-03-18 11:29:38','林甸县','230623','黑龙江省大庆市林甸县'),(786,'2016-03-18 11:29:38','2016-03-18 11:29:38','杜尔伯特蒙古族自治县','230624','黑龙江省大庆市杜尔伯特蒙古族自治县'),(787,'2016-03-18 11:29:38','2016-03-18 11:29:38','伊春市','230700','黑龙江省伊春市'),(788,'2016-03-18 11:29:38','2016-03-18 11:29:38','市辖区','230701','黑龙江省伊春市市辖区'),(789,'2016-03-18 11:29:38','2016-03-18 11:29:38','伊春区','230702','黑龙江省伊春市伊春区'),(790,'2016-03-18 11:29:38','2016-03-18 11:29:38','南岔区','230703','黑龙江省伊春市南岔区'),(791,'2016-03-18 11:29:38','2016-03-18 11:29:38','友好区','230704','黑龙江省伊春市友好区'),(792,'2016-03-18 11:29:38','2016-03-18 11:29:38','西林区','230705','黑龙江省伊春市西林区'),(793,'2016-03-18 11:29:38','2016-03-18 11:29:38','翠峦区','230706','黑龙江省伊春市翠峦区'),(794,'2016-03-18 11:29:39','2016-03-18 11:29:39','新青区','230707','黑龙江省伊春市新青区'),(795,'2016-03-18 11:29:39','2016-03-18 11:29:39','美溪区','230708','黑龙江省伊春市美溪区'),(796,'2016-03-18 11:29:39','2016-03-18 11:29:39','金山屯区','230709','黑龙江省伊春市金山屯区'),(797,'2016-03-18 11:29:39','2016-03-18 11:29:39','五营区','230710','黑龙江省伊春市五营区'),(798,'2016-03-18 11:29:39','2016-03-18 11:29:39','乌马河区','230711','黑龙江省伊春市乌马河区'),(799,'2016-03-18 11:29:39','2016-03-18 11:29:39','汤旺河区','230712','黑龙江省伊春市汤旺河区'),(800,'2016-03-18 11:29:39','2016-03-18 11:29:39','带岭区','230713','黑龙江省伊春市带岭区'),(801,'2016-03-18 11:29:39','2016-03-18 11:29:39','乌伊岭区','230714','黑龙江省伊春市乌伊岭区'),(802,'2016-03-18 11:29:39','2016-03-18 11:29:39','红星区','230715','黑龙江省伊春市红星区'),(803,'2016-03-18 11:29:39','2016-03-18 11:29:39','上甘岭区','230716','黑龙江省伊春市上甘岭区'),(804,'2016-03-18 11:29:39','2016-03-18 11:29:39','嘉荫县','230722','黑龙江省伊春市嘉荫县'),(805,'2016-03-18 11:29:39','2016-03-18 11:29:39','铁力市','230781','黑龙江省伊春市铁力市'),(806,'2016-03-18 11:29:39','2016-03-18 11:29:39','佳木斯市','230800','黑龙江省佳木斯市'),(807,'2016-03-18 11:29:39','2016-03-18 11:29:39','市辖区','230801','黑龙江省佳木斯市市辖区'),(808,'2016-03-18 11:29:39','2016-03-18 11:29:39','向阳区','230803','黑龙江省佳木斯市向阳区'),(809,'2016-03-18 11:29:40','2016-03-18 11:29:40','前进区','230804','黑龙江省佳木斯市前进区'),(810,'2016-03-18 11:29:40','2016-03-18 11:29:40','东风区','230805','黑龙江省佳木斯市东风区'),(811,'2016-03-18 11:29:40','2016-03-18 11:29:40','郊区','230811','黑龙江省佳木斯市郊区'),(812,'2016-03-18 11:29:40','2016-03-18 11:29:40','桦南县','230822','黑龙江省佳木斯市桦南县'),(813,'2016-03-18 11:29:40','2016-03-18 11:29:40','桦川县','230826','黑龙江省佳木斯市桦川县'),(814,'2016-03-18 11:29:40','2016-03-18 11:29:40','汤原县','230828','黑龙江省佳木斯市汤原县'),(815,'2016-03-18 11:29:40','2016-03-18 11:29:40','抚远县','230833','黑龙江省佳木斯市抚远县'),(816,'2016-03-18 11:29:40','2016-03-18 11:29:40','同江市','230881','黑龙江省佳木斯市同江市'),(817,'2016-03-18 11:29:40','2016-03-18 11:29:40','富锦市','230882','黑龙江省佳木斯市富锦市'),(818,'2016-03-18 11:29:40','2016-03-18 11:29:40','七台河市','230900','黑龙江省七台河市'),(819,'2016-03-18 11:29:40','2016-03-18 11:29:40','市辖区','230901','黑龙江省七台河市市辖区'),(820,'2016-03-18 11:29:40','2016-03-18 11:29:40','新兴区','230902','黑龙江省七台河市新兴区'),(821,'2016-03-18 11:29:40','2016-03-18 11:29:40','桃山区','230903','黑龙江省七台河市桃山区'),(822,'2016-03-18 11:29:40','2016-03-18 11:29:40','茄子河区','230904','黑龙江省七台河市茄子河区'),(823,'2016-03-18 11:29:40','2016-03-18 11:29:40','勃利县','230921','黑龙江省七台河市勃利县'),(824,'2016-03-18 11:29:40','2016-03-18 11:29:40','牡丹江市','231000','黑龙江省牡丹江市'),(825,'2016-03-18 11:29:41','2016-03-18 11:29:41','市辖区','231001','黑龙江省牡丹江市市辖区'),(826,'2016-03-18 11:29:41','2016-03-18 11:29:41','东安区','231002','黑龙江省牡丹江市东安区'),(827,'2016-03-18 11:29:41','2016-03-18 11:29:41','阳明区','231003','黑龙江省牡丹江市阳明区'),(828,'2016-03-18 11:29:41','2016-03-18 11:29:41','爱民区','231004','黑龙江省牡丹江市爱民区'),(829,'2016-03-18 11:29:41','2016-03-18 11:29:41','西安区','231005','黑龙江省牡丹江市西安区'),(830,'2016-03-18 11:29:41','2016-03-18 11:29:41','东宁县','231024','黑龙江省牡丹江市东宁县'),(831,'2016-03-18 11:29:41','2016-03-18 11:29:41','林口县','231025','黑龙江省牡丹江市林口县'),(832,'2016-03-18 11:29:41','2016-03-18 11:29:41','绥芬河市','231081','黑龙江省牡丹江市绥芬河市'),(833,'2016-03-18 11:29:41','2016-03-18 11:29:41','海林市','231083','黑龙江省牡丹江市海林市'),(834,'2016-03-18 11:29:41','2016-03-18 11:29:41','宁安市','231084','黑龙江省牡丹江市宁安市'),(835,'2016-03-18 11:29:41','2016-03-18 11:29:41','穆棱市','231085','黑龙江省牡丹江市穆棱市'),(836,'2016-03-18 11:29:41','2016-03-18 11:29:41','黑河市','231100','黑龙江省黑河市'),(837,'2016-03-18 11:29:41','2016-03-18 11:29:41','市辖区','231101','黑龙江省黑河市市辖区'),(838,'2016-03-18 11:29:41','2016-03-18 11:29:41','爱辉区','231102','黑龙江省黑河市爱辉区'),(839,'2016-03-18 11:29:41','2016-03-18 11:29:41','嫩江县','231121','黑龙江省黑河市嫩江县'),(840,'2016-03-18 11:29:41','2016-03-18 11:29:41','逊克县','231123','黑龙江省黑河市逊克县'),(841,'2016-03-18 11:29:41','2016-03-18 11:29:41','孙吴县','231124','黑龙江省黑河市孙吴县'),(842,'2016-03-18 11:29:42','2016-03-18 11:29:42','北安市','231181','黑龙江省黑河市北安市'),(843,'2016-03-18 11:29:42','2016-03-18 11:29:42','五大连池市','231182','黑龙江省黑河市五大连池市'),(844,'2016-03-18 11:29:42','2016-03-18 11:29:42','绥化市','231200','黑龙江省绥化市'),(845,'2016-03-18 11:29:42','2016-03-18 11:29:42','市辖区','231201','黑龙江省绥化市市辖区'),(846,'2016-03-18 11:29:42','2016-03-18 11:29:42','北林区','231202','黑龙江省绥化市北林区'),(847,'2016-03-18 11:29:42','2016-03-18 11:29:42','望奎县','231221','黑龙江省绥化市望奎县'),(848,'2016-03-18 11:29:42','2016-03-18 11:29:42','兰西县','231222','黑龙江省绥化市兰西县'),(849,'2016-03-18 11:29:42','2016-03-18 11:29:42','青冈县','231223','黑龙江省绥化市青冈县'),(850,'2016-03-18 11:29:42','2016-03-18 11:29:42','庆安县','231224','黑龙江省绥化市庆安县'),(851,'2016-03-18 11:29:42','2016-03-18 11:29:42','明水县','231225','黑龙江省绥化市明水县'),(852,'2016-03-18 11:29:42','2016-03-18 11:29:42','绥棱县','231226','黑龙江省绥化市绥棱县'),(853,'2016-03-18 11:29:42','2016-03-18 11:29:42','安达市','231281','黑龙江省绥化市安达市'),(854,'2016-03-18 11:29:42','2016-03-18 11:29:42','肇东市','231282','黑龙江省绥化市肇东市'),(855,'2016-03-18 11:29:42','2016-03-18 11:29:42','海伦市','231283','黑龙江省绥化市海伦市'),(856,'2016-03-18 11:29:43','2016-03-18 11:29:43','大兴安岭地区','232700','黑龙江省大兴安岭地区'),(857,'2016-03-18 11:29:43','2016-03-18 11:29:43','呼玛县','232721','黑龙江省大兴安岭地区呼玛县'),(858,'2016-03-18 11:29:43','2016-03-18 11:29:43','塔河县','232722','黑龙江省大兴安岭地区塔河县'),(859,'2016-03-18 11:29:43','2016-03-18 11:29:43','漠河县','232723','黑龙江省大兴安岭地区漠河县'),(860,'2016-03-18 11:29:43','2016-03-18 11:29:43','上海市','310000','上海市'),(861,'2016-03-18 11:29:43','2016-03-18 11:29:43','市辖区','310100','上海市市辖区'),(862,'2016-03-18 11:29:43','2016-03-18 11:29:43','黄浦区','310101','上海市黄浦区'),(863,'2016-03-18 11:29:43','2016-03-18 11:29:43','徐汇区','310104','上海市徐汇区'),(864,'2016-03-18 11:29:43','2016-03-18 11:29:43','长宁区','310105','上海市长宁区'),(865,'2016-03-18 11:29:43','2016-03-18 11:29:43','静安区','310106','上海市静安区'),(866,'2016-03-18 11:29:43','2016-03-18 11:29:43','普陀区','310107','上海市普陀区'),(867,'2016-03-18 11:29:43','2016-03-18 11:29:43','闸北区','310108','上海市闸北区'),(868,'2016-03-18 11:29:43','2016-03-18 11:29:43','虹口区','310109','上海市虹口区'),(869,'2016-03-18 11:29:43','2016-03-18 11:29:43','杨浦区','310110','上海市杨浦区'),(870,'2016-03-18 11:29:43','2016-03-18 11:29:43','闵行区','310112','上海市闵行区'),(871,'2016-03-18 11:29:44','2016-03-18 11:29:44','宝山区','310113','上海市宝山区'),(872,'2016-03-18 11:29:44','2016-03-18 11:29:44','嘉定区','310114','上海市嘉定区'),(873,'2016-03-18 11:29:44','2016-03-18 11:29:44','浦东新区','310115','上海市浦东新区'),(874,'2016-03-18 11:29:44','2016-03-18 11:29:44','金山区','310116','上海市金山区'),(875,'2016-03-18 11:29:44','2016-03-18 11:29:44','松江区','310117','上海市松江区'),(876,'2016-03-18 11:29:44','2016-03-18 11:29:44','青浦区','310118','上海市青浦区'),(877,'2016-03-18 11:29:44','2016-03-18 11:29:44','奉贤区','310120','上海市奉贤区'),(878,'2016-03-18 11:29:44','2016-03-18 11:29:44','县','310200','上海市县'),(879,'2016-03-18 11:29:44','2016-03-18 11:29:44','崇明县','310230','上海市崇明县'),(880,'2016-03-18 11:29:44','2016-03-18 11:29:44','江苏省','320000','江苏省'),(881,'2016-03-18 11:29:44','2016-03-18 11:29:44','南京市','320100','江苏省南京市'),(882,'2016-03-18 11:29:44','2016-03-18 11:29:44','市辖区','320101','江苏省南京市市辖区'),(883,'2016-03-18 11:29:44','2016-03-18 11:29:44','玄武区','320102','江苏省南京市玄武区'),(884,'2016-03-18 11:29:44','2016-03-18 11:29:44','秦淮区','320104','江苏省南京市秦淮区'),(885,'2016-03-18 11:29:45','2016-03-18 11:29:45','建邺区','320105','江苏省南京市建邺区'),(886,'2016-03-18 11:29:45','2016-03-18 11:29:45','鼓楼区','320106','江苏省南京市鼓楼区'),(887,'2016-03-18 11:29:45','2016-03-18 11:29:45','浦口区','320111','江苏省南京市浦口区'),(888,'2016-03-18 11:29:45','2016-03-18 11:29:45','栖霞区','320113','江苏省南京市栖霞区'),(889,'2016-03-18 11:29:45','2016-03-18 11:29:45','雨花台区','320114','江苏省南京市雨花台区'),(890,'2016-03-18 11:29:45','2016-03-18 11:29:45','江宁区','320115','江苏省南京市江宁区'),(891,'2016-03-18 11:29:45','2016-03-18 11:29:45','六合区','320116','江苏省南京市六合区'),(892,'2016-03-18 11:29:45','2016-03-18 11:29:45','溧水区','320117','江苏省南京市溧水区'),(893,'2016-03-18 11:29:45','2016-03-18 11:29:45','高淳区','320118','江苏省南京市高淳区'),(894,'2016-03-18 11:29:45','2016-03-18 11:29:45','无锡市','320200','江苏省无锡市'),(895,'2016-03-18 11:29:45','2016-03-18 11:29:45','市辖区','320201','江苏省无锡市市辖区'),(896,'2016-03-18 11:29:45','2016-03-18 11:29:45','崇安区','320202','江苏省无锡市崇安区'),(897,'2016-03-18 11:29:45','2016-03-18 11:29:45','南长区','320203','江苏省无锡市南长区'),(898,'2016-03-18 11:29:45','2016-03-18 11:29:45','北塘区','320204','江苏省无锡市北塘区'),(899,'2016-03-18 11:29:45','2016-03-18 11:29:45','锡山区','320205','江苏省无锡市锡山区'),(900,'2016-03-18 11:29:45','2016-03-18 11:29:45','惠山区','320206','江苏省无锡市惠山区'),(901,'2016-03-18 11:29:46','2016-03-18 11:29:46','滨湖区','320211','江苏省无锡市滨湖区'),(902,'2016-03-18 11:29:46','2016-03-18 11:29:46','江阴市','320281','江苏省无锡市江阴市'),(903,'2016-03-18 11:29:46','2016-03-18 11:29:46','宜兴市','320282','江苏省无锡市宜兴市'),(904,'2016-03-18 11:29:46','2016-03-18 11:29:46','徐州市','320300','江苏省徐州市'),(905,'2016-03-18 11:29:46','2016-03-18 11:29:46','市辖区','320301','江苏省徐州市市辖区'),(906,'2016-03-18 11:29:46','2016-03-18 11:29:46','鼓楼区','320302','江苏省徐州市鼓楼区'),(907,'2016-03-18 11:29:46','2016-03-18 11:29:46','云龙区','320303','江苏省徐州市云龙区'),(908,'2016-03-18 11:29:46','2016-03-18 11:29:46','贾汪区','320305','江苏省徐州市贾汪区'),(909,'2016-03-18 11:29:46','2016-03-18 11:29:46','泉山区','320311','江苏省徐州市泉山区'),(910,'2016-03-18 11:29:46','2016-03-18 11:29:46','铜山区','320312','江苏省徐州市铜山区'),(911,'2016-03-18 11:29:46','2016-03-18 11:29:46','丰县','320321','江苏省徐州市丰县'),(912,'2016-03-18 11:29:46','2016-03-18 11:29:46','沛县','320322','江苏省徐州市沛县'),(913,'2016-03-18 11:29:46','2016-03-18 11:29:46','睢宁县','320324','江苏省徐州市睢宁县'),(914,'2016-03-18 11:29:46','2016-03-18 11:29:46','新沂市','320381','江苏省徐州市新沂市'),(915,'2016-03-18 11:29:47','2016-03-18 11:29:47','邳州市','320382','江苏省徐州市邳州市'),(916,'2016-03-18 11:29:47','2016-03-18 11:29:47','常州市','320400','江苏省常州市'),(917,'2016-03-18 11:29:47','2016-03-18 11:29:47','市辖区','320401','江苏省常州市市辖区'),(918,'2016-03-18 11:29:47','2016-03-18 11:29:47','天宁区','320402','江苏省常州市天宁区'),(919,'2016-03-18 11:29:47','2016-03-18 11:29:47','钟楼区','320404','江苏省常州市钟楼区'),(920,'2016-03-18 11:29:47','2016-03-18 11:29:47','戚墅堰区','320405','江苏省常州市戚墅堰区'),(921,'2016-03-18 11:29:47','2016-03-18 11:29:47','新北区','320411','江苏省常州市新北区'),(922,'2016-03-18 11:29:47','2016-03-18 11:29:47','武进区','320412','江苏省常州市武进区'),(923,'2016-03-18 11:29:47','2016-03-18 11:29:47','溧阳市','320481','江苏省常州市溧阳市'),(924,'2016-03-18 11:29:47','2016-03-18 11:29:47','金坛市','320482','江苏省常州市金坛市'),(925,'2016-03-18 11:29:47','2016-03-18 11:29:47','苏州市','320500','江苏省苏州市'),(926,'2016-03-18 11:29:47','2016-03-18 11:29:47','市辖区','320501','江苏省苏州市市辖区'),(927,'2016-03-18 11:29:47','2016-03-18 11:29:47','虎丘区','320505','江苏省苏州市虎丘区'),(928,'2016-03-18 11:29:47','2016-03-18 11:29:47','吴中区','320506','江苏省苏州市吴中区'),(929,'2016-03-18 11:29:47','2016-03-18 11:29:47','相城区','320507','江苏省苏州市相城区'),(930,'2016-03-18 11:29:47','2016-03-18 11:29:47','姑苏区','320508','江苏省苏州市姑苏区'),(931,'2016-03-18 11:29:47','2016-03-18 11:29:47','吴江区','320509','江苏省苏州市吴江区'),(932,'2016-03-18 11:29:47','2016-03-18 11:29:47','常熟市','320581','江苏省苏州市常熟市'),(933,'2016-03-18 11:29:48','2016-03-18 11:29:48','张家港市','320582','江苏省苏州市张家港市'),(934,'2016-03-18 11:29:48','2016-03-18 11:29:48','昆山市','320583','江苏省苏州市昆山市'),(935,'2016-03-18 11:29:48','2016-03-18 11:29:48','太仓市','320585','江苏省苏州市太仓市'),(936,'2016-03-18 11:29:48','2016-03-18 11:29:48','南通市','320600','江苏省南通市'),(937,'2016-03-18 11:29:48','2016-03-18 11:29:48','市辖区','320601','江苏省南通市市辖区'),(938,'2016-03-18 11:29:48','2016-03-18 11:29:48','崇川区','320602','江苏省南通市崇川区'),(939,'2016-03-18 11:29:48','2016-03-18 11:29:48','港闸区','320611','江苏省南通市港闸区'),(940,'2016-03-18 11:29:48','2016-03-18 11:29:48','通州区','320612','江苏省南通市通州区'),(941,'2016-03-18 11:29:48','2016-03-18 11:29:48','海安县','320621','江苏省南通市海安县'),(942,'2016-03-18 11:29:48','2016-03-18 11:29:48','如东县','320623','江苏省南通市如东县'),(943,'2016-03-18 11:29:48','2016-03-18 11:29:48','启东市','320681','江苏省南通市启东市'),(944,'2016-03-18 11:29:48','2016-03-18 11:29:48','如皋市','320682','江苏省南通市如皋市'),(945,'2016-03-18 11:29:48','2016-03-18 11:29:48','海门市','320684','江苏省南通市海门市'),(946,'2016-03-18 11:29:48','2016-03-18 11:29:48','连云港市','320700','江苏省连云港市'),(947,'2016-03-18 11:29:48','2016-03-18 11:29:48','市辖区','320701','江苏省连云港市市辖区'),(948,'2016-03-18 11:29:48','2016-03-18 11:29:48','连云区','320703','江苏省连云港市连云区'),(949,'2016-03-18 11:29:48','2016-03-18 11:29:48','海州区','320706','江苏省连云港市海州区'),(950,'2016-03-18 11:29:48','2016-03-18 11:29:48','赣榆区','320707','江苏省连云港市赣榆区'),(951,'2016-03-18 11:29:49','2016-03-18 11:29:49','东海县','320722','江苏省连云港市东海县'),(952,'2016-03-18 11:29:49','2016-03-18 11:29:49','灌云县','320723','江苏省连云港市灌云县'),(953,'2016-03-18 11:29:49','2016-03-18 11:29:49','灌南县','320724','江苏省连云港市灌南县'),(954,'2016-03-18 11:29:49','2016-03-18 11:29:49','淮安市','320800','江苏省淮安市'),(955,'2016-03-18 11:29:49','2016-03-18 11:29:49','市辖区','320801','江苏省淮安市市辖区'),(956,'2016-03-18 11:29:49','2016-03-18 11:29:49','清河区','320802','江苏省淮安市清河区'),(957,'2016-03-18 11:29:49','2016-03-18 11:29:49','淮安区','320803','江苏省淮安市淮安区'),(958,'2016-03-18 11:29:49','2016-03-18 11:29:49','淮阴区','320804','江苏省淮安市淮阴区'),(959,'2016-03-18 11:29:49','2016-03-18 11:29:49','清浦区','320811','江苏省淮安市清浦区'),(960,'2016-03-18 11:29:49','2016-03-18 11:29:49','涟水县','320826','江苏省淮安市涟水县'),(961,'2016-03-18 11:29:49','2016-03-18 11:29:49','洪泽县','320829','江苏省淮安市洪泽县'),(962,'2016-03-18 11:29:49','2016-03-18 11:29:49','盱眙县','320830','江苏省淮安市盱眙县'),(963,'2016-03-18 11:29:49','2016-03-18 11:29:49','金湖县','320831','江苏省淮安市金湖县'),(964,'2016-03-18 11:29:49','2016-03-18 11:29:49','盐城市','320900','江苏省盐城市'),(965,'2016-03-18 11:29:49','2016-03-18 11:29:49','市辖区','320901','江苏省盐城市市辖区'),(966,'2016-03-18 11:29:49','2016-03-18 11:29:49','亭湖区','320902','江苏省盐城市亭湖区'),(967,'2016-03-18 11:29:49','2016-03-18 11:29:49','盐都区','320903','江苏省盐城市盐都区'),(968,'2016-03-18 11:29:49','2016-03-18 11:29:49','响水县','320921','江苏省盐城市响水县'),(969,'2016-03-18 11:29:50','2016-03-18 11:29:50','滨海县','320922','江苏省盐城市滨海县'),(970,'2016-03-18 11:29:50','2016-03-18 11:29:50','阜宁县','320923','江苏省盐城市阜宁县'),(971,'2016-03-18 11:29:50','2016-03-18 11:29:50','射阳县','320924','江苏省盐城市射阳县'),(972,'2016-03-18 11:29:50','2016-03-18 11:29:50','建湖县','320925','江苏省盐城市建湖县'),(973,'2016-03-18 11:29:50','2016-03-18 11:29:50','东台市','320981','江苏省盐城市东台市'),(974,'2016-03-18 11:29:50','2016-03-18 11:29:50','大丰市','320982','江苏省盐城市大丰市'),(975,'2016-03-18 11:29:50','2016-03-18 11:29:50','扬州市','321000','江苏省扬州市'),(976,'2016-03-18 11:29:50','2016-03-18 11:29:50','市辖区','321001','江苏省扬州市市辖区'),(977,'2016-03-18 11:29:50','2016-03-18 11:29:50','广陵区','321002','江苏省扬州市广陵区'),(978,'2016-03-18 11:29:50','2016-03-18 11:29:50','邗江区','321003','江苏省扬州市邗江区'),(979,'2016-03-18 11:29:50','2016-03-18 11:29:50','江都区','321012','江苏省扬州市江都区'),(980,'2016-03-18 11:29:50','2016-03-18 11:29:50','宝应县','321023','江苏省扬州市宝应县'),(981,'2016-03-18 11:29:50','2016-03-18 11:29:50','仪征市','321081','江苏省扬州市仪征市'),(982,'2016-03-18 11:29:50','2016-03-18 11:29:50','高邮市','321084','江苏省扬州市高邮市'),(983,'2016-03-18 11:29:50','2016-03-18 11:29:50','镇江市','321100','江苏省镇江市'),(984,'2016-03-18 11:29:50','2016-03-18 11:29:50','市辖区','321101','江苏省镇江市市辖区'),(985,'2016-03-18 11:29:50','2016-03-18 11:29:50','京口区','321102','江苏省镇江市京口区'),(986,'2016-03-18 11:29:50','2016-03-18 11:29:50','润州区','321111','江苏省镇江市润州区'),(987,'2016-03-18 11:29:50','2016-03-18 11:29:50','丹徒区','321112','江苏省镇江市丹徒区'),(988,'2016-03-18 11:29:51','2016-03-18 11:29:51','丹阳市','321181','江苏省镇江市丹阳市'),(989,'2016-03-18 11:29:51','2016-03-18 11:29:51','扬中市','321182','江苏省镇江市扬中市'),(990,'2016-03-18 11:29:51','2016-03-18 11:29:51','句容市','321183','江苏省镇江市句容市'),(991,'2016-03-18 11:29:51','2016-03-18 11:29:51','泰州市','321200','江苏省泰州市'),(992,'2016-03-18 11:29:51','2016-03-18 11:29:51','市辖区','321201','江苏省泰州市市辖区'),(993,'2016-03-18 11:29:51','2016-03-18 11:29:51','海陵区','321202','江苏省泰州市海陵区'),(994,'2016-03-18 11:29:51','2016-03-18 11:29:51','高港区','321203','江苏省泰州市高港区'),(995,'2016-03-18 11:29:51','2016-03-18 11:29:51','姜堰区','321204','江苏省泰州市姜堰区'),(996,'2016-03-18 11:29:51','2016-03-18 11:29:51','兴化市','321281','江苏省泰州市兴化市'),(997,'2016-03-18 11:29:51','2016-03-18 11:29:51','靖江市','321282','江苏省泰州市靖江市'),(998,'2016-03-18 11:29:51','2016-03-18 11:29:51','泰兴市','321283','江苏省泰州市泰兴市'),(999,'2016-03-18 11:29:51','2016-03-18 11:29:51','宿迁市','321300','江苏省宿迁市'),(1000,'2016-03-18 11:29:51','2016-03-18 11:29:51','市辖区','321301','江苏省宿迁市市辖区'),(1001,'2016-03-18 11:29:51','2016-03-18 11:29:51','宿城区','321302','江苏省宿迁市宿城区'),(1002,'2016-03-18 11:29:51','2016-03-18 11:29:51','宿豫区','321311','江苏省宿迁市宿豫区'),(1003,'2016-03-18 11:29:52','2016-03-18 11:29:52','沭阳县','321322','江苏省宿迁市沭阳县'),(1004,'2016-03-18 11:29:52','2016-03-18 11:29:52','泗阳县','321323','江苏省宿迁市泗阳县'),(1005,'2016-03-18 11:29:52','2016-03-18 11:29:52','泗洪县','321324','江苏省宿迁市泗洪县'),(1006,'2016-03-18 11:29:52','2016-03-18 11:29:52','浙江省','330000','浙江省'),(1007,'2016-03-18 11:29:52','2016-03-18 11:29:52','杭州市','330100','浙江省杭州市'),(1008,'2016-03-18 11:29:52','2016-03-18 11:29:52','市辖区','330101','浙江省杭州市市辖区'),(1009,'2016-03-18 11:29:52','2016-03-18 11:29:52','上城区','330102','浙江省杭州市上城区'),(1010,'2016-03-18 11:29:52','2016-03-18 11:29:52','下城区','330103','浙江省杭州市下城区'),(1011,'2016-03-18 11:29:52','2016-03-18 11:29:52','江干区','330104','浙江省杭州市江干区'),(1012,'2016-03-18 11:29:52','2016-03-18 11:29:52','拱墅区','330105','浙江省杭州市拱墅区'),(1013,'2016-03-18 11:29:52','2016-03-18 11:29:52','西湖区','330106','浙江省杭州市西湖区'),(1014,'2016-03-18 11:29:52','2016-03-18 11:29:52','滨江区','330108','浙江省杭州市滨江区'),(1015,'2016-03-18 11:29:52','2016-03-18 11:29:52','萧山区','330109','浙江省杭州市萧山区'),(1016,'2016-03-18 11:29:52','2016-03-18 11:29:52','余杭区','330110','浙江省杭州市余杭区'),(1017,'2016-03-18 11:29:53','2016-03-18 11:29:53','桐庐县','330122','浙江省杭州市桐庐县'),(1018,'2016-03-18 11:29:53','2016-03-18 11:29:53','淳安县','330127','浙江省杭州市淳安县'),(1019,'2016-03-18 11:29:53','2016-03-18 11:29:53','建德市','330182','浙江省杭州市建德市'),(1020,'2016-03-18 11:29:53','2016-03-18 11:29:53','富阳市','330183','浙江省���州市富阳市'),(1021,'2016-03-18 11:29:53','2016-03-18 11:29:53','临安市','330185','浙江省杭州市临安市'),(1022,'2016-03-18 11:29:53','2016-03-18 11:29:53','宁波市','330200','浙江省宁波市'),(1023,'2016-03-18 11:29:53','2016-03-18 11:29:53','市辖区','330201','浙江省宁波市市辖区'),(1024,'2016-03-18 11:29:53','2016-03-18 11:29:53','海曙区','330203','浙江省宁波市海曙区'),(1025,'2016-03-18 11:29:53','2016-03-18 11:29:53','江东区','330204','浙江省宁波市江东区'),(1026,'2016-03-18 11:29:53','2016-03-18 11:29:53','江北区','330205','浙江省宁波市江北区'),(1027,'2016-03-18 11:29:53','2016-03-18 11:29:53','北仑区','330206','浙江省宁波市北仑区'),(1028,'2016-03-18 11:29:53','2016-03-18 11:29:53','镇海区','330211','浙江省宁波市镇海区'),(1029,'2016-03-18 11:29:53','2016-03-18 11:29:53','鄞州区','330212','浙江省宁波市鄞州区'),(1030,'2016-03-18 11:29:53','2016-03-18 11:29:53','象山县','330225','浙江省宁波市象山县'),(1031,'2016-03-18 11:29:53','2016-03-18 11:29:53','宁海县','330226','浙江省宁波市宁海县'),(1032,'2016-03-18 11:29:53','2016-03-18 11:29:53','余姚市','330281','浙江省宁波市余姚市'),(1033,'2016-03-18 11:29:53','2016-03-18 11:29:53','慈溪市','330282','浙江省宁波市慈溪市'),(1034,'2016-03-18 11:29:54','2016-03-18 11:29:54','奉化市','330283','浙江省宁波市奉化市'),(1035,'2016-03-18 11:29:54','2016-03-18 11:29:54','温州市','330300','浙江省温州市'),(1036,'2016-03-18 11:29:54','2016-03-18 11:29:54','市辖区','330301','浙江省温州市市辖区'),(1037,'2016-03-18 11:29:54','2016-03-18 11:29:54','鹿城区','330302','浙江省温州市鹿城区'),(1038,'2016-03-18 11:29:54','2016-03-18 11:29:54','龙湾区','330303','浙江省温州市龙湾区'),(1039,'2016-03-18 11:29:54','2016-03-18 11:29:54','瓯海区','330304','浙江省温州市瓯海区'),(1040,'2016-03-18 11:29:54','2016-03-18 11:29:54','洞头县','330322','浙江省温州市洞头县'),(1041,'2016-03-18 11:29:54','2016-03-18 11:29:54','永嘉县','330324','浙江省温州市永嘉县'),(1042,'2016-03-18 11:29:54','2016-03-18 11:29:54','平阳县','330326','浙江省温州市平阳县'),(1043,'2016-03-18 11:29:54','2016-03-18 11:29:54','苍南县','330327','浙江省温州市苍南县'),(1044,'2016-03-18 11:29:54','2016-03-18 11:29:54','文成县','330328','浙江省温州市文成县'),(1045,'2016-03-18 11:29:54','2016-03-18 11:29:54','泰顺县','330329','浙江省温州市泰顺县'),(1046,'2016-03-18 11:29:54','2016-03-18 11:29:54','瑞安市','330381','浙江省温州市瑞安市'),(1047,'2016-03-18 11:29:54','2016-03-18 11:29:54','乐清市','330382','浙江省温州市乐清市'),(1048,'2016-03-18 11:29:54','2016-03-18 11:29:54','嘉兴市','330400','浙江省嘉兴市'),(1049,'2016-03-18 11:29:55','2016-03-18 11:29:55','市辖区','330401','浙江省嘉兴市市辖区'),(1050,'2016-03-18 11:29:55','2016-03-18 11:29:55','南湖区','330402','浙江省嘉兴市南湖区'),(1051,'2016-03-18 11:29:55','2016-03-18 11:29:55','秀洲区','330411','浙江省嘉兴市秀洲区'),(1052,'2016-03-18 11:29:55','2016-03-18 11:29:55','嘉善县','330421','浙江省嘉兴市嘉善县'),(1053,'2016-03-18 11:29:55','2016-03-18 11:29:55','海盐县','330424','浙江省嘉兴市海盐县'),(1054,'2016-03-18 11:29:55','2016-03-18 11:29:55','海宁市','330481','浙江省嘉兴市海宁市'),(1055,'2016-03-18 11:29:55','2016-03-18 11:29:55','平湖市','330482','浙江省嘉兴市平湖市'),(1056,'2016-03-18 11:29:55','2016-03-18 11:29:55','桐乡市','330483','浙江省嘉兴市桐乡市'),(1057,'2016-03-18 11:29:55','2016-03-18 11:29:55','湖州市','330500','浙江省湖州市'),(1058,'2016-03-18 11:29:55','2016-03-18 11:29:55','市辖区','330501','浙江省湖州市市辖区'),(1059,'2016-03-18 11:29:55','2016-03-18 11:29:55','吴兴区','330502','浙江省湖州市吴兴区'),(1060,'2016-03-18 11:29:55','2016-03-18 11:29:55','南浔区','330503','浙江省湖州市南浔区'),(1061,'2016-03-18 11:29:56','2016-03-18 11:29:56','德清县','330521','浙江省湖州市德清县'),(1062,'2016-03-18 11:29:56','2016-03-18 11:29:56','长兴县','330522','浙江省湖州市长兴县'),(1063,'2016-03-18 11:29:56','2016-03-18 11:29:56','安吉县','330523','浙江省湖州市安吉县'),(1064,'2016-03-18 11:29:56','2016-03-18 11:29:56','绍兴市','330600','浙江省绍兴市'),(1065,'2016-03-18 11:29:56','2016-03-18 11:29:56','市辖区','330601','浙江省绍兴市市辖区'),(1066,'2016-03-18 11:29:56','2016-03-18 11:29:56','越城区','330602','浙江省绍兴市越城区'),(1067,'2016-03-18 11:29:56','2016-03-18 11:29:56','柯桥区','330603','浙江省绍兴市柯桥区'),(1068,'2016-03-18 11:29:56','2016-03-18 11:29:56','上虞区','330604','浙江省绍兴市上虞区'),(1069,'2016-03-18 11:29:56','2016-03-18 11:29:56','新昌县','330624','浙江省绍兴市新昌县'),(1070,'2016-03-18 11:29:56','2016-03-18 11:29:56','诸暨市','330681','浙江省绍兴市诸暨市'),(1071,'2016-03-18 11:29:57','2016-03-18 11:29:57','嵊州市','330683','浙江省绍兴市嵊州市'),(1072,'2016-03-18 11:29:57','2016-03-18 11:29:57','金华市','330700','浙江省金华市'),(1073,'2016-03-18 11:29:57','2016-03-18 11:29:57','市辖区','330701','浙江省金华市市辖区'),(1074,'2016-03-18 11:29:57','2016-03-18 11:29:57','婺城区','330702','浙江省金华市婺城区'),(1075,'2016-03-18 11:29:57','2016-03-18 11:29:57','金东区','330703','浙江省金华市金东区'),(1076,'2016-03-18 11:29:57','2016-03-18 11:29:57','武义县','330723','浙江省金华市武义县'),(1077,'2016-03-18 11:29:57','2016-03-18 11:29:57','浦江县','330726','浙江省金华市浦江县'),(1078,'2016-03-18 11:29:57','2016-03-18 11:29:57','磐安县','330727','浙江省金华市磐安县'),(1079,'2016-03-18 11:29:57','2016-03-18 11:29:57','兰溪市','330781','浙江省金华市兰溪市'),(1080,'2016-03-18 11:29:57','2016-03-18 11:29:57','义乌市','330782','浙江省金华市义乌市'),(1081,'2016-03-18 11:29:57','2016-03-18 11:29:57','东阳市','330783','浙江省金华市东阳市'),(1082,'2016-03-18 11:29:58','2016-03-18 11:29:58','永康市','330784','浙江省金华市永康市'),(1083,'2016-03-18 11:29:58','2016-03-18 11:29:58','衢州市','330800','浙江省衢州市'),(1084,'2016-03-18 11:29:58','2016-03-18 11:29:58','市辖区','330801','浙江省衢州市市辖区'),(1085,'2016-03-18 11:29:58','2016-03-18 11:29:58','柯城区','330802','浙江省衢州市柯城区'),(1086,'2016-03-18 11:29:58','2016-03-18 11:29:58','衢江区','330803','浙江省衢州市衢江区'),(1087,'2016-03-18 11:29:58','2016-03-18 11:29:58','常山县','330822','浙江省衢州市常山县'),(1088,'2016-03-18 11:29:58','2016-03-18 11:29:58','开化县','330824','浙江省衢州市开化县'),(1089,'2016-03-18 11:29:58','2016-03-18 11:29:58','龙游县','330825','浙江省衢州市龙游县'),(1090,'2016-03-18 11:29:58','2016-03-18 11:29:58','江山市','330881','浙江省衢州市江山市'),(1091,'2016-03-18 11:29:58','2016-03-18 11:29:58','舟山市','330900','浙江省舟山市'),(1092,'2016-03-18 11:29:58','2016-03-18 11:29:58','市辖区','330901','浙江省舟山市市辖区'),(1093,'2016-03-18 11:29:58','2016-03-18 11:29:58','定海区','330902','浙江省舟山市定海区'),(1094,'2016-03-18 11:29:58','2016-03-18 11:29:58','普陀区','330903','浙江省舟山市普陀区'),(1095,'2016-03-18 11:29:59','2016-03-18 11:29:59','岱山县','330921','浙江省舟山市岱山县'),(1096,'2016-03-18 11:29:59','2016-03-18 11:29:59','嵊泗县','330922','浙江省舟山市嵊泗县'),(1097,'2016-03-18 11:29:59','2016-03-18 11:29:59','台州市','331000','浙江省台州市'),(1098,'2016-03-18 11:29:59','2016-03-18 11:29:59','市辖区','331001','浙江省台州市市辖区'),(1099,'2016-03-18 11:29:59','2016-03-18 11:29:59','椒江区','331002','浙江省台州市椒江区'),(1100,'2016-03-18 11:29:59','2016-03-18 11:29:59','黄岩区','331003','浙江省台州市黄岩区'),(1101,'2016-03-18 11:29:59','2016-03-18 11:29:59','路桥区','331004','浙江省台州市路桥区'),(1102,'2016-03-18 11:29:59','2016-03-18 11:29:59','玉环县','331021','浙江省台州市玉环县'),(1103,'2016-03-18 11:29:59','2016-03-18 11:29:59','三门县','331022','浙江省台州市三门县'),(1104,'2016-03-18 11:29:59','2016-03-18 11:29:59','天台县','331023','浙江省台州市天台县'),(1105,'2016-03-18 11:29:59','2016-03-18 11:29:59','仙居县','331024','浙江省台州市仙居县'),(1106,'2016-03-18 11:29:59','2016-03-18 11:29:59','温岭市','331081','浙江省台州市温岭市'),(1107,'2016-03-18 11:29:59','2016-03-18 11:29:59','临海市','331082','浙江省台州市临海市'),(1108,'2016-03-18 11:29:59','2016-03-18 11:29:59','丽水市','331100','浙江省丽水市'),(1109,'2016-03-18 11:29:59','2016-03-18 11:29:59','市辖区','331101','浙江省丽水市市辖区'),(1110,'2016-03-18 11:29:59','2016-03-18 11:29:59','莲都区','331102','浙江省丽水市莲都区'),(1111,'2016-03-18 11:30:00','2016-03-18 11:30:00','青田县','331121','浙江省丽水市青田县'),(1112,'2016-03-18 11:30:00','2016-03-18 11:30:00','缙云县','331122','浙江省丽水市缙云县'),(1113,'2016-03-18 11:30:00','2016-03-18 11:30:00','遂昌县','331123','浙江省丽水市遂昌县'),(1114,'2016-03-18 11:30:00','2016-03-18 11:30:00','松阳县','331124','浙江省丽水市松阳县'),(1115,'2016-03-18 11:30:00','2016-03-18 11:30:00','云和县','331125','浙江省丽水市云和县'),(1116,'2016-03-18 11:30:00','2016-03-18 11:30:00','庆元县','331126','浙江省丽水市庆元县'),(1117,'2016-03-18 11:30:00','2016-03-18 11:30:00','景宁畲族自治县','331127','浙江省丽水市景宁畲族自治县'),(1118,'2016-03-18 11:30:00','2016-03-18 11:30:00','龙泉市','331181','浙江省丽水市龙泉市'),(1119,'2016-03-18 11:30:00','2016-03-18 11:30:00','安徽省','340000','安徽省'),(1120,'2016-03-18 11:30:00','2016-03-18 11:30:00','合肥市','340100','安徽省合肥市'),(1121,'2016-03-18 11:30:00','2016-03-18 11:30:00','市辖区','340101','安徽省合肥市市辖区'),(1122,'2016-03-18 11:30:00','2016-03-18 11:30:00','瑶海区','340102','安徽省合肥市瑶海区'),(1123,'2016-03-18 11:30:00','2016-03-18 11:30:00','庐阳区','340103','安徽省合肥市庐阳区'),(1124,'2016-03-18 11:30:00','2016-03-18 11:30:00','蜀山区','340104','安徽省合肥市蜀山区'),(1125,'2016-03-18 11:30:00','2016-03-18 11:30:00','包河区','340111','安徽省合肥市包河区'),(1126,'2016-03-18 11:30:00','2016-03-18 11:30:00','长丰县','340121','安徽省合肥市长丰县'),(1127,'2016-03-18 11:30:00','2016-03-18 11:30:00','肥东县','340122','安徽省合肥市肥东县'),(1128,'2016-03-18 11:30:00','2016-03-18 11:30:00','肥西县','340123','安徽省合肥市肥西县'),(1129,'2016-03-18 11:30:00','2016-03-18 11:30:00','庐江县','340124','安徽省合肥市庐江县'),(1130,'2016-03-18 11:30:01','2016-03-18 11:30:01','巢湖市','340181','安徽省合肥市巢湖市'),(1131,'2016-03-18 11:30:01','2016-03-18 11:30:01','芜湖市','340200','安徽省芜湖市'),(1132,'2016-03-18 11:30:01','2016-03-18 11:30:01','市辖区','340201','安徽省芜湖市市辖区'),(1133,'2016-03-18 11:30:01','2016-03-18 11:30:01','镜湖区','340202','安徽省芜湖市镜湖区'),(1134,'2016-03-18 11:30:01','2016-03-18 11:30:01','弋江区','340203','安徽省芜湖市弋江区'),(1135,'2016-03-18 11:30:01','2016-03-18 11:30:01','鸠江区','340207','安徽省芜湖市鸠江区'),(1136,'2016-03-18 11:30:01','2016-03-18 11:30:01','三山区','340208','安徽省芜湖市三山区'),(1137,'2016-03-18 11:30:01','2016-03-18 11:30:01','芜湖县','340221','安徽省芜湖市芜湖县'),(1138,'2016-03-18 11:30:01','2016-03-18 11:30:01','繁昌县','340222','安徽省芜湖市繁昌县'),(1139,'2016-03-18 11:30:01','2016-03-18 11:30:01','南陵县','340223','安徽省芜湖市南陵县'),(1140,'2016-03-18 11:30:01','2016-03-18 11:30:01','无为县','340225','安徽省芜湖市无为县'),(1141,'2016-03-18 11:30:01','2016-03-18 11:30:01','蚌埠市','340300','安徽省蚌埠市'),(1142,'2016-03-18 11:30:01','2016-03-18 11:30:01','市辖区','340301','安徽省蚌埠市市辖区'),(1143,'2016-03-18 11:30:01','2016-03-18 11:30:01','龙子湖区','340302','安徽省蚌埠市龙子湖区'),(1144,'2016-03-18 11:30:01','2016-03-18 11:30:01','蚌山区','340303','安徽省蚌埠市蚌山区'),(1145,'2016-03-18 11:30:01','2016-03-18 11:30:01','禹会区','340304','安徽省蚌埠市禹会区'),(1146,'2016-03-18 11:30:01','2016-03-18 11:30:01','淮上区','340311','安徽省蚌埠市淮上区'),(1147,'2016-03-18 11:30:01','2016-03-18 11:30:01','怀远县','340321','安徽省蚌埠市怀远县'),(1148,'2016-03-18 11:30:01','2016-03-18 11:30:01','五河县','340322','安徽省蚌埠市五河县'),(1149,'2016-03-18 11:30:01','2016-03-18 11:30:01','固镇县','340323','安徽省蚌埠市固镇县'),(1150,'2016-03-18 11:30:02','2016-03-18 11:30:02','淮南市','340400','安徽省淮南市'),(1151,'2016-03-18 11:30:02','2016-03-18 11:30:02','市辖区','340401','安徽省淮南市市辖区'),(1152,'2016-03-18 11:30:02','2016-03-18 11:30:02','大通区','340402','安徽省淮南市大通区'),(1153,'2016-03-18 11:30:02','2016-03-18 11:30:02','田家庵区','340403','安徽省淮南市田家庵区'),(1154,'2016-03-18 11:30:02','2016-03-18 11:30:02','谢家集区','340404','安徽省淮南市谢家集区'),(1155,'2016-03-18 11:30:02','2016-03-18 11:30:02','八公山区','340405','安徽省淮南市八公山区'),(1156,'2016-03-18 11:30:02','2016-03-18 11:30:02','潘集区','340406','安徽省淮南市潘集区'),(1157,'2016-03-18 11:30:02','2016-03-18 11:30:02','凤台县','340421','安徽省淮南市凤台县'),(1158,'2016-03-18 11:30:02','2016-03-18 11:30:02','马鞍山市','340500','安徽省马鞍山市'),(1159,'2016-03-18 11:30:02','2016-03-18 11:30:02','市辖区','340501','安徽省马鞍山市市辖区'),(1160,'2016-03-18 11:30:02','2016-03-18 11:30:02','花山区','340503','安徽省马鞍山市花山区'),(1161,'2016-03-18 11:30:02','2016-03-18 11:30:02','雨山区','340504','安徽省马鞍山市雨山区'),(1162,'2016-03-18 11:30:02','2016-03-18 11:30:02','博望区','340506','安徽省马鞍山市博望区'),(1163,'2016-03-18 11:30:02','2016-03-18 11:30:02','当涂县','340521','安徽省马鞍山市当涂县'),(1164,'2016-03-18 11:30:02','2016-03-18 11:30:02','含山县','340522','安徽省马鞍山市含山县'),(1165,'2016-03-18 11:30:02','2016-03-18 11:30:02','和县','340523','安徽省马鞍山市和县'),(1166,'2016-03-18 11:30:02','2016-03-18 11:30:02','淮北市','340600','安徽省淮北市'),(1167,'2016-03-18 11:30:03','2016-03-18 11:30:03','市辖区','340601','安徽省淮北市市辖区'),(1168,'2016-03-18 11:30:03','2016-03-18 11:30:03','杜集区','340602','安徽省淮北市杜集区'),(1169,'2016-03-18 11:30:03','2016-03-18 11:30:03','相山区','340603','安徽省淮北市相山区'),(1170,'2016-03-18 11:30:03','2016-03-18 11:30:03','烈山区','340604','安徽省淮北市烈山区'),(1171,'2016-03-18 11:30:03','2016-03-18 11:30:03','濉溪县','340621','安徽省淮北市濉溪县'),(1172,'2016-03-18 11:30:03','2016-03-18 11:30:03','铜陵市','340700','安徽省铜陵市'),(1173,'2016-03-18 11:30:03','2016-03-18 11:30:03','市辖区','340701','安徽省铜陵市市辖区'),(1174,'2016-03-18 11:30:03','2016-03-18 11:30:03','铜官山区','340702','安徽省铜陵市铜官山区'),(1175,'2016-03-18 11:30:03','2016-03-18 11:30:03','狮子山区','340703','安徽省铜陵市狮子山区'),(1176,'2016-03-18 11:30:03','2016-03-18 11:30:03','郊区','340711','安徽省铜陵市郊区'),(1177,'2016-03-18 11:30:03','2016-03-18 11:30:03','铜陵县','340721','安徽省铜陵市铜陵县'),(1178,'2016-03-18 11:30:03','2016-03-18 11:30:03','安庆市','340800','安徽省安庆市'),(1179,'2016-03-18 11:30:03','2016-03-18 11:30:03','市辖区','340801','安徽省安庆市市辖区'),(1180,'2016-03-18 11:30:03','2016-03-18 11:30:03','迎江区','340802','安徽省安庆市迎江区'),(1181,'2016-03-18 11:30:04','2016-03-18 11:30:04','大观区','340803','安徽省安庆市大观区'),(1182,'2016-03-18 11:30:04','2016-03-18 11:30:04','宜秀区','340811','安徽省安庆市宜秀区'),(1183,'2016-03-18 11:30:04','2016-03-18 11:30:04','怀宁县','340822','安徽省安庆市怀宁县'),(1184,'2016-03-18 11:30:04','2016-03-18 11:30:04','枞阳县','340823','安徽省安庆市枞阳县'),(1185,'2016-03-18 11:30:04','2016-03-18 11:30:04','潜山县','340824','安徽省安庆市潜山县'),(1186,'2016-03-18 11:30:04','2016-03-18 11:30:04','太湖县','340825','安徽省安庆市太湖县'),(1187,'2016-03-18 11:30:04','2016-03-18 11:30:04','宿松县','340826','安徽省安庆市宿松县'),(1188,'2016-03-18 11:30:04','2016-03-18 11:30:04','望江县','340827','安徽省安庆市望江县'),(1189,'2016-03-18 11:30:04','2016-03-18 11:30:04','岳西县','340828','安徽省安庆市岳西县'),(1190,'2016-03-18 11:30:04','2016-03-18 11:30:04','桐城市','340881','安徽省安庆市桐城市'),(1191,'2016-03-18 11:30:04','2016-03-18 11:30:04','黄山市','341000','安徽省黄山市'),(1192,'2016-03-18 11:30:04','2016-03-18 11:30:04','市辖区','341001','安徽省黄山市市辖区'),(1193,'2016-03-18 11:30:04','2016-03-18 11:30:04','屯溪区','341002','安徽省黄山市屯溪区'),(1194,'2016-03-18 11:30:04','2016-03-18 11:30:04','黄山区','341003','安徽省黄山市黄山区'),(1195,'2016-03-18 11:30:04','2016-03-18 11:30:04','徽州区','341004','安徽省黄山市徽州区'),(1196,'2016-03-18 11:30:04','2016-03-18 11:30:04','歙县','341021','安徽省黄山市歙县'),(1197,'2016-03-18 11:30:05','2016-03-18 11:30:05','休宁县','341022','安徽省黄山市休宁县'),(1198,'2016-03-18 11:30:05','2016-03-18 11:30:05','黟县','341023','安徽省黄山市黟县'),(1199,'2016-03-18 11:30:05','2016-03-18 11:30:05','祁门县','341024','安徽省黄山市祁门县'),(1200,'2016-03-18 11:30:05','2016-03-18 11:30:05','滁州市','341100','安徽省滁州市'),(1201,'2016-03-18 11:30:05','2016-03-18 11:30:05','市辖区','341101','安徽省滁州市市辖区'),(1202,'2016-03-18 11:30:05','2016-03-18 11:30:05','琅琊区','341102','安徽省滁州市琅琊区'),(1203,'2016-03-18 11:30:05','2016-03-18 11:30:05','南谯区','341103','安徽省滁州市南谯区'),(1204,'2016-03-18 11:30:05','2016-03-18 11:30:05','来安县','341122','安徽省滁州市来安县'),(1205,'2016-03-18 11:30:05','2016-03-18 11:30:05','全椒县','341124','安徽省滁州市全椒县'),(1206,'2016-03-18 11:30:05','2016-03-18 11:30:05','定远县','341125','安徽省滁州市定远县'),(1207,'2016-03-18 11:30:05','2016-03-18 11:30:05','凤阳县','341126','安徽省滁州市凤阳县'),(1208,'2016-03-18 11:30:05','2016-03-18 11:30:05','天长市','341181','安徽省滁州市天长市'),(1209,'2016-03-18 11:30:05','2016-03-18 11:30:05','明光市','341182','安徽省滁州市明光市'),(1210,'2016-03-18 11:30:05','2016-03-18 11:30:05','阜阳市','341200','安徽省阜阳市'),(1211,'2016-03-18 11:30:06','2016-03-18 11:30:06','市辖区','341201','安徽省阜阳市市辖区'),(1212,'2016-03-18 11:30:06','2016-03-18 11:30:06','颍州区','341202','安徽省阜阳市颍州区'),(1213,'2016-03-18 11:30:06','2016-03-18 11:30:06','颍东区','341203','安徽省阜阳市颍东区'),(1214,'2016-03-18 11:30:06','2016-03-18 11:30:06','颍泉区','341204','安徽省阜阳市颍泉区'),(1215,'2016-03-18 11:30:06','2016-03-18 11:30:06','临泉县','341221','安徽省阜阳市临泉县'),(1216,'2016-03-18 11:30:06','2016-03-18 11:30:06','太和县','341222','安徽省阜阳市太和县'),(1217,'2016-03-18 11:30:06','2016-03-18 11:30:06','阜南县','341225','安徽省阜阳市阜南县'),(1218,'2016-03-18 11:30:06','2016-03-18 11:30:06','颍上县','341226','安徽省阜阳市颍上县'),(1219,'2016-03-18 11:30:06','2016-03-18 11:30:06','界首市','341282','安徽省阜阳市界首市'),(1220,'2016-03-18 11:30:06','2016-03-18 11:30:06','宿州市','341300','安徽省宿州市'),(1221,'2016-03-18 11:30:06','2016-03-18 11:30:06','市辖区','341301','安徽省宿州市市辖区'),(1222,'2016-03-18 11:30:06','2016-03-18 11:30:06','埇桥区','341302','安徽省宿州市埇桥区'),(1223,'2016-03-18 11:30:07','2016-03-18 11:30:07','砀山县','341321','安徽省宿州市砀山县'),(1224,'2016-03-18 11:30:07','2016-03-18 11:30:07','萧县','341322','安徽省宿州市萧县'),(1225,'2016-03-18 11:30:07','2016-03-18 11:30:07','灵璧县','341323','安徽省宿州市灵璧县'),(1226,'2016-03-18 11:30:07','2016-03-18 11:30:07','泗县','341324','安徽省宿州市泗县'),(1227,'2016-03-18 11:30:07','2016-03-18 11:30:07','六安市','341500','安徽省六安市'),(1228,'2016-03-18 11:30:07','2016-03-18 11:30:07','市辖区','341501','安徽省六安市市辖区'),(1229,'2016-03-18 11:30:07','2016-03-18 11:30:07','金安区','341502','安徽省六安市金安区'),(1230,'2016-03-18 11:30:07','2016-03-18 11:30:07','裕安区','341503','安徽省六安市裕安区'),(1231,'2016-03-18 11:30:07','2016-03-18 11:30:07','寿县','341521','安徽省六安市寿县'),(1232,'2016-03-18 11:30:07','2016-03-18 11:30:07','霍邱县','341522','安徽省六安市霍邱县'),(1233,'2016-03-18 11:30:07','2016-03-18 11:30:07','舒城县','341523','安徽省六安市舒城县'),(1234,'2016-03-18 11:30:07','2016-03-18 11:30:07','金寨县','341524','安徽省六安市金寨县'),(1235,'2016-03-18 11:30:07','2016-03-18 11:30:07','霍山县','341525','安徽省六安市霍山县'),(1236,'2016-03-18 11:30:07','2016-03-18 11:30:07','亳州市','341600','安徽省亳州市'),(1237,'2016-03-18 11:30:08','2016-03-18 11:30:08','市辖区','341601','安徽省亳州市市辖区'),(1238,'2016-03-18 11:30:08','2016-03-18 11:30:08','谯城区','341602','安徽省亳州市谯城区'),(1239,'2016-03-18 11:30:08','2016-03-18 11:30:08','涡阳县','341621','安徽省亳州市涡阳县'),(1240,'2016-03-18 11:30:08','2016-03-18 11:30:08','蒙城县','341622','安徽省亳州市蒙城县'),(1241,'2016-03-18 11:30:08','2016-03-18 11:30:08','利辛县','341623','安徽省亳州市利辛县'),(1242,'2016-03-18 11:30:08','2016-03-18 11:30:08','池州市','341700','安徽省池州市'),(1243,'2016-03-18 11:30:08','2016-03-18 11:30:08','市辖区','341701','安徽省池州市市辖区'),(1244,'2016-03-18 11:30:08','2016-03-18 11:30:08','贵池区','341702','安徽省池州市贵池区'),(1245,'2016-03-18 11:30:08','2016-03-18 11:30:08','东至县','341721','安徽省池州市东至县'),(1246,'2016-03-18 11:30:08','2016-03-18 11:30:08','石台县','341722','安徽省池州市石台县'),(1247,'2016-03-18 11:30:08','2016-03-18 11:30:08','青阳县','341723','安徽省池州市青阳县'),(1248,'2016-03-18 11:30:08','2016-03-18 11:30:08','宣城市','341800','安徽省宣城市'),(1249,'2016-03-18 11:30:09','2016-03-18 11:30:09','市辖区','341801','安徽省宣城市市辖区'),(1250,'2016-03-18 11:30:09','2016-03-18 11:30:09','宣州区','341802','安徽省宣城市宣州区'),(1251,'2016-03-18 11:30:09','2016-03-18 11:30:09','郎溪县','341821','安徽省宣城市郎溪县'),(1252,'2016-03-18 11:30:09','2016-03-18 11:30:09','广德县','341822','安徽省宣城市广德县'),(1253,'2016-03-18 11:30:09','2016-03-18 11:30:09','泾县','341823','安徽省宣城市泾县'),(1254,'2016-03-18 11:30:09','2016-03-18 11:30:09','绩溪县','341824','安徽省宣城市绩溪县'),(1255,'2016-03-18 11:30:09','2016-03-18 11:30:09','旌德县','341825','安徽省宣城市旌德县'),(1256,'2016-03-18 11:30:09','2016-03-18 11:30:09','宁国市','341881','安徽省宣城市宁国市'),(1257,'2016-03-18 11:30:09','2016-03-18 11:30:09','福建省','350000','福建省'),(1258,'2016-03-18 11:30:09','2016-03-18 11:30:09','福州市','350100','福建省福州市'),(1259,'2016-03-18 11:30:09','2016-03-18 11:30:09','市辖区','350101','福建省福州市市辖区'),(1260,'2016-03-18 11:30:09','2016-03-18 11:30:09','鼓楼区','350102','福建省福州市鼓楼区'),(1261,'2016-03-18 11:30:09','2016-03-18 11:30:09','台江区','350103','福建省福州市台江区'),(1262,'2016-03-18 11:30:10','2016-03-18 11:30:10','仓山区','350104','福建省福州市仓山区'),(1263,'2016-03-18 11:30:10','2016-03-18 11:30:10','马尾区','350105','福建省福州市马尾区'),(1264,'2016-03-18 11:30:10','2016-03-18 11:30:10','晋安区','350111','福建省福州市晋安区'),(1265,'2016-03-18 11:30:10','2016-03-18 11:30:10','闽侯县','350121','福建省福州市闽侯县'),(1266,'2016-03-18 11:30:10','2016-03-18 11:30:10','连江县','350122','福建省福州市连江县'),(1267,'2016-03-18 11:30:10','2016-03-18 11:30:10','罗源县','350123','福建省福州市罗源县'),(1268,'2016-03-18 11:30:10','2016-03-18 11:30:10','闽清县','350124','福建省福州市闽清县'),(1269,'2016-03-18 11:30:10','2016-03-18 11:30:10','永泰县','350125','福建省福州市永泰县'),(1270,'2016-03-18 11:30:10','2016-03-18 11:30:10','平潭县','350128','福建省福州市平潭县'),(1271,'2016-03-18 11:30:10','2016-03-18 11:30:10','福清市','350181','福建省福州市福清市'),(1272,'2016-03-18 11:30:10','2016-03-18 11:30:10','长乐市','350182','福建省福州市长乐市'),(1273,'2016-03-18 11:30:10','2016-03-18 11:30:10','厦门市','350200','福建省厦门市'),(1274,'2016-03-18 11:30:11','2016-03-18 11:30:11','市辖区','350201','福建省厦门市市辖区'),(1275,'2016-03-18 11:30:11','2016-03-18 11:30:11','思明区','350203','福建省厦门市思明区'),(1276,'2016-03-18 11:30:11','2016-03-18 11:30:11','海沧区','350205','福建省厦门市海沧区'),(1277,'2016-03-18 11:30:11','2016-03-18 11:30:11','湖里区','350206','福建省厦门市湖里区'),(1278,'2016-03-18 11:30:11','2016-03-18 11:30:11','集美区','350211','福建省厦门市集美区'),(1279,'2016-03-18 11:30:11','2016-03-18 11:30:11','同安区','350212','福建省厦门市同安区'),(1280,'2016-03-18 11:30:11','2016-03-18 11:30:11','翔安区','350213','福建省厦门市翔安区'),(1281,'2016-03-18 11:30:11','2016-03-18 11:30:11','莆田市','350300','福建省莆田市'),(1282,'2016-03-18 11:30:11','2016-03-18 11:30:11','市辖区','350301','福建省莆田市市辖区'),(1283,'2016-03-18 11:30:11','2016-03-18 11:30:11','城厢区','350302','福建省莆田市城厢区'),(1284,'2016-03-18 11:30:11','2016-03-18 11:30:11','涵江区','350303','福建省莆田市涵江区'),(1285,'2016-03-18 11:30:11','2016-03-18 11:30:11','荔城区','350304','福建省莆田市荔城区'),(1286,'2016-03-18 11:30:11','2016-03-18 11:30:11','秀屿区','350305','福建省莆田市秀屿区'),(1287,'2016-03-18 11:30:11','2016-03-18 11:30:11','仙游县','350322','福建省莆田市仙游县'),(1288,'2016-03-18 11:30:12','2016-03-18 11:30:12','三明市','350400','福建省三明市'),(1289,'2016-03-18 11:30:12','2016-03-18 11:30:12','市辖区','350401','福建省三明市市辖区'),(1290,'2016-03-18 11:30:12','2016-03-18 11:30:12','梅列区','350402','福建省三明市梅列区'),(1291,'2016-03-18 11:30:12','2016-03-18 11:30:12','三元区','350403','福建省三明市三元区'),(1292,'2016-03-18 11:30:12','2016-03-18 11:30:12','明溪县','350421','福建省三明市明溪县'),(1293,'2016-03-18 11:30:12','2016-03-18 11:30:12','清流县','350423','福建省三明市清流县'),(1294,'2016-03-18 11:30:12','2016-03-18 11:30:12','宁化县','350424','福建省三明市宁化县'),(1295,'2016-03-18 11:30:12','2016-03-18 11:30:12','大田县','350425','福建省三明市大田县'),(1296,'2016-03-18 11:30:12','2016-03-18 11:30:12','尤溪县','350426','福建省三明市尤溪县'),(1297,'2016-03-18 11:30:12','2016-03-18 11:30:12','沙县','350427','福建省三明市沙县'),(1298,'2016-03-18 11:30:12','2016-03-18 11:30:12','将乐县','350428','福建省三明市将乐县'),(1299,'2016-03-18 11:30:12','2016-03-18 11:30:12','泰宁县','350429','福建省三明市泰宁县'),(1300,'2016-03-18 11:30:12','2016-03-18 11:30:12','建宁县','350430','福建省三明市建宁县'),(1301,'2016-03-18 11:30:12','2016-03-18 11:30:12','永安市','350481','福建省三明市永安市'),(1302,'2016-03-18 11:30:12','2016-03-18 11:30:12','泉州市','350500','福建省泉州市'),(1304,'2016-03-18 11:30:12','2016-03-18 11:30:12','鲤城区','350502','福建省泉州市鲤城区'),(1305,'2016-03-18 11:30:12','2016-03-18 11:30:12','丰泽区','350503','福建省泉州市丰泽区'),(1306,'2016-03-18 11:30:12','2016-03-18 11:30:12','洛江区','350504','福建省泉州市洛江区'),(1307,'2016-03-18 11:30:12','2016-03-18 11:30:12','泉港区','350505','福建省泉州市泉港区'),(1308,'2016-03-18 11:30:13','2016-03-18 11:30:13','惠安县','350521','福建省泉州市惠安县'),(1309,'2016-03-18 11:30:13','2016-03-18 11:30:13','安溪县','350524','福建省泉州市安溪县'),(1310,'2016-03-18 11:30:13','2016-03-18 11:30:13','永春县','350525','福建省泉州市永春县'),(1311,'2016-03-18 11:30:13','2016-03-18 11:30:13','德化县','350526','福建省泉州市德化县'),(1313,'2016-03-18 11:30:13','2016-03-18 11:30:13','石狮市','350581','福建省泉州市石狮市'),(1314,'2016-03-18 11:30:13','2016-03-18 11:30:13','晋江市','350582','福建省泉州市晋江市'),(1315,'2016-03-18 11:30:13','2016-03-18 11:30:13','南安市','350583','福建省泉州市南安市'),(1316,'2016-03-18 11:30:13','2016-03-18 11:30:13','漳州市','350600','福建省漳州市'),(1317,'2016-03-18 11:30:13','2016-03-18 11:30:13','市辖区','350601','福建省漳州市市辖区'),(1318,'2016-03-18 11:30:13','2016-03-18 11:30:13','芗城区','350602','福建省漳州市芗城区'),(1319,'2016-03-18 11:30:13','2016-03-18 11:30:13','龙文区','350603','福建省漳州市龙文区'),(1320,'2016-03-18 11:30:13','2016-03-18 11:30:13','云霄县','350622','福建省漳州市云霄县'),(1321,'2016-03-18 11:30:13','2016-03-18 11:30:13','漳浦县','350623','福建省漳州市漳浦县'),(1322,'2016-03-18 11:30:13','2016-03-18 11:30:13','诏安县','350624','福建省漳州市诏安县'),(1323,'2016-03-18 11:30:14','2016-03-18 11:30:14','长泰县','350625','福建省漳州市长泰县'),(1324,'2016-03-18 11:30:14','2016-03-18 11:30:14','东山县','350626','福建省漳州市东山县'),(1325,'2016-03-18 11:30:14','2016-03-18 11:30:14','南靖县','350627','福建省漳州市南靖县'),(1326,'2016-03-18 11:30:14','2016-03-18 11:30:14','平和县','350628','福建省漳州市平和县'),(1327,'2016-03-18 11:30:14','2016-03-18 11:30:14','华安县','350629','福建省漳州市华安县'),(1328,'2016-03-18 11:30:14','2016-03-18 11:30:14','龙海市','350681','福建省漳州市龙海市'),(1329,'2016-03-18 11:30:14','2016-03-18 11:30:14','南平市','350700','福建省南平市'),(1330,'2016-03-18 11:30:14','2016-03-18 11:30:14','市辖区','350701','福建省南平市市辖区'),(1331,'2016-03-18 11:30:14','2016-03-18 11:30:14','延平区','350702','福建省南平市延平区'),(1332,'2016-03-18 11:30:14','2016-03-18 11:30:14','顺昌县','350721','福建省南平市顺昌县'),(1333,'2016-03-18 11:30:14','2016-03-18 11:30:14','浦城县','350722','福建省南平市浦城县'),(1334,'2016-03-18 11:30:14','2016-03-18 11:30:14','光泽县','350723','福建省南平市光泽县'),(1335,'2016-03-18 11:30:14','2016-03-18 11:30:14','松溪县','350724','福建省南平市松溪县'),(1336,'2016-03-18 11:30:14','2016-03-18 11:30:14','政和县','350725','福建省南平市政和县'),(1337,'2016-03-18 11:30:14','2016-03-18 11:30:14','邵武市','350781','福建省南平市邵武市'),(1338,'2016-03-18 11:30:15','2016-03-18 11:30:15','武夷山市','350782','福建省南平市武夷山市'),(1339,'2016-03-18 11:30:15','2016-03-18 11:30:15','建瓯市','350783','福建省南平市建瓯市'),(1340,'2016-03-18 11:30:15','2016-03-18 11:30:15','建阳市','350784','福建省南平市建阳市'),(1341,'2016-03-18 11:30:15','2016-03-18 11:30:15','龙岩市','350800','福建省龙岩市'),(1342,'2016-03-18 11:30:15','2016-03-18 11:30:15','市辖区','350801','福建省龙岩市市辖区'),(1343,'2016-03-18 11:30:15','2016-03-18 11:30:15','新罗区','350802','福建省龙岩市新罗区'),(1344,'2016-03-18 11:30:15','2016-03-18 11:30:15','长汀县','350821','福建省龙岩市长汀县'),(1345,'2016-03-18 11:30:15','2016-03-18 11:30:15','永定县','350822','福建省龙岩市永定县'),(1346,'2016-03-18 11:30:15','2016-03-18 11:30:15','上杭县','350823','福建省龙岩市上杭县'),(1347,'2016-03-18 11:30:15','2016-03-18 11:30:15','武平县','350824','福建省龙岩市武平县'),(1348,'2016-03-18 11:30:15','2016-03-18 11:30:15','连城县','350825','福建省龙岩市连城县'),(1349,'2016-03-18 11:30:15','2016-03-18 11:30:15','漳平市','350881','福建省龙岩市漳平市'),(1350,'2016-03-18 11:30:15','2016-03-18 11:30:15','宁德市','350900','福建省宁德市'),(1351,'2016-03-18 11:30:15','2016-03-18 11:30:15','市辖区','350901','福建省宁德市市辖区'),(1352,'2016-03-18 11:30:15','2016-03-18 11:30:15','蕉城区','350902','福建省宁德市蕉城区'),(1353,'2016-03-18 11:30:15','2016-03-18 11:30:15','霞浦县','350921','福建省宁德市霞浦县'),(1354,'2016-03-18 11:30:15','2016-03-18 11:30:15','古田县','350922','福建省宁德市古田县'),(1355,'2016-03-18 11:30:15','2016-03-18 11:30:15','屏南县','350923','福建省宁德市屏南县'),(1356,'2016-03-18 11:30:15','2016-03-18 11:30:15','寿宁县','350924','福建省宁德市寿宁县'),(1357,'2016-03-18 11:30:16','2016-03-18 11:30:16','周宁县','350925','福建省宁德市周宁县'),(1358,'2016-03-18 11:30:16','2016-03-18 11:30:16','柘荣县','350926','福建省宁德市柘荣县'),(1359,'2016-03-18 11:30:16','2016-03-18 11:30:16','福安市','350981','福建省宁德市福安市'),(1360,'2016-03-18 11:30:16','2016-03-18 11:30:16','福鼎市','350982','福建省宁德市福鼎市'),(1361,'2016-03-18 11:30:16','2016-03-18 11:30:16','江西省','360000','江西省'),(1362,'2016-03-18 11:30:16','2016-03-18 11:30:16','南昌市','360100','江西省南昌市'),(1363,'2016-03-18 11:30:16','2016-03-18 11:30:16','市辖区','360101','江西省南昌市市辖区'),(1364,'2016-03-18 11:30:16','2016-03-18 11:30:16','东湖区','360102','江西省南昌市东湖区'),(1365,'2016-03-18 11:30:16','2016-03-18 11:30:16','西湖区','360103','江西省南昌市西湖区'),(1366,'2016-03-18 11:30:16','2016-03-18 11:30:16','青云谱区','360104','江西省南昌市青云谱区'),(1367,'2016-03-18 11:30:16','2016-03-18 11:30:16','湾里区','360105','江西省南昌市湾里区'),(1368,'2016-03-18 11:30:16','2016-03-18 11:30:16','青山湖区','360111','江西省南昌市青山湖区'),(1369,'2016-03-18 11:30:16','2016-03-18 11:30:16','南昌县','360121','江西省南昌市南昌县'),(1370,'2016-03-18 11:30:16','2016-03-18 11:30:16','新建县','360122','江西省南昌市新建县'),(1371,'2016-03-18 11:30:16','2016-03-18 11:30:16','安义县','360123','江西省南昌市安义县'),(1372,'2016-03-18 11:30:17','2016-03-18 11:30:17','进贤县','360124','江西省南昌市进贤县'),(1373,'2016-03-18 11:30:17','2016-03-18 11:30:17','景德镇市','360200','江西省景德镇市'),(1374,'2016-03-18 11:30:17','2016-03-18 11:30:17','市辖区','360201','江西省景德镇市市辖区'),(1375,'2016-03-18 11:30:17','2016-03-18 11:30:17','昌江区','360202','江西省景德镇市昌江区'),(1376,'2016-03-18 11:30:17','2016-03-18 11:30:17','珠山区','360203','江西省景德镇市珠山区'),(1377,'2016-03-18 11:30:17','2016-03-18 11:30:17','浮梁县','360222','江西省景德镇市浮梁县'),(1378,'2016-03-18 11:30:17','2016-03-18 11:30:17','乐平市','360281','江西省景德镇市乐平市'),(1379,'2016-03-18 11:30:17','2016-03-18 11:30:17','萍乡市','360300','江西省萍乡市'),(1380,'2016-03-18 11:30:17','2016-03-18 11:30:17','市辖区','360301','江西省萍乡市市辖区'),(1381,'2016-03-18 11:30:17','2016-03-18 11:30:17','安源区','360302','江西省萍乡市安源区'),(1382,'2016-03-18 11:30:17','2016-03-18 11:30:17','湘东区','360313','江西省萍乡市湘东区'),(1383,'2016-03-18 11:30:17','2016-03-18 11:30:17','莲花县','360321','江西省萍乡市莲花县'),(1384,'2016-03-18 11:30:17','2016-03-18 11:30:17','上栗县','360322','江西省萍乡市上栗县'),(1385,'2016-03-18 11:30:17','2016-03-18 11:30:17','芦溪县','360323','江西省萍乡市芦溪县'),(1386,'2016-03-18 11:30:17','2016-03-18 11:30:17','九江市','360400','江西省九江市'),(1387,'2016-03-18 11:30:18','2016-03-18 11:30:18','市辖区','360401','江西省九江市市辖区'),(1388,'2016-03-18 11:30:18','2016-03-18 11:30:18','庐山区','360402','江西省九江市庐山区'),(1389,'2016-03-18 11:30:18','2016-03-18 11:30:18','浔阳区','360403','江西省九江市浔阳区'),(1390,'2016-03-18 11:30:18','2016-03-18 11:30:18','九江县','360421','江西省九江市九江县'),(1391,'2016-03-18 11:30:18','2016-03-18 11:30:18','武宁县','360423','江西省九江市武宁县'),(1392,'2016-03-18 11:30:18','2016-03-18 11:30:18','修水县','360424','江西省九江市修水县'),(1393,'2016-03-18 11:30:18','2016-03-18 11:30:18','永修县','360425','江西省九江市永修县'),(1394,'2016-03-18 11:30:18','2016-03-18 11:30:18','德安县','360426','江西省九江市德安县'),(1395,'2016-03-18 11:30:18','2016-03-18 11:30:18','星子县','360427','江西省九江市星子县'),(1396,'2016-03-18 11:30:18','2016-03-18 11:30:18','都昌县','360428','江西省九江市都昌县'),(1397,'2016-03-18 11:30:18','2016-03-18 11:30:18','湖口县','360429','江西省九江市湖口县'),(1398,'2016-03-18 11:30:18','2016-03-18 11:30:18','彭泽县','360430','江西省九江市彭泽县'),(1399,'2016-03-18 11:30:18','2016-03-18 11:30:18','瑞昌市','360481','江西省九江市瑞昌市'),(1400,'2016-03-18 11:30:18','2016-03-18 11:30:18','共青城市','360482','江西省九江市共青城市'),(1401,'2016-03-18 11:30:18','2016-03-18 11:30:18','新余市','360500','江西省新余市'),(1402,'2016-03-18 11:30:18','2016-03-18 11:30:18','市辖区','360501','江西省新余市市辖区'),(1403,'2016-03-18 11:30:18','2016-03-18 11:30:18','渝水区','360502','江西省新余市渝水区'),(1404,'2016-03-18 11:30:19','2016-03-18 11:30:19','分宜县','360521','江西省新余市分宜县'),(1405,'2016-03-18 11:30:19','2016-03-18 11:30:19','鹰潭市','360600','江西省鹰潭市'),(1406,'2016-03-18 11:30:19','2016-03-18 11:30:19','市辖区','360601','江西省鹰潭市市辖区'),(1407,'2016-03-18 11:30:19','2016-03-18 11:30:19','月湖区','360602','江西省鹰潭市月湖区'),(1408,'2016-03-18 11:30:19','2016-03-18 11:30:19','余江县','360622','江西省鹰潭市余江县'),(1409,'2016-03-18 11:30:19','2016-03-18 11:30:19','贵溪市','360681','江西省鹰潭市贵溪市'),(1410,'2016-03-18 11:30:19','2016-03-18 11:30:19','赣州市','360700','江西省赣州市'),(1411,'2016-03-18 11:30:19','2016-03-18 11:30:19','市辖区','360701','江西省赣州市市辖区'),(1412,'2016-03-18 11:30:19','2016-03-18 11:30:19','章贡区','360702','江西省赣州市章贡区'),(1413,'2016-03-18 11:30:19','2016-03-18 11:30:19','南康区','360703','江西省赣州市南康区'),(1414,'2016-03-18 11:30:19','2016-03-18 11:30:19','赣县','360721','江西省赣州市赣县'),(1415,'2016-03-18 11:30:19','2016-03-18 11:30:19','信丰县','360722','江西省赣州市信丰县'),(1416,'2016-03-18 11:30:19','2016-03-18 11:30:19','大余县','360723','江西省赣州市大余县'),(1417,'2016-03-18 11:30:19','2016-03-18 11:30:19','上犹县','360724','江西省赣州市上犹县'),(1418,'2016-03-18 11:30:19','2016-03-18 11:30:19','崇义县','360725','江西省赣州市崇义县'),(1419,'2016-03-18 11:30:20','2016-03-18 11:30:20','安远县','360726','江西省赣州市安远县'),(1420,'2016-03-18 11:30:20','2016-03-18 11:30:20','龙南县','360727','江西省赣州市龙南县'),(1421,'2016-03-18 11:30:20','2016-03-18 11:30:20','定南县','360728','江西省赣州市定南县'),(1422,'2016-03-18 11:30:20','2016-03-18 11:30:20','全南县','360729','江西省赣州市全南县'),(1423,'2016-03-18 11:30:20','2016-03-18 11:30:20','宁都县','360730','江西省赣州市宁都县'),(1424,'2016-03-18 11:30:20','2016-03-18 11:30:20','于都县','360731','江西省赣州市于都县'),(1425,'2016-03-18 11:30:20','2016-03-18 11:30:20','兴国县','360732','江西省赣州市兴国县'),(1426,'2016-03-18 11:30:20','2016-03-18 11:30:20','会昌县','360733','江西省赣州市会昌县'),(1427,'2016-03-18 11:30:20','2016-03-18 11:30:20','寻乌县','360734','江西省赣州市寻乌县'),(1428,'2016-03-18 11:30:20','2016-03-18 11:30:20','石城县','360735','江西省赣州市石城县'),(1429,'2016-03-18 11:30:20','2016-03-18 11:30:20','瑞金市','360781','江西省赣州市瑞金市'),(1430,'2016-03-18 11:30:20','2016-03-18 11:30:20','吉安市','360800','江西省吉安市'),(1431,'2016-03-18 11:30:20','2016-03-18 11:30:20','市辖区','360801','江西省吉安市市辖区'),(1432,'2016-03-18 11:30:20','2016-03-18 11:30:20','吉州区','360802','江西省吉安市吉州区'),(1433,'2016-03-18 11:30:20','2016-03-18 11:30:20','青原区','360803','江西省吉安市青原区'),(1434,'2016-03-18 11:30:20','2016-03-18 11:30:20','吉安县','360821','江西省吉安市吉安县'),(1435,'2016-03-18 11:30:20','2016-03-18 11:30:20','吉水县','360822','江西省吉安市吉水县'),(1436,'2016-03-18 11:30:21','2016-03-18 11:30:21','峡江县','360823','江西省吉安市峡江县'),(1437,'2016-03-18 11:30:21','2016-03-18 11:30:21','新干县','360824','江西省吉安市新干县'),(1438,'2016-03-18 11:30:21','2016-03-18 11:30:21','永丰县','360825','江西省吉安市永丰县'),(1439,'2016-03-18 11:30:21','2016-03-18 11:30:21','泰和县','360826','江西省吉安市泰和县'),(1440,'2016-03-18 11:30:21','2016-03-18 11:30:21','遂川县','360827','江西省吉安市遂川县'),(1441,'2016-03-18 11:30:21','2016-03-18 11:30:21','万安县','360828','江西省吉安市万安县'),(1442,'2016-03-18 11:30:21','2016-03-18 11:30:21','安福县','360829','江西省吉安市安福县'),(1443,'2016-03-18 11:30:21','2016-03-18 11:30:21','永新县','360830','江西省吉安市永新县'),(1444,'2016-03-18 11:30:21','2016-03-18 11:30:21','井冈山市','360881','江西省吉安市井冈山市'),(1445,'2016-03-18 11:30:21','2016-03-18 11:30:21','宜春市','360900','江西省宜春市'),(1446,'2016-03-18 11:30:21','2016-03-18 11:30:21','市辖区','360901','江西省宜春市市辖区'),(1447,'2016-03-18 11:30:22','2016-03-18 11:30:22','袁州区','360902','江西省宜春市袁州区'),(1448,'2016-03-18 11:30:22','2016-03-18 11:30:22','奉新县','360921','江西省宜春市奉新县'),(1449,'2016-03-18 11:30:22','2016-03-18 11:30:22','万载县','360922','江西省宜春市万载县'),(1450,'2016-03-18 11:30:22','2016-03-18 11:30:22','上高县','360923','江西省宜春市上高县'),(1451,'2016-03-18 11:30:22','2016-03-18 11:30:22','宜丰县','360924','江西省宜春市宜丰县'),(1452,'2016-03-18 11:30:22','2016-03-18 11:30:22','靖安县','360925','江西省宜春市靖安县'),(1453,'2016-03-18 11:30:22','2016-03-18 11:30:22','铜鼓县','360926','江西省宜春市铜鼓县'),(1454,'2016-03-18 11:30:22','2016-03-18 11:30:22','丰城市','360981','江西省宜春市丰城市'),(1455,'2016-03-18 11:30:22','2016-03-18 11:30:22','樟树市','360982','江西省宜春市樟树市'),(1456,'2016-03-18 11:30:22','2016-03-18 11:30:22','高安市','360983','江西省宜春市高安市'),(1457,'2016-03-18 11:30:22','2016-03-18 11:30:22','抚州市','361000','江西省抚州市'),(1458,'2016-03-18 11:30:22','2016-03-18 11:30:22','市辖区','361001','江西省抚州市市辖区'),(1459,'2016-03-18 11:30:22','2016-03-18 11:30:22','临川区','361002','江西省抚州市临川区'),(1460,'2016-03-18 11:30:22','2016-03-18 11:30:22','南城县','361021','江西省抚州市南城县'),(1461,'2016-03-18 11:30:22','2016-03-18 11:30:22','黎川县','361022','江西省抚州市黎川县'),(1462,'2016-03-18 11:30:22','2016-03-18 11:30:22','南丰县','361023','江西省抚州市南丰县'),(1463,'2016-03-18 11:30:22','2016-03-18 11:30:22','崇仁县','361024','江西省抚州市崇仁县'),(1464,'2016-03-18 11:30:23','2016-03-18 11:30:23','乐安县','361025','江西省抚州市乐安县'),(1465,'2016-03-18 11:30:23','2016-03-18 11:30:23','宜黄县','361026','江西省抚州市宜黄县'),(1466,'2016-03-18 11:30:23','2016-03-18 11:30:23','金溪县','361027','江西省抚州市金溪县'),(1467,'2016-03-18 11:30:23','2016-03-18 11:30:23','资溪县','361028','江西省抚州市资溪县'),(1468,'2016-03-18 11:30:23','2016-03-18 11:30:23','东乡县','361029','江西省抚州市东乡县'),(1469,'2016-03-18 11:30:23','2016-03-18 11:30:23','广昌县','361030','江西省抚州市广昌县'),(1470,'2016-03-18 11:30:23','2016-03-18 11:30:23','上饶市','361100','江西省上饶市'),(1471,'2016-03-18 11:30:23','2016-03-18 11:30:23','市辖区','361101','江西省上饶市市辖区'),(1472,'2016-03-18 11:30:23','2016-03-18 11:30:23','信州区','361102','江西省上饶市信州区'),(1473,'2016-03-18 11:30:23','2016-03-18 11:30:23','上饶县','361121','江西省上饶市上饶县'),(1474,'2016-03-18 11:30:23','2016-03-18 11:30:23','广丰县','361122','江西省上饶市广丰县'),(1475,'2016-03-18 11:30:23','2016-03-18 11:30:23','玉山县','361123','江西省上饶市玉山县'),(1476,'2016-03-18 11:30:23','2016-03-18 11:30:23','铅山县','361124','江西省上饶市铅山县'),(1477,'2016-03-18 11:30:23','2016-03-18 11:30:23','横峰县','361125','江西省上饶市横峰县'),(1478,'2016-03-18 11:30:24','2016-03-18 11:30:24','弋阳县','361126','江西省上饶市弋阳县'),(1479,'2016-03-18 11:30:24','2016-03-18 11:30:24','余干县','361127','江西省上饶市余干县'),(1480,'2016-03-18 11:30:24','2016-03-18 11:30:24','鄱阳县','361128','江西省上饶市鄱阳县'),(1481,'2016-03-18 11:30:24','2016-03-18 11:30:24','万年县','361129','江西省上饶市万年县'),(1482,'2016-03-18 11:30:24','2016-03-18 11:30:24','婺源县','361130','江西省上饶市婺源县'),(1483,'2016-03-18 11:30:24','2016-03-18 11:30:24','德兴市','361181','江西省上饶市德兴市'),(1484,'2016-03-18 11:30:24','2016-03-18 11:30:24','山东省','370000','山东省'),(1485,'2016-03-18 11:30:24','2016-03-18 11:30:24','济南市','370100','山东省济南市'),(1486,'2016-03-18 11:30:24','2016-03-18 11:30:24','市辖区','370101','山东省济南市市辖区'),(1487,'2016-03-18 11:30:24','2016-03-18 11:30:24','历下区','370102','山东省济南市历下区'),(1488,'2016-03-18 11:30:24','2016-03-18 11:30:24','市中区','370103','山东省济南市市中区'),(1489,'2016-03-18 11:30:24','2016-03-18 11:30:24','槐荫区','370104','山东省济南市槐荫区'),(1490,'2016-03-18 11:30:25','2016-03-18 11:30:25','天桥区','370105','山东省济南市天桥区'),(1491,'2016-03-18 11:30:25','2016-03-18 11:30:25','历城区','370112','山东省济南市历城区'),(1492,'2016-03-18 11:30:25','2016-03-18 11:30:25','长清区','370113','山东省济南市长清区'),(1493,'2016-03-18 11:30:25','2016-03-18 11:30:25','平阴县','370124','山东省济南市平阴县'),(1494,'2016-03-18 11:30:25','2016-03-18 11:30:25','济阳县','370125','山东省济南市济阳县'),(1495,'2016-03-18 11:30:25','2016-03-18 11:30:25','商河县','370126','山东省济南市商河县'),(1496,'2016-03-18 11:30:25','2016-03-18 11:30:25','章丘市','370181','山东省济南市章丘市'),(1497,'2016-03-18 11:30:25','2016-03-18 11:30:25','青岛市','370200','山东省青岛市'),(1498,'2016-03-18 11:30:25','2016-03-18 11:30:25','市辖区','370201','山东省青岛市市辖区'),(1499,'2016-03-18 11:30:25','2016-03-18 11:30:25','市南区','370202','山东省青岛市市南区'),(1500,'2016-03-18 11:30:25','2016-03-18 11:30:25','市北区','370203','山东省青岛市市北区'),(1501,'2016-03-18 11:30:25','2016-03-18 11:30:25','黄岛区','370211','山东省青岛市黄岛区'),(1502,'2016-03-18 11:30:25','2016-03-18 11:30:25','崂山区','370212','山东省青岛市崂山区'),(1503,'2016-03-18 11:30:25','2016-03-18 11:30:25','李沧区','370213','山东省青岛市李沧区'),(1504,'2016-03-18 11:30:26','2016-03-18 11:30:26','城阳区','370214','山东省青岛市城阳区'),(1505,'2016-03-18 11:30:26','2016-03-18 11:30:26','胶州市','370281','山东省青岛市胶州市'),(1506,'2016-03-18 11:30:26','2016-03-18 11:30:26','即墨市','370282','山东省青岛市即墨市'),(1507,'2016-03-18 11:30:26','2016-03-18 11:30:26','平度市','370283','山东省青岛市平度市'),(1508,'2016-03-18 11:30:26','2016-03-18 11:30:26','莱西市','370285','山东省青岛市莱西市'),(1509,'2016-03-18 11:30:26','2016-03-18 11:30:26','淄博市','370300','山东省淄博市'),(1510,'2016-03-18 11:30:26','2016-03-18 11:30:26','市辖区','370301','山东省淄博市市辖区'),(1511,'2016-03-18 11:30:26','2016-03-18 11:30:26','淄川区','370302','山东省淄博市淄川区'),(1512,'2016-03-18 11:30:26','2016-03-18 11:30:26','张店区','370303','山东省淄博市张店区'),(1513,'2016-03-18 11:30:26','2016-03-18 11:30:26','博山区','370304','山东省淄博市博山区'),(1514,'2016-03-18 11:30:26','2016-03-18 11:30:26','临淄区','370305','山东省淄博市临淄区'),(1515,'2016-03-18 11:30:26','2016-03-18 11:30:26','周村区','370306','山东省淄博市周村区'),(1516,'2016-03-18 11:30:27','2016-03-18 11:30:27','桓台县','370321','山东省淄博市桓台县'),(1517,'2016-03-18 11:30:27','2016-03-18 11:30:27','高青县','370322','山东省淄博市高青县'),(1518,'2016-03-18 11:30:27','2016-03-18 11:30:27','沂源县','370323','山东省淄博市沂源县'),(1519,'2016-03-18 11:30:27','2016-03-18 11:30:27','枣庄市','370400','山东省枣庄市'),(1520,'2016-03-18 11:30:27','2016-03-18 11:30:27','市辖区','370401','山东省枣庄市市辖区'),(1521,'2016-03-18 11:30:27','2016-03-18 11:30:27','市中区','370402','山东省枣庄市市中区'),(1522,'2016-03-18 11:30:27','2016-03-18 11:30:27','薛城区','370403','山东省枣庄市薛城区'),(1523,'2016-03-18 11:30:27','2016-03-18 11:30:27','峄城区','370404','山东省枣庄市峄城区'),(1524,'2016-03-18 11:30:27','2016-03-18 11:30:27','台儿庄区','370405','山东省枣庄市台儿庄区'),(1525,'2016-03-18 11:30:27','2016-03-18 11:30:27','山亭区','370406','山东省枣庄市山亭区'),(1526,'2016-03-18 11:30:27','2016-03-18 11:30:27','滕州市','370481','山东省枣庄市滕州市'),(1527,'2016-03-18 11:30:27','2016-03-18 11:30:27','东营市','370500','山东省东营市'),(1528,'2016-03-18 11:30:28','2016-03-18 11:30:28','市辖区','370501','山东省东营市市辖区'),(1529,'2016-03-18 11:30:28','2016-03-18 11:30:28','东营区','370502','山东省东营市东营区'),(1530,'2016-03-18 11:30:28','2016-03-18 11:30:28','河口区','370503','山东省东营市河口区'),(1531,'2016-03-18 11:30:28','2016-03-18 11:30:28','垦利县','370521','山东省东营市垦利县'),(1532,'2016-03-18 11:30:28','2016-03-18 11:30:28','利津县','370522','山东省东营市利津县'),(1533,'2016-03-18 11:30:28','2016-03-18 11:30:28','广饶县','370523','山东省东营市广饶县'),(1534,'2016-03-18 11:30:28','2016-03-18 11:30:28','烟台市','370600','山东省烟台市'),(1535,'2016-03-18 11:30:28','2016-03-18 11:30:28','市辖区','370601','山东省烟台市市辖区'),(1536,'2016-03-18 11:30:28','2016-03-18 11:30:28','芝罘区','370602','山东省烟台市芝罘区'),(1537,'2016-03-18 11:30:28','2016-03-18 11:30:28','福山区','370611','山东省烟台市福山区'),(1538,'2016-03-18 11:30:28','2016-03-18 11:30:28','牟平区','370612','山东省烟台市牟平区'),(1539,'2016-03-18 11:30:28','2016-03-18 11:30:28','莱山区','370613','山东省烟台市莱山区'),(1540,'2016-03-18 11:30:28','2016-03-18 11:30:28','长岛县','370634','山东省烟台市长岛县'),(1541,'2016-03-18 11:30:28','2016-03-18 11:30:28','龙口市','370681','山东省烟台市龙口市'),(1542,'2016-03-18 11:30:28','2016-03-18 11:30:28','莱阳市','370682','山东省烟台市莱阳市'),(1543,'2016-03-18 11:30:28','2016-03-18 11:30:28','莱州市','370683','山东省烟台市莱州市'),(1544,'2016-03-18 11:30:28','2016-03-18 11:30:28','蓬莱市','370684','山东省烟台市蓬莱市'),(1545,'2016-03-18 11:30:29','2016-03-18 11:30:29','招远市','370685','山东省烟台市招远市'),(1546,'2016-03-18 11:30:29','2016-03-18 11:30:29','栖霞市','370686','山东省烟台市栖霞市'),(1547,'2016-03-18 11:30:29','2016-03-18 11:30:29','海阳市','370687','山东省烟台市海阳市'),(1548,'2016-03-18 11:30:29','2016-03-18 11:30:29','潍坊市','370700','山东省潍坊市'),(1549,'2016-03-18 11:30:29','2016-03-18 11:30:29','市辖区','370701','山东省潍坊市市辖区'),(1550,'2016-03-18 11:30:29','2016-03-18 11:30:29','潍城区','370702','山东省潍坊市潍城区'),(1551,'2016-03-18 11:30:29','2016-03-18 11:30:29','寒亭区','370703','山东省潍坊市寒亭区'),(1552,'2016-03-18 11:30:29','2016-03-18 11:30:29','坊子区','370704','山东省潍坊市坊子区'),(1553,'2016-03-18 11:30:29','2016-03-18 11:30:29','奎文区','370705','山东省潍坊市奎文区'),(1554,'2016-03-18 11:30:29','2016-03-18 11:30:29','临朐县','370724','山东省潍坊市临朐县'),(1555,'2016-03-18 11:30:29','2016-03-18 11:30:29','昌乐县','370725','山东省潍坊市昌乐县'),(1556,'2016-03-18 11:30:29','2016-03-18 11:30:29','青州市','370781','山东省潍坊市青州市'),(1557,'2016-03-18 11:30:29','2016-03-18 11:30:29','诸城市','370782','山东省潍坊市诸城市'),(1558,'2016-03-18 11:30:29','2016-03-18 11:30:29','寿光市','370783','山东省潍坊市寿光市'),(1559,'2016-03-18 11:30:29','2016-03-18 11:30:29','安丘市','370784','山东省潍坊市安丘市'),(1560,'2016-03-18 11:30:29','2016-03-18 11:30:29','高密市','370785','山东省潍坊市高密市'),(1561,'2016-03-18 11:30:29','2016-03-18 11:30:29','昌邑市','370786','山东省潍坊市昌邑市'),(1562,'2016-03-18 11:30:30','2016-03-18 11:30:30','济宁市','370800','山东省济宁市'),(1563,'2016-03-18 11:30:30','2016-03-18 11:30:30','市辖区','370801','山东省济宁市市辖区'),(1564,'2016-03-18 11:30:30','2016-03-18 11:30:30','任城区','370811','山东省济宁市任城区'),(1565,'2016-03-18 11:30:30','2016-03-18 11:30:30','兖州区','370812','山东省济宁市兖州区'),(1566,'2016-03-18 11:30:30','2016-03-18 11:30:30','微山县','370826','山东省济宁市微山县'),(1567,'2016-03-18 11:30:30','2016-03-18 11:30:30','鱼台县','370827','山东省济宁市鱼台县'),(1568,'2016-03-18 11:30:30','2016-03-18 11:30:30','金乡县','370828','山东省济宁市金乡县'),(1569,'2016-03-18 11:30:30','2016-03-18 11:30:30','嘉祥县','370829','山东省济宁市嘉祥县'),(1570,'2016-03-18 11:30:30','2016-03-18 11:30:30','汶上县','370830','山东省济宁市汶上县'),(1571,'2016-03-18 11:30:30','2016-03-18 11:30:30','泗水县','370831','山东省济宁市泗水县'),(1572,'2016-03-18 11:30:30','2016-03-18 11:30:30','梁山县','370832','山东省济宁市梁山县'),(1573,'2016-03-18 11:30:30','2016-03-18 11:30:30','曲阜市','370881','山东省济宁市曲阜市'),(1574,'2016-03-18 11:30:30','2016-03-18 11:30:30','邹城市','370883','山东省济宁市邹城市'),(1575,'2016-03-18 11:30:30','2016-03-18 11:30:30','泰安市','370900','山东省泰安市'),(1576,'2016-03-18 11:30:30','2016-03-18 11:30:30','市辖区','370901','山东省泰安市市辖区'),(1577,'2016-03-18 11:30:30','2016-03-18 11:30:30','泰山区','370902','山东省泰安市泰山区'),(1578,'2016-03-18 11:30:30','2016-03-18 11:30:30','岱岳区','370911','山东省泰安市岱岳区'),(1579,'2016-03-18 11:30:31','2016-03-18 11:30:31','宁阳县','370921','山东省泰安市宁阳县'),(1580,'2016-03-18 11:30:31','2016-03-18 11:30:31','东平县','370923','山东省泰安市东平县'),(1581,'2016-03-18 11:30:31','2016-03-18 11:30:31','新泰市','370982','山东省泰安市新泰市'),(1582,'2016-03-18 11:30:31','2016-03-18 11:30:31','肥城市','370983','山东省泰安市肥城市'),(1583,'2016-03-18 11:30:31','2016-03-18 11:30:31','威海市','371000','山东省威海市'),(1584,'2016-03-18 11:30:31','2016-03-18 11:30:31','市辖区','371001','山东省威海市市辖区'),(1585,'2016-03-18 11:30:31','2016-03-18 11:30:31','环翠区','371002','山东省威海市环翠区'),(1586,'2016-03-18 11:30:31','2016-03-18 11:30:31','文登区','371003','山东省威海市文登区'),(1587,'2016-03-18 11:30:31','2016-03-18 11:30:31','荣成市','371082','山东省威海市荣成市'),(1588,'2016-03-18 11:30:31','2016-03-18 11:30:31','乳山市','371083','山东省威海市乳山市'),(1589,'2016-03-18 11:30:31','2016-03-18 11:30:31','日照市','371100','山东省日照市'),(1590,'2016-03-18 11:30:31','2016-03-18 11:30:31','市辖区','371101','山东省日照市市辖区'),(1591,'2016-03-18 11:30:31','2016-03-18 11:30:31','东港区','371102','山东省日照市东港区'),(1592,'2016-03-18 11:30:31','2016-03-18 11:30:31','岚山区','371103','山东省日照市岚山区'),(1593,'2016-03-18 11:30:31','2016-03-18 11:30:31','五莲县','371121','山东省日照市五莲县'),(1594,'2016-03-18 11:30:32','2016-03-18 11:30:32','莒县','371122','山东省日照市莒县'),(1595,'2016-03-18 11:30:32','2016-03-18 11:30:32','莱芜市','371200','山东省莱芜市'),(1596,'2016-03-18 11:30:32','2016-03-18 11:30:32','市辖区','371201','山东省莱芜市市辖区'),(1597,'2016-03-18 11:30:32','2016-03-18 11:30:32','莱城区','371202','山东省莱芜市莱城区'),(1598,'2016-03-18 11:30:32','2016-03-18 11:30:32','钢城区','371203','山东省莱芜市钢城区'),(1599,'2016-03-18 11:30:32','2016-03-18 11:30:32','临沂市','371300','山东省临沂市'),(1600,'2016-03-18 11:30:32','2016-03-18 11:30:32','市辖区','371301','山东省临沂市市辖区'),(1601,'2016-03-18 11:30:32','2016-03-18 11:30:32','兰山区','371302','山东省临沂市兰山区'),(1602,'2016-03-18 11:30:32','2016-03-18 11:30:32','罗庄区','371311','山东省临沂市罗庄区'),(1603,'2016-03-18 11:30:32','2016-03-18 11:30:32','河东区','371312','山东省临沂市河东区'),(1604,'2016-03-18 11:30:32','2016-03-18 11:30:32','沂南县','371321','山东省临沂市沂南县'),(1605,'2016-03-18 11:30:32','2016-03-18 11:30:32','郯城县','371322','山东省临沂市郯城县'),(1606,'2016-03-18 11:30:32','2016-03-18 11:30:32','沂水县','371323','山东省临沂市沂水县'),(1607,'2016-03-18 11:30:32','2016-03-18 11:30:32','兰陵县','371324','山东省临沂市兰陵县'),(1608,'2016-03-18 11:30:33','2016-03-18 11:30:33','费县','371325','山东省临沂市费县'),(1609,'2016-03-18 11:30:33','2016-03-18 11:30:33','平邑县','371326','山东省临沂市平邑县'),(1610,'2016-03-18 11:30:33','2016-03-18 11:30:33','莒南县','371327','山东省临沂市莒南县'),(1611,'2016-03-18 11:30:33','2016-03-18 11:30:33','蒙阴县','371328','山东省临沂市蒙阴县'),(1612,'2016-03-18 11:30:33','2016-03-18 11:30:33','临沭县','371329','山东省临沂市临沭县'),(1613,'2016-03-18 11:30:33','2016-03-18 11:30:33','德州市','371400','山东省德州市'),(1614,'2016-03-18 11:30:33','2016-03-18 11:30:33','市辖区','371401','山东省德州市市辖区'),(1615,'2016-03-18 11:30:33','2016-03-18 11:30:33','德城区','371402','山东省德州市德城区'),(1616,'2016-03-18 11:30:33','2016-03-18 11:30:33','陵城区','371403','山东省德州市陵城区'),(1617,'2016-03-18 11:30:33','2016-03-18 11:30:33','宁津县','371422','山东省德州市宁津县'),(1618,'2016-03-18 11:30:33','2016-03-18 11:30:33','庆云县','371423','山东省德州市庆云县'),(1619,'2016-03-18 11:30:33','2016-03-18 11:30:33','临邑县','371424','山东省德州市临邑县'),(1620,'2016-03-18 11:30:33','2016-03-18 11:30:33','齐河县','371425','山东省德州市齐河县'),(1621,'2016-03-18 11:30:33','2016-03-18 11:30:33','平原县','371426','山东省德州市平原县'),(1622,'2016-03-18 11:30:33','2016-03-18 11:30:33','夏津县','371427','山东省德州市夏津县'),(1623,'2016-03-18 11:30:33','2016-03-18 11:30:33','武城县','371428','山东省德州市武城县'),(1624,'2016-03-18 11:30:33','2016-03-18 11:30:33','乐陵市','371481','山东省德州市乐陵市'),(1625,'2016-03-18 11:30:33','2016-03-18 11:30:33','禹城市','371482','山东省德州市禹城市'),(1626,'2016-03-18 11:30:34','2016-03-18 11:30:34','聊城市','371500','山东省聊城市'),(1627,'2016-03-18 11:30:34','2016-03-18 11:30:34','市辖区','371501','山东省聊城市市辖区'),(1628,'2016-03-18 11:30:34','2016-03-18 11:30:34','东昌府区','371502','山东省聊城市东昌府区'),(1629,'2016-03-18 11:30:34','2016-03-18 11:30:34','阳谷县','371521','山东省聊城市阳谷县'),(1630,'2016-03-18 11:30:34','2016-03-18 11:30:34','莘县','371522','山东省聊城市莘县'),(1631,'2016-03-18 11:30:34','2016-03-18 11:30:34','茌平县','371523','山东省聊城市茌平县'),(1632,'2016-03-18 11:30:34','2016-03-18 11:30:34','东阿县','371524','山东省聊城市东阿县'),(1633,'2016-03-18 11:30:34','2016-03-18 11:30:34','冠县','371525','山东省聊城市冠县'),(1634,'2016-03-18 11:30:34','2016-03-18 11:30:34','高唐县','371526','山东省聊城市高唐县'),(1635,'2016-03-18 11:30:34','2016-03-18 11:30:34','临清市','371581','山东省聊城市临清市'),(1636,'2016-03-18 11:30:34','2016-03-18 11:30:34','滨州市','371600','山东省滨州市'),(1637,'2016-03-18 11:30:34','2016-03-18 11:30:34','市辖区','371601','山东省滨州市市辖区'),(1638,'2016-03-18 11:30:34','2016-03-18 11:30:34','滨城区','371602','山东省滨州市滨城区'),(1639,'2016-03-18 11:30:34','2016-03-18 11:30:34','沾化区','371603','山东省滨州市沾化区'),(1640,'2016-03-18 11:30:34','2016-03-18 11:30:34','惠民县','371621','山东省滨州市惠民县'),(1641,'2016-03-18 11:30:34','2016-03-18 11:30:34','阳信县','371622','山东省滨州市阳信县'),(1642,'2016-03-18 11:30:35','2016-03-18 11:30:35','无棣县','371623','山东省滨州市无棣县'),(1643,'2016-03-18 11:30:35','2016-03-18 11:30:35','博兴县','371625','山东省滨州市博兴县'),(1644,'2016-03-18 11:30:35','2016-03-18 11:30:35','邹平县','371626','山东省滨州市邹平县'),(1645,'2016-03-18 11:30:35','2016-03-18 11:30:35','菏泽市','371700','山东省菏泽市'),(1646,'2016-03-18 11:30:35','2016-03-18 11:30:35','市辖区','371701','山东省菏泽市市辖区'),(1647,'2016-03-18 11:30:35','2016-03-18 11:30:35','牡丹区','371702','山东省菏泽市牡丹区'),(1648,'2016-03-18 11:30:35','2016-03-18 11:30:35','曹县','371721','山东省菏泽市曹县'),(1649,'2016-03-18 11:30:35','2016-03-18 11:30:35','单县','371722','山东省菏泽市单县'),(1650,'2016-03-18 11:30:35','2016-03-18 11:30:35','成武县','371723','山东省菏泽市成武县'),(1651,'2016-03-18 11:30:35','2016-03-18 11:30:35','巨野县','371724','山东省菏泽市巨野县'),(1652,'2016-03-18 11:30:35','2016-03-18 11:30:35','郓城县','371725','山东省菏泽市郓城县'),(1653,'2016-03-18 11:30:35','2016-03-18 11:30:35','鄄城县','371726','山东省菏泽市鄄城县'),(1654,'2016-03-18 11:30:35','2016-03-18 11:30:35','定陶县','371727','山东省菏泽市定陶县'),(1655,'2016-03-18 11:30:35','2016-03-18 11:30:35','东明县','371728','山东省菏泽市东明县'),(1656,'2016-03-18 11:30:35','2016-03-18 11:30:35','河南省','410000','河南省'),(1657,'2016-03-18 11:30:35','2016-03-18 11:30:35','郑州市','410100','河南省郑州市'),(1658,'2016-03-18 11:30:36','2016-03-18 11:30:36','市辖区','410101','河南省郑州市市辖区'),(1659,'2016-03-18 11:30:36','2016-03-18 11:30:36','中原区','410102','河南省郑州市中原区'),(1660,'2016-03-18 11:30:36','2016-03-18 11:30:36','二七区','410103','河南省郑州市二七区'),(1661,'2016-03-18 11:30:36','2016-03-18 11:30:36','管城回族区','410104','河南省郑州市管城回族区'),(1662,'2016-03-18 11:30:36','2016-03-18 11:30:36','金水区','410105','河南省郑州市金水区'),(1663,'2016-03-18 11:30:36','2016-03-18 11:30:36','上街区','410106','河南省郑州市上街区'),(1664,'2016-03-18 11:30:36','2016-03-18 11:30:36','惠济区','410108','河南省郑州市惠济区'),(1665,'2016-03-18 11:30:36','2016-03-18 11:30:36','中牟县','410122','河南省郑州市中牟县'),(1666,'2016-03-18 11:30:36','2016-03-18 11:30:36','巩义市','410181','河南省郑州市巩义市'),(1667,'2016-03-18 11:30:36','2016-03-18 11:30:36','荥阳市','410182','河南省郑州市荥阳市'),(1668,'2016-03-18 11:30:36','2016-03-18 11:30:36','新密市','410183','河南省郑州市新密市'),(1669,'2016-03-18 11:30:36','2016-03-18 11:30:36','新郑市','410184','河南省郑州市新郑市'),(1670,'2016-03-18 11:30:36','2016-03-18 11:30:36','登封市','410185','河南省郑州市登封市'),(1671,'2016-03-18 11:30:36','2016-03-18 11:30:36','开封市','410200','河南省开封市'),(1672,'2016-03-18 11:30:37','2016-03-18 11:30:37','市辖区','410201','河南省开封市市辖区'),(1673,'2016-03-18 11:30:37','2016-03-18 11:30:37','龙亭区','410202','河南省开封市龙亭区'),(1674,'2016-03-18 11:30:37','2016-03-18 11:30:37','顺河回族区','410203','河南省开封市顺河回族区'),(1675,'2016-03-18 11:30:37','2016-03-18 11:30:37','鼓楼区','410204','河南省开封市鼓楼区'),(1676,'2016-03-18 11:30:37','2016-03-18 11:30:37','禹王台区','410205','河南省开封市禹王台区'),(1677,'2016-03-18 11:30:37','2016-03-18 11:30:37','金明区','410211','河南省开封市金明区'),(1678,'2016-03-18 11:30:37','2016-03-18 11:30:37','杞县','410221','河南省开封市杞县'),(1679,'2016-03-18 11:30:37','2016-03-18 11:30:37','通许县','410222','河南省开封市通许县'),(1680,'2016-03-18 11:30:37','2016-03-18 11:30:37','尉氏县','410223','河南省开封市尉氏县'),(1681,'2016-03-18 11:30:37','2016-03-18 11:30:37','开封县','410224','河南省开封市开封县'),(1682,'2016-03-18 11:30:37','2016-03-18 11:30:37','兰考县','410225','河南省开封市兰考县'),(1683,'2016-03-18 11:30:37','2016-03-18 11:30:37','洛阳市','410300','河南省洛阳市'),(1684,'2016-03-18 11:30:37','2016-03-18 11:30:37','市辖区','410301','河南省洛阳市市辖区'),(1685,'2016-03-18 11:30:37','2016-03-18 11:30:37','老城区','410302','河南省洛阳市老城区'),(1686,'2016-03-18 11:30:38','2016-03-18 11:30:38','西工区','410303','河南省洛阳市西工区'),(1687,'2016-03-18 11:30:38','2016-03-18 11:30:38','瀍河回族区','410304','河南省洛阳市瀍河回族区'),(1688,'2016-03-18 11:30:38','2016-03-18 11:30:38','涧西区','410305','河南省洛阳市涧西区'),(1689,'2016-03-18 11:30:38','2016-03-18 11:30:38','吉利区','410306','河南省洛阳市吉利区'),(1690,'2016-03-18 11:30:38','2016-03-18 11:30:38','洛龙区','410311','河南省洛阳市洛龙区'),(1691,'2016-03-18 11:30:38','2016-03-18 11:30:38','孟津县','410322','河南省洛阳市孟津县'),(1692,'2016-03-18 11:30:38','2016-03-18 11:30:38','新安县','410323','河南省洛阳市新安县'),(1693,'2016-03-18 11:30:38','2016-03-18 11:30:38','栾川县','410324','河南省洛阳市栾川县'),(1694,'2016-03-18 11:30:38','2016-03-18 11:30:38','嵩县','410325','河南省洛阳市嵩县'),(1695,'2016-03-18 11:30:38','2016-03-18 11:30:38','汝阳县','410326','河南省洛阳市汝阳县'),(1696,'2016-03-18 11:30:38','2016-03-18 11:30:38','宜阳县','410327','河南省洛阳市宜阳县'),(1697,'2016-03-18 11:30:38','2016-03-18 11:30:38','洛宁县','410328','河南省洛阳市洛宁县'),(1698,'2016-03-18 11:30:38','2016-03-18 11:30:38','伊川县','410329','河南省洛阳市伊川县'),(1699,'2016-03-18 11:30:38','2016-03-18 11:30:38','偃师市','410381','河南省洛阳市偃师市'),(1700,'2016-03-18 11:30:38','2016-03-18 11:30:38','平顶山市','410400','河南省平顶山市'),(1701,'2016-03-18 11:30:39','2016-03-18 11:30:39','市辖区','410401','河南省平顶山市市辖区'),(1702,'2016-03-18 11:30:39','2016-03-18 11:30:39','新华区','410402','河南省平顶山市新华区'),(1703,'2016-03-18 11:30:39','2016-03-18 11:30:39','卫东区','410403','河南省平顶山市卫东区'),(1704,'2016-03-18 11:30:39','2016-03-18 11:30:39','石龙区','410404','河南省平顶山市石龙区'),(1705,'2016-03-18 11:30:39','2016-03-18 11:30:39','湛河区','410411','河南省平顶山市湛河区'),(1706,'2016-03-18 11:30:39','2016-03-18 11:30:39','宝丰县','410421','河南省平顶山市宝丰县'),(1707,'2016-03-18 11:30:39','2016-03-18 11:30:39','叶县','410422','河南省平顶山市叶县'),(1708,'2016-03-18 11:30:39','2016-03-18 11:30:39','鲁山县','410423','河南省平顶山市鲁山县'),(1709,'2016-03-18 11:30:39','2016-03-18 11:30:39','郏县','410425','河南省平顶山市郏县'),(1710,'2016-03-18 11:30:39','2016-03-18 11:30:39','舞钢市','410481','河南省平顶山市舞钢市'),(1711,'2016-03-18 11:30:39','2016-03-18 11:30:39','汝州市','410482','河南省平顶山市汝州市'),(1712,'2016-03-18 11:30:39','2016-03-18 11:30:39','安阳市','410500','河南省安阳市'),(1713,'2016-03-18 11:30:39','2016-03-18 11:30:39','市辖区','410501','河南省安阳市市辖区'),(1714,'2016-03-18 11:30:40','2016-03-18 11:30:40','文峰区','410502','河南省安阳市文峰区'),(1715,'2016-03-18 11:30:40','2016-03-18 11:30:40','北关区','410503','河南省安阳市北关区'),(1716,'2016-03-18 11:30:40','2016-03-18 11:30:40','殷都区','410505','河南省安阳市殷都区'),(1717,'2016-03-18 11:30:40','2016-03-18 11:30:40','龙安区','410506','河南省安阳市龙安区'),(1718,'2016-03-18 11:30:40','2016-03-18 11:30:40','安阳县','410522','河南省安阳市安阳县'),(1719,'2016-03-18 11:30:40','2016-03-18 11:30:40','汤阴县','410523','河南省安阳市汤阴县'),(1720,'2016-03-18 11:30:40','2016-03-18 11:30:40','滑县','410526','河南省安阳市滑县'),(1721,'2016-03-18 11:30:40','2016-03-18 11:30:40','内黄县','410527','河南省安阳市内黄县'),(1722,'2016-03-18 11:30:40','2016-03-18 11:30:40','林州市','410581','河南省安阳市林州市'),(1723,'2016-03-18 11:30:40','2016-03-18 11:30:40','鹤壁市','410600','河南省鹤壁市'),(1724,'2016-03-18 11:30:40','2016-03-18 11:30:40','市辖区','410601','河南省鹤壁市市辖区'),(1725,'2016-03-18 11:30:40','2016-03-18 11:30:40','鹤山区','410602','河南省鹤壁市鹤山区'),(1726,'2016-03-18 11:30:41','2016-03-18 11:30:41','山城区','410603','河南省鹤壁市山城区'),(1727,'2016-03-18 11:30:41','2016-03-18 11:30:41','淇滨区','410611','河南省鹤壁市淇滨区'),(1728,'2016-03-18 11:30:41','2016-03-18 11:30:41','浚县','410621','河南省鹤壁市浚县'),(1729,'2016-03-18 11:30:41','2016-03-18 11:30:41','淇县','410622','河南省鹤壁市淇县'),(1730,'2016-03-18 11:30:41','2016-03-18 11:30:41','新乡市','410700','河南省新乡市'),(1731,'2016-03-18 11:30:41','2016-03-18 11:30:41','市辖区','410701','河南省新乡市市辖区'),(1732,'2016-03-18 11:30:41','2016-03-18 11:30:41','红旗区','410702','河南省新乡市红旗区'),(1733,'2016-03-18 11:30:41','2016-03-18 11:30:41','卫滨区','410703','河南省新乡市卫滨区'),(1734,'2016-03-18 11:30:41','2016-03-18 11:30:41','凤泉区','410704','河南省新乡市凤泉区'),(1735,'2016-03-18 11:30:41','2016-03-18 11:30:41','牧野区','410711','河南省新乡市牧野区'),(1736,'2016-03-18 11:30:41','2016-03-18 11:30:41','新乡县','410721','河南省新乡市新乡县'),(1737,'2016-03-18 11:30:41','2016-03-18 11:30:41','获嘉县','410724','河南省新乡市获嘉县'),(1738,'2016-03-18 11:30:42','2016-03-18 11:30:42','原阳县','410725','河南省新乡市原阳县'),(1739,'2016-03-18 11:30:42','2016-03-18 11:30:42','延津县','410726','河南省新乡市延津县'),(1740,'2016-03-18 11:30:42','2016-03-18 11:30:42','封丘县','410727','河南省新乡市封丘县'),(1741,'2016-03-18 11:30:42','2016-03-18 11:30:42','长垣县','410728','河南省新乡市长垣县'),(1742,'2016-03-18 11:30:42','2016-03-18 11:30:42','卫辉市','410781','河南省新乡市卫辉市'),(1743,'2016-03-18 11:30:42','2016-03-18 11:30:42','辉县市','410782','河南省新乡市辉县市'),(1744,'2016-03-18 11:30:42','2016-03-18 11:30:42','焦作市','410800','河南省焦作市'),(1745,'2016-03-18 11:30:42','2016-03-18 11:30:42','市辖区','410801','河南省焦作市市辖区'),(1746,'2016-03-18 11:30:42','2016-03-18 11:30:42','解放区','410802','河南省焦作市解放区'),(1747,'2016-03-18 11:30:42','2016-03-18 11:30:42','中站区','410803','河南省焦作市中站区'),(1748,'2016-03-18 11:30:42','2016-03-18 11:30:42','马村区','410804','河南省焦作市马村区'),(1749,'2016-03-18 11:30:42','2016-03-18 11:30:42','山阳区','410811','河南省焦作市山阳区'),(1750,'2016-03-18 11:30:42','2016-03-18 11:30:42','修武县','410821','河南省焦作市修武县'),(1751,'2016-03-18 11:30:43','2016-03-18 11:30:43','博爱县','410822','河南省焦作市博爱县'),(1752,'2016-03-18 11:30:43','2016-03-18 11:30:43','武陟县','410823','河南省焦作市武陟县'),(1753,'2016-03-18 11:30:43','2016-03-18 11:30:43','温县','410825','河南省焦作市温县'),(1754,'2016-03-18 11:30:43','2016-03-18 11:30:43','沁阳市','410882','河南省焦作市沁阳市'),(1755,'2016-03-18 11:30:43','2016-03-18 11:30:43','孟州市','410883','河南省焦作市孟州市'),(1756,'2016-03-18 11:30:43','2016-03-18 11:30:43','濮阳市','410900','河南省濮阳市'),(1757,'2016-03-18 11:30:43','2016-03-18 11:30:43','市辖区','410901','河南省濮阳市市辖区'),(1758,'2016-03-18 11:30:43','2016-03-18 11:30:43','华龙区','410902','河南省濮阳市华龙区'),(1759,'2016-03-18 11:30:43','2016-03-18 11:30:43','清丰县','410922','河南省濮阳市清丰县'),(1760,'2016-03-18 11:30:43','2016-03-18 11:30:43','南乐县','410923','河南省濮阳市南乐县'),(1761,'2016-03-18 11:30:43','2016-03-18 11:30:43','范县','410926','河南省濮阳市范县'),(1762,'2016-03-18 11:30:43','2016-03-18 11:30:43','台前县','410927','河南省濮阳市台前县'),(1763,'2016-03-18 11:30:44','2016-03-18 11:30:44','濮阳县','410928','河南省濮阳市濮阳县'),(1764,'2016-03-18 11:30:44','2016-03-18 11:30:44','许昌市','411000','河南省许昌市'),(1765,'2016-03-18 11:30:44','2016-03-18 11:30:44','市辖区','411001','河南省许昌市市辖区'),(1766,'2016-03-18 11:30:44','2016-03-18 11:30:44','魏都区','411002','河南省许昌市魏都区'),(1767,'2016-03-18 11:30:44','2016-03-18 11:30:44','许昌县','411023','河南省许昌市许昌县'),(1768,'2016-03-18 11:30:44','2016-03-18 11:30:44','鄢陵县','411024','河南省许昌市鄢陵县'),(1769,'2016-03-18 11:30:44','2016-03-18 11:30:44','襄城县','411025','河南省许昌市襄城县'),(1770,'2016-03-18 11:30:44','2016-03-18 11:30:44','禹州市','411081','河南省许昌市禹州市'),(1771,'2016-03-18 11:30:44','2016-03-18 11:30:44','长葛市','411082','河南省许昌市长葛市'),(1772,'2016-03-18 11:30:44','2016-03-18 11:30:44','漯河市','411100','河南省漯河市'),(1773,'2016-03-18 11:30:44','2016-03-18 11:30:44','市辖区','411101','河南省漯河市市辖区'),(1774,'2016-03-18 11:30:44','2016-03-18 11:30:44','源汇区','411102','河南省漯河市源汇区'),(1775,'2016-03-18 11:30:44','2016-03-18 11:30:44','郾城区','411103','河南省漯河市郾城区'),(1776,'2016-03-18 11:30:44','2016-03-18 11:30:44','召陵区','411104','河南省漯河市召陵区'),(1777,'2016-03-18 11:30:44','2016-03-18 11:30:44','舞阳县','411121','河南省漯河市舞阳县'),(1778,'2016-03-18 11:30:44','2016-03-18 11:30:44','临颍县','411122','河南省漯河市临颍县'),(1779,'2016-03-18 11:30:45','2016-03-18 11:30:45','三门峡市','411200','河南省三门峡市'),(1780,'2016-03-18 11:30:45','2016-03-18 11:30:45','市辖区','411201','河南省三门峡市市辖区'),(1781,'2016-03-18 11:30:45','2016-03-18 11:30:45','湖滨区','411202','河南省三门峡市湖滨区'),(1782,'2016-03-18 11:30:45','2016-03-18 11:30:45','渑池县','411221','河南省三门峡市渑池县'),(1783,'2016-03-18 11:30:45','2016-03-18 11:30:45','陕县','411222','河南省三门峡市陕县'),(1784,'2016-03-18 11:30:45','2016-03-18 11:30:45','卢氏县','411224','河南省三门峡市卢氏县'),(1785,'2016-03-18 11:30:45','2016-03-18 11:30:45','义马市','411281','河南省三门峡市义马市'),(1786,'2016-03-18 11:30:45','2016-03-18 11:30:45','灵宝市','411282','河南省三门峡市灵宝市'),(1787,'2016-03-18 11:30:45','2016-03-18 11:30:45','南阳市','411300','河南省南阳市'),(1788,'2016-03-18 11:30:45','2016-03-18 11:30:45','市辖区','411301','河南省南阳市市辖区'),(1789,'2016-03-18 11:30:45','2016-03-18 11:30:45','宛城区','411302','河南省南阳市宛城区'),(1790,'2016-03-18 11:30:45','2016-03-18 11:30:45','卧龙区','411303','河南省南阳市卧龙区'),(1791,'2016-03-18 11:30:45','2016-03-18 11:30:45','南召县','411321','河南省南阳市南召县'),(1792,'2016-03-18 11:30:45','2016-03-18 11:30:45','方城县','411322','河南省南阳市方城县'),(1793,'2016-03-18 11:30:45','2016-03-18 11:30:45','西峡县','411323','河南省南阳市西峡县'),(1794,'2016-03-18 11:30:45','2016-03-18 11:30:45','镇平县','411324','河南省南阳市镇平县'),(1795,'2016-03-18 11:30:45','2016-03-18 11:30:45','内乡县','411325','河南省南阳市内乡县'),(1796,'2016-03-18 11:30:45','2016-03-18 11:30:45','淅川县','411326','河南省南阳市淅川县'),(1797,'2016-03-18 11:30:46','2016-03-18 11:30:46','社旗县','411327','河南省南阳市社旗县'),(1798,'2016-03-18 11:30:46','2016-03-18 11:30:46','唐河县','411328','河南省南阳市唐河县'),(1799,'2016-03-18 11:30:46','2016-03-18 11:30:46','新野县','411329','河南省南阳市新野县'),(1800,'2016-03-18 11:30:46','2016-03-18 11:30:46','桐柏县','411330','河南省南阳市桐柏县'),(1801,'2016-03-18 11:30:46','2016-03-18 11:30:46','邓州市','411381','河南省南阳市邓州市'),(1802,'2016-03-18 11:30:46','2016-03-18 11:30:46','商丘市','411400','河南省商丘市'),(1803,'2016-03-18 11:30:46','2016-03-18 11:30:46','市辖区','411401','河南省商丘市市辖区'),(1804,'2016-03-18 11:30:46','2016-03-18 11:30:46','梁园区','411402','河南省商丘市梁园区'),(1805,'2016-03-18 11:30:46','2016-03-18 11:30:46','睢阳区','411403','河南省商丘市睢阳区'),(1806,'2016-03-18 11:30:46','2016-03-18 11:30:46','民权县','411421','河南省商丘市民权县'),(1807,'2016-03-18 11:30:46','2016-03-18 11:30:46','睢县','411422','河南省商丘市睢县'),(1808,'2016-03-18 11:30:46','2016-03-18 11:30:46','宁陵县','411423','河南省商丘市宁陵县'),(1809,'2016-03-18 11:30:46','2016-03-18 11:30:46','柘城县','411424','河南省商丘市柘城县'),(1810,'2016-03-18 11:30:46','2016-03-18 11:30:46','虞城县','411425','河南省商丘市虞城县'),(1811,'2016-03-18 11:30:46','2016-03-18 11:30:46','夏邑县','411426','河南省商丘市夏邑县'),(1812,'2016-03-18 11:30:46','2016-03-18 11:30:46','永城市','411481','河南省商丘市永城市'),(1813,'2016-03-18 11:30:46','2016-03-18 11:30:46','信阳市','411500','河南省信阳市'),(1814,'2016-03-18 11:30:47','2016-03-18 11:30:47','市辖区','411501','河南省信阳市市辖区'),(1815,'2016-03-18 11:30:47','2016-03-18 11:30:47','浉河区','411502','河南省信阳市浉河区'),(1816,'2016-03-18 11:30:47','2016-03-18 11:30:47','平桥区','411503','河南省信阳市平桥区'),(1817,'2016-03-18 11:30:47','2016-03-18 11:30:47','罗山县','411521','河南省信阳市罗山县'),(1818,'2016-03-18 11:30:47','2016-03-18 11:30:47','光山县','411522','河南省信阳市光山县'),(1819,'2016-03-18 11:30:47','2016-03-18 11:30:47','新县','411523','河南省信阳市新县'),(1820,'2016-03-18 11:30:47','2016-03-18 11:30:47','商城县','411524','河南省信阳市商城县'),(1821,'2016-03-18 11:30:47','2016-03-18 11:30:47','固始县','411525','河南省信阳市固始县'),(1822,'2016-03-18 11:30:47','2016-03-18 11:30:47','潢川县','411526','河南省信阳市潢川县'),(1823,'2016-03-18 11:30:47','2016-03-18 11:30:47','淮滨县','411527','河南省信阳市淮滨县'),(1824,'2016-03-18 11:30:47','2016-03-18 11:30:47','息县','411528','河南省信阳市息县'),(1825,'2016-03-18 11:30:47','2016-03-18 11:30:47','周口市','411600','河南省周口市'),(1826,'2016-03-18 11:30:47','2016-03-18 11:30:47','市辖区','411601','河南省周口市市辖区'),(1827,'2016-03-18 11:30:47','2016-03-18 11:30:47','川汇区','411602','河南省周口市川汇区'),(1828,'2016-03-18 11:30:47','2016-03-18 11:30:47','扶沟县','411621','河南省周口市扶沟县'),(1829,'2016-03-18 11:30:47','2016-03-18 11:30:47','西华县','411622','河南省周口市西华县'),(1830,'2016-03-18 11:30:47','2016-03-18 11:30:47','商水县','411623','河南省周口市商水县'),(1831,'2016-03-18 11:30:47','2016-03-18 11:30:47','沈丘县','411624','河南省周口市沈丘县'),(1832,'2016-03-18 11:30:48','2016-03-18 11:30:48','郸城县','411625','河南省周口市郸城县'),(1833,'2016-03-18 11:30:48','2016-03-18 11:30:48','淮阳县','411626','河南省周口市淮阳县'),(1834,'2016-03-18 11:30:48','2016-03-18 11:30:48','太康县','411627','河南省周口市太康县'),(1835,'2016-03-18 11:30:48','2016-03-18 11:30:48','鹿邑县','411628','河南省周口市鹿邑县'),(1836,'2016-03-18 11:30:48','2016-03-18 11:30:48','项城市','411681','河南省周口市项城市'),(1837,'2016-03-18 11:30:48','2016-03-18 11:30:48','驻马店市','411700','河南省驻马店市'),(1838,'2016-03-18 11:30:48','2016-03-18 11:30:48','市辖区','411701','河南省驻马店市市辖区'),(1839,'2016-03-18 11:30:48','2016-03-18 11:30:48','驿城区','411702','河南省驻马店市驿城区'),(1840,'2016-03-18 11:30:48','2016-03-18 11:30:48','西平县','411721','河南省驻马店市西平县'),(1841,'2016-03-18 11:30:48','2016-03-18 11:30:48','上蔡县','411722','河南省驻马店市上蔡县'),(1842,'2016-03-18 11:30:48','2016-03-18 11:30:48','平舆县','411723','河南省驻马店市平舆县'),(1843,'2016-03-18 11:30:48','2016-03-18 11:30:48','正阳县','411724','河南省驻马店市正阳县'),(1844,'2016-03-18 11:30:48','2016-03-18 11:30:48','确山县','411725','河南省驻马店市确山县'),(1845,'2016-03-18 11:30:48','2016-03-18 11:30:48','泌阳县','411726','河南省驻马店市泌阳县'),(1846,'2016-03-18 11:30:48','2016-03-18 11:30:48','汝南县','411727','河南省驻马店市汝南县'),(1847,'2016-03-18 11:30:48','2016-03-18 11:30:48','遂平县','411728','河南省驻马店市遂平县'),(1848,'2016-03-18 11:30:48','2016-03-18 11:30:48','新蔡县','411729','河南省驻马店市新蔡县'),(1849,'2016-03-18 11:30:48','2016-03-18 11:30:48','省直辖县级行政区划','419000','河南省省直辖县级行政区划'),(1850,'2016-03-18 11:30:49','2016-03-18 11:30:49','济源市','419001','河南省省直辖县级行政区划济源市'),(1851,'2016-03-18 11:30:49','2016-03-18 11:30:49','湖北省','420000','湖北省'),(1852,'2016-03-18 11:30:49','2016-03-18 11:30:49','武汉市','420100','湖北省武汉市'),(1853,'2016-03-18 11:30:49','2016-03-18 11:30:49','市辖区','420101','湖北省武汉市市辖区'),(1854,'2016-03-18 11:30:49','2016-03-18 11:30:49','江岸区','420102','湖北省武汉市江岸区'),(1855,'2016-03-18 11:30:49','2016-03-18 11:30:49','江汉区','420103','湖北省武汉市江汉区'),(1856,'2016-03-18 11:30:49','2016-03-18 11:30:49','硚口区','420104','湖北省武汉市硚口区'),(1857,'2016-03-18 11:30:49','2016-03-18 11:30:49','汉阳区','420105','湖北省武汉市汉阳区'),(1858,'2016-03-18 11:30:49','2016-03-18 11:30:49','武昌区','420106','湖北省武汉市武昌区'),(1859,'2016-03-18 11:30:49','2016-03-18 11:30:49','青山区','420107','湖北省武汉市青山区'),(1860,'2016-03-18 11:30:49','2016-03-18 11:30:49','洪山区','420111','湖北省武汉市洪山区'),(1861,'2016-03-18 11:30:49','2016-03-18 11:30:49','东西湖区','420112','湖北省武汉市东西湖区'),(1862,'2016-03-18 11:30:49','2016-03-18 11:30:49','汉南区','420113','湖北省武汉市汉南区'),(1863,'2016-03-18 11:30:49','2016-03-18 11:30:49','蔡甸区','420114','湖北省武汉市蔡甸区'),(1864,'2016-03-18 11:30:49','2016-03-18 11:30:49','江夏区','420115','湖北省武汉市江夏区'),(1865,'2016-03-18 11:30:50','2016-03-18 11:30:50','黄陂区','420116','湖北省武汉市黄陂区'),(1866,'2016-03-18 11:30:50','2016-03-18 11:30:50','新洲区','420117','湖北省武汉市新洲区'),(1867,'2016-03-18 11:30:50','2016-03-18 11:30:50','黄石市','420200','湖北省黄石市'),(1868,'2016-03-18 11:30:50','2016-03-18 11:30:50','市辖区','420201','湖北省黄石市市辖区'),(1869,'2016-03-18 11:30:50','2016-03-18 11:30:50','黄石港区','420202','湖北省黄石市黄石港区'),(1870,'2016-03-18 11:30:50','2016-03-18 11:30:50','西塞山区','420203','湖北省黄石市西塞山区'),(1871,'2016-03-18 11:30:50','2016-03-18 11:30:50','下陆区','420204','湖北省黄石市下陆区'),(1872,'2016-03-18 11:30:50','2016-03-18 11:30:50','铁山区','420205','湖北省黄石市铁山区'),(1873,'2016-03-18 11:30:50','2016-03-18 11:30:50','阳新县','420222','湖北省黄石市阳新县'),(1874,'2016-03-18 11:30:50','2016-03-18 11:30:50','大冶市','420281','湖北省黄石市大冶市'),(1875,'2016-03-18 11:30:50','2016-03-18 11:30:50','十堰市','420300','湖北省十堰市'),(1876,'2016-03-18 11:30:50','2016-03-18 11:30:50','市辖区','420301','湖北省十堰市市辖区'),(1877,'2016-03-18 11:30:50','2016-03-18 11:30:50','茅箭区','420302','湖北省十堰市茅箭区'),(1878,'2016-03-18 11:30:50','2016-03-18 11:30:50','张湾区','420303','湖北省十堰市张湾区'),(1879,'2016-03-18 11:30:50','2016-03-18 11:30:50','郧阳区','420304','湖北省十堰市郧阳区'),(1880,'2016-03-18 11:30:50','2016-03-18 11:30:50','郧西县','420322','湖北省十堰市郧西县'),(1881,'2016-03-18 11:30:50','2016-03-18 11:30:50','竹山县','420323','湖北省十堰市竹山县'),(1882,'2016-03-18 11:30:51','2016-03-18 11:30:51','竹溪县','420324','湖北省十堰市竹溪县'),(1883,'2016-03-18 11:30:51','2016-03-18 11:30:51','房县','420325','湖北省十堰市房县'),(1884,'2016-03-18 11:30:51','2016-03-18 11:30:51','丹江口市','420381','湖北省十堰市丹江口市'),(1885,'2016-03-18 11:30:51','2016-03-18 11:30:51','宜昌市','420500','湖北省宜昌市'),(1886,'2016-03-18 11:30:51','2016-03-18 11:30:51','市辖区','420501','湖北省宜昌市市辖区'),(1887,'2016-03-18 11:30:51','2016-03-18 11:30:51','西陵区','420502','湖北省宜昌市西陵区'),(1888,'2016-03-18 11:30:51','2016-03-18 11:30:51','伍家岗区','420503','湖北省宜昌市伍家岗区'),(1889,'2016-03-18 11:30:51','2016-03-18 11:30:51','点军区','420504','湖北省宜昌市点军区'),(1890,'2016-03-18 11:30:51','2016-03-18 11:30:51','猇亭区','420505','湖北省宜昌市猇亭区'),(1891,'2016-03-18 11:30:51','2016-03-18 11:30:51','夷陵区','420506','湖北省宜昌市夷陵区'),(1892,'2016-03-18 11:30:51','2016-03-18 11:30:51','远安县','420525','湖北省宜昌市远安县'),(1893,'2016-03-18 11:30:52','2016-03-18 11:30:52','兴山县','420526','湖北省宜昌市兴山县'),(1894,'2016-03-18 11:30:52','2016-03-18 11:30:52','秭归县','420527','湖北省宜昌市秭归县'),(1895,'2016-03-18 11:30:52','2016-03-18 11:30:52','长阳土家族自治县','420528','湖北省宜昌市长阳土家族自治县'),(1896,'2016-03-18 11:30:52','2016-03-18 11:30:52','五峰土家族自治县','420529','湖北省宜昌市五峰土家族自治县'),(1897,'2016-03-18 11:30:52','2016-03-18 11:30:52','宜都市','420581','湖北省宜昌市宜都市'),(1898,'2016-03-18 11:30:52','2016-03-18 11:30:52','当阳市','420582','湖北省宜昌市当阳市'),(1899,'2016-03-18 11:30:52','2016-03-18 11:30:52','枝江市','420583','湖北省宜昌市枝江市'),(1900,'2016-03-18 11:30:52','2016-03-18 11:30:52','襄阳市','420600','湖北省襄阳市'),(1901,'2016-03-18 11:30:52','2016-03-18 11:30:52','市辖区','420601','湖北省襄阳市市辖区'),(1902,'2016-03-18 11:30:52','2016-03-18 11:30:52','襄城区','420602','湖北省襄阳市襄城区'),(1903,'2016-03-18 11:30:52','2016-03-18 11:30:52','樊城区','420606','湖北省襄阳市樊城区'),(1904,'2016-03-18 11:30:52','2016-03-18 11:30:52','襄州区','420607','湖北省襄阳市襄州区'),(1905,'2016-03-18 11:30:52','2016-03-18 11:30:52','南漳县','420624','湖北省襄阳市南漳县'),(1906,'2016-03-18 11:30:52','2016-03-18 11:30:52','谷城县','420625','湖北省襄阳市谷城县'),(1907,'2016-03-18 11:30:53','2016-03-18 11:30:53','保康县','420626','湖北省襄阳市保康县'),(1908,'2016-03-18 11:30:53','2016-03-18 11:30:53','老河口市','420682','湖北省襄阳市老河口市'),(1909,'2016-03-18 11:30:53','2016-03-18 11:30:53','枣阳市','420683','湖北省襄阳市枣阳市'),(1910,'2016-03-18 11:30:53','2016-03-18 11:30:53','宜城市','420684','湖北省襄阳市宜城市'),(1911,'2016-03-18 11:30:53','2016-03-18 11:30:53','鄂州市','420700','湖北省鄂州市'),(1912,'2016-03-18 11:30:53','2016-03-18 11:30:53','市辖区','420701','湖北省鄂州市市辖区'),(1913,'2016-03-18 11:30:53','2016-03-18 11:30:53','梁子湖区','420702','湖北省鄂州市梁子湖区'),(1914,'2016-03-18 11:30:53','2016-03-18 11:30:53','华容区','420703','湖北省鄂州市华容区'),(1915,'2016-03-18 11:30:53','2016-03-18 11:30:53','鄂城区','420704','湖北省鄂州市鄂城区'),(1916,'2016-03-18 11:30:53','2016-03-18 11:30:53','荆门市','420800','湖北省荆门市'),(1917,'2016-03-18 11:30:53','2016-03-18 11:30:53','市辖区','420801','湖北省荆门市市辖区'),(1918,'2016-03-18 11:30:53','2016-03-18 11:30:53','东宝区','420802','湖北省荆门市东宝区'),(1919,'2016-03-18 11:30:54','2016-03-18 11:30:54','掇刀区','420804','湖北省荆门市掇刀区'),(1920,'2016-03-18 11:30:54','2016-03-18 11:30:54','京山县','420821','湖北省荆门市京山县'),(1921,'2016-03-18 11:30:54','2016-03-18 11:30:54','沙洋县','420822','湖北省荆门市沙洋县'),(1922,'2016-03-18 11:30:54','2016-03-18 11:30:54','钟祥市','420881','湖北省荆门市钟祥市'),(1923,'2016-03-18 11:30:54','2016-03-18 11:30:54','孝感市','420900','湖北省孝感市'),(1924,'2016-03-18 11:30:54','2016-03-18 11:30:54','市辖区','420901','湖北省孝感市市辖区'),(1925,'2016-03-18 11:30:54','2016-03-18 11:30:54','孝南区','420902','湖北省孝感市孝南区'),(1926,'2016-03-18 11:30:54','2016-03-18 11:30:54','孝昌县','420921','湖北省孝感市孝昌县'),(1927,'2016-03-18 11:30:54','2016-03-18 11:30:54','大悟县','420922','湖北省孝感市大悟县'),(1928,'2016-03-18 11:30:54','2016-03-18 11:30:54','云梦县','420923','湖北省孝感市云梦县'),(1929,'2016-03-18 11:30:54','2016-03-18 11:30:54','应城市','420981','湖北省孝感市应城市'),(1930,'2016-03-18 11:30:54','2016-03-18 11:30:54','安陆市','420982','湖北省孝感市安陆市'),(1931,'2016-03-18 11:30:55','2016-03-18 11:30:55','汉川市','420984','湖北省孝感市汉川市'),(1932,'2016-03-18 11:30:55','2016-03-18 11:30:55','荆州市','421000','湖北省荆州市'),(1933,'2016-03-18 11:30:55','2016-03-18 11:30:55','市辖区','421001','湖北省荆州市市辖区'),(1934,'2016-03-18 11:30:55','2016-03-18 11:30:55','沙市区','421002','湖北省荆州市沙市区'),(1935,'2016-03-18 11:30:55','2016-03-18 11:30:55','荆州区','421003','湖北省荆州市荆州区'),(1936,'2016-03-18 11:30:55','2016-03-18 11:30:55','公安县','421022','湖北省荆州市公安县'),(1937,'2016-03-18 11:30:55','2016-03-18 11:30:55','监利县','421023','湖北省荆州市监利县'),(1938,'2016-03-18 11:30:55','2016-03-18 11:30:55','江陵县','421024','湖北省荆州市江陵县'),(1939,'2016-03-18 11:30:55','2016-03-18 11:30:55','石首市','421081','湖北省荆州市石首市'),(1940,'2016-03-18 11:30:55','2016-03-18 11:30:55','洪湖市','421083','湖北省荆州市洪湖市'),(1941,'2016-03-18 11:30:55','2016-03-18 11:30:55','松滋市','421087','湖北省荆州市松滋市'),(1942,'2016-03-18 11:30:55','2016-03-18 11:30:55','黄冈市','421100','湖北省黄冈市'),(1943,'2016-03-18 11:30:55','2016-03-18 11:30:55','市辖区','421101','湖北省黄冈市市辖区'),(1944,'2016-03-18 11:30:55','2016-03-18 11:30:55','黄州区','421102','湖北省黄冈市黄州区'),(1945,'2016-03-18 11:30:56','2016-03-18 11:30:56','团风县','421121','湖北省黄冈市团风县'),(1946,'2016-03-18 11:30:56','2016-03-18 11:30:56','红安县','421122','湖北省黄冈市红安县'),(1947,'2016-03-18 11:30:56','2016-03-18 11:30:56','罗田县','421123','湖北省黄冈市罗田县'),(1948,'2016-03-18 11:30:56','2016-03-18 11:30:56','英山县','421124','湖北省黄冈市英山县'),(1949,'2016-03-18 11:30:56','2016-03-18 11:30:56','浠水县','421125','湖北省黄冈市浠水县'),(1950,'2016-03-18 11:30:56','2016-03-18 11:30:56','蕲春县','421126','湖北省黄冈市蕲春县'),(1951,'2016-03-18 11:30:56','2016-03-18 11:30:56','黄梅县','421127','湖北省黄冈市黄梅县'),(1952,'2016-03-18 11:30:56','2016-03-18 11:30:56','麻城市','421181','湖北省黄冈市麻城市'),(1953,'2016-03-18 11:30:56','2016-03-18 11:30:56','武穴市','421182','湖北省黄冈市武穴市'),(1954,'2016-03-18 11:30:56','2016-03-18 11:30:56','咸宁市','421200','湖北省咸宁市'),(1955,'2016-03-18 11:30:56','2016-03-18 11:30:56','市辖区','421201','湖北省咸宁市市辖区'),(1956,'2016-03-18 11:30:56','2016-03-18 11:30:56','咸安区','421202','湖北省咸宁市咸安区'),(1957,'2016-03-18 11:30:57','2016-03-18 11:30:57','嘉鱼县','421221','湖北省咸宁市嘉鱼县'),(1958,'2016-03-18 11:30:57','2016-03-18 11:30:57','通城县','421222','湖北省咸宁市通城县'),(1959,'2016-03-18 11:30:57','2016-03-18 11:30:57','崇阳县','421223','湖北省咸宁市崇阳县'),(1960,'2016-03-18 11:30:57','2016-03-18 11:30:57','通山县','421224','湖北省咸宁市通山县'),(1961,'2016-03-18 11:30:57','2016-03-18 11:30:57','赤壁市','421281','湖北省咸宁市赤壁市'),(1962,'2016-03-18 11:30:57','2016-03-18 11:30:57','随州市','421300','湖北省随州市'),(1963,'2016-03-18 11:30:57','2016-03-18 11:30:57','市辖区','421301','湖北省随州市市辖区'),(1964,'2016-03-18 11:30:57','2016-03-18 11:30:57','曾都区','421303','湖北省随州市曾都区'),(1965,'2016-03-18 11:30:57','2016-03-18 11:30:57','随县','421321','湖北省随州市随县'),(1966,'2016-03-18 11:30:57','2016-03-18 11:30:57','广水市','421381','湖北省随州市广水市'),(1967,'2016-03-18 11:30:57','2016-03-18 11:30:57','恩施土家族苗族自治州','422800','湖北省恩施土家族苗族自治州'),(1968,'2016-03-18 11:30:57','2016-03-18 11:30:57','恩施市','422801','湖北省恩施土家族苗族自治州恩施市'),(1969,'2016-03-18 11:30:57','2016-03-18 11:30:57','利川市','422802','湖北省恩施土家族苗族自治州利川市'),(1970,'2016-03-18 11:30:58','2016-03-18 11:30:58','建始县','422822','湖北省恩施土家族苗族自治州建始县'),(1971,'2016-03-18 11:30:58','2016-03-18 11:30:58','巴东县','422823','湖北省恩施土家族苗族自治州巴东县'),(1972,'2016-03-18 11:30:58','2016-03-18 11:30:58','宣恩县','422825','湖北省恩施土家族苗族自治州宣恩县'),(1973,'2016-03-18 11:30:58','2016-03-18 11:30:58','咸丰县','422826','湖北省恩施土家族苗族自治州咸丰县'),(1974,'2016-03-18 11:30:58','2016-03-18 11:30:58','来凤县','422827','湖北省恩施土家族苗族自治州来凤县'),(1975,'2016-03-18 11:30:58','2016-03-18 11:30:58','鹤峰县','422828','湖北省恩施土家族苗族自治州鹤峰县'),(1976,'2016-03-18 11:30:58','2016-03-18 11:30:58','省直辖县级行政区划','429000','湖北省省直辖县级行政区划'),(1977,'2016-03-18 11:30:58','2016-03-18 11:30:58','仙桃市','429004','湖北省省直辖县级行政区划仙桃市'),(1978,'2016-03-18 11:30:58','2016-03-18 11:30:58','潜江市','429005','湖北省省直辖县级行政区划潜江市'),(1979,'2016-03-18 11:30:58','2016-03-18 11:30:58','天门市','429006','湖北省省直辖县级行政区划天门市'),(1980,'2016-03-18 11:30:58','2016-03-18 11:30:58','神农架林区','429021','湖北省省直辖县级行政区划神农架林区'),(1981,'2016-03-18 11:30:58','2016-03-18 11:30:58','湖南省','430000','湖南省'),(1982,'2016-03-18 11:30:59','2016-03-18 11:30:59','长沙市','430100','湖南省长沙市'),(1983,'2016-03-18 11:30:59','2016-03-18 11:30:59','市辖区','430101','湖南省长沙市市辖区'),(1984,'2016-03-18 11:30:59','2016-03-18 11:30:59','芙蓉区','430102','湖南省长沙市芙蓉区'),(1985,'2016-03-18 11:30:59','2016-03-18 11:30:59','天心区','430103','湖南省长沙市天心区'),(1986,'2016-03-18 11:30:59','2016-03-18 11:30:59','岳麓区','430104','湖南省长沙市岳麓区'),(1987,'2016-03-18 11:30:59','2016-03-18 11:30:59','开福区','430105','湖南省长沙市开福区'),(1988,'2016-03-18 11:30:59','2016-03-18 11:30:59','雨花区','430111','湖南省长沙市雨花区'),(1989,'2016-03-18 11:30:59','2016-03-18 11:30:59','望城区','430112','湖南省长沙市望城区'),(1990,'2016-03-18 11:30:59','2016-03-18 11:30:59','长沙县','430121','湖南省长沙市长沙县'),(1991,'2016-03-18 11:30:59','2016-03-18 11:30:59','宁乡县','430124','湖南省长沙市宁乡县'),(1992,'2016-03-18 11:30:59','2016-03-18 11:30:59','浏阳市','430181','湖南省长沙市浏阳市'),(1993,'2016-03-18 11:30:59','2016-03-18 11:30:59','株洲市','430200','湖南省株洲市'),(1994,'2016-03-18 11:31:00','2016-03-18 11:31:00','市辖区','430201','湖南省株洲市市辖区'),(1995,'2016-03-18 11:31:00','2016-03-18 11:31:00','荷塘区','430202','湖南省株洲市荷塘区'),(1996,'2016-03-18 11:31:00','2016-03-18 11:31:00','芦淞区','430203','湖南省株洲市芦淞区'),(1997,'2016-03-18 11:31:00','2016-03-18 11:31:00','石峰区','430204','湖南省株洲市石峰区'),(1998,'2016-03-18 11:31:00','2016-03-18 11:31:00','天元区','430211','湖南省株洲市天元区'),(1999,'2016-03-18 11:31:00','2016-03-18 11:31:00','株洲县','430221','湖南省株洲市株洲县'),(2000,'2016-03-18 11:31:00','2016-03-18 11:31:00','攸县','430223','湖南省株洲市攸县'),(2001,'2016-03-18 11:31:00','2016-03-18 11:31:00','茶陵县','430224','湖南省株洲市茶陵县'),(2002,'2016-03-18 11:31:00','2016-03-18 11:31:00','炎陵县','430225','湖南省株洲市炎陵县'),(2003,'2016-03-18 11:31:00','2016-03-18 11:31:00','醴陵市','430281','湖南省株洲市醴陵市'),(2004,'2016-03-18 11:31:00','2016-03-18 11:31:00','湘潭市','430300','湖南省湘潭市'),(2005,'2016-03-18 11:31:00','2016-03-18 11:31:00','市辖区','430301','湖南省湘潭市市辖区'),(2006,'2016-03-18 11:31:01','2016-03-18 11:31:01','雨湖区','430302','湖南省湘潭市雨湖区'),(2007,'2016-03-18 11:31:01','2016-03-18 11:31:01','岳塘区','430304','湖南省湘潭市岳塘区'),(2008,'2016-03-18 11:31:01','2016-03-18 11:31:01','湘潭县','430321','湖南省湘潭市湘潭县'),(2009,'2016-03-18 11:31:01','2016-03-18 11:31:01','湘乡市','430381','湖南省湘潭市湘乡市'),(2010,'2016-03-18 11:31:01','2016-03-18 11:31:01','韶山市','430382','湖南省湘潭市韶山市'),(2011,'2016-03-18 11:31:01','2016-03-18 11:31:01','衡阳市','430400','湖南省衡阳市'),(2012,'2016-03-18 11:31:01','2016-03-18 11:31:01','市辖区','430401','湖南省衡阳市市辖区'),(2013,'2016-03-18 11:31:01','2016-03-18 11:31:01','珠晖区','430405','湖南省衡阳市珠晖区'),(2014,'2016-03-18 11:31:01','2016-03-18 11:31:01','雁峰区','430406','湖南省衡阳市雁峰区'),(2015,'2016-03-18 11:31:01','2016-03-18 11:31:01','石鼓区','430407','湖南省衡阳市石鼓区'),(2016,'2016-03-18 11:31:01','2016-03-18 11:31:01','蒸湘区','430408','湖南省衡阳市蒸湘区'),(2017,'2016-03-18 11:31:01','2016-03-18 11:31:01','南岳区','430412','湖南省衡阳市南岳区'),(2018,'2016-03-18 11:31:01','2016-03-18 11:31:01','衡阳县','430421','湖南省衡阳市衡阳县'),(2019,'2016-03-18 11:31:01','2016-03-18 11:31:01','衡南县','430422','湖南省衡阳市衡南县'),(2020,'2016-03-18 11:31:02','2016-03-18 11:31:02','衡山县','430423','湖南省衡阳市衡山县'),(2021,'2016-03-18 11:31:02','2016-03-18 11:31:02','衡东县','430424','湖南省衡阳市衡东县'),(2022,'2016-03-18 11:31:02','2016-03-18 11:31:02','祁东县','430426','湖南省衡阳市祁东县'),(2023,'2016-03-18 11:31:02','2016-03-18 11:31:02','耒阳市','430481','湖南省衡阳市耒阳市'),(2024,'2016-03-18 11:31:02','2016-03-18 11:31:02','常宁市','430482','湖南省衡阳市常宁市'),(2025,'2016-03-18 11:31:02','2016-03-18 11:31:02','邵阳市','430500','湖南省邵阳市'),(2026,'2016-03-18 11:31:02','2016-03-18 11:31:02','市辖区','430501','湖南省邵阳市市辖区'),(2027,'2016-03-18 11:31:02','2016-03-18 11:31:02','双清区','430502','湖南省邵阳市双清区'),(2028,'2016-03-18 11:31:02','2016-03-18 11:31:02','大祥区','430503','湖南省邵阳市大祥区'),(2029,'2016-03-18 11:31:02','2016-03-18 11:31:02','北塔区','430511','湖南省邵阳市北塔区'),(2030,'2016-03-18 11:31:02','2016-03-18 11:31:02','邵东县','430521','湖南省邵阳市邵东县'),(2031,'2016-03-18 11:31:02','2016-03-18 11:31:02','新邵县','430522','湖南省邵阳市新邵县'),(2032,'2016-03-18 11:31:02','2016-03-18 11:31:02','邵阳县','430523','湖南省邵阳市邵阳县'),(2033,'2016-03-18 11:31:02','2016-03-18 11:31:02','隆回县','430524','湖南省邵阳市隆回县'),(2034,'2016-03-18 11:31:02','2016-03-18 11:31:02','洞口县','430525','湖南省邵阳市洞口县'),(2035,'2016-03-18 11:31:02','2016-03-18 11:31:02','绥宁县','430527','湖南省邵阳市绥宁县'),(2036,'2016-03-18 11:31:03','2016-03-18 11:31:03','新宁县','430528','湖南省邵阳市新宁县'),(2037,'2016-03-18 11:31:03','2016-03-18 11:31:03','城步苗族自治县','430529','湖南省邵阳市城步苗族自治县'),(2038,'2016-03-18 11:31:03','2016-03-18 11:31:03','武冈市','430581','湖南省邵阳市武冈市'),(2039,'2016-03-18 11:31:03','2016-03-18 11:31:03','岳阳市','430600','湖南省岳阳市'),(2040,'2016-03-18 11:31:03','2016-03-18 11:31:03','市辖区','430601','湖南省岳阳市市辖区'),(2041,'2016-03-18 11:31:03','2016-03-18 11:31:03','岳阳楼区','430602','湖南省岳阳市岳阳楼区'),(2042,'2016-03-18 11:31:03','2016-03-18 11:31:03','云溪区','430603','湖南省岳阳市云溪区'),(2043,'2016-03-18 11:31:03','2016-03-18 11:31:03','君山区','430611','湖南省岳阳市君山区'),(2044,'2016-03-18 11:31:03','2016-03-18 11:31:03','岳阳县','430621','湖南省岳阳市岳阳县'),(2045,'2016-03-18 11:31:03','2016-03-18 11:31:03','华容县','430623','湖南省岳阳市华容县'),(2046,'2016-03-18 11:31:03','2016-03-18 11:31:03','湘阴县','430624','湖南省岳阳市湘阴县'),(2047,'2016-03-18 11:31:03','2016-03-18 11:31:03','平江县','430626','湖南省岳阳市平江县'),(2048,'2016-03-18 11:31:04','2016-03-18 11:31:04','汨罗市','430681','湖南省岳阳市汨罗市'),(2049,'2016-03-18 11:31:04','2016-03-18 11:31:04','临湘市','430682','湖南省岳阳市临湘市'),(2050,'2016-03-18 11:31:04','2016-03-18 11:31:04','常德市','430700','湖南省常德市'),(2051,'2016-03-18 11:31:04','2016-03-18 11:31:04','市辖区','430701','湖南省常德市市辖区'),(2052,'2016-03-18 11:31:04','2016-03-18 11:31:04','武陵区','430702','湖南省常德市武陵区'),(2053,'2016-03-18 11:31:04','2016-03-18 11:31:04','鼎城区','430703','湖南省常德市鼎城区'),(2054,'2016-03-18 11:31:04','2016-03-18 11:31:04','安乡县','430721','湖南省常德市安乡县'),(2055,'2016-03-18 11:31:04','2016-03-18 11:31:04','汉寿县','430722','湖南省常德市汉寿县'),(2056,'2016-03-18 11:31:04','2016-03-18 11:31:04','澧县','430723','湖南省常德市澧县'),(2057,'2016-03-18 11:31:04','2016-03-18 11:31:04','临澧县','430724','湖南省常德市临澧县'),(2058,'2016-03-18 11:31:04','2016-03-18 11:31:04','桃源县','430725','湖南省常德市桃源县'),(2059,'2016-03-18 11:31:05','2016-03-18 11:31:05','石门县','430726','湖南省常德市石门县'),(2060,'2016-03-18 11:31:05','2016-03-18 11:31:05','津市市','430781','湖南省常德市津市市'),(2061,'2016-03-18 11:31:05','2016-03-18 11:31:05','张家界市','430800','湖南省张家界市'),(2062,'2016-03-18 11:31:05','2016-03-18 11:31:05','市辖区','430801','湖南省张家界市市辖区'),(2063,'2016-03-18 11:31:05','2016-03-18 11:31:05','永定区','430802','湖南省张家界市永定区'),(2064,'2016-03-18 11:31:05','2016-03-18 11:31:05','武陵源区','430811','湖南省张家界市武陵源区'),(2065,'2016-03-18 11:31:05','2016-03-18 11:31:05','慈利县','430821','湖南省张家界市慈利县'),(2066,'2016-03-18 11:31:05','2016-03-18 11:31:05','桑植县','430822','湖南省张家界市桑植县'),(2067,'2016-03-18 11:31:05','2016-03-18 11:31:05','益阳市','430900','湖南省益阳市'),(2068,'2016-03-18 11:31:05','2016-03-18 11:31:05','市辖区','430901','湖南省益阳市市辖区'),(2069,'2016-03-18 11:31:05','2016-03-18 11:31:05','资阳区','430902','湖南省益阳市资阳区'),(2070,'2016-03-18 11:31:06','2016-03-18 11:31:06','赫山区','430903','湖南省益阳市赫山区'),(2071,'2016-03-18 11:31:06','2016-03-18 11:31:06','南县','430921','湖南省益阳市南县'),(2072,'2016-03-18 11:31:06','2016-03-18 11:31:06','桃江县','430922','湖南省益阳市桃江县'),(2073,'2016-03-18 11:31:06','2016-03-18 11:31:06','安化县','430923','湖南省益阳市安化县'),(2074,'2016-03-18 11:31:06','2016-03-18 11:31:06','沅江市','430981','湖南省益阳市沅江市'),(2075,'2016-03-18 11:31:06','2016-03-18 11:31:06','郴州市','431000','湖南省郴州市'),(2076,'2016-03-18 11:31:06','2016-03-18 11:31:06','市辖区','431001','湖南省郴州市市辖区'),(2077,'2016-03-18 11:31:06','2016-03-18 11:31:06','北湖区','431002','湖南省郴州市北湖区'),(2078,'2016-03-18 11:31:06','2016-03-18 11:31:06','苏仙区','431003','湖南省郴州市苏仙区'),(2079,'2016-03-18 11:31:06','2016-03-18 11:31:06','桂阳县','431021','湖南省郴州市桂阳县'),(2080,'2016-03-18 11:31:07','2016-03-18 11:31:07','宜章县','431022','湖南省郴州市宜章县'),(2081,'2016-03-18 11:31:07','2016-03-18 11:31:07','永兴县','431023','湖南省郴州市永兴县'),(2082,'2016-03-18 11:31:07','2016-03-18 11:31:07','嘉禾县','431024','湖南省郴州市嘉禾县'),(2083,'2016-03-18 11:31:07','2016-03-18 11:31:07','临武县','431025','湖南省郴州市临武县'),(2084,'2016-03-18 11:31:07','2016-03-18 11:31:07','汝城县','431026','湖南省郴州市汝城县'),(2085,'2016-03-18 11:31:07','2016-03-18 11:31:07','桂东县','431027','湖南省郴州市桂东县'),(2086,'2016-03-18 11:31:07','2016-03-18 11:31:07','安仁县','431028','湖南省郴州市安仁县'),(2087,'2016-03-18 11:31:07','2016-03-18 11:31:07','资兴市','431081','湖南省郴州市资兴市'),(2088,'2016-03-18 11:31:07','2016-03-18 11:31:07','永州市','431100','湖南省永州市'),(2089,'2016-03-18 11:31:07','2016-03-18 11:31:07','市辖区','431101','湖南省永州市市辖区'),(2090,'2016-03-18 11:31:07','2016-03-18 11:31:07','零陵区','431102','湖南省永州市零陵区'),(2091,'2016-03-18 11:31:07','2016-03-18 11:31:07','冷水滩区','431103','湖南省永州市冷水滩区'),(2092,'2016-03-18 11:31:07','2016-03-18 11:31:07','祁阳县','431121','湖南省永州市祁阳县'),(2093,'2016-03-18 11:31:08','2016-03-18 11:31:08','东安县','431122','湖南省永州市东安县'),(2094,'2016-03-18 11:31:08','2016-03-18 11:31:08','双牌县','431123','湖南省永州市双牌县'),(2095,'2016-03-18 11:31:08','2016-03-18 11:31:08','道县','431124','湖南省永州市道县'),(2096,'2016-03-18 11:31:08','2016-03-18 11:31:08','江永县','431125','湖南省永州市江永县'),(2097,'2016-03-18 11:31:08','2016-03-18 11:31:08','宁远县','431126','湖南省永州市宁远县'),(2098,'2016-03-18 11:31:08','2016-03-18 11:31:08','蓝山县','431127','湖南省永州市蓝山县'),(2099,'2016-03-18 11:31:08','2016-03-18 11:31:08','新田县','431128','湖南省永州市新田县'),(2100,'2016-03-18 11:31:08','2016-03-18 11:31:08','江华瑶族自治县','431129','湖南省永州市江华瑶族自治县'),(2101,'2016-03-18 11:31:08','2016-03-18 11:31:08','怀化市','431200','湖南省怀化市'),(2102,'2016-03-18 11:31:08','2016-03-18 11:31:08','市辖区','431201','湖南省怀化市市辖区'),(2103,'2016-03-18 11:31:08','2016-03-18 11:31:08','鹤城区','431202','湖南省怀化市鹤城区'),(2104,'2016-03-18 11:31:08','2016-03-18 11:31:08','中方县','431221','湖南省怀化市中方县'),(2105,'2016-03-18 11:31:08','2016-03-18 11:31:08','沅陵县','431222','湖南省怀化市沅陵县'),(2106,'2016-03-18 11:31:08','2016-03-18 11:31:08','辰溪县','431223','湖南省怀化市辰溪县'),(2107,'2016-03-18 11:31:08','2016-03-18 11:31:08','溆浦县','431224','湖南省怀化市溆浦县'),(2108,'2016-03-18 11:31:09','2016-03-18 11:31:09','会同县','431225','湖南省怀化市会同县'),(2109,'2016-03-18 11:31:09','2016-03-18 11:31:09','麻阳苗族自治县','431226','湖南省怀化市麻阳苗族自治县'),(2110,'2016-03-18 11:31:09','2016-03-18 11:31:09','新晃侗族自治县','431227','湖南省怀化市新晃侗族自治县'),(2111,'2016-03-18 11:31:09','2016-03-18 11:31:09','芷江侗族自治县','431228','湖南省怀化市芷江侗族自治县'),(2112,'2016-03-18 11:31:09','2016-03-18 11:31:09','靖州苗族侗族自治县','431229','湖南省怀化市靖州苗族侗族自治县'),(2113,'2016-03-18 11:31:09','2016-03-18 11:31:09','通道侗族自治县','431230','湖南省怀化市通道侗族自治县'),(2114,'2016-03-18 11:31:09','2016-03-18 11:31:09','洪江市','431281','湖南省怀化市洪江市'),(2115,'2016-03-18 11:31:09','2016-03-18 11:31:09','娄底市','431300','湖南省娄底市'),(2116,'2016-03-18 11:31:09','2016-03-18 11:31:09','市辖区','431301','湖南省娄底市市辖区'),(2117,'2016-03-18 11:31:09','2016-03-18 11:31:09','娄星区','431302','湖南省娄底市娄星区'),(2118,'2016-03-18 11:31:09','2016-03-18 11:31:09','双峰县','431321','湖南省娄底市双峰县'),(2119,'2016-03-18 11:31:09','2016-03-18 11:31:09','新化县','431322','湖南省娄底市新化县'),(2120,'2016-03-18 11:31:09','2016-03-18 11:31:09','冷水江市','431381','湖南省娄底市冷水江市'),(2121,'2016-03-18 11:31:09','2016-03-18 11:31:09','涟源市','431382','湖南省娄底市涟源市'),(2122,'2016-03-18 11:31:09','2016-03-18 11:31:09','湘西土家族苗族自治州','433100','湖南省湘西土家族苗族自治州'),(2123,'2016-03-18 11:31:09','2016-03-18 11:31:09','吉首市','433101','湖南省湘西土家族苗族自治州吉首市'),(2124,'2016-03-18 11:31:09','2016-03-18 11:31:09','泸溪县','433122','湖南省湘西土家族苗族自治州泸溪县'),(2125,'2016-03-18 11:31:09','2016-03-18 11:31:09','凤凰县','433123','湖南省湘西土家族苗族自治州凤凰县'),(2126,'2016-03-18 11:31:09','2016-03-18 11:31:09','花垣县','433124','湖南省湘西土家族苗族自治州花垣县'),(2127,'2016-03-18 11:31:09','2016-03-18 11:31:09','保靖县','433125','湖南省湘西土家族苗族自治州保靖县'),(2128,'2016-03-18 11:31:10','2016-03-18 11:31:10','古丈县','433126','湖南省湘西土家族苗族自治州古丈县'),(2129,'2016-03-18 11:31:10','2016-03-18 11:31:10','永顺县','433127','湖南省湘西土家族苗族自治州永顺县'),(2130,'2016-03-18 11:31:10','2016-03-18 11:31:10','龙山县','433130','湖南省湘西土家族苗族自治州龙山县'),(2131,'2016-03-18 11:31:10','2016-03-18 11:31:10','广东省','440000','广东省'),(2132,'2016-03-18 11:31:10','2016-03-18 11:31:10','广州市','440100','广东省广州市'),(2133,'2016-03-18 11:31:10','2016-03-18 11:31:10','市辖区','440101','广东省广州市市辖区'),(2134,'2016-03-18 11:31:10','2016-03-18 11:31:10','荔湾区','440103','广东省广州市荔湾区'),(2135,'2016-03-18 11:31:10','2016-03-18 11:31:10','越秀区','440104','广东省广州市越秀区'),(2136,'2016-03-18 11:31:10','2016-03-18 11:31:10','海珠区','440105','广东省广州市海珠区'),(2137,'2016-03-18 11:31:10','2016-03-18 11:31:10','天河区','440106','广东省广州市天河区'),(2138,'2016-03-18 11:31:10','2016-03-18 11:31:10','白云区','440111','广东省广州市白云区'),(2139,'2016-03-18 11:31:10','2016-03-18 11:31:10','黄埔区','440112','广东省广州市黄埔区'),(2140,'2016-03-18 11:31:10','2016-03-18 11:31:10','番禺区','440113','广东省广州市番禺区'),(2141,'2016-03-18 11:31:10','2016-03-18 11:31:10','花都区','440114','广东省广州市花都区'),(2142,'2016-03-18 11:31:10','2016-03-18 11:31:10','南沙区','440115','广东省广州市南沙区'),(2143,'2016-03-18 11:31:10','2016-03-18 11:31:10','萝岗区','440116','广东省广州市萝岗区'),(2144,'2016-03-18 11:31:11','2016-03-18 11:31:11','从化区','440117','广东省广州市从化区'),(2145,'2016-03-18 11:31:11','2016-03-18 11:31:11','增城区','440118','广东省广州市增城区'),(2146,'2016-03-18 11:31:11','2016-03-18 11:31:11','韶关市','440200','广东省韶关市'),(2147,'2016-03-18 11:31:11','2016-03-18 11:31:11','市辖区','440201','广东省韶关市市辖区'),(2148,'2016-03-18 11:31:11','2016-03-18 11:31:11','武江区','440203','广东省韶关市武江区'),(2149,'2016-03-18 11:31:11','2016-03-18 11:31:11','浈江区','440204','广东省韶关市浈江区'),(2150,'2016-03-18 11:31:11','2016-03-18 11:31:11','曲江区','440205','广东省韶关市曲江区'),(2151,'2016-03-18 11:31:11','2016-03-18 11:31:11','始兴县','440222','广东省韶关市始兴县'),(2152,'2016-03-18 11:31:11','2016-03-18 11:31:11','仁化县','440224','广东省韶关市仁化县'),(2153,'2016-03-18 11:31:11','2016-03-18 11:31:11','翁源县','440229','广东省韶关市翁源县'),(2154,'2016-03-18 11:31:11','2016-03-18 11:31:11','乳源瑶族自治县','440232','广东省韶关市乳源瑶族自治县'),(2155,'2016-03-18 11:31:11','2016-03-18 11:31:11','新丰县','440233','广东省韶关市新丰县'),(2156,'2016-03-18 11:31:11','2016-03-18 11:31:11','乐昌市','440281','广东省韶关市乐昌市'),(2157,'2016-03-18 11:31:11','2016-03-18 11:31:11','南雄市','440282','广东省韶关市南雄市'),(2158,'2016-03-18 11:31:11','2016-03-18 11:31:11','深圳市','440300','广东省深圳市'),(2159,'2016-03-18 11:31:11','2016-03-18 11:31:11','市辖区','440301','广东省深圳市市辖区'),(2160,'2016-03-18 11:31:12','2016-03-18 11:31:12','罗湖区','440303','广东省深圳市罗湖区'),(2161,'2016-03-18 11:31:12','2016-03-18 11:31:12','福田区','440304','广东省深圳市福田区'),(2162,'2016-03-18 11:31:12','2016-03-18 11:31:12','南山区','440305','广东省深圳市南山区'),(2163,'2016-03-18 11:31:12','2016-03-18 11:31:12','宝安区','440306','广东省深圳市宝安区'),(2164,'2016-03-18 11:31:12','2016-03-18 11:31:12','龙岗区','440307','广东省���圳市龙岗区'),(2165,'2016-03-18 11:31:12','2016-03-18 11:31:12','盐田区','440308','广东省深圳市盐田区'),(2166,'2016-03-18 11:31:12','2016-03-18 11:31:12','珠海市','440400','广东省珠海市'),(2167,'2016-03-18 11:31:12','2016-03-18 11:31:12','市辖区','440401','广东省珠海市市辖区'),(2168,'2016-03-18 11:31:12','2016-03-18 11:31:12','香洲区','440402','广东省珠海市香洲区'),(2169,'2016-03-18 11:31:12','2016-03-18 11:31:12','斗门区','440403','广东省珠海市斗门区'),(2170,'2016-03-18 11:31:12','2016-03-18 11:31:12','金湾区','440404','广东省珠海市金湾区'),(2171,'2016-03-18 11:31:12','2016-03-18 11:31:12','汕头市','440500','广东省汕头市'),(2172,'2016-03-18 11:31:12','2016-03-18 11:31:12','市辖区','440501','广东省汕头市市辖区'),(2173,'2016-03-18 11:31:12','2016-03-18 11:31:12','龙湖区','440507','广东省汕头市龙湖区'),(2174,'2016-03-18 11:31:12','2016-03-18 11:31:12','金平区','440511','广东省汕头市金平区'),(2175,'2016-03-18 11:31:12','2016-03-18 11:31:12','濠江区','440512','广东省汕头市濠江区'),(2176,'2016-03-18 11:31:13','2016-03-18 11:31:13','潮阳区','440513','广东省汕头市潮阳区'),(2177,'2016-03-18 11:31:13','2016-03-18 11:31:13','潮南区','440514','广东省汕头市潮南区'),(2178,'2016-03-18 11:31:13','2016-03-18 11:31:13','澄海区','440515','广东省汕头市澄海区'),(2179,'2016-03-18 11:31:13','2016-03-18 11:31:13','南澳县','440523','广东省汕头市南澳县'),(2180,'2016-03-18 11:31:13','2016-03-18 11:31:13','佛山市','440600','广东省佛山市'),(2181,'2016-03-18 11:31:13','2016-03-18 11:31:13','市辖区','440601','广东省佛山市市辖区'),(2182,'2016-03-18 11:31:13','2016-03-18 11:31:13','禅城区','440604','广东省佛山市禅城区'),(2183,'2016-03-18 11:31:13','2016-03-18 11:31:13','南海区','440605','广东省佛山市南海区'),(2184,'2016-03-18 11:31:13','2016-03-18 11:31:13','顺德区','440606','广东省佛山市顺德区'),(2185,'2016-03-18 11:31:13','2016-03-18 11:31:13','三水区','440607','广东省佛山市三水区'),(2186,'2016-03-18 11:31:13','2016-03-18 11:31:13','高明区','440608','广东省佛山市高明区'),(2187,'2016-03-18 11:31:13','2016-03-18 11:31:13','江门市','440700','广东省江门市'),(2188,'2016-03-18 11:31:13','2016-03-18 11:31:13','市辖区','440701','广东省江门市市辖区'),(2189,'2016-03-18 11:31:13','2016-03-18 11:31:13','蓬江区','440703','广东省江门市蓬江区'),(2190,'2016-03-18 11:31:13','2016-03-18 11:31:13','江海区','440704','广东省江门市江海区'),(2191,'2016-03-18 11:31:13','2016-03-18 11:31:13','新会区','440705','广东省江门市新会区'),(2192,'2016-03-18 11:31:13','2016-03-18 11:31:13','台山市','440781','广东省江门市台山市'),(2193,'2016-03-18 11:31:14','2016-03-18 11:31:14','开平市','440783','广东省江门市开平市'),(2194,'2016-03-18 11:31:14','2016-03-18 11:31:14','鹤山市','440784','广东省江门市鹤山市'),(2195,'2016-03-18 11:31:14','2016-03-18 11:31:14','恩平市','440785','广东省江门市恩平市'),(2196,'2016-03-18 11:31:14','2016-03-18 11:31:14','湛江市','440800','广东省湛江市'),(2197,'2016-03-18 11:31:14','2016-03-18 11:31:14','市辖区','440801','广东省湛江市市辖区'),(2198,'2016-03-18 11:31:14','2016-03-18 11:31:14','赤坎区','440802','广东省湛江市赤坎区'),(2199,'2016-03-18 11:31:14','2016-03-18 11:31:14','霞山区','440803','广东省湛江市霞山区'),(2200,'2016-03-18 11:31:14','2016-03-18 11:31:14','坡头区','440804','广东省湛江市坡头区'),(2201,'2016-03-18 11:31:14','2016-03-18 11:31:14','麻章区','440811','广东省湛江市麻章区'),(2202,'2016-03-18 11:31:14','2016-03-18 11:31:14','遂溪县','440823','广东省湛江市遂溪县'),(2203,'2016-03-18 11:31:14','2016-03-18 11:31:14','徐闻县','440825','广东省湛江市徐闻县'),(2204,'2016-03-18 11:31:14','2016-03-18 11:31:14','廉江市','440881','广东省湛江市廉江市'),(2205,'2016-03-18 11:31:14','2016-03-18 11:31:14','雷州市','440882','广东省湛江市雷州市'),(2206,'2016-03-18 11:31:14','2016-03-18 11:31:14','吴川市','440883','广东省湛江市吴川市'),(2207,'2016-03-18 11:31:14','2016-03-18 11:31:14','茂名市','440900','广东省茂名市'),(2208,'2016-03-18 11:31:14','2016-03-18 11:31:14','市辖区','440901','广东省茂名市市辖区'),(2209,'2016-03-18 11:31:14','2016-03-18 11:31:14','茂南区','440902','广东省茂名市茂南区'),(2210,'2016-03-18 11:31:15','2016-03-18 11:31:15','电白区','440904','广东省茂名市电白区'),(2211,'2016-03-18 11:31:15','2016-03-18 11:31:15','高州市','440981','广东省茂名市高州市'),(2212,'2016-03-18 11:31:15','2016-03-18 11:31:15','化州市','440982','广东省茂名市化州市'),(2213,'2016-03-18 11:31:15','2016-03-18 11:31:15','信宜市','440983','广东省茂名市信宜市'),(2214,'2016-03-18 11:31:15','2016-03-18 11:31:15','肇庆市','441200','广东省肇庆市'),(2215,'2016-03-18 11:31:15','2016-03-18 11:31:15','市辖区','441201','广东省肇庆市市辖区'),(2216,'2016-03-18 11:31:15','2016-03-18 11:31:15','端州区','441202','广东省肇庆市端州区'),(2217,'2016-03-18 11:31:15','2016-03-18 11:31:15','鼎湖区','441203','广东省肇庆市鼎湖区'),(2218,'2016-03-18 11:31:15','2016-03-18 11:31:15','广宁县','441223','广东省肇庆市广宁县'),(2219,'2016-03-18 11:31:15','2016-03-18 11:31:15','怀集县','441224','广东省肇庆市怀集县'),(2220,'2016-03-18 11:31:15','2016-03-18 11:31:15','封开县','441225','广东省肇庆市封开县'),(2221,'2016-03-18 11:31:15','2016-03-18 11:31:15','德庆县','441226','广东省肇庆市德庆县'),(2222,'2016-03-18 11:31:15','2016-03-18 11:31:15','高要市','441283','广东省肇庆市高要市'),(2223,'2016-03-18 11:31:15','2016-03-18 11:31:15','四会市','441284','广东省肇庆市四会市'),(2224,'2016-03-18 11:31:15','2016-03-18 11:31:15','惠州市','441300','广东省惠州市'),(2225,'2016-03-18 11:31:16','2016-03-18 11:31:16','市辖区','441301','广东省惠州市市辖区'),(2226,'2016-03-18 11:31:16','2016-03-18 11:31:16','惠城区','441302','广东省惠州市惠城区'),(2227,'2016-03-18 11:31:16','2016-03-18 11:31:16','惠阳区','441303','广东省惠州市惠阳区'),(2228,'2016-03-18 11:31:16','2016-03-18 11:31:16','博罗县','441322','广东省惠州市博罗县'),(2229,'2016-03-18 11:31:16','2016-03-18 11:31:16','惠东县','441323','广东省惠州市惠东县'),(2230,'2016-03-18 11:31:16','2016-03-18 11:31:16','龙门县','441324','广东省惠州市龙门县'),(2231,'2016-03-18 11:31:16','2016-03-18 11:31:16','梅州市','441400','广东省梅州市'),(2232,'2016-03-18 11:31:16','2016-03-18 11:31:16','市辖区','441401','广东省梅州市市辖区'),(2233,'2016-03-18 11:31:16','2016-03-18 11:31:16','梅江区','441402','广东省梅州市梅江区'),(2234,'2016-03-18 11:31:16','2016-03-18 11:31:16','梅县区','441403','广东省梅州市梅县区'),(2235,'2016-03-18 11:31:16','2016-03-18 11:31:16','大埔县','441422','广东省梅州市大埔县'),(2236,'2016-03-18 11:31:16','2016-03-18 11:31:16','丰顺县','441423','广东省梅州市丰顺县'),(2237,'2016-03-18 11:31:16','2016-03-18 11:31:16','五华县','441424','广东省梅州市五华县'),(2238,'2016-03-18 11:31:16','2016-03-18 11:31:16','平远县','441426','广东省梅州市平远县'),(2239,'2016-03-18 11:31:16','2016-03-18 11:31:16','蕉岭县','441427','广东省梅州市蕉岭县'),(2240,'2016-03-18 11:31:17','2016-03-18 11:31:17','兴宁市','441481','广东省梅州市兴宁市'),(2241,'2016-03-18 11:31:17','2016-03-18 11:31:17','汕尾市','441500','广东省汕尾市'),(2242,'2016-03-18 11:31:17','2016-03-18 11:31:17','市辖区','441501','广东省汕尾市市辖区'),(2243,'2016-03-18 11:31:17','2016-03-18 11:31:17','城区','441502','广东省汕尾市城区'),(2244,'2016-03-18 11:31:17','2016-03-18 11:31:17','海丰县','441521','广东省汕尾市海丰县'),(2245,'2016-03-18 11:31:17','2016-03-18 11:31:17','陆河县','441523','广东省汕尾市陆河县'),(2246,'2016-03-18 11:31:17','2016-03-18 11:31:17','陆丰市','441581','广东省汕尾市陆丰市'),(2247,'2016-03-18 11:31:17','2016-03-18 11:31:17','河源市','441600','广东省河源市'),(2248,'2016-03-18 11:31:17','2016-03-18 11:31:17','市辖区','441601','广东省河源市市辖区'),(2249,'2016-03-18 11:31:17','2016-03-18 11:31:17','源城区','441602','广东省河源市源城区'),(2250,'2016-03-18 11:31:17','2016-03-18 11:31:17','紫金县','441621','广东省河源市紫金县'),(2251,'2016-03-18 11:31:17','2016-03-18 11:31:17','龙川县','441622','广东省河源市龙川县'),(2252,'2016-03-18 11:31:17','2016-03-18 11:31:17','连平县','441623','广东省河源市连平县'),(2253,'2016-03-18 11:31:18','2016-03-18 11:31:18','和平县','441624','广东省河源市和平县'),(2254,'2016-03-18 11:31:18','2016-03-18 11:31:18','东源县','441625','广东省河源市东源县'),(2255,'2016-03-18 11:31:18','2016-03-18 11:31:18','阳江市','441700','广东省阳江市'),(2256,'2016-03-18 11:31:18','2016-03-18 11:31:18','市辖区','441701','广东省阳江市市辖区'),(2257,'2016-03-18 11:31:18','2016-03-18 11:31:18','江城区','441702','广东省阳江市江城区'),(2258,'2016-03-18 11:31:18','2016-03-18 11:31:18','阳西县','441721','广东省阳江市阳西县'),(2259,'2016-03-18 11:31:18','2016-03-18 11:31:18','阳东县','441723','广东省阳江市阳东县'),(2260,'2016-03-18 11:31:18','2016-03-18 11:31:18','阳春市','441781','广东省阳江市阳春市'),(2261,'2016-03-18 11:31:18','2016-03-18 11:31:18','清远市','441800','广东省清远市'),(2262,'2016-03-18 11:31:18','2016-03-18 11:31:18','市辖区','441801','广东省清远市市辖区'),(2263,'2016-03-18 11:31:18','2016-03-18 11:31:18','清城区','441802','广东省清远市清城区'),(2264,'2016-03-18 11:31:18','2016-03-18 11:31:18','清新区','441803','广东省清远市清新区'),(2265,'2016-03-18 11:31:18','2016-03-18 11:31:18','佛冈县','441821','广东省清远市佛冈县'),(2266,'2016-03-18 11:31:19','2016-03-18 11:31:19','阳山县','441823','广东省清远市阳山县'),(2267,'2016-03-18 11:31:19','2016-03-18 11:31:19','连山壮族瑶族自治县','441825','广东省清远市连山壮族瑶族自治县'),(2268,'2016-03-18 11:31:19','2016-03-18 11:31:19','连南瑶族自治县','441826','广东省清远市连南瑶族自治县'),(2269,'2016-03-18 11:31:19','2016-03-18 11:31:19','英德市','441881','广东省清远市英德市'),(2270,'2016-03-18 11:31:19','2016-03-18 11:31:19','连州市','441882','广东省清远市连州市'),(2271,'2016-03-18 11:31:19','2016-03-18 11:31:19','东莞市','441900','广东省东莞市'),(2272,'2016-03-18 11:31:19','2016-03-18 11:31:19','中山市','442000','广东省中山市'),(2273,'2016-03-18 11:31:19','2016-03-18 11:31:19','潮州市','445100','广东省潮州市'),(2274,'2016-03-18 11:31:19','2016-03-18 11:31:19','市辖区','445101','广东省潮州市市辖区'),(2275,'2016-03-18 11:31:19','2016-03-18 11:31:19','湘桥区','445102','广东省潮州市湘桥区'),(2276,'2016-03-18 11:31:19','2016-03-18 11:31:19','潮安区','445103','广东省潮州市潮安区'),(2277,'2016-03-18 11:31:19','2016-03-18 11:31:19','饶平县','445122','广东省潮州市饶平县'),(2278,'2016-03-18 11:31:19','2016-03-18 11:31:19','揭阳市','445200','广东省揭阳市'),(2279,'2016-03-18 11:31:19','2016-03-18 11:31:19','市辖区','445201','广东省揭阳市市辖区'),(2280,'2016-03-18 11:31:19','2016-03-18 11:31:19','榕城区','445202','广东省揭阳市榕城区'),(2281,'2016-03-18 11:31:20','2016-03-18 11:31:20','揭东区','445203','广东省揭阳市揭东区'),(2282,'2016-03-18 11:31:20','2016-03-18 11:31:20','揭西县','445222','广东省揭阳市揭西县'),(2283,'2016-03-18 11:31:20','2016-03-18 11:31:20','惠来县','445224','广东省揭阳市惠来县'),(2284,'2016-03-18 11:31:20','2016-03-18 11:31:20','普宁市','445281','广东省揭阳市普宁市'),(2285,'2016-03-18 11:31:20','2016-03-18 11:31:20','云浮市','445300','广东省云浮市'),(2286,'2016-03-18 11:31:20','2016-03-18 11:31:20','市辖区','445301','广东省云浮市市辖区'),(2287,'2016-03-18 11:31:20','2016-03-18 11:31:20','云城区','445302','广东省云浮市云城区'),(2288,'2016-03-18 11:31:20','2016-03-18 11:31:20','云安区','445303','广东省云浮市云安区'),(2289,'2016-03-18 11:31:20','2016-03-18 11:31:20','新兴县','445321','广东省云浮市新兴县'),(2290,'2016-03-18 11:31:20','2016-03-18 11:31:20','郁南县','445322','广东省云浮市郁南县'),(2291,'2016-03-18 11:31:20','2016-03-18 11:31:20','罗定市','445381','广东省云浮市罗定市'),(2292,'2016-03-18 11:31:20','2016-03-18 11:31:20','广西壮族自治区','450000','广西壮族自治区'),(2293,'2016-03-18 11:31:20','2016-03-18 11:31:20','南宁市','450100','广西壮族自治区南宁市'),(2294,'2016-03-18 11:31:20','2016-03-18 11:31:20','市辖区','450101','广西壮族自治区南宁市市辖区'),(2295,'2016-03-18 11:31:20','2016-03-18 11:31:20','兴宁区','450102','广西壮族自治区南宁市兴宁区'),(2296,'2016-03-18 11:31:21','2016-03-18 11:31:21','青秀区','450103','广西壮族自治区南宁市青秀区'),(2297,'2016-03-18 11:31:21','2016-03-18 11:31:21','江南区','450105','广西壮族自治区南宁市江南区'),(2298,'2016-03-18 11:31:21','2016-03-18 11:31:21','西乡塘区','450107','广西壮族自治区南宁市西乡塘区'),(2299,'2016-03-18 11:31:21','2016-03-18 11:31:21','良庆区','450108','广西壮族自治区南宁市良庆区'),(2300,'2016-03-18 11:31:21','2016-03-18 11:31:21','邕宁区','450109','广西壮族自治区南宁市邕宁区'),(2301,'2016-03-18 11:31:21','2016-03-18 11:31:21','武鸣县','450122','广西壮族自治区南宁市武鸣县'),(2302,'2016-03-18 11:31:21','2016-03-18 11:31:21','隆安县','450123','广西壮族自治区南宁市隆安县'),(2303,'2016-03-18 11:31:21','2016-03-18 11:31:21','马山县','450124','广西壮族自治区南宁市马山县'),(2304,'2016-03-18 11:31:21','2016-03-18 11:31:21','上林县','450125','广西壮族自治区南宁市上林县'),(2305,'2016-03-18 11:31:21','2016-03-18 11:31:21','宾阳县','450126','广西壮族自治区南宁市宾阳县'),(2306,'2016-03-18 11:31:22','2016-03-18 11:31:22','横县','450127','广西壮族自���区南宁市横县'),(2307,'2016-03-18 11:31:22','2016-03-18 11:31:22','柳州市','450200','广西壮族自治区柳州市'),(2308,'2016-03-18 11:31:22','2016-03-18 11:31:22','市辖区','450201','广西壮族自治区柳州市市辖区'),(2309,'2016-03-18 11:31:22','2016-03-18 11:31:22','城中区','450202','广西壮族自治区柳州市城中区'),(2310,'2016-03-18 11:31:22','2016-03-18 11:31:22','鱼峰区','450203','广西壮族自治区柳州市鱼峰区'),(2311,'2016-03-18 11:31:22','2016-03-18 11:31:22','柳南区','450204','广西壮族自治区柳州市柳南区'),(2312,'2016-03-18 11:31:22','2016-03-18 11:31:22','柳北区','450205','广西壮族自治区柳州市柳北区'),(2313,'2016-03-18 11:31:22','2016-03-18 11:31:22','柳江县','450221','广西壮族自治区柳州市柳江县'),(2314,'2016-03-18 11:31:22','2016-03-18 11:31:22','柳城县','450222','广西壮族自治区柳州市柳城县'),(2315,'2016-03-18 11:31:22','2016-03-18 11:31:22','鹿寨县','450223','广西壮族自治区柳州市鹿寨县'),(2316,'2016-03-18 11:31:22','2016-03-18 11:31:22','融安县','450224','广西壮族自治区柳州市融安县'),(2317,'2016-03-18 11:31:22','2016-03-18 11:31:22','融水苗族自治县','450225','广西壮族自治区柳州市融水苗族自治县'),(2318,'2016-03-18 11:31:22','2016-03-18 11:31:22','三江侗族自治县','450226','广西壮族自治区柳州市三江侗族自治县'),(2319,'2016-03-18 11:31:22','2016-03-18 11:31:22','桂林市','450300','广西壮族自治区桂林市'),(2320,'2016-03-18 11:31:23','2016-03-18 11:31:23','市辖区','450301','广西壮族自治区桂林市市辖区'),(2321,'2016-03-18 11:31:23','2016-03-18 11:31:23','秀峰区','450302','广西壮族自治区桂林市秀峰区'),(2322,'2016-03-18 11:31:23','2016-03-18 11:31:23','叠彩区','450303','广西壮族自治区桂林市叠彩区'),(2323,'2016-03-18 11:31:23','2016-03-18 11:31:23','象山区','450304','广西壮族自治区桂林市象山区'),(2324,'2016-03-18 11:31:23','2016-03-18 11:31:23','七星区','450305','广西壮族自治区桂林市七星区'),(2325,'2016-03-18 11:31:23','2016-03-18 11:31:23','雁山区','450311','广西壮族自治区桂林市雁山区'),(2326,'2016-03-18 11:31:23','2016-03-18 11:31:23','临桂区','450312','广西壮族自治区桂林市临桂区'),(2327,'2016-03-18 11:31:23','2016-03-18 11:31:23','阳朔县','450321','广西壮族自治区桂林市阳朔县'),(2328,'2016-03-18 11:31:23','2016-03-18 11:31:23','灵川县','450323','广西壮族自治区桂林市灵川县'),(2329,'2016-03-18 11:31:23','2016-03-18 11:31:23','全州县','450324','广西壮族自治区桂林市全州县'),(2330,'2016-03-18 11:31:23','2016-03-18 11:31:23','兴安县','450325','广西壮族自治区桂林市兴安县'),(2331,'2016-03-18 11:31:23','2016-03-18 11:31:23','永福县','450326','广西壮族自治区桂林市永福县'),(2332,'2016-03-18 11:31:24','2016-03-18 11:31:24','灌阳县','450327','广西壮族自治区桂林市灌阳县'),(2333,'2016-03-18 11:31:24','2016-03-18 11:31:24','龙胜各族自治县','450328','广西壮族自治区桂林市龙胜各族自治县'),(2334,'2016-03-18 11:31:24','2016-03-18 11:31:24','资源县','450329','广西壮族自治区桂林市资源县'),(2335,'2016-03-18 11:31:24','2016-03-18 11:31:24','平乐县','450330','广西壮族自治区桂林市平乐县'),(2336,'2016-03-18 11:31:24','2016-03-18 11:31:24','荔浦县','450331','广西壮族自治区桂林市荔浦县'),(2337,'2016-03-18 11:31:24','2016-03-18 11:31:24','恭城瑶族自治县','450332','广西壮族自治区桂林市恭城瑶族自治县'),(2338,'2016-03-18 11:31:24','2016-03-18 11:31:24','梧州市','450400','广西壮族自治区梧州市'),(2339,'2016-03-18 11:31:24','2016-03-18 11:31:24','市辖区','450401','广西壮族自治区梧州市市辖区'),(2340,'2016-03-18 11:31:24','2016-03-18 11:31:24','万秀区','450403','广西壮族自治区梧州市万秀区'),(2341,'2016-03-18 11:31:24','2016-03-18 11:31:24','长洲区','450405','广西壮族自治区梧州市长洲区'),(2342,'2016-03-18 11:31:24','2016-03-18 11:31:24','龙圩区','450406','广西壮族自治区梧州市龙圩区'),(2343,'2016-03-18 11:31:24','2016-03-18 11:31:24','苍梧县','450421','广西壮族自治区梧州市苍梧县'),(2344,'2016-03-18 11:31:24','2016-03-18 11:31:24','藤县','450422','广西壮族自治区梧州市藤县'),(2345,'2016-03-18 11:31:25','2016-03-18 11:31:25','蒙山县','450423','广西壮族自治区梧州市蒙山县'),(2346,'2016-03-18 11:31:25','2016-03-18 11:31:25','岑溪市','450481','广西壮族自治区梧州市岑溪市'),(2347,'2016-03-18 11:31:25','2016-03-18 11:31:25','北海市','450500','广西壮族自治区北海市'),(2348,'2016-03-18 11:31:25','2016-03-18 11:31:25','市辖区','450501','广西壮族自治区北海市市辖区'),(2349,'2016-03-18 11:31:25','2016-03-18 11:31:25','海城区','450502','广西壮族自治区北海市海城区'),(2350,'2016-03-18 11:31:25','2016-03-18 11:31:25','银海区','450503','广西壮族自治区北海市银海区'),(2351,'2016-03-18 11:31:25','2016-03-18 11:31:25','铁山港区','450512','广西壮族自治区北海市铁山港区'),(2352,'2016-03-18 11:31:25','2016-03-18 11:31:25','合浦县','450521','广西壮族自治区北海市合浦县'),(2353,'2016-03-18 11:31:25','2016-03-18 11:31:25','防城港市','450600','广西壮族自治区防城港市'),(2354,'2016-03-18 11:31:25','2016-03-18 11:31:25','市辖区','450601','广西壮族自治区防城港市市辖区'),(2355,'2016-03-18 11:31:25','2016-03-18 11:31:25','港口区','450602','广西壮族自治区防城港市港口区'),(2356,'2016-03-18 11:31:25','2016-03-18 11:31:25','防城区','450603','广西壮族自治区防城港市防城区'),(2357,'2016-03-18 11:31:25','2016-03-18 11:31:25','上思县','450621','广西壮族自治区防城港市上思县'),(2358,'2016-03-18 11:31:25','2016-03-18 11:31:25','东兴市','450681','广西壮族自治区防城港市东兴市'),(2359,'2016-03-18 11:31:25','2016-03-18 11:31:25','钦州市','450700','广西壮族自治区钦州市'),(2360,'2016-03-18 11:31:25','2016-03-18 11:31:25','市辖区','450701','广西壮族自治区钦州市市辖区'),(2361,'2016-03-18 11:31:25','2016-03-18 11:31:25','钦南区','450702','广西壮族自治区钦州市钦南区'),(2362,'2016-03-18 11:31:25','2016-03-18 11:31:25','钦北区','450703','广西壮族自治区钦州市钦北区'),(2363,'2016-03-18 11:31:26','2016-03-18 11:31:26','灵山县','450721','广西壮族自治区钦州市灵山县'),(2364,'2016-03-18 11:31:26','2016-03-18 11:31:26','浦北县','450722','广西壮族自治区钦州市浦北县'),(2365,'2016-03-18 11:31:26','2016-03-18 11:31:26','贵港市','450800','广西壮族自治区贵港市'),(2366,'2016-03-18 11:31:26','2016-03-18 11:31:26','市辖区','450801','广西壮族自治区贵港市市辖区'),(2367,'2016-03-18 11:31:26','2016-03-18 11:31:26','港北区','450802','广西壮族自治区贵港市港北区'),(2368,'2016-03-18 11:31:26','2016-03-18 11:31:26','港南区','450803','广西壮族自治区贵港市港南区'),(2369,'2016-03-18 11:31:26','2016-03-18 11:31:26','覃塘区','450804','广西壮族自治区贵港市覃塘区'),(2370,'2016-03-18 11:31:26','2016-03-18 11:31:26','平南县','450821','广西壮族自治区贵港��平南县'),(2371,'2016-03-18 11:31:26','2016-03-18 11:31:26','桂平市','450881','广西壮族自治区贵港市桂平市'),(2372,'2016-03-18 11:31:26','2016-03-18 11:31:26','玉林市','450900','广西壮族自治区玉林市'),(2373,'2016-03-18 11:31:26','2016-03-18 11:31:26','市辖区','450901','广西壮族自治区玉林市市辖区'),(2374,'2016-03-18 11:31:26','2016-03-18 11:31:26','玉州区','450902','广西壮族自治区玉林市玉州区'),(2375,'2016-03-18 11:31:26','2016-03-18 11:31:26','福绵区','450903','广西壮族自治区玉林市福绵区'),(2376,'2016-03-18 11:31:26','2016-03-18 11:31:26','容县','450921','广西壮族自治区玉林市容县'),(2377,'2016-03-18 11:31:26','2016-03-18 11:31:26','陆川县','450922','广西壮族自治区玉林市陆川县'),(2378,'2016-03-18 11:31:26','2016-03-18 11:31:26','博白县','450923','广西壮族自治区玉林市博白县'),(2379,'2016-03-18 11:31:26','2016-03-18 11:31:26','兴业县','450924','广西壮族自治区玉林市兴业县'),(2380,'2016-03-18 11:31:26','2016-03-18 11:31:26','北流市','450981','广西壮族自治区玉林市北流市'),(2381,'2016-03-18 11:31:27','2016-03-18 11:31:27','百色市','451000','广西壮族自治区百色市'),(2382,'2016-03-18 11:31:27','2016-03-18 11:31:27','市辖区','451001','广西壮族自治区百色市市辖区'),(2383,'2016-03-18 11:31:27','2016-03-18 11:31:27','右江区','451002','广西壮族自治区百色市右江区'),(2384,'2016-03-18 11:31:27','2016-03-18 11:31:27','田阳县','451021','广西壮族自治区百色市田阳县'),(2385,'2016-03-18 11:31:27','2016-03-18 11:31:27','田东县','451022','广西壮族自治区百色市田东县'),(2386,'2016-03-18 11:31:27','2016-03-18 11:31:27','平果县','451023','广西壮族自治区百色市平果县'),(2387,'2016-03-18 11:31:27','2016-03-18 11:31:27','德保县','451024','广西壮族自治区百色市德保县'),(2388,'2016-03-18 11:31:27','2016-03-18 11:31:27','靖西县','451025','广西壮族自治区百色市靖西县'),(2389,'2016-03-18 11:31:27','2016-03-18 11:31:27','那坡县','451026','广西壮族自治区百色市那坡县'),(2390,'2016-03-18 11:31:27','2016-03-18 11:31:27','凌云县','451027','广西壮族自治区百色市凌云县'),(2391,'2016-03-18 11:31:27','2016-03-18 11:31:27','乐业县','451028','广西壮族自治区百色市乐业县'),(2392,'2016-03-18 11:31:27','2016-03-18 11:31:27','田林县','451029','广西壮族自治区百色市田林县'),(2393,'2016-03-18 11:31:27','2016-03-18 11:31:27','西林县','451030','广西壮族自治区百色市西林县'),(2394,'2016-03-18 11:31:27','2016-03-18 11:31:27','隆林各族自治县','451031','广西壮族自治区百色市隆林各族自治县'),(2395,'2016-03-18 11:31:27','2016-03-18 11:31:27','贺州市','451100','广西壮族自治区贺州市'),(2396,'2016-03-18 11:31:27','2016-03-18 11:31:27','市辖区','451101','广西壮族自治区贺州市市辖区'),(2397,'2016-03-18 11:31:27','2016-03-18 11:31:27','八步区','451102','广西壮族自治区贺州市八步区'),(2398,'2016-03-18 11:31:28','2016-03-18 11:31:28','昭平县','451121','广西壮族自治区贺州市昭平县'),(2399,'2016-03-18 11:31:28','2016-03-18 11:31:28','钟山县','451122','广西壮族自治区贺州市钟山县'),(2400,'2016-03-18 11:31:28','2016-03-18 11:31:28','富川瑶族自治县','451123','广西壮族自治区贺州市富川瑶族自治县'),(2401,'2016-03-18 11:31:28','2016-03-18 11:31:28','河池市','451200','广西壮族自治区河池市'),(2402,'2016-03-18 11:31:28','2016-03-18 11:31:28','市辖区','451201','广西壮族自治区河池市市辖区'),(2403,'2016-03-18 11:31:28','2016-03-18 11:31:28','金城江区','451202','广西壮族自治区河池市金城江区'),(2404,'2016-03-18 11:31:28','2016-03-18 11:31:28','南丹县','451221','广西壮族自治区河池市南丹县'),(2405,'2016-03-18 11:31:28','2016-03-18 11:31:28','天峨县','451222','广西壮族自治区河池市天峨县'),(2406,'2016-03-18 11:31:28','2016-03-18 11:31:28','凤山县','451223','广西壮族自治区河池市凤山县'),(2407,'2016-03-18 11:31:28','2016-03-18 11:31:28','东兰县','451224','广西壮族自治区河池市东兰县'),(2408,'2016-03-18 11:31:28','2016-03-18 11:31:28','罗城仫佬族自治县','451225','广西壮族自治区河池市罗城仫佬族自治县'),(2409,'2016-03-18 11:31:28','2016-03-18 11:31:28','环江毛南族自治县','451226','广西壮族自治区河池市环江毛南族自治县'),(2410,'2016-03-18 11:31:29','2016-03-18 11:31:29','巴马瑶族自治县','451227','广西壮族自治区河池市巴马瑶族自治县'),(2411,'2016-03-18 11:31:29','2016-03-18 11:31:29','都安瑶族自治县','451228','广西壮族自治区河池市都安瑶族自治县'),(2412,'2016-03-18 11:31:29','2016-03-18 11:31:29','大化瑶族自治县','451229','广西壮族自治区河池市大化瑶族自治县'),(2413,'2016-03-18 11:31:29','2016-03-18 11:31:29','宜州市','451281','广西壮族自治区河池市宜州市'),(2414,'2016-03-18 11:31:29','2016-03-18 11:31:29','来宾市','451300','广西壮族自治区来宾市'),(2415,'2016-03-18 11:31:29','2016-03-18 11:31:29','市辖区','451301','广西壮族自治区来宾市市辖区'),(2416,'2016-03-18 11:31:29','2016-03-18 11:31:29','兴宾区','451302','广西壮族自治区来宾市兴宾区'),(2417,'2016-03-18 11:31:29','2016-03-18 11:31:29','忻城县','451321','广西壮族自治区来宾市忻城县'),(2418,'2016-03-18 11:31:29','2016-03-18 11:31:29','象州县','451322','广西壮族自治区来宾市象州县'),(2419,'2016-03-18 11:31:29','2016-03-18 11:31:29','武宣县','451323','广西壮族自治区来宾市武宣县'),(2420,'2016-03-18 11:31:29','2016-03-18 11:31:29','金秀瑶族自治县','451324','广西壮族自治区来宾市金秀瑶族自治县'),(2421,'2016-03-18 11:31:29','2016-03-18 11:31:29','合山市','451381','广西壮族自治区来宾市合山市'),(2422,'2016-03-18 11:31:29','2016-03-18 11:31:29','崇左市','451400','广西壮族自治区崇左市'),(2423,'2016-03-18 11:31:29','2016-03-18 11:31:29','市辖区','451401','广西壮族自治区崇左市市辖区'),(2424,'2016-03-18 11:31:29','2016-03-18 11:31:29','江州区','451402','广西壮族自治区崇左市江州区'),(2425,'2016-03-18 11:31:29','2016-03-18 11:31:29','扶绥县','451421','广西壮族自治区崇左市扶绥县'),(2426,'2016-03-18 11:31:29','2016-03-18 11:31:29','宁明县','451422','广西壮族自治区崇左市宁明县'),(2427,'2016-03-18 11:31:30','2016-03-18 11:31:30','龙州县','451423','广西壮族自治区崇左市龙州县'),(2428,'2016-03-18 11:31:30','2016-03-18 11:31:30','大新县','451424','广西壮族自治区崇左市大新县'),(2429,'2016-03-18 11:31:30','2016-03-18 11:31:30','天等县','451425','广西壮族自治区崇左市天等县'),(2430,'2016-03-18 11:31:30','2016-03-18 11:31:30','凭祥市','451481','广西壮族自治区崇左市凭祥市'),(2431,'2016-03-18 11:31:30','2016-03-18 11:31:30','海南省','460000','海南省'),(2432,'2016-03-18 11:31:30','2016-03-18 11:31:30','海口市','460100','海南省海口市'),(2433,'2016-03-18 11:31:30','2016-03-18 11:31:30','市辖区','460101','海南省海口市市辖区'),(2434,'2016-03-18 11:31:30','2016-03-18 11:31:30','秀英区','460105','海南省海口市秀英区'),(2435,'2016-03-18 11:31:30','2016-03-18 11:31:30','龙华区','460106','海南省海口市龙华区'),(2436,'2016-03-18 11:31:30','2016-03-18 11:31:30','琼山区','460107','海南省海口市琼山区'),(2437,'2016-03-18 11:31:30','2016-03-18 11:31:30','美兰区','460108','海南省海口市美兰区'),(2438,'2016-03-18 11:31:30','2016-03-18 11:31:30','三亚市','460200','海南省三亚市'),(2439,'2016-03-18 11:31:30','2016-03-18 11:31:30','市辖区','460201','海南省三亚市市辖区'),(2440,'2016-03-18 11:31:30','2016-03-18 11:31:30','海棠区','460202','海南省三亚市海棠区'),(2441,'2016-03-18 11:31:30','2016-03-18 11:31:30','吉阳区','460203','海南省三亚市吉阳区'),(2442,'2016-03-18 11:31:30','2016-03-18 11:31:30','天涯区','460204','海南省三亚市天涯区'),(2443,'2016-03-18 11:31:31','2016-03-18 11:31:31','崖州区','460205','海南省三亚市崖州区'),(2444,'2016-03-18 11:31:31','2016-03-18 11:31:31','三沙市','460300','海南省三沙市'),(2445,'2016-03-18 11:31:31','2016-03-18 11:31:31','省直辖县级行政区划','469000','海南省省直辖县级行政区划'),(2446,'2016-03-18 11:31:31','2016-03-18 11:31:31','五指山市','469001','海南省省直辖县级行政区划五指山市'),(2447,'2016-03-18 11:31:31','2016-03-18 11:31:31','琼海市','469002','海南省省直辖县级行政区划琼海市'),(2448,'2016-03-18 11:31:31','2016-03-18 11:31:31','儋州市','469003','海南省省直辖县级行政区划儋州市'),(2449,'2016-03-18 11:31:31','2016-03-18 11:31:31','文昌市','469005','海南省省直辖县级行政区划文昌市'),(2450,'2016-03-18 11:31:31','2016-03-18 11:31:31','万宁市','469006','海南省省直辖县级行政区划万宁市'),(2451,'2016-03-18 11:31:31','2016-03-18 11:31:31','东方市','469007','海南省省直辖县级行政区划东方市'),(2452,'2016-03-18 11:31:31','2016-03-18 11:31:31','定安县','469021','海南省省直辖县级行政区划定安县'),(2453,'2016-03-18 11:31:31','2016-03-18 11:31:31','屯昌县','469022','海南省省直辖县级行政区划屯昌县'),(2454,'2016-03-18 11:31:31','2016-03-18 11:31:31','澄迈县','469023','海南省省直辖县级行政区划澄迈县'),(2455,'2016-03-18 11:31:31','2016-03-18 11:31:31','临高县','469024','海南省省直辖县级行政区划临高县'),(2456,'2016-03-18 11:31:32','2016-03-18 11:31:32','白沙黎族自治县','469025','海南省省直辖县级行政区划白沙黎族自治县'),(2457,'2016-03-18 11:31:32','2016-03-18 11:31:32','昌江黎族自治县','469026','海南省省直辖县级行政区划昌江黎族自治县'),(2458,'2016-03-18 11:31:32','2016-03-18 11:31:32','乐东黎族自治县','469027','海南省省直辖县级行政区划乐东黎族自治县'),(2459,'2016-03-18 11:31:32','2016-03-18 11:31:32','陵水黎族自治县','469028','海南省省直辖县级行政区划陵水黎族自治县'),(2460,'2016-03-18 11:31:32','2016-03-18 11:31:32','保亭黎族苗族自治县','469029','海南省省直辖县级行政区划保亭黎族苗族自治县'),(2461,'2016-03-18 11:31:32','2016-03-18 11:31:32','琼中黎族苗族自治县','469030','海南省省直辖县级行政区划琼中黎族苗族自治县'),(2462,'2016-03-18 11:31:32','2016-03-18 11:31:32','重庆市','500000','重庆市'),(2463,'2016-03-18 11:31:32','2016-03-18 11:31:32','市辖区','500100','重庆市市辖区'),(2464,'2016-03-18 11:31:32','2016-03-18 11:31:32','万州区','500101','重庆市万州区'),(2465,'2016-03-18 11:31:32','2016-03-18 11:31:32','涪陵区','500102','重庆市涪陵区'),(2466,'2016-03-18 11:31:32','2016-03-18 11:31:32','渝中区','500103','重庆市渝中区'),(2467,'2016-03-18 11:31:32','2016-03-18 11:31:32','大渡口区','500104','重庆市大渡口区'),(2468,'2016-03-18 11:31:32','2016-03-18 11:31:32','江北区','500105','重庆市江北区'),(2469,'2016-03-18 11:31:32','2016-03-18 11:31:32','沙坪坝区','500106','重庆市沙坪坝区'),(2470,'2016-03-18 11:31:32','2016-03-18 11:31:32','九龙坡区','500107','重庆市九龙坡区'),(2471,'2016-03-18 11:31:32','2016-03-18 11:31:32','南岸区','500108','重庆市南岸区'),(2472,'2016-03-18 11:31:32','2016-03-18 11:31:32','北碚区','500109','重庆市北碚区'),(2473,'2016-03-18 11:31:32','2016-03-18 11:31:32','綦江区','500110','重庆市綦江区'),(2474,'2016-03-18 11:31:33','2016-03-18 11:31:33','大足区','500111','重庆市大足区'),(2475,'2016-03-18 11:31:33','2016-03-18 11:31:33','渝北区','500112','重庆市渝北区'),(2476,'2016-03-18 11:31:33','2016-03-18 11:31:33','巴南区','500113','重庆市巴南区'),(2477,'2016-03-18 11:31:33','2016-03-18 11:31:33','黔江区','500114','重庆市黔江区'),(2478,'2016-03-18 11:31:33','2016-03-18 11:31:33','长寿区','500115','重庆市长寿区'),(2479,'2016-03-18 11:31:33','2016-03-18 11:31:33','江津区','500116','重庆市江津区'),(2480,'2016-03-18 11:31:33','2016-03-18 11:31:33','合川区','500117','重庆市合川区'),(2481,'2016-03-18 11:31:33','2016-03-18 11:31:33','永川区','500118','重庆市永川区'),(2482,'2016-03-18 11:31:33','2016-03-18 11:31:33','南川区','500119','重庆市南川区'),(2483,'2016-03-18 11:31:33','2016-03-18 11:31:33','璧山区','500120','重庆市璧山区'),(2484,'2016-03-18 11:31:33','2016-03-18 11:31:33','铜梁区','500151','重庆市铜梁区'),(2485,'2016-03-18 11:31:33','2016-03-18 11:31:33','县','500200','重庆市县'),(2486,'2016-03-18 11:31:33','2016-03-18 11:31:33','潼南县','500223','重庆市潼南县'),(2487,'2016-03-18 11:31:33','2016-03-18 11:31:33','荣昌县','500226','重庆市荣昌县'),(2488,'2016-03-18 11:31:33','2016-03-18 11:31:33','梁平县','500228','重庆市梁平县'),(2489,'2016-03-18 11:31:34','2016-03-18 11:31:34','城口县','500229','重庆市城口县'),(2490,'2016-03-18 11:31:34','2016-03-18 11:31:34','丰都县','500230','重庆市丰都县'),(2491,'2016-03-18 11:31:34','2016-03-18 11:31:34','垫江县','500231','重庆市垫江县'),(2492,'2016-03-18 11:31:34','2016-03-18 11:31:34','武隆县','500232','重庆市武隆县'),(2493,'2016-03-18 11:31:34','2016-03-18 11:31:34','忠县','500233','重庆市忠县'),(2494,'2016-03-18 11:31:34','2016-03-18 11:31:34','开县','500234','重庆市开县'),(2495,'2016-03-18 11:31:34','2016-03-18 11:31:34','云阳县','500235','重庆市云阳县'),(2496,'2016-03-18 11:31:34','2016-03-18 11:31:34','奉节县','500236','重庆市奉节县'),(2497,'2016-03-18 11:31:34','2016-03-18 11:31:34','巫山县','500237','重庆市巫山县'),(2498,'2016-03-18 11:31:34','2016-03-18 11:31:34','巫溪县','500238','重庆市巫溪县'),(2499,'2016-03-18 11:31:34','2016-03-18 11:31:34','石柱土家族自治县','500240','重庆市石柱土家族自治县'),(2500,'2016-03-18 11:31:34','2016-03-18 11:31:34','秀山土家族苗族自治县','500241','重庆市秀山土家族苗族自治县'),(2501,'2016-03-18 11:31:34','2016-03-18 11:31:34','酉阳土家族苗族自治县','500242','重庆市酉阳土家族苗族自治县'),(2502,'2016-03-18 11:31:34','2016-03-18 11:31:34','彭水苗族土家族自治县','500243','重庆市彭水苗族土家族自治县'),(2503,'2016-03-18 11:31:35','2016-03-18 11:31:35','四川省','510000','四川省'),(2504,'2016-03-18 11:31:35','2016-03-18 11:31:35','成都市','510100','四川省成都市'),(2505,'2016-03-18 11:31:35','2016-03-18 11:31:35','市辖区','510101','四川省成都市市辖区'),(2506,'2016-03-18 11:31:35','2016-03-18 11:31:35','锦江区','510104','四川省成都市锦江区'),(2507,'2016-03-18 11:31:35','2016-03-18 11:31:35','青羊区','510105','四川省成都市青羊区'),(2508,'2016-03-18 11:31:35','2016-03-18 11:31:35','金牛区','510106','四川省成都市金牛区'),(2509,'2016-03-18 11:31:35','2016-03-18 11:31:35','武侯区','510107','四川省成都市武侯区'),(2510,'2016-03-18 11:31:35','2016-03-18 11:31:35','成华区','510108','四川省成都市成华区'),(2511,'2016-03-18 11:31:35','2016-03-18 11:31:35','龙泉驿区','510112','四川省成都市龙泉驿区'),(2512,'2016-03-18 11:31:35','2016-03-18 11:31:35','青白江区','510113','四川省成都市青白江区'),(2513,'2016-03-18 11:31:35','2016-03-18 11:31:35','新都区','510114','四川省成都市新都区'),(2514,'2016-03-18 11:31:35','2016-03-18 11:31:35','温江区','510115','四川省成都市温江区'),(2515,'2016-03-18 11:31:35','2016-03-18 11:31:35','金堂县','510121','四川省成都市金堂县'),(2516,'2016-03-18 11:31:35','2016-03-18 11:31:35','双流县','510122','四川省成都市双流县'),(2517,'2016-03-18 11:31:36','2016-03-18 11:31:36','郫县','510124','四川省成都市郫县'),(2518,'2016-03-18 11:31:36','2016-03-18 11:31:36','大邑县','510129','四川省成都市大邑县'),(2519,'2016-03-18 11:31:36','2016-03-18 11:31:36','蒲江县','510131','四川省成都市蒲江县'),(2520,'2016-03-18 11:31:36','2016-03-18 11:31:36','新津县','510132','四川省成都市新津县'),(2521,'2016-03-18 11:31:36','2016-03-18 11:31:36','都江堰市','510181','四川省成都市都江堰市'),(2522,'2016-03-18 11:31:36','2016-03-18 11:31:36','彭州市','510182','四川省成都市彭州市'),(2523,'2016-03-18 11:31:36','2016-03-18 11:31:36','邛崃市','510183','四川省成都市邛崃市'),(2524,'2016-03-18 11:31:36','2016-03-18 11:31:36','崇州市','510184','四川省成都市崇州市'),(2525,'2016-03-18 11:31:36','2016-03-18 11:31:36','自贡市','510300','四川省自贡市'),(2526,'2016-03-18 11:31:36','2016-03-18 11:31:36','市辖区','510301','四川省自贡市市辖区'),(2527,'2016-03-18 11:31:36','2016-03-18 11:31:36','自流井区','510302','四川省自贡市自流井区'),(2528,'2016-03-18 11:31:36','2016-03-18 11:31:36','贡井区','510303','四川省自贡市贡井区'),(2529,'2016-03-18 11:31:36','2016-03-18 11:31:36','大安区','510304','四川省自贡市大安区'),(2530,'2016-03-18 11:31:36','2016-03-18 11:31:36','沿滩区','510311','四川省自贡市沿滩区'),(2531,'2016-03-18 11:31:36','2016-03-18 11:31:36','荣县','510321','四川省自贡市荣县'),(2532,'2016-03-18 11:31:37','2016-03-18 11:31:37','富顺县','510322','四川省自贡市富顺县'),(2533,'2016-03-18 11:31:37','2016-03-18 11:31:37','攀枝花市','510400','四川省攀枝花市'),(2534,'2016-03-18 11:31:37','2016-03-18 11:31:37','市辖区','510401','四川省攀枝花市市辖区'),(2535,'2016-03-18 11:31:37','2016-03-18 11:31:37','东区','510402','四川省攀枝花市东区'),(2536,'2016-03-18 11:31:37','2016-03-18 11:31:37','西区','510403','四川省攀枝花市西区'),(2537,'2016-03-18 11:31:37','2016-03-18 11:31:37','仁和区','510411','四川省攀枝花市仁和区'),(2538,'2016-03-18 11:31:37','2016-03-18 11:31:37','米易县','510421','四川省攀枝花市米易县'),(2539,'2016-03-18 11:31:37','2016-03-18 11:31:37','盐边县','510422','四川省攀枝花市盐边县'),(2540,'2016-03-18 11:31:37','2016-03-18 11:31:37','泸州市','510500','四川省泸州市'),(2541,'2016-03-18 11:31:37','2016-03-18 11:31:37','市辖区','510501','四川省泸州市市辖区'),(2542,'2016-03-18 11:31:37','2016-03-18 11:31:37','江阳区','510502','四川省泸州市江阳区'),(2543,'2016-03-18 11:31:37','2016-03-18 11:31:37','纳溪区','510503','四川省泸州市纳溪区'),(2544,'2016-03-18 11:31:37','2016-03-18 11:31:37','龙马潭区','510504','四川省泸州市龙马潭区'),(2545,'2016-03-18 11:31:38','2016-03-18 11:31:38','泸县','510521','四川省泸州市泸县'),(2546,'2016-03-18 11:31:38','2016-03-18 11:31:38','合江县','510522','四川省泸州市合江县'),(2547,'2016-03-18 11:31:38','2016-03-18 11:31:38','叙永县','510524','四川省泸州市叙永县'),(2548,'2016-03-18 11:31:38','2016-03-18 11:31:38','古蔺县','510525','四川省泸州市古蔺县'),(2549,'2016-03-18 11:31:38','2016-03-18 11:31:38','德阳市','510600','四川省德阳市'),(2550,'2016-03-18 11:31:38','2016-03-18 11:31:38','市辖区','510601','四川省德阳市市辖区'),(2551,'2016-03-18 11:31:38','2016-03-18 11:31:38','旌阳区','510603','四川省德阳市旌阳区'),(2552,'2016-03-18 11:31:38','2016-03-18 11:31:38','中江县','510623','四川省德阳市中江县'),(2553,'2016-03-18 11:31:38','2016-03-18 11:31:38','罗江县','510626','四川省德阳市罗江县'),(2554,'2016-03-18 11:31:38','2016-03-18 11:31:38','广汉市','510681','四川省德阳市广汉市'),(2555,'2016-03-18 11:31:38','2016-03-18 11:31:38','什邡市','510682','四川省德阳市什邡市'),(2556,'2016-03-18 11:31:38','2016-03-18 11:31:38','绵竹市','510683','四川省德阳市绵竹市'),(2557,'2016-03-18 11:31:38','2016-03-18 11:31:38','绵阳市','510700','四川省绵阳市'),(2558,'2016-03-18 11:31:38','2016-03-18 11:31:38','市辖区','510701','四川省绵阳市市辖区'),(2559,'2016-03-18 11:31:39','2016-03-18 11:31:39','涪城区','510703','四川省绵阳市涪城区'),(2560,'2016-03-18 11:31:39','2016-03-18 11:31:39','游仙区','510704','四川省绵阳市游仙区'),(2561,'2016-03-18 11:31:39','2016-03-18 11:31:39','三台县','510722','四川省绵阳市三台县'),(2562,'2016-03-18 11:31:39','2016-03-18 11:31:39','盐亭县','510723','四川省绵阳市盐亭县'),(2563,'2016-03-18 11:31:39','2016-03-18 11:31:39','安县','510724','四川省绵阳市安县'),(2564,'2016-03-18 11:31:39','2016-03-18 11:31:39','梓潼县','510725','四川省绵阳市梓潼县'),(2565,'2016-03-18 11:31:39','2016-03-18 11:31:39','北川羌族自治县','510726','四川省绵阳市北川羌族自治县'),(2566,'2016-03-18 11:31:39','2016-03-18 11:31:39','平武县','510727','四川省绵阳市平武县'),(2567,'2016-03-18 11:31:39','2016-03-18 11:31:39','江油市','510781','四川省绵阳市江油市'),(2568,'2016-03-18 11:31:39','2016-03-18 11:31:39','广元市','510800','四川省广元市'),(2569,'2016-03-18 11:31:39','2016-03-18 11:31:39','市辖区','510801','四川省广元市市辖区'),(2570,'2016-03-18 11:31:39','2016-03-18 11:31:39','利州区','510802','四川省广元市利州区'),(2571,'2016-03-18 11:31:39','2016-03-18 11:31:39','昭化区','510811','四川省广元市昭化区'),(2572,'2016-03-18 11:31:39','2016-03-18 11:31:39','朝天区','510812','四川省广元市朝天区'),(2573,'2016-03-18 11:31:40','2016-03-18 11:31:40','旺苍县','510821','四川省广元市旺苍县'),(2574,'2016-03-18 11:31:40','2016-03-18 11:31:40','青川县','510822','四川省广元市青川县'),(2575,'2016-03-18 11:31:40','2016-03-18 11:31:40','剑阁县','510823','四川省广元市剑阁县'),(2576,'2016-03-18 11:31:40','2016-03-18 11:31:40','苍溪县','510824','四川省广元市苍溪县'),(2577,'2016-03-18 11:31:40','2016-03-18 11:31:40','遂宁市','510900','四川省遂宁市'),(2578,'2016-03-18 11:31:40','2016-03-18 11:31:40','市辖区','510901','四川省遂宁市市辖区'),(2579,'2016-03-18 11:31:40','2016-03-18 11:31:40','船山区','510903','四川省遂宁市船山区'),(2580,'2016-03-18 11:31:40','2016-03-18 11:31:40','安居区','510904','四川省遂宁市安居区'),(2581,'2016-03-18 11:31:40','2016-03-18 11:31:40','蓬溪县','510921','四川省遂宁市蓬溪县'),(2582,'2016-03-18 11:31:40','2016-03-18 11:31:40','射洪县','510922','四川省遂宁市射洪县'),(2583,'2016-03-18 11:31:40','2016-03-18 11:31:40','大英县','510923','四川省遂宁市大英县'),(2584,'2016-03-18 11:31:40','2016-03-18 11:31:40','内江市','511000','四川省内江市'),(2585,'2016-03-18 11:31:41','2016-03-18 11:31:41','市辖区','511001','四川省内江市市辖区'),(2586,'2016-03-18 11:31:41','2016-03-18 11:31:41','市中区','511002','四川省内江市市中区'),(2587,'2016-03-18 11:31:41','2016-03-18 11:31:41','东兴区','511011','四川省内江市东兴区'),(2588,'2016-03-18 11:31:41','2016-03-18 11:31:41','威远县','511024','四川省内江市威远县'),(2589,'2016-03-18 11:31:41','2016-03-18 11:31:41','资中县','511025','四川省内江市资中县'),(2590,'2016-03-18 11:31:41','2016-03-18 11:31:41','隆昌县','511028','四川省内江市隆昌县'),(2591,'2016-03-18 11:31:41','2016-03-18 11:31:41','乐山市','511100','四川省乐山市'),(2592,'2016-03-18 11:31:41','2016-03-18 11:31:41','市辖区','511101','四川省乐山市市辖区'),(2593,'2016-03-18 11:31:41','2016-03-18 11:31:41','市中区','511102','四川省乐山市市中区'),(2594,'2016-03-18 11:31:41','2016-03-18 11:31:41','沙湾区','511111','四川省乐山市沙湾区'),(2595,'2016-03-18 11:31:41','2016-03-18 11:31:41','五通桥区','511112','四川省乐山市五通桥区'),(2596,'2016-03-18 11:31:41','2016-03-18 11:31:41','金口河区','511113','四川省乐山市金口河区'),(2597,'2016-03-18 11:31:41','2016-03-18 11:31:41','犍为县','511123','四川省乐山市犍为县'),(2598,'2016-03-18 11:31:41','2016-03-18 11:31:41','井研县','511124','四川省乐山市井研县'),(2599,'2016-03-18 11:31:41','2016-03-18 11:31:41','夹江县','511126','四川省乐山市夹江县'),(2600,'2016-03-18 11:31:41','2016-03-18 11:31:41','沐川县','511129','四川省乐山市沐川县'),(2601,'2016-03-18 11:31:41','2016-03-18 11:31:41','峨边彝族自治县','511132','四川省乐山市峨边彝族自治县'),(2602,'2016-03-18 11:31:41','2016-03-18 11:31:41','马边彝族自治县','511133','四川省乐山市马边彝族自治县'),(2603,'2016-03-18 11:31:41','2016-03-18 11:31:41','峨眉山市','511181','四川省乐山市峨眉山市'),(2604,'2016-03-18 11:31:42','2016-03-18 11:31:42','南充市','511300','四川省南充市'),(2605,'2016-03-18 11:31:42','2016-03-18 11:31:42','市辖区','511301','四川省南充市市辖区'),(2606,'2016-03-18 11:31:42','2016-03-18 11:31:42','顺庆区','511302','四川省南充市顺庆区'),(2607,'2016-03-18 11:31:42','2016-03-18 11:31:42','高坪区','511303','四川省南充市高坪区'),(2608,'2016-03-18 11:31:42','2016-03-18 11:31:42','嘉陵区','511304','四川省南充市嘉陵区'),(2609,'2016-03-18 11:31:42','2016-03-18 11:31:42','南部县','511321','四川省南充市南部县'),(2610,'2016-03-18 11:31:42','2016-03-18 11:31:42','营山县','511322','四川省南充市营山县'),(2611,'2016-03-18 11:31:42','2016-03-18 11:31:42','蓬安县','511323','四川省南充市蓬安县'),(2612,'2016-03-18 11:31:42','2016-03-18 11:31:42','仪陇县','511324','四川省南充市仪陇县'),(2613,'2016-03-18 11:31:42','2016-03-18 11:31:42','西充县','511325','四川省南充市西充县'),(2614,'2016-03-18 11:31:42','2016-03-18 11:31:42','阆中市','511381','四川省南充市阆中市'),(2615,'2016-03-18 11:31:42','2016-03-18 11:31:42','眉山市','511400','四川省眉山市'),(2616,'2016-03-18 11:31:42','2016-03-18 11:31:42','市辖区','511401','四川省眉山市市辖区'),(2617,'2016-03-18 11:31:42','2016-03-18 11:31:42','东坡区','511402','四川省眉山市东坡区'),(2618,'2016-03-18 11:31:42','2016-03-18 11:31:42','仁寿县','511421','四川省眉山市仁寿县'),(2619,'2016-03-18 11:31:42','2016-03-18 11:31:42','彭山县','511422','四川省眉山市彭山县'),(2620,'2016-03-18 11:31:42','2016-03-18 11:31:42','洪雅县','511423','四川省眉山市洪雅县'),(2621,'2016-03-18 11:31:42','2016-03-18 11:31:42','丹棱县','511424','四川省眉山市丹棱县'),(2622,'2016-03-18 11:31:42','2016-03-18 11:31:42','青神县','511425','四川省眉山市青神县'),(2623,'2016-03-18 11:31:42','2016-03-18 11:31:42','宜宾市','511500','四川省宜宾市'),(2624,'2016-03-18 11:31:43','2016-03-18 11:31:43','市辖区','511501','四川省宜宾市市辖区'),(2625,'2016-03-18 11:31:43','2016-03-18 11:31:43','翠屏区','511502','四川省宜宾市翠屏区'),(2626,'2016-03-18 11:31:43','2016-03-18 11:31:43','南溪区','511503','四川省宜宾市南溪区'),(2627,'2016-03-18 11:31:43','2016-03-18 11:31:43','宜宾县','511521','四川省宜宾市宜宾县'),(2628,'2016-03-18 11:31:43','2016-03-18 11:31:43','江安县','511523','四川省宜宾市江安县'),(2629,'2016-03-18 11:31:43','2016-03-18 11:31:43','长宁县','511524','四川省宜宾市长宁县'),(2630,'2016-03-18 11:31:43','2016-03-18 11:31:43','高县','511525','四川省宜宾市高县'),(2631,'2016-03-18 11:31:43','2016-03-18 11:31:43','珙县','511526','四川省宜宾市珙县'),(2632,'2016-03-18 11:31:43','2016-03-18 11:31:43','筠连县','511527','四川省宜宾市筠连县'),(2633,'2016-03-18 11:31:43','2016-03-18 11:31:43','兴文县','511528','四川省宜宾市兴文县'),(2634,'2016-03-18 11:31:43','2016-03-18 11:31:43','屏山县','511529','四川省宜宾市屏山县'),(2635,'2016-03-18 11:31:43','2016-03-18 11:31:43','广安市','511600','四川省广安市'),(2636,'2016-03-18 11:31:43','2016-03-18 11:31:43','市辖区','511601','四川省广安市市辖区'),(2637,'2016-03-18 11:31:43','2016-03-18 11:31:43','广安区','511602','四川省广安市广安区'),(2638,'2016-03-18 11:31:43','2016-03-18 11:31:43','前锋区','511603','四川省广安市前锋区'),(2639,'2016-03-18 11:31:43','2016-03-18 11:31:43','岳池县','511621','四川省广安市岳池县'),(2640,'2016-03-18 11:31:44','2016-03-18 11:31:44','武胜县','511622','四川省广安市武胜县'),(2641,'2016-03-18 11:31:44','2016-03-18 11:31:44','邻水县','511623','四川省广安市邻水县'),(2642,'2016-03-18 11:31:44','2016-03-18 11:31:44','华蓥市','511681','四川省广安市华蓥市'),(2643,'2016-03-18 11:31:44','2016-03-18 11:31:44','达州市','511700','四川省达州市'),(2644,'2016-03-18 11:31:44','2016-03-18 11:31:44','市辖区','511701','四川省达州市市辖区'),(2645,'2016-03-18 11:31:44','2016-03-18 11:31:44','通川区','511702','四川省达州市通川区'),(2646,'2016-03-18 11:31:44','2016-03-18 11:31:44','达川区','511703','四川省达州市达川区'),(2647,'2016-03-18 11:31:44','2016-03-18 11:31:44','宣汉县','511722','四川省达州市宣汉县'),(2648,'2016-03-18 11:31:44','2016-03-18 11:31:44','开江县','511723','四川省达州市开江县'),(2649,'2016-03-18 11:31:44','2016-03-18 11:31:44','大竹县','511724','四川省达州市大竹县'),(2650,'2016-03-18 11:31:44','2016-03-18 11:31:44','渠县','511725','四川省达州市渠县'),(2651,'2016-03-18 11:31:44','2016-03-18 11:31:44','万源市','511781','四川省达州市万源市'),(2652,'2016-03-18 11:31:44','2016-03-18 11:31:44','雅安市','511800','四川省雅安市'),(2653,'2016-03-18 11:31:44','2016-03-18 11:31:44','市辖区','511801','四川省雅安市市辖区'),(2654,'2016-03-18 11:31:44','2016-03-18 11:31:44','雨城区','511802','四川省雅安市雨城区'),(2655,'2016-03-18 11:31:44','2016-03-18 11:31:44','名山区','511803','四川省雅安市名山区'),(2656,'2016-03-18 11:31:44','2016-03-18 11:31:44','荥经县','511822','四川省雅安市荥经县'),(2657,'2016-03-18 11:31:45','2016-03-18 11:31:45','汉源县','511823','四川省雅安市汉源县'),(2658,'2016-03-18 11:31:45','2016-03-18 11:31:45','石棉县','511824','四川省雅安市石棉县'),(2659,'2016-03-18 11:31:45','2016-03-18 11:31:45','天全县','511825','四川省雅安市天全县'),(2660,'2016-03-18 11:31:45','2016-03-18 11:31:45','芦山县','511826','四川省雅安市芦山县'),(2661,'2016-03-18 11:31:45','2016-03-18 11:31:45','宝兴县','511827','四川省雅安市宝兴县'),(2662,'2016-03-18 11:31:45','2016-03-18 11:31:45','巴中市','511900','四川省巴中市'),(2663,'2016-03-18 11:31:45','2016-03-18 11:31:45','市辖区','511901','四川省巴中市市辖区'),(2664,'2016-03-18 11:31:45','2016-03-18 11:31:45','巴州区','511902','四川省巴中市巴州区'),(2665,'2016-03-18 11:31:45','2016-03-18 11:31:45','恩阳区','511903','四川省巴中市恩阳区'),(2666,'2016-03-18 11:31:45','2016-03-18 11:31:45','通江县','511921','四川省巴中市通江县'),(2667,'2016-03-18 11:31:45','2016-03-18 11:31:45','南江县','511922','四川省巴中市南江县'),(2668,'2016-03-18 11:31:45','2016-03-18 11:31:45','平昌县','511923','四川省巴中市平昌县'),(2669,'2016-03-18 11:31:45','2016-03-18 11:31:45','资阳市','512000','四川省资阳市'),(2670,'2016-03-18 11:31:45','2016-03-18 11:31:45','市辖区','512001','四川省资阳市市辖区'),(2671,'2016-03-18 11:31:45','2016-03-18 11:31:45','雁江区','512002','四川省资阳市雁江区'),(2672,'2016-03-18 11:31:45','2016-03-18 11:31:45','安岳县','512021','四川省资阳市安岳县'),(2673,'2016-03-18 11:31:45','2016-03-18 11:31:45','乐至县','512022','四川省资阳市乐至县'),(2674,'2016-03-18 11:31:46','2016-03-18 11:31:46','简阳市','512081','四川省资阳市简阳市'),(2675,'2016-03-18 11:31:46','2016-03-18 11:31:46','阿坝藏族羌族自治州','513200','四川省阿坝藏族羌族自治州'),(2676,'2016-03-18 11:31:46','2016-03-18 11:31:46','汶川县','513221','四川省阿坝藏族羌族自治州汶川县'),(2677,'2016-03-18 11:31:46','2016-03-18 11:31:46','理县','513222','四川省阿坝藏族羌族自治州理县'),(2678,'2016-03-18 11:31:46','2016-03-18 11:31:46','茂县','513223','四川省阿坝藏族羌族自治州茂县'),(2679,'2016-03-18 11:31:46','2016-03-18 11:31:46','松潘县','513224','四川省阿坝藏族羌族自治州松潘县'),(2680,'2016-03-18 11:31:46','2016-03-18 11:31:46','九寨沟县','513225','四川省阿坝藏族羌族自治州九寨沟县'),(2681,'2016-03-18 11:31:46','2016-03-18 11:31:46','金川县','513226','四川省阿坝藏族羌族自治州金川县'),(2682,'2016-03-18 11:31:46','2016-03-18 11:31:46','小金县','513227','四川省阿坝藏族羌族自治州小金县'),(2683,'2016-03-18 11:31:46','2016-03-18 11:31:46','黑水县','513228','四川省阿坝藏族羌族自治州黑水县'),(2684,'2016-03-18 11:31:46','2016-03-18 11:31:46','马尔康县','513229','四川省阿坝藏族羌族自治州马尔康县'),(2685,'2016-03-18 11:31:46','2016-03-18 11:31:46','壤塘县','513230','四川省阿坝藏族羌族自治州壤塘县'),(2686,'2016-03-18 11:31:46','2016-03-18 11:31:46','阿坝县','513231','四川省阿坝藏族羌族自治州阿坝县'),(2687,'2016-03-18 11:31:46','2016-03-18 11:31:46','若尔盖县','513232','四川省阿坝藏族羌族自治州若尔盖县'),(2688,'2016-03-18 11:31:47','2016-03-18 11:31:47','红原县','513233','四川省阿坝藏族羌族自治州红原县'),(2689,'2016-03-18 11:31:47','2016-03-18 11:31:47','甘孜藏族自治州','513300','四川省甘孜藏族自治州'),(2690,'2016-03-18 11:31:47','2016-03-18 11:31:47','康定县','513321','四川省甘孜藏族自治州康定县'),(2691,'2016-03-18 11:31:47','2016-03-18 11:31:47','泸定县','513322','四川省甘孜藏族自治州泸定县'),(2692,'2016-03-18 11:31:47','2016-03-18 11:31:47','丹巴县','513323','四川省甘孜藏族自治州丹巴县'),(2693,'2016-03-18 11:31:47','2016-03-18 11:31:47','九龙县','513324','四川省甘孜藏族自治州九龙县'),(2694,'2016-03-18 11:31:47','2016-03-18 11:31:47','雅江县','513325','四川省甘孜藏族自治州雅江县'),(2695,'2016-03-18 11:31:47','2016-03-18 11:31:47','道孚县','513326','四川省甘孜藏族自治州道孚县'),(2696,'2016-03-18 11:31:47','2016-03-18 11:31:47','炉霍县','513327','四川省甘孜藏族自治州炉霍县'),(2697,'2016-03-18 11:31:47','2016-03-18 11:31:47','甘孜县','513328','四川省甘孜藏族自治州甘孜县'),(2698,'2016-03-18 11:31:47','2016-03-18 11:31:47','新龙县','513329','四川省甘孜藏族自治州新龙县'),(2699,'2016-03-18 11:31:47','2016-03-18 11:31:47','德格县','513330','四川省甘孜藏族自治州德格县'),(2700,'2016-03-18 11:31:47','2016-03-18 11:31:47','白玉县','513331','四川省甘孜藏族自治州白玉县'),(2701,'2016-03-18 11:31:47','2016-03-18 11:31:47','石渠县','513332','四川省甘孜藏族自治州石渠县'),(2702,'2016-03-18 11:31:47','2016-03-18 11:31:47','色达县','513333','四川省甘孜藏族自治州色达县'),(2703,'2016-03-18 11:31:48','2016-03-18 11:31:48','理塘县','513334','四川省甘孜藏族自治州理塘县'),(2704,'2016-03-18 11:31:48','2016-03-18 11:31:48','巴塘县','513335','四川省甘孜藏族自治州巴塘县'),(2705,'2016-03-18 11:31:48','2016-03-18 11:31:48','乡城县','513336','四川省甘孜藏族自治州乡城县'),(2706,'2016-03-18 11:31:48','2016-03-18 11:31:48','稻城县','513337','四川省甘孜藏族自治州稻城县'),(2707,'2016-03-18 11:31:48','2016-03-18 11:31:48','得荣县','513338','四川省甘孜藏族自治州得荣县'),(2708,'2016-03-18 11:31:48','2016-03-18 11:31:48','凉山彝族自治州','513400','四川省凉山彝族自治州'),(2709,'2016-03-18 11:31:48','2016-03-18 11:31:48','西昌市','513401','四川省凉山彝族自治州西昌市'),(2710,'2016-03-18 11:31:48','2016-03-18 11:31:48','木里藏族自治县','513422','四川省凉山彝族自治州木里藏族自治县'),(2711,'2016-03-18 11:31:48','2016-03-18 11:31:48','盐源县','513423','四川省凉山彝族自治州盐源县'),(2712,'2016-03-18 11:31:48','2016-03-18 11:31:48','德昌县','513424','四川省凉山彝族自治州德昌县'),(2713,'2016-03-18 11:31:48','2016-03-18 11:31:48','会理县','513425','四川省凉山彝族自治州会理县'),(2714,'2016-03-18 11:31:48','2016-03-18 11:31:48','会东县','513426','四川省凉山彝族自治州会东县'),(2715,'2016-03-18 11:31:48','2016-03-18 11:31:48','宁南县','513427','四川省凉山彝族自治州宁南县'),(2716,'2016-03-18 11:31:48','2016-03-18 11:31:48','普格县','513428','四川省凉山彝族自治州普格县'),(2717,'2016-03-18 11:31:48','2016-03-18 11:31:48','布拖县','513429','四川省凉山彝族自治州布拖县'),(2718,'2016-03-18 11:31:48','2016-03-18 11:31:48','金阳县','513430','四川省凉山彝族自治州金阳县'),(2719,'2016-03-18 11:31:49','2016-03-18 11:31:49','昭觉县','513431','四川省凉山彝族自治州昭觉县'),(2720,'2016-03-18 11:31:49','2016-03-18 11:31:49','喜德县','513432','四川省凉山彝族自治州喜德县'),(2721,'2016-03-18 11:31:49','2016-03-18 11:31:49','冕宁县','513433','四川省凉山彝族自治州冕宁县'),(2722,'2016-03-18 11:31:49','2016-03-18 11:31:49','越西县','513434','四川省凉山彝族自治州越西县'),(2723,'2016-03-18 11:31:49','2016-03-18 11:31:49','甘洛县','513435','四川省凉山彝族自治州甘洛县'),(2724,'2016-03-18 11:31:49','2016-03-18 11:31:49','美姑县','513436','四川省凉山彝族自治州美姑县'),(2725,'2016-03-18 11:31:49','2016-03-18 11:31:49','雷波县','513437','四川省凉山彝族自治州雷波县'),(2726,'2016-03-18 11:31:49','2016-03-18 11:31:49','贵州省','520000','贵州省'),(2727,'2016-03-18 11:31:49','2016-03-18 11:31:49','贵阳市','520100','贵州省贵阳市'),(2728,'2016-03-18 11:31:49','2016-03-18 11:31:49','市辖区','520101','贵州省贵阳市市辖区'),(2729,'2016-03-18 11:31:49','2016-03-18 11:31:49','南明区','520102','贵州省贵阳市南明区'),(2730,'2016-03-18 11:31:50','2016-03-18 11:31:50','云岩区','520103','贵州省贵阳市云岩区'),(2731,'2016-03-18 11:31:50','2016-03-18 11:31:50','花溪区','520111','贵州省贵阳市花溪区'),(2732,'2016-03-18 11:31:50','2016-03-18 11:31:50','乌当区','520112','贵州省贵阳市乌当区'),(2733,'2016-03-18 11:31:50','2016-03-18 11:31:50','白云区','520113','贵州省贵阳市白云区'),(2734,'2016-03-18 11:31:50','2016-03-18 11:31:50','观山湖区','520115','贵州省贵阳市观山湖区'),(2735,'2016-03-18 11:31:50','2016-03-18 11:31:50','开阳县','520121','贵州省贵阳市开阳县'),(2736,'2016-03-18 11:31:50','2016-03-18 11:31:50','息烽县','520122','贵州省贵阳市息烽县'),(2737,'2016-03-18 11:31:50','2016-03-18 11:31:50','修文县','520123','贵州省贵阳市修文县'),(2738,'2016-03-18 11:31:50','2016-03-18 11:31:50','清镇市','520181','贵州省贵阳市清镇市'),(2739,'2016-03-18 11:31:50','2016-03-18 11:31:50','六盘水市','520200','贵州省六盘水市'),(2740,'2016-03-18 11:31:50','2016-03-18 11:31:50','钟山区','520201','贵州省六盘水市钟山区'),(2741,'2016-03-18 11:31:50','2016-03-18 11:31:50','六枝特区','520203','贵州省六盘水市六枝特区'),(2742,'2016-03-18 11:31:50','2016-03-18 11:31:50','水城县','520221','贵州省六盘水市水城县'),(2743,'2016-03-18 11:31:50','2016-03-18 11:31:50','盘县','520222','贵州省六盘水市盘县'),(2744,'2016-03-18 11:31:50','2016-03-18 11:31:50','遵义市','520300','贵州省遵义市'),(2745,'2016-03-18 11:31:51','2016-03-18 11:31:51','市辖区','520301','贵州省遵义市市辖区'),(2746,'2016-03-18 11:31:51','2016-03-18 11:31:51','红花岗区','520302','贵州省遵义市红花岗区'),(2747,'2016-03-18 11:31:51','2016-03-18 11:31:51','汇川区','520303','贵州省遵义市汇川区'),(2748,'2016-03-18 11:31:51','2016-03-18 11:31:51','遵义县','520321','贵州省遵义市遵义县'),(2749,'2016-03-18 11:31:51','2016-03-18 11:31:51','桐梓县','520322','贵州省遵义市桐梓县'),(2750,'2016-03-18 11:31:51','2016-03-18 11:31:51','绥阳县','520323','贵州省遵义市绥阳县'),(2751,'2016-03-18 11:31:51','2016-03-18 11:31:51','正安县','520324','贵州省遵义市正安县'),(2752,'2016-03-18 11:31:51','2016-03-18 11:31:51','道真仡佬族苗族自治县','520325','贵州省遵义市道真仡佬族苗族自治县'),(2753,'2016-03-18 11:31:51','2016-03-18 11:31:51','务川仡佬族苗族自治县','520326','贵州省遵义市务川仡佬族苗族自治县'),(2754,'2016-03-18 11:31:51','2016-03-18 11:31:51','凤冈县','520327','贵州省遵义市凤冈县'),(2755,'2016-03-18 11:31:51','2016-03-18 11:31:51','湄潭县','520328','贵州省遵义市湄潭县'),(2756,'2016-03-18 11:31:51','2016-03-18 11:31:51','余庆县','520329','贵州省遵义市余庆县'),(2757,'2016-03-18 11:31:51','2016-03-18 11:31:51','习水县','520330','贵州省遵义市习水县'),(2758,'2016-03-18 11:31:52','2016-03-18 11:31:52','赤水市','520381','贵州省遵义市赤水市'),(2759,'2016-03-18 11:31:52','2016-03-18 11:31:52','仁怀市','520382','贵州省遵义市仁怀市'),(2760,'2016-03-18 11:31:52','2016-03-18 11:31:52','安顺市','520400','贵州省安顺市'),(2761,'2016-03-18 11:31:52','2016-03-18 11:31:52','市辖区','520401','贵州省安顺市市辖区'),(2762,'2016-03-18 11:31:52','2016-03-18 11:31:52','西秀区','520402','贵州省安顺市西秀区'),(2763,'2016-03-18 11:31:52','2016-03-18 11:31:52','平坝县','520421','贵州省安顺市平坝县'),(2764,'2016-03-18 11:31:52','2016-03-18 11:31:52','普定县','520422','贵州省安顺市普定县'),(2765,'2016-03-18 11:31:52','2016-03-18 11:31:52','镇宁布依族苗族自治县','520423','贵州省安顺��镇宁布依族苗族自治县'),(2766,'2016-03-18 11:31:52','2016-03-18 11:31:52','关岭布依族苗族自治县','520424','贵州省安顺市关岭布依族苗族自治县'),(2767,'2016-03-18 11:31:52','2016-03-18 11:31:52','紫云苗族布依族自治县','520425','贵州省安顺市紫云苗族布依族自治县'),(2768,'2016-03-18 11:31:52','2016-03-18 11:31:52','毕节市','520500','贵州省毕节市'),(2769,'2016-03-18 11:31:53','2016-03-18 11:31:53','市辖区','520501','贵州省毕节市市辖区'),(2770,'2016-03-18 11:31:53','2016-03-18 11:31:53','七星关区','520502','贵州省毕节市七星关区'),(2771,'2016-03-18 11:31:53','2016-03-18 11:31:53','大方县','520521','贵州省毕节市大方县'),(2772,'2016-03-18 11:31:53','2016-03-18 11:31:53','黔西县','520522','贵州省毕节市黔西县'),(2773,'2016-03-18 11:31:53','2016-03-18 11:31:53','金沙县','520523','贵州省毕节市金沙县'),(2774,'2016-03-18 11:31:53','2016-03-18 11:31:53','织金县','520524','贵州省毕节市织金县'),(2775,'2016-03-18 11:31:53','2016-03-18 11:31:53','纳雍县','520525','贵州省毕节市纳雍县'),(2776,'2016-03-18 11:31:53','2016-03-18 11:31:53','威宁彝族回族苗族自治县','520526','贵州省毕节市威宁彝族回族苗族自治县'),(2777,'2016-03-18 11:31:53','2016-03-18 11:31:53','赫章县','520527','贵州省毕节市赫章县'),(2778,'2016-03-18 11:31:53','2016-03-18 11:31:53','铜仁市','520600','贵州省铜仁市'),(2779,'2016-03-18 11:31:53','2016-03-18 11:31:53','市辖区','520601','贵州省铜仁市市辖区'),(2780,'2016-03-18 11:31:53','2016-03-18 11:31:53','碧江区','520602','贵州省铜仁市碧江区'),(2781,'2016-03-18 11:31:54','2016-03-18 11:31:54','万山区','520603','贵州省铜仁市万山区'),(2782,'2016-03-18 11:31:54','2016-03-18 11:31:54','江口县','520621','贵州省铜仁市江口县'),(2783,'2016-03-18 11:31:54','2016-03-18 11:31:54','玉屏侗族自治县','520622','贵州省铜仁市玉屏侗族自治县'),(2784,'2016-03-18 11:31:54','2016-03-18 11:31:54','石阡县','520623','贵州省铜仁市石阡县'),(2785,'2016-03-18 11:31:54','2016-03-18 11:31:54','思南县','520624','贵州省铜仁市思南县'),(2786,'2016-03-18 11:31:54','2016-03-18 11:31:54','印江土家族苗族自治县','520625','贵州省铜仁市印江土家族苗族自治县'),(2787,'2016-03-18 11:31:54','2016-03-18 11:31:54','德江县','520626','贵州省铜仁市德江县'),(2788,'2016-03-18 11:31:54','2016-03-18 11:31:54','沿河土家族自治县','520627','贵州省铜仁市沿河土家族自治县'),(2789,'2016-03-18 11:31:54','2016-03-18 11:31:54','松桃苗族自治县','520628','贵州省铜仁市松桃苗族自治县'),(2790,'2016-03-18 11:31:54','2016-03-18 11:31:54','黔西南布依族苗族自治州','522300','贵州省黔西南布依族苗族自治州'),(2791,'2016-03-18 11:31:54','2016-03-18 11:31:54','兴义市','522301','贵州省黔西南布依族苗族自治州兴义市'),(2792,'2016-03-18 11:31:55','2016-03-18 11:31:55','兴仁县','522322','贵州省黔西南布依族苗族自治州兴仁县'),(2793,'2016-03-18 11:31:55','2016-03-18 11:31:55','普安县','522323','贵州省黔西南布依族苗族自治州普安县'),(2794,'2016-03-18 11:31:55','2016-03-18 11:31:55','晴隆县','522324','贵州省黔西南布依族苗族自治州晴隆县'),(2795,'2016-03-18 11:31:55','2016-03-18 11:31:55','贞丰县','522325','贵州省黔西南布依族苗族自治州贞丰县'),(2796,'2016-03-18 11:31:55','2016-03-18 11:31:55','望谟县','522326','贵州省黔西南布依族苗族自治州望谟县'),(2797,'2016-03-18 11:31:55','2016-03-18 11:31:55','册亨县','522327','贵州省黔西南布依族苗族自治州册亨县'),(2798,'2016-03-18 11:31:55','2016-03-18 11:31:55','安龙县','522328','贵州省黔西南布依族苗族自治州安龙县'),(2799,'2016-03-18 11:31:55','2016-03-18 11:31:55','黔东南苗族侗族自治州','522600','贵州省黔东南苗族侗族自治州'),(2800,'2016-03-18 11:31:55','2016-03-18 11:31:55','凯里市','522601','贵州省黔东南苗族侗族自治州凯里市'),(2801,'2016-03-18 11:31:55','2016-03-18 11:31:55','黄平县','522622','贵州省黔东南苗族侗族自治州黄平县'),(2802,'2016-03-18 11:31:55','2016-03-18 11:31:55','施秉县','522623','贵州省黔东南苗族侗族自治州施秉县'),(2803,'2016-03-18 11:31:55','2016-03-18 11:31:55','三穗县','522624','贵州省黔东南苗族侗族自治州三穗县'),(2804,'2016-03-18 11:31:56','2016-03-18 11:31:56','镇远县','522625','贵州省黔东南苗族侗族自治州镇远县'),(2805,'2016-03-18 11:31:56','2016-03-18 11:31:56','岑巩县','522626','贵州省黔东南苗族侗族自治州岑巩县'),(2806,'2016-03-18 11:31:56','2016-03-18 11:31:56','天柱县','522627','贵州省黔东南苗族侗族自治州天柱县'),(2807,'2016-03-18 11:31:56','2016-03-18 11:31:56','锦屏县','522628','贵州省黔东南苗族侗族自治州锦屏县'),(2808,'2016-03-18 11:31:56','2016-03-18 11:31:56','剑河县','522629','贵州省黔东南苗族侗族自治州剑河县'),(2809,'2016-03-18 11:31:56','2016-03-18 11:31:56','台江县','522630','贵州省黔东南苗族侗族自治州台江县'),(2810,'2016-03-18 11:31:56','2016-03-18 11:31:56','黎平县','522631','贵州省黔东南苗族侗族自治州黎平县'),(2811,'2016-03-18 11:31:56','2016-03-18 11:31:56','榕江县','522632','贵州省黔东南苗族侗族自治州榕江县'),(2812,'2016-03-18 11:31:56','2016-03-18 11:31:56','从江县','522633','贵州省黔东南苗族侗族自治州从江县'),(2813,'2016-03-18 11:31:56','2016-03-18 11:31:56','雷山县','522634','贵州省黔东南苗族侗族自治州雷山县'),(2814,'2016-03-18 11:31:56','2016-03-18 11:31:56','麻江县','522635','贵州省黔东南苗族侗族自治州麻江县'),(2815,'2016-03-18 11:31:56','2016-03-18 11:31:56','丹寨县','522636','贵州省黔东南苗族侗族自治州丹寨县'),(2816,'2016-03-18 11:31:56','2016-03-18 11:31:56','黔南布依族苗族自治州','522700','贵州省黔南布依族苗族自治州'),(2817,'2016-03-18 11:31:57','2016-03-18 11:31:57','都匀市','522701','贵州省黔南布依族苗族自治州都匀市'),(2818,'2016-03-18 11:31:57','2016-03-18 11:31:57','福泉市','522702','贵州省黔南布依族苗族自治州福泉市'),(2819,'2016-03-18 11:31:57','2016-03-18 11:31:57','荔波县','522722','贵州省黔南布依族苗族自治州荔波县'),(2820,'2016-03-18 11:31:57','2016-03-18 11:31:57','贵定县','522723','贵州省黔南布依族苗族自治州贵定县'),(2821,'2016-03-18 11:31:57','2016-03-18 11:31:57','瓮安县','522725','贵州省黔南布依族苗族自治州瓮安县'),(2822,'2016-03-18 11:31:57','2016-03-18 11:31:57','独山县','522726','贵州省黔南布依族苗族自治州独山县'),(2823,'2016-03-18 11:31:57','2016-03-18 11:31:57','平塘县','522727','贵州省黔南布依族苗族自治州平塘县'),(2824,'2016-03-18 11:31:57','2016-03-18 11:31:57','罗甸县','522728','贵州省黔南布依族苗族自治州罗甸县'),(2825,'2016-03-18 11:31:57','2016-03-18 11:31:57','长顺县','522729','贵州省黔南布依族苗族自治州长顺县'),(2826,'2016-03-18 11:31:57','2016-03-18 11:31:57','龙里县','522730','贵州省黔南布依族苗族自治州龙里县'),(2827,'2016-03-18 11:31:57','2016-03-18 11:31:57','惠水县','522731','贵州省黔南布依族苗族自治州惠水县'),(2828,'2016-03-18 11:31:57','2016-03-18 11:31:57','三都水族自治县','522732','贵州省黔南布依族苗族自治州三都水族自治县'),(2829,'2016-03-18 11:31:57','2016-03-18 11:31:57','云南省','530000','云南省'),(2830,'2016-03-18 11:31:57','2016-03-18 11:31:57','昆明市','530100','云南省昆明市'),(2831,'2016-03-18 11:31:57','2016-03-18 11:31:57','市辖区','530101','云南省昆明市市辖区'),(2832,'2016-03-18 11:31:58','2016-03-18 11:31:58','五华区','530102','云南省昆明市五华区'),(2833,'2016-03-18 11:31:58','2016-03-18 11:31:58','盘龙区','530103','云南省昆明市盘龙区'),(2834,'2016-03-18 11:31:58','2016-03-18 11:31:58','官渡区','530111','云南省昆明市官渡区'),(2835,'2016-03-18 11:31:58','2016-03-18 11:31:58','西山区','530112','云南省昆明市西山区'),(2836,'2016-03-18 11:31:58','2016-03-18 11:31:58','东川区','530113','云南省昆明市东川区'),(2837,'2016-03-18 11:31:58','2016-03-18 11:31:58','呈贡区','530114','云南省昆明市呈贡区'),(2838,'2016-03-18 11:31:58','2016-03-18 11:31:58','晋宁县','530122','云南省昆明市晋宁县'),(2839,'2016-03-18 11:31:58','2016-03-18 11:31:58','富民县','530124','云南省昆明市富民县'),(2840,'2016-03-18 11:31:58','2016-03-18 11:31:58','宜良县','530125','云南省昆明市宜良县'),(2841,'2016-03-18 11:31:58','2016-03-18 11:31:58','石林彝族自治县','530126','云南省昆明市石林彝族自治县'),(2842,'2016-03-18 11:31:58','2016-03-18 11:31:58','嵩明县','530127','云南省昆明市嵩明县'),(2843,'2016-03-18 11:31:58','2016-03-18 11:31:58','禄劝彝族苗族自治县','530128','云南省昆明市禄劝彝族苗族自治县'),(2844,'2016-03-18 11:31:58','2016-03-18 11:31:58','寻甸回族彝族自治县','530129','云南省昆明市寻甸回族彝族自治县'),(2845,'2016-03-18 11:31:58','2016-03-18 11:31:58','安宁市','530181','云南省昆明市安宁市'),(2846,'2016-03-18 11:31:59','2016-03-18 11:31:59','曲靖市','530300','云南省曲靖市'),(2847,'2016-03-18 11:31:59','2016-03-18 11:31:59','市辖区','530301','云南省曲靖市市辖区'),(2848,'2016-03-18 11:31:59','2016-03-18 11:31:59','麒麟区','530302','云南省曲靖市麒麟区'),(2849,'2016-03-18 11:31:59','2016-03-18 11:31:59','马龙县','530321','云南省曲靖市马龙县'),(2850,'2016-03-18 11:31:59','2016-03-18 11:31:59','陆良县','530322','云南省曲靖市陆良县'),(2851,'2016-03-18 11:31:59','2016-03-18 11:31:59','师宗县','530323','云南省曲靖市师宗县'),(2852,'2016-03-18 11:31:59','2016-03-18 11:31:59','罗平县','530324','云南省曲靖市罗平县'),(2853,'2016-03-18 11:31:59','2016-03-18 11:31:59','富源县','530325','云南省曲靖市富源县'),(2854,'2016-03-18 11:31:59','2016-03-18 11:31:59','会泽县','530326','云南省曲靖市会泽县'),(2855,'2016-03-18 11:31:59','2016-03-18 11:31:59','沾益县','530328','云南省曲靖市沾益县'),(2856,'2016-03-18 11:31:59','2016-03-18 11:31:59','宣威市','530381','云南省曲靖市宣威市'),(2857,'2016-03-18 11:31:59','2016-03-18 11:31:59','玉溪市','530400','云南省玉溪市'),(2858,'2016-03-18 11:31:59','2016-03-18 11:31:59','市辖区','530401','云南省玉溪市市辖区'),(2859,'2016-03-18 11:31:59','2016-03-18 11:31:59','红塔区','530402','云南省玉溪市红塔区'),(2860,'2016-03-18 11:31:59','2016-03-18 11:31:59','江川县','530421','云南省玉溪市江川县'),(2861,'2016-03-18 11:31:59','2016-03-18 11:31:59','澄江县','530422','云南省玉溪市澄江县'),(2862,'2016-03-18 11:32:00','2016-03-18 11:32:00','通海县','530423','云南省玉溪市通海县'),(2863,'2016-03-18 11:32:00','2016-03-18 11:32:00','华宁县','530424','云南省玉溪市华宁县'),(2864,'2016-03-18 11:32:00','2016-03-18 11:32:00','易门县','530425','云南省玉溪市易门县'),(2865,'2016-03-18 11:32:00','2016-03-18 11:32:00','峨山彝族自治县','530426','云南省玉溪市峨山彝族自治县'),(2866,'2016-03-18 11:32:00','2016-03-18 11:32:00','新平彝族傣族自治县','530427','云南省玉溪市新平彝族傣族自治县'),(2867,'2016-03-18 11:32:00','2016-03-18 11:32:00','元江哈尼族彝族傣族自治县','530428','云南省玉溪市元江哈尼族彝族傣族自治县'),(2868,'2016-03-18 11:32:00','2016-03-18 11:32:00','保山市','530500','云南省保山市'),(2869,'2016-03-18 11:32:00','2016-03-18 11:32:00','市辖区','530501','云南省保山市市辖区'),(2870,'2016-03-18 11:32:00','2016-03-18 11:32:00','隆阳区','530502','云南省保山市隆阳区'),(2871,'2016-03-18 11:32:00','2016-03-18 11:32:00','施甸县','530521','云南省保山市施甸县'),(2872,'2016-03-18 11:32:00','2016-03-18 11:32:00','腾冲县','530522','云南省保山市腾冲县'),(2873,'2016-03-18 11:32:00','2016-03-18 11:32:00','龙陵县','530523','云南省保山市龙陵县'),(2874,'2016-03-18 11:32:00','2016-03-18 11:32:00','昌宁县','530524','云南省保山市昌宁县'),(2875,'2016-03-18 11:32:00','2016-03-18 11:32:00','昭通市','530600','云南省昭通市'),(2876,'2016-03-18 11:32:00','2016-03-18 11:32:00','市辖区','530601','云南省昭通市市辖区'),(2877,'2016-03-18 11:32:00','2016-03-18 11:32:00','昭阳区','530602','云南省昭通市昭阳区'),(2878,'2016-03-18 11:32:00','2016-03-18 11:32:00','鲁甸县','530621','云南省昭通市鲁甸县'),(2879,'2016-03-18 11:32:00','2016-03-18 11:32:00','巧家县','530622','云南省昭通市巧家县'),(2880,'2016-03-18 11:32:01','2016-03-18 11:32:01','盐津县','530623','云南省昭通市盐津县'),(2881,'2016-03-18 11:32:01','2016-03-18 11:32:01','大关县','530624','云南省昭通市大关县'),(2882,'2016-03-18 11:32:01','2016-03-18 11:32:01','永善县','530625','云南省昭通市永善县'),(2883,'2016-03-18 11:32:01','2016-03-18 11:32:01','绥江县','530626','云南省昭通市绥江县'),(2884,'2016-03-18 11:32:01','2016-03-18 11:32:01','镇雄县','530627','云南省昭通市镇雄县'),(2885,'2016-03-18 11:32:01','2016-03-18 11:32:01','彝良县','530628','云南省昭通市彝良县'),(2886,'2016-03-18 11:32:01','2016-03-18 11:32:01','威信县','530629','云南省昭通市威信县'),(2887,'2016-03-18 11:32:01','2016-03-18 11:32:01','水富县','530630','云南省昭通市水富县'),(2888,'2016-03-18 11:32:01','2016-03-18 11:32:01','丽江市','530700','云南省丽江市'),(2889,'2016-03-18 11:32:01','2016-03-18 11:32:01','市辖区','530701','云南省丽江市市辖区'),(2890,'2016-03-18 11:32:01','2016-03-18 11:32:01','古城区','530702','云南省丽江市古城区'),(2891,'2016-03-18 11:32:01','2016-03-18 11:32:01','玉龙纳西族自治县','530721','云南省丽江市玉龙纳西族自治县'),(2892,'2016-03-18 11:32:01','2016-03-18 11:32:01','永胜县','530722','云南省丽江市永胜县'),(2893,'2016-03-18 11:32:01','2016-03-18 11:32:01','华坪县','530723','云南省丽江市华坪县'),(2894,'2016-03-18 11:32:01','2016-03-18 11:32:01','宁蒗彝族自治县','530724','云南省丽江市宁蒗彝族自治县'),(2895,'2016-03-18 11:32:02','2016-03-18 11:32:02','普洱市','530800','云南省普洱市'),(2896,'2016-03-18 11:32:02','2016-03-18 11:32:02','市辖区','530801','云南省普洱市市辖区'),(2897,'2016-03-18 11:32:02','2016-03-18 11:32:02','思茅区','530802','云南省普洱市思茅区'),(2898,'2016-03-18 11:32:02','2016-03-18 11:32:02','宁洱哈尼族彝族自治县','530821','云南省普洱市宁洱哈尼族彝族自治县'),(2899,'2016-03-18 11:32:02','2016-03-18 11:32:02','墨江哈尼族自治县','530822','云南省普洱市墨江哈尼族自治县'),(2900,'2016-03-18 11:32:02','2016-03-18 11:32:02','景东彝族自治县','530823','云南省普洱市景东彝族自治县'),(2901,'2016-03-18 11:32:02','2016-03-18 11:32:02','景谷傣族彝族自治县','530824','云南省普洱市景谷傣族彝族自治县'),(2902,'2016-03-18 11:32:02','2016-03-18 11:32:02','镇沅彝族哈尼族拉祜族自治县','530825','云南省普洱市镇沅彝族哈尼族拉祜族自治县'),(2903,'2016-03-18 11:32:02','2016-03-18 11:32:02','江城哈尼族彝族自治县','530826','云南省普洱市江城哈尼族彝族自治县'),(2904,'2016-03-18 11:32:02','2016-03-18 11:32:02','孟连傣族拉祜族佤族自治县','530827','云南省普洱市孟连傣族拉祜族佤族自治县'),(2905,'2016-03-18 11:32:02','2016-03-18 11:32:02','澜沧拉祜族自治县','530828','云南省普洱市澜沧拉祜族自治县'),(2906,'2016-03-18 11:32:02','2016-03-18 11:32:02','西盟佤族自治县','530829','云南省普洱市西盟佤族自治县'),(2907,'2016-03-18 11:32:02','2016-03-18 11:32:02','临沧市','530900','云南省临沧市'),(2908,'2016-03-18 11:32:02','2016-03-18 11:32:02','市辖区','530901','云南省临沧市市辖区'),(2909,'2016-03-18 11:32:03','2016-03-18 11:32:03','临翔区','530902','云南省临沧市临翔区'),(2910,'2016-03-18 11:32:03','2016-03-18 11:32:03','凤庆县','530921','云南省临沧市凤庆县'),(2911,'2016-03-18 11:32:03','2016-03-18 11:32:03','云县','530922','云南省临沧市云县'),(2912,'2016-03-18 11:32:03','2016-03-18 11:32:03','永德县','530923','云南省临沧市永德县'),(2913,'2016-03-18 11:32:03','2016-03-18 11:32:03','镇康县','530924','云南省临沧市镇康县'),(2914,'2016-03-18 11:32:03','2016-03-18 11:32:03','双江拉祜族佤族布朗族傣族自治县','530925','云南省临沧市双江拉祜族佤族布朗族傣族自治县'),(2915,'2016-03-18 11:32:03','2016-03-18 11:32:03','耿马傣族佤族自治县','530926','云南省临沧市耿马傣族佤族自治县'),(2916,'2016-03-18 11:32:03','2016-03-18 11:32:03','沧源佤族自治县','530927','云南省临沧市沧源佤族自治县'),(2917,'2016-03-18 11:32:03','2016-03-18 11:32:03','楚雄彝族自治州','532300','云南省楚雄彝族自治州'),(2918,'2016-03-18 11:32:03','2016-03-18 11:32:03','楚雄市','532301','云南省楚雄彝族自治州楚雄市'),(2919,'2016-03-18 11:32:03','2016-03-18 11:32:03','双柏县','532322','云南省楚雄彝族自治州双柏县'),(2920,'2016-03-18 11:32:03','2016-03-18 11:32:03','牟定县','532323','云南省楚雄彝族自治州牟定县'),(2921,'2016-03-18 11:32:03','2016-03-18 11:32:03','南华县','532324','云南省楚雄彝族自治州南华县'),(2922,'2016-03-18 11:32:03','2016-03-18 11:32:03','姚安县','532325','云南省楚雄彝族自治州姚安县'),(2923,'2016-03-18 11:32:04','2016-03-18 11:32:04','大姚县','532326','云南省楚雄彝族自治州大姚县'),(2924,'2016-03-18 11:32:04','2016-03-18 11:32:04','永仁县','532327','云南省楚雄彝族自治州永仁县'),(2925,'2016-03-18 11:32:04','2016-03-18 11:32:04','元谋县','532328','云南省楚雄彝族自治州元谋县'),(2926,'2016-03-18 11:32:04','2016-03-18 11:32:04','武定县','532329','云南省楚雄彝族自治州武定县'),(2927,'2016-03-18 11:32:04','2016-03-18 11:32:04','禄丰县','532331','云南省楚雄彝族自治州禄丰县'),(2928,'2016-03-18 11:32:04','2016-03-18 11:32:04','红河哈尼族彝族自治州','532500','云南省红河哈尼族彝族自治州'),(2929,'2016-03-18 11:32:04','2016-03-18 11:32:04','个旧市','532501','云南省红河哈尼族彝族自治州个旧市'),(2930,'2016-03-18 11:32:04','2016-03-18 11:32:04','开远市','532502','云南省红河哈尼族彝族自治州开远市'),(2931,'2016-03-18 11:32:04','2016-03-18 11:32:04','蒙自市','532503','云南省红河哈尼族彝族自治州蒙自市'),(2932,'2016-03-18 11:32:04','2016-03-18 11:32:04','弥勒市','532504','云南省红河哈尼族彝族自治州弥勒市'),(2933,'2016-03-18 11:32:05','2016-03-18 11:32:05','屏边苗族自治县','532523','云南省红河哈尼族彝族自治州屏边苗族自治县'),(2934,'2016-03-18 11:32:05','2016-03-18 11:32:05','建水县','532524','云南省红河哈尼族彝族自治州建水县'),(2935,'2016-03-18 11:32:05','2016-03-18 11:32:05','石屏县','532525','云南省红河哈尼族彝族自治州石屏县'),(2936,'2016-03-18 11:32:05','2016-03-18 11:32:05','泸西县','532527','云南省红河哈尼族彝族自治州泸西县'),(2937,'2016-03-18 11:32:05','2016-03-18 11:32:05','元阳县','532528','云南省红河哈尼族彝族自治州元阳县'),(2938,'2016-03-18 11:32:05','2016-03-18 11:32:05','红河县','532529','云南省红河哈尼族彝族自治州红河县'),(2939,'2016-03-18 11:32:05','2016-03-18 11:32:05','金平苗族瑶族傣族自治县','532530','云南省红河哈尼族彝族自治州金平苗族瑶族傣族自治县'),(2940,'2016-03-18 11:32:06','2016-03-18 11:32:06','绿春县','532531','云南省红河哈尼族彝族自治州绿春县'),(2941,'2016-03-18 11:32:06','2016-03-18 11:32:06','河口瑶族自治县','532532','云南省红河哈尼族彝族自治州河口瑶族自治县'),(2942,'2016-03-18 11:32:06','2016-03-18 11:32:06','文山壮族苗族自治州','532600','云南省文山壮族苗族自治州'),(2943,'2016-03-18 11:32:06','2016-03-18 11:32:06','文山市','532601','云南省文山壮族苗族自治州文山市'),(2944,'2016-03-18 11:32:06','2016-03-18 11:32:06','砚山县','532622','云南省文山壮族苗族自治州砚山县'),(2945,'2016-03-18 11:32:06','2016-03-18 11:32:06','西畴县','532623','云南省文山壮族苗族自治州西畴县'),(2946,'2016-03-18 11:32:06','2016-03-18 11:32:06','麻栗坡县','532624','云南省文山壮族苗族自治州麻栗坡县'),(2947,'2016-03-18 11:32:06','2016-03-18 11:32:06','马关县','532625','云南省文山壮族苗族自治州马关县'),(2948,'2016-03-18 11:32:06','2016-03-18 11:32:06','丘北县','532626','云南省文山壮族苗族自治州丘北县'),(2949,'2016-03-18 11:32:06','2016-03-18 11:32:06','广南县','532627','云南省文山壮族苗族自治州广南县'),(2950,'2016-03-18 11:32:06','2016-03-18 11:32:06','富宁县','532628','云南省文山壮族苗族自治州富宁县'),(2951,'2016-03-18 11:32:06','2016-03-18 11:32:06','西双版纳傣族自治州','532800','云南省西双版纳傣族自治州'),(2952,'2016-03-18 11:32:06','2016-03-18 11:32:06','景洪市','532801','云南省西双版纳傣族自治州景洪市'),(2953,'2016-03-18 11:32:06','2016-03-18 11:32:06','勐海县','532822','云南省西双版纳傣族自治州勐海县'),(2954,'2016-03-18 11:32:06','2016-03-18 11:32:06','勐腊县','532823','云南省西双版纳傣族自治州勐腊县'),(2955,'2016-03-18 11:32:07','2016-03-18 11:32:07','大理白族自治州','532900','云南省大理白族自治州'),(2956,'2016-03-18 11:32:07','2016-03-18 11:32:07','大理市','532901','云南省大理白族自治州大理市'),(2957,'2016-03-18 11:32:07','2016-03-18 11:32:07','漾濞彝族自治县','532922','云南省大理白族自治州漾濞彝族自治县'),(2958,'2016-03-18 11:32:07','2016-03-18 11:32:07','祥云县','532923','云南省大理白族自治州祥云县'),(2959,'2016-03-18 11:32:07','2016-03-18 11:32:07','宾川县','532924','云南省大理白族自治州宾川县'),(2960,'2016-03-18 11:32:07','2016-03-18 11:32:07','弥渡县','532925','云南省大理白族自治州弥渡县'),(2961,'2016-03-18 11:32:07','2016-03-18 11:32:07','南涧彝族自治县','532926','云南省大理白族自治州南涧彝族自治县'),(2962,'2016-03-18 11:32:07','2016-03-18 11:32:07','巍山彝族回族自治县','532927','云南省大理白族自治州巍山彝族回族自治县'),(2963,'2016-03-18 11:32:07','2016-03-18 11:32:07','永平县','532928','云南省大理白族自治州永平县'),(2964,'2016-03-18 11:32:07','2016-03-18 11:32:07','云龙县','532929','云南省大理白族自治州云龙县'),(2965,'2016-03-18 11:32:07','2016-03-18 11:32:07','洱源县','532930','云南省大理白族自治州洱源县'),(2966,'2016-03-18 11:32:07','2016-03-18 11:32:07','剑川县','532931','云南省大理白族自治州剑川县'),(2967,'2016-03-18 11:32:07','2016-03-18 11:32:07','鹤庆县','532932','云南省大理白族自治州鹤庆县'),(2968,'2016-03-18 11:32:07','2016-03-18 11:32:07','德宏傣族景颇族自治州','533100','云南省德宏傣族景颇族自治州'),(2969,'2016-03-18 11:32:07','2016-03-18 11:32:07','瑞丽市','533102','云南省德宏傣族景颇族自治州瑞丽市'),(2970,'2016-03-18 11:32:07','2016-03-18 11:32:07','芒市','533103','云南省德宏傣族景颇族自治州芒市'),(2971,'2016-03-18 11:32:07','2016-03-18 11:32:07','梁河县','533122','云南省德宏傣族景颇族自治州梁河县'),(2972,'2016-03-18 11:32:07','2016-03-18 11:32:07','盈江县','533123','云南省德宏傣族景颇族自治州盈江县'),(2973,'2016-03-18 11:32:08','2016-03-18 11:32:08','陇川县','533124','云南省德宏傣族景颇族自治州陇川县'),(2974,'2016-03-18 11:32:08','2016-03-18 11:32:08','怒江傈僳族自治州','533300','云南省怒江傈僳族自治州'),(2975,'2016-03-18 11:32:08','2016-03-18 11:32:08','泸水县','533321','云南省怒江傈僳族自治州泸水县'),(2976,'2016-03-18 11:32:08','2016-03-18 11:32:08','福贡县','533323','云南省怒江傈僳族自治州福贡县'),(2977,'2016-03-18 11:32:08','2016-03-18 11:32:08','贡山独龙族怒族自治县','533324','云南省怒江傈僳族自治州贡山独龙族怒族自治县'),(2978,'2016-03-18 11:32:08','2016-03-18 11:32:08','兰坪白族普米族自治县','533325','云南省怒江傈僳族自治州兰坪白族普米族自治县'),(2979,'2016-03-18 11:32:08','2016-03-18 11:32:08','迪庆藏族自治州','533400','云南省迪庆藏族自治州'),(2980,'2016-03-18 11:32:08','2016-03-18 11:32:08','香格里拉县','533421','云南省迪庆藏族自治州香格里拉县'),(2981,'2016-03-18 11:32:08','2016-03-18 11:32:08','德钦县','533422','云南省迪庆藏族自治州德钦县'),(2982,'2016-03-18 11:32:08','2016-03-18 11:32:08','维西傈僳族自治县','533423','云南省迪庆藏族自治州维西傈僳族自治县'),(2983,'2016-03-18 11:32:08','2016-03-18 11:32:08','西藏自治区','540000','西藏自治区'),(2984,'2016-03-18 11:32:08','2016-03-18 11:32:08','拉萨市','540100','西藏自治区拉萨市'),(2985,'2016-03-18 11:32:08','2016-03-18 11:32:08','市辖区','540101','西藏自治区拉萨市市辖区'),(2986,'2016-03-18 11:32:08','2016-03-18 11:32:08','城关区','540102','西藏自治区拉萨市城关区'),(2987,'2016-03-18 11:32:08','2016-03-18 11:32:08','林周县','540121','西藏自治区拉萨市林周县'),(2988,'2016-03-18 11:32:08','2016-03-18 11:32:08','当雄县','540122','西藏自治区拉萨市当雄县'),(2989,'2016-03-18 11:32:08','2016-03-18 11:32:08','尼木县','540123','西藏自治区拉萨市尼木县'),(2990,'2016-03-18 11:32:09','2016-03-18 11:32:09','曲水县','540124','西藏自治区拉萨市曲水县'),(2991,'2016-03-18 11:32:09','2016-03-18 11:32:09','堆龙德庆县','540125','西藏自治区拉萨市堆龙德庆县'),(2992,'2016-03-18 11:32:09','2016-03-18 11:32:09','达孜县','540126','西藏自治区拉萨市达孜县'),(2993,'2016-03-18 11:32:09','2016-03-18 11:32:09','墨竹工卡县','540127','西藏自治区拉萨市墨竹工卡县'),(2994,'2016-03-18 11:32:09','2016-03-18 11:32:09','日喀则市','540200','西藏自治区日喀则市'),(2995,'2016-03-18 11:32:09','2016-03-18 11:32:09','桑珠孜区','540202','西藏自治区日喀则市桑珠孜区'),(2996,'2016-03-18 11:32:09','2016-03-18 11:32:09','南木林县','540221','西藏自治区日喀则市南木林县'),(2997,'2016-03-18 11:32:09','2016-03-18 11:32:09','江孜县','540222','西藏自治区日喀则市江孜县'),(2998,'2016-03-18 11:32:09','2016-03-18 11:32:09','定日县','540223','西藏自治区日喀则市定日县'),(2999,'2016-03-18 11:32:09','2016-03-18 11:32:09','萨迦县','540224','西藏自治区日喀则市萨迦县'),(3000,'2016-03-18 11:32:09','2016-03-18 11:32:09','拉孜县','540225','西藏自治区日喀则市拉孜县'),(3001,'2016-03-18 11:32:09','2016-03-18 11:32:09','昂仁县','540226','西藏自治区日喀则市昂仁县'),(3002,'2016-03-18 11:32:10','2016-03-18 11:32:10','谢通门县','540227','西藏自治区日喀则市谢通门县'),(3003,'2016-03-18 11:32:10','2016-03-18 11:32:10','白朗县','540228','西藏自治区日喀则市白朗县'),(3004,'2016-03-18 11:32:10','2016-03-18 11:32:10','仁布县','540229','西藏自治区日喀则市仁布县'),(3005,'2016-03-18 11:32:10','2016-03-18 11:32:10','康马县','540230','西藏自治区日喀则市康马县'),(3006,'2016-03-18 11:32:10','2016-03-18 11:32:10','定结县','540231','西藏自治区日喀则市定结县'),(3007,'2016-03-18 11:32:10','2016-03-18 11:32:10','仲巴县','540232','西藏自治区日喀则市仲巴县'),(3008,'2016-03-18 11:32:10','2016-03-18 11:32:10','亚东县','540233','西藏自治区日喀则市亚东县'),(3009,'2016-03-18 11:32:10','2016-03-18 11:32:10','吉隆县','540234','西藏自治区日喀则市吉隆县'),(3010,'2016-03-18 11:32:10','2016-03-18 11:32:10','聂拉木县','540235','西藏自治区日喀则市聂拉木县'),(3011,'2016-03-18 11:32:10','2016-03-18 11:32:10','萨嘎县','540236','西藏自治区日喀则市萨嘎县'),(3012,'2016-03-18 11:32:10','2016-03-18 11:32:10','岗巴县','540237','西藏自治区日喀则市岗巴县'),(3013,'2016-03-18 11:32:10','2016-03-18 11:32:10','昌都地区','542100','西藏自治区昌都地区'),(3014,'2016-03-18 11:32:10','2016-03-18 11:32:10','昌都县','542121','西藏自治区昌都地区昌都县'),(3015,'2016-03-18 11:32:10','2016-03-18 11:32:10','江达县','542122','西藏自治区昌都地区江达县'),(3016,'2016-03-18 11:32:10','2016-03-18 11:32:10','贡觉县','542123','西藏自治区昌都地区贡觉县'),(3017,'2016-03-18 11:32:11','2016-03-18 11:32:11','类乌齐县','542124','西藏自治区昌都地区类乌齐县'),(3018,'2016-03-18 11:32:11','2016-03-18 11:32:11','丁青县','542125','西藏自治区昌都地区丁青县'),(3019,'2016-03-18 11:32:11','2016-03-18 11:32:11','察雅县','542126','西藏自治区昌都��区察雅县'),(3020,'2016-03-18 11:32:11','2016-03-18 11:32:11','八宿县','542127','西藏自治区昌都地区八宿县'),(3021,'2016-03-18 11:32:11','2016-03-18 11:32:11','左贡县','542128','西藏自治区昌都地区左贡县'),(3022,'2016-03-18 11:32:11','2016-03-18 11:32:11','芒康县','542129','西藏自治区昌都地区芒康县'),(3023,'2016-03-18 11:32:11','2016-03-18 11:32:11','洛隆县','542132','西藏自治区昌都地区洛隆县'),(3024,'2016-03-18 11:32:11','2016-03-18 11:32:11','边坝县','542133','西藏自治区昌都地区边坝县'),(3025,'2016-03-18 11:32:11','2016-03-18 11:32:11','山南地区','542200','西藏自治区山南地区'),(3026,'2016-03-18 11:32:11','2016-03-18 11:32:11','乃东县','542221','西藏自治区山南地区乃东县'),(3027,'2016-03-18 11:32:12','2016-03-18 11:32:12','扎囊县','542222','西藏自治区山南地区扎囊县'),(3028,'2016-03-18 11:32:12','2016-03-18 11:32:12','贡嘎县','542223','西藏自治区山南地区贡嘎县'),(3029,'2016-03-18 11:32:12','2016-03-18 11:32:12','桑日县','542224','西藏自治区山南地区桑日县'),(3030,'2016-03-18 11:32:12','2016-03-18 11:32:12','琼结县','542225','西藏自治区山南地区琼结县'),(3031,'2016-03-18 11:32:12','2016-03-18 11:32:12','曲松县','542226','西藏自治区山南地区曲松县'),(3032,'2016-03-18 11:32:12','2016-03-18 11:32:12','措美县','542227','西藏自治区山南地区措美县'),(3033,'2016-03-18 11:32:12','2016-03-18 11:32:12','洛扎县','542228','西藏自治区山南地区洛扎县'),(3034,'2016-03-18 11:32:12','2016-03-18 11:32:12','加查县','542229','西藏自治区山南地区加查县'),(3035,'2016-03-18 11:32:12','2016-03-18 11:32:12','隆子县','542231','西藏自治区山南地区隆子县'),(3036,'2016-03-18 11:32:12','2016-03-18 11:32:12','错那县','542232','西藏自治区山南地区错那县'),(3037,'2016-03-18 11:32:13','2016-03-18 11:32:13','浪卡子县','542233','西藏自治区山南地区浪卡子县'),(3038,'2016-03-18 11:32:13','2016-03-18 11:32:13','那曲地区','542400','西藏自治区那曲地区'),(3039,'2016-03-18 11:32:13','2016-03-18 11:32:13','那曲县','542421','西藏自治区那曲地区那曲县'),(3040,'2016-03-18 11:32:13','2016-03-18 11:32:13','嘉黎县','542422','西藏自治区那曲地区嘉黎县'),(3041,'2016-03-18 11:32:13','2016-03-18 11:32:13','比如县','542423','西藏自治区那曲地区比如县'),(3042,'2016-03-18 11:32:13','2016-03-18 11:32:13','聂荣县','542424','西藏自治区那曲地区聂荣县'),(3043,'2016-03-18 11:32:13','2016-03-18 11:32:13','安多县','542425','西藏自治区那曲地区安多县'),(3044,'2016-03-18 11:32:13','2016-03-18 11:32:13','申扎县','542426','西藏自治区那曲地区申扎县'),(3045,'2016-03-18 11:32:13','2016-03-18 11:32:13','索县','542427','西藏自治区那曲地区索县'),(3046,'2016-03-18 11:32:14','2016-03-18 11:32:14','班戈县','542428','西藏自治区那曲地区班戈县'),(3047,'2016-03-18 11:32:14','2016-03-18 11:32:14','巴青县','542429','西藏自治区那曲地区巴青县'),(3048,'2016-03-18 11:32:14','2016-03-18 11:32:14','尼玛县','542430','西藏自治区那曲地区尼玛县'),(3049,'2016-03-18 11:32:14','2016-03-18 11:32:14','双湖县','542431','西藏自治区那曲地区双湖县'),(3050,'2016-03-18 11:32:14','2016-03-18 11:32:14','阿里地区','542500','西藏自治区阿里地区'),(3051,'2016-03-18 11:32:14','2016-03-18 11:32:14','普兰县','542521','西藏自治区阿里地区普兰县'),(3052,'2016-03-18 11:32:14','2016-03-18 11:32:14','札达县','542522','西藏自治区阿里地区札达县'),(3053,'2016-03-18 11:32:14','2016-03-18 11:32:14','噶尔县','542523','西藏自治区阿里地区噶尔县'),(3054,'2016-03-18 11:32:14','2016-03-18 11:32:14','日土县','542524','西藏自治区阿里地区日土县'),(3055,'2016-03-18 11:32:14','2016-03-18 11:32:14','革吉县','542525','西藏自治区阿里地区革吉县'),(3056,'2016-03-18 11:32:14','2016-03-18 11:32:14','改则县','542526','西藏自治区阿里地区改则县'),(3057,'2016-03-18 11:32:14','2016-03-18 11:32:14','措勤县','542527','西藏自治区阿里地区措勤县'),(3058,'2016-03-18 11:32:15','2016-03-18 11:32:15','林芝地区','542600','西藏自治区林芝地区'),(3059,'2016-03-18 11:32:15','2016-03-18 11:32:15','林芝县','542621','西藏自治区林芝地区林芝县'),(3060,'2016-03-18 11:32:15','2016-03-18 11:32:15','工布江达县','542622','西藏自治区林芝地区工布江达县'),(3061,'2016-03-18 11:32:15','2016-03-18 11:32:15','米林县','542623','西藏自治区林芝地区米林县'),(3062,'2016-03-18 11:32:15','2016-03-18 11:32:15','墨脱县','542624','西藏自治区林芝地区墨脱县'),(3063,'2016-03-18 11:32:15','2016-03-18 11:32:15','波密县','542625','西藏自治区林芝地区波密县'),(3064,'2016-03-18 11:32:15','2016-03-18 11:32:15','察隅县','542626','西藏自治区林芝地区察隅县'),(3065,'2016-03-18 11:32:15','2016-03-18 11:32:15','朗县','542627','西藏自治区林芝地区朗县'),(3066,'2016-03-18 11:32:15','2016-03-18 11:32:15','陕西省','610000','陕西省'),(3067,'2016-03-18 11:32:15','2016-03-18 11:32:15','西安市','610100','陕西省西安市'),(3068,'2016-03-18 11:32:15','2016-03-18 11:32:15','市辖区','610101','陕西省西安市市辖区'),(3069,'2016-03-18 11:32:15','2016-03-18 11:32:15','新城区','610102','陕西省西安市新城区'),(3070,'2016-03-18 11:32:15','2016-03-18 11:32:15','碑林区','610103','陕西省西安市碑林区'),(3071,'2016-03-18 11:32:16','2016-03-18 11:32:16','莲湖区','610104','陕西省西安市莲湖区'),(3072,'2016-03-18 11:32:16','2016-03-18 11:32:16','灞桥区','610111','陕西省西安市灞桥区'),(3073,'2016-03-18 11:32:16','2016-03-18 11:32:16','未央区','610112','陕西省西安市未央区'),(3074,'2016-03-18 11:32:16','2016-03-18 11:32:16','雁塔区','610113','陕西省西安市雁塔区'),(3075,'2016-03-18 11:32:16','2016-03-18 11:32:16','阎良区','610114','陕西省西安市阎良区'),(3076,'2016-03-18 11:32:16','2016-03-18 11:32:16','临潼区','610115','陕西省西安市临潼区'),(3077,'2016-03-18 11:32:16','2016-03-18 11:32:16','长安区','610116','陕西省西安市长安区'),(3078,'2016-03-18 11:32:16','2016-03-18 11:32:16','蓝田县','610122','陕西省西安市蓝田县'),(3079,'2016-03-18 11:32:16','2016-03-18 11:32:16','周至县','610124','陕西省西安市周至县'),(3080,'2016-03-18 11:32:16','2016-03-18 11:32:16','户县','610125','陕西省西安市户县'),(3081,'2016-03-18 11:32:16','2016-03-18 11:32:16','高陵县','610126','陕西省西安市高陵县'),(3082,'2016-03-18 11:32:16','2016-03-18 11:32:16','铜川市','610200','陕西省铜川市'),(3083,'2016-03-18 11:32:16','2016-03-18 11:32:16','市辖区','610201','陕西省铜川市市辖区'),(3084,'2016-03-18 11:32:16','2016-03-18 11:32:16','王益区','610202','陕西省铜川市王益区'),(3085,'2016-03-18 11:32:17','2016-03-18 11:32:17','印台区','610203','陕西省铜川市印台区'),(3086,'2016-03-18 11:32:17','2016-03-18 11:32:17','耀州区','610204','陕西省铜川市耀州区'),(3087,'2016-03-18 11:32:17','2016-03-18 11:32:17','宜君县','610222','陕西省铜川市宜君县'),(3088,'2016-03-18 11:32:17','2016-03-18 11:32:17','宝鸡市','610300','陕西省宝鸡市'),(3089,'2016-03-18 11:32:17','2016-03-18 11:32:17','市辖区','610301','陕西省宝鸡市市辖区'),(3090,'2016-03-18 11:32:17','2016-03-18 11:32:17','渭滨区','610302','陕西省宝鸡市渭滨区'),(3091,'2016-03-18 11:32:17','2016-03-18 11:32:17','金台区','610303','陕西省宝鸡市金台区'),(3092,'2016-03-18 11:32:17','2016-03-18 11:32:17','陈仓区','610304','陕西省宝鸡市陈仓区'),(3093,'2016-03-18 11:32:17','2016-03-18 11:32:17','凤翔县','610322','陕西省宝鸡市凤翔县'),(3094,'2016-03-18 11:32:17','2016-03-18 11:32:17','岐山县','610323','陕西省宝鸡市岐山县'),(3095,'2016-03-18 11:32:17','2016-03-18 11:32:17','扶风县','610324','陕西省宝鸡市扶风县'),(3096,'2016-03-18 11:32:17','2016-03-18 11:32:17','眉县','610326','陕西省宝鸡市眉县'),(3097,'2016-03-18 11:32:17','2016-03-18 11:32:17','陇县','610327','陕西省宝鸡市陇县'),(3098,'2016-03-18 11:32:17','2016-03-18 11:32:17','千阳县','610328','陕西省宝鸡市千阳县'),(3099,'2016-03-18 11:32:18','2016-03-18 11:32:18','麟游县','610329','陕西省宝鸡市麟游县'),(3100,'2016-03-18 11:32:18','2016-03-18 11:32:18','凤县','610330','陕西省宝鸡市凤县'),(3101,'2016-03-18 11:32:18','2016-03-18 11:32:18','太白县','610331','陕西省宝鸡市太白县'),(3102,'2016-03-18 11:32:18','2016-03-18 11:32:18','咸阳市','610400','陕西省咸阳市'),(3103,'2016-03-18 11:32:18','2016-03-18 11:32:18','市辖区','610401','陕西省咸阳市市辖区'),(3104,'2016-03-18 11:32:18','2016-03-18 11:32:18','秦都区','610402','陕西省咸阳市秦都区'),(3105,'2016-03-18 11:32:18','2016-03-18 11:32:18','杨陵区','610403','陕西省咸阳市杨陵区'),(3106,'2016-03-18 11:32:18','2016-03-18 11:32:18','渭城区','610404','陕西省咸阳市渭城区'),(3107,'2016-03-18 11:32:18','2016-03-18 11:32:18','三原县','610422','陕西省咸阳市三原县'),(3108,'2016-03-18 11:32:18','2016-03-18 11:32:18','泾阳县','610423','陕西省咸阳市泾阳县'),(3109,'2016-03-18 11:32:18','2016-03-18 11:32:18','乾县','610424','陕西省咸阳市乾县'),(3110,'2016-03-18 11:32:19','2016-03-18 11:32:19','礼泉县','610425','陕西省咸阳市礼泉县'),(3111,'2016-03-18 11:32:19','2016-03-18 11:32:19','永寿县','610426','陕西省咸阳市永寿县'),(3112,'2016-03-18 11:32:19','2016-03-18 11:32:19','彬县','610427','陕西省咸阳市彬县'),(3113,'2016-03-18 11:32:19','2016-03-18 11:32:19','长武县','610428','陕西省咸阳市长武县'),(3114,'2016-03-18 11:32:19','2016-03-18 11:32:19','旬邑县','610429','陕西省咸阳市旬邑县'),(3115,'2016-03-18 11:32:19','2016-03-18 11:32:19','淳化县','610430','陕西省咸阳市淳化县'),(3116,'2016-03-18 11:32:19','2016-03-18 11:32:19','武功县','610431','陕西省咸阳市武功县'),(3117,'2016-03-18 11:32:19','2016-03-18 11:32:19','兴平市','610481','陕西省咸阳市兴平市'),(3118,'2016-03-18 11:32:19','2016-03-18 11:32:19','渭南市','610500','陕西省渭南市'),(3119,'2016-03-18 11:32:19','2016-03-18 11:32:19','市辖区','610501','陕西省渭南市市辖区'),(3120,'2016-03-18 11:32:20','2016-03-18 11:32:20','临渭区','610502','陕西省渭南市临渭区'),(3121,'2016-03-18 11:32:20','2016-03-18 11:32:20','华县','610521','陕西省渭南市华县'),(3122,'2016-03-18 11:32:20','2016-03-18 11:32:20','潼关县','610522','陕西省渭南市潼关县'),(3123,'2016-03-18 11:32:20','2016-03-18 11:32:20','大荔县','610523','陕西省渭南市大荔县'),(3124,'2016-03-18 11:32:20','2016-03-18 11:32:20','合阳县','610524','陕西省渭南市合阳县'),(3125,'2016-03-18 11:32:20','2016-03-18 11:32:20','澄城县','610525','陕西省渭南市澄城县'),(3126,'2016-03-18 11:32:20','2016-03-18 11:32:20','蒲城县','610526','陕西省渭南市蒲城县'),(3127,'2016-03-18 11:32:20','2016-03-18 11:32:20','白水县','610527','陕西省渭南市白水县'),(3128,'2016-03-18 11:32:20','2016-03-18 11:32:20','富平县','610528','陕西省渭南市富平县'),(3129,'2016-03-18 11:32:20','2016-03-18 11:32:20','韩城市','610581','陕西省渭南市韩城市'),(3130,'2016-03-18 11:32:20','2016-03-18 11:32:20','华阴市','610582','陕西省渭南市华阴市'),(3131,'2016-03-18 11:32:20','2016-03-18 11:32:20','延安市','610600','陕西省延安市'),(3132,'2016-03-18 11:32:20','2016-03-18 11:32:20','市辖区','610601','陕西省延安市市辖区'),(3133,'2016-03-18 11:32:21','2016-03-18 11:32:21','宝塔区','610602','陕西省延安市宝塔区'),(3134,'2016-03-18 11:32:21','2016-03-18 11:32:21','延长县','610621','陕西省延安市延长县'),(3135,'2016-03-18 11:32:21','2016-03-18 11:32:21','延川县','610622','陕西省延安市延川县'),(3136,'2016-03-18 11:32:21','2016-03-18 11:32:21','子长县','610623','陕西省延安市子长县'),(3137,'2016-03-18 11:32:21','2016-03-18 11:32:21','安塞县','610624','陕西省延安市安塞县'),(3138,'2016-03-18 11:32:21','2016-03-18 11:32:21','志丹县','610625','陕西省延安市志丹县'),(3139,'2016-03-18 11:32:21','2016-03-18 11:32:21','吴起县','610626','陕西省延安市吴起县'),(3140,'2016-03-18 11:32:21','2016-03-18 11:32:21','甘泉县','610627','陕西省延安市甘泉县'),(3141,'2016-03-18 11:32:21','2016-03-18 11:32:21','富县','610628','陕西省延安市富县'),(3142,'2016-03-18 11:32:21','2016-03-18 11:32:21','洛川县','610629','陕西省延安市洛川县'),(3143,'2016-03-18 11:32:22','2016-03-18 11:32:22','宜川县','610630','陕西省延安市宜川县'),(3144,'2016-03-18 11:32:22','2016-03-18 11:32:22','黄龙县','610631','陕西省延安市黄龙县'),(3145,'2016-03-18 11:32:22','2016-03-18 11:32:22','黄陵县','610632','陕西省延安市黄陵县'),(3146,'2016-03-18 11:32:22','2016-03-18 11:32:22','汉中市','610700','陕西省汉中市'),(3147,'2016-03-18 11:32:22','2016-03-18 11:32:22','市辖区','610701','陕西省汉中市市辖区'),(3148,'2016-03-18 11:32:22','2016-03-18 11:32:22','汉台区','610702','陕西省汉中市汉台区'),(3149,'2016-03-18 11:32:22','2016-03-18 11:32:22','南郑县','610721','陕西省汉中市南郑县'),(3150,'2016-03-18 11:32:22','2016-03-18 11:32:22','城固县','610722','陕西省汉中市城固县'),(3151,'2016-03-18 11:32:22','2016-03-18 11:32:22','洋县','610723','陕西省汉中市洋县'),(3152,'2016-03-18 11:32:23','2016-03-18 11:32:23','西乡县','610724','陕西省汉中市西乡县'),(3153,'2016-03-18 11:32:23','2016-03-18 11:32:23','勉县','610725','陕西省汉中市勉县'),(3154,'2016-03-18 11:32:23','2016-03-18 11:32:23','宁强县','610726','陕西省汉中市宁强县'),(3155,'2016-03-18 11:32:23','2016-03-18 11:32:23','略阳县','610727','陕西省汉中市略阳县'),(3156,'2016-03-18 11:32:23','2016-03-18 11:32:23','镇巴县','610728','陕西省汉中市镇巴县'),(3157,'2016-03-18 11:32:24','2016-03-18 11:32:24','留坝县','610729','陕西省汉中市留坝县'),(3158,'2016-03-18 11:32:24','2016-03-18 11:32:24','佛坪县','610730','陕西省汉中市佛坪县'),(3159,'2016-03-18 11:32:24','2016-03-18 11:32:24','榆林市','610800','陕西省榆林市'),(3160,'2016-03-18 11:32:24','2016-03-18 11:32:24','市辖区','610801','陕西省榆林市市辖区'),(3161,'2016-03-18 11:32:24','2016-03-18 11:32:24','榆阳区','610802','陕西省榆林市榆阳区'),(3162,'2016-03-18 11:32:24','2016-03-18 11:32:24','神木县','610821','陕西省榆林市神木县'),(3163,'2016-03-18 11:32:24','2016-03-18 11:32:24','府谷县','610822','陕西省榆林市府谷县'),(3164,'2016-03-18 11:32:24','2016-03-18 11:32:24','横山县','610823','陕西省榆林市横山县'),(3165,'2016-03-18 11:32:24','2016-03-18 11:32:24','靖边县','610824','陕西省榆林市靖边县'),(3166,'2016-03-18 11:32:24','2016-03-18 11:32:24','定边县','610825','陕西省榆林市定边县'),(3167,'2016-03-18 11:32:24','2016-03-18 11:32:24','绥德县','610826','陕西省榆林市绥德县'),(3168,'2016-03-18 11:32:24','2016-03-18 11:32:24','米脂县','610827','陕西省榆林市米脂县'),(3169,'2016-03-18 11:32:24','2016-03-18 11:32:24','佳县','610828','陕西省榆林市佳县'),(3170,'2016-03-18 11:32:25','2016-03-18 11:32:25','吴堡县','610829','陕西省榆林市吴堡县'),(3171,'2016-03-18 11:32:25','2016-03-18 11:32:25','清涧县','610830','陕西省榆林市清涧县'),(3172,'2016-03-18 11:32:25','2016-03-18 11:32:25','子洲县','610831','陕西省榆林市子洲县'),(3173,'2016-03-18 11:32:25','2016-03-18 11:32:25','安康市','610900','陕西省安康市'),(3174,'2016-03-18 11:32:25','2016-03-18 11:32:25','市辖区','610901','陕西省安康市市辖区'),(3175,'2016-03-18 11:32:25','2016-03-18 11:32:25','汉滨区','610902','陕西省安康市汉滨区'),(3176,'2016-03-18 11:32:25','2016-03-18 11:32:25','汉阴县','610921','陕西省安康市汉阴县'),(3177,'2016-03-18 11:32:25','2016-03-18 11:32:25','石泉县','610922','陕西省安康市石泉县'),(3178,'2016-03-18 11:32:25','2016-03-18 11:32:25','宁陕县','610923','陕西省安康市宁陕县'),(3179,'2016-03-18 11:32:25','2016-03-18 11:32:25','紫阳县','610924','陕西省安康市紫阳县'),(3180,'2016-03-18 11:32:25','2016-03-18 11:32:25','岚皋县','610925','陕西省安康市岚皋县'),(3181,'2016-03-18 11:32:25','2016-03-18 11:32:25','平利县','610926','陕西省安康市平利县'),(3182,'2016-03-18 11:32:26','2016-03-18 11:32:26','镇坪县','610927','陕西省安康市镇坪县'),(3183,'2016-03-18 11:32:26','2016-03-18 11:32:26','旬阳县','610928','陕西省安康市旬阳县'),(3184,'2016-03-18 11:32:26','2016-03-18 11:32:26','白河县','610929','陕西省安康市白河县'),(3185,'2016-03-18 11:32:26','2016-03-18 11:32:26','商洛市','611000','陕西省商洛市'),(3186,'2016-03-18 11:32:26','2016-03-18 11:32:26','市辖区','611001','陕西省商洛市市辖区'),(3187,'2016-03-18 11:32:26','2016-03-18 11:32:26','商州区','611002','陕西省商洛市商州区'),(3188,'2016-03-18 11:32:26','2016-03-18 11:32:26','洛南县','611021','陕西省商洛市洛南县'),(3189,'2016-03-18 11:32:26','2016-03-18 11:32:26','丹凤县','611022','陕西省商洛市丹凤县'),(3190,'2016-03-18 11:32:26','2016-03-18 11:32:26','商南县','611023','陕西省商洛市商南县'),(3191,'2016-03-18 11:32:26','2016-03-18 11:32:26','山阳县','611024','陕西省商洛市山阳县'),(3192,'2016-03-18 11:32:26','2016-03-18 11:32:26','镇安县','611025','陕西省商洛市镇安县'),(3193,'2016-03-18 11:32:26','2016-03-18 11:32:26','柞水县','611026','陕西省商洛市柞水县'),(3194,'2016-03-18 11:32:26','2016-03-18 11:32:26','甘肃省','620000','甘肃省'),(3195,'2016-03-18 11:32:27','2016-03-18 11:32:27','兰州市','620100','甘肃省兰州市'),(3196,'2016-03-18 11:32:27','2016-03-18 11:32:27','市辖区','620101','甘肃省兰州市市辖区'),(3197,'2016-03-18 11:32:27','2016-03-18 11:32:27','城关区','620102','甘肃省兰州市城关区'),(3198,'2016-03-18 11:32:27','2016-03-18 11:32:27','七里河区','620103','甘肃省兰州市七里河区'),(3199,'2016-03-18 11:32:27','2016-03-18 11:32:27','西固区','620104','甘肃省兰州市西固区'),(3200,'2016-03-18 11:32:27','2016-03-18 11:32:27','安宁区','620105','甘肃省兰州市安宁区'),(3201,'2016-03-18 11:32:27','2016-03-18 11:32:27','红古区','620111','甘肃省兰州市红古区'),(3202,'2016-03-18 11:32:27','2016-03-18 11:32:27','永登县','620121','甘肃省兰州市永登县'),(3203,'2016-03-18 11:32:27','2016-03-18 11:32:27','皋兰县','620122','甘肃省兰州市皋兰县'),(3204,'2016-03-18 11:32:27','2016-03-18 11:32:27','榆中县','620123','甘肃省兰州市榆中县'),(3205,'2016-03-18 11:32:27','2016-03-18 11:32:27','嘉峪关市','620200','甘肃省嘉峪关市'),(3206,'2016-03-18 11:32:27','2016-03-18 11:32:27','市辖区','620201','甘肃省嘉峪关市市辖区'),(3207,'2016-03-18 11:32:27','2016-03-18 11:32:27','金昌市','620300','甘肃省金昌市'),(3208,'2016-03-18 11:32:27','2016-03-18 11:32:27','市辖区','620301','甘肃省金昌市市辖区'),(3209,'2016-03-18 11:32:27','2016-03-18 11:32:27','金川区','620302','甘肃省金昌市金川区'),(3210,'2016-03-18 11:32:27','2016-03-18 11:32:27','永昌县','620321','甘肃省金昌市永昌县'),(3211,'2016-03-18 11:32:27','2016-03-18 11:32:27','白银市','620400','甘肃省白银市'),(3212,'2016-03-18 11:32:27','2016-03-18 11:32:27','市辖区','620401','甘肃省白银市市辖区'),(3213,'2016-03-18 11:32:28','2016-03-18 11:32:28','白银区','620402','甘肃省白银市白银区'),(3214,'2016-03-18 11:32:28','2016-03-18 11:32:28','平川区','620403','甘肃省白银市平川区'),(3215,'2016-03-18 11:32:28','2016-03-18 11:32:28','靖远县','620421','甘肃省白银市靖远县'),(3216,'2016-03-18 11:32:28','2016-03-18 11:32:28','会宁县','620422','甘肃省白银市会宁县'),(3217,'2016-03-18 11:32:28','2016-03-18 11:32:28','景泰县','620423','甘肃省白银市景泰县'),(3218,'2016-03-18 11:32:28','2016-03-18 11:32:28','天水市','620500','甘肃省天水市'),(3219,'2016-03-18 11:32:28','2016-03-18 11:32:28','市辖区','620501','甘肃省天水市市辖区'),(3220,'2016-03-18 11:32:28','2016-03-18 11:32:28','秦州区','620502','甘肃省天水市秦州区'),(3221,'2016-03-18 11:32:28','2016-03-18 11:32:28','麦积区','620503','甘肃省天水市麦积区'),(3222,'2016-03-18 11:32:28','2016-03-18 11:32:28','清水县','620521','甘肃省天水市清水县'),(3223,'2016-03-18 11:32:28','2016-03-18 11:32:28','秦安县','620522','甘肃省天水市秦安县'),(3224,'2016-03-18 11:32:28','2016-03-18 11:32:28','甘谷县','620523','甘肃省天水市甘谷县'),(3225,'2016-03-18 11:32:28','2016-03-18 11:32:28','武山县','620524','甘肃省天水市武山县'),(3226,'2016-03-18 11:32:28','2016-03-18 11:32:28','张家川回族自治县','620525','甘肃省天水市张家川回族自治县'),(3227,'2016-03-18 11:32:28','2016-03-18 11:32:28','武威市','620600','甘肃省武威市'),(3228,'2016-03-18 11:32:28','2016-03-18 11:32:28','市辖区','620601','甘肃省武威市市辖区'),(3229,'2016-03-18 11:32:28','2016-03-18 11:32:28','凉州区','620602','甘肃省武威市凉州区'),(3230,'2016-03-18 11:32:28','2016-03-18 11:32:28','民勤县','620621','甘肃省武威市民勤县'),(3231,'2016-03-18 11:32:29','2016-03-18 11:32:29','古浪县','620622','甘肃省武威市古浪县'),(3232,'2016-03-18 11:32:29','2016-03-18 11:32:29','天祝藏族自治县','620623','甘肃省武威市天祝藏族自治县'),(3233,'2016-03-18 11:32:29','2016-03-18 11:32:29','张掖市','620700','甘肃省张掖市'),(3234,'2016-03-18 11:32:29','2016-03-18 11:32:29','市辖区','620701','甘肃省张掖市市辖区'),(3235,'2016-03-18 11:32:29','2016-03-18 11:32:29','甘州区','620702','甘肃省张掖市甘州区'),(3236,'2016-03-18 11:32:29','2016-03-18 11:32:29','肃南裕固族自治县','620721','甘肃省张掖市肃南裕固族自治县'),(3237,'2016-03-18 11:32:29','2016-03-18 11:32:29','民乐县','620722','甘肃省张掖市民乐县'),(3238,'2016-03-18 11:32:29','2016-03-18 11:32:29','临泽县','620723','甘肃省张掖市临泽县'),(3239,'2016-03-18 11:32:29','2016-03-18 11:32:29','高台县','620724','甘肃省张掖市高台县'),(3240,'2016-03-18 11:32:29','2016-03-18 11:32:29','山丹县','620725','甘肃省张掖市山丹县'),(3241,'2016-03-18 11:32:29','2016-03-18 11:32:29','平凉市','620800','甘肃省平凉市'),(3242,'2016-03-18 11:32:29','2016-03-18 11:32:29','市辖区','620801','甘肃省平凉市市辖区'),(3243,'2016-03-18 11:32:29','2016-03-18 11:32:29','崆峒区','620802','甘肃省平凉市崆峒区'),(3244,'2016-03-18 11:32:29','2016-03-18 11:32:29','泾川县','620821','甘肃省平凉市泾川县'),(3245,'2016-03-18 11:32:29','2016-03-18 11:32:29','灵台县','620822','甘肃省平凉市灵台县'),(3246,'2016-03-18 11:32:29','2016-03-18 11:32:29','崇信县','620823','甘肃省平凉市崇信县'),(3247,'2016-03-18 11:32:29','2016-03-18 11:32:29','华亭县','620824','甘肃省平凉市华亭县'),(3248,'2016-03-18 11:32:29','2016-03-18 11:32:29','庄浪县','620825','甘肃省平凉市庄浪县'),(3249,'2016-03-18 11:32:29','2016-03-18 11:32:29','静宁县','620826','甘肃省平凉市静宁县'),(3250,'2016-03-18 11:32:29','2016-03-18 11:32:29','酒泉市','620900','甘肃省酒泉市'),(3251,'2016-03-18 11:32:29','2016-03-18 11:32:29','市辖区','620901','甘肃省酒泉市市辖区'),(3252,'2016-03-18 11:32:30','2016-03-18 11:32:30','肃州区','620902','甘肃省酒泉市肃州区'),(3253,'2016-03-18 11:32:30','2016-03-18 11:32:30','金塔县','620921','甘肃省酒泉市金塔县'),(3254,'2016-03-18 11:32:30','2016-03-18 11:32:30','瓜州县','620922','甘肃省酒泉市瓜州县'),(3255,'2016-03-18 11:32:30','2016-03-18 11:32:30','肃北蒙古族自治县','620923','甘肃省酒泉市肃北蒙古族自治县'),(3256,'2016-03-18 11:32:30','2016-03-18 11:32:30','阿克塞哈萨克族自治县','620924','甘肃省酒泉市阿克塞哈萨克族自治县'),(3257,'2016-03-18 11:32:30','2016-03-18 11:32:30','玉门市','620981','甘肃省酒泉市玉门市'),(3258,'2016-03-18 11:32:30','2016-03-18 11:32:30','敦煌市','620982','甘肃省酒泉市敦煌市'),(3259,'2016-03-18 11:32:30','2016-03-18 11:32:30','庆阳市','621000','甘肃省庆阳市'),(3260,'2016-03-18 11:32:30','2016-03-18 11:32:30','市辖区','621001','甘肃省庆阳市市辖区'),(3261,'2016-03-18 11:32:30','2016-03-18 11:32:30','西峰区','621002','甘肃省庆阳市西峰区'),(3262,'2016-03-18 11:32:30','2016-03-18 11:32:30','庆城县','621021','甘肃省庆阳市庆城县'),(3263,'2016-03-18 11:32:30','2016-03-18 11:32:30','环县','621022','甘肃省庆阳市环县'),(3264,'2016-03-18 11:32:30','2016-03-18 11:32:30','华池县','621023','甘肃省庆阳市华池县'),(3265,'2016-03-18 11:32:30','2016-03-18 11:32:30','合水县','621024','甘肃省庆阳市合水县'),(3266,'2016-03-18 11:32:30','2016-03-18 11:32:30','正宁县','621025','甘肃省庆阳市正宁县'),(3267,'2016-03-18 11:32:30','2016-03-18 11:32:30','宁县','621026','甘肃省庆阳市宁县'),(3268,'2016-03-18 11:32:30','2016-03-18 11:32:30','镇原县','621027','甘肃省庆阳市镇原县'),(3269,'2016-03-18 11:32:30','2016-03-18 11:32:30','定西市','621100','甘肃省定西市'),(3270,'2016-03-18 11:32:30','2016-03-18 11:32:30','市辖区','621101','甘肃省定西市市辖区'),(3271,'2016-03-18 11:32:31','2016-03-18 11:32:31','安定区','621102','甘肃省定西市安定区'),(3272,'2016-03-18 11:32:31','2016-03-18 11:32:31','通渭县','621121','甘肃省定西市通渭县'),(3273,'2016-03-18 11:32:31','2016-03-18 11:32:31','陇西县','621122','甘肃省定西市陇西县'),(3274,'2016-03-18 11:32:31','2016-03-18 11:32:31','渭源县','621123','甘肃省定西市渭源县'),(3275,'2016-03-18 11:32:31','2016-03-18 11:32:31','临洮县','621124','甘肃省定西市临洮县'),(3276,'2016-03-18 11:32:31','2016-03-18 11:32:31','漳县','621125','甘肃省定西市漳县'),(3277,'2016-03-18 11:32:31','2016-03-18 11:32:31','岷县','621126','甘肃省定西市岷县'),(3278,'2016-03-18 11:32:31','2016-03-18 11:32:31','陇南市','621200','甘肃省陇南市'),(3279,'2016-03-18 11:32:31','2016-03-18 11:32:31','市辖区','621201','甘肃省陇南市市辖区'),(3280,'2016-03-18 11:32:31','2016-03-18 11:32:31','武都区','621202','甘肃省陇南市武都区'),(3281,'2016-03-18 11:32:31','2016-03-18 11:32:31','成县','621221','甘肃省��南市成县'),(3282,'2016-03-18 11:32:31','2016-03-18 11:32:31','文县','621222','甘肃省陇南市文县'),(3283,'2016-03-18 11:32:31','2016-03-18 11:32:31','宕昌县','621223','甘肃省陇南市宕昌县'),(3284,'2016-03-18 11:32:31','2016-03-18 11:32:31','康县','621224','甘肃省陇南市康县'),(3285,'2016-03-18 11:32:31','2016-03-18 11:32:31','西和县','621225','甘肃省陇南市西和县'),(3286,'2016-03-18 11:32:31','2016-03-18 11:32:31','礼县','621226','甘肃省陇南市礼县'),(3287,'2016-03-18 11:32:32','2016-03-18 11:32:32','徽县','621227','甘肃省陇南市徽县'),(3288,'2016-03-18 11:32:32','2016-03-18 11:32:32','两当县','621228','甘肃省陇南市两当县'),(3289,'2016-03-18 11:32:32','2016-03-18 11:32:32','临夏回族自治州','622900','甘肃省临夏回族自治州'),(3290,'2016-03-18 11:32:32','2016-03-18 11:32:32','临夏市','622901','甘肃省临夏回族自治州临夏市'),(3291,'2016-03-18 11:32:32','2016-03-18 11:32:32','临夏县','622921','甘肃省临夏回族自治州临夏县'),(3292,'2016-03-18 11:32:32','2016-03-18 11:32:32','康乐县','622922','甘肃省临夏回族自治州康乐县'),(3293,'2016-03-18 11:32:32','2016-03-18 11:32:32','永靖县','622923','甘肃省临夏回族自治州永靖县'),(3294,'2016-03-18 11:32:32','2016-03-18 11:32:32','广河县','622924','甘肃省临夏回族自治州广河县'),(3295,'2016-03-18 11:32:32','2016-03-18 11:32:32','和政县','622925','甘肃省临夏回族自治州和政县'),(3296,'2016-03-18 11:32:32','2016-03-18 11:32:32','东乡族自治县','622926','甘肃省临夏回族自治州东乡族自治县'),(3297,'2016-03-18 11:32:32','2016-03-18 11:32:32','积石山保安族东乡族撒拉族自治县','622927','甘肃省临夏回族自治州积石山保安族东乡族撒拉族自治县'),(3298,'2016-03-18 11:32:32','2016-03-18 11:32:32','甘南藏族自治州','623000','甘肃省甘南藏族自治州'),(3299,'2016-03-18 11:32:32','2016-03-18 11:32:32','合作市','623001','甘肃省甘南藏族自治州合作市'),(3300,'2016-03-18 11:32:32','2016-03-18 11:32:32','临潭县','623021','甘肃省甘南藏族自治州临潭县'),(3301,'2016-03-18 11:32:32','2016-03-18 11:32:32','卓尼县','623022','甘肃省甘南藏族自治州卓尼县'),(3302,'2016-03-18 11:32:32','2016-03-18 11:32:32','舟曲县','623023','甘肃省甘南藏族自治州舟曲县'),(3303,'2016-03-18 11:32:32','2016-03-18 11:32:32','迭部县','623024','甘肃省甘南藏族自治州迭部县'),(3304,'2016-03-18 11:32:33','2016-03-18 11:32:33','玛曲县','623025','甘肃省甘南藏族自治州玛曲县'),(3305,'2016-03-18 11:32:33','2016-03-18 11:32:33','碌曲县','623026','甘肃省甘南藏族自治州碌曲县'),(3306,'2016-03-18 11:32:33','2016-03-18 11:32:33','夏河县','623027','甘肃省甘南藏族自治州夏河县'),(3307,'2016-03-18 11:32:33','2016-03-18 11:32:33','青海省','630000','青海省'),(3308,'2016-03-18 11:32:33','2016-03-18 11:32:33','西宁市','630100','青海省西宁市'),(3309,'2016-03-18 11:32:33','2016-03-18 11:32:33','市辖区','630101','青海省西宁市市辖区'),(3310,'2016-03-18 11:32:33','2016-03-18 11:32:33','城东区','630102','青海省西宁市城东区'),(3311,'2016-03-18 11:32:33','2016-03-18 11:32:33','城中区','630103','青海省西宁市城中区'),(3312,'2016-03-18 11:32:33','2016-03-18 11:32:33','城西区','630104','青海省西宁市城西区'),(3313,'2016-03-18 11:32:33','2016-03-18 11:32:33','城北区','630105','青海省西宁市城北区'),(3314,'2016-03-18 11:32:33','2016-03-18 11:32:33','大通回族土族自治县','630121','青海省西宁市大通回族土族自治县'),(3315,'2016-03-18 11:32:33','2016-03-18 11:32:33','湟中县','630122','青海省西宁市湟中县'),(3316,'2016-03-18 11:32:33','2016-03-18 11:32:33','湟源县','630123','青海省西宁市湟源县'),(3317,'2016-03-18 11:32:33','2016-03-18 11:32:33','海东市','630200','青海省海东市'),(3318,'2016-03-18 11:32:33','2016-03-18 11:32:33','乐都区','630202','青海省海东市乐都区'),(3319,'2016-03-18 11:32:33','2016-03-18 11:32:33','平安县','630221','青海省海东市平安县'),(3320,'2016-03-18 11:32:33','2016-03-18 11:32:33','民和回族土族自治县','630222','青海省海东市民和回族土族自治县'),(3321,'2016-03-18 11:32:34','2016-03-18 11:32:34','互助土族自治县','630223','青海省海东市互助土族自治县'),(3322,'2016-03-18 11:32:34','2016-03-18 11:32:34','化隆回族自治县','630224','青海省海东市化隆回族自治县'),(3323,'2016-03-18 11:32:34','2016-03-18 11:32:34','循化撒拉族自治县','630225','青海省海东市循化撒拉族自治县'),(3324,'2016-03-18 11:32:34','2016-03-18 11:32:34','海北藏族自治州','632200','青海省海北藏族自治州'),(3325,'2016-03-18 11:32:34','2016-03-18 11:32:34','门源回族自治县','632221','青海省海北藏族自治州门源回族自治县'),(3326,'2016-03-18 11:32:34','2016-03-18 11:32:34','祁连县','632222','青海省海北藏族自治州祁连县'),(3327,'2016-03-18 11:32:34','2016-03-18 11:32:34','海晏县','632223','青海省海北藏族自治州海晏县'),(3328,'2016-03-18 11:32:34','2016-03-18 11:32:34','刚察县','632224','青海省海北藏族自治州刚察县'),(3329,'2016-03-18 11:32:34','2016-03-18 11:32:34','黄南藏族自治州','632300','青海省黄南藏族自治州'),(3330,'2016-03-18 11:32:34','2016-03-18 11:32:34','同仁县','632321','青海省黄南藏族自治州同仁县'),(3331,'2016-03-18 11:32:34','2016-03-18 11:32:34','尖扎县','632322','青海省黄南藏族自治州尖扎县'),(3332,'2016-03-18 11:32:34','2016-03-18 11:32:34','泽库县','632323','青海省黄南藏族自治州泽库县'),(3333,'2016-03-18 11:32:34','2016-03-18 11:32:34','河南蒙古族自治县','632324','青海省黄南藏族自治州河南蒙古族自治县'),(3334,'2016-03-18 11:32:34','2016-03-18 11:32:34','海南藏族自治州','632500','青海省海南藏族自治州'),(3335,'2016-03-18 11:32:35','2016-03-18 11:32:35','共和县','632521','青海省海南藏族自治州共和县'),(3336,'2016-03-18 11:32:35','2016-03-18 11:32:35','同德县','632522','青海省海南藏族自治州同德县'),(3337,'2016-03-18 11:32:35','2016-03-18 11:32:35','贵德县','632523','青海省海南藏族自治州贵德县'),(3338,'2016-03-18 11:32:35','2016-03-18 11:32:35','兴海县','632524','青海省海南藏族自治州兴海县'),(3339,'2016-03-18 11:32:35','2016-03-18 11:32:35','贵南县','632525','青海省海南藏族自治州贵南县'),(3340,'2016-03-18 11:32:35','2016-03-18 11:32:35','果洛藏族自治州','632600','青海省果洛藏族自治州'),(3341,'2016-03-18 11:32:35','2016-03-18 11:32:35','玛沁县','632621','青海省果洛藏族自治州玛沁县'),(3342,'2016-03-18 11:32:35','2016-03-18 11:32:35','班玛县','632622','青海省果洛藏族自治州班玛县'),(3343,'2016-03-18 11:32:35','2016-03-18 11:32:35','甘德县','632623','青海省果洛藏族自治州甘德县'),(3344,'2016-03-18 11:32:35','2016-03-18 11:32:35','达日县','632624','青海省果洛藏族自治州达日县'),(3345,'2016-03-18 11:32:35','2016-03-18 11:32:35','久治县','632625','青海省果洛藏族自治州久治县'),(3346,'2016-03-18 11:32:35','2016-03-18 11:32:35','玛多县','632626','青海省果洛藏族自治州玛多县'),(3347,'2016-03-18 11:32:35','2016-03-18 11:32:35','玉树藏族自治州','632700','青海省玉树藏族自治州'),(3348,'2016-03-18 11:32:35','2016-03-18 11:32:35','玉树市','632701','青海省玉树藏族自治州玉树市'),(3349,'2016-03-18 11:32:35','2016-03-18 11:32:35','杂多县','632722','青海省玉树藏族自治州杂多县'),(3350,'2016-03-18 11:32:35','2016-03-18 11:32:35','称多县','632723','青海省玉树藏族自治州称多县'),(3351,'2016-03-18 11:32:35','2016-03-18 11:32:35','治多县','632724','青海省玉树藏族自治州治多县'),(3352,'2016-03-18 11:32:35','2016-03-18 11:32:35','囊谦县','632725','青海省玉树藏族自治州囊谦县'),(3353,'2016-03-18 11:32:36','2016-03-18 11:32:36','曲麻莱县','632726','青海省玉树藏族自治州曲麻莱县'),(3354,'2016-03-18 11:32:36','2016-03-18 11:32:36','海西蒙古族藏族自治州','632800','青海省海西蒙古族藏族自治州'),(3355,'2016-03-18 11:32:36','2016-03-18 11:32:36','格尔木市','632801','青海省海西蒙古族藏族自治州格尔木市'),(3356,'2016-03-18 11:32:36','2016-03-18 11:32:36','德令哈市','632802','青海省海西蒙古族藏族自治州德令哈市'),(3357,'2016-03-18 11:32:36','2016-03-18 11:32:36','乌兰县','632821','青海省海西蒙古族藏族自治州乌兰县'),(3358,'2016-03-18 11:32:36','2016-03-18 11:32:36','都兰县','632822','青海省海西蒙古族藏族自治州都兰县'),(3359,'2016-03-18 11:32:36','2016-03-18 11:32:36','天峻县','632823','青海省海西蒙古族藏族自治州天峻县'),(3360,'2016-03-18 11:32:36','2016-03-18 11:32:36','宁夏回族自治区','640000','宁夏回族自治区'),(3361,'2016-03-18 11:32:36','2016-03-18 11:32:36','银川市','640100','宁夏回族自治区银川市'),(3362,'2016-03-18 11:32:36','2016-03-18 11:32:36','市辖区','640101','宁夏回族自治区银川市市辖区'),(3363,'2016-03-18 11:32:36','2016-03-18 11:32:36','兴庆区','640104','宁夏回族自治区银川市兴庆区'),(3364,'2016-03-18 11:32:36','2016-03-18 11:32:36','西夏区','640105','宁夏回族自治区银川市西夏区'),(3365,'2016-03-18 11:32:36','2016-03-18 11:32:36','金凤区','640106','宁夏回族自治区银川市金凤区'),(3366,'2016-03-18 11:32:36','2016-03-18 11:32:36','永宁县','640121','宁夏回族自治区银川市永宁县'),(3367,'2016-03-18 11:32:37','2016-03-18 11:32:37','贺兰县','640122','宁夏回族自治区银川市贺兰县'),(3368,'2016-03-18 11:32:37','2016-03-18 11:32:37','灵武市','640181','宁夏回族自治区银川市灵武市'),(3369,'2016-03-18 11:32:37','2016-03-18 11:32:37','石嘴山市','640200','宁夏回族自治区石嘴山市'),(3370,'2016-03-18 11:32:37','2016-03-18 11:32:37','市辖区','640201','宁夏回族自治区石嘴山市市辖区'),(3371,'2016-03-18 11:32:37','2016-03-18 11:32:37','大武口区','640202','宁夏回族自治区石嘴山市大武口区'),(3372,'2016-03-18 11:32:37','2016-03-18 11:32:37','惠农区','640205','宁夏回族自治区石嘴山市惠农区'),(3373,'2016-03-18 11:32:37','2016-03-18 11:32:37','平罗县','640221','宁夏回族自治区石嘴山市平罗县'),(3374,'2016-03-18 11:32:37','2016-03-18 11:32:37','吴忠市','640300','宁夏回族自治区吴忠市'),(3375,'2016-03-18 11:32:37','2016-03-18 11:32:37','市辖区','640301','宁夏回族自治区吴忠市市辖区'),(3376,'2016-03-18 11:32:37','2016-03-18 11:32:37','利通区','640302','宁夏回族自治区吴忠市利通区'),(3377,'2016-03-18 11:32:37','2016-03-18 11:32:37','红寺堡区','640303','宁夏回族自治区吴忠市红寺堡区'),(3378,'2016-03-18 11:32:37','2016-03-18 11:32:37','盐池县','640323','宁夏回族自治区吴忠市盐池县'),(3379,'2016-03-18 11:32:37','2016-03-18 11:32:37','同心县','640324','宁夏回族自治区吴忠市同心县'),(3380,'2016-03-18 11:32:38','2016-03-18 11:32:38','青铜峡市','640381','宁夏回族自治区吴忠市青铜峡市'),(3381,'2016-03-18 11:32:38','2016-03-18 11:32:38','固原市','640400','宁夏回族自治区固原市'),(3382,'2016-03-18 11:32:38','2016-03-18 11:32:38','市辖区','640401','宁夏回族自治区固原市市辖区'),(3383,'2016-03-18 11:32:38','2016-03-18 11:32:38','原州区','640402','宁夏回族自治区固原市原州区'),(3384,'2016-03-18 11:32:38','2016-03-18 11:32:38','西吉县','640422','宁夏回族自治区固原市西吉县'),(3385,'2016-03-18 11:32:38','2016-03-18 11:32:38','隆德县','640423','宁夏回族自治区固原市隆德县'),(3386,'2016-03-18 11:32:38','2016-03-18 11:32:38','泾源县','640424','宁夏回族自治区固原市泾源县'),(3387,'2016-03-18 11:32:38','2016-03-18 11:32:38','彭阳县','640425','宁夏回族自治区固原市彭阳县'),(3388,'2016-03-18 11:32:38','2016-03-18 11:32:38','中卫市','640500','宁夏回族自治区中卫市'),(3389,'2016-03-18 11:32:38','2016-03-18 11:32:38','市辖区','640501','宁夏回族自治区中卫市市辖区'),(3390,'2016-03-18 11:32:38','2016-03-18 11:32:38','沙坡头区','640502','宁夏回族自治区中卫市沙坡头区'),(3391,'2016-03-18 11:32:39','2016-03-18 11:32:39','中宁县','640521','宁夏回族自治区中卫市中宁县'),(3392,'2016-03-18 11:32:39','2016-03-18 11:32:39','��原县','640522','宁夏回族自治区中卫市海原县'),(3393,'2016-03-18 11:32:39','2016-03-18 11:32:39','新疆维吾尔自治区','650000','新疆维吾尔自治区'),(3394,'2016-03-18 11:32:39','2016-03-18 11:32:39','乌鲁木齐市','650100','新疆维吾尔自治区乌鲁木齐市'),(3395,'2016-03-18 11:32:39','2016-03-18 11:32:39','市辖区','650101','新疆维吾尔自治区乌鲁木齐市市辖区'),(3396,'2016-03-18 11:32:39','2016-03-18 11:32:39','天山区','650102','新疆维吾尔自治区乌鲁木齐市天山区'),(3397,'2016-03-18 11:32:39','2016-03-18 11:32:39','沙依巴克区','650103','新疆维吾尔自治区乌鲁木齐市沙依巴克区'),(3398,'2016-03-18 11:32:39','2016-03-18 11:32:39','新市区','650104','新疆维吾尔自治区乌鲁木齐市新市区'),(3399,'2016-03-18 11:32:39','2016-03-18 11:32:39','水磨沟区','650105','新疆维吾尔自治区乌鲁木齐市水磨沟区'),(3400,'2016-03-18 11:32:39','2016-03-18 11:32:39','头屯河区','650106','新疆维吾尔自治区乌鲁木齐市头屯河区'),(3401,'2016-03-18 11:32:39','2016-03-18 11:32:39','达坂城区','650107','新疆维吾尔自治区乌鲁木齐市达坂城区'),(3402,'2016-03-18 11:32:39','2016-03-18 11:32:39','米东区','650109','新疆维吾尔自治区乌鲁木齐市米东区'),(3403,'2016-03-18 11:32:39','2016-03-18 11:32:39','乌鲁木齐县','650121','新疆维吾尔自治区乌鲁木齐市乌鲁木齐县'),(3404,'2016-03-18 11:32:40','2016-03-18 11:32:40','克拉玛依市','650200','新疆维吾尔自治区克拉玛依市'),(3405,'2016-03-18 11:32:40','2016-03-18 11:32:40','市辖区','650201','新疆维吾尔自治区克拉玛依市市辖区'),(3406,'2016-03-18 11:32:40','2016-03-18 11:32:40','独山子区','650202','新疆维吾尔自治区克拉玛依市独山子区'),(3407,'2016-03-18 11:32:40','2016-03-18 11:32:40','克拉玛依区','650203','新疆维吾尔自治区克拉玛依市克拉玛依区'),(3408,'2016-03-18 11:32:40','2016-03-18 11:32:40','白碱滩区','650204','新疆维吾尔自治区克拉玛依市白碱滩区'),(3409,'2016-03-18 11:32:40','2016-03-18 11:32:40','乌尔禾区','650205','新疆维吾尔自治区克拉玛依市乌尔禾区'),(3410,'2016-03-18 11:32:40','2016-03-18 11:32:40','吐鲁番地区','652100','新疆维吾尔自治区吐鲁番地区'),(3411,'2016-03-18 11:32:40','2016-03-18 11:32:40','吐鲁番市','652101','新疆维吾尔自治区吐鲁番地区吐鲁番市'),(3412,'2016-03-18 11:32:40','2016-03-18 11:32:40','鄯善县','652122','新疆维吾尔自治区吐鲁番地区鄯善县'),(3413,'2016-03-18 11:32:40','2016-03-18 11:32:40','托克逊县','652123','新疆维吾尔自治区吐鲁番地区托克逊县'),(3414,'2016-03-18 11:32:40','2016-03-18 11:32:40','哈密地区','652200','新疆维吾尔自治区哈密地区'),(3415,'2016-03-18 11:32:40','2016-03-18 11:32:40','哈密市','652201','新疆维吾尔自治区哈密地区哈密市'),(3416,'2016-03-18 11:32:40','2016-03-18 11:32:40','巴里坤哈萨克自治县','652222','新疆维吾尔自治区哈密地区巴里坤哈萨克自治县'),(3417,'2016-03-18 11:32:40','2016-03-18 11:32:40','伊吾县','652223','新疆维吾尔自治区哈密地区伊吾县'),(3418,'2016-03-18 11:32:41','2016-03-18 11:32:41','昌吉回族自治州','652300','新疆维吾尔自治区昌吉回族自治州'),(3419,'2016-03-18 11:32:41','2016-03-18 11:32:41','昌吉市','652301','新疆维吾尔自治区昌吉回族自治州昌吉市'),(3420,'2016-03-18 11:32:41','2016-03-18 11:32:41','阜康市','652302','新疆维吾尔自治区昌吉回族自治州阜康市'),(3421,'2016-03-18 11:32:41','2016-03-18 11:32:41','呼图壁县','652323','新疆维吾尔自治区昌吉回族自治州呼图壁县'),(3422,'2016-03-18 11:32:41','2016-03-18 11:32:41','玛纳斯县','652324','新疆维吾尔自治区昌吉回族自治州玛纳斯县'),(3423,'2016-03-18 11:32:41','2016-03-18 11:32:41','奇台县','652325','新疆维吾尔自治区昌吉回族自治州奇台县'),(3424,'2016-03-18 11:32:41','2016-03-18 11:32:41','吉木萨尔县','652327','新疆维吾尔自治区昌吉回族自治州吉木萨尔县'),(3425,'2016-03-18 11:32:41','2016-03-18 11:32:41','木垒哈萨克自治县','652328','新疆维吾尔自治区昌吉回族自治州木垒哈萨克自治县'),(3426,'2016-03-18 11:32:41','2016-03-18 11:32:41','博尔塔拉蒙古自治州','652700','新疆维吾尔自治区博尔塔拉蒙古自治州'),(3427,'2016-03-18 11:32:41','2016-03-18 11:32:41','博乐市','652701','新疆维吾尔自治区博尔塔拉蒙古自治州博乐市'),(3428,'2016-03-18 11:32:41','2016-03-18 11:32:41','阿拉山口市','652702','新疆维吾尔自治区博尔塔拉蒙古自治州阿拉山口市'),(3429,'2016-03-18 11:32:41','2016-03-18 11:32:41','精河县','652722','新疆维吾尔自治区博尔塔拉蒙古自治州精河县'),(3430,'2016-03-18 11:32:42','2016-03-18 11:32:42','温泉县','652723','新疆维吾尔自治区博尔塔拉蒙古自治州温泉县'),(3431,'2016-03-18 11:32:42','2016-03-18 11:32:42','巴音郭楞蒙古自治州','652800','新疆维吾尔自治区巴音郭楞蒙古自治州'),(3432,'2016-03-18 11:32:42','2016-03-18 11:32:42','库尔勒市','652801','新疆维吾尔自治区巴音郭楞蒙古自治州库尔勒市'),(3433,'2016-03-18 11:32:42','2016-03-18 11:32:42','轮台县','652822','新疆维吾尔自治区巴音郭楞蒙古自治州轮台县'),(3434,'2016-03-18 11:32:42','2016-03-18 11:32:42','尉犁县','652823','新疆维吾尔自治区巴音郭楞蒙古自治州尉犁县'),(3435,'2016-03-18 11:32:42','2016-03-18 11:32:42','若羌县','652824','新疆维吾尔自治区巴音郭楞蒙古自治州若羌县'),(3436,'2016-03-18 11:32:42','2016-03-18 11:32:42','且末县','652825','新疆维吾尔自治区巴音郭楞蒙古自治州且末县'),(3437,'2016-03-18 11:32:42','2016-03-18 11:32:42','焉耆回族自治县','652826','新疆维吾尔自治区巴音郭楞蒙古自治州焉耆回族自治县'),(3438,'2016-03-18 11:32:42','2016-03-18 11:32:42','和静县','652827','新疆维吾尔自治区巴音郭楞蒙古自治州和静县'),(3439,'2016-03-18 11:32:42','2016-03-18 11:32:42','和硕县','652828','新疆维吾尔自治区巴音郭楞蒙古自治州和硕县'),(3440,'2016-03-18 11:32:42','2016-03-18 11:32:42','博湖县','652829','新疆维吾尔自治区巴音郭楞蒙古自治州博湖县'),(3441,'2016-03-18 11:32:42','2016-03-18 11:32:42','阿克苏地区','652900','新疆维吾尔自治区阿克苏地区'),(3442,'2016-03-18 11:32:42','2016-03-18 11:32:42','阿克苏市','652901','新疆维吾尔自治区阿克苏地区阿克苏市'),(3443,'2016-03-18 11:32:42','2016-03-18 11:32:42','温宿县','652922','新疆维吾尔自治区阿克苏地区温宿县'),(3444,'2016-03-18 11:32:43','2016-03-18 11:32:43','库车县','652923','新疆维吾尔自治区阿克苏地区库车县'),(3445,'2016-03-18 11:32:43','2016-03-18 11:32:43','沙雅县','652924','新疆维吾尔自治区阿克苏地区沙雅县'),(3446,'2016-03-18 11:32:43','2016-03-18 11:32:43','新和县','652925','新疆维吾尔自治区阿克苏地区新和县'),(3447,'2016-03-18 11:32:43','2016-03-18 11:32:43','拜城县','652926','新疆维吾尔自治区阿克苏地区拜城县'),(3448,'2016-03-18 11:32:43','2016-03-18 11:32:43','乌什县','652927','新疆维吾尔自治区阿克苏地区乌什县'),(3449,'2016-03-18 11:32:43','2016-03-18 11:32:43','阿瓦提县','652928','新疆维吾尔自治区阿克苏地区阿瓦提县'),(3450,'2016-03-18 11:32:43','2016-03-18 11:32:43','柯坪县','652929','新疆维吾尔自治区阿克苏地区柯坪县'),(3451,'2016-03-18 11:32:43','2016-03-18 11:32:43','克孜勒苏柯尔克孜自治州','653000','新疆维吾尔自治区克孜勒苏柯尔克孜自治州'),(3452,'2016-03-18 11:32:43','2016-03-18 11:32:43','阿图什市','653001','新疆维吾尔自治区克孜勒苏柯尔克孜自治州阿图什市'),(3453,'2016-03-18 11:32:43','2016-03-18 11:32:43','阿克陶县','653022','新疆维吾尔自治区克孜勒苏柯尔克孜自治州阿克陶县'),(3454,'2016-03-18 11:32:43','2016-03-18 11:32:43','阿合奇县','653023','新疆维吾尔自治区克孜勒苏柯尔克孜自治州阿合奇县'),(3455,'2016-03-18 11:32:43','2016-03-18 11:32:43','乌恰县','653024','新疆维吾尔自治区克孜勒苏柯尔克孜自治州乌恰县'),(3456,'2016-03-18 11:32:43','2016-03-18 11:32:43','喀什地区','653100','新疆维吾尔自治区喀什地区'),(3457,'2016-03-18 11:32:43','2016-03-18 11:32:43','喀什市','653101','新疆维吾尔自治区喀什地区喀什市'),(3458,'2016-03-18 11:32:43','2016-03-18 11:32:43','疏附县','653121','新疆维吾尔自治区喀什地区疏附县'),(3459,'2016-03-18 11:32:43','2016-03-18 11:32:43','疏勒县','653122','新疆维吾尔自治区喀什地区疏勒县'),(3460,'2016-03-18 11:32:43','2016-03-18 11:32:43','英吉沙县','653123','新疆维吾尔自治区喀什地区英吉沙县'),(3461,'2016-03-18 11:32:43','2016-03-18 11:32:43','泽普县','653124','新疆维吾尔自治区喀什地区泽普县'),(3462,'2016-03-18 11:32:43','2016-03-18 11:32:43','莎车县','653125','新疆维吾尔自治区喀什地区莎车县'),(3463,'2016-03-18 11:32:44','2016-03-18 11:32:44','叶城县','653126','新疆维吾尔自治区喀什地区叶城县'),(3464,'2016-03-18 11:32:44','2016-03-18 11:32:44','麦盖提县','653127','新疆维吾尔自治区喀什地区麦盖提县'),(3465,'2016-03-18 11:32:44','2016-03-18 11:32:44','岳普湖县','653128','新疆维吾尔自治区喀什地区岳普湖县'),(3466,'2016-03-18 11:32:44','2016-03-18 11:32:44','伽师县','653129','新疆维吾尔自治区喀什地区伽师县'),(3467,'2016-03-18 11:32:44','2016-03-18 11:32:44','巴楚县','653130','新疆维吾尔自治区喀什地区巴楚县'),(3468,'2016-03-18 11:32:44','2016-03-18 11:32:44','塔什库尔干塔吉克自治县','653131','新疆维吾尔自治区喀什地区塔什库尔干塔吉克自治县'),(3469,'2016-03-18 11:32:44','2016-03-18 11:32:44','和田地区','653200','新疆维吾尔自治区和田地区'),(3470,'2016-03-18 11:32:44','2016-03-18 11:32:44','和田市','653201','新疆维吾尔自治区和田地区和田市'),(3471,'2016-03-18 11:32:44','2016-03-18 11:32:44','和田县','653221','新疆维吾尔自治区和田地区和田县'),(3472,'2016-03-18 11:32:44','2016-03-18 11:32:44','墨玉县','653222','新疆维吾尔自治区和田地区墨玉县'),(3473,'2016-03-18 11:32:44','2016-03-18 11:32:44','皮山县','653223','新疆维吾尔自治区和田地区皮山县'),(3474,'2016-03-18 11:32:44','2016-03-18 11:32:44','洛浦县','653224','新疆维吾尔自治区和田地区洛浦县'),(3475,'2016-03-18 11:32:44','2016-03-18 11:32:44','策勒县','653225','新疆维吾尔自治区和田地区策勒县'),(3476,'2016-03-18 11:32:44','2016-03-18 11:32:44','于田县','653226','新疆维吾尔自治区和田地区于田县'),(3477,'2016-03-18 11:32:44','2016-03-18 11:32:44','民丰县','653227','新疆维吾尔自治区和田地区民丰县'),(3478,'2016-03-18 11:32:44','2016-03-18 11:32:44','伊犁哈萨克自治州','654000','新疆维吾尔自治区伊犁哈萨克自治州'),(3479,'2016-03-18 11:32:44','2016-03-18 11:32:44','伊宁市','654002','新疆维吾尔自治区伊犁哈萨克自治州伊宁市'),(3480,'2016-03-18 11:32:44','2016-03-18 11:32:44','奎屯市','654003','新疆维吾尔自治区伊犁哈萨克自治州奎屯市'),(3481,'2016-03-18 11:32:45','2016-03-18 11:32:45','伊宁县','654021','新疆维吾尔自治区伊犁哈萨克自治州伊宁县'),(3482,'2016-03-18 11:32:45','2016-03-18 11:32:45','察布查尔锡伯自治县','654022','新疆维吾尔自治区伊犁哈萨克自治州察布查尔锡伯自治县'),(3483,'2016-03-18 11:32:45','2016-03-18 11:32:45','霍城县','654023','新疆维吾尔自治区伊犁哈萨克自治州霍城县'),(3484,'2016-03-18 11:32:45','2016-03-18 11:32:45','巩留县','654024','新疆维吾尔自治区伊犁哈萨克自治州巩留县'),(3485,'2016-03-18 11:32:45','2016-03-18 11:32:45','新源县','654025','新疆维吾尔自治区伊犁哈萨克自治州新源县'),(3486,'2016-03-18 11:32:45','2016-03-18 11:32:45','昭苏县','654026','新疆维吾尔自治区伊犁哈萨克自治州昭苏县'),(3487,'2016-03-18 11:32:45','2016-03-18 11:32:45','特克斯县','654027','新疆维吾尔自治区伊犁哈萨克自治州特克斯县'),(3488,'2016-03-18 11:32:45','2016-03-18 11:32:45','尼勒克县','654028','新疆维吾尔自治区伊犁哈萨克自治州尼勒克县'),(3489,'2016-03-18 11:32:45','2016-03-18 11:32:45','塔城地区','654200','新疆维吾尔自治区塔城地区'),(3490,'2016-03-18 11:32:45','2016-03-18 11:32:45','塔城市','654201','新疆维吾尔自治区塔城地区塔城市'),(3491,'2016-03-18 11:32:45','2016-03-18 11:32:45','乌苏市','654202','新疆维吾尔自治区塔城地区乌苏市'),(3492,'2016-03-18 11:32:45','2016-03-18 11:32:45','额敏县','654221','新疆维吾尔自治区塔城地区额敏县'),(3493,'2016-03-18 11:32:45','2016-03-18 11:32:45','沙湾县','654223','新疆维吾尔自治区塔城地区沙湾县'),(3494,'2016-03-18 11:32:45','2016-03-18 11:32:45','托里县','654224','新疆维吾尔自治区塔城地区托里县'),(3495,'2016-03-18 11:32:45','2016-03-18 11:32:45','裕民县','654225','新疆维吾尔自治区塔城地区裕民县'),(3496,'2016-03-18 11:32:45','2016-03-18 11:32:45','和布克赛尔蒙古自治县','654226','新疆维吾尔自治区塔城地区和布克赛尔蒙古自治县'),(3497,'2016-03-18 11:32:45','2016-03-18 11:32:45','阿勒泰地区','654300','新疆维吾尔自治区阿勒泰地区'),(3498,'2016-03-18 11:32:45','2016-03-18 11:32:45','阿勒泰市','654301','新疆维吾尔自治区阿勒泰地区阿勒泰市'),(3499,'2016-03-18 11:32:45','2016-03-18 11:32:45','布尔津县','654321','新疆维吾尔自治区阿勒泰地区布尔津县'),(3500,'2016-03-18 11:32:45','2016-03-18 11:32:45','富蕴县','654322','新疆维吾尔自治区阿勒泰地区富蕴县'),(3501,'2016-03-18 11:32:45','2016-03-18 11:32:45','福海县','654323','新疆维吾尔自治区阿勒泰地区福海县'),(3502,'2016-03-18 11:32:46','2016-03-18 11:32:46','哈巴河县','654324','新疆维吾尔自治区阿勒泰地区哈巴河县'),(3503,'2016-03-18 11:32:46','2016-03-18 11:32:46','青河县','654325','新疆维吾尔自治区阿勒泰地区青河县'),(3504,'2016-03-18 11:32:46','2016-03-18 11:32:46','吉木乃县','654326','新疆维吾尔自治区阿勒泰地区吉木乃县'),(3505,'2016-03-18 11:32:46','2016-03-18 11:32:46','自治区直辖县级行政区划','659000','新疆维吾尔自治区自治区直辖县级行政区划'),(3506,'2016-03-18 11:32:46','2016-03-18 11:32:46','石河子市','659001','新疆维吾尔自治区石河子市'),(3507,'2016-03-18 11:32:46','2016-03-18 11:32:46','阿拉尔市','659002','新疆维吾尔自治区阿拉尔市'),(3508,'2016-03-18 11:32:46','2016-03-18 11:32:46','图木舒克市','659003','新疆维吾尔自治区图木舒克市'),(3509,'2016-03-18 11:32:46','2016-03-18 11:32:46','五家渠市','659004','新疆维吾尔自治区五家渠市'),(3510,'2016-03-18 11:32:46','2016-03-18 11:32:46','台湾省','710000','台湾省'),(3511,'2016-03-18 11:32:46','2016-03-18 11:32:46','香港特别行政区','810000','香港特别行政区'),(3512,'2016-03-18 11:32:46','2016-03-18 11:32:46','澳门特别行政区','820000','澳门特别行政区'),(3513,'2019-10-08 15:40:59','2019-10-08 15:41:04','香港岛','810100','香港特别行政区香港岛'),(3514,'2019-10-08 15:43:53','2019-10-08 15:43:56','中西区','810101','香港特别行政区香港岛中西区'),(3515,'2019-10-08 15:44:45','2019-10-08 15:44:53','湾仔','810102','香港特别行政区香港岛湾仔'),(3516,'2019-10-08 15:45:48','2019-10-08 15:45:46','东区','810103','香港特别行政区香港岛东区'),(3517,'2019-10-08 15:46:37','2019-10-08 15:46:35','南区','810104','香港特别行政区香港岛南区'),(3518,'2019-10-08 15:47:29','2019-10-08 15:47:27','九龙','810200','香港特别行政区九龙'),(3519,'2019-10-08 15:48:43','2019-10-08 15:48:40','九龙城区','810201','香港特别行政区九龙九龙城区'),(3520,'2019-10-08 16:07:39','2019-10-08 16:07:37','油尖旺区','810202','香港特别行政区九龙油尖旺区'),(3521,'2019-10-08 16:08:08','2019-10-08 16:08:05','深水埗区','810203','香港特别行政区九龙深水埗区'),(3522,'2019-10-08 16:08:37','2019-10-08 16:08:35','黄大仙区','810204','香港特别行政区九龙黄大仙区'),(3523,'2019-10-08 16:09:08','2019-10-08 16:09:12','观塘区','810205','香港特别行政区九龙观塘区'),(3524,'2019-10-08 16:09:50','2019-10-08 16:09:53','新界','810300','香港特别行政区新界'),(3525,'2019-10-08 16:10:28','2019-10-08 16:10:25','北区','810301','香港特别行政区新界北区'),(3526,'2019-10-08 16:10:53','2019-10-08 16:10:49','大埔区','810302','香港特别行政区新界大埔区'),(3527,'2019-10-08 16:11:16','2019-10-08 16:11:12','沙田区','810303','香港特别行政区新界沙田区'),(3528,'2019-10-08 16:11:38','2019-10-08 16:11:36','西贡区','810304','香港特别行政区新界西贡区'),(3529,'2019-10-08 16:12:03','2019-10-08 16:11:59','元朗区','810305','香港特别行政区新界元朗区'),(3530,'2019-10-08 16:12:28','2019-10-08 16:12:26','屯门区','810306','香港特别行政区新界屯门区'),(3531,'2019-10-08 16:12:58','2019-10-08 16:12:56','荃湾区','810307','香港特别行政区新界荃湾区'),(3532,'2019-10-08 16:13:23','2019-10-08 16:13:20','葵青区','810308','香港特别行政区新界葵青区'),(3533,'2019-10-08 16:13:57','2019-10-08 16:14:00','离岛区','810309','香港特别行政区新界离岛区'),(3534,'2019-10-08 16:15:07','2019-10-08 16:15:04','澳门半岛','820100','澳门特别行政区澳门半岛'),(3535,'2019-10-08 16:24:03','2019-10-08 16:23:59','离岛','820200','澳门特别行政区离岛'),(3536,'2019-10-08 16:38:25','2019-10-08 16:38:22','台北市','710100','台湾省台北市'),(3537,'2019-10-08 16:39:09','2019-10-08 16:39:06','中正区','710101','台湾省台北市中正区'),(3538,'2019-10-08 16:41:05','2019-10-08 16:40:59','大同区','710102','台湾省台北市大同区'),(3539,'2019-10-08 16:41:29','2019-10-08 16:41:25','中山区','710103','台湾省台北市中山区'),(3540,'2019-10-08 16:41:56','2019-10-08 16:41:53','松山区','710104','台湾省台北市松山区'),(3541,'2019-10-08 16:42:20','2019-10-08 16:42:22','大安区','710105','台湾省台北市大安区'),(3542,'2019-10-08 16:42:50','2019-10-08 16:42:48','万华区','710106','台湾省台北市万华区'),(3543,'2019-10-08 16:43:14','2019-10-08 16:43:12','信义区','710107','台湾省台北市信义区'),(3544,'2019-10-08 16:43:41','2019-10-08 16:43:38','士林区','710108','台湾省台北市士林区'),(3545,'2019-10-08 16:44:04','2019-10-08 16:44:06','北投区','710109','台湾省台北市北投区'),(3546,'2019-10-08 16:44:45','2019-10-08 16:44:42','内湖区','710110','台湾省台北市内湖区'),(3547,'2019-10-08 16:46:08','2019-10-08 16:46:05','南港区','710111','台湾省台北市南港区'),(3548,'2019-10-08 16:46:38','2019-10-08 16:46:35','文山区','710112','台湾省台北市文山区'),(3549,'2019-10-08 16:47:01','2019-10-08 16:46:58','其它区','710113','台湾省台北市其它区'),(3550,'2019-10-08 16:46:58','2019-10-08 16:46:58','高雄市','710200','台湾省高雄市'),(3551,'2019-10-08 16:46:58','2019-10-08 16:46:58','新兴区','710201','台湾省高雄市新兴区'),(3552,'2019-10-08 16:46:58','2019-10-08 16:46:58','前金区','710202','台湾省高雄市前金区'),(3553,'2019-10-08 16:46:58','2019-10-08 16:46:58','芩雅区','710203','台湾省高雄市芩雅区'),(3554,'2019-10-08 16:46:58','2019-10-08 16:46:58','盐埕区','710204','台湾省高雄市盐埕区'),(3555,'2019-10-08 16:46:58','2019-10-08 16:46:58','鼓山区','710205','台湾省高雄市鼓山区'),(3556,'2019-10-08 16:46:58','2019-10-08 16:46:58','旗津区','710206','台湾省高雄市旗津区'),(3557,'2019-10-08 16:46:58','2019-10-08 16:46:58','前镇区','710207','台湾省高雄市前镇区'),(3558,'2019-10-08 16:46:58','2019-10-08 16:46:58','三民区','710208','台湾省高雄市三民区'),(3559,'2019-10-08 16:46:58','2019-10-08 16:46:58','左营区','710209','台湾省高雄市左营区'),(3560,'2019-10-08 16:46:58','2019-10-08 16:46:58','楠梓区','710210','台湾省高雄市楠梓区'),(3561,'2019-10-08 16:46:58','2019-10-08 16:46:58','小港区','710211','台湾省高雄市小港区'),(3562,'2019-10-08 16:46:58','2019-10-08 16:46:58','其它区','710212','台湾省高雄市其它区'),(3563,NULL,NULL,'台南市','710300','台湾省台南市'),(3564,NULL,NULL,'中西区','710301','台湾省台南市中西区'),(3565,NULL,NULL,'东区','710302','台湾省台南市东区'),(3566,NULL,NULL,'南区','710303','台湾省台南市南区'),(3567,NULL,NULL,'北区','710304','台湾省台南市北区'),(3568,NULL,NULL,'安平区','710305','台湾省台南市安平区'),(3569,NULL,NULL,'安南区','710306','台湾省台南市安南区'),(3570,NULL,NULL,'其它区','710307','台湾省台南市其它区'),(3571,NULL,NULL,'台中市','710400','台湾省台中市'),(3572,NULL,NULL,'中区','710401','台湾省台中市中区'),(3573,NULL,NULL,'东区','710402','台湾省台中市东区'),(3574,NULL,NULL,'南区','710403','台湾省台中市南区'),(3575,NULL,NULL,'西区','710404','台湾省台中市西区'),(3576,NULL,NULL,'北区','710405','台湾省台中市北区'),(3577,NULL,NULL,'北屯区','710406','台湾省台中市北屯区'),(3578,NULL,NULL,'西屯区','710407','台湾省台中市西屯区'),(3579,NULL,NULL,'南屯区','710408','台湾省台中市南屯区'),(3580,NULL,NULL,'其它区','710409','台湾省台中市其它区'),(3581,NULL,NULL,'金门县','710500','台湾省金门县'),(3582,NULL,NULL,'南投县','710600','台湾省南投县'),(3583,NULL,NULL,'基隆市','710700','台湾省基隆市'),(3584,NULL,NULL,'仁爱区','710701','台湾省基隆市仁爱区'),(3585,NULL,NULL,'信义区','710702','台湾省基隆市信义区'),(3586,NULL,NULL,'中正区','710703','台湾省基隆市中正区'),(3587,NULL,NULL,'中山区','710704','台湾省基隆市中山区'),(3588,NULL,NULL,'安乐区','710705','台湾省基隆市安乐区'),(3589,NULL,NULL,'暖暖区','710706','台湾省基隆市暖暖区'),(3590,NULL,NULL,'七堵区','710707','台湾省基隆市七堵区'),(3591,NULL,NULL,'其它区','710708','台湾省基隆市其它区'),(3592,NULL,NULL,'新竹市','710800','台湾省新竹市'),(3593,NULL,NULL,'东区','710801','台湾省新竹市东区'),(3594,NULL,NULL,'北区','710802','台湾省新竹市北区'),(3595,NULL,NULL,'香山区','710803','台湾省新竹市香山区'),(3596,NULL,NULL,'其它区','710804','台湾省新竹市其它区'),(3597,NULL,NULL,'嘉义市','710900','台湾省嘉义市'),(3598,NULL,NULL,'新北市','711100','台湾省新北市'),(3599,NULL,NULL,'宜兰县','711200','台湾省宜兰县'),(3600,NULL,NULL,'新竹县','711300','台湾省新竹县'),(3601,NULL,NULL,'桃园县','711400','台湾省桃园县'),(3602,NULL,NULL,'苗栗县','711500','台湾省苗栗县'),(3603,NULL,NULL,'彰化县','711700','台湾省彰化县'),(3604,NULL,NULL,'嘉义县','711900','台湾省嘉义县'),(3605,NULL,NULL,'云林县','712100','台湾省云林县'),(3606,NULL,NULL,'屏东县','712400','台湾省屏东县'),(3607,NULL,NULL,'台东县','712500','台湾省台东县'),(3608,NULL,NULL,'花莲县','712600','台湾省花莲县'),(3609,NULL,NULL,'澎湖县','712700','台湾省澎湖县'),(3610,'2019-12-13 12:08:19','2019-12-13 12:08:22','其他','720000','其他'),(3611,'2019-12-13 12:08:16','2019-12-13 12:08:25','其他','720100','其他'),(3612,'2020-01-15 16:55:47','2020-01-15 16:55:47','泉州经济技术开发区','350590','福建省泉州市泉州经济技术开发区'),(3613,'2020-01-17 17:21:53','2020-01-17 17:21:53','泉州市直','350591','福建省泉州市泉州市直'),(3614,'2020-01-17 17:21:53','2020-01-17 17:21:53','泉州市台商投资区','350592','福建省泉州市台商投资区');
/*!40000 ALTER TABLE `un_common_location` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_currency_filetype`
--

DROP TABLE IF EXISTS `un_currency_filetype`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_currency_filetype` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `type` varchar(30) DEFAULT NULL COMMENT '申报类别',
  `name` varchar(100) DEFAULT NULL COMMENT '附件类型名称',
  `api` varchar(20) DEFAULT NULL COMMENT '附件类型api',
  `must` tinyint(1) DEFAULT NULL COMMENT '是否必传',
  `active` tinyint(1) DEFAULT NULL COMMENT '是否生效',
  `sn` smallint(3) DEFAULT NULL COMMENT '排序',
  `checkCompany` varchar(30) DEFAULT NULL COMMENT '审核单位',
  `description` varchar(4000) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `templateUrl` varchar(255) DEFAULT NULL COMMENT '模板',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='通用附件类别表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_currency_filetype`
--

LOCK TABLES `un_currency_filetype` WRITE;
/*!40000 ALTER TABLE `un_currency_filetype` DISABLE KEYS */;
INSERT INTO `un_currency_filetype` VALUES ('1161965644164075522','enterpriseChange','企业营业执照','businessLicense',1,1,1,'1158293574504660993','此栏仅限上传1张图片，多余图片请上传至“其他”栏。','2019-08-15 19:39:32','1','2019-12-20 16:01:33','58','jjrcw/fileTypeTemplate/201908/1165452849991544834.jpg'),('1177047550859280385','enterpriseChange','其他','other1',2,1,2,'1158293574504660993','','2019-09-26 10:29:39','1',NULL,NULL,NULL);
/*!40000 ALTER TABLE `un_currency_filetype` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_education_school`
--

DROP TABLE IF EXISTS `un_education_school`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_education_school` (
  `id` varchar(50) NOT NULL DEFAULT '' COMMENT '主键',
  `personId` varchar(40) DEFAULT NULL,
  `talentId` varchar(40) DEFAULT NULL,
  `year` smallint(4) DEFAULT NULL COMMENT '申报年度',
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `enterpriseName` varchar(100) DEFAULT NULL,
  `enterpriseAddress` varchar(100) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `project` varchar(10) DEFAULT NULL COMMENT '申报项目',
  `pName` varchar(50) DEFAULT NULL COMMENT '父母姓名',
  `pSex` tinyint(1) DEFAULT NULL COMMENT '父母性别',
  `pIdcard` varchar(30) DEFAULT NULL COMMENT '父母证件号码',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `identifyCondition` varchar(255) DEFAULT NULL,
  `certificateNo` varchar(20) DEFAULT NULL COMMENT '证书编号',
  `nativePlace` varchar(50) DEFAULT NULL COMMENT '籍贯',
  `company` varchar(100) DEFAULT NULL COMMENT '工作单位',
  `address` varchar(200) DEFAULT NULL COMMENT '现居地址',
  `phone` varchar(22) DEFAULT NULL COMMENT '联系电话',
  `cName` varchar(50) DEFAULT NULL COMMENT '子女姓名',
  `cSex` tinyint(1) DEFAULT NULL COMMENT '子女性别',
  `cIdcard` varchar(40) DEFAULT NULL COMMENT '子女证件号码',
  `cBirthday` varchar(20) DEFAULT NULL COMMENT '子女出生日期',
  `stuNumber` varchar(255) DEFAULT NULL COMMENT '学籍号',
  `cRelation` varchar(50) DEFAULT NULL COMMENT '与申报人关系',
  `nowSchool` varchar(100) DEFAULT NULL COMMENT '现就读学校',
  `nowGrade` varchar(50) DEFAULT NULL COMMENT '现就读年级',
  `applySchool` varchar(100) DEFAULT NULL COMMENT '拟申请学校',
  `companyStreet` varchar(50) DEFAULT NULL COMMENT '工作单位所属镇街',
  `houseStreet` varchar(50) DEFAULT NULL COMMENT '房产所在镇街',
  `checkState` tinyint(3) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `score` int(2) DEFAULT NULL,
  `firstSubmitTime` varchar(50) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(50) DEFAULT NULL COMMENT '最新提交时间',
  `passTime` varchar(40) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  `qzgccrcActiveTime` varchar(50) DEFAULT NULL,
  `certificateStartTime` varchar(50) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_education_school`
--

LOCK TABLES `un_education_school` WRITE;
/*!40000 ALTER TABLE `un_education_school` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_education_school` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_enterprise`
--

DROP TABLE IF EXISTS `un_enterprise`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_enterprise` (
  `id` varchar(50) NOT NULL,
  `uid` varchar(50) DEFAULT NULL COMMENT '微信uid',
  `jUsername` varchar(255) DEFAULT NULL,
  `source` tinyint(1) DEFAULT 1,
  `type` tinyint(1) DEFAULT NULL,
  `talentType` varchar(255) DEFAULT NULL,
  `name` varchar(100) DEFAULT NULL COMMENT '单位名称',
  `idCard` varchar(40) DEFAULT NULL COMMENT '社会信用代码',
  `street` varchar(30) DEFAULT NULL COMMENT '所属街道',
  `address` varchar(100) DEFAULT NULL COMMENT '单位地址',
  `industryField` varchar(100) DEFAULT '',
  `legal` varchar(30) DEFAULT NULL COMMENT '法人代表',
  `ephone` varchar(20) DEFAULT NULL COMMENT '单位电话',
  `agentName` varchar(30) DEFAULT NULL COMMENT '经办人',
  `agentPhone` varchar(20) DEFAULT NULL COMMENT '经办人电话/登录账号',
  `username` varchar(50) DEFAULT NULL COMMENT '用户名',
  `password` varchar(50) DEFAULT NULL COMMENT '登陆密码（加密后）',
  `agentEmail` varchar(40) DEFAULT NULL COMMENT '经办人邮箱',
  `imgurl` varchar(100) DEFAULT NULL COMMENT '证件链接',
  `checkState` int(1) DEFAULT NULL COMMENT '1-未审核，2-驳回，3-审核通过',
  `checkMsg` varchar(225) DEFAULT NULL COMMENT '审核意见',
  `checkUser` varchar(50) DEFAULT NULL COMMENT '审核人',
  `active` int(1) DEFAULT NULL COMMENT '1-有效，2-拉黑，默认为1',
  `activeMsg` varchar(100) DEFAULT NULL COMMENT '拉黑/冻结原因',
  `headPortrait` varchar(100) DEFAULT NULL COMMENT '用户头像',
  `description` varchar(100) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='企业用户信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_enterprise`
--

LOCK TABLES `un_enterprise` WRITE;
/*!40000 ALTER TABLE `un_enterprise` DISABLE KEYS */;
INSERT INTO `un_enterprise` VALUES ('',NULL,NULL,1,NULL,NULL,NULL,NULL,NULL,NULL,'',NULL,NULL,'testAgent',NULL,'enterprise','21232f297a57a5a743894a0e4a801fc3',NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL,NULL),('1560676248278011905',NULL,NULL,1,1,'myqy','agenttest','sjkdjfkjdkjfkdf','00002','123123123','03','123123123','13333333','sdfsdf','13860786698','enterprise1','ffc27fa80f6e9683c8c32df72f83dc81','sugangqiang@foxmail.com','jjrcw/idCard/202208/1560676239709048833.jpg',3,'机构账号注册审核通过。123','刘建锋',1,NULL,NULL,NULL,NULL,'2022-08-20 01:13:08','1','2022-08-20 01:23:49');
/*!40000 ALTER TABLE `un_enterprise` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_enterprisechange_record`
--

DROP TABLE IF EXISTS `un_enterprisechange_record`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_enterprisechange_record` (
  `id` varchar(50) NOT NULL,
  `mainId` varchar(50) DEFAULT NULL COMMENT '单位id',
  `type` int(1) DEFAULT NULL,
  `oldName` varchar(100) DEFAULT NULL COMMENT '旧单位名',
  `oldIdCard` varchar(40) DEFAULT NULL COMMENT '旧社会信用代码',
  `oldIndustryField` varchar(100) DEFAULT NULL,
  `oldStreet` varchar(30) DEFAULT NULL COMMENT '旧所属街道',
  `oldAddress` varchar(100) DEFAULT NULL COMMENT '旧单位地址',
  `oldLegal` varchar(30) DEFAULT NULL COMMENT '旧法人代表',
  `oldEphone` varchar(20) DEFAULT NULL COMMENT '旧单位电话',
  `oldAgentName` varchar(30) DEFAULT NULL COMMENT '旧经办人',
  `oldAgentEmail` varchar(40) DEFAULT NULL COMMENT '旧电子邮箱',
  `oldAgentPhone` varchar(20) DEFAULT NULL COMMENT '旧经办人电话',
  `oldTalentType` varchar(50) DEFAULT NULL,
  `newName` varchar(100) DEFAULT NULL COMMENT '新单位名',
  `newIdCard` varchar(40) DEFAULT NULL COMMENT '新社会信用代码',
  `newIndustryField` varchar(100) DEFAULT NULL,
  `newStreet` varchar(30) DEFAULT NULL COMMENT '新所属街道',
  `newAddress` varchar(100) DEFAULT NULL COMMENT '新单位地址',
  `newLegal` varchar(30) DEFAULT NULL COMMENT '新法人代表',
  `newEphone` varchar(20) DEFAULT NULL COMMENT '新单位电话',
  `newAgentName` varchar(30) DEFAULT NULL COMMENT '新经办人',
  `newAgentEmail` varchar(40) DEFAULT NULL COMMENT '新电子邮箱',
  `newAgentPhone` varchar(20) DEFAULT NULL COMMENT '新经办人电话',
  `newTalentType` varchar(50) DEFAULT NULL,
  `checkState` int(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `description` varchar(100) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='企业用户信息变更表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_enterprisechange_record`
--

LOCK TABLES `un_enterprisechange_record` WRITE;
/*!40000 ALTER TABLE `un_enterprisechange_record` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_enterprisechange_record` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_enterprisechange_record_file`
--

DROP TABLE IF EXISTS `un_enterprisechange_record_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_enterprisechange_record_file` (
  `id` varchar(50) NOT NULL,
  `rId` varchar(50) DEFAULT NULL COMMENT '单位变更记录id',
  `typeId` varchar(50) DEFAULT NULL COMMENT '附件类型id',
  `origName` varchar(100) DEFAULT NULL COMMENT '附件原名',
  `url` varchar(100) DEFAULT NULL COMMENT '附件新名',
  `description` varchar(100) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='企业用户信息变更附件表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_enterprisechange_record_file`
--

LOCK TABLES `un_enterprisechange_record_file` WRITE;
/*!40000 ALTER TABLE `un_enterprisechange_record_file` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_enterprisechange_record_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_house_money_dict`
--

DROP TABLE IF EXISTS `un_house_money_dict`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_house_money_dict` (
  `id` varchar(40) NOT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '类型  1-个人，2-房产，3-其他政策',
  `code` varchar(50) DEFAULT NULL COMMENT '编号',
  `total` decimal(10,2) DEFAULT NULL COMMENT '总额',
  `balance` decimal(10,2) DEFAULT NULL COMMENT '余额',
  `count` tinyint(1) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `createUser` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_house_money_dict`
--

LOCK TABLES `un_house_money_dict` WRITE;
/*!40000 ALTER TABLE `un_house_money_dict` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_house_money_dict` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_house_renting`
--

DROP TABLE IF EXISTS `un_house_renting`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_house_renting` (
  `id` varchar(40) NOT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `talentId` varchar(40) DEFAULT NULL,
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `cardType` varchar(10) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `nativePlace` varchar(50) DEFAULT NULL COMMENT '籍贯',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '入职时间',
  `post` varchar(100) DEFAULT NULL COMMENT '岗位/职务',
  `enterpriseAddress` varchar(100) DEFAULT NULL COMMENT '工作单位地址',
  `address` varchar(100) DEFAULT NULL COMMENT '现居地址',
  `phone` varchar(20) DEFAULT NULL COMMENT '联系电话',
  `email` varchar(100) DEFAULT NULL COMMENT '电子邮箱',
  `marryStatus` varchar(10) DEFAULT NULL COMMENT '婚姻状态',
  `spouseName` varchar(50) DEFAULT NULL COMMENT '配偶姓名',
  `spouseSex` tinyint(1) DEFAULT NULL COMMENT '配偶性别',
  `spouseCardType` varchar(10) DEFAULT NULL COMMENT '配偶证件类型',
  `spouseIdCard` varchar(40) DEFAULT NULL COMMENT '配偶证件号码',
  `spouseTalentArrange` tinyint(1) DEFAULT NULL COMMENT '配偶人才层次',
  `spouseNativePlace` varchar(60) DEFAULT NULL COMMENT '配偶籍贯',
  `spouseEntryTime` varchar(40) DEFAULT NULL COMMENT '配偶入职时间',
  `spousePost` varchar(100) DEFAULT NULL COMMENT '配偶岗位/职务',
  `spouseEnterpriseName` varchar(100) DEFAULT NULL COMMENT '配偶工作单位',
  `spouseEnterpriseAddress` varchar(100) DEFAULT NULL COMMENT '配偶工作单位地址',
  `spouseAddress` varchar(100) DEFAULT NULL COMMENT '配偶现居地址',
  `spousePhone` varchar(20) DEFAULT NULL COMMENT '配偶联系电话',
  `spouseEmail` varchar(100) DEFAULT NULL COMMENT '配偶电子邮箱',
  `houseType` tinyint(1) DEFAULT NULL COMMENT '拟申请租住人才社区',
  `pensionDetail` varchar(100) DEFAULT NULL COMMENT '养老保险缴纳月份',
  `unemploymentDetail` varchar(100) DEFAULT NULL COMMENT '失业保险缴纳月份',
  `medicaDetail` varchar(100) DEFAULT NULL COMMENT '医疗保险缴纳月份',
  `taxDetail` varchar(100) DEFAULT NULL COMMENT '个税缴纳月份',
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `mzjCheckMsg` varchar(255) DEFAULT NULL COMMENT '民政局审核意见',
  `zrzyjCheckMsg` varchar(255) DEFAULT NULL COMMENT '自然资源局审核意见',
  `zjjCheckMsg` varchar(255) DEFAULT NULL COMMENT '住建局审核意见',
  `rentStartTime` varchar(40) DEFAULT NULL COMMENT '承租开始日期',
  `rentEndTime` varchar(40) DEFAULT NULL COMMENT '承租截止时间',
  `rentAddress` varchar(255) DEFAULT NULL COMMENT '承租详细地址',
  `rentMoney` decimal(10,2) DEFAULT NULL,
  `files` varchar(500) DEFAULT NULL COMMENT '驳回附件类型',
  `fields` varchar(500) DEFAULT NULL COMMENT '驳回字段',
  `firstSubmitTime` varchar(50) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(50) DEFAULT NULL COMMENT '最新提交时间',
  `firstPassTime` varchar(40) DEFAULT NULL,
  `depPassTime` varchar(40) DEFAULT NULL,
  `reviewPassTime` varchar(40) DEFAULT NULL,
  `publicState` tinyint(1) DEFAULT NULL COMMENT '公示状态',
  `highProcess` tinyint(1) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_house_renting`
--

LOCK TABLES `un_house_renting` WRITE;
/*!40000 ALTER TABLE `un_house_renting` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_house_renting` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_house_renting_fees`
--

DROP TABLE IF EXISTS `un_house_renting_fees`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_house_renting_fees` (
  `id` varchar(40) NOT NULL,
  `type` tinyint(1) DEFAULT NULL,
  `baseId` varchar(40) DEFAULT NULL COMMENT '租房申请id',
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `phone` varchar(40) DEFAULT NULL COMMENT '联系电话',
  `email` varchar(50) DEFAULT NULL,
  `bankAddress` varchar(100) DEFAULT NULL COMMENT '开户银行网点',
  `bankAccount` varchar(50) DEFAULT NULL COMMENT '银行账号',
  `money` decimal(10,2) DEFAULT NULL,
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `firstSubmitTime` varchar(50) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(50) DEFAULT NULL,
  `publicState` tinyint(1) DEFAULT NULL COMMENT '公示状态',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_house_renting_fees`
--

LOCK TABLES `un_house_renting_fees` WRITE;
/*!40000 ALTER TABLE `un_house_renting_fees` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_house_renting_fees` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_house_renting_purchase_fees`
--

DROP TABLE IF EXISTS `un_house_renting_purchase_fees`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_house_renting_purchase_fees` (
  `id` varchar(40) NOT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `talentId` varchar(40) DEFAULT NULL,
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `cardType` varchar(10) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `nativePlace` varchar(50) DEFAULT NULL COMMENT '籍贯',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '入职时间',
  `post` varchar(100) DEFAULT NULL COMMENT '岗位/职务',
  `enterpriseAddress` varchar(100) DEFAULT NULL COMMENT '工作单位地址',
  `address` varchar(100) DEFAULT NULL COMMENT '现居地址',
  `phone` varchar(20) DEFAULT NULL COMMENT '联系电话',
  `email` varchar(100) DEFAULT NULL COMMENT '电子邮箱',
  `marryStatus` varchar(10) DEFAULT NULL COMMENT '婚姻状态',
  `spouseName` varchar(50) DEFAULT NULL COMMENT '配偶姓名',
  `spouseSex` tinyint(1) DEFAULT NULL COMMENT '配偶性别',
  `spouseCardType` varchar(10) DEFAULT NULL COMMENT '配偶证件类型',
  `spouseIdCard` varchar(40) DEFAULT NULL COMMENT '配偶证件号码',
  `spouseTalentArrange` tinyint(1) DEFAULT NULL COMMENT '配偶人才层次',
  `spouseNativePlace` varchar(60) DEFAULT NULL COMMENT '配偶籍贯',
  `spouseEntryTime` varchar(40) DEFAULT NULL COMMENT '配偶入职时间',
  `spousePost` varchar(100) DEFAULT NULL COMMENT '配偶岗位/职务',
  `spouseEnterpriseName` varchar(100) DEFAULT NULL COMMENT '配偶工作单位',
  `spouseEnterpriseAddress` varchar(100) DEFAULT NULL COMMENT '配偶工作单位地址',
  `spouseAddress` varchar(100) DEFAULT NULL COMMENT '配偶现居地址',
  `spousePhone` varchar(20) DEFAULT NULL COMMENT '配偶联系电话',
  `spouseEmail` varchar(100) DEFAULT NULL COMMENT '配偶电子邮箱',
  `houseType` tinyint(1) DEFAULT NULL COMMENT '房产所属人才社区',
  `houseAddress` varchar(200) DEFAULT NULL COMMENT '房产详细地址',
  `houseMoney` decimal(10,2) DEFAULT NULL COMMENT '房产成交金额',
  `bankAddress` varchar(255) DEFAULT NULL COMMENT '开户银行网点',
  `bankAccount` varchar(50) DEFAULT NULL COMMENT '银行账号',
  `money` decimal(10,2) DEFAULT NULL COMMENT '兑现金额',
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `files` varchar(500) DEFAULT NULL COMMENT '驳回附件类型',
  `fields` varchar(500) DEFAULT NULL COMMENT '驳回字段',
  `firstSubmitTime` varchar(50) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(50) DEFAULT NULL COMMENT '最新提交时间',
  `passTime` varchar(40) DEFAULT NULL,
  `publicState` tinyint(1) DEFAULT NULL COMMENT '公示状态',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_house_renting_purchase_fees`
--

LOCK TABLES `un_house_renting_purchase_fees` WRITE;
/*!40000 ALTER TABLE `un_house_renting_purchase_fees` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_house_renting_purchase_fees` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase`
--

DROP TABLE IF EXISTS `un_housepurchase`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase` (
  `id` varchar(40) NOT NULL COMMENT '主键',
  `talentId` varchar(40) DEFAULT NULL,
  `enterpriseId` varchar(40) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `declareType` tinyint(1) DEFAULT NULL,
  `declareObject` tinyint(2) DEFAULT NULL COMMENT '申报对象',
  `year` smallint(4) DEFAULT NULL COMMENT '申报年度',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `cardType` varchar(10) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(30) DEFAULT NULL COMMENT '证件号码',
  `provinceCode` varchar(10) DEFAULT NULL,
  `provinceName` varchar(50) DEFAULT NULL,
  `cityCode` varchar(10) DEFAULT NULL,
  `cityName` varchar(50) DEFAULT NULL,
  `countyCode` varchar(10) DEFAULT NULL,
  `countyName` varchar(100) DEFAULT NULL,
  `street` varchar(20) DEFAULT NULL,
  `talentType` varchar(15) DEFAULT NULL COMMENT '人才标签',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `certificateStartTime` varchar(40) DEFAULT NULL COMMENT '证书开始时间',
  `certificateEndTime` varchar(40) DEFAULT NULL,
  `identifyCondition` varchar(50) DEFAULT NULL COMMENT '认定条件',
  `idenfityConditionName` varchar(500) DEFAULT NULL COMMENT '认定条件名称',
  `identifyGetTime` varchar(40) DEFAULT NULL COMMENT '认定条件获得时间',
  `phone` varchar(22) DEFAULT NULL COMMENT '联系电话',
  `marryStatus` varchar(10) DEFAULT NULL COMMENT '婚姻状态',
  `spouseIsLibrary` tinyint(1) DEFAULT NULL COMMENT '是否在库',
  `spouseName` varchar(50) DEFAULT NULL COMMENT '配偶姓名',
  `spouseCardType` varchar(10) DEFAULT NULL COMMENT '配偶证件类型',
  `spouseIdcard` varchar(20) DEFAULT NULL COMMENT '配偶证件号码',
  `childName` varchar(50) DEFAULT NULL COMMENT '子女姓名',
  `childCardType` varchar(10) DEFAULT NULL COMMENT '子女证件类型',
  `childIdCard` varchar(30) DEFAULT NULL COMMENT '子女证件号码',
  `number` tinyint(1) DEFAULT NULL COMMENT '享受第几次购房补贴',
  `houseAddress` varchar(100) DEFAULT NULL COMMENT '房屋坐落地址',
  `houseArea` double(5,2) DEFAULT NULL COMMENT '房源购置面积',
  `houseCode` varchar(50) DEFAULT NULL,
  `recordTime` varchar(40) DEFAULT NULL COMMENT '商品房购房合同备案时间',
  `houseMoney` double(10,2) DEFAULT NULL COMMENT '房屋成交金额',
  `realEstateNo` varchar(50) DEFAULT NULL COMMENT '不动产权编号',
  `recordNo` varchar(50) DEFAULT NULL COMMENT '备案合同编号',
  `isEnjoyOther` tinyint(1) DEFAULT NULL COMMENT '是否享受我市其他政策',
  `bank` varchar(40) DEFAULT NULL COMMENT '开户银行',
  `bankNumber` varchar(20) DEFAULT NULL,
  `bankNetwork` varchar(100) DEFAULT NULL COMMENT '开户银行网点',
  `bankAccount` varchar(30) DEFAULT NULL COMMENT '开户银行账号',
  `sbPayDetail` varchar(50) DEFAULT NULL COMMENT '社保缴纳情况',
  `taxPayDetail` varchar(50) DEFAULT NULL COMMENT '个人所得税缴纳情况',
  `letterDetail` varchar(50) DEFAULT NULL COMMENT '工资情况',
  `attendDetail` varchar(50) DEFAULT NULL COMMENT '考勤情况',
  `allowanceType` tinyint(1) DEFAULT NULL,
  `mzjCheckDetail` varchar(300) DEFAULT NULL COMMENT '民政局核查结果',
  `checkIsTradeRecord` tinyint(1) DEFAULT NULL COMMENT '是否交易备案',
  `checkRecordTime` varchar(40) DEFAULT NULL COMMENT '交易备案时间',
  `zjjCheckDetail` varchar(300) DEFAULT NULL COMMENT '住建局备注',
  `isHasBdcCard` tinyint(1) DEFAULT NULL COMMENT '是否已办理不动产权证',
  `bdcRegistTime` varchar(40) DEFAULT NULL COMMENT '不动产权证登记时间',
  `isOwner` tinyint(1) DEFAULT NULL COMMENT '其购置的房屋是否还在其名下',
  `transferMethod` varchar(100) DEFAULT NULL COMMENT '过户方式',
  `transferTime` varchar(40) DEFAULT NULL COMMENT '申请人将此房屋过户时间',
  `zrzzjCheckDetail` varchar(300) DEFAULT NULL COMMENT '自然资源局备注',
  `totalMoney` decimal(10,2) DEFAULT NULL,
  `balanceMoney` decimal(10,2) DEFAULT NULL COMMENT '享受其他政策总金额',
  `lastOtherMoney` decimal(10,2) DEFAULT NULL,
  `nowOtherMoney` decimal(10,2) DEFAULT NULL,
  `talentArrangeMoney` decimal(10,2) DEFAULT NULL,
  `houseBalanceMoney` decimal(10,2) DEFAULT NULL,
  `nowSubOtherMoney` decimal(10,2) DEFAULT NULL,
  `nowNotSubOtherMoney` decimal(10,2) DEFAULT NULL,
  `shouldEnjoyMoney` decimal(10,2) DEFAULT NULL COMMENT '应享受金额',
  `realEnjoyMoney` decimal(10,2) DEFAULT NULL COMMENT '实际享受金额',
  `decideDetail` varchar(1000) DEFAULT NULL,
  `decideMoneyDetail` varchar(1000) DEFAULT NULL,
  `talentArrangeMonths` varchar(255) DEFAULT NULL,
  `monthCount` tinyint(2) DEFAULT NULL,
  `firstSubmitTime` varchar(40) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(40) DEFAULT NULL COMMENT '最新提交时间',
  `firstPassTime` varchar(40) DEFAULT NULL,
  `depPassTime` varchar(40) DEFAULT NULL,
  `reviewPassTime` varchar(40) DEFAULT NULL,
  `isConflict` tinyint(1) DEFAULT NULL,
  `isRecover` tinyint(1) DEFAULT NULL,
  `zxMsg` varchar(255) DEFAULT NULL,
  `checkState` smallint(4) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(300) DEFAULT NULL COMMENT '审核意见',
  `publicState` tinyint(1) DEFAULT 1,
  `cashType` tinyint(1) DEFAULT NULL,
  `cashIdCards` varchar(100) DEFAULT NULL,
  `fields` varchar(500) DEFAULT NULL COMMENT '驳回字段',
  `files` varchar(500) DEFAULT NULL COMMENT '驳回附件',
  `toProcess` tinyint(1) DEFAULT NULL,
  `toDep` varchar(200) DEFAULT NULL,
  `highProcess` tinyint(1) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE,
  UNIQUE KEY `index-pry` (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase`
--

LOCK TABLES `un_housepurchase` WRITE;
/*!40000 ALTER TABLE `un_housepurchase` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase_children`
--

DROP TABLE IF EXISTS `un_housepurchase_children`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase_children` (
  `id` varchar(40) NOT NULL COMMENT 'id',
  `pId` varchar(40) DEFAULT NULL COMMENT '父id',
  `name` varchar(100) DEFAULT NULL COMMENT '子女姓名',
  `cardType` varchar(20) DEFAULT NULL COMMENT '子女证件类型',
  `idCard` varchar(255) DEFAULT NULL COMMENT '子女证件号码',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase_children`
--

LOCK TABLES `un_housepurchase_children` WRITE;
/*!40000 ALTER TABLE `un_housepurchase_children` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase_children` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase_enjoy_history`
--

DROP TABLE IF EXISTS `un_housepurchase_enjoy_history`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase_enjoy_history` (
  `id` varchar(40) NOT NULL COMMENT '主键',
  `pId` varchar(40) DEFAULT NULL COMMENT '父id',
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `year` int(4) DEFAULT NULL COMMENT '申报年度',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `money` double(10,5) DEFAULT NULL COMMENT '享受金额',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase_enjoy_history`
--

LOCK TABLES `un_housepurchase_enjoy_history` WRITE;
/*!40000 ALTER TABLE `un_housepurchase_enjoy_history` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase_enjoy_history` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase_enjoy_other`
--

DROP TABLE IF EXISTS `un_housepurchase_enjoy_other`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase_enjoy_other` (
  `id` varchar(40) NOT NULL COMMENT '主键',
  `pId` varchar(40) DEFAULT NULL COMMENT '父id',
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `name` varchar(100) DEFAULT NULL COMMENT '政策名称',
  `idCard` varchar(40) DEFAULT NULL,
  `houseAddress` varchar(255) DEFAULT NULL,
  `recordNo` varchar(100) DEFAULT NULL,
  `enjoyPolicyName` varchar(255) DEFAULT NULL,
  `enjoyTime` varchar(40) DEFAULT NULL COMMENT '享受时间',
  `money` double(10,5) DEFAULT NULL COMMENT '享受金额',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase_enjoy_other`
--

LOCK TABLES `un_housepurchase_enjoy_other` WRITE;
/*!40000 ALTER TABLE `un_housepurchase_enjoy_other` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase_enjoy_other` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase_house_info`
--

DROP TABLE IF EXISTS `un_housepurchase_house_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase_house_info` (
  `id` varchar(255) NOT NULL,
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `spouseIdCard` varchar(40) DEFAULT NULL COMMENT '配偶证件号码',
  `houseAddress` varchar(255) DEFAULT NULL COMMENT '房屋坐落地址',
  `houseArea` decimal(10,2) DEFAULT NULL COMMENT '房屋建筑面积',
  `houseMoney` decimal(10,2) DEFAULT NULL COMMENT '房屋成交金额',
  `recordTime` varchar(40) DEFAULT NULL COMMENT '商品房购房合同备案时间',
  `realEstateNo` varchar(40) DEFAULT NULL COMMENT '不动产权证书编号',
  `recordNo` varchar(40) DEFAULT NULL COMMENT '备案合同编号',
  `balanceMoney` decimal(10,2) DEFAULT NULL,
  `count` tinyint(1) DEFAULT NULL COMMENT '享受次数',
  `lastYearArrears` decimal(10,2) DEFAULT NULL COMMENT '上一年度未扣除金额',
  `createTime` varchar(40) DEFAULT NULL,
  `createUser` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase_house_info`
--

LOCK TABLES `un_housepurchase_house_info` WRITE;
/*!40000 ALTER TABLE `un_housepurchase_house_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase_house_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase_other_house`
--

DROP TABLE IF EXISTS `un_housepurchase_other_house`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase_other_house` (
  `id` varchar(40) NOT NULL COMMENT 'id',
  `pId` varchar(40) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '信息类型',
  `talentId` varchar(40) DEFAULT NULL,
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `name` varchar(40) DEFAULT NULL COMMENT '购房人姓名',
  `houseAddress` varchar(255) DEFAULT NULL COMMENT '房屋坐落地址',
  `number` varchar(100) DEFAULT NULL COMMENT '合同编号/不动产权号',
  `area` double DEFAULT NULL COMMENT '面积',
  `recordTime` varchar(40) DEFAULT NULL COMMENT '交易备案时间/房屋登记时间',
  `tradeMethod` varchar(100) DEFAULT NULL COMMENT '交易方式',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase_other_house`
--

LOCK TABLES `un_housepurchase_other_house` WRITE;
/*!40000 ALTER TABLE `un_housepurchase_other_house` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase_other_house` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase_resettlement_allowance`
--

DROP TABLE IF EXISTS `un_housepurchase_resettlement_allowance`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase_resettlement_allowance` (
  `id` varchar(40) NOT NULL,
  `mainId` varchar(40) DEFAULT NULL,
  `type` varchar(255) DEFAULT NULL COMMENT '一次性安家补助类型',
  `amount` decimal(10,2) DEFAULT NULL COMMENT '补助金额',
  `payTime` varchar(40) DEFAULT NULL COMMENT '发放时间',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间'
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='一次性安家补助';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase_resettlement_allowance`
--

LOCK TABLES `un_housepurchase_resettlement_allowance` WRITE;
/*!40000 ALTER TABLE `un_housepurchase_resettlement_allowance` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase_resettlement_allowance` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_housepurchase_spouse`
--

DROP TABLE IF EXISTS `un_housepurchase_spouse`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_housepurchase_spouse` (
  `id` varchar(40) NOT NULL,
  `pId` varchar(40) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '登记类型',
  `registerTime` varchar(40) DEFAULT NULL COMMENT '登记时间',
  `name` varchar(100) DEFAULT NULL COMMENT '姓名',
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `description` varchar(1000) DEFAULT NULL,
  `createTime` varchar(50) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_housepurchase_spouse`
--

LOCK TABLES `un_housepurchase_spouse` WRITE;
/*!40000 ALTER TABLE `un_housepurchase_spouse` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_housepurchase_spouse` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_houser_renting_purchase_apply`
--

DROP TABLE IF EXISTS `un_houser_renting_purchase_apply`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_houser_renting_purchase_apply` (
  `id` varchar(40) NOT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `talentId` varchar(40) DEFAULT NULL,
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `cardType` varchar(10) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `nativePlace` varchar(50) DEFAULT NULL COMMENT '籍贯',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '入职时间',
  `post` varchar(100) DEFAULT NULL COMMENT '岗位/职务',
  `enterpriseAddress` varchar(100) DEFAULT NULL COMMENT '工作单位地址',
  `address` varchar(100) DEFAULT NULL COMMENT '现居地址',
  `phone` varchar(20) DEFAULT NULL COMMENT '联系电话',
  `email` varchar(100) DEFAULT NULL COMMENT '电子邮箱',
  `marryStatus` varchar(10) DEFAULT NULL COMMENT '婚姻状态',
  `spouseName` varchar(50) DEFAULT NULL COMMENT '配偶姓名',
  `spouseSex` tinyint(1) DEFAULT NULL COMMENT '配偶性别',
  `spouseCardType` varchar(10) DEFAULT NULL COMMENT '配偶证件类型',
  `spouseIdCard` varchar(40) DEFAULT NULL COMMENT '配偶证件号码',
  `spouseTalentArrange` tinyint(1) DEFAULT NULL COMMENT '配偶人才层次',
  `spouseNativePlace` varchar(60) DEFAULT NULL COMMENT '配偶籍贯',
  `spouseEntryTime` varchar(40) DEFAULT NULL COMMENT '配偶入职时间',
  `spousePost` varchar(100) DEFAULT NULL COMMENT '配偶岗位/职务',
  `spouseEnterpriseName` varchar(100) DEFAULT NULL COMMENT '配偶工作单位',
  `spouseEnterpriseAddress` varchar(100) DEFAULT NULL COMMENT '配偶工作单位地址',
  `spouseAddress` varchar(100) DEFAULT NULL COMMENT '配偶现居地址',
  `spousePhone` varchar(20) DEFAULT NULL COMMENT '配偶联系电话',
  `spouseEmail` varchar(100) DEFAULT NULL COMMENT '配偶电子邮箱',
  `houseType` tinyint(1) DEFAULT NULL COMMENT '拟申请租住人才社区',
  `pensionDetail` varchar(100) DEFAULT NULL COMMENT '养老保险缴纳月份',
  `unemploymentDetail` varchar(100) DEFAULT NULL COMMENT '失业保险缴纳月份',
  `medicaDetail` varchar(100) DEFAULT NULL COMMENT '医疗保险缴纳月份',
  `taxDetail` varchar(100) DEFAULT NULL COMMENT '个税缴纳月份',
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `mzjCheckMsg` varchar(1000) DEFAULT NULL COMMENT '民政局审核意见',
  `zrzyjCheckMsg` varchar(1000) DEFAULT NULL COMMENT '自然资源局审核意见',
  `zjjCheckMsg` varchar(1000) DEFAULT NULL COMMENT '住建局审核意见',
  `applyAddress` varchar(200) DEFAULT NULL COMMENT '承租开始日期',
  `files` varchar(500) DEFAULT NULL COMMENT '驳回附件类型',
  `fields` varchar(500) DEFAULT NULL COMMENT '驳回字段',
  `firstSubmitTime` varchar(50) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(50) DEFAULT NULL COMMENT '最新提交时间',
  `firstPassTime` varchar(40) DEFAULT NULL,
  `depPassTime` varchar(40) DEFAULT NULL,
  `reviewPassTime` varchar(40) DEFAULT NULL,
  `publicState` tinyint(1) DEFAULT NULL COMMENT '公示状态',
  `highProcess` tinyint(1) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_houser_renting_purchase_apply`
--

LOCK TABLES `un_houser_renting_purchase_apply` WRITE;
/*!40000 ALTER TABLE `un_houser_renting_purchase_apply` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_houser_renting_purchase_apply` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_identify_condition`
--

DROP TABLE IF EXISTS `un_identify_condition`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_identify_condition` (
  `id` varchar(30) NOT NULL COMMENT '主键',
  `source` tinyint(1) DEFAULT NULL,
  `talentLevel` varchar(30) NOT NULL COMMENT '人才层次',
  `talentTypes` varchar(255) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '人才类别',
  `name` varchar(255) DEFAULT NULL COMMENT '名称',
  `activeYear` tinyint(2) DEFAULT NULL COMMENT '有效期',
  `notWorkYear` tinyint(1) DEFAULT NULL COMMENT '忽略常年工作判定条件',
  `active` tinyint(1) DEFAULT 1 COMMENT '是否启用',
  `companyIds` varchar(255) DEFAULT NULL COMMENT '审核单位id',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='人才认定条件表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_identify_condition`
--

LOCK TABLES `un_identify_condition` WRITE;
/*!40000 ALTER TABLE `un_identify_condition` DISABLE KEYS */;
INSERT INTO `un_identify_condition` VALUES ('1196306160564707329',1,'1',NULL,1,'国际顶级知名奖项获得者：诺贝尔奖；中国国家最高科学技术奖；美国国家科学奖章(总统科学奖)；美国国家技术创新奖章；法国全国科研中心科研奖章；英国皇家金质奖章；科普利奖章；图灵奖；菲尔兹奖；沃尔夫奖；阿贝尔奖；拉斯克奖；克拉福德奖；日本国际奖；京都奖；邵逸夫奖',0,2,1,'','',NULL,NULL,'2020-05-09 14:01:51','1'),('1196306160564707330',1,'1',NULL,1,'中国科学院院士、中国工程院院士',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707331',1,'1',NULL,1,'中国社会科学院学部委员、荣誉学部委员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707332',1,'1',NULL,1,'国家“千人计划”创新人才长期项目的入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707333',1,'1',NULL,1,'国家“千人计划”创业人才项目的入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707334',1,'1',NULL,1,'国家“千人计划”外国专家项目的入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707335',1,'1',NULL,1,'国家“千人计划”顶尖人才与创新团队项目的入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707336',1,'1',NULL,1,'国家“万人计划”杰出人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707337',1,'1',NULL,1,'近10年，国家自然科学奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707338',1,'1',NULL,1,'近10年，国家技术发明奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707339',1,'1',NULL,1,'近10年，国家科技进步奖特等奖前5位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707340',1,'1',NULL,1,'近10年，国家科技进步奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707341',1,'1',NULL,1,'近10年，省科学技术奖重大贡献奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707342',1,'1',NULL,1,'近10年，长江学者成就奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707343',1,'1',NULL,1,'近10年，孙冶方经济科学奖著作奖、论文奖前2位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707344',1,'1',NULL,1,'近10年，担任过世界500强工业和信息化企业及中国50强工业和信息化企业总部董事长（或总裁）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707345',1,'1',NULL,1,'近10年，担任过世界500强非工业和信息化企业及中国50强非工业和信息化企业总部董事长（或总裁）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707346',1,'1',NULL,1,'近10年，担任过世界500强工业和信息化企业及中国50强工业和信息化企业首席执行官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707347',1,'1',NULL,1,'近10年，担任过世界500强非工业和信息化企业及中国50强非工业和信息化企业首席执行官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707348',1,'1',NULL,1,'近10年，担任过世界500强企业及中国50强企业首席技术官（技术研发部门第一负责人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160564707349',1,'1',NULL,1,'近10年，担任过世界500强工业和信息化企业及中国50强工业和信息化企业首席设计官（工艺设计部门第一负责人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593410',1,'1',NULL,1,'近10年，担任过世界500强非工业和信息化企业及中国50强非工业和信息化企业首席设计官（工艺设计部门第一负责人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593411',1,'1',NULL,1,'近10年，担任过世界500强企业及中国50强工业和信息化企业首席质量官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593412',1,'1',NULL,1,'近10年，担任三大世界大学排名最新同时排前500名大学的校长',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593413',1,'1',NULL,1,'近10年，担任国家科技重大专项专家组组长，且项目（课题）通过验收',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593414',1,'1',NULL,1,'近10年，担任国家科技支撑（攻关）计划项目负责人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593415',1,'1',NULL,1,'近10年，担任国家重点研发计划重点专项项目组负责人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593416',1,'1',NULL,1,'近10年，担任国家“973计划”项目首席科学家',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593417',1,'1',NULL,1,'近10年，担任国家“863计划”领域主题专家组组长',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593418',1,'1',NULL,1,'近10年，担任国家级人工智能或机器人领域大赛专家组组长',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306160648593419',1,'1',NULL,1,'近10年，担任国家重点学科首席专家，年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439873',1,'1',NULL,1,'近10年，担任重点实验室首席专家，年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439874',1,'1',NULL,1,'近10年，担任国家级企业技术中心首席专家，年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439875',1,'1',NULL,1,'近10年，担任工程技术研究中心首席专家，年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439876',1,'1',NULL,1,'近10年，担任国家制造业创新中心主任，年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439877',1,'1',NULL,1,'近5年，培养输出获得奥运会或近两届列入奥运会项目的世界杯、世锦赛冠军的主教练员',5,1,1,'','5',NULL,NULL,'2020-02-27 09:37:06','87'),('1196306166063439878',1,'1',NULL,1,'港澳台人才：台湾“中央研究院”院士',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439879',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强工业和信息化企业及台湾最新权威排名百大企业总部董事长（或总裁）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439880',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强非工业和信息化企业及台湾最新权威排名百大企业总部董事长（或总裁）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439881',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强工业和信息化企业及台湾最新权威排名百大企业首席执行官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439882',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强非工业和信息化企业及台湾最新权威排名百大企业首席执行官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439883',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强企业及台湾最新权威排名百大企业首席技术官（技术研发部门第一负责人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439884',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强工业和信息化企业及台湾最新权威排名百大企业首席设计官（工艺设计部门第一负责人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439885',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强非工业和信息化企业及台湾最新权威排名百大企业首席设计官（工艺设计部门第一负责人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439886',1,'1',NULL,1,'港澳台人才：近10年，担任世界500强工业和信息化企业及台湾最新权威排名百大企业首席质量官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439887',1,'1',NULL,1,'外籍人才：美国、英国、德国、法国、日本、意大利、加拿大、瑞典、丹麦、挪威、芬兰、比利时、瑞士、奥地利、荷兰、西班牙、澳大利亚、新西兰、俄罗斯、以色列、印度、乌克兰、新加坡、韩国的最高学术权威机构会员（一般翻译为“院士”，具体的机构名称以中国科学院国际合作局网站为准）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439888',1,'1',NULL,1,'外籍人才：德雷珀奖（Charles Stark Draper Prize）获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439889',1,'1',NULL,1,'外籍人才：拉斯奖（Fritz J. and Dolores H. Russ Prize）获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439890',1,'1',NULL,1,'外籍人才：戈登奖（Bernard M. Gordon Prize）获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439891',1,'1',NULL,1,'外籍人才：中国政府“友谊奖”等面向外国专家的国家级对外表彰奖项获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439892',1,'1',NULL,1,'外籍人才：“国际科技合作奖”等面向外国专家的国家级对外表彰奖项获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439893',1,'1',NULL,1,'外籍人才：近10年，担任国际著名金融机构首席执行官或首席专家',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439894',1,'1',NULL,1,'外籍人才：近10年，担任国际著名会计师事务所首席执行官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439895',1,'1',NULL,1,'外籍人才：近10年，担任国际著名律师事务所首席执行官',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439896',1,'1',NULL,1,'外籍人才：近10年，担任国际著名学术组织主席',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439897',1,'1',NULL,1,'外籍人才：近10年，担任八国集团成员国（美国、英国、德国、法国、日本、意大利、加拿大、俄罗斯）国家级重大科技计划项目负责人或首席科学家',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439898',1,'1',NULL,1,'外籍人才：近10年，担任国际著名艺术比赛评委会主席',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439899',1,'1',NULL,1,'紧缺急需集成电路人才：获国际电气和电子工程师协会奖',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439900',1,'1',NULL,1,'紧缺急需集成电路人才：国际电气和电子工程师协会会士、国际工程技术学会会士、国际计算机学会会士',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439901',1,'1',NULL,1,'紧缺急需集成电路人才：在全球前25大半导体公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306166063439902',1,'1',NULL,1,'紧缺急需集成电路人才：在集成电路设计、制造、封测、装备、材料等领域全球前10大公司担任副总经理、副总裁或首席科学家以上职务累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680002',1,'1',NULL,1,'紧缺急需集成电路人才：在全球前5大电子设计自动化工具软件公司担任副总经理、副总裁或首席科学家以上职务累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680003',1,'1',NULL,1,'紧缺急需装备制造人才：担任过三大世界大学排名最新同时排名前100名大学的教授且担任电气与电子工程师学会（美国）、电气工程师学会（英国）或美国计算机协会会士',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680004',1,'1',NULL,1,'紧缺急需装备制造人才：担任过装备制造相关领域世界500强企业及中国50强企业和中国装备制造业100强总部总工程师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680005',1,'1',NULL,1,'紧缺急需石油化工人才：担任过三大世界大学排名最新同时排前100名大学的教授且担任石油化工和炼制协会（美国）、油气协会（英国）等同级别学会（协会）会士',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680006',1,'1',NULL,1,'紧缺急需石油化工人才：担任过石油化工相关领域世界500强企业及中国50强企业和中国石油石化装备制造业100强总部总工程师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680007',1,'1',NULL,1,'紧缺急需光电人才：担任过三大世界大学排名最新同时排前100名大学的教授，且从事LED或光生物相关研究或教学者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680008',1,'1',NULL,1,'紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物等领域全球前10大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680009',1,'1',NULL,1,'紧缺急需半导体人才：中国机械工程学会科技成就奖、青年科技成就奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680010',1,'1',NULL,1,'紧缺急需半导体人才：中国机械工业科学技术奖特等奖前3位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680011',1,'1',NULL,1,'紧缺急需半导体人才：近10年，在《Nature》、《Science》或《Reviews of Modern Physics》杂志上以第一作者或通讯作者发表LED衬底、芯片、封装、应用或集成电路相关论文者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680012',1,'1',NULL,1,'紧缺急需半导体人才：在集成电路材料（硅片、光罩材料等）、电子设计自动化（EDA）工具软件、硅智财（SIP）全球前10大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680013',1,'1',NULL,1,'第一层次其他由企事业等用人单位根据人才对本单位贡献情况提出，与本层次其他人才标准相当的人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680014',1,'2',NULL,1,'国家“千人计划”创新人才短期项目入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680015',1,'2',NULL,1,'国家“千人计划”青年项目入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680016',1,'2',NULL,1,'国家“千人计划”新疆西藏项目入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680017',1,'2',NULL,1,'国家“千人计划”文化艺术人才项目入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680018',1,'2',NULL,1,'国家“万人计划”领军人才（包括科技创新领军人才、科技创业领军人才、哲学社会科学领军人才、教学名师和百千万工程领军人才）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680019',1,'2',NULL,1,'国家“万人计划”青年拔尖人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680020',1,'2',NULL,1,'“新世纪百千万人才工程”国家级人选',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680021',1,'2',NULL,1,'国家有突出贡献的中青年专家',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680022',1,'2',NULL,1,'全国杰出专业技术人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680023',1,'2',NULL,1,'中国工艺美术大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680024',1,'2',NULL,1,'全国工程勘察设计大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680025',1,'2',NULL,1,'大国工匠',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680026',1,'2',NULL,1,'亚太地区手工艺大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680027',1,'2',NULL,1,'茅盾文学奖',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680028',1,'2',NULL,1,'鲁迅文学奖',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680029',1,'2',NULL,1,'吴阶平医学奖',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680030',1,'2',NULL,1,'国医大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306171335680031',1,'2',NULL,1,'“长江学者奖励计划”特聘教授、讲座教授',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399233',1,'2',NULL,1,'国家杰出青年基金获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399234',1,'2',NULL,1,'中国青年科技奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399235',1,'2',NULL,1,'中国青年女科学家奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399236',1,'2',NULL,1,'全国新闻出版行业领军人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399237',1,'2',NULL,1,'中宣部“文化名家”暨“四个一批”人才工程入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399238',1,'2',NULL,1,'享受国务院政府特殊津贴人员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399239',1,'2',NULL,1,'全国优秀科技工作者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399240',1,'2',NULL,1,'国家级非物质文化遗产代表性项目代表性传承人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399241',1,'2',NULL,1,'现代农业产业技术体系首席科学家',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399242',1,'2',NULL,1,'中国农学会“神农中华农业科技奖”获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399243',1,'2',NULL,1,'光华龙腾奖中国设计贡献奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399244',1,'2',NULL,1,'全国教书育人楷模',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399245',1,'2',NULL,1,'福建省引才“百人计划”入选者（含团队带头人）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399246',1,'2',NULL,1,'福建省引进台湾高层次人才“百人计划”入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399247',1,'2',NULL,1,'省杰出人民教师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399248',1,'2',NULL,1,'近10年，国家技术发明奖二等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399249',1,'2',NULL,1,'近10年，国家自然科学奖二等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399250',1,'2',NULL,1,'近10年，国家科技进步奖二等奖第1完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399251',1,'2',NULL,1,'近10年，国际发明展览会金奖第1完成人，同时是国家科技进步奖二等奖第2、3完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399252',1,'2',NULL,1,'近10年，中国专利金奖前3位专利发明人（设计人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399253',1,'2',NULL,1,'近10年，中国外观设计金奖前3位专利发明人（设计人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399254',1,'2',NULL,1,'近10年，全国科技工作者创新创业大赛金奖项目前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399255',1,'2',NULL,1,'近10年，国家级教学成果奖特等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399256',1,'2',NULL,1,'近10年，中华技能大奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399257',1,'2',NULL,1,'近10年，全国质量奖个人奖（中国杰出质量人）获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399258',1,'2',NULL,1,'近10年，中国服装设计金顶奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399259',1,'2',NULL,1,'近10年，中国优秀工业设计奖金奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399260',1,'2',NULL,1,'近10年，中国文化艺术政府奖“文华奖”获得者（2016年5月以后）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399261',1,'2',NULL,1,'近10年，全国美术作品展览金奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306176402399262',1,'2',NULL,1,'近10年，全国优秀企业家',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758338',1,'2',NULL,1,'近10年，泉州杰出人才奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758339',1,'2',NULL,1,'近10年，担任三大世界大学排名最新同时排前500名大学的副校长',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758340',1,'2',NULL,1,'近10年，担任国内知名金融机构董事长（或总裁）、行长、总经理',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758341',1,'2',NULL,1,'近10年，担任国家科技重大专项专家组副组长、项目（课题）组长，且项目（课题）通过验收',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758342',1,'2',NULL,1,'近10年，担任国家“973计划”项目承担研究任务的项目专家组成员',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758343',1,'2',NULL,1,'近10年，担任国家“863计划”领域主题专家组副组长、召集人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758344',1,'2',NULL,1,'近10年，担任国家重点研发计划重点专项项目组副组长',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758345',1,'2',NULL,1,'近10年，担任国家实验室主任、学术委员会主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758346',1,'2',NULL,1,'近10年，担任国家重点实验室主任、学术委员会主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758347',1,'2',NULL,1,'近10年，担任国家工程实验室主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758348',1,'2',NULL,1,'近10年，担任国家级企业技术中心主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758349',1,'2',NULL,1,'近10年，担任国家工程研究中心主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758350',1,'2',NULL,1,'近10年，担任国家工程技术研究中心主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758351',1,'2',NULL,1,'近10年，担任国家能源研发（实验）中心主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758352',1,'2',NULL,1,'近10年，担任国家级工业设计中心设计创新负责人，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758353',1,'2',NULL,1,'近10年，担任国家级质检中心主任，且年薪高于6倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758354',1,'2',NULL,1,'近10年，担任国家制造业创新中心技术委员会副主任，且年薪高于4倍以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758355',1,'2',NULL,1,'近10年，担任国家自然科学基金重大项目资助的项目主持人，且项目已结题',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758356',1,'2',NULL,1,'近10年，担任国家社会科学基金重大项目资助的项目主持人，且项目已结题',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758357',1,'2',NULL,1,'近10年，担任国家自然科学基金创新研究群体项目的项目负责人，且项目已结题',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758358',1,'2',NULL,1,'近10年，担任国家重大科研仪器研制项目的项目负责人，且项目已结题',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758359',1,'2',NULL,1,'近10年，担任国家社会科学基金重大项目首席专家',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758360',1,'2',NULL,1,'近10年，担任全国专业标准化技术委员会主任委员',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758361',1,'2',NULL,1,'近10年，担任国家标准制（修）订排名第1起草人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758362',1,'2',NULL,1,'国家临床重点专科（学科）带头人，且项目经国家有关审批部门验收通过',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758363',1,'2',NULL,1,'国家中医药管理局重点专科（学科）带头人，且项目经国家有关审批部门验收通过',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758364',1,'2',NULL,1,'近3年内为我市企业（年纳税额度不低于1亿元人民币）引进各类高层管理技术人员（总监，副总，总经理以上级别）25人（含）以上的人力资源服务公司董事长（执行董事）或总经理，该公司成立时间5年以上，需具备一般纳税人资质企业，工商注册主体和经营主体在泉州，由申报人公司和引进人才企业出具相关证明',3,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758365',1,'2',NULL,1,'担任过世界500强工业和信息化企业及中国50强工业和信息化企业总部副董事长、副总裁、副总经理3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758366',1,'2',NULL,1,'担任过世界500强非工业和信息化企业及中国50强非工业和信息化企业总部副董事长、副总裁、副总经理3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306181439758367',1,'2',NULL,1,'担任过世界500强工业和信息化企业及中国50强工业和信息化企业总部直属一级子公司（大洲级区域部门）主要负责人3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117442',1,'2',NULL,1,'担任过世界500强非工业和信息化企业及中国50强非工业和信息化企业总部直属一级子公司（大洲级区域部门）主要负责人3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117443',1,'2',NULL,1,'担任过三大世界大学排名最新同时排前100名大学的教授3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117444',1,'2',NULL,1,'担任过道琼斯工业平均指数成分股、日经225指数成分股、伦敦《金融时报》30指数成分股、香港恒生综合指数成分股、台湾50指数成分股以及A股、H股等上市公司董事长、副董事长职务2年以上（职务性质及任职时间以上市公司年报公布数据为准）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117445',1,'2',NULL,1,'担任过管理规模排名前50名的公募基金管理公司或在中国证券投资基金业协会登记备案、管理规模30亿以上的私募基金管理人的董事长、副董事长职务2年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117446',1,'2',NULL,1,'在国际著名金融机构担任高级管理职务2年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117447',1,'2',NULL,1,'在国际著名会计师事务所等中介机构担任过合伙人、董事副总经理或相当职级的高级职务2年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117448',1,'2',NULL,1,'在国际著名律师事务所等中介机构担任过合伙人、董事副总经理或相当职级的高级职务2年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117449',1,'2',NULL,1,'近5年，在《Nature》《Science》《Cell》或其它自然科学、临床医学等领域影响因子25以上（以medsci网站查询系统最新公布的期刊影响因子为准）国际顶级期刊以第一作者或通讯作者（含同等贡献作者）发表研究类或综述类论文者（不含短评、读者来信类文章）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117450',1,'2',NULL,1,'取得博士研究生导师资格3年以上且评聘正高级专业技术职务',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117451',1,'2',NULL,1,'近5年，培养输送出获得奥运会或近两届列入奥运会项目的世界杯、世锦赛第2、3名运动员的主教练员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117452',1,'2',NULL,1,'近5年，经国家、福建省确认由泉州市输送并代表国家参赛，获得奥运会或近两届列入奥运会项目的世界杯、世锦赛个人项目冠军的现役运动员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117453',1,'2',NULL,1,'港澳台人才：近10年内担任世界500强企业总部副董事长、副总裁、副总经理或总部直属一级子公司主要负责人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117454',1,'2',NULL,1,'港澳台人才：近10年内担任香港、澳门、台湾著名大学的校长',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117455',1,'2',NULL,1,'外籍人才：近10年，获得美国、英国、德国、法国、日本、意大利、加拿大科学基金杰出青年类资助奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117456',1,'2',NULL,1,'外籍人才：近10年，获得德国红点设计奖至尊大奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117457',1,'2',NULL,1,'外籍人才：近10年，获得iF设计奖金奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117458',1,'2',NULL,1,'外籍人才：近10年，获得美国工业设计奖金奖前2名设计师',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117459',1,'2',NULL,1,'外籍人才：近10年，获得国际著名建筑奖中最高级别个人奖项',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117460',1,'2',NULL,1,'外籍人才：近10年，获得著名文学奖中最高级别个人奖项',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117461',1,'2',NULL,1,'外籍人才：近10年，获得著名电影、电视、戏剧奖中最高级别个人奖项',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117462',1,'2',NULL,1,'外籍人才：近10年，获得著名音乐奖中最高级别个人奖项',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117463',1,'2',NULL,1,'外籍人才：近10年，获得著名广告奖中最高级别个人奖项',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117464',1,'2',NULL,1,'外籍人才：近10年，获得国际一类艺术比赛大奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117465',1,'2',NULL,1,'外籍人才：近10年，担任国际著名学术组织副主席',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117466',1,'2',NULL,1,'外籍人才：近10年，担任过国际标准化组织（ISO）标样委员会委员',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117467',1,'2',NULL,1,'外籍人才：近10年，担任国际著名学术组织的高级成员（Senior Fellow）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117468',1,'2',NULL,1,'外籍人才：近10年，担任国际著名艺术比赛评委会副主席',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117469',1,'2',NULL,1,'外籍人才：近10年，担任国际高水平科技期刊（《期刊引用报告》JCR一、二区）正、副总编（主编）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117470',1,'2',NULL,1,'外籍人才：近10年，担任八国集团成员国（美国、英国、德国、法国、日本、意大利、加拿大、俄罗斯）国立研究所所长、副所长、首席研究员或国家实验室主任、副主任、首席研究员',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306186477117471',1,'2',NULL,1,'紧缺急需集成电路人才：国际电气和电子工程师协会技术奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836674',1,'2',NULL,1,'紧缺急需集成电路人才：在全球前25大半导体公司担任一级部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836675',1,'2',NULL,1,'紧缺急需集成电路人才：在集成电路设计、制造、封测、装备、材料等领域全球前10大公司一级部门的部门负责人、技术负责人、总工程师累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836676',1,'2',NULL,1,'紧缺急需集成电路人才：在集成电路设计、制造、封测、装备、材料等领域大陆或台湾前5大公司担任副总经理、副总裁或首席科学家以上职务累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836677',1,'2',NULL,1,'紧缺急需集成电路人才：在全球前5大电子设计自动化工具软件公司担任一级部门的部门负责人、技术负责人、总工程师累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836678',1,'2',NULL,1,'紧缺急需集成电路人才：任职集成电路企业高管或从事集成电路科研、技术、工程相关工作者，且年薪高于12倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836679',1,'2',NULL,1,'紧缺急需装备制造人才：毕业于三大世界大学排名最新同时排前100名大学博士，并以第一作者或通讯作者（含同等贡献作者）身份在SCI一区发表论文3篇及以上，来泉后从事装备制造相关工作且被用人单位聘任正高级专业技术职务岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836680',1,'2',NULL,1,'紧缺急需装备制造人才：担任过装备制造相关领域世界500强企业及中国50强企业和中国装备制造业100强总部副总工程师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836681',1,'2',NULL,1,'紧缺急需石油化工人才：从事炼油化工技术、工程相关工作或任职大型炼油化工企业高管，且年薪高于12倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836682',1,'2',NULL,1,'紧缺急需石油化工人才：毕业于三大世界大学排名最新同时排前100名大学工学博士，并以第一作者或通讯作者（含同等贡献作者）身份在JCR一区发表论文5篇及以上，来泉后从事石油化工相关工作且被用人单位聘任正高级专业技术职务岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836683',1,'2',NULL,1,'紧缺急需石油化工人才：担任过石油化工相关领域世界500强企业及中国50强企业和中国石油石化装备制造业100强总部副总工程师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836684',1,'2',NULL,1,'紧缺急需光电人才：担任过三大世界大学排名最新同时排前200名大学的副教授，来泉后从事LED或光生物相关研究或教学者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836685',1,'2',NULL,1,'紧缺急需光电人才：取得三大世界大学排名最新同时排前300名学校的博士学位，且近5年在JCR一区以第一作者或通讯作者发表4篇以上光电信息产业或光生物领域相关论文者',5,1,1,'','',NULL,NULL,'2020-02-27 09:36:47','87'),('1196306191543836686',1,'2',NULL,1,'紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物等领域全球前10大公司一级部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836687',1,'2',NULL,1,'紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物等领域大陆或台湾前5大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836688',1,'2',NULL,1,'紧缺急需半导体人才：中国机械工业科学技术奖一等奖前2位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191543836689',1,'2',NULL,1,'紧缺急需半导体人才：在三大世界大学排名最新同时排前200名大学的教授，来泉后从事光电产业或集成电路相关研究或教学者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391106',1,'2',NULL,1,'紧缺急需半导体人才：取得三大世界大学排名最新同时排前300名大学的博士学位，且近5年在JCR一区以第一作者或通讯作者发表4篇以上半导体产业相关论文者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391107',1,'2',NULL,1,'第二层次其他由企事业等用人单位根据人才对本单位贡献情况提出，与本层次其他人才标准相当的人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391108',1,'3',NULL,1,'中国陶瓷艺术大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391109',1,'3',NULL,1,'中国制茶大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391110',1,'3',NULL,1,'中国木雕艺术大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391111',1,'3',NULL,1,'中国石雕艺术大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391112',1,'3',NULL,1,'全国技术能手',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391113',1,'3',NULL,1,'全国优秀建造师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391114',1,'3',NULL,1,'文化部优秀专家',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391115',1,'3',NULL,1,'科技部创新人才推进计划入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391116',1,'3',NULL,1,'教育部高等学校教学名师奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391117',1,'3',NULL,1,'教育部“新世纪优秀人才支持计划”入选者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391118',1,'3',NULL,1,'全国优秀教师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306191577391119',1,'3',NULL,1,'中国广播影视大奖（中国电影华表奖、中国电视剧飞天奖、中国电视文艺星光奖）获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276161',1,'3',NULL,1,'中国戏剧奖（梅花表演奖、曹禺剧本奖等）获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276162',1,'3',NULL,1,'全国戏剧文化奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276163',1,'3',NULL,1,'全国乡镇卫生院优秀院长',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276164',1,'3',NULL,1,'国家产业技术体系岗位专家',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276165',1,'3',NULL,1,'全国农业科教兴村杰出带头人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276166',1,'3',NULL,1,'全国科普惠农兴村带头人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276167',1,'3',NULL,1,'全国农村青年致富带头人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276168',1,'3',NULL,1,'“新世纪百千万人才工程”省级人选',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276169',1,'3',NULL,1,'省部级有突出贡献的中青年专家',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276170',1,'3',NULL,1,'省（含副省级市）级以上优秀专家',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276171',1,'3',NULL,1,'省特支人才“双百计划”',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276172',1,'3',NULL,1,'省优秀人才“百人计划”（ 文化名家、技能大师、优秀农村实用人才、优秀社会工作专业人才）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276173',1,'3',NULL,1,'省产业人才高地领军人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276174',1,'3',NULL,1,'省工艺美术大师',0,2,1,'','',NULL,NULL,'2020-04-17 15:29:52','58'),('1196306196669276175',1,'3',NULL,1,'省工程勘察设计大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276176',1,'3',NULL,1,'海西创业英才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276177',1,'3',NULL,1,'福建省首席高级技师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276178',1,'3',NULL,1,'福建省优秀高技能人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276179',1,'3',NULL,1,'省杰出青年科学基金获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276180',1,'3',NULL,1,'泉州杰出人才奖提名奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276181',1,'3',NULL,1,'近10年，中国创新设计红星奖至尊金奖获奖作品的第1设计师',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276182',1,'3',NULL,1,'近10年，获光华龙腾设计创新奖中国设计业十大杰出青年',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276183',1,'3',NULL,1,'近10年，中国工业设计十佳大奖前2位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276184',1,'3',NULL,1,'近10年，获福建省“海峡杯”工业设计大赛金奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276185',1,'3',NULL,1,'近10年，中国科学院“百人计划”入选者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276186',1,'3',NULL,1,'近10年，国家知识产权专家库专家',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276187',1,'3',NULL,1,'近10年，国际发明展览会金奖第2、3完成人或国际发明展览会银奖第1完成人，且获省科技进步奖二等奖前3位完成人及以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276188',1,'3',NULL,1,'近10年，国际发明展览会金奖第2、3完成人或国际发明展览会银奖第1完成人，且取得正高级专业技术资格',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276189',1,'3',NULL,1,'近10年，国际发明展览会金奖第2、3完成人或国际发明展览会银奖第1完成人，且取得博士学历',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306196669276190',1,'3',NULL,1,'近10年，国家科技进步奖二等奖第2、3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606786',1,'3',NULL,1,'近10年，国家级教学成果奖一等奖前2位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606787',1,'3',NULL,1,'近10年，华夏建设科学技术奖特等奖、一等奖前2位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606788',1,'3',NULL,1,'近10年，中国人民解放军科学技术进步奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606789',1,'3',NULL,1,'近10年，中国人民解放军医疗成果奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606790',1,'3',NULL,1,'近10年，全国科技工作者创新创业大赛银奖项目前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606791',1,'3',NULL,1,'近10年，省科学技术突出贡献奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606792',1,'3',NULL,1,'近10年，省（自治区、直辖市）科学技术进步奖、技术发明奖、自然科学奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606793',1,'3',NULL,1,'近10年，省部级哲学社会科学优秀成果奖一等奖第1位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606794',1,'3',NULL,1,'近10年，国家人社部、科技部主办的创新创业大赛行业总决赛特等奖的获奖项目核心团队且个人在大赛中被评为优秀指导教师奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606795',1,'3',NULL,1,'近10年，国家人社部、科技部主办的创新创业大赛行业总决赛一等奖的获奖项目核心团队第一负责人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606796',1,'3',NULL,1,'近10年，泉州市人才港湾计划•3D打印创新创业大赛金奖产（作）品第1位完成人。',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606797',1,'3',NULL,1,'近10年，全国工程建设“鲁班奖”',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606798',1,'3',NULL,1,'近10年，国家优质工程“金质奖”“银质奖”',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606799',1,'3',NULL,1,'近10年，“中国建筑工程装饰奖”（含公共建筑装饰类和建筑幕墙类）的项目经理；',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606800',1,'3',NULL,1,'近10年，中国测绘地理信息科技进步奖、中国优秀测绘地理信息工程奖一等奖或金奖的前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606801',1,'3',NULL,1,'近10年，中国专利优秀奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606802',1,'3',NULL,1,'近10年，中国外观设计优秀奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606803',1,'3',NULL,1,'近10年，省级专利金奖或特等奖、一等奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606804',1,'3',NULL,1,'近10年，泉州市重大发明专利奖前3位专利发明人（设计人）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606805',1,'3',NULL,1,'近10年，全国播音主持“金话筒”奖（广播播音员主持人奖、电视播音员主持人奖）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606806',1,'3',NULL,1,'近10年，全国精神文明建设“五个一工程”奖单项奖（含子项6个：戏剧、电影（包括动画电影）、电视剧（包括电视动画片、电视纪录片）、广播剧、歌曲、图书（包括文学类图书、通俗理论读物和少儿读物））主要作者（含编剧、导演）和主要演员前3名',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606807',1,'3',NULL,1,'近10年，大众电影百花奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606808',1,'3',NULL,1,'近10年，中国电影金鸡奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606809',1,'3',NULL,1,'近10年，中国音乐金钟奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606810',1,'3',NULL,1,'近10年，中国美术奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606811',1,'3',NULL,1,'近10年，中国曲艺牡丹奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606812',1,'3',NULL,1,'近10年，中国舞蹈荷花奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606813',1,'3',NULL,1,'近10年，中国民间文艺山花奖金奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606814',1,'3',NULL,1,'近10年，中国摄影金像奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306201727606815',1,'3',NULL,1,'近10年，中国书法兰亭奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411457',1,'3',NULL,1,'近10年，中国杂技金菊奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411458',1,'3',NULL,1,'近10年，中国电视金鹰奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411459',1,'3',NULL,1,'近10年，全国优秀儿童文学奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411460',1,'3',NULL,1,'近10年，王选新闻科学技术奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411461',1,'3',NULL,1,'近10年，中国文联文艺评论奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411462',1,'3',NULL,1,'近10年，中国新闻奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411463',1,'3',NULL,1,'近10年，国家广播影视科技创新奖一等奖前3位完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411464',1,'3',NULL,1,'近10年，长江韬奋奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411465',1,'3',NULL,1,'近10年，全国优秀新闻工作者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411466',1,'3',NULL,1,'近10年，全国中青年德艺双馨文艺工作者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411467',1,'3',NULL,1,'近10年，2016年5月以前“文华奖”获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411468',1,'3',NULL,1,'近10年，中国文化艺术政府奖群星奖（2016年3月以后）、动漫奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411469',1,'3',NULL,1,'近10年，中国出版政府奖优秀出版人物奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411470',1,'3',NULL,1,'近10年，中国侨界贡献奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411471',1,'3',NULL,1,'近10年，全国农牧渔业丰收奖农业技术推广成果奖一等奖、贡献奖和合作奖第1完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411472',1,'3',NULL,1,'近10年，建筑行业国家级工法编写第1完成人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411473',1,'3',NULL,1,'近10年，中国十佳服装设计师',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411474',1,'3',NULL,1,'近10年，省名师（名校长）工作室领衔人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411475',1,'3',NULL,1,'近10年，省优秀企业家',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411476',1,'3',NULL,1,'近5年，担任APEC电子商务工商联盟专家委员会委员、国家电子商务示范基地负责人，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411477',1,'3',NULL,1,'近5年，担任高等院校国家重点学科带头人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411478',1,'3',NULL,1,'近5年，担任国家精品课程负责人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411479',1,'3',NULL,1,'近5年，担任教育部“211工程”院校国家重点学科博士生导师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411480',1,'3',NULL,1,'近5年，担任国家科技重大专项专家组成员、项目（课题）第1副组长、分课题组长且项目（课题）通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411481',1,'3',NULL,1,'近5年，担任国家科技支撑（攻关）计划课题第1负责人且课题通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411482',1,'3',NULL,1,'近5年，担任国家“973计划”项目首席科学家助理、课题组第1负责人且课题通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411483',1,'3',NULL,1,'近5年，担任国家“863计划”主题项目或重大项目首席专家且项目通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411484',1,'3',NULL,1,'近5年，担任国家“863计划”专题组组长、副组长且专题通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411485',1,'3',NULL,1,'近5年，担任“国家软科学研究计划”重大项目第1负责人且项目通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306206731411486',1,'3',NULL,1,'近5年，担任科技部国际科技合作计划项目中方项目第1负责人且项目通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993346',1,'3',NULL,1,'近5年，担任国家自然科学基金重点项目、重大研究计划项目、重点国际（地区）合作研究项目、组织间国际（地区）合作与交流项目、联合基金或优秀青年科学基金项目资助的项目总负责人（不含子项目），且项目通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993347',1,'3',NULL,1,'近5年，担任国家社会科学基金重点项目、重大研究计划项目、重点国际（地区）合作研究项目、组织间国际（地区）合作与交流项目、联合基金或优秀青年科学基金项目资助的项目总负责人（不含子项目），且项目通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993348',1,'3',NULL,1,'近5年，担任国家重点研发计划重点专项任务（或课题）负责人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993349',1,'3',NULL,1,'近5年，担任国家社会科学基金优秀成果（成果文库）项目前2位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993350',1,'3',NULL,1,'近5年，担任国家重点实验室前2位副主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993351',1,'3',NULL,1,'近5年，担任国家工程实验室前2位副主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993352',1,'3',NULL,1,'近5年，担任国家级企业技术中心前2位副主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993353',1,'3',NULL,1,'近5年，担任国家工程研究中心前2位副主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993354',1,'3',NULL,1,'近5年，担任国家工程技术研究中心前2位副主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993355',1,'3',NULL,1,'近5年，担任国家能源研发（实验）中心前2位副主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993356',1,'3',NULL,1,'近5年，担任国家级质检中心前2位副主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993357',1,'3',NULL,1,'近5年，担任国家工程学术（技术）委员会主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993358',1,'3',NULL,1,'近5年，担任国家能源研发（实验）中心学术委员会主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993359',1,'3',NULL,1,'近5年，“闽江学者”特聘教授入选者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993360',1,'3',NULL,1,'近5年，“桐江学者”特聘教授入选者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993361',1,'3',NULL,1,'近5年，担任全国专业标准化技术委员会副主任委员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993362',1,'3',NULL,1,'近5年，担任参与国家标准制（修）订排名第2位起草人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993363',1,'3',NULL,1,'近5年，担任行业标准制（修）订排名第1位起草人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993364',1,'3',NULL,1,'近5年，担任省临床重点专科（学科）、医学重点专科（学科）的科室负责人或学术技术带头人，且项目经省临床重点专科建设项目管理委员会验收通过',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993365',1,'3',NULL,1,'近5年，拥有国际发明专利或核心技术国内发明专利，该发明专利近5年内要求获得过泉州市科技进步奖一等奖或专利奖一等奖及以上，上一年度在泉州年销售额（营业额）3000万元人民币以上或年纳税额150万元人民币以上的企业（不含房地产行业）董事长（总裁）、总经理（首席执行官）或首席技术专家（首席技术官）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993366',1,'3',NULL,1,'近5年，掌握核心竞争力、形成有独创性领先性的商业模式，上一年度在泉州年销售额（营业额）3000万元人民币以上或年纳税额150万元人民币以上的企业（不含房地产行业）董事长（总裁）、总经理（首席执行官）或首席技术专家（首席技术官）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993367',1,'3',NULL,1,'在三级甲等医院担任临床医技科室主任（负责人）2年以上，且评聘副高级专业技术职务资格',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993368',1,'3',NULL,1,'在三级甲等医院担任行政职能科室正职及以上管理人员2年以上，有20年临床工作经验，且评聘正高级专业技术职务资格',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993369',1,'3',NULL,1,'担任过道琼斯工业平均指数成分股、日经225指数成分股、伦敦《金融时报》30指数成分股、香港恒生综合指数成分股、台湾50指数成分股以及A股、H股等上市公司总经理、副总经理、首席技术官或技术总监（职务性质及任职时间以上市公司年报公布数据为准）2年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993370',1,'3',NULL,1,'担任过管理规模排名前50名的公募基金管理公司或在中国证券投资基金业协会登记备案、管理规模30亿以上的私募基金管理人的总经理、副总经理、合伙人或相当职级的高级职务2年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993371',1,'3',NULL,1,'担任过三大世界大学排名最新同时排前100名大学的副教授（终身制）及其它同级别的终身教职人员（如研究员、副研究员）2年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993372',1,'3',NULL,1,'担任过世界500强工业和信息化企业及中国50强工业和信息化企业总部高级副董事长、副总裁、副总经理或总部直属一级子公司（大洲级区域部门）主要负责人1年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993373',1,'3',NULL,1,'担任过世界500强非工业和信息化企业及中国50强非工业和信息化企业总部高级副董事长、副总裁、副总经理或总部直属一级子公司（大洲级区域部门）主要负责人1年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993374',1,'3',NULL,1,'近5年，经国家、福建省确认由泉州市输送并代表国家参赛，获得奥运会或近两届列入奥运会项目的世界杯、世锦赛个人项目第2、3名的现役运动员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306211751993375',1,'3',NULL,1,'受聘于我市国家高新技术企业，连续2年年薪高于6倍以上的高级经营管理人员、高级技术研发人员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603714',1,'3',NULL,1,'受聘于本标准（一、二层次）认定人选在我市创办的工业和信息化企业，连续2年年薪高于6倍以上的高级经营管理人员、高级技术研发人员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603715',1,'3',NULL,1,'受聘于本标准（一、二层次）认定人选在我市创办的非工业和信息化企业，连续2年年薪高于6倍以上的高级经营管理人员、高级技术研发人员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603716',1,'3',NULL,1,'受聘于我市重点产业工业和信息化企业，连续2年年薪高于6倍以上的高级经营管理人员、高级技术研发人员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603717',1,'3',NULL,1,'受聘于我市重点产业非工业和信息化企业，连续2年年薪高于6倍以上的高级经营管理人员、高级技术研发人员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603718',1,'3',NULL,1,'取得硕士研究生导师资格3年以上且评聘正高级专业技术职务资格',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603719',1,'3',NULL,1,'港澳台人才：近10年内担任世界500强企业及台湾最新权威排名百大企业二级公司（地区总部）主要负责人',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603720',1,'3',NULL,1,'港澳台人才：近10年内在香港、澳门、台湾著名大学，受聘全职教授或高级管理人员1年以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603721',1,'3',NULL,1,'港澳台人才：近10年内在香港、澳门、台湾著名大学，受聘全职副教授3年以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603722',1,'3',NULL,1,'港澳台人才：受聘于我市重点工业和信息化产业企业，年薪高于6倍以上的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603723',1,'3',NULL,1,'港澳台人才：受聘于我市非工业和信息化重点产业企业，年薪高于6倍以上的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603724',1,'3',NULL,1,'港澳台人才：近10年内在港澳台科研机构，担任研究员、教授（或相当技术职务）1年以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603725',1,'3',NULL,1,'港澳台人才：近10年内在港澳台科研机构，担任副研究员、副教授（或相当技术职务）累计时间3年以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603726',1,'3',NULL,1,'港澳台人才：近10年内担任过新竹科学工业园、台南科学工业园、台中科技园等台湾著名科技园区管理服务机构中层正职3年以上',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603727',1,'3',NULL,1,'港澳台人才：近10年内获得台湾工业总会、商业总会、工商协进会、中小企业总会、工业协进会、电电公会等六大工商团体评选或授予的最高奖项（行业公认奖项）',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603728',1,'3',NULL,1,'港澳台人才：毕业于三大世界大学排名最新同时排前100名大学的博士，且有1年以上工作经历',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603729',1,'3',NULL,1,'外籍人才：近10年，国际一类艺术比赛二等奖以上或国际二类艺术比赛大奖获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603730',1,'3',NULL,1,'外籍人才：近10年，获得国家级重大艺术比赛或艺术节政府奖项一等奖',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603731',1,'3',NULL,1,'外籍人才：近10年，省“友谊奖”获得者',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603732',1,'3',NULL,1,'外籍人才：近5年，担任过国际著名艺术比赛评委会评委',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603733',1,'3',NULL,1,'外籍人才：近5年，担任过国家级重大艺术比赛或艺术节评委会主任',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603734',1,'3',NULL,1,'外籍人才：在国际成熟自由港、自贸试验区或国际知名开发区管理机构担任中层正职或相当管理岗位3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603735',1,'3',NULL,1,'受聘于我市重点产业工业和信息化企业，年薪高于6倍以上的外籍人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603736',1,'3',NULL,1,'受聘于我市重点产业非工业和信息化企业，年薪高于6倍以上的外籍人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603737',1,'3',NULL,1,'紧缺急需集成电路人才：国际电气和电子工程师协会高级会员、国际计算机学会资深会员、国际工程技术学会高级会员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603738',1,'3',NULL,1,'紧缺急需集成电路人才：在全球前25大半导体公司担任二级部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603739',1,'3',NULL,1,'紧缺急需集成电路人才：在集成电路设计、制造、封测、装备、材料等领域全球前10大公司担任二级部门的部门负责人、技术负责人、总工程师累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603740',1,'3',NULL,1,'紧缺急需集成电路人才：在集成电路设计、制造、封测、装备、材料等领域大陆或台湾前5大公司担任一级部门的部门负责人、技术负责人、总工程师累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603741',1,'3',NULL,1,'紧缺急需集成电路人才：在全球前5大电子设计自动化（EDA）工具软件公司担任二级部门的部门负责人、技术负责人、总工程师累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603742',1,'3',NULL,1,'紧缺急需集成电路人才：任职集成电路企业高管或从事集成电路科研、技术、工程相关工作者，且年薪高于8倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306216751603743',1,'3',NULL,1,'紧缺急需装备制造人才：毕业于三大世界大学排名最新同时排前100名大学的博士，并以第一作者或通讯作者（含同等贡献作者）身份发表SCI收录论文5篇及以上，来泉后从事装备制造相关工作且被用人单位聘任高级专业技术职务岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214082',1,'3',NULL,1,'紧缺急需装备制造人才：担任过装备制造相关领域世界500强企业及中国50强和中国装备制造业100强企业部门高级经理并以技术负责身份完成1500万以上级别项目',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214083',1,'3',NULL,1,'紧缺急需石油化工人才：担任过国家级“双一流”建设高校或中国科学院大学的教授或研究员，且从事石油化工相关研究或教学者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214084',1,'3',NULL,1,'紧缺急需石油化工人才：取得三大世界大学排名 最新同时排前300名大学的博士学位，且近5年在JCR一区第一作者或通讯作者（含同等贡献作者）身份发表2篇以上石油化工产业或催化领域相关论文者',5,1,1,'','',NULL,NULL,'2020-02-27 09:37:44','87'),('1196306221751214085',1,'3',NULL,1,'紧缺急需石油化工人才：从事大型炼油化工企业技术、工程相关工作，且年薪高于8倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214086',1,'3',NULL,1,'紧缺急需石油化工人才：从事炼油化工企业技术、工程相关工作者，并取得所属行业认定的教授级专业技术资格且年薪高于6倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214087',1,'3',NULL,1,'紧缺急需石油化工人才：中国石油与化学工业联合会科技进步奖、技术发明奖特等奖和一等奖前3位完成人、中国腐蚀与防护学会科技进步一等奖前3位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214088',1,'3',NULL,1,'紧缺急需光电人才：担任过国家级“双一流”建设高校或中国科学院大学的教授，且从事LED或光生物相关研究或教学者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214089',1,'3',NULL,1,'紧缺急需光电人才：取得三大世界大学排名最新同时排前300名大学的博士学位，且近5年在JCR一区第一作者或通讯作者发表2篇以上光电信息产业或光生物领域相关论文者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214090',1,'3',NULL,1,'紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物等领域全球前10大公司担任二级部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214091',1,'3',NULL,1,'紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物等领域大陆或台湾前5大公司担任一级部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214092',1,'3',NULL,1,'紧缺急需光电人才：在属于光电信息产业或光生物领域的高新技术企业或知识产权优势企业担任总经理、总裁或首席科学家以上职务累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214093',1,'3',NULL,1,'紧缺急需半导体人才：中国机械工业科学技术奖二等奖第1位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214094',1,'3',NULL,1,'紧缺急需半导体人才：在三大世界大学排名最新同时排前200名大学的副教授，并从事半导体产业相关研究或教学者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214095',1,'3',NULL,1,'紧缺急需半导体人才：取得三大世界大学排名最新同时排前300名大学的博士学位，且近5年在期刊分区表中列入大类一区的学术期刊上以第一作者或通讯作者发表2篇以上半导体产业相关论文者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214096',1,'3',NULL,1,'紧缺急需半导体人才：在属于半导体产业领域的高新技术企业或知识产权优势企业担任总经理、总裁或首席科学家以上职务累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214097',1,'3',NULL,1,'紧缺急需人工智能人才：毕业于三大世界大学排名最新同时排前200名大学的博士，并以第一作者或通讯作者（含同等贡献作者）身份在国际高水平科技期刊发表SCI收录论文2篇及以上，来泉后从事新一代人工智能关键共性技术（知识计算引擎与知识服务技术、跨媒体分析推理技术、群体智能关键技术、混合增强智能新架构与新技术、自主无人系统的智能技术、虚拟现实智能建模技术、智能计算芯片与系统、自然语言处理技术）相关工作且被用人单位聘任高级技术岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214098',1,'3',NULL,1,'紧缺急需人工智能人才：在人工智能相关领域国内外优秀企事业单位担任部门高级经理或相当职务并以技术负责人身份完成1500万以上级别项目',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214099',1,'3',NULL,1,'第三层次其他由企事业等用人单位根据人才对本单位贡献情况提出，与本层次其他人才标准相当的人才',0,2,1,'','',NULL,NULL,'2020-04-02 15:28:07','87'),('1196306221751214100',1,'4',NULL,1,'全国广播电视技术能手一等奖',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214101',1,'4',NULL,1,'现代农业产业技术体系试验站站长',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214102',1,'4',NULL,1,'中国乡村旅游致富带头人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214103',1,'4',NULL,1,'中国传统工艺美术大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214104',1,'4',NULL,1,'省陶瓷艺术大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214105',1,'4',NULL,1,'省特级教师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214106',1,'4',NULL,1,'省技术能手',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214107',1,'4',NULL,1,'省级非物质文化遗产代表性项目代表性传承人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214108',1,'4',NULL,1,'福建省科普惠农兴村带头人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214109',1,'4',NULL,1,'福建省优秀青年企业家',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214110',1,'4',NULL,1,'省级工匠',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306221751214111',1,'4',NULL,1,'福建省工艺美术名人',0,2,1,'','',NULL,NULL,'2020-04-17 15:37:55','87'),('1196306226767601666',1,'4',NULL,1,'泉州优秀人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601667',1,'4',NULL,1,'泉州市技能大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601668',1,'4',NULL,1,'泉州市工艺美术大师',0,2,1,'','',NULL,NULL,'2020-04-17 15:22:46','58'),('1196306226767601669',1,'4',NULL,1,'安溪铁观音大师',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601670',1,'4',NULL,1,'近5年内，毕业于三大世界大学排名最新同时排前200名大学且有1年以上工作经验的博士',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601671',1,'4',NULL,1,'近5年内，在三大世界大学排名最新同时排前200名的大学有1年以上留学经历回国就任高级职位的博士',5,1,1,'','',NULL,NULL,'2020-02-27 09:11:29','87'),('1196306226767601672',1,'4',NULL,1,'毕业于国家级“双一流”建设高校或中科院，且有1年及以上留学经历的博士',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601673',1,'4',NULL,1,'近5年内，以第一作者或通讯作者（含同等贡献作者）身份在国际高水平科技期刊（所在专业领域《期刊引用报告》JCR二区以上）发表论文5篇及以上者(一篇JCR一区等同于两篇JCR二区）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601674',1,'4',NULL,1,'近5年，获得德国红点设计奖的优异奖或设计概念奖前２位设计师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601675',1,'4',NULL,1,'近5年，获得光华龙腾设计创新奖中国设计业十大杰出青年提名奖',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601676',1,'4',NULL,1,'近5年，获得福建省“海峡杯”工业设计大赛银奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601677',1,'4',NULL,1,'近5年，获国际发明展览会银奖第2、3完成人，国际发明展览会铜奖第1完成人，且获省科技进步奖三等奖前3位完成人及以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601678',1,'4',NULL,1,'近5年，获国际发明展览会银奖第2、3完成人，国际发明展览会铜奖第1完成人，且取得副高级以上专业技术任职资格',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601679',1,'4',NULL,1,'近5年，获国际发明展览会银奖第2、3完成人，国际发明展览会铜奖第1完成人，且获得硕士以上学位',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601680',1,'4',NULL,1,'近5年，获国际发明展览会银奖第2、3完成人，国际发明展览会铜奖第1完成人，且取得国家一级职业资格',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601681',1,'4',NULL,1,'近5年，获全国科技工作者创新创业大赛铜奖团队前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601682',1,'4',NULL,1,'近5年，获华夏建设科学技术奖二等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601683',1,'4',NULL,1,'近5年，获中国人民解放军科学技术进步奖二等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601684',1,'4',NULL,1,'近5年，获中国人民解放军医疗成果奖二等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601685',1,'4',NULL,1,'近5年，获中国人民解放军科学技术进步奖三等奖前1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601686',1,'4',NULL,1,'近5年，获中国人民解放军医疗成果奖三等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601687',1,'4',NULL,1,'近5年，获省级科学技术奖二等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601688',1,'4',NULL,1,'近5年，获省级科学技术奖三等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601689',1,'4',NULL,1,'近5年，获福建青年科技奖',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601690',1,'4',NULL,1,'近5年，获福建省优秀科技工作者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601691',1,'4',NULL,1,'近5年，获省级专利二、三等奖前3位专利发明人（设计人）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601692',1,'4',NULL,1,'近5年，获省部级哲学社会科学优秀成果奖一等奖第2位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601693',1,'4',NULL,1,'近5年，获省部级哲学社会科学优秀成果奖二等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601694',1,'4',NULL,1,'近5年，获中国测绘地理信息科技进步奖二等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306226767601695',1,'4',NULL,1,'近5年，获中国优秀测绘地理信息工程奖银奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600642',1,'4',NULL,1,'近5年，获省部级优秀城乡规划设计奖一等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600643',1,'4',NULL,1,'近5年，获省部级优秀勘察设计奖一等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600644',1,'4',NULL,1,'近5年，获省优秀测绘地理信息工程奖一等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600645',1,'4',NULL,1,'近5年，获省测绘地理信息科技进步奖一等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600646',1,'4',NULL,1,'近5年，获地市级科学技术奖一等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600647',1,'4',NULL,1,'近5年，获地市级专利金奖或一等奖前3位专利发明人或设计人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600648',1,'4',NULL,1,'近5年，获地市级社会科学优秀成果一等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600649',1,'4',NULL,1,'近5年，获中国新闻奖二等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600650',1,'4',NULL,1,'近5年，获国家广播影视科技创新奖二等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600651',1,'4',NULL,1,'近5年，2016年3月以前“群星奖”优秀节目奖或金奖获奖人第1主创人员（舞蹈、戏剧、曲艺类的编、导、作曲等，音乐类作曲，美术、书法、摄影类作者）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600652',1,'4',NULL,1,'近5年，全国广播影视“十佳百优”理论人才',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600653',1,'4',NULL,1,'近5年，广播节目技术质量奖（金鹿奖）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600654',1,'4',NULL,1,'近5年，电视节目技术质量奖（金帆奖）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600655',1,'4',NULL,1,'近5年，获全国德艺双馨电视艺术工作者（百佳电视艺术工作者）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600656',1,'4',NULL,1,'近5年，获福建省十佳新闻工作者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600657',1,'4',NULL,1,'近5年，福建省宣传文化系统“四个一批”人才入选者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600658',1,'4',NULL,1,'近5年，获国家级教学成果奖二等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600659',1,'4',NULL,1,'近5年，获国家级专业教学资源库前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600660',1,'4',NULL,1,'近5年，获省级优秀教学成果奖特等奖前3位完成人、一等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600661',1,'4',NULL,1,'近5年，省级高校杰出青年科研人才培育计划入选者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600662',1,'4',NULL,1,'近5年，省级“高等学校教学名师奖”获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600663',1,'4',NULL,1,'近5年，省级中小学名校长获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600664',1,'4',NULL,1,'近5年，省级中小学教学名师获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600665',1,'4',NULL,1,'近5年，黄炎培职业教育奖杰出校长奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600666',1,'4',NULL,1,'近5年，国家百千万知识产权人才工程百名高层次人才培养人选',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600667',1,'4',NULL,1,'近5年，获全国农牧渔业丰收奖农业技术推广成果奖一等奖、贡献奖和合作奖第2、3完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600668',1,'4',NULL,1,'近5年，中国国际动漫节金猴奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600669',1,'4',NULL,1,'近5年，中国“伞都杯”国际伞具创意设计大赛特别奖或金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600670',1,'4',NULL,1,'近5年，全国陶瓷行业技术能手',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306231775600671',1,'4',NULL,1,'近5年，全国水泥企业优秀总工程师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822402',1,'4',NULL,1,'近5年，全国十佳纺织面料设计师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822403',1,'4',NULL,1,'近5年，福建省优质工程奖“闽江杯”项目经理',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822404',1,'4',NULL,1,'近5年，福建省十佳服装设计师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822405',1,'4',NULL,1,'近5年，福建省优秀商标代理人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822406',1,'4',NULL,1,'近5年，建筑行业省级工法编写第1完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822407',1,'4',NULL,1,'近5年，国家级高技能人才培训基地负责人，且任职1年（含）以上，年薪高于相应倍数以上（工作单位属企业性质的按4倍以上标准确定，除企业以外的按2倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822408',1,'4',NULL,1,'近5年，担任全国专业标准化技术委员会分技术委员会主任委员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822409',1,'4',NULL,1,'近5年，担任中国电子商务协会专家委员会专家',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822410',1,'4',NULL,1,'近5年，担任教育部“211工程”院校国家重点学科教授或研究员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822411',1,'4',NULL,1,'近5年，省高校新世纪优秀人才计划入选者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822412',1,'4',NULL,1,'近5年，担任国家科技重大专项分课题前2位副组长，且项目（课题）通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822413',1,'4',NULL,1,'近5年，担任国家科技支撑（攻关）计划课题第2、3负责人，且课题通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822414',1,'4',NULL,1,'近5年，担任国家重点研发计划专题负责人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822415',1,'4',NULL,1,'近5年，担任国家“973计划”课题组第2、3负责人，且课题通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822416',1,'4',NULL,1,'近5年，担任国家“863计划”课题组组长、副组长，子课题负责人，且课题通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822417',1,'4',NULL,1,'近5年，担任“国家软科学研究计划”面上项目第1负责人，且课题通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822418',1,'4',NULL,1,'近5年，担任科技部国际科技合作计划项目中方主要参加人员前3位，且完成项目通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822419',1,'4',NULL,1,'近5年，获得国家自然科学基金“年度项目”“青年科学基金项目”资助的项目第1负责人，且项目通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822420',1,'4',NULL,1,'近5年，获得国家社会科学基金“年度项目”“青年科学基金项目”资助的项目第1负责人，且项目通过结题验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822421',1,'4',NULL,1,'近5年，获得国家部委主办的创新创业大赛行业总决赛二、三等奖的获奖项目核心团队的第1负责人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822422',1,'4',NULL,1,'近5年，获得福建省创新创业大赛总决赛一等奖的获奖项目核心团队的第1负责人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822423',1,'4',NULL,1,'近5年，泉州市人才“港湾计划”3D打印创新创业大赛银奖产（作）品第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822424',1,'4',NULL,1,'近5年，担任国家级服务型制造示范企业总经理，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822425',1,'4',NULL,1,'近5年，担任国家级服务型制造示范项目实施主体企业总经理，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822426',1,'4',NULL,1,'近5年，担任国家AAAAA级物流企业总经理，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822427',1,'4',NULL,1,'近5年，担任国家级服务型制造示范平台负责人，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822428',1,'4',NULL,1,'近5年，担任省部级工程实验室学术委员会主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822429',1,'4',NULL,1,'近5年，担任省部级（重点）实验室主任、学术委员会主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822430',1,'4',NULL,1,'近5年，担任省部级工程实验室主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306236766822431',1,'4',NULL,1,'近5年，担任省部级工程研究中心主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015681',1,'4',NULL,1,'近5年，担任省级企业技术中心主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015682',1,'4',NULL,1,'近5年，担任省级制造业创新中心技术委员会主任，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015683',1,'4',NULL,1,'近5年，担任省级工业设计中心设计创新带头人，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015684',1,'4',NULL,1,'近5年，担任省级中小企业公共服务示范平台运营负责人，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015685',1,'4',NULL,1,'近5年，担任省级小微企业创业创新示范基地运营负责人，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015686',1,'4',NULL,1,'近5年，担任省级服务型制造公共服务平台负责人，且年薪高于4倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015687',1,'4',NULL,1,'近5年，在农林业领域育成新品种通过省级审（认、鉴）定或品种登记，并获得农业部植物新品种权证前5位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015688',1,'4',NULL,1,'近5年，拥有国际发明专利或核心技术国内发明专利，该发明专利近5年内要求获得过泉州市科技进步奖二等奖或专利奖二等奖及以上，上一年度在泉州年销售额（营业额）1000万元人民币以上或年纳税额100万元人民币以上（不含房地产行业）董事长（总裁）、总经理（首席执行官）或首席技术专家',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015689',1,'4',NULL,1,'近5年，掌握核心竞争力、形成有独创性领先性的商业模式，上一年度在泉州年销售额（营业额）1000万元人民币以上或年纳税额100万元人民币以上（不含房地产行业）董事长（总裁）、总经理（首席执行官）或首席技术专家',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015690',1,'4',NULL,1,'近5年，担任省重大建设专项技术带头人，且年薪高于相应倍数以上（工作单位属企业性质的按4倍以上标准确定，除企业以外的按2倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015691',1,'4',NULL,1,'近5年，担任省电子商务示范基地负责人，且年薪高于相应倍数以上（工作单位属企业性质的按4倍以上标准确定，除企业以外的按2倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015692',1,'4',NULL,1,'近5年，担任省级制造业单项冠军产品第1研发人员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015693',1,'4',NULL,1,'近5年，担任地市级临床重点专科（学科）科室负责人或学术技术带头人，且项目经市临床重点专科建设项目管理委员会验收通过',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015694',1,'4',NULL,1,'近5年，担任地市级医学重点专科（学科）科室负责人或学术技术带头人，且项目经市临床重点专科建设项目管理委员会验收通过',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015695',1,'4',NULL,1,'担任过世界500强企业或中国50强总部中层正职以上管理人员或与之级别相当的专业技术人员、总部直属一级子公司（大洲级区域部门）高级经营管理人员、技术部门或工艺设计部门主要负责人3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015696',1,'4',NULL,1,'担任过道琼斯工业平均指数成分股、日经225指数成分股、伦敦《金融时报》30指数成分股、香港恒生综合指数成分股、台湾50指数成分股以及A股、H股等上市公司财务总监、投资总监、市场总监或相当职级的高级管理职务、中层专业技术岗位负责人或一级子公司高级技术岗位负责人2年以上，连续2年年薪高于相应倍数以上的技术类或管理人员（高级管理职务的按4倍以上标准确定，中层专业技术岗位负责人或一级子公司高级技术岗位负责人的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015697',1,'4',NULL,1,'担任过管理规模排名前50名的公募基金管理公司或在中国证券投资基金业协会登记备案、管理规模30亿以上的私募基金管理人的投资总监或相当职级的高级职务2年以上，连续2年年薪高于相应倍数以上的技术类或管理人员（高级管理职务的按4倍以上标准确定，中层专业技术岗位负责人或一级子公司高级技术岗位负责人的按3倍以上标准确定）。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015698',1,'4',NULL,1,'担任中国驰名商标企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015699',1,'4',NULL,1,'担任国家创新型企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015700',1,'4',NULL,1,'担任国家级企业技术中心副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015701',1,'4',NULL,1,'担任国家级技术创新示范企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015702',1,'4',NULL,1,'担任国家级科技孵化器企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015703',1,'4',NULL,1,'担任国家级智能制造示范企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015704',1,'4',NULL,1,'担任国家级小型微型企业创业创新基地（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241779015705',1,'4',NULL,1,'担任国家级中小企业公共服务示范平台副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241808375809',1,'4',NULL,1,'担任国家高新技术企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241808375810',1,'4',NULL,1,'担任国家规划布局内重点软件企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241808375811',1,'4',NULL,1,'担任国际科技合作基地企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241808375812',1,'4',NULL,1,'担任国家高技术研究发展（863）计划承担单位副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306241808375813',1,'4',NULL,1,'担任中国软件100强企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597570',1,'4',NULL,1,'担任工信部计算机信息系统集成一级资质企业（集团、总公司）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597571',1,'4',NULL,1,'担任工信部实训基地副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597572',1,'4',NULL,1,'担任国家知识产权示范（优势企业）副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597573',1,'4',NULL,1,'担任国家引进外国智力示范单位副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597574',1,'4',NULL,1,'担任国家级博士后科研工作站副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597575',1,'4',NULL,1,'担任中国优秀诚信企业副总经理以上高级经营管理人员或相当技术岗位2年以上，连续2年年薪高于相应倍数以上的技术类或管理类人员（工作单位属企业性质的按4倍以上标准确定，除企业以外的按3倍以上标准确定）。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597576',1,'4',NULL,1,'取得硕士研究生导师资格3年以上且评聘副高级专业技术职务资格',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597577',1,'4',NULL,1,'评聘正高级专业技术职务者',0,2,1,'','',NULL,NULL,'2020-04-17 17:28:36','87'),('1196306246799597578',1,'4',NULL,1,'博士后出站留（来）泉创业或工作者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597579',1,'4',NULL,1,'近5年，培养输送出获得奥运会或近两届列入奥运会项目的世界杯、世锦赛第4至8名运动员的主教练员，直接培养出获得亚运会、全运会冠军的主教练员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597580',1,'4',NULL,1,'近5年，经国家、福建省确认由泉州市输送并代表国家或福建省参赛，获得奥运会或近两届列入奥运会项目的世界杯、世锦赛个人项目第4至8名，或获得亚运会、全运会个人项目冠军的现役运动员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597581',1,'4',NULL,1,'取得国家体育总局主办的“全国传统武术大赛”金奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597582',1,'4',NULL,1,'取得“国际武术联合会”主办的世界传统武术锦标赛金奖获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597583',1,'4',NULL,1,'取得“国际单项体育联合会”主办的赛事金牌获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597584',1,'4',NULL,1,'福建省优秀医院管理者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597585',1,'4',NULL,1,'福建省先进医院工作者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597586',1,'4',NULL,1,'福建省优秀护士',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597587',1,'4',NULL,1,'福建省名中医',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597588',1,'4',NULL,1,'受聘于我市国家高新技术企业，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（高级经营管理人才、高级技术研发人员必须在企业全职工作，并担任企业副总经理以上管理职务或具有副高级以上专业技术职务任职资格者，工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597589',1,'4',NULL,1,'受聘于我市科研院所，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（高级经营管理人才、高级技术研发人员必须在企业全职工作，并担任企业副总经理以上管理职务或具有副高级以上专业技术职务任职资格者，工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597590',1,'4',NULL,1,'受聘于我市本标准（一、二层次）认定人选创办的工业和信息化企业，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（高级经营管理人才、高级技术研发人员必须在企业全职工作，并担任企业副总经理以上管理职务或具有副高级以上专业技术职务任职资格者，工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597591',1,'4',NULL,1,'受聘于我市本标准（一、二层次）认定人选创办的非工业和信息化企业，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（高级经营管理人才、高级技术研发人员必须在企业全职工作，并担任企业副总经理以上管理职务或具有副高级以上专业技术职务任职资格者，工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597592',1,'4',NULL,1,'受聘于我市重点产业工业和信息化企业，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（高级经营管理人才、高级技术研发人员必须在企业全职工作，并担任企业副总经理以上管理职务或具有副高级以上专业技术职务任职资格者，工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597593',1,'4',NULL,1,'受聘于我市重点产业非工业和信息化企业，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（高级经营管理人才、高级技术研发人员必须在企业全职工作，并担任企业副总经理以上管理职务或具有副高级以上专业技术职务任职资格者，工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597594',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在我省院士专家示范工作站全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246799597595',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上重点实验室全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246849929217',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上工程研究中心全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246849929218',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上企业技术中心全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246849929219',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上生产力促进中心等科研平台所在企业全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306246849929220',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上高科技企业全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345282',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上装备行业众创空间全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345283',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上科技孵化器全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345284',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省级以上智能制造示范企业全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345285',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在省龙头企业全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345286',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在市纳税前50强企业全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345287',1,'4',NULL,1,'以受聘方式引进我市工作，年龄60周岁以下，在总部注册地在我市的国内外上市公司等企事业单位全职工作，已任职满1年且剩余合同期不低于3年的核心科技研发人员，连续2年年薪高于相应倍数以上的（工作单位属企业性质的按4倍或以上标准确定，除企业以外的按3倍或以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345288',1,'4',NULL,1,'近10年内担任世界500强企业及台湾最新权威排名百大企业二级公司部门负责人、技术负责人或其它相应职务累计3年以上者的港澳台人才',10,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345289',1,'4',NULL,1,'毕业于三大世界大学排名最新同时排前300名大学的博士，有1年以上工作经历的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345290',1,'4',NULL,1,'受聘于我市重点产业工业和信息化企业，年薪高于4倍以上的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345291',1,'4',NULL,1,'受聘于我市重点产业非工业和信息化企业，年薪高于4倍以上的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345292',1,'4',NULL,1,'外籍人才：近5年，获得国际一类艺术比赛三等奖或国际二类艺术比赛以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345293',1,'4',NULL,1,'外籍人才：近5年，获得国际著名工业设计iF奖的产品设计奖、传达设计奖、包装设计奖前2位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345294',1,'4',NULL,1,'外籍人才：近5年，获得德国红点设计奖的产品设计奖、传达设计奖、包装设计奖前2位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345295',1,'4',NULL,1,'外籍人才：在国际成熟自由港担任中层副职或相当技术岗位3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345296',1,'4',NULL,1,'外籍人才：在自贸试验区担任中层副职或相当技术岗位3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345297',1,'4',NULL,1,'外籍人才：在国际知名开发区管理机构担任中层副职或相当技术岗位3年以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345298',1,'4',NULL,1,'受聘于我市重点产业工业和信息化企业，年薪高于4倍以上的外籍人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345299',1,'4',NULL,1,'受聘于我市重点产业非工业和信息化企业，年薪高于4倍以上的外籍人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345300',1,'4',NULL,1,'紧缺急需集成电路人才：在全球前25大半导体公司技术研发、工程部门、管理部门担任经理、功能主管、资深工程师、主任工程师或其他相应职务以上累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345301',1,'4',NULL,1,'紧缺急需集成电路人才：在集成电路设计、制造、封测、装备、材料等领域全球前10大公司技术研发、工程部门、管理部门担任经理、功能主管、资深工程师、主任工程师或其他相应职务以上累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345302',1,'4',NULL,1,'紧缺急需集成电路人才：在集成电路设计、制造、封测、装备、材料等领域大陆或台湾前5大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345303',1,'4',NULL,1,'紧缺急需集成电路人才：在全球电子设计自动化（EDA）工具软件前5大公司技术研发、工程部门、管理部门担任经理、功能主管、资深工程师、主任工程师或其他相应职务以上累计7年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345304',1,'4',NULL,1,'紧缺急需集成电路人才：取得博士学位，所学专业学科门类为理学、工学（含工程博士），且从事集成电路科研、技术、工程相关工作者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345305',1,'4',NULL,1,'紧缺急需集成电路人才：取得三大世界大学排名最新同时排前200名高校或列入国家支持建设（含支持筹备建设）示范性微电子学院的高校的硕士学位，所学专业学科门类为理学、工学（含工程硕士），且从事集成电路科研、技术、工程相关工作者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345306',1,'4',NULL,1,'紧缺急需集成电路人才：任职集成电路企业高管或从事集成电路科研、技术、工程相关工作者，且年薪高于5倍以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345307',1,'4',NULL,1,'紧缺急需装备制造人才：毕业于国家级“双一流”建设高校、中科院大学、中国社科院大学的博士，来泉后从事装备制造相关工作且被用人单位聘任高级专业技术岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345308',1,'4',NULL,1,'紧缺急需装备制造人才：在装备制造相关领域世界500强企业及中国50强企业工作和中国装备制造业100强工作5年以上且具有硕士学位并以技术负责身份完成800万以上级别项目',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345309',1,'4',NULL,1,'紧缺急需石油化工人才：毕业于国家级“双一流”建设高校、中科院大学的博士，来泉后从事石油化工相关工作且被用人单位聘任副高级及以上专业技术职务岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345310',1,'4',NULL,1,'紧缺急需石油化工人才：毕业于三大世界大学排名最新同时排前300名大学博士，所学专业与石油化工相关',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306251845345311',1,'4',NULL,1,'紧缺急需石油化工人才：取得博士学位并以第一作者或通讯作者（含同等贡献）发表SCI论文5篇，来泉后从事石油化工相关工作',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149954',1,'4',NULL,1,'紧缺急需石油化工人才：从事炼油化工企业技术、工程相关工作，年薪高于5倍以上且被用人单位聘任高级专业技术职务者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149955',1,'4',NULL,1,'紧缺急需石油化工人才：中国石油与化学工业联合会科技进步奖、技术发明奖二等奖前3位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149956',1,'4',NULL,1,'紧缺急需石油化工人才：中国腐蚀与防护学会科技进步二等奖前3位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149957',1,'4',NULL,1,'紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物等领域全球前10大公司技术研发、工程部门、管理部门担任经理、功能主管、资深工程师、主任工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149958',1,'4',NULL,1,'紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物等领域大陆或台湾前5大公司担任二级部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149959',1,'4',NULL,1,'紧缺急需光电人才：在属于光电信息产业或光生物领域的高新技术企业或知识产权优势企业担任副总经理、副总裁累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149960',1,'4',NULL,1,'紧缺急需半导体人才：中国机械工业科学技术奖三等奖第1位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149961',1,'4',NULL,1,'紧缺急需半导体人才：在属于半导体领域的高新技术企业担任副总经理、副总裁累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149962',1,'4',NULL,1,'紧缺急需半导体人才：在国家知识产权优势企业担任副总经理、副总裁累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149963',1,'4',NULL,1,'紧缺急需半导体人才：近5年，取得三大世界大学排名最新同时排前200名大学的硕士学位，所学专业学科门类为理学、工学，且从事半导体产业科研、技术、工程相关工作者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149964',1,'4',NULL,1,'紧缺急需信息技术人才：在泉州新一代信息技术企业工作2年以上的博士生',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149965',1,'4',NULL,1,'紧缺急需信息技术人才：担任信息技术企业高管，且年薪高于5倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149966',1,'4',NULL,1,'紧缺急需人工智能人才：毕业于国家级“双一流”建设高校、中科院大学、中国社科院大学的工学博士，来泉后从事新一代人工智能关键共性技术（知识计算引擎与知识服务技术、跨媒体分析推理技术、群体智能关键技术、混合增强智能新架构与新技术、自主无人系统的智能技术、虚拟现实智能建模技术、智能计算芯片与系统、自然语言处理技术）相关工作且被用人单位聘任高级技术岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149967',1,'4',NULL,1,'紧缺急需人工智能人才：在人工智能相关领域国内外优秀企事业单位工作3年以上且具有硕士学位并以技术负责人身份完成500万以上级别项目',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149968',1,'4',NULL,1,'第四层次其他由企事业等用人单位根据人才对本单位贡献情况提出，与本层次其他人才标准相当的人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149969',1,'5',NULL,1,'省农村青年致富带头人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149970',1,'5',NULL,1,'泉州市海纳百川高端人才聚集计划入选者（其中符合前四类条件的从高从优认定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149971',1,'5',NULL,1,'泉州市级非物质文化遗产代表性项目代表性传承人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149972',1,'5',NULL,1,'泉州工匠获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149973',1,'5',NULL,1,'获安溪铁观音制茶工艺大师称号',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149974',1,'5',NULL,1,'获安溪铁观音名匠称号',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149975',1,'5',NULL,1,'近5年，国际发明展览会铜奖第2、3完成人，且获地市级科技进步奖三等奖前3位完成人及以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149976',1,'5',NULL,1,'近5年，国际发明展览会铜奖第2、3完成人，且获取得中级以上专业技术任职资格',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149977',1,'5',NULL,1,'近5年，国际发明展览会铜奖第2、3完成人，且获取得国家二级以上职业资格',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149978',1,'5',NULL,1,'近5年，国际发明展览会铜奖第2、3完成人，且获年薪高于2.5倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149979',1,'5',NULL,1,'近5年，获中国人民解放军科学技术进步奖三等奖第2位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149980',1,'5',NULL,1,'近5年，获中国人民解放军医疗成果奖三等奖第2位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149981',1,'5',NULL,1,'近5年，获省部级哲学社会科学优秀成果奖三等奖第1完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149982',1,'5',NULL,1,'近5年，获省级科学技术奖三等奖第2、3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306256849149983',1,'5',NULL,1,'近5年，获地市级科学技术奖二等奖前2位完成人、三等奖第1位完成人',5,1,1,'','',NULL,NULL,'2020-05-14 09:32:44','87'),('1196306261878120449',1,'5',NULL,1,'近5年，获地市级专利银奖、优秀奖或二、三等奖前3位专利发明人或设计人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120450',1,'5',NULL,1,'近5年，获地市级社会科学优秀成果奖二等奖第1完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120451',1,'5',NULL,1,'近5年，获泉州市青年科技奖',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120452',1,'5',NULL,1,'近5年，中国新闻奖三等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120453',1,'5',NULL,1,'近5年，国家广播影视科技创新奖三等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120454',1,'5',NULL,1,'近5年，福建新闻奖一等奖第1位完成人',5,1,1,'','',NULL,NULL,'2020-03-05 08:20:20','87'),('1196306261878120455',1,'5',NULL,1,'近5年，福建省优秀出版人奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120456',1,'5',NULL,1,'近5年，福建省百花文艺奖一等奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120457',1,'5',NULL,1,'近5年，福建省曲艺“丹桂奖”大赛一等奖表演者第1人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120458',1,'5',NULL,1,'近5年，福建省文化厅主办的全省性艺术专业比赛一等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120459',1,'5',NULL,1,'近5年，华东区六省一市省级政府文化主管部门联办的区域性艺术专业比赛一等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120460',1,'5',NULL,1,'近5年，获光华龙腾设计创新奖中国设计业青年百人榜',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120461',1,'5',NULL,1,'近5年，福建省“海峡杯”工业设计大赛铜奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120462',1,'5',NULL,1,'近5年，中国测绘地理信息科技进步奖三等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120463',1,'5',NULL,1,'近5年，中国优秀测绘地理信息工程奖铜奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120464',1,'5',NULL,1,'近5年，省部级优秀城乡规划设计奖二、三等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120465',1,'5',NULL,1,'近5年，省部级优秀勘察设计奖二、三等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120466',1,'5',NULL,1,'近5年，省优秀测绘地理信息工程奖二、三等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120467',1,'5',NULL,1,'近5年，省测绘地理信息科技进步奖二、三等奖前3位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120468',1,'5',NULL,1,'近5年，中国工艺美术“百花杯”金奖',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120469',1,'5',NULL,1,'近5年，福建省工艺美术“争艳杯”金奖',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120470',1,'5',NULL,1,'近5年，泉州市工业设计十佳精英人物',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120471',1,'5',NULL,1,'近5年，泉州市海峡两岸100新锐设计师评选10佳设计师获评人选',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120472',1,'5',NULL,1,'近5年，泉州市市级工业设计中心设计创新带头人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120473',1,'5',NULL,1,'近5年，“金狮奖”全国木偶皮影中青年技艺大赛金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120474',1,'5',NULL,1,'近5年，中国国际（厦门）动漫节金海豚奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120475',1,'5',NULL,1,'近5年，全国农牧渔业丰收奖农业技术推广成果奖二等奖前5位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120476',1,'5',NULL,1,'近5年，全国优秀纺织面料设计师获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120477',1,'5',NULL,1,'近5年，海峡两岸（厦门）文化产业交易会（简称“厦门文博会”）“海峡工艺精品奖”金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306261878120478',1,'5',NULL,1,'近5年，“何朝宗杯”中国（德化）陶瓷工业设计大赛特等奖或金奖奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673857',1,'5',NULL,1,'近5年，“匠心杯”中国（安溪）藤铁工艺现场创作大赛特别奖或金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673858',1,'5',NULL,1,'近5年，省级金牌工人获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673859',1,'5',NULL,1,'近5年，泉州市工艺美术创新设计“天工奖”大赛一等奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673860',1,'5',NULL,1,'近5年，中国“伞都杯”国际伞具创意设计大赛银奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673861',1,'5',NULL,1,'近5年，教育部组织的教学大赛一等奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673862',1,'5',NULL,1,'近5年，地市级中小学名校长获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673863',1,'5',NULL,1,'近5年，地市级中小学教学名师获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673864',1,'5',NULL,1,'近5年，获泉州市十大杰出青年企业家',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673865',1,'5',NULL,1,'近5年，获泉州市十大杰出留学人员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673866',1,'5',NULL,1,'近5年，获泉州市侨界十大杰出青年',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673867',1,'5',NULL,1,'近5年，获泉州市十大杰出职业经理人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673868',1,'5',NULL,1,'近5年，获泉州市电子商务领军人物',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673869',1,'5',NULL,1,'近5年，担任全国专业标准化技术委员会分技术委员会副主任委员',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673870',1,'5',NULL,1,'近5年，担任国家级服务型制造示范企业副总经理，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673871',1,'5',NULL,1,'近5年，担任国家级服务型制造示范项目实施主体企业副总经理，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673872',1,'5',NULL,1,'近5年，担任国家AAAAA级物流企业副总经理，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673873',1,'5',NULL,1,'近5年，担任国家AAAA级物流企业总经理，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673874',1,'5',NULL,1,'近5年，担任省级服务型制造示范企业总经理，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673875',1,'5',NULL,1,'近5年，担任省级服务型制造示范平台负责人，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673876',1,'5',NULL,1,'近5年，担任省部级（重点）实验室、学术委员会副主任，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673877',1,'5',NULL,1,'近5年，担任省部级工程实验室副主任，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673878',1,'5',NULL,1,'近5年，担任省部级工程研究中心副主任，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673879',1,'5',NULL,1,'近5年，担任省级企业技术中心副主任，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673880',1,'5',NULL,1,'近5年，担任省级制造业创新中心技术委员会副主任，且年薪高于2倍以上',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673881',1,'5',NULL,1,'近5年，担任省级学科（教学）、专业带头人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673882',1,'5',NULL,1,'近5年，担任省级精品在线开放课程、共享课程负责人且项目通过验收',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673883',1,'5',NULL,1,'近5年，担任泉州市高等职业教育技能名师工作室主持人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673884',1,'5',NULL,1,'近5年，获得福建省创新创业大赛总决赛二等奖的获奖项目核心团队的第1负责人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673885',1,'5',NULL,1,'近5年，泉州市人才港湾计划•3D打印创新创业大赛优秀奖产（作）品第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306266919673886',1,'5',NULL,1,'近5年，证券发行保荐代表人资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306271931867137',1,'5',NULL,1,'近5年，特许金融分析师 （CFA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306271931867138',1,'5',NULL,1,'近5年，国际注册投资分析师（CIIA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113346',1,'5',NULL,1,'近5年，金融风险管理师（FRM）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113347',1,'5',NULL,1,'近5年，美国注册会计师（AICPA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113348',1,'5',NULL,1,'近5年，英国特许会计师（CA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113349',1,'5',NULL,1,'近5年，英国皇家特许会计师（ACA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113350',1,'5',NULL,1,'近5年，特许公认会计师（ACCA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113351',1,'5',NULL,1,'近5年，加拿大注册会计师（CPA Canada）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113352',1,'5',NULL,1,'近5年，美国管理会计师（CMA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113353',1,'5',NULL,1,'近5年，澳大利亚注册会计师（ASCPA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113354',1,'5',NULL,1,'近5年，美国财产保险核保师（CPCU）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113355',1,'5',NULL,1,'近5年，北美精算师（FSA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113356',1,'5',NULL,1,'近5年，英国精算师（FIA）资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113357',1,'5',NULL,1,'近5年，澳洲精算师资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113358',1,'5',NULL,1,'近5年，中国精算师（FCAA）等资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）。',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113359',1,'5',NULL,1,'近5年，国际会计师公会全权会员（AAIA）等资格证书者，连续2年年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格须进行执业注册，工作单位属企业性质的按2倍以上标准确定，属企业以外的按1.5倍以上标准确定）。',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113360',1,'5',NULL,1,'取得全日制硕士学位来泉创办企业，担任法定代表人且股份占比达30%以上，企业年纳税10万元以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113361',1,'5',NULL,1,'新三板上市企业法定代表人，且年薪高于4倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113362',1,'5',NULL,1,'培养输送出获得近两届列入奥运会项目的亚锦赛、全国锦标赛冠军的主教练员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113363',1,'5',NULL,1,'经国家、福建省确认由泉州市输送，获得近2年全国比赛（国家体育总局盖章）的个人项目金牌现役运动员',2,1,1,'','',NULL,NULL,'2020-02-27 09:44:43','87'),('1196306272045113364',1,'5',NULL,1,'取得“国际单项体育联合会”主办的赛事银、铜牌牌获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113365',1,'5',NULL,1,'取得中国单项体育协会主办的赛事金牌获得者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113366',1,'5',NULL,1,'取得国家一级职业资格或经全国统考取得国家最高等级职业资格，且从事职业资格所在专业领域工作2年以上、年薪高于相应倍数以上的技术类或管理类人员(准入类职业资格进行执业注册，工作单位属企业性质的按2倍以上标准确定，除企业以外的按1.5倍以上标准确定)',0,2,1,'','',NULL,NULL,'2020-05-20 16:42:12','87'),('1196306272045113367',1,'5',NULL,1,'在泉州市主导产业、特色产业、新兴产业的工业和信息化企业，取得副高级专业技术职务任职资格者且任职3年以上的专业技术人员，年薪高于2倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113368',1,'5',NULL,1,'泉州市主导产业、特色产业、新兴产业非工业和信息化企业，取得副高级专业技术职务任职资格者且任职3年以上的专业技术人员，年薪高于2倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113369',1,'5',NULL,1,'卫生医疗系统取得副高级专业技术职务任职资格者且聘任5年以上的专业技术人员，其中紧缺急需专业（依据：我市紧缺急需人才引进指导目录）取得副高级专业技术职务任职资格者且聘任3年以上的专业技术人员',0,2,1,'','',NULL,NULL,'2020-04-17 17:19:23','87'),('1196306272045113370',1,'5',NULL,1,'教育系统取得副高级专业技术职务任职资格者且聘任5年以上的专业技术人员，其中紧缺急需专业（依据：我市紧缺急需人才引进指导目录）取得副高级专业技术职务任职资格者且聘任3年以上的专业技术人员',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113371',1,'5',NULL,1,'取得博士学位者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113372',1,'5',NULL,1,'在农林业领域育成新品种通过审（认、鉴）定或品种登记，并获得省级植物新品种权证前5位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306272045113373',1,'5',NULL,1,'具有10年以上（含10年）执业经历的泉州市资深专利代理人，且年薪高于4倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216129',1,'5',NULL,1,'经全国统考取得律师资格或国家法律职业资格，执业7年以上，年薪高于4倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216130',1,'5',NULL,1,'经全国统考取得国家高级以上等级导游员资格的导游员，年薪高于相应倍数以上（工作单位属企业性质的按2倍以上标准确定，除企业以外的按1.5倍以上标准确定）',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216131',1,'5',NULL,1,'拥有国际发明专利或核心技术国内发明专利，该发明专利近5年内要求获得过泉州市科技进步奖三等奖或专利奖三等奖及以上，上一年度在泉州年销售额（营业额）1000万人民币或年纳税额100万元人民币企业的高级经营、管理、技术、技能等重点人才，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（工作单位属企业性质的4倍或以上标准确定，除企业以外的按3倍或以上标准确定',5,1,1,'','',NULL,NULL,'2020-02-27 09:39:29','87'),('1196306277271216132',1,'5',NULL,1,'拥有掌握核心竞争力、形成有独创性领先性的商业模式，上一年度在泉州年销售额（营业额）1000万人民币或年纳税额100万元人民币企业的高级经营、管理、技术、技能等重点人才，连续2年年薪高于相应倍数以上的高级经营管理人员、高级技术研发人员（工作单位属企业性质的4倍或以上标准确定，除企业以外的按3倍或以上标准确定',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216133',1,'5',NULL,1,'有1年以上工作经历、取得硕士学位者，并以第1发明人3项授权实用新型专业或1项发明专利的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216134',1,'5',NULL,1,'受聘于我市重点产业工业和信息化企业，年薪高于3倍以上的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216135',1,'5',NULL,1,'受聘于我市重点产业非工业和信息化企业，年薪高于3倍以上的港澳台人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216136',1,'5',NULL,1,'近5年，担任“外国青年学者研究基金项目” 资助的项目负责人，且项目通过结题验收的外籍人才',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216137',1,'5',NULL,1,'近5年，担任“海外及港澳学者合作研究基金项目” 资助的项目负责人，且项目通过结题验收的外籍人才',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216138',1,'5',NULL,1,'受聘于我市重点产业工业和信息化企业，年薪高于3倍以上的外籍人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216139',1,'5',NULL,1,'受聘于我市重点产业非工业和信息化企业，年薪高于3倍以上的外籍人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216140',1,'5',NULL,1,'紧缺急需集成电路人才：近5年，取得三大世界大学排名最新同时排前500名大学的理学、工学学士学位，且从事集成电路科研、技术、工程相关工作者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216141',1,'5',NULL,1,'紧缺急需集成电路人才：近5年，取得国家级“双一流”建设高校的理学、工学学士学位，且从事集成电路科研、技术、工程相关工作者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216142',1,'5',NULL,1,'紧缺急需集成电路人才：近5年，取得相关国家部委支持（含支持筹备建设）建设示范性微电子学院高校的示范性微电子学院学士学位者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216143',1,'5',NULL,1,'紧缺急需集成电路人才：近5年，取得硕士学位，所学专业学科门类为理学、工学（含工程硕士），且从事集成电路科研、技术、工程相关工作者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216144',1,'5',NULL,1,'紧缺急需集成电路人才：任职集成电路企业高管或从事集成电路科研、技术、工程相关工作者，且年薪高于3倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216145',1,'5',NULL,1,'紧缺急需装备制造人才：取得硕士学位并有2年及以上工作经历者，来泉后从事装备制造相关工作且被用人单位聘任中级专业技术职务岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216146',1,'5',NULL,1,'紧缺急需装备制造人才：取得硕士学位者并以第1发明人3项授权实用新型专业或1项授权发明专利，来泉后从事装备制造相关工作',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216147',1,'5',NULL,1,'紧缺急需装备制造人才：取得硕士学位者并以第一作者发表1篇SCI收录或2篇EI收录论文，来泉后从事装备制造相关工作',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216148',1,'5',NULL,1,'紧缺急需装备制造人才：在装备制造领域世界500强企业及中国50强企业和中国装备制造业100强工作5年以上且具有硕士学位并以技术负责人身份完成200万以上级别项目',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216149',1,'5',NULL,1,'紧缺急需石油化工人才：取得国家级“双一流”建设高校的硕士学位并有2年及以上工作经历者，来泉后从事石油化工相关工作且被用人单位聘任中级专业技术职务及以上岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216150',1,'5',NULL,1,'紧缺急需石油化工人才：取得国家级“双一流”建设高校的硕士学位者并以第1发明人3项授权实用新型专业或1项授权发明专利，来泉后从事石油化工相关工作',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216151',1,'5',NULL,1,'紧缺急需石油化工人才：取得国家级“双一流”建设高校的硕士学位者并以第一作者（含同等贡献）发表1篇SCI收录或3篇EI收录论文，来泉后从事石油化工相关工作',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216152',1,'5',NULL,1,'紧缺急需石油化工人才：中国石油与化学工业联合会科技进步奖、技术发明奖三等奖前3位完成人、中国腐蚀与防护学会科技进步三等奖前3位完成人',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216153',1,'5',NULL,1,'紧缺急需光电人才：取得三大世界大学排名最新同时排前500名大学的理学、工学、农学学士及以上学位，且从事LED科研、技术、工程或光生物领域相关工作者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216154',1,'5',NULL,1,'紧缺急需光电人才：取得国家级“双一流”建设高校的理学、工学、农学学士及以上学位，且从事LED科研、技术、工程或光生物领域相关工作者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216155',1,'5',NULL,1,'紧缺急需光电人才：在光电信息产业或光生物等领域所属的知识产权优势企业中担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216156',1,'5',NULL,1,'紧缺急需光电人才：在光电信息产业或光生物等领域所属的高新技术企业中担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216157',1,'5',NULL,1,'紧缺急需半导体人才：近5年，取得三大世界大学排名最新同时排前500名大学的理学、工学学士学位，且从事半导体产业科研、技术、工程相关工作者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306277271216158',1,'5',NULL,1,'紧缺急需半导体人才：在半导体产业领域所属的知识产权优势企业担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518274',1,'5',NULL,1,'紧缺急需半导体人才：在半导体产业领域所属的高新技术企业担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518275',1,'5',NULL,1,'紧缺急需信息技术人才：在泉州新一代信息技术企业工作2年以上的硕士研究生',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518276',1,'5',NULL,1,'紧缺急需信息技术人才：新一代信息技术企业高管，年薪高于3倍以上',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518277',1,'5',NULL,1,'紧缺急需人工智能人才:取得工学硕士学位，来泉后从事新一代人工智能关键共性技术（知识计算引擎与知识服务技术、跨媒体分析推理技术、群体智能关键技术、混合增强智能新架构与新技术、自主无人系统的智能技术、虚拟现实智能建模技术、智能计算芯片与系统、自然语言处理技术）相关工作被用人单位聘任为中级技术岗位',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518278',1,'5',NULL,1,'第五层次其他由企事业等用人单位根据人才对本单位贡献情况提出，与本层次其他人才标准相当的人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518279',1,'6',NULL,1,'近5年，全国广播电视技术能手三等奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518280',1,'6',NULL,1,'近5年，“石狮杯”全国高校毕业生服装设计大赛金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518281',1,'6',NULL,1,'近5年，福建文创奖金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518282',1,'6',NULL,1,'近5年，福建省工艺美术“争艳杯”银奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518283',1,'6',NULL,1,'近5年，获“福建省陶瓷艺术名人”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518284',1,'6',NULL,1,'近5年，获“福建省陶瓷行业技术能手”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518285',1,'6',NULL,1,'近5年，福建省“海峡杯”工业设计大赛优秀奖第1位完成人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518286',1,'6',NULL,1,'近5年，省建筑行业岗位技能竞赛（省级一类赛）团体一等奖（含古建筑特色工种技能竞赛）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518287',1,'6',NULL,1,'近5年，省建筑行业岗位技能竞赛（省级一类赛）个人前三名选手（含古建筑特色工种技能竞赛）',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518288',1,'6',NULL,1,'近5年，获“泉州市技术能手”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518289',1,'6',NULL,1,'近5年，省、市优质工程奖“刺桐杯”、“闽江杯”及以上优质工程奖的项目负责人或项目经理、项目技术负责人、项目总监理工程师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518290',1,'6',NULL,1,'近5年，省外地级市及以上优质工程奖的项目负责人或项目经理、项目技术负责人、项目总监理工程师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518291',1,'6',NULL,1,'近5年，泉州市建筑企业优秀经理、优秀项目经理',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518292',1,'6',NULL,1,'近5年，获“县级技能大师”称号',5,1,1,'','',NULL,NULL,'2020-05-14 09:07:52','87'),('1196306282350518293',1,'6',NULL,1,'近5年，获“县级工匠”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518294',1,'6',NULL,1,'近5年，获“市级金牌工人”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518295',1,'6',NULL,1,'近5年，惠安国际雕刻艺术品博览会金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518296',1,'6',NULL,1,'近5年，“金凤凰”创新产品设计大奖赛金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518297',1,'6',NULL,1,'近5年，“何朝宗杯”中国（德化）陶瓷工业设计大赛银奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518298',1,'6',NULL,1,'近5年，“匠心杯”中国（安溪）藤铁工艺现场创作大赛银奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518299',1,'6',NULL,1,'近5年，海峡两岸（厦门）文化产业交易会（简称“厦门文博会”）“海峡工艺精品奖”银奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518300',1,'6',NULL,1,'近5年，海峡两岸（厦门）文化产业交易会（简称“厦门文博会”）“中华工艺优秀作品奖”金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518301',1,'6',NULL,1,'近5年，泉州市工艺美术创新设计“天工奖”大赛二等奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518302',1,'6',NULL,1,'近5年，中国“伞都杯”国际伞具创意设计大赛铜奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306282350518303',1,'6',NULL,1,'近5年，泉州市科普惠农兴村计划农村科普带头人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763458',1,'6',NULL,1,'近5年，获“泉州市优秀青年企业家”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763459',1,'6',NULL,1,'近5年，获“泉州市青年优秀人才”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763460',1,'6',NULL,1,'我市紧缺急需集成电路人才：在全球前25大半导体公司技术研发、工程部门、管理部门担任经理、功能主管、资深工程师、主任工程师或其他相应职务以上累计2年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763461',1,'6',NULL,1,'我市紧缺急需集成电路人才：在集成电路设计、制造、集成器件制造（IDM）、封测、装备等领域全球前10大公司技术研发、工程部门、管理部门担任经理、功能主管、资深工程师、主任工程师或其他相应职务以上累计3年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763462',1,'6',NULL,1,'我市紧缺急需集成电路人才：在集成电路设计、制造、封测等领域大陆或台湾前10大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计3年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763463',1,'6',NULL,1,'我市紧缺急需集成电路人才：在集成电路材料（硅片、光罩材料等）、电子设计自动化（EDA）工具软件、硅智财（SIP）全球前5大公司技术研发、工程部门、管理部门担任经理、功能主管、资深工程师、主任工程师或其他相应职务以上累计3年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763464',1,'6',NULL,1,'我市紧缺急需半导体人才：在国家重点扶持或鼓励的光电企业或集成电路企业担任二级及以上部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763465',1,'6',NULL,1,'我市紧缺急需半导体人才：在高新技术企业担任二级科研、技术、工程等部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763466',1,'6',NULL,1,'我市紧缺急需半导体人才：从中国境外引进的光电企业或集成电路企业担任一级部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763467',1,'6',NULL,1,'我市紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物领域等全球前10大公司担任技术、研发、工程等部门经理、功能主管、资深工程师、主任工程师或其他相应职务以上累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763468',1,'6',NULL,1,'我市紧缺急需光电人才：在LED衬底、芯片、封装、应用或光生物领域等大陆或台湾前10大公司担任二级科研、技术、工程等部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763469',1,'6',NULL,1,'第六层次其他由企事业等用人单位根据人才对本单位贡献情况提出，与本层次其他人才标准相当的人才',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763470',1,'7',NULL,1,'近5年，“石狮杯”全国高校毕业生服装设计大赛银、铜奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763471',1,'7',NULL,1,'近5年，福建文创奖银奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763472',1,'7',NULL,1,'近5年，福建省工艺美术“争艳杯”铜奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763473',1,'7',NULL,1,'近5年，泉州市工艺美术创新设计“天工奖”大赛三等奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763474',1,'7',NULL,1,'近5年，“何朝宗杯”中国（德化）陶瓷工业设计大赛铜奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763475',1,'7',NULL,1,'近5年，“匠心杯”中国（安溪）藤铁工艺现场创作大赛铜奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763476',1,'7',NULL,1,'近5年，县级工艺美术大师',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763477',1,'7',NULL,1,'近5年，县级非物质文化遗产代表性项目代表传承人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763478',1,'7',NULL,1,'近5年，获“县级金牌工人”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763479',1,'7',NULL,1,'近5年，获“县级技术能手”称号',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763480',1,'7',NULL,1,'近5年，“大地奖”陶瓷作品大赛金奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763481',1,'7',NULL,1,'近5年，惠安国际雕刻艺术品博览会银奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763482',1,'7',NULL,1,'近5年，海峡两岸（厦门）文化产业交易会（简称“厦门文博会”）“海峡工艺精品奖”铜奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763483',1,'7',NULL,1,'近5年，海峡两岸（厦门）文化产业交易会（简称“厦门文博会”）“中华工艺优秀作品奖”银、铜奖获得者',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763484',1,'7',NULL,1,'“八大美院”（中央美术学院、中国美术学院、鲁迅美术学院、广州美术学院、四川美术学院、西安美术学院、天津美术学院、湖北美术学院）和景德镇陶瓷大学陶瓷美术学院全日制本科毕业生，来泉后从事专业相关工作1年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763485',1,'7',NULL,1,'“八大纺织服装高校”（东华大学、天津工业大学、北京服装学院、苏州大学、西安工程大学、浙江理工大学、武汉纺织大学、中原工学院）及江西服装学院全日制本科毕业生，来泉后从事专业相关工作1年以上者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306287471763486',1,'7',NULL,1,'我市紧缺急需集成电路人才：在国家鼓励的集成电路企业担任一级部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2年以上者',0,2,1,NULL,'2',NULL,NULL,NULL,NULL),('1196306287471763487',1,'7',NULL,1,'我市紧缺急需半导体人才：在大陆或台湾光电或集成电路企业中担任二级科研、技术、工程等部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计满2年者',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1196306292534288385',1,'7',NULL,1,'我市紧缺急需文化创意人才：近5年，担任县级创意产业（文化创意）单位或县级文化创意产业示范（基地）负责人',5,1,1,NULL,'',NULL,NULL,NULL,NULL),('1196306292534288386',1,'7',NULL,1,'第七层次由企事业等用人单位根据人才对本单位贡献情况提出，与本层次其他人才标准相当的人才',0,2,1,'','',NULL,NULL,'2020-05-12 10:31:04','87'),('1196308533672550402',3,'2',NULL,1,'近10年，获得福建省“海峡杯”工业设计大赛特别奖的第一设计师',10,1,1,'1196327814145646594,','',NULL,NULL,'2019-11-18 15:43:49','1'),('1196308533672550403',3,'3',NULL,1,'近5年，入选全国专业社会工作领军人才者',5,1,1,'1196327955313336322,','',NULL,NULL,'2019-11-18 15:51:34','1'),('1196308533672550404',3,'3',NULL,1,'近5年，获得由中宣部、中央网信办、国家广播电视总局、中国记协主办的“好记者讲好故事”演讲活动十佳选手',5,1,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2019-11-18 15:53:25','1'),('1196308533672550405',3,'4',NULL,1,'近10年，获得“海峡杯”创业创新大赛一等奖入选项目的第一负责人',10,1,1,'1210488527915302913','',NULL,NULL,'2020-06-29 18:14:23','87'),('1196308533672550406',3,'4',NULL,1,'近5年，获得由中宣部、中央网信办、国家广播电视总局、中国记协主办的“好记者讲好故事”演讲活动优胜选手',5,1,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2019-11-18 15:53:50','1'),('1196308533672550407',3,'4',NULL,1,'晋江市博士后科研工作站在站博士后',0,2,1,'1196328965217853442,','',NULL,NULL,'2019-11-18 15:56:17','1'),('1196308533672550408',3,'5',NULL,1,'近10年，获得“海峡杯”创业创新大赛二等奖入选项目的第一负责人',10,1,1,'1210488527915302913','',NULL,NULL,'2020-06-30 08:21:51','87'),('1196308533672550409',3,'5',NULL,1,'近5年，获得由中宣部、中央网信办、国家广播电视总局、中国记协主办的“好记者讲好故事”演讲活动优秀选手',5,1,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2019-11-18 15:54:56','1'),('1196308533672550410',3,'5',NULL,1,'省委宣传部、省新闻工作者协会主办的福建省新闻战线“好记者讲好故事”演讲比赛金奖获得者',0,2,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2020-03-04 18:15:32','87'),('1196308533672550411',3,'5',NULL,1,'省级新闻奖一等奖第1位完成人',0,2,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2020-03-04 18:15:37','87'),('1196308533672550412',3,'6',NULL,1,'取得全日制硕士学位者',0,2,1,'1196331850672513026,','',NULL,NULL,'2019-11-18 15:59:26','1'),('1196308533672550413',3,'6',NULL,1,'近5年，晋江市专利金奖第1位专利发明人或设计人',5,1,1,'1210488645792022529,','',NULL,NULL,'2020-03-04 17:26:14','58'),('1196308533672550414',3,'6',NULL,1,'近5年，福建省戏剧会演单项奖（含戏曲、话剧、歌剧、舞剧、音乐剧、木偶剧、杂技、曲艺等）的主要作者（含编剧、导演）和主要演员前2名',5,1,1,'1196332086363037697,','',NULL,NULL,'2019-11-18 16:06:27','1'),('1196308533672550415',3,'6',NULL,1,'近5年，省委宣传部、省新闻工作者协会主办的福建省新闻战线“好记者讲好故事”演讲比赛银奖获得者',5,1,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2020-03-04 18:15:43','87'),('1196308533672550416',3,'6',NULL,1,'近5年，获“泉州市十佳新闻工作者”称号',5,1,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2020-03-04 18:15:48','87'),('1196308533672550417',3,'6',NULL,1,'近5年，获“地市级技术能手”称号',5,1,1,'1196332264142807042,','',NULL,NULL,'2019-11-18 16:04:10','1'),('1196308533672550418',3,'6',NULL,1,'近5年，受聘于我市社工机构的高级社会工作师',5,1,1,'1196327955313336322,','',NULL,NULL,'2019-11-18 16:05:27','1'),('1196308533672550419',3,'6',NULL,1,'近10年，获得“海峡杯”创业创新大赛三等奖入选项目的第一负责人',10,1,1,'1210488527915302913','',NULL,NULL,'2020-06-30 08:22:05','87'),('1196308533672550420',3,'6',NULL,1,'近5年，直接培训出获得福建省运会（青少年部）第一、二、三名的主教练员',5,1,1,'1196332383294595073,','',NULL,NULL,'2019-11-18 16:13:47','1'),('1196308533672550421',3,'6',NULL,1,'近5年，泉州市确认由晋江市输送并代表泉州市参赛，获得福建省锦标赛第一、二、三名的主教练员',5,1,1,'1196332383294595073,','',NULL,NULL,'2019-11-18 16:13:11','1'),('1196308533672550422',3,'6',NULL,1,'直接培训出获得全国少儿锦标赛前六名，并向福建省体校输送两名运动员，具备中级专业技术职务资格的教练员',0,2,1,'1196332383294595073,','',NULL,NULL,'2019-11-18 16:12:49','1'),('1196308533672550423',3,'6',NULL,1,'省级新闻奖一等奖第2位完成人、二等奖第1位完成人',0,2,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2020-03-04 18:15:51','87'),('1196308533672550424',3,'7',NULL,1,'近5年，晋江市专利银奖第1位专利发明人或设计人',5,1,1,'1210488645792022529,','',NULL,NULL,'2020-03-04 17:26:31','58'),('1196308533672550425',3,'7',NULL,1,'近5年，泉州市刺桐文艺奖单项奖（含子项5个：文艺类图书、电影、电视剧片、戏剧、歌曲）主要作者（含编剧、导演）和主要演员前2名',5,1,1,'1196328018018181122,1196332086363037697,','',NULL,NULL,'2020-03-04 17:30:08','58'),('1196308533672550426',3,'7',NULL,1,'近5年，直接培训出获得福建省运会（青少年部）第四、五、六名的主教练员',5,1,1,'1196332383294595073,','',NULL,NULL,'2019-11-18 16:07:57','1'),('1196308533672550427',3,'7',NULL,1,'近5年，经泉州市确认由晋江市输送并代表泉州市参赛，获得福建省锦标赛第四、五、六名的主教练员',5,1,1,'1196332383294595073,','',NULL,NULL,'2019-11-18 16:11:20','1'),('1196308533672550428',3,'7',NULL,1,'省级新闻奖二等奖第2位完成人、三等奖第1位完成人',0,2,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2020-03-04 18:15:55','87'),('1196308533672550429',3,'7',NULL,1,'地级市级广播电视艺术奖一等奖获得者第1位完成人',0,2,1,'1196328018018181122,1196328242593800193,','',NULL,NULL,'2020-03-04 17:22:37','58'),('1199492454388330497',NULL,'1',NULL,2,'（一）国际顶级知名奖项获得者：诺贝尔奖、中国国家最高科学技术奖、美国国家科学奖章（总统科学奖）、美国国家技术创新奖章、法国全国科研中心科研奖章、英国皇家金质奖章、科普利奖章、图灵奖、菲尔兹奖、沃尔夫奖、阿贝尔奖、克拉福德奖、日本国际奖、京都奖、邵逸夫奖；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330498',NULL,'1',NULL,2,'（二）国际电气和电子工程师协会（IEEE）奖章获得者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330499',NULL,'1',NULL,2,'（三）国际电气和电子工程师协会会士（IEEE Fellow）、国际计算机学会会士（ACM Fellow）、国际工程技术学会会士（IET Fellow）、美国物理学会会士（APS Fellow）；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330500',NULL,'1',NULL,2,'（四）美国工程界三大最高奖项：德雷铂奖（Charles Stark Draper Prize）、拉斯奖（Fritz J. and Dolores H. Russ Prize）、戈登奖（Bernard M. Gordon Prize）获得者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330501',NULL,'1',NULL,2,'（五）中国、美国、英国、德国、法国、日本、意大利、加拿大、瑞典、丹麦、挪威、芬兰、比利时、瑞士、奥地利、荷兰、西班牙、澳大利亚、新西兰、俄罗斯、以色列、印度、乌克兰、新加坡、韩国等的科学院院士、工程院院士（即成员member或高级成员fellow，见中国科学院国际合作局网站http://www.bic.cas.cn），台湾中央研究院院士；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330502',NULL,'1',NULL,2,'（六）国家“千人计划”创新人才长期项目、创业人才项目、外国专家项目、顶尖人才与创新团队项目的入选者、国家“万人计划”杰出人才；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330503',NULL,'1',NULL,2,'（七）中华人民共和国国际科学技术合作奖获得者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330504',NULL,'1',NULL,2,'（八）中国机械工程学会科技成就奖、青年科技成就奖获得者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330505',NULL,'1',NULL,2,'（九）中国机械工业科学技术奖特等奖前3位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330506',NULL,'1',NULL,2,'（十）近10年，获得以下奖项之一者：\n1. 国家自然科学奖、技术发明奖一等奖前3位完成人，国家科技进步奖特等奖前5位完成人，国家科技进步奖一等奖前3位完成人，省科学技术奖重大贡献奖获得者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330507',NULL,'1',NULL,2,'（十）近10年，获得以下奖项之一者：2. 中国青年科学家奖；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330508',NULL,'1',NULL,2,'（十）近10年，获得以下奖项之一者：3. 长江学者成就奖。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330509',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：1. 国家科技重大专项专家组组长，且项目（课题）通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330510',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：2. 国家科技支撑（攻关）计划项目负责人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330511',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：3. 国家重点研发计划重点专项项目组负责人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330512',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：4. 国家“973计划”项目首席科学家；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330513',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：5. 国家“863计划”领域主题专家组组长；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330514',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：6. 国家级人工智能或机器人领域大赛专家组组长；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330515',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：7. 国家重点学科、重点实验室、国家级企业技术中心、工程技术研究中心首席专家、国家制造业创新中心技术委员会主任，且年薪高于6倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330516',NULL,'1',NULL,2,'（十一）近10年，担任以下职务之一者：8. 八国集团成员国（美国、英国、德国、法国、日本、意大利、加拿大、俄罗斯）国家级重大科技计划项目负责人或首席科学家。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330517',NULL,'1',NULL,2,'（十二）近10年，在《Nature》、《Science》或《Reviews of Modern Physics》杂志上以第一作者或通讯作者发表集成电路相关论文者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330518',NULL,'1',NULL,2,'（十三）在全球前25大半导体公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330519',NULL,'1',NULL,2,'（十四）近10年，担任过世界500强企业及中国50强企业总部董事长（或总裁）、首席执行官、首席技术官（技术研发部门第一负责人）、首席设计官（工艺设计部门第一负责人）、首席质量官。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330520',NULL,'2',NULL,2,'（一）国际电气和电子工程师协会（IEEE）技术奖获得者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330521',NULL,'2',NULL,2,'（二）国家“千人计划”创新人才短期项目、青年项目、新疆西藏项目入选者；国家“万人计划”领军人才（包括科技创新领军人才、科技创业领军人才和百千万工程领军人才）、国家“万人计划”青年拔尖人才、“新世纪百千万人才工程”国家级人选、国家有突出贡献的中青年专家、全国杰出专业技术人才；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330522',NULL,'2',NULL,2,'（三）国家杰出青年基金获得者、中国青年科技奖获得者、中国青年女科学家奖、享受国务院政府特殊津贴人员、全国优秀科技工作者、福建省引才“百人计划”入选者（含团队带头人）、福建省引进台湾高层次人才“百人计划”入选者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330523',NULL,'2',NULL,2,'（四）中国机械工业科学技术奖一等奖前2位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330524',NULL,'2',NULL,2,'（五）近10年，获得以下奖项之一者：1. 国家自然科学奖、技术发明奖二等奖前3位完成人，国家科技进步奖二等奖第1完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330525',NULL,'2',NULL,2,'（五）近10年，获得以下奖项之一者：2. 国际发明展览会金奖第1完成人，同时是国家科技进步奖二等奖第2、3完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330526',NULL,'2',NULL,2,'（五）近10年，获得以下奖项之一者：3. 中国专利金奖前3位专利发明人（设计人）；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492454388330527',NULL,'2',NULL,2,'（五）近10年，获得以下奖项之一者：4. 全国科技工作者创新创业大赛金奖项目前3位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885761',NULL,'2',NULL,2,'（五）近10年，获得以下奖项之一者：5. 美国、英国、德国、法国、日本、意大利、加拿大科学基金杰出青年类资助奖之一者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885762',NULL,'2',NULL,2,'（五）近10年，获得以下奖项之一者：6. 全国质量奖个人奖（中国杰出质量人）；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885763',NULL,'2',NULL,2,'（五）近10年，获得以下奖项之一者：7. 泉州杰出人才奖。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885764',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：1. 国家科技重大专项专家组副组长、项目（课题）组长，且项目（课题）通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885765',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：2. 国家重点研发计划重点专项项目组副组长；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885766',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：3. 国家“973计划”项目承担研究任务的项目专家组成员；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885767',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：4. 国家“863计划”领域主题专家组副组长、召集人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885768',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：5. 国家自然科学基金重大项目资助的项目主持人、国家自然科学基金创新研究群体项目的项目负责人、国家重大科研仪器研制项目的项目负责人，且项目已结题；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885769',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：6. 国家实验室主任、学术委员会主任，国家重点实验室主任、学术委员会主任，国家工程实验室主任、国家工程研究中心主任、国家工程技术研究中心主任、国家能源研发（实验）中心主任、国家级质检中心主任，且年薪高于6倍以上；国家制造业创新中心技术委员会副主任，且年薪高于4倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885770',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：7. 八国集团成员国（美国、英国、德国、法国、日本、意大利、加拿大、俄罗斯）国立研究所所长、副所长、首席研究员或国家实验室主任、副主任、首席研究员；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885771',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：8. 国际著名学术组织副主席、国际标准化组织（ISO）标样委员会委员；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885772',NULL,'2',NULL,2,'（六）近10年，担任以下职务之一者：9. 国际高水平科技期刊（《期刊分区》一、二区）正、副总编（主编）。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885773',NULL,'2',NULL,2,'（七）在全球前25大半导体公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885774',NULL,'2',NULL,2,'（八）在集成电路设计、制造、集成器件制造（IDM）、封测、装备等领域全球前10大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885775',NULL,'2',NULL,2,'（九）在集成电路材料、电子设计自动化（EDA）工具软件、硅智财（SIP）全球前5大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者;',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885776',NULL,'2',NULL,2,'（十）担任过世界500强企业及中国50强企业总部副董事长、副总裁、副总经理或总部直属一级子公司（大洲级区域部门）主要负责人3年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885777',NULL,'2',NULL,2,'（十一）在世界大学排名前200名的学校获评教授，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885778',NULL,'2',NULL,2,'（十二）“长江学者奖励计划”特聘教授、讲座教授，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885779',NULL,'2',NULL,2,'（十三）取得“985工程”高校和中国科学院大学博士研究生导师资格3年以上且取得正高级专业技术职务者，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885780',NULL,'2',NULL,2,'（十四）获得全国集成电路“创业之芯”大赛特等奖项目的第1负责人。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885781',NULL,'3',NULL,2,'（一）科技部创新人才推进计划入选者、国家产业技术体系岗位专家、“新世纪百千万人才工程”省级人选、省部级有突出贡献的中青年专家、省（含副省级市）级以上优秀专家、省特支人才“双百计划”、省产业人才高地领军人才、省杰出青年科学基金获得者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885782',NULL,'3',NULL,2,'（二）中国机械工业科学技术奖二等奖第1位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885783',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：1. 国家科技进步奖二等奖第2、3位完成人，省科学技术突出贡献奖，省级科学技术进步奖、技术发明奖、自然科学奖一等奖前3位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885784',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：2. 国际发明展览会金奖第2、3完成人或国际发明展览会银奖第1完成人，且同时符合以下条件之一：①省科技进步奖二等奖前3位完成人及以上，②取得正高级专业技术资格，③取得博士学历；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885785',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：3. 中国专利优秀奖；省级专利金奖或特等奖、一等奖；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885786',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：4. 中国人民解放军科学技术进步奖一等奖前3位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885787',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：5. 全国科技工作者创新创业大赛银奖项目前3位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885788',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：6. 国家部委主办的创新创业大赛行业总决赛特等奖的获奖项目核心团队前3位完成人，国家部委主办的创新创业大赛行业总决赛一等奖的获奖项目核心团队第1负责人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885789',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：7. 台湾工业总会、商业总会、工商协进会、中小企业总会、工业协进会、电电公会等六大工商团体评选或授予的最高奖项（行业公认奖项）；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492458544885790',NULL,'3',NULL,2,'（三）近10年，获得以下奖项之一者：8. 中国科学院“百人计划”入选者。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422658',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：1. 国家科技重大专项专家组成员、项目（课题）第1副组长、分课题组长，且项目（课题）通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422659',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：2. 国家科技支撑（攻关）计划课题第1负责人且课题通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422660',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：3. 国家重点研发计划重点专项任务（或课题）负责人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422661',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：4. 国家“973计划”项目首席科学家助理、课题组第1负责人，且课题通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422662',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：5. 国家“863计划”主题项目或重大项目首席专家，且项目通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422663',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：6. 国家“863计划”专题组组长、副组长，且专题通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422664',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：7. “国家软科学研究计划”重大项目第1负责人且项目通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422665',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：8. 科技部国际科技合作计划项目中方项目第1负责人且项目通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422666',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：9. 国家自然科学基金的重点项目、重大研究计划项目、重点国际（地区）合作研究项目、组织间国际（地区）合作与交流项目、联合基金或优秀青年科学基金项目资助的项目总负责人（不含子项目），且项目通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422667',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：10. 国家重点实验室、国家工程实验室、国家级企业技术中心、国家工程研究中心、国家工程技术研究中心、国家能源研发（实验）中心、国家级质检中心前2位副主任或工程学术（技术）委员会主任、国家能源研发（实验）中心学术委员会主任，且年薪高于4倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422668',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：11. 全国专业标准化技术委员会副主任委员；参与国家标准制（修）订排名第2位起草人；行业标准制（修）订排名第1位起草人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422669',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：12. “闽江学者”特聘教授、“桐江学者”特聘教授入选者，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422670',NULL,'3',NULL,2,'（四）近5年，担任以下职务之一者：13. 高等院校国家重点学科带头人、国家精品课程负责人、教育部“211工程”高校国家重点学科博士生导师，并从事集成电路相关研究或教学者。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422671',NULL,'3',NULL,2,'（五）在全球前25大半导体公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422672',NULL,'3',NULL,2,'（六）在集成电路设计、制造、集成器件制造（IDM）、封测、装备等领域全球前10大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422673',NULL,'3',NULL,2,'（七）在集成电路材料、电子设计自动化（EDA）工具软件、硅智财（SIP）全球前5大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422674',NULL,'3',NULL,2,'（八）在集成电路设计、制造、封测等领域大陆或台湾前10大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422675',NULL,'3',NULL,2,'（九）在集成电路装备、材料等领域大陆或台湾前5大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422676',NULL,'3',NULL,2,'（十）担任过世界500强企业及中国50强企业总部副董事长、副总裁、副总经理或总部直属一级子公司（大洲级区域部门）主要负责人1年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422677',NULL,'3',NULL,2,'（十一）在世界大学排名前200名的学校获评副教授，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422678',NULL,'3',NULL,2,'（十二）在世界大学排名201-500名的学校获评教授，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422679',NULL,'3',NULL,2,'（十三）取得“985工程”高校和中国科学院大学硕士研究生导师资格3年以上且取得正高级专业技术职务任职资格，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422680',NULL,'3',NULL,2,'（十四）取得博士学位，且近5年在期刊分区表中列入大类一区的学术期刊上以第一作者或通讯作者发表2篇以上集成电路相关论文者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422681',NULL,'3',NULL,2,'（十五）获得全国集成电路“创业之芯”大赛一等奖项目的第1负责人。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422682',NULL,'4',NULL,2,'（一）国际电气和电子工程师协会（IEEE）、国际计算机学会（ACM）、 国际工程技术学会（IET）、美国物理学会（APS）等国际知名学会高级会员或资深会员；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422683',NULL,'4',NULL,2,'（二）中国机械工业科学技术奖三等奖第1位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422684',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：1. 省级科学技术进步奖、技术发明奖、自然科学奖二等奖前3位完成人、三等奖第1位完成人，地市级科学技术奖一等奖前3位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422685',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：2. 国际发明展览会银奖第2、3完成人或国际发明展览会铜奖第1完成人，且同时符合以下条件之一：①省科技进步奖三等奖前3位完成人及以上， ②取得副高级以上专业技术职务任职资格，③取得国家一级职业资格；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422686',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：3. 省级专利二、三等奖前3位专利发明人（设计人），地市级专利金奖或一等奖前3位专利发明人或设计人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492462420422687',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：4. 中国人民解放军科学技术进步奖二等奖前3位完成人、三等奖第1位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988034',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：5. 全国科技工作者创新创业大赛铜奖项目前3位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988035',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：6. 国家部委主办的创新创业大赛行业总决赛二、三等奖的获奖项目核心团队的第1负责人，获得福建省创新创业大赛总决赛一等奖的获奖项目核心团队的第1负责人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988036',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：7. 福建青年科技奖；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988037',NULL,'4',NULL,2,'（三）近5年，获得以下项目之一者：8. 福建省优秀科技工作者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988038',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：1. 国家科技重大专项分课题前2位副组长，且项目（课题）通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988039',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：2. 国家科技支撑（攻关）计划课题第2、3负责人，且课题通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988040',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：3. 国家重点研发计划专题负责人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988041',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：4. 国家“973计划”课题组第2、3负责人，且课题通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988042',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：5. 国家“863计划”课题组组长、副组长，子课题负责人，且课题通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988043',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：6. “国家软科学研究计划”面上项目第1负责人，且课题通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988044',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：7. 科技部国际科技合作计划项目中方主要参加人员前3位，且完成项目通过验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988045',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：8.国家自然科学基金年度项目、青年科学基金项目资助的项目第1负责人，且项目通过结题验收；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988046',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：9. 省部级工程实验室主任、学术委员会主任，省部级（重点）实验室主任、学术委员会主任，省部级工程研究中心主任、省级企业技术中心主任、省级制造业创新中心技术委员会主任，且年薪高于4倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988047',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：10. 全国专业标准化技术委员会分技术委员会主任委员；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988048',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：11. 国家级服务型制造示范企业、国家级服务型制造示范项目实施主体企业总经理，国家级服务型制造示范平台负责人、省级服务型制造公共服务平台负责人，省级中小企业公共服务示范平台运营负责人、省级小微企业创业创新示范基地运营负责人，且年薪高于4倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988049',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：12. 教育部“211工程”高校国家重点学科教授或研究员，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988050',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：13. 福建省高校新世纪优秀人才计划入选者，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988051',NULL,'4',NULL,2,'（四）近5年，担任以下职务之一者：14.“省级制造业单项冠军产品”第1研发人员。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988052',NULL,'4',NULL,2,'（五）在全球前25大半导体公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988053',NULL,'4',NULL,2,'（六）在集成电路设计、制造、集成器件制造（IDM）、封测、装备等领域全球前10大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988054',NULL,'4',NULL,2,'（七）在集成电路材料、电子设计自动化（EDA）工具软件、硅智财（SIP）全球前5大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988055',NULL,'4',NULL,2,'（八）在集成电路设计、制造、封测等领域大陆或台湾前10大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988056',NULL,'4',NULL,2,'（九）在集成电路装备、材料等领域大陆或台湾前5大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988057',NULL,'4',NULL,2,'（十）担任过世界500强企业或中国50强总部一级部门负责人或与之级别相当的专业技术人员、总部直属一级子公司（大洲级区域部门）副总或与之级别相当的专业技术人员等职务3年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988058',NULL,'4',NULL,2,'（十一）取得“985工程”高校和中国科学院大学硕士研究生导师资格3年以上且取得副高级专业技术职务任职资格，并从事集成电路相关研究或教学者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988059',NULL,'4',NULL,2,'（十二）博士后出站留（来）晋江创业或工作者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988060',NULL,'4',NULL,2,'（十三）晋江市博士后科研工作站在站博士后；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988061',NULL,'4',NULL,2,'（十四）取得世界大学排名前200名学校的博士学位，所学专业学科门类为理学、工学，且从事集成电路科研、技术、工程相关工作者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988062',NULL,'4',NULL,2,'（十五）取得正高级专业技术职务任职资格者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492466274988063',NULL,'4',NULL,2,'（十六）获得全国集成电路“创业之芯”大赛二等奖项目的第1负责人。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776194',NULL,'5',NULL,2,'（一）近5年，获得以下奖项之一者：1. 省级科学技术进步奖、技术发明奖、自然科学奖三等奖第2、3位完成人，地市级科学技术奖二等奖前2位完成人、三等奖第1位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776195',NULL,'5',NULL,2,'（一）近5年，获得以下奖项之一者：2. 国际发明展览会铜奖第2、3完成人，且同时符合以下条件之一：①地市级科技进步奖三等奖前3位完成人及以上，②取得副高级以上专业技术任职资格，③取得国家一级以上职业资格；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776196',NULL,'5',NULL,2,'（一）近5年，获得以下奖项之一者：3. 地市级专利银奖、优秀奖或二、三等奖前3位专利发明人或设计人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776197',NULL,'5',NULL,2,'（一）近5年，获得以下奖项之一者：4. 中国人民解放军科学技术进步奖三等奖第2位完成人；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776198',NULL,'5',NULL,2,'（一）近5年，获得以下奖项之一者：5. 福建省创新创业大赛总决赛二等奖的获奖项目核心团队的第1负责人。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776199',NULL,'5',NULL,2,'（二）近5年，担任以下职务之一者：1. 省部级（重点）实验室、学术委员会、省部级工程实验室、省部级工程研究中心、省级企业技术中心、省级制造业创新中心技术委员会副主任，且年薪高于2倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776200',NULL,'5',NULL,2,'（二）近5年，担任以下职务之一者：2. 全国专业标准化技术委员会分技术委员会副主任委员；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776201',NULL,'5',NULL,2,'（二）近5年，担任以下职务之一者：3. 担任国家级服务型制造示范企业、国家级服务型制造示范项目实施主体企业、省级服务型制造示范企业总经理，省级服务型制造示范平台负责人，且年薪高于2倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776202',NULL,'5',NULL,2,'（二）近5年，担任以下职务之一者：4. 省级学科（教学）、专业带头人，并从事集成电路相关研究或教学者；省级精品在线开放课程、共享课程负责人且项目通过验收，并从事集成电路相关研究或教学者。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776203',NULL,'5',NULL,2,'（三）在集成电路设计、制造、集成器件制造（IDM）、封测、装备等领域全球前10大公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776204',NULL,'5',NULL,2,'（四）在集成电路材料、电子设计自动化（EDA）工具软件、硅智财（SIP）全球前5大公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776205',NULL,'5',NULL,2,'（五）在集成电路设计、制造、封测等领域大陆或台湾前10大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776206',NULL,'5',NULL,2,'（六）在集成电路装备、材料等领域大陆或台湾前5大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776207',NULL,'5',NULL,2,'（七）取得国家一级职业资格的技术类人员或经全国统考取得国家最高等级职业资格的管理类人员，且从事职业资格所在领域工作2年以上，年薪高于2倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776208',NULL,'5',NULL,2,'（八）取得博士学位者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776209',NULL,'5',NULL,2,'（九）取得世界大学排名前200名学校的硕士学位，所学专业学科门类为理学、工学或相关国家部委支持（筹备）建设示范性微电子学院的硕士学位，且从事集成电路科研、技术、工程相关工作者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776210',NULL,'5',NULL,2,'（十）取得副高级专业技术职务任职资格者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776211',NULL,'5',NULL,2,'（十一）获得全国集成电路“创业之芯”大赛三等奖项目的第1负责人。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776212',NULL,'6',NULL,2,'（一）在国家鼓励的集成电路企业担任一级部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计5年以上者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776213',NULL,'6',NULL,2,'（二）取得国家一级职业资格的技术类人员或经全国统考取得国家最高等级职业资格的管理类人员，且从事职业资格所在领域工作2年以上，年薪高于1倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776214',NULL,'6',NULL,2,'（三）取得全日制硕士研究生学位；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776215',NULL,'6',NULL,2,'（四）取得非全日制硕士研究生学位，所学专业学科门类为理学、工学，且从事集成电路科研、技术、工程相关工作者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776216',NULL,'6',NULL,2,'（五）取得世界大学排名前500名学校的学士学位，所学专业学科门类为理学、工学，且从事集成电路科研、技术、工程相关工作者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776217',NULL,'6',NULL,2,'（六）取得“985工程”高校、中国科学院大学的理学、工学学士学位，且从事集成电路科研、技术、工程相关工作者；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776218',NULL,'6',NULL,2,'（七）取得相关国家部委支持（筹备）建设示范性微电子学院的学士学位，且从事集成电路科研、技术、工程相关工作者。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776219',NULL,'7',NULL,2,'（一）取得国家二级职业资格的技术类人员或经全国统考取得国家二级职业资格的管理类人员，且从事职业资格所在专业领域工作2年以上，年薪高于1.5倍以上；',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1199492470112776220',NULL,'7',NULL,2,'（二）取得国家相关部委发布的“双一流”建设学科名单所属学科的理学、工学学士学位，且从事集成电路科研、技术、工程相关工作者。',0,2,1,NULL,'',NULL,NULL,NULL,NULL),('1212899592484491266',1,'6',NULL,1,'取得国家一级职业资格或经全国统考取得国家最高等级职业资格，且从事职业资格所在专业领域工作2年以上、年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格进行执业注册，工作单位属企业性质的按1.5倍以上标准确定，除企业以外的按1倍以上标准确定）。',0,2,1,'','','2020-01-03 08:52:52','87',NULL,NULL),('1212900080936357890',1,'7',NULL,1,'取得国家二级职业资格的技术类人员或经全国统考取得国家二级职业资格的技术类或管理类人员，且从事职业资格所在专业领域工作2年以上、年薪高于相应倍数以上的技术类或管理类人员（准入类职业资格进行执业注册，工作单位属企业性质的按1.5倍以上标准确定，除企业以外的按1倍以上标准确定）。',0,2,1,'','','2020-01-03 08:54:48','87',NULL,NULL),('1213018206369812482',1,'6',NULL,1,'近5年，在我市信息技术、智能制造、电子信息、纺织鞋服、机械汽配、文化创意、光电信息、信息技术、光生物、智能制造、金融等行业领域从事相关工作，在企业担任高管或技术负责人，且年薪高于2.5倍以上',5,1,1,'','','2020-01-03 16:44:11','87',NULL,NULL),('1214084381191196673',1,'7',NULL,1,'我市紧缺电子商务人才，具有下述2年以上岗位经历者：所在电子商务企业年交易额1亿元以上（含1亿元，以纳入政府统计一套表联网直报平台的数据为准）或年营业收入500万元以上（含500万元，以审计报告数据为准），且年薪高于1.5倍以上的高层管理人员或与之级别相当的专业技术人员、设计人员、营销人员（提供劳动合同及社会保险参保缴费明细）',0,2,1,'','','2020-01-06 15:20:47','87','2020-01-06 15:36:51','87'),('1214088242635231234',1,'7',NULL,1,'我市紧缺电子商务人才，具有下述2年以上岗位经验者：所在企业为市级以上电子商务示范企业、电商十佳企业，且年薪高于1.5倍以上的高层管理人员或与之级别相当的专业技术人员、专业设计人员、专业营销人员（提供劳动合同及社会保险参保缴费明细）。',0,2,1,'','','2020-01-06 15:36:08','87',NULL,NULL),('1214111895934488577',1,'6',NULL,1,'曾在国内4A及以上景区担任副总经理及以上职务累计在5年以上，且年薪高于2倍以上',0,2,1,'','','2020-01-06 17:10:07','87',NULL,NULL),('1214112163694661634',1,'6',NULL,1,'曾在国家文旅局（国家文化和旅游部）最新公布（以提出申请的时间确定）的百强旅行社中旅行社担任部门经理及以上管理人员，具备5年以上旅行社从业经历，且年薪高于2倍以上',0,2,1,'','','2020-01-06 17:11:11','87',NULL,NULL),('1214112341570899970',1,'6',NULL,1,'近5年，取得国家级“双一流”高校（学科）或原“985工程”、“211工程”大学的理学、工学学士学位，来泉后从事信息技术、智能制造、电子信息、纺织鞋服、机械汽配、石材加工、水暖厨卫等相关行业工作，且年薪高于2倍以上',5,1,1,'','','2020-01-06 17:11:54','87',NULL,NULL),('1214113774265454593',1,'6',NULL,1,'近5年，在我市工作，取得机械装备、水暖厨卫、石材加工、茶叶、家居工艺、制香、陶瓷、老醋、雕刻、纺织服装等特色产业工程系列中级及以上专业技术职务任职资格的人员，且年薪高于2倍以上',5,1,1,'','','2020-01-06 17:17:35','87',NULL,NULL),('1214113861079158785',1,'6',NULL,1,'近5年，获得福建省“清新福建金牌导游”称号，且年薪高于1.5倍以上',5,1,1,'','','2020-01-06 17:17:56','87',NULL,NULL),('1214113958277959681',1,'6',NULL,1,'近5年，获得福建省“清新福建金牌景区讲解员”称号，且年薪高于1.5倍以上',5,1,1,'','','2020-01-06 17:18:19','87',NULL,NULL),('1214114156504961025',1,'6',NULL,1,'经全国统考取得国家中级及以上等级导游员资格的导游员，且年薪高于1.5倍以上',0,2,1,'','','2020-01-06 17:19:06','87',NULL,NULL),('1214114236440006658',1,'6',NULL,1,'近5年，创办的农场、合作社获县级表彰的大专及以上毕业生',5,1,1,'','','2020-01-06 17:19:25','87',NULL,NULL),('1214114347962355714',1,'6',NULL,1,'近5年，创办的农场、合作社列入市级龙头企业、市级示范农场、示范合作社的大专及以上毕业生',5,1,1,'','','2020-01-06 17:19:52','87',NULL,NULL),('1214115256754786305',1,'6',NULL,1,'我市紧缺急需集成电路人才：在国家知识产权优势企业担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2年以上者',0,2,1,'','','2020-01-06 17:23:29','87',NULL,NULL),('1214115389131214850',1,'6',NULL,1,'我市紧缺急需集成电路人才：从事集成电路科研、技术、工程相关工作者，且年薪高于2倍以上',0,2,1,'','','2020-01-06 17:24:00','87',NULL,NULL),('1214115508207505410',1,'6',NULL,1,'我市紧缺急需石油化工人才：原“985工程”高校、中国科学院大学本科毕业且取得中级专业技术职务任职资格且具有3年以上石油化工企业工作经历者',0,2,1,'','','2020-01-06 17:24:28','87',NULL,NULL),('1214115640126754818',1,'6',NULL,1,'我市紧缺急需石油化工人才：原“985工程”高校、中国科学院大学本科毕业且在近5年内以第一作者或通讯作者身份（含同等贡献）发表石油化工行业相关1篇中科院2区及以上SCI论文或2篇SCI论文者',5,1,1,'','','2020-01-06 17:25:00','87','2020-02-27 09:41:34','87'),('1214115763019862017',1,'6',NULL,1,'我市紧缺急需石油化工人才：原“985工程”高校、中国科学院大学本科毕业且在近5年内有2件授权发明专利者',5,1,1,'','','2020-01-06 17:25:29','87','2020-02-27 09:41:39','87'),('1214115896528752642',1,'6',NULL,1,'我市紧缺急需半导体人才：在知识产权优势企业担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2年以上者',0,2,1,'','','2020-01-06 17:26:01','87',NULL,NULL),('1214116104201326593',1,'6',NULL,1,'我市紧缺急需光电人才：在光电信息、光生物领域所属的企业中从事科研、技术、工程相关工作者，且年薪高于2倍以上',0,2,1,'','','2020-01-06 17:26:51','87',NULL,NULL),('1214116207838384130',1,'6',NULL,1,'我市紧缺急需文化创意人才：近5年来，取得本科以上学历，来泉后从事文化创意产业，在企业内任高级管理人员，且年薪高于2倍以上',5,1,1,'','','2020-01-06 17:27:15','87',NULL,NULL),('1214116313102831617',1,'6',NULL,1,'我市紧缺急需现代金融人才：近5年来，国家级“双一流”高校（学科）或原“985工程”、“211工程”大学的全日制本科金融类专业毕业并获经济学学士学位，来泉后从事银行、保险、证券、信托、期货、基金、消费金融、金融租赁、财务公司及小额贷款、典当、融资担保等工作，并取得中级专业技术职务任职资格，且年薪高于2倍以上',5,1,1,'','','2020-01-06 17:27:40','87',NULL,NULL),('1214116415070556161',1,'6',NULL,1,'我市紧缺急需现代金融人才：近5年来，在泉州各类金融机构县级支行（支公司）内任高级管理人员且年薪高于2倍以上',5,1,1,'','','2020-01-06 17:28:05','87',NULL,NULL),('1214116560860368898',1,'6',NULL,1,'我市紧缺急需电子商务人才：具有下述2年以上岗位经历者，所在电子商务企业年交易额1亿元以上（含1亿元，以纳入政府统计一套表联网直报平台的数据为准）或年营业收入500万元以上（含500万元，以审计报告数据为准），年薪高于2倍以上的高层管理人员或与之级别相当的专业技术人员、设计人员、营销人员（提供劳动合同及社会保险参保缴费明细）',0,2,1,'','','2020-01-06 17:28:39','87',NULL,NULL),('1214116707858141186',1,'6',NULL,1,'我市紧缺急需电子商务人才：具有下述2年以上岗位经历者，所在企业为市级以上电子商务示范企业、电商十佳企业，且年薪高于工资2倍以上的高层管理人员或与之级别相当的专业技术人员、专业设计人员、专业营销人员（提供劳动合同及社会保险参保缴费明细）',0,2,1,'','','2020-01-06 17:29:15','87',NULL,NULL),('1214117132573364226',1,'7',NULL,1,'近5年，取得大学的理学、工学学士学位，来泉后从事信息技术、智能制造、电子信息、纺织鞋服、机械汽配、石材加工、水暖厨卫等相关行业工作，在企业担任高管或技术负责人，且年薪高于1.5倍以上',5,1,1,'','','2020-01-06 17:30:56','87',NULL,NULL),('1214117217201836033',1,'7',NULL,1,'.近5年，取得农业系列中级专业技术任职资格的新型职业农民',5,1,1,'','','2020-01-06 17:31:16','87',NULL,NULL),('1214117310541877250',1,'7',NULL,1,'我市紧缺急需集成电路人才：在高新技术企业担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2年以上者',0,2,1,'','','2020-01-06 17:31:38','87',NULL,NULL),('1214117463491366914',1,'7',NULL,1,'我市紧缺急需集成电路人才：在省级知识产权优势企业担任一级科研、技术、工程等部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计2年以上者',0,2,1,'','','2020-01-06 17:32:15','87',NULL,NULL),('1214117557636714498',1,'7',NULL,1,'我市紧缺急需石油化工人才：原“211工程”高校、国家级“双一流”高校（学科）本科毕业且取得中级专业技术职务任职资格或普通高等院校本科毕业且有3年石油化工企业工作经历者',0,2,1,'','','2020-01-06 17:32:37','87',NULL,NULL),('1214117654671937538',1,'7',NULL,1,'我市紧缺急需石油化工人才：普通高等院校本科毕业且有3年石油化工企业工作经历者',0,2,1,'','','2020-01-06 17:33:00','87',NULL,NULL),('1214117759231741953',1,'7',NULL,1,'我市紧缺急需石油化工人才：原“985工程”高校、中国科学院大学本科毕业且在近5年内以第一作者或通讯作者身份（含同等贡献）发表石油化工行业相关1篇中科院3区及以上SCI论文',5,1,1,'','','2020-01-06 17:33:25','87',NULL,NULL),('1214117845177225218',1,'7',NULL,1,'我市紧缺急需石油化工人才：原“985工程”高校、中国科学院大学本科毕业且在近5年内获得1件授权发明专利或获得3件授权实用新型专利者',5,1,1,'','','2020-01-06 17:33:46','87',NULL,NULL),('1214118136219979778',1,'7',NULL,1,'我市紧缺急需石油化工人才：普通高等院校本科毕业且在近5年内以第一作者或通讯作者身份（含同等贡献）发表石油行业相关1篇中科院2区及以上SCI论文者',5,1,1,'','','2020-01-06 17:34:55','87',NULL,NULL),('1214118245439655937',1,'7',NULL,1,'我市紧缺急需半导体人才：取得全日制本科一批院校理学、工学专业学士学位，且从事集成电路科研、技术、工程相关工作者',0,2,1,'','','2020-01-06 17:35:21','87',NULL,NULL),('1214118359000436737',1,'7',NULL,1,'我市紧缺急需光电人才：取得全日制本科学历、学士学位，来泉后从事LED科研、技术、工程或光生物领域相关工作2年以上者',0,2,1,'','','2020-01-06 17:35:48','87',NULL,NULL),('1214118442399977474',1,'7',NULL,1,'我市紧缺急需光电人才：在光电信息、光生物领域所属的企业中从事科研、技术、工程相关工作者，且年薪高于1.5倍以上',0,2,1,'','','2020-01-06 17:36:08','87',NULL,NULL),('1214118558968074242',1,'7',NULL,1,'我市紧缺急需文化创意人才：近5年来，取得学士学位，来泉后从事文化创意产业，在企业内任中级以上管理人员，且年薪高于1倍以上',5,1,1,'','','2020-01-06 17:36:36','87',NULL,NULL),('1214118662080843777',1,'7',NULL,1,'我市紧缺急需文化创意人才：创办文化创意企业，担任法定代表人且股份占比达30%以上，企业连续经营满两年的归国华侨',0,2,1,'','','2020-01-06 17:37:00','87',NULL,NULL),('1214118745757208578',1,'7',NULL,1,'我市紧缺急需文化创意人才：创办文化创意企业，担任法定代表人且股份占比达30%以上，企业连续经营满两年的台湾青年',0,2,1,'','','2020-01-06 17:37:20','87',NULL,NULL),('1214118931069947906',1,'7',NULL,1,'我市紧缺急需现代金融人才：近5年来，取得全日制大学本科金融类专业毕业并获经济学学士学位，来泉后从事银行、保险、证券、信托、期货、基金、消费金融、金融租赁、财务公司及小额贷款、典当、融资担保等工作，或在泉州各类金融机构县级支行（支公司）内任高级管理人员或部门负责人且年薪高于1.5倍以上',5,1,1,'','','2020-01-06 17:38:05','87',NULL,NULL),('1214119025999630337',1,'7',NULL,1,'我市紧缺急需现代金融人才：近5年来，在泉州各类金融机构县级支行（支公司）内任高级管理人员或部门负责人且年薪高于1.5倍以上',5,1,1,'','','2020-01-06 17:38:27','87',NULL,NULL),('1214119921206710273',1,'5',NULL,1,'全国广播电视技术能手二等奖获得者',0,2,1,'','','2020-01-06 17:42:01','87',NULL,NULL),('1217351615846043649',1,'6',NULL,1,'在我市17个重点产业企业就业并取得全日制硕士学位者',0,2,1,'','','2020-01-15 15:43:37','87',NULL,NULL),('1239725751801004034',1,'5',NULL,1,'泉州市博士后科研工作站在站博士后（原泉州市高层次人才认定标准）',0,2,1,'',NULL,'2020-03-17 09:30:26','87','2020-04-16 09:51:12','87'),('1239839989659910146',1,'5',NULL,1,'近5年，在CSSCI刊物上发表学术论文3篇（原泉州高层次人才认定标准）',5,1,1,'',NULL,'2020-03-17 17:04:23','87','2020-03-17 17:05:49','87'),('1241923836044185601',1,'3',NULL,1,'省引进高层次创业创新人才“百人计划”入选者（原泉州市高层次人才认定标准））',0,2,1,'',NULL,'2020-03-23 11:04:50','87',NULL,NULL),('1243351001461760001',1,'5',NULL,1,'博士后出站留（来）泉创业或工作者（原泉州高层次人才认定标准）',0,2,1,'',NULL,'2020-03-27 09:35:53','87','2020-03-27 09:36:24','87'),('1250602557236150274',1,'4',NULL,1,'平均工资6倍以上的企业高级经营管理人员（原泉州高层次人才认定标准）',0,2,1,'',NULL,'2020-04-16 09:50:59','87',NULL,NULL),('1259021631435636737',1,'4',NULL,1,'获奖作品的第一设计师(原泉州市高层次人才认定标准))',0,2,1,'',NULL,'2020-05-09 15:25:23','87',NULL,NULL),('1259022484494155777',1,'3',NULL,1,'平均工资8倍或以上的高级经营管理人员、高级技术研发人员(重点产业企业)(原泉州市高层次人才认定标准))',0,2,1,'',NULL,'2020-05-09 15:28:46','87',NULL,NULL),('1259025123554426882',1,'5',NULL,1,'装备制造产业紧缺急需人才：取得工学博士学位，来泉后从事装备制造相关工作。(原泉州市高层次人才认定标准))',0,2,1,'',NULL,'2020-05-09 15:39:15','87',NULL,NULL),('1259026431074172929',1,'4',NULL,1,'上市公司财务总监、投资总监、市场总监或相当职级的高级管理职务、中层专业技术岗位负责人或一级子公司高级技术岗位负责人(原泉州市高层次人才认定标准))',0,2,1,'',NULL,'2020-05-09 15:44:27','87',NULL,NULL),('1259027669475983361',1,'3',NULL,1,'上市公司的总经理、副总经理、首席技术官或技术总监(原泉州市高层次人才认定标准))',0,2,1,'',NULL,'2020-05-09 15:49:22','87',NULL,NULL),('1260137722916417538',1,'2',NULL,1,'德国红点设计奖至尊大奖(原泉州市高层次人才认定标准)',0,2,1,'',NULL,'2020-05-12 17:20:20','87',NULL,NULL),('1305772938523365378',3,'2','gzh',1,'近10年，担任国家工程技术研究中心主任，且年薪高于6倍以上 (仅适用于国字号平台)',10,1,1,'1197443773921181697',NULL,'2020-09-15 15:38:23','87','2020-10-23 16:25:05','87'),('1323210711811289090',1,'4','',1,'外籍人才：近5年，获得德国红点设计奖的产品设计奖、传达设计奖、包装设计奖前2位完成人	',5,1,1,'',NULL,'2020-11-02 18:29:52','87',NULL,NULL),('1377070754352410625',NULL,'2',NULL,2,'(年限不足，降一级认定)在全球前25大半导体公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 09:30:27','68','2021-07-14 11:42:06','68'),('1377078997753606146',NULL,'3',NULL,2,'(年限不足，降一级认定)在全球前25大半导体公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:03:12','68','2021-07-14 11:42:11','68'),('1377086914645012481',NULL,'3',NULL,2,'(年限不足，降一级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:34:40','68','2021-07-14 11:42:17','68'),('1377087101388009473',NULL,'3',NULL,2,'(年限不足，降一级认定)在集成电路材料、电子设计自动化(EDA)工具软件、硅智财(SIP)全球前5大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者;(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:35:24','68','2021-07-14 11:42:20','68'),('1377089621208412161',NULL,'4',NULL,2,'(年限不足，降一级认定)在全球前25大半导体公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:45:25','68','2021-07-14 11:42:23','68'),('1377089726917455874',NULL,'4',NULL,2,'(年限不足，降一级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:45:50','68','2021-07-14 11:42:26','68'),('1377089828860014593',NULL,'4',NULL,2,'(年限不足，降一级认定)在集成电路材料、电子设计自动化(EDA)工具软件、硅智财(SIP)全球前5大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:46:14','68','2021-07-14 11:42:33','68'),('1377089905246679041',NULL,'4',NULL,2,'(年限不足，降一级认定)在集成电路设计、制造、封测等领域大陆或台湾前10大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:46:33','68','2021-07-14 11:42:36','68'),('1377090081017376769',NULL,'4',NULL,2,'(年限不足，降一级认定)在集成电路装备、材料等领域大陆或台湾前5大公司担任副总经理、副总裁或首席科学家以上职务累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:47:15','68','2021-07-14 11:42:39','68'),('1377090771798274049',NULL,'5',NULL,2,'(年限不足，降一级认定)在全球前25大半导体公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:49:59','68','2021-07-14 11:42:41','68'),('1377090859027214338',NULL,'5',NULL,2,'(年限不足，降一级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:50:20','68','2021-07-14 11:42:43','68'),('1377090933232840705',NULL,'5',NULL,2,'(年限不足，降一级认定)在集成电路材料、电子设计自动化(EDA)工具软件、硅智财(SIP)全球前5大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:50:38','68','2021-07-14 11:42:46','68'),('1377091034831466497',NULL,'5',NULL,2,'(年限不足，降一级认定)在集成电路设计、制造、封测等领域大陆或台湾前10大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:51:02','68','2021-07-14 11:42:51','68'),('1377091170571726849',NULL,'5',NULL,2,'(年限不足，降一级认定)在集成电路装备、材料等领域大陆或台湾前5大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 10:51:34','68','2021-07-14 11:42:53','68'),('1377094927049109505',NULL,'6',NULL,2,'(年限不足，降一级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 11:06:30','68','2021-07-14 11:42:56','68'),('1377095273116938242',NULL,'6',NULL,2,'(年限不足，降一级认定)在集成电路材料、电子设计自动化(EDA)工具软件、硅智财(SIP)全球前5大公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 11:07:52','68','2021-07-14 11:42:58','68'),('1377095335511404545',NULL,'6',NULL,2,'(年限不足，降一级认定)在集成电路设计、制造、封测等领域大陆或台湾前10大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 11:08:07','68','2021-07-14 11:43:01','68'),('1377095394550427650',NULL,'6',NULL,2,'(年限不足，降一级认定)在集成电路装备、材料等领域大陆或台湾前5大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 11:08:21','68','2021-07-14 11:43:05','68'),('1377095752773349377',NULL,'7',NULL,2,'(年限不足，降一级认定)在国家鼓励的集成电路企业担任一级部门的部门负责人、技术负责人、总工程师或其他相应科研技术职务以上累计5年以上者；(依据：晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”)',0,2,1,'',NULL,'2021-03-31 11:09:47','68','2021-07-14 11:43:09','68'),('1414508514193219585',NULL,'4',NULL,2,'(未在总部任职，降一级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司担任一级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：认定标准说明五)',0,2,1,'',NULL,'2021-07-12 16:54:44','68','2021-07-14 11:43:11','68'),('1414510719377907713',NULL,'7',NULL,2,'(年限不足且未在总部任职，降两级认定) 在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；(依据：1.晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”；2.认定标准说明五)',0,2,1,'',NULL,'2021-07-12 17:03:30','68','2021-07-14 11:43:14','68'),('1414511675020713986',NULL,'5',NULL,2,'(未在总部任职，降一级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：认定标准说明五)',0,2,1,'',NULL,'2021-07-12 17:07:18','68','2021-07-14 11:43:16','68'),('1414517284029898754',NULL,'6',NULL,2,'(未在总部任职，降一级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；(依据：认定标准说明五)',0,2,1,'',NULL,'2021-07-12 17:29:35','68','2021-07-14 11:43:22','68'),('1414519179939192833',NULL,'6',NULL,2,'(年限不足且未在总部任职，降两级认定)在集成电路设计、制造、集成器件制造(IDM)、封测、装备等领域全球前10大公司担任二级部门的部门负责人、技术负责人、总工程师或其他相应职务以上累计5年以上者；(依据：1.晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”；2.认定标准说明五)',0,2,1,'',NULL,'2021-07-12 17:37:07','68','2021-07-14 11:43:25','68'),('1414520316419416066',NULL,'6',NULL,2,'(年限不足且未在总部任职，降两级认定)在全球前25大半导体公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；(依据：1.晋江市集成电路优秀人才认定及2016年度人才津补贴兑现工作的报告关于“优秀人才任职年限不够的处理意见”；2.认定标准说明五)',0,2,1,'',NULL,'2021-07-12 17:41:38','68','2021-07-14 11:43:28','68'),('1414525678279237634',NULL,'5',NULL,2,'(未在总部任职，降一级认定)在全球前25大半导体公司技术研发、工程部门、管理部门担任经理、功能主管、主任工程师、资深工程师、高级工程师或其他相应职务以上累计5年以上者；(依据：认定标准说明五)',0,2,1,'',NULL,'2021-07-12 18:02:56','68','2021-07-14 11:43:31','68'),('1560691218172612609',1,'1','zzbsh',2,'测试测试',99,1,1,'1196327814145646594,1196327955313336322,1196328018018181122,1196328242593800193,1197443773921181697',NULL,'2022-08-20 02:12:37','1','2022-08-20 02:31:27','1');
/*!40000 ALTER TABLE `un_identify_condition` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_major_projects`
--

DROP TABLE IF EXISTS `un_major_projects`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_major_projects` (
  `id` varchar(40) NOT NULL COMMENT '主键',
  `type` tinyint(1) DEFAULT NULL COMMENT '人才类型',
  `source` tinyint(1) DEFAULT NULL COMMENT '人才来源',
  `talentId` varchar(40) DEFAULT NULL COMMENT '优秀人才Id',
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `cardType` varchar(10) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `talentArrange` varchar(1) DEFAULT NULL COMMENT '人才层次',
  `nationality` varchar(50) DEFAULT NULL COMMENT '国家/地区',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '入职时间',
  `startTime` varchar(40) DEFAULT NULL COMMENT '合同开始时间',
  `endTime` varchar(40) DEFAULT NULL COMMENT '合同结束时间',
  `post` varchar(255) DEFAULT NULL COMMENT '岗位/职位',
  `bankName` varchar(60) DEFAULT NULL COMMENT '开户银行',
  `bankAddress` varchar(255) DEFAULT NULL COMMENT '开户银行网点',
  `bankNumber` varchar(40) DEFAULT NULL COMMENT '银行账号',
  `phone` varchar(30) DEFAULT NULL COMMENT '联系电话',
  `address` varchar(255) DEFAULT NULL COMMENT '联系地址',
  `email` varchar(100) DEFAULT NULL COMMENT '电子邮箱',
  `documentName` varchar(200) DEFAULT NULL COMMENT '入选重大专项批准文件',
  `degree` varchar(255) DEFAULT NULL COMMENT '重大专项级别、名称',
  `fundsSupport` decimal(10,2) DEFAULT NULL COMMENT '各级政府配套经费资助',
  `quotaProportion` decimal(10,2) DEFAULT NULL COMMENT '配套额度比例',
  `applicationAmount` decimal(10,2) DEFAULT NULL COMMENT '申请晋江市配套资助金额',
  `firstSubmitTime` varchar(40) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(40) DEFAULT NULL COMMENT '最新提交时间',
  `checkState` tinyint(2) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `publicState` tinyint(1) DEFAULT 1,
  `files` varchar(255) DEFAULT NULL,
  `fields` varchar(255) DEFAULT NULL,
  `description` varchar(1000) DEFAULT NULL,
  `createTime` varchar(50) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_major_projects`
--

LOCK TABLES `un_major_projects` WRITE;
/*!40000 ALTER TABLE `un_major_projects` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_major_projects` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_medical_fees`
--

DROP TABLE IF EXISTS `un_medical_fees`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_medical_fees` (
  `id` varchar(40) NOT NULL COMMENT 'id',
  `mainId` varchar(40) DEFAULT NULL,
  `hospital` varchar(255) DEFAULT NULL COMMENT '救治医院',
  `startTime` varchar(40) DEFAULT NULL COMMENT '住院开始时间',
  `endTime` varchar(40) DEFAULT NULL COMMENT '住院截至时间',
  `settlementTime` varchar(40) DEFAULT NULL COMMENT '医保报销结算时间',
  `total` decimal(10,2) DEFAULT NULL COMMENT '总费用',
  `plan` decimal(10,2) DEFAULT NULL COMMENT '统筹基金',
  `insurance` decimal(10,2) DEFAULT NULL COMMENT '商保基金',
  `ownFees` decimal(10,2) DEFAULT NULL COMMENT '个人自费',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_medical_fees`
--

LOCK TABLES `un_medical_fees` WRITE;
/*!40000 ALTER TABLE `un_medical_fees` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_medical_fees` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_medical_subsidy`
--

DROP TABLE IF EXISTS `un_medical_subsidy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_medical_subsidy` (
  `id` varchar(40) NOT NULL COMMENT 'id',
  `year` varchar(10) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `talentId` varchar(40) DEFAULT NULL,
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `cardType` varchar(10) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `talentArrange` tinyint(1) DEFAULT NULL COMMENT '人才层次',
  `certificateNo` varchar(20) DEFAULT NULL COMMENT '证书编号',
  `nativePlace` varchar(100) DEFAULT NULL COMMENT '籍贯',
  `address` varchar(200) DEFAULT NULL COMMENT '现居地址',
  `phone` varchar(20) DEFAULT NULL COMMENT '联系电话',
  `pensionDetail` varchar(100) DEFAULT NULL COMMENT '养老保险缴纳月份',
  `unemploymentDetail` varchar(100) DEFAULT NULL COMMENT '失业保险缴纳月份',
  `medicaDetail` varchar(100) DEFAULT NULL COMMENT '医疗保险缴纳月份',
  `taxDetail` varchar(100) DEFAULT NULL COMMENT '个税缴纳月份',
  `bankAddress` varchar(100) DEFAULT NULL COMMENT '开户银行网点',
  `bankNumber` varchar(40) DEFAULT NULL COMMENT '银行账号',
  `cashMoney` decimal(10,2) DEFAULT NULL COMMENT '兑现金额',
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `files` varchar(500) DEFAULT NULL COMMENT '驳回附件类型',
  `fields` varchar(500) DEFAULT NULL COMMENT '驳回字段',
  `firstSubmitTime` varchar(50) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(50) DEFAULT NULL COMMENT '最新提交时间',
  `passTime` varchar(40) DEFAULT NULL,
  `publicState` tinyint(1) DEFAULT NULL COMMENT '公示状态',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_medical_subsidy`
--

LOCK TABLES `un_medical_subsidy` WRITE;
/*!40000 ALTER TABLE `un_medical_subsidy` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_medical_subsidy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_person`
--

DROP TABLE IF EXISTS `un_person`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_person` (
  `id` varchar(50) NOT NULL,
  `uid` varchar(50) DEFAULT NULL COMMENT '微信id',
  `type` tinyint(1) DEFAULT NULL,
  `jUsername` varchar(255) DEFAULT NULL,
  `source` tinyint(1) DEFAULT 1,
  `username` varchar(20) DEFAULT NULL COMMENT '登陆用户名',
  `password` varchar(50) DEFAULT NULL COMMENT '登录密码（加密后）',
  `name` varchar(20) DEFAULT NULL COMMENT '姓名',
  `sex` int(1) DEFAULT NULL COMMENT '性别{1-男，2-女}',
  `idCard` varchar(30) DEFAULT NULL COMMENT '证件号码',
  `phone` varchar(20) DEFAULT NULL COMMENT '电话号码',
  `address` varchar(100) DEFAULT NULL COMMENT '联系地址',
  `email` varchar(20) DEFAULT NULL COMMENT '邮箱',
  `active` int(1) DEFAULT NULL COMMENT '状态{1-有效，2-被冻结}',
  `activeMsg` varchar(100) DEFAULT NULL COMMENT '拉黑/冻结原因',
  `headPortrait` varchar(100) DEFAULT NULL COMMENT ' 用户头像',
  `description` varchar(100) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='个人用户信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_person`
--

LOCK TABLES `un_person` WRITE;
/*!40000 ALTER TABLE `un_person` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_person` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_allowance_arrange`
--

DROP TABLE IF EXISTS `un_talent_allowance_arrange`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_allowance_arrange` (
  `id` varchar(30) NOT NULL,
  `mainId` varchar(30) DEFAULT NULL,
  `talentArrange` varchar(10) NOT NULL,
  `identifyCondition` varchar(40) DEFAULT NULL,
  `identifyConditionName` varchar(1000) DEFAULT NULL,
  `identifyConditionGetTime` varchar(50) DEFAULT NULL,
  `startTime` varchar(40) DEFAULT NULL COMMENT '开始日期',
  `endTime` varchar(40) DEFAULT NULL COMMENT '截止日期',
  `prepareMonths` varchar(255) DEFAULT NULL COMMENT '享受月份(忽略其他条件)',
  `months` varchar(255) DEFAULT NULL COMMENT '享受月份',
  `count` tinyint(2) DEFAULT NULL,
  `total` decimal(10,2) DEFAULT NULL COMMENT '兑现金额',
  `jobMoney` decimal(10,2) DEFAULT NULL,
  `jtMoney` decimal(10,2) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='津补贴人才层次记录表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_allowance_arrange`
--

LOCK TABLES `un_talent_allowance_arrange` WRITE;
/*!40000 ALTER TABLE `un_talent_allowance_arrange` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_allowance_arrange` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_allowance_info`
--

DROP TABLE IF EXISTS `un_talent_allowance_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_allowance_info` (
  `id` varchar(30) NOT NULL COMMENT 'id',
  `type` tinyint(1) DEFAULT NULL,
  `talentId` varchar(30) DEFAULT NULL COMMENT '优秀人才id',
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '申报单位id',
  `enterpriseName` varchar(255) DEFAULT NULL COMMENT '申报单位名',
  `year` varchar(4) DEFAULT NULL COMMENT '申报年度',
  `source` varchar(1) DEFAULT NULL COMMENT '申报来源',
  `qzgccrcActiveTime` varchar(40) DEFAULT NULL COMMENT '泉州高层次人才证书有效期',
  `talentType` varchar(30) DEFAULT NULL COMMENT '人才标签',
  `letterTime` varchar(40) DEFAULT NULL COMMENT '行政介绍信时间',
  `gygb` tinyint(1) DEFAULT NULL COMMENT '国有股比',
  `fromCity` varchar(30) DEFAULT NULL COMMENT '来源县市',
  `fromCityName` varchar(255) DEFAULT NULL,
  `address` varchar(255) DEFAULT NULL COMMENT '所属镇街',
  `introductionMode` varchar(20) DEFAULT NULL COMMENT '引进方式',
  `name` varchar(100) DEFAULT NULL COMMENT '姓名',
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `cardType` varchar(20) DEFAULT NULL,
  `idCard` varchar(30) DEFAULT NULL COMMENT '证件号码',
  `provinceCode` varchar(20) DEFAULT NULL,
  `provinceName` varchar(100) DEFAULT NULL,
  `cityCode` varchar(20) DEFAULT NULL,
  `cityName` varchar(100) DEFAULT NULL,
  `countyCode` varchar(20) DEFAULT NULL,
  `countyName` varchar(100) DEFAULT NULL,
  `firstInJJTime` varchar(30) DEFAULT NULL COMMENT '首次来晋时间',
  `entryTime` varchar(30) DEFAULT NULL COMMENT '本单位入职时间',
  `post` varchar(255) DEFAULT NULL COMMENT '职务',
  `phone` varchar(20) DEFAULT NULL COMMENT '手机号码',
  `talentArrange` smallint(2) DEFAULT NULL COMMENT '人才层次',
  `identifyCondition` varchar(40) DEFAULT NULL COMMENT '认定条件',
  `identifyGetTime` varchar(40) DEFAULT NULL COMMENT '认定条件获得时间',
  `identifyOutTime` varchar(40) DEFAULT NULL COMMENT '认定条件过期时间',
  `identifyConditionName` varchar(255) DEFAULT NULL COMMENT '认定条件名称',
  `identifyMonth` varchar(255) DEFAULT NULL COMMENT '认定月份',
  `bank` varchar(100) DEFAULT NULL,
  `bankNetwork` varchar(100) DEFAULT NULL,
  `bankAccount` varchar(100) DEFAULT NULL,
  `bankNumber` varchar(50) DEFAULT NULL,
  `wage` decimal(10,2) DEFAULT NULL,
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(2000) DEFAULT NULL COMMENT '审核意见',
  `money` decimal(10,2) DEFAULT NULL,
  `publicState` tinyint(1) DEFAULT 1,
  `fields` varchar(255) DEFAULT NULL,
  `files` varchar(255) DEFAULT NULL,
  `projects` varchar(255) DEFAULT NULL,
  `concats` varchar(255) DEFAULT NULL,
  `firstSubmitTime` varchar(40) DEFAULT NULL,
  `firstPassTime` varchar(40) DEFAULT NULL,
  `newSubmitTime` varchar(40) DEFAULT NULL,
  `visitPassTime` varchar(40) DEFAULT NULL,
  `reviewPassTime` varchar(40) DEFAULT NULL,
  `highProcess` tinyint(1) DEFAULT NULL,
  `isSupple` tinyint(1) DEFAULT 2,
  `isPublicCheck` tinyint(1) DEFAULT 2,
  `recommendAllowanceType` tinyint(1) DEFAULT NULL,
  `recommendAllowanceMsg` varchar(500) DEFAULT NULL,
  `recommendMonths` varchar(100) DEFAULT NULL,
  `recommendMoney` decimal(10,2) DEFAULT NULL,
  `recommendMoneyDesc` varchar(500) DEFAULT NULL,
  `recommendTalentArrange` varchar(10) DEFAULT NULL,
  `allowanceType` tinyint(1) DEFAULT NULL,
  `allowanceMsg` varchar(1000) DEFAULT NULL,
  `months` varchar(255) DEFAULT NULL,
  `moneyDesc` varchar(255) DEFAULT NULL,
  `toProcess` tinyint(1) DEFAULT NULL,
  `toDep` varchar(30) DEFAULT NULL,
  `workAllowanceMoney` decimal(10,2) DEFAULT NULL,
  `developAllowanceMoney` decimal(10,2) DEFAULT NULL,
  `jtTalentArrange` varchar(10) DEFAULT NULL,
  `outMsg` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `notPassMark` tinyint(1) unsigned zerofill DEFAULT 0 COMMENT '审核不通过标注',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='优秀人才津补贴申报基础信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_allowance_info`
--

LOCK TABLES `un_talent_allowance_info` WRITE;
/*!40000 ALTER TABLE `un_talent_allowance_info` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_allowance_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_allowance_project`
--

DROP TABLE IF EXISTS `un_talent_allowance_project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_allowance_project` (
  `id` int(40) NOT NULL AUTO_INCREMENT COMMENT 'id',
  `mainId` varchar(40) DEFAULT NULL COMMENT '津补贴id',
  `baseId` varchar(40) DEFAULT NULL,
  `enterpriseId` varchar(40) NOT NULL,
  `project` varchar(2) DEFAULT NULL COMMENT '核查项目',
  `months` varchar(255) DEFAULT NULL COMMENT '可享受月份',
  `days` smallint(3) DEFAULT NULL,
  `fileUrl` varchar(255) DEFAULT NULL,
  `description` varchar(1000) DEFAULT NULL,
  `isLock` tinyint(1) DEFAULT NULL,
  `createTime` varchar(50) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB AUTO_INCREMENT=11608 DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='津补贴核查项目表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_allowance_project`
--

LOCK TABLES `un_talent_allowance_project` WRITE;
/*!40000 ALTER TABLE `un_talent_allowance_project` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_allowance_project` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_allowancecontract_detail`
--

DROP TABLE IF EXISTS `un_talent_allowancecontract_detail`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_allowancecontract_detail` (
  `id` varchar(30) NOT NULL COMMENT 'id',
  `mainId` varchar(30) DEFAULT NULL COMMENT '津补贴id',
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '企业id',
  `talentType` varchar(20) DEFAULT NULL COMMENT '人才标签',
  `letterTime` varchar(40) DEFAULT NULL,
  `identifyGetTime` varchar(40) DEFAULT NULL,
  `gygb` tinyint(1) DEFAULT NULL,
  `startTime` varchar(40) DEFAULT NULL COMMENT '合同开始时间',
  `endTime` varchar(40) DEFAULT NULL COMMENT '合同结束时间',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '入职时间',
  `quitTime` varchar(40) DEFAULT NULL COMMENT '离职时间',
  `months` varchar(255) DEFAULT NULL COMMENT '可享受月份',
  `allowanceType` tinyint(1) DEFAULT 1,
  `allowanceDesc` varchar(255) DEFAULT NULL,
  `allowanceMoney` decimal(10,2) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `isLock` tinyint(1) DEFAULT NULL,
  `isQuit` tinyint(1) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `post` varchar(500) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='津补贴申报工作单位详情';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_allowancecontract_detail`
--

LOCK TABLES `un_talent_allowancecontract_detail` WRITE;
/*!40000 ALTER TABLE `un_talent_allowancecontract_detail` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_allowancecontract_detail` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_bank_change`
--

DROP TABLE IF EXISTS `un_talent_bank_change`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_bank_change` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `talentId` varchar(30) DEFAULT NULL COMMENT '优秀人才id',
  `type` tinyint(1) DEFAULT NULL,
  `talentName` varchar(255) DEFAULT NULL COMMENT '对象姓名',
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '工作单位id',
  `enterpriseName` varchar(255) DEFAULT NULL COMMENT '企业名称',
  `idCard` varchar(30) DEFAULT NULL COMMENT '证件号码',
  `talentArrange` varchar(30) DEFAULT NULL COMMENT '人才层次',
  `oldBankName` varchar(100) DEFAULT NULL COMMENT '原开户银行',
  `oldBankNerPoint` varchar(100) DEFAULT NULL COMMENT '原开户银行网点',
  `oldBankAccount` varchar(100) DEFAULT NULL COMMENT '原银行账号',
  `oldBankNumber` varchar(100) DEFAULT NULL COMMENT '原银行行号',
  `newBankName` varchar(100) DEFAULT NULL COMMENT '现开户银行',
  `newBankNerPoint` varchar(100) DEFAULT NULL COMMENT '现开户银行网点',
  `newBankAccount` varchar(100) DEFAULT NULL COMMENT '现银行账号',
  `newBankNumber` varchar(100) DEFAULT NULL COMMENT '现银行行号',
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `passTime` varchar(40) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='优秀人才银行账号变更记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_bank_change`
--

LOCK TABLES `un_talent_bank_change` WRITE;
/*!40000 ALTER TABLE `un_talent_bank_change` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_bank_change` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_basic_change`
--

DROP TABLE IF EXISTS `un_talent_basic_change`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_basic_change` (
  `id` varchar(40) NOT NULL,
  `type` tinyint(1) DEFAULT NULL,
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `talentId` varchar(40) DEFAULT NULL,
  `oldName` varchar(50) DEFAULT NULL COMMENT '原姓名',
  `oldBirthday` varchar(50) DEFAULT NULL COMMENT '原出生日期',
  `oldNationality` varchar(50) DEFAULT NULL COMMENT '原国籍',
  `oldNation` varchar(100) DEFAULT NULL,
  `oldPolitics` varchar(50) DEFAULT NULL COMMENT '原政治面貌',
  `oldCardType` varchar(50) DEFAULT NULL COMMENT '原证件类型',
  `oldIdCard` varchar(50) NOT NULL COMMENT '原证件号码',
  `oldEmail` varchar(50) NOT NULL COMMENT '原电子邮箱',
  `newName` varchar(50) DEFAULT NULL COMMENT '现姓名',
  `newBirthday` varchar(40) DEFAULT NULL COMMENT '现出生日期',
  `newNationality` varchar(50) DEFAULT NULL COMMENT '现国籍',
  `newNation` varchar(100) DEFAULT NULL COMMENT '现民族',
  `newPolitics` varchar(50) DEFAULT NULL COMMENT '现政治面貌',
  `newCardType` varchar(50) DEFAULT NULL COMMENT '现证件类型',
  `newIdCard` varchar(50) DEFAULT NULL COMMENT '现证件号码',
  `newEmail` varchar(50) DEFAULT NULL COMMENT '现邮箱',
  `firstSubmitTime` varchar(40) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(40) DEFAULT NULL COMMENT '最新提交时间',
  `checkState` tinyint(1) DEFAULT NULL,
  `checkMsg` varchar(500) DEFAULT NULL COMMENT '审核意见',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_basic_change`
--

LOCK TABLES `un_talent_basic_change` WRITE;
/*!40000 ALTER TABLE `un_talent_basic_change` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_basic_change` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_checklog`
--

DROP TABLE IF EXISTS `un_talent_checklog`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_checklog` (
  `id` varchar(30) NOT NULL COMMENT '主键',
  `type` tinyint(1) DEFAULT NULL COMMENT '类别',
  `mainId` varchar(30) NOT NULL COMMENT '主表id',
  `companyId` varchar(30) DEFAULT NULL,
  `typeFileId` varchar(30) DEFAULT NULL COMMENT '附件类别id',
  `active` tinyint(1) DEFAULT NULL COMMENT '是否生效',
  `state` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `step` tinyint(1) DEFAULT NULL COMMENT '步骤',
  `stateChange` varchar(255) DEFAULT NULL,
  `description` varchar(1000) DEFAULT NULL,
  `createTime` varchar(50) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `index_zh1` (`mainId`,`companyId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='优秀人才审核日志';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_checklog`
--

LOCK TABLES `un_talent_checklog` WRITE;
/*!40000 ALTER TABLE `un_talent_checklog` DISABLE KEYS */;
INSERT INTO `un_talent_checklog` VALUES ('1560676248659693570',10,'1560676248278011905',NULL,NULL,1,1,100,'用户提交','用户注册','2022-08-20 01:13:08','用户',NULL,NULL),('1560678939439927297',10,'1560676248278011905',NULL,NULL,1,3,101,'<span class=\'label label-primary\'>审核通过</span>','机构账号注册审核通过。123','2022-08-20 01:23:49','admin(super)',NULL,NULL),('1560698278465507330',1,'1560698278390009858',NULL,NULL,1,1,0,'保存未提交','添加人才认定申报','2022-08-20 02:40:40','申报用户',NULL,NULL),('1560700252200112129',1,'1560698278390009858',NULL,'1178131640547270658',1,1,0,NULL,'添加附件，附件名为：202006091591691272114478.jpg','2022-08-20 02:48:31','申报用户',NULL,NULL),('1560700296420659201',1,'1560698278390009858',NULL,'1185025144825004034',1,1,0,NULL,'添加附件，附件名为：202006091591691272114478.jpg','2022-08-20 02:48:41','申报用户',NULL,NULL),('1560700529745596417',1,'1560698278390009858',NULL,'1185025499830894594',1,1,0,NULL,'添加附件，附件名为：202006091591691272114478.jpg','2022-08-20 02:49:37','申报用户',NULL,NULL),('1560700596569247745',1,'1560698278390009858',NULL,'1185026393880346625',1,1,0,NULL,'添加附件，附件名为：202006091591691272114478.jpg','2022-08-20 02:49:53','申报用户',NULL,NULL),('1560700621487607809',1,'1560698278390009858',NULL,'1210382500880424962',1,1,0,NULL,'添加附件，附件名为：202006091591691272114478.jpg','2022-08-20 02:49:59','申报用户',NULL,NULL),('1560701014342897666',1,'1560698278390009858',NULL,'1185029319591936001',1,1,0,NULL,'添加附件，附件名为：微信图片_20220717142048.jpg','2022-08-20 02:51:32','申报用户',NULL,NULL),('1560701040666349570',1,'1560698278390009858',NULL,'1210382500880424962',1,1,0,NULL,'添加附件，附件名为：202006091591691272114478.jpg','2022-08-20 02:51:39','申报用户',NULL,NULL),('1560701069980340225',1,'1560698278390009858',NULL,NULL,1,1,0,'<span class=\'label\'>待提交</span>-><span class=\'label label-success\'>待初审</span>','确认提交审核','2022-08-20 02:51:46','申报用户',NULL,NULL),('1560703895498395649',1,'1560698278390009858',NULL,NULL,1,3,1,'<span class=\'label label-success\'>待初审</span>-><span class=\'label label-success\'>待复核</span>','初审通过，待复核。','2022-08-20 03:02:59','admin(super)',NULL,NULL),('1560705212614709249',1,'1560698278390009858',NULL,NULL,1,2,3,'<span class=\'label label-success\'>待复核</span>-><span class=\'label label-danger\'>部门驳回</span>','退回上级','2022-08-20 03:08:13','admin(super)',NULL,NULL),('1560705996962140162',1,'1560698278390009858',NULL,NULL,1,2,1,'<span class=\'label label-danger\'>部门驳回</span>-><span class=\'label label-danger\'>初审驳回</span>','退回看状态','2022-08-20 03:11:20','admin(super)',NULL,NULL),('1560707266108198914',1,'1560698278390009858',NULL,NULL,1,1,0,'<span class=\'label label-danger\'>初审驳回</span>-><span class=\'label label-success\'>待初审</span>','确认提交审核','2022-08-20 03:16:23','申报用户',NULL,NULL),('1560707666089611266',1,'1560698278390009858',NULL,NULL,1,3,1,'<span class=\'label label-success\'>待初审</span>-><span class=\'label label-success\'>待复核</span>','初审通过，待复核。','2022-08-20 03:17:58','admin(super)',NULL,NULL),('1560707813209018370',1,'1560698278390009858',NULL,NULL,1,3,3,'<span class=\'label label-success\'>待复核</span>-><span class=\'label label-primary\'>复核通过</span>','复核通过，待核查征信。','2022-08-20 03:18:33','admin(super)',NULL,NULL),('1560708189366784001',1,'1560698278390009858',NULL,NULL,1,11,3,'<span class=\'label label-primary\'>复核通过</span>-><span class=\'label label-success\'>待复核</span>','撤销原因：123','2022-08-20 03:20:03','admin(super)',NULL,NULL),('1560708658931699714',1,'1560698278390009858',NULL,NULL,1,-1,3,'<span class=\'label label-success\'>待复核</span>-><span class=\'label label-danger\'>审核不通过</span>','复核不通过','2022-08-20 03:21:55','admin(super)',NULL,NULL);
/*!40000 ALTER TABLE `un_talent_checklog` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_common_file`
--

DROP TABLE IF EXISTS `un_talent_common_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_common_file` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `mainId` varchar(30) DEFAULT NULL COMMENT '离职记录id',
  `typeId` varchar(50) DEFAULT NULL COMMENT '附件类别id',
  `orignName` varchar(255) DEFAULT NULL COMMENT '附件原名',
  `url` varchar(255) DEFAULT NULL COMMENT '附件现名',
  `sn` tinyint(2) DEFAULT NULL COMMENT '序号',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='人才认定通用附件';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_common_file`
--

LOCK TABLES `un_talent_common_file` WRITE;
/*!40000 ALTER TABLE `un_talent_common_file` DISABLE KEYS */;
INSERT INTO `un_talent_common_file` VALUES ('1211939276233687042','1211938606080376833','1161965644164075522','营业执照（副本）.jpg','jjrcw/talentFile/talentCommonFile/201912/1211939276128829442.jpg',1,NULL,'2019-12-31 17:16:54',NULL,NULL,NULL),('1213353088438571009','1213351711956078594','1177047550859280385','C:\\Users\\Administrator\\Desktop\\未标题-2.jpg','jjrcw/talentFile/talentCommonFile/202001/1213353088337907713.jpg',1,NULL,'2020-01-04 14:54:53',NULL,NULL,NULL),('1213353814694891521','1213351711956078594','1161965644164075522','C:\\Users\\Administrator\\Desktop\\07877fe8746e4230287ba0ade5c7928.jpg','jjrcw/talentFile/talentCommonFile/202001/1213353814619394049.jpg',1,NULL,'2020-01-04 14:57:47',NULL,NULL,NULL),('1214054964754665473','1214054824291618818','1161965644164075522','三证后营业执照副本0000.jpg','jjrcw/talentFile/talentCommonFile/202001/1214054964654002178.jpg',1,NULL,'2020-01-06 13:23:54',NULL,NULL,NULL),('1215164483387834370','1215164447815942146','1161965644164075522','110106134755122.jpg','jjrcw/talentFile/talentCommonFile/202001/1215164483257810946.jpg',1,NULL,'2020-01-09 14:52:44',NULL,NULL,NULL),('1216622052044185602','1216622017093050369','1161965644164075522','110106134755122.jpg','jjrcw/talentFile/talentCommonFile/202001/1216622051926745090.jpg',1,NULL,'2020-01-13 15:24:35',NULL,NULL,NULL),('1219809404539387905','1219809293474217986','1161965644164075522','微信图片_20200121174020.jpg','jjrcw/talentFile/talentCommonFile/202001/1219809404438724609.jpg',1,NULL,'2020-01-22 10:29:59',NULL,NULL,NULL),('1231780527908974594','1231779523540938754','1161965644164075522','ded9bc26e0b24d050cab49562a248aa.jpg','jjrcw/talentFile/talentCommonFile/202002/1231780527795728386.jpg',1,NULL,'2020-02-24 11:18:57',NULL,NULL,NULL),('1232931490870968321','1232931442682609665','1161965644164075522','110106134755122.jpg','jjrcw/talentFile/talentCommonFile/202002/1232931490711584769.jpg',1,NULL,'2020-02-27 15:32:28',NULL,NULL,NULL),('1232931964097511425','1232931926206169089','1161965644164075522','110106134755122.jpg','jjrcw/talentFile/talentCommonFile/202002/1232931963992653826.jpg',1,NULL,'2020-02-27 15:34:21',NULL,NULL,NULL),('1235412942556610562','1235411707208253442','1161965644164075522','5、营业执照.png','jjrcw/talentFile/talentCommonFile/202003/1235412942422392834.png',1,NULL,'2020-03-05 11:52:53',NULL,NULL,NULL),('1249998550088122369','1249998422287679490','1161965644164075522','丰预泰-营业执照.jpg','jjrcw/talentFile/talentCommonFile/202004/1249998549958098946.jpg',1,NULL,'2020-04-14 17:50:52',NULL,NULL,NULL),('1253154617202671618','1253152807385661441','1161965644164075522','集团营业执照.png','jjrcw/talentFile/talentCommonFile/202004/1253154616988762113.png',1,NULL,'2020-04-23 10:51:57',NULL,NULL,NULL),('1255048579140124674','1255047628895387649','1161965644164075522','信泰营业执照.jpg','jjrcw/talentFile/talentCommonFile/202004/1255048578959769601.jpg',1,NULL,'2020-04-28 16:17:53',NULL,NULL,NULL),('1258324685360259074','1258324222611087361','1161965644164075522','事业单位法人证书.jpg','jjrcw/talentFile/talentCommonFile/202005/1258324685247012865.jpg',1,NULL,'2020-05-07 17:15:58',NULL,NULL,NULL),('1259653064084750338','1259652684059836418','1161965644164075522','万物智联营业执照.jpeg','jjrcw/talentFile/talentCommonFile/202005/1259653063975698433.jpeg',1,NULL,'2020-05-11 09:14:28',NULL,NULL,NULL),('1260100981199273986','1260100796612149250','1161965644164075522','晋江大白.JPG','jjrcw/talentFile/talentCommonFile/202005/1260100981098610690.JPG',1,NULL,'2020-05-12 14:54:20',NULL,NULL,NULL),('1268742557366538241','1268742228419858434','1161965644164075522','集团营业执照.png','jjrcw/talentFile/talentCommonFile/202006/1268742557056159745.png',1,NULL,'2020-06-05 11:12:52',NULL,NULL,NULL),('1271362321838559234','1271362179211251714','1161965644164075522','福建营业执照  副本  2018.01.17.jpg','jjrcw/talentFile/talentCommonFile/202006/1271362321729507330.jpg',1,NULL,'2020-06-12 16:42:52',NULL,NULL,NULL),('1271363031762259969','1271362933514883074','1161965644164075522','中国营业执照副本 2020.1.15.jpg','jjrcw/talentFile/talentCommonFile/202006/1271363031644819457.jpg',1,NULL,'2020-06-12 16:45:42',NULL,NULL,NULL),('1271363519421403137','1271363282564861953','1161965644164075522','童装营业执照  副本 2016.03.07.jpg','jjrcw/talentFile/talentCommonFile/202006/1271363519308156929.jpg',1,NULL,'2020-06-12 16:47:38',NULL,NULL,NULL),('1272815830777778177','1272813687341633537','1161965644164075522','微信图片_20200616165757.jpg','jjrcw/talentFile/talentCommonFile/202006/1272815830270267393.jpg',1,NULL,'2020-06-16 16:58:36',NULL,NULL,NULL),('1275261282076901378','1275261187893805058','1161965644164075522','营业执照副本6-1.jpg','jjrcw/talentFile/talentCommonFile/202006/1275261281938489346.jpg',1,NULL,'2020-06-23 10:55:57',NULL,NULL,NULL),('1275588182141878274','1275588083080806401','1161965644164075522','微信图片_20200622114833_副本.jpg','jjrcw/talentFile/talentCommonFile/202006/1275588182049603585.jpg',1,NULL,'2020-06-24 08:34:56',NULL,NULL,NULL),('1275588651916509186','1275588083080806401','1161965644164075522','微信图片_20200622114833_副本.jpg','jjrcw/talentFile/talentCommonFile/202006/1275588651824234497.jpg',2,NULL,'2020-06-24 08:36:48',NULL,NULL,NULL),('1277881172667437058','1277873750376747010','1207221285556019202','李欣离职证明.jpg','jjrcw/talentFile/talentCommonFile/202008/1295532402289934337.jpg',1,NULL,'2020-06-30 16:26:28',NULL,'2020-08-18 09:26:09',NULL),('1278156057671143426','1278154240602181634','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202007/1278156057436262402.jpg',1,NULL,'2020-07-01 10:38:45',NULL,NULL,NULL),('1282847146634240002','1282846958502928385','1161965644164075522','1594689561(1).jpg','jjrcw/talentFile/talentCommonFile/202007/1282847146411941890.jpg',1,NULL,'2020-07-14 09:19:28',NULL,NULL,NULL),('1283583290581721089','1283581516445655041','1207221285556019202','吴康强离职证明.jpg','jjrcw/talentFile/talentCommonFile/202007/1283583290351034370.jpg',1,NULL,'2020-07-16 10:04:38',NULL,NULL,NULL),('1283583562984988673','1283583506697428994','1207221285556019202','杨玫曼离职证明.jpg','jjrcw/talentFile/talentCommonFile/202007/1283583562892713985.jpg',1,NULL,'2020-07-16 10:05:43',NULL,NULL,NULL),('1284025914308435969','1284025084918374401','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202007/1284025914182606850.jpg',1,NULL,'2020-07-17 15:23:28',NULL,NULL,NULL),('1286135209594478594','1286134969705455618','1207221285556019202','（胡炜）解除（终止）劳动关系证明docx.JPG','jjrcw/talentFile/talentCommonFile/202007/1286135209468649473.JPG',1,NULL,'2020-07-23 11:05:03',NULL,NULL,NULL),('1287629567053291521','1287629502750416897','1207221285556019202','陈阿霞离职单.jpg','jjrcw/talentFile/talentCommonFile/202007/1287629566990376961.jpg',1,NULL,'2020-07-27 14:03:06',NULL,NULL,NULL),('1288393910648893441','1288393688426278914','1161965644164075522','IMG_3105.JPG','jjrcw/talentFile/talentCommonFile/202007/1288393910535647234.JPG',1,NULL,'2020-07-29 16:40:20',NULL,NULL,NULL),('1288652473917030402','1288407170097934337','1161965644164075522','事业单位证书.jpg','jjrcw/talentFile/talentCommonFile/202007/1288652473828950017.jpg',1,NULL,'2020-07-30 09:47:46',NULL,NULL,NULL),('1288685302419865601','1288681933278068738','1161965644164075522','营业执照.jpg','jjrcw/talentFile/talentCommonFile/202007/1288685302285647874.jpg',1,NULL,'2020-07-30 11:58:13',NULL,NULL,NULL),('1290094178700640257','1290094114607480833','1161965644164075522','陈震毅时期营业执照.jpg','jjrcw/talentFile/talentCommonFile/202008/1290094178553839617.jpg',1,NULL,'2020-08-03 09:16:35',NULL,NULL,NULL),('1290106111235518466','1290105971623915521','1207221285556019202','（胡炜）解除（终止）劳动关系证明docx.JPG','jjrcw/talentFile/talentCommonFile/202008/1290106111088717825.JPG',1,NULL,'2020-08-03 10:04:00',NULL,NULL,NULL),('1290194035939594242','1289130436517224450','1207221285556019202','李淼离职证明.pdf','jjrcw/talentFile/talentCommonFile/202008/1290194035830542337.pdf',1,NULL,'2020-08-03 15:53:23',NULL,NULL,NULL),('1290258962251370498','1290258537531953154','1161965644164075522','1、福建永恒能源营业执照 副本2020.5.22.jpg','jjrcw/talentFile/talentCommonFile/202008/1290258962117152769.jpg',1,NULL,'2020-08-03 20:11:23',NULL,NULL,NULL),('1290460835948384257','1290460238444613634','1161965644164075522','营业执照.jpg','jjrcw/talentFile/talentCommonFile/202008/1290460835847720962.jpg',1,NULL,'2020-08-04 09:33:33',NULL,NULL,NULL),('1290911142394232833','1290910628684267522','1207570630070976514','劳动合同1-吴康强.jpg','jjrcw/talentFile/talentCommonFile/202008/1290911142310346754.jpg',1,NULL,'2020-08-05 15:22:54',NULL,NULL,NULL),('1290911173151064066','1290910628684267522','1207570630070976514','劳动合同2-吴康强.jpg','jjrcw/talentFile/talentCommonFile/202008/1290911172689690625.jpg',2,NULL,'2020-08-05 15:23:02',NULL,NULL,NULL),('1290921919142461441','1290910628684267522','1207570630070976514','吴康强任职证明.JPG','jjrcw/talentFile/talentCommonFile/202008/1290921919062769666.JPG',3,NULL,'2020-08-05 16:05:44',NULL,NULL,NULL),('1291176957223964673','1291176749220040706','1161965644164075522','营业执照-泉州福林.jpg','jjrcw/talentFile/talentCommonFile/202008/1291176957085552641.jpg',1,NULL,'2020-08-06 08:59:10',NULL,NULL,NULL),('1291217443116597249','1291217246881890306','1161965644164075522','营业执照正本2020.jpg','jjrcw/talentFile/talentCommonFile/202008/1291217442999156737.jpg',1,NULL,'2020-08-06 11:40:02',NULL,NULL,NULL),('1291300067700903937','1291299173101998081','1161965644164075522','晋江太古飞机复合材料有限公司-营业执照.jpg','jjrcw/talentFile/talentCommonFile/202008/1291300067591852033.jpg',1,NULL,'2020-08-06 17:08:21',NULL,NULL,NULL),('1291652713251115009','1291652622951944193','1207221285556019202','离职证明-马红彬.pdf','jjrcw/talentFile/talentCommonFile/202008/1291652713175617538.pdf',1,NULL,'2020-08-07 16:29:39',NULL,NULL,NULL),('1291652888602382338','1291652622951944193','1207221285556019202','劳动合同（旧单位）-凤竹纺织.pdf','jjrcw/talentFile/talentCommonFile/202008/1291652888493330433.pdf',2,NULL,'2020-08-07 16:30:21',NULL,NULL,NULL),('1291683800874594305','1291683629319172098','1161965644164075522','金鹰营业执照_20190228151036.jpg','jjrcw/talentFile/talentCommonFile/202008/1291683800790708226.jpg',1,NULL,'2020-08-07 18:33:11',NULL,NULL,NULL),('1291893885152374786','1291893758660554754','1207570630070976514','劳动合同-新单位-欣欣织造.pdf','jjrcw/talentFile/talentCommonFile/202008/1291893885060100098.pdf',1,NULL,'2020-08-08 08:27:59',NULL,NULL,NULL),('1291910900571287553','1291893758660554754','1207570630070976514','在职证明-马红彬.pdf','jjrcw/talentFile/talentCommonFile/202008/1291910900445458434.pdf',2,NULL,'2020-08-08 09:35:35',NULL,NULL,NULL),('1293011005529501697','1292998665975214081','1161965644164075522','营业执照正本.png','jjrcw/talentFile/talentCommonFile/202008/1293011005445615617.png',1,NULL,'2020-08-11 10:27:01',NULL,NULL,NULL),('1293011012173279234','1293004318466748417','1161965644164075522','欣欣织造营业执照.jpg','jjrcw/talentFile/talentCommonFile/202008/1293011012089393154.jpg',1,NULL,'2020-08-11 10:27:02',NULL,NULL,NULL),('1293076818940698626','1293076694768328705','1207221285556019202','解聘证明-张敏.pdf','jjrcw/talentFile/talentCommonFile/202008/1293076818823258113.pdf',1,NULL,'2020-08-11 14:48:32',NULL,NULL,NULL),('1293077379836583938','1293077131424735233','1207221285556019202','曾雅丹解聘证明.jpg','jjrcw/talentFile/talentCommonFile/202008/1293077379731726337.jpg',1,NULL,'2020-08-11 14:50:46',NULL,NULL,NULL),('1293352432453050369','1293351998929788929','1207221285556019202','郭小强劳动合同(2018.11.01-2021.10.31).pdf','jjrcw/talentFile/talentCommonFile/202008/1293352432360775682.pdf',1,NULL,'2020-08-12 09:03:43',NULL,NULL,NULL),('1293353279790538753','1293353231841255425','1207570630070976514','郭小强劳动合同(2018.11.01-2021.10.31).pdf','jjrcw/talentFile/talentCommonFile/202008/1293353279668903937.pdf',1,NULL,'2020-08-12 09:07:05',NULL,NULL,NULL),('1293353314771034113','1293353231841255425','1207570630070976514','郭小强任职文件.pdf','jjrcw/talentFile/talentCommonFile/202008/1293353314645204993.pdf',2,NULL,'2020-08-12 09:07:14',NULL,NULL,NULL),('1293394350327226370','1293394267561025537','1161965644164075522','营业执照.png','jjrcw/talentFile/talentCommonFile/202008/1293394350251728897.png',1,NULL,'2020-08-12 11:50:17',NULL,NULL,NULL),('1293444622504189953','1293439007593619458','1207221285556019202','楚威离职证明.jpg','jjrcw/talentFile/talentCommonFile/202008/1293444622399332353.jpg',1,NULL,'2020-08-12 15:10:03',NULL,NULL,NULL),('1293444976268566529','1293439007593619458','1207221371723800578','众腾在职证明.pdf','jjrcw/talentFile/talentCommonFile/202008/1293444976197263361.pdf',1,NULL,'2020-08-12 15:11:28',NULL,NULL,NULL),('1293480498483453954','1293480018667659266','1207570630070976514','众腾劳动合书pdf.pdf','jjrcw/talentFile/talentCommonFile/202008/1293480498391179266.pdf',1,NULL,'2020-08-12 17:32:37',NULL,NULL,NULL),('1293480702079164418','1293480018667659266','1207570630070976514','众腾在职证明.pdf','jjrcw/talentFile/talentCommonFile/202008/1293480701982695425.pdf',2,NULL,'2020-08-12 17:33:25',NULL,NULL,NULL),('1293847287205724161','1290121740076228610','1161965644164075522','营业执照（最新）.jpg','jjrcw/talentFile/talentCommonFile/202008/1293847287100866562.jpg',1,NULL,'2020-08-13 17:50:06',NULL,NULL,NULL),('1295259990751182849','1295259760429367298','1207221285556019202','[Untitled]_2-6.pdf','jjrcw/talentFile/talentCommonFile/202008/1295259990633742338.pdf',1,NULL,'2020-08-17 15:23:41',NULL,NULL,NULL),('1295260140898877442','1295260118425796609','1207221285556019202','[Untitled]_1-6.pdf','jjrcw/talentFile/talentCommonFile/202008/1295260140819185666.pdf',1,NULL,'2020-08-17 15:24:17',NULL,NULL,NULL),('1295260314140409857','1295260243743211521','1207221285556019202','[Untitled]_4-6.pdf','jjrcw/talentFile/talentCommonFile/202008/1295260314035552258.pdf',1,NULL,'2020-08-17 15:24:58',NULL,NULL,NULL),('1295260687450243073','1295260527554985986','1207221285556019202','[Untitled]_3-6.pdf','jjrcw/talentFile/talentCommonFile/202008/1295260687366356994.pdf',1,NULL,'2020-08-17 15:26:27',NULL,NULL,NULL),('1295260918170517506','1295260892333604866','1207221285556019202','[Untitled]_6-6.pdf','jjrcw/talentFile/talentCommonFile/202008/1295260918048882690.pdf',1,NULL,'2020-08-17 15:27:22',NULL,NULL,NULL),('1295261051658436610','1295261017017679873','1207221285556019202','[Untitled]_5-6.pdf','jjrcw/talentFile/talentCommonFile/202008/1295261051549384705.pdf',1,NULL,'2020-08-17 15:27:54',NULL,NULL,NULL),('1295263103545507842','1295263007911182337','1207221285556019202','[Untitled]_2020081716463700.pdf','jjrcw/talentFile/talentCommonFile/202008/1295263103461621762.pdf',1,NULL,'2020-08-17 15:36:03',NULL,NULL,NULL),('1295532530841157633','1287629502750416897','1207221285556019202','陈阿霞离职证明.jpg','jjrcw/talentFile/talentCommonFile/202008/1295532530723717121.jpg',2,NULL,'2020-08-18 09:26:39',NULL,NULL,NULL),('1295615137750712321','1295615079563132930','1207221285556019202','智军离职证明.pdf','jjrcw/talentFile/talentCommonFile/202008/1295615137641660418.pdf',1,NULL,'2020-08-18 14:54:54',NULL,NULL,NULL),('1295615355883880450','1295615255212195842','1207221285556019202','黄美玲.pdf','jjrcw/talentFile/talentCommonFile/202008/1295615355812577282.pdf',1,NULL,'2020-08-18 14:55:46',NULL,NULL,NULL),('1295615554182184961','1295615484586098690','1207221285556019202','陈长钦.pdf','jjrcw/talentFile/talentCommonFile/202008/1295615554081521665.pdf',1,NULL,'2020-08-18 14:56:34',NULL,NULL,NULL),('1295977222456213505','1295609455316041730','1207570630070976514','1.pdf','jjrcw/talentFile/talentCommonFile/202008/1295977222326190081.pdf',1,NULL,'2020-08-19 14:53:42',NULL,NULL,NULL),('1295977272079024130','1295609455316041730','1207570630070976514','2.jpg','jjrcw/talentFile/talentCommonFile/202008/1295977271911251969.jpg',2,NULL,'2020-08-19 14:53:54',NULL,NULL,NULL),('1295977300096974850','1295609455316041730','1207570630070976514','3.jpg','jjrcw/talentFile/talentCommonFile/202008/1295977300021477377.jpg',3,NULL,'2020-08-19 14:54:01',NULL,NULL,NULL),('1295978793139175426','1295978720573521921','1207570630070976514','8.jpg','jjrcw/talentFile/talentCommonFile/202008/1295978792988180482.jpg',1,NULL,'2020-08-19 14:59:57',NULL,NULL,NULL),('1295978804606402561','1295978720573521921','1207570630070976514','9.pdf','jjrcw/talentFile/talentCommonFile/202008/1295978804526710785.pdf',2,NULL,'2020-08-19 14:59:59',NULL,NULL,NULL),('1295979616204226561','1295979371391090689','1207570630070976514','1.jpg','jjrcw/talentFile/talentCommonFile/202008/1295979616078397442.jpg',1,NULL,'2020-08-19 15:03:13',NULL,NULL,NULL),('1295979701549924354','1295979371391090689','1207570630070976514','2.pdf','jjrcw/talentFile/talentCommonFile/202008/1295979701424095234.pdf',2,NULL,'2020-08-19 15:03:33',NULL,NULL,NULL),('1295979736798855170','1295979371391090689','1207570630070976514','3.jpg','jjrcw/talentFile/talentCommonFile/202008/1295979736723357698.jpg',3,NULL,'2020-08-19 15:03:42',NULL,NULL,NULL),('1295980634677706753','1295980578599862273','1207570630070976514','4.jpg','jjrcw/talentFile/talentCommonFile/202008/1295980634509934593.jpg',1,NULL,'2020-08-19 15:07:16',NULL,NULL,NULL),('1295980712897282050','1295980578599862273','1207570630070976514','5.pdf','jjrcw/talentFile/talentCommonFile/202008/1295980712775647233.pdf',2,NULL,'2020-08-19 15:07:34',NULL,NULL,NULL),('1295980750046232578','1295980578599862273','1207570630070976514','6.jpg','jjrcw/talentFile/talentCommonFile/202008/1295980749949763586.jpg',3,NULL,'2020-08-19 15:07:43',NULL,NULL,NULL),('1295981366252404737','1295981316113694722','1207570630070976514','a.jpg','jjrcw/talentFile/talentCommonFile/202008/1295981366130769921.jpg',1,NULL,'2020-08-19 15:10:10',NULL,NULL,NULL),('1295981401853657090','1295981316113694722','1207570630070976514','b.jpg','jjrcw/talentFile/talentCommonFile/202008/1295981401341952001.jpg',2,NULL,'2020-08-19 15:10:19',NULL,NULL,NULL),('1295981420967100417','1295981316113694722','1207570630070976514','c.pdf','jjrcw/talentFile/talentCommonFile/202008/1295981420870631425.pdf',3,NULL,'2020-08-19 15:10:23',NULL,NULL,NULL),('1295981906701058049','1295981852149940225','1207570630070976514','e.jpg','jjrcw/talentFile/talentCommonFile/202008/1295981906503925762.jpg',1,NULL,'2020-08-19 15:12:19',NULL,NULL,NULL),('1295981933150339073','1295981852149940225','1207570630070976514','f.pdf','jjrcw/talentFile/talentCommonFile/202008/1295981933070647298.pdf',2,NULL,'2020-08-19 15:12:25',NULL,NULL,NULL),('1295998801575673857','1295998592070189057','1207570630070976514','劳动合同1-吴康强.jpg','jjrcw/talentFile/talentCommonFile/202008/1295998800728424449.jpg',1,NULL,'2020-08-19 16:19:27',NULL,NULL,NULL),('1295998842356891650','1295998592070189057','1207570630070976514','劳动合同2-吴康强.jpg','jjrcw/talentFile/talentCommonFile/202008/1295998842264616962.jpg',2,NULL,'2020-08-19 16:19:37',NULL,NULL,NULL),('1295998891459608577','1295998592070189057','1207570630070976514','吴康强任职证明（信泰）.JPG','jjrcw/talentFile/talentCommonFile/202008/1295998891354750977.JPG',3,NULL,'2020-08-19 16:19:48',NULL,NULL,NULL),('1296002047094554625','1296001944036311041','1207570630070976514','苏倍庆 劳动合同 -1.jpg','jjrcw/talentFile/talentCommonFile/202008/1296002046964531201.jpg',1,NULL,'2020-08-19 16:32:21',NULL,NULL,NULL),('1296002078174347266','1296001944036311041','1207570630070976514','苏倍庆 劳动合同 -2.jpg','jjrcw/talentFile/talentCommonFile/202008/1296002078027546626.jpg',2,NULL,'2020-08-19 16:32:28',NULL,NULL,NULL),('1296002098944540673','1296001944036311041','1207570630070976514','苏倍庆续约-1.jpg','jjrcw/talentFile/talentCommonFile/202008/1296002098873237505.jpg',3,NULL,'2020-08-19 16:32:33',NULL,NULL,NULL),('1296002117567250434','1296001944036311041','1207570630070976514','苏倍庆续约-2.jpg','jjrcw/talentFile/talentCommonFile/202008/1296002117470781442.jpg',4,NULL,'2020-08-19 16:32:38',NULL,NULL,NULL),('1296002162286919682','1296001944036311041','1207570630070976514','任职证明-苏倍庆.jpg','jjrcw/talentFile/talentCommonFile/202008/1296002162190450690.jpg',5,NULL,'2020-08-19 16:32:48',NULL,NULL,NULL),('1296260872007581698','1296257621224849410','1207570630070976514','劳动合同书陈柏菁.pdf','jjrcw/talentFile/talentCommonFile/202008/1296260871873363970.pdf',1,NULL,'2020-08-20 09:40:49',NULL,NULL,NULL),('1297726719884652546','1297726105498808321','1207221285556019202','陶离职.jpg','jjrcw/talentFile/talentCommonFile/202008/1297726719754629121.jpg',1,NULL,'2020-08-24 10:45:35',NULL,NULL,NULL),('1299152119944835074','1299149699739152386','1161965644164075522','营业执照.png','jjrcw/talentFile/talentCommonFile/202008/1299152119806423041.png',1,NULL,'2020-08-28 09:09:37',NULL,NULL,NULL),('1299171174160396289','1299170279418884097','1207221285556019202','谢媚娜离职证明.jpg','jjrcw/talentFile/talentCommonFile/202008/1299171174034567170.jpg',1,NULL,'2020-08-28 10:25:20',NULL,NULL,NULL),('1299171314078183426','1299171271061401601','1207221285556019202','曾现萍离职证明.jpg','jjrcw/talentFile/talentCommonFile/202008/1299171313918799874.jpg',1,NULL,'2020-08-28 10:25:53',NULL,NULL,NULL),('1301397915046014977','1301397867369361410','1161965644164075522','营业执照-宜家青阳.jpg','jjrcw/talentFile/talentCommonFile/202009/1301397914932768770.jpg',1,NULL,'2020-09-03 13:53:36',NULL,NULL,NULL),('1303260905060032514','1303260797111230466','1207221285556019202','劳动合同(任学文）.pdf','jjrcw/talentFile/talentCommonFile/202009/1303260904950980609.pdf',1,NULL,'2020-09-08 17:16:27',NULL,NULL,NULL),('1303492424324104193','1303492368040738818','1207570630070976514','劳动合同(任学文）.pdf','jjrcw/talentFile/talentCommonFile/202009/1303492424177303554.pdf',1,NULL,'2020-09-09 08:36:26',NULL,NULL,NULL),('1304306136152834050','1304305490871746561','1161965644164075522','新地址营业执照.jpg','jjrcw/talentFile/talentCommonFile/202009/1304306135892787202.jpg',1,NULL,'2020-09-11 14:29:50',NULL,NULL,NULL),('1305438626460520449','1305438558596681730','1207221285556019202','蔡白-离职证明.jpg','jjrcw/talentFile/talentCommonFile/202009/1310459418462146562.jpg',1,NULL,'2020-09-14 17:29:57',NULL,'2020-09-28 14:00:47',NULL),('1306428006943748097','1303903064872222722','1161965644164075522','营业执照付本.jpg','jjrcw/talentFile/talentCommonFile/202009/1306428006721449985.jpg',1,NULL,'2020-09-17 11:01:23',NULL,NULL,NULL),('1306875460860309506','1306875186347307009','1161965644164075522','202003营业执照（副本）复印件.jpg','jjrcw/talentFile/talentCommonFile/202009/1306875460776423425.jpg',1,NULL,'2020-09-18 16:39:25',NULL,NULL,NULL),('1308591510001872897','1308591308494925825','1161965644164075522','峰安皮业股份有限公司 三证合一.jpg','jjrcw/talentFile/talentCommonFile/202009/1308591509796352002.jpg',1,NULL,'2020-09-23 10:18:23',NULL,NULL,NULL),('1308646821345685506','1308646289759596545','1161965644164075522','中国营业执照.png','jjrcw/talentFile/talentCommonFile/202009/1308646821161136130.png',1,NULL,'2020-09-23 13:58:10',NULL,NULL,NULL),('1310406452145311745','1310405806306381825','1161965644164075522','三六一度（福建）体育用品有限公司营业执照.png','jjrcw/talentFile/talentCommonFile/202009/1310406451985928193.png',1,NULL,'2020-09-28 10:30:19',NULL,NULL,NULL),('1314775388815138818','1314775354430234625','1161965644164075522','营业执照副本2020.6.28.jpg','jjrcw/talentFile/talentCommonFile/202010/1314775388659949570.jpg',1,NULL,'2020-10-10 11:50:54',NULL,NULL,NULL),('1316618552089817090','1302169476891963393','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202010/1316618551867518977.jpg',1,NULL,'2020-10-15 13:54:59',NULL,NULL,NULL),('1316896528475926529','1316636336752472066','1207570630070976514','黄天祥任职证明.jpg','jjrcw/talentFile/talentCommonFile/202010/1316896528341708801.jpg',1,NULL,'2020-10-16 08:19:33',NULL,NULL,NULL),('1316896562282016770','1316636336752472066','1207570630070976514','黄天祥合同1.jpg','jjrcw/talentFile/talentCommonFile/202010/1316896562193936385.jpg',2,NULL,'2020-10-16 08:19:41',NULL,NULL,NULL),('1316896586906775553','1316636336752472066','1207570630070976514','黄天祥合同2.jpg','jjrcw/talentFile/talentCommonFile/202010/1316896586789335041.jpg',3,NULL,'2020-10-16 08:19:47',NULL,NULL,NULL),('1316903336439492609','1314729488336068609','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202010/1316903336359800834.jpg',1,NULL,'2020-10-16 08:46:36',NULL,NULL,NULL),('1318746732389003265','1318476511497465858','1207221285556019202','苏凤全-离职证明 (20.1.1).PDF','jjrcw/talentFile/talentCommonFile/202010/1318746732217036802.PDF',1,NULL,'2020-10-21 10:51:36',NULL,NULL,NULL),('1318751295452016641','1318751160332513281','1207221285556019202','曹旭-离职证明 (20.1.1).PDF','jjrcw/talentFile/talentCommonFile/202010/1318751295351353345.PDF',1,NULL,'2020-10-21 11:09:44',NULL,NULL,NULL),('1318757964932247553','1318757560152551425','1207570630070976514','苏凤全劳动合同.PDF','jjrcw/talentFile/talentCommonFile/202010/1318757964781252609.PDF',1,NULL,'2020-10-21 11:36:14',NULL,NULL,NULL),('1318757992946003969','1318757560152551425','1207570630070976514','苏凤全任职证明.PDF','jjrcw/talentFile/talentCommonFile/202010/1318757992862117890.PDF',2,NULL,'2020-10-21 11:36:21',NULL,NULL,NULL),('1319082809771487234','1319082526219759618','1207221285556019202','37a8e2f16c5b998051aee99f0ef7ee24.pdf','jjrcw/talentFile/talentCommonFile/202010/1319082809540800513.pdf',1,NULL,'2020-10-22 09:07:03',NULL,NULL,NULL),('1319114690168680450','1319112547231657985','1207221285556019202','com.a fion.pdf','jjrcw/talentFile/talentCommonFile/202010/1319114690093182977.pdf',1,NULL,'2020-10-22 11:13:44',NULL,NULL,NULL),('1319115109741686785','1319112623991615489','1207221285556019202','#AIMINI (GGUEGA4 35058319781124371X, 2000 4 7 F.pdf','jjrcw/talentFile/talentCommonFile/202010/1319115109620051969.pdf',1,NULL,'2020-10-22 11:15:24',NULL,NULL,NULL),('1320217756666228738','1315609900495187969','1207221285556019202','离职证明.pdf','jjrcw/talentFile/talentCommonFile/202010/1320217756498456577.pdf',1,NULL,'2020-10-25 12:16:56',NULL,NULL,NULL),('1320633307326640129','1214348286694084609','1161965644164075522','营业执照.jpg','jjrcw/talentFile/talentCommonFile/202010/1320633307213393922.jpg',1,NULL,'2020-10-26 15:48:11',NULL,NULL,NULL),('1321356141657124865','1321355423793606658','1207570630070976514','1.jpg','jjrcw/talentFile/talentCommonFile/202010/1321356141556461570.jpg',1,NULL,'2020-10-28 15:40:28',NULL,NULL,NULL),('1321356182203461633','1321355423793606658','1207570630070976514','2.jpg','jjrcw/talentFile/talentCommonFile/202010/1321356182090215425.jpg',2,NULL,'2020-10-28 15:40:38',NULL,NULL,NULL),('1321356210628259842','1321355423793606658','1207570630070976514','3.jpg','jjrcw/talentFile/talentCommonFile/202010/1321356210544373761.jpg',3,NULL,'2020-10-28 15:40:44',NULL,NULL,NULL),('1321356237773795329','1321355423793606658','1207570630070976514','4.jpg','jjrcw/talentFile/talentCommonFile/202010/1321356237715075074.jpg',4,NULL,'2020-10-28 15:40:51',NULL,NULL,NULL),('1321356277544185857','1321355423793606658','1207570630070976514','renzhi.jpg','jjrcw/talentFile/talentCommonFile/202010/1321356277451911170.jpg',5,NULL,'2020-10-28 15:41:00',NULL,NULL,NULL),('1321372268655341569','1321372108852359170','1207570630070976514','劳动合同-曹旭.PDF','jjrcw/talentFile/talentCommonFile/202010/1321372268516929537.PDF',1,NULL,'2020-10-28 16:44:33',NULL,NULL,NULL),('1321372321025421314','1321372108852359170','1207570630070976514','任职证明-曹旭.PDF','jjrcw/talentFile/talentCommonFile/202010/1321372320887009281.PDF',2,NULL,'2020-10-28 16:44:45',NULL,NULL,NULL),('1322082274862231553','1322082101486481410','1207221285556019202','离职证明.pdf','jjrcw/talentFile/talentCommonFile/202010/1322082274748985345.pdf',1,NULL,'2020-10-30 15:45:52',NULL,NULL,NULL),('1322083241049518081','1322083173877739521','1207221285556019202','离职证明.pdf','jjrcw/talentFile/talentCommonFile/202010/1322083240944660481.pdf',1,NULL,'2020-10-30 15:49:42',NULL,NULL,NULL),('1322083783561768961','1322083639613255682','1207221285556019202','离职证明.pdf','jjrcw/talentFile/talentCommonFile/202010/1322083783431745538.pdf',1,NULL,'2020-10-30 15:51:51',NULL,NULL,NULL),('1322084311037440001','1322084259506221057','1207221285556019202','离职证明-乔松.pdf','jjrcw/talentFile/talentCommonFile/202010/1322084310903222273.pdf',1,NULL,'2020-10-30 15:53:57',NULL,NULL,NULL),('1322086492998266882','1322086429735579649','1207221285556019202','离职证明.pdf','jjrcw/talentFile/talentCommonFile/202010/1322086492910186498.pdf',1,NULL,'2020-10-30 16:02:37',NULL,NULL,NULL),('1322100294477213697','1322096939352780802','1207570630070976514','劳动合同-吴真兰.doc.pdf','jjrcw/talentFile/talentCommonFile/202010/1322100294355578881.pdf',1,NULL,'2020-10-30 16:57:28',NULL,NULL,NULL),('1322504269475147778','1322096939352780802','1207570630070976514','任职证明-吴真兰.jpg','jjrcw/talentFile/talentCommonFile/202010/1322504269399650305.jpg',2,NULL,'2020-10-31 19:42:43',NULL,NULL,NULL),('1323550247867183105','1323550124932132866','1207570630070976514','劳务合同1.pdf','jjrcw/talentFile/talentCommonFile/202011/1323550247783297026.pdf',1,NULL,'2020-11-03 16:59:04',NULL,NULL,NULL),('1323550274442293249','1323550124932132866','1207570630070976514','劳务合同2.pdf','jjrcw/talentFile/talentCommonFile/202011/1323550274375184386.pdf',2,NULL,'2020-11-03 16:59:10',NULL,NULL,NULL),('1323550309057884161','1323550124932132866','1207570630070976514','劳务合同3.pdf','jjrcw/talentFile/talentCommonFile/202011/1323550308940443650.pdf',3,NULL,'2020-11-03 16:59:18',NULL,NULL,NULL),('1323550345439277058','1323550124932132866','1207570630070976514','劳务合同4.pdf','jjrcw/talentFile/talentCommonFile/202011/1323550345305059329.pdf',4,NULL,'2020-11-03 16:59:27',NULL,NULL,NULL),('1323550380881145858','1323550124932132866','1207570630070976514','任职证明.pdf','jjrcw/talentFile/talentCommonFile/202011/1323550380822425601.pdf',5,NULL,'2020-11-03 16:59:35',NULL,NULL,NULL),('1323820506914287618','1323812563166752770','1207570630070976514','合同1.pdf','jjrcw/talentFile/talentCommonFile/202011/1323820506822012930.pdf',1,NULL,'2020-11-04 10:52:58',NULL,NULL,NULL),('1323820530708574210','1323812563166752770','1207570630070976514','合同2.pdf','jjrcw/talentFile/talentCommonFile/202011/1323820530595328002.pdf',2,NULL,'2020-11-04 10:53:04',NULL,NULL,NULL),('1323820560764956674','1323812563166752770','1207570630070976514','任职证明.pdf','jjrcw/talentFile/talentCommonFile/202011/1323820560702042114.pdf',3,NULL,'2020-11-04 10:53:11',NULL,NULL,NULL),('1323823815590998018','1323822105413873666','1207570630070976514','合同1.pdf','jjrcw/talentFile/talentCommonFile/202011/1323823815414837250.pdf',1,NULL,'2020-11-04 11:06:07',NULL,NULL,NULL),('1323823837875335170','1323822105413873666','1207570630070976514','合同2.pdf','jjrcw/talentFile/talentCommonFile/202011/1323823837787254785.pdf',2,NULL,'2020-11-04 11:06:13',NULL,NULL,NULL),('1323823858226098178','1323822105413873666','1207570630070976514','任职证明.pdf','jjrcw/talentFile/talentCommonFile/202011/1323823858150600706.pdf',3,NULL,'2020-11-04 11:06:17',NULL,NULL,NULL),('1325597445744349186','1289020182685081602','1207221285556019202','闫娇-离职证明.JPG','jjrcw/talentFile/talentCommonFile/202011/1325597445660463106.JPG',1,NULL,'2020-11-09 08:33:54',NULL,NULL,NULL),('1327040009018142721','1326800500049358850','1207221285556019202','林本慧 离职材料 20201016.pdf','jjrcw/talentFile/talentCommonFile/202011/1327040008896507905.pdf',1,NULL,'2020-11-13 08:06:08',NULL,NULL,NULL),('1328176865319337985','1328176666186366978','1207221285556019202','解聘证明.jpg','jjrcw/talentFile/talentCommonFile/202011/1328176865227063298.jpg',1,NULL,'2020-11-16 11:23:35',NULL,NULL,NULL),('1329223030844424193','1329222389707309057','1207221285556019202','员工离职申请表_人力资源部_萧志勤_20200212.pdf','jjrcw/talentFile/talentCommonFile/202011/1329223030731177986.pdf',1,NULL,'2020-11-19 08:40:40',NULL,NULL,NULL),('1329608732404875265','1329608481291894786','1161965644164075522','2020协创所新营业执照.jpg','jjrcw/talentFile/talentCommonFile/202011/1329608732300017665.jpg',1,NULL,'2020-11-20 10:13:19',NULL,NULL,NULL),('1329668823002906626','1329668382710038530','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202011/1329668822893854722.jpg',1,NULL,'2020-11-20 14:12:06',NULL,NULL,NULL),('1329682906234224642','1329682704215572481','1207570630070976514','合同.pdf','jjrcw/talentFile/talentCommonFile/202011/1329682906129367041.pdf',1,NULL,'2020-11-20 15:08:03',NULL,NULL,NULL),('1329682995946192898','1329682704215572481','1207570630070976514','合同2.pdf','jjrcw/talentFile/talentCommonFile/202011/1329682995841335297.pdf',2,NULL,'2020-11-20 15:08:25',NULL,NULL,NULL),('1329683090271895554','1329682704215572481','1207570630070976514','任职证明.pdf','jjrcw/talentFile/talentCommonFile/202011/1329683090196398081.pdf',3,NULL,'2020-11-20 15:08:47',NULL,NULL,NULL),('1329690520842141698','1329690428324184065','1207221285556019202','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202011/1329690520535957505.jpg',1,NULL,'2020-11-20 15:38:19',NULL,NULL,NULL),('1329690873251758082','1329690835482050562','1207221285556019202','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202011/1329690873125928961.jpg',1,NULL,'2020-11-20 15:39:43',NULL,NULL,NULL),('1329690975840239617','1329690939496595458','1207221285556019202','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202011/1329690975693438977.jpg',1,NULL,'2020-11-20 15:40:07',NULL,NULL,NULL),('1329691069180280834','1329691036259188737','1207221285556019202','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202011/1329691069092200450.jpg',1,NULL,'2020-11-20 15:40:30',NULL,NULL,NULL),('1329691582080745473','1329691543170187266','1207221285556019202','庄金红、郑龚峰、蔡玉珊局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202011/1329691581996859393.jpg',1,NULL,'2020-11-20 15:42:32',NULL,NULL,NULL),('1331056985826656258','1329222389707309057','1207221285556019202','肖志勤离职证明.pdf','jjrcw/talentFile/talentCommonFile/202011/1331056985730187266.pdf',2,NULL,'2020-11-24 10:08:09',NULL,NULL,NULL),('1331147315242598401','1328890377779806210','1207221285556019202','离职证明-贾明国.pdf','jjrcw/talentFile/talentCommonFile/202011/1331147315146129410.pdf',1,NULL,'2020-11-24 16:07:06',NULL,NULL,NULL),('1332258532250091521','1330729084862332929','1207570630070976514','聘用协议.jpg','jjrcw/talentFile/talentCommonFile/202011/1332258532086513665.jpg',1,NULL,'2020-11-27 17:42:40',NULL,NULL,NULL),('1332258553292914689','1330729084862332929','1207570630070976514','任职证明.jpg','jjrcw/talentFile/talentCommonFile/202011/1332258553192251394.jpg',2,NULL,'2020-11-27 17:42:45',NULL,NULL,NULL),('1333217289197060098','1331159884808323074','1207221285556019202','黄璇璇 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202011/1333217289083813890.jpg',1,NULL,'2020-11-30 09:12:26',NULL,NULL,NULL),('1333217582110474241','1331160607969247233','1207221285556019202','陆昌兴 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202011/1333217581976256514.jpg',1,NULL,'2020-11-30 09:13:36',NULL,NULL,NULL),('1333219488694272001','1331160801095974913','1207221285556019202','翁森 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202011/1333219488530694145.jpg',1,NULL,'2020-11-30 09:21:10',NULL,NULL,NULL),('1333219697729994753','1331161316525604865','1207221285556019202','张朋朋 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202011/1333219697587388417.jpg',1,NULL,'2020-11-30 09:22:00',NULL,NULL,NULL),('1334304257381236738','1334303374366998530','1161965644164075522','营业执照.png','jjrcw/talentFile/talentCommonFile/202012/1334304257276379137.png',1,NULL,'2020-12-03 09:11:39',NULL,NULL,NULL),('1334502342149537793','1334091599327526913','1207570630070976514','劳动合同-闫肃.pdf','jjrcw/talentFile/talentCommonFile/202012/1334502341973377025.pdf',1,NULL,'2020-12-03 22:18:46',NULL,NULL,NULL),('1334502403445096450','1334091599327526913','1207570630070976514','任职证明-闫肃.pdf','jjrcw/talentFile/talentCommonFile/202012/1334502403340238849.pdf',2,NULL,'2020-12-03 22:19:01',NULL,NULL,NULL),('1334792109571440641','1334792081473798145','1207221285556019202','李明鑫 离职证明 20200710.jpg','jjrcw/talentFile/talentCommonFile/202012/1334792109433028609.jpg',1,NULL,'2020-12-04 17:30:12',NULL,NULL,NULL),('1334792314479968258','1334792292338237442','1207221285556019202','沈久相 离职证明20200209.jpg','jjrcw/talentFile/talentCommonFile/202012/1334792314354139138.jpg',1,NULL,'2020-12-04 17:31:01',NULL,NULL,NULL),('1335208902064603137','1335208475017347073','1207570630070976514','img001.jpg','jjrcw/talentFile/talentCommonFile/202012/1335208901833916418.jpg',1,NULL,'2020-12-05 21:06:23',NULL,NULL,NULL),('1335208939188387842','1335208475017347073','1207570630070976514','img002.jpg','jjrcw/talentFile/talentCommonFile/202012/1335208939083530242.jpg',2,NULL,'2020-12-05 21:06:32',NULL,NULL,NULL),('1335208975875964929','1335208475017347073','1207570630070976514','img003.jpg','jjrcw/talentFile/talentCommonFile/202012/1335208975741747201.jpg',3,NULL,'2020-12-05 21:06:41',NULL,NULL,NULL),('1335209030301253633','1335208475017347073','1207570630070976514','img004.jpg','jjrcw/talentFile/talentCommonFile/202012/1335209030192201729.jpg',4,NULL,'2020-12-05 21:06:54',NULL,NULL,NULL),('1335209085636706306','1335208475017347073','1207570630070976514','img005.jpg','jjrcw/talentFile/talentCommonFile/202012/1335209085494099970.jpg',5,NULL,'2020-12-05 21:07:07',NULL,NULL,NULL),('1335797607531806722','1335797010728484866','1161965644164075522','1212253296652259330.jpg','jjrcw/talentFile/talentCommonFile/202012/1335797607456309250.jpg',1,NULL,'2020-12-07 12:05:42',NULL,NULL,NULL),('1335842137316524034','1335841978583089154','1207570630070976514','林东旭劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202012/1335842136968396802.jpg',1,NULL,'2020-12-07 15:02:38',NULL,NULL,NULL),('1335842154659971074','1335841978583089154','1207570630070976514','劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202012/1335842154563502082.jpg',2,NULL,'2020-12-07 15:02:43',NULL,NULL,NULL),('1335842173769220097','1335841978583089154','1207570630070976514','劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202012/1335842173635002369.jpg',3,NULL,'2020-12-07 15:02:47',NULL,NULL,NULL),('1335842192102522881','1335841978583089154','1207570630070976514','劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202012/1335842192014442498.jpg',4,NULL,'2020-12-07 15:02:52',NULL,NULL,NULL),('1335842221563314178','1335841978583089154','1207570630070976514','林东旭劳动合同5.jpg','jjrcw/talentFile/talentCommonFile/202012/1335842221429096450.jpg',5,NULL,'2020-12-07 15:02:59',NULL,NULL,NULL),('1335842453931950082','1335841978583089154','1207570733326352385','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202012/1335842453835481090.jpg',1,NULL,'2020-12-07 15:03:54',NULL,NULL,NULL),('1335843063527899138','1335843009408794625','1207570733326352385','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843063389487105.jpg',1,NULL,'2020-12-07 15:06:19',NULL,NULL,NULL),('1335843160823169025','1335843009408794625','1207570630070976514','方仲宁劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843160659591169.jpg',1,NULL,'2020-12-07 15:06:42',NULL,NULL,NULL),('1335843182037958658','1335843009408794625','1207570630070976514','劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843181945683970.jpg',2,NULL,'2020-12-07 15:06:48',NULL,NULL,NULL),('1335843205815468033','1335843009408794625','1207570630070976514','劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843205706416129.jpg',3,NULL,'2020-12-07 15:06:53',NULL,NULL,NULL),('1335843227655208962','1335843009408794625','1207570630070976514','劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843227571322881.jpg',4,NULL,'2020-12-07 15:06:58',NULL,NULL,NULL),('1335843247070642178','1335843009408794625','1207570630070976514','方仲宁劳动合同5.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843246995144706.jpg',5,NULL,'2020-12-07 15:07:03',NULL,NULL,NULL),('1335843500561793026','1335843457607925762','1207570630070976514','蔡华裕劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843500448546817.jpg',1,NULL,'2020-12-07 15:08:03',NULL,NULL,NULL),('1335843519306137601','1335843457607925762','1207570630070976514','劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843519188697089.jpg',2,NULL,'2020-12-07 15:08:08',NULL,NULL,NULL),('1335843536989323266','1335843457607925762','1207570630070976514','劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843536901242882.jpg',3,NULL,'2020-12-07 15:08:12',NULL,NULL,NULL),('1335843553590378498','1335843457607925762','1207570630070976514','劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843553451966466.jpg',4,NULL,'2020-12-07 15:08:16',NULL,NULL,NULL),('1335843571428753410','1335843457607925762','1207570630070976514','蔡华裕劳动合同5.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843571302924290.jpg',5,NULL,'2020-12-07 15:08:20',NULL,NULL,NULL),('1335843895161913345','1335843457607925762','1207570733326352385','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202012/1335843894985752577.jpg',1,NULL,'2020-12-07 15:09:38',NULL,NULL,NULL),('1335844152344051713','1335844098279473153','1207570733326352385','蔡华裕、林东旭、方仲宁、叶泽毅局人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202012/1335844152201445378.jpg',1,NULL,'2020-12-07 15:10:39',NULL,NULL,NULL),('1335844350134845442','1335844098279473153','1207570630070976514','叶泽毅劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202012/1335844350029987841.jpg',1,NULL,'2020-12-07 15:11:26',NULL,NULL,NULL),('1335844367658647553','1335844098279473153','1207570630070976514','劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202012/1335844367583150081.jpg',2,NULL,'2020-12-07 15:11:30',NULL,NULL,NULL),('1335844388714053634','1335844098279473153','1207570630070976514','劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202012/1335844388588224513.jpg',3,NULL,'2020-12-07 15:11:35',NULL,NULL,NULL),('1335844405797453825','1335844098279473153','1207570630070976514','劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202012/1335844405705179138.jpg',4,NULL,'2020-12-07 15:11:39',NULL,NULL,NULL),('1335844427163238402','1335844098279473153','1207570630070976514','叶泽毅劳动合同5.jpg','jjrcw/talentFile/talentCommonFile/202012/1335844427062575106.jpg',5,NULL,'2020-12-07 15:11:44',NULL,NULL,NULL),('1335845107273826306','1335845046208954370','1207570630070976514','庄金红劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202012/1335845107147997185.jpg',1,NULL,'2020-12-07 15:14:27',NULL,NULL,NULL),('1335845120775290881','1335845046208954370','1207570630070976514','庄金红劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202012/1335845120699793409.jpg',2,NULL,'2020-12-07 15:14:30',NULL,NULL,NULL),('1335845134083817473','1335845046208954370','1207570630070976514','庄金红劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202012/1335845133983154177.jpg',3,NULL,'2020-12-07 15:14:33',NULL,NULL,NULL),('1335845146326990850','1335845046208954370','1207570630070976514','庄金红劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202012/1335845146230521858.jpg',4,NULL,'2020-12-07 15:14:36',NULL,NULL,NULL),('1335845158389809153','1335845046208954370','1207570630070976514','庄金红劳动合同5.jpg','jjrcw/talentFile/talentCommonFile/202012/1335845158305923074.jpg',5,NULL,'2020-12-07 15:14:39',NULL,NULL,NULL),('1335845291600904193','1335845046208954370','1207570733326352385','庄金红、郑龚峰、蔡玉珊局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202012/1335845291416354818.jpg',1,NULL,'2020-12-07 15:15:10',NULL,NULL,NULL),('1336126286862483458','1322083960808861698','1207221285556019202','离职证明-白述铭.pdf','jjrcw/talentFile/talentCommonFile/202012/1336126286757625858.pdf',1,NULL,'2020-12-08 09:51:45',NULL,NULL,NULL),('1336960211180584962','1336960101503729665','1161965644164075522','创标执照.jpg','jjrcw/talentFile/talentCommonFile/202012/1336960211075727362.jpg',1,NULL,'2020-12-10 17:05:28',NULL,NULL,NULL),('1337225407497240577','1337217199927984129','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202012/1337225407417548802.jpg',1,NULL,'2020-12-11 10:39:16',NULL,NULL,NULL),('1337232726180233218','1329684514586230786','1207570630070976514','杨晓日任职证明.pdf','jjrcw/talentFile/talentCommonFile/202012/1337232726096347138.pdf',3,NULL,'2020-12-11 11:08:21',NULL,NULL,NULL),('1337235171102949378','1337233589699346434','1207570630070976514','工作证明.png','jjrcw/talentFile/talentCommonFile/202012/1337235171002286082.png',1,NULL,'2020-12-11 11:18:04',NULL,NULL,NULL),('1337235495989542914','1337233589699346434','1207570630070976514','合同2.png','jjrcw/talentFile/talentCommonFile/202012/1337235495922434049.png',2,NULL,'2020-12-11 11:19:21',NULL,NULL,NULL),('1337235534266761218','1337233589699346434','1207570630070976514','合同1.png','jjrcw/talentFile/talentCommonFile/202012/1337235534166097921.png',3,NULL,'2020-12-11 11:19:30',NULL,NULL,NULL),('1339395514109526017','1339394605908492290','1207221285556019202','0d9d45766d54f5dd144d6062d5d88cf.jpg','jjrcw/talentFile/talentCommonFile/202012/1339395513996279809.jpg',1,NULL,'2020-12-17 10:22:29',NULL,NULL,NULL),('1339471966247059457','1329684514586230786','1207570630070976514','杨晓日合同1.pdf','jjrcw/talentFile/talentCommonFile/202012/1339471966117036033.pdf',4,NULL,'2020-12-17 15:26:17',NULL,NULL,NULL),('1339471989231845377','1329684514586230786','1207570630070976514','杨晓日合同2.pdf','jjrcw/talentFile/talentCommonFile/202012/1339471989106016257.pdf',5,NULL,'2020-12-17 15:26:23',NULL,NULL,NULL),('1341197379382018049','1341197188524408833','1207570630070976514','3、陶鹏合同正面.JPG','jjrcw/talentFile/talentCommonFile/202012/1341197379268771841.JPG',1,NULL,'2020-12-22 09:42:28',NULL,NULL,NULL),('1341197408842809345','1341197188524408833','1207570630070976514','3、陶鹏合同反面.JPG','jjrcw/talentFile/talentCommonFile/202012/1341197408691814401.JPG',2,NULL,'2020-12-22 09:42:35',NULL,NULL,NULL),('1341197446532825090','1341197188524408833','1207570630070976514','陶鹏-任职证明.JPG','jjrcw/talentFile/talentCommonFile/202012/1341197446465716225.JPG',3,NULL,'2020-12-22 09:42:44',NULL,NULL,NULL),('1341288475957133313','1341287672924078082','1161965644164075522','营业执照2020.04.09.png','jjrcw/talentFile/talentCommonFile/202012/1341288475860664322.png',1,NULL,'2020-12-22 15:44:27',NULL,NULL,NULL),('1341292017971363842','1341291878003245058','1207221285556019202','林一速-调动证明.pdf','jjrcw/talentFile/talentCommonFile/202012/1341292017908449281.pdf',1,NULL,'2020-12-22 15:58:31',NULL,NULL,NULL),('1341295286907043841','1341295056451010561','1207570630070976514','3.1林一速劳动合同(福建恒安家庭).pdf','jjrcw/talentFile/talentCommonFile/202012/1341295286806380546.pdf',1,NULL,'2020-12-22 16:11:31',NULL,NULL,NULL),('1341295302207864833','1341295056451010561','1207570630070976514','1.9.4林一速在职证明.pdf','jjrcw/talentFile/talentCommonFile/202012/1341295302132367361.pdf',2,NULL,'2020-12-22 16:11:34',NULL,NULL,NULL),('1343086131339616258','1335208475017347073','1207570630070976514','希领证明.jpg','jjrcw/talentFile/talentCommonFile/202012/1343086131201204226.jpg',6,NULL,'2020-12-27 14:47:41',NULL,NULL,NULL),('1343392521392250881','1343392101882159105','1161965644164075522','营业执照-恒安（中国）纸业有限公司.jpg','jjrcw/talentFile/talentCommonFile/202012/1343392521291587587.jpg',1,NULL,'2020-12-28 11:05:10',NULL,NULL,NULL),('1344480805220515842','1344480572633776129','1161965644164075522','营业执照.png','jjrcw/talentFile/talentCommonFile/202012/1344480805103075329.png',1,NULL,'2020-12-31 11:09:37',NULL,NULL,NULL),('1344492113852628994','1344480572633776129','1177047550859280385','内资企业情况表1.png','jjrcw/talentFile/talentCommonFile/202012/1344492113751965699.png',1,NULL,'2020-12-31 11:54:34',NULL,NULL,NULL),('1344492184065277953','1344480572633776129','1177047550859280385','内资企业情况表2.png','jjrcw/talentFile/talentCommonFile/202012/1344492183998169090.png',2,NULL,'2020-12-31 11:54:50',NULL,NULL,NULL),('1344542845687562241','1344542707086786562','1161965644164075522','营业执照副本.jpg','jjrcw/talentFile/talentCommonFile/202012/1344542845549150210.jpg',1,NULL,'2020-12-31 15:16:09',NULL,NULL,NULL),('1349273547691786241','1346630779567865858','1161965644164075522','营业执照-2020.jpg','jjrcw/talentFile/talentCommonFile/202101/1349273547456905218.jpg',1,NULL,'2021-01-13 16:34:16',NULL,NULL,NULL),('1355056639190761473','1355056578058780673','1161965644164075522','卡尔美营业执照.jpg','jjrcw/talentFile/talentCommonFile/202101/1355056639073320962.jpg',1,NULL,'2021-01-29 15:34:13',NULL,NULL,NULL),('1355056847110799361','1355056578058780673','1177047550859280385','lALPBFuNcgS7dxjNDbPNCbA_2480_3507.png','jjrcw/talentFile/talentCommonFile/202101/1355056846984970242.png',1,NULL,'2021-01-29 15:35:02',NULL,NULL,NULL),('1356405529894715393','1356405446390317058','1207221285556019202','（许小军）解除（终止）劳动关系证明.jpg','jjrcw/talentFile/talentCommonFile/202102/1356405529823412225.jpg',1,NULL,'2021-02-02 08:54:13',NULL,NULL,NULL),('1356786813439574017','1356786341190303745','1161965644164075522','营业执照副本.jpg','jjrcw/talentFile/talentCommonFile/202102/1356786813355687937.jpg',1,NULL,'2021-02-03 10:09:18',NULL,NULL,NULL),('1358239059201269762','1358238807761133569','1207221285556019202','IMG20210207_101949.jpg','jjrcw/talentFile/talentCommonFile/202102/1358239059054469121.jpg',1,NULL,'2021-02-07 10:20:01',NULL,NULL,NULL),('1358316247372046337','1358316064051601409','1207221285556019202','IMG20210207_152632.jpg','jjrcw/talentFile/talentCommonFile/202102/1358316247267188737.jpg',1,NULL,'2021-02-07 15:26:44',NULL,NULL,NULL),('1362223719358963714','1362216863420948482','1207570630070976514','李志灿-劳动合同-丰裕泰.pdf','jjrcw/talentFile/talentCommonFile/202102/1362223719166025730.pdf',1,NULL,'2021-02-18 10:13:38',NULL,NULL,NULL),('1362224895701852162','1362216863420948482','1207570630070976514','李志灿-劳动合同-丰预泰.pdf','jjrcw/talentFile/talentCommonFile/202102/1362224895500525569.pdf',2,NULL,'2021-02-18 10:18:18',NULL,NULL,NULL),('1362225268126687234','1362216863420948482','1207570630070976514','说明.pdf','jjrcw/talentFile/talentCommonFile/202102/1362225267929554945.pdf',3,NULL,'2021-02-18 10:19:47',NULL,NULL,NULL),('1364055945633636353','1363020223380234242','1161965644164075522','福建营业执照  副本  2018.01.17.jpg','jjrcw/talentFile/talentCommonFile/202102/1364055945549750273.jpg',1,NULL,'2021-02-23 11:34:15',NULL,NULL,NULL),('1364056921933389825','1364056861313114113','1161965644164075522','中国营业执照  副本  2017.11.27.jpg','jjrcw/talentFile/talentCommonFile/202102/1364056921832726529.jpg',1,NULL,'2021-02-23 11:38:07',NULL,NULL,NULL),('1364454539192737794','1363397950100774913','1207221285556019202','0-叶雅瑜离职证明-202102.pdf','jjrcw/talentFile/talentCommonFile/202102/1364454539092074498.pdf',1,NULL,'2021-02-24 13:58:07',NULL,NULL,NULL),('1366598045864599553','1366315067854856194','1207221285556019202','庄洋洋离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1366598045776519170.jpg',1,NULL,'2021-03-02 11:55:38',NULL,NULL,NULL),('1366598291613065218','1366598246557851649','1207221285556019202','辜冬梅离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1366598291516596225.jpg',1,NULL,'2021-03-02 11:56:37',NULL,NULL,NULL),('1366598668827795458','1366598551475363841','1207221285556019202','王淑莲离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1366598668697772033.jpg',1,NULL,'2021-03-02 11:58:07',NULL,NULL,NULL),('1366598889347522562','1366598846339129345','1207221285556019202','宗月离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1366598889288802305.jpg',1,NULL,'2021-03-02 11:59:00',NULL,NULL,NULL),('1366599153055997954','1366599090267267073','1207221285556019202','陈恺炜离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1366599152976306177.jpg',1,NULL,'2021-03-02 12:00:02',NULL,NULL,NULL),('1366599375773540354','1366599349915656194','1207221285556019202','施云离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1366599375664488449.jpg',1,NULL,'2021-03-02 12:00:56',NULL,NULL,NULL),('1366599542132219906','1366599510364561409','1207221285556019202','李丽离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1366599542031556610.jpg',1,NULL,'2021-03-02 12:01:35',NULL,NULL,NULL),('1369169415916003329','1369169320424284161','1161965644164075522','锦福营业执照盖章.jpg','jjrcw/talentFile/talentCommonFile/202103/1369169415777591297.jpg',1,NULL,'2021-03-09 14:13:21',NULL,NULL,NULL),('1369169850403954690','1369169820532121602','1161965644164075522','正麒营业执照.jpg','jjrcw/talentFile/talentCommonFile/202103/1369169850307485697.jpg',1,NULL,'2021-03-09 14:15:04',NULL,NULL,NULL),('1369170079836577794','1369170026833158146','1161965644164075522','锦兴营业执照盖章.jpg','jjrcw/talentFile/talentCommonFile/202103/1369170079681388546.jpg',1,NULL,'2021-03-09 14:15:59',NULL,NULL,NULL),('1369820869655830529','1369820739598852097','1207570630070976514','丰裕泰合同-郑桂军.pdf','jjrcw/talentFile/talentCommonFile/202103/1369820869576138754.pdf',1,NULL,'2021-03-11 09:22:00',NULL,NULL,NULL),('1369827953801732098','1369820739598852097','1207570630070976514','在职证明.JPG','jjrcw/talentFile/talentCommonFile/202103/1369827953659125761.JPG',2,NULL,'2021-03-11 09:50:09',NULL,NULL,NULL),('1369828426273300482','1369820739598852097','1207570630070976514','丰预泰合同-郑桂军.pdf','jjrcw/talentFile/talentCommonFile/202103/1369828426176831490.pdf',3,NULL,'2021-03-11 09:52:01',NULL,NULL,NULL),('1369829054030585857','1369820739598852097','1207570630070976514','工作单位说明.pdf','jjrcw/talentFile/talentCommonFile/202103/1369829053892173826.pdf',4,NULL,'2021-03-11 09:54:31',NULL,NULL,NULL),('1369838238235140097','1369838143238348801','1207570630070976514','李志灿-劳动合同-丰预泰.pdf','jjrcw/talentFile/talentCommonFile/202103/1369838238159642625.pdf',1,NULL,'2021-03-11 10:31:01',NULL,NULL,NULL),('1369838256887209985','1369838143238348801','1207570630070976514','李志灿-劳动合同-丰裕泰.pdf','jjrcw/talentFile/talentCommonFile/202103/1369838256744603649.pdf',2,NULL,'2021-03-11 10:31:05',NULL,NULL,NULL),('1369838473246187522','1369838143238348801','1207570630070976514','在职证明-李志灿.JPG','jjrcw/talentFile/talentCommonFile/202103/1369838473149718530.JPG',3,NULL,'2021-03-11 10:31:57',NULL,NULL,NULL),('1369838936058273794','1369838901425905666','1207570630070976514','丰预泰合同-郑桂军.pdf','jjrcw/talentFile/talentCommonFile/202103/1369838935953416193.pdf',1,NULL,'2021-03-11 10:33:47',NULL,NULL,NULL),('1369838954655817730','1369838901425905666','1207570630070976514','丰裕泰合同-郑桂军.pdf','jjrcw/talentFile/talentCommonFile/202103/1369838992807206914.pdf',2,NULL,'2021-03-11 10:33:51',NULL,'2021-03-11 10:34:00',NULL),('1369839015313842177','1369838901425905666','1207570630070976514','工作单位说明.pdf','jjrcw/talentFile/talentCommonFile/202103/1369839015229956098.pdf',3,NULL,'2021-03-11 10:34:06',NULL,NULL,NULL),('1369839038348959745','1369838901425905666','1207570630070976514','在职证明-郑桂军.JPG','jjrcw/talentFile/talentCommonFile/202103/1369839038281850882.JPG',4,NULL,'2021-03-11 10:34:11',NULL,NULL,NULL),('1371643317036625922','1371642841524187138','1161965644164075522','凯燕研究院执照.jpg','jjrcw/talentFile/talentCommonFile/202103/1371643316910796802.jpg',1,NULL,'2021-03-16 10:03:45',NULL,NULL,NULL),('1371713471065993217','1371713144979828737','1161965644164075522','变更后营业执照股份.png','jjrcw/talentFile/talentCommonFile/202103/1371713470948552706.png',1,NULL,'2021-03-16 14:42:31',NULL,NULL,NULL),('1371717317918044162','1371717142902321153','1207221285556019202','许群英.jpg','jjrcw/talentFile/talentCommonFile/202103/1371717317804797954.jpg',1,NULL,'2021-03-16 14:57:48',NULL,NULL,NULL),('1371717555328233473','1371717410394058754','1207221285556019202','吴辉炫.jpg','jjrcw/talentFile/talentCommonFile/202103/1371717555219181570.jpg',1,NULL,'2021-03-16 14:58:45',NULL,NULL,NULL),('1371730178287448066','1371627084635549698','1207221285556019202','中共晋江市委关于陈铭等同志职务任免的通知.pdf','jjrcw/talentFile/talentCommonFile/202103/1371730178216144897.pdf',1,NULL,'2021-03-16 15:48:54',NULL,NULL,NULL),('1372027714491445249','1372026499707760642','1161965644164075522','泉州中升雷克萨斯汽车销售有限公司营业执照.jpg','jjrcw/talentFile/talentCommonFile/202103/1372027714382393346.jpg',1,NULL,'2021-03-17 11:31:12',NULL,NULL,NULL),('1372079789871001602','1371660311156862977','1207221285556019202','img665.jpg','jjrcw/talentFile/talentCommonFile/202103/1372079789799698434.jpg',1,NULL,'2021-03-17 14:58:08',NULL,NULL,NULL),('1372110002399014914','1372091746250452993','1207570630070976514','劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202103/1372110002306740226.jpg',1,NULL,'2021-03-17 16:58:11',NULL,NULL,NULL),('1372110034615463938','1372091746250452993','1207570630070976514','劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202103/1372110034510606337.jpg',2,NULL,'2021-03-17 16:58:19',NULL,NULL,NULL),('1372110053661798402','1372091746250452993','1207570630070976514','劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202103/1372110053561135106.jpg',3,NULL,'2021-03-17 16:58:24',NULL,NULL,NULL),('1372110067272314882','1372091746250452993','1207570630070976514','劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202103/1372110067184234498.jpg',4,NULL,'2021-03-17 16:58:27',NULL,NULL,NULL),('1372110284436598786','1372091746250452993','1207570630070976514','任职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1372110284344324098.jpg',5,NULL,'2021-03-17 16:59:19',NULL,NULL,NULL),('1372365264863207425','1371724378118664194','1207221285556019202','离职申请.jpg','jjrcw/talentFile/talentCommonFile/202103/1372365264791904258.jpg',1,NULL,'2021-03-18 09:52:31',NULL,NULL,NULL),('1372365318546104322','1371724378118664194','1207221285556019202','移交手续.jpg','jjrcw/talentFile/talentCommonFile/202103/1372365318437052418.jpg',2,NULL,'2021-03-18 09:52:43',NULL,NULL,NULL),('1372477945783885825','1372477786215784450','1207570630070976514','许群英.jpg','jjrcw/talentFile/talentCommonFile/202103/1372477945624502273.jpg',1,NULL,'2021-03-18 17:20:16',NULL,NULL,NULL),('1372478708492902401','1372478629635792898','1207570630070976514','吴辉炫.jpg','jjrcw/talentFile/talentCommonFile/202103/1372478708392239106.jpg',1,NULL,'2021-03-18 17:23:18',NULL,NULL,NULL),('1372723555694825474','1372723447255289858','1207221285556019202','张鸿鹏（重症）、蔡巧玫、李颖莹、颜培淅、张湘闽五位局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202103/1372723555594162177.jpg',1,NULL,'2021-03-19 09:36:14',NULL,NULL,NULL),('1372723767037415425','1372723740240007169','1207221285556019202','张鸿鹏（重症）、蔡巧玫、李颖莹、颜培淅、张湘闽五位局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202103/1372723766911586305.jpg',1,NULL,'2021-03-19 09:37:04',NULL,NULL,NULL),('1372724104116850690','1372724072399523841','1207221285556019202','张鸿鹏（重症）、蔡巧玫、李颖莹、颜培淅、张湘闽五位局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202103/1372724103986827266.jpg',1,NULL,'2021-03-19 09:38:25',NULL,NULL,NULL),('1372739370645213185','1372739261199044609','1207570733326352385','张鸿鹏（重症）、蔡巧玫、李颖莹、颜培淅、张湘闽五位局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202103/1372739370561327106.jpg',1,NULL,'2021-03-19 10:39:04',NULL,NULL,NULL),('1372739474940776449','1372739261199044609','1207570630070976514','蔡巧玫劳动合同01.jpg','jjrcw/talentFile/talentCommonFile/202103/1372739474823335937.jpg',1,NULL,'2021-03-19 10:39:29',NULL,NULL,NULL),('1372739488123473921','1372739261199044609','1207570630070976514','蔡巧玫劳动合同02.jpg','jjrcw/talentFile/talentCommonFile/202103/1372739487972478978.jpg',2,NULL,'2021-03-19 10:39:32',NULL,NULL,NULL),('1372739502904201218','1372739261199044609','1207570630070976514','蔡巧玫劳动合同03.jpg','jjrcw/talentFile/talentCommonFile/202103/1372739502753206273.jpg',3,NULL,'2021-03-19 10:39:36',NULL,NULL,NULL),('1372739514665029633','1372739261199044609','1207570630070976514','蔡巧玫劳动合同04.jpg','jjrcw/talentFile/talentCommonFile/202103/1372739514555977729.jpg',4,NULL,'2021-03-19 10:39:39',NULL,NULL,NULL),('1372739656646414338','1372739261199044609','1207570630070976514','蔡巧玫工作证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1372739656533168130.jpg',5,NULL,'2021-03-19 10:40:13',NULL,NULL,NULL),('1372740098788970497','1372740008791789569','1207570630070976514','张鸿鹏工作证明（重症）.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740098650558466.jpg',1,NULL,'2021-03-19 10:41:58',NULL,NULL,NULL),('1372740136487374850','1372740008791789569','1207570733326352385','张鸿鹏（重症）、蔡巧玫、李颖莹、颜培淅、张湘闽五位局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740136386711554.jpg',1,NULL,'2021-03-19 10:42:07',NULL,NULL,NULL),('1372740235200319490','1372740008791789569','1207570630070976514','张鸿鹏劳动动合同01.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740235116433410.jpg',2,NULL,'2021-03-19 10:42:31',NULL,NULL,NULL),('1372740248068444161','1372740008791789569','1207570630070976514','张鸿鹏劳动动合同02.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740247955197954.jpg',3,NULL,'2021-03-19 10:42:34',NULL,NULL,NULL),('1372740261209198594','1372740008791789569','1207570630070976514','张鸿鹏劳动动合同03.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740261079175170.jpg',4,NULL,'2021-03-19 10:42:37',NULL,NULL,NULL),('1372740280121315330','1372740008791789569','1207570630070976514','张鸿鹏劳动动合同04.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740280033234946.jpg',5,NULL,'2021-03-19 10:42:41',NULL,NULL,NULL),('1372740907299786754','1372740851205165057','1207570630070976514','李颖莹劳动合同01.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740907157180417.jpg',1,NULL,'2021-03-19 10:45:11',NULL,NULL,NULL),('1372740919693955073','1372740851205165057','1207570630070976514','李颖莹劳动合同02.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740919589097473.jpg',2,NULL,'2021-03-19 10:45:14',NULL,NULL,NULL),('1372740933358997506','1372740851205165057','1207570630070976514','李颖莹劳动合同03.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740933224779777.jpg',3,NULL,'2021-03-19 10:45:17',NULL,NULL,NULL),('1372740943706345473','1372740851205165057','1207570630070976514','李颖莹劳动合同04.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740943618265089.jpg',4,NULL,'2021-03-19 10:45:19',NULL,NULL,NULL),('1372740983871000577','1372740851205165057','1207570733326352385','张鸿鹏（重症）、蔡巧玫、李颖莹、颜培淅、张湘闽五位局行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202103/1372740983736782850.jpg',1,NULL,'2021-03-19 10:45:29',NULL,NULL,NULL),('1372741090267910145','1372740851205165057','1207570630070976514','李颖莹工作证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1372741090158858241.jpg',5,NULL,'2021-03-19 10:45:54',NULL,NULL,NULL),('1372748146987257857','1372737303264382977','1207221285556019202','金鹰杨国强人才标签修改说明.pdf','jjrcw/talentFile/talentCommonFile/202103/1372748146907566081.pdf',1,NULL,'2021-03-19 11:13:57',NULL,NULL,NULL),('1372808770001850370','1372750662995038210','1207221285556019202','离职证明-南港.jpg','jjrcw/talentFile/talentCommonFile/202103/1372808769892798465.jpg',1,NULL,'2021-03-19 15:14:50',NULL,NULL,NULL),('1372812876330323970','1372812717320065025','1207570630070976514','许群英.jpg','jjrcw/talentFile/talentCommonFile/202103/1372812876170940417.jpg',1,NULL,'2021-03-19 15:31:10',NULL,NULL,NULL),('1372827410449321985','1372827379134648322','1207221285556019202','蓝晶晶离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1372827410352852994.jpg',1,NULL,'2021-03-19 16:28:55',NULL,NULL,NULL),('1372827780630204418','1372827745523879938','1207221285556019202','吕彬彬离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1372827780516958209.jpg',1,NULL,'2021-03-19 16:30:23',NULL,NULL,NULL),('1372829372385349633','1372828864211865601','1161965644164075522','营业执照副本（2020）.jpg','jjrcw/talentFile/talentCommonFile/202103/1372829372297269249.jpg',1,NULL,'2021-03-19 16:36:42',NULL,NULL,NULL),('1372834501666820098','1372834007951101953','1207221285556019202','荣兴营业执照.jpg','jjrcw/talentFile/talentCommonFile/202103/1372834501574545410.jpg',1,NULL,'2021-03-19 16:57:05',NULL,NULL,NULL),('1372837135144472578','1372836316403748866','1207570630070976514','陈荣浩合同.pdf','jjrcw/talentFile/talentCommonFile/202103/1372837135064780801.pdf',1,NULL,'2021-03-19 17:07:33',NULL,NULL,NULL),('1373064005307879426','1371398195803959298','1207221285556019202','5d53f9161e31a7a26aa4388d961a14e.jpg','jjrcw/talentFile/talentCommonFile/202103/1373064005211410433.jpg',1,NULL,'2021-03-20 08:09:03',NULL,NULL,NULL),('1373064040066076673','1371398195803959298','1207221285556019202','cac6d6edf07b7d89f151467a4c2de5d.jpg','jjrcw/talentFile/talentCommonFile/202103/1373064040003162114.jpg',2,NULL,'2021-03-20 08:09:12',NULL,NULL,NULL),('1373156104413925378','1373155448508665858','1161965644164075522','中乔体育营业执照.jpg','jjrcw/talentFile/talentCommonFile/202103/1373156104225181698.jpg',1,NULL,'2021-03-20 14:15:01',NULL,NULL,NULL),('1373807653741940738','1373807364938944513','1207221285556019202','调动证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1373807653666443265.jpg',1,NULL,'2021-03-22 09:24:03',NULL,NULL,NULL),('1373812659442438145','1373812496074297345','1207570630070976514','调动证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1373812659358552066.jpg',1,NULL,'2021-03-22 09:43:56',NULL,NULL,NULL),('1373910349828345857','1373844148167135233','1161965644164075522','海峡石墨烯研究院营业执照.png','jjrcw/talentFile/talentCommonFile/202103/1373910349702516737.png',1,NULL,'2021-03-22 16:12:08',NULL,NULL,NULL),('1373917825604800513','1373916908155326465','1207221285556019202','祁进宇离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1373917825487360002.jpg',1,NULL,'2021-03-22 16:41:50',NULL,NULL,NULL),('1374171135964368898','1296257621224849410','1207570630070976514','在职证明.pdf','jjrcw/talentFile/talentCommonFile/202103/1374171135893065729.pdf',2,NULL,'2021-03-23 09:28:24',NULL,NULL,NULL),('1374171516517765121','1371632661415702530','1207221285556019202','齐玉波离职表.jpg','jjrcw/talentFile/talentCommonFile/202103/1374171516425490433.jpg',1,NULL,'2021-03-23 09:29:55',NULL,NULL,NULL),('1374174724950609921','1374174265758208001','1207221285556019202','陈崟离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1374174724900278274.jpg',1,NULL,'2021-03-23 09:42:40',NULL,NULL,NULL),('1374178979258322945','1374156017918562306','1207221285556019202','王翔鹏离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1374178979191214081.jpg',1,NULL,'2021-03-23 09:59:34',NULL,NULL,NULL),('1374211211058499586','1374211118087557122','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1374211210983002113.jpg',1,NULL,'2021-03-23 12:07:38',NULL,NULL,NULL),('1374245677126758402','1374245557085777921','1207221285556019202','倪娜-离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1374245677038678017.jpg',1,NULL,'2021-03-23 14:24:36',NULL,NULL,NULL),('1374538052503973890','1371724378118664194','1207221371723800578','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1374538052399116290.jpg',1,NULL,'2021-03-24 09:46:24',NULL,NULL,NULL),('1374550750314737666','1374203681792086018','1207221285556019202','{%O3A6Q7N9F7X9{S7GC4FXL.jpg','jjrcw/talentFile/talentCommonFile/202103/1374550750251823105.jpg',1,NULL,'2021-03-24 10:36:51',NULL,NULL,NULL),('1374882801077301249','1374180201793081345','1207570630070976514','王翔鹏在职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1374882800993415170.jpg',1,NULL,'2021-03-25 08:36:18',NULL,NULL,NULL),('1374882860061798401','1374180201793081345','1207570630070976514','王翔鹏劳动合同 (1).pdf','jjrcw/talentFile/talentCommonFile/202103/1374882859994689538.pdf',2,NULL,'2021-03-25 08:36:32',NULL,NULL,NULL),('1374913132580941826','1374913012397355009','1161965644164075522','锦科营业执照.png','jjrcw/talentFile/talentCommonFile/202103/1374913132492861442.png',1,NULL,'2021-03-25 10:36:50',NULL,NULL,NULL),('1374921508719276033','1374918122649268225','1207570630070976514','李液佳劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202103/1374921508656361473.jpg',1,NULL,'2021-03-25 11:10:07',NULL,NULL,NULL),('1374921528080183298','1374918122649268225','1207570630070976514','李液佳劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202103/1374921528008880129.jpg',2,NULL,'2021-03-25 11:10:11',NULL,NULL,NULL),('1374921546157633537','1374918122649268225','1207570630070976514','李液佳劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202103/1374921546073747458.jpg',3,NULL,'2021-03-25 11:10:16',NULL,NULL,NULL),('1374921562091794434','1374918122649268225','1207570630070976514','李液佳劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202103/1374921561999519746.jpg',4,NULL,'2021-03-25 11:10:19',NULL,NULL,NULL),('1374926845283250177','1374918122649268225','1207570733326352385','在职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1374926845182586882.jpg',1,NULL,'2021-03-25 11:31:19',NULL,NULL,NULL),('1374980537373990913','1374979787277246465','1207570630070976514','劳动合同书（嘉景） .pdf','jjrcw/talentFile/talentCommonFile/202103/1374980537294299137.pdf',1,NULL,'2021-03-25 15:04:40',NULL,NULL,NULL),('1374981061133508609','1374979787277246465','1207570630070976514','任职证明.png','jjrcw/talentFile/talentCommonFile/202103/1374981061066399746.png',2,NULL,'2021-03-25 15:06:45',NULL,NULL,NULL),('1375255272959811586','1375254788467367937','1207570630070976514','倪娜-劳动合同 (1).jpg','jjrcw/talentFile/talentCommonFile/202103/1375255272829788162.jpg',1,NULL,'2021-03-26 09:16:22',NULL,NULL,NULL),('1375255321706012674','1375254788467367937','1207570630070976514','倪娜-劳动合同 (2).jpg','jjrcw/talentFile/talentCommonFile/202103/1375255321584377858.jpg',2,NULL,'2021-03-26 09:16:34',NULL,NULL,NULL),('1375255357487620097','1375254788467367937','1207570630070976514','倪娜-在职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1375255357403734018.jpg',3,NULL,'2021-03-26 09:16:42',NULL,NULL,NULL),('1375281721099984897','1374288359588999170','1207221285556019202','邹明田-离职证明（主体变更）.pdf','jjrcw/talentFile/talentCommonFile/202103/1375281720944795650.pdf',1,NULL,'2021-03-26 11:01:28',NULL,NULL,NULL),('1375360292627718145','1375359996199477250','1207570630070976514','杨总劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202103/1375360292506083330.pdf',1,NULL,'2021-03-26 16:13:41',NULL,NULL,NULL),('1375360357387771906','1375359996199477250','1207570630070976514','金鹰营业执照.pdf','jjrcw/talentFile/talentCommonFile/202103/1375360357303885825.pdf',2,NULL,'2021-03-26 16:13:56',NULL,NULL,NULL),('1376369636110540802','1376369507567706114','1207221285556019202','离职证明书-姜慧勇.pdf','jjrcw/talentFile/talentCommonFile/202103/1376369636060209154.pdf',1,NULL,'2021-03-29 11:04:27',NULL,NULL,NULL),('1376448905985658881','1376448004394848258','1161965644164075522','fa5509dbd763d33cb4f9dea5af3313c.jpg','jjrcw/talentFile/talentCommonFile/202103/1376448905884995585.jpg',1,NULL,'2021-03-29 16:19:27',NULL,NULL,NULL),('1376448921097736194','1376448004394848258','1177047550859280385','90816b1a1e3335cb57a3a4d2c134bc0.jpg','jjrcw/talentFile/talentCommonFile/202103/1376448921026433025.jpg',1,NULL,'2021-03-29 16:19:30',NULL,NULL,NULL),('1376457198657343489','1376456924597325825','1207221285556019202','调动单.jpg','jjrcw/talentFile/talentCommonFile/202103/1377160490383388674.jpg',1,NULL,'2021-03-29 16:52:24',NULL,'2021-03-31 15:27:01',NULL),('1376796734914584577','1376792456741281794','1207221285556019202','2021-03-30-15-21-28.pdf','jjrcw/talentFile/talentCommonFile/202103/1376796734813921281.pdf',1,NULL,'2021-03-30 15:21:35',NULL,NULL,NULL),('1376806328831336450','1376805464003600385','1161965644164075522','27139efd9503eb20b47131cbfa9dae3.jpg','jjrcw/talentFile/talentCommonFile/202103/1376806328781004802.jpg',1,NULL,'2021-03-30 15:59:43',NULL,NULL,NULL),('1376806338838945793','1376805464003600385','1177047550859280385','010eaad5ba61e1924a18266e20d2891.jpg','jjrcw/talentFile/talentCommonFile/202103/1376806338771836931.jpg',1,NULL,'2021-03-30 15:59:45',NULL,NULL,NULL),('1377078542109585410','1377078448333336578','1207221285556019202','2020年人才标签变更汇总表-泉州职业技术大学.jpg','jjrcw/talentFile/talentCommonFile/202103/1377078541933424642.jpg',1,NULL,'2021-03-31 10:01:23',NULL,NULL,NULL),('1377079144973676546','1372481061770076161','1207221285556019202','2020年人才标签变更汇总表-泉州职业技术大学.jpg','jjrcw/talentFile/talentCommonFile/202103/1377079144814292993.jpg',1,NULL,'2021-03-31 10:03:47',NULL,NULL,NULL),('1377079217707102210','1372481825993236482','1207221285556019202','2020年人才标签变更汇总表-泉州职业技术大学.jpg','jjrcw/talentFile/talentCommonFile/202103/1377079217577078786.jpg',1,NULL,'2021-03-31 10:04:05',NULL,NULL,NULL),('1377079400301932545','1377079372929904642','1207221285556019202','2020年人才标签变更汇总表-泉州职业技术大学.jpg','jjrcw/talentFile/talentCommonFile/202103/1377079400138354690.jpg',1,NULL,'2021-03-31 10:04:48',NULL,NULL,NULL),('1377079532946796545','1377079511971082242','1207221285556019202','2020年人才标签变更汇总表-泉州职业技术大学.jpg','jjrcw/talentFile/talentCommonFile/202103/1377079532799995906.jpg',1,NULL,'2021-03-31 10:05:20',NULL,NULL,NULL),('1377080473049706497','1377080446675922946','1207221285556019202','2020年人才标签变更汇总表-泉州职业技术大学.jpg','jjrcw/talentFile/talentCommonFile/202103/1377080472877740034.jpg',1,NULL,'2021-03-31 10:09:04',NULL,NULL,NULL),('1377080608492171265','1377080576292499457','1207221285556019202','2020年人才标签变更汇总表-泉州职业技术大学.jpg','jjrcw/talentFile/talentCommonFile/202103/1377080608366342145.jpg',1,NULL,'2021-03-31 10:09:36',NULL,NULL,NULL),('1377164898580115458','1377152445146279938','1207221285556019202','利郎离职证明.jpg','jjrcw/talentFile/talentCommonFile/202103/1377164898475257857.jpg',1,NULL,'2021-03-31 15:44:32',NULL,NULL,NULL),('1377174328113704961','1377173940409020417','1207570630070976514','调动书.jpg','jjrcw/talentFile/talentCommonFile/202103/1377174328008847362.jpg',1,NULL,'2021-03-31 16:22:01',NULL,NULL,NULL),('1377428658205044738','1377428502487314433','1207221285556019202','终止（解除）劳动合同证明书.pdf','jjrcw/talentFile/talentCommonFile/202104/1377428658045661186.pdf',1,NULL,'2021-04-01 09:12:38',NULL,NULL,NULL),('1377432637563547649','1376489422186352641','1207570630070976514','第六层次-邹明田-附件2：劳动合同21年4月续签前.pdf','jjrcw/talentFile/talentCommonFile/202104/1377432637450301442.pdf',1,NULL,'2021-04-01 09:28:26',NULL,NULL,NULL),('1377432673668116481','1376489422186352641','1207570630070976514','第六层次-邹明田-附件2：三方协议书.pdf','jjrcw/talentFile/talentCommonFile/202104/1377432673554870273.pdf',2,NULL,'2021-04-01 09:28:35',NULL,NULL,NULL),('1377432707163828225','1376489422186352641','1207570630070976514','第六层次-邹明田-附件2：劳动合同21年4月续签后.pdf','jjrcw/talentFile/talentCommonFile/202104/1377432707079942145.pdf',3,NULL,'2021-04-01 09:28:43',NULL,NULL,NULL),('1377547302989803522','1376489422186352641','1207570630070976514','邹明田-在职证明.pdf','jjrcw/talentFile/talentCommonFile/202104/1377547302910111745.pdf',4,NULL,'2021-04-01 17:04:05',NULL,NULL,NULL),('1377550315745783810','1377550107448258562','1207570630070976514','陈   闻劳动合同20200101-20231231 (1).pdf','jjrcw/talentFile/talentCommonFile/202104/1377550315594788866.pdf',1,NULL,'2021-04-01 17:16:03',NULL,NULL,NULL),('1377560681875845122','1377550107448258562','1207570630070976514','陈闻 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202104/1377560681783570433.jpg',2,NULL,'2021-04-01 17:57:15',NULL,NULL,NULL),('1377563034486124545','1377562555626631170','1207570630070976514','庚钟银 合同（20170401-20200331） (1).pdf','jjrcw/talentFile/talentCommonFile/202104/1377563034330935298.pdf',1,NULL,'2021-04-01 18:06:35',NULL,NULL,NULL),('1377563054803333121','1377562555626631170','1207570630070976514','庚钟银 劳动合同20200401-20221231.pdf','jjrcw/talentFile/talentCommonFile/202104/1377563054660726785.pdf',2,NULL,'2021-04-01 18:06:40',NULL,NULL,NULL),('1377563092417851394','1377562555626631170','1207570630070976514','庚钟银 任职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377563092308799489.jpg',3,NULL,'2021-04-01 18:06:49',NULL,NULL,NULL),('1377563898990899202','1377563494215397377','1207570630070976514','吴汶錡 任职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377563898932178946.jpg',1,NULL,'2021-04-01 18:10:02',NULL,NULL,NULL),('1377564103148646402','1377563494215397377','1207570630070976514','吴汶錡 合同 20190201-20220115.pdf','jjrcw/talentFile/talentCommonFile/202104/1377564102959902722.pdf',2,NULL,'2021-04-01 18:10:50',NULL,NULL,NULL),('1377564693287219202','1377564617714249729','1207570630070976514','郑向敏 合同20170401-20200331.pdf','jjrcw/talentFile/talentCommonFile/202104/1377564693136224258.pdf',1,NULL,'2021-04-01 18:13:11',NULL,NULL,NULL),('1377564713390518273','1377564617714249729','1207570630070976514','郑向敏 劳动合同20200401-20221231 (1).pdf','jjrcw/talentFile/talentCommonFile/202104/1377564713235329025.pdf',2,NULL,'2021-04-01 18:13:16',NULL,NULL,NULL),('1377564756906422273','1377564617714249729','1207570630070976514','郑向敏 任职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377564756805758977.jpg',3,NULL,'2021-04-01 18:13:26',NULL,NULL,NULL),('1377609040749740033','1377608396907298818','1207570630070976514','郑宏 劳动合同20170301-20200130 (1).pdf','jjrcw/talentFile/talentCommonFile/202104/1377609040397418498.pdf',1,NULL,'2021-04-01 21:09:24',NULL,NULL,NULL),('1377609066951557122','1377608396907298818','1207570630070976514','郑宏 劳动合同20200201-20230115 (1).pdf','jjrcw/talentFile/talentCommonFile/202104/1377609066767007746.pdf',2,NULL,'2021-04-01 21:09:30',NULL,NULL,NULL),('1377609091395960833','1377608396907298818','1207570630070976514','郑宏 任职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377609091282714626.jpg',3,NULL,'2021-04-01 21:09:36',NULL,NULL,NULL),('1377609523006619649','1377609414852296706','1207570630070976514','王淑莲 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202104/1377609522922733569.jpg',1,NULL,'2021-04-01 21:11:19',NULL,NULL,NULL),('1377609576257503234','1377609414852296706','1207570630070976514','王淑莲-劳动合同20190729-20230115.pdf','jjrcw/talentFile/talentCommonFile/202104/1377609576110702593.pdf',2,NULL,'2021-04-01 21:11:32',NULL,NULL,NULL),('1377610006718922753','1377609957750423553','1207570630070976514','谢明强-劳动合同20180917-20220115.pdf','jjrcw/talentFile/talentCommonFile/202104/1377610006555344897.pdf',1,NULL,'2021-04-01 21:13:15',NULL,NULL,NULL),('1377610039275110402','1377609957750423553','1207570630070976514','谢明强 任职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377610039191224322.jpg',2,NULL,'2021-04-01 21:13:22',NULL,NULL,NULL),('1377611021363003394','1377610537164161025','1207570630070976514','吴剑峰 合同20180112-20210111 (1).pdf','jjrcw/talentFile/talentCommonFile/202104/1377611021136510977.pdf',1,NULL,'2021-04-01 21:17:16',NULL,NULL,NULL),('1377611041378222081','1377610537164161025','1207570630070976514','吴剑峰 任职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377611041273364481.jpg',2,NULL,'2021-04-01 21:17:21',NULL,NULL,NULL),('1377611091764396033','1377610537164161025','1207570630070976514','吴剑峰20210112-20240115 (1).pdf','jjrcw/talentFile/talentCommonFile/202104/1377611091521126402.pdf',3,NULL,'2021-04-01 21:17:33',NULL,NULL,NULL),('1377784386774188034','1371640537718829058','1207221285556019202','人才标签变更.jpg','jjrcw/talentFile/talentCommonFile/202104/1377784386665136129.jpg',1,NULL,'2021-04-02 08:46:10',NULL,NULL,NULL),('1377784401940791298','1371640537718829058','1207221285556019202','邵华-博士后出站.jpg','jjrcw/talentFile/talentCommonFile/202104/1377784401819156481.jpg',2,NULL,'2021-04-02 08:46:14',NULL,NULL,NULL),('1377784575584976898','1377784551954268161','1207221285556019202','人才标签变更.jpg','jjrcw/talentFile/talentCommonFile/202104/1377784575475924993.jpg',1,NULL,'2021-04-02 08:46:55',NULL,NULL,NULL),('1377784588205637633','1377784551954268161','1207221285556019202','熊婕颖-任命国际学院副院长.jpg','jjrcw/talentFile/talentCommonFile/202104/1377784588121751554.jpg',2,NULL,'2021-04-02 08:46:58',NULL,NULL,NULL),('1377784711962771457','1377784691649757185','1207221285556019202','人才标签变更.jpg','jjrcw/talentFile/talentCommonFile/202104/1377784711832748034.jpg',1,NULL,'2021-04-02 08:47:27',NULL,NULL,NULL),('1377784724017201154','1377784691649757185','1207221285556019202','徐露维-行政转教师岗.jpg','jjrcw/talentFile/talentCommonFile/202104/1377784723903954946.jpg',2,NULL,'2021-04-02 08:47:30',NULL,NULL,NULL),('1377800389058969602','1377799720860205058','1207570630070976514','2020-12-01《劳动合同》（陈晓鹭）.pdf','jjrcw/talentFile/talentCommonFile/202104/1377800388945723393.pdf',1,NULL,'2021-04-02 09:49:45',NULL,NULL,NULL),('1377802403390242817','1377802341419401218','1207221285556019202','王淑莲离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377802403289579521.jpg',1,NULL,'2021-04-02 09:57:45',NULL,NULL,NULL),('1377809441952448513','1377809224934965249','1207221285556019202','庄金红、郑龚峰、蔡玉珊人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202104/1377809441860173826.jpg',1,NULL,'2021-04-02 10:25:44',NULL,NULL,NULL),('1377809656121999362','1283230376382177281','1207221285556019202','翁温答离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377809656042307585.jpg',1,NULL,'2021-04-02 10:26:35',NULL,NULL,NULL),('1377809721498615810','1283231907009536001','1207221285556019202','张振伟离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377809721410535426.jpg',1,NULL,'2021-04-02 10:26:50',NULL,NULL,NULL),('1377809773910638594','1283232255463923713','1207221285556019202','刘义圣离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377809773772226562.jpg',1,NULL,'2021-04-02 10:27:03',NULL,NULL,NULL),('1377809926033850370','1377809890969468929','1207221285556019202','苏涓涓离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377809925945769985.jpg',1,NULL,'2021-04-02 10:27:39',NULL,NULL,NULL),('1377811786836819970','1377811683916988418','1207570630070976514','合同1.jpg','jjrcw/talentFile/talentCommonFile/202104/1377811786761322498.jpg',1,NULL,'2021-04-02 10:35:03',NULL,NULL,NULL),('1377811802229915649','1377811683916988418','1207570630070976514','合同2.jpg','jjrcw/talentFile/talentCommonFile/202104/1377811802129252354.jpg',2,NULL,'2021-04-02 10:35:06',NULL,NULL,NULL),('1377811814674415618','1377811683916988418','1207570630070976514','合同3.jpg','jjrcw/talentFile/talentCommonFile/202104/1377811814582140930.jpg',3,NULL,'2021-04-02 10:35:09',NULL,NULL,NULL),('1377811824606527489','1377811683916988418','1207570630070976514','合同4.jpg','jjrcw/talentFile/talentCommonFile/202104/1377811824526835714.jpg',4,NULL,'2021-04-02 10:35:12',NULL,NULL,NULL),('1377812375587078146','1377812341164425217','1207570630070976514','邵华泉州轻工聘用合同1.jpg','jjrcw/talentFile/talentCommonFile/202104/1377812375486414849.jpg',1,NULL,'2021-04-02 10:37:23',NULL,NULL,NULL),('1377812385015873537','1377812341164425217','1207570630070976514','邵华泉州轻工聘用合同2.jpg','jjrcw/talentFile/talentCommonFile/202104/1377812384919404546.jpg',2,NULL,'2021-04-02 10:37:25',NULL,NULL,NULL),('1377812394478223361','1377812341164425217','1207570630070976514','邵华泉州轻工聘用合同3.jpg','jjrcw/talentFile/talentCommonFile/202104/1377812394394337281.jpg',3,NULL,'2021-04-02 10:37:28',NULL,NULL,NULL),('1377812406134194178','1377812341164425217','1207570630070976514','邵华泉州轻工聘用合同4.jpg','jjrcw/talentFile/talentCommonFile/202104/1377812406050308098.jpg',4,NULL,'2021-04-02 10:37:30',NULL,NULL,NULL),('1377812808334393346','1377812768807272450','1207570630070976514','合同 (1).png','jjrcw/talentFile/talentCommonFile/202104/1377812808263090178.png',1,NULL,'2021-04-02 10:39:06',NULL,NULL,NULL),('1377812817721245698','1377812768807272450','1207570630070976514','合同 (2).png','jjrcw/talentFile/talentCommonFile/202104/1377812817603805185.png',2,NULL,'2021-04-02 10:39:08',NULL,NULL,NULL),('1377812829230415874','1377812768807272450','1207570630070976514','合同 (3).png','jjrcw/talentFile/talentCommonFile/202104/1377812829129752577.png',3,NULL,'2021-04-02 10:39:11',NULL,NULL,NULL),('1377812838785040385','1377812768807272450','1207570630070976514','合同 (4).png','jjrcw/talentFile/talentCommonFile/202104/1377812838726320129.png',4,NULL,'2021-04-02 10:39:13',NULL,NULL,NULL),('1377814026746150914','1377813942922985474','1207570630070976514','郑龚峰劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202104/1377814026620321793.jpg',1,NULL,'2021-04-02 10:43:57',NULL,NULL,NULL),('1377814062854914050','1377813942922985474','1207570630070976514','劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202104/1377814062783610882.jpg',2,NULL,'2021-04-02 10:44:05',NULL,NULL,NULL),('1377814169914523650','1377813942922985474','1207570630070976514','劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202104/1377814169830637570.jpg',3,NULL,'2021-04-02 10:44:31',NULL,NULL,NULL),('1377814183063666690','1377813942922985474','1207570630070976514','劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202104/1377814182963003393.jpg',4,NULL,'2021-04-02 10:44:34',NULL,NULL,NULL),('1377814200017043457','1377813942922985474','1207570630070976514','郑龚峰劳动合同5.jpg','jjrcw/talentFile/talentCommonFile/202104/1377814199907991553.jpg',5,NULL,'2021-04-02 10:44:38',NULL,NULL,NULL),('1377814336550027266','1377813942922985474','1207570733326352385','庄金红、郑龚峰、蔡玉珊人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202104/1377814336478724098.jpg',1,NULL,'2021-04-02 10:45:11',NULL,NULL,NULL),('1377819535616327681','1377818756222369793','1207221285556019202','白成云离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377819535507275777.jpg',1,NULL,'2021-04-02 11:05:50',NULL,NULL,NULL),('1377819836675080194','1377818744591564802','1207570630070976514','凡硕劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202104/1377819836603777025.pdf',1,NULL,'2021-04-02 11:07:02',NULL,NULL,NULL),('1377820152543920130','1377819667409747970','1207221285556019202','庄加福离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377820152439062530.jpg',1,NULL,'2021-04-02 11:08:17',NULL,NULL,NULL),('1377820821359247361','1377820285482385409','1207221285556019202','曾文浩离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377820821262778370.jpg',1,NULL,'2021-04-02 11:10:57',NULL,NULL,NULL),('1377821497619464193','1377821027886776322','1207221285556019202','杨林杰离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377821497531383810.jpg',1,NULL,'2021-04-02 11:13:38',NULL,NULL,NULL),('1377822062520909825','1377821612820217857','1207221285556019202','刘哲夫离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377822062462189570.jpg',1,NULL,'2021-04-02 11:15:53',NULL,NULL,NULL),('1377823907070951426','1377822796733825025','1207221285556019202','黄礼坤离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377823906970288129.jpg',1,NULL,'2021-04-02 11:23:12',NULL,NULL,NULL),('1377824307308216322','1377824013946011649','1207221285556019202','洪溢都离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1377824307211747330.jpg',1,NULL,'2021-04-02 11:24:48',NULL,NULL,NULL),('1377878146187083778','1377811683916988418','1207570630070976514','人才标签变更.jpg','jjrcw/talentFile/talentCommonFile/202104/1377878146057060353.jpg',5,NULL,'2021-04-02 14:58:44',NULL,NULL,NULL),('1377878208086622210','1377811683916988418','1207570630070976514','徐露维-行政转教师岗.jpg','jjrcw/talentFile/talentCommonFile/202104/1377878207964987393.jpg',6,NULL,'2021-04-02 14:58:59',NULL,NULL,NULL),('1377878268295856130','1377812341164425217','1207570630070976514','人才标签变更.jpg','jjrcw/talentFile/talentCommonFile/202104/1377878268220358658.jpg',5,NULL,'2021-04-02 14:59:13',NULL,NULL,NULL),('1377878280832630786','1377812341164425217','1207570630070976514','邵华-博士后出站.jpg','jjrcw/talentFile/talentCommonFile/202104/1377878280727773186.jpg',6,NULL,'2021-04-02 14:59:16',NULL,NULL,NULL),('1377878329318785025','1377812768807272450','1207570630070976514','人才标签变更.jpg','jjrcw/talentFile/talentCommonFile/202104/1377878329205538817.jpg',5,NULL,'2021-04-02 14:59:28',NULL,NULL,NULL),('1377878342480510978','1377812768807272450','1207570630070976514','熊婕颖-任命国际学院副院长.jpg','jjrcw/talentFile/talentCommonFile/202104/1377878342371459073.jpg',6,NULL,'2021-04-02 14:59:31',NULL,NULL,NULL),('1379067145094250498','1379055380952334338','1207221285556019202','离职证明.pdf','jjrcw/talentFile/talentCommonFile/202104/1379067144955838466.pdf',1,NULL,'2021-04-05 21:43:23',NULL,NULL,NULL),('1379232351229394946','1379232105925525505','1161965644164075522','智融营业执照正本_00.jpg','jjrcw/talentFile/talentCommonFile/202104/1379232351082594306.jpg',1,NULL,'2021-04-06 08:39:52',NULL,NULL,NULL),('1379240001417592833','1379236100719067137','1207570630070976514','劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202104/1379240001300152322.pdf',1,NULL,'2021-04-06 09:10:16',NULL,NULL,NULL),('1379240049186521089','1379236100719067137','1207570630070976514','工作证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1379240049111023618.jpg',2,NULL,'2021-04-06 09:10:27',NULL,NULL,NULL),('1380059658634477569','1378240907941330946','1207221285556019202','范金兴离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1380059658521231362.jpg',1,NULL,'2021-04-08 15:27:17',NULL,NULL,NULL),('1385055957083488258','1385055894269591554','1207221285556019202','张俊卿离职证明.pdf','jjrcw/talentFile/talentCommonFile/202104/1385055956903133185.pdf',1,NULL,'2021-04-22 10:20:47',NULL,NULL,NULL),('1385117207956029442','1385116924358164481','1161965644164075522','灵源药业营业执照2020.2.25.jpg','jjrcw/talentFile/talentCommonFile/202104/1385117207821811714.jpg',1,NULL,'2021-04-22 14:24:11',NULL,NULL,NULL),('1387593259416600577','1243366471850074114','1161965644164075522','福建北电-营业执照.jpg','jjrcw/talentFile/talentCommonFile/202104/1387593259315937281.jpg',1,NULL,'2021-04-29 10:23:07',NULL,NULL,NULL),('1387713100395884546','1387712899836850178','1207221285556019202','LD01-12 苏倍庆 离职交接材料.pdf','jjrcw/talentFile/talentCommonFile/202104/1387713100282638337.pdf',1,NULL,'2021-04-29 18:19:20',NULL,NULL,NULL),('1387991204922175489','1387990637390901250','1161965644164075522','福建约克--营业执照2.jpg','jjrcw/talentFile/talentCommonFile/202104/1387991204834095106.jpg',1,NULL,'2021-04-30 12:44:25',NULL,NULL,NULL),('1388046310652817409','1388046184865640449','1207221285556019202','金小红离职申请单.jpg','jjrcw/talentFile/talentCommonFile/202104/1388046310602485761.jpg',1,NULL,'2021-04-30 16:23:23',NULL,NULL,NULL),('1388046407805480962','1388046184865640449','1207221285556019202','金小红离职证明.jpg','jjrcw/talentFile/talentCommonFile/202104/1388046407709011969.jpg',2,NULL,'2021-04-30 16:23:46',NULL,NULL,NULL),('1389030096605589505','1389029470937067521','1161965644164075522','向维智联（福建）科技有限公司.jpg','jjrcw/talentFile/talentCommonFile/202105/1389030096391680001.jpg',1,NULL,'2021-05-03 09:32:36',NULL,NULL,NULL),('1392012703177945090','1371628504407453698','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202105/1392012703056310274.jpg',1,NULL,'2021-05-11 15:04:25',NULL,NULL,NULL),('1394951914403180546','1394951738275966977','1161965644164075522','民顺营业执照.jpg','jjrcw/talentFile/talentCommonFile/202105/1394951914210242562.jpg',1,NULL,'2021-05-19 17:43:48',NULL,NULL,NULL),('1395662189200715777','1395662084355698690','1207570630070976514','凡硕劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202105/1395662189095858177.pdf',1,NULL,'2021-05-21 16:46:10',NULL,NULL,NULL),('1395666671183638529','1395662084355698690','1207570630070976514','任职证明.jpg','jjrcw/talentFile/talentCommonFile/202105/1395666671095558145.jpg',2,NULL,'2021-05-21 17:03:59',NULL,NULL,NULL),('1399649156699553793','1399649081889947649','1207221285556019202','许群英.jpg','jjrcw/talentFile/talentCommonFile/202106/1399649156338843650.jpg',1,NULL,'2021-06-01 16:48:57',NULL,NULL,NULL),('1399649310269800449','1399649238123577346','1207221285556019202','吴辉炫.jpg','jjrcw/talentFile/talentCommonFile/202106/1399649309963616257.jpg',1,NULL,'2021-06-01 16:49:34',NULL,NULL,NULL),('1399902529004797954','1399898008304254977','1161965644164075522','单位营业执照.jpg','jjrcw/talentFile/talentCommonFile/202106/1399902528774111233.jpg',1,NULL,'2021-06-02 09:35:46',NULL,NULL,NULL),('1400022518676357121','1400022384307634178','1161965644164075522','营业执照.jpg','jjrcw/talentFile/talentCommonFile/202106/1400022518420504578.jpg',1,NULL,'2021-06-02 17:32:34',NULL,NULL,NULL),('1402573466082770946','1402567724370001921','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202106/1402573465776586754.jpg',1,NULL,'2021-06-09 18:29:07',NULL,NULL,NULL),('1404621660140634114','1404621307240284161','1161965644164075522','峰安皮业股份有限公司 三证合一.jpg','jjrcw/talentFile/talentCommonFile/202106/1404621659872198657.jpg',1,NULL,'2021-06-15 10:07:55',NULL,NULL,NULL),('1406883743888625666','1406883477927809025','1207570630070976514','事业单位法人证书正本.jpg','jjrcw/talentFile/talentCommonFile/202106/1406883723793715202.jpg',1,NULL,'2021-06-21 15:56:37',NULL,NULL,NULL),('1407516219698880513','1407514236992659458','1207221285556019202','D:\\扫描文件夹\\张清明任免职文件.pdf','jjrcw/talentFile/talentCommonFile/202106/1407516219438833665.pdf',1,NULL,'2021-06-23 09:49:51',NULL,NULL,NULL),('1407548031334653953','1407517229733421058','1207221285556019202','D:\\扫描文件夹\\调动函.pdf','jjrcw/talentFile/talentCommonFile/202106/1407548031116550145.pdf',1,NULL,'2021-06-23 11:56:16',NULL,NULL,NULL),('1407988644693712897','1407957701555691522','1207221285556019202','2021年人才标签明细汇总1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407988644479803394.jpg',1,NULL,'2021-06-24 17:07:06',NULL,NULL,NULL),('1407992106760314881','1407990414312513537','1207221285556019202','2021年人才标签明细汇总1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407992106584154113.jpg',1,NULL,'2021-06-24 17:20:52',NULL,NULL,NULL),('1407992197629911042','1407990576606912514','1207221285556019202','2021年人才标签明细汇总1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407992197416001537.jpg',1,NULL,'2021-06-24 17:21:13',NULL,NULL,NULL),('1407992262142500865','1407990854395666433','1207221285556019202','2021年人才标签明细汇总1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407992261945368577.jpg',1,NULL,'2021-06-24 17:21:29',NULL,NULL,NULL),('1407992323253510146','1407990976286334978','1207221285556019202','2021年人才标签明细汇总1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407992323077349378.jpg',1,NULL,'2021-06-24 17:21:43',NULL,NULL,NULL),('1407992379213914113','1407991090946023425','1207221285556019202','2021年人才标签明细汇总1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407992379008393218.jpg',1,NULL,'2021-06-24 17:21:57',NULL,NULL,NULL),('1407992433471430657','1407991210261389314','1207221285556019202','2021年人才标签明细汇总1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407992433274298369.jpg',1,NULL,'2021-06-24 17:22:10',NULL,NULL,NULL),('1407996786940878849','1407996740845477890','1207570630070976514','许丽璇 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407996786722775041.jpg',1,NULL,'2021-06-24 17:39:27',NULL,NULL,NULL),('1407996894344421377','1407996740845477890','1207570630070976514','许丽璇-劳动合同20190901-20220115.pdf','jjrcw/talentFile/talentCommonFile/202106/1407996893945962497.pdf',2,NULL,'2021-06-24 17:39:53',NULL,NULL,NULL),('1407997423871107074','1407997385996541953','1207570630070976514','卢淑蓉 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407997423627837442.jpg',1,NULL,'2021-06-24 17:41:59',NULL,NULL,NULL),('1407998678999801857','1407998646988873730','1207570630070976514','蓝开辉 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407998678777503746.jpg',1,NULL,'2021-06-24 17:46:59',NULL,NULL,NULL),('1407998734356226049','1407998646988873730','1207570630070976514','蓝开辉-劳动合同20201008-20240115.pdf','jjrcw/talentFile/talentCommonFile/202106/1407998733970350082.pdf',2,NULL,'2021-06-24 17:47:12',NULL,NULL,NULL),('1407999311467290626','1407999267162857473','1207570630070976514','赖丽春 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407999311286935553.jpg',1,NULL,'2021-06-24 17:49:29',NULL,NULL,NULL),('1407999353867509762','1407999267162857473','1207570630070976514','赖丽春-劳动合同20190218-20220115.pdf','jjrcw/talentFile/talentCommonFile/202106/1407999353599074306.pdf',2,NULL,'2021-06-24 17:49:39',NULL,NULL,NULL),('1407999885906583554','1407999862103908354','1207570630070976514','金为民 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202106/1407999885722034177.jpg',1,NULL,'2021-06-24 17:51:46',NULL,NULL,NULL),('1407999899206721538','1407999862103908354','1207570630070976514','金为民-劳动合同20180201-20210131.pdf','jjrcw/talentFile/talentCommonFile/202106/1407999898997006338.pdf',2,NULL,'2021-06-24 17:51:50',NULL,NULL,NULL),('1408002290773696513','1408002262541836289','1207570630070976514','吴铭辉 任职证明1.jpg','jjrcw/talentFile/talentCommonFile/202106/1408002290580758529.jpg',1,NULL,'2021-06-24 18:01:20',NULL,NULL,NULL),('1408002305868996609','1408002262541836289','1207570630070976514','吴铭辉20210116-20240115 (1).pdf','jjrcw/talentFile/talentCommonFile/202106/1408002305634115585.pdf',2,NULL,'2021-06-24 18:01:23',NULL,NULL,NULL),('1408002325791940609','1408002262541836289','1207570630070976514','吴铭辉-劳动合同20180201-20210115.pdf','jjrcw/talentFile/talentCommonFile/202106/1408002325594808322.pdf',3,NULL,'2021-06-24 18:01:28',NULL,NULL,NULL),('1408239197478756354','1407981432722202626','1207221285556019202','石新国人才标签变更.pdf','jjrcw/talentFile/talentCommonFile/202106/1408239197256458242.pdf',1,NULL,'2021-06-25 09:42:43',NULL,NULL,NULL),('1409317225080332289','1409317090485116929','1207570630070976514','石新国人才标签变更.pdf','jjrcw/talentFile/talentCommonFile/202106/1409317224853839874.pdf',1,NULL,'2021-06-28 09:06:24',NULL,NULL,NULL),('1409747423470854145','1406863952243118082','1207221285556019202','说明.pdf','jjrcw/talentFile/talentCommonFile/202106/1409747423265333249.pdf',1,NULL,'2021-06-29 13:35:52',NULL,NULL,NULL),('1409775473386364929','1409773946076700673','1207221285556019202','陈培煌1.jpg','jjrcw/talentFile/talentCommonFile/202106/1409775473193426945.jpg',1,NULL,'2021-06-29 15:27:19',NULL,NULL,NULL),('1409775552822288386','1409773946076700673','1207221285556019202','陈培煌2.jpg','jjrcw/talentFile/talentCommonFile/202106/1409775552608378882.jpg',2,NULL,'2021-06-29 15:27:38',NULL,NULL,NULL),('1410076888755380226','1410076204890890242','1207221285556019202','沈文浩离职单.jpg','jjrcw/talentFile/talentCommonFile/202106/1410076888541470722.jpg',1,NULL,'2021-06-30 11:25:02',NULL,NULL,NULL),('1411142535312613378','1411142250515177474','1161965644164075522','时空营业执照副本（贺钢）.jpg','jjrcw/talentFile/talentCommonFile/202107/1411143028566958081.jpg',1,NULL,'2021-07-03 09:59:32',NULL,'2021-07-03 10:01:30',NULL),('1411872695406075906','1411872514799345665','1161965644164075522','时空营业执照副本（贺钢）.jpg','jjrcw/talentFile/talentCommonFile/202107/1411872695158611969.jpg',1,NULL,'2021-07-05 10:20:56',NULL,NULL,NULL),('1412584122248896513','1410076204890890242','1207221285556019202','沈文浩离职证明.pdf','jjrcw/talentFile/talentCommonFile/202107/1412584122072735745.pdf',2,NULL,'2021-07-07 09:27:53',NULL,NULL,NULL),('1412633366943014913','1407996740845477890','1207570630070976514','标签变更.jpg','jjrcw/talentFile/talentCommonFile/202107/1412633366762659841.jpg',3,NULL,'2021-07-07 12:43:34',NULL,NULL,NULL),('1412633562108174337','1407997385996541953','1207570630070976514','标签变更.jpg','jjrcw/talentFile/talentCommonFile/202107/1412633561919430657.jpg',3,NULL,'2021-07-07 12:44:21',NULL,NULL,NULL),('1412633774100881410','1407997385996541953','1207570630070976514','卢淑蓉 劳动合同（20180523-20210522）7.pdf','jjrcw/talentFile/talentCommonFile/202107/1412633773870194689.pdf',4,NULL,'2021-07-07 12:45:11',NULL,NULL,NULL),('1412634391099777025','1407998646988873730','1207570630070976514','标签变更.jpg','jjrcw/talentFile/talentCommonFile/202107/1412634390894256130.jpg',3,NULL,'2021-07-07 12:47:38',NULL,NULL,NULL),('1412634670176182273','1407999267162857473','1207570630070976514','标签变更.jpg','jjrcw/talentFile/talentCommonFile/202107/1412634669983244289.jpg',3,NULL,'2021-07-07 12:48:45',NULL,NULL,NULL),('1412634745958866945','1407999862103908354','1207570630070976514','标签变更.jpg','jjrcw/talentFile/talentCommonFile/202107/1412634745774317569.jpg',3,NULL,'2021-07-07 12:49:03',NULL,NULL,NULL),('1412634830088216578','1408002262541836289','1207570630070976514','标签变更.jpg','jjrcw/talentFile/talentCommonFile/202107/1412634829849141250.jpg',4,NULL,'2021-07-07 12:49:23',NULL,NULL,NULL),('1412664274047770626','1412659125124374530','1207570630070976514','外聘协议.jpg','jjrcw/talentFile/talentCommonFile/202107/1412664273741586433.jpg',1,NULL,'2021-07-07 14:46:23',NULL,NULL,NULL),('1412664303693111297','1412659125124374530','1207570630070976514','外聘协议 (2).jpg','jjrcw/talentFile/talentCommonFile/202107/1412664303495979009.jpg',2,NULL,'2021-07-07 14:46:30',NULL,NULL,NULL),('1412664322164826114','1412659125124374530','1207570630070976514','任职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1412664321988665345.jpg',3,NULL,'2021-07-07 14:46:35',NULL,NULL,NULL),('1412664505711763458','1412659125124374530','1207570630070976514','标签变更.jpg','jjrcw/talentFile/talentCommonFile/202107/1412664505481076738.jpg',4,NULL,'2021-07-07 14:47:18',NULL,NULL,NULL),('1413056728748040194','1413055647880093698','1177047550859280385','内资企业登记表1.png','jjrcw/talentFile/talentCommonFile/202107/1413056728475410433.png',1,NULL,'2021-07-08 16:45:52',NULL,NULL,NULL),('1413056776487608322','1413055647880093698','1177047550859280385','内资企业登记表2.png','jjrcw/talentFile/talentCommonFile/202107/1413056776265310210.png',2,NULL,'2021-07-08 16:46:03',NULL,NULL,NULL),('1413056798650310657','1413055647880093698','1177047550859280385','内资企业登记表3.png','jjrcw/talentFile/talentCommonFile/202107/1413056798365097986.png',3,NULL,'2021-07-08 16:46:08',NULL,NULL,NULL),('1413058525583679489','1413055647880093698','1161965644164075522','营业执照.png','jjrcw/talentFile/talentCommonFile/202107/1413058525327826946.png',1,NULL,'2021-07-08 16:53:00',NULL,NULL,NULL),('1415155425275314178','1415155179610734594','1207221285556019202','朱小平主体变更合同.pdf','jjrcw/talentFile/talentCommonFile/202107/1415155425019461634.pdf',1,NULL,'2021-07-14 11:45:20',NULL,NULL,NULL),('1415220308444479490','1415219773729439745','1161965644164075522','1626249767(1).jpg','jjrcw/talentFile/talentCommonFile/202107/1415220308197015553.jpg',1,NULL,'2021-07-14 16:03:09',NULL,NULL,NULL),('1415222430883938306','1415222310897483777','1161965644164075522','营业执照-福建恒安集团有限公司.jpg','jjrcw/talentFile/talentCommonFile/202107/1415222430695194626.jpg',1,NULL,'2021-07-14 16:11:35',NULL,NULL,NULL),('1415234143326863362','1415234083344121857','1207221285556019202','舒华离职证明.pdf','jjrcw/talentFile/talentCommonFile/202107/1415234143142313986.pdf',1,NULL,'2021-07-14 16:58:08',NULL,NULL,NULL),('1415511881153544194','1415511739121827841','1161965644164075522','营业执照.jpg','jjrcw/talentFile/talentCommonFile/202107/1415511880893497346.jpg',1,NULL,'2021-07-15 11:21:46',NULL,NULL,NULL),('1415557167943024641','1415557017875021825','1161965644164075522','饮料营业执照.jpg','jjrcw/talentFile/talentCommonFile/202107/1415557167699755009.jpg',1,NULL,'2021-07-15 14:21:43',NULL,NULL,NULL),('1415592790066233346','1407514236992659458','1207221285556019202','张清明解除劳动关系证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1415592789839740929.jpg',2,NULL,'2021-07-15 16:43:16',NULL,NULL,NULL),('1415593379579854849','1407517229733421058','1207221285556019202','曹辰解除劳动关系证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1415593379336585217.jpg',2,NULL,'2021-07-15 16:45:36',NULL,NULL,NULL),('1417328957652500482','1417328264153694210','1207221285556019202','标签变更-第2次.jpg','jjrcw/talentFile/talentCommonFile/202107/1417328957434396674.jpg',1,NULL,'2021-07-20 11:42:10',NULL,NULL,NULL),('1417675621542166530','1417674029447282689','1209811013886771202','陈恩果离职.jpeg','jjrcw/talentFile/talentCommonFile/202107/1417675621307285506.jpeg',1,NULL,'2021-07-21 10:39:41',NULL,NULL,NULL),('1417679449821839362','1417677191273021441','1207221285556019202','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417679449515655169.jpg',1,NULL,'2021-07-21 10:54:54',NULL,NULL,NULL),('1417679958720937986','1417679872435716098','1207221285556019202','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417679958544777218.jpg',1,NULL,'2021-07-21 10:56:56',NULL,NULL,NULL),('1417680196747689986','1417680165483347969','1207221285556019202','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417680196508614657.jpg',1,NULL,'2021-07-21 10:57:52',NULL,NULL,NULL),('1417680443859304450','1417680416667631617','1207221285556019202','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417680443616034817.jpg',1,NULL,'2021-07-21 10:58:51',NULL,NULL,NULL),('1417680607697207297','1417680576520945665','1207221285556019202','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417680607479103489.jpg',1,NULL,'2021-07-21 10:59:30',NULL,NULL,NULL),('1417734491643871234','1414402668280979458','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1417735063528833025.jpg',1,NULL,'2021-07-21 14:33:37',NULL,'2021-07-21 14:35:54',NULL),('1417752532708524034','1417752478081908737','1207570630070976514','郑子苹-劳动合同20170301-20220228.pdf','jjrcw/talentFile/talentCommonFile/202107/1417752532456865794.pdf',1,NULL,'2021-07-21 15:45:19',NULL,NULL,NULL),('1417753657385975810','1417753596052668417','1207570630070976514','叶城锋 劳动合同20180117-20210116.pdf','jjrcw/talentFile/talentCommonFile/202107/1417753657075597313.pdf',1,NULL,'2021-07-21 15:49:47',NULL,NULL,NULL),('1417753704827748354','1417753596052668417','1207570630070976514','叶城锋-劳动合同20210117-20240115.pdf','jjrcw/talentFile/talentCommonFile/202107/1417753704517369857.pdf',2,NULL,'2021-07-21 15:49:58',NULL,NULL,NULL),('1417755019716886529','1417754954688397313','1207570630070976514','蔡海毅-劳动合同20180110-20210110.pdf','jjrcw/talentFile/talentCommonFile/202107/1417755019419090945.pdf',1,NULL,'2021-07-21 15:55:11',NULL,NULL,NULL),('1417755098632716290','1417754954688397313','1207570630070976514','蔡海毅 劳动合同20210111-20240115.pdf','jjrcw/talentFile/talentCommonFile/202107/1417755098305560578.pdf',2,NULL,'2021-07-21 15:55:30',NULL,NULL,NULL),('1417757971617710082','1417757878030204930','1207570630070976514','申龙涉-劳动合同20190101-20220115 (1).pdf','jjrcw/talentFile/talentCommonFile/202107/1417757971256999937.pdf',1,NULL,'2021-07-21 16:06:55',NULL,NULL,NULL),('1417761036366282754','1417760987053850625','1207570630070976514','王为民 劳动合同 20190101-20220115.pdf','jjrcw/talentFile/talentCommonFile/202107/1417761036064292866.pdf',1,NULL,'2021-07-21 16:19:06',NULL,NULL,NULL),('1417763547651276802','1417752478081908737','1207570630070976514','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763547449950209.jpg',2,NULL,'2021-07-21 16:29:05',NULL,NULL,NULL),('1417763565644840962','1417752478081908737','1207570630070976514','郑子苹 晋江人才证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763565443514369.jpg',3,NULL,'2021-07-21 16:29:09',NULL,NULL,NULL),('1417763659865686018','1417753596052668417','1207570630070976514','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763659618222082.jpg',3,NULL,'2021-07-21 16:29:31',NULL,NULL,NULL),('1417763685245419521','1417753596052668417','1207570630070976514','叶城锋 晋江人才证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763684997955585.jpg',4,NULL,'2021-07-21 16:29:37',NULL,NULL,NULL),('1417763756871548929','1417754954688397313','1207570630070976514','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763756691193857.jpg',3,NULL,'2021-07-21 16:29:55',NULL,NULL,NULL),('1417763778841313282','1417754954688397313','1207570630070976514','蔡海毅 晋江人才证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763778648375297.jpg',4,NULL,'2021-07-21 16:30:00',NULL,NULL,NULL),('1417763960941215745','1417757878030204930','1207570630070976514','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763960710529025.jpg',2,NULL,'2021-07-21 16:30:43',NULL,NULL,NULL),('1417763973641568258','1417757878030204930','1207570630070976514','申龙涉 晋江人才证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1417763973431853058.jpg',3,NULL,'2021-07-21 16:30:46',NULL,NULL,NULL),('1417764057456345089','1417760987053850625','1207570630070976514','人才变更汇总表.jpg','jjrcw/talentFile/talentCommonFile/202107/1417764057263407106.jpg',2,NULL,'2021-07-21 16:31:06',NULL,NULL,NULL),('1417764070563545089','1417760987053850625','1207570630070976514','王为民 晋江人才证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1417764070370607106.jpg',3,NULL,'2021-07-21 16:31:09',NULL,NULL,NULL),('1418039742452236289','1418038384709894145','1161965644164075522','正麒营业执照.jpg','jjrcw/talentFile/talentCommonFile/202107/1418039742259298305.jpg',1,NULL,'2021-07-22 10:46:35',NULL,NULL,NULL),('1418040703157567489','1418040366711472129','1161965644164075522','锦兴营业执照盖章.jpg','jjrcw/talentFile/talentCommonFile/202107/1418040702905909249.jpg',1,NULL,'2021-07-22 10:50:24',NULL,NULL,NULL),('1418042627378413570','1417778721779122178','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418042627193864193.pdf',1,NULL,'2021-07-22 10:58:02',NULL,NULL,NULL),('1418042719774736386','1418017448434630657','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418042719552438274.pdf',1,NULL,'2021-07-22 10:58:25',NULL,NULL,NULL),('1418042778121699330','1418017977525108738','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418042777899401218.pdf',1,NULL,'2021-07-22 10:58:38',NULL,NULL,NULL),('1418042834161795073','1418018290680233986','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418042833935302657.pdf',1,NULL,'2021-07-22 10:58:52',NULL,NULL,NULL),('1418042919763345409','1418018466799058946','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418042919545241602.pdf',1,NULL,'2021-07-22 10:59:12',NULL,NULL,NULL),('1418043056405381121','1418018566875152386','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043056170500098.pdf',1,NULL,'2021-07-22 10:59:45',NULL,NULL,NULL),('1418043128945868801','1418018704834199553','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043128727764993.pdf',1,NULL,'2021-07-22 11:00:02',NULL,NULL,NULL),('1418043183492792321','1418018844932341761','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043183274688513.pdf',1,NULL,'2021-07-22 11:00:15',NULL,NULL,NULL),('1418043254724657154','1418018964017020930','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043254510747649.pdf',1,NULL,'2021-07-22 11:00:32',NULL,NULL,NULL),('1418043318968811521','1418019025211916289','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043318733930498.pdf',1,NULL,'2021-07-22 11:00:47',NULL,NULL,NULL),('1418043409406394369','1418019085647642626','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043409188290561.pdf',1,NULL,'2021-07-22 11:01:09',NULL,NULL,NULL),('1418043472165765121','1418019161220612097','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043471914106882.pdf',1,NULL,'2021-07-22 11:01:24',NULL,NULL,NULL),('1418043539392069633','1418019218560942082','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043539199131650.pdf',1,NULL,'2021-07-22 11:01:40',NULL,NULL,NULL),('1418043608233181186','1418019306351919105','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043607989911553.pdf',1,NULL,'2021-07-22 11:01:56',NULL,NULL,NULL),('1418043675534983169','1418019407950544897','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043675262353410.pdf',1,NULL,'2021-07-22 11:02:12',NULL,NULL,NULL),('1418043740144041986','1418019481044680705','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043739930132482.pdf',1,NULL,'2021-07-22 11:02:28',NULL,NULL,NULL),('1418043796163166210','1418019543942463490','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043795949256706.pdf',1,NULL,'2021-07-22 11:02:41',NULL,NULL,NULL),('1418043857672634370','1418019605292548098','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043857462919170.pdf',1,NULL,'2021-07-22 11:02:56',NULL,NULL,NULL),('1418043926979313665','1418019734309339137','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043926723461121.pdf',1,NULL,'2021-07-22 11:03:12',NULL,NULL,NULL),('1418043983380119553','1418019658782507009','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418043983115878401.pdf',1,NULL,'2021-07-22 11:03:26',NULL,NULL,NULL),('1418044051575308289','1418019816756772865','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044051327844354.pdf',1,NULL,'2021-07-22 11:03:42',NULL,NULL,NULL),('1418044105396617217','1418019888852664321','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044105136570370.pdf',1,NULL,'2021-07-22 11:03:55',NULL,NULL,NULL),('1418044160899842050','1418019966405345282','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044160694321154.pdf',1,NULL,'2021-07-22 11:04:08',NULL,NULL,NULL),('1418044221465591810','1418020180751056898','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044221205544962.pdf',1,NULL,'2021-07-22 11:04:23',NULL,NULL,NULL),('1418044297671901186','1418020257611677697','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044297269248002.pdf',1,NULL,'2021-07-22 11:04:41',NULL,NULL,NULL),('1418044362842996737','1418020328780627970','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044362515841026.pdf',1,NULL,'2021-07-22 11:04:56',NULL,NULL,NULL),('1418044781711360002','1418020393163194369','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044781505839105.pdf',1,NULL,'2021-07-22 11:06:36',NULL,NULL,NULL),('1418044845481558018','1418020562495635457','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044845204733954.pdf',1,NULL,'2021-07-22 11:06:51',NULL,NULL,NULL),('1418044906831642626','1418020700182052866','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044906605150209.pdf',1,NULL,'2021-07-22 11:07:06',NULL,NULL,NULL),('1418044961907048450','1418020773745950722','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418044961613447169.pdf',1,NULL,'2021-07-22 11:07:19',NULL,NULL,NULL),('1418045676155076609','1418020880348381185','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418045675970527233.pdf',1,NULL,'2021-07-22 11:10:09',NULL,NULL,NULL),('1418045725291347969','1418020966553911297','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418045725077438466.pdf',1,NULL,'2021-07-22 11:10:21',NULL,NULL,NULL),('1418045776176644097','1418021223035600898','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418045775924985858.pdf',1,NULL,'2021-07-22 11:10:33',NULL,NULL,NULL),('1418045831910555649','1418021343802195970','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418045831709229057.pdf',1,NULL,'2021-07-22 11:10:47',NULL,NULL,NULL),('1418045893608767489','1418021443777626113','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418045893390663681.pdf',1,NULL,'2021-07-22 11:11:01',NULL,NULL,NULL),('1418045958649839618','1418021518079721473','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418045958448513026.pdf',1,NULL,'2021-07-22 11:11:17',NULL,NULL,NULL),('1418046016904527873','1418021577634643970','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046016740950018.pdf',1,NULL,'2021-07-22 11:11:31',NULL,NULL,NULL),('1418046069450768386','1418021633943175170','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046069266219009.pdf',1,NULL,'2021-07-22 11:11:43',NULL,NULL,NULL),('1418046120390590466','1418021705162457089','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046120193458178.pdf',1,NULL,'2021-07-22 11:11:55',NULL,NULL,NULL),('1418046170642546689','1418021775689678849','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046170428637186.pdf',1,NULL,'2021-07-22 11:12:07',NULL,NULL,NULL),('1418046468379410434','1418022360916721666','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046468161306625.pdf',1,NULL,'2021-07-22 11:13:18',NULL,NULL,NULL),('1418046527653314561','1418022422799482881','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046527401656322.pdf',1,NULL,'2021-07-22 11:13:32',NULL,NULL,NULL),('1418046573593526273','1418022495168004097','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046573362839553.pdf',1,NULL,'2021-07-22 11:13:43',NULL,NULL,NULL),('1418046626408202242','1418022557516333057','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046626211069954.pdf',1,NULL,'2021-07-22 11:13:56',NULL,NULL,NULL),('1418046680267259905','1418022696758837250','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046680040767489.pdf',1,NULL,'2021-07-22 11:14:09',NULL,NULL,NULL),('1418046725771264002','1418022759480459266','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046725536382977.pdf',1,NULL,'2021-07-22 11:14:20',NULL,NULL,NULL),('1418046774387441666','1418022896491593729','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046774190309377.pdf',1,NULL,'2021-07-22 11:14:31',NULL,NULL,NULL),('1418046824161247233','1418022962077925378','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046823943143425.pdf',1,NULL,'2021-07-22 11:14:43',NULL,NULL,NULL),('1418046886866092033','1418023035729903618','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046886681542657.pdf',1,NULL,'2021-07-22 11:14:58',NULL,NULL,NULL),('1418046931963248641','1418023106894659586','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418046931690618882.pdf',1,NULL,'2021-07-22 11:15:09',NULL,NULL,NULL),('1418047214579646465','1418023241120776194','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418047214357348353.pdf',1,NULL,'2021-07-22 11:16:16',NULL,NULL,NULL),('1418047258309459969','1418023293708959746','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418047258091356162.pdf',1,NULL,'2021-07-22 11:16:27',NULL,NULL,NULL),('1418047304388083713','1418023353939165186','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418047304157396994.pdf',1,NULL,'2021-07-22 11:16:38',NULL,NULL,NULL),('1418047350697394177','1418023431718338561','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418047350517039105.pdf',1,NULL,'2021-07-22 11:16:49',NULL,NULL,NULL),('1418047402580934658','1418023489293549569','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418047402392190977.pdf',1,NULL,'2021-07-22 11:17:01',NULL,NULL,NULL),('1418047460932091905','1418023647171346433','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418047460701405186.pdf',1,NULL,'2021-07-22 11:17:15',NULL,NULL,NULL),('1418048038307397634','1418023718331908097','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048038089293825.pdf',1,NULL,'2021-07-22 11:19:33',NULL,NULL,NULL),('1418048084717371394','1418023795884589057','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048084507656194.pdf',1,NULL,'2021-07-22 11:19:44',NULL,NULL,NULL),('1418048132914118658','1418023869041639425','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048132675043329.pdf',1,NULL,'2021-07-22 11:19:55',NULL,NULL,NULL),('1418048196013228033','1418023941284331521','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048195782541314.pdf',1,NULL,'2021-07-22 11:20:10',NULL,NULL,NULL),('1418048250656620545','1418024016383344642','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048250434322434.pdf',1,NULL,'2021-07-22 11:20:23',NULL,NULL,NULL),('1418048319980077058','1418024111619211265','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048319757778945.pdf',1,NULL,'2021-07-22 11:20:40',NULL,NULL,NULL),('1418048369011490818','1418024229521096705','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048368793387009.pdf',1,NULL,'2021-07-22 11:20:51',NULL,NULL,NULL),('1418048415387910145','1418024301101088769','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048415140446209.pdf',1,NULL,'2021-07-22 11:21:02',NULL,NULL,NULL),('1418048460598312962','1418024518366035969','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048460396986370.pdf',1,NULL,'2021-07-22 11:21:13',NULL,NULL,NULL),('1418048624318775297','1418024591787327489','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048624113254401.pdf',1,NULL,'2021-07-22 11:21:52',NULL,NULL,NULL),('1418048672549076993','1418024779318853634','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048672381304833.pdf',1,NULL,'2021-07-22 11:22:04',NULL,NULL,NULL),('1418048722503237633','1418024908658606081','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048722285133825.pdf',1,NULL,'2021-07-22 11:22:16',NULL,NULL,NULL),('1418048773870878721','1418024981199093762','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048773690523649.pdf',1,NULL,'2021-07-22 11:22:28',NULL,NULL,NULL),('1418048833509687298','1418025083137458178','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048833287389186.pdf',1,NULL,'2021-07-22 11:22:42',NULL,NULL,NULL),('1418048892016033794','1418025373362323457','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048891797929985.pdf',1,NULL,'2021-07-22 11:22:56',NULL,NULL,NULL),('1418048940992921602','1418025535765774337','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048940745457665.pdf',1,NULL,'2021-07-22 11:23:08',NULL,NULL,NULL),('1418048982948544514','1418025750077931521','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418048982680109058.pdf',1,NULL,'2021-07-22 11:23:18',NULL,NULL,NULL),('1418049035478007809','1418025877702213633','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049035222155265.pdf',1,NULL,'2021-07-22 11:23:30',NULL,NULL,NULL),('1418049087516737537','1418025940700659714','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049087286050818.pdf',1,NULL,'2021-07-22 11:23:43',NULL,NULL,NULL),('1418049135801565186','1418026017997488129','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049135579267074.pdf',1,NULL,'2021-07-22 11:23:54',NULL,NULL,NULL),('1418049184241582081','1418026075623030785','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049184015089665.pdf',1,NULL,'2021-07-22 11:24:06',NULL,NULL,NULL),('1418049230475395073','1418026141800759297','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049230282457090.pdf',1,NULL,'2021-07-22 11:24:17',NULL,NULL,NULL),('1418049279691358209','1418026224562765826','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049279469060098.pdf',1,NULL,'2021-07-22 11:24:29',NULL,NULL,NULL),('1418049324004179969','1418026437671157761','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049323828019201.pdf',1,NULL,'2021-07-22 11:24:39',NULL,NULL,NULL),('1418049373668933633','1418026494726275073','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049373475995649.pdf',1,NULL,'2021-07-22 11:24:51',NULL,NULL,NULL),('1418049415586807810','1418026550405660673','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049415402258434.pdf',1,NULL,'2021-07-22 11:25:01',NULL,NULL,NULL),('1418049456846176258','1418026615748722689','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049456628072450.pdf',1,NULL,'2021-07-22 11:25:11',NULL,NULL,NULL),('1418049499477082114','1418026665447030785','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049499263172609.pdf',1,NULL,'2021-07-22 11:25:21',NULL,NULL,NULL),('1418049552753131522','1418026733088571394','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049552547610626.pdf',1,NULL,'2021-07-22 11:25:34',NULL,NULL,NULL),('1418049603554541570','1418026792551219202','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049603365797889.pdf',1,NULL,'2021-07-22 11:25:46',NULL,NULL,NULL),('1418049649964515330','1418026864009576449','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049649779965953.pdf',1,NULL,'2021-07-22 11:25:57',NULL,NULL,NULL),('1418049713847959553','1418026927712665601','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049713638244354.pdf',1,NULL,'2021-07-22 11:26:12',NULL,NULL,NULL),('1418049758055923714','1418026984918777858','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049757812654081.pdf',1,NULL,'2021-07-22 11:26:23',NULL,NULL,NULL),('1418049815073292290','1418027038782029825','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049814855188481.pdf',1,NULL,'2021-07-22 11:26:36',NULL,NULL,NULL),('1418049902230929410','1418027099842707457','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049901979271170.pdf',1,NULL,'2021-07-22 11:26:57',NULL,NULL,NULL),('1418049954995273729','1418027271050002434','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418049954747809793.pdf',1,NULL,'2021-07-22 11:27:10',NULL,NULL,NULL),('1418050030618574850','1418027341073907713','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418050030387888129.pdf',1,NULL,'2021-07-22 11:27:28',NULL,NULL,NULL),('1418050271929466882','1418027470350745602','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418050271744917506.pdf',1,NULL,'2021-07-22 11:28:25',NULL,NULL,NULL),('1418050389957181442','1418027532728434689','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418050389760049153.pdf',1,NULL,'2021-07-22 11:28:53',NULL,NULL,NULL),('1418050439785512961','1418027585928986625','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418050439559020546.pdf',1,NULL,'2021-07-22 11:29:05',NULL,NULL,NULL),('1418050486002548737','1418027711976210434','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418050485759279105.pdf',1,NULL,'2021-07-22 11:29:16',NULL,NULL,NULL),('1418051557479448577','1418027653826379777','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051557211013121.pdf',1,NULL,'2021-07-22 11:33:32',NULL,NULL,NULL),('1418051609962774530','1418027800736071681','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051609757253634.pdf',1,NULL,'2021-07-22 11:33:44',NULL,NULL,NULL),('1418051685581881346','1418027888757735425','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051685401526274.pdf',1,NULL,'2021-07-22 11:34:02',NULL,NULL,NULL),('1418051746621587458','1418027948887277569','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051746353152002.pdf',1,NULL,'2021-07-22 11:34:17',NULL,NULL,NULL),('1418051824056827905','1418028023675912193','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051823821946881.pdf',1,NULL,'2021-07-22 11:34:35',NULL,NULL,NULL),('1418051886786838530','1418028079728590850','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051886610677762.pdf',1,NULL,'2021-07-22 11:34:50',NULL,NULL,NULL),('1418051939723149314','1418030701252476929','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051939538599937.pdf',1,NULL,'2021-07-22 11:35:03',NULL,NULL,NULL),('1418051984572841986','1418030750271307778','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418051984400875521.pdf',1,NULL,'2021-07-22 11:35:13',NULL,NULL,NULL),('1418052040076066817','1418030798321254402','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052039912488962.pdf',1,NULL,'2021-07-22 11:35:27',NULL,NULL,NULL),('1418052086364405762','1418030856840183810','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052086142107650.pdf',1,NULL,'2021-07-22 11:35:38',NULL,NULL,NULL),('1418052133550325762','1418030907570290689','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052133348999169.pdf',1,NULL,'2021-07-22 11:35:49',NULL,NULL,NULL),('1418052179855441922','1418030989782843394','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052179616366593.pdf',1,NULL,'2021-07-22 11:36:00',NULL,NULL,NULL),('1418052228081549314','1418031050264707073','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052227896999937.pdf',1,NULL,'2021-07-22 11:36:11',NULL,NULL,NULL),('1418052284318777345','1418031105478524930','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052284134227969.pdf',1,NULL,'2021-07-22 11:36:25',NULL,NULL,NULL),('1418052327390085122','1418031157462728706','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052327155204097.pdf',1,NULL,'2021-07-22 11:36:35',NULL,NULL,NULL),('1418052377918865409','1418031227167866882','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052377700761601.pdf',1,NULL,'2021-07-22 11:36:47',NULL,NULL,NULL),('1418052420331667457','1418031282721423361','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052420126146561.pdf',1,NULL,'2021-07-22 11:36:57',NULL,NULL,NULL),('1418052466250907650','1418031334282002433','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052466020220929.pdf',1,NULL,'2021-07-22 11:37:08',NULL,NULL,NULL),('1418052513638154241','1418031383602823170','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052513461993474.pdf',1,NULL,'2021-07-22 11:37:20',NULL,NULL,NULL),('1418052561847484417','1418031648569589762','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052561654546434.pdf',1,NULL,'2021-07-22 11:37:31',NULL,NULL,NULL),('1418052608194543617','1418031696300769281','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052608009994242.pdf',1,NULL,'2021-07-22 11:37:42',NULL,NULL,NULL),('1418052651286822914','1418031746439479298','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052651072913409.pdf',1,NULL,'2021-07-22 11:37:52',NULL,NULL,NULL),('1418052698074284033','1418031804350234626','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052697864568834.pdf',1,NULL,'2021-07-22 11:38:04',NULL,NULL,NULL),('1418052759827021826','1418032127915622402','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052759621500930.pdf',1,NULL,'2021-07-22 11:38:18',NULL,NULL,NULL),('1418052797936467969','1418032209264148482','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052797747724289.pdf',1,NULL,'2021-07-22 11:38:27',NULL,NULL,NULL),('1418052846561034241','1418032273730600961','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052846313570305.pdf',1,NULL,'2021-07-22 11:38:39',NULL,NULL,NULL),('1418052885656141825','1418032334392819713','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052885484175361.pdf',1,NULL,'2021-07-22 11:38:48',NULL,NULL,NULL),('1418052938676338689','1418032391456325634','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052938495983617.pdf',1,NULL,'2021-07-22 11:39:01',NULL,NULL,NULL),('1418052986315243521','1418032476428730369','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418052986084556801.pdf',1,NULL,'2021-07-22 11:39:12',NULL,NULL,NULL),('1418053036151963650','1418032534335291393','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053035954831361.pdf',1,NULL,'2021-07-22 11:39:24',NULL,NULL,NULL),('1418053078355050498','1418032588458590210','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053078153723905.pdf',1,NULL,'2021-07-22 11:39:34',NULL,NULL,NULL),('1418053121136951298','1418032649389244417','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053120944013313.pdf',1,NULL,'2021-07-22 11:39:44',NULL,NULL,NULL),('1418053364884733954','1418032741068341249','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053364712767489.pdf',1,NULL,'2021-07-22 11:40:43',NULL,NULL,NULL),('1418053420736086018','1418032792008163329','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053420484427778.pdf',1,NULL,'2021-07-22 11:40:56',NULL,NULL,NULL),('1418053461454389249','1418032856357175297','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053461265645570.pdf',1,NULL,'2021-07-22 11:41:06',NULL,NULL,NULL),('1418053510267699202','1418032924174876674','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053510028623874.pdf',1,NULL,'2021-07-22 11:41:17',NULL,NULL,NULL),('1418053553280286721','1418032986418348033','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053553078960129.pdf',1,NULL,'2021-07-22 11:41:27',NULL,NULL,NULL),('1418053598184505346','1418033061685133314','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053597978984449.pdf',1,NULL,'2021-07-22 11:41:38',NULL,NULL,NULL),('1418053641020932097','1418033135144173569','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053640807022594.pdf',1,NULL,'2021-07-22 11:41:48',NULL,NULL,NULL),('1418053685472165889','1418033740944277506','1209811013886771202','晋江市集成电路优秀人才离职名单137位(盖章版).pdf','jjrcw/talentFile/talentCommonFile/202107/1418053685300199426.pdf',1,NULL,'2021-07-22 11:41:59',NULL,NULL,NULL),('1418220486499794945','1418105472979861505','1207221285556019202','195551尹华一博士后证书.pdf','jjrcw/talentFile/talentCommonFile/202107/1418220486302662658.pdf',1,NULL,'2021-07-22 22:44:47',NULL,NULL,NULL),('1418454024985804802','1418453939849822209','1207221285556019202','李小鹏离职证明.pdf','jjrcw/talentFile/talentCommonFile/202107/1418454024767700994.pdf',1,NULL,'2021-07-23 14:12:47',NULL,NULL,NULL),('1418454810293731330','1418454753876148225','1207221285556019202','陈旺离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1418454810084016129.jpg',1,NULL,'2021-07-23 14:15:55',NULL,NULL,NULL),('1418502082691891201','1418402148256874497','1207221285556019202','卓东贤.jpg','jjrcw/talentFile/talentCommonFile/202107/1418502082503147522.jpg',1,NULL,'2021-07-23 17:23:45',NULL,NULL,NULL),('1418502149402296321','1418402262832676865','1207221285556019202','瞿波.jpg','jjrcw/talentFile/talentCommonFile/202107/1418502149205164033.jpg',1,NULL,'2021-07-23 17:24:01',NULL,NULL,NULL),('1418815881995124738','1418815701229010946','1207570630070976514','鲁西军合同正面1.jpg','jjrcw/talentFile/talentCommonFile/202107/1418815881814769665.jpg',1,NULL,'2021-07-24 14:10:41',NULL,NULL,NULL),('1418815927771758594','1418815701229010946','1207570630070976514','鲁西军合同背面2.jpg','jjrcw/talentFile/talentCommonFile/202107/1418815927524294658.jpg',2,NULL,'2021-07-24 14:10:52',NULL,NULL,NULL),('1418815977344237569','1418815701229010946','1207570733326352385','鲁西军在职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1418815977142910977.jpg',1,NULL,'2021-07-24 14:11:03',NULL,NULL,NULL),('1418850815266816002','1418833411606347777','1207570630070976514','吕小星（卡尔美- 合同）.pdf','jjrcw/talentFile/talentCommonFile/202107/1418850815027740674.pdf',1,NULL,'2021-07-24 16:29:29',NULL,NULL,NULL),('1418850939674066946','1418833411606347777','1207570630070976514','3-吕小星-在职证明（卡尔美）.jpg','jjrcw/talentFile/talentCommonFile/202107/1418850939464351745.jpg',2,NULL,'2021-07-24 16:29:59',NULL,NULL,NULL),('1418862024355512322','1418861933515276290','1161965644164075522','营业执照副本1.jpg','jjrcw/talentFile/talentCommonFile/202107/1418862024179351554.jpg',1,NULL,'2021-07-24 17:14:02',NULL,NULL,NULL),('1419576379342618626','1419576292809932802','1161965644164075522','营业执照副本.jpg','jjrcw/talentFile/talentCommonFile/202107/1419576379120320513.jpg',1,NULL,'2021-07-26 16:32:37',NULL,NULL,NULL),('1419579092491075585','1419578989378306049','1209811013886771202','张萧.png','jjrcw/talentFile/talentCommonFile/202107/1419579092243611649.png',1,NULL,'2021-07-26 16:43:24',NULL,NULL,NULL),('1419859982811189250','1419859910719492097','1207570630070976514','许群英、黄东昭、陈名智组织部行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202107/1419859982521782274.jpg',1,NULL,'2021-07-27 11:19:34',NULL,NULL,NULL),('1420272808079970305','1420272646079172610','1207570733326352385','195551尹华一博士后证书.pdf','jjrcw/talentFile/talentCommonFile/202107/1420272807777980417.pdf',1,NULL,'2021-07-28 14:39:59',NULL,NULL,NULL),('1420278659075330049','1420272646079172610','1207570630070976514','20200101-20241231-聘用协议-Hua1.pdf','jjrcw/talentFile/talentCommonFile/202107/1420278658815283201.pdf',1,NULL,'2021-07-28 15:03:14',NULL,NULL,NULL),('1420567642900582401','1420567583656038401','1207221285556019202','卞倩 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420567642661507073.jpg',1,NULL,'2021-07-29 10:11:33',NULL,NULL,NULL),('1420568091540115458','1420568062075129858','1207221285556019202','陈俊坤 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420568091301040130.jpg',1,NULL,'2021-07-29 10:13:20',NULL,NULL,NULL),('1420568649625817089','1420568621293293570','1207221285556019202','李蕊 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420568649344798722.jpg',1,NULL,'2021-07-29 10:15:33',NULL,NULL,NULL),('1420574067420876801','1420574043093913602','1207221285556019202','林振兴 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420574067194384385.jpg',1,NULL,'2021-07-29 10:37:05',NULL,NULL,NULL),('1420578704337195010','1420578667561537538','1207221285556019202','欧阳春风 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420578704047788033.jpg',1,NULL,'2021-07-29 10:55:30',NULL,NULL,NULL),('1420579136400838657','1420579113055342594','1207221285556019202','潘少彬 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420579136178540546.jpg',1,NULL,'2021-07-29 10:57:13',NULL,NULL,NULL),('1420581992952549378','1420581949109489666','1207221285556019202','张旭宝 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420581992633782274.jpg',1,NULL,'2021-07-29 11:08:34',NULL,NULL,NULL),('1420625572001751042','1420207986453827585','1207221285556019202','盼福离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420625571720732674.jpg',1,NULL,'2021-07-29 14:01:44',NULL,NULL,NULL),('1420653769120555009','1420653715324411905','1207570630070976514','瞿波劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202107/1420653768881479682.pdf',1,NULL,'2021-07-29 15:53:47',NULL,NULL,NULL),('1420653823260631042','1420653715324411905','1207570733326352385','瞿波在职证明.pdf','jjrcw/talentFile/talentCommonFile/202107/1420653822929281025.pdf',1,NULL,'2021-07-29 15:54:00',NULL,NULL,NULL),('1420665600555884545','1420558187479748610','1207221285556019202','幸青山-离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1420665600237117442.jpg',1,NULL,'2021-07-29 16:40:48',NULL,NULL,NULL),('1420935982122819586','1420649587525296130','1207570630070976514','卓东贤劳动合同.pdf.pdf','jjrcw/talentFile/talentCommonFile/202107/1420935981795663874.pdf',1,NULL,'2021-07-30 10:35:12',NULL,NULL,NULL),('1420936059646140417','1420649587525296130','1207570733326352385','卓东贤在职证明.pdf','jjrcw/talentFile/talentCommonFile/202107/1420936059331567617.pdf',1,NULL,'2021-07-30 10:35:30',NULL,NULL,NULL),('1421413955032604674','1416198133678899201','1207221285556019202','蔡少阳离职证明.jpg','jjrcw/talentFile/talentCommonFile/202107/1421413954718031874.jpg',1,NULL,'2021-07-31 18:14:30',NULL,NULL,NULL),('1422393800801673217','1422393710301175810','1207570630070976514','朱小平主体变更合同.pdf','jjrcw/talentFile/talentCommonFile/202108/1422393800529043457.pdf',1,NULL,'2021-08-03 11:08:03',NULL,NULL,NULL),('1422400379630411777','1422397665987026945','1207221285556019202','离职证明2(2).pdf','jjrcw/talentFile/talentCommonFile/202108/1422400379324227586.pdf',1,NULL,'2021-08-03 11:34:12',NULL,NULL,NULL),('1422400725182341121','1422400615098638337','1207570630070976514','朱小平主体变更合同.pdf','jjrcw/talentFile/talentCommonFile/202108/1422400724850991106.pdf',1,NULL,'2021-08-03 11:35:34',NULL,NULL,NULL),('1422402643849928705','1422402601063833601','1207221285556019202','赖莹莹离职证明.pdf','jjrcw/talentFile/talentCommonFile/202108/1422402643619241985.pdf',1,NULL,'2021-08-03 11:43:11',NULL,NULL,NULL),('1422402938768220161','1422402896825180162','1207221285556019202','陈建宇离职证明.pdf','jjrcw/talentFile/talentCommonFile/202108/1422402938516561921.pdf',1,NULL,'2021-08-03 11:44:22',NULL,NULL,NULL),('1422755239936679938','1414469292455403521','1207221285556019202','张鸿儒.pdf','jjrcw/talentFile/talentCommonFile/202108/1422755239689216001.pdf',1,NULL,'2021-08-04 11:04:17',NULL,NULL,NULL),('1423081350214213633','1423081225769213954','1207570630070976514','灵雀谷营业执照付本.jpg','jjrcw/talentFile/talentCommonFile/202108/1423081349903835138.jpg',1,NULL,'2021-08-05 08:40:08',NULL,NULL,NULL),('1423563405003890689','1423561919997976577','1207221285556019202','(江洋生）解除（终止）劳务关系证明.jpg','jjrcw/talentFile/talentCommonFile/202108/1423563404710289409.jpg',1,NULL,'2021-08-06 16:35:38',NULL,NULL,NULL),('1424536346810163202','1424536298001047554','1209811013886771202','离职证明-陈辉煌.pdf','jjrcw/talentFile/talentCommonFile/202108/1424536346608836609.pdf',1,NULL,'2021-08-09 09:01:46',NULL,NULL,NULL),('1425033827000033281','1425033698121654274','1207570630070976514','张鸿儒.pdf','jjrcw/talentFile/talentCommonFile/202108/1425033826773540865.pdf',1,NULL,'2021-08-10 17:58:34',NULL,NULL,NULL),('1426009482873274369','1426009367278256130','1161965644164075522','普斯特营业执照.jpg','jjrcw/talentFile/talentCommonFile/202108/1426009482592256002.jpg',1,NULL,'2021-08-13 10:35:29',NULL,NULL,NULL),('1426349836122193922','1426349644559941634','1161965644164075522','1.信泰福建-营业执照副本210413.jpg','jjrcw/talentFile/talentCommonFile/202108/1426349835799232514.jpg',1,NULL,'2021-08-14 09:07:55',NULL,NULL,NULL),('1426350414000816129','1426350359185457153','1161965644164075522','万物智联营业执照-新.jpg','jjrcw/talentFile/talentCommonFile/202108/1426350413753352194.jpg',1,NULL,'2021-08-14 09:10:13',NULL,NULL,NULL),('1426350802498224130','1426350737884971009','1161965644164075522','向维智联（福建）科技有限公司.jpg','jjrcw/talentFile/talentCommonFile/202108/1426350802288508930.jpg',1,NULL,'2021-08-14 09:11:46',NULL,NULL,NULL),('1427186889932144642','1248086804893077506','1161965644164075522','营业执照2.png','jjrcw/talentFile/talentCommonFile/202108/1427186889634349058.png',1,NULL,'2021-08-16 16:34:05',NULL,NULL,NULL),('1427192763673214978','1426013685561688065','1207570630070976514','蔡少阳在职证明.jpg','jjrcw/talentFile/talentCommonFile/202108/1427192763383808001.jpg',1,NULL,'2021-08-16 16:57:25',NULL,NULL,NULL),('1427192891758870530','1426013685561688065','1207570630070976514','蔡少阳劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202108/1427192891570126849.jpg',2,NULL,'2021-08-16 16:57:56',NULL,NULL,NULL),('1427192918090711041','1426013685561688065','1207570630070976514','蔡少阳劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202108/1427192917897773057.jpg',3,NULL,'2021-08-16 16:58:02',NULL,NULL,NULL),('1427192939750096897','1426013685561688065','1207570630070976514','蔡少阳劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202108/1427192939481661442.jpg',4,NULL,'2021-08-16 16:58:07',NULL,NULL,NULL),('1427192961543700482','1426013685561688065','1207570630070976514','蔡少阳劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202108/1427192961346568194.jpg',5,NULL,'2021-08-16 16:58:12',NULL,NULL,NULL),('1427900227909636097','1427899949273632770','1207221285556019202','离职证明-LIU JIA.pdf','jjrcw/talentFile/talentCommonFile/202108/1427900227716698113.pdf',1,NULL,'2021-08-18 15:48:38',NULL,NULL,NULL),('1428266232645210113','1428266064059355137','1161965644164075522','营业执照.Jpg','jjrcw/talentFile/talentCommonFile/202108/1428266232250945538.Jpg',1,NULL,'2021-08-19 16:03:00',NULL,NULL,NULL),('1428526229027344385','1428526084554543106','1209811775526240257','陈辉煌劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202108/1428526228821823490.pdf',1,NULL,'2021-08-20 09:16:08',NULL,NULL,NULL),('1428526610994221057','1428526564294840321','1209811775526240257','陈超伟劳动合同书.pdf','jjrcw/talentFile/talentCommonFile/202108/1428526610784505857.pdf',1,NULL,'2021-08-20 09:17:39',NULL,NULL,NULL),('1430074168447127553','1413341675736047617','1207221285556019202','证明.jpg','jjrcw/talentFile/talentCommonFile/202108/1430074168191275010.jpg',1,NULL,'2021-08-24 15:47:05',NULL,NULL,NULL),('1430110982268571649','1430110679557263362','1161965644164075522','1111.jpg','jjrcw/talentFile/talentCommonFile/202108/1430110982063050753.jpg',1,NULL,'2021-08-24 18:13:23',NULL,NULL,NULL),('1430799327994892290','1430798821226500098','1207570630070976514','f59149bfdeb54951b7ae68d54ba9f489_1231766720075657218.jpg','jjrcw/talentFile/talentCommonFile/202108/1430799327818731521.jpg',1,NULL,'2021-08-26 15:48:37',NULL,NULL,NULL),('1430799369413644290','1430798821226500098','1207570630070976514','21d496de76a61af5ef897047649d1850_1216713184757424130.jpg','jjrcw/talentFile/talentCommonFile/202108/1430799369203929090.jpg',2,NULL,'2021-08-26 15:48:47',NULL,NULL,NULL),('1430799392998215682','1430798821226500098','1207570630070976514','bc140a34b9ac5891515d10e07d31fb04_1216713098052771842.jpg','jjrcw/talentFile/talentCommonFile/202108/1430799392801083393.jpg',3,NULL,'2021-08-26 15:48:52',NULL,NULL,NULL),('1430799404679352321','1430798821226500098','1207570630070976514','c4d20d07bd01436bb11a63916b0f3f9e_1216713239262404609.jpg','jjrcw/talentFile/talentCommonFile/202108/1430799404494802945.jpg',4,NULL,'2021-08-26 15:48:55',NULL,NULL,NULL),('1430799416213688322','1430798821226500098','1207570630070976514','ce4594748aa53a6d44e71f9b94c50f96_1216713364525293570.jpg','jjrcw/talentFile/talentCommonFile/202108/1430799415995584514.jpg',5,NULL,'2021-08-26 15:48:58',NULL,NULL,NULL),('1430799426619756545','1430798821226500098','1207570630070976514','f0007428cb5dece4e9de77bd68186b95_1216713297634533377.jpg','jjrcw/talentFile/talentCommonFile/202108/1430799426372292610.jpg',6,NULL,'2021-08-26 15:49:00',NULL,NULL,NULL),('1432219359765385217','1422400615098638337','1207570630070976514','朱小平在职证明.pdf','jjrcw/talentFile/talentCommonFile/202108/1432219359572447234.pdf',2,NULL,'2021-08-30 13:51:19',NULL,NULL,NULL),('1432245990080958465','1432233635813052417','1207221285556019202','美溪.jpg','jjrcw/talentFile/talentCommonFile/202108/1432245989867048962.jpg',1,NULL,'2021-08-30 15:37:08',NULL,NULL,NULL),('1432255038297788418','1432250523305693186','1207570630070976514','合同1.png','jjrcw/talentFile/talentCommonFile/202108/1432255038092267521.png',1,NULL,'2021-08-30 16:13:05',NULL,NULL,NULL),('1432255100264435714','1432250523305693186','1207570630070976514','合同2.png','jjrcw/talentFile/talentCommonFile/202108/1432255100029554690.png',2,NULL,'2021-08-30 16:13:20',NULL,NULL,NULL),('1432255155717328897','1432250523305693186','1207570630070976514','任职证明.png','jjrcw/talentFile/talentCommonFile/202108/1432255155532779521.png',3,NULL,'2021-08-30 16:13:33',NULL,NULL,NULL),('1433774807232569346','1427169705457614850','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1433774806972522498.jpg',1,NULL,'2021-09-03 20:52:06',NULL,NULL,NULL),('1434711084593340418','1434710718543847426','1161965644164075522','企业营业执照.JPG','jjrcw/talentFile/talentCommonFile/202109/1434711084345876482.JPG',1,NULL,'2021-09-06 10:52:32',NULL,NULL,NULL),('1434746637774774274','1434746480203161601','1209811775526240257','劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202109/1434746637556670466.pdf',1,NULL,'2021-09-06 13:13:49',NULL,NULL,NULL),('1434775289669378049','1434772161100275714','1207221285556019202','梁永贤-离职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1434775289379971074.jpg',1,NULL,'2021-09-06 15:07:40',NULL,NULL,NULL),('1436142772720549889','1436142685093150721','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1436142772498251777.jpg',1,NULL,'2021-09-10 09:41:33',NULL,NULL,NULL),('1436149401604112385','1436145722629079041','1207570630070976514','任职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1436149401306316801.jpg',1,NULL,'2021-09-10 10:07:54',NULL,NULL,NULL),('1436150944445284353','1436145722629079041','1207570630070976514','劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202109/1436150944193626113.pdf',2,NULL,'2021-09-10 10:14:02',NULL,NULL,NULL),('1437686455634784258','1437686333714755586','1161965644164075522','锦福营业执照盖章.jpg','jjrcw/talentFile/talentCommonFile/202109/1437686455412486146.jpg',1,NULL,'2021-09-14 15:55:36',NULL,NULL,NULL),('1437706232109494274','1437705094366785538','1207221285556019202','林天真-解除（终止）劳动关系证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1437706231874613249.jpg',1,NULL,'2021-09-14 17:14:11',NULL,NULL,NULL),('1438665903658004482','1438665681036931074','1161965644164075522','营业执照.png','jjrcw/talentFile/talentCommonFile/202109/1438665903465066498.png',1,NULL,'2021-09-17 08:47:35',NULL,NULL,NULL),('1439421112059457538','1439420509023399938','1207221285556019202','ebce9e01e6ed4c3499b8383d91361b7.jpg','jjrcw/talentFile/talentCommonFile/202109/1439421111816187905.jpg',1,NULL,'2021-09-19 10:48:30',NULL,NULL,NULL),('1439885851508109313','1439161595514089473','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1439885851269033986.jpg',1,NULL,'2021-09-20 17:35:13',NULL,NULL,NULL),('1440867475892760577','1439056438839242754','1207570630070976514','微信图片_202109231035161.jpg','jjrcw/talentFile/talentCommonFile/202109/1440867475712405506.jpg',1,NULL,'2021-09-23 10:35:50',NULL,NULL,NULL),('1440867522529226753','1439056438839242754','1207570630070976514','微信图片_20210923103516.jpg','jjrcw/talentFile/talentCommonFile/202109/1440867522327900162.jpg',2,NULL,'2021-09-23 10:36:02',NULL,NULL,NULL),('1442311354504474626','1442308098315284481','1207221285556019202','陈伟宏离职证明20201231.jpg','jjrcw/talentFile/talentCommonFile/202109/1442311354198290434.jpg',1,NULL,'2021-09-27 10:13:18',NULL,NULL,NULL),('1442360720342675457','1442360419866931202','1207221285556019202','鲁西军离职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1442360720082628610.jpg',1,NULL,'2021-09-27 13:29:28',NULL,NULL,NULL),('1442645420797882370','1442644997487751169','1207570630070976514','01劳动合同20170227-20200229.png','jjrcw/talentFile/talentCommonFile/202109/1442645420462338050.png',1,NULL,'2021-09-28 08:20:46',NULL,NULL,NULL),('1442646470858665986','1442644997487751169','1207570630070976514','02劳动合同20170227-20200229.png','jjrcw/talentFile/talentCommonFile/202109/1442646470594424833.png',2,NULL,'2021-09-28 08:24:56',NULL,NULL,NULL),('1442646962967965698','1442644997487751169','1207570630070976514','陈伟宏-劳动合同20200301-20250228.pdf','jjrcw/talentFile/talentCommonFile/202109/1442646962607255553.pdf',3,NULL,'2021-09-28 08:26:53',NULL,NULL,NULL),('1442647108711641089','1442644997487751169','1207570733326352385','员工隶属说明.pdf','jjrcw/talentFile/talentCommonFile/202109/1442647108535480322.pdf',1,NULL,'2021-09-28 08:27:28',NULL,NULL,NULL),('1442732284934385666','1442731203898667010','1207570630070976514','劳动合同1.jpg','jjrcw/talentFile/talentCommonFile/202109/1442732284649172993.jpg',1,NULL,'2021-09-28 14:05:56',NULL,NULL,NULL),('1442732308632203265','1442731203898667010','1207570630070976514','劳动合同2.jpg','jjrcw/talentFile/talentCommonFile/202109/1442732308447653890.jpg',2,NULL,'2021-09-28 14:06:01',NULL,NULL,NULL),('1442732323844943874','1442731203898667010','1207570630070976514','劳动合同3.jpg','jjrcw/talentFile/talentCommonFile/202109/1442732323631034370.jpg',3,NULL,'2021-09-28 14:06:05',NULL,NULL,NULL),('1442732337799393282','1442731203898667010','1207570630070976514','劳动合同4.jpg','jjrcw/talentFile/talentCommonFile/202109/1442732337602260993.jpg',4,NULL,'2021-09-28 14:06:08',NULL,NULL,NULL),('1442732351078559746','1442731203898667010','1207570630070976514','任职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1442732350818512897.jpg',5,NULL,'2021-09-28 14:06:11',NULL,NULL,NULL),('1442738681717747714','1442738634234032129','1207221285556019202','离职证明.jpg','jjrcw/talentFile/talentCommonFile/202109/1442738681499643906.jpg',1,NULL,'2021-09-28 14:31:21',NULL,NULL,NULL),('1443029618398359553','1443028318289948673','1207221285556019202','王道明辞职批复1.jpg','jjrcw/talentFile/talentCommonFile/202109/1443029618176061441.jpg',1,NULL,'2021-09-29 09:47:25',NULL,NULL,NULL),('1443029632113733634','1443028318289948673','1207221285556019202','王道明辞职批复2.jpg','jjrcw/talentFile/talentCommonFile/202109/1443029631883046914.jpg',2,NULL,'2021-09-29 09:47:29',NULL,NULL,NULL),('1443030772087812098','1372340573196886017','1207221285556019202','杨声波调动通知书.jpg','jjrcw/talentFile/talentCommonFile/202109/1443030771815182338.jpg',1,NULL,'2021-09-29 09:52:00',NULL,NULL,NULL),('1443401623605899265','1443401535739424769','1207221285556019202','陈瑜萍-劳动合同(1).pdf','jjrcw/talentFile/talentCommonFile/202109/1443401623366823937.pdf',1,NULL,'2021-09-30 10:25:38',NULL,NULL,NULL),('1443403077485883393','1443402984552689665','1207570630070976514','陈瑜萍-劳动合同(1).pdf','jjrcw/talentFile/talentCommonFile/202109/1443403077246808066.pdf',1,NULL,'2021-09-30 10:31:25',NULL,NULL,NULL),('1443487118948069378','1443487037171724289','1207570630070976514','红鼎劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202109/1443487118599942146.pdf',1,NULL,'2021-09-30 16:05:22',NULL,NULL,NULL),('1443487147435782145','1443487037171724289','1207570630070976514','任职证明.pdf','jjrcw/talentFile/talentCommonFile/202109/1443487147142180866.pdf',2,NULL,'2021-09-30 16:05:29',NULL,NULL,NULL),('1443509564925308929','1443509506226024449','1207221285556019202','扫描0001(1).pdf','jjrcw/talentFile/talentCommonFile/202109/1443509564749148161.pdf',1,NULL,'2021-09-30 17:34:34',NULL,NULL,NULL),('1445630462482477057','1439056438839242754','1207570630070976514','微信图片_20211006140100.jpg','jjrcw/talentFile/talentCommonFile/202110/1445630462293733377.jpg',3,NULL,'2021-10-06 14:02:15',NULL,NULL,NULL),('1446308919726075905','1441577378152214529','1207221285556019202','张永良-离职证明.jpg','jjrcw/talentFile/talentCommonFile/202110/1446308919537332225.jpg',1,NULL,'2021-10-08 10:58:12',NULL,NULL,NULL),('1446744502382391298','1445942992438325249','1207570630070976514','1、幸青山劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202110/1446744502130733057.pdf',1,NULL,'2021-10-09 15:49:03',NULL,NULL,NULL),('1446744521785241602','1445942992438325249','1207570630070976514','2、幸青山任职证明.pdf','jjrcw/talentFile/talentCommonFile/202110/1446744521558749185.pdf',2,NULL,'2021-10-09 15:49:07',NULL,NULL,NULL),('1447806814178537473','1447806713628487681','1207221285556019202','蔡琪琪 离职证明0.jpg','jjrcw/talentFile/talentCommonFile/202110/1447806813863964674.jpg',1,NULL,'2021-10-12 14:10:18',NULL,NULL,NULL),('1447807608189644801','1447807563331563522','1207221285556019202','刘伟宝 离职证明0.jpg','jjrcw/talentFile/talentCommonFile/202110/1447807607937986561.jpg',1,NULL,'2021-10-12 14:13:27',NULL,NULL,NULL),('1447808007994896385','1447807913904074754','1207221285556019202','王曾豪 离职证明0.jpg','jjrcw/talentFile/talentCommonFile/202110/1447808007785181185.jpg',1,NULL,'2021-10-12 14:15:02',NULL,NULL,NULL),('1447808381866766338','1447808328460693506','1207221285556019202','王青莹 离职证明0.jpg','jjrcw/talentFile/talentCommonFile/202110/1447808381669634049.jpg',1,NULL,'2021-10-12 14:16:31',NULL,NULL,NULL),('1447808744598564866','1447808674557882369','1207221285556019202','张友香 离职证明.jpg','jjrcw/talentFile/talentCommonFile/202110/1447808744330129409.jpg',1,NULL,'2021-10-12 14:17:58',NULL,NULL,NULL),('1448107011102240769','1448106131321810945','1207221285556019202','苏秋梅、施志宏、蔡秀群人社局调动通知书.jpg','jjrcw/talentFile/talentCommonFile/202110/1448107010808639490.jpg',1,NULL,'2021-10-13 10:03:10',NULL,NULL,NULL),('1448107175254716418','1448107118132490241','1207221285556019202','苏秋梅、施志宏、蔡秀群人社局调动通知书.jpg','jjrcw/talentFile/talentCommonFile/202110/1448107174952726529.jpg',1,NULL,'2021-10-13 10:03:49',NULL,NULL,NULL),('1448479162972008450','1448479009389178882','1207570630070976514','苏秋梅任职审批表.pdf','jjrcw/talentFile/talentCommonFile/202110/1448479162728738818.pdf',1,NULL,'2021-10-14 10:41:58',NULL,NULL,NULL),('1448479339115999233','1448479009389178882','1207570733326352385','干部行政介绍信（晋人社干字（2021年）第59号）.pdf','jjrcw/talentFile/talentCommonFile/202110/1448479338872729601.pdf',1,NULL,'2021-10-14 10:42:40',NULL,NULL,NULL),('1448479394644389890','1448479009389178882','1207570630070976514','用编审批表（苏秋梅）.pdf','jjrcw/talentFile/talentCommonFile/202110/1448479394438868994.pdf',2,NULL,'2021-10-14 10:42:53',NULL,NULL,NULL),('1448481676295434242','1448481621140336641','1207570630070976514','用编审批表（施志宏）.pdf','jjrcw/talentFile/talentCommonFile/202110/1448481676064747521.pdf',1,NULL,'2021-10-14 10:51:57',NULL,NULL,NULL),('1448481711393370114','1448481621140336641','1207570733326352385','干部行政介绍信（晋人社干字（2021年）第59号）.pdf','jjrcw/talentFile/talentCommonFile/202110/1448481711137517570.pdf',1,NULL,'2021-10-14 10:52:06',NULL,NULL,NULL),('1448481814220926977','1448481621140336641','1207570630070976514','施志宏任职审批表.pdf','jjrcw/talentFile/talentCommonFile/202110/1448481813956685825.pdf',2,NULL,'2021-10-14 10:52:30',NULL,NULL,NULL),('1450264711856680961','1450264083138899970','1207570630070976514','S22C-721092809531_0001.jpg','jjrcw/talentFile/talentCommonFile/202110/1450264711659548673.jpg',1,NULL,'2021-10-19 08:57:06',NULL,NULL,NULL),('1450264761601126401','1450264083138899970','1207570630070976514','S22C-721092809531_0002.jpg','jjrcw/talentFile/talentCommonFile/202110/1450264761378828289.jpg',2,NULL,'2021-10-19 08:57:18',NULL,NULL,NULL),('1451393219362320385','1448896489366515714','1207570630070976514','罗耀发合同.pdf','jjrcw/talentFile/talentCommonFile/202110/1451393219072913410.pdf',1,NULL,'2021-10-22 11:41:23',NULL,NULL,NULL),('1451393244700110850','1448896489366515714','1207570630070976514','罗耀发在职证明.pdf','jjrcw/talentFile/talentCommonFile/202110/1451393244532338689.pdf',2,NULL,'2021-10-22 11:41:29',NULL,NULL,NULL),('1452472131446140929','1452471947383304193','1207221285556019202','陈柏菁解除关系证明书.pdf','jjrcw/talentFile/talentCommonFile/202110/1452472131236425729.pdf',1,NULL,'2021-10-25 11:08:36',NULL,NULL,NULL),('1453157836400914434','1447894540156432385','1207221285556019202','王子茜离职证明.pdf','jjrcw/talentFile/talentCommonFile/202110/1453157836145061889.pdf',1,NULL,'2021-10-27 08:33:21',NULL,NULL,NULL),('1454276726992433154','1454275571402960898','1207221285556019202','IMG_0001.jpg','jjrcw/talentFile/talentCommonFile/202110/1454276726703026178.jpg',1,NULL,'2021-10-30 10:39:25',NULL,NULL,NULL),('1456157853659197441','1456155766753882114','1207570630070976514','林天真劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202111/1456157853386567682.pdf',1,NULL,'2021-11-04 15:14:21',NULL,NULL,NULL),('1456164026269593602','1456163993960869889','1207570630070976514','张永良劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202111/1456164026059878402.pdf',1,NULL,'2021-11-04 15:38:52',NULL,NULL,NULL),('1456165529935966210','1456164946923515906','1161965644164075522','1636011874(1).png','jjrcw/talentFile/talentCommonFile/202111/1456165529533313025.png',1,NULL,'2021-11-04 15:44:51',NULL,NULL,NULL),('1456511614172819458','1456501596673306626','1207221285556019202','25c5e92ba286beeb046343d00bc4c24.jpg','jjrcw/talentFile/talentCommonFile/202111/1456511613929549825.jpg',1,NULL,'2021-11-05 14:40:04',NULL,NULL,NULL),('1456511639749685250','1456501596673306626','1207221285556019202','df4552752601d7e633dd1a9523a2c6e.jpg','jjrcw/talentFile/talentCommonFile/202111/1456511639556747265.jpg',2,NULL,'2021-11-05 14:40:10',NULL,NULL,NULL),('1459072900895109121','1459070004610756609','1207570630070976514','陈柏菁 劳动合同.pdf','jjrcw/talentFile/talentCommonFile/202111/1459072900601507842.pdf',1,NULL,'2021-11-12 16:17:42',NULL,NULL,NULL),('1460534274133356545','1460533613241069570','1207570630070976514','劳动合同-蔡庆白.pdf','jjrcw/talentFile/talentCommonFile/202111/1460534273873309698.pdf',1,NULL,'2021-11-16 17:04:41',NULL,NULL,NULL),('1460535037190500354','1460533613241069570','1207570630070976514','蔡庆白入职证明.pdf','jjrcw/talentFile/talentCommonFile/202111/1460535036959813634.pdf',2,NULL,'2021-11-16 17:07:42',NULL,NULL,NULL),('1462995875784585217','1462990985117069314','1207221285556019202','微信图片_20211123120601.jpg','jjrcw/talentFile/talentCommonFile/202111/1462995875524538370.jpg',1,NULL,'2021-11-23 12:06:12',NULL,NULL,NULL),('1462995902913343489','1462990985117069314','1207221371723800578','微信图片_20211123120556.jpg','jjrcw/talentFile/talentCommonFile/202111/1462995902699433986.jpg',1,NULL,'2021-11-23 12:06:19',NULL,NULL,NULL),('1464015358120718337','1464015119552901122','1207221285556019202','终止（解除）劳动关系证明 肖炳烜.pdf','jjrcw/talentFile/talentCommonFile/202111/1464015357902614530.pdf',1,NULL,'2021-11-26 07:37:16',NULL,NULL,NULL),('1464049327914643457','1450264083138899970','1207570630070976514','1.PDF','jjrcw/talentFile/talentCommonFile/202111/1464049327734288386.PDF',3,NULL,'2021-11-26 09:52:15',NULL,NULL,NULL),('1464064140128579585','1459070004610756609','1207570733326352385','工作证明.pdf','jjrcw/talentFile/talentCommonFile/202111/1464064139944030210.pdf',1,NULL,'2021-11-26 10:51:06',NULL,NULL,NULL),('1464081078850449410','1464081048194281474','1207570630070976514','杨声波、尤夏洪人社行政介绍信.jpg','jjrcw/talentFile/talentCommonFile/202111/1464081078649122818.jpg',1,NULL,'2021-11-26 11:58:25',NULL,NULL,NULL),('1465139314831683586','1456155766753882114','1207570630070976514','林天真在职证明.pdf','jjrcw/talentFile/talentCommonFile/202111/1465139639990906882.pdf',2,NULL,'2021-11-29 10:03:28',NULL,'2021-11-29 10:04:45',NULL),('1465139986499137537','1456163993960869889','1207570630070976514','张永良在职证明.pdf','jjrcw/talentFile/talentCommonFile/202111/1465139986302005250.pdf',2,NULL,'2021-11-29 10:06:08',NULL,NULL,NULL),('1465149661907021826','1465148796987011074','1161965644164075522','投资公司.png','jjrcw/talentFile/talentCommonFile/202111/1465149661684723713.png',1,NULL,'2021-11-29 10:44:35',NULL,NULL,NULL);
/*!40000 ALTER TABLE `un_talent_common_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_depcheckstate`
--

DROP TABLE IF EXISTS `un_talent_depcheckstate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_depcheckstate` (
  `id` varchar(30) NOT NULL COMMENT '主键',
  `type` tinyint(1) DEFAULT NULL COMMENT '申报类型',
  `mainId` varchar(30) DEFAULT NULL COMMENT '主标id',
  `companyId` varchar(30) DEFAULT NULL COMMENT '审核单位id',
  `state` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `submitTime` varchar(40) DEFAULT NULL COMMENT '提交时间',
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(40) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `index_companyId` (`companyId`) USING BTREE,
  KEY `index_mainId` (`mainId`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='优秀人才-部门审核情况表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_depcheckstate`
--

LOCK TABLES `un_talent_depcheckstate` WRITE;
/*!40000 ALTER TABLE `un_talent_depcheckstate` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_depcheckstate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_file`
--

DROP TABLE IF EXISTS `un_talent_file`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_file` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `mainId` varchar(30) DEFAULT NULL COMMENT '优秀人才申报ID',
  `fileTypeId` varchar(30) DEFAULT NULL COMMENT '附件类别id',
  `orignName` varchar(200) DEFAULT NULL COMMENT '附件原名',
  `url` varchar(255) DEFAULT NULL COMMENT '地址',
  `sn` tinyint(2) DEFAULT NULL COMMENT '序号',
  `fState` tinyint(1) DEFAULT NULL COMMENT '初审状态',
  `sState` tinyint(1) DEFAULT NULL COMMENT '部门审核状态',
  `tState` tinyint(1) DEFAULT NULL COMMENT '复核状态',
  `checkMsg` varchar(200) DEFAULT NULL COMMENT '审核意见',
  `description` varchar(255) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE,
  KEY `index_mainId_fileTypeId_sn` (`mainId`,`fileTypeId`,`sn`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_file`
--

LOCK TABLES `un_talent_file` WRITE;
/*!40000 ALTER TABLE `un_talent_file` DISABLE KEYS */;
INSERT INTO `un_talent_file` VALUES ('1560700252124614658','1560698278390009858','1178131640547270658','202006091591691272114478.jpg','jjrcw/talentFile/talentIdentifyFile/202208/1560700249796775937.jpg',1,1,1,1,NULL,NULL,NULL,'2022-08-20 02:48:31',NULL,NULL),('1560700296395493378','1560698278390009858','1185025144825004034','202006091591691272114478.jpg','jjrcw/talentFile/talentIdentifyFile/202208/1560700293631447041.jpg',1,1,1,1,NULL,NULL,NULL,'2022-08-20 02:48:41',NULL,NULL),('1560700529695264770','1560698278390009858','1185025499830894594','202006091591691272114478.jpg','jjrcw/talentFile/talentIdentifyFile/202208/1560700445633024002.jpg',1,1,1,1,NULL,NULL,NULL,'2022-08-20 02:49:37',NULL,NULL),('1560700596510527490','1560698278390009858','1185026393880346625','202006091591691272114478.jpg','jjrcw/talentFile/talentIdentifyFile/202208/1560700594379821058.jpg',1,1,1,1,NULL,NULL,NULL,'2022-08-20 02:49:53',NULL,NULL),('1560700621454053377','1560698278390009858','1210382500880424962','202006091591691272114478.jpg','jjrcw/talentFile/talentIdentifyFile/202208/1560700619281403906.jpg',1,1,1,1,NULL,NULL,NULL,'2022-08-20 02:49:59',NULL,NULL),('1560701014300954626','1560698278390009858','1185029319591936001','微信图片_20220717142048.jpg','jjrcw/talentFile/talentIdentifyFile/202208/1560701010765156354.jpg',1,1,1,1,NULL,NULL,NULL,'2022-08-20 02:51:32',NULL,NULL),('1560701040607629313','1560698278390009858','1210382500880424962','202006091591691272114478.jpg','jjrcw/talentFile/talentIdentifyFile/202208/1560701038502088705.jpg',2,1,1,1,NULL,NULL,NULL,'2022-08-20 02:51:39',NULL,NULL);
/*!40000 ALTER TABLE `un_talent_file` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_info`
--

DROP TABLE IF EXISTS `un_talent_info`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_info` (
  `id` varchar(30) NOT NULL COMMENT '主键',
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '所属单位',
  `year` int(4) DEFAULT NULL,
  `source` tinyint(1) DEFAULT NULL COMMENT '来源',
  `ourCitySource` tinyint(1) DEFAULT NULL,
  `type` tinyint(1) DEFAULT NULL COMMENT '人才类型',
  `talentType` varchar(30) DEFAULT NULL COMMENT '申报人才类型',
  `cardType` tinyint(1) DEFAULT NULL,
  `idCard` varchar(30) DEFAULT NULL COMMENT '证件号码',
  `name` varchar(100) DEFAULT NULL COMMENT '姓名',
  `photo` varchar(100) DEFAULT NULL,
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `nation` varchar(50) DEFAULT NULL COMMENT '民族',
  `nationality` varchar(30) DEFAULT NULL COMMENT '国籍',
  `provinceCode` varchar(50) DEFAULT NULL COMMENT '籍贯省代码',
  `provinceName` varchar(100) DEFAULT NULL COMMENT '籍贯省名称',
  `cityCode` varchar(50) DEFAULT NULL COMMENT '籍贯市代码',
  `cityName` varchar(100) DEFAULT NULL COMMENT '籍贯市名称',
  `countyCode` varchar(50) DEFAULT NULL COMMENT '籍贯县代码',
  `countyName` varchar(100) DEFAULT NULL COMMENT '籍贯县名称',
  `birthday` varchar(40) DEFAULT NULL COMMENT '出生日期',
  `address` varchar(255) DEFAULT NULL COMMENT '现居地址',
  `politics` varchar(50) DEFAULT NULL COMMENT '政治面貌',
  `highEducation` varchar(100) DEFAULT NULL COMMENT '最高学历',
  `graduateSchool` varchar(100) DEFAULT NULL COMMENT '毕业学校',
  `major` varchar(100) DEFAULT NULL COMMENT '专业',
  `post` varchar(100) DEFAULT NULL COMMENT '职务',
  `phone` varchar(20) DEFAULT NULL COMMENT '手机号码',
  `email` varchar(150) DEFAULT NULL,
  `bank` varchar(100) DEFAULT NULL COMMENT '开户银行',
  `bankNetwork` varchar(100) DEFAULT '' COMMENT '开户银行网点',
  `bankAccount` varchar(50) DEFAULT NULL COMMENT '银行账号',
  `bankNumber` varchar(50) DEFAULT NULL COMMENT '银行行号',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '入职时间',
  `quitTime` varchar(40) DEFAULT NULL,
  `startTime` varchar(40) DEFAULT NULL COMMENT '工作合同开始时间',
  `endTime` varchar(40) DEFAULT NULL COMMENT '工作合同结束时间',
  `lastYearWages` decimal(10,2) DEFAULT NULL COMMENT '上一年度年薪',
  `talentArrange` varchar(20) DEFAULT NULL COMMENT '人才层次',
  `identifyCondition` varchar(30) DEFAULT NULL COMMENT '认定条件',
  `identifyGetTime` varchar(40) DEFAULT NULL COMMENT '认定条件获得时间',
  `identifyOutTime` varchar(40) DEFAULT NULL COMMENT '过期时间',
  `identifyConditionName` varchar(255) DEFAULT NULL COMMENT '认定条件名称',
  `identifyMonth` date DEFAULT NULL,
  `certificateNO` varchar(50) DEFAULT NULL,
  `breakFaith` tinyint(1) DEFAULT NULL COMMENT '曾被相关部门列为失信人员',
  `letterTime` varchar(40) DEFAULT NULL COMMENT '行政介绍信时间',
  `gygb` tinyint(1) DEFAULT NULL COMMENT '是否为我市本级国有股比超过50%',
  `certificateStartTime` varchar(40) DEFAULT NULL,
  `qzgccrcActiveTime` varchar(40) DEFAULT NULL COMMENT '泉州高层次人才证书的有效期',
  `educationAndResume` text DEFAULT NULL COMMENT '教育背景及工作简历',
  `mainHonours` text DEFAULT NULL COMMENT '主要业绩及取得的荣誉',
  `firstInJJTime` varchar(40) DEFAULT NULL COMMENT '首次来晋工作时间',
  `isIntroduction` tinyint(1) DEFAULT NULL,
  `industryField` varchar(255) DEFAULT NULL COMMENT '行业领域',
  `title` varchar(255) DEFAULT NULL COMMENT '职称',
  `professionalQualifications` varchar(255) DEFAULT NULL COMMENT '国家职业资格',
  `studyAbroad` tinyint(1) DEFAULT NULL COMMENT '是否有留学经历',
  `studyAbroadCountry` varchar(100) DEFAULT NULL,
  `studyAbroadTime` varchar(40) DEFAULT NULL,
  `introductionMode` varchar(40) DEFAULT NULL,
  `fromCity` varchar(20) DEFAULT NULL,
  `fromCityName` varchar(255) DEFAULT NULL,
  `qzBatch` varchar(20) DEFAULT NULL,
  `basicState` tinyint(2) DEFAULT NULL COMMENT '基础信息审核状态',
  `basicMsg` varchar(255) DEFAULT NULL COMMENT '基础信息审核意见',
  `isPublic` tinyint(1) DEFAULT 1,
  `isCertification` tinyint(1) DEFAULT 1 COMMENT '是否发证',
  `publicBatch` varchar(20) DEFAULT NULL,
  `active` tinyint(1) DEFAULT NULL COMMENT '是否确认提交',
  `checkState` tinyint(2) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(2000) DEFAULT NULL COMMENT '基础信息审核意见',
  `fields` varchar(2000) DEFAULT NULL,
  `files` varchar(500) DEFAULT NULL,
  `firstSubmitTime` varchar(40) DEFAULT NULL COMMENT '首次确认提交时间',
  `newSubmitTime` varchar(40) DEFAULT NULL COMMENT '最新确认提交时间',
  `outMsg` varchar(255) DEFAULT NULL COMMENT '退件原因',
  `firstDepPassTime` varchar(40) DEFAULT NULL COMMENT '首次部门审核通过时间',
  `firstBeforeSubmitTime` varchar(40) DEFAULT NULL,
  `beforeCheckCompany` varchar(255) DEFAULT NULL,
  `highProcess` smallint(2) DEFAULT -2,
  `isEffect` tinyint(1) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  PRIMARY KEY (`id`) USING BTREE,
  KEY `index_checkState` (`checkState`,`isPublic`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='人才认定申报信息表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_info`
--

LOCK TABLES `un_talent_info` WRITE;
/*!40000 ALTER TABLE `un_talent_info` DISABLE KEYS */;
INSERT INTO `un_talent_info` VALUES ('1560698278390009858','1560676248278011905',2022,2,NULL,1,'zzbsh',1,'350581199501250531','龚珊情','jjrcw/talentFile/photo/202208/1560698420824379393.jpg',2,'01','01','350000','福建省','350500','泉州市','350581','石狮市','2022-08-01','00002','13','01','哈佛','唬烂','职业唬烂王','13559517922','sugangqiang@foxmail.com','中国银行','中国银行福建省石狮市花园路分行','6228480688737459273','1','2022-08-01',NULL,'2022-08-01','2022-08-31',1.00,'1','1196306171335680013','2022-08-01',NULL,'一级唬烂王',NULL,NULL,2,'2022-08-01',NULL,'2022-08-01','2022-08-31','fq','fq','2022-08-03',NULL,'03','唬烂王','最帅资格',2,NULL,NULL,'01','350581','石狮市','1',NULL,NULL,1,1,NULL,1,-1,'复核不通过','','','2022-08-20 02:51:46','2022-08-20 03:16:23',NULL,'2022-08-20 03:17:58',NULL,NULL,3,1,NULL,'2022-08-20 02:40:40','1560676248278011905',NULL,NULL);
/*!40000 ALTER TABLE `un_talent_info` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_quit`
--

DROP TABLE IF EXISTS `un_talent_quit`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_quit` (
  `id` varchar(30) NOT NULL,
  `year` varchar(8) DEFAULT NULL,
  `talentId` varchar(30) DEFAULT NULL COMMENT '优秀人才Id',
  `type` tinyint(1) DEFAULT NULL,
  `talentName` varchar(100) DEFAULT NULL COMMENT '优秀人才姓名',
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '企业id',
  `enterpriseName` varchar(255) DEFAULT NULL COMMENT '企业名称',
  `talentType` varchar(20) DEFAULT NULL,
  `letterTime` varchar(40) DEFAULT NULL,
  `gygb` int(1) DEFAULT NULL,
  `identifyGetTime` varchar(40) DEFAULT NULL,
  `idCard` varchar(50) DEFAULT NULL COMMENT '证件号码',
  `talentArrange` varchar(30) DEFAULT NULL COMMENT '人才层次',
  `identifyTime` varchar(40) DEFAULT NULL COMMENT '认定时间',
  `starttime` varchar(40) DEFAULT NULL COMMENT '合同开始时间',
  `endtime` varchar(40) DEFAULT NULL COMMENT '合同结束时间',
  `phone` varchar(22) DEFAULT NULL COMMENT '手机号码',
  `entryTime` varchar(40) DEFAULT NULL,
  `quitTime` varchar(40) DEFAULT NULL COMMENT '离职时间',
  `quitReason` varchar(100) DEFAULT NULL,
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `fileTypeStr` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `passTime` varchar(40) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '修改时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `post` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='优秀人才离职记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_quit`
--

LOCK TABLES `un_talent_quit` WRITE;
/*!40000 ALTER TABLE `un_talent_quit` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_quit` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_type_change`
--

DROP TABLE IF EXISTS `un_talent_type_change`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_type_change` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `year` varchar(8) DEFAULT NULL,
  `talentId` varchar(30) DEFAULT NULL COMMENT '优秀人才id',
  `type` tinyint(1) DEFAULT NULL,
  `talentName` varchar(100) DEFAULT NULL COMMENT '优秀人才姓名',
  `idCard` varchar(30) DEFAULT NULL,
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '单位id',
  `enterpriseName` varchar(100) DEFAULT NULL COMMENT '单位名称',
  `oldYear` int(4) DEFAULT NULL,
  `oldSource` tinyint(1) DEFAULT NULL,
  `oldFromCity` varchar(255) DEFAULT NULL,
  `oldFromCityName` varchar(255) DEFAULT NULL,
  `oldQzBath` varchar(10) DEFAULT NULL,
  `oldOurCitySource` tinyint(1) DEFAULT NULL,
  `oldTalentArrange` varchar(30) DEFAULT NULL COMMENT '原人才层次',
  `oldIdentifyCondition` varchar(40) DEFAULT NULL COMMENT '原认定条件',
  `oldIdentifyGetTime` varchar(40) DEFAULT NULL COMMENT '原认定条件获得时间',
  `oldIdentifyOutTime` varchar(40) DEFAULT NULL COMMENT '原认定条件过期时间',
  `oldIdentifyConditionName` varchar(500) DEFAULT NULL COMMENT '原认定条件名称',
  `oldIdentifyMonth` varchar(40) DEFAULT NULL COMMENT '原认定月份',
  `oldCertificateNO` varchar(100) DEFAULT NULL COMMENT '原人才证书编号',
  `oldCertificateStartTime` varchar(40) DEFAULT NULL,
  `oldCertificateOutTime` varchar(40) DEFAULT NULL,
  `oldIsIntroduction` tinyint(1) DEFAULT NULL,
  `oldIntroductionMode` varchar(20) DEFAULT NULL,
  `newYear` int(4) DEFAULT NULL,
  `newSource` tinyint(1) DEFAULT NULL,
  `newFromCity` varchar(100) DEFAULT NULL,
  `newFromCityName` varchar(255) DEFAULT NULL,
  `newQzBath` varchar(20) DEFAULT NULL,
  `newOurCitySource` tinyint(1) DEFAULT NULL,
  `newTalentArrange` varchar(30) DEFAULT NULL COMMENT '新人才层次',
  `newIdentifyCondition` varchar(50) DEFAULT NULL COMMENT '新认定条件',
  `newIdentifyGetTime` varchar(40) DEFAULT NULL COMMENT '新认定条件获得时间',
  `newIdentifyConditionName` varchar(500) DEFAULT NULL COMMENT '新认定条件名称',
  `newIdentifyOutTime` date DEFAULT NULL,
  `newIdentifyMonth` varchar(40) DEFAULT NULL COMMENT '新认定月份',
  `newCertificateNO` varchar(100) DEFAULT NULL COMMENT '新人才证书编号',
  `newCertificateStartTime` varchar(40) DEFAULT NULL,
  `newCertificateOutTime` varchar(40) DEFAULT NULL,
  `newIsIntroduction` tinyint(1) DEFAULT NULL,
  `newIntroductionMode` varchar(50) DEFAULT NULL,
  `checkState` tinyint(2) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `basicState` tinyint(1) DEFAULT NULL COMMENT '基础信息审核状态',
  `basicMsg` varchar(255) DEFAULT NULL COMMENT '基础信息审核意见',
  `firstSubmitTime` varchar(40) DEFAULT NULL,
  `newSubmitTime` varchar(40) DEFAULT NULL,
  `firstDepPassTime` varchar(40) DEFAULT NULL,
  `firstBeforeSubmitTime` varchar(40) DEFAULT NULL,
  `beforeCheckCompany` varchar(50) DEFAULT NULL,
  `fields` varchar(1000) DEFAULT NULL,
  `files` varchar(500) DEFAULT NULL,
  `publicBatch` varchar(255) DEFAULT NULL,
  `isPublic` tinyint(1) DEFAULT NULL,
  `outMsg` varchar(1000) DEFAULT NULL,
  `highProcess` smallint(2) DEFAULT -2,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='优秀人才类别变更记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_type_change`
--

LOCK TABLES `un_talent_type_change` WRITE;
/*!40000 ALTER TABLE `un_talent_type_change` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_type_change` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talent_workunit_change`
--

DROP TABLE IF EXISTS `un_talent_workunit_change`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talent_workunit_change` (
  `id` varchar(30) NOT NULL COMMENT '唯一标识',
  `year` varchar(8) DEFAULT NULL,
  `talentId` varchar(30) DEFAULT NULL COMMENT '优秀人才id',
  `type` tinyint(1) DEFAULT NULL,
  `idCard` varchar(36) DEFAULT NULL COMMENT '证件号码',
  `talentName` varchar(100) DEFAULT NULL COMMENT '姓名',
  `talentArrange` varchar(30) DEFAULT NULL COMMENT '人才层次',
  `identifyTime` varchar(40) DEFAULT NULL COMMENT '认定日期',
  `oldEnterpriseId` varchar(40) DEFAULT NULL COMMENT '原工作单位',
  `oldTalentType` varchar(255) DEFAULT NULL COMMENT '原申报人才类型',
  `oldLetterTime` varchar(50) DEFAULT NULL,
  `oldGygb` tinyint(1) DEFAULT NULL,
  `oldAnyTime` varchar(40) DEFAULT NULL,
  `quitTime` varchar(40) DEFAULT NULL COMMENT '离职时间',
  `oldStartTime` varchar(40) DEFAULT NULL,
  `oldEndTime` varchar(40) DEFAULT NULL,
  `oldPost` varchar(255) DEFAULT NULL,
  `quitReason` varchar(100) DEFAULT NULL,
  `newEnterpriseId` varchar(40) DEFAULT NULL COMMENT '新单位',
  `newTalentType` varchar(40) DEFAULT NULL COMMENT '新申报人才类型',
  `newLetterTime` varchar(40) DEFAULT NULL,
  `newGygb` tinyint(1) DEFAULT NULL,
  `starttime` varchar(40) DEFAULT NULL COMMENT '合同开始时间',
  `endtime` varchar(40) DEFAULT NULL COMMENT '合同结束时间',
  `phone` varchar(255) DEFAULT NULL COMMENT '手机号码',
  `anyTime` varchar(40) DEFAULT NULL COMMENT '到任时间',
  `anyReason` varchar(100) DEFAULT NULL,
  `checkState` tinyint(1) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `fileTypeStr` varchar(255) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `createTime` varchar(40) DEFAULT NULL COMMENT '创建时间',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '更新用户',
  `passTime` varchar(40) DEFAULT NULL,
  `newPost` varchar(255) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='优秀人才工作单位变更记录';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talent_workunit_change`
--

LOCK TABLES `un_talent_workunit_change` WRITE;
/*!40000 ALTER TABLE `un_talent_workunit_change` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talent_workunit_change` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talentcheckproperties`
--

DROP TABLE IF EXISTS `un_talentcheckproperties`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talentcheckproperties` (
  `id` varchar(30) NOT NULL COMMENT '主键',
  `code` varchar(30) DEFAULT NULL COMMENT '人才标签code',
  `enterpriseId` varchar(30) DEFAULT NULL COMMENT '企业id',
  `companyId` varchar(30) DEFAULT NULL COMMENT '审核单位id',
  `description` varchar(255) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `createTime` varchar(40) DEFAULT NULL,
  `updateUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='人才认定主管部门审核配置';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talentcheckproperties`
--

LOCK TABLES `un_talentcheckproperties` WRITE;
/*!40000 ALTER TABLE `un_talentcheckproperties` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talentcheckproperties` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_talentidentify_file_checkstate`
--

DROP TABLE IF EXISTS `un_talentidentify_file_checkstate`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_talentidentify_file_checkstate` (
  `id` varchar(30) NOT NULL COMMENT '主键',
  `mainId` varchar(30) DEFAULT NULL COMMENT '人才认定id',
  `fileTypeId` varchar(30) DEFAULT NULL COMMENT '附件类型id',
  `companyId` varchar(30) DEFAULT NULL COMMENT '审核单位',
  `fState` tinyint(2) DEFAULT NULL COMMENT '初审状态',
  `bState` tinyint(2) DEFAULT NULL COMMENT '部门审核状态',
  `tState` tinyint(2) DEFAULT NULL COMMENT '复核状态',
  `fMsg` varchar(255) DEFAULT NULL COMMENT '初审意见',
  `bMsg` varchar(255) DEFAULT NULL COMMENT '部门审核意见',
  `tMsg` varchar(255) DEFAULT NULL COMMENT '复核意见',
  `createTime` varchar(40) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL,
  `description` varchar(255) DEFAULT NULL COMMENT '备注',
  `updateUser` varchar(50) DEFAULT NULL COMMENT '修改用户',
  `createUser` varchar(50) DEFAULT NULL COMMENT '创建用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC COMMENT='人才认定附件审核状态表';
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_talentidentify_file_checkstate`
--

LOCK TABLES `un_talentidentify_file_checkstate` WRITE;
/*!40000 ALTER TABLE `un_talentidentify_file_checkstate` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_talentidentify_file_checkstate` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_training_project`
--

DROP TABLE IF EXISTS `un_training_project`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_training_project` (
  `id` varchar(40) NOT NULL,
  `mainId` varchar(40) DEFAULT NULL COMMENT '培训补贴id',
  `type` tinyint(1) DEFAULT NULL COMMENT '项目类型',
  `months` varchar(2) DEFAULT NULL COMMENT '缴纳月份',
  `money` decimal(10,2) DEFAULT NULL COMMENT '缴纳金额',
  `description` varchar(1000) DEFAULT NULL,
  `createTime` varchar(50) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_training_project`
--

LOCK TABLES `un_training_project` WRITE;
/*!40000 ALTER TABLE `un_training_project` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_training_project` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Table structure for table `un_training_subsidy`
--

DROP TABLE IF EXISTS `un_training_subsidy`;
/*!40101 SET @saved_cs_client     = @@character_set_client */;
/*!50503 SET character_set_client = utf8mb4 */;
CREATE TABLE `un_training_subsidy` (
  `id` varchar(40) NOT NULL COMMENT '主键',
  `type` tinyint(1) DEFAULT NULL,
  `enterpriseId` varchar(40) DEFAULT NULL COMMENT '企业id',
  `year` varchar(6) DEFAULT NULL COMMENT '申报年度',
  `name` varchar(50) DEFAULT NULL COMMENT '姓名',
  `sex` tinyint(1) DEFAULT NULL COMMENT '性别',
  `cardType` varchar(10) DEFAULT NULL COMMENT '证件类型',
  `idCard` varchar(40) DEFAULT NULL COMMENT '证件号码',
  `nationality` varchar(50) DEFAULT NULL COMMENT '国籍',
  `entryTime` varchar(40) DEFAULT NULL COMMENT '入职时间',
  `startTime` varchar(40) DEFAULT NULL COMMENT '合同开始时间',
  `endTime` varchar(40) DEFAULT NULL COMMENT '合同结束时间',
  `yearSalary` decimal(10,2) DEFAULT NULL COMMENT '上一年度年薪',
  `yearTax` decimal(10,2) DEFAULT NULL COMMENT '上一年度缴纳个税总额',
  `bankName` varchar(60) DEFAULT NULL COMMENT '开户银行',
  `bankAddress` varchar(255) DEFAULT NULL COMMENT '开户银行网点',
  `bankNumber` varchar(40) DEFAULT NULL COMMENT '银行账号',
  `phone` varchar(30) DEFAULT NULL COMMENT '联系电话',
  `address` varchar(255) DEFAULT NULL COMMENT '联系地址',
  `taxDetails` varchar(500) DEFAULT NULL COMMENT '个税缴纳详情',
  `enjoyYear` int(4) DEFAULT NULL,
  `enjoyMoney` decimal(10,2) DEFAULT NULL,
  `firstSubmitTime` varchar(40) DEFAULT NULL COMMENT '首次提交时间',
  `newSubmitTime` varchar(40) DEFAULT NULL COMMENT '最新提交时间',
  `checkState` tinyint(2) DEFAULT NULL COMMENT '审核状态',
  `checkMsg` varchar(255) DEFAULT NULL COMMENT '审核意见',
  `publicState` tinyint(1) DEFAULT 1,
  `files` varchar(255) DEFAULT NULL,
  `fields` varchar(255) DEFAULT NULL,
  `description` varchar(1000) DEFAULT NULL,
  `createTime` varchar(50) DEFAULT NULL,
  `createUser` varchar(50) DEFAULT NULL,
  `updateTime` varchar(40) DEFAULT NULL COMMENT '更新时间',
  `updateUser` varchar(40) DEFAULT NULL COMMENT '更新用户',
  PRIMARY KEY (`id`) USING BTREE
) ENGINE=InnoDB DEFAULT CHARSET=utf8mb4 ROW_FORMAT=DYNAMIC;
/*!40101 SET character_set_client = @saved_cs_client */;

--
-- Dumping data for table `un_training_subsidy`
--

LOCK TABLES `un_training_subsidy` WRITE;
/*!40000 ALTER TABLE `un_training_subsidy` DISABLE KEYS */;
/*!40000 ALTER TABLE `un_training_subsidy` ENABLE KEYS */;
UNLOCK TABLES;

--
-- Final view structure for view `past_12_month_view`
--

/*!50001 DROP VIEW IF EXISTS `past_12_month_view`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `past_12_month_view` AS select date_format(curdate(),'%Y-%m') AS `month` union select date_format(curdate() - interval 1 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 2 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 3 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 4 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 5 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 6 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 7 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 8 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 9 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 10 month,'%Y-%m') AS `month` union select date_format(curdate() - interval 11 month,'%Y-%m') AS `month` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;

--
-- Final view structure for view `past_week_view`
--

/*!50001 DROP VIEW IF EXISTS `past_week_view`*/;
/*!50001 SET @saved_cs_client          = @@character_set_client */;
/*!50001 SET @saved_cs_results         = @@character_set_results */;
/*!50001 SET @saved_col_connection     = @@collation_connection */;
/*!50001 SET character_set_client      = utf8mb4 */;
/*!50001 SET character_set_results     = utf8mb4 */;
/*!50001 SET collation_connection      = utf8mb4_general_ci */;
/*!50001 CREATE ALGORITHM=UNDEFINED */
/*!50013 DEFINER=`root`@`localhost` SQL SECURITY DEFINER */
/*!50001 VIEW `past_week_view` AS select date_format(curdate(),'%Y-%m-%d') AS `day` union select date_format(curdate() - interval 1 day,'%Y-%m-%d') AS `day` union select date_format(curdate() - interval 2 day,'%Y-%m-%d') AS `day` union select date_format(curdate() - interval 3 day,'%Y-%m-%d') AS `day` union select date_format(curdate() - interval 4 day,'%Y-%m-%d') AS `day` union select date_format(curdate() - interval 5 day,'%Y-%m-%d') AS `day` union select date_format(curdate() - interval 6 day,'%Y-%m-%d') AS `day` */;
/*!50001 SET character_set_client      = @saved_cs_client */;
/*!50001 SET character_set_results     = @saved_cs_results */;
/*!50001 SET collation_connection      = @saved_col_connection */;
/*!40103 SET TIME_ZONE=@OLD_TIME_ZONE */;

/*!40101 SET SQL_MODE=@OLD_SQL_MODE */;
/*!40014 SET FOREIGN_KEY_CHECKS=@OLD_FOREIGN_KEY_CHECKS */;
/*!40014 SET UNIQUE_CHECKS=@OLD_UNIQUE_CHECKS */;
/*!40101 SET CHARACTER_SET_CLIENT=@OLD_CHARACTER_SET_CLIENT */;
/*!40101 SET CHARACTER_SET_RESULTS=@OLD_CHARACTER_SET_RESULTS */;
/*!40101 SET COLLATION_CONNECTION=@OLD_COLLATION_CONNECTION */;
/*!40111 SET SQL_NOTES=@OLD_SQL_NOTES */;

-- Dump completed on 2022-08-22  5:51:01
